/*eslint-disable block-scoped-var, id-length, no-control-regex, no-magic-numbers, no-prototype-builtins, no-redeclare, no-shadow, no-var, sort-vars*/
"use strict";

var $protobuf = require("protobufjs/minimal");

// Common aliases
var $Reader = $protobuf.Reader, $Writer = $protobuf.Writer, $util = $protobuf.util;

// Exported root namespace
var $root = $protobuf.roots["default"] || ($protobuf.roots["default"] = {});

$root.google = (function() {

    /**
     * Namespace google.
     * @exports google
     * @namespace
     */
    var google = {};

    google.protobuf = (function() {

        /**
         * Namespace protobuf.
         * @memberof google
         * @namespace
         */
        var protobuf = {};

        protobuf.Duration = (function() {

            /**
             * Properties of a Duration.
             * @memberof google.protobuf
             * @interface IDuration
             * @property {number|Long|null} [seconds] Duration seconds
             * @property {number|null} [nanos] Duration nanos
             */

            /**
             * Constructs a new Duration.
             * @memberof google.protobuf
             * @classdesc Represents a Duration.
             * @implements IDuration
             * @constructor
             * @param {google.protobuf.IDuration=} [properties] Properties to set
             */
            function Duration(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * Duration seconds.
             * @member {number|Long} seconds
             * @memberof google.protobuf.Duration
             * @instance
             */
            Duration.prototype.seconds = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

            /**
             * Duration nanos.
             * @member {number} nanos
             * @memberof google.protobuf.Duration
             * @instance
             */
            Duration.prototype.nanos = 0;

            /**
             * Creates a new Duration instance using the specified properties.
             * @function create
             * @memberof google.protobuf.Duration
             * @static
             * @param {google.protobuf.IDuration=} [properties] Properties to set
             * @returns {google.protobuf.Duration} Duration instance
             */
            Duration.create = function create(properties) {
                return new Duration(properties);
            };

            /**
             * Encodes the specified Duration message. Does not implicitly {@link google.protobuf.Duration.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.Duration
             * @static
             * @param {google.protobuf.IDuration} message Duration message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Duration.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.seconds != null && message.hasOwnProperty("seconds"))
                    writer.uint32(/* id 1, wireType 0 =*/8).int64(message.seconds);
                if (message.nanos != null && message.hasOwnProperty("nanos"))
                    writer.uint32(/* id 2, wireType 0 =*/16).int32(message.nanos);
                return writer;
            };

            /**
             * Encodes the specified Duration message, length delimited. Does not implicitly {@link google.protobuf.Duration.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.Duration
             * @static
             * @param {google.protobuf.IDuration} message Duration message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Duration.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a Duration message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.Duration
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.Duration} Duration
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Duration.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.Duration();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.seconds = reader.int64();
                        break;
                    case 2:
                        message.nanos = reader.int32();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a Duration message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.Duration
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.Duration} Duration
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Duration.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a Duration message.
             * @function verify
             * @memberof google.protobuf.Duration
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            Duration.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.seconds != null && message.hasOwnProperty("seconds"))
                    if (!$util.isInteger(message.seconds) && !(message.seconds && $util.isInteger(message.seconds.low) && $util.isInteger(message.seconds.high)))
                        return "seconds: integer|Long expected";
                if (message.nanos != null && message.hasOwnProperty("nanos"))
                    if (!$util.isInteger(message.nanos))
                        return "nanos: integer expected";
                return null;
            };

            /**
             * Creates a Duration message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.Duration
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.Duration} Duration
             */
            Duration.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.Duration)
                    return object;
                var message = new $root.google.protobuf.Duration();
                if (object.seconds != null)
                    if ($util.Long)
                        (message.seconds = $util.Long.fromValue(object.seconds)).unsigned = false;
                    else if (typeof object.seconds === "string")
                        message.seconds = parseInt(object.seconds, 10);
                    else if (typeof object.seconds === "number")
                        message.seconds = object.seconds;
                    else if (typeof object.seconds === "object")
                        message.seconds = new $util.LongBits(object.seconds.low >>> 0, object.seconds.high >>> 0).toNumber();
                if (object.nanos != null)
                    message.nanos = object.nanos | 0;
                return message;
            };

            /**
             * Creates a plain object from a Duration message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.Duration
             * @static
             * @param {google.protobuf.Duration} message Duration
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            Duration.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults) {
                    if ($util.Long) {
                        var long = new $util.Long(0, 0, false);
                        object.seconds = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                    } else
                        object.seconds = options.longs === String ? "0" : 0;
                    object.nanos = 0;
                }
                if (message.seconds != null && message.hasOwnProperty("seconds"))
                    if (typeof message.seconds === "number")
                        object.seconds = options.longs === String ? String(message.seconds) : message.seconds;
                    else
                        object.seconds = options.longs === String ? $util.Long.prototype.toString.call(message.seconds) : options.longs === Number ? new $util.LongBits(message.seconds.low >>> 0, message.seconds.high >>> 0).toNumber() : message.seconds;
                if (message.nanos != null && message.hasOwnProperty("nanos"))
                    object.nanos = message.nanos;
                return object;
            };

            /**
             * Converts this Duration to JSON.
             * @function toJSON
             * @memberof google.protobuf.Duration
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            Duration.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return Duration;
        })();

        protobuf.Any = (function() {

            /**
             * Properties of an Any.
             * @memberof google.protobuf
             * @interface IAny
             * @property {string|null} [type_url] Any type_url
             * @property {Uint8Array|null} [value] Any value
             */

            /**
             * Constructs a new Any.
             * @memberof google.protobuf
             * @classdesc Represents an Any.
             * @implements IAny
             * @constructor
             * @param {google.protobuf.IAny=} [properties] Properties to set
             */
            function Any(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * Any type_url.
             * @member {string} type_url
             * @memberof google.protobuf.Any
             * @instance
             */
            Any.prototype.type_url = "";

            /**
             * Any value.
             * @member {Uint8Array} value
             * @memberof google.protobuf.Any
             * @instance
             */
            Any.prototype.value = $util.newBuffer([]);

            /**
             * Creates a new Any instance using the specified properties.
             * @function create
             * @memberof google.protobuf.Any
             * @static
             * @param {google.protobuf.IAny=} [properties] Properties to set
             * @returns {google.protobuf.Any} Any instance
             */
            Any.create = function create(properties) {
                return new Any(properties);
            };

            /**
             * Encodes the specified Any message. Does not implicitly {@link google.protobuf.Any.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.Any
             * @static
             * @param {google.protobuf.IAny} message Any message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Any.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.type_url != null && message.hasOwnProperty("type_url"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.type_url);
                if (message.value != null && message.hasOwnProperty("value"))
                    writer.uint32(/* id 2, wireType 2 =*/18).bytes(message.value);
                return writer;
            };

            /**
             * Encodes the specified Any message, length delimited. Does not implicitly {@link google.protobuf.Any.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.Any
             * @static
             * @param {google.protobuf.IAny} message Any message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Any.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes an Any message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.Any
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.Any} Any
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Any.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.Any();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.type_url = reader.string();
                        break;
                    case 2:
                        message.value = reader.bytes();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes an Any message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.Any
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.Any} Any
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Any.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies an Any message.
             * @function verify
             * @memberof google.protobuf.Any
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            Any.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.type_url != null && message.hasOwnProperty("type_url"))
                    if (!$util.isString(message.type_url))
                        return "type_url: string expected";
                if (message.value != null && message.hasOwnProperty("value"))
                    if (!(message.value && typeof message.value.length === "number" || $util.isString(message.value)))
                        return "value: buffer expected";
                return null;
            };

            /**
             * Creates an Any message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.Any
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.Any} Any
             */
            Any.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.Any)
                    return object;
                var message = new $root.google.protobuf.Any();
                if (object.type_url != null)
                    message.type_url = String(object.type_url);
                if (object.value != null)
                    if (typeof object.value === "string")
                        $util.base64.decode(object.value, message.value = $util.newBuffer($util.base64.length(object.value)), 0);
                    else if (object.value.length)
                        message.value = object.value;
                return message;
            };

            /**
             * Creates a plain object from an Any message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.Any
             * @static
             * @param {google.protobuf.Any} message Any
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            Any.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults) {
                    object.type_url = "";
                    if (options.bytes === String)
                        object.value = "";
                    else {
                        object.value = [];
                        if (options.bytes !== Array)
                            object.value = $util.newBuffer(object.value);
                    }
                }
                if (message.type_url != null && message.hasOwnProperty("type_url"))
                    object.type_url = message.type_url;
                if (message.value != null && message.hasOwnProperty("value"))
                    object.value = options.bytes === String ? $util.base64.encode(message.value, 0, message.value.length) : options.bytes === Array ? Array.prototype.slice.call(message.value) : message.value;
                return object;
            };

            /**
             * Converts this Any to JSON.
             * @function toJSON
             * @memberof google.protobuf.Any
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            Any.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return Any;
        })();

        protobuf.FileDescriptorSet = (function() {

            /**
             * Properties of a FileDescriptorSet.
             * @memberof google.protobuf
             * @interface IFileDescriptorSet
             * @property {Array.<google.protobuf.IFileDescriptorProto>|null} [file] FileDescriptorSet file
             */

            /**
             * Constructs a new FileDescriptorSet.
             * @memberof google.protobuf
             * @classdesc Represents a FileDescriptorSet.
             * @implements IFileDescriptorSet
             * @constructor
             * @param {google.protobuf.IFileDescriptorSet=} [properties] Properties to set
             */
            function FileDescriptorSet(properties) {
                this.file = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * FileDescriptorSet file.
             * @member {Array.<google.protobuf.IFileDescriptorProto>} file
             * @memberof google.protobuf.FileDescriptorSet
             * @instance
             */
            FileDescriptorSet.prototype.file = $util.emptyArray;

            /**
             * Creates a new FileDescriptorSet instance using the specified properties.
             * @function create
             * @memberof google.protobuf.FileDescriptorSet
             * @static
             * @param {google.protobuf.IFileDescriptorSet=} [properties] Properties to set
             * @returns {google.protobuf.FileDescriptorSet} FileDescriptorSet instance
             */
            FileDescriptorSet.create = function create(properties) {
                return new FileDescriptorSet(properties);
            };

            /**
             * Encodes the specified FileDescriptorSet message. Does not implicitly {@link google.protobuf.FileDescriptorSet.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.FileDescriptorSet
             * @static
             * @param {google.protobuf.IFileDescriptorSet} message FileDescriptorSet message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            FileDescriptorSet.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.file != null && message.file.length)
                    for (var i = 0; i < message.file.length; ++i)
                        $root.google.protobuf.FileDescriptorProto.encode(message.file[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified FileDescriptorSet message, length delimited. Does not implicitly {@link google.protobuf.FileDescriptorSet.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.FileDescriptorSet
             * @static
             * @param {google.protobuf.IFileDescriptorSet} message FileDescriptorSet message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            FileDescriptorSet.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a FileDescriptorSet message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.FileDescriptorSet
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.FileDescriptorSet} FileDescriptorSet
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            FileDescriptorSet.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FileDescriptorSet();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        if (!(message.file && message.file.length))
                            message.file = [];
                        message.file.push($root.google.protobuf.FileDescriptorProto.decode(reader, reader.uint32()));
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a FileDescriptorSet message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.FileDescriptorSet
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.FileDescriptorSet} FileDescriptorSet
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            FileDescriptorSet.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a FileDescriptorSet message.
             * @function verify
             * @memberof google.protobuf.FileDescriptorSet
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            FileDescriptorSet.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.file != null && message.hasOwnProperty("file")) {
                    if (!Array.isArray(message.file))
                        return "file: array expected";
                    for (var i = 0; i < message.file.length; ++i) {
                        var error = $root.google.protobuf.FileDescriptorProto.verify(message.file[i]);
                        if (error)
                            return "file." + error;
                    }
                }
                return null;
            };

            /**
             * Creates a FileDescriptorSet message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.FileDescriptorSet
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.FileDescriptorSet} FileDescriptorSet
             */
            FileDescriptorSet.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.FileDescriptorSet)
                    return object;
                var message = new $root.google.protobuf.FileDescriptorSet();
                if (object.file) {
                    if (!Array.isArray(object.file))
                        throw TypeError(".google.protobuf.FileDescriptorSet.file: array expected");
                    message.file = [];
                    for (var i = 0; i < object.file.length; ++i) {
                        if (typeof object.file[i] !== "object")
                            throw TypeError(".google.protobuf.FileDescriptorSet.file: object expected");
                        message.file[i] = $root.google.protobuf.FileDescriptorProto.fromObject(object.file[i]);
                    }
                }
                return message;
            };

            /**
             * Creates a plain object from a FileDescriptorSet message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.FileDescriptorSet
             * @static
             * @param {google.protobuf.FileDescriptorSet} message FileDescriptorSet
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            FileDescriptorSet.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.file = [];
                if (message.file && message.file.length) {
                    object.file = [];
                    for (var j = 0; j < message.file.length; ++j)
                        object.file[j] = $root.google.protobuf.FileDescriptorProto.toObject(message.file[j], options);
                }
                return object;
            };

            /**
             * Converts this FileDescriptorSet to JSON.
             * @function toJSON
             * @memberof google.protobuf.FileDescriptorSet
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            FileDescriptorSet.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return FileDescriptorSet;
        })();

        protobuf.FileDescriptorProto = (function() {

            /**
             * Properties of a FileDescriptorProto.
             * @memberof google.protobuf
             * @interface IFileDescriptorProto
             * @property {string|null} [name] FileDescriptorProto name
             * @property {string|null} ["package"] FileDescriptorProto package
             * @property {Array.<string>|null} [dependency] FileDescriptorProto dependency
             * @property {Array.<number>|null} [publicDependency] FileDescriptorProto publicDependency
             * @property {Array.<number>|null} [weakDependency] FileDescriptorProto weakDependency
             * @property {Array.<google.protobuf.IDescriptorProto>|null} [messageType] FileDescriptorProto messageType
             * @property {Array.<google.protobuf.IEnumDescriptorProto>|null} [enumType] FileDescriptorProto enumType
             * @property {Array.<google.protobuf.IServiceDescriptorProto>|null} [service] FileDescriptorProto service
             * @property {Array.<google.protobuf.IFieldDescriptorProto>|null} [extension] FileDescriptorProto extension
             * @property {google.protobuf.IFileOptions|null} [options] FileDescriptorProto options
             * @property {google.protobuf.ISourceCodeInfo|null} [sourceCodeInfo] FileDescriptorProto sourceCodeInfo
             * @property {string|null} [syntax] FileDescriptorProto syntax
             */

            /**
             * Constructs a new FileDescriptorProto.
             * @memberof google.protobuf
             * @classdesc Represents a FileDescriptorProto.
             * @implements IFileDescriptorProto
             * @constructor
             * @param {google.protobuf.IFileDescriptorProto=} [properties] Properties to set
             */
            function FileDescriptorProto(properties) {
                this.dependency = [];
                this.publicDependency = [];
                this.weakDependency = [];
                this.messageType = [];
                this.enumType = [];
                this.service = [];
                this.extension = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * FileDescriptorProto name.
             * @member {string} name
             * @memberof google.protobuf.FileDescriptorProto
             * @instance
             */
            FileDescriptorProto.prototype.name = "";

            /**
             * FileDescriptorProto package.
             * @member {string} package
             * @memberof google.protobuf.FileDescriptorProto
             * @instance
             */
            FileDescriptorProto.prototype["package"] = "";

            /**
             * FileDescriptorProto dependency.
             * @member {Array.<string>} dependency
             * @memberof google.protobuf.FileDescriptorProto
             * @instance
             */
            FileDescriptorProto.prototype.dependency = $util.emptyArray;

            /**
             * FileDescriptorProto publicDependency.
             * @member {Array.<number>} publicDependency
             * @memberof google.protobuf.FileDescriptorProto
             * @instance
             */
            FileDescriptorProto.prototype.publicDependency = $util.emptyArray;

            /**
             * FileDescriptorProto weakDependency.
             * @member {Array.<number>} weakDependency
             * @memberof google.protobuf.FileDescriptorProto
             * @instance
             */
            FileDescriptorProto.prototype.weakDependency = $util.emptyArray;

            /**
             * FileDescriptorProto messageType.
             * @member {Array.<google.protobuf.IDescriptorProto>} messageType
             * @memberof google.protobuf.FileDescriptorProto
             * @instance
             */
            FileDescriptorProto.prototype.messageType = $util.emptyArray;

            /**
             * FileDescriptorProto enumType.
             * @member {Array.<google.protobuf.IEnumDescriptorProto>} enumType
             * @memberof google.protobuf.FileDescriptorProto
             * @instance
             */
            FileDescriptorProto.prototype.enumType = $util.emptyArray;

            /**
             * FileDescriptorProto service.
             * @member {Array.<google.protobuf.IServiceDescriptorProto>} service
             * @memberof google.protobuf.FileDescriptorProto
             * @instance
             */
            FileDescriptorProto.prototype.service = $util.emptyArray;

            /**
             * FileDescriptorProto extension.
             * @member {Array.<google.protobuf.IFieldDescriptorProto>} extension
             * @memberof google.protobuf.FileDescriptorProto
             * @instance
             */
            FileDescriptorProto.prototype.extension = $util.emptyArray;

            /**
             * FileDescriptorProto options.
             * @member {google.protobuf.IFileOptions|null|undefined} options
             * @memberof google.protobuf.FileDescriptorProto
             * @instance
             */
            FileDescriptorProto.prototype.options = null;

            /**
             * FileDescriptorProto sourceCodeInfo.
             * @member {google.protobuf.ISourceCodeInfo|null|undefined} sourceCodeInfo
             * @memberof google.protobuf.FileDescriptorProto
             * @instance
             */
            FileDescriptorProto.prototype.sourceCodeInfo = null;

            /**
             * FileDescriptorProto syntax.
             * @member {string} syntax
             * @memberof google.protobuf.FileDescriptorProto
             * @instance
             */
            FileDescriptorProto.prototype.syntax = "";

            /**
             * Creates a new FileDescriptorProto instance using the specified properties.
             * @function create
             * @memberof google.protobuf.FileDescriptorProto
             * @static
             * @param {google.protobuf.IFileDescriptorProto=} [properties] Properties to set
             * @returns {google.protobuf.FileDescriptorProto} FileDescriptorProto instance
             */
            FileDescriptorProto.create = function create(properties) {
                return new FileDescriptorProto(properties);
            };

            /**
             * Encodes the specified FileDescriptorProto message. Does not implicitly {@link google.protobuf.FileDescriptorProto.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.FileDescriptorProto
             * @static
             * @param {google.protobuf.IFileDescriptorProto} message FileDescriptorProto message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            FileDescriptorProto.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.name != null && message.hasOwnProperty("name"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                if (message["package"] != null && message.hasOwnProperty("package"))
                    writer.uint32(/* id 2, wireType 2 =*/18).string(message["package"]);
                if (message.dependency != null && message.dependency.length)
                    for (var i = 0; i < message.dependency.length; ++i)
                        writer.uint32(/* id 3, wireType 2 =*/26).string(message.dependency[i]);
                if (message.messageType != null && message.messageType.length)
                    for (var i = 0; i < message.messageType.length; ++i)
                        $root.google.protobuf.DescriptorProto.encode(message.messageType[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                if (message.enumType != null && message.enumType.length)
                    for (var i = 0; i < message.enumType.length; ++i)
                        $root.google.protobuf.EnumDescriptorProto.encode(message.enumType[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                if (message.service != null && message.service.length)
                    for (var i = 0; i < message.service.length; ++i)
                        $root.google.protobuf.ServiceDescriptorProto.encode(message.service[i], writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                if (message.extension != null && message.extension.length)
                    for (var i = 0; i < message.extension.length; ++i)
                        $root.google.protobuf.FieldDescriptorProto.encode(message.extension[i], writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                if (message.options != null && message.hasOwnProperty("options"))
                    $root.google.protobuf.FileOptions.encode(message.options, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                if (message.sourceCodeInfo != null && message.hasOwnProperty("sourceCodeInfo"))
                    $root.google.protobuf.SourceCodeInfo.encode(message.sourceCodeInfo, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                if (message.publicDependency != null && message.publicDependency.length)
                    for (var i = 0; i < message.publicDependency.length; ++i)
                        writer.uint32(/* id 10, wireType 0 =*/80).int32(message.publicDependency[i]);
                if (message.weakDependency != null && message.weakDependency.length)
                    for (var i = 0; i < message.weakDependency.length; ++i)
                        writer.uint32(/* id 11, wireType 0 =*/88).int32(message.weakDependency[i]);
                if (message.syntax != null && message.hasOwnProperty("syntax"))
                    writer.uint32(/* id 12, wireType 2 =*/98).string(message.syntax);
                return writer;
            };

            /**
             * Encodes the specified FileDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.FileDescriptorProto.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.FileDescriptorProto
             * @static
             * @param {google.protobuf.IFileDescriptorProto} message FileDescriptorProto message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            FileDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a FileDescriptorProto message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.FileDescriptorProto
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.FileDescriptorProto} FileDescriptorProto
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            FileDescriptorProto.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FileDescriptorProto();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.name = reader.string();
                        break;
                    case 2:
                        message["package"] = reader.string();
                        break;
                    case 3:
                        if (!(message.dependency && message.dependency.length))
                            message.dependency = [];
                        message.dependency.push(reader.string());
                        break;
                    case 10:
                        if (!(message.publicDependency && message.publicDependency.length))
                            message.publicDependency = [];
                        if ((tag & 7) === 2) {
                            var end2 = reader.uint32() + reader.pos;
                            while (reader.pos < end2)
                                message.publicDependency.push(reader.int32());
                        } else
                            message.publicDependency.push(reader.int32());
                        break;
                    case 11:
                        if (!(message.weakDependency && message.weakDependency.length))
                            message.weakDependency = [];
                        if ((tag & 7) === 2) {
                            var end2 = reader.uint32() + reader.pos;
                            while (reader.pos < end2)
                                message.weakDependency.push(reader.int32());
                        } else
                            message.weakDependency.push(reader.int32());
                        break;
                    case 4:
                        if (!(message.messageType && message.messageType.length))
                            message.messageType = [];
                        message.messageType.push($root.google.protobuf.DescriptorProto.decode(reader, reader.uint32()));
                        break;
                    case 5:
                        if (!(message.enumType && message.enumType.length))
                            message.enumType = [];
                        message.enumType.push($root.google.protobuf.EnumDescriptorProto.decode(reader, reader.uint32()));
                        break;
                    case 6:
                        if (!(message.service && message.service.length))
                            message.service = [];
                        message.service.push($root.google.protobuf.ServiceDescriptorProto.decode(reader, reader.uint32()));
                        break;
                    case 7:
                        if (!(message.extension && message.extension.length))
                            message.extension = [];
                        message.extension.push($root.google.protobuf.FieldDescriptorProto.decode(reader, reader.uint32()));
                        break;
                    case 8:
                        message.options = $root.google.protobuf.FileOptions.decode(reader, reader.uint32());
                        break;
                    case 9:
                        message.sourceCodeInfo = $root.google.protobuf.SourceCodeInfo.decode(reader, reader.uint32());
                        break;
                    case 12:
                        message.syntax = reader.string();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a FileDescriptorProto message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.FileDescriptorProto
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.FileDescriptorProto} FileDescriptorProto
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            FileDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a FileDescriptorProto message.
             * @function verify
             * @memberof google.protobuf.FileDescriptorProto
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            FileDescriptorProto.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.name != null && message.hasOwnProperty("name"))
                    if (!$util.isString(message.name))
                        return "name: string expected";
                if (message["package"] != null && message.hasOwnProperty("package"))
                    if (!$util.isString(message["package"]))
                        return "package: string expected";
                if (message.dependency != null && message.hasOwnProperty("dependency")) {
                    if (!Array.isArray(message.dependency))
                        return "dependency: array expected";
                    for (var i = 0; i < message.dependency.length; ++i)
                        if (!$util.isString(message.dependency[i]))
                            return "dependency: string[] expected";
                }
                if (message.publicDependency != null && message.hasOwnProperty("publicDependency")) {
                    if (!Array.isArray(message.publicDependency))
                        return "publicDependency: array expected";
                    for (var i = 0; i < message.publicDependency.length; ++i)
                        if (!$util.isInteger(message.publicDependency[i]))
                            return "publicDependency: integer[] expected";
                }
                if (message.weakDependency != null && message.hasOwnProperty("weakDependency")) {
                    if (!Array.isArray(message.weakDependency))
                        return "weakDependency: array expected";
                    for (var i = 0; i < message.weakDependency.length; ++i)
                        if (!$util.isInteger(message.weakDependency[i]))
                            return "weakDependency: integer[] expected";
                }
                if (message.messageType != null && message.hasOwnProperty("messageType")) {
                    if (!Array.isArray(message.messageType))
                        return "messageType: array expected";
                    for (var i = 0; i < message.messageType.length; ++i) {
                        var error = $root.google.protobuf.DescriptorProto.verify(message.messageType[i]);
                        if (error)
                            return "messageType." + error;
                    }
                }
                if (message.enumType != null && message.hasOwnProperty("enumType")) {
                    if (!Array.isArray(message.enumType))
                        return "enumType: array expected";
                    for (var i = 0; i < message.enumType.length; ++i) {
                        var error = $root.google.protobuf.EnumDescriptorProto.verify(message.enumType[i]);
                        if (error)
                            return "enumType." + error;
                    }
                }
                if (message.service != null && message.hasOwnProperty("service")) {
                    if (!Array.isArray(message.service))
                        return "service: array expected";
                    for (var i = 0; i < message.service.length; ++i) {
                        var error = $root.google.protobuf.ServiceDescriptorProto.verify(message.service[i]);
                        if (error)
                            return "service." + error;
                    }
                }
                if (message.extension != null && message.hasOwnProperty("extension")) {
                    if (!Array.isArray(message.extension))
                        return "extension: array expected";
                    for (var i = 0; i < message.extension.length; ++i) {
                        var error = $root.google.protobuf.FieldDescriptorProto.verify(message.extension[i]);
                        if (error)
                            return "extension." + error;
                    }
                }
                if (message.options != null && message.hasOwnProperty("options")) {
                    var error = $root.google.protobuf.FileOptions.verify(message.options);
                    if (error)
                        return "options." + error;
                }
                if (message.sourceCodeInfo != null && message.hasOwnProperty("sourceCodeInfo")) {
                    var error = $root.google.protobuf.SourceCodeInfo.verify(message.sourceCodeInfo);
                    if (error)
                        return "sourceCodeInfo." + error;
                }
                if (message.syntax != null && message.hasOwnProperty("syntax"))
                    if (!$util.isString(message.syntax))
                        return "syntax: string expected";
                return null;
            };

            /**
             * Creates a FileDescriptorProto message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.FileDescriptorProto
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.FileDescriptorProto} FileDescriptorProto
             */
            FileDescriptorProto.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.FileDescriptorProto)
                    return object;
                var message = new $root.google.protobuf.FileDescriptorProto();
                if (object.name != null)
                    message.name = String(object.name);
                if (object["package"] != null)
                    message["package"] = String(object["package"]);
                if (object.dependency) {
                    if (!Array.isArray(object.dependency))
                        throw TypeError(".google.protobuf.FileDescriptorProto.dependency: array expected");
                    message.dependency = [];
                    for (var i = 0; i < object.dependency.length; ++i)
                        message.dependency[i] = String(object.dependency[i]);
                }
                if (object.publicDependency) {
                    if (!Array.isArray(object.publicDependency))
                        throw TypeError(".google.protobuf.FileDescriptorProto.publicDependency: array expected");
                    message.publicDependency = [];
                    for (var i = 0; i < object.publicDependency.length; ++i)
                        message.publicDependency[i] = object.publicDependency[i] | 0;
                }
                if (object.weakDependency) {
                    if (!Array.isArray(object.weakDependency))
                        throw TypeError(".google.protobuf.FileDescriptorProto.weakDependency: array expected");
                    message.weakDependency = [];
                    for (var i = 0; i < object.weakDependency.length; ++i)
                        message.weakDependency[i] = object.weakDependency[i] | 0;
                }
                if (object.messageType) {
                    if (!Array.isArray(object.messageType))
                        throw TypeError(".google.protobuf.FileDescriptorProto.messageType: array expected");
                    message.messageType = [];
                    for (var i = 0; i < object.messageType.length; ++i) {
                        if (typeof object.messageType[i] !== "object")
                            throw TypeError(".google.protobuf.FileDescriptorProto.messageType: object expected");
                        message.messageType[i] = $root.google.protobuf.DescriptorProto.fromObject(object.messageType[i]);
                    }
                }
                if (object.enumType) {
                    if (!Array.isArray(object.enumType))
                        throw TypeError(".google.protobuf.FileDescriptorProto.enumType: array expected");
                    message.enumType = [];
                    for (var i = 0; i < object.enumType.length; ++i) {
                        if (typeof object.enumType[i] !== "object")
                            throw TypeError(".google.protobuf.FileDescriptorProto.enumType: object expected");
                        message.enumType[i] = $root.google.protobuf.EnumDescriptorProto.fromObject(object.enumType[i]);
                    }
                }
                if (object.service) {
                    if (!Array.isArray(object.service))
                        throw TypeError(".google.protobuf.FileDescriptorProto.service: array expected");
                    message.service = [];
                    for (var i = 0; i < object.service.length; ++i) {
                        if (typeof object.service[i] !== "object")
                            throw TypeError(".google.protobuf.FileDescriptorProto.service: object expected");
                        message.service[i] = $root.google.protobuf.ServiceDescriptorProto.fromObject(object.service[i]);
                    }
                }
                if (object.extension) {
                    if (!Array.isArray(object.extension))
                        throw TypeError(".google.protobuf.FileDescriptorProto.extension: array expected");
                    message.extension = [];
                    for (var i = 0; i < object.extension.length; ++i) {
                        if (typeof object.extension[i] !== "object")
                            throw TypeError(".google.protobuf.FileDescriptorProto.extension: object expected");
                        message.extension[i] = $root.google.protobuf.FieldDescriptorProto.fromObject(object.extension[i]);
                    }
                }
                if (object.options != null) {
                    if (typeof object.options !== "object")
                        throw TypeError(".google.protobuf.FileDescriptorProto.options: object expected");
                    message.options = $root.google.protobuf.FileOptions.fromObject(object.options);
                }
                if (object.sourceCodeInfo != null) {
                    if (typeof object.sourceCodeInfo !== "object")
                        throw TypeError(".google.protobuf.FileDescriptorProto.sourceCodeInfo: object expected");
                    message.sourceCodeInfo = $root.google.protobuf.SourceCodeInfo.fromObject(object.sourceCodeInfo);
                }
                if (object.syntax != null)
                    message.syntax = String(object.syntax);
                return message;
            };

            /**
             * Creates a plain object from a FileDescriptorProto message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.FileDescriptorProto
             * @static
             * @param {google.protobuf.FileDescriptorProto} message FileDescriptorProto
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            FileDescriptorProto.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults) {
                    object.dependency = [];
                    object.messageType = [];
                    object.enumType = [];
                    object.service = [];
                    object.extension = [];
                    object.publicDependency = [];
                    object.weakDependency = [];
                }
                if (options.defaults) {
                    object.name = "";
                    object["package"] = "";
                    object.options = null;
                    object.sourceCodeInfo = null;
                    object.syntax = "";
                }
                if (message.name != null && message.hasOwnProperty("name"))
                    object.name = message.name;
                if (message["package"] != null && message.hasOwnProperty("package"))
                    object["package"] = message["package"];
                if (message.dependency && message.dependency.length) {
                    object.dependency = [];
                    for (var j = 0; j < message.dependency.length; ++j)
                        object.dependency[j] = message.dependency[j];
                }
                if (message.messageType && message.messageType.length) {
                    object.messageType = [];
                    for (var j = 0; j < message.messageType.length; ++j)
                        object.messageType[j] = $root.google.protobuf.DescriptorProto.toObject(message.messageType[j], options);
                }
                if (message.enumType && message.enumType.length) {
                    object.enumType = [];
                    for (var j = 0; j < message.enumType.length; ++j)
                        object.enumType[j] = $root.google.protobuf.EnumDescriptorProto.toObject(message.enumType[j], options);
                }
                if (message.service && message.service.length) {
                    object.service = [];
                    for (var j = 0; j < message.service.length; ++j)
                        object.service[j] = $root.google.protobuf.ServiceDescriptorProto.toObject(message.service[j], options);
                }
                if (message.extension && message.extension.length) {
                    object.extension = [];
                    for (var j = 0; j < message.extension.length; ++j)
                        object.extension[j] = $root.google.protobuf.FieldDescriptorProto.toObject(message.extension[j], options);
                }
                if (message.options != null && message.hasOwnProperty("options"))
                    object.options = $root.google.protobuf.FileOptions.toObject(message.options, options);
                if (message.sourceCodeInfo != null && message.hasOwnProperty("sourceCodeInfo"))
                    object.sourceCodeInfo = $root.google.protobuf.SourceCodeInfo.toObject(message.sourceCodeInfo, options);
                if (message.publicDependency && message.publicDependency.length) {
                    object.publicDependency = [];
                    for (var j = 0; j < message.publicDependency.length; ++j)
                        object.publicDependency[j] = message.publicDependency[j];
                }
                if (message.weakDependency && message.weakDependency.length) {
                    object.weakDependency = [];
                    for (var j = 0; j < message.weakDependency.length; ++j)
                        object.weakDependency[j] = message.weakDependency[j];
                }
                if (message.syntax != null && message.hasOwnProperty("syntax"))
                    object.syntax = message.syntax;
                return object;
            };

            /**
             * Converts this FileDescriptorProto to JSON.
             * @function toJSON
             * @memberof google.protobuf.FileDescriptorProto
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            FileDescriptorProto.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return FileDescriptorProto;
        })();

        protobuf.DescriptorProto = (function() {

            /**
             * Properties of a DescriptorProto.
             * @memberof google.protobuf
             * @interface IDescriptorProto
             * @property {string|null} [name] DescriptorProto name
             * @property {Array.<google.protobuf.IFieldDescriptorProto>|null} [field] DescriptorProto field
             * @property {Array.<google.protobuf.IFieldDescriptorProto>|null} [extension] DescriptorProto extension
             * @property {Array.<google.protobuf.IDescriptorProto>|null} [nestedType] DescriptorProto nestedType
             * @property {Array.<google.protobuf.IEnumDescriptorProto>|null} [enumType] DescriptorProto enumType
             * @property {Array.<google.protobuf.DescriptorProto.IExtensionRange>|null} [extensionRange] DescriptorProto extensionRange
             * @property {Array.<google.protobuf.IOneofDescriptorProto>|null} [oneofDecl] DescriptorProto oneofDecl
             * @property {google.protobuf.IMessageOptions|null} [options] DescriptorProto options
             * @property {Array.<google.protobuf.DescriptorProto.IReservedRange>|null} [reservedRange] DescriptorProto reservedRange
             * @property {Array.<string>|null} [reservedName] DescriptorProto reservedName
             */

            /**
             * Constructs a new DescriptorProto.
             * @memberof google.protobuf
             * @classdesc Represents a DescriptorProto.
             * @implements IDescriptorProto
             * @constructor
             * @param {google.protobuf.IDescriptorProto=} [properties] Properties to set
             */
            function DescriptorProto(properties) {
                this.field = [];
                this.extension = [];
                this.nestedType = [];
                this.enumType = [];
                this.extensionRange = [];
                this.oneofDecl = [];
                this.reservedRange = [];
                this.reservedName = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * DescriptorProto name.
             * @member {string} name
             * @memberof google.protobuf.DescriptorProto
             * @instance
             */
            DescriptorProto.prototype.name = "";

            /**
             * DescriptorProto field.
             * @member {Array.<google.protobuf.IFieldDescriptorProto>} field
             * @memberof google.protobuf.DescriptorProto
             * @instance
             */
            DescriptorProto.prototype.field = $util.emptyArray;

            /**
             * DescriptorProto extension.
             * @member {Array.<google.protobuf.IFieldDescriptorProto>} extension
             * @memberof google.protobuf.DescriptorProto
             * @instance
             */
            DescriptorProto.prototype.extension = $util.emptyArray;

            /**
             * DescriptorProto nestedType.
             * @member {Array.<google.protobuf.IDescriptorProto>} nestedType
             * @memberof google.protobuf.DescriptorProto
             * @instance
             */
            DescriptorProto.prototype.nestedType = $util.emptyArray;

            /**
             * DescriptorProto enumType.
             * @member {Array.<google.protobuf.IEnumDescriptorProto>} enumType
             * @memberof google.protobuf.DescriptorProto
             * @instance
             */
            DescriptorProto.prototype.enumType = $util.emptyArray;

            /**
             * DescriptorProto extensionRange.
             * @member {Array.<google.protobuf.DescriptorProto.IExtensionRange>} extensionRange
             * @memberof google.protobuf.DescriptorProto
             * @instance
             */
            DescriptorProto.prototype.extensionRange = $util.emptyArray;

            /**
             * DescriptorProto oneofDecl.
             * @member {Array.<google.protobuf.IOneofDescriptorProto>} oneofDecl
             * @memberof google.protobuf.DescriptorProto
             * @instance
             */
            DescriptorProto.prototype.oneofDecl = $util.emptyArray;

            /**
             * DescriptorProto options.
             * @member {google.protobuf.IMessageOptions|null|undefined} options
             * @memberof google.protobuf.DescriptorProto
             * @instance
             */
            DescriptorProto.prototype.options = null;

            /**
             * DescriptorProto reservedRange.
             * @member {Array.<google.protobuf.DescriptorProto.IReservedRange>} reservedRange
             * @memberof google.protobuf.DescriptorProto
             * @instance
             */
            DescriptorProto.prototype.reservedRange = $util.emptyArray;

            /**
             * DescriptorProto reservedName.
             * @member {Array.<string>} reservedName
             * @memberof google.protobuf.DescriptorProto
             * @instance
             */
            DescriptorProto.prototype.reservedName = $util.emptyArray;

            /**
             * Creates a new DescriptorProto instance using the specified properties.
             * @function create
             * @memberof google.protobuf.DescriptorProto
             * @static
             * @param {google.protobuf.IDescriptorProto=} [properties] Properties to set
             * @returns {google.protobuf.DescriptorProto} DescriptorProto instance
             */
            DescriptorProto.create = function create(properties) {
                return new DescriptorProto(properties);
            };

            /**
             * Encodes the specified DescriptorProto message. Does not implicitly {@link google.protobuf.DescriptorProto.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.DescriptorProto
             * @static
             * @param {google.protobuf.IDescriptorProto} message DescriptorProto message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            DescriptorProto.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.name != null && message.hasOwnProperty("name"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                if (message.field != null && message.field.length)
                    for (var i = 0; i < message.field.length; ++i)
                        $root.google.protobuf.FieldDescriptorProto.encode(message.field[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                if (message.nestedType != null && message.nestedType.length)
                    for (var i = 0; i < message.nestedType.length; ++i)
                        $root.google.protobuf.DescriptorProto.encode(message.nestedType[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                if (message.enumType != null && message.enumType.length)
                    for (var i = 0; i < message.enumType.length; ++i)
                        $root.google.protobuf.EnumDescriptorProto.encode(message.enumType[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                if (message.extensionRange != null && message.extensionRange.length)
                    for (var i = 0; i < message.extensionRange.length; ++i)
                        $root.google.protobuf.DescriptorProto.ExtensionRange.encode(message.extensionRange[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                if (message.extension != null && message.extension.length)
                    for (var i = 0; i < message.extension.length; ++i)
                        $root.google.protobuf.FieldDescriptorProto.encode(message.extension[i], writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                if (message.options != null && message.hasOwnProperty("options"))
                    $root.google.protobuf.MessageOptions.encode(message.options, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                if (message.oneofDecl != null && message.oneofDecl.length)
                    for (var i = 0; i < message.oneofDecl.length; ++i)
                        $root.google.protobuf.OneofDescriptorProto.encode(message.oneofDecl[i], writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                if (message.reservedRange != null && message.reservedRange.length)
                    for (var i = 0; i < message.reservedRange.length; ++i)
                        $root.google.protobuf.DescriptorProto.ReservedRange.encode(message.reservedRange[i], writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                if (message.reservedName != null && message.reservedName.length)
                    for (var i = 0; i < message.reservedName.length; ++i)
                        writer.uint32(/* id 10, wireType 2 =*/82).string(message.reservedName[i]);
                return writer;
            };

            /**
             * Encodes the specified DescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.DescriptorProto.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.DescriptorProto
             * @static
             * @param {google.protobuf.IDescriptorProto} message DescriptorProto message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            DescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a DescriptorProto message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.DescriptorProto
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.DescriptorProto} DescriptorProto
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            DescriptorProto.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.DescriptorProto();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.name = reader.string();
                        break;
                    case 2:
                        if (!(message.field && message.field.length))
                            message.field = [];
                        message.field.push($root.google.protobuf.FieldDescriptorProto.decode(reader, reader.uint32()));
                        break;
                    case 6:
                        if (!(message.extension && message.extension.length))
                            message.extension = [];
                        message.extension.push($root.google.protobuf.FieldDescriptorProto.decode(reader, reader.uint32()));
                        break;
                    case 3:
                        if (!(message.nestedType && message.nestedType.length))
                            message.nestedType = [];
                        message.nestedType.push($root.google.protobuf.DescriptorProto.decode(reader, reader.uint32()));
                        break;
                    case 4:
                        if (!(message.enumType && message.enumType.length))
                            message.enumType = [];
                        message.enumType.push($root.google.protobuf.EnumDescriptorProto.decode(reader, reader.uint32()));
                        break;
                    case 5:
                        if (!(message.extensionRange && message.extensionRange.length))
                            message.extensionRange = [];
                        message.extensionRange.push($root.google.protobuf.DescriptorProto.ExtensionRange.decode(reader, reader.uint32()));
                        break;
                    case 8:
                        if (!(message.oneofDecl && message.oneofDecl.length))
                            message.oneofDecl = [];
                        message.oneofDecl.push($root.google.protobuf.OneofDescriptorProto.decode(reader, reader.uint32()));
                        break;
                    case 7:
                        message.options = $root.google.protobuf.MessageOptions.decode(reader, reader.uint32());
                        break;
                    case 9:
                        if (!(message.reservedRange && message.reservedRange.length))
                            message.reservedRange = [];
                        message.reservedRange.push($root.google.protobuf.DescriptorProto.ReservedRange.decode(reader, reader.uint32()));
                        break;
                    case 10:
                        if (!(message.reservedName && message.reservedName.length))
                            message.reservedName = [];
                        message.reservedName.push(reader.string());
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a DescriptorProto message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.DescriptorProto
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.DescriptorProto} DescriptorProto
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            DescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a DescriptorProto message.
             * @function verify
             * @memberof google.protobuf.DescriptorProto
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            DescriptorProto.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.name != null && message.hasOwnProperty("name"))
                    if (!$util.isString(message.name))
                        return "name: string expected";
                if (message.field != null && message.hasOwnProperty("field")) {
                    if (!Array.isArray(message.field))
                        return "field: array expected";
                    for (var i = 0; i < message.field.length; ++i) {
                        var error = $root.google.protobuf.FieldDescriptorProto.verify(message.field[i]);
                        if (error)
                            return "field." + error;
                    }
                }
                if (message.extension != null && message.hasOwnProperty("extension")) {
                    if (!Array.isArray(message.extension))
                        return "extension: array expected";
                    for (var i = 0; i < message.extension.length; ++i) {
                        var error = $root.google.protobuf.FieldDescriptorProto.verify(message.extension[i]);
                        if (error)
                            return "extension." + error;
                    }
                }
                if (message.nestedType != null && message.hasOwnProperty("nestedType")) {
                    if (!Array.isArray(message.nestedType))
                        return "nestedType: array expected";
                    for (var i = 0; i < message.nestedType.length; ++i) {
                        var error = $root.google.protobuf.DescriptorProto.verify(message.nestedType[i]);
                        if (error)
                            return "nestedType." + error;
                    }
                }
                if (message.enumType != null && message.hasOwnProperty("enumType")) {
                    if (!Array.isArray(message.enumType))
                        return "enumType: array expected";
                    for (var i = 0; i < message.enumType.length; ++i) {
                        var error = $root.google.protobuf.EnumDescriptorProto.verify(message.enumType[i]);
                        if (error)
                            return "enumType." + error;
                    }
                }
                if (message.extensionRange != null && message.hasOwnProperty("extensionRange")) {
                    if (!Array.isArray(message.extensionRange))
                        return "extensionRange: array expected";
                    for (var i = 0; i < message.extensionRange.length; ++i) {
                        var error = $root.google.protobuf.DescriptorProto.ExtensionRange.verify(message.extensionRange[i]);
                        if (error)
                            return "extensionRange." + error;
                    }
                }
                if (message.oneofDecl != null && message.hasOwnProperty("oneofDecl")) {
                    if (!Array.isArray(message.oneofDecl))
                        return "oneofDecl: array expected";
                    for (var i = 0; i < message.oneofDecl.length; ++i) {
                        var error = $root.google.protobuf.OneofDescriptorProto.verify(message.oneofDecl[i]);
                        if (error)
                            return "oneofDecl." + error;
                    }
                }
                if (message.options != null && message.hasOwnProperty("options")) {
                    var error = $root.google.protobuf.MessageOptions.verify(message.options);
                    if (error)
                        return "options." + error;
                }
                if (message.reservedRange != null && message.hasOwnProperty("reservedRange")) {
                    if (!Array.isArray(message.reservedRange))
                        return "reservedRange: array expected";
                    for (var i = 0; i < message.reservedRange.length; ++i) {
                        var error = $root.google.protobuf.DescriptorProto.ReservedRange.verify(message.reservedRange[i]);
                        if (error)
                            return "reservedRange." + error;
                    }
                }
                if (message.reservedName != null && message.hasOwnProperty("reservedName")) {
                    if (!Array.isArray(message.reservedName))
                        return "reservedName: array expected";
                    for (var i = 0; i < message.reservedName.length; ++i)
                        if (!$util.isString(message.reservedName[i]))
                            return "reservedName: string[] expected";
                }
                return null;
            };

            /**
             * Creates a DescriptorProto message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.DescriptorProto
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.DescriptorProto} DescriptorProto
             */
            DescriptorProto.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.DescriptorProto)
                    return object;
                var message = new $root.google.protobuf.DescriptorProto();
                if (object.name != null)
                    message.name = String(object.name);
                if (object.field) {
                    if (!Array.isArray(object.field))
                        throw TypeError(".google.protobuf.DescriptorProto.field: array expected");
                    message.field = [];
                    for (var i = 0; i < object.field.length; ++i) {
                        if (typeof object.field[i] !== "object")
                            throw TypeError(".google.protobuf.DescriptorProto.field: object expected");
                        message.field[i] = $root.google.protobuf.FieldDescriptorProto.fromObject(object.field[i]);
                    }
                }
                if (object.extension) {
                    if (!Array.isArray(object.extension))
                        throw TypeError(".google.protobuf.DescriptorProto.extension: array expected");
                    message.extension = [];
                    for (var i = 0; i < object.extension.length; ++i) {
                        if (typeof object.extension[i] !== "object")
                            throw TypeError(".google.protobuf.DescriptorProto.extension: object expected");
                        message.extension[i] = $root.google.protobuf.FieldDescriptorProto.fromObject(object.extension[i]);
                    }
                }
                if (object.nestedType) {
                    if (!Array.isArray(object.nestedType))
                        throw TypeError(".google.protobuf.DescriptorProto.nestedType: array expected");
                    message.nestedType = [];
                    for (var i = 0; i < object.nestedType.length; ++i) {
                        if (typeof object.nestedType[i] !== "object")
                            throw TypeError(".google.protobuf.DescriptorProto.nestedType: object expected");
                        message.nestedType[i] = $root.google.protobuf.DescriptorProto.fromObject(object.nestedType[i]);
                    }
                }
                if (object.enumType) {
                    if (!Array.isArray(object.enumType))
                        throw TypeError(".google.protobuf.DescriptorProto.enumType: array expected");
                    message.enumType = [];
                    for (var i = 0; i < object.enumType.length; ++i) {
                        if (typeof object.enumType[i] !== "object")
                            throw TypeError(".google.protobuf.DescriptorProto.enumType: object expected");
                        message.enumType[i] = $root.google.protobuf.EnumDescriptorProto.fromObject(object.enumType[i]);
                    }
                }
                if (object.extensionRange) {
                    if (!Array.isArray(object.extensionRange))
                        throw TypeError(".google.protobuf.DescriptorProto.extensionRange: array expected");
                    message.extensionRange = [];
                    for (var i = 0; i < object.extensionRange.length; ++i) {
                        if (typeof object.extensionRange[i] !== "object")
                            throw TypeError(".google.protobuf.DescriptorProto.extensionRange: object expected");
                        message.extensionRange[i] = $root.google.protobuf.DescriptorProto.ExtensionRange.fromObject(object.extensionRange[i]);
                    }
                }
                if (object.oneofDecl) {
                    if (!Array.isArray(object.oneofDecl))
                        throw TypeError(".google.protobuf.DescriptorProto.oneofDecl: array expected");
                    message.oneofDecl = [];
                    for (var i = 0; i < object.oneofDecl.length; ++i) {
                        if (typeof object.oneofDecl[i] !== "object")
                            throw TypeError(".google.protobuf.DescriptorProto.oneofDecl: object expected");
                        message.oneofDecl[i] = $root.google.protobuf.OneofDescriptorProto.fromObject(object.oneofDecl[i]);
                    }
                }
                if (object.options != null) {
                    if (typeof object.options !== "object")
                        throw TypeError(".google.protobuf.DescriptorProto.options: object expected");
                    message.options = $root.google.protobuf.MessageOptions.fromObject(object.options);
                }
                if (object.reservedRange) {
                    if (!Array.isArray(object.reservedRange))
                        throw TypeError(".google.protobuf.DescriptorProto.reservedRange: array expected");
                    message.reservedRange = [];
                    for (var i = 0; i < object.reservedRange.length; ++i) {
                        if (typeof object.reservedRange[i] !== "object")
                            throw TypeError(".google.protobuf.DescriptorProto.reservedRange: object expected");
                        message.reservedRange[i] = $root.google.protobuf.DescriptorProto.ReservedRange.fromObject(object.reservedRange[i]);
                    }
                }
                if (object.reservedName) {
                    if (!Array.isArray(object.reservedName))
                        throw TypeError(".google.protobuf.DescriptorProto.reservedName: array expected");
                    message.reservedName = [];
                    for (var i = 0; i < object.reservedName.length; ++i)
                        message.reservedName[i] = String(object.reservedName[i]);
                }
                return message;
            };

            /**
             * Creates a plain object from a DescriptorProto message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.DescriptorProto
             * @static
             * @param {google.protobuf.DescriptorProto} message DescriptorProto
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            DescriptorProto.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults) {
                    object.field = [];
                    object.nestedType = [];
                    object.enumType = [];
                    object.extensionRange = [];
                    object.extension = [];
                    object.oneofDecl = [];
                    object.reservedRange = [];
                    object.reservedName = [];
                }
                if (options.defaults) {
                    object.name = "";
                    object.options = null;
                }
                if (message.name != null && message.hasOwnProperty("name"))
                    object.name = message.name;
                if (message.field && message.field.length) {
                    object.field = [];
                    for (var j = 0; j < message.field.length; ++j)
                        object.field[j] = $root.google.protobuf.FieldDescriptorProto.toObject(message.field[j], options);
                }
                if (message.nestedType && message.nestedType.length) {
                    object.nestedType = [];
                    for (var j = 0; j < message.nestedType.length; ++j)
                        object.nestedType[j] = $root.google.protobuf.DescriptorProto.toObject(message.nestedType[j], options);
                }
                if (message.enumType && message.enumType.length) {
                    object.enumType = [];
                    for (var j = 0; j < message.enumType.length; ++j)
                        object.enumType[j] = $root.google.protobuf.EnumDescriptorProto.toObject(message.enumType[j], options);
                }
                if (message.extensionRange && message.extensionRange.length) {
                    object.extensionRange = [];
                    for (var j = 0; j < message.extensionRange.length; ++j)
                        object.extensionRange[j] = $root.google.protobuf.DescriptorProto.ExtensionRange.toObject(message.extensionRange[j], options);
                }
                if (message.extension && message.extension.length) {
                    object.extension = [];
                    for (var j = 0; j < message.extension.length; ++j)
                        object.extension[j] = $root.google.protobuf.FieldDescriptorProto.toObject(message.extension[j], options);
                }
                if (message.options != null && message.hasOwnProperty("options"))
                    object.options = $root.google.protobuf.MessageOptions.toObject(message.options, options);
                if (message.oneofDecl && message.oneofDecl.length) {
                    object.oneofDecl = [];
                    for (var j = 0; j < message.oneofDecl.length; ++j)
                        object.oneofDecl[j] = $root.google.protobuf.OneofDescriptorProto.toObject(message.oneofDecl[j], options);
                }
                if (message.reservedRange && message.reservedRange.length) {
                    object.reservedRange = [];
                    for (var j = 0; j < message.reservedRange.length; ++j)
                        object.reservedRange[j] = $root.google.protobuf.DescriptorProto.ReservedRange.toObject(message.reservedRange[j], options);
                }
                if (message.reservedName && message.reservedName.length) {
                    object.reservedName = [];
                    for (var j = 0; j < message.reservedName.length; ++j)
                        object.reservedName[j] = message.reservedName[j];
                }
                return object;
            };

            /**
             * Converts this DescriptorProto to JSON.
             * @function toJSON
             * @memberof google.protobuf.DescriptorProto
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            DescriptorProto.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            DescriptorProto.ExtensionRange = (function() {

                /**
                 * Properties of an ExtensionRange.
                 * @memberof google.protobuf.DescriptorProto
                 * @interface IExtensionRange
                 * @property {number|null} [start] ExtensionRange start
                 * @property {number|null} [end] ExtensionRange end
                 */

                /**
                 * Constructs a new ExtensionRange.
                 * @memberof google.protobuf.DescriptorProto
                 * @classdesc Represents an ExtensionRange.
                 * @implements IExtensionRange
                 * @constructor
                 * @param {google.protobuf.DescriptorProto.IExtensionRange=} [properties] Properties to set
                 */
                function ExtensionRange(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }

                /**
                 * ExtensionRange start.
                 * @member {number} start
                 * @memberof google.protobuf.DescriptorProto.ExtensionRange
                 * @instance
                 */
                ExtensionRange.prototype.start = 0;

                /**
                 * ExtensionRange end.
                 * @member {number} end
                 * @memberof google.protobuf.DescriptorProto.ExtensionRange
                 * @instance
                 */
                ExtensionRange.prototype.end = 0;

                /**
                 * Creates a new ExtensionRange instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.DescriptorProto.ExtensionRange
                 * @static
                 * @param {google.protobuf.DescriptorProto.IExtensionRange=} [properties] Properties to set
                 * @returns {google.protobuf.DescriptorProto.ExtensionRange} ExtensionRange instance
                 */
                ExtensionRange.create = function create(properties) {
                    return new ExtensionRange(properties);
                };

                /**
                 * Encodes the specified ExtensionRange message. Does not implicitly {@link google.protobuf.DescriptorProto.ExtensionRange.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.DescriptorProto.ExtensionRange
                 * @static
                 * @param {google.protobuf.DescriptorProto.IExtensionRange} message ExtensionRange message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ExtensionRange.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.start != null && message.hasOwnProperty("start"))
                        writer.uint32(/* id 1, wireType 0 =*/8).int32(message.start);
                    if (message.end != null && message.hasOwnProperty("end"))
                        writer.uint32(/* id 2, wireType 0 =*/16).int32(message.end);
                    return writer;
                };

                /**
                 * Encodes the specified ExtensionRange message, length delimited. Does not implicitly {@link google.protobuf.DescriptorProto.ExtensionRange.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.DescriptorProto.ExtensionRange
                 * @static
                 * @param {google.protobuf.DescriptorProto.IExtensionRange} message ExtensionRange message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ExtensionRange.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };

                /**
                 * Decodes an ExtensionRange message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.DescriptorProto.ExtensionRange
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.DescriptorProto.ExtensionRange} ExtensionRange
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ExtensionRange.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.DescriptorProto.ExtensionRange();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1:
                            message.start = reader.int32();
                            break;
                        case 2:
                            message.end = reader.int32();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };

                /**
                 * Decodes an ExtensionRange message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.DescriptorProto.ExtensionRange
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.DescriptorProto.ExtensionRange} ExtensionRange
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ExtensionRange.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };

                /**
                 * Verifies an ExtensionRange message.
                 * @function verify
                 * @memberof google.protobuf.DescriptorProto.ExtensionRange
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                ExtensionRange.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.start != null && message.hasOwnProperty("start"))
                        if (!$util.isInteger(message.start))
                            return "start: integer expected";
                    if (message.end != null && message.hasOwnProperty("end"))
                        if (!$util.isInteger(message.end))
                            return "end: integer expected";
                    return null;
                };

                /**
                 * Creates an ExtensionRange message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.DescriptorProto.ExtensionRange
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.DescriptorProto.ExtensionRange} ExtensionRange
                 */
                ExtensionRange.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.DescriptorProto.ExtensionRange)
                        return object;
                    var message = new $root.google.protobuf.DescriptorProto.ExtensionRange();
                    if (object.start != null)
                        message.start = object.start | 0;
                    if (object.end != null)
                        message.end = object.end | 0;
                    return message;
                };

                /**
                 * Creates a plain object from an ExtensionRange message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.DescriptorProto.ExtensionRange
                 * @static
                 * @param {google.protobuf.DescriptorProto.ExtensionRange} message ExtensionRange
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                ExtensionRange.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.start = 0;
                        object.end = 0;
                    }
                    if (message.start != null && message.hasOwnProperty("start"))
                        object.start = message.start;
                    if (message.end != null && message.hasOwnProperty("end"))
                        object.end = message.end;
                    return object;
                };

                /**
                 * Converts this ExtensionRange to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.DescriptorProto.ExtensionRange
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                ExtensionRange.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };

                return ExtensionRange;
            })();

            DescriptorProto.ReservedRange = (function() {

                /**
                 * Properties of a ReservedRange.
                 * @memberof google.protobuf.DescriptorProto
                 * @interface IReservedRange
                 * @property {number|null} [start] ReservedRange start
                 * @property {number|null} [end] ReservedRange end
                 */

                /**
                 * Constructs a new ReservedRange.
                 * @memberof google.protobuf.DescriptorProto
                 * @classdesc Represents a ReservedRange.
                 * @implements IReservedRange
                 * @constructor
                 * @param {google.protobuf.DescriptorProto.IReservedRange=} [properties] Properties to set
                 */
                function ReservedRange(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }

                /**
                 * ReservedRange start.
                 * @member {number} start
                 * @memberof google.protobuf.DescriptorProto.ReservedRange
                 * @instance
                 */
                ReservedRange.prototype.start = 0;

                /**
                 * ReservedRange end.
                 * @member {number} end
                 * @memberof google.protobuf.DescriptorProto.ReservedRange
                 * @instance
                 */
                ReservedRange.prototype.end = 0;

                /**
                 * Creates a new ReservedRange instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.DescriptorProto.ReservedRange
                 * @static
                 * @param {google.protobuf.DescriptorProto.IReservedRange=} [properties] Properties to set
                 * @returns {google.protobuf.DescriptorProto.ReservedRange} ReservedRange instance
                 */
                ReservedRange.create = function create(properties) {
                    return new ReservedRange(properties);
                };

                /**
                 * Encodes the specified ReservedRange message. Does not implicitly {@link google.protobuf.DescriptorProto.ReservedRange.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.DescriptorProto.ReservedRange
                 * @static
                 * @param {google.protobuf.DescriptorProto.IReservedRange} message ReservedRange message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ReservedRange.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.start != null && message.hasOwnProperty("start"))
                        writer.uint32(/* id 1, wireType 0 =*/8).int32(message.start);
                    if (message.end != null && message.hasOwnProperty("end"))
                        writer.uint32(/* id 2, wireType 0 =*/16).int32(message.end);
                    return writer;
                };

                /**
                 * Encodes the specified ReservedRange message, length delimited. Does not implicitly {@link google.protobuf.DescriptorProto.ReservedRange.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.DescriptorProto.ReservedRange
                 * @static
                 * @param {google.protobuf.DescriptorProto.IReservedRange} message ReservedRange message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ReservedRange.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };

                /**
                 * Decodes a ReservedRange message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.DescriptorProto.ReservedRange
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.DescriptorProto.ReservedRange} ReservedRange
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ReservedRange.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.DescriptorProto.ReservedRange();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1:
                            message.start = reader.int32();
                            break;
                        case 2:
                            message.end = reader.int32();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };

                /**
                 * Decodes a ReservedRange message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.DescriptorProto.ReservedRange
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.DescriptorProto.ReservedRange} ReservedRange
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ReservedRange.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };

                /**
                 * Verifies a ReservedRange message.
                 * @function verify
                 * @memberof google.protobuf.DescriptorProto.ReservedRange
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                ReservedRange.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.start != null && message.hasOwnProperty("start"))
                        if (!$util.isInteger(message.start))
                            return "start: integer expected";
                    if (message.end != null && message.hasOwnProperty("end"))
                        if (!$util.isInteger(message.end))
                            return "end: integer expected";
                    return null;
                };

                /**
                 * Creates a ReservedRange message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.DescriptorProto.ReservedRange
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.DescriptorProto.ReservedRange} ReservedRange
                 */
                ReservedRange.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.DescriptorProto.ReservedRange)
                        return object;
                    var message = new $root.google.protobuf.DescriptorProto.ReservedRange();
                    if (object.start != null)
                        message.start = object.start | 0;
                    if (object.end != null)
                        message.end = object.end | 0;
                    return message;
                };

                /**
                 * Creates a plain object from a ReservedRange message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.DescriptorProto.ReservedRange
                 * @static
                 * @param {google.protobuf.DescriptorProto.ReservedRange} message ReservedRange
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                ReservedRange.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.start = 0;
                        object.end = 0;
                    }
                    if (message.start != null && message.hasOwnProperty("start"))
                        object.start = message.start;
                    if (message.end != null && message.hasOwnProperty("end"))
                        object.end = message.end;
                    return object;
                };

                /**
                 * Converts this ReservedRange to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.DescriptorProto.ReservedRange
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                ReservedRange.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };

                return ReservedRange;
            })();

            return DescriptorProto;
        })();

        protobuf.FieldDescriptorProto = (function() {

            /**
             * Properties of a FieldDescriptorProto.
             * @memberof google.protobuf
             * @interface IFieldDescriptorProto
             * @property {string|null} [name] FieldDescriptorProto name
             * @property {number|null} [number] FieldDescriptorProto number
             * @property {google.protobuf.FieldDescriptorProto.Label|null} [label] FieldDescriptorProto label
             * @property {google.protobuf.FieldDescriptorProto.Type|null} [type] FieldDescriptorProto type
             * @property {string|null} [typeName] FieldDescriptorProto typeName
             * @property {string|null} [extendee] FieldDescriptorProto extendee
             * @property {string|null} [defaultValue] FieldDescriptorProto defaultValue
             * @property {number|null} [oneofIndex] FieldDescriptorProto oneofIndex
             * @property {string|null} [jsonName] FieldDescriptorProto jsonName
             * @property {google.protobuf.IFieldOptions|null} [options] FieldDescriptorProto options
             */

            /**
             * Constructs a new FieldDescriptorProto.
             * @memberof google.protobuf
             * @classdesc Represents a FieldDescriptorProto.
             * @implements IFieldDescriptorProto
             * @constructor
             * @param {google.protobuf.IFieldDescriptorProto=} [properties] Properties to set
             */
            function FieldDescriptorProto(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * FieldDescriptorProto name.
             * @member {string} name
             * @memberof google.protobuf.FieldDescriptorProto
             * @instance
             */
            FieldDescriptorProto.prototype.name = "";

            /**
             * FieldDescriptorProto number.
             * @member {number} number
             * @memberof google.protobuf.FieldDescriptorProto
             * @instance
             */
            FieldDescriptorProto.prototype.number = 0;

            /**
             * FieldDescriptorProto label.
             * @member {google.protobuf.FieldDescriptorProto.Label} label
             * @memberof google.protobuf.FieldDescriptorProto
             * @instance
             */
            FieldDescriptorProto.prototype.label = 1;

            /**
             * FieldDescriptorProto type.
             * @member {google.protobuf.FieldDescriptorProto.Type} type
             * @memberof google.protobuf.FieldDescriptorProto
             * @instance
             */
            FieldDescriptorProto.prototype.type = 1;

            /**
             * FieldDescriptorProto typeName.
             * @member {string} typeName
             * @memberof google.protobuf.FieldDescriptorProto
             * @instance
             */
            FieldDescriptorProto.prototype.typeName = "";

            /**
             * FieldDescriptorProto extendee.
             * @member {string} extendee
             * @memberof google.protobuf.FieldDescriptorProto
             * @instance
             */
            FieldDescriptorProto.prototype.extendee = "";

            /**
             * FieldDescriptorProto defaultValue.
             * @member {string} defaultValue
             * @memberof google.protobuf.FieldDescriptorProto
             * @instance
             */
            FieldDescriptorProto.prototype.defaultValue = "";

            /**
             * FieldDescriptorProto oneofIndex.
             * @member {number} oneofIndex
             * @memberof google.protobuf.FieldDescriptorProto
             * @instance
             */
            FieldDescriptorProto.prototype.oneofIndex = 0;

            /**
             * FieldDescriptorProto jsonName.
             * @member {string} jsonName
             * @memberof google.protobuf.FieldDescriptorProto
             * @instance
             */
            FieldDescriptorProto.prototype.jsonName = "";

            /**
             * FieldDescriptorProto options.
             * @member {google.protobuf.IFieldOptions|null|undefined} options
             * @memberof google.protobuf.FieldDescriptorProto
             * @instance
             */
            FieldDescriptorProto.prototype.options = null;

            /**
             * Creates a new FieldDescriptorProto instance using the specified properties.
             * @function create
             * @memberof google.protobuf.FieldDescriptorProto
             * @static
             * @param {google.protobuf.IFieldDescriptorProto=} [properties] Properties to set
             * @returns {google.protobuf.FieldDescriptorProto} FieldDescriptorProto instance
             */
            FieldDescriptorProto.create = function create(properties) {
                return new FieldDescriptorProto(properties);
            };

            /**
             * Encodes the specified FieldDescriptorProto message. Does not implicitly {@link google.protobuf.FieldDescriptorProto.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.FieldDescriptorProto
             * @static
             * @param {google.protobuf.IFieldDescriptorProto} message FieldDescriptorProto message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            FieldDescriptorProto.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.name != null && message.hasOwnProperty("name"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                if (message.extendee != null && message.hasOwnProperty("extendee"))
                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.extendee);
                if (message.number != null && message.hasOwnProperty("number"))
                    writer.uint32(/* id 3, wireType 0 =*/24).int32(message.number);
                if (message.label != null && message.hasOwnProperty("label"))
                    writer.uint32(/* id 4, wireType 0 =*/32).int32(message.label);
                if (message.type != null && message.hasOwnProperty("type"))
                    writer.uint32(/* id 5, wireType 0 =*/40).int32(message.type);
                if (message.typeName != null && message.hasOwnProperty("typeName"))
                    writer.uint32(/* id 6, wireType 2 =*/50).string(message.typeName);
                if (message.defaultValue != null && message.hasOwnProperty("defaultValue"))
                    writer.uint32(/* id 7, wireType 2 =*/58).string(message.defaultValue);
                if (message.options != null && message.hasOwnProperty("options"))
                    $root.google.protobuf.FieldOptions.encode(message.options, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                if (message.oneofIndex != null && message.hasOwnProperty("oneofIndex"))
                    writer.uint32(/* id 9, wireType 0 =*/72).int32(message.oneofIndex);
                if (message.jsonName != null && message.hasOwnProperty("jsonName"))
                    writer.uint32(/* id 10, wireType 2 =*/82).string(message.jsonName);
                return writer;
            };

            /**
             * Encodes the specified FieldDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.FieldDescriptorProto.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.FieldDescriptorProto
             * @static
             * @param {google.protobuf.IFieldDescriptorProto} message FieldDescriptorProto message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            FieldDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a FieldDescriptorProto message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.FieldDescriptorProto
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.FieldDescriptorProto} FieldDescriptorProto
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            FieldDescriptorProto.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FieldDescriptorProto();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.name = reader.string();
                        break;
                    case 3:
                        message.number = reader.int32();
                        break;
                    case 4:
                        message.label = reader.int32();
                        break;
                    case 5:
                        message.type = reader.int32();
                        break;
                    case 6:
                        message.typeName = reader.string();
                        break;
                    case 2:
                        message.extendee = reader.string();
                        break;
                    case 7:
                        message.defaultValue = reader.string();
                        break;
                    case 9:
                        message.oneofIndex = reader.int32();
                        break;
                    case 10:
                        message.jsonName = reader.string();
                        break;
                    case 8:
                        message.options = $root.google.protobuf.FieldOptions.decode(reader, reader.uint32());
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a FieldDescriptorProto message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.FieldDescriptorProto
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.FieldDescriptorProto} FieldDescriptorProto
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            FieldDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a FieldDescriptorProto message.
             * @function verify
             * @memberof google.protobuf.FieldDescriptorProto
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            FieldDescriptorProto.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.name != null && message.hasOwnProperty("name"))
                    if (!$util.isString(message.name))
                        return "name: string expected";
                if (message.number != null && message.hasOwnProperty("number"))
                    if (!$util.isInteger(message.number))
                        return "number: integer expected";
                if (message.label != null && message.hasOwnProperty("label"))
                    switch (message.label) {
                    default:
                        return "label: enum value expected";
                    case 1:
                    case 2:
                    case 3:
                        break;
                    }
                if (message.type != null && message.hasOwnProperty("type"))
                    switch (message.type) {
                    default:
                        return "type: enum value expected";
                    case 1:
                    case 2:
                    case 3:
                    case 4:
                    case 5:
                    case 6:
                    case 7:
                    case 8:
                    case 9:
                    case 10:
                    case 11:
                    case 12:
                    case 13:
                    case 14:
                    case 15:
                    case 16:
                    case 17:
                    case 18:
                        break;
                    }
                if (message.typeName != null && message.hasOwnProperty("typeName"))
                    if (!$util.isString(message.typeName))
                        return "typeName: string expected";
                if (message.extendee != null && message.hasOwnProperty("extendee"))
                    if (!$util.isString(message.extendee))
                        return "extendee: string expected";
                if (message.defaultValue != null && message.hasOwnProperty("defaultValue"))
                    if (!$util.isString(message.defaultValue))
                        return "defaultValue: string expected";
                if (message.oneofIndex != null && message.hasOwnProperty("oneofIndex"))
                    if (!$util.isInteger(message.oneofIndex))
                        return "oneofIndex: integer expected";
                if (message.jsonName != null && message.hasOwnProperty("jsonName"))
                    if (!$util.isString(message.jsonName))
                        return "jsonName: string expected";
                if (message.options != null && message.hasOwnProperty("options")) {
                    var error = $root.google.protobuf.FieldOptions.verify(message.options);
                    if (error)
                        return "options." + error;
                }
                return null;
            };

            /**
             * Creates a FieldDescriptorProto message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.FieldDescriptorProto
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.FieldDescriptorProto} FieldDescriptorProto
             */
            FieldDescriptorProto.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.FieldDescriptorProto)
                    return object;
                var message = new $root.google.protobuf.FieldDescriptorProto();
                if (object.name != null)
                    message.name = String(object.name);
                if (object.number != null)
                    message.number = object.number | 0;
                switch (object.label) {
                case "LABEL_OPTIONAL":
                case 1:
                    message.label = 1;
                    break;
                case "LABEL_REQUIRED":
                case 2:
                    message.label = 2;
                    break;
                case "LABEL_REPEATED":
                case 3:
                    message.label = 3;
                    break;
                }
                switch (object.type) {
                case "TYPE_DOUBLE":
                case 1:
                    message.type = 1;
                    break;
                case "TYPE_FLOAT":
                case 2:
                    message.type = 2;
                    break;
                case "TYPE_INT64":
                case 3:
                    message.type = 3;
                    break;
                case "TYPE_UINT64":
                case 4:
                    message.type = 4;
                    break;
                case "TYPE_INT32":
                case 5:
                    message.type = 5;
                    break;
                case "TYPE_FIXED64":
                case 6:
                    message.type = 6;
                    break;
                case "TYPE_FIXED32":
                case 7:
                    message.type = 7;
                    break;
                case "TYPE_BOOL":
                case 8:
                    message.type = 8;
                    break;
                case "TYPE_STRING":
                case 9:
                    message.type = 9;
                    break;
                case "TYPE_GROUP":
                case 10:
                    message.type = 10;
                    break;
                case "TYPE_MESSAGE":
                case 11:
                    message.type = 11;
                    break;
                case "TYPE_BYTES":
                case 12:
                    message.type = 12;
                    break;
                case "TYPE_UINT32":
                case 13:
                    message.type = 13;
                    break;
                case "TYPE_ENUM":
                case 14:
                    message.type = 14;
                    break;
                case "TYPE_SFIXED32":
                case 15:
                    message.type = 15;
                    break;
                case "TYPE_SFIXED64":
                case 16:
                    message.type = 16;
                    break;
                case "TYPE_SINT32":
                case 17:
                    message.type = 17;
                    break;
                case "TYPE_SINT64":
                case 18:
                    message.type = 18;
                    break;
                }
                if (object.typeName != null)
                    message.typeName = String(object.typeName);
                if (object.extendee != null)
                    message.extendee = String(object.extendee);
                if (object.defaultValue != null)
                    message.defaultValue = String(object.defaultValue);
                if (object.oneofIndex != null)
                    message.oneofIndex = object.oneofIndex | 0;
                if (object.jsonName != null)
                    message.jsonName = String(object.jsonName);
                if (object.options != null) {
                    if (typeof object.options !== "object")
                        throw TypeError(".google.protobuf.FieldDescriptorProto.options: object expected");
                    message.options = $root.google.protobuf.FieldOptions.fromObject(object.options);
                }
                return message;
            };

            /**
             * Creates a plain object from a FieldDescriptorProto message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.FieldDescriptorProto
             * @static
             * @param {google.protobuf.FieldDescriptorProto} message FieldDescriptorProto
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            FieldDescriptorProto.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults) {
                    object.name = "";
                    object.extendee = "";
                    object.number = 0;
                    object.label = options.enums === String ? "LABEL_OPTIONAL" : 1;
                    object.type = options.enums === String ? "TYPE_DOUBLE" : 1;
                    object.typeName = "";
                    object.defaultValue = "";
                    object.options = null;
                    object.oneofIndex = 0;
                    object.jsonName = "";
                }
                if (message.name != null && message.hasOwnProperty("name"))
                    object.name = message.name;
                if (message.extendee != null && message.hasOwnProperty("extendee"))
                    object.extendee = message.extendee;
                if (message.number != null && message.hasOwnProperty("number"))
                    object.number = message.number;
                if (message.label != null && message.hasOwnProperty("label"))
                    object.label = options.enums === String ? $root.google.protobuf.FieldDescriptorProto.Label[message.label] : message.label;
                if (message.type != null && message.hasOwnProperty("type"))
                    object.type = options.enums === String ? $root.google.protobuf.FieldDescriptorProto.Type[message.type] : message.type;
                if (message.typeName != null && message.hasOwnProperty("typeName"))
                    object.typeName = message.typeName;
                if (message.defaultValue != null && message.hasOwnProperty("defaultValue"))
                    object.defaultValue = message.defaultValue;
                if (message.options != null && message.hasOwnProperty("options"))
                    object.options = $root.google.protobuf.FieldOptions.toObject(message.options, options);
                if (message.oneofIndex != null && message.hasOwnProperty("oneofIndex"))
                    object.oneofIndex = message.oneofIndex;
                if (message.jsonName != null && message.hasOwnProperty("jsonName"))
                    object.jsonName = message.jsonName;
                return object;
            };

            /**
             * Converts this FieldDescriptorProto to JSON.
             * @function toJSON
             * @memberof google.protobuf.FieldDescriptorProto
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            FieldDescriptorProto.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            /**
             * Type enum.
             * @name google.protobuf.FieldDescriptorProto.Type
             * @enum {string}
             * @property {number} TYPE_DOUBLE=1 TYPE_DOUBLE value
             * @property {number} TYPE_FLOAT=2 TYPE_FLOAT value
             * @property {number} TYPE_INT64=3 TYPE_INT64 value
             * @property {number} TYPE_UINT64=4 TYPE_UINT64 value
             * @property {number} TYPE_INT32=5 TYPE_INT32 value
             * @property {number} TYPE_FIXED64=6 TYPE_FIXED64 value
             * @property {number} TYPE_FIXED32=7 TYPE_FIXED32 value
             * @property {number} TYPE_BOOL=8 TYPE_BOOL value
             * @property {number} TYPE_STRING=9 TYPE_STRING value
             * @property {number} TYPE_GROUP=10 TYPE_GROUP value
             * @property {number} TYPE_MESSAGE=11 TYPE_MESSAGE value
             * @property {number} TYPE_BYTES=12 TYPE_BYTES value
             * @property {number} TYPE_UINT32=13 TYPE_UINT32 value
             * @property {number} TYPE_ENUM=14 TYPE_ENUM value
             * @property {number} TYPE_SFIXED32=15 TYPE_SFIXED32 value
             * @property {number} TYPE_SFIXED64=16 TYPE_SFIXED64 value
             * @property {number} TYPE_SINT32=17 TYPE_SINT32 value
             * @property {number} TYPE_SINT64=18 TYPE_SINT64 value
             */
            FieldDescriptorProto.Type = (function() {
                var valuesById = {}, values = Object.create(valuesById);
                values[valuesById[1] = "TYPE_DOUBLE"] = 1;
                values[valuesById[2] = "TYPE_FLOAT"] = 2;
                values[valuesById[3] = "TYPE_INT64"] = 3;
                values[valuesById[4] = "TYPE_UINT64"] = 4;
                values[valuesById[5] = "TYPE_INT32"] = 5;
                values[valuesById[6] = "TYPE_FIXED64"] = 6;
                values[valuesById[7] = "TYPE_FIXED32"] = 7;
                values[valuesById[8] = "TYPE_BOOL"] = 8;
                values[valuesById[9] = "TYPE_STRING"] = 9;
                values[valuesById[10] = "TYPE_GROUP"] = 10;
                values[valuesById[11] = "TYPE_MESSAGE"] = 11;
                values[valuesById[12] = "TYPE_BYTES"] = 12;
                values[valuesById[13] = "TYPE_UINT32"] = 13;
                values[valuesById[14] = "TYPE_ENUM"] = 14;
                values[valuesById[15] = "TYPE_SFIXED32"] = 15;
                values[valuesById[16] = "TYPE_SFIXED64"] = 16;
                values[valuesById[17] = "TYPE_SINT32"] = 17;
                values[valuesById[18] = "TYPE_SINT64"] = 18;
                return values;
            })();

            /**
             * Label enum.
             * @name google.protobuf.FieldDescriptorProto.Label
             * @enum {string}
             * @property {number} LABEL_OPTIONAL=1 LABEL_OPTIONAL value
             * @property {number} LABEL_REQUIRED=2 LABEL_REQUIRED value
             * @property {number} LABEL_REPEATED=3 LABEL_REPEATED value
             */
            FieldDescriptorProto.Label = (function() {
                var valuesById = {}, values = Object.create(valuesById);
                values[valuesById[1] = "LABEL_OPTIONAL"] = 1;
                values[valuesById[2] = "LABEL_REQUIRED"] = 2;
                values[valuesById[3] = "LABEL_REPEATED"] = 3;
                return values;
            })();

            return FieldDescriptorProto;
        })();

        protobuf.OneofDescriptorProto = (function() {

            /**
             * Properties of an OneofDescriptorProto.
             * @memberof google.protobuf
             * @interface IOneofDescriptorProto
             * @property {string|null} [name] OneofDescriptorProto name
             * @property {google.protobuf.IOneofOptions|null} [options] OneofDescriptorProto options
             */

            /**
             * Constructs a new OneofDescriptorProto.
             * @memberof google.protobuf
             * @classdesc Represents an OneofDescriptorProto.
             * @implements IOneofDescriptorProto
             * @constructor
             * @param {google.protobuf.IOneofDescriptorProto=} [properties] Properties to set
             */
            function OneofDescriptorProto(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * OneofDescriptorProto name.
             * @member {string} name
             * @memberof google.protobuf.OneofDescriptorProto
             * @instance
             */
            OneofDescriptorProto.prototype.name = "";

            /**
             * OneofDescriptorProto options.
             * @member {google.protobuf.IOneofOptions|null|undefined} options
             * @memberof google.protobuf.OneofDescriptorProto
             * @instance
             */
            OneofDescriptorProto.prototype.options = null;

            /**
             * Creates a new OneofDescriptorProto instance using the specified properties.
             * @function create
             * @memberof google.protobuf.OneofDescriptorProto
             * @static
             * @param {google.protobuf.IOneofDescriptorProto=} [properties] Properties to set
             * @returns {google.protobuf.OneofDescriptorProto} OneofDescriptorProto instance
             */
            OneofDescriptorProto.create = function create(properties) {
                return new OneofDescriptorProto(properties);
            };

            /**
             * Encodes the specified OneofDescriptorProto message. Does not implicitly {@link google.protobuf.OneofDescriptorProto.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.OneofDescriptorProto
             * @static
             * @param {google.protobuf.IOneofDescriptorProto} message OneofDescriptorProto message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            OneofDescriptorProto.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.name != null && message.hasOwnProperty("name"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                if (message.options != null && message.hasOwnProperty("options"))
                    $root.google.protobuf.OneofOptions.encode(message.options, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified OneofDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.OneofDescriptorProto.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.OneofDescriptorProto
             * @static
             * @param {google.protobuf.IOneofDescriptorProto} message OneofDescriptorProto message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            OneofDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes an OneofDescriptorProto message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.OneofDescriptorProto
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.OneofDescriptorProto} OneofDescriptorProto
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            OneofDescriptorProto.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.OneofDescriptorProto();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.name = reader.string();
                        break;
                    case 2:
                        message.options = $root.google.protobuf.OneofOptions.decode(reader, reader.uint32());
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes an OneofDescriptorProto message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.OneofDescriptorProto
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.OneofDescriptorProto} OneofDescriptorProto
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            OneofDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies an OneofDescriptorProto message.
             * @function verify
             * @memberof google.protobuf.OneofDescriptorProto
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            OneofDescriptorProto.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.name != null && message.hasOwnProperty("name"))
                    if (!$util.isString(message.name))
                        return "name: string expected";
                if (message.options != null && message.hasOwnProperty("options")) {
                    var error = $root.google.protobuf.OneofOptions.verify(message.options);
                    if (error)
                        return "options." + error;
                }
                return null;
            };

            /**
             * Creates an OneofDescriptorProto message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.OneofDescriptorProto
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.OneofDescriptorProto} OneofDescriptorProto
             */
            OneofDescriptorProto.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.OneofDescriptorProto)
                    return object;
                var message = new $root.google.protobuf.OneofDescriptorProto();
                if (object.name != null)
                    message.name = String(object.name);
                if (object.options != null) {
                    if (typeof object.options !== "object")
                        throw TypeError(".google.protobuf.OneofDescriptorProto.options: object expected");
                    message.options = $root.google.protobuf.OneofOptions.fromObject(object.options);
                }
                return message;
            };

            /**
             * Creates a plain object from an OneofDescriptorProto message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.OneofDescriptorProto
             * @static
             * @param {google.protobuf.OneofDescriptorProto} message OneofDescriptorProto
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            OneofDescriptorProto.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults) {
                    object.name = "";
                    object.options = null;
                }
                if (message.name != null && message.hasOwnProperty("name"))
                    object.name = message.name;
                if (message.options != null && message.hasOwnProperty("options"))
                    object.options = $root.google.protobuf.OneofOptions.toObject(message.options, options);
                return object;
            };

            /**
             * Converts this OneofDescriptorProto to JSON.
             * @function toJSON
             * @memberof google.protobuf.OneofDescriptorProto
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            OneofDescriptorProto.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return OneofDescriptorProto;
        })();

        protobuf.EnumDescriptorProto = (function() {

            /**
             * Properties of an EnumDescriptorProto.
             * @memberof google.protobuf
             * @interface IEnumDescriptorProto
             * @property {string|null} [name] EnumDescriptorProto name
             * @property {Array.<google.protobuf.IEnumValueDescriptorProto>|null} [value] EnumDescriptorProto value
             * @property {google.protobuf.IEnumOptions|null} [options] EnumDescriptorProto options
             */

            /**
             * Constructs a new EnumDescriptorProto.
             * @memberof google.protobuf
             * @classdesc Represents an EnumDescriptorProto.
             * @implements IEnumDescriptorProto
             * @constructor
             * @param {google.protobuf.IEnumDescriptorProto=} [properties] Properties to set
             */
            function EnumDescriptorProto(properties) {
                this.value = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * EnumDescriptorProto name.
             * @member {string} name
             * @memberof google.protobuf.EnumDescriptorProto
             * @instance
             */
            EnumDescriptorProto.prototype.name = "";

            /**
             * EnumDescriptorProto value.
             * @member {Array.<google.protobuf.IEnumValueDescriptorProto>} value
             * @memberof google.protobuf.EnumDescriptorProto
             * @instance
             */
            EnumDescriptorProto.prototype.value = $util.emptyArray;

            /**
             * EnumDescriptorProto options.
             * @member {google.protobuf.IEnumOptions|null|undefined} options
             * @memberof google.protobuf.EnumDescriptorProto
             * @instance
             */
            EnumDescriptorProto.prototype.options = null;

            /**
             * Creates a new EnumDescriptorProto instance using the specified properties.
             * @function create
             * @memberof google.protobuf.EnumDescriptorProto
             * @static
             * @param {google.protobuf.IEnumDescriptorProto=} [properties] Properties to set
             * @returns {google.protobuf.EnumDescriptorProto} EnumDescriptorProto instance
             */
            EnumDescriptorProto.create = function create(properties) {
                return new EnumDescriptorProto(properties);
            };

            /**
             * Encodes the specified EnumDescriptorProto message. Does not implicitly {@link google.protobuf.EnumDescriptorProto.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.EnumDescriptorProto
             * @static
             * @param {google.protobuf.IEnumDescriptorProto} message EnumDescriptorProto message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            EnumDescriptorProto.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.name != null && message.hasOwnProperty("name"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                if (message.value != null && message.value.length)
                    for (var i = 0; i < message.value.length; ++i)
                        $root.google.protobuf.EnumValueDescriptorProto.encode(message.value[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                if (message.options != null && message.hasOwnProperty("options"))
                    $root.google.protobuf.EnumOptions.encode(message.options, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified EnumDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.EnumDescriptorProto.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.EnumDescriptorProto
             * @static
             * @param {google.protobuf.IEnumDescriptorProto} message EnumDescriptorProto message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            EnumDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes an EnumDescriptorProto message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.EnumDescriptorProto
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.EnumDescriptorProto} EnumDescriptorProto
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            EnumDescriptorProto.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.EnumDescriptorProto();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.name = reader.string();
                        break;
                    case 2:
                        if (!(message.value && message.value.length))
                            message.value = [];
                        message.value.push($root.google.protobuf.EnumValueDescriptorProto.decode(reader, reader.uint32()));
                        break;
                    case 3:
                        message.options = $root.google.protobuf.EnumOptions.decode(reader, reader.uint32());
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes an EnumDescriptorProto message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.EnumDescriptorProto
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.EnumDescriptorProto} EnumDescriptorProto
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            EnumDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies an EnumDescriptorProto message.
             * @function verify
             * @memberof google.protobuf.EnumDescriptorProto
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            EnumDescriptorProto.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.name != null && message.hasOwnProperty("name"))
                    if (!$util.isString(message.name))
                        return "name: string expected";
                if (message.value != null && message.hasOwnProperty("value")) {
                    if (!Array.isArray(message.value))
                        return "value: array expected";
                    for (var i = 0; i < message.value.length; ++i) {
                        var error = $root.google.protobuf.EnumValueDescriptorProto.verify(message.value[i]);
                        if (error)
                            return "value." + error;
                    }
                }
                if (message.options != null && message.hasOwnProperty("options")) {
                    var error = $root.google.protobuf.EnumOptions.verify(message.options);
                    if (error)
                        return "options." + error;
                }
                return null;
            };

            /**
             * Creates an EnumDescriptorProto message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.EnumDescriptorProto
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.EnumDescriptorProto} EnumDescriptorProto
             */
            EnumDescriptorProto.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.EnumDescriptorProto)
                    return object;
                var message = new $root.google.protobuf.EnumDescriptorProto();
                if (object.name != null)
                    message.name = String(object.name);
                if (object.value) {
                    if (!Array.isArray(object.value))
                        throw TypeError(".google.protobuf.EnumDescriptorProto.value: array expected");
                    message.value = [];
                    for (var i = 0; i < object.value.length; ++i) {
                        if (typeof object.value[i] !== "object")
                            throw TypeError(".google.protobuf.EnumDescriptorProto.value: object expected");
                        message.value[i] = $root.google.protobuf.EnumValueDescriptorProto.fromObject(object.value[i]);
                    }
                }
                if (object.options != null) {
                    if (typeof object.options !== "object")
                        throw TypeError(".google.protobuf.EnumDescriptorProto.options: object expected");
                    message.options = $root.google.protobuf.EnumOptions.fromObject(object.options);
                }
                return message;
            };

            /**
             * Creates a plain object from an EnumDescriptorProto message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.EnumDescriptorProto
             * @static
             * @param {google.protobuf.EnumDescriptorProto} message EnumDescriptorProto
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            EnumDescriptorProto.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.value = [];
                if (options.defaults) {
                    object.name = "";
                    object.options = null;
                }
                if (message.name != null && message.hasOwnProperty("name"))
                    object.name = message.name;
                if (message.value && message.value.length) {
                    object.value = [];
                    for (var j = 0; j < message.value.length; ++j)
                        object.value[j] = $root.google.protobuf.EnumValueDescriptorProto.toObject(message.value[j], options);
                }
                if (message.options != null && message.hasOwnProperty("options"))
                    object.options = $root.google.protobuf.EnumOptions.toObject(message.options, options);
                return object;
            };

            /**
             * Converts this EnumDescriptorProto to JSON.
             * @function toJSON
             * @memberof google.protobuf.EnumDescriptorProto
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            EnumDescriptorProto.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return EnumDescriptorProto;
        })();

        protobuf.EnumValueDescriptorProto = (function() {

            /**
             * Properties of an EnumValueDescriptorProto.
             * @memberof google.protobuf
             * @interface IEnumValueDescriptorProto
             * @property {string|null} [name] EnumValueDescriptorProto name
             * @property {number|null} [number] EnumValueDescriptorProto number
             * @property {google.protobuf.IEnumValueOptions|null} [options] EnumValueDescriptorProto options
             */

            /**
             * Constructs a new EnumValueDescriptorProto.
             * @memberof google.protobuf
             * @classdesc Represents an EnumValueDescriptorProto.
             * @implements IEnumValueDescriptorProto
             * @constructor
             * @param {google.protobuf.IEnumValueDescriptorProto=} [properties] Properties to set
             */
            function EnumValueDescriptorProto(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * EnumValueDescriptorProto name.
             * @member {string} name
             * @memberof google.protobuf.EnumValueDescriptorProto
             * @instance
             */
            EnumValueDescriptorProto.prototype.name = "";

            /**
             * EnumValueDescriptorProto number.
             * @member {number} number
             * @memberof google.protobuf.EnumValueDescriptorProto
             * @instance
             */
            EnumValueDescriptorProto.prototype.number = 0;

            /**
             * EnumValueDescriptorProto options.
             * @member {google.protobuf.IEnumValueOptions|null|undefined} options
             * @memberof google.protobuf.EnumValueDescriptorProto
             * @instance
             */
            EnumValueDescriptorProto.prototype.options = null;

            /**
             * Creates a new EnumValueDescriptorProto instance using the specified properties.
             * @function create
             * @memberof google.protobuf.EnumValueDescriptorProto
             * @static
             * @param {google.protobuf.IEnumValueDescriptorProto=} [properties] Properties to set
             * @returns {google.protobuf.EnumValueDescriptorProto} EnumValueDescriptorProto instance
             */
            EnumValueDescriptorProto.create = function create(properties) {
                return new EnumValueDescriptorProto(properties);
            };

            /**
             * Encodes the specified EnumValueDescriptorProto message. Does not implicitly {@link google.protobuf.EnumValueDescriptorProto.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.EnumValueDescriptorProto
             * @static
             * @param {google.protobuf.IEnumValueDescriptorProto} message EnumValueDescriptorProto message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            EnumValueDescriptorProto.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.name != null && message.hasOwnProperty("name"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                if (message.number != null && message.hasOwnProperty("number"))
                    writer.uint32(/* id 2, wireType 0 =*/16).int32(message.number);
                if (message.options != null && message.hasOwnProperty("options"))
                    $root.google.protobuf.EnumValueOptions.encode(message.options, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified EnumValueDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.EnumValueDescriptorProto.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.EnumValueDescriptorProto
             * @static
             * @param {google.protobuf.IEnumValueDescriptorProto} message EnumValueDescriptorProto message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            EnumValueDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes an EnumValueDescriptorProto message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.EnumValueDescriptorProto
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.EnumValueDescriptorProto} EnumValueDescriptorProto
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            EnumValueDescriptorProto.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.EnumValueDescriptorProto();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.name = reader.string();
                        break;
                    case 2:
                        message.number = reader.int32();
                        break;
                    case 3:
                        message.options = $root.google.protobuf.EnumValueOptions.decode(reader, reader.uint32());
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes an EnumValueDescriptorProto message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.EnumValueDescriptorProto
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.EnumValueDescriptorProto} EnumValueDescriptorProto
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            EnumValueDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies an EnumValueDescriptorProto message.
             * @function verify
             * @memberof google.protobuf.EnumValueDescriptorProto
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            EnumValueDescriptorProto.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.name != null && message.hasOwnProperty("name"))
                    if (!$util.isString(message.name))
                        return "name: string expected";
                if (message.number != null && message.hasOwnProperty("number"))
                    if (!$util.isInteger(message.number))
                        return "number: integer expected";
                if (message.options != null && message.hasOwnProperty("options")) {
                    var error = $root.google.protobuf.EnumValueOptions.verify(message.options);
                    if (error)
                        return "options." + error;
                }
                return null;
            };

            /**
             * Creates an EnumValueDescriptorProto message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.EnumValueDescriptorProto
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.EnumValueDescriptorProto} EnumValueDescriptorProto
             */
            EnumValueDescriptorProto.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.EnumValueDescriptorProto)
                    return object;
                var message = new $root.google.protobuf.EnumValueDescriptorProto();
                if (object.name != null)
                    message.name = String(object.name);
                if (object.number != null)
                    message.number = object.number | 0;
                if (object.options != null) {
                    if (typeof object.options !== "object")
                        throw TypeError(".google.protobuf.EnumValueDescriptorProto.options: object expected");
                    message.options = $root.google.protobuf.EnumValueOptions.fromObject(object.options);
                }
                return message;
            };

            /**
             * Creates a plain object from an EnumValueDescriptorProto message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.EnumValueDescriptorProto
             * @static
             * @param {google.protobuf.EnumValueDescriptorProto} message EnumValueDescriptorProto
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            EnumValueDescriptorProto.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults) {
                    object.name = "";
                    object.number = 0;
                    object.options = null;
                }
                if (message.name != null && message.hasOwnProperty("name"))
                    object.name = message.name;
                if (message.number != null && message.hasOwnProperty("number"))
                    object.number = message.number;
                if (message.options != null && message.hasOwnProperty("options"))
                    object.options = $root.google.protobuf.EnumValueOptions.toObject(message.options, options);
                return object;
            };

            /**
             * Converts this EnumValueDescriptorProto to JSON.
             * @function toJSON
             * @memberof google.protobuf.EnumValueDescriptorProto
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            EnumValueDescriptorProto.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return EnumValueDescriptorProto;
        })();

        protobuf.ServiceDescriptorProto = (function() {

            /**
             * Properties of a ServiceDescriptorProto.
             * @memberof google.protobuf
             * @interface IServiceDescriptorProto
             * @property {string|null} [name] ServiceDescriptorProto name
             * @property {Array.<google.protobuf.IMethodDescriptorProto>|null} [method] ServiceDescriptorProto method
             * @property {google.protobuf.IServiceOptions|null} [options] ServiceDescriptorProto options
             */

            /**
             * Constructs a new ServiceDescriptorProto.
             * @memberof google.protobuf
             * @classdesc Represents a ServiceDescriptorProto.
             * @implements IServiceDescriptorProto
             * @constructor
             * @param {google.protobuf.IServiceDescriptorProto=} [properties] Properties to set
             */
            function ServiceDescriptorProto(properties) {
                this.method = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * ServiceDescriptorProto name.
             * @member {string} name
             * @memberof google.protobuf.ServiceDescriptorProto
             * @instance
             */
            ServiceDescriptorProto.prototype.name = "";

            /**
             * ServiceDescriptorProto method.
             * @member {Array.<google.protobuf.IMethodDescriptorProto>} method
             * @memberof google.protobuf.ServiceDescriptorProto
             * @instance
             */
            ServiceDescriptorProto.prototype.method = $util.emptyArray;

            /**
             * ServiceDescriptorProto options.
             * @member {google.protobuf.IServiceOptions|null|undefined} options
             * @memberof google.protobuf.ServiceDescriptorProto
             * @instance
             */
            ServiceDescriptorProto.prototype.options = null;

            /**
             * Creates a new ServiceDescriptorProto instance using the specified properties.
             * @function create
             * @memberof google.protobuf.ServiceDescriptorProto
             * @static
             * @param {google.protobuf.IServiceDescriptorProto=} [properties] Properties to set
             * @returns {google.protobuf.ServiceDescriptorProto} ServiceDescriptorProto instance
             */
            ServiceDescriptorProto.create = function create(properties) {
                return new ServiceDescriptorProto(properties);
            };

            /**
             * Encodes the specified ServiceDescriptorProto message. Does not implicitly {@link google.protobuf.ServiceDescriptorProto.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.ServiceDescriptorProto
             * @static
             * @param {google.protobuf.IServiceDescriptorProto} message ServiceDescriptorProto message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            ServiceDescriptorProto.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.name != null && message.hasOwnProperty("name"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                if (message.method != null && message.method.length)
                    for (var i = 0; i < message.method.length; ++i)
                        $root.google.protobuf.MethodDescriptorProto.encode(message.method[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                if (message.options != null && message.hasOwnProperty("options"))
                    $root.google.protobuf.ServiceOptions.encode(message.options, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified ServiceDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.ServiceDescriptorProto.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.ServiceDescriptorProto
             * @static
             * @param {google.protobuf.IServiceDescriptorProto} message ServiceDescriptorProto message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            ServiceDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a ServiceDescriptorProto message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.ServiceDescriptorProto
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.ServiceDescriptorProto} ServiceDescriptorProto
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            ServiceDescriptorProto.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.ServiceDescriptorProto();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.name = reader.string();
                        break;
                    case 2:
                        if (!(message.method && message.method.length))
                            message.method = [];
                        message.method.push($root.google.protobuf.MethodDescriptorProto.decode(reader, reader.uint32()));
                        break;
                    case 3:
                        message.options = $root.google.protobuf.ServiceOptions.decode(reader, reader.uint32());
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a ServiceDescriptorProto message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.ServiceDescriptorProto
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.ServiceDescriptorProto} ServiceDescriptorProto
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            ServiceDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a ServiceDescriptorProto message.
             * @function verify
             * @memberof google.protobuf.ServiceDescriptorProto
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            ServiceDescriptorProto.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.name != null && message.hasOwnProperty("name"))
                    if (!$util.isString(message.name))
                        return "name: string expected";
                if (message.method != null && message.hasOwnProperty("method")) {
                    if (!Array.isArray(message.method))
                        return "method: array expected";
                    for (var i = 0; i < message.method.length; ++i) {
                        var error = $root.google.protobuf.MethodDescriptorProto.verify(message.method[i]);
                        if (error)
                            return "method." + error;
                    }
                }
                if (message.options != null && message.hasOwnProperty("options")) {
                    var error = $root.google.protobuf.ServiceOptions.verify(message.options);
                    if (error)
                        return "options." + error;
                }
                return null;
            };

            /**
             * Creates a ServiceDescriptorProto message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.ServiceDescriptorProto
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.ServiceDescriptorProto} ServiceDescriptorProto
             */
            ServiceDescriptorProto.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.ServiceDescriptorProto)
                    return object;
                var message = new $root.google.protobuf.ServiceDescriptorProto();
                if (object.name != null)
                    message.name = String(object.name);
                if (object.method) {
                    if (!Array.isArray(object.method))
                        throw TypeError(".google.protobuf.ServiceDescriptorProto.method: array expected");
                    message.method = [];
                    for (var i = 0; i < object.method.length; ++i) {
                        if (typeof object.method[i] !== "object")
                            throw TypeError(".google.protobuf.ServiceDescriptorProto.method: object expected");
                        message.method[i] = $root.google.protobuf.MethodDescriptorProto.fromObject(object.method[i]);
                    }
                }
                if (object.options != null) {
                    if (typeof object.options !== "object")
                        throw TypeError(".google.protobuf.ServiceDescriptorProto.options: object expected");
                    message.options = $root.google.protobuf.ServiceOptions.fromObject(object.options);
                }
                return message;
            };

            /**
             * Creates a plain object from a ServiceDescriptorProto message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.ServiceDescriptorProto
             * @static
             * @param {google.protobuf.ServiceDescriptorProto} message ServiceDescriptorProto
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            ServiceDescriptorProto.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.method = [];
                if (options.defaults) {
                    object.name = "";
                    object.options = null;
                }
                if (message.name != null && message.hasOwnProperty("name"))
                    object.name = message.name;
                if (message.method && message.method.length) {
                    object.method = [];
                    for (var j = 0; j < message.method.length; ++j)
                        object.method[j] = $root.google.protobuf.MethodDescriptorProto.toObject(message.method[j], options);
                }
                if (message.options != null && message.hasOwnProperty("options"))
                    object.options = $root.google.protobuf.ServiceOptions.toObject(message.options, options);
                return object;
            };

            /**
             * Converts this ServiceDescriptorProto to JSON.
             * @function toJSON
             * @memberof google.protobuf.ServiceDescriptorProto
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            ServiceDescriptorProto.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return ServiceDescriptorProto;
        })();

        protobuf.MethodDescriptorProto = (function() {

            /**
             * Properties of a MethodDescriptorProto.
             * @memberof google.protobuf
             * @interface IMethodDescriptorProto
             * @property {string|null} [name] MethodDescriptorProto name
             * @property {string|null} [inputType] MethodDescriptorProto inputType
             * @property {string|null} [outputType] MethodDescriptorProto outputType
             * @property {google.protobuf.IMethodOptions|null} [options] MethodDescriptorProto options
             * @property {boolean|null} [clientStreaming] MethodDescriptorProto clientStreaming
             * @property {boolean|null} [serverStreaming] MethodDescriptorProto serverStreaming
             */

            /**
             * Constructs a new MethodDescriptorProto.
             * @memberof google.protobuf
             * @classdesc Represents a MethodDescriptorProto.
             * @implements IMethodDescriptorProto
             * @constructor
             * @param {google.protobuf.IMethodDescriptorProto=} [properties] Properties to set
             */
            function MethodDescriptorProto(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * MethodDescriptorProto name.
             * @member {string} name
             * @memberof google.protobuf.MethodDescriptorProto
             * @instance
             */
            MethodDescriptorProto.prototype.name = "";

            /**
             * MethodDescriptorProto inputType.
             * @member {string} inputType
             * @memberof google.protobuf.MethodDescriptorProto
             * @instance
             */
            MethodDescriptorProto.prototype.inputType = "";

            /**
             * MethodDescriptorProto outputType.
             * @member {string} outputType
             * @memberof google.protobuf.MethodDescriptorProto
             * @instance
             */
            MethodDescriptorProto.prototype.outputType = "";

            /**
             * MethodDescriptorProto options.
             * @member {google.protobuf.IMethodOptions|null|undefined} options
             * @memberof google.protobuf.MethodDescriptorProto
             * @instance
             */
            MethodDescriptorProto.prototype.options = null;

            /**
             * MethodDescriptorProto clientStreaming.
             * @member {boolean} clientStreaming
             * @memberof google.protobuf.MethodDescriptorProto
             * @instance
             */
            MethodDescriptorProto.prototype.clientStreaming = false;

            /**
             * MethodDescriptorProto serverStreaming.
             * @member {boolean} serverStreaming
             * @memberof google.protobuf.MethodDescriptorProto
             * @instance
             */
            MethodDescriptorProto.prototype.serverStreaming = false;

            /**
             * Creates a new MethodDescriptorProto instance using the specified properties.
             * @function create
             * @memberof google.protobuf.MethodDescriptorProto
             * @static
             * @param {google.protobuf.IMethodDescriptorProto=} [properties] Properties to set
             * @returns {google.protobuf.MethodDescriptorProto} MethodDescriptorProto instance
             */
            MethodDescriptorProto.create = function create(properties) {
                return new MethodDescriptorProto(properties);
            };

            /**
             * Encodes the specified MethodDescriptorProto message. Does not implicitly {@link google.protobuf.MethodDescriptorProto.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.MethodDescriptorProto
             * @static
             * @param {google.protobuf.IMethodDescriptorProto} message MethodDescriptorProto message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            MethodDescriptorProto.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.name != null && message.hasOwnProperty("name"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                if (message.inputType != null && message.hasOwnProperty("inputType"))
                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.inputType);
                if (message.outputType != null && message.hasOwnProperty("outputType"))
                    writer.uint32(/* id 3, wireType 2 =*/26).string(message.outputType);
                if (message.options != null && message.hasOwnProperty("options"))
                    $root.google.protobuf.MethodOptions.encode(message.options, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                if (message.clientStreaming != null && message.hasOwnProperty("clientStreaming"))
                    writer.uint32(/* id 5, wireType 0 =*/40).bool(message.clientStreaming);
                if (message.serverStreaming != null && message.hasOwnProperty("serverStreaming"))
                    writer.uint32(/* id 6, wireType 0 =*/48).bool(message.serverStreaming);
                return writer;
            };

            /**
             * Encodes the specified MethodDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.MethodDescriptorProto.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.MethodDescriptorProto
             * @static
             * @param {google.protobuf.IMethodDescriptorProto} message MethodDescriptorProto message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            MethodDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a MethodDescriptorProto message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.MethodDescriptorProto
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.MethodDescriptorProto} MethodDescriptorProto
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            MethodDescriptorProto.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.MethodDescriptorProto();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.name = reader.string();
                        break;
                    case 2:
                        message.inputType = reader.string();
                        break;
                    case 3:
                        message.outputType = reader.string();
                        break;
                    case 4:
                        message.options = $root.google.protobuf.MethodOptions.decode(reader, reader.uint32());
                        break;
                    case 5:
                        message.clientStreaming = reader.bool();
                        break;
                    case 6:
                        message.serverStreaming = reader.bool();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a MethodDescriptorProto message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.MethodDescriptorProto
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.MethodDescriptorProto} MethodDescriptorProto
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            MethodDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a MethodDescriptorProto message.
             * @function verify
             * @memberof google.protobuf.MethodDescriptorProto
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            MethodDescriptorProto.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.name != null && message.hasOwnProperty("name"))
                    if (!$util.isString(message.name))
                        return "name: string expected";
                if (message.inputType != null && message.hasOwnProperty("inputType"))
                    if (!$util.isString(message.inputType))
                        return "inputType: string expected";
                if (message.outputType != null && message.hasOwnProperty("outputType"))
                    if (!$util.isString(message.outputType))
                        return "outputType: string expected";
                if (message.options != null && message.hasOwnProperty("options")) {
                    var error = $root.google.protobuf.MethodOptions.verify(message.options);
                    if (error)
                        return "options." + error;
                }
                if (message.clientStreaming != null && message.hasOwnProperty("clientStreaming"))
                    if (typeof message.clientStreaming !== "boolean")
                        return "clientStreaming: boolean expected";
                if (message.serverStreaming != null && message.hasOwnProperty("serverStreaming"))
                    if (typeof message.serverStreaming !== "boolean")
                        return "serverStreaming: boolean expected";
                return null;
            };

            /**
             * Creates a MethodDescriptorProto message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.MethodDescriptorProto
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.MethodDescriptorProto} MethodDescriptorProto
             */
            MethodDescriptorProto.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.MethodDescriptorProto)
                    return object;
                var message = new $root.google.protobuf.MethodDescriptorProto();
                if (object.name != null)
                    message.name = String(object.name);
                if (object.inputType != null)
                    message.inputType = String(object.inputType);
                if (object.outputType != null)
                    message.outputType = String(object.outputType);
                if (object.options != null) {
                    if (typeof object.options !== "object")
                        throw TypeError(".google.protobuf.MethodDescriptorProto.options: object expected");
                    message.options = $root.google.protobuf.MethodOptions.fromObject(object.options);
                }
                if (object.clientStreaming != null)
                    message.clientStreaming = Boolean(object.clientStreaming);
                if (object.serverStreaming != null)
                    message.serverStreaming = Boolean(object.serverStreaming);
                return message;
            };

            /**
             * Creates a plain object from a MethodDescriptorProto message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.MethodDescriptorProto
             * @static
             * @param {google.protobuf.MethodDescriptorProto} message MethodDescriptorProto
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            MethodDescriptorProto.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults) {
                    object.name = "";
                    object.inputType = "";
                    object.outputType = "";
                    object.options = null;
                    object.clientStreaming = false;
                    object.serverStreaming = false;
                }
                if (message.name != null && message.hasOwnProperty("name"))
                    object.name = message.name;
                if (message.inputType != null && message.hasOwnProperty("inputType"))
                    object.inputType = message.inputType;
                if (message.outputType != null && message.hasOwnProperty("outputType"))
                    object.outputType = message.outputType;
                if (message.options != null && message.hasOwnProperty("options"))
                    object.options = $root.google.protobuf.MethodOptions.toObject(message.options, options);
                if (message.clientStreaming != null && message.hasOwnProperty("clientStreaming"))
                    object.clientStreaming = message.clientStreaming;
                if (message.serverStreaming != null && message.hasOwnProperty("serverStreaming"))
                    object.serverStreaming = message.serverStreaming;
                return object;
            };

            /**
             * Converts this MethodDescriptorProto to JSON.
             * @function toJSON
             * @memberof google.protobuf.MethodDescriptorProto
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            MethodDescriptorProto.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return MethodDescriptorProto;
        })();

        protobuf.FileOptions = (function() {

            /**
             * Properties of a FileOptions.
             * @memberof google.protobuf
             * @interface IFileOptions
             * @property {string|null} [javaPackage] FileOptions javaPackage
             * @property {string|null} [javaOuterClassname] FileOptions javaOuterClassname
             * @property {boolean|null} [javaMultipleFiles] FileOptions javaMultipleFiles
             * @property {boolean|null} [javaGenerateEqualsAndHash] FileOptions javaGenerateEqualsAndHash
             * @property {boolean|null} [javaStringCheckUtf8] FileOptions javaStringCheckUtf8
             * @property {google.protobuf.FileOptions.OptimizeMode|null} [optimizeFor] FileOptions optimizeFor
             * @property {string|null} [goPackage] FileOptions goPackage
             * @property {boolean|null} [ccGenericServices] FileOptions ccGenericServices
             * @property {boolean|null} [javaGenericServices] FileOptions javaGenericServices
             * @property {boolean|null} [pyGenericServices] FileOptions pyGenericServices
             * @property {boolean|null} [deprecated] FileOptions deprecated
             * @property {boolean|null} [ccEnableArenas] FileOptions ccEnableArenas
             * @property {string|null} [objcClassPrefix] FileOptions objcClassPrefix
             * @property {string|null} [csharpNamespace] FileOptions csharpNamespace
             * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] FileOptions uninterpretedOption
             */

            /**
             * Constructs a new FileOptions.
             * @memberof google.protobuf
             * @classdesc Represents a FileOptions.
             * @implements IFileOptions
             * @constructor
             * @param {google.protobuf.IFileOptions=} [properties] Properties to set
             */
            function FileOptions(properties) {
                this.uninterpretedOption = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * FileOptions javaPackage.
             * @member {string} javaPackage
             * @memberof google.protobuf.FileOptions
             * @instance
             */
            FileOptions.prototype.javaPackage = "";

            /**
             * FileOptions javaOuterClassname.
             * @member {string} javaOuterClassname
             * @memberof google.protobuf.FileOptions
             * @instance
             */
            FileOptions.prototype.javaOuterClassname = "";

            /**
             * FileOptions javaMultipleFiles.
             * @member {boolean} javaMultipleFiles
             * @memberof google.protobuf.FileOptions
             * @instance
             */
            FileOptions.prototype.javaMultipleFiles = false;

            /**
             * FileOptions javaGenerateEqualsAndHash.
             * @member {boolean} javaGenerateEqualsAndHash
             * @memberof google.protobuf.FileOptions
             * @instance
             */
            FileOptions.prototype.javaGenerateEqualsAndHash = false;

            /**
             * FileOptions javaStringCheckUtf8.
             * @member {boolean} javaStringCheckUtf8
             * @memberof google.protobuf.FileOptions
             * @instance
             */
            FileOptions.prototype.javaStringCheckUtf8 = false;

            /**
             * FileOptions optimizeFor.
             * @member {google.protobuf.FileOptions.OptimizeMode} optimizeFor
             * @memberof google.protobuf.FileOptions
             * @instance
             */
            FileOptions.prototype.optimizeFor = 1;

            /**
             * FileOptions goPackage.
             * @member {string} goPackage
             * @memberof google.protobuf.FileOptions
             * @instance
             */
            FileOptions.prototype.goPackage = "";

            /**
             * FileOptions ccGenericServices.
             * @member {boolean} ccGenericServices
             * @memberof google.protobuf.FileOptions
             * @instance
             */
            FileOptions.prototype.ccGenericServices = false;

            /**
             * FileOptions javaGenericServices.
             * @member {boolean} javaGenericServices
             * @memberof google.protobuf.FileOptions
             * @instance
             */
            FileOptions.prototype.javaGenericServices = false;

            /**
             * FileOptions pyGenericServices.
             * @member {boolean} pyGenericServices
             * @memberof google.protobuf.FileOptions
             * @instance
             */
            FileOptions.prototype.pyGenericServices = false;

            /**
             * FileOptions deprecated.
             * @member {boolean} deprecated
             * @memberof google.protobuf.FileOptions
             * @instance
             */
            FileOptions.prototype.deprecated = false;

            /**
             * FileOptions ccEnableArenas.
             * @member {boolean} ccEnableArenas
             * @memberof google.protobuf.FileOptions
             * @instance
             */
            FileOptions.prototype.ccEnableArenas = false;

            /**
             * FileOptions objcClassPrefix.
             * @member {string} objcClassPrefix
             * @memberof google.protobuf.FileOptions
             * @instance
             */
            FileOptions.prototype.objcClassPrefix = "";

            /**
             * FileOptions csharpNamespace.
             * @member {string} csharpNamespace
             * @memberof google.protobuf.FileOptions
             * @instance
             */
            FileOptions.prototype.csharpNamespace = "";

            /**
             * FileOptions uninterpretedOption.
             * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
             * @memberof google.protobuf.FileOptions
             * @instance
             */
            FileOptions.prototype.uninterpretedOption = $util.emptyArray;

            /**
             * Creates a new FileOptions instance using the specified properties.
             * @function create
             * @memberof google.protobuf.FileOptions
             * @static
             * @param {google.protobuf.IFileOptions=} [properties] Properties to set
             * @returns {google.protobuf.FileOptions} FileOptions instance
             */
            FileOptions.create = function create(properties) {
                return new FileOptions(properties);
            };

            /**
             * Encodes the specified FileOptions message. Does not implicitly {@link google.protobuf.FileOptions.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.FileOptions
             * @static
             * @param {google.protobuf.IFileOptions} message FileOptions message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            FileOptions.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.javaPackage != null && message.hasOwnProperty("javaPackage"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.javaPackage);
                if (message.javaOuterClassname != null && message.hasOwnProperty("javaOuterClassname"))
                    writer.uint32(/* id 8, wireType 2 =*/66).string(message.javaOuterClassname);
                if (message.optimizeFor != null && message.hasOwnProperty("optimizeFor"))
                    writer.uint32(/* id 9, wireType 0 =*/72).int32(message.optimizeFor);
                if (message.javaMultipleFiles != null && message.hasOwnProperty("javaMultipleFiles"))
                    writer.uint32(/* id 10, wireType 0 =*/80).bool(message.javaMultipleFiles);
                if (message.goPackage != null && message.hasOwnProperty("goPackage"))
                    writer.uint32(/* id 11, wireType 2 =*/90).string(message.goPackage);
                if (message.ccGenericServices != null && message.hasOwnProperty("ccGenericServices"))
                    writer.uint32(/* id 16, wireType 0 =*/128).bool(message.ccGenericServices);
                if (message.javaGenericServices != null && message.hasOwnProperty("javaGenericServices"))
                    writer.uint32(/* id 17, wireType 0 =*/136).bool(message.javaGenericServices);
                if (message.pyGenericServices != null && message.hasOwnProperty("pyGenericServices"))
                    writer.uint32(/* id 18, wireType 0 =*/144).bool(message.pyGenericServices);
                if (message.javaGenerateEqualsAndHash != null && message.hasOwnProperty("javaGenerateEqualsAndHash"))
                    writer.uint32(/* id 20, wireType 0 =*/160).bool(message.javaGenerateEqualsAndHash);
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    writer.uint32(/* id 23, wireType 0 =*/184).bool(message.deprecated);
                if (message.javaStringCheckUtf8 != null && message.hasOwnProperty("javaStringCheckUtf8"))
                    writer.uint32(/* id 27, wireType 0 =*/216).bool(message.javaStringCheckUtf8);
                if (message.ccEnableArenas != null && message.hasOwnProperty("ccEnableArenas"))
                    writer.uint32(/* id 31, wireType 0 =*/248).bool(message.ccEnableArenas);
                if (message.objcClassPrefix != null && message.hasOwnProperty("objcClassPrefix"))
                    writer.uint32(/* id 36, wireType 2 =*/290).string(message.objcClassPrefix);
                if (message.csharpNamespace != null && message.hasOwnProperty("csharpNamespace"))
                    writer.uint32(/* id 37, wireType 2 =*/298).string(message.csharpNamespace);
                if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                    for (var i = 0; i < message.uninterpretedOption.length; ++i)
                        $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified FileOptions message, length delimited. Does not implicitly {@link google.protobuf.FileOptions.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.FileOptions
             * @static
             * @param {google.protobuf.IFileOptions} message FileOptions message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            FileOptions.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a FileOptions message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.FileOptions
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.FileOptions} FileOptions
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            FileOptions.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FileOptions();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.javaPackage = reader.string();
                        break;
                    case 8:
                        message.javaOuterClassname = reader.string();
                        break;
                    case 10:
                        message.javaMultipleFiles = reader.bool();
                        break;
                    case 20:
                        message.javaGenerateEqualsAndHash = reader.bool();
                        break;
                    case 27:
                        message.javaStringCheckUtf8 = reader.bool();
                        break;
                    case 9:
                        message.optimizeFor = reader.int32();
                        break;
                    case 11:
                        message.goPackage = reader.string();
                        break;
                    case 16:
                        message.ccGenericServices = reader.bool();
                        break;
                    case 17:
                        message.javaGenericServices = reader.bool();
                        break;
                    case 18:
                        message.pyGenericServices = reader.bool();
                        break;
                    case 23:
                        message.deprecated = reader.bool();
                        break;
                    case 31:
                        message.ccEnableArenas = reader.bool();
                        break;
                    case 36:
                        message.objcClassPrefix = reader.string();
                        break;
                    case 37:
                        message.csharpNamespace = reader.string();
                        break;
                    case 999:
                        if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                            message.uninterpretedOption = [];
                        message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a FileOptions message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.FileOptions
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.FileOptions} FileOptions
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            FileOptions.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a FileOptions message.
             * @function verify
             * @memberof google.protobuf.FileOptions
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            FileOptions.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.javaPackage != null && message.hasOwnProperty("javaPackage"))
                    if (!$util.isString(message.javaPackage))
                        return "javaPackage: string expected";
                if (message.javaOuterClassname != null && message.hasOwnProperty("javaOuterClassname"))
                    if (!$util.isString(message.javaOuterClassname))
                        return "javaOuterClassname: string expected";
                if (message.javaMultipleFiles != null && message.hasOwnProperty("javaMultipleFiles"))
                    if (typeof message.javaMultipleFiles !== "boolean")
                        return "javaMultipleFiles: boolean expected";
                if (message.javaGenerateEqualsAndHash != null && message.hasOwnProperty("javaGenerateEqualsAndHash"))
                    if (typeof message.javaGenerateEqualsAndHash !== "boolean")
                        return "javaGenerateEqualsAndHash: boolean expected";
                if (message.javaStringCheckUtf8 != null && message.hasOwnProperty("javaStringCheckUtf8"))
                    if (typeof message.javaStringCheckUtf8 !== "boolean")
                        return "javaStringCheckUtf8: boolean expected";
                if (message.optimizeFor != null && message.hasOwnProperty("optimizeFor"))
                    switch (message.optimizeFor) {
                    default:
                        return "optimizeFor: enum value expected";
                    case 1:
                    case 2:
                    case 3:
                        break;
                    }
                if (message.goPackage != null && message.hasOwnProperty("goPackage"))
                    if (!$util.isString(message.goPackage))
                        return "goPackage: string expected";
                if (message.ccGenericServices != null && message.hasOwnProperty("ccGenericServices"))
                    if (typeof message.ccGenericServices !== "boolean")
                        return "ccGenericServices: boolean expected";
                if (message.javaGenericServices != null && message.hasOwnProperty("javaGenericServices"))
                    if (typeof message.javaGenericServices !== "boolean")
                        return "javaGenericServices: boolean expected";
                if (message.pyGenericServices != null && message.hasOwnProperty("pyGenericServices"))
                    if (typeof message.pyGenericServices !== "boolean")
                        return "pyGenericServices: boolean expected";
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    if (typeof message.deprecated !== "boolean")
                        return "deprecated: boolean expected";
                if (message.ccEnableArenas != null && message.hasOwnProperty("ccEnableArenas"))
                    if (typeof message.ccEnableArenas !== "boolean")
                        return "ccEnableArenas: boolean expected";
                if (message.objcClassPrefix != null && message.hasOwnProperty("objcClassPrefix"))
                    if (!$util.isString(message.objcClassPrefix))
                        return "objcClassPrefix: string expected";
                if (message.csharpNamespace != null && message.hasOwnProperty("csharpNamespace"))
                    if (!$util.isString(message.csharpNamespace))
                        return "csharpNamespace: string expected";
                if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                    if (!Array.isArray(message.uninterpretedOption))
                        return "uninterpretedOption: array expected";
                    for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                        var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                        if (error)
                            return "uninterpretedOption." + error;
                    }
                }
                return null;
            };

            /**
             * Creates a FileOptions message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.FileOptions
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.FileOptions} FileOptions
             */
            FileOptions.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.FileOptions)
                    return object;
                var message = new $root.google.protobuf.FileOptions();
                if (object.javaPackage != null)
                    message.javaPackage = String(object.javaPackage);
                if (object.javaOuterClassname != null)
                    message.javaOuterClassname = String(object.javaOuterClassname);
                if (object.javaMultipleFiles != null)
                    message.javaMultipleFiles = Boolean(object.javaMultipleFiles);
                if (object.javaGenerateEqualsAndHash != null)
                    message.javaGenerateEqualsAndHash = Boolean(object.javaGenerateEqualsAndHash);
                if (object.javaStringCheckUtf8 != null)
                    message.javaStringCheckUtf8 = Boolean(object.javaStringCheckUtf8);
                switch (object.optimizeFor) {
                case "SPEED":
                case 1:
                    message.optimizeFor = 1;
                    break;
                case "CODE_SIZE":
                case 2:
                    message.optimizeFor = 2;
                    break;
                case "LITE_RUNTIME":
                case 3:
                    message.optimizeFor = 3;
                    break;
                }
                if (object.goPackage != null)
                    message.goPackage = String(object.goPackage);
                if (object.ccGenericServices != null)
                    message.ccGenericServices = Boolean(object.ccGenericServices);
                if (object.javaGenericServices != null)
                    message.javaGenericServices = Boolean(object.javaGenericServices);
                if (object.pyGenericServices != null)
                    message.pyGenericServices = Boolean(object.pyGenericServices);
                if (object.deprecated != null)
                    message.deprecated = Boolean(object.deprecated);
                if (object.ccEnableArenas != null)
                    message.ccEnableArenas = Boolean(object.ccEnableArenas);
                if (object.objcClassPrefix != null)
                    message.objcClassPrefix = String(object.objcClassPrefix);
                if (object.csharpNamespace != null)
                    message.csharpNamespace = String(object.csharpNamespace);
                if (object.uninterpretedOption) {
                    if (!Array.isArray(object.uninterpretedOption))
                        throw TypeError(".google.protobuf.FileOptions.uninterpretedOption: array expected");
                    message.uninterpretedOption = [];
                    for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                        if (typeof object.uninterpretedOption[i] !== "object")
                            throw TypeError(".google.protobuf.FileOptions.uninterpretedOption: object expected");
                        message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                    }
                }
                return message;
            };

            /**
             * Creates a plain object from a FileOptions message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.FileOptions
             * @static
             * @param {google.protobuf.FileOptions} message FileOptions
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            FileOptions.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.uninterpretedOption = [];
                if (options.defaults) {
                    object.javaPackage = "";
                    object.javaOuterClassname = "";
                    object.optimizeFor = options.enums === String ? "SPEED" : 1;
                    object.javaMultipleFiles = false;
                    object.goPackage = "";
                    object.ccGenericServices = false;
                    object.javaGenericServices = false;
                    object.pyGenericServices = false;
                    object.javaGenerateEqualsAndHash = false;
                    object.deprecated = false;
                    object.javaStringCheckUtf8 = false;
                    object.ccEnableArenas = false;
                    object.objcClassPrefix = "";
                    object.csharpNamespace = "";
                }
                if (message.javaPackage != null && message.hasOwnProperty("javaPackage"))
                    object.javaPackage = message.javaPackage;
                if (message.javaOuterClassname != null && message.hasOwnProperty("javaOuterClassname"))
                    object.javaOuterClassname = message.javaOuterClassname;
                if (message.optimizeFor != null && message.hasOwnProperty("optimizeFor"))
                    object.optimizeFor = options.enums === String ? $root.google.protobuf.FileOptions.OptimizeMode[message.optimizeFor] : message.optimizeFor;
                if (message.javaMultipleFiles != null && message.hasOwnProperty("javaMultipleFiles"))
                    object.javaMultipleFiles = message.javaMultipleFiles;
                if (message.goPackage != null && message.hasOwnProperty("goPackage"))
                    object.goPackage = message.goPackage;
                if (message.ccGenericServices != null && message.hasOwnProperty("ccGenericServices"))
                    object.ccGenericServices = message.ccGenericServices;
                if (message.javaGenericServices != null && message.hasOwnProperty("javaGenericServices"))
                    object.javaGenericServices = message.javaGenericServices;
                if (message.pyGenericServices != null && message.hasOwnProperty("pyGenericServices"))
                    object.pyGenericServices = message.pyGenericServices;
                if (message.javaGenerateEqualsAndHash != null && message.hasOwnProperty("javaGenerateEqualsAndHash"))
                    object.javaGenerateEqualsAndHash = message.javaGenerateEqualsAndHash;
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    object.deprecated = message.deprecated;
                if (message.javaStringCheckUtf8 != null && message.hasOwnProperty("javaStringCheckUtf8"))
                    object.javaStringCheckUtf8 = message.javaStringCheckUtf8;
                if (message.ccEnableArenas != null && message.hasOwnProperty("ccEnableArenas"))
                    object.ccEnableArenas = message.ccEnableArenas;
                if (message.objcClassPrefix != null && message.hasOwnProperty("objcClassPrefix"))
                    object.objcClassPrefix = message.objcClassPrefix;
                if (message.csharpNamespace != null && message.hasOwnProperty("csharpNamespace"))
                    object.csharpNamespace = message.csharpNamespace;
                if (message.uninterpretedOption && message.uninterpretedOption.length) {
                    object.uninterpretedOption = [];
                    for (var j = 0; j < message.uninterpretedOption.length; ++j)
                        object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                }
                return object;
            };

            /**
             * Converts this FileOptions to JSON.
             * @function toJSON
             * @memberof google.protobuf.FileOptions
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            FileOptions.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            /**
             * OptimizeMode enum.
             * @name google.protobuf.FileOptions.OptimizeMode
             * @enum {string}
             * @property {number} SPEED=1 SPEED value
             * @property {number} CODE_SIZE=2 CODE_SIZE value
             * @property {number} LITE_RUNTIME=3 LITE_RUNTIME value
             */
            FileOptions.OptimizeMode = (function() {
                var valuesById = {}, values = Object.create(valuesById);
                values[valuesById[1] = "SPEED"] = 1;
                values[valuesById[2] = "CODE_SIZE"] = 2;
                values[valuesById[3] = "LITE_RUNTIME"] = 3;
                return values;
            })();

            return FileOptions;
        })();

        protobuf.MessageOptions = (function() {

            /**
             * Properties of a MessageOptions.
             * @memberof google.protobuf
             * @interface IMessageOptions
             * @property {boolean|null} [messageSetWireFormat] MessageOptions messageSetWireFormat
             * @property {boolean|null} [noStandardDescriptorAccessor] MessageOptions noStandardDescriptorAccessor
             * @property {boolean|null} [deprecated] MessageOptions deprecated
             * @property {boolean|null} [mapEntry] MessageOptions mapEntry
             * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] MessageOptions uninterpretedOption
             */

            /**
             * Constructs a new MessageOptions.
             * @memberof google.protobuf
             * @classdesc Represents a MessageOptions.
             * @implements IMessageOptions
             * @constructor
             * @param {google.protobuf.IMessageOptions=} [properties] Properties to set
             */
            function MessageOptions(properties) {
                this.uninterpretedOption = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * MessageOptions messageSetWireFormat.
             * @member {boolean} messageSetWireFormat
             * @memberof google.protobuf.MessageOptions
             * @instance
             */
            MessageOptions.prototype.messageSetWireFormat = false;

            /**
             * MessageOptions noStandardDescriptorAccessor.
             * @member {boolean} noStandardDescriptorAccessor
             * @memberof google.protobuf.MessageOptions
             * @instance
             */
            MessageOptions.prototype.noStandardDescriptorAccessor = false;

            /**
             * MessageOptions deprecated.
             * @member {boolean} deprecated
             * @memberof google.protobuf.MessageOptions
             * @instance
             */
            MessageOptions.prototype.deprecated = false;

            /**
             * MessageOptions mapEntry.
             * @member {boolean} mapEntry
             * @memberof google.protobuf.MessageOptions
             * @instance
             */
            MessageOptions.prototype.mapEntry = false;

            /**
             * MessageOptions uninterpretedOption.
             * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
             * @memberof google.protobuf.MessageOptions
             * @instance
             */
            MessageOptions.prototype.uninterpretedOption = $util.emptyArray;

            /**
             * Creates a new MessageOptions instance using the specified properties.
             * @function create
             * @memberof google.protobuf.MessageOptions
             * @static
             * @param {google.protobuf.IMessageOptions=} [properties] Properties to set
             * @returns {google.protobuf.MessageOptions} MessageOptions instance
             */
            MessageOptions.create = function create(properties) {
                return new MessageOptions(properties);
            };

            /**
             * Encodes the specified MessageOptions message. Does not implicitly {@link google.protobuf.MessageOptions.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.MessageOptions
             * @static
             * @param {google.protobuf.IMessageOptions} message MessageOptions message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            MessageOptions.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.messageSetWireFormat != null && message.hasOwnProperty("messageSetWireFormat"))
                    writer.uint32(/* id 1, wireType 0 =*/8).bool(message.messageSetWireFormat);
                if (message.noStandardDescriptorAccessor != null && message.hasOwnProperty("noStandardDescriptorAccessor"))
                    writer.uint32(/* id 2, wireType 0 =*/16).bool(message.noStandardDescriptorAccessor);
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    writer.uint32(/* id 3, wireType 0 =*/24).bool(message.deprecated);
                if (message.mapEntry != null && message.hasOwnProperty("mapEntry"))
                    writer.uint32(/* id 7, wireType 0 =*/56).bool(message.mapEntry);
                if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                    for (var i = 0; i < message.uninterpretedOption.length; ++i)
                        $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified MessageOptions message, length delimited. Does not implicitly {@link google.protobuf.MessageOptions.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.MessageOptions
             * @static
             * @param {google.protobuf.IMessageOptions} message MessageOptions message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            MessageOptions.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a MessageOptions message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.MessageOptions
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.MessageOptions} MessageOptions
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            MessageOptions.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.MessageOptions();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.messageSetWireFormat = reader.bool();
                        break;
                    case 2:
                        message.noStandardDescriptorAccessor = reader.bool();
                        break;
                    case 3:
                        message.deprecated = reader.bool();
                        break;
                    case 7:
                        message.mapEntry = reader.bool();
                        break;
                    case 999:
                        if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                            message.uninterpretedOption = [];
                        message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a MessageOptions message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.MessageOptions
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.MessageOptions} MessageOptions
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            MessageOptions.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a MessageOptions message.
             * @function verify
             * @memberof google.protobuf.MessageOptions
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            MessageOptions.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.messageSetWireFormat != null && message.hasOwnProperty("messageSetWireFormat"))
                    if (typeof message.messageSetWireFormat !== "boolean")
                        return "messageSetWireFormat: boolean expected";
                if (message.noStandardDescriptorAccessor != null && message.hasOwnProperty("noStandardDescriptorAccessor"))
                    if (typeof message.noStandardDescriptorAccessor !== "boolean")
                        return "noStandardDescriptorAccessor: boolean expected";
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    if (typeof message.deprecated !== "boolean")
                        return "deprecated: boolean expected";
                if (message.mapEntry != null && message.hasOwnProperty("mapEntry"))
                    if (typeof message.mapEntry !== "boolean")
                        return "mapEntry: boolean expected";
                if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                    if (!Array.isArray(message.uninterpretedOption))
                        return "uninterpretedOption: array expected";
                    for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                        var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                        if (error)
                            return "uninterpretedOption." + error;
                    }
                }
                return null;
            };

            /**
             * Creates a MessageOptions message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.MessageOptions
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.MessageOptions} MessageOptions
             */
            MessageOptions.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.MessageOptions)
                    return object;
                var message = new $root.google.protobuf.MessageOptions();
                if (object.messageSetWireFormat != null)
                    message.messageSetWireFormat = Boolean(object.messageSetWireFormat);
                if (object.noStandardDescriptorAccessor != null)
                    message.noStandardDescriptorAccessor = Boolean(object.noStandardDescriptorAccessor);
                if (object.deprecated != null)
                    message.deprecated = Boolean(object.deprecated);
                if (object.mapEntry != null)
                    message.mapEntry = Boolean(object.mapEntry);
                if (object.uninterpretedOption) {
                    if (!Array.isArray(object.uninterpretedOption))
                        throw TypeError(".google.protobuf.MessageOptions.uninterpretedOption: array expected");
                    message.uninterpretedOption = [];
                    for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                        if (typeof object.uninterpretedOption[i] !== "object")
                            throw TypeError(".google.protobuf.MessageOptions.uninterpretedOption: object expected");
                        message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                    }
                }
                return message;
            };

            /**
             * Creates a plain object from a MessageOptions message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.MessageOptions
             * @static
             * @param {google.protobuf.MessageOptions} message MessageOptions
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            MessageOptions.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.uninterpretedOption = [];
                if (options.defaults) {
                    object.messageSetWireFormat = false;
                    object.noStandardDescriptorAccessor = false;
                    object.deprecated = false;
                    object.mapEntry = false;
                }
                if (message.messageSetWireFormat != null && message.hasOwnProperty("messageSetWireFormat"))
                    object.messageSetWireFormat = message.messageSetWireFormat;
                if (message.noStandardDescriptorAccessor != null && message.hasOwnProperty("noStandardDescriptorAccessor"))
                    object.noStandardDescriptorAccessor = message.noStandardDescriptorAccessor;
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    object.deprecated = message.deprecated;
                if (message.mapEntry != null && message.hasOwnProperty("mapEntry"))
                    object.mapEntry = message.mapEntry;
                if (message.uninterpretedOption && message.uninterpretedOption.length) {
                    object.uninterpretedOption = [];
                    for (var j = 0; j < message.uninterpretedOption.length; ++j)
                        object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                }
                return object;
            };

            /**
             * Converts this MessageOptions to JSON.
             * @function toJSON
             * @memberof google.protobuf.MessageOptions
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            MessageOptions.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return MessageOptions;
        })();

        protobuf.FieldOptions = (function() {

            /**
             * Properties of a FieldOptions.
             * @memberof google.protobuf
             * @interface IFieldOptions
             * @property {google.protobuf.FieldOptions.CType|null} [ctype] FieldOptions ctype
             * @property {boolean|null} [packed] FieldOptions packed
             * @property {google.protobuf.FieldOptions.JSType|null} [jstype] FieldOptions jstype
             * @property {boolean|null} [lazy] FieldOptions lazy
             * @property {boolean|null} [deprecated] FieldOptions deprecated
             * @property {boolean|null} [weak] FieldOptions weak
             * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] FieldOptions uninterpretedOption
             */

            /**
             * Constructs a new FieldOptions.
             * @memberof google.protobuf
             * @classdesc Represents a FieldOptions.
             * @implements IFieldOptions
             * @constructor
             * @param {google.protobuf.IFieldOptions=} [properties] Properties to set
             */
            function FieldOptions(properties) {
                this.uninterpretedOption = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * FieldOptions ctype.
             * @member {google.protobuf.FieldOptions.CType} ctype
             * @memberof google.protobuf.FieldOptions
             * @instance
             */
            FieldOptions.prototype.ctype = 0;

            /**
             * FieldOptions packed.
             * @member {boolean} packed
             * @memberof google.protobuf.FieldOptions
             * @instance
             */
            FieldOptions.prototype.packed = false;

            /**
             * FieldOptions jstype.
             * @member {google.protobuf.FieldOptions.JSType} jstype
             * @memberof google.protobuf.FieldOptions
             * @instance
             */
            FieldOptions.prototype.jstype = 0;

            /**
             * FieldOptions lazy.
             * @member {boolean} lazy
             * @memberof google.protobuf.FieldOptions
             * @instance
             */
            FieldOptions.prototype.lazy = false;

            /**
             * FieldOptions deprecated.
             * @member {boolean} deprecated
             * @memberof google.protobuf.FieldOptions
             * @instance
             */
            FieldOptions.prototype.deprecated = false;

            /**
             * FieldOptions weak.
             * @member {boolean} weak
             * @memberof google.protobuf.FieldOptions
             * @instance
             */
            FieldOptions.prototype.weak = false;

            /**
             * FieldOptions uninterpretedOption.
             * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
             * @memberof google.protobuf.FieldOptions
             * @instance
             */
            FieldOptions.prototype.uninterpretedOption = $util.emptyArray;

            /**
             * Creates a new FieldOptions instance using the specified properties.
             * @function create
             * @memberof google.protobuf.FieldOptions
             * @static
             * @param {google.protobuf.IFieldOptions=} [properties] Properties to set
             * @returns {google.protobuf.FieldOptions} FieldOptions instance
             */
            FieldOptions.create = function create(properties) {
                return new FieldOptions(properties);
            };

            /**
             * Encodes the specified FieldOptions message. Does not implicitly {@link google.protobuf.FieldOptions.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.FieldOptions
             * @static
             * @param {google.protobuf.IFieldOptions} message FieldOptions message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            FieldOptions.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.ctype != null && message.hasOwnProperty("ctype"))
                    writer.uint32(/* id 1, wireType 0 =*/8).int32(message.ctype);
                if (message.packed != null && message.hasOwnProperty("packed"))
                    writer.uint32(/* id 2, wireType 0 =*/16).bool(message.packed);
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    writer.uint32(/* id 3, wireType 0 =*/24).bool(message.deprecated);
                if (message.lazy != null && message.hasOwnProperty("lazy"))
                    writer.uint32(/* id 5, wireType 0 =*/40).bool(message.lazy);
                if (message.jstype != null && message.hasOwnProperty("jstype"))
                    writer.uint32(/* id 6, wireType 0 =*/48).int32(message.jstype);
                if (message.weak != null && message.hasOwnProperty("weak"))
                    writer.uint32(/* id 10, wireType 0 =*/80).bool(message.weak);
                if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                    for (var i = 0; i < message.uninterpretedOption.length; ++i)
                        $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified FieldOptions message, length delimited. Does not implicitly {@link google.protobuf.FieldOptions.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.FieldOptions
             * @static
             * @param {google.protobuf.IFieldOptions} message FieldOptions message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            FieldOptions.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a FieldOptions message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.FieldOptions
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.FieldOptions} FieldOptions
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            FieldOptions.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FieldOptions();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.ctype = reader.int32();
                        break;
                    case 2:
                        message.packed = reader.bool();
                        break;
                    case 6:
                        message.jstype = reader.int32();
                        break;
                    case 5:
                        message.lazy = reader.bool();
                        break;
                    case 3:
                        message.deprecated = reader.bool();
                        break;
                    case 10:
                        message.weak = reader.bool();
                        break;
                    case 999:
                        if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                            message.uninterpretedOption = [];
                        message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a FieldOptions message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.FieldOptions
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.FieldOptions} FieldOptions
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            FieldOptions.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a FieldOptions message.
             * @function verify
             * @memberof google.protobuf.FieldOptions
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            FieldOptions.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.ctype != null && message.hasOwnProperty("ctype"))
                    switch (message.ctype) {
                    default:
                        return "ctype: enum value expected";
                    case 0:
                    case 1:
                    case 2:
                        break;
                    }
                if (message.packed != null && message.hasOwnProperty("packed"))
                    if (typeof message.packed !== "boolean")
                        return "packed: boolean expected";
                if (message.jstype != null && message.hasOwnProperty("jstype"))
                    switch (message.jstype) {
                    default:
                        return "jstype: enum value expected";
                    case 0:
                    case 1:
                    case 2:
                        break;
                    }
                if (message.lazy != null && message.hasOwnProperty("lazy"))
                    if (typeof message.lazy !== "boolean")
                        return "lazy: boolean expected";
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    if (typeof message.deprecated !== "boolean")
                        return "deprecated: boolean expected";
                if (message.weak != null && message.hasOwnProperty("weak"))
                    if (typeof message.weak !== "boolean")
                        return "weak: boolean expected";
                if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                    if (!Array.isArray(message.uninterpretedOption))
                        return "uninterpretedOption: array expected";
                    for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                        var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                        if (error)
                            return "uninterpretedOption." + error;
                    }
                }
                return null;
            };

            /**
             * Creates a FieldOptions message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.FieldOptions
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.FieldOptions} FieldOptions
             */
            FieldOptions.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.FieldOptions)
                    return object;
                var message = new $root.google.protobuf.FieldOptions();
                switch (object.ctype) {
                case "STRING":
                case 0:
                    message.ctype = 0;
                    break;
                case "CORD":
                case 1:
                    message.ctype = 1;
                    break;
                case "STRING_PIECE":
                case 2:
                    message.ctype = 2;
                    break;
                }
                if (object.packed != null)
                    message.packed = Boolean(object.packed);
                switch (object.jstype) {
                case "JS_NORMAL":
                case 0:
                    message.jstype = 0;
                    break;
                case "JS_STRING":
                case 1:
                    message.jstype = 1;
                    break;
                case "JS_NUMBER":
                case 2:
                    message.jstype = 2;
                    break;
                }
                if (object.lazy != null)
                    message.lazy = Boolean(object.lazy);
                if (object.deprecated != null)
                    message.deprecated = Boolean(object.deprecated);
                if (object.weak != null)
                    message.weak = Boolean(object.weak);
                if (object.uninterpretedOption) {
                    if (!Array.isArray(object.uninterpretedOption))
                        throw TypeError(".google.protobuf.FieldOptions.uninterpretedOption: array expected");
                    message.uninterpretedOption = [];
                    for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                        if (typeof object.uninterpretedOption[i] !== "object")
                            throw TypeError(".google.protobuf.FieldOptions.uninterpretedOption: object expected");
                        message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                    }
                }
                return message;
            };

            /**
             * Creates a plain object from a FieldOptions message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.FieldOptions
             * @static
             * @param {google.protobuf.FieldOptions} message FieldOptions
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            FieldOptions.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.uninterpretedOption = [];
                if (options.defaults) {
                    object.ctype = options.enums === String ? "STRING" : 0;
                    object.packed = false;
                    object.deprecated = false;
                    object.lazy = false;
                    object.jstype = options.enums === String ? "JS_NORMAL" : 0;
                    object.weak = false;
                }
                if (message.ctype != null && message.hasOwnProperty("ctype"))
                    object.ctype = options.enums === String ? $root.google.protobuf.FieldOptions.CType[message.ctype] : message.ctype;
                if (message.packed != null && message.hasOwnProperty("packed"))
                    object.packed = message.packed;
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    object.deprecated = message.deprecated;
                if (message.lazy != null && message.hasOwnProperty("lazy"))
                    object.lazy = message.lazy;
                if (message.jstype != null && message.hasOwnProperty("jstype"))
                    object.jstype = options.enums === String ? $root.google.protobuf.FieldOptions.JSType[message.jstype] : message.jstype;
                if (message.weak != null && message.hasOwnProperty("weak"))
                    object.weak = message.weak;
                if (message.uninterpretedOption && message.uninterpretedOption.length) {
                    object.uninterpretedOption = [];
                    for (var j = 0; j < message.uninterpretedOption.length; ++j)
                        object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                }
                return object;
            };

            /**
             * Converts this FieldOptions to JSON.
             * @function toJSON
             * @memberof google.protobuf.FieldOptions
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            FieldOptions.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            /**
             * CType enum.
             * @name google.protobuf.FieldOptions.CType
             * @enum {string}
             * @property {number} STRING=0 STRING value
             * @property {number} CORD=1 CORD value
             * @property {number} STRING_PIECE=2 STRING_PIECE value
             */
            FieldOptions.CType = (function() {
                var valuesById = {}, values = Object.create(valuesById);
                values[valuesById[0] = "STRING"] = 0;
                values[valuesById[1] = "CORD"] = 1;
                values[valuesById[2] = "STRING_PIECE"] = 2;
                return values;
            })();

            /**
             * JSType enum.
             * @name google.protobuf.FieldOptions.JSType
             * @enum {string}
             * @property {number} JS_NORMAL=0 JS_NORMAL value
             * @property {number} JS_STRING=1 JS_STRING value
             * @property {number} JS_NUMBER=2 JS_NUMBER value
             */
            FieldOptions.JSType = (function() {
                var valuesById = {}, values = Object.create(valuesById);
                values[valuesById[0] = "JS_NORMAL"] = 0;
                values[valuesById[1] = "JS_STRING"] = 1;
                values[valuesById[2] = "JS_NUMBER"] = 2;
                return values;
            })();

            return FieldOptions;
        })();

        protobuf.OneofOptions = (function() {

            /**
             * Properties of an OneofOptions.
             * @memberof google.protobuf
             * @interface IOneofOptions
             * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] OneofOptions uninterpretedOption
             */

            /**
             * Constructs a new OneofOptions.
             * @memberof google.protobuf
             * @classdesc Represents an OneofOptions.
             * @implements IOneofOptions
             * @constructor
             * @param {google.protobuf.IOneofOptions=} [properties] Properties to set
             */
            function OneofOptions(properties) {
                this.uninterpretedOption = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * OneofOptions uninterpretedOption.
             * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
             * @memberof google.protobuf.OneofOptions
             * @instance
             */
            OneofOptions.prototype.uninterpretedOption = $util.emptyArray;

            /**
             * Creates a new OneofOptions instance using the specified properties.
             * @function create
             * @memberof google.protobuf.OneofOptions
             * @static
             * @param {google.protobuf.IOneofOptions=} [properties] Properties to set
             * @returns {google.protobuf.OneofOptions} OneofOptions instance
             */
            OneofOptions.create = function create(properties) {
                return new OneofOptions(properties);
            };

            /**
             * Encodes the specified OneofOptions message. Does not implicitly {@link google.protobuf.OneofOptions.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.OneofOptions
             * @static
             * @param {google.protobuf.IOneofOptions} message OneofOptions message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            OneofOptions.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                    for (var i = 0; i < message.uninterpretedOption.length; ++i)
                        $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified OneofOptions message, length delimited. Does not implicitly {@link google.protobuf.OneofOptions.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.OneofOptions
             * @static
             * @param {google.protobuf.IOneofOptions} message OneofOptions message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            OneofOptions.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes an OneofOptions message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.OneofOptions
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.OneofOptions} OneofOptions
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            OneofOptions.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.OneofOptions();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 999:
                        if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                            message.uninterpretedOption = [];
                        message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes an OneofOptions message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.OneofOptions
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.OneofOptions} OneofOptions
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            OneofOptions.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies an OneofOptions message.
             * @function verify
             * @memberof google.protobuf.OneofOptions
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            OneofOptions.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                    if (!Array.isArray(message.uninterpretedOption))
                        return "uninterpretedOption: array expected";
                    for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                        var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                        if (error)
                            return "uninterpretedOption." + error;
                    }
                }
                return null;
            };

            /**
             * Creates an OneofOptions message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.OneofOptions
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.OneofOptions} OneofOptions
             */
            OneofOptions.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.OneofOptions)
                    return object;
                var message = new $root.google.protobuf.OneofOptions();
                if (object.uninterpretedOption) {
                    if (!Array.isArray(object.uninterpretedOption))
                        throw TypeError(".google.protobuf.OneofOptions.uninterpretedOption: array expected");
                    message.uninterpretedOption = [];
                    for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                        if (typeof object.uninterpretedOption[i] !== "object")
                            throw TypeError(".google.protobuf.OneofOptions.uninterpretedOption: object expected");
                        message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                    }
                }
                return message;
            };

            /**
             * Creates a plain object from an OneofOptions message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.OneofOptions
             * @static
             * @param {google.protobuf.OneofOptions} message OneofOptions
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            OneofOptions.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.uninterpretedOption = [];
                if (message.uninterpretedOption && message.uninterpretedOption.length) {
                    object.uninterpretedOption = [];
                    for (var j = 0; j < message.uninterpretedOption.length; ++j)
                        object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                }
                return object;
            };

            /**
             * Converts this OneofOptions to JSON.
             * @function toJSON
             * @memberof google.protobuf.OneofOptions
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            OneofOptions.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return OneofOptions;
        })();

        protobuf.EnumOptions = (function() {

            /**
             * Properties of an EnumOptions.
             * @memberof google.protobuf
             * @interface IEnumOptions
             * @property {boolean|null} [allowAlias] EnumOptions allowAlias
             * @property {boolean|null} [deprecated] EnumOptions deprecated
             * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] EnumOptions uninterpretedOption
             */

            /**
             * Constructs a new EnumOptions.
             * @memberof google.protobuf
             * @classdesc Represents an EnumOptions.
             * @implements IEnumOptions
             * @constructor
             * @param {google.protobuf.IEnumOptions=} [properties] Properties to set
             */
            function EnumOptions(properties) {
                this.uninterpretedOption = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * EnumOptions allowAlias.
             * @member {boolean} allowAlias
             * @memberof google.protobuf.EnumOptions
             * @instance
             */
            EnumOptions.prototype.allowAlias = false;

            /**
             * EnumOptions deprecated.
             * @member {boolean} deprecated
             * @memberof google.protobuf.EnumOptions
             * @instance
             */
            EnumOptions.prototype.deprecated = false;

            /**
             * EnumOptions uninterpretedOption.
             * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
             * @memberof google.protobuf.EnumOptions
             * @instance
             */
            EnumOptions.prototype.uninterpretedOption = $util.emptyArray;

            /**
             * Creates a new EnumOptions instance using the specified properties.
             * @function create
             * @memberof google.protobuf.EnumOptions
             * @static
             * @param {google.protobuf.IEnumOptions=} [properties] Properties to set
             * @returns {google.protobuf.EnumOptions} EnumOptions instance
             */
            EnumOptions.create = function create(properties) {
                return new EnumOptions(properties);
            };

            /**
             * Encodes the specified EnumOptions message. Does not implicitly {@link google.protobuf.EnumOptions.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.EnumOptions
             * @static
             * @param {google.protobuf.IEnumOptions} message EnumOptions message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            EnumOptions.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.allowAlias != null && message.hasOwnProperty("allowAlias"))
                    writer.uint32(/* id 2, wireType 0 =*/16).bool(message.allowAlias);
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    writer.uint32(/* id 3, wireType 0 =*/24).bool(message.deprecated);
                if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                    for (var i = 0; i < message.uninterpretedOption.length; ++i)
                        $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified EnumOptions message, length delimited. Does not implicitly {@link google.protobuf.EnumOptions.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.EnumOptions
             * @static
             * @param {google.protobuf.IEnumOptions} message EnumOptions message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            EnumOptions.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes an EnumOptions message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.EnumOptions
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.EnumOptions} EnumOptions
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            EnumOptions.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.EnumOptions();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 2:
                        message.allowAlias = reader.bool();
                        break;
                    case 3:
                        message.deprecated = reader.bool();
                        break;
                    case 999:
                        if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                            message.uninterpretedOption = [];
                        message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes an EnumOptions message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.EnumOptions
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.EnumOptions} EnumOptions
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            EnumOptions.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies an EnumOptions message.
             * @function verify
             * @memberof google.protobuf.EnumOptions
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            EnumOptions.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.allowAlias != null && message.hasOwnProperty("allowAlias"))
                    if (typeof message.allowAlias !== "boolean")
                        return "allowAlias: boolean expected";
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    if (typeof message.deprecated !== "boolean")
                        return "deprecated: boolean expected";
                if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                    if (!Array.isArray(message.uninterpretedOption))
                        return "uninterpretedOption: array expected";
                    for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                        var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                        if (error)
                            return "uninterpretedOption." + error;
                    }
                }
                return null;
            };

            /**
             * Creates an EnumOptions message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.EnumOptions
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.EnumOptions} EnumOptions
             */
            EnumOptions.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.EnumOptions)
                    return object;
                var message = new $root.google.protobuf.EnumOptions();
                if (object.allowAlias != null)
                    message.allowAlias = Boolean(object.allowAlias);
                if (object.deprecated != null)
                    message.deprecated = Boolean(object.deprecated);
                if (object.uninterpretedOption) {
                    if (!Array.isArray(object.uninterpretedOption))
                        throw TypeError(".google.protobuf.EnumOptions.uninterpretedOption: array expected");
                    message.uninterpretedOption = [];
                    for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                        if (typeof object.uninterpretedOption[i] !== "object")
                            throw TypeError(".google.protobuf.EnumOptions.uninterpretedOption: object expected");
                        message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                    }
                }
                return message;
            };

            /**
             * Creates a plain object from an EnumOptions message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.EnumOptions
             * @static
             * @param {google.protobuf.EnumOptions} message EnumOptions
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            EnumOptions.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.uninterpretedOption = [];
                if (options.defaults) {
                    object.allowAlias = false;
                    object.deprecated = false;
                }
                if (message.allowAlias != null && message.hasOwnProperty("allowAlias"))
                    object.allowAlias = message.allowAlias;
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    object.deprecated = message.deprecated;
                if (message.uninterpretedOption && message.uninterpretedOption.length) {
                    object.uninterpretedOption = [];
                    for (var j = 0; j < message.uninterpretedOption.length; ++j)
                        object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                }
                return object;
            };

            /**
             * Converts this EnumOptions to JSON.
             * @function toJSON
             * @memberof google.protobuf.EnumOptions
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            EnumOptions.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return EnumOptions;
        })();

        protobuf.EnumValueOptions = (function() {

            /**
             * Properties of an EnumValueOptions.
             * @memberof google.protobuf
             * @interface IEnumValueOptions
             * @property {boolean|null} [deprecated] EnumValueOptions deprecated
             * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] EnumValueOptions uninterpretedOption
             */

            /**
             * Constructs a new EnumValueOptions.
             * @memberof google.protobuf
             * @classdesc Represents an EnumValueOptions.
             * @implements IEnumValueOptions
             * @constructor
             * @param {google.protobuf.IEnumValueOptions=} [properties] Properties to set
             */
            function EnumValueOptions(properties) {
                this.uninterpretedOption = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * EnumValueOptions deprecated.
             * @member {boolean} deprecated
             * @memberof google.protobuf.EnumValueOptions
             * @instance
             */
            EnumValueOptions.prototype.deprecated = false;

            /**
             * EnumValueOptions uninterpretedOption.
             * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
             * @memberof google.protobuf.EnumValueOptions
             * @instance
             */
            EnumValueOptions.prototype.uninterpretedOption = $util.emptyArray;

            /**
             * Creates a new EnumValueOptions instance using the specified properties.
             * @function create
             * @memberof google.protobuf.EnumValueOptions
             * @static
             * @param {google.protobuf.IEnumValueOptions=} [properties] Properties to set
             * @returns {google.protobuf.EnumValueOptions} EnumValueOptions instance
             */
            EnumValueOptions.create = function create(properties) {
                return new EnumValueOptions(properties);
            };

            /**
             * Encodes the specified EnumValueOptions message. Does not implicitly {@link google.protobuf.EnumValueOptions.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.EnumValueOptions
             * @static
             * @param {google.protobuf.IEnumValueOptions} message EnumValueOptions message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            EnumValueOptions.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    writer.uint32(/* id 1, wireType 0 =*/8).bool(message.deprecated);
                if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                    for (var i = 0; i < message.uninterpretedOption.length; ++i)
                        $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified EnumValueOptions message, length delimited. Does not implicitly {@link google.protobuf.EnumValueOptions.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.EnumValueOptions
             * @static
             * @param {google.protobuf.IEnumValueOptions} message EnumValueOptions message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            EnumValueOptions.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes an EnumValueOptions message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.EnumValueOptions
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.EnumValueOptions} EnumValueOptions
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            EnumValueOptions.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.EnumValueOptions();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.deprecated = reader.bool();
                        break;
                    case 999:
                        if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                            message.uninterpretedOption = [];
                        message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes an EnumValueOptions message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.EnumValueOptions
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.EnumValueOptions} EnumValueOptions
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            EnumValueOptions.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies an EnumValueOptions message.
             * @function verify
             * @memberof google.protobuf.EnumValueOptions
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            EnumValueOptions.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    if (typeof message.deprecated !== "boolean")
                        return "deprecated: boolean expected";
                if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                    if (!Array.isArray(message.uninterpretedOption))
                        return "uninterpretedOption: array expected";
                    for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                        var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                        if (error)
                            return "uninterpretedOption." + error;
                    }
                }
                return null;
            };

            /**
             * Creates an EnumValueOptions message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.EnumValueOptions
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.EnumValueOptions} EnumValueOptions
             */
            EnumValueOptions.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.EnumValueOptions)
                    return object;
                var message = new $root.google.protobuf.EnumValueOptions();
                if (object.deprecated != null)
                    message.deprecated = Boolean(object.deprecated);
                if (object.uninterpretedOption) {
                    if (!Array.isArray(object.uninterpretedOption))
                        throw TypeError(".google.protobuf.EnumValueOptions.uninterpretedOption: array expected");
                    message.uninterpretedOption = [];
                    for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                        if (typeof object.uninterpretedOption[i] !== "object")
                            throw TypeError(".google.protobuf.EnumValueOptions.uninterpretedOption: object expected");
                        message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                    }
                }
                return message;
            };

            /**
             * Creates a plain object from an EnumValueOptions message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.EnumValueOptions
             * @static
             * @param {google.protobuf.EnumValueOptions} message EnumValueOptions
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            EnumValueOptions.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.uninterpretedOption = [];
                if (options.defaults)
                    object.deprecated = false;
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    object.deprecated = message.deprecated;
                if (message.uninterpretedOption && message.uninterpretedOption.length) {
                    object.uninterpretedOption = [];
                    for (var j = 0; j < message.uninterpretedOption.length; ++j)
                        object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                }
                return object;
            };

            /**
             * Converts this EnumValueOptions to JSON.
             * @function toJSON
             * @memberof google.protobuf.EnumValueOptions
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            EnumValueOptions.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return EnumValueOptions;
        })();

        protobuf.ServiceOptions = (function() {

            /**
             * Properties of a ServiceOptions.
             * @memberof google.protobuf
             * @interface IServiceOptions
             * @property {boolean|null} [deprecated] ServiceOptions deprecated
             * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] ServiceOptions uninterpretedOption
             */

            /**
             * Constructs a new ServiceOptions.
             * @memberof google.protobuf
             * @classdesc Represents a ServiceOptions.
             * @implements IServiceOptions
             * @constructor
             * @param {google.protobuf.IServiceOptions=} [properties] Properties to set
             */
            function ServiceOptions(properties) {
                this.uninterpretedOption = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * ServiceOptions deprecated.
             * @member {boolean} deprecated
             * @memberof google.protobuf.ServiceOptions
             * @instance
             */
            ServiceOptions.prototype.deprecated = false;

            /**
             * ServiceOptions uninterpretedOption.
             * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
             * @memberof google.protobuf.ServiceOptions
             * @instance
             */
            ServiceOptions.prototype.uninterpretedOption = $util.emptyArray;

            /**
             * Creates a new ServiceOptions instance using the specified properties.
             * @function create
             * @memberof google.protobuf.ServiceOptions
             * @static
             * @param {google.protobuf.IServiceOptions=} [properties] Properties to set
             * @returns {google.protobuf.ServiceOptions} ServiceOptions instance
             */
            ServiceOptions.create = function create(properties) {
                return new ServiceOptions(properties);
            };

            /**
             * Encodes the specified ServiceOptions message. Does not implicitly {@link google.protobuf.ServiceOptions.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.ServiceOptions
             * @static
             * @param {google.protobuf.IServiceOptions} message ServiceOptions message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            ServiceOptions.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    writer.uint32(/* id 33, wireType 0 =*/264).bool(message.deprecated);
                if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                    for (var i = 0; i < message.uninterpretedOption.length; ++i)
                        $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified ServiceOptions message, length delimited. Does not implicitly {@link google.protobuf.ServiceOptions.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.ServiceOptions
             * @static
             * @param {google.protobuf.IServiceOptions} message ServiceOptions message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            ServiceOptions.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a ServiceOptions message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.ServiceOptions
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.ServiceOptions} ServiceOptions
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            ServiceOptions.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.ServiceOptions();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 33:
                        message.deprecated = reader.bool();
                        break;
                    case 999:
                        if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                            message.uninterpretedOption = [];
                        message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a ServiceOptions message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.ServiceOptions
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.ServiceOptions} ServiceOptions
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            ServiceOptions.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a ServiceOptions message.
             * @function verify
             * @memberof google.protobuf.ServiceOptions
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            ServiceOptions.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    if (typeof message.deprecated !== "boolean")
                        return "deprecated: boolean expected";
                if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                    if (!Array.isArray(message.uninterpretedOption))
                        return "uninterpretedOption: array expected";
                    for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                        var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                        if (error)
                            return "uninterpretedOption." + error;
                    }
                }
                return null;
            };

            /**
             * Creates a ServiceOptions message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.ServiceOptions
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.ServiceOptions} ServiceOptions
             */
            ServiceOptions.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.ServiceOptions)
                    return object;
                var message = new $root.google.protobuf.ServiceOptions();
                if (object.deprecated != null)
                    message.deprecated = Boolean(object.deprecated);
                if (object.uninterpretedOption) {
                    if (!Array.isArray(object.uninterpretedOption))
                        throw TypeError(".google.protobuf.ServiceOptions.uninterpretedOption: array expected");
                    message.uninterpretedOption = [];
                    for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                        if (typeof object.uninterpretedOption[i] !== "object")
                            throw TypeError(".google.protobuf.ServiceOptions.uninterpretedOption: object expected");
                        message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                    }
                }
                return message;
            };

            /**
             * Creates a plain object from a ServiceOptions message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.ServiceOptions
             * @static
             * @param {google.protobuf.ServiceOptions} message ServiceOptions
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            ServiceOptions.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.uninterpretedOption = [];
                if (options.defaults)
                    object.deprecated = false;
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    object.deprecated = message.deprecated;
                if (message.uninterpretedOption && message.uninterpretedOption.length) {
                    object.uninterpretedOption = [];
                    for (var j = 0; j < message.uninterpretedOption.length; ++j)
                        object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                }
                return object;
            };

            /**
             * Converts this ServiceOptions to JSON.
             * @function toJSON
             * @memberof google.protobuf.ServiceOptions
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            ServiceOptions.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return ServiceOptions;
        })();

        protobuf.MethodOptions = (function() {

            /**
             * Properties of a MethodOptions.
             * @memberof google.protobuf
             * @interface IMethodOptions
             * @property {boolean|null} [deprecated] MethodOptions deprecated
             * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] MethodOptions uninterpretedOption
             * @property {google.longrunning.IOperationInfo|null} [".google.longrunning.operationInfo"] MethodOptions .google.longrunning.operationInfo
             * @property {google.api.IHttpRule|null} [".google.api.http"] MethodOptions .google.api.http
             */

            /**
             * Constructs a new MethodOptions.
             * @memberof google.protobuf
             * @classdesc Represents a MethodOptions.
             * @implements IMethodOptions
             * @constructor
             * @param {google.protobuf.IMethodOptions=} [properties] Properties to set
             */
            function MethodOptions(properties) {
                this.uninterpretedOption = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * MethodOptions deprecated.
             * @member {boolean} deprecated
             * @memberof google.protobuf.MethodOptions
             * @instance
             */
            MethodOptions.prototype.deprecated = false;

            /**
             * MethodOptions uninterpretedOption.
             * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
             * @memberof google.protobuf.MethodOptions
             * @instance
             */
            MethodOptions.prototype.uninterpretedOption = $util.emptyArray;

            /**
             * MethodOptions .google.longrunning.operationInfo.
             * @member {google.longrunning.IOperationInfo|null|undefined} .google.longrunning.operationInfo
             * @memberof google.protobuf.MethodOptions
             * @instance
             */
            MethodOptions.prototype[".google.longrunning.operationInfo"] = null;

            /**
             * MethodOptions .google.api.http.
             * @member {google.api.IHttpRule|null|undefined} .google.api.http
             * @memberof google.protobuf.MethodOptions
             * @instance
             */
            MethodOptions.prototype[".google.api.http"] = null;

            /**
             * Creates a new MethodOptions instance using the specified properties.
             * @function create
             * @memberof google.protobuf.MethodOptions
             * @static
             * @param {google.protobuf.IMethodOptions=} [properties] Properties to set
             * @returns {google.protobuf.MethodOptions} MethodOptions instance
             */
            MethodOptions.create = function create(properties) {
                return new MethodOptions(properties);
            };

            /**
             * Encodes the specified MethodOptions message. Does not implicitly {@link google.protobuf.MethodOptions.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.MethodOptions
             * @static
             * @param {google.protobuf.IMethodOptions} message MethodOptions message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            MethodOptions.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    writer.uint32(/* id 33, wireType 0 =*/264).bool(message.deprecated);
                if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                    for (var i = 0; i < message.uninterpretedOption.length; ++i)
                        $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                if (message[".google.longrunning.operationInfo"] != null && message.hasOwnProperty(".google.longrunning.operationInfo"))
                    $root.google.longrunning.OperationInfo.encode(message[".google.longrunning.operationInfo"], writer.uint32(/* id 1049, wireType 2 =*/8394).fork()).ldelim();
                if (message[".google.api.http"] != null && message.hasOwnProperty(".google.api.http"))
                    $root.google.api.HttpRule.encode(message[".google.api.http"], writer.uint32(/* id 72295728, wireType 2 =*/578365826).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified MethodOptions message, length delimited. Does not implicitly {@link google.protobuf.MethodOptions.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.MethodOptions
             * @static
             * @param {google.protobuf.IMethodOptions} message MethodOptions message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            MethodOptions.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a MethodOptions message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.MethodOptions
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.MethodOptions} MethodOptions
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            MethodOptions.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.MethodOptions();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 33:
                        message.deprecated = reader.bool();
                        break;
                    case 999:
                        if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                            message.uninterpretedOption = [];
                        message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                        break;
                    case 1049:
                        message[".google.longrunning.operationInfo"] = $root.google.longrunning.OperationInfo.decode(reader, reader.uint32());
                        break;
                    case 72295728:
                        message[".google.api.http"] = $root.google.api.HttpRule.decode(reader, reader.uint32());
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a MethodOptions message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.MethodOptions
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.MethodOptions} MethodOptions
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            MethodOptions.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a MethodOptions message.
             * @function verify
             * @memberof google.protobuf.MethodOptions
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            MethodOptions.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    if (typeof message.deprecated !== "boolean")
                        return "deprecated: boolean expected";
                if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                    if (!Array.isArray(message.uninterpretedOption))
                        return "uninterpretedOption: array expected";
                    for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                        var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                        if (error)
                            return "uninterpretedOption." + error;
                    }
                }
                if (message[".google.longrunning.operationInfo"] != null && message.hasOwnProperty(".google.longrunning.operationInfo")) {
                    var error = $root.google.longrunning.OperationInfo.verify(message[".google.longrunning.operationInfo"]);
                    if (error)
                        return ".google.longrunning.operationInfo." + error;
                }
                if (message[".google.api.http"] != null && message.hasOwnProperty(".google.api.http")) {
                    var error = $root.google.api.HttpRule.verify(message[".google.api.http"]);
                    if (error)
                        return ".google.api.http." + error;
                }
                return null;
            };

            /**
             * Creates a MethodOptions message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.MethodOptions
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.MethodOptions} MethodOptions
             */
            MethodOptions.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.MethodOptions)
                    return object;
                var message = new $root.google.protobuf.MethodOptions();
                if (object.deprecated != null)
                    message.deprecated = Boolean(object.deprecated);
                if (object.uninterpretedOption) {
                    if (!Array.isArray(object.uninterpretedOption))
                        throw TypeError(".google.protobuf.MethodOptions.uninterpretedOption: array expected");
                    message.uninterpretedOption = [];
                    for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                        if (typeof object.uninterpretedOption[i] !== "object")
                            throw TypeError(".google.protobuf.MethodOptions.uninterpretedOption: object expected");
                        message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                    }
                }
                if (object[".google.longrunning.operationInfo"] != null) {
                    if (typeof object[".google.longrunning.operationInfo"] !== "object")
                        throw TypeError(".google.protobuf.MethodOptions..google.longrunning.operationInfo: object expected");
                    message[".google.longrunning.operationInfo"] = $root.google.longrunning.OperationInfo.fromObject(object[".google.longrunning.operationInfo"]);
                }
                if (object[".google.api.http"] != null) {
                    if (typeof object[".google.api.http"] !== "object")
                        throw TypeError(".google.protobuf.MethodOptions..google.api.http: object expected");
                    message[".google.api.http"] = $root.google.api.HttpRule.fromObject(object[".google.api.http"]);
                }
                return message;
            };

            /**
             * Creates a plain object from a MethodOptions message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.MethodOptions
             * @static
             * @param {google.protobuf.MethodOptions} message MethodOptions
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            MethodOptions.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.uninterpretedOption = [];
                if (options.defaults) {
                    object.deprecated = false;
                    object[".google.longrunning.operationInfo"] = null;
                    object[".google.api.http"] = null;
                }
                if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                    object.deprecated = message.deprecated;
                if (message.uninterpretedOption && message.uninterpretedOption.length) {
                    object.uninterpretedOption = [];
                    for (var j = 0; j < message.uninterpretedOption.length; ++j)
                        object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                }
                if (message[".google.longrunning.operationInfo"] != null && message.hasOwnProperty(".google.longrunning.operationInfo"))
                    object[".google.longrunning.operationInfo"] = $root.google.longrunning.OperationInfo.toObject(message[".google.longrunning.operationInfo"], options);
                if (message[".google.api.http"] != null && message.hasOwnProperty(".google.api.http"))
                    object[".google.api.http"] = $root.google.api.HttpRule.toObject(message[".google.api.http"], options);
                return object;
            };

            /**
             * Converts this MethodOptions to JSON.
             * @function toJSON
             * @memberof google.protobuf.MethodOptions
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            MethodOptions.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return MethodOptions;
        })();

        protobuf.UninterpretedOption = (function() {

            /**
             * Properties of an UninterpretedOption.
             * @memberof google.protobuf
             * @interface IUninterpretedOption
             * @property {Array.<google.protobuf.UninterpretedOption.INamePart>|null} [name] UninterpretedOption name
             * @property {string|null} [identifierValue] UninterpretedOption identifierValue
             * @property {number|Long|null} [positiveIntValue] UninterpretedOption positiveIntValue
             * @property {number|Long|null} [negativeIntValue] UninterpretedOption negativeIntValue
             * @property {number|null} [doubleValue] UninterpretedOption doubleValue
             * @property {Uint8Array|null} [stringValue] UninterpretedOption stringValue
             * @property {string|null} [aggregateValue] UninterpretedOption aggregateValue
             */

            /**
             * Constructs a new UninterpretedOption.
             * @memberof google.protobuf
             * @classdesc Represents an UninterpretedOption.
             * @implements IUninterpretedOption
             * @constructor
             * @param {google.protobuf.IUninterpretedOption=} [properties] Properties to set
             */
            function UninterpretedOption(properties) {
                this.name = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * UninterpretedOption name.
             * @member {Array.<google.protobuf.UninterpretedOption.INamePart>} name
             * @memberof google.protobuf.UninterpretedOption
             * @instance
             */
            UninterpretedOption.prototype.name = $util.emptyArray;

            /**
             * UninterpretedOption identifierValue.
             * @member {string} identifierValue
             * @memberof google.protobuf.UninterpretedOption
             * @instance
             */
            UninterpretedOption.prototype.identifierValue = "";

            /**
             * UninterpretedOption positiveIntValue.
             * @member {number|Long} positiveIntValue
             * @memberof google.protobuf.UninterpretedOption
             * @instance
             */
            UninterpretedOption.prototype.positiveIntValue = $util.Long ? $util.Long.fromBits(0,0,true) : 0;

            /**
             * UninterpretedOption negativeIntValue.
             * @member {number|Long} negativeIntValue
             * @memberof google.protobuf.UninterpretedOption
             * @instance
             */
            UninterpretedOption.prototype.negativeIntValue = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

            /**
             * UninterpretedOption doubleValue.
             * @member {number} doubleValue
             * @memberof google.protobuf.UninterpretedOption
             * @instance
             */
            UninterpretedOption.prototype.doubleValue = 0;

            /**
             * UninterpretedOption stringValue.
             * @member {Uint8Array} stringValue
             * @memberof google.protobuf.UninterpretedOption
             * @instance
             */
            UninterpretedOption.prototype.stringValue = $util.newBuffer([]);

            /**
             * UninterpretedOption aggregateValue.
             * @member {string} aggregateValue
             * @memberof google.protobuf.UninterpretedOption
             * @instance
             */
            UninterpretedOption.prototype.aggregateValue = "";

            /**
             * Creates a new UninterpretedOption instance using the specified properties.
             * @function create
             * @memberof google.protobuf.UninterpretedOption
             * @static
             * @param {google.protobuf.IUninterpretedOption=} [properties] Properties to set
             * @returns {google.protobuf.UninterpretedOption} UninterpretedOption instance
             */
            UninterpretedOption.create = function create(properties) {
                return new UninterpretedOption(properties);
            };

            /**
             * Encodes the specified UninterpretedOption message. Does not implicitly {@link google.protobuf.UninterpretedOption.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.UninterpretedOption
             * @static
             * @param {google.protobuf.IUninterpretedOption} message UninterpretedOption message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            UninterpretedOption.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.name != null && message.name.length)
                    for (var i = 0; i < message.name.length; ++i)
                        $root.google.protobuf.UninterpretedOption.NamePart.encode(message.name[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                if (message.identifierValue != null && message.hasOwnProperty("identifierValue"))
                    writer.uint32(/* id 3, wireType 2 =*/26).string(message.identifierValue);
                if (message.positiveIntValue != null && message.hasOwnProperty("positiveIntValue"))
                    writer.uint32(/* id 4, wireType 0 =*/32).uint64(message.positiveIntValue);
                if (message.negativeIntValue != null && message.hasOwnProperty("negativeIntValue"))
                    writer.uint32(/* id 5, wireType 0 =*/40).int64(message.negativeIntValue);
                if (message.doubleValue != null && message.hasOwnProperty("doubleValue"))
                    writer.uint32(/* id 6, wireType 1 =*/49).double(message.doubleValue);
                if (message.stringValue != null && message.hasOwnProperty("stringValue"))
                    writer.uint32(/* id 7, wireType 2 =*/58).bytes(message.stringValue);
                if (message.aggregateValue != null && message.hasOwnProperty("aggregateValue"))
                    writer.uint32(/* id 8, wireType 2 =*/66).string(message.aggregateValue);
                return writer;
            };

            /**
             * Encodes the specified UninterpretedOption message, length delimited. Does not implicitly {@link google.protobuf.UninterpretedOption.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.UninterpretedOption
             * @static
             * @param {google.protobuf.IUninterpretedOption} message UninterpretedOption message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            UninterpretedOption.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes an UninterpretedOption message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.UninterpretedOption
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.UninterpretedOption} UninterpretedOption
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            UninterpretedOption.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.UninterpretedOption();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 2:
                        if (!(message.name && message.name.length))
                            message.name = [];
                        message.name.push($root.google.protobuf.UninterpretedOption.NamePart.decode(reader, reader.uint32()));
                        break;
                    case 3:
                        message.identifierValue = reader.string();
                        break;
                    case 4:
                        message.positiveIntValue = reader.uint64();
                        break;
                    case 5:
                        message.negativeIntValue = reader.int64();
                        break;
                    case 6:
                        message.doubleValue = reader.double();
                        break;
                    case 7:
                        message.stringValue = reader.bytes();
                        break;
                    case 8:
                        message.aggregateValue = reader.string();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes an UninterpretedOption message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.UninterpretedOption
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.UninterpretedOption} UninterpretedOption
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            UninterpretedOption.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies an UninterpretedOption message.
             * @function verify
             * @memberof google.protobuf.UninterpretedOption
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            UninterpretedOption.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.name != null && message.hasOwnProperty("name")) {
                    if (!Array.isArray(message.name))
                        return "name: array expected";
                    for (var i = 0; i < message.name.length; ++i) {
                        var error = $root.google.protobuf.UninterpretedOption.NamePart.verify(message.name[i]);
                        if (error)
                            return "name." + error;
                    }
                }
                if (message.identifierValue != null && message.hasOwnProperty("identifierValue"))
                    if (!$util.isString(message.identifierValue))
                        return "identifierValue: string expected";
                if (message.positiveIntValue != null && message.hasOwnProperty("positiveIntValue"))
                    if (!$util.isInteger(message.positiveIntValue) && !(message.positiveIntValue && $util.isInteger(message.positiveIntValue.low) && $util.isInteger(message.positiveIntValue.high)))
                        return "positiveIntValue: integer|Long expected";
                if (message.negativeIntValue != null && message.hasOwnProperty("negativeIntValue"))
                    if (!$util.isInteger(message.negativeIntValue) && !(message.negativeIntValue && $util.isInteger(message.negativeIntValue.low) && $util.isInteger(message.negativeIntValue.high)))
                        return "negativeIntValue: integer|Long expected";
                if (message.doubleValue != null && message.hasOwnProperty("doubleValue"))
                    if (typeof message.doubleValue !== "number")
                        return "doubleValue: number expected";
                if (message.stringValue != null && message.hasOwnProperty("stringValue"))
                    if (!(message.stringValue && typeof message.stringValue.length === "number" || $util.isString(message.stringValue)))
                        return "stringValue: buffer expected";
                if (message.aggregateValue != null && message.hasOwnProperty("aggregateValue"))
                    if (!$util.isString(message.aggregateValue))
                        return "aggregateValue: string expected";
                return null;
            };

            /**
             * Creates an UninterpretedOption message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.UninterpretedOption
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.UninterpretedOption} UninterpretedOption
             */
            UninterpretedOption.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.UninterpretedOption)
                    return object;
                var message = new $root.google.protobuf.UninterpretedOption();
                if (object.name) {
                    if (!Array.isArray(object.name))
                        throw TypeError(".google.protobuf.UninterpretedOption.name: array expected");
                    message.name = [];
                    for (var i = 0; i < object.name.length; ++i) {
                        if (typeof object.name[i] !== "object")
                            throw TypeError(".google.protobuf.UninterpretedOption.name: object expected");
                        message.name[i] = $root.google.protobuf.UninterpretedOption.NamePart.fromObject(object.name[i]);
                    }
                }
                if (object.identifierValue != null)
                    message.identifierValue = String(object.identifierValue);
                if (object.positiveIntValue != null)
                    if ($util.Long)
                        (message.positiveIntValue = $util.Long.fromValue(object.positiveIntValue)).unsigned = true;
                    else if (typeof object.positiveIntValue === "string")
                        message.positiveIntValue = parseInt(object.positiveIntValue, 10);
                    else if (typeof object.positiveIntValue === "number")
                        message.positiveIntValue = object.positiveIntValue;
                    else if (typeof object.positiveIntValue === "object")
                        message.positiveIntValue = new $util.LongBits(object.positiveIntValue.low >>> 0, object.positiveIntValue.high >>> 0).toNumber(true);
                if (object.negativeIntValue != null)
                    if ($util.Long)
                        (message.negativeIntValue = $util.Long.fromValue(object.negativeIntValue)).unsigned = false;
                    else if (typeof object.negativeIntValue === "string")
                        message.negativeIntValue = parseInt(object.negativeIntValue, 10);
                    else if (typeof object.negativeIntValue === "number")
                        message.negativeIntValue = object.negativeIntValue;
                    else if (typeof object.negativeIntValue === "object")
                        message.negativeIntValue = new $util.LongBits(object.negativeIntValue.low >>> 0, object.negativeIntValue.high >>> 0).toNumber();
                if (object.doubleValue != null)
                    message.doubleValue = Number(object.doubleValue);
                if (object.stringValue != null)
                    if (typeof object.stringValue === "string")
                        $util.base64.decode(object.stringValue, message.stringValue = $util.newBuffer($util.base64.length(object.stringValue)), 0);
                    else if (object.stringValue.length)
                        message.stringValue = object.stringValue;
                if (object.aggregateValue != null)
                    message.aggregateValue = String(object.aggregateValue);
                return message;
            };

            /**
             * Creates a plain object from an UninterpretedOption message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.UninterpretedOption
             * @static
             * @param {google.protobuf.UninterpretedOption} message UninterpretedOption
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            UninterpretedOption.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.name = [];
                if (options.defaults) {
                    object.identifierValue = "";
                    if ($util.Long) {
                        var long = new $util.Long(0, 0, true);
                        object.positiveIntValue = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                    } else
                        object.positiveIntValue = options.longs === String ? "0" : 0;
                    if ($util.Long) {
                        var long = new $util.Long(0, 0, false);
                        object.negativeIntValue = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                    } else
                        object.negativeIntValue = options.longs === String ? "0" : 0;
                    object.doubleValue = 0;
                    if (options.bytes === String)
                        object.stringValue = "";
                    else {
                        object.stringValue = [];
                        if (options.bytes !== Array)
                            object.stringValue = $util.newBuffer(object.stringValue);
                    }
                    object.aggregateValue = "";
                }
                if (message.name && message.name.length) {
                    object.name = [];
                    for (var j = 0; j < message.name.length; ++j)
                        object.name[j] = $root.google.protobuf.UninterpretedOption.NamePart.toObject(message.name[j], options);
                }
                if (message.identifierValue != null && message.hasOwnProperty("identifierValue"))
                    object.identifierValue = message.identifierValue;
                if (message.positiveIntValue != null && message.hasOwnProperty("positiveIntValue"))
                    if (typeof message.positiveIntValue === "number")
                        object.positiveIntValue = options.longs === String ? String(message.positiveIntValue) : message.positiveIntValue;
                    else
                        object.positiveIntValue = options.longs === String ? $util.Long.prototype.toString.call(message.positiveIntValue) : options.longs === Number ? new $util.LongBits(message.positiveIntValue.low >>> 0, message.positiveIntValue.high >>> 0).toNumber(true) : message.positiveIntValue;
                if (message.negativeIntValue != null && message.hasOwnProperty("negativeIntValue"))
                    if (typeof message.negativeIntValue === "number")
                        object.negativeIntValue = options.longs === String ? String(message.negativeIntValue) : message.negativeIntValue;
                    else
                        object.negativeIntValue = options.longs === String ? $util.Long.prototype.toString.call(message.negativeIntValue) : options.longs === Number ? new $util.LongBits(message.negativeIntValue.low >>> 0, message.negativeIntValue.high >>> 0).toNumber() : message.negativeIntValue;
                if (message.doubleValue != null && message.hasOwnProperty("doubleValue"))
                    object.doubleValue = options.json && !isFinite(message.doubleValue) ? String(message.doubleValue) : message.doubleValue;
                if (message.stringValue != null && message.hasOwnProperty("stringValue"))
                    object.stringValue = options.bytes === String ? $util.base64.encode(message.stringValue, 0, message.stringValue.length) : options.bytes === Array ? Array.prototype.slice.call(message.stringValue) : message.stringValue;
                if (message.aggregateValue != null && message.hasOwnProperty("aggregateValue"))
                    object.aggregateValue = message.aggregateValue;
                return object;
            };

            /**
             * Converts this UninterpretedOption to JSON.
             * @function toJSON
             * @memberof google.protobuf.UninterpretedOption
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            UninterpretedOption.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            UninterpretedOption.NamePart = (function() {

                /**
                 * Properties of a NamePart.
                 * @memberof google.protobuf.UninterpretedOption
                 * @interface INamePart
                 * @property {string} namePart NamePart namePart
                 * @property {boolean} isExtension NamePart isExtension
                 */

                /**
                 * Constructs a new NamePart.
                 * @memberof google.protobuf.UninterpretedOption
                 * @classdesc Represents a NamePart.
                 * @implements INamePart
                 * @constructor
                 * @param {google.protobuf.UninterpretedOption.INamePart=} [properties] Properties to set
                 */
                function NamePart(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }

                /**
                 * NamePart namePart.
                 * @member {string} namePart
                 * @memberof google.protobuf.UninterpretedOption.NamePart
                 * @instance
                 */
                NamePart.prototype.namePart = "";

                /**
                 * NamePart isExtension.
                 * @member {boolean} isExtension
                 * @memberof google.protobuf.UninterpretedOption.NamePart
                 * @instance
                 */
                NamePart.prototype.isExtension = false;

                /**
                 * Creates a new NamePart instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.UninterpretedOption.NamePart
                 * @static
                 * @param {google.protobuf.UninterpretedOption.INamePart=} [properties] Properties to set
                 * @returns {google.protobuf.UninterpretedOption.NamePart} NamePart instance
                 */
                NamePart.create = function create(properties) {
                    return new NamePart(properties);
                };

                /**
                 * Encodes the specified NamePart message. Does not implicitly {@link google.protobuf.UninterpretedOption.NamePart.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.UninterpretedOption.NamePart
                 * @static
                 * @param {google.protobuf.UninterpretedOption.INamePart} message NamePart message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                NamePart.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.namePart);
                    writer.uint32(/* id 2, wireType 0 =*/16).bool(message.isExtension);
                    return writer;
                };

                /**
                 * Encodes the specified NamePart message, length delimited. Does not implicitly {@link google.protobuf.UninterpretedOption.NamePart.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.UninterpretedOption.NamePart
                 * @static
                 * @param {google.protobuf.UninterpretedOption.INamePart} message NamePart message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                NamePart.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };

                /**
                 * Decodes a NamePart message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.UninterpretedOption.NamePart
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.UninterpretedOption.NamePart} NamePart
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                NamePart.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.UninterpretedOption.NamePart();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1:
                            message.namePart = reader.string();
                            break;
                        case 2:
                            message.isExtension = reader.bool();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    if (!message.hasOwnProperty("namePart"))
                        throw $util.ProtocolError("missing required 'namePart'", { instance: message });
                    if (!message.hasOwnProperty("isExtension"))
                        throw $util.ProtocolError("missing required 'isExtension'", { instance: message });
                    return message;
                };

                /**
                 * Decodes a NamePart message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.UninterpretedOption.NamePart
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.UninterpretedOption.NamePart} NamePart
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                NamePart.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };

                /**
                 * Verifies a NamePart message.
                 * @function verify
                 * @memberof google.protobuf.UninterpretedOption.NamePart
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                NamePart.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (!$util.isString(message.namePart))
                        return "namePart: string expected";
                    if (typeof message.isExtension !== "boolean")
                        return "isExtension: boolean expected";
                    return null;
                };

                /**
                 * Creates a NamePart message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.UninterpretedOption.NamePart
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.UninterpretedOption.NamePart} NamePart
                 */
                NamePart.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.UninterpretedOption.NamePart)
                        return object;
                    var message = new $root.google.protobuf.UninterpretedOption.NamePart();
                    if (object.namePart != null)
                        message.namePart = String(object.namePart);
                    if (object.isExtension != null)
                        message.isExtension = Boolean(object.isExtension);
                    return message;
                };

                /**
                 * Creates a plain object from a NamePart message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.UninterpretedOption.NamePart
                 * @static
                 * @param {google.protobuf.UninterpretedOption.NamePart} message NamePart
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                NamePart.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.namePart = "";
                        object.isExtension = false;
                    }
                    if (message.namePart != null && message.hasOwnProperty("namePart"))
                        object.namePart = message.namePart;
                    if (message.isExtension != null && message.hasOwnProperty("isExtension"))
                        object.isExtension = message.isExtension;
                    return object;
                };

                /**
                 * Converts this NamePart to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.UninterpretedOption.NamePart
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                NamePart.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };

                return NamePart;
            })();

            return UninterpretedOption;
        })();

        protobuf.SourceCodeInfo = (function() {

            /**
             * Properties of a SourceCodeInfo.
             * @memberof google.protobuf
             * @interface ISourceCodeInfo
             * @property {Array.<google.protobuf.SourceCodeInfo.ILocation>|null} [location] SourceCodeInfo location
             */

            /**
             * Constructs a new SourceCodeInfo.
             * @memberof google.protobuf
             * @classdesc Represents a SourceCodeInfo.
             * @implements ISourceCodeInfo
             * @constructor
             * @param {google.protobuf.ISourceCodeInfo=} [properties] Properties to set
             */
            function SourceCodeInfo(properties) {
                this.location = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * SourceCodeInfo location.
             * @member {Array.<google.protobuf.SourceCodeInfo.ILocation>} location
             * @memberof google.protobuf.SourceCodeInfo
             * @instance
             */
            SourceCodeInfo.prototype.location = $util.emptyArray;

            /**
             * Creates a new SourceCodeInfo instance using the specified properties.
             * @function create
             * @memberof google.protobuf.SourceCodeInfo
             * @static
             * @param {google.protobuf.ISourceCodeInfo=} [properties] Properties to set
             * @returns {google.protobuf.SourceCodeInfo} SourceCodeInfo instance
             */
            SourceCodeInfo.create = function create(properties) {
                return new SourceCodeInfo(properties);
            };

            /**
             * Encodes the specified SourceCodeInfo message. Does not implicitly {@link google.protobuf.SourceCodeInfo.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.SourceCodeInfo
             * @static
             * @param {google.protobuf.ISourceCodeInfo} message SourceCodeInfo message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            SourceCodeInfo.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.location != null && message.location.length)
                    for (var i = 0; i < message.location.length; ++i)
                        $root.google.protobuf.SourceCodeInfo.Location.encode(message.location[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified SourceCodeInfo message, length delimited. Does not implicitly {@link google.protobuf.SourceCodeInfo.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.SourceCodeInfo
             * @static
             * @param {google.protobuf.ISourceCodeInfo} message SourceCodeInfo message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            SourceCodeInfo.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a SourceCodeInfo message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.SourceCodeInfo
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.SourceCodeInfo} SourceCodeInfo
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            SourceCodeInfo.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.SourceCodeInfo();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        if (!(message.location && message.location.length))
                            message.location = [];
                        message.location.push($root.google.protobuf.SourceCodeInfo.Location.decode(reader, reader.uint32()));
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a SourceCodeInfo message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.SourceCodeInfo
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.SourceCodeInfo} SourceCodeInfo
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            SourceCodeInfo.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a SourceCodeInfo message.
             * @function verify
             * @memberof google.protobuf.SourceCodeInfo
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            SourceCodeInfo.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.location != null && message.hasOwnProperty("location")) {
                    if (!Array.isArray(message.location))
                        return "location: array expected";
                    for (var i = 0; i < message.location.length; ++i) {
                        var error = $root.google.protobuf.SourceCodeInfo.Location.verify(message.location[i]);
                        if (error)
                            return "location." + error;
                    }
                }
                return null;
            };

            /**
             * Creates a SourceCodeInfo message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.SourceCodeInfo
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.SourceCodeInfo} SourceCodeInfo
             */
            SourceCodeInfo.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.SourceCodeInfo)
                    return object;
                var message = new $root.google.protobuf.SourceCodeInfo();
                if (object.location) {
                    if (!Array.isArray(object.location))
                        throw TypeError(".google.protobuf.SourceCodeInfo.location: array expected");
                    message.location = [];
                    for (var i = 0; i < object.location.length; ++i) {
                        if (typeof object.location[i] !== "object")
                            throw TypeError(".google.protobuf.SourceCodeInfo.location: object expected");
                        message.location[i] = $root.google.protobuf.SourceCodeInfo.Location.fromObject(object.location[i]);
                    }
                }
                return message;
            };

            /**
             * Creates a plain object from a SourceCodeInfo message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.SourceCodeInfo
             * @static
             * @param {google.protobuf.SourceCodeInfo} message SourceCodeInfo
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            SourceCodeInfo.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.location = [];
                if (message.location && message.location.length) {
                    object.location = [];
                    for (var j = 0; j < message.location.length; ++j)
                        object.location[j] = $root.google.protobuf.SourceCodeInfo.Location.toObject(message.location[j], options);
                }
                return object;
            };

            /**
             * Converts this SourceCodeInfo to JSON.
             * @function toJSON
             * @memberof google.protobuf.SourceCodeInfo
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            SourceCodeInfo.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            SourceCodeInfo.Location = (function() {

                /**
                 * Properties of a Location.
                 * @memberof google.protobuf.SourceCodeInfo
                 * @interface ILocation
                 * @property {Array.<number>|null} [path] Location path
                 * @property {Array.<number>|null} [span] Location span
                 * @property {string|null} [leadingComments] Location leadingComments
                 * @property {string|null} [trailingComments] Location trailingComments
                 * @property {Array.<string>|null} [leadingDetachedComments] Location leadingDetachedComments
                 */

                /**
                 * Constructs a new Location.
                 * @memberof google.protobuf.SourceCodeInfo
                 * @classdesc Represents a Location.
                 * @implements ILocation
                 * @constructor
                 * @param {google.protobuf.SourceCodeInfo.ILocation=} [properties] Properties to set
                 */
                function Location(properties) {
                    this.path = [];
                    this.span = [];
                    this.leadingDetachedComments = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }

                /**
                 * Location path.
                 * @member {Array.<number>} path
                 * @memberof google.protobuf.SourceCodeInfo.Location
                 * @instance
                 */
                Location.prototype.path = $util.emptyArray;

                /**
                 * Location span.
                 * @member {Array.<number>} span
                 * @memberof google.protobuf.SourceCodeInfo.Location
                 * @instance
                 */
                Location.prototype.span = $util.emptyArray;

                /**
                 * Location leadingComments.
                 * @member {string} leadingComments
                 * @memberof google.protobuf.SourceCodeInfo.Location
                 * @instance
                 */
                Location.prototype.leadingComments = "";

                /**
                 * Location trailingComments.
                 * @member {string} trailingComments
                 * @memberof google.protobuf.SourceCodeInfo.Location
                 * @instance
                 */
                Location.prototype.trailingComments = "";

                /**
                 * Location leadingDetachedComments.
                 * @member {Array.<string>} leadingDetachedComments
                 * @memberof google.protobuf.SourceCodeInfo.Location
                 * @instance
                 */
                Location.prototype.leadingDetachedComments = $util.emptyArray;

                /**
                 * Creates a new Location instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.SourceCodeInfo.Location
                 * @static
                 * @param {google.protobuf.SourceCodeInfo.ILocation=} [properties] Properties to set
                 * @returns {google.protobuf.SourceCodeInfo.Location} Location instance
                 */
                Location.create = function create(properties) {
                    return new Location(properties);
                };

                /**
                 * Encodes the specified Location message. Does not implicitly {@link google.protobuf.SourceCodeInfo.Location.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.SourceCodeInfo.Location
                 * @static
                 * @param {google.protobuf.SourceCodeInfo.ILocation} message Location message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Location.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.path != null && message.path.length) {
                        writer.uint32(/* id 1, wireType 2 =*/10).fork();
                        for (var i = 0; i < message.path.length; ++i)
                            writer.int32(message.path[i]);
                        writer.ldelim();
                    }
                    if (message.span != null && message.span.length) {
                        writer.uint32(/* id 2, wireType 2 =*/18).fork();
                        for (var i = 0; i < message.span.length; ++i)
                            writer.int32(message.span[i]);
                        writer.ldelim();
                    }
                    if (message.leadingComments != null && message.hasOwnProperty("leadingComments"))
                        writer.uint32(/* id 3, wireType 2 =*/26).string(message.leadingComments);
                    if (message.trailingComments != null && message.hasOwnProperty("trailingComments"))
                        writer.uint32(/* id 4, wireType 2 =*/34).string(message.trailingComments);
                    if (message.leadingDetachedComments != null && message.leadingDetachedComments.length)
                        for (var i = 0; i < message.leadingDetachedComments.length; ++i)
                            writer.uint32(/* id 6, wireType 2 =*/50).string(message.leadingDetachedComments[i]);
                    return writer;
                };

                /**
                 * Encodes the specified Location message, length delimited. Does not implicitly {@link google.protobuf.SourceCodeInfo.Location.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.SourceCodeInfo.Location
                 * @static
                 * @param {google.protobuf.SourceCodeInfo.ILocation} message Location message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Location.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };

                /**
                 * Decodes a Location message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.SourceCodeInfo.Location
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.SourceCodeInfo.Location} Location
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Location.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.SourceCodeInfo.Location();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1:
                            if (!(message.path && message.path.length))
                                message.path = [];
                            if ((tag & 7) === 2) {
                                var end2 = reader.uint32() + reader.pos;
                                while (reader.pos < end2)
                                    message.path.push(reader.int32());
                            } else
                                message.path.push(reader.int32());
                            break;
                        case 2:
                            if (!(message.span && message.span.length))
                                message.span = [];
                            if ((tag & 7) === 2) {
                                var end2 = reader.uint32() + reader.pos;
                                while (reader.pos < end2)
                                    message.span.push(reader.int32());
                            } else
                                message.span.push(reader.int32());
                            break;
                        case 3:
                            message.leadingComments = reader.string();
                            break;
                        case 4:
                            message.trailingComments = reader.string();
                            break;
                        case 6:
                            if (!(message.leadingDetachedComments && message.leadingDetachedComments.length))
                                message.leadingDetachedComments = [];
                            message.leadingDetachedComments.push(reader.string());
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };

                /**
                 * Decodes a Location message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.SourceCodeInfo.Location
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.SourceCodeInfo.Location} Location
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Location.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };

                /**
                 * Verifies a Location message.
                 * @function verify
                 * @memberof google.protobuf.SourceCodeInfo.Location
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                Location.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.path != null && message.hasOwnProperty("path")) {
                        if (!Array.isArray(message.path))
                            return "path: array expected";
                        for (var i = 0; i < message.path.length; ++i)
                            if (!$util.isInteger(message.path[i]))
                                return "path: integer[] expected";
                    }
                    if (message.span != null && message.hasOwnProperty("span")) {
                        if (!Array.isArray(message.span))
                            return "span: array expected";
                        for (var i = 0; i < message.span.length; ++i)
                            if (!$util.isInteger(message.span[i]))
                                return "span: integer[] expected";
                    }
                    if (message.leadingComments != null && message.hasOwnProperty("leadingComments"))
                        if (!$util.isString(message.leadingComments))
                            return "leadingComments: string expected";
                    if (message.trailingComments != null && message.hasOwnProperty("trailingComments"))
                        if (!$util.isString(message.trailingComments))
                            return "trailingComments: string expected";
                    if (message.leadingDetachedComments != null && message.hasOwnProperty("leadingDetachedComments")) {
                        if (!Array.isArray(message.leadingDetachedComments))
                            return "leadingDetachedComments: array expected";
                        for (var i = 0; i < message.leadingDetachedComments.length; ++i)
                            if (!$util.isString(message.leadingDetachedComments[i]))
                                return "leadingDetachedComments: string[] expected";
                    }
                    return null;
                };

                /**
                 * Creates a Location message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.SourceCodeInfo.Location
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.SourceCodeInfo.Location} Location
                 */
                Location.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.SourceCodeInfo.Location)
                        return object;
                    var message = new $root.google.protobuf.SourceCodeInfo.Location();
                    if (object.path) {
                        if (!Array.isArray(object.path))
                            throw TypeError(".google.protobuf.SourceCodeInfo.Location.path: array expected");
                        message.path = [];
                        for (var i = 0; i < object.path.length; ++i)
                            message.path[i] = object.path[i] | 0;
                    }
                    if (object.span) {
                        if (!Array.isArray(object.span))
                            throw TypeError(".google.protobuf.SourceCodeInfo.Location.span: array expected");
                        message.span = [];
                        for (var i = 0; i < object.span.length; ++i)
                            message.span[i] = object.span[i] | 0;
                    }
                    if (object.leadingComments != null)
                        message.leadingComments = String(object.leadingComments);
                    if (object.trailingComments != null)
                        message.trailingComments = String(object.trailingComments);
                    if (object.leadingDetachedComments) {
                        if (!Array.isArray(object.leadingDetachedComments))
                            throw TypeError(".google.protobuf.SourceCodeInfo.Location.leadingDetachedComments: array expected");
                        message.leadingDetachedComments = [];
                        for (var i = 0; i < object.leadingDetachedComments.length; ++i)
                            message.leadingDetachedComments[i] = String(object.leadingDetachedComments[i]);
                    }
                    return message;
                };

                /**
                 * Creates a plain object from a Location message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.SourceCodeInfo.Location
                 * @static
                 * @param {google.protobuf.SourceCodeInfo.Location} message Location
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                Location.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults) {
                        object.path = [];
                        object.span = [];
                        object.leadingDetachedComments = [];
                    }
                    if (options.defaults) {
                        object.leadingComments = "";
                        object.trailingComments = "";
                    }
                    if (message.path && message.path.length) {
                        object.path = [];
                        for (var j = 0; j < message.path.length; ++j)
                            object.path[j] = message.path[j];
                    }
                    if (message.span && message.span.length) {
                        object.span = [];
                        for (var j = 0; j < message.span.length; ++j)
                            object.span[j] = message.span[j];
                    }
                    if (message.leadingComments != null && message.hasOwnProperty("leadingComments"))
                        object.leadingComments = message.leadingComments;
                    if (message.trailingComments != null && message.hasOwnProperty("trailingComments"))
                        object.trailingComments = message.trailingComments;
                    if (message.leadingDetachedComments && message.leadingDetachedComments.length) {
                        object.leadingDetachedComments = [];
                        for (var j = 0; j < message.leadingDetachedComments.length; ++j)
                            object.leadingDetachedComments[j] = message.leadingDetachedComments[j];
                    }
                    return object;
                };

                /**
                 * Converts this Location to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.SourceCodeInfo.Location
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                Location.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };

                return Location;
            })();

            return SourceCodeInfo;
        })();

        protobuf.GeneratedCodeInfo = (function() {

            /**
             * Properties of a GeneratedCodeInfo.
             * @memberof google.protobuf
             * @interface IGeneratedCodeInfo
             * @property {Array.<google.protobuf.GeneratedCodeInfo.IAnnotation>|null} [annotation] GeneratedCodeInfo annotation
             */

            /**
             * Constructs a new GeneratedCodeInfo.
             * @memberof google.protobuf
             * @classdesc Represents a GeneratedCodeInfo.
             * @implements IGeneratedCodeInfo
             * @constructor
             * @param {google.protobuf.IGeneratedCodeInfo=} [properties] Properties to set
             */
            function GeneratedCodeInfo(properties) {
                this.annotation = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * GeneratedCodeInfo annotation.
             * @member {Array.<google.protobuf.GeneratedCodeInfo.IAnnotation>} annotation
             * @memberof google.protobuf.GeneratedCodeInfo
             * @instance
             */
            GeneratedCodeInfo.prototype.annotation = $util.emptyArray;

            /**
             * Creates a new GeneratedCodeInfo instance using the specified properties.
             * @function create
             * @memberof google.protobuf.GeneratedCodeInfo
             * @static
             * @param {google.protobuf.IGeneratedCodeInfo=} [properties] Properties to set
             * @returns {google.protobuf.GeneratedCodeInfo} GeneratedCodeInfo instance
             */
            GeneratedCodeInfo.create = function create(properties) {
                return new GeneratedCodeInfo(properties);
            };

            /**
             * Encodes the specified GeneratedCodeInfo message. Does not implicitly {@link google.protobuf.GeneratedCodeInfo.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.GeneratedCodeInfo
             * @static
             * @param {google.protobuf.IGeneratedCodeInfo} message GeneratedCodeInfo message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            GeneratedCodeInfo.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.annotation != null && message.annotation.length)
                    for (var i = 0; i < message.annotation.length; ++i)
                        $root.google.protobuf.GeneratedCodeInfo.Annotation.encode(message.annotation[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified GeneratedCodeInfo message, length delimited. Does not implicitly {@link google.protobuf.GeneratedCodeInfo.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.GeneratedCodeInfo
             * @static
             * @param {google.protobuf.IGeneratedCodeInfo} message GeneratedCodeInfo message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            GeneratedCodeInfo.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a GeneratedCodeInfo message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.GeneratedCodeInfo
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.GeneratedCodeInfo} GeneratedCodeInfo
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            GeneratedCodeInfo.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.GeneratedCodeInfo();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        if (!(message.annotation && message.annotation.length))
                            message.annotation = [];
                        message.annotation.push($root.google.protobuf.GeneratedCodeInfo.Annotation.decode(reader, reader.uint32()));
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a GeneratedCodeInfo message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.GeneratedCodeInfo
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.GeneratedCodeInfo} GeneratedCodeInfo
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            GeneratedCodeInfo.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a GeneratedCodeInfo message.
             * @function verify
             * @memberof google.protobuf.GeneratedCodeInfo
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            GeneratedCodeInfo.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.annotation != null && message.hasOwnProperty("annotation")) {
                    if (!Array.isArray(message.annotation))
                        return "annotation: array expected";
                    for (var i = 0; i < message.annotation.length; ++i) {
                        var error = $root.google.protobuf.GeneratedCodeInfo.Annotation.verify(message.annotation[i]);
                        if (error)
                            return "annotation." + error;
                    }
                }
                return null;
            };

            /**
             * Creates a GeneratedCodeInfo message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.GeneratedCodeInfo
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.GeneratedCodeInfo} GeneratedCodeInfo
             */
            GeneratedCodeInfo.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.GeneratedCodeInfo)
                    return object;
                var message = new $root.google.protobuf.GeneratedCodeInfo();
                if (object.annotation) {
                    if (!Array.isArray(object.annotation))
                        throw TypeError(".google.protobuf.GeneratedCodeInfo.annotation: array expected");
                    message.annotation = [];
                    for (var i = 0; i < object.annotation.length; ++i) {
                        if (typeof object.annotation[i] !== "object")
                            throw TypeError(".google.protobuf.GeneratedCodeInfo.annotation: object expected");
                        message.annotation[i] = $root.google.protobuf.GeneratedCodeInfo.Annotation.fromObject(object.annotation[i]);
                    }
                }
                return message;
            };

            /**
             * Creates a plain object from a GeneratedCodeInfo message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.GeneratedCodeInfo
             * @static
             * @param {google.protobuf.GeneratedCodeInfo} message GeneratedCodeInfo
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            GeneratedCodeInfo.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.annotation = [];
                if (message.annotation && message.annotation.length) {
                    object.annotation = [];
                    for (var j = 0; j < message.annotation.length; ++j)
                        object.annotation[j] = $root.google.protobuf.GeneratedCodeInfo.Annotation.toObject(message.annotation[j], options);
                }
                return object;
            };

            /**
             * Converts this GeneratedCodeInfo to JSON.
             * @function toJSON
             * @memberof google.protobuf.GeneratedCodeInfo
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            GeneratedCodeInfo.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            GeneratedCodeInfo.Annotation = (function() {

                /**
                 * Properties of an Annotation.
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @interface IAnnotation
                 * @property {Array.<number>|null} [path] Annotation path
                 * @property {string|null} [sourceFile] Annotation sourceFile
                 * @property {number|null} [begin] Annotation begin
                 * @property {number|null} [end] Annotation end
                 */

                /**
                 * Constructs a new Annotation.
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @classdesc Represents an Annotation.
                 * @implements IAnnotation
                 * @constructor
                 * @param {google.protobuf.GeneratedCodeInfo.IAnnotation=} [properties] Properties to set
                 */
                function Annotation(properties) {
                    this.path = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }

                /**
                 * Annotation path.
                 * @member {Array.<number>} path
                 * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                 * @instance
                 */
                Annotation.prototype.path = $util.emptyArray;

                /**
                 * Annotation sourceFile.
                 * @member {string} sourceFile
                 * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                 * @instance
                 */
                Annotation.prototype.sourceFile = "";

                /**
                 * Annotation begin.
                 * @member {number} begin
                 * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                 * @instance
                 */
                Annotation.prototype.begin = 0;

                /**
                 * Annotation end.
                 * @member {number} end
                 * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                 * @instance
                 */
                Annotation.prototype.end = 0;

                /**
                 * Creates a new Annotation instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                 * @static
                 * @param {google.protobuf.GeneratedCodeInfo.IAnnotation=} [properties] Properties to set
                 * @returns {google.protobuf.GeneratedCodeInfo.Annotation} Annotation instance
                 */
                Annotation.create = function create(properties) {
                    return new Annotation(properties);
                };

                /**
                 * Encodes the specified Annotation message. Does not implicitly {@link google.protobuf.GeneratedCodeInfo.Annotation.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                 * @static
                 * @param {google.protobuf.GeneratedCodeInfo.IAnnotation} message Annotation message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Annotation.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.path != null && message.path.length) {
                        writer.uint32(/* id 1, wireType 2 =*/10).fork();
                        for (var i = 0; i < message.path.length; ++i)
                            writer.int32(message.path[i]);
                        writer.ldelim();
                    }
                    if (message.sourceFile != null && message.hasOwnProperty("sourceFile"))
                        writer.uint32(/* id 2, wireType 2 =*/18).string(message.sourceFile);
                    if (message.begin != null && message.hasOwnProperty("begin"))
                        writer.uint32(/* id 3, wireType 0 =*/24).int32(message.begin);
                    if (message.end != null && message.hasOwnProperty("end"))
                        writer.uint32(/* id 4, wireType 0 =*/32).int32(message.end);
                    return writer;
                };

                /**
                 * Encodes the specified Annotation message, length delimited. Does not implicitly {@link google.protobuf.GeneratedCodeInfo.Annotation.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                 * @static
                 * @param {google.protobuf.GeneratedCodeInfo.IAnnotation} message Annotation message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Annotation.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };

                /**
                 * Decodes an Annotation message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.GeneratedCodeInfo.Annotation} Annotation
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Annotation.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.GeneratedCodeInfo.Annotation();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1:
                            if (!(message.path && message.path.length))
                                message.path = [];
                            if ((tag & 7) === 2) {
                                var end2 = reader.uint32() + reader.pos;
                                while (reader.pos < end2)
                                    message.path.push(reader.int32());
                            } else
                                message.path.push(reader.int32());
                            break;
                        case 2:
                            message.sourceFile = reader.string();
                            break;
                        case 3:
                            message.begin = reader.int32();
                            break;
                        case 4:
                            message.end = reader.int32();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };

                /**
                 * Decodes an Annotation message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.GeneratedCodeInfo.Annotation} Annotation
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Annotation.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };

                /**
                 * Verifies an Annotation message.
                 * @function verify
                 * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                Annotation.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.path != null && message.hasOwnProperty("path")) {
                        if (!Array.isArray(message.path))
                            return "path: array expected";
                        for (var i = 0; i < message.path.length; ++i)
                            if (!$util.isInteger(message.path[i]))
                                return "path: integer[] expected";
                    }
                    if (message.sourceFile != null && message.hasOwnProperty("sourceFile"))
                        if (!$util.isString(message.sourceFile))
                            return "sourceFile: string expected";
                    if (message.begin != null && message.hasOwnProperty("begin"))
                        if (!$util.isInteger(message.begin))
                            return "begin: integer expected";
                    if (message.end != null && message.hasOwnProperty("end"))
                        if (!$util.isInteger(message.end))
                            return "end: integer expected";
                    return null;
                };

                /**
                 * Creates an Annotation message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.GeneratedCodeInfo.Annotation} Annotation
                 */
                Annotation.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.GeneratedCodeInfo.Annotation)
                        return object;
                    var message = new $root.google.protobuf.GeneratedCodeInfo.Annotation();
                    if (object.path) {
                        if (!Array.isArray(object.path))
                            throw TypeError(".google.protobuf.GeneratedCodeInfo.Annotation.path: array expected");
                        message.path = [];
                        for (var i = 0; i < object.path.length; ++i)
                            message.path[i] = object.path[i] | 0;
                    }
                    if (object.sourceFile != null)
                        message.sourceFile = String(object.sourceFile);
                    if (object.begin != null)
                        message.begin = object.begin | 0;
                    if (object.end != null)
                        message.end = object.end | 0;
                    return message;
                };

                /**
                 * Creates a plain object from an Annotation message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                 * @static
                 * @param {google.protobuf.GeneratedCodeInfo.Annotation} message Annotation
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                Annotation.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.path = [];
                    if (options.defaults) {
                        object.sourceFile = "";
                        object.begin = 0;
                        object.end = 0;
                    }
                    if (message.path && message.path.length) {
                        object.path = [];
                        for (var j = 0; j < message.path.length; ++j)
                            object.path[j] = message.path[j];
                    }
                    if (message.sourceFile != null && message.hasOwnProperty("sourceFile"))
                        object.sourceFile = message.sourceFile;
                    if (message.begin != null && message.hasOwnProperty("begin"))
                        object.begin = message.begin;
                    if (message.end != null && message.hasOwnProperty("end"))
                        object.end = message.end;
                    return object;
                };

                /**
                 * Converts this Annotation to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                Annotation.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };

                return Annotation;
            })();

            return GeneratedCodeInfo;
        })();

        protobuf.Empty = (function() {

            /**
             * Properties of an Empty.
             * @memberof google.protobuf
             * @interface IEmpty
             */

            /**
             * Constructs a new Empty.
             * @memberof google.protobuf
             * @classdesc Represents an Empty.
             * @implements IEmpty
             * @constructor
             * @param {google.protobuf.IEmpty=} [properties] Properties to set
             */
            function Empty(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * Creates a new Empty instance using the specified properties.
             * @function create
             * @memberof google.protobuf.Empty
             * @static
             * @param {google.protobuf.IEmpty=} [properties] Properties to set
             * @returns {google.protobuf.Empty} Empty instance
             */
            Empty.create = function create(properties) {
                return new Empty(properties);
            };

            /**
             * Encodes the specified Empty message. Does not implicitly {@link google.protobuf.Empty.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.Empty
             * @static
             * @param {google.protobuf.IEmpty} message Empty message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Empty.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                return writer;
            };

            /**
             * Encodes the specified Empty message, length delimited. Does not implicitly {@link google.protobuf.Empty.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.Empty
             * @static
             * @param {google.protobuf.IEmpty} message Empty message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Empty.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes an Empty message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.Empty
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.Empty} Empty
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Empty.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.Empty();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes an Empty message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.Empty
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.Empty} Empty
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Empty.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies an Empty message.
             * @function verify
             * @memberof google.protobuf.Empty
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            Empty.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                return null;
            };

            /**
             * Creates an Empty message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.Empty
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.Empty} Empty
             */
            Empty.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.Empty)
                    return object;
                return new $root.google.protobuf.Empty();
            };

            /**
             * Creates a plain object from an Empty message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.Empty
             * @static
             * @param {google.protobuf.Empty} message Empty
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            Empty.toObject = function toObject() {
                return {};
            };

            /**
             * Converts this Empty to JSON.
             * @function toJSON
             * @memberof google.protobuf.Empty
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            Empty.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return Empty;
        })();

        protobuf.DoubleValue = (function() {

            /**
             * Properties of a DoubleValue.
             * @memberof google.protobuf
             * @interface IDoubleValue
             * @property {number|null} [value] DoubleValue value
             */

            /**
             * Constructs a new DoubleValue.
             * @memberof google.protobuf
             * @classdesc Represents a DoubleValue.
             * @implements IDoubleValue
             * @constructor
             * @param {google.protobuf.IDoubleValue=} [properties] Properties to set
             */
            function DoubleValue(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * DoubleValue value.
             * @member {number} value
             * @memberof google.protobuf.DoubleValue
             * @instance
             */
            DoubleValue.prototype.value = 0;

            /**
             * Creates a new DoubleValue instance using the specified properties.
             * @function create
             * @memberof google.protobuf.DoubleValue
             * @static
             * @param {google.protobuf.IDoubleValue=} [properties] Properties to set
             * @returns {google.protobuf.DoubleValue} DoubleValue instance
             */
            DoubleValue.create = function create(properties) {
                return new DoubleValue(properties);
            };

            /**
             * Encodes the specified DoubleValue message. Does not implicitly {@link google.protobuf.DoubleValue.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.DoubleValue
             * @static
             * @param {google.protobuf.IDoubleValue} message DoubleValue message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            DoubleValue.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.value != null && message.hasOwnProperty("value"))
                    writer.uint32(/* id 1, wireType 1 =*/9).double(message.value);
                return writer;
            };

            /**
             * Encodes the specified DoubleValue message, length delimited. Does not implicitly {@link google.protobuf.DoubleValue.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.DoubleValue
             * @static
             * @param {google.protobuf.IDoubleValue} message DoubleValue message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            DoubleValue.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a DoubleValue message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.DoubleValue
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.DoubleValue} DoubleValue
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            DoubleValue.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.DoubleValue();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.value = reader.double();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a DoubleValue message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.DoubleValue
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.DoubleValue} DoubleValue
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            DoubleValue.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a DoubleValue message.
             * @function verify
             * @memberof google.protobuf.DoubleValue
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            DoubleValue.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.value != null && message.hasOwnProperty("value"))
                    if (typeof message.value !== "number")
                        return "value: number expected";
                return null;
            };

            /**
             * Creates a DoubleValue message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.DoubleValue
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.DoubleValue} DoubleValue
             */
            DoubleValue.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.DoubleValue)
                    return object;
                var message = new $root.google.protobuf.DoubleValue();
                if (object.value != null)
                    message.value = Number(object.value);
                return message;
            };

            /**
             * Creates a plain object from a DoubleValue message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.DoubleValue
             * @static
             * @param {google.protobuf.DoubleValue} message DoubleValue
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            DoubleValue.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults)
                    object.value = 0;
                if (message.value != null && message.hasOwnProperty("value"))
                    object.value = options.json && !isFinite(message.value) ? String(message.value) : message.value;
                return object;
            };

            /**
             * Converts this DoubleValue to JSON.
             * @function toJSON
             * @memberof google.protobuf.DoubleValue
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            DoubleValue.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return DoubleValue;
        })();

        protobuf.FloatValue = (function() {

            /**
             * Properties of a FloatValue.
             * @memberof google.protobuf
             * @interface IFloatValue
             * @property {number|null} [value] FloatValue value
             */

            /**
             * Constructs a new FloatValue.
             * @memberof google.protobuf
             * @classdesc Represents a FloatValue.
             * @implements IFloatValue
             * @constructor
             * @param {google.protobuf.IFloatValue=} [properties] Properties to set
             */
            function FloatValue(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * FloatValue value.
             * @member {number} value
             * @memberof google.protobuf.FloatValue
             * @instance
             */
            FloatValue.prototype.value = 0;

            /**
             * Creates a new FloatValue instance using the specified properties.
             * @function create
             * @memberof google.protobuf.FloatValue
             * @static
             * @param {google.protobuf.IFloatValue=} [properties] Properties to set
             * @returns {google.protobuf.FloatValue} FloatValue instance
             */
            FloatValue.create = function create(properties) {
                return new FloatValue(properties);
            };

            /**
             * Encodes the specified FloatValue message. Does not implicitly {@link google.protobuf.FloatValue.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.FloatValue
             * @static
             * @param {google.protobuf.IFloatValue} message FloatValue message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            FloatValue.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.value != null && message.hasOwnProperty("value"))
                    writer.uint32(/* id 1, wireType 5 =*/13).float(message.value);
                return writer;
            };

            /**
             * Encodes the specified FloatValue message, length delimited. Does not implicitly {@link google.protobuf.FloatValue.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.FloatValue
             * @static
             * @param {google.protobuf.IFloatValue} message FloatValue message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            FloatValue.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a FloatValue message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.FloatValue
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.FloatValue} FloatValue
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            FloatValue.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FloatValue();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.value = reader.float();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a FloatValue message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.FloatValue
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.FloatValue} FloatValue
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            FloatValue.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a FloatValue message.
             * @function verify
             * @memberof google.protobuf.FloatValue
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            FloatValue.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.value != null && message.hasOwnProperty("value"))
                    if (typeof message.value !== "number")
                        return "value: number expected";
                return null;
            };

            /**
             * Creates a FloatValue message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.FloatValue
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.FloatValue} FloatValue
             */
            FloatValue.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.FloatValue)
                    return object;
                var message = new $root.google.protobuf.FloatValue();
                if (object.value != null)
                    message.value = Number(object.value);
                return message;
            };

            /**
             * Creates a plain object from a FloatValue message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.FloatValue
             * @static
             * @param {google.protobuf.FloatValue} message FloatValue
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            FloatValue.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults)
                    object.value = 0;
                if (message.value != null && message.hasOwnProperty("value"))
                    object.value = options.json && !isFinite(message.value) ? String(message.value) : message.value;
                return object;
            };

            /**
             * Converts this FloatValue to JSON.
             * @function toJSON
             * @memberof google.protobuf.FloatValue
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            FloatValue.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return FloatValue;
        })();

        protobuf.Int64Value = (function() {

            /**
             * Properties of an Int64Value.
             * @memberof google.protobuf
             * @interface IInt64Value
             * @property {number|Long|null} [value] Int64Value value
             */

            /**
             * Constructs a new Int64Value.
             * @memberof google.protobuf
             * @classdesc Represents an Int64Value.
             * @implements IInt64Value
             * @constructor
             * @param {google.protobuf.IInt64Value=} [properties] Properties to set
             */
            function Int64Value(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * Int64Value value.
             * @member {number|Long} value
             * @memberof google.protobuf.Int64Value
             * @instance
             */
            Int64Value.prototype.value = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

            /**
             * Creates a new Int64Value instance using the specified properties.
             * @function create
             * @memberof google.protobuf.Int64Value
             * @static
             * @param {google.protobuf.IInt64Value=} [properties] Properties to set
             * @returns {google.protobuf.Int64Value} Int64Value instance
             */
            Int64Value.create = function create(properties) {
                return new Int64Value(properties);
            };

            /**
             * Encodes the specified Int64Value message. Does not implicitly {@link google.protobuf.Int64Value.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.Int64Value
             * @static
             * @param {google.protobuf.IInt64Value} message Int64Value message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Int64Value.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.value != null && message.hasOwnProperty("value"))
                    writer.uint32(/* id 1, wireType 0 =*/8).int64(message.value);
                return writer;
            };

            /**
             * Encodes the specified Int64Value message, length delimited. Does not implicitly {@link google.protobuf.Int64Value.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.Int64Value
             * @static
             * @param {google.protobuf.IInt64Value} message Int64Value message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Int64Value.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes an Int64Value message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.Int64Value
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.Int64Value} Int64Value
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Int64Value.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.Int64Value();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.value = reader.int64();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes an Int64Value message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.Int64Value
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.Int64Value} Int64Value
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Int64Value.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies an Int64Value message.
             * @function verify
             * @memberof google.protobuf.Int64Value
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            Int64Value.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.value != null && message.hasOwnProperty("value"))
                    if (!$util.isInteger(message.value) && !(message.value && $util.isInteger(message.value.low) && $util.isInteger(message.value.high)))
                        return "value: integer|Long expected";
                return null;
            };

            /**
             * Creates an Int64Value message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.Int64Value
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.Int64Value} Int64Value
             */
            Int64Value.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.Int64Value)
                    return object;
                var message = new $root.google.protobuf.Int64Value();
                if (object.value != null)
                    if ($util.Long)
                        (message.value = $util.Long.fromValue(object.value)).unsigned = false;
                    else if (typeof object.value === "string")
                        message.value = parseInt(object.value, 10);
                    else if (typeof object.value === "number")
                        message.value = object.value;
                    else if (typeof object.value === "object")
                        message.value = new $util.LongBits(object.value.low >>> 0, object.value.high >>> 0).toNumber();
                return message;
            };

            /**
             * Creates a plain object from an Int64Value message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.Int64Value
             * @static
             * @param {google.protobuf.Int64Value} message Int64Value
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            Int64Value.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults)
                    if ($util.Long) {
                        var long = new $util.Long(0, 0, false);
                        object.value = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                    } else
                        object.value = options.longs === String ? "0" : 0;
                if (message.value != null && message.hasOwnProperty("value"))
                    if (typeof message.value === "number")
                        object.value = options.longs === String ? String(message.value) : message.value;
                    else
                        object.value = options.longs === String ? $util.Long.prototype.toString.call(message.value) : options.longs === Number ? new $util.LongBits(message.value.low >>> 0, message.value.high >>> 0).toNumber() : message.value;
                return object;
            };

            /**
             * Converts this Int64Value to JSON.
             * @function toJSON
             * @memberof google.protobuf.Int64Value
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            Int64Value.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return Int64Value;
        })();

        protobuf.UInt64Value = (function() {

            /**
             * Properties of a UInt64Value.
             * @memberof google.protobuf
             * @interface IUInt64Value
             * @property {number|Long|null} [value] UInt64Value value
             */

            /**
             * Constructs a new UInt64Value.
             * @memberof google.protobuf
             * @classdesc Represents a UInt64Value.
             * @implements IUInt64Value
             * @constructor
             * @param {google.protobuf.IUInt64Value=} [properties] Properties to set
             */
            function UInt64Value(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * UInt64Value value.
             * @member {number|Long} value
             * @memberof google.protobuf.UInt64Value
             * @instance
             */
            UInt64Value.prototype.value = $util.Long ? $util.Long.fromBits(0,0,true) : 0;

            /**
             * Creates a new UInt64Value instance using the specified properties.
             * @function create
             * @memberof google.protobuf.UInt64Value
             * @static
             * @param {google.protobuf.IUInt64Value=} [properties] Properties to set
             * @returns {google.protobuf.UInt64Value} UInt64Value instance
             */
            UInt64Value.create = function create(properties) {
                return new UInt64Value(properties);
            };

            /**
             * Encodes the specified UInt64Value message. Does not implicitly {@link google.protobuf.UInt64Value.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.UInt64Value
             * @static
             * @param {google.protobuf.IUInt64Value} message UInt64Value message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            UInt64Value.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.value != null && message.hasOwnProperty("value"))
                    writer.uint32(/* id 1, wireType 0 =*/8).uint64(message.value);
                return writer;
            };

            /**
             * Encodes the specified UInt64Value message, length delimited. Does not implicitly {@link google.protobuf.UInt64Value.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.UInt64Value
             * @static
             * @param {google.protobuf.IUInt64Value} message UInt64Value message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            UInt64Value.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a UInt64Value message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.UInt64Value
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.UInt64Value} UInt64Value
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            UInt64Value.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.UInt64Value();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.value = reader.uint64();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a UInt64Value message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.UInt64Value
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.UInt64Value} UInt64Value
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            UInt64Value.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a UInt64Value message.
             * @function verify
             * @memberof google.protobuf.UInt64Value
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            UInt64Value.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.value != null && message.hasOwnProperty("value"))
                    if (!$util.isInteger(message.value) && !(message.value && $util.isInteger(message.value.low) && $util.isInteger(message.value.high)))
                        return "value: integer|Long expected";
                return null;
            };

            /**
             * Creates a UInt64Value message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.UInt64Value
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.UInt64Value} UInt64Value
             */
            UInt64Value.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.UInt64Value)
                    return object;
                var message = new $root.google.protobuf.UInt64Value();
                if (object.value != null)
                    if ($util.Long)
                        (message.value = $util.Long.fromValue(object.value)).unsigned = true;
                    else if (typeof object.value === "string")
                        message.value = parseInt(object.value, 10);
                    else if (typeof object.value === "number")
                        message.value = object.value;
                    else if (typeof object.value === "object")
                        message.value = new $util.LongBits(object.value.low >>> 0, object.value.high >>> 0).toNumber(true);
                return message;
            };

            /**
             * Creates a plain object from a UInt64Value message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.UInt64Value
             * @static
             * @param {google.protobuf.UInt64Value} message UInt64Value
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            UInt64Value.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults)
                    if ($util.Long) {
                        var long = new $util.Long(0, 0, true);
                        object.value = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                    } else
                        object.value = options.longs === String ? "0" : 0;
                if (message.value != null && message.hasOwnProperty("value"))
                    if (typeof message.value === "number")
                        object.value = options.longs === String ? String(message.value) : message.value;
                    else
                        object.value = options.longs === String ? $util.Long.prototype.toString.call(message.value) : options.longs === Number ? new $util.LongBits(message.value.low >>> 0, message.value.high >>> 0).toNumber(true) : message.value;
                return object;
            };

            /**
             * Converts this UInt64Value to JSON.
             * @function toJSON
             * @memberof google.protobuf.UInt64Value
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            UInt64Value.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return UInt64Value;
        })();

        protobuf.Int32Value = (function() {

            /**
             * Properties of an Int32Value.
             * @memberof google.protobuf
             * @interface IInt32Value
             * @property {number|null} [value] Int32Value value
             */

            /**
             * Constructs a new Int32Value.
             * @memberof google.protobuf
             * @classdesc Represents an Int32Value.
             * @implements IInt32Value
             * @constructor
             * @param {google.protobuf.IInt32Value=} [properties] Properties to set
             */
            function Int32Value(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * Int32Value value.
             * @member {number} value
             * @memberof google.protobuf.Int32Value
             * @instance
             */
            Int32Value.prototype.value = 0;

            /**
             * Creates a new Int32Value instance using the specified properties.
             * @function create
             * @memberof google.protobuf.Int32Value
             * @static
             * @param {google.protobuf.IInt32Value=} [properties] Properties to set
             * @returns {google.protobuf.Int32Value} Int32Value instance
             */
            Int32Value.create = function create(properties) {
                return new Int32Value(properties);
            };

            /**
             * Encodes the specified Int32Value message. Does not implicitly {@link google.protobuf.Int32Value.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.Int32Value
             * @static
             * @param {google.protobuf.IInt32Value} message Int32Value message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Int32Value.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.value != null && message.hasOwnProperty("value"))
                    writer.uint32(/* id 1, wireType 0 =*/8).int32(message.value);
                return writer;
            };

            /**
             * Encodes the specified Int32Value message, length delimited. Does not implicitly {@link google.protobuf.Int32Value.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.Int32Value
             * @static
             * @param {google.protobuf.IInt32Value} message Int32Value message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Int32Value.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes an Int32Value message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.Int32Value
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.Int32Value} Int32Value
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Int32Value.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.Int32Value();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.value = reader.int32();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes an Int32Value message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.Int32Value
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.Int32Value} Int32Value
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Int32Value.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies an Int32Value message.
             * @function verify
             * @memberof google.protobuf.Int32Value
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            Int32Value.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.value != null && message.hasOwnProperty("value"))
                    if (!$util.isInteger(message.value))
                        return "value: integer expected";
                return null;
            };

            /**
             * Creates an Int32Value message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.Int32Value
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.Int32Value} Int32Value
             */
            Int32Value.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.Int32Value)
                    return object;
                var message = new $root.google.protobuf.Int32Value();
                if (object.value != null)
                    message.value = object.value | 0;
                return message;
            };

            /**
             * Creates a plain object from an Int32Value message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.Int32Value
             * @static
             * @param {google.protobuf.Int32Value} message Int32Value
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            Int32Value.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults)
                    object.value = 0;
                if (message.value != null && message.hasOwnProperty("value"))
                    object.value = message.value;
                return object;
            };

            /**
             * Converts this Int32Value to JSON.
             * @function toJSON
             * @memberof google.protobuf.Int32Value
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            Int32Value.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return Int32Value;
        })();

        protobuf.UInt32Value = (function() {

            /**
             * Properties of a UInt32Value.
             * @memberof google.protobuf
             * @interface IUInt32Value
             * @property {number|null} [value] UInt32Value value
             */

            /**
             * Constructs a new UInt32Value.
             * @memberof google.protobuf
             * @classdesc Represents a UInt32Value.
             * @implements IUInt32Value
             * @constructor
             * @param {google.protobuf.IUInt32Value=} [properties] Properties to set
             */
            function UInt32Value(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * UInt32Value value.
             * @member {number} value
             * @memberof google.protobuf.UInt32Value
             * @instance
             */
            UInt32Value.prototype.value = 0;

            /**
             * Creates a new UInt32Value instance using the specified properties.
             * @function create
             * @memberof google.protobuf.UInt32Value
             * @static
             * @param {google.protobuf.IUInt32Value=} [properties] Properties to set
             * @returns {google.protobuf.UInt32Value} UInt32Value instance
             */
            UInt32Value.create = function create(properties) {
                return new UInt32Value(properties);
            };

            /**
             * Encodes the specified UInt32Value message. Does not implicitly {@link google.protobuf.UInt32Value.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.UInt32Value
             * @static
             * @param {google.protobuf.IUInt32Value} message UInt32Value message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            UInt32Value.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.value != null && message.hasOwnProperty("value"))
                    writer.uint32(/* id 1, wireType 0 =*/8).uint32(message.value);
                return writer;
            };

            /**
             * Encodes the specified UInt32Value message, length delimited. Does not implicitly {@link google.protobuf.UInt32Value.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.UInt32Value
             * @static
             * @param {google.protobuf.IUInt32Value} message UInt32Value message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            UInt32Value.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a UInt32Value message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.UInt32Value
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.UInt32Value} UInt32Value
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            UInt32Value.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.UInt32Value();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.value = reader.uint32();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a UInt32Value message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.UInt32Value
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.UInt32Value} UInt32Value
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            UInt32Value.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a UInt32Value message.
             * @function verify
             * @memberof google.protobuf.UInt32Value
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            UInt32Value.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.value != null && message.hasOwnProperty("value"))
                    if (!$util.isInteger(message.value))
                        return "value: integer expected";
                return null;
            };

            /**
             * Creates a UInt32Value message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.UInt32Value
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.UInt32Value} UInt32Value
             */
            UInt32Value.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.UInt32Value)
                    return object;
                var message = new $root.google.protobuf.UInt32Value();
                if (object.value != null)
                    message.value = object.value >>> 0;
                return message;
            };

            /**
             * Creates a plain object from a UInt32Value message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.UInt32Value
             * @static
             * @param {google.protobuf.UInt32Value} message UInt32Value
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            UInt32Value.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults)
                    object.value = 0;
                if (message.value != null && message.hasOwnProperty("value"))
                    object.value = message.value;
                return object;
            };

            /**
             * Converts this UInt32Value to JSON.
             * @function toJSON
             * @memberof google.protobuf.UInt32Value
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            UInt32Value.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return UInt32Value;
        })();

        protobuf.BoolValue = (function() {

            /**
             * Properties of a BoolValue.
             * @memberof google.protobuf
             * @interface IBoolValue
             * @property {boolean|null} [value] BoolValue value
             */

            /**
             * Constructs a new BoolValue.
             * @memberof google.protobuf
             * @classdesc Represents a BoolValue.
             * @implements IBoolValue
             * @constructor
             * @param {google.protobuf.IBoolValue=} [properties] Properties to set
             */
            function BoolValue(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * BoolValue value.
             * @member {boolean} value
             * @memberof google.protobuf.BoolValue
             * @instance
             */
            BoolValue.prototype.value = false;

            /**
             * Creates a new BoolValue instance using the specified properties.
             * @function create
             * @memberof google.protobuf.BoolValue
             * @static
             * @param {google.protobuf.IBoolValue=} [properties] Properties to set
             * @returns {google.protobuf.BoolValue} BoolValue instance
             */
            BoolValue.create = function create(properties) {
                return new BoolValue(properties);
            };

            /**
             * Encodes the specified BoolValue message. Does not implicitly {@link google.protobuf.BoolValue.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.BoolValue
             * @static
             * @param {google.protobuf.IBoolValue} message BoolValue message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            BoolValue.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.value != null && message.hasOwnProperty("value"))
                    writer.uint32(/* id 1, wireType 0 =*/8).bool(message.value);
                return writer;
            };

            /**
             * Encodes the specified BoolValue message, length delimited. Does not implicitly {@link google.protobuf.BoolValue.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.BoolValue
             * @static
             * @param {google.protobuf.IBoolValue} message BoolValue message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            BoolValue.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a BoolValue message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.BoolValue
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.BoolValue} BoolValue
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            BoolValue.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.BoolValue();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.value = reader.bool();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a BoolValue message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.BoolValue
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.BoolValue} BoolValue
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            BoolValue.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a BoolValue message.
             * @function verify
             * @memberof google.protobuf.BoolValue
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            BoolValue.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.value != null && message.hasOwnProperty("value"))
                    if (typeof message.value !== "boolean")
                        return "value: boolean expected";
                return null;
            };

            /**
             * Creates a BoolValue message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.BoolValue
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.BoolValue} BoolValue
             */
            BoolValue.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.BoolValue)
                    return object;
                var message = new $root.google.protobuf.BoolValue();
                if (object.value != null)
                    message.value = Boolean(object.value);
                return message;
            };

            /**
             * Creates a plain object from a BoolValue message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.BoolValue
             * @static
             * @param {google.protobuf.BoolValue} message BoolValue
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            BoolValue.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults)
                    object.value = false;
                if (message.value != null && message.hasOwnProperty("value"))
                    object.value = message.value;
                return object;
            };

            /**
             * Converts this BoolValue to JSON.
             * @function toJSON
             * @memberof google.protobuf.BoolValue
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            BoolValue.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return BoolValue;
        })();

        protobuf.StringValue = (function() {

            /**
             * Properties of a StringValue.
             * @memberof google.protobuf
             * @interface IStringValue
             * @property {string|null} [value] StringValue value
             */

            /**
             * Constructs a new StringValue.
             * @memberof google.protobuf
             * @classdesc Represents a StringValue.
             * @implements IStringValue
             * @constructor
             * @param {google.protobuf.IStringValue=} [properties] Properties to set
             */
            function StringValue(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * StringValue value.
             * @member {string} value
             * @memberof google.protobuf.StringValue
             * @instance
             */
            StringValue.prototype.value = "";

            /**
             * Creates a new StringValue instance using the specified properties.
             * @function create
             * @memberof google.protobuf.StringValue
             * @static
             * @param {google.protobuf.IStringValue=} [properties] Properties to set
             * @returns {google.protobuf.StringValue} StringValue instance
             */
            StringValue.create = function create(properties) {
                return new StringValue(properties);
            };

            /**
             * Encodes the specified StringValue message. Does not implicitly {@link google.protobuf.StringValue.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.StringValue
             * @static
             * @param {google.protobuf.IStringValue} message StringValue message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            StringValue.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.value != null && message.hasOwnProperty("value"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.value);
                return writer;
            };

            /**
             * Encodes the specified StringValue message, length delimited. Does not implicitly {@link google.protobuf.StringValue.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.StringValue
             * @static
             * @param {google.protobuf.IStringValue} message StringValue message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            StringValue.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a StringValue message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.StringValue
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.StringValue} StringValue
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            StringValue.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.StringValue();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.value = reader.string();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a StringValue message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.StringValue
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.StringValue} StringValue
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            StringValue.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a StringValue message.
             * @function verify
             * @memberof google.protobuf.StringValue
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            StringValue.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.value != null && message.hasOwnProperty("value"))
                    if (!$util.isString(message.value))
                        return "value: string expected";
                return null;
            };

            /**
             * Creates a StringValue message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.StringValue
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.StringValue} StringValue
             */
            StringValue.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.StringValue)
                    return object;
                var message = new $root.google.protobuf.StringValue();
                if (object.value != null)
                    message.value = String(object.value);
                return message;
            };

            /**
             * Creates a plain object from a StringValue message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.StringValue
             * @static
             * @param {google.protobuf.StringValue} message StringValue
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            StringValue.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults)
                    object.value = "";
                if (message.value != null && message.hasOwnProperty("value"))
                    object.value = message.value;
                return object;
            };

            /**
             * Converts this StringValue to JSON.
             * @function toJSON
             * @memberof google.protobuf.StringValue
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            StringValue.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return StringValue;
        })();

        protobuf.BytesValue = (function() {

            /**
             * Properties of a BytesValue.
             * @memberof google.protobuf
             * @interface IBytesValue
             * @property {Uint8Array|null} [value] BytesValue value
             */

            /**
             * Constructs a new BytesValue.
             * @memberof google.protobuf
             * @classdesc Represents a BytesValue.
             * @implements IBytesValue
             * @constructor
             * @param {google.protobuf.IBytesValue=} [properties] Properties to set
             */
            function BytesValue(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * BytesValue value.
             * @member {Uint8Array} value
             * @memberof google.protobuf.BytesValue
             * @instance
             */
            BytesValue.prototype.value = $util.newBuffer([]);

            /**
             * Creates a new BytesValue instance using the specified properties.
             * @function create
             * @memberof google.protobuf.BytesValue
             * @static
             * @param {google.protobuf.IBytesValue=} [properties] Properties to set
             * @returns {google.protobuf.BytesValue} BytesValue instance
             */
            BytesValue.create = function create(properties) {
                return new BytesValue(properties);
            };

            /**
             * Encodes the specified BytesValue message. Does not implicitly {@link google.protobuf.BytesValue.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.BytesValue
             * @static
             * @param {google.protobuf.IBytesValue} message BytesValue message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            BytesValue.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.value != null && message.hasOwnProperty("value"))
                    writer.uint32(/* id 1, wireType 2 =*/10).bytes(message.value);
                return writer;
            };

            /**
             * Encodes the specified BytesValue message, length delimited. Does not implicitly {@link google.protobuf.BytesValue.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.BytesValue
             * @static
             * @param {google.protobuf.IBytesValue} message BytesValue message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            BytesValue.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a BytesValue message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.BytesValue
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.BytesValue} BytesValue
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            BytesValue.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.BytesValue();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.value = reader.bytes();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a BytesValue message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.BytesValue
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.BytesValue} BytesValue
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            BytesValue.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a BytesValue message.
             * @function verify
             * @memberof google.protobuf.BytesValue
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            BytesValue.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.value != null && message.hasOwnProperty("value"))
                    if (!(message.value && typeof message.value.length === "number" || $util.isString(message.value)))
                        return "value: buffer expected";
                return null;
            };

            /**
             * Creates a BytesValue message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.BytesValue
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.BytesValue} BytesValue
             */
            BytesValue.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.BytesValue)
                    return object;
                var message = new $root.google.protobuf.BytesValue();
                if (object.value != null)
                    if (typeof object.value === "string")
                        $util.base64.decode(object.value, message.value = $util.newBuffer($util.base64.length(object.value)), 0);
                    else if (object.value.length)
                        message.value = object.value;
                return message;
            };

            /**
             * Creates a plain object from a BytesValue message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.BytesValue
             * @static
             * @param {google.protobuf.BytesValue} message BytesValue
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            BytesValue.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults)
                    if (options.bytes === String)
                        object.value = "";
                    else {
                        object.value = [];
                        if (options.bytes !== Array)
                            object.value = $util.newBuffer(object.value);
                    }
                if (message.value != null && message.hasOwnProperty("value"))
                    object.value = options.bytes === String ? $util.base64.encode(message.value, 0, message.value.length) : options.bytes === Array ? Array.prototype.slice.call(message.value) : message.value;
                return object;
            };

            /**
             * Converts this BytesValue to JSON.
             * @function toJSON
             * @memberof google.protobuf.BytesValue
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            BytesValue.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return BytesValue;
        })();

        protobuf.FieldMask = (function() {

            /**
             * Properties of a FieldMask.
             * @memberof google.protobuf
             * @interface IFieldMask
             * @property {Array.<string>|null} [paths] FieldMask paths
             */

            /**
             * Constructs a new FieldMask.
             * @memberof google.protobuf
             * @classdesc Represents a FieldMask.
             * @implements IFieldMask
             * @constructor
             * @param {google.protobuf.IFieldMask=} [properties] Properties to set
             */
            function FieldMask(properties) {
                this.paths = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * FieldMask paths.
             * @member {Array.<string>} paths
             * @memberof google.protobuf.FieldMask
             * @instance
             */
            FieldMask.prototype.paths = $util.emptyArray;

            /**
             * Creates a new FieldMask instance using the specified properties.
             * @function create
             * @memberof google.protobuf.FieldMask
             * @static
             * @param {google.protobuf.IFieldMask=} [properties] Properties to set
             * @returns {google.protobuf.FieldMask} FieldMask instance
             */
            FieldMask.create = function create(properties) {
                return new FieldMask(properties);
            };

            /**
             * Encodes the specified FieldMask message. Does not implicitly {@link google.protobuf.FieldMask.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.FieldMask
             * @static
             * @param {google.protobuf.IFieldMask} message FieldMask message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            FieldMask.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.paths != null && message.paths.length)
                    for (var i = 0; i < message.paths.length; ++i)
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.paths[i]);
                return writer;
            };

            /**
             * Encodes the specified FieldMask message, length delimited. Does not implicitly {@link google.protobuf.FieldMask.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.FieldMask
             * @static
             * @param {google.protobuf.IFieldMask} message FieldMask message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            FieldMask.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a FieldMask message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.FieldMask
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.FieldMask} FieldMask
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            FieldMask.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FieldMask();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        if (!(message.paths && message.paths.length))
                            message.paths = [];
                        message.paths.push(reader.string());
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a FieldMask message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.FieldMask
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.FieldMask} FieldMask
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            FieldMask.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a FieldMask message.
             * @function verify
             * @memberof google.protobuf.FieldMask
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            FieldMask.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.paths != null && message.hasOwnProperty("paths")) {
                    if (!Array.isArray(message.paths))
                        return "paths: array expected";
                    for (var i = 0; i < message.paths.length; ++i)
                        if (!$util.isString(message.paths[i]))
                            return "paths: string[] expected";
                }
                return null;
            };

            /**
             * Creates a FieldMask message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.FieldMask
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.FieldMask} FieldMask
             */
            FieldMask.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.FieldMask)
                    return object;
                var message = new $root.google.protobuf.FieldMask();
                if (object.paths) {
                    if (!Array.isArray(object.paths))
                        throw TypeError(".google.protobuf.FieldMask.paths: array expected");
                    message.paths = [];
                    for (var i = 0; i < object.paths.length; ++i)
                        message.paths[i] = String(object.paths[i]);
                }
                return message;
            };

            /**
             * Creates a plain object from a FieldMask message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.FieldMask
             * @static
             * @param {google.protobuf.FieldMask} message FieldMask
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            FieldMask.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.paths = [];
                if (message.paths && message.paths.length) {
                    object.paths = [];
                    for (var j = 0; j < message.paths.length; ++j)
                        object.paths[j] = message.paths[j];
                }
                return object;
            };

            /**
             * Converts this FieldMask to JSON.
             * @function toJSON
             * @memberof google.protobuf.FieldMask
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            FieldMask.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return FieldMask;
        })();

        return protobuf;
    })();

    google.rpc = (function() {

        /**
         * Namespace rpc.
         * @memberof google
         * @namespace
         */
        var rpc = {};

        /**
         * Code enum.
         * @name google.rpc.Code
         * @enum {string}
         * @property {number} OK=0 OK value
         * @property {number} CANCELLED=1 CANCELLED value
         * @property {number} UNKNOWN=2 UNKNOWN value
         * @property {number} INVALID_ARGUMENT=3 INVALID_ARGUMENT value
         * @property {number} DEADLINE_EXCEEDED=4 DEADLINE_EXCEEDED value
         * @property {number} NOT_FOUND=5 NOT_FOUND value
         * @property {number} ALREADY_EXISTS=6 ALREADY_EXISTS value
         * @property {number} PERMISSION_DENIED=7 PERMISSION_DENIED value
         * @property {number} UNAUTHENTICATED=16 UNAUTHENTICATED value
         * @property {number} RESOURCE_EXHAUSTED=8 RESOURCE_EXHAUSTED value
         * @property {number} FAILED_PRECONDITION=9 FAILED_PRECONDITION value
         * @property {number} ABORTED=10 ABORTED value
         * @property {number} OUT_OF_RANGE=11 OUT_OF_RANGE value
         * @property {number} UNIMPLEMENTED=12 UNIMPLEMENTED value
         * @property {number} INTERNAL=13 INTERNAL value
         * @property {number} UNAVAILABLE=14 UNAVAILABLE value
         * @property {number} DATA_LOSS=15 DATA_LOSS value
         */
        rpc.Code = (function() {
            var valuesById = {}, values = Object.create(valuesById);
            values[valuesById[0] = "OK"] = 0;
            values[valuesById[1] = "CANCELLED"] = 1;
            values[valuesById[2] = "UNKNOWN"] = 2;
            values[valuesById[3] = "INVALID_ARGUMENT"] = 3;
            values[valuesById[4] = "DEADLINE_EXCEEDED"] = 4;
            values[valuesById[5] = "NOT_FOUND"] = 5;
            values[valuesById[6] = "ALREADY_EXISTS"] = 6;
            values[valuesById[7] = "PERMISSION_DENIED"] = 7;
            values[valuesById[16] = "UNAUTHENTICATED"] = 16;
            values[valuesById[8] = "RESOURCE_EXHAUSTED"] = 8;
            values[valuesById[9] = "FAILED_PRECONDITION"] = 9;
            values[valuesById[10] = "ABORTED"] = 10;
            values[valuesById[11] = "OUT_OF_RANGE"] = 11;
            values[valuesById[12] = "UNIMPLEMENTED"] = 12;
            values[valuesById[13] = "INTERNAL"] = 13;
            values[valuesById[14] = "UNAVAILABLE"] = 14;
            values[valuesById[15] = "DATA_LOSS"] = 15;
            return values;
        })();

        rpc.RetryInfo = (function() {

            /**
             * Properties of a RetryInfo.
             * @memberof google.rpc
             * @interface IRetryInfo
             * @property {google.protobuf.IDuration|null} [retryDelay] RetryInfo retryDelay
             */

            /**
             * Constructs a new RetryInfo.
             * @memberof google.rpc
             * @classdesc Represents a RetryInfo.
             * @implements IRetryInfo
             * @constructor
             * @param {google.rpc.IRetryInfo=} [properties] Properties to set
             */
            function RetryInfo(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * RetryInfo retryDelay.
             * @member {google.protobuf.IDuration|null|undefined} retryDelay
             * @memberof google.rpc.RetryInfo
             * @instance
             */
            RetryInfo.prototype.retryDelay = null;

            /**
             * Creates a new RetryInfo instance using the specified properties.
             * @function create
             * @memberof google.rpc.RetryInfo
             * @static
             * @param {google.rpc.IRetryInfo=} [properties] Properties to set
             * @returns {google.rpc.RetryInfo} RetryInfo instance
             */
            RetryInfo.create = function create(properties) {
                return new RetryInfo(properties);
            };

            /**
             * Encodes the specified RetryInfo message. Does not implicitly {@link google.rpc.RetryInfo.verify|verify} messages.
             * @function encode
             * @memberof google.rpc.RetryInfo
             * @static
             * @param {google.rpc.IRetryInfo} message RetryInfo message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            RetryInfo.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.retryDelay != null && message.hasOwnProperty("retryDelay"))
                    $root.google.protobuf.Duration.encode(message.retryDelay, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified RetryInfo message, length delimited. Does not implicitly {@link google.rpc.RetryInfo.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.rpc.RetryInfo
             * @static
             * @param {google.rpc.IRetryInfo} message RetryInfo message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            RetryInfo.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a RetryInfo message from the specified reader or buffer.
             * @function decode
             * @memberof google.rpc.RetryInfo
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.rpc.RetryInfo} RetryInfo
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            RetryInfo.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.rpc.RetryInfo();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.retryDelay = $root.google.protobuf.Duration.decode(reader, reader.uint32());
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a RetryInfo message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.rpc.RetryInfo
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.rpc.RetryInfo} RetryInfo
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            RetryInfo.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a RetryInfo message.
             * @function verify
             * @memberof google.rpc.RetryInfo
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            RetryInfo.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.retryDelay != null && message.hasOwnProperty("retryDelay")) {
                    var error = $root.google.protobuf.Duration.verify(message.retryDelay);
                    if (error)
                        return "retryDelay." + error;
                }
                return null;
            };

            /**
             * Creates a RetryInfo message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.rpc.RetryInfo
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.rpc.RetryInfo} RetryInfo
             */
            RetryInfo.fromObject = function fromObject(object) {
                if (object instanceof $root.google.rpc.RetryInfo)
                    return object;
                var message = new $root.google.rpc.RetryInfo();
                if (object.retryDelay != null) {
                    if (typeof object.retryDelay !== "object")
                        throw TypeError(".google.rpc.RetryInfo.retryDelay: object expected");
                    message.retryDelay = $root.google.protobuf.Duration.fromObject(object.retryDelay);
                }
                return message;
            };

            /**
             * Creates a plain object from a RetryInfo message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.rpc.RetryInfo
             * @static
             * @param {google.rpc.RetryInfo} message RetryInfo
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            RetryInfo.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults)
                    object.retryDelay = null;
                if (message.retryDelay != null && message.hasOwnProperty("retryDelay"))
                    object.retryDelay = $root.google.protobuf.Duration.toObject(message.retryDelay, options);
                return object;
            };

            /**
             * Converts this RetryInfo to JSON.
             * @function toJSON
             * @memberof google.rpc.RetryInfo
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            RetryInfo.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return RetryInfo;
        })();

        rpc.DebugInfo = (function() {

            /**
             * Properties of a DebugInfo.
             * @memberof google.rpc
             * @interface IDebugInfo
             * @property {Array.<string>|null} [stackEntries] DebugInfo stackEntries
             * @property {string|null} [detail] DebugInfo detail
             */

            /**
             * Constructs a new DebugInfo.
             * @memberof google.rpc
             * @classdesc Represents a DebugInfo.
             * @implements IDebugInfo
             * @constructor
             * @param {google.rpc.IDebugInfo=} [properties] Properties to set
             */
            function DebugInfo(properties) {
                this.stackEntries = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * DebugInfo stackEntries.
             * @member {Array.<string>} stackEntries
             * @memberof google.rpc.DebugInfo
             * @instance
             */
            DebugInfo.prototype.stackEntries = $util.emptyArray;

            /**
             * DebugInfo detail.
             * @member {string} detail
             * @memberof google.rpc.DebugInfo
             * @instance
             */
            DebugInfo.prototype.detail = "";

            /**
             * Creates a new DebugInfo instance using the specified properties.
             * @function create
             * @memberof google.rpc.DebugInfo
             * @static
             * @param {google.rpc.IDebugInfo=} [properties] Properties to set
             * @returns {google.rpc.DebugInfo} DebugInfo instance
             */
            DebugInfo.create = function create(properties) {
                return new DebugInfo(properties);
            };

            /**
             * Encodes the specified DebugInfo message. Does not implicitly {@link google.rpc.DebugInfo.verify|verify} messages.
             * @function encode
             * @memberof google.rpc.DebugInfo
             * @static
             * @param {google.rpc.IDebugInfo} message DebugInfo message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            DebugInfo.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.stackEntries != null && message.stackEntries.length)
                    for (var i = 0; i < message.stackEntries.length; ++i)
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.stackEntries[i]);
                if (message.detail != null && message.hasOwnProperty("detail"))
                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.detail);
                return writer;
            };

            /**
             * Encodes the specified DebugInfo message, length delimited. Does not implicitly {@link google.rpc.DebugInfo.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.rpc.DebugInfo
             * @static
             * @param {google.rpc.IDebugInfo} message DebugInfo message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            DebugInfo.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a DebugInfo message from the specified reader or buffer.
             * @function decode
             * @memberof google.rpc.DebugInfo
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.rpc.DebugInfo} DebugInfo
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            DebugInfo.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.rpc.DebugInfo();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        if (!(message.stackEntries && message.stackEntries.length))
                            message.stackEntries = [];
                        message.stackEntries.push(reader.string());
                        break;
                    case 2:
                        message.detail = reader.string();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a DebugInfo message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.rpc.DebugInfo
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.rpc.DebugInfo} DebugInfo
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            DebugInfo.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a DebugInfo message.
             * @function verify
             * @memberof google.rpc.DebugInfo
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            DebugInfo.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.stackEntries != null && message.hasOwnProperty("stackEntries")) {
                    if (!Array.isArray(message.stackEntries))
                        return "stackEntries: array expected";
                    for (var i = 0; i < message.stackEntries.length; ++i)
                        if (!$util.isString(message.stackEntries[i]))
                            return "stackEntries: string[] expected";
                }
                if (message.detail != null && message.hasOwnProperty("detail"))
                    if (!$util.isString(message.detail))
                        return "detail: string expected";
                return null;
            };

            /**
             * Creates a DebugInfo message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.rpc.DebugInfo
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.rpc.DebugInfo} DebugInfo
             */
            DebugInfo.fromObject = function fromObject(object) {
                if (object instanceof $root.google.rpc.DebugInfo)
                    return object;
                var message = new $root.google.rpc.DebugInfo();
                if (object.stackEntries) {
                    if (!Array.isArray(object.stackEntries))
                        throw TypeError(".google.rpc.DebugInfo.stackEntries: array expected");
                    message.stackEntries = [];
                    for (var i = 0; i < object.stackEntries.length; ++i)
                        message.stackEntries[i] = String(object.stackEntries[i]);
                }
                if (object.detail != null)
                    message.detail = String(object.detail);
                return message;
            };

            /**
             * Creates a plain object from a DebugInfo message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.rpc.DebugInfo
             * @static
             * @param {google.rpc.DebugInfo} message DebugInfo
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            DebugInfo.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.stackEntries = [];
                if (options.defaults)
                    object.detail = "";
                if (message.stackEntries && message.stackEntries.length) {
                    object.stackEntries = [];
                    for (var j = 0; j < message.stackEntries.length; ++j)
                        object.stackEntries[j] = message.stackEntries[j];
                }
                if (message.detail != null && message.hasOwnProperty("detail"))
                    object.detail = message.detail;
                return object;
            };

            /**
             * Converts this DebugInfo to JSON.
             * @function toJSON
             * @memberof google.rpc.DebugInfo
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            DebugInfo.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return DebugInfo;
        })();

        rpc.QuotaFailure = (function() {

            /**
             * Properties of a QuotaFailure.
             * @memberof google.rpc
             * @interface IQuotaFailure
             * @property {Array.<google.rpc.QuotaFailure.IViolation>|null} [violations] QuotaFailure violations
             */

            /**
             * Constructs a new QuotaFailure.
             * @memberof google.rpc
             * @classdesc Represents a QuotaFailure.
             * @implements IQuotaFailure
             * @constructor
             * @param {google.rpc.IQuotaFailure=} [properties] Properties to set
             */
            function QuotaFailure(properties) {
                this.violations = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * QuotaFailure violations.
             * @member {Array.<google.rpc.QuotaFailure.IViolation>} violations
             * @memberof google.rpc.QuotaFailure
             * @instance
             */
            QuotaFailure.prototype.violations = $util.emptyArray;

            /**
             * Creates a new QuotaFailure instance using the specified properties.
             * @function create
             * @memberof google.rpc.QuotaFailure
             * @static
             * @param {google.rpc.IQuotaFailure=} [properties] Properties to set
             * @returns {google.rpc.QuotaFailure} QuotaFailure instance
             */
            QuotaFailure.create = function create(properties) {
                return new QuotaFailure(properties);
            };

            /**
             * Encodes the specified QuotaFailure message. Does not implicitly {@link google.rpc.QuotaFailure.verify|verify} messages.
             * @function encode
             * @memberof google.rpc.QuotaFailure
             * @static
             * @param {google.rpc.IQuotaFailure} message QuotaFailure message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            QuotaFailure.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.violations != null && message.violations.length)
                    for (var i = 0; i < message.violations.length; ++i)
                        $root.google.rpc.QuotaFailure.Violation.encode(message.violations[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified QuotaFailure message, length delimited. Does not implicitly {@link google.rpc.QuotaFailure.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.rpc.QuotaFailure
             * @static
             * @param {google.rpc.IQuotaFailure} message QuotaFailure message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            QuotaFailure.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a QuotaFailure message from the specified reader or buffer.
             * @function decode
             * @memberof google.rpc.QuotaFailure
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.rpc.QuotaFailure} QuotaFailure
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            QuotaFailure.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.rpc.QuotaFailure();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        if (!(message.violations && message.violations.length))
                            message.violations = [];
                        message.violations.push($root.google.rpc.QuotaFailure.Violation.decode(reader, reader.uint32()));
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a QuotaFailure message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.rpc.QuotaFailure
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.rpc.QuotaFailure} QuotaFailure
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            QuotaFailure.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a QuotaFailure message.
             * @function verify
             * @memberof google.rpc.QuotaFailure
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            QuotaFailure.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.violations != null && message.hasOwnProperty("violations")) {
                    if (!Array.isArray(message.violations))
                        return "violations: array expected";
                    for (var i = 0; i < message.violations.length; ++i) {
                        var error = $root.google.rpc.QuotaFailure.Violation.verify(message.violations[i]);
                        if (error)
                            return "violations." + error;
                    }
                }
                return null;
            };

            /**
             * Creates a QuotaFailure message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.rpc.QuotaFailure
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.rpc.QuotaFailure} QuotaFailure
             */
            QuotaFailure.fromObject = function fromObject(object) {
                if (object instanceof $root.google.rpc.QuotaFailure)
                    return object;
                var message = new $root.google.rpc.QuotaFailure();
                if (object.violations) {
                    if (!Array.isArray(object.violations))
                        throw TypeError(".google.rpc.QuotaFailure.violations: array expected");
                    message.violations = [];
                    for (var i = 0; i < object.violations.length; ++i) {
                        if (typeof object.violations[i] !== "object")
                            throw TypeError(".google.rpc.QuotaFailure.violations: object expected");
                        message.violations[i] = $root.google.rpc.QuotaFailure.Violation.fromObject(object.violations[i]);
                    }
                }
                return message;
            };

            /**
             * Creates a plain object from a QuotaFailure message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.rpc.QuotaFailure
             * @static
             * @param {google.rpc.QuotaFailure} message QuotaFailure
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            QuotaFailure.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.violations = [];
                if (message.violations && message.violations.length) {
                    object.violations = [];
                    for (var j = 0; j < message.violations.length; ++j)
                        object.violations[j] = $root.google.rpc.QuotaFailure.Violation.toObject(message.violations[j], options);
                }
                return object;
            };

            /**
             * Converts this QuotaFailure to JSON.
             * @function toJSON
             * @memberof google.rpc.QuotaFailure
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            QuotaFailure.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            QuotaFailure.Violation = (function() {

                /**
                 * Properties of a Violation.
                 * @memberof google.rpc.QuotaFailure
                 * @interface IViolation
                 * @property {string|null} [subject] Violation subject
                 * @property {string|null} [description] Violation description
                 */

                /**
                 * Constructs a new Violation.
                 * @memberof google.rpc.QuotaFailure
                 * @classdesc Represents a Violation.
                 * @implements IViolation
                 * @constructor
                 * @param {google.rpc.QuotaFailure.IViolation=} [properties] Properties to set
                 */
                function Violation(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }

                /**
                 * Violation subject.
                 * @member {string} subject
                 * @memberof google.rpc.QuotaFailure.Violation
                 * @instance
                 */
                Violation.prototype.subject = "";

                /**
                 * Violation description.
                 * @member {string} description
                 * @memberof google.rpc.QuotaFailure.Violation
                 * @instance
                 */
                Violation.prototype.description = "";

                /**
                 * Creates a new Violation instance using the specified properties.
                 * @function create
                 * @memberof google.rpc.QuotaFailure.Violation
                 * @static
                 * @param {google.rpc.QuotaFailure.IViolation=} [properties] Properties to set
                 * @returns {google.rpc.QuotaFailure.Violation} Violation instance
                 */
                Violation.create = function create(properties) {
                    return new Violation(properties);
                };

                /**
                 * Encodes the specified Violation message. Does not implicitly {@link google.rpc.QuotaFailure.Violation.verify|verify} messages.
                 * @function encode
                 * @memberof google.rpc.QuotaFailure.Violation
                 * @static
                 * @param {google.rpc.QuotaFailure.IViolation} message Violation message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Violation.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.subject != null && message.hasOwnProperty("subject"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.subject);
                    if (message.description != null && message.hasOwnProperty("description"))
                        writer.uint32(/* id 2, wireType 2 =*/18).string(message.description);
                    return writer;
                };

                /**
                 * Encodes the specified Violation message, length delimited. Does not implicitly {@link google.rpc.QuotaFailure.Violation.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.rpc.QuotaFailure.Violation
                 * @static
                 * @param {google.rpc.QuotaFailure.IViolation} message Violation message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Violation.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };

                /**
                 * Decodes a Violation message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.rpc.QuotaFailure.Violation
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.rpc.QuotaFailure.Violation} Violation
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Violation.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.rpc.QuotaFailure.Violation();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1:
                            message.subject = reader.string();
                            break;
                        case 2:
                            message.description = reader.string();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };

                /**
                 * Decodes a Violation message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.rpc.QuotaFailure.Violation
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.rpc.QuotaFailure.Violation} Violation
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Violation.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };

                /**
                 * Verifies a Violation message.
                 * @function verify
                 * @memberof google.rpc.QuotaFailure.Violation
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                Violation.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.subject != null && message.hasOwnProperty("subject"))
                        if (!$util.isString(message.subject))
                            return "subject: string expected";
                    if (message.description != null && message.hasOwnProperty("description"))
                        if (!$util.isString(message.description))
                            return "description: string expected";
                    return null;
                };

                /**
                 * Creates a Violation message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.rpc.QuotaFailure.Violation
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.rpc.QuotaFailure.Violation} Violation
                 */
                Violation.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.rpc.QuotaFailure.Violation)
                        return object;
                    var message = new $root.google.rpc.QuotaFailure.Violation();
                    if (object.subject != null)
                        message.subject = String(object.subject);
                    if (object.description != null)
                        message.description = String(object.description);
                    return message;
                };

                /**
                 * Creates a plain object from a Violation message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.rpc.QuotaFailure.Violation
                 * @static
                 * @param {google.rpc.QuotaFailure.Violation} message Violation
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                Violation.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.subject = "";
                        object.description = "";
                    }
                    if (message.subject != null && message.hasOwnProperty("subject"))
                        object.subject = message.subject;
                    if (message.description != null && message.hasOwnProperty("description"))
                        object.description = message.description;
                    return object;
                };

                /**
                 * Converts this Violation to JSON.
                 * @function toJSON
                 * @memberof google.rpc.QuotaFailure.Violation
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                Violation.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };

                return Violation;
            })();

            return QuotaFailure;
        })();

        rpc.PreconditionFailure = (function() {

            /**
             * Properties of a PreconditionFailure.
             * @memberof google.rpc
             * @interface IPreconditionFailure
             * @property {Array.<google.rpc.PreconditionFailure.IViolation>|null} [violations] PreconditionFailure violations
             */

            /**
             * Constructs a new PreconditionFailure.
             * @memberof google.rpc
             * @classdesc Represents a PreconditionFailure.
             * @implements IPreconditionFailure
             * @constructor
             * @param {google.rpc.IPreconditionFailure=} [properties] Properties to set
             */
            function PreconditionFailure(properties) {
                this.violations = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * PreconditionFailure violations.
             * @member {Array.<google.rpc.PreconditionFailure.IViolation>} violations
             * @memberof google.rpc.PreconditionFailure
             * @instance
             */
            PreconditionFailure.prototype.violations = $util.emptyArray;

            /**
             * Creates a new PreconditionFailure instance using the specified properties.
             * @function create
             * @memberof google.rpc.PreconditionFailure
             * @static
             * @param {google.rpc.IPreconditionFailure=} [properties] Properties to set
             * @returns {google.rpc.PreconditionFailure} PreconditionFailure instance
             */
            PreconditionFailure.create = function create(properties) {
                return new PreconditionFailure(properties);
            };

            /**
             * Encodes the specified PreconditionFailure message. Does not implicitly {@link google.rpc.PreconditionFailure.verify|verify} messages.
             * @function encode
             * @memberof google.rpc.PreconditionFailure
             * @static
             * @param {google.rpc.IPreconditionFailure} message PreconditionFailure message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            PreconditionFailure.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.violations != null && message.violations.length)
                    for (var i = 0; i < message.violations.length; ++i)
                        $root.google.rpc.PreconditionFailure.Violation.encode(message.violations[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified PreconditionFailure message, length delimited. Does not implicitly {@link google.rpc.PreconditionFailure.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.rpc.PreconditionFailure
             * @static
             * @param {google.rpc.IPreconditionFailure} message PreconditionFailure message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            PreconditionFailure.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a PreconditionFailure message from the specified reader or buffer.
             * @function decode
             * @memberof google.rpc.PreconditionFailure
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.rpc.PreconditionFailure} PreconditionFailure
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            PreconditionFailure.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.rpc.PreconditionFailure();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        if (!(message.violations && message.violations.length))
                            message.violations = [];
                        message.violations.push($root.google.rpc.PreconditionFailure.Violation.decode(reader, reader.uint32()));
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a PreconditionFailure message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.rpc.PreconditionFailure
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.rpc.PreconditionFailure} PreconditionFailure
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            PreconditionFailure.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a PreconditionFailure message.
             * @function verify
             * @memberof google.rpc.PreconditionFailure
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            PreconditionFailure.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.violations != null && message.hasOwnProperty("violations")) {
                    if (!Array.isArray(message.violations))
                        return "violations: array expected";
                    for (var i = 0; i < message.violations.length; ++i) {
                        var error = $root.google.rpc.PreconditionFailure.Violation.verify(message.violations[i]);
                        if (error)
                            return "violations." + error;
                    }
                }
                return null;
            };

            /**
             * Creates a PreconditionFailure message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.rpc.PreconditionFailure
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.rpc.PreconditionFailure} PreconditionFailure
             */
            PreconditionFailure.fromObject = function fromObject(object) {
                if (object instanceof $root.google.rpc.PreconditionFailure)
                    return object;
                var message = new $root.google.rpc.PreconditionFailure();
                if (object.violations) {
                    if (!Array.isArray(object.violations))
                        throw TypeError(".google.rpc.PreconditionFailure.violations: array expected");
                    message.violations = [];
                    for (var i = 0; i < object.violations.length; ++i) {
                        if (typeof object.violations[i] !== "object")
                            throw TypeError(".google.rpc.PreconditionFailure.violations: object expected");
                        message.violations[i] = $root.google.rpc.PreconditionFailure.Violation.fromObject(object.violations[i]);
                    }
                }
                return message;
            };

            /**
             * Creates a plain object from a PreconditionFailure message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.rpc.PreconditionFailure
             * @static
             * @param {google.rpc.PreconditionFailure} message PreconditionFailure
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            PreconditionFailure.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.violations = [];
                if (message.violations && message.violations.length) {
                    object.violations = [];
                    for (var j = 0; j < message.violations.length; ++j)
                        object.violations[j] = $root.google.rpc.PreconditionFailure.Violation.toObject(message.violations[j], options);
                }
                return object;
            };

            /**
             * Converts this PreconditionFailure to JSON.
             * @function toJSON
             * @memberof google.rpc.PreconditionFailure
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            PreconditionFailure.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            PreconditionFailure.Violation = (function() {

                /**
                 * Properties of a Violation.
                 * @memberof google.rpc.PreconditionFailure
                 * @interface IViolation
                 * @property {string|null} [type] Violation type
                 * @property {string|null} [subject] Violation subject
                 * @property {string|null} [description] Violation description
                 */

                /**
                 * Constructs a new Violation.
                 * @memberof google.rpc.PreconditionFailure
                 * @classdesc Represents a Violation.
                 * @implements IViolation
                 * @constructor
                 * @param {google.rpc.PreconditionFailure.IViolation=} [properties] Properties to set
                 */
                function Violation(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }

                /**
                 * Violation type.
                 * @member {string} type
                 * @memberof google.rpc.PreconditionFailure.Violation
                 * @instance
                 */
                Violation.prototype.type = "";

                /**
                 * Violation subject.
                 * @member {string} subject
                 * @memberof google.rpc.PreconditionFailure.Violation
                 * @instance
                 */
                Violation.prototype.subject = "";

                /**
                 * Violation description.
                 * @member {string} description
                 * @memberof google.rpc.PreconditionFailure.Violation
                 * @instance
                 */
                Violation.prototype.description = "";

                /**
                 * Creates a new Violation instance using the specified properties.
                 * @function create
                 * @memberof google.rpc.PreconditionFailure.Violation
                 * @static
                 * @param {google.rpc.PreconditionFailure.IViolation=} [properties] Properties to set
                 * @returns {google.rpc.PreconditionFailure.Violation} Violation instance
                 */
                Violation.create = function create(properties) {
                    return new Violation(properties);
                };

                /**
                 * Encodes the specified Violation message. Does not implicitly {@link google.rpc.PreconditionFailure.Violation.verify|verify} messages.
                 * @function encode
                 * @memberof google.rpc.PreconditionFailure.Violation
                 * @static
                 * @param {google.rpc.PreconditionFailure.IViolation} message Violation message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Violation.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.type != null && message.hasOwnProperty("type"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.type);
                    if (message.subject != null && message.hasOwnProperty("subject"))
                        writer.uint32(/* id 2, wireType 2 =*/18).string(message.subject);
                    if (message.description != null && message.hasOwnProperty("description"))
                        writer.uint32(/* id 3, wireType 2 =*/26).string(message.description);
                    return writer;
                };

                /**
                 * Encodes the specified Violation message, length delimited. Does not implicitly {@link google.rpc.PreconditionFailure.Violation.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.rpc.PreconditionFailure.Violation
                 * @static
                 * @param {google.rpc.PreconditionFailure.IViolation} message Violation message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Violation.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };

                /**
                 * Decodes a Violation message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.rpc.PreconditionFailure.Violation
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.rpc.PreconditionFailure.Violation} Violation
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Violation.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.rpc.PreconditionFailure.Violation();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1:
                            message.type = reader.string();
                            break;
                        case 2:
                            message.subject = reader.string();
                            break;
                        case 3:
                            message.description = reader.string();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };

                /**
                 * Decodes a Violation message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.rpc.PreconditionFailure.Violation
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.rpc.PreconditionFailure.Violation} Violation
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Violation.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };

                /**
                 * Verifies a Violation message.
                 * @function verify
                 * @memberof google.rpc.PreconditionFailure.Violation
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                Violation.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.type != null && message.hasOwnProperty("type"))
                        if (!$util.isString(message.type))
                            return "type: string expected";
                    if (message.subject != null && message.hasOwnProperty("subject"))
                        if (!$util.isString(message.subject))
                            return "subject: string expected";
                    if (message.description != null && message.hasOwnProperty("description"))
                        if (!$util.isString(message.description))
                            return "description: string expected";
                    return null;
                };

                /**
                 * Creates a Violation message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.rpc.PreconditionFailure.Violation
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.rpc.PreconditionFailure.Violation} Violation
                 */
                Violation.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.rpc.PreconditionFailure.Violation)
                        return object;
                    var message = new $root.google.rpc.PreconditionFailure.Violation();
                    if (object.type != null)
                        message.type = String(object.type);
                    if (object.subject != null)
                        message.subject = String(object.subject);
                    if (object.description != null)
                        message.description = String(object.description);
                    return message;
                };

                /**
                 * Creates a plain object from a Violation message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.rpc.PreconditionFailure.Violation
                 * @static
                 * @param {google.rpc.PreconditionFailure.Violation} message Violation
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                Violation.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.type = "";
                        object.subject = "";
                        object.description = "";
                    }
                    if (message.type != null && message.hasOwnProperty("type"))
                        object.type = message.type;
                    if (message.subject != null && message.hasOwnProperty("subject"))
                        object.subject = message.subject;
                    if (message.description != null && message.hasOwnProperty("description"))
                        object.description = message.description;
                    return object;
                };

                /**
                 * Converts this Violation to JSON.
                 * @function toJSON
                 * @memberof google.rpc.PreconditionFailure.Violation
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                Violation.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };

                return Violation;
            })();

            return PreconditionFailure;
        })();

        rpc.BadRequest = (function() {

            /**
             * Properties of a BadRequest.
             * @memberof google.rpc
             * @interface IBadRequest
             * @property {Array.<google.rpc.BadRequest.IFieldViolation>|null} [fieldViolations] BadRequest fieldViolations
             */

            /**
             * Constructs a new BadRequest.
             * @memberof google.rpc
             * @classdesc Represents a BadRequest.
             * @implements IBadRequest
             * @constructor
             * @param {google.rpc.IBadRequest=} [properties] Properties to set
             */
            function BadRequest(properties) {
                this.fieldViolations = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * BadRequest fieldViolations.
             * @member {Array.<google.rpc.BadRequest.IFieldViolation>} fieldViolations
             * @memberof google.rpc.BadRequest
             * @instance
             */
            BadRequest.prototype.fieldViolations = $util.emptyArray;

            /**
             * Creates a new BadRequest instance using the specified properties.
             * @function create
             * @memberof google.rpc.BadRequest
             * @static
             * @param {google.rpc.IBadRequest=} [properties] Properties to set
             * @returns {google.rpc.BadRequest} BadRequest instance
             */
            BadRequest.create = function create(properties) {
                return new BadRequest(properties);
            };

            /**
             * Encodes the specified BadRequest message. Does not implicitly {@link google.rpc.BadRequest.verify|verify} messages.
             * @function encode
             * @memberof google.rpc.BadRequest
             * @static
             * @param {google.rpc.IBadRequest} message BadRequest message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            BadRequest.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.fieldViolations != null && message.fieldViolations.length)
                    for (var i = 0; i < message.fieldViolations.length; ++i)
                        $root.google.rpc.BadRequest.FieldViolation.encode(message.fieldViolations[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified BadRequest message, length delimited. Does not implicitly {@link google.rpc.BadRequest.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.rpc.BadRequest
             * @static
             * @param {google.rpc.IBadRequest} message BadRequest message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            BadRequest.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a BadRequest message from the specified reader or buffer.
             * @function decode
             * @memberof google.rpc.BadRequest
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.rpc.BadRequest} BadRequest
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            BadRequest.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.rpc.BadRequest();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        if (!(message.fieldViolations && message.fieldViolations.length))
                            message.fieldViolations = [];
                        message.fieldViolations.push($root.google.rpc.BadRequest.FieldViolation.decode(reader, reader.uint32()));
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a BadRequest message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.rpc.BadRequest
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.rpc.BadRequest} BadRequest
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            BadRequest.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a BadRequest message.
             * @function verify
             * @memberof google.rpc.BadRequest
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            BadRequest.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.fieldViolations != null && message.hasOwnProperty("fieldViolations")) {
                    if (!Array.isArray(message.fieldViolations))
                        return "fieldViolations: array expected";
                    for (var i = 0; i < message.fieldViolations.length; ++i) {
                        var error = $root.google.rpc.BadRequest.FieldViolation.verify(message.fieldViolations[i]);
                        if (error)
                            return "fieldViolations." + error;
                    }
                }
                return null;
            };

            /**
             * Creates a BadRequest message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.rpc.BadRequest
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.rpc.BadRequest} BadRequest
             */
            BadRequest.fromObject = function fromObject(object) {
                if (object instanceof $root.google.rpc.BadRequest)
                    return object;
                var message = new $root.google.rpc.BadRequest();
                if (object.fieldViolations) {
                    if (!Array.isArray(object.fieldViolations))
                        throw TypeError(".google.rpc.BadRequest.fieldViolations: array expected");
                    message.fieldViolations = [];
                    for (var i = 0; i < object.fieldViolations.length; ++i) {
                        if (typeof object.fieldViolations[i] !== "object")
                            throw TypeError(".google.rpc.BadRequest.fieldViolations: object expected");
                        message.fieldViolations[i] = $root.google.rpc.BadRequest.FieldViolation.fromObject(object.fieldViolations[i]);
                    }
                }
                return message;
            };

            /**
             * Creates a plain object from a BadRequest message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.rpc.BadRequest
             * @static
             * @param {google.rpc.BadRequest} message BadRequest
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            BadRequest.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.fieldViolations = [];
                if (message.fieldViolations && message.fieldViolations.length) {
                    object.fieldViolations = [];
                    for (var j = 0; j < message.fieldViolations.length; ++j)
                        object.fieldViolations[j] = $root.google.rpc.BadRequest.FieldViolation.toObject(message.fieldViolations[j], options);
                }
                return object;
            };

            /**
             * Converts this BadRequest to JSON.
             * @function toJSON
             * @memberof google.rpc.BadRequest
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            BadRequest.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            BadRequest.FieldViolation = (function() {

                /**
                 * Properties of a FieldViolation.
                 * @memberof google.rpc.BadRequest
                 * @interface IFieldViolation
                 * @property {string|null} [field] FieldViolation field
                 * @property {string|null} [description] FieldViolation description
                 */

                /**
                 * Constructs a new FieldViolation.
                 * @memberof google.rpc.BadRequest
                 * @classdesc Represents a FieldViolation.
                 * @implements IFieldViolation
                 * @constructor
                 * @param {google.rpc.BadRequest.IFieldViolation=} [properties] Properties to set
                 */
                function FieldViolation(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }

                /**
                 * FieldViolation field.
                 * @member {string} field
                 * @memberof google.rpc.BadRequest.FieldViolation
                 * @instance
                 */
                FieldViolation.prototype.field = "";

                /**
                 * FieldViolation description.
                 * @member {string} description
                 * @memberof google.rpc.BadRequest.FieldViolation
                 * @instance
                 */
                FieldViolation.prototype.description = "";

                /**
                 * Creates a new FieldViolation instance using the specified properties.
                 * @function create
                 * @memberof google.rpc.BadRequest.FieldViolation
                 * @static
                 * @param {google.rpc.BadRequest.IFieldViolation=} [properties] Properties to set
                 * @returns {google.rpc.BadRequest.FieldViolation} FieldViolation instance
                 */
                FieldViolation.create = function create(properties) {
                    return new FieldViolation(properties);
                };

                /**
                 * Encodes the specified FieldViolation message. Does not implicitly {@link google.rpc.BadRequest.FieldViolation.verify|verify} messages.
                 * @function encode
                 * @memberof google.rpc.BadRequest.FieldViolation
                 * @static
                 * @param {google.rpc.BadRequest.IFieldViolation} message FieldViolation message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FieldViolation.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.field != null && message.hasOwnProperty("field"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.field);
                    if (message.description != null && message.hasOwnProperty("description"))
                        writer.uint32(/* id 2, wireType 2 =*/18).string(message.description);
                    return writer;
                };

                /**
                 * Encodes the specified FieldViolation message, length delimited. Does not implicitly {@link google.rpc.BadRequest.FieldViolation.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.rpc.BadRequest.FieldViolation
                 * @static
                 * @param {google.rpc.BadRequest.IFieldViolation} message FieldViolation message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FieldViolation.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };

                /**
                 * Decodes a FieldViolation message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.rpc.BadRequest.FieldViolation
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.rpc.BadRequest.FieldViolation} FieldViolation
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FieldViolation.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.rpc.BadRequest.FieldViolation();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1:
                            message.field = reader.string();
                            break;
                        case 2:
                            message.description = reader.string();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };

                /**
                 * Decodes a FieldViolation message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.rpc.BadRequest.FieldViolation
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.rpc.BadRequest.FieldViolation} FieldViolation
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FieldViolation.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };

                /**
                 * Verifies a FieldViolation message.
                 * @function verify
                 * @memberof google.rpc.BadRequest.FieldViolation
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                FieldViolation.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.field != null && message.hasOwnProperty("field"))
                        if (!$util.isString(message.field))
                            return "field: string expected";
                    if (message.description != null && message.hasOwnProperty("description"))
                        if (!$util.isString(message.description))
                            return "description: string expected";
                    return null;
                };

                /**
                 * Creates a FieldViolation message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.rpc.BadRequest.FieldViolation
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.rpc.BadRequest.FieldViolation} FieldViolation
                 */
                FieldViolation.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.rpc.BadRequest.FieldViolation)
                        return object;
                    var message = new $root.google.rpc.BadRequest.FieldViolation();
                    if (object.field != null)
                        message.field = String(object.field);
                    if (object.description != null)
                        message.description = String(object.description);
                    return message;
                };

                /**
                 * Creates a plain object from a FieldViolation message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.rpc.BadRequest.FieldViolation
                 * @static
                 * @param {google.rpc.BadRequest.FieldViolation} message FieldViolation
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                FieldViolation.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.field = "";
                        object.description = "";
                    }
                    if (message.field != null && message.hasOwnProperty("field"))
                        object.field = message.field;
                    if (message.description != null && message.hasOwnProperty("description"))
                        object.description = message.description;
                    return object;
                };

                /**
                 * Converts this FieldViolation to JSON.
                 * @function toJSON
                 * @memberof google.rpc.BadRequest.FieldViolation
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                FieldViolation.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };

                return FieldViolation;
            })();

            return BadRequest;
        })();

        rpc.RequestInfo = (function() {

            /**
             * Properties of a RequestInfo.
             * @memberof google.rpc
             * @interface IRequestInfo
             * @property {string|null} [requestId] RequestInfo requestId
             * @property {string|null} [servingData] RequestInfo servingData
             */

            /**
             * Constructs a new RequestInfo.
             * @memberof google.rpc
             * @classdesc Represents a RequestInfo.
             * @implements IRequestInfo
             * @constructor
             * @param {google.rpc.IRequestInfo=} [properties] Properties to set
             */
            function RequestInfo(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * RequestInfo requestId.
             * @member {string} requestId
             * @memberof google.rpc.RequestInfo
             * @instance
             */
            RequestInfo.prototype.requestId = "";

            /**
             * RequestInfo servingData.
             * @member {string} servingData
             * @memberof google.rpc.RequestInfo
             * @instance
             */
            RequestInfo.prototype.servingData = "";

            /**
             * Creates a new RequestInfo instance using the specified properties.
             * @function create
             * @memberof google.rpc.RequestInfo
             * @static
             * @param {google.rpc.IRequestInfo=} [properties] Properties to set
             * @returns {google.rpc.RequestInfo} RequestInfo instance
             */
            RequestInfo.create = function create(properties) {
                return new RequestInfo(properties);
            };

            /**
             * Encodes the specified RequestInfo message. Does not implicitly {@link google.rpc.RequestInfo.verify|verify} messages.
             * @function encode
             * @memberof google.rpc.RequestInfo
             * @static
             * @param {google.rpc.IRequestInfo} message RequestInfo message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            RequestInfo.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.requestId != null && message.hasOwnProperty("requestId"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.requestId);
                if (message.servingData != null && message.hasOwnProperty("servingData"))
                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.servingData);
                return writer;
            };

            /**
             * Encodes the specified RequestInfo message, length delimited. Does not implicitly {@link google.rpc.RequestInfo.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.rpc.RequestInfo
             * @static
             * @param {google.rpc.IRequestInfo} message RequestInfo message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            RequestInfo.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a RequestInfo message from the specified reader or buffer.
             * @function decode
             * @memberof google.rpc.RequestInfo
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.rpc.RequestInfo} RequestInfo
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            RequestInfo.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.rpc.RequestInfo();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.requestId = reader.string();
                        break;
                    case 2:
                        message.servingData = reader.string();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a RequestInfo message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.rpc.RequestInfo
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.rpc.RequestInfo} RequestInfo
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            RequestInfo.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a RequestInfo message.
             * @function verify
             * @memberof google.rpc.RequestInfo
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            RequestInfo.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.requestId != null && message.hasOwnProperty("requestId"))
                    if (!$util.isString(message.requestId))
                        return "requestId: string expected";
                if (message.servingData != null && message.hasOwnProperty("servingData"))
                    if (!$util.isString(message.servingData))
                        return "servingData: string expected";
                return null;
            };

            /**
             * Creates a RequestInfo message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.rpc.RequestInfo
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.rpc.RequestInfo} RequestInfo
             */
            RequestInfo.fromObject = function fromObject(object) {
                if (object instanceof $root.google.rpc.RequestInfo)
                    return object;
                var message = new $root.google.rpc.RequestInfo();
                if (object.requestId != null)
                    message.requestId = String(object.requestId);
                if (object.servingData != null)
                    message.servingData = String(object.servingData);
                return message;
            };

            /**
             * Creates a plain object from a RequestInfo message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.rpc.RequestInfo
             * @static
             * @param {google.rpc.RequestInfo} message RequestInfo
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            RequestInfo.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults) {
                    object.requestId = "";
                    object.servingData = "";
                }
                if (message.requestId != null && message.hasOwnProperty("requestId"))
                    object.requestId = message.requestId;
                if (message.servingData != null && message.hasOwnProperty("servingData"))
                    object.servingData = message.servingData;
                return object;
            };

            /**
             * Converts this RequestInfo to JSON.
             * @function toJSON
             * @memberof google.rpc.RequestInfo
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            RequestInfo.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return RequestInfo;
        })();

        rpc.ResourceInfo = (function() {

            /**
             * Properties of a ResourceInfo.
             * @memberof google.rpc
             * @interface IResourceInfo
             * @property {string|null} [resourceType] ResourceInfo resourceType
             * @property {string|null} [resourceName] ResourceInfo resourceName
             * @property {string|null} [owner] ResourceInfo owner
             * @property {string|null} [description] ResourceInfo description
             */

            /**
             * Constructs a new ResourceInfo.
             * @memberof google.rpc
             * @classdesc Represents a ResourceInfo.
             * @implements IResourceInfo
             * @constructor
             * @param {google.rpc.IResourceInfo=} [properties] Properties to set
             */
            function ResourceInfo(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * ResourceInfo resourceType.
             * @member {string} resourceType
             * @memberof google.rpc.ResourceInfo
             * @instance
             */
            ResourceInfo.prototype.resourceType = "";

            /**
             * ResourceInfo resourceName.
             * @member {string} resourceName
             * @memberof google.rpc.ResourceInfo
             * @instance
             */
            ResourceInfo.prototype.resourceName = "";

            /**
             * ResourceInfo owner.
             * @member {string} owner
             * @memberof google.rpc.ResourceInfo
             * @instance
             */
            ResourceInfo.prototype.owner = "";

            /**
             * ResourceInfo description.
             * @member {string} description
             * @memberof google.rpc.ResourceInfo
             * @instance
             */
            ResourceInfo.prototype.description = "";

            /**
             * Creates a new ResourceInfo instance using the specified properties.
             * @function create
             * @memberof google.rpc.ResourceInfo
             * @static
             * @param {google.rpc.IResourceInfo=} [properties] Properties to set
             * @returns {google.rpc.ResourceInfo} ResourceInfo instance
             */
            ResourceInfo.create = function create(properties) {
                return new ResourceInfo(properties);
            };

            /**
             * Encodes the specified ResourceInfo message. Does not implicitly {@link google.rpc.ResourceInfo.verify|verify} messages.
             * @function encode
             * @memberof google.rpc.ResourceInfo
             * @static
             * @param {google.rpc.IResourceInfo} message ResourceInfo message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            ResourceInfo.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.resourceType != null && message.hasOwnProperty("resourceType"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceType);
                if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.resourceName);
                if (message.owner != null && message.hasOwnProperty("owner"))
                    writer.uint32(/* id 3, wireType 2 =*/26).string(message.owner);
                if (message.description != null && message.hasOwnProperty("description"))
                    writer.uint32(/* id 4, wireType 2 =*/34).string(message.description);
                return writer;
            };

            /**
             * Encodes the specified ResourceInfo message, length delimited. Does not implicitly {@link google.rpc.ResourceInfo.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.rpc.ResourceInfo
             * @static
             * @param {google.rpc.IResourceInfo} message ResourceInfo message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            ResourceInfo.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a ResourceInfo message from the specified reader or buffer.
             * @function decode
             * @memberof google.rpc.ResourceInfo
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.rpc.ResourceInfo} ResourceInfo
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            ResourceInfo.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.rpc.ResourceInfo();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.resourceType = reader.string();
                        break;
                    case 2:
                        message.resourceName = reader.string();
                        break;
                    case 3:
                        message.owner = reader.string();
                        break;
                    case 4:
                        message.description = reader.string();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a ResourceInfo message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.rpc.ResourceInfo
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.rpc.ResourceInfo} ResourceInfo
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            ResourceInfo.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a ResourceInfo message.
             * @function verify
             * @memberof google.rpc.ResourceInfo
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            ResourceInfo.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.resourceType != null && message.hasOwnProperty("resourceType"))
                    if (!$util.isString(message.resourceType))
                        return "resourceType: string expected";
                if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                    if (!$util.isString(message.resourceName))
                        return "resourceName: string expected";
                if (message.owner != null && message.hasOwnProperty("owner"))
                    if (!$util.isString(message.owner))
                        return "owner: string expected";
                if (message.description != null && message.hasOwnProperty("description"))
                    if (!$util.isString(message.description))
                        return "description: string expected";
                return null;
            };

            /**
             * Creates a ResourceInfo message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.rpc.ResourceInfo
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.rpc.ResourceInfo} ResourceInfo
             */
            ResourceInfo.fromObject = function fromObject(object) {
                if (object instanceof $root.google.rpc.ResourceInfo)
                    return object;
                var message = new $root.google.rpc.ResourceInfo();
                if (object.resourceType != null)
                    message.resourceType = String(object.resourceType);
                if (object.resourceName != null)
                    message.resourceName = String(object.resourceName);
                if (object.owner != null)
                    message.owner = String(object.owner);
                if (object.description != null)
                    message.description = String(object.description);
                return message;
            };

            /**
             * Creates a plain object from a ResourceInfo message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.rpc.ResourceInfo
             * @static
             * @param {google.rpc.ResourceInfo} message ResourceInfo
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            ResourceInfo.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults) {
                    object.resourceType = "";
                    object.resourceName = "";
                    object.owner = "";
                    object.description = "";
                }
                if (message.resourceType != null && message.hasOwnProperty("resourceType"))
                    object.resourceType = message.resourceType;
                if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                    object.resourceName = message.resourceName;
                if (message.owner != null && message.hasOwnProperty("owner"))
                    object.owner = message.owner;
                if (message.description != null && message.hasOwnProperty("description"))
                    object.description = message.description;
                return object;
            };

            /**
             * Converts this ResourceInfo to JSON.
             * @function toJSON
             * @memberof google.rpc.ResourceInfo
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            ResourceInfo.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return ResourceInfo;
        })();

        rpc.Help = (function() {

            /**
             * Properties of a Help.
             * @memberof google.rpc
             * @interface IHelp
             * @property {Array.<google.rpc.Help.ILink>|null} [links] Help links
             */

            /**
             * Constructs a new Help.
             * @memberof google.rpc
             * @classdesc Represents a Help.
             * @implements IHelp
             * @constructor
             * @param {google.rpc.IHelp=} [properties] Properties to set
             */
            function Help(properties) {
                this.links = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * Help links.
             * @member {Array.<google.rpc.Help.ILink>} links
             * @memberof google.rpc.Help
             * @instance
             */
            Help.prototype.links = $util.emptyArray;

            /**
             * Creates a new Help instance using the specified properties.
             * @function create
             * @memberof google.rpc.Help
             * @static
             * @param {google.rpc.IHelp=} [properties] Properties to set
             * @returns {google.rpc.Help} Help instance
             */
            Help.create = function create(properties) {
                return new Help(properties);
            };

            /**
             * Encodes the specified Help message. Does not implicitly {@link google.rpc.Help.verify|verify} messages.
             * @function encode
             * @memberof google.rpc.Help
             * @static
             * @param {google.rpc.IHelp} message Help message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Help.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.links != null && message.links.length)
                    for (var i = 0; i < message.links.length; ++i)
                        $root.google.rpc.Help.Link.encode(message.links[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified Help message, length delimited. Does not implicitly {@link google.rpc.Help.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.rpc.Help
             * @static
             * @param {google.rpc.IHelp} message Help message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Help.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a Help message from the specified reader or buffer.
             * @function decode
             * @memberof google.rpc.Help
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.rpc.Help} Help
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Help.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.rpc.Help();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        if (!(message.links && message.links.length))
                            message.links = [];
                        message.links.push($root.google.rpc.Help.Link.decode(reader, reader.uint32()));
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a Help message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.rpc.Help
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.rpc.Help} Help
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Help.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a Help message.
             * @function verify
             * @memberof google.rpc.Help
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            Help.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.links != null && message.hasOwnProperty("links")) {
                    if (!Array.isArray(message.links))
                        return "links: array expected";
                    for (var i = 0; i < message.links.length; ++i) {
                        var error = $root.google.rpc.Help.Link.verify(message.links[i]);
                        if (error)
                            return "links." + error;
                    }
                }
                return null;
            };

            /**
             * Creates a Help message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.rpc.Help
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.rpc.Help} Help
             */
            Help.fromObject = function fromObject(object) {
                if (object instanceof $root.google.rpc.Help)
                    return object;
                var message = new $root.google.rpc.Help();
                if (object.links) {
                    if (!Array.isArray(object.links))
                        throw TypeError(".google.rpc.Help.links: array expected");
                    message.links = [];
                    for (var i = 0; i < object.links.length; ++i) {
                        if (typeof object.links[i] !== "object")
                            throw TypeError(".google.rpc.Help.links: object expected");
                        message.links[i] = $root.google.rpc.Help.Link.fromObject(object.links[i]);
                    }
                }
                return message;
            };

            /**
             * Creates a plain object from a Help message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.rpc.Help
             * @static
             * @param {google.rpc.Help} message Help
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            Help.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.links = [];
                if (message.links && message.links.length) {
                    object.links = [];
                    for (var j = 0; j < message.links.length; ++j)
                        object.links[j] = $root.google.rpc.Help.Link.toObject(message.links[j], options);
                }
                return object;
            };

            /**
             * Converts this Help to JSON.
             * @function toJSON
             * @memberof google.rpc.Help
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            Help.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            Help.Link = (function() {

                /**
                 * Properties of a Link.
                 * @memberof google.rpc.Help
                 * @interface ILink
                 * @property {string|null} [description] Link description
                 * @property {string|null} [url] Link url
                 */

                /**
                 * Constructs a new Link.
                 * @memberof google.rpc.Help
                 * @classdesc Represents a Link.
                 * @implements ILink
                 * @constructor
                 * @param {google.rpc.Help.ILink=} [properties] Properties to set
                 */
                function Link(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }

                /**
                 * Link description.
                 * @member {string} description
                 * @memberof google.rpc.Help.Link
                 * @instance
                 */
                Link.prototype.description = "";

                /**
                 * Link url.
                 * @member {string} url
                 * @memberof google.rpc.Help.Link
                 * @instance
                 */
                Link.prototype.url = "";

                /**
                 * Creates a new Link instance using the specified properties.
                 * @function create
                 * @memberof google.rpc.Help.Link
                 * @static
                 * @param {google.rpc.Help.ILink=} [properties] Properties to set
                 * @returns {google.rpc.Help.Link} Link instance
                 */
                Link.create = function create(properties) {
                    return new Link(properties);
                };

                /**
                 * Encodes the specified Link message. Does not implicitly {@link google.rpc.Help.Link.verify|verify} messages.
                 * @function encode
                 * @memberof google.rpc.Help.Link
                 * @static
                 * @param {google.rpc.Help.ILink} message Link message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Link.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.description != null && message.hasOwnProperty("description"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.description);
                    if (message.url != null && message.hasOwnProperty("url"))
                        writer.uint32(/* id 2, wireType 2 =*/18).string(message.url);
                    return writer;
                };

                /**
                 * Encodes the specified Link message, length delimited. Does not implicitly {@link google.rpc.Help.Link.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.rpc.Help.Link
                 * @static
                 * @param {google.rpc.Help.ILink} message Link message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Link.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };

                /**
                 * Decodes a Link message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.rpc.Help.Link
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.rpc.Help.Link} Link
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Link.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.rpc.Help.Link();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1:
                            message.description = reader.string();
                            break;
                        case 2:
                            message.url = reader.string();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };

                /**
                 * Decodes a Link message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.rpc.Help.Link
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.rpc.Help.Link} Link
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Link.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };

                /**
                 * Verifies a Link message.
                 * @function verify
                 * @memberof google.rpc.Help.Link
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                Link.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.description != null && message.hasOwnProperty("description"))
                        if (!$util.isString(message.description))
                            return "description: string expected";
                    if (message.url != null && message.hasOwnProperty("url"))
                        if (!$util.isString(message.url))
                            return "url: string expected";
                    return null;
                };

                /**
                 * Creates a Link message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.rpc.Help.Link
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.rpc.Help.Link} Link
                 */
                Link.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.rpc.Help.Link)
                        return object;
                    var message = new $root.google.rpc.Help.Link();
                    if (object.description != null)
                        message.description = String(object.description);
                    if (object.url != null)
                        message.url = String(object.url);
                    return message;
                };

                /**
                 * Creates a plain object from a Link message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.rpc.Help.Link
                 * @static
                 * @param {google.rpc.Help.Link} message Link
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                Link.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.description = "";
                        object.url = "";
                    }
                    if (message.description != null && message.hasOwnProperty("description"))
                        object.description = message.description;
                    if (message.url != null && message.hasOwnProperty("url"))
                        object.url = message.url;
                    return object;
                };

                /**
                 * Converts this Link to JSON.
                 * @function toJSON
                 * @memberof google.rpc.Help.Link
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                Link.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };

                return Link;
            })();

            return Help;
        })();

        rpc.LocalizedMessage = (function() {

            /**
             * Properties of a LocalizedMessage.
             * @memberof google.rpc
             * @interface ILocalizedMessage
             * @property {string|null} [locale] LocalizedMessage locale
             * @property {string|null} [message] LocalizedMessage message
             */

            /**
             * Constructs a new LocalizedMessage.
             * @memberof google.rpc
             * @classdesc Represents a LocalizedMessage.
             * @implements ILocalizedMessage
             * @constructor
             * @param {google.rpc.ILocalizedMessage=} [properties] Properties to set
             */
            function LocalizedMessage(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * LocalizedMessage locale.
             * @member {string} locale
             * @memberof google.rpc.LocalizedMessage
             * @instance
             */
            LocalizedMessage.prototype.locale = "";

            /**
             * LocalizedMessage message.
             * @member {string} message
             * @memberof google.rpc.LocalizedMessage
             * @instance
             */
            LocalizedMessage.prototype.message = "";

            /**
             * Creates a new LocalizedMessage instance using the specified properties.
             * @function create
             * @memberof google.rpc.LocalizedMessage
             * @static
             * @param {google.rpc.ILocalizedMessage=} [properties] Properties to set
             * @returns {google.rpc.LocalizedMessage} LocalizedMessage instance
             */
            LocalizedMessage.create = function create(properties) {
                return new LocalizedMessage(properties);
            };

            /**
             * Encodes the specified LocalizedMessage message. Does not implicitly {@link google.rpc.LocalizedMessage.verify|verify} messages.
             * @function encode
             * @memberof google.rpc.LocalizedMessage
             * @static
             * @param {google.rpc.ILocalizedMessage} message LocalizedMessage message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            LocalizedMessage.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.locale != null && message.hasOwnProperty("locale"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.locale);
                if (message.message != null && message.hasOwnProperty("message"))
                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.message);
                return writer;
            };

            /**
             * Encodes the specified LocalizedMessage message, length delimited. Does not implicitly {@link google.rpc.LocalizedMessage.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.rpc.LocalizedMessage
             * @static
             * @param {google.rpc.ILocalizedMessage} message LocalizedMessage message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            LocalizedMessage.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a LocalizedMessage message from the specified reader or buffer.
             * @function decode
             * @memberof google.rpc.LocalizedMessage
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.rpc.LocalizedMessage} LocalizedMessage
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            LocalizedMessage.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.rpc.LocalizedMessage();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.locale = reader.string();
                        break;
                    case 2:
                        message.message = reader.string();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a LocalizedMessage message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.rpc.LocalizedMessage
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.rpc.LocalizedMessage} LocalizedMessage
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            LocalizedMessage.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a LocalizedMessage message.
             * @function verify
             * @memberof google.rpc.LocalizedMessage
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            LocalizedMessage.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.locale != null && message.hasOwnProperty("locale"))
                    if (!$util.isString(message.locale))
                        return "locale: string expected";
                if (message.message != null && message.hasOwnProperty("message"))
                    if (!$util.isString(message.message))
                        return "message: string expected";
                return null;
            };

            /**
             * Creates a LocalizedMessage message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.rpc.LocalizedMessage
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.rpc.LocalizedMessage} LocalizedMessage
             */
            LocalizedMessage.fromObject = function fromObject(object) {
                if (object instanceof $root.google.rpc.LocalizedMessage)
                    return object;
                var message = new $root.google.rpc.LocalizedMessage();
                if (object.locale != null)
                    message.locale = String(object.locale);
                if (object.message != null)
                    message.message = String(object.message);
                return message;
            };

            /**
             * Creates a plain object from a LocalizedMessage message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.rpc.LocalizedMessage
             * @static
             * @param {google.rpc.LocalizedMessage} message LocalizedMessage
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            LocalizedMessage.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults) {
                    object.locale = "";
                    object.message = "";
                }
                if (message.locale != null && message.hasOwnProperty("locale"))
                    object.locale = message.locale;
                if (message.message != null && message.hasOwnProperty("message"))
                    object.message = message.message;
                return object;
            };

            /**
             * Converts this LocalizedMessage to JSON.
             * @function toJSON
             * @memberof google.rpc.LocalizedMessage
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            LocalizedMessage.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return LocalizedMessage;
        })();

        rpc.Status = (function() {

            /**
             * Properties of a Status.
             * @memberof google.rpc
             * @interface IStatus
             * @property {number|null} [code] Status code
             * @property {string|null} [message] Status message
             * @property {Array.<google.protobuf.IAny>|null} [details] Status details
             */

            /**
             * Constructs a new Status.
             * @memberof google.rpc
             * @classdesc Represents a Status.
             * @implements IStatus
             * @constructor
             * @param {google.rpc.IStatus=} [properties] Properties to set
             */
            function Status(properties) {
                this.details = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * Status code.
             * @member {number} code
             * @memberof google.rpc.Status
             * @instance
             */
            Status.prototype.code = 0;

            /**
             * Status message.
             * @member {string} message
             * @memberof google.rpc.Status
             * @instance
             */
            Status.prototype.message = "";

            /**
             * Status details.
             * @member {Array.<google.protobuf.IAny>} details
             * @memberof google.rpc.Status
             * @instance
             */
            Status.prototype.details = $util.emptyArray;

            /**
             * Creates a new Status instance using the specified properties.
             * @function create
             * @memberof google.rpc.Status
             * @static
             * @param {google.rpc.IStatus=} [properties] Properties to set
             * @returns {google.rpc.Status} Status instance
             */
            Status.create = function create(properties) {
                return new Status(properties);
            };

            /**
             * Encodes the specified Status message. Does not implicitly {@link google.rpc.Status.verify|verify} messages.
             * @function encode
             * @memberof google.rpc.Status
             * @static
             * @param {google.rpc.IStatus} message Status message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Status.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.code != null && message.hasOwnProperty("code"))
                    writer.uint32(/* id 1, wireType 0 =*/8).int32(message.code);
                if (message.message != null && message.hasOwnProperty("message"))
                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.message);
                if (message.details != null && message.details.length)
                    for (var i = 0; i < message.details.length; ++i)
                        $root.google.protobuf.Any.encode(message.details[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified Status message, length delimited. Does not implicitly {@link google.rpc.Status.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.rpc.Status
             * @static
             * @param {google.rpc.IStatus} message Status message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Status.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a Status message from the specified reader or buffer.
             * @function decode
             * @memberof google.rpc.Status
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.rpc.Status} Status
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Status.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.rpc.Status();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.code = reader.int32();
                        break;
                    case 2:
                        message.message = reader.string();
                        break;
                    case 3:
                        if (!(message.details && message.details.length))
                            message.details = [];
                        message.details.push($root.google.protobuf.Any.decode(reader, reader.uint32()));
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a Status message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.rpc.Status
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.rpc.Status} Status
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Status.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a Status message.
             * @function verify
             * @memberof google.rpc.Status
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            Status.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.code != null && message.hasOwnProperty("code"))
                    if (!$util.isInteger(message.code))
                        return "code: integer expected";
                if (message.message != null && message.hasOwnProperty("message"))
                    if (!$util.isString(message.message))
                        return "message: string expected";
                if (message.details != null && message.hasOwnProperty("details")) {
                    if (!Array.isArray(message.details))
                        return "details: array expected";
                    for (var i = 0; i < message.details.length; ++i) {
                        var error = $root.google.protobuf.Any.verify(message.details[i]);
                        if (error)
                            return "details." + error;
                    }
                }
                return null;
            };

            /**
             * Creates a Status message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.rpc.Status
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.rpc.Status} Status
             */
            Status.fromObject = function fromObject(object) {
                if (object instanceof $root.google.rpc.Status)
                    return object;
                var message = new $root.google.rpc.Status();
                if (object.code != null)
                    message.code = object.code | 0;
                if (object.message != null)
                    message.message = String(object.message);
                if (object.details) {
                    if (!Array.isArray(object.details))
                        throw TypeError(".google.rpc.Status.details: array expected");
                    message.details = [];
                    for (var i = 0; i < object.details.length; ++i) {
                        if (typeof object.details[i] !== "object")
                            throw TypeError(".google.rpc.Status.details: object expected");
                        message.details[i] = $root.google.protobuf.Any.fromObject(object.details[i]);
                    }
                }
                return message;
            };

            /**
             * Creates a plain object from a Status message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.rpc.Status
             * @static
             * @param {google.rpc.Status} message Status
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            Status.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.details = [];
                if (options.defaults) {
                    object.code = 0;
                    object.message = "";
                }
                if (message.code != null && message.hasOwnProperty("code"))
                    object.code = message.code;
                if (message.message != null && message.hasOwnProperty("message"))
                    object.message = message.message;
                if (message.details && message.details.length) {
                    object.details = [];
                    for (var j = 0; j < message.details.length; ++j)
                        object.details[j] = $root.google.protobuf.Any.toObject(message.details[j], options);
                }
                return object;
            };

            /**
             * Converts this Status to JSON.
             * @function toJSON
             * @memberof google.rpc.Status
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            Status.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return Status;
        })();

        return rpc;
    })();

    google.longrunning = (function() {

        /**
         * Namespace longrunning.
         * @memberof google
         * @namespace
         */
        var longrunning = {};

        longrunning.Operations = (function() {

            /**
             * Constructs a new Operations service.
             * @memberof google.longrunning
             * @classdesc Represents an Operations
             * @extends $protobuf.rpc.Service
             * @constructor
             * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
             * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
             * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
             */
            function Operations(rpcImpl, requestDelimited, responseDelimited) {
                $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
            }

            (Operations.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Operations;

            /**
             * Creates new Operations service using the specified rpc implementation.
             * @function create
             * @memberof google.longrunning.Operations
             * @static
             * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
             * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
             * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
             * @returns {Operations} RPC service. Useful where requests and/or responses are streamed.
             */
            Operations.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                return new this(rpcImpl, requestDelimited, responseDelimited);
            };

            /**
             * Callback as used by {@link google.longrunning.Operations#listOperations}.
             * @memberof google.longrunning.Operations
             * @typedef ListOperationsCallback
             * @type {function}
             * @param {Error|null} error Error, if any
             * @param {google.longrunning.ListOperationsResponse} [response] ListOperationsResponse
             */

            /**
             * Calls ListOperations.
             * @function listOperations
             * @memberof google.longrunning.Operations
             * @instance
             * @param {google.longrunning.IListOperationsRequest} request ListOperationsRequest message or plain object
             * @param {google.longrunning.Operations.ListOperationsCallback} callback Node-style callback called with the error, if any, and ListOperationsResponse
             * @returns {undefined}
             * @variation 1
             */
            Object.defineProperty(Operations.prototype.listOperations = function listOperations(request, callback) {
                return this.rpcCall(listOperations, $root.google.longrunning.ListOperationsRequest, $root.google.longrunning.ListOperationsResponse, request, callback);
            }, "name", { value: "ListOperations" });

            /**
             * Calls ListOperations.
             * @function listOperations
             * @memberof google.longrunning.Operations
             * @instance
             * @param {google.longrunning.IListOperationsRequest} request ListOperationsRequest message or plain object
             * @returns {Promise<google.longrunning.ListOperationsResponse>} Promise
             * @variation 2
             */

            /**
             * Callback as used by {@link google.longrunning.Operations#getOperation}.
             * @memberof google.longrunning.Operations
             * @typedef GetOperationCallback
             * @type {function}
             * @param {Error|null} error Error, if any
             * @param {google.longrunning.Operation} [response] Operation
             */

            /**
             * Calls GetOperation.
             * @function getOperation
             * @memberof google.longrunning.Operations
             * @instance
             * @param {google.longrunning.IGetOperationRequest} request GetOperationRequest message or plain object
             * @param {google.longrunning.Operations.GetOperationCallback} callback Node-style callback called with the error, if any, and Operation
             * @returns {undefined}
             * @variation 1
             */
            Object.defineProperty(Operations.prototype.getOperation = function getOperation(request, callback) {
                return this.rpcCall(getOperation, $root.google.longrunning.GetOperationRequest, $root.google.longrunning.Operation, request, callback);
            }, "name", { value: "GetOperation" });

            /**
             * Calls GetOperation.
             * @function getOperation
             * @memberof google.longrunning.Operations
             * @instance
             * @param {google.longrunning.IGetOperationRequest} request GetOperationRequest message or plain object
             * @returns {Promise<google.longrunning.Operation>} Promise
             * @variation 2
             */

            /**
             * Callback as used by {@link google.longrunning.Operations#deleteOperation}.
             * @memberof google.longrunning.Operations
             * @typedef DeleteOperationCallback
             * @type {function}
             * @param {Error|null} error Error, if any
             * @param {google.protobuf.Empty} [response] Empty
             */

            /**
             * Calls DeleteOperation.
             * @function deleteOperation
             * @memberof google.longrunning.Operations
             * @instance
             * @param {google.longrunning.IDeleteOperationRequest} request DeleteOperationRequest message or plain object
             * @param {google.longrunning.Operations.DeleteOperationCallback} callback Node-style callback called with the error, if any, and Empty
             * @returns {undefined}
             * @variation 1
             */
            Object.defineProperty(Operations.prototype.deleteOperation = function deleteOperation(request, callback) {
                return this.rpcCall(deleteOperation, $root.google.longrunning.DeleteOperationRequest, $root.google.protobuf.Empty, request, callback);
            }, "name", { value: "DeleteOperation" });

            /**
             * Calls DeleteOperation.
             * @function deleteOperation
             * @memberof google.longrunning.Operations
             * @instance
             * @param {google.longrunning.IDeleteOperationRequest} request DeleteOperationRequest message or plain object
             * @returns {Promise<google.protobuf.Empty>} Promise
             * @variation 2
             */

            /**
             * Callback as used by {@link google.longrunning.Operations#cancelOperation}.
             * @memberof google.longrunning.Operations
             * @typedef CancelOperationCallback
             * @type {function}
             * @param {Error|null} error Error, if any
             * @param {google.protobuf.Empty} [response] Empty
             */

            /**
             * Calls CancelOperation.
             * @function cancelOperation
             * @memberof google.longrunning.Operations
             * @instance
             * @param {google.longrunning.ICancelOperationRequest} request CancelOperationRequest message or plain object
             * @param {google.longrunning.Operations.CancelOperationCallback} callback Node-style callback called with the error, if any, and Empty
             * @returns {undefined}
             * @variation 1
             */
            Object.defineProperty(Operations.prototype.cancelOperation = function cancelOperation(request, callback) {
                return this.rpcCall(cancelOperation, $root.google.longrunning.CancelOperationRequest, $root.google.protobuf.Empty, request, callback);
            }, "name", { value: "CancelOperation" });

            /**
             * Calls CancelOperation.
             * @function cancelOperation
             * @memberof google.longrunning.Operations
             * @instance
             * @param {google.longrunning.ICancelOperationRequest} request CancelOperationRequest message or plain object
             * @returns {Promise<google.protobuf.Empty>} Promise
             * @variation 2
             */

            /**
             * Callback as used by {@link google.longrunning.Operations#waitOperation}.
             * @memberof google.longrunning.Operations
             * @typedef WaitOperationCallback
             * @type {function}
             * @param {Error|null} error Error, if any
             * @param {google.longrunning.Operation} [response] Operation
             */

            /**
             * Calls WaitOperation.
             * @function waitOperation
             * @memberof google.longrunning.Operations
             * @instance
             * @param {google.longrunning.IWaitOperationRequest} request WaitOperationRequest message or plain object
             * @param {google.longrunning.Operations.WaitOperationCallback} callback Node-style callback called with the error, if any, and Operation
             * @returns {undefined}
             * @variation 1
             */
            Object.defineProperty(Operations.prototype.waitOperation = function waitOperation(request, callback) {
                return this.rpcCall(waitOperation, $root.google.longrunning.WaitOperationRequest, $root.google.longrunning.Operation, request, callback);
            }, "name", { value: "WaitOperation" });

            /**
             * Calls WaitOperation.
             * @function waitOperation
             * @memberof google.longrunning.Operations
             * @instance
             * @param {google.longrunning.IWaitOperationRequest} request WaitOperationRequest message or plain object
             * @returns {Promise<google.longrunning.Operation>} Promise
             * @variation 2
             */

            return Operations;
        })();

        longrunning.Operation = (function() {

            /**
             * Properties of an Operation.
             * @memberof google.longrunning
             * @interface IOperation
             * @property {string|null} [name] Operation name
             * @property {google.protobuf.IAny|null} [metadata] Operation metadata
             * @property {boolean|null} [done] Operation done
             * @property {google.rpc.IStatus|null} [error] Operation error
             * @property {google.protobuf.IAny|null} [response] Operation response
             */

            /**
             * Constructs a new Operation.
             * @memberof google.longrunning
             * @classdesc Represents an Operation.
             * @implements IOperation
             * @constructor
             * @param {google.longrunning.IOperation=} [properties] Properties to set
             */
            function Operation(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * Operation name.
             * @member {string} name
             * @memberof google.longrunning.Operation
             * @instance
             */
            Operation.prototype.name = "";

            /**
             * Operation metadata.
             * @member {google.protobuf.IAny|null|undefined} metadata
             * @memberof google.longrunning.Operation
             * @instance
             */
            Operation.prototype.metadata = null;

            /**
             * Operation done.
             * @member {boolean} done
             * @memberof google.longrunning.Operation
             * @instance
             */
            Operation.prototype.done = false;

            /**
             * Operation error.
             * @member {google.rpc.IStatus|null|undefined} error
             * @memberof google.longrunning.Operation
             * @instance
             */
            Operation.prototype.error = null;

            /**
             * Operation response.
             * @member {google.protobuf.IAny|null|undefined} response
             * @memberof google.longrunning.Operation
             * @instance
             */
            Operation.prototype.response = null;

            // OneOf field names bound to virtual getters and setters
            var $oneOfFields;

            /**
             * Operation result.
             * @member {"error"|"response"|undefined} result
             * @memberof google.longrunning.Operation
             * @instance
             */
            Object.defineProperty(Operation.prototype, "result", {
                get: $util.oneOfGetter($oneOfFields = ["error", "response"]),
                set: $util.oneOfSetter($oneOfFields)
            });

            /**
             * Creates a new Operation instance using the specified properties.
             * @function create
             * @memberof google.longrunning.Operation
             * @static
             * @param {google.longrunning.IOperation=} [properties] Properties to set
             * @returns {google.longrunning.Operation} Operation instance
             */
            Operation.create = function create(properties) {
                return new Operation(properties);
            };

            /**
             * Encodes the specified Operation message. Does not implicitly {@link google.longrunning.Operation.verify|verify} messages.
             * @function encode
             * @memberof google.longrunning.Operation
             * @static
             * @param {google.longrunning.IOperation} message Operation message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Operation.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.name != null && message.hasOwnProperty("name"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                if (message.metadata != null && message.hasOwnProperty("metadata"))
                    $root.google.protobuf.Any.encode(message.metadata, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                if (message.done != null && message.hasOwnProperty("done"))
                    writer.uint32(/* id 3, wireType 0 =*/24).bool(message.done);
                if (message.error != null && message.hasOwnProperty("error"))
                    $root.google.rpc.Status.encode(message.error, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                if (message.response != null && message.hasOwnProperty("response"))
                    $root.google.protobuf.Any.encode(message.response, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified Operation message, length delimited. Does not implicitly {@link google.longrunning.Operation.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.longrunning.Operation
             * @static
             * @param {google.longrunning.IOperation} message Operation message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Operation.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes an Operation message from the specified reader or buffer.
             * @function decode
             * @memberof google.longrunning.Operation
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.longrunning.Operation} Operation
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Operation.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.longrunning.Operation();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.name = reader.string();
                        break;
                    case 2:
                        message.metadata = $root.google.protobuf.Any.decode(reader, reader.uint32());
                        break;
                    case 3:
                        message.done = reader.bool();
                        break;
                    case 4:
                        message.error = $root.google.rpc.Status.decode(reader, reader.uint32());
                        break;
                    case 5:
                        message.response = $root.google.protobuf.Any.decode(reader, reader.uint32());
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes an Operation message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.longrunning.Operation
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.longrunning.Operation} Operation
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Operation.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies an Operation message.
             * @function verify
             * @memberof google.longrunning.Operation
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            Operation.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                var properties = {};
                if (message.name != null && message.hasOwnProperty("name"))
                    if (!$util.isString(message.name))
                        return "name: string expected";
                if (message.metadata != null && message.hasOwnProperty("metadata")) {
                    var error = $root.google.protobuf.Any.verify(message.metadata);
                    if (error)
                        return "metadata." + error;
                }
                if (message.done != null && message.hasOwnProperty("done"))
                    if (typeof message.done !== "boolean")
                        return "done: boolean expected";
                if (message.error != null && message.hasOwnProperty("error")) {
                    properties.result = 1;
                    {
                        var error = $root.google.rpc.Status.verify(message.error);
                        if (error)
                            return "error." + error;
                    }
                }
                if (message.response != null && message.hasOwnProperty("response")) {
                    if (properties.result === 1)
                        return "result: multiple values";
                    properties.result = 1;
                    {
                        var error = $root.google.protobuf.Any.verify(message.response);
                        if (error)
                            return "response." + error;
                    }
                }
                return null;
            };

            /**
             * Creates an Operation message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.longrunning.Operation
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.longrunning.Operation} Operation
             */
            Operation.fromObject = function fromObject(object) {
                if (object instanceof $root.google.longrunning.Operation)
                    return object;
                var message = new $root.google.longrunning.Operation();
                if (object.name != null)
                    message.name = String(object.name);
                if (object.metadata != null) {
                    if (typeof object.metadata !== "object")
                        throw TypeError(".google.longrunning.Operation.metadata: object expected");
                    message.metadata = $root.google.protobuf.Any.fromObject(object.metadata);
                }
                if (object.done != null)
                    message.done = Boolean(object.done);
                if (object.error != null) {
                    if (typeof object.error !== "object")
                        throw TypeError(".google.longrunning.Operation.error: object expected");
                    message.error = $root.google.rpc.Status.fromObject(object.error);
                }
                if (object.response != null) {
                    if (typeof object.response !== "object")
                        throw TypeError(".google.longrunning.Operation.response: object expected");
                    message.response = $root.google.protobuf.Any.fromObject(object.response);
                }
                return message;
            };

            /**
             * Creates a plain object from an Operation message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.longrunning.Operation
             * @static
             * @param {google.longrunning.Operation} message Operation
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            Operation.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults) {
                    object.name = "";
                    object.metadata = null;
                    object.done = false;
                }
                if (message.name != null && message.hasOwnProperty("name"))
                    object.name = message.name;
                if (message.metadata != null && message.hasOwnProperty("metadata"))
                    object.metadata = $root.google.protobuf.Any.toObject(message.metadata, options);
                if (message.done != null && message.hasOwnProperty("done"))
                    object.done = message.done;
                if (message.error != null && message.hasOwnProperty("error")) {
                    object.error = $root.google.rpc.Status.toObject(message.error, options);
                    if (options.oneofs)
                        object.result = "error";
                }
                if (message.response != null && message.hasOwnProperty("response")) {
                    object.response = $root.google.protobuf.Any.toObject(message.response, options);
                    if (options.oneofs)
                        object.result = "response";
                }
                return object;
            };

            /**
             * Converts this Operation to JSON.
             * @function toJSON
             * @memberof google.longrunning.Operation
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            Operation.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return Operation;
        })();

        longrunning.GetOperationRequest = (function() {

            /**
             * Properties of a GetOperationRequest.
             * @memberof google.longrunning
             * @interface IGetOperationRequest
             * @property {string|null} [name] GetOperationRequest name
             */

            /**
             * Constructs a new GetOperationRequest.
             * @memberof google.longrunning
             * @classdesc Represents a GetOperationRequest.
             * @implements IGetOperationRequest
             * @constructor
             * @param {google.longrunning.IGetOperationRequest=} [properties] Properties to set
             */
            function GetOperationRequest(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * GetOperationRequest name.
             * @member {string} name
             * @memberof google.longrunning.GetOperationRequest
             * @instance
             */
            GetOperationRequest.prototype.name = "";

            /**
             * Creates a new GetOperationRequest instance using the specified properties.
             * @function create
             * @memberof google.longrunning.GetOperationRequest
             * @static
             * @param {google.longrunning.IGetOperationRequest=} [properties] Properties to set
             * @returns {google.longrunning.GetOperationRequest} GetOperationRequest instance
             */
            GetOperationRequest.create = function create(properties) {
                return new GetOperationRequest(properties);
            };

            /**
             * Encodes the specified GetOperationRequest message. Does not implicitly {@link google.longrunning.GetOperationRequest.verify|verify} messages.
             * @function encode
             * @memberof google.longrunning.GetOperationRequest
             * @static
             * @param {google.longrunning.IGetOperationRequest} message GetOperationRequest message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            GetOperationRequest.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.name != null && message.hasOwnProperty("name"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                return writer;
            };

            /**
             * Encodes the specified GetOperationRequest message, length delimited. Does not implicitly {@link google.longrunning.GetOperationRequest.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.longrunning.GetOperationRequest
             * @static
             * @param {google.longrunning.IGetOperationRequest} message GetOperationRequest message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            GetOperationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a GetOperationRequest message from the specified reader or buffer.
             * @function decode
             * @memberof google.longrunning.GetOperationRequest
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.longrunning.GetOperationRequest} GetOperationRequest
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            GetOperationRequest.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.longrunning.GetOperationRequest();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.name = reader.string();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a GetOperationRequest message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.longrunning.GetOperationRequest
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.longrunning.GetOperationRequest} GetOperationRequest
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            GetOperationRequest.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a GetOperationRequest message.
             * @function verify
             * @memberof google.longrunning.GetOperationRequest
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            GetOperationRequest.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.name != null && message.hasOwnProperty("name"))
                    if (!$util.isString(message.name))
                        return "name: string expected";
                return null;
            };

            /**
             * Creates a GetOperationRequest message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.longrunning.GetOperationRequest
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.longrunning.GetOperationRequest} GetOperationRequest
             */
            GetOperationRequest.fromObject = function fromObject(object) {
                if (object instanceof $root.google.longrunning.GetOperationRequest)
                    return object;
                var message = new $root.google.longrunning.GetOperationRequest();
                if (object.name != null)
                    message.name = String(object.name);
                return message;
            };

            /**
             * Creates a plain object from a GetOperationRequest message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.longrunning.GetOperationRequest
             * @static
             * @param {google.longrunning.GetOperationRequest} message GetOperationRequest
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            GetOperationRequest.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults)
                    object.name = "";
                if (message.name != null && message.hasOwnProperty("name"))
                    object.name = message.name;
                return object;
            };

            /**
             * Converts this GetOperationRequest to JSON.
             * @function toJSON
             * @memberof google.longrunning.GetOperationRequest
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            GetOperationRequest.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return GetOperationRequest;
        })();

        longrunning.ListOperationsRequest = (function() {

            /**
             * Properties of a ListOperationsRequest.
             * @memberof google.longrunning
             * @interface IListOperationsRequest
             * @property {string|null} [name] ListOperationsRequest name
             * @property {string|null} [filter] ListOperationsRequest filter
             * @property {number|null} [pageSize] ListOperationsRequest pageSize
             * @property {string|null} [pageToken] ListOperationsRequest pageToken
             */

            /**
             * Constructs a new ListOperationsRequest.
             * @memberof google.longrunning
             * @classdesc Represents a ListOperationsRequest.
             * @implements IListOperationsRequest
             * @constructor
             * @param {google.longrunning.IListOperationsRequest=} [properties] Properties to set
             */
            function ListOperationsRequest(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * ListOperationsRequest name.
             * @member {string} name
             * @memberof google.longrunning.ListOperationsRequest
             * @instance
             */
            ListOperationsRequest.prototype.name = "";

            /**
             * ListOperationsRequest filter.
             * @member {string} filter
             * @memberof google.longrunning.ListOperationsRequest
             * @instance
             */
            ListOperationsRequest.prototype.filter = "";

            /**
             * ListOperationsRequest pageSize.
             * @member {number} pageSize
             * @memberof google.longrunning.ListOperationsRequest
             * @instance
             */
            ListOperationsRequest.prototype.pageSize = 0;

            /**
             * ListOperationsRequest pageToken.
             * @member {string} pageToken
             * @memberof google.longrunning.ListOperationsRequest
             * @instance
             */
            ListOperationsRequest.prototype.pageToken = "";

            /**
             * Creates a new ListOperationsRequest instance using the specified properties.
             * @function create
             * @memberof google.longrunning.ListOperationsRequest
             * @static
             * @param {google.longrunning.IListOperationsRequest=} [properties] Properties to set
             * @returns {google.longrunning.ListOperationsRequest} ListOperationsRequest instance
             */
            ListOperationsRequest.create = function create(properties) {
                return new ListOperationsRequest(properties);
            };

            /**
             * Encodes the specified ListOperationsRequest message. Does not implicitly {@link google.longrunning.ListOperationsRequest.verify|verify} messages.
             * @function encode
             * @memberof google.longrunning.ListOperationsRequest
             * @static
             * @param {google.longrunning.IListOperationsRequest} message ListOperationsRequest message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            ListOperationsRequest.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.filter != null && message.hasOwnProperty("filter"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.filter);
                if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                    writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                    writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                if (message.name != null && message.hasOwnProperty("name"))
                    writer.uint32(/* id 4, wireType 2 =*/34).string(message.name);
                return writer;
            };

            /**
             * Encodes the specified ListOperationsRequest message, length delimited. Does not implicitly {@link google.longrunning.ListOperationsRequest.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.longrunning.ListOperationsRequest
             * @static
             * @param {google.longrunning.IListOperationsRequest} message ListOperationsRequest message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            ListOperationsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a ListOperationsRequest message from the specified reader or buffer.
             * @function decode
             * @memberof google.longrunning.ListOperationsRequest
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.longrunning.ListOperationsRequest} ListOperationsRequest
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            ListOperationsRequest.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.longrunning.ListOperationsRequest();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 4:
                        message.name = reader.string();
                        break;
                    case 1:
                        message.filter = reader.string();
                        break;
                    case 2:
                        message.pageSize = reader.int32();
                        break;
                    case 3:
                        message.pageToken = reader.string();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a ListOperationsRequest message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.longrunning.ListOperationsRequest
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.longrunning.ListOperationsRequest} ListOperationsRequest
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            ListOperationsRequest.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a ListOperationsRequest message.
             * @function verify
             * @memberof google.longrunning.ListOperationsRequest
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            ListOperationsRequest.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.name != null && message.hasOwnProperty("name"))
                    if (!$util.isString(message.name))
                        return "name: string expected";
                if (message.filter != null && message.hasOwnProperty("filter"))
                    if (!$util.isString(message.filter))
                        return "filter: string expected";
                if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                    if (!$util.isInteger(message.pageSize))
                        return "pageSize: integer expected";
                if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                    if (!$util.isString(message.pageToken))
                        return "pageToken: string expected";
                return null;
            };

            /**
             * Creates a ListOperationsRequest message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.longrunning.ListOperationsRequest
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.longrunning.ListOperationsRequest} ListOperationsRequest
             */
            ListOperationsRequest.fromObject = function fromObject(object) {
                if (object instanceof $root.google.longrunning.ListOperationsRequest)
                    return object;
                var message = new $root.google.longrunning.ListOperationsRequest();
                if (object.name != null)
                    message.name = String(object.name);
                if (object.filter != null)
                    message.filter = String(object.filter);
                if (object.pageSize != null)
                    message.pageSize = object.pageSize | 0;
                if (object.pageToken != null)
                    message.pageToken = String(object.pageToken);
                return message;
            };

            /**
             * Creates a plain object from a ListOperationsRequest message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.longrunning.ListOperationsRequest
             * @static
             * @param {google.longrunning.ListOperationsRequest} message ListOperationsRequest
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            ListOperationsRequest.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults) {
                    object.filter = "";
                    object.pageSize = 0;
                    object.pageToken = "";
                    object.name = "";
                }
                if (message.filter != null && message.hasOwnProperty("filter"))
                    object.filter = message.filter;
                if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                    object.pageSize = message.pageSize;
                if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                    object.pageToken = message.pageToken;
                if (message.name != null && message.hasOwnProperty("name"))
                    object.name = message.name;
                return object;
            };

            /**
             * Converts this ListOperationsRequest to JSON.
             * @function toJSON
             * @memberof google.longrunning.ListOperationsRequest
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            ListOperationsRequest.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return ListOperationsRequest;
        })();

        longrunning.ListOperationsResponse = (function() {

            /**
             * Properties of a ListOperationsResponse.
             * @memberof google.longrunning
             * @interface IListOperationsResponse
             * @property {Array.<google.longrunning.IOperation>|null} [operations] ListOperationsResponse operations
             * @property {string|null} [nextPageToken] ListOperationsResponse nextPageToken
             */

            /**
             * Constructs a new ListOperationsResponse.
             * @memberof google.longrunning
             * @classdesc Represents a ListOperationsResponse.
             * @implements IListOperationsResponse
             * @constructor
             * @param {google.longrunning.IListOperationsResponse=} [properties] Properties to set
             */
            function ListOperationsResponse(properties) {
                this.operations = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * ListOperationsResponse operations.
             * @member {Array.<google.longrunning.IOperation>} operations
             * @memberof google.longrunning.ListOperationsResponse
             * @instance
             */
            ListOperationsResponse.prototype.operations = $util.emptyArray;

            /**
             * ListOperationsResponse nextPageToken.
             * @member {string} nextPageToken
             * @memberof google.longrunning.ListOperationsResponse
             * @instance
             */
            ListOperationsResponse.prototype.nextPageToken = "";

            /**
             * Creates a new ListOperationsResponse instance using the specified properties.
             * @function create
             * @memberof google.longrunning.ListOperationsResponse
             * @static
             * @param {google.longrunning.IListOperationsResponse=} [properties] Properties to set
             * @returns {google.longrunning.ListOperationsResponse} ListOperationsResponse instance
             */
            ListOperationsResponse.create = function create(properties) {
                return new ListOperationsResponse(properties);
            };

            /**
             * Encodes the specified ListOperationsResponse message. Does not implicitly {@link google.longrunning.ListOperationsResponse.verify|verify} messages.
             * @function encode
             * @memberof google.longrunning.ListOperationsResponse
             * @static
             * @param {google.longrunning.IListOperationsResponse} message ListOperationsResponse message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            ListOperationsResponse.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.operations != null && message.operations.length)
                    for (var i = 0; i < message.operations.length; ++i)
                        $root.google.longrunning.Operation.encode(message.operations[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                return writer;
            };

            /**
             * Encodes the specified ListOperationsResponse message, length delimited. Does not implicitly {@link google.longrunning.ListOperationsResponse.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.longrunning.ListOperationsResponse
             * @static
             * @param {google.longrunning.IListOperationsResponse} message ListOperationsResponse message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            ListOperationsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a ListOperationsResponse message from the specified reader or buffer.
             * @function decode
             * @memberof google.longrunning.ListOperationsResponse
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.longrunning.ListOperationsResponse} ListOperationsResponse
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            ListOperationsResponse.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.longrunning.ListOperationsResponse();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        if (!(message.operations && message.operations.length))
                            message.operations = [];
                        message.operations.push($root.google.longrunning.Operation.decode(reader, reader.uint32()));
                        break;
                    case 2:
                        message.nextPageToken = reader.string();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a ListOperationsResponse message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.longrunning.ListOperationsResponse
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.longrunning.ListOperationsResponse} ListOperationsResponse
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            ListOperationsResponse.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a ListOperationsResponse message.
             * @function verify
             * @memberof google.longrunning.ListOperationsResponse
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            ListOperationsResponse.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.operations != null && message.hasOwnProperty("operations")) {
                    if (!Array.isArray(message.operations))
                        return "operations: array expected";
                    for (var i = 0; i < message.operations.length; ++i) {
                        var error = $root.google.longrunning.Operation.verify(message.operations[i]);
                        if (error)
                            return "operations." + error;
                    }
                }
                if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                    if (!$util.isString(message.nextPageToken))
                        return "nextPageToken: string expected";
                return null;
            };

            /**
             * Creates a ListOperationsResponse message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.longrunning.ListOperationsResponse
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.longrunning.ListOperationsResponse} ListOperationsResponse
             */
            ListOperationsResponse.fromObject = function fromObject(object) {
                if (object instanceof $root.google.longrunning.ListOperationsResponse)
                    return object;
                var message = new $root.google.longrunning.ListOperationsResponse();
                if (object.operations) {
                    if (!Array.isArray(object.operations))
                        throw TypeError(".google.longrunning.ListOperationsResponse.operations: array expected");
                    message.operations = [];
                    for (var i = 0; i < object.operations.length; ++i) {
                        if (typeof object.operations[i] !== "object")
                            throw TypeError(".google.longrunning.ListOperationsResponse.operations: object expected");
                        message.operations[i] = $root.google.longrunning.Operation.fromObject(object.operations[i]);
                    }
                }
                if (object.nextPageToken != null)
                    message.nextPageToken = String(object.nextPageToken);
                return message;
            };

            /**
             * Creates a plain object from a ListOperationsResponse message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.longrunning.ListOperationsResponse
             * @static
             * @param {google.longrunning.ListOperationsResponse} message ListOperationsResponse
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            ListOperationsResponse.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.operations = [];
                if (options.defaults)
                    object.nextPageToken = "";
                if (message.operations && message.operations.length) {
                    object.operations = [];
                    for (var j = 0; j < message.operations.length; ++j)
                        object.operations[j] = $root.google.longrunning.Operation.toObject(message.operations[j], options);
                }
                if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                    object.nextPageToken = message.nextPageToken;
                return object;
            };

            /**
             * Converts this ListOperationsResponse to JSON.
             * @function toJSON
             * @memberof google.longrunning.ListOperationsResponse
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            ListOperationsResponse.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return ListOperationsResponse;
        })();

        longrunning.CancelOperationRequest = (function() {

            /**
             * Properties of a CancelOperationRequest.
             * @memberof google.longrunning
             * @interface ICancelOperationRequest
             * @property {string|null} [name] CancelOperationRequest name
             */

            /**
             * Constructs a new CancelOperationRequest.
             * @memberof google.longrunning
             * @classdesc Represents a CancelOperationRequest.
             * @implements ICancelOperationRequest
             * @constructor
             * @param {google.longrunning.ICancelOperationRequest=} [properties] Properties to set
             */
            function CancelOperationRequest(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * CancelOperationRequest name.
             * @member {string} name
             * @memberof google.longrunning.CancelOperationRequest
             * @instance
             */
            CancelOperationRequest.prototype.name = "";

            /**
             * Creates a new CancelOperationRequest instance using the specified properties.
             * @function create
             * @memberof google.longrunning.CancelOperationRequest
             * @static
             * @param {google.longrunning.ICancelOperationRequest=} [properties] Properties to set
             * @returns {google.longrunning.CancelOperationRequest} CancelOperationRequest instance
             */
            CancelOperationRequest.create = function create(properties) {
                return new CancelOperationRequest(properties);
            };

            /**
             * Encodes the specified CancelOperationRequest message. Does not implicitly {@link google.longrunning.CancelOperationRequest.verify|verify} messages.
             * @function encode
             * @memberof google.longrunning.CancelOperationRequest
             * @static
             * @param {google.longrunning.ICancelOperationRequest} message CancelOperationRequest message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            CancelOperationRequest.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.name != null && message.hasOwnProperty("name"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                return writer;
            };

            /**
             * Encodes the specified CancelOperationRequest message, length delimited. Does not implicitly {@link google.longrunning.CancelOperationRequest.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.longrunning.CancelOperationRequest
             * @static
             * @param {google.longrunning.ICancelOperationRequest} message CancelOperationRequest message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            CancelOperationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a CancelOperationRequest message from the specified reader or buffer.
             * @function decode
             * @memberof google.longrunning.CancelOperationRequest
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.longrunning.CancelOperationRequest} CancelOperationRequest
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            CancelOperationRequest.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.longrunning.CancelOperationRequest();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.name = reader.string();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a CancelOperationRequest message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.longrunning.CancelOperationRequest
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.longrunning.CancelOperationRequest} CancelOperationRequest
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            CancelOperationRequest.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a CancelOperationRequest message.
             * @function verify
             * @memberof google.longrunning.CancelOperationRequest
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            CancelOperationRequest.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.name != null && message.hasOwnProperty("name"))
                    if (!$util.isString(message.name))
                        return "name: string expected";
                return null;
            };

            /**
             * Creates a CancelOperationRequest message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.longrunning.CancelOperationRequest
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.longrunning.CancelOperationRequest} CancelOperationRequest
             */
            CancelOperationRequest.fromObject = function fromObject(object) {
                if (object instanceof $root.google.longrunning.CancelOperationRequest)
                    return object;
                var message = new $root.google.longrunning.CancelOperationRequest();
                if (object.name != null)
                    message.name = String(object.name);
                return message;
            };

            /**
             * Creates a plain object from a CancelOperationRequest message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.longrunning.CancelOperationRequest
             * @static
             * @param {google.longrunning.CancelOperationRequest} message CancelOperationRequest
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            CancelOperationRequest.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults)
                    object.name = "";
                if (message.name != null && message.hasOwnProperty("name"))
                    object.name = message.name;
                return object;
            };

            /**
             * Converts this CancelOperationRequest to JSON.
             * @function toJSON
             * @memberof google.longrunning.CancelOperationRequest
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            CancelOperationRequest.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return CancelOperationRequest;
        })();

        longrunning.DeleteOperationRequest = (function() {

            /**
             * Properties of a DeleteOperationRequest.
             * @memberof google.longrunning
             * @interface IDeleteOperationRequest
             * @property {string|null} [name] DeleteOperationRequest name
             */

            /**
             * Constructs a new DeleteOperationRequest.
             * @memberof google.longrunning
             * @classdesc Represents a DeleteOperationRequest.
             * @implements IDeleteOperationRequest
             * @constructor
             * @param {google.longrunning.IDeleteOperationRequest=} [properties] Properties to set
             */
            function DeleteOperationRequest(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * DeleteOperationRequest name.
             * @member {string} name
             * @memberof google.longrunning.DeleteOperationRequest
             * @instance
             */
            DeleteOperationRequest.prototype.name = "";

            /**
             * Creates a new DeleteOperationRequest instance using the specified properties.
             * @function create
             * @memberof google.longrunning.DeleteOperationRequest
             * @static
             * @param {google.longrunning.IDeleteOperationRequest=} [properties] Properties to set
             * @returns {google.longrunning.DeleteOperationRequest} DeleteOperationRequest instance
             */
            DeleteOperationRequest.create = function create(properties) {
                return new DeleteOperationRequest(properties);
            };

            /**
             * Encodes the specified DeleteOperationRequest message. Does not implicitly {@link google.longrunning.DeleteOperationRequest.verify|verify} messages.
             * @function encode
             * @memberof google.longrunning.DeleteOperationRequest
             * @static
             * @param {google.longrunning.IDeleteOperationRequest} message DeleteOperationRequest message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            DeleteOperationRequest.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.name != null && message.hasOwnProperty("name"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                return writer;
            };

            /**
             * Encodes the specified DeleteOperationRequest message, length delimited. Does not implicitly {@link google.longrunning.DeleteOperationRequest.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.longrunning.DeleteOperationRequest
             * @static
             * @param {google.longrunning.IDeleteOperationRequest} message DeleteOperationRequest message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            DeleteOperationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a DeleteOperationRequest message from the specified reader or buffer.
             * @function decode
             * @memberof google.longrunning.DeleteOperationRequest
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.longrunning.DeleteOperationRequest} DeleteOperationRequest
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            DeleteOperationRequest.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.longrunning.DeleteOperationRequest();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.name = reader.string();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a DeleteOperationRequest message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.longrunning.DeleteOperationRequest
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.longrunning.DeleteOperationRequest} DeleteOperationRequest
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            DeleteOperationRequest.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a DeleteOperationRequest message.
             * @function verify
             * @memberof google.longrunning.DeleteOperationRequest
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            DeleteOperationRequest.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.name != null && message.hasOwnProperty("name"))
                    if (!$util.isString(message.name))
                        return "name: string expected";
                return null;
            };

            /**
             * Creates a DeleteOperationRequest message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.longrunning.DeleteOperationRequest
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.longrunning.DeleteOperationRequest} DeleteOperationRequest
             */
            DeleteOperationRequest.fromObject = function fromObject(object) {
                if (object instanceof $root.google.longrunning.DeleteOperationRequest)
                    return object;
                var message = new $root.google.longrunning.DeleteOperationRequest();
                if (object.name != null)
                    message.name = String(object.name);
                return message;
            };

            /**
             * Creates a plain object from a DeleteOperationRequest message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.longrunning.DeleteOperationRequest
             * @static
             * @param {google.longrunning.DeleteOperationRequest} message DeleteOperationRequest
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            DeleteOperationRequest.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults)
                    object.name = "";
                if (message.name != null && message.hasOwnProperty("name"))
                    object.name = message.name;
                return object;
            };

            /**
             * Converts this DeleteOperationRequest to JSON.
             * @function toJSON
             * @memberof google.longrunning.DeleteOperationRequest
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            DeleteOperationRequest.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return DeleteOperationRequest;
        })();

        longrunning.WaitOperationRequest = (function() {

            /**
             * Properties of a WaitOperationRequest.
             * @memberof google.longrunning
             * @interface IWaitOperationRequest
             * @property {string|null} [name] WaitOperationRequest name
             * @property {google.protobuf.IDuration|null} [timeout] WaitOperationRequest timeout
             */

            /**
             * Constructs a new WaitOperationRequest.
             * @memberof google.longrunning
             * @classdesc Represents a WaitOperationRequest.
             * @implements IWaitOperationRequest
             * @constructor
             * @param {google.longrunning.IWaitOperationRequest=} [properties] Properties to set
             */
            function WaitOperationRequest(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * WaitOperationRequest name.
             * @member {string} name
             * @memberof google.longrunning.WaitOperationRequest
             * @instance
             */
            WaitOperationRequest.prototype.name = "";

            /**
             * WaitOperationRequest timeout.
             * @member {google.protobuf.IDuration|null|undefined} timeout
             * @memberof google.longrunning.WaitOperationRequest
             * @instance
             */
            WaitOperationRequest.prototype.timeout = null;

            /**
             * Creates a new WaitOperationRequest instance using the specified properties.
             * @function create
             * @memberof google.longrunning.WaitOperationRequest
             * @static
             * @param {google.longrunning.IWaitOperationRequest=} [properties] Properties to set
             * @returns {google.longrunning.WaitOperationRequest} WaitOperationRequest instance
             */
            WaitOperationRequest.create = function create(properties) {
                return new WaitOperationRequest(properties);
            };

            /**
             * Encodes the specified WaitOperationRequest message. Does not implicitly {@link google.longrunning.WaitOperationRequest.verify|verify} messages.
             * @function encode
             * @memberof google.longrunning.WaitOperationRequest
             * @static
             * @param {google.longrunning.IWaitOperationRequest} message WaitOperationRequest message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            WaitOperationRequest.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.name != null && message.hasOwnProperty("name"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                if (message.timeout != null && message.hasOwnProperty("timeout"))
                    $root.google.protobuf.Duration.encode(message.timeout, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified WaitOperationRequest message, length delimited. Does not implicitly {@link google.longrunning.WaitOperationRequest.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.longrunning.WaitOperationRequest
             * @static
             * @param {google.longrunning.IWaitOperationRequest} message WaitOperationRequest message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            WaitOperationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a WaitOperationRequest message from the specified reader or buffer.
             * @function decode
             * @memberof google.longrunning.WaitOperationRequest
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.longrunning.WaitOperationRequest} WaitOperationRequest
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            WaitOperationRequest.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.longrunning.WaitOperationRequest();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.name = reader.string();
                        break;
                    case 2:
                        message.timeout = $root.google.protobuf.Duration.decode(reader, reader.uint32());
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a WaitOperationRequest message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.longrunning.WaitOperationRequest
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.longrunning.WaitOperationRequest} WaitOperationRequest
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            WaitOperationRequest.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a WaitOperationRequest message.
             * @function verify
             * @memberof google.longrunning.WaitOperationRequest
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            WaitOperationRequest.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.name != null && message.hasOwnProperty("name"))
                    if (!$util.isString(message.name))
                        return "name: string expected";
                if (message.timeout != null && message.hasOwnProperty("timeout")) {
                    var error = $root.google.protobuf.Duration.verify(message.timeout);
                    if (error)
                        return "timeout." + error;
                }
                return null;
            };

            /**
             * Creates a WaitOperationRequest message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.longrunning.WaitOperationRequest
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.longrunning.WaitOperationRequest} WaitOperationRequest
             */
            WaitOperationRequest.fromObject = function fromObject(object) {
                if (object instanceof $root.google.longrunning.WaitOperationRequest)
                    return object;
                var message = new $root.google.longrunning.WaitOperationRequest();
                if (object.name != null)
                    message.name = String(object.name);
                if (object.timeout != null) {
                    if (typeof object.timeout !== "object")
                        throw TypeError(".google.longrunning.WaitOperationRequest.timeout: object expected");
                    message.timeout = $root.google.protobuf.Duration.fromObject(object.timeout);
                }
                return message;
            };

            /**
             * Creates a plain object from a WaitOperationRequest message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.longrunning.WaitOperationRequest
             * @static
             * @param {google.longrunning.WaitOperationRequest} message WaitOperationRequest
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            WaitOperationRequest.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults) {
                    object.name = "";
                    object.timeout = null;
                }
                if (message.name != null && message.hasOwnProperty("name"))
                    object.name = message.name;
                if (message.timeout != null && message.hasOwnProperty("timeout"))
                    object.timeout = $root.google.protobuf.Duration.toObject(message.timeout, options);
                return object;
            };

            /**
             * Converts this WaitOperationRequest to JSON.
             * @function toJSON
             * @memberof google.longrunning.WaitOperationRequest
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            WaitOperationRequest.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return WaitOperationRequest;
        })();

        longrunning.OperationInfo = (function() {

            /**
             * Properties of an OperationInfo.
             * @memberof google.longrunning
             * @interface IOperationInfo
             * @property {string|null} [responseType] OperationInfo responseType
             * @property {string|null} [metadataType] OperationInfo metadataType
             */

            /**
             * Constructs a new OperationInfo.
             * @memberof google.longrunning
             * @classdesc Represents an OperationInfo.
             * @implements IOperationInfo
             * @constructor
             * @param {google.longrunning.IOperationInfo=} [properties] Properties to set
             */
            function OperationInfo(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * OperationInfo responseType.
             * @member {string} responseType
             * @memberof google.longrunning.OperationInfo
             * @instance
             */
            OperationInfo.prototype.responseType = "";

            /**
             * OperationInfo metadataType.
             * @member {string} metadataType
             * @memberof google.longrunning.OperationInfo
             * @instance
             */
            OperationInfo.prototype.metadataType = "";

            /**
             * Creates a new OperationInfo instance using the specified properties.
             * @function create
             * @memberof google.longrunning.OperationInfo
             * @static
             * @param {google.longrunning.IOperationInfo=} [properties] Properties to set
             * @returns {google.longrunning.OperationInfo} OperationInfo instance
             */
            OperationInfo.create = function create(properties) {
                return new OperationInfo(properties);
            };

            /**
             * Encodes the specified OperationInfo message. Does not implicitly {@link google.longrunning.OperationInfo.verify|verify} messages.
             * @function encode
             * @memberof google.longrunning.OperationInfo
             * @static
             * @param {google.longrunning.IOperationInfo} message OperationInfo message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            OperationInfo.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.responseType != null && message.hasOwnProperty("responseType"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.responseType);
                if (message.metadataType != null && message.hasOwnProperty("metadataType"))
                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.metadataType);
                return writer;
            };

            /**
             * Encodes the specified OperationInfo message, length delimited. Does not implicitly {@link google.longrunning.OperationInfo.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.longrunning.OperationInfo
             * @static
             * @param {google.longrunning.IOperationInfo} message OperationInfo message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            OperationInfo.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes an OperationInfo message from the specified reader or buffer.
             * @function decode
             * @memberof google.longrunning.OperationInfo
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.longrunning.OperationInfo} OperationInfo
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            OperationInfo.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.longrunning.OperationInfo();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.responseType = reader.string();
                        break;
                    case 2:
                        message.metadataType = reader.string();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes an OperationInfo message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.longrunning.OperationInfo
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.longrunning.OperationInfo} OperationInfo
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            OperationInfo.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies an OperationInfo message.
             * @function verify
             * @memberof google.longrunning.OperationInfo
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            OperationInfo.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.responseType != null && message.hasOwnProperty("responseType"))
                    if (!$util.isString(message.responseType))
                        return "responseType: string expected";
                if (message.metadataType != null && message.hasOwnProperty("metadataType"))
                    if (!$util.isString(message.metadataType))
                        return "metadataType: string expected";
                return null;
            };

            /**
             * Creates an OperationInfo message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.longrunning.OperationInfo
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.longrunning.OperationInfo} OperationInfo
             */
            OperationInfo.fromObject = function fromObject(object) {
                if (object instanceof $root.google.longrunning.OperationInfo)
                    return object;
                var message = new $root.google.longrunning.OperationInfo();
                if (object.responseType != null)
                    message.responseType = String(object.responseType);
                if (object.metadataType != null)
                    message.metadataType = String(object.metadataType);
                return message;
            };

            /**
             * Creates a plain object from an OperationInfo message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.longrunning.OperationInfo
             * @static
             * @param {google.longrunning.OperationInfo} message OperationInfo
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            OperationInfo.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults) {
                    object.responseType = "";
                    object.metadataType = "";
                }
                if (message.responseType != null && message.hasOwnProperty("responseType"))
                    object.responseType = message.responseType;
                if (message.metadataType != null && message.hasOwnProperty("metadataType"))
                    object.metadataType = message.metadataType;
                return object;
            };

            /**
             * Converts this OperationInfo to JSON.
             * @function toJSON
             * @memberof google.longrunning.OperationInfo
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            OperationInfo.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return OperationInfo;
        })();

        return longrunning;
    })();

    google.api = (function() {

        /**
         * Namespace api.
         * @memberof google
         * @namespace
         */
        var api = {};

        api.Http = (function() {

            /**
             * Properties of a Http.
             * @memberof google.api
             * @interface IHttp
             * @property {Array.<google.api.IHttpRule>|null} [rules] Http rules
             */

            /**
             * Constructs a new Http.
             * @memberof google.api
             * @classdesc Represents a Http.
             * @implements IHttp
             * @constructor
             * @param {google.api.IHttp=} [properties] Properties to set
             */
            function Http(properties) {
                this.rules = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * Http rules.
             * @member {Array.<google.api.IHttpRule>} rules
             * @memberof google.api.Http
             * @instance
             */
            Http.prototype.rules = $util.emptyArray;

            /**
             * Creates a new Http instance using the specified properties.
             * @function create
             * @memberof google.api.Http
             * @static
             * @param {google.api.IHttp=} [properties] Properties to set
             * @returns {google.api.Http} Http instance
             */
            Http.create = function create(properties) {
                return new Http(properties);
            };

            /**
             * Encodes the specified Http message. Does not implicitly {@link google.api.Http.verify|verify} messages.
             * @function encode
             * @memberof google.api.Http
             * @static
             * @param {google.api.IHttp} message Http message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Http.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.rules != null && message.rules.length)
                    for (var i = 0; i < message.rules.length; ++i)
                        $root.google.api.HttpRule.encode(message.rules[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified Http message, length delimited. Does not implicitly {@link google.api.Http.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.api.Http
             * @static
             * @param {google.api.IHttp} message Http message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Http.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a Http message from the specified reader or buffer.
             * @function decode
             * @memberof google.api.Http
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.api.Http} Http
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Http.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.Http();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        if (!(message.rules && message.rules.length))
                            message.rules = [];
                        message.rules.push($root.google.api.HttpRule.decode(reader, reader.uint32()));
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a Http message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.api.Http
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.api.Http} Http
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Http.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a Http message.
             * @function verify
             * @memberof google.api.Http
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            Http.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.rules != null && message.hasOwnProperty("rules")) {
                    if (!Array.isArray(message.rules))
                        return "rules: array expected";
                    for (var i = 0; i < message.rules.length; ++i) {
                        var error = $root.google.api.HttpRule.verify(message.rules[i]);
                        if (error)
                            return "rules." + error;
                    }
                }
                return null;
            };

            /**
             * Creates a Http message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.api.Http
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.api.Http} Http
             */
            Http.fromObject = function fromObject(object) {
                if (object instanceof $root.google.api.Http)
                    return object;
                var message = new $root.google.api.Http();
                if (object.rules) {
                    if (!Array.isArray(object.rules))
                        throw TypeError(".google.api.Http.rules: array expected");
                    message.rules = [];
                    for (var i = 0; i < object.rules.length; ++i) {
                        if (typeof object.rules[i] !== "object")
                            throw TypeError(".google.api.Http.rules: object expected");
                        message.rules[i] = $root.google.api.HttpRule.fromObject(object.rules[i]);
                    }
                }
                return message;
            };

            /**
             * Creates a plain object from a Http message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.api.Http
             * @static
             * @param {google.api.Http} message Http
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            Http.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.rules = [];
                if (message.rules && message.rules.length) {
                    object.rules = [];
                    for (var j = 0; j < message.rules.length; ++j)
                        object.rules[j] = $root.google.api.HttpRule.toObject(message.rules[j], options);
                }
                return object;
            };

            /**
             * Converts this Http to JSON.
             * @function toJSON
             * @memberof google.api.Http
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            Http.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return Http;
        })();

        api.HttpRule = (function() {

            /**
             * Properties of a HttpRule.
             * @memberof google.api
             * @interface IHttpRule
             * @property {string|null} [get] HttpRule get
             * @property {string|null} [put] HttpRule put
             * @property {string|null} [post] HttpRule post
             * @property {string|null} ["delete"] HttpRule delete
             * @property {string|null} [patch] HttpRule patch
             * @property {google.api.ICustomHttpPattern|null} [custom] HttpRule custom
             * @property {string|null} [selector] HttpRule selector
             * @property {string|null} [body] HttpRule body
             * @property {Array.<google.api.IHttpRule>|null} [additionalBindings] HttpRule additionalBindings
             */

            /**
             * Constructs a new HttpRule.
             * @memberof google.api
             * @classdesc Represents a HttpRule.
             * @implements IHttpRule
             * @constructor
             * @param {google.api.IHttpRule=} [properties] Properties to set
             */
            function HttpRule(properties) {
                this.additionalBindings = [];
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * HttpRule get.
             * @member {string} get
             * @memberof google.api.HttpRule
             * @instance
             */
            HttpRule.prototype.get = "";

            /**
             * HttpRule put.
             * @member {string} put
             * @memberof google.api.HttpRule
             * @instance
             */
            HttpRule.prototype.put = "";

            /**
             * HttpRule post.
             * @member {string} post
             * @memberof google.api.HttpRule
             * @instance
             */
            HttpRule.prototype.post = "";

            /**
             * HttpRule delete.
             * @member {string} delete
             * @memberof google.api.HttpRule
             * @instance
             */
            HttpRule.prototype["delete"] = "";

            /**
             * HttpRule patch.
             * @member {string} patch
             * @memberof google.api.HttpRule
             * @instance
             */
            HttpRule.prototype.patch = "";

            /**
             * HttpRule custom.
             * @member {google.api.ICustomHttpPattern|null|undefined} custom
             * @memberof google.api.HttpRule
             * @instance
             */
            HttpRule.prototype.custom = null;

            /**
             * HttpRule selector.
             * @member {string} selector
             * @memberof google.api.HttpRule
             * @instance
             */
            HttpRule.prototype.selector = "";

            /**
             * HttpRule body.
             * @member {string} body
             * @memberof google.api.HttpRule
             * @instance
             */
            HttpRule.prototype.body = "";

            /**
             * HttpRule additionalBindings.
             * @member {Array.<google.api.IHttpRule>} additionalBindings
             * @memberof google.api.HttpRule
             * @instance
             */
            HttpRule.prototype.additionalBindings = $util.emptyArray;

            // OneOf field names bound to virtual getters and setters
            var $oneOfFields;

            /**
             * HttpRule pattern.
             * @member {"get"|"put"|"post"|"delete"|"patch"|"custom"|undefined} pattern
             * @memberof google.api.HttpRule
             * @instance
             */
            Object.defineProperty(HttpRule.prototype, "pattern", {
                get: $util.oneOfGetter($oneOfFields = ["get", "put", "post", "delete", "patch", "custom"]),
                set: $util.oneOfSetter($oneOfFields)
            });

            /**
             * Creates a new HttpRule instance using the specified properties.
             * @function create
             * @memberof google.api.HttpRule
             * @static
             * @param {google.api.IHttpRule=} [properties] Properties to set
             * @returns {google.api.HttpRule} HttpRule instance
             */
            HttpRule.create = function create(properties) {
                return new HttpRule(properties);
            };

            /**
             * Encodes the specified HttpRule message. Does not implicitly {@link google.api.HttpRule.verify|verify} messages.
             * @function encode
             * @memberof google.api.HttpRule
             * @static
             * @param {google.api.IHttpRule} message HttpRule message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            HttpRule.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.selector != null && message.hasOwnProperty("selector"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.selector);
                if (message.get != null && message.hasOwnProperty("get"))
                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.get);
                if (message.put != null && message.hasOwnProperty("put"))
                    writer.uint32(/* id 3, wireType 2 =*/26).string(message.put);
                if (message.post != null && message.hasOwnProperty("post"))
                    writer.uint32(/* id 4, wireType 2 =*/34).string(message.post);
                if (message["delete"] != null && message.hasOwnProperty("delete"))
                    writer.uint32(/* id 5, wireType 2 =*/42).string(message["delete"]);
                if (message.patch != null && message.hasOwnProperty("patch"))
                    writer.uint32(/* id 6, wireType 2 =*/50).string(message.patch);
                if (message.body != null && message.hasOwnProperty("body"))
                    writer.uint32(/* id 7, wireType 2 =*/58).string(message.body);
                if (message.custom != null && message.hasOwnProperty("custom"))
                    $root.google.api.CustomHttpPattern.encode(message.custom, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                if (message.additionalBindings != null && message.additionalBindings.length)
                    for (var i = 0; i < message.additionalBindings.length; ++i)
                        $root.google.api.HttpRule.encode(message.additionalBindings[i], writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                return writer;
            };

            /**
             * Encodes the specified HttpRule message, length delimited. Does not implicitly {@link google.api.HttpRule.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.api.HttpRule
             * @static
             * @param {google.api.IHttpRule} message HttpRule message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            HttpRule.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a HttpRule message from the specified reader or buffer.
             * @function decode
             * @memberof google.api.HttpRule
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.api.HttpRule} HttpRule
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            HttpRule.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.HttpRule();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 2:
                        message.get = reader.string();
                        break;
                    case 3:
                        message.put = reader.string();
                        break;
                    case 4:
                        message.post = reader.string();
                        break;
                    case 5:
                        message["delete"] = reader.string();
                        break;
                    case 6:
                        message.patch = reader.string();
                        break;
                    case 8:
                        message.custom = $root.google.api.CustomHttpPattern.decode(reader, reader.uint32());
                        break;
                    case 1:
                        message.selector = reader.string();
                        break;
                    case 7:
                        message.body = reader.string();
                        break;
                    case 11:
                        if (!(message.additionalBindings && message.additionalBindings.length))
                            message.additionalBindings = [];
                        message.additionalBindings.push($root.google.api.HttpRule.decode(reader, reader.uint32()));
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a HttpRule message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.api.HttpRule
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.api.HttpRule} HttpRule
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            HttpRule.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a HttpRule message.
             * @function verify
             * @memberof google.api.HttpRule
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            HttpRule.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                var properties = {};
                if (message.get != null && message.hasOwnProperty("get")) {
                    properties.pattern = 1;
                    if (!$util.isString(message.get))
                        return "get: string expected";
                }
                if (message.put != null && message.hasOwnProperty("put")) {
                    if (properties.pattern === 1)
                        return "pattern: multiple values";
                    properties.pattern = 1;
                    if (!$util.isString(message.put))
                        return "put: string expected";
                }
                if (message.post != null && message.hasOwnProperty("post")) {
                    if (properties.pattern === 1)
                        return "pattern: multiple values";
                    properties.pattern = 1;
                    if (!$util.isString(message.post))
                        return "post: string expected";
                }
                if (message["delete"] != null && message.hasOwnProperty("delete")) {
                    if (properties.pattern === 1)
                        return "pattern: multiple values";
                    properties.pattern = 1;
                    if (!$util.isString(message["delete"]))
                        return "delete: string expected";
                }
                if (message.patch != null && message.hasOwnProperty("patch")) {
                    if (properties.pattern === 1)
                        return "pattern: multiple values";
                    properties.pattern = 1;
                    if (!$util.isString(message.patch))
                        return "patch: string expected";
                }
                if (message.custom != null && message.hasOwnProperty("custom")) {
                    if (properties.pattern === 1)
                        return "pattern: multiple values";
                    properties.pattern = 1;
                    {
                        var error = $root.google.api.CustomHttpPattern.verify(message.custom);
                        if (error)
                            return "custom." + error;
                    }
                }
                if (message.selector != null && message.hasOwnProperty("selector"))
                    if (!$util.isString(message.selector))
                        return "selector: string expected";
                if (message.body != null && message.hasOwnProperty("body"))
                    if (!$util.isString(message.body))
                        return "body: string expected";
                if (message.additionalBindings != null && message.hasOwnProperty("additionalBindings")) {
                    if (!Array.isArray(message.additionalBindings))
                        return "additionalBindings: array expected";
                    for (var i = 0; i < message.additionalBindings.length; ++i) {
                        var error = $root.google.api.HttpRule.verify(message.additionalBindings[i]);
                        if (error)
                            return "additionalBindings." + error;
                    }
                }
                return null;
            };

            /**
             * Creates a HttpRule message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.api.HttpRule
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.api.HttpRule} HttpRule
             */
            HttpRule.fromObject = function fromObject(object) {
                if (object instanceof $root.google.api.HttpRule)
                    return object;
                var message = new $root.google.api.HttpRule();
                if (object.get != null)
                    message.get = String(object.get);
                if (object.put != null)
                    message.put = String(object.put);
                if (object.post != null)
                    message.post = String(object.post);
                if (object["delete"] != null)
                    message["delete"] = String(object["delete"]);
                if (object.patch != null)
                    message.patch = String(object.patch);
                if (object.custom != null) {
                    if (typeof object.custom !== "object")
                        throw TypeError(".google.api.HttpRule.custom: object expected");
                    message.custom = $root.google.api.CustomHttpPattern.fromObject(object.custom);
                }
                if (object.selector != null)
                    message.selector = String(object.selector);
                if (object.body != null)
                    message.body = String(object.body);
                if (object.additionalBindings) {
                    if (!Array.isArray(object.additionalBindings))
                        throw TypeError(".google.api.HttpRule.additionalBindings: array expected");
                    message.additionalBindings = [];
                    for (var i = 0; i < object.additionalBindings.length; ++i) {
                        if (typeof object.additionalBindings[i] !== "object")
                            throw TypeError(".google.api.HttpRule.additionalBindings: object expected");
                        message.additionalBindings[i] = $root.google.api.HttpRule.fromObject(object.additionalBindings[i]);
                    }
                }
                return message;
            };

            /**
             * Creates a plain object from a HttpRule message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.api.HttpRule
             * @static
             * @param {google.api.HttpRule} message HttpRule
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            HttpRule.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.additionalBindings = [];
                if (options.defaults) {
                    object.selector = "";
                    object.body = "";
                }
                if (message.selector != null && message.hasOwnProperty("selector"))
                    object.selector = message.selector;
                if (message.get != null && message.hasOwnProperty("get")) {
                    object.get = message.get;
                    if (options.oneofs)
                        object.pattern = "get";
                }
                if (message.put != null && message.hasOwnProperty("put")) {
                    object.put = message.put;
                    if (options.oneofs)
                        object.pattern = "put";
                }
                if (message.post != null && message.hasOwnProperty("post")) {
                    object.post = message.post;
                    if (options.oneofs)
                        object.pattern = "post";
                }
                if (message["delete"] != null && message.hasOwnProperty("delete")) {
                    object["delete"] = message["delete"];
                    if (options.oneofs)
                        object.pattern = "delete";
                }
                if (message.patch != null && message.hasOwnProperty("patch")) {
                    object.patch = message.patch;
                    if (options.oneofs)
                        object.pattern = "patch";
                }
                if (message.body != null && message.hasOwnProperty("body"))
                    object.body = message.body;
                if (message.custom != null && message.hasOwnProperty("custom")) {
                    object.custom = $root.google.api.CustomHttpPattern.toObject(message.custom, options);
                    if (options.oneofs)
                        object.pattern = "custom";
                }
                if (message.additionalBindings && message.additionalBindings.length) {
                    object.additionalBindings = [];
                    for (var j = 0; j < message.additionalBindings.length; ++j)
                        object.additionalBindings[j] = $root.google.api.HttpRule.toObject(message.additionalBindings[j], options);
                }
                return object;
            };

            /**
             * Converts this HttpRule to JSON.
             * @function toJSON
             * @memberof google.api.HttpRule
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            HttpRule.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return HttpRule;
        })();

        api.CustomHttpPattern = (function() {

            /**
             * Properties of a CustomHttpPattern.
             * @memberof google.api
             * @interface ICustomHttpPattern
             * @property {string|null} [kind] CustomHttpPattern kind
             * @property {string|null} [path] CustomHttpPattern path
             */

            /**
             * Constructs a new CustomHttpPattern.
             * @memberof google.api
             * @classdesc Represents a CustomHttpPattern.
             * @implements ICustomHttpPattern
             * @constructor
             * @param {google.api.ICustomHttpPattern=} [properties] Properties to set
             */
            function CustomHttpPattern(properties) {
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * CustomHttpPattern kind.
             * @member {string} kind
             * @memberof google.api.CustomHttpPattern
             * @instance
             */
            CustomHttpPattern.prototype.kind = "";

            /**
             * CustomHttpPattern path.
             * @member {string} path
             * @memberof google.api.CustomHttpPattern
             * @instance
             */
            CustomHttpPattern.prototype.path = "";

            /**
             * Creates a new CustomHttpPattern instance using the specified properties.
             * @function create
             * @memberof google.api.CustomHttpPattern
             * @static
             * @param {google.api.ICustomHttpPattern=} [properties] Properties to set
             * @returns {google.api.CustomHttpPattern} CustomHttpPattern instance
             */
            CustomHttpPattern.create = function create(properties) {
                return new CustomHttpPattern(properties);
            };

            /**
             * Encodes the specified CustomHttpPattern message. Does not implicitly {@link google.api.CustomHttpPattern.verify|verify} messages.
             * @function encode
             * @memberof google.api.CustomHttpPattern
             * @static
             * @param {google.api.ICustomHttpPattern} message CustomHttpPattern message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            CustomHttpPattern.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.kind != null && message.hasOwnProperty("kind"))
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.kind);
                if (message.path != null && message.hasOwnProperty("path"))
                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.path);
                return writer;
            };

            /**
             * Encodes the specified CustomHttpPattern message, length delimited. Does not implicitly {@link google.api.CustomHttpPattern.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.api.CustomHttpPattern
             * @static
             * @param {google.api.ICustomHttpPattern} message CustomHttpPattern message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            CustomHttpPattern.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a CustomHttpPattern message from the specified reader or buffer.
             * @function decode
             * @memberof google.api.CustomHttpPattern
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.api.CustomHttpPattern} CustomHttpPattern
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            CustomHttpPattern.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.CustomHttpPattern();
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        message.kind = reader.string();
                        break;
                    case 2:
                        message.path = reader.string();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a CustomHttpPattern message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.api.CustomHttpPattern
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.api.CustomHttpPattern} CustomHttpPattern
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            CustomHttpPattern.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a CustomHttpPattern message.
             * @function verify
             * @memberof google.api.CustomHttpPattern
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            CustomHttpPattern.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.kind != null && message.hasOwnProperty("kind"))
                    if (!$util.isString(message.kind))
                        return "kind: string expected";
                if (message.path != null && message.hasOwnProperty("path"))
                    if (!$util.isString(message.path))
                        return "path: string expected";
                return null;
            };

            /**
             * Creates a CustomHttpPattern message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.api.CustomHttpPattern
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.api.CustomHttpPattern} CustomHttpPattern
             */
            CustomHttpPattern.fromObject = function fromObject(object) {
                if (object instanceof $root.google.api.CustomHttpPattern)
                    return object;
                var message = new $root.google.api.CustomHttpPattern();
                if (object.kind != null)
                    message.kind = String(object.kind);
                if (object.path != null)
                    message.path = String(object.path);
                return message;
            };

            /**
             * Creates a plain object from a CustomHttpPattern message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.api.CustomHttpPattern
             * @static
             * @param {google.api.CustomHttpPattern} message CustomHttpPattern
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            CustomHttpPattern.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.defaults) {
                    object.kind = "";
                    object.path = "";
                }
                if (message.kind != null && message.hasOwnProperty("kind"))
                    object.kind = message.kind;
                if (message.path != null && message.hasOwnProperty("path"))
                    object.path = message.path;
                return object;
            };

            /**
             * Converts this CustomHttpPattern to JSON.
             * @function toJSON
             * @memberof google.api.CustomHttpPattern
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            CustomHttpPattern.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            return CustomHttpPattern;
        })();

        return api;
    })();

    google.ads = (function() {

        /**
         * Namespace ads.
         * @memberof google
         * @namespace
         */
        var ads = {};

        ads.googleads = (function() {

            /**
             * Namespace googleads.
             * @memberof google.ads
             * @namespace
             */
            var googleads = {};

            googleads.v1 = (function() {

                /**
                 * Namespace v1.
                 * @memberof google.ads.googleads
                 * @namespace
                 */
                var v1 = {};

                v1.common = (function() {

                    /**
                     * Namespace common.
                     * @memberof google.ads.googleads.v1
                     * @namespace
                     */
                    var common = {};

                    common.AdTextAsset = (function() {

                        /**
                         * Properties of an AdTextAsset.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IAdTextAsset
                         * @property {google.protobuf.IStringValue|null} [text] AdTextAsset text
                         * @property {google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum.ServedAssetFieldType|null} [pinnedField] AdTextAsset pinnedField
                         */

                        /**
                         * Constructs a new AdTextAsset.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an AdTextAsset.
                         * @implements IAdTextAsset
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IAdTextAsset=} [properties] Properties to set
                         */
                        function AdTextAsset(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdTextAsset text.
                         * @member {google.protobuf.IStringValue|null|undefined} text
                         * @memberof google.ads.googleads.v1.common.AdTextAsset
                         * @instance
                         */
                        AdTextAsset.prototype.text = null;

                        /**
                         * AdTextAsset pinnedField.
                         * @member {google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum.ServedAssetFieldType} pinnedField
                         * @memberof google.ads.googleads.v1.common.AdTextAsset
                         * @instance
                         */
                        AdTextAsset.prototype.pinnedField = 0;

                        /**
                         * Creates a new AdTextAsset instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.AdTextAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IAdTextAsset=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.AdTextAsset} AdTextAsset instance
                         */
                        AdTextAsset.create = function create(properties) {
                            return new AdTextAsset(properties);
                        };

                        /**
                         * Encodes the specified AdTextAsset message. Does not implicitly {@link google.ads.googleads.v1.common.AdTextAsset.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.AdTextAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IAdTextAsset} message AdTextAsset message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdTextAsset.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.text != null && message.hasOwnProperty("text"))
                                $root.google.protobuf.StringValue.encode(message.text, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.pinnedField != null && message.hasOwnProperty("pinnedField"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pinnedField);
                            return writer;
                        };

                        /**
                         * Encodes the specified AdTextAsset message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.AdTextAsset.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.AdTextAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IAdTextAsset} message AdTextAsset message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdTextAsset.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdTextAsset message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.AdTextAsset
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.AdTextAsset} AdTextAsset
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdTextAsset.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.AdTextAsset();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.text = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.pinnedField = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdTextAsset message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.AdTextAsset
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.AdTextAsset} AdTextAsset
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdTextAsset.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdTextAsset message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.AdTextAsset
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdTextAsset.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.text != null && message.hasOwnProperty("text")) {
                                var error = $root.google.protobuf.StringValue.verify(message.text);
                                if (error)
                                    return "text." + error;
                            }
                            if (message.pinnedField != null && message.hasOwnProperty("pinnedField"))
                                switch (message.pinnedField) {
                                default:
                                    return "pinnedField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates an AdTextAsset message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.AdTextAsset
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.AdTextAsset} AdTextAsset
                         */
                        AdTextAsset.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.AdTextAsset)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.AdTextAsset();
                            if (object.text != null) {
                                if (typeof object.text !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AdTextAsset.text: object expected");
                                message.text = $root.google.protobuf.StringValue.fromObject(object.text);
                            }
                            switch (object.pinnedField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.pinnedField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.pinnedField = 1;
                                break;
                            case "HEADLINE_1":
                            case 2:
                                message.pinnedField = 2;
                                break;
                            case "HEADLINE_2":
                            case 3:
                                message.pinnedField = 3;
                                break;
                            case "HEADLINE_3":
                            case 4:
                                message.pinnedField = 4;
                                break;
                            case "DESCRIPTION_1":
                            case 5:
                                message.pinnedField = 5;
                                break;
                            case "DESCRIPTION_2":
                            case 6:
                                message.pinnedField = 6;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdTextAsset message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.AdTextAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.AdTextAsset} message AdTextAsset
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdTextAsset.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.text = null;
                                object.pinnedField = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.text != null && message.hasOwnProperty("text"))
                                object.text = $root.google.protobuf.StringValue.toObject(message.text, options);
                            if (message.pinnedField != null && message.hasOwnProperty("pinnedField"))
                                object.pinnedField = options.enums === String ? $root.google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum.ServedAssetFieldType[message.pinnedField] : message.pinnedField;
                            return object;
                        };

                        /**
                         * Converts this AdTextAsset to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.AdTextAsset
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdTextAsset.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdTextAsset;
                    })();

                    common.AdImageAsset = (function() {

                        /**
                         * Properties of an AdImageAsset.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IAdImageAsset
                         * @property {google.protobuf.IStringValue|null} [asset] AdImageAsset asset
                         */

                        /**
                         * Constructs a new AdImageAsset.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an AdImageAsset.
                         * @implements IAdImageAsset
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IAdImageAsset=} [properties] Properties to set
                         */
                        function AdImageAsset(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdImageAsset asset.
                         * @member {google.protobuf.IStringValue|null|undefined} asset
                         * @memberof google.ads.googleads.v1.common.AdImageAsset
                         * @instance
                         */
                        AdImageAsset.prototype.asset = null;

                        /**
                         * Creates a new AdImageAsset instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.AdImageAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IAdImageAsset=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.AdImageAsset} AdImageAsset instance
                         */
                        AdImageAsset.create = function create(properties) {
                            return new AdImageAsset(properties);
                        };

                        /**
                         * Encodes the specified AdImageAsset message. Does not implicitly {@link google.ads.googleads.v1.common.AdImageAsset.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.AdImageAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IAdImageAsset} message AdImageAsset message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdImageAsset.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.asset != null && message.hasOwnProperty("asset"))
                                $root.google.protobuf.StringValue.encode(message.asset, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdImageAsset message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.AdImageAsset.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.AdImageAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IAdImageAsset} message AdImageAsset message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdImageAsset.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdImageAsset message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.AdImageAsset
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.AdImageAsset} AdImageAsset
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdImageAsset.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.AdImageAsset();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.asset = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdImageAsset message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.AdImageAsset
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.AdImageAsset} AdImageAsset
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdImageAsset.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdImageAsset message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.AdImageAsset
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdImageAsset.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.asset != null && message.hasOwnProperty("asset")) {
                                var error = $root.google.protobuf.StringValue.verify(message.asset);
                                if (error)
                                    return "asset." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an AdImageAsset message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.AdImageAsset
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.AdImageAsset} AdImageAsset
                         */
                        AdImageAsset.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.AdImageAsset)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.AdImageAsset();
                            if (object.asset != null) {
                                if (typeof object.asset !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AdImageAsset.asset: object expected");
                                message.asset = $root.google.protobuf.StringValue.fromObject(object.asset);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdImageAsset message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.AdImageAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.AdImageAsset} message AdImageAsset
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdImageAsset.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.asset = null;
                            if (message.asset != null && message.hasOwnProperty("asset"))
                                object.asset = $root.google.protobuf.StringValue.toObject(message.asset, options);
                            return object;
                        };

                        /**
                         * Converts this AdImageAsset to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.AdImageAsset
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdImageAsset.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdImageAsset;
                    })();

                    common.AdVideoAsset = (function() {

                        /**
                         * Properties of an AdVideoAsset.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IAdVideoAsset
                         * @property {google.protobuf.IStringValue|null} [asset] AdVideoAsset asset
                         */

                        /**
                         * Constructs a new AdVideoAsset.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an AdVideoAsset.
                         * @implements IAdVideoAsset
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IAdVideoAsset=} [properties] Properties to set
                         */
                        function AdVideoAsset(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdVideoAsset asset.
                         * @member {google.protobuf.IStringValue|null|undefined} asset
                         * @memberof google.ads.googleads.v1.common.AdVideoAsset
                         * @instance
                         */
                        AdVideoAsset.prototype.asset = null;

                        /**
                         * Creates a new AdVideoAsset instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.AdVideoAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IAdVideoAsset=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.AdVideoAsset} AdVideoAsset instance
                         */
                        AdVideoAsset.create = function create(properties) {
                            return new AdVideoAsset(properties);
                        };

                        /**
                         * Encodes the specified AdVideoAsset message. Does not implicitly {@link google.ads.googleads.v1.common.AdVideoAsset.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.AdVideoAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IAdVideoAsset} message AdVideoAsset message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdVideoAsset.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.asset != null && message.hasOwnProperty("asset"))
                                $root.google.protobuf.StringValue.encode(message.asset, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdVideoAsset message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.AdVideoAsset.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.AdVideoAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IAdVideoAsset} message AdVideoAsset message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdVideoAsset.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdVideoAsset message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.AdVideoAsset
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.AdVideoAsset} AdVideoAsset
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdVideoAsset.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.AdVideoAsset();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.asset = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdVideoAsset message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.AdVideoAsset
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.AdVideoAsset} AdVideoAsset
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdVideoAsset.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdVideoAsset message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.AdVideoAsset
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdVideoAsset.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.asset != null && message.hasOwnProperty("asset")) {
                                var error = $root.google.protobuf.StringValue.verify(message.asset);
                                if (error)
                                    return "asset." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an AdVideoAsset message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.AdVideoAsset
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.AdVideoAsset} AdVideoAsset
                         */
                        AdVideoAsset.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.AdVideoAsset)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.AdVideoAsset();
                            if (object.asset != null) {
                                if (typeof object.asset !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AdVideoAsset.asset: object expected");
                                message.asset = $root.google.protobuf.StringValue.fromObject(object.asset);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdVideoAsset message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.AdVideoAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.AdVideoAsset} message AdVideoAsset
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdVideoAsset.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.asset = null;
                            if (message.asset != null && message.hasOwnProperty("asset"))
                                object.asset = $root.google.protobuf.StringValue.toObject(message.asset, options);
                            return object;
                        };

                        /**
                         * Converts this AdVideoAsset to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.AdVideoAsset
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdVideoAsset.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdVideoAsset;
                    })();

                    common.AdMediaBundleAsset = (function() {

                        /**
                         * Properties of an AdMediaBundleAsset.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IAdMediaBundleAsset
                         * @property {google.protobuf.IStringValue|null} [asset] AdMediaBundleAsset asset
                         */

                        /**
                         * Constructs a new AdMediaBundleAsset.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an AdMediaBundleAsset.
                         * @implements IAdMediaBundleAsset
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IAdMediaBundleAsset=} [properties] Properties to set
                         */
                        function AdMediaBundleAsset(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdMediaBundleAsset asset.
                         * @member {google.protobuf.IStringValue|null|undefined} asset
                         * @memberof google.ads.googleads.v1.common.AdMediaBundleAsset
                         * @instance
                         */
                        AdMediaBundleAsset.prototype.asset = null;

                        /**
                         * Creates a new AdMediaBundleAsset instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.AdMediaBundleAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IAdMediaBundleAsset=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.AdMediaBundleAsset} AdMediaBundleAsset instance
                         */
                        AdMediaBundleAsset.create = function create(properties) {
                            return new AdMediaBundleAsset(properties);
                        };

                        /**
                         * Encodes the specified AdMediaBundleAsset message. Does not implicitly {@link google.ads.googleads.v1.common.AdMediaBundleAsset.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.AdMediaBundleAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IAdMediaBundleAsset} message AdMediaBundleAsset message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdMediaBundleAsset.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.asset != null && message.hasOwnProperty("asset"))
                                $root.google.protobuf.StringValue.encode(message.asset, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdMediaBundleAsset message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.AdMediaBundleAsset.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.AdMediaBundleAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IAdMediaBundleAsset} message AdMediaBundleAsset message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdMediaBundleAsset.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdMediaBundleAsset message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.AdMediaBundleAsset
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.AdMediaBundleAsset} AdMediaBundleAsset
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdMediaBundleAsset.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.AdMediaBundleAsset();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.asset = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdMediaBundleAsset message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.AdMediaBundleAsset
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.AdMediaBundleAsset} AdMediaBundleAsset
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdMediaBundleAsset.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdMediaBundleAsset message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.AdMediaBundleAsset
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdMediaBundleAsset.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.asset != null && message.hasOwnProperty("asset")) {
                                var error = $root.google.protobuf.StringValue.verify(message.asset);
                                if (error)
                                    return "asset." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an AdMediaBundleAsset message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.AdMediaBundleAsset
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.AdMediaBundleAsset} AdMediaBundleAsset
                         */
                        AdMediaBundleAsset.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.AdMediaBundleAsset)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.AdMediaBundleAsset();
                            if (object.asset != null) {
                                if (typeof object.asset !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AdMediaBundleAsset.asset: object expected");
                                message.asset = $root.google.protobuf.StringValue.fromObject(object.asset);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdMediaBundleAsset message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.AdMediaBundleAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.AdMediaBundleAsset} message AdMediaBundleAsset
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdMediaBundleAsset.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.asset = null;
                            if (message.asset != null && message.hasOwnProperty("asset"))
                                object.asset = $root.google.protobuf.StringValue.toObject(message.asset, options);
                            return object;
                        };

                        /**
                         * Converts this AdMediaBundleAsset to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.AdMediaBundleAsset
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdMediaBundleAsset.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdMediaBundleAsset;
                    })();

                    common.TextAdInfo = (function() {

                        /**
                         * Properties of a TextAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ITextAdInfo
                         * @property {google.protobuf.IStringValue|null} [headline] TextAdInfo headline
                         * @property {google.protobuf.IStringValue|null} [description1] TextAdInfo description1
                         * @property {google.protobuf.IStringValue|null} [description2] TextAdInfo description2
                         */

                        /**
                         * Constructs a new TextAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a TextAdInfo.
                         * @implements ITextAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ITextAdInfo=} [properties] Properties to set
                         */
                        function TextAdInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * TextAdInfo headline.
                         * @member {google.protobuf.IStringValue|null|undefined} headline
                         * @memberof google.ads.googleads.v1.common.TextAdInfo
                         * @instance
                         */
                        TextAdInfo.prototype.headline = null;

                        /**
                         * TextAdInfo description1.
                         * @member {google.protobuf.IStringValue|null|undefined} description1
                         * @memberof google.ads.googleads.v1.common.TextAdInfo
                         * @instance
                         */
                        TextAdInfo.prototype.description1 = null;

                        /**
                         * TextAdInfo description2.
                         * @member {google.protobuf.IStringValue|null|undefined} description2
                         * @memberof google.ads.googleads.v1.common.TextAdInfo
                         * @instance
                         */
                        TextAdInfo.prototype.description2 = null;

                        /**
                         * Creates a new TextAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.TextAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ITextAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.TextAdInfo} TextAdInfo instance
                         */
                        TextAdInfo.create = function create(properties) {
                            return new TextAdInfo(properties);
                        };

                        /**
                         * Encodes the specified TextAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.TextAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.TextAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ITextAdInfo} message TextAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TextAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.headline != null && message.hasOwnProperty("headline"))
                                $root.google.protobuf.StringValue.encode(message.headline, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.description1 != null && message.hasOwnProperty("description1"))
                                $root.google.protobuf.StringValue.encode(message.description1, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.description2 != null && message.hasOwnProperty("description2"))
                                $root.google.protobuf.StringValue.encode(message.description2, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified TextAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.TextAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.TextAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ITextAdInfo} message TextAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TextAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TextAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.TextAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.TextAdInfo} TextAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TextAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.TextAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.headline = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.description1 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.description2 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TextAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.TextAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.TextAdInfo} TextAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TextAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TextAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.TextAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TextAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.headline != null && message.hasOwnProperty("headline")) {
                                var error = $root.google.protobuf.StringValue.verify(message.headline);
                                if (error)
                                    return "headline." + error;
                            }
                            if (message.description1 != null && message.hasOwnProperty("description1")) {
                                var error = $root.google.protobuf.StringValue.verify(message.description1);
                                if (error)
                                    return "description1." + error;
                            }
                            if (message.description2 != null && message.hasOwnProperty("description2")) {
                                var error = $root.google.protobuf.StringValue.verify(message.description2);
                                if (error)
                                    return "description2." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a TextAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.TextAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.TextAdInfo} TextAdInfo
                         */
                        TextAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.TextAdInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.TextAdInfo();
                            if (object.headline != null) {
                                if (typeof object.headline !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TextAdInfo.headline: object expected");
                                message.headline = $root.google.protobuf.StringValue.fromObject(object.headline);
                            }
                            if (object.description1 != null) {
                                if (typeof object.description1 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TextAdInfo.description1: object expected");
                                message.description1 = $root.google.protobuf.StringValue.fromObject(object.description1);
                            }
                            if (object.description2 != null) {
                                if (typeof object.description2 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TextAdInfo.description2: object expected");
                                message.description2 = $root.google.protobuf.StringValue.fromObject(object.description2);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a TextAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.TextAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.TextAdInfo} message TextAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TextAdInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.headline = null;
                                object.description1 = null;
                                object.description2 = null;
                            }
                            if (message.headline != null && message.hasOwnProperty("headline"))
                                object.headline = $root.google.protobuf.StringValue.toObject(message.headline, options);
                            if (message.description1 != null && message.hasOwnProperty("description1"))
                                object.description1 = $root.google.protobuf.StringValue.toObject(message.description1, options);
                            if (message.description2 != null && message.hasOwnProperty("description2"))
                                object.description2 = $root.google.protobuf.StringValue.toObject(message.description2, options);
                            return object;
                        };

                        /**
                         * Converts this TextAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.TextAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TextAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return TextAdInfo;
                    })();

                    common.ExpandedTextAdInfo = (function() {

                        /**
                         * Properties of an ExpandedTextAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IExpandedTextAdInfo
                         * @property {google.protobuf.IStringValue|null} [headlinePart1] ExpandedTextAdInfo headlinePart1
                         * @property {google.protobuf.IStringValue|null} [headlinePart2] ExpandedTextAdInfo headlinePart2
                         * @property {google.protobuf.IStringValue|null} [headlinePart3] ExpandedTextAdInfo headlinePart3
                         * @property {google.protobuf.IStringValue|null} [description] ExpandedTextAdInfo description
                         * @property {google.protobuf.IStringValue|null} [description2] ExpandedTextAdInfo description2
                         * @property {google.protobuf.IStringValue|null} [path1] ExpandedTextAdInfo path1
                         * @property {google.protobuf.IStringValue|null} [path2] ExpandedTextAdInfo path2
                         */

                        /**
                         * Constructs a new ExpandedTextAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an ExpandedTextAdInfo.
                         * @implements IExpandedTextAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IExpandedTextAdInfo=} [properties] Properties to set
                         */
                        function ExpandedTextAdInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ExpandedTextAdInfo headlinePart1.
                         * @member {google.protobuf.IStringValue|null|undefined} headlinePart1
                         * @memberof google.ads.googleads.v1.common.ExpandedTextAdInfo
                         * @instance
                         */
                        ExpandedTextAdInfo.prototype.headlinePart1 = null;

                        /**
                         * ExpandedTextAdInfo headlinePart2.
                         * @member {google.protobuf.IStringValue|null|undefined} headlinePart2
                         * @memberof google.ads.googleads.v1.common.ExpandedTextAdInfo
                         * @instance
                         */
                        ExpandedTextAdInfo.prototype.headlinePart2 = null;

                        /**
                         * ExpandedTextAdInfo headlinePart3.
                         * @member {google.protobuf.IStringValue|null|undefined} headlinePart3
                         * @memberof google.ads.googleads.v1.common.ExpandedTextAdInfo
                         * @instance
                         */
                        ExpandedTextAdInfo.prototype.headlinePart3 = null;

                        /**
                         * ExpandedTextAdInfo description.
                         * @member {google.protobuf.IStringValue|null|undefined} description
                         * @memberof google.ads.googleads.v1.common.ExpandedTextAdInfo
                         * @instance
                         */
                        ExpandedTextAdInfo.prototype.description = null;

                        /**
                         * ExpandedTextAdInfo description2.
                         * @member {google.protobuf.IStringValue|null|undefined} description2
                         * @memberof google.ads.googleads.v1.common.ExpandedTextAdInfo
                         * @instance
                         */
                        ExpandedTextAdInfo.prototype.description2 = null;

                        /**
                         * ExpandedTextAdInfo path1.
                         * @member {google.protobuf.IStringValue|null|undefined} path1
                         * @memberof google.ads.googleads.v1.common.ExpandedTextAdInfo
                         * @instance
                         */
                        ExpandedTextAdInfo.prototype.path1 = null;

                        /**
                         * ExpandedTextAdInfo path2.
                         * @member {google.protobuf.IStringValue|null|undefined} path2
                         * @memberof google.ads.googleads.v1.common.ExpandedTextAdInfo
                         * @instance
                         */
                        ExpandedTextAdInfo.prototype.path2 = null;

                        /**
                         * Creates a new ExpandedTextAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ExpandedTextAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IExpandedTextAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ExpandedTextAdInfo} ExpandedTextAdInfo instance
                         */
                        ExpandedTextAdInfo.create = function create(properties) {
                            return new ExpandedTextAdInfo(properties);
                        };

                        /**
                         * Encodes the specified ExpandedTextAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ExpandedTextAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ExpandedTextAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IExpandedTextAdInfo} message ExpandedTextAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExpandedTextAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.headlinePart1 != null && message.hasOwnProperty("headlinePart1"))
                                $root.google.protobuf.StringValue.encode(message.headlinePart1, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.headlinePart2 != null && message.hasOwnProperty("headlinePart2"))
                                $root.google.protobuf.StringValue.encode(message.headlinePart2, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.description != null && message.hasOwnProperty("description"))
                                $root.google.protobuf.StringValue.encode(message.description, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.path1 != null && message.hasOwnProperty("path1"))
                                $root.google.protobuf.StringValue.encode(message.path1, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.path2 != null && message.hasOwnProperty("path2"))
                                $root.google.protobuf.StringValue.encode(message.path2, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.headlinePart3 != null && message.hasOwnProperty("headlinePart3"))
                                $root.google.protobuf.StringValue.encode(message.headlinePart3, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.description2 != null && message.hasOwnProperty("description2"))
                                $root.google.protobuf.StringValue.encode(message.description2, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ExpandedTextAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ExpandedTextAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ExpandedTextAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IExpandedTextAdInfo} message ExpandedTextAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExpandedTextAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ExpandedTextAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ExpandedTextAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ExpandedTextAdInfo} ExpandedTextAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExpandedTextAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ExpandedTextAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.headlinePart1 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.headlinePart2 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.headlinePart3 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.description = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.description2 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.path1 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.path2 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ExpandedTextAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ExpandedTextAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ExpandedTextAdInfo} ExpandedTextAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExpandedTextAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ExpandedTextAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ExpandedTextAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExpandedTextAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.headlinePart1 != null && message.hasOwnProperty("headlinePart1")) {
                                var error = $root.google.protobuf.StringValue.verify(message.headlinePart1);
                                if (error)
                                    return "headlinePart1." + error;
                            }
                            if (message.headlinePart2 != null && message.hasOwnProperty("headlinePart2")) {
                                var error = $root.google.protobuf.StringValue.verify(message.headlinePart2);
                                if (error)
                                    return "headlinePart2." + error;
                            }
                            if (message.headlinePart3 != null && message.hasOwnProperty("headlinePart3")) {
                                var error = $root.google.protobuf.StringValue.verify(message.headlinePart3);
                                if (error)
                                    return "headlinePart3." + error;
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                var error = $root.google.protobuf.StringValue.verify(message.description);
                                if (error)
                                    return "description." + error;
                            }
                            if (message.description2 != null && message.hasOwnProperty("description2")) {
                                var error = $root.google.protobuf.StringValue.verify(message.description2);
                                if (error)
                                    return "description2." + error;
                            }
                            if (message.path1 != null && message.hasOwnProperty("path1")) {
                                var error = $root.google.protobuf.StringValue.verify(message.path1);
                                if (error)
                                    return "path1." + error;
                            }
                            if (message.path2 != null && message.hasOwnProperty("path2")) {
                                var error = $root.google.protobuf.StringValue.verify(message.path2);
                                if (error)
                                    return "path2." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an ExpandedTextAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ExpandedTextAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ExpandedTextAdInfo} ExpandedTextAdInfo
                         */
                        ExpandedTextAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ExpandedTextAdInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ExpandedTextAdInfo();
                            if (object.headlinePart1 != null) {
                                if (typeof object.headlinePart1 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ExpandedTextAdInfo.headlinePart1: object expected");
                                message.headlinePart1 = $root.google.protobuf.StringValue.fromObject(object.headlinePart1);
                            }
                            if (object.headlinePart2 != null) {
                                if (typeof object.headlinePart2 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ExpandedTextAdInfo.headlinePart2: object expected");
                                message.headlinePart2 = $root.google.protobuf.StringValue.fromObject(object.headlinePart2);
                            }
                            if (object.headlinePart3 != null) {
                                if (typeof object.headlinePart3 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ExpandedTextAdInfo.headlinePart3: object expected");
                                message.headlinePart3 = $root.google.protobuf.StringValue.fromObject(object.headlinePart3);
                            }
                            if (object.description != null) {
                                if (typeof object.description !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ExpandedTextAdInfo.description: object expected");
                                message.description = $root.google.protobuf.StringValue.fromObject(object.description);
                            }
                            if (object.description2 != null) {
                                if (typeof object.description2 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ExpandedTextAdInfo.description2: object expected");
                                message.description2 = $root.google.protobuf.StringValue.fromObject(object.description2);
                            }
                            if (object.path1 != null) {
                                if (typeof object.path1 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ExpandedTextAdInfo.path1: object expected");
                                message.path1 = $root.google.protobuf.StringValue.fromObject(object.path1);
                            }
                            if (object.path2 != null) {
                                if (typeof object.path2 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ExpandedTextAdInfo.path2: object expected");
                                message.path2 = $root.google.protobuf.StringValue.fromObject(object.path2);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an ExpandedTextAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ExpandedTextAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ExpandedTextAdInfo} message ExpandedTextAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExpandedTextAdInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.headlinePart1 = null;
                                object.headlinePart2 = null;
                                object.description = null;
                                object.path1 = null;
                                object.path2 = null;
                                object.headlinePart3 = null;
                                object.description2 = null;
                            }
                            if (message.headlinePart1 != null && message.hasOwnProperty("headlinePart1"))
                                object.headlinePart1 = $root.google.protobuf.StringValue.toObject(message.headlinePart1, options);
                            if (message.headlinePart2 != null && message.hasOwnProperty("headlinePart2"))
                                object.headlinePart2 = $root.google.protobuf.StringValue.toObject(message.headlinePart2, options);
                            if (message.description != null && message.hasOwnProperty("description"))
                                object.description = $root.google.protobuf.StringValue.toObject(message.description, options);
                            if (message.path1 != null && message.hasOwnProperty("path1"))
                                object.path1 = $root.google.protobuf.StringValue.toObject(message.path1, options);
                            if (message.path2 != null && message.hasOwnProperty("path2"))
                                object.path2 = $root.google.protobuf.StringValue.toObject(message.path2, options);
                            if (message.headlinePart3 != null && message.hasOwnProperty("headlinePart3"))
                                object.headlinePart3 = $root.google.protobuf.StringValue.toObject(message.headlinePart3, options);
                            if (message.description2 != null && message.hasOwnProperty("description2"))
                                object.description2 = $root.google.protobuf.StringValue.toObject(message.description2, options);
                            return object;
                        };

                        /**
                         * Converts this ExpandedTextAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ExpandedTextAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExpandedTextAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ExpandedTextAdInfo;
                    })();

                    common.CallOnlyAdInfo = (function() {

                        /**
                         * Properties of a CallOnlyAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ICallOnlyAdInfo
                         * @property {google.protobuf.IStringValue|null} [countryCode] CallOnlyAdInfo countryCode
                         * @property {google.protobuf.IStringValue|null} [phoneNumber] CallOnlyAdInfo phoneNumber
                         * @property {google.protobuf.IStringValue|null} [businessName] CallOnlyAdInfo businessName
                         * @property {google.protobuf.IStringValue|null} [headline1] CallOnlyAdInfo headline1
                         * @property {google.protobuf.IStringValue|null} [headline2] CallOnlyAdInfo headline2
                         * @property {google.protobuf.IStringValue|null} [description1] CallOnlyAdInfo description1
                         * @property {google.protobuf.IStringValue|null} [description2] CallOnlyAdInfo description2
                         * @property {google.protobuf.IBoolValue|null} [callTracked] CallOnlyAdInfo callTracked
                         * @property {google.protobuf.IBoolValue|null} [disableCallConversion] CallOnlyAdInfo disableCallConversion
                         * @property {google.protobuf.IStringValue|null} [phoneNumberVerificationUrl] CallOnlyAdInfo phoneNumberVerificationUrl
                         * @property {google.protobuf.IStringValue|null} [conversionAction] CallOnlyAdInfo conversionAction
                         * @property {google.ads.googleads.v1.enums.CallConversionReportingStateEnum.CallConversionReportingState|null} [conversionReportingState] CallOnlyAdInfo conversionReportingState
                         */

                        /**
                         * Constructs a new CallOnlyAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a CallOnlyAdInfo.
                         * @implements ICallOnlyAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ICallOnlyAdInfo=} [properties] Properties to set
                         */
                        function CallOnlyAdInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CallOnlyAdInfo countryCode.
                         * @member {google.protobuf.IStringValue|null|undefined} countryCode
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @instance
                         */
                        CallOnlyAdInfo.prototype.countryCode = null;

                        /**
                         * CallOnlyAdInfo phoneNumber.
                         * @member {google.protobuf.IStringValue|null|undefined} phoneNumber
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @instance
                         */
                        CallOnlyAdInfo.prototype.phoneNumber = null;

                        /**
                         * CallOnlyAdInfo businessName.
                         * @member {google.protobuf.IStringValue|null|undefined} businessName
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @instance
                         */
                        CallOnlyAdInfo.prototype.businessName = null;

                        /**
                         * CallOnlyAdInfo headline1.
                         * @member {google.protobuf.IStringValue|null|undefined} headline1
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @instance
                         */
                        CallOnlyAdInfo.prototype.headline1 = null;

                        /**
                         * CallOnlyAdInfo headline2.
                         * @member {google.protobuf.IStringValue|null|undefined} headline2
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @instance
                         */
                        CallOnlyAdInfo.prototype.headline2 = null;

                        /**
                         * CallOnlyAdInfo description1.
                         * @member {google.protobuf.IStringValue|null|undefined} description1
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @instance
                         */
                        CallOnlyAdInfo.prototype.description1 = null;

                        /**
                         * CallOnlyAdInfo description2.
                         * @member {google.protobuf.IStringValue|null|undefined} description2
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @instance
                         */
                        CallOnlyAdInfo.prototype.description2 = null;

                        /**
                         * CallOnlyAdInfo callTracked.
                         * @member {google.protobuf.IBoolValue|null|undefined} callTracked
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @instance
                         */
                        CallOnlyAdInfo.prototype.callTracked = null;

                        /**
                         * CallOnlyAdInfo disableCallConversion.
                         * @member {google.protobuf.IBoolValue|null|undefined} disableCallConversion
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @instance
                         */
                        CallOnlyAdInfo.prototype.disableCallConversion = null;

                        /**
                         * CallOnlyAdInfo phoneNumberVerificationUrl.
                         * @member {google.protobuf.IStringValue|null|undefined} phoneNumberVerificationUrl
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @instance
                         */
                        CallOnlyAdInfo.prototype.phoneNumberVerificationUrl = null;

                        /**
                         * CallOnlyAdInfo conversionAction.
                         * @member {google.protobuf.IStringValue|null|undefined} conversionAction
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @instance
                         */
                        CallOnlyAdInfo.prototype.conversionAction = null;

                        /**
                         * CallOnlyAdInfo conversionReportingState.
                         * @member {google.ads.googleads.v1.enums.CallConversionReportingStateEnum.CallConversionReportingState} conversionReportingState
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @instance
                         */
                        CallOnlyAdInfo.prototype.conversionReportingState = 0;

                        /**
                         * Creates a new CallOnlyAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ICallOnlyAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.CallOnlyAdInfo} CallOnlyAdInfo instance
                         */
                        CallOnlyAdInfo.create = function create(properties) {
                            return new CallOnlyAdInfo(properties);
                        };

                        /**
                         * Encodes the specified CallOnlyAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.CallOnlyAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ICallOnlyAdInfo} message CallOnlyAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CallOnlyAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                $root.google.protobuf.StringValue.encode(message.countryCode, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.phoneNumber != null && message.hasOwnProperty("phoneNumber"))
                                $root.google.protobuf.StringValue.encode(message.phoneNumber, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.businessName != null && message.hasOwnProperty("businessName"))
                                $root.google.protobuf.StringValue.encode(message.businessName, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.description1 != null && message.hasOwnProperty("description1"))
                                $root.google.protobuf.StringValue.encode(message.description1, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.description2 != null && message.hasOwnProperty("description2"))
                                $root.google.protobuf.StringValue.encode(message.description2, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.callTracked != null && message.hasOwnProperty("callTracked"))
                                $root.google.protobuf.BoolValue.encode(message.callTracked, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.disableCallConversion != null && message.hasOwnProperty("disableCallConversion"))
                                $root.google.protobuf.BoolValue.encode(message.disableCallConversion, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.phoneNumberVerificationUrl != null && message.hasOwnProperty("phoneNumberVerificationUrl"))
                                $root.google.protobuf.StringValue.encode(message.phoneNumberVerificationUrl, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                $root.google.protobuf.StringValue.encode(message.conversionAction, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.conversionReportingState != null && message.hasOwnProperty("conversionReportingState"))
                                writer.uint32(/* id 10, wireType 0 =*/80).int32(message.conversionReportingState);
                            if (message.headline1 != null && message.hasOwnProperty("headline1"))
                                $root.google.protobuf.StringValue.encode(message.headline1, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.headline2 != null && message.hasOwnProperty("headline2"))
                                $root.google.protobuf.StringValue.encode(message.headline2, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CallOnlyAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.CallOnlyAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ICallOnlyAdInfo} message CallOnlyAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CallOnlyAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CallOnlyAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.CallOnlyAdInfo} CallOnlyAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CallOnlyAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.CallOnlyAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.countryCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.phoneNumber = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.businessName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.headline1 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.headline2 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.description1 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.description2 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.callTracked = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.disableCallConversion = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.phoneNumberVerificationUrl = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.conversionAction = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.conversionReportingState = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CallOnlyAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.CallOnlyAdInfo} CallOnlyAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CallOnlyAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CallOnlyAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CallOnlyAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.countryCode != null && message.hasOwnProperty("countryCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.countryCode);
                                if (error)
                                    return "countryCode." + error;
                            }
                            if (message.phoneNumber != null && message.hasOwnProperty("phoneNumber")) {
                                var error = $root.google.protobuf.StringValue.verify(message.phoneNumber);
                                if (error)
                                    return "phoneNumber." + error;
                            }
                            if (message.businessName != null && message.hasOwnProperty("businessName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.businessName);
                                if (error)
                                    return "businessName." + error;
                            }
                            if (message.headline1 != null && message.hasOwnProperty("headline1")) {
                                var error = $root.google.protobuf.StringValue.verify(message.headline1);
                                if (error)
                                    return "headline1." + error;
                            }
                            if (message.headline2 != null && message.hasOwnProperty("headline2")) {
                                var error = $root.google.protobuf.StringValue.verify(message.headline2);
                                if (error)
                                    return "headline2." + error;
                            }
                            if (message.description1 != null && message.hasOwnProperty("description1")) {
                                var error = $root.google.protobuf.StringValue.verify(message.description1);
                                if (error)
                                    return "description1." + error;
                            }
                            if (message.description2 != null && message.hasOwnProperty("description2")) {
                                var error = $root.google.protobuf.StringValue.verify(message.description2);
                                if (error)
                                    return "description2." + error;
                            }
                            if (message.callTracked != null && message.hasOwnProperty("callTracked")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.callTracked);
                                if (error)
                                    return "callTracked." + error;
                            }
                            if (message.disableCallConversion != null && message.hasOwnProperty("disableCallConversion")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.disableCallConversion);
                                if (error)
                                    return "disableCallConversion." + error;
                            }
                            if (message.phoneNumberVerificationUrl != null && message.hasOwnProperty("phoneNumberVerificationUrl")) {
                                var error = $root.google.protobuf.StringValue.verify(message.phoneNumberVerificationUrl);
                                if (error)
                                    return "phoneNumberVerificationUrl." + error;
                            }
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction")) {
                                var error = $root.google.protobuf.StringValue.verify(message.conversionAction);
                                if (error)
                                    return "conversionAction." + error;
                            }
                            if (message.conversionReportingState != null && message.hasOwnProperty("conversionReportingState"))
                                switch (message.conversionReportingState) {
                                default:
                                    return "conversionReportingState: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a CallOnlyAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.CallOnlyAdInfo} CallOnlyAdInfo
                         */
                        CallOnlyAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.CallOnlyAdInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.CallOnlyAdInfo();
                            if (object.countryCode != null) {
                                if (typeof object.countryCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CallOnlyAdInfo.countryCode: object expected");
                                message.countryCode = $root.google.protobuf.StringValue.fromObject(object.countryCode);
                            }
                            if (object.phoneNumber != null) {
                                if (typeof object.phoneNumber !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CallOnlyAdInfo.phoneNumber: object expected");
                                message.phoneNumber = $root.google.protobuf.StringValue.fromObject(object.phoneNumber);
                            }
                            if (object.businessName != null) {
                                if (typeof object.businessName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CallOnlyAdInfo.businessName: object expected");
                                message.businessName = $root.google.protobuf.StringValue.fromObject(object.businessName);
                            }
                            if (object.headline1 != null) {
                                if (typeof object.headline1 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CallOnlyAdInfo.headline1: object expected");
                                message.headline1 = $root.google.protobuf.StringValue.fromObject(object.headline1);
                            }
                            if (object.headline2 != null) {
                                if (typeof object.headline2 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CallOnlyAdInfo.headline2: object expected");
                                message.headline2 = $root.google.protobuf.StringValue.fromObject(object.headline2);
                            }
                            if (object.description1 != null) {
                                if (typeof object.description1 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CallOnlyAdInfo.description1: object expected");
                                message.description1 = $root.google.protobuf.StringValue.fromObject(object.description1);
                            }
                            if (object.description2 != null) {
                                if (typeof object.description2 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CallOnlyAdInfo.description2: object expected");
                                message.description2 = $root.google.protobuf.StringValue.fromObject(object.description2);
                            }
                            if (object.callTracked != null) {
                                if (typeof object.callTracked !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CallOnlyAdInfo.callTracked: object expected");
                                message.callTracked = $root.google.protobuf.BoolValue.fromObject(object.callTracked);
                            }
                            if (object.disableCallConversion != null) {
                                if (typeof object.disableCallConversion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CallOnlyAdInfo.disableCallConversion: object expected");
                                message.disableCallConversion = $root.google.protobuf.BoolValue.fromObject(object.disableCallConversion);
                            }
                            if (object.phoneNumberVerificationUrl != null) {
                                if (typeof object.phoneNumberVerificationUrl !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CallOnlyAdInfo.phoneNumberVerificationUrl: object expected");
                                message.phoneNumberVerificationUrl = $root.google.protobuf.StringValue.fromObject(object.phoneNumberVerificationUrl);
                            }
                            if (object.conversionAction != null) {
                                if (typeof object.conversionAction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CallOnlyAdInfo.conversionAction: object expected");
                                message.conversionAction = $root.google.protobuf.StringValue.fromObject(object.conversionAction);
                            }
                            switch (object.conversionReportingState) {
                            case "UNSPECIFIED":
                            case 0:
                                message.conversionReportingState = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.conversionReportingState = 1;
                                break;
                            case "DISABLED":
                            case 2:
                                message.conversionReportingState = 2;
                                break;
                            case "USE_ACCOUNT_LEVEL_CALL_CONVERSION_ACTION":
                            case 3:
                                message.conversionReportingState = 3;
                                break;
                            case "USE_RESOURCE_LEVEL_CALL_CONVERSION_ACTION":
                            case 4:
                                message.conversionReportingState = 4;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CallOnlyAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.CallOnlyAdInfo} message CallOnlyAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CallOnlyAdInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.countryCode = null;
                                object.phoneNumber = null;
                                object.businessName = null;
                                object.description1 = null;
                                object.description2 = null;
                                object.callTracked = null;
                                object.disableCallConversion = null;
                                object.phoneNumberVerificationUrl = null;
                                object.conversionAction = null;
                                object.conversionReportingState = options.enums === String ? "UNSPECIFIED" : 0;
                                object.headline1 = null;
                                object.headline2 = null;
                            }
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                object.countryCode = $root.google.protobuf.StringValue.toObject(message.countryCode, options);
                            if (message.phoneNumber != null && message.hasOwnProperty("phoneNumber"))
                                object.phoneNumber = $root.google.protobuf.StringValue.toObject(message.phoneNumber, options);
                            if (message.businessName != null && message.hasOwnProperty("businessName"))
                                object.businessName = $root.google.protobuf.StringValue.toObject(message.businessName, options);
                            if (message.description1 != null && message.hasOwnProperty("description1"))
                                object.description1 = $root.google.protobuf.StringValue.toObject(message.description1, options);
                            if (message.description2 != null && message.hasOwnProperty("description2"))
                                object.description2 = $root.google.protobuf.StringValue.toObject(message.description2, options);
                            if (message.callTracked != null && message.hasOwnProperty("callTracked"))
                                object.callTracked = $root.google.protobuf.BoolValue.toObject(message.callTracked, options);
                            if (message.disableCallConversion != null && message.hasOwnProperty("disableCallConversion"))
                                object.disableCallConversion = $root.google.protobuf.BoolValue.toObject(message.disableCallConversion, options);
                            if (message.phoneNumberVerificationUrl != null && message.hasOwnProperty("phoneNumberVerificationUrl"))
                                object.phoneNumberVerificationUrl = $root.google.protobuf.StringValue.toObject(message.phoneNumberVerificationUrl, options);
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                object.conversionAction = $root.google.protobuf.StringValue.toObject(message.conversionAction, options);
                            if (message.conversionReportingState != null && message.hasOwnProperty("conversionReportingState"))
                                object.conversionReportingState = options.enums === String ? $root.google.ads.googleads.v1.enums.CallConversionReportingStateEnum.CallConversionReportingState[message.conversionReportingState] : message.conversionReportingState;
                            if (message.headline1 != null && message.hasOwnProperty("headline1"))
                                object.headline1 = $root.google.protobuf.StringValue.toObject(message.headline1, options);
                            if (message.headline2 != null && message.hasOwnProperty("headline2"))
                                object.headline2 = $root.google.protobuf.StringValue.toObject(message.headline2, options);
                            return object;
                        };

                        /**
                         * Converts this CallOnlyAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.CallOnlyAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CallOnlyAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CallOnlyAdInfo;
                    })();

                    common.ExpandedDynamicSearchAdInfo = (function() {

                        /**
                         * Properties of an ExpandedDynamicSearchAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IExpandedDynamicSearchAdInfo
                         * @property {google.protobuf.IStringValue|null} [description] ExpandedDynamicSearchAdInfo description
                         */

                        /**
                         * Constructs a new ExpandedDynamicSearchAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an ExpandedDynamicSearchAdInfo.
                         * @implements IExpandedDynamicSearchAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IExpandedDynamicSearchAdInfo=} [properties] Properties to set
                         */
                        function ExpandedDynamicSearchAdInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ExpandedDynamicSearchAdInfo description.
                         * @member {google.protobuf.IStringValue|null|undefined} description
                         * @memberof google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo
                         * @instance
                         */
                        ExpandedDynamicSearchAdInfo.prototype.description = null;

                        /**
                         * Creates a new ExpandedDynamicSearchAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IExpandedDynamicSearchAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo} ExpandedDynamicSearchAdInfo instance
                         */
                        ExpandedDynamicSearchAdInfo.create = function create(properties) {
                            return new ExpandedDynamicSearchAdInfo(properties);
                        };

                        /**
                         * Encodes the specified ExpandedDynamicSearchAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IExpandedDynamicSearchAdInfo} message ExpandedDynamicSearchAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExpandedDynamicSearchAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.description != null && message.hasOwnProperty("description"))
                                $root.google.protobuf.StringValue.encode(message.description, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ExpandedDynamicSearchAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IExpandedDynamicSearchAdInfo} message ExpandedDynamicSearchAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExpandedDynamicSearchAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ExpandedDynamicSearchAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo} ExpandedDynamicSearchAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExpandedDynamicSearchAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.description = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ExpandedDynamicSearchAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo} ExpandedDynamicSearchAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExpandedDynamicSearchAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ExpandedDynamicSearchAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExpandedDynamicSearchAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.description != null && message.hasOwnProperty("description")) {
                                var error = $root.google.protobuf.StringValue.verify(message.description);
                                if (error)
                                    return "description." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an ExpandedDynamicSearchAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo} ExpandedDynamicSearchAdInfo
                         */
                        ExpandedDynamicSearchAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo();
                            if (object.description != null) {
                                if (typeof object.description !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo.description: object expected");
                                message.description = $root.google.protobuf.StringValue.fromObject(object.description);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an ExpandedDynamicSearchAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo} message ExpandedDynamicSearchAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExpandedDynamicSearchAdInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.description = null;
                            if (message.description != null && message.hasOwnProperty("description"))
                                object.description = $root.google.protobuf.StringValue.toObject(message.description, options);
                            return object;
                        };

                        /**
                         * Converts this ExpandedDynamicSearchAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExpandedDynamicSearchAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ExpandedDynamicSearchAdInfo;
                    })();

                    common.HotelAdInfo = (function() {

                        /**
                         * Properties of a HotelAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IHotelAdInfo
                         */

                        /**
                         * Constructs a new HotelAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a HotelAdInfo.
                         * @implements IHotelAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IHotelAdInfo=} [properties] Properties to set
                         */
                        function HotelAdInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new HotelAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.HotelAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.HotelAdInfo} HotelAdInfo instance
                         */
                        HotelAdInfo.create = function create(properties) {
                            return new HotelAdInfo(properties);
                        };

                        /**
                         * Encodes the specified HotelAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.HotelAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.HotelAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelAdInfo} message HotelAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified HotelAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.HotelAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelAdInfo} message HotelAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a HotelAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.HotelAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.HotelAdInfo} HotelAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.HotelAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a HotelAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.HotelAdInfo} HotelAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a HotelAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.HotelAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HotelAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a HotelAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.HotelAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.HotelAdInfo} HotelAdInfo
                         */
                        HotelAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.HotelAdInfo)
                                return object;
                            return new $root.google.ads.googleads.v1.common.HotelAdInfo();
                        };

                        /**
                         * Creates a plain object from a HotelAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.HotelAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.HotelAdInfo} message HotelAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HotelAdInfo.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this HotelAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.HotelAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HotelAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return HotelAdInfo;
                    })();

                    common.ShoppingSmartAdInfo = (function() {

                        /**
                         * Properties of a ShoppingSmartAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IShoppingSmartAdInfo
                         */

                        /**
                         * Constructs a new ShoppingSmartAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ShoppingSmartAdInfo.
                         * @implements IShoppingSmartAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IShoppingSmartAdInfo=} [properties] Properties to set
                         */
                        function ShoppingSmartAdInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ShoppingSmartAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ShoppingSmartAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IShoppingSmartAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ShoppingSmartAdInfo} ShoppingSmartAdInfo instance
                         */
                        ShoppingSmartAdInfo.create = function create(properties) {
                            return new ShoppingSmartAdInfo(properties);
                        };

                        /**
                         * Encodes the specified ShoppingSmartAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ShoppingSmartAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ShoppingSmartAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IShoppingSmartAdInfo} message ShoppingSmartAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ShoppingSmartAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ShoppingSmartAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ShoppingSmartAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ShoppingSmartAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IShoppingSmartAdInfo} message ShoppingSmartAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ShoppingSmartAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ShoppingSmartAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ShoppingSmartAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ShoppingSmartAdInfo} ShoppingSmartAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ShoppingSmartAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ShoppingSmartAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ShoppingSmartAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ShoppingSmartAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ShoppingSmartAdInfo} ShoppingSmartAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ShoppingSmartAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ShoppingSmartAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ShoppingSmartAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ShoppingSmartAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ShoppingSmartAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ShoppingSmartAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ShoppingSmartAdInfo} ShoppingSmartAdInfo
                         */
                        ShoppingSmartAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ShoppingSmartAdInfo)
                                return object;
                            return new $root.google.ads.googleads.v1.common.ShoppingSmartAdInfo();
                        };

                        /**
                         * Creates a plain object from a ShoppingSmartAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ShoppingSmartAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ShoppingSmartAdInfo} message ShoppingSmartAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ShoppingSmartAdInfo.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ShoppingSmartAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ShoppingSmartAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ShoppingSmartAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ShoppingSmartAdInfo;
                    })();

                    common.ShoppingProductAdInfo = (function() {

                        /**
                         * Properties of a ShoppingProductAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IShoppingProductAdInfo
                         */

                        /**
                         * Constructs a new ShoppingProductAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ShoppingProductAdInfo.
                         * @implements IShoppingProductAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IShoppingProductAdInfo=} [properties] Properties to set
                         */
                        function ShoppingProductAdInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ShoppingProductAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ShoppingProductAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IShoppingProductAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ShoppingProductAdInfo} ShoppingProductAdInfo instance
                         */
                        ShoppingProductAdInfo.create = function create(properties) {
                            return new ShoppingProductAdInfo(properties);
                        };

                        /**
                         * Encodes the specified ShoppingProductAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ShoppingProductAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ShoppingProductAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IShoppingProductAdInfo} message ShoppingProductAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ShoppingProductAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ShoppingProductAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ShoppingProductAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ShoppingProductAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IShoppingProductAdInfo} message ShoppingProductAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ShoppingProductAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ShoppingProductAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ShoppingProductAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ShoppingProductAdInfo} ShoppingProductAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ShoppingProductAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ShoppingProductAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ShoppingProductAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ShoppingProductAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ShoppingProductAdInfo} ShoppingProductAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ShoppingProductAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ShoppingProductAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ShoppingProductAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ShoppingProductAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ShoppingProductAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ShoppingProductAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ShoppingProductAdInfo} ShoppingProductAdInfo
                         */
                        ShoppingProductAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ShoppingProductAdInfo)
                                return object;
                            return new $root.google.ads.googleads.v1.common.ShoppingProductAdInfo();
                        };

                        /**
                         * Creates a plain object from a ShoppingProductAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ShoppingProductAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ShoppingProductAdInfo} message ShoppingProductAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ShoppingProductAdInfo.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ShoppingProductAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ShoppingProductAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ShoppingProductAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ShoppingProductAdInfo;
                    })();

                    common.GmailAdInfo = (function() {

                        /**
                         * Properties of a GmailAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IGmailAdInfo
                         * @property {google.ads.googleads.v1.common.IGmailTeaser|null} [teaser] GmailAdInfo teaser
                         * @property {google.protobuf.IStringValue|null} [headerImage] GmailAdInfo headerImage
                         * @property {google.protobuf.IStringValue|null} [marketingImage] GmailAdInfo marketingImage
                         * @property {google.protobuf.IStringValue|null} [marketingImageHeadline] GmailAdInfo marketingImageHeadline
                         * @property {google.protobuf.IStringValue|null} [marketingImageDescription] GmailAdInfo marketingImageDescription
                         * @property {google.ads.googleads.v1.common.IDisplayCallToAction|null} [marketingImageDisplayCallToAction] GmailAdInfo marketingImageDisplayCallToAction
                         * @property {Array.<google.ads.googleads.v1.common.IProductImage>|null} [productImages] GmailAdInfo productImages
                         * @property {Array.<google.ads.googleads.v1.common.IProductVideo>|null} [productVideos] GmailAdInfo productVideos
                         */

                        /**
                         * Constructs a new GmailAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a GmailAdInfo.
                         * @implements IGmailAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IGmailAdInfo=} [properties] Properties to set
                         */
                        function GmailAdInfo(properties) {
                            this.productImages = [];
                            this.productVideos = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GmailAdInfo teaser.
                         * @member {google.ads.googleads.v1.common.IGmailTeaser|null|undefined} teaser
                         * @memberof google.ads.googleads.v1.common.GmailAdInfo
                         * @instance
                         */
                        GmailAdInfo.prototype.teaser = null;

                        /**
                         * GmailAdInfo headerImage.
                         * @member {google.protobuf.IStringValue|null|undefined} headerImage
                         * @memberof google.ads.googleads.v1.common.GmailAdInfo
                         * @instance
                         */
                        GmailAdInfo.prototype.headerImage = null;

                        /**
                         * GmailAdInfo marketingImage.
                         * @member {google.protobuf.IStringValue|null|undefined} marketingImage
                         * @memberof google.ads.googleads.v1.common.GmailAdInfo
                         * @instance
                         */
                        GmailAdInfo.prototype.marketingImage = null;

                        /**
                         * GmailAdInfo marketingImageHeadline.
                         * @member {google.protobuf.IStringValue|null|undefined} marketingImageHeadline
                         * @memberof google.ads.googleads.v1.common.GmailAdInfo
                         * @instance
                         */
                        GmailAdInfo.prototype.marketingImageHeadline = null;

                        /**
                         * GmailAdInfo marketingImageDescription.
                         * @member {google.protobuf.IStringValue|null|undefined} marketingImageDescription
                         * @memberof google.ads.googleads.v1.common.GmailAdInfo
                         * @instance
                         */
                        GmailAdInfo.prototype.marketingImageDescription = null;

                        /**
                         * GmailAdInfo marketingImageDisplayCallToAction.
                         * @member {google.ads.googleads.v1.common.IDisplayCallToAction|null|undefined} marketingImageDisplayCallToAction
                         * @memberof google.ads.googleads.v1.common.GmailAdInfo
                         * @instance
                         */
                        GmailAdInfo.prototype.marketingImageDisplayCallToAction = null;

                        /**
                         * GmailAdInfo productImages.
                         * @member {Array.<google.ads.googleads.v1.common.IProductImage>} productImages
                         * @memberof google.ads.googleads.v1.common.GmailAdInfo
                         * @instance
                         */
                        GmailAdInfo.prototype.productImages = $util.emptyArray;

                        /**
                         * GmailAdInfo productVideos.
                         * @member {Array.<google.ads.googleads.v1.common.IProductVideo>} productVideos
                         * @memberof google.ads.googleads.v1.common.GmailAdInfo
                         * @instance
                         */
                        GmailAdInfo.prototype.productVideos = $util.emptyArray;

                        /**
                         * Creates a new GmailAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.GmailAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IGmailAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.GmailAdInfo} GmailAdInfo instance
                         */
                        GmailAdInfo.create = function create(properties) {
                            return new GmailAdInfo(properties);
                        };

                        /**
                         * Encodes the specified GmailAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.GmailAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.GmailAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IGmailAdInfo} message GmailAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GmailAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.teaser != null && message.hasOwnProperty("teaser"))
                                $root.google.ads.googleads.v1.common.GmailTeaser.encode(message.teaser, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.headerImage != null && message.hasOwnProperty("headerImage"))
                                $root.google.protobuf.StringValue.encode(message.headerImage, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.marketingImage != null && message.hasOwnProperty("marketingImage"))
                                $root.google.protobuf.StringValue.encode(message.marketingImage, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.marketingImageHeadline != null && message.hasOwnProperty("marketingImageHeadline"))
                                $root.google.protobuf.StringValue.encode(message.marketingImageHeadline, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.marketingImageDescription != null && message.hasOwnProperty("marketingImageDescription"))
                                $root.google.protobuf.StringValue.encode(message.marketingImageDescription, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.marketingImageDisplayCallToAction != null && message.hasOwnProperty("marketingImageDisplayCallToAction"))
                                $root.google.ads.googleads.v1.common.DisplayCallToAction.encode(message.marketingImageDisplayCallToAction, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.productImages != null && message.productImages.length)
                                for (var i = 0; i < message.productImages.length; ++i)
                                    $root.google.ads.googleads.v1.common.ProductImage.encode(message.productImages[i], writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.productVideos != null && message.productVideos.length)
                                for (var i = 0; i < message.productVideos.length; ++i)
                                    $root.google.ads.googleads.v1.common.ProductVideo.encode(message.productVideos[i], writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified GmailAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.GmailAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.GmailAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IGmailAdInfo} message GmailAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GmailAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GmailAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.GmailAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.GmailAdInfo} GmailAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GmailAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.GmailAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.teaser = $root.google.ads.googleads.v1.common.GmailTeaser.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.headerImage = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.marketingImage = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.marketingImageHeadline = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.marketingImageDescription = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.marketingImageDisplayCallToAction = $root.google.ads.googleads.v1.common.DisplayCallToAction.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    if (!(message.productImages && message.productImages.length))
                                        message.productImages = [];
                                    message.productImages.push($root.google.ads.googleads.v1.common.ProductImage.decode(reader, reader.uint32()));
                                    break;
                                case 8:
                                    if (!(message.productVideos && message.productVideos.length))
                                        message.productVideos = [];
                                    message.productVideos.push($root.google.ads.googleads.v1.common.ProductVideo.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GmailAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.GmailAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.GmailAdInfo} GmailAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GmailAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GmailAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.GmailAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GmailAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.teaser != null && message.hasOwnProperty("teaser")) {
                                var error = $root.google.ads.googleads.v1.common.GmailTeaser.verify(message.teaser);
                                if (error)
                                    return "teaser." + error;
                            }
                            if (message.headerImage != null && message.hasOwnProperty("headerImage")) {
                                var error = $root.google.protobuf.StringValue.verify(message.headerImage);
                                if (error)
                                    return "headerImage." + error;
                            }
                            if (message.marketingImage != null && message.hasOwnProperty("marketingImage")) {
                                var error = $root.google.protobuf.StringValue.verify(message.marketingImage);
                                if (error)
                                    return "marketingImage." + error;
                            }
                            if (message.marketingImageHeadline != null && message.hasOwnProperty("marketingImageHeadline")) {
                                var error = $root.google.protobuf.StringValue.verify(message.marketingImageHeadline);
                                if (error)
                                    return "marketingImageHeadline." + error;
                            }
                            if (message.marketingImageDescription != null && message.hasOwnProperty("marketingImageDescription")) {
                                var error = $root.google.protobuf.StringValue.verify(message.marketingImageDescription);
                                if (error)
                                    return "marketingImageDescription." + error;
                            }
                            if (message.marketingImageDisplayCallToAction != null && message.hasOwnProperty("marketingImageDisplayCallToAction")) {
                                var error = $root.google.ads.googleads.v1.common.DisplayCallToAction.verify(message.marketingImageDisplayCallToAction);
                                if (error)
                                    return "marketingImageDisplayCallToAction." + error;
                            }
                            if (message.productImages != null && message.hasOwnProperty("productImages")) {
                                if (!Array.isArray(message.productImages))
                                    return "productImages: array expected";
                                for (var i = 0; i < message.productImages.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.ProductImage.verify(message.productImages[i]);
                                    if (error)
                                        return "productImages." + error;
                                }
                            }
                            if (message.productVideos != null && message.hasOwnProperty("productVideos")) {
                                if (!Array.isArray(message.productVideos))
                                    return "productVideos: array expected";
                                for (var i = 0; i < message.productVideos.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.ProductVideo.verify(message.productVideos[i]);
                                    if (error)
                                        return "productVideos." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a GmailAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.GmailAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.GmailAdInfo} GmailAdInfo
                         */
                        GmailAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.GmailAdInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.GmailAdInfo();
                            if (object.teaser != null) {
                                if (typeof object.teaser !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.GmailAdInfo.teaser: object expected");
                                message.teaser = $root.google.ads.googleads.v1.common.GmailTeaser.fromObject(object.teaser);
                            }
                            if (object.headerImage != null) {
                                if (typeof object.headerImage !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.GmailAdInfo.headerImage: object expected");
                                message.headerImage = $root.google.protobuf.StringValue.fromObject(object.headerImage);
                            }
                            if (object.marketingImage != null) {
                                if (typeof object.marketingImage !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.GmailAdInfo.marketingImage: object expected");
                                message.marketingImage = $root.google.protobuf.StringValue.fromObject(object.marketingImage);
                            }
                            if (object.marketingImageHeadline != null) {
                                if (typeof object.marketingImageHeadline !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.GmailAdInfo.marketingImageHeadline: object expected");
                                message.marketingImageHeadline = $root.google.protobuf.StringValue.fromObject(object.marketingImageHeadline);
                            }
                            if (object.marketingImageDescription != null) {
                                if (typeof object.marketingImageDescription !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.GmailAdInfo.marketingImageDescription: object expected");
                                message.marketingImageDescription = $root.google.protobuf.StringValue.fromObject(object.marketingImageDescription);
                            }
                            if (object.marketingImageDisplayCallToAction != null) {
                                if (typeof object.marketingImageDisplayCallToAction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.GmailAdInfo.marketingImageDisplayCallToAction: object expected");
                                message.marketingImageDisplayCallToAction = $root.google.ads.googleads.v1.common.DisplayCallToAction.fromObject(object.marketingImageDisplayCallToAction);
                            }
                            if (object.productImages) {
                                if (!Array.isArray(object.productImages))
                                    throw TypeError(".google.ads.googleads.v1.common.GmailAdInfo.productImages: array expected");
                                message.productImages = [];
                                for (var i = 0; i < object.productImages.length; ++i) {
                                    if (typeof object.productImages[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.GmailAdInfo.productImages: object expected");
                                    message.productImages[i] = $root.google.ads.googleads.v1.common.ProductImage.fromObject(object.productImages[i]);
                                }
                            }
                            if (object.productVideos) {
                                if (!Array.isArray(object.productVideos))
                                    throw TypeError(".google.ads.googleads.v1.common.GmailAdInfo.productVideos: array expected");
                                message.productVideos = [];
                                for (var i = 0; i < object.productVideos.length; ++i) {
                                    if (typeof object.productVideos[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.GmailAdInfo.productVideos: object expected");
                                    message.productVideos[i] = $root.google.ads.googleads.v1.common.ProductVideo.fromObject(object.productVideos[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a GmailAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.GmailAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.GmailAdInfo} message GmailAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GmailAdInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.productImages = [];
                                object.productVideos = [];
                            }
                            if (options.defaults) {
                                object.teaser = null;
                                object.headerImage = null;
                                object.marketingImage = null;
                                object.marketingImageHeadline = null;
                                object.marketingImageDescription = null;
                                object.marketingImageDisplayCallToAction = null;
                            }
                            if (message.teaser != null && message.hasOwnProperty("teaser"))
                                object.teaser = $root.google.ads.googleads.v1.common.GmailTeaser.toObject(message.teaser, options);
                            if (message.headerImage != null && message.hasOwnProperty("headerImage"))
                                object.headerImage = $root.google.protobuf.StringValue.toObject(message.headerImage, options);
                            if (message.marketingImage != null && message.hasOwnProperty("marketingImage"))
                                object.marketingImage = $root.google.protobuf.StringValue.toObject(message.marketingImage, options);
                            if (message.marketingImageHeadline != null && message.hasOwnProperty("marketingImageHeadline"))
                                object.marketingImageHeadline = $root.google.protobuf.StringValue.toObject(message.marketingImageHeadline, options);
                            if (message.marketingImageDescription != null && message.hasOwnProperty("marketingImageDescription"))
                                object.marketingImageDescription = $root.google.protobuf.StringValue.toObject(message.marketingImageDescription, options);
                            if (message.marketingImageDisplayCallToAction != null && message.hasOwnProperty("marketingImageDisplayCallToAction"))
                                object.marketingImageDisplayCallToAction = $root.google.ads.googleads.v1.common.DisplayCallToAction.toObject(message.marketingImageDisplayCallToAction, options);
                            if (message.productImages && message.productImages.length) {
                                object.productImages = [];
                                for (var j = 0; j < message.productImages.length; ++j)
                                    object.productImages[j] = $root.google.ads.googleads.v1.common.ProductImage.toObject(message.productImages[j], options);
                            }
                            if (message.productVideos && message.productVideos.length) {
                                object.productVideos = [];
                                for (var j = 0; j < message.productVideos.length; ++j)
                                    object.productVideos[j] = $root.google.ads.googleads.v1.common.ProductVideo.toObject(message.productVideos[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this GmailAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.GmailAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GmailAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GmailAdInfo;
                    })();

                    common.GmailTeaser = (function() {

                        /**
                         * Properties of a GmailTeaser.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IGmailTeaser
                         * @property {google.protobuf.IStringValue|null} [headline] GmailTeaser headline
                         * @property {google.protobuf.IStringValue|null} [description] GmailTeaser description
                         * @property {google.protobuf.IStringValue|null} [businessName] GmailTeaser businessName
                         * @property {google.protobuf.IStringValue|null} [logoImage] GmailTeaser logoImage
                         */

                        /**
                         * Constructs a new GmailTeaser.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a GmailTeaser.
                         * @implements IGmailTeaser
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IGmailTeaser=} [properties] Properties to set
                         */
                        function GmailTeaser(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GmailTeaser headline.
                         * @member {google.protobuf.IStringValue|null|undefined} headline
                         * @memberof google.ads.googleads.v1.common.GmailTeaser
                         * @instance
                         */
                        GmailTeaser.prototype.headline = null;

                        /**
                         * GmailTeaser description.
                         * @member {google.protobuf.IStringValue|null|undefined} description
                         * @memberof google.ads.googleads.v1.common.GmailTeaser
                         * @instance
                         */
                        GmailTeaser.prototype.description = null;

                        /**
                         * GmailTeaser businessName.
                         * @member {google.protobuf.IStringValue|null|undefined} businessName
                         * @memberof google.ads.googleads.v1.common.GmailTeaser
                         * @instance
                         */
                        GmailTeaser.prototype.businessName = null;

                        /**
                         * GmailTeaser logoImage.
                         * @member {google.protobuf.IStringValue|null|undefined} logoImage
                         * @memberof google.ads.googleads.v1.common.GmailTeaser
                         * @instance
                         */
                        GmailTeaser.prototype.logoImage = null;

                        /**
                         * Creates a new GmailTeaser instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.GmailTeaser
                         * @static
                         * @param {google.ads.googleads.v1.common.IGmailTeaser=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.GmailTeaser} GmailTeaser instance
                         */
                        GmailTeaser.create = function create(properties) {
                            return new GmailTeaser(properties);
                        };

                        /**
                         * Encodes the specified GmailTeaser message. Does not implicitly {@link google.ads.googleads.v1.common.GmailTeaser.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.GmailTeaser
                         * @static
                         * @param {google.ads.googleads.v1.common.IGmailTeaser} message GmailTeaser message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GmailTeaser.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.headline != null && message.hasOwnProperty("headline"))
                                $root.google.protobuf.StringValue.encode(message.headline, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.description != null && message.hasOwnProperty("description"))
                                $root.google.protobuf.StringValue.encode(message.description, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.businessName != null && message.hasOwnProperty("businessName"))
                                $root.google.protobuf.StringValue.encode(message.businessName, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.logoImage != null && message.hasOwnProperty("logoImage"))
                                $root.google.protobuf.StringValue.encode(message.logoImage, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified GmailTeaser message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.GmailTeaser.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.GmailTeaser
                         * @static
                         * @param {google.ads.googleads.v1.common.IGmailTeaser} message GmailTeaser message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GmailTeaser.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GmailTeaser message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.GmailTeaser
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.GmailTeaser} GmailTeaser
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GmailTeaser.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.GmailTeaser();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.headline = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.description = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.businessName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.logoImage = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GmailTeaser message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.GmailTeaser
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.GmailTeaser} GmailTeaser
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GmailTeaser.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GmailTeaser message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.GmailTeaser
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GmailTeaser.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.headline != null && message.hasOwnProperty("headline")) {
                                var error = $root.google.protobuf.StringValue.verify(message.headline);
                                if (error)
                                    return "headline." + error;
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                var error = $root.google.protobuf.StringValue.verify(message.description);
                                if (error)
                                    return "description." + error;
                            }
                            if (message.businessName != null && message.hasOwnProperty("businessName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.businessName);
                                if (error)
                                    return "businessName." + error;
                            }
                            if (message.logoImage != null && message.hasOwnProperty("logoImage")) {
                                var error = $root.google.protobuf.StringValue.verify(message.logoImage);
                                if (error)
                                    return "logoImage." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a GmailTeaser message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.GmailTeaser
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.GmailTeaser} GmailTeaser
                         */
                        GmailTeaser.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.GmailTeaser)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.GmailTeaser();
                            if (object.headline != null) {
                                if (typeof object.headline !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.GmailTeaser.headline: object expected");
                                message.headline = $root.google.protobuf.StringValue.fromObject(object.headline);
                            }
                            if (object.description != null) {
                                if (typeof object.description !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.GmailTeaser.description: object expected");
                                message.description = $root.google.protobuf.StringValue.fromObject(object.description);
                            }
                            if (object.businessName != null) {
                                if (typeof object.businessName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.GmailTeaser.businessName: object expected");
                                message.businessName = $root.google.protobuf.StringValue.fromObject(object.businessName);
                            }
                            if (object.logoImage != null) {
                                if (typeof object.logoImage !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.GmailTeaser.logoImage: object expected");
                                message.logoImage = $root.google.protobuf.StringValue.fromObject(object.logoImage);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a GmailTeaser message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.GmailTeaser
                         * @static
                         * @param {google.ads.googleads.v1.common.GmailTeaser} message GmailTeaser
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GmailTeaser.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.headline = null;
                                object.description = null;
                                object.businessName = null;
                                object.logoImage = null;
                            }
                            if (message.headline != null && message.hasOwnProperty("headline"))
                                object.headline = $root.google.protobuf.StringValue.toObject(message.headline, options);
                            if (message.description != null && message.hasOwnProperty("description"))
                                object.description = $root.google.protobuf.StringValue.toObject(message.description, options);
                            if (message.businessName != null && message.hasOwnProperty("businessName"))
                                object.businessName = $root.google.protobuf.StringValue.toObject(message.businessName, options);
                            if (message.logoImage != null && message.hasOwnProperty("logoImage"))
                                object.logoImage = $root.google.protobuf.StringValue.toObject(message.logoImage, options);
                            return object;
                        };

                        /**
                         * Converts this GmailTeaser to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.GmailTeaser
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GmailTeaser.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GmailTeaser;
                    })();

                    common.DisplayCallToAction = (function() {

                        /**
                         * Properties of a DisplayCallToAction.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IDisplayCallToAction
                         * @property {google.protobuf.IStringValue|null} [text] DisplayCallToAction text
                         * @property {google.protobuf.IStringValue|null} [textColor] DisplayCallToAction textColor
                         * @property {google.protobuf.IStringValue|null} [urlCollectionId] DisplayCallToAction urlCollectionId
                         */

                        /**
                         * Constructs a new DisplayCallToAction.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a DisplayCallToAction.
                         * @implements IDisplayCallToAction
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IDisplayCallToAction=} [properties] Properties to set
                         */
                        function DisplayCallToAction(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * DisplayCallToAction text.
                         * @member {google.protobuf.IStringValue|null|undefined} text
                         * @memberof google.ads.googleads.v1.common.DisplayCallToAction
                         * @instance
                         */
                        DisplayCallToAction.prototype.text = null;

                        /**
                         * DisplayCallToAction textColor.
                         * @member {google.protobuf.IStringValue|null|undefined} textColor
                         * @memberof google.ads.googleads.v1.common.DisplayCallToAction
                         * @instance
                         */
                        DisplayCallToAction.prototype.textColor = null;

                        /**
                         * DisplayCallToAction urlCollectionId.
                         * @member {google.protobuf.IStringValue|null|undefined} urlCollectionId
                         * @memberof google.ads.googleads.v1.common.DisplayCallToAction
                         * @instance
                         */
                        DisplayCallToAction.prototype.urlCollectionId = null;

                        /**
                         * Creates a new DisplayCallToAction instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.DisplayCallToAction
                         * @static
                         * @param {google.ads.googleads.v1.common.IDisplayCallToAction=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.DisplayCallToAction} DisplayCallToAction instance
                         */
                        DisplayCallToAction.create = function create(properties) {
                            return new DisplayCallToAction(properties);
                        };

                        /**
                         * Encodes the specified DisplayCallToAction message. Does not implicitly {@link google.ads.googleads.v1.common.DisplayCallToAction.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.DisplayCallToAction
                         * @static
                         * @param {google.ads.googleads.v1.common.IDisplayCallToAction} message DisplayCallToAction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisplayCallToAction.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.text != null && message.hasOwnProperty("text"))
                                $root.google.protobuf.StringValue.encode(message.text, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.textColor != null && message.hasOwnProperty("textColor"))
                                $root.google.protobuf.StringValue.encode(message.textColor, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.urlCollectionId != null && message.hasOwnProperty("urlCollectionId"))
                                $root.google.protobuf.StringValue.encode(message.urlCollectionId, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified DisplayCallToAction message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.DisplayCallToAction.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.DisplayCallToAction
                         * @static
                         * @param {google.ads.googleads.v1.common.IDisplayCallToAction} message DisplayCallToAction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisplayCallToAction.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DisplayCallToAction message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.DisplayCallToAction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.DisplayCallToAction} DisplayCallToAction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisplayCallToAction.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.DisplayCallToAction();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.text = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.textColor = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.urlCollectionId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DisplayCallToAction message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.DisplayCallToAction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.DisplayCallToAction} DisplayCallToAction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisplayCallToAction.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DisplayCallToAction message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.DisplayCallToAction
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DisplayCallToAction.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.text != null && message.hasOwnProperty("text")) {
                                var error = $root.google.protobuf.StringValue.verify(message.text);
                                if (error)
                                    return "text." + error;
                            }
                            if (message.textColor != null && message.hasOwnProperty("textColor")) {
                                var error = $root.google.protobuf.StringValue.verify(message.textColor);
                                if (error)
                                    return "textColor." + error;
                            }
                            if (message.urlCollectionId != null && message.hasOwnProperty("urlCollectionId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.urlCollectionId);
                                if (error)
                                    return "urlCollectionId." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a DisplayCallToAction message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.DisplayCallToAction
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.DisplayCallToAction} DisplayCallToAction
                         */
                        DisplayCallToAction.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.DisplayCallToAction)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.DisplayCallToAction();
                            if (object.text != null) {
                                if (typeof object.text !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.DisplayCallToAction.text: object expected");
                                message.text = $root.google.protobuf.StringValue.fromObject(object.text);
                            }
                            if (object.textColor != null) {
                                if (typeof object.textColor !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.DisplayCallToAction.textColor: object expected");
                                message.textColor = $root.google.protobuf.StringValue.fromObject(object.textColor);
                            }
                            if (object.urlCollectionId != null) {
                                if (typeof object.urlCollectionId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.DisplayCallToAction.urlCollectionId: object expected");
                                message.urlCollectionId = $root.google.protobuf.StringValue.fromObject(object.urlCollectionId);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a DisplayCallToAction message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.DisplayCallToAction
                         * @static
                         * @param {google.ads.googleads.v1.common.DisplayCallToAction} message DisplayCallToAction
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DisplayCallToAction.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.text = null;
                                object.textColor = null;
                                object.urlCollectionId = null;
                            }
                            if (message.text != null && message.hasOwnProperty("text"))
                                object.text = $root.google.protobuf.StringValue.toObject(message.text, options);
                            if (message.textColor != null && message.hasOwnProperty("textColor"))
                                object.textColor = $root.google.protobuf.StringValue.toObject(message.textColor, options);
                            if (message.urlCollectionId != null && message.hasOwnProperty("urlCollectionId"))
                                object.urlCollectionId = $root.google.protobuf.StringValue.toObject(message.urlCollectionId, options);
                            return object;
                        };

                        /**
                         * Converts this DisplayCallToAction to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.DisplayCallToAction
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DisplayCallToAction.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return DisplayCallToAction;
                    })();

                    common.ProductImage = (function() {

                        /**
                         * Properties of a ProductImage.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IProductImage
                         * @property {google.protobuf.IStringValue|null} [productImage] ProductImage productImage
                         * @property {google.protobuf.IStringValue|null} [description] ProductImage description
                         * @property {google.ads.googleads.v1.common.IDisplayCallToAction|null} [displayCallToAction] ProductImage displayCallToAction
                         */

                        /**
                         * Constructs a new ProductImage.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ProductImage.
                         * @implements IProductImage
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IProductImage=} [properties] Properties to set
                         */
                        function ProductImage(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ProductImage productImage.
                         * @member {google.protobuf.IStringValue|null|undefined} productImage
                         * @memberof google.ads.googleads.v1.common.ProductImage
                         * @instance
                         */
                        ProductImage.prototype.productImage = null;

                        /**
                         * ProductImage description.
                         * @member {google.protobuf.IStringValue|null|undefined} description
                         * @memberof google.ads.googleads.v1.common.ProductImage
                         * @instance
                         */
                        ProductImage.prototype.description = null;

                        /**
                         * ProductImage displayCallToAction.
                         * @member {google.ads.googleads.v1.common.IDisplayCallToAction|null|undefined} displayCallToAction
                         * @memberof google.ads.googleads.v1.common.ProductImage
                         * @instance
                         */
                        ProductImage.prototype.displayCallToAction = null;

                        /**
                         * Creates a new ProductImage instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ProductImage
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductImage=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ProductImage} ProductImage instance
                         */
                        ProductImage.create = function create(properties) {
                            return new ProductImage(properties);
                        };

                        /**
                         * Encodes the specified ProductImage message. Does not implicitly {@link google.ads.googleads.v1.common.ProductImage.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ProductImage
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductImage} message ProductImage message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductImage.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.productImage != null && message.hasOwnProperty("productImage"))
                                $root.google.protobuf.StringValue.encode(message.productImage, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.description != null && message.hasOwnProperty("description"))
                                $root.google.protobuf.StringValue.encode(message.description, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.displayCallToAction != null && message.hasOwnProperty("displayCallToAction"))
                                $root.google.ads.googleads.v1.common.DisplayCallToAction.encode(message.displayCallToAction, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ProductImage message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ProductImage.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ProductImage
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductImage} message ProductImage message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductImage.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ProductImage message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ProductImage
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ProductImage} ProductImage
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductImage.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ProductImage();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.productImage = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.description = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.displayCallToAction = $root.google.ads.googleads.v1.common.DisplayCallToAction.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ProductImage message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ProductImage
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ProductImage} ProductImage
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductImage.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ProductImage message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ProductImage
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProductImage.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.productImage != null && message.hasOwnProperty("productImage")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productImage);
                                if (error)
                                    return "productImage." + error;
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                var error = $root.google.protobuf.StringValue.verify(message.description);
                                if (error)
                                    return "description." + error;
                            }
                            if (message.displayCallToAction != null && message.hasOwnProperty("displayCallToAction")) {
                                var error = $root.google.ads.googleads.v1.common.DisplayCallToAction.verify(message.displayCallToAction);
                                if (error)
                                    return "displayCallToAction." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a ProductImage message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ProductImage
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ProductImage} ProductImage
                         */
                        ProductImage.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ProductImage)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ProductImage();
                            if (object.productImage != null) {
                                if (typeof object.productImage !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ProductImage.productImage: object expected");
                                message.productImage = $root.google.protobuf.StringValue.fromObject(object.productImage);
                            }
                            if (object.description != null) {
                                if (typeof object.description !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ProductImage.description: object expected");
                                message.description = $root.google.protobuf.StringValue.fromObject(object.description);
                            }
                            if (object.displayCallToAction != null) {
                                if (typeof object.displayCallToAction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ProductImage.displayCallToAction: object expected");
                                message.displayCallToAction = $root.google.ads.googleads.v1.common.DisplayCallToAction.fromObject(object.displayCallToAction);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ProductImage message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ProductImage
                         * @static
                         * @param {google.ads.googleads.v1.common.ProductImage} message ProductImage
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProductImage.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.productImage = null;
                                object.description = null;
                                object.displayCallToAction = null;
                            }
                            if (message.productImage != null && message.hasOwnProperty("productImage"))
                                object.productImage = $root.google.protobuf.StringValue.toObject(message.productImage, options);
                            if (message.description != null && message.hasOwnProperty("description"))
                                object.description = $root.google.protobuf.StringValue.toObject(message.description, options);
                            if (message.displayCallToAction != null && message.hasOwnProperty("displayCallToAction"))
                                object.displayCallToAction = $root.google.ads.googleads.v1.common.DisplayCallToAction.toObject(message.displayCallToAction, options);
                            return object;
                        };

                        /**
                         * Converts this ProductImage to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ProductImage
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProductImage.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ProductImage;
                    })();

                    common.ProductVideo = (function() {

                        /**
                         * Properties of a ProductVideo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IProductVideo
                         * @property {google.protobuf.IStringValue|null} [productVideo] ProductVideo productVideo
                         */

                        /**
                         * Constructs a new ProductVideo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ProductVideo.
                         * @implements IProductVideo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IProductVideo=} [properties] Properties to set
                         */
                        function ProductVideo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ProductVideo productVideo.
                         * @member {google.protobuf.IStringValue|null|undefined} productVideo
                         * @memberof google.ads.googleads.v1.common.ProductVideo
                         * @instance
                         */
                        ProductVideo.prototype.productVideo = null;

                        /**
                         * Creates a new ProductVideo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ProductVideo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductVideo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ProductVideo} ProductVideo instance
                         */
                        ProductVideo.create = function create(properties) {
                            return new ProductVideo(properties);
                        };

                        /**
                         * Encodes the specified ProductVideo message. Does not implicitly {@link google.ads.googleads.v1.common.ProductVideo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ProductVideo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductVideo} message ProductVideo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductVideo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.productVideo != null && message.hasOwnProperty("productVideo"))
                                $root.google.protobuf.StringValue.encode(message.productVideo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ProductVideo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ProductVideo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ProductVideo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductVideo} message ProductVideo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductVideo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ProductVideo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ProductVideo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ProductVideo} ProductVideo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductVideo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ProductVideo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.productVideo = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ProductVideo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ProductVideo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ProductVideo} ProductVideo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductVideo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ProductVideo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ProductVideo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProductVideo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.productVideo != null && message.hasOwnProperty("productVideo")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productVideo);
                                if (error)
                                    return "productVideo." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a ProductVideo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ProductVideo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ProductVideo} ProductVideo
                         */
                        ProductVideo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ProductVideo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ProductVideo();
                            if (object.productVideo != null) {
                                if (typeof object.productVideo !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ProductVideo.productVideo: object expected");
                                message.productVideo = $root.google.protobuf.StringValue.fromObject(object.productVideo);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ProductVideo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ProductVideo
                         * @static
                         * @param {google.ads.googleads.v1.common.ProductVideo} message ProductVideo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProductVideo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.productVideo = null;
                            if (message.productVideo != null && message.hasOwnProperty("productVideo"))
                                object.productVideo = $root.google.protobuf.StringValue.toObject(message.productVideo, options);
                            return object;
                        };

                        /**
                         * Converts this ProductVideo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ProductVideo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProductVideo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ProductVideo;
                    })();

                    common.ImageAdInfo = (function() {

                        /**
                         * Properties of an ImageAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IImageAdInfo
                         * @property {google.protobuf.IInt64Value|null} [pixelWidth] ImageAdInfo pixelWidth
                         * @property {google.protobuf.IInt64Value|null} [pixelHeight] ImageAdInfo pixelHeight
                         * @property {google.protobuf.IStringValue|null} [imageUrl] ImageAdInfo imageUrl
                         * @property {google.protobuf.IInt64Value|null} [previewPixelWidth] ImageAdInfo previewPixelWidth
                         * @property {google.protobuf.IInt64Value|null} [previewPixelHeight] ImageAdInfo previewPixelHeight
                         * @property {google.protobuf.IStringValue|null} [previewImageUrl] ImageAdInfo previewImageUrl
                         * @property {google.ads.googleads.v1.enums.MimeTypeEnum.MimeType|null} [mimeType] ImageAdInfo mimeType
                         * @property {google.protobuf.IStringValue|null} [name] ImageAdInfo name
                         * @property {google.protobuf.IStringValue|null} [mediaFile] ImageAdInfo mediaFile
                         * @property {google.protobuf.IBytesValue|null} [data] ImageAdInfo data
                         * @property {google.protobuf.IInt64Value|null} [adIdToCopyImageFrom] ImageAdInfo adIdToCopyImageFrom
                         */

                        /**
                         * Constructs a new ImageAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an ImageAdInfo.
                         * @implements IImageAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IImageAdInfo=} [properties] Properties to set
                         */
                        function ImageAdInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ImageAdInfo pixelWidth.
                         * @member {google.protobuf.IInt64Value|null|undefined} pixelWidth
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @instance
                         */
                        ImageAdInfo.prototype.pixelWidth = null;

                        /**
                         * ImageAdInfo pixelHeight.
                         * @member {google.protobuf.IInt64Value|null|undefined} pixelHeight
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @instance
                         */
                        ImageAdInfo.prototype.pixelHeight = null;

                        /**
                         * ImageAdInfo imageUrl.
                         * @member {google.protobuf.IStringValue|null|undefined} imageUrl
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @instance
                         */
                        ImageAdInfo.prototype.imageUrl = null;

                        /**
                         * ImageAdInfo previewPixelWidth.
                         * @member {google.protobuf.IInt64Value|null|undefined} previewPixelWidth
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @instance
                         */
                        ImageAdInfo.prototype.previewPixelWidth = null;

                        /**
                         * ImageAdInfo previewPixelHeight.
                         * @member {google.protobuf.IInt64Value|null|undefined} previewPixelHeight
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @instance
                         */
                        ImageAdInfo.prototype.previewPixelHeight = null;

                        /**
                         * ImageAdInfo previewImageUrl.
                         * @member {google.protobuf.IStringValue|null|undefined} previewImageUrl
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @instance
                         */
                        ImageAdInfo.prototype.previewImageUrl = null;

                        /**
                         * ImageAdInfo mimeType.
                         * @member {google.ads.googleads.v1.enums.MimeTypeEnum.MimeType} mimeType
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @instance
                         */
                        ImageAdInfo.prototype.mimeType = 0;

                        /**
                         * ImageAdInfo name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @instance
                         */
                        ImageAdInfo.prototype.name = null;

                        /**
                         * ImageAdInfo mediaFile.
                         * @member {google.protobuf.IStringValue|null|undefined} mediaFile
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @instance
                         */
                        ImageAdInfo.prototype.mediaFile = null;

                        /**
                         * ImageAdInfo data.
                         * @member {google.protobuf.IBytesValue|null|undefined} data
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @instance
                         */
                        ImageAdInfo.prototype.data = null;

                        /**
                         * ImageAdInfo adIdToCopyImageFrom.
                         * @member {google.protobuf.IInt64Value|null|undefined} adIdToCopyImageFrom
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @instance
                         */
                        ImageAdInfo.prototype.adIdToCopyImageFrom = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * ImageAdInfo image.
                         * @member {"mediaFile"|"data"|"adIdToCopyImageFrom"|undefined} image
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @instance
                         */
                        Object.defineProperty(ImageAdInfo.prototype, "image", {
                            get: $util.oneOfGetter($oneOfFields = ["mediaFile", "data", "adIdToCopyImageFrom"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new ImageAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IImageAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ImageAdInfo} ImageAdInfo instance
                         */
                        ImageAdInfo.create = function create(properties) {
                            return new ImageAdInfo(properties);
                        };

                        /**
                         * Encodes the specified ImageAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ImageAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IImageAdInfo} message ImageAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ImageAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.mediaFile != null && message.hasOwnProperty("mediaFile"))
                                $root.google.protobuf.StringValue.encode(message.mediaFile, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.data != null && message.hasOwnProperty("data"))
                                $root.google.protobuf.BytesValue.encode(message.data, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.adIdToCopyImageFrom != null && message.hasOwnProperty("adIdToCopyImageFrom"))
                                $root.google.protobuf.Int64Value.encode(message.adIdToCopyImageFrom, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.pixelWidth != null && message.hasOwnProperty("pixelWidth"))
                                $root.google.protobuf.Int64Value.encode(message.pixelWidth, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.pixelHeight != null && message.hasOwnProperty("pixelHeight"))
                                $root.google.protobuf.Int64Value.encode(message.pixelHeight, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.imageUrl != null && message.hasOwnProperty("imageUrl"))
                                $root.google.protobuf.StringValue.encode(message.imageUrl, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.previewPixelWidth != null && message.hasOwnProperty("previewPixelWidth"))
                                $root.google.protobuf.Int64Value.encode(message.previewPixelWidth, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.previewPixelHeight != null && message.hasOwnProperty("previewPixelHeight"))
                                $root.google.protobuf.Int64Value.encode(message.previewPixelHeight, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.previewImageUrl != null && message.hasOwnProperty("previewImageUrl"))
                                $root.google.protobuf.StringValue.encode(message.previewImageUrl, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.mimeType != null && message.hasOwnProperty("mimeType"))
                                writer.uint32(/* id 10, wireType 0 =*/80).int32(message.mimeType);
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ImageAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ImageAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IImageAdInfo} message ImageAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ImageAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ImageAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ImageAdInfo} ImageAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ImageAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ImageAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.pixelWidth = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.pixelHeight = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.imageUrl = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.previewPixelWidth = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.previewPixelHeight = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.previewImageUrl = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.mimeType = reader.int32();
                                    break;
                                case 11:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.mediaFile = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.data = $root.google.protobuf.BytesValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.adIdToCopyImageFrom = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ImageAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ImageAdInfo} ImageAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ImageAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ImageAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ImageAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.pixelWidth != null && message.hasOwnProperty("pixelWidth")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.pixelWidth);
                                if (error)
                                    return "pixelWidth." + error;
                            }
                            if (message.pixelHeight != null && message.hasOwnProperty("pixelHeight")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.pixelHeight);
                                if (error)
                                    return "pixelHeight." + error;
                            }
                            if (message.imageUrl != null && message.hasOwnProperty("imageUrl")) {
                                var error = $root.google.protobuf.StringValue.verify(message.imageUrl);
                                if (error)
                                    return "imageUrl." + error;
                            }
                            if (message.previewPixelWidth != null && message.hasOwnProperty("previewPixelWidth")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.previewPixelWidth);
                                if (error)
                                    return "previewPixelWidth." + error;
                            }
                            if (message.previewPixelHeight != null && message.hasOwnProperty("previewPixelHeight")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.previewPixelHeight);
                                if (error)
                                    return "previewPixelHeight." + error;
                            }
                            if (message.previewImageUrl != null && message.hasOwnProperty("previewImageUrl")) {
                                var error = $root.google.protobuf.StringValue.verify(message.previewImageUrl);
                                if (error)
                                    return "previewImageUrl." + error;
                            }
                            if (message.mimeType != null && message.hasOwnProperty("mimeType"))
                                switch (message.mimeType) {
                                default:
                                    return "mimeType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                    break;
                                }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.mediaFile != null && message.hasOwnProperty("mediaFile")) {
                                properties.image = 1;
                                {
                                    var error = $root.google.protobuf.StringValue.verify(message.mediaFile);
                                    if (error)
                                        return "mediaFile." + error;
                                }
                            }
                            if (message.data != null && message.hasOwnProperty("data")) {
                                if (properties.image === 1)
                                    return "image: multiple values";
                                properties.image = 1;
                                {
                                    var error = $root.google.protobuf.BytesValue.verify(message.data);
                                    if (error)
                                        return "data." + error;
                                }
                            }
                            if (message.adIdToCopyImageFrom != null && message.hasOwnProperty("adIdToCopyImageFrom")) {
                                if (properties.image === 1)
                                    return "image: multiple values";
                                properties.image = 1;
                                {
                                    var error = $root.google.protobuf.Int64Value.verify(message.adIdToCopyImageFrom);
                                    if (error)
                                        return "adIdToCopyImageFrom." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an ImageAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ImageAdInfo} ImageAdInfo
                         */
                        ImageAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ImageAdInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ImageAdInfo();
                            if (object.pixelWidth != null) {
                                if (typeof object.pixelWidth !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ImageAdInfo.pixelWidth: object expected");
                                message.pixelWidth = $root.google.protobuf.Int64Value.fromObject(object.pixelWidth);
                            }
                            if (object.pixelHeight != null) {
                                if (typeof object.pixelHeight !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ImageAdInfo.pixelHeight: object expected");
                                message.pixelHeight = $root.google.protobuf.Int64Value.fromObject(object.pixelHeight);
                            }
                            if (object.imageUrl != null) {
                                if (typeof object.imageUrl !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ImageAdInfo.imageUrl: object expected");
                                message.imageUrl = $root.google.protobuf.StringValue.fromObject(object.imageUrl);
                            }
                            if (object.previewPixelWidth != null) {
                                if (typeof object.previewPixelWidth !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ImageAdInfo.previewPixelWidth: object expected");
                                message.previewPixelWidth = $root.google.protobuf.Int64Value.fromObject(object.previewPixelWidth);
                            }
                            if (object.previewPixelHeight != null) {
                                if (typeof object.previewPixelHeight !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ImageAdInfo.previewPixelHeight: object expected");
                                message.previewPixelHeight = $root.google.protobuf.Int64Value.fromObject(object.previewPixelHeight);
                            }
                            if (object.previewImageUrl != null) {
                                if (typeof object.previewImageUrl !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ImageAdInfo.previewImageUrl: object expected");
                                message.previewImageUrl = $root.google.protobuf.StringValue.fromObject(object.previewImageUrl);
                            }
                            switch (object.mimeType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.mimeType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.mimeType = 1;
                                break;
                            case "IMAGE_JPEG":
                            case 2:
                                message.mimeType = 2;
                                break;
                            case "IMAGE_GIF":
                            case 3:
                                message.mimeType = 3;
                                break;
                            case "IMAGE_PNG":
                            case 4:
                                message.mimeType = 4;
                                break;
                            case "FLASH":
                            case 5:
                                message.mimeType = 5;
                                break;
                            case "TEXT_HTML":
                            case 6:
                                message.mimeType = 6;
                                break;
                            case "PDF":
                            case 7:
                                message.mimeType = 7;
                                break;
                            case "MSWORD":
                            case 8:
                                message.mimeType = 8;
                                break;
                            case "MSEXCEL":
                            case 9:
                                message.mimeType = 9;
                                break;
                            case "RTF":
                            case 10:
                                message.mimeType = 10;
                                break;
                            case "AUDIO_WAV":
                            case 11:
                                message.mimeType = 11;
                                break;
                            case "AUDIO_MP3":
                            case 12:
                                message.mimeType = 12;
                                break;
                            case "HTML5_AD_ZIP":
                            case 13:
                                message.mimeType = 13;
                                break;
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ImageAdInfo.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            if (object.mediaFile != null) {
                                if (typeof object.mediaFile !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ImageAdInfo.mediaFile: object expected");
                                message.mediaFile = $root.google.protobuf.StringValue.fromObject(object.mediaFile);
                            }
                            if (object.data != null) {
                                if (typeof object.data !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ImageAdInfo.data: object expected");
                                message.data = $root.google.protobuf.BytesValue.fromObject(object.data);
                            }
                            if (object.adIdToCopyImageFrom != null) {
                                if (typeof object.adIdToCopyImageFrom !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ImageAdInfo.adIdToCopyImageFrom: object expected");
                                message.adIdToCopyImageFrom = $root.google.protobuf.Int64Value.fromObject(object.adIdToCopyImageFrom);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an ImageAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ImageAdInfo} message ImageAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ImageAdInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.pixelWidth = null;
                                object.pixelHeight = null;
                                object.imageUrl = null;
                                object.previewPixelWidth = null;
                                object.previewPixelHeight = null;
                                object.previewImageUrl = null;
                                object.mimeType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.name = null;
                            }
                            if (message.mediaFile != null && message.hasOwnProperty("mediaFile")) {
                                object.mediaFile = $root.google.protobuf.StringValue.toObject(message.mediaFile, options);
                                if (options.oneofs)
                                    object.image = "mediaFile";
                            }
                            if (message.data != null && message.hasOwnProperty("data")) {
                                object.data = $root.google.protobuf.BytesValue.toObject(message.data, options);
                                if (options.oneofs)
                                    object.image = "data";
                            }
                            if (message.adIdToCopyImageFrom != null && message.hasOwnProperty("adIdToCopyImageFrom")) {
                                object.adIdToCopyImageFrom = $root.google.protobuf.Int64Value.toObject(message.adIdToCopyImageFrom, options);
                                if (options.oneofs)
                                    object.image = "adIdToCopyImageFrom";
                            }
                            if (message.pixelWidth != null && message.hasOwnProperty("pixelWidth"))
                                object.pixelWidth = $root.google.protobuf.Int64Value.toObject(message.pixelWidth, options);
                            if (message.pixelHeight != null && message.hasOwnProperty("pixelHeight"))
                                object.pixelHeight = $root.google.protobuf.Int64Value.toObject(message.pixelHeight, options);
                            if (message.imageUrl != null && message.hasOwnProperty("imageUrl"))
                                object.imageUrl = $root.google.protobuf.StringValue.toObject(message.imageUrl, options);
                            if (message.previewPixelWidth != null && message.hasOwnProperty("previewPixelWidth"))
                                object.previewPixelWidth = $root.google.protobuf.Int64Value.toObject(message.previewPixelWidth, options);
                            if (message.previewPixelHeight != null && message.hasOwnProperty("previewPixelHeight"))
                                object.previewPixelHeight = $root.google.protobuf.Int64Value.toObject(message.previewPixelHeight, options);
                            if (message.previewImageUrl != null && message.hasOwnProperty("previewImageUrl"))
                                object.previewImageUrl = $root.google.protobuf.StringValue.toObject(message.previewImageUrl, options);
                            if (message.mimeType != null && message.hasOwnProperty("mimeType"))
                                object.mimeType = options.enums === String ? $root.google.ads.googleads.v1.enums.MimeTypeEnum.MimeType[message.mimeType] : message.mimeType;
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            return object;
                        };

                        /**
                         * Converts this ImageAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ImageAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ImageAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ImageAdInfo;
                    })();

                    common.VideoBumperInStreamAdInfo = (function() {

                        /**
                         * Properties of a VideoBumperInStreamAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IVideoBumperInStreamAdInfo
                         */

                        /**
                         * Constructs a new VideoBumperInStreamAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a VideoBumperInStreamAdInfo.
                         * @implements IVideoBumperInStreamAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IVideoBumperInStreamAdInfo=} [properties] Properties to set
                         */
                        function VideoBumperInStreamAdInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new VideoBumperInStreamAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.VideoBumperInStreamAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IVideoBumperInStreamAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.VideoBumperInStreamAdInfo} VideoBumperInStreamAdInfo instance
                         */
                        VideoBumperInStreamAdInfo.create = function create(properties) {
                            return new VideoBumperInStreamAdInfo(properties);
                        };

                        /**
                         * Encodes the specified VideoBumperInStreamAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.VideoBumperInStreamAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.VideoBumperInStreamAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IVideoBumperInStreamAdInfo} message VideoBumperInStreamAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VideoBumperInStreamAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified VideoBumperInStreamAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.VideoBumperInStreamAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.VideoBumperInStreamAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IVideoBumperInStreamAdInfo} message VideoBumperInStreamAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VideoBumperInStreamAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a VideoBumperInStreamAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.VideoBumperInStreamAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.VideoBumperInStreamAdInfo} VideoBumperInStreamAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VideoBumperInStreamAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.VideoBumperInStreamAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a VideoBumperInStreamAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.VideoBumperInStreamAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.VideoBumperInStreamAdInfo} VideoBumperInStreamAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VideoBumperInStreamAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a VideoBumperInStreamAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.VideoBumperInStreamAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VideoBumperInStreamAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a VideoBumperInStreamAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.VideoBumperInStreamAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.VideoBumperInStreamAdInfo} VideoBumperInStreamAdInfo
                         */
                        VideoBumperInStreamAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.VideoBumperInStreamAdInfo)
                                return object;
                            return new $root.google.ads.googleads.v1.common.VideoBumperInStreamAdInfo();
                        };

                        /**
                         * Creates a plain object from a VideoBumperInStreamAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.VideoBumperInStreamAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.VideoBumperInStreamAdInfo} message VideoBumperInStreamAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VideoBumperInStreamAdInfo.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this VideoBumperInStreamAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.VideoBumperInStreamAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VideoBumperInStreamAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return VideoBumperInStreamAdInfo;
                    })();

                    common.VideoNonSkippableInStreamAdInfo = (function() {

                        /**
                         * Properties of a VideoNonSkippableInStreamAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IVideoNonSkippableInStreamAdInfo
                         */

                        /**
                         * Constructs a new VideoNonSkippableInStreamAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a VideoNonSkippableInStreamAdInfo.
                         * @implements IVideoNonSkippableInStreamAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IVideoNonSkippableInStreamAdInfo=} [properties] Properties to set
                         */
                        function VideoNonSkippableInStreamAdInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new VideoNonSkippableInStreamAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IVideoNonSkippableInStreamAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo} VideoNonSkippableInStreamAdInfo instance
                         */
                        VideoNonSkippableInStreamAdInfo.create = function create(properties) {
                            return new VideoNonSkippableInStreamAdInfo(properties);
                        };

                        /**
                         * Encodes the specified VideoNonSkippableInStreamAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IVideoNonSkippableInStreamAdInfo} message VideoNonSkippableInStreamAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VideoNonSkippableInStreamAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified VideoNonSkippableInStreamAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IVideoNonSkippableInStreamAdInfo} message VideoNonSkippableInStreamAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VideoNonSkippableInStreamAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a VideoNonSkippableInStreamAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo} VideoNonSkippableInStreamAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VideoNonSkippableInStreamAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a VideoNonSkippableInStreamAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo} VideoNonSkippableInStreamAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VideoNonSkippableInStreamAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a VideoNonSkippableInStreamAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VideoNonSkippableInStreamAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a VideoNonSkippableInStreamAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo} VideoNonSkippableInStreamAdInfo
                         */
                        VideoNonSkippableInStreamAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo)
                                return object;
                            return new $root.google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo();
                        };

                        /**
                         * Creates a plain object from a VideoNonSkippableInStreamAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo} message VideoNonSkippableInStreamAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VideoNonSkippableInStreamAdInfo.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this VideoNonSkippableInStreamAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VideoNonSkippableInStreamAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return VideoNonSkippableInStreamAdInfo;
                    })();

                    common.VideoTrueViewInStreamAdInfo = (function() {

                        /**
                         * Properties of a VideoTrueViewInStreamAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IVideoTrueViewInStreamAdInfo
                         * @property {google.protobuf.IStringValue|null} [actionButtonLabel] VideoTrueViewInStreamAdInfo actionButtonLabel
                         * @property {google.protobuf.IStringValue|null} [actionHeadline] VideoTrueViewInStreamAdInfo actionHeadline
                         * @property {google.protobuf.IStringValue|null} [companionBanner] VideoTrueViewInStreamAdInfo companionBanner
                         */

                        /**
                         * Constructs a new VideoTrueViewInStreamAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a VideoTrueViewInStreamAdInfo.
                         * @implements IVideoTrueViewInStreamAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IVideoTrueViewInStreamAdInfo=} [properties] Properties to set
                         */
                        function VideoTrueViewInStreamAdInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * VideoTrueViewInStreamAdInfo actionButtonLabel.
                         * @member {google.protobuf.IStringValue|null|undefined} actionButtonLabel
                         * @memberof google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo
                         * @instance
                         */
                        VideoTrueViewInStreamAdInfo.prototype.actionButtonLabel = null;

                        /**
                         * VideoTrueViewInStreamAdInfo actionHeadline.
                         * @member {google.protobuf.IStringValue|null|undefined} actionHeadline
                         * @memberof google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo
                         * @instance
                         */
                        VideoTrueViewInStreamAdInfo.prototype.actionHeadline = null;

                        /**
                         * VideoTrueViewInStreamAdInfo companionBanner.
                         * @member {google.protobuf.IStringValue|null|undefined} companionBanner
                         * @memberof google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo
                         * @instance
                         */
                        VideoTrueViewInStreamAdInfo.prototype.companionBanner = null;

                        /**
                         * Creates a new VideoTrueViewInStreamAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IVideoTrueViewInStreamAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo} VideoTrueViewInStreamAdInfo instance
                         */
                        VideoTrueViewInStreamAdInfo.create = function create(properties) {
                            return new VideoTrueViewInStreamAdInfo(properties);
                        };

                        /**
                         * Encodes the specified VideoTrueViewInStreamAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IVideoTrueViewInStreamAdInfo} message VideoTrueViewInStreamAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VideoTrueViewInStreamAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.actionButtonLabel != null && message.hasOwnProperty("actionButtonLabel"))
                                $root.google.protobuf.StringValue.encode(message.actionButtonLabel, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.actionHeadline != null && message.hasOwnProperty("actionHeadline"))
                                $root.google.protobuf.StringValue.encode(message.actionHeadline, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.companionBanner != null && message.hasOwnProperty("companionBanner"))
                                $root.google.protobuf.StringValue.encode(message.companionBanner, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified VideoTrueViewInStreamAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IVideoTrueViewInStreamAdInfo} message VideoTrueViewInStreamAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VideoTrueViewInStreamAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a VideoTrueViewInStreamAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo} VideoTrueViewInStreamAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VideoTrueViewInStreamAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.actionButtonLabel = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.actionHeadline = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.companionBanner = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a VideoTrueViewInStreamAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo} VideoTrueViewInStreamAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VideoTrueViewInStreamAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a VideoTrueViewInStreamAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VideoTrueViewInStreamAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.actionButtonLabel != null && message.hasOwnProperty("actionButtonLabel")) {
                                var error = $root.google.protobuf.StringValue.verify(message.actionButtonLabel);
                                if (error)
                                    return "actionButtonLabel." + error;
                            }
                            if (message.actionHeadline != null && message.hasOwnProperty("actionHeadline")) {
                                var error = $root.google.protobuf.StringValue.verify(message.actionHeadline);
                                if (error)
                                    return "actionHeadline." + error;
                            }
                            if (message.companionBanner != null && message.hasOwnProperty("companionBanner")) {
                                var error = $root.google.protobuf.StringValue.verify(message.companionBanner);
                                if (error)
                                    return "companionBanner." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a VideoTrueViewInStreamAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo} VideoTrueViewInStreamAdInfo
                         */
                        VideoTrueViewInStreamAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo();
                            if (object.actionButtonLabel != null) {
                                if (typeof object.actionButtonLabel !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo.actionButtonLabel: object expected");
                                message.actionButtonLabel = $root.google.protobuf.StringValue.fromObject(object.actionButtonLabel);
                            }
                            if (object.actionHeadline != null) {
                                if (typeof object.actionHeadline !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo.actionHeadline: object expected");
                                message.actionHeadline = $root.google.protobuf.StringValue.fromObject(object.actionHeadline);
                            }
                            if (object.companionBanner != null) {
                                if (typeof object.companionBanner !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo.companionBanner: object expected");
                                message.companionBanner = $root.google.protobuf.StringValue.fromObject(object.companionBanner);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a VideoTrueViewInStreamAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo} message VideoTrueViewInStreamAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VideoTrueViewInStreamAdInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.actionButtonLabel = null;
                                object.actionHeadline = null;
                                object.companionBanner = null;
                            }
                            if (message.actionButtonLabel != null && message.hasOwnProperty("actionButtonLabel"))
                                object.actionButtonLabel = $root.google.protobuf.StringValue.toObject(message.actionButtonLabel, options);
                            if (message.actionHeadline != null && message.hasOwnProperty("actionHeadline"))
                                object.actionHeadline = $root.google.protobuf.StringValue.toObject(message.actionHeadline, options);
                            if (message.companionBanner != null && message.hasOwnProperty("companionBanner"))
                                object.companionBanner = $root.google.protobuf.StringValue.toObject(message.companionBanner, options);
                            return object;
                        };

                        /**
                         * Converts this VideoTrueViewInStreamAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VideoTrueViewInStreamAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return VideoTrueViewInStreamAdInfo;
                    })();

                    common.VideoOutstreamAdInfo = (function() {

                        /**
                         * Properties of a VideoOutstreamAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IVideoOutstreamAdInfo
                         * @property {google.protobuf.IStringValue|null} [headline] VideoOutstreamAdInfo headline
                         * @property {google.protobuf.IStringValue|null} [description] VideoOutstreamAdInfo description
                         */

                        /**
                         * Constructs a new VideoOutstreamAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a VideoOutstreamAdInfo.
                         * @implements IVideoOutstreamAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IVideoOutstreamAdInfo=} [properties] Properties to set
                         */
                        function VideoOutstreamAdInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * VideoOutstreamAdInfo headline.
                         * @member {google.protobuf.IStringValue|null|undefined} headline
                         * @memberof google.ads.googleads.v1.common.VideoOutstreamAdInfo
                         * @instance
                         */
                        VideoOutstreamAdInfo.prototype.headline = null;

                        /**
                         * VideoOutstreamAdInfo description.
                         * @member {google.protobuf.IStringValue|null|undefined} description
                         * @memberof google.ads.googleads.v1.common.VideoOutstreamAdInfo
                         * @instance
                         */
                        VideoOutstreamAdInfo.prototype.description = null;

                        /**
                         * Creates a new VideoOutstreamAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.VideoOutstreamAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IVideoOutstreamAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.VideoOutstreamAdInfo} VideoOutstreamAdInfo instance
                         */
                        VideoOutstreamAdInfo.create = function create(properties) {
                            return new VideoOutstreamAdInfo(properties);
                        };

                        /**
                         * Encodes the specified VideoOutstreamAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.VideoOutstreamAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.VideoOutstreamAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IVideoOutstreamAdInfo} message VideoOutstreamAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VideoOutstreamAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.headline != null && message.hasOwnProperty("headline"))
                                $root.google.protobuf.StringValue.encode(message.headline, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.description != null && message.hasOwnProperty("description"))
                                $root.google.protobuf.StringValue.encode(message.description, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified VideoOutstreamAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.VideoOutstreamAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.VideoOutstreamAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IVideoOutstreamAdInfo} message VideoOutstreamAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VideoOutstreamAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a VideoOutstreamAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.VideoOutstreamAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.VideoOutstreamAdInfo} VideoOutstreamAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VideoOutstreamAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.VideoOutstreamAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.headline = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.description = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a VideoOutstreamAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.VideoOutstreamAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.VideoOutstreamAdInfo} VideoOutstreamAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VideoOutstreamAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a VideoOutstreamAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.VideoOutstreamAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VideoOutstreamAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.headline != null && message.hasOwnProperty("headline")) {
                                var error = $root.google.protobuf.StringValue.verify(message.headline);
                                if (error)
                                    return "headline." + error;
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                var error = $root.google.protobuf.StringValue.verify(message.description);
                                if (error)
                                    return "description." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a VideoOutstreamAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.VideoOutstreamAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.VideoOutstreamAdInfo} VideoOutstreamAdInfo
                         */
                        VideoOutstreamAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.VideoOutstreamAdInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.VideoOutstreamAdInfo();
                            if (object.headline != null) {
                                if (typeof object.headline !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.VideoOutstreamAdInfo.headline: object expected");
                                message.headline = $root.google.protobuf.StringValue.fromObject(object.headline);
                            }
                            if (object.description != null) {
                                if (typeof object.description !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.VideoOutstreamAdInfo.description: object expected");
                                message.description = $root.google.protobuf.StringValue.fromObject(object.description);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a VideoOutstreamAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.VideoOutstreamAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.VideoOutstreamAdInfo} message VideoOutstreamAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VideoOutstreamAdInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.headline = null;
                                object.description = null;
                            }
                            if (message.headline != null && message.hasOwnProperty("headline"))
                                object.headline = $root.google.protobuf.StringValue.toObject(message.headline, options);
                            if (message.description != null && message.hasOwnProperty("description"))
                                object.description = $root.google.protobuf.StringValue.toObject(message.description, options);
                            return object;
                        };

                        /**
                         * Converts this VideoOutstreamAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.VideoOutstreamAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VideoOutstreamAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return VideoOutstreamAdInfo;
                    })();

                    common.VideoAdInfo = (function() {

                        /**
                         * Properties of a VideoAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IVideoAdInfo
                         * @property {google.protobuf.IStringValue|null} [mediaFile] VideoAdInfo mediaFile
                         * @property {google.ads.googleads.v1.common.IVideoTrueViewInStreamAdInfo|null} [inStream] VideoAdInfo inStream
                         * @property {google.ads.googleads.v1.common.IVideoBumperInStreamAdInfo|null} [bumper] VideoAdInfo bumper
                         * @property {google.ads.googleads.v1.common.IVideoOutstreamAdInfo|null} [outStream] VideoAdInfo outStream
                         * @property {google.ads.googleads.v1.common.IVideoNonSkippableInStreamAdInfo|null} [nonSkippable] VideoAdInfo nonSkippable
                         */

                        /**
                         * Constructs a new VideoAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a VideoAdInfo.
                         * @implements IVideoAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IVideoAdInfo=} [properties] Properties to set
                         */
                        function VideoAdInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * VideoAdInfo mediaFile.
                         * @member {google.protobuf.IStringValue|null|undefined} mediaFile
                         * @memberof google.ads.googleads.v1.common.VideoAdInfo
                         * @instance
                         */
                        VideoAdInfo.prototype.mediaFile = null;

                        /**
                         * VideoAdInfo inStream.
                         * @member {google.ads.googleads.v1.common.IVideoTrueViewInStreamAdInfo|null|undefined} inStream
                         * @memberof google.ads.googleads.v1.common.VideoAdInfo
                         * @instance
                         */
                        VideoAdInfo.prototype.inStream = null;

                        /**
                         * VideoAdInfo bumper.
                         * @member {google.ads.googleads.v1.common.IVideoBumperInStreamAdInfo|null|undefined} bumper
                         * @memberof google.ads.googleads.v1.common.VideoAdInfo
                         * @instance
                         */
                        VideoAdInfo.prototype.bumper = null;

                        /**
                         * VideoAdInfo outStream.
                         * @member {google.ads.googleads.v1.common.IVideoOutstreamAdInfo|null|undefined} outStream
                         * @memberof google.ads.googleads.v1.common.VideoAdInfo
                         * @instance
                         */
                        VideoAdInfo.prototype.outStream = null;

                        /**
                         * VideoAdInfo nonSkippable.
                         * @member {google.ads.googleads.v1.common.IVideoNonSkippableInStreamAdInfo|null|undefined} nonSkippable
                         * @memberof google.ads.googleads.v1.common.VideoAdInfo
                         * @instance
                         */
                        VideoAdInfo.prototype.nonSkippable = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * VideoAdInfo format.
                         * @member {"inStream"|"bumper"|"outStream"|"nonSkippable"|undefined} format
                         * @memberof google.ads.googleads.v1.common.VideoAdInfo
                         * @instance
                         */
                        Object.defineProperty(VideoAdInfo.prototype, "format", {
                            get: $util.oneOfGetter($oneOfFields = ["inStream", "bumper", "outStream", "nonSkippable"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new VideoAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.VideoAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IVideoAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.VideoAdInfo} VideoAdInfo instance
                         */
                        VideoAdInfo.create = function create(properties) {
                            return new VideoAdInfo(properties);
                        };

                        /**
                         * Encodes the specified VideoAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.VideoAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.VideoAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IVideoAdInfo} message VideoAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VideoAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.mediaFile != null && message.hasOwnProperty("mediaFile"))
                                $root.google.protobuf.StringValue.encode(message.mediaFile, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.inStream != null && message.hasOwnProperty("inStream"))
                                $root.google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo.encode(message.inStream, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.bumper != null && message.hasOwnProperty("bumper"))
                                $root.google.ads.googleads.v1.common.VideoBumperInStreamAdInfo.encode(message.bumper, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.outStream != null && message.hasOwnProperty("outStream"))
                                $root.google.ads.googleads.v1.common.VideoOutstreamAdInfo.encode(message.outStream, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.nonSkippable != null && message.hasOwnProperty("nonSkippable"))
                                $root.google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo.encode(message.nonSkippable, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified VideoAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.VideoAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.VideoAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IVideoAdInfo} message VideoAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VideoAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a VideoAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.VideoAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.VideoAdInfo} VideoAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VideoAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.VideoAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.mediaFile = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.inStream = $root.google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.bumper = $root.google.ads.googleads.v1.common.VideoBumperInStreamAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.outStream = $root.google.ads.googleads.v1.common.VideoOutstreamAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.nonSkippable = $root.google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a VideoAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.VideoAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.VideoAdInfo} VideoAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VideoAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a VideoAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.VideoAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VideoAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.mediaFile != null && message.hasOwnProperty("mediaFile")) {
                                var error = $root.google.protobuf.StringValue.verify(message.mediaFile);
                                if (error)
                                    return "mediaFile." + error;
                            }
                            if (message.inStream != null && message.hasOwnProperty("inStream")) {
                                properties.format = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo.verify(message.inStream);
                                    if (error)
                                        return "inStream." + error;
                                }
                            }
                            if (message.bumper != null && message.hasOwnProperty("bumper")) {
                                if (properties.format === 1)
                                    return "format: multiple values";
                                properties.format = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.VideoBumperInStreamAdInfo.verify(message.bumper);
                                    if (error)
                                        return "bumper." + error;
                                }
                            }
                            if (message.outStream != null && message.hasOwnProperty("outStream")) {
                                if (properties.format === 1)
                                    return "format: multiple values";
                                properties.format = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.VideoOutstreamAdInfo.verify(message.outStream);
                                    if (error)
                                        return "outStream." + error;
                                }
                            }
                            if (message.nonSkippable != null && message.hasOwnProperty("nonSkippable")) {
                                if (properties.format === 1)
                                    return "format: multiple values";
                                properties.format = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo.verify(message.nonSkippable);
                                    if (error)
                                        return "nonSkippable." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a VideoAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.VideoAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.VideoAdInfo} VideoAdInfo
                         */
                        VideoAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.VideoAdInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.VideoAdInfo();
                            if (object.mediaFile != null) {
                                if (typeof object.mediaFile !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.VideoAdInfo.mediaFile: object expected");
                                message.mediaFile = $root.google.protobuf.StringValue.fromObject(object.mediaFile);
                            }
                            if (object.inStream != null) {
                                if (typeof object.inStream !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.VideoAdInfo.inStream: object expected");
                                message.inStream = $root.google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo.fromObject(object.inStream);
                            }
                            if (object.bumper != null) {
                                if (typeof object.bumper !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.VideoAdInfo.bumper: object expected");
                                message.bumper = $root.google.ads.googleads.v1.common.VideoBumperInStreamAdInfo.fromObject(object.bumper);
                            }
                            if (object.outStream != null) {
                                if (typeof object.outStream !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.VideoAdInfo.outStream: object expected");
                                message.outStream = $root.google.ads.googleads.v1.common.VideoOutstreamAdInfo.fromObject(object.outStream);
                            }
                            if (object.nonSkippable != null) {
                                if (typeof object.nonSkippable !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.VideoAdInfo.nonSkippable: object expected");
                                message.nonSkippable = $root.google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo.fromObject(object.nonSkippable);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a VideoAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.VideoAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.VideoAdInfo} message VideoAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VideoAdInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.mediaFile = null;
                            if (message.mediaFile != null && message.hasOwnProperty("mediaFile"))
                                object.mediaFile = $root.google.protobuf.StringValue.toObject(message.mediaFile, options);
                            if (message.inStream != null && message.hasOwnProperty("inStream")) {
                                object.inStream = $root.google.ads.googleads.v1.common.VideoTrueViewInStreamAdInfo.toObject(message.inStream, options);
                                if (options.oneofs)
                                    object.format = "inStream";
                            }
                            if (message.bumper != null && message.hasOwnProperty("bumper")) {
                                object.bumper = $root.google.ads.googleads.v1.common.VideoBumperInStreamAdInfo.toObject(message.bumper, options);
                                if (options.oneofs)
                                    object.format = "bumper";
                            }
                            if (message.outStream != null && message.hasOwnProperty("outStream")) {
                                object.outStream = $root.google.ads.googleads.v1.common.VideoOutstreamAdInfo.toObject(message.outStream, options);
                                if (options.oneofs)
                                    object.format = "outStream";
                            }
                            if (message.nonSkippable != null && message.hasOwnProperty("nonSkippable")) {
                                object.nonSkippable = $root.google.ads.googleads.v1.common.VideoNonSkippableInStreamAdInfo.toObject(message.nonSkippable, options);
                                if (options.oneofs)
                                    object.format = "nonSkippable";
                            }
                            return object;
                        };

                        /**
                         * Converts this VideoAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.VideoAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VideoAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return VideoAdInfo;
                    })();

                    common.ResponsiveSearchAdInfo = (function() {

                        /**
                         * Properties of a ResponsiveSearchAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IResponsiveSearchAdInfo
                         * @property {Array.<google.ads.googleads.v1.common.IAdTextAsset>|null} [headlines] ResponsiveSearchAdInfo headlines
                         * @property {Array.<google.ads.googleads.v1.common.IAdTextAsset>|null} [descriptions] ResponsiveSearchAdInfo descriptions
                         * @property {google.protobuf.IStringValue|null} [path1] ResponsiveSearchAdInfo path1
                         * @property {google.protobuf.IStringValue|null} [path2] ResponsiveSearchAdInfo path2
                         */

                        /**
                         * Constructs a new ResponsiveSearchAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ResponsiveSearchAdInfo.
                         * @implements IResponsiveSearchAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IResponsiveSearchAdInfo=} [properties] Properties to set
                         */
                        function ResponsiveSearchAdInfo(properties) {
                            this.headlines = [];
                            this.descriptions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ResponsiveSearchAdInfo headlines.
                         * @member {Array.<google.ads.googleads.v1.common.IAdTextAsset>} headlines
                         * @memberof google.ads.googleads.v1.common.ResponsiveSearchAdInfo
                         * @instance
                         */
                        ResponsiveSearchAdInfo.prototype.headlines = $util.emptyArray;

                        /**
                         * ResponsiveSearchAdInfo descriptions.
                         * @member {Array.<google.ads.googleads.v1.common.IAdTextAsset>} descriptions
                         * @memberof google.ads.googleads.v1.common.ResponsiveSearchAdInfo
                         * @instance
                         */
                        ResponsiveSearchAdInfo.prototype.descriptions = $util.emptyArray;

                        /**
                         * ResponsiveSearchAdInfo path1.
                         * @member {google.protobuf.IStringValue|null|undefined} path1
                         * @memberof google.ads.googleads.v1.common.ResponsiveSearchAdInfo
                         * @instance
                         */
                        ResponsiveSearchAdInfo.prototype.path1 = null;

                        /**
                         * ResponsiveSearchAdInfo path2.
                         * @member {google.protobuf.IStringValue|null|undefined} path2
                         * @memberof google.ads.googleads.v1.common.ResponsiveSearchAdInfo
                         * @instance
                         */
                        ResponsiveSearchAdInfo.prototype.path2 = null;

                        /**
                         * Creates a new ResponsiveSearchAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ResponsiveSearchAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IResponsiveSearchAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ResponsiveSearchAdInfo} ResponsiveSearchAdInfo instance
                         */
                        ResponsiveSearchAdInfo.create = function create(properties) {
                            return new ResponsiveSearchAdInfo(properties);
                        };

                        /**
                         * Encodes the specified ResponsiveSearchAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ResponsiveSearchAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ResponsiveSearchAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IResponsiveSearchAdInfo} message ResponsiveSearchAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResponsiveSearchAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.headlines != null && message.headlines.length)
                                for (var i = 0; i < message.headlines.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdTextAsset.encode(message.headlines[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.descriptions != null && message.descriptions.length)
                                for (var i = 0; i < message.descriptions.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdTextAsset.encode(message.descriptions[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.path1 != null && message.hasOwnProperty("path1"))
                                $root.google.protobuf.StringValue.encode(message.path1, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.path2 != null && message.hasOwnProperty("path2"))
                                $root.google.protobuf.StringValue.encode(message.path2, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ResponsiveSearchAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ResponsiveSearchAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ResponsiveSearchAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IResponsiveSearchAdInfo} message ResponsiveSearchAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResponsiveSearchAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ResponsiveSearchAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ResponsiveSearchAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ResponsiveSearchAdInfo} ResponsiveSearchAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResponsiveSearchAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ResponsiveSearchAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.headlines && message.headlines.length))
                                        message.headlines = [];
                                    message.headlines.push($root.google.ads.googleads.v1.common.AdTextAsset.decode(reader, reader.uint32()));
                                    break;
                                case 2:
                                    if (!(message.descriptions && message.descriptions.length))
                                        message.descriptions = [];
                                    message.descriptions.push($root.google.ads.googleads.v1.common.AdTextAsset.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.path1 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.path2 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ResponsiveSearchAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ResponsiveSearchAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ResponsiveSearchAdInfo} ResponsiveSearchAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResponsiveSearchAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ResponsiveSearchAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ResponsiveSearchAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResponsiveSearchAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.headlines != null && message.hasOwnProperty("headlines")) {
                                if (!Array.isArray(message.headlines))
                                    return "headlines: array expected";
                                for (var i = 0; i < message.headlines.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdTextAsset.verify(message.headlines[i]);
                                    if (error)
                                        return "headlines." + error;
                                }
                            }
                            if (message.descriptions != null && message.hasOwnProperty("descriptions")) {
                                if (!Array.isArray(message.descriptions))
                                    return "descriptions: array expected";
                                for (var i = 0; i < message.descriptions.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdTextAsset.verify(message.descriptions[i]);
                                    if (error)
                                        return "descriptions." + error;
                                }
                            }
                            if (message.path1 != null && message.hasOwnProperty("path1")) {
                                var error = $root.google.protobuf.StringValue.verify(message.path1);
                                if (error)
                                    return "path1." + error;
                            }
                            if (message.path2 != null && message.hasOwnProperty("path2")) {
                                var error = $root.google.protobuf.StringValue.verify(message.path2);
                                if (error)
                                    return "path2." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a ResponsiveSearchAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ResponsiveSearchAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ResponsiveSearchAdInfo} ResponsiveSearchAdInfo
                         */
                        ResponsiveSearchAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ResponsiveSearchAdInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ResponsiveSearchAdInfo();
                            if (object.headlines) {
                                if (!Array.isArray(object.headlines))
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveSearchAdInfo.headlines: array expected");
                                message.headlines = [];
                                for (var i = 0; i < object.headlines.length; ++i) {
                                    if (typeof object.headlines[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.ResponsiveSearchAdInfo.headlines: object expected");
                                    message.headlines[i] = $root.google.ads.googleads.v1.common.AdTextAsset.fromObject(object.headlines[i]);
                                }
                            }
                            if (object.descriptions) {
                                if (!Array.isArray(object.descriptions))
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveSearchAdInfo.descriptions: array expected");
                                message.descriptions = [];
                                for (var i = 0; i < object.descriptions.length; ++i) {
                                    if (typeof object.descriptions[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.ResponsiveSearchAdInfo.descriptions: object expected");
                                    message.descriptions[i] = $root.google.ads.googleads.v1.common.AdTextAsset.fromObject(object.descriptions[i]);
                                }
                            }
                            if (object.path1 != null) {
                                if (typeof object.path1 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveSearchAdInfo.path1: object expected");
                                message.path1 = $root.google.protobuf.StringValue.fromObject(object.path1);
                            }
                            if (object.path2 != null) {
                                if (typeof object.path2 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveSearchAdInfo.path2: object expected");
                                message.path2 = $root.google.protobuf.StringValue.fromObject(object.path2);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ResponsiveSearchAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ResponsiveSearchAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ResponsiveSearchAdInfo} message ResponsiveSearchAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResponsiveSearchAdInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.headlines = [];
                                object.descriptions = [];
                            }
                            if (options.defaults) {
                                object.path1 = null;
                                object.path2 = null;
                            }
                            if (message.headlines && message.headlines.length) {
                                object.headlines = [];
                                for (var j = 0; j < message.headlines.length; ++j)
                                    object.headlines[j] = $root.google.ads.googleads.v1.common.AdTextAsset.toObject(message.headlines[j], options);
                            }
                            if (message.descriptions && message.descriptions.length) {
                                object.descriptions = [];
                                for (var j = 0; j < message.descriptions.length; ++j)
                                    object.descriptions[j] = $root.google.ads.googleads.v1.common.AdTextAsset.toObject(message.descriptions[j], options);
                            }
                            if (message.path1 != null && message.hasOwnProperty("path1"))
                                object.path1 = $root.google.protobuf.StringValue.toObject(message.path1, options);
                            if (message.path2 != null && message.hasOwnProperty("path2"))
                                object.path2 = $root.google.protobuf.StringValue.toObject(message.path2, options);
                            return object;
                        };

                        /**
                         * Converts this ResponsiveSearchAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ResponsiveSearchAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResponsiveSearchAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ResponsiveSearchAdInfo;
                    })();

                    common.LegacyResponsiveDisplayAdInfo = (function() {

                        /**
                         * Properties of a LegacyResponsiveDisplayAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ILegacyResponsiveDisplayAdInfo
                         * @property {google.protobuf.IStringValue|null} [shortHeadline] LegacyResponsiveDisplayAdInfo shortHeadline
                         * @property {google.protobuf.IStringValue|null} [longHeadline] LegacyResponsiveDisplayAdInfo longHeadline
                         * @property {google.protobuf.IStringValue|null} [description] LegacyResponsiveDisplayAdInfo description
                         * @property {google.protobuf.IStringValue|null} [businessName] LegacyResponsiveDisplayAdInfo businessName
                         * @property {google.protobuf.IBoolValue|null} [allowFlexibleColor] LegacyResponsiveDisplayAdInfo allowFlexibleColor
                         * @property {google.protobuf.IStringValue|null} [accentColor] LegacyResponsiveDisplayAdInfo accentColor
                         * @property {google.protobuf.IStringValue|null} [mainColor] LegacyResponsiveDisplayAdInfo mainColor
                         * @property {google.protobuf.IStringValue|null} [callToActionText] LegacyResponsiveDisplayAdInfo callToActionText
                         * @property {google.protobuf.IStringValue|null} [logoImage] LegacyResponsiveDisplayAdInfo logoImage
                         * @property {google.protobuf.IStringValue|null} [squareLogoImage] LegacyResponsiveDisplayAdInfo squareLogoImage
                         * @property {google.protobuf.IStringValue|null} [marketingImage] LegacyResponsiveDisplayAdInfo marketingImage
                         * @property {google.protobuf.IStringValue|null} [squareMarketingImage] LegacyResponsiveDisplayAdInfo squareMarketingImage
                         * @property {google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum.DisplayAdFormatSetting|null} [formatSetting] LegacyResponsiveDisplayAdInfo formatSetting
                         * @property {google.protobuf.IStringValue|null} [pricePrefix] LegacyResponsiveDisplayAdInfo pricePrefix
                         * @property {google.protobuf.IStringValue|null} [promoText] LegacyResponsiveDisplayAdInfo promoText
                         */

                        /**
                         * Constructs a new LegacyResponsiveDisplayAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a LegacyResponsiveDisplayAdInfo.
                         * @implements ILegacyResponsiveDisplayAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ILegacyResponsiveDisplayAdInfo=} [properties] Properties to set
                         */
                        function LegacyResponsiveDisplayAdInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * LegacyResponsiveDisplayAdInfo shortHeadline.
                         * @member {google.protobuf.IStringValue|null|undefined} shortHeadline
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @instance
                         */
                        LegacyResponsiveDisplayAdInfo.prototype.shortHeadline = null;

                        /**
                         * LegacyResponsiveDisplayAdInfo longHeadline.
                         * @member {google.protobuf.IStringValue|null|undefined} longHeadline
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @instance
                         */
                        LegacyResponsiveDisplayAdInfo.prototype.longHeadline = null;

                        /**
                         * LegacyResponsiveDisplayAdInfo description.
                         * @member {google.protobuf.IStringValue|null|undefined} description
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @instance
                         */
                        LegacyResponsiveDisplayAdInfo.prototype.description = null;

                        /**
                         * LegacyResponsiveDisplayAdInfo businessName.
                         * @member {google.protobuf.IStringValue|null|undefined} businessName
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @instance
                         */
                        LegacyResponsiveDisplayAdInfo.prototype.businessName = null;

                        /**
                         * LegacyResponsiveDisplayAdInfo allowFlexibleColor.
                         * @member {google.protobuf.IBoolValue|null|undefined} allowFlexibleColor
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @instance
                         */
                        LegacyResponsiveDisplayAdInfo.prototype.allowFlexibleColor = null;

                        /**
                         * LegacyResponsiveDisplayAdInfo accentColor.
                         * @member {google.protobuf.IStringValue|null|undefined} accentColor
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @instance
                         */
                        LegacyResponsiveDisplayAdInfo.prototype.accentColor = null;

                        /**
                         * LegacyResponsiveDisplayAdInfo mainColor.
                         * @member {google.protobuf.IStringValue|null|undefined} mainColor
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @instance
                         */
                        LegacyResponsiveDisplayAdInfo.prototype.mainColor = null;

                        /**
                         * LegacyResponsiveDisplayAdInfo callToActionText.
                         * @member {google.protobuf.IStringValue|null|undefined} callToActionText
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @instance
                         */
                        LegacyResponsiveDisplayAdInfo.prototype.callToActionText = null;

                        /**
                         * LegacyResponsiveDisplayAdInfo logoImage.
                         * @member {google.protobuf.IStringValue|null|undefined} logoImage
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @instance
                         */
                        LegacyResponsiveDisplayAdInfo.prototype.logoImage = null;

                        /**
                         * LegacyResponsiveDisplayAdInfo squareLogoImage.
                         * @member {google.protobuf.IStringValue|null|undefined} squareLogoImage
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @instance
                         */
                        LegacyResponsiveDisplayAdInfo.prototype.squareLogoImage = null;

                        /**
                         * LegacyResponsiveDisplayAdInfo marketingImage.
                         * @member {google.protobuf.IStringValue|null|undefined} marketingImage
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @instance
                         */
                        LegacyResponsiveDisplayAdInfo.prototype.marketingImage = null;

                        /**
                         * LegacyResponsiveDisplayAdInfo squareMarketingImage.
                         * @member {google.protobuf.IStringValue|null|undefined} squareMarketingImage
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @instance
                         */
                        LegacyResponsiveDisplayAdInfo.prototype.squareMarketingImage = null;

                        /**
                         * LegacyResponsiveDisplayAdInfo formatSetting.
                         * @member {google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum.DisplayAdFormatSetting} formatSetting
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @instance
                         */
                        LegacyResponsiveDisplayAdInfo.prototype.formatSetting = 0;

                        /**
                         * LegacyResponsiveDisplayAdInfo pricePrefix.
                         * @member {google.protobuf.IStringValue|null|undefined} pricePrefix
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @instance
                         */
                        LegacyResponsiveDisplayAdInfo.prototype.pricePrefix = null;

                        /**
                         * LegacyResponsiveDisplayAdInfo promoText.
                         * @member {google.protobuf.IStringValue|null|undefined} promoText
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @instance
                         */
                        LegacyResponsiveDisplayAdInfo.prototype.promoText = null;

                        /**
                         * Creates a new LegacyResponsiveDisplayAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILegacyResponsiveDisplayAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo} LegacyResponsiveDisplayAdInfo instance
                         */
                        LegacyResponsiveDisplayAdInfo.create = function create(properties) {
                            return new LegacyResponsiveDisplayAdInfo(properties);
                        };

                        /**
                         * Encodes the specified LegacyResponsiveDisplayAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILegacyResponsiveDisplayAdInfo} message LegacyResponsiveDisplayAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LegacyResponsiveDisplayAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.shortHeadline != null && message.hasOwnProperty("shortHeadline"))
                                $root.google.protobuf.StringValue.encode(message.shortHeadline, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.longHeadline != null && message.hasOwnProperty("longHeadline"))
                                $root.google.protobuf.StringValue.encode(message.longHeadline, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.description != null && message.hasOwnProperty("description"))
                                $root.google.protobuf.StringValue.encode(message.description, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.businessName != null && message.hasOwnProperty("businessName"))
                                $root.google.protobuf.StringValue.encode(message.businessName, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.allowFlexibleColor != null && message.hasOwnProperty("allowFlexibleColor"))
                                $root.google.protobuf.BoolValue.encode(message.allowFlexibleColor, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.accentColor != null && message.hasOwnProperty("accentColor"))
                                $root.google.protobuf.StringValue.encode(message.accentColor, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.mainColor != null && message.hasOwnProperty("mainColor"))
                                $root.google.protobuf.StringValue.encode(message.mainColor, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.callToActionText != null && message.hasOwnProperty("callToActionText"))
                                $root.google.protobuf.StringValue.encode(message.callToActionText, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.logoImage != null && message.hasOwnProperty("logoImage"))
                                $root.google.protobuf.StringValue.encode(message.logoImage, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.squareLogoImage != null && message.hasOwnProperty("squareLogoImage"))
                                $root.google.protobuf.StringValue.encode(message.squareLogoImage, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.marketingImage != null && message.hasOwnProperty("marketingImage"))
                                $root.google.protobuf.StringValue.encode(message.marketingImage, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.squareMarketingImage != null && message.hasOwnProperty("squareMarketingImage"))
                                $root.google.protobuf.StringValue.encode(message.squareMarketingImage, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.formatSetting != null && message.hasOwnProperty("formatSetting"))
                                writer.uint32(/* id 13, wireType 0 =*/104).int32(message.formatSetting);
                            if (message.pricePrefix != null && message.hasOwnProperty("pricePrefix"))
                                $root.google.protobuf.StringValue.encode(message.pricePrefix, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.promoText != null && message.hasOwnProperty("promoText"))
                                $root.google.protobuf.StringValue.encode(message.promoText, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified LegacyResponsiveDisplayAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILegacyResponsiveDisplayAdInfo} message LegacyResponsiveDisplayAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LegacyResponsiveDisplayAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LegacyResponsiveDisplayAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo} LegacyResponsiveDisplayAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LegacyResponsiveDisplayAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.shortHeadline = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.longHeadline = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.description = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.businessName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.allowFlexibleColor = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.accentColor = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.mainColor = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.callToActionText = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.logoImage = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.squareLogoImage = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.marketingImage = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.squareMarketingImage = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 13:
                                    message.formatSetting = reader.int32();
                                    break;
                                case 14:
                                    message.pricePrefix = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 15:
                                    message.promoText = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LegacyResponsiveDisplayAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo} LegacyResponsiveDisplayAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LegacyResponsiveDisplayAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LegacyResponsiveDisplayAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LegacyResponsiveDisplayAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.shortHeadline != null && message.hasOwnProperty("shortHeadline")) {
                                var error = $root.google.protobuf.StringValue.verify(message.shortHeadline);
                                if (error)
                                    return "shortHeadline." + error;
                            }
                            if (message.longHeadline != null && message.hasOwnProperty("longHeadline")) {
                                var error = $root.google.protobuf.StringValue.verify(message.longHeadline);
                                if (error)
                                    return "longHeadline." + error;
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                var error = $root.google.protobuf.StringValue.verify(message.description);
                                if (error)
                                    return "description." + error;
                            }
                            if (message.businessName != null && message.hasOwnProperty("businessName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.businessName);
                                if (error)
                                    return "businessName." + error;
                            }
                            if (message.allowFlexibleColor != null && message.hasOwnProperty("allowFlexibleColor")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.allowFlexibleColor);
                                if (error)
                                    return "allowFlexibleColor." + error;
                            }
                            if (message.accentColor != null && message.hasOwnProperty("accentColor")) {
                                var error = $root.google.protobuf.StringValue.verify(message.accentColor);
                                if (error)
                                    return "accentColor." + error;
                            }
                            if (message.mainColor != null && message.hasOwnProperty("mainColor")) {
                                var error = $root.google.protobuf.StringValue.verify(message.mainColor);
                                if (error)
                                    return "mainColor." + error;
                            }
                            if (message.callToActionText != null && message.hasOwnProperty("callToActionText")) {
                                var error = $root.google.protobuf.StringValue.verify(message.callToActionText);
                                if (error)
                                    return "callToActionText." + error;
                            }
                            if (message.logoImage != null && message.hasOwnProperty("logoImage")) {
                                var error = $root.google.protobuf.StringValue.verify(message.logoImage);
                                if (error)
                                    return "logoImage." + error;
                            }
                            if (message.squareLogoImage != null && message.hasOwnProperty("squareLogoImage")) {
                                var error = $root.google.protobuf.StringValue.verify(message.squareLogoImage);
                                if (error)
                                    return "squareLogoImage." + error;
                            }
                            if (message.marketingImage != null && message.hasOwnProperty("marketingImage")) {
                                var error = $root.google.protobuf.StringValue.verify(message.marketingImage);
                                if (error)
                                    return "marketingImage." + error;
                            }
                            if (message.squareMarketingImage != null && message.hasOwnProperty("squareMarketingImage")) {
                                var error = $root.google.protobuf.StringValue.verify(message.squareMarketingImage);
                                if (error)
                                    return "squareMarketingImage." + error;
                            }
                            if (message.formatSetting != null && message.hasOwnProperty("formatSetting"))
                                switch (message.formatSetting) {
                                default:
                                    return "formatSetting: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.pricePrefix != null && message.hasOwnProperty("pricePrefix")) {
                                var error = $root.google.protobuf.StringValue.verify(message.pricePrefix);
                                if (error)
                                    return "pricePrefix." + error;
                            }
                            if (message.promoText != null && message.hasOwnProperty("promoText")) {
                                var error = $root.google.protobuf.StringValue.verify(message.promoText);
                                if (error)
                                    return "promoText." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a LegacyResponsiveDisplayAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo} LegacyResponsiveDisplayAdInfo
                         */
                        LegacyResponsiveDisplayAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo();
                            if (object.shortHeadline != null) {
                                if (typeof object.shortHeadline !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.shortHeadline: object expected");
                                message.shortHeadline = $root.google.protobuf.StringValue.fromObject(object.shortHeadline);
                            }
                            if (object.longHeadline != null) {
                                if (typeof object.longHeadline !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.longHeadline: object expected");
                                message.longHeadline = $root.google.protobuf.StringValue.fromObject(object.longHeadline);
                            }
                            if (object.description != null) {
                                if (typeof object.description !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.description: object expected");
                                message.description = $root.google.protobuf.StringValue.fromObject(object.description);
                            }
                            if (object.businessName != null) {
                                if (typeof object.businessName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.businessName: object expected");
                                message.businessName = $root.google.protobuf.StringValue.fromObject(object.businessName);
                            }
                            if (object.allowFlexibleColor != null) {
                                if (typeof object.allowFlexibleColor !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.allowFlexibleColor: object expected");
                                message.allowFlexibleColor = $root.google.protobuf.BoolValue.fromObject(object.allowFlexibleColor);
                            }
                            if (object.accentColor != null) {
                                if (typeof object.accentColor !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.accentColor: object expected");
                                message.accentColor = $root.google.protobuf.StringValue.fromObject(object.accentColor);
                            }
                            if (object.mainColor != null) {
                                if (typeof object.mainColor !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.mainColor: object expected");
                                message.mainColor = $root.google.protobuf.StringValue.fromObject(object.mainColor);
                            }
                            if (object.callToActionText != null) {
                                if (typeof object.callToActionText !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.callToActionText: object expected");
                                message.callToActionText = $root.google.protobuf.StringValue.fromObject(object.callToActionText);
                            }
                            if (object.logoImage != null) {
                                if (typeof object.logoImage !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.logoImage: object expected");
                                message.logoImage = $root.google.protobuf.StringValue.fromObject(object.logoImage);
                            }
                            if (object.squareLogoImage != null) {
                                if (typeof object.squareLogoImage !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.squareLogoImage: object expected");
                                message.squareLogoImage = $root.google.protobuf.StringValue.fromObject(object.squareLogoImage);
                            }
                            if (object.marketingImage != null) {
                                if (typeof object.marketingImage !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.marketingImage: object expected");
                                message.marketingImage = $root.google.protobuf.StringValue.fromObject(object.marketingImage);
                            }
                            if (object.squareMarketingImage != null) {
                                if (typeof object.squareMarketingImage !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.squareMarketingImage: object expected");
                                message.squareMarketingImage = $root.google.protobuf.StringValue.fromObject(object.squareMarketingImage);
                            }
                            switch (object.formatSetting) {
                            case "UNSPECIFIED":
                            case 0:
                                message.formatSetting = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.formatSetting = 1;
                                break;
                            case "ALL_FORMATS":
                            case 2:
                                message.formatSetting = 2;
                                break;
                            case "NON_NATIVE":
                            case 3:
                                message.formatSetting = 3;
                                break;
                            case "NATIVE":
                            case 4:
                                message.formatSetting = 4;
                                break;
                            }
                            if (object.pricePrefix != null) {
                                if (typeof object.pricePrefix !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.pricePrefix: object expected");
                                message.pricePrefix = $root.google.protobuf.StringValue.fromObject(object.pricePrefix);
                            }
                            if (object.promoText != null) {
                                if (typeof object.promoText !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.promoText: object expected");
                                message.promoText = $root.google.protobuf.StringValue.fromObject(object.promoText);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a LegacyResponsiveDisplayAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo} message LegacyResponsiveDisplayAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LegacyResponsiveDisplayAdInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.shortHeadline = null;
                                object.longHeadline = null;
                                object.description = null;
                                object.businessName = null;
                                object.allowFlexibleColor = null;
                                object.accentColor = null;
                                object.mainColor = null;
                                object.callToActionText = null;
                                object.logoImage = null;
                                object.squareLogoImage = null;
                                object.marketingImage = null;
                                object.squareMarketingImage = null;
                                object.formatSetting = options.enums === String ? "UNSPECIFIED" : 0;
                                object.pricePrefix = null;
                                object.promoText = null;
                            }
                            if (message.shortHeadline != null && message.hasOwnProperty("shortHeadline"))
                                object.shortHeadline = $root.google.protobuf.StringValue.toObject(message.shortHeadline, options);
                            if (message.longHeadline != null && message.hasOwnProperty("longHeadline"))
                                object.longHeadline = $root.google.protobuf.StringValue.toObject(message.longHeadline, options);
                            if (message.description != null && message.hasOwnProperty("description"))
                                object.description = $root.google.protobuf.StringValue.toObject(message.description, options);
                            if (message.businessName != null && message.hasOwnProperty("businessName"))
                                object.businessName = $root.google.protobuf.StringValue.toObject(message.businessName, options);
                            if (message.allowFlexibleColor != null && message.hasOwnProperty("allowFlexibleColor"))
                                object.allowFlexibleColor = $root.google.protobuf.BoolValue.toObject(message.allowFlexibleColor, options);
                            if (message.accentColor != null && message.hasOwnProperty("accentColor"))
                                object.accentColor = $root.google.protobuf.StringValue.toObject(message.accentColor, options);
                            if (message.mainColor != null && message.hasOwnProperty("mainColor"))
                                object.mainColor = $root.google.protobuf.StringValue.toObject(message.mainColor, options);
                            if (message.callToActionText != null && message.hasOwnProperty("callToActionText"))
                                object.callToActionText = $root.google.protobuf.StringValue.toObject(message.callToActionText, options);
                            if (message.logoImage != null && message.hasOwnProperty("logoImage"))
                                object.logoImage = $root.google.protobuf.StringValue.toObject(message.logoImage, options);
                            if (message.squareLogoImage != null && message.hasOwnProperty("squareLogoImage"))
                                object.squareLogoImage = $root.google.protobuf.StringValue.toObject(message.squareLogoImage, options);
                            if (message.marketingImage != null && message.hasOwnProperty("marketingImage"))
                                object.marketingImage = $root.google.protobuf.StringValue.toObject(message.marketingImage, options);
                            if (message.squareMarketingImage != null && message.hasOwnProperty("squareMarketingImage"))
                                object.squareMarketingImage = $root.google.protobuf.StringValue.toObject(message.squareMarketingImage, options);
                            if (message.formatSetting != null && message.hasOwnProperty("formatSetting"))
                                object.formatSetting = options.enums === String ? $root.google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum.DisplayAdFormatSetting[message.formatSetting] : message.formatSetting;
                            if (message.pricePrefix != null && message.hasOwnProperty("pricePrefix"))
                                object.pricePrefix = $root.google.protobuf.StringValue.toObject(message.pricePrefix, options);
                            if (message.promoText != null && message.hasOwnProperty("promoText"))
                                object.promoText = $root.google.protobuf.StringValue.toObject(message.promoText, options);
                            return object;
                        };

                        /**
                         * Converts this LegacyResponsiveDisplayAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LegacyResponsiveDisplayAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return LegacyResponsiveDisplayAdInfo;
                    })();

                    common.AppAdInfo = (function() {

                        /**
                         * Properties of an AppAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IAppAdInfo
                         * @property {google.ads.googleads.v1.common.IAdTextAsset|null} [mandatoryAdText] AppAdInfo mandatoryAdText
                         * @property {Array.<google.ads.googleads.v1.common.IAdTextAsset>|null} [headlines] AppAdInfo headlines
                         * @property {Array.<google.ads.googleads.v1.common.IAdTextAsset>|null} [descriptions] AppAdInfo descriptions
                         * @property {Array.<google.ads.googleads.v1.common.IAdImageAsset>|null} [images] AppAdInfo images
                         * @property {Array.<google.ads.googleads.v1.common.IAdVideoAsset>|null} [youtubeVideos] AppAdInfo youtubeVideos
                         * @property {Array.<google.ads.googleads.v1.common.IAdMediaBundleAsset>|null} [html5MediaBundles] AppAdInfo html5MediaBundles
                         */

                        /**
                         * Constructs a new AppAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an AppAdInfo.
                         * @implements IAppAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IAppAdInfo=} [properties] Properties to set
                         */
                        function AppAdInfo(properties) {
                            this.headlines = [];
                            this.descriptions = [];
                            this.images = [];
                            this.youtubeVideos = [];
                            this.html5MediaBundles = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AppAdInfo mandatoryAdText.
                         * @member {google.ads.googleads.v1.common.IAdTextAsset|null|undefined} mandatoryAdText
                         * @memberof google.ads.googleads.v1.common.AppAdInfo
                         * @instance
                         */
                        AppAdInfo.prototype.mandatoryAdText = null;

                        /**
                         * AppAdInfo headlines.
                         * @member {Array.<google.ads.googleads.v1.common.IAdTextAsset>} headlines
                         * @memberof google.ads.googleads.v1.common.AppAdInfo
                         * @instance
                         */
                        AppAdInfo.prototype.headlines = $util.emptyArray;

                        /**
                         * AppAdInfo descriptions.
                         * @member {Array.<google.ads.googleads.v1.common.IAdTextAsset>} descriptions
                         * @memberof google.ads.googleads.v1.common.AppAdInfo
                         * @instance
                         */
                        AppAdInfo.prototype.descriptions = $util.emptyArray;

                        /**
                         * AppAdInfo images.
                         * @member {Array.<google.ads.googleads.v1.common.IAdImageAsset>} images
                         * @memberof google.ads.googleads.v1.common.AppAdInfo
                         * @instance
                         */
                        AppAdInfo.prototype.images = $util.emptyArray;

                        /**
                         * AppAdInfo youtubeVideos.
                         * @member {Array.<google.ads.googleads.v1.common.IAdVideoAsset>} youtubeVideos
                         * @memberof google.ads.googleads.v1.common.AppAdInfo
                         * @instance
                         */
                        AppAdInfo.prototype.youtubeVideos = $util.emptyArray;

                        /**
                         * AppAdInfo html5MediaBundles.
                         * @member {Array.<google.ads.googleads.v1.common.IAdMediaBundleAsset>} html5MediaBundles
                         * @memberof google.ads.googleads.v1.common.AppAdInfo
                         * @instance
                         */
                        AppAdInfo.prototype.html5MediaBundles = $util.emptyArray;

                        /**
                         * Creates a new AppAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.AppAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IAppAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.AppAdInfo} AppAdInfo instance
                         */
                        AppAdInfo.create = function create(properties) {
                            return new AppAdInfo(properties);
                        };

                        /**
                         * Encodes the specified AppAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.AppAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.AppAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IAppAdInfo} message AppAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.mandatoryAdText != null && message.hasOwnProperty("mandatoryAdText"))
                                $root.google.ads.googleads.v1.common.AdTextAsset.encode(message.mandatoryAdText, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.headlines != null && message.headlines.length)
                                for (var i = 0; i < message.headlines.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdTextAsset.encode(message.headlines[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.descriptions != null && message.descriptions.length)
                                for (var i = 0; i < message.descriptions.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdTextAsset.encode(message.descriptions[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.images != null && message.images.length)
                                for (var i = 0; i < message.images.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdImageAsset.encode(message.images[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.youtubeVideos != null && message.youtubeVideos.length)
                                for (var i = 0; i < message.youtubeVideos.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdVideoAsset.encode(message.youtubeVideos[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.html5MediaBundles != null && message.html5MediaBundles.length)
                                for (var i = 0; i < message.html5MediaBundles.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdMediaBundleAsset.encode(message.html5MediaBundles[i], writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AppAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.AppAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.AppAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IAppAdInfo} message AppAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AppAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.AppAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.AppAdInfo} AppAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.AppAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.mandatoryAdText = $root.google.ads.googleads.v1.common.AdTextAsset.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.headlines && message.headlines.length))
                                        message.headlines = [];
                                    message.headlines.push($root.google.ads.googleads.v1.common.AdTextAsset.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    if (!(message.descriptions && message.descriptions.length))
                                        message.descriptions = [];
                                    message.descriptions.push($root.google.ads.googleads.v1.common.AdTextAsset.decode(reader, reader.uint32()));
                                    break;
                                case 4:
                                    if (!(message.images && message.images.length))
                                        message.images = [];
                                    message.images.push($root.google.ads.googleads.v1.common.AdImageAsset.decode(reader, reader.uint32()));
                                    break;
                                case 5:
                                    if (!(message.youtubeVideos && message.youtubeVideos.length))
                                        message.youtubeVideos = [];
                                    message.youtubeVideos.push($root.google.ads.googleads.v1.common.AdVideoAsset.decode(reader, reader.uint32()));
                                    break;
                                case 6:
                                    if (!(message.html5MediaBundles && message.html5MediaBundles.length))
                                        message.html5MediaBundles = [];
                                    message.html5MediaBundles.push($root.google.ads.googleads.v1.common.AdMediaBundleAsset.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AppAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.AppAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.AppAdInfo} AppAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AppAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.AppAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AppAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.mandatoryAdText != null && message.hasOwnProperty("mandatoryAdText")) {
                                var error = $root.google.ads.googleads.v1.common.AdTextAsset.verify(message.mandatoryAdText);
                                if (error)
                                    return "mandatoryAdText." + error;
                            }
                            if (message.headlines != null && message.hasOwnProperty("headlines")) {
                                if (!Array.isArray(message.headlines))
                                    return "headlines: array expected";
                                for (var i = 0; i < message.headlines.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdTextAsset.verify(message.headlines[i]);
                                    if (error)
                                        return "headlines." + error;
                                }
                            }
                            if (message.descriptions != null && message.hasOwnProperty("descriptions")) {
                                if (!Array.isArray(message.descriptions))
                                    return "descriptions: array expected";
                                for (var i = 0; i < message.descriptions.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdTextAsset.verify(message.descriptions[i]);
                                    if (error)
                                        return "descriptions." + error;
                                }
                            }
                            if (message.images != null && message.hasOwnProperty("images")) {
                                if (!Array.isArray(message.images))
                                    return "images: array expected";
                                for (var i = 0; i < message.images.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdImageAsset.verify(message.images[i]);
                                    if (error)
                                        return "images." + error;
                                }
                            }
                            if (message.youtubeVideos != null && message.hasOwnProperty("youtubeVideos")) {
                                if (!Array.isArray(message.youtubeVideos))
                                    return "youtubeVideos: array expected";
                                for (var i = 0; i < message.youtubeVideos.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdVideoAsset.verify(message.youtubeVideos[i]);
                                    if (error)
                                        return "youtubeVideos." + error;
                                }
                            }
                            if (message.html5MediaBundles != null && message.hasOwnProperty("html5MediaBundles")) {
                                if (!Array.isArray(message.html5MediaBundles))
                                    return "html5MediaBundles: array expected";
                                for (var i = 0; i < message.html5MediaBundles.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdMediaBundleAsset.verify(message.html5MediaBundles[i]);
                                    if (error)
                                        return "html5MediaBundles." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an AppAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.AppAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.AppAdInfo} AppAdInfo
                         */
                        AppAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.AppAdInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.AppAdInfo();
                            if (object.mandatoryAdText != null) {
                                if (typeof object.mandatoryAdText !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AppAdInfo.mandatoryAdText: object expected");
                                message.mandatoryAdText = $root.google.ads.googleads.v1.common.AdTextAsset.fromObject(object.mandatoryAdText);
                            }
                            if (object.headlines) {
                                if (!Array.isArray(object.headlines))
                                    throw TypeError(".google.ads.googleads.v1.common.AppAdInfo.headlines: array expected");
                                message.headlines = [];
                                for (var i = 0; i < object.headlines.length; ++i) {
                                    if (typeof object.headlines[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.AppAdInfo.headlines: object expected");
                                    message.headlines[i] = $root.google.ads.googleads.v1.common.AdTextAsset.fromObject(object.headlines[i]);
                                }
                            }
                            if (object.descriptions) {
                                if (!Array.isArray(object.descriptions))
                                    throw TypeError(".google.ads.googleads.v1.common.AppAdInfo.descriptions: array expected");
                                message.descriptions = [];
                                for (var i = 0; i < object.descriptions.length; ++i) {
                                    if (typeof object.descriptions[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.AppAdInfo.descriptions: object expected");
                                    message.descriptions[i] = $root.google.ads.googleads.v1.common.AdTextAsset.fromObject(object.descriptions[i]);
                                }
                            }
                            if (object.images) {
                                if (!Array.isArray(object.images))
                                    throw TypeError(".google.ads.googleads.v1.common.AppAdInfo.images: array expected");
                                message.images = [];
                                for (var i = 0; i < object.images.length; ++i) {
                                    if (typeof object.images[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.AppAdInfo.images: object expected");
                                    message.images[i] = $root.google.ads.googleads.v1.common.AdImageAsset.fromObject(object.images[i]);
                                }
                            }
                            if (object.youtubeVideos) {
                                if (!Array.isArray(object.youtubeVideos))
                                    throw TypeError(".google.ads.googleads.v1.common.AppAdInfo.youtubeVideos: array expected");
                                message.youtubeVideos = [];
                                for (var i = 0; i < object.youtubeVideos.length; ++i) {
                                    if (typeof object.youtubeVideos[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.AppAdInfo.youtubeVideos: object expected");
                                    message.youtubeVideos[i] = $root.google.ads.googleads.v1.common.AdVideoAsset.fromObject(object.youtubeVideos[i]);
                                }
                            }
                            if (object.html5MediaBundles) {
                                if (!Array.isArray(object.html5MediaBundles))
                                    throw TypeError(".google.ads.googleads.v1.common.AppAdInfo.html5MediaBundles: array expected");
                                message.html5MediaBundles = [];
                                for (var i = 0; i < object.html5MediaBundles.length; ++i) {
                                    if (typeof object.html5MediaBundles[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.AppAdInfo.html5MediaBundles: object expected");
                                    message.html5MediaBundles[i] = $root.google.ads.googleads.v1.common.AdMediaBundleAsset.fromObject(object.html5MediaBundles[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AppAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.AppAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.AppAdInfo} message AppAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AppAdInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.headlines = [];
                                object.descriptions = [];
                                object.images = [];
                                object.youtubeVideos = [];
                                object.html5MediaBundles = [];
                            }
                            if (options.defaults)
                                object.mandatoryAdText = null;
                            if (message.mandatoryAdText != null && message.hasOwnProperty("mandatoryAdText"))
                                object.mandatoryAdText = $root.google.ads.googleads.v1.common.AdTextAsset.toObject(message.mandatoryAdText, options);
                            if (message.headlines && message.headlines.length) {
                                object.headlines = [];
                                for (var j = 0; j < message.headlines.length; ++j)
                                    object.headlines[j] = $root.google.ads.googleads.v1.common.AdTextAsset.toObject(message.headlines[j], options);
                            }
                            if (message.descriptions && message.descriptions.length) {
                                object.descriptions = [];
                                for (var j = 0; j < message.descriptions.length; ++j)
                                    object.descriptions[j] = $root.google.ads.googleads.v1.common.AdTextAsset.toObject(message.descriptions[j], options);
                            }
                            if (message.images && message.images.length) {
                                object.images = [];
                                for (var j = 0; j < message.images.length; ++j)
                                    object.images[j] = $root.google.ads.googleads.v1.common.AdImageAsset.toObject(message.images[j], options);
                            }
                            if (message.youtubeVideos && message.youtubeVideos.length) {
                                object.youtubeVideos = [];
                                for (var j = 0; j < message.youtubeVideos.length; ++j)
                                    object.youtubeVideos[j] = $root.google.ads.googleads.v1.common.AdVideoAsset.toObject(message.youtubeVideos[j], options);
                            }
                            if (message.html5MediaBundles && message.html5MediaBundles.length) {
                                object.html5MediaBundles = [];
                                for (var j = 0; j < message.html5MediaBundles.length; ++j)
                                    object.html5MediaBundles[j] = $root.google.ads.googleads.v1.common.AdMediaBundleAsset.toObject(message.html5MediaBundles[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this AppAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.AppAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AppAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AppAdInfo;
                    })();

                    common.AppEngagementAdInfo = (function() {

                        /**
                         * Properties of an AppEngagementAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IAppEngagementAdInfo
                         * @property {Array.<google.ads.googleads.v1.common.IAdTextAsset>|null} [headlines] AppEngagementAdInfo headlines
                         * @property {Array.<google.ads.googleads.v1.common.IAdTextAsset>|null} [descriptions] AppEngagementAdInfo descriptions
                         * @property {Array.<google.ads.googleads.v1.common.IAdImageAsset>|null} [images] AppEngagementAdInfo images
                         * @property {Array.<google.ads.googleads.v1.common.IAdVideoAsset>|null} [videos] AppEngagementAdInfo videos
                         */

                        /**
                         * Constructs a new AppEngagementAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an AppEngagementAdInfo.
                         * @implements IAppEngagementAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IAppEngagementAdInfo=} [properties] Properties to set
                         */
                        function AppEngagementAdInfo(properties) {
                            this.headlines = [];
                            this.descriptions = [];
                            this.images = [];
                            this.videos = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AppEngagementAdInfo headlines.
                         * @member {Array.<google.ads.googleads.v1.common.IAdTextAsset>} headlines
                         * @memberof google.ads.googleads.v1.common.AppEngagementAdInfo
                         * @instance
                         */
                        AppEngagementAdInfo.prototype.headlines = $util.emptyArray;

                        /**
                         * AppEngagementAdInfo descriptions.
                         * @member {Array.<google.ads.googleads.v1.common.IAdTextAsset>} descriptions
                         * @memberof google.ads.googleads.v1.common.AppEngagementAdInfo
                         * @instance
                         */
                        AppEngagementAdInfo.prototype.descriptions = $util.emptyArray;

                        /**
                         * AppEngagementAdInfo images.
                         * @member {Array.<google.ads.googleads.v1.common.IAdImageAsset>} images
                         * @memberof google.ads.googleads.v1.common.AppEngagementAdInfo
                         * @instance
                         */
                        AppEngagementAdInfo.prototype.images = $util.emptyArray;

                        /**
                         * AppEngagementAdInfo videos.
                         * @member {Array.<google.ads.googleads.v1.common.IAdVideoAsset>} videos
                         * @memberof google.ads.googleads.v1.common.AppEngagementAdInfo
                         * @instance
                         */
                        AppEngagementAdInfo.prototype.videos = $util.emptyArray;

                        /**
                         * Creates a new AppEngagementAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.AppEngagementAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IAppEngagementAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.AppEngagementAdInfo} AppEngagementAdInfo instance
                         */
                        AppEngagementAdInfo.create = function create(properties) {
                            return new AppEngagementAdInfo(properties);
                        };

                        /**
                         * Encodes the specified AppEngagementAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.AppEngagementAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.AppEngagementAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IAppEngagementAdInfo} message AppEngagementAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppEngagementAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.headlines != null && message.headlines.length)
                                for (var i = 0; i < message.headlines.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdTextAsset.encode(message.headlines[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.descriptions != null && message.descriptions.length)
                                for (var i = 0; i < message.descriptions.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdTextAsset.encode(message.descriptions[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.images != null && message.images.length)
                                for (var i = 0; i < message.images.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdImageAsset.encode(message.images[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.videos != null && message.videos.length)
                                for (var i = 0; i < message.videos.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdVideoAsset.encode(message.videos[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AppEngagementAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.AppEngagementAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.AppEngagementAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IAppEngagementAdInfo} message AppEngagementAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppEngagementAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AppEngagementAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.AppEngagementAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.AppEngagementAdInfo} AppEngagementAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppEngagementAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.AppEngagementAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.headlines && message.headlines.length))
                                        message.headlines = [];
                                    message.headlines.push($root.google.ads.googleads.v1.common.AdTextAsset.decode(reader, reader.uint32()));
                                    break;
                                case 2:
                                    if (!(message.descriptions && message.descriptions.length))
                                        message.descriptions = [];
                                    message.descriptions.push($root.google.ads.googleads.v1.common.AdTextAsset.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    if (!(message.images && message.images.length))
                                        message.images = [];
                                    message.images.push($root.google.ads.googleads.v1.common.AdImageAsset.decode(reader, reader.uint32()));
                                    break;
                                case 4:
                                    if (!(message.videos && message.videos.length))
                                        message.videos = [];
                                    message.videos.push($root.google.ads.googleads.v1.common.AdVideoAsset.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AppEngagementAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.AppEngagementAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.AppEngagementAdInfo} AppEngagementAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppEngagementAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AppEngagementAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.AppEngagementAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AppEngagementAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.headlines != null && message.hasOwnProperty("headlines")) {
                                if (!Array.isArray(message.headlines))
                                    return "headlines: array expected";
                                for (var i = 0; i < message.headlines.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdTextAsset.verify(message.headlines[i]);
                                    if (error)
                                        return "headlines." + error;
                                }
                            }
                            if (message.descriptions != null && message.hasOwnProperty("descriptions")) {
                                if (!Array.isArray(message.descriptions))
                                    return "descriptions: array expected";
                                for (var i = 0; i < message.descriptions.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdTextAsset.verify(message.descriptions[i]);
                                    if (error)
                                        return "descriptions." + error;
                                }
                            }
                            if (message.images != null && message.hasOwnProperty("images")) {
                                if (!Array.isArray(message.images))
                                    return "images: array expected";
                                for (var i = 0; i < message.images.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdImageAsset.verify(message.images[i]);
                                    if (error)
                                        return "images." + error;
                                }
                            }
                            if (message.videos != null && message.hasOwnProperty("videos")) {
                                if (!Array.isArray(message.videos))
                                    return "videos: array expected";
                                for (var i = 0; i < message.videos.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdVideoAsset.verify(message.videos[i]);
                                    if (error)
                                        return "videos." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an AppEngagementAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.AppEngagementAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.AppEngagementAdInfo} AppEngagementAdInfo
                         */
                        AppEngagementAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.AppEngagementAdInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.AppEngagementAdInfo();
                            if (object.headlines) {
                                if (!Array.isArray(object.headlines))
                                    throw TypeError(".google.ads.googleads.v1.common.AppEngagementAdInfo.headlines: array expected");
                                message.headlines = [];
                                for (var i = 0; i < object.headlines.length; ++i) {
                                    if (typeof object.headlines[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.AppEngagementAdInfo.headlines: object expected");
                                    message.headlines[i] = $root.google.ads.googleads.v1.common.AdTextAsset.fromObject(object.headlines[i]);
                                }
                            }
                            if (object.descriptions) {
                                if (!Array.isArray(object.descriptions))
                                    throw TypeError(".google.ads.googleads.v1.common.AppEngagementAdInfo.descriptions: array expected");
                                message.descriptions = [];
                                for (var i = 0; i < object.descriptions.length; ++i) {
                                    if (typeof object.descriptions[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.AppEngagementAdInfo.descriptions: object expected");
                                    message.descriptions[i] = $root.google.ads.googleads.v1.common.AdTextAsset.fromObject(object.descriptions[i]);
                                }
                            }
                            if (object.images) {
                                if (!Array.isArray(object.images))
                                    throw TypeError(".google.ads.googleads.v1.common.AppEngagementAdInfo.images: array expected");
                                message.images = [];
                                for (var i = 0; i < object.images.length; ++i) {
                                    if (typeof object.images[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.AppEngagementAdInfo.images: object expected");
                                    message.images[i] = $root.google.ads.googleads.v1.common.AdImageAsset.fromObject(object.images[i]);
                                }
                            }
                            if (object.videos) {
                                if (!Array.isArray(object.videos))
                                    throw TypeError(".google.ads.googleads.v1.common.AppEngagementAdInfo.videos: array expected");
                                message.videos = [];
                                for (var i = 0; i < object.videos.length; ++i) {
                                    if (typeof object.videos[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.AppEngagementAdInfo.videos: object expected");
                                    message.videos[i] = $root.google.ads.googleads.v1.common.AdVideoAsset.fromObject(object.videos[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AppEngagementAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.AppEngagementAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.AppEngagementAdInfo} message AppEngagementAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AppEngagementAdInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.headlines = [];
                                object.descriptions = [];
                                object.images = [];
                                object.videos = [];
                            }
                            if (message.headlines && message.headlines.length) {
                                object.headlines = [];
                                for (var j = 0; j < message.headlines.length; ++j)
                                    object.headlines[j] = $root.google.ads.googleads.v1.common.AdTextAsset.toObject(message.headlines[j], options);
                            }
                            if (message.descriptions && message.descriptions.length) {
                                object.descriptions = [];
                                for (var j = 0; j < message.descriptions.length; ++j)
                                    object.descriptions[j] = $root.google.ads.googleads.v1.common.AdTextAsset.toObject(message.descriptions[j], options);
                            }
                            if (message.images && message.images.length) {
                                object.images = [];
                                for (var j = 0; j < message.images.length; ++j)
                                    object.images[j] = $root.google.ads.googleads.v1.common.AdImageAsset.toObject(message.images[j], options);
                            }
                            if (message.videos && message.videos.length) {
                                object.videos = [];
                                for (var j = 0; j < message.videos.length; ++j)
                                    object.videos[j] = $root.google.ads.googleads.v1.common.AdVideoAsset.toObject(message.videos[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this AppEngagementAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.AppEngagementAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AppEngagementAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AppEngagementAdInfo;
                    })();

                    common.LegacyAppInstallAdInfo = (function() {

                        /**
                         * Properties of a LegacyAppInstallAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ILegacyAppInstallAdInfo
                         * @property {google.protobuf.IStringValue|null} [appId] LegacyAppInstallAdInfo appId
                         * @property {google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum.LegacyAppInstallAdAppStore|null} [appStore] LegacyAppInstallAdInfo appStore
                         * @property {google.protobuf.IStringValue|null} [headline] LegacyAppInstallAdInfo headline
                         * @property {google.protobuf.IStringValue|null} [description1] LegacyAppInstallAdInfo description1
                         * @property {google.protobuf.IStringValue|null} [description2] LegacyAppInstallAdInfo description2
                         */

                        /**
                         * Constructs a new LegacyAppInstallAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a LegacyAppInstallAdInfo.
                         * @implements ILegacyAppInstallAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ILegacyAppInstallAdInfo=} [properties] Properties to set
                         */
                        function LegacyAppInstallAdInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * LegacyAppInstallAdInfo appId.
                         * @member {google.protobuf.IStringValue|null|undefined} appId
                         * @memberof google.ads.googleads.v1.common.LegacyAppInstallAdInfo
                         * @instance
                         */
                        LegacyAppInstallAdInfo.prototype.appId = null;

                        /**
                         * LegacyAppInstallAdInfo appStore.
                         * @member {google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum.LegacyAppInstallAdAppStore} appStore
                         * @memberof google.ads.googleads.v1.common.LegacyAppInstallAdInfo
                         * @instance
                         */
                        LegacyAppInstallAdInfo.prototype.appStore = 0;

                        /**
                         * LegacyAppInstallAdInfo headline.
                         * @member {google.protobuf.IStringValue|null|undefined} headline
                         * @memberof google.ads.googleads.v1.common.LegacyAppInstallAdInfo
                         * @instance
                         */
                        LegacyAppInstallAdInfo.prototype.headline = null;

                        /**
                         * LegacyAppInstallAdInfo description1.
                         * @member {google.protobuf.IStringValue|null|undefined} description1
                         * @memberof google.ads.googleads.v1.common.LegacyAppInstallAdInfo
                         * @instance
                         */
                        LegacyAppInstallAdInfo.prototype.description1 = null;

                        /**
                         * LegacyAppInstallAdInfo description2.
                         * @member {google.protobuf.IStringValue|null|undefined} description2
                         * @memberof google.ads.googleads.v1.common.LegacyAppInstallAdInfo
                         * @instance
                         */
                        LegacyAppInstallAdInfo.prototype.description2 = null;

                        /**
                         * Creates a new LegacyAppInstallAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.LegacyAppInstallAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILegacyAppInstallAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.LegacyAppInstallAdInfo} LegacyAppInstallAdInfo instance
                         */
                        LegacyAppInstallAdInfo.create = function create(properties) {
                            return new LegacyAppInstallAdInfo(properties);
                        };

                        /**
                         * Encodes the specified LegacyAppInstallAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.LegacyAppInstallAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.LegacyAppInstallAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILegacyAppInstallAdInfo} message LegacyAppInstallAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LegacyAppInstallAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.appId != null && message.hasOwnProperty("appId"))
                                $root.google.protobuf.StringValue.encode(message.appId, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.appStore != null && message.hasOwnProperty("appStore"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.appStore);
                            if (message.headline != null && message.hasOwnProperty("headline"))
                                $root.google.protobuf.StringValue.encode(message.headline, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.description1 != null && message.hasOwnProperty("description1"))
                                $root.google.protobuf.StringValue.encode(message.description1, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.description2 != null && message.hasOwnProperty("description2"))
                                $root.google.protobuf.StringValue.encode(message.description2, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified LegacyAppInstallAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.LegacyAppInstallAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.LegacyAppInstallAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILegacyAppInstallAdInfo} message LegacyAppInstallAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LegacyAppInstallAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LegacyAppInstallAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.LegacyAppInstallAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.LegacyAppInstallAdInfo} LegacyAppInstallAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LegacyAppInstallAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.LegacyAppInstallAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.appId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.appStore = reader.int32();
                                    break;
                                case 3:
                                    message.headline = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.description1 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.description2 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LegacyAppInstallAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.LegacyAppInstallAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.LegacyAppInstallAdInfo} LegacyAppInstallAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LegacyAppInstallAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LegacyAppInstallAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.LegacyAppInstallAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LegacyAppInstallAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.appId != null && message.hasOwnProperty("appId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.appId);
                                if (error)
                                    return "appId." + error;
                            }
                            if (message.appStore != null && message.hasOwnProperty("appStore"))
                                switch (message.appStore) {
                                default:
                                    return "appStore: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            if (message.headline != null && message.hasOwnProperty("headline")) {
                                var error = $root.google.protobuf.StringValue.verify(message.headline);
                                if (error)
                                    return "headline." + error;
                            }
                            if (message.description1 != null && message.hasOwnProperty("description1")) {
                                var error = $root.google.protobuf.StringValue.verify(message.description1);
                                if (error)
                                    return "description1." + error;
                            }
                            if (message.description2 != null && message.hasOwnProperty("description2")) {
                                var error = $root.google.protobuf.StringValue.verify(message.description2);
                                if (error)
                                    return "description2." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a LegacyAppInstallAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.LegacyAppInstallAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.LegacyAppInstallAdInfo} LegacyAppInstallAdInfo
                         */
                        LegacyAppInstallAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.LegacyAppInstallAdInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.LegacyAppInstallAdInfo();
                            if (object.appId != null) {
                                if (typeof object.appId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LegacyAppInstallAdInfo.appId: object expected");
                                message.appId = $root.google.protobuf.StringValue.fromObject(object.appId);
                            }
                            switch (object.appStore) {
                            case "UNSPECIFIED":
                            case 0:
                                message.appStore = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.appStore = 1;
                                break;
                            case "APPLE_APP_STORE":
                            case 2:
                                message.appStore = 2;
                                break;
                            case "GOOGLE_PLAY":
                            case 3:
                                message.appStore = 3;
                                break;
                            case "WINDOWS_STORE":
                            case 4:
                                message.appStore = 4;
                                break;
                            case "WINDOWS_PHONE_STORE":
                            case 5:
                                message.appStore = 5;
                                break;
                            case "CN_APP_STORE":
                            case 6:
                                message.appStore = 6;
                                break;
                            }
                            if (object.headline != null) {
                                if (typeof object.headline !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LegacyAppInstallAdInfo.headline: object expected");
                                message.headline = $root.google.protobuf.StringValue.fromObject(object.headline);
                            }
                            if (object.description1 != null) {
                                if (typeof object.description1 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LegacyAppInstallAdInfo.description1: object expected");
                                message.description1 = $root.google.protobuf.StringValue.fromObject(object.description1);
                            }
                            if (object.description2 != null) {
                                if (typeof object.description2 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LegacyAppInstallAdInfo.description2: object expected");
                                message.description2 = $root.google.protobuf.StringValue.fromObject(object.description2);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a LegacyAppInstallAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.LegacyAppInstallAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.LegacyAppInstallAdInfo} message LegacyAppInstallAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LegacyAppInstallAdInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.appId = null;
                                object.appStore = options.enums === String ? "UNSPECIFIED" : 0;
                                object.headline = null;
                                object.description1 = null;
                                object.description2 = null;
                            }
                            if (message.appId != null && message.hasOwnProperty("appId"))
                                object.appId = $root.google.protobuf.StringValue.toObject(message.appId, options);
                            if (message.appStore != null && message.hasOwnProperty("appStore"))
                                object.appStore = options.enums === String ? $root.google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum.LegacyAppInstallAdAppStore[message.appStore] : message.appStore;
                            if (message.headline != null && message.hasOwnProperty("headline"))
                                object.headline = $root.google.protobuf.StringValue.toObject(message.headline, options);
                            if (message.description1 != null && message.hasOwnProperty("description1"))
                                object.description1 = $root.google.protobuf.StringValue.toObject(message.description1, options);
                            if (message.description2 != null && message.hasOwnProperty("description2"))
                                object.description2 = $root.google.protobuf.StringValue.toObject(message.description2, options);
                            return object;
                        };

                        /**
                         * Converts this LegacyAppInstallAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.LegacyAppInstallAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LegacyAppInstallAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return LegacyAppInstallAdInfo;
                    })();

                    common.ResponsiveDisplayAdInfo = (function() {

                        /**
                         * Properties of a ResponsiveDisplayAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IResponsiveDisplayAdInfo
                         * @property {Array.<google.ads.googleads.v1.common.IAdImageAsset>|null} [marketingImages] ResponsiveDisplayAdInfo marketingImages
                         * @property {Array.<google.ads.googleads.v1.common.IAdImageAsset>|null} [squareMarketingImages] ResponsiveDisplayAdInfo squareMarketingImages
                         * @property {Array.<google.ads.googleads.v1.common.IAdImageAsset>|null} [logoImages] ResponsiveDisplayAdInfo logoImages
                         * @property {Array.<google.ads.googleads.v1.common.IAdImageAsset>|null} [squareLogoImages] ResponsiveDisplayAdInfo squareLogoImages
                         * @property {Array.<google.ads.googleads.v1.common.IAdTextAsset>|null} [headlines] ResponsiveDisplayAdInfo headlines
                         * @property {google.ads.googleads.v1.common.IAdTextAsset|null} [longHeadline] ResponsiveDisplayAdInfo longHeadline
                         * @property {Array.<google.ads.googleads.v1.common.IAdTextAsset>|null} [descriptions] ResponsiveDisplayAdInfo descriptions
                         * @property {Array.<google.ads.googleads.v1.common.IAdVideoAsset>|null} [youtubeVideos] ResponsiveDisplayAdInfo youtubeVideos
                         * @property {google.protobuf.IStringValue|null} [businessName] ResponsiveDisplayAdInfo businessName
                         * @property {google.protobuf.IStringValue|null} [mainColor] ResponsiveDisplayAdInfo mainColor
                         * @property {google.protobuf.IStringValue|null} [accentColor] ResponsiveDisplayAdInfo accentColor
                         * @property {google.protobuf.IBoolValue|null} [allowFlexibleColor] ResponsiveDisplayAdInfo allowFlexibleColor
                         * @property {google.protobuf.IStringValue|null} [callToActionText] ResponsiveDisplayAdInfo callToActionText
                         * @property {google.protobuf.IStringValue|null} [pricePrefix] ResponsiveDisplayAdInfo pricePrefix
                         * @property {google.protobuf.IStringValue|null} [promoText] ResponsiveDisplayAdInfo promoText
                         * @property {google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum.DisplayAdFormatSetting|null} [formatSetting] ResponsiveDisplayAdInfo formatSetting
                         */

                        /**
                         * Constructs a new ResponsiveDisplayAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ResponsiveDisplayAdInfo.
                         * @implements IResponsiveDisplayAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IResponsiveDisplayAdInfo=} [properties] Properties to set
                         */
                        function ResponsiveDisplayAdInfo(properties) {
                            this.marketingImages = [];
                            this.squareMarketingImages = [];
                            this.logoImages = [];
                            this.squareLogoImages = [];
                            this.headlines = [];
                            this.descriptions = [];
                            this.youtubeVideos = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ResponsiveDisplayAdInfo marketingImages.
                         * @member {Array.<google.ads.googleads.v1.common.IAdImageAsset>} marketingImages
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @instance
                         */
                        ResponsiveDisplayAdInfo.prototype.marketingImages = $util.emptyArray;

                        /**
                         * ResponsiveDisplayAdInfo squareMarketingImages.
                         * @member {Array.<google.ads.googleads.v1.common.IAdImageAsset>} squareMarketingImages
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @instance
                         */
                        ResponsiveDisplayAdInfo.prototype.squareMarketingImages = $util.emptyArray;

                        /**
                         * ResponsiveDisplayAdInfo logoImages.
                         * @member {Array.<google.ads.googleads.v1.common.IAdImageAsset>} logoImages
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @instance
                         */
                        ResponsiveDisplayAdInfo.prototype.logoImages = $util.emptyArray;

                        /**
                         * ResponsiveDisplayAdInfo squareLogoImages.
                         * @member {Array.<google.ads.googleads.v1.common.IAdImageAsset>} squareLogoImages
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @instance
                         */
                        ResponsiveDisplayAdInfo.prototype.squareLogoImages = $util.emptyArray;

                        /**
                         * ResponsiveDisplayAdInfo headlines.
                         * @member {Array.<google.ads.googleads.v1.common.IAdTextAsset>} headlines
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @instance
                         */
                        ResponsiveDisplayAdInfo.prototype.headlines = $util.emptyArray;

                        /**
                         * ResponsiveDisplayAdInfo longHeadline.
                         * @member {google.ads.googleads.v1.common.IAdTextAsset|null|undefined} longHeadline
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @instance
                         */
                        ResponsiveDisplayAdInfo.prototype.longHeadline = null;

                        /**
                         * ResponsiveDisplayAdInfo descriptions.
                         * @member {Array.<google.ads.googleads.v1.common.IAdTextAsset>} descriptions
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @instance
                         */
                        ResponsiveDisplayAdInfo.prototype.descriptions = $util.emptyArray;

                        /**
                         * ResponsiveDisplayAdInfo youtubeVideos.
                         * @member {Array.<google.ads.googleads.v1.common.IAdVideoAsset>} youtubeVideos
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @instance
                         */
                        ResponsiveDisplayAdInfo.prototype.youtubeVideos = $util.emptyArray;

                        /**
                         * ResponsiveDisplayAdInfo businessName.
                         * @member {google.protobuf.IStringValue|null|undefined} businessName
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @instance
                         */
                        ResponsiveDisplayAdInfo.prototype.businessName = null;

                        /**
                         * ResponsiveDisplayAdInfo mainColor.
                         * @member {google.protobuf.IStringValue|null|undefined} mainColor
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @instance
                         */
                        ResponsiveDisplayAdInfo.prototype.mainColor = null;

                        /**
                         * ResponsiveDisplayAdInfo accentColor.
                         * @member {google.protobuf.IStringValue|null|undefined} accentColor
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @instance
                         */
                        ResponsiveDisplayAdInfo.prototype.accentColor = null;

                        /**
                         * ResponsiveDisplayAdInfo allowFlexibleColor.
                         * @member {google.protobuf.IBoolValue|null|undefined} allowFlexibleColor
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @instance
                         */
                        ResponsiveDisplayAdInfo.prototype.allowFlexibleColor = null;

                        /**
                         * ResponsiveDisplayAdInfo callToActionText.
                         * @member {google.protobuf.IStringValue|null|undefined} callToActionText
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @instance
                         */
                        ResponsiveDisplayAdInfo.prototype.callToActionText = null;

                        /**
                         * ResponsiveDisplayAdInfo pricePrefix.
                         * @member {google.protobuf.IStringValue|null|undefined} pricePrefix
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @instance
                         */
                        ResponsiveDisplayAdInfo.prototype.pricePrefix = null;

                        /**
                         * ResponsiveDisplayAdInfo promoText.
                         * @member {google.protobuf.IStringValue|null|undefined} promoText
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @instance
                         */
                        ResponsiveDisplayAdInfo.prototype.promoText = null;

                        /**
                         * ResponsiveDisplayAdInfo formatSetting.
                         * @member {google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum.DisplayAdFormatSetting} formatSetting
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @instance
                         */
                        ResponsiveDisplayAdInfo.prototype.formatSetting = 0;

                        /**
                         * Creates a new ResponsiveDisplayAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IResponsiveDisplayAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ResponsiveDisplayAdInfo} ResponsiveDisplayAdInfo instance
                         */
                        ResponsiveDisplayAdInfo.create = function create(properties) {
                            return new ResponsiveDisplayAdInfo(properties);
                        };

                        /**
                         * Encodes the specified ResponsiveDisplayAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IResponsiveDisplayAdInfo} message ResponsiveDisplayAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResponsiveDisplayAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.marketingImages != null && message.marketingImages.length)
                                for (var i = 0; i < message.marketingImages.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdImageAsset.encode(message.marketingImages[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.squareMarketingImages != null && message.squareMarketingImages.length)
                                for (var i = 0; i < message.squareMarketingImages.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdImageAsset.encode(message.squareMarketingImages[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.logoImages != null && message.logoImages.length)
                                for (var i = 0; i < message.logoImages.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdImageAsset.encode(message.logoImages[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.squareLogoImages != null && message.squareLogoImages.length)
                                for (var i = 0; i < message.squareLogoImages.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdImageAsset.encode(message.squareLogoImages[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.headlines != null && message.headlines.length)
                                for (var i = 0; i < message.headlines.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdTextAsset.encode(message.headlines[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.longHeadline != null && message.hasOwnProperty("longHeadline"))
                                $root.google.ads.googleads.v1.common.AdTextAsset.encode(message.longHeadline, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.descriptions != null && message.descriptions.length)
                                for (var i = 0; i < message.descriptions.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdTextAsset.encode(message.descriptions[i], writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.youtubeVideos != null && message.youtubeVideos.length)
                                for (var i = 0; i < message.youtubeVideos.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdVideoAsset.encode(message.youtubeVideos[i], writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.businessName != null && message.hasOwnProperty("businessName"))
                                $root.google.protobuf.StringValue.encode(message.businessName, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.mainColor != null && message.hasOwnProperty("mainColor"))
                                $root.google.protobuf.StringValue.encode(message.mainColor, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.accentColor != null && message.hasOwnProperty("accentColor"))
                                $root.google.protobuf.StringValue.encode(message.accentColor, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.allowFlexibleColor != null && message.hasOwnProperty("allowFlexibleColor"))
                                $root.google.protobuf.BoolValue.encode(message.allowFlexibleColor, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.callToActionText != null && message.hasOwnProperty("callToActionText"))
                                $root.google.protobuf.StringValue.encode(message.callToActionText, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                            if (message.pricePrefix != null && message.hasOwnProperty("pricePrefix"))
                                $root.google.protobuf.StringValue.encode(message.pricePrefix, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.promoText != null && message.hasOwnProperty("promoText"))
                                $root.google.protobuf.StringValue.encode(message.promoText, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
                            if (message.formatSetting != null && message.hasOwnProperty("formatSetting"))
                                writer.uint32(/* id 16, wireType 0 =*/128).int32(message.formatSetting);
                            return writer;
                        };

                        /**
                         * Encodes the specified ResponsiveDisplayAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IResponsiveDisplayAdInfo} message ResponsiveDisplayAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResponsiveDisplayAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ResponsiveDisplayAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ResponsiveDisplayAdInfo} ResponsiveDisplayAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResponsiveDisplayAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ResponsiveDisplayAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.marketingImages && message.marketingImages.length))
                                        message.marketingImages = [];
                                    message.marketingImages.push($root.google.ads.googleads.v1.common.AdImageAsset.decode(reader, reader.uint32()));
                                    break;
                                case 2:
                                    if (!(message.squareMarketingImages && message.squareMarketingImages.length))
                                        message.squareMarketingImages = [];
                                    message.squareMarketingImages.push($root.google.ads.googleads.v1.common.AdImageAsset.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    if (!(message.logoImages && message.logoImages.length))
                                        message.logoImages = [];
                                    message.logoImages.push($root.google.ads.googleads.v1.common.AdImageAsset.decode(reader, reader.uint32()));
                                    break;
                                case 4:
                                    if (!(message.squareLogoImages && message.squareLogoImages.length))
                                        message.squareLogoImages = [];
                                    message.squareLogoImages.push($root.google.ads.googleads.v1.common.AdImageAsset.decode(reader, reader.uint32()));
                                    break;
                                case 5:
                                    if (!(message.headlines && message.headlines.length))
                                        message.headlines = [];
                                    message.headlines.push($root.google.ads.googleads.v1.common.AdTextAsset.decode(reader, reader.uint32()));
                                    break;
                                case 6:
                                    message.longHeadline = $root.google.ads.googleads.v1.common.AdTextAsset.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    if (!(message.descriptions && message.descriptions.length))
                                        message.descriptions = [];
                                    message.descriptions.push($root.google.ads.googleads.v1.common.AdTextAsset.decode(reader, reader.uint32()));
                                    break;
                                case 8:
                                    if (!(message.youtubeVideos && message.youtubeVideos.length))
                                        message.youtubeVideos = [];
                                    message.youtubeVideos.push($root.google.ads.googleads.v1.common.AdVideoAsset.decode(reader, reader.uint32()));
                                    break;
                                case 9:
                                    message.businessName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.mainColor = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.accentColor = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.allowFlexibleColor = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 13:
                                    message.callToActionText = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 14:
                                    message.pricePrefix = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 15:
                                    message.promoText = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 16:
                                    message.formatSetting = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ResponsiveDisplayAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ResponsiveDisplayAdInfo} ResponsiveDisplayAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResponsiveDisplayAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ResponsiveDisplayAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResponsiveDisplayAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.marketingImages != null && message.hasOwnProperty("marketingImages")) {
                                if (!Array.isArray(message.marketingImages))
                                    return "marketingImages: array expected";
                                for (var i = 0; i < message.marketingImages.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdImageAsset.verify(message.marketingImages[i]);
                                    if (error)
                                        return "marketingImages." + error;
                                }
                            }
                            if (message.squareMarketingImages != null && message.hasOwnProperty("squareMarketingImages")) {
                                if (!Array.isArray(message.squareMarketingImages))
                                    return "squareMarketingImages: array expected";
                                for (var i = 0; i < message.squareMarketingImages.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdImageAsset.verify(message.squareMarketingImages[i]);
                                    if (error)
                                        return "squareMarketingImages." + error;
                                }
                            }
                            if (message.logoImages != null && message.hasOwnProperty("logoImages")) {
                                if (!Array.isArray(message.logoImages))
                                    return "logoImages: array expected";
                                for (var i = 0; i < message.logoImages.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdImageAsset.verify(message.logoImages[i]);
                                    if (error)
                                        return "logoImages." + error;
                                }
                            }
                            if (message.squareLogoImages != null && message.hasOwnProperty("squareLogoImages")) {
                                if (!Array.isArray(message.squareLogoImages))
                                    return "squareLogoImages: array expected";
                                for (var i = 0; i < message.squareLogoImages.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdImageAsset.verify(message.squareLogoImages[i]);
                                    if (error)
                                        return "squareLogoImages." + error;
                                }
                            }
                            if (message.headlines != null && message.hasOwnProperty("headlines")) {
                                if (!Array.isArray(message.headlines))
                                    return "headlines: array expected";
                                for (var i = 0; i < message.headlines.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdTextAsset.verify(message.headlines[i]);
                                    if (error)
                                        return "headlines." + error;
                                }
                            }
                            if (message.longHeadline != null && message.hasOwnProperty("longHeadline")) {
                                var error = $root.google.ads.googleads.v1.common.AdTextAsset.verify(message.longHeadline);
                                if (error)
                                    return "longHeadline." + error;
                            }
                            if (message.descriptions != null && message.hasOwnProperty("descriptions")) {
                                if (!Array.isArray(message.descriptions))
                                    return "descriptions: array expected";
                                for (var i = 0; i < message.descriptions.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdTextAsset.verify(message.descriptions[i]);
                                    if (error)
                                        return "descriptions." + error;
                                }
                            }
                            if (message.youtubeVideos != null && message.hasOwnProperty("youtubeVideos")) {
                                if (!Array.isArray(message.youtubeVideos))
                                    return "youtubeVideos: array expected";
                                for (var i = 0; i < message.youtubeVideos.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdVideoAsset.verify(message.youtubeVideos[i]);
                                    if (error)
                                        return "youtubeVideos." + error;
                                }
                            }
                            if (message.businessName != null && message.hasOwnProperty("businessName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.businessName);
                                if (error)
                                    return "businessName." + error;
                            }
                            if (message.mainColor != null && message.hasOwnProperty("mainColor")) {
                                var error = $root.google.protobuf.StringValue.verify(message.mainColor);
                                if (error)
                                    return "mainColor." + error;
                            }
                            if (message.accentColor != null && message.hasOwnProperty("accentColor")) {
                                var error = $root.google.protobuf.StringValue.verify(message.accentColor);
                                if (error)
                                    return "accentColor." + error;
                            }
                            if (message.allowFlexibleColor != null && message.hasOwnProperty("allowFlexibleColor")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.allowFlexibleColor);
                                if (error)
                                    return "allowFlexibleColor." + error;
                            }
                            if (message.callToActionText != null && message.hasOwnProperty("callToActionText")) {
                                var error = $root.google.protobuf.StringValue.verify(message.callToActionText);
                                if (error)
                                    return "callToActionText." + error;
                            }
                            if (message.pricePrefix != null && message.hasOwnProperty("pricePrefix")) {
                                var error = $root.google.protobuf.StringValue.verify(message.pricePrefix);
                                if (error)
                                    return "pricePrefix." + error;
                            }
                            if (message.promoText != null && message.hasOwnProperty("promoText")) {
                                var error = $root.google.protobuf.StringValue.verify(message.promoText);
                                if (error)
                                    return "promoText." + error;
                            }
                            if (message.formatSetting != null && message.hasOwnProperty("formatSetting"))
                                switch (message.formatSetting) {
                                default:
                                    return "formatSetting: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a ResponsiveDisplayAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ResponsiveDisplayAdInfo} ResponsiveDisplayAdInfo
                         */
                        ResponsiveDisplayAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ResponsiveDisplayAdInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ResponsiveDisplayAdInfo();
                            if (object.marketingImages) {
                                if (!Array.isArray(object.marketingImages))
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.marketingImages: array expected");
                                message.marketingImages = [];
                                for (var i = 0; i < object.marketingImages.length; ++i) {
                                    if (typeof object.marketingImages[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.marketingImages: object expected");
                                    message.marketingImages[i] = $root.google.ads.googleads.v1.common.AdImageAsset.fromObject(object.marketingImages[i]);
                                }
                            }
                            if (object.squareMarketingImages) {
                                if (!Array.isArray(object.squareMarketingImages))
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.squareMarketingImages: array expected");
                                message.squareMarketingImages = [];
                                for (var i = 0; i < object.squareMarketingImages.length; ++i) {
                                    if (typeof object.squareMarketingImages[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.squareMarketingImages: object expected");
                                    message.squareMarketingImages[i] = $root.google.ads.googleads.v1.common.AdImageAsset.fromObject(object.squareMarketingImages[i]);
                                }
                            }
                            if (object.logoImages) {
                                if (!Array.isArray(object.logoImages))
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.logoImages: array expected");
                                message.logoImages = [];
                                for (var i = 0; i < object.logoImages.length; ++i) {
                                    if (typeof object.logoImages[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.logoImages: object expected");
                                    message.logoImages[i] = $root.google.ads.googleads.v1.common.AdImageAsset.fromObject(object.logoImages[i]);
                                }
                            }
                            if (object.squareLogoImages) {
                                if (!Array.isArray(object.squareLogoImages))
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.squareLogoImages: array expected");
                                message.squareLogoImages = [];
                                for (var i = 0; i < object.squareLogoImages.length; ++i) {
                                    if (typeof object.squareLogoImages[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.squareLogoImages: object expected");
                                    message.squareLogoImages[i] = $root.google.ads.googleads.v1.common.AdImageAsset.fromObject(object.squareLogoImages[i]);
                                }
                            }
                            if (object.headlines) {
                                if (!Array.isArray(object.headlines))
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.headlines: array expected");
                                message.headlines = [];
                                for (var i = 0; i < object.headlines.length; ++i) {
                                    if (typeof object.headlines[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.headlines: object expected");
                                    message.headlines[i] = $root.google.ads.googleads.v1.common.AdTextAsset.fromObject(object.headlines[i]);
                                }
                            }
                            if (object.longHeadline != null) {
                                if (typeof object.longHeadline !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.longHeadline: object expected");
                                message.longHeadline = $root.google.ads.googleads.v1.common.AdTextAsset.fromObject(object.longHeadline);
                            }
                            if (object.descriptions) {
                                if (!Array.isArray(object.descriptions))
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.descriptions: array expected");
                                message.descriptions = [];
                                for (var i = 0; i < object.descriptions.length; ++i) {
                                    if (typeof object.descriptions[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.descriptions: object expected");
                                    message.descriptions[i] = $root.google.ads.googleads.v1.common.AdTextAsset.fromObject(object.descriptions[i]);
                                }
                            }
                            if (object.youtubeVideos) {
                                if (!Array.isArray(object.youtubeVideos))
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.youtubeVideos: array expected");
                                message.youtubeVideos = [];
                                for (var i = 0; i < object.youtubeVideos.length; ++i) {
                                    if (typeof object.youtubeVideos[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.youtubeVideos: object expected");
                                    message.youtubeVideos[i] = $root.google.ads.googleads.v1.common.AdVideoAsset.fromObject(object.youtubeVideos[i]);
                                }
                            }
                            if (object.businessName != null) {
                                if (typeof object.businessName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.businessName: object expected");
                                message.businessName = $root.google.protobuf.StringValue.fromObject(object.businessName);
                            }
                            if (object.mainColor != null) {
                                if (typeof object.mainColor !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.mainColor: object expected");
                                message.mainColor = $root.google.protobuf.StringValue.fromObject(object.mainColor);
                            }
                            if (object.accentColor != null) {
                                if (typeof object.accentColor !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.accentColor: object expected");
                                message.accentColor = $root.google.protobuf.StringValue.fromObject(object.accentColor);
                            }
                            if (object.allowFlexibleColor != null) {
                                if (typeof object.allowFlexibleColor !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.allowFlexibleColor: object expected");
                                message.allowFlexibleColor = $root.google.protobuf.BoolValue.fromObject(object.allowFlexibleColor);
                            }
                            if (object.callToActionText != null) {
                                if (typeof object.callToActionText !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.callToActionText: object expected");
                                message.callToActionText = $root.google.protobuf.StringValue.fromObject(object.callToActionText);
                            }
                            if (object.pricePrefix != null) {
                                if (typeof object.pricePrefix !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.pricePrefix: object expected");
                                message.pricePrefix = $root.google.protobuf.StringValue.fromObject(object.pricePrefix);
                            }
                            if (object.promoText != null) {
                                if (typeof object.promoText !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.promoText: object expected");
                                message.promoText = $root.google.protobuf.StringValue.fromObject(object.promoText);
                            }
                            switch (object.formatSetting) {
                            case "UNSPECIFIED":
                            case 0:
                                message.formatSetting = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.formatSetting = 1;
                                break;
                            case "ALL_FORMATS":
                            case 2:
                                message.formatSetting = 2;
                                break;
                            case "NON_NATIVE":
                            case 3:
                                message.formatSetting = 3;
                                break;
                            case "NATIVE":
                            case 4:
                                message.formatSetting = 4;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ResponsiveDisplayAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ResponsiveDisplayAdInfo} message ResponsiveDisplayAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResponsiveDisplayAdInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.marketingImages = [];
                                object.squareMarketingImages = [];
                                object.logoImages = [];
                                object.squareLogoImages = [];
                                object.headlines = [];
                                object.descriptions = [];
                                object.youtubeVideos = [];
                            }
                            if (options.defaults) {
                                object.longHeadline = null;
                                object.businessName = null;
                                object.mainColor = null;
                                object.accentColor = null;
                                object.allowFlexibleColor = null;
                                object.callToActionText = null;
                                object.pricePrefix = null;
                                object.promoText = null;
                                object.formatSetting = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.marketingImages && message.marketingImages.length) {
                                object.marketingImages = [];
                                for (var j = 0; j < message.marketingImages.length; ++j)
                                    object.marketingImages[j] = $root.google.ads.googleads.v1.common.AdImageAsset.toObject(message.marketingImages[j], options);
                            }
                            if (message.squareMarketingImages && message.squareMarketingImages.length) {
                                object.squareMarketingImages = [];
                                for (var j = 0; j < message.squareMarketingImages.length; ++j)
                                    object.squareMarketingImages[j] = $root.google.ads.googleads.v1.common.AdImageAsset.toObject(message.squareMarketingImages[j], options);
                            }
                            if (message.logoImages && message.logoImages.length) {
                                object.logoImages = [];
                                for (var j = 0; j < message.logoImages.length; ++j)
                                    object.logoImages[j] = $root.google.ads.googleads.v1.common.AdImageAsset.toObject(message.logoImages[j], options);
                            }
                            if (message.squareLogoImages && message.squareLogoImages.length) {
                                object.squareLogoImages = [];
                                for (var j = 0; j < message.squareLogoImages.length; ++j)
                                    object.squareLogoImages[j] = $root.google.ads.googleads.v1.common.AdImageAsset.toObject(message.squareLogoImages[j], options);
                            }
                            if (message.headlines && message.headlines.length) {
                                object.headlines = [];
                                for (var j = 0; j < message.headlines.length; ++j)
                                    object.headlines[j] = $root.google.ads.googleads.v1.common.AdTextAsset.toObject(message.headlines[j], options);
                            }
                            if (message.longHeadline != null && message.hasOwnProperty("longHeadline"))
                                object.longHeadline = $root.google.ads.googleads.v1.common.AdTextAsset.toObject(message.longHeadline, options);
                            if (message.descriptions && message.descriptions.length) {
                                object.descriptions = [];
                                for (var j = 0; j < message.descriptions.length; ++j)
                                    object.descriptions[j] = $root.google.ads.googleads.v1.common.AdTextAsset.toObject(message.descriptions[j], options);
                            }
                            if (message.youtubeVideos && message.youtubeVideos.length) {
                                object.youtubeVideos = [];
                                for (var j = 0; j < message.youtubeVideos.length; ++j)
                                    object.youtubeVideos[j] = $root.google.ads.googleads.v1.common.AdVideoAsset.toObject(message.youtubeVideos[j], options);
                            }
                            if (message.businessName != null && message.hasOwnProperty("businessName"))
                                object.businessName = $root.google.protobuf.StringValue.toObject(message.businessName, options);
                            if (message.mainColor != null && message.hasOwnProperty("mainColor"))
                                object.mainColor = $root.google.protobuf.StringValue.toObject(message.mainColor, options);
                            if (message.accentColor != null && message.hasOwnProperty("accentColor"))
                                object.accentColor = $root.google.protobuf.StringValue.toObject(message.accentColor, options);
                            if (message.allowFlexibleColor != null && message.hasOwnProperty("allowFlexibleColor"))
                                object.allowFlexibleColor = $root.google.protobuf.BoolValue.toObject(message.allowFlexibleColor, options);
                            if (message.callToActionText != null && message.hasOwnProperty("callToActionText"))
                                object.callToActionText = $root.google.protobuf.StringValue.toObject(message.callToActionText, options);
                            if (message.pricePrefix != null && message.hasOwnProperty("pricePrefix"))
                                object.pricePrefix = $root.google.protobuf.StringValue.toObject(message.pricePrefix, options);
                            if (message.promoText != null && message.hasOwnProperty("promoText"))
                                object.promoText = $root.google.protobuf.StringValue.toObject(message.promoText, options);
                            if (message.formatSetting != null && message.hasOwnProperty("formatSetting"))
                                object.formatSetting = options.enums === String ? $root.google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum.DisplayAdFormatSetting[message.formatSetting] : message.formatSetting;
                            return object;
                        };

                        /**
                         * Converts this ResponsiveDisplayAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ResponsiveDisplayAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResponsiveDisplayAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ResponsiveDisplayAdInfo;
                    })();

                    common.DisplayUploadAdInfo = (function() {

                        /**
                         * Properties of a DisplayUploadAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IDisplayUploadAdInfo
                         * @property {google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum.DisplayUploadProductType|null} [displayUploadProductType] DisplayUploadAdInfo displayUploadProductType
                         * @property {google.ads.googleads.v1.common.IAdMediaBundleAsset|null} [mediaBundle] DisplayUploadAdInfo mediaBundle
                         */

                        /**
                         * Constructs a new DisplayUploadAdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a DisplayUploadAdInfo.
                         * @implements IDisplayUploadAdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IDisplayUploadAdInfo=} [properties] Properties to set
                         */
                        function DisplayUploadAdInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * DisplayUploadAdInfo displayUploadProductType.
                         * @member {google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum.DisplayUploadProductType} displayUploadProductType
                         * @memberof google.ads.googleads.v1.common.DisplayUploadAdInfo
                         * @instance
                         */
                        DisplayUploadAdInfo.prototype.displayUploadProductType = 0;

                        /**
                         * DisplayUploadAdInfo mediaBundle.
                         * @member {google.ads.googleads.v1.common.IAdMediaBundleAsset|null|undefined} mediaBundle
                         * @memberof google.ads.googleads.v1.common.DisplayUploadAdInfo
                         * @instance
                         */
                        DisplayUploadAdInfo.prototype.mediaBundle = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * DisplayUploadAdInfo mediaAsset.
                         * @member {"mediaBundle"|undefined} mediaAsset
                         * @memberof google.ads.googleads.v1.common.DisplayUploadAdInfo
                         * @instance
                         */
                        Object.defineProperty(DisplayUploadAdInfo.prototype, "mediaAsset", {
                            get: $util.oneOfGetter($oneOfFields = ["mediaBundle"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new DisplayUploadAdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.DisplayUploadAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IDisplayUploadAdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.DisplayUploadAdInfo} DisplayUploadAdInfo instance
                         */
                        DisplayUploadAdInfo.create = function create(properties) {
                            return new DisplayUploadAdInfo(properties);
                        };

                        /**
                         * Encodes the specified DisplayUploadAdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.DisplayUploadAdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.DisplayUploadAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IDisplayUploadAdInfo} message DisplayUploadAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisplayUploadAdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.displayUploadProductType != null && message.hasOwnProperty("displayUploadProductType"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.displayUploadProductType);
                            if (message.mediaBundle != null && message.hasOwnProperty("mediaBundle"))
                                $root.google.ads.googleads.v1.common.AdMediaBundleAsset.encode(message.mediaBundle, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified DisplayUploadAdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.DisplayUploadAdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.DisplayUploadAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IDisplayUploadAdInfo} message DisplayUploadAdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisplayUploadAdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DisplayUploadAdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.DisplayUploadAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.DisplayUploadAdInfo} DisplayUploadAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisplayUploadAdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.DisplayUploadAdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.displayUploadProductType = reader.int32();
                                    break;
                                case 2:
                                    message.mediaBundle = $root.google.ads.googleads.v1.common.AdMediaBundleAsset.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DisplayUploadAdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.DisplayUploadAdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.DisplayUploadAdInfo} DisplayUploadAdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisplayUploadAdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DisplayUploadAdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.DisplayUploadAdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DisplayUploadAdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.displayUploadProductType != null && message.hasOwnProperty("displayUploadProductType"))
                                switch (message.displayUploadProductType) {
                                default:
                                    return "displayUploadProductType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                    break;
                                }
                            if (message.mediaBundle != null && message.hasOwnProperty("mediaBundle")) {
                                properties.mediaAsset = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.AdMediaBundleAsset.verify(message.mediaBundle);
                                    if (error)
                                        return "mediaBundle." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a DisplayUploadAdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.DisplayUploadAdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.DisplayUploadAdInfo} DisplayUploadAdInfo
                         */
                        DisplayUploadAdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.DisplayUploadAdInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.DisplayUploadAdInfo();
                            switch (object.displayUploadProductType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.displayUploadProductType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.displayUploadProductType = 1;
                                break;
                            case "HTML5_UPLOAD_AD":
                            case 2:
                                message.displayUploadProductType = 2;
                                break;
                            case "DYNAMIC_HTML5_EDUCATION_AD":
                            case 3:
                                message.displayUploadProductType = 3;
                                break;
                            case "DYNAMIC_HTML5_FLIGHT_AD":
                            case 4:
                                message.displayUploadProductType = 4;
                                break;
                            case "DYNAMIC_HTML5_HOTEL_RENTAL_AD":
                            case 5:
                                message.displayUploadProductType = 5;
                                break;
                            case "DYNAMIC_HTML5_JOB_AD":
                            case 6:
                                message.displayUploadProductType = 6;
                                break;
                            case "DYNAMIC_HTML5_LOCAL_AD":
                            case 7:
                                message.displayUploadProductType = 7;
                                break;
                            case "DYNAMIC_HTML5_REAL_ESTATE_AD":
                            case 8:
                                message.displayUploadProductType = 8;
                                break;
                            case "DYNAMIC_HTML5_CUSTOM_AD":
                            case 9:
                                message.displayUploadProductType = 9;
                                break;
                            case "DYNAMIC_HTML5_TRAVEL_AD":
                            case 10:
                                message.displayUploadProductType = 10;
                                break;
                            case "DYNAMIC_HTML5_HOTEL_AD":
                            case 11:
                                message.displayUploadProductType = 11;
                                break;
                            }
                            if (object.mediaBundle != null) {
                                if (typeof object.mediaBundle !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.DisplayUploadAdInfo.mediaBundle: object expected");
                                message.mediaBundle = $root.google.ads.googleads.v1.common.AdMediaBundleAsset.fromObject(object.mediaBundle);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a DisplayUploadAdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.DisplayUploadAdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.DisplayUploadAdInfo} message DisplayUploadAdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DisplayUploadAdInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.displayUploadProductType = options.enums === String ? "UNSPECIFIED" : 0;
                            if (message.displayUploadProductType != null && message.hasOwnProperty("displayUploadProductType"))
                                object.displayUploadProductType = options.enums === String ? $root.google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum.DisplayUploadProductType[message.displayUploadProductType] : message.displayUploadProductType;
                            if (message.mediaBundle != null && message.hasOwnProperty("mediaBundle")) {
                                object.mediaBundle = $root.google.ads.googleads.v1.common.AdMediaBundleAsset.toObject(message.mediaBundle, options);
                                if (options.oneofs)
                                    object.mediaAsset = "mediaBundle";
                            }
                            return object;
                        };

                        /**
                         * Converts this DisplayUploadAdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.DisplayUploadAdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DisplayUploadAdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return DisplayUploadAdInfo;
                    })();

                    common.YoutubeVideoAsset = (function() {

                        /**
                         * Properties of a YoutubeVideoAsset.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IYoutubeVideoAsset
                         * @property {google.protobuf.IStringValue|null} [youtubeVideoId] YoutubeVideoAsset youtubeVideoId
                         */

                        /**
                         * Constructs a new YoutubeVideoAsset.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a YoutubeVideoAsset.
                         * @implements IYoutubeVideoAsset
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IYoutubeVideoAsset=} [properties] Properties to set
                         */
                        function YoutubeVideoAsset(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * YoutubeVideoAsset youtubeVideoId.
                         * @member {google.protobuf.IStringValue|null|undefined} youtubeVideoId
                         * @memberof google.ads.googleads.v1.common.YoutubeVideoAsset
                         * @instance
                         */
                        YoutubeVideoAsset.prototype.youtubeVideoId = null;

                        /**
                         * Creates a new YoutubeVideoAsset instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.YoutubeVideoAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IYoutubeVideoAsset=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.YoutubeVideoAsset} YoutubeVideoAsset instance
                         */
                        YoutubeVideoAsset.create = function create(properties) {
                            return new YoutubeVideoAsset(properties);
                        };

                        /**
                         * Encodes the specified YoutubeVideoAsset message. Does not implicitly {@link google.ads.googleads.v1.common.YoutubeVideoAsset.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.YoutubeVideoAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IYoutubeVideoAsset} message YoutubeVideoAsset message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        YoutubeVideoAsset.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.youtubeVideoId != null && message.hasOwnProperty("youtubeVideoId"))
                                $root.google.protobuf.StringValue.encode(message.youtubeVideoId, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified YoutubeVideoAsset message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.YoutubeVideoAsset.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.YoutubeVideoAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IYoutubeVideoAsset} message YoutubeVideoAsset message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        YoutubeVideoAsset.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a YoutubeVideoAsset message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.YoutubeVideoAsset
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.YoutubeVideoAsset} YoutubeVideoAsset
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        YoutubeVideoAsset.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.YoutubeVideoAsset();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.youtubeVideoId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a YoutubeVideoAsset message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.YoutubeVideoAsset
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.YoutubeVideoAsset} YoutubeVideoAsset
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        YoutubeVideoAsset.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a YoutubeVideoAsset message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.YoutubeVideoAsset
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        YoutubeVideoAsset.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.youtubeVideoId != null && message.hasOwnProperty("youtubeVideoId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.youtubeVideoId);
                                if (error)
                                    return "youtubeVideoId." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a YoutubeVideoAsset message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.YoutubeVideoAsset
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.YoutubeVideoAsset} YoutubeVideoAsset
                         */
                        YoutubeVideoAsset.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.YoutubeVideoAsset)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.YoutubeVideoAsset();
                            if (object.youtubeVideoId != null) {
                                if (typeof object.youtubeVideoId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.YoutubeVideoAsset.youtubeVideoId: object expected");
                                message.youtubeVideoId = $root.google.protobuf.StringValue.fromObject(object.youtubeVideoId);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a YoutubeVideoAsset message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.YoutubeVideoAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.YoutubeVideoAsset} message YoutubeVideoAsset
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        YoutubeVideoAsset.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.youtubeVideoId = null;
                            if (message.youtubeVideoId != null && message.hasOwnProperty("youtubeVideoId"))
                                object.youtubeVideoId = $root.google.protobuf.StringValue.toObject(message.youtubeVideoId, options);
                            return object;
                        };

                        /**
                         * Converts this YoutubeVideoAsset to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.YoutubeVideoAsset
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        YoutubeVideoAsset.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return YoutubeVideoAsset;
                    })();

                    common.MediaBundleAsset = (function() {

                        /**
                         * Properties of a MediaBundleAsset.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IMediaBundleAsset
                         * @property {google.protobuf.IBytesValue|null} [data] MediaBundleAsset data
                         */

                        /**
                         * Constructs a new MediaBundleAsset.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a MediaBundleAsset.
                         * @implements IMediaBundleAsset
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IMediaBundleAsset=} [properties] Properties to set
                         */
                        function MediaBundleAsset(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MediaBundleAsset data.
                         * @member {google.protobuf.IBytesValue|null|undefined} data
                         * @memberof google.ads.googleads.v1.common.MediaBundleAsset
                         * @instance
                         */
                        MediaBundleAsset.prototype.data = null;

                        /**
                         * Creates a new MediaBundleAsset instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.MediaBundleAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IMediaBundleAsset=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.MediaBundleAsset} MediaBundleAsset instance
                         */
                        MediaBundleAsset.create = function create(properties) {
                            return new MediaBundleAsset(properties);
                        };

                        /**
                         * Encodes the specified MediaBundleAsset message. Does not implicitly {@link google.ads.googleads.v1.common.MediaBundleAsset.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.MediaBundleAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IMediaBundleAsset} message MediaBundleAsset message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaBundleAsset.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.data != null && message.hasOwnProperty("data"))
                                $root.google.protobuf.BytesValue.encode(message.data, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MediaBundleAsset message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.MediaBundleAsset.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.MediaBundleAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IMediaBundleAsset} message MediaBundleAsset message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaBundleAsset.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MediaBundleAsset message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.MediaBundleAsset
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.MediaBundleAsset} MediaBundleAsset
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaBundleAsset.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.MediaBundleAsset();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.data = $root.google.protobuf.BytesValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MediaBundleAsset message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.MediaBundleAsset
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.MediaBundleAsset} MediaBundleAsset
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaBundleAsset.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MediaBundleAsset message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.MediaBundleAsset
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MediaBundleAsset.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.data != null && message.hasOwnProperty("data")) {
                                var error = $root.google.protobuf.BytesValue.verify(message.data);
                                if (error)
                                    return "data." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MediaBundleAsset message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.MediaBundleAsset
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.MediaBundleAsset} MediaBundleAsset
                         */
                        MediaBundleAsset.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.MediaBundleAsset)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.MediaBundleAsset();
                            if (object.data != null) {
                                if (typeof object.data !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.MediaBundleAsset.data: object expected");
                                message.data = $root.google.protobuf.BytesValue.fromObject(object.data);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MediaBundleAsset message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.MediaBundleAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.MediaBundleAsset} message MediaBundleAsset
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MediaBundleAsset.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.data = null;
                            if (message.data != null && message.hasOwnProperty("data"))
                                object.data = $root.google.protobuf.BytesValue.toObject(message.data, options);
                            return object;
                        };

                        /**
                         * Converts this MediaBundleAsset to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.MediaBundleAsset
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MediaBundleAsset.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MediaBundleAsset;
                    })();

                    common.ImageAsset = (function() {

                        /**
                         * Properties of an ImageAsset.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IImageAsset
                         * @property {google.protobuf.IBytesValue|null} [data] ImageAsset data
                         * @property {google.protobuf.IInt64Value|null} [fileSize] ImageAsset fileSize
                         * @property {google.ads.googleads.v1.enums.MimeTypeEnum.MimeType|null} [mimeType] ImageAsset mimeType
                         * @property {google.ads.googleads.v1.common.IImageDimension|null} [fullSize] ImageAsset fullSize
                         */

                        /**
                         * Constructs a new ImageAsset.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an ImageAsset.
                         * @implements IImageAsset
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IImageAsset=} [properties] Properties to set
                         */
                        function ImageAsset(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ImageAsset data.
                         * @member {google.protobuf.IBytesValue|null|undefined} data
                         * @memberof google.ads.googleads.v1.common.ImageAsset
                         * @instance
                         */
                        ImageAsset.prototype.data = null;

                        /**
                         * ImageAsset fileSize.
                         * @member {google.protobuf.IInt64Value|null|undefined} fileSize
                         * @memberof google.ads.googleads.v1.common.ImageAsset
                         * @instance
                         */
                        ImageAsset.prototype.fileSize = null;

                        /**
                         * ImageAsset mimeType.
                         * @member {google.ads.googleads.v1.enums.MimeTypeEnum.MimeType} mimeType
                         * @memberof google.ads.googleads.v1.common.ImageAsset
                         * @instance
                         */
                        ImageAsset.prototype.mimeType = 0;

                        /**
                         * ImageAsset fullSize.
                         * @member {google.ads.googleads.v1.common.IImageDimension|null|undefined} fullSize
                         * @memberof google.ads.googleads.v1.common.ImageAsset
                         * @instance
                         */
                        ImageAsset.prototype.fullSize = null;

                        /**
                         * Creates a new ImageAsset instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ImageAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IImageAsset=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ImageAsset} ImageAsset instance
                         */
                        ImageAsset.create = function create(properties) {
                            return new ImageAsset(properties);
                        };

                        /**
                         * Encodes the specified ImageAsset message. Does not implicitly {@link google.ads.googleads.v1.common.ImageAsset.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ImageAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IImageAsset} message ImageAsset message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ImageAsset.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.data != null && message.hasOwnProperty("data"))
                                $root.google.protobuf.BytesValue.encode(message.data, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.fileSize != null && message.hasOwnProperty("fileSize"))
                                $root.google.protobuf.Int64Value.encode(message.fileSize, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.mimeType != null && message.hasOwnProperty("mimeType"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.mimeType);
                            if (message.fullSize != null && message.hasOwnProperty("fullSize"))
                                $root.google.ads.googleads.v1.common.ImageDimension.encode(message.fullSize, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ImageAsset message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ImageAsset.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ImageAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.IImageAsset} message ImageAsset message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ImageAsset.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ImageAsset message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ImageAsset
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ImageAsset} ImageAsset
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ImageAsset.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ImageAsset();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.data = $root.google.protobuf.BytesValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.fileSize = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.mimeType = reader.int32();
                                    break;
                                case 4:
                                    message.fullSize = $root.google.ads.googleads.v1.common.ImageDimension.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ImageAsset message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ImageAsset
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ImageAsset} ImageAsset
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ImageAsset.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ImageAsset message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ImageAsset
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ImageAsset.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.data != null && message.hasOwnProperty("data")) {
                                var error = $root.google.protobuf.BytesValue.verify(message.data);
                                if (error)
                                    return "data." + error;
                            }
                            if (message.fileSize != null && message.hasOwnProperty("fileSize")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.fileSize);
                                if (error)
                                    return "fileSize." + error;
                            }
                            if (message.mimeType != null && message.hasOwnProperty("mimeType"))
                                switch (message.mimeType) {
                                default:
                                    return "mimeType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                    break;
                                }
                            if (message.fullSize != null && message.hasOwnProperty("fullSize")) {
                                var error = $root.google.ads.googleads.v1.common.ImageDimension.verify(message.fullSize);
                                if (error)
                                    return "fullSize." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an ImageAsset message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ImageAsset
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ImageAsset} ImageAsset
                         */
                        ImageAsset.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ImageAsset)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ImageAsset();
                            if (object.data != null) {
                                if (typeof object.data !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ImageAsset.data: object expected");
                                message.data = $root.google.protobuf.BytesValue.fromObject(object.data);
                            }
                            if (object.fileSize != null) {
                                if (typeof object.fileSize !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ImageAsset.fileSize: object expected");
                                message.fileSize = $root.google.protobuf.Int64Value.fromObject(object.fileSize);
                            }
                            switch (object.mimeType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.mimeType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.mimeType = 1;
                                break;
                            case "IMAGE_JPEG":
                            case 2:
                                message.mimeType = 2;
                                break;
                            case "IMAGE_GIF":
                            case 3:
                                message.mimeType = 3;
                                break;
                            case "IMAGE_PNG":
                            case 4:
                                message.mimeType = 4;
                                break;
                            case "FLASH":
                            case 5:
                                message.mimeType = 5;
                                break;
                            case "TEXT_HTML":
                            case 6:
                                message.mimeType = 6;
                                break;
                            case "PDF":
                            case 7:
                                message.mimeType = 7;
                                break;
                            case "MSWORD":
                            case 8:
                                message.mimeType = 8;
                                break;
                            case "MSEXCEL":
                            case 9:
                                message.mimeType = 9;
                                break;
                            case "RTF":
                            case 10:
                                message.mimeType = 10;
                                break;
                            case "AUDIO_WAV":
                            case 11:
                                message.mimeType = 11;
                                break;
                            case "AUDIO_MP3":
                            case 12:
                                message.mimeType = 12;
                                break;
                            case "HTML5_AD_ZIP":
                            case 13:
                                message.mimeType = 13;
                                break;
                            }
                            if (object.fullSize != null) {
                                if (typeof object.fullSize !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ImageAsset.fullSize: object expected");
                                message.fullSize = $root.google.ads.googleads.v1.common.ImageDimension.fromObject(object.fullSize);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an ImageAsset message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ImageAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.ImageAsset} message ImageAsset
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ImageAsset.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.data = null;
                                object.fileSize = null;
                                object.mimeType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.fullSize = null;
                            }
                            if (message.data != null && message.hasOwnProperty("data"))
                                object.data = $root.google.protobuf.BytesValue.toObject(message.data, options);
                            if (message.fileSize != null && message.hasOwnProperty("fileSize"))
                                object.fileSize = $root.google.protobuf.Int64Value.toObject(message.fileSize, options);
                            if (message.mimeType != null && message.hasOwnProperty("mimeType"))
                                object.mimeType = options.enums === String ? $root.google.ads.googleads.v1.enums.MimeTypeEnum.MimeType[message.mimeType] : message.mimeType;
                            if (message.fullSize != null && message.hasOwnProperty("fullSize"))
                                object.fullSize = $root.google.ads.googleads.v1.common.ImageDimension.toObject(message.fullSize, options);
                            return object;
                        };

                        /**
                         * Converts this ImageAsset to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ImageAsset
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ImageAsset.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ImageAsset;
                    })();

                    common.ImageDimension = (function() {

                        /**
                         * Properties of an ImageDimension.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IImageDimension
                         * @property {google.protobuf.IInt64Value|null} [heightPixels] ImageDimension heightPixels
                         * @property {google.protobuf.IInt64Value|null} [widthPixels] ImageDimension widthPixels
                         * @property {google.protobuf.IStringValue|null} [url] ImageDimension url
                         */

                        /**
                         * Constructs a new ImageDimension.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an ImageDimension.
                         * @implements IImageDimension
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IImageDimension=} [properties] Properties to set
                         */
                        function ImageDimension(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ImageDimension heightPixels.
                         * @member {google.protobuf.IInt64Value|null|undefined} heightPixels
                         * @memberof google.ads.googleads.v1.common.ImageDimension
                         * @instance
                         */
                        ImageDimension.prototype.heightPixels = null;

                        /**
                         * ImageDimension widthPixels.
                         * @member {google.protobuf.IInt64Value|null|undefined} widthPixels
                         * @memberof google.ads.googleads.v1.common.ImageDimension
                         * @instance
                         */
                        ImageDimension.prototype.widthPixels = null;

                        /**
                         * ImageDimension url.
                         * @member {google.protobuf.IStringValue|null|undefined} url
                         * @memberof google.ads.googleads.v1.common.ImageDimension
                         * @instance
                         */
                        ImageDimension.prototype.url = null;

                        /**
                         * Creates a new ImageDimension instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ImageDimension
                         * @static
                         * @param {google.ads.googleads.v1.common.IImageDimension=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ImageDimension} ImageDimension instance
                         */
                        ImageDimension.create = function create(properties) {
                            return new ImageDimension(properties);
                        };

                        /**
                         * Encodes the specified ImageDimension message. Does not implicitly {@link google.ads.googleads.v1.common.ImageDimension.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ImageDimension
                         * @static
                         * @param {google.ads.googleads.v1.common.IImageDimension} message ImageDimension message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ImageDimension.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.heightPixels != null && message.hasOwnProperty("heightPixels"))
                                $root.google.protobuf.Int64Value.encode(message.heightPixels, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.widthPixels != null && message.hasOwnProperty("widthPixels"))
                                $root.google.protobuf.Int64Value.encode(message.widthPixels, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.url != null && message.hasOwnProperty("url"))
                                $root.google.protobuf.StringValue.encode(message.url, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ImageDimension message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ImageDimension.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ImageDimension
                         * @static
                         * @param {google.ads.googleads.v1.common.IImageDimension} message ImageDimension message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ImageDimension.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ImageDimension message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ImageDimension
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ImageDimension} ImageDimension
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ImageDimension.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ImageDimension();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.heightPixels = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.widthPixels = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.url = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ImageDimension message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ImageDimension
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ImageDimension} ImageDimension
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ImageDimension.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ImageDimension message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ImageDimension
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ImageDimension.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.heightPixels != null && message.hasOwnProperty("heightPixels")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.heightPixels);
                                if (error)
                                    return "heightPixels." + error;
                            }
                            if (message.widthPixels != null && message.hasOwnProperty("widthPixels")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.widthPixels);
                                if (error)
                                    return "widthPixels." + error;
                            }
                            if (message.url != null && message.hasOwnProperty("url")) {
                                var error = $root.google.protobuf.StringValue.verify(message.url);
                                if (error)
                                    return "url." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an ImageDimension message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ImageDimension
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ImageDimension} ImageDimension
                         */
                        ImageDimension.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ImageDimension)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ImageDimension();
                            if (object.heightPixels != null) {
                                if (typeof object.heightPixels !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ImageDimension.heightPixels: object expected");
                                message.heightPixels = $root.google.protobuf.Int64Value.fromObject(object.heightPixels);
                            }
                            if (object.widthPixels != null) {
                                if (typeof object.widthPixels !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ImageDimension.widthPixels: object expected");
                                message.widthPixels = $root.google.protobuf.Int64Value.fromObject(object.widthPixels);
                            }
                            if (object.url != null) {
                                if (typeof object.url !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ImageDimension.url: object expected");
                                message.url = $root.google.protobuf.StringValue.fromObject(object.url);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an ImageDimension message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ImageDimension
                         * @static
                         * @param {google.ads.googleads.v1.common.ImageDimension} message ImageDimension
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ImageDimension.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.heightPixels = null;
                                object.widthPixels = null;
                                object.url = null;
                            }
                            if (message.heightPixels != null && message.hasOwnProperty("heightPixels"))
                                object.heightPixels = $root.google.protobuf.Int64Value.toObject(message.heightPixels, options);
                            if (message.widthPixels != null && message.hasOwnProperty("widthPixels"))
                                object.widthPixels = $root.google.protobuf.Int64Value.toObject(message.widthPixels, options);
                            if (message.url != null && message.hasOwnProperty("url"))
                                object.url = $root.google.protobuf.StringValue.toObject(message.url, options);
                            return object;
                        };

                        /**
                         * Converts this ImageDimension to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ImageDimension
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ImageDimension.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ImageDimension;
                    })();

                    common.TextAsset = (function() {

                        /**
                         * Properties of a TextAsset.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ITextAsset
                         * @property {google.protobuf.IStringValue|null} [text] TextAsset text
                         */

                        /**
                         * Constructs a new TextAsset.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a TextAsset.
                         * @implements ITextAsset
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ITextAsset=} [properties] Properties to set
                         */
                        function TextAsset(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * TextAsset text.
                         * @member {google.protobuf.IStringValue|null|undefined} text
                         * @memberof google.ads.googleads.v1.common.TextAsset
                         * @instance
                         */
                        TextAsset.prototype.text = null;

                        /**
                         * Creates a new TextAsset instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.TextAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.ITextAsset=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.TextAsset} TextAsset instance
                         */
                        TextAsset.create = function create(properties) {
                            return new TextAsset(properties);
                        };

                        /**
                         * Encodes the specified TextAsset message. Does not implicitly {@link google.ads.googleads.v1.common.TextAsset.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.TextAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.ITextAsset} message TextAsset message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TextAsset.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.text != null && message.hasOwnProperty("text"))
                                $root.google.protobuf.StringValue.encode(message.text, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified TextAsset message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.TextAsset.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.TextAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.ITextAsset} message TextAsset message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TextAsset.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TextAsset message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.TextAsset
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.TextAsset} TextAsset
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TextAsset.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.TextAsset();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.text = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TextAsset message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.TextAsset
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.TextAsset} TextAsset
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TextAsset.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TextAsset message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.TextAsset
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TextAsset.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.text != null && message.hasOwnProperty("text")) {
                                var error = $root.google.protobuf.StringValue.verify(message.text);
                                if (error)
                                    return "text." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a TextAsset message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.TextAsset
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.TextAsset} TextAsset
                         */
                        TextAsset.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.TextAsset)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.TextAsset();
                            if (object.text != null) {
                                if (typeof object.text !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TextAsset.text: object expected");
                                message.text = $root.google.protobuf.StringValue.fromObject(object.text);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a TextAsset message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.TextAsset
                         * @static
                         * @param {google.ads.googleads.v1.common.TextAsset} message TextAsset
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TextAsset.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.text = null;
                            if (message.text != null && message.hasOwnProperty("text"))
                                object.text = $root.google.protobuf.StringValue.toObject(message.text, options);
                            return object;
                        };

                        /**
                         * Converts this TextAsset to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.TextAsset
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TextAsset.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return TextAsset;
                    })();

                    common.Commission = (function() {

                        /**
                         * Properties of a Commission.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ICommission
                         * @property {google.protobuf.IInt64Value|null} [commissionRateMicros] Commission commissionRateMicros
                         */

                        /**
                         * Constructs a new Commission.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a Commission.
                         * @implements ICommission
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ICommission=} [properties] Properties to set
                         */
                        function Commission(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Commission commissionRateMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} commissionRateMicros
                         * @memberof google.ads.googleads.v1.common.Commission
                         * @instance
                         */
                        Commission.prototype.commissionRateMicros = null;

                        /**
                         * Creates a new Commission instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.Commission
                         * @static
                         * @param {google.ads.googleads.v1.common.ICommission=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.Commission} Commission instance
                         */
                        Commission.create = function create(properties) {
                            return new Commission(properties);
                        };

                        /**
                         * Encodes the specified Commission message. Does not implicitly {@link google.ads.googleads.v1.common.Commission.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.Commission
                         * @static
                         * @param {google.ads.googleads.v1.common.ICommission} message Commission message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Commission.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.commissionRateMicros != null && message.hasOwnProperty("commissionRateMicros"))
                                $root.google.protobuf.Int64Value.encode(message.commissionRateMicros, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified Commission message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.Commission.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.Commission
                         * @static
                         * @param {google.ads.googleads.v1.common.ICommission} message Commission message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Commission.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a Commission message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.Commission
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.Commission} Commission
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Commission.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.Commission();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.commissionRateMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a Commission message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.Commission
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.Commission} Commission
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Commission.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a Commission message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.Commission
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Commission.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.commissionRateMicros != null && message.hasOwnProperty("commissionRateMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.commissionRateMicros);
                                if (error)
                                    return "commissionRateMicros." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a Commission message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.Commission
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.Commission} Commission
                         */
                        Commission.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.Commission)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.Commission();
                            if (object.commissionRateMicros != null) {
                                if (typeof object.commissionRateMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Commission.commissionRateMicros: object expected");
                                message.commissionRateMicros = $root.google.protobuf.Int64Value.fromObject(object.commissionRateMicros);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a Commission message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.Commission
                         * @static
                         * @param {google.ads.googleads.v1.common.Commission} message Commission
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Commission.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.commissionRateMicros = null;
                            if (message.commissionRateMicros != null && message.hasOwnProperty("commissionRateMicros"))
                                object.commissionRateMicros = $root.google.protobuf.Int64Value.toObject(message.commissionRateMicros, options);
                            return object;
                        };

                        /**
                         * Converts this Commission to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.Commission
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Commission.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return Commission;
                    })();

                    common.EnhancedCpc = (function() {

                        /**
                         * Properties of an EnhancedCpc.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IEnhancedCpc
                         */

                        /**
                         * Constructs a new EnhancedCpc.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an EnhancedCpc.
                         * @implements IEnhancedCpc
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IEnhancedCpc=} [properties] Properties to set
                         */
                        function EnhancedCpc(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new EnhancedCpc instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.EnhancedCpc
                         * @static
                         * @param {google.ads.googleads.v1.common.IEnhancedCpc=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.EnhancedCpc} EnhancedCpc instance
                         */
                        EnhancedCpc.create = function create(properties) {
                            return new EnhancedCpc(properties);
                        };

                        /**
                         * Encodes the specified EnhancedCpc message. Does not implicitly {@link google.ads.googleads.v1.common.EnhancedCpc.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.EnhancedCpc
                         * @static
                         * @param {google.ads.googleads.v1.common.IEnhancedCpc} message EnhancedCpc message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        EnhancedCpc.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified EnhancedCpc message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.EnhancedCpc.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.EnhancedCpc
                         * @static
                         * @param {google.ads.googleads.v1.common.IEnhancedCpc} message EnhancedCpc message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        EnhancedCpc.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an EnhancedCpc message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.EnhancedCpc
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.EnhancedCpc} EnhancedCpc
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        EnhancedCpc.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.EnhancedCpc();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an EnhancedCpc message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.EnhancedCpc
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.EnhancedCpc} EnhancedCpc
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        EnhancedCpc.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an EnhancedCpc message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.EnhancedCpc
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        EnhancedCpc.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an EnhancedCpc message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.EnhancedCpc
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.EnhancedCpc} EnhancedCpc
                         */
                        EnhancedCpc.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.EnhancedCpc)
                                return object;
                            return new $root.google.ads.googleads.v1.common.EnhancedCpc();
                        };

                        /**
                         * Creates a plain object from an EnhancedCpc message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.EnhancedCpc
                         * @static
                         * @param {google.ads.googleads.v1.common.EnhancedCpc} message EnhancedCpc
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        EnhancedCpc.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this EnhancedCpc to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.EnhancedCpc
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        EnhancedCpc.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return EnhancedCpc;
                    })();

                    common.ManualCpc = (function() {

                        /**
                         * Properties of a ManualCpc.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IManualCpc
                         * @property {google.protobuf.IBoolValue|null} [enhancedCpcEnabled] ManualCpc enhancedCpcEnabled
                         */

                        /**
                         * Constructs a new ManualCpc.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ManualCpc.
                         * @implements IManualCpc
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IManualCpc=} [properties] Properties to set
                         */
                        function ManualCpc(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ManualCpc enhancedCpcEnabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} enhancedCpcEnabled
                         * @memberof google.ads.googleads.v1.common.ManualCpc
                         * @instance
                         */
                        ManualCpc.prototype.enhancedCpcEnabled = null;

                        /**
                         * Creates a new ManualCpc instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ManualCpc
                         * @static
                         * @param {google.ads.googleads.v1.common.IManualCpc=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ManualCpc} ManualCpc instance
                         */
                        ManualCpc.create = function create(properties) {
                            return new ManualCpc(properties);
                        };

                        /**
                         * Encodes the specified ManualCpc message. Does not implicitly {@link google.ads.googleads.v1.common.ManualCpc.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ManualCpc
                         * @static
                         * @param {google.ads.googleads.v1.common.IManualCpc} message ManualCpc message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ManualCpc.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.enhancedCpcEnabled != null && message.hasOwnProperty("enhancedCpcEnabled"))
                                $root.google.protobuf.BoolValue.encode(message.enhancedCpcEnabled, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ManualCpc message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ManualCpc.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ManualCpc
                         * @static
                         * @param {google.ads.googleads.v1.common.IManualCpc} message ManualCpc message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ManualCpc.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ManualCpc message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ManualCpc
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ManualCpc} ManualCpc
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ManualCpc.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ManualCpc();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.enhancedCpcEnabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ManualCpc message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ManualCpc
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ManualCpc} ManualCpc
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ManualCpc.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ManualCpc message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ManualCpc
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ManualCpc.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.enhancedCpcEnabled != null && message.hasOwnProperty("enhancedCpcEnabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.enhancedCpcEnabled);
                                if (error)
                                    return "enhancedCpcEnabled." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a ManualCpc message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ManualCpc
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ManualCpc} ManualCpc
                         */
                        ManualCpc.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ManualCpc)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ManualCpc();
                            if (object.enhancedCpcEnabled != null) {
                                if (typeof object.enhancedCpcEnabled !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ManualCpc.enhancedCpcEnabled: object expected");
                                message.enhancedCpcEnabled = $root.google.protobuf.BoolValue.fromObject(object.enhancedCpcEnabled);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ManualCpc message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ManualCpc
                         * @static
                         * @param {google.ads.googleads.v1.common.ManualCpc} message ManualCpc
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ManualCpc.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.enhancedCpcEnabled = null;
                            if (message.enhancedCpcEnabled != null && message.hasOwnProperty("enhancedCpcEnabled"))
                                object.enhancedCpcEnabled = $root.google.protobuf.BoolValue.toObject(message.enhancedCpcEnabled, options);
                            return object;
                        };

                        /**
                         * Converts this ManualCpc to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ManualCpc
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ManualCpc.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ManualCpc;
                    })();

                    common.ManualCpm = (function() {

                        /**
                         * Properties of a ManualCpm.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IManualCpm
                         */

                        /**
                         * Constructs a new ManualCpm.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ManualCpm.
                         * @implements IManualCpm
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IManualCpm=} [properties] Properties to set
                         */
                        function ManualCpm(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ManualCpm instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ManualCpm
                         * @static
                         * @param {google.ads.googleads.v1.common.IManualCpm=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ManualCpm} ManualCpm instance
                         */
                        ManualCpm.create = function create(properties) {
                            return new ManualCpm(properties);
                        };

                        /**
                         * Encodes the specified ManualCpm message. Does not implicitly {@link google.ads.googleads.v1.common.ManualCpm.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ManualCpm
                         * @static
                         * @param {google.ads.googleads.v1.common.IManualCpm} message ManualCpm message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ManualCpm.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ManualCpm message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ManualCpm.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ManualCpm
                         * @static
                         * @param {google.ads.googleads.v1.common.IManualCpm} message ManualCpm message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ManualCpm.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ManualCpm message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ManualCpm
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ManualCpm} ManualCpm
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ManualCpm.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ManualCpm();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ManualCpm message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ManualCpm
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ManualCpm} ManualCpm
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ManualCpm.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ManualCpm message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ManualCpm
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ManualCpm.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ManualCpm message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ManualCpm
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ManualCpm} ManualCpm
                         */
                        ManualCpm.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ManualCpm)
                                return object;
                            return new $root.google.ads.googleads.v1.common.ManualCpm();
                        };

                        /**
                         * Creates a plain object from a ManualCpm message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ManualCpm
                         * @static
                         * @param {google.ads.googleads.v1.common.ManualCpm} message ManualCpm
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ManualCpm.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ManualCpm to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ManualCpm
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ManualCpm.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ManualCpm;
                    })();

                    common.ManualCpv = (function() {

                        /**
                         * Properties of a ManualCpv.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IManualCpv
                         */

                        /**
                         * Constructs a new ManualCpv.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ManualCpv.
                         * @implements IManualCpv
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IManualCpv=} [properties] Properties to set
                         */
                        function ManualCpv(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ManualCpv instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ManualCpv
                         * @static
                         * @param {google.ads.googleads.v1.common.IManualCpv=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ManualCpv} ManualCpv instance
                         */
                        ManualCpv.create = function create(properties) {
                            return new ManualCpv(properties);
                        };

                        /**
                         * Encodes the specified ManualCpv message. Does not implicitly {@link google.ads.googleads.v1.common.ManualCpv.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ManualCpv
                         * @static
                         * @param {google.ads.googleads.v1.common.IManualCpv} message ManualCpv message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ManualCpv.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ManualCpv message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ManualCpv.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ManualCpv
                         * @static
                         * @param {google.ads.googleads.v1.common.IManualCpv} message ManualCpv message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ManualCpv.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ManualCpv message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ManualCpv
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ManualCpv} ManualCpv
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ManualCpv.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ManualCpv();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ManualCpv message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ManualCpv
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ManualCpv} ManualCpv
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ManualCpv.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ManualCpv message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ManualCpv
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ManualCpv.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ManualCpv message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ManualCpv
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ManualCpv} ManualCpv
                         */
                        ManualCpv.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ManualCpv)
                                return object;
                            return new $root.google.ads.googleads.v1.common.ManualCpv();
                        };

                        /**
                         * Creates a plain object from a ManualCpv message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ManualCpv
                         * @static
                         * @param {google.ads.googleads.v1.common.ManualCpv} message ManualCpv
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ManualCpv.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ManualCpv to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ManualCpv
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ManualCpv.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ManualCpv;
                    })();

                    common.MaximizeConversions = (function() {

                        /**
                         * Properties of a MaximizeConversions.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IMaximizeConversions
                         */

                        /**
                         * Constructs a new MaximizeConversions.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a MaximizeConversions.
                         * @implements IMaximizeConversions
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IMaximizeConversions=} [properties] Properties to set
                         */
                        function MaximizeConversions(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new MaximizeConversions instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.MaximizeConversions
                         * @static
                         * @param {google.ads.googleads.v1.common.IMaximizeConversions=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.MaximizeConversions} MaximizeConversions instance
                         */
                        MaximizeConversions.create = function create(properties) {
                            return new MaximizeConversions(properties);
                        };

                        /**
                         * Encodes the specified MaximizeConversions message. Does not implicitly {@link google.ads.googleads.v1.common.MaximizeConversions.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.MaximizeConversions
                         * @static
                         * @param {google.ads.googleads.v1.common.IMaximizeConversions} message MaximizeConversions message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MaximizeConversions.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified MaximizeConversions message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.MaximizeConversions.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.MaximizeConversions
                         * @static
                         * @param {google.ads.googleads.v1.common.IMaximizeConversions} message MaximizeConversions message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MaximizeConversions.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MaximizeConversions message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.MaximizeConversions
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.MaximizeConversions} MaximizeConversions
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MaximizeConversions.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.MaximizeConversions();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MaximizeConversions message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.MaximizeConversions
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.MaximizeConversions} MaximizeConversions
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MaximizeConversions.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MaximizeConversions message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.MaximizeConversions
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MaximizeConversions.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a MaximizeConversions message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.MaximizeConversions
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.MaximizeConversions} MaximizeConversions
                         */
                        MaximizeConversions.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.MaximizeConversions)
                                return object;
                            return new $root.google.ads.googleads.v1.common.MaximizeConversions();
                        };

                        /**
                         * Creates a plain object from a MaximizeConversions message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.MaximizeConversions
                         * @static
                         * @param {google.ads.googleads.v1.common.MaximizeConversions} message MaximizeConversions
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MaximizeConversions.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this MaximizeConversions to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.MaximizeConversions
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MaximizeConversions.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MaximizeConversions;
                    })();

                    common.MaximizeConversionValue = (function() {

                        /**
                         * Properties of a MaximizeConversionValue.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IMaximizeConversionValue
                         * @property {google.protobuf.IDoubleValue|null} [targetRoas] MaximizeConversionValue targetRoas
                         */

                        /**
                         * Constructs a new MaximizeConversionValue.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a MaximizeConversionValue.
                         * @implements IMaximizeConversionValue
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IMaximizeConversionValue=} [properties] Properties to set
                         */
                        function MaximizeConversionValue(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MaximizeConversionValue targetRoas.
                         * @member {google.protobuf.IDoubleValue|null|undefined} targetRoas
                         * @memberof google.ads.googleads.v1.common.MaximizeConversionValue
                         * @instance
                         */
                        MaximizeConversionValue.prototype.targetRoas = null;

                        /**
                         * Creates a new MaximizeConversionValue instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.MaximizeConversionValue
                         * @static
                         * @param {google.ads.googleads.v1.common.IMaximizeConversionValue=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.MaximizeConversionValue} MaximizeConversionValue instance
                         */
                        MaximizeConversionValue.create = function create(properties) {
                            return new MaximizeConversionValue(properties);
                        };

                        /**
                         * Encodes the specified MaximizeConversionValue message. Does not implicitly {@link google.ads.googleads.v1.common.MaximizeConversionValue.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.MaximizeConversionValue
                         * @static
                         * @param {google.ads.googleads.v1.common.IMaximizeConversionValue} message MaximizeConversionValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MaximizeConversionValue.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetRoas != null && message.hasOwnProperty("targetRoas"))
                                $root.google.protobuf.DoubleValue.encode(message.targetRoas, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MaximizeConversionValue message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.MaximizeConversionValue.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.MaximizeConversionValue
                         * @static
                         * @param {google.ads.googleads.v1.common.IMaximizeConversionValue} message MaximizeConversionValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MaximizeConversionValue.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MaximizeConversionValue message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.MaximizeConversionValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.MaximizeConversionValue} MaximizeConversionValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MaximizeConversionValue.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.MaximizeConversionValue();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.targetRoas = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MaximizeConversionValue message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.MaximizeConversionValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.MaximizeConversionValue} MaximizeConversionValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MaximizeConversionValue.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MaximizeConversionValue message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.MaximizeConversionValue
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MaximizeConversionValue.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.targetRoas != null && message.hasOwnProperty("targetRoas")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.targetRoas);
                                if (error)
                                    return "targetRoas." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MaximizeConversionValue message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.MaximizeConversionValue
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.MaximizeConversionValue} MaximizeConversionValue
                         */
                        MaximizeConversionValue.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.MaximizeConversionValue)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.MaximizeConversionValue();
                            if (object.targetRoas != null) {
                                if (typeof object.targetRoas !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.MaximizeConversionValue.targetRoas: object expected");
                                message.targetRoas = $root.google.protobuf.DoubleValue.fromObject(object.targetRoas);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MaximizeConversionValue message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.MaximizeConversionValue
                         * @static
                         * @param {google.ads.googleads.v1.common.MaximizeConversionValue} message MaximizeConversionValue
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MaximizeConversionValue.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.targetRoas = null;
                            if (message.targetRoas != null && message.hasOwnProperty("targetRoas"))
                                object.targetRoas = $root.google.protobuf.DoubleValue.toObject(message.targetRoas, options);
                            return object;
                        };

                        /**
                         * Converts this MaximizeConversionValue to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.MaximizeConversionValue
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MaximizeConversionValue.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MaximizeConversionValue;
                    })();

                    common.PageOnePromoted = (function() {

                        /**
                         * Properties of a PageOnePromoted.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IPageOnePromoted
                         * @property {google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum.PageOnePromotedStrategyGoal|null} [strategyGoal] PageOnePromoted strategyGoal
                         * @property {google.protobuf.IInt64Value|null} [cpcBidCeilingMicros] PageOnePromoted cpcBidCeilingMicros
                         * @property {google.protobuf.IDoubleValue|null} [bidModifier] PageOnePromoted bidModifier
                         * @property {google.protobuf.IBoolValue|null} [onlyRaiseCpcBids] PageOnePromoted onlyRaiseCpcBids
                         * @property {google.protobuf.IBoolValue|null} [raiseCpcBidWhenBudgetConstrained] PageOnePromoted raiseCpcBidWhenBudgetConstrained
                         * @property {google.protobuf.IBoolValue|null} [raiseCpcBidWhenQualityScoreIsLow] PageOnePromoted raiseCpcBidWhenQualityScoreIsLow
                         */

                        /**
                         * Constructs a new PageOnePromoted.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a PageOnePromoted.
                         * @implements IPageOnePromoted
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IPageOnePromoted=} [properties] Properties to set
                         */
                        function PageOnePromoted(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * PageOnePromoted strategyGoal.
                         * @member {google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum.PageOnePromotedStrategyGoal} strategyGoal
                         * @memberof google.ads.googleads.v1.common.PageOnePromoted
                         * @instance
                         */
                        PageOnePromoted.prototype.strategyGoal = 0;

                        /**
                         * PageOnePromoted cpcBidCeilingMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpcBidCeilingMicros
                         * @memberof google.ads.googleads.v1.common.PageOnePromoted
                         * @instance
                         */
                        PageOnePromoted.prototype.cpcBidCeilingMicros = null;

                        /**
                         * PageOnePromoted bidModifier.
                         * @member {google.protobuf.IDoubleValue|null|undefined} bidModifier
                         * @memberof google.ads.googleads.v1.common.PageOnePromoted
                         * @instance
                         */
                        PageOnePromoted.prototype.bidModifier = null;

                        /**
                         * PageOnePromoted onlyRaiseCpcBids.
                         * @member {google.protobuf.IBoolValue|null|undefined} onlyRaiseCpcBids
                         * @memberof google.ads.googleads.v1.common.PageOnePromoted
                         * @instance
                         */
                        PageOnePromoted.prototype.onlyRaiseCpcBids = null;

                        /**
                         * PageOnePromoted raiseCpcBidWhenBudgetConstrained.
                         * @member {google.protobuf.IBoolValue|null|undefined} raiseCpcBidWhenBudgetConstrained
                         * @memberof google.ads.googleads.v1.common.PageOnePromoted
                         * @instance
                         */
                        PageOnePromoted.prototype.raiseCpcBidWhenBudgetConstrained = null;

                        /**
                         * PageOnePromoted raiseCpcBidWhenQualityScoreIsLow.
                         * @member {google.protobuf.IBoolValue|null|undefined} raiseCpcBidWhenQualityScoreIsLow
                         * @memberof google.ads.googleads.v1.common.PageOnePromoted
                         * @instance
                         */
                        PageOnePromoted.prototype.raiseCpcBidWhenQualityScoreIsLow = null;

                        /**
                         * Creates a new PageOnePromoted instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.PageOnePromoted
                         * @static
                         * @param {google.ads.googleads.v1.common.IPageOnePromoted=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.PageOnePromoted} PageOnePromoted instance
                         */
                        PageOnePromoted.create = function create(properties) {
                            return new PageOnePromoted(properties);
                        };

                        /**
                         * Encodes the specified PageOnePromoted message. Does not implicitly {@link google.ads.googleads.v1.common.PageOnePromoted.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.PageOnePromoted
                         * @static
                         * @param {google.ads.googleads.v1.common.IPageOnePromoted} message PageOnePromoted message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PageOnePromoted.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.strategyGoal != null && message.hasOwnProperty("strategyGoal"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.strategyGoal);
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpcBidCeilingMicros, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.bidModifier != null && message.hasOwnProperty("bidModifier"))
                                $root.google.protobuf.DoubleValue.encode(message.bidModifier, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.onlyRaiseCpcBids != null && message.hasOwnProperty("onlyRaiseCpcBids"))
                                $root.google.protobuf.BoolValue.encode(message.onlyRaiseCpcBids, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.raiseCpcBidWhenBudgetConstrained != null && message.hasOwnProperty("raiseCpcBidWhenBudgetConstrained"))
                                $root.google.protobuf.BoolValue.encode(message.raiseCpcBidWhenBudgetConstrained, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.raiseCpcBidWhenQualityScoreIsLow != null && message.hasOwnProperty("raiseCpcBidWhenQualityScoreIsLow"))
                                $root.google.protobuf.BoolValue.encode(message.raiseCpcBidWhenQualityScoreIsLow, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified PageOnePromoted message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PageOnePromoted.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.PageOnePromoted
                         * @static
                         * @param {google.ads.googleads.v1.common.IPageOnePromoted} message PageOnePromoted message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PageOnePromoted.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PageOnePromoted message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.PageOnePromoted
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.PageOnePromoted} PageOnePromoted
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PageOnePromoted.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PageOnePromoted();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.strategyGoal = reader.int32();
                                    break;
                                case 2:
                                    message.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.bidModifier = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.onlyRaiseCpcBids = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.raiseCpcBidWhenBudgetConstrained = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.raiseCpcBidWhenQualityScoreIsLow = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PageOnePromoted message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.PageOnePromoted
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.PageOnePromoted} PageOnePromoted
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PageOnePromoted.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PageOnePromoted message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.PageOnePromoted
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PageOnePromoted.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.strategyGoal != null && message.hasOwnProperty("strategyGoal"))
                                switch (message.strategyGoal) {
                                default:
                                    return "strategyGoal: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpcBidCeilingMicros);
                                if (error)
                                    return "cpcBidCeilingMicros." + error;
                            }
                            if (message.bidModifier != null && message.hasOwnProperty("bidModifier")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.bidModifier);
                                if (error)
                                    return "bidModifier." + error;
                            }
                            if (message.onlyRaiseCpcBids != null && message.hasOwnProperty("onlyRaiseCpcBids")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.onlyRaiseCpcBids);
                                if (error)
                                    return "onlyRaiseCpcBids." + error;
                            }
                            if (message.raiseCpcBidWhenBudgetConstrained != null && message.hasOwnProperty("raiseCpcBidWhenBudgetConstrained")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.raiseCpcBidWhenBudgetConstrained);
                                if (error)
                                    return "raiseCpcBidWhenBudgetConstrained." + error;
                            }
                            if (message.raiseCpcBidWhenQualityScoreIsLow != null && message.hasOwnProperty("raiseCpcBidWhenQualityScoreIsLow")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.raiseCpcBidWhenQualityScoreIsLow);
                                if (error)
                                    return "raiseCpcBidWhenQualityScoreIsLow." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a PageOnePromoted message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.PageOnePromoted
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.PageOnePromoted} PageOnePromoted
                         */
                        PageOnePromoted.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.PageOnePromoted)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.PageOnePromoted();
                            switch (object.strategyGoal) {
                            case "UNSPECIFIED":
                            case 0:
                                message.strategyGoal = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.strategyGoal = 1;
                                break;
                            case "FIRST_PAGE":
                            case 2:
                                message.strategyGoal = 2;
                                break;
                            case "FIRST_PAGE_PROMOTED":
                            case 3:
                                message.strategyGoal = 3;
                                break;
                            }
                            if (object.cpcBidCeilingMicros != null) {
                                if (typeof object.cpcBidCeilingMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PageOnePromoted.cpcBidCeilingMicros: object expected");
                                message.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.fromObject(object.cpcBidCeilingMicros);
                            }
                            if (object.bidModifier != null) {
                                if (typeof object.bidModifier !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PageOnePromoted.bidModifier: object expected");
                                message.bidModifier = $root.google.protobuf.DoubleValue.fromObject(object.bidModifier);
                            }
                            if (object.onlyRaiseCpcBids != null) {
                                if (typeof object.onlyRaiseCpcBids !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PageOnePromoted.onlyRaiseCpcBids: object expected");
                                message.onlyRaiseCpcBids = $root.google.protobuf.BoolValue.fromObject(object.onlyRaiseCpcBids);
                            }
                            if (object.raiseCpcBidWhenBudgetConstrained != null) {
                                if (typeof object.raiseCpcBidWhenBudgetConstrained !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PageOnePromoted.raiseCpcBidWhenBudgetConstrained: object expected");
                                message.raiseCpcBidWhenBudgetConstrained = $root.google.protobuf.BoolValue.fromObject(object.raiseCpcBidWhenBudgetConstrained);
                            }
                            if (object.raiseCpcBidWhenQualityScoreIsLow != null) {
                                if (typeof object.raiseCpcBidWhenQualityScoreIsLow !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PageOnePromoted.raiseCpcBidWhenQualityScoreIsLow: object expected");
                                message.raiseCpcBidWhenQualityScoreIsLow = $root.google.protobuf.BoolValue.fromObject(object.raiseCpcBidWhenQualityScoreIsLow);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a PageOnePromoted message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.PageOnePromoted
                         * @static
                         * @param {google.ads.googleads.v1.common.PageOnePromoted} message PageOnePromoted
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PageOnePromoted.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.strategyGoal = options.enums === String ? "UNSPECIFIED" : 0;
                                object.cpcBidCeilingMicros = null;
                                object.bidModifier = null;
                                object.onlyRaiseCpcBids = null;
                                object.raiseCpcBidWhenBudgetConstrained = null;
                                object.raiseCpcBidWhenQualityScoreIsLow = null;
                            }
                            if (message.strategyGoal != null && message.hasOwnProperty("strategyGoal"))
                                object.strategyGoal = options.enums === String ? $root.google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum.PageOnePromotedStrategyGoal[message.strategyGoal] : message.strategyGoal;
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros"))
                                object.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.toObject(message.cpcBidCeilingMicros, options);
                            if (message.bidModifier != null && message.hasOwnProperty("bidModifier"))
                                object.bidModifier = $root.google.protobuf.DoubleValue.toObject(message.bidModifier, options);
                            if (message.onlyRaiseCpcBids != null && message.hasOwnProperty("onlyRaiseCpcBids"))
                                object.onlyRaiseCpcBids = $root.google.protobuf.BoolValue.toObject(message.onlyRaiseCpcBids, options);
                            if (message.raiseCpcBidWhenBudgetConstrained != null && message.hasOwnProperty("raiseCpcBidWhenBudgetConstrained"))
                                object.raiseCpcBidWhenBudgetConstrained = $root.google.protobuf.BoolValue.toObject(message.raiseCpcBidWhenBudgetConstrained, options);
                            if (message.raiseCpcBidWhenQualityScoreIsLow != null && message.hasOwnProperty("raiseCpcBidWhenQualityScoreIsLow"))
                                object.raiseCpcBidWhenQualityScoreIsLow = $root.google.protobuf.BoolValue.toObject(message.raiseCpcBidWhenQualityScoreIsLow, options);
                            return object;
                        };

                        /**
                         * Converts this PageOnePromoted to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.PageOnePromoted
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PageOnePromoted.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return PageOnePromoted;
                    })();

                    common.TargetCpa = (function() {

                        /**
                         * Properties of a TargetCpa.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ITargetCpa
                         * @property {google.protobuf.IInt64Value|null} [targetCpaMicros] TargetCpa targetCpaMicros
                         * @property {google.protobuf.IInt64Value|null} [cpcBidCeilingMicros] TargetCpa cpcBidCeilingMicros
                         * @property {google.protobuf.IInt64Value|null} [cpcBidFloorMicros] TargetCpa cpcBidFloorMicros
                         */

                        /**
                         * Constructs a new TargetCpa.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a TargetCpa.
                         * @implements ITargetCpa
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ITargetCpa=} [properties] Properties to set
                         */
                        function TargetCpa(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * TargetCpa targetCpaMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} targetCpaMicros
                         * @memberof google.ads.googleads.v1.common.TargetCpa
                         * @instance
                         */
                        TargetCpa.prototype.targetCpaMicros = null;

                        /**
                         * TargetCpa cpcBidCeilingMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpcBidCeilingMicros
                         * @memberof google.ads.googleads.v1.common.TargetCpa
                         * @instance
                         */
                        TargetCpa.prototype.cpcBidCeilingMicros = null;

                        /**
                         * TargetCpa cpcBidFloorMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpcBidFloorMicros
                         * @memberof google.ads.googleads.v1.common.TargetCpa
                         * @instance
                         */
                        TargetCpa.prototype.cpcBidFloorMicros = null;

                        /**
                         * Creates a new TargetCpa instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.TargetCpa
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetCpa=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.TargetCpa} TargetCpa instance
                         */
                        TargetCpa.create = function create(properties) {
                            return new TargetCpa(properties);
                        };

                        /**
                         * Encodes the specified TargetCpa message. Does not implicitly {@link google.ads.googleads.v1.common.TargetCpa.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.TargetCpa
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetCpa} message TargetCpa message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetCpa.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetCpaMicros != null && message.hasOwnProperty("targetCpaMicros"))
                                $root.google.protobuf.Int64Value.encode(message.targetCpaMicros, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpcBidCeilingMicros, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.cpcBidFloorMicros != null && message.hasOwnProperty("cpcBidFloorMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpcBidFloorMicros, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified TargetCpa message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.TargetCpa.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetCpa
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetCpa} message TargetCpa message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetCpa.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TargetCpa message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.TargetCpa
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.TargetCpa} TargetCpa
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetCpa.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.TargetCpa();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.targetCpaMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.cpcBidFloorMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TargetCpa message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetCpa
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.TargetCpa} TargetCpa
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetCpa.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TargetCpa message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.TargetCpa
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetCpa.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.targetCpaMicros != null && message.hasOwnProperty("targetCpaMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.targetCpaMicros);
                                if (error)
                                    return "targetCpaMicros." + error;
                            }
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpcBidCeilingMicros);
                                if (error)
                                    return "cpcBidCeilingMicros." + error;
                            }
                            if (message.cpcBidFloorMicros != null && message.hasOwnProperty("cpcBidFloorMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpcBidFloorMicros);
                                if (error)
                                    return "cpcBidFloorMicros." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a TargetCpa message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.TargetCpa
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.TargetCpa} TargetCpa
                         */
                        TargetCpa.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.TargetCpa)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.TargetCpa();
                            if (object.targetCpaMicros != null) {
                                if (typeof object.targetCpaMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetCpa.targetCpaMicros: object expected");
                                message.targetCpaMicros = $root.google.protobuf.Int64Value.fromObject(object.targetCpaMicros);
                            }
                            if (object.cpcBidCeilingMicros != null) {
                                if (typeof object.cpcBidCeilingMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetCpa.cpcBidCeilingMicros: object expected");
                                message.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.fromObject(object.cpcBidCeilingMicros);
                            }
                            if (object.cpcBidFloorMicros != null) {
                                if (typeof object.cpcBidFloorMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetCpa.cpcBidFloorMicros: object expected");
                                message.cpcBidFloorMicros = $root.google.protobuf.Int64Value.fromObject(object.cpcBidFloorMicros);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a TargetCpa message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.TargetCpa
                         * @static
                         * @param {google.ads.googleads.v1.common.TargetCpa} message TargetCpa
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetCpa.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetCpaMicros = null;
                                object.cpcBidCeilingMicros = null;
                                object.cpcBidFloorMicros = null;
                            }
                            if (message.targetCpaMicros != null && message.hasOwnProperty("targetCpaMicros"))
                                object.targetCpaMicros = $root.google.protobuf.Int64Value.toObject(message.targetCpaMicros, options);
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros"))
                                object.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.toObject(message.cpcBidCeilingMicros, options);
                            if (message.cpcBidFloorMicros != null && message.hasOwnProperty("cpcBidFloorMicros"))
                                object.cpcBidFloorMicros = $root.google.protobuf.Int64Value.toObject(message.cpcBidFloorMicros, options);
                            return object;
                        };

                        /**
                         * Converts this TargetCpa to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.TargetCpa
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetCpa.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return TargetCpa;
                    })();

                    common.TargetCpm = (function() {

                        /**
                         * Properties of a TargetCpm.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ITargetCpm
                         */

                        /**
                         * Constructs a new TargetCpm.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a TargetCpm.
                         * @implements ITargetCpm
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ITargetCpm=} [properties] Properties to set
                         */
                        function TargetCpm(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new TargetCpm instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.TargetCpm
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetCpm=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.TargetCpm} TargetCpm instance
                         */
                        TargetCpm.create = function create(properties) {
                            return new TargetCpm(properties);
                        };

                        /**
                         * Encodes the specified TargetCpm message. Does not implicitly {@link google.ads.googleads.v1.common.TargetCpm.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.TargetCpm
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetCpm} message TargetCpm message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetCpm.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified TargetCpm message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.TargetCpm.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetCpm
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetCpm} message TargetCpm message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetCpm.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TargetCpm message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.TargetCpm
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.TargetCpm} TargetCpm
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetCpm.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.TargetCpm();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TargetCpm message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetCpm
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.TargetCpm} TargetCpm
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetCpm.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TargetCpm message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.TargetCpm
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetCpm.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a TargetCpm message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.TargetCpm
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.TargetCpm} TargetCpm
                         */
                        TargetCpm.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.TargetCpm)
                                return object;
                            return new $root.google.ads.googleads.v1.common.TargetCpm();
                        };

                        /**
                         * Creates a plain object from a TargetCpm message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.TargetCpm
                         * @static
                         * @param {google.ads.googleads.v1.common.TargetCpm} message TargetCpm
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetCpm.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this TargetCpm to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.TargetCpm
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetCpm.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return TargetCpm;
                    })();

                    common.TargetImpressionShare = (function() {

                        /**
                         * Properties of a TargetImpressionShare.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ITargetImpressionShare
                         * @property {google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum.TargetImpressionShareLocation|null} [location] TargetImpressionShare location
                         * @property {google.protobuf.IInt64Value|null} [locationFractionMicros] TargetImpressionShare locationFractionMicros
                         * @property {google.protobuf.IInt64Value|null} [cpcBidCeilingMicros] TargetImpressionShare cpcBidCeilingMicros
                         */

                        /**
                         * Constructs a new TargetImpressionShare.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a TargetImpressionShare.
                         * @implements ITargetImpressionShare
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ITargetImpressionShare=} [properties] Properties to set
                         */
                        function TargetImpressionShare(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * TargetImpressionShare location.
                         * @member {google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum.TargetImpressionShareLocation} location
                         * @memberof google.ads.googleads.v1.common.TargetImpressionShare
                         * @instance
                         */
                        TargetImpressionShare.prototype.location = 0;

                        /**
                         * TargetImpressionShare locationFractionMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} locationFractionMicros
                         * @memberof google.ads.googleads.v1.common.TargetImpressionShare
                         * @instance
                         */
                        TargetImpressionShare.prototype.locationFractionMicros = null;

                        /**
                         * TargetImpressionShare cpcBidCeilingMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpcBidCeilingMicros
                         * @memberof google.ads.googleads.v1.common.TargetImpressionShare
                         * @instance
                         */
                        TargetImpressionShare.prototype.cpcBidCeilingMicros = null;

                        /**
                         * Creates a new TargetImpressionShare instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.TargetImpressionShare
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetImpressionShare=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.TargetImpressionShare} TargetImpressionShare instance
                         */
                        TargetImpressionShare.create = function create(properties) {
                            return new TargetImpressionShare(properties);
                        };

                        /**
                         * Encodes the specified TargetImpressionShare message. Does not implicitly {@link google.ads.googleads.v1.common.TargetImpressionShare.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.TargetImpressionShare
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetImpressionShare} message TargetImpressionShare message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetImpressionShare.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.location != null && message.hasOwnProperty("location"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.location);
                            if (message.locationFractionMicros != null && message.hasOwnProperty("locationFractionMicros"))
                                $root.google.protobuf.Int64Value.encode(message.locationFractionMicros, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpcBidCeilingMicros, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified TargetImpressionShare message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.TargetImpressionShare.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetImpressionShare
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetImpressionShare} message TargetImpressionShare message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetImpressionShare.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TargetImpressionShare message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.TargetImpressionShare
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.TargetImpressionShare} TargetImpressionShare
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetImpressionShare.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.TargetImpressionShare();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.location = reader.int32();
                                    break;
                                case 2:
                                    message.locationFractionMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TargetImpressionShare message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetImpressionShare
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.TargetImpressionShare} TargetImpressionShare
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetImpressionShare.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TargetImpressionShare message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.TargetImpressionShare
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetImpressionShare.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.location != null && message.hasOwnProperty("location"))
                                switch (message.location) {
                                default:
                                    return "location: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.locationFractionMicros != null && message.hasOwnProperty("locationFractionMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.locationFractionMicros);
                                if (error)
                                    return "locationFractionMicros." + error;
                            }
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpcBidCeilingMicros);
                                if (error)
                                    return "cpcBidCeilingMicros." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a TargetImpressionShare message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.TargetImpressionShare
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.TargetImpressionShare} TargetImpressionShare
                         */
                        TargetImpressionShare.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.TargetImpressionShare)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.TargetImpressionShare();
                            switch (object.location) {
                            case "UNSPECIFIED":
                            case 0:
                                message.location = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.location = 1;
                                break;
                            case "ANYWHERE_ON_PAGE":
                            case 2:
                                message.location = 2;
                                break;
                            case "TOP_OF_PAGE":
                            case 3:
                                message.location = 3;
                                break;
                            case "ABSOLUTE_TOP_OF_PAGE":
                            case 4:
                                message.location = 4;
                                break;
                            }
                            if (object.locationFractionMicros != null) {
                                if (typeof object.locationFractionMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetImpressionShare.locationFractionMicros: object expected");
                                message.locationFractionMicros = $root.google.protobuf.Int64Value.fromObject(object.locationFractionMicros);
                            }
                            if (object.cpcBidCeilingMicros != null) {
                                if (typeof object.cpcBidCeilingMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetImpressionShare.cpcBidCeilingMicros: object expected");
                                message.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.fromObject(object.cpcBidCeilingMicros);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a TargetImpressionShare message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.TargetImpressionShare
                         * @static
                         * @param {google.ads.googleads.v1.common.TargetImpressionShare} message TargetImpressionShare
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetImpressionShare.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.location = options.enums === String ? "UNSPECIFIED" : 0;
                                object.locationFractionMicros = null;
                                object.cpcBidCeilingMicros = null;
                            }
                            if (message.location != null && message.hasOwnProperty("location"))
                                object.location = options.enums === String ? $root.google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum.TargetImpressionShareLocation[message.location] : message.location;
                            if (message.locationFractionMicros != null && message.hasOwnProperty("locationFractionMicros"))
                                object.locationFractionMicros = $root.google.protobuf.Int64Value.toObject(message.locationFractionMicros, options);
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros"))
                                object.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.toObject(message.cpcBidCeilingMicros, options);
                            return object;
                        };

                        /**
                         * Converts this TargetImpressionShare to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.TargetImpressionShare
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetImpressionShare.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return TargetImpressionShare;
                    })();

                    common.TargetOutrankShare = (function() {

                        /**
                         * Properties of a TargetOutrankShare.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ITargetOutrankShare
                         * @property {google.protobuf.IInt32Value|null} [targetOutrankShareMicros] TargetOutrankShare targetOutrankShareMicros
                         * @property {google.protobuf.IStringValue|null} [competitorDomain] TargetOutrankShare competitorDomain
                         * @property {google.protobuf.IInt64Value|null} [cpcBidCeilingMicros] TargetOutrankShare cpcBidCeilingMicros
                         * @property {google.protobuf.IBoolValue|null} [onlyRaiseCpcBids] TargetOutrankShare onlyRaiseCpcBids
                         * @property {google.protobuf.IBoolValue|null} [raiseCpcBidWhenQualityScoreIsLow] TargetOutrankShare raiseCpcBidWhenQualityScoreIsLow
                         */

                        /**
                         * Constructs a new TargetOutrankShare.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a TargetOutrankShare.
                         * @implements ITargetOutrankShare
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ITargetOutrankShare=} [properties] Properties to set
                         */
                        function TargetOutrankShare(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * TargetOutrankShare targetOutrankShareMicros.
                         * @member {google.protobuf.IInt32Value|null|undefined} targetOutrankShareMicros
                         * @memberof google.ads.googleads.v1.common.TargetOutrankShare
                         * @instance
                         */
                        TargetOutrankShare.prototype.targetOutrankShareMicros = null;

                        /**
                         * TargetOutrankShare competitorDomain.
                         * @member {google.protobuf.IStringValue|null|undefined} competitorDomain
                         * @memberof google.ads.googleads.v1.common.TargetOutrankShare
                         * @instance
                         */
                        TargetOutrankShare.prototype.competitorDomain = null;

                        /**
                         * TargetOutrankShare cpcBidCeilingMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpcBidCeilingMicros
                         * @memberof google.ads.googleads.v1.common.TargetOutrankShare
                         * @instance
                         */
                        TargetOutrankShare.prototype.cpcBidCeilingMicros = null;

                        /**
                         * TargetOutrankShare onlyRaiseCpcBids.
                         * @member {google.protobuf.IBoolValue|null|undefined} onlyRaiseCpcBids
                         * @memberof google.ads.googleads.v1.common.TargetOutrankShare
                         * @instance
                         */
                        TargetOutrankShare.prototype.onlyRaiseCpcBids = null;

                        /**
                         * TargetOutrankShare raiseCpcBidWhenQualityScoreIsLow.
                         * @member {google.protobuf.IBoolValue|null|undefined} raiseCpcBidWhenQualityScoreIsLow
                         * @memberof google.ads.googleads.v1.common.TargetOutrankShare
                         * @instance
                         */
                        TargetOutrankShare.prototype.raiseCpcBidWhenQualityScoreIsLow = null;

                        /**
                         * Creates a new TargetOutrankShare instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.TargetOutrankShare
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetOutrankShare=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.TargetOutrankShare} TargetOutrankShare instance
                         */
                        TargetOutrankShare.create = function create(properties) {
                            return new TargetOutrankShare(properties);
                        };

                        /**
                         * Encodes the specified TargetOutrankShare message. Does not implicitly {@link google.ads.googleads.v1.common.TargetOutrankShare.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.TargetOutrankShare
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetOutrankShare} message TargetOutrankShare message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetOutrankShare.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetOutrankShareMicros != null && message.hasOwnProperty("targetOutrankShareMicros"))
                                $root.google.protobuf.Int32Value.encode(message.targetOutrankShareMicros, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.competitorDomain != null && message.hasOwnProperty("competitorDomain"))
                                $root.google.protobuf.StringValue.encode(message.competitorDomain, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpcBidCeilingMicros, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.onlyRaiseCpcBids != null && message.hasOwnProperty("onlyRaiseCpcBids"))
                                $root.google.protobuf.BoolValue.encode(message.onlyRaiseCpcBids, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.raiseCpcBidWhenQualityScoreIsLow != null && message.hasOwnProperty("raiseCpcBidWhenQualityScoreIsLow"))
                                $root.google.protobuf.BoolValue.encode(message.raiseCpcBidWhenQualityScoreIsLow, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified TargetOutrankShare message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.TargetOutrankShare.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetOutrankShare
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetOutrankShare} message TargetOutrankShare message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetOutrankShare.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TargetOutrankShare message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.TargetOutrankShare
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.TargetOutrankShare} TargetOutrankShare
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetOutrankShare.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.TargetOutrankShare();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.targetOutrankShareMicros = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.competitorDomain = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.onlyRaiseCpcBids = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.raiseCpcBidWhenQualityScoreIsLow = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TargetOutrankShare message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetOutrankShare
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.TargetOutrankShare} TargetOutrankShare
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetOutrankShare.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TargetOutrankShare message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.TargetOutrankShare
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetOutrankShare.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.targetOutrankShareMicros != null && message.hasOwnProperty("targetOutrankShareMicros")) {
                                var error = $root.google.protobuf.Int32Value.verify(message.targetOutrankShareMicros);
                                if (error)
                                    return "targetOutrankShareMicros." + error;
                            }
                            if (message.competitorDomain != null && message.hasOwnProperty("competitorDomain")) {
                                var error = $root.google.protobuf.StringValue.verify(message.competitorDomain);
                                if (error)
                                    return "competitorDomain." + error;
                            }
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpcBidCeilingMicros);
                                if (error)
                                    return "cpcBidCeilingMicros." + error;
                            }
                            if (message.onlyRaiseCpcBids != null && message.hasOwnProperty("onlyRaiseCpcBids")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.onlyRaiseCpcBids);
                                if (error)
                                    return "onlyRaiseCpcBids." + error;
                            }
                            if (message.raiseCpcBidWhenQualityScoreIsLow != null && message.hasOwnProperty("raiseCpcBidWhenQualityScoreIsLow")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.raiseCpcBidWhenQualityScoreIsLow);
                                if (error)
                                    return "raiseCpcBidWhenQualityScoreIsLow." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a TargetOutrankShare message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.TargetOutrankShare
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.TargetOutrankShare} TargetOutrankShare
                         */
                        TargetOutrankShare.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.TargetOutrankShare)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.TargetOutrankShare();
                            if (object.targetOutrankShareMicros != null) {
                                if (typeof object.targetOutrankShareMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetOutrankShare.targetOutrankShareMicros: object expected");
                                message.targetOutrankShareMicros = $root.google.protobuf.Int32Value.fromObject(object.targetOutrankShareMicros);
                            }
                            if (object.competitorDomain != null) {
                                if (typeof object.competitorDomain !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetOutrankShare.competitorDomain: object expected");
                                message.competitorDomain = $root.google.protobuf.StringValue.fromObject(object.competitorDomain);
                            }
                            if (object.cpcBidCeilingMicros != null) {
                                if (typeof object.cpcBidCeilingMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetOutrankShare.cpcBidCeilingMicros: object expected");
                                message.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.fromObject(object.cpcBidCeilingMicros);
                            }
                            if (object.onlyRaiseCpcBids != null) {
                                if (typeof object.onlyRaiseCpcBids !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetOutrankShare.onlyRaiseCpcBids: object expected");
                                message.onlyRaiseCpcBids = $root.google.protobuf.BoolValue.fromObject(object.onlyRaiseCpcBids);
                            }
                            if (object.raiseCpcBidWhenQualityScoreIsLow != null) {
                                if (typeof object.raiseCpcBidWhenQualityScoreIsLow !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetOutrankShare.raiseCpcBidWhenQualityScoreIsLow: object expected");
                                message.raiseCpcBidWhenQualityScoreIsLow = $root.google.protobuf.BoolValue.fromObject(object.raiseCpcBidWhenQualityScoreIsLow);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a TargetOutrankShare message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.TargetOutrankShare
                         * @static
                         * @param {google.ads.googleads.v1.common.TargetOutrankShare} message TargetOutrankShare
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetOutrankShare.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetOutrankShareMicros = null;
                                object.competitorDomain = null;
                                object.cpcBidCeilingMicros = null;
                                object.onlyRaiseCpcBids = null;
                                object.raiseCpcBidWhenQualityScoreIsLow = null;
                            }
                            if (message.targetOutrankShareMicros != null && message.hasOwnProperty("targetOutrankShareMicros"))
                                object.targetOutrankShareMicros = $root.google.protobuf.Int32Value.toObject(message.targetOutrankShareMicros, options);
                            if (message.competitorDomain != null && message.hasOwnProperty("competitorDomain"))
                                object.competitorDomain = $root.google.protobuf.StringValue.toObject(message.competitorDomain, options);
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros"))
                                object.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.toObject(message.cpcBidCeilingMicros, options);
                            if (message.onlyRaiseCpcBids != null && message.hasOwnProperty("onlyRaiseCpcBids"))
                                object.onlyRaiseCpcBids = $root.google.protobuf.BoolValue.toObject(message.onlyRaiseCpcBids, options);
                            if (message.raiseCpcBidWhenQualityScoreIsLow != null && message.hasOwnProperty("raiseCpcBidWhenQualityScoreIsLow"))
                                object.raiseCpcBidWhenQualityScoreIsLow = $root.google.protobuf.BoolValue.toObject(message.raiseCpcBidWhenQualityScoreIsLow, options);
                            return object;
                        };

                        /**
                         * Converts this TargetOutrankShare to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.TargetOutrankShare
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetOutrankShare.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return TargetOutrankShare;
                    })();

                    common.TargetRoas = (function() {

                        /**
                         * Properties of a TargetRoas.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ITargetRoas
                         * @property {google.protobuf.IDoubleValue|null} [targetRoas] TargetRoas targetRoas
                         * @property {google.protobuf.IInt64Value|null} [cpcBidCeilingMicros] TargetRoas cpcBidCeilingMicros
                         * @property {google.protobuf.IInt64Value|null} [cpcBidFloorMicros] TargetRoas cpcBidFloorMicros
                         */

                        /**
                         * Constructs a new TargetRoas.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a TargetRoas.
                         * @implements ITargetRoas
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ITargetRoas=} [properties] Properties to set
                         */
                        function TargetRoas(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * TargetRoas targetRoas.
                         * @member {google.protobuf.IDoubleValue|null|undefined} targetRoas
                         * @memberof google.ads.googleads.v1.common.TargetRoas
                         * @instance
                         */
                        TargetRoas.prototype.targetRoas = null;

                        /**
                         * TargetRoas cpcBidCeilingMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpcBidCeilingMicros
                         * @memberof google.ads.googleads.v1.common.TargetRoas
                         * @instance
                         */
                        TargetRoas.prototype.cpcBidCeilingMicros = null;

                        /**
                         * TargetRoas cpcBidFloorMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpcBidFloorMicros
                         * @memberof google.ads.googleads.v1.common.TargetRoas
                         * @instance
                         */
                        TargetRoas.prototype.cpcBidFloorMicros = null;

                        /**
                         * Creates a new TargetRoas instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.TargetRoas
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetRoas=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.TargetRoas} TargetRoas instance
                         */
                        TargetRoas.create = function create(properties) {
                            return new TargetRoas(properties);
                        };

                        /**
                         * Encodes the specified TargetRoas message. Does not implicitly {@link google.ads.googleads.v1.common.TargetRoas.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.TargetRoas
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetRoas} message TargetRoas message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetRoas.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetRoas != null && message.hasOwnProperty("targetRoas"))
                                $root.google.protobuf.DoubleValue.encode(message.targetRoas, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpcBidCeilingMicros, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.cpcBidFloorMicros != null && message.hasOwnProperty("cpcBidFloorMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpcBidFloorMicros, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified TargetRoas message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.TargetRoas.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetRoas
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetRoas} message TargetRoas message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetRoas.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TargetRoas message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.TargetRoas
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.TargetRoas} TargetRoas
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetRoas.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.TargetRoas();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.targetRoas = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.cpcBidFloorMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TargetRoas message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetRoas
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.TargetRoas} TargetRoas
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetRoas.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TargetRoas message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.TargetRoas
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetRoas.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.targetRoas != null && message.hasOwnProperty("targetRoas")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.targetRoas);
                                if (error)
                                    return "targetRoas." + error;
                            }
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpcBidCeilingMicros);
                                if (error)
                                    return "cpcBidCeilingMicros." + error;
                            }
                            if (message.cpcBidFloorMicros != null && message.hasOwnProperty("cpcBidFloorMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpcBidFloorMicros);
                                if (error)
                                    return "cpcBidFloorMicros." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a TargetRoas message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.TargetRoas
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.TargetRoas} TargetRoas
                         */
                        TargetRoas.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.TargetRoas)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.TargetRoas();
                            if (object.targetRoas != null) {
                                if (typeof object.targetRoas !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetRoas.targetRoas: object expected");
                                message.targetRoas = $root.google.protobuf.DoubleValue.fromObject(object.targetRoas);
                            }
                            if (object.cpcBidCeilingMicros != null) {
                                if (typeof object.cpcBidCeilingMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetRoas.cpcBidCeilingMicros: object expected");
                                message.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.fromObject(object.cpcBidCeilingMicros);
                            }
                            if (object.cpcBidFloorMicros != null) {
                                if (typeof object.cpcBidFloorMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetRoas.cpcBidFloorMicros: object expected");
                                message.cpcBidFloorMicros = $root.google.protobuf.Int64Value.fromObject(object.cpcBidFloorMicros);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a TargetRoas message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.TargetRoas
                         * @static
                         * @param {google.ads.googleads.v1.common.TargetRoas} message TargetRoas
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetRoas.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetRoas = null;
                                object.cpcBidCeilingMicros = null;
                                object.cpcBidFloorMicros = null;
                            }
                            if (message.targetRoas != null && message.hasOwnProperty("targetRoas"))
                                object.targetRoas = $root.google.protobuf.DoubleValue.toObject(message.targetRoas, options);
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros"))
                                object.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.toObject(message.cpcBidCeilingMicros, options);
                            if (message.cpcBidFloorMicros != null && message.hasOwnProperty("cpcBidFloorMicros"))
                                object.cpcBidFloorMicros = $root.google.protobuf.Int64Value.toObject(message.cpcBidFloorMicros, options);
                            return object;
                        };

                        /**
                         * Converts this TargetRoas to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.TargetRoas
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetRoas.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return TargetRoas;
                    })();

                    common.TargetSpend = (function() {

                        /**
                         * Properties of a TargetSpend.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ITargetSpend
                         * @property {google.protobuf.IInt64Value|null} [targetSpendMicros] TargetSpend targetSpendMicros
                         * @property {google.protobuf.IInt64Value|null} [cpcBidCeilingMicros] TargetSpend cpcBidCeilingMicros
                         */

                        /**
                         * Constructs a new TargetSpend.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a TargetSpend.
                         * @implements ITargetSpend
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ITargetSpend=} [properties] Properties to set
                         */
                        function TargetSpend(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * TargetSpend targetSpendMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} targetSpendMicros
                         * @memberof google.ads.googleads.v1.common.TargetSpend
                         * @instance
                         */
                        TargetSpend.prototype.targetSpendMicros = null;

                        /**
                         * TargetSpend cpcBidCeilingMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpcBidCeilingMicros
                         * @memberof google.ads.googleads.v1.common.TargetSpend
                         * @instance
                         */
                        TargetSpend.prototype.cpcBidCeilingMicros = null;

                        /**
                         * Creates a new TargetSpend instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.TargetSpend
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetSpend=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.TargetSpend} TargetSpend instance
                         */
                        TargetSpend.create = function create(properties) {
                            return new TargetSpend(properties);
                        };

                        /**
                         * Encodes the specified TargetSpend message. Does not implicitly {@link google.ads.googleads.v1.common.TargetSpend.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.TargetSpend
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetSpend} message TargetSpend message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetSpend.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetSpendMicros != null && message.hasOwnProperty("targetSpendMicros"))
                                $root.google.protobuf.Int64Value.encode(message.targetSpendMicros, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpcBidCeilingMicros, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified TargetSpend message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.TargetSpend.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetSpend
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetSpend} message TargetSpend message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetSpend.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TargetSpend message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.TargetSpend
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.TargetSpend} TargetSpend
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetSpend.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.TargetSpend();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.targetSpendMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TargetSpend message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetSpend
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.TargetSpend} TargetSpend
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetSpend.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TargetSpend message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.TargetSpend
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetSpend.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.targetSpendMicros != null && message.hasOwnProperty("targetSpendMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.targetSpendMicros);
                                if (error)
                                    return "targetSpendMicros." + error;
                            }
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpcBidCeilingMicros);
                                if (error)
                                    return "cpcBidCeilingMicros." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a TargetSpend message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.TargetSpend
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.TargetSpend} TargetSpend
                         */
                        TargetSpend.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.TargetSpend)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.TargetSpend();
                            if (object.targetSpendMicros != null) {
                                if (typeof object.targetSpendMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetSpend.targetSpendMicros: object expected");
                                message.targetSpendMicros = $root.google.protobuf.Int64Value.fromObject(object.targetSpendMicros);
                            }
                            if (object.cpcBidCeilingMicros != null) {
                                if (typeof object.cpcBidCeilingMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetSpend.cpcBidCeilingMicros: object expected");
                                message.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.fromObject(object.cpcBidCeilingMicros);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a TargetSpend message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.TargetSpend
                         * @static
                         * @param {google.ads.googleads.v1.common.TargetSpend} message TargetSpend
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetSpend.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetSpendMicros = null;
                                object.cpcBidCeilingMicros = null;
                            }
                            if (message.targetSpendMicros != null && message.hasOwnProperty("targetSpendMicros"))
                                object.targetSpendMicros = $root.google.protobuf.Int64Value.toObject(message.targetSpendMicros, options);
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros"))
                                object.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.toObject(message.cpcBidCeilingMicros, options);
                            return object;
                        };

                        /**
                         * Converts this TargetSpend to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.TargetSpend
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetSpend.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return TargetSpend;
                    })();

                    common.PercentCpc = (function() {

                        /**
                         * Properties of a PercentCpc.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IPercentCpc
                         * @property {google.protobuf.IInt64Value|null} [cpcBidCeilingMicros] PercentCpc cpcBidCeilingMicros
                         * @property {google.protobuf.IBoolValue|null} [enhancedCpcEnabled] PercentCpc enhancedCpcEnabled
                         */

                        /**
                         * Constructs a new PercentCpc.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a PercentCpc.
                         * @implements IPercentCpc
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IPercentCpc=} [properties] Properties to set
                         */
                        function PercentCpc(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * PercentCpc cpcBidCeilingMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpcBidCeilingMicros
                         * @memberof google.ads.googleads.v1.common.PercentCpc
                         * @instance
                         */
                        PercentCpc.prototype.cpcBidCeilingMicros = null;

                        /**
                         * PercentCpc enhancedCpcEnabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} enhancedCpcEnabled
                         * @memberof google.ads.googleads.v1.common.PercentCpc
                         * @instance
                         */
                        PercentCpc.prototype.enhancedCpcEnabled = null;

                        /**
                         * Creates a new PercentCpc instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.PercentCpc
                         * @static
                         * @param {google.ads.googleads.v1.common.IPercentCpc=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.PercentCpc} PercentCpc instance
                         */
                        PercentCpc.create = function create(properties) {
                            return new PercentCpc(properties);
                        };

                        /**
                         * Encodes the specified PercentCpc message. Does not implicitly {@link google.ads.googleads.v1.common.PercentCpc.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.PercentCpc
                         * @static
                         * @param {google.ads.googleads.v1.common.IPercentCpc} message PercentCpc message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PercentCpc.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpcBidCeilingMicros, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.enhancedCpcEnabled != null && message.hasOwnProperty("enhancedCpcEnabled"))
                                $root.google.protobuf.BoolValue.encode(message.enhancedCpcEnabled, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified PercentCpc message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PercentCpc.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.PercentCpc
                         * @static
                         * @param {google.ads.googleads.v1.common.IPercentCpc} message PercentCpc message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PercentCpc.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PercentCpc message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.PercentCpc
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.PercentCpc} PercentCpc
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PercentCpc.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PercentCpc();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.enhancedCpcEnabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PercentCpc message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.PercentCpc
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.PercentCpc} PercentCpc
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PercentCpc.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PercentCpc message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.PercentCpc
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PercentCpc.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpcBidCeilingMicros);
                                if (error)
                                    return "cpcBidCeilingMicros." + error;
                            }
                            if (message.enhancedCpcEnabled != null && message.hasOwnProperty("enhancedCpcEnabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.enhancedCpcEnabled);
                                if (error)
                                    return "enhancedCpcEnabled." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a PercentCpc message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.PercentCpc
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.PercentCpc} PercentCpc
                         */
                        PercentCpc.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.PercentCpc)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.PercentCpc();
                            if (object.cpcBidCeilingMicros != null) {
                                if (typeof object.cpcBidCeilingMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PercentCpc.cpcBidCeilingMicros: object expected");
                                message.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.fromObject(object.cpcBidCeilingMicros);
                            }
                            if (object.enhancedCpcEnabled != null) {
                                if (typeof object.enhancedCpcEnabled !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PercentCpc.enhancedCpcEnabled: object expected");
                                message.enhancedCpcEnabled = $root.google.protobuf.BoolValue.fromObject(object.enhancedCpcEnabled);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a PercentCpc message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.PercentCpc
                         * @static
                         * @param {google.ads.googleads.v1.common.PercentCpc} message PercentCpc
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PercentCpc.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.cpcBidCeilingMicros = null;
                                object.enhancedCpcEnabled = null;
                            }
                            if (message.cpcBidCeilingMicros != null && message.hasOwnProperty("cpcBidCeilingMicros"))
                                object.cpcBidCeilingMicros = $root.google.protobuf.Int64Value.toObject(message.cpcBidCeilingMicros, options);
                            if (message.enhancedCpcEnabled != null && message.hasOwnProperty("enhancedCpcEnabled"))
                                object.enhancedCpcEnabled = $root.google.protobuf.BoolValue.toObject(message.enhancedCpcEnabled, options);
                            return object;
                        };

                        /**
                         * Converts this PercentCpc to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.PercentCpc
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PercentCpc.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return PercentCpc;
                    })();

                    common.ClickLocation = (function() {

                        /**
                         * Properties of a ClickLocation.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IClickLocation
                         * @property {google.protobuf.IStringValue|null} [city] ClickLocation city
                         * @property {google.protobuf.IStringValue|null} [country] ClickLocation country
                         * @property {google.protobuf.IStringValue|null} [metro] ClickLocation metro
                         * @property {google.protobuf.IStringValue|null} [mostSpecific] ClickLocation mostSpecific
                         * @property {google.protobuf.IStringValue|null} [region] ClickLocation region
                         */

                        /**
                         * Constructs a new ClickLocation.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ClickLocation.
                         * @implements IClickLocation
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IClickLocation=} [properties] Properties to set
                         */
                        function ClickLocation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ClickLocation city.
                         * @member {google.protobuf.IStringValue|null|undefined} city
                         * @memberof google.ads.googleads.v1.common.ClickLocation
                         * @instance
                         */
                        ClickLocation.prototype.city = null;

                        /**
                         * ClickLocation country.
                         * @member {google.protobuf.IStringValue|null|undefined} country
                         * @memberof google.ads.googleads.v1.common.ClickLocation
                         * @instance
                         */
                        ClickLocation.prototype.country = null;

                        /**
                         * ClickLocation metro.
                         * @member {google.protobuf.IStringValue|null|undefined} metro
                         * @memberof google.ads.googleads.v1.common.ClickLocation
                         * @instance
                         */
                        ClickLocation.prototype.metro = null;

                        /**
                         * ClickLocation mostSpecific.
                         * @member {google.protobuf.IStringValue|null|undefined} mostSpecific
                         * @memberof google.ads.googleads.v1.common.ClickLocation
                         * @instance
                         */
                        ClickLocation.prototype.mostSpecific = null;

                        /**
                         * ClickLocation region.
                         * @member {google.protobuf.IStringValue|null|undefined} region
                         * @memberof google.ads.googleads.v1.common.ClickLocation
                         * @instance
                         */
                        ClickLocation.prototype.region = null;

                        /**
                         * Creates a new ClickLocation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ClickLocation
                         * @static
                         * @param {google.ads.googleads.v1.common.IClickLocation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ClickLocation} ClickLocation instance
                         */
                        ClickLocation.create = function create(properties) {
                            return new ClickLocation(properties);
                        };

                        /**
                         * Encodes the specified ClickLocation message. Does not implicitly {@link google.ads.googleads.v1.common.ClickLocation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ClickLocation
                         * @static
                         * @param {google.ads.googleads.v1.common.IClickLocation} message ClickLocation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ClickLocation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.city != null && message.hasOwnProperty("city"))
                                $root.google.protobuf.StringValue.encode(message.city, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.country != null && message.hasOwnProperty("country"))
                                $root.google.protobuf.StringValue.encode(message.country, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.metro != null && message.hasOwnProperty("metro"))
                                $root.google.protobuf.StringValue.encode(message.metro, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.mostSpecific != null && message.hasOwnProperty("mostSpecific"))
                                $root.google.protobuf.StringValue.encode(message.mostSpecific, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.region != null && message.hasOwnProperty("region"))
                                $root.google.protobuf.StringValue.encode(message.region, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ClickLocation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ClickLocation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ClickLocation
                         * @static
                         * @param {google.ads.googleads.v1.common.IClickLocation} message ClickLocation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ClickLocation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ClickLocation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ClickLocation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ClickLocation} ClickLocation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ClickLocation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ClickLocation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.city = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.country = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.metro = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.mostSpecific = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.region = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ClickLocation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ClickLocation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ClickLocation} ClickLocation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ClickLocation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ClickLocation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ClickLocation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ClickLocation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.city != null && message.hasOwnProperty("city")) {
                                var error = $root.google.protobuf.StringValue.verify(message.city);
                                if (error)
                                    return "city." + error;
                            }
                            if (message.country != null && message.hasOwnProperty("country")) {
                                var error = $root.google.protobuf.StringValue.verify(message.country);
                                if (error)
                                    return "country." + error;
                            }
                            if (message.metro != null && message.hasOwnProperty("metro")) {
                                var error = $root.google.protobuf.StringValue.verify(message.metro);
                                if (error)
                                    return "metro." + error;
                            }
                            if (message.mostSpecific != null && message.hasOwnProperty("mostSpecific")) {
                                var error = $root.google.protobuf.StringValue.verify(message.mostSpecific);
                                if (error)
                                    return "mostSpecific." + error;
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                var error = $root.google.protobuf.StringValue.verify(message.region);
                                if (error)
                                    return "region." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a ClickLocation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ClickLocation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ClickLocation} ClickLocation
                         */
                        ClickLocation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ClickLocation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ClickLocation();
                            if (object.city != null) {
                                if (typeof object.city !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ClickLocation.city: object expected");
                                message.city = $root.google.protobuf.StringValue.fromObject(object.city);
                            }
                            if (object.country != null) {
                                if (typeof object.country !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ClickLocation.country: object expected");
                                message.country = $root.google.protobuf.StringValue.fromObject(object.country);
                            }
                            if (object.metro != null) {
                                if (typeof object.metro !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ClickLocation.metro: object expected");
                                message.metro = $root.google.protobuf.StringValue.fromObject(object.metro);
                            }
                            if (object.mostSpecific != null) {
                                if (typeof object.mostSpecific !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ClickLocation.mostSpecific: object expected");
                                message.mostSpecific = $root.google.protobuf.StringValue.fromObject(object.mostSpecific);
                            }
                            if (object.region != null) {
                                if (typeof object.region !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ClickLocation.region: object expected");
                                message.region = $root.google.protobuf.StringValue.fromObject(object.region);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ClickLocation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ClickLocation
                         * @static
                         * @param {google.ads.googleads.v1.common.ClickLocation} message ClickLocation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ClickLocation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.city = null;
                                object.country = null;
                                object.metro = null;
                                object.mostSpecific = null;
                                object.region = null;
                            }
                            if (message.city != null && message.hasOwnProperty("city"))
                                object.city = $root.google.protobuf.StringValue.toObject(message.city, options);
                            if (message.country != null && message.hasOwnProperty("country"))
                                object.country = $root.google.protobuf.StringValue.toObject(message.country, options);
                            if (message.metro != null && message.hasOwnProperty("metro"))
                                object.metro = $root.google.protobuf.StringValue.toObject(message.metro, options);
                            if (message.mostSpecific != null && message.hasOwnProperty("mostSpecific"))
                                object.mostSpecific = $root.google.protobuf.StringValue.toObject(message.mostSpecific, options);
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = $root.google.protobuf.StringValue.toObject(message.region, options);
                            return object;
                        };

                        /**
                         * Converts this ClickLocation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ClickLocation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ClickLocation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ClickLocation;
                    })();

                    common.KeywordInfo = (function() {

                        /**
                         * Properties of a KeywordInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IKeywordInfo
                         * @property {google.protobuf.IStringValue|null} [text] KeywordInfo text
                         * @property {google.ads.googleads.v1.enums.KeywordMatchTypeEnum.KeywordMatchType|null} [matchType] KeywordInfo matchType
                         */

                        /**
                         * Constructs a new KeywordInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a KeywordInfo.
                         * @implements IKeywordInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IKeywordInfo=} [properties] Properties to set
                         */
                        function KeywordInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordInfo text.
                         * @member {google.protobuf.IStringValue|null|undefined} text
                         * @memberof google.ads.googleads.v1.common.KeywordInfo
                         * @instance
                         */
                        KeywordInfo.prototype.text = null;

                        /**
                         * KeywordInfo matchType.
                         * @member {google.ads.googleads.v1.enums.KeywordMatchTypeEnum.KeywordMatchType} matchType
                         * @memberof google.ads.googleads.v1.common.KeywordInfo
                         * @instance
                         */
                        KeywordInfo.prototype.matchType = 0;

                        /**
                         * Creates a new KeywordInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.KeywordInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IKeywordInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.KeywordInfo} KeywordInfo instance
                         */
                        KeywordInfo.create = function create(properties) {
                            return new KeywordInfo(properties);
                        };

                        /**
                         * Encodes the specified KeywordInfo message. Does not implicitly {@link google.ads.googleads.v1.common.KeywordInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.KeywordInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IKeywordInfo} message KeywordInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.text != null && message.hasOwnProperty("text"))
                                $root.google.protobuf.StringValue.encode(message.text, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.matchType != null && message.hasOwnProperty("matchType"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.matchType);
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.KeywordInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.KeywordInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IKeywordInfo} message KeywordInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.KeywordInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.KeywordInfo} KeywordInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.KeywordInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.text = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.matchType = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.KeywordInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.KeywordInfo} KeywordInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.KeywordInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.text != null && message.hasOwnProperty("text")) {
                                var error = $root.google.protobuf.StringValue.verify(message.text);
                                if (error)
                                    return "text." + error;
                            }
                            if (message.matchType != null && message.hasOwnProperty("matchType"))
                                switch (message.matchType) {
                                default:
                                    return "matchType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a KeywordInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.KeywordInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.KeywordInfo} KeywordInfo
                         */
                        KeywordInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.KeywordInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.KeywordInfo();
                            if (object.text != null) {
                                if (typeof object.text !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.KeywordInfo.text: object expected");
                                message.text = $root.google.protobuf.StringValue.fromObject(object.text);
                            }
                            switch (object.matchType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.matchType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.matchType = 1;
                                break;
                            case "EXACT":
                            case 2:
                                message.matchType = 2;
                                break;
                            case "PHRASE":
                            case 3:
                                message.matchType = 3;
                                break;
                            case "BROAD":
                            case 4:
                                message.matchType = 4;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.KeywordInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.KeywordInfo} message KeywordInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.text = null;
                                object.matchType = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.text != null && message.hasOwnProperty("text"))
                                object.text = $root.google.protobuf.StringValue.toObject(message.text, options);
                            if (message.matchType != null && message.hasOwnProperty("matchType"))
                                object.matchType = options.enums === String ? $root.google.ads.googleads.v1.enums.KeywordMatchTypeEnum.KeywordMatchType[message.matchType] : message.matchType;
                            return object;
                        };

                        /**
                         * Converts this KeywordInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.KeywordInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordInfo;
                    })();

                    common.PlacementInfo = (function() {

                        /**
                         * Properties of a PlacementInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IPlacementInfo
                         * @property {google.protobuf.IStringValue|null} [url] PlacementInfo url
                         */

                        /**
                         * Constructs a new PlacementInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a PlacementInfo.
                         * @implements IPlacementInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IPlacementInfo=} [properties] Properties to set
                         */
                        function PlacementInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * PlacementInfo url.
                         * @member {google.protobuf.IStringValue|null|undefined} url
                         * @memberof google.ads.googleads.v1.common.PlacementInfo
                         * @instance
                         */
                        PlacementInfo.prototype.url = null;

                        /**
                         * Creates a new PlacementInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.PlacementInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IPlacementInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.PlacementInfo} PlacementInfo instance
                         */
                        PlacementInfo.create = function create(properties) {
                            return new PlacementInfo(properties);
                        };

                        /**
                         * Encodes the specified PlacementInfo message. Does not implicitly {@link google.ads.googleads.v1.common.PlacementInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.PlacementInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IPlacementInfo} message PlacementInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PlacementInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.url != null && message.hasOwnProperty("url"))
                                $root.google.protobuf.StringValue.encode(message.url, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified PlacementInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PlacementInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.PlacementInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IPlacementInfo} message PlacementInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PlacementInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PlacementInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.PlacementInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.PlacementInfo} PlacementInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PlacementInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PlacementInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.url = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PlacementInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.PlacementInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.PlacementInfo} PlacementInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PlacementInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PlacementInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.PlacementInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PlacementInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.url != null && message.hasOwnProperty("url")) {
                                var error = $root.google.protobuf.StringValue.verify(message.url);
                                if (error)
                                    return "url." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a PlacementInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.PlacementInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.PlacementInfo} PlacementInfo
                         */
                        PlacementInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.PlacementInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.PlacementInfo();
                            if (object.url != null) {
                                if (typeof object.url !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PlacementInfo.url: object expected");
                                message.url = $root.google.protobuf.StringValue.fromObject(object.url);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a PlacementInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.PlacementInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.PlacementInfo} message PlacementInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PlacementInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.url = null;
                            if (message.url != null && message.hasOwnProperty("url"))
                                object.url = $root.google.protobuf.StringValue.toObject(message.url, options);
                            return object;
                        };

                        /**
                         * Converts this PlacementInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.PlacementInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PlacementInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return PlacementInfo;
                    })();

                    common.MobileAppCategoryInfo = (function() {

                        /**
                         * Properties of a MobileAppCategoryInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IMobileAppCategoryInfo
                         * @property {google.protobuf.IStringValue|null} [mobileAppCategoryConstant] MobileAppCategoryInfo mobileAppCategoryConstant
                         */

                        /**
                         * Constructs a new MobileAppCategoryInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a MobileAppCategoryInfo.
                         * @implements IMobileAppCategoryInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IMobileAppCategoryInfo=} [properties] Properties to set
                         */
                        function MobileAppCategoryInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MobileAppCategoryInfo mobileAppCategoryConstant.
                         * @member {google.protobuf.IStringValue|null|undefined} mobileAppCategoryConstant
                         * @memberof google.ads.googleads.v1.common.MobileAppCategoryInfo
                         * @instance
                         */
                        MobileAppCategoryInfo.prototype.mobileAppCategoryConstant = null;

                        /**
                         * Creates a new MobileAppCategoryInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.MobileAppCategoryInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IMobileAppCategoryInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.MobileAppCategoryInfo} MobileAppCategoryInfo instance
                         */
                        MobileAppCategoryInfo.create = function create(properties) {
                            return new MobileAppCategoryInfo(properties);
                        };

                        /**
                         * Encodes the specified MobileAppCategoryInfo message. Does not implicitly {@link google.ads.googleads.v1.common.MobileAppCategoryInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.MobileAppCategoryInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IMobileAppCategoryInfo} message MobileAppCategoryInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MobileAppCategoryInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.mobileAppCategoryConstant != null && message.hasOwnProperty("mobileAppCategoryConstant"))
                                $root.google.protobuf.StringValue.encode(message.mobileAppCategoryConstant, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MobileAppCategoryInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.MobileAppCategoryInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.MobileAppCategoryInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IMobileAppCategoryInfo} message MobileAppCategoryInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MobileAppCategoryInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MobileAppCategoryInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.MobileAppCategoryInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.MobileAppCategoryInfo} MobileAppCategoryInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MobileAppCategoryInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.MobileAppCategoryInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.mobileAppCategoryConstant = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MobileAppCategoryInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.MobileAppCategoryInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.MobileAppCategoryInfo} MobileAppCategoryInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MobileAppCategoryInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MobileAppCategoryInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.MobileAppCategoryInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MobileAppCategoryInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.mobileAppCategoryConstant != null && message.hasOwnProperty("mobileAppCategoryConstant")) {
                                var error = $root.google.protobuf.StringValue.verify(message.mobileAppCategoryConstant);
                                if (error)
                                    return "mobileAppCategoryConstant." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MobileAppCategoryInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.MobileAppCategoryInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.MobileAppCategoryInfo} MobileAppCategoryInfo
                         */
                        MobileAppCategoryInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.MobileAppCategoryInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.MobileAppCategoryInfo();
                            if (object.mobileAppCategoryConstant != null) {
                                if (typeof object.mobileAppCategoryConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.MobileAppCategoryInfo.mobileAppCategoryConstant: object expected");
                                message.mobileAppCategoryConstant = $root.google.protobuf.StringValue.fromObject(object.mobileAppCategoryConstant);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MobileAppCategoryInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.MobileAppCategoryInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.MobileAppCategoryInfo} message MobileAppCategoryInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MobileAppCategoryInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.mobileAppCategoryConstant = null;
                            if (message.mobileAppCategoryConstant != null && message.hasOwnProperty("mobileAppCategoryConstant"))
                                object.mobileAppCategoryConstant = $root.google.protobuf.StringValue.toObject(message.mobileAppCategoryConstant, options);
                            return object;
                        };

                        /**
                         * Converts this MobileAppCategoryInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.MobileAppCategoryInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MobileAppCategoryInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MobileAppCategoryInfo;
                    })();

                    common.MobileApplicationInfo = (function() {

                        /**
                         * Properties of a MobileApplicationInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IMobileApplicationInfo
                         * @property {google.protobuf.IStringValue|null} [appId] MobileApplicationInfo appId
                         * @property {google.protobuf.IStringValue|null} [name] MobileApplicationInfo name
                         */

                        /**
                         * Constructs a new MobileApplicationInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a MobileApplicationInfo.
                         * @implements IMobileApplicationInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IMobileApplicationInfo=} [properties] Properties to set
                         */
                        function MobileApplicationInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MobileApplicationInfo appId.
                         * @member {google.protobuf.IStringValue|null|undefined} appId
                         * @memberof google.ads.googleads.v1.common.MobileApplicationInfo
                         * @instance
                         */
                        MobileApplicationInfo.prototype.appId = null;

                        /**
                         * MobileApplicationInfo name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.common.MobileApplicationInfo
                         * @instance
                         */
                        MobileApplicationInfo.prototype.name = null;

                        /**
                         * Creates a new MobileApplicationInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.MobileApplicationInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IMobileApplicationInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.MobileApplicationInfo} MobileApplicationInfo instance
                         */
                        MobileApplicationInfo.create = function create(properties) {
                            return new MobileApplicationInfo(properties);
                        };

                        /**
                         * Encodes the specified MobileApplicationInfo message. Does not implicitly {@link google.ads.googleads.v1.common.MobileApplicationInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.MobileApplicationInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IMobileApplicationInfo} message MobileApplicationInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MobileApplicationInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.appId != null && message.hasOwnProperty("appId"))
                                $root.google.protobuf.StringValue.encode(message.appId, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MobileApplicationInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.MobileApplicationInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.MobileApplicationInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IMobileApplicationInfo} message MobileApplicationInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MobileApplicationInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MobileApplicationInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.MobileApplicationInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.MobileApplicationInfo} MobileApplicationInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MobileApplicationInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.MobileApplicationInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2:
                                    message.appId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MobileApplicationInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.MobileApplicationInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.MobileApplicationInfo} MobileApplicationInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MobileApplicationInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MobileApplicationInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.MobileApplicationInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MobileApplicationInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.appId != null && message.hasOwnProperty("appId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.appId);
                                if (error)
                                    return "appId." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MobileApplicationInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.MobileApplicationInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.MobileApplicationInfo} MobileApplicationInfo
                         */
                        MobileApplicationInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.MobileApplicationInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.MobileApplicationInfo();
                            if (object.appId != null) {
                                if (typeof object.appId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.MobileApplicationInfo.appId: object expected");
                                message.appId = $root.google.protobuf.StringValue.fromObject(object.appId);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.MobileApplicationInfo.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MobileApplicationInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.MobileApplicationInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.MobileApplicationInfo} message MobileApplicationInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MobileApplicationInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.appId = null;
                                object.name = null;
                            }
                            if (message.appId != null && message.hasOwnProperty("appId"))
                                object.appId = $root.google.protobuf.StringValue.toObject(message.appId, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            return object;
                        };

                        /**
                         * Converts this MobileApplicationInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.MobileApplicationInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MobileApplicationInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MobileApplicationInfo;
                    })();

                    common.LocationInfo = (function() {

                        /**
                         * Properties of a LocationInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ILocationInfo
                         * @property {google.protobuf.IStringValue|null} [geoTargetConstant] LocationInfo geoTargetConstant
                         */

                        /**
                         * Constructs a new LocationInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a LocationInfo.
                         * @implements ILocationInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ILocationInfo=} [properties] Properties to set
                         */
                        function LocationInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * LocationInfo geoTargetConstant.
                         * @member {google.protobuf.IStringValue|null|undefined} geoTargetConstant
                         * @memberof google.ads.googleads.v1.common.LocationInfo
                         * @instance
                         */
                        LocationInfo.prototype.geoTargetConstant = null;

                        /**
                         * Creates a new LocationInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.LocationInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILocationInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.LocationInfo} LocationInfo instance
                         */
                        LocationInfo.create = function create(properties) {
                            return new LocationInfo(properties);
                        };

                        /**
                         * Encodes the specified LocationInfo message. Does not implicitly {@link google.ads.googleads.v1.common.LocationInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.LocationInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILocationInfo} message LocationInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.geoTargetConstant != null && message.hasOwnProperty("geoTargetConstant"))
                                $root.google.protobuf.StringValue.encode(message.geoTargetConstant, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified LocationInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.LocationInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.LocationInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILocationInfo} message LocationInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LocationInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.LocationInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.LocationInfo} LocationInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.LocationInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.geoTargetConstant = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LocationInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.LocationInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.LocationInfo} LocationInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LocationInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.LocationInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LocationInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.geoTargetConstant != null && message.hasOwnProperty("geoTargetConstant")) {
                                var error = $root.google.protobuf.StringValue.verify(message.geoTargetConstant);
                                if (error)
                                    return "geoTargetConstant." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a LocationInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.LocationInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.LocationInfo} LocationInfo
                         */
                        LocationInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.LocationInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.LocationInfo();
                            if (object.geoTargetConstant != null) {
                                if (typeof object.geoTargetConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LocationInfo.geoTargetConstant: object expected");
                                message.geoTargetConstant = $root.google.protobuf.StringValue.fromObject(object.geoTargetConstant);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a LocationInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.LocationInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.LocationInfo} message LocationInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LocationInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.geoTargetConstant = null;
                            if (message.geoTargetConstant != null && message.hasOwnProperty("geoTargetConstant"))
                                object.geoTargetConstant = $root.google.protobuf.StringValue.toObject(message.geoTargetConstant, options);
                            return object;
                        };

                        /**
                         * Converts this LocationInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.LocationInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LocationInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return LocationInfo;
                    })();

                    common.DeviceInfo = (function() {

                        /**
                         * Properties of a DeviceInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IDeviceInfo
                         * @property {google.ads.googleads.v1.enums.DeviceEnum.Device|null} [type] DeviceInfo type
                         */

                        /**
                         * Constructs a new DeviceInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a DeviceInfo.
                         * @implements IDeviceInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IDeviceInfo=} [properties] Properties to set
                         */
                        function DeviceInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * DeviceInfo type.
                         * @member {google.ads.googleads.v1.enums.DeviceEnum.Device} type
                         * @memberof google.ads.googleads.v1.common.DeviceInfo
                         * @instance
                         */
                        DeviceInfo.prototype.type = 0;

                        /**
                         * Creates a new DeviceInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.DeviceInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IDeviceInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.DeviceInfo} DeviceInfo instance
                         */
                        DeviceInfo.create = function create(properties) {
                            return new DeviceInfo(properties);
                        };

                        /**
                         * Encodes the specified DeviceInfo message. Does not implicitly {@link google.ads.googleads.v1.common.DeviceInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.DeviceInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IDeviceInfo} message DeviceInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeviceInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.type);
                            return writer;
                        };

                        /**
                         * Encodes the specified DeviceInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.DeviceInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.DeviceInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IDeviceInfo} message DeviceInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeviceInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DeviceInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.DeviceInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.DeviceInfo} DeviceInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeviceInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.DeviceInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.type = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DeviceInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.DeviceInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.DeviceInfo} DeviceInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeviceInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DeviceInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.DeviceInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeviceInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a DeviceInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.DeviceInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.DeviceInfo} DeviceInfo
                         */
                        DeviceInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.DeviceInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.DeviceInfo();
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "MOBILE":
                            case 2:
                                message.type = 2;
                                break;
                            case "TABLET":
                            case 3:
                                message.type = 3;
                                break;
                            case "DESKTOP":
                            case 4:
                                message.type = 4;
                                break;
                            case "OTHER":
                            case 5:
                                message.type = 5;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a DeviceInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.DeviceInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.DeviceInfo} message DeviceInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeviceInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.DeviceEnum.Device[message.type] : message.type;
                            return object;
                        };

                        /**
                         * Converts this DeviceInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.DeviceInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeviceInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return DeviceInfo;
                    })();

                    common.PreferredContentInfo = (function() {

                        /**
                         * Properties of a PreferredContentInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IPreferredContentInfo
                         * @property {google.ads.googleads.v1.enums.PreferredContentTypeEnum.PreferredContentType|null} [type] PreferredContentInfo type
                         */

                        /**
                         * Constructs a new PreferredContentInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a PreferredContentInfo.
                         * @implements IPreferredContentInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IPreferredContentInfo=} [properties] Properties to set
                         */
                        function PreferredContentInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * PreferredContentInfo type.
                         * @member {google.ads.googleads.v1.enums.PreferredContentTypeEnum.PreferredContentType} type
                         * @memberof google.ads.googleads.v1.common.PreferredContentInfo
                         * @instance
                         */
                        PreferredContentInfo.prototype.type = 0;

                        /**
                         * Creates a new PreferredContentInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.PreferredContentInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IPreferredContentInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.PreferredContentInfo} PreferredContentInfo instance
                         */
                        PreferredContentInfo.create = function create(properties) {
                            return new PreferredContentInfo(properties);
                        };

                        /**
                         * Encodes the specified PreferredContentInfo message. Does not implicitly {@link google.ads.googleads.v1.common.PreferredContentInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.PreferredContentInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IPreferredContentInfo} message PreferredContentInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PreferredContentInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.type);
                            return writer;
                        };

                        /**
                         * Encodes the specified PreferredContentInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PreferredContentInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.PreferredContentInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IPreferredContentInfo} message PreferredContentInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PreferredContentInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PreferredContentInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.PreferredContentInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.PreferredContentInfo} PreferredContentInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PreferredContentInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PreferredContentInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2:
                                    message.type = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PreferredContentInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.PreferredContentInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.PreferredContentInfo} PreferredContentInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PreferredContentInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PreferredContentInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.PreferredContentInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PreferredContentInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 400:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a PreferredContentInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.PreferredContentInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.PreferredContentInfo} PreferredContentInfo
                         */
                        PreferredContentInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.PreferredContentInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.PreferredContentInfo();
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "YOUTUBE_TOP_CONTENT":
                            case 400:
                                message.type = 400;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a PreferredContentInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.PreferredContentInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.PreferredContentInfo} message PreferredContentInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PreferredContentInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.PreferredContentTypeEnum.PreferredContentType[message.type] : message.type;
                            return object;
                        };

                        /**
                         * Converts this PreferredContentInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.PreferredContentInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PreferredContentInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return PreferredContentInfo;
                    })();

                    common.ListingGroupInfo = (function() {

                        /**
                         * Properties of a ListingGroupInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IListingGroupInfo
                         * @property {google.ads.googleads.v1.enums.ListingGroupTypeEnum.ListingGroupType|null} [type] ListingGroupInfo type
                         * @property {google.ads.googleads.v1.common.IListingDimensionInfo|null} [caseValue] ListingGroupInfo caseValue
                         * @property {google.protobuf.IStringValue|null} [parentAdGroupCriterion] ListingGroupInfo parentAdGroupCriterion
                         */

                        /**
                         * Constructs a new ListingGroupInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ListingGroupInfo.
                         * @implements IListingGroupInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IListingGroupInfo=} [properties] Properties to set
                         */
                        function ListingGroupInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ListingGroupInfo type.
                         * @member {google.ads.googleads.v1.enums.ListingGroupTypeEnum.ListingGroupType} type
                         * @memberof google.ads.googleads.v1.common.ListingGroupInfo
                         * @instance
                         */
                        ListingGroupInfo.prototype.type = 0;

                        /**
                         * ListingGroupInfo caseValue.
                         * @member {google.ads.googleads.v1.common.IListingDimensionInfo|null|undefined} caseValue
                         * @memberof google.ads.googleads.v1.common.ListingGroupInfo
                         * @instance
                         */
                        ListingGroupInfo.prototype.caseValue = null;

                        /**
                         * ListingGroupInfo parentAdGroupCriterion.
                         * @member {google.protobuf.IStringValue|null|undefined} parentAdGroupCriterion
                         * @memberof google.ads.googleads.v1.common.ListingGroupInfo
                         * @instance
                         */
                        ListingGroupInfo.prototype.parentAdGroupCriterion = null;

                        /**
                         * Creates a new ListingGroupInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ListingGroupInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IListingGroupInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ListingGroupInfo} ListingGroupInfo instance
                         */
                        ListingGroupInfo.create = function create(properties) {
                            return new ListingGroupInfo(properties);
                        };

                        /**
                         * Encodes the specified ListingGroupInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ListingGroupInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ListingGroupInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IListingGroupInfo} message ListingGroupInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListingGroupInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.type);
                            if (message.caseValue != null && message.hasOwnProperty("caseValue"))
                                $root.google.ads.googleads.v1.common.ListingDimensionInfo.encode(message.caseValue, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.parentAdGroupCriterion != null && message.hasOwnProperty("parentAdGroupCriterion"))
                                $root.google.protobuf.StringValue.encode(message.parentAdGroupCriterion, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ListingGroupInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ListingGroupInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ListingGroupInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IListingGroupInfo} message ListingGroupInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListingGroupInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ListingGroupInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ListingGroupInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ListingGroupInfo} ListingGroupInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListingGroupInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ListingGroupInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.type = reader.int32();
                                    break;
                                case 2:
                                    message.caseValue = $root.google.ads.googleads.v1.common.ListingDimensionInfo.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.parentAdGroupCriterion = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ListingGroupInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ListingGroupInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ListingGroupInfo} ListingGroupInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListingGroupInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ListingGroupInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ListingGroupInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListingGroupInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.caseValue != null && message.hasOwnProperty("caseValue")) {
                                var error = $root.google.ads.googleads.v1.common.ListingDimensionInfo.verify(message.caseValue);
                                if (error)
                                    return "caseValue." + error;
                            }
                            if (message.parentAdGroupCriterion != null && message.hasOwnProperty("parentAdGroupCriterion")) {
                                var error = $root.google.protobuf.StringValue.verify(message.parentAdGroupCriterion);
                                if (error)
                                    return "parentAdGroupCriterion." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a ListingGroupInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ListingGroupInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ListingGroupInfo} ListingGroupInfo
                         */
                        ListingGroupInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ListingGroupInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ListingGroupInfo();
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "SUBDIVISION":
                            case 2:
                                message.type = 2;
                                break;
                            case "UNIT":
                            case 3:
                                message.type = 3;
                                break;
                            }
                            if (object.caseValue != null) {
                                if (typeof object.caseValue !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ListingGroupInfo.caseValue: object expected");
                                message.caseValue = $root.google.ads.googleads.v1.common.ListingDimensionInfo.fromObject(object.caseValue);
                            }
                            if (object.parentAdGroupCriterion != null) {
                                if (typeof object.parentAdGroupCriterion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ListingGroupInfo.parentAdGroupCriterion: object expected");
                                message.parentAdGroupCriterion = $root.google.protobuf.StringValue.fromObject(object.parentAdGroupCriterion);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ListingGroupInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ListingGroupInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ListingGroupInfo} message ListingGroupInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListingGroupInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.caseValue = null;
                                object.parentAdGroupCriterion = null;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.ListingGroupTypeEnum.ListingGroupType[message.type] : message.type;
                            if (message.caseValue != null && message.hasOwnProperty("caseValue"))
                                object.caseValue = $root.google.ads.googleads.v1.common.ListingDimensionInfo.toObject(message.caseValue, options);
                            if (message.parentAdGroupCriterion != null && message.hasOwnProperty("parentAdGroupCriterion"))
                                object.parentAdGroupCriterion = $root.google.protobuf.StringValue.toObject(message.parentAdGroupCriterion, options);
                            return object;
                        };

                        /**
                         * Converts this ListingGroupInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ListingGroupInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListingGroupInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ListingGroupInfo;
                    })();

                    common.ListingScopeInfo = (function() {

                        /**
                         * Properties of a ListingScopeInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IListingScopeInfo
                         * @property {Array.<google.ads.googleads.v1.common.IListingDimensionInfo>|null} [dimensions] ListingScopeInfo dimensions
                         */

                        /**
                         * Constructs a new ListingScopeInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ListingScopeInfo.
                         * @implements IListingScopeInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IListingScopeInfo=} [properties] Properties to set
                         */
                        function ListingScopeInfo(properties) {
                            this.dimensions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ListingScopeInfo dimensions.
                         * @member {Array.<google.ads.googleads.v1.common.IListingDimensionInfo>} dimensions
                         * @memberof google.ads.googleads.v1.common.ListingScopeInfo
                         * @instance
                         */
                        ListingScopeInfo.prototype.dimensions = $util.emptyArray;

                        /**
                         * Creates a new ListingScopeInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ListingScopeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IListingScopeInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ListingScopeInfo} ListingScopeInfo instance
                         */
                        ListingScopeInfo.create = function create(properties) {
                            return new ListingScopeInfo(properties);
                        };

                        /**
                         * Encodes the specified ListingScopeInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ListingScopeInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ListingScopeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IListingScopeInfo} message ListingScopeInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListingScopeInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dimensions != null && message.dimensions.length)
                                for (var i = 0; i < message.dimensions.length; ++i)
                                    $root.google.ads.googleads.v1.common.ListingDimensionInfo.encode(message.dimensions[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ListingScopeInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ListingScopeInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ListingScopeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IListingScopeInfo} message ListingScopeInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListingScopeInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ListingScopeInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ListingScopeInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ListingScopeInfo} ListingScopeInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListingScopeInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ListingScopeInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2:
                                    if (!(message.dimensions && message.dimensions.length))
                                        message.dimensions = [];
                                    message.dimensions.push($root.google.ads.googleads.v1.common.ListingDimensionInfo.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ListingScopeInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ListingScopeInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ListingScopeInfo} ListingScopeInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListingScopeInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ListingScopeInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ListingScopeInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListingScopeInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.dimensions != null && message.hasOwnProperty("dimensions")) {
                                if (!Array.isArray(message.dimensions))
                                    return "dimensions: array expected";
                                for (var i = 0; i < message.dimensions.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.ListingDimensionInfo.verify(message.dimensions[i]);
                                    if (error)
                                        return "dimensions." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a ListingScopeInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ListingScopeInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ListingScopeInfo} ListingScopeInfo
                         */
                        ListingScopeInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ListingScopeInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ListingScopeInfo();
                            if (object.dimensions) {
                                if (!Array.isArray(object.dimensions))
                                    throw TypeError(".google.ads.googleads.v1.common.ListingScopeInfo.dimensions: array expected");
                                message.dimensions = [];
                                for (var i = 0; i < object.dimensions.length; ++i) {
                                    if (typeof object.dimensions[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.ListingScopeInfo.dimensions: object expected");
                                    message.dimensions[i] = $root.google.ads.googleads.v1.common.ListingDimensionInfo.fromObject(object.dimensions[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ListingScopeInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ListingScopeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ListingScopeInfo} message ListingScopeInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListingScopeInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.dimensions = [];
                            if (message.dimensions && message.dimensions.length) {
                                object.dimensions = [];
                                for (var j = 0; j < message.dimensions.length; ++j)
                                    object.dimensions[j] = $root.google.ads.googleads.v1.common.ListingDimensionInfo.toObject(message.dimensions[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this ListingScopeInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ListingScopeInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListingScopeInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ListingScopeInfo;
                    })();

                    common.ListingDimensionInfo = (function() {

                        /**
                         * Properties of a ListingDimensionInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IListingDimensionInfo
                         * @property {google.ads.googleads.v1.common.IListingBrandInfo|null} [listingBrand] ListingDimensionInfo listingBrand
                         * @property {google.ads.googleads.v1.common.IHotelIdInfo|null} [hotelId] ListingDimensionInfo hotelId
                         * @property {google.ads.googleads.v1.common.IHotelClassInfo|null} [hotelClass] ListingDimensionInfo hotelClass
                         * @property {google.ads.googleads.v1.common.IHotelCountryRegionInfo|null} [hotelCountryRegion] ListingDimensionInfo hotelCountryRegion
                         * @property {google.ads.googleads.v1.common.IHotelStateInfo|null} [hotelState] ListingDimensionInfo hotelState
                         * @property {google.ads.googleads.v1.common.IHotelCityInfo|null} [hotelCity] ListingDimensionInfo hotelCity
                         * @property {google.ads.googleads.v1.common.IListingCustomAttributeInfo|null} [listingCustomAttribute] ListingDimensionInfo listingCustomAttribute
                         * @property {google.ads.googleads.v1.common.IProductBiddingCategoryInfo|null} [productBiddingCategory] ListingDimensionInfo productBiddingCategory
                         * @property {google.ads.googleads.v1.common.IProductChannelInfo|null} [productChannel] ListingDimensionInfo productChannel
                         * @property {google.ads.googleads.v1.common.IProductChannelExclusivityInfo|null} [productChannelExclusivity] ListingDimensionInfo productChannelExclusivity
                         * @property {google.ads.googleads.v1.common.IProductConditionInfo|null} [productCondition] ListingDimensionInfo productCondition
                         * @property {google.ads.googleads.v1.common.IProductItemIdInfo|null} [productItemId] ListingDimensionInfo productItemId
                         * @property {google.ads.googleads.v1.common.IProductTypeInfo|null} [productType] ListingDimensionInfo productType
                         * @property {google.ads.googleads.v1.common.IUnknownListingDimensionInfo|null} [unknownListingDimension] ListingDimensionInfo unknownListingDimension
                         */

                        /**
                         * Constructs a new ListingDimensionInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ListingDimensionInfo.
                         * @implements IListingDimensionInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IListingDimensionInfo=} [properties] Properties to set
                         */
                        function ListingDimensionInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ListingDimensionInfo listingBrand.
                         * @member {google.ads.googleads.v1.common.IListingBrandInfo|null|undefined} listingBrand
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @instance
                         */
                        ListingDimensionInfo.prototype.listingBrand = null;

                        /**
                         * ListingDimensionInfo hotelId.
                         * @member {google.ads.googleads.v1.common.IHotelIdInfo|null|undefined} hotelId
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @instance
                         */
                        ListingDimensionInfo.prototype.hotelId = null;

                        /**
                         * ListingDimensionInfo hotelClass.
                         * @member {google.ads.googleads.v1.common.IHotelClassInfo|null|undefined} hotelClass
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @instance
                         */
                        ListingDimensionInfo.prototype.hotelClass = null;

                        /**
                         * ListingDimensionInfo hotelCountryRegion.
                         * @member {google.ads.googleads.v1.common.IHotelCountryRegionInfo|null|undefined} hotelCountryRegion
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @instance
                         */
                        ListingDimensionInfo.prototype.hotelCountryRegion = null;

                        /**
                         * ListingDimensionInfo hotelState.
                         * @member {google.ads.googleads.v1.common.IHotelStateInfo|null|undefined} hotelState
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @instance
                         */
                        ListingDimensionInfo.prototype.hotelState = null;

                        /**
                         * ListingDimensionInfo hotelCity.
                         * @member {google.ads.googleads.v1.common.IHotelCityInfo|null|undefined} hotelCity
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @instance
                         */
                        ListingDimensionInfo.prototype.hotelCity = null;

                        /**
                         * ListingDimensionInfo listingCustomAttribute.
                         * @member {google.ads.googleads.v1.common.IListingCustomAttributeInfo|null|undefined} listingCustomAttribute
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @instance
                         */
                        ListingDimensionInfo.prototype.listingCustomAttribute = null;

                        /**
                         * ListingDimensionInfo productBiddingCategory.
                         * @member {google.ads.googleads.v1.common.IProductBiddingCategoryInfo|null|undefined} productBiddingCategory
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @instance
                         */
                        ListingDimensionInfo.prototype.productBiddingCategory = null;

                        /**
                         * ListingDimensionInfo productChannel.
                         * @member {google.ads.googleads.v1.common.IProductChannelInfo|null|undefined} productChannel
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @instance
                         */
                        ListingDimensionInfo.prototype.productChannel = null;

                        /**
                         * ListingDimensionInfo productChannelExclusivity.
                         * @member {google.ads.googleads.v1.common.IProductChannelExclusivityInfo|null|undefined} productChannelExclusivity
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @instance
                         */
                        ListingDimensionInfo.prototype.productChannelExclusivity = null;

                        /**
                         * ListingDimensionInfo productCondition.
                         * @member {google.ads.googleads.v1.common.IProductConditionInfo|null|undefined} productCondition
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @instance
                         */
                        ListingDimensionInfo.prototype.productCondition = null;

                        /**
                         * ListingDimensionInfo productItemId.
                         * @member {google.ads.googleads.v1.common.IProductItemIdInfo|null|undefined} productItemId
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @instance
                         */
                        ListingDimensionInfo.prototype.productItemId = null;

                        /**
                         * ListingDimensionInfo productType.
                         * @member {google.ads.googleads.v1.common.IProductTypeInfo|null|undefined} productType
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @instance
                         */
                        ListingDimensionInfo.prototype.productType = null;

                        /**
                         * ListingDimensionInfo unknownListingDimension.
                         * @member {google.ads.googleads.v1.common.IUnknownListingDimensionInfo|null|undefined} unknownListingDimension
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @instance
                         */
                        ListingDimensionInfo.prototype.unknownListingDimension = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * ListingDimensionInfo dimension.
                         * @member {"listingBrand"|"hotelId"|"hotelClass"|"hotelCountryRegion"|"hotelState"|"hotelCity"|"listingCustomAttribute"|"productBiddingCategory"|"productChannel"|"productChannelExclusivity"|"productCondition"|"productItemId"|"productType"|"unknownListingDimension"|undefined} dimension
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @instance
                         */
                        Object.defineProperty(ListingDimensionInfo.prototype, "dimension", {
                            get: $util.oneOfGetter($oneOfFields = ["listingBrand", "hotelId", "hotelClass", "hotelCountryRegion", "hotelState", "hotelCity", "listingCustomAttribute", "productBiddingCategory", "productChannel", "productChannelExclusivity", "productCondition", "productItemId", "productType", "unknownListingDimension"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new ListingDimensionInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IListingDimensionInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ListingDimensionInfo} ListingDimensionInfo instance
                         */
                        ListingDimensionInfo.create = function create(properties) {
                            return new ListingDimensionInfo(properties);
                        };

                        /**
                         * Encodes the specified ListingDimensionInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ListingDimensionInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IListingDimensionInfo} message ListingDimensionInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListingDimensionInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.listingBrand != null && message.hasOwnProperty("listingBrand"))
                                $root.google.ads.googleads.v1.common.ListingBrandInfo.encode(message.listingBrand, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.hotelId != null && message.hasOwnProperty("hotelId"))
                                $root.google.ads.googleads.v1.common.HotelIdInfo.encode(message.hotelId, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.hotelClass != null && message.hasOwnProperty("hotelClass"))
                                $root.google.ads.googleads.v1.common.HotelClassInfo.encode(message.hotelClass, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.hotelCountryRegion != null && message.hasOwnProperty("hotelCountryRegion"))
                                $root.google.ads.googleads.v1.common.HotelCountryRegionInfo.encode(message.hotelCountryRegion, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.hotelState != null && message.hasOwnProperty("hotelState"))
                                $root.google.ads.googleads.v1.common.HotelStateInfo.encode(message.hotelState, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.hotelCity != null && message.hasOwnProperty("hotelCity"))
                                $root.google.ads.googleads.v1.common.HotelCityInfo.encode(message.hotelCity, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.listingCustomAttribute != null && message.hasOwnProperty("listingCustomAttribute"))
                                $root.google.ads.googleads.v1.common.ListingCustomAttributeInfo.encode(message.listingCustomAttribute, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.productChannel != null && message.hasOwnProperty("productChannel"))
                                $root.google.ads.googleads.v1.common.ProductChannelInfo.encode(message.productChannel, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.productChannelExclusivity != null && message.hasOwnProperty("productChannelExclusivity"))
                                $root.google.ads.googleads.v1.common.ProductChannelExclusivityInfo.encode(message.productChannelExclusivity, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.productCondition != null && message.hasOwnProperty("productCondition"))
                                $root.google.ads.googleads.v1.common.ProductConditionInfo.encode(message.productCondition, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.productItemId != null && message.hasOwnProperty("productItemId"))
                                $root.google.ads.googleads.v1.common.ProductItemIdInfo.encode(message.productItemId, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.productType != null && message.hasOwnProperty("productType"))
                                $root.google.ads.googleads.v1.common.ProductTypeInfo.encode(message.productType, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.productBiddingCategory != null && message.hasOwnProperty("productBiddingCategory"))
                                $root.google.ads.googleads.v1.common.ProductBiddingCategoryInfo.encode(message.productBiddingCategory, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                            if (message.unknownListingDimension != null && message.hasOwnProperty("unknownListingDimension"))
                                $root.google.ads.googleads.v1.common.UnknownListingDimensionInfo.encode(message.unknownListingDimension, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ListingDimensionInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ListingDimensionInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IListingDimensionInfo} message ListingDimensionInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListingDimensionInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ListingDimensionInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ListingDimensionInfo} ListingDimensionInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListingDimensionInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ListingDimensionInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.listingBrand = $root.google.ads.googleads.v1.common.ListingBrandInfo.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.hotelId = $root.google.ads.googleads.v1.common.HotelIdInfo.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.hotelClass = $root.google.ads.googleads.v1.common.HotelClassInfo.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.hotelCountryRegion = $root.google.ads.googleads.v1.common.HotelCountryRegionInfo.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.hotelState = $root.google.ads.googleads.v1.common.HotelStateInfo.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.hotelCity = $root.google.ads.googleads.v1.common.HotelCityInfo.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.listingCustomAttribute = $root.google.ads.googleads.v1.common.ListingCustomAttributeInfo.decode(reader, reader.uint32());
                                    break;
                                case 13:
                                    message.productBiddingCategory = $root.google.ads.googleads.v1.common.ProductBiddingCategoryInfo.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.productChannel = $root.google.ads.googleads.v1.common.ProductChannelInfo.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.productChannelExclusivity = $root.google.ads.googleads.v1.common.ProductChannelExclusivityInfo.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.productCondition = $root.google.ads.googleads.v1.common.ProductConditionInfo.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.productItemId = $root.google.ads.googleads.v1.common.ProductItemIdInfo.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.productType = $root.google.ads.googleads.v1.common.ProductTypeInfo.decode(reader, reader.uint32());
                                    break;
                                case 14:
                                    message.unknownListingDimension = $root.google.ads.googleads.v1.common.UnknownListingDimensionInfo.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ListingDimensionInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ListingDimensionInfo} ListingDimensionInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListingDimensionInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ListingDimensionInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListingDimensionInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.listingBrand != null && message.hasOwnProperty("listingBrand")) {
                                properties.dimension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ListingBrandInfo.verify(message.listingBrand);
                                    if (error)
                                        return "listingBrand." + error;
                                }
                            }
                            if (message.hotelId != null && message.hasOwnProperty("hotelId")) {
                                if (properties.dimension === 1)
                                    return "dimension: multiple values";
                                properties.dimension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.HotelIdInfo.verify(message.hotelId);
                                    if (error)
                                        return "hotelId." + error;
                                }
                            }
                            if (message.hotelClass != null && message.hasOwnProperty("hotelClass")) {
                                if (properties.dimension === 1)
                                    return "dimension: multiple values";
                                properties.dimension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.HotelClassInfo.verify(message.hotelClass);
                                    if (error)
                                        return "hotelClass." + error;
                                }
                            }
                            if (message.hotelCountryRegion != null && message.hasOwnProperty("hotelCountryRegion")) {
                                if (properties.dimension === 1)
                                    return "dimension: multiple values";
                                properties.dimension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.HotelCountryRegionInfo.verify(message.hotelCountryRegion);
                                    if (error)
                                        return "hotelCountryRegion." + error;
                                }
                            }
                            if (message.hotelState != null && message.hasOwnProperty("hotelState")) {
                                if (properties.dimension === 1)
                                    return "dimension: multiple values";
                                properties.dimension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.HotelStateInfo.verify(message.hotelState);
                                    if (error)
                                        return "hotelState." + error;
                                }
                            }
                            if (message.hotelCity != null && message.hasOwnProperty("hotelCity")) {
                                if (properties.dimension === 1)
                                    return "dimension: multiple values";
                                properties.dimension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.HotelCityInfo.verify(message.hotelCity);
                                    if (error)
                                        return "hotelCity." + error;
                                }
                            }
                            if (message.listingCustomAttribute != null && message.hasOwnProperty("listingCustomAttribute")) {
                                if (properties.dimension === 1)
                                    return "dimension: multiple values";
                                properties.dimension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ListingCustomAttributeInfo.verify(message.listingCustomAttribute);
                                    if (error)
                                        return "listingCustomAttribute." + error;
                                }
                            }
                            if (message.productBiddingCategory != null && message.hasOwnProperty("productBiddingCategory")) {
                                if (properties.dimension === 1)
                                    return "dimension: multiple values";
                                properties.dimension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ProductBiddingCategoryInfo.verify(message.productBiddingCategory);
                                    if (error)
                                        return "productBiddingCategory." + error;
                                }
                            }
                            if (message.productChannel != null && message.hasOwnProperty("productChannel")) {
                                if (properties.dimension === 1)
                                    return "dimension: multiple values";
                                properties.dimension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ProductChannelInfo.verify(message.productChannel);
                                    if (error)
                                        return "productChannel." + error;
                                }
                            }
                            if (message.productChannelExclusivity != null && message.hasOwnProperty("productChannelExclusivity")) {
                                if (properties.dimension === 1)
                                    return "dimension: multiple values";
                                properties.dimension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ProductChannelExclusivityInfo.verify(message.productChannelExclusivity);
                                    if (error)
                                        return "productChannelExclusivity." + error;
                                }
                            }
                            if (message.productCondition != null && message.hasOwnProperty("productCondition")) {
                                if (properties.dimension === 1)
                                    return "dimension: multiple values";
                                properties.dimension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ProductConditionInfo.verify(message.productCondition);
                                    if (error)
                                        return "productCondition." + error;
                                }
                            }
                            if (message.productItemId != null && message.hasOwnProperty("productItemId")) {
                                if (properties.dimension === 1)
                                    return "dimension: multiple values";
                                properties.dimension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ProductItemIdInfo.verify(message.productItemId);
                                    if (error)
                                        return "productItemId." + error;
                                }
                            }
                            if (message.productType != null && message.hasOwnProperty("productType")) {
                                if (properties.dimension === 1)
                                    return "dimension: multiple values";
                                properties.dimension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ProductTypeInfo.verify(message.productType);
                                    if (error)
                                        return "productType." + error;
                                }
                            }
                            if (message.unknownListingDimension != null && message.hasOwnProperty("unknownListingDimension")) {
                                if (properties.dimension === 1)
                                    return "dimension: multiple values";
                                properties.dimension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.UnknownListingDimensionInfo.verify(message.unknownListingDimension);
                                    if (error)
                                        return "unknownListingDimension." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a ListingDimensionInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ListingDimensionInfo} ListingDimensionInfo
                         */
                        ListingDimensionInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ListingDimensionInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ListingDimensionInfo();
                            if (object.listingBrand != null) {
                                if (typeof object.listingBrand !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ListingDimensionInfo.listingBrand: object expected");
                                message.listingBrand = $root.google.ads.googleads.v1.common.ListingBrandInfo.fromObject(object.listingBrand);
                            }
                            if (object.hotelId != null) {
                                if (typeof object.hotelId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ListingDimensionInfo.hotelId: object expected");
                                message.hotelId = $root.google.ads.googleads.v1.common.HotelIdInfo.fromObject(object.hotelId);
                            }
                            if (object.hotelClass != null) {
                                if (typeof object.hotelClass !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ListingDimensionInfo.hotelClass: object expected");
                                message.hotelClass = $root.google.ads.googleads.v1.common.HotelClassInfo.fromObject(object.hotelClass);
                            }
                            if (object.hotelCountryRegion != null) {
                                if (typeof object.hotelCountryRegion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ListingDimensionInfo.hotelCountryRegion: object expected");
                                message.hotelCountryRegion = $root.google.ads.googleads.v1.common.HotelCountryRegionInfo.fromObject(object.hotelCountryRegion);
                            }
                            if (object.hotelState != null) {
                                if (typeof object.hotelState !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ListingDimensionInfo.hotelState: object expected");
                                message.hotelState = $root.google.ads.googleads.v1.common.HotelStateInfo.fromObject(object.hotelState);
                            }
                            if (object.hotelCity != null) {
                                if (typeof object.hotelCity !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ListingDimensionInfo.hotelCity: object expected");
                                message.hotelCity = $root.google.ads.googleads.v1.common.HotelCityInfo.fromObject(object.hotelCity);
                            }
                            if (object.listingCustomAttribute != null) {
                                if (typeof object.listingCustomAttribute !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ListingDimensionInfo.listingCustomAttribute: object expected");
                                message.listingCustomAttribute = $root.google.ads.googleads.v1.common.ListingCustomAttributeInfo.fromObject(object.listingCustomAttribute);
                            }
                            if (object.productBiddingCategory != null) {
                                if (typeof object.productBiddingCategory !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ListingDimensionInfo.productBiddingCategory: object expected");
                                message.productBiddingCategory = $root.google.ads.googleads.v1.common.ProductBiddingCategoryInfo.fromObject(object.productBiddingCategory);
                            }
                            if (object.productChannel != null) {
                                if (typeof object.productChannel !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ListingDimensionInfo.productChannel: object expected");
                                message.productChannel = $root.google.ads.googleads.v1.common.ProductChannelInfo.fromObject(object.productChannel);
                            }
                            if (object.productChannelExclusivity != null) {
                                if (typeof object.productChannelExclusivity !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ListingDimensionInfo.productChannelExclusivity: object expected");
                                message.productChannelExclusivity = $root.google.ads.googleads.v1.common.ProductChannelExclusivityInfo.fromObject(object.productChannelExclusivity);
                            }
                            if (object.productCondition != null) {
                                if (typeof object.productCondition !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ListingDimensionInfo.productCondition: object expected");
                                message.productCondition = $root.google.ads.googleads.v1.common.ProductConditionInfo.fromObject(object.productCondition);
                            }
                            if (object.productItemId != null) {
                                if (typeof object.productItemId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ListingDimensionInfo.productItemId: object expected");
                                message.productItemId = $root.google.ads.googleads.v1.common.ProductItemIdInfo.fromObject(object.productItemId);
                            }
                            if (object.productType != null) {
                                if (typeof object.productType !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ListingDimensionInfo.productType: object expected");
                                message.productType = $root.google.ads.googleads.v1.common.ProductTypeInfo.fromObject(object.productType);
                            }
                            if (object.unknownListingDimension != null) {
                                if (typeof object.unknownListingDimension !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ListingDimensionInfo.unknownListingDimension: object expected");
                                message.unknownListingDimension = $root.google.ads.googleads.v1.common.UnknownListingDimensionInfo.fromObject(object.unknownListingDimension);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ListingDimensionInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ListingDimensionInfo} message ListingDimensionInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListingDimensionInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.listingBrand != null && message.hasOwnProperty("listingBrand")) {
                                object.listingBrand = $root.google.ads.googleads.v1.common.ListingBrandInfo.toObject(message.listingBrand, options);
                                if (options.oneofs)
                                    object.dimension = "listingBrand";
                            }
                            if (message.hotelId != null && message.hasOwnProperty("hotelId")) {
                                object.hotelId = $root.google.ads.googleads.v1.common.HotelIdInfo.toObject(message.hotelId, options);
                                if (options.oneofs)
                                    object.dimension = "hotelId";
                            }
                            if (message.hotelClass != null && message.hasOwnProperty("hotelClass")) {
                                object.hotelClass = $root.google.ads.googleads.v1.common.HotelClassInfo.toObject(message.hotelClass, options);
                                if (options.oneofs)
                                    object.dimension = "hotelClass";
                            }
                            if (message.hotelCountryRegion != null && message.hasOwnProperty("hotelCountryRegion")) {
                                object.hotelCountryRegion = $root.google.ads.googleads.v1.common.HotelCountryRegionInfo.toObject(message.hotelCountryRegion, options);
                                if (options.oneofs)
                                    object.dimension = "hotelCountryRegion";
                            }
                            if (message.hotelState != null && message.hasOwnProperty("hotelState")) {
                                object.hotelState = $root.google.ads.googleads.v1.common.HotelStateInfo.toObject(message.hotelState, options);
                                if (options.oneofs)
                                    object.dimension = "hotelState";
                            }
                            if (message.hotelCity != null && message.hasOwnProperty("hotelCity")) {
                                object.hotelCity = $root.google.ads.googleads.v1.common.HotelCityInfo.toObject(message.hotelCity, options);
                                if (options.oneofs)
                                    object.dimension = "hotelCity";
                            }
                            if (message.listingCustomAttribute != null && message.hasOwnProperty("listingCustomAttribute")) {
                                object.listingCustomAttribute = $root.google.ads.googleads.v1.common.ListingCustomAttributeInfo.toObject(message.listingCustomAttribute, options);
                                if (options.oneofs)
                                    object.dimension = "listingCustomAttribute";
                            }
                            if (message.productChannel != null && message.hasOwnProperty("productChannel")) {
                                object.productChannel = $root.google.ads.googleads.v1.common.ProductChannelInfo.toObject(message.productChannel, options);
                                if (options.oneofs)
                                    object.dimension = "productChannel";
                            }
                            if (message.productChannelExclusivity != null && message.hasOwnProperty("productChannelExclusivity")) {
                                object.productChannelExclusivity = $root.google.ads.googleads.v1.common.ProductChannelExclusivityInfo.toObject(message.productChannelExclusivity, options);
                                if (options.oneofs)
                                    object.dimension = "productChannelExclusivity";
                            }
                            if (message.productCondition != null && message.hasOwnProperty("productCondition")) {
                                object.productCondition = $root.google.ads.googleads.v1.common.ProductConditionInfo.toObject(message.productCondition, options);
                                if (options.oneofs)
                                    object.dimension = "productCondition";
                            }
                            if (message.productItemId != null && message.hasOwnProperty("productItemId")) {
                                object.productItemId = $root.google.ads.googleads.v1.common.ProductItemIdInfo.toObject(message.productItemId, options);
                                if (options.oneofs)
                                    object.dimension = "productItemId";
                            }
                            if (message.productType != null && message.hasOwnProperty("productType")) {
                                object.productType = $root.google.ads.googleads.v1.common.ProductTypeInfo.toObject(message.productType, options);
                                if (options.oneofs)
                                    object.dimension = "productType";
                            }
                            if (message.productBiddingCategory != null && message.hasOwnProperty("productBiddingCategory")) {
                                object.productBiddingCategory = $root.google.ads.googleads.v1.common.ProductBiddingCategoryInfo.toObject(message.productBiddingCategory, options);
                                if (options.oneofs)
                                    object.dimension = "productBiddingCategory";
                            }
                            if (message.unknownListingDimension != null && message.hasOwnProperty("unknownListingDimension")) {
                                object.unknownListingDimension = $root.google.ads.googleads.v1.common.UnknownListingDimensionInfo.toObject(message.unknownListingDimension, options);
                                if (options.oneofs)
                                    object.dimension = "unknownListingDimension";
                            }
                            return object;
                        };

                        /**
                         * Converts this ListingDimensionInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ListingDimensionInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListingDimensionInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ListingDimensionInfo;
                    })();

                    common.ListingBrandInfo = (function() {

                        /**
                         * Properties of a ListingBrandInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IListingBrandInfo
                         * @property {google.protobuf.IStringValue|null} [value] ListingBrandInfo value
                         */

                        /**
                         * Constructs a new ListingBrandInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ListingBrandInfo.
                         * @implements IListingBrandInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IListingBrandInfo=} [properties] Properties to set
                         */
                        function ListingBrandInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ListingBrandInfo value.
                         * @member {google.protobuf.IStringValue|null|undefined} value
                         * @memberof google.ads.googleads.v1.common.ListingBrandInfo
                         * @instance
                         */
                        ListingBrandInfo.prototype.value = null;

                        /**
                         * Creates a new ListingBrandInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ListingBrandInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IListingBrandInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ListingBrandInfo} ListingBrandInfo instance
                         */
                        ListingBrandInfo.create = function create(properties) {
                            return new ListingBrandInfo(properties);
                        };

                        /**
                         * Encodes the specified ListingBrandInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ListingBrandInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ListingBrandInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IListingBrandInfo} message ListingBrandInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListingBrandInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.value != null && message.hasOwnProperty("value"))
                                $root.google.protobuf.StringValue.encode(message.value, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ListingBrandInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ListingBrandInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ListingBrandInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IListingBrandInfo} message ListingBrandInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListingBrandInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ListingBrandInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ListingBrandInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ListingBrandInfo} ListingBrandInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListingBrandInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ListingBrandInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.value = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ListingBrandInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ListingBrandInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ListingBrandInfo} ListingBrandInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListingBrandInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ListingBrandInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ListingBrandInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListingBrandInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.value != null && message.hasOwnProperty("value")) {
                                var error = $root.google.protobuf.StringValue.verify(message.value);
                                if (error)
                                    return "value." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a ListingBrandInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ListingBrandInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ListingBrandInfo} ListingBrandInfo
                         */
                        ListingBrandInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ListingBrandInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ListingBrandInfo();
                            if (object.value != null) {
                                if (typeof object.value !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ListingBrandInfo.value: object expected");
                                message.value = $root.google.protobuf.StringValue.fromObject(object.value);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ListingBrandInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ListingBrandInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ListingBrandInfo} message ListingBrandInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListingBrandInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.value = null;
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = $root.google.protobuf.StringValue.toObject(message.value, options);
                            return object;
                        };

                        /**
                         * Converts this ListingBrandInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ListingBrandInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListingBrandInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ListingBrandInfo;
                    })();

                    common.HotelIdInfo = (function() {

                        /**
                         * Properties of a HotelIdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IHotelIdInfo
                         * @property {google.protobuf.IStringValue|null} [value] HotelIdInfo value
                         */

                        /**
                         * Constructs a new HotelIdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a HotelIdInfo.
                         * @implements IHotelIdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IHotelIdInfo=} [properties] Properties to set
                         */
                        function HotelIdInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * HotelIdInfo value.
                         * @member {google.protobuf.IStringValue|null|undefined} value
                         * @memberof google.ads.googleads.v1.common.HotelIdInfo
                         * @instance
                         */
                        HotelIdInfo.prototype.value = null;

                        /**
                         * Creates a new HotelIdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.HotelIdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelIdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.HotelIdInfo} HotelIdInfo instance
                         */
                        HotelIdInfo.create = function create(properties) {
                            return new HotelIdInfo(properties);
                        };

                        /**
                         * Encodes the specified HotelIdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.HotelIdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.HotelIdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelIdInfo} message HotelIdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelIdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.value != null && message.hasOwnProperty("value"))
                                $root.google.protobuf.StringValue.encode(message.value, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified HotelIdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.HotelIdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelIdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelIdInfo} message HotelIdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelIdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a HotelIdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.HotelIdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.HotelIdInfo} HotelIdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelIdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.HotelIdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.value = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a HotelIdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelIdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.HotelIdInfo} HotelIdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelIdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a HotelIdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.HotelIdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HotelIdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.value != null && message.hasOwnProperty("value")) {
                                var error = $root.google.protobuf.StringValue.verify(message.value);
                                if (error)
                                    return "value." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a HotelIdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.HotelIdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.HotelIdInfo} HotelIdInfo
                         */
                        HotelIdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.HotelIdInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.HotelIdInfo();
                            if (object.value != null) {
                                if (typeof object.value !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.HotelIdInfo.value: object expected");
                                message.value = $root.google.protobuf.StringValue.fromObject(object.value);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a HotelIdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.HotelIdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.HotelIdInfo} message HotelIdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HotelIdInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.value = null;
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = $root.google.protobuf.StringValue.toObject(message.value, options);
                            return object;
                        };

                        /**
                         * Converts this HotelIdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.HotelIdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HotelIdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return HotelIdInfo;
                    })();

                    common.HotelClassInfo = (function() {

                        /**
                         * Properties of a HotelClassInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IHotelClassInfo
                         * @property {google.protobuf.IInt64Value|null} [value] HotelClassInfo value
                         */

                        /**
                         * Constructs a new HotelClassInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a HotelClassInfo.
                         * @implements IHotelClassInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IHotelClassInfo=} [properties] Properties to set
                         */
                        function HotelClassInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * HotelClassInfo value.
                         * @member {google.protobuf.IInt64Value|null|undefined} value
                         * @memberof google.ads.googleads.v1.common.HotelClassInfo
                         * @instance
                         */
                        HotelClassInfo.prototype.value = null;

                        /**
                         * Creates a new HotelClassInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.HotelClassInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelClassInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.HotelClassInfo} HotelClassInfo instance
                         */
                        HotelClassInfo.create = function create(properties) {
                            return new HotelClassInfo(properties);
                        };

                        /**
                         * Encodes the specified HotelClassInfo message. Does not implicitly {@link google.ads.googleads.v1.common.HotelClassInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.HotelClassInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelClassInfo} message HotelClassInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelClassInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.value != null && message.hasOwnProperty("value"))
                                $root.google.protobuf.Int64Value.encode(message.value, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified HotelClassInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.HotelClassInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelClassInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelClassInfo} message HotelClassInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelClassInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a HotelClassInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.HotelClassInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.HotelClassInfo} HotelClassInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelClassInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.HotelClassInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.value = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a HotelClassInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelClassInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.HotelClassInfo} HotelClassInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelClassInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a HotelClassInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.HotelClassInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HotelClassInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.value != null && message.hasOwnProperty("value")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.value);
                                if (error)
                                    return "value." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a HotelClassInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.HotelClassInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.HotelClassInfo} HotelClassInfo
                         */
                        HotelClassInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.HotelClassInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.HotelClassInfo();
                            if (object.value != null) {
                                if (typeof object.value !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.HotelClassInfo.value: object expected");
                                message.value = $root.google.protobuf.Int64Value.fromObject(object.value);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a HotelClassInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.HotelClassInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.HotelClassInfo} message HotelClassInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HotelClassInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.value = null;
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = $root.google.protobuf.Int64Value.toObject(message.value, options);
                            return object;
                        };

                        /**
                         * Converts this HotelClassInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.HotelClassInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HotelClassInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return HotelClassInfo;
                    })();

                    common.HotelCountryRegionInfo = (function() {

                        /**
                         * Properties of a HotelCountryRegionInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IHotelCountryRegionInfo
                         * @property {google.protobuf.IStringValue|null} [countryRegionCriterion] HotelCountryRegionInfo countryRegionCriterion
                         */

                        /**
                         * Constructs a new HotelCountryRegionInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a HotelCountryRegionInfo.
                         * @implements IHotelCountryRegionInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IHotelCountryRegionInfo=} [properties] Properties to set
                         */
                        function HotelCountryRegionInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * HotelCountryRegionInfo countryRegionCriterion.
                         * @member {google.protobuf.IStringValue|null|undefined} countryRegionCriterion
                         * @memberof google.ads.googleads.v1.common.HotelCountryRegionInfo
                         * @instance
                         */
                        HotelCountryRegionInfo.prototype.countryRegionCriterion = null;

                        /**
                         * Creates a new HotelCountryRegionInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.HotelCountryRegionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelCountryRegionInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.HotelCountryRegionInfo} HotelCountryRegionInfo instance
                         */
                        HotelCountryRegionInfo.create = function create(properties) {
                            return new HotelCountryRegionInfo(properties);
                        };

                        /**
                         * Encodes the specified HotelCountryRegionInfo message. Does not implicitly {@link google.ads.googleads.v1.common.HotelCountryRegionInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.HotelCountryRegionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelCountryRegionInfo} message HotelCountryRegionInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelCountryRegionInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.countryRegionCriterion != null && message.hasOwnProperty("countryRegionCriterion"))
                                $root.google.protobuf.StringValue.encode(message.countryRegionCriterion, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified HotelCountryRegionInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.HotelCountryRegionInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelCountryRegionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelCountryRegionInfo} message HotelCountryRegionInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelCountryRegionInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a HotelCountryRegionInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.HotelCountryRegionInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.HotelCountryRegionInfo} HotelCountryRegionInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelCountryRegionInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.HotelCountryRegionInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.countryRegionCriterion = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a HotelCountryRegionInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelCountryRegionInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.HotelCountryRegionInfo} HotelCountryRegionInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelCountryRegionInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a HotelCountryRegionInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.HotelCountryRegionInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HotelCountryRegionInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.countryRegionCriterion != null && message.hasOwnProperty("countryRegionCriterion")) {
                                var error = $root.google.protobuf.StringValue.verify(message.countryRegionCriterion);
                                if (error)
                                    return "countryRegionCriterion." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a HotelCountryRegionInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.HotelCountryRegionInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.HotelCountryRegionInfo} HotelCountryRegionInfo
                         */
                        HotelCountryRegionInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.HotelCountryRegionInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.HotelCountryRegionInfo();
                            if (object.countryRegionCriterion != null) {
                                if (typeof object.countryRegionCriterion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.HotelCountryRegionInfo.countryRegionCriterion: object expected");
                                message.countryRegionCriterion = $root.google.protobuf.StringValue.fromObject(object.countryRegionCriterion);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a HotelCountryRegionInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.HotelCountryRegionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.HotelCountryRegionInfo} message HotelCountryRegionInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HotelCountryRegionInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.countryRegionCriterion = null;
                            if (message.countryRegionCriterion != null && message.hasOwnProperty("countryRegionCriterion"))
                                object.countryRegionCriterion = $root.google.protobuf.StringValue.toObject(message.countryRegionCriterion, options);
                            return object;
                        };

                        /**
                         * Converts this HotelCountryRegionInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.HotelCountryRegionInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HotelCountryRegionInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return HotelCountryRegionInfo;
                    })();

                    common.HotelStateInfo = (function() {

                        /**
                         * Properties of a HotelStateInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IHotelStateInfo
                         * @property {google.protobuf.IStringValue|null} [stateCriterion] HotelStateInfo stateCriterion
                         */

                        /**
                         * Constructs a new HotelStateInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a HotelStateInfo.
                         * @implements IHotelStateInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IHotelStateInfo=} [properties] Properties to set
                         */
                        function HotelStateInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * HotelStateInfo stateCriterion.
                         * @member {google.protobuf.IStringValue|null|undefined} stateCriterion
                         * @memberof google.ads.googleads.v1.common.HotelStateInfo
                         * @instance
                         */
                        HotelStateInfo.prototype.stateCriterion = null;

                        /**
                         * Creates a new HotelStateInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.HotelStateInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelStateInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.HotelStateInfo} HotelStateInfo instance
                         */
                        HotelStateInfo.create = function create(properties) {
                            return new HotelStateInfo(properties);
                        };

                        /**
                         * Encodes the specified HotelStateInfo message. Does not implicitly {@link google.ads.googleads.v1.common.HotelStateInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.HotelStateInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelStateInfo} message HotelStateInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelStateInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.stateCriterion != null && message.hasOwnProperty("stateCriterion"))
                                $root.google.protobuf.StringValue.encode(message.stateCriterion, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified HotelStateInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.HotelStateInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelStateInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelStateInfo} message HotelStateInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelStateInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a HotelStateInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.HotelStateInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.HotelStateInfo} HotelStateInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelStateInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.HotelStateInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.stateCriterion = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a HotelStateInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelStateInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.HotelStateInfo} HotelStateInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelStateInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a HotelStateInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.HotelStateInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HotelStateInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.stateCriterion != null && message.hasOwnProperty("stateCriterion")) {
                                var error = $root.google.protobuf.StringValue.verify(message.stateCriterion);
                                if (error)
                                    return "stateCriterion." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a HotelStateInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.HotelStateInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.HotelStateInfo} HotelStateInfo
                         */
                        HotelStateInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.HotelStateInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.HotelStateInfo();
                            if (object.stateCriterion != null) {
                                if (typeof object.stateCriterion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.HotelStateInfo.stateCriterion: object expected");
                                message.stateCriterion = $root.google.protobuf.StringValue.fromObject(object.stateCriterion);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a HotelStateInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.HotelStateInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.HotelStateInfo} message HotelStateInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HotelStateInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.stateCriterion = null;
                            if (message.stateCriterion != null && message.hasOwnProperty("stateCriterion"))
                                object.stateCriterion = $root.google.protobuf.StringValue.toObject(message.stateCriterion, options);
                            return object;
                        };

                        /**
                         * Converts this HotelStateInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.HotelStateInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HotelStateInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return HotelStateInfo;
                    })();

                    common.HotelCityInfo = (function() {

                        /**
                         * Properties of a HotelCityInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IHotelCityInfo
                         * @property {google.protobuf.IStringValue|null} [cityCriterion] HotelCityInfo cityCriterion
                         */

                        /**
                         * Constructs a new HotelCityInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a HotelCityInfo.
                         * @implements IHotelCityInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IHotelCityInfo=} [properties] Properties to set
                         */
                        function HotelCityInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * HotelCityInfo cityCriterion.
                         * @member {google.protobuf.IStringValue|null|undefined} cityCriterion
                         * @memberof google.ads.googleads.v1.common.HotelCityInfo
                         * @instance
                         */
                        HotelCityInfo.prototype.cityCriterion = null;

                        /**
                         * Creates a new HotelCityInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.HotelCityInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelCityInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.HotelCityInfo} HotelCityInfo instance
                         */
                        HotelCityInfo.create = function create(properties) {
                            return new HotelCityInfo(properties);
                        };

                        /**
                         * Encodes the specified HotelCityInfo message. Does not implicitly {@link google.ads.googleads.v1.common.HotelCityInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.HotelCityInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelCityInfo} message HotelCityInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelCityInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.cityCriterion != null && message.hasOwnProperty("cityCriterion"))
                                $root.google.protobuf.StringValue.encode(message.cityCriterion, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified HotelCityInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.HotelCityInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelCityInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelCityInfo} message HotelCityInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelCityInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a HotelCityInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.HotelCityInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.HotelCityInfo} HotelCityInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelCityInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.HotelCityInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.cityCriterion = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a HotelCityInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelCityInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.HotelCityInfo} HotelCityInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelCityInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a HotelCityInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.HotelCityInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HotelCityInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.cityCriterion != null && message.hasOwnProperty("cityCriterion")) {
                                var error = $root.google.protobuf.StringValue.verify(message.cityCriterion);
                                if (error)
                                    return "cityCriterion." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a HotelCityInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.HotelCityInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.HotelCityInfo} HotelCityInfo
                         */
                        HotelCityInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.HotelCityInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.HotelCityInfo();
                            if (object.cityCriterion != null) {
                                if (typeof object.cityCriterion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.HotelCityInfo.cityCriterion: object expected");
                                message.cityCriterion = $root.google.protobuf.StringValue.fromObject(object.cityCriterion);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a HotelCityInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.HotelCityInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.HotelCityInfo} message HotelCityInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HotelCityInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.cityCriterion = null;
                            if (message.cityCriterion != null && message.hasOwnProperty("cityCriterion"))
                                object.cityCriterion = $root.google.protobuf.StringValue.toObject(message.cityCriterion, options);
                            return object;
                        };

                        /**
                         * Converts this HotelCityInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.HotelCityInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HotelCityInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return HotelCityInfo;
                    })();

                    common.ListingCustomAttributeInfo = (function() {

                        /**
                         * Properties of a ListingCustomAttributeInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IListingCustomAttributeInfo
                         * @property {google.protobuf.IStringValue|null} [value] ListingCustomAttributeInfo value
                         * @property {google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum.ListingCustomAttributeIndex|null} [index] ListingCustomAttributeInfo index
                         */

                        /**
                         * Constructs a new ListingCustomAttributeInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ListingCustomAttributeInfo.
                         * @implements IListingCustomAttributeInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IListingCustomAttributeInfo=} [properties] Properties to set
                         */
                        function ListingCustomAttributeInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ListingCustomAttributeInfo value.
                         * @member {google.protobuf.IStringValue|null|undefined} value
                         * @memberof google.ads.googleads.v1.common.ListingCustomAttributeInfo
                         * @instance
                         */
                        ListingCustomAttributeInfo.prototype.value = null;

                        /**
                         * ListingCustomAttributeInfo index.
                         * @member {google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum.ListingCustomAttributeIndex} index
                         * @memberof google.ads.googleads.v1.common.ListingCustomAttributeInfo
                         * @instance
                         */
                        ListingCustomAttributeInfo.prototype.index = 0;

                        /**
                         * Creates a new ListingCustomAttributeInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ListingCustomAttributeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IListingCustomAttributeInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ListingCustomAttributeInfo} ListingCustomAttributeInfo instance
                         */
                        ListingCustomAttributeInfo.create = function create(properties) {
                            return new ListingCustomAttributeInfo(properties);
                        };

                        /**
                         * Encodes the specified ListingCustomAttributeInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ListingCustomAttributeInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ListingCustomAttributeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IListingCustomAttributeInfo} message ListingCustomAttributeInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListingCustomAttributeInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.value != null && message.hasOwnProperty("value"))
                                $root.google.protobuf.StringValue.encode(message.value, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.index != null && message.hasOwnProperty("index"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.index);
                            return writer;
                        };

                        /**
                         * Encodes the specified ListingCustomAttributeInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ListingCustomAttributeInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ListingCustomAttributeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IListingCustomAttributeInfo} message ListingCustomAttributeInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListingCustomAttributeInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ListingCustomAttributeInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ListingCustomAttributeInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ListingCustomAttributeInfo} ListingCustomAttributeInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListingCustomAttributeInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ListingCustomAttributeInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.value = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.index = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ListingCustomAttributeInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ListingCustomAttributeInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ListingCustomAttributeInfo} ListingCustomAttributeInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListingCustomAttributeInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ListingCustomAttributeInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ListingCustomAttributeInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListingCustomAttributeInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.value != null && message.hasOwnProperty("value")) {
                                var error = $root.google.protobuf.StringValue.verify(message.value);
                                if (error)
                                    return "value." + error;
                            }
                            if (message.index != null && message.hasOwnProperty("index"))
                                switch (message.index) {
                                default:
                                    return "index: enum value expected";
                                case 0:
                                case 1:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a ListingCustomAttributeInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ListingCustomAttributeInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ListingCustomAttributeInfo} ListingCustomAttributeInfo
                         */
                        ListingCustomAttributeInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ListingCustomAttributeInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ListingCustomAttributeInfo();
                            if (object.value != null) {
                                if (typeof object.value !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ListingCustomAttributeInfo.value: object expected");
                                message.value = $root.google.protobuf.StringValue.fromObject(object.value);
                            }
                            switch (object.index) {
                            case "UNSPECIFIED":
                            case 0:
                                message.index = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.index = 1;
                                break;
                            case "INDEX0":
                            case 7:
                                message.index = 7;
                                break;
                            case "INDEX1":
                            case 8:
                                message.index = 8;
                                break;
                            case "INDEX2":
                            case 9:
                                message.index = 9;
                                break;
                            case "INDEX3":
                            case 10:
                                message.index = 10;
                                break;
                            case "INDEX4":
                            case 11:
                                message.index = 11;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ListingCustomAttributeInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ListingCustomAttributeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ListingCustomAttributeInfo} message ListingCustomAttributeInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListingCustomAttributeInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.value = null;
                                object.index = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = $root.google.protobuf.StringValue.toObject(message.value, options);
                            if (message.index != null && message.hasOwnProperty("index"))
                                object.index = options.enums === String ? $root.google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum.ListingCustomAttributeIndex[message.index] : message.index;
                            return object;
                        };

                        /**
                         * Converts this ListingCustomAttributeInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ListingCustomAttributeInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListingCustomAttributeInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ListingCustomAttributeInfo;
                    })();

                    common.ProductBiddingCategoryInfo = (function() {

                        /**
                         * Properties of a ProductBiddingCategoryInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IProductBiddingCategoryInfo
                         * @property {google.protobuf.IInt64Value|null} [id] ProductBiddingCategoryInfo id
                         * @property {google.protobuf.IStringValue|null} [countryCode] ProductBiddingCategoryInfo countryCode
                         * @property {google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum.ProductBiddingCategoryLevel|null} [level] ProductBiddingCategoryInfo level
                         */

                        /**
                         * Constructs a new ProductBiddingCategoryInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ProductBiddingCategoryInfo.
                         * @implements IProductBiddingCategoryInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IProductBiddingCategoryInfo=} [properties] Properties to set
                         */
                        function ProductBiddingCategoryInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ProductBiddingCategoryInfo id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.common.ProductBiddingCategoryInfo
                         * @instance
                         */
                        ProductBiddingCategoryInfo.prototype.id = null;

                        /**
                         * ProductBiddingCategoryInfo countryCode.
                         * @member {google.protobuf.IStringValue|null|undefined} countryCode
                         * @memberof google.ads.googleads.v1.common.ProductBiddingCategoryInfo
                         * @instance
                         */
                        ProductBiddingCategoryInfo.prototype.countryCode = null;

                        /**
                         * ProductBiddingCategoryInfo level.
                         * @member {google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum.ProductBiddingCategoryLevel} level
                         * @memberof google.ads.googleads.v1.common.ProductBiddingCategoryInfo
                         * @instance
                         */
                        ProductBiddingCategoryInfo.prototype.level = 0;

                        /**
                         * Creates a new ProductBiddingCategoryInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ProductBiddingCategoryInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductBiddingCategoryInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ProductBiddingCategoryInfo} ProductBiddingCategoryInfo instance
                         */
                        ProductBiddingCategoryInfo.create = function create(properties) {
                            return new ProductBiddingCategoryInfo(properties);
                        };

                        /**
                         * Encodes the specified ProductBiddingCategoryInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ProductBiddingCategoryInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ProductBiddingCategoryInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductBiddingCategoryInfo} message ProductBiddingCategoryInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductBiddingCategoryInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                $root.google.protobuf.StringValue.encode(message.countryCode, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.level != null && message.hasOwnProperty("level"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.level);
                            return writer;
                        };

                        /**
                         * Encodes the specified ProductBiddingCategoryInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ProductBiddingCategoryInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ProductBiddingCategoryInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductBiddingCategoryInfo} message ProductBiddingCategoryInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductBiddingCategoryInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ProductBiddingCategoryInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ProductBiddingCategoryInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ProductBiddingCategoryInfo} ProductBiddingCategoryInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductBiddingCategoryInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ProductBiddingCategoryInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.countryCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.level = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ProductBiddingCategoryInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ProductBiddingCategoryInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ProductBiddingCategoryInfo} ProductBiddingCategoryInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductBiddingCategoryInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ProductBiddingCategoryInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ProductBiddingCategoryInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProductBiddingCategoryInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.countryCode != null && message.hasOwnProperty("countryCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.countryCode);
                                if (error)
                                    return "countryCode." + error;
                            }
                            if (message.level != null && message.hasOwnProperty("level"))
                                switch (message.level) {
                                default:
                                    return "level: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a ProductBiddingCategoryInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ProductBiddingCategoryInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ProductBiddingCategoryInfo} ProductBiddingCategoryInfo
                         */
                        ProductBiddingCategoryInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ProductBiddingCategoryInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ProductBiddingCategoryInfo();
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ProductBiddingCategoryInfo.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.countryCode != null) {
                                if (typeof object.countryCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ProductBiddingCategoryInfo.countryCode: object expected");
                                message.countryCode = $root.google.protobuf.StringValue.fromObject(object.countryCode);
                            }
                            switch (object.level) {
                            case "UNSPECIFIED":
                            case 0:
                                message.level = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.level = 1;
                                break;
                            case "LEVEL1":
                            case 2:
                                message.level = 2;
                                break;
                            case "LEVEL2":
                            case 3:
                                message.level = 3;
                                break;
                            case "LEVEL3":
                            case 4:
                                message.level = 4;
                                break;
                            case "LEVEL4":
                            case 5:
                                message.level = 5;
                                break;
                            case "LEVEL5":
                            case 6:
                                message.level = 6;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ProductBiddingCategoryInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ProductBiddingCategoryInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ProductBiddingCategoryInfo} message ProductBiddingCategoryInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProductBiddingCategoryInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.id = null;
                                object.countryCode = null;
                                object.level = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                object.countryCode = $root.google.protobuf.StringValue.toObject(message.countryCode, options);
                            if (message.level != null && message.hasOwnProperty("level"))
                                object.level = options.enums === String ? $root.google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum.ProductBiddingCategoryLevel[message.level] : message.level;
                            return object;
                        };

                        /**
                         * Converts this ProductBiddingCategoryInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ProductBiddingCategoryInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProductBiddingCategoryInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ProductBiddingCategoryInfo;
                    })();

                    common.ProductChannelInfo = (function() {

                        /**
                         * Properties of a ProductChannelInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IProductChannelInfo
                         * @property {google.ads.googleads.v1.enums.ProductChannelEnum.ProductChannel|null} [channel] ProductChannelInfo channel
                         */

                        /**
                         * Constructs a new ProductChannelInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ProductChannelInfo.
                         * @implements IProductChannelInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IProductChannelInfo=} [properties] Properties to set
                         */
                        function ProductChannelInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ProductChannelInfo channel.
                         * @member {google.ads.googleads.v1.enums.ProductChannelEnum.ProductChannel} channel
                         * @memberof google.ads.googleads.v1.common.ProductChannelInfo
                         * @instance
                         */
                        ProductChannelInfo.prototype.channel = 0;

                        /**
                         * Creates a new ProductChannelInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ProductChannelInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductChannelInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ProductChannelInfo} ProductChannelInfo instance
                         */
                        ProductChannelInfo.create = function create(properties) {
                            return new ProductChannelInfo(properties);
                        };

                        /**
                         * Encodes the specified ProductChannelInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ProductChannelInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ProductChannelInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductChannelInfo} message ProductChannelInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductChannelInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.channel != null && message.hasOwnProperty("channel"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.channel);
                            return writer;
                        };

                        /**
                         * Encodes the specified ProductChannelInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ProductChannelInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ProductChannelInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductChannelInfo} message ProductChannelInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductChannelInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ProductChannelInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ProductChannelInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ProductChannelInfo} ProductChannelInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductChannelInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ProductChannelInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.channel = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ProductChannelInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ProductChannelInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ProductChannelInfo} ProductChannelInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductChannelInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ProductChannelInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ProductChannelInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProductChannelInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.channel != null && message.hasOwnProperty("channel"))
                                switch (message.channel) {
                                default:
                                    return "channel: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a ProductChannelInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ProductChannelInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ProductChannelInfo} ProductChannelInfo
                         */
                        ProductChannelInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ProductChannelInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ProductChannelInfo();
                            switch (object.channel) {
                            case "UNSPECIFIED":
                            case 0:
                                message.channel = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.channel = 1;
                                break;
                            case "ONLINE":
                            case 2:
                                message.channel = 2;
                                break;
                            case "LOCAL":
                            case 3:
                                message.channel = 3;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ProductChannelInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ProductChannelInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ProductChannelInfo} message ProductChannelInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProductChannelInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.channel = options.enums === String ? "UNSPECIFIED" : 0;
                            if (message.channel != null && message.hasOwnProperty("channel"))
                                object.channel = options.enums === String ? $root.google.ads.googleads.v1.enums.ProductChannelEnum.ProductChannel[message.channel] : message.channel;
                            return object;
                        };

                        /**
                         * Converts this ProductChannelInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ProductChannelInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProductChannelInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ProductChannelInfo;
                    })();

                    common.ProductChannelExclusivityInfo = (function() {

                        /**
                         * Properties of a ProductChannelExclusivityInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IProductChannelExclusivityInfo
                         * @property {google.ads.googleads.v1.enums.ProductChannelExclusivityEnum.ProductChannelExclusivity|null} [channelExclusivity] ProductChannelExclusivityInfo channelExclusivity
                         */

                        /**
                         * Constructs a new ProductChannelExclusivityInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ProductChannelExclusivityInfo.
                         * @implements IProductChannelExclusivityInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IProductChannelExclusivityInfo=} [properties] Properties to set
                         */
                        function ProductChannelExclusivityInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ProductChannelExclusivityInfo channelExclusivity.
                         * @member {google.ads.googleads.v1.enums.ProductChannelExclusivityEnum.ProductChannelExclusivity} channelExclusivity
                         * @memberof google.ads.googleads.v1.common.ProductChannelExclusivityInfo
                         * @instance
                         */
                        ProductChannelExclusivityInfo.prototype.channelExclusivity = 0;

                        /**
                         * Creates a new ProductChannelExclusivityInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ProductChannelExclusivityInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductChannelExclusivityInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ProductChannelExclusivityInfo} ProductChannelExclusivityInfo instance
                         */
                        ProductChannelExclusivityInfo.create = function create(properties) {
                            return new ProductChannelExclusivityInfo(properties);
                        };

                        /**
                         * Encodes the specified ProductChannelExclusivityInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ProductChannelExclusivityInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ProductChannelExclusivityInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductChannelExclusivityInfo} message ProductChannelExclusivityInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductChannelExclusivityInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.channelExclusivity != null && message.hasOwnProperty("channelExclusivity"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.channelExclusivity);
                            return writer;
                        };

                        /**
                         * Encodes the specified ProductChannelExclusivityInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ProductChannelExclusivityInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ProductChannelExclusivityInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductChannelExclusivityInfo} message ProductChannelExclusivityInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductChannelExclusivityInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ProductChannelExclusivityInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ProductChannelExclusivityInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ProductChannelExclusivityInfo} ProductChannelExclusivityInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductChannelExclusivityInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ProductChannelExclusivityInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.channelExclusivity = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ProductChannelExclusivityInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ProductChannelExclusivityInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ProductChannelExclusivityInfo} ProductChannelExclusivityInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductChannelExclusivityInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ProductChannelExclusivityInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ProductChannelExclusivityInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProductChannelExclusivityInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.channelExclusivity != null && message.hasOwnProperty("channelExclusivity"))
                                switch (message.channelExclusivity) {
                                default:
                                    return "channelExclusivity: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a ProductChannelExclusivityInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ProductChannelExclusivityInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ProductChannelExclusivityInfo} ProductChannelExclusivityInfo
                         */
                        ProductChannelExclusivityInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ProductChannelExclusivityInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ProductChannelExclusivityInfo();
                            switch (object.channelExclusivity) {
                            case "UNSPECIFIED":
                            case 0:
                                message.channelExclusivity = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.channelExclusivity = 1;
                                break;
                            case "SINGLE_CHANNEL":
                            case 2:
                                message.channelExclusivity = 2;
                                break;
                            case "MULTI_CHANNEL":
                            case 3:
                                message.channelExclusivity = 3;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ProductChannelExclusivityInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ProductChannelExclusivityInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ProductChannelExclusivityInfo} message ProductChannelExclusivityInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProductChannelExclusivityInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.channelExclusivity = options.enums === String ? "UNSPECIFIED" : 0;
                            if (message.channelExclusivity != null && message.hasOwnProperty("channelExclusivity"))
                                object.channelExclusivity = options.enums === String ? $root.google.ads.googleads.v1.enums.ProductChannelExclusivityEnum.ProductChannelExclusivity[message.channelExclusivity] : message.channelExclusivity;
                            return object;
                        };

                        /**
                         * Converts this ProductChannelExclusivityInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ProductChannelExclusivityInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProductChannelExclusivityInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ProductChannelExclusivityInfo;
                    })();

                    common.ProductConditionInfo = (function() {

                        /**
                         * Properties of a ProductConditionInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IProductConditionInfo
                         * @property {google.ads.googleads.v1.enums.ProductConditionEnum.ProductCondition|null} [condition] ProductConditionInfo condition
                         */

                        /**
                         * Constructs a new ProductConditionInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ProductConditionInfo.
                         * @implements IProductConditionInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IProductConditionInfo=} [properties] Properties to set
                         */
                        function ProductConditionInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ProductConditionInfo condition.
                         * @member {google.ads.googleads.v1.enums.ProductConditionEnum.ProductCondition} condition
                         * @memberof google.ads.googleads.v1.common.ProductConditionInfo
                         * @instance
                         */
                        ProductConditionInfo.prototype.condition = 0;

                        /**
                         * Creates a new ProductConditionInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ProductConditionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductConditionInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ProductConditionInfo} ProductConditionInfo instance
                         */
                        ProductConditionInfo.create = function create(properties) {
                            return new ProductConditionInfo(properties);
                        };

                        /**
                         * Encodes the specified ProductConditionInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ProductConditionInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ProductConditionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductConditionInfo} message ProductConditionInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductConditionInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.condition != null && message.hasOwnProperty("condition"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.condition);
                            return writer;
                        };

                        /**
                         * Encodes the specified ProductConditionInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ProductConditionInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ProductConditionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductConditionInfo} message ProductConditionInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductConditionInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ProductConditionInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ProductConditionInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ProductConditionInfo} ProductConditionInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductConditionInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ProductConditionInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.condition = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ProductConditionInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ProductConditionInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ProductConditionInfo} ProductConditionInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductConditionInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ProductConditionInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ProductConditionInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProductConditionInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.condition != null && message.hasOwnProperty("condition"))
                                switch (message.condition) {
                                default:
                                    return "condition: enum value expected";
                                case 0:
                                case 1:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a ProductConditionInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ProductConditionInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ProductConditionInfo} ProductConditionInfo
                         */
                        ProductConditionInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ProductConditionInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ProductConditionInfo();
                            switch (object.condition) {
                            case "UNSPECIFIED":
                            case 0:
                                message.condition = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.condition = 1;
                                break;
                            case "NEW":
                            case 3:
                                message.condition = 3;
                                break;
                            case "REFURBISHED":
                            case 4:
                                message.condition = 4;
                                break;
                            case "USED":
                            case 5:
                                message.condition = 5;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ProductConditionInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ProductConditionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ProductConditionInfo} message ProductConditionInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProductConditionInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.condition = options.enums === String ? "UNSPECIFIED" : 0;
                            if (message.condition != null && message.hasOwnProperty("condition"))
                                object.condition = options.enums === String ? $root.google.ads.googleads.v1.enums.ProductConditionEnum.ProductCondition[message.condition] : message.condition;
                            return object;
                        };

                        /**
                         * Converts this ProductConditionInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ProductConditionInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProductConditionInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ProductConditionInfo;
                    })();

                    common.ProductItemIdInfo = (function() {

                        /**
                         * Properties of a ProductItemIdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IProductItemIdInfo
                         * @property {google.protobuf.IStringValue|null} [value] ProductItemIdInfo value
                         */

                        /**
                         * Constructs a new ProductItemIdInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ProductItemIdInfo.
                         * @implements IProductItemIdInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IProductItemIdInfo=} [properties] Properties to set
                         */
                        function ProductItemIdInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ProductItemIdInfo value.
                         * @member {google.protobuf.IStringValue|null|undefined} value
                         * @memberof google.ads.googleads.v1.common.ProductItemIdInfo
                         * @instance
                         */
                        ProductItemIdInfo.prototype.value = null;

                        /**
                         * Creates a new ProductItemIdInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ProductItemIdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductItemIdInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ProductItemIdInfo} ProductItemIdInfo instance
                         */
                        ProductItemIdInfo.create = function create(properties) {
                            return new ProductItemIdInfo(properties);
                        };

                        /**
                         * Encodes the specified ProductItemIdInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ProductItemIdInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ProductItemIdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductItemIdInfo} message ProductItemIdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductItemIdInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.value != null && message.hasOwnProperty("value"))
                                $root.google.protobuf.StringValue.encode(message.value, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ProductItemIdInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ProductItemIdInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ProductItemIdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductItemIdInfo} message ProductItemIdInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductItemIdInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ProductItemIdInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ProductItemIdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ProductItemIdInfo} ProductItemIdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductItemIdInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ProductItemIdInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.value = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ProductItemIdInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ProductItemIdInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ProductItemIdInfo} ProductItemIdInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductItemIdInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ProductItemIdInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ProductItemIdInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProductItemIdInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.value != null && message.hasOwnProperty("value")) {
                                var error = $root.google.protobuf.StringValue.verify(message.value);
                                if (error)
                                    return "value." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a ProductItemIdInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ProductItemIdInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ProductItemIdInfo} ProductItemIdInfo
                         */
                        ProductItemIdInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ProductItemIdInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ProductItemIdInfo();
                            if (object.value != null) {
                                if (typeof object.value !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ProductItemIdInfo.value: object expected");
                                message.value = $root.google.protobuf.StringValue.fromObject(object.value);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ProductItemIdInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ProductItemIdInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ProductItemIdInfo} message ProductItemIdInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProductItemIdInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.value = null;
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = $root.google.protobuf.StringValue.toObject(message.value, options);
                            return object;
                        };

                        /**
                         * Converts this ProductItemIdInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ProductItemIdInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProductItemIdInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ProductItemIdInfo;
                    })();

                    common.ProductTypeInfo = (function() {

                        /**
                         * Properties of a ProductTypeInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IProductTypeInfo
                         * @property {google.protobuf.IStringValue|null} [value] ProductTypeInfo value
                         * @property {google.ads.googleads.v1.enums.ProductTypeLevelEnum.ProductTypeLevel|null} [level] ProductTypeInfo level
                         */

                        /**
                         * Constructs a new ProductTypeInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ProductTypeInfo.
                         * @implements IProductTypeInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IProductTypeInfo=} [properties] Properties to set
                         */
                        function ProductTypeInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ProductTypeInfo value.
                         * @member {google.protobuf.IStringValue|null|undefined} value
                         * @memberof google.ads.googleads.v1.common.ProductTypeInfo
                         * @instance
                         */
                        ProductTypeInfo.prototype.value = null;

                        /**
                         * ProductTypeInfo level.
                         * @member {google.ads.googleads.v1.enums.ProductTypeLevelEnum.ProductTypeLevel} level
                         * @memberof google.ads.googleads.v1.common.ProductTypeInfo
                         * @instance
                         */
                        ProductTypeInfo.prototype.level = 0;

                        /**
                         * Creates a new ProductTypeInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ProductTypeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductTypeInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ProductTypeInfo} ProductTypeInfo instance
                         */
                        ProductTypeInfo.create = function create(properties) {
                            return new ProductTypeInfo(properties);
                        };

                        /**
                         * Encodes the specified ProductTypeInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ProductTypeInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ProductTypeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductTypeInfo} message ProductTypeInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductTypeInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.value != null && message.hasOwnProperty("value"))
                                $root.google.protobuf.StringValue.encode(message.value, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.level != null && message.hasOwnProperty("level"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.level);
                            return writer;
                        };

                        /**
                         * Encodes the specified ProductTypeInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ProductTypeInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ProductTypeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProductTypeInfo} message ProductTypeInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductTypeInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ProductTypeInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ProductTypeInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ProductTypeInfo} ProductTypeInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductTypeInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ProductTypeInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.value = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.level = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ProductTypeInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ProductTypeInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ProductTypeInfo} ProductTypeInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductTypeInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ProductTypeInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ProductTypeInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProductTypeInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.value != null && message.hasOwnProperty("value")) {
                                var error = $root.google.protobuf.StringValue.verify(message.value);
                                if (error)
                                    return "value." + error;
                            }
                            if (message.level != null && message.hasOwnProperty("level"))
                                switch (message.level) {
                                default:
                                    return "level: enum value expected";
                                case 0:
                                case 1:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a ProductTypeInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ProductTypeInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ProductTypeInfo} ProductTypeInfo
                         */
                        ProductTypeInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ProductTypeInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ProductTypeInfo();
                            if (object.value != null) {
                                if (typeof object.value !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ProductTypeInfo.value: object expected");
                                message.value = $root.google.protobuf.StringValue.fromObject(object.value);
                            }
                            switch (object.level) {
                            case "UNSPECIFIED":
                            case 0:
                                message.level = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.level = 1;
                                break;
                            case "LEVEL1":
                            case 7:
                                message.level = 7;
                                break;
                            case "LEVEL2":
                            case 8:
                                message.level = 8;
                                break;
                            case "LEVEL3":
                            case 9:
                                message.level = 9;
                                break;
                            case "LEVEL4":
                            case 10:
                                message.level = 10;
                                break;
                            case "LEVEL5":
                            case 11:
                                message.level = 11;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ProductTypeInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ProductTypeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ProductTypeInfo} message ProductTypeInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProductTypeInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.value = null;
                                object.level = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = $root.google.protobuf.StringValue.toObject(message.value, options);
                            if (message.level != null && message.hasOwnProperty("level"))
                                object.level = options.enums === String ? $root.google.ads.googleads.v1.enums.ProductTypeLevelEnum.ProductTypeLevel[message.level] : message.level;
                            return object;
                        };

                        /**
                         * Converts this ProductTypeInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ProductTypeInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProductTypeInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ProductTypeInfo;
                    })();

                    common.UnknownListingDimensionInfo = (function() {

                        /**
                         * Properties of an UnknownListingDimensionInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IUnknownListingDimensionInfo
                         */

                        /**
                         * Constructs a new UnknownListingDimensionInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an UnknownListingDimensionInfo.
                         * @implements IUnknownListingDimensionInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IUnknownListingDimensionInfo=} [properties] Properties to set
                         */
                        function UnknownListingDimensionInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new UnknownListingDimensionInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.UnknownListingDimensionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUnknownListingDimensionInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.UnknownListingDimensionInfo} UnknownListingDimensionInfo instance
                         */
                        UnknownListingDimensionInfo.create = function create(properties) {
                            return new UnknownListingDimensionInfo(properties);
                        };

                        /**
                         * Encodes the specified UnknownListingDimensionInfo message. Does not implicitly {@link google.ads.googleads.v1.common.UnknownListingDimensionInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.UnknownListingDimensionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUnknownListingDimensionInfo} message UnknownListingDimensionInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UnknownListingDimensionInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified UnknownListingDimensionInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.UnknownListingDimensionInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.UnknownListingDimensionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUnknownListingDimensionInfo} message UnknownListingDimensionInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UnknownListingDimensionInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an UnknownListingDimensionInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.UnknownListingDimensionInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.UnknownListingDimensionInfo} UnknownListingDimensionInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UnknownListingDimensionInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.UnknownListingDimensionInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an UnknownListingDimensionInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.UnknownListingDimensionInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.UnknownListingDimensionInfo} UnknownListingDimensionInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UnknownListingDimensionInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an UnknownListingDimensionInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.UnknownListingDimensionInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UnknownListingDimensionInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an UnknownListingDimensionInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.UnknownListingDimensionInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.UnknownListingDimensionInfo} UnknownListingDimensionInfo
                         */
                        UnknownListingDimensionInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.UnknownListingDimensionInfo)
                                return object;
                            return new $root.google.ads.googleads.v1.common.UnknownListingDimensionInfo();
                        };

                        /**
                         * Creates a plain object from an UnknownListingDimensionInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.UnknownListingDimensionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.UnknownListingDimensionInfo} message UnknownListingDimensionInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UnknownListingDimensionInfo.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this UnknownListingDimensionInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.UnknownListingDimensionInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UnknownListingDimensionInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UnknownListingDimensionInfo;
                    })();

                    common.HotelDateSelectionTypeInfo = (function() {

                        /**
                         * Properties of a HotelDateSelectionTypeInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IHotelDateSelectionTypeInfo
                         * @property {google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum.HotelDateSelectionType|null} [type] HotelDateSelectionTypeInfo type
                         */

                        /**
                         * Constructs a new HotelDateSelectionTypeInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a HotelDateSelectionTypeInfo.
                         * @implements IHotelDateSelectionTypeInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IHotelDateSelectionTypeInfo=} [properties] Properties to set
                         */
                        function HotelDateSelectionTypeInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * HotelDateSelectionTypeInfo type.
                         * @member {google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum.HotelDateSelectionType} type
                         * @memberof google.ads.googleads.v1.common.HotelDateSelectionTypeInfo
                         * @instance
                         */
                        HotelDateSelectionTypeInfo.prototype.type = 0;

                        /**
                         * Creates a new HotelDateSelectionTypeInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.HotelDateSelectionTypeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelDateSelectionTypeInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.HotelDateSelectionTypeInfo} HotelDateSelectionTypeInfo instance
                         */
                        HotelDateSelectionTypeInfo.create = function create(properties) {
                            return new HotelDateSelectionTypeInfo(properties);
                        };

                        /**
                         * Encodes the specified HotelDateSelectionTypeInfo message. Does not implicitly {@link google.ads.googleads.v1.common.HotelDateSelectionTypeInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.HotelDateSelectionTypeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelDateSelectionTypeInfo} message HotelDateSelectionTypeInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelDateSelectionTypeInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.type);
                            return writer;
                        };

                        /**
                         * Encodes the specified HotelDateSelectionTypeInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.HotelDateSelectionTypeInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelDateSelectionTypeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelDateSelectionTypeInfo} message HotelDateSelectionTypeInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelDateSelectionTypeInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a HotelDateSelectionTypeInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.HotelDateSelectionTypeInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.HotelDateSelectionTypeInfo} HotelDateSelectionTypeInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelDateSelectionTypeInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.HotelDateSelectionTypeInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.type = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a HotelDateSelectionTypeInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelDateSelectionTypeInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.HotelDateSelectionTypeInfo} HotelDateSelectionTypeInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelDateSelectionTypeInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a HotelDateSelectionTypeInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.HotelDateSelectionTypeInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HotelDateSelectionTypeInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 50:
                                case 51:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a HotelDateSelectionTypeInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.HotelDateSelectionTypeInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.HotelDateSelectionTypeInfo} HotelDateSelectionTypeInfo
                         */
                        HotelDateSelectionTypeInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.HotelDateSelectionTypeInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.HotelDateSelectionTypeInfo();
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "DEFAULT_SELECTION":
                            case 50:
                                message.type = 50;
                                break;
                            case "USER_SELECTED":
                            case 51:
                                message.type = 51;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a HotelDateSelectionTypeInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.HotelDateSelectionTypeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.HotelDateSelectionTypeInfo} message HotelDateSelectionTypeInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HotelDateSelectionTypeInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum.HotelDateSelectionType[message.type] : message.type;
                            return object;
                        };

                        /**
                         * Converts this HotelDateSelectionTypeInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.HotelDateSelectionTypeInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HotelDateSelectionTypeInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return HotelDateSelectionTypeInfo;
                    })();

                    common.HotelAdvanceBookingWindowInfo = (function() {

                        /**
                         * Properties of a HotelAdvanceBookingWindowInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IHotelAdvanceBookingWindowInfo
                         * @property {google.protobuf.IInt64Value|null} [minDays] HotelAdvanceBookingWindowInfo minDays
                         * @property {google.protobuf.IInt64Value|null} [maxDays] HotelAdvanceBookingWindowInfo maxDays
                         */

                        /**
                         * Constructs a new HotelAdvanceBookingWindowInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a HotelAdvanceBookingWindowInfo.
                         * @implements IHotelAdvanceBookingWindowInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IHotelAdvanceBookingWindowInfo=} [properties] Properties to set
                         */
                        function HotelAdvanceBookingWindowInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * HotelAdvanceBookingWindowInfo minDays.
                         * @member {google.protobuf.IInt64Value|null|undefined} minDays
                         * @memberof google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo
                         * @instance
                         */
                        HotelAdvanceBookingWindowInfo.prototype.minDays = null;

                        /**
                         * HotelAdvanceBookingWindowInfo maxDays.
                         * @member {google.protobuf.IInt64Value|null|undefined} maxDays
                         * @memberof google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo
                         * @instance
                         */
                        HotelAdvanceBookingWindowInfo.prototype.maxDays = null;

                        /**
                         * Creates a new HotelAdvanceBookingWindowInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelAdvanceBookingWindowInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo} HotelAdvanceBookingWindowInfo instance
                         */
                        HotelAdvanceBookingWindowInfo.create = function create(properties) {
                            return new HotelAdvanceBookingWindowInfo(properties);
                        };

                        /**
                         * Encodes the specified HotelAdvanceBookingWindowInfo message. Does not implicitly {@link google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelAdvanceBookingWindowInfo} message HotelAdvanceBookingWindowInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelAdvanceBookingWindowInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.minDays != null && message.hasOwnProperty("minDays"))
                                $root.google.protobuf.Int64Value.encode(message.minDays, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.maxDays != null && message.hasOwnProperty("maxDays"))
                                $root.google.protobuf.Int64Value.encode(message.maxDays, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified HotelAdvanceBookingWindowInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelAdvanceBookingWindowInfo} message HotelAdvanceBookingWindowInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelAdvanceBookingWindowInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a HotelAdvanceBookingWindowInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo} HotelAdvanceBookingWindowInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelAdvanceBookingWindowInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.minDays = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.maxDays = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a HotelAdvanceBookingWindowInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo} HotelAdvanceBookingWindowInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelAdvanceBookingWindowInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a HotelAdvanceBookingWindowInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HotelAdvanceBookingWindowInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.minDays != null && message.hasOwnProperty("minDays")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.minDays);
                                if (error)
                                    return "minDays." + error;
                            }
                            if (message.maxDays != null && message.hasOwnProperty("maxDays")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.maxDays);
                                if (error)
                                    return "maxDays." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a HotelAdvanceBookingWindowInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo} HotelAdvanceBookingWindowInfo
                         */
                        HotelAdvanceBookingWindowInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo();
                            if (object.minDays != null) {
                                if (typeof object.minDays !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo.minDays: object expected");
                                message.minDays = $root.google.protobuf.Int64Value.fromObject(object.minDays);
                            }
                            if (object.maxDays != null) {
                                if (typeof object.maxDays !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo.maxDays: object expected");
                                message.maxDays = $root.google.protobuf.Int64Value.fromObject(object.maxDays);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a HotelAdvanceBookingWindowInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo} message HotelAdvanceBookingWindowInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HotelAdvanceBookingWindowInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.minDays = null;
                                object.maxDays = null;
                            }
                            if (message.minDays != null && message.hasOwnProperty("minDays"))
                                object.minDays = $root.google.protobuf.Int64Value.toObject(message.minDays, options);
                            if (message.maxDays != null && message.hasOwnProperty("maxDays"))
                                object.maxDays = $root.google.protobuf.Int64Value.toObject(message.maxDays, options);
                            return object;
                        };

                        /**
                         * Converts this HotelAdvanceBookingWindowInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HotelAdvanceBookingWindowInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return HotelAdvanceBookingWindowInfo;
                    })();

                    common.HotelLengthOfStayInfo = (function() {

                        /**
                         * Properties of a HotelLengthOfStayInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IHotelLengthOfStayInfo
                         * @property {google.protobuf.IInt64Value|null} [minNights] HotelLengthOfStayInfo minNights
                         * @property {google.protobuf.IInt64Value|null} [maxNights] HotelLengthOfStayInfo maxNights
                         */

                        /**
                         * Constructs a new HotelLengthOfStayInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a HotelLengthOfStayInfo.
                         * @implements IHotelLengthOfStayInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IHotelLengthOfStayInfo=} [properties] Properties to set
                         */
                        function HotelLengthOfStayInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * HotelLengthOfStayInfo minNights.
                         * @member {google.protobuf.IInt64Value|null|undefined} minNights
                         * @memberof google.ads.googleads.v1.common.HotelLengthOfStayInfo
                         * @instance
                         */
                        HotelLengthOfStayInfo.prototype.minNights = null;

                        /**
                         * HotelLengthOfStayInfo maxNights.
                         * @member {google.protobuf.IInt64Value|null|undefined} maxNights
                         * @memberof google.ads.googleads.v1.common.HotelLengthOfStayInfo
                         * @instance
                         */
                        HotelLengthOfStayInfo.prototype.maxNights = null;

                        /**
                         * Creates a new HotelLengthOfStayInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.HotelLengthOfStayInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelLengthOfStayInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.HotelLengthOfStayInfo} HotelLengthOfStayInfo instance
                         */
                        HotelLengthOfStayInfo.create = function create(properties) {
                            return new HotelLengthOfStayInfo(properties);
                        };

                        /**
                         * Encodes the specified HotelLengthOfStayInfo message. Does not implicitly {@link google.ads.googleads.v1.common.HotelLengthOfStayInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.HotelLengthOfStayInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelLengthOfStayInfo} message HotelLengthOfStayInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelLengthOfStayInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.minNights != null && message.hasOwnProperty("minNights"))
                                $root.google.protobuf.Int64Value.encode(message.minNights, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.maxNights != null && message.hasOwnProperty("maxNights"))
                                $root.google.protobuf.Int64Value.encode(message.maxNights, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified HotelLengthOfStayInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.HotelLengthOfStayInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelLengthOfStayInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelLengthOfStayInfo} message HotelLengthOfStayInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelLengthOfStayInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a HotelLengthOfStayInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.HotelLengthOfStayInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.HotelLengthOfStayInfo} HotelLengthOfStayInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelLengthOfStayInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.HotelLengthOfStayInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.minNights = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.maxNights = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a HotelLengthOfStayInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelLengthOfStayInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.HotelLengthOfStayInfo} HotelLengthOfStayInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelLengthOfStayInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a HotelLengthOfStayInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.HotelLengthOfStayInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HotelLengthOfStayInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.minNights != null && message.hasOwnProperty("minNights")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.minNights);
                                if (error)
                                    return "minNights." + error;
                            }
                            if (message.maxNights != null && message.hasOwnProperty("maxNights")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.maxNights);
                                if (error)
                                    return "maxNights." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a HotelLengthOfStayInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.HotelLengthOfStayInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.HotelLengthOfStayInfo} HotelLengthOfStayInfo
                         */
                        HotelLengthOfStayInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.HotelLengthOfStayInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.HotelLengthOfStayInfo();
                            if (object.minNights != null) {
                                if (typeof object.minNights !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.HotelLengthOfStayInfo.minNights: object expected");
                                message.minNights = $root.google.protobuf.Int64Value.fromObject(object.minNights);
                            }
                            if (object.maxNights != null) {
                                if (typeof object.maxNights !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.HotelLengthOfStayInfo.maxNights: object expected");
                                message.maxNights = $root.google.protobuf.Int64Value.fromObject(object.maxNights);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a HotelLengthOfStayInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.HotelLengthOfStayInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.HotelLengthOfStayInfo} message HotelLengthOfStayInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HotelLengthOfStayInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.minNights = null;
                                object.maxNights = null;
                            }
                            if (message.minNights != null && message.hasOwnProperty("minNights"))
                                object.minNights = $root.google.protobuf.Int64Value.toObject(message.minNights, options);
                            if (message.maxNights != null && message.hasOwnProperty("maxNights"))
                                object.maxNights = $root.google.protobuf.Int64Value.toObject(message.maxNights, options);
                            return object;
                        };

                        /**
                         * Converts this HotelLengthOfStayInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.HotelLengthOfStayInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HotelLengthOfStayInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return HotelLengthOfStayInfo;
                    })();

                    common.HotelCheckInDayInfo = (function() {

                        /**
                         * Properties of a HotelCheckInDayInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IHotelCheckInDayInfo
                         * @property {google.ads.googleads.v1.enums.DayOfWeekEnum.DayOfWeek|null} [dayOfWeek] HotelCheckInDayInfo dayOfWeek
                         */

                        /**
                         * Constructs a new HotelCheckInDayInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a HotelCheckInDayInfo.
                         * @implements IHotelCheckInDayInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IHotelCheckInDayInfo=} [properties] Properties to set
                         */
                        function HotelCheckInDayInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * HotelCheckInDayInfo dayOfWeek.
                         * @member {google.ads.googleads.v1.enums.DayOfWeekEnum.DayOfWeek} dayOfWeek
                         * @memberof google.ads.googleads.v1.common.HotelCheckInDayInfo
                         * @instance
                         */
                        HotelCheckInDayInfo.prototype.dayOfWeek = 0;

                        /**
                         * Creates a new HotelCheckInDayInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.HotelCheckInDayInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelCheckInDayInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.HotelCheckInDayInfo} HotelCheckInDayInfo instance
                         */
                        HotelCheckInDayInfo.create = function create(properties) {
                            return new HotelCheckInDayInfo(properties);
                        };

                        /**
                         * Encodes the specified HotelCheckInDayInfo message. Does not implicitly {@link google.ads.googleads.v1.common.HotelCheckInDayInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.HotelCheckInDayInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelCheckInDayInfo} message HotelCheckInDayInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelCheckInDayInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dayOfWeek != null && message.hasOwnProperty("dayOfWeek"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.dayOfWeek);
                            return writer;
                        };

                        /**
                         * Encodes the specified HotelCheckInDayInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.HotelCheckInDayInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelCheckInDayInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IHotelCheckInDayInfo} message HotelCheckInDayInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelCheckInDayInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a HotelCheckInDayInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.HotelCheckInDayInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.HotelCheckInDayInfo} HotelCheckInDayInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelCheckInDayInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.HotelCheckInDayInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.dayOfWeek = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a HotelCheckInDayInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.HotelCheckInDayInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.HotelCheckInDayInfo} HotelCheckInDayInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelCheckInDayInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a HotelCheckInDayInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.HotelCheckInDayInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HotelCheckInDayInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.dayOfWeek != null && message.hasOwnProperty("dayOfWeek"))
                                switch (message.dayOfWeek) {
                                default:
                                    return "dayOfWeek: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a HotelCheckInDayInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.HotelCheckInDayInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.HotelCheckInDayInfo} HotelCheckInDayInfo
                         */
                        HotelCheckInDayInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.HotelCheckInDayInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.HotelCheckInDayInfo();
                            switch (object.dayOfWeek) {
                            case "UNSPECIFIED":
                            case 0:
                                message.dayOfWeek = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.dayOfWeek = 1;
                                break;
                            case "MONDAY":
                            case 2:
                                message.dayOfWeek = 2;
                                break;
                            case "TUESDAY":
                            case 3:
                                message.dayOfWeek = 3;
                                break;
                            case "WEDNESDAY":
                            case 4:
                                message.dayOfWeek = 4;
                                break;
                            case "THURSDAY":
                            case 5:
                                message.dayOfWeek = 5;
                                break;
                            case "FRIDAY":
                            case 6:
                                message.dayOfWeek = 6;
                                break;
                            case "SATURDAY":
                            case 7:
                                message.dayOfWeek = 7;
                                break;
                            case "SUNDAY":
                            case 8:
                                message.dayOfWeek = 8;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a HotelCheckInDayInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.HotelCheckInDayInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.HotelCheckInDayInfo} message HotelCheckInDayInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HotelCheckInDayInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.dayOfWeek = options.enums === String ? "UNSPECIFIED" : 0;
                            if (message.dayOfWeek != null && message.hasOwnProperty("dayOfWeek"))
                                object.dayOfWeek = options.enums === String ? $root.google.ads.googleads.v1.enums.DayOfWeekEnum.DayOfWeek[message.dayOfWeek] : message.dayOfWeek;
                            return object;
                        };

                        /**
                         * Converts this HotelCheckInDayInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.HotelCheckInDayInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HotelCheckInDayInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return HotelCheckInDayInfo;
                    })();

                    common.InteractionTypeInfo = (function() {

                        /**
                         * Properties of an InteractionTypeInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IInteractionTypeInfo
                         * @property {google.ads.googleads.v1.enums.InteractionTypeEnum.InteractionType|null} [type] InteractionTypeInfo type
                         */

                        /**
                         * Constructs a new InteractionTypeInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an InteractionTypeInfo.
                         * @implements IInteractionTypeInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IInteractionTypeInfo=} [properties] Properties to set
                         */
                        function InteractionTypeInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * InteractionTypeInfo type.
                         * @member {google.ads.googleads.v1.enums.InteractionTypeEnum.InteractionType} type
                         * @memberof google.ads.googleads.v1.common.InteractionTypeInfo
                         * @instance
                         */
                        InteractionTypeInfo.prototype.type = 0;

                        /**
                         * Creates a new InteractionTypeInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.InteractionTypeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IInteractionTypeInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.InteractionTypeInfo} InteractionTypeInfo instance
                         */
                        InteractionTypeInfo.create = function create(properties) {
                            return new InteractionTypeInfo(properties);
                        };

                        /**
                         * Encodes the specified InteractionTypeInfo message. Does not implicitly {@link google.ads.googleads.v1.common.InteractionTypeInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.InteractionTypeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IInteractionTypeInfo} message InteractionTypeInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InteractionTypeInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.type);
                            return writer;
                        };

                        /**
                         * Encodes the specified InteractionTypeInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.InteractionTypeInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.InteractionTypeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IInteractionTypeInfo} message InteractionTypeInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InteractionTypeInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an InteractionTypeInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.InteractionTypeInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.InteractionTypeInfo} InteractionTypeInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InteractionTypeInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.InteractionTypeInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.type = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an InteractionTypeInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.InteractionTypeInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.InteractionTypeInfo} InteractionTypeInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InteractionTypeInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an InteractionTypeInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.InteractionTypeInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InteractionTypeInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 8000:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates an InteractionTypeInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.InteractionTypeInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.InteractionTypeInfo} InteractionTypeInfo
                         */
                        InteractionTypeInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.InteractionTypeInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.InteractionTypeInfo();
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "CALLS":
                            case 8000:
                                message.type = 8000;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an InteractionTypeInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.InteractionTypeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.InteractionTypeInfo} message InteractionTypeInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InteractionTypeInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.InteractionTypeEnum.InteractionType[message.type] : message.type;
                            return object;
                        };

                        /**
                         * Converts this InteractionTypeInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.InteractionTypeInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InteractionTypeInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return InteractionTypeInfo;
                    })();

                    common.AdScheduleInfo = (function() {

                        /**
                         * Properties of an AdScheduleInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IAdScheduleInfo
                         * @property {google.ads.googleads.v1.enums.MinuteOfHourEnum.MinuteOfHour|null} [startMinute] AdScheduleInfo startMinute
                         * @property {google.ads.googleads.v1.enums.MinuteOfHourEnum.MinuteOfHour|null} [endMinute] AdScheduleInfo endMinute
                         * @property {google.protobuf.IInt32Value|null} [startHour] AdScheduleInfo startHour
                         * @property {google.protobuf.IInt32Value|null} [endHour] AdScheduleInfo endHour
                         * @property {google.ads.googleads.v1.enums.DayOfWeekEnum.DayOfWeek|null} [dayOfWeek] AdScheduleInfo dayOfWeek
                         */

                        /**
                         * Constructs a new AdScheduleInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an AdScheduleInfo.
                         * @implements IAdScheduleInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IAdScheduleInfo=} [properties] Properties to set
                         */
                        function AdScheduleInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdScheduleInfo startMinute.
                         * @member {google.ads.googleads.v1.enums.MinuteOfHourEnum.MinuteOfHour} startMinute
                         * @memberof google.ads.googleads.v1.common.AdScheduleInfo
                         * @instance
                         */
                        AdScheduleInfo.prototype.startMinute = 0;

                        /**
                         * AdScheduleInfo endMinute.
                         * @member {google.ads.googleads.v1.enums.MinuteOfHourEnum.MinuteOfHour} endMinute
                         * @memberof google.ads.googleads.v1.common.AdScheduleInfo
                         * @instance
                         */
                        AdScheduleInfo.prototype.endMinute = 0;

                        /**
                         * AdScheduleInfo startHour.
                         * @member {google.protobuf.IInt32Value|null|undefined} startHour
                         * @memberof google.ads.googleads.v1.common.AdScheduleInfo
                         * @instance
                         */
                        AdScheduleInfo.prototype.startHour = null;

                        /**
                         * AdScheduleInfo endHour.
                         * @member {google.protobuf.IInt32Value|null|undefined} endHour
                         * @memberof google.ads.googleads.v1.common.AdScheduleInfo
                         * @instance
                         */
                        AdScheduleInfo.prototype.endHour = null;

                        /**
                         * AdScheduleInfo dayOfWeek.
                         * @member {google.ads.googleads.v1.enums.DayOfWeekEnum.DayOfWeek} dayOfWeek
                         * @memberof google.ads.googleads.v1.common.AdScheduleInfo
                         * @instance
                         */
                        AdScheduleInfo.prototype.dayOfWeek = 0;

                        /**
                         * Creates a new AdScheduleInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.AdScheduleInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IAdScheduleInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.AdScheduleInfo} AdScheduleInfo instance
                         */
                        AdScheduleInfo.create = function create(properties) {
                            return new AdScheduleInfo(properties);
                        };

                        /**
                         * Encodes the specified AdScheduleInfo message. Does not implicitly {@link google.ads.googleads.v1.common.AdScheduleInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.AdScheduleInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IAdScheduleInfo} message AdScheduleInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdScheduleInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.startMinute != null && message.hasOwnProperty("startMinute"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.startMinute);
                            if (message.endMinute != null && message.hasOwnProperty("endMinute"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.endMinute);
                            if (message.startHour != null && message.hasOwnProperty("startHour"))
                                $root.google.protobuf.Int32Value.encode(message.startHour, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.endHour != null && message.hasOwnProperty("endHour"))
                                $root.google.protobuf.Int32Value.encode(message.endHour, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.dayOfWeek != null && message.hasOwnProperty("dayOfWeek"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.dayOfWeek);
                            return writer;
                        };

                        /**
                         * Encodes the specified AdScheduleInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.AdScheduleInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.AdScheduleInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IAdScheduleInfo} message AdScheduleInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdScheduleInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdScheduleInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.AdScheduleInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.AdScheduleInfo} AdScheduleInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdScheduleInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.AdScheduleInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.startMinute = reader.int32();
                                    break;
                                case 2:
                                    message.endMinute = reader.int32();
                                    break;
                                case 3:
                                    message.startHour = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.endHour = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.dayOfWeek = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdScheduleInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.AdScheduleInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.AdScheduleInfo} AdScheduleInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdScheduleInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdScheduleInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.AdScheduleInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdScheduleInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.startMinute != null && message.hasOwnProperty("startMinute"))
                                switch (message.startMinute) {
                                default:
                                    return "startMinute: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            if (message.endMinute != null && message.hasOwnProperty("endMinute"))
                                switch (message.endMinute) {
                                default:
                                    return "endMinute: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            if (message.startHour != null && message.hasOwnProperty("startHour")) {
                                var error = $root.google.protobuf.Int32Value.verify(message.startHour);
                                if (error)
                                    return "startHour." + error;
                            }
                            if (message.endHour != null && message.hasOwnProperty("endHour")) {
                                var error = $root.google.protobuf.Int32Value.verify(message.endHour);
                                if (error)
                                    return "endHour." + error;
                            }
                            if (message.dayOfWeek != null && message.hasOwnProperty("dayOfWeek"))
                                switch (message.dayOfWeek) {
                                default:
                                    return "dayOfWeek: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates an AdScheduleInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.AdScheduleInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.AdScheduleInfo} AdScheduleInfo
                         */
                        AdScheduleInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.AdScheduleInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.AdScheduleInfo();
                            switch (object.startMinute) {
                            case "UNSPECIFIED":
                            case 0:
                                message.startMinute = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.startMinute = 1;
                                break;
                            case "ZERO":
                            case 2:
                                message.startMinute = 2;
                                break;
                            case "FIFTEEN":
                            case 3:
                                message.startMinute = 3;
                                break;
                            case "THIRTY":
                            case 4:
                                message.startMinute = 4;
                                break;
                            case "FORTY_FIVE":
                            case 5:
                                message.startMinute = 5;
                                break;
                            }
                            switch (object.endMinute) {
                            case "UNSPECIFIED":
                            case 0:
                                message.endMinute = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.endMinute = 1;
                                break;
                            case "ZERO":
                            case 2:
                                message.endMinute = 2;
                                break;
                            case "FIFTEEN":
                            case 3:
                                message.endMinute = 3;
                                break;
                            case "THIRTY":
                            case 4:
                                message.endMinute = 4;
                                break;
                            case "FORTY_FIVE":
                            case 5:
                                message.endMinute = 5;
                                break;
                            }
                            if (object.startHour != null) {
                                if (typeof object.startHour !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AdScheduleInfo.startHour: object expected");
                                message.startHour = $root.google.protobuf.Int32Value.fromObject(object.startHour);
                            }
                            if (object.endHour != null) {
                                if (typeof object.endHour !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AdScheduleInfo.endHour: object expected");
                                message.endHour = $root.google.protobuf.Int32Value.fromObject(object.endHour);
                            }
                            switch (object.dayOfWeek) {
                            case "UNSPECIFIED":
                            case 0:
                                message.dayOfWeek = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.dayOfWeek = 1;
                                break;
                            case "MONDAY":
                            case 2:
                                message.dayOfWeek = 2;
                                break;
                            case "TUESDAY":
                            case 3:
                                message.dayOfWeek = 3;
                                break;
                            case "WEDNESDAY":
                            case 4:
                                message.dayOfWeek = 4;
                                break;
                            case "THURSDAY":
                            case 5:
                                message.dayOfWeek = 5;
                                break;
                            case "FRIDAY":
                            case 6:
                                message.dayOfWeek = 6;
                                break;
                            case "SATURDAY":
                            case 7:
                                message.dayOfWeek = 7;
                                break;
                            case "SUNDAY":
                            case 8:
                                message.dayOfWeek = 8;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdScheduleInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.AdScheduleInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.AdScheduleInfo} message AdScheduleInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdScheduleInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.startMinute = options.enums === String ? "UNSPECIFIED" : 0;
                                object.endMinute = options.enums === String ? "UNSPECIFIED" : 0;
                                object.startHour = null;
                                object.endHour = null;
                                object.dayOfWeek = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.startMinute != null && message.hasOwnProperty("startMinute"))
                                object.startMinute = options.enums === String ? $root.google.ads.googleads.v1.enums.MinuteOfHourEnum.MinuteOfHour[message.startMinute] : message.startMinute;
                            if (message.endMinute != null && message.hasOwnProperty("endMinute"))
                                object.endMinute = options.enums === String ? $root.google.ads.googleads.v1.enums.MinuteOfHourEnum.MinuteOfHour[message.endMinute] : message.endMinute;
                            if (message.startHour != null && message.hasOwnProperty("startHour"))
                                object.startHour = $root.google.protobuf.Int32Value.toObject(message.startHour, options);
                            if (message.endHour != null && message.hasOwnProperty("endHour"))
                                object.endHour = $root.google.protobuf.Int32Value.toObject(message.endHour, options);
                            if (message.dayOfWeek != null && message.hasOwnProperty("dayOfWeek"))
                                object.dayOfWeek = options.enums === String ? $root.google.ads.googleads.v1.enums.DayOfWeekEnum.DayOfWeek[message.dayOfWeek] : message.dayOfWeek;
                            return object;
                        };

                        /**
                         * Converts this AdScheduleInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.AdScheduleInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdScheduleInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdScheduleInfo;
                    })();

                    common.AgeRangeInfo = (function() {

                        /**
                         * Properties of an AgeRangeInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IAgeRangeInfo
                         * @property {google.ads.googleads.v1.enums.AgeRangeTypeEnum.AgeRangeType|null} [type] AgeRangeInfo type
                         */

                        /**
                         * Constructs a new AgeRangeInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an AgeRangeInfo.
                         * @implements IAgeRangeInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IAgeRangeInfo=} [properties] Properties to set
                         */
                        function AgeRangeInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AgeRangeInfo type.
                         * @member {google.ads.googleads.v1.enums.AgeRangeTypeEnum.AgeRangeType} type
                         * @memberof google.ads.googleads.v1.common.AgeRangeInfo
                         * @instance
                         */
                        AgeRangeInfo.prototype.type = 0;

                        /**
                         * Creates a new AgeRangeInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.AgeRangeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IAgeRangeInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.AgeRangeInfo} AgeRangeInfo instance
                         */
                        AgeRangeInfo.create = function create(properties) {
                            return new AgeRangeInfo(properties);
                        };

                        /**
                         * Encodes the specified AgeRangeInfo message. Does not implicitly {@link google.ads.googleads.v1.common.AgeRangeInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.AgeRangeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IAgeRangeInfo} message AgeRangeInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AgeRangeInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.type);
                            return writer;
                        };

                        /**
                         * Encodes the specified AgeRangeInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.AgeRangeInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.AgeRangeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IAgeRangeInfo} message AgeRangeInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AgeRangeInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AgeRangeInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.AgeRangeInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.AgeRangeInfo} AgeRangeInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AgeRangeInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.AgeRangeInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.type = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AgeRangeInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.AgeRangeInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.AgeRangeInfo} AgeRangeInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AgeRangeInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AgeRangeInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.AgeRangeInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AgeRangeInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 503001:
                                case 503002:
                                case 503003:
                                case 503004:
                                case 503005:
                                case 503006:
                                case 503999:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates an AgeRangeInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.AgeRangeInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.AgeRangeInfo} AgeRangeInfo
                         */
                        AgeRangeInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.AgeRangeInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.AgeRangeInfo();
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "AGE_RANGE_18_24":
                            case 503001:
                                message.type = 503001;
                                break;
                            case "AGE_RANGE_25_34":
                            case 503002:
                                message.type = 503002;
                                break;
                            case "AGE_RANGE_35_44":
                            case 503003:
                                message.type = 503003;
                                break;
                            case "AGE_RANGE_45_54":
                            case 503004:
                                message.type = 503004;
                                break;
                            case "AGE_RANGE_55_64":
                            case 503005:
                                message.type = 503005;
                                break;
                            case "AGE_RANGE_65_UP":
                            case 503006:
                                message.type = 503006;
                                break;
                            case "AGE_RANGE_UNDETERMINED":
                            case 503999:
                                message.type = 503999;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AgeRangeInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.AgeRangeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.AgeRangeInfo} message AgeRangeInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AgeRangeInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.AgeRangeTypeEnum.AgeRangeType[message.type] : message.type;
                            return object;
                        };

                        /**
                         * Converts this AgeRangeInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.AgeRangeInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AgeRangeInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AgeRangeInfo;
                    })();

                    common.GenderInfo = (function() {

                        /**
                         * Properties of a GenderInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IGenderInfo
                         * @property {google.ads.googleads.v1.enums.GenderTypeEnum.GenderType|null} [type] GenderInfo type
                         */

                        /**
                         * Constructs a new GenderInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a GenderInfo.
                         * @implements IGenderInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IGenderInfo=} [properties] Properties to set
                         */
                        function GenderInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GenderInfo type.
                         * @member {google.ads.googleads.v1.enums.GenderTypeEnum.GenderType} type
                         * @memberof google.ads.googleads.v1.common.GenderInfo
                         * @instance
                         */
                        GenderInfo.prototype.type = 0;

                        /**
                         * Creates a new GenderInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.GenderInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IGenderInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.GenderInfo} GenderInfo instance
                         */
                        GenderInfo.create = function create(properties) {
                            return new GenderInfo(properties);
                        };

                        /**
                         * Encodes the specified GenderInfo message. Does not implicitly {@link google.ads.googleads.v1.common.GenderInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.GenderInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IGenderInfo} message GenderInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenderInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.type);
                            return writer;
                        };

                        /**
                         * Encodes the specified GenderInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.GenderInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.GenderInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IGenderInfo} message GenderInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenderInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GenderInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.GenderInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.GenderInfo} GenderInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenderInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.GenderInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.type = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GenderInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.GenderInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.GenderInfo} GenderInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenderInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GenderInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.GenderInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GenderInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 10:
                                case 11:
                                case 20:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a GenderInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.GenderInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.GenderInfo} GenderInfo
                         */
                        GenderInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.GenderInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.GenderInfo();
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "MALE":
                            case 10:
                                message.type = 10;
                                break;
                            case "FEMALE":
                            case 11:
                                message.type = 11;
                                break;
                            case "UNDETERMINED":
                            case 20:
                                message.type = 20;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a GenderInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.GenderInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.GenderInfo} message GenderInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GenderInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.GenderTypeEnum.GenderType[message.type] : message.type;
                            return object;
                        };

                        /**
                         * Converts this GenderInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.GenderInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GenderInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GenderInfo;
                    })();

                    common.IncomeRangeInfo = (function() {

                        /**
                         * Properties of an IncomeRangeInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IIncomeRangeInfo
                         * @property {google.ads.googleads.v1.enums.IncomeRangeTypeEnum.IncomeRangeType|null} [type] IncomeRangeInfo type
                         */

                        /**
                         * Constructs a new IncomeRangeInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an IncomeRangeInfo.
                         * @implements IIncomeRangeInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IIncomeRangeInfo=} [properties] Properties to set
                         */
                        function IncomeRangeInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * IncomeRangeInfo type.
                         * @member {google.ads.googleads.v1.enums.IncomeRangeTypeEnum.IncomeRangeType} type
                         * @memberof google.ads.googleads.v1.common.IncomeRangeInfo
                         * @instance
                         */
                        IncomeRangeInfo.prototype.type = 0;

                        /**
                         * Creates a new IncomeRangeInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.IncomeRangeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IIncomeRangeInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.IncomeRangeInfo} IncomeRangeInfo instance
                         */
                        IncomeRangeInfo.create = function create(properties) {
                            return new IncomeRangeInfo(properties);
                        };

                        /**
                         * Encodes the specified IncomeRangeInfo message. Does not implicitly {@link google.ads.googleads.v1.common.IncomeRangeInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.IncomeRangeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IIncomeRangeInfo} message IncomeRangeInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        IncomeRangeInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.type);
                            return writer;
                        };

                        /**
                         * Encodes the specified IncomeRangeInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.IncomeRangeInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.IncomeRangeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IIncomeRangeInfo} message IncomeRangeInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        IncomeRangeInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an IncomeRangeInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.IncomeRangeInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.IncomeRangeInfo} IncomeRangeInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        IncomeRangeInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.IncomeRangeInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.type = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an IncomeRangeInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.IncomeRangeInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.IncomeRangeInfo} IncomeRangeInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        IncomeRangeInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an IncomeRangeInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.IncomeRangeInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        IncomeRangeInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 510001:
                                case 510002:
                                case 510003:
                                case 510004:
                                case 510005:
                                case 510006:
                                case 510000:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates an IncomeRangeInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.IncomeRangeInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.IncomeRangeInfo} IncomeRangeInfo
                         */
                        IncomeRangeInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.IncomeRangeInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.IncomeRangeInfo();
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "INCOME_RANGE_0_50":
                            case 510001:
                                message.type = 510001;
                                break;
                            case "INCOME_RANGE_50_60":
                            case 510002:
                                message.type = 510002;
                                break;
                            case "INCOME_RANGE_60_70":
                            case 510003:
                                message.type = 510003;
                                break;
                            case "INCOME_RANGE_70_80":
                            case 510004:
                                message.type = 510004;
                                break;
                            case "INCOME_RANGE_80_90":
                            case 510005:
                                message.type = 510005;
                                break;
                            case "INCOME_RANGE_90_UP":
                            case 510006:
                                message.type = 510006;
                                break;
                            case "INCOME_RANGE_UNDETERMINED":
                            case 510000:
                                message.type = 510000;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an IncomeRangeInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.IncomeRangeInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IncomeRangeInfo} message IncomeRangeInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        IncomeRangeInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.IncomeRangeTypeEnum.IncomeRangeType[message.type] : message.type;
                            return object;
                        };

                        /**
                         * Converts this IncomeRangeInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.IncomeRangeInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        IncomeRangeInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return IncomeRangeInfo;
                    })();

                    common.ParentalStatusInfo = (function() {

                        /**
                         * Properties of a ParentalStatusInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IParentalStatusInfo
                         * @property {google.ads.googleads.v1.enums.ParentalStatusTypeEnum.ParentalStatusType|null} [type] ParentalStatusInfo type
                         */

                        /**
                         * Constructs a new ParentalStatusInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ParentalStatusInfo.
                         * @implements IParentalStatusInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IParentalStatusInfo=} [properties] Properties to set
                         */
                        function ParentalStatusInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ParentalStatusInfo type.
                         * @member {google.ads.googleads.v1.enums.ParentalStatusTypeEnum.ParentalStatusType} type
                         * @memberof google.ads.googleads.v1.common.ParentalStatusInfo
                         * @instance
                         */
                        ParentalStatusInfo.prototype.type = 0;

                        /**
                         * Creates a new ParentalStatusInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ParentalStatusInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IParentalStatusInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ParentalStatusInfo} ParentalStatusInfo instance
                         */
                        ParentalStatusInfo.create = function create(properties) {
                            return new ParentalStatusInfo(properties);
                        };

                        /**
                         * Encodes the specified ParentalStatusInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ParentalStatusInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ParentalStatusInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IParentalStatusInfo} message ParentalStatusInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ParentalStatusInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.type);
                            return writer;
                        };

                        /**
                         * Encodes the specified ParentalStatusInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ParentalStatusInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ParentalStatusInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IParentalStatusInfo} message ParentalStatusInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ParentalStatusInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ParentalStatusInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ParentalStatusInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ParentalStatusInfo} ParentalStatusInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ParentalStatusInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ParentalStatusInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.type = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ParentalStatusInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ParentalStatusInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ParentalStatusInfo} ParentalStatusInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ParentalStatusInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ParentalStatusInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ParentalStatusInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ParentalStatusInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 300:
                                case 301:
                                case 302:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a ParentalStatusInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ParentalStatusInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ParentalStatusInfo} ParentalStatusInfo
                         */
                        ParentalStatusInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ParentalStatusInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ParentalStatusInfo();
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "PARENT":
                            case 300:
                                message.type = 300;
                                break;
                            case "NOT_A_PARENT":
                            case 301:
                                message.type = 301;
                                break;
                            case "UNDETERMINED":
                            case 302:
                                message.type = 302;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ParentalStatusInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ParentalStatusInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ParentalStatusInfo} message ParentalStatusInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ParentalStatusInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.ParentalStatusTypeEnum.ParentalStatusType[message.type] : message.type;
                            return object;
                        };

                        /**
                         * Converts this ParentalStatusInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ParentalStatusInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ParentalStatusInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ParentalStatusInfo;
                    })();

                    common.YouTubeVideoInfo = (function() {

                        /**
                         * Properties of a YouTubeVideoInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IYouTubeVideoInfo
                         * @property {google.protobuf.IStringValue|null} [videoId] YouTubeVideoInfo videoId
                         */

                        /**
                         * Constructs a new YouTubeVideoInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a YouTubeVideoInfo.
                         * @implements IYouTubeVideoInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IYouTubeVideoInfo=} [properties] Properties to set
                         */
                        function YouTubeVideoInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * YouTubeVideoInfo videoId.
                         * @member {google.protobuf.IStringValue|null|undefined} videoId
                         * @memberof google.ads.googleads.v1.common.YouTubeVideoInfo
                         * @instance
                         */
                        YouTubeVideoInfo.prototype.videoId = null;

                        /**
                         * Creates a new YouTubeVideoInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.YouTubeVideoInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IYouTubeVideoInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.YouTubeVideoInfo} YouTubeVideoInfo instance
                         */
                        YouTubeVideoInfo.create = function create(properties) {
                            return new YouTubeVideoInfo(properties);
                        };

                        /**
                         * Encodes the specified YouTubeVideoInfo message. Does not implicitly {@link google.ads.googleads.v1.common.YouTubeVideoInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.YouTubeVideoInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IYouTubeVideoInfo} message YouTubeVideoInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        YouTubeVideoInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.videoId != null && message.hasOwnProperty("videoId"))
                                $root.google.protobuf.StringValue.encode(message.videoId, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified YouTubeVideoInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.YouTubeVideoInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.YouTubeVideoInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IYouTubeVideoInfo} message YouTubeVideoInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        YouTubeVideoInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a YouTubeVideoInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.YouTubeVideoInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.YouTubeVideoInfo} YouTubeVideoInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        YouTubeVideoInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.YouTubeVideoInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.videoId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a YouTubeVideoInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.YouTubeVideoInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.YouTubeVideoInfo} YouTubeVideoInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        YouTubeVideoInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a YouTubeVideoInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.YouTubeVideoInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        YouTubeVideoInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.videoId != null && message.hasOwnProperty("videoId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.videoId);
                                if (error)
                                    return "videoId." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a YouTubeVideoInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.YouTubeVideoInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.YouTubeVideoInfo} YouTubeVideoInfo
                         */
                        YouTubeVideoInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.YouTubeVideoInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.YouTubeVideoInfo();
                            if (object.videoId != null) {
                                if (typeof object.videoId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.YouTubeVideoInfo.videoId: object expected");
                                message.videoId = $root.google.protobuf.StringValue.fromObject(object.videoId);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a YouTubeVideoInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.YouTubeVideoInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.YouTubeVideoInfo} message YouTubeVideoInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        YouTubeVideoInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.videoId = null;
                            if (message.videoId != null && message.hasOwnProperty("videoId"))
                                object.videoId = $root.google.protobuf.StringValue.toObject(message.videoId, options);
                            return object;
                        };

                        /**
                         * Converts this YouTubeVideoInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.YouTubeVideoInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        YouTubeVideoInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return YouTubeVideoInfo;
                    })();

                    common.YouTubeChannelInfo = (function() {

                        /**
                         * Properties of a YouTubeChannelInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IYouTubeChannelInfo
                         * @property {google.protobuf.IStringValue|null} [channelId] YouTubeChannelInfo channelId
                         */

                        /**
                         * Constructs a new YouTubeChannelInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a YouTubeChannelInfo.
                         * @implements IYouTubeChannelInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IYouTubeChannelInfo=} [properties] Properties to set
                         */
                        function YouTubeChannelInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * YouTubeChannelInfo channelId.
                         * @member {google.protobuf.IStringValue|null|undefined} channelId
                         * @memberof google.ads.googleads.v1.common.YouTubeChannelInfo
                         * @instance
                         */
                        YouTubeChannelInfo.prototype.channelId = null;

                        /**
                         * Creates a new YouTubeChannelInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.YouTubeChannelInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IYouTubeChannelInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.YouTubeChannelInfo} YouTubeChannelInfo instance
                         */
                        YouTubeChannelInfo.create = function create(properties) {
                            return new YouTubeChannelInfo(properties);
                        };

                        /**
                         * Encodes the specified YouTubeChannelInfo message. Does not implicitly {@link google.ads.googleads.v1.common.YouTubeChannelInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.YouTubeChannelInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IYouTubeChannelInfo} message YouTubeChannelInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        YouTubeChannelInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.channelId != null && message.hasOwnProperty("channelId"))
                                $root.google.protobuf.StringValue.encode(message.channelId, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified YouTubeChannelInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.YouTubeChannelInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.YouTubeChannelInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IYouTubeChannelInfo} message YouTubeChannelInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        YouTubeChannelInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a YouTubeChannelInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.YouTubeChannelInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.YouTubeChannelInfo} YouTubeChannelInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        YouTubeChannelInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.YouTubeChannelInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.channelId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a YouTubeChannelInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.YouTubeChannelInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.YouTubeChannelInfo} YouTubeChannelInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        YouTubeChannelInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a YouTubeChannelInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.YouTubeChannelInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        YouTubeChannelInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.channelId != null && message.hasOwnProperty("channelId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.channelId);
                                if (error)
                                    return "channelId." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a YouTubeChannelInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.YouTubeChannelInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.YouTubeChannelInfo} YouTubeChannelInfo
                         */
                        YouTubeChannelInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.YouTubeChannelInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.YouTubeChannelInfo();
                            if (object.channelId != null) {
                                if (typeof object.channelId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.YouTubeChannelInfo.channelId: object expected");
                                message.channelId = $root.google.protobuf.StringValue.fromObject(object.channelId);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a YouTubeChannelInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.YouTubeChannelInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.YouTubeChannelInfo} message YouTubeChannelInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        YouTubeChannelInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.channelId = null;
                            if (message.channelId != null && message.hasOwnProperty("channelId"))
                                object.channelId = $root.google.protobuf.StringValue.toObject(message.channelId, options);
                            return object;
                        };

                        /**
                         * Converts this YouTubeChannelInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.YouTubeChannelInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        YouTubeChannelInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return YouTubeChannelInfo;
                    })();

                    common.UserListInfo = (function() {

                        /**
                         * Properties of a UserListInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IUserListInfo
                         * @property {google.protobuf.IStringValue|null} [userList] UserListInfo userList
                         */

                        /**
                         * Constructs a new UserListInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a UserListInfo.
                         * @implements IUserListInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IUserListInfo=} [properties] Properties to set
                         */
                        function UserListInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UserListInfo userList.
                         * @member {google.protobuf.IStringValue|null|undefined} userList
                         * @memberof google.ads.googleads.v1.common.UserListInfo
                         * @instance
                         */
                        UserListInfo.prototype.userList = null;

                        /**
                         * Creates a new UserListInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.UserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.UserListInfo} UserListInfo instance
                         */
                        UserListInfo.create = function create(properties) {
                            return new UserListInfo(properties);
                        };

                        /**
                         * Encodes the specified UserListInfo message. Does not implicitly {@link google.ads.googleads.v1.common.UserListInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.UserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListInfo} message UserListInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.userList != null && message.hasOwnProperty("userList"))
                                $root.google.protobuf.StringValue.encode(message.userList, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.UserListInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListInfo} message UserListInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.UserListInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.UserListInfo} UserListInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.UserListInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.userList = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserListInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.UserListInfo} UserListInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.UserListInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.userList != null && message.hasOwnProperty("userList")) {
                                var error = $root.google.protobuf.StringValue.verify(message.userList);
                                if (error)
                                    return "userList." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a UserListInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.UserListInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.UserListInfo} UserListInfo
                         */
                        UserListInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.UserListInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.UserListInfo();
                            if (object.userList != null) {
                                if (typeof object.userList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.UserListInfo.userList: object expected");
                                message.userList = $root.google.protobuf.StringValue.fromObject(object.userList);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a UserListInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.UserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.UserListInfo} message UserListInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.userList = null;
                            if (message.userList != null && message.hasOwnProperty("userList"))
                                object.userList = $root.google.protobuf.StringValue.toObject(message.userList, options);
                            return object;
                        };

                        /**
                         * Converts this UserListInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.UserListInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UserListInfo;
                    })();

                    common.ProximityInfo = (function() {

                        /**
                         * Properties of a ProximityInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IProximityInfo
                         * @property {google.ads.googleads.v1.common.IGeoPointInfo|null} [geoPoint] ProximityInfo geoPoint
                         * @property {google.protobuf.IDoubleValue|null} [radius] ProximityInfo radius
                         * @property {google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum.ProximityRadiusUnits|null} [radiusUnits] ProximityInfo radiusUnits
                         * @property {google.ads.googleads.v1.common.IAddressInfo|null} [address] ProximityInfo address
                         */

                        /**
                         * Constructs a new ProximityInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ProximityInfo.
                         * @implements IProximityInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IProximityInfo=} [properties] Properties to set
                         */
                        function ProximityInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ProximityInfo geoPoint.
                         * @member {google.ads.googleads.v1.common.IGeoPointInfo|null|undefined} geoPoint
                         * @memberof google.ads.googleads.v1.common.ProximityInfo
                         * @instance
                         */
                        ProximityInfo.prototype.geoPoint = null;

                        /**
                         * ProximityInfo radius.
                         * @member {google.protobuf.IDoubleValue|null|undefined} radius
                         * @memberof google.ads.googleads.v1.common.ProximityInfo
                         * @instance
                         */
                        ProximityInfo.prototype.radius = null;

                        /**
                         * ProximityInfo radiusUnits.
                         * @member {google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum.ProximityRadiusUnits} radiusUnits
                         * @memberof google.ads.googleads.v1.common.ProximityInfo
                         * @instance
                         */
                        ProximityInfo.prototype.radiusUnits = 0;

                        /**
                         * ProximityInfo address.
                         * @member {google.ads.googleads.v1.common.IAddressInfo|null|undefined} address
                         * @memberof google.ads.googleads.v1.common.ProximityInfo
                         * @instance
                         */
                        ProximityInfo.prototype.address = null;

                        /**
                         * Creates a new ProximityInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ProximityInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProximityInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ProximityInfo} ProximityInfo instance
                         */
                        ProximityInfo.create = function create(properties) {
                            return new ProximityInfo(properties);
                        };

                        /**
                         * Encodes the specified ProximityInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ProximityInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ProximityInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProximityInfo} message ProximityInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProximityInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.geoPoint != null && message.hasOwnProperty("geoPoint"))
                                $root.google.ads.googleads.v1.common.GeoPointInfo.encode(message.geoPoint, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.radius != null && message.hasOwnProperty("radius"))
                                $root.google.protobuf.DoubleValue.encode(message.radius, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.radiusUnits != null && message.hasOwnProperty("radiusUnits"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.radiusUnits);
                            if (message.address != null && message.hasOwnProperty("address"))
                                $root.google.ads.googleads.v1.common.AddressInfo.encode(message.address, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ProximityInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ProximityInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ProximityInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IProximityInfo} message ProximityInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProximityInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ProximityInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ProximityInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ProximityInfo} ProximityInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProximityInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ProximityInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.geoPoint = $root.google.ads.googleads.v1.common.GeoPointInfo.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.radius = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.radiusUnits = reader.int32();
                                    break;
                                case 4:
                                    message.address = $root.google.ads.googleads.v1.common.AddressInfo.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ProximityInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ProximityInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ProximityInfo} ProximityInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProximityInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ProximityInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ProximityInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProximityInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.geoPoint != null && message.hasOwnProperty("geoPoint")) {
                                var error = $root.google.ads.googleads.v1.common.GeoPointInfo.verify(message.geoPoint);
                                if (error)
                                    return "geoPoint." + error;
                            }
                            if (message.radius != null && message.hasOwnProperty("radius")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.radius);
                                if (error)
                                    return "radius." + error;
                            }
                            if (message.radiusUnits != null && message.hasOwnProperty("radiusUnits"))
                                switch (message.radiusUnits) {
                                default:
                                    return "radiusUnits: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.address != null && message.hasOwnProperty("address")) {
                                var error = $root.google.ads.googleads.v1.common.AddressInfo.verify(message.address);
                                if (error)
                                    return "address." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a ProximityInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ProximityInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ProximityInfo} ProximityInfo
                         */
                        ProximityInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ProximityInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ProximityInfo();
                            if (object.geoPoint != null) {
                                if (typeof object.geoPoint !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ProximityInfo.geoPoint: object expected");
                                message.geoPoint = $root.google.ads.googleads.v1.common.GeoPointInfo.fromObject(object.geoPoint);
                            }
                            if (object.radius != null) {
                                if (typeof object.radius !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ProximityInfo.radius: object expected");
                                message.radius = $root.google.protobuf.DoubleValue.fromObject(object.radius);
                            }
                            switch (object.radiusUnits) {
                            case "UNSPECIFIED":
                            case 0:
                                message.radiusUnits = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.radiusUnits = 1;
                                break;
                            case "MILES":
                            case 2:
                                message.radiusUnits = 2;
                                break;
                            case "KILOMETERS":
                            case 3:
                                message.radiusUnits = 3;
                                break;
                            }
                            if (object.address != null) {
                                if (typeof object.address !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ProximityInfo.address: object expected");
                                message.address = $root.google.ads.googleads.v1.common.AddressInfo.fromObject(object.address);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ProximityInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ProximityInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ProximityInfo} message ProximityInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProximityInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.geoPoint = null;
                                object.radius = null;
                                object.radiusUnits = options.enums === String ? "UNSPECIFIED" : 0;
                                object.address = null;
                            }
                            if (message.geoPoint != null && message.hasOwnProperty("geoPoint"))
                                object.geoPoint = $root.google.ads.googleads.v1.common.GeoPointInfo.toObject(message.geoPoint, options);
                            if (message.radius != null && message.hasOwnProperty("radius"))
                                object.radius = $root.google.protobuf.DoubleValue.toObject(message.radius, options);
                            if (message.radiusUnits != null && message.hasOwnProperty("radiusUnits"))
                                object.radiusUnits = options.enums === String ? $root.google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum.ProximityRadiusUnits[message.radiusUnits] : message.radiusUnits;
                            if (message.address != null && message.hasOwnProperty("address"))
                                object.address = $root.google.ads.googleads.v1.common.AddressInfo.toObject(message.address, options);
                            return object;
                        };

                        /**
                         * Converts this ProximityInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ProximityInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProximityInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ProximityInfo;
                    })();

                    common.GeoPointInfo = (function() {

                        /**
                         * Properties of a GeoPointInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IGeoPointInfo
                         * @property {google.protobuf.IInt32Value|null} [longitudeInMicroDegrees] GeoPointInfo longitudeInMicroDegrees
                         * @property {google.protobuf.IInt32Value|null} [latitudeInMicroDegrees] GeoPointInfo latitudeInMicroDegrees
                         */

                        /**
                         * Constructs a new GeoPointInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a GeoPointInfo.
                         * @implements IGeoPointInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IGeoPointInfo=} [properties] Properties to set
                         */
                        function GeoPointInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GeoPointInfo longitudeInMicroDegrees.
                         * @member {google.protobuf.IInt32Value|null|undefined} longitudeInMicroDegrees
                         * @memberof google.ads.googleads.v1.common.GeoPointInfo
                         * @instance
                         */
                        GeoPointInfo.prototype.longitudeInMicroDegrees = null;

                        /**
                         * GeoPointInfo latitudeInMicroDegrees.
                         * @member {google.protobuf.IInt32Value|null|undefined} latitudeInMicroDegrees
                         * @memberof google.ads.googleads.v1.common.GeoPointInfo
                         * @instance
                         */
                        GeoPointInfo.prototype.latitudeInMicroDegrees = null;

                        /**
                         * Creates a new GeoPointInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.GeoPointInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IGeoPointInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.GeoPointInfo} GeoPointInfo instance
                         */
                        GeoPointInfo.create = function create(properties) {
                            return new GeoPointInfo(properties);
                        };

                        /**
                         * Encodes the specified GeoPointInfo message. Does not implicitly {@link google.ads.googleads.v1.common.GeoPointInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.GeoPointInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IGeoPointInfo} message GeoPointInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GeoPointInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.longitudeInMicroDegrees != null && message.hasOwnProperty("longitudeInMicroDegrees"))
                                $root.google.protobuf.Int32Value.encode(message.longitudeInMicroDegrees, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.latitudeInMicroDegrees != null && message.hasOwnProperty("latitudeInMicroDegrees"))
                                $root.google.protobuf.Int32Value.encode(message.latitudeInMicroDegrees, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified GeoPointInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.GeoPointInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.GeoPointInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IGeoPointInfo} message GeoPointInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GeoPointInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GeoPointInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.GeoPointInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.GeoPointInfo} GeoPointInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GeoPointInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.GeoPointInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.longitudeInMicroDegrees = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.latitudeInMicroDegrees = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GeoPointInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.GeoPointInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.GeoPointInfo} GeoPointInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GeoPointInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GeoPointInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.GeoPointInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GeoPointInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.longitudeInMicroDegrees != null && message.hasOwnProperty("longitudeInMicroDegrees")) {
                                var error = $root.google.protobuf.Int32Value.verify(message.longitudeInMicroDegrees);
                                if (error)
                                    return "longitudeInMicroDegrees." + error;
                            }
                            if (message.latitudeInMicroDegrees != null && message.hasOwnProperty("latitudeInMicroDegrees")) {
                                var error = $root.google.protobuf.Int32Value.verify(message.latitudeInMicroDegrees);
                                if (error)
                                    return "latitudeInMicroDegrees." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a GeoPointInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.GeoPointInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.GeoPointInfo} GeoPointInfo
                         */
                        GeoPointInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.GeoPointInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.GeoPointInfo();
                            if (object.longitudeInMicroDegrees != null) {
                                if (typeof object.longitudeInMicroDegrees !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.GeoPointInfo.longitudeInMicroDegrees: object expected");
                                message.longitudeInMicroDegrees = $root.google.protobuf.Int32Value.fromObject(object.longitudeInMicroDegrees);
                            }
                            if (object.latitudeInMicroDegrees != null) {
                                if (typeof object.latitudeInMicroDegrees !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.GeoPointInfo.latitudeInMicroDegrees: object expected");
                                message.latitudeInMicroDegrees = $root.google.protobuf.Int32Value.fromObject(object.latitudeInMicroDegrees);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a GeoPointInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.GeoPointInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.GeoPointInfo} message GeoPointInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GeoPointInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.longitudeInMicroDegrees = null;
                                object.latitudeInMicroDegrees = null;
                            }
                            if (message.longitudeInMicroDegrees != null && message.hasOwnProperty("longitudeInMicroDegrees"))
                                object.longitudeInMicroDegrees = $root.google.protobuf.Int32Value.toObject(message.longitudeInMicroDegrees, options);
                            if (message.latitudeInMicroDegrees != null && message.hasOwnProperty("latitudeInMicroDegrees"))
                                object.latitudeInMicroDegrees = $root.google.protobuf.Int32Value.toObject(message.latitudeInMicroDegrees, options);
                            return object;
                        };

                        /**
                         * Converts this GeoPointInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.GeoPointInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GeoPointInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GeoPointInfo;
                    })();

                    common.AddressInfo = (function() {

                        /**
                         * Properties of an AddressInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IAddressInfo
                         * @property {google.protobuf.IStringValue|null} [postalCode] AddressInfo postalCode
                         * @property {google.protobuf.IStringValue|null} [provinceCode] AddressInfo provinceCode
                         * @property {google.protobuf.IStringValue|null} [countryCode] AddressInfo countryCode
                         * @property {google.protobuf.IStringValue|null} [provinceName] AddressInfo provinceName
                         * @property {google.protobuf.IStringValue|null} [streetAddress] AddressInfo streetAddress
                         * @property {google.protobuf.IStringValue|null} [streetAddress2] AddressInfo streetAddress2
                         * @property {google.protobuf.IStringValue|null} [cityName] AddressInfo cityName
                         */

                        /**
                         * Constructs a new AddressInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an AddressInfo.
                         * @implements IAddressInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IAddressInfo=} [properties] Properties to set
                         */
                        function AddressInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AddressInfo postalCode.
                         * @member {google.protobuf.IStringValue|null|undefined} postalCode
                         * @memberof google.ads.googleads.v1.common.AddressInfo
                         * @instance
                         */
                        AddressInfo.prototype.postalCode = null;

                        /**
                         * AddressInfo provinceCode.
                         * @member {google.protobuf.IStringValue|null|undefined} provinceCode
                         * @memberof google.ads.googleads.v1.common.AddressInfo
                         * @instance
                         */
                        AddressInfo.prototype.provinceCode = null;

                        /**
                         * AddressInfo countryCode.
                         * @member {google.protobuf.IStringValue|null|undefined} countryCode
                         * @memberof google.ads.googleads.v1.common.AddressInfo
                         * @instance
                         */
                        AddressInfo.prototype.countryCode = null;

                        /**
                         * AddressInfo provinceName.
                         * @member {google.protobuf.IStringValue|null|undefined} provinceName
                         * @memberof google.ads.googleads.v1.common.AddressInfo
                         * @instance
                         */
                        AddressInfo.prototype.provinceName = null;

                        /**
                         * AddressInfo streetAddress.
                         * @member {google.protobuf.IStringValue|null|undefined} streetAddress
                         * @memberof google.ads.googleads.v1.common.AddressInfo
                         * @instance
                         */
                        AddressInfo.prototype.streetAddress = null;

                        /**
                         * AddressInfo streetAddress2.
                         * @member {google.protobuf.IStringValue|null|undefined} streetAddress2
                         * @memberof google.ads.googleads.v1.common.AddressInfo
                         * @instance
                         */
                        AddressInfo.prototype.streetAddress2 = null;

                        /**
                         * AddressInfo cityName.
                         * @member {google.protobuf.IStringValue|null|undefined} cityName
                         * @memberof google.ads.googleads.v1.common.AddressInfo
                         * @instance
                         */
                        AddressInfo.prototype.cityName = null;

                        /**
                         * Creates a new AddressInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.AddressInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IAddressInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.AddressInfo} AddressInfo instance
                         */
                        AddressInfo.create = function create(properties) {
                            return new AddressInfo(properties);
                        };

                        /**
                         * Encodes the specified AddressInfo message. Does not implicitly {@link google.ads.googleads.v1.common.AddressInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.AddressInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IAddressInfo} message AddressInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddressInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.postalCode != null && message.hasOwnProperty("postalCode"))
                                $root.google.protobuf.StringValue.encode(message.postalCode, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.provinceCode != null && message.hasOwnProperty("provinceCode"))
                                $root.google.protobuf.StringValue.encode(message.provinceCode, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                $root.google.protobuf.StringValue.encode(message.countryCode, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.provinceName != null && message.hasOwnProperty("provinceName"))
                                $root.google.protobuf.StringValue.encode(message.provinceName, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.streetAddress != null && message.hasOwnProperty("streetAddress"))
                                $root.google.protobuf.StringValue.encode(message.streetAddress, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.streetAddress2 != null && message.hasOwnProperty("streetAddress2"))
                                $root.google.protobuf.StringValue.encode(message.streetAddress2, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.cityName != null && message.hasOwnProperty("cityName"))
                                $root.google.protobuf.StringValue.encode(message.cityName, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AddressInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.AddressInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.AddressInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IAddressInfo} message AddressInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddressInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AddressInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.AddressInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.AddressInfo} AddressInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddressInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.AddressInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.postalCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.provinceCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.countryCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.provinceName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.streetAddress = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.streetAddress2 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.cityName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AddressInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.AddressInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.AddressInfo} AddressInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddressInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AddressInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.AddressInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddressInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.postalCode != null && message.hasOwnProperty("postalCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.postalCode);
                                if (error)
                                    return "postalCode." + error;
                            }
                            if (message.provinceCode != null && message.hasOwnProperty("provinceCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.provinceCode);
                                if (error)
                                    return "provinceCode." + error;
                            }
                            if (message.countryCode != null && message.hasOwnProperty("countryCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.countryCode);
                                if (error)
                                    return "countryCode." + error;
                            }
                            if (message.provinceName != null && message.hasOwnProperty("provinceName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.provinceName);
                                if (error)
                                    return "provinceName." + error;
                            }
                            if (message.streetAddress != null && message.hasOwnProperty("streetAddress")) {
                                var error = $root.google.protobuf.StringValue.verify(message.streetAddress);
                                if (error)
                                    return "streetAddress." + error;
                            }
                            if (message.streetAddress2 != null && message.hasOwnProperty("streetAddress2")) {
                                var error = $root.google.protobuf.StringValue.verify(message.streetAddress2);
                                if (error)
                                    return "streetAddress2." + error;
                            }
                            if (message.cityName != null && message.hasOwnProperty("cityName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.cityName);
                                if (error)
                                    return "cityName." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an AddressInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.AddressInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.AddressInfo} AddressInfo
                         */
                        AddressInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.AddressInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.AddressInfo();
                            if (object.postalCode != null) {
                                if (typeof object.postalCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AddressInfo.postalCode: object expected");
                                message.postalCode = $root.google.protobuf.StringValue.fromObject(object.postalCode);
                            }
                            if (object.provinceCode != null) {
                                if (typeof object.provinceCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AddressInfo.provinceCode: object expected");
                                message.provinceCode = $root.google.protobuf.StringValue.fromObject(object.provinceCode);
                            }
                            if (object.countryCode != null) {
                                if (typeof object.countryCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AddressInfo.countryCode: object expected");
                                message.countryCode = $root.google.protobuf.StringValue.fromObject(object.countryCode);
                            }
                            if (object.provinceName != null) {
                                if (typeof object.provinceName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AddressInfo.provinceName: object expected");
                                message.provinceName = $root.google.protobuf.StringValue.fromObject(object.provinceName);
                            }
                            if (object.streetAddress != null) {
                                if (typeof object.streetAddress !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AddressInfo.streetAddress: object expected");
                                message.streetAddress = $root.google.protobuf.StringValue.fromObject(object.streetAddress);
                            }
                            if (object.streetAddress2 != null) {
                                if (typeof object.streetAddress2 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AddressInfo.streetAddress2: object expected");
                                message.streetAddress2 = $root.google.protobuf.StringValue.fromObject(object.streetAddress2);
                            }
                            if (object.cityName != null) {
                                if (typeof object.cityName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AddressInfo.cityName: object expected");
                                message.cityName = $root.google.protobuf.StringValue.fromObject(object.cityName);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AddressInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.AddressInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.AddressInfo} message AddressInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddressInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.postalCode = null;
                                object.provinceCode = null;
                                object.countryCode = null;
                                object.provinceName = null;
                                object.streetAddress = null;
                                object.streetAddress2 = null;
                                object.cityName = null;
                            }
                            if (message.postalCode != null && message.hasOwnProperty("postalCode"))
                                object.postalCode = $root.google.protobuf.StringValue.toObject(message.postalCode, options);
                            if (message.provinceCode != null && message.hasOwnProperty("provinceCode"))
                                object.provinceCode = $root.google.protobuf.StringValue.toObject(message.provinceCode, options);
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                object.countryCode = $root.google.protobuf.StringValue.toObject(message.countryCode, options);
                            if (message.provinceName != null && message.hasOwnProperty("provinceName"))
                                object.provinceName = $root.google.protobuf.StringValue.toObject(message.provinceName, options);
                            if (message.streetAddress != null && message.hasOwnProperty("streetAddress"))
                                object.streetAddress = $root.google.protobuf.StringValue.toObject(message.streetAddress, options);
                            if (message.streetAddress2 != null && message.hasOwnProperty("streetAddress2"))
                                object.streetAddress2 = $root.google.protobuf.StringValue.toObject(message.streetAddress2, options);
                            if (message.cityName != null && message.hasOwnProperty("cityName"))
                                object.cityName = $root.google.protobuf.StringValue.toObject(message.cityName, options);
                            return object;
                        };

                        /**
                         * Converts this AddressInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.AddressInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddressInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AddressInfo;
                    })();

                    common.TopicInfo = (function() {

                        /**
                         * Properties of a TopicInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ITopicInfo
                         * @property {google.protobuf.IStringValue|null} [topicConstant] TopicInfo topicConstant
                         * @property {Array.<google.protobuf.IStringValue>|null} [path] TopicInfo path
                         */

                        /**
                         * Constructs a new TopicInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a TopicInfo.
                         * @implements ITopicInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ITopicInfo=} [properties] Properties to set
                         */
                        function TopicInfo(properties) {
                            this.path = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * TopicInfo topicConstant.
                         * @member {google.protobuf.IStringValue|null|undefined} topicConstant
                         * @memberof google.ads.googleads.v1.common.TopicInfo
                         * @instance
                         */
                        TopicInfo.prototype.topicConstant = null;

                        /**
                         * TopicInfo path.
                         * @member {Array.<google.protobuf.IStringValue>} path
                         * @memberof google.ads.googleads.v1.common.TopicInfo
                         * @instance
                         */
                        TopicInfo.prototype.path = $util.emptyArray;

                        /**
                         * Creates a new TopicInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.TopicInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ITopicInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.TopicInfo} TopicInfo instance
                         */
                        TopicInfo.create = function create(properties) {
                            return new TopicInfo(properties);
                        };

                        /**
                         * Encodes the specified TopicInfo message. Does not implicitly {@link google.ads.googleads.v1.common.TopicInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.TopicInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ITopicInfo} message TopicInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TopicInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.topicConstant != null && message.hasOwnProperty("topicConstant"))
                                $root.google.protobuf.StringValue.encode(message.topicConstant, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.path != null && message.path.length)
                                for (var i = 0; i < message.path.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.path[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified TopicInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.TopicInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.TopicInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ITopicInfo} message TopicInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TopicInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TopicInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.TopicInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.TopicInfo} TopicInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TopicInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.TopicInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.topicConstant = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.path && message.path.length))
                                        message.path = [];
                                    message.path.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TopicInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.TopicInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.TopicInfo} TopicInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TopicInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TopicInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.TopicInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TopicInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.topicConstant != null && message.hasOwnProperty("topicConstant")) {
                                var error = $root.google.protobuf.StringValue.verify(message.topicConstant);
                                if (error)
                                    return "topicConstant." + error;
                            }
                            if (message.path != null && message.hasOwnProperty("path")) {
                                if (!Array.isArray(message.path))
                                    return "path: array expected";
                                for (var i = 0; i < message.path.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.path[i]);
                                    if (error)
                                        return "path." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a TopicInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.TopicInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.TopicInfo} TopicInfo
                         */
                        TopicInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.TopicInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.TopicInfo();
                            if (object.topicConstant != null) {
                                if (typeof object.topicConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TopicInfo.topicConstant: object expected");
                                message.topicConstant = $root.google.protobuf.StringValue.fromObject(object.topicConstant);
                            }
                            if (object.path) {
                                if (!Array.isArray(object.path))
                                    throw TypeError(".google.ads.googleads.v1.common.TopicInfo.path: array expected");
                                message.path = [];
                                for (var i = 0; i < object.path.length; ++i) {
                                    if (typeof object.path[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.TopicInfo.path: object expected");
                                    message.path[i] = $root.google.protobuf.StringValue.fromObject(object.path[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a TopicInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.TopicInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.TopicInfo} message TopicInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TopicInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.path = [];
                            if (options.defaults)
                                object.topicConstant = null;
                            if (message.topicConstant != null && message.hasOwnProperty("topicConstant"))
                                object.topicConstant = $root.google.protobuf.StringValue.toObject(message.topicConstant, options);
                            if (message.path && message.path.length) {
                                object.path = [];
                                for (var j = 0; j < message.path.length; ++j)
                                    object.path[j] = $root.google.protobuf.StringValue.toObject(message.path[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this TopicInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.TopicInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TopicInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return TopicInfo;
                    })();

                    common.LanguageInfo = (function() {

                        /**
                         * Properties of a LanguageInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ILanguageInfo
                         * @property {google.protobuf.IStringValue|null} [languageConstant] LanguageInfo languageConstant
                         */

                        /**
                         * Constructs a new LanguageInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a LanguageInfo.
                         * @implements ILanguageInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ILanguageInfo=} [properties] Properties to set
                         */
                        function LanguageInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * LanguageInfo languageConstant.
                         * @member {google.protobuf.IStringValue|null|undefined} languageConstant
                         * @memberof google.ads.googleads.v1.common.LanguageInfo
                         * @instance
                         */
                        LanguageInfo.prototype.languageConstant = null;

                        /**
                         * Creates a new LanguageInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.LanguageInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILanguageInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.LanguageInfo} LanguageInfo instance
                         */
                        LanguageInfo.create = function create(properties) {
                            return new LanguageInfo(properties);
                        };

                        /**
                         * Encodes the specified LanguageInfo message. Does not implicitly {@link google.ads.googleads.v1.common.LanguageInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.LanguageInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILanguageInfo} message LanguageInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LanguageInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.languageConstant != null && message.hasOwnProperty("languageConstant"))
                                $root.google.protobuf.StringValue.encode(message.languageConstant, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified LanguageInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.LanguageInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.LanguageInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILanguageInfo} message LanguageInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LanguageInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LanguageInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.LanguageInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.LanguageInfo} LanguageInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LanguageInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.LanguageInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.languageConstant = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LanguageInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.LanguageInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.LanguageInfo} LanguageInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LanguageInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LanguageInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.LanguageInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LanguageInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.languageConstant != null && message.hasOwnProperty("languageConstant")) {
                                var error = $root.google.protobuf.StringValue.verify(message.languageConstant);
                                if (error)
                                    return "languageConstant." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a LanguageInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.LanguageInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.LanguageInfo} LanguageInfo
                         */
                        LanguageInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.LanguageInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.LanguageInfo();
                            if (object.languageConstant != null) {
                                if (typeof object.languageConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LanguageInfo.languageConstant: object expected");
                                message.languageConstant = $root.google.protobuf.StringValue.fromObject(object.languageConstant);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a LanguageInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.LanguageInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.LanguageInfo} message LanguageInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LanguageInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.languageConstant = null;
                            if (message.languageConstant != null && message.hasOwnProperty("languageConstant"))
                                object.languageConstant = $root.google.protobuf.StringValue.toObject(message.languageConstant, options);
                            return object;
                        };

                        /**
                         * Converts this LanguageInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.LanguageInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LanguageInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return LanguageInfo;
                    })();

                    common.IpBlockInfo = (function() {

                        /**
                         * Properties of an IpBlockInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IIpBlockInfo
                         * @property {google.protobuf.IStringValue|null} [ipAddress] IpBlockInfo ipAddress
                         */

                        /**
                         * Constructs a new IpBlockInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an IpBlockInfo.
                         * @implements IIpBlockInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IIpBlockInfo=} [properties] Properties to set
                         */
                        function IpBlockInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * IpBlockInfo ipAddress.
                         * @member {google.protobuf.IStringValue|null|undefined} ipAddress
                         * @memberof google.ads.googleads.v1.common.IpBlockInfo
                         * @instance
                         */
                        IpBlockInfo.prototype.ipAddress = null;

                        /**
                         * Creates a new IpBlockInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.IpBlockInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IIpBlockInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.IpBlockInfo} IpBlockInfo instance
                         */
                        IpBlockInfo.create = function create(properties) {
                            return new IpBlockInfo(properties);
                        };

                        /**
                         * Encodes the specified IpBlockInfo message. Does not implicitly {@link google.ads.googleads.v1.common.IpBlockInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.IpBlockInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IIpBlockInfo} message IpBlockInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        IpBlockInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.ipAddress != null && message.hasOwnProperty("ipAddress"))
                                $root.google.protobuf.StringValue.encode(message.ipAddress, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified IpBlockInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.IpBlockInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.IpBlockInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IIpBlockInfo} message IpBlockInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        IpBlockInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an IpBlockInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.IpBlockInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.IpBlockInfo} IpBlockInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        IpBlockInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.IpBlockInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.ipAddress = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an IpBlockInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.IpBlockInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.IpBlockInfo} IpBlockInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        IpBlockInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an IpBlockInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.IpBlockInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        IpBlockInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.ipAddress != null && message.hasOwnProperty("ipAddress")) {
                                var error = $root.google.protobuf.StringValue.verify(message.ipAddress);
                                if (error)
                                    return "ipAddress." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an IpBlockInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.IpBlockInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.IpBlockInfo} IpBlockInfo
                         */
                        IpBlockInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.IpBlockInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.IpBlockInfo();
                            if (object.ipAddress != null) {
                                if (typeof object.ipAddress !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.IpBlockInfo.ipAddress: object expected");
                                message.ipAddress = $root.google.protobuf.StringValue.fromObject(object.ipAddress);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an IpBlockInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.IpBlockInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IpBlockInfo} message IpBlockInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        IpBlockInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.ipAddress = null;
                            if (message.ipAddress != null && message.hasOwnProperty("ipAddress"))
                                object.ipAddress = $root.google.protobuf.StringValue.toObject(message.ipAddress, options);
                            return object;
                        };

                        /**
                         * Converts this IpBlockInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.IpBlockInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        IpBlockInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return IpBlockInfo;
                    })();

                    common.ContentLabelInfo = (function() {

                        /**
                         * Properties of a ContentLabelInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IContentLabelInfo
                         * @property {google.ads.googleads.v1.enums.ContentLabelTypeEnum.ContentLabelType|null} [type] ContentLabelInfo type
                         */

                        /**
                         * Constructs a new ContentLabelInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a ContentLabelInfo.
                         * @implements IContentLabelInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IContentLabelInfo=} [properties] Properties to set
                         */
                        function ContentLabelInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ContentLabelInfo type.
                         * @member {google.ads.googleads.v1.enums.ContentLabelTypeEnum.ContentLabelType} type
                         * @memberof google.ads.googleads.v1.common.ContentLabelInfo
                         * @instance
                         */
                        ContentLabelInfo.prototype.type = 0;

                        /**
                         * Creates a new ContentLabelInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ContentLabelInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IContentLabelInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ContentLabelInfo} ContentLabelInfo instance
                         */
                        ContentLabelInfo.create = function create(properties) {
                            return new ContentLabelInfo(properties);
                        };

                        /**
                         * Encodes the specified ContentLabelInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ContentLabelInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ContentLabelInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IContentLabelInfo} message ContentLabelInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ContentLabelInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.type);
                            return writer;
                        };

                        /**
                         * Encodes the specified ContentLabelInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ContentLabelInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ContentLabelInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IContentLabelInfo} message ContentLabelInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ContentLabelInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ContentLabelInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ContentLabelInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ContentLabelInfo} ContentLabelInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ContentLabelInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ContentLabelInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.type = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ContentLabelInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ContentLabelInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ContentLabelInfo} ContentLabelInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ContentLabelInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ContentLabelInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ContentLabelInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ContentLabelInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a ContentLabelInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ContentLabelInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ContentLabelInfo} ContentLabelInfo
                         */
                        ContentLabelInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ContentLabelInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ContentLabelInfo();
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "SEXUALLY_SUGGESTIVE":
                            case 2:
                                message.type = 2;
                                break;
                            case "BELOW_THE_FOLD":
                            case 3:
                                message.type = 3;
                                break;
                            case "PARKED_DOMAIN":
                            case 4:
                                message.type = 4;
                                break;
                            case "GAME":
                            case 5:
                                message.type = 5;
                                break;
                            case "JUVENILE":
                            case 6:
                                message.type = 6;
                                break;
                            case "PROFANITY":
                            case 7:
                                message.type = 7;
                                break;
                            case "TRAGEDY":
                            case 8:
                                message.type = 8;
                                break;
                            case "VIDEO":
                            case 9:
                                message.type = 9;
                                break;
                            case "VIDEO_RATING_DV_G":
                            case 10:
                                message.type = 10;
                                break;
                            case "VIDEO_RATING_DV_PG":
                            case 11:
                                message.type = 11;
                                break;
                            case "VIDEO_RATING_DV_T":
                            case 12:
                                message.type = 12;
                                break;
                            case "VIDEO_RATING_DV_MA":
                            case 13:
                                message.type = 13;
                                break;
                            case "VIDEO_NOT_YET_RATED":
                            case 14:
                                message.type = 14;
                                break;
                            case "EMBEDDED_VIDEO":
                            case 15:
                                message.type = 15;
                                break;
                            case "LIVE_STREAMING_VIDEO":
                            case 16:
                                message.type = 16;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ContentLabelInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ContentLabelInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ContentLabelInfo} message ContentLabelInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ContentLabelInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.ContentLabelTypeEnum.ContentLabelType[message.type] : message.type;
                            return object;
                        };

                        /**
                         * Converts this ContentLabelInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ContentLabelInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ContentLabelInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ContentLabelInfo;
                    })();

                    common.CarrierInfo = (function() {

                        /**
                         * Properties of a CarrierInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ICarrierInfo
                         * @property {google.protobuf.IStringValue|null} [carrierConstant] CarrierInfo carrierConstant
                         */

                        /**
                         * Constructs a new CarrierInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a CarrierInfo.
                         * @implements ICarrierInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ICarrierInfo=} [properties] Properties to set
                         */
                        function CarrierInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CarrierInfo carrierConstant.
                         * @member {google.protobuf.IStringValue|null|undefined} carrierConstant
                         * @memberof google.ads.googleads.v1.common.CarrierInfo
                         * @instance
                         */
                        CarrierInfo.prototype.carrierConstant = null;

                        /**
                         * Creates a new CarrierInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.CarrierInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ICarrierInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.CarrierInfo} CarrierInfo instance
                         */
                        CarrierInfo.create = function create(properties) {
                            return new CarrierInfo(properties);
                        };

                        /**
                         * Encodes the specified CarrierInfo message. Does not implicitly {@link google.ads.googleads.v1.common.CarrierInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.CarrierInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ICarrierInfo} message CarrierInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CarrierInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.carrierConstant != null && message.hasOwnProperty("carrierConstant"))
                                $root.google.protobuf.StringValue.encode(message.carrierConstant, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CarrierInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.CarrierInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.CarrierInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ICarrierInfo} message CarrierInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CarrierInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CarrierInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.CarrierInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.CarrierInfo} CarrierInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CarrierInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.CarrierInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.carrierConstant = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CarrierInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.CarrierInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.CarrierInfo} CarrierInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CarrierInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CarrierInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.CarrierInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CarrierInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.carrierConstant != null && message.hasOwnProperty("carrierConstant")) {
                                var error = $root.google.protobuf.StringValue.verify(message.carrierConstant);
                                if (error)
                                    return "carrierConstant." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CarrierInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.CarrierInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.CarrierInfo} CarrierInfo
                         */
                        CarrierInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.CarrierInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.CarrierInfo();
                            if (object.carrierConstant != null) {
                                if (typeof object.carrierConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CarrierInfo.carrierConstant: object expected");
                                message.carrierConstant = $root.google.protobuf.StringValue.fromObject(object.carrierConstant);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CarrierInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.CarrierInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.CarrierInfo} message CarrierInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CarrierInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.carrierConstant = null;
                            if (message.carrierConstant != null && message.hasOwnProperty("carrierConstant"))
                                object.carrierConstant = $root.google.protobuf.StringValue.toObject(message.carrierConstant, options);
                            return object;
                        };

                        /**
                         * Converts this CarrierInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.CarrierInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CarrierInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CarrierInfo;
                    })();

                    common.UserInterestInfo = (function() {

                        /**
                         * Properties of a UserInterestInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IUserInterestInfo
                         * @property {google.protobuf.IStringValue|null} [userInterestCategory] UserInterestInfo userInterestCategory
                         */

                        /**
                         * Constructs a new UserInterestInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a UserInterestInfo.
                         * @implements IUserInterestInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IUserInterestInfo=} [properties] Properties to set
                         */
                        function UserInterestInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UserInterestInfo userInterestCategory.
                         * @member {google.protobuf.IStringValue|null|undefined} userInterestCategory
                         * @memberof google.ads.googleads.v1.common.UserInterestInfo
                         * @instance
                         */
                        UserInterestInfo.prototype.userInterestCategory = null;

                        /**
                         * Creates a new UserInterestInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.UserInterestInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserInterestInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.UserInterestInfo} UserInterestInfo instance
                         */
                        UserInterestInfo.create = function create(properties) {
                            return new UserInterestInfo(properties);
                        };

                        /**
                         * Encodes the specified UserInterestInfo message. Does not implicitly {@link google.ads.googleads.v1.common.UserInterestInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.UserInterestInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserInterestInfo} message UserInterestInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserInterestInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.userInterestCategory != null && message.hasOwnProperty("userInterestCategory"))
                                $root.google.protobuf.StringValue.encode(message.userInterestCategory, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserInterestInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.UserInterestInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserInterestInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserInterestInfo} message UserInterestInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserInterestInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserInterestInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.UserInterestInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.UserInterestInfo} UserInterestInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserInterestInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.UserInterestInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.userInterestCategory = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserInterestInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserInterestInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.UserInterestInfo} UserInterestInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserInterestInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserInterestInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.UserInterestInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserInterestInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.userInterestCategory != null && message.hasOwnProperty("userInterestCategory")) {
                                var error = $root.google.protobuf.StringValue.verify(message.userInterestCategory);
                                if (error)
                                    return "userInterestCategory." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a UserInterestInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.UserInterestInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.UserInterestInfo} UserInterestInfo
                         */
                        UserInterestInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.UserInterestInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.UserInterestInfo();
                            if (object.userInterestCategory != null) {
                                if (typeof object.userInterestCategory !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.UserInterestInfo.userInterestCategory: object expected");
                                message.userInterestCategory = $root.google.protobuf.StringValue.fromObject(object.userInterestCategory);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a UserInterestInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.UserInterestInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.UserInterestInfo} message UserInterestInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserInterestInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.userInterestCategory = null;
                            if (message.userInterestCategory != null && message.hasOwnProperty("userInterestCategory"))
                                object.userInterestCategory = $root.google.protobuf.StringValue.toObject(message.userInterestCategory, options);
                            return object;
                        };

                        /**
                         * Converts this UserInterestInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.UserInterestInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserInterestInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UserInterestInfo;
                    })();

                    common.WebpageInfo = (function() {

                        /**
                         * Properties of a WebpageInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IWebpageInfo
                         * @property {google.protobuf.IStringValue|null} [criterionName] WebpageInfo criterionName
                         * @property {Array.<google.ads.googleads.v1.common.IWebpageConditionInfo>|null} [conditions] WebpageInfo conditions
                         */

                        /**
                         * Constructs a new WebpageInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a WebpageInfo.
                         * @implements IWebpageInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IWebpageInfo=} [properties] Properties to set
                         */
                        function WebpageInfo(properties) {
                            this.conditions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * WebpageInfo criterionName.
                         * @member {google.protobuf.IStringValue|null|undefined} criterionName
                         * @memberof google.ads.googleads.v1.common.WebpageInfo
                         * @instance
                         */
                        WebpageInfo.prototype.criterionName = null;

                        /**
                         * WebpageInfo conditions.
                         * @member {Array.<google.ads.googleads.v1.common.IWebpageConditionInfo>} conditions
                         * @memberof google.ads.googleads.v1.common.WebpageInfo
                         * @instance
                         */
                        WebpageInfo.prototype.conditions = $util.emptyArray;

                        /**
                         * Creates a new WebpageInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.WebpageInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IWebpageInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.WebpageInfo} WebpageInfo instance
                         */
                        WebpageInfo.create = function create(properties) {
                            return new WebpageInfo(properties);
                        };

                        /**
                         * Encodes the specified WebpageInfo message. Does not implicitly {@link google.ads.googleads.v1.common.WebpageInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.WebpageInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IWebpageInfo} message WebpageInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WebpageInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.criterionName != null && message.hasOwnProperty("criterionName"))
                                $root.google.protobuf.StringValue.encode(message.criterionName, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.conditions != null && message.conditions.length)
                                for (var i = 0; i < message.conditions.length; ++i)
                                    $root.google.ads.googleads.v1.common.WebpageConditionInfo.encode(message.conditions[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified WebpageInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.WebpageInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.WebpageInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IWebpageInfo} message WebpageInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WebpageInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a WebpageInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.WebpageInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.WebpageInfo} WebpageInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WebpageInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.WebpageInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.criterionName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.conditions && message.conditions.length))
                                        message.conditions = [];
                                    message.conditions.push($root.google.ads.googleads.v1.common.WebpageConditionInfo.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a WebpageInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.WebpageInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.WebpageInfo} WebpageInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WebpageInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a WebpageInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.WebpageInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        WebpageInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.criterionName != null && message.hasOwnProperty("criterionName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.criterionName);
                                if (error)
                                    return "criterionName." + error;
                            }
                            if (message.conditions != null && message.hasOwnProperty("conditions")) {
                                if (!Array.isArray(message.conditions))
                                    return "conditions: array expected";
                                for (var i = 0; i < message.conditions.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.WebpageConditionInfo.verify(message.conditions[i]);
                                    if (error)
                                        return "conditions." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a WebpageInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.WebpageInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.WebpageInfo} WebpageInfo
                         */
                        WebpageInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.WebpageInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.WebpageInfo();
                            if (object.criterionName != null) {
                                if (typeof object.criterionName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.WebpageInfo.criterionName: object expected");
                                message.criterionName = $root.google.protobuf.StringValue.fromObject(object.criterionName);
                            }
                            if (object.conditions) {
                                if (!Array.isArray(object.conditions))
                                    throw TypeError(".google.ads.googleads.v1.common.WebpageInfo.conditions: array expected");
                                message.conditions = [];
                                for (var i = 0; i < object.conditions.length; ++i) {
                                    if (typeof object.conditions[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.WebpageInfo.conditions: object expected");
                                    message.conditions[i] = $root.google.ads.googleads.v1.common.WebpageConditionInfo.fromObject(object.conditions[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a WebpageInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.WebpageInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.WebpageInfo} message WebpageInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        WebpageInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.conditions = [];
                            if (options.defaults)
                                object.criterionName = null;
                            if (message.criterionName != null && message.hasOwnProperty("criterionName"))
                                object.criterionName = $root.google.protobuf.StringValue.toObject(message.criterionName, options);
                            if (message.conditions && message.conditions.length) {
                                object.conditions = [];
                                for (var j = 0; j < message.conditions.length; ++j)
                                    object.conditions[j] = $root.google.ads.googleads.v1.common.WebpageConditionInfo.toObject(message.conditions[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this WebpageInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.WebpageInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        WebpageInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return WebpageInfo;
                    })();

                    common.WebpageConditionInfo = (function() {

                        /**
                         * Properties of a WebpageConditionInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IWebpageConditionInfo
                         * @property {google.ads.googleads.v1.enums.WebpageConditionOperandEnum.WebpageConditionOperand|null} [operand] WebpageConditionInfo operand
                         * @property {google.ads.googleads.v1.enums.WebpageConditionOperatorEnum.WebpageConditionOperator|null} [operator] WebpageConditionInfo operator
                         * @property {google.protobuf.IStringValue|null} [argument] WebpageConditionInfo argument
                         */

                        /**
                         * Constructs a new WebpageConditionInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a WebpageConditionInfo.
                         * @implements IWebpageConditionInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IWebpageConditionInfo=} [properties] Properties to set
                         */
                        function WebpageConditionInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * WebpageConditionInfo operand.
                         * @member {google.ads.googleads.v1.enums.WebpageConditionOperandEnum.WebpageConditionOperand} operand
                         * @memberof google.ads.googleads.v1.common.WebpageConditionInfo
                         * @instance
                         */
                        WebpageConditionInfo.prototype.operand = 0;

                        /**
                         * WebpageConditionInfo operator.
                         * @member {google.ads.googleads.v1.enums.WebpageConditionOperatorEnum.WebpageConditionOperator} operator
                         * @memberof google.ads.googleads.v1.common.WebpageConditionInfo
                         * @instance
                         */
                        WebpageConditionInfo.prototype.operator = 0;

                        /**
                         * WebpageConditionInfo argument.
                         * @member {google.protobuf.IStringValue|null|undefined} argument
                         * @memberof google.ads.googleads.v1.common.WebpageConditionInfo
                         * @instance
                         */
                        WebpageConditionInfo.prototype.argument = null;

                        /**
                         * Creates a new WebpageConditionInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.WebpageConditionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IWebpageConditionInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.WebpageConditionInfo} WebpageConditionInfo instance
                         */
                        WebpageConditionInfo.create = function create(properties) {
                            return new WebpageConditionInfo(properties);
                        };

                        /**
                         * Encodes the specified WebpageConditionInfo message. Does not implicitly {@link google.ads.googleads.v1.common.WebpageConditionInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.WebpageConditionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IWebpageConditionInfo} message WebpageConditionInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WebpageConditionInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operand != null && message.hasOwnProperty("operand"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.operand);
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.operator);
                            if (message.argument != null && message.hasOwnProperty("argument"))
                                $root.google.protobuf.StringValue.encode(message.argument, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified WebpageConditionInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.WebpageConditionInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.WebpageConditionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IWebpageConditionInfo} message WebpageConditionInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WebpageConditionInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a WebpageConditionInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.WebpageConditionInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.WebpageConditionInfo} WebpageConditionInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WebpageConditionInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.WebpageConditionInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.operand = reader.int32();
                                    break;
                                case 2:
                                    message.operator = reader.int32();
                                    break;
                                case 3:
                                    message.argument = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a WebpageConditionInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.WebpageConditionInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.WebpageConditionInfo} WebpageConditionInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WebpageConditionInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a WebpageConditionInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.WebpageConditionInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        WebpageConditionInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operand != null && message.hasOwnProperty("operand"))
                                switch (message.operand) {
                                default:
                                    return "operand: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                switch (message.operator) {
                                default:
                                    return "operator: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.argument != null && message.hasOwnProperty("argument")) {
                                var error = $root.google.protobuf.StringValue.verify(message.argument);
                                if (error)
                                    return "argument." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a WebpageConditionInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.WebpageConditionInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.WebpageConditionInfo} WebpageConditionInfo
                         */
                        WebpageConditionInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.WebpageConditionInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.WebpageConditionInfo();
                            switch (object.operand) {
                            case "UNSPECIFIED":
                            case 0:
                                message.operand = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.operand = 1;
                                break;
                            case "URL":
                            case 2:
                                message.operand = 2;
                                break;
                            case "CATEGORY":
                            case 3:
                                message.operand = 3;
                                break;
                            case "PAGE_TITLE":
                            case 4:
                                message.operand = 4;
                                break;
                            case "PAGE_CONTENT":
                            case 5:
                                message.operand = 5;
                                break;
                            case "CUSTOM_LABEL":
                            case 6:
                                message.operand = 6;
                                break;
                            }
                            switch (object.operator) {
                            case "UNSPECIFIED":
                            case 0:
                                message.operator = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.operator = 1;
                                break;
                            case "EQUALS":
                            case 2:
                                message.operator = 2;
                                break;
                            case "CONTAINS":
                            case 3:
                                message.operator = 3;
                                break;
                            }
                            if (object.argument != null) {
                                if (typeof object.argument !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.WebpageConditionInfo.argument: object expected");
                                message.argument = $root.google.protobuf.StringValue.fromObject(object.argument);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a WebpageConditionInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.WebpageConditionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.WebpageConditionInfo} message WebpageConditionInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        WebpageConditionInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.operand = options.enums === String ? "UNSPECIFIED" : 0;
                                object.operator = options.enums === String ? "UNSPECIFIED" : 0;
                                object.argument = null;
                            }
                            if (message.operand != null && message.hasOwnProperty("operand"))
                                object.operand = options.enums === String ? $root.google.ads.googleads.v1.enums.WebpageConditionOperandEnum.WebpageConditionOperand[message.operand] : message.operand;
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                object.operator = options.enums === String ? $root.google.ads.googleads.v1.enums.WebpageConditionOperatorEnum.WebpageConditionOperator[message.operator] : message.operator;
                            if (message.argument != null && message.hasOwnProperty("argument"))
                                object.argument = $root.google.protobuf.StringValue.toObject(message.argument, options);
                            return object;
                        };

                        /**
                         * Converts this WebpageConditionInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.WebpageConditionInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        WebpageConditionInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return WebpageConditionInfo;
                    })();

                    common.OperatingSystemVersionInfo = (function() {

                        /**
                         * Properties of an OperatingSystemVersionInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IOperatingSystemVersionInfo
                         * @property {google.protobuf.IStringValue|null} [operatingSystemVersionConstant] OperatingSystemVersionInfo operatingSystemVersionConstant
                         */

                        /**
                         * Constructs a new OperatingSystemVersionInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an OperatingSystemVersionInfo.
                         * @implements IOperatingSystemVersionInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IOperatingSystemVersionInfo=} [properties] Properties to set
                         */
                        function OperatingSystemVersionInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * OperatingSystemVersionInfo operatingSystemVersionConstant.
                         * @member {google.protobuf.IStringValue|null|undefined} operatingSystemVersionConstant
                         * @memberof google.ads.googleads.v1.common.OperatingSystemVersionInfo
                         * @instance
                         */
                        OperatingSystemVersionInfo.prototype.operatingSystemVersionConstant = null;

                        /**
                         * Creates a new OperatingSystemVersionInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.OperatingSystemVersionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IOperatingSystemVersionInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.OperatingSystemVersionInfo} OperatingSystemVersionInfo instance
                         */
                        OperatingSystemVersionInfo.create = function create(properties) {
                            return new OperatingSystemVersionInfo(properties);
                        };

                        /**
                         * Encodes the specified OperatingSystemVersionInfo message. Does not implicitly {@link google.ads.googleads.v1.common.OperatingSystemVersionInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.OperatingSystemVersionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IOperatingSystemVersionInfo} message OperatingSystemVersionInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        OperatingSystemVersionInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operatingSystemVersionConstant != null && message.hasOwnProperty("operatingSystemVersionConstant"))
                                $root.google.protobuf.StringValue.encode(message.operatingSystemVersionConstant, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified OperatingSystemVersionInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.OperatingSystemVersionInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.OperatingSystemVersionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IOperatingSystemVersionInfo} message OperatingSystemVersionInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        OperatingSystemVersionInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an OperatingSystemVersionInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.OperatingSystemVersionInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.OperatingSystemVersionInfo} OperatingSystemVersionInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        OperatingSystemVersionInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.OperatingSystemVersionInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.operatingSystemVersionConstant = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an OperatingSystemVersionInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.OperatingSystemVersionInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.OperatingSystemVersionInfo} OperatingSystemVersionInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        OperatingSystemVersionInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an OperatingSystemVersionInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.OperatingSystemVersionInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        OperatingSystemVersionInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operatingSystemVersionConstant != null && message.hasOwnProperty("operatingSystemVersionConstant")) {
                                var error = $root.google.protobuf.StringValue.verify(message.operatingSystemVersionConstant);
                                if (error)
                                    return "operatingSystemVersionConstant." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an OperatingSystemVersionInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.OperatingSystemVersionInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.OperatingSystemVersionInfo} OperatingSystemVersionInfo
                         */
                        OperatingSystemVersionInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.OperatingSystemVersionInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.OperatingSystemVersionInfo();
                            if (object.operatingSystemVersionConstant != null) {
                                if (typeof object.operatingSystemVersionConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.OperatingSystemVersionInfo.operatingSystemVersionConstant: object expected");
                                message.operatingSystemVersionConstant = $root.google.protobuf.StringValue.fromObject(object.operatingSystemVersionConstant);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an OperatingSystemVersionInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.OperatingSystemVersionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.OperatingSystemVersionInfo} message OperatingSystemVersionInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        OperatingSystemVersionInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.operatingSystemVersionConstant = null;
                            if (message.operatingSystemVersionConstant != null && message.hasOwnProperty("operatingSystemVersionConstant"))
                                object.operatingSystemVersionConstant = $root.google.protobuf.StringValue.toObject(message.operatingSystemVersionConstant, options);
                            return object;
                        };

                        /**
                         * Converts this OperatingSystemVersionInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.OperatingSystemVersionInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        OperatingSystemVersionInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return OperatingSystemVersionInfo;
                    })();

                    common.AppPaymentModelInfo = (function() {

                        /**
                         * Properties of an AppPaymentModelInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IAppPaymentModelInfo
                         * @property {google.ads.googleads.v1.enums.AppPaymentModelTypeEnum.AppPaymentModelType|null} [type] AppPaymentModelInfo type
                         */

                        /**
                         * Constructs a new AppPaymentModelInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an AppPaymentModelInfo.
                         * @implements IAppPaymentModelInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IAppPaymentModelInfo=} [properties] Properties to set
                         */
                        function AppPaymentModelInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AppPaymentModelInfo type.
                         * @member {google.ads.googleads.v1.enums.AppPaymentModelTypeEnum.AppPaymentModelType} type
                         * @memberof google.ads.googleads.v1.common.AppPaymentModelInfo
                         * @instance
                         */
                        AppPaymentModelInfo.prototype.type = 0;

                        /**
                         * Creates a new AppPaymentModelInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.AppPaymentModelInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IAppPaymentModelInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.AppPaymentModelInfo} AppPaymentModelInfo instance
                         */
                        AppPaymentModelInfo.create = function create(properties) {
                            return new AppPaymentModelInfo(properties);
                        };

                        /**
                         * Encodes the specified AppPaymentModelInfo message. Does not implicitly {@link google.ads.googleads.v1.common.AppPaymentModelInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.AppPaymentModelInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IAppPaymentModelInfo} message AppPaymentModelInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppPaymentModelInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.type);
                            return writer;
                        };

                        /**
                         * Encodes the specified AppPaymentModelInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.AppPaymentModelInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.AppPaymentModelInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IAppPaymentModelInfo} message AppPaymentModelInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppPaymentModelInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AppPaymentModelInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.AppPaymentModelInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.AppPaymentModelInfo} AppPaymentModelInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppPaymentModelInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.AppPaymentModelInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.type = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AppPaymentModelInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.AppPaymentModelInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.AppPaymentModelInfo} AppPaymentModelInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppPaymentModelInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AppPaymentModelInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.AppPaymentModelInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AppPaymentModelInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 30:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates an AppPaymentModelInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.AppPaymentModelInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.AppPaymentModelInfo} AppPaymentModelInfo
                         */
                        AppPaymentModelInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.AppPaymentModelInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.AppPaymentModelInfo();
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "PAID":
                            case 30:
                                message.type = 30;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AppPaymentModelInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.AppPaymentModelInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.AppPaymentModelInfo} message AppPaymentModelInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AppPaymentModelInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.AppPaymentModelTypeEnum.AppPaymentModelType[message.type] : message.type;
                            return object;
                        };

                        /**
                         * Converts this AppPaymentModelInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.AppPaymentModelInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AppPaymentModelInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AppPaymentModelInfo;
                    })();

                    common.MobileDeviceInfo = (function() {

                        /**
                         * Properties of a MobileDeviceInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IMobileDeviceInfo
                         * @property {google.protobuf.IStringValue|null} [mobileDeviceConstant] MobileDeviceInfo mobileDeviceConstant
                         */

                        /**
                         * Constructs a new MobileDeviceInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a MobileDeviceInfo.
                         * @implements IMobileDeviceInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IMobileDeviceInfo=} [properties] Properties to set
                         */
                        function MobileDeviceInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MobileDeviceInfo mobileDeviceConstant.
                         * @member {google.protobuf.IStringValue|null|undefined} mobileDeviceConstant
                         * @memberof google.ads.googleads.v1.common.MobileDeviceInfo
                         * @instance
                         */
                        MobileDeviceInfo.prototype.mobileDeviceConstant = null;

                        /**
                         * Creates a new MobileDeviceInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.MobileDeviceInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IMobileDeviceInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.MobileDeviceInfo} MobileDeviceInfo instance
                         */
                        MobileDeviceInfo.create = function create(properties) {
                            return new MobileDeviceInfo(properties);
                        };

                        /**
                         * Encodes the specified MobileDeviceInfo message. Does not implicitly {@link google.ads.googleads.v1.common.MobileDeviceInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.MobileDeviceInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IMobileDeviceInfo} message MobileDeviceInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MobileDeviceInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.mobileDeviceConstant != null && message.hasOwnProperty("mobileDeviceConstant"))
                                $root.google.protobuf.StringValue.encode(message.mobileDeviceConstant, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MobileDeviceInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.MobileDeviceInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.MobileDeviceInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IMobileDeviceInfo} message MobileDeviceInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MobileDeviceInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MobileDeviceInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.MobileDeviceInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.MobileDeviceInfo} MobileDeviceInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MobileDeviceInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.MobileDeviceInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.mobileDeviceConstant = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MobileDeviceInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.MobileDeviceInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.MobileDeviceInfo} MobileDeviceInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MobileDeviceInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MobileDeviceInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.MobileDeviceInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MobileDeviceInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.mobileDeviceConstant != null && message.hasOwnProperty("mobileDeviceConstant")) {
                                var error = $root.google.protobuf.StringValue.verify(message.mobileDeviceConstant);
                                if (error)
                                    return "mobileDeviceConstant." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MobileDeviceInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.MobileDeviceInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.MobileDeviceInfo} MobileDeviceInfo
                         */
                        MobileDeviceInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.MobileDeviceInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.MobileDeviceInfo();
                            if (object.mobileDeviceConstant != null) {
                                if (typeof object.mobileDeviceConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.MobileDeviceInfo.mobileDeviceConstant: object expected");
                                message.mobileDeviceConstant = $root.google.protobuf.StringValue.fromObject(object.mobileDeviceConstant);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MobileDeviceInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.MobileDeviceInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.MobileDeviceInfo} message MobileDeviceInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MobileDeviceInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.mobileDeviceConstant = null;
                            if (message.mobileDeviceConstant != null && message.hasOwnProperty("mobileDeviceConstant"))
                                object.mobileDeviceConstant = $root.google.protobuf.StringValue.toObject(message.mobileDeviceConstant, options);
                            return object;
                        };

                        /**
                         * Converts this MobileDeviceInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.MobileDeviceInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MobileDeviceInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MobileDeviceInfo;
                    })();

                    common.CustomAffinityInfo = (function() {

                        /**
                         * Properties of a CustomAffinityInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ICustomAffinityInfo
                         * @property {google.protobuf.IStringValue|null} [customAffinity] CustomAffinityInfo customAffinity
                         */

                        /**
                         * Constructs a new CustomAffinityInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a CustomAffinityInfo.
                         * @implements ICustomAffinityInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ICustomAffinityInfo=} [properties] Properties to set
                         */
                        function CustomAffinityInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomAffinityInfo customAffinity.
                         * @member {google.protobuf.IStringValue|null|undefined} customAffinity
                         * @memberof google.ads.googleads.v1.common.CustomAffinityInfo
                         * @instance
                         */
                        CustomAffinityInfo.prototype.customAffinity = null;

                        /**
                         * Creates a new CustomAffinityInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.CustomAffinityInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ICustomAffinityInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.CustomAffinityInfo} CustomAffinityInfo instance
                         */
                        CustomAffinityInfo.create = function create(properties) {
                            return new CustomAffinityInfo(properties);
                        };

                        /**
                         * Encodes the specified CustomAffinityInfo message. Does not implicitly {@link google.ads.googleads.v1.common.CustomAffinityInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.CustomAffinityInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ICustomAffinityInfo} message CustomAffinityInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomAffinityInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customAffinity != null && message.hasOwnProperty("customAffinity"))
                                $root.google.protobuf.StringValue.encode(message.customAffinity, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomAffinityInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.CustomAffinityInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.CustomAffinityInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ICustomAffinityInfo} message CustomAffinityInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomAffinityInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomAffinityInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.CustomAffinityInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.CustomAffinityInfo} CustomAffinityInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomAffinityInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.CustomAffinityInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customAffinity = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomAffinityInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.CustomAffinityInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.CustomAffinityInfo} CustomAffinityInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomAffinityInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomAffinityInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.CustomAffinityInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomAffinityInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customAffinity != null && message.hasOwnProperty("customAffinity")) {
                                var error = $root.google.protobuf.StringValue.verify(message.customAffinity);
                                if (error)
                                    return "customAffinity." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CustomAffinityInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.CustomAffinityInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.CustomAffinityInfo} CustomAffinityInfo
                         */
                        CustomAffinityInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.CustomAffinityInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.CustomAffinityInfo();
                            if (object.customAffinity != null) {
                                if (typeof object.customAffinity !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CustomAffinityInfo.customAffinity: object expected");
                                message.customAffinity = $root.google.protobuf.StringValue.fromObject(object.customAffinity);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomAffinityInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.CustomAffinityInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.CustomAffinityInfo} message CustomAffinityInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomAffinityInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.customAffinity = null;
                            if (message.customAffinity != null && message.hasOwnProperty("customAffinity"))
                                object.customAffinity = $root.google.protobuf.StringValue.toObject(message.customAffinity, options);
                            return object;
                        };

                        /**
                         * Converts this CustomAffinityInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.CustomAffinityInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomAffinityInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomAffinityInfo;
                    })();

                    common.CustomIntentInfo = (function() {

                        /**
                         * Properties of a CustomIntentInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ICustomIntentInfo
                         * @property {google.protobuf.IStringValue|null} [customIntent] CustomIntentInfo customIntent
                         */

                        /**
                         * Constructs a new CustomIntentInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a CustomIntentInfo.
                         * @implements ICustomIntentInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ICustomIntentInfo=} [properties] Properties to set
                         */
                        function CustomIntentInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomIntentInfo customIntent.
                         * @member {google.protobuf.IStringValue|null|undefined} customIntent
                         * @memberof google.ads.googleads.v1.common.CustomIntentInfo
                         * @instance
                         */
                        CustomIntentInfo.prototype.customIntent = null;

                        /**
                         * Creates a new CustomIntentInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.CustomIntentInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ICustomIntentInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.CustomIntentInfo} CustomIntentInfo instance
                         */
                        CustomIntentInfo.create = function create(properties) {
                            return new CustomIntentInfo(properties);
                        };

                        /**
                         * Encodes the specified CustomIntentInfo message. Does not implicitly {@link google.ads.googleads.v1.common.CustomIntentInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.CustomIntentInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ICustomIntentInfo} message CustomIntentInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomIntentInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customIntent != null && message.hasOwnProperty("customIntent"))
                                $root.google.protobuf.StringValue.encode(message.customIntent, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomIntentInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.CustomIntentInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.CustomIntentInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ICustomIntentInfo} message CustomIntentInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomIntentInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomIntentInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.CustomIntentInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.CustomIntentInfo} CustomIntentInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomIntentInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.CustomIntentInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customIntent = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomIntentInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.CustomIntentInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.CustomIntentInfo} CustomIntentInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomIntentInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomIntentInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.CustomIntentInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomIntentInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customIntent != null && message.hasOwnProperty("customIntent")) {
                                var error = $root.google.protobuf.StringValue.verify(message.customIntent);
                                if (error)
                                    return "customIntent." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CustomIntentInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.CustomIntentInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.CustomIntentInfo} CustomIntentInfo
                         */
                        CustomIntentInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.CustomIntentInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.CustomIntentInfo();
                            if (object.customIntent != null) {
                                if (typeof object.customIntent !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CustomIntentInfo.customIntent: object expected");
                                message.customIntent = $root.google.protobuf.StringValue.fromObject(object.customIntent);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomIntentInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.CustomIntentInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.CustomIntentInfo} message CustomIntentInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomIntentInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.customIntent = null;
                            if (message.customIntent != null && message.hasOwnProperty("customIntent"))
                                object.customIntent = $root.google.protobuf.StringValue.toObject(message.customIntent, options);
                            return object;
                        };

                        /**
                         * Converts this CustomIntentInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.CustomIntentInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomIntentInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomIntentInfo;
                    })();

                    common.LocationGroupInfo = (function() {

                        /**
                         * Properties of a LocationGroupInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ILocationGroupInfo
                         * @property {google.protobuf.IStringValue|null} [feed] LocationGroupInfo feed
                         * @property {Array.<google.protobuf.IStringValue>|null} [geoTargetConstants] LocationGroupInfo geoTargetConstants
                         * @property {google.protobuf.IInt64Value|null} [radius] LocationGroupInfo radius
                         * @property {google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum.LocationGroupRadiusUnits|null} [radiusUnits] LocationGroupInfo radiusUnits
                         */

                        /**
                         * Constructs a new LocationGroupInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a LocationGroupInfo.
                         * @implements ILocationGroupInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ILocationGroupInfo=} [properties] Properties to set
                         */
                        function LocationGroupInfo(properties) {
                            this.geoTargetConstants = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * LocationGroupInfo feed.
                         * @member {google.protobuf.IStringValue|null|undefined} feed
                         * @memberof google.ads.googleads.v1.common.LocationGroupInfo
                         * @instance
                         */
                        LocationGroupInfo.prototype.feed = null;

                        /**
                         * LocationGroupInfo geoTargetConstants.
                         * @member {Array.<google.protobuf.IStringValue>} geoTargetConstants
                         * @memberof google.ads.googleads.v1.common.LocationGroupInfo
                         * @instance
                         */
                        LocationGroupInfo.prototype.geoTargetConstants = $util.emptyArray;

                        /**
                         * LocationGroupInfo radius.
                         * @member {google.protobuf.IInt64Value|null|undefined} radius
                         * @memberof google.ads.googleads.v1.common.LocationGroupInfo
                         * @instance
                         */
                        LocationGroupInfo.prototype.radius = null;

                        /**
                         * LocationGroupInfo radiusUnits.
                         * @member {google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum.LocationGroupRadiusUnits} radiusUnits
                         * @memberof google.ads.googleads.v1.common.LocationGroupInfo
                         * @instance
                         */
                        LocationGroupInfo.prototype.radiusUnits = 0;

                        /**
                         * Creates a new LocationGroupInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.LocationGroupInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILocationGroupInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.LocationGroupInfo} LocationGroupInfo instance
                         */
                        LocationGroupInfo.create = function create(properties) {
                            return new LocationGroupInfo(properties);
                        };

                        /**
                         * Encodes the specified LocationGroupInfo message. Does not implicitly {@link google.ads.googleads.v1.common.LocationGroupInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.LocationGroupInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILocationGroupInfo} message LocationGroupInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationGroupInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.feed != null && message.hasOwnProperty("feed"))
                                $root.google.protobuf.StringValue.encode(message.feed, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.geoTargetConstants != null && message.geoTargetConstants.length)
                                for (var i = 0; i < message.geoTargetConstants.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.geoTargetConstants[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.radius != null && message.hasOwnProperty("radius"))
                                $root.google.protobuf.Int64Value.encode(message.radius, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.radiusUnits != null && message.hasOwnProperty("radiusUnits"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.radiusUnits);
                            return writer;
                        };

                        /**
                         * Encodes the specified LocationGroupInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.LocationGroupInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.LocationGroupInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILocationGroupInfo} message LocationGroupInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationGroupInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LocationGroupInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.LocationGroupInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.LocationGroupInfo} LocationGroupInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationGroupInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.LocationGroupInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.feed = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.geoTargetConstants && message.geoTargetConstants.length))
                                        message.geoTargetConstants = [];
                                    message.geoTargetConstants.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.radius = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.radiusUnits = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LocationGroupInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.LocationGroupInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.LocationGroupInfo} LocationGroupInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationGroupInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LocationGroupInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.LocationGroupInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LocationGroupInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.feed != null && message.hasOwnProperty("feed")) {
                                var error = $root.google.protobuf.StringValue.verify(message.feed);
                                if (error)
                                    return "feed." + error;
                            }
                            if (message.geoTargetConstants != null && message.hasOwnProperty("geoTargetConstants")) {
                                if (!Array.isArray(message.geoTargetConstants))
                                    return "geoTargetConstants: array expected";
                                for (var i = 0; i < message.geoTargetConstants.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.geoTargetConstants[i]);
                                    if (error)
                                        return "geoTargetConstants." + error;
                                }
                            }
                            if (message.radius != null && message.hasOwnProperty("radius")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.radius);
                                if (error)
                                    return "radius." + error;
                            }
                            if (message.radiusUnits != null && message.hasOwnProperty("radiusUnits"))
                                switch (message.radiusUnits) {
                                default:
                                    return "radiusUnits: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a LocationGroupInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.LocationGroupInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.LocationGroupInfo} LocationGroupInfo
                         */
                        LocationGroupInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.LocationGroupInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.LocationGroupInfo();
                            if (object.feed != null) {
                                if (typeof object.feed !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LocationGroupInfo.feed: object expected");
                                message.feed = $root.google.protobuf.StringValue.fromObject(object.feed);
                            }
                            if (object.geoTargetConstants) {
                                if (!Array.isArray(object.geoTargetConstants))
                                    throw TypeError(".google.ads.googleads.v1.common.LocationGroupInfo.geoTargetConstants: array expected");
                                message.geoTargetConstants = [];
                                for (var i = 0; i < object.geoTargetConstants.length; ++i) {
                                    if (typeof object.geoTargetConstants[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.LocationGroupInfo.geoTargetConstants: object expected");
                                    message.geoTargetConstants[i] = $root.google.protobuf.StringValue.fromObject(object.geoTargetConstants[i]);
                                }
                            }
                            if (object.radius != null) {
                                if (typeof object.radius !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LocationGroupInfo.radius: object expected");
                                message.radius = $root.google.protobuf.Int64Value.fromObject(object.radius);
                            }
                            switch (object.radiusUnits) {
                            case "UNSPECIFIED":
                            case 0:
                                message.radiusUnits = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.radiusUnits = 1;
                                break;
                            case "METERS":
                            case 2:
                                message.radiusUnits = 2;
                                break;
                            case "MILES":
                            case 3:
                                message.radiusUnits = 3;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a LocationGroupInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.LocationGroupInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.LocationGroupInfo} message LocationGroupInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LocationGroupInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.geoTargetConstants = [];
                            if (options.defaults) {
                                object.feed = null;
                                object.radius = null;
                                object.radiusUnits = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.feed != null && message.hasOwnProperty("feed"))
                                object.feed = $root.google.protobuf.StringValue.toObject(message.feed, options);
                            if (message.geoTargetConstants && message.geoTargetConstants.length) {
                                object.geoTargetConstants = [];
                                for (var j = 0; j < message.geoTargetConstants.length; ++j)
                                    object.geoTargetConstants[j] = $root.google.protobuf.StringValue.toObject(message.geoTargetConstants[j], options);
                            }
                            if (message.radius != null && message.hasOwnProperty("radius"))
                                object.radius = $root.google.protobuf.Int64Value.toObject(message.radius, options);
                            if (message.radiusUnits != null && message.hasOwnProperty("radiusUnits"))
                                object.radiusUnits = options.enums === String ? $root.google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum.LocationGroupRadiusUnits[message.radiusUnits] : message.radiusUnits;
                            return object;
                        };

                        /**
                         * Converts this LocationGroupInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.LocationGroupInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LocationGroupInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return LocationGroupInfo;
                    })();

                    common.CriterionCategoryAvailability = (function() {

                        /**
                         * Properties of a CriterionCategoryAvailability.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ICriterionCategoryAvailability
                         * @property {google.ads.googleads.v1.common.ICriterionCategoryChannelAvailability|null} [channel] CriterionCategoryAvailability channel
                         * @property {Array.<google.ads.googleads.v1.common.ICriterionCategoryLocaleAvailability>|null} [locale] CriterionCategoryAvailability locale
                         */

                        /**
                         * Constructs a new CriterionCategoryAvailability.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a CriterionCategoryAvailability.
                         * @implements ICriterionCategoryAvailability
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ICriterionCategoryAvailability=} [properties] Properties to set
                         */
                        function CriterionCategoryAvailability(properties) {
                            this.locale = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CriterionCategoryAvailability channel.
                         * @member {google.ads.googleads.v1.common.ICriterionCategoryChannelAvailability|null|undefined} channel
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryAvailability
                         * @instance
                         */
                        CriterionCategoryAvailability.prototype.channel = null;

                        /**
                         * CriterionCategoryAvailability locale.
                         * @member {Array.<google.ads.googleads.v1.common.ICriterionCategoryLocaleAvailability>} locale
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryAvailability
                         * @instance
                         */
                        CriterionCategoryAvailability.prototype.locale = $util.emptyArray;

                        /**
                         * Creates a new CriterionCategoryAvailability instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryAvailability
                         * @static
                         * @param {google.ads.googleads.v1.common.ICriterionCategoryAvailability=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.CriterionCategoryAvailability} CriterionCategoryAvailability instance
                         */
                        CriterionCategoryAvailability.create = function create(properties) {
                            return new CriterionCategoryAvailability(properties);
                        };

                        /**
                         * Encodes the specified CriterionCategoryAvailability message. Does not implicitly {@link google.ads.googleads.v1.common.CriterionCategoryAvailability.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryAvailability
                         * @static
                         * @param {google.ads.googleads.v1.common.ICriterionCategoryAvailability} message CriterionCategoryAvailability message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CriterionCategoryAvailability.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.channel != null && message.hasOwnProperty("channel"))
                                $root.google.ads.googleads.v1.common.CriterionCategoryChannelAvailability.encode(message.channel, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.locale != null && message.locale.length)
                                for (var i = 0; i < message.locale.length; ++i)
                                    $root.google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability.encode(message.locale[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CriterionCategoryAvailability message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.CriterionCategoryAvailability.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryAvailability
                         * @static
                         * @param {google.ads.googleads.v1.common.ICriterionCategoryAvailability} message CriterionCategoryAvailability message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CriterionCategoryAvailability.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CriterionCategoryAvailability message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryAvailability
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.CriterionCategoryAvailability} CriterionCategoryAvailability
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CriterionCategoryAvailability.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.CriterionCategoryAvailability();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.channel = $root.google.ads.googleads.v1.common.CriterionCategoryChannelAvailability.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.locale && message.locale.length))
                                        message.locale = [];
                                    message.locale.push($root.google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CriterionCategoryAvailability message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryAvailability
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.CriterionCategoryAvailability} CriterionCategoryAvailability
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CriterionCategoryAvailability.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CriterionCategoryAvailability message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryAvailability
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CriterionCategoryAvailability.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.channel != null && message.hasOwnProperty("channel")) {
                                var error = $root.google.ads.googleads.v1.common.CriterionCategoryChannelAvailability.verify(message.channel);
                                if (error)
                                    return "channel." + error;
                            }
                            if (message.locale != null && message.hasOwnProperty("locale")) {
                                if (!Array.isArray(message.locale))
                                    return "locale: array expected";
                                for (var i = 0; i < message.locale.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability.verify(message.locale[i]);
                                    if (error)
                                        return "locale." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a CriterionCategoryAvailability message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryAvailability
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.CriterionCategoryAvailability} CriterionCategoryAvailability
                         */
                        CriterionCategoryAvailability.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.CriterionCategoryAvailability)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.CriterionCategoryAvailability();
                            if (object.channel != null) {
                                if (typeof object.channel !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CriterionCategoryAvailability.channel: object expected");
                                message.channel = $root.google.ads.googleads.v1.common.CriterionCategoryChannelAvailability.fromObject(object.channel);
                            }
                            if (object.locale) {
                                if (!Array.isArray(object.locale))
                                    throw TypeError(".google.ads.googleads.v1.common.CriterionCategoryAvailability.locale: array expected");
                                message.locale = [];
                                for (var i = 0; i < object.locale.length; ++i) {
                                    if (typeof object.locale[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.CriterionCategoryAvailability.locale: object expected");
                                    message.locale[i] = $root.google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability.fromObject(object.locale[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CriterionCategoryAvailability message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryAvailability
                         * @static
                         * @param {google.ads.googleads.v1.common.CriterionCategoryAvailability} message CriterionCategoryAvailability
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CriterionCategoryAvailability.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.locale = [];
                            if (options.defaults)
                                object.channel = null;
                            if (message.channel != null && message.hasOwnProperty("channel"))
                                object.channel = $root.google.ads.googleads.v1.common.CriterionCategoryChannelAvailability.toObject(message.channel, options);
                            if (message.locale && message.locale.length) {
                                object.locale = [];
                                for (var j = 0; j < message.locale.length; ++j)
                                    object.locale[j] = $root.google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability.toObject(message.locale[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this CriterionCategoryAvailability to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryAvailability
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CriterionCategoryAvailability.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CriterionCategoryAvailability;
                    })();

                    common.CriterionCategoryChannelAvailability = (function() {

                        /**
                         * Properties of a CriterionCategoryChannelAvailability.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ICriterionCategoryChannelAvailability
                         * @property {google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum.CriterionCategoryChannelAvailabilityMode|null} [availabilityMode] CriterionCategoryChannelAvailability availabilityMode
                         * @property {google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum.AdvertisingChannelType|null} [advertisingChannelType] CriterionCategoryChannelAvailability advertisingChannelType
                         * @property {Array.<google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum.AdvertisingChannelSubType>|null} [advertisingChannelSubType] CriterionCategoryChannelAvailability advertisingChannelSubType
                         * @property {google.protobuf.IBoolValue|null} [includeDefaultChannelSubType] CriterionCategoryChannelAvailability includeDefaultChannelSubType
                         */

                        /**
                         * Constructs a new CriterionCategoryChannelAvailability.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a CriterionCategoryChannelAvailability.
                         * @implements ICriterionCategoryChannelAvailability
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ICriterionCategoryChannelAvailability=} [properties] Properties to set
                         */
                        function CriterionCategoryChannelAvailability(properties) {
                            this.advertisingChannelSubType = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CriterionCategoryChannelAvailability availabilityMode.
                         * @member {google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum.CriterionCategoryChannelAvailabilityMode} availabilityMode
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryChannelAvailability
                         * @instance
                         */
                        CriterionCategoryChannelAvailability.prototype.availabilityMode = 0;

                        /**
                         * CriterionCategoryChannelAvailability advertisingChannelType.
                         * @member {google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum.AdvertisingChannelType} advertisingChannelType
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryChannelAvailability
                         * @instance
                         */
                        CriterionCategoryChannelAvailability.prototype.advertisingChannelType = 0;

                        /**
                         * CriterionCategoryChannelAvailability advertisingChannelSubType.
                         * @member {Array.<google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum.AdvertisingChannelSubType>} advertisingChannelSubType
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryChannelAvailability
                         * @instance
                         */
                        CriterionCategoryChannelAvailability.prototype.advertisingChannelSubType = $util.emptyArray;

                        /**
                         * CriterionCategoryChannelAvailability includeDefaultChannelSubType.
                         * @member {google.protobuf.IBoolValue|null|undefined} includeDefaultChannelSubType
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryChannelAvailability
                         * @instance
                         */
                        CriterionCategoryChannelAvailability.prototype.includeDefaultChannelSubType = null;

                        /**
                         * Creates a new CriterionCategoryChannelAvailability instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryChannelAvailability
                         * @static
                         * @param {google.ads.googleads.v1.common.ICriterionCategoryChannelAvailability=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.CriterionCategoryChannelAvailability} CriterionCategoryChannelAvailability instance
                         */
                        CriterionCategoryChannelAvailability.create = function create(properties) {
                            return new CriterionCategoryChannelAvailability(properties);
                        };

                        /**
                         * Encodes the specified CriterionCategoryChannelAvailability message. Does not implicitly {@link google.ads.googleads.v1.common.CriterionCategoryChannelAvailability.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryChannelAvailability
                         * @static
                         * @param {google.ads.googleads.v1.common.ICriterionCategoryChannelAvailability} message CriterionCategoryChannelAvailability message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CriterionCategoryChannelAvailability.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.availabilityMode != null && message.hasOwnProperty("availabilityMode"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.availabilityMode);
                            if (message.advertisingChannelType != null && message.hasOwnProperty("advertisingChannelType"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.advertisingChannelType);
                            if (message.advertisingChannelSubType != null && message.advertisingChannelSubType.length) {
                                writer.uint32(/* id 3, wireType 2 =*/26).fork();
                                for (var i = 0; i < message.advertisingChannelSubType.length; ++i)
                                    writer.int32(message.advertisingChannelSubType[i]);
                                writer.ldelim();
                            }
                            if (message.includeDefaultChannelSubType != null && message.hasOwnProperty("includeDefaultChannelSubType"))
                                $root.google.protobuf.BoolValue.encode(message.includeDefaultChannelSubType, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CriterionCategoryChannelAvailability message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.CriterionCategoryChannelAvailability.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryChannelAvailability
                         * @static
                         * @param {google.ads.googleads.v1.common.ICriterionCategoryChannelAvailability} message CriterionCategoryChannelAvailability message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CriterionCategoryChannelAvailability.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CriterionCategoryChannelAvailability message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryChannelAvailability
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.CriterionCategoryChannelAvailability} CriterionCategoryChannelAvailability
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CriterionCategoryChannelAvailability.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.CriterionCategoryChannelAvailability();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.availabilityMode = reader.int32();
                                    break;
                                case 2:
                                    message.advertisingChannelType = reader.int32();
                                    break;
                                case 3:
                                    if (!(message.advertisingChannelSubType && message.advertisingChannelSubType.length))
                                        message.advertisingChannelSubType = [];
                                    if ((tag & 7) === 2) {
                                        var end2 = reader.uint32() + reader.pos;
                                        while (reader.pos < end2)
                                            message.advertisingChannelSubType.push(reader.int32());
                                    } else
                                        message.advertisingChannelSubType.push(reader.int32());
                                    break;
                                case 4:
                                    message.includeDefaultChannelSubType = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CriterionCategoryChannelAvailability message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryChannelAvailability
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.CriterionCategoryChannelAvailability} CriterionCategoryChannelAvailability
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CriterionCategoryChannelAvailability.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CriterionCategoryChannelAvailability message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryChannelAvailability
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CriterionCategoryChannelAvailability.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.availabilityMode != null && message.hasOwnProperty("availabilityMode"))
                                switch (message.availabilityMode) {
                                default:
                                    return "availabilityMode: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.advertisingChannelType != null && message.hasOwnProperty("advertisingChannelType"))
                                switch (message.advertisingChannelType) {
                                default:
                                    return "advertisingChannelType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            if (message.advertisingChannelSubType != null && message.hasOwnProperty("advertisingChannelSubType")) {
                                if (!Array.isArray(message.advertisingChannelSubType))
                                    return "advertisingChannelSubType: array expected";
                                for (var i = 0; i < message.advertisingChannelSubType.length; ++i)
                                    switch (message.advertisingChannelSubType[i]) {
                                    default:
                                        return "advertisingChannelSubType: enum value[] expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                    case 5:
                                    case 6:
                                    case 7:
                                    case 8:
                                    case 9:
                                    case 10:
                                    case 11:
                                    case 12:
                                    case 13:
                                        break;
                                    }
                            }
                            if (message.includeDefaultChannelSubType != null && message.hasOwnProperty("includeDefaultChannelSubType")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.includeDefaultChannelSubType);
                                if (error)
                                    return "includeDefaultChannelSubType." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CriterionCategoryChannelAvailability message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryChannelAvailability
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.CriterionCategoryChannelAvailability} CriterionCategoryChannelAvailability
                         */
                        CriterionCategoryChannelAvailability.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.CriterionCategoryChannelAvailability)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.CriterionCategoryChannelAvailability();
                            switch (object.availabilityMode) {
                            case "UNSPECIFIED":
                            case 0:
                                message.availabilityMode = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.availabilityMode = 1;
                                break;
                            case "ALL_CHANNELS":
                            case 2:
                                message.availabilityMode = 2;
                                break;
                            case "CHANNEL_TYPE_AND_ALL_SUBTYPES":
                            case 3:
                                message.availabilityMode = 3;
                                break;
                            case "CHANNEL_TYPE_AND_SUBSET_SUBTYPES":
                            case 4:
                                message.availabilityMode = 4;
                                break;
                            }
                            switch (object.advertisingChannelType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.advertisingChannelType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.advertisingChannelType = 1;
                                break;
                            case "SEARCH":
                            case 2:
                                message.advertisingChannelType = 2;
                                break;
                            case "DISPLAY":
                            case 3:
                                message.advertisingChannelType = 3;
                                break;
                            case "SHOPPING":
                            case 4:
                                message.advertisingChannelType = 4;
                                break;
                            case "HOTEL":
                            case 5:
                                message.advertisingChannelType = 5;
                                break;
                            case "VIDEO":
                            case 6:
                                message.advertisingChannelType = 6;
                                break;
                            case "MULTI_CHANNEL":
                            case 7:
                                message.advertisingChannelType = 7;
                                break;
                            }
                            if (object.advertisingChannelSubType) {
                                if (!Array.isArray(object.advertisingChannelSubType))
                                    throw TypeError(".google.ads.googleads.v1.common.CriterionCategoryChannelAvailability.advertisingChannelSubType: array expected");
                                message.advertisingChannelSubType = [];
                                for (var i = 0; i < object.advertisingChannelSubType.length; ++i)
                                    switch (object.advertisingChannelSubType[i]) {
                                    default:
                                    case "UNSPECIFIED":
                                    case 0:
                                        message.advertisingChannelSubType[i] = 0;
                                        break;
                                    case "UNKNOWN":
                                    case 1:
                                        message.advertisingChannelSubType[i] = 1;
                                        break;
                                    case "SEARCH_MOBILE_APP":
                                    case 2:
                                        message.advertisingChannelSubType[i] = 2;
                                        break;
                                    case "DISPLAY_MOBILE_APP":
                                    case 3:
                                        message.advertisingChannelSubType[i] = 3;
                                        break;
                                    case "SEARCH_EXPRESS":
                                    case 4:
                                        message.advertisingChannelSubType[i] = 4;
                                        break;
                                    case "DISPLAY_EXPRESS":
                                    case 5:
                                        message.advertisingChannelSubType[i] = 5;
                                        break;
                                    case "SHOPPING_SMART_ADS":
                                    case 6:
                                        message.advertisingChannelSubType[i] = 6;
                                        break;
                                    case "DISPLAY_GMAIL_AD":
                                    case 7:
                                        message.advertisingChannelSubType[i] = 7;
                                        break;
                                    case "DISPLAY_SMART_CAMPAIGN":
                                    case 8:
                                        message.advertisingChannelSubType[i] = 8;
                                        break;
                                    case "VIDEO_OUTSTREAM":
                                    case 9:
                                        message.advertisingChannelSubType[i] = 9;
                                        break;
                                    case "VIDEO_ACTION":
                                    case 10:
                                        message.advertisingChannelSubType[i] = 10;
                                        break;
                                    case "VIDEO_NON_SKIPPABLE":
                                    case 11:
                                        message.advertisingChannelSubType[i] = 11;
                                        break;
                                    case "APP_CAMPAIGN":
                                    case 12:
                                        message.advertisingChannelSubType[i] = 12;
                                        break;
                                    case "APP_CAMPAIGN_FOR_ENGAGEMENT":
                                    case 13:
                                        message.advertisingChannelSubType[i] = 13;
                                        break;
                                    }
                            }
                            if (object.includeDefaultChannelSubType != null) {
                                if (typeof object.includeDefaultChannelSubType !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CriterionCategoryChannelAvailability.includeDefaultChannelSubType: object expected");
                                message.includeDefaultChannelSubType = $root.google.protobuf.BoolValue.fromObject(object.includeDefaultChannelSubType);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CriterionCategoryChannelAvailability message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryChannelAvailability
                         * @static
                         * @param {google.ads.googleads.v1.common.CriterionCategoryChannelAvailability} message CriterionCategoryChannelAvailability
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CriterionCategoryChannelAvailability.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.advertisingChannelSubType = [];
                            if (options.defaults) {
                                object.availabilityMode = options.enums === String ? "UNSPECIFIED" : 0;
                                object.advertisingChannelType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.includeDefaultChannelSubType = null;
                            }
                            if (message.availabilityMode != null && message.hasOwnProperty("availabilityMode"))
                                object.availabilityMode = options.enums === String ? $root.google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum.CriterionCategoryChannelAvailabilityMode[message.availabilityMode] : message.availabilityMode;
                            if (message.advertisingChannelType != null && message.hasOwnProperty("advertisingChannelType"))
                                object.advertisingChannelType = options.enums === String ? $root.google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum.AdvertisingChannelType[message.advertisingChannelType] : message.advertisingChannelType;
                            if (message.advertisingChannelSubType && message.advertisingChannelSubType.length) {
                                object.advertisingChannelSubType = [];
                                for (var j = 0; j < message.advertisingChannelSubType.length; ++j)
                                    object.advertisingChannelSubType[j] = options.enums === String ? $root.google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum.AdvertisingChannelSubType[message.advertisingChannelSubType[j]] : message.advertisingChannelSubType[j];
                            }
                            if (message.includeDefaultChannelSubType != null && message.hasOwnProperty("includeDefaultChannelSubType"))
                                object.includeDefaultChannelSubType = $root.google.protobuf.BoolValue.toObject(message.includeDefaultChannelSubType, options);
                            return object;
                        };

                        /**
                         * Converts this CriterionCategoryChannelAvailability to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryChannelAvailability
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CriterionCategoryChannelAvailability.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CriterionCategoryChannelAvailability;
                    })();

                    common.CriterionCategoryLocaleAvailability = (function() {

                        /**
                         * Properties of a CriterionCategoryLocaleAvailability.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ICriterionCategoryLocaleAvailability
                         * @property {google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum.CriterionCategoryLocaleAvailabilityMode|null} [availabilityMode] CriterionCategoryLocaleAvailability availabilityMode
                         * @property {google.protobuf.IStringValue|null} [countryCode] CriterionCategoryLocaleAvailability countryCode
                         * @property {google.protobuf.IStringValue|null} [languageCode] CriterionCategoryLocaleAvailability languageCode
                         */

                        /**
                         * Constructs a new CriterionCategoryLocaleAvailability.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a CriterionCategoryLocaleAvailability.
                         * @implements ICriterionCategoryLocaleAvailability
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ICriterionCategoryLocaleAvailability=} [properties] Properties to set
                         */
                        function CriterionCategoryLocaleAvailability(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CriterionCategoryLocaleAvailability availabilityMode.
                         * @member {google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum.CriterionCategoryLocaleAvailabilityMode} availabilityMode
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability
                         * @instance
                         */
                        CriterionCategoryLocaleAvailability.prototype.availabilityMode = 0;

                        /**
                         * CriterionCategoryLocaleAvailability countryCode.
                         * @member {google.protobuf.IStringValue|null|undefined} countryCode
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability
                         * @instance
                         */
                        CriterionCategoryLocaleAvailability.prototype.countryCode = null;

                        /**
                         * CriterionCategoryLocaleAvailability languageCode.
                         * @member {google.protobuf.IStringValue|null|undefined} languageCode
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability
                         * @instance
                         */
                        CriterionCategoryLocaleAvailability.prototype.languageCode = null;

                        /**
                         * Creates a new CriterionCategoryLocaleAvailability instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability
                         * @static
                         * @param {google.ads.googleads.v1.common.ICriterionCategoryLocaleAvailability=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability} CriterionCategoryLocaleAvailability instance
                         */
                        CriterionCategoryLocaleAvailability.create = function create(properties) {
                            return new CriterionCategoryLocaleAvailability(properties);
                        };

                        /**
                         * Encodes the specified CriterionCategoryLocaleAvailability message. Does not implicitly {@link google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability
                         * @static
                         * @param {google.ads.googleads.v1.common.ICriterionCategoryLocaleAvailability} message CriterionCategoryLocaleAvailability message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CriterionCategoryLocaleAvailability.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.availabilityMode != null && message.hasOwnProperty("availabilityMode"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.availabilityMode);
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                $root.google.protobuf.StringValue.encode(message.countryCode, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.languageCode != null && message.hasOwnProperty("languageCode"))
                                $root.google.protobuf.StringValue.encode(message.languageCode, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CriterionCategoryLocaleAvailability message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability
                         * @static
                         * @param {google.ads.googleads.v1.common.ICriterionCategoryLocaleAvailability} message CriterionCategoryLocaleAvailability message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CriterionCategoryLocaleAvailability.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CriterionCategoryLocaleAvailability message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability} CriterionCategoryLocaleAvailability
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CriterionCategoryLocaleAvailability.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.availabilityMode = reader.int32();
                                    break;
                                case 2:
                                    message.countryCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.languageCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CriterionCategoryLocaleAvailability message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability} CriterionCategoryLocaleAvailability
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CriterionCategoryLocaleAvailability.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CriterionCategoryLocaleAvailability message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CriterionCategoryLocaleAvailability.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.availabilityMode != null && message.hasOwnProperty("availabilityMode"))
                                switch (message.availabilityMode) {
                                default:
                                    return "availabilityMode: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            if (message.countryCode != null && message.hasOwnProperty("countryCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.countryCode);
                                if (error)
                                    return "countryCode." + error;
                            }
                            if (message.languageCode != null && message.hasOwnProperty("languageCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.languageCode);
                                if (error)
                                    return "languageCode." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CriterionCategoryLocaleAvailability message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability} CriterionCategoryLocaleAvailability
                         */
                        CriterionCategoryLocaleAvailability.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability();
                            switch (object.availabilityMode) {
                            case "UNSPECIFIED":
                            case 0:
                                message.availabilityMode = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.availabilityMode = 1;
                                break;
                            case "ALL_LOCALES":
                            case 2:
                                message.availabilityMode = 2;
                                break;
                            case "COUNTRY_AND_ALL_LANGUAGES":
                            case 3:
                                message.availabilityMode = 3;
                                break;
                            case "LANGUAGE_AND_ALL_COUNTRIES":
                            case 4:
                                message.availabilityMode = 4;
                                break;
                            case "COUNTRY_AND_LANGUAGE":
                            case 5:
                                message.availabilityMode = 5;
                                break;
                            }
                            if (object.countryCode != null) {
                                if (typeof object.countryCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability.countryCode: object expected");
                                message.countryCode = $root.google.protobuf.StringValue.fromObject(object.countryCode);
                            }
                            if (object.languageCode != null) {
                                if (typeof object.languageCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability.languageCode: object expected");
                                message.languageCode = $root.google.protobuf.StringValue.fromObject(object.languageCode);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CriterionCategoryLocaleAvailability message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability
                         * @static
                         * @param {google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability} message CriterionCategoryLocaleAvailability
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CriterionCategoryLocaleAvailability.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.availabilityMode = options.enums === String ? "UNSPECIFIED" : 0;
                                object.countryCode = null;
                                object.languageCode = null;
                            }
                            if (message.availabilityMode != null && message.hasOwnProperty("availabilityMode"))
                                object.availabilityMode = options.enums === String ? $root.google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum.CriterionCategoryLocaleAvailabilityMode[message.availabilityMode] : message.availabilityMode;
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                object.countryCode = $root.google.protobuf.StringValue.toObject(message.countryCode, options);
                            if (message.languageCode != null && message.hasOwnProperty("languageCode"))
                                object.languageCode = $root.google.protobuf.StringValue.toObject(message.languageCode, options);
                            return object;
                        };

                        /**
                         * Converts this CriterionCategoryLocaleAvailability to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.CriterionCategoryLocaleAvailability
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CriterionCategoryLocaleAvailability.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CriterionCategoryLocaleAvailability;
                    })();

                    common.CustomParameter = (function() {

                        /**
                         * Properties of a CustomParameter.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ICustomParameter
                         * @property {google.protobuf.IStringValue|null} [key] CustomParameter key
                         * @property {google.protobuf.IStringValue|null} [value] CustomParameter value
                         */

                        /**
                         * Constructs a new CustomParameter.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a CustomParameter.
                         * @implements ICustomParameter
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ICustomParameter=} [properties] Properties to set
                         */
                        function CustomParameter(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomParameter key.
                         * @member {google.protobuf.IStringValue|null|undefined} key
                         * @memberof google.ads.googleads.v1.common.CustomParameter
                         * @instance
                         */
                        CustomParameter.prototype.key = null;

                        /**
                         * CustomParameter value.
                         * @member {google.protobuf.IStringValue|null|undefined} value
                         * @memberof google.ads.googleads.v1.common.CustomParameter
                         * @instance
                         */
                        CustomParameter.prototype.value = null;

                        /**
                         * Creates a new CustomParameter instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.CustomParameter
                         * @static
                         * @param {google.ads.googleads.v1.common.ICustomParameter=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.CustomParameter} CustomParameter instance
                         */
                        CustomParameter.create = function create(properties) {
                            return new CustomParameter(properties);
                        };

                        /**
                         * Encodes the specified CustomParameter message. Does not implicitly {@link google.ads.googleads.v1.common.CustomParameter.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.CustomParameter
                         * @static
                         * @param {google.ads.googleads.v1.common.ICustomParameter} message CustomParameter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomParameter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.key != null && message.hasOwnProperty("key"))
                                $root.google.protobuf.StringValue.encode(message.key, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.value != null && message.hasOwnProperty("value"))
                                $root.google.protobuf.StringValue.encode(message.value, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomParameter message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.CustomParameter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.CustomParameter
                         * @static
                         * @param {google.ads.googleads.v1.common.ICustomParameter} message CustomParameter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomParameter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomParameter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.CustomParameter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.CustomParameter} CustomParameter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomParameter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.CustomParameter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.key = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.value = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomParameter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.CustomParameter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.CustomParameter} CustomParameter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomParameter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomParameter message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.CustomParameter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomParameter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.key != null && message.hasOwnProperty("key")) {
                                var error = $root.google.protobuf.StringValue.verify(message.key);
                                if (error)
                                    return "key." + error;
                            }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                var error = $root.google.protobuf.StringValue.verify(message.value);
                                if (error)
                                    return "value." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CustomParameter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.CustomParameter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.CustomParameter} CustomParameter
                         */
                        CustomParameter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.CustomParameter)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.CustomParameter();
                            if (object.key != null) {
                                if (typeof object.key !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CustomParameter.key: object expected");
                                message.key = $root.google.protobuf.StringValue.fromObject(object.key);
                            }
                            if (object.value != null) {
                                if (typeof object.value !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CustomParameter.value: object expected");
                                message.value = $root.google.protobuf.StringValue.fromObject(object.value);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomParameter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.CustomParameter
                         * @static
                         * @param {google.ads.googleads.v1.common.CustomParameter} message CustomParameter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomParameter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.key = null;
                                object.value = null;
                            }
                            if (message.key != null && message.hasOwnProperty("key"))
                                object.key = $root.google.protobuf.StringValue.toObject(message.key, options);
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = $root.google.protobuf.StringValue.toObject(message.value, options);
                            return object;
                        };

                        /**
                         * Converts this CustomParameter to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.CustomParameter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomParameter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomParameter;
                    })();

                    common.DateRange = (function() {

                        /**
                         * Properties of a DateRange.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IDateRange
                         * @property {google.protobuf.IStringValue|null} [startDate] DateRange startDate
                         * @property {google.protobuf.IStringValue|null} [endDate] DateRange endDate
                         */

                        /**
                         * Constructs a new DateRange.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a DateRange.
                         * @implements IDateRange
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IDateRange=} [properties] Properties to set
                         */
                        function DateRange(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * DateRange startDate.
                         * @member {google.protobuf.IStringValue|null|undefined} startDate
                         * @memberof google.ads.googleads.v1.common.DateRange
                         * @instance
                         */
                        DateRange.prototype.startDate = null;

                        /**
                         * DateRange endDate.
                         * @member {google.protobuf.IStringValue|null|undefined} endDate
                         * @memberof google.ads.googleads.v1.common.DateRange
                         * @instance
                         */
                        DateRange.prototype.endDate = null;

                        /**
                         * Creates a new DateRange instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.DateRange
                         * @static
                         * @param {google.ads.googleads.v1.common.IDateRange=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.DateRange} DateRange instance
                         */
                        DateRange.create = function create(properties) {
                            return new DateRange(properties);
                        };

                        /**
                         * Encodes the specified DateRange message. Does not implicitly {@link google.ads.googleads.v1.common.DateRange.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.DateRange
                         * @static
                         * @param {google.ads.googleads.v1.common.IDateRange} message DateRange message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DateRange.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.startDate != null && message.hasOwnProperty("startDate"))
                                $root.google.protobuf.StringValue.encode(message.startDate, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.endDate != null && message.hasOwnProperty("endDate"))
                                $root.google.protobuf.StringValue.encode(message.endDate, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified DateRange message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.DateRange.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.DateRange
                         * @static
                         * @param {google.ads.googleads.v1.common.IDateRange} message DateRange message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DateRange.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DateRange message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.DateRange
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.DateRange} DateRange
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DateRange.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.DateRange();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.startDate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.endDate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DateRange message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.DateRange
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.DateRange} DateRange
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DateRange.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DateRange message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.DateRange
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DateRange.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.startDate != null && message.hasOwnProperty("startDate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.startDate);
                                if (error)
                                    return "startDate." + error;
                            }
                            if (message.endDate != null && message.hasOwnProperty("endDate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.endDate);
                                if (error)
                                    return "endDate." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a DateRange message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.DateRange
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.DateRange} DateRange
                         */
                        DateRange.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.DateRange)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.DateRange();
                            if (object.startDate != null) {
                                if (typeof object.startDate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.DateRange.startDate: object expected");
                                message.startDate = $root.google.protobuf.StringValue.fromObject(object.startDate);
                            }
                            if (object.endDate != null) {
                                if (typeof object.endDate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.DateRange.endDate: object expected");
                                message.endDate = $root.google.protobuf.StringValue.fromObject(object.endDate);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a DateRange message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.DateRange
                         * @static
                         * @param {google.ads.googleads.v1.common.DateRange} message DateRange
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DateRange.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.startDate = null;
                                object.endDate = null;
                            }
                            if (message.startDate != null && message.hasOwnProperty("startDate"))
                                object.startDate = $root.google.protobuf.StringValue.toObject(message.startDate, options);
                            if (message.endDate != null && message.hasOwnProperty("endDate"))
                                object.endDate = $root.google.protobuf.StringValue.toObject(message.endDate, options);
                            return object;
                        };

                        /**
                         * Converts this DateRange to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.DateRange
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DateRange.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return DateRange;
                    })();

                    common.ExplorerAutoOptimizerSetting = (function() {

                        /**
                         * Properties of an ExplorerAutoOptimizerSetting.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IExplorerAutoOptimizerSetting
                         * @property {google.protobuf.IBoolValue|null} [optIn] ExplorerAutoOptimizerSetting optIn
                         */

                        /**
                         * Constructs a new ExplorerAutoOptimizerSetting.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an ExplorerAutoOptimizerSetting.
                         * @implements IExplorerAutoOptimizerSetting
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IExplorerAutoOptimizerSetting=} [properties] Properties to set
                         */
                        function ExplorerAutoOptimizerSetting(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ExplorerAutoOptimizerSetting optIn.
                         * @member {google.protobuf.IBoolValue|null|undefined} optIn
                         * @memberof google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting
                         * @instance
                         */
                        ExplorerAutoOptimizerSetting.prototype.optIn = null;

                        /**
                         * Creates a new ExplorerAutoOptimizerSetting instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting
                         * @static
                         * @param {google.ads.googleads.v1.common.IExplorerAutoOptimizerSetting=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting} ExplorerAutoOptimizerSetting instance
                         */
                        ExplorerAutoOptimizerSetting.create = function create(properties) {
                            return new ExplorerAutoOptimizerSetting(properties);
                        };

                        /**
                         * Encodes the specified ExplorerAutoOptimizerSetting message. Does not implicitly {@link google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting
                         * @static
                         * @param {google.ads.googleads.v1.common.IExplorerAutoOptimizerSetting} message ExplorerAutoOptimizerSetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExplorerAutoOptimizerSetting.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.optIn != null && message.hasOwnProperty("optIn"))
                                $root.google.protobuf.BoolValue.encode(message.optIn, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ExplorerAutoOptimizerSetting message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting
                         * @static
                         * @param {google.ads.googleads.v1.common.IExplorerAutoOptimizerSetting} message ExplorerAutoOptimizerSetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExplorerAutoOptimizerSetting.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ExplorerAutoOptimizerSetting message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting} ExplorerAutoOptimizerSetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExplorerAutoOptimizerSetting.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.optIn = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ExplorerAutoOptimizerSetting message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting} ExplorerAutoOptimizerSetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExplorerAutoOptimizerSetting.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ExplorerAutoOptimizerSetting message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExplorerAutoOptimizerSetting.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.optIn != null && message.hasOwnProperty("optIn")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.optIn);
                                if (error)
                                    return "optIn." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an ExplorerAutoOptimizerSetting message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting} ExplorerAutoOptimizerSetting
                         */
                        ExplorerAutoOptimizerSetting.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting();
                            if (object.optIn != null) {
                                if (typeof object.optIn !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting.optIn: object expected");
                                message.optIn = $root.google.protobuf.BoolValue.fromObject(object.optIn);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an ExplorerAutoOptimizerSetting message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting
                         * @static
                         * @param {google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting} message ExplorerAutoOptimizerSetting
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExplorerAutoOptimizerSetting.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.optIn = null;
                            if (message.optIn != null && message.hasOwnProperty("optIn"))
                                object.optIn = $root.google.protobuf.BoolValue.toObject(message.optIn, options);
                            return object;
                        };

                        /**
                         * Converts this ExplorerAutoOptimizerSetting to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExplorerAutoOptimizerSetting.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ExplorerAutoOptimizerSetting;
                    })();

                    common.AppFeedItem = (function() {

                        /**
                         * Properties of an AppFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IAppFeedItem
                         * @property {google.protobuf.IStringValue|null} [linkText] AppFeedItem linkText
                         * @property {google.protobuf.IStringValue|null} [appId] AppFeedItem appId
                         * @property {google.ads.googleads.v1.enums.AppStoreEnum.AppStore|null} [appStore] AppFeedItem appStore
                         * @property {Array.<google.protobuf.IStringValue>|null} [finalUrls] AppFeedItem finalUrls
                         * @property {Array.<google.protobuf.IStringValue>|null} [finalMobileUrls] AppFeedItem finalMobileUrls
                         * @property {google.protobuf.IStringValue|null} [trackingUrlTemplate] AppFeedItem trackingUrlTemplate
                         * @property {Array.<google.ads.googleads.v1.common.ICustomParameter>|null} [urlCustomParameters] AppFeedItem urlCustomParameters
                         * @property {google.protobuf.IStringValue|null} [finalUrlSuffix] AppFeedItem finalUrlSuffix
                         */

                        /**
                         * Constructs a new AppFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an AppFeedItem.
                         * @implements IAppFeedItem
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IAppFeedItem=} [properties] Properties to set
                         */
                        function AppFeedItem(properties) {
                            this.finalUrls = [];
                            this.finalMobileUrls = [];
                            this.urlCustomParameters = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AppFeedItem linkText.
                         * @member {google.protobuf.IStringValue|null|undefined} linkText
                         * @memberof google.ads.googleads.v1.common.AppFeedItem
                         * @instance
                         */
                        AppFeedItem.prototype.linkText = null;

                        /**
                         * AppFeedItem appId.
                         * @member {google.protobuf.IStringValue|null|undefined} appId
                         * @memberof google.ads.googleads.v1.common.AppFeedItem
                         * @instance
                         */
                        AppFeedItem.prototype.appId = null;

                        /**
                         * AppFeedItem appStore.
                         * @member {google.ads.googleads.v1.enums.AppStoreEnum.AppStore} appStore
                         * @memberof google.ads.googleads.v1.common.AppFeedItem
                         * @instance
                         */
                        AppFeedItem.prototype.appStore = 0;

                        /**
                         * AppFeedItem finalUrls.
                         * @member {Array.<google.protobuf.IStringValue>} finalUrls
                         * @memberof google.ads.googleads.v1.common.AppFeedItem
                         * @instance
                         */
                        AppFeedItem.prototype.finalUrls = $util.emptyArray;

                        /**
                         * AppFeedItem finalMobileUrls.
                         * @member {Array.<google.protobuf.IStringValue>} finalMobileUrls
                         * @memberof google.ads.googleads.v1.common.AppFeedItem
                         * @instance
                         */
                        AppFeedItem.prototype.finalMobileUrls = $util.emptyArray;

                        /**
                         * AppFeedItem trackingUrlTemplate.
                         * @member {google.protobuf.IStringValue|null|undefined} trackingUrlTemplate
                         * @memberof google.ads.googleads.v1.common.AppFeedItem
                         * @instance
                         */
                        AppFeedItem.prototype.trackingUrlTemplate = null;

                        /**
                         * AppFeedItem urlCustomParameters.
                         * @member {Array.<google.ads.googleads.v1.common.ICustomParameter>} urlCustomParameters
                         * @memberof google.ads.googleads.v1.common.AppFeedItem
                         * @instance
                         */
                        AppFeedItem.prototype.urlCustomParameters = $util.emptyArray;

                        /**
                         * AppFeedItem finalUrlSuffix.
                         * @member {google.protobuf.IStringValue|null|undefined} finalUrlSuffix
                         * @memberof google.ads.googleads.v1.common.AppFeedItem
                         * @instance
                         */
                        AppFeedItem.prototype.finalUrlSuffix = null;

                        /**
                         * Creates a new AppFeedItem instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.AppFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.IAppFeedItem=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.AppFeedItem} AppFeedItem instance
                         */
                        AppFeedItem.create = function create(properties) {
                            return new AppFeedItem(properties);
                        };

                        /**
                         * Encodes the specified AppFeedItem message. Does not implicitly {@link google.ads.googleads.v1.common.AppFeedItem.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.AppFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.IAppFeedItem} message AppFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppFeedItem.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.linkText != null && message.hasOwnProperty("linkText"))
                                $root.google.protobuf.StringValue.encode(message.linkText, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.appId != null && message.hasOwnProperty("appId"))
                                $root.google.protobuf.StringValue.encode(message.appId, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.appStore != null && message.hasOwnProperty("appStore"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.appStore);
                            if (message.finalUrls != null && message.finalUrls.length)
                                for (var i = 0; i < message.finalUrls.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.finalUrls[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.finalMobileUrls != null && message.finalMobileUrls.length)
                                for (var i = 0; i < message.finalMobileUrls.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.finalMobileUrls[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                $root.google.protobuf.StringValue.encode(message.trackingUrlTemplate, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.urlCustomParameters != null && message.urlCustomParameters.length)
                                for (var i = 0; i < message.urlCustomParameters.length; ++i)
                                    $root.google.ads.googleads.v1.common.CustomParameter.encode(message.urlCustomParameters[i], writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix"))
                                $root.google.protobuf.StringValue.encode(message.finalUrlSuffix, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AppFeedItem message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.AppFeedItem.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.AppFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.IAppFeedItem} message AppFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppFeedItem.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AppFeedItem message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.AppFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.AppFeedItem} AppFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppFeedItem.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.AppFeedItem();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.linkText = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.appId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.appStore = reader.int32();
                                    break;
                                case 4:
                                    if (!(message.finalUrls && message.finalUrls.length))
                                        message.finalUrls = [];
                                    message.finalUrls.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 5:
                                    if (!(message.finalMobileUrls && message.finalMobileUrls.length))
                                        message.finalMobileUrls = [];
                                    message.finalMobileUrls.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 6:
                                    message.trackingUrlTemplate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    if (!(message.urlCustomParameters && message.urlCustomParameters.length))
                                        message.urlCustomParameters = [];
                                    message.urlCustomParameters.push($root.google.ads.googleads.v1.common.CustomParameter.decode(reader, reader.uint32()));
                                    break;
                                case 8:
                                    message.finalUrlSuffix = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AppFeedItem message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.AppFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.AppFeedItem} AppFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppFeedItem.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AppFeedItem message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.AppFeedItem
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AppFeedItem.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.linkText != null && message.hasOwnProperty("linkText")) {
                                var error = $root.google.protobuf.StringValue.verify(message.linkText);
                                if (error)
                                    return "linkText." + error;
                            }
                            if (message.appId != null && message.hasOwnProperty("appId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.appId);
                                if (error)
                                    return "appId." + error;
                            }
                            if (message.appStore != null && message.hasOwnProperty("appStore"))
                                switch (message.appStore) {
                                default:
                                    return "appStore: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.finalUrls != null && message.hasOwnProperty("finalUrls")) {
                                if (!Array.isArray(message.finalUrls))
                                    return "finalUrls: array expected";
                                for (var i = 0; i < message.finalUrls.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.finalUrls[i]);
                                    if (error)
                                        return "finalUrls." + error;
                                }
                            }
                            if (message.finalMobileUrls != null && message.hasOwnProperty("finalMobileUrls")) {
                                if (!Array.isArray(message.finalMobileUrls))
                                    return "finalMobileUrls: array expected";
                                for (var i = 0; i < message.finalMobileUrls.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.finalMobileUrls[i]);
                                    if (error)
                                        return "finalMobileUrls." + error;
                                }
                            }
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.trackingUrlTemplate);
                                if (error)
                                    return "trackingUrlTemplate." + error;
                            }
                            if (message.urlCustomParameters != null && message.hasOwnProperty("urlCustomParameters")) {
                                if (!Array.isArray(message.urlCustomParameters))
                                    return "urlCustomParameters: array expected";
                                for (var i = 0; i < message.urlCustomParameters.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.CustomParameter.verify(message.urlCustomParameters[i]);
                                    if (error)
                                        return "urlCustomParameters." + error;
                                }
                            }
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix")) {
                                var error = $root.google.protobuf.StringValue.verify(message.finalUrlSuffix);
                                if (error)
                                    return "finalUrlSuffix." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an AppFeedItem message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.AppFeedItem
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.AppFeedItem} AppFeedItem
                         */
                        AppFeedItem.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.AppFeedItem)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.AppFeedItem();
                            if (object.linkText != null) {
                                if (typeof object.linkText !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AppFeedItem.linkText: object expected");
                                message.linkText = $root.google.protobuf.StringValue.fromObject(object.linkText);
                            }
                            if (object.appId != null) {
                                if (typeof object.appId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AppFeedItem.appId: object expected");
                                message.appId = $root.google.protobuf.StringValue.fromObject(object.appId);
                            }
                            switch (object.appStore) {
                            case "UNSPECIFIED":
                            case 0:
                                message.appStore = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.appStore = 1;
                                break;
                            case "APPLE_ITUNES":
                            case 2:
                                message.appStore = 2;
                                break;
                            case "GOOGLE_PLAY":
                            case 3:
                                message.appStore = 3;
                                break;
                            }
                            if (object.finalUrls) {
                                if (!Array.isArray(object.finalUrls))
                                    throw TypeError(".google.ads.googleads.v1.common.AppFeedItem.finalUrls: array expected");
                                message.finalUrls = [];
                                for (var i = 0; i < object.finalUrls.length; ++i) {
                                    if (typeof object.finalUrls[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.AppFeedItem.finalUrls: object expected");
                                    message.finalUrls[i] = $root.google.protobuf.StringValue.fromObject(object.finalUrls[i]);
                                }
                            }
                            if (object.finalMobileUrls) {
                                if (!Array.isArray(object.finalMobileUrls))
                                    throw TypeError(".google.ads.googleads.v1.common.AppFeedItem.finalMobileUrls: array expected");
                                message.finalMobileUrls = [];
                                for (var i = 0; i < object.finalMobileUrls.length; ++i) {
                                    if (typeof object.finalMobileUrls[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.AppFeedItem.finalMobileUrls: object expected");
                                    message.finalMobileUrls[i] = $root.google.protobuf.StringValue.fromObject(object.finalMobileUrls[i]);
                                }
                            }
                            if (object.trackingUrlTemplate != null) {
                                if (typeof object.trackingUrlTemplate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AppFeedItem.trackingUrlTemplate: object expected");
                                message.trackingUrlTemplate = $root.google.protobuf.StringValue.fromObject(object.trackingUrlTemplate);
                            }
                            if (object.urlCustomParameters) {
                                if (!Array.isArray(object.urlCustomParameters))
                                    throw TypeError(".google.ads.googleads.v1.common.AppFeedItem.urlCustomParameters: array expected");
                                message.urlCustomParameters = [];
                                for (var i = 0; i < object.urlCustomParameters.length; ++i) {
                                    if (typeof object.urlCustomParameters[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.AppFeedItem.urlCustomParameters: object expected");
                                    message.urlCustomParameters[i] = $root.google.ads.googleads.v1.common.CustomParameter.fromObject(object.urlCustomParameters[i]);
                                }
                            }
                            if (object.finalUrlSuffix != null) {
                                if (typeof object.finalUrlSuffix !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AppFeedItem.finalUrlSuffix: object expected");
                                message.finalUrlSuffix = $root.google.protobuf.StringValue.fromObject(object.finalUrlSuffix);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AppFeedItem message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.AppFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.AppFeedItem} message AppFeedItem
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AppFeedItem.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.finalUrls = [];
                                object.finalMobileUrls = [];
                                object.urlCustomParameters = [];
                            }
                            if (options.defaults) {
                                object.linkText = null;
                                object.appId = null;
                                object.appStore = options.enums === String ? "UNSPECIFIED" : 0;
                                object.trackingUrlTemplate = null;
                                object.finalUrlSuffix = null;
                            }
                            if (message.linkText != null && message.hasOwnProperty("linkText"))
                                object.linkText = $root.google.protobuf.StringValue.toObject(message.linkText, options);
                            if (message.appId != null && message.hasOwnProperty("appId"))
                                object.appId = $root.google.protobuf.StringValue.toObject(message.appId, options);
                            if (message.appStore != null && message.hasOwnProperty("appStore"))
                                object.appStore = options.enums === String ? $root.google.ads.googleads.v1.enums.AppStoreEnum.AppStore[message.appStore] : message.appStore;
                            if (message.finalUrls && message.finalUrls.length) {
                                object.finalUrls = [];
                                for (var j = 0; j < message.finalUrls.length; ++j)
                                    object.finalUrls[j] = $root.google.protobuf.StringValue.toObject(message.finalUrls[j], options);
                            }
                            if (message.finalMobileUrls && message.finalMobileUrls.length) {
                                object.finalMobileUrls = [];
                                for (var j = 0; j < message.finalMobileUrls.length; ++j)
                                    object.finalMobileUrls[j] = $root.google.protobuf.StringValue.toObject(message.finalMobileUrls[j], options);
                            }
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                object.trackingUrlTemplate = $root.google.protobuf.StringValue.toObject(message.trackingUrlTemplate, options);
                            if (message.urlCustomParameters && message.urlCustomParameters.length) {
                                object.urlCustomParameters = [];
                                for (var j = 0; j < message.urlCustomParameters.length; ++j)
                                    object.urlCustomParameters[j] = $root.google.ads.googleads.v1.common.CustomParameter.toObject(message.urlCustomParameters[j], options);
                            }
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix"))
                                object.finalUrlSuffix = $root.google.protobuf.StringValue.toObject(message.finalUrlSuffix, options);
                            return object;
                        };

                        /**
                         * Converts this AppFeedItem to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.AppFeedItem
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AppFeedItem.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AppFeedItem;
                    })();

                    common.CallFeedItem = (function() {

                        /**
                         * Properties of a CallFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ICallFeedItem
                         * @property {google.protobuf.IStringValue|null} [phoneNumber] CallFeedItem phoneNumber
                         * @property {google.protobuf.IStringValue|null} [countryCode] CallFeedItem countryCode
                         * @property {google.protobuf.IBoolValue|null} [callTrackingEnabled] CallFeedItem callTrackingEnabled
                         * @property {google.protobuf.IStringValue|null} [callConversionAction] CallFeedItem callConversionAction
                         * @property {google.protobuf.IBoolValue|null} [callConversionTrackingDisabled] CallFeedItem callConversionTrackingDisabled
                         * @property {google.ads.googleads.v1.enums.CallConversionReportingStateEnum.CallConversionReportingState|null} [callConversionReportingState] CallFeedItem callConversionReportingState
                         */

                        /**
                         * Constructs a new CallFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a CallFeedItem.
                         * @implements ICallFeedItem
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ICallFeedItem=} [properties] Properties to set
                         */
                        function CallFeedItem(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CallFeedItem phoneNumber.
                         * @member {google.protobuf.IStringValue|null|undefined} phoneNumber
                         * @memberof google.ads.googleads.v1.common.CallFeedItem
                         * @instance
                         */
                        CallFeedItem.prototype.phoneNumber = null;

                        /**
                         * CallFeedItem countryCode.
                         * @member {google.protobuf.IStringValue|null|undefined} countryCode
                         * @memberof google.ads.googleads.v1.common.CallFeedItem
                         * @instance
                         */
                        CallFeedItem.prototype.countryCode = null;

                        /**
                         * CallFeedItem callTrackingEnabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} callTrackingEnabled
                         * @memberof google.ads.googleads.v1.common.CallFeedItem
                         * @instance
                         */
                        CallFeedItem.prototype.callTrackingEnabled = null;

                        /**
                         * CallFeedItem callConversionAction.
                         * @member {google.protobuf.IStringValue|null|undefined} callConversionAction
                         * @memberof google.ads.googleads.v1.common.CallFeedItem
                         * @instance
                         */
                        CallFeedItem.prototype.callConversionAction = null;

                        /**
                         * CallFeedItem callConversionTrackingDisabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} callConversionTrackingDisabled
                         * @memberof google.ads.googleads.v1.common.CallFeedItem
                         * @instance
                         */
                        CallFeedItem.prototype.callConversionTrackingDisabled = null;

                        /**
                         * CallFeedItem callConversionReportingState.
                         * @member {google.ads.googleads.v1.enums.CallConversionReportingStateEnum.CallConversionReportingState} callConversionReportingState
                         * @memberof google.ads.googleads.v1.common.CallFeedItem
                         * @instance
                         */
                        CallFeedItem.prototype.callConversionReportingState = 0;

                        /**
                         * Creates a new CallFeedItem instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.CallFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.ICallFeedItem=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.CallFeedItem} CallFeedItem instance
                         */
                        CallFeedItem.create = function create(properties) {
                            return new CallFeedItem(properties);
                        };

                        /**
                         * Encodes the specified CallFeedItem message. Does not implicitly {@link google.ads.googleads.v1.common.CallFeedItem.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.CallFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.ICallFeedItem} message CallFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CallFeedItem.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.phoneNumber != null && message.hasOwnProperty("phoneNumber"))
                                $root.google.protobuf.StringValue.encode(message.phoneNumber, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                $root.google.protobuf.StringValue.encode(message.countryCode, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.callTrackingEnabled != null && message.hasOwnProperty("callTrackingEnabled"))
                                $root.google.protobuf.BoolValue.encode(message.callTrackingEnabled, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.callConversionAction != null && message.hasOwnProperty("callConversionAction"))
                                $root.google.protobuf.StringValue.encode(message.callConversionAction, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.callConversionTrackingDisabled != null && message.hasOwnProperty("callConversionTrackingDisabled"))
                                $root.google.protobuf.BoolValue.encode(message.callConversionTrackingDisabled, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.callConversionReportingState != null && message.hasOwnProperty("callConversionReportingState"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.callConversionReportingState);
                            return writer;
                        };

                        /**
                         * Encodes the specified CallFeedItem message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.CallFeedItem.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.CallFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.ICallFeedItem} message CallFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CallFeedItem.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CallFeedItem message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.CallFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.CallFeedItem} CallFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CallFeedItem.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.CallFeedItem();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.phoneNumber = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.countryCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.callTrackingEnabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.callConversionAction = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.callConversionTrackingDisabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.callConversionReportingState = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CallFeedItem message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.CallFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.CallFeedItem} CallFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CallFeedItem.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CallFeedItem message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.CallFeedItem
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CallFeedItem.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.phoneNumber != null && message.hasOwnProperty("phoneNumber")) {
                                var error = $root.google.protobuf.StringValue.verify(message.phoneNumber);
                                if (error)
                                    return "phoneNumber." + error;
                            }
                            if (message.countryCode != null && message.hasOwnProperty("countryCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.countryCode);
                                if (error)
                                    return "countryCode." + error;
                            }
                            if (message.callTrackingEnabled != null && message.hasOwnProperty("callTrackingEnabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.callTrackingEnabled);
                                if (error)
                                    return "callTrackingEnabled." + error;
                            }
                            if (message.callConversionAction != null && message.hasOwnProperty("callConversionAction")) {
                                var error = $root.google.protobuf.StringValue.verify(message.callConversionAction);
                                if (error)
                                    return "callConversionAction." + error;
                            }
                            if (message.callConversionTrackingDisabled != null && message.hasOwnProperty("callConversionTrackingDisabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.callConversionTrackingDisabled);
                                if (error)
                                    return "callConversionTrackingDisabled." + error;
                            }
                            if (message.callConversionReportingState != null && message.hasOwnProperty("callConversionReportingState"))
                                switch (message.callConversionReportingState) {
                                default:
                                    return "callConversionReportingState: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a CallFeedItem message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.CallFeedItem
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.CallFeedItem} CallFeedItem
                         */
                        CallFeedItem.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.CallFeedItem)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.CallFeedItem();
                            if (object.phoneNumber != null) {
                                if (typeof object.phoneNumber !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CallFeedItem.phoneNumber: object expected");
                                message.phoneNumber = $root.google.protobuf.StringValue.fromObject(object.phoneNumber);
                            }
                            if (object.countryCode != null) {
                                if (typeof object.countryCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CallFeedItem.countryCode: object expected");
                                message.countryCode = $root.google.protobuf.StringValue.fromObject(object.countryCode);
                            }
                            if (object.callTrackingEnabled != null) {
                                if (typeof object.callTrackingEnabled !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CallFeedItem.callTrackingEnabled: object expected");
                                message.callTrackingEnabled = $root.google.protobuf.BoolValue.fromObject(object.callTrackingEnabled);
                            }
                            if (object.callConversionAction != null) {
                                if (typeof object.callConversionAction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CallFeedItem.callConversionAction: object expected");
                                message.callConversionAction = $root.google.protobuf.StringValue.fromObject(object.callConversionAction);
                            }
                            if (object.callConversionTrackingDisabled != null) {
                                if (typeof object.callConversionTrackingDisabled !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CallFeedItem.callConversionTrackingDisabled: object expected");
                                message.callConversionTrackingDisabled = $root.google.protobuf.BoolValue.fromObject(object.callConversionTrackingDisabled);
                            }
                            switch (object.callConversionReportingState) {
                            case "UNSPECIFIED":
                            case 0:
                                message.callConversionReportingState = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.callConversionReportingState = 1;
                                break;
                            case "DISABLED":
                            case 2:
                                message.callConversionReportingState = 2;
                                break;
                            case "USE_ACCOUNT_LEVEL_CALL_CONVERSION_ACTION":
                            case 3:
                                message.callConversionReportingState = 3;
                                break;
                            case "USE_RESOURCE_LEVEL_CALL_CONVERSION_ACTION":
                            case 4:
                                message.callConversionReportingState = 4;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CallFeedItem message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.CallFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.CallFeedItem} message CallFeedItem
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CallFeedItem.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.phoneNumber = null;
                                object.countryCode = null;
                                object.callTrackingEnabled = null;
                                object.callConversionAction = null;
                                object.callConversionTrackingDisabled = null;
                                object.callConversionReportingState = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.phoneNumber != null && message.hasOwnProperty("phoneNumber"))
                                object.phoneNumber = $root.google.protobuf.StringValue.toObject(message.phoneNumber, options);
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                object.countryCode = $root.google.protobuf.StringValue.toObject(message.countryCode, options);
                            if (message.callTrackingEnabled != null && message.hasOwnProperty("callTrackingEnabled"))
                                object.callTrackingEnabled = $root.google.protobuf.BoolValue.toObject(message.callTrackingEnabled, options);
                            if (message.callConversionAction != null && message.hasOwnProperty("callConversionAction"))
                                object.callConversionAction = $root.google.protobuf.StringValue.toObject(message.callConversionAction, options);
                            if (message.callConversionTrackingDisabled != null && message.hasOwnProperty("callConversionTrackingDisabled"))
                                object.callConversionTrackingDisabled = $root.google.protobuf.BoolValue.toObject(message.callConversionTrackingDisabled, options);
                            if (message.callConversionReportingState != null && message.hasOwnProperty("callConversionReportingState"))
                                object.callConversionReportingState = options.enums === String ? $root.google.ads.googleads.v1.enums.CallConversionReportingStateEnum.CallConversionReportingState[message.callConversionReportingState] : message.callConversionReportingState;
                            return object;
                        };

                        /**
                         * Converts this CallFeedItem to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.CallFeedItem
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CallFeedItem.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CallFeedItem;
                    })();

                    common.CalloutFeedItem = (function() {

                        /**
                         * Properties of a CalloutFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ICalloutFeedItem
                         * @property {google.protobuf.IStringValue|null} [calloutText] CalloutFeedItem calloutText
                         */

                        /**
                         * Constructs a new CalloutFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a CalloutFeedItem.
                         * @implements ICalloutFeedItem
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ICalloutFeedItem=} [properties] Properties to set
                         */
                        function CalloutFeedItem(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CalloutFeedItem calloutText.
                         * @member {google.protobuf.IStringValue|null|undefined} calloutText
                         * @memberof google.ads.googleads.v1.common.CalloutFeedItem
                         * @instance
                         */
                        CalloutFeedItem.prototype.calloutText = null;

                        /**
                         * Creates a new CalloutFeedItem instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.CalloutFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.ICalloutFeedItem=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.CalloutFeedItem} CalloutFeedItem instance
                         */
                        CalloutFeedItem.create = function create(properties) {
                            return new CalloutFeedItem(properties);
                        };

                        /**
                         * Encodes the specified CalloutFeedItem message. Does not implicitly {@link google.ads.googleads.v1.common.CalloutFeedItem.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.CalloutFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.ICalloutFeedItem} message CalloutFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CalloutFeedItem.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.calloutText != null && message.hasOwnProperty("calloutText"))
                                $root.google.protobuf.StringValue.encode(message.calloutText, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CalloutFeedItem message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.CalloutFeedItem.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.CalloutFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.ICalloutFeedItem} message CalloutFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CalloutFeedItem.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CalloutFeedItem message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.CalloutFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.CalloutFeedItem} CalloutFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CalloutFeedItem.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.CalloutFeedItem();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.calloutText = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CalloutFeedItem message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.CalloutFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.CalloutFeedItem} CalloutFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CalloutFeedItem.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CalloutFeedItem message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.CalloutFeedItem
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CalloutFeedItem.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.calloutText != null && message.hasOwnProperty("calloutText")) {
                                var error = $root.google.protobuf.StringValue.verify(message.calloutText);
                                if (error)
                                    return "calloutText." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CalloutFeedItem message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.CalloutFeedItem
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.CalloutFeedItem} CalloutFeedItem
                         */
                        CalloutFeedItem.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.CalloutFeedItem)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.CalloutFeedItem();
                            if (object.calloutText != null) {
                                if (typeof object.calloutText !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CalloutFeedItem.calloutText: object expected");
                                message.calloutText = $root.google.protobuf.StringValue.fromObject(object.calloutText);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CalloutFeedItem message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.CalloutFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.CalloutFeedItem} message CalloutFeedItem
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CalloutFeedItem.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.calloutText = null;
                            if (message.calloutText != null && message.hasOwnProperty("calloutText"))
                                object.calloutText = $root.google.protobuf.StringValue.toObject(message.calloutText, options);
                            return object;
                        };

                        /**
                         * Converts this CalloutFeedItem to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.CalloutFeedItem
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CalloutFeedItem.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CalloutFeedItem;
                    })();

                    common.LocationFeedItem = (function() {

                        /**
                         * Properties of a LocationFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ILocationFeedItem
                         * @property {google.protobuf.IStringValue|null} [businessName] LocationFeedItem businessName
                         * @property {google.protobuf.IStringValue|null} [addressLine_1] LocationFeedItem addressLine_1
                         * @property {google.protobuf.IStringValue|null} [addressLine_2] LocationFeedItem addressLine_2
                         * @property {google.protobuf.IStringValue|null} [city] LocationFeedItem city
                         * @property {google.protobuf.IStringValue|null} [province] LocationFeedItem province
                         * @property {google.protobuf.IStringValue|null} [postalCode] LocationFeedItem postalCode
                         * @property {google.protobuf.IStringValue|null} [countryCode] LocationFeedItem countryCode
                         * @property {google.protobuf.IStringValue|null} [phoneNumber] LocationFeedItem phoneNumber
                         */

                        /**
                         * Constructs a new LocationFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a LocationFeedItem.
                         * @implements ILocationFeedItem
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ILocationFeedItem=} [properties] Properties to set
                         */
                        function LocationFeedItem(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * LocationFeedItem businessName.
                         * @member {google.protobuf.IStringValue|null|undefined} businessName
                         * @memberof google.ads.googleads.v1.common.LocationFeedItem
                         * @instance
                         */
                        LocationFeedItem.prototype.businessName = null;

                        /**
                         * LocationFeedItem addressLine_1.
                         * @member {google.protobuf.IStringValue|null|undefined} addressLine_1
                         * @memberof google.ads.googleads.v1.common.LocationFeedItem
                         * @instance
                         */
                        LocationFeedItem.prototype.addressLine_1 = null;

                        /**
                         * LocationFeedItem addressLine_2.
                         * @member {google.protobuf.IStringValue|null|undefined} addressLine_2
                         * @memberof google.ads.googleads.v1.common.LocationFeedItem
                         * @instance
                         */
                        LocationFeedItem.prototype.addressLine_2 = null;

                        /**
                         * LocationFeedItem city.
                         * @member {google.protobuf.IStringValue|null|undefined} city
                         * @memberof google.ads.googleads.v1.common.LocationFeedItem
                         * @instance
                         */
                        LocationFeedItem.prototype.city = null;

                        /**
                         * LocationFeedItem province.
                         * @member {google.protobuf.IStringValue|null|undefined} province
                         * @memberof google.ads.googleads.v1.common.LocationFeedItem
                         * @instance
                         */
                        LocationFeedItem.prototype.province = null;

                        /**
                         * LocationFeedItem postalCode.
                         * @member {google.protobuf.IStringValue|null|undefined} postalCode
                         * @memberof google.ads.googleads.v1.common.LocationFeedItem
                         * @instance
                         */
                        LocationFeedItem.prototype.postalCode = null;

                        /**
                         * LocationFeedItem countryCode.
                         * @member {google.protobuf.IStringValue|null|undefined} countryCode
                         * @memberof google.ads.googleads.v1.common.LocationFeedItem
                         * @instance
                         */
                        LocationFeedItem.prototype.countryCode = null;

                        /**
                         * LocationFeedItem phoneNumber.
                         * @member {google.protobuf.IStringValue|null|undefined} phoneNumber
                         * @memberof google.ads.googleads.v1.common.LocationFeedItem
                         * @instance
                         */
                        LocationFeedItem.prototype.phoneNumber = null;

                        /**
                         * Creates a new LocationFeedItem instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.LocationFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.ILocationFeedItem=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.LocationFeedItem} LocationFeedItem instance
                         */
                        LocationFeedItem.create = function create(properties) {
                            return new LocationFeedItem(properties);
                        };

                        /**
                         * Encodes the specified LocationFeedItem message. Does not implicitly {@link google.ads.googleads.v1.common.LocationFeedItem.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.LocationFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.ILocationFeedItem} message LocationFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationFeedItem.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.businessName != null && message.hasOwnProperty("businessName"))
                                $root.google.protobuf.StringValue.encode(message.businessName, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.addressLine_1 != null && message.hasOwnProperty("addressLine_1"))
                                $root.google.protobuf.StringValue.encode(message.addressLine_1, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.addressLine_2 != null && message.hasOwnProperty("addressLine_2"))
                                $root.google.protobuf.StringValue.encode(message.addressLine_2, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.city != null && message.hasOwnProperty("city"))
                                $root.google.protobuf.StringValue.encode(message.city, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.province != null && message.hasOwnProperty("province"))
                                $root.google.protobuf.StringValue.encode(message.province, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.postalCode != null && message.hasOwnProperty("postalCode"))
                                $root.google.protobuf.StringValue.encode(message.postalCode, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                $root.google.protobuf.StringValue.encode(message.countryCode, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.phoneNumber != null && message.hasOwnProperty("phoneNumber"))
                                $root.google.protobuf.StringValue.encode(message.phoneNumber, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified LocationFeedItem message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.LocationFeedItem.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.LocationFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.ILocationFeedItem} message LocationFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationFeedItem.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LocationFeedItem message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.LocationFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.LocationFeedItem} LocationFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationFeedItem.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.LocationFeedItem();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.businessName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.addressLine_1 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.addressLine_2 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.city = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.province = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.postalCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.countryCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.phoneNumber = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LocationFeedItem message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.LocationFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.LocationFeedItem} LocationFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationFeedItem.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LocationFeedItem message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.LocationFeedItem
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LocationFeedItem.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.businessName != null && message.hasOwnProperty("businessName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.businessName);
                                if (error)
                                    return "businessName." + error;
                            }
                            if (message.addressLine_1 != null && message.hasOwnProperty("addressLine_1")) {
                                var error = $root.google.protobuf.StringValue.verify(message.addressLine_1);
                                if (error)
                                    return "addressLine_1." + error;
                            }
                            if (message.addressLine_2 != null && message.hasOwnProperty("addressLine_2")) {
                                var error = $root.google.protobuf.StringValue.verify(message.addressLine_2);
                                if (error)
                                    return "addressLine_2." + error;
                            }
                            if (message.city != null && message.hasOwnProperty("city")) {
                                var error = $root.google.protobuf.StringValue.verify(message.city);
                                if (error)
                                    return "city." + error;
                            }
                            if (message.province != null && message.hasOwnProperty("province")) {
                                var error = $root.google.protobuf.StringValue.verify(message.province);
                                if (error)
                                    return "province." + error;
                            }
                            if (message.postalCode != null && message.hasOwnProperty("postalCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.postalCode);
                                if (error)
                                    return "postalCode." + error;
                            }
                            if (message.countryCode != null && message.hasOwnProperty("countryCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.countryCode);
                                if (error)
                                    return "countryCode." + error;
                            }
                            if (message.phoneNumber != null && message.hasOwnProperty("phoneNumber")) {
                                var error = $root.google.protobuf.StringValue.verify(message.phoneNumber);
                                if (error)
                                    return "phoneNumber." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a LocationFeedItem message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.LocationFeedItem
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.LocationFeedItem} LocationFeedItem
                         */
                        LocationFeedItem.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.LocationFeedItem)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.LocationFeedItem();
                            if (object.businessName != null) {
                                if (typeof object.businessName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LocationFeedItem.businessName: object expected");
                                message.businessName = $root.google.protobuf.StringValue.fromObject(object.businessName);
                            }
                            if (object.addressLine_1 != null) {
                                if (typeof object.addressLine_1 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LocationFeedItem.addressLine_1: object expected");
                                message.addressLine_1 = $root.google.protobuf.StringValue.fromObject(object.addressLine_1);
                            }
                            if (object.addressLine_2 != null) {
                                if (typeof object.addressLine_2 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LocationFeedItem.addressLine_2: object expected");
                                message.addressLine_2 = $root.google.protobuf.StringValue.fromObject(object.addressLine_2);
                            }
                            if (object.city != null) {
                                if (typeof object.city !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LocationFeedItem.city: object expected");
                                message.city = $root.google.protobuf.StringValue.fromObject(object.city);
                            }
                            if (object.province != null) {
                                if (typeof object.province !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LocationFeedItem.province: object expected");
                                message.province = $root.google.protobuf.StringValue.fromObject(object.province);
                            }
                            if (object.postalCode != null) {
                                if (typeof object.postalCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LocationFeedItem.postalCode: object expected");
                                message.postalCode = $root.google.protobuf.StringValue.fromObject(object.postalCode);
                            }
                            if (object.countryCode != null) {
                                if (typeof object.countryCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LocationFeedItem.countryCode: object expected");
                                message.countryCode = $root.google.protobuf.StringValue.fromObject(object.countryCode);
                            }
                            if (object.phoneNumber != null) {
                                if (typeof object.phoneNumber !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LocationFeedItem.phoneNumber: object expected");
                                message.phoneNumber = $root.google.protobuf.StringValue.fromObject(object.phoneNumber);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a LocationFeedItem message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.LocationFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.LocationFeedItem} message LocationFeedItem
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LocationFeedItem.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.businessName = null;
                                object.addressLine_1 = null;
                                object.addressLine_2 = null;
                                object.city = null;
                                object.province = null;
                                object.postalCode = null;
                                object.countryCode = null;
                                object.phoneNumber = null;
                            }
                            if (message.businessName != null && message.hasOwnProperty("businessName"))
                                object.businessName = $root.google.protobuf.StringValue.toObject(message.businessName, options);
                            if (message.addressLine_1 != null && message.hasOwnProperty("addressLine_1"))
                                object.addressLine_1 = $root.google.protobuf.StringValue.toObject(message.addressLine_1, options);
                            if (message.addressLine_2 != null && message.hasOwnProperty("addressLine_2"))
                                object.addressLine_2 = $root.google.protobuf.StringValue.toObject(message.addressLine_2, options);
                            if (message.city != null && message.hasOwnProperty("city"))
                                object.city = $root.google.protobuf.StringValue.toObject(message.city, options);
                            if (message.province != null && message.hasOwnProperty("province"))
                                object.province = $root.google.protobuf.StringValue.toObject(message.province, options);
                            if (message.postalCode != null && message.hasOwnProperty("postalCode"))
                                object.postalCode = $root.google.protobuf.StringValue.toObject(message.postalCode, options);
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                object.countryCode = $root.google.protobuf.StringValue.toObject(message.countryCode, options);
                            if (message.phoneNumber != null && message.hasOwnProperty("phoneNumber"))
                                object.phoneNumber = $root.google.protobuf.StringValue.toObject(message.phoneNumber, options);
                            return object;
                        };

                        /**
                         * Converts this LocationFeedItem to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.LocationFeedItem
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LocationFeedItem.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return LocationFeedItem;
                    })();

                    common.AffiliateLocationFeedItem = (function() {

                        /**
                         * Properties of an AffiliateLocationFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IAffiliateLocationFeedItem
                         * @property {google.protobuf.IStringValue|null} [businessName] AffiliateLocationFeedItem businessName
                         * @property {google.protobuf.IStringValue|null} [addressLine_1] AffiliateLocationFeedItem addressLine_1
                         * @property {google.protobuf.IStringValue|null} [addressLine_2] AffiliateLocationFeedItem addressLine_2
                         * @property {google.protobuf.IStringValue|null} [city] AffiliateLocationFeedItem city
                         * @property {google.protobuf.IStringValue|null} [province] AffiliateLocationFeedItem province
                         * @property {google.protobuf.IStringValue|null} [postalCode] AffiliateLocationFeedItem postalCode
                         * @property {google.protobuf.IStringValue|null} [countryCode] AffiliateLocationFeedItem countryCode
                         * @property {google.protobuf.IStringValue|null} [phoneNumber] AffiliateLocationFeedItem phoneNumber
                         * @property {google.protobuf.IInt64Value|null} [chainId] AffiliateLocationFeedItem chainId
                         * @property {google.protobuf.IStringValue|null} [chainName] AffiliateLocationFeedItem chainName
                         */

                        /**
                         * Constructs a new AffiliateLocationFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an AffiliateLocationFeedItem.
                         * @implements IAffiliateLocationFeedItem
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IAffiliateLocationFeedItem=} [properties] Properties to set
                         */
                        function AffiliateLocationFeedItem(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AffiliateLocationFeedItem businessName.
                         * @member {google.protobuf.IStringValue|null|undefined} businessName
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @instance
                         */
                        AffiliateLocationFeedItem.prototype.businessName = null;

                        /**
                         * AffiliateLocationFeedItem addressLine_1.
                         * @member {google.protobuf.IStringValue|null|undefined} addressLine_1
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @instance
                         */
                        AffiliateLocationFeedItem.prototype.addressLine_1 = null;

                        /**
                         * AffiliateLocationFeedItem addressLine_2.
                         * @member {google.protobuf.IStringValue|null|undefined} addressLine_2
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @instance
                         */
                        AffiliateLocationFeedItem.prototype.addressLine_2 = null;

                        /**
                         * AffiliateLocationFeedItem city.
                         * @member {google.protobuf.IStringValue|null|undefined} city
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @instance
                         */
                        AffiliateLocationFeedItem.prototype.city = null;

                        /**
                         * AffiliateLocationFeedItem province.
                         * @member {google.protobuf.IStringValue|null|undefined} province
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @instance
                         */
                        AffiliateLocationFeedItem.prototype.province = null;

                        /**
                         * AffiliateLocationFeedItem postalCode.
                         * @member {google.protobuf.IStringValue|null|undefined} postalCode
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @instance
                         */
                        AffiliateLocationFeedItem.prototype.postalCode = null;

                        /**
                         * AffiliateLocationFeedItem countryCode.
                         * @member {google.protobuf.IStringValue|null|undefined} countryCode
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @instance
                         */
                        AffiliateLocationFeedItem.prototype.countryCode = null;

                        /**
                         * AffiliateLocationFeedItem phoneNumber.
                         * @member {google.protobuf.IStringValue|null|undefined} phoneNumber
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @instance
                         */
                        AffiliateLocationFeedItem.prototype.phoneNumber = null;

                        /**
                         * AffiliateLocationFeedItem chainId.
                         * @member {google.protobuf.IInt64Value|null|undefined} chainId
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @instance
                         */
                        AffiliateLocationFeedItem.prototype.chainId = null;

                        /**
                         * AffiliateLocationFeedItem chainName.
                         * @member {google.protobuf.IStringValue|null|undefined} chainName
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @instance
                         */
                        AffiliateLocationFeedItem.prototype.chainName = null;

                        /**
                         * Creates a new AffiliateLocationFeedItem instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.IAffiliateLocationFeedItem=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.AffiliateLocationFeedItem} AffiliateLocationFeedItem instance
                         */
                        AffiliateLocationFeedItem.create = function create(properties) {
                            return new AffiliateLocationFeedItem(properties);
                        };

                        /**
                         * Encodes the specified AffiliateLocationFeedItem message. Does not implicitly {@link google.ads.googleads.v1.common.AffiliateLocationFeedItem.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.IAffiliateLocationFeedItem} message AffiliateLocationFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AffiliateLocationFeedItem.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.businessName != null && message.hasOwnProperty("businessName"))
                                $root.google.protobuf.StringValue.encode(message.businessName, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.addressLine_1 != null && message.hasOwnProperty("addressLine_1"))
                                $root.google.protobuf.StringValue.encode(message.addressLine_1, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.addressLine_2 != null && message.hasOwnProperty("addressLine_2"))
                                $root.google.protobuf.StringValue.encode(message.addressLine_2, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.city != null && message.hasOwnProperty("city"))
                                $root.google.protobuf.StringValue.encode(message.city, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.province != null && message.hasOwnProperty("province"))
                                $root.google.protobuf.StringValue.encode(message.province, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.postalCode != null && message.hasOwnProperty("postalCode"))
                                $root.google.protobuf.StringValue.encode(message.postalCode, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                $root.google.protobuf.StringValue.encode(message.countryCode, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.phoneNumber != null && message.hasOwnProperty("phoneNumber"))
                                $root.google.protobuf.StringValue.encode(message.phoneNumber, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.chainId != null && message.hasOwnProperty("chainId"))
                                $root.google.protobuf.Int64Value.encode(message.chainId, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.chainName != null && message.hasOwnProperty("chainName"))
                                $root.google.protobuf.StringValue.encode(message.chainName, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AffiliateLocationFeedItem message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.AffiliateLocationFeedItem.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.IAffiliateLocationFeedItem} message AffiliateLocationFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AffiliateLocationFeedItem.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AffiliateLocationFeedItem message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.AffiliateLocationFeedItem} AffiliateLocationFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AffiliateLocationFeedItem.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.AffiliateLocationFeedItem();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.businessName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.addressLine_1 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.addressLine_2 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.city = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.province = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.postalCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.countryCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.phoneNumber = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.chainId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.chainName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AffiliateLocationFeedItem message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.AffiliateLocationFeedItem} AffiliateLocationFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AffiliateLocationFeedItem.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AffiliateLocationFeedItem message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AffiliateLocationFeedItem.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.businessName != null && message.hasOwnProperty("businessName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.businessName);
                                if (error)
                                    return "businessName." + error;
                            }
                            if (message.addressLine_1 != null && message.hasOwnProperty("addressLine_1")) {
                                var error = $root.google.protobuf.StringValue.verify(message.addressLine_1);
                                if (error)
                                    return "addressLine_1." + error;
                            }
                            if (message.addressLine_2 != null && message.hasOwnProperty("addressLine_2")) {
                                var error = $root.google.protobuf.StringValue.verify(message.addressLine_2);
                                if (error)
                                    return "addressLine_2." + error;
                            }
                            if (message.city != null && message.hasOwnProperty("city")) {
                                var error = $root.google.protobuf.StringValue.verify(message.city);
                                if (error)
                                    return "city." + error;
                            }
                            if (message.province != null && message.hasOwnProperty("province")) {
                                var error = $root.google.protobuf.StringValue.verify(message.province);
                                if (error)
                                    return "province." + error;
                            }
                            if (message.postalCode != null && message.hasOwnProperty("postalCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.postalCode);
                                if (error)
                                    return "postalCode." + error;
                            }
                            if (message.countryCode != null && message.hasOwnProperty("countryCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.countryCode);
                                if (error)
                                    return "countryCode." + error;
                            }
                            if (message.phoneNumber != null && message.hasOwnProperty("phoneNumber")) {
                                var error = $root.google.protobuf.StringValue.verify(message.phoneNumber);
                                if (error)
                                    return "phoneNumber." + error;
                            }
                            if (message.chainId != null && message.hasOwnProperty("chainId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.chainId);
                                if (error)
                                    return "chainId." + error;
                            }
                            if (message.chainName != null && message.hasOwnProperty("chainName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.chainName);
                                if (error)
                                    return "chainName." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an AffiliateLocationFeedItem message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.AffiliateLocationFeedItem} AffiliateLocationFeedItem
                         */
                        AffiliateLocationFeedItem.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.AffiliateLocationFeedItem)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.AffiliateLocationFeedItem();
                            if (object.businessName != null) {
                                if (typeof object.businessName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AffiliateLocationFeedItem.businessName: object expected");
                                message.businessName = $root.google.protobuf.StringValue.fromObject(object.businessName);
                            }
                            if (object.addressLine_1 != null) {
                                if (typeof object.addressLine_1 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AffiliateLocationFeedItem.addressLine_1: object expected");
                                message.addressLine_1 = $root.google.protobuf.StringValue.fromObject(object.addressLine_1);
                            }
                            if (object.addressLine_2 != null) {
                                if (typeof object.addressLine_2 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AffiliateLocationFeedItem.addressLine_2: object expected");
                                message.addressLine_2 = $root.google.protobuf.StringValue.fromObject(object.addressLine_2);
                            }
                            if (object.city != null) {
                                if (typeof object.city !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AffiliateLocationFeedItem.city: object expected");
                                message.city = $root.google.protobuf.StringValue.fromObject(object.city);
                            }
                            if (object.province != null) {
                                if (typeof object.province !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AffiliateLocationFeedItem.province: object expected");
                                message.province = $root.google.protobuf.StringValue.fromObject(object.province);
                            }
                            if (object.postalCode != null) {
                                if (typeof object.postalCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AffiliateLocationFeedItem.postalCode: object expected");
                                message.postalCode = $root.google.protobuf.StringValue.fromObject(object.postalCode);
                            }
                            if (object.countryCode != null) {
                                if (typeof object.countryCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AffiliateLocationFeedItem.countryCode: object expected");
                                message.countryCode = $root.google.protobuf.StringValue.fromObject(object.countryCode);
                            }
                            if (object.phoneNumber != null) {
                                if (typeof object.phoneNumber !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AffiliateLocationFeedItem.phoneNumber: object expected");
                                message.phoneNumber = $root.google.protobuf.StringValue.fromObject(object.phoneNumber);
                            }
                            if (object.chainId != null) {
                                if (typeof object.chainId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AffiliateLocationFeedItem.chainId: object expected");
                                message.chainId = $root.google.protobuf.Int64Value.fromObject(object.chainId);
                            }
                            if (object.chainName != null) {
                                if (typeof object.chainName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.AffiliateLocationFeedItem.chainName: object expected");
                                message.chainName = $root.google.protobuf.StringValue.fromObject(object.chainName);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AffiliateLocationFeedItem message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.AffiliateLocationFeedItem} message AffiliateLocationFeedItem
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AffiliateLocationFeedItem.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.businessName = null;
                                object.addressLine_1 = null;
                                object.addressLine_2 = null;
                                object.city = null;
                                object.province = null;
                                object.postalCode = null;
                                object.countryCode = null;
                                object.phoneNumber = null;
                                object.chainId = null;
                                object.chainName = null;
                            }
                            if (message.businessName != null && message.hasOwnProperty("businessName"))
                                object.businessName = $root.google.protobuf.StringValue.toObject(message.businessName, options);
                            if (message.addressLine_1 != null && message.hasOwnProperty("addressLine_1"))
                                object.addressLine_1 = $root.google.protobuf.StringValue.toObject(message.addressLine_1, options);
                            if (message.addressLine_2 != null && message.hasOwnProperty("addressLine_2"))
                                object.addressLine_2 = $root.google.protobuf.StringValue.toObject(message.addressLine_2, options);
                            if (message.city != null && message.hasOwnProperty("city"))
                                object.city = $root.google.protobuf.StringValue.toObject(message.city, options);
                            if (message.province != null && message.hasOwnProperty("province"))
                                object.province = $root.google.protobuf.StringValue.toObject(message.province, options);
                            if (message.postalCode != null && message.hasOwnProperty("postalCode"))
                                object.postalCode = $root.google.protobuf.StringValue.toObject(message.postalCode, options);
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                object.countryCode = $root.google.protobuf.StringValue.toObject(message.countryCode, options);
                            if (message.phoneNumber != null && message.hasOwnProperty("phoneNumber"))
                                object.phoneNumber = $root.google.protobuf.StringValue.toObject(message.phoneNumber, options);
                            if (message.chainId != null && message.hasOwnProperty("chainId"))
                                object.chainId = $root.google.protobuf.Int64Value.toObject(message.chainId, options);
                            if (message.chainName != null && message.hasOwnProperty("chainName"))
                                object.chainName = $root.google.protobuf.StringValue.toObject(message.chainName, options);
                            return object;
                        };

                        /**
                         * Converts this AffiliateLocationFeedItem to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.AffiliateLocationFeedItem
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AffiliateLocationFeedItem.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AffiliateLocationFeedItem;
                    })();

                    common.TextMessageFeedItem = (function() {

                        /**
                         * Properties of a TextMessageFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ITextMessageFeedItem
                         * @property {google.protobuf.IStringValue|null} [businessName] TextMessageFeedItem businessName
                         * @property {google.protobuf.IStringValue|null} [countryCode] TextMessageFeedItem countryCode
                         * @property {google.protobuf.IStringValue|null} [phoneNumber] TextMessageFeedItem phoneNumber
                         * @property {google.protobuf.IStringValue|null} [text] TextMessageFeedItem text
                         * @property {google.protobuf.IStringValue|null} [extensionText] TextMessageFeedItem extensionText
                         */

                        /**
                         * Constructs a new TextMessageFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a TextMessageFeedItem.
                         * @implements ITextMessageFeedItem
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ITextMessageFeedItem=} [properties] Properties to set
                         */
                        function TextMessageFeedItem(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * TextMessageFeedItem businessName.
                         * @member {google.protobuf.IStringValue|null|undefined} businessName
                         * @memberof google.ads.googleads.v1.common.TextMessageFeedItem
                         * @instance
                         */
                        TextMessageFeedItem.prototype.businessName = null;

                        /**
                         * TextMessageFeedItem countryCode.
                         * @member {google.protobuf.IStringValue|null|undefined} countryCode
                         * @memberof google.ads.googleads.v1.common.TextMessageFeedItem
                         * @instance
                         */
                        TextMessageFeedItem.prototype.countryCode = null;

                        /**
                         * TextMessageFeedItem phoneNumber.
                         * @member {google.protobuf.IStringValue|null|undefined} phoneNumber
                         * @memberof google.ads.googleads.v1.common.TextMessageFeedItem
                         * @instance
                         */
                        TextMessageFeedItem.prototype.phoneNumber = null;

                        /**
                         * TextMessageFeedItem text.
                         * @member {google.protobuf.IStringValue|null|undefined} text
                         * @memberof google.ads.googleads.v1.common.TextMessageFeedItem
                         * @instance
                         */
                        TextMessageFeedItem.prototype.text = null;

                        /**
                         * TextMessageFeedItem extensionText.
                         * @member {google.protobuf.IStringValue|null|undefined} extensionText
                         * @memberof google.ads.googleads.v1.common.TextMessageFeedItem
                         * @instance
                         */
                        TextMessageFeedItem.prototype.extensionText = null;

                        /**
                         * Creates a new TextMessageFeedItem instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.TextMessageFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.ITextMessageFeedItem=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.TextMessageFeedItem} TextMessageFeedItem instance
                         */
                        TextMessageFeedItem.create = function create(properties) {
                            return new TextMessageFeedItem(properties);
                        };

                        /**
                         * Encodes the specified TextMessageFeedItem message. Does not implicitly {@link google.ads.googleads.v1.common.TextMessageFeedItem.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.TextMessageFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.ITextMessageFeedItem} message TextMessageFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TextMessageFeedItem.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.businessName != null && message.hasOwnProperty("businessName"))
                                $root.google.protobuf.StringValue.encode(message.businessName, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                $root.google.protobuf.StringValue.encode(message.countryCode, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.phoneNumber != null && message.hasOwnProperty("phoneNumber"))
                                $root.google.protobuf.StringValue.encode(message.phoneNumber, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.text != null && message.hasOwnProperty("text"))
                                $root.google.protobuf.StringValue.encode(message.text, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.extensionText != null && message.hasOwnProperty("extensionText"))
                                $root.google.protobuf.StringValue.encode(message.extensionText, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified TextMessageFeedItem message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.TextMessageFeedItem.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.TextMessageFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.ITextMessageFeedItem} message TextMessageFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TextMessageFeedItem.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TextMessageFeedItem message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.TextMessageFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.TextMessageFeedItem} TextMessageFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TextMessageFeedItem.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.TextMessageFeedItem();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.businessName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.countryCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.phoneNumber = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.text = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.extensionText = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TextMessageFeedItem message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.TextMessageFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.TextMessageFeedItem} TextMessageFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TextMessageFeedItem.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TextMessageFeedItem message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.TextMessageFeedItem
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TextMessageFeedItem.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.businessName != null && message.hasOwnProperty("businessName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.businessName);
                                if (error)
                                    return "businessName." + error;
                            }
                            if (message.countryCode != null && message.hasOwnProperty("countryCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.countryCode);
                                if (error)
                                    return "countryCode." + error;
                            }
                            if (message.phoneNumber != null && message.hasOwnProperty("phoneNumber")) {
                                var error = $root.google.protobuf.StringValue.verify(message.phoneNumber);
                                if (error)
                                    return "phoneNumber." + error;
                            }
                            if (message.text != null && message.hasOwnProperty("text")) {
                                var error = $root.google.protobuf.StringValue.verify(message.text);
                                if (error)
                                    return "text." + error;
                            }
                            if (message.extensionText != null && message.hasOwnProperty("extensionText")) {
                                var error = $root.google.protobuf.StringValue.verify(message.extensionText);
                                if (error)
                                    return "extensionText." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a TextMessageFeedItem message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.TextMessageFeedItem
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.TextMessageFeedItem} TextMessageFeedItem
                         */
                        TextMessageFeedItem.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.TextMessageFeedItem)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.TextMessageFeedItem();
                            if (object.businessName != null) {
                                if (typeof object.businessName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TextMessageFeedItem.businessName: object expected");
                                message.businessName = $root.google.protobuf.StringValue.fromObject(object.businessName);
                            }
                            if (object.countryCode != null) {
                                if (typeof object.countryCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TextMessageFeedItem.countryCode: object expected");
                                message.countryCode = $root.google.protobuf.StringValue.fromObject(object.countryCode);
                            }
                            if (object.phoneNumber != null) {
                                if (typeof object.phoneNumber !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TextMessageFeedItem.phoneNumber: object expected");
                                message.phoneNumber = $root.google.protobuf.StringValue.fromObject(object.phoneNumber);
                            }
                            if (object.text != null) {
                                if (typeof object.text !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TextMessageFeedItem.text: object expected");
                                message.text = $root.google.protobuf.StringValue.fromObject(object.text);
                            }
                            if (object.extensionText != null) {
                                if (typeof object.extensionText !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TextMessageFeedItem.extensionText: object expected");
                                message.extensionText = $root.google.protobuf.StringValue.fromObject(object.extensionText);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a TextMessageFeedItem message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.TextMessageFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.TextMessageFeedItem} message TextMessageFeedItem
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TextMessageFeedItem.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.businessName = null;
                                object.countryCode = null;
                                object.phoneNumber = null;
                                object.text = null;
                                object.extensionText = null;
                            }
                            if (message.businessName != null && message.hasOwnProperty("businessName"))
                                object.businessName = $root.google.protobuf.StringValue.toObject(message.businessName, options);
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                object.countryCode = $root.google.protobuf.StringValue.toObject(message.countryCode, options);
                            if (message.phoneNumber != null && message.hasOwnProperty("phoneNumber"))
                                object.phoneNumber = $root.google.protobuf.StringValue.toObject(message.phoneNumber, options);
                            if (message.text != null && message.hasOwnProperty("text"))
                                object.text = $root.google.protobuf.StringValue.toObject(message.text, options);
                            if (message.extensionText != null && message.hasOwnProperty("extensionText"))
                                object.extensionText = $root.google.protobuf.StringValue.toObject(message.extensionText, options);
                            return object;
                        };

                        /**
                         * Converts this TextMessageFeedItem to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.TextMessageFeedItem
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TextMessageFeedItem.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return TextMessageFeedItem;
                    })();

                    common.PriceFeedItem = (function() {

                        /**
                         * Properties of a PriceFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IPriceFeedItem
                         * @property {google.ads.googleads.v1.enums.PriceExtensionTypeEnum.PriceExtensionType|null} [type] PriceFeedItem type
                         * @property {google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum.PriceExtensionPriceQualifier|null} [priceQualifier] PriceFeedItem priceQualifier
                         * @property {google.protobuf.IStringValue|null} [trackingUrlTemplate] PriceFeedItem trackingUrlTemplate
                         * @property {google.protobuf.IStringValue|null} [languageCode] PriceFeedItem languageCode
                         * @property {Array.<google.ads.googleads.v1.common.IPriceOffer>|null} [priceOfferings] PriceFeedItem priceOfferings
                         * @property {google.protobuf.IStringValue|null} [finalUrlSuffix] PriceFeedItem finalUrlSuffix
                         */

                        /**
                         * Constructs a new PriceFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a PriceFeedItem.
                         * @implements IPriceFeedItem
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IPriceFeedItem=} [properties] Properties to set
                         */
                        function PriceFeedItem(properties) {
                            this.priceOfferings = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * PriceFeedItem type.
                         * @member {google.ads.googleads.v1.enums.PriceExtensionTypeEnum.PriceExtensionType} type
                         * @memberof google.ads.googleads.v1.common.PriceFeedItem
                         * @instance
                         */
                        PriceFeedItem.prototype.type = 0;

                        /**
                         * PriceFeedItem priceQualifier.
                         * @member {google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum.PriceExtensionPriceQualifier} priceQualifier
                         * @memberof google.ads.googleads.v1.common.PriceFeedItem
                         * @instance
                         */
                        PriceFeedItem.prototype.priceQualifier = 0;

                        /**
                         * PriceFeedItem trackingUrlTemplate.
                         * @member {google.protobuf.IStringValue|null|undefined} trackingUrlTemplate
                         * @memberof google.ads.googleads.v1.common.PriceFeedItem
                         * @instance
                         */
                        PriceFeedItem.prototype.trackingUrlTemplate = null;

                        /**
                         * PriceFeedItem languageCode.
                         * @member {google.protobuf.IStringValue|null|undefined} languageCode
                         * @memberof google.ads.googleads.v1.common.PriceFeedItem
                         * @instance
                         */
                        PriceFeedItem.prototype.languageCode = null;

                        /**
                         * PriceFeedItem priceOfferings.
                         * @member {Array.<google.ads.googleads.v1.common.IPriceOffer>} priceOfferings
                         * @memberof google.ads.googleads.v1.common.PriceFeedItem
                         * @instance
                         */
                        PriceFeedItem.prototype.priceOfferings = $util.emptyArray;

                        /**
                         * PriceFeedItem finalUrlSuffix.
                         * @member {google.protobuf.IStringValue|null|undefined} finalUrlSuffix
                         * @memberof google.ads.googleads.v1.common.PriceFeedItem
                         * @instance
                         */
                        PriceFeedItem.prototype.finalUrlSuffix = null;

                        /**
                         * Creates a new PriceFeedItem instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.PriceFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.IPriceFeedItem=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.PriceFeedItem} PriceFeedItem instance
                         */
                        PriceFeedItem.create = function create(properties) {
                            return new PriceFeedItem(properties);
                        };

                        /**
                         * Encodes the specified PriceFeedItem message. Does not implicitly {@link google.ads.googleads.v1.common.PriceFeedItem.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.PriceFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.IPriceFeedItem} message PriceFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PriceFeedItem.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.type);
                            if (message.priceQualifier != null && message.hasOwnProperty("priceQualifier"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.priceQualifier);
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                $root.google.protobuf.StringValue.encode(message.trackingUrlTemplate, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.languageCode != null && message.hasOwnProperty("languageCode"))
                                $root.google.protobuf.StringValue.encode(message.languageCode, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.priceOfferings != null && message.priceOfferings.length)
                                for (var i = 0; i < message.priceOfferings.length; ++i)
                                    $root.google.ads.googleads.v1.common.PriceOffer.encode(message.priceOfferings[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix"))
                                $root.google.protobuf.StringValue.encode(message.finalUrlSuffix, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified PriceFeedItem message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PriceFeedItem.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.PriceFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.IPriceFeedItem} message PriceFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PriceFeedItem.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PriceFeedItem message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.PriceFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.PriceFeedItem} PriceFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PriceFeedItem.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PriceFeedItem();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.type = reader.int32();
                                    break;
                                case 2:
                                    message.priceQualifier = reader.int32();
                                    break;
                                case 3:
                                    message.trackingUrlTemplate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.languageCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    if (!(message.priceOfferings && message.priceOfferings.length))
                                        message.priceOfferings = [];
                                    message.priceOfferings.push($root.google.ads.googleads.v1.common.PriceOffer.decode(reader, reader.uint32()));
                                    break;
                                case 6:
                                    message.finalUrlSuffix = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PriceFeedItem message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.PriceFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.PriceFeedItem} PriceFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PriceFeedItem.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PriceFeedItem message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.PriceFeedItem
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PriceFeedItem.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                    break;
                                }
                            if (message.priceQualifier != null && message.hasOwnProperty("priceQualifier"))
                                switch (message.priceQualifier) {
                                default:
                                    return "priceQualifier: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.trackingUrlTemplate);
                                if (error)
                                    return "trackingUrlTemplate." + error;
                            }
                            if (message.languageCode != null && message.hasOwnProperty("languageCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.languageCode);
                                if (error)
                                    return "languageCode." + error;
                            }
                            if (message.priceOfferings != null && message.hasOwnProperty("priceOfferings")) {
                                if (!Array.isArray(message.priceOfferings))
                                    return "priceOfferings: array expected";
                                for (var i = 0; i < message.priceOfferings.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.PriceOffer.verify(message.priceOfferings[i]);
                                    if (error)
                                        return "priceOfferings." + error;
                                }
                            }
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix")) {
                                var error = $root.google.protobuf.StringValue.verify(message.finalUrlSuffix);
                                if (error)
                                    return "finalUrlSuffix." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a PriceFeedItem message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.PriceFeedItem
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.PriceFeedItem} PriceFeedItem
                         */
                        PriceFeedItem.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.PriceFeedItem)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.PriceFeedItem();
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "BRANDS":
                            case 2:
                                message.type = 2;
                                break;
                            case "EVENTS":
                            case 3:
                                message.type = 3;
                                break;
                            case "LOCATIONS":
                            case 4:
                                message.type = 4;
                                break;
                            case "NEIGHBORHOODS":
                            case 5:
                                message.type = 5;
                                break;
                            case "PRODUCT_CATEGORIES":
                            case 6:
                                message.type = 6;
                                break;
                            case "PRODUCT_TIERS":
                            case 7:
                                message.type = 7;
                                break;
                            case "SERVICES":
                            case 8:
                                message.type = 8;
                                break;
                            case "SERVICE_CATEGORIES":
                            case 9:
                                message.type = 9;
                                break;
                            case "SERVICE_TIERS":
                            case 10:
                                message.type = 10;
                                break;
                            }
                            switch (object.priceQualifier) {
                            case "UNSPECIFIED":
                            case 0:
                                message.priceQualifier = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.priceQualifier = 1;
                                break;
                            case "FROM":
                            case 2:
                                message.priceQualifier = 2;
                                break;
                            case "UP_TO":
                            case 3:
                                message.priceQualifier = 3;
                                break;
                            case "AVERAGE":
                            case 4:
                                message.priceQualifier = 4;
                                break;
                            }
                            if (object.trackingUrlTemplate != null) {
                                if (typeof object.trackingUrlTemplate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PriceFeedItem.trackingUrlTemplate: object expected");
                                message.trackingUrlTemplate = $root.google.protobuf.StringValue.fromObject(object.trackingUrlTemplate);
                            }
                            if (object.languageCode != null) {
                                if (typeof object.languageCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PriceFeedItem.languageCode: object expected");
                                message.languageCode = $root.google.protobuf.StringValue.fromObject(object.languageCode);
                            }
                            if (object.priceOfferings) {
                                if (!Array.isArray(object.priceOfferings))
                                    throw TypeError(".google.ads.googleads.v1.common.PriceFeedItem.priceOfferings: array expected");
                                message.priceOfferings = [];
                                for (var i = 0; i < object.priceOfferings.length; ++i) {
                                    if (typeof object.priceOfferings[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.PriceFeedItem.priceOfferings: object expected");
                                    message.priceOfferings[i] = $root.google.ads.googleads.v1.common.PriceOffer.fromObject(object.priceOfferings[i]);
                                }
                            }
                            if (object.finalUrlSuffix != null) {
                                if (typeof object.finalUrlSuffix !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PriceFeedItem.finalUrlSuffix: object expected");
                                message.finalUrlSuffix = $root.google.protobuf.StringValue.fromObject(object.finalUrlSuffix);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a PriceFeedItem message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.PriceFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.PriceFeedItem} message PriceFeedItem
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PriceFeedItem.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.priceOfferings = [];
                            if (options.defaults) {
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.priceQualifier = options.enums === String ? "UNSPECIFIED" : 0;
                                object.trackingUrlTemplate = null;
                                object.languageCode = null;
                                object.finalUrlSuffix = null;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.PriceExtensionTypeEnum.PriceExtensionType[message.type] : message.type;
                            if (message.priceQualifier != null && message.hasOwnProperty("priceQualifier"))
                                object.priceQualifier = options.enums === String ? $root.google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum.PriceExtensionPriceQualifier[message.priceQualifier] : message.priceQualifier;
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                object.trackingUrlTemplate = $root.google.protobuf.StringValue.toObject(message.trackingUrlTemplate, options);
                            if (message.languageCode != null && message.hasOwnProperty("languageCode"))
                                object.languageCode = $root.google.protobuf.StringValue.toObject(message.languageCode, options);
                            if (message.priceOfferings && message.priceOfferings.length) {
                                object.priceOfferings = [];
                                for (var j = 0; j < message.priceOfferings.length; ++j)
                                    object.priceOfferings[j] = $root.google.ads.googleads.v1.common.PriceOffer.toObject(message.priceOfferings[j], options);
                            }
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix"))
                                object.finalUrlSuffix = $root.google.protobuf.StringValue.toObject(message.finalUrlSuffix, options);
                            return object;
                        };

                        /**
                         * Converts this PriceFeedItem to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.PriceFeedItem
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PriceFeedItem.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return PriceFeedItem;
                    })();

                    common.PriceOffer = (function() {

                        /**
                         * Properties of a PriceOffer.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IPriceOffer
                         * @property {google.protobuf.IStringValue|null} [header] PriceOffer header
                         * @property {google.protobuf.IStringValue|null} [description] PriceOffer description
                         * @property {google.ads.googleads.v1.common.IMoney|null} [price] PriceOffer price
                         * @property {google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum.PriceExtensionPriceUnit|null} [unit] PriceOffer unit
                         * @property {Array.<google.protobuf.IStringValue>|null} [finalUrls] PriceOffer finalUrls
                         * @property {Array.<google.protobuf.IStringValue>|null} [finalMobileUrls] PriceOffer finalMobileUrls
                         */

                        /**
                         * Constructs a new PriceOffer.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a PriceOffer.
                         * @implements IPriceOffer
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IPriceOffer=} [properties] Properties to set
                         */
                        function PriceOffer(properties) {
                            this.finalUrls = [];
                            this.finalMobileUrls = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * PriceOffer header.
                         * @member {google.protobuf.IStringValue|null|undefined} header
                         * @memberof google.ads.googleads.v1.common.PriceOffer
                         * @instance
                         */
                        PriceOffer.prototype.header = null;

                        /**
                         * PriceOffer description.
                         * @member {google.protobuf.IStringValue|null|undefined} description
                         * @memberof google.ads.googleads.v1.common.PriceOffer
                         * @instance
                         */
                        PriceOffer.prototype.description = null;

                        /**
                         * PriceOffer price.
                         * @member {google.ads.googleads.v1.common.IMoney|null|undefined} price
                         * @memberof google.ads.googleads.v1.common.PriceOffer
                         * @instance
                         */
                        PriceOffer.prototype.price = null;

                        /**
                         * PriceOffer unit.
                         * @member {google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum.PriceExtensionPriceUnit} unit
                         * @memberof google.ads.googleads.v1.common.PriceOffer
                         * @instance
                         */
                        PriceOffer.prototype.unit = 0;

                        /**
                         * PriceOffer finalUrls.
                         * @member {Array.<google.protobuf.IStringValue>} finalUrls
                         * @memberof google.ads.googleads.v1.common.PriceOffer
                         * @instance
                         */
                        PriceOffer.prototype.finalUrls = $util.emptyArray;

                        /**
                         * PriceOffer finalMobileUrls.
                         * @member {Array.<google.protobuf.IStringValue>} finalMobileUrls
                         * @memberof google.ads.googleads.v1.common.PriceOffer
                         * @instance
                         */
                        PriceOffer.prototype.finalMobileUrls = $util.emptyArray;

                        /**
                         * Creates a new PriceOffer instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.PriceOffer
                         * @static
                         * @param {google.ads.googleads.v1.common.IPriceOffer=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.PriceOffer} PriceOffer instance
                         */
                        PriceOffer.create = function create(properties) {
                            return new PriceOffer(properties);
                        };

                        /**
                         * Encodes the specified PriceOffer message. Does not implicitly {@link google.ads.googleads.v1.common.PriceOffer.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.PriceOffer
                         * @static
                         * @param {google.ads.googleads.v1.common.IPriceOffer} message PriceOffer message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PriceOffer.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.header != null && message.hasOwnProperty("header"))
                                $root.google.protobuf.StringValue.encode(message.header, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.description != null && message.hasOwnProperty("description"))
                                $root.google.protobuf.StringValue.encode(message.description, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.price != null && message.hasOwnProperty("price"))
                                $root.google.ads.googleads.v1.common.Money.encode(message.price, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.unit != null && message.hasOwnProperty("unit"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.unit);
                            if (message.finalUrls != null && message.finalUrls.length)
                                for (var i = 0; i < message.finalUrls.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.finalUrls[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.finalMobileUrls != null && message.finalMobileUrls.length)
                                for (var i = 0; i < message.finalMobileUrls.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.finalMobileUrls[i], writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified PriceOffer message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PriceOffer.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.PriceOffer
                         * @static
                         * @param {google.ads.googleads.v1.common.IPriceOffer} message PriceOffer message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PriceOffer.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PriceOffer message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.PriceOffer
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.PriceOffer} PriceOffer
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PriceOffer.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PriceOffer();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.header = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.description = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.price = $root.google.ads.googleads.v1.common.Money.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.unit = reader.int32();
                                    break;
                                case 5:
                                    if (!(message.finalUrls && message.finalUrls.length))
                                        message.finalUrls = [];
                                    message.finalUrls.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 6:
                                    if (!(message.finalMobileUrls && message.finalMobileUrls.length))
                                        message.finalMobileUrls = [];
                                    message.finalMobileUrls.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PriceOffer message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.PriceOffer
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.PriceOffer} PriceOffer
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PriceOffer.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PriceOffer message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.PriceOffer
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PriceOffer.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.header != null && message.hasOwnProperty("header")) {
                                var error = $root.google.protobuf.StringValue.verify(message.header);
                                if (error)
                                    return "header." + error;
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                var error = $root.google.protobuf.StringValue.verify(message.description);
                                if (error)
                                    return "description." + error;
                            }
                            if (message.price != null && message.hasOwnProperty("price")) {
                                var error = $root.google.ads.googleads.v1.common.Money.verify(message.price);
                                if (error)
                                    return "price." + error;
                            }
                            if (message.unit != null && message.hasOwnProperty("unit"))
                                switch (message.unit) {
                                default:
                                    return "unit: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            if (message.finalUrls != null && message.hasOwnProperty("finalUrls")) {
                                if (!Array.isArray(message.finalUrls))
                                    return "finalUrls: array expected";
                                for (var i = 0; i < message.finalUrls.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.finalUrls[i]);
                                    if (error)
                                        return "finalUrls." + error;
                                }
                            }
                            if (message.finalMobileUrls != null && message.hasOwnProperty("finalMobileUrls")) {
                                if (!Array.isArray(message.finalMobileUrls))
                                    return "finalMobileUrls: array expected";
                                for (var i = 0; i < message.finalMobileUrls.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.finalMobileUrls[i]);
                                    if (error)
                                        return "finalMobileUrls." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a PriceOffer message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.PriceOffer
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.PriceOffer} PriceOffer
                         */
                        PriceOffer.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.PriceOffer)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.PriceOffer();
                            if (object.header != null) {
                                if (typeof object.header !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PriceOffer.header: object expected");
                                message.header = $root.google.protobuf.StringValue.fromObject(object.header);
                            }
                            if (object.description != null) {
                                if (typeof object.description !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PriceOffer.description: object expected");
                                message.description = $root.google.protobuf.StringValue.fromObject(object.description);
                            }
                            if (object.price != null) {
                                if (typeof object.price !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PriceOffer.price: object expected");
                                message.price = $root.google.ads.googleads.v1.common.Money.fromObject(object.price);
                            }
                            switch (object.unit) {
                            case "UNSPECIFIED":
                            case 0:
                                message.unit = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.unit = 1;
                                break;
                            case "PER_HOUR":
                            case 2:
                                message.unit = 2;
                                break;
                            case "PER_DAY":
                            case 3:
                                message.unit = 3;
                                break;
                            case "PER_WEEK":
                            case 4:
                                message.unit = 4;
                                break;
                            case "PER_MONTH":
                            case 5:
                                message.unit = 5;
                                break;
                            case "PER_YEAR":
                            case 6:
                                message.unit = 6;
                                break;
                            case "PER_NIGHT":
                            case 7:
                                message.unit = 7;
                                break;
                            }
                            if (object.finalUrls) {
                                if (!Array.isArray(object.finalUrls))
                                    throw TypeError(".google.ads.googleads.v1.common.PriceOffer.finalUrls: array expected");
                                message.finalUrls = [];
                                for (var i = 0; i < object.finalUrls.length; ++i) {
                                    if (typeof object.finalUrls[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.PriceOffer.finalUrls: object expected");
                                    message.finalUrls[i] = $root.google.protobuf.StringValue.fromObject(object.finalUrls[i]);
                                }
                            }
                            if (object.finalMobileUrls) {
                                if (!Array.isArray(object.finalMobileUrls))
                                    throw TypeError(".google.ads.googleads.v1.common.PriceOffer.finalMobileUrls: array expected");
                                message.finalMobileUrls = [];
                                for (var i = 0; i < object.finalMobileUrls.length; ++i) {
                                    if (typeof object.finalMobileUrls[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.PriceOffer.finalMobileUrls: object expected");
                                    message.finalMobileUrls[i] = $root.google.protobuf.StringValue.fromObject(object.finalMobileUrls[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a PriceOffer message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.PriceOffer
                         * @static
                         * @param {google.ads.googleads.v1.common.PriceOffer} message PriceOffer
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PriceOffer.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.finalUrls = [];
                                object.finalMobileUrls = [];
                            }
                            if (options.defaults) {
                                object.header = null;
                                object.description = null;
                                object.price = null;
                                object.unit = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.header != null && message.hasOwnProperty("header"))
                                object.header = $root.google.protobuf.StringValue.toObject(message.header, options);
                            if (message.description != null && message.hasOwnProperty("description"))
                                object.description = $root.google.protobuf.StringValue.toObject(message.description, options);
                            if (message.price != null && message.hasOwnProperty("price"))
                                object.price = $root.google.ads.googleads.v1.common.Money.toObject(message.price, options);
                            if (message.unit != null && message.hasOwnProperty("unit"))
                                object.unit = options.enums === String ? $root.google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum.PriceExtensionPriceUnit[message.unit] : message.unit;
                            if (message.finalUrls && message.finalUrls.length) {
                                object.finalUrls = [];
                                for (var j = 0; j < message.finalUrls.length; ++j)
                                    object.finalUrls[j] = $root.google.protobuf.StringValue.toObject(message.finalUrls[j], options);
                            }
                            if (message.finalMobileUrls && message.finalMobileUrls.length) {
                                object.finalMobileUrls = [];
                                for (var j = 0; j < message.finalMobileUrls.length; ++j)
                                    object.finalMobileUrls[j] = $root.google.protobuf.StringValue.toObject(message.finalMobileUrls[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this PriceOffer to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.PriceOffer
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PriceOffer.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return PriceOffer;
                    })();

                    common.PromotionFeedItem = (function() {

                        /**
                         * Properties of a PromotionFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IPromotionFeedItem
                         * @property {google.protobuf.IStringValue|null} [promotionTarget] PromotionFeedItem promotionTarget
                         * @property {google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum.PromotionExtensionDiscountModifier|null} [discountModifier] PromotionFeedItem discountModifier
                         * @property {google.protobuf.IStringValue|null} [promotionStartDate] PromotionFeedItem promotionStartDate
                         * @property {google.protobuf.IStringValue|null} [promotionEndDate] PromotionFeedItem promotionEndDate
                         * @property {google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum.PromotionExtensionOccasion|null} [occasion] PromotionFeedItem occasion
                         * @property {Array.<google.protobuf.IStringValue>|null} [finalUrls] PromotionFeedItem finalUrls
                         * @property {Array.<google.protobuf.IStringValue>|null} [finalMobileUrls] PromotionFeedItem finalMobileUrls
                         * @property {google.protobuf.IStringValue|null} [trackingUrlTemplate] PromotionFeedItem trackingUrlTemplate
                         * @property {Array.<google.ads.googleads.v1.common.ICustomParameter>|null} [urlCustomParameters] PromotionFeedItem urlCustomParameters
                         * @property {google.protobuf.IStringValue|null} [finalUrlSuffix] PromotionFeedItem finalUrlSuffix
                         * @property {google.protobuf.IStringValue|null} [languageCode] PromotionFeedItem languageCode
                         * @property {google.protobuf.IInt64Value|null} [percentOff] PromotionFeedItem percentOff
                         * @property {google.ads.googleads.v1.common.IMoney|null} [moneyAmountOff] PromotionFeedItem moneyAmountOff
                         * @property {google.protobuf.IStringValue|null} [promotionCode] PromotionFeedItem promotionCode
                         * @property {google.ads.googleads.v1.common.IMoney|null} [ordersOverAmount] PromotionFeedItem ordersOverAmount
                         */

                        /**
                         * Constructs a new PromotionFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a PromotionFeedItem.
                         * @implements IPromotionFeedItem
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IPromotionFeedItem=} [properties] Properties to set
                         */
                        function PromotionFeedItem(properties) {
                            this.finalUrls = [];
                            this.finalMobileUrls = [];
                            this.urlCustomParameters = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * PromotionFeedItem promotionTarget.
                         * @member {google.protobuf.IStringValue|null|undefined} promotionTarget
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @instance
                         */
                        PromotionFeedItem.prototype.promotionTarget = null;

                        /**
                         * PromotionFeedItem discountModifier.
                         * @member {google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum.PromotionExtensionDiscountModifier} discountModifier
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @instance
                         */
                        PromotionFeedItem.prototype.discountModifier = 0;

                        /**
                         * PromotionFeedItem promotionStartDate.
                         * @member {google.protobuf.IStringValue|null|undefined} promotionStartDate
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @instance
                         */
                        PromotionFeedItem.prototype.promotionStartDate = null;

                        /**
                         * PromotionFeedItem promotionEndDate.
                         * @member {google.protobuf.IStringValue|null|undefined} promotionEndDate
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @instance
                         */
                        PromotionFeedItem.prototype.promotionEndDate = null;

                        /**
                         * PromotionFeedItem occasion.
                         * @member {google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum.PromotionExtensionOccasion} occasion
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @instance
                         */
                        PromotionFeedItem.prototype.occasion = 0;

                        /**
                         * PromotionFeedItem finalUrls.
                         * @member {Array.<google.protobuf.IStringValue>} finalUrls
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @instance
                         */
                        PromotionFeedItem.prototype.finalUrls = $util.emptyArray;

                        /**
                         * PromotionFeedItem finalMobileUrls.
                         * @member {Array.<google.protobuf.IStringValue>} finalMobileUrls
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @instance
                         */
                        PromotionFeedItem.prototype.finalMobileUrls = $util.emptyArray;

                        /**
                         * PromotionFeedItem trackingUrlTemplate.
                         * @member {google.protobuf.IStringValue|null|undefined} trackingUrlTemplate
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @instance
                         */
                        PromotionFeedItem.prototype.trackingUrlTemplate = null;

                        /**
                         * PromotionFeedItem urlCustomParameters.
                         * @member {Array.<google.ads.googleads.v1.common.ICustomParameter>} urlCustomParameters
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @instance
                         */
                        PromotionFeedItem.prototype.urlCustomParameters = $util.emptyArray;

                        /**
                         * PromotionFeedItem finalUrlSuffix.
                         * @member {google.protobuf.IStringValue|null|undefined} finalUrlSuffix
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @instance
                         */
                        PromotionFeedItem.prototype.finalUrlSuffix = null;

                        /**
                         * PromotionFeedItem languageCode.
                         * @member {google.protobuf.IStringValue|null|undefined} languageCode
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @instance
                         */
                        PromotionFeedItem.prototype.languageCode = null;

                        /**
                         * PromotionFeedItem percentOff.
                         * @member {google.protobuf.IInt64Value|null|undefined} percentOff
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @instance
                         */
                        PromotionFeedItem.prototype.percentOff = null;

                        /**
                         * PromotionFeedItem moneyAmountOff.
                         * @member {google.ads.googleads.v1.common.IMoney|null|undefined} moneyAmountOff
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @instance
                         */
                        PromotionFeedItem.prototype.moneyAmountOff = null;

                        /**
                         * PromotionFeedItem promotionCode.
                         * @member {google.protobuf.IStringValue|null|undefined} promotionCode
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @instance
                         */
                        PromotionFeedItem.prototype.promotionCode = null;

                        /**
                         * PromotionFeedItem ordersOverAmount.
                         * @member {google.ads.googleads.v1.common.IMoney|null|undefined} ordersOverAmount
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @instance
                         */
                        PromotionFeedItem.prototype.ordersOverAmount = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * PromotionFeedItem discountType.
                         * @member {"percentOff"|"moneyAmountOff"|undefined} discountType
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @instance
                         */
                        Object.defineProperty(PromotionFeedItem.prototype, "discountType", {
                            get: $util.oneOfGetter($oneOfFields = ["percentOff", "moneyAmountOff"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * PromotionFeedItem promotionTrigger.
                         * @member {"promotionCode"|"ordersOverAmount"|undefined} promotionTrigger
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @instance
                         */
                        Object.defineProperty(PromotionFeedItem.prototype, "promotionTrigger", {
                            get: $util.oneOfGetter($oneOfFields = ["promotionCode", "ordersOverAmount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new PromotionFeedItem instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.IPromotionFeedItem=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.PromotionFeedItem} PromotionFeedItem instance
                         */
                        PromotionFeedItem.create = function create(properties) {
                            return new PromotionFeedItem(properties);
                        };

                        /**
                         * Encodes the specified PromotionFeedItem message. Does not implicitly {@link google.ads.googleads.v1.common.PromotionFeedItem.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.IPromotionFeedItem} message PromotionFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PromotionFeedItem.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.promotionTarget != null && message.hasOwnProperty("promotionTarget"))
                                $root.google.protobuf.StringValue.encode(message.promotionTarget, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.discountModifier != null && message.hasOwnProperty("discountModifier"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.discountModifier);
                            if (message.percentOff != null && message.hasOwnProperty("percentOff"))
                                $root.google.protobuf.Int64Value.encode(message.percentOff, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.moneyAmountOff != null && message.hasOwnProperty("moneyAmountOff"))
                                $root.google.ads.googleads.v1.common.Money.encode(message.moneyAmountOff, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.promotionCode != null && message.hasOwnProperty("promotionCode"))
                                $root.google.protobuf.StringValue.encode(message.promotionCode, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.ordersOverAmount != null && message.hasOwnProperty("ordersOverAmount"))
                                $root.google.ads.googleads.v1.common.Money.encode(message.ordersOverAmount, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.promotionStartDate != null && message.hasOwnProperty("promotionStartDate"))
                                $root.google.protobuf.StringValue.encode(message.promotionStartDate, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.promotionEndDate != null && message.hasOwnProperty("promotionEndDate"))
                                $root.google.protobuf.StringValue.encode(message.promotionEndDate, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.occasion != null && message.hasOwnProperty("occasion"))
                                writer.uint32(/* id 9, wireType 0 =*/72).int32(message.occasion);
                            if (message.finalUrls != null && message.finalUrls.length)
                                for (var i = 0; i < message.finalUrls.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.finalUrls[i], writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.finalMobileUrls != null && message.finalMobileUrls.length)
                                for (var i = 0; i < message.finalMobileUrls.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.finalMobileUrls[i], writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                $root.google.protobuf.StringValue.encode(message.trackingUrlTemplate, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.urlCustomParameters != null && message.urlCustomParameters.length)
                                for (var i = 0; i < message.urlCustomParameters.length; ++i)
                                    $root.google.ads.googleads.v1.common.CustomParameter.encode(message.urlCustomParameters[i], writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix"))
                                $root.google.protobuf.StringValue.encode(message.finalUrlSuffix, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.languageCode != null && message.hasOwnProperty("languageCode"))
                                $root.google.protobuf.StringValue.encode(message.languageCode, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified PromotionFeedItem message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PromotionFeedItem.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.IPromotionFeedItem} message PromotionFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PromotionFeedItem.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PromotionFeedItem message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.PromotionFeedItem} PromotionFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PromotionFeedItem.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PromotionFeedItem();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.promotionTarget = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.discountModifier = reader.int32();
                                    break;
                                case 7:
                                    message.promotionStartDate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.promotionEndDate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.occasion = reader.int32();
                                    break;
                                case 10:
                                    if (!(message.finalUrls && message.finalUrls.length))
                                        message.finalUrls = [];
                                    message.finalUrls.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 11:
                                    if (!(message.finalMobileUrls && message.finalMobileUrls.length))
                                        message.finalMobileUrls = [];
                                    message.finalMobileUrls.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 12:
                                    message.trackingUrlTemplate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 13:
                                    if (!(message.urlCustomParameters && message.urlCustomParameters.length))
                                        message.urlCustomParameters = [];
                                    message.urlCustomParameters.push($root.google.ads.googleads.v1.common.CustomParameter.decode(reader, reader.uint32()));
                                    break;
                                case 14:
                                    message.finalUrlSuffix = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 15:
                                    message.languageCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.percentOff = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.moneyAmountOff = $root.google.ads.googleads.v1.common.Money.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.promotionCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.ordersOverAmount = $root.google.ads.googleads.v1.common.Money.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PromotionFeedItem message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.PromotionFeedItem} PromotionFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PromotionFeedItem.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PromotionFeedItem message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PromotionFeedItem.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.promotionTarget != null && message.hasOwnProperty("promotionTarget")) {
                                var error = $root.google.protobuf.StringValue.verify(message.promotionTarget);
                                if (error)
                                    return "promotionTarget." + error;
                            }
                            if (message.discountModifier != null && message.hasOwnProperty("discountModifier"))
                                switch (message.discountModifier) {
                                default:
                                    return "discountModifier: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            if (message.promotionStartDate != null && message.hasOwnProperty("promotionStartDate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.promotionStartDate);
                                if (error)
                                    return "promotionStartDate." + error;
                            }
                            if (message.promotionEndDate != null && message.hasOwnProperty("promotionEndDate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.promotionEndDate);
                                if (error)
                                    return "promotionEndDate." + error;
                            }
                            if (message.occasion != null && message.hasOwnProperty("occasion"))
                                switch (message.occasion) {
                                default:
                                    return "occasion: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                case 32:
                                case 33:
                                case 34:
                                case 35:
                                case 36:
                                case 37:
                                case 38:
                                    break;
                                }
                            if (message.finalUrls != null && message.hasOwnProperty("finalUrls")) {
                                if (!Array.isArray(message.finalUrls))
                                    return "finalUrls: array expected";
                                for (var i = 0; i < message.finalUrls.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.finalUrls[i]);
                                    if (error)
                                        return "finalUrls." + error;
                                }
                            }
                            if (message.finalMobileUrls != null && message.hasOwnProperty("finalMobileUrls")) {
                                if (!Array.isArray(message.finalMobileUrls))
                                    return "finalMobileUrls: array expected";
                                for (var i = 0; i < message.finalMobileUrls.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.finalMobileUrls[i]);
                                    if (error)
                                        return "finalMobileUrls." + error;
                                }
                            }
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.trackingUrlTemplate);
                                if (error)
                                    return "trackingUrlTemplate." + error;
                            }
                            if (message.urlCustomParameters != null && message.hasOwnProperty("urlCustomParameters")) {
                                if (!Array.isArray(message.urlCustomParameters))
                                    return "urlCustomParameters: array expected";
                                for (var i = 0; i < message.urlCustomParameters.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.CustomParameter.verify(message.urlCustomParameters[i]);
                                    if (error)
                                        return "urlCustomParameters." + error;
                                }
                            }
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix")) {
                                var error = $root.google.protobuf.StringValue.verify(message.finalUrlSuffix);
                                if (error)
                                    return "finalUrlSuffix." + error;
                            }
                            if (message.languageCode != null && message.hasOwnProperty("languageCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.languageCode);
                                if (error)
                                    return "languageCode." + error;
                            }
                            if (message.percentOff != null && message.hasOwnProperty("percentOff")) {
                                properties.discountType = 1;
                                {
                                    var error = $root.google.protobuf.Int64Value.verify(message.percentOff);
                                    if (error)
                                        return "percentOff." + error;
                                }
                            }
                            if (message.moneyAmountOff != null && message.hasOwnProperty("moneyAmountOff")) {
                                if (properties.discountType === 1)
                                    return "discountType: multiple values";
                                properties.discountType = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.Money.verify(message.moneyAmountOff);
                                    if (error)
                                        return "moneyAmountOff." + error;
                                }
                            }
                            if (message.promotionCode != null && message.hasOwnProperty("promotionCode")) {
                                properties.promotionTrigger = 1;
                                {
                                    var error = $root.google.protobuf.StringValue.verify(message.promotionCode);
                                    if (error)
                                        return "promotionCode." + error;
                                }
                            }
                            if (message.ordersOverAmount != null && message.hasOwnProperty("ordersOverAmount")) {
                                if (properties.promotionTrigger === 1)
                                    return "promotionTrigger: multiple values";
                                properties.promotionTrigger = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.Money.verify(message.ordersOverAmount);
                                    if (error)
                                        return "ordersOverAmount." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a PromotionFeedItem message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.PromotionFeedItem} PromotionFeedItem
                         */
                        PromotionFeedItem.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.PromotionFeedItem)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.PromotionFeedItem();
                            if (object.promotionTarget != null) {
                                if (typeof object.promotionTarget !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PromotionFeedItem.promotionTarget: object expected");
                                message.promotionTarget = $root.google.protobuf.StringValue.fromObject(object.promotionTarget);
                            }
                            switch (object.discountModifier) {
                            case "UNSPECIFIED":
                            case 0:
                                message.discountModifier = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.discountModifier = 1;
                                break;
                            case "UP_TO":
                            case 2:
                                message.discountModifier = 2;
                                break;
                            }
                            if (object.promotionStartDate != null) {
                                if (typeof object.promotionStartDate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PromotionFeedItem.promotionStartDate: object expected");
                                message.promotionStartDate = $root.google.protobuf.StringValue.fromObject(object.promotionStartDate);
                            }
                            if (object.promotionEndDate != null) {
                                if (typeof object.promotionEndDate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PromotionFeedItem.promotionEndDate: object expected");
                                message.promotionEndDate = $root.google.protobuf.StringValue.fromObject(object.promotionEndDate);
                            }
                            switch (object.occasion) {
                            case "UNSPECIFIED":
                            case 0:
                                message.occasion = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.occasion = 1;
                                break;
                            case "NEW_YEARS":
                            case 2:
                                message.occasion = 2;
                                break;
                            case "CHINESE_NEW_YEAR":
                            case 3:
                                message.occasion = 3;
                                break;
                            case "VALENTINES_DAY":
                            case 4:
                                message.occasion = 4;
                                break;
                            case "EASTER":
                            case 5:
                                message.occasion = 5;
                                break;
                            case "MOTHERS_DAY":
                            case 6:
                                message.occasion = 6;
                                break;
                            case "FATHERS_DAY":
                            case 7:
                                message.occasion = 7;
                                break;
                            case "LABOR_DAY":
                            case 8:
                                message.occasion = 8;
                                break;
                            case "BACK_TO_SCHOOL":
                            case 9:
                                message.occasion = 9;
                                break;
                            case "HALLOWEEN":
                            case 10:
                                message.occasion = 10;
                                break;
                            case "BLACK_FRIDAY":
                            case 11:
                                message.occasion = 11;
                                break;
                            case "CYBER_MONDAY":
                            case 12:
                                message.occasion = 12;
                                break;
                            case "CHRISTMAS":
                            case 13:
                                message.occasion = 13;
                                break;
                            case "BOXING_DAY":
                            case 14:
                                message.occasion = 14;
                                break;
                            case "INDEPENDENCE_DAY":
                            case 15:
                                message.occasion = 15;
                                break;
                            case "NATIONAL_DAY":
                            case 16:
                                message.occasion = 16;
                                break;
                            case "END_OF_SEASON":
                            case 17:
                                message.occasion = 17;
                                break;
                            case "WINTER_SALE":
                            case 18:
                                message.occasion = 18;
                                break;
                            case "SUMMER_SALE":
                            case 19:
                                message.occasion = 19;
                                break;
                            case "FALL_SALE":
                            case 20:
                                message.occasion = 20;
                                break;
                            case "SPRING_SALE":
                            case 21:
                                message.occasion = 21;
                                break;
                            case "RAMADAN":
                            case 22:
                                message.occasion = 22;
                                break;
                            case "EID_AL_FITR":
                            case 23:
                                message.occasion = 23;
                                break;
                            case "EID_AL_ADHA":
                            case 24:
                                message.occasion = 24;
                                break;
                            case "SINGLES_DAY":
                            case 25:
                                message.occasion = 25;
                                break;
                            case "WOMENS_DAY":
                            case 26:
                                message.occasion = 26;
                                break;
                            case "HOLI":
                            case 27:
                                message.occasion = 27;
                                break;
                            case "PARENTS_DAY":
                            case 28:
                                message.occasion = 28;
                                break;
                            case "ST_NICHOLAS_DAY":
                            case 29:
                                message.occasion = 29;
                                break;
                            case "CARNIVAL":
                            case 30:
                                message.occasion = 30;
                                break;
                            case "EPIPHANY":
                            case 31:
                                message.occasion = 31;
                                break;
                            case "ROSH_HASHANAH":
                            case 32:
                                message.occasion = 32;
                                break;
                            case "PASSOVER":
                            case 33:
                                message.occasion = 33;
                                break;
                            case "HANUKKAH":
                            case 34:
                                message.occasion = 34;
                                break;
                            case "DIWALI":
                            case 35:
                                message.occasion = 35;
                                break;
                            case "NAVRATRI":
                            case 36:
                                message.occasion = 36;
                                break;
                            case "SONGKRAN":
                            case 37:
                                message.occasion = 37;
                                break;
                            case "YEAR_END_GIFT":
                            case 38:
                                message.occasion = 38;
                                break;
                            }
                            if (object.finalUrls) {
                                if (!Array.isArray(object.finalUrls))
                                    throw TypeError(".google.ads.googleads.v1.common.PromotionFeedItem.finalUrls: array expected");
                                message.finalUrls = [];
                                for (var i = 0; i < object.finalUrls.length; ++i) {
                                    if (typeof object.finalUrls[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.PromotionFeedItem.finalUrls: object expected");
                                    message.finalUrls[i] = $root.google.protobuf.StringValue.fromObject(object.finalUrls[i]);
                                }
                            }
                            if (object.finalMobileUrls) {
                                if (!Array.isArray(object.finalMobileUrls))
                                    throw TypeError(".google.ads.googleads.v1.common.PromotionFeedItem.finalMobileUrls: array expected");
                                message.finalMobileUrls = [];
                                for (var i = 0; i < object.finalMobileUrls.length; ++i) {
                                    if (typeof object.finalMobileUrls[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.PromotionFeedItem.finalMobileUrls: object expected");
                                    message.finalMobileUrls[i] = $root.google.protobuf.StringValue.fromObject(object.finalMobileUrls[i]);
                                }
                            }
                            if (object.trackingUrlTemplate != null) {
                                if (typeof object.trackingUrlTemplate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PromotionFeedItem.trackingUrlTemplate: object expected");
                                message.trackingUrlTemplate = $root.google.protobuf.StringValue.fromObject(object.trackingUrlTemplate);
                            }
                            if (object.urlCustomParameters) {
                                if (!Array.isArray(object.urlCustomParameters))
                                    throw TypeError(".google.ads.googleads.v1.common.PromotionFeedItem.urlCustomParameters: array expected");
                                message.urlCustomParameters = [];
                                for (var i = 0; i < object.urlCustomParameters.length; ++i) {
                                    if (typeof object.urlCustomParameters[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.PromotionFeedItem.urlCustomParameters: object expected");
                                    message.urlCustomParameters[i] = $root.google.ads.googleads.v1.common.CustomParameter.fromObject(object.urlCustomParameters[i]);
                                }
                            }
                            if (object.finalUrlSuffix != null) {
                                if (typeof object.finalUrlSuffix !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PromotionFeedItem.finalUrlSuffix: object expected");
                                message.finalUrlSuffix = $root.google.protobuf.StringValue.fromObject(object.finalUrlSuffix);
                            }
                            if (object.languageCode != null) {
                                if (typeof object.languageCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PromotionFeedItem.languageCode: object expected");
                                message.languageCode = $root.google.protobuf.StringValue.fromObject(object.languageCode);
                            }
                            if (object.percentOff != null) {
                                if (typeof object.percentOff !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PromotionFeedItem.percentOff: object expected");
                                message.percentOff = $root.google.protobuf.Int64Value.fromObject(object.percentOff);
                            }
                            if (object.moneyAmountOff != null) {
                                if (typeof object.moneyAmountOff !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PromotionFeedItem.moneyAmountOff: object expected");
                                message.moneyAmountOff = $root.google.ads.googleads.v1.common.Money.fromObject(object.moneyAmountOff);
                            }
                            if (object.promotionCode != null) {
                                if (typeof object.promotionCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PromotionFeedItem.promotionCode: object expected");
                                message.promotionCode = $root.google.protobuf.StringValue.fromObject(object.promotionCode);
                            }
                            if (object.ordersOverAmount != null) {
                                if (typeof object.ordersOverAmount !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PromotionFeedItem.ordersOverAmount: object expected");
                                message.ordersOverAmount = $root.google.ads.googleads.v1.common.Money.fromObject(object.ordersOverAmount);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a PromotionFeedItem message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.PromotionFeedItem} message PromotionFeedItem
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PromotionFeedItem.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.finalUrls = [];
                                object.finalMobileUrls = [];
                                object.urlCustomParameters = [];
                            }
                            if (options.defaults) {
                                object.promotionTarget = null;
                                object.discountModifier = options.enums === String ? "UNSPECIFIED" : 0;
                                object.promotionStartDate = null;
                                object.promotionEndDate = null;
                                object.occasion = options.enums === String ? "UNSPECIFIED" : 0;
                                object.trackingUrlTemplate = null;
                                object.finalUrlSuffix = null;
                                object.languageCode = null;
                            }
                            if (message.promotionTarget != null && message.hasOwnProperty("promotionTarget"))
                                object.promotionTarget = $root.google.protobuf.StringValue.toObject(message.promotionTarget, options);
                            if (message.discountModifier != null && message.hasOwnProperty("discountModifier"))
                                object.discountModifier = options.enums === String ? $root.google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum.PromotionExtensionDiscountModifier[message.discountModifier] : message.discountModifier;
                            if (message.percentOff != null && message.hasOwnProperty("percentOff")) {
                                object.percentOff = $root.google.protobuf.Int64Value.toObject(message.percentOff, options);
                                if (options.oneofs)
                                    object.discountType = "percentOff";
                            }
                            if (message.moneyAmountOff != null && message.hasOwnProperty("moneyAmountOff")) {
                                object.moneyAmountOff = $root.google.ads.googleads.v1.common.Money.toObject(message.moneyAmountOff, options);
                                if (options.oneofs)
                                    object.discountType = "moneyAmountOff";
                            }
                            if (message.promotionCode != null && message.hasOwnProperty("promotionCode")) {
                                object.promotionCode = $root.google.protobuf.StringValue.toObject(message.promotionCode, options);
                                if (options.oneofs)
                                    object.promotionTrigger = "promotionCode";
                            }
                            if (message.ordersOverAmount != null && message.hasOwnProperty("ordersOverAmount")) {
                                object.ordersOverAmount = $root.google.ads.googleads.v1.common.Money.toObject(message.ordersOverAmount, options);
                                if (options.oneofs)
                                    object.promotionTrigger = "ordersOverAmount";
                            }
                            if (message.promotionStartDate != null && message.hasOwnProperty("promotionStartDate"))
                                object.promotionStartDate = $root.google.protobuf.StringValue.toObject(message.promotionStartDate, options);
                            if (message.promotionEndDate != null && message.hasOwnProperty("promotionEndDate"))
                                object.promotionEndDate = $root.google.protobuf.StringValue.toObject(message.promotionEndDate, options);
                            if (message.occasion != null && message.hasOwnProperty("occasion"))
                                object.occasion = options.enums === String ? $root.google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum.PromotionExtensionOccasion[message.occasion] : message.occasion;
                            if (message.finalUrls && message.finalUrls.length) {
                                object.finalUrls = [];
                                for (var j = 0; j < message.finalUrls.length; ++j)
                                    object.finalUrls[j] = $root.google.protobuf.StringValue.toObject(message.finalUrls[j], options);
                            }
                            if (message.finalMobileUrls && message.finalMobileUrls.length) {
                                object.finalMobileUrls = [];
                                for (var j = 0; j < message.finalMobileUrls.length; ++j)
                                    object.finalMobileUrls[j] = $root.google.protobuf.StringValue.toObject(message.finalMobileUrls[j], options);
                            }
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                object.trackingUrlTemplate = $root.google.protobuf.StringValue.toObject(message.trackingUrlTemplate, options);
                            if (message.urlCustomParameters && message.urlCustomParameters.length) {
                                object.urlCustomParameters = [];
                                for (var j = 0; j < message.urlCustomParameters.length; ++j)
                                    object.urlCustomParameters[j] = $root.google.ads.googleads.v1.common.CustomParameter.toObject(message.urlCustomParameters[j], options);
                            }
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix"))
                                object.finalUrlSuffix = $root.google.protobuf.StringValue.toObject(message.finalUrlSuffix, options);
                            if (message.languageCode != null && message.hasOwnProperty("languageCode"))
                                object.languageCode = $root.google.protobuf.StringValue.toObject(message.languageCode, options);
                            return object;
                        };

                        /**
                         * Converts this PromotionFeedItem to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.PromotionFeedItem
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PromotionFeedItem.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return PromotionFeedItem;
                    })();

                    common.StructuredSnippetFeedItem = (function() {

                        /**
                         * Properties of a StructuredSnippetFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IStructuredSnippetFeedItem
                         * @property {google.protobuf.IStringValue|null} [header] StructuredSnippetFeedItem header
                         * @property {Array.<google.protobuf.IStringValue>|null} [values] StructuredSnippetFeedItem values
                         */

                        /**
                         * Constructs a new StructuredSnippetFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a StructuredSnippetFeedItem.
                         * @implements IStructuredSnippetFeedItem
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IStructuredSnippetFeedItem=} [properties] Properties to set
                         */
                        function StructuredSnippetFeedItem(properties) {
                            this.values = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * StructuredSnippetFeedItem header.
                         * @member {google.protobuf.IStringValue|null|undefined} header
                         * @memberof google.ads.googleads.v1.common.StructuredSnippetFeedItem
                         * @instance
                         */
                        StructuredSnippetFeedItem.prototype.header = null;

                        /**
                         * StructuredSnippetFeedItem values.
                         * @member {Array.<google.protobuf.IStringValue>} values
                         * @memberof google.ads.googleads.v1.common.StructuredSnippetFeedItem
                         * @instance
                         */
                        StructuredSnippetFeedItem.prototype.values = $util.emptyArray;

                        /**
                         * Creates a new StructuredSnippetFeedItem instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.StructuredSnippetFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.IStructuredSnippetFeedItem=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.StructuredSnippetFeedItem} StructuredSnippetFeedItem instance
                         */
                        StructuredSnippetFeedItem.create = function create(properties) {
                            return new StructuredSnippetFeedItem(properties);
                        };

                        /**
                         * Encodes the specified StructuredSnippetFeedItem message. Does not implicitly {@link google.ads.googleads.v1.common.StructuredSnippetFeedItem.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.StructuredSnippetFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.IStructuredSnippetFeedItem} message StructuredSnippetFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StructuredSnippetFeedItem.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.header != null && message.hasOwnProperty("header"))
                                $root.google.protobuf.StringValue.encode(message.header, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.values != null && message.values.length)
                                for (var i = 0; i < message.values.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.values[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified StructuredSnippetFeedItem message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.StructuredSnippetFeedItem.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.StructuredSnippetFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.IStructuredSnippetFeedItem} message StructuredSnippetFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StructuredSnippetFeedItem.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a StructuredSnippetFeedItem message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.StructuredSnippetFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.StructuredSnippetFeedItem} StructuredSnippetFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StructuredSnippetFeedItem.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.StructuredSnippetFeedItem();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.header = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.values && message.values.length))
                                        message.values = [];
                                    message.values.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a StructuredSnippetFeedItem message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.StructuredSnippetFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.StructuredSnippetFeedItem} StructuredSnippetFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StructuredSnippetFeedItem.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a StructuredSnippetFeedItem message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.StructuredSnippetFeedItem
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        StructuredSnippetFeedItem.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.header != null && message.hasOwnProperty("header")) {
                                var error = $root.google.protobuf.StringValue.verify(message.header);
                                if (error)
                                    return "header." + error;
                            }
                            if (message.values != null && message.hasOwnProperty("values")) {
                                if (!Array.isArray(message.values))
                                    return "values: array expected";
                                for (var i = 0; i < message.values.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.values[i]);
                                    if (error)
                                        return "values." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a StructuredSnippetFeedItem message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.StructuredSnippetFeedItem
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.StructuredSnippetFeedItem} StructuredSnippetFeedItem
                         */
                        StructuredSnippetFeedItem.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.StructuredSnippetFeedItem)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.StructuredSnippetFeedItem();
                            if (object.header != null) {
                                if (typeof object.header !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.StructuredSnippetFeedItem.header: object expected");
                                message.header = $root.google.protobuf.StringValue.fromObject(object.header);
                            }
                            if (object.values) {
                                if (!Array.isArray(object.values))
                                    throw TypeError(".google.ads.googleads.v1.common.StructuredSnippetFeedItem.values: array expected");
                                message.values = [];
                                for (var i = 0; i < object.values.length; ++i) {
                                    if (typeof object.values[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.StructuredSnippetFeedItem.values: object expected");
                                    message.values[i] = $root.google.protobuf.StringValue.fromObject(object.values[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a StructuredSnippetFeedItem message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.StructuredSnippetFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.StructuredSnippetFeedItem} message StructuredSnippetFeedItem
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        StructuredSnippetFeedItem.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.values = [];
                            if (options.defaults)
                                object.header = null;
                            if (message.header != null && message.hasOwnProperty("header"))
                                object.header = $root.google.protobuf.StringValue.toObject(message.header, options);
                            if (message.values && message.values.length) {
                                object.values = [];
                                for (var j = 0; j < message.values.length; ++j)
                                    object.values[j] = $root.google.protobuf.StringValue.toObject(message.values[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this StructuredSnippetFeedItem to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.StructuredSnippetFeedItem
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        StructuredSnippetFeedItem.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return StructuredSnippetFeedItem;
                    })();

                    common.SitelinkFeedItem = (function() {

                        /**
                         * Properties of a SitelinkFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ISitelinkFeedItem
                         * @property {google.protobuf.IStringValue|null} [linkText] SitelinkFeedItem linkText
                         * @property {google.protobuf.IStringValue|null} [line1] SitelinkFeedItem line1
                         * @property {google.protobuf.IStringValue|null} [line2] SitelinkFeedItem line2
                         * @property {Array.<google.protobuf.IStringValue>|null} [finalUrls] SitelinkFeedItem finalUrls
                         * @property {Array.<google.protobuf.IStringValue>|null} [finalMobileUrls] SitelinkFeedItem finalMobileUrls
                         * @property {google.protobuf.IStringValue|null} [trackingUrlTemplate] SitelinkFeedItem trackingUrlTemplate
                         * @property {Array.<google.ads.googleads.v1.common.ICustomParameter>|null} [urlCustomParameters] SitelinkFeedItem urlCustomParameters
                         * @property {google.protobuf.IStringValue|null} [finalUrlSuffix] SitelinkFeedItem finalUrlSuffix
                         */

                        /**
                         * Constructs a new SitelinkFeedItem.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a SitelinkFeedItem.
                         * @implements ISitelinkFeedItem
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ISitelinkFeedItem=} [properties] Properties to set
                         */
                        function SitelinkFeedItem(properties) {
                            this.finalUrls = [];
                            this.finalMobileUrls = [];
                            this.urlCustomParameters = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * SitelinkFeedItem linkText.
                         * @member {google.protobuf.IStringValue|null|undefined} linkText
                         * @memberof google.ads.googleads.v1.common.SitelinkFeedItem
                         * @instance
                         */
                        SitelinkFeedItem.prototype.linkText = null;

                        /**
                         * SitelinkFeedItem line1.
                         * @member {google.protobuf.IStringValue|null|undefined} line1
                         * @memberof google.ads.googleads.v1.common.SitelinkFeedItem
                         * @instance
                         */
                        SitelinkFeedItem.prototype.line1 = null;

                        /**
                         * SitelinkFeedItem line2.
                         * @member {google.protobuf.IStringValue|null|undefined} line2
                         * @memberof google.ads.googleads.v1.common.SitelinkFeedItem
                         * @instance
                         */
                        SitelinkFeedItem.prototype.line2 = null;

                        /**
                         * SitelinkFeedItem finalUrls.
                         * @member {Array.<google.protobuf.IStringValue>} finalUrls
                         * @memberof google.ads.googleads.v1.common.SitelinkFeedItem
                         * @instance
                         */
                        SitelinkFeedItem.prototype.finalUrls = $util.emptyArray;

                        /**
                         * SitelinkFeedItem finalMobileUrls.
                         * @member {Array.<google.protobuf.IStringValue>} finalMobileUrls
                         * @memberof google.ads.googleads.v1.common.SitelinkFeedItem
                         * @instance
                         */
                        SitelinkFeedItem.prototype.finalMobileUrls = $util.emptyArray;

                        /**
                         * SitelinkFeedItem trackingUrlTemplate.
                         * @member {google.protobuf.IStringValue|null|undefined} trackingUrlTemplate
                         * @memberof google.ads.googleads.v1.common.SitelinkFeedItem
                         * @instance
                         */
                        SitelinkFeedItem.prototype.trackingUrlTemplate = null;

                        /**
                         * SitelinkFeedItem urlCustomParameters.
                         * @member {Array.<google.ads.googleads.v1.common.ICustomParameter>} urlCustomParameters
                         * @memberof google.ads.googleads.v1.common.SitelinkFeedItem
                         * @instance
                         */
                        SitelinkFeedItem.prototype.urlCustomParameters = $util.emptyArray;

                        /**
                         * SitelinkFeedItem finalUrlSuffix.
                         * @member {google.protobuf.IStringValue|null|undefined} finalUrlSuffix
                         * @memberof google.ads.googleads.v1.common.SitelinkFeedItem
                         * @instance
                         */
                        SitelinkFeedItem.prototype.finalUrlSuffix = null;

                        /**
                         * Creates a new SitelinkFeedItem instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.SitelinkFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.ISitelinkFeedItem=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.SitelinkFeedItem} SitelinkFeedItem instance
                         */
                        SitelinkFeedItem.create = function create(properties) {
                            return new SitelinkFeedItem(properties);
                        };

                        /**
                         * Encodes the specified SitelinkFeedItem message. Does not implicitly {@link google.ads.googleads.v1.common.SitelinkFeedItem.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.SitelinkFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.ISitelinkFeedItem} message SitelinkFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SitelinkFeedItem.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.linkText != null && message.hasOwnProperty("linkText"))
                                $root.google.protobuf.StringValue.encode(message.linkText, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.line1 != null && message.hasOwnProperty("line1"))
                                $root.google.protobuf.StringValue.encode(message.line1, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.line2 != null && message.hasOwnProperty("line2"))
                                $root.google.protobuf.StringValue.encode(message.line2, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.finalUrls != null && message.finalUrls.length)
                                for (var i = 0; i < message.finalUrls.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.finalUrls[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.finalMobileUrls != null && message.finalMobileUrls.length)
                                for (var i = 0; i < message.finalMobileUrls.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.finalMobileUrls[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                $root.google.protobuf.StringValue.encode(message.trackingUrlTemplate, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.urlCustomParameters != null && message.urlCustomParameters.length)
                                for (var i = 0; i < message.urlCustomParameters.length; ++i)
                                    $root.google.ads.googleads.v1.common.CustomParameter.encode(message.urlCustomParameters[i], writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix"))
                                $root.google.protobuf.StringValue.encode(message.finalUrlSuffix, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified SitelinkFeedItem message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.SitelinkFeedItem.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.SitelinkFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.ISitelinkFeedItem} message SitelinkFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SitelinkFeedItem.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SitelinkFeedItem message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.SitelinkFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.SitelinkFeedItem} SitelinkFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SitelinkFeedItem.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.SitelinkFeedItem();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.linkText = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.line1 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.line2 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    if (!(message.finalUrls && message.finalUrls.length))
                                        message.finalUrls = [];
                                    message.finalUrls.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 5:
                                    if (!(message.finalMobileUrls && message.finalMobileUrls.length))
                                        message.finalMobileUrls = [];
                                    message.finalMobileUrls.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 6:
                                    message.trackingUrlTemplate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    if (!(message.urlCustomParameters && message.urlCustomParameters.length))
                                        message.urlCustomParameters = [];
                                    message.urlCustomParameters.push($root.google.ads.googleads.v1.common.CustomParameter.decode(reader, reader.uint32()));
                                    break;
                                case 8:
                                    message.finalUrlSuffix = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SitelinkFeedItem message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.SitelinkFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.SitelinkFeedItem} SitelinkFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SitelinkFeedItem.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SitelinkFeedItem message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.SitelinkFeedItem
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SitelinkFeedItem.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.linkText != null && message.hasOwnProperty("linkText")) {
                                var error = $root.google.protobuf.StringValue.verify(message.linkText);
                                if (error)
                                    return "linkText." + error;
                            }
                            if (message.line1 != null && message.hasOwnProperty("line1")) {
                                var error = $root.google.protobuf.StringValue.verify(message.line1);
                                if (error)
                                    return "line1." + error;
                            }
                            if (message.line2 != null && message.hasOwnProperty("line2")) {
                                var error = $root.google.protobuf.StringValue.verify(message.line2);
                                if (error)
                                    return "line2." + error;
                            }
                            if (message.finalUrls != null && message.hasOwnProperty("finalUrls")) {
                                if (!Array.isArray(message.finalUrls))
                                    return "finalUrls: array expected";
                                for (var i = 0; i < message.finalUrls.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.finalUrls[i]);
                                    if (error)
                                        return "finalUrls." + error;
                                }
                            }
                            if (message.finalMobileUrls != null && message.hasOwnProperty("finalMobileUrls")) {
                                if (!Array.isArray(message.finalMobileUrls))
                                    return "finalMobileUrls: array expected";
                                for (var i = 0; i < message.finalMobileUrls.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.finalMobileUrls[i]);
                                    if (error)
                                        return "finalMobileUrls." + error;
                                }
                            }
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.trackingUrlTemplate);
                                if (error)
                                    return "trackingUrlTemplate." + error;
                            }
                            if (message.urlCustomParameters != null && message.hasOwnProperty("urlCustomParameters")) {
                                if (!Array.isArray(message.urlCustomParameters))
                                    return "urlCustomParameters: array expected";
                                for (var i = 0; i < message.urlCustomParameters.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.CustomParameter.verify(message.urlCustomParameters[i]);
                                    if (error)
                                        return "urlCustomParameters." + error;
                                }
                            }
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix")) {
                                var error = $root.google.protobuf.StringValue.verify(message.finalUrlSuffix);
                                if (error)
                                    return "finalUrlSuffix." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a SitelinkFeedItem message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.SitelinkFeedItem
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.SitelinkFeedItem} SitelinkFeedItem
                         */
                        SitelinkFeedItem.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.SitelinkFeedItem)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.SitelinkFeedItem();
                            if (object.linkText != null) {
                                if (typeof object.linkText !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.SitelinkFeedItem.linkText: object expected");
                                message.linkText = $root.google.protobuf.StringValue.fromObject(object.linkText);
                            }
                            if (object.line1 != null) {
                                if (typeof object.line1 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.SitelinkFeedItem.line1: object expected");
                                message.line1 = $root.google.protobuf.StringValue.fromObject(object.line1);
                            }
                            if (object.line2 != null) {
                                if (typeof object.line2 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.SitelinkFeedItem.line2: object expected");
                                message.line2 = $root.google.protobuf.StringValue.fromObject(object.line2);
                            }
                            if (object.finalUrls) {
                                if (!Array.isArray(object.finalUrls))
                                    throw TypeError(".google.ads.googleads.v1.common.SitelinkFeedItem.finalUrls: array expected");
                                message.finalUrls = [];
                                for (var i = 0; i < object.finalUrls.length; ++i) {
                                    if (typeof object.finalUrls[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.SitelinkFeedItem.finalUrls: object expected");
                                    message.finalUrls[i] = $root.google.protobuf.StringValue.fromObject(object.finalUrls[i]);
                                }
                            }
                            if (object.finalMobileUrls) {
                                if (!Array.isArray(object.finalMobileUrls))
                                    throw TypeError(".google.ads.googleads.v1.common.SitelinkFeedItem.finalMobileUrls: array expected");
                                message.finalMobileUrls = [];
                                for (var i = 0; i < object.finalMobileUrls.length; ++i) {
                                    if (typeof object.finalMobileUrls[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.SitelinkFeedItem.finalMobileUrls: object expected");
                                    message.finalMobileUrls[i] = $root.google.protobuf.StringValue.fromObject(object.finalMobileUrls[i]);
                                }
                            }
                            if (object.trackingUrlTemplate != null) {
                                if (typeof object.trackingUrlTemplate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.SitelinkFeedItem.trackingUrlTemplate: object expected");
                                message.trackingUrlTemplate = $root.google.protobuf.StringValue.fromObject(object.trackingUrlTemplate);
                            }
                            if (object.urlCustomParameters) {
                                if (!Array.isArray(object.urlCustomParameters))
                                    throw TypeError(".google.ads.googleads.v1.common.SitelinkFeedItem.urlCustomParameters: array expected");
                                message.urlCustomParameters = [];
                                for (var i = 0; i < object.urlCustomParameters.length; ++i) {
                                    if (typeof object.urlCustomParameters[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.SitelinkFeedItem.urlCustomParameters: object expected");
                                    message.urlCustomParameters[i] = $root.google.ads.googleads.v1.common.CustomParameter.fromObject(object.urlCustomParameters[i]);
                                }
                            }
                            if (object.finalUrlSuffix != null) {
                                if (typeof object.finalUrlSuffix !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.SitelinkFeedItem.finalUrlSuffix: object expected");
                                message.finalUrlSuffix = $root.google.protobuf.StringValue.fromObject(object.finalUrlSuffix);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a SitelinkFeedItem message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.SitelinkFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.common.SitelinkFeedItem} message SitelinkFeedItem
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SitelinkFeedItem.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.finalUrls = [];
                                object.finalMobileUrls = [];
                                object.urlCustomParameters = [];
                            }
                            if (options.defaults) {
                                object.linkText = null;
                                object.line1 = null;
                                object.line2 = null;
                                object.trackingUrlTemplate = null;
                                object.finalUrlSuffix = null;
                            }
                            if (message.linkText != null && message.hasOwnProperty("linkText"))
                                object.linkText = $root.google.protobuf.StringValue.toObject(message.linkText, options);
                            if (message.line1 != null && message.hasOwnProperty("line1"))
                                object.line1 = $root.google.protobuf.StringValue.toObject(message.line1, options);
                            if (message.line2 != null && message.hasOwnProperty("line2"))
                                object.line2 = $root.google.protobuf.StringValue.toObject(message.line2, options);
                            if (message.finalUrls && message.finalUrls.length) {
                                object.finalUrls = [];
                                for (var j = 0; j < message.finalUrls.length; ++j)
                                    object.finalUrls[j] = $root.google.protobuf.StringValue.toObject(message.finalUrls[j], options);
                            }
                            if (message.finalMobileUrls && message.finalMobileUrls.length) {
                                object.finalMobileUrls = [];
                                for (var j = 0; j < message.finalMobileUrls.length; ++j)
                                    object.finalMobileUrls[j] = $root.google.protobuf.StringValue.toObject(message.finalMobileUrls[j], options);
                            }
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                object.trackingUrlTemplate = $root.google.protobuf.StringValue.toObject(message.trackingUrlTemplate, options);
                            if (message.urlCustomParameters && message.urlCustomParameters.length) {
                                object.urlCustomParameters = [];
                                for (var j = 0; j < message.urlCustomParameters.length; ++j)
                                    object.urlCustomParameters[j] = $root.google.ads.googleads.v1.common.CustomParameter.toObject(message.urlCustomParameters[j], options);
                            }
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix"))
                                object.finalUrlSuffix = $root.google.protobuf.StringValue.toObject(message.finalUrlSuffix, options);
                            return object;
                        };

                        /**
                         * Converts this SitelinkFeedItem to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.SitelinkFeedItem
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SitelinkFeedItem.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return SitelinkFeedItem;
                    })();

                    common.Money = (function() {

                        /**
                         * Properties of a Money.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IMoney
                         * @property {google.protobuf.IStringValue|null} [currencyCode] Money currencyCode
                         * @property {google.protobuf.IInt64Value|null} [amountMicros] Money amountMicros
                         */

                        /**
                         * Constructs a new Money.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a Money.
                         * @implements IMoney
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IMoney=} [properties] Properties to set
                         */
                        function Money(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Money currencyCode.
                         * @member {google.protobuf.IStringValue|null|undefined} currencyCode
                         * @memberof google.ads.googleads.v1.common.Money
                         * @instance
                         */
                        Money.prototype.currencyCode = null;

                        /**
                         * Money amountMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} amountMicros
                         * @memberof google.ads.googleads.v1.common.Money
                         * @instance
                         */
                        Money.prototype.amountMicros = null;

                        /**
                         * Creates a new Money instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.Money
                         * @static
                         * @param {google.ads.googleads.v1.common.IMoney=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.Money} Money instance
                         */
                        Money.create = function create(properties) {
                            return new Money(properties);
                        };

                        /**
                         * Encodes the specified Money message. Does not implicitly {@link google.ads.googleads.v1.common.Money.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.Money
                         * @static
                         * @param {google.ads.googleads.v1.common.IMoney} message Money message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Money.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode"))
                                $root.google.protobuf.StringValue.encode(message.currencyCode, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.amountMicros != null && message.hasOwnProperty("amountMicros"))
                                $root.google.protobuf.Int64Value.encode(message.amountMicros, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified Money message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.Money.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.Money
                         * @static
                         * @param {google.ads.googleads.v1.common.IMoney} message Money message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Money.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a Money message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.Money
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.Money} Money
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Money.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.Money();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.currencyCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.amountMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a Money message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.Money
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.Money} Money
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Money.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a Money message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.Money
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Money.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.currencyCode);
                                if (error)
                                    return "currencyCode." + error;
                            }
                            if (message.amountMicros != null && message.hasOwnProperty("amountMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.amountMicros);
                                if (error)
                                    return "amountMicros." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a Money message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.Money
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.Money} Money
                         */
                        Money.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.Money)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.Money();
                            if (object.currencyCode != null) {
                                if (typeof object.currencyCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Money.currencyCode: object expected");
                                message.currencyCode = $root.google.protobuf.StringValue.fromObject(object.currencyCode);
                            }
                            if (object.amountMicros != null) {
                                if (typeof object.amountMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Money.amountMicros: object expected");
                                message.amountMicros = $root.google.protobuf.Int64Value.fromObject(object.amountMicros);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a Money message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.Money
                         * @static
                         * @param {google.ads.googleads.v1.common.Money} message Money
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Money.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.currencyCode = null;
                                object.amountMicros = null;
                            }
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode"))
                                object.currencyCode = $root.google.protobuf.StringValue.toObject(message.currencyCode, options);
                            if (message.amountMicros != null && message.hasOwnProperty("amountMicros"))
                                object.amountMicros = $root.google.protobuf.Int64Value.toObject(message.amountMicros, options);
                            return object;
                        };

                        /**
                         * Converts this Money to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.Money
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Money.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return Money;
                    })();

                    common.FinalAppUrl = (function() {

                        /**
                         * Properties of a FinalAppUrl.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IFinalAppUrl
                         * @property {google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum.AppUrlOperatingSystemType|null} [osType] FinalAppUrl osType
                         * @property {google.protobuf.IStringValue|null} [url] FinalAppUrl url
                         */

                        /**
                         * Constructs a new FinalAppUrl.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a FinalAppUrl.
                         * @implements IFinalAppUrl
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IFinalAppUrl=} [properties] Properties to set
                         */
                        function FinalAppUrl(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * FinalAppUrl osType.
                         * @member {google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum.AppUrlOperatingSystemType} osType
                         * @memberof google.ads.googleads.v1.common.FinalAppUrl
                         * @instance
                         */
                        FinalAppUrl.prototype.osType = 0;

                        /**
                         * FinalAppUrl url.
                         * @member {google.protobuf.IStringValue|null|undefined} url
                         * @memberof google.ads.googleads.v1.common.FinalAppUrl
                         * @instance
                         */
                        FinalAppUrl.prototype.url = null;

                        /**
                         * Creates a new FinalAppUrl instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.FinalAppUrl
                         * @static
                         * @param {google.ads.googleads.v1.common.IFinalAppUrl=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.FinalAppUrl} FinalAppUrl instance
                         */
                        FinalAppUrl.create = function create(properties) {
                            return new FinalAppUrl(properties);
                        };

                        /**
                         * Encodes the specified FinalAppUrl message. Does not implicitly {@link google.ads.googleads.v1.common.FinalAppUrl.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.FinalAppUrl
                         * @static
                         * @param {google.ads.googleads.v1.common.IFinalAppUrl} message FinalAppUrl message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FinalAppUrl.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.osType != null && message.hasOwnProperty("osType"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.osType);
                            if (message.url != null && message.hasOwnProperty("url"))
                                $root.google.protobuf.StringValue.encode(message.url, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified FinalAppUrl message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.FinalAppUrl.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.FinalAppUrl
                         * @static
                         * @param {google.ads.googleads.v1.common.IFinalAppUrl} message FinalAppUrl message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FinalAppUrl.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FinalAppUrl message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.FinalAppUrl
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.FinalAppUrl} FinalAppUrl
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FinalAppUrl.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.FinalAppUrl();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.osType = reader.int32();
                                    break;
                                case 2:
                                    message.url = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FinalAppUrl message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.FinalAppUrl
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.FinalAppUrl} FinalAppUrl
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FinalAppUrl.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FinalAppUrl message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.FinalAppUrl
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FinalAppUrl.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.osType != null && message.hasOwnProperty("osType"))
                                switch (message.osType) {
                                default:
                                    return "osType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.url != null && message.hasOwnProperty("url")) {
                                var error = $root.google.protobuf.StringValue.verify(message.url);
                                if (error)
                                    return "url." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a FinalAppUrl message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.FinalAppUrl
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.FinalAppUrl} FinalAppUrl
                         */
                        FinalAppUrl.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.FinalAppUrl)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.FinalAppUrl();
                            switch (object.osType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.osType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.osType = 1;
                                break;
                            case "IOS":
                            case 2:
                                message.osType = 2;
                                break;
                            case "ANDROID":
                            case 3:
                                message.osType = 3;
                                break;
                            }
                            if (object.url != null) {
                                if (typeof object.url !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.FinalAppUrl.url: object expected");
                                message.url = $root.google.protobuf.StringValue.fromObject(object.url);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a FinalAppUrl message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.FinalAppUrl
                         * @static
                         * @param {google.ads.googleads.v1.common.FinalAppUrl} message FinalAppUrl
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FinalAppUrl.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.osType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.url = null;
                            }
                            if (message.osType != null && message.hasOwnProperty("osType"))
                                object.osType = options.enums === String ? $root.google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum.AppUrlOperatingSystemType[message.osType] : message.osType;
                            if (message.url != null && message.hasOwnProperty("url"))
                                object.url = $root.google.protobuf.StringValue.toObject(message.url, options);
                            return object;
                        };

                        /**
                         * Converts this FinalAppUrl to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.FinalAppUrl
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FinalAppUrl.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return FinalAppUrl;
                    })();

                    common.FrequencyCapEntry = (function() {

                        /**
                         * Properties of a FrequencyCapEntry.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IFrequencyCapEntry
                         * @property {google.ads.googleads.v1.common.IFrequencyCapKey|null} [key] FrequencyCapEntry key
                         * @property {google.protobuf.IInt32Value|null} [cap] FrequencyCapEntry cap
                         */

                        /**
                         * Constructs a new FrequencyCapEntry.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a FrequencyCapEntry.
                         * @implements IFrequencyCapEntry
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IFrequencyCapEntry=} [properties] Properties to set
                         */
                        function FrequencyCapEntry(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * FrequencyCapEntry key.
                         * @member {google.ads.googleads.v1.common.IFrequencyCapKey|null|undefined} key
                         * @memberof google.ads.googleads.v1.common.FrequencyCapEntry
                         * @instance
                         */
                        FrequencyCapEntry.prototype.key = null;

                        /**
                         * FrequencyCapEntry cap.
                         * @member {google.protobuf.IInt32Value|null|undefined} cap
                         * @memberof google.ads.googleads.v1.common.FrequencyCapEntry
                         * @instance
                         */
                        FrequencyCapEntry.prototype.cap = null;

                        /**
                         * Creates a new FrequencyCapEntry instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.FrequencyCapEntry
                         * @static
                         * @param {google.ads.googleads.v1.common.IFrequencyCapEntry=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.FrequencyCapEntry} FrequencyCapEntry instance
                         */
                        FrequencyCapEntry.create = function create(properties) {
                            return new FrequencyCapEntry(properties);
                        };

                        /**
                         * Encodes the specified FrequencyCapEntry message. Does not implicitly {@link google.ads.googleads.v1.common.FrequencyCapEntry.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.FrequencyCapEntry
                         * @static
                         * @param {google.ads.googleads.v1.common.IFrequencyCapEntry} message FrequencyCapEntry message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FrequencyCapEntry.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.key != null && message.hasOwnProperty("key"))
                                $root.google.ads.googleads.v1.common.FrequencyCapKey.encode(message.key, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.cap != null && message.hasOwnProperty("cap"))
                                $root.google.protobuf.Int32Value.encode(message.cap, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified FrequencyCapEntry message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.FrequencyCapEntry.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.FrequencyCapEntry
                         * @static
                         * @param {google.ads.googleads.v1.common.IFrequencyCapEntry} message FrequencyCapEntry message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FrequencyCapEntry.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FrequencyCapEntry message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.FrequencyCapEntry
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.FrequencyCapEntry} FrequencyCapEntry
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FrequencyCapEntry.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.FrequencyCapEntry();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.key = $root.google.ads.googleads.v1.common.FrequencyCapKey.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.cap = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FrequencyCapEntry message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.FrequencyCapEntry
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.FrequencyCapEntry} FrequencyCapEntry
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FrequencyCapEntry.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FrequencyCapEntry message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.FrequencyCapEntry
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FrequencyCapEntry.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.key != null && message.hasOwnProperty("key")) {
                                var error = $root.google.ads.googleads.v1.common.FrequencyCapKey.verify(message.key);
                                if (error)
                                    return "key." + error;
                            }
                            if (message.cap != null && message.hasOwnProperty("cap")) {
                                var error = $root.google.protobuf.Int32Value.verify(message.cap);
                                if (error)
                                    return "cap." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a FrequencyCapEntry message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.FrequencyCapEntry
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.FrequencyCapEntry} FrequencyCapEntry
                         */
                        FrequencyCapEntry.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.FrequencyCapEntry)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.FrequencyCapEntry();
                            if (object.key != null) {
                                if (typeof object.key !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.FrequencyCapEntry.key: object expected");
                                message.key = $root.google.ads.googleads.v1.common.FrequencyCapKey.fromObject(object.key);
                            }
                            if (object.cap != null) {
                                if (typeof object.cap !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.FrequencyCapEntry.cap: object expected");
                                message.cap = $root.google.protobuf.Int32Value.fromObject(object.cap);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a FrequencyCapEntry message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.FrequencyCapEntry
                         * @static
                         * @param {google.ads.googleads.v1.common.FrequencyCapEntry} message FrequencyCapEntry
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FrequencyCapEntry.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.key = null;
                                object.cap = null;
                            }
                            if (message.key != null && message.hasOwnProperty("key"))
                                object.key = $root.google.ads.googleads.v1.common.FrequencyCapKey.toObject(message.key, options);
                            if (message.cap != null && message.hasOwnProperty("cap"))
                                object.cap = $root.google.protobuf.Int32Value.toObject(message.cap, options);
                            return object;
                        };

                        /**
                         * Converts this FrequencyCapEntry to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.FrequencyCapEntry
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FrequencyCapEntry.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return FrequencyCapEntry;
                    })();

                    common.FrequencyCapKey = (function() {

                        /**
                         * Properties of a FrequencyCapKey.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IFrequencyCapKey
                         * @property {google.ads.googleads.v1.enums.FrequencyCapLevelEnum.FrequencyCapLevel|null} [level] FrequencyCapKey level
                         * @property {google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum.FrequencyCapEventType|null} [eventType] FrequencyCapKey eventType
                         * @property {google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum.FrequencyCapTimeUnit|null} [timeUnit] FrequencyCapKey timeUnit
                         * @property {google.protobuf.IInt32Value|null} [timeLength] FrequencyCapKey timeLength
                         */

                        /**
                         * Constructs a new FrequencyCapKey.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a FrequencyCapKey.
                         * @implements IFrequencyCapKey
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IFrequencyCapKey=} [properties] Properties to set
                         */
                        function FrequencyCapKey(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * FrequencyCapKey level.
                         * @member {google.ads.googleads.v1.enums.FrequencyCapLevelEnum.FrequencyCapLevel} level
                         * @memberof google.ads.googleads.v1.common.FrequencyCapKey
                         * @instance
                         */
                        FrequencyCapKey.prototype.level = 0;

                        /**
                         * FrequencyCapKey eventType.
                         * @member {google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum.FrequencyCapEventType} eventType
                         * @memberof google.ads.googleads.v1.common.FrequencyCapKey
                         * @instance
                         */
                        FrequencyCapKey.prototype.eventType = 0;

                        /**
                         * FrequencyCapKey timeUnit.
                         * @member {google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum.FrequencyCapTimeUnit} timeUnit
                         * @memberof google.ads.googleads.v1.common.FrequencyCapKey
                         * @instance
                         */
                        FrequencyCapKey.prototype.timeUnit = 0;

                        /**
                         * FrequencyCapKey timeLength.
                         * @member {google.protobuf.IInt32Value|null|undefined} timeLength
                         * @memberof google.ads.googleads.v1.common.FrequencyCapKey
                         * @instance
                         */
                        FrequencyCapKey.prototype.timeLength = null;

                        /**
                         * Creates a new FrequencyCapKey instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.FrequencyCapKey
                         * @static
                         * @param {google.ads.googleads.v1.common.IFrequencyCapKey=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.FrequencyCapKey} FrequencyCapKey instance
                         */
                        FrequencyCapKey.create = function create(properties) {
                            return new FrequencyCapKey(properties);
                        };

                        /**
                         * Encodes the specified FrequencyCapKey message. Does not implicitly {@link google.ads.googleads.v1.common.FrequencyCapKey.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.FrequencyCapKey
                         * @static
                         * @param {google.ads.googleads.v1.common.IFrequencyCapKey} message FrequencyCapKey message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FrequencyCapKey.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.level != null && message.hasOwnProperty("level"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.level);
                            if (message.timeUnit != null && message.hasOwnProperty("timeUnit"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.timeUnit);
                            if (message.eventType != null && message.hasOwnProperty("eventType"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.eventType);
                            if (message.timeLength != null && message.hasOwnProperty("timeLength"))
                                $root.google.protobuf.Int32Value.encode(message.timeLength, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified FrequencyCapKey message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.FrequencyCapKey.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.FrequencyCapKey
                         * @static
                         * @param {google.ads.googleads.v1.common.IFrequencyCapKey} message FrequencyCapKey message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FrequencyCapKey.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FrequencyCapKey message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.FrequencyCapKey
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.FrequencyCapKey} FrequencyCapKey
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FrequencyCapKey.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.FrequencyCapKey();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.level = reader.int32();
                                    break;
                                case 3:
                                    message.eventType = reader.int32();
                                    break;
                                case 2:
                                    message.timeUnit = reader.int32();
                                    break;
                                case 4:
                                    message.timeLength = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FrequencyCapKey message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.FrequencyCapKey
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.FrequencyCapKey} FrequencyCapKey
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FrequencyCapKey.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FrequencyCapKey message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.FrequencyCapKey
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FrequencyCapKey.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.level != null && message.hasOwnProperty("level"))
                                switch (message.level) {
                                default:
                                    return "level: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.eventType != null && message.hasOwnProperty("eventType"))
                                switch (message.eventType) {
                                default:
                                    return "eventType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.timeUnit != null && message.hasOwnProperty("timeUnit"))
                                switch (message.timeUnit) {
                                default:
                                    return "timeUnit: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.timeLength != null && message.hasOwnProperty("timeLength")) {
                                var error = $root.google.protobuf.Int32Value.verify(message.timeLength);
                                if (error)
                                    return "timeLength." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a FrequencyCapKey message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.FrequencyCapKey
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.FrequencyCapKey} FrequencyCapKey
                         */
                        FrequencyCapKey.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.FrequencyCapKey)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.FrequencyCapKey();
                            switch (object.level) {
                            case "UNSPECIFIED":
                            case 0:
                                message.level = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.level = 1;
                                break;
                            case "AD_GROUP_AD":
                            case 2:
                                message.level = 2;
                                break;
                            case "AD_GROUP":
                            case 3:
                                message.level = 3;
                                break;
                            case "CAMPAIGN":
                            case 4:
                                message.level = 4;
                                break;
                            }
                            switch (object.eventType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.eventType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.eventType = 1;
                                break;
                            case "IMPRESSION":
                            case 2:
                                message.eventType = 2;
                                break;
                            case "VIDEO_VIEW":
                            case 3:
                                message.eventType = 3;
                                break;
                            }
                            switch (object.timeUnit) {
                            case "UNSPECIFIED":
                            case 0:
                                message.timeUnit = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.timeUnit = 1;
                                break;
                            case "DAY":
                            case 2:
                                message.timeUnit = 2;
                                break;
                            case "WEEK":
                            case 3:
                                message.timeUnit = 3;
                                break;
                            case "MONTH":
                            case 4:
                                message.timeUnit = 4;
                                break;
                            }
                            if (object.timeLength != null) {
                                if (typeof object.timeLength !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.FrequencyCapKey.timeLength: object expected");
                                message.timeLength = $root.google.protobuf.Int32Value.fromObject(object.timeLength);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a FrequencyCapKey message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.FrequencyCapKey
                         * @static
                         * @param {google.ads.googleads.v1.common.FrequencyCapKey} message FrequencyCapKey
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FrequencyCapKey.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.level = options.enums === String ? "UNSPECIFIED" : 0;
                                object.timeUnit = options.enums === String ? "UNSPECIFIED" : 0;
                                object.eventType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.timeLength = null;
                            }
                            if (message.level != null && message.hasOwnProperty("level"))
                                object.level = options.enums === String ? $root.google.ads.googleads.v1.enums.FrequencyCapLevelEnum.FrequencyCapLevel[message.level] : message.level;
                            if (message.timeUnit != null && message.hasOwnProperty("timeUnit"))
                                object.timeUnit = options.enums === String ? $root.google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum.FrequencyCapTimeUnit[message.timeUnit] : message.timeUnit;
                            if (message.eventType != null && message.hasOwnProperty("eventType"))
                                object.eventType = options.enums === String ? $root.google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum.FrequencyCapEventType[message.eventType] : message.eventType;
                            if (message.timeLength != null && message.hasOwnProperty("timeLength"))
                                object.timeLength = $root.google.protobuf.Int32Value.toObject(message.timeLength, options);
                            return object;
                        };

                        /**
                         * Converts this FrequencyCapKey to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.FrequencyCapKey
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FrequencyCapKey.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return FrequencyCapKey;
                    })();

                    common.KeywordPlanHistoricalMetrics = (function() {

                        /**
                         * Properties of a KeywordPlanHistoricalMetrics.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IKeywordPlanHistoricalMetrics
                         * @property {google.protobuf.IInt64Value|null} [avgMonthlySearches] KeywordPlanHistoricalMetrics avgMonthlySearches
                         * @property {google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum.KeywordPlanCompetitionLevel|null} [competition] KeywordPlanHistoricalMetrics competition
                         */

                        /**
                         * Constructs a new KeywordPlanHistoricalMetrics.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a KeywordPlanHistoricalMetrics.
                         * @implements IKeywordPlanHistoricalMetrics
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IKeywordPlanHistoricalMetrics=} [properties] Properties to set
                         */
                        function KeywordPlanHistoricalMetrics(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordPlanHistoricalMetrics avgMonthlySearches.
                         * @member {google.protobuf.IInt64Value|null|undefined} avgMonthlySearches
                         * @memberof google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics
                         * @instance
                         */
                        KeywordPlanHistoricalMetrics.prototype.avgMonthlySearches = null;

                        /**
                         * KeywordPlanHistoricalMetrics competition.
                         * @member {google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum.KeywordPlanCompetitionLevel} competition
                         * @memberof google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics
                         * @instance
                         */
                        KeywordPlanHistoricalMetrics.prototype.competition = 0;

                        /**
                         * Creates a new KeywordPlanHistoricalMetrics instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics
                         * @static
                         * @param {google.ads.googleads.v1.common.IKeywordPlanHistoricalMetrics=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics} KeywordPlanHistoricalMetrics instance
                         */
                        KeywordPlanHistoricalMetrics.create = function create(properties) {
                            return new KeywordPlanHistoricalMetrics(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanHistoricalMetrics message. Does not implicitly {@link google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics
                         * @static
                         * @param {google.ads.googleads.v1.common.IKeywordPlanHistoricalMetrics} message KeywordPlanHistoricalMetrics message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanHistoricalMetrics.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.avgMonthlySearches != null && message.hasOwnProperty("avgMonthlySearches"))
                                $root.google.protobuf.Int64Value.encode(message.avgMonthlySearches, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.competition != null && message.hasOwnProperty("competition"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.competition);
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanHistoricalMetrics message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics
                         * @static
                         * @param {google.ads.googleads.v1.common.IKeywordPlanHistoricalMetrics} message KeywordPlanHistoricalMetrics message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanHistoricalMetrics.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanHistoricalMetrics message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics} KeywordPlanHistoricalMetrics
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanHistoricalMetrics.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.avgMonthlySearches = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.competition = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanHistoricalMetrics message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics} KeywordPlanHistoricalMetrics
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanHistoricalMetrics.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanHistoricalMetrics message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanHistoricalMetrics.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.avgMonthlySearches != null && message.hasOwnProperty("avgMonthlySearches")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.avgMonthlySearches);
                                if (error)
                                    return "avgMonthlySearches." + error;
                            }
                            if (message.competition != null && message.hasOwnProperty("competition"))
                                switch (message.competition) {
                                default:
                                    return "competition: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanHistoricalMetrics message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics} KeywordPlanHistoricalMetrics
                         */
                        KeywordPlanHistoricalMetrics.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics();
                            if (object.avgMonthlySearches != null) {
                                if (typeof object.avgMonthlySearches !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics.avgMonthlySearches: object expected");
                                message.avgMonthlySearches = $root.google.protobuf.Int64Value.fromObject(object.avgMonthlySearches);
                            }
                            switch (object.competition) {
                            case "UNSPECIFIED":
                            case 0:
                                message.competition = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.competition = 1;
                                break;
                            case "LOW":
                            case 2:
                                message.competition = 2;
                                break;
                            case "MEDIUM":
                            case 3:
                                message.competition = 3;
                                break;
                            case "HIGH":
                            case 4:
                                message.competition = 4;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordPlanHistoricalMetrics message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics
                         * @static
                         * @param {google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics} message KeywordPlanHistoricalMetrics
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanHistoricalMetrics.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.avgMonthlySearches = null;
                                object.competition = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.avgMonthlySearches != null && message.hasOwnProperty("avgMonthlySearches"))
                                object.avgMonthlySearches = $root.google.protobuf.Int64Value.toObject(message.avgMonthlySearches, options);
                            if (message.competition != null && message.hasOwnProperty("competition"))
                                object.competition = options.enums === String ? $root.google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum.KeywordPlanCompetitionLevel[message.competition] : message.competition;
                            return object;
                        };

                        /**
                         * Converts this KeywordPlanHistoricalMetrics to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanHistoricalMetrics.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordPlanHistoricalMetrics;
                    })();

                    common.MatchingFunction = (function() {

                        /**
                         * Properties of a MatchingFunction.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IMatchingFunction
                         * @property {google.protobuf.IStringValue|null} [functionString] MatchingFunction functionString
                         * @property {google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum.MatchingFunctionOperator|null} [operator] MatchingFunction operator
                         * @property {Array.<google.ads.googleads.v1.common.IOperand>|null} [leftOperands] MatchingFunction leftOperands
                         * @property {Array.<google.ads.googleads.v1.common.IOperand>|null} [rightOperands] MatchingFunction rightOperands
                         */

                        /**
                         * Constructs a new MatchingFunction.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a MatchingFunction.
                         * @implements IMatchingFunction
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IMatchingFunction=} [properties] Properties to set
                         */
                        function MatchingFunction(properties) {
                            this.leftOperands = [];
                            this.rightOperands = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MatchingFunction functionString.
                         * @member {google.protobuf.IStringValue|null|undefined} functionString
                         * @memberof google.ads.googleads.v1.common.MatchingFunction
                         * @instance
                         */
                        MatchingFunction.prototype.functionString = null;

                        /**
                         * MatchingFunction operator.
                         * @member {google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum.MatchingFunctionOperator} operator
                         * @memberof google.ads.googleads.v1.common.MatchingFunction
                         * @instance
                         */
                        MatchingFunction.prototype.operator = 0;

                        /**
                         * MatchingFunction leftOperands.
                         * @member {Array.<google.ads.googleads.v1.common.IOperand>} leftOperands
                         * @memberof google.ads.googleads.v1.common.MatchingFunction
                         * @instance
                         */
                        MatchingFunction.prototype.leftOperands = $util.emptyArray;

                        /**
                         * MatchingFunction rightOperands.
                         * @member {Array.<google.ads.googleads.v1.common.IOperand>} rightOperands
                         * @memberof google.ads.googleads.v1.common.MatchingFunction
                         * @instance
                         */
                        MatchingFunction.prototype.rightOperands = $util.emptyArray;

                        /**
                         * Creates a new MatchingFunction instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.MatchingFunction
                         * @static
                         * @param {google.ads.googleads.v1.common.IMatchingFunction=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.MatchingFunction} MatchingFunction instance
                         */
                        MatchingFunction.create = function create(properties) {
                            return new MatchingFunction(properties);
                        };

                        /**
                         * Encodes the specified MatchingFunction message. Does not implicitly {@link google.ads.googleads.v1.common.MatchingFunction.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.MatchingFunction
                         * @static
                         * @param {google.ads.googleads.v1.common.IMatchingFunction} message MatchingFunction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MatchingFunction.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.functionString != null && message.hasOwnProperty("functionString"))
                                $root.google.protobuf.StringValue.encode(message.functionString, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.leftOperands != null && message.leftOperands.length)
                                for (var i = 0; i < message.leftOperands.length; ++i)
                                    $root.google.ads.googleads.v1.common.Operand.encode(message.leftOperands[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.rightOperands != null && message.rightOperands.length)
                                for (var i = 0; i < message.rightOperands.length; ++i)
                                    $root.google.ads.googleads.v1.common.Operand.encode(message.rightOperands[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.operator);
                            return writer;
                        };

                        /**
                         * Encodes the specified MatchingFunction message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.MatchingFunction.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.MatchingFunction
                         * @static
                         * @param {google.ads.googleads.v1.common.IMatchingFunction} message MatchingFunction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MatchingFunction.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MatchingFunction message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.MatchingFunction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.MatchingFunction} MatchingFunction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MatchingFunction.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.MatchingFunction();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.functionString = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.operator = reader.int32();
                                    break;
                                case 2:
                                    if (!(message.leftOperands && message.leftOperands.length))
                                        message.leftOperands = [];
                                    message.leftOperands.push($root.google.ads.googleads.v1.common.Operand.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    if (!(message.rightOperands && message.rightOperands.length))
                                        message.rightOperands = [];
                                    message.rightOperands.push($root.google.ads.googleads.v1.common.Operand.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MatchingFunction message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.MatchingFunction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.MatchingFunction} MatchingFunction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MatchingFunction.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MatchingFunction message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.MatchingFunction
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MatchingFunction.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.functionString != null && message.hasOwnProperty("functionString")) {
                                var error = $root.google.protobuf.StringValue.verify(message.functionString);
                                if (error)
                                    return "functionString." + error;
                            }
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                switch (message.operator) {
                                default:
                                    return "operator: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            if (message.leftOperands != null && message.hasOwnProperty("leftOperands")) {
                                if (!Array.isArray(message.leftOperands))
                                    return "leftOperands: array expected";
                                for (var i = 0; i < message.leftOperands.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.Operand.verify(message.leftOperands[i]);
                                    if (error)
                                        return "leftOperands." + error;
                                }
                            }
                            if (message.rightOperands != null && message.hasOwnProperty("rightOperands")) {
                                if (!Array.isArray(message.rightOperands))
                                    return "rightOperands: array expected";
                                for (var i = 0; i < message.rightOperands.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.Operand.verify(message.rightOperands[i]);
                                    if (error)
                                        return "rightOperands." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MatchingFunction message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.MatchingFunction
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.MatchingFunction} MatchingFunction
                         */
                        MatchingFunction.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.MatchingFunction)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.MatchingFunction();
                            if (object.functionString != null) {
                                if (typeof object.functionString !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.MatchingFunction.functionString: object expected");
                                message.functionString = $root.google.protobuf.StringValue.fromObject(object.functionString);
                            }
                            switch (object.operator) {
                            case "UNSPECIFIED":
                            case 0:
                                message.operator = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.operator = 1;
                                break;
                            case "IN":
                            case 2:
                                message.operator = 2;
                                break;
                            case "IDENTITY":
                            case 3:
                                message.operator = 3;
                                break;
                            case "EQUALS":
                            case 4:
                                message.operator = 4;
                                break;
                            case "AND":
                            case 5:
                                message.operator = 5;
                                break;
                            case "CONTAINS_ANY":
                            case 6:
                                message.operator = 6;
                                break;
                            }
                            if (object.leftOperands) {
                                if (!Array.isArray(object.leftOperands))
                                    throw TypeError(".google.ads.googleads.v1.common.MatchingFunction.leftOperands: array expected");
                                message.leftOperands = [];
                                for (var i = 0; i < object.leftOperands.length; ++i) {
                                    if (typeof object.leftOperands[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.MatchingFunction.leftOperands: object expected");
                                    message.leftOperands[i] = $root.google.ads.googleads.v1.common.Operand.fromObject(object.leftOperands[i]);
                                }
                            }
                            if (object.rightOperands) {
                                if (!Array.isArray(object.rightOperands))
                                    throw TypeError(".google.ads.googleads.v1.common.MatchingFunction.rightOperands: array expected");
                                message.rightOperands = [];
                                for (var i = 0; i < object.rightOperands.length; ++i) {
                                    if (typeof object.rightOperands[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.MatchingFunction.rightOperands: object expected");
                                    message.rightOperands[i] = $root.google.ads.googleads.v1.common.Operand.fromObject(object.rightOperands[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MatchingFunction message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.MatchingFunction
                         * @static
                         * @param {google.ads.googleads.v1.common.MatchingFunction} message MatchingFunction
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MatchingFunction.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.leftOperands = [];
                                object.rightOperands = [];
                            }
                            if (options.defaults) {
                                object.functionString = null;
                                object.operator = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.functionString != null && message.hasOwnProperty("functionString"))
                                object.functionString = $root.google.protobuf.StringValue.toObject(message.functionString, options);
                            if (message.leftOperands && message.leftOperands.length) {
                                object.leftOperands = [];
                                for (var j = 0; j < message.leftOperands.length; ++j)
                                    object.leftOperands[j] = $root.google.ads.googleads.v1.common.Operand.toObject(message.leftOperands[j], options);
                            }
                            if (message.rightOperands && message.rightOperands.length) {
                                object.rightOperands = [];
                                for (var j = 0; j < message.rightOperands.length; ++j)
                                    object.rightOperands[j] = $root.google.ads.googleads.v1.common.Operand.toObject(message.rightOperands[j], options);
                            }
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                object.operator = options.enums === String ? $root.google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum.MatchingFunctionOperator[message.operator] : message.operator;
                            return object;
                        };

                        /**
                         * Converts this MatchingFunction to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.MatchingFunction
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MatchingFunction.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MatchingFunction;
                    })();

                    common.Operand = (function() {

                        /**
                         * Properties of an Operand.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IOperand
                         * @property {google.ads.googleads.v1.common.Operand.IConstantOperand|null} [constantOperand] Operand constantOperand
                         * @property {google.ads.googleads.v1.common.Operand.IFeedAttributeOperand|null} [feedAttributeOperand] Operand feedAttributeOperand
                         * @property {google.ads.googleads.v1.common.Operand.IFunctionOperand|null} [functionOperand] Operand functionOperand
                         * @property {google.ads.googleads.v1.common.Operand.IRequestContextOperand|null} [requestContextOperand] Operand requestContextOperand
                         */

                        /**
                         * Constructs a new Operand.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an Operand.
                         * @implements IOperand
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IOperand=} [properties] Properties to set
                         */
                        function Operand(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Operand constantOperand.
                         * @member {google.ads.googleads.v1.common.Operand.IConstantOperand|null|undefined} constantOperand
                         * @memberof google.ads.googleads.v1.common.Operand
                         * @instance
                         */
                        Operand.prototype.constantOperand = null;

                        /**
                         * Operand feedAttributeOperand.
                         * @member {google.ads.googleads.v1.common.Operand.IFeedAttributeOperand|null|undefined} feedAttributeOperand
                         * @memberof google.ads.googleads.v1.common.Operand
                         * @instance
                         */
                        Operand.prototype.feedAttributeOperand = null;

                        /**
                         * Operand functionOperand.
                         * @member {google.ads.googleads.v1.common.Operand.IFunctionOperand|null|undefined} functionOperand
                         * @memberof google.ads.googleads.v1.common.Operand
                         * @instance
                         */
                        Operand.prototype.functionOperand = null;

                        /**
                         * Operand requestContextOperand.
                         * @member {google.ads.googleads.v1.common.Operand.IRequestContextOperand|null|undefined} requestContextOperand
                         * @memberof google.ads.googleads.v1.common.Operand
                         * @instance
                         */
                        Operand.prototype.requestContextOperand = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * Operand functionArgumentOperand.
                         * @member {"constantOperand"|"feedAttributeOperand"|"functionOperand"|"requestContextOperand"|undefined} functionArgumentOperand
                         * @memberof google.ads.googleads.v1.common.Operand
                         * @instance
                         */
                        Object.defineProperty(Operand.prototype, "functionArgumentOperand", {
                            get: $util.oneOfGetter($oneOfFields = ["constantOperand", "feedAttributeOperand", "functionOperand", "requestContextOperand"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new Operand instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.Operand
                         * @static
                         * @param {google.ads.googleads.v1.common.IOperand=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.Operand} Operand instance
                         */
                        Operand.create = function create(properties) {
                            return new Operand(properties);
                        };

                        /**
                         * Encodes the specified Operand message. Does not implicitly {@link google.ads.googleads.v1.common.Operand.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.Operand
                         * @static
                         * @param {google.ads.googleads.v1.common.IOperand} message Operand message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Operand.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.constantOperand != null && message.hasOwnProperty("constantOperand"))
                                $root.google.ads.googleads.v1.common.Operand.ConstantOperand.encode(message.constantOperand, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.feedAttributeOperand != null && message.hasOwnProperty("feedAttributeOperand"))
                                $root.google.ads.googleads.v1.common.Operand.FeedAttributeOperand.encode(message.feedAttributeOperand, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.functionOperand != null && message.hasOwnProperty("functionOperand"))
                                $root.google.ads.googleads.v1.common.Operand.FunctionOperand.encode(message.functionOperand, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.requestContextOperand != null && message.hasOwnProperty("requestContextOperand"))
                                $root.google.ads.googleads.v1.common.Operand.RequestContextOperand.encode(message.requestContextOperand, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified Operand message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.Operand.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.Operand
                         * @static
                         * @param {google.ads.googleads.v1.common.IOperand} message Operand message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Operand.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an Operand message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.Operand
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.Operand} Operand
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Operand.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.Operand();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.constantOperand = $root.google.ads.googleads.v1.common.Operand.ConstantOperand.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.feedAttributeOperand = $root.google.ads.googleads.v1.common.Operand.FeedAttributeOperand.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.functionOperand = $root.google.ads.googleads.v1.common.Operand.FunctionOperand.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.requestContextOperand = $root.google.ads.googleads.v1.common.Operand.RequestContextOperand.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an Operand message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.Operand
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.Operand} Operand
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Operand.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an Operand message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.Operand
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Operand.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.constantOperand != null && message.hasOwnProperty("constantOperand")) {
                                properties.functionArgumentOperand = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.Operand.ConstantOperand.verify(message.constantOperand);
                                    if (error)
                                        return "constantOperand." + error;
                                }
                            }
                            if (message.feedAttributeOperand != null && message.hasOwnProperty("feedAttributeOperand")) {
                                if (properties.functionArgumentOperand === 1)
                                    return "functionArgumentOperand: multiple values";
                                properties.functionArgumentOperand = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.Operand.FeedAttributeOperand.verify(message.feedAttributeOperand);
                                    if (error)
                                        return "feedAttributeOperand." + error;
                                }
                            }
                            if (message.functionOperand != null && message.hasOwnProperty("functionOperand")) {
                                if (properties.functionArgumentOperand === 1)
                                    return "functionArgumentOperand: multiple values";
                                properties.functionArgumentOperand = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.Operand.FunctionOperand.verify(message.functionOperand);
                                    if (error)
                                        return "functionOperand." + error;
                                }
                            }
                            if (message.requestContextOperand != null && message.hasOwnProperty("requestContextOperand")) {
                                if (properties.functionArgumentOperand === 1)
                                    return "functionArgumentOperand: multiple values";
                                properties.functionArgumentOperand = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.Operand.RequestContextOperand.verify(message.requestContextOperand);
                                    if (error)
                                        return "requestContextOperand." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an Operand message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.Operand
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.Operand} Operand
                         */
                        Operand.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.Operand)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.Operand();
                            if (object.constantOperand != null) {
                                if (typeof object.constantOperand !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Operand.constantOperand: object expected");
                                message.constantOperand = $root.google.ads.googleads.v1.common.Operand.ConstantOperand.fromObject(object.constantOperand);
                            }
                            if (object.feedAttributeOperand != null) {
                                if (typeof object.feedAttributeOperand !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Operand.feedAttributeOperand: object expected");
                                message.feedAttributeOperand = $root.google.ads.googleads.v1.common.Operand.FeedAttributeOperand.fromObject(object.feedAttributeOperand);
                            }
                            if (object.functionOperand != null) {
                                if (typeof object.functionOperand !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Operand.functionOperand: object expected");
                                message.functionOperand = $root.google.ads.googleads.v1.common.Operand.FunctionOperand.fromObject(object.functionOperand);
                            }
                            if (object.requestContextOperand != null) {
                                if (typeof object.requestContextOperand !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Operand.requestContextOperand: object expected");
                                message.requestContextOperand = $root.google.ads.googleads.v1.common.Operand.RequestContextOperand.fromObject(object.requestContextOperand);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an Operand message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.Operand
                         * @static
                         * @param {google.ads.googleads.v1.common.Operand} message Operand
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Operand.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.constantOperand != null && message.hasOwnProperty("constantOperand")) {
                                object.constantOperand = $root.google.ads.googleads.v1.common.Operand.ConstantOperand.toObject(message.constantOperand, options);
                                if (options.oneofs)
                                    object.functionArgumentOperand = "constantOperand";
                            }
                            if (message.feedAttributeOperand != null && message.hasOwnProperty("feedAttributeOperand")) {
                                object.feedAttributeOperand = $root.google.ads.googleads.v1.common.Operand.FeedAttributeOperand.toObject(message.feedAttributeOperand, options);
                                if (options.oneofs)
                                    object.functionArgumentOperand = "feedAttributeOperand";
                            }
                            if (message.functionOperand != null && message.hasOwnProperty("functionOperand")) {
                                object.functionOperand = $root.google.ads.googleads.v1.common.Operand.FunctionOperand.toObject(message.functionOperand, options);
                                if (options.oneofs)
                                    object.functionArgumentOperand = "functionOperand";
                            }
                            if (message.requestContextOperand != null && message.hasOwnProperty("requestContextOperand")) {
                                object.requestContextOperand = $root.google.ads.googleads.v1.common.Operand.RequestContextOperand.toObject(message.requestContextOperand, options);
                                if (options.oneofs)
                                    object.functionArgumentOperand = "requestContextOperand";
                            }
                            return object;
                        };

                        /**
                         * Converts this Operand to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.Operand
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Operand.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        Operand.ConstantOperand = (function() {

                            /**
                             * Properties of a ConstantOperand.
                             * @memberof google.ads.googleads.v1.common.Operand
                             * @interface IConstantOperand
                             * @property {google.protobuf.IStringValue|null} [stringValue] ConstantOperand stringValue
                             * @property {google.protobuf.IInt64Value|null} [longValue] ConstantOperand longValue
                             * @property {google.protobuf.IBoolValue|null} [booleanValue] ConstantOperand booleanValue
                             * @property {google.protobuf.IDoubleValue|null} [doubleValue] ConstantOperand doubleValue
                             */

                            /**
                             * Constructs a new ConstantOperand.
                             * @memberof google.ads.googleads.v1.common.Operand
                             * @classdesc Represents a ConstantOperand.
                             * @implements IConstantOperand
                             * @constructor
                             * @param {google.ads.googleads.v1.common.Operand.IConstantOperand=} [properties] Properties to set
                             */
                            function ConstantOperand(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * ConstantOperand stringValue.
                             * @member {google.protobuf.IStringValue|null|undefined} stringValue
                             * @memberof google.ads.googleads.v1.common.Operand.ConstantOperand
                             * @instance
                             */
                            ConstantOperand.prototype.stringValue = null;

                            /**
                             * ConstantOperand longValue.
                             * @member {google.protobuf.IInt64Value|null|undefined} longValue
                             * @memberof google.ads.googleads.v1.common.Operand.ConstantOperand
                             * @instance
                             */
                            ConstantOperand.prototype.longValue = null;

                            /**
                             * ConstantOperand booleanValue.
                             * @member {google.protobuf.IBoolValue|null|undefined} booleanValue
                             * @memberof google.ads.googleads.v1.common.Operand.ConstantOperand
                             * @instance
                             */
                            ConstantOperand.prototype.booleanValue = null;

                            /**
                             * ConstantOperand doubleValue.
                             * @member {google.protobuf.IDoubleValue|null|undefined} doubleValue
                             * @memberof google.ads.googleads.v1.common.Operand.ConstantOperand
                             * @instance
                             */
                            ConstantOperand.prototype.doubleValue = null;

                            // OneOf field names bound to virtual getters and setters
                            var $oneOfFields;

                            /**
                             * ConstantOperand constantOperandValue.
                             * @member {"stringValue"|"longValue"|"booleanValue"|"doubleValue"|undefined} constantOperandValue
                             * @memberof google.ads.googleads.v1.common.Operand.ConstantOperand
                             * @instance
                             */
                            Object.defineProperty(ConstantOperand.prototype, "constantOperandValue", {
                                get: $util.oneOfGetter($oneOfFields = ["stringValue", "longValue", "booleanValue", "doubleValue"]),
                                set: $util.oneOfSetter($oneOfFields)
                            });

                            /**
                             * Creates a new ConstantOperand instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.common.Operand.ConstantOperand
                             * @static
                             * @param {google.ads.googleads.v1.common.Operand.IConstantOperand=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.common.Operand.ConstantOperand} ConstantOperand instance
                             */
                            ConstantOperand.create = function create(properties) {
                                return new ConstantOperand(properties);
                            };

                            /**
                             * Encodes the specified ConstantOperand message. Does not implicitly {@link google.ads.googleads.v1.common.Operand.ConstantOperand.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.common.Operand.ConstantOperand
                             * @static
                             * @param {google.ads.googleads.v1.common.Operand.IConstantOperand} message ConstantOperand message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            ConstantOperand.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.stringValue != null && message.hasOwnProperty("stringValue"))
                                    $root.google.protobuf.StringValue.encode(message.stringValue, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.longValue != null && message.hasOwnProperty("longValue"))
                                    $root.google.protobuf.Int64Value.encode(message.longValue, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                if (message.booleanValue != null && message.hasOwnProperty("booleanValue"))
                                    $root.google.protobuf.BoolValue.encode(message.booleanValue, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                                if (message.doubleValue != null && message.hasOwnProperty("doubleValue"))
                                    $root.google.protobuf.DoubleValue.encode(message.doubleValue, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified ConstantOperand message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.Operand.ConstantOperand.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.common.Operand.ConstantOperand
                             * @static
                             * @param {google.ads.googleads.v1.common.Operand.IConstantOperand} message ConstantOperand message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            ConstantOperand.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a ConstantOperand message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.common.Operand.ConstantOperand
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.common.Operand.ConstantOperand} ConstantOperand
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            ConstantOperand.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.Operand.ConstantOperand();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.stringValue = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.longValue = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    case 3:
                                        message.booleanValue = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    case 4:
                                        message.doubleValue = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a ConstantOperand message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.common.Operand.ConstantOperand
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.common.Operand.ConstantOperand} ConstantOperand
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            ConstantOperand.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a ConstantOperand message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.common.Operand.ConstantOperand
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            ConstantOperand.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                var properties = {};
                                if (message.stringValue != null && message.hasOwnProperty("stringValue")) {
                                    properties.constantOperandValue = 1;
                                    {
                                        var error = $root.google.protobuf.StringValue.verify(message.stringValue);
                                        if (error)
                                            return "stringValue." + error;
                                    }
                                }
                                if (message.longValue != null && message.hasOwnProperty("longValue")) {
                                    if (properties.constantOperandValue === 1)
                                        return "constantOperandValue: multiple values";
                                    properties.constantOperandValue = 1;
                                    {
                                        var error = $root.google.protobuf.Int64Value.verify(message.longValue);
                                        if (error)
                                            return "longValue." + error;
                                    }
                                }
                                if (message.booleanValue != null && message.hasOwnProperty("booleanValue")) {
                                    if (properties.constantOperandValue === 1)
                                        return "constantOperandValue: multiple values";
                                    properties.constantOperandValue = 1;
                                    {
                                        var error = $root.google.protobuf.BoolValue.verify(message.booleanValue);
                                        if (error)
                                            return "booleanValue." + error;
                                    }
                                }
                                if (message.doubleValue != null && message.hasOwnProperty("doubleValue")) {
                                    if (properties.constantOperandValue === 1)
                                        return "constantOperandValue: multiple values";
                                    properties.constantOperandValue = 1;
                                    {
                                        var error = $root.google.protobuf.DoubleValue.verify(message.doubleValue);
                                        if (error)
                                            return "doubleValue." + error;
                                    }
                                }
                                return null;
                            };

                            /**
                             * Creates a ConstantOperand message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.common.Operand.ConstantOperand
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.common.Operand.ConstantOperand} ConstantOperand
                             */
                            ConstantOperand.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.common.Operand.ConstantOperand)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.common.Operand.ConstantOperand();
                                if (object.stringValue != null) {
                                    if (typeof object.stringValue !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.Operand.ConstantOperand.stringValue: object expected");
                                    message.stringValue = $root.google.protobuf.StringValue.fromObject(object.stringValue);
                                }
                                if (object.longValue != null) {
                                    if (typeof object.longValue !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.Operand.ConstantOperand.longValue: object expected");
                                    message.longValue = $root.google.protobuf.Int64Value.fromObject(object.longValue);
                                }
                                if (object.booleanValue != null) {
                                    if (typeof object.booleanValue !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.Operand.ConstantOperand.booleanValue: object expected");
                                    message.booleanValue = $root.google.protobuf.BoolValue.fromObject(object.booleanValue);
                                }
                                if (object.doubleValue != null) {
                                    if (typeof object.doubleValue !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.Operand.ConstantOperand.doubleValue: object expected");
                                    message.doubleValue = $root.google.protobuf.DoubleValue.fromObject(object.doubleValue);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a ConstantOperand message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.common.Operand.ConstantOperand
                             * @static
                             * @param {google.ads.googleads.v1.common.Operand.ConstantOperand} message ConstantOperand
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            ConstantOperand.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (message.stringValue != null && message.hasOwnProperty("stringValue")) {
                                    object.stringValue = $root.google.protobuf.StringValue.toObject(message.stringValue, options);
                                    if (options.oneofs)
                                        object.constantOperandValue = "stringValue";
                                }
                                if (message.longValue != null && message.hasOwnProperty("longValue")) {
                                    object.longValue = $root.google.protobuf.Int64Value.toObject(message.longValue, options);
                                    if (options.oneofs)
                                        object.constantOperandValue = "longValue";
                                }
                                if (message.booleanValue != null && message.hasOwnProperty("booleanValue")) {
                                    object.booleanValue = $root.google.protobuf.BoolValue.toObject(message.booleanValue, options);
                                    if (options.oneofs)
                                        object.constantOperandValue = "booleanValue";
                                }
                                if (message.doubleValue != null && message.hasOwnProperty("doubleValue")) {
                                    object.doubleValue = $root.google.protobuf.DoubleValue.toObject(message.doubleValue, options);
                                    if (options.oneofs)
                                        object.constantOperandValue = "doubleValue";
                                }
                                return object;
                            };

                            /**
                             * Converts this ConstantOperand to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.common.Operand.ConstantOperand
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            ConstantOperand.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return ConstantOperand;
                        })();

                        Operand.FeedAttributeOperand = (function() {

                            /**
                             * Properties of a FeedAttributeOperand.
                             * @memberof google.ads.googleads.v1.common.Operand
                             * @interface IFeedAttributeOperand
                             * @property {google.protobuf.IInt64Value|null} [feedId] FeedAttributeOperand feedId
                             * @property {google.protobuf.IInt64Value|null} [feedAttributeId] FeedAttributeOperand feedAttributeId
                             */

                            /**
                             * Constructs a new FeedAttributeOperand.
                             * @memberof google.ads.googleads.v1.common.Operand
                             * @classdesc Represents a FeedAttributeOperand.
                             * @implements IFeedAttributeOperand
                             * @constructor
                             * @param {google.ads.googleads.v1.common.Operand.IFeedAttributeOperand=} [properties] Properties to set
                             */
                            function FeedAttributeOperand(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * FeedAttributeOperand feedId.
                             * @member {google.protobuf.IInt64Value|null|undefined} feedId
                             * @memberof google.ads.googleads.v1.common.Operand.FeedAttributeOperand
                             * @instance
                             */
                            FeedAttributeOperand.prototype.feedId = null;

                            /**
                             * FeedAttributeOperand feedAttributeId.
                             * @member {google.protobuf.IInt64Value|null|undefined} feedAttributeId
                             * @memberof google.ads.googleads.v1.common.Operand.FeedAttributeOperand
                             * @instance
                             */
                            FeedAttributeOperand.prototype.feedAttributeId = null;

                            /**
                             * Creates a new FeedAttributeOperand instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.common.Operand.FeedAttributeOperand
                             * @static
                             * @param {google.ads.googleads.v1.common.Operand.IFeedAttributeOperand=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.common.Operand.FeedAttributeOperand} FeedAttributeOperand instance
                             */
                            FeedAttributeOperand.create = function create(properties) {
                                return new FeedAttributeOperand(properties);
                            };

                            /**
                             * Encodes the specified FeedAttributeOperand message. Does not implicitly {@link google.ads.googleads.v1.common.Operand.FeedAttributeOperand.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.common.Operand.FeedAttributeOperand
                             * @static
                             * @param {google.ads.googleads.v1.common.Operand.IFeedAttributeOperand} message FeedAttributeOperand message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            FeedAttributeOperand.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.feedId != null && message.hasOwnProperty("feedId"))
                                    $root.google.protobuf.Int64Value.encode(message.feedId, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.feedAttributeId != null && message.hasOwnProperty("feedAttributeId"))
                                    $root.google.protobuf.Int64Value.encode(message.feedAttributeId, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified FeedAttributeOperand message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.Operand.FeedAttributeOperand.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.common.Operand.FeedAttributeOperand
                             * @static
                             * @param {google.ads.googleads.v1.common.Operand.IFeedAttributeOperand} message FeedAttributeOperand message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            FeedAttributeOperand.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a FeedAttributeOperand message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.common.Operand.FeedAttributeOperand
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.common.Operand.FeedAttributeOperand} FeedAttributeOperand
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            FeedAttributeOperand.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.Operand.FeedAttributeOperand();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.feedId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.feedAttributeId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a FeedAttributeOperand message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.common.Operand.FeedAttributeOperand
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.common.Operand.FeedAttributeOperand} FeedAttributeOperand
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            FeedAttributeOperand.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a FeedAttributeOperand message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.common.Operand.FeedAttributeOperand
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            FeedAttributeOperand.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.feedId != null && message.hasOwnProperty("feedId")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.feedId);
                                    if (error)
                                        return "feedId." + error;
                                }
                                if (message.feedAttributeId != null && message.hasOwnProperty("feedAttributeId")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.feedAttributeId);
                                    if (error)
                                        return "feedAttributeId." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a FeedAttributeOperand message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.common.Operand.FeedAttributeOperand
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.common.Operand.FeedAttributeOperand} FeedAttributeOperand
                             */
                            FeedAttributeOperand.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.common.Operand.FeedAttributeOperand)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.common.Operand.FeedAttributeOperand();
                                if (object.feedId != null) {
                                    if (typeof object.feedId !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.Operand.FeedAttributeOperand.feedId: object expected");
                                    message.feedId = $root.google.protobuf.Int64Value.fromObject(object.feedId);
                                }
                                if (object.feedAttributeId != null) {
                                    if (typeof object.feedAttributeId !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.Operand.FeedAttributeOperand.feedAttributeId: object expected");
                                    message.feedAttributeId = $root.google.protobuf.Int64Value.fromObject(object.feedAttributeId);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a FeedAttributeOperand message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.common.Operand.FeedAttributeOperand
                             * @static
                             * @param {google.ads.googleads.v1.common.Operand.FeedAttributeOperand} message FeedAttributeOperand
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            FeedAttributeOperand.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.feedId = null;
                                    object.feedAttributeId = null;
                                }
                                if (message.feedId != null && message.hasOwnProperty("feedId"))
                                    object.feedId = $root.google.protobuf.Int64Value.toObject(message.feedId, options);
                                if (message.feedAttributeId != null && message.hasOwnProperty("feedAttributeId"))
                                    object.feedAttributeId = $root.google.protobuf.Int64Value.toObject(message.feedAttributeId, options);
                                return object;
                            };

                            /**
                             * Converts this FeedAttributeOperand to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.common.Operand.FeedAttributeOperand
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            FeedAttributeOperand.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return FeedAttributeOperand;
                        })();

                        Operand.FunctionOperand = (function() {

                            /**
                             * Properties of a FunctionOperand.
                             * @memberof google.ads.googleads.v1.common.Operand
                             * @interface IFunctionOperand
                             * @property {google.ads.googleads.v1.common.IMatchingFunction|null} [matchingFunction] FunctionOperand matchingFunction
                             */

                            /**
                             * Constructs a new FunctionOperand.
                             * @memberof google.ads.googleads.v1.common.Operand
                             * @classdesc Represents a FunctionOperand.
                             * @implements IFunctionOperand
                             * @constructor
                             * @param {google.ads.googleads.v1.common.Operand.IFunctionOperand=} [properties] Properties to set
                             */
                            function FunctionOperand(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * FunctionOperand matchingFunction.
                             * @member {google.ads.googleads.v1.common.IMatchingFunction|null|undefined} matchingFunction
                             * @memberof google.ads.googleads.v1.common.Operand.FunctionOperand
                             * @instance
                             */
                            FunctionOperand.prototype.matchingFunction = null;

                            /**
                             * Creates a new FunctionOperand instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.common.Operand.FunctionOperand
                             * @static
                             * @param {google.ads.googleads.v1.common.Operand.IFunctionOperand=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.common.Operand.FunctionOperand} FunctionOperand instance
                             */
                            FunctionOperand.create = function create(properties) {
                                return new FunctionOperand(properties);
                            };

                            /**
                             * Encodes the specified FunctionOperand message. Does not implicitly {@link google.ads.googleads.v1.common.Operand.FunctionOperand.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.common.Operand.FunctionOperand
                             * @static
                             * @param {google.ads.googleads.v1.common.Operand.IFunctionOperand} message FunctionOperand message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            FunctionOperand.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.matchingFunction != null && message.hasOwnProperty("matchingFunction"))
                                    $root.google.ads.googleads.v1.common.MatchingFunction.encode(message.matchingFunction, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified FunctionOperand message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.Operand.FunctionOperand.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.common.Operand.FunctionOperand
                             * @static
                             * @param {google.ads.googleads.v1.common.Operand.IFunctionOperand} message FunctionOperand message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            FunctionOperand.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a FunctionOperand message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.common.Operand.FunctionOperand
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.common.Operand.FunctionOperand} FunctionOperand
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            FunctionOperand.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.Operand.FunctionOperand();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.matchingFunction = $root.google.ads.googleads.v1.common.MatchingFunction.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a FunctionOperand message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.common.Operand.FunctionOperand
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.common.Operand.FunctionOperand} FunctionOperand
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            FunctionOperand.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a FunctionOperand message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.common.Operand.FunctionOperand
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            FunctionOperand.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.matchingFunction != null && message.hasOwnProperty("matchingFunction")) {
                                    var error = $root.google.ads.googleads.v1.common.MatchingFunction.verify(message.matchingFunction);
                                    if (error)
                                        return "matchingFunction." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a FunctionOperand message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.common.Operand.FunctionOperand
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.common.Operand.FunctionOperand} FunctionOperand
                             */
                            FunctionOperand.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.common.Operand.FunctionOperand)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.common.Operand.FunctionOperand();
                                if (object.matchingFunction != null) {
                                    if (typeof object.matchingFunction !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.Operand.FunctionOperand.matchingFunction: object expected");
                                    message.matchingFunction = $root.google.ads.googleads.v1.common.MatchingFunction.fromObject(object.matchingFunction);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a FunctionOperand message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.common.Operand.FunctionOperand
                             * @static
                             * @param {google.ads.googleads.v1.common.Operand.FunctionOperand} message FunctionOperand
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            FunctionOperand.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults)
                                    object.matchingFunction = null;
                                if (message.matchingFunction != null && message.hasOwnProperty("matchingFunction"))
                                    object.matchingFunction = $root.google.ads.googleads.v1.common.MatchingFunction.toObject(message.matchingFunction, options);
                                return object;
                            };

                            /**
                             * Converts this FunctionOperand to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.common.Operand.FunctionOperand
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            FunctionOperand.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return FunctionOperand;
                        })();

                        Operand.RequestContextOperand = (function() {

                            /**
                             * Properties of a RequestContextOperand.
                             * @memberof google.ads.googleads.v1.common.Operand
                             * @interface IRequestContextOperand
                             * @property {google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum.MatchingFunctionContextType|null} [contextType] RequestContextOperand contextType
                             */

                            /**
                             * Constructs a new RequestContextOperand.
                             * @memberof google.ads.googleads.v1.common.Operand
                             * @classdesc Represents a RequestContextOperand.
                             * @implements IRequestContextOperand
                             * @constructor
                             * @param {google.ads.googleads.v1.common.Operand.IRequestContextOperand=} [properties] Properties to set
                             */
                            function RequestContextOperand(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * RequestContextOperand contextType.
                             * @member {google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum.MatchingFunctionContextType} contextType
                             * @memberof google.ads.googleads.v1.common.Operand.RequestContextOperand
                             * @instance
                             */
                            RequestContextOperand.prototype.contextType = 0;

                            /**
                             * Creates a new RequestContextOperand instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.common.Operand.RequestContextOperand
                             * @static
                             * @param {google.ads.googleads.v1.common.Operand.IRequestContextOperand=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.common.Operand.RequestContextOperand} RequestContextOperand instance
                             */
                            RequestContextOperand.create = function create(properties) {
                                return new RequestContextOperand(properties);
                            };

                            /**
                             * Encodes the specified RequestContextOperand message. Does not implicitly {@link google.ads.googleads.v1.common.Operand.RequestContextOperand.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.common.Operand.RequestContextOperand
                             * @static
                             * @param {google.ads.googleads.v1.common.Operand.IRequestContextOperand} message RequestContextOperand message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            RequestContextOperand.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.contextType != null && message.hasOwnProperty("contextType"))
                                    writer.uint32(/* id 1, wireType 0 =*/8).int32(message.contextType);
                                return writer;
                            };

                            /**
                             * Encodes the specified RequestContextOperand message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.Operand.RequestContextOperand.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.common.Operand.RequestContextOperand
                             * @static
                             * @param {google.ads.googleads.v1.common.Operand.IRequestContextOperand} message RequestContextOperand message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            RequestContextOperand.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a RequestContextOperand message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.common.Operand.RequestContextOperand
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.common.Operand.RequestContextOperand} RequestContextOperand
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            RequestContextOperand.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.Operand.RequestContextOperand();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.contextType = reader.int32();
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a RequestContextOperand message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.common.Operand.RequestContextOperand
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.common.Operand.RequestContextOperand} RequestContextOperand
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            RequestContextOperand.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a RequestContextOperand message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.common.Operand.RequestContextOperand
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            RequestContextOperand.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.contextType != null && message.hasOwnProperty("contextType"))
                                    switch (message.contextType) {
                                    default:
                                        return "contextType: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                        break;
                                    }
                                return null;
                            };

                            /**
                             * Creates a RequestContextOperand message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.common.Operand.RequestContextOperand
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.common.Operand.RequestContextOperand} RequestContextOperand
                             */
                            RequestContextOperand.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.common.Operand.RequestContextOperand)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.common.Operand.RequestContextOperand();
                                switch (object.contextType) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.contextType = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.contextType = 1;
                                    break;
                                case "FEED_ITEM_ID":
                                case 2:
                                    message.contextType = 2;
                                    break;
                                case "DEVICE_NAME":
                                case 3:
                                    message.contextType = 3;
                                    break;
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a RequestContextOperand message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.common.Operand.RequestContextOperand
                             * @static
                             * @param {google.ads.googleads.v1.common.Operand.RequestContextOperand} message RequestContextOperand
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            RequestContextOperand.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults)
                                    object.contextType = options.enums === String ? "UNSPECIFIED" : 0;
                                if (message.contextType != null && message.hasOwnProperty("contextType"))
                                    object.contextType = options.enums === String ? $root.google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum.MatchingFunctionContextType[message.contextType] : message.contextType;
                                return object;
                            };

                            /**
                             * Converts this RequestContextOperand to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.common.Operand.RequestContextOperand
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            RequestContextOperand.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return RequestContextOperand;
                        })();

                        return Operand;
                    })();

                    common.Metrics = (function() {

                        /**
                         * Properties of a Metrics.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IMetrics
                         * @property {google.protobuf.IDoubleValue|null} [absoluteTopImpressionPercentage] Metrics absoluteTopImpressionPercentage
                         * @property {google.protobuf.IDoubleValue|null} [activeViewCpm] Metrics activeViewCpm
                         * @property {google.protobuf.IDoubleValue|null} [activeViewCtr] Metrics activeViewCtr
                         * @property {google.protobuf.IInt64Value|null} [activeViewImpressions] Metrics activeViewImpressions
                         * @property {google.protobuf.IDoubleValue|null} [activeViewMeasurability] Metrics activeViewMeasurability
                         * @property {google.protobuf.IInt64Value|null} [activeViewMeasurableCostMicros] Metrics activeViewMeasurableCostMicros
                         * @property {google.protobuf.IInt64Value|null} [activeViewMeasurableImpressions] Metrics activeViewMeasurableImpressions
                         * @property {google.protobuf.IDoubleValue|null} [activeViewViewability] Metrics activeViewViewability
                         * @property {google.protobuf.IDoubleValue|null} [allConversionsFromInteractionsRate] Metrics allConversionsFromInteractionsRate
                         * @property {google.protobuf.IDoubleValue|null} [allConversionsValue] Metrics allConversionsValue
                         * @property {google.protobuf.IDoubleValue|null} [allConversions] Metrics allConversions
                         * @property {google.protobuf.IDoubleValue|null} [allConversionsValuePerCost] Metrics allConversionsValuePerCost
                         * @property {google.protobuf.IDoubleValue|null} [allConversionsFromClickToCall] Metrics allConversionsFromClickToCall
                         * @property {google.protobuf.IDoubleValue|null} [allConversionsFromDirections] Metrics allConversionsFromDirections
                         * @property {google.protobuf.IDoubleValue|null} [allConversionsFromInteractionsValuePerInteraction] Metrics allConversionsFromInteractionsValuePerInteraction
                         * @property {google.protobuf.IDoubleValue|null} [allConversionsFromMenu] Metrics allConversionsFromMenu
                         * @property {google.protobuf.IDoubleValue|null} [allConversionsFromOrder] Metrics allConversionsFromOrder
                         * @property {google.protobuf.IDoubleValue|null} [allConversionsFromOtherEngagement] Metrics allConversionsFromOtherEngagement
                         * @property {google.protobuf.IDoubleValue|null} [allConversionsFromStoreVisit] Metrics allConversionsFromStoreVisit
                         * @property {google.protobuf.IDoubleValue|null} [allConversionsFromStoreWebsite] Metrics allConversionsFromStoreWebsite
                         * @property {google.protobuf.IDoubleValue|null} [averageCost] Metrics averageCost
                         * @property {google.protobuf.IDoubleValue|null} [averageCpc] Metrics averageCpc
                         * @property {google.protobuf.IDoubleValue|null} [averageCpe] Metrics averageCpe
                         * @property {google.protobuf.IDoubleValue|null} [averageCpm] Metrics averageCpm
                         * @property {google.protobuf.IDoubleValue|null} [averageCpv] Metrics averageCpv
                         * @property {google.protobuf.IDoubleValue|null} [averageFrequency] Metrics averageFrequency
                         * @property {google.protobuf.IDoubleValue|null} [averagePageViews] Metrics averagePageViews
                         * @property {google.protobuf.IDoubleValue|null} [averagePosition] Metrics averagePosition
                         * @property {google.protobuf.IDoubleValue|null} [averageTimeOnSite] Metrics averageTimeOnSite
                         * @property {google.protobuf.IDoubleValue|null} [benchmarkAverageMaxCpc] Metrics benchmarkAverageMaxCpc
                         * @property {google.protobuf.IDoubleValue|null} [benchmarkCtr] Metrics benchmarkCtr
                         * @property {google.protobuf.IDoubleValue|null} [bounceRate] Metrics bounceRate
                         * @property {google.protobuf.IInt64Value|null} [clicks] Metrics clicks
                         * @property {google.protobuf.IInt64Value|null} [combinedClicks] Metrics combinedClicks
                         * @property {google.protobuf.IDoubleValue|null} [combinedClicksPerQuery] Metrics combinedClicksPerQuery
                         * @property {google.protobuf.IInt64Value|null} [combinedQueries] Metrics combinedQueries
                         * @property {google.protobuf.IDoubleValue|null} [contentBudgetLostImpressionShare] Metrics contentBudgetLostImpressionShare
                         * @property {google.protobuf.IDoubleValue|null} [contentImpressionShare] Metrics contentImpressionShare
                         * @property {google.protobuf.IStringValue|null} [conversionLastReceivedRequestDateTime] Metrics conversionLastReceivedRequestDateTime
                         * @property {google.protobuf.IStringValue|null} [conversionLastConversionDate] Metrics conversionLastConversionDate
                         * @property {google.protobuf.IDoubleValue|null} [contentRankLostImpressionShare] Metrics contentRankLostImpressionShare
                         * @property {google.protobuf.IDoubleValue|null} [conversionsFromInteractionsRate] Metrics conversionsFromInteractionsRate
                         * @property {google.protobuf.IDoubleValue|null} [conversionsValue] Metrics conversionsValue
                         * @property {google.protobuf.IDoubleValue|null} [conversionsValuePerCost] Metrics conversionsValuePerCost
                         * @property {google.protobuf.IDoubleValue|null} [conversionsFromInteractionsValuePerInteraction] Metrics conversionsFromInteractionsValuePerInteraction
                         * @property {google.protobuf.IDoubleValue|null} [conversions] Metrics conversions
                         * @property {google.protobuf.IInt64Value|null} [costMicros] Metrics costMicros
                         * @property {google.protobuf.IDoubleValue|null} [costPerAllConversions] Metrics costPerAllConversions
                         * @property {google.protobuf.IDoubleValue|null} [costPerConversion] Metrics costPerConversion
                         * @property {google.protobuf.IDoubleValue|null} [costPerCurrentModelAttributedConversion] Metrics costPerCurrentModelAttributedConversion
                         * @property {google.protobuf.IDoubleValue|null} [crossDeviceConversions] Metrics crossDeviceConversions
                         * @property {google.protobuf.IDoubleValue|null} [ctr] Metrics ctr
                         * @property {google.protobuf.IDoubleValue|null} [currentModelAttributedConversions] Metrics currentModelAttributedConversions
                         * @property {google.protobuf.IDoubleValue|null} [currentModelAttributedConversionsFromInteractionsRate] Metrics currentModelAttributedConversionsFromInteractionsRate
                         * @property {google.protobuf.IDoubleValue|null} [currentModelAttributedConversionsFromInteractionsValuePerInteraction] Metrics currentModelAttributedConversionsFromInteractionsValuePerInteraction
                         * @property {google.protobuf.IDoubleValue|null} [currentModelAttributedConversionsValue] Metrics currentModelAttributedConversionsValue
                         * @property {google.protobuf.IDoubleValue|null} [currentModelAttributedConversionsValuePerCost] Metrics currentModelAttributedConversionsValuePerCost
                         * @property {google.protobuf.IDoubleValue|null} [engagementRate] Metrics engagementRate
                         * @property {google.protobuf.IInt64Value|null} [engagements] Metrics engagements
                         * @property {google.protobuf.IDoubleValue|null} [hotelAverageLeadValueMicros] Metrics hotelAverageLeadValueMicros
                         * @property {google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket|null} [historicalCreativeQualityScore] Metrics historicalCreativeQualityScore
                         * @property {google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket|null} [historicalLandingPageQualityScore] Metrics historicalLandingPageQualityScore
                         * @property {google.protobuf.IInt64Value|null} [historicalQualityScore] Metrics historicalQualityScore
                         * @property {google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket|null} [historicalSearchPredictedCtr] Metrics historicalSearchPredictedCtr
                         * @property {google.protobuf.IInt64Value|null} [gmailForwards] Metrics gmailForwards
                         * @property {google.protobuf.IInt64Value|null} [gmailSaves] Metrics gmailSaves
                         * @property {google.protobuf.IInt64Value|null} [gmailSecondaryClicks] Metrics gmailSecondaryClicks
                         * @property {google.protobuf.IInt64Value|null} [impressionReach] Metrics impressionReach
                         * @property {google.protobuf.IInt64Value|null} [impressionsFromStoreReach] Metrics impressionsFromStoreReach
                         * @property {google.protobuf.IInt64Value|null} [impressions] Metrics impressions
                         * @property {google.protobuf.IDoubleValue|null} [interactionRate] Metrics interactionRate
                         * @property {google.protobuf.IInt64Value|null} [interactions] Metrics interactions
                         * @property {Array.<google.ads.googleads.v1.enums.InteractionEventTypeEnum.InteractionEventType>|null} [interactionEventTypes] Metrics interactionEventTypes
                         * @property {google.protobuf.IDoubleValue|null} [invalidClickRate] Metrics invalidClickRate
                         * @property {google.protobuf.IInt64Value|null} [invalidClicks] Metrics invalidClicks
                         * @property {google.protobuf.IDoubleValue|null} [mobileFriendlyClicksPercentage] Metrics mobileFriendlyClicksPercentage
                         * @property {google.protobuf.IInt64Value|null} [organicClicks] Metrics organicClicks
                         * @property {google.protobuf.IDoubleValue|null} [organicClicksPerQuery] Metrics organicClicksPerQuery
                         * @property {google.protobuf.IInt64Value|null} [organicImpressions] Metrics organicImpressions
                         * @property {google.protobuf.IDoubleValue|null} [organicImpressionsPerQuery] Metrics organicImpressionsPerQuery
                         * @property {google.protobuf.IInt64Value|null} [organicQueries] Metrics organicQueries
                         * @property {google.protobuf.IDoubleValue|null} [percentNewVisitors] Metrics percentNewVisitors
                         * @property {google.protobuf.IInt64Value|null} [phoneCalls] Metrics phoneCalls
                         * @property {google.protobuf.IInt64Value|null} [phoneImpressions] Metrics phoneImpressions
                         * @property {google.protobuf.IDoubleValue|null} [phoneThroughRate] Metrics phoneThroughRate
                         * @property {google.protobuf.IDoubleValue|null} [relativeCtr] Metrics relativeCtr
                         * @property {google.protobuf.IDoubleValue|null} [searchAbsoluteTopImpressionShare] Metrics searchAbsoluteTopImpressionShare
                         * @property {google.protobuf.IDoubleValue|null} [searchBudgetLostAbsoluteTopImpressionShare] Metrics searchBudgetLostAbsoluteTopImpressionShare
                         * @property {google.protobuf.IDoubleValue|null} [searchBudgetLostImpressionShare] Metrics searchBudgetLostImpressionShare
                         * @property {google.protobuf.IDoubleValue|null} [searchBudgetLostTopImpressionShare] Metrics searchBudgetLostTopImpressionShare
                         * @property {google.protobuf.IDoubleValue|null} [searchClickShare] Metrics searchClickShare
                         * @property {google.protobuf.IDoubleValue|null} [searchExactMatchImpressionShare] Metrics searchExactMatchImpressionShare
                         * @property {google.protobuf.IDoubleValue|null} [searchImpressionShare] Metrics searchImpressionShare
                         * @property {google.protobuf.IDoubleValue|null} [searchRankLostAbsoluteTopImpressionShare] Metrics searchRankLostAbsoluteTopImpressionShare
                         * @property {google.protobuf.IDoubleValue|null} [searchRankLostImpressionShare] Metrics searchRankLostImpressionShare
                         * @property {google.protobuf.IDoubleValue|null} [searchRankLostTopImpressionShare] Metrics searchRankLostTopImpressionShare
                         * @property {google.protobuf.IDoubleValue|null} [searchTopImpressionShare] Metrics searchTopImpressionShare
                         * @property {google.protobuf.IInt64Value|null} [speedScore] Metrics speedScore
                         * @property {google.protobuf.IDoubleValue|null} [topImpressionPercentage] Metrics topImpressionPercentage
                         * @property {google.protobuf.IDoubleValue|null} [validAcceleratedMobilePagesClicksPercentage] Metrics validAcceleratedMobilePagesClicksPercentage
                         * @property {google.protobuf.IDoubleValue|null} [valuePerAllConversions] Metrics valuePerAllConversions
                         * @property {google.protobuf.IDoubleValue|null} [valuePerConversion] Metrics valuePerConversion
                         * @property {google.protobuf.IDoubleValue|null} [valuePerCurrentModelAttributedConversion] Metrics valuePerCurrentModelAttributedConversion
                         * @property {google.protobuf.IDoubleValue|null} [videoQuartile_100Rate] Metrics videoQuartile_100Rate
                         * @property {google.protobuf.IDoubleValue|null} [videoQuartile_25Rate] Metrics videoQuartile_25Rate
                         * @property {google.protobuf.IDoubleValue|null} [videoQuartile_50Rate] Metrics videoQuartile_50Rate
                         * @property {google.protobuf.IDoubleValue|null} [videoQuartile_75Rate] Metrics videoQuartile_75Rate
                         * @property {google.protobuf.IDoubleValue|null} [videoViewRate] Metrics videoViewRate
                         * @property {google.protobuf.IInt64Value|null} [videoViews] Metrics videoViews
                         * @property {google.protobuf.IInt64Value|null} [viewThroughConversions] Metrics viewThroughConversions
                         */

                        /**
                         * Constructs a new Metrics.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a Metrics.
                         * @implements IMetrics
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IMetrics=} [properties] Properties to set
                         */
                        function Metrics(properties) {
                            this.interactionEventTypes = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Metrics absoluteTopImpressionPercentage.
                         * @member {google.protobuf.IDoubleValue|null|undefined} absoluteTopImpressionPercentage
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.absoluteTopImpressionPercentage = null;

                        /**
                         * Metrics activeViewCpm.
                         * @member {google.protobuf.IDoubleValue|null|undefined} activeViewCpm
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.activeViewCpm = null;

                        /**
                         * Metrics activeViewCtr.
                         * @member {google.protobuf.IDoubleValue|null|undefined} activeViewCtr
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.activeViewCtr = null;

                        /**
                         * Metrics activeViewImpressions.
                         * @member {google.protobuf.IInt64Value|null|undefined} activeViewImpressions
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.activeViewImpressions = null;

                        /**
                         * Metrics activeViewMeasurability.
                         * @member {google.protobuf.IDoubleValue|null|undefined} activeViewMeasurability
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.activeViewMeasurability = null;

                        /**
                         * Metrics activeViewMeasurableCostMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} activeViewMeasurableCostMicros
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.activeViewMeasurableCostMicros = null;

                        /**
                         * Metrics activeViewMeasurableImpressions.
                         * @member {google.protobuf.IInt64Value|null|undefined} activeViewMeasurableImpressions
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.activeViewMeasurableImpressions = null;

                        /**
                         * Metrics activeViewViewability.
                         * @member {google.protobuf.IDoubleValue|null|undefined} activeViewViewability
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.activeViewViewability = null;

                        /**
                         * Metrics allConversionsFromInteractionsRate.
                         * @member {google.protobuf.IDoubleValue|null|undefined} allConversionsFromInteractionsRate
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.allConversionsFromInteractionsRate = null;

                        /**
                         * Metrics allConversionsValue.
                         * @member {google.protobuf.IDoubleValue|null|undefined} allConversionsValue
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.allConversionsValue = null;

                        /**
                         * Metrics allConversions.
                         * @member {google.protobuf.IDoubleValue|null|undefined} allConversions
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.allConversions = null;

                        /**
                         * Metrics allConversionsValuePerCost.
                         * @member {google.protobuf.IDoubleValue|null|undefined} allConversionsValuePerCost
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.allConversionsValuePerCost = null;

                        /**
                         * Metrics allConversionsFromClickToCall.
                         * @member {google.protobuf.IDoubleValue|null|undefined} allConversionsFromClickToCall
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.allConversionsFromClickToCall = null;

                        /**
                         * Metrics allConversionsFromDirections.
                         * @member {google.protobuf.IDoubleValue|null|undefined} allConversionsFromDirections
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.allConversionsFromDirections = null;

                        /**
                         * Metrics allConversionsFromInteractionsValuePerInteraction.
                         * @member {google.protobuf.IDoubleValue|null|undefined} allConversionsFromInteractionsValuePerInteraction
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.allConversionsFromInteractionsValuePerInteraction = null;

                        /**
                         * Metrics allConversionsFromMenu.
                         * @member {google.protobuf.IDoubleValue|null|undefined} allConversionsFromMenu
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.allConversionsFromMenu = null;

                        /**
                         * Metrics allConversionsFromOrder.
                         * @member {google.protobuf.IDoubleValue|null|undefined} allConversionsFromOrder
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.allConversionsFromOrder = null;

                        /**
                         * Metrics allConversionsFromOtherEngagement.
                         * @member {google.protobuf.IDoubleValue|null|undefined} allConversionsFromOtherEngagement
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.allConversionsFromOtherEngagement = null;

                        /**
                         * Metrics allConversionsFromStoreVisit.
                         * @member {google.protobuf.IDoubleValue|null|undefined} allConversionsFromStoreVisit
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.allConversionsFromStoreVisit = null;

                        /**
                         * Metrics allConversionsFromStoreWebsite.
                         * @member {google.protobuf.IDoubleValue|null|undefined} allConversionsFromStoreWebsite
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.allConversionsFromStoreWebsite = null;

                        /**
                         * Metrics averageCost.
                         * @member {google.protobuf.IDoubleValue|null|undefined} averageCost
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.averageCost = null;

                        /**
                         * Metrics averageCpc.
                         * @member {google.protobuf.IDoubleValue|null|undefined} averageCpc
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.averageCpc = null;

                        /**
                         * Metrics averageCpe.
                         * @member {google.protobuf.IDoubleValue|null|undefined} averageCpe
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.averageCpe = null;

                        /**
                         * Metrics averageCpm.
                         * @member {google.protobuf.IDoubleValue|null|undefined} averageCpm
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.averageCpm = null;

                        /**
                         * Metrics averageCpv.
                         * @member {google.protobuf.IDoubleValue|null|undefined} averageCpv
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.averageCpv = null;

                        /**
                         * Metrics averageFrequency.
                         * @member {google.protobuf.IDoubleValue|null|undefined} averageFrequency
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.averageFrequency = null;

                        /**
                         * Metrics averagePageViews.
                         * @member {google.protobuf.IDoubleValue|null|undefined} averagePageViews
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.averagePageViews = null;

                        /**
                         * Metrics averagePosition.
                         * @member {google.protobuf.IDoubleValue|null|undefined} averagePosition
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.averagePosition = null;

                        /**
                         * Metrics averageTimeOnSite.
                         * @member {google.protobuf.IDoubleValue|null|undefined} averageTimeOnSite
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.averageTimeOnSite = null;

                        /**
                         * Metrics benchmarkAverageMaxCpc.
                         * @member {google.protobuf.IDoubleValue|null|undefined} benchmarkAverageMaxCpc
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.benchmarkAverageMaxCpc = null;

                        /**
                         * Metrics benchmarkCtr.
                         * @member {google.protobuf.IDoubleValue|null|undefined} benchmarkCtr
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.benchmarkCtr = null;

                        /**
                         * Metrics bounceRate.
                         * @member {google.protobuf.IDoubleValue|null|undefined} bounceRate
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.bounceRate = null;

                        /**
                         * Metrics clicks.
                         * @member {google.protobuf.IInt64Value|null|undefined} clicks
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.clicks = null;

                        /**
                         * Metrics combinedClicks.
                         * @member {google.protobuf.IInt64Value|null|undefined} combinedClicks
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.combinedClicks = null;

                        /**
                         * Metrics combinedClicksPerQuery.
                         * @member {google.protobuf.IDoubleValue|null|undefined} combinedClicksPerQuery
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.combinedClicksPerQuery = null;

                        /**
                         * Metrics combinedQueries.
                         * @member {google.protobuf.IInt64Value|null|undefined} combinedQueries
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.combinedQueries = null;

                        /**
                         * Metrics contentBudgetLostImpressionShare.
                         * @member {google.protobuf.IDoubleValue|null|undefined} contentBudgetLostImpressionShare
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.contentBudgetLostImpressionShare = null;

                        /**
                         * Metrics contentImpressionShare.
                         * @member {google.protobuf.IDoubleValue|null|undefined} contentImpressionShare
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.contentImpressionShare = null;

                        /**
                         * Metrics conversionLastReceivedRequestDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} conversionLastReceivedRequestDateTime
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.conversionLastReceivedRequestDateTime = null;

                        /**
                         * Metrics conversionLastConversionDate.
                         * @member {google.protobuf.IStringValue|null|undefined} conversionLastConversionDate
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.conversionLastConversionDate = null;

                        /**
                         * Metrics contentRankLostImpressionShare.
                         * @member {google.protobuf.IDoubleValue|null|undefined} contentRankLostImpressionShare
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.contentRankLostImpressionShare = null;

                        /**
                         * Metrics conversionsFromInteractionsRate.
                         * @member {google.protobuf.IDoubleValue|null|undefined} conversionsFromInteractionsRate
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.conversionsFromInteractionsRate = null;

                        /**
                         * Metrics conversionsValue.
                         * @member {google.protobuf.IDoubleValue|null|undefined} conversionsValue
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.conversionsValue = null;

                        /**
                         * Metrics conversionsValuePerCost.
                         * @member {google.protobuf.IDoubleValue|null|undefined} conversionsValuePerCost
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.conversionsValuePerCost = null;

                        /**
                         * Metrics conversionsFromInteractionsValuePerInteraction.
                         * @member {google.protobuf.IDoubleValue|null|undefined} conversionsFromInteractionsValuePerInteraction
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.conversionsFromInteractionsValuePerInteraction = null;

                        /**
                         * Metrics conversions.
                         * @member {google.protobuf.IDoubleValue|null|undefined} conversions
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.conversions = null;

                        /**
                         * Metrics costMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} costMicros
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.costMicros = null;

                        /**
                         * Metrics costPerAllConversions.
                         * @member {google.protobuf.IDoubleValue|null|undefined} costPerAllConversions
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.costPerAllConversions = null;

                        /**
                         * Metrics costPerConversion.
                         * @member {google.protobuf.IDoubleValue|null|undefined} costPerConversion
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.costPerConversion = null;

                        /**
                         * Metrics costPerCurrentModelAttributedConversion.
                         * @member {google.protobuf.IDoubleValue|null|undefined} costPerCurrentModelAttributedConversion
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.costPerCurrentModelAttributedConversion = null;

                        /**
                         * Metrics crossDeviceConversions.
                         * @member {google.protobuf.IDoubleValue|null|undefined} crossDeviceConversions
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.crossDeviceConversions = null;

                        /**
                         * Metrics ctr.
                         * @member {google.protobuf.IDoubleValue|null|undefined} ctr
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.ctr = null;

                        /**
                         * Metrics currentModelAttributedConversions.
                         * @member {google.protobuf.IDoubleValue|null|undefined} currentModelAttributedConversions
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.currentModelAttributedConversions = null;

                        /**
                         * Metrics currentModelAttributedConversionsFromInteractionsRate.
                         * @member {google.protobuf.IDoubleValue|null|undefined} currentModelAttributedConversionsFromInteractionsRate
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.currentModelAttributedConversionsFromInteractionsRate = null;

                        /**
                         * Metrics currentModelAttributedConversionsFromInteractionsValuePerInteraction.
                         * @member {google.protobuf.IDoubleValue|null|undefined} currentModelAttributedConversionsFromInteractionsValuePerInteraction
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.currentModelAttributedConversionsFromInteractionsValuePerInteraction = null;

                        /**
                         * Metrics currentModelAttributedConversionsValue.
                         * @member {google.protobuf.IDoubleValue|null|undefined} currentModelAttributedConversionsValue
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.currentModelAttributedConversionsValue = null;

                        /**
                         * Metrics currentModelAttributedConversionsValuePerCost.
                         * @member {google.protobuf.IDoubleValue|null|undefined} currentModelAttributedConversionsValuePerCost
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.currentModelAttributedConversionsValuePerCost = null;

                        /**
                         * Metrics engagementRate.
                         * @member {google.protobuf.IDoubleValue|null|undefined} engagementRate
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.engagementRate = null;

                        /**
                         * Metrics engagements.
                         * @member {google.protobuf.IInt64Value|null|undefined} engagements
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.engagements = null;

                        /**
                         * Metrics hotelAverageLeadValueMicros.
                         * @member {google.protobuf.IDoubleValue|null|undefined} hotelAverageLeadValueMicros
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.hotelAverageLeadValueMicros = null;

                        /**
                         * Metrics historicalCreativeQualityScore.
                         * @member {google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket} historicalCreativeQualityScore
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.historicalCreativeQualityScore = 0;

                        /**
                         * Metrics historicalLandingPageQualityScore.
                         * @member {google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket} historicalLandingPageQualityScore
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.historicalLandingPageQualityScore = 0;

                        /**
                         * Metrics historicalQualityScore.
                         * @member {google.protobuf.IInt64Value|null|undefined} historicalQualityScore
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.historicalQualityScore = null;

                        /**
                         * Metrics historicalSearchPredictedCtr.
                         * @member {google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket} historicalSearchPredictedCtr
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.historicalSearchPredictedCtr = 0;

                        /**
                         * Metrics gmailForwards.
                         * @member {google.protobuf.IInt64Value|null|undefined} gmailForwards
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.gmailForwards = null;

                        /**
                         * Metrics gmailSaves.
                         * @member {google.protobuf.IInt64Value|null|undefined} gmailSaves
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.gmailSaves = null;

                        /**
                         * Metrics gmailSecondaryClicks.
                         * @member {google.protobuf.IInt64Value|null|undefined} gmailSecondaryClicks
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.gmailSecondaryClicks = null;

                        /**
                         * Metrics impressionReach.
                         * @member {google.protobuf.IInt64Value|null|undefined} impressionReach
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.impressionReach = null;

                        /**
                         * Metrics impressionsFromStoreReach.
                         * @member {google.protobuf.IInt64Value|null|undefined} impressionsFromStoreReach
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.impressionsFromStoreReach = null;

                        /**
                         * Metrics impressions.
                         * @member {google.protobuf.IInt64Value|null|undefined} impressions
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.impressions = null;

                        /**
                         * Metrics interactionRate.
                         * @member {google.protobuf.IDoubleValue|null|undefined} interactionRate
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.interactionRate = null;

                        /**
                         * Metrics interactions.
                         * @member {google.protobuf.IInt64Value|null|undefined} interactions
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.interactions = null;

                        /**
                         * Metrics interactionEventTypes.
                         * @member {Array.<google.ads.googleads.v1.enums.InteractionEventTypeEnum.InteractionEventType>} interactionEventTypes
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.interactionEventTypes = $util.emptyArray;

                        /**
                         * Metrics invalidClickRate.
                         * @member {google.protobuf.IDoubleValue|null|undefined} invalidClickRate
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.invalidClickRate = null;

                        /**
                         * Metrics invalidClicks.
                         * @member {google.protobuf.IInt64Value|null|undefined} invalidClicks
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.invalidClicks = null;

                        /**
                         * Metrics mobileFriendlyClicksPercentage.
                         * @member {google.protobuf.IDoubleValue|null|undefined} mobileFriendlyClicksPercentage
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.mobileFriendlyClicksPercentage = null;

                        /**
                         * Metrics organicClicks.
                         * @member {google.protobuf.IInt64Value|null|undefined} organicClicks
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.organicClicks = null;

                        /**
                         * Metrics organicClicksPerQuery.
                         * @member {google.protobuf.IDoubleValue|null|undefined} organicClicksPerQuery
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.organicClicksPerQuery = null;

                        /**
                         * Metrics organicImpressions.
                         * @member {google.protobuf.IInt64Value|null|undefined} organicImpressions
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.organicImpressions = null;

                        /**
                         * Metrics organicImpressionsPerQuery.
                         * @member {google.protobuf.IDoubleValue|null|undefined} organicImpressionsPerQuery
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.organicImpressionsPerQuery = null;

                        /**
                         * Metrics organicQueries.
                         * @member {google.protobuf.IInt64Value|null|undefined} organicQueries
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.organicQueries = null;

                        /**
                         * Metrics percentNewVisitors.
                         * @member {google.protobuf.IDoubleValue|null|undefined} percentNewVisitors
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.percentNewVisitors = null;

                        /**
                         * Metrics phoneCalls.
                         * @member {google.protobuf.IInt64Value|null|undefined} phoneCalls
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.phoneCalls = null;

                        /**
                         * Metrics phoneImpressions.
                         * @member {google.protobuf.IInt64Value|null|undefined} phoneImpressions
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.phoneImpressions = null;

                        /**
                         * Metrics phoneThroughRate.
                         * @member {google.protobuf.IDoubleValue|null|undefined} phoneThroughRate
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.phoneThroughRate = null;

                        /**
                         * Metrics relativeCtr.
                         * @member {google.protobuf.IDoubleValue|null|undefined} relativeCtr
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.relativeCtr = null;

                        /**
                         * Metrics searchAbsoluteTopImpressionShare.
                         * @member {google.protobuf.IDoubleValue|null|undefined} searchAbsoluteTopImpressionShare
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.searchAbsoluteTopImpressionShare = null;

                        /**
                         * Metrics searchBudgetLostAbsoluteTopImpressionShare.
                         * @member {google.protobuf.IDoubleValue|null|undefined} searchBudgetLostAbsoluteTopImpressionShare
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.searchBudgetLostAbsoluteTopImpressionShare = null;

                        /**
                         * Metrics searchBudgetLostImpressionShare.
                         * @member {google.protobuf.IDoubleValue|null|undefined} searchBudgetLostImpressionShare
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.searchBudgetLostImpressionShare = null;

                        /**
                         * Metrics searchBudgetLostTopImpressionShare.
                         * @member {google.protobuf.IDoubleValue|null|undefined} searchBudgetLostTopImpressionShare
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.searchBudgetLostTopImpressionShare = null;

                        /**
                         * Metrics searchClickShare.
                         * @member {google.protobuf.IDoubleValue|null|undefined} searchClickShare
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.searchClickShare = null;

                        /**
                         * Metrics searchExactMatchImpressionShare.
                         * @member {google.protobuf.IDoubleValue|null|undefined} searchExactMatchImpressionShare
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.searchExactMatchImpressionShare = null;

                        /**
                         * Metrics searchImpressionShare.
                         * @member {google.protobuf.IDoubleValue|null|undefined} searchImpressionShare
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.searchImpressionShare = null;

                        /**
                         * Metrics searchRankLostAbsoluteTopImpressionShare.
                         * @member {google.protobuf.IDoubleValue|null|undefined} searchRankLostAbsoluteTopImpressionShare
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.searchRankLostAbsoluteTopImpressionShare = null;

                        /**
                         * Metrics searchRankLostImpressionShare.
                         * @member {google.protobuf.IDoubleValue|null|undefined} searchRankLostImpressionShare
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.searchRankLostImpressionShare = null;

                        /**
                         * Metrics searchRankLostTopImpressionShare.
                         * @member {google.protobuf.IDoubleValue|null|undefined} searchRankLostTopImpressionShare
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.searchRankLostTopImpressionShare = null;

                        /**
                         * Metrics searchTopImpressionShare.
                         * @member {google.protobuf.IDoubleValue|null|undefined} searchTopImpressionShare
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.searchTopImpressionShare = null;

                        /**
                         * Metrics speedScore.
                         * @member {google.protobuf.IInt64Value|null|undefined} speedScore
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.speedScore = null;

                        /**
                         * Metrics topImpressionPercentage.
                         * @member {google.protobuf.IDoubleValue|null|undefined} topImpressionPercentage
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.topImpressionPercentage = null;

                        /**
                         * Metrics validAcceleratedMobilePagesClicksPercentage.
                         * @member {google.protobuf.IDoubleValue|null|undefined} validAcceleratedMobilePagesClicksPercentage
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.validAcceleratedMobilePagesClicksPercentage = null;

                        /**
                         * Metrics valuePerAllConversions.
                         * @member {google.protobuf.IDoubleValue|null|undefined} valuePerAllConversions
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.valuePerAllConversions = null;

                        /**
                         * Metrics valuePerConversion.
                         * @member {google.protobuf.IDoubleValue|null|undefined} valuePerConversion
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.valuePerConversion = null;

                        /**
                         * Metrics valuePerCurrentModelAttributedConversion.
                         * @member {google.protobuf.IDoubleValue|null|undefined} valuePerCurrentModelAttributedConversion
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.valuePerCurrentModelAttributedConversion = null;

                        /**
                         * Metrics videoQuartile_100Rate.
                         * @member {google.protobuf.IDoubleValue|null|undefined} videoQuartile_100Rate
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.videoQuartile_100Rate = null;

                        /**
                         * Metrics videoQuartile_25Rate.
                         * @member {google.protobuf.IDoubleValue|null|undefined} videoQuartile_25Rate
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.videoQuartile_25Rate = null;

                        /**
                         * Metrics videoQuartile_50Rate.
                         * @member {google.protobuf.IDoubleValue|null|undefined} videoQuartile_50Rate
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.videoQuartile_50Rate = null;

                        /**
                         * Metrics videoQuartile_75Rate.
                         * @member {google.protobuf.IDoubleValue|null|undefined} videoQuartile_75Rate
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.videoQuartile_75Rate = null;

                        /**
                         * Metrics videoViewRate.
                         * @member {google.protobuf.IDoubleValue|null|undefined} videoViewRate
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.videoViewRate = null;

                        /**
                         * Metrics videoViews.
                         * @member {google.protobuf.IInt64Value|null|undefined} videoViews
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.videoViews = null;

                        /**
                         * Metrics viewThroughConversions.
                         * @member {google.protobuf.IInt64Value|null|undefined} viewThroughConversions
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         */
                        Metrics.prototype.viewThroughConversions = null;

                        /**
                         * Creates a new Metrics instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @static
                         * @param {google.ads.googleads.v1.common.IMetrics=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.Metrics} Metrics instance
                         */
                        Metrics.create = function create(properties) {
                            return new Metrics(properties);
                        };

                        /**
                         * Encodes the specified Metrics message. Does not implicitly {@link google.ads.googleads.v1.common.Metrics.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @static
                         * @param {google.ads.googleads.v1.common.IMetrics} message Metrics message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Metrics.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.activeViewCpm != null && message.hasOwnProperty("activeViewCpm"))
                                $root.google.protobuf.DoubleValue.encode(message.activeViewCpm, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.activeViewImpressions != null && message.hasOwnProperty("activeViewImpressions"))
                                $root.google.protobuf.Int64Value.encode(message.activeViewImpressions, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.activeViewMeasurableCostMicros != null && message.hasOwnProperty("activeViewMeasurableCostMicros"))
                                $root.google.protobuf.Int64Value.encode(message.activeViewMeasurableCostMicros, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.activeViewMeasurableImpressions != null && message.hasOwnProperty("activeViewMeasurableImpressions"))
                                $root.google.protobuf.Int64Value.encode(message.activeViewMeasurableImpressions, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.allConversions != null && message.hasOwnProperty("allConversions"))
                                $root.google.protobuf.DoubleValue.encode(message.allConversions, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.averageCost != null && message.hasOwnProperty("averageCost"))
                                $root.google.protobuf.DoubleValue.encode(message.averageCost, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.averageCpc != null && message.hasOwnProperty("averageCpc"))
                                $root.google.protobuf.DoubleValue.encode(message.averageCpc, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.averageCpm != null && message.hasOwnProperty("averageCpm"))
                                $root.google.protobuf.DoubleValue.encode(message.averageCpm, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.averageCpv != null && message.hasOwnProperty("averageCpv"))
                                $root.google.protobuf.DoubleValue.encode(message.averageCpv, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.averageFrequency != null && message.hasOwnProperty("averageFrequency"))
                                $root.google.protobuf.DoubleValue.encode(message.averageFrequency, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.averagePosition != null && message.hasOwnProperty("averagePosition"))
                                $root.google.protobuf.DoubleValue.encode(message.averagePosition, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                            if (message.benchmarkAverageMaxCpc != null && message.hasOwnProperty("benchmarkAverageMaxCpc"))
                                $root.google.protobuf.DoubleValue.encode(message.benchmarkAverageMaxCpc, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.bounceRate != null && message.hasOwnProperty("bounceRate"))
                                $root.google.protobuf.DoubleValue.encode(message.bounceRate, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
                            if (message.clicks != null && message.hasOwnProperty("clicks"))
                                $root.google.protobuf.Int64Value.encode(message.clicks, writer.uint32(/* id 19, wireType 2 =*/154).fork()).ldelim();
                            if (message.contentBudgetLostImpressionShare != null && message.hasOwnProperty("contentBudgetLostImpressionShare"))
                                $root.google.protobuf.DoubleValue.encode(message.contentBudgetLostImpressionShare, writer.uint32(/* id 20, wireType 2 =*/162).fork()).ldelim();
                            if (message.contentImpressionShare != null && message.hasOwnProperty("contentImpressionShare"))
                                $root.google.protobuf.DoubleValue.encode(message.contentImpressionShare, writer.uint32(/* id 21, wireType 2 =*/170).fork()).ldelim();
                            if (message.contentRankLostImpressionShare != null && message.hasOwnProperty("contentRankLostImpressionShare"))
                                $root.google.protobuf.DoubleValue.encode(message.contentRankLostImpressionShare, writer.uint32(/* id 22, wireType 2 =*/178).fork()).ldelim();
                            if (message.conversions != null && message.hasOwnProperty("conversions"))
                                $root.google.protobuf.DoubleValue.encode(message.conversions, writer.uint32(/* id 25, wireType 2 =*/202).fork()).ldelim();
                            if (message.costMicros != null && message.hasOwnProperty("costMicros"))
                                $root.google.protobuf.Int64Value.encode(message.costMicros, writer.uint32(/* id 26, wireType 2 =*/210).fork()).ldelim();
                            if (message.costPerConversion != null && message.hasOwnProperty("costPerConversion"))
                                $root.google.protobuf.DoubleValue.encode(message.costPerConversion, writer.uint32(/* id 28, wireType 2 =*/226).fork()).ldelim();
                            if (message.crossDeviceConversions != null && message.hasOwnProperty("crossDeviceConversions"))
                                $root.google.protobuf.DoubleValue.encode(message.crossDeviceConversions, writer.uint32(/* id 29, wireType 2 =*/234).fork()).ldelim();
                            if (message.ctr != null && message.hasOwnProperty("ctr"))
                                $root.google.protobuf.DoubleValue.encode(message.ctr, writer.uint32(/* id 30, wireType 2 =*/242).fork()).ldelim();
                            if (message.engagementRate != null && message.hasOwnProperty("engagementRate"))
                                $root.google.protobuf.DoubleValue.encode(message.engagementRate, writer.uint32(/* id 31, wireType 2 =*/250).fork()).ldelim();
                            if (message.engagements != null && message.hasOwnProperty("engagements"))
                                $root.google.protobuf.Int64Value.encode(message.engagements, writer.uint32(/* id 32, wireType 2 =*/258).fork()).ldelim();
                            if (message.impressionReach != null && message.hasOwnProperty("impressionReach"))
                                $root.google.protobuf.Int64Value.encode(message.impressionReach, writer.uint32(/* id 36, wireType 2 =*/290).fork()).ldelim();
                            if (message.impressions != null && message.hasOwnProperty("impressions"))
                                $root.google.protobuf.Int64Value.encode(message.impressions, writer.uint32(/* id 37, wireType 2 =*/298).fork()).ldelim();
                            if (message.interactionRate != null && message.hasOwnProperty("interactionRate"))
                                $root.google.protobuf.DoubleValue.encode(message.interactionRate, writer.uint32(/* id 38, wireType 2 =*/306).fork()).ldelim();
                            if (message.interactions != null && message.hasOwnProperty("interactions"))
                                $root.google.protobuf.Int64Value.encode(message.interactions, writer.uint32(/* id 39, wireType 2 =*/314).fork()).ldelim();
                            if (message.invalidClickRate != null && message.hasOwnProperty("invalidClickRate"))
                                $root.google.protobuf.DoubleValue.encode(message.invalidClickRate, writer.uint32(/* id 40, wireType 2 =*/322).fork()).ldelim();
                            if (message.invalidClicks != null && message.hasOwnProperty("invalidClicks"))
                                $root.google.protobuf.Int64Value.encode(message.invalidClicks, writer.uint32(/* id 41, wireType 2 =*/330).fork()).ldelim();
                            if (message.percentNewVisitors != null && message.hasOwnProperty("percentNewVisitors"))
                                $root.google.protobuf.DoubleValue.encode(message.percentNewVisitors, writer.uint32(/* id 42, wireType 2 =*/338).fork()).ldelim();
                            if (message.phoneCalls != null && message.hasOwnProperty("phoneCalls"))
                                $root.google.protobuf.Int64Value.encode(message.phoneCalls, writer.uint32(/* id 43, wireType 2 =*/346).fork()).ldelim();
                            if (message.phoneImpressions != null && message.hasOwnProperty("phoneImpressions"))
                                $root.google.protobuf.Int64Value.encode(message.phoneImpressions, writer.uint32(/* id 44, wireType 2 =*/354).fork()).ldelim();
                            if (message.phoneThroughRate != null && message.hasOwnProperty("phoneThroughRate"))
                                $root.google.protobuf.DoubleValue.encode(message.phoneThroughRate, writer.uint32(/* id 45, wireType 2 =*/362).fork()).ldelim();
                            if (message.relativeCtr != null && message.hasOwnProperty("relativeCtr"))
                                $root.google.protobuf.DoubleValue.encode(message.relativeCtr, writer.uint32(/* id 46, wireType 2 =*/370).fork()).ldelim();
                            if (message.searchBudgetLostImpressionShare != null && message.hasOwnProperty("searchBudgetLostImpressionShare"))
                                $root.google.protobuf.DoubleValue.encode(message.searchBudgetLostImpressionShare, writer.uint32(/* id 47, wireType 2 =*/378).fork()).ldelim();
                            if (message.searchClickShare != null && message.hasOwnProperty("searchClickShare"))
                                $root.google.protobuf.DoubleValue.encode(message.searchClickShare, writer.uint32(/* id 48, wireType 2 =*/386).fork()).ldelim();
                            if (message.searchExactMatchImpressionShare != null && message.hasOwnProperty("searchExactMatchImpressionShare"))
                                $root.google.protobuf.DoubleValue.encode(message.searchExactMatchImpressionShare, writer.uint32(/* id 49, wireType 2 =*/394).fork()).ldelim();
                            if (message.searchImpressionShare != null && message.hasOwnProperty("searchImpressionShare"))
                                $root.google.protobuf.DoubleValue.encode(message.searchImpressionShare, writer.uint32(/* id 50, wireType 2 =*/402).fork()).ldelim();
                            if (message.searchRankLostImpressionShare != null && message.hasOwnProperty("searchRankLostImpressionShare"))
                                $root.google.protobuf.DoubleValue.encode(message.searchRankLostImpressionShare, writer.uint32(/* id 51, wireType 2 =*/410).fork()).ldelim();
                            if (message.valuePerAllConversions != null && message.hasOwnProperty("valuePerAllConversions"))
                                $root.google.protobuf.DoubleValue.encode(message.valuePerAllConversions, writer.uint32(/* id 52, wireType 2 =*/418).fork()).ldelim();
                            if (message.valuePerConversion != null && message.hasOwnProperty("valuePerConversion"))
                                $root.google.protobuf.DoubleValue.encode(message.valuePerConversion, writer.uint32(/* id 53, wireType 2 =*/426).fork()).ldelim();
                            if (message.videoQuartile_100Rate != null && message.hasOwnProperty("videoQuartile_100Rate"))
                                $root.google.protobuf.DoubleValue.encode(message.videoQuartile_100Rate, writer.uint32(/* id 54, wireType 2 =*/434).fork()).ldelim();
                            if (message.videoQuartile_25Rate != null && message.hasOwnProperty("videoQuartile_25Rate"))
                                $root.google.protobuf.DoubleValue.encode(message.videoQuartile_25Rate, writer.uint32(/* id 55, wireType 2 =*/442).fork()).ldelim();
                            if (message.videoQuartile_50Rate != null && message.hasOwnProperty("videoQuartile_50Rate"))
                                $root.google.protobuf.DoubleValue.encode(message.videoQuartile_50Rate, writer.uint32(/* id 56, wireType 2 =*/450).fork()).ldelim();
                            if (message.videoQuartile_75Rate != null && message.hasOwnProperty("videoQuartile_75Rate"))
                                $root.google.protobuf.DoubleValue.encode(message.videoQuartile_75Rate, writer.uint32(/* id 57, wireType 2 =*/458).fork()).ldelim();
                            if (message.videoViewRate != null && message.hasOwnProperty("videoViewRate"))
                                $root.google.protobuf.DoubleValue.encode(message.videoViewRate, writer.uint32(/* id 58, wireType 2 =*/466).fork()).ldelim();
                            if (message.videoViews != null && message.hasOwnProperty("videoViews"))
                                $root.google.protobuf.Int64Value.encode(message.videoViews, writer.uint32(/* id 59, wireType 2 =*/474).fork()).ldelim();
                            if (message.viewThroughConversions != null && message.hasOwnProperty("viewThroughConversions"))
                                $root.google.protobuf.Int64Value.encode(message.viewThroughConversions, writer.uint32(/* id 60, wireType 2 =*/482).fork()).ldelim();
                            if (message.allConversionsValuePerCost != null && message.hasOwnProperty("allConversionsValuePerCost"))
                                $root.google.protobuf.DoubleValue.encode(message.allConversionsValuePerCost, writer.uint32(/* id 62, wireType 2 =*/498).fork()).ldelim();
                            if (message.allConversionsFromInteractionsRate != null && message.hasOwnProperty("allConversionsFromInteractionsRate"))
                                $root.google.protobuf.DoubleValue.encode(message.allConversionsFromInteractionsRate, writer.uint32(/* id 65, wireType 2 =*/522).fork()).ldelim();
                            if (message.allConversionsValue != null && message.hasOwnProperty("allConversionsValue"))
                                $root.google.protobuf.DoubleValue.encode(message.allConversionsValue, writer.uint32(/* id 66, wireType 2 =*/530).fork()).ldelim();
                            if (message.allConversionsFromInteractionsValuePerInteraction != null && message.hasOwnProperty("allConversionsFromInteractionsValuePerInteraction"))
                                $root.google.protobuf.DoubleValue.encode(message.allConversionsFromInteractionsValuePerInteraction, writer.uint32(/* id 67, wireType 2 =*/538).fork()).ldelim();
                            if (message.costPerAllConversions != null && message.hasOwnProperty("costPerAllConversions"))
                                $root.google.protobuf.DoubleValue.encode(message.costPerAllConversions, writer.uint32(/* id 68, wireType 2 =*/546).fork()).ldelim();
                            if (message.conversionsFromInteractionsRate != null && message.hasOwnProperty("conversionsFromInteractionsRate"))
                                $root.google.protobuf.DoubleValue.encode(message.conversionsFromInteractionsRate, writer.uint32(/* id 69, wireType 2 =*/554).fork()).ldelim();
                            if (message.conversionsValue != null && message.hasOwnProperty("conversionsValue"))
                                $root.google.protobuf.DoubleValue.encode(message.conversionsValue, writer.uint32(/* id 70, wireType 2 =*/562).fork()).ldelim();
                            if (message.conversionsValuePerCost != null && message.hasOwnProperty("conversionsValuePerCost"))
                                $root.google.protobuf.DoubleValue.encode(message.conversionsValuePerCost, writer.uint32(/* id 71, wireType 2 =*/570).fork()).ldelim();
                            if (message.conversionsFromInteractionsValuePerInteraction != null && message.hasOwnProperty("conversionsFromInteractionsValuePerInteraction"))
                                $root.google.protobuf.DoubleValue.encode(message.conversionsFromInteractionsValuePerInteraction, writer.uint32(/* id 72, wireType 2 =*/578).fork()).ldelim();
                            if (message.conversionLastReceivedRequestDateTime != null && message.hasOwnProperty("conversionLastReceivedRequestDateTime"))
                                $root.google.protobuf.StringValue.encode(message.conversionLastReceivedRequestDateTime, writer.uint32(/* id 73, wireType 2 =*/586).fork()).ldelim();
                            if (message.conversionLastConversionDate != null && message.hasOwnProperty("conversionLastConversionDate"))
                                $root.google.protobuf.StringValue.encode(message.conversionLastConversionDate, writer.uint32(/* id 74, wireType 2 =*/594).fork()).ldelim();
                            if (message.hotelAverageLeadValueMicros != null && message.hasOwnProperty("hotelAverageLeadValueMicros"))
                                $root.google.protobuf.DoubleValue.encode(message.hotelAverageLeadValueMicros, writer.uint32(/* id 75, wireType 2 =*/602).fork()).ldelim();
                            if (message.benchmarkCtr != null && message.hasOwnProperty("benchmarkCtr"))
                                $root.google.protobuf.DoubleValue.encode(message.benchmarkCtr, writer.uint32(/* id 77, wireType 2 =*/618).fork()).ldelim();
                            if (message.searchAbsoluteTopImpressionShare != null && message.hasOwnProperty("searchAbsoluteTopImpressionShare"))
                                $root.google.protobuf.DoubleValue.encode(message.searchAbsoluteTopImpressionShare, writer.uint32(/* id 78, wireType 2 =*/626).fork()).ldelim();
                            if (message.activeViewCtr != null && message.hasOwnProperty("activeViewCtr"))
                                $root.google.protobuf.DoubleValue.encode(message.activeViewCtr, writer.uint32(/* id 79, wireType 2 =*/634).fork()).ldelim();
                            if (message.historicalCreativeQualityScore != null && message.hasOwnProperty("historicalCreativeQualityScore"))
                                writer.uint32(/* id 80, wireType 0 =*/640).int32(message.historicalCreativeQualityScore);
                            if (message.historicalLandingPageQualityScore != null && message.hasOwnProperty("historicalLandingPageQualityScore"))
                                writer.uint32(/* id 81, wireType 0 =*/648).int32(message.historicalLandingPageQualityScore);
                            if (message.historicalQualityScore != null && message.hasOwnProperty("historicalQualityScore"))
                                $root.google.protobuf.Int64Value.encode(message.historicalQualityScore, writer.uint32(/* id 82, wireType 2 =*/658).fork()).ldelim();
                            if (message.historicalSearchPredictedCtr != null && message.hasOwnProperty("historicalSearchPredictedCtr"))
                                writer.uint32(/* id 83, wireType 0 =*/664).int32(message.historicalSearchPredictedCtr);
                            if (message.averageTimeOnSite != null && message.hasOwnProperty("averageTimeOnSite"))
                                $root.google.protobuf.DoubleValue.encode(message.averageTimeOnSite, writer.uint32(/* id 84, wireType 2 =*/674).fork()).ldelim();
                            if (message.gmailForwards != null && message.hasOwnProperty("gmailForwards"))
                                $root.google.protobuf.Int64Value.encode(message.gmailForwards, writer.uint32(/* id 85, wireType 2 =*/682).fork()).ldelim();
                            if (message.gmailSaves != null && message.hasOwnProperty("gmailSaves"))
                                $root.google.protobuf.Int64Value.encode(message.gmailSaves, writer.uint32(/* id 86, wireType 2 =*/690).fork()).ldelim();
                            if (message.gmailSecondaryClicks != null && message.hasOwnProperty("gmailSecondaryClicks"))
                                $root.google.protobuf.Int64Value.encode(message.gmailSecondaryClicks, writer.uint32(/* id 87, wireType 2 =*/698).fork()).ldelim();
                            if (message.searchBudgetLostAbsoluteTopImpressionShare != null && message.hasOwnProperty("searchBudgetLostAbsoluteTopImpressionShare"))
                                $root.google.protobuf.DoubleValue.encode(message.searchBudgetLostAbsoluteTopImpressionShare, writer.uint32(/* id 88, wireType 2 =*/706).fork()).ldelim();
                            if (message.searchBudgetLostTopImpressionShare != null && message.hasOwnProperty("searchBudgetLostTopImpressionShare"))
                                $root.google.protobuf.DoubleValue.encode(message.searchBudgetLostTopImpressionShare, writer.uint32(/* id 89, wireType 2 =*/714).fork()).ldelim();
                            if (message.searchRankLostAbsoluteTopImpressionShare != null && message.hasOwnProperty("searchRankLostAbsoluteTopImpressionShare"))
                                $root.google.protobuf.DoubleValue.encode(message.searchRankLostAbsoluteTopImpressionShare, writer.uint32(/* id 90, wireType 2 =*/722).fork()).ldelim();
                            if (message.searchRankLostTopImpressionShare != null && message.hasOwnProperty("searchRankLostTopImpressionShare"))
                                $root.google.protobuf.DoubleValue.encode(message.searchRankLostTopImpressionShare, writer.uint32(/* id 91, wireType 2 =*/730).fork()).ldelim();
                            if (message.searchTopImpressionShare != null && message.hasOwnProperty("searchTopImpressionShare"))
                                $root.google.protobuf.DoubleValue.encode(message.searchTopImpressionShare, writer.uint32(/* id 92, wireType 2 =*/738).fork()).ldelim();
                            if (message.topImpressionPercentage != null && message.hasOwnProperty("topImpressionPercentage"))
                                $root.google.protobuf.DoubleValue.encode(message.topImpressionPercentage, writer.uint32(/* id 93, wireType 2 =*/746).fork()).ldelim();
                            if (message.valuePerCurrentModelAttributedConversion != null && message.hasOwnProperty("valuePerCurrentModelAttributedConversion"))
                                $root.google.protobuf.DoubleValue.encode(message.valuePerCurrentModelAttributedConversion, writer.uint32(/* id 94, wireType 2 =*/754).fork()).ldelim();
                            if (message.absoluteTopImpressionPercentage != null && message.hasOwnProperty("absoluteTopImpressionPercentage"))
                                $root.google.protobuf.DoubleValue.encode(message.absoluteTopImpressionPercentage, writer.uint32(/* id 95, wireType 2 =*/762).fork()).ldelim();
                            if (message.activeViewMeasurability != null && message.hasOwnProperty("activeViewMeasurability"))
                                $root.google.protobuf.DoubleValue.encode(message.activeViewMeasurability, writer.uint32(/* id 96, wireType 2 =*/770).fork()).ldelim();
                            if (message.activeViewViewability != null && message.hasOwnProperty("activeViewViewability"))
                                $root.google.protobuf.DoubleValue.encode(message.activeViewViewability, writer.uint32(/* id 97, wireType 2 =*/778).fork()).ldelim();
                            if (message.averageCpe != null && message.hasOwnProperty("averageCpe"))
                                $root.google.protobuf.DoubleValue.encode(message.averageCpe, writer.uint32(/* id 98, wireType 2 =*/786).fork()).ldelim();
                            if (message.averagePageViews != null && message.hasOwnProperty("averagePageViews"))
                                $root.google.protobuf.DoubleValue.encode(message.averagePageViews, writer.uint32(/* id 99, wireType 2 =*/794).fork()).ldelim();
                            if (message.interactionEventTypes != null && message.interactionEventTypes.length) {
                                writer.uint32(/* id 100, wireType 2 =*/802).fork();
                                for (var i = 0; i < message.interactionEventTypes.length; ++i)
                                    writer.int32(message.interactionEventTypes[i]);
                                writer.ldelim();
                            }
                            if (message.currentModelAttributedConversions != null && message.hasOwnProperty("currentModelAttributedConversions"))
                                $root.google.protobuf.DoubleValue.encode(message.currentModelAttributedConversions, writer.uint32(/* id 101, wireType 2 =*/810).fork()).ldelim();
                            if (message.currentModelAttributedConversionsFromInteractionsRate != null && message.hasOwnProperty("currentModelAttributedConversionsFromInteractionsRate"))
                                $root.google.protobuf.DoubleValue.encode(message.currentModelAttributedConversionsFromInteractionsRate, writer.uint32(/* id 102, wireType 2 =*/818).fork()).ldelim();
                            if (message.currentModelAttributedConversionsFromInteractionsValuePerInteraction != null && message.hasOwnProperty("currentModelAttributedConversionsFromInteractionsValuePerInteraction"))
                                $root.google.protobuf.DoubleValue.encode(message.currentModelAttributedConversionsFromInteractionsValuePerInteraction, writer.uint32(/* id 103, wireType 2 =*/826).fork()).ldelim();
                            if (message.currentModelAttributedConversionsValue != null && message.hasOwnProperty("currentModelAttributedConversionsValue"))
                                $root.google.protobuf.DoubleValue.encode(message.currentModelAttributedConversionsValue, writer.uint32(/* id 104, wireType 2 =*/834).fork()).ldelim();
                            if (message.currentModelAttributedConversionsValuePerCost != null && message.hasOwnProperty("currentModelAttributedConversionsValuePerCost"))
                                $root.google.protobuf.DoubleValue.encode(message.currentModelAttributedConversionsValuePerCost, writer.uint32(/* id 105, wireType 2 =*/842).fork()).ldelim();
                            if (message.costPerCurrentModelAttributedConversion != null && message.hasOwnProperty("costPerCurrentModelAttributedConversion"))
                                $root.google.protobuf.DoubleValue.encode(message.costPerCurrentModelAttributedConversion, writer.uint32(/* id 106, wireType 2 =*/850).fork()).ldelim();
                            if (message.speedScore != null && message.hasOwnProperty("speedScore"))
                                $root.google.protobuf.Int64Value.encode(message.speedScore, writer.uint32(/* id 107, wireType 2 =*/858).fork()).ldelim();
                            if (message.validAcceleratedMobilePagesClicksPercentage != null && message.hasOwnProperty("validAcceleratedMobilePagesClicksPercentage"))
                                $root.google.protobuf.DoubleValue.encode(message.validAcceleratedMobilePagesClicksPercentage, writer.uint32(/* id 108, wireType 2 =*/866).fork()).ldelim();
                            if (message.mobileFriendlyClicksPercentage != null && message.hasOwnProperty("mobileFriendlyClicksPercentage"))
                                $root.google.protobuf.DoubleValue.encode(message.mobileFriendlyClicksPercentage, writer.uint32(/* id 109, wireType 2 =*/874).fork()).ldelim();
                            if (message.organicClicks != null && message.hasOwnProperty("organicClicks"))
                                $root.google.protobuf.Int64Value.encode(message.organicClicks, writer.uint32(/* id 110, wireType 2 =*/882).fork()).ldelim();
                            if (message.organicClicksPerQuery != null && message.hasOwnProperty("organicClicksPerQuery"))
                                $root.google.protobuf.DoubleValue.encode(message.organicClicksPerQuery, writer.uint32(/* id 111, wireType 2 =*/890).fork()).ldelim();
                            if (message.organicImpressions != null && message.hasOwnProperty("organicImpressions"))
                                $root.google.protobuf.Int64Value.encode(message.organicImpressions, writer.uint32(/* id 112, wireType 2 =*/898).fork()).ldelim();
                            if (message.organicImpressionsPerQuery != null && message.hasOwnProperty("organicImpressionsPerQuery"))
                                $root.google.protobuf.DoubleValue.encode(message.organicImpressionsPerQuery, writer.uint32(/* id 113, wireType 2 =*/906).fork()).ldelim();
                            if (message.organicQueries != null && message.hasOwnProperty("organicQueries"))
                                $root.google.protobuf.Int64Value.encode(message.organicQueries, writer.uint32(/* id 114, wireType 2 =*/914).fork()).ldelim();
                            if (message.combinedClicks != null && message.hasOwnProperty("combinedClicks"))
                                $root.google.protobuf.Int64Value.encode(message.combinedClicks, writer.uint32(/* id 115, wireType 2 =*/922).fork()).ldelim();
                            if (message.combinedClicksPerQuery != null && message.hasOwnProperty("combinedClicksPerQuery"))
                                $root.google.protobuf.DoubleValue.encode(message.combinedClicksPerQuery, writer.uint32(/* id 116, wireType 2 =*/930).fork()).ldelim();
                            if (message.combinedQueries != null && message.hasOwnProperty("combinedQueries"))
                                $root.google.protobuf.Int64Value.encode(message.combinedQueries, writer.uint32(/* id 117, wireType 2 =*/938).fork()).ldelim();
                            if (message.allConversionsFromClickToCall != null && message.hasOwnProperty("allConversionsFromClickToCall"))
                                $root.google.protobuf.DoubleValue.encode(message.allConversionsFromClickToCall, writer.uint32(/* id 118, wireType 2 =*/946).fork()).ldelim();
                            if (message.allConversionsFromDirections != null && message.hasOwnProperty("allConversionsFromDirections"))
                                $root.google.protobuf.DoubleValue.encode(message.allConversionsFromDirections, writer.uint32(/* id 119, wireType 2 =*/954).fork()).ldelim();
                            if (message.allConversionsFromMenu != null && message.hasOwnProperty("allConversionsFromMenu"))
                                $root.google.protobuf.DoubleValue.encode(message.allConversionsFromMenu, writer.uint32(/* id 120, wireType 2 =*/962).fork()).ldelim();
                            if (message.allConversionsFromOrder != null && message.hasOwnProperty("allConversionsFromOrder"))
                                $root.google.protobuf.DoubleValue.encode(message.allConversionsFromOrder, writer.uint32(/* id 121, wireType 2 =*/970).fork()).ldelim();
                            if (message.allConversionsFromOtherEngagement != null && message.hasOwnProperty("allConversionsFromOtherEngagement"))
                                $root.google.protobuf.DoubleValue.encode(message.allConversionsFromOtherEngagement, writer.uint32(/* id 122, wireType 2 =*/978).fork()).ldelim();
                            if (message.allConversionsFromStoreVisit != null && message.hasOwnProperty("allConversionsFromStoreVisit"))
                                $root.google.protobuf.DoubleValue.encode(message.allConversionsFromStoreVisit, writer.uint32(/* id 123, wireType 2 =*/986).fork()).ldelim();
                            if (message.allConversionsFromStoreWebsite != null && message.hasOwnProperty("allConversionsFromStoreWebsite"))
                                $root.google.protobuf.DoubleValue.encode(message.allConversionsFromStoreWebsite, writer.uint32(/* id 124, wireType 2 =*/994).fork()).ldelim();
                            if (message.impressionsFromStoreReach != null && message.hasOwnProperty("impressionsFromStoreReach"))
                                $root.google.protobuf.Int64Value.encode(message.impressionsFromStoreReach, writer.uint32(/* id 125, wireType 2 =*/1002).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified Metrics message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.Metrics.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @static
                         * @param {google.ads.googleads.v1.common.IMetrics} message Metrics message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Metrics.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a Metrics message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.Metrics} Metrics
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Metrics.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.Metrics();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 95:
                                    message.absoluteTopImpressionPercentage = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.activeViewCpm = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 79:
                                    message.activeViewCtr = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.activeViewImpressions = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 96:
                                    message.activeViewMeasurability = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.activeViewMeasurableCostMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.activeViewMeasurableImpressions = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 97:
                                    message.activeViewViewability = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 65:
                                    message.allConversionsFromInteractionsRate = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 66:
                                    message.allConversionsValue = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.allConversions = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 62:
                                    message.allConversionsValuePerCost = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 118:
                                    message.allConversionsFromClickToCall = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 119:
                                    message.allConversionsFromDirections = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 67:
                                    message.allConversionsFromInteractionsValuePerInteraction = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 120:
                                    message.allConversionsFromMenu = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 121:
                                    message.allConversionsFromOrder = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 122:
                                    message.allConversionsFromOtherEngagement = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 123:
                                    message.allConversionsFromStoreVisit = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 124:
                                    message.allConversionsFromStoreWebsite = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.averageCost = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.averageCpc = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 98:
                                    message.averageCpe = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.averageCpm = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.averageCpv = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.averageFrequency = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 99:
                                    message.averagePageViews = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 13:
                                    message.averagePosition = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 84:
                                    message.averageTimeOnSite = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 14:
                                    message.benchmarkAverageMaxCpc = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 77:
                                    message.benchmarkCtr = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 15:
                                    message.bounceRate = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 19:
                                    message.clicks = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 115:
                                    message.combinedClicks = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 116:
                                    message.combinedClicksPerQuery = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 117:
                                    message.combinedQueries = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 20:
                                    message.contentBudgetLostImpressionShare = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 21:
                                    message.contentImpressionShare = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 73:
                                    message.conversionLastReceivedRequestDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 74:
                                    message.conversionLastConversionDate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 22:
                                    message.contentRankLostImpressionShare = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 69:
                                    message.conversionsFromInteractionsRate = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 70:
                                    message.conversionsValue = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 71:
                                    message.conversionsValuePerCost = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 72:
                                    message.conversionsFromInteractionsValuePerInteraction = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 25:
                                    message.conversions = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 26:
                                    message.costMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 68:
                                    message.costPerAllConversions = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 28:
                                    message.costPerConversion = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 106:
                                    message.costPerCurrentModelAttributedConversion = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 29:
                                    message.crossDeviceConversions = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 30:
                                    message.ctr = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 101:
                                    message.currentModelAttributedConversions = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 102:
                                    message.currentModelAttributedConversionsFromInteractionsRate = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 103:
                                    message.currentModelAttributedConversionsFromInteractionsValuePerInteraction = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 104:
                                    message.currentModelAttributedConversionsValue = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 105:
                                    message.currentModelAttributedConversionsValuePerCost = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 31:
                                    message.engagementRate = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 32:
                                    message.engagements = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 75:
                                    message.hotelAverageLeadValueMicros = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 80:
                                    message.historicalCreativeQualityScore = reader.int32();
                                    break;
                                case 81:
                                    message.historicalLandingPageQualityScore = reader.int32();
                                    break;
                                case 82:
                                    message.historicalQualityScore = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 83:
                                    message.historicalSearchPredictedCtr = reader.int32();
                                    break;
                                case 85:
                                    message.gmailForwards = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 86:
                                    message.gmailSaves = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 87:
                                    message.gmailSecondaryClicks = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 36:
                                    message.impressionReach = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 125:
                                    message.impressionsFromStoreReach = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 37:
                                    message.impressions = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 38:
                                    message.interactionRate = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 39:
                                    message.interactions = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 100:
                                    if (!(message.interactionEventTypes && message.interactionEventTypes.length))
                                        message.interactionEventTypes = [];
                                    if ((tag & 7) === 2) {
                                        var end2 = reader.uint32() + reader.pos;
                                        while (reader.pos < end2)
                                            message.interactionEventTypes.push(reader.int32());
                                    } else
                                        message.interactionEventTypes.push(reader.int32());
                                    break;
                                case 40:
                                    message.invalidClickRate = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 41:
                                    message.invalidClicks = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 109:
                                    message.mobileFriendlyClicksPercentage = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 110:
                                    message.organicClicks = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 111:
                                    message.organicClicksPerQuery = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 112:
                                    message.organicImpressions = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 113:
                                    message.organicImpressionsPerQuery = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 114:
                                    message.organicQueries = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 42:
                                    message.percentNewVisitors = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 43:
                                    message.phoneCalls = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 44:
                                    message.phoneImpressions = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 45:
                                    message.phoneThroughRate = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 46:
                                    message.relativeCtr = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 78:
                                    message.searchAbsoluteTopImpressionShare = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 88:
                                    message.searchBudgetLostAbsoluteTopImpressionShare = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 47:
                                    message.searchBudgetLostImpressionShare = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 89:
                                    message.searchBudgetLostTopImpressionShare = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 48:
                                    message.searchClickShare = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 49:
                                    message.searchExactMatchImpressionShare = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 50:
                                    message.searchImpressionShare = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 90:
                                    message.searchRankLostAbsoluteTopImpressionShare = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 51:
                                    message.searchRankLostImpressionShare = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 91:
                                    message.searchRankLostTopImpressionShare = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 92:
                                    message.searchTopImpressionShare = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 107:
                                    message.speedScore = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 93:
                                    message.topImpressionPercentage = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 108:
                                    message.validAcceleratedMobilePagesClicksPercentage = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 52:
                                    message.valuePerAllConversions = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 53:
                                    message.valuePerConversion = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 94:
                                    message.valuePerCurrentModelAttributedConversion = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 54:
                                    message.videoQuartile_100Rate = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 55:
                                    message.videoQuartile_25Rate = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 56:
                                    message.videoQuartile_50Rate = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 57:
                                    message.videoQuartile_75Rate = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 58:
                                    message.videoViewRate = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 59:
                                    message.videoViews = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 60:
                                    message.viewThroughConversions = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a Metrics message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.Metrics} Metrics
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Metrics.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a Metrics message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Metrics.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.absoluteTopImpressionPercentage != null && message.hasOwnProperty("absoluteTopImpressionPercentage")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.absoluteTopImpressionPercentage);
                                if (error)
                                    return "absoluteTopImpressionPercentage." + error;
                            }
                            if (message.activeViewCpm != null && message.hasOwnProperty("activeViewCpm")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.activeViewCpm);
                                if (error)
                                    return "activeViewCpm." + error;
                            }
                            if (message.activeViewCtr != null && message.hasOwnProperty("activeViewCtr")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.activeViewCtr);
                                if (error)
                                    return "activeViewCtr." + error;
                            }
                            if (message.activeViewImpressions != null && message.hasOwnProperty("activeViewImpressions")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.activeViewImpressions);
                                if (error)
                                    return "activeViewImpressions." + error;
                            }
                            if (message.activeViewMeasurability != null && message.hasOwnProperty("activeViewMeasurability")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.activeViewMeasurability);
                                if (error)
                                    return "activeViewMeasurability." + error;
                            }
                            if (message.activeViewMeasurableCostMicros != null && message.hasOwnProperty("activeViewMeasurableCostMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.activeViewMeasurableCostMicros);
                                if (error)
                                    return "activeViewMeasurableCostMicros." + error;
                            }
                            if (message.activeViewMeasurableImpressions != null && message.hasOwnProperty("activeViewMeasurableImpressions")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.activeViewMeasurableImpressions);
                                if (error)
                                    return "activeViewMeasurableImpressions." + error;
                            }
                            if (message.activeViewViewability != null && message.hasOwnProperty("activeViewViewability")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.activeViewViewability);
                                if (error)
                                    return "activeViewViewability." + error;
                            }
                            if (message.allConversionsFromInteractionsRate != null && message.hasOwnProperty("allConversionsFromInteractionsRate")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.allConversionsFromInteractionsRate);
                                if (error)
                                    return "allConversionsFromInteractionsRate." + error;
                            }
                            if (message.allConversionsValue != null && message.hasOwnProperty("allConversionsValue")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.allConversionsValue);
                                if (error)
                                    return "allConversionsValue." + error;
                            }
                            if (message.allConversions != null && message.hasOwnProperty("allConversions")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.allConversions);
                                if (error)
                                    return "allConversions." + error;
                            }
                            if (message.allConversionsValuePerCost != null && message.hasOwnProperty("allConversionsValuePerCost")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.allConversionsValuePerCost);
                                if (error)
                                    return "allConversionsValuePerCost." + error;
                            }
                            if (message.allConversionsFromClickToCall != null && message.hasOwnProperty("allConversionsFromClickToCall")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.allConversionsFromClickToCall);
                                if (error)
                                    return "allConversionsFromClickToCall." + error;
                            }
                            if (message.allConversionsFromDirections != null && message.hasOwnProperty("allConversionsFromDirections")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.allConversionsFromDirections);
                                if (error)
                                    return "allConversionsFromDirections." + error;
                            }
                            if (message.allConversionsFromInteractionsValuePerInteraction != null && message.hasOwnProperty("allConversionsFromInteractionsValuePerInteraction")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.allConversionsFromInteractionsValuePerInteraction);
                                if (error)
                                    return "allConversionsFromInteractionsValuePerInteraction." + error;
                            }
                            if (message.allConversionsFromMenu != null && message.hasOwnProperty("allConversionsFromMenu")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.allConversionsFromMenu);
                                if (error)
                                    return "allConversionsFromMenu." + error;
                            }
                            if (message.allConversionsFromOrder != null && message.hasOwnProperty("allConversionsFromOrder")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.allConversionsFromOrder);
                                if (error)
                                    return "allConversionsFromOrder." + error;
                            }
                            if (message.allConversionsFromOtherEngagement != null && message.hasOwnProperty("allConversionsFromOtherEngagement")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.allConversionsFromOtherEngagement);
                                if (error)
                                    return "allConversionsFromOtherEngagement." + error;
                            }
                            if (message.allConversionsFromStoreVisit != null && message.hasOwnProperty("allConversionsFromStoreVisit")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.allConversionsFromStoreVisit);
                                if (error)
                                    return "allConversionsFromStoreVisit." + error;
                            }
                            if (message.allConversionsFromStoreWebsite != null && message.hasOwnProperty("allConversionsFromStoreWebsite")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.allConversionsFromStoreWebsite);
                                if (error)
                                    return "allConversionsFromStoreWebsite." + error;
                            }
                            if (message.averageCost != null && message.hasOwnProperty("averageCost")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.averageCost);
                                if (error)
                                    return "averageCost." + error;
                            }
                            if (message.averageCpc != null && message.hasOwnProperty("averageCpc")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.averageCpc);
                                if (error)
                                    return "averageCpc." + error;
                            }
                            if (message.averageCpe != null && message.hasOwnProperty("averageCpe")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.averageCpe);
                                if (error)
                                    return "averageCpe." + error;
                            }
                            if (message.averageCpm != null && message.hasOwnProperty("averageCpm")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.averageCpm);
                                if (error)
                                    return "averageCpm." + error;
                            }
                            if (message.averageCpv != null && message.hasOwnProperty("averageCpv")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.averageCpv);
                                if (error)
                                    return "averageCpv." + error;
                            }
                            if (message.averageFrequency != null && message.hasOwnProperty("averageFrequency")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.averageFrequency);
                                if (error)
                                    return "averageFrequency." + error;
                            }
                            if (message.averagePageViews != null && message.hasOwnProperty("averagePageViews")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.averagePageViews);
                                if (error)
                                    return "averagePageViews." + error;
                            }
                            if (message.averagePosition != null && message.hasOwnProperty("averagePosition")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.averagePosition);
                                if (error)
                                    return "averagePosition." + error;
                            }
                            if (message.averageTimeOnSite != null && message.hasOwnProperty("averageTimeOnSite")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.averageTimeOnSite);
                                if (error)
                                    return "averageTimeOnSite." + error;
                            }
                            if (message.benchmarkAverageMaxCpc != null && message.hasOwnProperty("benchmarkAverageMaxCpc")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.benchmarkAverageMaxCpc);
                                if (error)
                                    return "benchmarkAverageMaxCpc." + error;
                            }
                            if (message.benchmarkCtr != null && message.hasOwnProperty("benchmarkCtr")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.benchmarkCtr);
                                if (error)
                                    return "benchmarkCtr." + error;
                            }
                            if (message.bounceRate != null && message.hasOwnProperty("bounceRate")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.bounceRate);
                                if (error)
                                    return "bounceRate." + error;
                            }
                            if (message.clicks != null && message.hasOwnProperty("clicks")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.clicks);
                                if (error)
                                    return "clicks." + error;
                            }
                            if (message.combinedClicks != null && message.hasOwnProperty("combinedClicks")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.combinedClicks);
                                if (error)
                                    return "combinedClicks." + error;
                            }
                            if (message.combinedClicksPerQuery != null && message.hasOwnProperty("combinedClicksPerQuery")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.combinedClicksPerQuery);
                                if (error)
                                    return "combinedClicksPerQuery." + error;
                            }
                            if (message.combinedQueries != null && message.hasOwnProperty("combinedQueries")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.combinedQueries);
                                if (error)
                                    return "combinedQueries." + error;
                            }
                            if (message.contentBudgetLostImpressionShare != null && message.hasOwnProperty("contentBudgetLostImpressionShare")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.contentBudgetLostImpressionShare);
                                if (error)
                                    return "contentBudgetLostImpressionShare." + error;
                            }
                            if (message.contentImpressionShare != null && message.hasOwnProperty("contentImpressionShare")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.contentImpressionShare);
                                if (error)
                                    return "contentImpressionShare." + error;
                            }
                            if (message.conversionLastReceivedRequestDateTime != null && message.hasOwnProperty("conversionLastReceivedRequestDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.conversionLastReceivedRequestDateTime);
                                if (error)
                                    return "conversionLastReceivedRequestDateTime." + error;
                            }
                            if (message.conversionLastConversionDate != null && message.hasOwnProperty("conversionLastConversionDate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.conversionLastConversionDate);
                                if (error)
                                    return "conversionLastConversionDate." + error;
                            }
                            if (message.contentRankLostImpressionShare != null && message.hasOwnProperty("contentRankLostImpressionShare")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.contentRankLostImpressionShare);
                                if (error)
                                    return "contentRankLostImpressionShare." + error;
                            }
                            if (message.conversionsFromInteractionsRate != null && message.hasOwnProperty("conversionsFromInteractionsRate")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.conversionsFromInteractionsRate);
                                if (error)
                                    return "conversionsFromInteractionsRate." + error;
                            }
                            if (message.conversionsValue != null && message.hasOwnProperty("conversionsValue")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.conversionsValue);
                                if (error)
                                    return "conversionsValue." + error;
                            }
                            if (message.conversionsValuePerCost != null && message.hasOwnProperty("conversionsValuePerCost")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.conversionsValuePerCost);
                                if (error)
                                    return "conversionsValuePerCost." + error;
                            }
                            if (message.conversionsFromInteractionsValuePerInteraction != null && message.hasOwnProperty("conversionsFromInteractionsValuePerInteraction")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.conversionsFromInteractionsValuePerInteraction);
                                if (error)
                                    return "conversionsFromInteractionsValuePerInteraction." + error;
                            }
                            if (message.conversions != null && message.hasOwnProperty("conversions")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.conversions);
                                if (error)
                                    return "conversions." + error;
                            }
                            if (message.costMicros != null && message.hasOwnProperty("costMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.costMicros);
                                if (error)
                                    return "costMicros." + error;
                            }
                            if (message.costPerAllConversions != null && message.hasOwnProperty("costPerAllConversions")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.costPerAllConversions);
                                if (error)
                                    return "costPerAllConversions." + error;
                            }
                            if (message.costPerConversion != null && message.hasOwnProperty("costPerConversion")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.costPerConversion);
                                if (error)
                                    return "costPerConversion." + error;
                            }
                            if (message.costPerCurrentModelAttributedConversion != null && message.hasOwnProperty("costPerCurrentModelAttributedConversion")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.costPerCurrentModelAttributedConversion);
                                if (error)
                                    return "costPerCurrentModelAttributedConversion." + error;
                            }
                            if (message.crossDeviceConversions != null && message.hasOwnProperty("crossDeviceConversions")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.crossDeviceConversions);
                                if (error)
                                    return "crossDeviceConversions." + error;
                            }
                            if (message.ctr != null && message.hasOwnProperty("ctr")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.ctr);
                                if (error)
                                    return "ctr." + error;
                            }
                            if (message.currentModelAttributedConversions != null && message.hasOwnProperty("currentModelAttributedConversions")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.currentModelAttributedConversions);
                                if (error)
                                    return "currentModelAttributedConversions." + error;
                            }
                            if (message.currentModelAttributedConversionsFromInteractionsRate != null && message.hasOwnProperty("currentModelAttributedConversionsFromInteractionsRate")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.currentModelAttributedConversionsFromInteractionsRate);
                                if (error)
                                    return "currentModelAttributedConversionsFromInteractionsRate." + error;
                            }
                            if (message.currentModelAttributedConversionsFromInteractionsValuePerInteraction != null && message.hasOwnProperty("currentModelAttributedConversionsFromInteractionsValuePerInteraction")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.currentModelAttributedConversionsFromInteractionsValuePerInteraction);
                                if (error)
                                    return "currentModelAttributedConversionsFromInteractionsValuePerInteraction." + error;
                            }
                            if (message.currentModelAttributedConversionsValue != null && message.hasOwnProperty("currentModelAttributedConversionsValue")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.currentModelAttributedConversionsValue);
                                if (error)
                                    return "currentModelAttributedConversionsValue." + error;
                            }
                            if (message.currentModelAttributedConversionsValuePerCost != null && message.hasOwnProperty("currentModelAttributedConversionsValuePerCost")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.currentModelAttributedConversionsValuePerCost);
                                if (error)
                                    return "currentModelAttributedConversionsValuePerCost." + error;
                            }
                            if (message.engagementRate != null && message.hasOwnProperty("engagementRate")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.engagementRate);
                                if (error)
                                    return "engagementRate." + error;
                            }
                            if (message.engagements != null && message.hasOwnProperty("engagements")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.engagements);
                                if (error)
                                    return "engagements." + error;
                            }
                            if (message.hotelAverageLeadValueMicros != null && message.hasOwnProperty("hotelAverageLeadValueMicros")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.hotelAverageLeadValueMicros);
                                if (error)
                                    return "hotelAverageLeadValueMicros." + error;
                            }
                            if (message.historicalCreativeQualityScore != null && message.hasOwnProperty("historicalCreativeQualityScore"))
                                switch (message.historicalCreativeQualityScore) {
                                default:
                                    return "historicalCreativeQualityScore: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.historicalLandingPageQualityScore != null && message.hasOwnProperty("historicalLandingPageQualityScore"))
                                switch (message.historicalLandingPageQualityScore) {
                                default:
                                    return "historicalLandingPageQualityScore: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.historicalQualityScore != null && message.hasOwnProperty("historicalQualityScore")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.historicalQualityScore);
                                if (error)
                                    return "historicalQualityScore." + error;
                            }
                            if (message.historicalSearchPredictedCtr != null && message.hasOwnProperty("historicalSearchPredictedCtr"))
                                switch (message.historicalSearchPredictedCtr) {
                                default:
                                    return "historicalSearchPredictedCtr: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.gmailForwards != null && message.hasOwnProperty("gmailForwards")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.gmailForwards);
                                if (error)
                                    return "gmailForwards." + error;
                            }
                            if (message.gmailSaves != null && message.hasOwnProperty("gmailSaves")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.gmailSaves);
                                if (error)
                                    return "gmailSaves." + error;
                            }
                            if (message.gmailSecondaryClicks != null && message.hasOwnProperty("gmailSecondaryClicks")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.gmailSecondaryClicks);
                                if (error)
                                    return "gmailSecondaryClicks." + error;
                            }
                            if (message.impressionReach != null && message.hasOwnProperty("impressionReach")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.impressionReach);
                                if (error)
                                    return "impressionReach." + error;
                            }
                            if (message.impressionsFromStoreReach != null && message.hasOwnProperty("impressionsFromStoreReach")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.impressionsFromStoreReach);
                                if (error)
                                    return "impressionsFromStoreReach." + error;
                            }
                            if (message.impressions != null && message.hasOwnProperty("impressions")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.impressions);
                                if (error)
                                    return "impressions." + error;
                            }
                            if (message.interactionRate != null && message.hasOwnProperty("interactionRate")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.interactionRate);
                                if (error)
                                    return "interactionRate." + error;
                            }
                            if (message.interactions != null && message.hasOwnProperty("interactions")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.interactions);
                                if (error)
                                    return "interactions." + error;
                            }
                            if (message.interactionEventTypes != null && message.hasOwnProperty("interactionEventTypes")) {
                                if (!Array.isArray(message.interactionEventTypes))
                                    return "interactionEventTypes: array expected";
                                for (var i = 0; i < message.interactionEventTypes.length; ++i)
                                    switch (message.interactionEventTypes[i]) {
                                    default:
                                        return "interactionEventTypes: enum value[] expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                    case 5:
                                        break;
                                    }
                            }
                            if (message.invalidClickRate != null && message.hasOwnProperty("invalidClickRate")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.invalidClickRate);
                                if (error)
                                    return "invalidClickRate." + error;
                            }
                            if (message.invalidClicks != null && message.hasOwnProperty("invalidClicks")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.invalidClicks);
                                if (error)
                                    return "invalidClicks." + error;
                            }
                            if (message.mobileFriendlyClicksPercentage != null && message.hasOwnProperty("mobileFriendlyClicksPercentage")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.mobileFriendlyClicksPercentage);
                                if (error)
                                    return "mobileFriendlyClicksPercentage." + error;
                            }
                            if (message.organicClicks != null && message.hasOwnProperty("organicClicks")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.organicClicks);
                                if (error)
                                    return "organicClicks." + error;
                            }
                            if (message.organicClicksPerQuery != null && message.hasOwnProperty("organicClicksPerQuery")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.organicClicksPerQuery);
                                if (error)
                                    return "organicClicksPerQuery." + error;
                            }
                            if (message.organicImpressions != null && message.hasOwnProperty("organicImpressions")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.organicImpressions);
                                if (error)
                                    return "organicImpressions." + error;
                            }
                            if (message.organicImpressionsPerQuery != null && message.hasOwnProperty("organicImpressionsPerQuery")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.organicImpressionsPerQuery);
                                if (error)
                                    return "organicImpressionsPerQuery." + error;
                            }
                            if (message.organicQueries != null && message.hasOwnProperty("organicQueries")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.organicQueries);
                                if (error)
                                    return "organicQueries." + error;
                            }
                            if (message.percentNewVisitors != null && message.hasOwnProperty("percentNewVisitors")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.percentNewVisitors);
                                if (error)
                                    return "percentNewVisitors." + error;
                            }
                            if (message.phoneCalls != null && message.hasOwnProperty("phoneCalls")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.phoneCalls);
                                if (error)
                                    return "phoneCalls." + error;
                            }
                            if (message.phoneImpressions != null && message.hasOwnProperty("phoneImpressions")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.phoneImpressions);
                                if (error)
                                    return "phoneImpressions." + error;
                            }
                            if (message.phoneThroughRate != null && message.hasOwnProperty("phoneThroughRate")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.phoneThroughRate);
                                if (error)
                                    return "phoneThroughRate." + error;
                            }
                            if (message.relativeCtr != null && message.hasOwnProperty("relativeCtr")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.relativeCtr);
                                if (error)
                                    return "relativeCtr." + error;
                            }
                            if (message.searchAbsoluteTopImpressionShare != null && message.hasOwnProperty("searchAbsoluteTopImpressionShare")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.searchAbsoluteTopImpressionShare);
                                if (error)
                                    return "searchAbsoluteTopImpressionShare." + error;
                            }
                            if (message.searchBudgetLostAbsoluteTopImpressionShare != null && message.hasOwnProperty("searchBudgetLostAbsoluteTopImpressionShare")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.searchBudgetLostAbsoluteTopImpressionShare);
                                if (error)
                                    return "searchBudgetLostAbsoluteTopImpressionShare." + error;
                            }
                            if (message.searchBudgetLostImpressionShare != null && message.hasOwnProperty("searchBudgetLostImpressionShare")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.searchBudgetLostImpressionShare);
                                if (error)
                                    return "searchBudgetLostImpressionShare." + error;
                            }
                            if (message.searchBudgetLostTopImpressionShare != null && message.hasOwnProperty("searchBudgetLostTopImpressionShare")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.searchBudgetLostTopImpressionShare);
                                if (error)
                                    return "searchBudgetLostTopImpressionShare." + error;
                            }
                            if (message.searchClickShare != null && message.hasOwnProperty("searchClickShare")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.searchClickShare);
                                if (error)
                                    return "searchClickShare." + error;
                            }
                            if (message.searchExactMatchImpressionShare != null && message.hasOwnProperty("searchExactMatchImpressionShare")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.searchExactMatchImpressionShare);
                                if (error)
                                    return "searchExactMatchImpressionShare." + error;
                            }
                            if (message.searchImpressionShare != null && message.hasOwnProperty("searchImpressionShare")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.searchImpressionShare);
                                if (error)
                                    return "searchImpressionShare." + error;
                            }
                            if (message.searchRankLostAbsoluteTopImpressionShare != null && message.hasOwnProperty("searchRankLostAbsoluteTopImpressionShare")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.searchRankLostAbsoluteTopImpressionShare);
                                if (error)
                                    return "searchRankLostAbsoluteTopImpressionShare." + error;
                            }
                            if (message.searchRankLostImpressionShare != null && message.hasOwnProperty("searchRankLostImpressionShare")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.searchRankLostImpressionShare);
                                if (error)
                                    return "searchRankLostImpressionShare." + error;
                            }
                            if (message.searchRankLostTopImpressionShare != null && message.hasOwnProperty("searchRankLostTopImpressionShare")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.searchRankLostTopImpressionShare);
                                if (error)
                                    return "searchRankLostTopImpressionShare." + error;
                            }
                            if (message.searchTopImpressionShare != null && message.hasOwnProperty("searchTopImpressionShare")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.searchTopImpressionShare);
                                if (error)
                                    return "searchTopImpressionShare." + error;
                            }
                            if (message.speedScore != null && message.hasOwnProperty("speedScore")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.speedScore);
                                if (error)
                                    return "speedScore." + error;
                            }
                            if (message.topImpressionPercentage != null && message.hasOwnProperty("topImpressionPercentage")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.topImpressionPercentage);
                                if (error)
                                    return "topImpressionPercentage." + error;
                            }
                            if (message.validAcceleratedMobilePagesClicksPercentage != null && message.hasOwnProperty("validAcceleratedMobilePagesClicksPercentage")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.validAcceleratedMobilePagesClicksPercentage);
                                if (error)
                                    return "validAcceleratedMobilePagesClicksPercentage." + error;
                            }
                            if (message.valuePerAllConversions != null && message.hasOwnProperty("valuePerAllConversions")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.valuePerAllConversions);
                                if (error)
                                    return "valuePerAllConversions." + error;
                            }
                            if (message.valuePerConversion != null && message.hasOwnProperty("valuePerConversion")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.valuePerConversion);
                                if (error)
                                    return "valuePerConversion." + error;
                            }
                            if (message.valuePerCurrentModelAttributedConversion != null && message.hasOwnProperty("valuePerCurrentModelAttributedConversion")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.valuePerCurrentModelAttributedConversion);
                                if (error)
                                    return "valuePerCurrentModelAttributedConversion." + error;
                            }
                            if (message.videoQuartile_100Rate != null && message.hasOwnProperty("videoQuartile_100Rate")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.videoQuartile_100Rate);
                                if (error)
                                    return "videoQuartile_100Rate." + error;
                            }
                            if (message.videoQuartile_25Rate != null && message.hasOwnProperty("videoQuartile_25Rate")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.videoQuartile_25Rate);
                                if (error)
                                    return "videoQuartile_25Rate." + error;
                            }
                            if (message.videoQuartile_50Rate != null && message.hasOwnProperty("videoQuartile_50Rate")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.videoQuartile_50Rate);
                                if (error)
                                    return "videoQuartile_50Rate." + error;
                            }
                            if (message.videoQuartile_75Rate != null && message.hasOwnProperty("videoQuartile_75Rate")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.videoQuartile_75Rate);
                                if (error)
                                    return "videoQuartile_75Rate." + error;
                            }
                            if (message.videoViewRate != null && message.hasOwnProperty("videoViewRate")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.videoViewRate);
                                if (error)
                                    return "videoViewRate." + error;
                            }
                            if (message.videoViews != null && message.hasOwnProperty("videoViews")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.videoViews);
                                if (error)
                                    return "videoViews." + error;
                            }
                            if (message.viewThroughConversions != null && message.hasOwnProperty("viewThroughConversions")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.viewThroughConversions);
                                if (error)
                                    return "viewThroughConversions." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a Metrics message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.Metrics} Metrics
                         */
                        Metrics.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.Metrics)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.Metrics();
                            if (object.absoluteTopImpressionPercentage != null) {
                                if (typeof object.absoluteTopImpressionPercentage !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.absoluteTopImpressionPercentage: object expected");
                                message.absoluteTopImpressionPercentage = $root.google.protobuf.DoubleValue.fromObject(object.absoluteTopImpressionPercentage);
                            }
                            if (object.activeViewCpm != null) {
                                if (typeof object.activeViewCpm !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.activeViewCpm: object expected");
                                message.activeViewCpm = $root.google.protobuf.DoubleValue.fromObject(object.activeViewCpm);
                            }
                            if (object.activeViewCtr != null) {
                                if (typeof object.activeViewCtr !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.activeViewCtr: object expected");
                                message.activeViewCtr = $root.google.protobuf.DoubleValue.fromObject(object.activeViewCtr);
                            }
                            if (object.activeViewImpressions != null) {
                                if (typeof object.activeViewImpressions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.activeViewImpressions: object expected");
                                message.activeViewImpressions = $root.google.protobuf.Int64Value.fromObject(object.activeViewImpressions);
                            }
                            if (object.activeViewMeasurability != null) {
                                if (typeof object.activeViewMeasurability !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.activeViewMeasurability: object expected");
                                message.activeViewMeasurability = $root.google.protobuf.DoubleValue.fromObject(object.activeViewMeasurability);
                            }
                            if (object.activeViewMeasurableCostMicros != null) {
                                if (typeof object.activeViewMeasurableCostMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.activeViewMeasurableCostMicros: object expected");
                                message.activeViewMeasurableCostMicros = $root.google.protobuf.Int64Value.fromObject(object.activeViewMeasurableCostMicros);
                            }
                            if (object.activeViewMeasurableImpressions != null) {
                                if (typeof object.activeViewMeasurableImpressions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.activeViewMeasurableImpressions: object expected");
                                message.activeViewMeasurableImpressions = $root.google.protobuf.Int64Value.fromObject(object.activeViewMeasurableImpressions);
                            }
                            if (object.activeViewViewability != null) {
                                if (typeof object.activeViewViewability !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.activeViewViewability: object expected");
                                message.activeViewViewability = $root.google.protobuf.DoubleValue.fromObject(object.activeViewViewability);
                            }
                            if (object.allConversionsFromInteractionsRate != null) {
                                if (typeof object.allConversionsFromInteractionsRate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.allConversionsFromInteractionsRate: object expected");
                                message.allConversionsFromInteractionsRate = $root.google.protobuf.DoubleValue.fromObject(object.allConversionsFromInteractionsRate);
                            }
                            if (object.allConversionsValue != null) {
                                if (typeof object.allConversionsValue !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.allConversionsValue: object expected");
                                message.allConversionsValue = $root.google.protobuf.DoubleValue.fromObject(object.allConversionsValue);
                            }
                            if (object.allConversions != null) {
                                if (typeof object.allConversions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.allConversions: object expected");
                                message.allConversions = $root.google.protobuf.DoubleValue.fromObject(object.allConversions);
                            }
                            if (object.allConversionsValuePerCost != null) {
                                if (typeof object.allConversionsValuePerCost !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.allConversionsValuePerCost: object expected");
                                message.allConversionsValuePerCost = $root.google.protobuf.DoubleValue.fromObject(object.allConversionsValuePerCost);
                            }
                            if (object.allConversionsFromClickToCall != null) {
                                if (typeof object.allConversionsFromClickToCall !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.allConversionsFromClickToCall: object expected");
                                message.allConversionsFromClickToCall = $root.google.protobuf.DoubleValue.fromObject(object.allConversionsFromClickToCall);
                            }
                            if (object.allConversionsFromDirections != null) {
                                if (typeof object.allConversionsFromDirections !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.allConversionsFromDirections: object expected");
                                message.allConversionsFromDirections = $root.google.protobuf.DoubleValue.fromObject(object.allConversionsFromDirections);
                            }
                            if (object.allConversionsFromInteractionsValuePerInteraction != null) {
                                if (typeof object.allConversionsFromInteractionsValuePerInteraction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.allConversionsFromInteractionsValuePerInteraction: object expected");
                                message.allConversionsFromInteractionsValuePerInteraction = $root.google.protobuf.DoubleValue.fromObject(object.allConversionsFromInteractionsValuePerInteraction);
                            }
                            if (object.allConversionsFromMenu != null) {
                                if (typeof object.allConversionsFromMenu !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.allConversionsFromMenu: object expected");
                                message.allConversionsFromMenu = $root.google.protobuf.DoubleValue.fromObject(object.allConversionsFromMenu);
                            }
                            if (object.allConversionsFromOrder != null) {
                                if (typeof object.allConversionsFromOrder !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.allConversionsFromOrder: object expected");
                                message.allConversionsFromOrder = $root.google.protobuf.DoubleValue.fromObject(object.allConversionsFromOrder);
                            }
                            if (object.allConversionsFromOtherEngagement != null) {
                                if (typeof object.allConversionsFromOtherEngagement !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.allConversionsFromOtherEngagement: object expected");
                                message.allConversionsFromOtherEngagement = $root.google.protobuf.DoubleValue.fromObject(object.allConversionsFromOtherEngagement);
                            }
                            if (object.allConversionsFromStoreVisit != null) {
                                if (typeof object.allConversionsFromStoreVisit !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.allConversionsFromStoreVisit: object expected");
                                message.allConversionsFromStoreVisit = $root.google.protobuf.DoubleValue.fromObject(object.allConversionsFromStoreVisit);
                            }
                            if (object.allConversionsFromStoreWebsite != null) {
                                if (typeof object.allConversionsFromStoreWebsite !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.allConversionsFromStoreWebsite: object expected");
                                message.allConversionsFromStoreWebsite = $root.google.protobuf.DoubleValue.fromObject(object.allConversionsFromStoreWebsite);
                            }
                            if (object.averageCost != null) {
                                if (typeof object.averageCost !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.averageCost: object expected");
                                message.averageCost = $root.google.protobuf.DoubleValue.fromObject(object.averageCost);
                            }
                            if (object.averageCpc != null) {
                                if (typeof object.averageCpc !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.averageCpc: object expected");
                                message.averageCpc = $root.google.protobuf.DoubleValue.fromObject(object.averageCpc);
                            }
                            if (object.averageCpe != null) {
                                if (typeof object.averageCpe !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.averageCpe: object expected");
                                message.averageCpe = $root.google.protobuf.DoubleValue.fromObject(object.averageCpe);
                            }
                            if (object.averageCpm != null) {
                                if (typeof object.averageCpm !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.averageCpm: object expected");
                                message.averageCpm = $root.google.protobuf.DoubleValue.fromObject(object.averageCpm);
                            }
                            if (object.averageCpv != null) {
                                if (typeof object.averageCpv !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.averageCpv: object expected");
                                message.averageCpv = $root.google.protobuf.DoubleValue.fromObject(object.averageCpv);
                            }
                            if (object.averageFrequency != null) {
                                if (typeof object.averageFrequency !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.averageFrequency: object expected");
                                message.averageFrequency = $root.google.protobuf.DoubleValue.fromObject(object.averageFrequency);
                            }
                            if (object.averagePageViews != null) {
                                if (typeof object.averagePageViews !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.averagePageViews: object expected");
                                message.averagePageViews = $root.google.protobuf.DoubleValue.fromObject(object.averagePageViews);
                            }
                            if (object.averagePosition != null) {
                                if (typeof object.averagePosition !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.averagePosition: object expected");
                                message.averagePosition = $root.google.protobuf.DoubleValue.fromObject(object.averagePosition);
                            }
                            if (object.averageTimeOnSite != null) {
                                if (typeof object.averageTimeOnSite !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.averageTimeOnSite: object expected");
                                message.averageTimeOnSite = $root.google.protobuf.DoubleValue.fromObject(object.averageTimeOnSite);
                            }
                            if (object.benchmarkAverageMaxCpc != null) {
                                if (typeof object.benchmarkAverageMaxCpc !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.benchmarkAverageMaxCpc: object expected");
                                message.benchmarkAverageMaxCpc = $root.google.protobuf.DoubleValue.fromObject(object.benchmarkAverageMaxCpc);
                            }
                            if (object.benchmarkCtr != null) {
                                if (typeof object.benchmarkCtr !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.benchmarkCtr: object expected");
                                message.benchmarkCtr = $root.google.protobuf.DoubleValue.fromObject(object.benchmarkCtr);
                            }
                            if (object.bounceRate != null) {
                                if (typeof object.bounceRate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.bounceRate: object expected");
                                message.bounceRate = $root.google.protobuf.DoubleValue.fromObject(object.bounceRate);
                            }
                            if (object.clicks != null) {
                                if (typeof object.clicks !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.clicks: object expected");
                                message.clicks = $root.google.protobuf.Int64Value.fromObject(object.clicks);
                            }
                            if (object.combinedClicks != null) {
                                if (typeof object.combinedClicks !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.combinedClicks: object expected");
                                message.combinedClicks = $root.google.protobuf.Int64Value.fromObject(object.combinedClicks);
                            }
                            if (object.combinedClicksPerQuery != null) {
                                if (typeof object.combinedClicksPerQuery !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.combinedClicksPerQuery: object expected");
                                message.combinedClicksPerQuery = $root.google.protobuf.DoubleValue.fromObject(object.combinedClicksPerQuery);
                            }
                            if (object.combinedQueries != null) {
                                if (typeof object.combinedQueries !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.combinedQueries: object expected");
                                message.combinedQueries = $root.google.protobuf.Int64Value.fromObject(object.combinedQueries);
                            }
                            if (object.contentBudgetLostImpressionShare != null) {
                                if (typeof object.contentBudgetLostImpressionShare !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.contentBudgetLostImpressionShare: object expected");
                                message.contentBudgetLostImpressionShare = $root.google.protobuf.DoubleValue.fromObject(object.contentBudgetLostImpressionShare);
                            }
                            if (object.contentImpressionShare != null) {
                                if (typeof object.contentImpressionShare !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.contentImpressionShare: object expected");
                                message.contentImpressionShare = $root.google.protobuf.DoubleValue.fromObject(object.contentImpressionShare);
                            }
                            if (object.conversionLastReceivedRequestDateTime != null) {
                                if (typeof object.conversionLastReceivedRequestDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.conversionLastReceivedRequestDateTime: object expected");
                                message.conversionLastReceivedRequestDateTime = $root.google.protobuf.StringValue.fromObject(object.conversionLastReceivedRequestDateTime);
                            }
                            if (object.conversionLastConversionDate != null) {
                                if (typeof object.conversionLastConversionDate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.conversionLastConversionDate: object expected");
                                message.conversionLastConversionDate = $root.google.protobuf.StringValue.fromObject(object.conversionLastConversionDate);
                            }
                            if (object.contentRankLostImpressionShare != null) {
                                if (typeof object.contentRankLostImpressionShare !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.contentRankLostImpressionShare: object expected");
                                message.contentRankLostImpressionShare = $root.google.protobuf.DoubleValue.fromObject(object.contentRankLostImpressionShare);
                            }
                            if (object.conversionsFromInteractionsRate != null) {
                                if (typeof object.conversionsFromInteractionsRate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.conversionsFromInteractionsRate: object expected");
                                message.conversionsFromInteractionsRate = $root.google.protobuf.DoubleValue.fromObject(object.conversionsFromInteractionsRate);
                            }
                            if (object.conversionsValue != null) {
                                if (typeof object.conversionsValue !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.conversionsValue: object expected");
                                message.conversionsValue = $root.google.protobuf.DoubleValue.fromObject(object.conversionsValue);
                            }
                            if (object.conversionsValuePerCost != null) {
                                if (typeof object.conversionsValuePerCost !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.conversionsValuePerCost: object expected");
                                message.conversionsValuePerCost = $root.google.protobuf.DoubleValue.fromObject(object.conversionsValuePerCost);
                            }
                            if (object.conversionsFromInteractionsValuePerInteraction != null) {
                                if (typeof object.conversionsFromInteractionsValuePerInteraction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.conversionsFromInteractionsValuePerInteraction: object expected");
                                message.conversionsFromInteractionsValuePerInteraction = $root.google.protobuf.DoubleValue.fromObject(object.conversionsFromInteractionsValuePerInteraction);
                            }
                            if (object.conversions != null) {
                                if (typeof object.conversions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.conversions: object expected");
                                message.conversions = $root.google.protobuf.DoubleValue.fromObject(object.conversions);
                            }
                            if (object.costMicros != null) {
                                if (typeof object.costMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.costMicros: object expected");
                                message.costMicros = $root.google.protobuf.Int64Value.fromObject(object.costMicros);
                            }
                            if (object.costPerAllConversions != null) {
                                if (typeof object.costPerAllConversions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.costPerAllConversions: object expected");
                                message.costPerAllConversions = $root.google.protobuf.DoubleValue.fromObject(object.costPerAllConversions);
                            }
                            if (object.costPerConversion != null) {
                                if (typeof object.costPerConversion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.costPerConversion: object expected");
                                message.costPerConversion = $root.google.protobuf.DoubleValue.fromObject(object.costPerConversion);
                            }
                            if (object.costPerCurrentModelAttributedConversion != null) {
                                if (typeof object.costPerCurrentModelAttributedConversion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.costPerCurrentModelAttributedConversion: object expected");
                                message.costPerCurrentModelAttributedConversion = $root.google.protobuf.DoubleValue.fromObject(object.costPerCurrentModelAttributedConversion);
                            }
                            if (object.crossDeviceConversions != null) {
                                if (typeof object.crossDeviceConversions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.crossDeviceConversions: object expected");
                                message.crossDeviceConversions = $root.google.protobuf.DoubleValue.fromObject(object.crossDeviceConversions);
                            }
                            if (object.ctr != null) {
                                if (typeof object.ctr !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.ctr: object expected");
                                message.ctr = $root.google.protobuf.DoubleValue.fromObject(object.ctr);
                            }
                            if (object.currentModelAttributedConversions != null) {
                                if (typeof object.currentModelAttributedConversions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.currentModelAttributedConversions: object expected");
                                message.currentModelAttributedConversions = $root.google.protobuf.DoubleValue.fromObject(object.currentModelAttributedConversions);
                            }
                            if (object.currentModelAttributedConversionsFromInteractionsRate != null) {
                                if (typeof object.currentModelAttributedConversionsFromInteractionsRate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.currentModelAttributedConversionsFromInteractionsRate: object expected");
                                message.currentModelAttributedConversionsFromInteractionsRate = $root.google.protobuf.DoubleValue.fromObject(object.currentModelAttributedConversionsFromInteractionsRate);
                            }
                            if (object.currentModelAttributedConversionsFromInteractionsValuePerInteraction != null) {
                                if (typeof object.currentModelAttributedConversionsFromInteractionsValuePerInteraction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.currentModelAttributedConversionsFromInteractionsValuePerInteraction: object expected");
                                message.currentModelAttributedConversionsFromInteractionsValuePerInteraction = $root.google.protobuf.DoubleValue.fromObject(object.currentModelAttributedConversionsFromInteractionsValuePerInteraction);
                            }
                            if (object.currentModelAttributedConversionsValue != null) {
                                if (typeof object.currentModelAttributedConversionsValue !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.currentModelAttributedConversionsValue: object expected");
                                message.currentModelAttributedConversionsValue = $root.google.protobuf.DoubleValue.fromObject(object.currentModelAttributedConversionsValue);
                            }
                            if (object.currentModelAttributedConversionsValuePerCost != null) {
                                if (typeof object.currentModelAttributedConversionsValuePerCost !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.currentModelAttributedConversionsValuePerCost: object expected");
                                message.currentModelAttributedConversionsValuePerCost = $root.google.protobuf.DoubleValue.fromObject(object.currentModelAttributedConversionsValuePerCost);
                            }
                            if (object.engagementRate != null) {
                                if (typeof object.engagementRate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.engagementRate: object expected");
                                message.engagementRate = $root.google.protobuf.DoubleValue.fromObject(object.engagementRate);
                            }
                            if (object.engagements != null) {
                                if (typeof object.engagements !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.engagements: object expected");
                                message.engagements = $root.google.protobuf.Int64Value.fromObject(object.engagements);
                            }
                            if (object.hotelAverageLeadValueMicros != null) {
                                if (typeof object.hotelAverageLeadValueMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.hotelAverageLeadValueMicros: object expected");
                                message.hotelAverageLeadValueMicros = $root.google.protobuf.DoubleValue.fromObject(object.hotelAverageLeadValueMicros);
                            }
                            switch (object.historicalCreativeQualityScore) {
                            case "UNSPECIFIED":
                            case 0:
                                message.historicalCreativeQualityScore = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.historicalCreativeQualityScore = 1;
                                break;
                            case "BELOW_AVERAGE":
                            case 2:
                                message.historicalCreativeQualityScore = 2;
                                break;
                            case "AVERAGE":
                            case 3:
                                message.historicalCreativeQualityScore = 3;
                                break;
                            case "ABOVE_AVERAGE":
                            case 4:
                                message.historicalCreativeQualityScore = 4;
                                break;
                            }
                            switch (object.historicalLandingPageQualityScore) {
                            case "UNSPECIFIED":
                            case 0:
                                message.historicalLandingPageQualityScore = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.historicalLandingPageQualityScore = 1;
                                break;
                            case "BELOW_AVERAGE":
                            case 2:
                                message.historicalLandingPageQualityScore = 2;
                                break;
                            case "AVERAGE":
                            case 3:
                                message.historicalLandingPageQualityScore = 3;
                                break;
                            case "ABOVE_AVERAGE":
                            case 4:
                                message.historicalLandingPageQualityScore = 4;
                                break;
                            }
                            if (object.historicalQualityScore != null) {
                                if (typeof object.historicalQualityScore !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.historicalQualityScore: object expected");
                                message.historicalQualityScore = $root.google.protobuf.Int64Value.fromObject(object.historicalQualityScore);
                            }
                            switch (object.historicalSearchPredictedCtr) {
                            case "UNSPECIFIED":
                            case 0:
                                message.historicalSearchPredictedCtr = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.historicalSearchPredictedCtr = 1;
                                break;
                            case "BELOW_AVERAGE":
                            case 2:
                                message.historicalSearchPredictedCtr = 2;
                                break;
                            case "AVERAGE":
                            case 3:
                                message.historicalSearchPredictedCtr = 3;
                                break;
                            case "ABOVE_AVERAGE":
                            case 4:
                                message.historicalSearchPredictedCtr = 4;
                                break;
                            }
                            if (object.gmailForwards != null) {
                                if (typeof object.gmailForwards !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.gmailForwards: object expected");
                                message.gmailForwards = $root.google.protobuf.Int64Value.fromObject(object.gmailForwards);
                            }
                            if (object.gmailSaves != null) {
                                if (typeof object.gmailSaves !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.gmailSaves: object expected");
                                message.gmailSaves = $root.google.protobuf.Int64Value.fromObject(object.gmailSaves);
                            }
                            if (object.gmailSecondaryClicks != null) {
                                if (typeof object.gmailSecondaryClicks !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.gmailSecondaryClicks: object expected");
                                message.gmailSecondaryClicks = $root.google.protobuf.Int64Value.fromObject(object.gmailSecondaryClicks);
                            }
                            if (object.impressionReach != null) {
                                if (typeof object.impressionReach !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.impressionReach: object expected");
                                message.impressionReach = $root.google.protobuf.Int64Value.fromObject(object.impressionReach);
                            }
                            if (object.impressionsFromStoreReach != null) {
                                if (typeof object.impressionsFromStoreReach !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.impressionsFromStoreReach: object expected");
                                message.impressionsFromStoreReach = $root.google.protobuf.Int64Value.fromObject(object.impressionsFromStoreReach);
                            }
                            if (object.impressions != null) {
                                if (typeof object.impressions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.impressions: object expected");
                                message.impressions = $root.google.protobuf.Int64Value.fromObject(object.impressions);
                            }
                            if (object.interactionRate != null) {
                                if (typeof object.interactionRate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.interactionRate: object expected");
                                message.interactionRate = $root.google.protobuf.DoubleValue.fromObject(object.interactionRate);
                            }
                            if (object.interactions != null) {
                                if (typeof object.interactions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.interactions: object expected");
                                message.interactions = $root.google.protobuf.Int64Value.fromObject(object.interactions);
                            }
                            if (object.interactionEventTypes) {
                                if (!Array.isArray(object.interactionEventTypes))
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.interactionEventTypes: array expected");
                                message.interactionEventTypes = [];
                                for (var i = 0; i < object.interactionEventTypes.length; ++i)
                                    switch (object.interactionEventTypes[i]) {
                                    default:
                                    case "UNSPECIFIED":
                                    case 0:
                                        message.interactionEventTypes[i] = 0;
                                        break;
                                    case "UNKNOWN":
                                    case 1:
                                        message.interactionEventTypes[i] = 1;
                                        break;
                                    case "CLICK":
                                    case 2:
                                        message.interactionEventTypes[i] = 2;
                                        break;
                                    case "ENGAGEMENT":
                                    case 3:
                                        message.interactionEventTypes[i] = 3;
                                        break;
                                    case "VIDEO_VIEW":
                                    case 4:
                                        message.interactionEventTypes[i] = 4;
                                        break;
                                    case "NONE":
                                    case 5:
                                        message.interactionEventTypes[i] = 5;
                                        break;
                                    }
                            }
                            if (object.invalidClickRate != null) {
                                if (typeof object.invalidClickRate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.invalidClickRate: object expected");
                                message.invalidClickRate = $root.google.protobuf.DoubleValue.fromObject(object.invalidClickRate);
                            }
                            if (object.invalidClicks != null) {
                                if (typeof object.invalidClicks !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.invalidClicks: object expected");
                                message.invalidClicks = $root.google.protobuf.Int64Value.fromObject(object.invalidClicks);
                            }
                            if (object.mobileFriendlyClicksPercentage != null) {
                                if (typeof object.mobileFriendlyClicksPercentage !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.mobileFriendlyClicksPercentage: object expected");
                                message.mobileFriendlyClicksPercentage = $root.google.protobuf.DoubleValue.fromObject(object.mobileFriendlyClicksPercentage);
                            }
                            if (object.organicClicks != null) {
                                if (typeof object.organicClicks !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.organicClicks: object expected");
                                message.organicClicks = $root.google.protobuf.Int64Value.fromObject(object.organicClicks);
                            }
                            if (object.organicClicksPerQuery != null) {
                                if (typeof object.organicClicksPerQuery !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.organicClicksPerQuery: object expected");
                                message.organicClicksPerQuery = $root.google.protobuf.DoubleValue.fromObject(object.organicClicksPerQuery);
                            }
                            if (object.organicImpressions != null) {
                                if (typeof object.organicImpressions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.organicImpressions: object expected");
                                message.organicImpressions = $root.google.protobuf.Int64Value.fromObject(object.organicImpressions);
                            }
                            if (object.organicImpressionsPerQuery != null) {
                                if (typeof object.organicImpressionsPerQuery !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.organicImpressionsPerQuery: object expected");
                                message.organicImpressionsPerQuery = $root.google.protobuf.DoubleValue.fromObject(object.organicImpressionsPerQuery);
                            }
                            if (object.organicQueries != null) {
                                if (typeof object.organicQueries !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.organicQueries: object expected");
                                message.organicQueries = $root.google.protobuf.Int64Value.fromObject(object.organicQueries);
                            }
                            if (object.percentNewVisitors != null) {
                                if (typeof object.percentNewVisitors !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.percentNewVisitors: object expected");
                                message.percentNewVisitors = $root.google.protobuf.DoubleValue.fromObject(object.percentNewVisitors);
                            }
                            if (object.phoneCalls != null) {
                                if (typeof object.phoneCalls !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.phoneCalls: object expected");
                                message.phoneCalls = $root.google.protobuf.Int64Value.fromObject(object.phoneCalls);
                            }
                            if (object.phoneImpressions != null) {
                                if (typeof object.phoneImpressions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.phoneImpressions: object expected");
                                message.phoneImpressions = $root.google.protobuf.Int64Value.fromObject(object.phoneImpressions);
                            }
                            if (object.phoneThroughRate != null) {
                                if (typeof object.phoneThroughRate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.phoneThroughRate: object expected");
                                message.phoneThroughRate = $root.google.protobuf.DoubleValue.fromObject(object.phoneThroughRate);
                            }
                            if (object.relativeCtr != null) {
                                if (typeof object.relativeCtr !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.relativeCtr: object expected");
                                message.relativeCtr = $root.google.protobuf.DoubleValue.fromObject(object.relativeCtr);
                            }
                            if (object.searchAbsoluteTopImpressionShare != null) {
                                if (typeof object.searchAbsoluteTopImpressionShare !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.searchAbsoluteTopImpressionShare: object expected");
                                message.searchAbsoluteTopImpressionShare = $root.google.protobuf.DoubleValue.fromObject(object.searchAbsoluteTopImpressionShare);
                            }
                            if (object.searchBudgetLostAbsoluteTopImpressionShare != null) {
                                if (typeof object.searchBudgetLostAbsoluteTopImpressionShare !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.searchBudgetLostAbsoluteTopImpressionShare: object expected");
                                message.searchBudgetLostAbsoluteTopImpressionShare = $root.google.protobuf.DoubleValue.fromObject(object.searchBudgetLostAbsoluteTopImpressionShare);
                            }
                            if (object.searchBudgetLostImpressionShare != null) {
                                if (typeof object.searchBudgetLostImpressionShare !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.searchBudgetLostImpressionShare: object expected");
                                message.searchBudgetLostImpressionShare = $root.google.protobuf.DoubleValue.fromObject(object.searchBudgetLostImpressionShare);
                            }
                            if (object.searchBudgetLostTopImpressionShare != null) {
                                if (typeof object.searchBudgetLostTopImpressionShare !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.searchBudgetLostTopImpressionShare: object expected");
                                message.searchBudgetLostTopImpressionShare = $root.google.protobuf.DoubleValue.fromObject(object.searchBudgetLostTopImpressionShare);
                            }
                            if (object.searchClickShare != null) {
                                if (typeof object.searchClickShare !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.searchClickShare: object expected");
                                message.searchClickShare = $root.google.protobuf.DoubleValue.fromObject(object.searchClickShare);
                            }
                            if (object.searchExactMatchImpressionShare != null) {
                                if (typeof object.searchExactMatchImpressionShare !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.searchExactMatchImpressionShare: object expected");
                                message.searchExactMatchImpressionShare = $root.google.protobuf.DoubleValue.fromObject(object.searchExactMatchImpressionShare);
                            }
                            if (object.searchImpressionShare != null) {
                                if (typeof object.searchImpressionShare !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.searchImpressionShare: object expected");
                                message.searchImpressionShare = $root.google.protobuf.DoubleValue.fromObject(object.searchImpressionShare);
                            }
                            if (object.searchRankLostAbsoluteTopImpressionShare != null) {
                                if (typeof object.searchRankLostAbsoluteTopImpressionShare !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.searchRankLostAbsoluteTopImpressionShare: object expected");
                                message.searchRankLostAbsoluteTopImpressionShare = $root.google.protobuf.DoubleValue.fromObject(object.searchRankLostAbsoluteTopImpressionShare);
                            }
                            if (object.searchRankLostImpressionShare != null) {
                                if (typeof object.searchRankLostImpressionShare !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.searchRankLostImpressionShare: object expected");
                                message.searchRankLostImpressionShare = $root.google.protobuf.DoubleValue.fromObject(object.searchRankLostImpressionShare);
                            }
                            if (object.searchRankLostTopImpressionShare != null) {
                                if (typeof object.searchRankLostTopImpressionShare !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.searchRankLostTopImpressionShare: object expected");
                                message.searchRankLostTopImpressionShare = $root.google.protobuf.DoubleValue.fromObject(object.searchRankLostTopImpressionShare);
                            }
                            if (object.searchTopImpressionShare != null) {
                                if (typeof object.searchTopImpressionShare !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.searchTopImpressionShare: object expected");
                                message.searchTopImpressionShare = $root.google.protobuf.DoubleValue.fromObject(object.searchTopImpressionShare);
                            }
                            if (object.speedScore != null) {
                                if (typeof object.speedScore !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.speedScore: object expected");
                                message.speedScore = $root.google.protobuf.Int64Value.fromObject(object.speedScore);
                            }
                            if (object.topImpressionPercentage != null) {
                                if (typeof object.topImpressionPercentage !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.topImpressionPercentage: object expected");
                                message.topImpressionPercentage = $root.google.protobuf.DoubleValue.fromObject(object.topImpressionPercentage);
                            }
                            if (object.validAcceleratedMobilePagesClicksPercentage != null) {
                                if (typeof object.validAcceleratedMobilePagesClicksPercentage !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.validAcceleratedMobilePagesClicksPercentage: object expected");
                                message.validAcceleratedMobilePagesClicksPercentage = $root.google.protobuf.DoubleValue.fromObject(object.validAcceleratedMobilePagesClicksPercentage);
                            }
                            if (object.valuePerAllConversions != null) {
                                if (typeof object.valuePerAllConversions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.valuePerAllConversions: object expected");
                                message.valuePerAllConversions = $root.google.protobuf.DoubleValue.fromObject(object.valuePerAllConversions);
                            }
                            if (object.valuePerConversion != null) {
                                if (typeof object.valuePerConversion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.valuePerConversion: object expected");
                                message.valuePerConversion = $root.google.protobuf.DoubleValue.fromObject(object.valuePerConversion);
                            }
                            if (object.valuePerCurrentModelAttributedConversion != null) {
                                if (typeof object.valuePerCurrentModelAttributedConversion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.valuePerCurrentModelAttributedConversion: object expected");
                                message.valuePerCurrentModelAttributedConversion = $root.google.protobuf.DoubleValue.fromObject(object.valuePerCurrentModelAttributedConversion);
                            }
                            if (object.videoQuartile_100Rate != null) {
                                if (typeof object.videoQuartile_100Rate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.videoQuartile_100Rate: object expected");
                                message.videoQuartile_100Rate = $root.google.protobuf.DoubleValue.fromObject(object.videoQuartile_100Rate);
                            }
                            if (object.videoQuartile_25Rate != null) {
                                if (typeof object.videoQuartile_25Rate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.videoQuartile_25Rate: object expected");
                                message.videoQuartile_25Rate = $root.google.protobuf.DoubleValue.fromObject(object.videoQuartile_25Rate);
                            }
                            if (object.videoQuartile_50Rate != null) {
                                if (typeof object.videoQuartile_50Rate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.videoQuartile_50Rate: object expected");
                                message.videoQuartile_50Rate = $root.google.protobuf.DoubleValue.fromObject(object.videoQuartile_50Rate);
                            }
                            if (object.videoQuartile_75Rate != null) {
                                if (typeof object.videoQuartile_75Rate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.videoQuartile_75Rate: object expected");
                                message.videoQuartile_75Rate = $root.google.protobuf.DoubleValue.fromObject(object.videoQuartile_75Rate);
                            }
                            if (object.videoViewRate != null) {
                                if (typeof object.videoViewRate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.videoViewRate: object expected");
                                message.videoViewRate = $root.google.protobuf.DoubleValue.fromObject(object.videoViewRate);
                            }
                            if (object.videoViews != null) {
                                if (typeof object.videoViews !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.videoViews: object expected");
                                message.videoViews = $root.google.protobuf.Int64Value.fromObject(object.videoViews);
                            }
                            if (object.viewThroughConversions != null) {
                                if (typeof object.viewThroughConversions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Metrics.viewThroughConversions: object expected");
                                message.viewThroughConversions = $root.google.protobuf.Int64Value.fromObject(object.viewThroughConversions);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a Metrics message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @static
                         * @param {google.ads.googleads.v1.common.Metrics} message Metrics
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Metrics.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.interactionEventTypes = [];
                            if (options.defaults) {
                                object.activeViewCpm = null;
                                object.activeViewImpressions = null;
                                object.activeViewMeasurableCostMicros = null;
                                object.activeViewMeasurableImpressions = null;
                                object.allConversions = null;
                                object.averageCost = null;
                                object.averageCpc = null;
                                object.averageCpm = null;
                                object.averageCpv = null;
                                object.averageFrequency = null;
                                object.averagePosition = null;
                                object.benchmarkAverageMaxCpc = null;
                                object.bounceRate = null;
                                object.clicks = null;
                                object.contentBudgetLostImpressionShare = null;
                                object.contentImpressionShare = null;
                                object.contentRankLostImpressionShare = null;
                                object.conversions = null;
                                object.costMicros = null;
                                object.costPerConversion = null;
                                object.crossDeviceConversions = null;
                                object.ctr = null;
                                object.engagementRate = null;
                                object.engagements = null;
                                object.impressionReach = null;
                                object.impressions = null;
                                object.interactionRate = null;
                                object.interactions = null;
                                object.invalidClickRate = null;
                                object.invalidClicks = null;
                                object.percentNewVisitors = null;
                                object.phoneCalls = null;
                                object.phoneImpressions = null;
                                object.phoneThroughRate = null;
                                object.relativeCtr = null;
                                object.searchBudgetLostImpressionShare = null;
                                object.searchClickShare = null;
                                object.searchExactMatchImpressionShare = null;
                                object.searchImpressionShare = null;
                                object.searchRankLostImpressionShare = null;
                                object.valuePerAllConversions = null;
                                object.valuePerConversion = null;
                                object.videoQuartile_100Rate = null;
                                object.videoQuartile_25Rate = null;
                                object.videoQuartile_50Rate = null;
                                object.videoQuartile_75Rate = null;
                                object.videoViewRate = null;
                                object.videoViews = null;
                                object.viewThroughConversions = null;
                                object.allConversionsValuePerCost = null;
                                object.allConversionsFromInteractionsRate = null;
                                object.allConversionsValue = null;
                                object.allConversionsFromInteractionsValuePerInteraction = null;
                                object.costPerAllConversions = null;
                                object.conversionsFromInteractionsRate = null;
                                object.conversionsValue = null;
                                object.conversionsValuePerCost = null;
                                object.conversionsFromInteractionsValuePerInteraction = null;
                                object.conversionLastReceivedRequestDateTime = null;
                                object.conversionLastConversionDate = null;
                                object.hotelAverageLeadValueMicros = null;
                                object.benchmarkCtr = null;
                                object.searchAbsoluteTopImpressionShare = null;
                                object.activeViewCtr = null;
                                object.historicalCreativeQualityScore = options.enums === String ? "UNSPECIFIED" : 0;
                                object.historicalLandingPageQualityScore = options.enums === String ? "UNSPECIFIED" : 0;
                                object.historicalQualityScore = null;
                                object.historicalSearchPredictedCtr = options.enums === String ? "UNSPECIFIED" : 0;
                                object.averageTimeOnSite = null;
                                object.gmailForwards = null;
                                object.gmailSaves = null;
                                object.gmailSecondaryClicks = null;
                                object.searchBudgetLostAbsoluteTopImpressionShare = null;
                                object.searchBudgetLostTopImpressionShare = null;
                                object.searchRankLostAbsoluteTopImpressionShare = null;
                                object.searchRankLostTopImpressionShare = null;
                                object.searchTopImpressionShare = null;
                                object.topImpressionPercentage = null;
                                object.valuePerCurrentModelAttributedConversion = null;
                                object.absoluteTopImpressionPercentage = null;
                                object.activeViewMeasurability = null;
                                object.activeViewViewability = null;
                                object.averageCpe = null;
                                object.averagePageViews = null;
                                object.currentModelAttributedConversions = null;
                                object.currentModelAttributedConversionsFromInteractionsRate = null;
                                object.currentModelAttributedConversionsFromInteractionsValuePerInteraction = null;
                                object.currentModelAttributedConversionsValue = null;
                                object.currentModelAttributedConversionsValuePerCost = null;
                                object.costPerCurrentModelAttributedConversion = null;
                                object.speedScore = null;
                                object.validAcceleratedMobilePagesClicksPercentage = null;
                                object.mobileFriendlyClicksPercentage = null;
                                object.organicClicks = null;
                                object.organicClicksPerQuery = null;
                                object.organicImpressions = null;
                                object.organicImpressionsPerQuery = null;
                                object.organicQueries = null;
                                object.combinedClicks = null;
                                object.combinedClicksPerQuery = null;
                                object.combinedQueries = null;
                                object.allConversionsFromClickToCall = null;
                                object.allConversionsFromDirections = null;
                                object.allConversionsFromMenu = null;
                                object.allConversionsFromOrder = null;
                                object.allConversionsFromOtherEngagement = null;
                                object.allConversionsFromStoreVisit = null;
                                object.allConversionsFromStoreWebsite = null;
                                object.impressionsFromStoreReach = null;
                            }
                            if (message.activeViewCpm != null && message.hasOwnProperty("activeViewCpm"))
                                object.activeViewCpm = $root.google.protobuf.DoubleValue.toObject(message.activeViewCpm, options);
                            if (message.activeViewImpressions != null && message.hasOwnProperty("activeViewImpressions"))
                                object.activeViewImpressions = $root.google.protobuf.Int64Value.toObject(message.activeViewImpressions, options);
                            if (message.activeViewMeasurableCostMicros != null && message.hasOwnProperty("activeViewMeasurableCostMicros"))
                                object.activeViewMeasurableCostMicros = $root.google.protobuf.Int64Value.toObject(message.activeViewMeasurableCostMicros, options);
                            if (message.activeViewMeasurableImpressions != null && message.hasOwnProperty("activeViewMeasurableImpressions"))
                                object.activeViewMeasurableImpressions = $root.google.protobuf.Int64Value.toObject(message.activeViewMeasurableImpressions, options);
                            if (message.allConversions != null && message.hasOwnProperty("allConversions"))
                                object.allConversions = $root.google.protobuf.DoubleValue.toObject(message.allConversions, options);
                            if (message.averageCost != null && message.hasOwnProperty("averageCost"))
                                object.averageCost = $root.google.protobuf.DoubleValue.toObject(message.averageCost, options);
                            if (message.averageCpc != null && message.hasOwnProperty("averageCpc"))
                                object.averageCpc = $root.google.protobuf.DoubleValue.toObject(message.averageCpc, options);
                            if (message.averageCpm != null && message.hasOwnProperty("averageCpm"))
                                object.averageCpm = $root.google.protobuf.DoubleValue.toObject(message.averageCpm, options);
                            if (message.averageCpv != null && message.hasOwnProperty("averageCpv"))
                                object.averageCpv = $root.google.protobuf.DoubleValue.toObject(message.averageCpv, options);
                            if (message.averageFrequency != null && message.hasOwnProperty("averageFrequency"))
                                object.averageFrequency = $root.google.protobuf.DoubleValue.toObject(message.averageFrequency, options);
                            if (message.averagePosition != null && message.hasOwnProperty("averagePosition"))
                                object.averagePosition = $root.google.protobuf.DoubleValue.toObject(message.averagePosition, options);
                            if (message.benchmarkAverageMaxCpc != null && message.hasOwnProperty("benchmarkAverageMaxCpc"))
                                object.benchmarkAverageMaxCpc = $root.google.protobuf.DoubleValue.toObject(message.benchmarkAverageMaxCpc, options);
                            if (message.bounceRate != null && message.hasOwnProperty("bounceRate"))
                                object.bounceRate = $root.google.protobuf.DoubleValue.toObject(message.bounceRate, options);
                            if (message.clicks != null && message.hasOwnProperty("clicks"))
                                object.clicks = $root.google.protobuf.Int64Value.toObject(message.clicks, options);
                            if (message.contentBudgetLostImpressionShare != null && message.hasOwnProperty("contentBudgetLostImpressionShare"))
                                object.contentBudgetLostImpressionShare = $root.google.protobuf.DoubleValue.toObject(message.contentBudgetLostImpressionShare, options);
                            if (message.contentImpressionShare != null && message.hasOwnProperty("contentImpressionShare"))
                                object.contentImpressionShare = $root.google.protobuf.DoubleValue.toObject(message.contentImpressionShare, options);
                            if (message.contentRankLostImpressionShare != null && message.hasOwnProperty("contentRankLostImpressionShare"))
                                object.contentRankLostImpressionShare = $root.google.protobuf.DoubleValue.toObject(message.contentRankLostImpressionShare, options);
                            if (message.conversions != null && message.hasOwnProperty("conversions"))
                                object.conversions = $root.google.protobuf.DoubleValue.toObject(message.conversions, options);
                            if (message.costMicros != null && message.hasOwnProperty("costMicros"))
                                object.costMicros = $root.google.protobuf.Int64Value.toObject(message.costMicros, options);
                            if (message.costPerConversion != null && message.hasOwnProperty("costPerConversion"))
                                object.costPerConversion = $root.google.protobuf.DoubleValue.toObject(message.costPerConversion, options);
                            if (message.crossDeviceConversions != null && message.hasOwnProperty("crossDeviceConversions"))
                                object.crossDeviceConversions = $root.google.protobuf.DoubleValue.toObject(message.crossDeviceConversions, options);
                            if (message.ctr != null && message.hasOwnProperty("ctr"))
                                object.ctr = $root.google.protobuf.DoubleValue.toObject(message.ctr, options);
                            if (message.engagementRate != null && message.hasOwnProperty("engagementRate"))
                                object.engagementRate = $root.google.protobuf.DoubleValue.toObject(message.engagementRate, options);
                            if (message.engagements != null && message.hasOwnProperty("engagements"))
                                object.engagements = $root.google.protobuf.Int64Value.toObject(message.engagements, options);
                            if (message.impressionReach != null && message.hasOwnProperty("impressionReach"))
                                object.impressionReach = $root.google.protobuf.Int64Value.toObject(message.impressionReach, options);
                            if (message.impressions != null && message.hasOwnProperty("impressions"))
                                object.impressions = $root.google.protobuf.Int64Value.toObject(message.impressions, options);
                            if (message.interactionRate != null && message.hasOwnProperty("interactionRate"))
                                object.interactionRate = $root.google.protobuf.DoubleValue.toObject(message.interactionRate, options);
                            if (message.interactions != null && message.hasOwnProperty("interactions"))
                                object.interactions = $root.google.protobuf.Int64Value.toObject(message.interactions, options);
                            if (message.invalidClickRate != null && message.hasOwnProperty("invalidClickRate"))
                                object.invalidClickRate = $root.google.protobuf.DoubleValue.toObject(message.invalidClickRate, options);
                            if (message.invalidClicks != null && message.hasOwnProperty("invalidClicks"))
                                object.invalidClicks = $root.google.protobuf.Int64Value.toObject(message.invalidClicks, options);
                            if (message.percentNewVisitors != null && message.hasOwnProperty("percentNewVisitors"))
                                object.percentNewVisitors = $root.google.protobuf.DoubleValue.toObject(message.percentNewVisitors, options);
                            if (message.phoneCalls != null && message.hasOwnProperty("phoneCalls"))
                                object.phoneCalls = $root.google.protobuf.Int64Value.toObject(message.phoneCalls, options);
                            if (message.phoneImpressions != null && message.hasOwnProperty("phoneImpressions"))
                                object.phoneImpressions = $root.google.protobuf.Int64Value.toObject(message.phoneImpressions, options);
                            if (message.phoneThroughRate != null && message.hasOwnProperty("phoneThroughRate"))
                                object.phoneThroughRate = $root.google.protobuf.DoubleValue.toObject(message.phoneThroughRate, options);
                            if (message.relativeCtr != null && message.hasOwnProperty("relativeCtr"))
                                object.relativeCtr = $root.google.protobuf.DoubleValue.toObject(message.relativeCtr, options);
                            if (message.searchBudgetLostImpressionShare != null && message.hasOwnProperty("searchBudgetLostImpressionShare"))
                                object.searchBudgetLostImpressionShare = $root.google.protobuf.DoubleValue.toObject(message.searchBudgetLostImpressionShare, options);
                            if (message.searchClickShare != null && message.hasOwnProperty("searchClickShare"))
                                object.searchClickShare = $root.google.protobuf.DoubleValue.toObject(message.searchClickShare, options);
                            if (message.searchExactMatchImpressionShare != null && message.hasOwnProperty("searchExactMatchImpressionShare"))
                                object.searchExactMatchImpressionShare = $root.google.protobuf.DoubleValue.toObject(message.searchExactMatchImpressionShare, options);
                            if (message.searchImpressionShare != null && message.hasOwnProperty("searchImpressionShare"))
                                object.searchImpressionShare = $root.google.protobuf.DoubleValue.toObject(message.searchImpressionShare, options);
                            if (message.searchRankLostImpressionShare != null && message.hasOwnProperty("searchRankLostImpressionShare"))
                                object.searchRankLostImpressionShare = $root.google.protobuf.DoubleValue.toObject(message.searchRankLostImpressionShare, options);
                            if (message.valuePerAllConversions != null && message.hasOwnProperty("valuePerAllConversions"))
                                object.valuePerAllConversions = $root.google.protobuf.DoubleValue.toObject(message.valuePerAllConversions, options);
                            if (message.valuePerConversion != null && message.hasOwnProperty("valuePerConversion"))
                                object.valuePerConversion = $root.google.protobuf.DoubleValue.toObject(message.valuePerConversion, options);
                            if (message.videoQuartile_100Rate != null && message.hasOwnProperty("videoQuartile_100Rate"))
                                object.videoQuartile_100Rate = $root.google.protobuf.DoubleValue.toObject(message.videoQuartile_100Rate, options);
                            if (message.videoQuartile_25Rate != null && message.hasOwnProperty("videoQuartile_25Rate"))
                                object.videoQuartile_25Rate = $root.google.protobuf.DoubleValue.toObject(message.videoQuartile_25Rate, options);
                            if (message.videoQuartile_50Rate != null && message.hasOwnProperty("videoQuartile_50Rate"))
                                object.videoQuartile_50Rate = $root.google.protobuf.DoubleValue.toObject(message.videoQuartile_50Rate, options);
                            if (message.videoQuartile_75Rate != null && message.hasOwnProperty("videoQuartile_75Rate"))
                                object.videoQuartile_75Rate = $root.google.protobuf.DoubleValue.toObject(message.videoQuartile_75Rate, options);
                            if (message.videoViewRate != null && message.hasOwnProperty("videoViewRate"))
                                object.videoViewRate = $root.google.protobuf.DoubleValue.toObject(message.videoViewRate, options);
                            if (message.videoViews != null && message.hasOwnProperty("videoViews"))
                                object.videoViews = $root.google.protobuf.Int64Value.toObject(message.videoViews, options);
                            if (message.viewThroughConversions != null && message.hasOwnProperty("viewThroughConversions"))
                                object.viewThroughConversions = $root.google.protobuf.Int64Value.toObject(message.viewThroughConversions, options);
                            if (message.allConversionsValuePerCost != null && message.hasOwnProperty("allConversionsValuePerCost"))
                                object.allConversionsValuePerCost = $root.google.protobuf.DoubleValue.toObject(message.allConversionsValuePerCost, options);
                            if (message.allConversionsFromInteractionsRate != null && message.hasOwnProperty("allConversionsFromInteractionsRate"))
                                object.allConversionsFromInteractionsRate = $root.google.protobuf.DoubleValue.toObject(message.allConversionsFromInteractionsRate, options);
                            if (message.allConversionsValue != null && message.hasOwnProperty("allConversionsValue"))
                                object.allConversionsValue = $root.google.protobuf.DoubleValue.toObject(message.allConversionsValue, options);
                            if (message.allConversionsFromInteractionsValuePerInteraction != null && message.hasOwnProperty("allConversionsFromInteractionsValuePerInteraction"))
                                object.allConversionsFromInteractionsValuePerInteraction = $root.google.protobuf.DoubleValue.toObject(message.allConversionsFromInteractionsValuePerInteraction, options);
                            if (message.costPerAllConversions != null && message.hasOwnProperty("costPerAllConversions"))
                                object.costPerAllConversions = $root.google.protobuf.DoubleValue.toObject(message.costPerAllConversions, options);
                            if (message.conversionsFromInteractionsRate != null && message.hasOwnProperty("conversionsFromInteractionsRate"))
                                object.conversionsFromInteractionsRate = $root.google.protobuf.DoubleValue.toObject(message.conversionsFromInteractionsRate, options);
                            if (message.conversionsValue != null && message.hasOwnProperty("conversionsValue"))
                                object.conversionsValue = $root.google.protobuf.DoubleValue.toObject(message.conversionsValue, options);
                            if (message.conversionsValuePerCost != null && message.hasOwnProperty("conversionsValuePerCost"))
                                object.conversionsValuePerCost = $root.google.protobuf.DoubleValue.toObject(message.conversionsValuePerCost, options);
                            if (message.conversionsFromInteractionsValuePerInteraction != null && message.hasOwnProperty("conversionsFromInteractionsValuePerInteraction"))
                                object.conversionsFromInteractionsValuePerInteraction = $root.google.protobuf.DoubleValue.toObject(message.conversionsFromInteractionsValuePerInteraction, options);
                            if (message.conversionLastReceivedRequestDateTime != null && message.hasOwnProperty("conversionLastReceivedRequestDateTime"))
                                object.conversionLastReceivedRequestDateTime = $root.google.protobuf.StringValue.toObject(message.conversionLastReceivedRequestDateTime, options);
                            if (message.conversionLastConversionDate != null && message.hasOwnProperty("conversionLastConversionDate"))
                                object.conversionLastConversionDate = $root.google.protobuf.StringValue.toObject(message.conversionLastConversionDate, options);
                            if (message.hotelAverageLeadValueMicros != null && message.hasOwnProperty("hotelAverageLeadValueMicros"))
                                object.hotelAverageLeadValueMicros = $root.google.protobuf.DoubleValue.toObject(message.hotelAverageLeadValueMicros, options);
                            if (message.benchmarkCtr != null && message.hasOwnProperty("benchmarkCtr"))
                                object.benchmarkCtr = $root.google.protobuf.DoubleValue.toObject(message.benchmarkCtr, options);
                            if (message.searchAbsoluteTopImpressionShare != null && message.hasOwnProperty("searchAbsoluteTopImpressionShare"))
                                object.searchAbsoluteTopImpressionShare = $root.google.protobuf.DoubleValue.toObject(message.searchAbsoluteTopImpressionShare, options);
                            if (message.activeViewCtr != null && message.hasOwnProperty("activeViewCtr"))
                                object.activeViewCtr = $root.google.protobuf.DoubleValue.toObject(message.activeViewCtr, options);
                            if (message.historicalCreativeQualityScore != null && message.hasOwnProperty("historicalCreativeQualityScore"))
                                object.historicalCreativeQualityScore = options.enums === String ? $root.google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket[message.historicalCreativeQualityScore] : message.historicalCreativeQualityScore;
                            if (message.historicalLandingPageQualityScore != null && message.hasOwnProperty("historicalLandingPageQualityScore"))
                                object.historicalLandingPageQualityScore = options.enums === String ? $root.google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket[message.historicalLandingPageQualityScore] : message.historicalLandingPageQualityScore;
                            if (message.historicalQualityScore != null && message.hasOwnProperty("historicalQualityScore"))
                                object.historicalQualityScore = $root.google.protobuf.Int64Value.toObject(message.historicalQualityScore, options);
                            if (message.historicalSearchPredictedCtr != null && message.hasOwnProperty("historicalSearchPredictedCtr"))
                                object.historicalSearchPredictedCtr = options.enums === String ? $root.google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket[message.historicalSearchPredictedCtr] : message.historicalSearchPredictedCtr;
                            if (message.averageTimeOnSite != null && message.hasOwnProperty("averageTimeOnSite"))
                                object.averageTimeOnSite = $root.google.protobuf.DoubleValue.toObject(message.averageTimeOnSite, options);
                            if (message.gmailForwards != null && message.hasOwnProperty("gmailForwards"))
                                object.gmailForwards = $root.google.protobuf.Int64Value.toObject(message.gmailForwards, options);
                            if (message.gmailSaves != null && message.hasOwnProperty("gmailSaves"))
                                object.gmailSaves = $root.google.protobuf.Int64Value.toObject(message.gmailSaves, options);
                            if (message.gmailSecondaryClicks != null && message.hasOwnProperty("gmailSecondaryClicks"))
                                object.gmailSecondaryClicks = $root.google.protobuf.Int64Value.toObject(message.gmailSecondaryClicks, options);
                            if (message.searchBudgetLostAbsoluteTopImpressionShare != null && message.hasOwnProperty("searchBudgetLostAbsoluteTopImpressionShare"))
                                object.searchBudgetLostAbsoluteTopImpressionShare = $root.google.protobuf.DoubleValue.toObject(message.searchBudgetLostAbsoluteTopImpressionShare, options);
                            if (message.searchBudgetLostTopImpressionShare != null && message.hasOwnProperty("searchBudgetLostTopImpressionShare"))
                                object.searchBudgetLostTopImpressionShare = $root.google.protobuf.DoubleValue.toObject(message.searchBudgetLostTopImpressionShare, options);
                            if (message.searchRankLostAbsoluteTopImpressionShare != null && message.hasOwnProperty("searchRankLostAbsoluteTopImpressionShare"))
                                object.searchRankLostAbsoluteTopImpressionShare = $root.google.protobuf.DoubleValue.toObject(message.searchRankLostAbsoluteTopImpressionShare, options);
                            if (message.searchRankLostTopImpressionShare != null && message.hasOwnProperty("searchRankLostTopImpressionShare"))
                                object.searchRankLostTopImpressionShare = $root.google.protobuf.DoubleValue.toObject(message.searchRankLostTopImpressionShare, options);
                            if (message.searchTopImpressionShare != null && message.hasOwnProperty("searchTopImpressionShare"))
                                object.searchTopImpressionShare = $root.google.protobuf.DoubleValue.toObject(message.searchTopImpressionShare, options);
                            if (message.topImpressionPercentage != null && message.hasOwnProperty("topImpressionPercentage"))
                                object.topImpressionPercentage = $root.google.protobuf.DoubleValue.toObject(message.topImpressionPercentage, options);
                            if (message.valuePerCurrentModelAttributedConversion != null && message.hasOwnProperty("valuePerCurrentModelAttributedConversion"))
                                object.valuePerCurrentModelAttributedConversion = $root.google.protobuf.DoubleValue.toObject(message.valuePerCurrentModelAttributedConversion, options);
                            if (message.absoluteTopImpressionPercentage != null && message.hasOwnProperty("absoluteTopImpressionPercentage"))
                                object.absoluteTopImpressionPercentage = $root.google.protobuf.DoubleValue.toObject(message.absoluteTopImpressionPercentage, options);
                            if (message.activeViewMeasurability != null && message.hasOwnProperty("activeViewMeasurability"))
                                object.activeViewMeasurability = $root.google.protobuf.DoubleValue.toObject(message.activeViewMeasurability, options);
                            if (message.activeViewViewability != null && message.hasOwnProperty("activeViewViewability"))
                                object.activeViewViewability = $root.google.protobuf.DoubleValue.toObject(message.activeViewViewability, options);
                            if (message.averageCpe != null && message.hasOwnProperty("averageCpe"))
                                object.averageCpe = $root.google.protobuf.DoubleValue.toObject(message.averageCpe, options);
                            if (message.averagePageViews != null && message.hasOwnProperty("averagePageViews"))
                                object.averagePageViews = $root.google.protobuf.DoubleValue.toObject(message.averagePageViews, options);
                            if (message.interactionEventTypes && message.interactionEventTypes.length) {
                                object.interactionEventTypes = [];
                                for (var j = 0; j < message.interactionEventTypes.length; ++j)
                                    object.interactionEventTypes[j] = options.enums === String ? $root.google.ads.googleads.v1.enums.InteractionEventTypeEnum.InteractionEventType[message.interactionEventTypes[j]] : message.interactionEventTypes[j];
                            }
                            if (message.currentModelAttributedConversions != null && message.hasOwnProperty("currentModelAttributedConversions"))
                                object.currentModelAttributedConversions = $root.google.protobuf.DoubleValue.toObject(message.currentModelAttributedConversions, options);
                            if (message.currentModelAttributedConversionsFromInteractionsRate != null && message.hasOwnProperty("currentModelAttributedConversionsFromInteractionsRate"))
                                object.currentModelAttributedConversionsFromInteractionsRate = $root.google.protobuf.DoubleValue.toObject(message.currentModelAttributedConversionsFromInteractionsRate, options);
                            if (message.currentModelAttributedConversionsFromInteractionsValuePerInteraction != null && message.hasOwnProperty("currentModelAttributedConversionsFromInteractionsValuePerInteraction"))
                                object.currentModelAttributedConversionsFromInteractionsValuePerInteraction = $root.google.protobuf.DoubleValue.toObject(message.currentModelAttributedConversionsFromInteractionsValuePerInteraction, options);
                            if (message.currentModelAttributedConversionsValue != null && message.hasOwnProperty("currentModelAttributedConversionsValue"))
                                object.currentModelAttributedConversionsValue = $root.google.protobuf.DoubleValue.toObject(message.currentModelAttributedConversionsValue, options);
                            if (message.currentModelAttributedConversionsValuePerCost != null && message.hasOwnProperty("currentModelAttributedConversionsValuePerCost"))
                                object.currentModelAttributedConversionsValuePerCost = $root.google.protobuf.DoubleValue.toObject(message.currentModelAttributedConversionsValuePerCost, options);
                            if (message.costPerCurrentModelAttributedConversion != null && message.hasOwnProperty("costPerCurrentModelAttributedConversion"))
                                object.costPerCurrentModelAttributedConversion = $root.google.protobuf.DoubleValue.toObject(message.costPerCurrentModelAttributedConversion, options);
                            if (message.speedScore != null && message.hasOwnProperty("speedScore"))
                                object.speedScore = $root.google.protobuf.Int64Value.toObject(message.speedScore, options);
                            if (message.validAcceleratedMobilePagesClicksPercentage != null && message.hasOwnProperty("validAcceleratedMobilePagesClicksPercentage"))
                                object.validAcceleratedMobilePagesClicksPercentage = $root.google.protobuf.DoubleValue.toObject(message.validAcceleratedMobilePagesClicksPercentage, options);
                            if (message.mobileFriendlyClicksPercentage != null && message.hasOwnProperty("mobileFriendlyClicksPercentage"))
                                object.mobileFriendlyClicksPercentage = $root.google.protobuf.DoubleValue.toObject(message.mobileFriendlyClicksPercentage, options);
                            if (message.organicClicks != null && message.hasOwnProperty("organicClicks"))
                                object.organicClicks = $root.google.protobuf.Int64Value.toObject(message.organicClicks, options);
                            if (message.organicClicksPerQuery != null && message.hasOwnProperty("organicClicksPerQuery"))
                                object.organicClicksPerQuery = $root.google.protobuf.DoubleValue.toObject(message.organicClicksPerQuery, options);
                            if (message.organicImpressions != null && message.hasOwnProperty("organicImpressions"))
                                object.organicImpressions = $root.google.protobuf.Int64Value.toObject(message.organicImpressions, options);
                            if (message.organicImpressionsPerQuery != null && message.hasOwnProperty("organicImpressionsPerQuery"))
                                object.organicImpressionsPerQuery = $root.google.protobuf.DoubleValue.toObject(message.organicImpressionsPerQuery, options);
                            if (message.organicQueries != null && message.hasOwnProperty("organicQueries"))
                                object.organicQueries = $root.google.protobuf.Int64Value.toObject(message.organicQueries, options);
                            if (message.combinedClicks != null && message.hasOwnProperty("combinedClicks"))
                                object.combinedClicks = $root.google.protobuf.Int64Value.toObject(message.combinedClicks, options);
                            if (message.combinedClicksPerQuery != null && message.hasOwnProperty("combinedClicksPerQuery"))
                                object.combinedClicksPerQuery = $root.google.protobuf.DoubleValue.toObject(message.combinedClicksPerQuery, options);
                            if (message.combinedQueries != null && message.hasOwnProperty("combinedQueries"))
                                object.combinedQueries = $root.google.protobuf.Int64Value.toObject(message.combinedQueries, options);
                            if (message.allConversionsFromClickToCall != null && message.hasOwnProperty("allConversionsFromClickToCall"))
                                object.allConversionsFromClickToCall = $root.google.protobuf.DoubleValue.toObject(message.allConversionsFromClickToCall, options);
                            if (message.allConversionsFromDirections != null && message.hasOwnProperty("allConversionsFromDirections"))
                                object.allConversionsFromDirections = $root.google.protobuf.DoubleValue.toObject(message.allConversionsFromDirections, options);
                            if (message.allConversionsFromMenu != null && message.hasOwnProperty("allConversionsFromMenu"))
                                object.allConversionsFromMenu = $root.google.protobuf.DoubleValue.toObject(message.allConversionsFromMenu, options);
                            if (message.allConversionsFromOrder != null && message.hasOwnProperty("allConversionsFromOrder"))
                                object.allConversionsFromOrder = $root.google.protobuf.DoubleValue.toObject(message.allConversionsFromOrder, options);
                            if (message.allConversionsFromOtherEngagement != null && message.hasOwnProperty("allConversionsFromOtherEngagement"))
                                object.allConversionsFromOtherEngagement = $root.google.protobuf.DoubleValue.toObject(message.allConversionsFromOtherEngagement, options);
                            if (message.allConversionsFromStoreVisit != null && message.hasOwnProperty("allConversionsFromStoreVisit"))
                                object.allConversionsFromStoreVisit = $root.google.protobuf.DoubleValue.toObject(message.allConversionsFromStoreVisit, options);
                            if (message.allConversionsFromStoreWebsite != null && message.hasOwnProperty("allConversionsFromStoreWebsite"))
                                object.allConversionsFromStoreWebsite = $root.google.protobuf.DoubleValue.toObject(message.allConversionsFromStoreWebsite, options);
                            if (message.impressionsFromStoreReach != null && message.hasOwnProperty("impressionsFromStoreReach"))
                                object.impressionsFromStoreReach = $root.google.protobuf.Int64Value.toObject(message.impressionsFromStoreReach, options);
                            return object;
                        };

                        /**
                         * Converts this Metrics to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.Metrics
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Metrics.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return Metrics;
                    })();

                    common.PolicyViolationKey = (function() {

                        /**
                         * Properties of a PolicyViolationKey.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IPolicyViolationKey
                         * @property {google.protobuf.IStringValue|null} [policyName] PolicyViolationKey policyName
                         * @property {google.protobuf.IStringValue|null} [violatingText] PolicyViolationKey violatingText
                         */

                        /**
                         * Constructs a new PolicyViolationKey.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a PolicyViolationKey.
                         * @implements IPolicyViolationKey
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IPolicyViolationKey=} [properties] Properties to set
                         */
                        function PolicyViolationKey(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * PolicyViolationKey policyName.
                         * @member {google.protobuf.IStringValue|null|undefined} policyName
                         * @memberof google.ads.googleads.v1.common.PolicyViolationKey
                         * @instance
                         */
                        PolicyViolationKey.prototype.policyName = null;

                        /**
                         * PolicyViolationKey violatingText.
                         * @member {google.protobuf.IStringValue|null|undefined} violatingText
                         * @memberof google.ads.googleads.v1.common.PolicyViolationKey
                         * @instance
                         */
                        PolicyViolationKey.prototype.violatingText = null;

                        /**
                         * Creates a new PolicyViolationKey instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.PolicyViolationKey
                         * @static
                         * @param {google.ads.googleads.v1.common.IPolicyViolationKey=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.PolicyViolationKey} PolicyViolationKey instance
                         */
                        PolicyViolationKey.create = function create(properties) {
                            return new PolicyViolationKey(properties);
                        };

                        /**
                         * Encodes the specified PolicyViolationKey message. Does not implicitly {@link google.ads.googleads.v1.common.PolicyViolationKey.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.PolicyViolationKey
                         * @static
                         * @param {google.ads.googleads.v1.common.IPolicyViolationKey} message PolicyViolationKey message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyViolationKey.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.policyName != null && message.hasOwnProperty("policyName"))
                                $root.google.protobuf.StringValue.encode(message.policyName, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.violatingText != null && message.hasOwnProperty("violatingText"))
                                $root.google.protobuf.StringValue.encode(message.violatingText, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified PolicyViolationKey message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PolicyViolationKey.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.PolicyViolationKey
                         * @static
                         * @param {google.ads.googleads.v1.common.IPolicyViolationKey} message PolicyViolationKey message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyViolationKey.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PolicyViolationKey message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.PolicyViolationKey
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.PolicyViolationKey} PolicyViolationKey
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyViolationKey.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PolicyViolationKey();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.policyName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.violatingText = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PolicyViolationKey message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.PolicyViolationKey
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.PolicyViolationKey} PolicyViolationKey
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyViolationKey.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PolicyViolationKey message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.PolicyViolationKey
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PolicyViolationKey.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.policyName != null && message.hasOwnProperty("policyName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.policyName);
                                if (error)
                                    return "policyName." + error;
                            }
                            if (message.violatingText != null && message.hasOwnProperty("violatingText")) {
                                var error = $root.google.protobuf.StringValue.verify(message.violatingText);
                                if (error)
                                    return "violatingText." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a PolicyViolationKey message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.PolicyViolationKey
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.PolicyViolationKey} PolicyViolationKey
                         */
                        PolicyViolationKey.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.PolicyViolationKey)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.PolicyViolationKey();
                            if (object.policyName != null) {
                                if (typeof object.policyName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PolicyViolationKey.policyName: object expected");
                                message.policyName = $root.google.protobuf.StringValue.fromObject(object.policyName);
                            }
                            if (object.violatingText != null) {
                                if (typeof object.violatingText !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PolicyViolationKey.violatingText: object expected");
                                message.violatingText = $root.google.protobuf.StringValue.fromObject(object.violatingText);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a PolicyViolationKey message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.PolicyViolationKey
                         * @static
                         * @param {google.ads.googleads.v1.common.PolicyViolationKey} message PolicyViolationKey
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PolicyViolationKey.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.policyName = null;
                                object.violatingText = null;
                            }
                            if (message.policyName != null && message.hasOwnProperty("policyName"))
                                object.policyName = $root.google.protobuf.StringValue.toObject(message.policyName, options);
                            if (message.violatingText != null && message.hasOwnProperty("violatingText"))
                                object.violatingText = $root.google.protobuf.StringValue.toObject(message.violatingText, options);
                            return object;
                        };

                        /**
                         * Converts this PolicyViolationKey to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.PolicyViolationKey
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PolicyViolationKey.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return PolicyViolationKey;
                    })();

                    common.PolicyValidationParameter = (function() {

                        /**
                         * Properties of a PolicyValidationParameter.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IPolicyValidationParameter
                         * @property {Array.<google.protobuf.IStringValue>|null} [ignorablePolicyTopics] PolicyValidationParameter ignorablePolicyTopics
                         * @property {Array.<google.ads.googleads.v1.common.IPolicyViolationKey>|null} [exemptPolicyViolationKeys] PolicyValidationParameter exemptPolicyViolationKeys
                         */

                        /**
                         * Constructs a new PolicyValidationParameter.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a PolicyValidationParameter.
                         * @implements IPolicyValidationParameter
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IPolicyValidationParameter=} [properties] Properties to set
                         */
                        function PolicyValidationParameter(properties) {
                            this.ignorablePolicyTopics = [];
                            this.exemptPolicyViolationKeys = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * PolicyValidationParameter ignorablePolicyTopics.
                         * @member {Array.<google.protobuf.IStringValue>} ignorablePolicyTopics
                         * @memberof google.ads.googleads.v1.common.PolicyValidationParameter
                         * @instance
                         */
                        PolicyValidationParameter.prototype.ignorablePolicyTopics = $util.emptyArray;

                        /**
                         * PolicyValidationParameter exemptPolicyViolationKeys.
                         * @member {Array.<google.ads.googleads.v1.common.IPolicyViolationKey>} exemptPolicyViolationKeys
                         * @memberof google.ads.googleads.v1.common.PolicyValidationParameter
                         * @instance
                         */
                        PolicyValidationParameter.prototype.exemptPolicyViolationKeys = $util.emptyArray;

                        /**
                         * Creates a new PolicyValidationParameter instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.PolicyValidationParameter
                         * @static
                         * @param {google.ads.googleads.v1.common.IPolicyValidationParameter=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.PolicyValidationParameter} PolicyValidationParameter instance
                         */
                        PolicyValidationParameter.create = function create(properties) {
                            return new PolicyValidationParameter(properties);
                        };

                        /**
                         * Encodes the specified PolicyValidationParameter message. Does not implicitly {@link google.ads.googleads.v1.common.PolicyValidationParameter.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.PolicyValidationParameter
                         * @static
                         * @param {google.ads.googleads.v1.common.IPolicyValidationParameter} message PolicyValidationParameter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyValidationParameter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.ignorablePolicyTopics != null && message.ignorablePolicyTopics.length)
                                for (var i = 0; i < message.ignorablePolicyTopics.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.ignorablePolicyTopics[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.exemptPolicyViolationKeys != null && message.exemptPolicyViolationKeys.length)
                                for (var i = 0; i < message.exemptPolicyViolationKeys.length; ++i)
                                    $root.google.ads.googleads.v1.common.PolicyViolationKey.encode(message.exemptPolicyViolationKeys[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified PolicyValidationParameter message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PolicyValidationParameter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.PolicyValidationParameter
                         * @static
                         * @param {google.ads.googleads.v1.common.IPolicyValidationParameter} message PolicyValidationParameter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyValidationParameter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PolicyValidationParameter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.PolicyValidationParameter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.PolicyValidationParameter} PolicyValidationParameter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyValidationParameter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PolicyValidationParameter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.ignorablePolicyTopics && message.ignorablePolicyTopics.length))
                                        message.ignorablePolicyTopics = [];
                                    message.ignorablePolicyTopics.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 2:
                                    if (!(message.exemptPolicyViolationKeys && message.exemptPolicyViolationKeys.length))
                                        message.exemptPolicyViolationKeys = [];
                                    message.exemptPolicyViolationKeys.push($root.google.ads.googleads.v1.common.PolicyViolationKey.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PolicyValidationParameter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.PolicyValidationParameter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.PolicyValidationParameter} PolicyValidationParameter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyValidationParameter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PolicyValidationParameter message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.PolicyValidationParameter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PolicyValidationParameter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.ignorablePolicyTopics != null && message.hasOwnProperty("ignorablePolicyTopics")) {
                                if (!Array.isArray(message.ignorablePolicyTopics))
                                    return "ignorablePolicyTopics: array expected";
                                for (var i = 0; i < message.ignorablePolicyTopics.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.ignorablePolicyTopics[i]);
                                    if (error)
                                        return "ignorablePolicyTopics." + error;
                                }
                            }
                            if (message.exemptPolicyViolationKeys != null && message.hasOwnProperty("exemptPolicyViolationKeys")) {
                                if (!Array.isArray(message.exemptPolicyViolationKeys))
                                    return "exemptPolicyViolationKeys: array expected";
                                for (var i = 0; i < message.exemptPolicyViolationKeys.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.PolicyViolationKey.verify(message.exemptPolicyViolationKeys[i]);
                                    if (error)
                                        return "exemptPolicyViolationKeys." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a PolicyValidationParameter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.PolicyValidationParameter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.PolicyValidationParameter} PolicyValidationParameter
                         */
                        PolicyValidationParameter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.PolicyValidationParameter)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.PolicyValidationParameter();
                            if (object.ignorablePolicyTopics) {
                                if (!Array.isArray(object.ignorablePolicyTopics))
                                    throw TypeError(".google.ads.googleads.v1.common.PolicyValidationParameter.ignorablePolicyTopics: array expected");
                                message.ignorablePolicyTopics = [];
                                for (var i = 0; i < object.ignorablePolicyTopics.length; ++i) {
                                    if (typeof object.ignorablePolicyTopics[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.PolicyValidationParameter.ignorablePolicyTopics: object expected");
                                    message.ignorablePolicyTopics[i] = $root.google.protobuf.StringValue.fromObject(object.ignorablePolicyTopics[i]);
                                }
                            }
                            if (object.exemptPolicyViolationKeys) {
                                if (!Array.isArray(object.exemptPolicyViolationKeys))
                                    throw TypeError(".google.ads.googleads.v1.common.PolicyValidationParameter.exemptPolicyViolationKeys: array expected");
                                message.exemptPolicyViolationKeys = [];
                                for (var i = 0; i < object.exemptPolicyViolationKeys.length; ++i) {
                                    if (typeof object.exemptPolicyViolationKeys[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.PolicyValidationParameter.exemptPolicyViolationKeys: object expected");
                                    message.exemptPolicyViolationKeys[i] = $root.google.ads.googleads.v1.common.PolicyViolationKey.fromObject(object.exemptPolicyViolationKeys[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a PolicyValidationParameter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.PolicyValidationParameter
                         * @static
                         * @param {google.ads.googleads.v1.common.PolicyValidationParameter} message PolicyValidationParameter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PolicyValidationParameter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.ignorablePolicyTopics = [];
                                object.exemptPolicyViolationKeys = [];
                            }
                            if (message.ignorablePolicyTopics && message.ignorablePolicyTopics.length) {
                                object.ignorablePolicyTopics = [];
                                for (var j = 0; j < message.ignorablePolicyTopics.length; ++j)
                                    object.ignorablePolicyTopics[j] = $root.google.protobuf.StringValue.toObject(message.ignorablePolicyTopics[j], options);
                            }
                            if (message.exemptPolicyViolationKeys && message.exemptPolicyViolationKeys.length) {
                                object.exemptPolicyViolationKeys = [];
                                for (var j = 0; j < message.exemptPolicyViolationKeys.length; ++j)
                                    object.exemptPolicyViolationKeys[j] = $root.google.ads.googleads.v1.common.PolicyViolationKey.toObject(message.exemptPolicyViolationKeys[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this PolicyValidationParameter to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.PolicyValidationParameter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PolicyValidationParameter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return PolicyValidationParameter;
                    })();

                    common.PolicyTopicEntry = (function() {

                        /**
                         * Properties of a PolicyTopicEntry.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IPolicyTopicEntry
                         * @property {google.protobuf.IStringValue|null} [topic] PolicyTopicEntry topic
                         * @property {google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum.PolicyTopicEntryType|null} [type] PolicyTopicEntry type
                         * @property {Array.<google.ads.googleads.v1.common.IPolicyTopicEvidence>|null} [evidences] PolicyTopicEntry evidences
                         * @property {Array.<google.ads.googleads.v1.common.IPolicyTopicConstraint>|null} [constraints] PolicyTopicEntry constraints
                         */

                        /**
                         * Constructs a new PolicyTopicEntry.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a PolicyTopicEntry.
                         * @implements IPolicyTopicEntry
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IPolicyTopicEntry=} [properties] Properties to set
                         */
                        function PolicyTopicEntry(properties) {
                            this.evidences = [];
                            this.constraints = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * PolicyTopicEntry topic.
                         * @member {google.protobuf.IStringValue|null|undefined} topic
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEntry
                         * @instance
                         */
                        PolicyTopicEntry.prototype.topic = null;

                        /**
                         * PolicyTopicEntry type.
                         * @member {google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum.PolicyTopicEntryType} type
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEntry
                         * @instance
                         */
                        PolicyTopicEntry.prototype.type = 0;

                        /**
                         * PolicyTopicEntry evidences.
                         * @member {Array.<google.ads.googleads.v1.common.IPolicyTopicEvidence>} evidences
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEntry
                         * @instance
                         */
                        PolicyTopicEntry.prototype.evidences = $util.emptyArray;

                        /**
                         * PolicyTopicEntry constraints.
                         * @member {Array.<google.ads.googleads.v1.common.IPolicyTopicConstraint>} constraints
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEntry
                         * @instance
                         */
                        PolicyTopicEntry.prototype.constraints = $util.emptyArray;

                        /**
                         * Creates a new PolicyTopicEntry instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEntry
                         * @static
                         * @param {google.ads.googleads.v1.common.IPolicyTopicEntry=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.PolicyTopicEntry} PolicyTopicEntry instance
                         */
                        PolicyTopicEntry.create = function create(properties) {
                            return new PolicyTopicEntry(properties);
                        };

                        /**
                         * Encodes the specified PolicyTopicEntry message. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicEntry.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEntry
                         * @static
                         * @param {google.ads.googleads.v1.common.IPolicyTopicEntry} message PolicyTopicEntry message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyTopicEntry.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.topic != null && message.hasOwnProperty("topic"))
                                $root.google.protobuf.StringValue.encode(message.topic, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.type);
                            if (message.evidences != null && message.evidences.length)
                                for (var i = 0; i < message.evidences.length; ++i)
                                    $root.google.ads.googleads.v1.common.PolicyTopicEvidence.encode(message.evidences[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.constraints != null && message.constraints.length)
                                for (var i = 0; i < message.constraints.length; ++i)
                                    $root.google.ads.googleads.v1.common.PolicyTopicConstraint.encode(message.constraints[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified PolicyTopicEntry message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicEntry.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEntry
                         * @static
                         * @param {google.ads.googleads.v1.common.IPolicyTopicEntry} message PolicyTopicEntry message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyTopicEntry.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PolicyTopicEntry message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEntry
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.PolicyTopicEntry} PolicyTopicEntry
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyTopicEntry.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PolicyTopicEntry();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.topic = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.type = reader.int32();
                                    break;
                                case 3:
                                    if (!(message.evidences && message.evidences.length))
                                        message.evidences = [];
                                    message.evidences.push($root.google.ads.googleads.v1.common.PolicyTopicEvidence.decode(reader, reader.uint32()));
                                    break;
                                case 4:
                                    if (!(message.constraints && message.constraints.length))
                                        message.constraints = [];
                                    message.constraints.push($root.google.ads.googleads.v1.common.PolicyTopicConstraint.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PolicyTopicEntry message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEntry
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.PolicyTopicEntry} PolicyTopicEntry
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyTopicEntry.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PolicyTopicEntry message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEntry
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PolicyTopicEntry.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.topic != null && message.hasOwnProperty("topic")) {
                                var error = $root.google.protobuf.StringValue.verify(message.topic);
                                if (error)
                                    return "topic." + error;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 4:
                                case 8:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            if (message.evidences != null && message.hasOwnProperty("evidences")) {
                                if (!Array.isArray(message.evidences))
                                    return "evidences: array expected";
                                for (var i = 0; i < message.evidences.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.verify(message.evidences[i]);
                                    if (error)
                                        return "evidences." + error;
                                }
                            }
                            if (message.constraints != null && message.hasOwnProperty("constraints")) {
                                if (!Array.isArray(message.constraints))
                                    return "constraints: array expected";
                                for (var i = 0; i < message.constraints.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.verify(message.constraints[i]);
                                    if (error)
                                        return "constraints." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a PolicyTopicEntry message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEntry
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.PolicyTopicEntry} PolicyTopicEntry
                         */
                        PolicyTopicEntry.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.PolicyTopicEntry)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.PolicyTopicEntry();
                            if (object.topic != null) {
                                if (typeof object.topic !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEntry.topic: object expected");
                                message.topic = $root.google.protobuf.StringValue.fromObject(object.topic);
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "PROHIBITED":
                            case 2:
                                message.type = 2;
                                break;
                            case "LIMITED":
                            case 4:
                                message.type = 4;
                                break;
                            case "FULLY_LIMITED":
                            case 8:
                                message.type = 8;
                                break;
                            case "DESCRIPTIVE":
                            case 5:
                                message.type = 5;
                                break;
                            case "BROADENING":
                            case 6:
                                message.type = 6;
                                break;
                            case "AREA_OF_INTEREST_ONLY":
                            case 7:
                                message.type = 7;
                                break;
                            }
                            if (object.evidences) {
                                if (!Array.isArray(object.evidences))
                                    throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEntry.evidences: array expected");
                                message.evidences = [];
                                for (var i = 0; i < object.evidences.length; ++i) {
                                    if (typeof object.evidences[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEntry.evidences: object expected");
                                    message.evidences[i] = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.fromObject(object.evidences[i]);
                                }
                            }
                            if (object.constraints) {
                                if (!Array.isArray(object.constraints))
                                    throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEntry.constraints: array expected");
                                message.constraints = [];
                                for (var i = 0; i < object.constraints.length; ++i) {
                                    if (typeof object.constraints[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEntry.constraints: object expected");
                                    message.constraints[i] = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.fromObject(object.constraints[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a PolicyTopicEntry message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEntry
                         * @static
                         * @param {google.ads.googleads.v1.common.PolicyTopicEntry} message PolicyTopicEntry
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PolicyTopicEntry.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.evidences = [];
                                object.constraints = [];
                            }
                            if (options.defaults) {
                                object.topic = null;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.topic != null && message.hasOwnProperty("topic"))
                                object.topic = $root.google.protobuf.StringValue.toObject(message.topic, options);
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum.PolicyTopicEntryType[message.type] : message.type;
                            if (message.evidences && message.evidences.length) {
                                object.evidences = [];
                                for (var j = 0; j < message.evidences.length; ++j)
                                    object.evidences[j] = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.toObject(message.evidences[j], options);
                            }
                            if (message.constraints && message.constraints.length) {
                                object.constraints = [];
                                for (var j = 0; j < message.constraints.length; ++j)
                                    object.constraints[j] = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.toObject(message.constraints[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this PolicyTopicEntry to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEntry
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PolicyTopicEntry.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return PolicyTopicEntry;
                    })();

                    common.PolicyTopicEvidence = (function() {

                        /**
                         * Properties of a PolicyTopicEvidence.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IPolicyTopicEvidence
                         * @property {google.protobuf.IInt32Value|null} [httpCode] PolicyTopicEvidence httpCode
                         * @property {google.ads.googleads.v1.common.PolicyTopicEvidence.IWebsiteList|null} [websiteList] PolicyTopicEvidence websiteList
                         * @property {google.ads.googleads.v1.common.PolicyTopicEvidence.ITextList|null} [textList] PolicyTopicEvidence textList
                         * @property {google.protobuf.IStringValue|null} [languageCode] PolicyTopicEvidence languageCode
                         * @property {google.ads.googleads.v1.common.PolicyTopicEvidence.IDestinationTextList|null} [destinationTextList] PolicyTopicEvidence destinationTextList
                         * @property {google.ads.googleads.v1.common.PolicyTopicEvidence.IDestinationMismatch|null} [destinationMismatch] PolicyTopicEvidence destinationMismatch
                         * @property {google.ads.googleads.v1.common.PolicyTopicEvidence.IDestinationNotWorking|null} [destinationNotWorking] PolicyTopicEvidence destinationNotWorking
                         */

                        /**
                         * Constructs a new PolicyTopicEvidence.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a PolicyTopicEvidence.
                         * @implements IPolicyTopicEvidence
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IPolicyTopicEvidence=} [properties] Properties to set
                         */
                        function PolicyTopicEvidence(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * PolicyTopicEvidence httpCode.
                         * @member {google.protobuf.IInt32Value|null|undefined} httpCode
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                         * @instance
                         */
                        PolicyTopicEvidence.prototype.httpCode = null;

                        /**
                         * PolicyTopicEvidence websiteList.
                         * @member {google.ads.googleads.v1.common.PolicyTopicEvidence.IWebsiteList|null|undefined} websiteList
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                         * @instance
                         */
                        PolicyTopicEvidence.prototype.websiteList = null;

                        /**
                         * PolicyTopicEvidence textList.
                         * @member {google.ads.googleads.v1.common.PolicyTopicEvidence.ITextList|null|undefined} textList
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                         * @instance
                         */
                        PolicyTopicEvidence.prototype.textList = null;

                        /**
                         * PolicyTopicEvidence languageCode.
                         * @member {google.protobuf.IStringValue|null|undefined} languageCode
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                         * @instance
                         */
                        PolicyTopicEvidence.prototype.languageCode = null;

                        /**
                         * PolicyTopicEvidence destinationTextList.
                         * @member {google.ads.googleads.v1.common.PolicyTopicEvidence.IDestinationTextList|null|undefined} destinationTextList
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                         * @instance
                         */
                        PolicyTopicEvidence.prototype.destinationTextList = null;

                        /**
                         * PolicyTopicEvidence destinationMismatch.
                         * @member {google.ads.googleads.v1.common.PolicyTopicEvidence.IDestinationMismatch|null|undefined} destinationMismatch
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                         * @instance
                         */
                        PolicyTopicEvidence.prototype.destinationMismatch = null;

                        /**
                         * PolicyTopicEvidence destinationNotWorking.
                         * @member {google.ads.googleads.v1.common.PolicyTopicEvidence.IDestinationNotWorking|null|undefined} destinationNotWorking
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                         * @instance
                         */
                        PolicyTopicEvidence.prototype.destinationNotWorking = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * PolicyTopicEvidence value.
                         * @member {"httpCode"|"websiteList"|"textList"|"languageCode"|"destinationTextList"|"destinationMismatch"|"destinationNotWorking"|undefined} value
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                         * @instance
                         */
                        Object.defineProperty(PolicyTopicEvidence.prototype, "value", {
                            get: $util.oneOfGetter($oneOfFields = ["httpCode", "websiteList", "textList", "languageCode", "destinationTextList", "destinationMismatch", "destinationNotWorking"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new PolicyTopicEvidence instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                         * @static
                         * @param {google.ads.googleads.v1.common.IPolicyTopicEvidence=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence} PolicyTopicEvidence instance
                         */
                        PolicyTopicEvidence.create = function create(properties) {
                            return new PolicyTopicEvidence(properties);
                        };

                        /**
                         * Encodes the specified PolicyTopicEvidence message. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicEvidence.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                         * @static
                         * @param {google.ads.googleads.v1.common.IPolicyTopicEvidence} message PolicyTopicEvidence message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyTopicEvidence.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.httpCode != null && message.hasOwnProperty("httpCode"))
                                $root.google.protobuf.Int32Value.encode(message.httpCode, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.websiteList != null && message.hasOwnProperty("websiteList"))
                                $root.google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList.encode(message.websiteList, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.textList != null && message.hasOwnProperty("textList"))
                                $root.google.ads.googleads.v1.common.PolicyTopicEvidence.TextList.encode(message.textList, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.languageCode != null && message.hasOwnProperty("languageCode"))
                                $root.google.protobuf.StringValue.encode(message.languageCode, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.destinationTextList != null && message.hasOwnProperty("destinationTextList"))
                                $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList.encode(message.destinationTextList, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.destinationMismatch != null && message.hasOwnProperty("destinationMismatch"))
                                $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch.encode(message.destinationMismatch, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.destinationNotWorking != null && message.hasOwnProperty("destinationNotWorking"))
                                $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking.encode(message.destinationNotWorking, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified PolicyTopicEvidence message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicEvidence.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                         * @static
                         * @param {google.ads.googleads.v1.common.IPolicyTopicEvidence} message PolicyTopicEvidence message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyTopicEvidence.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PolicyTopicEvidence message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence} PolicyTopicEvidence
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyTopicEvidence.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PolicyTopicEvidence();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2:
                                    message.httpCode = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.websiteList = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.textList = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.TextList.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.languageCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.destinationTextList = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.destinationMismatch = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.destinationNotWorking = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PolicyTopicEvidence message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence} PolicyTopicEvidence
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyTopicEvidence.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PolicyTopicEvidence message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PolicyTopicEvidence.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.httpCode != null && message.hasOwnProperty("httpCode")) {
                                properties.value = 1;
                                {
                                    var error = $root.google.protobuf.Int32Value.verify(message.httpCode);
                                    if (error)
                                        return "httpCode." + error;
                                }
                            }
                            if (message.websiteList != null && message.hasOwnProperty("websiteList")) {
                                if (properties.value === 1)
                                    return "value: multiple values";
                                properties.value = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList.verify(message.websiteList);
                                    if (error)
                                        return "websiteList." + error;
                                }
                            }
                            if (message.textList != null && message.hasOwnProperty("textList")) {
                                if (properties.value === 1)
                                    return "value: multiple values";
                                properties.value = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.TextList.verify(message.textList);
                                    if (error)
                                        return "textList." + error;
                                }
                            }
                            if (message.languageCode != null && message.hasOwnProperty("languageCode")) {
                                if (properties.value === 1)
                                    return "value: multiple values";
                                properties.value = 1;
                                {
                                    var error = $root.google.protobuf.StringValue.verify(message.languageCode);
                                    if (error)
                                        return "languageCode." + error;
                                }
                            }
                            if (message.destinationTextList != null && message.hasOwnProperty("destinationTextList")) {
                                if (properties.value === 1)
                                    return "value: multiple values";
                                properties.value = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList.verify(message.destinationTextList);
                                    if (error)
                                        return "destinationTextList." + error;
                                }
                            }
                            if (message.destinationMismatch != null && message.hasOwnProperty("destinationMismatch")) {
                                if (properties.value === 1)
                                    return "value: multiple values";
                                properties.value = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch.verify(message.destinationMismatch);
                                    if (error)
                                        return "destinationMismatch." + error;
                                }
                            }
                            if (message.destinationNotWorking != null && message.hasOwnProperty("destinationNotWorking")) {
                                if (properties.value === 1)
                                    return "value: multiple values";
                                properties.value = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking.verify(message.destinationNotWorking);
                                    if (error)
                                        return "destinationNotWorking." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a PolicyTopicEvidence message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence} PolicyTopicEvidence
                         */
                        PolicyTopicEvidence.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.PolicyTopicEvidence)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.PolicyTopicEvidence();
                            if (object.httpCode != null) {
                                if (typeof object.httpCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEvidence.httpCode: object expected");
                                message.httpCode = $root.google.protobuf.Int32Value.fromObject(object.httpCode);
                            }
                            if (object.websiteList != null) {
                                if (typeof object.websiteList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEvidence.websiteList: object expected");
                                message.websiteList = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList.fromObject(object.websiteList);
                            }
                            if (object.textList != null) {
                                if (typeof object.textList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEvidence.textList: object expected");
                                message.textList = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.TextList.fromObject(object.textList);
                            }
                            if (object.languageCode != null) {
                                if (typeof object.languageCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEvidence.languageCode: object expected");
                                message.languageCode = $root.google.protobuf.StringValue.fromObject(object.languageCode);
                            }
                            if (object.destinationTextList != null) {
                                if (typeof object.destinationTextList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEvidence.destinationTextList: object expected");
                                message.destinationTextList = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList.fromObject(object.destinationTextList);
                            }
                            if (object.destinationMismatch != null) {
                                if (typeof object.destinationMismatch !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEvidence.destinationMismatch: object expected");
                                message.destinationMismatch = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch.fromObject(object.destinationMismatch);
                            }
                            if (object.destinationNotWorking != null) {
                                if (typeof object.destinationNotWorking !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEvidence.destinationNotWorking: object expected");
                                message.destinationNotWorking = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking.fromObject(object.destinationNotWorking);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a PolicyTopicEvidence message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                         * @static
                         * @param {google.ads.googleads.v1.common.PolicyTopicEvidence} message PolicyTopicEvidence
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PolicyTopicEvidence.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.httpCode != null && message.hasOwnProperty("httpCode")) {
                                object.httpCode = $root.google.protobuf.Int32Value.toObject(message.httpCode, options);
                                if (options.oneofs)
                                    object.value = "httpCode";
                            }
                            if (message.websiteList != null && message.hasOwnProperty("websiteList")) {
                                object.websiteList = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList.toObject(message.websiteList, options);
                                if (options.oneofs)
                                    object.value = "websiteList";
                            }
                            if (message.textList != null && message.hasOwnProperty("textList")) {
                                object.textList = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.TextList.toObject(message.textList, options);
                                if (options.oneofs)
                                    object.value = "textList";
                            }
                            if (message.languageCode != null && message.hasOwnProperty("languageCode")) {
                                object.languageCode = $root.google.protobuf.StringValue.toObject(message.languageCode, options);
                                if (options.oneofs)
                                    object.value = "languageCode";
                            }
                            if (message.destinationTextList != null && message.hasOwnProperty("destinationTextList")) {
                                object.destinationTextList = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList.toObject(message.destinationTextList, options);
                                if (options.oneofs)
                                    object.value = "destinationTextList";
                            }
                            if (message.destinationMismatch != null && message.hasOwnProperty("destinationMismatch")) {
                                object.destinationMismatch = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch.toObject(message.destinationMismatch, options);
                                if (options.oneofs)
                                    object.value = "destinationMismatch";
                            }
                            if (message.destinationNotWorking != null && message.hasOwnProperty("destinationNotWorking")) {
                                object.destinationNotWorking = $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking.toObject(message.destinationNotWorking, options);
                                if (options.oneofs)
                                    object.value = "destinationNotWorking";
                            }
                            return object;
                        };

                        /**
                         * Converts this PolicyTopicEvidence to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PolicyTopicEvidence.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        PolicyTopicEvidence.TextList = (function() {

                            /**
                             * Properties of a TextList.
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                             * @interface ITextList
                             * @property {Array.<google.protobuf.IStringValue>|null} [texts] TextList texts
                             */

                            /**
                             * Constructs a new TextList.
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                             * @classdesc Represents a TextList.
                             * @implements ITextList
                             * @constructor
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.ITextList=} [properties] Properties to set
                             */
                            function TextList(properties) {
                                this.texts = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * TextList texts.
                             * @member {Array.<google.protobuf.IStringValue>} texts
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.TextList
                             * @instance
                             */
                            TextList.prototype.texts = $util.emptyArray;

                            /**
                             * Creates a new TextList instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.TextList
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.ITextList=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.TextList} TextList instance
                             */
                            TextList.create = function create(properties) {
                                return new TextList(properties);
                            };

                            /**
                             * Encodes the specified TextList message. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicEvidence.TextList.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.TextList
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.ITextList} message TextList message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            TextList.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.texts != null && message.texts.length)
                                    for (var i = 0; i < message.texts.length; ++i)
                                        $root.google.protobuf.StringValue.encode(message.texts[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified TextList message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicEvidence.TextList.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.TextList
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.ITextList} message TextList message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            TextList.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a TextList message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.TextList
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.TextList} TextList
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            TextList.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PolicyTopicEvidence.TextList();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        if (!(message.texts && message.texts.length))
                                            message.texts = [];
                                        message.texts.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a TextList message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.TextList
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.TextList} TextList
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            TextList.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a TextList message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.TextList
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            TextList.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.texts != null && message.hasOwnProperty("texts")) {
                                    if (!Array.isArray(message.texts))
                                        return "texts: array expected";
                                    for (var i = 0; i < message.texts.length; ++i) {
                                        var error = $root.google.protobuf.StringValue.verify(message.texts[i]);
                                        if (error)
                                            return "texts." + error;
                                    }
                                }
                                return null;
                            };

                            /**
                             * Creates a TextList message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.TextList
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.TextList} TextList
                             */
                            TextList.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.common.PolicyTopicEvidence.TextList)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.common.PolicyTopicEvidence.TextList();
                                if (object.texts) {
                                    if (!Array.isArray(object.texts))
                                        throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEvidence.TextList.texts: array expected");
                                    message.texts = [];
                                    for (var i = 0; i < object.texts.length; ++i) {
                                        if (typeof object.texts[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEvidence.TextList.texts: object expected");
                                        message.texts[i] = $root.google.protobuf.StringValue.fromObject(object.texts[i]);
                                    }
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a TextList message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.TextList
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.TextList} message TextList
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            TextList.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.texts = [];
                                if (message.texts && message.texts.length) {
                                    object.texts = [];
                                    for (var j = 0; j < message.texts.length; ++j)
                                        object.texts[j] = $root.google.protobuf.StringValue.toObject(message.texts[j], options);
                                }
                                return object;
                            };

                            /**
                             * Converts this TextList to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.TextList
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            TextList.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return TextList;
                        })();

                        PolicyTopicEvidence.WebsiteList = (function() {

                            /**
                             * Properties of a WebsiteList.
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                             * @interface IWebsiteList
                             * @property {Array.<google.protobuf.IStringValue>|null} [websites] WebsiteList websites
                             */

                            /**
                             * Constructs a new WebsiteList.
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                             * @classdesc Represents a WebsiteList.
                             * @implements IWebsiteList
                             * @constructor
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.IWebsiteList=} [properties] Properties to set
                             */
                            function WebsiteList(properties) {
                                this.websites = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * WebsiteList websites.
                             * @member {Array.<google.protobuf.IStringValue>} websites
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList
                             * @instance
                             */
                            WebsiteList.prototype.websites = $util.emptyArray;

                            /**
                             * Creates a new WebsiteList instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.IWebsiteList=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList} WebsiteList instance
                             */
                            WebsiteList.create = function create(properties) {
                                return new WebsiteList(properties);
                            };

                            /**
                             * Encodes the specified WebsiteList message. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.IWebsiteList} message WebsiteList message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            WebsiteList.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.websites != null && message.websites.length)
                                    for (var i = 0; i < message.websites.length; ++i)
                                        $root.google.protobuf.StringValue.encode(message.websites[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified WebsiteList message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.IWebsiteList} message WebsiteList message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            WebsiteList.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a WebsiteList message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList} WebsiteList
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            WebsiteList.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        if (!(message.websites && message.websites.length))
                                            message.websites = [];
                                        message.websites.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a WebsiteList message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList} WebsiteList
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            WebsiteList.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a WebsiteList message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            WebsiteList.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.websites != null && message.hasOwnProperty("websites")) {
                                    if (!Array.isArray(message.websites))
                                        return "websites: array expected";
                                    for (var i = 0; i < message.websites.length; ++i) {
                                        var error = $root.google.protobuf.StringValue.verify(message.websites[i]);
                                        if (error)
                                            return "websites." + error;
                                    }
                                }
                                return null;
                            };

                            /**
                             * Creates a WebsiteList message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList} WebsiteList
                             */
                            WebsiteList.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList();
                                if (object.websites) {
                                    if (!Array.isArray(object.websites))
                                        throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList.websites: array expected");
                                    message.websites = [];
                                    for (var i = 0; i < object.websites.length; ++i) {
                                        if (typeof object.websites[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList.websites: object expected");
                                        message.websites[i] = $root.google.protobuf.StringValue.fromObject(object.websites[i]);
                                    }
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a WebsiteList message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList} message WebsiteList
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            WebsiteList.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.websites = [];
                                if (message.websites && message.websites.length) {
                                    object.websites = [];
                                    for (var j = 0; j < message.websites.length; ++j)
                                        object.websites[j] = $root.google.protobuf.StringValue.toObject(message.websites[j], options);
                                }
                                return object;
                            };

                            /**
                             * Converts this WebsiteList to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.WebsiteList
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            WebsiteList.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return WebsiteList;
                        })();

                        PolicyTopicEvidence.DestinationTextList = (function() {

                            /**
                             * Properties of a DestinationTextList.
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                             * @interface IDestinationTextList
                             * @property {Array.<google.protobuf.IStringValue>|null} [destinationTexts] DestinationTextList destinationTexts
                             */

                            /**
                             * Constructs a new DestinationTextList.
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                             * @classdesc Represents a DestinationTextList.
                             * @implements IDestinationTextList
                             * @constructor
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.IDestinationTextList=} [properties] Properties to set
                             */
                            function DestinationTextList(properties) {
                                this.destinationTexts = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * DestinationTextList destinationTexts.
                             * @member {Array.<google.protobuf.IStringValue>} destinationTexts
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList
                             * @instance
                             */
                            DestinationTextList.prototype.destinationTexts = $util.emptyArray;

                            /**
                             * Creates a new DestinationTextList instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.IDestinationTextList=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList} DestinationTextList instance
                             */
                            DestinationTextList.create = function create(properties) {
                                return new DestinationTextList(properties);
                            };

                            /**
                             * Encodes the specified DestinationTextList message. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.IDestinationTextList} message DestinationTextList message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            DestinationTextList.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.destinationTexts != null && message.destinationTexts.length)
                                    for (var i = 0; i < message.destinationTexts.length; ++i)
                                        $root.google.protobuf.StringValue.encode(message.destinationTexts[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified DestinationTextList message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.IDestinationTextList} message DestinationTextList message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            DestinationTextList.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a DestinationTextList message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList} DestinationTextList
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            DestinationTextList.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        if (!(message.destinationTexts && message.destinationTexts.length))
                                            message.destinationTexts = [];
                                        message.destinationTexts.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a DestinationTextList message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList} DestinationTextList
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            DestinationTextList.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a DestinationTextList message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            DestinationTextList.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.destinationTexts != null && message.hasOwnProperty("destinationTexts")) {
                                    if (!Array.isArray(message.destinationTexts))
                                        return "destinationTexts: array expected";
                                    for (var i = 0; i < message.destinationTexts.length; ++i) {
                                        var error = $root.google.protobuf.StringValue.verify(message.destinationTexts[i]);
                                        if (error)
                                            return "destinationTexts." + error;
                                    }
                                }
                                return null;
                            };

                            /**
                             * Creates a DestinationTextList message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList} DestinationTextList
                             */
                            DestinationTextList.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList();
                                if (object.destinationTexts) {
                                    if (!Array.isArray(object.destinationTexts))
                                        throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList.destinationTexts: array expected");
                                    message.destinationTexts = [];
                                    for (var i = 0; i < object.destinationTexts.length; ++i) {
                                        if (typeof object.destinationTexts[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList.destinationTexts: object expected");
                                        message.destinationTexts[i] = $root.google.protobuf.StringValue.fromObject(object.destinationTexts[i]);
                                    }
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a DestinationTextList message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList} message DestinationTextList
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            DestinationTextList.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.destinationTexts = [];
                                if (message.destinationTexts && message.destinationTexts.length) {
                                    object.destinationTexts = [];
                                    for (var j = 0; j < message.destinationTexts.length; ++j)
                                        object.destinationTexts[j] = $root.google.protobuf.StringValue.toObject(message.destinationTexts[j], options);
                                }
                                return object;
                            };

                            /**
                             * Converts this DestinationTextList to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationTextList
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            DestinationTextList.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return DestinationTextList;
                        })();

                        PolicyTopicEvidence.DestinationMismatch = (function() {

                            /**
                             * Properties of a DestinationMismatch.
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                             * @interface IDestinationMismatch
                             * @property {Array.<google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.PolicyTopicEvidenceDestinationMismatchUrlType>|null} [urlTypes] DestinationMismatch urlTypes
                             */

                            /**
                             * Constructs a new DestinationMismatch.
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                             * @classdesc Represents a DestinationMismatch.
                             * @implements IDestinationMismatch
                             * @constructor
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.IDestinationMismatch=} [properties] Properties to set
                             */
                            function DestinationMismatch(properties) {
                                this.urlTypes = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * DestinationMismatch urlTypes.
                             * @member {Array.<google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.PolicyTopicEvidenceDestinationMismatchUrlType>} urlTypes
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch
                             * @instance
                             */
                            DestinationMismatch.prototype.urlTypes = $util.emptyArray;

                            /**
                             * Creates a new DestinationMismatch instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.IDestinationMismatch=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch} DestinationMismatch instance
                             */
                            DestinationMismatch.create = function create(properties) {
                                return new DestinationMismatch(properties);
                            };

                            /**
                             * Encodes the specified DestinationMismatch message. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.IDestinationMismatch} message DestinationMismatch message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            DestinationMismatch.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.urlTypes != null && message.urlTypes.length) {
                                    writer.uint32(/* id 1, wireType 2 =*/10).fork();
                                    for (var i = 0; i < message.urlTypes.length; ++i)
                                        writer.int32(message.urlTypes[i]);
                                    writer.ldelim();
                                }
                                return writer;
                            };

                            /**
                             * Encodes the specified DestinationMismatch message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.IDestinationMismatch} message DestinationMismatch message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            DestinationMismatch.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a DestinationMismatch message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch} DestinationMismatch
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            DestinationMismatch.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        if (!(message.urlTypes && message.urlTypes.length))
                                            message.urlTypes = [];
                                        if ((tag & 7) === 2) {
                                            var end2 = reader.uint32() + reader.pos;
                                            while (reader.pos < end2)
                                                message.urlTypes.push(reader.int32());
                                        } else
                                            message.urlTypes.push(reader.int32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a DestinationMismatch message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch} DestinationMismatch
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            DestinationMismatch.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a DestinationMismatch message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            DestinationMismatch.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.urlTypes != null && message.hasOwnProperty("urlTypes")) {
                                    if (!Array.isArray(message.urlTypes))
                                        return "urlTypes: array expected";
                                    for (var i = 0; i < message.urlTypes.length; ++i)
                                        switch (message.urlTypes[i]) {
                                        default:
                                            return "urlTypes: enum value[] expected";
                                        case 0:
                                        case 1:
                                        case 2:
                                        case 3:
                                        case 4:
                                        case 5:
                                        case 6:
                                            break;
                                        }
                                }
                                return null;
                            };

                            /**
                             * Creates a DestinationMismatch message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch} DestinationMismatch
                             */
                            DestinationMismatch.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch();
                                if (object.urlTypes) {
                                    if (!Array.isArray(object.urlTypes))
                                        throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch.urlTypes: array expected");
                                    message.urlTypes = [];
                                    for (var i = 0; i < object.urlTypes.length; ++i)
                                        switch (object.urlTypes[i]) {
                                        default:
                                        case "UNSPECIFIED":
                                        case 0:
                                            message.urlTypes[i] = 0;
                                            break;
                                        case "UNKNOWN":
                                        case 1:
                                            message.urlTypes[i] = 1;
                                            break;
                                        case "DISPLAY_URL":
                                        case 2:
                                            message.urlTypes[i] = 2;
                                            break;
                                        case "FINAL_URL":
                                        case 3:
                                            message.urlTypes[i] = 3;
                                            break;
                                        case "FINAL_MOBILE_URL":
                                        case 4:
                                            message.urlTypes[i] = 4;
                                            break;
                                        case "TRACKING_URL":
                                        case 5:
                                            message.urlTypes[i] = 5;
                                            break;
                                        case "MOBILE_TRACKING_URL":
                                        case 6:
                                            message.urlTypes[i] = 6;
                                            break;
                                        }
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a DestinationMismatch message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch} message DestinationMismatch
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            DestinationMismatch.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.urlTypes = [];
                                if (message.urlTypes && message.urlTypes.length) {
                                    object.urlTypes = [];
                                    for (var j = 0; j < message.urlTypes.length; ++j)
                                        object.urlTypes[j] = options.enums === String ? $root.google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.PolicyTopicEvidenceDestinationMismatchUrlType[message.urlTypes[j]] : message.urlTypes[j];
                                }
                                return object;
                            };

                            /**
                             * Converts this DestinationMismatch to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationMismatch
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            DestinationMismatch.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return DestinationMismatch;
                        })();

                        PolicyTopicEvidence.DestinationNotWorking = (function() {

                            /**
                             * Properties of a DestinationNotWorking.
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                             * @interface IDestinationNotWorking
                             * @property {google.protobuf.IStringValue|null} [expandedUrl] DestinationNotWorking expandedUrl
                             * @property {google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.PolicyTopicEvidenceDestinationNotWorkingDevice|null} [device] DestinationNotWorking device
                             * @property {google.protobuf.IStringValue|null} [lastCheckedDateTime] DestinationNotWorking lastCheckedDateTime
                             */

                            /**
                             * Constructs a new DestinationNotWorking.
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence
                             * @classdesc Represents a DestinationNotWorking.
                             * @implements IDestinationNotWorking
                             * @constructor
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.IDestinationNotWorking=} [properties] Properties to set
                             */
                            function DestinationNotWorking(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * DestinationNotWorking expandedUrl.
                             * @member {google.protobuf.IStringValue|null|undefined} expandedUrl
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking
                             * @instance
                             */
                            DestinationNotWorking.prototype.expandedUrl = null;

                            /**
                             * DestinationNotWorking device.
                             * @member {google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.PolicyTopicEvidenceDestinationNotWorkingDevice} device
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking
                             * @instance
                             */
                            DestinationNotWorking.prototype.device = 0;

                            /**
                             * DestinationNotWorking lastCheckedDateTime.
                             * @member {google.protobuf.IStringValue|null|undefined} lastCheckedDateTime
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking
                             * @instance
                             */
                            DestinationNotWorking.prototype.lastCheckedDateTime = null;

                            /**
                             * Creates a new DestinationNotWorking instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.IDestinationNotWorking=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking} DestinationNotWorking instance
                             */
                            DestinationNotWorking.create = function create(properties) {
                                return new DestinationNotWorking(properties);
                            };

                            /**
                             * Encodes the specified DestinationNotWorking message. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.IDestinationNotWorking} message DestinationNotWorking message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            DestinationNotWorking.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.expandedUrl != null && message.hasOwnProperty("expandedUrl"))
                                    $root.google.protobuf.StringValue.encode(message.expandedUrl, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                                if (message.device != null && message.hasOwnProperty("device"))
                                    writer.uint32(/* id 4, wireType 0 =*/32).int32(message.device);
                                if (message.lastCheckedDateTime != null && message.hasOwnProperty("lastCheckedDateTime"))
                                    $root.google.protobuf.StringValue.encode(message.lastCheckedDateTime, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified DestinationNotWorking message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.IDestinationNotWorking} message DestinationNotWorking message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            DestinationNotWorking.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a DestinationNotWorking message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking} DestinationNotWorking
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            DestinationNotWorking.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 3:
                                        message.expandedUrl = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 4:
                                        message.device = reader.int32();
                                        break;
                                    case 5:
                                        message.lastCheckedDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a DestinationNotWorking message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking} DestinationNotWorking
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            DestinationNotWorking.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a DestinationNotWorking message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            DestinationNotWorking.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.expandedUrl != null && message.hasOwnProperty("expandedUrl")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.expandedUrl);
                                    if (error)
                                        return "expandedUrl." + error;
                                }
                                if (message.device != null && message.hasOwnProperty("device"))
                                    switch (message.device) {
                                    default:
                                        return "device: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                        break;
                                    }
                                if (message.lastCheckedDateTime != null && message.hasOwnProperty("lastCheckedDateTime")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.lastCheckedDateTime);
                                    if (error)
                                        return "lastCheckedDateTime." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a DestinationNotWorking message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking} DestinationNotWorking
                             */
                            DestinationNotWorking.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking();
                                if (object.expandedUrl != null) {
                                    if (typeof object.expandedUrl !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking.expandedUrl: object expected");
                                    message.expandedUrl = $root.google.protobuf.StringValue.fromObject(object.expandedUrl);
                                }
                                switch (object.device) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.device = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.device = 1;
                                    break;
                                case "DESKTOP":
                                case 2:
                                    message.device = 2;
                                    break;
                                case "ANDROID":
                                case 3:
                                    message.device = 3;
                                    break;
                                case "IOS":
                                case 4:
                                    message.device = 4;
                                    break;
                                }
                                if (object.lastCheckedDateTime != null) {
                                    if (typeof object.lastCheckedDateTime !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking.lastCheckedDateTime: object expected");
                                    message.lastCheckedDateTime = $root.google.protobuf.StringValue.fromObject(object.lastCheckedDateTime);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a DestinationNotWorking message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking} message DestinationNotWorking
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            DestinationNotWorking.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.expandedUrl = null;
                                    object.device = options.enums === String ? "UNSPECIFIED" : 0;
                                    object.lastCheckedDateTime = null;
                                }
                                if (message.expandedUrl != null && message.hasOwnProperty("expandedUrl"))
                                    object.expandedUrl = $root.google.protobuf.StringValue.toObject(message.expandedUrl, options);
                                if (message.device != null && message.hasOwnProperty("device"))
                                    object.device = options.enums === String ? $root.google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.PolicyTopicEvidenceDestinationNotWorkingDevice[message.device] : message.device;
                                if (message.lastCheckedDateTime != null && message.hasOwnProperty("lastCheckedDateTime"))
                                    object.lastCheckedDateTime = $root.google.protobuf.StringValue.toObject(message.lastCheckedDateTime, options);
                                return object;
                            };

                            /**
                             * Converts this DestinationNotWorking to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.common.PolicyTopicEvidence.DestinationNotWorking
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            DestinationNotWorking.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return DestinationNotWorking;
                        })();

                        return PolicyTopicEvidence;
                    })();

                    common.PolicyTopicConstraint = (function() {

                        /**
                         * Properties of a PolicyTopicConstraint.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IPolicyTopicConstraint
                         * @property {google.ads.googleads.v1.common.PolicyTopicConstraint.ICountryConstraintList|null} [countryConstraintList] PolicyTopicConstraint countryConstraintList
                         * @property {google.ads.googleads.v1.common.PolicyTopicConstraint.IResellerConstraint|null} [resellerConstraint] PolicyTopicConstraint resellerConstraint
                         * @property {google.ads.googleads.v1.common.PolicyTopicConstraint.ICountryConstraintList|null} [certificateMissingInCountryList] PolicyTopicConstraint certificateMissingInCountryList
                         * @property {google.ads.googleads.v1.common.PolicyTopicConstraint.ICountryConstraintList|null} [certificateDomainMismatchInCountryList] PolicyTopicConstraint certificateDomainMismatchInCountryList
                         */

                        /**
                         * Constructs a new PolicyTopicConstraint.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a PolicyTopicConstraint.
                         * @implements IPolicyTopicConstraint
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IPolicyTopicConstraint=} [properties] Properties to set
                         */
                        function PolicyTopicConstraint(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * PolicyTopicConstraint countryConstraintList.
                         * @member {google.ads.googleads.v1.common.PolicyTopicConstraint.ICountryConstraintList|null|undefined} countryConstraintList
                         * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                         * @instance
                         */
                        PolicyTopicConstraint.prototype.countryConstraintList = null;

                        /**
                         * PolicyTopicConstraint resellerConstraint.
                         * @member {google.ads.googleads.v1.common.PolicyTopicConstraint.IResellerConstraint|null|undefined} resellerConstraint
                         * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                         * @instance
                         */
                        PolicyTopicConstraint.prototype.resellerConstraint = null;

                        /**
                         * PolicyTopicConstraint certificateMissingInCountryList.
                         * @member {google.ads.googleads.v1.common.PolicyTopicConstraint.ICountryConstraintList|null|undefined} certificateMissingInCountryList
                         * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                         * @instance
                         */
                        PolicyTopicConstraint.prototype.certificateMissingInCountryList = null;

                        /**
                         * PolicyTopicConstraint certificateDomainMismatchInCountryList.
                         * @member {google.ads.googleads.v1.common.PolicyTopicConstraint.ICountryConstraintList|null|undefined} certificateDomainMismatchInCountryList
                         * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                         * @instance
                         */
                        PolicyTopicConstraint.prototype.certificateDomainMismatchInCountryList = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * PolicyTopicConstraint value.
                         * @member {"countryConstraintList"|"resellerConstraint"|"certificateMissingInCountryList"|"certificateDomainMismatchInCountryList"|undefined} value
                         * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                         * @instance
                         */
                        Object.defineProperty(PolicyTopicConstraint.prototype, "value", {
                            get: $util.oneOfGetter($oneOfFields = ["countryConstraintList", "resellerConstraint", "certificateMissingInCountryList", "certificateDomainMismatchInCountryList"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new PolicyTopicConstraint instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                         * @static
                         * @param {google.ads.googleads.v1.common.IPolicyTopicConstraint=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.PolicyTopicConstraint} PolicyTopicConstraint instance
                         */
                        PolicyTopicConstraint.create = function create(properties) {
                            return new PolicyTopicConstraint(properties);
                        };

                        /**
                         * Encodes the specified PolicyTopicConstraint message. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicConstraint.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                         * @static
                         * @param {google.ads.googleads.v1.common.IPolicyTopicConstraint} message PolicyTopicConstraint message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyTopicConstraint.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.countryConstraintList != null && message.hasOwnProperty("countryConstraintList"))
                                $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.encode(message.countryConstraintList, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.resellerConstraint != null && message.hasOwnProperty("resellerConstraint"))
                                $root.google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint.encode(message.resellerConstraint, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.certificateMissingInCountryList != null && message.hasOwnProperty("certificateMissingInCountryList"))
                                $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.encode(message.certificateMissingInCountryList, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.certificateDomainMismatchInCountryList != null && message.hasOwnProperty("certificateDomainMismatchInCountryList"))
                                $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.encode(message.certificateDomainMismatchInCountryList, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified PolicyTopicConstraint message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicConstraint.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                         * @static
                         * @param {google.ads.googleads.v1.common.IPolicyTopicConstraint} message PolicyTopicConstraint message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyTopicConstraint.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PolicyTopicConstraint message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.PolicyTopicConstraint} PolicyTopicConstraint
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyTopicConstraint.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PolicyTopicConstraint();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.countryConstraintList = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.resellerConstraint = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.certificateMissingInCountryList = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.certificateDomainMismatchInCountryList = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PolicyTopicConstraint message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.PolicyTopicConstraint} PolicyTopicConstraint
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyTopicConstraint.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PolicyTopicConstraint message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PolicyTopicConstraint.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.countryConstraintList != null && message.hasOwnProperty("countryConstraintList")) {
                                properties.value = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.verify(message.countryConstraintList);
                                    if (error)
                                        return "countryConstraintList." + error;
                                }
                            }
                            if (message.resellerConstraint != null && message.hasOwnProperty("resellerConstraint")) {
                                if (properties.value === 1)
                                    return "value: multiple values";
                                properties.value = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint.verify(message.resellerConstraint);
                                    if (error)
                                        return "resellerConstraint." + error;
                                }
                            }
                            if (message.certificateMissingInCountryList != null && message.hasOwnProperty("certificateMissingInCountryList")) {
                                if (properties.value === 1)
                                    return "value: multiple values";
                                properties.value = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.verify(message.certificateMissingInCountryList);
                                    if (error)
                                        return "certificateMissingInCountryList." + error;
                                }
                            }
                            if (message.certificateDomainMismatchInCountryList != null && message.hasOwnProperty("certificateDomainMismatchInCountryList")) {
                                if (properties.value === 1)
                                    return "value: multiple values";
                                properties.value = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.verify(message.certificateDomainMismatchInCountryList);
                                    if (error)
                                        return "certificateDomainMismatchInCountryList." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a PolicyTopicConstraint message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.PolicyTopicConstraint} PolicyTopicConstraint
                         */
                        PolicyTopicConstraint.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.PolicyTopicConstraint)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.PolicyTopicConstraint();
                            if (object.countryConstraintList != null) {
                                if (typeof object.countryConstraintList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PolicyTopicConstraint.countryConstraintList: object expected");
                                message.countryConstraintList = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.fromObject(object.countryConstraintList);
                            }
                            if (object.resellerConstraint != null) {
                                if (typeof object.resellerConstraint !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PolicyTopicConstraint.resellerConstraint: object expected");
                                message.resellerConstraint = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint.fromObject(object.resellerConstraint);
                            }
                            if (object.certificateMissingInCountryList != null) {
                                if (typeof object.certificateMissingInCountryList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PolicyTopicConstraint.certificateMissingInCountryList: object expected");
                                message.certificateMissingInCountryList = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.fromObject(object.certificateMissingInCountryList);
                            }
                            if (object.certificateDomainMismatchInCountryList != null) {
                                if (typeof object.certificateDomainMismatchInCountryList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.PolicyTopicConstraint.certificateDomainMismatchInCountryList: object expected");
                                message.certificateDomainMismatchInCountryList = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.fromObject(object.certificateDomainMismatchInCountryList);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a PolicyTopicConstraint message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                         * @static
                         * @param {google.ads.googleads.v1.common.PolicyTopicConstraint} message PolicyTopicConstraint
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PolicyTopicConstraint.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.countryConstraintList != null && message.hasOwnProperty("countryConstraintList")) {
                                object.countryConstraintList = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.toObject(message.countryConstraintList, options);
                                if (options.oneofs)
                                    object.value = "countryConstraintList";
                            }
                            if (message.resellerConstraint != null && message.hasOwnProperty("resellerConstraint")) {
                                object.resellerConstraint = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint.toObject(message.resellerConstraint, options);
                                if (options.oneofs)
                                    object.value = "resellerConstraint";
                            }
                            if (message.certificateMissingInCountryList != null && message.hasOwnProperty("certificateMissingInCountryList")) {
                                object.certificateMissingInCountryList = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.toObject(message.certificateMissingInCountryList, options);
                                if (options.oneofs)
                                    object.value = "certificateMissingInCountryList";
                            }
                            if (message.certificateDomainMismatchInCountryList != null && message.hasOwnProperty("certificateDomainMismatchInCountryList")) {
                                object.certificateDomainMismatchInCountryList = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.toObject(message.certificateDomainMismatchInCountryList, options);
                                if (options.oneofs)
                                    object.value = "certificateDomainMismatchInCountryList";
                            }
                            return object;
                        };

                        /**
                         * Converts this PolicyTopicConstraint to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PolicyTopicConstraint.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        PolicyTopicConstraint.CountryConstraintList = (function() {

                            /**
                             * Properties of a CountryConstraintList.
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                             * @interface ICountryConstraintList
                             * @property {google.protobuf.IInt32Value|null} [totalTargetedCountries] CountryConstraintList totalTargetedCountries
                             * @property {Array.<google.ads.googleads.v1.common.PolicyTopicConstraint.ICountryConstraint>|null} [countries] CountryConstraintList countries
                             */

                            /**
                             * Constructs a new CountryConstraintList.
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                             * @classdesc Represents a CountryConstraintList.
                             * @implements ICountryConstraintList
                             * @constructor
                             * @param {google.ads.googleads.v1.common.PolicyTopicConstraint.ICountryConstraintList=} [properties] Properties to set
                             */
                            function CountryConstraintList(properties) {
                                this.countries = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * CountryConstraintList totalTargetedCountries.
                             * @member {google.protobuf.IInt32Value|null|undefined} totalTargetedCountries
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList
                             * @instance
                             */
                            CountryConstraintList.prototype.totalTargetedCountries = null;

                            /**
                             * CountryConstraintList countries.
                             * @member {Array.<google.ads.googleads.v1.common.PolicyTopicConstraint.ICountryConstraint>} countries
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList
                             * @instance
                             */
                            CountryConstraintList.prototype.countries = $util.emptyArray;

                            /**
                             * Creates a new CountryConstraintList instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicConstraint.ICountryConstraintList=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList} CountryConstraintList instance
                             */
                            CountryConstraintList.create = function create(properties) {
                                return new CountryConstraintList(properties);
                            };

                            /**
                             * Encodes the specified CountryConstraintList message. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicConstraint.ICountryConstraintList} message CountryConstraintList message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            CountryConstraintList.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.totalTargetedCountries != null && message.hasOwnProperty("totalTargetedCountries"))
                                    $root.google.protobuf.Int32Value.encode(message.totalTargetedCountries, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.countries != null && message.countries.length)
                                    for (var i = 0; i < message.countries.length; ++i)
                                        $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint.encode(message.countries[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified CountryConstraintList message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicConstraint.ICountryConstraintList} message CountryConstraintList message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            CountryConstraintList.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a CountryConstraintList message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList} CountryConstraintList
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            CountryConstraintList.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.totalTargetedCountries = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        if (!(message.countries && message.countries.length))
                                            message.countries = [];
                                        message.countries.push($root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint.decode(reader, reader.uint32()));
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a CountryConstraintList message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList} CountryConstraintList
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            CountryConstraintList.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a CountryConstraintList message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            CountryConstraintList.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.totalTargetedCountries != null && message.hasOwnProperty("totalTargetedCountries")) {
                                    var error = $root.google.protobuf.Int32Value.verify(message.totalTargetedCountries);
                                    if (error)
                                        return "totalTargetedCountries." + error;
                                }
                                if (message.countries != null && message.hasOwnProperty("countries")) {
                                    if (!Array.isArray(message.countries))
                                        return "countries: array expected";
                                    for (var i = 0; i < message.countries.length; ++i) {
                                        var error = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint.verify(message.countries[i]);
                                        if (error)
                                            return "countries." + error;
                                    }
                                }
                                return null;
                            };

                            /**
                             * Creates a CountryConstraintList message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList} CountryConstraintList
                             */
                            CountryConstraintList.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList();
                                if (object.totalTargetedCountries != null) {
                                    if (typeof object.totalTargetedCountries !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.totalTargetedCountries: object expected");
                                    message.totalTargetedCountries = $root.google.protobuf.Int32Value.fromObject(object.totalTargetedCountries);
                                }
                                if (object.countries) {
                                    if (!Array.isArray(object.countries))
                                        throw TypeError(".google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.countries: array expected");
                                    message.countries = [];
                                    for (var i = 0; i < object.countries.length; ++i) {
                                        if (typeof object.countries[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList.countries: object expected");
                                        message.countries[i] = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint.fromObject(object.countries[i]);
                                    }
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a CountryConstraintList message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList} message CountryConstraintList
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            CountryConstraintList.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.countries = [];
                                if (options.defaults)
                                    object.totalTargetedCountries = null;
                                if (message.totalTargetedCountries != null && message.hasOwnProperty("totalTargetedCountries"))
                                    object.totalTargetedCountries = $root.google.protobuf.Int32Value.toObject(message.totalTargetedCountries, options);
                                if (message.countries && message.countries.length) {
                                    object.countries = [];
                                    for (var j = 0; j < message.countries.length; ++j)
                                        object.countries[j] = $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint.toObject(message.countries[j], options);
                                }
                                return object;
                            };

                            /**
                             * Converts this CountryConstraintList to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraintList
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            CountryConstraintList.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return CountryConstraintList;
                        })();

                        PolicyTopicConstraint.ResellerConstraint = (function() {

                            /**
                             * Properties of a ResellerConstraint.
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                             * @interface IResellerConstraint
                             */

                            /**
                             * Constructs a new ResellerConstraint.
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                             * @classdesc Represents a ResellerConstraint.
                             * @implements IResellerConstraint
                             * @constructor
                             * @param {google.ads.googleads.v1.common.PolicyTopicConstraint.IResellerConstraint=} [properties] Properties to set
                             */
                            function ResellerConstraint(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * Creates a new ResellerConstraint instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicConstraint.IResellerConstraint=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint} ResellerConstraint instance
                             */
                            ResellerConstraint.create = function create(properties) {
                                return new ResellerConstraint(properties);
                            };

                            /**
                             * Encodes the specified ResellerConstraint message. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicConstraint.IResellerConstraint} message ResellerConstraint message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            ResellerConstraint.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                return writer;
                            };

                            /**
                             * Encodes the specified ResellerConstraint message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicConstraint.IResellerConstraint} message ResellerConstraint message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            ResellerConstraint.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a ResellerConstraint message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint} ResellerConstraint
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            ResellerConstraint.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a ResellerConstraint message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint} ResellerConstraint
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            ResellerConstraint.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a ResellerConstraint message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            ResellerConstraint.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                return null;
                            };

                            /**
                             * Creates a ResellerConstraint message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint} ResellerConstraint
                             */
                            ResellerConstraint.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint)
                                    return object;
                                return new $root.google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint();
                            };

                            /**
                             * Creates a plain object from a ResellerConstraint message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint} message ResellerConstraint
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            ResellerConstraint.toObject = function toObject() {
                                return {};
                            };

                            /**
                             * Converts this ResellerConstraint to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.ResellerConstraint
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            ResellerConstraint.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return ResellerConstraint;
                        })();

                        PolicyTopicConstraint.CountryConstraint = (function() {

                            /**
                             * Properties of a CountryConstraint.
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                             * @interface ICountryConstraint
                             * @property {google.protobuf.IStringValue|null} [countryCriterion] CountryConstraint countryCriterion
                             */

                            /**
                             * Constructs a new CountryConstraint.
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint
                             * @classdesc Represents a CountryConstraint.
                             * @implements ICountryConstraint
                             * @constructor
                             * @param {google.ads.googleads.v1.common.PolicyTopicConstraint.ICountryConstraint=} [properties] Properties to set
                             */
                            function CountryConstraint(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * CountryConstraint countryCriterion.
                             * @member {google.protobuf.IStringValue|null|undefined} countryCriterion
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint
                             * @instance
                             */
                            CountryConstraint.prototype.countryCriterion = null;

                            /**
                             * Creates a new CountryConstraint instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicConstraint.ICountryConstraint=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint} CountryConstraint instance
                             */
                            CountryConstraint.create = function create(properties) {
                                return new CountryConstraint(properties);
                            };

                            /**
                             * Encodes the specified CountryConstraint message. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicConstraint.ICountryConstraint} message CountryConstraint message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            CountryConstraint.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.countryCriterion != null && message.hasOwnProperty("countryCriterion"))
                                    $root.google.protobuf.StringValue.encode(message.countryCriterion, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified CountryConstraint message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicConstraint.ICountryConstraint} message CountryConstraint message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            CountryConstraint.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a CountryConstraint message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint} CountryConstraint
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            CountryConstraint.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.countryCriterion = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a CountryConstraint message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint} CountryConstraint
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            CountryConstraint.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a CountryConstraint message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            CountryConstraint.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.countryCriterion != null && message.hasOwnProperty("countryCriterion")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.countryCriterion);
                                    if (error)
                                        return "countryCriterion." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a CountryConstraint message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint} CountryConstraint
                             */
                            CountryConstraint.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint();
                                if (object.countryCriterion != null) {
                                    if (typeof object.countryCriterion !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint.countryCriterion: object expected");
                                    message.countryCriterion = $root.google.protobuf.StringValue.fromObject(object.countryCriterion);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a CountryConstraint message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint
                             * @static
                             * @param {google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint} message CountryConstraint
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            CountryConstraint.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults)
                                    object.countryCriterion = null;
                                if (message.countryCriterion != null && message.hasOwnProperty("countryCriterion"))
                                    object.countryCriterion = $root.google.protobuf.StringValue.toObject(message.countryCriterion, options);
                                return object;
                            };

                            /**
                             * Converts this CountryConstraint to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.common.PolicyTopicConstraint.CountryConstraint
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            CountryConstraint.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return CountryConstraint;
                        })();

                        return PolicyTopicConstraint;
                    })();

                    common.RealTimeBiddingSetting = (function() {

                        /**
                         * Properties of a RealTimeBiddingSetting.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IRealTimeBiddingSetting
                         * @property {google.protobuf.IBoolValue|null} [optIn] RealTimeBiddingSetting optIn
                         */

                        /**
                         * Constructs a new RealTimeBiddingSetting.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a RealTimeBiddingSetting.
                         * @implements IRealTimeBiddingSetting
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IRealTimeBiddingSetting=} [properties] Properties to set
                         */
                        function RealTimeBiddingSetting(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * RealTimeBiddingSetting optIn.
                         * @member {google.protobuf.IBoolValue|null|undefined} optIn
                         * @memberof google.ads.googleads.v1.common.RealTimeBiddingSetting
                         * @instance
                         */
                        RealTimeBiddingSetting.prototype.optIn = null;

                        /**
                         * Creates a new RealTimeBiddingSetting instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.RealTimeBiddingSetting
                         * @static
                         * @param {google.ads.googleads.v1.common.IRealTimeBiddingSetting=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.RealTimeBiddingSetting} RealTimeBiddingSetting instance
                         */
                        RealTimeBiddingSetting.create = function create(properties) {
                            return new RealTimeBiddingSetting(properties);
                        };

                        /**
                         * Encodes the specified RealTimeBiddingSetting message. Does not implicitly {@link google.ads.googleads.v1.common.RealTimeBiddingSetting.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.RealTimeBiddingSetting
                         * @static
                         * @param {google.ads.googleads.v1.common.IRealTimeBiddingSetting} message RealTimeBiddingSetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RealTimeBiddingSetting.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.optIn != null && message.hasOwnProperty("optIn"))
                                $root.google.protobuf.BoolValue.encode(message.optIn, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified RealTimeBiddingSetting message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.RealTimeBiddingSetting.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.RealTimeBiddingSetting
                         * @static
                         * @param {google.ads.googleads.v1.common.IRealTimeBiddingSetting} message RealTimeBiddingSetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RealTimeBiddingSetting.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a RealTimeBiddingSetting message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.RealTimeBiddingSetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.RealTimeBiddingSetting} RealTimeBiddingSetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RealTimeBiddingSetting.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.RealTimeBiddingSetting();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.optIn = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a RealTimeBiddingSetting message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.RealTimeBiddingSetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.RealTimeBiddingSetting} RealTimeBiddingSetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RealTimeBiddingSetting.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a RealTimeBiddingSetting message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.RealTimeBiddingSetting
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RealTimeBiddingSetting.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.optIn != null && message.hasOwnProperty("optIn")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.optIn);
                                if (error)
                                    return "optIn." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a RealTimeBiddingSetting message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.RealTimeBiddingSetting
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.RealTimeBiddingSetting} RealTimeBiddingSetting
                         */
                        RealTimeBiddingSetting.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.RealTimeBiddingSetting)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.RealTimeBiddingSetting();
                            if (object.optIn != null) {
                                if (typeof object.optIn !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.RealTimeBiddingSetting.optIn: object expected");
                                message.optIn = $root.google.protobuf.BoolValue.fromObject(object.optIn);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a RealTimeBiddingSetting message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.RealTimeBiddingSetting
                         * @static
                         * @param {google.ads.googleads.v1.common.RealTimeBiddingSetting} message RealTimeBiddingSetting
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RealTimeBiddingSetting.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.optIn = null;
                            if (message.optIn != null && message.hasOwnProperty("optIn"))
                                object.optIn = $root.google.protobuf.BoolValue.toObject(message.optIn, options);
                            return object;
                        };

                        /**
                         * Converts this RealTimeBiddingSetting to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.RealTimeBiddingSetting
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RealTimeBiddingSetting.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return RealTimeBiddingSetting;
                    })();

                    common.Segments = (function() {

                        /**
                         * Properties of a Segments.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ISegments
                         * @property {google.ads.googleads.v1.enums.AdNetworkTypeEnum.AdNetworkType|null} [adNetworkType] Segments adNetworkType
                         * @property {google.ads.googleads.v1.enums.ClickTypeEnum.ClickType|null} [clickType] Segments clickType
                         * @property {google.protobuf.IStringValue|null} [conversionAction] Segments conversionAction
                         * @property {google.ads.googleads.v1.enums.ConversionActionCategoryEnum.ConversionActionCategory|null} [conversionActionCategory] Segments conversionActionCategory
                         * @property {google.protobuf.IStringValue|null} [conversionActionName] Segments conversionActionName
                         * @property {google.protobuf.IBoolValue|null} [conversionAdjustment] Segments conversionAdjustment
                         * @property {google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum.ConversionAttributionEventType|null} [conversionAttributionEventType] Segments conversionAttributionEventType
                         * @property {google.ads.googleads.v1.enums.ConversionLagBucketEnum.ConversionLagBucket|null} [conversionLagBucket] Segments conversionLagBucket
                         * @property {google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum.ConversionOrAdjustmentLagBucket|null} [conversionOrAdjustmentLagBucket] Segments conversionOrAdjustmentLagBucket
                         * @property {google.protobuf.IStringValue|null} [date] Segments date
                         * @property {google.ads.googleads.v1.enums.DayOfWeekEnum.DayOfWeek|null} [dayOfWeek] Segments dayOfWeek
                         * @property {google.ads.googleads.v1.enums.DeviceEnum.Device|null} [device] Segments device
                         * @property {google.ads.googleads.v1.enums.ExternalConversionSourceEnum.ExternalConversionSource|null} [externalConversionSource] Segments externalConversionSource
                         * @property {google.protobuf.IStringValue|null} [geoTargetAirport] Segments geoTargetAirport
                         * @property {google.protobuf.IStringValue|null} [geoTargetCity] Segments geoTargetCity
                         * @property {google.protobuf.IStringValue|null} [geoTargetCounty] Segments geoTargetCounty
                         * @property {google.protobuf.IStringValue|null} [geoTargetDistrict] Segments geoTargetDistrict
                         * @property {google.protobuf.IStringValue|null} [geoTargetMetro] Segments geoTargetMetro
                         * @property {google.protobuf.IStringValue|null} [geoTargetMostSpecificLocation] Segments geoTargetMostSpecificLocation
                         * @property {google.protobuf.IStringValue|null} [geoTargetPostalCode] Segments geoTargetPostalCode
                         * @property {google.protobuf.IStringValue|null} [geoTargetRegion] Segments geoTargetRegion
                         * @property {google.protobuf.IStringValue|null} [geoTargetState] Segments geoTargetState
                         * @property {google.protobuf.IInt64Value|null} [hotelBookingWindowDays] Segments hotelBookingWindowDays
                         * @property {google.protobuf.IInt64Value|null} [hotelCenterId] Segments hotelCenterId
                         * @property {google.protobuf.IStringValue|null} [hotelCheckInDate] Segments hotelCheckInDate
                         * @property {google.ads.googleads.v1.enums.DayOfWeekEnum.DayOfWeek|null} [hotelCheckInDayOfWeek] Segments hotelCheckInDayOfWeek
                         * @property {google.protobuf.IStringValue|null} [hotelCity] Segments hotelCity
                         * @property {google.protobuf.IInt32Value|null} [hotelClass] Segments hotelClass
                         * @property {google.protobuf.IStringValue|null} [hotelCountry] Segments hotelCountry
                         * @property {google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum.HotelDateSelectionType|null} [hotelDateSelectionType] Segments hotelDateSelectionType
                         * @property {google.protobuf.IInt32Value|null} [hotelLengthOfStay] Segments hotelLengthOfStay
                         * @property {google.protobuf.IStringValue|null} [hotelState] Segments hotelState
                         * @property {google.protobuf.IInt32Value|null} [hour] Segments hour
                         * @property {google.protobuf.IBoolValue|null} [interactionOnThisExtension] Segments interactionOnThisExtension
                         * @property {google.ads.googleads.v1.common.IKeyword|null} [keyword] Segments keyword
                         * @property {google.protobuf.IStringValue|null} [month] Segments month
                         * @property {google.ads.googleads.v1.enums.MonthOfYearEnum.MonthOfYear|null} [monthOfYear] Segments monthOfYear
                         * @property {google.protobuf.IStringValue|null} [partnerHotelId] Segments partnerHotelId
                         * @property {google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType|null} [placeholderType] Segments placeholderType
                         * @property {google.protobuf.IUInt64Value|null} [productAggregatorId] Segments productAggregatorId
                         * @property {google.protobuf.IStringValue|null} [productBiddingCategoryLevel1] Segments productBiddingCategoryLevel1
                         * @property {google.protobuf.IStringValue|null} [productBiddingCategoryLevel2] Segments productBiddingCategoryLevel2
                         * @property {google.protobuf.IStringValue|null} [productBiddingCategoryLevel3] Segments productBiddingCategoryLevel3
                         * @property {google.protobuf.IStringValue|null} [productBiddingCategoryLevel4] Segments productBiddingCategoryLevel4
                         * @property {google.protobuf.IStringValue|null} [productBiddingCategoryLevel5] Segments productBiddingCategoryLevel5
                         * @property {google.protobuf.IStringValue|null} [productBrand] Segments productBrand
                         * @property {google.ads.googleads.v1.enums.ProductChannelEnum.ProductChannel|null} [productChannel] Segments productChannel
                         * @property {google.ads.googleads.v1.enums.ProductChannelExclusivityEnum.ProductChannelExclusivity|null} [productChannelExclusivity] Segments productChannelExclusivity
                         * @property {google.ads.googleads.v1.enums.ProductConditionEnum.ProductCondition|null} [productCondition] Segments productCondition
                         * @property {google.protobuf.IStringValue|null} [productCountry] Segments productCountry
                         * @property {google.protobuf.IStringValue|null} [productCustomAttribute0] Segments productCustomAttribute0
                         * @property {google.protobuf.IStringValue|null} [productCustomAttribute1] Segments productCustomAttribute1
                         * @property {google.protobuf.IStringValue|null} [productCustomAttribute2] Segments productCustomAttribute2
                         * @property {google.protobuf.IStringValue|null} [productCustomAttribute3] Segments productCustomAttribute3
                         * @property {google.protobuf.IStringValue|null} [productCustomAttribute4] Segments productCustomAttribute4
                         * @property {google.protobuf.IStringValue|null} [productItemId] Segments productItemId
                         * @property {google.protobuf.IStringValue|null} [productLanguage] Segments productLanguage
                         * @property {google.protobuf.IUInt64Value|null} [productMerchantId] Segments productMerchantId
                         * @property {google.protobuf.IStringValue|null} [productStoreId] Segments productStoreId
                         * @property {google.protobuf.IStringValue|null} [productTitle] Segments productTitle
                         * @property {google.protobuf.IStringValue|null} [productTypeL1] Segments productTypeL1
                         * @property {google.protobuf.IStringValue|null} [productTypeL2] Segments productTypeL2
                         * @property {google.protobuf.IStringValue|null} [productTypeL3] Segments productTypeL3
                         * @property {google.protobuf.IStringValue|null} [productTypeL4] Segments productTypeL4
                         * @property {google.protobuf.IStringValue|null} [productTypeL5] Segments productTypeL5
                         * @property {google.protobuf.IStringValue|null} [quarter] Segments quarter
                         * @property {google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum.SearchEngineResultsPageType|null} [searchEngineResultsPageType] Segments searchEngineResultsPageType
                         * @property {google.ads.googleads.v1.enums.SearchTermMatchTypeEnum.SearchTermMatchType|null} [searchTermMatchType] Segments searchTermMatchType
                         * @property {google.ads.googleads.v1.enums.SlotEnum.Slot|null} [slot] Segments slot
                         * @property {google.protobuf.IStringValue|null} [webpage] Segments webpage
                         * @property {google.protobuf.IStringValue|null} [week] Segments week
                         * @property {google.protobuf.IInt32Value|null} [year] Segments year
                         */

                        /**
                         * Constructs a new Segments.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a Segments.
                         * @implements ISegments
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ISegments=} [properties] Properties to set
                         */
                        function Segments(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Segments adNetworkType.
                         * @member {google.ads.googleads.v1.enums.AdNetworkTypeEnum.AdNetworkType} adNetworkType
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.adNetworkType = 0;

                        /**
                         * Segments clickType.
                         * @member {google.ads.googleads.v1.enums.ClickTypeEnum.ClickType} clickType
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.clickType = 0;

                        /**
                         * Segments conversionAction.
                         * @member {google.protobuf.IStringValue|null|undefined} conversionAction
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.conversionAction = null;

                        /**
                         * Segments conversionActionCategory.
                         * @member {google.ads.googleads.v1.enums.ConversionActionCategoryEnum.ConversionActionCategory} conversionActionCategory
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.conversionActionCategory = 0;

                        /**
                         * Segments conversionActionName.
                         * @member {google.protobuf.IStringValue|null|undefined} conversionActionName
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.conversionActionName = null;

                        /**
                         * Segments conversionAdjustment.
                         * @member {google.protobuf.IBoolValue|null|undefined} conversionAdjustment
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.conversionAdjustment = null;

                        /**
                         * Segments conversionAttributionEventType.
                         * @member {google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum.ConversionAttributionEventType} conversionAttributionEventType
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.conversionAttributionEventType = 0;

                        /**
                         * Segments conversionLagBucket.
                         * @member {google.ads.googleads.v1.enums.ConversionLagBucketEnum.ConversionLagBucket} conversionLagBucket
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.conversionLagBucket = 0;

                        /**
                         * Segments conversionOrAdjustmentLagBucket.
                         * @member {google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum.ConversionOrAdjustmentLagBucket} conversionOrAdjustmentLagBucket
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.conversionOrAdjustmentLagBucket = 0;

                        /**
                         * Segments date.
                         * @member {google.protobuf.IStringValue|null|undefined} date
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.date = null;

                        /**
                         * Segments dayOfWeek.
                         * @member {google.ads.googleads.v1.enums.DayOfWeekEnum.DayOfWeek} dayOfWeek
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.dayOfWeek = 0;

                        /**
                         * Segments device.
                         * @member {google.ads.googleads.v1.enums.DeviceEnum.Device} device
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.device = 0;

                        /**
                         * Segments externalConversionSource.
                         * @member {google.ads.googleads.v1.enums.ExternalConversionSourceEnum.ExternalConversionSource} externalConversionSource
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.externalConversionSource = 0;

                        /**
                         * Segments geoTargetAirport.
                         * @member {google.protobuf.IStringValue|null|undefined} geoTargetAirport
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.geoTargetAirport = null;

                        /**
                         * Segments geoTargetCity.
                         * @member {google.protobuf.IStringValue|null|undefined} geoTargetCity
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.geoTargetCity = null;

                        /**
                         * Segments geoTargetCounty.
                         * @member {google.protobuf.IStringValue|null|undefined} geoTargetCounty
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.geoTargetCounty = null;

                        /**
                         * Segments geoTargetDistrict.
                         * @member {google.protobuf.IStringValue|null|undefined} geoTargetDistrict
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.geoTargetDistrict = null;

                        /**
                         * Segments geoTargetMetro.
                         * @member {google.protobuf.IStringValue|null|undefined} geoTargetMetro
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.geoTargetMetro = null;

                        /**
                         * Segments geoTargetMostSpecificLocation.
                         * @member {google.protobuf.IStringValue|null|undefined} geoTargetMostSpecificLocation
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.geoTargetMostSpecificLocation = null;

                        /**
                         * Segments geoTargetPostalCode.
                         * @member {google.protobuf.IStringValue|null|undefined} geoTargetPostalCode
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.geoTargetPostalCode = null;

                        /**
                         * Segments geoTargetRegion.
                         * @member {google.protobuf.IStringValue|null|undefined} geoTargetRegion
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.geoTargetRegion = null;

                        /**
                         * Segments geoTargetState.
                         * @member {google.protobuf.IStringValue|null|undefined} geoTargetState
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.geoTargetState = null;

                        /**
                         * Segments hotelBookingWindowDays.
                         * @member {google.protobuf.IInt64Value|null|undefined} hotelBookingWindowDays
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.hotelBookingWindowDays = null;

                        /**
                         * Segments hotelCenterId.
                         * @member {google.protobuf.IInt64Value|null|undefined} hotelCenterId
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.hotelCenterId = null;

                        /**
                         * Segments hotelCheckInDate.
                         * @member {google.protobuf.IStringValue|null|undefined} hotelCheckInDate
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.hotelCheckInDate = null;

                        /**
                         * Segments hotelCheckInDayOfWeek.
                         * @member {google.ads.googleads.v1.enums.DayOfWeekEnum.DayOfWeek} hotelCheckInDayOfWeek
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.hotelCheckInDayOfWeek = 0;

                        /**
                         * Segments hotelCity.
                         * @member {google.protobuf.IStringValue|null|undefined} hotelCity
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.hotelCity = null;

                        /**
                         * Segments hotelClass.
                         * @member {google.protobuf.IInt32Value|null|undefined} hotelClass
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.hotelClass = null;

                        /**
                         * Segments hotelCountry.
                         * @member {google.protobuf.IStringValue|null|undefined} hotelCountry
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.hotelCountry = null;

                        /**
                         * Segments hotelDateSelectionType.
                         * @member {google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum.HotelDateSelectionType} hotelDateSelectionType
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.hotelDateSelectionType = 0;

                        /**
                         * Segments hotelLengthOfStay.
                         * @member {google.protobuf.IInt32Value|null|undefined} hotelLengthOfStay
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.hotelLengthOfStay = null;

                        /**
                         * Segments hotelState.
                         * @member {google.protobuf.IStringValue|null|undefined} hotelState
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.hotelState = null;

                        /**
                         * Segments hour.
                         * @member {google.protobuf.IInt32Value|null|undefined} hour
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.hour = null;

                        /**
                         * Segments interactionOnThisExtension.
                         * @member {google.protobuf.IBoolValue|null|undefined} interactionOnThisExtension
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.interactionOnThisExtension = null;

                        /**
                         * Segments keyword.
                         * @member {google.ads.googleads.v1.common.IKeyword|null|undefined} keyword
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.keyword = null;

                        /**
                         * Segments month.
                         * @member {google.protobuf.IStringValue|null|undefined} month
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.month = null;

                        /**
                         * Segments monthOfYear.
                         * @member {google.ads.googleads.v1.enums.MonthOfYearEnum.MonthOfYear} monthOfYear
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.monthOfYear = 0;

                        /**
                         * Segments partnerHotelId.
                         * @member {google.protobuf.IStringValue|null|undefined} partnerHotelId
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.partnerHotelId = null;

                        /**
                         * Segments placeholderType.
                         * @member {google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType} placeholderType
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.placeholderType = 0;

                        /**
                         * Segments productAggregatorId.
                         * @member {google.protobuf.IUInt64Value|null|undefined} productAggregatorId
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productAggregatorId = null;

                        /**
                         * Segments productBiddingCategoryLevel1.
                         * @member {google.protobuf.IStringValue|null|undefined} productBiddingCategoryLevel1
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productBiddingCategoryLevel1 = null;

                        /**
                         * Segments productBiddingCategoryLevel2.
                         * @member {google.protobuf.IStringValue|null|undefined} productBiddingCategoryLevel2
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productBiddingCategoryLevel2 = null;

                        /**
                         * Segments productBiddingCategoryLevel3.
                         * @member {google.protobuf.IStringValue|null|undefined} productBiddingCategoryLevel3
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productBiddingCategoryLevel3 = null;

                        /**
                         * Segments productBiddingCategoryLevel4.
                         * @member {google.protobuf.IStringValue|null|undefined} productBiddingCategoryLevel4
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productBiddingCategoryLevel4 = null;

                        /**
                         * Segments productBiddingCategoryLevel5.
                         * @member {google.protobuf.IStringValue|null|undefined} productBiddingCategoryLevel5
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productBiddingCategoryLevel5 = null;

                        /**
                         * Segments productBrand.
                         * @member {google.protobuf.IStringValue|null|undefined} productBrand
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productBrand = null;

                        /**
                         * Segments productChannel.
                         * @member {google.ads.googleads.v1.enums.ProductChannelEnum.ProductChannel} productChannel
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productChannel = 0;

                        /**
                         * Segments productChannelExclusivity.
                         * @member {google.ads.googleads.v1.enums.ProductChannelExclusivityEnum.ProductChannelExclusivity} productChannelExclusivity
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productChannelExclusivity = 0;

                        /**
                         * Segments productCondition.
                         * @member {google.ads.googleads.v1.enums.ProductConditionEnum.ProductCondition} productCondition
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productCondition = 0;

                        /**
                         * Segments productCountry.
                         * @member {google.protobuf.IStringValue|null|undefined} productCountry
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productCountry = null;

                        /**
                         * Segments productCustomAttribute0.
                         * @member {google.protobuf.IStringValue|null|undefined} productCustomAttribute0
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productCustomAttribute0 = null;

                        /**
                         * Segments productCustomAttribute1.
                         * @member {google.protobuf.IStringValue|null|undefined} productCustomAttribute1
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productCustomAttribute1 = null;

                        /**
                         * Segments productCustomAttribute2.
                         * @member {google.protobuf.IStringValue|null|undefined} productCustomAttribute2
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productCustomAttribute2 = null;

                        /**
                         * Segments productCustomAttribute3.
                         * @member {google.protobuf.IStringValue|null|undefined} productCustomAttribute3
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productCustomAttribute3 = null;

                        /**
                         * Segments productCustomAttribute4.
                         * @member {google.protobuf.IStringValue|null|undefined} productCustomAttribute4
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productCustomAttribute4 = null;

                        /**
                         * Segments productItemId.
                         * @member {google.protobuf.IStringValue|null|undefined} productItemId
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productItemId = null;

                        /**
                         * Segments productLanguage.
                         * @member {google.protobuf.IStringValue|null|undefined} productLanguage
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productLanguage = null;

                        /**
                         * Segments productMerchantId.
                         * @member {google.protobuf.IUInt64Value|null|undefined} productMerchantId
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productMerchantId = null;

                        /**
                         * Segments productStoreId.
                         * @member {google.protobuf.IStringValue|null|undefined} productStoreId
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productStoreId = null;

                        /**
                         * Segments productTitle.
                         * @member {google.protobuf.IStringValue|null|undefined} productTitle
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productTitle = null;

                        /**
                         * Segments productTypeL1.
                         * @member {google.protobuf.IStringValue|null|undefined} productTypeL1
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productTypeL1 = null;

                        /**
                         * Segments productTypeL2.
                         * @member {google.protobuf.IStringValue|null|undefined} productTypeL2
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productTypeL2 = null;

                        /**
                         * Segments productTypeL3.
                         * @member {google.protobuf.IStringValue|null|undefined} productTypeL3
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productTypeL3 = null;

                        /**
                         * Segments productTypeL4.
                         * @member {google.protobuf.IStringValue|null|undefined} productTypeL4
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productTypeL4 = null;

                        /**
                         * Segments productTypeL5.
                         * @member {google.protobuf.IStringValue|null|undefined} productTypeL5
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.productTypeL5 = null;

                        /**
                         * Segments quarter.
                         * @member {google.protobuf.IStringValue|null|undefined} quarter
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.quarter = null;

                        /**
                         * Segments searchEngineResultsPageType.
                         * @member {google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum.SearchEngineResultsPageType} searchEngineResultsPageType
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.searchEngineResultsPageType = 0;

                        /**
                         * Segments searchTermMatchType.
                         * @member {google.ads.googleads.v1.enums.SearchTermMatchTypeEnum.SearchTermMatchType} searchTermMatchType
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.searchTermMatchType = 0;

                        /**
                         * Segments slot.
                         * @member {google.ads.googleads.v1.enums.SlotEnum.Slot} slot
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.slot = 0;

                        /**
                         * Segments webpage.
                         * @member {google.protobuf.IStringValue|null|undefined} webpage
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.webpage = null;

                        /**
                         * Segments week.
                         * @member {google.protobuf.IStringValue|null|undefined} week
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.week = null;

                        /**
                         * Segments year.
                         * @member {google.protobuf.IInt32Value|null|undefined} year
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         */
                        Segments.prototype.year = null;

                        /**
                         * Creates a new Segments instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @static
                         * @param {google.ads.googleads.v1.common.ISegments=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.Segments} Segments instance
                         */
                        Segments.create = function create(properties) {
                            return new Segments(properties);
                        };

                        /**
                         * Encodes the specified Segments message. Does not implicitly {@link google.ads.googleads.v1.common.Segments.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @static
                         * @param {google.ads.googleads.v1.common.ISegments} message Segments message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Segments.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.device != null && message.hasOwnProperty("device"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.device);
                            if (message.conversionAttributionEventType != null && message.hasOwnProperty("conversionAttributionEventType"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.conversionAttributionEventType);
                            if (message.adNetworkType != null && message.hasOwnProperty("adNetworkType"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.adNetworkType);
                            if (message.date != null && message.hasOwnProperty("date"))
                                $root.google.protobuf.StringValue.encode(message.date, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.dayOfWeek != null && message.hasOwnProperty("dayOfWeek"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.dayOfWeek);
                            if (message.hotelBookingWindowDays != null && message.hasOwnProperty("hotelBookingWindowDays"))
                                $root.google.protobuf.Int64Value.encode(message.hotelBookingWindowDays, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.hotelCenterId != null && message.hasOwnProperty("hotelCenterId"))
                                $root.google.protobuf.Int64Value.encode(message.hotelCenterId, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.hotelCheckInDate != null && message.hasOwnProperty("hotelCheckInDate"))
                                $root.google.protobuf.StringValue.encode(message.hotelCheckInDate, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.hotelCheckInDayOfWeek != null && message.hasOwnProperty("hotelCheckInDayOfWeek"))
                                writer.uint32(/* id 9, wireType 0 =*/72).int32(message.hotelCheckInDayOfWeek);
                            if (message.hotelCity != null && message.hasOwnProperty("hotelCity"))
                                $root.google.protobuf.StringValue.encode(message.hotelCity, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.hotelClass != null && message.hasOwnProperty("hotelClass"))
                                $root.google.protobuf.Int32Value.encode(message.hotelClass, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.hotelCountry != null && message.hasOwnProperty("hotelCountry"))
                                $root.google.protobuf.StringValue.encode(message.hotelCountry, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.hotelDateSelectionType != null && message.hasOwnProperty("hotelDateSelectionType"))
                                writer.uint32(/* id 13, wireType 0 =*/104).int32(message.hotelDateSelectionType);
                            if (message.hotelLengthOfStay != null && message.hasOwnProperty("hotelLengthOfStay"))
                                $root.google.protobuf.Int32Value.encode(message.hotelLengthOfStay, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.hotelState != null && message.hasOwnProperty("hotelState"))
                                $root.google.protobuf.StringValue.encode(message.hotelState, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
                            if (message.hour != null && message.hasOwnProperty("hour"))
                                $root.google.protobuf.Int32Value.encode(message.hour, writer.uint32(/* id 16, wireType 2 =*/130).fork()).ldelim();
                            if (message.month != null && message.hasOwnProperty("month"))
                                $root.google.protobuf.StringValue.encode(message.month, writer.uint32(/* id 17, wireType 2 =*/138).fork()).ldelim();
                            if (message.monthOfYear != null && message.hasOwnProperty("monthOfYear"))
                                writer.uint32(/* id 18, wireType 0 =*/144).int32(message.monthOfYear);
                            if (message.partnerHotelId != null && message.hasOwnProperty("partnerHotelId"))
                                $root.google.protobuf.StringValue.encode(message.partnerHotelId, writer.uint32(/* id 19, wireType 2 =*/154).fork()).ldelim();
                            if (message.placeholderType != null && message.hasOwnProperty("placeholderType"))
                                writer.uint32(/* id 20, wireType 0 =*/160).int32(message.placeholderType);
                            if (message.quarter != null && message.hasOwnProperty("quarter"))
                                $root.google.protobuf.StringValue.encode(message.quarter, writer.uint32(/* id 21, wireType 2 =*/170).fork()).ldelim();
                            if (message.searchTermMatchType != null && message.hasOwnProperty("searchTermMatchType"))
                                writer.uint32(/* id 22, wireType 0 =*/176).int32(message.searchTermMatchType);
                            if (message.slot != null && message.hasOwnProperty("slot"))
                                writer.uint32(/* id 23, wireType 0 =*/184).int32(message.slot);
                            if (message.week != null && message.hasOwnProperty("week"))
                                $root.google.protobuf.StringValue.encode(message.week, writer.uint32(/* id 24, wireType 2 =*/194).fork()).ldelim();
                            if (message.year != null && message.hasOwnProperty("year"))
                                $root.google.protobuf.Int32Value.encode(message.year, writer.uint32(/* id 25, wireType 2 =*/202).fork()).ldelim();
                            if (message.clickType != null && message.hasOwnProperty("clickType"))
                                writer.uint32(/* id 26, wireType 0 =*/208).int32(message.clickType);
                            if (message.conversionAdjustment != null && message.hasOwnProperty("conversionAdjustment"))
                                $root.google.protobuf.BoolValue.encode(message.conversionAdjustment, writer.uint32(/* id 27, wireType 2 =*/218).fork()).ldelim();
                            if (message.productAggregatorId != null && message.hasOwnProperty("productAggregatorId"))
                                $root.google.protobuf.UInt64Value.encode(message.productAggregatorId, writer.uint32(/* id 28, wireType 2 =*/226).fork()).ldelim();
                            if (message.productBrand != null && message.hasOwnProperty("productBrand"))
                                $root.google.protobuf.StringValue.encode(message.productBrand, writer.uint32(/* id 29, wireType 2 =*/234).fork()).ldelim();
                            if (message.productChannel != null && message.hasOwnProperty("productChannel"))
                                writer.uint32(/* id 30, wireType 0 =*/240).int32(message.productChannel);
                            if (message.productChannelExclusivity != null && message.hasOwnProperty("productChannelExclusivity"))
                                writer.uint32(/* id 31, wireType 0 =*/248).int32(message.productChannelExclusivity);
                            if (message.productCondition != null && message.hasOwnProperty("productCondition"))
                                writer.uint32(/* id 32, wireType 0 =*/256).int32(message.productCondition);
                            if (message.productCountry != null && message.hasOwnProperty("productCountry"))
                                $root.google.protobuf.StringValue.encode(message.productCountry, writer.uint32(/* id 33, wireType 2 =*/266).fork()).ldelim();
                            if (message.productCustomAttribute0 != null && message.hasOwnProperty("productCustomAttribute0"))
                                $root.google.protobuf.StringValue.encode(message.productCustomAttribute0, writer.uint32(/* id 34, wireType 2 =*/274).fork()).ldelim();
                            if (message.productCustomAttribute1 != null && message.hasOwnProperty("productCustomAttribute1"))
                                $root.google.protobuf.StringValue.encode(message.productCustomAttribute1, writer.uint32(/* id 35, wireType 2 =*/282).fork()).ldelim();
                            if (message.productCustomAttribute2 != null && message.hasOwnProperty("productCustomAttribute2"))
                                $root.google.protobuf.StringValue.encode(message.productCustomAttribute2, writer.uint32(/* id 36, wireType 2 =*/290).fork()).ldelim();
                            if (message.productCustomAttribute3 != null && message.hasOwnProperty("productCustomAttribute3"))
                                $root.google.protobuf.StringValue.encode(message.productCustomAttribute3, writer.uint32(/* id 37, wireType 2 =*/298).fork()).ldelim();
                            if (message.productCustomAttribute4 != null && message.hasOwnProperty("productCustomAttribute4"))
                                $root.google.protobuf.StringValue.encode(message.productCustomAttribute4, writer.uint32(/* id 38, wireType 2 =*/306).fork()).ldelim();
                            if (message.productItemId != null && message.hasOwnProperty("productItemId"))
                                $root.google.protobuf.StringValue.encode(message.productItemId, writer.uint32(/* id 39, wireType 2 =*/314).fork()).ldelim();
                            if (message.productLanguage != null && message.hasOwnProperty("productLanguage"))
                                $root.google.protobuf.StringValue.encode(message.productLanguage, writer.uint32(/* id 40, wireType 2 =*/322).fork()).ldelim();
                            if (message.productMerchantId != null && message.hasOwnProperty("productMerchantId"))
                                $root.google.protobuf.UInt64Value.encode(message.productMerchantId, writer.uint32(/* id 41, wireType 2 =*/330).fork()).ldelim();
                            if (message.productStoreId != null && message.hasOwnProperty("productStoreId"))
                                $root.google.protobuf.StringValue.encode(message.productStoreId, writer.uint32(/* id 42, wireType 2 =*/338).fork()).ldelim();
                            if (message.productTitle != null && message.hasOwnProperty("productTitle"))
                                $root.google.protobuf.StringValue.encode(message.productTitle, writer.uint32(/* id 43, wireType 2 =*/346).fork()).ldelim();
                            if (message.productTypeL1 != null && message.hasOwnProperty("productTypeL1"))
                                $root.google.protobuf.StringValue.encode(message.productTypeL1, writer.uint32(/* id 44, wireType 2 =*/354).fork()).ldelim();
                            if (message.productTypeL2 != null && message.hasOwnProperty("productTypeL2"))
                                $root.google.protobuf.StringValue.encode(message.productTypeL2, writer.uint32(/* id 45, wireType 2 =*/362).fork()).ldelim();
                            if (message.productTypeL3 != null && message.hasOwnProperty("productTypeL3"))
                                $root.google.protobuf.StringValue.encode(message.productTypeL3, writer.uint32(/* id 46, wireType 2 =*/370).fork()).ldelim();
                            if (message.productTypeL4 != null && message.hasOwnProperty("productTypeL4"))
                                $root.google.protobuf.StringValue.encode(message.productTypeL4, writer.uint32(/* id 47, wireType 2 =*/378).fork()).ldelim();
                            if (message.productTypeL5 != null && message.hasOwnProperty("productTypeL5"))
                                $root.google.protobuf.StringValue.encode(message.productTypeL5, writer.uint32(/* id 48, wireType 2 =*/386).fork()).ldelim();
                            if (message.interactionOnThisExtension != null && message.hasOwnProperty("interactionOnThisExtension"))
                                $root.google.protobuf.BoolValue.encode(message.interactionOnThisExtension, writer.uint32(/* id 49, wireType 2 =*/394).fork()).ldelim();
                            if (message.conversionLagBucket != null && message.hasOwnProperty("conversionLagBucket"))
                                writer.uint32(/* id 50, wireType 0 =*/400).int32(message.conversionLagBucket);
                            if (message.conversionOrAdjustmentLagBucket != null && message.hasOwnProperty("conversionOrAdjustmentLagBucket"))
                                writer.uint32(/* id 51, wireType 0 =*/408).int32(message.conversionOrAdjustmentLagBucket);
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                $root.google.protobuf.StringValue.encode(message.conversionAction, writer.uint32(/* id 52, wireType 2 =*/418).fork()).ldelim();
                            if (message.conversionActionCategory != null && message.hasOwnProperty("conversionActionCategory"))
                                writer.uint32(/* id 53, wireType 0 =*/424).int32(message.conversionActionCategory);
                            if (message.conversionActionName != null && message.hasOwnProperty("conversionActionName"))
                                $root.google.protobuf.StringValue.encode(message.conversionActionName, writer.uint32(/* id 54, wireType 2 =*/434).fork()).ldelim();
                            if (message.externalConversionSource != null && message.hasOwnProperty("externalConversionSource"))
                                writer.uint32(/* id 55, wireType 0 =*/440).int32(message.externalConversionSource);
                            if (message.productBiddingCategoryLevel1 != null && message.hasOwnProperty("productBiddingCategoryLevel1"))
                                $root.google.protobuf.StringValue.encode(message.productBiddingCategoryLevel1, writer.uint32(/* id 56, wireType 2 =*/450).fork()).ldelim();
                            if (message.productBiddingCategoryLevel2 != null && message.hasOwnProperty("productBiddingCategoryLevel2"))
                                $root.google.protobuf.StringValue.encode(message.productBiddingCategoryLevel2, writer.uint32(/* id 57, wireType 2 =*/458).fork()).ldelim();
                            if (message.productBiddingCategoryLevel3 != null && message.hasOwnProperty("productBiddingCategoryLevel3"))
                                $root.google.protobuf.StringValue.encode(message.productBiddingCategoryLevel3, writer.uint32(/* id 58, wireType 2 =*/466).fork()).ldelim();
                            if (message.productBiddingCategoryLevel4 != null && message.hasOwnProperty("productBiddingCategoryLevel4"))
                                $root.google.protobuf.StringValue.encode(message.productBiddingCategoryLevel4, writer.uint32(/* id 59, wireType 2 =*/474).fork()).ldelim();
                            if (message.productBiddingCategoryLevel5 != null && message.hasOwnProperty("productBiddingCategoryLevel5"))
                                $root.google.protobuf.StringValue.encode(message.productBiddingCategoryLevel5, writer.uint32(/* id 60, wireType 2 =*/482).fork()).ldelim();
                            if (message.keyword != null && message.hasOwnProperty("keyword"))
                                $root.google.ads.googleads.v1.common.Keyword.encode(message.keyword, writer.uint32(/* id 61, wireType 2 =*/490).fork()).ldelim();
                            if (message.geoTargetCity != null && message.hasOwnProperty("geoTargetCity"))
                                $root.google.protobuf.StringValue.encode(message.geoTargetCity, writer.uint32(/* id 62, wireType 2 =*/498).fork()).ldelim();
                            if (message.geoTargetMetro != null && message.hasOwnProperty("geoTargetMetro"))
                                $root.google.protobuf.StringValue.encode(message.geoTargetMetro, writer.uint32(/* id 63, wireType 2 =*/506).fork()).ldelim();
                            if (message.geoTargetRegion != null && message.hasOwnProperty("geoTargetRegion"))
                                $root.google.protobuf.StringValue.encode(message.geoTargetRegion, writer.uint32(/* id 64, wireType 2 =*/514).fork()).ldelim();
                            if (message.geoTargetAirport != null && message.hasOwnProperty("geoTargetAirport"))
                                $root.google.protobuf.StringValue.encode(message.geoTargetAirport, writer.uint32(/* id 65, wireType 2 =*/522).fork()).ldelim();
                            if (message.webpage != null && message.hasOwnProperty("webpage"))
                                $root.google.protobuf.StringValue.encode(message.webpage, writer.uint32(/* id 66, wireType 2 =*/530).fork()).ldelim();
                            if (message.geoTargetState != null && message.hasOwnProperty("geoTargetState"))
                                $root.google.protobuf.StringValue.encode(message.geoTargetState, writer.uint32(/* id 67, wireType 2 =*/538).fork()).ldelim();
                            if (message.geoTargetCounty != null && message.hasOwnProperty("geoTargetCounty"))
                                $root.google.protobuf.StringValue.encode(message.geoTargetCounty, writer.uint32(/* id 68, wireType 2 =*/546).fork()).ldelim();
                            if (message.geoTargetDistrict != null && message.hasOwnProperty("geoTargetDistrict"))
                                $root.google.protobuf.StringValue.encode(message.geoTargetDistrict, writer.uint32(/* id 69, wireType 2 =*/554).fork()).ldelim();
                            if (message.searchEngineResultsPageType != null && message.hasOwnProperty("searchEngineResultsPageType"))
                                writer.uint32(/* id 70, wireType 0 =*/560).int32(message.searchEngineResultsPageType);
                            if (message.geoTargetPostalCode != null && message.hasOwnProperty("geoTargetPostalCode"))
                                $root.google.protobuf.StringValue.encode(message.geoTargetPostalCode, writer.uint32(/* id 71, wireType 2 =*/570).fork()).ldelim();
                            if (message.geoTargetMostSpecificLocation != null && message.hasOwnProperty("geoTargetMostSpecificLocation"))
                                $root.google.protobuf.StringValue.encode(message.geoTargetMostSpecificLocation, writer.uint32(/* id 72, wireType 2 =*/578).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified Segments message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.Segments.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @static
                         * @param {google.ads.googleads.v1.common.ISegments} message Segments message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Segments.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a Segments message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.Segments} Segments
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Segments.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.Segments();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.adNetworkType = reader.int32();
                                    break;
                                case 26:
                                    message.clickType = reader.int32();
                                    break;
                                case 52:
                                    message.conversionAction = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 53:
                                    message.conversionActionCategory = reader.int32();
                                    break;
                                case 54:
                                    message.conversionActionName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 27:
                                    message.conversionAdjustment = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.conversionAttributionEventType = reader.int32();
                                    break;
                                case 50:
                                    message.conversionLagBucket = reader.int32();
                                    break;
                                case 51:
                                    message.conversionOrAdjustmentLagBucket = reader.int32();
                                    break;
                                case 4:
                                    message.date = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.dayOfWeek = reader.int32();
                                    break;
                                case 1:
                                    message.device = reader.int32();
                                    break;
                                case 55:
                                    message.externalConversionSource = reader.int32();
                                    break;
                                case 65:
                                    message.geoTargetAirport = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 62:
                                    message.geoTargetCity = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 68:
                                    message.geoTargetCounty = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 69:
                                    message.geoTargetDistrict = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 63:
                                    message.geoTargetMetro = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 72:
                                    message.geoTargetMostSpecificLocation = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 71:
                                    message.geoTargetPostalCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 64:
                                    message.geoTargetRegion = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 67:
                                    message.geoTargetState = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.hotelBookingWindowDays = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.hotelCenterId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.hotelCheckInDate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.hotelCheckInDayOfWeek = reader.int32();
                                    break;
                                case 10:
                                    message.hotelCity = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.hotelClass = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.hotelCountry = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 13:
                                    message.hotelDateSelectionType = reader.int32();
                                    break;
                                case 14:
                                    message.hotelLengthOfStay = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                    break;
                                case 15:
                                    message.hotelState = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 16:
                                    message.hour = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                    break;
                                case 49:
                                    message.interactionOnThisExtension = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 61:
                                    message.keyword = $root.google.ads.googleads.v1.common.Keyword.decode(reader, reader.uint32());
                                    break;
                                case 17:
                                    message.month = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 18:
                                    message.monthOfYear = reader.int32();
                                    break;
                                case 19:
                                    message.partnerHotelId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 20:
                                    message.placeholderType = reader.int32();
                                    break;
                                case 28:
                                    message.productAggregatorId = $root.google.protobuf.UInt64Value.decode(reader, reader.uint32());
                                    break;
                                case 56:
                                    message.productBiddingCategoryLevel1 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 57:
                                    message.productBiddingCategoryLevel2 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 58:
                                    message.productBiddingCategoryLevel3 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 59:
                                    message.productBiddingCategoryLevel4 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 60:
                                    message.productBiddingCategoryLevel5 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 29:
                                    message.productBrand = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 30:
                                    message.productChannel = reader.int32();
                                    break;
                                case 31:
                                    message.productChannelExclusivity = reader.int32();
                                    break;
                                case 32:
                                    message.productCondition = reader.int32();
                                    break;
                                case 33:
                                    message.productCountry = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 34:
                                    message.productCustomAttribute0 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 35:
                                    message.productCustomAttribute1 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 36:
                                    message.productCustomAttribute2 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 37:
                                    message.productCustomAttribute3 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 38:
                                    message.productCustomAttribute4 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 39:
                                    message.productItemId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 40:
                                    message.productLanguage = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 41:
                                    message.productMerchantId = $root.google.protobuf.UInt64Value.decode(reader, reader.uint32());
                                    break;
                                case 42:
                                    message.productStoreId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 43:
                                    message.productTitle = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 44:
                                    message.productTypeL1 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 45:
                                    message.productTypeL2 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 46:
                                    message.productTypeL3 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 47:
                                    message.productTypeL4 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 48:
                                    message.productTypeL5 = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 21:
                                    message.quarter = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 70:
                                    message.searchEngineResultsPageType = reader.int32();
                                    break;
                                case 22:
                                    message.searchTermMatchType = reader.int32();
                                    break;
                                case 23:
                                    message.slot = reader.int32();
                                    break;
                                case 66:
                                    message.webpage = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 24:
                                    message.week = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 25:
                                    message.year = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a Segments message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.Segments} Segments
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Segments.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a Segments message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Segments.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.adNetworkType != null && message.hasOwnProperty("adNetworkType"))
                                switch (message.adNetworkType) {
                                default:
                                    return "adNetworkType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            if (message.clickType != null && message.hasOwnProperty("clickType"))
                                switch (message.clickType) {
                                default:
                                    return "clickType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 25:
                                case 26:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                case 32:
                                case 33:
                                case 34:
                                case 35:
                                case 36:
                                case 37:
                                case 38:
                                case 39:
                                case 40:
                                case 42:
                                case 43:
                                case 44:
                                case 45:
                                case 46:
                                case 47:
                                case 48:
                                case 49:
                                case 50:
                                case 51:
                                case 52:
                                case 53:
                                case 54:
                                case 55:
                                    break;
                                }
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction")) {
                                var error = $root.google.protobuf.StringValue.verify(message.conversionAction);
                                if (error)
                                    return "conversionAction." + error;
                            }
                            if (message.conversionActionCategory != null && message.hasOwnProperty("conversionActionCategory"))
                                switch (message.conversionActionCategory) {
                                default:
                                    return "conversionActionCategory: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            if (message.conversionActionName != null && message.hasOwnProperty("conversionActionName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.conversionActionName);
                                if (error)
                                    return "conversionActionName." + error;
                            }
                            if (message.conversionAdjustment != null && message.hasOwnProperty("conversionAdjustment")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.conversionAdjustment);
                                if (error)
                                    return "conversionAdjustment." + error;
                            }
                            if (message.conversionAttributionEventType != null && message.hasOwnProperty("conversionAttributionEventType"))
                                switch (message.conversionAttributionEventType) {
                                default:
                                    return "conversionAttributionEventType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.conversionLagBucket != null && message.hasOwnProperty("conversionLagBucket"))
                                switch (message.conversionLagBucket) {
                                default:
                                    return "conversionLagBucket: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                    break;
                                }
                            if (message.conversionOrAdjustmentLagBucket != null && message.hasOwnProperty("conversionOrAdjustmentLagBucket"))
                                switch (message.conversionOrAdjustmentLagBucket) {
                                default:
                                    return "conversionOrAdjustmentLagBucket: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                case 32:
                                case 33:
                                case 34:
                                case 35:
                                case 36:
                                case 37:
                                case 38:
                                case 39:
                                case 40:
                                case 41:
                                case 42:
                                    break;
                                }
                            if (message.date != null && message.hasOwnProperty("date")) {
                                var error = $root.google.protobuf.StringValue.verify(message.date);
                                if (error)
                                    return "date." + error;
                            }
                            if (message.dayOfWeek != null && message.hasOwnProperty("dayOfWeek"))
                                switch (message.dayOfWeek) {
                                default:
                                    return "dayOfWeek: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                    break;
                                }
                            if (message.device != null && message.hasOwnProperty("device"))
                                switch (message.device) {
                                default:
                                    return "device: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            if (message.externalConversionSource != null && message.hasOwnProperty("externalConversionSource"))
                                switch (message.externalConversionSource) {
                                default:
                                    return "externalConversionSource: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                    break;
                                }
                            if (message.geoTargetAirport != null && message.hasOwnProperty("geoTargetAirport")) {
                                var error = $root.google.protobuf.StringValue.verify(message.geoTargetAirport);
                                if (error)
                                    return "geoTargetAirport." + error;
                            }
                            if (message.geoTargetCity != null && message.hasOwnProperty("geoTargetCity")) {
                                var error = $root.google.protobuf.StringValue.verify(message.geoTargetCity);
                                if (error)
                                    return "geoTargetCity." + error;
                            }
                            if (message.geoTargetCounty != null && message.hasOwnProperty("geoTargetCounty")) {
                                var error = $root.google.protobuf.StringValue.verify(message.geoTargetCounty);
                                if (error)
                                    return "geoTargetCounty." + error;
                            }
                            if (message.geoTargetDistrict != null && message.hasOwnProperty("geoTargetDistrict")) {
                                var error = $root.google.protobuf.StringValue.verify(message.geoTargetDistrict);
                                if (error)
                                    return "geoTargetDistrict." + error;
                            }
                            if (message.geoTargetMetro != null && message.hasOwnProperty("geoTargetMetro")) {
                                var error = $root.google.protobuf.StringValue.verify(message.geoTargetMetro);
                                if (error)
                                    return "geoTargetMetro." + error;
                            }
                            if (message.geoTargetMostSpecificLocation != null && message.hasOwnProperty("geoTargetMostSpecificLocation")) {
                                var error = $root.google.protobuf.StringValue.verify(message.geoTargetMostSpecificLocation);
                                if (error)
                                    return "geoTargetMostSpecificLocation." + error;
                            }
                            if (message.geoTargetPostalCode != null && message.hasOwnProperty("geoTargetPostalCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.geoTargetPostalCode);
                                if (error)
                                    return "geoTargetPostalCode." + error;
                            }
                            if (message.geoTargetRegion != null && message.hasOwnProperty("geoTargetRegion")) {
                                var error = $root.google.protobuf.StringValue.verify(message.geoTargetRegion);
                                if (error)
                                    return "geoTargetRegion." + error;
                            }
                            if (message.geoTargetState != null && message.hasOwnProperty("geoTargetState")) {
                                var error = $root.google.protobuf.StringValue.verify(message.geoTargetState);
                                if (error)
                                    return "geoTargetState." + error;
                            }
                            if (message.hotelBookingWindowDays != null && message.hasOwnProperty("hotelBookingWindowDays")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.hotelBookingWindowDays);
                                if (error)
                                    return "hotelBookingWindowDays." + error;
                            }
                            if (message.hotelCenterId != null && message.hasOwnProperty("hotelCenterId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.hotelCenterId);
                                if (error)
                                    return "hotelCenterId." + error;
                            }
                            if (message.hotelCheckInDate != null && message.hasOwnProperty("hotelCheckInDate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.hotelCheckInDate);
                                if (error)
                                    return "hotelCheckInDate." + error;
                            }
                            if (message.hotelCheckInDayOfWeek != null && message.hasOwnProperty("hotelCheckInDayOfWeek"))
                                switch (message.hotelCheckInDayOfWeek) {
                                default:
                                    return "hotelCheckInDayOfWeek: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                    break;
                                }
                            if (message.hotelCity != null && message.hasOwnProperty("hotelCity")) {
                                var error = $root.google.protobuf.StringValue.verify(message.hotelCity);
                                if (error)
                                    return "hotelCity." + error;
                            }
                            if (message.hotelClass != null && message.hasOwnProperty("hotelClass")) {
                                var error = $root.google.protobuf.Int32Value.verify(message.hotelClass);
                                if (error)
                                    return "hotelClass." + error;
                            }
                            if (message.hotelCountry != null && message.hasOwnProperty("hotelCountry")) {
                                var error = $root.google.protobuf.StringValue.verify(message.hotelCountry);
                                if (error)
                                    return "hotelCountry." + error;
                            }
                            if (message.hotelDateSelectionType != null && message.hasOwnProperty("hotelDateSelectionType"))
                                switch (message.hotelDateSelectionType) {
                                default:
                                    return "hotelDateSelectionType: enum value expected";
                                case 0:
                                case 1:
                                case 50:
                                case 51:
                                    break;
                                }
                            if (message.hotelLengthOfStay != null && message.hasOwnProperty("hotelLengthOfStay")) {
                                var error = $root.google.protobuf.Int32Value.verify(message.hotelLengthOfStay);
                                if (error)
                                    return "hotelLengthOfStay." + error;
                            }
                            if (message.hotelState != null && message.hasOwnProperty("hotelState")) {
                                var error = $root.google.protobuf.StringValue.verify(message.hotelState);
                                if (error)
                                    return "hotelState." + error;
                            }
                            if (message.hour != null && message.hasOwnProperty("hour")) {
                                var error = $root.google.protobuf.Int32Value.verify(message.hour);
                                if (error)
                                    return "hour." + error;
                            }
                            if (message.interactionOnThisExtension != null && message.hasOwnProperty("interactionOnThisExtension")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.interactionOnThisExtension);
                                if (error)
                                    return "interactionOnThisExtension." + error;
                            }
                            if (message.keyword != null && message.hasOwnProperty("keyword")) {
                                var error = $root.google.ads.googleads.v1.common.Keyword.verify(message.keyword);
                                if (error)
                                    return "keyword." + error;
                            }
                            if (message.month != null && message.hasOwnProperty("month")) {
                                var error = $root.google.protobuf.StringValue.verify(message.month);
                                if (error)
                                    return "month." + error;
                            }
                            if (message.monthOfYear != null && message.hasOwnProperty("monthOfYear"))
                                switch (message.monthOfYear) {
                                default:
                                    return "monthOfYear: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                    break;
                                }
                            if (message.partnerHotelId != null && message.hasOwnProperty("partnerHotelId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.partnerHotelId);
                                if (error)
                                    return "partnerHotelId." + error;
                            }
                            if (message.placeholderType != null && message.hasOwnProperty("placeholderType"))
                                switch (message.placeholderType) {
                                default:
                                    return "placeholderType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                    break;
                                }
                            if (message.productAggregatorId != null && message.hasOwnProperty("productAggregatorId")) {
                                var error = $root.google.protobuf.UInt64Value.verify(message.productAggregatorId);
                                if (error)
                                    return "productAggregatorId." + error;
                            }
                            if (message.productBiddingCategoryLevel1 != null && message.hasOwnProperty("productBiddingCategoryLevel1")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productBiddingCategoryLevel1);
                                if (error)
                                    return "productBiddingCategoryLevel1." + error;
                            }
                            if (message.productBiddingCategoryLevel2 != null && message.hasOwnProperty("productBiddingCategoryLevel2")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productBiddingCategoryLevel2);
                                if (error)
                                    return "productBiddingCategoryLevel2." + error;
                            }
                            if (message.productBiddingCategoryLevel3 != null && message.hasOwnProperty("productBiddingCategoryLevel3")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productBiddingCategoryLevel3);
                                if (error)
                                    return "productBiddingCategoryLevel3." + error;
                            }
                            if (message.productBiddingCategoryLevel4 != null && message.hasOwnProperty("productBiddingCategoryLevel4")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productBiddingCategoryLevel4);
                                if (error)
                                    return "productBiddingCategoryLevel4." + error;
                            }
                            if (message.productBiddingCategoryLevel5 != null && message.hasOwnProperty("productBiddingCategoryLevel5")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productBiddingCategoryLevel5);
                                if (error)
                                    return "productBiddingCategoryLevel5." + error;
                            }
                            if (message.productBrand != null && message.hasOwnProperty("productBrand")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productBrand);
                                if (error)
                                    return "productBrand." + error;
                            }
                            if (message.productChannel != null && message.hasOwnProperty("productChannel"))
                                switch (message.productChannel) {
                                default:
                                    return "productChannel: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.productChannelExclusivity != null && message.hasOwnProperty("productChannelExclusivity"))
                                switch (message.productChannelExclusivity) {
                                default:
                                    return "productChannelExclusivity: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.productCondition != null && message.hasOwnProperty("productCondition"))
                                switch (message.productCondition) {
                                default:
                                    return "productCondition: enum value expected";
                                case 0:
                                case 1:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            if (message.productCountry != null && message.hasOwnProperty("productCountry")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productCountry);
                                if (error)
                                    return "productCountry." + error;
                            }
                            if (message.productCustomAttribute0 != null && message.hasOwnProperty("productCustomAttribute0")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productCustomAttribute0);
                                if (error)
                                    return "productCustomAttribute0." + error;
                            }
                            if (message.productCustomAttribute1 != null && message.hasOwnProperty("productCustomAttribute1")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productCustomAttribute1);
                                if (error)
                                    return "productCustomAttribute1." + error;
                            }
                            if (message.productCustomAttribute2 != null && message.hasOwnProperty("productCustomAttribute2")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productCustomAttribute2);
                                if (error)
                                    return "productCustomAttribute2." + error;
                            }
                            if (message.productCustomAttribute3 != null && message.hasOwnProperty("productCustomAttribute3")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productCustomAttribute3);
                                if (error)
                                    return "productCustomAttribute3." + error;
                            }
                            if (message.productCustomAttribute4 != null && message.hasOwnProperty("productCustomAttribute4")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productCustomAttribute4);
                                if (error)
                                    return "productCustomAttribute4." + error;
                            }
                            if (message.productItemId != null && message.hasOwnProperty("productItemId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productItemId);
                                if (error)
                                    return "productItemId." + error;
                            }
                            if (message.productLanguage != null && message.hasOwnProperty("productLanguage")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productLanguage);
                                if (error)
                                    return "productLanguage." + error;
                            }
                            if (message.productMerchantId != null && message.hasOwnProperty("productMerchantId")) {
                                var error = $root.google.protobuf.UInt64Value.verify(message.productMerchantId);
                                if (error)
                                    return "productMerchantId." + error;
                            }
                            if (message.productStoreId != null && message.hasOwnProperty("productStoreId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productStoreId);
                                if (error)
                                    return "productStoreId." + error;
                            }
                            if (message.productTitle != null && message.hasOwnProperty("productTitle")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productTitle);
                                if (error)
                                    return "productTitle." + error;
                            }
                            if (message.productTypeL1 != null && message.hasOwnProperty("productTypeL1")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productTypeL1);
                                if (error)
                                    return "productTypeL1." + error;
                            }
                            if (message.productTypeL2 != null && message.hasOwnProperty("productTypeL2")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productTypeL2);
                                if (error)
                                    return "productTypeL2." + error;
                            }
                            if (message.productTypeL3 != null && message.hasOwnProperty("productTypeL3")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productTypeL3);
                                if (error)
                                    return "productTypeL3." + error;
                            }
                            if (message.productTypeL4 != null && message.hasOwnProperty("productTypeL4")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productTypeL4);
                                if (error)
                                    return "productTypeL4." + error;
                            }
                            if (message.productTypeL5 != null && message.hasOwnProperty("productTypeL5")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productTypeL5);
                                if (error)
                                    return "productTypeL5." + error;
                            }
                            if (message.quarter != null && message.hasOwnProperty("quarter")) {
                                var error = $root.google.protobuf.StringValue.verify(message.quarter);
                                if (error)
                                    return "quarter." + error;
                            }
                            if (message.searchEngineResultsPageType != null && message.hasOwnProperty("searchEngineResultsPageType"))
                                switch (message.searchEngineResultsPageType) {
                                default:
                                    return "searchEngineResultsPageType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.searchTermMatchType != null && message.hasOwnProperty("searchTermMatchType"))
                                switch (message.searchTermMatchType) {
                                default:
                                    return "searchTermMatchType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            if (message.slot != null && message.hasOwnProperty("slot"))
                                switch (message.slot) {
                                default:
                                    return "slot: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                    break;
                                }
                            if (message.webpage != null && message.hasOwnProperty("webpage")) {
                                var error = $root.google.protobuf.StringValue.verify(message.webpage);
                                if (error)
                                    return "webpage." + error;
                            }
                            if (message.week != null && message.hasOwnProperty("week")) {
                                var error = $root.google.protobuf.StringValue.verify(message.week);
                                if (error)
                                    return "week." + error;
                            }
                            if (message.year != null && message.hasOwnProperty("year")) {
                                var error = $root.google.protobuf.Int32Value.verify(message.year);
                                if (error)
                                    return "year." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a Segments message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.Segments} Segments
                         */
                        Segments.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.Segments)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.Segments();
                            switch (object.adNetworkType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.adNetworkType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.adNetworkType = 1;
                                break;
                            case "SEARCH":
                            case 2:
                                message.adNetworkType = 2;
                                break;
                            case "SEARCH_PARTNERS":
                            case 3:
                                message.adNetworkType = 3;
                                break;
                            case "CONTENT":
                            case 4:
                                message.adNetworkType = 4;
                                break;
                            case "YOUTUBE_SEARCH":
                            case 5:
                                message.adNetworkType = 5;
                                break;
                            case "YOUTUBE_WATCH":
                            case 6:
                                message.adNetworkType = 6;
                                break;
                            case "MIXED":
                            case 7:
                                message.adNetworkType = 7;
                                break;
                            }
                            switch (object.clickType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.clickType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.clickType = 1;
                                break;
                            case "APP_DEEPLINK":
                            case 2:
                                message.clickType = 2;
                                break;
                            case "BREADCRUMBS":
                            case 3:
                                message.clickType = 3;
                                break;
                            case "BROADBAND_PLAN":
                            case 4:
                                message.clickType = 4;
                                break;
                            case "CALL_TRACKING":
                            case 5:
                                message.clickType = 5;
                                break;
                            case "CALLS":
                            case 6:
                                message.clickType = 6;
                                break;
                            case "CLICK_ON_ENGAGEMENT_AD":
                            case 7:
                                message.clickType = 7;
                                break;
                            case "GET_DIRECTIONS":
                            case 8:
                                message.clickType = 8;
                                break;
                            case "LOCATION_EXPANSION":
                            case 9:
                                message.clickType = 9;
                                break;
                            case "LOCATION_FORMAT_CALL":
                            case 10:
                                message.clickType = 10;
                                break;
                            case "LOCATION_FORMAT_DIRECTIONS":
                            case 11:
                                message.clickType = 11;
                                break;
                            case "LOCATION_FORMAT_IMAGE":
                            case 12:
                                message.clickType = 12;
                                break;
                            case "LOCATION_FORMAT_LANDING_PAGE":
                            case 13:
                                message.clickType = 13;
                                break;
                            case "LOCATION_FORMAT_MAP":
                            case 14:
                                message.clickType = 14;
                                break;
                            case "LOCATION_FORMAT_STORE_INFO":
                            case 15:
                                message.clickType = 15;
                                break;
                            case "LOCATION_FORMAT_TEXT":
                            case 16:
                                message.clickType = 16;
                                break;
                            case "MOBILE_CALL_TRACKING":
                            case 17:
                                message.clickType = 17;
                                break;
                            case "OFFER_PRINTS":
                            case 18:
                                message.clickType = 18;
                                break;
                            case "OTHER":
                            case 19:
                                message.clickType = 19;
                                break;
                            case "PRODUCT_EXTENSION_CLICKS":
                            case 20:
                                message.clickType = 20;
                                break;
                            case "PRODUCT_LISTING_AD_CLICKS":
                            case 21:
                                message.clickType = 21;
                                break;
                            case "SITELINKS":
                            case 22:
                                message.clickType = 22;
                                break;
                            case "STORE_LOCATOR":
                            case 23:
                                message.clickType = 23;
                                break;
                            case "URL_CLICKS":
                            case 25:
                                message.clickType = 25;
                                break;
                            case "VIDEO_APP_STORE_CLICKS":
                            case 26:
                                message.clickType = 26;
                                break;
                            case "VIDEO_CALL_TO_ACTION_CLICKS":
                            case 27:
                                message.clickType = 27;
                                break;
                            case "VIDEO_CARD_ACTION_HEADLINE_CLICKS":
                            case 28:
                                message.clickType = 28;
                                break;
                            case "VIDEO_END_CAP_CLICKS":
                            case 29:
                                message.clickType = 29;
                                break;
                            case "VIDEO_WEBSITE_CLICKS":
                            case 30:
                                message.clickType = 30;
                                break;
                            case "VISUAL_SITELINKS":
                            case 31:
                                message.clickType = 31;
                                break;
                            case "WIRELESS_PLAN":
                            case 32:
                                message.clickType = 32;
                                break;
                            case "PRODUCT_LISTING_AD_LOCAL":
                            case 33:
                                message.clickType = 33;
                                break;
                            case "PRODUCT_LISTING_AD_MULTICHANNEL_LOCAL":
                            case 34:
                                message.clickType = 34;
                                break;
                            case "PRODUCT_LISTING_AD_MULTICHANNEL_ONLINE":
                            case 35:
                                message.clickType = 35;
                                break;
                            case "PRODUCT_LISTING_ADS_COUPON":
                            case 36:
                                message.clickType = 36;
                                break;
                            case "PRODUCT_LISTING_AD_TRANSACTABLE":
                            case 37:
                                message.clickType = 37;
                                break;
                            case "PRODUCT_AD_APP_DEEPLINK":
                            case 38:
                                message.clickType = 38;
                                break;
                            case "SHOWCASE_AD_CATEGORY_LINK":
                            case 39:
                                message.clickType = 39;
                                break;
                            case "SHOWCASE_AD_LOCAL_STOREFRONT_LINK":
                            case 40:
                                message.clickType = 40;
                                break;
                            case "SHOWCASE_AD_ONLINE_PRODUCT_LINK":
                            case 42:
                                message.clickType = 42;
                                break;
                            case "SHOWCASE_AD_LOCAL_PRODUCT_LINK":
                            case 43:
                                message.clickType = 43;
                                break;
                            case "PROMOTION_EXTENSION":
                            case 44:
                                message.clickType = 44;
                                break;
                            case "SWIPEABLE_GALLERY_AD_HEADLINE":
                            case 45:
                                message.clickType = 45;
                                break;
                            case "SWIPEABLE_GALLERY_AD_SWIPES":
                            case 46:
                                message.clickType = 46;
                                break;
                            case "SWIPEABLE_GALLERY_AD_SEE_MORE":
                            case 47:
                                message.clickType = 47;
                                break;
                            case "SWIPEABLE_GALLERY_AD_SITELINK_ONE":
                            case 48:
                                message.clickType = 48;
                                break;
                            case "SWIPEABLE_GALLERY_AD_SITELINK_TWO":
                            case 49:
                                message.clickType = 49;
                                break;
                            case "SWIPEABLE_GALLERY_AD_SITELINK_THREE":
                            case 50:
                                message.clickType = 50;
                                break;
                            case "SWIPEABLE_GALLERY_AD_SITELINK_FOUR":
                            case 51:
                                message.clickType = 51;
                                break;
                            case "SWIPEABLE_GALLERY_AD_SITELINK_FIVE":
                            case 52:
                                message.clickType = 52;
                                break;
                            case "HOTEL_PRICE":
                            case 53:
                                message.clickType = 53;
                                break;
                            case "PRICE_EXTENSION":
                            case 54:
                                message.clickType = 54;
                                break;
                            case "HOTEL_BOOK_ON_GOOGLE_ROOM_SELECTION":
                            case 55:
                                message.clickType = 55;
                                break;
                            }
                            if (object.conversionAction != null) {
                                if (typeof object.conversionAction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.conversionAction: object expected");
                                message.conversionAction = $root.google.protobuf.StringValue.fromObject(object.conversionAction);
                            }
                            switch (object.conversionActionCategory) {
                            case "UNSPECIFIED":
                            case 0:
                                message.conversionActionCategory = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.conversionActionCategory = 1;
                                break;
                            case "DEFAULT":
                            case 2:
                                message.conversionActionCategory = 2;
                                break;
                            case "PAGE_VIEW":
                            case 3:
                                message.conversionActionCategory = 3;
                                break;
                            case "PURCHASE":
                            case 4:
                                message.conversionActionCategory = 4;
                                break;
                            case "SIGNUP":
                            case 5:
                                message.conversionActionCategory = 5;
                                break;
                            case "LEAD":
                            case 6:
                                message.conversionActionCategory = 6;
                                break;
                            case "DOWNLOAD":
                            case 7:
                                message.conversionActionCategory = 7;
                                break;
                            }
                            if (object.conversionActionName != null) {
                                if (typeof object.conversionActionName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.conversionActionName: object expected");
                                message.conversionActionName = $root.google.protobuf.StringValue.fromObject(object.conversionActionName);
                            }
                            if (object.conversionAdjustment != null) {
                                if (typeof object.conversionAdjustment !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.conversionAdjustment: object expected");
                                message.conversionAdjustment = $root.google.protobuf.BoolValue.fromObject(object.conversionAdjustment);
                            }
                            switch (object.conversionAttributionEventType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.conversionAttributionEventType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.conversionAttributionEventType = 1;
                                break;
                            case "IMPRESSION":
                            case 2:
                                message.conversionAttributionEventType = 2;
                                break;
                            case "INTERACTION":
                            case 3:
                                message.conversionAttributionEventType = 3;
                                break;
                            }
                            switch (object.conversionLagBucket) {
                            case "UNSPECIFIED":
                            case 0:
                                message.conversionLagBucket = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.conversionLagBucket = 1;
                                break;
                            case "LESS_THAN_ONE_DAY":
                            case 2:
                                message.conversionLagBucket = 2;
                                break;
                            case "ONE_TO_TWO_DAYS":
                            case 3:
                                message.conversionLagBucket = 3;
                                break;
                            case "TWO_TO_THREE_DAYS":
                            case 4:
                                message.conversionLagBucket = 4;
                                break;
                            case "THREE_TO_FOUR_DAYS":
                            case 5:
                                message.conversionLagBucket = 5;
                                break;
                            case "FOUR_TO_FIVE_DAYS":
                            case 6:
                                message.conversionLagBucket = 6;
                                break;
                            case "FIVE_TO_SIX_DAYS":
                            case 7:
                                message.conversionLagBucket = 7;
                                break;
                            case "SIX_TO_SEVEN_DAYS":
                            case 8:
                                message.conversionLagBucket = 8;
                                break;
                            case "SEVEN_TO_EIGHT_DAYS":
                            case 9:
                                message.conversionLagBucket = 9;
                                break;
                            case "EIGHT_TO_NINE_DAYS":
                            case 10:
                                message.conversionLagBucket = 10;
                                break;
                            case "NINE_TO_TEN_DAYS":
                            case 11:
                                message.conversionLagBucket = 11;
                                break;
                            case "TEN_TO_ELEVEN_DAYS":
                            case 12:
                                message.conversionLagBucket = 12;
                                break;
                            case "ELEVEN_TO_TWELVE_DAYS":
                            case 13:
                                message.conversionLagBucket = 13;
                                break;
                            case "TWELVE_TO_THIRTEEN_DAYS":
                            case 14:
                                message.conversionLagBucket = 14;
                                break;
                            case "THIRTEEN_TO_FOURTEEN_DAYS":
                            case 15:
                                message.conversionLagBucket = 15;
                                break;
                            case "FOURTEEN_TO_TWENTY_ONE_DAYS":
                            case 16:
                                message.conversionLagBucket = 16;
                                break;
                            case "TWENTY_ONE_TO_THIRTY_DAYS":
                            case 17:
                                message.conversionLagBucket = 17;
                                break;
                            case "THIRTY_TO_FORTY_FIVE_DAYS":
                            case 18:
                                message.conversionLagBucket = 18;
                                break;
                            case "FORTY_FIVE_TO_SIXTY_DAYS":
                            case 19:
                                message.conversionLagBucket = 19;
                                break;
                            case "SIXTY_TO_NINETY_DAYS":
                            case 20:
                                message.conversionLagBucket = 20;
                                break;
                            }
                            switch (object.conversionOrAdjustmentLagBucket) {
                            case "UNSPECIFIED":
                            case 0:
                                message.conversionOrAdjustmentLagBucket = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.conversionOrAdjustmentLagBucket = 1;
                                break;
                            case "CONVERSION_LESS_THAN_ONE_DAY":
                            case 2:
                                message.conversionOrAdjustmentLagBucket = 2;
                                break;
                            case "CONVERSION_ONE_TO_TWO_DAYS":
                            case 3:
                                message.conversionOrAdjustmentLagBucket = 3;
                                break;
                            case "CONVERSION_TWO_TO_THREE_DAYS":
                            case 4:
                                message.conversionOrAdjustmentLagBucket = 4;
                                break;
                            case "CONVERSION_THREE_TO_FOUR_DAYS":
                            case 5:
                                message.conversionOrAdjustmentLagBucket = 5;
                                break;
                            case "CONVERSION_FOUR_TO_FIVE_DAYS":
                            case 6:
                                message.conversionOrAdjustmentLagBucket = 6;
                                break;
                            case "CONVERSION_FIVE_TO_SIX_DAYS":
                            case 7:
                                message.conversionOrAdjustmentLagBucket = 7;
                                break;
                            case "CONVERSION_SIX_TO_SEVEN_DAYS":
                            case 8:
                                message.conversionOrAdjustmentLagBucket = 8;
                                break;
                            case "CONVERSION_SEVEN_TO_EIGHT_DAYS":
                            case 9:
                                message.conversionOrAdjustmentLagBucket = 9;
                                break;
                            case "CONVERSION_EIGHT_TO_NINE_DAYS":
                            case 10:
                                message.conversionOrAdjustmentLagBucket = 10;
                                break;
                            case "CONVERSION_NINE_TO_TEN_DAYS":
                            case 11:
                                message.conversionOrAdjustmentLagBucket = 11;
                                break;
                            case "CONVERSION_TEN_TO_ELEVEN_DAYS":
                            case 12:
                                message.conversionOrAdjustmentLagBucket = 12;
                                break;
                            case "CONVERSION_ELEVEN_TO_TWELVE_DAYS":
                            case 13:
                                message.conversionOrAdjustmentLagBucket = 13;
                                break;
                            case "CONVERSION_TWELVE_TO_THIRTEEN_DAYS":
                            case 14:
                                message.conversionOrAdjustmentLagBucket = 14;
                                break;
                            case "CONVERSION_THIRTEEN_TO_FOURTEEN_DAYS":
                            case 15:
                                message.conversionOrAdjustmentLagBucket = 15;
                                break;
                            case "CONVERSION_FOURTEEN_TO_TWENTY_ONE_DAYS":
                            case 16:
                                message.conversionOrAdjustmentLagBucket = 16;
                                break;
                            case "CONVERSION_TWENTY_ONE_TO_THIRTY_DAYS":
                            case 17:
                                message.conversionOrAdjustmentLagBucket = 17;
                                break;
                            case "CONVERSION_THIRTY_TO_FORTY_FIVE_DAYS":
                            case 18:
                                message.conversionOrAdjustmentLagBucket = 18;
                                break;
                            case "CONVERSION_FORTY_FIVE_TO_SIXTY_DAYS":
                            case 19:
                                message.conversionOrAdjustmentLagBucket = 19;
                                break;
                            case "CONVERSION_SIXTY_TO_NINETY_DAYS":
                            case 20:
                                message.conversionOrAdjustmentLagBucket = 20;
                                break;
                            case "ADJUSTMENT_LESS_THAN_ONE_DAY":
                            case 21:
                                message.conversionOrAdjustmentLagBucket = 21;
                                break;
                            case "ADJUSTMENT_ONE_TO_TWO_DAYS":
                            case 22:
                                message.conversionOrAdjustmentLagBucket = 22;
                                break;
                            case "ADJUSTMENT_TWO_TO_THREE_DAYS":
                            case 23:
                                message.conversionOrAdjustmentLagBucket = 23;
                                break;
                            case "ADJUSTMENT_THREE_TO_FOUR_DAYS":
                            case 24:
                                message.conversionOrAdjustmentLagBucket = 24;
                                break;
                            case "ADJUSTMENT_FOUR_TO_FIVE_DAYS":
                            case 25:
                                message.conversionOrAdjustmentLagBucket = 25;
                                break;
                            case "ADJUSTMENT_FIVE_TO_SIX_DAYS":
                            case 26:
                                message.conversionOrAdjustmentLagBucket = 26;
                                break;
                            case "ADJUSTMENT_SIX_TO_SEVEN_DAYS":
                            case 27:
                                message.conversionOrAdjustmentLagBucket = 27;
                                break;
                            case "ADJUSTMENT_SEVEN_TO_EIGHT_DAYS":
                            case 28:
                                message.conversionOrAdjustmentLagBucket = 28;
                                break;
                            case "ADJUSTMENT_EIGHT_TO_NINE_DAYS":
                            case 29:
                                message.conversionOrAdjustmentLagBucket = 29;
                                break;
                            case "ADJUSTMENT_NINE_TO_TEN_DAYS":
                            case 30:
                                message.conversionOrAdjustmentLagBucket = 30;
                                break;
                            case "ADJUSTMENT_TEN_TO_ELEVEN_DAYS":
                            case 31:
                                message.conversionOrAdjustmentLagBucket = 31;
                                break;
                            case "ADJUSTMENT_ELEVEN_TO_TWELVE_DAYS":
                            case 32:
                                message.conversionOrAdjustmentLagBucket = 32;
                                break;
                            case "ADJUSTMENT_TWELVE_TO_THIRTEEN_DAYS":
                            case 33:
                                message.conversionOrAdjustmentLagBucket = 33;
                                break;
                            case "ADJUSTMENT_THIRTEEN_TO_FOURTEEN_DAYS":
                            case 34:
                                message.conversionOrAdjustmentLagBucket = 34;
                                break;
                            case "ADJUSTMENT_FOURTEEN_TO_TWENTY_ONE_DAYS":
                            case 35:
                                message.conversionOrAdjustmentLagBucket = 35;
                                break;
                            case "ADJUSTMENT_TWENTY_ONE_TO_THIRTY_DAYS":
                            case 36:
                                message.conversionOrAdjustmentLagBucket = 36;
                                break;
                            case "ADJUSTMENT_THIRTY_TO_FORTY_FIVE_DAYS":
                            case 37:
                                message.conversionOrAdjustmentLagBucket = 37;
                                break;
                            case "ADJUSTMENT_FORTY_FIVE_TO_SIXTY_DAYS":
                            case 38:
                                message.conversionOrAdjustmentLagBucket = 38;
                                break;
                            case "ADJUSTMENT_SIXTY_TO_NINETY_DAYS":
                            case 39:
                                message.conversionOrAdjustmentLagBucket = 39;
                                break;
                            case "ADJUSTMENT_NINETY_TO_ONE_HUNDRED_AND_FORTY_FIVE_DAYS":
                            case 40:
                                message.conversionOrAdjustmentLagBucket = 40;
                                break;
                            case "CONVERSION_UNKNOWN":
                            case 41:
                                message.conversionOrAdjustmentLagBucket = 41;
                                break;
                            case "ADJUSTMENT_UNKNOWN":
                            case 42:
                                message.conversionOrAdjustmentLagBucket = 42;
                                break;
                            }
                            if (object.date != null) {
                                if (typeof object.date !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.date: object expected");
                                message.date = $root.google.protobuf.StringValue.fromObject(object.date);
                            }
                            switch (object.dayOfWeek) {
                            case "UNSPECIFIED":
                            case 0:
                                message.dayOfWeek = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.dayOfWeek = 1;
                                break;
                            case "MONDAY":
                            case 2:
                                message.dayOfWeek = 2;
                                break;
                            case "TUESDAY":
                            case 3:
                                message.dayOfWeek = 3;
                                break;
                            case "WEDNESDAY":
                            case 4:
                                message.dayOfWeek = 4;
                                break;
                            case "THURSDAY":
                            case 5:
                                message.dayOfWeek = 5;
                                break;
                            case "FRIDAY":
                            case 6:
                                message.dayOfWeek = 6;
                                break;
                            case "SATURDAY":
                            case 7:
                                message.dayOfWeek = 7;
                                break;
                            case "SUNDAY":
                            case 8:
                                message.dayOfWeek = 8;
                                break;
                            }
                            switch (object.device) {
                            case "UNSPECIFIED":
                            case 0:
                                message.device = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.device = 1;
                                break;
                            case "MOBILE":
                            case 2:
                                message.device = 2;
                                break;
                            case "TABLET":
                            case 3:
                                message.device = 3;
                                break;
                            case "DESKTOP":
                            case 4:
                                message.device = 4;
                                break;
                            case "OTHER":
                            case 5:
                                message.device = 5;
                                break;
                            }
                            switch (object.externalConversionSource) {
                            case "UNSPECIFIED":
                            case 0:
                                message.externalConversionSource = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.externalConversionSource = 1;
                                break;
                            case "WEBPAGE":
                            case 2:
                                message.externalConversionSource = 2;
                                break;
                            case "ANALYTICS":
                            case 3:
                                message.externalConversionSource = 3;
                                break;
                            case "UPLOAD":
                            case 4:
                                message.externalConversionSource = 4;
                                break;
                            case "AD_CALL_METRICS":
                            case 5:
                                message.externalConversionSource = 5;
                                break;
                            case "WEBSITE_CALL_METRICS":
                            case 6:
                                message.externalConversionSource = 6;
                                break;
                            case "STORE_VISITS":
                            case 7:
                                message.externalConversionSource = 7;
                                break;
                            case "ANDROID_IN_APP":
                            case 8:
                                message.externalConversionSource = 8;
                                break;
                            case "IOS_IN_APP":
                            case 9:
                                message.externalConversionSource = 9;
                                break;
                            case "IOS_FIRST_OPEN":
                            case 10:
                                message.externalConversionSource = 10;
                                break;
                            case "APP_UNSPECIFIED":
                            case 11:
                                message.externalConversionSource = 11;
                                break;
                            case "ANDROID_FIRST_OPEN":
                            case 12:
                                message.externalConversionSource = 12;
                                break;
                            case "UPLOAD_CALLS":
                            case 13:
                                message.externalConversionSource = 13;
                                break;
                            case "FIREBASE":
                            case 14:
                                message.externalConversionSource = 14;
                                break;
                            case "CLICK_TO_CALL":
                            case 15:
                                message.externalConversionSource = 15;
                                break;
                            case "SALESFORCE":
                            case 16:
                                message.externalConversionSource = 16;
                                break;
                            case "STORE_SALES_CRM":
                            case 17:
                                message.externalConversionSource = 17;
                                break;
                            case "STORE_SALES_PAYMENT_NETWORK":
                            case 18:
                                message.externalConversionSource = 18;
                                break;
                            case "GOOGLE_PLAY":
                            case 19:
                                message.externalConversionSource = 19;
                                break;
                            case "THIRD_PARTY_APP_ANALYTICS":
                            case 20:
                                message.externalConversionSource = 20;
                                break;
                            case "GOOGLE_ATTRIBUTION":
                            case 21:
                                message.externalConversionSource = 21;
                                break;
                            case "STORE_SALES_DIRECT":
                            case 22:
                                message.externalConversionSource = 22;
                                break;
                            }
                            if (object.geoTargetAirport != null) {
                                if (typeof object.geoTargetAirport !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.geoTargetAirport: object expected");
                                message.geoTargetAirport = $root.google.protobuf.StringValue.fromObject(object.geoTargetAirport);
                            }
                            if (object.geoTargetCity != null) {
                                if (typeof object.geoTargetCity !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.geoTargetCity: object expected");
                                message.geoTargetCity = $root.google.protobuf.StringValue.fromObject(object.geoTargetCity);
                            }
                            if (object.geoTargetCounty != null) {
                                if (typeof object.geoTargetCounty !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.geoTargetCounty: object expected");
                                message.geoTargetCounty = $root.google.protobuf.StringValue.fromObject(object.geoTargetCounty);
                            }
                            if (object.geoTargetDistrict != null) {
                                if (typeof object.geoTargetDistrict !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.geoTargetDistrict: object expected");
                                message.geoTargetDistrict = $root.google.protobuf.StringValue.fromObject(object.geoTargetDistrict);
                            }
                            if (object.geoTargetMetro != null) {
                                if (typeof object.geoTargetMetro !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.geoTargetMetro: object expected");
                                message.geoTargetMetro = $root.google.protobuf.StringValue.fromObject(object.geoTargetMetro);
                            }
                            if (object.geoTargetMostSpecificLocation != null) {
                                if (typeof object.geoTargetMostSpecificLocation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.geoTargetMostSpecificLocation: object expected");
                                message.geoTargetMostSpecificLocation = $root.google.protobuf.StringValue.fromObject(object.geoTargetMostSpecificLocation);
                            }
                            if (object.geoTargetPostalCode != null) {
                                if (typeof object.geoTargetPostalCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.geoTargetPostalCode: object expected");
                                message.geoTargetPostalCode = $root.google.protobuf.StringValue.fromObject(object.geoTargetPostalCode);
                            }
                            if (object.geoTargetRegion != null) {
                                if (typeof object.geoTargetRegion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.geoTargetRegion: object expected");
                                message.geoTargetRegion = $root.google.protobuf.StringValue.fromObject(object.geoTargetRegion);
                            }
                            if (object.geoTargetState != null) {
                                if (typeof object.geoTargetState !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.geoTargetState: object expected");
                                message.geoTargetState = $root.google.protobuf.StringValue.fromObject(object.geoTargetState);
                            }
                            if (object.hotelBookingWindowDays != null) {
                                if (typeof object.hotelBookingWindowDays !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.hotelBookingWindowDays: object expected");
                                message.hotelBookingWindowDays = $root.google.protobuf.Int64Value.fromObject(object.hotelBookingWindowDays);
                            }
                            if (object.hotelCenterId != null) {
                                if (typeof object.hotelCenterId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.hotelCenterId: object expected");
                                message.hotelCenterId = $root.google.protobuf.Int64Value.fromObject(object.hotelCenterId);
                            }
                            if (object.hotelCheckInDate != null) {
                                if (typeof object.hotelCheckInDate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.hotelCheckInDate: object expected");
                                message.hotelCheckInDate = $root.google.protobuf.StringValue.fromObject(object.hotelCheckInDate);
                            }
                            switch (object.hotelCheckInDayOfWeek) {
                            case "UNSPECIFIED":
                            case 0:
                                message.hotelCheckInDayOfWeek = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.hotelCheckInDayOfWeek = 1;
                                break;
                            case "MONDAY":
                            case 2:
                                message.hotelCheckInDayOfWeek = 2;
                                break;
                            case "TUESDAY":
                            case 3:
                                message.hotelCheckInDayOfWeek = 3;
                                break;
                            case "WEDNESDAY":
                            case 4:
                                message.hotelCheckInDayOfWeek = 4;
                                break;
                            case "THURSDAY":
                            case 5:
                                message.hotelCheckInDayOfWeek = 5;
                                break;
                            case "FRIDAY":
                            case 6:
                                message.hotelCheckInDayOfWeek = 6;
                                break;
                            case "SATURDAY":
                            case 7:
                                message.hotelCheckInDayOfWeek = 7;
                                break;
                            case "SUNDAY":
                            case 8:
                                message.hotelCheckInDayOfWeek = 8;
                                break;
                            }
                            if (object.hotelCity != null) {
                                if (typeof object.hotelCity !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.hotelCity: object expected");
                                message.hotelCity = $root.google.protobuf.StringValue.fromObject(object.hotelCity);
                            }
                            if (object.hotelClass != null) {
                                if (typeof object.hotelClass !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.hotelClass: object expected");
                                message.hotelClass = $root.google.protobuf.Int32Value.fromObject(object.hotelClass);
                            }
                            if (object.hotelCountry != null) {
                                if (typeof object.hotelCountry !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.hotelCountry: object expected");
                                message.hotelCountry = $root.google.protobuf.StringValue.fromObject(object.hotelCountry);
                            }
                            switch (object.hotelDateSelectionType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.hotelDateSelectionType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.hotelDateSelectionType = 1;
                                break;
                            case "DEFAULT_SELECTION":
                            case 50:
                                message.hotelDateSelectionType = 50;
                                break;
                            case "USER_SELECTED":
                            case 51:
                                message.hotelDateSelectionType = 51;
                                break;
                            }
                            if (object.hotelLengthOfStay != null) {
                                if (typeof object.hotelLengthOfStay !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.hotelLengthOfStay: object expected");
                                message.hotelLengthOfStay = $root.google.protobuf.Int32Value.fromObject(object.hotelLengthOfStay);
                            }
                            if (object.hotelState != null) {
                                if (typeof object.hotelState !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.hotelState: object expected");
                                message.hotelState = $root.google.protobuf.StringValue.fromObject(object.hotelState);
                            }
                            if (object.hour != null) {
                                if (typeof object.hour !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.hour: object expected");
                                message.hour = $root.google.protobuf.Int32Value.fromObject(object.hour);
                            }
                            if (object.interactionOnThisExtension != null) {
                                if (typeof object.interactionOnThisExtension !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.interactionOnThisExtension: object expected");
                                message.interactionOnThisExtension = $root.google.protobuf.BoolValue.fromObject(object.interactionOnThisExtension);
                            }
                            if (object.keyword != null) {
                                if (typeof object.keyword !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.keyword: object expected");
                                message.keyword = $root.google.ads.googleads.v1.common.Keyword.fromObject(object.keyword);
                            }
                            if (object.month != null) {
                                if (typeof object.month !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.month: object expected");
                                message.month = $root.google.protobuf.StringValue.fromObject(object.month);
                            }
                            switch (object.monthOfYear) {
                            case "UNSPECIFIED":
                            case 0:
                                message.monthOfYear = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.monthOfYear = 1;
                                break;
                            case "JANUARY":
                            case 2:
                                message.monthOfYear = 2;
                                break;
                            case "FEBRUARY":
                            case 3:
                                message.monthOfYear = 3;
                                break;
                            case "MARCH":
                            case 4:
                                message.monthOfYear = 4;
                                break;
                            case "APRIL":
                            case 5:
                                message.monthOfYear = 5;
                                break;
                            case "MAY":
                            case 6:
                                message.monthOfYear = 6;
                                break;
                            case "JUNE":
                            case 7:
                                message.monthOfYear = 7;
                                break;
                            case "JULY":
                            case 8:
                                message.monthOfYear = 8;
                                break;
                            case "AUGUST":
                            case 9:
                                message.monthOfYear = 9;
                                break;
                            case "SEPTEMBER":
                            case 10:
                                message.monthOfYear = 10;
                                break;
                            case "OCTOBER":
                            case 11:
                                message.monthOfYear = 11;
                                break;
                            case "NOVEMBER":
                            case 12:
                                message.monthOfYear = 12;
                                break;
                            case "DECEMBER":
                            case 13:
                                message.monthOfYear = 13;
                                break;
                            }
                            if (object.partnerHotelId != null) {
                                if (typeof object.partnerHotelId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.partnerHotelId: object expected");
                                message.partnerHotelId = $root.google.protobuf.StringValue.fromObject(object.partnerHotelId);
                            }
                            switch (object.placeholderType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.placeholderType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.placeholderType = 1;
                                break;
                            case "SITELINK":
                            case 2:
                                message.placeholderType = 2;
                                break;
                            case "CALL":
                            case 3:
                                message.placeholderType = 3;
                                break;
                            case "APP":
                            case 4:
                                message.placeholderType = 4;
                                break;
                            case "LOCATION":
                            case 5:
                                message.placeholderType = 5;
                                break;
                            case "AFFILIATE_LOCATION":
                            case 6:
                                message.placeholderType = 6;
                                break;
                            case "CALLOUT":
                            case 7:
                                message.placeholderType = 7;
                                break;
                            case "STRUCTURED_SNIPPET":
                            case 8:
                                message.placeholderType = 8;
                                break;
                            case "MESSAGE":
                            case 9:
                                message.placeholderType = 9;
                                break;
                            case "PRICE":
                            case 10:
                                message.placeholderType = 10;
                                break;
                            case "PROMOTION":
                            case 11:
                                message.placeholderType = 11;
                                break;
                            case "AD_CUSTOMIZER":
                            case 12:
                                message.placeholderType = 12;
                                break;
                            case "DYNAMIC_EDUCATION":
                            case 13:
                                message.placeholderType = 13;
                                break;
                            case "DYNAMIC_FLIGHT":
                            case 14:
                                message.placeholderType = 14;
                                break;
                            case "DYNAMIC_CUSTOM":
                            case 15:
                                message.placeholderType = 15;
                                break;
                            case "DYNAMIC_HOTEL":
                            case 16:
                                message.placeholderType = 16;
                                break;
                            case "DYNAMIC_REAL_ESTATE":
                            case 17:
                                message.placeholderType = 17;
                                break;
                            case "DYNAMIC_TRAVEL":
                            case 18:
                                message.placeholderType = 18;
                                break;
                            case "DYNAMIC_LOCAL":
                            case 19:
                                message.placeholderType = 19;
                                break;
                            case "DYNAMIC_JOB":
                            case 20:
                                message.placeholderType = 20;
                                break;
                            }
                            if (object.productAggregatorId != null) {
                                if (typeof object.productAggregatorId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productAggregatorId: object expected");
                                message.productAggregatorId = $root.google.protobuf.UInt64Value.fromObject(object.productAggregatorId);
                            }
                            if (object.productBiddingCategoryLevel1 != null) {
                                if (typeof object.productBiddingCategoryLevel1 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productBiddingCategoryLevel1: object expected");
                                message.productBiddingCategoryLevel1 = $root.google.protobuf.StringValue.fromObject(object.productBiddingCategoryLevel1);
                            }
                            if (object.productBiddingCategoryLevel2 != null) {
                                if (typeof object.productBiddingCategoryLevel2 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productBiddingCategoryLevel2: object expected");
                                message.productBiddingCategoryLevel2 = $root.google.protobuf.StringValue.fromObject(object.productBiddingCategoryLevel2);
                            }
                            if (object.productBiddingCategoryLevel3 != null) {
                                if (typeof object.productBiddingCategoryLevel3 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productBiddingCategoryLevel3: object expected");
                                message.productBiddingCategoryLevel3 = $root.google.protobuf.StringValue.fromObject(object.productBiddingCategoryLevel3);
                            }
                            if (object.productBiddingCategoryLevel4 != null) {
                                if (typeof object.productBiddingCategoryLevel4 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productBiddingCategoryLevel4: object expected");
                                message.productBiddingCategoryLevel4 = $root.google.protobuf.StringValue.fromObject(object.productBiddingCategoryLevel4);
                            }
                            if (object.productBiddingCategoryLevel5 != null) {
                                if (typeof object.productBiddingCategoryLevel5 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productBiddingCategoryLevel5: object expected");
                                message.productBiddingCategoryLevel5 = $root.google.protobuf.StringValue.fromObject(object.productBiddingCategoryLevel5);
                            }
                            if (object.productBrand != null) {
                                if (typeof object.productBrand !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productBrand: object expected");
                                message.productBrand = $root.google.protobuf.StringValue.fromObject(object.productBrand);
                            }
                            switch (object.productChannel) {
                            case "UNSPECIFIED":
                            case 0:
                                message.productChannel = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.productChannel = 1;
                                break;
                            case "ONLINE":
                            case 2:
                                message.productChannel = 2;
                                break;
                            case "LOCAL":
                            case 3:
                                message.productChannel = 3;
                                break;
                            }
                            switch (object.productChannelExclusivity) {
                            case "UNSPECIFIED":
                            case 0:
                                message.productChannelExclusivity = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.productChannelExclusivity = 1;
                                break;
                            case "SINGLE_CHANNEL":
                            case 2:
                                message.productChannelExclusivity = 2;
                                break;
                            case "MULTI_CHANNEL":
                            case 3:
                                message.productChannelExclusivity = 3;
                                break;
                            }
                            switch (object.productCondition) {
                            case "UNSPECIFIED":
                            case 0:
                                message.productCondition = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.productCondition = 1;
                                break;
                            case "NEW":
                            case 3:
                                message.productCondition = 3;
                                break;
                            case "REFURBISHED":
                            case 4:
                                message.productCondition = 4;
                                break;
                            case "USED":
                            case 5:
                                message.productCondition = 5;
                                break;
                            }
                            if (object.productCountry != null) {
                                if (typeof object.productCountry !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productCountry: object expected");
                                message.productCountry = $root.google.protobuf.StringValue.fromObject(object.productCountry);
                            }
                            if (object.productCustomAttribute0 != null) {
                                if (typeof object.productCustomAttribute0 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productCustomAttribute0: object expected");
                                message.productCustomAttribute0 = $root.google.protobuf.StringValue.fromObject(object.productCustomAttribute0);
                            }
                            if (object.productCustomAttribute1 != null) {
                                if (typeof object.productCustomAttribute1 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productCustomAttribute1: object expected");
                                message.productCustomAttribute1 = $root.google.protobuf.StringValue.fromObject(object.productCustomAttribute1);
                            }
                            if (object.productCustomAttribute2 != null) {
                                if (typeof object.productCustomAttribute2 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productCustomAttribute2: object expected");
                                message.productCustomAttribute2 = $root.google.protobuf.StringValue.fromObject(object.productCustomAttribute2);
                            }
                            if (object.productCustomAttribute3 != null) {
                                if (typeof object.productCustomAttribute3 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productCustomAttribute3: object expected");
                                message.productCustomAttribute3 = $root.google.protobuf.StringValue.fromObject(object.productCustomAttribute3);
                            }
                            if (object.productCustomAttribute4 != null) {
                                if (typeof object.productCustomAttribute4 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productCustomAttribute4: object expected");
                                message.productCustomAttribute4 = $root.google.protobuf.StringValue.fromObject(object.productCustomAttribute4);
                            }
                            if (object.productItemId != null) {
                                if (typeof object.productItemId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productItemId: object expected");
                                message.productItemId = $root.google.protobuf.StringValue.fromObject(object.productItemId);
                            }
                            if (object.productLanguage != null) {
                                if (typeof object.productLanguage !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productLanguage: object expected");
                                message.productLanguage = $root.google.protobuf.StringValue.fromObject(object.productLanguage);
                            }
                            if (object.productMerchantId != null) {
                                if (typeof object.productMerchantId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productMerchantId: object expected");
                                message.productMerchantId = $root.google.protobuf.UInt64Value.fromObject(object.productMerchantId);
                            }
                            if (object.productStoreId != null) {
                                if (typeof object.productStoreId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productStoreId: object expected");
                                message.productStoreId = $root.google.protobuf.StringValue.fromObject(object.productStoreId);
                            }
                            if (object.productTitle != null) {
                                if (typeof object.productTitle !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productTitle: object expected");
                                message.productTitle = $root.google.protobuf.StringValue.fromObject(object.productTitle);
                            }
                            if (object.productTypeL1 != null) {
                                if (typeof object.productTypeL1 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productTypeL1: object expected");
                                message.productTypeL1 = $root.google.protobuf.StringValue.fromObject(object.productTypeL1);
                            }
                            if (object.productTypeL2 != null) {
                                if (typeof object.productTypeL2 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productTypeL2: object expected");
                                message.productTypeL2 = $root.google.protobuf.StringValue.fromObject(object.productTypeL2);
                            }
                            if (object.productTypeL3 != null) {
                                if (typeof object.productTypeL3 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productTypeL3: object expected");
                                message.productTypeL3 = $root.google.protobuf.StringValue.fromObject(object.productTypeL3);
                            }
                            if (object.productTypeL4 != null) {
                                if (typeof object.productTypeL4 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productTypeL4: object expected");
                                message.productTypeL4 = $root.google.protobuf.StringValue.fromObject(object.productTypeL4);
                            }
                            if (object.productTypeL5 != null) {
                                if (typeof object.productTypeL5 !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.productTypeL5: object expected");
                                message.productTypeL5 = $root.google.protobuf.StringValue.fromObject(object.productTypeL5);
                            }
                            if (object.quarter != null) {
                                if (typeof object.quarter !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.quarter: object expected");
                                message.quarter = $root.google.protobuf.StringValue.fromObject(object.quarter);
                            }
                            switch (object.searchEngineResultsPageType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.searchEngineResultsPageType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.searchEngineResultsPageType = 1;
                                break;
                            case "ADS_ONLY":
                            case 2:
                                message.searchEngineResultsPageType = 2;
                                break;
                            case "ORGANIC_ONLY":
                            case 3:
                                message.searchEngineResultsPageType = 3;
                                break;
                            case "ADS_AND_ORGANIC":
                            case 4:
                                message.searchEngineResultsPageType = 4;
                                break;
                            }
                            switch (object.searchTermMatchType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.searchTermMatchType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.searchTermMatchType = 1;
                                break;
                            case "BROAD":
                            case 2:
                                message.searchTermMatchType = 2;
                                break;
                            case "EXACT":
                            case 3:
                                message.searchTermMatchType = 3;
                                break;
                            case "PHRASE":
                            case 4:
                                message.searchTermMatchType = 4;
                                break;
                            case "NEAR_EXACT":
                            case 5:
                                message.searchTermMatchType = 5;
                                break;
                            case "NEAR_PHRASE":
                            case 6:
                                message.searchTermMatchType = 6;
                                break;
                            }
                            switch (object.slot) {
                            case "UNSPECIFIED":
                            case 0:
                                message.slot = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.slot = 1;
                                break;
                            case "SEARCH_SIDE":
                            case 2:
                                message.slot = 2;
                                break;
                            case "SEARCH_TOP":
                            case 3:
                                message.slot = 3;
                                break;
                            case "SEARCH_OTHER":
                            case 4:
                                message.slot = 4;
                                break;
                            case "CONTENT":
                            case 5:
                                message.slot = 5;
                                break;
                            case "SEARCH_PARTNER_TOP":
                            case 6:
                                message.slot = 6;
                                break;
                            case "SEARCH_PARTNER_OTHER":
                            case 7:
                                message.slot = 7;
                                break;
                            case "MIXED":
                            case 8:
                                message.slot = 8;
                                break;
                            }
                            if (object.webpage != null) {
                                if (typeof object.webpage !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.webpage: object expected");
                                message.webpage = $root.google.protobuf.StringValue.fromObject(object.webpage);
                            }
                            if (object.week != null) {
                                if (typeof object.week !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.week: object expected");
                                message.week = $root.google.protobuf.StringValue.fromObject(object.week);
                            }
                            if (object.year != null) {
                                if (typeof object.year !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Segments.year: object expected");
                                message.year = $root.google.protobuf.Int32Value.fromObject(object.year);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a Segments message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @static
                         * @param {google.ads.googleads.v1.common.Segments} message Segments
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Segments.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.device = options.enums === String ? "UNSPECIFIED" : 0;
                                object.conversionAttributionEventType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.adNetworkType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.date = null;
                                object.dayOfWeek = options.enums === String ? "UNSPECIFIED" : 0;
                                object.hotelBookingWindowDays = null;
                                object.hotelCenterId = null;
                                object.hotelCheckInDate = null;
                                object.hotelCheckInDayOfWeek = options.enums === String ? "UNSPECIFIED" : 0;
                                object.hotelCity = null;
                                object.hotelClass = null;
                                object.hotelCountry = null;
                                object.hotelDateSelectionType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.hotelLengthOfStay = null;
                                object.hotelState = null;
                                object.hour = null;
                                object.month = null;
                                object.monthOfYear = options.enums === String ? "UNSPECIFIED" : 0;
                                object.partnerHotelId = null;
                                object.placeholderType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.quarter = null;
                                object.searchTermMatchType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.slot = options.enums === String ? "UNSPECIFIED" : 0;
                                object.week = null;
                                object.year = null;
                                object.clickType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.conversionAdjustment = null;
                                object.productAggregatorId = null;
                                object.productBrand = null;
                                object.productChannel = options.enums === String ? "UNSPECIFIED" : 0;
                                object.productChannelExclusivity = options.enums === String ? "UNSPECIFIED" : 0;
                                object.productCondition = options.enums === String ? "UNSPECIFIED" : 0;
                                object.productCountry = null;
                                object.productCustomAttribute0 = null;
                                object.productCustomAttribute1 = null;
                                object.productCustomAttribute2 = null;
                                object.productCustomAttribute3 = null;
                                object.productCustomAttribute4 = null;
                                object.productItemId = null;
                                object.productLanguage = null;
                                object.productMerchantId = null;
                                object.productStoreId = null;
                                object.productTitle = null;
                                object.productTypeL1 = null;
                                object.productTypeL2 = null;
                                object.productTypeL3 = null;
                                object.productTypeL4 = null;
                                object.productTypeL5 = null;
                                object.interactionOnThisExtension = null;
                                object.conversionLagBucket = options.enums === String ? "UNSPECIFIED" : 0;
                                object.conversionOrAdjustmentLagBucket = options.enums === String ? "UNSPECIFIED" : 0;
                                object.conversionAction = null;
                                object.conversionActionCategory = options.enums === String ? "UNSPECIFIED" : 0;
                                object.conversionActionName = null;
                                object.externalConversionSource = options.enums === String ? "UNSPECIFIED" : 0;
                                object.productBiddingCategoryLevel1 = null;
                                object.productBiddingCategoryLevel2 = null;
                                object.productBiddingCategoryLevel3 = null;
                                object.productBiddingCategoryLevel4 = null;
                                object.productBiddingCategoryLevel5 = null;
                                object.keyword = null;
                                object.geoTargetCity = null;
                                object.geoTargetMetro = null;
                                object.geoTargetRegion = null;
                                object.geoTargetAirport = null;
                                object.webpage = null;
                                object.geoTargetState = null;
                                object.geoTargetCounty = null;
                                object.geoTargetDistrict = null;
                                object.searchEngineResultsPageType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.geoTargetPostalCode = null;
                                object.geoTargetMostSpecificLocation = null;
                            }
                            if (message.device != null && message.hasOwnProperty("device"))
                                object.device = options.enums === String ? $root.google.ads.googleads.v1.enums.DeviceEnum.Device[message.device] : message.device;
                            if (message.conversionAttributionEventType != null && message.hasOwnProperty("conversionAttributionEventType"))
                                object.conversionAttributionEventType = options.enums === String ? $root.google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum.ConversionAttributionEventType[message.conversionAttributionEventType] : message.conversionAttributionEventType;
                            if (message.adNetworkType != null && message.hasOwnProperty("adNetworkType"))
                                object.adNetworkType = options.enums === String ? $root.google.ads.googleads.v1.enums.AdNetworkTypeEnum.AdNetworkType[message.adNetworkType] : message.adNetworkType;
                            if (message.date != null && message.hasOwnProperty("date"))
                                object.date = $root.google.protobuf.StringValue.toObject(message.date, options);
                            if (message.dayOfWeek != null && message.hasOwnProperty("dayOfWeek"))
                                object.dayOfWeek = options.enums === String ? $root.google.ads.googleads.v1.enums.DayOfWeekEnum.DayOfWeek[message.dayOfWeek] : message.dayOfWeek;
                            if (message.hotelBookingWindowDays != null && message.hasOwnProperty("hotelBookingWindowDays"))
                                object.hotelBookingWindowDays = $root.google.protobuf.Int64Value.toObject(message.hotelBookingWindowDays, options);
                            if (message.hotelCenterId != null && message.hasOwnProperty("hotelCenterId"))
                                object.hotelCenterId = $root.google.protobuf.Int64Value.toObject(message.hotelCenterId, options);
                            if (message.hotelCheckInDate != null && message.hasOwnProperty("hotelCheckInDate"))
                                object.hotelCheckInDate = $root.google.protobuf.StringValue.toObject(message.hotelCheckInDate, options);
                            if (message.hotelCheckInDayOfWeek != null && message.hasOwnProperty("hotelCheckInDayOfWeek"))
                                object.hotelCheckInDayOfWeek = options.enums === String ? $root.google.ads.googleads.v1.enums.DayOfWeekEnum.DayOfWeek[message.hotelCheckInDayOfWeek] : message.hotelCheckInDayOfWeek;
                            if (message.hotelCity != null && message.hasOwnProperty("hotelCity"))
                                object.hotelCity = $root.google.protobuf.StringValue.toObject(message.hotelCity, options);
                            if (message.hotelClass != null && message.hasOwnProperty("hotelClass"))
                                object.hotelClass = $root.google.protobuf.Int32Value.toObject(message.hotelClass, options);
                            if (message.hotelCountry != null && message.hasOwnProperty("hotelCountry"))
                                object.hotelCountry = $root.google.protobuf.StringValue.toObject(message.hotelCountry, options);
                            if (message.hotelDateSelectionType != null && message.hasOwnProperty("hotelDateSelectionType"))
                                object.hotelDateSelectionType = options.enums === String ? $root.google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum.HotelDateSelectionType[message.hotelDateSelectionType] : message.hotelDateSelectionType;
                            if (message.hotelLengthOfStay != null && message.hasOwnProperty("hotelLengthOfStay"))
                                object.hotelLengthOfStay = $root.google.protobuf.Int32Value.toObject(message.hotelLengthOfStay, options);
                            if (message.hotelState != null && message.hasOwnProperty("hotelState"))
                                object.hotelState = $root.google.protobuf.StringValue.toObject(message.hotelState, options);
                            if (message.hour != null && message.hasOwnProperty("hour"))
                                object.hour = $root.google.protobuf.Int32Value.toObject(message.hour, options);
                            if (message.month != null && message.hasOwnProperty("month"))
                                object.month = $root.google.protobuf.StringValue.toObject(message.month, options);
                            if (message.monthOfYear != null && message.hasOwnProperty("monthOfYear"))
                                object.monthOfYear = options.enums === String ? $root.google.ads.googleads.v1.enums.MonthOfYearEnum.MonthOfYear[message.monthOfYear] : message.monthOfYear;
                            if (message.partnerHotelId != null && message.hasOwnProperty("partnerHotelId"))
                                object.partnerHotelId = $root.google.protobuf.StringValue.toObject(message.partnerHotelId, options);
                            if (message.placeholderType != null && message.hasOwnProperty("placeholderType"))
                                object.placeholderType = options.enums === String ? $root.google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType[message.placeholderType] : message.placeholderType;
                            if (message.quarter != null && message.hasOwnProperty("quarter"))
                                object.quarter = $root.google.protobuf.StringValue.toObject(message.quarter, options);
                            if (message.searchTermMatchType != null && message.hasOwnProperty("searchTermMatchType"))
                                object.searchTermMatchType = options.enums === String ? $root.google.ads.googleads.v1.enums.SearchTermMatchTypeEnum.SearchTermMatchType[message.searchTermMatchType] : message.searchTermMatchType;
                            if (message.slot != null && message.hasOwnProperty("slot"))
                                object.slot = options.enums === String ? $root.google.ads.googleads.v1.enums.SlotEnum.Slot[message.slot] : message.slot;
                            if (message.week != null && message.hasOwnProperty("week"))
                                object.week = $root.google.protobuf.StringValue.toObject(message.week, options);
                            if (message.year != null && message.hasOwnProperty("year"))
                                object.year = $root.google.protobuf.Int32Value.toObject(message.year, options);
                            if (message.clickType != null && message.hasOwnProperty("clickType"))
                                object.clickType = options.enums === String ? $root.google.ads.googleads.v1.enums.ClickTypeEnum.ClickType[message.clickType] : message.clickType;
                            if (message.conversionAdjustment != null && message.hasOwnProperty("conversionAdjustment"))
                                object.conversionAdjustment = $root.google.protobuf.BoolValue.toObject(message.conversionAdjustment, options);
                            if (message.productAggregatorId != null && message.hasOwnProperty("productAggregatorId"))
                                object.productAggregatorId = $root.google.protobuf.UInt64Value.toObject(message.productAggregatorId, options);
                            if (message.productBrand != null && message.hasOwnProperty("productBrand"))
                                object.productBrand = $root.google.protobuf.StringValue.toObject(message.productBrand, options);
                            if (message.productChannel != null && message.hasOwnProperty("productChannel"))
                                object.productChannel = options.enums === String ? $root.google.ads.googleads.v1.enums.ProductChannelEnum.ProductChannel[message.productChannel] : message.productChannel;
                            if (message.productChannelExclusivity != null && message.hasOwnProperty("productChannelExclusivity"))
                                object.productChannelExclusivity = options.enums === String ? $root.google.ads.googleads.v1.enums.ProductChannelExclusivityEnum.ProductChannelExclusivity[message.productChannelExclusivity] : message.productChannelExclusivity;
                            if (message.productCondition != null && message.hasOwnProperty("productCondition"))
                                object.productCondition = options.enums === String ? $root.google.ads.googleads.v1.enums.ProductConditionEnum.ProductCondition[message.productCondition] : message.productCondition;
                            if (message.productCountry != null && message.hasOwnProperty("productCountry"))
                                object.productCountry = $root.google.protobuf.StringValue.toObject(message.productCountry, options);
                            if (message.productCustomAttribute0 != null && message.hasOwnProperty("productCustomAttribute0"))
                                object.productCustomAttribute0 = $root.google.protobuf.StringValue.toObject(message.productCustomAttribute0, options);
                            if (message.productCustomAttribute1 != null && message.hasOwnProperty("productCustomAttribute1"))
                                object.productCustomAttribute1 = $root.google.protobuf.StringValue.toObject(message.productCustomAttribute1, options);
                            if (message.productCustomAttribute2 != null && message.hasOwnProperty("productCustomAttribute2"))
                                object.productCustomAttribute2 = $root.google.protobuf.StringValue.toObject(message.productCustomAttribute2, options);
                            if (message.productCustomAttribute3 != null && message.hasOwnProperty("productCustomAttribute3"))
                                object.productCustomAttribute3 = $root.google.protobuf.StringValue.toObject(message.productCustomAttribute3, options);
                            if (message.productCustomAttribute4 != null && message.hasOwnProperty("productCustomAttribute4"))
                                object.productCustomAttribute4 = $root.google.protobuf.StringValue.toObject(message.productCustomAttribute4, options);
                            if (message.productItemId != null && message.hasOwnProperty("productItemId"))
                                object.productItemId = $root.google.protobuf.StringValue.toObject(message.productItemId, options);
                            if (message.productLanguage != null && message.hasOwnProperty("productLanguage"))
                                object.productLanguage = $root.google.protobuf.StringValue.toObject(message.productLanguage, options);
                            if (message.productMerchantId != null && message.hasOwnProperty("productMerchantId"))
                                object.productMerchantId = $root.google.protobuf.UInt64Value.toObject(message.productMerchantId, options);
                            if (message.productStoreId != null && message.hasOwnProperty("productStoreId"))
                                object.productStoreId = $root.google.protobuf.StringValue.toObject(message.productStoreId, options);
                            if (message.productTitle != null && message.hasOwnProperty("productTitle"))
                                object.productTitle = $root.google.protobuf.StringValue.toObject(message.productTitle, options);
                            if (message.productTypeL1 != null && message.hasOwnProperty("productTypeL1"))
                                object.productTypeL1 = $root.google.protobuf.StringValue.toObject(message.productTypeL1, options);
                            if (message.productTypeL2 != null && message.hasOwnProperty("productTypeL2"))
                                object.productTypeL2 = $root.google.protobuf.StringValue.toObject(message.productTypeL2, options);
                            if (message.productTypeL3 != null && message.hasOwnProperty("productTypeL3"))
                                object.productTypeL3 = $root.google.protobuf.StringValue.toObject(message.productTypeL3, options);
                            if (message.productTypeL4 != null && message.hasOwnProperty("productTypeL4"))
                                object.productTypeL4 = $root.google.protobuf.StringValue.toObject(message.productTypeL4, options);
                            if (message.productTypeL5 != null && message.hasOwnProperty("productTypeL5"))
                                object.productTypeL5 = $root.google.protobuf.StringValue.toObject(message.productTypeL5, options);
                            if (message.interactionOnThisExtension != null && message.hasOwnProperty("interactionOnThisExtension"))
                                object.interactionOnThisExtension = $root.google.protobuf.BoolValue.toObject(message.interactionOnThisExtension, options);
                            if (message.conversionLagBucket != null && message.hasOwnProperty("conversionLagBucket"))
                                object.conversionLagBucket = options.enums === String ? $root.google.ads.googleads.v1.enums.ConversionLagBucketEnum.ConversionLagBucket[message.conversionLagBucket] : message.conversionLagBucket;
                            if (message.conversionOrAdjustmentLagBucket != null && message.hasOwnProperty("conversionOrAdjustmentLagBucket"))
                                object.conversionOrAdjustmentLagBucket = options.enums === String ? $root.google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum.ConversionOrAdjustmentLagBucket[message.conversionOrAdjustmentLagBucket] : message.conversionOrAdjustmentLagBucket;
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                object.conversionAction = $root.google.protobuf.StringValue.toObject(message.conversionAction, options);
                            if (message.conversionActionCategory != null && message.hasOwnProperty("conversionActionCategory"))
                                object.conversionActionCategory = options.enums === String ? $root.google.ads.googleads.v1.enums.ConversionActionCategoryEnum.ConversionActionCategory[message.conversionActionCategory] : message.conversionActionCategory;
                            if (message.conversionActionName != null && message.hasOwnProperty("conversionActionName"))
                                object.conversionActionName = $root.google.protobuf.StringValue.toObject(message.conversionActionName, options);
                            if (message.externalConversionSource != null && message.hasOwnProperty("externalConversionSource"))
                                object.externalConversionSource = options.enums === String ? $root.google.ads.googleads.v1.enums.ExternalConversionSourceEnum.ExternalConversionSource[message.externalConversionSource] : message.externalConversionSource;
                            if (message.productBiddingCategoryLevel1 != null && message.hasOwnProperty("productBiddingCategoryLevel1"))
                                object.productBiddingCategoryLevel1 = $root.google.protobuf.StringValue.toObject(message.productBiddingCategoryLevel1, options);
                            if (message.productBiddingCategoryLevel2 != null && message.hasOwnProperty("productBiddingCategoryLevel2"))
                                object.productBiddingCategoryLevel2 = $root.google.protobuf.StringValue.toObject(message.productBiddingCategoryLevel2, options);
                            if (message.productBiddingCategoryLevel3 != null && message.hasOwnProperty("productBiddingCategoryLevel3"))
                                object.productBiddingCategoryLevel3 = $root.google.protobuf.StringValue.toObject(message.productBiddingCategoryLevel3, options);
                            if (message.productBiddingCategoryLevel4 != null && message.hasOwnProperty("productBiddingCategoryLevel4"))
                                object.productBiddingCategoryLevel4 = $root.google.protobuf.StringValue.toObject(message.productBiddingCategoryLevel4, options);
                            if (message.productBiddingCategoryLevel5 != null && message.hasOwnProperty("productBiddingCategoryLevel5"))
                                object.productBiddingCategoryLevel5 = $root.google.protobuf.StringValue.toObject(message.productBiddingCategoryLevel5, options);
                            if (message.keyword != null && message.hasOwnProperty("keyword"))
                                object.keyword = $root.google.ads.googleads.v1.common.Keyword.toObject(message.keyword, options);
                            if (message.geoTargetCity != null && message.hasOwnProperty("geoTargetCity"))
                                object.geoTargetCity = $root.google.protobuf.StringValue.toObject(message.geoTargetCity, options);
                            if (message.geoTargetMetro != null && message.hasOwnProperty("geoTargetMetro"))
                                object.geoTargetMetro = $root.google.protobuf.StringValue.toObject(message.geoTargetMetro, options);
                            if (message.geoTargetRegion != null && message.hasOwnProperty("geoTargetRegion"))
                                object.geoTargetRegion = $root.google.protobuf.StringValue.toObject(message.geoTargetRegion, options);
                            if (message.geoTargetAirport != null && message.hasOwnProperty("geoTargetAirport"))
                                object.geoTargetAirport = $root.google.protobuf.StringValue.toObject(message.geoTargetAirport, options);
                            if (message.webpage != null && message.hasOwnProperty("webpage"))
                                object.webpage = $root.google.protobuf.StringValue.toObject(message.webpage, options);
                            if (message.geoTargetState != null && message.hasOwnProperty("geoTargetState"))
                                object.geoTargetState = $root.google.protobuf.StringValue.toObject(message.geoTargetState, options);
                            if (message.geoTargetCounty != null && message.hasOwnProperty("geoTargetCounty"))
                                object.geoTargetCounty = $root.google.protobuf.StringValue.toObject(message.geoTargetCounty, options);
                            if (message.geoTargetDistrict != null && message.hasOwnProperty("geoTargetDistrict"))
                                object.geoTargetDistrict = $root.google.protobuf.StringValue.toObject(message.geoTargetDistrict, options);
                            if (message.searchEngineResultsPageType != null && message.hasOwnProperty("searchEngineResultsPageType"))
                                object.searchEngineResultsPageType = options.enums === String ? $root.google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum.SearchEngineResultsPageType[message.searchEngineResultsPageType] : message.searchEngineResultsPageType;
                            if (message.geoTargetPostalCode != null && message.hasOwnProperty("geoTargetPostalCode"))
                                object.geoTargetPostalCode = $root.google.protobuf.StringValue.toObject(message.geoTargetPostalCode, options);
                            if (message.geoTargetMostSpecificLocation != null && message.hasOwnProperty("geoTargetMostSpecificLocation"))
                                object.geoTargetMostSpecificLocation = $root.google.protobuf.StringValue.toObject(message.geoTargetMostSpecificLocation, options);
                            return object;
                        };

                        /**
                         * Converts this Segments to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.Segments
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Segments.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return Segments;
                    })();

                    common.Keyword = (function() {

                        /**
                         * Properties of a Keyword.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IKeyword
                         * @property {google.protobuf.IStringValue|null} [adGroupCriterion] Keyword adGroupCriterion
                         * @property {google.ads.googleads.v1.common.IKeywordInfo|null} [info] Keyword info
                         */

                        /**
                         * Constructs a new Keyword.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a Keyword.
                         * @implements IKeyword
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IKeyword=} [properties] Properties to set
                         */
                        function Keyword(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Keyword adGroupCriterion.
                         * @member {google.protobuf.IStringValue|null|undefined} adGroupCriterion
                         * @memberof google.ads.googleads.v1.common.Keyword
                         * @instance
                         */
                        Keyword.prototype.adGroupCriterion = null;

                        /**
                         * Keyword info.
                         * @member {google.ads.googleads.v1.common.IKeywordInfo|null|undefined} info
                         * @memberof google.ads.googleads.v1.common.Keyword
                         * @instance
                         */
                        Keyword.prototype.info = null;

                        /**
                         * Creates a new Keyword instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.Keyword
                         * @static
                         * @param {google.ads.googleads.v1.common.IKeyword=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.Keyword} Keyword instance
                         */
                        Keyword.create = function create(properties) {
                            return new Keyword(properties);
                        };

                        /**
                         * Encodes the specified Keyword message. Does not implicitly {@link google.ads.googleads.v1.common.Keyword.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.Keyword
                         * @static
                         * @param {google.ads.googleads.v1.common.IKeyword} message Keyword message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Keyword.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.adGroupCriterion != null && message.hasOwnProperty("adGroupCriterion"))
                                $root.google.protobuf.StringValue.encode(message.adGroupCriterion, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.info != null && message.hasOwnProperty("info"))
                                $root.google.ads.googleads.v1.common.KeywordInfo.encode(message.info, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified Keyword message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.Keyword.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.Keyword
                         * @static
                         * @param {google.ads.googleads.v1.common.IKeyword} message Keyword message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Keyword.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a Keyword message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.Keyword
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.Keyword} Keyword
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Keyword.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.Keyword();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.adGroupCriterion = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.info = $root.google.ads.googleads.v1.common.KeywordInfo.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a Keyword message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.Keyword
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.Keyword} Keyword
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Keyword.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a Keyword message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.Keyword
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Keyword.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.adGroupCriterion != null && message.hasOwnProperty("adGroupCriterion")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adGroupCriterion);
                                if (error)
                                    return "adGroupCriterion." + error;
                            }
                            if (message.info != null && message.hasOwnProperty("info")) {
                                var error = $root.google.ads.googleads.v1.common.KeywordInfo.verify(message.info);
                                if (error)
                                    return "info." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a Keyword message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.Keyword
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.Keyword} Keyword
                         */
                        Keyword.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.Keyword)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.Keyword();
                            if (object.adGroupCriterion != null) {
                                if (typeof object.adGroupCriterion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Keyword.adGroupCriterion: object expected");
                                message.adGroupCriterion = $root.google.protobuf.StringValue.fromObject(object.adGroupCriterion);
                            }
                            if (object.info != null) {
                                if (typeof object.info !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.Keyword.info: object expected");
                                message.info = $root.google.ads.googleads.v1.common.KeywordInfo.fromObject(object.info);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a Keyword message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.Keyword
                         * @static
                         * @param {google.ads.googleads.v1.common.Keyword} message Keyword
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Keyword.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.adGroupCriterion = null;
                                object.info = null;
                            }
                            if (message.adGroupCriterion != null && message.hasOwnProperty("adGroupCriterion"))
                                object.adGroupCriterion = $root.google.protobuf.StringValue.toObject(message.adGroupCriterion, options);
                            if (message.info != null && message.hasOwnProperty("info"))
                                object.info = $root.google.ads.googleads.v1.common.KeywordInfo.toObject(message.info, options);
                            return object;
                        };

                        /**
                         * Converts this Keyword to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.Keyword
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Keyword.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return Keyword;
                    })();

                    common.BidModifierSimulationPointList = (function() {

                        /**
                         * Properties of a BidModifierSimulationPointList.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IBidModifierSimulationPointList
                         * @property {Array.<google.ads.googleads.v1.common.IBidModifierSimulationPoint>|null} [points] BidModifierSimulationPointList points
                         */

                        /**
                         * Constructs a new BidModifierSimulationPointList.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a BidModifierSimulationPointList.
                         * @implements IBidModifierSimulationPointList
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IBidModifierSimulationPointList=} [properties] Properties to set
                         */
                        function BidModifierSimulationPointList(properties) {
                            this.points = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * BidModifierSimulationPointList points.
                         * @member {Array.<google.ads.googleads.v1.common.IBidModifierSimulationPoint>} points
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPointList
                         * @instance
                         */
                        BidModifierSimulationPointList.prototype.points = $util.emptyArray;

                        /**
                         * Creates a new BidModifierSimulationPointList instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPointList
                         * @static
                         * @param {google.ads.googleads.v1.common.IBidModifierSimulationPointList=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.BidModifierSimulationPointList} BidModifierSimulationPointList instance
                         */
                        BidModifierSimulationPointList.create = function create(properties) {
                            return new BidModifierSimulationPointList(properties);
                        };

                        /**
                         * Encodes the specified BidModifierSimulationPointList message. Does not implicitly {@link google.ads.googleads.v1.common.BidModifierSimulationPointList.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPointList
                         * @static
                         * @param {google.ads.googleads.v1.common.IBidModifierSimulationPointList} message BidModifierSimulationPointList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BidModifierSimulationPointList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.points != null && message.points.length)
                                for (var i = 0; i < message.points.length; ++i)
                                    $root.google.ads.googleads.v1.common.BidModifierSimulationPoint.encode(message.points[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified BidModifierSimulationPointList message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.BidModifierSimulationPointList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPointList
                         * @static
                         * @param {google.ads.googleads.v1.common.IBidModifierSimulationPointList} message BidModifierSimulationPointList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BidModifierSimulationPointList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BidModifierSimulationPointList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPointList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.BidModifierSimulationPointList} BidModifierSimulationPointList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BidModifierSimulationPointList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.BidModifierSimulationPointList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.points && message.points.length))
                                        message.points = [];
                                    message.points.push($root.google.ads.googleads.v1.common.BidModifierSimulationPoint.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BidModifierSimulationPointList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPointList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.BidModifierSimulationPointList} BidModifierSimulationPointList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BidModifierSimulationPointList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BidModifierSimulationPointList message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPointList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BidModifierSimulationPointList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.points != null && message.hasOwnProperty("points")) {
                                if (!Array.isArray(message.points))
                                    return "points: array expected";
                                for (var i = 0; i < message.points.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.BidModifierSimulationPoint.verify(message.points[i]);
                                    if (error)
                                        return "points." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a BidModifierSimulationPointList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPointList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.BidModifierSimulationPointList} BidModifierSimulationPointList
                         */
                        BidModifierSimulationPointList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.BidModifierSimulationPointList)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.BidModifierSimulationPointList();
                            if (object.points) {
                                if (!Array.isArray(object.points))
                                    throw TypeError(".google.ads.googleads.v1.common.BidModifierSimulationPointList.points: array expected");
                                message.points = [];
                                for (var i = 0; i < object.points.length; ++i) {
                                    if (typeof object.points[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.BidModifierSimulationPointList.points: object expected");
                                    message.points[i] = $root.google.ads.googleads.v1.common.BidModifierSimulationPoint.fromObject(object.points[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a BidModifierSimulationPointList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPointList
                         * @static
                         * @param {google.ads.googleads.v1.common.BidModifierSimulationPointList} message BidModifierSimulationPointList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BidModifierSimulationPointList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.points = [];
                            if (message.points && message.points.length) {
                                object.points = [];
                                for (var j = 0; j < message.points.length; ++j)
                                    object.points[j] = $root.google.ads.googleads.v1.common.BidModifierSimulationPoint.toObject(message.points[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this BidModifierSimulationPointList to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPointList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BidModifierSimulationPointList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return BidModifierSimulationPointList;
                    })();

                    common.CpcBidSimulationPointList = (function() {

                        /**
                         * Properties of a CpcBidSimulationPointList.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ICpcBidSimulationPointList
                         * @property {Array.<google.ads.googleads.v1.common.ICpcBidSimulationPoint>|null} [points] CpcBidSimulationPointList points
                         */

                        /**
                         * Constructs a new CpcBidSimulationPointList.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a CpcBidSimulationPointList.
                         * @implements ICpcBidSimulationPointList
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ICpcBidSimulationPointList=} [properties] Properties to set
                         */
                        function CpcBidSimulationPointList(properties) {
                            this.points = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CpcBidSimulationPointList points.
                         * @member {Array.<google.ads.googleads.v1.common.ICpcBidSimulationPoint>} points
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPointList
                         * @instance
                         */
                        CpcBidSimulationPointList.prototype.points = $util.emptyArray;

                        /**
                         * Creates a new CpcBidSimulationPointList instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPointList
                         * @static
                         * @param {google.ads.googleads.v1.common.ICpcBidSimulationPointList=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.CpcBidSimulationPointList} CpcBidSimulationPointList instance
                         */
                        CpcBidSimulationPointList.create = function create(properties) {
                            return new CpcBidSimulationPointList(properties);
                        };

                        /**
                         * Encodes the specified CpcBidSimulationPointList message. Does not implicitly {@link google.ads.googleads.v1.common.CpcBidSimulationPointList.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPointList
                         * @static
                         * @param {google.ads.googleads.v1.common.ICpcBidSimulationPointList} message CpcBidSimulationPointList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CpcBidSimulationPointList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.points != null && message.points.length)
                                for (var i = 0; i < message.points.length; ++i)
                                    $root.google.ads.googleads.v1.common.CpcBidSimulationPoint.encode(message.points[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CpcBidSimulationPointList message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.CpcBidSimulationPointList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPointList
                         * @static
                         * @param {google.ads.googleads.v1.common.ICpcBidSimulationPointList} message CpcBidSimulationPointList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CpcBidSimulationPointList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CpcBidSimulationPointList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPointList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.CpcBidSimulationPointList} CpcBidSimulationPointList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CpcBidSimulationPointList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.CpcBidSimulationPointList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.points && message.points.length))
                                        message.points = [];
                                    message.points.push($root.google.ads.googleads.v1.common.CpcBidSimulationPoint.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CpcBidSimulationPointList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPointList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.CpcBidSimulationPointList} CpcBidSimulationPointList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CpcBidSimulationPointList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CpcBidSimulationPointList message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPointList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CpcBidSimulationPointList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.points != null && message.hasOwnProperty("points")) {
                                if (!Array.isArray(message.points))
                                    return "points: array expected";
                                for (var i = 0; i < message.points.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.CpcBidSimulationPoint.verify(message.points[i]);
                                    if (error)
                                        return "points." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a CpcBidSimulationPointList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPointList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.CpcBidSimulationPointList} CpcBidSimulationPointList
                         */
                        CpcBidSimulationPointList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.CpcBidSimulationPointList)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.CpcBidSimulationPointList();
                            if (object.points) {
                                if (!Array.isArray(object.points))
                                    throw TypeError(".google.ads.googleads.v1.common.CpcBidSimulationPointList.points: array expected");
                                message.points = [];
                                for (var i = 0; i < object.points.length; ++i) {
                                    if (typeof object.points[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.CpcBidSimulationPointList.points: object expected");
                                    message.points[i] = $root.google.ads.googleads.v1.common.CpcBidSimulationPoint.fromObject(object.points[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CpcBidSimulationPointList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPointList
                         * @static
                         * @param {google.ads.googleads.v1.common.CpcBidSimulationPointList} message CpcBidSimulationPointList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CpcBidSimulationPointList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.points = [];
                            if (message.points && message.points.length) {
                                object.points = [];
                                for (var j = 0; j < message.points.length; ++j)
                                    object.points[j] = $root.google.ads.googleads.v1.common.CpcBidSimulationPoint.toObject(message.points[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this CpcBidSimulationPointList to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPointList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CpcBidSimulationPointList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CpcBidSimulationPointList;
                    })();

                    common.TargetCpaSimulationPointList = (function() {

                        /**
                         * Properties of a TargetCpaSimulationPointList.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ITargetCpaSimulationPointList
                         * @property {Array.<google.ads.googleads.v1.common.ITargetCpaSimulationPoint>|null} [points] TargetCpaSimulationPointList points
                         */

                        /**
                         * Constructs a new TargetCpaSimulationPointList.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a TargetCpaSimulationPointList.
                         * @implements ITargetCpaSimulationPointList
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ITargetCpaSimulationPointList=} [properties] Properties to set
                         */
                        function TargetCpaSimulationPointList(properties) {
                            this.points = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * TargetCpaSimulationPointList points.
                         * @member {Array.<google.ads.googleads.v1.common.ITargetCpaSimulationPoint>} points
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPointList
                         * @instance
                         */
                        TargetCpaSimulationPointList.prototype.points = $util.emptyArray;

                        /**
                         * Creates a new TargetCpaSimulationPointList instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPointList
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetCpaSimulationPointList=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.TargetCpaSimulationPointList} TargetCpaSimulationPointList instance
                         */
                        TargetCpaSimulationPointList.create = function create(properties) {
                            return new TargetCpaSimulationPointList(properties);
                        };

                        /**
                         * Encodes the specified TargetCpaSimulationPointList message. Does not implicitly {@link google.ads.googleads.v1.common.TargetCpaSimulationPointList.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPointList
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetCpaSimulationPointList} message TargetCpaSimulationPointList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetCpaSimulationPointList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.points != null && message.points.length)
                                for (var i = 0; i < message.points.length; ++i)
                                    $root.google.ads.googleads.v1.common.TargetCpaSimulationPoint.encode(message.points[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified TargetCpaSimulationPointList message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.TargetCpaSimulationPointList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPointList
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetCpaSimulationPointList} message TargetCpaSimulationPointList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetCpaSimulationPointList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TargetCpaSimulationPointList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPointList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.TargetCpaSimulationPointList} TargetCpaSimulationPointList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetCpaSimulationPointList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.TargetCpaSimulationPointList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.points && message.points.length))
                                        message.points = [];
                                    message.points.push($root.google.ads.googleads.v1.common.TargetCpaSimulationPoint.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TargetCpaSimulationPointList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPointList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.TargetCpaSimulationPointList} TargetCpaSimulationPointList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetCpaSimulationPointList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TargetCpaSimulationPointList message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPointList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetCpaSimulationPointList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.points != null && message.hasOwnProperty("points")) {
                                if (!Array.isArray(message.points))
                                    return "points: array expected";
                                for (var i = 0; i < message.points.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.TargetCpaSimulationPoint.verify(message.points[i]);
                                    if (error)
                                        return "points." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a TargetCpaSimulationPointList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPointList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.TargetCpaSimulationPointList} TargetCpaSimulationPointList
                         */
                        TargetCpaSimulationPointList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.TargetCpaSimulationPointList)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.TargetCpaSimulationPointList();
                            if (object.points) {
                                if (!Array.isArray(object.points))
                                    throw TypeError(".google.ads.googleads.v1.common.TargetCpaSimulationPointList.points: array expected");
                                message.points = [];
                                for (var i = 0; i < object.points.length; ++i) {
                                    if (typeof object.points[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.TargetCpaSimulationPointList.points: object expected");
                                    message.points[i] = $root.google.ads.googleads.v1.common.TargetCpaSimulationPoint.fromObject(object.points[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a TargetCpaSimulationPointList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPointList
                         * @static
                         * @param {google.ads.googleads.v1.common.TargetCpaSimulationPointList} message TargetCpaSimulationPointList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetCpaSimulationPointList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.points = [];
                            if (message.points && message.points.length) {
                                object.points = [];
                                for (var j = 0; j < message.points.length; ++j)
                                    object.points[j] = $root.google.ads.googleads.v1.common.TargetCpaSimulationPoint.toObject(message.points[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this TargetCpaSimulationPointList to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPointList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetCpaSimulationPointList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return TargetCpaSimulationPointList;
                    })();

                    common.BidModifierSimulationPoint = (function() {

                        /**
                         * Properties of a BidModifierSimulationPoint.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IBidModifierSimulationPoint
                         * @property {google.protobuf.IDoubleValue|null} [bidModifier] BidModifierSimulationPoint bidModifier
                         * @property {google.protobuf.IDoubleValue|null} [biddableConversions] BidModifierSimulationPoint biddableConversions
                         * @property {google.protobuf.IDoubleValue|null} [biddableConversionsValue] BidModifierSimulationPoint biddableConversionsValue
                         * @property {google.protobuf.IInt64Value|null} [clicks] BidModifierSimulationPoint clicks
                         * @property {google.protobuf.IInt64Value|null} [costMicros] BidModifierSimulationPoint costMicros
                         * @property {google.protobuf.IInt64Value|null} [impressions] BidModifierSimulationPoint impressions
                         * @property {google.protobuf.IInt64Value|null} [topSlotImpressions] BidModifierSimulationPoint topSlotImpressions
                         */

                        /**
                         * Constructs a new BidModifierSimulationPoint.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a BidModifierSimulationPoint.
                         * @implements IBidModifierSimulationPoint
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IBidModifierSimulationPoint=} [properties] Properties to set
                         */
                        function BidModifierSimulationPoint(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * BidModifierSimulationPoint bidModifier.
                         * @member {google.protobuf.IDoubleValue|null|undefined} bidModifier
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPoint
                         * @instance
                         */
                        BidModifierSimulationPoint.prototype.bidModifier = null;

                        /**
                         * BidModifierSimulationPoint biddableConversions.
                         * @member {google.protobuf.IDoubleValue|null|undefined} biddableConversions
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPoint
                         * @instance
                         */
                        BidModifierSimulationPoint.prototype.biddableConversions = null;

                        /**
                         * BidModifierSimulationPoint biddableConversionsValue.
                         * @member {google.protobuf.IDoubleValue|null|undefined} biddableConversionsValue
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPoint
                         * @instance
                         */
                        BidModifierSimulationPoint.prototype.biddableConversionsValue = null;

                        /**
                         * BidModifierSimulationPoint clicks.
                         * @member {google.protobuf.IInt64Value|null|undefined} clicks
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPoint
                         * @instance
                         */
                        BidModifierSimulationPoint.prototype.clicks = null;

                        /**
                         * BidModifierSimulationPoint costMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} costMicros
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPoint
                         * @instance
                         */
                        BidModifierSimulationPoint.prototype.costMicros = null;

                        /**
                         * BidModifierSimulationPoint impressions.
                         * @member {google.protobuf.IInt64Value|null|undefined} impressions
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPoint
                         * @instance
                         */
                        BidModifierSimulationPoint.prototype.impressions = null;

                        /**
                         * BidModifierSimulationPoint topSlotImpressions.
                         * @member {google.protobuf.IInt64Value|null|undefined} topSlotImpressions
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPoint
                         * @instance
                         */
                        BidModifierSimulationPoint.prototype.topSlotImpressions = null;

                        /**
                         * Creates a new BidModifierSimulationPoint instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPoint
                         * @static
                         * @param {google.ads.googleads.v1.common.IBidModifierSimulationPoint=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.BidModifierSimulationPoint} BidModifierSimulationPoint instance
                         */
                        BidModifierSimulationPoint.create = function create(properties) {
                            return new BidModifierSimulationPoint(properties);
                        };

                        /**
                         * Encodes the specified BidModifierSimulationPoint message. Does not implicitly {@link google.ads.googleads.v1.common.BidModifierSimulationPoint.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPoint
                         * @static
                         * @param {google.ads.googleads.v1.common.IBidModifierSimulationPoint} message BidModifierSimulationPoint message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BidModifierSimulationPoint.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.bidModifier != null && message.hasOwnProperty("bidModifier"))
                                $root.google.protobuf.DoubleValue.encode(message.bidModifier, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.biddableConversions != null && message.hasOwnProperty("biddableConversions"))
                                $root.google.protobuf.DoubleValue.encode(message.biddableConversions, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.biddableConversionsValue != null && message.hasOwnProperty("biddableConversionsValue"))
                                $root.google.protobuf.DoubleValue.encode(message.biddableConversionsValue, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.clicks != null && message.hasOwnProperty("clicks"))
                                $root.google.protobuf.Int64Value.encode(message.clicks, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.costMicros != null && message.hasOwnProperty("costMicros"))
                                $root.google.protobuf.Int64Value.encode(message.costMicros, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.impressions != null && message.hasOwnProperty("impressions"))
                                $root.google.protobuf.Int64Value.encode(message.impressions, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.topSlotImpressions != null && message.hasOwnProperty("topSlotImpressions"))
                                $root.google.protobuf.Int64Value.encode(message.topSlotImpressions, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified BidModifierSimulationPoint message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.BidModifierSimulationPoint.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPoint
                         * @static
                         * @param {google.ads.googleads.v1.common.IBidModifierSimulationPoint} message BidModifierSimulationPoint message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BidModifierSimulationPoint.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BidModifierSimulationPoint message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPoint
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.BidModifierSimulationPoint} BidModifierSimulationPoint
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BidModifierSimulationPoint.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.BidModifierSimulationPoint();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.bidModifier = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.biddableConversions = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.biddableConversionsValue = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.clicks = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.costMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.impressions = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.topSlotImpressions = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BidModifierSimulationPoint message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPoint
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.BidModifierSimulationPoint} BidModifierSimulationPoint
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BidModifierSimulationPoint.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BidModifierSimulationPoint message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPoint
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BidModifierSimulationPoint.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.bidModifier != null && message.hasOwnProperty("bidModifier")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.bidModifier);
                                if (error)
                                    return "bidModifier." + error;
                            }
                            if (message.biddableConversions != null && message.hasOwnProperty("biddableConversions")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.biddableConversions);
                                if (error)
                                    return "biddableConversions." + error;
                            }
                            if (message.biddableConversionsValue != null && message.hasOwnProperty("biddableConversionsValue")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.biddableConversionsValue);
                                if (error)
                                    return "biddableConversionsValue." + error;
                            }
                            if (message.clicks != null && message.hasOwnProperty("clicks")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.clicks);
                                if (error)
                                    return "clicks." + error;
                            }
                            if (message.costMicros != null && message.hasOwnProperty("costMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.costMicros);
                                if (error)
                                    return "costMicros." + error;
                            }
                            if (message.impressions != null && message.hasOwnProperty("impressions")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.impressions);
                                if (error)
                                    return "impressions." + error;
                            }
                            if (message.topSlotImpressions != null && message.hasOwnProperty("topSlotImpressions")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.topSlotImpressions);
                                if (error)
                                    return "topSlotImpressions." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a BidModifierSimulationPoint message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPoint
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.BidModifierSimulationPoint} BidModifierSimulationPoint
                         */
                        BidModifierSimulationPoint.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.BidModifierSimulationPoint)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.BidModifierSimulationPoint();
                            if (object.bidModifier != null) {
                                if (typeof object.bidModifier !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.BidModifierSimulationPoint.bidModifier: object expected");
                                message.bidModifier = $root.google.protobuf.DoubleValue.fromObject(object.bidModifier);
                            }
                            if (object.biddableConversions != null) {
                                if (typeof object.biddableConversions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.BidModifierSimulationPoint.biddableConversions: object expected");
                                message.biddableConversions = $root.google.protobuf.DoubleValue.fromObject(object.biddableConversions);
                            }
                            if (object.biddableConversionsValue != null) {
                                if (typeof object.biddableConversionsValue !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.BidModifierSimulationPoint.biddableConversionsValue: object expected");
                                message.biddableConversionsValue = $root.google.protobuf.DoubleValue.fromObject(object.biddableConversionsValue);
                            }
                            if (object.clicks != null) {
                                if (typeof object.clicks !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.BidModifierSimulationPoint.clicks: object expected");
                                message.clicks = $root.google.protobuf.Int64Value.fromObject(object.clicks);
                            }
                            if (object.costMicros != null) {
                                if (typeof object.costMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.BidModifierSimulationPoint.costMicros: object expected");
                                message.costMicros = $root.google.protobuf.Int64Value.fromObject(object.costMicros);
                            }
                            if (object.impressions != null) {
                                if (typeof object.impressions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.BidModifierSimulationPoint.impressions: object expected");
                                message.impressions = $root.google.protobuf.Int64Value.fromObject(object.impressions);
                            }
                            if (object.topSlotImpressions != null) {
                                if (typeof object.topSlotImpressions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.BidModifierSimulationPoint.topSlotImpressions: object expected");
                                message.topSlotImpressions = $root.google.protobuf.Int64Value.fromObject(object.topSlotImpressions);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a BidModifierSimulationPoint message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPoint
                         * @static
                         * @param {google.ads.googleads.v1.common.BidModifierSimulationPoint} message BidModifierSimulationPoint
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BidModifierSimulationPoint.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.bidModifier = null;
                                object.biddableConversions = null;
                                object.biddableConversionsValue = null;
                                object.clicks = null;
                                object.costMicros = null;
                                object.impressions = null;
                                object.topSlotImpressions = null;
                            }
                            if (message.bidModifier != null && message.hasOwnProperty("bidModifier"))
                                object.bidModifier = $root.google.protobuf.DoubleValue.toObject(message.bidModifier, options);
                            if (message.biddableConversions != null && message.hasOwnProperty("biddableConversions"))
                                object.biddableConversions = $root.google.protobuf.DoubleValue.toObject(message.biddableConversions, options);
                            if (message.biddableConversionsValue != null && message.hasOwnProperty("biddableConversionsValue"))
                                object.biddableConversionsValue = $root.google.protobuf.DoubleValue.toObject(message.biddableConversionsValue, options);
                            if (message.clicks != null && message.hasOwnProperty("clicks"))
                                object.clicks = $root.google.protobuf.Int64Value.toObject(message.clicks, options);
                            if (message.costMicros != null && message.hasOwnProperty("costMicros"))
                                object.costMicros = $root.google.protobuf.Int64Value.toObject(message.costMicros, options);
                            if (message.impressions != null && message.hasOwnProperty("impressions"))
                                object.impressions = $root.google.protobuf.Int64Value.toObject(message.impressions, options);
                            if (message.topSlotImpressions != null && message.hasOwnProperty("topSlotImpressions"))
                                object.topSlotImpressions = $root.google.protobuf.Int64Value.toObject(message.topSlotImpressions, options);
                            return object;
                        };

                        /**
                         * Converts this BidModifierSimulationPoint to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.BidModifierSimulationPoint
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BidModifierSimulationPoint.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return BidModifierSimulationPoint;
                    })();

                    common.CpcBidSimulationPoint = (function() {

                        /**
                         * Properties of a CpcBidSimulationPoint.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ICpcBidSimulationPoint
                         * @property {google.protobuf.IInt64Value|null} [cpcBidMicros] CpcBidSimulationPoint cpcBidMicros
                         * @property {google.protobuf.IDoubleValue|null} [biddableConversions] CpcBidSimulationPoint biddableConversions
                         * @property {google.protobuf.IDoubleValue|null} [biddableConversionsValue] CpcBidSimulationPoint biddableConversionsValue
                         * @property {google.protobuf.IInt64Value|null} [clicks] CpcBidSimulationPoint clicks
                         * @property {google.protobuf.IInt64Value|null} [costMicros] CpcBidSimulationPoint costMicros
                         * @property {google.protobuf.IInt64Value|null} [impressions] CpcBidSimulationPoint impressions
                         * @property {google.protobuf.IInt64Value|null} [topSlotImpressions] CpcBidSimulationPoint topSlotImpressions
                         */

                        /**
                         * Constructs a new CpcBidSimulationPoint.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a CpcBidSimulationPoint.
                         * @implements ICpcBidSimulationPoint
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ICpcBidSimulationPoint=} [properties] Properties to set
                         */
                        function CpcBidSimulationPoint(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CpcBidSimulationPoint cpcBidMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpcBidMicros
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPoint
                         * @instance
                         */
                        CpcBidSimulationPoint.prototype.cpcBidMicros = null;

                        /**
                         * CpcBidSimulationPoint biddableConversions.
                         * @member {google.protobuf.IDoubleValue|null|undefined} biddableConversions
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPoint
                         * @instance
                         */
                        CpcBidSimulationPoint.prototype.biddableConversions = null;

                        /**
                         * CpcBidSimulationPoint biddableConversionsValue.
                         * @member {google.protobuf.IDoubleValue|null|undefined} biddableConversionsValue
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPoint
                         * @instance
                         */
                        CpcBidSimulationPoint.prototype.biddableConversionsValue = null;

                        /**
                         * CpcBidSimulationPoint clicks.
                         * @member {google.protobuf.IInt64Value|null|undefined} clicks
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPoint
                         * @instance
                         */
                        CpcBidSimulationPoint.prototype.clicks = null;

                        /**
                         * CpcBidSimulationPoint costMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} costMicros
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPoint
                         * @instance
                         */
                        CpcBidSimulationPoint.prototype.costMicros = null;

                        /**
                         * CpcBidSimulationPoint impressions.
                         * @member {google.protobuf.IInt64Value|null|undefined} impressions
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPoint
                         * @instance
                         */
                        CpcBidSimulationPoint.prototype.impressions = null;

                        /**
                         * CpcBidSimulationPoint topSlotImpressions.
                         * @member {google.protobuf.IInt64Value|null|undefined} topSlotImpressions
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPoint
                         * @instance
                         */
                        CpcBidSimulationPoint.prototype.topSlotImpressions = null;

                        /**
                         * Creates a new CpcBidSimulationPoint instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPoint
                         * @static
                         * @param {google.ads.googleads.v1.common.ICpcBidSimulationPoint=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.CpcBidSimulationPoint} CpcBidSimulationPoint instance
                         */
                        CpcBidSimulationPoint.create = function create(properties) {
                            return new CpcBidSimulationPoint(properties);
                        };

                        /**
                         * Encodes the specified CpcBidSimulationPoint message. Does not implicitly {@link google.ads.googleads.v1.common.CpcBidSimulationPoint.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPoint
                         * @static
                         * @param {google.ads.googleads.v1.common.ICpcBidSimulationPoint} message CpcBidSimulationPoint message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CpcBidSimulationPoint.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpcBidMicros, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.biddableConversions != null && message.hasOwnProperty("biddableConversions"))
                                $root.google.protobuf.DoubleValue.encode(message.biddableConversions, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.biddableConversionsValue != null && message.hasOwnProperty("biddableConversionsValue"))
                                $root.google.protobuf.DoubleValue.encode(message.biddableConversionsValue, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.clicks != null && message.hasOwnProperty("clicks"))
                                $root.google.protobuf.Int64Value.encode(message.clicks, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.costMicros != null && message.hasOwnProperty("costMicros"))
                                $root.google.protobuf.Int64Value.encode(message.costMicros, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.impressions != null && message.hasOwnProperty("impressions"))
                                $root.google.protobuf.Int64Value.encode(message.impressions, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.topSlotImpressions != null && message.hasOwnProperty("topSlotImpressions"))
                                $root.google.protobuf.Int64Value.encode(message.topSlotImpressions, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CpcBidSimulationPoint message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.CpcBidSimulationPoint.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPoint
                         * @static
                         * @param {google.ads.googleads.v1.common.ICpcBidSimulationPoint} message CpcBidSimulationPoint message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CpcBidSimulationPoint.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CpcBidSimulationPoint message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPoint
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.CpcBidSimulationPoint} CpcBidSimulationPoint
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CpcBidSimulationPoint.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.CpcBidSimulationPoint();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.cpcBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.biddableConversions = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.biddableConversionsValue = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.clicks = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.costMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.impressions = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.topSlotImpressions = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CpcBidSimulationPoint message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPoint
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.CpcBidSimulationPoint} CpcBidSimulationPoint
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CpcBidSimulationPoint.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CpcBidSimulationPoint message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPoint
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CpcBidSimulationPoint.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpcBidMicros);
                                if (error)
                                    return "cpcBidMicros." + error;
                            }
                            if (message.biddableConversions != null && message.hasOwnProperty("biddableConversions")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.biddableConversions);
                                if (error)
                                    return "biddableConversions." + error;
                            }
                            if (message.biddableConversionsValue != null && message.hasOwnProperty("biddableConversionsValue")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.biddableConversionsValue);
                                if (error)
                                    return "biddableConversionsValue." + error;
                            }
                            if (message.clicks != null && message.hasOwnProperty("clicks")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.clicks);
                                if (error)
                                    return "clicks." + error;
                            }
                            if (message.costMicros != null && message.hasOwnProperty("costMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.costMicros);
                                if (error)
                                    return "costMicros." + error;
                            }
                            if (message.impressions != null && message.hasOwnProperty("impressions")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.impressions);
                                if (error)
                                    return "impressions." + error;
                            }
                            if (message.topSlotImpressions != null && message.hasOwnProperty("topSlotImpressions")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.topSlotImpressions);
                                if (error)
                                    return "topSlotImpressions." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CpcBidSimulationPoint message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPoint
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.CpcBidSimulationPoint} CpcBidSimulationPoint
                         */
                        CpcBidSimulationPoint.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.CpcBidSimulationPoint)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.CpcBidSimulationPoint();
                            if (object.cpcBidMicros != null) {
                                if (typeof object.cpcBidMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CpcBidSimulationPoint.cpcBidMicros: object expected");
                                message.cpcBidMicros = $root.google.protobuf.Int64Value.fromObject(object.cpcBidMicros);
                            }
                            if (object.biddableConversions != null) {
                                if (typeof object.biddableConversions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CpcBidSimulationPoint.biddableConversions: object expected");
                                message.biddableConversions = $root.google.protobuf.DoubleValue.fromObject(object.biddableConversions);
                            }
                            if (object.biddableConversionsValue != null) {
                                if (typeof object.biddableConversionsValue !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CpcBidSimulationPoint.biddableConversionsValue: object expected");
                                message.biddableConversionsValue = $root.google.protobuf.DoubleValue.fromObject(object.biddableConversionsValue);
                            }
                            if (object.clicks != null) {
                                if (typeof object.clicks !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CpcBidSimulationPoint.clicks: object expected");
                                message.clicks = $root.google.protobuf.Int64Value.fromObject(object.clicks);
                            }
                            if (object.costMicros != null) {
                                if (typeof object.costMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CpcBidSimulationPoint.costMicros: object expected");
                                message.costMicros = $root.google.protobuf.Int64Value.fromObject(object.costMicros);
                            }
                            if (object.impressions != null) {
                                if (typeof object.impressions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CpcBidSimulationPoint.impressions: object expected");
                                message.impressions = $root.google.protobuf.Int64Value.fromObject(object.impressions);
                            }
                            if (object.topSlotImpressions != null) {
                                if (typeof object.topSlotImpressions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CpcBidSimulationPoint.topSlotImpressions: object expected");
                                message.topSlotImpressions = $root.google.protobuf.Int64Value.fromObject(object.topSlotImpressions);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CpcBidSimulationPoint message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPoint
                         * @static
                         * @param {google.ads.googleads.v1.common.CpcBidSimulationPoint} message CpcBidSimulationPoint
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CpcBidSimulationPoint.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.cpcBidMicros = null;
                                object.biddableConversions = null;
                                object.biddableConversionsValue = null;
                                object.clicks = null;
                                object.costMicros = null;
                                object.impressions = null;
                                object.topSlotImpressions = null;
                            }
                            if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros"))
                                object.cpcBidMicros = $root.google.protobuf.Int64Value.toObject(message.cpcBidMicros, options);
                            if (message.biddableConversions != null && message.hasOwnProperty("biddableConversions"))
                                object.biddableConversions = $root.google.protobuf.DoubleValue.toObject(message.biddableConversions, options);
                            if (message.biddableConversionsValue != null && message.hasOwnProperty("biddableConversionsValue"))
                                object.biddableConversionsValue = $root.google.protobuf.DoubleValue.toObject(message.biddableConversionsValue, options);
                            if (message.clicks != null && message.hasOwnProperty("clicks"))
                                object.clicks = $root.google.protobuf.Int64Value.toObject(message.clicks, options);
                            if (message.costMicros != null && message.hasOwnProperty("costMicros"))
                                object.costMicros = $root.google.protobuf.Int64Value.toObject(message.costMicros, options);
                            if (message.impressions != null && message.hasOwnProperty("impressions"))
                                object.impressions = $root.google.protobuf.Int64Value.toObject(message.impressions, options);
                            if (message.topSlotImpressions != null && message.hasOwnProperty("topSlotImpressions"))
                                object.topSlotImpressions = $root.google.protobuf.Int64Value.toObject(message.topSlotImpressions, options);
                            return object;
                        };

                        /**
                         * Converts this CpcBidSimulationPoint to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.CpcBidSimulationPoint
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CpcBidSimulationPoint.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CpcBidSimulationPoint;
                    })();

                    common.TargetCpaSimulationPoint = (function() {

                        /**
                         * Properties of a TargetCpaSimulationPoint.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ITargetCpaSimulationPoint
                         * @property {google.protobuf.IInt64Value|null} [targetCpaMicros] TargetCpaSimulationPoint targetCpaMicros
                         * @property {google.protobuf.IDoubleValue|null} [biddableConversions] TargetCpaSimulationPoint biddableConversions
                         * @property {google.protobuf.IDoubleValue|null} [biddableConversionsValue] TargetCpaSimulationPoint biddableConversionsValue
                         * @property {google.protobuf.IInt64Value|null} [clicks] TargetCpaSimulationPoint clicks
                         * @property {google.protobuf.IInt64Value|null} [costMicros] TargetCpaSimulationPoint costMicros
                         * @property {google.protobuf.IInt64Value|null} [impressions] TargetCpaSimulationPoint impressions
                         * @property {google.protobuf.IInt64Value|null} [topSlotImpressions] TargetCpaSimulationPoint topSlotImpressions
                         */

                        /**
                         * Constructs a new TargetCpaSimulationPoint.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a TargetCpaSimulationPoint.
                         * @implements ITargetCpaSimulationPoint
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ITargetCpaSimulationPoint=} [properties] Properties to set
                         */
                        function TargetCpaSimulationPoint(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * TargetCpaSimulationPoint targetCpaMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} targetCpaMicros
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPoint
                         * @instance
                         */
                        TargetCpaSimulationPoint.prototype.targetCpaMicros = null;

                        /**
                         * TargetCpaSimulationPoint biddableConversions.
                         * @member {google.protobuf.IDoubleValue|null|undefined} biddableConversions
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPoint
                         * @instance
                         */
                        TargetCpaSimulationPoint.prototype.biddableConversions = null;

                        /**
                         * TargetCpaSimulationPoint biddableConversionsValue.
                         * @member {google.protobuf.IDoubleValue|null|undefined} biddableConversionsValue
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPoint
                         * @instance
                         */
                        TargetCpaSimulationPoint.prototype.biddableConversionsValue = null;

                        /**
                         * TargetCpaSimulationPoint clicks.
                         * @member {google.protobuf.IInt64Value|null|undefined} clicks
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPoint
                         * @instance
                         */
                        TargetCpaSimulationPoint.prototype.clicks = null;

                        /**
                         * TargetCpaSimulationPoint costMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} costMicros
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPoint
                         * @instance
                         */
                        TargetCpaSimulationPoint.prototype.costMicros = null;

                        /**
                         * TargetCpaSimulationPoint impressions.
                         * @member {google.protobuf.IInt64Value|null|undefined} impressions
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPoint
                         * @instance
                         */
                        TargetCpaSimulationPoint.prototype.impressions = null;

                        /**
                         * TargetCpaSimulationPoint topSlotImpressions.
                         * @member {google.protobuf.IInt64Value|null|undefined} topSlotImpressions
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPoint
                         * @instance
                         */
                        TargetCpaSimulationPoint.prototype.topSlotImpressions = null;

                        /**
                         * Creates a new TargetCpaSimulationPoint instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPoint
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetCpaSimulationPoint=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.TargetCpaSimulationPoint} TargetCpaSimulationPoint instance
                         */
                        TargetCpaSimulationPoint.create = function create(properties) {
                            return new TargetCpaSimulationPoint(properties);
                        };

                        /**
                         * Encodes the specified TargetCpaSimulationPoint message. Does not implicitly {@link google.ads.googleads.v1.common.TargetCpaSimulationPoint.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPoint
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetCpaSimulationPoint} message TargetCpaSimulationPoint message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetCpaSimulationPoint.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetCpaMicros != null && message.hasOwnProperty("targetCpaMicros"))
                                $root.google.protobuf.Int64Value.encode(message.targetCpaMicros, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.biddableConversions != null && message.hasOwnProperty("biddableConversions"))
                                $root.google.protobuf.DoubleValue.encode(message.biddableConversions, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.biddableConversionsValue != null && message.hasOwnProperty("biddableConversionsValue"))
                                $root.google.protobuf.DoubleValue.encode(message.biddableConversionsValue, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.clicks != null && message.hasOwnProperty("clicks"))
                                $root.google.protobuf.Int64Value.encode(message.clicks, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.costMicros != null && message.hasOwnProperty("costMicros"))
                                $root.google.protobuf.Int64Value.encode(message.costMicros, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.impressions != null && message.hasOwnProperty("impressions"))
                                $root.google.protobuf.Int64Value.encode(message.impressions, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.topSlotImpressions != null && message.hasOwnProperty("topSlotImpressions"))
                                $root.google.protobuf.Int64Value.encode(message.topSlotImpressions, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified TargetCpaSimulationPoint message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.TargetCpaSimulationPoint.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPoint
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetCpaSimulationPoint} message TargetCpaSimulationPoint message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetCpaSimulationPoint.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TargetCpaSimulationPoint message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPoint
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.TargetCpaSimulationPoint} TargetCpaSimulationPoint
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetCpaSimulationPoint.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.TargetCpaSimulationPoint();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.targetCpaMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.biddableConversions = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.biddableConversionsValue = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.clicks = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.costMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.impressions = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.topSlotImpressions = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TargetCpaSimulationPoint message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPoint
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.TargetCpaSimulationPoint} TargetCpaSimulationPoint
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetCpaSimulationPoint.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TargetCpaSimulationPoint message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPoint
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetCpaSimulationPoint.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.targetCpaMicros != null && message.hasOwnProperty("targetCpaMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.targetCpaMicros);
                                if (error)
                                    return "targetCpaMicros." + error;
                            }
                            if (message.biddableConversions != null && message.hasOwnProperty("biddableConversions")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.biddableConversions);
                                if (error)
                                    return "biddableConversions." + error;
                            }
                            if (message.biddableConversionsValue != null && message.hasOwnProperty("biddableConversionsValue")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.biddableConversionsValue);
                                if (error)
                                    return "biddableConversionsValue." + error;
                            }
                            if (message.clicks != null && message.hasOwnProperty("clicks")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.clicks);
                                if (error)
                                    return "clicks." + error;
                            }
                            if (message.costMicros != null && message.hasOwnProperty("costMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.costMicros);
                                if (error)
                                    return "costMicros." + error;
                            }
                            if (message.impressions != null && message.hasOwnProperty("impressions")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.impressions);
                                if (error)
                                    return "impressions." + error;
                            }
                            if (message.topSlotImpressions != null && message.hasOwnProperty("topSlotImpressions")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.topSlotImpressions);
                                if (error)
                                    return "topSlotImpressions." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a TargetCpaSimulationPoint message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPoint
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.TargetCpaSimulationPoint} TargetCpaSimulationPoint
                         */
                        TargetCpaSimulationPoint.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.TargetCpaSimulationPoint)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.TargetCpaSimulationPoint();
                            if (object.targetCpaMicros != null) {
                                if (typeof object.targetCpaMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetCpaSimulationPoint.targetCpaMicros: object expected");
                                message.targetCpaMicros = $root.google.protobuf.Int64Value.fromObject(object.targetCpaMicros);
                            }
                            if (object.biddableConversions != null) {
                                if (typeof object.biddableConversions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetCpaSimulationPoint.biddableConversions: object expected");
                                message.biddableConversions = $root.google.protobuf.DoubleValue.fromObject(object.biddableConversions);
                            }
                            if (object.biddableConversionsValue != null) {
                                if (typeof object.biddableConversionsValue !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetCpaSimulationPoint.biddableConversionsValue: object expected");
                                message.biddableConversionsValue = $root.google.protobuf.DoubleValue.fromObject(object.biddableConversionsValue);
                            }
                            if (object.clicks != null) {
                                if (typeof object.clicks !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetCpaSimulationPoint.clicks: object expected");
                                message.clicks = $root.google.protobuf.Int64Value.fromObject(object.clicks);
                            }
                            if (object.costMicros != null) {
                                if (typeof object.costMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetCpaSimulationPoint.costMicros: object expected");
                                message.costMicros = $root.google.protobuf.Int64Value.fromObject(object.costMicros);
                            }
                            if (object.impressions != null) {
                                if (typeof object.impressions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetCpaSimulationPoint.impressions: object expected");
                                message.impressions = $root.google.protobuf.Int64Value.fromObject(object.impressions);
                            }
                            if (object.topSlotImpressions != null) {
                                if (typeof object.topSlotImpressions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetCpaSimulationPoint.topSlotImpressions: object expected");
                                message.topSlotImpressions = $root.google.protobuf.Int64Value.fromObject(object.topSlotImpressions);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a TargetCpaSimulationPoint message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPoint
                         * @static
                         * @param {google.ads.googleads.v1.common.TargetCpaSimulationPoint} message TargetCpaSimulationPoint
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetCpaSimulationPoint.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetCpaMicros = null;
                                object.biddableConversions = null;
                                object.biddableConversionsValue = null;
                                object.clicks = null;
                                object.costMicros = null;
                                object.impressions = null;
                                object.topSlotImpressions = null;
                            }
                            if (message.targetCpaMicros != null && message.hasOwnProperty("targetCpaMicros"))
                                object.targetCpaMicros = $root.google.protobuf.Int64Value.toObject(message.targetCpaMicros, options);
                            if (message.biddableConversions != null && message.hasOwnProperty("biddableConversions"))
                                object.biddableConversions = $root.google.protobuf.DoubleValue.toObject(message.biddableConversions, options);
                            if (message.biddableConversionsValue != null && message.hasOwnProperty("biddableConversionsValue"))
                                object.biddableConversionsValue = $root.google.protobuf.DoubleValue.toObject(message.biddableConversionsValue, options);
                            if (message.clicks != null && message.hasOwnProperty("clicks"))
                                object.clicks = $root.google.protobuf.Int64Value.toObject(message.clicks, options);
                            if (message.costMicros != null && message.hasOwnProperty("costMicros"))
                                object.costMicros = $root.google.protobuf.Int64Value.toObject(message.costMicros, options);
                            if (message.impressions != null && message.hasOwnProperty("impressions"))
                                object.impressions = $root.google.protobuf.Int64Value.toObject(message.impressions, options);
                            if (message.topSlotImpressions != null && message.hasOwnProperty("topSlotImpressions"))
                                object.topSlotImpressions = $root.google.protobuf.Int64Value.toObject(message.topSlotImpressions, options);
                            return object;
                        };

                        /**
                         * Converts this TargetCpaSimulationPoint to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.TargetCpaSimulationPoint
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetCpaSimulationPoint.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return TargetCpaSimulationPoint;
                    })();

                    common.TagSnippet = (function() {

                        /**
                         * Properties of a TagSnippet.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ITagSnippet
                         * @property {google.ads.googleads.v1.enums.TrackingCodeTypeEnum.TrackingCodeType|null} [type] TagSnippet type
                         * @property {google.ads.googleads.v1.enums.TrackingCodePageFormatEnum.TrackingCodePageFormat|null} [pageFormat] TagSnippet pageFormat
                         * @property {google.protobuf.IStringValue|null} [globalSiteTag] TagSnippet globalSiteTag
                         * @property {google.protobuf.IStringValue|null} [eventSnippet] TagSnippet eventSnippet
                         */

                        /**
                         * Constructs a new TagSnippet.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a TagSnippet.
                         * @implements ITagSnippet
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ITagSnippet=} [properties] Properties to set
                         */
                        function TagSnippet(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * TagSnippet type.
                         * @member {google.ads.googleads.v1.enums.TrackingCodeTypeEnum.TrackingCodeType} type
                         * @memberof google.ads.googleads.v1.common.TagSnippet
                         * @instance
                         */
                        TagSnippet.prototype.type = 0;

                        /**
                         * TagSnippet pageFormat.
                         * @member {google.ads.googleads.v1.enums.TrackingCodePageFormatEnum.TrackingCodePageFormat} pageFormat
                         * @memberof google.ads.googleads.v1.common.TagSnippet
                         * @instance
                         */
                        TagSnippet.prototype.pageFormat = 0;

                        /**
                         * TagSnippet globalSiteTag.
                         * @member {google.protobuf.IStringValue|null|undefined} globalSiteTag
                         * @memberof google.ads.googleads.v1.common.TagSnippet
                         * @instance
                         */
                        TagSnippet.prototype.globalSiteTag = null;

                        /**
                         * TagSnippet eventSnippet.
                         * @member {google.protobuf.IStringValue|null|undefined} eventSnippet
                         * @memberof google.ads.googleads.v1.common.TagSnippet
                         * @instance
                         */
                        TagSnippet.prototype.eventSnippet = null;

                        /**
                         * Creates a new TagSnippet instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.TagSnippet
                         * @static
                         * @param {google.ads.googleads.v1.common.ITagSnippet=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.TagSnippet} TagSnippet instance
                         */
                        TagSnippet.create = function create(properties) {
                            return new TagSnippet(properties);
                        };

                        /**
                         * Encodes the specified TagSnippet message. Does not implicitly {@link google.ads.googleads.v1.common.TagSnippet.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.TagSnippet
                         * @static
                         * @param {google.ads.googleads.v1.common.ITagSnippet} message TagSnippet message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TagSnippet.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.type);
                            if (message.pageFormat != null && message.hasOwnProperty("pageFormat"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageFormat);
                            if (message.globalSiteTag != null && message.hasOwnProperty("globalSiteTag"))
                                $root.google.protobuf.StringValue.encode(message.globalSiteTag, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.eventSnippet != null && message.hasOwnProperty("eventSnippet"))
                                $root.google.protobuf.StringValue.encode(message.eventSnippet, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified TagSnippet message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.TagSnippet.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.TagSnippet
                         * @static
                         * @param {google.ads.googleads.v1.common.ITagSnippet} message TagSnippet message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TagSnippet.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TagSnippet message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.TagSnippet
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.TagSnippet} TagSnippet
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TagSnippet.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.TagSnippet();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.type = reader.int32();
                                    break;
                                case 2:
                                    message.pageFormat = reader.int32();
                                    break;
                                case 3:
                                    message.globalSiteTag = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.eventSnippet = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TagSnippet message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.TagSnippet
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.TagSnippet} TagSnippet
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TagSnippet.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TagSnippet message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.TagSnippet
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TagSnippet.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.pageFormat != null && message.hasOwnProperty("pageFormat"))
                                switch (message.pageFormat) {
                                default:
                                    return "pageFormat: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.globalSiteTag != null && message.hasOwnProperty("globalSiteTag")) {
                                var error = $root.google.protobuf.StringValue.verify(message.globalSiteTag);
                                if (error)
                                    return "globalSiteTag." + error;
                            }
                            if (message.eventSnippet != null && message.hasOwnProperty("eventSnippet")) {
                                var error = $root.google.protobuf.StringValue.verify(message.eventSnippet);
                                if (error)
                                    return "eventSnippet." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a TagSnippet message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.TagSnippet
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.TagSnippet} TagSnippet
                         */
                        TagSnippet.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.TagSnippet)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.TagSnippet();
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "WEBPAGE":
                            case 2:
                                message.type = 2;
                                break;
                            case "WEBPAGE_ONCLICK":
                            case 3:
                                message.type = 3;
                                break;
                            case "CLICK_TO_CALL":
                            case 4:
                                message.type = 4;
                                break;
                            }
                            switch (object.pageFormat) {
                            case "UNSPECIFIED":
                            case 0:
                                message.pageFormat = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.pageFormat = 1;
                                break;
                            case "HTML":
                            case 2:
                                message.pageFormat = 2;
                                break;
                            case "AMP":
                            case 3:
                                message.pageFormat = 3;
                                break;
                            }
                            if (object.globalSiteTag != null) {
                                if (typeof object.globalSiteTag !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TagSnippet.globalSiteTag: object expected");
                                message.globalSiteTag = $root.google.protobuf.StringValue.fromObject(object.globalSiteTag);
                            }
                            if (object.eventSnippet != null) {
                                if (typeof object.eventSnippet !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TagSnippet.eventSnippet: object expected");
                                message.eventSnippet = $root.google.protobuf.StringValue.fromObject(object.eventSnippet);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a TagSnippet message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.TagSnippet
                         * @static
                         * @param {google.ads.googleads.v1.common.TagSnippet} message TagSnippet
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TagSnippet.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.pageFormat = options.enums === String ? "UNSPECIFIED" : 0;
                                object.globalSiteTag = null;
                                object.eventSnippet = null;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.TrackingCodeTypeEnum.TrackingCodeType[message.type] : message.type;
                            if (message.pageFormat != null && message.hasOwnProperty("pageFormat"))
                                object.pageFormat = options.enums === String ? $root.google.ads.googleads.v1.enums.TrackingCodePageFormatEnum.TrackingCodePageFormat[message.pageFormat] : message.pageFormat;
                            if (message.globalSiteTag != null && message.hasOwnProperty("globalSiteTag"))
                                object.globalSiteTag = $root.google.protobuf.StringValue.toObject(message.globalSiteTag, options);
                            if (message.eventSnippet != null && message.hasOwnProperty("eventSnippet"))
                                object.eventSnippet = $root.google.protobuf.StringValue.toObject(message.eventSnippet, options);
                            return object;
                        };

                        /**
                         * Converts this TagSnippet to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.TagSnippet
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TagSnippet.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return TagSnippet;
                    })();

                    common.TargetingSetting = (function() {

                        /**
                         * Properties of a TargetingSetting.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ITargetingSetting
                         * @property {Array.<google.ads.googleads.v1.common.ITargetRestriction>|null} [targetRestrictions] TargetingSetting targetRestrictions
                         */

                        /**
                         * Constructs a new TargetingSetting.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a TargetingSetting.
                         * @implements ITargetingSetting
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ITargetingSetting=} [properties] Properties to set
                         */
                        function TargetingSetting(properties) {
                            this.targetRestrictions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * TargetingSetting targetRestrictions.
                         * @member {Array.<google.ads.googleads.v1.common.ITargetRestriction>} targetRestrictions
                         * @memberof google.ads.googleads.v1.common.TargetingSetting
                         * @instance
                         */
                        TargetingSetting.prototype.targetRestrictions = $util.emptyArray;

                        /**
                         * Creates a new TargetingSetting instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.TargetingSetting
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetingSetting=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.TargetingSetting} TargetingSetting instance
                         */
                        TargetingSetting.create = function create(properties) {
                            return new TargetingSetting(properties);
                        };

                        /**
                         * Encodes the specified TargetingSetting message. Does not implicitly {@link google.ads.googleads.v1.common.TargetingSetting.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.TargetingSetting
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetingSetting} message TargetingSetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetingSetting.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetRestrictions != null && message.targetRestrictions.length)
                                for (var i = 0; i < message.targetRestrictions.length; ++i)
                                    $root.google.ads.googleads.v1.common.TargetRestriction.encode(message.targetRestrictions[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified TargetingSetting message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.TargetingSetting.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetingSetting
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetingSetting} message TargetingSetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetingSetting.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TargetingSetting message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.TargetingSetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.TargetingSetting} TargetingSetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetingSetting.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.TargetingSetting();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.targetRestrictions && message.targetRestrictions.length))
                                        message.targetRestrictions = [];
                                    message.targetRestrictions.push($root.google.ads.googleads.v1.common.TargetRestriction.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TargetingSetting message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetingSetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.TargetingSetting} TargetingSetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetingSetting.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TargetingSetting message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.TargetingSetting
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetingSetting.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.targetRestrictions != null && message.hasOwnProperty("targetRestrictions")) {
                                if (!Array.isArray(message.targetRestrictions))
                                    return "targetRestrictions: array expected";
                                for (var i = 0; i < message.targetRestrictions.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.TargetRestriction.verify(message.targetRestrictions[i]);
                                    if (error)
                                        return "targetRestrictions." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a TargetingSetting message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.TargetingSetting
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.TargetingSetting} TargetingSetting
                         */
                        TargetingSetting.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.TargetingSetting)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.TargetingSetting();
                            if (object.targetRestrictions) {
                                if (!Array.isArray(object.targetRestrictions))
                                    throw TypeError(".google.ads.googleads.v1.common.TargetingSetting.targetRestrictions: array expected");
                                message.targetRestrictions = [];
                                for (var i = 0; i < object.targetRestrictions.length; ++i) {
                                    if (typeof object.targetRestrictions[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.TargetingSetting.targetRestrictions: object expected");
                                    message.targetRestrictions[i] = $root.google.ads.googleads.v1.common.TargetRestriction.fromObject(object.targetRestrictions[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a TargetingSetting message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.TargetingSetting
                         * @static
                         * @param {google.ads.googleads.v1.common.TargetingSetting} message TargetingSetting
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetingSetting.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.targetRestrictions = [];
                            if (message.targetRestrictions && message.targetRestrictions.length) {
                                object.targetRestrictions = [];
                                for (var j = 0; j < message.targetRestrictions.length; ++j)
                                    object.targetRestrictions[j] = $root.google.ads.googleads.v1.common.TargetRestriction.toObject(message.targetRestrictions[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this TargetingSetting to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.TargetingSetting
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetingSetting.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return TargetingSetting;
                    })();

                    common.TargetRestriction = (function() {

                        /**
                         * Properties of a TargetRestriction.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ITargetRestriction
                         * @property {google.ads.googleads.v1.enums.TargetingDimensionEnum.TargetingDimension|null} [targetingDimension] TargetRestriction targetingDimension
                         * @property {google.protobuf.IBoolValue|null} [bidOnly] TargetRestriction bidOnly
                         */

                        /**
                         * Constructs a new TargetRestriction.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a TargetRestriction.
                         * @implements ITargetRestriction
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ITargetRestriction=} [properties] Properties to set
                         */
                        function TargetRestriction(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * TargetRestriction targetingDimension.
                         * @member {google.ads.googleads.v1.enums.TargetingDimensionEnum.TargetingDimension} targetingDimension
                         * @memberof google.ads.googleads.v1.common.TargetRestriction
                         * @instance
                         */
                        TargetRestriction.prototype.targetingDimension = 0;

                        /**
                         * TargetRestriction bidOnly.
                         * @member {google.protobuf.IBoolValue|null|undefined} bidOnly
                         * @memberof google.ads.googleads.v1.common.TargetRestriction
                         * @instance
                         */
                        TargetRestriction.prototype.bidOnly = null;

                        /**
                         * Creates a new TargetRestriction instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.TargetRestriction
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetRestriction=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.TargetRestriction} TargetRestriction instance
                         */
                        TargetRestriction.create = function create(properties) {
                            return new TargetRestriction(properties);
                        };

                        /**
                         * Encodes the specified TargetRestriction message. Does not implicitly {@link google.ads.googleads.v1.common.TargetRestriction.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.TargetRestriction
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetRestriction} message TargetRestriction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetRestriction.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetingDimension != null && message.hasOwnProperty("targetingDimension"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.targetingDimension);
                            if (message.bidOnly != null && message.hasOwnProperty("bidOnly"))
                                $root.google.protobuf.BoolValue.encode(message.bidOnly, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified TargetRestriction message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.TargetRestriction.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetRestriction
                         * @static
                         * @param {google.ads.googleads.v1.common.ITargetRestriction} message TargetRestriction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetRestriction.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TargetRestriction message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.TargetRestriction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.TargetRestriction} TargetRestriction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetRestriction.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.TargetRestriction();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.targetingDimension = reader.int32();
                                    break;
                                case 2:
                                    message.bidOnly = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TargetRestriction message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.TargetRestriction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.TargetRestriction} TargetRestriction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetRestriction.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TargetRestriction message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.TargetRestriction
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetRestriction.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.targetingDimension != null && message.hasOwnProperty("targetingDimension"))
                                switch (message.targetingDimension) {
                                default:
                                    return "targetingDimension: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                    break;
                                }
                            if (message.bidOnly != null && message.hasOwnProperty("bidOnly")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.bidOnly);
                                if (error)
                                    return "bidOnly." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a TargetRestriction message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.TargetRestriction
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.TargetRestriction} TargetRestriction
                         */
                        TargetRestriction.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.TargetRestriction)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.TargetRestriction();
                            switch (object.targetingDimension) {
                            case "UNSPECIFIED":
                            case 0:
                                message.targetingDimension = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.targetingDimension = 1;
                                break;
                            case "KEYWORD":
                            case 2:
                                message.targetingDimension = 2;
                                break;
                            case "AUDIENCE":
                            case 3:
                                message.targetingDimension = 3;
                                break;
                            case "TOPIC":
                            case 4:
                                message.targetingDimension = 4;
                                break;
                            case "GENDER":
                            case 5:
                                message.targetingDimension = 5;
                                break;
                            case "AGE_RANGE":
                            case 6:
                                message.targetingDimension = 6;
                                break;
                            case "PLACEMENT":
                            case 7:
                                message.targetingDimension = 7;
                                break;
                            case "PARENTAL_STATUS":
                            case 8:
                                message.targetingDimension = 8;
                                break;
                            case "INCOME_RANGE":
                            case 9:
                                message.targetingDimension = 9;
                                break;
                            }
                            if (object.bidOnly != null) {
                                if (typeof object.bidOnly !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TargetRestriction.bidOnly: object expected");
                                message.bidOnly = $root.google.protobuf.BoolValue.fromObject(object.bidOnly);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a TargetRestriction message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.TargetRestriction
                         * @static
                         * @param {google.ads.googleads.v1.common.TargetRestriction} message TargetRestriction
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetRestriction.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetingDimension = options.enums === String ? "UNSPECIFIED" : 0;
                                object.bidOnly = null;
                            }
                            if (message.targetingDimension != null && message.hasOwnProperty("targetingDimension"))
                                object.targetingDimension = options.enums === String ? $root.google.ads.googleads.v1.enums.TargetingDimensionEnum.TargetingDimension[message.targetingDimension] : message.targetingDimension;
                            if (message.bidOnly != null && message.hasOwnProperty("bidOnly"))
                                object.bidOnly = $root.google.protobuf.BoolValue.toObject(message.bidOnly, options);
                            return object;
                        };

                        /**
                         * Converts this TargetRestriction to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.TargetRestriction
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetRestriction.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return TargetRestriction;
                    })();

                    common.TextLabel = (function() {

                        /**
                         * Properties of a TextLabel.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ITextLabel
                         * @property {google.protobuf.IStringValue|null} [backgroundColor] TextLabel backgroundColor
                         * @property {google.protobuf.IStringValue|null} [description] TextLabel description
                         */

                        /**
                         * Constructs a new TextLabel.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a TextLabel.
                         * @implements ITextLabel
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ITextLabel=} [properties] Properties to set
                         */
                        function TextLabel(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * TextLabel backgroundColor.
                         * @member {google.protobuf.IStringValue|null|undefined} backgroundColor
                         * @memberof google.ads.googleads.v1.common.TextLabel
                         * @instance
                         */
                        TextLabel.prototype.backgroundColor = null;

                        /**
                         * TextLabel description.
                         * @member {google.protobuf.IStringValue|null|undefined} description
                         * @memberof google.ads.googleads.v1.common.TextLabel
                         * @instance
                         */
                        TextLabel.prototype.description = null;

                        /**
                         * Creates a new TextLabel instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.TextLabel
                         * @static
                         * @param {google.ads.googleads.v1.common.ITextLabel=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.TextLabel} TextLabel instance
                         */
                        TextLabel.create = function create(properties) {
                            return new TextLabel(properties);
                        };

                        /**
                         * Encodes the specified TextLabel message. Does not implicitly {@link google.ads.googleads.v1.common.TextLabel.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.TextLabel
                         * @static
                         * @param {google.ads.googleads.v1.common.ITextLabel} message TextLabel message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TextLabel.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.backgroundColor != null && message.hasOwnProperty("backgroundColor"))
                                $root.google.protobuf.StringValue.encode(message.backgroundColor, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.description != null && message.hasOwnProperty("description"))
                                $root.google.protobuf.StringValue.encode(message.description, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified TextLabel message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.TextLabel.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.TextLabel
                         * @static
                         * @param {google.ads.googleads.v1.common.ITextLabel} message TextLabel message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TextLabel.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TextLabel message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.TextLabel
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.TextLabel} TextLabel
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TextLabel.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.TextLabel();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.backgroundColor = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.description = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TextLabel message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.TextLabel
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.TextLabel} TextLabel
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TextLabel.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TextLabel message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.TextLabel
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TextLabel.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.backgroundColor != null && message.hasOwnProperty("backgroundColor")) {
                                var error = $root.google.protobuf.StringValue.verify(message.backgroundColor);
                                if (error)
                                    return "backgroundColor." + error;
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                var error = $root.google.protobuf.StringValue.verify(message.description);
                                if (error)
                                    return "description." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a TextLabel message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.TextLabel
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.TextLabel} TextLabel
                         */
                        TextLabel.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.TextLabel)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.TextLabel();
                            if (object.backgroundColor != null) {
                                if (typeof object.backgroundColor !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TextLabel.backgroundColor: object expected");
                                message.backgroundColor = $root.google.protobuf.StringValue.fromObject(object.backgroundColor);
                            }
                            if (object.description != null) {
                                if (typeof object.description !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.TextLabel.description: object expected");
                                message.description = $root.google.protobuf.StringValue.fromObject(object.description);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a TextLabel message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.TextLabel
                         * @static
                         * @param {google.ads.googleads.v1.common.TextLabel} message TextLabel
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TextLabel.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.backgroundColor = null;
                                object.description = null;
                            }
                            if (message.backgroundColor != null && message.hasOwnProperty("backgroundColor"))
                                object.backgroundColor = $root.google.protobuf.StringValue.toObject(message.backgroundColor, options);
                            if (message.description != null && message.hasOwnProperty("description"))
                                object.description = $root.google.protobuf.StringValue.toObject(message.description, options);
                            return object;
                        };

                        /**
                         * Converts this TextLabel to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.TextLabel
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TextLabel.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return TextLabel;
                    })();

                    common.UrlCollection = (function() {

                        /**
                         * Properties of an UrlCollection.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IUrlCollection
                         * @property {google.protobuf.IStringValue|null} [urlCollectionId] UrlCollection urlCollectionId
                         * @property {Array.<google.protobuf.IStringValue>|null} [finalUrls] UrlCollection finalUrls
                         * @property {Array.<google.protobuf.IStringValue>|null} [finalMobileUrls] UrlCollection finalMobileUrls
                         * @property {google.protobuf.IStringValue|null} [trackingUrlTemplate] UrlCollection trackingUrlTemplate
                         */

                        /**
                         * Constructs a new UrlCollection.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an UrlCollection.
                         * @implements IUrlCollection
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IUrlCollection=} [properties] Properties to set
                         */
                        function UrlCollection(properties) {
                            this.finalUrls = [];
                            this.finalMobileUrls = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UrlCollection urlCollectionId.
                         * @member {google.protobuf.IStringValue|null|undefined} urlCollectionId
                         * @memberof google.ads.googleads.v1.common.UrlCollection
                         * @instance
                         */
                        UrlCollection.prototype.urlCollectionId = null;

                        /**
                         * UrlCollection finalUrls.
                         * @member {Array.<google.protobuf.IStringValue>} finalUrls
                         * @memberof google.ads.googleads.v1.common.UrlCollection
                         * @instance
                         */
                        UrlCollection.prototype.finalUrls = $util.emptyArray;

                        /**
                         * UrlCollection finalMobileUrls.
                         * @member {Array.<google.protobuf.IStringValue>} finalMobileUrls
                         * @memberof google.ads.googleads.v1.common.UrlCollection
                         * @instance
                         */
                        UrlCollection.prototype.finalMobileUrls = $util.emptyArray;

                        /**
                         * UrlCollection trackingUrlTemplate.
                         * @member {google.protobuf.IStringValue|null|undefined} trackingUrlTemplate
                         * @memberof google.ads.googleads.v1.common.UrlCollection
                         * @instance
                         */
                        UrlCollection.prototype.trackingUrlTemplate = null;

                        /**
                         * Creates a new UrlCollection instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.UrlCollection
                         * @static
                         * @param {google.ads.googleads.v1.common.IUrlCollection=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.UrlCollection} UrlCollection instance
                         */
                        UrlCollection.create = function create(properties) {
                            return new UrlCollection(properties);
                        };

                        /**
                         * Encodes the specified UrlCollection message. Does not implicitly {@link google.ads.googleads.v1.common.UrlCollection.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.UrlCollection
                         * @static
                         * @param {google.ads.googleads.v1.common.IUrlCollection} message UrlCollection message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlCollection.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.urlCollectionId != null && message.hasOwnProperty("urlCollectionId"))
                                $root.google.protobuf.StringValue.encode(message.urlCollectionId, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.finalUrls != null && message.finalUrls.length)
                                for (var i = 0; i < message.finalUrls.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.finalUrls[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.finalMobileUrls != null && message.finalMobileUrls.length)
                                for (var i = 0; i < message.finalMobileUrls.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.finalMobileUrls[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                $root.google.protobuf.StringValue.encode(message.trackingUrlTemplate, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified UrlCollection message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.UrlCollection.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.UrlCollection
                         * @static
                         * @param {google.ads.googleads.v1.common.IUrlCollection} message UrlCollection message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlCollection.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an UrlCollection message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.UrlCollection
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.UrlCollection} UrlCollection
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlCollection.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.UrlCollection();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.urlCollectionId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.finalUrls && message.finalUrls.length))
                                        message.finalUrls = [];
                                    message.finalUrls.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    if (!(message.finalMobileUrls && message.finalMobileUrls.length))
                                        message.finalMobileUrls = [];
                                    message.finalMobileUrls.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 4:
                                    message.trackingUrlTemplate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an UrlCollection message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.UrlCollection
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.UrlCollection} UrlCollection
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlCollection.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an UrlCollection message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.UrlCollection
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UrlCollection.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.urlCollectionId != null && message.hasOwnProperty("urlCollectionId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.urlCollectionId);
                                if (error)
                                    return "urlCollectionId." + error;
                            }
                            if (message.finalUrls != null && message.hasOwnProperty("finalUrls")) {
                                if (!Array.isArray(message.finalUrls))
                                    return "finalUrls: array expected";
                                for (var i = 0; i < message.finalUrls.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.finalUrls[i]);
                                    if (error)
                                        return "finalUrls." + error;
                                }
                            }
                            if (message.finalMobileUrls != null && message.hasOwnProperty("finalMobileUrls")) {
                                if (!Array.isArray(message.finalMobileUrls))
                                    return "finalMobileUrls: array expected";
                                for (var i = 0; i < message.finalMobileUrls.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.finalMobileUrls[i]);
                                    if (error)
                                        return "finalMobileUrls." + error;
                                }
                            }
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.trackingUrlTemplate);
                                if (error)
                                    return "trackingUrlTemplate." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an UrlCollection message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.UrlCollection
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.UrlCollection} UrlCollection
                         */
                        UrlCollection.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.UrlCollection)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.UrlCollection();
                            if (object.urlCollectionId != null) {
                                if (typeof object.urlCollectionId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.UrlCollection.urlCollectionId: object expected");
                                message.urlCollectionId = $root.google.protobuf.StringValue.fromObject(object.urlCollectionId);
                            }
                            if (object.finalUrls) {
                                if (!Array.isArray(object.finalUrls))
                                    throw TypeError(".google.ads.googleads.v1.common.UrlCollection.finalUrls: array expected");
                                message.finalUrls = [];
                                for (var i = 0; i < object.finalUrls.length; ++i) {
                                    if (typeof object.finalUrls[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.UrlCollection.finalUrls: object expected");
                                    message.finalUrls[i] = $root.google.protobuf.StringValue.fromObject(object.finalUrls[i]);
                                }
                            }
                            if (object.finalMobileUrls) {
                                if (!Array.isArray(object.finalMobileUrls))
                                    throw TypeError(".google.ads.googleads.v1.common.UrlCollection.finalMobileUrls: array expected");
                                message.finalMobileUrls = [];
                                for (var i = 0; i < object.finalMobileUrls.length; ++i) {
                                    if (typeof object.finalMobileUrls[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.UrlCollection.finalMobileUrls: object expected");
                                    message.finalMobileUrls[i] = $root.google.protobuf.StringValue.fromObject(object.finalMobileUrls[i]);
                                }
                            }
                            if (object.trackingUrlTemplate != null) {
                                if (typeof object.trackingUrlTemplate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.UrlCollection.trackingUrlTemplate: object expected");
                                message.trackingUrlTemplate = $root.google.protobuf.StringValue.fromObject(object.trackingUrlTemplate);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an UrlCollection message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.UrlCollection
                         * @static
                         * @param {google.ads.googleads.v1.common.UrlCollection} message UrlCollection
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UrlCollection.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.finalUrls = [];
                                object.finalMobileUrls = [];
                            }
                            if (options.defaults) {
                                object.urlCollectionId = null;
                                object.trackingUrlTemplate = null;
                            }
                            if (message.urlCollectionId != null && message.hasOwnProperty("urlCollectionId"))
                                object.urlCollectionId = $root.google.protobuf.StringValue.toObject(message.urlCollectionId, options);
                            if (message.finalUrls && message.finalUrls.length) {
                                object.finalUrls = [];
                                for (var j = 0; j < message.finalUrls.length; ++j)
                                    object.finalUrls[j] = $root.google.protobuf.StringValue.toObject(message.finalUrls[j], options);
                            }
                            if (message.finalMobileUrls && message.finalMobileUrls.length) {
                                object.finalMobileUrls = [];
                                for (var j = 0; j < message.finalMobileUrls.length; ++j)
                                    object.finalMobileUrls[j] = $root.google.protobuf.StringValue.toObject(message.finalMobileUrls[j], options);
                            }
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                object.trackingUrlTemplate = $root.google.protobuf.StringValue.toObject(message.trackingUrlTemplate, options);
                            return object;
                        };

                        /**
                         * Converts this UrlCollection to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.UrlCollection
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UrlCollection.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UrlCollection;
                    })();

                    common.SimilarUserListInfo = (function() {

                        /**
                         * Properties of a SimilarUserListInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ISimilarUserListInfo
                         * @property {google.protobuf.IStringValue|null} [seedUserList] SimilarUserListInfo seedUserList
                         */

                        /**
                         * Constructs a new SimilarUserListInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a SimilarUserListInfo.
                         * @implements ISimilarUserListInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ISimilarUserListInfo=} [properties] Properties to set
                         */
                        function SimilarUserListInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * SimilarUserListInfo seedUserList.
                         * @member {google.protobuf.IStringValue|null|undefined} seedUserList
                         * @memberof google.ads.googleads.v1.common.SimilarUserListInfo
                         * @instance
                         */
                        SimilarUserListInfo.prototype.seedUserList = null;

                        /**
                         * Creates a new SimilarUserListInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.SimilarUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ISimilarUserListInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.SimilarUserListInfo} SimilarUserListInfo instance
                         */
                        SimilarUserListInfo.create = function create(properties) {
                            return new SimilarUserListInfo(properties);
                        };

                        /**
                         * Encodes the specified SimilarUserListInfo message. Does not implicitly {@link google.ads.googleads.v1.common.SimilarUserListInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.SimilarUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ISimilarUserListInfo} message SimilarUserListInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SimilarUserListInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.seedUserList != null && message.hasOwnProperty("seedUserList"))
                                $root.google.protobuf.StringValue.encode(message.seedUserList, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified SimilarUserListInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.SimilarUserListInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.SimilarUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ISimilarUserListInfo} message SimilarUserListInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SimilarUserListInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SimilarUserListInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.SimilarUserListInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.SimilarUserListInfo} SimilarUserListInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SimilarUserListInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.SimilarUserListInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.seedUserList = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SimilarUserListInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.SimilarUserListInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.SimilarUserListInfo} SimilarUserListInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SimilarUserListInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SimilarUserListInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.SimilarUserListInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SimilarUserListInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.seedUserList != null && message.hasOwnProperty("seedUserList")) {
                                var error = $root.google.protobuf.StringValue.verify(message.seedUserList);
                                if (error)
                                    return "seedUserList." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a SimilarUserListInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.SimilarUserListInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.SimilarUserListInfo} SimilarUserListInfo
                         */
                        SimilarUserListInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.SimilarUserListInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.SimilarUserListInfo();
                            if (object.seedUserList != null) {
                                if (typeof object.seedUserList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.SimilarUserListInfo.seedUserList: object expected");
                                message.seedUserList = $root.google.protobuf.StringValue.fromObject(object.seedUserList);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a SimilarUserListInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.SimilarUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.SimilarUserListInfo} message SimilarUserListInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SimilarUserListInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.seedUserList = null;
                            if (message.seedUserList != null && message.hasOwnProperty("seedUserList"))
                                object.seedUserList = $root.google.protobuf.StringValue.toObject(message.seedUserList, options);
                            return object;
                        };

                        /**
                         * Converts this SimilarUserListInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.SimilarUserListInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SimilarUserListInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return SimilarUserListInfo;
                    })();

                    common.CrmBasedUserListInfo = (function() {

                        /**
                         * Properties of a CrmBasedUserListInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ICrmBasedUserListInfo
                         * @property {google.protobuf.IStringValue|null} [appId] CrmBasedUserListInfo appId
                         * @property {google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum.CustomerMatchUploadKeyType|null} [uploadKeyType] CrmBasedUserListInfo uploadKeyType
                         * @property {google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum.UserListCrmDataSourceType|null} [dataSourceType] CrmBasedUserListInfo dataSourceType
                         */

                        /**
                         * Constructs a new CrmBasedUserListInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a CrmBasedUserListInfo.
                         * @implements ICrmBasedUserListInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ICrmBasedUserListInfo=} [properties] Properties to set
                         */
                        function CrmBasedUserListInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CrmBasedUserListInfo appId.
                         * @member {google.protobuf.IStringValue|null|undefined} appId
                         * @memberof google.ads.googleads.v1.common.CrmBasedUserListInfo
                         * @instance
                         */
                        CrmBasedUserListInfo.prototype.appId = null;

                        /**
                         * CrmBasedUserListInfo uploadKeyType.
                         * @member {google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum.CustomerMatchUploadKeyType} uploadKeyType
                         * @memberof google.ads.googleads.v1.common.CrmBasedUserListInfo
                         * @instance
                         */
                        CrmBasedUserListInfo.prototype.uploadKeyType = 0;

                        /**
                         * CrmBasedUserListInfo dataSourceType.
                         * @member {google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum.UserListCrmDataSourceType} dataSourceType
                         * @memberof google.ads.googleads.v1.common.CrmBasedUserListInfo
                         * @instance
                         */
                        CrmBasedUserListInfo.prototype.dataSourceType = 0;

                        /**
                         * Creates a new CrmBasedUserListInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.CrmBasedUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ICrmBasedUserListInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.CrmBasedUserListInfo} CrmBasedUserListInfo instance
                         */
                        CrmBasedUserListInfo.create = function create(properties) {
                            return new CrmBasedUserListInfo(properties);
                        };

                        /**
                         * Encodes the specified CrmBasedUserListInfo message. Does not implicitly {@link google.ads.googleads.v1.common.CrmBasedUserListInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.CrmBasedUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ICrmBasedUserListInfo} message CrmBasedUserListInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CrmBasedUserListInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.appId != null && message.hasOwnProperty("appId"))
                                $root.google.protobuf.StringValue.encode(message.appId, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.uploadKeyType != null && message.hasOwnProperty("uploadKeyType"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.uploadKeyType);
                            if (message.dataSourceType != null && message.hasOwnProperty("dataSourceType"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.dataSourceType);
                            return writer;
                        };

                        /**
                         * Encodes the specified CrmBasedUserListInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.CrmBasedUserListInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.CrmBasedUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ICrmBasedUserListInfo} message CrmBasedUserListInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CrmBasedUserListInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CrmBasedUserListInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.CrmBasedUserListInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.CrmBasedUserListInfo} CrmBasedUserListInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CrmBasedUserListInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.CrmBasedUserListInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.appId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.uploadKeyType = reader.int32();
                                    break;
                                case 3:
                                    message.dataSourceType = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CrmBasedUserListInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.CrmBasedUserListInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.CrmBasedUserListInfo} CrmBasedUserListInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CrmBasedUserListInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CrmBasedUserListInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.CrmBasedUserListInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CrmBasedUserListInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.appId != null && message.hasOwnProperty("appId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.appId);
                                if (error)
                                    return "appId." + error;
                            }
                            if (message.uploadKeyType != null && message.hasOwnProperty("uploadKeyType"))
                                switch (message.uploadKeyType) {
                                default:
                                    return "uploadKeyType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.dataSourceType != null && message.hasOwnProperty("dataSourceType"))
                                switch (message.dataSourceType) {
                                default:
                                    return "dataSourceType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a CrmBasedUserListInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.CrmBasedUserListInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.CrmBasedUserListInfo} CrmBasedUserListInfo
                         */
                        CrmBasedUserListInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.CrmBasedUserListInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.CrmBasedUserListInfo();
                            if (object.appId != null) {
                                if (typeof object.appId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CrmBasedUserListInfo.appId: object expected");
                                message.appId = $root.google.protobuf.StringValue.fromObject(object.appId);
                            }
                            switch (object.uploadKeyType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.uploadKeyType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.uploadKeyType = 1;
                                break;
                            case "CONTACT_INFO":
                            case 2:
                                message.uploadKeyType = 2;
                                break;
                            case "CRM_ID":
                            case 3:
                                message.uploadKeyType = 3;
                                break;
                            case "MOBILE_ADVERTISING_ID":
                            case 4:
                                message.uploadKeyType = 4;
                                break;
                            }
                            switch (object.dataSourceType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.dataSourceType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.dataSourceType = 1;
                                break;
                            case "FIRST_PARTY":
                            case 2:
                                message.dataSourceType = 2;
                                break;
                            case "THIRD_PARTY_CREDIT_BUREAU":
                            case 3:
                                message.dataSourceType = 3;
                                break;
                            case "THIRD_PARTY_VOTER_FILE":
                            case 4:
                                message.dataSourceType = 4;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CrmBasedUserListInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.CrmBasedUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.CrmBasedUserListInfo} message CrmBasedUserListInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CrmBasedUserListInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.appId = null;
                                object.uploadKeyType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.dataSourceType = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.appId != null && message.hasOwnProperty("appId"))
                                object.appId = $root.google.protobuf.StringValue.toObject(message.appId, options);
                            if (message.uploadKeyType != null && message.hasOwnProperty("uploadKeyType"))
                                object.uploadKeyType = options.enums === String ? $root.google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum.CustomerMatchUploadKeyType[message.uploadKeyType] : message.uploadKeyType;
                            if (message.dataSourceType != null && message.hasOwnProperty("dataSourceType"))
                                object.dataSourceType = options.enums === String ? $root.google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum.UserListCrmDataSourceType[message.dataSourceType] : message.dataSourceType;
                            return object;
                        };

                        /**
                         * Converts this CrmBasedUserListInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.CrmBasedUserListInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CrmBasedUserListInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CrmBasedUserListInfo;
                    })();

                    common.UserListRuleInfo = (function() {

                        /**
                         * Properties of a UserListRuleInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IUserListRuleInfo
                         * @property {google.ads.googleads.v1.enums.UserListRuleTypeEnum.UserListRuleType|null} [ruleType] UserListRuleInfo ruleType
                         * @property {Array.<google.ads.googleads.v1.common.IUserListRuleItemGroupInfo>|null} [ruleItemGroups] UserListRuleInfo ruleItemGroups
                         */

                        /**
                         * Constructs a new UserListRuleInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a UserListRuleInfo.
                         * @implements IUserListRuleInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IUserListRuleInfo=} [properties] Properties to set
                         */
                        function UserListRuleInfo(properties) {
                            this.ruleItemGroups = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UserListRuleInfo ruleType.
                         * @member {google.ads.googleads.v1.enums.UserListRuleTypeEnum.UserListRuleType} ruleType
                         * @memberof google.ads.googleads.v1.common.UserListRuleInfo
                         * @instance
                         */
                        UserListRuleInfo.prototype.ruleType = 0;

                        /**
                         * UserListRuleInfo ruleItemGroups.
                         * @member {Array.<google.ads.googleads.v1.common.IUserListRuleItemGroupInfo>} ruleItemGroups
                         * @memberof google.ads.googleads.v1.common.UserListRuleInfo
                         * @instance
                         */
                        UserListRuleInfo.prototype.ruleItemGroups = $util.emptyArray;

                        /**
                         * Creates a new UserListRuleInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.UserListRuleInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListRuleInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.UserListRuleInfo} UserListRuleInfo instance
                         */
                        UserListRuleInfo.create = function create(properties) {
                            return new UserListRuleInfo(properties);
                        };

                        /**
                         * Encodes the specified UserListRuleInfo message. Does not implicitly {@link google.ads.googleads.v1.common.UserListRuleInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.UserListRuleInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListRuleInfo} message UserListRuleInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListRuleInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.ruleType != null && message.hasOwnProperty("ruleType"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.ruleType);
                            if (message.ruleItemGroups != null && message.ruleItemGroups.length)
                                for (var i = 0; i < message.ruleItemGroups.length; ++i)
                                    $root.google.ads.googleads.v1.common.UserListRuleItemGroupInfo.encode(message.ruleItemGroups[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListRuleInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.UserListRuleInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserListRuleInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListRuleInfo} message UserListRuleInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListRuleInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListRuleInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.UserListRuleInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.UserListRuleInfo} UserListRuleInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListRuleInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.UserListRuleInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.ruleType = reader.int32();
                                    break;
                                case 2:
                                    if (!(message.ruleItemGroups && message.ruleItemGroups.length))
                                        message.ruleItemGroups = [];
                                    message.ruleItemGroups.push($root.google.ads.googleads.v1.common.UserListRuleItemGroupInfo.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListRuleInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserListRuleInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.UserListRuleInfo} UserListRuleInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListRuleInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListRuleInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.UserListRuleInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListRuleInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.ruleType != null && message.hasOwnProperty("ruleType"))
                                switch (message.ruleType) {
                                default:
                                    return "ruleType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.ruleItemGroups != null && message.hasOwnProperty("ruleItemGroups")) {
                                if (!Array.isArray(message.ruleItemGroups))
                                    return "ruleItemGroups: array expected";
                                for (var i = 0; i < message.ruleItemGroups.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.UserListRuleItemGroupInfo.verify(message.ruleItemGroups[i]);
                                    if (error)
                                        return "ruleItemGroups." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a UserListRuleInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.UserListRuleInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.UserListRuleInfo} UserListRuleInfo
                         */
                        UserListRuleInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.UserListRuleInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.UserListRuleInfo();
                            switch (object.ruleType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.ruleType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.ruleType = 1;
                                break;
                            case "AND_OF_ORS":
                            case 2:
                                message.ruleType = 2;
                                break;
                            case "OR_OF_ANDS":
                            case 3:
                                message.ruleType = 3;
                                break;
                            }
                            if (object.ruleItemGroups) {
                                if (!Array.isArray(object.ruleItemGroups))
                                    throw TypeError(".google.ads.googleads.v1.common.UserListRuleInfo.ruleItemGroups: array expected");
                                message.ruleItemGroups = [];
                                for (var i = 0; i < object.ruleItemGroups.length; ++i) {
                                    if (typeof object.ruleItemGroups[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.UserListRuleInfo.ruleItemGroups: object expected");
                                    message.ruleItemGroups[i] = $root.google.ads.googleads.v1.common.UserListRuleItemGroupInfo.fromObject(object.ruleItemGroups[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a UserListRuleInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.UserListRuleInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.UserListRuleInfo} message UserListRuleInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListRuleInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.ruleItemGroups = [];
                            if (options.defaults)
                                object.ruleType = options.enums === String ? "UNSPECIFIED" : 0;
                            if (message.ruleType != null && message.hasOwnProperty("ruleType"))
                                object.ruleType = options.enums === String ? $root.google.ads.googleads.v1.enums.UserListRuleTypeEnum.UserListRuleType[message.ruleType] : message.ruleType;
                            if (message.ruleItemGroups && message.ruleItemGroups.length) {
                                object.ruleItemGroups = [];
                                for (var j = 0; j < message.ruleItemGroups.length; ++j)
                                    object.ruleItemGroups[j] = $root.google.ads.googleads.v1.common.UserListRuleItemGroupInfo.toObject(message.ruleItemGroups[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this UserListRuleInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.UserListRuleInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListRuleInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UserListRuleInfo;
                    })();

                    common.UserListRuleItemGroupInfo = (function() {

                        /**
                         * Properties of a UserListRuleItemGroupInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IUserListRuleItemGroupInfo
                         * @property {Array.<google.ads.googleads.v1.common.IUserListRuleItemInfo>|null} [ruleItems] UserListRuleItemGroupInfo ruleItems
                         */

                        /**
                         * Constructs a new UserListRuleItemGroupInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a UserListRuleItemGroupInfo.
                         * @implements IUserListRuleItemGroupInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IUserListRuleItemGroupInfo=} [properties] Properties to set
                         */
                        function UserListRuleItemGroupInfo(properties) {
                            this.ruleItems = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UserListRuleItemGroupInfo ruleItems.
                         * @member {Array.<google.ads.googleads.v1.common.IUserListRuleItemInfo>} ruleItems
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemGroupInfo
                         * @instance
                         */
                        UserListRuleItemGroupInfo.prototype.ruleItems = $util.emptyArray;

                        /**
                         * Creates a new UserListRuleItemGroupInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemGroupInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListRuleItemGroupInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.UserListRuleItemGroupInfo} UserListRuleItemGroupInfo instance
                         */
                        UserListRuleItemGroupInfo.create = function create(properties) {
                            return new UserListRuleItemGroupInfo(properties);
                        };

                        /**
                         * Encodes the specified UserListRuleItemGroupInfo message. Does not implicitly {@link google.ads.googleads.v1.common.UserListRuleItemGroupInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemGroupInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListRuleItemGroupInfo} message UserListRuleItemGroupInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListRuleItemGroupInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.ruleItems != null && message.ruleItems.length)
                                for (var i = 0; i < message.ruleItems.length; ++i)
                                    $root.google.ads.googleads.v1.common.UserListRuleItemInfo.encode(message.ruleItems[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListRuleItemGroupInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.UserListRuleItemGroupInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemGroupInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListRuleItemGroupInfo} message UserListRuleItemGroupInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListRuleItemGroupInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListRuleItemGroupInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemGroupInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.UserListRuleItemGroupInfo} UserListRuleItemGroupInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListRuleItemGroupInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.UserListRuleItemGroupInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.ruleItems && message.ruleItems.length))
                                        message.ruleItems = [];
                                    message.ruleItems.push($root.google.ads.googleads.v1.common.UserListRuleItemInfo.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListRuleItemGroupInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemGroupInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.UserListRuleItemGroupInfo} UserListRuleItemGroupInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListRuleItemGroupInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListRuleItemGroupInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemGroupInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListRuleItemGroupInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.ruleItems != null && message.hasOwnProperty("ruleItems")) {
                                if (!Array.isArray(message.ruleItems))
                                    return "ruleItems: array expected";
                                for (var i = 0; i < message.ruleItems.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.UserListRuleItemInfo.verify(message.ruleItems[i]);
                                    if (error)
                                        return "ruleItems." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a UserListRuleItemGroupInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemGroupInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.UserListRuleItemGroupInfo} UserListRuleItemGroupInfo
                         */
                        UserListRuleItemGroupInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.UserListRuleItemGroupInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.UserListRuleItemGroupInfo();
                            if (object.ruleItems) {
                                if (!Array.isArray(object.ruleItems))
                                    throw TypeError(".google.ads.googleads.v1.common.UserListRuleItemGroupInfo.ruleItems: array expected");
                                message.ruleItems = [];
                                for (var i = 0; i < object.ruleItems.length; ++i) {
                                    if (typeof object.ruleItems[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.UserListRuleItemGroupInfo.ruleItems: object expected");
                                    message.ruleItems[i] = $root.google.ads.googleads.v1.common.UserListRuleItemInfo.fromObject(object.ruleItems[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a UserListRuleItemGroupInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemGroupInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.UserListRuleItemGroupInfo} message UserListRuleItemGroupInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListRuleItemGroupInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.ruleItems = [];
                            if (message.ruleItems && message.ruleItems.length) {
                                object.ruleItems = [];
                                for (var j = 0; j < message.ruleItems.length; ++j)
                                    object.ruleItems[j] = $root.google.ads.googleads.v1.common.UserListRuleItemInfo.toObject(message.ruleItems[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this UserListRuleItemGroupInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemGroupInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListRuleItemGroupInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UserListRuleItemGroupInfo;
                    })();

                    common.UserListRuleItemInfo = (function() {

                        /**
                         * Properties of a UserListRuleItemInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IUserListRuleItemInfo
                         * @property {google.protobuf.IStringValue|null} [name] UserListRuleItemInfo name
                         * @property {google.ads.googleads.v1.common.IUserListNumberRuleItemInfo|null} [numberRuleItem] UserListRuleItemInfo numberRuleItem
                         * @property {google.ads.googleads.v1.common.IUserListStringRuleItemInfo|null} [stringRuleItem] UserListRuleItemInfo stringRuleItem
                         * @property {google.ads.googleads.v1.common.IUserListDateRuleItemInfo|null} [dateRuleItem] UserListRuleItemInfo dateRuleItem
                         */

                        /**
                         * Constructs a new UserListRuleItemInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a UserListRuleItemInfo.
                         * @implements IUserListRuleItemInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IUserListRuleItemInfo=} [properties] Properties to set
                         */
                        function UserListRuleItemInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UserListRuleItemInfo name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemInfo
                         * @instance
                         */
                        UserListRuleItemInfo.prototype.name = null;

                        /**
                         * UserListRuleItemInfo numberRuleItem.
                         * @member {google.ads.googleads.v1.common.IUserListNumberRuleItemInfo|null|undefined} numberRuleItem
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemInfo
                         * @instance
                         */
                        UserListRuleItemInfo.prototype.numberRuleItem = null;

                        /**
                         * UserListRuleItemInfo stringRuleItem.
                         * @member {google.ads.googleads.v1.common.IUserListStringRuleItemInfo|null|undefined} stringRuleItem
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemInfo
                         * @instance
                         */
                        UserListRuleItemInfo.prototype.stringRuleItem = null;

                        /**
                         * UserListRuleItemInfo dateRuleItem.
                         * @member {google.ads.googleads.v1.common.IUserListDateRuleItemInfo|null|undefined} dateRuleItem
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemInfo
                         * @instance
                         */
                        UserListRuleItemInfo.prototype.dateRuleItem = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * UserListRuleItemInfo ruleItem.
                         * @member {"numberRuleItem"|"stringRuleItem"|"dateRuleItem"|undefined} ruleItem
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemInfo
                         * @instance
                         */
                        Object.defineProperty(UserListRuleItemInfo.prototype, "ruleItem", {
                            get: $util.oneOfGetter($oneOfFields = ["numberRuleItem", "stringRuleItem", "dateRuleItem"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new UserListRuleItemInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListRuleItemInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.UserListRuleItemInfo} UserListRuleItemInfo instance
                         */
                        UserListRuleItemInfo.create = function create(properties) {
                            return new UserListRuleItemInfo(properties);
                        };

                        /**
                         * Encodes the specified UserListRuleItemInfo message. Does not implicitly {@link google.ads.googleads.v1.common.UserListRuleItemInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListRuleItemInfo} message UserListRuleItemInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListRuleItemInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.numberRuleItem != null && message.hasOwnProperty("numberRuleItem"))
                                $root.google.ads.googleads.v1.common.UserListNumberRuleItemInfo.encode(message.numberRuleItem, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.stringRuleItem != null && message.hasOwnProperty("stringRuleItem"))
                                $root.google.ads.googleads.v1.common.UserListStringRuleItemInfo.encode(message.stringRuleItem, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.dateRuleItem != null && message.hasOwnProperty("dateRuleItem"))
                                $root.google.ads.googleads.v1.common.UserListDateRuleItemInfo.encode(message.dateRuleItem, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListRuleItemInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.UserListRuleItemInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListRuleItemInfo} message UserListRuleItemInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListRuleItemInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListRuleItemInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.UserListRuleItemInfo} UserListRuleItemInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListRuleItemInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.UserListRuleItemInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.numberRuleItem = $root.google.ads.googleads.v1.common.UserListNumberRuleItemInfo.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.stringRuleItem = $root.google.ads.googleads.v1.common.UserListStringRuleItemInfo.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.dateRuleItem = $root.google.ads.googleads.v1.common.UserListDateRuleItemInfo.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListRuleItemInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.UserListRuleItemInfo} UserListRuleItemInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListRuleItemInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListRuleItemInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListRuleItemInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.numberRuleItem != null && message.hasOwnProperty("numberRuleItem")) {
                                properties.ruleItem = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.UserListNumberRuleItemInfo.verify(message.numberRuleItem);
                                    if (error)
                                        return "numberRuleItem." + error;
                                }
                            }
                            if (message.stringRuleItem != null && message.hasOwnProperty("stringRuleItem")) {
                                if (properties.ruleItem === 1)
                                    return "ruleItem: multiple values";
                                properties.ruleItem = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.UserListStringRuleItemInfo.verify(message.stringRuleItem);
                                    if (error)
                                        return "stringRuleItem." + error;
                                }
                            }
                            if (message.dateRuleItem != null && message.hasOwnProperty("dateRuleItem")) {
                                if (properties.ruleItem === 1)
                                    return "ruleItem: multiple values";
                                properties.ruleItem = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.UserListDateRuleItemInfo.verify(message.dateRuleItem);
                                    if (error)
                                        return "dateRuleItem." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a UserListRuleItemInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.UserListRuleItemInfo} UserListRuleItemInfo
                         */
                        UserListRuleItemInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.UserListRuleItemInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.UserListRuleItemInfo();
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.UserListRuleItemInfo.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            if (object.numberRuleItem != null) {
                                if (typeof object.numberRuleItem !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.UserListRuleItemInfo.numberRuleItem: object expected");
                                message.numberRuleItem = $root.google.ads.googleads.v1.common.UserListNumberRuleItemInfo.fromObject(object.numberRuleItem);
                            }
                            if (object.stringRuleItem != null) {
                                if (typeof object.stringRuleItem !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.UserListRuleItemInfo.stringRuleItem: object expected");
                                message.stringRuleItem = $root.google.ads.googleads.v1.common.UserListStringRuleItemInfo.fromObject(object.stringRuleItem);
                            }
                            if (object.dateRuleItem != null) {
                                if (typeof object.dateRuleItem !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.UserListRuleItemInfo.dateRuleItem: object expected");
                                message.dateRuleItem = $root.google.ads.googleads.v1.common.UserListDateRuleItemInfo.fromObject(object.dateRuleItem);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a UserListRuleItemInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.UserListRuleItemInfo} message UserListRuleItemInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListRuleItemInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = null;
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.numberRuleItem != null && message.hasOwnProperty("numberRuleItem")) {
                                object.numberRuleItem = $root.google.ads.googleads.v1.common.UserListNumberRuleItemInfo.toObject(message.numberRuleItem, options);
                                if (options.oneofs)
                                    object.ruleItem = "numberRuleItem";
                            }
                            if (message.stringRuleItem != null && message.hasOwnProperty("stringRuleItem")) {
                                object.stringRuleItem = $root.google.ads.googleads.v1.common.UserListStringRuleItemInfo.toObject(message.stringRuleItem, options);
                                if (options.oneofs)
                                    object.ruleItem = "stringRuleItem";
                            }
                            if (message.dateRuleItem != null && message.hasOwnProperty("dateRuleItem")) {
                                object.dateRuleItem = $root.google.ads.googleads.v1.common.UserListDateRuleItemInfo.toObject(message.dateRuleItem, options);
                                if (options.oneofs)
                                    object.ruleItem = "dateRuleItem";
                            }
                            return object;
                        };

                        /**
                         * Converts this UserListRuleItemInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.UserListRuleItemInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListRuleItemInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UserListRuleItemInfo;
                    })();

                    common.UserListDateRuleItemInfo = (function() {

                        /**
                         * Properties of a UserListDateRuleItemInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IUserListDateRuleItemInfo
                         * @property {google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum.UserListDateRuleItemOperator|null} [operator] UserListDateRuleItemInfo operator
                         * @property {google.protobuf.IStringValue|null} [value] UserListDateRuleItemInfo value
                         * @property {google.protobuf.IInt64Value|null} [offsetInDays] UserListDateRuleItemInfo offsetInDays
                         */

                        /**
                         * Constructs a new UserListDateRuleItemInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a UserListDateRuleItemInfo.
                         * @implements IUserListDateRuleItemInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IUserListDateRuleItemInfo=} [properties] Properties to set
                         */
                        function UserListDateRuleItemInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UserListDateRuleItemInfo operator.
                         * @member {google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum.UserListDateRuleItemOperator} operator
                         * @memberof google.ads.googleads.v1.common.UserListDateRuleItemInfo
                         * @instance
                         */
                        UserListDateRuleItemInfo.prototype.operator = 0;

                        /**
                         * UserListDateRuleItemInfo value.
                         * @member {google.protobuf.IStringValue|null|undefined} value
                         * @memberof google.ads.googleads.v1.common.UserListDateRuleItemInfo
                         * @instance
                         */
                        UserListDateRuleItemInfo.prototype.value = null;

                        /**
                         * UserListDateRuleItemInfo offsetInDays.
                         * @member {google.protobuf.IInt64Value|null|undefined} offsetInDays
                         * @memberof google.ads.googleads.v1.common.UserListDateRuleItemInfo
                         * @instance
                         */
                        UserListDateRuleItemInfo.prototype.offsetInDays = null;

                        /**
                         * Creates a new UserListDateRuleItemInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.UserListDateRuleItemInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListDateRuleItemInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.UserListDateRuleItemInfo} UserListDateRuleItemInfo instance
                         */
                        UserListDateRuleItemInfo.create = function create(properties) {
                            return new UserListDateRuleItemInfo(properties);
                        };

                        /**
                         * Encodes the specified UserListDateRuleItemInfo message. Does not implicitly {@link google.ads.googleads.v1.common.UserListDateRuleItemInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.UserListDateRuleItemInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListDateRuleItemInfo} message UserListDateRuleItemInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListDateRuleItemInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.operator);
                            if (message.value != null && message.hasOwnProperty("value"))
                                $root.google.protobuf.StringValue.encode(message.value, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.offsetInDays != null && message.hasOwnProperty("offsetInDays"))
                                $root.google.protobuf.Int64Value.encode(message.offsetInDays, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListDateRuleItemInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.UserListDateRuleItemInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserListDateRuleItemInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListDateRuleItemInfo} message UserListDateRuleItemInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListDateRuleItemInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListDateRuleItemInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.UserListDateRuleItemInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.UserListDateRuleItemInfo} UserListDateRuleItemInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListDateRuleItemInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.UserListDateRuleItemInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.operator = reader.int32();
                                    break;
                                case 2:
                                    message.value = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.offsetInDays = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListDateRuleItemInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserListDateRuleItemInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.UserListDateRuleItemInfo} UserListDateRuleItemInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListDateRuleItemInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListDateRuleItemInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.UserListDateRuleItemInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListDateRuleItemInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                switch (message.operator) {
                                default:
                                    return "operator: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                var error = $root.google.protobuf.StringValue.verify(message.value);
                                if (error)
                                    return "value." + error;
                            }
                            if (message.offsetInDays != null && message.hasOwnProperty("offsetInDays")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.offsetInDays);
                                if (error)
                                    return "offsetInDays." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a UserListDateRuleItemInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.UserListDateRuleItemInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.UserListDateRuleItemInfo} UserListDateRuleItemInfo
                         */
                        UserListDateRuleItemInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.UserListDateRuleItemInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.UserListDateRuleItemInfo();
                            switch (object.operator) {
                            case "UNSPECIFIED":
                            case 0:
                                message.operator = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.operator = 1;
                                break;
                            case "EQUALS":
                            case 2:
                                message.operator = 2;
                                break;
                            case "NOT_EQUALS":
                            case 3:
                                message.operator = 3;
                                break;
                            case "BEFORE":
                            case 4:
                                message.operator = 4;
                                break;
                            case "AFTER":
                            case 5:
                                message.operator = 5;
                                break;
                            }
                            if (object.value != null) {
                                if (typeof object.value !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.UserListDateRuleItemInfo.value: object expected");
                                message.value = $root.google.protobuf.StringValue.fromObject(object.value);
                            }
                            if (object.offsetInDays != null) {
                                if (typeof object.offsetInDays !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.UserListDateRuleItemInfo.offsetInDays: object expected");
                                message.offsetInDays = $root.google.protobuf.Int64Value.fromObject(object.offsetInDays);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a UserListDateRuleItemInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.UserListDateRuleItemInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.UserListDateRuleItemInfo} message UserListDateRuleItemInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListDateRuleItemInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.operator = options.enums === String ? "UNSPECIFIED" : 0;
                                object.value = null;
                                object.offsetInDays = null;
                            }
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                object.operator = options.enums === String ? $root.google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum.UserListDateRuleItemOperator[message.operator] : message.operator;
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = $root.google.protobuf.StringValue.toObject(message.value, options);
                            if (message.offsetInDays != null && message.hasOwnProperty("offsetInDays"))
                                object.offsetInDays = $root.google.protobuf.Int64Value.toObject(message.offsetInDays, options);
                            return object;
                        };

                        /**
                         * Converts this UserListDateRuleItemInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.UserListDateRuleItemInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListDateRuleItemInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UserListDateRuleItemInfo;
                    })();

                    common.UserListNumberRuleItemInfo = (function() {

                        /**
                         * Properties of a UserListNumberRuleItemInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IUserListNumberRuleItemInfo
                         * @property {google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum.UserListNumberRuleItemOperator|null} [operator] UserListNumberRuleItemInfo operator
                         * @property {google.protobuf.IDoubleValue|null} [value] UserListNumberRuleItemInfo value
                         */

                        /**
                         * Constructs a new UserListNumberRuleItemInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a UserListNumberRuleItemInfo.
                         * @implements IUserListNumberRuleItemInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IUserListNumberRuleItemInfo=} [properties] Properties to set
                         */
                        function UserListNumberRuleItemInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UserListNumberRuleItemInfo operator.
                         * @member {google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum.UserListNumberRuleItemOperator} operator
                         * @memberof google.ads.googleads.v1.common.UserListNumberRuleItemInfo
                         * @instance
                         */
                        UserListNumberRuleItemInfo.prototype.operator = 0;

                        /**
                         * UserListNumberRuleItemInfo value.
                         * @member {google.protobuf.IDoubleValue|null|undefined} value
                         * @memberof google.ads.googleads.v1.common.UserListNumberRuleItemInfo
                         * @instance
                         */
                        UserListNumberRuleItemInfo.prototype.value = null;

                        /**
                         * Creates a new UserListNumberRuleItemInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.UserListNumberRuleItemInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListNumberRuleItemInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.UserListNumberRuleItemInfo} UserListNumberRuleItemInfo instance
                         */
                        UserListNumberRuleItemInfo.create = function create(properties) {
                            return new UserListNumberRuleItemInfo(properties);
                        };

                        /**
                         * Encodes the specified UserListNumberRuleItemInfo message. Does not implicitly {@link google.ads.googleads.v1.common.UserListNumberRuleItemInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.UserListNumberRuleItemInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListNumberRuleItemInfo} message UserListNumberRuleItemInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListNumberRuleItemInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.operator);
                            if (message.value != null && message.hasOwnProperty("value"))
                                $root.google.protobuf.DoubleValue.encode(message.value, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListNumberRuleItemInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.UserListNumberRuleItemInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserListNumberRuleItemInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListNumberRuleItemInfo} message UserListNumberRuleItemInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListNumberRuleItemInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListNumberRuleItemInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.UserListNumberRuleItemInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.UserListNumberRuleItemInfo} UserListNumberRuleItemInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListNumberRuleItemInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.UserListNumberRuleItemInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.operator = reader.int32();
                                    break;
                                case 2:
                                    message.value = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListNumberRuleItemInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserListNumberRuleItemInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.UserListNumberRuleItemInfo} UserListNumberRuleItemInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListNumberRuleItemInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListNumberRuleItemInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.UserListNumberRuleItemInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListNumberRuleItemInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                switch (message.operator) {
                                default:
                                    return "operator: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.value);
                                if (error)
                                    return "value." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a UserListNumberRuleItemInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.UserListNumberRuleItemInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.UserListNumberRuleItemInfo} UserListNumberRuleItemInfo
                         */
                        UserListNumberRuleItemInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.UserListNumberRuleItemInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.UserListNumberRuleItemInfo();
                            switch (object.operator) {
                            case "UNSPECIFIED":
                            case 0:
                                message.operator = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.operator = 1;
                                break;
                            case "GREATER_THAN":
                            case 2:
                                message.operator = 2;
                                break;
                            case "GREATER_THAN_OR_EQUAL":
                            case 3:
                                message.operator = 3;
                                break;
                            case "EQUALS":
                            case 4:
                                message.operator = 4;
                                break;
                            case "NOT_EQUALS":
                            case 5:
                                message.operator = 5;
                                break;
                            case "LESS_THAN":
                            case 6:
                                message.operator = 6;
                                break;
                            case "LESS_THAN_OR_EQUAL":
                            case 7:
                                message.operator = 7;
                                break;
                            }
                            if (object.value != null) {
                                if (typeof object.value !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.UserListNumberRuleItemInfo.value: object expected");
                                message.value = $root.google.protobuf.DoubleValue.fromObject(object.value);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a UserListNumberRuleItemInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.UserListNumberRuleItemInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.UserListNumberRuleItemInfo} message UserListNumberRuleItemInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListNumberRuleItemInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.operator = options.enums === String ? "UNSPECIFIED" : 0;
                                object.value = null;
                            }
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                object.operator = options.enums === String ? $root.google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum.UserListNumberRuleItemOperator[message.operator] : message.operator;
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = $root.google.protobuf.DoubleValue.toObject(message.value, options);
                            return object;
                        };

                        /**
                         * Converts this UserListNumberRuleItemInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.UserListNumberRuleItemInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListNumberRuleItemInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UserListNumberRuleItemInfo;
                    })();

                    common.UserListStringRuleItemInfo = (function() {

                        /**
                         * Properties of a UserListStringRuleItemInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IUserListStringRuleItemInfo
                         * @property {google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum.UserListStringRuleItemOperator|null} [operator] UserListStringRuleItemInfo operator
                         * @property {google.protobuf.IStringValue|null} [value] UserListStringRuleItemInfo value
                         */

                        /**
                         * Constructs a new UserListStringRuleItemInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a UserListStringRuleItemInfo.
                         * @implements IUserListStringRuleItemInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IUserListStringRuleItemInfo=} [properties] Properties to set
                         */
                        function UserListStringRuleItemInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UserListStringRuleItemInfo operator.
                         * @member {google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum.UserListStringRuleItemOperator} operator
                         * @memberof google.ads.googleads.v1.common.UserListStringRuleItemInfo
                         * @instance
                         */
                        UserListStringRuleItemInfo.prototype.operator = 0;

                        /**
                         * UserListStringRuleItemInfo value.
                         * @member {google.protobuf.IStringValue|null|undefined} value
                         * @memberof google.ads.googleads.v1.common.UserListStringRuleItemInfo
                         * @instance
                         */
                        UserListStringRuleItemInfo.prototype.value = null;

                        /**
                         * Creates a new UserListStringRuleItemInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.UserListStringRuleItemInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListStringRuleItemInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.UserListStringRuleItemInfo} UserListStringRuleItemInfo instance
                         */
                        UserListStringRuleItemInfo.create = function create(properties) {
                            return new UserListStringRuleItemInfo(properties);
                        };

                        /**
                         * Encodes the specified UserListStringRuleItemInfo message. Does not implicitly {@link google.ads.googleads.v1.common.UserListStringRuleItemInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.UserListStringRuleItemInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListStringRuleItemInfo} message UserListStringRuleItemInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListStringRuleItemInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.operator);
                            if (message.value != null && message.hasOwnProperty("value"))
                                $root.google.protobuf.StringValue.encode(message.value, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListStringRuleItemInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.UserListStringRuleItemInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserListStringRuleItemInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListStringRuleItemInfo} message UserListStringRuleItemInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListStringRuleItemInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListStringRuleItemInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.UserListStringRuleItemInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.UserListStringRuleItemInfo} UserListStringRuleItemInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListStringRuleItemInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.UserListStringRuleItemInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.operator = reader.int32();
                                    break;
                                case 2:
                                    message.value = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListStringRuleItemInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserListStringRuleItemInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.UserListStringRuleItemInfo} UserListStringRuleItemInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListStringRuleItemInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListStringRuleItemInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.UserListStringRuleItemInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListStringRuleItemInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                switch (message.operator) {
                                default:
                                    return "operator: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                    break;
                                }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                var error = $root.google.protobuf.StringValue.verify(message.value);
                                if (error)
                                    return "value." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a UserListStringRuleItemInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.UserListStringRuleItemInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.UserListStringRuleItemInfo} UserListStringRuleItemInfo
                         */
                        UserListStringRuleItemInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.UserListStringRuleItemInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.UserListStringRuleItemInfo();
                            switch (object.operator) {
                            case "UNSPECIFIED":
                            case 0:
                                message.operator = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.operator = 1;
                                break;
                            case "CONTAINS":
                            case 2:
                                message.operator = 2;
                                break;
                            case "EQUALS":
                            case 3:
                                message.operator = 3;
                                break;
                            case "STARTS_WITH":
                            case 4:
                                message.operator = 4;
                                break;
                            case "ENDS_WITH":
                            case 5:
                                message.operator = 5;
                                break;
                            case "NOT_EQUALS":
                            case 6:
                                message.operator = 6;
                                break;
                            case "NOT_CONTAINS":
                            case 7:
                                message.operator = 7;
                                break;
                            case "NOT_STARTS_WITH":
                            case 8:
                                message.operator = 8;
                                break;
                            case "NOT_ENDS_WITH":
                            case 9:
                                message.operator = 9;
                                break;
                            }
                            if (object.value != null) {
                                if (typeof object.value !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.UserListStringRuleItemInfo.value: object expected");
                                message.value = $root.google.protobuf.StringValue.fromObject(object.value);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a UserListStringRuleItemInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.UserListStringRuleItemInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.UserListStringRuleItemInfo} message UserListStringRuleItemInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListStringRuleItemInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.operator = options.enums === String ? "UNSPECIFIED" : 0;
                                object.value = null;
                            }
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                object.operator = options.enums === String ? $root.google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum.UserListStringRuleItemOperator[message.operator] : message.operator;
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = $root.google.protobuf.StringValue.toObject(message.value, options);
                            return object;
                        };

                        /**
                         * Converts this UserListStringRuleItemInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.UserListStringRuleItemInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListStringRuleItemInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UserListStringRuleItemInfo;
                    })();

                    common.CombinedRuleUserListInfo = (function() {

                        /**
                         * Properties of a CombinedRuleUserListInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ICombinedRuleUserListInfo
                         * @property {google.ads.googleads.v1.common.IUserListRuleInfo|null} [leftOperand] CombinedRuleUserListInfo leftOperand
                         * @property {google.ads.googleads.v1.common.IUserListRuleInfo|null} [rightOperand] CombinedRuleUserListInfo rightOperand
                         * @property {google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum.UserListCombinedRuleOperator|null} [ruleOperator] CombinedRuleUserListInfo ruleOperator
                         */

                        /**
                         * Constructs a new CombinedRuleUserListInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a CombinedRuleUserListInfo.
                         * @implements ICombinedRuleUserListInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ICombinedRuleUserListInfo=} [properties] Properties to set
                         */
                        function CombinedRuleUserListInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CombinedRuleUserListInfo leftOperand.
                         * @member {google.ads.googleads.v1.common.IUserListRuleInfo|null|undefined} leftOperand
                         * @memberof google.ads.googleads.v1.common.CombinedRuleUserListInfo
                         * @instance
                         */
                        CombinedRuleUserListInfo.prototype.leftOperand = null;

                        /**
                         * CombinedRuleUserListInfo rightOperand.
                         * @member {google.ads.googleads.v1.common.IUserListRuleInfo|null|undefined} rightOperand
                         * @memberof google.ads.googleads.v1.common.CombinedRuleUserListInfo
                         * @instance
                         */
                        CombinedRuleUserListInfo.prototype.rightOperand = null;

                        /**
                         * CombinedRuleUserListInfo ruleOperator.
                         * @member {google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum.UserListCombinedRuleOperator} ruleOperator
                         * @memberof google.ads.googleads.v1.common.CombinedRuleUserListInfo
                         * @instance
                         */
                        CombinedRuleUserListInfo.prototype.ruleOperator = 0;

                        /**
                         * Creates a new CombinedRuleUserListInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.CombinedRuleUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ICombinedRuleUserListInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.CombinedRuleUserListInfo} CombinedRuleUserListInfo instance
                         */
                        CombinedRuleUserListInfo.create = function create(properties) {
                            return new CombinedRuleUserListInfo(properties);
                        };

                        /**
                         * Encodes the specified CombinedRuleUserListInfo message. Does not implicitly {@link google.ads.googleads.v1.common.CombinedRuleUserListInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.CombinedRuleUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ICombinedRuleUserListInfo} message CombinedRuleUserListInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CombinedRuleUserListInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.leftOperand != null && message.hasOwnProperty("leftOperand"))
                                $root.google.ads.googleads.v1.common.UserListRuleInfo.encode(message.leftOperand, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.rightOperand != null && message.hasOwnProperty("rightOperand"))
                                $root.google.ads.googleads.v1.common.UserListRuleInfo.encode(message.rightOperand, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.ruleOperator != null && message.hasOwnProperty("ruleOperator"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.ruleOperator);
                            return writer;
                        };

                        /**
                         * Encodes the specified CombinedRuleUserListInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.CombinedRuleUserListInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.CombinedRuleUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ICombinedRuleUserListInfo} message CombinedRuleUserListInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CombinedRuleUserListInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CombinedRuleUserListInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.CombinedRuleUserListInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.CombinedRuleUserListInfo} CombinedRuleUserListInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CombinedRuleUserListInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.CombinedRuleUserListInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.leftOperand = $root.google.ads.googleads.v1.common.UserListRuleInfo.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.rightOperand = $root.google.ads.googleads.v1.common.UserListRuleInfo.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.ruleOperator = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CombinedRuleUserListInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.CombinedRuleUserListInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.CombinedRuleUserListInfo} CombinedRuleUserListInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CombinedRuleUserListInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CombinedRuleUserListInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.CombinedRuleUserListInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CombinedRuleUserListInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.leftOperand != null && message.hasOwnProperty("leftOperand")) {
                                var error = $root.google.ads.googleads.v1.common.UserListRuleInfo.verify(message.leftOperand);
                                if (error)
                                    return "leftOperand." + error;
                            }
                            if (message.rightOperand != null && message.hasOwnProperty("rightOperand")) {
                                var error = $root.google.ads.googleads.v1.common.UserListRuleInfo.verify(message.rightOperand);
                                if (error)
                                    return "rightOperand." + error;
                            }
                            if (message.ruleOperator != null && message.hasOwnProperty("ruleOperator"))
                                switch (message.ruleOperator) {
                                default:
                                    return "ruleOperator: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a CombinedRuleUserListInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.CombinedRuleUserListInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.CombinedRuleUserListInfo} CombinedRuleUserListInfo
                         */
                        CombinedRuleUserListInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.CombinedRuleUserListInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.CombinedRuleUserListInfo();
                            if (object.leftOperand != null) {
                                if (typeof object.leftOperand !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CombinedRuleUserListInfo.leftOperand: object expected");
                                message.leftOperand = $root.google.ads.googleads.v1.common.UserListRuleInfo.fromObject(object.leftOperand);
                            }
                            if (object.rightOperand != null) {
                                if (typeof object.rightOperand !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.CombinedRuleUserListInfo.rightOperand: object expected");
                                message.rightOperand = $root.google.ads.googleads.v1.common.UserListRuleInfo.fromObject(object.rightOperand);
                            }
                            switch (object.ruleOperator) {
                            case "UNSPECIFIED":
                            case 0:
                                message.ruleOperator = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.ruleOperator = 1;
                                break;
                            case "AND":
                            case 2:
                                message.ruleOperator = 2;
                                break;
                            case "AND_NOT":
                            case 3:
                                message.ruleOperator = 3;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CombinedRuleUserListInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.CombinedRuleUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.CombinedRuleUserListInfo} message CombinedRuleUserListInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CombinedRuleUserListInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.leftOperand = null;
                                object.rightOperand = null;
                                object.ruleOperator = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.leftOperand != null && message.hasOwnProperty("leftOperand"))
                                object.leftOperand = $root.google.ads.googleads.v1.common.UserListRuleInfo.toObject(message.leftOperand, options);
                            if (message.rightOperand != null && message.hasOwnProperty("rightOperand"))
                                object.rightOperand = $root.google.ads.googleads.v1.common.UserListRuleInfo.toObject(message.rightOperand, options);
                            if (message.ruleOperator != null && message.hasOwnProperty("ruleOperator"))
                                object.ruleOperator = options.enums === String ? $root.google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum.UserListCombinedRuleOperator[message.ruleOperator] : message.ruleOperator;
                            return object;
                        };

                        /**
                         * Converts this CombinedRuleUserListInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.CombinedRuleUserListInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CombinedRuleUserListInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CombinedRuleUserListInfo;
                    })();

                    common.DateSpecificRuleUserListInfo = (function() {

                        /**
                         * Properties of a DateSpecificRuleUserListInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IDateSpecificRuleUserListInfo
                         * @property {google.ads.googleads.v1.common.IUserListRuleInfo|null} [rule] DateSpecificRuleUserListInfo rule
                         * @property {google.protobuf.IStringValue|null} [startDate] DateSpecificRuleUserListInfo startDate
                         * @property {google.protobuf.IStringValue|null} [endDate] DateSpecificRuleUserListInfo endDate
                         */

                        /**
                         * Constructs a new DateSpecificRuleUserListInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a DateSpecificRuleUserListInfo.
                         * @implements IDateSpecificRuleUserListInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IDateSpecificRuleUserListInfo=} [properties] Properties to set
                         */
                        function DateSpecificRuleUserListInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * DateSpecificRuleUserListInfo rule.
                         * @member {google.ads.googleads.v1.common.IUserListRuleInfo|null|undefined} rule
                         * @memberof google.ads.googleads.v1.common.DateSpecificRuleUserListInfo
                         * @instance
                         */
                        DateSpecificRuleUserListInfo.prototype.rule = null;

                        /**
                         * DateSpecificRuleUserListInfo startDate.
                         * @member {google.protobuf.IStringValue|null|undefined} startDate
                         * @memberof google.ads.googleads.v1.common.DateSpecificRuleUserListInfo
                         * @instance
                         */
                        DateSpecificRuleUserListInfo.prototype.startDate = null;

                        /**
                         * DateSpecificRuleUserListInfo endDate.
                         * @member {google.protobuf.IStringValue|null|undefined} endDate
                         * @memberof google.ads.googleads.v1.common.DateSpecificRuleUserListInfo
                         * @instance
                         */
                        DateSpecificRuleUserListInfo.prototype.endDate = null;

                        /**
                         * Creates a new DateSpecificRuleUserListInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.DateSpecificRuleUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IDateSpecificRuleUserListInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.DateSpecificRuleUserListInfo} DateSpecificRuleUserListInfo instance
                         */
                        DateSpecificRuleUserListInfo.create = function create(properties) {
                            return new DateSpecificRuleUserListInfo(properties);
                        };

                        /**
                         * Encodes the specified DateSpecificRuleUserListInfo message. Does not implicitly {@link google.ads.googleads.v1.common.DateSpecificRuleUserListInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.DateSpecificRuleUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IDateSpecificRuleUserListInfo} message DateSpecificRuleUserListInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DateSpecificRuleUserListInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.rule != null && message.hasOwnProperty("rule"))
                                $root.google.ads.googleads.v1.common.UserListRuleInfo.encode(message.rule, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.startDate != null && message.hasOwnProperty("startDate"))
                                $root.google.protobuf.StringValue.encode(message.startDate, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.endDate != null && message.hasOwnProperty("endDate"))
                                $root.google.protobuf.StringValue.encode(message.endDate, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified DateSpecificRuleUserListInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.DateSpecificRuleUserListInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.DateSpecificRuleUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IDateSpecificRuleUserListInfo} message DateSpecificRuleUserListInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DateSpecificRuleUserListInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DateSpecificRuleUserListInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.DateSpecificRuleUserListInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.DateSpecificRuleUserListInfo} DateSpecificRuleUserListInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DateSpecificRuleUserListInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.DateSpecificRuleUserListInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.rule = $root.google.ads.googleads.v1.common.UserListRuleInfo.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.startDate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.endDate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DateSpecificRuleUserListInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.DateSpecificRuleUserListInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.DateSpecificRuleUserListInfo} DateSpecificRuleUserListInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DateSpecificRuleUserListInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DateSpecificRuleUserListInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.DateSpecificRuleUserListInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DateSpecificRuleUserListInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.rule != null && message.hasOwnProperty("rule")) {
                                var error = $root.google.ads.googleads.v1.common.UserListRuleInfo.verify(message.rule);
                                if (error)
                                    return "rule." + error;
                            }
                            if (message.startDate != null && message.hasOwnProperty("startDate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.startDate);
                                if (error)
                                    return "startDate." + error;
                            }
                            if (message.endDate != null && message.hasOwnProperty("endDate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.endDate);
                                if (error)
                                    return "endDate." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a DateSpecificRuleUserListInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.DateSpecificRuleUserListInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.DateSpecificRuleUserListInfo} DateSpecificRuleUserListInfo
                         */
                        DateSpecificRuleUserListInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.DateSpecificRuleUserListInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.DateSpecificRuleUserListInfo();
                            if (object.rule != null) {
                                if (typeof object.rule !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.DateSpecificRuleUserListInfo.rule: object expected");
                                message.rule = $root.google.ads.googleads.v1.common.UserListRuleInfo.fromObject(object.rule);
                            }
                            if (object.startDate != null) {
                                if (typeof object.startDate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.DateSpecificRuleUserListInfo.startDate: object expected");
                                message.startDate = $root.google.protobuf.StringValue.fromObject(object.startDate);
                            }
                            if (object.endDate != null) {
                                if (typeof object.endDate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.DateSpecificRuleUserListInfo.endDate: object expected");
                                message.endDate = $root.google.protobuf.StringValue.fromObject(object.endDate);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a DateSpecificRuleUserListInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.DateSpecificRuleUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.DateSpecificRuleUserListInfo} message DateSpecificRuleUserListInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DateSpecificRuleUserListInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.rule = null;
                                object.startDate = null;
                                object.endDate = null;
                            }
                            if (message.rule != null && message.hasOwnProperty("rule"))
                                object.rule = $root.google.ads.googleads.v1.common.UserListRuleInfo.toObject(message.rule, options);
                            if (message.startDate != null && message.hasOwnProperty("startDate"))
                                object.startDate = $root.google.protobuf.StringValue.toObject(message.startDate, options);
                            if (message.endDate != null && message.hasOwnProperty("endDate"))
                                object.endDate = $root.google.protobuf.StringValue.toObject(message.endDate, options);
                            return object;
                        };

                        /**
                         * Converts this DateSpecificRuleUserListInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.DateSpecificRuleUserListInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DateSpecificRuleUserListInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return DateSpecificRuleUserListInfo;
                    })();

                    common.ExpressionRuleUserListInfo = (function() {

                        /**
                         * Properties of an ExpressionRuleUserListInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IExpressionRuleUserListInfo
                         * @property {google.ads.googleads.v1.common.IUserListRuleInfo|null} [rule] ExpressionRuleUserListInfo rule
                         */

                        /**
                         * Constructs a new ExpressionRuleUserListInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents an ExpressionRuleUserListInfo.
                         * @implements IExpressionRuleUserListInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IExpressionRuleUserListInfo=} [properties] Properties to set
                         */
                        function ExpressionRuleUserListInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ExpressionRuleUserListInfo rule.
                         * @member {google.ads.googleads.v1.common.IUserListRuleInfo|null|undefined} rule
                         * @memberof google.ads.googleads.v1.common.ExpressionRuleUserListInfo
                         * @instance
                         */
                        ExpressionRuleUserListInfo.prototype.rule = null;

                        /**
                         * Creates a new ExpressionRuleUserListInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.ExpressionRuleUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IExpressionRuleUserListInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.ExpressionRuleUserListInfo} ExpressionRuleUserListInfo instance
                         */
                        ExpressionRuleUserListInfo.create = function create(properties) {
                            return new ExpressionRuleUserListInfo(properties);
                        };

                        /**
                         * Encodes the specified ExpressionRuleUserListInfo message. Does not implicitly {@link google.ads.googleads.v1.common.ExpressionRuleUserListInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.ExpressionRuleUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IExpressionRuleUserListInfo} message ExpressionRuleUserListInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExpressionRuleUserListInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.rule != null && message.hasOwnProperty("rule"))
                                $root.google.ads.googleads.v1.common.UserListRuleInfo.encode(message.rule, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ExpressionRuleUserListInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.ExpressionRuleUserListInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.ExpressionRuleUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IExpressionRuleUserListInfo} message ExpressionRuleUserListInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExpressionRuleUserListInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ExpressionRuleUserListInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.ExpressionRuleUserListInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.ExpressionRuleUserListInfo} ExpressionRuleUserListInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExpressionRuleUserListInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.ExpressionRuleUserListInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.rule = $root.google.ads.googleads.v1.common.UserListRuleInfo.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ExpressionRuleUserListInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.ExpressionRuleUserListInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.ExpressionRuleUserListInfo} ExpressionRuleUserListInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExpressionRuleUserListInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ExpressionRuleUserListInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.ExpressionRuleUserListInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExpressionRuleUserListInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.rule != null && message.hasOwnProperty("rule")) {
                                var error = $root.google.ads.googleads.v1.common.UserListRuleInfo.verify(message.rule);
                                if (error)
                                    return "rule." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an ExpressionRuleUserListInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.ExpressionRuleUserListInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.ExpressionRuleUserListInfo} ExpressionRuleUserListInfo
                         */
                        ExpressionRuleUserListInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.ExpressionRuleUserListInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.ExpressionRuleUserListInfo();
                            if (object.rule != null) {
                                if (typeof object.rule !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.ExpressionRuleUserListInfo.rule: object expected");
                                message.rule = $root.google.ads.googleads.v1.common.UserListRuleInfo.fromObject(object.rule);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an ExpressionRuleUserListInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.ExpressionRuleUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ExpressionRuleUserListInfo} message ExpressionRuleUserListInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExpressionRuleUserListInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.rule = null;
                            if (message.rule != null && message.hasOwnProperty("rule"))
                                object.rule = $root.google.ads.googleads.v1.common.UserListRuleInfo.toObject(message.rule, options);
                            return object;
                        };

                        /**
                         * Converts this ExpressionRuleUserListInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.ExpressionRuleUserListInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExpressionRuleUserListInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ExpressionRuleUserListInfo;
                    })();

                    common.RuleBasedUserListInfo = (function() {

                        /**
                         * Properties of a RuleBasedUserListInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IRuleBasedUserListInfo
                         * @property {google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum.UserListPrepopulationStatus|null} [prepopulationStatus] RuleBasedUserListInfo prepopulationStatus
                         * @property {google.ads.googleads.v1.common.ICombinedRuleUserListInfo|null} [combinedRuleUserList] RuleBasedUserListInfo combinedRuleUserList
                         * @property {google.ads.googleads.v1.common.IDateSpecificRuleUserListInfo|null} [dateSpecificRuleUserList] RuleBasedUserListInfo dateSpecificRuleUserList
                         * @property {google.ads.googleads.v1.common.IExpressionRuleUserListInfo|null} [expressionRuleUserList] RuleBasedUserListInfo expressionRuleUserList
                         */

                        /**
                         * Constructs a new RuleBasedUserListInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a RuleBasedUserListInfo.
                         * @implements IRuleBasedUserListInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IRuleBasedUserListInfo=} [properties] Properties to set
                         */
                        function RuleBasedUserListInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * RuleBasedUserListInfo prepopulationStatus.
                         * @member {google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum.UserListPrepopulationStatus} prepopulationStatus
                         * @memberof google.ads.googleads.v1.common.RuleBasedUserListInfo
                         * @instance
                         */
                        RuleBasedUserListInfo.prototype.prepopulationStatus = 0;

                        /**
                         * RuleBasedUserListInfo combinedRuleUserList.
                         * @member {google.ads.googleads.v1.common.ICombinedRuleUserListInfo|null|undefined} combinedRuleUserList
                         * @memberof google.ads.googleads.v1.common.RuleBasedUserListInfo
                         * @instance
                         */
                        RuleBasedUserListInfo.prototype.combinedRuleUserList = null;

                        /**
                         * RuleBasedUserListInfo dateSpecificRuleUserList.
                         * @member {google.ads.googleads.v1.common.IDateSpecificRuleUserListInfo|null|undefined} dateSpecificRuleUserList
                         * @memberof google.ads.googleads.v1.common.RuleBasedUserListInfo
                         * @instance
                         */
                        RuleBasedUserListInfo.prototype.dateSpecificRuleUserList = null;

                        /**
                         * RuleBasedUserListInfo expressionRuleUserList.
                         * @member {google.ads.googleads.v1.common.IExpressionRuleUserListInfo|null|undefined} expressionRuleUserList
                         * @memberof google.ads.googleads.v1.common.RuleBasedUserListInfo
                         * @instance
                         */
                        RuleBasedUserListInfo.prototype.expressionRuleUserList = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * RuleBasedUserListInfo ruleBasedUserList.
                         * @member {"combinedRuleUserList"|"dateSpecificRuleUserList"|"expressionRuleUserList"|undefined} ruleBasedUserList
                         * @memberof google.ads.googleads.v1.common.RuleBasedUserListInfo
                         * @instance
                         */
                        Object.defineProperty(RuleBasedUserListInfo.prototype, "ruleBasedUserList", {
                            get: $util.oneOfGetter($oneOfFields = ["combinedRuleUserList", "dateSpecificRuleUserList", "expressionRuleUserList"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new RuleBasedUserListInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.RuleBasedUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IRuleBasedUserListInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.RuleBasedUserListInfo} RuleBasedUserListInfo instance
                         */
                        RuleBasedUserListInfo.create = function create(properties) {
                            return new RuleBasedUserListInfo(properties);
                        };

                        /**
                         * Encodes the specified RuleBasedUserListInfo message. Does not implicitly {@link google.ads.googleads.v1.common.RuleBasedUserListInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.RuleBasedUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IRuleBasedUserListInfo} message RuleBasedUserListInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RuleBasedUserListInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.prepopulationStatus != null && message.hasOwnProperty("prepopulationStatus"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.prepopulationStatus);
                            if (message.combinedRuleUserList != null && message.hasOwnProperty("combinedRuleUserList"))
                                $root.google.ads.googleads.v1.common.CombinedRuleUserListInfo.encode(message.combinedRuleUserList, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.dateSpecificRuleUserList != null && message.hasOwnProperty("dateSpecificRuleUserList"))
                                $root.google.ads.googleads.v1.common.DateSpecificRuleUserListInfo.encode(message.dateSpecificRuleUserList, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.expressionRuleUserList != null && message.hasOwnProperty("expressionRuleUserList"))
                                $root.google.ads.googleads.v1.common.ExpressionRuleUserListInfo.encode(message.expressionRuleUserList, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified RuleBasedUserListInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.RuleBasedUserListInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.RuleBasedUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IRuleBasedUserListInfo} message RuleBasedUserListInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RuleBasedUserListInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a RuleBasedUserListInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.RuleBasedUserListInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.RuleBasedUserListInfo} RuleBasedUserListInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RuleBasedUserListInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.RuleBasedUserListInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.prepopulationStatus = reader.int32();
                                    break;
                                case 2:
                                    message.combinedRuleUserList = $root.google.ads.googleads.v1.common.CombinedRuleUserListInfo.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.dateSpecificRuleUserList = $root.google.ads.googleads.v1.common.DateSpecificRuleUserListInfo.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.expressionRuleUserList = $root.google.ads.googleads.v1.common.ExpressionRuleUserListInfo.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a RuleBasedUserListInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.RuleBasedUserListInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.RuleBasedUserListInfo} RuleBasedUserListInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RuleBasedUserListInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a RuleBasedUserListInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.RuleBasedUserListInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RuleBasedUserListInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.prepopulationStatus != null && message.hasOwnProperty("prepopulationStatus"))
                                switch (message.prepopulationStatus) {
                                default:
                                    return "prepopulationStatus: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.combinedRuleUserList != null && message.hasOwnProperty("combinedRuleUserList")) {
                                properties.ruleBasedUserList = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.CombinedRuleUserListInfo.verify(message.combinedRuleUserList);
                                    if (error)
                                        return "combinedRuleUserList." + error;
                                }
                            }
                            if (message.dateSpecificRuleUserList != null && message.hasOwnProperty("dateSpecificRuleUserList")) {
                                if (properties.ruleBasedUserList === 1)
                                    return "ruleBasedUserList: multiple values";
                                properties.ruleBasedUserList = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.DateSpecificRuleUserListInfo.verify(message.dateSpecificRuleUserList);
                                    if (error)
                                        return "dateSpecificRuleUserList." + error;
                                }
                            }
                            if (message.expressionRuleUserList != null && message.hasOwnProperty("expressionRuleUserList")) {
                                if (properties.ruleBasedUserList === 1)
                                    return "ruleBasedUserList: multiple values";
                                properties.ruleBasedUserList = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ExpressionRuleUserListInfo.verify(message.expressionRuleUserList);
                                    if (error)
                                        return "expressionRuleUserList." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a RuleBasedUserListInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.RuleBasedUserListInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.RuleBasedUserListInfo} RuleBasedUserListInfo
                         */
                        RuleBasedUserListInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.RuleBasedUserListInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.RuleBasedUserListInfo();
                            switch (object.prepopulationStatus) {
                            case "UNSPECIFIED":
                            case 0:
                                message.prepopulationStatus = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.prepopulationStatus = 1;
                                break;
                            case "REQUESTED":
                            case 2:
                                message.prepopulationStatus = 2;
                                break;
                            case "FINISHED":
                            case 3:
                                message.prepopulationStatus = 3;
                                break;
                            case "FAILED":
                            case 4:
                                message.prepopulationStatus = 4;
                                break;
                            }
                            if (object.combinedRuleUserList != null) {
                                if (typeof object.combinedRuleUserList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.RuleBasedUserListInfo.combinedRuleUserList: object expected");
                                message.combinedRuleUserList = $root.google.ads.googleads.v1.common.CombinedRuleUserListInfo.fromObject(object.combinedRuleUserList);
                            }
                            if (object.dateSpecificRuleUserList != null) {
                                if (typeof object.dateSpecificRuleUserList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.RuleBasedUserListInfo.dateSpecificRuleUserList: object expected");
                                message.dateSpecificRuleUserList = $root.google.ads.googleads.v1.common.DateSpecificRuleUserListInfo.fromObject(object.dateSpecificRuleUserList);
                            }
                            if (object.expressionRuleUserList != null) {
                                if (typeof object.expressionRuleUserList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.RuleBasedUserListInfo.expressionRuleUserList: object expected");
                                message.expressionRuleUserList = $root.google.ads.googleads.v1.common.ExpressionRuleUserListInfo.fromObject(object.expressionRuleUserList);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a RuleBasedUserListInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.RuleBasedUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.RuleBasedUserListInfo} message RuleBasedUserListInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RuleBasedUserListInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.prepopulationStatus = options.enums === String ? "UNSPECIFIED" : 0;
                            if (message.prepopulationStatus != null && message.hasOwnProperty("prepopulationStatus"))
                                object.prepopulationStatus = options.enums === String ? $root.google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum.UserListPrepopulationStatus[message.prepopulationStatus] : message.prepopulationStatus;
                            if (message.combinedRuleUserList != null && message.hasOwnProperty("combinedRuleUserList")) {
                                object.combinedRuleUserList = $root.google.ads.googleads.v1.common.CombinedRuleUserListInfo.toObject(message.combinedRuleUserList, options);
                                if (options.oneofs)
                                    object.ruleBasedUserList = "combinedRuleUserList";
                            }
                            if (message.dateSpecificRuleUserList != null && message.hasOwnProperty("dateSpecificRuleUserList")) {
                                object.dateSpecificRuleUserList = $root.google.ads.googleads.v1.common.DateSpecificRuleUserListInfo.toObject(message.dateSpecificRuleUserList, options);
                                if (options.oneofs)
                                    object.ruleBasedUserList = "dateSpecificRuleUserList";
                            }
                            if (message.expressionRuleUserList != null && message.hasOwnProperty("expressionRuleUserList")) {
                                object.expressionRuleUserList = $root.google.ads.googleads.v1.common.ExpressionRuleUserListInfo.toObject(message.expressionRuleUserList, options);
                                if (options.oneofs)
                                    object.ruleBasedUserList = "expressionRuleUserList";
                            }
                            return object;
                        };

                        /**
                         * Converts this RuleBasedUserListInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.RuleBasedUserListInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RuleBasedUserListInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return RuleBasedUserListInfo;
                    })();

                    common.LogicalUserListInfo = (function() {

                        /**
                         * Properties of a LogicalUserListInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ILogicalUserListInfo
                         * @property {Array.<google.ads.googleads.v1.common.IUserListLogicalRuleInfo>|null} [rules] LogicalUserListInfo rules
                         */

                        /**
                         * Constructs a new LogicalUserListInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a LogicalUserListInfo.
                         * @implements ILogicalUserListInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ILogicalUserListInfo=} [properties] Properties to set
                         */
                        function LogicalUserListInfo(properties) {
                            this.rules = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * LogicalUserListInfo rules.
                         * @member {Array.<google.ads.googleads.v1.common.IUserListLogicalRuleInfo>} rules
                         * @memberof google.ads.googleads.v1.common.LogicalUserListInfo
                         * @instance
                         */
                        LogicalUserListInfo.prototype.rules = $util.emptyArray;

                        /**
                         * Creates a new LogicalUserListInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.LogicalUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILogicalUserListInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.LogicalUserListInfo} LogicalUserListInfo instance
                         */
                        LogicalUserListInfo.create = function create(properties) {
                            return new LogicalUserListInfo(properties);
                        };

                        /**
                         * Encodes the specified LogicalUserListInfo message. Does not implicitly {@link google.ads.googleads.v1.common.LogicalUserListInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.LogicalUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILogicalUserListInfo} message LogicalUserListInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LogicalUserListInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.rules != null && message.rules.length)
                                for (var i = 0; i < message.rules.length; ++i)
                                    $root.google.ads.googleads.v1.common.UserListLogicalRuleInfo.encode(message.rules[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified LogicalUserListInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.LogicalUserListInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.LogicalUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILogicalUserListInfo} message LogicalUserListInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LogicalUserListInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LogicalUserListInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.LogicalUserListInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.LogicalUserListInfo} LogicalUserListInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LogicalUserListInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.LogicalUserListInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.rules && message.rules.length))
                                        message.rules = [];
                                    message.rules.push($root.google.ads.googleads.v1.common.UserListLogicalRuleInfo.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LogicalUserListInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.LogicalUserListInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.LogicalUserListInfo} LogicalUserListInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LogicalUserListInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LogicalUserListInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.LogicalUserListInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LogicalUserListInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.rules != null && message.hasOwnProperty("rules")) {
                                if (!Array.isArray(message.rules))
                                    return "rules: array expected";
                                for (var i = 0; i < message.rules.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.UserListLogicalRuleInfo.verify(message.rules[i]);
                                    if (error)
                                        return "rules." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a LogicalUserListInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.LogicalUserListInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.LogicalUserListInfo} LogicalUserListInfo
                         */
                        LogicalUserListInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.LogicalUserListInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.LogicalUserListInfo();
                            if (object.rules) {
                                if (!Array.isArray(object.rules))
                                    throw TypeError(".google.ads.googleads.v1.common.LogicalUserListInfo.rules: array expected");
                                message.rules = [];
                                for (var i = 0; i < object.rules.length; ++i) {
                                    if (typeof object.rules[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.LogicalUserListInfo.rules: object expected");
                                    message.rules[i] = $root.google.ads.googleads.v1.common.UserListLogicalRuleInfo.fromObject(object.rules[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a LogicalUserListInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.LogicalUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.LogicalUserListInfo} message LogicalUserListInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LogicalUserListInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.rules = [];
                            if (message.rules && message.rules.length) {
                                object.rules = [];
                                for (var j = 0; j < message.rules.length; ++j)
                                    object.rules[j] = $root.google.ads.googleads.v1.common.UserListLogicalRuleInfo.toObject(message.rules[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this LogicalUserListInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.LogicalUserListInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LogicalUserListInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return LogicalUserListInfo;
                    })();

                    common.UserListLogicalRuleInfo = (function() {

                        /**
                         * Properties of a UserListLogicalRuleInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IUserListLogicalRuleInfo
                         * @property {google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum.UserListLogicalRuleOperator|null} [operator] UserListLogicalRuleInfo operator
                         * @property {Array.<google.ads.googleads.v1.common.ILogicalUserListOperandInfo>|null} [ruleOperands] UserListLogicalRuleInfo ruleOperands
                         */

                        /**
                         * Constructs a new UserListLogicalRuleInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a UserListLogicalRuleInfo.
                         * @implements IUserListLogicalRuleInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IUserListLogicalRuleInfo=} [properties] Properties to set
                         */
                        function UserListLogicalRuleInfo(properties) {
                            this.ruleOperands = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UserListLogicalRuleInfo operator.
                         * @member {google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum.UserListLogicalRuleOperator} operator
                         * @memberof google.ads.googleads.v1.common.UserListLogicalRuleInfo
                         * @instance
                         */
                        UserListLogicalRuleInfo.prototype.operator = 0;

                        /**
                         * UserListLogicalRuleInfo ruleOperands.
                         * @member {Array.<google.ads.googleads.v1.common.ILogicalUserListOperandInfo>} ruleOperands
                         * @memberof google.ads.googleads.v1.common.UserListLogicalRuleInfo
                         * @instance
                         */
                        UserListLogicalRuleInfo.prototype.ruleOperands = $util.emptyArray;

                        /**
                         * Creates a new UserListLogicalRuleInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.UserListLogicalRuleInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListLogicalRuleInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.UserListLogicalRuleInfo} UserListLogicalRuleInfo instance
                         */
                        UserListLogicalRuleInfo.create = function create(properties) {
                            return new UserListLogicalRuleInfo(properties);
                        };

                        /**
                         * Encodes the specified UserListLogicalRuleInfo message. Does not implicitly {@link google.ads.googleads.v1.common.UserListLogicalRuleInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.UserListLogicalRuleInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListLogicalRuleInfo} message UserListLogicalRuleInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListLogicalRuleInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.operator);
                            if (message.ruleOperands != null && message.ruleOperands.length)
                                for (var i = 0; i < message.ruleOperands.length; ++i)
                                    $root.google.ads.googleads.v1.common.LogicalUserListOperandInfo.encode(message.ruleOperands[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListLogicalRuleInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.UserListLogicalRuleInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserListLogicalRuleInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListLogicalRuleInfo} message UserListLogicalRuleInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListLogicalRuleInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListLogicalRuleInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.UserListLogicalRuleInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.UserListLogicalRuleInfo} UserListLogicalRuleInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListLogicalRuleInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.UserListLogicalRuleInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.operator = reader.int32();
                                    break;
                                case 2:
                                    if (!(message.ruleOperands && message.ruleOperands.length))
                                        message.ruleOperands = [];
                                    message.ruleOperands.push($root.google.ads.googleads.v1.common.LogicalUserListOperandInfo.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListLogicalRuleInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserListLogicalRuleInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.UserListLogicalRuleInfo} UserListLogicalRuleInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListLogicalRuleInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListLogicalRuleInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.UserListLogicalRuleInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListLogicalRuleInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                switch (message.operator) {
                                default:
                                    return "operator: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.ruleOperands != null && message.hasOwnProperty("ruleOperands")) {
                                if (!Array.isArray(message.ruleOperands))
                                    return "ruleOperands: array expected";
                                for (var i = 0; i < message.ruleOperands.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.LogicalUserListOperandInfo.verify(message.ruleOperands[i]);
                                    if (error)
                                        return "ruleOperands." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a UserListLogicalRuleInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.UserListLogicalRuleInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.UserListLogicalRuleInfo} UserListLogicalRuleInfo
                         */
                        UserListLogicalRuleInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.UserListLogicalRuleInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.UserListLogicalRuleInfo();
                            switch (object.operator) {
                            case "UNSPECIFIED":
                            case 0:
                                message.operator = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.operator = 1;
                                break;
                            case "ALL":
                            case 2:
                                message.operator = 2;
                                break;
                            case "ANY":
                            case 3:
                                message.operator = 3;
                                break;
                            case "NONE":
                            case 4:
                                message.operator = 4;
                                break;
                            }
                            if (object.ruleOperands) {
                                if (!Array.isArray(object.ruleOperands))
                                    throw TypeError(".google.ads.googleads.v1.common.UserListLogicalRuleInfo.ruleOperands: array expected");
                                message.ruleOperands = [];
                                for (var i = 0; i < object.ruleOperands.length; ++i) {
                                    if (typeof object.ruleOperands[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.UserListLogicalRuleInfo.ruleOperands: object expected");
                                    message.ruleOperands[i] = $root.google.ads.googleads.v1.common.LogicalUserListOperandInfo.fromObject(object.ruleOperands[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a UserListLogicalRuleInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.UserListLogicalRuleInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.UserListLogicalRuleInfo} message UserListLogicalRuleInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListLogicalRuleInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.ruleOperands = [];
                            if (options.defaults)
                                object.operator = options.enums === String ? "UNSPECIFIED" : 0;
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                object.operator = options.enums === String ? $root.google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum.UserListLogicalRuleOperator[message.operator] : message.operator;
                            if (message.ruleOperands && message.ruleOperands.length) {
                                object.ruleOperands = [];
                                for (var j = 0; j < message.ruleOperands.length; ++j)
                                    object.ruleOperands[j] = $root.google.ads.googleads.v1.common.LogicalUserListOperandInfo.toObject(message.ruleOperands[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this UserListLogicalRuleInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.UserListLogicalRuleInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListLogicalRuleInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UserListLogicalRuleInfo;
                    })();

                    common.LogicalUserListOperandInfo = (function() {

                        /**
                         * Properties of a LogicalUserListOperandInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface ILogicalUserListOperandInfo
                         * @property {google.protobuf.IStringValue|null} [userList] LogicalUserListOperandInfo userList
                         */

                        /**
                         * Constructs a new LogicalUserListOperandInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a LogicalUserListOperandInfo.
                         * @implements ILogicalUserListOperandInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.ILogicalUserListOperandInfo=} [properties] Properties to set
                         */
                        function LogicalUserListOperandInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * LogicalUserListOperandInfo userList.
                         * @member {google.protobuf.IStringValue|null|undefined} userList
                         * @memberof google.ads.googleads.v1.common.LogicalUserListOperandInfo
                         * @instance
                         */
                        LogicalUserListOperandInfo.prototype.userList = null;

                        /**
                         * Creates a new LogicalUserListOperandInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.LogicalUserListOperandInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILogicalUserListOperandInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.LogicalUserListOperandInfo} LogicalUserListOperandInfo instance
                         */
                        LogicalUserListOperandInfo.create = function create(properties) {
                            return new LogicalUserListOperandInfo(properties);
                        };

                        /**
                         * Encodes the specified LogicalUserListOperandInfo message. Does not implicitly {@link google.ads.googleads.v1.common.LogicalUserListOperandInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.LogicalUserListOperandInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILogicalUserListOperandInfo} message LogicalUserListOperandInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LogicalUserListOperandInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.userList != null && message.hasOwnProperty("userList"))
                                $root.google.protobuf.StringValue.encode(message.userList, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified LogicalUserListOperandInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.LogicalUserListOperandInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.LogicalUserListOperandInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.ILogicalUserListOperandInfo} message LogicalUserListOperandInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LogicalUserListOperandInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LogicalUserListOperandInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.LogicalUserListOperandInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.LogicalUserListOperandInfo} LogicalUserListOperandInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LogicalUserListOperandInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.LogicalUserListOperandInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.userList = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LogicalUserListOperandInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.LogicalUserListOperandInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.LogicalUserListOperandInfo} LogicalUserListOperandInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LogicalUserListOperandInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LogicalUserListOperandInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.LogicalUserListOperandInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LogicalUserListOperandInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.userList != null && message.hasOwnProperty("userList")) {
                                var error = $root.google.protobuf.StringValue.verify(message.userList);
                                if (error)
                                    return "userList." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a LogicalUserListOperandInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.LogicalUserListOperandInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.LogicalUserListOperandInfo} LogicalUserListOperandInfo
                         */
                        LogicalUserListOperandInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.LogicalUserListOperandInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.LogicalUserListOperandInfo();
                            if (object.userList != null) {
                                if (typeof object.userList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.LogicalUserListOperandInfo.userList: object expected");
                                message.userList = $root.google.protobuf.StringValue.fromObject(object.userList);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a LogicalUserListOperandInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.LogicalUserListOperandInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.LogicalUserListOperandInfo} message LogicalUserListOperandInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LogicalUserListOperandInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.userList = null;
                            if (message.userList != null && message.hasOwnProperty("userList"))
                                object.userList = $root.google.protobuf.StringValue.toObject(message.userList, options);
                            return object;
                        };

                        /**
                         * Converts this LogicalUserListOperandInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.LogicalUserListOperandInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LogicalUserListOperandInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return LogicalUserListOperandInfo;
                    })();

                    common.BasicUserListInfo = (function() {

                        /**
                         * Properties of a BasicUserListInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IBasicUserListInfo
                         * @property {Array.<google.ads.googleads.v1.common.IUserListActionInfo>|null} [actions] BasicUserListInfo actions
                         */

                        /**
                         * Constructs a new BasicUserListInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a BasicUserListInfo.
                         * @implements IBasicUserListInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IBasicUserListInfo=} [properties] Properties to set
                         */
                        function BasicUserListInfo(properties) {
                            this.actions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * BasicUserListInfo actions.
                         * @member {Array.<google.ads.googleads.v1.common.IUserListActionInfo>} actions
                         * @memberof google.ads.googleads.v1.common.BasicUserListInfo
                         * @instance
                         */
                        BasicUserListInfo.prototype.actions = $util.emptyArray;

                        /**
                         * Creates a new BasicUserListInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.BasicUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IBasicUserListInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.BasicUserListInfo} BasicUserListInfo instance
                         */
                        BasicUserListInfo.create = function create(properties) {
                            return new BasicUserListInfo(properties);
                        };

                        /**
                         * Encodes the specified BasicUserListInfo message. Does not implicitly {@link google.ads.googleads.v1.common.BasicUserListInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.BasicUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IBasicUserListInfo} message BasicUserListInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BasicUserListInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.actions != null && message.actions.length)
                                for (var i = 0; i < message.actions.length; ++i)
                                    $root.google.ads.googleads.v1.common.UserListActionInfo.encode(message.actions[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified BasicUserListInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.BasicUserListInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.BasicUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IBasicUserListInfo} message BasicUserListInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BasicUserListInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BasicUserListInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.BasicUserListInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.BasicUserListInfo} BasicUserListInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BasicUserListInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.BasicUserListInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.actions && message.actions.length))
                                        message.actions = [];
                                    message.actions.push($root.google.ads.googleads.v1.common.UserListActionInfo.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BasicUserListInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.BasicUserListInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.BasicUserListInfo} BasicUserListInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BasicUserListInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BasicUserListInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.BasicUserListInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BasicUserListInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.actions != null && message.hasOwnProperty("actions")) {
                                if (!Array.isArray(message.actions))
                                    return "actions: array expected";
                                for (var i = 0; i < message.actions.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.UserListActionInfo.verify(message.actions[i]);
                                    if (error)
                                        return "actions." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a BasicUserListInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.BasicUserListInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.BasicUserListInfo} BasicUserListInfo
                         */
                        BasicUserListInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.BasicUserListInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.BasicUserListInfo();
                            if (object.actions) {
                                if (!Array.isArray(object.actions))
                                    throw TypeError(".google.ads.googleads.v1.common.BasicUserListInfo.actions: array expected");
                                message.actions = [];
                                for (var i = 0; i < object.actions.length; ++i) {
                                    if (typeof object.actions[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.common.BasicUserListInfo.actions: object expected");
                                    message.actions[i] = $root.google.ads.googleads.v1.common.UserListActionInfo.fromObject(object.actions[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a BasicUserListInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.BasicUserListInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.BasicUserListInfo} message BasicUserListInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BasicUserListInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.actions = [];
                            if (message.actions && message.actions.length) {
                                object.actions = [];
                                for (var j = 0; j < message.actions.length; ++j)
                                    object.actions[j] = $root.google.ads.googleads.v1.common.UserListActionInfo.toObject(message.actions[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this BasicUserListInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.BasicUserListInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BasicUserListInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return BasicUserListInfo;
                    })();

                    common.UserListActionInfo = (function() {

                        /**
                         * Properties of a UserListActionInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IUserListActionInfo
                         * @property {google.protobuf.IStringValue|null} [conversionAction] UserListActionInfo conversionAction
                         * @property {google.protobuf.IStringValue|null} [remarketingAction] UserListActionInfo remarketingAction
                         */

                        /**
                         * Constructs a new UserListActionInfo.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a UserListActionInfo.
                         * @implements IUserListActionInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IUserListActionInfo=} [properties] Properties to set
                         */
                        function UserListActionInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UserListActionInfo conversionAction.
                         * @member {google.protobuf.IStringValue|null|undefined} conversionAction
                         * @memberof google.ads.googleads.v1.common.UserListActionInfo
                         * @instance
                         */
                        UserListActionInfo.prototype.conversionAction = null;

                        /**
                         * UserListActionInfo remarketingAction.
                         * @member {google.protobuf.IStringValue|null|undefined} remarketingAction
                         * @memberof google.ads.googleads.v1.common.UserListActionInfo
                         * @instance
                         */
                        UserListActionInfo.prototype.remarketingAction = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * UserListActionInfo userListAction.
                         * @member {"conversionAction"|"remarketingAction"|undefined} userListAction
                         * @memberof google.ads.googleads.v1.common.UserListActionInfo
                         * @instance
                         */
                        Object.defineProperty(UserListActionInfo.prototype, "userListAction", {
                            get: $util.oneOfGetter($oneOfFields = ["conversionAction", "remarketingAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new UserListActionInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.UserListActionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListActionInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.UserListActionInfo} UserListActionInfo instance
                         */
                        UserListActionInfo.create = function create(properties) {
                            return new UserListActionInfo(properties);
                        };

                        /**
                         * Encodes the specified UserListActionInfo message. Does not implicitly {@link google.ads.googleads.v1.common.UserListActionInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.UserListActionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListActionInfo} message UserListActionInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListActionInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                $root.google.protobuf.StringValue.encode(message.conversionAction, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.remarketingAction != null && message.hasOwnProperty("remarketingAction"))
                                $root.google.protobuf.StringValue.encode(message.remarketingAction, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListActionInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.UserListActionInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserListActionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.IUserListActionInfo} message UserListActionInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListActionInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListActionInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.UserListActionInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.UserListActionInfo} UserListActionInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListActionInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.UserListActionInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.conversionAction = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.remarketingAction = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListActionInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.UserListActionInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.UserListActionInfo} UserListActionInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListActionInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListActionInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.UserListActionInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListActionInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction")) {
                                properties.userListAction = 1;
                                {
                                    var error = $root.google.protobuf.StringValue.verify(message.conversionAction);
                                    if (error)
                                        return "conversionAction." + error;
                                }
                            }
                            if (message.remarketingAction != null && message.hasOwnProperty("remarketingAction")) {
                                if (properties.userListAction === 1)
                                    return "userListAction: multiple values";
                                properties.userListAction = 1;
                                {
                                    var error = $root.google.protobuf.StringValue.verify(message.remarketingAction);
                                    if (error)
                                        return "remarketingAction." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a UserListActionInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.UserListActionInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.UserListActionInfo} UserListActionInfo
                         */
                        UserListActionInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.UserListActionInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.UserListActionInfo();
                            if (object.conversionAction != null) {
                                if (typeof object.conversionAction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.UserListActionInfo.conversionAction: object expected");
                                message.conversionAction = $root.google.protobuf.StringValue.fromObject(object.conversionAction);
                            }
                            if (object.remarketingAction != null) {
                                if (typeof object.remarketingAction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.common.UserListActionInfo.remarketingAction: object expected");
                                message.remarketingAction = $root.google.protobuf.StringValue.fromObject(object.remarketingAction);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a UserListActionInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.UserListActionInfo
                         * @static
                         * @param {google.ads.googleads.v1.common.UserListActionInfo} message UserListActionInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListActionInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction")) {
                                object.conversionAction = $root.google.protobuf.StringValue.toObject(message.conversionAction, options);
                                if (options.oneofs)
                                    object.userListAction = "conversionAction";
                            }
                            if (message.remarketingAction != null && message.hasOwnProperty("remarketingAction")) {
                                object.remarketingAction = $root.google.protobuf.StringValue.toObject(message.remarketingAction, options);
                                if (options.oneofs)
                                    object.userListAction = "remarketingAction";
                            }
                            return object;
                        };

                        /**
                         * Converts this UserListActionInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.UserListActionInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListActionInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UserListActionInfo;
                    })();

                    common.Value = (function() {

                        /**
                         * Properties of a Value.
                         * @memberof google.ads.googleads.v1.common
                         * @interface IValue
                         * @property {boolean|null} [booleanValue] Value booleanValue
                         * @property {number|Long|null} [int64Value] Value int64Value
                         * @property {number|null} [floatValue] Value floatValue
                         * @property {number|null} [doubleValue] Value doubleValue
                         * @property {string|null} [stringValue] Value stringValue
                         */

                        /**
                         * Constructs a new Value.
                         * @memberof google.ads.googleads.v1.common
                         * @classdesc Represents a Value.
                         * @implements IValue
                         * @constructor
                         * @param {google.ads.googleads.v1.common.IValue=} [properties] Properties to set
                         */
                        function Value(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Value booleanValue.
                         * @member {boolean} booleanValue
                         * @memberof google.ads.googleads.v1.common.Value
                         * @instance
                         */
                        Value.prototype.booleanValue = false;

                        /**
                         * Value int64Value.
                         * @member {number|Long} int64Value
                         * @memberof google.ads.googleads.v1.common.Value
                         * @instance
                         */
                        Value.prototype.int64Value = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

                        /**
                         * Value floatValue.
                         * @member {number} floatValue
                         * @memberof google.ads.googleads.v1.common.Value
                         * @instance
                         */
                        Value.prototype.floatValue = 0;

                        /**
                         * Value doubleValue.
                         * @member {number} doubleValue
                         * @memberof google.ads.googleads.v1.common.Value
                         * @instance
                         */
                        Value.prototype.doubleValue = 0;

                        /**
                         * Value stringValue.
                         * @member {string} stringValue
                         * @memberof google.ads.googleads.v1.common.Value
                         * @instance
                         */
                        Value.prototype.stringValue = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * Value value.
                         * @member {"booleanValue"|"int64Value"|"floatValue"|"doubleValue"|"stringValue"|undefined} value
                         * @memberof google.ads.googleads.v1.common.Value
                         * @instance
                         */
                        Object.defineProperty(Value.prototype, "value", {
                            get: $util.oneOfGetter($oneOfFields = ["booleanValue", "int64Value", "floatValue", "doubleValue", "stringValue"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new Value instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.common.Value
                         * @static
                         * @param {google.ads.googleads.v1.common.IValue=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.common.Value} Value instance
                         */
                        Value.create = function create(properties) {
                            return new Value(properties);
                        };

                        /**
                         * Encodes the specified Value message. Does not implicitly {@link google.ads.googleads.v1.common.Value.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.common.Value
                         * @static
                         * @param {google.ads.googleads.v1.common.IValue} message Value message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Value.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.booleanValue != null && message.hasOwnProperty("booleanValue"))
                                writer.uint32(/* id 1, wireType 0 =*/8).bool(message.booleanValue);
                            if (message.int64Value != null && message.hasOwnProperty("int64Value"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int64(message.int64Value);
                            if (message.floatValue != null && message.hasOwnProperty("floatValue"))
                                writer.uint32(/* id 3, wireType 5 =*/29).float(message.floatValue);
                            if (message.doubleValue != null && message.hasOwnProperty("doubleValue"))
                                writer.uint32(/* id 4, wireType 1 =*/33).double(message.doubleValue);
                            if (message.stringValue != null && message.hasOwnProperty("stringValue"))
                                writer.uint32(/* id 5, wireType 2 =*/42).string(message.stringValue);
                            return writer;
                        };

                        /**
                         * Encodes the specified Value message, length delimited. Does not implicitly {@link google.ads.googleads.v1.common.Value.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.common.Value
                         * @static
                         * @param {google.ads.googleads.v1.common.IValue} message Value message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Value.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a Value message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.common.Value
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.common.Value} Value
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Value.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.common.Value();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.booleanValue = reader.bool();
                                    break;
                                case 2:
                                    message.int64Value = reader.int64();
                                    break;
                                case 3:
                                    message.floatValue = reader.float();
                                    break;
                                case 4:
                                    message.doubleValue = reader.double();
                                    break;
                                case 5:
                                    message.stringValue = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a Value message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.common.Value
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.common.Value} Value
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Value.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a Value message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.common.Value
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Value.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.booleanValue != null && message.hasOwnProperty("booleanValue")) {
                                properties.value = 1;
                                if (typeof message.booleanValue !== "boolean")
                                    return "booleanValue: boolean expected";
                            }
                            if (message.int64Value != null && message.hasOwnProperty("int64Value")) {
                                if (properties.value === 1)
                                    return "value: multiple values";
                                properties.value = 1;
                                if (!$util.isInteger(message.int64Value) && !(message.int64Value && $util.isInteger(message.int64Value.low) && $util.isInteger(message.int64Value.high)))
                                    return "int64Value: integer|Long expected";
                            }
                            if (message.floatValue != null && message.hasOwnProperty("floatValue")) {
                                if (properties.value === 1)
                                    return "value: multiple values";
                                properties.value = 1;
                                if (typeof message.floatValue !== "number")
                                    return "floatValue: number expected";
                            }
                            if (message.doubleValue != null && message.hasOwnProperty("doubleValue")) {
                                if (properties.value === 1)
                                    return "value: multiple values";
                                properties.value = 1;
                                if (typeof message.doubleValue !== "number")
                                    return "doubleValue: number expected";
                            }
                            if (message.stringValue != null && message.hasOwnProperty("stringValue")) {
                                if (properties.value === 1)
                                    return "value: multiple values";
                                properties.value = 1;
                                if (!$util.isString(message.stringValue))
                                    return "stringValue: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a Value message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.common.Value
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.common.Value} Value
                         */
                        Value.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.common.Value)
                                return object;
                            var message = new $root.google.ads.googleads.v1.common.Value();
                            if (object.booleanValue != null)
                                message.booleanValue = Boolean(object.booleanValue);
                            if (object.int64Value != null)
                                if ($util.Long)
                                    (message.int64Value = $util.Long.fromValue(object.int64Value)).unsigned = false;
                                else if (typeof object.int64Value === "string")
                                    message.int64Value = parseInt(object.int64Value, 10);
                                else if (typeof object.int64Value === "number")
                                    message.int64Value = object.int64Value;
                                else if (typeof object.int64Value === "object")
                                    message.int64Value = new $util.LongBits(object.int64Value.low >>> 0, object.int64Value.high >>> 0).toNumber();
                            if (object.floatValue != null)
                                message.floatValue = Number(object.floatValue);
                            if (object.doubleValue != null)
                                message.doubleValue = Number(object.doubleValue);
                            if (object.stringValue != null)
                                message.stringValue = String(object.stringValue);
                            return message;
                        };

                        /**
                         * Creates a plain object from a Value message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.common.Value
                         * @static
                         * @param {google.ads.googleads.v1.common.Value} message Value
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Value.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.booleanValue != null && message.hasOwnProperty("booleanValue")) {
                                object.booleanValue = message.booleanValue;
                                if (options.oneofs)
                                    object.value = "booleanValue";
                            }
                            if (message.int64Value != null && message.hasOwnProperty("int64Value")) {
                                if (typeof message.int64Value === "number")
                                    object.int64Value = options.longs === String ? String(message.int64Value) : message.int64Value;
                                else
                                    object.int64Value = options.longs === String ? $util.Long.prototype.toString.call(message.int64Value) : options.longs === Number ? new $util.LongBits(message.int64Value.low >>> 0, message.int64Value.high >>> 0).toNumber() : message.int64Value;
                                if (options.oneofs)
                                    object.value = "int64Value";
                            }
                            if (message.floatValue != null && message.hasOwnProperty("floatValue")) {
                                object.floatValue = options.json && !isFinite(message.floatValue) ? String(message.floatValue) : message.floatValue;
                                if (options.oneofs)
                                    object.value = "floatValue";
                            }
                            if (message.doubleValue != null && message.hasOwnProperty("doubleValue")) {
                                object.doubleValue = options.json && !isFinite(message.doubleValue) ? String(message.doubleValue) : message.doubleValue;
                                if (options.oneofs)
                                    object.value = "doubleValue";
                            }
                            if (message.stringValue != null && message.hasOwnProperty("stringValue")) {
                                object.stringValue = message.stringValue;
                                if (options.oneofs)
                                    object.value = "stringValue";
                            }
                            return object;
                        };

                        /**
                         * Converts this Value to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.common.Value
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Value.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return Value;
                    })();

                    return common;
                })();

                v1.errors = (function() {

                    /**
                     * Namespace errors.
                     * @memberof google.ads.googleads.v1
                     * @namespace
                     */
                    var errors = {};

                    errors.AccountBudgetProposalErrorEnum = (function() {

                        /**
                         * Properties of an AccountBudgetProposalErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IAccountBudgetProposalErrorEnum
                         */

                        /**
                         * Constructs a new AccountBudgetProposalErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an AccountBudgetProposalErrorEnum.
                         * @implements IAccountBudgetProposalErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IAccountBudgetProposalErrorEnum=} [properties] Properties to set
                         */
                        function AccountBudgetProposalErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AccountBudgetProposalErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAccountBudgetProposalErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum} AccountBudgetProposalErrorEnum instance
                         */
                        AccountBudgetProposalErrorEnum.create = function create(properties) {
                            return new AccountBudgetProposalErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified AccountBudgetProposalErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAccountBudgetProposalErrorEnum} message AccountBudgetProposalErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccountBudgetProposalErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AccountBudgetProposalErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAccountBudgetProposalErrorEnum} message AccountBudgetProposalErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccountBudgetProposalErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AccountBudgetProposalErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum} AccountBudgetProposalErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccountBudgetProposalErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AccountBudgetProposalErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum} AccountBudgetProposalErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccountBudgetProposalErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AccountBudgetProposalErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccountBudgetProposalErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AccountBudgetProposalErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum} AccountBudgetProposalErrorEnum
                         */
                        AccountBudgetProposalErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum();
                        };

                        /**
                         * Creates a plain object from an AccountBudgetProposalErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum} message AccountBudgetProposalErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccountBudgetProposalErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AccountBudgetProposalErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccountBudgetProposalErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AccountBudgetProposalError enum.
                         * @name google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum.AccountBudgetProposalError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} FIELD_MASK_NOT_ALLOWED=2 FIELD_MASK_NOT_ALLOWED value
                         * @property {number} IMMUTABLE_FIELD=3 IMMUTABLE_FIELD value
                         * @property {number} REQUIRED_FIELD_MISSING=4 REQUIRED_FIELD_MISSING value
                         * @property {number} CANNOT_CANCEL_APPROVED_PROPOSAL=5 CANNOT_CANCEL_APPROVED_PROPOSAL value
                         * @property {number} CANNOT_REMOVE_UNAPPROVED_BUDGET=6 CANNOT_REMOVE_UNAPPROVED_BUDGET value
                         * @property {number} CANNOT_REMOVE_RUNNING_BUDGET=7 CANNOT_REMOVE_RUNNING_BUDGET value
                         * @property {number} CANNOT_END_UNAPPROVED_BUDGET=8 CANNOT_END_UNAPPROVED_BUDGET value
                         * @property {number} CANNOT_END_INACTIVE_BUDGET=9 CANNOT_END_INACTIVE_BUDGET value
                         * @property {number} BUDGET_NAME_REQUIRED=10 BUDGET_NAME_REQUIRED value
                         * @property {number} CANNOT_UPDATE_OLD_BUDGET=11 CANNOT_UPDATE_OLD_BUDGET value
                         * @property {number} CANNOT_END_IN_PAST=12 CANNOT_END_IN_PAST value
                         * @property {number} CANNOT_EXTEND_END_TIME=13 CANNOT_EXTEND_END_TIME value
                         * @property {number} PURCHASE_ORDER_NUMBER_REQUIRED=14 PURCHASE_ORDER_NUMBER_REQUIRED value
                         * @property {number} PENDING_UPDATE_PROPOSAL_EXISTS=15 PENDING_UPDATE_PROPOSAL_EXISTS value
                         * @property {number} MULTIPLE_BUDGETS_NOT_ALLOWED_FOR_UNAPPROVED_BILLING_SETUP=16 MULTIPLE_BUDGETS_NOT_ALLOWED_FOR_UNAPPROVED_BILLING_SETUP value
                         * @property {number} CANNOT_UPDATE_START_TIME_FOR_STARTED_BUDGET=17 CANNOT_UPDATE_START_TIME_FOR_STARTED_BUDGET value
                         * @property {number} SPENDING_LIMIT_LOWER_THAN_ACCRUED_COST_NOT_ALLOWED=18 SPENDING_LIMIT_LOWER_THAN_ACCRUED_COST_NOT_ALLOWED value
                         * @property {number} UPDATE_IS_NO_OP=19 UPDATE_IS_NO_OP value
                         * @property {number} END_TIME_MUST_FOLLOW_START_TIME=20 END_TIME_MUST_FOLLOW_START_TIME value
                         * @property {number} BUDGET_DATE_RANGE_INCOMPATIBLE_WITH_BILLING_SETUP=21 BUDGET_DATE_RANGE_INCOMPATIBLE_WITH_BILLING_SETUP value
                         * @property {number} NOT_AUTHORIZED=22 NOT_AUTHORIZED value
                         * @property {number} INVALID_BILLING_SETUP=23 INVALID_BILLING_SETUP value
                         */
                        AccountBudgetProposalErrorEnum.AccountBudgetProposalError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "FIELD_MASK_NOT_ALLOWED"] = 2;
                            values[valuesById[3] = "IMMUTABLE_FIELD"] = 3;
                            values[valuesById[4] = "REQUIRED_FIELD_MISSING"] = 4;
                            values[valuesById[5] = "CANNOT_CANCEL_APPROVED_PROPOSAL"] = 5;
                            values[valuesById[6] = "CANNOT_REMOVE_UNAPPROVED_BUDGET"] = 6;
                            values[valuesById[7] = "CANNOT_REMOVE_RUNNING_BUDGET"] = 7;
                            values[valuesById[8] = "CANNOT_END_UNAPPROVED_BUDGET"] = 8;
                            values[valuesById[9] = "CANNOT_END_INACTIVE_BUDGET"] = 9;
                            values[valuesById[10] = "BUDGET_NAME_REQUIRED"] = 10;
                            values[valuesById[11] = "CANNOT_UPDATE_OLD_BUDGET"] = 11;
                            values[valuesById[12] = "CANNOT_END_IN_PAST"] = 12;
                            values[valuesById[13] = "CANNOT_EXTEND_END_TIME"] = 13;
                            values[valuesById[14] = "PURCHASE_ORDER_NUMBER_REQUIRED"] = 14;
                            values[valuesById[15] = "PENDING_UPDATE_PROPOSAL_EXISTS"] = 15;
                            values[valuesById[16] = "MULTIPLE_BUDGETS_NOT_ALLOWED_FOR_UNAPPROVED_BILLING_SETUP"] = 16;
                            values[valuesById[17] = "CANNOT_UPDATE_START_TIME_FOR_STARTED_BUDGET"] = 17;
                            values[valuesById[18] = "SPENDING_LIMIT_LOWER_THAN_ACCRUED_COST_NOT_ALLOWED"] = 18;
                            values[valuesById[19] = "UPDATE_IS_NO_OP"] = 19;
                            values[valuesById[20] = "END_TIME_MUST_FOLLOW_START_TIME"] = 20;
                            values[valuesById[21] = "BUDGET_DATE_RANGE_INCOMPATIBLE_WITH_BILLING_SETUP"] = 21;
                            values[valuesById[22] = "NOT_AUTHORIZED"] = 22;
                            values[valuesById[23] = "INVALID_BILLING_SETUP"] = 23;
                            return values;
                        })();

                        return AccountBudgetProposalErrorEnum;
                    })();

                    errors.AdCustomizerErrorEnum = (function() {

                        /**
                         * Properties of an AdCustomizerErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IAdCustomizerErrorEnum
                         */

                        /**
                         * Constructs a new AdCustomizerErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an AdCustomizerErrorEnum.
                         * @implements IAdCustomizerErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IAdCustomizerErrorEnum=} [properties] Properties to set
                         */
                        function AdCustomizerErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdCustomizerErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.AdCustomizerErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdCustomizerErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.AdCustomizerErrorEnum} AdCustomizerErrorEnum instance
                         */
                        AdCustomizerErrorEnum.create = function create(properties) {
                            return new AdCustomizerErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified AdCustomizerErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.AdCustomizerErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.AdCustomizerErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdCustomizerErrorEnum} message AdCustomizerErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdCustomizerErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdCustomizerErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.AdCustomizerErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdCustomizerErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdCustomizerErrorEnum} message AdCustomizerErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdCustomizerErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdCustomizerErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.AdCustomizerErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.AdCustomizerErrorEnum} AdCustomizerErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdCustomizerErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.AdCustomizerErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdCustomizerErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdCustomizerErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.AdCustomizerErrorEnum} AdCustomizerErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdCustomizerErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdCustomizerErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.AdCustomizerErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdCustomizerErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdCustomizerErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.AdCustomizerErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.AdCustomizerErrorEnum} AdCustomizerErrorEnum
                         */
                        AdCustomizerErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.AdCustomizerErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.AdCustomizerErrorEnum();
                        };

                        /**
                         * Creates a plain object from an AdCustomizerErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.AdCustomizerErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.AdCustomizerErrorEnum} message AdCustomizerErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdCustomizerErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdCustomizerErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.AdCustomizerErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdCustomizerErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdCustomizerError enum.
                         * @name google.ads.googleads.v1.errors.AdCustomizerErrorEnum.AdCustomizerError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} COUNTDOWN_INVALID_DATE_FORMAT=2 COUNTDOWN_INVALID_DATE_FORMAT value
                         * @property {number} COUNTDOWN_DATE_IN_PAST=3 COUNTDOWN_DATE_IN_PAST value
                         * @property {number} COUNTDOWN_INVALID_LOCALE=4 COUNTDOWN_INVALID_LOCALE value
                         * @property {number} COUNTDOWN_INVALID_START_DAYS_BEFORE=5 COUNTDOWN_INVALID_START_DAYS_BEFORE value
                         * @property {number} UNKNOWN_USER_LIST=6 UNKNOWN_USER_LIST value
                         */
                        AdCustomizerErrorEnum.AdCustomizerError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "COUNTDOWN_INVALID_DATE_FORMAT"] = 2;
                            values[valuesById[3] = "COUNTDOWN_DATE_IN_PAST"] = 3;
                            values[valuesById[4] = "COUNTDOWN_INVALID_LOCALE"] = 4;
                            values[valuesById[5] = "COUNTDOWN_INVALID_START_DAYS_BEFORE"] = 5;
                            values[valuesById[6] = "UNKNOWN_USER_LIST"] = 6;
                            return values;
                        })();

                        return AdCustomizerErrorEnum;
                    })();

                    errors.AdErrorEnum = (function() {

                        /**
                         * Properties of an AdErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IAdErrorEnum
                         */

                        /**
                         * Constructs a new AdErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an AdErrorEnum.
                         * @implements IAdErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IAdErrorEnum=} [properties] Properties to set
                         */
                        function AdErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.AdErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.AdErrorEnum} AdErrorEnum instance
                         */
                        AdErrorEnum.create = function create(properties) {
                            return new AdErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified AdErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.AdErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.AdErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdErrorEnum} message AdErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.AdErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdErrorEnum} message AdErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.AdErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.AdErrorEnum} AdErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.AdErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.AdErrorEnum} AdErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.AdErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.AdErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.AdErrorEnum} AdErrorEnum
                         */
                        AdErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.AdErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.AdErrorEnum();
                        };

                        /**
                         * Creates a plain object from an AdErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.AdErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.AdErrorEnum} message AdErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.AdErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdError enum.
                         * @name google.ads.googleads.v1.errors.AdErrorEnum.AdError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} AD_CUSTOMIZERS_NOT_SUPPORTED_FOR_AD_TYPE=2 AD_CUSTOMIZERS_NOT_SUPPORTED_FOR_AD_TYPE value
                         * @property {number} APPROXIMATELY_TOO_LONG=3 APPROXIMATELY_TOO_LONG value
                         * @property {number} APPROXIMATELY_TOO_SHORT=4 APPROXIMATELY_TOO_SHORT value
                         * @property {number} BAD_SNIPPET=5 BAD_SNIPPET value
                         * @property {number} CANNOT_MODIFY_AD=6 CANNOT_MODIFY_AD value
                         * @property {number} CANNOT_SET_BUSINESS_NAME_IF_URL_SET=7 CANNOT_SET_BUSINESS_NAME_IF_URL_SET value
                         * @property {number} CANNOT_SET_FIELD=8 CANNOT_SET_FIELD value
                         * @property {number} CANNOT_SET_FIELD_WITH_ORIGIN_AD_ID_SET=9 CANNOT_SET_FIELD_WITH_ORIGIN_AD_ID_SET value
                         * @property {number} CANNOT_SET_FIELD_WITH_AD_ID_SET_FOR_SHARING=10 CANNOT_SET_FIELD_WITH_AD_ID_SET_FOR_SHARING value
                         * @property {number} CANNOT_SET_ALLOW_FLEXIBLE_COLOR_FALSE=11 CANNOT_SET_ALLOW_FLEXIBLE_COLOR_FALSE value
                         * @property {number} CANNOT_SET_COLOR_CONTROL_WHEN_NATIVE_FORMAT_SETTING=12 CANNOT_SET_COLOR_CONTROL_WHEN_NATIVE_FORMAT_SETTING value
                         * @property {number} CANNOT_SET_URL=13 CANNOT_SET_URL value
                         * @property {number} CANNOT_SET_WITHOUT_FINAL_URLS=14 CANNOT_SET_WITHOUT_FINAL_URLS value
                         * @property {number} CANNOT_SET_WITH_FINAL_URLS=15 CANNOT_SET_WITH_FINAL_URLS value
                         * @property {number} CANNOT_SET_WITH_URL_DATA=17 CANNOT_SET_WITH_URL_DATA value
                         * @property {number} CANNOT_USE_AD_SUBCLASS_FOR_OPERATOR=18 CANNOT_USE_AD_SUBCLASS_FOR_OPERATOR value
                         * @property {number} CUSTOMER_NOT_APPROVED_MOBILEADS=19 CUSTOMER_NOT_APPROVED_MOBILEADS value
                         * @property {number} CUSTOMER_NOT_APPROVED_THIRDPARTY_ADS=20 CUSTOMER_NOT_APPROVED_THIRDPARTY_ADS value
                         * @property {number} CUSTOMER_NOT_APPROVED_THIRDPARTY_REDIRECT_ADS=21 CUSTOMER_NOT_APPROVED_THIRDPARTY_REDIRECT_ADS value
                         * @property {number} CUSTOMER_NOT_ELIGIBLE=22 CUSTOMER_NOT_ELIGIBLE value
                         * @property {number} CUSTOMER_NOT_ELIGIBLE_FOR_UPDATING_BEACON_URL=23 CUSTOMER_NOT_ELIGIBLE_FOR_UPDATING_BEACON_URL value
                         * @property {number} DIMENSION_ALREADY_IN_UNION=24 DIMENSION_ALREADY_IN_UNION value
                         * @property {number} DIMENSION_MUST_BE_SET=25 DIMENSION_MUST_BE_SET value
                         * @property {number} DIMENSION_NOT_IN_UNION=26 DIMENSION_NOT_IN_UNION value
                         * @property {number} DISPLAY_URL_CANNOT_BE_SPECIFIED=27 DISPLAY_URL_CANNOT_BE_SPECIFIED value
                         * @property {number} DOMESTIC_PHONE_NUMBER_FORMAT=28 DOMESTIC_PHONE_NUMBER_FORMAT value
                         * @property {number} EMERGENCY_PHONE_NUMBER=29 EMERGENCY_PHONE_NUMBER value
                         * @property {number} EMPTY_FIELD=30 EMPTY_FIELD value
                         * @property {number} FEED_ATTRIBUTE_MUST_HAVE_MAPPING_FOR_TYPE_ID=31 FEED_ATTRIBUTE_MUST_HAVE_MAPPING_FOR_TYPE_ID value
                         * @property {number} FEED_ATTRIBUTE_MAPPING_TYPE_MISMATCH=32 FEED_ATTRIBUTE_MAPPING_TYPE_MISMATCH value
                         * @property {number} ILLEGAL_AD_CUSTOMIZER_TAG_USE=33 ILLEGAL_AD_CUSTOMIZER_TAG_USE value
                         * @property {number} ILLEGAL_TAG_USE=34 ILLEGAL_TAG_USE value
                         * @property {number} INCONSISTENT_DIMENSIONS=35 INCONSISTENT_DIMENSIONS value
                         * @property {number} INCONSISTENT_STATUS_IN_TEMPLATE_UNION=36 INCONSISTENT_STATUS_IN_TEMPLATE_UNION value
                         * @property {number} INCORRECT_LENGTH=37 INCORRECT_LENGTH value
                         * @property {number} INELIGIBLE_FOR_UPGRADE=38 INELIGIBLE_FOR_UPGRADE value
                         * @property {number} INVALID_AD_ADDRESS_CAMPAIGN_TARGET=39 INVALID_AD_ADDRESS_CAMPAIGN_TARGET value
                         * @property {number} INVALID_AD_TYPE=40 INVALID_AD_TYPE value
                         * @property {number} INVALID_ATTRIBUTES_FOR_MOBILE_IMAGE=41 INVALID_ATTRIBUTES_FOR_MOBILE_IMAGE value
                         * @property {number} INVALID_ATTRIBUTES_FOR_MOBILE_TEXT=42 INVALID_ATTRIBUTES_FOR_MOBILE_TEXT value
                         * @property {number} INVALID_CALL_TO_ACTION_TEXT=43 INVALID_CALL_TO_ACTION_TEXT value
                         * @property {number} INVALID_CHARACTER_FOR_URL=44 INVALID_CHARACTER_FOR_URL value
                         * @property {number} INVALID_COUNTRY_CODE=45 INVALID_COUNTRY_CODE value
                         * @property {number} INVALID_EXPANDED_DYNAMIC_SEARCH_AD_TAG=47 INVALID_EXPANDED_DYNAMIC_SEARCH_AD_TAG value
                         * @property {number} INVALID_INPUT=48 INVALID_INPUT value
                         * @property {number} INVALID_MARKUP_LANGUAGE=49 INVALID_MARKUP_LANGUAGE value
                         * @property {number} INVALID_MOBILE_CARRIER=50 INVALID_MOBILE_CARRIER value
                         * @property {number} INVALID_MOBILE_CARRIER_TARGET=51 INVALID_MOBILE_CARRIER_TARGET value
                         * @property {number} INVALID_NUMBER_OF_ELEMENTS=52 INVALID_NUMBER_OF_ELEMENTS value
                         * @property {number} INVALID_PHONE_NUMBER_FORMAT=53 INVALID_PHONE_NUMBER_FORMAT value
                         * @property {number} INVALID_RICH_MEDIA_CERTIFIED_VENDOR_FORMAT_ID=54 INVALID_RICH_MEDIA_CERTIFIED_VENDOR_FORMAT_ID value
                         * @property {number} INVALID_TEMPLATE_DATA=55 INVALID_TEMPLATE_DATA value
                         * @property {number} INVALID_TEMPLATE_ELEMENT_FIELD_TYPE=56 INVALID_TEMPLATE_ELEMENT_FIELD_TYPE value
                         * @property {number} INVALID_TEMPLATE_ID=57 INVALID_TEMPLATE_ID value
                         * @property {number} LINE_TOO_WIDE=58 LINE_TOO_WIDE value
                         * @property {number} MISSING_AD_CUSTOMIZER_MAPPING=59 MISSING_AD_CUSTOMIZER_MAPPING value
                         * @property {number} MISSING_ADDRESS_COMPONENT=60 MISSING_ADDRESS_COMPONENT value
                         * @property {number} MISSING_ADVERTISEMENT_NAME=61 MISSING_ADVERTISEMENT_NAME value
                         * @property {number} MISSING_BUSINESS_NAME=62 MISSING_BUSINESS_NAME value
                         * @property {number} MISSING_DESCRIPTION1=63 MISSING_DESCRIPTION1 value
                         * @property {number} MISSING_DESCRIPTION2=64 MISSING_DESCRIPTION2 value
                         * @property {number} MISSING_DESTINATION_URL_TAG=65 MISSING_DESTINATION_URL_TAG value
                         * @property {number} MISSING_LANDING_PAGE_URL_TAG=66 MISSING_LANDING_PAGE_URL_TAG value
                         * @property {number} MISSING_DIMENSION=67 MISSING_DIMENSION value
                         * @property {number} MISSING_DISPLAY_URL=68 MISSING_DISPLAY_URL value
                         * @property {number} MISSING_HEADLINE=69 MISSING_HEADLINE value
                         * @property {number} MISSING_HEIGHT=70 MISSING_HEIGHT value
                         * @property {number} MISSING_IMAGE=71 MISSING_IMAGE value
                         * @property {number} MISSING_MARKETING_IMAGE_OR_PRODUCT_VIDEOS=72 MISSING_MARKETING_IMAGE_OR_PRODUCT_VIDEOS value
                         * @property {number} MISSING_MARKUP_LANGUAGES=73 MISSING_MARKUP_LANGUAGES value
                         * @property {number} MISSING_MOBILE_CARRIER=74 MISSING_MOBILE_CARRIER value
                         * @property {number} MISSING_PHONE=75 MISSING_PHONE value
                         * @property {number} MISSING_REQUIRED_TEMPLATE_FIELDS=76 MISSING_REQUIRED_TEMPLATE_FIELDS value
                         * @property {number} MISSING_TEMPLATE_FIELD_VALUE=77 MISSING_TEMPLATE_FIELD_VALUE value
                         * @property {number} MISSING_TEXT=78 MISSING_TEXT value
                         * @property {number} MISSING_VISIBLE_URL=79 MISSING_VISIBLE_URL value
                         * @property {number} MISSING_WIDTH=80 MISSING_WIDTH value
                         * @property {number} MULTIPLE_DISTINCT_FEEDS_UNSUPPORTED=81 MULTIPLE_DISTINCT_FEEDS_UNSUPPORTED value
                         * @property {number} MUST_USE_TEMP_AD_UNION_ID_ON_ADD=82 MUST_USE_TEMP_AD_UNION_ID_ON_ADD value
                         * @property {number} TOO_LONG=83 TOO_LONG value
                         * @property {number} TOO_SHORT=84 TOO_SHORT value
                         * @property {number} UNION_DIMENSIONS_CANNOT_CHANGE=85 UNION_DIMENSIONS_CANNOT_CHANGE value
                         * @property {number} UNKNOWN_ADDRESS_COMPONENT=86 UNKNOWN_ADDRESS_COMPONENT value
                         * @property {number} UNKNOWN_FIELD_NAME=87 UNKNOWN_FIELD_NAME value
                         * @property {number} UNKNOWN_UNIQUE_NAME=88 UNKNOWN_UNIQUE_NAME value
                         * @property {number} UNSUPPORTED_DIMENSIONS=89 UNSUPPORTED_DIMENSIONS value
                         * @property {number} URL_INVALID_SCHEME=90 URL_INVALID_SCHEME value
                         * @property {number} URL_INVALID_TOP_LEVEL_DOMAIN=91 URL_INVALID_TOP_LEVEL_DOMAIN value
                         * @property {number} URL_MALFORMED=92 URL_MALFORMED value
                         * @property {number} URL_NO_HOST=93 URL_NO_HOST value
                         * @property {number} URL_NOT_EQUIVALENT=94 URL_NOT_EQUIVALENT value
                         * @property {number} URL_HOST_NAME_TOO_LONG=95 URL_HOST_NAME_TOO_LONG value
                         * @property {number} URL_NO_SCHEME=96 URL_NO_SCHEME value
                         * @property {number} URL_NO_TOP_LEVEL_DOMAIN=97 URL_NO_TOP_LEVEL_DOMAIN value
                         * @property {number} URL_PATH_NOT_ALLOWED=98 URL_PATH_NOT_ALLOWED value
                         * @property {number} URL_PORT_NOT_ALLOWED=99 URL_PORT_NOT_ALLOWED value
                         * @property {number} URL_QUERY_NOT_ALLOWED=100 URL_QUERY_NOT_ALLOWED value
                         * @property {number} URL_SCHEME_BEFORE_EXPANDED_DYNAMIC_SEARCH_AD_TAG=102 URL_SCHEME_BEFORE_EXPANDED_DYNAMIC_SEARCH_AD_TAG value
                         * @property {number} USER_DOES_NOT_HAVE_ACCESS_TO_TEMPLATE=103 USER_DOES_NOT_HAVE_ACCESS_TO_TEMPLATE value
                         * @property {number} INCONSISTENT_EXPANDABLE_SETTINGS=104 INCONSISTENT_EXPANDABLE_SETTINGS value
                         * @property {number} INVALID_FORMAT=105 INVALID_FORMAT value
                         * @property {number} INVALID_FIELD_TEXT=106 INVALID_FIELD_TEXT value
                         * @property {number} ELEMENT_NOT_PRESENT=107 ELEMENT_NOT_PRESENT value
                         * @property {number} IMAGE_ERROR=108 IMAGE_ERROR value
                         * @property {number} VALUE_NOT_IN_RANGE=109 VALUE_NOT_IN_RANGE value
                         * @property {number} FIELD_NOT_PRESENT=110 FIELD_NOT_PRESENT value
                         * @property {number} ADDRESS_NOT_COMPLETE=111 ADDRESS_NOT_COMPLETE value
                         * @property {number} ADDRESS_INVALID=112 ADDRESS_INVALID value
                         * @property {number} VIDEO_RETRIEVAL_ERROR=113 VIDEO_RETRIEVAL_ERROR value
                         * @property {number} AUDIO_ERROR=114 AUDIO_ERROR value
                         * @property {number} INVALID_YOUTUBE_DISPLAY_URL=115 INVALID_YOUTUBE_DISPLAY_URL value
                         * @property {number} TOO_MANY_PRODUCT_IMAGES=116 TOO_MANY_PRODUCT_IMAGES value
                         * @property {number} TOO_MANY_PRODUCT_VIDEOS=117 TOO_MANY_PRODUCT_VIDEOS value
                         * @property {number} INCOMPATIBLE_AD_TYPE_AND_DEVICE_PREFERENCE=118 INCOMPATIBLE_AD_TYPE_AND_DEVICE_PREFERENCE value
                         * @property {number} CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY=119 CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY value
                         * @property {number} CARRIER_SPECIFIC_SHORT_NUMBER_NOT_ALLOWED=120 CARRIER_SPECIFIC_SHORT_NUMBER_NOT_ALLOWED value
                         * @property {number} DISALLOWED_NUMBER_TYPE=121 DISALLOWED_NUMBER_TYPE value
                         * @property {number} PHONE_NUMBER_NOT_SUPPORTED_FOR_COUNTRY=122 PHONE_NUMBER_NOT_SUPPORTED_FOR_COUNTRY value
                         * @property {number} PHONE_NUMBER_NOT_SUPPORTED_WITH_CALLTRACKING_FOR_COUNTRY=123 PHONE_NUMBER_NOT_SUPPORTED_WITH_CALLTRACKING_FOR_COUNTRY value
                         * @property {number} PREMIUM_RATE_NUMBER_NOT_ALLOWED=124 PREMIUM_RATE_NUMBER_NOT_ALLOWED value
                         * @property {number} VANITY_PHONE_NUMBER_NOT_ALLOWED=125 VANITY_PHONE_NUMBER_NOT_ALLOWED value
                         * @property {number} INVALID_CALL_CONVERSION_TYPE_ID=126 INVALID_CALL_CONVERSION_TYPE_ID value
                         * @property {number} CANNOT_DISABLE_CALL_CONVERSION_AND_SET_CONVERSION_TYPE_ID=127 CANNOT_DISABLE_CALL_CONVERSION_AND_SET_CONVERSION_TYPE_ID value
                         * @property {number} CANNOT_SET_PATH2_WITHOUT_PATH1=128 CANNOT_SET_PATH2_WITHOUT_PATH1 value
                         * @property {number} MISSING_DYNAMIC_SEARCH_ADS_SETTING_DOMAIN_NAME=129 MISSING_DYNAMIC_SEARCH_ADS_SETTING_DOMAIN_NAME value
                         * @property {number} INCOMPATIBLE_WITH_RESTRICTION_TYPE=130 INCOMPATIBLE_WITH_RESTRICTION_TYPE value
                         * @property {number} CUSTOMER_CONSENT_FOR_CALL_RECORDING_REQUIRED=131 CUSTOMER_CONSENT_FOR_CALL_RECORDING_REQUIRED value
                         * @property {number} MISSING_IMAGE_OR_MEDIA_BUNDLE=132 MISSING_IMAGE_OR_MEDIA_BUNDLE value
                         * @property {number} PRODUCT_TYPE_NOT_SUPPORTED_IN_THIS_CAMPAIGN=133 PRODUCT_TYPE_NOT_SUPPORTED_IN_THIS_CAMPAIGN value
                         */
                        AdErrorEnum.AdError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "AD_CUSTOMIZERS_NOT_SUPPORTED_FOR_AD_TYPE"] = 2;
                            values[valuesById[3] = "APPROXIMATELY_TOO_LONG"] = 3;
                            values[valuesById[4] = "APPROXIMATELY_TOO_SHORT"] = 4;
                            values[valuesById[5] = "BAD_SNIPPET"] = 5;
                            values[valuesById[6] = "CANNOT_MODIFY_AD"] = 6;
                            values[valuesById[7] = "CANNOT_SET_BUSINESS_NAME_IF_URL_SET"] = 7;
                            values[valuesById[8] = "CANNOT_SET_FIELD"] = 8;
                            values[valuesById[9] = "CANNOT_SET_FIELD_WITH_ORIGIN_AD_ID_SET"] = 9;
                            values[valuesById[10] = "CANNOT_SET_FIELD_WITH_AD_ID_SET_FOR_SHARING"] = 10;
                            values[valuesById[11] = "CANNOT_SET_ALLOW_FLEXIBLE_COLOR_FALSE"] = 11;
                            values[valuesById[12] = "CANNOT_SET_COLOR_CONTROL_WHEN_NATIVE_FORMAT_SETTING"] = 12;
                            values[valuesById[13] = "CANNOT_SET_URL"] = 13;
                            values[valuesById[14] = "CANNOT_SET_WITHOUT_FINAL_URLS"] = 14;
                            values[valuesById[15] = "CANNOT_SET_WITH_FINAL_URLS"] = 15;
                            values[valuesById[17] = "CANNOT_SET_WITH_URL_DATA"] = 17;
                            values[valuesById[18] = "CANNOT_USE_AD_SUBCLASS_FOR_OPERATOR"] = 18;
                            values[valuesById[19] = "CUSTOMER_NOT_APPROVED_MOBILEADS"] = 19;
                            values[valuesById[20] = "CUSTOMER_NOT_APPROVED_THIRDPARTY_ADS"] = 20;
                            values[valuesById[21] = "CUSTOMER_NOT_APPROVED_THIRDPARTY_REDIRECT_ADS"] = 21;
                            values[valuesById[22] = "CUSTOMER_NOT_ELIGIBLE"] = 22;
                            values[valuesById[23] = "CUSTOMER_NOT_ELIGIBLE_FOR_UPDATING_BEACON_URL"] = 23;
                            values[valuesById[24] = "DIMENSION_ALREADY_IN_UNION"] = 24;
                            values[valuesById[25] = "DIMENSION_MUST_BE_SET"] = 25;
                            values[valuesById[26] = "DIMENSION_NOT_IN_UNION"] = 26;
                            values[valuesById[27] = "DISPLAY_URL_CANNOT_BE_SPECIFIED"] = 27;
                            values[valuesById[28] = "DOMESTIC_PHONE_NUMBER_FORMAT"] = 28;
                            values[valuesById[29] = "EMERGENCY_PHONE_NUMBER"] = 29;
                            values[valuesById[30] = "EMPTY_FIELD"] = 30;
                            values[valuesById[31] = "FEED_ATTRIBUTE_MUST_HAVE_MAPPING_FOR_TYPE_ID"] = 31;
                            values[valuesById[32] = "FEED_ATTRIBUTE_MAPPING_TYPE_MISMATCH"] = 32;
                            values[valuesById[33] = "ILLEGAL_AD_CUSTOMIZER_TAG_USE"] = 33;
                            values[valuesById[34] = "ILLEGAL_TAG_USE"] = 34;
                            values[valuesById[35] = "INCONSISTENT_DIMENSIONS"] = 35;
                            values[valuesById[36] = "INCONSISTENT_STATUS_IN_TEMPLATE_UNION"] = 36;
                            values[valuesById[37] = "INCORRECT_LENGTH"] = 37;
                            values[valuesById[38] = "INELIGIBLE_FOR_UPGRADE"] = 38;
                            values[valuesById[39] = "INVALID_AD_ADDRESS_CAMPAIGN_TARGET"] = 39;
                            values[valuesById[40] = "INVALID_AD_TYPE"] = 40;
                            values[valuesById[41] = "INVALID_ATTRIBUTES_FOR_MOBILE_IMAGE"] = 41;
                            values[valuesById[42] = "INVALID_ATTRIBUTES_FOR_MOBILE_TEXT"] = 42;
                            values[valuesById[43] = "INVALID_CALL_TO_ACTION_TEXT"] = 43;
                            values[valuesById[44] = "INVALID_CHARACTER_FOR_URL"] = 44;
                            values[valuesById[45] = "INVALID_COUNTRY_CODE"] = 45;
                            values[valuesById[47] = "INVALID_EXPANDED_DYNAMIC_SEARCH_AD_TAG"] = 47;
                            values[valuesById[48] = "INVALID_INPUT"] = 48;
                            values[valuesById[49] = "INVALID_MARKUP_LANGUAGE"] = 49;
                            values[valuesById[50] = "INVALID_MOBILE_CARRIER"] = 50;
                            values[valuesById[51] = "INVALID_MOBILE_CARRIER_TARGET"] = 51;
                            values[valuesById[52] = "INVALID_NUMBER_OF_ELEMENTS"] = 52;
                            values[valuesById[53] = "INVALID_PHONE_NUMBER_FORMAT"] = 53;
                            values[valuesById[54] = "INVALID_RICH_MEDIA_CERTIFIED_VENDOR_FORMAT_ID"] = 54;
                            values[valuesById[55] = "INVALID_TEMPLATE_DATA"] = 55;
                            values[valuesById[56] = "INVALID_TEMPLATE_ELEMENT_FIELD_TYPE"] = 56;
                            values[valuesById[57] = "INVALID_TEMPLATE_ID"] = 57;
                            values[valuesById[58] = "LINE_TOO_WIDE"] = 58;
                            values[valuesById[59] = "MISSING_AD_CUSTOMIZER_MAPPING"] = 59;
                            values[valuesById[60] = "MISSING_ADDRESS_COMPONENT"] = 60;
                            values[valuesById[61] = "MISSING_ADVERTISEMENT_NAME"] = 61;
                            values[valuesById[62] = "MISSING_BUSINESS_NAME"] = 62;
                            values[valuesById[63] = "MISSING_DESCRIPTION1"] = 63;
                            values[valuesById[64] = "MISSING_DESCRIPTION2"] = 64;
                            values[valuesById[65] = "MISSING_DESTINATION_URL_TAG"] = 65;
                            values[valuesById[66] = "MISSING_LANDING_PAGE_URL_TAG"] = 66;
                            values[valuesById[67] = "MISSING_DIMENSION"] = 67;
                            values[valuesById[68] = "MISSING_DISPLAY_URL"] = 68;
                            values[valuesById[69] = "MISSING_HEADLINE"] = 69;
                            values[valuesById[70] = "MISSING_HEIGHT"] = 70;
                            values[valuesById[71] = "MISSING_IMAGE"] = 71;
                            values[valuesById[72] = "MISSING_MARKETING_IMAGE_OR_PRODUCT_VIDEOS"] = 72;
                            values[valuesById[73] = "MISSING_MARKUP_LANGUAGES"] = 73;
                            values[valuesById[74] = "MISSING_MOBILE_CARRIER"] = 74;
                            values[valuesById[75] = "MISSING_PHONE"] = 75;
                            values[valuesById[76] = "MISSING_REQUIRED_TEMPLATE_FIELDS"] = 76;
                            values[valuesById[77] = "MISSING_TEMPLATE_FIELD_VALUE"] = 77;
                            values[valuesById[78] = "MISSING_TEXT"] = 78;
                            values[valuesById[79] = "MISSING_VISIBLE_URL"] = 79;
                            values[valuesById[80] = "MISSING_WIDTH"] = 80;
                            values[valuesById[81] = "MULTIPLE_DISTINCT_FEEDS_UNSUPPORTED"] = 81;
                            values[valuesById[82] = "MUST_USE_TEMP_AD_UNION_ID_ON_ADD"] = 82;
                            values[valuesById[83] = "TOO_LONG"] = 83;
                            values[valuesById[84] = "TOO_SHORT"] = 84;
                            values[valuesById[85] = "UNION_DIMENSIONS_CANNOT_CHANGE"] = 85;
                            values[valuesById[86] = "UNKNOWN_ADDRESS_COMPONENT"] = 86;
                            values[valuesById[87] = "UNKNOWN_FIELD_NAME"] = 87;
                            values[valuesById[88] = "UNKNOWN_UNIQUE_NAME"] = 88;
                            values[valuesById[89] = "UNSUPPORTED_DIMENSIONS"] = 89;
                            values[valuesById[90] = "URL_INVALID_SCHEME"] = 90;
                            values[valuesById[91] = "URL_INVALID_TOP_LEVEL_DOMAIN"] = 91;
                            values[valuesById[92] = "URL_MALFORMED"] = 92;
                            values[valuesById[93] = "URL_NO_HOST"] = 93;
                            values[valuesById[94] = "URL_NOT_EQUIVALENT"] = 94;
                            values[valuesById[95] = "URL_HOST_NAME_TOO_LONG"] = 95;
                            values[valuesById[96] = "URL_NO_SCHEME"] = 96;
                            values[valuesById[97] = "URL_NO_TOP_LEVEL_DOMAIN"] = 97;
                            values[valuesById[98] = "URL_PATH_NOT_ALLOWED"] = 98;
                            values[valuesById[99] = "URL_PORT_NOT_ALLOWED"] = 99;
                            values[valuesById[100] = "URL_QUERY_NOT_ALLOWED"] = 100;
                            values[valuesById[102] = "URL_SCHEME_BEFORE_EXPANDED_DYNAMIC_SEARCH_AD_TAG"] = 102;
                            values[valuesById[103] = "USER_DOES_NOT_HAVE_ACCESS_TO_TEMPLATE"] = 103;
                            values[valuesById[104] = "INCONSISTENT_EXPANDABLE_SETTINGS"] = 104;
                            values[valuesById[105] = "INVALID_FORMAT"] = 105;
                            values[valuesById[106] = "INVALID_FIELD_TEXT"] = 106;
                            values[valuesById[107] = "ELEMENT_NOT_PRESENT"] = 107;
                            values[valuesById[108] = "IMAGE_ERROR"] = 108;
                            values[valuesById[109] = "VALUE_NOT_IN_RANGE"] = 109;
                            values[valuesById[110] = "FIELD_NOT_PRESENT"] = 110;
                            values[valuesById[111] = "ADDRESS_NOT_COMPLETE"] = 111;
                            values[valuesById[112] = "ADDRESS_INVALID"] = 112;
                            values[valuesById[113] = "VIDEO_RETRIEVAL_ERROR"] = 113;
                            values[valuesById[114] = "AUDIO_ERROR"] = 114;
                            values[valuesById[115] = "INVALID_YOUTUBE_DISPLAY_URL"] = 115;
                            values[valuesById[116] = "TOO_MANY_PRODUCT_IMAGES"] = 116;
                            values[valuesById[117] = "TOO_MANY_PRODUCT_VIDEOS"] = 117;
                            values[valuesById[118] = "INCOMPATIBLE_AD_TYPE_AND_DEVICE_PREFERENCE"] = 118;
                            values[valuesById[119] = "CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY"] = 119;
                            values[valuesById[120] = "CARRIER_SPECIFIC_SHORT_NUMBER_NOT_ALLOWED"] = 120;
                            values[valuesById[121] = "DISALLOWED_NUMBER_TYPE"] = 121;
                            values[valuesById[122] = "PHONE_NUMBER_NOT_SUPPORTED_FOR_COUNTRY"] = 122;
                            values[valuesById[123] = "PHONE_NUMBER_NOT_SUPPORTED_WITH_CALLTRACKING_FOR_COUNTRY"] = 123;
                            values[valuesById[124] = "PREMIUM_RATE_NUMBER_NOT_ALLOWED"] = 124;
                            values[valuesById[125] = "VANITY_PHONE_NUMBER_NOT_ALLOWED"] = 125;
                            values[valuesById[126] = "INVALID_CALL_CONVERSION_TYPE_ID"] = 126;
                            values[valuesById[127] = "CANNOT_DISABLE_CALL_CONVERSION_AND_SET_CONVERSION_TYPE_ID"] = 127;
                            values[valuesById[128] = "CANNOT_SET_PATH2_WITHOUT_PATH1"] = 128;
                            values[valuesById[129] = "MISSING_DYNAMIC_SEARCH_ADS_SETTING_DOMAIN_NAME"] = 129;
                            values[valuesById[130] = "INCOMPATIBLE_WITH_RESTRICTION_TYPE"] = 130;
                            values[valuesById[131] = "CUSTOMER_CONSENT_FOR_CALL_RECORDING_REQUIRED"] = 131;
                            values[valuesById[132] = "MISSING_IMAGE_OR_MEDIA_BUNDLE"] = 132;
                            values[valuesById[133] = "PRODUCT_TYPE_NOT_SUPPORTED_IN_THIS_CAMPAIGN"] = 133;
                            return values;
                        })();

                        return AdErrorEnum;
                    })();

                    errors.AdGroupAdErrorEnum = (function() {

                        /**
                         * Properties of an AdGroupAdErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IAdGroupAdErrorEnum
                         */

                        /**
                         * Constructs a new AdGroupAdErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an AdGroupAdErrorEnum.
                         * @implements IAdGroupAdErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IAdGroupAdErrorEnum=} [properties] Properties to set
                         */
                        function AdGroupAdErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdGroupAdErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.AdGroupAdErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdGroupAdErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.AdGroupAdErrorEnum} AdGroupAdErrorEnum instance
                         */
                        AdGroupAdErrorEnum.create = function create(properties) {
                            return new AdGroupAdErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified AdGroupAdErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.AdGroupAdErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.AdGroupAdErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdGroupAdErrorEnum} message AdGroupAdErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupAdErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupAdErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.AdGroupAdErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdGroupAdErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdGroupAdErrorEnum} message AdGroupAdErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupAdErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupAdErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.AdGroupAdErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.AdGroupAdErrorEnum} AdGroupAdErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupAdErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.AdGroupAdErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupAdErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdGroupAdErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.AdGroupAdErrorEnum} AdGroupAdErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupAdErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupAdErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.AdGroupAdErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupAdErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdGroupAdErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.AdGroupAdErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.AdGroupAdErrorEnum} AdGroupAdErrorEnum
                         */
                        AdGroupAdErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.AdGroupAdErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.AdGroupAdErrorEnum();
                        };

                        /**
                         * Creates a plain object from an AdGroupAdErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.AdGroupAdErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.AdGroupAdErrorEnum} message AdGroupAdErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupAdErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdGroupAdErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.AdGroupAdErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupAdErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdGroupAdError enum.
                         * @name google.ads.googleads.v1.errors.AdGroupAdErrorEnum.AdGroupAdError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} AD_GROUP_AD_LABEL_DOES_NOT_EXIST=2 AD_GROUP_AD_LABEL_DOES_NOT_EXIST value
                         * @property {number} AD_GROUP_AD_LABEL_ALREADY_EXISTS=3 AD_GROUP_AD_LABEL_ALREADY_EXISTS value
                         * @property {number} AD_NOT_UNDER_ADGROUP=4 AD_NOT_UNDER_ADGROUP value
                         * @property {number} CANNOT_OPERATE_ON_REMOVED_ADGROUPAD=5 CANNOT_OPERATE_ON_REMOVED_ADGROUPAD value
                         * @property {number} CANNOT_CREATE_DEPRECATED_ADS=6 CANNOT_CREATE_DEPRECATED_ADS value
                         * @property {number} CANNOT_CREATE_TEXT_ADS=7 CANNOT_CREATE_TEXT_ADS value
                         * @property {number} EMPTY_FIELD=8 EMPTY_FIELD value
                         * @property {number} RESOURCE_REFERENCED_IN_MULTIPLE_OPS=9 RESOURCE_REFERENCED_IN_MULTIPLE_OPS value
                         */
                        AdGroupAdErrorEnum.AdGroupAdError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "AD_GROUP_AD_LABEL_DOES_NOT_EXIST"] = 2;
                            values[valuesById[3] = "AD_GROUP_AD_LABEL_ALREADY_EXISTS"] = 3;
                            values[valuesById[4] = "AD_NOT_UNDER_ADGROUP"] = 4;
                            values[valuesById[5] = "CANNOT_OPERATE_ON_REMOVED_ADGROUPAD"] = 5;
                            values[valuesById[6] = "CANNOT_CREATE_DEPRECATED_ADS"] = 6;
                            values[valuesById[7] = "CANNOT_CREATE_TEXT_ADS"] = 7;
                            values[valuesById[8] = "EMPTY_FIELD"] = 8;
                            values[valuesById[9] = "RESOURCE_REFERENCED_IN_MULTIPLE_OPS"] = 9;
                            return values;
                        })();

                        return AdGroupAdErrorEnum;
                    })();

                    errors.AdGroupBidModifierErrorEnum = (function() {

                        /**
                         * Properties of an AdGroupBidModifierErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IAdGroupBidModifierErrorEnum
                         */

                        /**
                         * Constructs a new AdGroupBidModifierErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an AdGroupBidModifierErrorEnum.
                         * @implements IAdGroupBidModifierErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IAdGroupBidModifierErrorEnum=} [properties] Properties to set
                         */
                        function AdGroupBidModifierErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdGroupBidModifierErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdGroupBidModifierErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum} AdGroupBidModifierErrorEnum instance
                         */
                        AdGroupBidModifierErrorEnum.create = function create(properties) {
                            return new AdGroupBidModifierErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified AdGroupBidModifierErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdGroupBidModifierErrorEnum} message AdGroupBidModifierErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupBidModifierErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupBidModifierErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdGroupBidModifierErrorEnum} message AdGroupBidModifierErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupBidModifierErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupBidModifierErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum} AdGroupBidModifierErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupBidModifierErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupBidModifierErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum} AdGroupBidModifierErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupBidModifierErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupBidModifierErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupBidModifierErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdGroupBidModifierErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum} AdGroupBidModifierErrorEnum
                         */
                        AdGroupBidModifierErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum();
                        };

                        /**
                         * Creates a plain object from an AdGroupBidModifierErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum} message AdGroupBidModifierErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupBidModifierErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdGroupBidModifierErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupBidModifierErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdGroupBidModifierError enum.
                         * @name google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum.AdGroupBidModifierError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CRITERION_ID_NOT_SUPPORTED=2 CRITERION_ID_NOT_SUPPORTED value
                         * @property {number} CANNOT_OVERRIDE_OPTED_OUT_CAMPAIGN_CRITERION_BID_MODIFIER=3 CANNOT_OVERRIDE_OPTED_OUT_CAMPAIGN_CRITERION_BID_MODIFIER value
                         */
                        AdGroupBidModifierErrorEnum.AdGroupBidModifierError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CRITERION_ID_NOT_SUPPORTED"] = 2;
                            values[valuesById[3] = "CANNOT_OVERRIDE_OPTED_OUT_CAMPAIGN_CRITERION_BID_MODIFIER"] = 3;
                            return values;
                        })();

                        return AdGroupBidModifierErrorEnum;
                    })();

                    errors.AdGroupCriterionErrorEnum = (function() {

                        /**
                         * Properties of an AdGroupCriterionErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IAdGroupCriterionErrorEnum
                         */

                        /**
                         * Constructs a new AdGroupCriterionErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an AdGroupCriterionErrorEnum.
                         * @implements IAdGroupCriterionErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IAdGroupCriterionErrorEnum=} [properties] Properties to set
                         */
                        function AdGroupCriterionErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdGroupCriterionErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdGroupCriterionErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum} AdGroupCriterionErrorEnum instance
                         */
                        AdGroupCriterionErrorEnum.create = function create(properties) {
                            return new AdGroupCriterionErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified AdGroupCriterionErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdGroupCriterionErrorEnum} message AdGroupCriterionErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupCriterionErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupCriterionErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdGroupCriterionErrorEnum} message AdGroupCriterionErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupCriterionErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupCriterionErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum} AdGroupCriterionErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupCriterionErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupCriterionErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum} AdGroupCriterionErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupCriterionErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupCriterionErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupCriterionErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdGroupCriterionErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum} AdGroupCriterionErrorEnum
                         */
                        AdGroupCriterionErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum();
                        };

                        /**
                         * Creates a plain object from an AdGroupCriterionErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum} message AdGroupCriterionErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupCriterionErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdGroupCriterionErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupCriterionErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdGroupCriterionError enum.
                         * @name google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum.AdGroupCriterionError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} AD_GROUP_CRITERION_LABEL_DOES_NOT_EXIST=2 AD_GROUP_CRITERION_LABEL_DOES_NOT_EXIST value
                         * @property {number} AD_GROUP_CRITERION_LABEL_ALREADY_EXISTS=3 AD_GROUP_CRITERION_LABEL_ALREADY_EXISTS value
                         * @property {number} CANNOT_ADD_LABEL_TO_NEGATIVE_CRITERION=4 CANNOT_ADD_LABEL_TO_NEGATIVE_CRITERION value
                         * @property {number} TOO_MANY_OPERATIONS=5 TOO_MANY_OPERATIONS value
                         * @property {number} CANT_UPDATE_NEGATIVE=6 CANT_UPDATE_NEGATIVE value
                         * @property {number} CONCRETE_TYPE_REQUIRED=7 CONCRETE_TYPE_REQUIRED value
                         * @property {number} BID_INCOMPATIBLE_WITH_ADGROUP=8 BID_INCOMPATIBLE_WITH_ADGROUP value
                         * @property {number} CANNOT_TARGET_AND_EXCLUDE=9 CANNOT_TARGET_AND_EXCLUDE value
                         * @property {number} ILLEGAL_URL=10 ILLEGAL_URL value
                         * @property {number} INVALID_KEYWORD_TEXT=11 INVALID_KEYWORD_TEXT value
                         * @property {number} INVALID_DESTINATION_URL=12 INVALID_DESTINATION_URL value
                         * @property {number} MISSING_DESTINATION_URL_TAG=13 MISSING_DESTINATION_URL_TAG value
                         * @property {number} KEYWORD_LEVEL_BID_NOT_SUPPORTED_FOR_MANUALCPM=14 KEYWORD_LEVEL_BID_NOT_SUPPORTED_FOR_MANUALCPM value
                         * @property {number} INVALID_USER_STATUS=15 INVALID_USER_STATUS value
                         * @property {number} CANNOT_ADD_CRITERIA_TYPE=16 CANNOT_ADD_CRITERIA_TYPE value
                         * @property {number} CANNOT_EXCLUDE_CRITERIA_TYPE=17 CANNOT_EXCLUDE_CRITERIA_TYPE value
                         * @property {number} CAMPAIGN_TYPE_NOT_COMPATIBLE_WITH_PARTIAL_FAILURE=27 CAMPAIGN_TYPE_NOT_COMPATIBLE_WITH_PARTIAL_FAILURE value
                         * @property {number} OPERATIONS_FOR_TOO_MANY_SHOPPING_ADGROUPS=28 OPERATIONS_FOR_TOO_MANY_SHOPPING_ADGROUPS value
                         * @property {number} CANNOT_MODIFY_URL_FIELDS_WITH_DUPLICATE_ELEMENTS=29 CANNOT_MODIFY_URL_FIELDS_WITH_DUPLICATE_ELEMENTS value
                         * @property {number} CANNOT_SET_WITHOUT_FINAL_URLS=30 CANNOT_SET_WITHOUT_FINAL_URLS value
                         * @property {number} CANNOT_CLEAR_FINAL_URLS_IF_FINAL_MOBILE_URLS_EXIST=31 CANNOT_CLEAR_FINAL_URLS_IF_FINAL_MOBILE_URLS_EXIST value
                         * @property {number} CANNOT_CLEAR_FINAL_URLS_IF_FINAL_APP_URLS_EXIST=32 CANNOT_CLEAR_FINAL_URLS_IF_FINAL_APP_URLS_EXIST value
                         * @property {number} CANNOT_CLEAR_FINAL_URLS_IF_TRACKING_URL_TEMPLATE_EXISTS=33 CANNOT_CLEAR_FINAL_URLS_IF_TRACKING_URL_TEMPLATE_EXISTS value
                         * @property {number} CANNOT_CLEAR_FINAL_URLS_IF_URL_CUSTOM_PARAMETERS_EXIST=34 CANNOT_CLEAR_FINAL_URLS_IF_URL_CUSTOM_PARAMETERS_EXIST value
                         * @property {number} CANNOT_SET_BOTH_DESTINATION_URL_AND_FINAL_URLS=35 CANNOT_SET_BOTH_DESTINATION_URL_AND_FINAL_URLS value
                         * @property {number} CANNOT_SET_BOTH_DESTINATION_URL_AND_TRACKING_URL_TEMPLATE=36 CANNOT_SET_BOTH_DESTINATION_URL_AND_TRACKING_URL_TEMPLATE value
                         * @property {number} FINAL_URLS_NOT_SUPPORTED_FOR_CRITERION_TYPE=37 FINAL_URLS_NOT_SUPPORTED_FOR_CRITERION_TYPE value
                         * @property {number} FINAL_MOBILE_URLS_NOT_SUPPORTED_FOR_CRITERION_TYPE=38 FINAL_MOBILE_URLS_NOT_SUPPORTED_FOR_CRITERION_TYPE value
                         * @property {number} INVALID_LISTING_GROUP_HIERARCHY=39 INVALID_LISTING_GROUP_HIERARCHY value
                         * @property {number} LISTING_GROUP_UNIT_CANNOT_HAVE_CHILDREN=40 LISTING_GROUP_UNIT_CANNOT_HAVE_CHILDREN value
                         * @property {number} LISTING_GROUP_SUBDIVISION_REQUIRES_OTHERS_CASE=41 LISTING_GROUP_SUBDIVISION_REQUIRES_OTHERS_CASE value
                         * @property {number} LISTING_GROUP_REQUIRES_SAME_DIMENSION_TYPE_AS_SIBLINGS=42 LISTING_GROUP_REQUIRES_SAME_DIMENSION_TYPE_AS_SIBLINGS value
                         * @property {number} LISTING_GROUP_ALREADY_EXISTS=43 LISTING_GROUP_ALREADY_EXISTS value
                         * @property {number} LISTING_GROUP_DOES_NOT_EXIST=44 LISTING_GROUP_DOES_NOT_EXIST value
                         * @property {number} LISTING_GROUP_CANNOT_BE_REMOVED=45 LISTING_GROUP_CANNOT_BE_REMOVED value
                         * @property {number} INVALID_LISTING_GROUP_TYPE=46 INVALID_LISTING_GROUP_TYPE value
                         * @property {number} LISTING_GROUP_ADD_MAY_ONLY_USE_TEMP_ID=47 LISTING_GROUP_ADD_MAY_ONLY_USE_TEMP_ID value
                         */
                        AdGroupCriterionErrorEnum.AdGroupCriterionError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "AD_GROUP_CRITERION_LABEL_DOES_NOT_EXIST"] = 2;
                            values[valuesById[3] = "AD_GROUP_CRITERION_LABEL_ALREADY_EXISTS"] = 3;
                            values[valuesById[4] = "CANNOT_ADD_LABEL_TO_NEGATIVE_CRITERION"] = 4;
                            values[valuesById[5] = "TOO_MANY_OPERATIONS"] = 5;
                            values[valuesById[6] = "CANT_UPDATE_NEGATIVE"] = 6;
                            values[valuesById[7] = "CONCRETE_TYPE_REQUIRED"] = 7;
                            values[valuesById[8] = "BID_INCOMPATIBLE_WITH_ADGROUP"] = 8;
                            values[valuesById[9] = "CANNOT_TARGET_AND_EXCLUDE"] = 9;
                            values[valuesById[10] = "ILLEGAL_URL"] = 10;
                            values[valuesById[11] = "INVALID_KEYWORD_TEXT"] = 11;
                            values[valuesById[12] = "INVALID_DESTINATION_URL"] = 12;
                            values[valuesById[13] = "MISSING_DESTINATION_URL_TAG"] = 13;
                            values[valuesById[14] = "KEYWORD_LEVEL_BID_NOT_SUPPORTED_FOR_MANUALCPM"] = 14;
                            values[valuesById[15] = "INVALID_USER_STATUS"] = 15;
                            values[valuesById[16] = "CANNOT_ADD_CRITERIA_TYPE"] = 16;
                            values[valuesById[17] = "CANNOT_EXCLUDE_CRITERIA_TYPE"] = 17;
                            values[valuesById[27] = "CAMPAIGN_TYPE_NOT_COMPATIBLE_WITH_PARTIAL_FAILURE"] = 27;
                            values[valuesById[28] = "OPERATIONS_FOR_TOO_MANY_SHOPPING_ADGROUPS"] = 28;
                            values[valuesById[29] = "CANNOT_MODIFY_URL_FIELDS_WITH_DUPLICATE_ELEMENTS"] = 29;
                            values[valuesById[30] = "CANNOT_SET_WITHOUT_FINAL_URLS"] = 30;
                            values[valuesById[31] = "CANNOT_CLEAR_FINAL_URLS_IF_FINAL_MOBILE_URLS_EXIST"] = 31;
                            values[valuesById[32] = "CANNOT_CLEAR_FINAL_URLS_IF_FINAL_APP_URLS_EXIST"] = 32;
                            values[valuesById[33] = "CANNOT_CLEAR_FINAL_URLS_IF_TRACKING_URL_TEMPLATE_EXISTS"] = 33;
                            values[valuesById[34] = "CANNOT_CLEAR_FINAL_URLS_IF_URL_CUSTOM_PARAMETERS_EXIST"] = 34;
                            values[valuesById[35] = "CANNOT_SET_BOTH_DESTINATION_URL_AND_FINAL_URLS"] = 35;
                            values[valuesById[36] = "CANNOT_SET_BOTH_DESTINATION_URL_AND_TRACKING_URL_TEMPLATE"] = 36;
                            values[valuesById[37] = "FINAL_URLS_NOT_SUPPORTED_FOR_CRITERION_TYPE"] = 37;
                            values[valuesById[38] = "FINAL_MOBILE_URLS_NOT_SUPPORTED_FOR_CRITERION_TYPE"] = 38;
                            values[valuesById[39] = "INVALID_LISTING_GROUP_HIERARCHY"] = 39;
                            values[valuesById[40] = "LISTING_GROUP_UNIT_CANNOT_HAVE_CHILDREN"] = 40;
                            values[valuesById[41] = "LISTING_GROUP_SUBDIVISION_REQUIRES_OTHERS_CASE"] = 41;
                            values[valuesById[42] = "LISTING_GROUP_REQUIRES_SAME_DIMENSION_TYPE_AS_SIBLINGS"] = 42;
                            values[valuesById[43] = "LISTING_GROUP_ALREADY_EXISTS"] = 43;
                            values[valuesById[44] = "LISTING_GROUP_DOES_NOT_EXIST"] = 44;
                            values[valuesById[45] = "LISTING_GROUP_CANNOT_BE_REMOVED"] = 45;
                            values[valuesById[46] = "INVALID_LISTING_GROUP_TYPE"] = 46;
                            values[valuesById[47] = "LISTING_GROUP_ADD_MAY_ONLY_USE_TEMP_ID"] = 47;
                            return values;
                        })();

                        return AdGroupCriterionErrorEnum;
                    })();

                    errors.AdGroupErrorEnum = (function() {

                        /**
                         * Properties of an AdGroupErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IAdGroupErrorEnum
                         */

                        /**
                         * Constructs a new AdGroupErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an AdGroupErrorEnum.
                         * @implements IAdGroupErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IAdGroupErrorEnum=} [properties] Properties to set
                         */
                        function AdGroupErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdGroupErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.AdGroupErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdGroupErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.AdGroupErrorEnum} AdGroupErrorEnum instance
                         */
                        AdGroupErrorEnum.create = function create(properties) {
                            return new AdGroupErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified AdGroupErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.AdGroupErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.AdGroupErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdGroupErrorEnum} message AdGroupErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.AdGroupErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdGroupErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdGroupErrorEnum} message AdGroupErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.AdGroupErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.AdGroupErrorEnum} AdGroupErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.AdGroupErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdGroupErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.AdGroupErrorEnum} AdGroupErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.AdGroupErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdGroupErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.AdGroupErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.AdGroupErrorEnum} AdGroupErrorEnum
                         */
                        AdGroupErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.AdGroupErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.AdGroupErrorEnum();
                        };

                        /**
                         * Creates a plain object from an AdGroupErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.AdGroupErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.AdGroupErrorEnum} message AdGroupErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdGroupErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.AdGroupErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdGroupError enum.
                         * @name google.ads.googleads.v1.errors.AdGroupErrorEnum.AdGroupError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} DUPLICATE_ADGROUP_NAME=2 DUPLICATE_ADGROUP_NAME value
                         * @property {number} INVALID_ADGROUP_NAME=3 INVALID_ADGROUP_NAME value
                         * @property {number} ADVERTISER_NOT_ON_CONTENT_NETWORK=5 ADVERTISER_NOT_ON_CONTENT_NETWORK value
                         * @property {number} BID_TOO_BIG=6 BID_TOO_BIG value
                         * @property {number} BID_TYPE_AND_BIDDING_STRATEGY_MISMATCH=7 BID_TYPE_AND_BIDDING_STRATEGY_MISMATCH value
                         * @property {number} MISSING_ADGROUP_NAME=8 MISSING_ADGROUP_NAME value
                         * @property {number} ADGROUP_LABEL_DOES_NOT_EXIST=9 ADGROUP_LABEL_DOES_NOT_EXIST value
                         * @property {number} ADGROUP_LABEL_ALREADY_EXISTS=10 ADGROUP_LABEL_ALREADY_EXISTS value
                         * @property {number} INVALID_CONTENT_BID_CRITERION_TYPE_GROUP=11 INVALID_CONTENT_BID_CRITERION_TYPE_GROUP value
                         * @property {number} AD_GROUP_TYPE_NOT_VALID_FOR_ADVERTISING_CHANNEL_TYPE=12 AD_GROUP_TYPE_NOT_VALID_FOR_ADVERTISING_CHANNEL_TYPE value
                         * @property {number} ADGROUP_TYPE_NOT_SUPPORTED_FOR_CAMPAIGN_SALES_COUNTRY=13 ADGROUP_TYPE_NOT_SUPPORTED_FOR_CAMPAIGN_SALES_COUNTRY value
                         * @property {number} CANNOT_ADD_ADGROUP_OF_TYPE_DSA_TO_CAMPAIGN_WITHOUT_DSA_SETTING=14 CANNOT_ADD_ADGROUP_OF_TYPE_DSA_TO_CAMPAIGN_WITHOUT_DSA_SETTING value
                         */
                        AdGroupErrorEnum.AdGroupError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "DUPLICATE_ADGROUP_NAME"] = 2;
                            values[valuesById[3] = "INVALID_ADGROUP_NAME"] = 3;
                            values[valuesById[5] = "ADVERTISER_NOT_ON_CONTENT_NETWORK"] = 5;
                            values[valuesById[6] = "BID_TOO_BIG"] = 6;
                            values[valuesById[7] = "BID_TYPE_AND_BIDDING_STRATEGY_MISMATCH"] = 7;
                            values[valuesById[8] = "MISSING_ADGROUP_NAME"] = 8;
                            values[valuesById[9] = "ADGROUP_LABEL_DOES_NOT_EXIST"] = 9;
                            values[valuesById[10] = "ADGROUP_LABEL_ALREADY_EXISTS"] = 10;
                            values[valuesById[11] = "INVALID_CONTENT_BID_CRITERION_TYPE_GROUP"] = 11;
                            values[valuesById[12] = "AD_GROUP_TYPE_NOT_VALID_FOR_ADVERTISING_CHANNEL_TYPE"] = 12;
                            values[valuesById[13] = "ADGROUP_TYPE_NOT_SUPPORTED_FOR_CAMPAIGN_SALES_COUNTRY"] = 13;
                            values[valuesById[14] = "CANNOT_ADD_ADGROUP_OF_TYPE_DSA_TO_CAMPAIGN_WITHOUT_DSA_SETTING"] = 14;
                            return values;
                        })();

                        return AdGroupErrorEnum;
                    })();

                    errors.AdGroupFeedErrorEnum = (function() {

                        /**
                         * Properties of an AdGroupFeedErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IAdGroupFeedErrorEnum
                         */

                        /**
                         * Constructs a new AdGroupFeedErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an AdGroupFeedErrorEnum.
                         * @implements IAdGroupFeedErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IAdGroupFeedErrorEnum=} [properties] Properties to set
                         */
                        function AdGroupFeedErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdGroupFeedErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.AdGroupFeedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdGroupFeedErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.AdGroupFeedErrorEnum} AdGroupFeedErrorEnum instance
                         */
                        AdGroupFeedErrorEnum.create = function create(properties) {
                            return new AdGroupFeedErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified AdGroupFeedErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.AdGroupFeedErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.AdGroupFeedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdGroupFeedErrorEnum} message AdGroupFeedErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupFeedErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupFeedErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.AdGroupFeedErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdGroupFeedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdGroupFeedErrorEnum} message AdGroupFeedErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupFeedErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupFeedErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.AdGroupFeedErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.AdGroupFeedErrorEnum} AdGroupFeedErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupFeedErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.AdGroupFeedErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupFeedErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdGroupFeedErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.AdGroupFeedErrorEnum} AdGroupFeedErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupFeedErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupFeedErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.AdGroupFeedErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupFeedErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdGroupFeedErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.AdGroupFeedErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.AdGroupFeedErrorEnum} AdGroupFeedErrorEnum
                         */
                        AdGroupFeedErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.AdGroupFeedErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.AdGroupFeedErrorEnum();
                        };

                        /**
                         * Creates a plain object from an AdGroupFeedErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.AdGroupFeedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.AdGroupFeedErrorEnum} message AdGroupFeedErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupFeedErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdGroupFeedErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.AdGroupFeedErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupFeedErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdGroupFeedError enum.
                         * @name google.ads.googleads.v1.errors.AdGroupFeedErrorEnum.AdGroupFeedError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE=2 FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE value
                         * @property {number} CANNOT_CREATE_FOR_REMOVED_FEED=3 CANNOT_CREATE_FOR_REMOVED_FEED value
                         * @property {number} ADGROUP_FEED_ALREADY_EXISTS=4 ADGROUP_FEED_ALREADY_EXISTS value
                         * @property {number} CANNOT_OPERATE_ON_REMOVED_ADGROUP_FEED=5 CANNOT_OPERATE_ON_REMOVED_ADGROUP_FEED value
                         * @property {number} INVALID_PLACEHOLDER_TYPE=6 INVALID_PLACEHOLDER_TYPE value
                         * @property {number} MISSING_FEEDMAPPING_FOR_PLACEHOLDER_TYPE=7 MISSING_FEEDMAPPING_FOR_PLACEHOLDER_TYPE value
                         * @property {number} NO_EXISTING_LOCATION_CUSTOMER_FEED=8 NO_EXISTING_LOCATION_CUSTOMER_FEED value
                         */
                        AdGroupFeedErrorEnum.AdGroupFeedError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE"] = 2;
                            values[valuesById[3] = "CANNOT_CREATE_FOR_REMOVED_FEED"] = 3;
                            values[valuesById[4] = "ADGROUP_FEED_ALREADY_EXISTS"] = 4;
                            values[valuesById[5] = "CANNOT_OPERATE_ON_REMOVED_ADGROUP_FEED"] = 5;
                            values[valuesById[6] = "INVALID_PLACEHOLDER_TYPE"] = 6;
                            values[valuesById[7] = "MISSING_FEEDMAPPING_FOR_PLACEHOLDER_TYPE"] = 7;
                            values[valuesById[8] = "NO_EXISTING_LOCATION_CUSTOMER_FEED"] = 8;
                            return values;
                        })();

                        return AdGroupFeedErrorEnum;
                    })();

                    errors.AdParameterErrorEnum = (function() {

                        /**
                         * Properties of an AdParameterErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IAdParameterErrorEnum
                         */

                        /**
                         * Constructs a new AdParameterErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an AdParameterErrorEnum.
                         * @implements IAdParameterErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IAdParameterErrorEnum=} [properties] Properties to set
                         */
                        function AdParameterErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdParameterErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.AdParameterErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdParameterErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.AdParameterErrorEnum} AdParameterErrorEnum instance
                         */
                        AdParameterErrorEnum.create = function create(properties) {
                            return new AdParameterErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified AdParameterErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.AdParameterErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.AdParameterErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdParameterErrorEnum} message AdParameterErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdParameterErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdParameterErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.AdParameterErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdParameterErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdParameterErrorEnum} message AdParameterErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdParameterErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdParameterErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.AdParameterErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.AdParameterErrorEnum} AdParameterErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdParameterErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.AdParameterErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdParameterErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdParameterErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.AdParameterErrorEnum} AdParameterErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdParameterErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdParameterErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.AdParameterErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdParameterErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdParameterErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.AdParameterErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.AdParameterErrorEnum} AdParameterErrorEnum
                         */
                        AdParameterErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.AdParameterErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.AdParameterErrorEnum();
                        };

                        /**
                         * Creates a plain object from an AdParameterErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.AdParameterErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.AdParameterErrorEnum} message AdParameterErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdParameterErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdParameterErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.AdParameterErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdParameterErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdParameterError enum.
                         * @name google.ads.googleads.v1.errors.AdParameterErrorEnum.AdParameterError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} AD_GROUP_CRITERION_MUST_BE_KEYWORD=2 AD_GROUP_CRITERION_MUST_BE_KEYWORD value
                         * @property {number} INVALID_INSERTION_TEXT_FORMAT=3 INVALID_INSERTION_TEXT_FORMAT value
                         */
                        AdParameterErrorEnum.AdParameterError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "AD_GROUP_CRITERION_MUST_BE_KEYWORD"] = 2;
                            values[valuesById[3] = "INVALID_INSERTION_TEXT_FORMAT"] = 3;
                            return values;
                        })();

                        return AdParameterErrorEnum;
                    })();

                    errors.AdSharingErrorEnum = (function() {

                        /**
                         * Properties of an AdSharingErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IAdSharingErrorEnum
                         */

                        /**
                         * Constructs a new AdSharingErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an AdSharingErrorEnum.
                         * @implements IAdSharingErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IAdSharingErrorEnum=} [properties] Properties to set
                         */
                        function AdSharingErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdSharingErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.AdSharingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdSharingErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.AdSharingErrorEnum} AdSharingErrorEnum instance
                         */
                        AdSharingErrorEnum.create = function create(properties) {
                            return new AdSharingErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified AdSharingErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.AdSharingErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.AdSharingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdSharingErrorEnum} message AdSharingErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdSharingErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdSharingErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.AdSharingErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdSharingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdSharingErrorEnum} message AdSharingErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdSharingErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdSharingErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.AdSharingErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.AdSharingErrorEnum} AdSharingErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdSharingErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.AdSharingErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdSharingErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdSharingErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.AdSharingErrorEnum} AdSharingErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdSharingErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdSharingErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.AdSharingErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdSharingErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdSharingErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.AdSharingErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.AdSharingErrorEnum} AdSharingErrorEnum
                         */
                        AdSharingErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.AdSharingErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.AdSharingErrorEnum();
                        };

                        /**
                         * Creates a plain object from an AdSharingErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.AdSharingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.AdSharingErrorEnum} message AdSharingErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdSharingErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdSharingErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.AdSharingErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdSharingErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdSharingError enum.
                         * @name google.ads.googleads.v1.errors.AdSharingErrorEnum.AdSharingError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} AD_GROUP_ALREADY_CONTAINS_AD=2 AD_GROUP_ALREADY_CONTAINS_AD value
                         * @property {number} INCOMPATIBLE_AD_UNDER_AD_GROUP=3 INCOMPATIBLE_AD_UNDER_AD_GROUP value
                         * @property {number} CANNOT_SHARE_INACTIVE_AD=4 CANNOT_SHARE_INACTIVE_AD value
                         */
                        AdSharingErrorEnum.AdSharingError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "AD_GROUP_ALREADY_CONTAINS_AD"] = 2;
                            values[valuesById[3] = "INCOMPATIBLE_AD_UNDER_AD_GROUP"] = 3;
                            values[valuesById[4] = "CANNOT_SHARE_INACTIVE_AD"] = 4;
                            return values;
                        })();

                        return AdSharingErrorEnum;
                    })();

                    errors.AdxErrorEnum = (function() {

                        /**
                         * Properties of an AdxErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IAdxErrorEnum
                         */

                        /**
                         * Constructs a new AdxErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an AdxErrorEnum.
                         * @implements IAdxErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IAdxErrorEnum=} [properties] Properties to set
                         */
                        function AdxErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdxErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.AdxErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdxErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.AdxErrorEnum} AdxErrorEnum instance
                         */
                        AdxErrorEnum.create = function create(properties) {
                            return new AdxErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified AdxErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.AdxErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.AdxErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdxErrorEnum} message AdxErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdxErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdxErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.AdxErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdxErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAdxErrorEnum} message AdxErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdxErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdxErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.AdxErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.AdxErrorEnum} AdxErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdxErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.AdxErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdxErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AdxErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.AdxErrorEnum} AdxErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdxErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdxErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.AdxErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdxErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdxErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.AdxErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.AdxErrorEnum} AdxErrorEnum
                         */
                        AdxErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.AdxErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.AdxErrorEnum();
                        };

                        /**
                         * Creates a plain object from an AdxErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.AdxErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.AdxErrorEnum} message AdxErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdxErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdxErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.AdxErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdxErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdxError enum.
                         * @name google.ads.googleads.v1.errors.AdxErrorEnum.AdxError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} UNSUPPORTED_FEATURE=2 UNSUPPORTED_FEATURE value
                         */
                        AdxErrorEnum.AdxError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "UNSUPPORTED_FEATURE"] = 2;
                            return values;
                        })();

                        return AdxErrorEnum;
                    })();

                    errors.AssetErrorEnum = (function() {

                        /**
                         * Properties of an AssetErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IAssetErrorEnum
                         */

                        /**
                         * Constructs a new AssetErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an AssetErrorEnum.
                         * @implements IAssetErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IAssetErrorEnum=} [properties] Properties to set
                         */
                        function AssetErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AssetErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.AssetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAssetErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.AssetErrorEnum} AssetErrorEnum instance
                         */
                        AssetErrorEnum.create = function create(properties) {
                            return new AssetErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified AssetErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.AssetErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.AssetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAssetErrorEnum} message AssetErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AssetErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AssetErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.AssetErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AssetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAssetErrorEnum} message AssetErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AssetErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AssetErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.AssetErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.AssetErrorEnum} AssetErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AssetErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.AssetErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AssetErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AssetErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.AssetErrorEnum} AssetErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AssetErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AssetErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.AssetErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AssetErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AssetErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.AssetErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.AssetErrorEnum} AssetErrorEnum
                         */
                        AssetErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.AssetErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.AssetErrorEnum();
                        };

                        /**
                         * Creates a plain object from an AssetErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.AssetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.AssetErrorEnum} message AssetErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AssetErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AssetErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.AssetErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AssetErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AssetError enum.
                         * @name google.ads.googleads.v1.errors.AssetErrorEnum.AssetError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CUSTOMER_NOT_WHITELISTED_FOR_ASSET_TYPE=2 CUSTOMER_NOT_WHITELISTED_FOR_ASSET_TYPE value
                         * @property {number} DUPLICATE_ASSET=3 DUPLICATE_ASSET value
                         * @property {number} DUPLICATE_ASSET_NAME=4 DUPLICATE_ASSET_NAME value
                         * @property {number} ASSET_DATA_IS_MISSING=5 ASSET_DATA_IS_MISSING value
                         * @property {number} CANNOT_MODIFY_ASSET_NAME=6 CANNOT_MODIFY_ASSET_NAME value
                         */
                        AssetErrorEnum.AssetError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CUSTOMER_NOT_WHITELISTED_FOR_ASSET_TYPE"] = 2;
                            values[valuesById[3] = "DUPLICATE_ASSET"] = 3;
                            values[valuesById[4] = "DUPLICATE_ASSET_NAME"] = 4;
                            values[valuesById[5] = "ASSET_DATA_IS_MISSING"] = 5;
                            values[valuesById[6] = "CANNOT_MODIFY_ASSET_NAME"] = 6;
                            return values;
                        })();

                        return AssetErrorEnum;
                    })();

                    errors.AuthenticationErrorEnum = (function() {

                        /**
                         * Properties of an AuthenticationErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IAuthenticationErrorEnum
                         */

                        /**
                         * Constructs a new AuthenticationErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an AuthenticationErrorEnum.
                         * @implements IAuthenticationErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IAuthenticationErrorEnum=} [properties] Properties to set
                         */
                        function AuthenticationErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AuthenticationErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.AuthenticationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAuthenticationErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.AuthenticationErrorEnum} AuthenticationErrorEnum instance
                         */
                        AuthenticationErrorEnum.create = function create(properties) {
                            return new AuthenticationErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified AuthenticationErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.AuthenticationErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.AuthenticationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAuthenticationErrorEnum} message AuthenticationErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AuthenticationErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AuthenticationErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.AuthenticationErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AuthenticationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAuthenticationErrorEnum} message AuthenticationErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AuthenticationErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AuthenticationErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.AuthenticationErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.AuthenticationErrorEnum} AuthenticationErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AuthenticationErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.AuthenticationErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AuthenticationErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AuthenticationErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.AuthenticationErrorEnum} AuthenticationErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AuthenticationErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AuthenticationErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.AuthenticationErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AuthenticationErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AuthenticationErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.AuthenticationErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.AuthenticationErrorEnum} AuthenticationErrorEnum
                         */
                        AuthenticationErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.AuthenticationErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.AuthenticationErrorEnum();
                        };

                        /**
                         * Creates a plain object from an AuthenticationErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.AuthenticationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.AuthenticationErrorEnum} message AuthenticationErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AuthenticationErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AuthenticationErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.AuthenticationErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AuthenticationErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AuthenticationError enum.
                         * @name google.ads.googleads.v1.errors.AuthenticationErrorEnum.AuthenticationError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} AUTHENTICATION_ERROR=2 AUTHENTICATION_ERROR value
                         * @property {number} CLIENT_CUSTOMER_ID_INVALID=5 CLIENT_CUSTOMER_ID_INVALID value
                         * @property {number} CUSTOMER_NOT_FOUND=8 CUSTOMER_NOT_FOUND value
                         * @property {number} GOOGLE_ACCOUNT_DELETED=9 GOOGLE_ACCOUNT_DELETED value
                         * @property {number} GOOGLE_ACCOUNT_COOKIE_INVALID=10 GOOGLE_ACCOUNT_COOKIE_INVALID value
                         * @property {number} GOOGLE_ACCOUNT_AUTHENTICATION_FAILED=25 GOOGLE_ACCOUNT_AUTHENTICATION_FAILED value
                         * @property {number} GOOGLE_ACCOUNT_USER_AND_ADS_USER_MISMATCH=12 GOOGLE_ACCOUNT_USER_AND_ADS_USER_MISMATCH value
                         * @property {number} LOGIN_COOKIE_REQUIRED=13 LOGIN_COOKIE_REQUIRED value
                         * @property {number} NOT_ADS_USER=14 NOT_ADS_USER value
                         * @property {number} OAUTH_TOKEN_INVALID=15 OAUTH_TOKEN_INVALID value
                         * @property {number} OAUTH_TOKEN_EXPIRED=16 OAUTH_TOKEN_EXPIRED value
                         * @property {number} OAUTH_TOKEN_DISABLED=17 OAUTH_TOKEN_DISABLED value
                         * @property {number} OAUTH_TOKEN_REVOKED=18 OAUTH_TOKEN_REVOKED value
                         * @property {number} OAUTH_TOKEN_HEADER_INVALID=19 OAUTH_TOKEN_HEADER_INVALID value
                         * @property {number} LOGIN_COOKIE_INVALID=20 LOGIN_COOKIE_INVALID value
                         * @property {number} USER_ID_INVALID=22 USER_ID_INVALID value
                         * @property {number} TWO_STEP_VERIFICATION_NOT_ENROLLED=23 TWO_STEP_VERIFICATION_NOT_ENROLLED value
                         * @property {number} ADVANCED_PROTECTION_NOT_ENROLLED=24 ADVANCED_PROTECTION_NOT_ENROLLED value
                         */
                        AuthenticationErrorEnum.AuthenticationError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "AUTHENTICATION_ERROR"] = 2;
                            values[valuesById[5] = "CLIENT_CUSTOMER_ID_INVALID"] = 5;
                            values[valuesById[8] = "CUSTOMER_NOT_FOUND"] = 8;
                            values[valuesById[9] = "GOOGLE_ACCOUNT_DELETED"] = 9;
                            values[valuesById[10] = "GOOGLE_ACCOUNT_COOKIE_INVALID"] = 10;
                            values[valuesById[25] = "GOOGLE_ACCOUNT_AUTHENTICATION_FAILED"] = 25;
                            values[valuesById[12] = "GOOGLE_ACCOUNT_USER_AND_ADS_USER_MISMATCH"] = 12;
                            values[valuesById[13] = "LOGIN_COOKIE_REQUIRED"] = 13;
                            values[valuesById[14] = "NOT_ADS_USER"] = 14;
                            values[valuesById[15] = "OAUTH_TOKEN_INVALID"] = 15;
                            values[valuesById[16] = "OAUTH_TOKEN_EXPIRED"] = 16;
                            values[valuesById[17] = "OAUTH_TOKEN_DISABLED"] = 17;
                            values[valuesById[18] = "OAUTH_TOKEN_REVOKED"] = 18;
                            values[valuesById[19] = "OAUTH_TOKEN_HEADER_INVALID"] = 19;
                            values[valuesById[20] = "LOGIN_COOKIE_INVALID"] = 20;
                            values[valuesById[22] = "USER_ID_INVALID"] = 22;
                            values[valuesById[23] = "TWO_STEP_VERIFICATION_NOT_ENROLLED"] = 23;
                            values[valuesById[24] = "ADVANCED_PROTECTION_NOT_ENROLLED"] = 24;
                            return values;
                        })();

                        return AuthenticationErrorEnum;
                    })();

                    errors.AuthorizationErrorEnum = (function() {

                        /**
                         * Properties of an AuthorizationErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IAuthorizationErrorEnum
                         */

                        /**
                         * Constructs a new AuthorizationErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an AuthorizationErrorEnum.
                         * @implements IAuthorizationErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IAuthorizationErrorEnum=} [properties] Properties to set
                         */
                        function AuthorizationErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AuthorizationErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.AuthorizationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAuthorizationErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.AuthorizationErrorEnum} AuthorizationErrorEnum instance
                         */
                        AuthorizationErrorEnum.create = function create(properties) {
                            return new AuthorizationErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified AuthorizationErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.AuthorizationErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.AuthorizationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAuthorizationErrorEnum} message AuthorizationErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AuthorizationErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AuthorizationErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.AuthorizationErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AuthorizationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IAuthorizationErrorEnum} message AuthorizationErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AuthorizationErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AuthorizationErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.AuthorizationErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.AuthorizationErrorEnum} AuthorizationErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AuthorizationErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.AuthorizationErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AuthorizationErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.AuthorizationErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.AuthorizationErrorEnum} AuthorizationErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AuthorizationErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AuthorizationErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.AuthorizationErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AuthorizationErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AuthorizationErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.AuthorizationErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.AuthorizationErrorEnum} AuthorizationErrorEnum
                         */
                        AuthorizationErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.AuthorizationErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.AuthorizationErrorEnum();
                        };

                        /**
                         * Creates a plain object from an AuthorizationErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.AuthorizationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.AuthorizationErrorEnum} message AuthorizationErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AuthorizationErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AuthorizationErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.AuthorizationErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AuthorizationErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AuthorizationError enum.
                         * @name google.ads.googleads.v1.errors.AuthorizationErrorEnum.AuthorizationError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} USER_PERMISSION_DENIED=2 USER_PERMISSION_DENIED value
                         * @property {number} DEVELOPER_TOKEN_NOT_WHITELISTED=3 DEVELOPER_TOKEN_NOT_WHITELISTED value
                         * @property {number} DEVELOPER_TOKEN_PROHIBITED=4 DEVELOPER_TOKEN_PROHIBITED value
                         * @property {number} PROJECT_DISABLED=5 PROJECT_DISABLED value
                         * @property {number} AUTHORIZATION_ERROR=6 AUTHORIZATION_ERROR value
                         * @property {number} ACTION_NOT_PERMITTED=7 ACTION_NOT_PERMITTED value
                         * @property {number} INCOMPLETE_SIGNUP=8 INCOMPLETE_SIGNUP value
                         * @property {number} CUSTOMER_NOT_ENABLED=24 CUSTOMER_NOT_ENABLED value
                         * @property {number} MISSING_TOS=9 MISSING_TOS value
                         * @property {number} DEVELOPER_TOKEN_NOT_APPROVED=10 DEVELOPER_TOKEN_NOT_APPROVED value
                         */
                        AuthorizationErrorEnum.AuthorizationError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "USER_PERMISSION_DENIED"] = 2;
                            values[valuesById[3] = "DEVELOPER_TOKEN_NOT_WHITELISTED"] = 3;
                            values[valuesById[4] = "DEVELOPER_TOKEN_PROHIBITED"] = 4;
                            values[valuesById[5] = "PROJECT_DISABLED"] = 5;
                            values[valuesById[6] = "AUTHORIZATION_ERROR"] = 6;
                            values[valuesById[7] = "ACTION_NOT_PERMITTED"] = 7;
                            values[valuesById[8] = "INCOMPLETE_SIGNUP"] = 8;
                            values[valuesById[24] = "CUSTOMER_NOT_ENABLED"] = 24;
                            values[valuesById[9] = "MISSING_TOS"] = 9;
                            values[valuesById[10] = "DEVELOPER_TOKEN_NOT_APPROVED"] = 10;
                            return values;
                        })();

                        return AuthorizationErrorEnum;
                    })();

                    errors.BiddingErrorEnum = (function() {

                        /**
                         * Properties of a BiddingErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IBiddingErrorEnum
                         */

                        /**
                         * Constructs a new BiddingErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a BiddingErrorEnum.
                         * @implements IBiddingErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IBiddingErrorEnum=} [properties] Properties to set
                         */
                        function BiddingErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new BiddingErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.BiddingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IBiddingErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.BiddingErrorEnum} BiddingErrorEnum instance
                         */
                        BiddingErrorEnum.create = function create(properties) {
                            return new BiddingErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified BiddingErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.BiddingErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.BiddingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IBiddingErrorEnum} message BiddingErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BiddingErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified BiddingErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.BiddingErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.BiddingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IBiddingErrorEnum} message BiddingErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BiddingErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BiddingErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.BiddingErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.BiddingErrorEnum} BiddingErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BiddingErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.BiddingErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BiddingErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.BiddingErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.BiddingErrorEnum} BiddingErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BiddingErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BiddingErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.BiddingErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BiddingErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a BiddingErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.BiddingErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.BiddingErrorEnum} BiddingErrorEnum
                         */
                        BiddingErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.BiddingErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.BiddingErrorEnum();
                        };

                        /**
                         * Creates a plain object from a BiddingErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.BiddingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.BiddingErrorEnum} message BiddingErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BiddingErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this BiddingErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.BiddingErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BiddingErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * BiddingError enum.
                         * @name google.ads.googleads.v1.errors.BiddingErrorEnum.BiddingError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} BIDDING_STRATEGY_TRANSITION_NOT_ALLOWED=2 BIDDING_STRATEGY_TRANSITION_NOT_ALLOWED value
                         * @property {number} CANNOT_ATTACH_BIDDING_STRATEGY_TO_CAMPAIGN=7 CANNOT_ATTACH_BIDDING_STRATEGY_TO_CAMPAIGN value
                         * @property {number} INVALID_ANONYMOUS_BIDDING_STRATEGY_TYPE=10 INVALID_ANONYMOUS_BIDDING_STRATEGY_TYPE value
                         * @property {number} INVALID_BIDDING_STRATEGY_TYPE=14 INVALID_BIDDING_STRATEGY_TYPE value
                         * @property {number} INVALID_BID=17 INVALID_BID value
                         * @property {number} BIDDING_STRATEGY_NOT_AVAILABLE_FOR_ACCOUNT_TYPE=18 BIDDING_STRATEGY_NOT_AVAILABLE_FOR_ACCOUNT_TYPE value
                         * @property {number} CONVERSION_TRACKING_NOT_ENABLED=19 CONVERSION_TRACKING_NOT_ENABLED value
                         * @property {number} NOT_ENOUGH_CONVERSIONS=20 NOT_ENOUGH_CONVERSIONS value
                         * @property {number} CANNOT_CREATE_CAMPAIGN_WITH_BIDDING_STRATEGY=21 CANNOT_CREATE_CAMPAIGN_WITH_BIDDING_STRATEGY value
                         * @property {number} CANNOT_TARGET_CONTENT_NETWORK_ONLY_WITH_CAMPAIGN_LEVEL_POP_BIDDING_STRATEGY=23 CANNOT_TARGET_CONTENT_NETWORK_ONLY_WITH_CAMPAIGN_LEVEL_POP_BIDDING_STRATEGY value
                         * @property {number} BIDDING_STRATEGY_NOT_SUPPORTED_WITH_AD_SCHEDULE=24 BIDDING_STRATEGY_NOT_SUPPORTED_WITH_AD_SCHEDULE value
                         * @property {number} PAY_PER_CONVERSION_NOT_AVAILABLE_FOR_CUSTOMER=25 PAY_PER_CONVERSION_NOT_AVAILABLE_FOR_CUSTOMER value
                         * @property {number} PAY_PER_CONVERSION_NOT_ALLOWED_WITH_TARGET_CPA=26 PAY_PER_CONVERSION_NOT_ALLOWED_WITH_TARGET_CPA value
                         * @property {number} BIDDING_STRATEGY_NOT_ALLOWED_FOR_SEARCH_ONLY_CAMPAIGNS=27 BIDDING_STRATEGY_NOT_ALLOWED_FOR_SEARCH_ONLY_CAMPAIGNS value
                         * @property {number} BIDDING_STRATEGY_NOT_SUPPORTED_IN_DRAFTS_OR_EXPERIMENTS=28 BIDDING_STRATEGY_NOT_SUPPORTED_IN_DRAFTS_OR_EXPERIMENTS value
                         * @property {number} BIDDING_STRATEGY_TYPE_DOES_NOT_SUPPORT_PRODUCT_TYPE_ADGROUP_CRITERION=29 BIDDING_STRATEGY_TYPE_DOES_NOT_SUPPORT_PRODUCT_TYPE_ADGROUP_CRITERION value
                         * @property {number} BID_TOO_SMALL=30 BID_TOO_SMALL value
                         * @property {number} BID_TOO_BIG=31 BID_TOO_BIG value
                         * @property {number} BID_TOO_MANY_FRACTIONAL_DIGITS=32 BID_TOO_MANY_FRACTIONAL_DIGITS value
                         * @property {number} INVALID_DOMAIN_NAME=33 INVALID_DOMAIN_NAME value
                         * @property {number} NOT_COMPATIBLE_WITH_PAYMENT_MODE=34 NOT_COMPATIBLE_WITH_PAYMENT_MODE value
                         * @property {number} NOT_COMPATIBLE_WITH_BUDGET_TYPE=35 NOT_COMPATIBLE_WITH_BUDGET_TYPE value
                         */
                        BiddingErrorEnum.BiddingError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "BIDDING_STRATEGY_TRANSITION_NOT_ALLOWED"] = 2;
                            values[valuesById[7] = "CANNOT_ATTACH_BIDDING_STRATEGY_TO_CAMPAIGN"] = 7;
                            values[valuesById[10] = "INVALID_ANONYMOUS_BIDDING_STRATEGY_TYPE"] = 10;
                            values[valuesById[14] = "INVALID_BIDDING_STRATEGY_TYPE"] = 14;
                            values[valuesById[17] = "INVALID_BID"] = 17;
                            values[valuesById[18] = "BIDDING_STRATEGY_NOT_AVAILABLE_FOR_ACCOUNT_TYPE"] = 18;
                            values[valuesById[19] = "CONVERSION_TRACKING_NOT_ENABLED"] = 19;
                            values[valuesById[20] = "NOT_ENOUGH_CONVERSIONS"] = 20;
                            values[valuesById[21] = "CANNOT_CREATE_CAMPAIGN_WITH_BIDDING_STRATEGY"] = 21;
                            values[valuesById[23] = "CANNOT_TARGET_CONTENT_NETWORK_ONLY_WITH_CAMPAIGN_LEVEL_POP_BIDDING_STRATEGY"] = 23;
                            values[valuesById[24] = "BIDDING_STRATEGY_NOT_SUPPORTED_WITH_AD_SCHEDULE"] = 24;
                            values[valuesById[25] = "PAY_PER_CONVERSION_NOT_AVAILABLE_FOR_CUSTOMER"] = 25;
                            values[valuesById[26] = "PAY_PER_CONVERSION_NOT_ALLOWED_WITH_TARGET_CPA"] = 26;
                            values[valuesById[27] = "BIDDING_STRATEGY_NOT_ALLOWED_FOR_SEARCH_ONLY_CAMPAIGNS"] = 27;
                            values[valuesById[28] = "BIDDING_STRATEGY_NOT_SUPPORTED_IN_DRAFTS_OR_EXPERIMENTS"] = 28;
                            values[valuesById[29] = "BIDDING_STRATEGY_TYPE_DOES_NOT_SUPPORT_PRODUCT_TYPE_ADGROUP_CRITERION"] = 29;
                            values[valuesById[30] = "BID_TOO_SMALL"] = 30;
                            values[valuesById[31] = "BID_TOO_BIG"] = 31;
                            values[valuesById[32] = "BID_TOO_MANY_FRACTIONAL_DIGITS"] = 32;
                            values[valuesById[33] = "INVALID_DOMAIN_NAME"] = 33;
                            values[valuesById[34] = "NOT_COMPATIBLE_WITH_PAYMENT_MODE"] = 34;
                            values[valuesById[35] = "NOT_COMPATIBLE_WITH_BUDGET_TYPE"] = 35;
                            return values;
                        })();

                        return BiddingErrorEnum;
                    })();

                    errors.BiddingStrategyErrorEnum = (function() {

                        /**
                         * Properties of a BiddingStrategyErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IBiddingStrategyErrorEnum
                         */

                        /**
                         * Constructs a new BiddingStrategyErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a BiddingStrategyErrorEnum.
                         * @implements IBiddingStrategyErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IBiddingStrategyErrorEnum=} [properties] Properties to set
                         */
                        function BiddingStrategyErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new BiddingStrategyErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.BiddingStrategyErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IBiddingStrategyErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.BiddingStrategyErrorEnum} BiddingStrategyErrorEnum instance
                         */
                        BiddingStrategyErrorEnum.create = function create(properties) {
                            return new BiddingStrategyErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified BiddingStrategyErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.BiddingStrategyErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.BiddingStrategyErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IBiddingStrategyErrorEnum} message BiddingStrategyErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BiddingStrategyErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified BiddingStrategyErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.BiddingStrategyErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.BiddingStrategyErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IBiddingStrategyErrorEnum} message BiddingStrategyErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BiddingStrategyErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BiddingStrategyErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.BiddingStrategyErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.BiddingStrategyErrorEnum} BiddingStrategyErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BiddingStrategyErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.BiddingStrategyErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BiddingStrategyErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.BiddingStrategyErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.BiddingStrategyErrorEnum} BiddingStrategyErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BiddingStrategyErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BiddingStrategyErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.BiddingStrategyErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BiddingStrategyErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a BiddingStrategyErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.BiddingStrategyErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.BiddingStrategyErrorEnum} BiddingStrategyErrorEnum
                         */
                        BiddingStrategyErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.BiddingStrategyErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.BiddingStrategyErrorEnum();
                        };

                        /**
                         * Creates a plain object from a BiddingStrategyErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.BiddingStrategyErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.BiddingStrategyErrorEnum} message BiddingStrategyErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BiddingStrategyErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this BiddingStrategyErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.BiddingStrategyErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BiddingStrategyErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * BiddingStrategyError enum.
                         * @name google.ads.googleads.v1.errors.BiddingStrategyErrorEnum.BiddingStrategyError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} DUPLICATE_NAME=2 DUPLICATE_NAME value
                         * @property {number} CANNOT_CHANGE_BIDDING_STRATEGY_TYPE=3 CANNOT_CHANGE_BIDDING_STRATEGY_TYPE value
                         * @property {number} CANNOT_REMOVE_ASSOCIATED_STRATEGY=4 CANNOT_REMOVE_ASSOCIATED_STRATEGY value
                         * @property {number} BIDDING_STRATEGY_NOT_SUPPORTED=5 BIDDING_STRATEGY_NOT_SUPPORTED value
                         * @property {number} INCOMPATIBLE_BIDDING_STRATEGY_AND_BIDDING_STRATEGY_GOAL_TYPE=6 INCOMPATIBLE_BIDDING_STRATEGY_AND_BIDDING_STRATEGY_GOAL_TYPE value
                         */
                        BiddingStrategyErrorEnum.BiddingStrategyError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "DUPLICATE_NAME"] = 2;
                            values[valuesById[3] = "CANNOT_CHANGE_BIDDING_STRATEGY_TYPE"] = 3;
                            values[valuesById[4] = "CANNOT_REMOVE_ASSOCIATED_STRATEGY"] = 4;
                            values[valuesById[5] = "BIDDING_STRATEGY_NOT_SUPPORTED"] = 5;
                            values[valuesById[6] = "INCOMPATIBLE_BIDDING_STRATEGY_AND_BIDDING_STRATEGY_GOAL_TYPE"] = 6;
                            return values;
                        })();

                        return BiddingStrategyErrorEnum;
                    })();

                    errors.BillingSetupErrorEnum = (function() {

                        /**
                         * Properties of a BillingSetupErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IBillingSetupErrorEnum
                         */

                        /**
                         * Constructs a new BillingSetupErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a BillingSetupErrorEnum.
                         * @implements IBillingSetupErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IBillingSetupErrorEnum=} [properties] Properties to set
                         */
                        function BillingSetupErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new BillingSetupErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.BillingSetupErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IBillingSetupErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.BillingSetupErrorEnum} BillingSetupErrorEnum instance
                         */
                        BillingSetupErrorEnum.create = function create(properties) {
                            return new BillingSetupErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified BillingSetupErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.BillingSetupErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.BillingSetupErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IBillingSetupErrorEnum} message BillingSetupErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BillingSetupErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified BillingSetupErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.BillingSetupErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.BillingSetupErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IBillingSetupErrorEnum} message BillingSetupErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BillingSetupErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BillingSetupErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.BillingSetupErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.BillingSetupErrorEnum} BillingSetupErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BillingSetupErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.BillingSetupErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BillingSetupErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.BillingSetupErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.BillingSetupErrorEnum} BillingSetupErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BillingSetupErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BillingSetupErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.BillingSetupErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BillingSetupErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a BillingSetupErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.BillingSetupErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.BillingSetupErrorEnum} BillingSetupErrorEnum
                         */
                        BillingSetupErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.BillingSetupErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.BillingSetupErrorEnum();
                        };

                        /**
                         * Creates a plain object from a BillingSetupErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.BillingSetupErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.BillingSetupErrorEnum} message BillingSetupErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BillingSetupErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this BillingSetupErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.BillingSetupErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BillingSetupErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * BillingSetupError enum.
                         * @name google.ads.googleads.v1.errors.BillingSetupErrorEnum.BillingSetupError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CANNOT_USE_EXISTING_AND_NEW_ACCOUNT=2 CANNOT_USE_EXISTING_AND_NEW_ACCOUNT value
                         * @property {number} CANNOT_REMOVE_STARTED_BILLING_SETUP=3 CANNOT_REMOVE_STARTED_BILLING_SETUP value
                         * @property {number} CANNOT_CHANGE_BILLING_TO_SAME_PAYMENTS_ACCOUNT=4 CANNOT_CHANGE_BILLING_TO_SAME_PAYMENTS_ACCOUNT value
                         * @property {number} BILLING_SETUP_NOT_PERMITTED_FOR_CUSTOMER_STATUS=5 BILLING_SETUP_NOT_PERMITTED_FOR_CUSTOMER_STATUS value
                         * @property {number} INVALID_PAYMENTS_ACCOUNT=6 INVALID_PAYMENTS_ACCOUNT value
                         * @property {number} BILLING_SETUP_NOT_PERMITTED_FOR_CUSTOMER_CATEGORY=7 BILLING_SETUP_NOT_PERMITTED_FOR_CUSTOMER_CATEGORY value
                         * @property {number} INVALID_START_TIME_TYPE=8 INVALID_START_TIME_TYPE value
                         * @property {number} THIRD_PARTY_ALREADY_HAS_BILLING=9 THIRD_PARTY_ALREADY_HAS_BILLING value
                         * @property {number} BILLING_SETUP_IN_PROGRESS=10 BILLING_SETUP_IN_PROGRESS value
                         * @property {number} NO_SIGNUP_PERMISSION=11 NO_SIGNUP_PERMISSION value
                         * @property {number} CHANGE_OF_BILL_TO_IN_PROGRESS=12 CHANGE_OF_BILL_TO_IN_PROGRESS value
                         * @property {number} PAYMENTS_PROFILE_NOT_FOUND=13 PAYMENTS_PROFILE_NOT_FOUND value
                         * @property {number} PAYMENTS_ACCOUNT_NOT_FOUND=14 PAYMENTS_ACCOUNT_NOT_FOUND value
                         * @property {number} PAYMENTS_PROFILE_INELIGIBLE=15 PAYMENTS_PROFILE_INELIGIBLE value
                         * @property {number} PAYMENTS_ACCOUNT_INELIGIBLE=16 PAYMENTS_ACCOUNT_INELIGIBLE value
                         */
                        BillingSetupErrorEnum.BillingSetupError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CANNOT_USE_EXISTING_AND_NEW_ACCOUNT"] = 2;
                            values[valuesById[3] = "CANNOT_REMOVE_STARTED_BILLING_SETUP"] = 3;
                            values[valuesById[4] = "CANNOT_CHANGE_BILLING_TO_SAME_PAYMENTS_ACCOUNT"] = 4;
                            values[valuesById[5] = "BILLING_SETUP_NOT_PERMITTED_FOR_CUSTOMER_STATUS"] = 5;
                            values[valuesById[6] = "INVALID_PAYMENTS_ACCOUNT"] = 6;
                            values[valuesById[7] = "BILLING_SETUP_NOT_PERMITTED_FOR_CUSTOMER_CATEGORY"] = 7;
                            values[valuesById[8] = "INVALID_START_TIME_TYPE"] = 8;
                            values[valuesById[9] = "THIRD_PARTY_ALREADY_HAS_BILLING"] = 9;
                            values[valuesById[10] = "BILLING_SETUP_IN_PROGRESS"] = 10;
                            values[valuesById[11] = "NO_SIGNUP_PERMISSION"] = 11;
                            values[valuesById[12] = "CHANGE_OF_BILL_TO_IN_PROGRESS"] = 12;
                            values[valuesById[13] = "PAYMENTS_PROFILE_NOT_FOUND"] = 13;
                            values[valuesById[14] = "PAYMENTS_ACCOUNT_NOT_FOUND"] = 14;
                            values[valuesById[15] = "PAYMENTS_PROFILE_INELIGIBLE"] = 15;
                            values[valuesById[16] = "PAYMENTS_ACCOUNT_INELIGIBLE"] = 16;
                            return values;
                        })();

                        return BillingSetupErrorEnum;
                    })();

                    errors.CampaignBudgetErrorEnum = (function() {

                        /**
                         * Properties of a CampaignBudgetErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ICampaignBudgetErrorEnum
                         */

                        /**
                         * Constructs a new CampaignBudgetErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a CampaignBudgetErrorEnum.
                         * @implements ICampaignBudgetErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ICampaignBudgetErrorEnum=} [properties] Properties to set
                         */
                        function CampaignBudgetErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CampaignBudgetErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.CampaignBudgetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICampaignBudgetErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.CampaignBudgetErrorEnum} CampaignBudgetErrorEnum instance
                         */
                        CampaignBudgetErrorEnum.create = function create(properties) {
                            return new CampaignBudgetErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified CampaignBudgetErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.CampaignBudgetErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.CampaignBudgetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICampaignBudgetErrorEnum} message CampaignBudgetErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignBudgetErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignBudgetErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.CampaignBudgetErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CampaignBudgetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICampaignBudgetErrorEnum} message CampaignBudgetErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignBudgetErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignBudgetErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.CampaignBudgetErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.CampaignBudgetErrorEnum} CampaignBudgetErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignBudgetErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.CampaignBudgetErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignBudgetErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CampaignBudgetErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.CampaignBudgetErrorEnum} CampaignBudgetErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignBudgetErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignBudgetErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.CampaignBudgetErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignBudgetErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CampaignBudgetErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.CampaignBudgetErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.CampaignBudgetErrorEnum} CampaignBudgetErrorEnum
                         */
                        CampaignBudgetErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.CampaignBudgetErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.CampaignBudgetErrorEnum();
                        };

                        /**
                         * Creates a plain object from a CampaignBudgetErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.CampaignBudgetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.CampaignBudgetErrorEnum} message CampaignBudgetErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignBudgetErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CampaignBudgetErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.CampaignBudgetErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignBudgetErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CampaignBudgetError enum.
                         * @name google.ads.googleads.v1.errors.CampaignBudgetErrorEnum.CampaignBudgetError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CAMPAIGN_BUDGET_CANNOT_BE_SHARED=17 CAMPAIGN_BUDGET_CANNOT_BE_SHARED value
                         * @property {number} CAMPAIGN_BUDGET_REMOVED=2 CAMPAIGN_BUDGET_REMOVED value
                         * @property {number} CAMPAIGN_BUDGET_IN_USE=3 CAMPAIGN_BUDGET_IN_USE value
                         * @property {number} CAMPAIGN_BUDGET_PERIOD_NOT_AVAILABLE=4 CAMPAIGN_BUDGET_PERIOD_NOT_AVAILABLE value
                         * @property {number} CANNOT_MODIFY_FIELD_OF_IMPLICITLY_SHARED_CAMPAIGN_BUDGET=6 CANNOT_MODIFY_FIELD_OF_IMPLICITLY_SHARED_CAMPAIGN_BUDGET value
                         * @property {number} CANNOT_UPDATE_CAMPAIGN_BUDGET_TO_IMPLICITLY_SHARED=7 CANNOT_UPDATE_CAMPAIGN_BUDGET_TO_IMPLICITLY_SHARED value
                         * @property {number} CANNOT_UPDATE_CAMPAIGN_BUDGET_TO_EXPLICITLY_SHARED_WITHOUT_NAME=8 CANNOT_UPDATE_CAMPAIGN_BUDGET_TO_EXPLICITLY_SHARED_WITHOUT_NAME value
                         * @property {number} CANNOT_UPDATE_CAMPAIGN_BUDGET_TO_EXPLICITLY_SHARED=9 CANNOT_UPDATE_CAMPAIGN_BUDGET_TO_EXPLICITLY_SHARED value
                         * @property {number} CANNOT_USE_IMPLICITLY_SHARED_CAMPAIGN_BUDGET_WITH_MULTIPLE_CAMPAIGNS=10 CANNOT_USE_IMPLICITLY_SHARED_CAMPAIGN_BUDGET_WITH_MULTIPLE_CAMPAIGNS value
                         * @property {number} DUPLICATE_NAME=11 DUPLICATE_NAME value
                         * @property {number} MONEY_AMOUNT_IN_WRONG_CURRENCY=12 MONEY_AMOUNT_IN_WRONG_CURRENCY value
                         * @property {number} MONEY_AMOUNT_LESS_THAN_CURRENCY_MINIMUM_CPC=13 MONEY_AMOUNT_LESS_THAN_CURRENCY_MINIMUM_CPC value
                         * @property {number} MONEY_AMOUNT_TOO_LARGE=14 MONEY_AMOUNT_TOO_LARGE value
                         * @property {number} NEGATIVE_MONEY_AMOUNT=15 NEGATIVE_MONEY_AMOUNT value
                         * @property {number} NON_MULTIPLE_OF_MINIMUM_CURRENCY_UNIT=16 NON_MULTIPLE_OF_MINIMUM_CURRENCY_UNIT value
                         */
                        CampaignBudgetErrorEnum.CampaignBudgetError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[17] = "CAMPAIGN_BUDGET_CANNOT_BE_SHARED"] = 17;
                            values[valuesById[2] = "CAMPAIGN_BUDGET_REMOVED"] = 2;
                            values[valuesById[3] = "CAMPAIGN_BUDGET_IN_USE"] = 3;
                            values[valuesById[4] = "CAMPAIGN_BUDGET_PERIOD_NOT_AVAILABLE"] = 4;
                            values[valuesById[6] = "CANNOT_MODIFY_FIELD_OF_IMPLICITLY_SHARED_CAMPAIGN_BUDGET"] = 6;
                            values[valuesById[7] = "CANNOT_UPDATE_CAMPAIGN_BUDGET_TO_IMPLICITLY_SHARED"] = 7;
                            values[valuesById[8] = "CANNOT_UPDATE_CAMPAIGN_BUDGET_TO_EXPLICITLY_SHARED_WITHOUT_NAME"] = 8;
                            values[valuesById[9] = "CANNOT_UPDATE_CAMPAIGN_BUDGET_TO_EXPLICITLY_SHARED"] = 9;
                            values[valuesById[10] = "CANNOT_USE_IMPLICITLY_SHARED_CAMPAIGN_BUDGET_WITH_MULTIPLE_CAMPAIGNS"] = 10;
                            values[valuesById[11] = "DUPLICATE_NAME"] = 11;
                            values[valuesById[12] = "MONEY_AMOUNT_IN_WRONG_CURRENCY"] = 12;
                            values[valuesById[13] = "MONEY_AMOUNT_LESS_THAN_CURRENCY_MINIMUM_CPC"] = 13;
                            values[valuesById[14] = "MONEY_AMOUNT_TOO_LARGE"] = 14;
                            values[valuesById[15] = "NEGATIVE_MONEY_AMOUNT"] = 15;
                            values[valuesById[16] = "NON_MULTIPLE_OF_MINIMUM_CURRENCY_UNIT"] = 16;
                            return values;
                        })();

                        return CampaignBudgetErrorEnum;
                    })();

                    errors.CampaignCriterionErrorEnum = (function() {

                        /**
                         * Properties of a CampaignCriterionErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ICampaignCriterionErrorEnum
                         */

                        /**
                         * Constructs a new CampaignCriterionErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a CampaignCriterionErrorEnum.
                         * @implements ICampaignCriterionErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ICampaignCriterionErrorEnum=} [properties] Properties to set
                         */
                        function CampaignCriterionErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CampaignCriterionErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.CampaignCriterionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICampaignCriterionErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.CampaignCriterionErrorEnum} CampaignCriterionErrorEnum instance
                         */
                        CampaignCriterionErrorEnum.create = function create(properties) {
                            return new CampaignCriterionErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified CampaignCriterionErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.CampaignCriterionErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.CampaignCriterionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICampaignCriterionErrorEnum} message CampaignCriterionErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignCriterionErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignCriterionErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.CampaignCriterionErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CampaignCriterionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICampaignCriterionErrorEnum} message CampaignCriterionErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignCriterionErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignCriterionErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.CampaignCriterionErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.CampaignCriterionErrorEnum} CampaignCriterionErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignCriterionErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.CampaignCriterionErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignCriterionErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CampaignCriterionErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.CampaignCriterionErrorEnum} CampaignCriterionErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignCriterionErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignCriterionErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.CampaignCriterionErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignCriterionErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CampaignCriterionErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.CampaignCriterionErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.CampaignCriterionErrorEnum} CampaignCriterionErrorEnum
                         */
                        CampaignCriterionErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.CampaignCriterionErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.CampaignCriterionErrorEnum();
                        };

                        /**
                         * Creates a plain object from a CampaignCriterionErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.CampaignCriterionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.CampaignCriterionErrorEnum} message CampaignCriterionErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignCriterionErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CampaignCriterionErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.CampaignCriterionErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignCriterionErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CampaignCriterionError enum.
                         * @name google.ads.googleads.v1.errors.CampaignCriterionErrorEnum.CampaignCriterionError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CONCRETE_TYPE_REQUIRED=2 CONCRETE_TYPE_REQUIRED value
                         * @property {number} INVALID_PLACEMENT_URL=3 INVALID_PLACEMENT_URL value
                         * @property {number} CANNOT_EXCLUDE_CRITERIA_TYPE=4 CANNOT_EXCLUDE_CRITERIA_TYPE value
                         * @property {number} CANNOT_SET_STATUS_FOR_CRITERIA_TYPE=5 CANNOT_SET_STATUS_FOR_CRITERIA_TYPE value
                         * @property {number} CANNOT_SET_STATUS_FOR_EXCLUDED_CRITERIA=6 CANNOT_SET_STATUS_FOR_EXCLUDED_CRITERIA value
                         * @property {number} CANNOT_TARGET_AND_EXCLUDE=7 CANNOT_TARGET_AND_EXCLUDE value
                         * @property {number} TOO_MANY_OPERATIONS=8 TOO_MANY_OPERATIONS value
                         * @property {number} OPERATOR_NOT_SUPPORTED_FOR_CRITERION_TYPE=9 OPERATOR_NOT_SUPPORTED_FOR_CRITERION_TYPE value
                         * @property {number} SHOPPING_CAMPAIGN_SALES_COUNTRY_NOT_SUPPORTED_FOR_SALES_CHANNEL=10 SHOPPING_CAMPAIGN_SALES_COUNTRY_NOT_SUPPORTED_FOR_SALES_CHANNEL value
                         * @property {number} CANNOT_ADD_EXISTING_FIELD=11 CANNOT_ADD_EXISTING_FIELD value
                         * @property {number} CANNOT_UPDATE_NEGATIVE_CRITERION=12 CANNOT_UPDATE_NEGATIVE_CRITERION value
                         */
                        CampaignCriterionErrorEnum.CampaignCriterionError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CONCRETE_TYPE_REQUIRED"] = 2;
                            values[valuesById[3] = "INVALID_PLACEMENT_URL"] = 3;
                            values[valuesById[4] = "CANNOT_EXCLUDE_CRITERIA_TYPE"] = 4;
                            values[valuesById[5] = "CANNOT_SET_STATUS_FOR_CRITERIA_TYPE"] = 5;
                            values[valuesById[6] = "CANNOT_SET_STATUS_FOR_EXCLUDED_CRITERIA"] = 6;
                            values[valuesById[7] = "CANNOT_TARGET_AND_EXCLUDE"] = 7;
                            values[valuesById[8] = "TOO_MANY_OPERATIONS"] = 8;
                            values[valuesById[9] = "OPERATOR_NOT_SUPPORTED_FOR_CRITERION_TYPE"] = 9;
                            values[valuesById[10] = "SHOPPING_CAMPAIGN_SALES_COUNTRY_NOT_SUPPORTED_FOR_SALES_CHANNEL"] = 10;
                            values[valuesById[11] = "CANNOT_ADD_EXISTING_FIELD"] = 11;
                            values[valuesById[12] = "CANNOT_UPDATE_NEGATIVE_CRITERION"] = 12;
                            return values;
                        })();

                        return CampaignCriterionErrorEnum;
                    })();

                    errors.CampaignErrorEnum = (function() {

                        /**
                         * Properties of a CampaignErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ICampaignErrorEnum
                         */

                        /**
                         * Constructs a new CampaignErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a CampaignErrorEnum.
                         * @implements ICampaignErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ICampaignErrorEnum=} [properties] Properties to set
                         */
                        function CampaignErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CampaignErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.CampaignErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICampaignErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.CampaignErrorEnum} CampaignErrorEnum instance
                         */
                        CampaignErrorEnum.create = function create(properties) {
                            return new CampaignErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified CampaignErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.CampaignErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.CampaignErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICampaignErrorEnum} message CampaignErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.CampaignErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CampaignErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICampaignErrorEnum} message CampaignErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.CampaignErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.CampaignErrorEnum} CampaignErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.CampaignErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CampaignErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.CampaignErrorEnum} CampaignErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.CampaignErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CampaignErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.CampaignErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.CampaignErrorEnum} CampaignErrorEnum
                         */
                        CampaignErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.CampaignErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.CampaignErrorEnum();
                        };

                        /**
                         * Creates a plain object from a CampaignErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.CampaignErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.CampaignErrorEnum} message CampaignErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CampaignErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.CampaignErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CampaignError enum.
                         * @name google.ads.googleads.v1.errors.CampaignErrorEnum.CampaignError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CANNOT_TARGET_CONTENT_NETWORK=3 CANNOT_TARGET_CONTENT_NETWORK value
                         * @property {number} CANNOT_TARGET_SEARCH_NETWORK=4 CANNOT_TARGET_SEARCH_NETWORK value
                         * @property {number} CANNOT_TARGET_SEARCH_NETWORK_WITHOUT_GOOGLE_SEARCH=5 CANNOT_TARGET_SEARCH_NETWORK_WITHOUT_GOOGLE_SEARCH value
                         * @property {number} CANNOT_TARGET_GOOGLE_SEARCH_FOR_CPM_CAMPAIGN=6 CANNOT_TARGET_GOOGLE_SEARCH_FOR_CPM_CAMPAIGN value
                         * @property {number} CAMPAIGN_MUST_TARGET_AT_LEAST_ONE_NETWORK=7 CAMPAIGN_MUST_TARGET_AT_LEAST_ONE_NETWORK value
                         * @property {number} CANNOT_TARGET_PARTNER_SEARCH_NETWORK=8 CANNOT_TARGET_PARTNER_SEARCH_NETWORK value
                         * @property {number} CANNOT_TARGET_CONTENT_NETWORK_ONLY_WITH_CRITERIA_LEVEL_BIDDING_STRATEGY=9 CANNOT_TARGET_CONTENT_NETWORK_ONLY_WITH_CRITERIA_LEVEL_BIDDING_STRATEGY value
                         * @property {number} CAMPAIGN_DURATION_MUST_CONTAIN_ALL_RUNNABLE_TRIALS=10 CAMPAIGN_DURATION_MUST_CONTAIN_ALL_RUNNABLE_TRIALS value
                         * @property {number} CANNOT_MODIFY_FOR_TRIAL_CAMPAIGN=11 CANNOT_MODIFY_FOR_TRIAL_CAMPAIGN value
                         * @property {number} DUPLICATE_CAMPAIGN_NAME=12 DUPLICATE_CAMPAIGN_NAME value
                         * @property {number} INCOMPATIBLE_CAMPAIGN_FIELD=13 INCOMPATIBLE_CAMPAIGN_FIELD value
                         * @property {number} INVALID_CAMPAIGN_NAME=14 INVALID_CAMPAIGN_NAME value
                         * @property {number} INVALID_AD_SERVING_OPTIMIZATION_STATUS=15 INVALID_AD_SERVING_OPTIMIZATION_STATUS value
                         * @property {number} INVALID_TRACKING_URL=16 INVALID_TRACKING_URL value
                         * @property {number} CANNOT_SET_BOTH_TRACKING_URL_TEMPLATE_AND_TRACKING_SETTING=17 CANNOT_SET_BOTH_TRACKING_URL_TEMPLATE_AND_TRACKING_SETTING value
                         * @property {number} MAX_IMPRESSIONS_NOT_IN_RANGE=18 MAX_IMPRESSIONS_NOT_IN_RANGE value
                         * @property {number} TIME_UNIT_NOT_SUPPORTED=19 TIME_UNIT_NOT_SUPPORTED value
                         * @property {number} INVALID_OPERATION_IF_SERVING_STATUS_HAS_ENDED=20 INVALID_OPERATION_IF_SERVING_STATUS_HAS_ENDED value
                         * @property {number} BUDGET_CANNOT_BE_SHARED=21 BUDGET_CANNOT_BE_SHARED value
                         * @property {number} CAMPAIGN_CANNOT_USE_SHARED_BUDGET=22 CAMPAIGN_CANNOT_USE_SHARED_BUDGET value
                         * @property {number} CANNOT_CHANGE_BUDGET_ON_CAMPAIGN_WITH_TRIALS=23 CANNOT_CHANGE_BUDGET_ON_CAMPAIGN_WITH_TRIALS value
                         * @property {number} CAMPAIGN_LABEL_DOES_NOT_EXIST=24 CAMPAIGN_LABEL_DOES_NOT_EXIST value
                         * @property {number} CAMPAIGN_LABEL_ALREADY_EXISTS=25 CAMPAIGN_LABEL_ALREADY_EXISTS value
                         * @property {number} MISSING_SHOPPING_SETTING=26 MISSING_SHOPPING_SETTING value
                         * @property {number} INVALID_SHOPPING_SALES_COUNTRY=27 INVALID_SHOPPING_SALES_COUNTRY value
                         * @property {number} MISSING_UNIVERSAL_APP_CAMPAIGN_SETTING=30 MISSING_UNIVERSAL_APP_CAMPAIGN_SETTING value
                         * @property {number} ADVERTISING_CHANNEL_TYPE_NOT_AVAILABLE_FOR_ACCOUNT_TYPE=31 ADVERTISING_CHANNEL_TYPE_NOT_AVAILABLE_FOR_ACCOUNT_TYPE value
                         * @property {number} INVALID_ADVERTISING_CHANNEL_SUB_TYPE=32 INVALID_ADVERTISING_CHANNEL_SUB_TYPE value
                         * @property {number} AT_LEAST_ONE_CONVERSION_MUST_BE_SELECTED=33 AT_LEAST_ONE_CONVERSION_MUST_BE_SELECTED value
                         * @property {number} CANNOT_SET_AD_ROTATION_MODE=34 CANNOT_SET_AD_ROTATION_MODE value
                         * @property {number} CANNOT_MODIFY_START_DATE_IF_ALREADY_STARTED=35 CANNOT_MODIFY_START_DATE_IF_ALREADY_STARTED value
                         * @property {number} CANNOT_SET_DATE_TO_PAST=36 CANNOT_SET_DATE_TO_PAST value
                         * @property {number} MISSING_HOTEL_CUSTOMER_LINK=37 MISSING_HOTEL_CUSTOMER_LINK value
                         * @property {number} INVALID_HOTEL_CUSTOMER_LINK=38 INVALID_HOTEL_CUSTOMER_LINK value
                         * @property {number} MISSING_HOTEL_SETTING=39 MISSING_HOTEL_SETTING value
                         * @property {number} CANNOT_USE_SHARED_CAMPAIGN_BUDGET_WHILE_PART_OF_CAMPAIGN_GROUP=40 CANNOT_USE_SHARED_CAMPAIGN_BUDGET_WHILE_PART_OF_CAMPAIGN_GROUP value
                         * @property {number} APP_NOT_FOUND=41 APP_NOT_FOUND value
                         */
                        CampaignErrorEnum.CampaignError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[3] = "CANNOT_TARGET_CONTENT_NETWORK"] = 3;
                            values[valuesById[4] = "CANNOT_TARGET_SEARCH_NETWORK"] = 4;
                            values[valuesById[5] = "CANNOT_TARGET_SEARCH_NETWORK_WITHOUT_GOOGLE_SEARCH"] = 5;
                            values[valuesById[6] = "CANNOT_TARGET_GOOGLE_SEARCH_FOR_CPM_CAMPAIGN"] = 6;
                            values[valuesById[7] = "CAMPAIGN_MUST_TARGET_AT_LEAST_ONE_NETWORK"] = 7;
                            values[valuesById[8] = "CANNOT_TARGET_PARTNER_SEARCH_NETWORK"] = 8;
                            values[valuesById[9] = "CANNOT_TARGET_CONTENT_NETWORK_ONLY_WITH_CRITERIA_LEVEL_BIDDING_STRATEGY"] = 9;
                            values[valuesById[10] = "CAMPAIGN_DURATION_MUST_CONTAIN_ALL_RUNNABLE_TRIALS"] = 10;
                            values[valuesById[11] = "CANNOT_MODIFY_FOR_TRIAL_CAMPAIGN"] = 11;
                            values[valuesById[12] = "DUPLICATE_CAMPAIGN_NAME"] = 12;
                            values[valuesById[13] = "INCOMPATIBLE_CAMPAIGN_FIELD"] = 13;
                            values[valuesById[14] = "INVALID_CAMPAIGN_NAME"] = 14;
                            values[valuesById[15] = "INVALID_AD_SERVING_OPTIMIZATION_STATUS"] = 15;
                            values[valuesById[16] = "INVALID_TRACKING_URL"] = 16;
                            values[valuesById[17] = "CANNOT_SET_BOTH_TRACKING_URL_TEMPLATE_AND_TRACKING_SETTING"] = 17;
                            values[valuesById[18] = "MAX_IMPRESSIONS_NOT_IN_RANGE"] = 18;
                            values[valuesById[19] = "TIME_UNIT_NOT_SUPPORTED"] = 19;
                            values[valuesById[20] = "INVALID_OPERATION_IF_SERVING_STATUS_HAS_ENDED"] = 20;
                            values[valuesById[21] = "BUDGET_CANNOT_BE_SHARED"] = 21;
                            values[valuesById[22] = "CAMPAIGN_CANNOT_USE_SHARED_BUDGET"] = 22;
                            values[valuesById[23] = "CANNOT_CHANGE_BUDGET_ON_CAMPAIGN_WITH_TRIALS"] = 23;
                            values[valuesById[24] = "CAMPAIGN_LABEL_DOES_NOT_EXIST"] = 24;
                            values[valuesById[25] = "CAMPAIGN_LABEL_ALREADY_EXISTS"] = 25;
                            values[valuesById[26] = "MISSING_SHOPPING_SETTING"] = 26;
                            values[valuesById[27] = "INVALID_SHOPPING_SALES_COUNTRY"] = 27;
                            values[valuesById[30] = "MISSING_UNIVERSAL_APP_CAMPAIGN_SETTING"] = 30;
                            values[valuesById[31] = "ADVERTISING_CHANNEL_TYPE_NOT_AVAILABLE_FOR_ACCOUNT_TYPE"] = 31;
                            values[valuesById[32] = "INVALID_ADVERTISING_CHANNEL_SUB_TYPE"] = 32;
                            values[valuesById[33] = "AT_LEAST_ONE_CONVERSION_MUST_BE_SELECTED"] = 33;
                            values[valuesById[34] = "CANNOT_SET_AD_ROTATION_MODE"] = 34;
                            values[valuesById[35] = "CANNOT_MODIFY_START_DATE_IF_ALREADY_STARTED"] = 35;
                            values[valuesById[36] = "CANNOT_SET_DATE_TO_PAST"] = 36;
                            values[valuesById[37] = "MISSING_HOTEL_CUSTOMER_LINK"] = 37;
                            values[valuesById[38] = "INVALID_HOTEL_CUSTOMER_LINK"] = 38;
                            values[valuesById[39] = "MISSING_HOTEL_SETTING"] = 39;
                            values[valuesById[40] = "CANNOT_USE_SHARED_CAMPAIGN_BUDGET_WHILE_PART_OF_CAMPAIGN_GROUP"] = 40;
                            values[valuesById[41] = "APP_NOT_FOUND"] = 41;
                            return values;
                        })();

                        return CampaignErrorEnum;
                    })();

                    errors.CampaignFeedErrorEnum = (function() {

                        /**
                         * Properties of a CampaignFeedErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ICampaignFeedErrorEnum
                         */

                        /**
                         * Constructs a new CampaignFeedErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a CampaignFeedErrorEnum.
                         * @implements ICampaignFeedErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ICampaignFeedErrorEnum=} [properties] Properties to set
                         */
                        function CampaignFeedErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CampaignFeedErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.CampaignFeedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICampaignFeedErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.CampaignFeedErrorEnum} CampaignFeedErrorEnum instance
                         */
                        CampaignFeedErrorEnum.create = function create(properties) {
                            return new CampaignFeedErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified CampaignFeedErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.CampaignFeedErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.CampaignFeedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICampaignFeedErrorEnum} message CampaignFeedErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignFeedErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignFeedErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.CampaignFeedErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CampaignFeedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICampaignFeedErrorEnum} message CampaignFeedErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignFeedErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignFeedErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.CampaignFeedErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.CampaignFeedErrorEnum} CampaignFeedErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignFeedErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.CampaignFeedErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignFeedErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CampaignFeedErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.CampaignFeedErrorEnum} CampaignFeedErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignFeedErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignFeedErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.CampaignFeedErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignFeedErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CampaignFeedErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.CampaignFeedErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.CampaignFeedErrorEnum} CampaignFeedErrorEnum
                         */
                        CampaignFeedErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.CampaignFeedErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.CampaignFeedErrorEnum();
                        };

                        /**
                         * Creates a plain object from a CampaignFeedErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.CampaignFeedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.CampaignFeedErrorEnum} message CampaignFeedErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignFeedErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CampaignFeedErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.CampaignFeedErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignFeedErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CampaignFeedError enum.
                         * @name google.ads.googleads.v1.errors.CampaignFeedErrorEnum.CampaignFeedError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE=2 FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE value
                         * @property {number} CANNOT_CREATE_FOR_REMOVED_FEED=4 CANNOT_CREATE_FOR_REMOVED_FEED value
                         * @property {number} CANNOT_CREATE_ALREADY_EXISTING_CAMPAIGN_FEED=5 CANNOT_CREATE_ALREADY_EXISTING_CAMPAIGN_FEED value
                         * @property {number} CANNOT_MODIFY_REMOVED_CAMPAIGN_FEED=6 CANNOT_MODIFY_REMOVED_CAMPAIGN_FEED value
                         * @property {number} INVALID_PLACEHOLDER_TYPE=7 INVALID_PLACEHOLDER_TYPE value
                         * @property {number} MISSING_FEEDMAPPING_FOR_PLACEHOLDER_TYPE=8 MISSING_FEEDMAPPING_FOR_PLACEHOLDER_TYPE value
                         */
                        CampaignFeedErrorEnum.CampaignFeedError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE"] = 2;
                            values[valuesById[4] = "CANNOT_CREATE_FOR_REMOVED_FEED"] = 4;
                            values[valuesById[5] = "CANNOT_CREATE_ALREADY_EXISTING_CAMPAIGN_FEED"] = 5;
                            values[valuesById[6] = "CANNOT_MODIFY_REMOVED_CAMPAIGN_FEED"] = 6;
                            values[valuesById[7] = "INVALID_PLACEHOLDER_TYPE"] = 7;
                            values[valuesById[8] = "MISSING_FEEDMAPPING_FOR_PLACEHOLDER_TYPE"] = 8;
                            return values;
                        })();

                        return CampaignFeedErrorEnum;
                    })();

                    errors.CampaignSharedSetErrorEnum = (function() {

                        /**
                         * Properties of a CampaignSharedSetErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ICampaignSharedSetErrorEnum
                         */

                        /**
                         * Constructs a new CampaignSharedSetErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a CampaignSharedSetErrorEnum.
                         * @implements ICampaignSharedSetErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ICampaignSharedSetErrorEnum=} [properties] Properties to set
                         */
                        function CampaignSharedSetErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CampaignSharedSetErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICampaignSharedSetErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum} CampaignSharedSetErrorEnum instance
                         */
                        CampaignSharedSetErrorEnum.create = function create(properties) {
                            return new CampaignSharedSetErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified CampaignSharedSetErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICampaignSharedSetErrorEnum} message CampaignSharedSetErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignSharedSetErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignSharedSetErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICampaignSharedSetErrorEnum} message CampaignSharedSetErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignSharedSetErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignSharedSetErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum} CampaignSharedSetErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignSharedSetErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignSharedSetErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum} CampaignSharedSetErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignSharedSetErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignSharedSetErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignSharedSetErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CampaignSharedSetErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum} CampaignSharedSetErrorEnum
                         */
                        CampaignSharedSetErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum();
                        };

                        /**
                         * Creates a plain object from a CampaignSharedSetErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum} message CampaignSharedSetErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignSharedSetErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CampaignSharedSetErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignSharedSetErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CampaignSharedSetError enum.
                         * @name google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum.CampaignSharedSetError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} SHARED_SET_ACCESS_DENIED=2 SHARED_SET_ACCESS_DENIED value
                         */
                        CampaignSharedSetErrorEnum.CampaignSharedSetError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "SHARED_SET_ACCESS_DENIED"] = 2;
                            return values;
                        })();

                        return CampaignSharedSetErrorEnum;
                    })();

                    errors.ChangeStatusErrorEnum = (function() {

                        /**
                         * Properties of a ChangeStatusErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IChangeStatusErrorEnum
                         */

                        /**
                         * Constructs a new ChangeStatusErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a ChangeStatusErrorEnum.
                         * @implements IChangeStatusErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IChangeStatusErrorEnum=} [properties] Properties to set
                         */
                        function ChangeStatusErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ChangeStatusErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.ChangeStatusErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IChangeStatusErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.ChangeStatusErrorEnum} ChangeStatusErrorEnum instance
                         */
                        ChangeStatusErrorEnum.create = function create(properties) {
                            return new ChangeStatusErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified ChangeStatusErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.ChangeStatusErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.ChangeStatusErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IChangeStatusErrorEnum} message ChangeStatusErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChangeStatusErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ChangeStatusErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.ChangeStatusErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ChangeStatusErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IChangeStatusErrorEnum} message ChangeStatusErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChangeStatusErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ChangeStatusErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.ChangeStatusErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.ChangeStatusErrorEnum} ChangeStatusErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChangeStatusErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.ChangeStatusErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ChangeStatusErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ChangeStatusErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.ChangeStatusErrorEnum} ChangeStatusErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChangeStatusErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ChangeStatusErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.ChangeStatusErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ChangeStatusErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ChangeStatusErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.ChangeStatusErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.ChangeStatusErrorEnum} ChangeStatusErrorEnum
                         */
                        ChangeStatusErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.ChangeStatusErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.ChangeStatusErrorEnum();
                        };

                        /**
                         * Creates a plain object from a ChangeStatusErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.ChangeStatusErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ChangeStatusErrorEnum} message ChangeStatusErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ChangeStatusErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ChangeStatusErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.ChangeStatusErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ChangeStatusErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ChangeStatusError enum.
                         * @name google.ads.googleads.v1.errors.ChangeStatusErrorEnum.ChangeStatusError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} START_DATE_TOO_OLD=3 START_DATE_TOO_OLD value
                         */
                        ChangeStatusErrorEnum.ChangeStatusError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[3] = "START_DATE_TOO_OLD"] = 3;
                            return values;
                        })();

                        return ChangeStatusErrorEnum;
                    })();

                    errors.CollectionSizeErrorEnum = (function() {

                        /**
                         * Properties of a CollectionSizeErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ICollectionSizeErrorEnum
                         */

                        /**
                         * Constructs a new CollectionSizeErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a CollectionSizeErrorEnum.
                         * @implements ICollectionSizeErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ICollectionSizeErrorEnum=} [properties] Properties to set
                         */
                        function CollectionSizeErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CollectionSizeErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.CollectionSizeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICollectionSizeErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.CollectionSizeErrorEnum} CollectionSizeErrorEnum instance
                         */
                        CollectionSizeErrorEnum.create = function create(properties) {
                            return new CollectionSizeErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified CollectionSizeErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.CollectionSizeErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.CollectionSizeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICollectionSizeErrorEnum} message CollectionSizeErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CollectionSizeErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CollectionSizeErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.CollectionSizeErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CollectionSizeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICollectionSizeErrorEnum} message CollectionSizeErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CollectionSizeErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CollectionSizeErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.CollectionSizeErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.CollectionSizeErrorEnum} CollectionSizeErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CollectionSizeErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.CollectionSizeErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CollectionSizeErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CollectionSizeErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.CollectionSizeErrorEnum} CollectionSizeErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CollectionSizeErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CollectionSizeErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.CollectionSizeErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CollectionSizeErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CollectionSizeErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.CollectionSizeErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.CollectionSizeErrorEnum} CollectionSizeErrorEnum
                         */
                        CollectionSizeErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.CollectionSizeErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.CollectionSizeErrorEnum();
                        };

                        /**
                         * Creates a plain object from a CollectionSizeErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.CollectionSizeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.CollectionSizeErrorEnum} message CollectionSizeErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CollectionSizeErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CollectionSizeErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.CollectionSizeErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CollectionSizeErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CollectionSizeError enum.
                         * @name google.ads.googleads.v1.errors.CollectionSizeErrorEnum.CollectionSizeError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} TOO_FEW=2 TOO_FEW value
                         * @property {number} TOO_MANY=3 TOO_MANY value
                         */
                        CollectionSizeErrorEnum.CollectionSizeError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "TOO_FEW"] = 2;
                            values[valuesById[3] = "TOO_MANY"] = 3;
                            return values;
                        })();

                        return CollectionSizeErrorEnum;
                    })();

                    errors.ContextErrorEnum = (function() {

                        /**
                         * Properties of a ContextErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IContextErrorEnum
                         */

                        /**
                         * Constructs a new ContextErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a ContextErrorEnum.
                         * @implements IContextErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IContextErrorEnum=} [properties] Properties to set
                         */
                        function ContextErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ContextErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.ContextErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IContextErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.ContextErrorEnum} ContextErrorEnum instance
                         */
                        ContextErrorEnum.create = function create(properties) {
                            return new ContextErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified ContextErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.ContextErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.ContextErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IContextErrorEnum} message ContextErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ContextErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ContextErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.ContextErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ContextErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IContextErrorEnum} message ContextErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ContextErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ContextErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.ContextErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.ContextErrorEnum} ContextErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ContextErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.ContextErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ContextErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ContextErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.ContextErrorEnum} ContextErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ContextErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ContextErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.ContextErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ContextErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ContextErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.ContextErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.ContextErrorEnum} ContextErrorEnum
                         */
                        ContextErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.ContextErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.ContextErrorEnum();
                        };

                        /**
                         * Creates a plain object from a ContextErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.ContextErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ContextErrorEnum} message ContextErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ContextErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ContextErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.ContextErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ContextErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ContextError enum.
                         * @name google.ads.googleads.v1.errors.ContextErrorEnum.ContextError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} OPERATION_NOT_PERMITTED_FOR_CONTEXT=2 OPERATION_NOT_PERMITTED_FOR_CONTEXT value
                         * @property {number} OPERATION_NOT_PERMITTED_FOR_REMOVED_RESOURCE=3 OPERATION_NOT_PERMITTED_FOR_REMOVED_RESOURCE value
                         */
                        ContextErrorEnum.ContextError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "OPERATION_NOT_PERMITTED_FOR_CONTEXT"] = 2;
                            values[valuesById[3] = "OPERATION_NOT_PERMITTED_FOR_REMOVED_RESOURCE"] = 3;
                            return values;
                        })();

                        return ContextErrorEnum;
                    })();

                    errors.ConversionActionErrorEnum = (function() {

                        /**
                         * Properties of a ConversionActionErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IConversionActionErrorEnum
                         */

                        /**
                         * Constructs a new ConversionActionErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a ConversionActionErrorEnum.
                         * @implements IConversionActionErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IConversionActionErrorEnum=} [properties] Properties to set
                         */
                        function ConversionActionErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ConversionActionErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.ConversionActionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IConversionActionErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.ConversionActionErrorEnum} ConversionActionErrorEnum instance
                         */
                        ConversionActionErrorEnum.create = function create(properties) {
                            return new ConversionActionErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified ConversionActionErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.ConversionActionErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.ConversionActionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IConversionActionErrorEnum} message ConversionActionErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionActionErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ConversionActionErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.ConversionActionErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ConversionActionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IConversionActionErrorEnum} message ConversionActionErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionActionErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ConversionActionErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.ConversionActionErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.ConversionActionErrorEnum} ConversionActionErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionActionErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.ConversionActionErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ConversionActionErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ConversionActionErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.ConversionActionErrorEnum} ConversionActionErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionActionErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ConversionActionErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.ConversionActionErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConversionActionErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ConversionActionErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.ConversionActionErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.ConversionActionErrorEnum} ConversionActionErrorEnum
                         */
                        ConversionActionErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.ConversionActionErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.ConversionActionErrorEnum();
                        };

                        /**
                         * Creates a plain object from a ConversionActionErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.ConversionActionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ConversionActionErrorEnum} message ConversionActionErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConversionActionErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ConversionActionErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.ConversionActionErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConversionActionErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ConversionActionError enum.
                         * @name google.ads.googleads.v1.errors.ConversionActionErrorEnum.ConversionActionError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} DUPLICATE_NAME=2 DUPLICATE_NAME value
                         * @property {number} DUPLICATE_APP_ID=3 DUPLICATE_APP_ID value
                         * @property {number} TWO_CONVERSION_ACTIONS_BIDDING_ON_SAME_APP_DOWNLOAD=4 TWO_CONVERSION_ACTIONS_BIDDING_ON_SAME_APP_DOWNLOAD value
                         * @property {number} BIDDING_ON_SAME_APP_DOWNLOAD_AS_GLOBAL_ACTION=5 BIDDING_ON_SAME_APP_DOWNLOAD_AS_GLOBAL_ACTION value
                         * @property {number} DATA_DRIVEN_MODEL_WAS_NEVER_GENERATED=6 DATA_DRIVEN_MODEL_WAS_NEVER_GENERATED value
                         * @property {number} DATA_DRIVEN_MODEL_EXPIRED=7 DATA_DRIVEN_MODEL_EXPIRED value
                         * @property {number} DATA_DRIVEN_MODEL_STALE=8 DATA_DRIVEN_MODEL_STALE value
                         * @property {number} DATA_DRIVEN_MODEL_UNKNOWN=9 DATA_DRIVEN_MODEL_UNKNOWN value
                         */
                        ConversionActionErrorEnum.ConversionActionError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "DUPLICATE_NAME"] = 2;
                            values[valuesById[3] = "DUPLICATE_APP_ID"] = 3;
                            values[valuesById[4] = "TWO_CONVERSION_ACTIONS_BIDDING_ON_SAME_APP_DOWNLOAD"] = 4;
                            values[valuesById[5] = "BIDDING_ON_SAME_APP_DOWNLOAD_AS_GLOBAL_ACTION"] = 5;
                            values[valuesById[6] = "DATA_DRIVEN_MODEL_WAS_NEVER_GENERATED"] = 6;
                            values[valuesById[7] = "DATA_DRIVEN_MODEL_EXPIRED"] = 7;
                            values[valuesById[8] = "DATA_DRIVEN_MODEL_STALE"] = 8;
                            values[valuesById[9] = "DATA_DRIVEN_MODEL_UNKNOWN"] = 9;
                            return values;
                        })();

                        return ConversionActionErrorEnum;
                    })();

                    errors.ConversionAdjustmentUploadErrorEnum = (function() {

                        /**
                         * Properties of a ConversionAdjustmentUploadErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IConversionAdjustmentUploadErrorEnum
                         */

                        /**
                         * Constructs a new ConversionAdjustmentUploadErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a ConversionAdjustmentUploadErrorEnum.
                         * @implements IConversionAdjustmentUploadErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IConversionAdjustmentUploadErrorEnum=} [properties] Properties to set
                         */
                        function ConversionAdjustmentUploadErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ConversionAdjustmentUploadErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IConversionAdjustmentUploadErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum} ConversionAdjustmentUploadErrorEnum instance
                         */
                        ConversionAdjustmentUploadErrorEnum.create = function create(properties) {
                            return new ConversionAdjustmentUploadErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified ConversionAdjustmentUploadErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IConversionAdjustmentUploadErrorEnum} message ConversionAdjustmentUploadErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionAdjustmentUploadErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ConversionAdjustmentUploadErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IConversionAdjustmentUploadErrorEnum} message ConversionAdjustmentUploadErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionAdjustmentUploadErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ConversionAdjustmentUploadErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum} ConversionAdjustmentUploadErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionAdjustmentUploadErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ConversionAdjustmentUploadErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum} ConversionAdjustmentUploadErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionAdjustmentUploadErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ConversionAdjustmentUploadErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConversionAdjustmentUploadErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ConversionAdjustmentUploadErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum} ConversionAdjustmentUploadErrorEnum
                         */
                        ConversionAdjustmentUploadErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum();
                        };

                        /**
                         * Creates a plain object from a ConversionAdjustmentUploadErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum} message ConversionAdjustmentUploadErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConversionAdjustmentUploadErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ConversionAdjustmentUploadErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConversionAdjustmentUploadErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ConversionAdjustmentUploadError enum.
                         * @name google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum.ConversionAdjustmentUploadError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} TOO_RECENT_CONVERSION_ACTION=2 TOO_RECENT_CONVERSION_ACTION value
                         * @property {number} INVALID_CONVERSION_ACTION=3 INVALID_CONVERSION_ACTION value
                         * @property {number} CONVERSION_ALREADY_RETRACTED=4 CONVERSION_ALREADY_RETRACTED value
                         * @property {number} CONVERSION_NOT_FOUND=5 CONVERSION_NOT_FOUND value
                         * @property {number} CONVERSION_EXPIRED=6 CONVERSION_EXPIRED value
                         * @property {number} ADJUSTMENT_PRECEDES_CONVERSION=7 ADJUSTMENT_PRECEDES_CONVERSION value
                         * @property {number} MORE_RECENT_RESTATEMENT_FOUND=8 MORE_RECENT_RESTATEMENT_FOUND value
                         * @property {number} TOO_RECENT_CONVERSION=9 TOO_RECENT_CONVERSION value
                         * @property {number} CANNOT_RESTATE_CONVERSION_ACTION_THAT_ALWAYS_USES_DEFAULT_CONVERSION_VALUE=10 CANNOT_RESTATE_CONVERSION_ACTION_THAT_ALWAYS_USES_DEFAULT_CONVERSION_VALUE value
                         */
                        ConversionAdjustmentUploadErrorEnum.ConversionAdjustmentUploadError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "TOO_RECENT_CONVERSION_ACTION"] = 2;
                            values[valuesById[3] = "INVALID_CONVERSION_ACTION"] = 3;
                            values[valuesById[4] = "CONVERSION_ALREADY_RETRACTED"] = 4;
                            values[valuesById[5] = "CONVERSION_NOT_FOUND"] = 5;
                            values[valuesById[6] = "CONVERSION_EXPIRED"] = 6;
                            values[valuesById[7] = "ADJUSTMENT_PRECEDES_CONVERSION"] = 7;
                            values[valuesById[8] = "MORE_RECENT_RESTATEMENT_FOUND"] = 8;
                            values[valuesById[9] = "TOO_RECENT_CONVERSION"] = 9;
                            values[valuesById[10] = "CANNOT_RESTATE_CONVERSION_ACTION_THAT_ALWAYS_USES_DEFAULT_CONVERSION_VALUE"] = 10;
                            return values;
                        })();

                        return ConversionAdjustmentUploadErrorEnum;
                    })();

                    errors.ConversionUploadErrorEnum = (function() {

                        /**
                         * Properties of a ConversionUploadErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IConversionUploadErrorEnum
                         */

                        /**
                         * Constructs a new ConversionUploadErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a ConversionUploadErrorEnum.
                         * @implements IConversionUploadErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IConversionUploadErrorEnum=} [properties] Properties to set
                         */
                        function ConversionUploadErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ConversionUploadErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.ConversionUploadErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IConversionUploadErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.ConversionUploadErrorEnum} ConversionUploadErrorEnum instance
                         */
                        ConversionUploadErrorEnum.create = function create(properties) {
                            return new ConversionUploadErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified ConversionUploadErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.ConversionUploadErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.ConversionUploadErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IConversionUploadErrorEnum} message ConversionUploadErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionUploadErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ConversionUploadErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.ConversionUploadErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ConversionUploadErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IConversionUploadErrorEnum} message ConversionUploadErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionUploadErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ConversionUploadErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.ConversionUploadErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.ConversionUploadErrorEnum} ConversionUploadErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionUploadErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.ConversionUploadErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ConversionUploadErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ConversionUploadErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.ConversionUploadErrorEnum} ConversionUploadErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionUploadErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ConversionUploadErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.ConversionUploadErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConversionUploadErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ConversionUploadErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.ConversionUploadErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.ConversionUploadErrorEnum} ConversionUploadErrorEnum
                         */
                        ConversionUploadErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.ConversionUploadErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.ConversionUploadErrorEnum();
                        };

                        /**
                         * Creates a plain object from a ConversionUploadErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.ConversionUploadErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ConversionUploadErrorEnum} message ConversionUploadErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConversionUploadErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ConversionUploadErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.ConversionUploadErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConversionUploadErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ConversionUploadError enum.
                         * @name google.ads.googleads.v1.errors.ConversionUploadErrorEnum.ConversionUploadError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} TOO_MANY_CONVERSIONS_IN_REQUEST=2 TOO_MANY_CONVERSIONS_IN_REQUEST value
                         * @property {number} UNPARSEABLE_GCLID=3 UNPARSEABLE_GCLID value
                         * @property {number} CONVERSION_PRECEDES_GCLID=4 CONVERSION_PRECEDES_GCLID value
                         * @property {number} EXPIRED_GCLID=5 EXPIRED_GCLID value
                         * @property {number} TOO_RECENT_GCLID=6 TOO_RECENT_GCLID value
                         * @property {number} GCLID_NOT_FOUND=7 GCLID_NOT_FOUND value
                         * @property {number} UNAUTHORIZED_CUSTOMER=8 UNAUTHORIZED_CUSTOMER value
                         * @property {number} INVALID_CONVERSION_ACTION=9 INVALID_CONVERSION_ACTION value
                         * @property {number} TOO_RECENT_CONVERSION_ACTION=10 TOO_RECENT_CONVERSION_ACTION value
                         * @property {number} CONVERSION_TRACKING_NOT_ENABLED_AT_IMPRESSION_TIME=11 CONVERSION_TRACKING_NOT_ENABLED_AT_IMPRESSION_TIME value
                         * @property {number} EXTERNAL_ATTRIBUTION_DATA_SET_FOR_NON_EXTERNALLY_ATTRIBUTED_CONVERSION_ACTION=12 EXTERNAL_ATTRIBUTION_DATA_SET_FOR_NON_EXTERNALLY_ATTRIBUTED_CONVERSION_ACTION value
                         * @property {number} EXTERNAL_ATTRIBUTION_DATA_NOT_SET_FOR_EXTERNALLY_ATTRIBUTED_CONVERSION_ACTION=13 EXTERNAL_ATTRIBUTION_DATA_NOT_SET_FOR_EXTERNALLY_ATTRIBUTED_CONVERSION_ACTION value
                         * @property {number} ORDER_ID_NOT_PERMITTED_FOR_EXTERNALLY_ATTRIBUTED_CONVERSION_ACTION=14 ORDER_ID_NOT_PERMITTED_FOR_EXTERNALLY_ATTRIBUTED_CONVERSION_ACTION value
                         * @property {number} ORDER_ID_ALREADY_IN_USE=15 ORDER_ID_ALREADY_IN_USE value
                         * @property {number} DUPLICATE_ORDER_ID=16 DUPLICATE_ORDER_ID value
                         * @property {number} TOO_RECENT_CALL=17 TOO_RECENT_CALL value
                         * @property {number} EXPIRED_CALL=18 EXPIRED_CALL value
                         * @property {number} CALL_NOT_FOUND=19 CALL_NOT_FOUND value
                         * @property {number} CONVERSION_PRECEDES_CALL=20 CONVERSION_PRECEDES_CALL value
                         * @property {number} CONVERSION_TRACKING_NOT_ENABLED_AT_CALL_TIME=21 CONVERSION_TRACKING_NOT_ENABLED_AT_CALL_TIME value
                         * @property {number} UNPARSEABLE_CALLERS_PHONE_NUMBER=22 UNPARSEABLE_CALLERS_PHONE_NUMBER value
                         */
                        ConversionUploadErrorEnum.ConversionUploadError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "TOO_MANY_CONVERSIONS_IN_REQUEST"] = 2;
                            values[valuesById[3] = "UNPARSEABLE_GCLID"] = 3;
                            values[valuesById[4] = "CONVERSION_PRECEDES_GCLID"] = 4;
                            values[valuesById[5] = "EXPIRED_GCLID"] = 5;
                            values[valuesById[6] = "TOO_RECENT_GCLID"] = 6;
                            values[valuesById[7] = "GCLID_NOT_FOUND"] = 7;
                            values[valuesById[8] = "UNAUTHORIZED_CUSTOMER"] = 8;
                            values[valuesById[9] = "INVALID_CONVERSION_ACTION"] = 9;
                            values[valuesById[10] = "TOO_RECENT_CONVERSION_ACTION"] = 10;
                            values[valuesById[11] = "CONVERSION_TRACKING_NOT_ENABLED_AT_IMPRESSION_TIME"] = 11;
                            values[valuesById[12] = "EXTERNAL_ATTRIBUTION_DATA_SET_FOR_NON_EXTERNALLY_ATTRIBUTED_CONVERSION_ACTION"] = 12;
                            values[valuesById[13] = "EXTERNAL_ATTRIBUTION_DATA_NOT_SET_FOR_EXTERNALLY_ATTRIBUTED_CONVERSION_ACTION"] = 13;
                            values[valuesById[14] = "ORDER_ID_NOT_PERMITTED_FOR_EXTERNALLY_ATTRIBUTED_CONVERSION_ACTION"] = 14;
                            values[valuesById[15] = "ORDER_ID_ALREADY_IN_USE"] = 15;
                            values[valuesById[16] = "DUPLICATE_ORDER_ID"] = 16;
                            values[valuesById[17] = "TOO_RECENT_CALL"] = 17;
                            values[valuesById[18] = "EXPIRED_CALL"] = 18;
                            values[valuesById[19] = "CALL_NOT_FOUND"] = 19;
                            values[valuesById[20] = "CONVERSION_PRECEDES_CALL"] = 20;
                            values[valuesById[21] = "CONVERSION_TRACKING_NOT_ENABLED_AT_CALL_TIME"] = 21;
                            values[valuesById[22] = "UNPARSEABLE_CALLERS_PHONE_NUMBER"] = 22;
                            return values;
                        })();

                        return ConversionUploadErrorEnum;
                    })();

                    errors.CountryCodeErrorEnum = (function() {

                        /**
                         * Properties of a CountryCodeErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ICountryCodeErrorEnum
                         */

                        /**
                         * Constructs a new CountryCodeErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a CountryCodeErrorEnum.
                         * @implements ICountryCodeErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ICountryCodeErrorEnum=} [properties] Properties to set
                         */
                        function CountryCodeErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CountryCodeErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.CountryCodeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICountryCodeErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.CountryCodeErrorEnum} CountryCodeErrorEnum instance
                         */
                        CountryCodeErrorEnum.create = function create(properties) {
                            return new CountryCodeErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified CountryCodeErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.CountryCodeErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.CountryCodeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICountryCodeErrorEnum} message CountryCodeErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CountryCodeErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CountryCodeErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.CountryCodeErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CountryCodeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICountryCodeErrorEnum} message CountryCodeErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CountryCodeErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CountryCodeErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.CountryCodeErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.CountryCodeErrorEnum} CountryCodeErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CountryCodeErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.CountryCodeErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CountryCodeErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CountryCodeErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.CountryCodeErrorEnum} CountryCodeErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CountryCodeErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CountryCodeErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.CountryCodeErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CountryCodeErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CountryCodeErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.CountryCodeErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.CountryCodeErrorEnum} CountryCodeErrorEnum
                         */
                        CountryCodeErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.CountryCodeErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.CountryCodeErrorEnum();
                        };

                        /**
                         * Creates a plain object from a CountryCodeErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.CountryCodeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.CountryCodeErrorEnum} message CountryCodeErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CountryCodeErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CountryCodeErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.CountryCodeErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CountryCodeErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CountryCodeError enum.
                         * @name google.ads.googleads.v1.errors.CountryCodeErrorEnum.CountryCodeError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} INVALID_COUNTRY_CODE=2 INVALID_COUNTRY_CODE value
                         */
                        CountryCodeErrorEnum.CountryCodeError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "INVALID_COUNTRY_CODE"] = 2;
                            return values;
                        })();

                        return CountryCodeErrorEnum;
                    })();

                    errors.CriterionErrorEnum = (function() {

                        /**
                         * Properties of a CriterionErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ICriterionErrorEnum
                         */

                        /**
                         * Constructs a new CriterionErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a CriterionErrorEnum.
                         * @implements ICriterionErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ICriterionErrorEnum=} [properties] Properties to set
                         */
                        function CriterionErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CriterionErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.CriterionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICriterionErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.CriterionErrorEnum} CriterionErrorEnum instance
                         */
                        CriterionErrorEnum.create = function create(properties) {
                            return new CriterionErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified CriterionErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.CriterionErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.CriterionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICriterionErrorEnum} message CriterionErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CriterionErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CriterionErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.CriterionErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CriterionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICriterionErrorEnum} message CriterionErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CriterionErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CriterionErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.CriterionErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.CriterionErrorEnum} CriterionErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CriterionErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.CriterionErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CriterionErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CriterionErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.CriterionErrorEnum} CriterionErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CriterionErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CriterionErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.CriterionErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CriterionErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CriterionErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.CriterionErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.CriterionErrorEnum} CriterionErrorEnum
                         */
                        CriterionErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.CriterionErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.CriterionErrorEnum();
                        };

                        /**
                         * Creates a plain object from a CriterionErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.CriterionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.CriterionErrorEnum} message CriterionErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CriterionErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CriterionErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.CriterionErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CriterionErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CriterionError enum.
                         * @name google.ads.googleads.v1.errors.CriterionErrorEnum.CriterionError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CONCRETE_TYPE_REQUIRED=2 CONCRETE_TYPE_REQUIRED value
                         * @property {number} INVALID_EXCLUDED_CATEGORY=3 INVALID_EXCLUDED_CATEGORY value
                         * @property {number} INVALID_KEYWORD_TEXT=4 INVALID_KEYWORD_TEXT value
                         * @property {number} KEYWORD_TEXT_TOO_LONG=5 KEYWORD_TEXT_TOO_LONG value
                         * @property {number} KEYWORD_HAS_TOO_MANY_WORDS=6 KEYWORD_HAS_TOO_MANY_WORDS value
                         * @property {number} KEYWORD_HAS_INVALID_CHARS=7 KEYWORD_HAS_INVALID_CHARS value
                         * @property {number} INVALID_PLACEMENT_URL=8 INVALID_PLACEMENT_URL value
                         * @property {number} INVALID_USER_LIST=9 INVALID_USER_LIST value
                         * @property {number} INVALID_USER_INTEREST=10 INVALID_USER_INTEREST value
                         * @property {number} INVALID_FORMAT_FOR_PLACEMENT_URL=11 INVALID_FORMAT_FOR_PLACEMENT_URL value
                         * @property {number} PLACEMENT_URL_IS_TOO_LONG=12 PLACEMENT_URL_IS_TOO_LONG value
                         * @property {number} PLACEMENT_URL_HAS_ILLEGAL_CHAR=13 PLACEMENT_URL_HAS_ILLEGAL_CHAR value
                         * @property {number} PLACEMENT_URL_HAS_MULTIPLE_SITES_IN_LINE=14 PLACEMENT_URL_HAS_MULTIPLE_SITES_IN_LINE value
                         * @property {number} PLACEMENT_IS_NOT_AVAILABLE_FOR_TARGETING_OR_EXCLUSION=15 PLACEMENT_IS_NOT_AVAILABLE_FOR_TARGETING_OR_EXCLUSION value
                         * @property {number} INVALID_TOPIC_PATH=16 INVALID_TOPIC_PATH value
                         * @property {number} INVALID_YOUTUBE_CHANNEL_ID=17 INVALID_YOUTUBE_CHANNEL_ID value
                         * @property {number} INVALID_YOUTUBE_VIDEO_ID=18 INVALID_YOUTUBE_VIDEO_ID value
                         * @property {number} YOUTUBE_VERTICAL_CHANNEL_DEPRECATED=19 YOUTUBE_VERTICAL_CHANNEL_DEPRECATED value
                         * @property {number} YOUTUBE_DEMOGRAPHIC_CHANNEL_DEPRECATED=20 YOUTUBE_DEMOGRAPHIC_CHANNEL_DEPRECATED value
                         * @property {number} YOUTUBE_URL_UNSUPPORTED=21 YOUTUBE_URL_UNSUPPORTED value
                         * @property {number} CANNOT_EXCLUDE_CRITERIA_TYPE=22 CANNOT_EXCLUDE_CRITERIA_TYPE value
                         * @property {number} CANNOT_ADD_CRITERIA_TYPE=23 CANNOT_ADD_CRITERIA_TYPE value
                         * @property {number} INVALID_PRODUCT_FILTER=24 INVALID_PRODUCT_FILTER value
                         * @property {number} PRODUCT_FILTER_TOO_LONG=25 PRODUCT_FILTER_TOO_LONG value
                         * @property {number} CANNOT_EXCLUDE_SIMILAR_USER_LIST=26 CANNOT_EXCLUDE_SIMILAR_USER_LIST value
                         * @property {number} CANNOT_ADD_CLOSED_USER_LIST=27 CANNOT_ADD_CLOSED_USER_LIST value
                         * @property {number} CANNOT_ADD_DISPLAY_ONLY_LISTS_TO_SEARCH_ONLY_CAMPAIGNS=28 CANNOT_ADD_DISPLAY_ONLY_LISTS_TO_SEARCH_ONLY_CAMPAIGNS value
                         * @property {number} CANNOT_ADD_DISPLAY_ONLY_LISTS_TO_SEARCH_CAMPAIGNS=29 CANNOT_ADD_DISPLAY_ONLY_LISTS_TO_SEARCH_CAMPAIGNS value
                         * @property {number} CANNOT_ADD_DISPLAY_ONLY_LISTS_TO_SHOPPING_CAMPAIGNS=30 CANNOT_ADD_DISPLAY_ONLY_LISTS_TO_SHOPPING_CAMPAIGNS value
                         * @property {number} CANNOT_ADD_USER_INTERESTS_TO_SEARCH_CAMPAIGNS=31 CANNOT_ADD_USER_INTERESTS_TO_SEARCH_CAMPAIGNS value
                         * @property {number} CANNOT_SET_BIDS_ON_CRITERION_TYPE_IN_SEARCH_CAMPAIGNS=32 CANNOT_SET_BIDS_ON_CRITERION_TYPE_IN_SEARCH_CAMPAIGNS value
                         * @property {number} CANNOT_ADD_URLS_TO_CRITERION_TYPE_FOR_CAMPAIGN_TYPE=33 CANNOT_ADD_URLS_TO_CRITERION_TYPE_FOR_CAMPAIGN_TYPE value
                         * @property {number} INVALID_CUSTOM_AFFINITY=96 INVALID_CUSTOM_AFFINITY value
                         * @property {number} INVALID_CUSTOM_INTENT=97 INVALID_CUSTOM_INTENT value
                         * @property {number} INVALID_IP_ADDRESS=34 INVALID_IP_ADDRESS value
                         * @property {number} INVALID_IP_FORMAT=35 INVALID_IP_FORMAT value
                         * @property {number} INVALID_MOBILE_APP=36 INVALID_MOBILE_APP value
                         * @property {number} INVALID_MOBILE_APP_CATEGORY=37 INVALID_MOBILE_APP_CATEGORY value
                         * @property {number} INVALID_CRITERION_ID=38 INVALID_CRITERION_ID value
                         * @property {number} CANNOT_TARGET_CRITERION=39 CANNOT_TARGET_CRITERION value
                         * @property {number} CANNOT_TARGET_OBSOLETE_CRITERION=40 CANNOT_TARGET_OBSOLETE_CRITERION value
                         * @property {number} CRITERION_ID_AND_TYPE_MISMATCH=41 CRITERION_ID_AND_TYPE_MISMATCH value
                         * @property {number} INVALID_PROXIMITY_RADIUS=42 INVALID_PROXIMITY_RADIUS value
                         * @property {number} INVALID_PROXIMITY_RADIUS_UNITS=43 INVALID_PROXIMITY_RADIUS_UNITS value
                         * @property {number} INVALID_STREETADDRESS_LENGTH=44 INVALID_STREETADDRESS_LENGTH value
                         * @property {number} INVALID_CITYNAME_LENGTH=45 INVALID_CITYNAME_LENGTH value
                         * @property {number} INVALID_REGIONCODE_LENGTH=46 INVALID_REGIONCODE_LENGTH value
                         * @property {number} INVALID_REGIONNAME_LENGTH=47 INVALID_REGIONNAME_LENGTH value
                         * @property {number} INVALID_POSTALCODE_LENGTH=48 INVALID_POSTALCODE_LENGTH value
                         * @property {number} INVALID_COUNTRY_CODE=49 INVALID_COUNTRY_CODE value
                         * @property {number} INVALID_LATITUDE=50 INVALID_LATITUDE value
                         * @property {number} INVALID_LONGITUDE=51 INVALID_LONGITUDE value
                         * @property {number} PROXIMITY_GEOPOINT_AND_ADDRESS_BOTH_CANNOT_BE_NULL=52 PROXIMITY_GEOPOINT_AND_ADDRESS_BOTH_CANNOT_BE_NULL value
                         * @property {number} INVALID_PROXIMITY_ADDRESS=53 INVALID_PROXIMITY_ADDRESS value
                         * @property {number} INVALID_USER_DOMAIN_NAME=54 INVALID_USER_DOMAIN_NAME value
                         * @property {number} CRITERION_PARAMETER_TOO_LONG=55 CRITERION_PARAMETER_TOO_LONG value
                         * @property {number} AD_SCHEDULE_TIME_INTERVALS_OVERLAP=56 AD_SCHEDULE_TIME_INTERVALS_OVERLAP value
                         * @property {number} AD_SCHEDULE_INTERVAL_CANNOT_SPAN_MULTIPLE_DAYS=57 AD_SCHEDULE_INTERVAL_CANNOT_SPAN_MULTIPLE_DAYS value
                         * @property {number} AD_SCHEDULE_INVALID_TIME_INTERVAL=58 AD_SCHEDULE_INVALID_TIME_INTERVAL value
                         * @property {number} AD_SCHEDULE_EXCEEDED_INTERVALS_PER_DAY_LIMIT=59 AD_SCHEDULE_EXCEEDED_INTERVALS_PER_DAY_LIMIT value
                         * @property {number} AD_SCHEDULE_CRITERION_ID_MISMATCHING_FIELDS=60 AD_SCHEDULE_CRITERION_ID_MISMATCHING_FIELDS value
                         * @property {number} CANNOT_BID_MODIFY_CRITERION_TYPE=61 CANNOT_BID_MODIFY_CRITERION_TYPE value
                         * @property {number} CANNOT_BID_MODIFY_CRITERION_CAMPAIGN_OPTED_OUT=62 CANNOT_BID_MODIFY_CRITERION_CAMPAIGN_OPTED_OUT value
                         * @property {number} CANNOT_BID_MODIFY_NEGATIVE_CRITERION=63 CANNOT_BID_MODIFY_NEGATIVE_CRITERION value
                         * @property {number} BID_MODIFIER_ALREADY_EXISTS=64 BID_MODIFIER_ALREADY_EXISTS value
                         * @property {number} FEED_ID_NOT_ALLOWED=65 FEED_ID_NOT_ALLOWED value
                         * @property {number} ACCOUNT_INELIGIBLE_FOR_CRITERIA_TYPE=66 ACCOUNT_INELIGIBLE_FOR_CRITERIA_TYPE value
                         * @property {number} CRITERIA_TYPE_INVALID_FOR_BIDDING_STRATEGY=67 CRITERIA_TYPE_INVALID_FOR_BIDDING_STRATEGY value
                         * @property {number} CANNOT_EXCLUDE_CRITERION=68 CANNOT_EXCLUDE_CRITERION value
                         * @property {number} CANNOT_REMOVE_CRITERION=69 CANNOT_REMOVE_CRITERION value
                         * @property {number} PRODUCT_SCOPE_TOO_LONG=70 PRODUCT_SCOPE_TOO_LONG value
                         * @property {number} PRODUCT_SCOPE_TOO_MANY_DIMENSIONS=71 PRODUCT_SCOPE_TOO_MANY_DIMENSIONS value
                         * @property {number} PRODUCT_PARTITION_TOO_LONG=72 PRODUCT_PARTITION_TOO_LONG value
                         * @property {number} PRODUCT_PARTITION_TOO_MANY_DIMENSIONS=73 PRODUCT_PARTITION_TOO_MANY_DIMENSIONS value
                         * @property {number} INVALID_PRODUCT_DIMENSION=74 INVALID_PRODUCT_DIMENSION value
                         * @property {number} INVALID_PRODUCT_DIMENSION_TYPE=75 INVALID_PRODUCT_DIMENSION_TYPE value
                         * @property {number} INVALID_PRODUCT_BIDDING_CATEGORY=76 INVALID_PRODUCT_BIDDING_CATEGORY value
                         * @property {number} MISSING_SHOPPING_SETTING=77 MISSING_SHOPPING_SETTING value
                         * @property {number} INVALID_MATCHING_FUNCTION=78 INVALID_MATCHING_FUNCTION value
                         * @property {number} LOCATION_FILTER_NOT_ALLOWED=79 LOCATION_FILTER_NOT_ALLOWED value
                         * @property {number} INVALID_FEED_FOR_LOCATION_FILTER=98 INVALID_FEED_FOR_LOCATION_FILTER value
                         * @property {number} LOCATION_FILTER_INVALID=80 LOCATION_FILTER_INVALID value
                         * @property {number} CANNOT_ATTACH_CRITERIA_AT_CAMPAIGN_AND_ADGROUP=81 CANNOT_ATTACH_CRITERIA_AT_CAMPAIGN_AND_ADGROUP value
                         * @property {number} HOTEL_LENGTH_OF_STAY_OVERLAPS_WITH_EXISTING_CRITERION=82 HOTEL_LENGTH_OF_STAY_OVERLAPS_WITH_EXISTING_CRITERION value
                         * @property {number} HOTEL_ADVANCE_BOOKING_WINDOW_OVERLAPS_WITH_EXISTING_CRITERION=83 HOTEL_ADVANCE_BOOKING_WINDOW_OVERLAPS_WITH_EXISTING_CRITERION value
                         * @property {number} FIELD_INCOMPATIBLE_WITH_NEGATIVE_TARGETING=84 FIELD_INCOMPATIBLE_WITH_NEGATIVE_TARGETING value
                         * @property {number} INVALID_WEBPAGE_CONDITION=85 INVALID_WEBPAGE_CONDITION value
                         * @property {number} INVALID_WEBPAGE_CONDITION_URL=86 INVALID_WEBPAGE_CONDITION_URL value
                         * @property {number} WEBPAGE_CONDITION_URL_CANNOT_BE_EMPTY=87 WEBPAGE_CONDITION_URL_CANNOT_BE_EMPTY value
                         * @property {number} WEBPAGE_CONDITION_URL_UNSUPPORTED_PROTOCOL=88 WEBPAGE_CONDITION_URL_UNSUPPORTED_PROTOCOL value
                         * @property {number} WEBPAGE_CONDITION_URL_CANNOT_BE_IP_ADDRESS=89 WEBPAGE_CONDITION_URL_CANNOT_BE_IP_ADDRESS value
                         * @property {number} WEBPAGE_CONDITION_URL_DOMAIN_NOT_CONSISTENT_WITH_CAMPAIGN_SETTING=90 WEBPAGE_CONDITION_URL_DOMAIN_NOT_CONSISTENT_WITH_CAMPAIGN_SETTING value
                         * @property {number} WEBPAGE_CONDITION_URL_CANNOT_BE_PUBLIC_SUFFIX=91 WEBPAGE_CONDITION_URL_CANNOT_BE_PUBLIC_SUFFIX value
                         * @property {number} WEBPAGE_CONDITION_URL_INVALID_PUBLIC_SUFFIX=92 WEBPAGE_CONDITION_URL_INVALID_PUBLIC_SUFFIX value
                         * @property {number} WEBPAGE_CONDITION_URL_VALUE_TRACK_VALUE_NOT_SUPPORTED=93 WEBPAGE_CONDITION_URL_VALUE_TRACK_VALUE_NOT_SUPPORTED value
                         * @property {number} WEBPAGE_CRITERION_URL_EQUALS_CAN_HAVE_ONLY_ONE_CONDITION=94 WEBPAGE_CRITERION_URL_EQUALS_CAN_HAVE_ONLY_ONE_CONDITION value
                         * @property {number} WEBPAGE_CRITERION_NOT_SUPPORTED_ON_NON_DSA_AD_GROUP=95 WEBPAGE_CRITERION_NOT_SUPPORTED_ON_NON_DSA_AD_GROUP value
                         */
                        CriterionErrorEnum.CriterionError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CONCRETE_TYPE_REQUIRED"] = 2;
                            values[valuesById[3] = "INVALID_EXCLUDED_CATEGORY"] = 3;
                            values[valuesById[4] = "INVALID_KEYWORD_TEXT"] = 4;
                            values[valuesById[5] = "KEYWORD_TEXT_TOO_LONG"] = 5;
                            values[valuesById[6] = "KEYWORD_HAS_TOO_MANY_WORDS"] = 6;
                            values[valuesById[7] = "KEYWORD_HAS_INVALID_CHARS"] = 7;
                            values[valuesById[8] = "INVALID_PLACEMENT_URL"] = 8;
                            values[valuesById[9] = "INVALID_USER_LIST"] = 9;
                            values[valuesById[10] = "INVALID_USER_INTEREST"] = 10;
                            values[valuesById[11] = "INVALID_FORMAT_FOR_PLACEMENT_URL"] = 11;
                            values[valuesById[12] = "PLACEMENT_URL_IS_TOO_LONG"] = 12;
                            values[valuesById[13] = "PLACEMENT_URL_HAS_ILLEGAL_CHAR"] = 13;
                            values[valuesById[14] = "PLACEMENT_URL_HAS_MULTIPLE_SITES_IN_LINE"] = 14;
                            values[valuesById[15] = "PLACEMENT_IS_NOT_AVAILABLE_FOR_TARGETING_OR_EXCLUSION"] = 15;
                            values[valuesById[16] = "INVALID_TOPIC_PATH"] = 16;
                            values[valuesById[17] = "INVALID_YOUTUBE_CHANNEL_ID"] = 17;
                            values[valuesById[18] = "INVALID_YOUTUBE_VIDEO_ID"] = 18;
                            values[valuesById[19] = "YOUTUBE_VERTICAL_CHANNEL_DEPRECATED"] = 19;
                            values[valuesById[20] = "YOUTUBE_DEMOGRAPHIC_CHANNEL_DEPRECATED"] = 20;
                            values[valuesById[21] = "YOUTUBE_URL_UNSUPPORTED"] = 21;
                            values[valuesById[22] = "CANNOT_EXCLUDE_CRITERIA_TYPE"] = 22;
                            values[valuesById[23] = "CANNOT_ADD_CRITERIA_TYPE"] = 23;
                            values[valuesById[24] = "INVALID_PRODUCT_FILTER"] = 24;
                            values[valuesById[25] = "PRODUCT_FILTER_TOO_LONG"] = 25;
                            values[valuesById[26] = "CANNOT_EXCLUDE_SIMILAR_USER_LIST"] = 26;
                            values[valuesById[27] = "CANNOT_ADD_CLOSED_USER_LIST"] = 27;
                            values[valuesById[28] = "CANNOT_ADD_DISPLAY_ONLY_LISTS_TO_SEARCH_ONLY_CAMPAIGNS"] = 28;
                            values[valuesById[29] = "CANNOT_ADD_DISPLAY_ONLY_LISTS_TO_SEARCH_CAMPAIGNS"] = 29;
                            values[valuesById[30] = "CANNOT_ADD_DISPLAY_ONLY_LISTS_TO_SHOPPING_CAMPAIGNS"] = 30;
                            values[valuesById[31] = "CANNOT_ADD_USER_INTERESTS_TO_SEARCH_CAMPAIGNS"] = 31;
                            values[valuesById[32] = "CANNOT_SET_BIDS_ON_CRITERION_TYPE_IN_SEARCH_CAMPAIGNS"] = 32;
                            values[valuesById[33] = "CANNOT_ADD_URLS_TO_CRITERION_TYPE_FOR_CAMPAIGN_TYPE"] = 33;
                            values[valuesById[96] = "INVALID_CUSTOM_AFFINITY"] = 96;
                            values[valuesById[97] = "INVALID_CUSTOM_INTENT"] = 97;
                            values[valuesById[34] = "INVALID_IP_ADDRESS"] = 34;
                            values[valuesById[35] = "INVALID_IP_FORMAT"] = 35;
                            values[valuesById[36] = "INVALID_MOBILE_APP"] = 36;
                            values[valuesById[37] = "INVALID_MOBILE_APP_CATEGORY"] = 37;
                            values[valuesById[38] = "INVALID_CRITERION_ID"] = 38;
                            values[valuesById[39] = "CANNOT_TARGET_CRITERION"] = 39;
                            values[valuesById[40] = "CANNOT_TARGET_OBSOLETE_CRITERION"] = 40;
                            values[valuesById[41] = "CRITERION_ID_AND_TYPE_MISMATCH"] = 41;
                            values[valuesById[42] = "INVALID_PROXIMITY_RADIUS"] = 42;
                            values[valuesById[43] = "INVALID_PROXIMITY_RADIUS_UNITS"] = 43;
                            values[valuesById[44] = "INVALID_STREETADDRESS_LENGTH"] = 44;
                            values[valuesById[45] = "INVALID_CITYNAME_LENGTH"] = 45;
                            values[valuesById[46] = "INVALID_REGIONCODE_LENGTH"] = 46;
                            values[valuesById[47] = "INVALID_REGIONNAME_LENGTH"] = 47;
                            values[valuesById[48] = "INVALID_POSTALCODE_LENGTH"] = 48;
                            values[valuesById[49] = "INVALID_COUNTRY_CODE"] = 49;
                            values[valuesById[50] = "INVALID_LATITUDE"] = 50;
                            values[valuesById[51] = "INVALID_LONGITUDE"] = 51;
                            values[valuesById[52] = "PROXIMITY_GEOPOINT_AND_ADDRESS_BOTH_CANNOT_BE_NULL"] = 52;
                            values[valuesById[53] = "INVALID_PROXIMITY_ADDRESS"] = 53;
                            values[valuesById[54] = "INVALID_USER_DOMAIN_NAME"] = 54;
                            values[valuesById[55] = "CRITERION_PARAMETER_TOO_LONG"] = 55;
                            values[valuesById[56] = "AD_SCHEDULE_TIME_INTERVALS_OVERLAP"] = 56;
                            values[valuesById[57] = "AD_SCHEDULE_INTERVAL_CANNOT_SPAN_MULTIPLE_DAYS"] = 57;
                            values[valuesById[58] = "AD_SCHEDULE_INVALID_TIME_INTERVAL"] = 58;
                            values[valuesById[59] = "AD_SCHEDULE_EXCEEDED_INTERVALS_PER_DAY_LIMIT"] = 59;
                            values[valuesById[60] = "AD_SCHEDULE_CRITERION_ID_MISMATCHING_FIELDS"] = 60;
                            values[valuesById[61] = "CANNOT_BID_MODIFY_CRITERION_TYPE"] = 61;
                            values[valuesById[62] = "CANNOT_BID_MODIFY_CRITERION_CAMPAIGN_OPTED_OUT"] = 62;
                            values[valuesById[63] = "CANNOT_BID_MODIFY_NEGATIVE_CRITERION"] = 63;
                            values[valuesById[64] = "BID_MODIFIER_ALREADY_EXISTS"] = 64;
                            values[valuesById[65] = "FEED_ID_NOT_ALLOWED"] = 65;
                            values[valuesById[66] = "ACCOUNT_INELIGIBLE_FOR_CRITERIA_TYPE"] = 66;
                            values[valuesById[67] = "CRITERIA_TYPE_INVALID_FOR_BIDDING_STRATEGY"] = 67;
                            values[valuesById[68] = "CANNOT_EXCLUDE_CRITERION"] = 68;
                            values[valuesById[69] = "CANNOT_REMOVE_CRITERION"] = 69;
                            values[valuesById[70] = "PRODUCT_SCOPE_TOO_LONG"] = 70;
                            values[valuesById[71] = "PRODUCT_SCOPE_TOO_MANY_DIMENSIONS"] = 71;
                            values[valuesById[72] = "PRODUCT_PARTITION_TOO_LONG"] = 72;
                            values[valuesById[73] = "PRODUCT_PARTITION_TOO_MANY_DIMENSIONS"] = 73;
                            values[valuesById[74] = "INVALID_PRODUCT_DIMENSION"] = 74;
                            values[valuesById[75] = "INVALID_PRODUCT_DIMENSION_TYPE"] = 75;
                            values[valuesById[76] = "INVALID_PRODUCT_BIDDING_CATEGORY"] = 76;
                            values[valuesById[77] = "MISSING_SHOPPING_SETTING"] = 77;
                            values[valuesById[78] = "INVALID_MATCHING_FUNCTION"] = 78;
                            values[valuesById[79] = "LOCATION_FILTER_NOT_ALLOWED"] = 79;
                            values[valuesById[98] = "INVALID_FEED_FOR_LOCATION_FILTER"] = 98;
                            values[valuesById[80] = "LOCATION_FILTER_INVALID"] = 80;
                            values[valuesById[81] = "CANNOT_ATTACH_CRITERIA_AT_CAMPAIGN_AND_ADGROUP"] = 81;
                            values[valuesById[82] = "HOTEL_LENGTH_OF_STAY_OVERLAPS_WITH_EXISTING_CRITERION"] = 82;
                            values[valuesById[83] = "HOTEL_ADVANCE_BOOKING_WINDOW_OVERLAPS_WITH_EXISTING_CRITERION"] = 83;
                            values[valuesById[84] = "FIELD_INCOMPATIBLE_WITH_NEGATIVE_TARGETING"] = 84;
                            values[valuesById[85] = "INVALID_WEBPAGE_CONDITION"] = 85;
                            values[valuesById[86] = "INVALID_WEBPAGE_CONDITION_URL"] = 86;
                            values[valuesById[87] = "WEBPAGE_CONDITION_URL_CANNOT_BE_EMPTY"] = 87;
                            values[valuesById[88] = "WEBPAGE_CONDITION_URL_UNSUPPORTED_PROTOCOL"] = 88;
                            values[valuesById[89] = "WEBPAGE_CONDITION_URL_CANNOT_BE_IP_ADDRESS"] = 89;
                            values[valuesById[90] = "WEBPAGE_CONDITION_URL_DOMAIN_NOT_CONSISTENT_WITH_CAMPAIGN_SETTING"] = 90;
                            values[valuesById[91] = "WEBPAGE_CONDITION_URL_CANNOT_BE_PUBLIC_SUFFIX"] = 91;
                            values[valuesById[92] = "WEBPAGE_CONDITION_URL_INVALID_PUBLIC_SUFFIX"] = 92;
                            values[valuesById[93] = "WEBPAGE_CONDITION_URL_VALUE_TRACK_VALUE_NOT_SUPPORTED"] = 93;
                            values[valuesById[94] = "WEBPAGE_CRITERION_URL_EQUALS_CAN_HAVE_ONLY_ONE_CONDITION"] = 94;
                            values[valuesById[95] = "WEBPAGE_CRITERION_NOT_SUPPORTED_ON_NON_DSA_AD_GROUP"] = 95;
                            return values;
                        })();

                        return CriterionErrorEnum;
                    })();

                    errors.CustomInterestErrorEnum = (function() {

                        /**
                         * Properties of a CustomInterestErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ICustomInterestErrorEnum
                         */

                        /**
                         * Constructs a new CustomInterestErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a CustomInterestErrorEnum.
                         * @implements ICustomInterestErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ICustomInterestErrorEnum=} [properties] Properties to set
                         */
                        function CustomInterestErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CustomInterestErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.CustomInterestErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICustomInterestErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.CustomInterestErrorEnum} CustomInterestErrorEnum instance
                         */
                        CustomInterestErrorEnum.create = function create(properties) {
                            return new CustomInterestErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified CustomInterestErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.CustomInterestErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.CustomInterestErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICustomInterestErrorEnum} message CustomInterestErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomInterestErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomInterestErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.CustomInterestErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CustomInterestErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICustomInterestErrorEnum} message CustomInterestErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomInterestErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomInterestErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.CustomInterestErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.CustomInterestErrorEnum} CustomInterestErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomInterestErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.CustomInterestErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomInterestErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CustomInterestErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.CustomInterestErrorEnum} CustomInterestErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomInterestErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomInterestErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.CustomInterestErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomInterestErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CustomInterestErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.CustomInterestErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.CustomInterestErrorEnum} CustomInterestErrorEnum
                         */
                        CustomInterestErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.CustomInterestErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.CustomInterestErrorEnum();
                        };

                        /**
                         * Creates a plain object from a CustomInterestErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.CustomInterestErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.CustomInterestErrorEnum} message CustomInterestErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomInterestErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CustomInterestErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.CustomInterestErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomInterestErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CustomInterestError enum.
                         * @name google.ads.googleads.v1.errors.CustomInterestErrorEnum.CustomInterestError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} NAME_ALREADY_USED=2 NAME_ALREADY_USED value
                         * @property {number} CUSTOM_INTEREST_MEMBER_ID_AND_TYPE_PARAMETER_NOT_PRESENT_IN_REMOVE=3 CUSTOM_INTEREST_MEMBER_ID_AND_TYPE_PARAMETER_NOT_PRESENT_IN_REMOVE value
                         * @property {number} TYPE_AND_PARAMETER_NOT_FOUND=4 TYPE_AND_PARAMETER_NOT_FOUND value
                         * @property {number} TYPE_AND_PARAMETER_ALREADY_EXISTED=5 TYPE_AND_PARAMETER_ALREADY_EXISTED value
                         * @property {number} INVALID_CUSTOM_INTEREST_MEMBER_TYPE=6 INVALID_CUSTOM_INTEREST_MEMBER_TYPE value
                         * @property {number} CANNOT_REMOVE_WHILE_IN_USE=7 CANNOT_REMOVE_WHILE_IN_USE value
                         * @property {number} CANNOT_CHANGE_TYPE=8 CANNOT_CHANGE_TYPE value
                         */
                        CustomInterestErrorEnum.CustomInterestError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "NAME_ALREADY_USED"] = 2;
                            values[valuesById[3] = "CUSTOM_INTEREST_MEMBER_ID_AND_TYPE_PARAMETER_NOT_PRESENT_IN_REMOVE"] = 3;
                            values[valuesById[4] = "TYPE_AND_PARAMETER_NOT_FOUND"] = 4;
                            values[valuesById[5] = "TYPE_AND_PARAMETER_ALREADY_EXISTED"] = 5;
                            values[valuesById[6] = "INVALID_CUSTOM_INTEREST_MEMBER_TYPE"] = 6;
                            values[valuesById[7] = "CANNOT_REMOVE_WHILE_IN_USE"] = 7;
                            values[valuesById[8] = "CANNOT_CHANGE_TYPE"] = 8;
                            return values;
                        })();

                        return CustomInterestErrorEnum;
                    })();

                    errors.CustomerClientLinkErrorEnum = (function() {

                        /**
                         * Properties of a CustomerClientLinkErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ICustomerClientLinkErrorEnum
                         */

                        /**
                         * Constructs a new CustomerClientLinkErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a CustomerClientLinkErrorEnum.
                         * @implements ICustomerClientLinkErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ICustomerClientLinkErrorEnum=} [properties] Properties to set
                         */
                        function CustomerClientLinkErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CustomerClientLinkErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICustomerClientLinkErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum} CustomerClientLinkErrorEnum instance
                         */
                        CustomerClientLinkErrorEnum.create = function create(properties) {
                            return new CustomerClientLinkErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified CustomerClientLinkErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICustomerClientLinkErrorEnum} message CustomerClientLinkErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerClientLinkErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerClientLinkErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICustomerClientLinkErrorEnum} message CustomerClientLinkErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerClientLinkErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerClientLinkErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum} CustomerClientLinkErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerClientLinkErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerClientLinkErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum} CustomerClientLinkErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerClientLinkErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerClientLinkErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerClientLinkErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CustomerClientLinkErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum} CustomerClientLinkErrorEnum
                         */
                        CustomerClientLinkErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum();
                        };

                        /**
                         * Creates a plain object from a CustomerClientLinkErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum} message CustomerClientLinkErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerClientLinkErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CustomerClientLinkErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerClientLinkErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CustomerClientLinkError enum.
                         * @name google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum.CustomerClientLinkError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CLIENT_ALREADY_INVITED_BY_THIS_MANAGER=2 CLIENT_ALREADY_INVITED_BY_THIS_MANAGER value
                         * @property {number} CLIENT_ALREADY_MANAGED_IN_HIERARCHY=3 CLIENT_ALREADY_MANAGED_IN_HIERARCHY value
                         * @property {number} CYCLIC_LINK_NOT_ALLOWED=4 CYCLIC_LINK_NOT_ALLOWED value
                         * @property {number} CUSTOMER_HAS_TOO_MANY_ACCOUNTS=5 CUSTOMER_HAS_TOO_MANY_ACCOUNTS value
                         * @property {number} CLIENT_HAS_TOO_MANY_INVITATIONS=6 CLIENT_HAS_TOO_MANY_INVITATIONS value
                         * @property {number} CANNOT_HIDE_OR_UNHIDE_MANAGER_ACCOUNTS=7 CANNOT_HIDE_OR_UNHIDE_MANAGER_ACCOUNTS value
                         * @property {number} CUSTOMER_HAS_TOO_MANY_ACCOUNTS_AT_MANAGER=8 CUSTOMER_HAS_TOO_MANY_ACCOUNTS_AT_MANAGER value
                         */
                        CustomerClientLinkErrorEnum.CustomerClientLinkError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CLIENT_ALREADY_INVITED_BY_THIS_MANAGER"] = 2;
                            values[valuesById[3] = "CLIENT_ALREADY_MANAGED_IN_HIERARCHY"] = 3;
                            values[valuesById[4] = "CYCLIC_LINK_NOT_ALLOWED"] = 4;
                            values[valuesById[5] = "CUSTOMER_HAS_TOO_MANY_ACCOUNTS"] = 5;
                            values[valuesById[6] = "CLIENT_HAS_TOO_MANY_INVITATIONS"] = 6;
                            values[valuesById[7] = "CANNOT_HIDE_OR_UNHIDE_MANAGER_ACCOUNTS"] = 7;
                            values[valuesById[8] = "CUSTOMER_HAS_TOO_MANY_ACCOUNTS_AT_MANAGER"] = 8;
                            return values;
                        })();

                        return CustomerClientLinkErrorEnum;
                    })();

                    errors.CustomerErrorEnum = (function() {

                        /**
                         * Properties of a CustomerErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ICustomerErrorEnum
                         */

                        /**
                         * Constructs a new CustomerErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a CustomerErrorEnum.
                         * @implements ICustomerErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ICustomerErrorEnum=} [properties] Properties to set
                         */
                        function CustomerErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CustomerErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.CustomerErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICustomerErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.CustomerErrorEnum} CustomerErrorEnum instance
                         */
                        CustomerErrorEnum.create = function create(properties) {
                            return new CustomerErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified CustomerErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.CustomerErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.CustomerErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICustomerErrorEnum} message CustomerErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.CustomerErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CustomerErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICustomerErrorEnum} message CustomerErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.CustomerErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.CustomerErrorEnum} CustomerErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.CustomerErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CustomerErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.CustomerErrorEnum} CustomerErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.CustomerErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CustomerErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.CustomerErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.CustomerErrorEnum} CustomerErrorEnum
                         */
                        CustomerErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.CustomerErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.CustomerErrorEnum();
                        };

                        /**
                         * Creates a plain object from a CustomerErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.CustomerErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.CustomerErrorEnum} message CustomerErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CustomerErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.CustomerErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CustomerError enum.
                         * @name google.ads.googleads.v1.errors.CustomerErrorEnum.CustomerError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} STATUS_CHANGE_DISALLOWED=2 STATUS_CHANGE_DISALLOWED value
                         * @property {number} ACCOUNT_NOT_SET_UP=3 ACCOUNT_NOT_SET_UP value
                         */
                        CustomerErrorEnum.CustomerError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "STATUS_CHANGE_DISALLOWED"] = 2;
                            values[valuesById[3] = "ACCOUNT_NOT_SET_UP"] = 3;
                            return values;
                        })();

                        return CustomerErrorEnum;
                    })();

                    errors.CustomerFeedErrorEnum = (function() {

                        /**
                         * Properties of a CustomerFeedErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ICustomerFeedErrorEnum
                         */

                        /**
                         * Constructs a new CustomerFeedErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a CustomerFeedErrorEnum.
                         * @implements ICustomerFeedErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ICustomerFeedErrorEnum=} [properties] Properties to set
                         */
                        function CustomerFeedErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CustomerFeedErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.CustomerFeedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICustomerFeedErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.CustomerFeedErrorEnum} CustomerFeedErrorEnum instance
                         */
                        CustomerFeedErrorEnum.create = function create(properties) {
                            return new CustomerFeedErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified CustomerFeedErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.CustomerFeedErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.CustomerFeedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICustomerFeedErrorEnum} message CustomerFeedErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerFeedErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerFeedErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.CustomerFeedErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CustomerFeedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICustomerFeedErrorEnum} message CustomerFeedErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerFeedErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerFeedErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.CustomerFeedErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.CustomerFeedErrorEnum} CustomerFeedErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerFeedErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.CustomerFeedErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerFeedErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CustomerFeedErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.CustomerFeedErrorEnum} CustomerFeedErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerFeedErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerFeedErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.CustomerFeedErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerFeedErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CustomerFeedErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.CustomerFeedErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.CustomerFeedErrorEnum} CustomerFeedErrorEnum
                         */
                        CustomerFeedErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.CustomerFeedErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.CustomerFeedErrorEnum();
                        };

                        /**
                         * Creates a plain object from a CustomerFeedErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.CustomerFeedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.CustomerFeedErrorEnum} message CustomerFeedErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerFeedErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CustomerFeedErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.CustomerFeedErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerFeedErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CustomerFeedError enum.
                         * @name google.ads.googleads.v1.errors.CustomerFeedErrorEnum.CustomerFeedError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE=2 FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE value
                         * @property {number} CANNOT_CREATE_FOR_REMOVED_FEED=3 CANNOT_CREATE_FOR_REMOVED_FEED value
                         * @property {number} CANNOT_CREATE_ALREADY_EXISTING_CUSTOMER_FEED=4 CANNOT_CREATE_ALREADY_EXISTING_CUSTOMER_FEED value
                         * @property {number} CANNOT_MODIFY_REMOVED_CUSTOMER_FEED=5 CANNOT_MODIFY_REMOVED_CUSTOMER_FEED value
                         * @property {number} INVALID_PLACEHOLDER_TYPE=6 INVALID_PLACEHOLDER_TYPE value
                         * @property {number} MISSING_FEEDMAPPING_FOR_PLACEHOLDER_TYPE=7 MISSING_FEEDMAPPING_FOR_PLACEHOLDER_TYPE value
                         * @property {number} PLACEHOLDER_TYPE_NOT_ALLOWED_ON_CUSTOMER_FEED=8 PLACEHOLDER_TYPE_NOT_ALLOWED_ON_CUSTOMER_FEED value
                         */
                        CustomerFeedErrorEnum.CustomerFeedError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE"] = 2;
                            values[valuesById[3] = "CANNOT_CREATE_FOR_REMOVED_FEED"] = 3;
                            values[valuesById[4] = "CANNOT_CREATE_ALREADY_EXISTING_CUSTOMER_FEED"] = 4;
                            values[valuesById[5] = "CANNOT_MODIFY_REMOVED_CUSTOMER_FEED"] = 5;
                            values[valuesById[6] = "INVALID_PLACEHOLDER_TYPE"] = 6;
                            values[valuesById[7] = "MISSING_FEEDMAPPING_FOR_PLACEHOLDER_TYPE"] = 7;
                            values[valuesById[8] = "PLACEHOLDER_TYPE_NOT_ALLOWED_ON_CUSTOMER_FEED"] = 8;
                            return values;
                        })();

                        return CustomerFeedErrorEnum;
                    })();

                    errors.CustomerManagerLinkErrorEnum = (function() {

                        /**
                         * Properties of a CustomerManagerLinkErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ICustomerManagerLinkErrorEnum
                         */

                        /**
                         * Constructs a new CustomerManagerLinkErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a CustomerManagerLinkErrorEnum.
                         * @implements ICustomerManagerLinkErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ICustomerManagerLinkErrorEnum=} [properties] Properties to set
                         */
                        function CustomerManagerLinkErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CustomerManagerLinkErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICustomerManagerLinkErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum} CustomerManagerLinkErrorEnum instance
                         */
                        CustomerManagerLinkErrorEnum.create = function create(properties) {
                            return new CustomerManagerLinkErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified CustomerManagerLinkErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICustomerManagerLinkErrorEnum} message CustomerManagerLinkErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerManagerLinkErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerManagerLinkErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ICustomerManagerLinkErrorEnum} message CustomerManagerLinkErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerManagerLinkErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerManagerLinkErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum} CustomerManagerLinkErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerManagerLinkErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerManagerLinkErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum} CustomerManagerLinkErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerManagerLinkErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerManagerLinkErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerManagerLinkErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CustomerManagerLinkErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum} CustomerManagerLinkErrorEnum
                         */
                        CustomerManagerLinkErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum();
                        };

                        /**
                         * Creates a plain object from a CustomerManagerLinkErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum} message CustomerManagerLinkErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerManagerLinkErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CustomerManagerLinkErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerManagerLinkErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CustomerManagerLinkError enum.
                         * @name google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum.CustomerManagerLinkError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} NO_PENDING_INVITE=2 NO_PENDING_INVITE value
                         * @property {number} SAME_CLIENT_MORE_THAN_ONCE_PER_CALL=3 SAME_CLIENT_MORE_THAN_ONCE_PER_CALL value
                         * @property {number} MANAGER_HAS_MAX_NUMBER_OF_LINKED_ACCOUNTS=4 MANAGER_HAS_MAX_NUMBER_OF_LINKED_ACCOUNTS value
                         * @property {number} CANNOT_UNLINK_ACCOUNT_WITHOUT_ACTIVE_USER=5 CANNOT_UNLINK_ACCOUNT_WITHOUT_ACTIVE_USER value
                         * @property {number} CANNOT_REMOVE_LAST_CLIENT_ACCOUNT_OWNER=6 CANNOT_REMOVE_LAST_CLIENT_ACCOUNT_OWNER value
                         * @property {number} CANNOT_CHANGE_ROLE_BY_NON_ACCOUNT_OWNER=7 CANNOT_CHANGE_ROLE_BY_NON_ACCOUNT_OWNER value
                         * @property {number} CANNOT_CHANGE_ROLE_FOR_NON_ACTIVE_LINK_ACCOUNT=8 CANNOT_CHANGE_ROLE_FOR_NON_ACTIVE_LINK_ACCOUNT value
                         * @property {number} DUPLICATE_CHILD_FOUND=9 DUPLICATE_CHILD_FOUND value
                         */
                        CustomerManagerLinkErrorEnum.CustomerManagerLinkError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "NO_PENDING_INVITE"] = 2;
                            values[valuesById[3] = "SAME_CLIENT_MORE_THAN_ONCE_PER_CALL"] = 3;
                            values[valuesById[4] = "MANAGER_HAS_MAX_NUMBER_OF_LINKED_ACCOUNTS"] = 4;
                            values[valuesById[5] = "CANNOT_UNLINK_ACCOUNT_WITHOUT_ACTIVE_USER"] = 5;
                            values[valuesById[6] = "CANNOT_REMOVE_LAST_CLIENT_ACCOUNT_OWNER"] = 6;
                            values[valuesById[7] = "CANNOT_CHANGE_ROLE_BY_NON_ACCOUNT_OWNER"] = 7;
                            values[valuesById[8] = "CANNOT_CHANGE_ROLE_FOR_NON_ACTIVE_LINK_ACCOUNT"] = 8;
                            values[valuesById[9] = "DUPLICATE_CHILD_FOUND"] = 9;
                            return values;
                        })();

                        return CustomerManagerLinkErrorEnum;
                    })();

                    errors.DatabaseErrorEnum = (function() {

                        /**
                         * Properties of a DatabaseErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IDatabaseErrorEnum
                         */

                        /**
                         * Constructs a new DatabaseErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a DatabaseErrorEnum.
                         * @implements IDatabaseErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IDatabaseErrorEnum=} [properties] Properties to set
                         */
                        function DatabaseErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new DatabaseErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.DatabaseErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IDatabaseErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.DatabaseErrorEnum} DatabaseErrorEnum instance
                         */
                        DatabaseErrorEnum.create = function create(properties) {
                            return new DatabaseErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified DatabaseErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.DatabaseErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.DatabaseErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IDatabaseErrorEnum} message DatabaseErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DatabaseErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified DatabaseErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.DatabaseErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.DatabaseErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IDatabaseErrorEnum} message DatabaseErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DatabaseErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DatabaseErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.DatabaseErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.DatabaseErrorEnum} DatabaseErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DatabaseErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.DatabaseErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DatabaseErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.DatabaseErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.DatabaseErrorEnum} DatabaseErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DatabaseErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DatabaseErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.DatabaseErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DatabaseErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a DatabaseErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.DatabaseErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.DatabaseErrorEnum} DatabaseErrorEnum
                         */
                        DatabaseErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.DatabaseErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.DatabaseErrorEnum();
                        };

                        /**
                         * Creates a plain object from a DatabaseErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.DatabaseErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.DatabaseErrorEnum} message DatabaseErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DatabaseErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this DatabaseErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.DatabaseErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DatabaseErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * DatabaseError enum.
                         * @name google.ads.googleads.v1.errors.DatabaseErrorEnum.DatabaseError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CONCURRENT_MODIFICATION=2 CONCURRENT_MODIFICATION value
                         */
                        DatabaseErrorEnum.DatabaseError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CONCURRENT_MODIFICATION"] = 2;
                            return values;
                        })();

                        return DatabaseErrorEnum;
                    })();

                    errors.DateErrorEnum = (function() {

                        /**
                         * Properties of a DateErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IDateErrorEnum
                         */

                        /**
                         * Constructs a new DateErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a DateErrorEnum.
                         * @implements IDateErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IDateErrorEnum=} [properties] Properties to set
                         */
                        function DateErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new DateErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.DateErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IDateErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.DateErrorEnum} DateErrorEnum instance
                         */
                        DateErrorEnum.create = function create(properties) {
                            return new DateErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified DateErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.DateErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.DateErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IDateErrorEnum} message DateErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DateErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified DateErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.DateErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.DateErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IDateErrorEnum} message DateErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DateErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DateErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.DateErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.DateErrorEnum} DateErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DateErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.DateErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DateErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.DateErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.DateErrorEnum} DateErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DateErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DateErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.DateErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DateErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a DateErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.DateErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.DateErrorEnum} DateErrorEnum
                         */
                        DateErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.DateErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.DateErrorEnum();
                        };

                        /**
                         * Creates a plain object from a DateErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.DateErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.DateErrorEnum} message DateErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DateErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this DateErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.DateErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DateErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * DateError enum.
                         * @name google.ads.googleads.v1.errors.DateErrorEnum.DateError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} INVALID_FIELD_VALUES_IN_DATE=2 INVALID_FIELD_VALUES_IN_DATE value
                         * @property {number} INVALID_FIELD_VALUES_IN_DATE_TIME=3 INVALID_FIELD_VALUES_IN_DATE_TIME value
                         * @property {number} INVALID_STRING_DATE=4 INVALID_STRING_DATE value
                         * @property {number} INVALID_STRING_DATE_TIME_MICROS=6 INVALID_STRING_DATE_TIME_MICROS value
                         * @property {number} INVALID_STRING_DATE_TIME_SECONDS=11 INVALID_STRING_DATE_TIME_SECONDS value
                         * @property {number} INVALID_STRING_DATE_TIME_SECONDS_WITH_OFFSET=12 INVALID_STRING_DATE_TIME_SECONDS_WITH_OFFSET value
                         * @property {number} EARLIER_THAN_MINIMUM_DATE=7 EARLIER_THAN_MINIMUM_DATE value
                         * @property {number} LATER_THAN_MAXIMUM_DATE=8 LATER_THAN_MAXIMUM_DATE value
                         * @property {number} DATE_RANGE_MINIMUM_DATE_LATER_THAN_MAXIMUM_DATE=9 DATE_RANGE_MINIMUM_DATE_LATER_THAN_MAXIMUM_DATE value
                         * @property {number} DATE_RANGE_MINIMUM_AND_MAXIMUM_DATES_BOTH_NULL=10 DATE_RANGE_MINIMUM_AND_MAXIMUM_DATES_BOTH_NULL value
                         */
                        DateErrorEnum.DateError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "INVALID_FIELD_VALUES_IN_DATE"] = 2;
                            values[valuesById[3] = "INVALID_FIELD_VALUES_IN_DATE_TIME"] = 3;
                            values[valuesById[4] = "INVALID_STRING_DATE"] = 4;
                            values[valuesById[6] = "INVALID_STRING_DATE_TIME_MICROS"] = 6;
                            values[valuesById[11] = "INVALID_STRING_DATE_TIME_SECONDS"] = 11;
                            values[valuesById[12] = "INVALID_STRING_DATE_TIME_SECONDS_WITH_OFFSET"] = 12;
                            values[valuesById[7] = "EARLIER_THAN_MINIMUM_DATE"] = 7;
                            values[valuesById[8] = "LATER_THAN_MAXIMUM_DATE"] = 8;
                            values[valuesById[9] = "DATE_RANGE_MINIMUM_DATE_LATER_THAN_MAXIMUM_DATE"] = 9;
                            values[valuesById[10] = "DATE_RANGE_MINIMUM_AND_MAXIMUM_DATES_BOTH_NULL"] = 10;
                            return values;
                        })();

                        return DateErrorEnum;
                    })();

                    errors.DateRangeErrorEnum = (function() {

                        /**
                         * Properties of a DateRangeErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IDateRangeErrorEnum
                         */

                        /**
                         * Constructs a new DateRangeErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a DateRangeErrorEnum.
                         * @implements IDateRangeErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IDateRangeErrorEnum=} [properties] Properties to set
                         */
                        function DateRangeErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new DateRangeErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.DateRangeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IDateRangeErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.DateRangeErrorEnum} DateRangeErrorEnum instance
                         */
                        DateRangeErrorEnum.create = function create(properties) {
                            return new DateRangeErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified DateRangeErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.DateRangeErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.DateRangeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IDateRangeErrorEnum} message DateRangeErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DateRangeErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified DateRangeErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.DateRangeErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.DateRangeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IDateRangeErrorEnum} message DateRangeErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DateRangeErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DateRangeErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.DateRangeErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.DateRangeErrorEnum} DateRangeErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DateRangeErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.DateRangeErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DateRangeErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.DateRangeErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.DateRangeErrorEnum} DateRangeErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DateRangeErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DateRangeErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.DateRangeErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DateRangeErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a DateRangeErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.DateRangeErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.DateRangeErrorEnum} DateRangeErrorEnum
                         */
                        DateRangeErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.DateRangeErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.DateRangeErrorEnum();
                        };

                        /**
                         * Creates a plain object from a DateRangeErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.DateRangeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.DateRangeErrorEnum} message DateRangeErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DateRangeErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this DateRangeErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.DateRangeErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DateRangeErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * DateRangeError enum.
                         * @name google.ads.googleads.v1.errors.DateRangeErrorEnum.DateRangeError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} INVALID_DATE=2 INVALID_DATE value
                         * @property {number} START_DATE_AFTER_END_DATE=3 START_DATE_AFTER_END_DATE value
                         * @property {number} CANNOT_SET_DATE_TO_PAST=4 CANNOT_SET_DATE_TO_PAST value
                         * @property {number} AFTER_MAXIMUM_ALLOWABLE_DATE=5 AFTER_MAXIMUM_ALLOWABLE_DATE value
                         * @property {number} CANNOT_MODIFY_START_DATE_IF_ALREADY_STARTED=6 CANNOT_MODIFY_START_DATE_IF_ALREADY_STARTED value
                         */
                        DateRangeErrorEnum.DateRangeError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "INVALID_DATE"] = 2;
                            values[valuesById[3] = "START_DATE_AFTER_END_DATE"] = 3;
                            values[valuesById[4] = "CANNOT_SET_DATE_TO_PAST"] = 4;
                            values[valuesById[5] = "AFTER_MAXIMUM_ALLOWABLE_DATE"] = 5;
                            values[valuesById[6] = "CANNOT_MODIFY_START_DATE_IF_ALREADY_STARTED"] = 6;
                            return values;
                        })();

                        return DateRangeErrorEnum;
                    })();

                    errors.DistinctErrorEnum = (function() {

                        /**
                         * Properties of a DistinctErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IDistinctErrorEnum
                         */

                        /**
                         * Constructs a new DistinctErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a DistinctErrorEnum.
                         * @implements IDistinctErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IDistinctErrorEnum=} [properties] Properties to set
                         */
                        function DistinctErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new DistinctErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.DistinctErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IDistinctErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.DistinctErrorEnum} DistinctErrorEnum instance
                         */
                        DistinctErrorEnum.create = function create(properties) {
                            return new DistinctErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified DistinctErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.DistinctErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.DistinctErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IDistinctErrorEnum} message DistinctErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DistinctErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified DistinctErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.DistinctErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.DistinctErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IDistinctErrorEnum} message DistinctErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DistinctErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DistinctErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.DistinctErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.DistinctErrorEnum} DistinctErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DistinctErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.DistinctErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DistinctErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.DistinctErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.DistinctErrorEnum} DistinctErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DistinctErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DistinctErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.DistinctErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DistinctErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a DistinctErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.DistinctErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.DistinctErrorEnum} DistinctErrorEnum
                         */
                        DistinctErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.DistinctErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.DistinctErrorEnum();
                        };

                        /**
                         * Creates a plain object from a DistinctErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.DistinctErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.DistinctErrorEnum} message DistinctErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DistinctErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this DistinctErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.DistinctErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DistinctErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * DistinctError enum.
                         * @name google.ads.googleads.v1.errors.DistinctErrorEnum.DistinctError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} DUPLICATE_ELEMENT=2 DUPLICATE_ELEMENT value
                         * @property {number} DUPLICATE_TYPE=3 DUPLICATE_TYPE value
                         */
                        DistinctErrorEnum.DistinctError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "DUPLICATE_ELEMENT"] = 2;
                            values[valuesById[3] = "DUPLICATE_TYPE"] = 3;
                            return values;
                        })();

                        return DistinctErrorEnum;
                    })();

                    errors.EnumErrorEnum = (function() {

                        /**
                         * Properties of an EnumErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IEnumErrorEnum
                         */

                        /**
                         * Constructs a new EnumErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an EnumErrorEnum.
                         * @implements IEnumErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IEnumErrorEnum=} [properties] Properties to set
                         */
                        function EnumErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new EnumErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.EnumErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IEnumErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.EnumErrorEnum} EnumErrorEnum instance
                         */
                        EnumErrorEnum.create = function create(properties) {
                            return new EnumErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified EnumErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.EnumErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.EnumErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IEnumErrorEnum} message EnumErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        EnumErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified EnumErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.EnumErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.EnumErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IEnumErrorEnum} message EnumErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        EnumErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an EnumErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.EnumErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.EnumErrorEnum} EnumErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        EnumErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.EnumErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an EnumErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.EnumErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.EnumErrorEnum} EnumErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        EnumErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an EnumErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.EnumErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        EnumErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an EnumErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.EnumErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.EnumErrorEnum} EnumErrorEnum
                         */
                        EnumErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.EnumErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.EnumErrorEnum();
                        };

                        /**
                         * Creates a plain object from an EnumErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.EnumErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.EnumErrorEnum} message EnumErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        EnumErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this EnumErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.EnumErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        EnumErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * EnumError enum.
                         * @name google.ads.googleads.v1.errors.EnumErrorEnum.EnumError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENUM_VALUE_NOT_PERMITTED=3 ENUM_VALUE_NOT_PERMITTED value
                         */
                        EnumErrorEnum.EnumError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[3] = "ENUM_VALUE_NOT_PERMITTED"] = 3;
                            return values;
                        })();

                        return EnumErrorEnum;
                    })();

                    errors.GoogleAdsFailure = (function() {

                        /**
                         * Properties of a GoogleAdsFailure.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IGoogleAdsFailure
                         * @property {Array.<google.ads.googleads.v1.errors.IGoogleAdsError>|null} [errors] GoogleAdsFailure errors
                         */

                        /**
                         * Constructs a new GoogleAdsFailure.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a GoogleAdsFailure.
                         * @implements IGoogleAdsFailure
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IGoogleAdsFailure=} [properties] Properties to set
                         */
                        function GoogleAdsFailure(properties) {
                            this.errors = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GoogleAdsFailure errors.
                         * @member {Array.<google.ads.googleads.v1.errors.IGoogleAdsError>} errors
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsFailure
                         * @instance
                         */
                        GoogleAdsFailure.prototype.errors = $util.emptyArray;

                        /**
                         * Creates a new GoogleAdsFailure instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsFailure
                         * @static
                         * @param {google.ads.googleads.v1.errors.IGoogleAdsFailure=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.GoogleAdsFailure} GoogleAdsFailure instance
                         */
                        GoogleAdsFailure.create = function create(properties) {
                            return new GoogleAdsFailure(properties);
                        };

                        /**
                         * Encodes the specified GoogleAdsFailure message. Does not implicitly {@link google.ads.googleads.v1.errors.GoogleAdsFailure.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsFailure
                         * @static
                         * @param {google.ads.googleads.v1.errors.IGoogleAdsFailure} message GoogleAdsFailure message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GoogleAdsFailure.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.errors != null && message.errors.length)
                                for (var i = 0; i < message.errors.length; ++i)
                                    $root.google.ads.googleads.v1.errors.GoogleAdsError.encode(message.errors[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified GoogleAdsFailure message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.GoogleAdsFailure.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsFailure
                         * @static
                         * @param {google.ads.googleads.v1.errors.IGoogleAdsFailure} message GoogleAdsFailure message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GoogleAdsFailure.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GoogleAdsFailure message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsFailure
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.GoogleAdsFailure} GoogleAdsFailure
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GoogleAdsFailure.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.GoogleAdsFailure();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.errors && message.errors.length))
                                        message.errors = [];
                                    message.errors.push($root.google.ads.googleads.v1.errors.GoogleAdsError.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GoogleAdsFailure message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsFailure
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.GoogleAdsFailure} GoogleAdsFailure
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GoogleAdsFailure.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GoogleAdsFailure message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsFailure
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GoogleAdsFailure.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.errors != null && message.hasOwnProperty("errors")) {
                                if (!Array.isArray(message.errors))
                                    return "errors: array expected";
                                for (var i = 0; i < message.errors.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.errors.GoogleAdsError.verify(message.errors[i]);
                                    if (error)
                                        return "errors." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a GoogleAdsFailure message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsFailure
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.GoogleAdsFailure} GoogleAdsFailure
                         */
                        GoogleAdsFailure.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.GoogleAdsFailure)
                                return object;
                            var message = new $root.google.ads.googleads.v1.errors.GoogleAdsFailure();
                            if (object.errors) {
                                if (!Array.isArray(object.errors))
                                    throw TypeError(".google.ads.googleads.v1.errors.GoogleAdsFailure.errors: array expected");
                                message.errors = [];
                                for (var i = 0; i < object.errors.length; ++i) {
                                    if (typeof object.errors[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.errors.GoogleAdsFailure.errors: object expected");
                                    message.errors[i] = $root.google.ads.googleads.v1.errors.GoogleAdsError.fromObject(object.errors[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a GoogleAdsFailure message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsFailure
                         * @static
                         * @param {google.ads.googleads.v1.errors.GoogleAdsFailure} message GoogleAdsFailure
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GoogleAdsFailure.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.errors = [];
                            if (message.errors && message.errors.length) {
                                object.errors = [];
                                for (var j = 0; j < message.errors.length; ++j)
                                    object.errors[j] = $root.google.ads.googleads.v1.errors.GoogleAdsError.toObject(message.errors[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this GoogleAdsFailure to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsFailure
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GoogleAdsFailure.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GoogleAdsFailure;
                    })();

                    errors.GoogleAdsError = (function() {

                        /**
                         * Properties of a GoogleAdsError.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IGoogleAdsError
                         * @property {google.ads.googleads.v1.errors.IErrorCode|null} [errorCode] GoogleAdsError errorCode
                         * @property {string|null} [message] GoogleAdsError message
                         * @property {google.ads.googleads.v1.common.IValue|null} [trigger] GoogleAdsError trigger
                         * @property {google.ads.googleads.v1.errors.IErrorLocation|null} [location] GoogleAdsError location
                         * @property {google.ads.googleads.v1.errors.IErrorDetails|null} [details] GoogleAdsError details
                         */

                        /**
                         * Constructs a new GoogleAdsError.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a GoogleAdsError.
                         * @implements IGoogleAdsError
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IGoogleAdsError=} [properties] Properties to set
                         */
                        function GoogleAdsError(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GoogleAdsError errorCode.
                         * @member {google.ads.googleads.v1.errors.IErrorCode|null|undefined} errorCode
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsError
                         * @instance
                         */
                        GoogleAdsError.prototype.errorCode = null;

                        /**
                         * GoogleAdsError message.
                         * @member {string} message
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsError
                         * @instance
                         */
                        GoogleAdsError.prototype.message = "";

                        /**
                         * GoogleAdsError trigger.
                         * @member {google.ads.googleads.v1.common.IValue|null|undefined} trigger
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsError
                         * @instance
                         */
                        GoogleAdsError.prototype.trigger = null;

                        /**
                         * GoogleAdsError location.
                         * @member {google.ads.googleads.v1.errors.IErrorLocation|null|undefined} location
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsError
                         * @instance
                         */
                        GoogleAdsError.prototype.location = null;

                        /**
                         * GoogleAdsError details.
                         * @member {google.ads.googleads.v1.errors.IErrorDetails|null|undefined} details
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsError
                         * @instance
                         */
                        GoogleAdsError.prototype.details = null;

                        /**
                         * Creates a new GoogleAdsError instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsError
                         * @static
                         * @param {google.ads.googleads.v1.errors.IGoogleAdsError=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.GoogleAdsError} GoogleAdsError instance
                         */
                        GoogleAdsError.create = function create(properties) {
                            return new GoogleAdsError(properties);
                        };

                        /**
                         * Encodes the specified GoogleAdsError message. Does not implicitly {@link google.ads.googleads.v1.errors.GoogleAdsError.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsError
                         * @static
                         * @param {google.ads.googleads.v1.errors.IGoogleAdsError} message GoogleAdsError message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GoogleAdsError.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.errorCode != null && message.hasOwnProperty("errorCode"))
                                $root.google.ads.googleads.v1.errors.ErrorCode.encode(message.errorCode, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.message != null && message.hasOwnProperty("message"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.message);
                            if (message.trigger != null && message.hasOwnProperty("trigger"))
                                $root.google.ads.googleads.v1.common.Value.encode(message.trigger, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.location != null && message.hasOwnProperty("location"))
                                $root.google.ads.googleads.v1.errors.ErrorLocation.encode(message.location, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.details != null && message.hasOwnProperty("details"))
                                $root.google.ads.googleads.v1.errors.ErrorDetails.encode(message.details, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified GoogleAdsError message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.GoogleAdsError.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsError
                         * @static
                         * @param {google.ads.googleads.v1.errors.IGoogleAdsError} message GoogleAdsError message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GoogleAdsError.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GoogleAdsError message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsError
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.GoogleAdsError} GoogleAdsError
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GoogleAdsError.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.GoogleAdsError();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.errorCode = $root.google.ads.googleads.v1.errors.ErrorCode.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.message = reader.string();
                                    break;
                                case 3:
                                    message.trigger = $root.google.ads.googleads.v1.common.Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.location = $root.google.ads.googleads.v1.errors.ErrorLocation.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.details = $root.google.ads.googleads.v1.errors.ErrorDetails.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GoogleAdsError message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsError
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.GoogleAdsError} GoogleAdsError
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GoogleAdsError.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GoogleAdsError message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsError
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GoogleAdsError.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.errorCode != null && message.hasOwnProperty("errorCode")) {
                                var error = $root.google.ads.googleads.v1.errors.ErrorCode.verify(message.errorCode);
                                if (error)
                                    return "errorCode." + error;
                            }
                            if (message.message != null && message.hasOwnProperty("message"))
                                if (!$util.isString(message.message))
                                    return "message: string expected";
                            if (message.trigger != null && message.hasOwnProperty("trigger")) {
                                var error = $root.google.ads.googleads.v1.common.Value.verify(message.trigger);
                                if (error)
                                    return "trigger." + error;
                            }
                            if (message.location != null && message.hasOwnProperty("location")) {
                                var error = $root.google.ads.googleads.v1.errors.ErrorLocation.verify(message.location);
                                if (error)
                                    return "location." + error;
                            }
                            if (message.details != null && message.hasOwnProperty("details")) {
                                var error = $root.google.ads.googleads.v1.errors.ErrorDetails.verify(message.details);
                                if (error)
                                    return "details." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a GoogleAdsError message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsError
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.GoogleAdsError} GoogleAdsError
                         */
                        GoogleAdsError.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.GoogleAdsError)
                                return object;
                            var message = new $root.google.ads.googleads.v1.errors.GoogleAdsError();
                            if (object.errorCode != null) {
                                if (typeof object.errorCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.errors.GoogleAdsError.errorCode: object expected");
                                message.errorCode = $root.google.ads.googleads.v1.errors.ErrorCode.fromObject(object.errorCode);
                            }
                            if (object.message != null)
                                message.message = String(object.message);
                            if (object.trigger != null) {
                                if (typeof object.trigger !== "object")
                                    throw TypeError(".google.ads.googleads.v1.errors.GoogleAdsError.trigger: object expected");
                                message.trigger = $root.google.ads.googleads.v1.common.Value.fromObject(object.trigger);
                            }
                            if (object.location != null) {
                                if (typeof object.location !== "object")
                                    throw TypeError(".google.ads.googleads.v1.errors.GoogleAdsError.location: object expected");
                                message.location = $root.google.ads.googleads.v1.errors.ErrorLocation.fromObject(object.location);
                            }
                            if (object.details != null) {
                                if (typeof object.details !== "object")
                                    throw TypeError(".google.ads.googleads.v1.errors.GoogleAdsError.details: object expected");
                                message.details = $root.google.ads.googleads.v1.errors.ErrorDetails.fromObject(object.details);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a GoogleAdsError message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsError
                         * @static
                         * @param {google.ads.googleads.v1.errors.GoogleAdsError} message GoogleAdsError
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GoogleAdsError.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.errorCode = null;
                                object.message = "";
                                object.trigger = null;
                                object.location = null;
                                object.details = null;
                            }
                            if (message.errorCode != null && message.hasOwnProperty("errorCode"))
                                object.errorCode = $root.google.ads.googleads.v1.errors.ErrorCode.toObject(message.errorCode, options);
                            if (message.message != null && message.hasOwnProperty("message"))
                                object.message = message.message;
                            if (message.trigger != null && message.hasOwnProperty("trigger"))
                                object.trigger = $root.google.ads.googleads.v1.common.Value.toObject(message.trigger, options);
                            if (message.location != null && message.hasOwnProperty("location"))
                                object.location = $root.google.ads.googleads.v1.errors.ErrorLocation.toObject(message.location, options);
                            if (message.details != null && message.hasOwnProperty("details"))
                                object.details = $root.google.ads.googleads.v1.errors.ErrorDetails.toObject(message.details, options);
                            return object;
                        };

                        /**
                         * Converts this GoogleAdsError to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.GoogleAdsError
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GoogleAdsError.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GoogleAdsError;
                    })();

                    errors.ErrorCode = (function() {

                        /**
                         * Properties of an ErrorCode.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IErrorCode
                         * @property {google.ads.googleads.v1.errors.RequestErrorEnum.RequestError|null} [requestError] ErrorCode requestError
                         * @property {google.ads.googleads.v1.errors.BiddingStrategyErrorEnum.BiddingStrategyError|null} [biddingStrategyError] ErrorCode biddingStrategyError
                         * @property {google.ads.googleads.v1.errors.UrlFieldErrorEnum.UrlFieldError|null} [urlFieldError] ErrorCode urlFieldError
                         * @property {google.ads.googleads.v1.errors.ListOperationErrorEnum.ListOperationError|null} [listOperationError] ErrorCode listOperationError
                         * @property {google.ads.googleads.v1.errors.QueryErrorEnum.QueryError|null} [queryError] ErrorCode queryError
                         * @property {google.ads.googleads.v1.errors.MutateErrorEnum.MutateError|null} [mutateError] ErrorCode mutateError
                         * @property {google.ads.googleads.v1.errors.FieldMaskErrorEnum.FieldMaskError|null} [fieldMaskError] ErrorCode fieldMaskError
                         * @property {google.ads.googleads.v1.errors.AuthorizationErrorEnum.AuthorizationError|null} [authorizationError] ErrorCode authorizationError
                         * @property {google.ads.googleads.v1.errors.InternalErrorEnum.InternalError|null} [internalError] ErrorCode internalError
                         * @property {google.ads.googleads.v1.errors.QuotaErrorEnum.QuotaError|null} [quotaError] ErrorCode quotaError
                         * @property {google.ads.googleads.v1.errors.AdErrorEnum.AdError|null} [adError] ErrorCode adError
                         * @property {google.ads.googleads.v1.errors.AdGroupErrorEnum.AdGroupError|null} [adGroupError] ErrorCode adGroupError
                         * @property {google.ads.googleads.v1.errors.CampaignBudgetErrorEnum.CampaignBudgetError|null} [campaignBudgetError] ErrorCode campaignBudgetError
                         * @property {google.ads.googleads.v1.errors.CampaignErrorEnum.CampaignError|null} [campaignError] ErrorCode campaignError
                         * @property {google.ads.googleads.v1.errors.AuthenticationErrorEnum.AuthenticationError|null} [authenticationError] ErrorCode authenticationError
                         * @property {google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum.AdGroupCriterionError|null} [adGroupCriterionError] ErrorCode adGroupCriterionError
                         * @property {google.ads.googleads.v1.errors.AdCustomizerErrorEnum.AdCustomizerError|null} [adCustomizerError] ErrorCode adCustomizerError
                         * @property {google.ads.googleads.v1.errors.AdGroupAdErrorEnum.AdGroupAdError|null} [adGroupAdError] ErrorCode adGroupAdError
                         * @property {google.ads.googleads.v1.errors.AdSharingErrorEnum.AdSharingError|null} [adSharingError] ErrorCode adSharingError
                         * @property {google.ads.googleads.v1.errors.AdxErrorEnum.AdxError|null} [adxError] ErrorCode adxError
                         * @property {google.ads.googleads.v1.errors.AssetErrorEnum.AssetError|null} [assetError] ErrorCode assetError
                         * @property {google.ads.googleads.v1.errors.BiddingErrorEnum.BiddingError|null} [biddingError] ErrorCode biddingError
                         * @property {google.ads.googleads.v1.errors.CampaignCriterionErrorEnum.CampaignCriterionError|null} [campaignCriterionError] ErrorCode campaignCriterionError
                         * @property {google.ads.googleads.v1.errors.CollectionSizeErrorEnum.CollectionSizeError|null} [collectionSizeError] ErrorCode collectionSizeError
                         * @property {google.ads.googleads.v1.errors.CountryCodeErrorEnum.CountryCodeError|null} [countryCodeError] ErrorCode countryCodeError
                         * @property {google.ads.googleads.v1.errors.CriterionErrorEnum.CriterionError|null} [criterionError] ErrorCode criterionError
                         * @property {google.ads.googleads.v1.errors.CustomerErrorEnum.CustomerError|null} [customerError] ErrorCode customerError
                         * @property {google.ads.googleads.v1.errors.DateErrorEnum.DateError|null} [dateError] ErrorCode dateError
                         * @property {google.ads.googleads.v1.errors.DateRangeErrorEnum.DateRangeError|null} [dateRangeError] ErrorCode dateRangeError
                         * @property {google.ads.googleads.v1.errors.DistinctErrorEnum.DistinctError|null} [distinctError] ErrorCode distinctError
                         * @property {google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum.FeedAttributeReferenceError|null} [feedAttributeReferenceError] ErrorCode feedAttributeReferenceError
                         * @property {google.ads.googleads.v1.errors.FunctionErrorEnum.FunctionError|null} [functionError] ErrorCode functionError
                         * @property {google.ads.googleads.v1.errors.FunctionParsingErrorEnum.FunctionParsingError|null} [functionParsingError] ErrorCode functionParsingError
                         * @property {google.ads.googleads.v1.errors.IdErrorEnum.IdError|null} [idError] ErrorCode idError
                         * @property {google.ads.googleads.v1.errors.ImageErrorEnum.ImageError|null} [imageError] ErrorCode imageError
                         * @property {google.ads.googleads.v1.errors.LanguageCodeErrorEnum.LanguageCodeError|null} [languageCodeError] ErrorCode languageCodeError
                         * @property {google.ads.googleads.v1.errors.MediaBundleErrorEnum.MediaBundleError|null} [mediaBundleError] ErrorCode mediaBundleError
                         * @property {google.ads.googleads.v1.errors.MediaUploadErrorEnum.MediaUploadError|null} [mediaUploadError] ErrorCode mediaUploadError
                         * @property {google.ads.googleads.v1.errors.MediaFileErrorEnum.MediaFileError|null} [mediaFileError] ErrorCode mediaFileError
                         * @property {google.ads.googleads.v1.errors.MultiplierErrorEnum.MultiplierError|null} [multiplierError] ErrorCode multiplierError
                         * @property {google.ads.googleads.v1.errors.NewResourceCreationErrorEnum.NewResourceCreationError|null} [newResourceCreationError] ErrorCode newResourceCreationError
                         * @property {google.ads.googleads.v1.errors.NotEmptyErrorEnum.NotEmptyError|null} [notEmptyError] ErrorCode notEmptyError
                         * @property {google.ads.googleads.v1.errors.NullErrorEnum.NullError|null} [nullError] ErrorCode nullError
                         * @property {google.ads.googleads.v1.errors.OperatorErrorEnum.OperatorError|null} [operatorError] ErrorCode operatorError
                         * @property {google.ads.googleads.v1.errors.RangeErrorEnum.RangeError|null} [rangeError] ErrorCode rangeError
                         * @property {google.ads.googleads.v1.errors.RecommendationErrorEnum.RecommendationError|null} [recommendationError] ErrorCode recommendationError
                         * @property {google.ads.googleads.v1.errors.RegionCodeErrorEnum.RegionCodeError|null} [regionCodeError] ErrorCode regionCodeError
                         * @property {google.ads.googleads.v1.errors.SettingErrorEnum.SettingError|null} [settingError] ErrorCode settingError
                         * @property {google.ads.googleads.v1.errors.StringFormatErrorEnum.StringFormatError|null} [stringFormatError] ErrorCode stringFormatError
                         * @property {google.ads.googleads.v1.errors.StringLengthErrorEnum.StringLengthError|null} [stringLengthError] ErrorCode stringLengthError
                         * @property {google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum.OperationAccessDeniedError|null} [operationAccessDeniedError] ErrorCode operationAccessDeniedError
                         * @property {google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum.ResourceAccessDeniedError|null} [resourceAccessDeniedError] ErrorCode resourceAccessDeniedError
                         * @property {google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum.ResourceCountLimitExceededError|null} [resourceCountLimitExceededError] ErrorCode resourceCountLimitExceededError
                         * @property {google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum.YoutubeVideoRegistrationError|null} [youtubeVideoRegistrationError] ErrorCode youtubeVideoRegistrationError
                         * @property {google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum.AdGroupBidModifierError|null} [adGroupBidModifierError] ErrorCode adGroupBidModifierError
                         * @property {google.ads.googleads.v1.errors.ContextErrorEnum.ContextError|null} [contextError] ErrorCode contextError
                         * @property {google.ads.googleads.v1.errors.FieldErrorEnum.FieldError|null} [fieldError] ErrorCode fieldError
                         * @property {google.ads.googleads.v1.errors.SharedSetErrorEnum.SharedSetError|null} [sharedSetError] ErrorCode sharedSetError
                         * @property {google.ads.googleads.v1.errors.SharedCriterionErrorEnum.SharedCriterionError|null} [sharedCriterionError] ErrorCode sharedCriterionError
                         * @property {google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum.CampaignSharedSetError|null} [campaignSharedSetError] ErrorCode campaignSharedSetError
                         * @property {google.ads.googleads.v1.errors.ConversionActionErrorEnum.ConversionActionError|null} [conversionActionError] ErrorCode conversionActionError
                         * @property {google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum.ConversionAdjustmentUploadError|null} [conversionAdjustmentUploadError] ErrorCode conversionAdjustmentUploadError
                         * @property {google.ads.googleads.v1.errors.ConversionUploadErrorEnum.ConversionUploadError|null} [conversionUploadError] ErrorCode conversionUploadError
                         * @property {google.ads.googleads.v1.errors.HeaderErrorEnum.HeaderError|null} [headerError] ErrorCode headerError
                         * @property {google.ads.googleads.v1.errors.DatabaseErrorEnum.DatabaseError|null} [databaseError] ErrorCode databaseError
                         * @property {google.ads.googleads.v1.errors.PolicyFindingErrorEnum.PolicyFindingError|null} [policyFindingError] ErrorCode policyFindingError
                         * @property {google.ads.googleads.v1.errors.EnumErrorEnum.EnumError|null} [enumError] ErrorCode enumError
                         * @property {google.ads.googleads.v1.errors.KeywordPlanErrorEnum.KeywordPlanError|null} [keywordPlanError] ErrorCode keywordPlanError
                         * @property {google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum.KeywordPlanCampaignError|null} [keywordPlanCampaignError] ErrorCode keywordPlanCampaignError
                         * @property {google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum.KeywordPlanNegativeKeywordError|null} [keywordPlanNegativeKeywordError] ErrorCode keywordPlanNegativeKeywordError
                         * @property {google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum.KeywordPlanAdGroupError|null} [keywordPlanAdGroupError] ErrorCode keywordPlanAdGroupError
                         * @property {google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum.KeywordPlanKeywordError|null} [keywordPlanKeywordError] ErrorCode keywordPlanKeywordError
                         * @property {google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum.KeywordPlanIdeaError|null} [keywordPlanIdeaError] ErrorCode keywordPlanIdeaError
                         * @property {google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum.AccountBudgetProposalError|null} [accountBudgetProposalError] ErrorCode accountBudgetProposalError
                         * @property {google.ads.googleads.v1.errors.UserListErrorEnum.UserListError|null} [userListError] ErrorCode userListError
                         * @property {google.ads.googleads.v1.errors.ChangeStatusErrorEnum.ChangeStatusError|null} [changeStatusError] ErrorCode changeStatusError
                         * @property {google.ads.googleads.v1.errors.FeedErrorEnum.FeedError|null} [feedError] ErrorCode feedError
                         * @property {google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum.GeoTargetConstantSuggestionError|null} [geoTargetConstantSuggestionError] ErrorCode geoTargetConstantSuggestionError
                         * @property {google.ads.googleads.v1.errors.FeedItemErrorEnum.FeedItemError|null} [feedItemError] ErrorCode feedItemError
                         * @property {google.ads.googleads.v1.errors.LabelErrorEnum.LabelError|null} [labelError] ErrorCode labelError
                         * @property {google.ads.googleads.v1.errors.BillingSetupErrorEnum.BillingSetupError|null} [billingSetupError] ErrorCode billingSetupError
                         * @property {google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum.CustomerClientLinkError|null} [customerClientLinkError] ErrorCode customerClientLinkError
                         * @property {google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum.CustomerManagerLinkError|null} [customerManagerLinkError] ErrorCode customerManagerLinkError
                         * @property {google.ads.googleads.v1.errors.FeedMappingErrorEnum.FeedMappingError|null} [feedMappingError] ErrorCode feedMappingError
                         * @property {google.ads.googleads.v1.errors.CustomerFeedErrorEnum.CustomerFeedError|null} [customerFeedError] ErrorCode customerFeedError
                         * @property {google.ads.googleads.v1.errors.AdGroupFeedErrorEnum.AdGroupFeedError|null} [adGroupFeedError] ErrorCode adGroupFeedError
                         * @property {google.ads.googleads.v1.errors.CampaignFeedErrorEnum.CampaignFeedError|null} [campaignFeedError] ErrorCode campaignFeedError
                         * @property {google.ads.googleads.v1.errors.CustomInterestErrorEnum.CustomInterestError|null} [customInterestError] ErrorCode customInterestError
                         * @property {google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum.ExtensionFeedItemError|null} [extensionFeedItemError] ErrorCode extensionFeedItemError
                         * @property {google.ads.googleads.v1.errors.AdParameterErrorEnum.AdParameterError|null} [adParameterError] ErrorCode adParameterError
                         * @property {google.ads.googleads.v1.errors.FeedItemValidationErrorEnum.FeedItemValidationError|null} [feedItemValidationError] ErrorCode feedItemValidationError
                         * @property {google.ads.googleads.v1.errors.ExtensionSettingErrorEnum.ExtensionSettingError|null} [extensionSettingError] ErrorCode extensionSettingError
                         * @property {google.ads.googleads.v1.errors.FeedItemTargetErrorEnum.FeedItemTargetError|null} [feedItemTargetError] ErrorCode feedItemTargetError
                         * @property {google.ads.googleads.v1.errors.PolicyViolationErrorEnum.PolicyViolationError|null} [policyViolationError] ErrorCode policyViolationError
                         * @property {google.ads.googleads.v1.errors.MutateJobErrorEnum.MutateJobError|null} [mutateJobError] ErrorCode mutateJobError
                         * @property {google.ads.googleads.v1.errors.PartialFailureErrorEnum.PartialFailureError|null} [partialFailureError] ErrorCode partialFailureError
                         * @property {google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum.PolicyValidationParameterError|null} [policyValidationParameterError] ErrorCode policyValidationParameterError
                         * @property {google.ads.googleads.v1.errors.SizeLimitErrorEnum.SizeLimitError|null} [sizeLimitError] ErrorCode sizeLimitError
                         */

                        /**
                         * Constructs a new ErrorCode.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an ErrorCode.
                         * @implements IErrorCode
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IErrorCode=} [properties] Properties to set
                         */
                        function ErrorCode(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ErrorCode requestError.
                         * @member {google.ads.googleads.v1.errors.RequestErrorEnum.RequestError} requestError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.requestError = 0;

                        /**
                         * ErrorCode biddingStrategyError.
                         * @member {google.ads.googleads.v1.errors.BiddingStrategyErrorEnum.BiddingStrategyError} biddingStrategyError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.biddingStrategyError = 0;

                        /**
                         * ErrorCode urlFieldError.
                         * @member {google.ads.googleads.v1.errors.UrlFieldErrorEnum.UrlFieldError} urlFieldError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.urlFieldError = 0;

                        /**
                         * ErrorCode listOperationError.
                         * @member {google.ads.googleads.v1.errors.ListOperationErrorEnum.ListOperationError} listOperationError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.listOperationError = 0;

                        /**
                         * ErrorCode queryError.
                         * @member {google.ads.googleads.v1.errors.QueryErrorEnum.QueryError} queryError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.queryError = 0;

                        /**
                         * ErrorCode mutateError.
                         * @member {google.ads.googleads.v1.errors.MutateErrorEnum.MutateError} mutateError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.mutateError = 0;

                        /**
                         * ErrorCode fieldMaskError.
                         * @member {google.ads.googleads.v1.errors.FieldMaskErrorEnum.FieldMaskError} fieldMaskError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.fieldMaskError = 0;

                        /**
                         * ErrorCode authorizationError.
                         * @member {google.ads.googleads.v1.errors.AuthorizationErrorEnum.AuthorizationError} authorizationError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.authorizationError = 0;

                        /**
                         * ErrorCode internalError.
                         * @member {google.ads.googleads.v1.errors.InternalErrorEnum.InternalError} internalError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.internalError = 0;

                        /**
                         * ErrorCode quotaError.
                         * @member {google.ads.googleads.v1.errors.QuotaErrorEnum.QuotaError} quotaError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.quotaError = 0;

                        /**
                         * ErrorCode adError.
                         * @member {google.ads.googleads.v1.errors.AdErrorEnum.AdError} adError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.adError = 0;

                        /**
                         * ErrorCode adGroupError.
                         * @member {google.ads.googleads.v1.errors.AdGroupErrorEnum.AdGroupError} adGroupError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.adGroupError = 0;

                        /**
                         * ErrorCode campaignBudgetError.
                         * @member {google.ads.googleads.v1.errors.CampaignBudgetErrorEnum.CampaignBudgetError} campaignBudgetError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.campaignBudgetError = 0;

                        /**
                         * ErrorCode campaignError.
                         * @member {google.ads.googleads.v1.errors.CampaignErrorEnum.CampaignError} campaignError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.campaignError = 0;

                        /**
                         * ErrorCode authenticationError.
                         * @member {google.ads.googleads.v1.errors.AuthenticationErrorEnum.AuthenticationError} authenticationError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.authenticationError = 0;

                        /**
                         * ErrorCode adGroupCriterionError.
                         * @member {google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum.AdGroupCriterionError} adGroupCriterionError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.adGroupCriterionError = 0;

                        /**
                         * ErrorCode adCustomizerError.
                         * @member {google.ads.googleads.v1.errors.AdCustomizerErrorEnum.AdCustomizerError} adCustomizerError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.adCustomizerError = 0;

                        /**
                         * ErrorCode adGroupAdError.
                         * @member {google.ads.googleads.v1.errors.AdGroupAdErrorEnum.AdGroupAdError} adGroupAdError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.adGroupAdError = 0;

                        /**
                         * ErrorCode adSharingError.
                         * @member {google.ads.googleads.v1.errors.AdSharingErrorEnum.AdSharingError} adSharingError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.adSharingError = 0;

                        /**
                         * ErrorCode adxError.
                         * @member {google.ads.googleads.v1.errors.AdxErrorEnum.AdxError} adxError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.adxError = 0;

                        /**
                         * ErrorCode assetError.
                         * @member {google.ads.googleads.v1.errors.AssetErrorEnum.AssetError} assetError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.assetError = 0;

                        /**
                         * ErrorCode biddingError.
                         * @member {google.ads.googleads.v1.errors.BiddingErrorEnum.BiddingError} biddingError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.biddingError = 0;

                        /**
                         * ErrorCode campaignCriterionError.
                         * @member {google.ads.googleads.v1.errors.CampaignCriterionErrorEnum.CampaignCriterionError} campaignCriterionError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.campaignCriterionError = 0;

                        /**
                         * ErrorCode collectionSizeError.
                         * @member {google.ads.googleads.v1.errors.CollectionSizeErrorEnum.CollectionSizeError} collectionSizeError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.collectionSizeError = 0;

                        /**
                         * ErrorCode countryCodeError.
                         * @member {google.ads.googleads.v1.errors.CountryCodeErrorEnum.CountryCodeError} countryCodeError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.countryCodeError = 0;

                        /**
                         * ErrorCode criterionError.
                         * @member {google.ads.googleads.v1.errors.CriterionErrorEnum.CriterionError} criterionError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.criterionError = 0;

                        /**
                         * ErrorCode customerError.
                         * @member {google.ads.googleads.v1.errors.CustomerErrorEnum.CustomerError} customerError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.customerError = 0;

                        /**
                         * ErrorCode dateError.
                         * @member {google.ads.googleads.v1.errors.DateErrorEnum.DateError} dateError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.dateError = 0;

                        /**
                         * ErrorCode dateRangeError.
                         * @member {google.ads.googleads.v1.errors.DateRangeErrorEnum.DateRangeError} dateRangeError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.dateRangeError = 0;

                        /**
                         * ErrorCode distinctError.
                         * @member {google.ads.googleads.v1.errors.DistinctErrorEnum.DistinctError} distinctError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.distinctError = 0;

                        /**
                         * ErrorCode feedAttributeReferenceError.
                         * @member {google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum.FeedAttributeReferenceError} feedAttributeReferenceError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.feedAttributeReferenceError = 0;

                        /**
                         * ErrorCode functionError.
                         * @member {google.ads.googleads.v1.errors.FunctionErrorEnum.FunctionError} functionError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.functionError = 0;

                        /**
                         * ErrorCode functionParsingError.
                         * @member {google.ads.googleads.v1.errors.FunctionParsingErrorEnum.FunctionParsingError} functionParsingError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.functionParsingError = 0;

                        /**
                         * ErrorCode idError.
                         * @member {google.ads.googleads.v1.errors.IdErrorEnum.IdError} idError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.idError = 0;

                        /**
                         * ErrorCode imageError.
                         * @member {google.ads.googleads.v1.errors.ImageErrorEnum.ImageError} imageError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.imageError = 0;

                        /**
                         * ErrorCode languageCodeError.
                         * @member {google.ads.googleads.v1.errors.LanguageCodeErrorEnum.LanguageCodeError} languageCodeError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.languageCodeError = 0;

                        /**
                         * ErrorCode mediaBundleError.
                         * @member {google.ads.googleads.v1.errors.MediaBundleErrorEnum.MediaBundleError} mediaBundleError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.mediaBundleError = 0;

                        /**
                         * ErrorCode mediaUploadError.
                         * @member {google.ads.googleads.v1.errors.MediaUploadErrorEnum.MediaUploadError} mediaUploadError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.mediaUploadError = 0;

                        /**
                         * ErrorCode mediaFileError.
                         * @member {google.ads.googleads.v1.errors.MediaFileErrorEnum.MediaFileError} mediaFileError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.mediaFileError = 0;

                        /**
                         * ErrorCode multiplierError.
                         * @member {google.ads.googleads.v1.errors.MultiplierErrorEnum.MultiplierError} multiplierError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.multiplierError = 0;

                        /**
                         * ErrorCode newResourceCreationError.
                         * @member {google.ads.googleads.v1.errors.NewResourceCreationErrorEnum.NewResourceCreationError} newResourceCreationError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.newResourceCreationError = 0;

                        /**
                         * ErrorCode notEmptyError.
                         * @member {google.ads.googleads.v1.errors.NotEmptyErrorEnum.NotEmptyError} notEmptyError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.notEmptyError = 0;

                        /**
                         * ErrorCode nullError.
                         * @member {google.ads.googleads.v1.errors.NullErrorEnum.NullError} nullError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.nullError = 0;

                        /**
                         * ErrorCode operatorError.
                         * @member {google.ads.googleads.v1.errors.OperatorErrorEnum.OperatorError} operatorError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.operatorError = 0;

                        /**
                         * ErrorCode rangeError.
                         * @member {google.ads.googleads.v1.errors.RangeErrorEnum.RangeError} rangeError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.rangeError = 0;

                        /**
                         * ErrorCode recommendationError.
                         * @member {google.ads.googleads.v1.errors.RecommendationErrorEnum.RecommendationError} recommendationError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.recommendationError = 0;

                        /**
                         * ErrorCode regionCodeError.
                         * @member {google.ads.googleads.v1.errors.RegionCodeErrorEnum.RegionCodeError} regionCodeError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.regionCodeError = 0;

                        /**
                         * ErrorCode settingError.
                         * @member {google.ads.googleads.v1.errors.SettingErrorEnum.SettingError} settingError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.settingError = 0;

                        /**
                         * ErrorCode stringFormatError.
                         * @member {google.ads.googleads.v1.errors.StringFormatErrorEnum.StringFormatError} stringFormatError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.stringFormatError = 0;

                        /**
                         * ErrorCode stringLengthError.
                         * @member {google.ads.googleads.v1.errors.StringLengthErrorEnum.StringLengthError} stringLengthError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.stringLengthError = 0;

                        /**
                         * ErrorCode operationAccessDeniedError.
                         * @member {google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum.OperationAccessDeniedError} operationAccessDeniedError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.operationAccessDeniedError = 0;

                        /**
                         * ErrorCode resourceAccessDeniedError.
                         * @member {google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum.ResourceAccessDeniedError} resourceAccessDeniedError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.resourceAccessDeniedError = 0;

                        /**
                         * ErrorCode resourceCountLimitExceededError.
                         * @member {google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum.ResourceCountLimitExceededError} resourceCountLimitExceededError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.resourceCountLimitExceededError = 0;

                        /**
                         * ErrorCode youtubeVideoRegistrationError.
                         * @member {google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum.YoutubeVideoRegistrationError} youtubeVideoRegistrationError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.youtubeVideoRegistrationError = 0;

                        /**
                         * ErrorCode adGroupBidModifierError.
                         * @member {google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum.AdGroupBidModifierError} adGroupBidModifierError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.adGroupBidModifierError = 0;

                        /**
                         * ErrorCode contextError.
                         * @member {google.ads.googleads.v1.errors.ContextErrorEnum.ContextError} contextError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.contextError = 0;

                        /**
                         * ErrorCode fieldError.
                         * @member {google.ads.googleads.v1.errors.FieldErrorEnum.FieldError} fieldError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.fieldError = 0;

                        /**
                         * ErrorCode sharedSetError.
                         * @member {google.ads.googleads.v1.errors.SharedSetErrorEnum.SharedSetError} sharedSetError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.sharedSetError = 0;

                        /**
                         * ErrorCode sharedCriterionError.
                         * @member {google.ads.googleads.v1.errors.SharedCriterionErrorEnum.SharedCriterionError} sharedCriterionError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.sharedCriterionError = 0;

                        /**
                         * ErrorCode campaignSharedSetError.
                         * @member {google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum.CampaignSharedSetError} campaignSharedSetError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.campaignSharedSetError = 0;

                        /**
                         * ErrorCode conversionActionError.
                         * @member {google.ads.googleads.v1.errors.ConversionActionErrorEnum.ConversionActionError} conversionActionError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.conversionActionError = 0;

                        /**
                         * ErrorCode conversionAdjustmentUploadError.
                         * @member {google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum.ConversionAdjustmentUploadError} conversionAdjustmentUploadError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.conversionAdjustmentUploadError = 0;

                        /**
                         * ErrorCode conversionUploadError.
                         * @member {google.ads.googleads.v1.errors.ConversionUploadErrorEnum.ConversionUploadError} conversionUploadError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.conversionUploadError = 0;

                        /**
                         * ErrorCode headerError.
                         * @member {google.ads.googleads.v1.errors.HeaderErrorEnum.HeaderError} headerError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.headerError = 0;

                        /**
                         * ErrorCode databaseError.
                         * @member {google.ads.googleads.v1.errors.DatabaseErrorEnum.DatabaseError} databaseError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.databaseError = 0;

                        /**
                         * ErrorCode policyFindingError.
                         * @member {google.ads.googleads.v1.errors.PolicyFindingErrorEnum.PolicyFindingError} policyFindingError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.policyFindingError = 0;

                        /**
                         * ErrorCode enumError.
                         * @member {google.ads.googleads.v1.errors.EnumErrorEnum.EnumError} enumError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.enumError = 0;

                        /**
                         * ErrorCode keywordPlanError.
                         * @member {google.ads.googleads.v1.errors.KeywordPlanErrorEnum.KeywordPlanError} keywordPlanError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.keywordPlanError = 0;

                        /**
                         * ErrorCode keywordPlanCampaignError.
                         * @member {google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum.KeywordPlanCampaignError} keywordPlanCampaignError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.keywordPlanCampaignError = 0;

                        /**
                         * ErrorCode keywordPlanNegativeKeywordError.
                         * @member {google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum.KeywordPlanNegativeKeywordError} keywordPlanNegativeKeywordError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.keywordPlanNegativeKeywordError = 0;

                        /**
                         * ErrorCode keywordPlanAdGroupError.
                         * @member {google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum.KeywordPlanAdGroupError} keywordPlanAdGroupError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.keywordPlanAdGroupError = 0;

                        /**
                         * ErrorCode keywordPlanKeywordError.
                         * @member {google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum.KeywordPlanKeywordError} keywordPlanKeywordError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.keywordPlanKeywordError = 0;

                        /**
                         * ErrorCode keywordPlanIdeaError.
                         * @member {google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum.KeywordPlanIdeaError} keywordPlanIdeaError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.keywordPlanIdeaError = 0;

                        /**
                         * ErrorCode accountBudgetProposalError.
                         * @member {google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum.AccountBudgetProposalError} accountBudgetProposalError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.accountBudgetProposalError = 0;

                        /**
                         * ErrorCode userListError.
                         * @member {google.ads.googleads.v1.errors.UserListErrorEnum.UserListError} userListError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.userListError = 0;

                        /**
                         * ErrorCode changeStatusError.
                         * @member {google.ads.googleads.v1.errors.ChangeStatusErrorEnum.ChangeStatusError} changeStatusError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.changeStatusError = 0;

                        /**
                         * ErrorCode feedError.
                         * @member {google.ads.googleads.v1.errors.FeedErrorEnum.FeedError} feedError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.feedError = 0;

                        /**
                         * ErrorCode geoTargetConstantSuggestionError.
                         * @member {google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum.GeoTargetConstantSuggestionError} geoTargetConstantSuggestionError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.geoTargetConstantSuggestionError = 0;

                        /**
                         * ErrorCode feedItemError.
                         * @member {google.ads.googleads.v1.errors.FeedItemErrorEnum.FeedItemError} feedItemError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.feedItemError = 0;

                        /**
                         * ErrorCode labelError.
                         * @member {google.ads.googleads.v1.errors.LabelErrorEnum.LabelError} labelError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.labelError = 0;

                        /**
                         * ErrorCode billingSetupError.
                         * @member {google.ads.googleads.v1.errors.BillingSetupErrorEnum.BillingSetupError} billingSetupError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.billingSetupError = 0;

                        /**
                         * ErrorCode customerClientLinkError.
                         * @member {google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum.CustomerClientLinkError} customerClientLinkError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.customerClientLinkError = 0;

                        /**
                         * ErrorCode customerManagerLinkError.
                         * @member {google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum.CustomerManagerLinkError} customerManagerLinkError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.customerManagerLinkError = 0;

                        /**
                         * ErrorCode feedMappingError.
                         * @member {google.ads.googleads.v1.errors.FeedMappingErrorEnum.FeedMappingError} feedMappingError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.feedMappingError = 0;

                        /**
                         * ErrorCode customerFeedError.
                         * @member {google.ads.googleads.v1.errors.CustomerFeedErrorEnum.CustomerFeedError} customerFeedError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.customerFeedError = 0;

                        /**
                         * ErrorCode adGroupFeedError.
                         * @member {google.ads.googleads.v1.errors.AdGroupFeedErrorEnum.AdGroupFeedError} adGroupFeedError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.adGroupFeedError = 0;

                        /**
                         * ErrorCode campaignFeedError.
                         * @member {google.ads.googleads.v1.errors.CampaignFeedErrorEnum.CampaignFeedError} campaignFeedError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.campaignFeedError = 0;

                        /**
                         * ErrorCode customInterestError.
                         * @member {google.ads.googleads.v1.errors.CustomInterestErrorEnum.CustomInterestError} customInterestError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.customInterestError = 0;

                        /**
                         * ErrorCode extensionFeedItemError.
                         * @member {google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum.ExtensionFeedItemError} extensionFeedItemError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.extensionFeedItemError = 0;

                        /**
                         * ErrorCode adParameterError.
                         * @member {google.ads.googleads.v1.errors.AdParameterErrorEnum.AdParameterError} adParameterError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.adParameterError = 0;

                        /**
                         * ErrorCode feedItemValidationError.
                         * @member {google.ads.googleads.v1.errors.FeedItemValidationErrorEnum.FeedItemValidationError} feedItemValidationError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.feedItemValidationError = 0;

                        /**
                         * ErrorCode extensionSettingError.
                         * @member {google.ads.googleads.v1.errors.ExtensionSettingErrorEnum.ExtensionSettingError} extensionSettingError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.extensionSettingError = 0;

                        /**
                         * ErrorCode feedItemTargetError.
                         * @member {google.ads.googleads.v1.errors.FeedItemTargetErrorEnum.FeedItemTargetError} feedItemTargetError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.feedItemTargetError = 0;

                        /**
                         * ErrorCode policyViolationError.
                         * @member {google.ads.googleads.v1.errors.PolicyViolationErrorEnum.PolicyViolationError} policyViolationError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.policyViolationError = 0;

                        /**
                         * ErrorCode mutateJobError.
                         * @member {google.ads.googleads.v1.errors.MutateJobErrorEnum.MutateJobError} mutateJobError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.mutateJobError = 0;

                        /**
                         * ErrorCode partialFailureError.
                         * @member {google.ads.googleads.v1.errors.PartialFailureErrorEnum.PartialFailureError} partialFailureError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.partialFailureError = 0;

                        /**
                         * ErrorCode policyValidationParameterError.
                         * @member {google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum.PolicyValidationParameterError} policyValidationParameterError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.policyValidationParameterError = 0;

                        /**
                         * ErrorCode sizeLimitError.
                         * @member {google.ads.googleads.v1.errors.SizeLimitErrorEnum.SizeLimitError} sizeLimitError
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        ErrorCode.prototype.sizeLimitError = 0;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * ErrorCode errorCode.
                         * @member {"requestError"|"biddingStrategyError"|"urlFieldError"|"listOperationError"|"queryError"|"mutateError"|"fieldMaskError"|"authorizationError"|"internalError"|"quotaError"|"adError"|"adGroupError"|"campaignBudgetError"|"campaignError"|"authenticationError"|"adGroupCriterionError"|"adCustomizerError"|"adGroupAdError"|"adSharingError"|"adxError"|"assetError"|"biddingError"|"campaignCriterionError"|"collectionSizeError"|"countryCodeError"|"criterionError"|"customerError"|"dateError"|"dateRangeError"|"distinctError"|"feedAttributeReferenceError"|"functionError"|"functionParsingError"|"idError"|"imageError"|"languageCodeError"|"mediaBundleError"|"mediaUploadError"|"mediaFileError"|"multiplierError"|"newResourceCreationError"|"notEmptyError"|"nullError"|"operatorError"|"rangeError"|"recommendationError"|"regionCodeError"|"settingError"|"stringFormatError"|"stringLengthError"|"operationAccessDeniedError"|"resourceAccessDeniedError"|"resourceCountLimitExceededError"|"youtubeVideoRegistrationError"|"adGroupBidModifierError"|"contextError"|"fieldError"|"sharedSetError"|"sharedCriterionError"|"campaignSharedSetError"|"conversionActionError"|"conversionAdjustmentUploadError"|"conversionUploadError"|"headerError"|"databaseError"|"policyFindingError"|"enumError"|"keywordPlanError"|"keywordPlanCampaignError"|"keywordPlanNegativeKeywordError"|"keywordPlanAdGroupError"|"keywordPlanKeywordError"|"keywordPlanIdeaError"|"accountBudgetProposalError"|"userListError"|"changeStatusError"|"feedError"|"geoTargetConstantSuggestionError"|"feedItemError"|"labelError"|"billingSetupError"|"customerClientLinkError"|"customerManagerLinkError"|"feedMappingError"|"customerFeedError"|"adGroupFeedError"|"campaignFeedError"|"customInterestError"|"extensionFeedItemError"|"adParameterError"|"feedItemValidationError"|"extensionSettingError"|"feedItemTargetError"|"policyViolationError"|"mutateJobError"|"partialFailureError"|"policyValidationParameterError"|"sizeLimitError"|undefined} errorCode
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         */
                        Object.defineProperty(ErrorCode.prototype, "errorCode", {
                            get: $util.oneOfGetter($oneOfFields = ["requestError", "biddingStrategyError", "urlFieldError", "listOperationError", "queryError", "mutateError", "fieldMaskError", "authorizationError", "internalError", "quotaError", "adError", "adGroupError", "campaignBudgetError", "campaignError", "authenticationError", "adGroupCriterionError", "adCustomizerError", "adGroupAdError", "adSharingError", "adxError", "assetError", "biddingError", "campaignCriterionError", "collectionSizeError", "countryCodeError", "criterionError", "customerError", "dateError", "dateRangeError", "distinctError", "feedAttributeReferenceError", "functionError", "functionParsingError", "idError", "imageError", "languageCodeError", "mediaBundleError", "mediaUploadError", "mediaFileError", "multiplierError", "newResourceCreationError", "notEmptyError", "nullError", "operatorError", "rangeError", "recommendationError", "regionCodeError", "settingError", "stringFormatError", "stringLengthError", "operationAccessDeniedError", "resourceAccessDeniedError", "resourceCountLimitExceededError", "youtubeVideoRegistrationError", "adGroupBidModifierError", "contextError", "fieldError", "sharedSetError", "sharedCriterionError", "campaignSharedSetError", "conversionActionError", "conversionAdjustmentUploadError", "conversionUploadError", "headerError", "databaseError", "policyFindingError", "enumError", "keywordPlanError", "keywordPlanCampaignError", "keywordPlanNegativeKeywordError", "keywordPlanAdGroupError", "keywordPlanKeywordError", "keywordPlanIdeaError", "accountBudgetProposalError", "userListError", "changeStatusError", "feedError", "geoTargetConstantSuggestionError", "feedItemError", "labelError", "billingSetupError", "customerClientLinkError", "customerManagerLinkError", "feedMappingError", "customerFeedError", "adGroupFeedError", "campaignFeedError", "customInterestError", "extensionFeedItemError", "adParameterError", "feedItemValidationError", "extensionSettingError", "feedItemTargetError", "policyViolationError", "mutateJobError", "partialFailureError", "policyValidationParameterError", "sizeLimitError"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new ErrorCode instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @static
                         * @param {google.ads.googleads.v1.errors.IErrorCode=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.ErrorCode} ErrorCode instance
                         */
                        ErrorCode.create = function create(properties) {
                            return new ErrorCode(properties);
                        };

                        /**
                         * Encodes the specified ErrorCode message. Does not implicitly {@link google.ads.googleads.v1.errors.ErrorCode.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @static
                         * @param {google.ads.googleads.v1.errors.IErrorCode} message ErrorCode message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ErrorCode.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestError != null && message.hasOwnProperty("requestError"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.requestError);
                            if (message.biddingStrategyError != null && message.hasOwnProperty("biddingStrategyError"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.biddingStrategyError);
                            if (message.urlFieldError != null && message.hasOwnProperty("urlFieldError"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.urlFieldError);
                            if (message.listOperationError != null && message.hasOwnProperty("listOperationError"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.listOperationError);
                            if (message.queryError != null && message.hasOwnProperty("queryError"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.queryError);
                            if (message.mutateError != null && message.hasOwnProperty("mutateError"))
                                writer.uint32(/* id 7, wireType 0 =*/56).int32(message.mutateError);
                            if (message.fieldMaskError != null && message.hasOwnProperty("fieldMaskError"))
                                writer.uint32(/* id 8, wireType 0 =*/64).int32(message.fieldMaskError);
                            if (message.authorizationError != null && message.hasOwnProperty("authorizationError"))
                                writer.uint32(/* id 9, wireType 0 =*/72).int32(message.authorizationError);
                            if (message.internalError != null && message.hasOwnProperty("internalError"))
                                writer.uint32(/* id 10, wireType 0 =*/80).int32(message.internalError);
                            if (message.quotaError != null && message.hasOwnProperty("quotaError"))
                                writer.uint32(/* id 11, wireType 0 =*/88).int32(message.quotaError);
                            if (message.adError != null && message.hasOwnProperty("adError"))
                                writer.uint32(/* id 12, wireType 0 =*/96).int32(message.adError);
                            if (message.adGroupError != null && message.hasOwnProperty("adGroupError"))
                                writer.uint32(/* id 13, wireType 0 =*/104).int32(message.adGroupError);
                            if (message.campaignBudgetError != null && message.hasOwnProperty("campaignBudgetError"))
                                writer.uint32(/* id 14, wireType 0 =*/112).int32(message.campaignBudgetError);
                            if (message.campaignError != null && message.hasOwnProperty("campaignError"))
                                writer.uint32(/* id 15, wireType 0 =*/120).int32(message.campaignError);
                            if (message.authenticationError != null && message.hasOwnProperty("authenticationError"))
                                writer.uint32(/* id 17, wireType 0 =*/136).int32(message.authenticationError);
                            if (message.adGroupCriterionError != null && message.hasOwnProperty("adGroupCriterionError"))
                                writer.uint32(/* id 18, wireType 0 =*/144).int32(message.adGroupCriterionError);
                            if (message.adCustomizerError != null && message.hasOwnProperty("adCustomizerError"))
                                writer.uint32(/* id 19, wireType 0 =*/152).int32(message.adCustomizerError);
                            if (message.adGroupAdError != null && message.hasOwnProperty("adGroupAdError"))
                                writer.uint32(/* id 21, wireType 0 =*/168).int32(message.adGroupAdError);
                            if (message.adSharingError != null && message.hasOwnProperty("adSharingError"))
                                writer.uint32(/* id 24, wireType 0 =*/192).int32(message.adSharingError);
                            if (message.adxError != null && message.hasOwnProperty("adxError"))
                                writer.uint32(/* id 25, wireType 0 =*/200).int32(message.adxError);
                            if (message.biddingError != null && message.hasOwnProperty("biddingError"))
                                writer.uint32(/* id 26, wireType 0 =*/208).int32(message.biddingError);
                            if (message.campaignCriterionError != null && message.hasOwnProperty("campaignCriterionError"))
                                writer.uint32(/* id 29, wireType 0 =*/232).int32(message.campaignCriterionError);
                            if (message.collectionSizeError != null && message.hasOwnProperty("collectionSizeError"))
                                writer.uint32(/* id 31, wireType 0 =*/248).int32(message.collectionSizeError);
                            if (message.criterionError != null && message.hasOwnProperty("criterionError"))
                                writer.uint32(/* id 32, wireType 0 =*/256).int32(message.criterionError);
                            if (message.dateError != null && message.hasOwnProperty("dateError"))
                                writer.uint32(/* id 33, wireType 0 =*/264).int32(message.dateError);
                            if (message.dateRangeError != null && message.hasOwnProperty("dateRangeError"))
                                writer.uint32(/* id 34, wireType 0 =*/272).int32(message.dateRangeError);
                            if (message.distinctError != null && message.hasOwnProperty("distinctError"))
                                writer.uint32(/* id 35, wireType 0 =*/280).int32(message.distinctError);
                            if (message.feedAttributeReferenceError != null && message.hasOwnProperty("feedAttributeReferenceError"))
                                writer.uint32(/* id 36, wireType 0 =*/288).int32(message.feedAttributeReferenceError);
                            if (message.functionError != null && message.hasOwnProperty("functionError"))
                                writer.uint32(/* id 37, wireType 0 =*/296).int32(message.functionError);
                            if (message.functionParsingError != null && message.hasOwnProperty("functionParsingError"))
                                writer.uint32(/* id 38, wireType 0 =*/304).int32(message.functionParsingError);
                            if (message.idError != null && message.hasOwnProperty("idError"))
                                writer.uint32(/* id 39, wireType 0 =*/312).int32(message.idError);
                            if (message.imageError != null && message.hasOwnProperty("imageError"))
                                writer.uint32(/* id 40, wireType 0 =*/320).int32(message.imageError);
                            if (message.mediaBundleError != null && message.hasOwnProperty("mediaBundleError"))
                                writer.uint32(/* id 42, wireType 0 =*/336).int32(message.mediaBundleError);
                            if (message.multiplierError != null && message.hasOwnProperty("multiplierError"))
                                writer.uint32(/* id 44, wireType 0 =*/352).int32(message.multiplierError);
                            if (message.newResourceCreationError != null && message.hasOwnProperty("newResourceCreationError"))
                                writer.uint32(/* id 45, wireType 0 =*/360).int32(message.newResourceCreationError);
                            if (message.notEmptyError != null && message.hasOwnProperty("notEmptyError"))
                                writer.uint32(/* id 46, wireType 0 =*/368).int32(message.notEmptyError);
                            if (message.nullError != null && message.hasOwnProperty("nullError"))
                                writer.uint32(/* id 47, wireType 0 =*/376).int32(message.nullError);
                            if (message.operatorError != null && message.hasOwnProperty("operatorError"))
                                writer.uint32(/* id 48, wireType 0 =*/384).int32(message.operatorError);
                            if (message.rangeError != null && message.hasOwnProperty("rangeError"))
                                writer.uint32(/* id 49, wireType 0 =*/392).int32(message.rangeError);
                            if (message.regionCodeError != null && message.hasOwnProperty("regionCodeError"))
                                writer.uint32(/* id 51, wireType 0 =*/408).int32(message.regionCodeError);
                            if (message.settingError != null && message.hasOwnProperty("settingError"))
                                writer.uint32(/* id 52, wireType 0 =*/416).int32(message.settingError);
                            if (message.stringFormatError != null && message.hasOwnProperty("stringFormatError"))
                                writer.uint32(/* id 53, wireType 0 =*/424).int32(message.stringFormatError);
                            if (message.stringLengthError != null && message.hasOwnProperty("stringLengthError"))
                                writer.uint32(/* id 54, wireType 0 =*/432).int32(message.stringLengthError);
                            if (message.operationAccessDeniedError != null && message.hasOwnProperty("operationAccessDeniedError"))
                                writer.uint32(/* id 55, wireType 0 =*/440).int32(message.operationAccessDeniedError);
                            if (message.resourceAccessDeniedError != null && message.hasOwnProperty("resourceAccessDeniedError"))
                                writer.uint32(/* id 56, wireType 0 =*/448).int32(message.resourceAccessDeniedError);
                            if (message.resourceCountLimitExceededError != null && message.hasOwnProperty("resourceCountLimitExceededError"))
                                writer.uint32(/* id 57, wireType 0 =*/456).int32(message.resourceCountLimitExceededError);
                            if (message.recommendationError != null && message.hasOwnProperty("recommendationError"))
                                writer.uint32(/* id 58, wireType 0 =*/464).int32(message.recommendationError);
                            if (message.adGroupBidModifierError != null && message.hasOwnProperty("adGroupBidModifierError"))
                                writer.uint32(/* id 59, wireType 0 =*/472).int32(message.adGroupBidModifierError);
                            if (message.contextError != null && message.hasOwnProperty("contextError"))
                                writer.uint32(/* id 60, wireType 0 =*/480).int32(message.contextError);
                            if (message.fieldError != null && message.hasOwnProperty("fieldError"))
                                writer.uint32(/* id 61, wireType 0 =*/488).int32(message.fieldError);
                            if (message.sharedSetError != null && message.hasOwnProperty("sharedSetError"))
                                writer.uint32(/* id 62, wireType 0 =*/496).int32(message.sharedSetError);
                            if (message.sharedCriterionError != null && message.hasOwnProperty("sharedCriterionError"))
                                writer.uint32(/* id 63, wireType 0 =*/504).int32(message.sharedCriterionError);
                            if (message.campaignSharedSetError != null && message.hasOwnProperty("campaignSharedSetError"))
                                writer.uint32(/* id 64, wireType 0 =*/512).int32(message.campaignSharedSetError);
                            if (message.conversionActionError != null && message.hasOwnProperty("conversionActionError"))
                                writer.uint32(/* id 65, wireType 0 =*/520).int32(message.conversionActionError);
                            if (message.headerError != null && message.hasOwnProperty("headerError"))
                                writer.uint32(/* id 66, wireType 0 =*/528).int32(message.headerError);
                            if (message.databaseError != null && message.hasOwnProperty("databaseError"))
                                writer.uint32(/* id 67, wireType 0 =*/536).int32(message.databaseError);
                            if (message.policyFindingError != null && message.hasOwnProperty("policyFindingError"))
                                writer.uint32(/* id 68, wireType 0 =*/544).int32(message.policyFindingError);
                            if (message.enumError != null && message.hasOwnProperty("enumError"))
                                writer.uint32(/* id 70, wireType 0 =*/560).int32(message.enumError);
                            if (message.keywordPlanError != null && message.hasOwnProperty("keywordPlanError"))
                                writer.uint32(/* id 71, wireType 0 =*/568).int32(message.keywordPlanError);
                            if (message.keywordPlanCampaignError != null && message.hasOwnProperty("keywordPlanCampaignError"))
                                writer.uint32(/* id 72, wireType 0 =*/576).int32(message.keywordPlanCampaignError);
                            if (message.keywordPlanNegativeKeywordError != null && message.hasOwnProperty("keywordPlanNegativeKeywordError"))
                                writer.uint32(/* id 73, wireType 0 =*/584).int32(message.keywordPlanNegativeKeywordError);
                            if (message.keywordPlanAdGroupError != null && message.hasOwnProperty("keywordPlanAdGroupError"))
                                writer.uint32(/* id 74, wireType 0 =*/592).int32(message.keywordPlanAdGroupError);
                            if (message.keywordPlanKeywordError != null && message.hasOwnProperty("keywordPlanKeywordError"))
                                writer.uint32(/* id 75, wireType 0 =*/600).int32(message.keywordPlanKeywordError);
                            if (message.keywordPlanIdeaError != null && message.hasOwnProperty("keywordPlanIdeaError"))
                                writer.uint32(/* id 76, wireType 0 =*/608).int32(message.keywordPlanIdeaError);
                            if (message.accountBudgetProposalError != null && message.hasOwnProperty("accountBudgetProposalError"))
                                writer.uint32(/* id 77, wireType 0 =*/616).int32(message.accountBudgetProposalError);
                            if (message.userListError != null && message.hasOwnProperty("userListError"))
                                writer.uint32(/* id 78, wireType 0 =*/624).int32(message.userListError);
                            if (message.changeStatusError != null && message.hasOwnProperty("changeStatusError"))
                                writer.uint32(/* id 79, wireType 0 =*/632).int32(message.changeStatusError);
                            if (message.feedError != null && message.hasOwnProperty("feedError"))
                                writer.uint32(/* id 80, wireType 0 =*/640).int32(message.feedError);
                            if (message.geoTargetConstantSuggestionError != null && message.hasOwnProperty("geoTargetConstantSuggestionError"))
                                writer.uint32(/* id 81, wireType 0 =*/648).int32(message.geoTargetConstantSuggestionError);
                            if (message.feedItemError != null && message.hasOwnProperty("feedItemError"))
                                writer.uint32(/* id 83, wireType 0 =*/664).int32(message.feedItemError);
                            if (message.labelError != null && message.hasOwnProperty("labelError"))
                                writer.uint32(/* id 84, wireType 0 =*/672).int32(message.labelError);
                            if (message.mediaFileError != null && message.hasOwnProperty("mediaFileError"))
                                writer.uint32(/* id 86, wireType 0 =*/688).int32(message.mediaFileError);
                            if (message.billingSetupError != null && message.hasOwnProperty("billingSetupError"))
                                writer.uint32(/* id 87, wireType 0 =*/696).int32(message.billingSetupError);
                            if (message.customerClientLinkError != null && message.hasOwnProperty("customerClientLinkError"))
                                writer.uint32(/* id 88, wireType 0 =*/704).int32(message.customerClientLinkError);
                            if (message.customerError != null && message.hasOwnProperty("customerError"))
                                writer.uint32(/* id 90, wireType 0 =*/720).int32(message.customerError);
                            if (message.customerManagerLinkError != null && message.hasOwnProperty("customerManagerLinkError"))
                                writer.uint32(/* id 91, wireType 0 =*/728).int32(message.customerManagerLinkError);
                            if (message.feedMappingError != null && message.hasOwnProperty("feedMappingError"))
                                writer.uint32(/* id 92, wireType 0 =*/736).int32(message.feedMappingError);
                            if (message.customerFeedError != null && message.hasOwnProperty("customerFeedError"))
                                writer.uint32(/* id 93, wireType 0 =*/744).int32(message.customerFeedError);
                            if (message.adGroupFeedError != null && message.hasOwnProperty("adGroupFeedError"))
                                writer.uint32(/* id 94, wireType 0 =*/752).int32(message.adGroupFeedError);
                            if (message.campaignFeedError != null && message.hasOwnProperty("campaignFeedError"))
                                writer.uint32(/* id 96, wireType 0 =*/768).int32(message.campaignFeedError);
                            if (message.customInterestError != null && message.hasOwnProperty("customInterestError"))
                                writer.uint32(/* id 97, wireType 0 =*/776).int32(message.customInterestError);
                            if (message.extensionFeedItemError != null && message.hasOwnProperty("extensionFeedItemError"))
                                writer.uint32(/* id 100, wireType 0 =*/800).int32(message.extensionFeedItemError);
                            if (message.adParameterError != null && message.hasOwnProperty("adParameterError"))
                                writer.uint32(/* id 101, wireType 0 =*/808).int32(message.adParameterError);
                            if (message.feedItemValidationError != null && message.hasOwnProperty("feedItemValidationError"))
                                writer.uint32(/* id 102, wireType 0 =*/816).int32(message.feedItemValidationError);
                            if (message.extensionSettingError != null && message.hasOwnProperty("extensionSettingError"))
                                writer.uint32(/* id 103, wireType 0 =*/824).int32(message.extensionSettingError);
                            if (message.feedItemTargetError != null && message.hasOwnProperty("feedItemTargetError"))
                                writer.uint32(/* id 104, wireType 0 =*/832).int32(message.feedItemTargetError);
                            if (message.policyViolationError != null && message.hasOwnProperty("policyViolationError"))
                                writer.uint32(/* id 105, wireType 0 =*/840).int32(message.policyViolationError);
                            if (message.assetError != null && message.hasOwnProperty("assetError"))
                                writer.uint32(/* id 107, wireType 0 =*/856).int32(message.assetError);
                            if (message.mutateJobError != null && message.hasOwnProperty("mutateJobError"))
                                writer.uint32(/* id 108, wireType 0 =*/864).int32(message.mutateJobError);
                            if (message.countryCodeError != null && message.hasOwnProperty("countryCodeError"))
                                writer.uint32(/* id 109, wireType 0 =*/872).int32(message.countryCodeError);
                            if (message.languageCodeError != null && message.hasOwnProperty("languageCodeError"))
                                writer.uint32(/* id 110, wireType 0 =*/880).int32(message.languageCodeError);
                            if (message.conversionUploadError != null && message.hasOwnProperty("conversionUploadError"))
                                writer.uint32(/* id 111, wireType 0 =*/888).int32(message.conversionUploadError);
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                writer.uint32(/* id 112, wireType 0 =*/896).int32(message.partialFailureError);
                            if (message.policyValidationParameterError != null && message.hasOwnProperty("policyValidationParameterError"))
                                writer.uint32(/* id 114, wireType 0 =*/912).int32(message.policyValidationParameterError);
                            if (message.conversionAdjustmentUploadError != null && message.hasOwnProperty("conversionAdjustmentUploadError"))
                                writer.uint32(/* id 115, wireType 0 =*/920).int32(message.conversionAdjustmentUploadError);
                            if (message.mediaUploadError != null && message.hasOwnProperty("mediaUploadError"))
                                writer.uint32(/* id 116, wireType 0 =*/928).int32(message.mediaUploadError);
                            if (message.youtubeVideoRegistrationError != null && message.hasOwnProperty("youtubeVideoRegistrationError"))
                                writer.uint32(/* id 117, wireType 0 =*/936).int32(message.youtubeVideoRegistrationError);
                            if (message.sizeLimitError != null && message.hasOwnProperty("sizeLimitError"))
                                writer.uint32(/* id 118, wireType 0 =*/944).int32(message.sizeLimitError);
                            return writer;
                        };

                        /**
                         * Encodes the specified ErrorCode message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.ErrorCode.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @static
                         * @param {google.ads.googleads.v1.errors.IErrorCode} message ErrorCode message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ErrorCode.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ErrorCode message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.ErrorCode} ErrorCode
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ErrorCode.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.ErrorCode();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.requestError = reader.int32();
                                    break;
                                case 2:
                                    message.biddingStrategyError = reader.int32();
                                    break;
                                case 3:
                                    message.urlFieldError = reader.int32();
                                    break;
                                case 4:
                                    message.listOperationError = reader.int32();
                                    break;
                                case 5:
                                    message.queryError = reader.int32();
                                    break;
                                case 7:
                                    message.mutateError = reader.int32();
                                    break;
                                case 8:
                                    message.fieldMaskError = reader.int32();
                                    break;
                                case 9:
                                    message.authorizationError = reader.int32();
                                    break;
                                case 10:
                                    message.internalError = reader.int32();
                                    break;
                                case 11:
                                    message.quotaError = reader.int32();
                                    break;
                                case 12:
                                    message.adError = reader.int32();
                                    break;
                                case 13:
                                    message.adGroupError = reader.int32();
                                    break;
                                case 14:
                                    message.campaignBudgetError = reader.int32();
                                    break;
                                case 15:
                                    message.campaignError = reader.int32();
                                    break;
                                case 17:
                                    message.authenticationError = reader.int32();
                                    break;
                                case 18:
                                    message.adGroupCriterionError = reader.int32();
                                    break;
                                case 19:
                                    message.adCustomizerError = reader.int32();
                                    break;
                                case 21:
                                    message.adGroupAdError = reader.int32();
                                    break;
                                case 24:
                                    message.adSharingError = reader.int32();
                                    break;
                                case 25:
                                    message.adxError = reader.int32();
                                    break;
                                case 107:
                                    message.assetError = reader.int32();
                                    break;
                                case 26:
                                    message.biddingError = reader.int32();
                                    break;
                                case 29:
                                    message.campaignCriterionError = reader.int32();
                                    break;
                                case 31:
                                    message.collectionSizeError = reader.int32();
                                    break;
                                case 109:
                                    message.countryCodeError = reader.int32();
                                    break;
                                case 32:
                                    message.criterionError = reader.int32();
                                    break;
                                case 90:
                                    message.customerError = reader.int32();
                                    break;
                                case 33:
                                    message.dateError = reader.int32();
                                    break;
                                case 34:
                                    message.dateRangeError = reader.int32();
                                    break;
                                case 35:
                                    message.distinctError = reader.int32();
                                    break;
                                case 36:
                                    message.feedAttributeReferenceError = reader.int32();
                                    break;
                                case 37:
                                    message.functionError = reader.int32();
                                    break;
                                case 38:
                                    message.functionParsingError = reader.int32();
                                    break;
                                case 39:
                                    message.idError = reader.int32();
                                    break;
                                case 40:
                                    message.imageError = reader.int32();
                                    break;
                                case 110:
                                    message.languageCodeError = reader.int32();
                                    break;
                                case 42:
                                    message.mediaBundleError = reader.int32();
                                    break;
                                case 116:
                                    message.mediaUploadError = reader.int32();
                                    break;
                                case 86:
                                    message.mediaFileError = reader.int32();
                                    break;
                                case 44:
                                    message.multiplierError = reader.int32();
                                    break;
                                case 45:
                                    message.newResourceCreationError = reader.int32();
                                    break;
                                case 46:
                                    message.notEmptyError = reader.int32();
                                    break;
                                case 47:
                                    message.nullError = reader.int32();
                                    break;
                                case 48:
                                    message.operatorError = reader.int32();
                                    break;
                                case 49:
                                    message.rangeError = reader.int32();
                                    break;
                                case 58:
                                    message.recommendationError = reader.int32();
                                    break;
                                case 51:
                                    message.regionCodeError = reader.int32();
                                    break;
                                case 52:
                                    message.settingError = reader.int32();
                                    break;
                                case 53:
                                    message.stringFormatError = reader.int32();
                                    break;
                                case 54:
                                    message.stringLengthError = reader.int32();
                                    break;
                                case 55:
                                    message.operationAccessDeniedError = reader.int32();
                                    break;
                                case 56:
                                    message.resourceAccessDeniedError = reader.int32();
                                    break;
                                case 57:
                                    message.resourceCountLimitExceededError = reader.int32();
                                    break;
                                case 117:
                                    message.youtubeVideoRegistrationError = reader.int32();
                                    break;
                                case 59:
                                    message.adGroupBidModifierError = reader.int32();
                                    break;
                                case 60:
                                    message.contextError = reader.int32();
                                    break;
                                case 61:
                                    message.fieldError = reader.int32();
                                    break;
                                case 62:
                                    message.sharedSetError = reader.int32();
                                    break;
                                case 63:
                                    message.sharedCriterionError = reader.int32();
                                    break;
                                case 64:
                                    message.campaignSharedSetError = reader.int32();
                                    break;
                                case 65:
                                    message.conversionActionError = reader.int32();
                                    break;
                                case 115:
                                    message.conversionAdjustmentUploadError = reader.int32();
                                    break;
                                case 111:
                                    message.conversionUploadError = reader.int32();
                                    break;
                                case 66:
                                    message.headerError = reader.int32();
                                    break;
                                case 67:
                                    message.databaseError = reader.int32();
                                    break;
                                case 68:
                                    message.policyFindingError = reader.int32();
                                    break;
                                case 70:
                                    message.enumError = reader.int32();
                                    break;
                                case 71:
                                    message.keywordPlanError = reader.int32();
                                    break;
                                case 72:
                                    message.keywordPlanCampaignError = reader.int32();
                                    break;
                                case 73:
                                    message.keywordPlanNegativeKeywordError = reader.int32();
                                    break;
                                case 74:
                                    message.keywordPlanAdGroupError = reader.int32();
                                    break;
                                case 75:
                                    message.keywordPlanKeywordError = reader.int32();
                                    break;
                                case 76:
                                    message.keywordPlanIdeaError = reader.int32();
                                    break;
                                case 77:
                                    message.accountBudgetProposalError = reader.int32();
                                    break;
                                case 78:
                                    message.userListError = reader.int32();
                                    break;
                                case 79:
                                    message.changeStatusError = reader.int32();
                                    break;
                                case 80:
                                    message.feedError = reader.int32();
                                    break;
                                case 81:
                                    message.geoTargetConstantSuggestionError = reader.int32();
                                    break;
                                case 83:
                                    message.feedItemError = reader.int32();
                                    break;
                                case 84:
                                    message.labelError = reader.int32();
                                    break;
                                case 87:
                                    message.billingSetupError = reader.int32();
                                    break;
                                case 88:
                                    message.customerClientLinkError = reader.int32();
                                    break;
                                case 91:
                                    message.customerManagerLinkError = reader.int32();
                                    break;
                                case 92:
                                    message.feedMappingError = reader.int32();
                                    break;
                                case 93:
                                    message.customerFeedError = reader.int32();
                                    break;
                                case 94:
                                    message.adGroupFeedError = reader.int32();
                                    break;
                                case 96:
                                    message.campaignFeedError = reader.int32();
                                    break;
                                case 97:
                                    message.customInterestError = reader.int32();
                                    break;
                                case 100:
                                    message.extensionFeedItemError = reader.int32();
                                    break;
                                case 101:
                                    message.adParameterError = reader.int32();
                                    break;
                                case 102:
                                    message.feedItemValidationError = reader.int32();
                                    break;
                                case 103:
                                    message.extensionSettingError = reader.int32();
                                    break;
                                case 104:
                                    message.feedItemTargetError = reader.int32();
                                    break;
                                case 105:
                                    message.policyViolationError = reader.int32();
                                    break;
                                case 108:
                                    message.mutateJobError = reader.int32();
                                    break;
                                case 112:
                                    message.partialFailureError = reader.int32();
                                    break;
                                case 114:
                                    message.policyValidationParameterError = reader.int32();
                                    break;
                                case 118:
                                    message.sizeLimitError = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ErrorCode message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.ErrorCode} ErrorCode
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ErrorCode.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ErrorCode message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ErrorCode.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.requestError != null && message.hasOwnProperty("requestError")) {
                                properties.errorCode = 1;
                                switch (message.requestError) {
                                default:
                                    return "requestError: enum value expected";
                                case 0:
                                case 1:
                                case 3:
                                case 4:
                                case 17:
                                case 16:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 22:
                                case 9:
                                case 11:
                                case 13:
                                case 14:
                                case 15:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                    break;
                                }
                            }
                            if (message.biddingStrategyError != null && message.hasOwnProperty("biddingStrategyError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.biddingStrategyError) {
                                default:
                                    return "biddingStrategyError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            }
                            if (message.urlFieldError != null && message.hasOwnProperty("urlFieldError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.urlFieldError) {
                                default:
                                    return "urlFieldError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                case 32:
                                case 33:
                                case 34:
                                case 39:
                                case 40:
                                case 41:
                                case 42:
                                case 43:
                                case 52:
                                case 44:
                                case 45:
                                case 46:
                                case 47:
                                case 48:
                                case 49:
                                case 50:
                                case 51:
                                case 53:
                                case 54:
                                case 55:
                                case 56:
                                    break;
                                }
                            }
                            if (message.listOperationError != null && message.hasOwnProperty("listOperationError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.listOperationError) {
                                default:
                                    return "listOperationError: enum value expected";
                                case 0:
                                case 1:
                                case 7:
                                case 8:
                                    break;
                                }
                            }
                            if (message.queryError != null && message.hasOwnProperty("queryError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.queryError) {
                                default:
                                    return "queryError: enum value expected";
                                case 0:
                                case 1:
                                case 50:
                                case 18:
                                case 7:
                                case 12:
                                case 15:
                                case 5:
                                case 3:
                                case 61:
                                case 62:
                                case 45:
                                case 2:
                                case 4:
                                case 36:
                                case 30:
                                case 14:
                                case 37:
                                case 55:
                                case 44:
                                case 41:
                                case 16:
                                case 13:
                                case 42:
                                case 29:
                                case 38:
                                case 57:
                                case 26:
                                case 22:
                                case 56:
                                case 35:
                                case 28:
                                case 54:
                                case 31:
                                case 40:
                                case 23:
                                case 24:
                                case 43:
                                case 48:
                                case 58:
                                case 49:
                                case 51:
                                case 53:
                                case 25:
                                case 8:
                                case 10:
                                case 21:
                                case 6:
                                case 34:
                                case 9:
                                case 47:
                                case 32:
                                case 11:
                                case 59:
                                    break;
                                }
                            }
                            if (message.mutateError != null && message.hasOwnProperty("mutateError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.mutateError) {
                                default:
                                    return "mutateError: enum value expected";
                                case 0:
                                case 1:
                                case 3:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                    break;
                                }
                            }
                            if (message.fieldMaskError != null && message.hasOwnProperty("fieldMaskError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.fieldMaskError) {
                                default:
                                    return "fieldMaskError: enum value expected";
                                case 0:
                                case 1:
                                case 5:
                                case 4:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.authorizationError != null && message.hasOwnProperty("authorizationError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.authorizationError) {
                                default:
                                    return "authorizationError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 24:
                                case 9:
                                case 10:
                                    break;
                                }
                            }
                            if (message.internalError != null && message.hasOwnProperty("internalError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.internalError) {
                                default:
                                    return "internalError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            }
                            if (message.quotaError != null && message.hasOwnProperty("quotaError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.quotaError) {
                                default:
                                    return "quotaError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            }
                            if (message.adError != null && message.hasOwnProperty("adError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.adError) {
                                default:
                                    return "adError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                case 32:
                                case 33:
                                case 34:
                                case 35:
                                case 36:
                                case 37:
                                case 38:
                                case 39:
                                case 40:
                                case 41:
                                case 42:
                                case 43:
                                case 44:
                                case 45:
                                case 47:
                                case 48:
                                case 49:
                                case 50:
                                case 51:
                                case 52:
                                case 53:
                                case 54:
                                case 55:
                                case 56:
                                case 57:
                                case 58:
                                case 59:
                                case 60:
                                case 61:
                                case 62:
                                case 63:
                                case 64:
                                case 65:
                                case 66:
                                case 67:
                                case 68:
                                case 69:
                                case 70:
                                case 71:
                                case 72:
                                case 73:
                                case 74:
                                case 75:
                                case 76:
                                case 77:
                                case 78:
                                case 79:
                                case 80:
                                case 81:
                                case 82:
                                case 83:
                                case 84:
                                case 85:
                                case 86:
                                case 87:
                                case 88:
                                case 89:
                                case 90:
                                case 91:
                                case 92:
                                case 93:
                                case 94:
                                case 95:
                                case 96:
                                case 97:
                                case 98:
                                case 99:
                                case 100:
                                case 102:
                                case 103:
                                case 104:
                                case 105:
                                case 106:
                                case 107:
                                case 108:
                                case 109:
                                case 110:
                                case 111:
                                case 112:
                                case 113:
                                case 114:
                                case 115:
                                case 116:
                                case 117:
                                case 118:
                                case 119:
                                case 120:
                                case 121:
                                case 122:
                                case 123:
                                case 124:
                                case 125:
                                case 126:
                                case 127:
                                case 128:
                                case 129:
                                case 130:
                                case 131:
                                case 132:
                                case 133:
                                    break;
                                }
                            }
                            if (message.adGroupError != null && message.hasOwnProperty("adGroupError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.adGroupError) {
                                default:
                                    return "adGroupError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                    break;
                                }
                            }
                            if (message.campaignBudgetError != null && message.hasOwnProperty("campaignBudgetError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.campaignBudgetError) {
                                default:
                                    return "campaignBudgetError: enum value expected";
                                case 0:
                                case 1:
                                case 17:
                                case 2:
                                case 3:
                                case 4:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                    break;
                                }
                            }
                            if (message.campaignError != null && message.hasOwnProperty("campaignError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.campaignError) {
                                default:
                                    return "campaignError: enum value expected";
                                case 0:
                                case 1:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                case 27:
                                case 30:
                                case 31:
                                case 32:
                                case 33:
                                case 34:
                                case 35:
                                case 36:
                                case 37:
                                case 38:
                                case 39:
                                case 40:
                                case 41:
                                    break;
                                }
                            }
                            if (message.authenticationError != null && message.hasOwnProperty("authenticationError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.authenticationError) {
                                default:
                                    return "authenticationError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 5:
                                case 8:
                                case 9:
                                case 10:
                                case 25:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 22:
                                case 23:
                                case 24:
                                    break;
                                }
                            }
                            if (message.adGroupCriterionError != null && message.hasOwnProperty("adGroupCriterionError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.adGroupCriterionError) {
                                default:
                                    return "adGroupCriterionError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                case 32:
                                case 33:
                                case 34:
                                case 35:
                                case 36:
                                case 37:
                                case 38:
                                case 39:
                                case 40:
                                case 41:
                                case 42:
                                case 43:
                                case 44:
                                case 45:
                                case 46:
                                case 47:
                                    break;
                                }
                            }
                            if (message.adCustomizerError != null && message.hasOwnProperty("adCustomizerError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.adCustomizerError) {
                                default:
                                    return "adCustomizerError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            }
                            if (message.adGroupAdError != null && message.hasOwnProperty("adGroupAdError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.adGroupAdError) {
                                default:
                                    return "adGroupAdError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                    break;
                                }
                            }
                            if (message.adSharingError != null && message.hasOwnProperty("adSharingError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.adSharingError) {
                                default:
                                    return "adSharingError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            }
                            if (message.adxError != null && message.hasOwnProperty("adxError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.adxError) {
                                default:
                                    return "adxError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            if (message.assetError != null && message.hasOwnProperty("assetError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.assetError) {
                                default:
                                    return "assetError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            }
                            if (message.biddingError != null && message.hasOwnProperty("biddingError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.biddingError) {
                                default:
                                    return "biddingError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 7:
                                case 10:
                                case 14:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                case 32:
                                case 33:
                                case 34:
                                case 35:
                                    break;
                                }
                            }
                            if (message.campaignCriterionError != null && message.hasOwnProperty("campaignCriterionError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.campaignCriterionError) {
                                default:
                                    return "campaignCriterionError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                    break;
                                }
                            }
                            if (message.collectionSizeError != null && message.hasOwnProperty("collectionSizeError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.collectionSizeError) {
                                default:
                                    return "collectionSizeError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.countryCodeError != null && message.hasOwnProperty("countryCodeError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.countryCodeError) {
                                default:
                                    return "countryCodeError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            if (message.criterionError != null && message.hasOwnProperty("criterionError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.criterionError) {
                                default:
                                    return "criterionError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                case 32:
                                case 33:
                                case 96:
                                case 97:
                                case 34:
                                case 35:
                                case 36:
                                case 37:
                                case 38:
                                case 39:
                                case 40:
                                case 41:
                                case 42:
                                case 43:
                                case 44:
                                case 45:
                                case 46:
                                case 47:
                                case 48:
                                case 49:
                                case 50:
                                case 51:
                                case 52:
                                case 53:
                                case 54:
                                case 55:
                                case 56:
                                case 57:
                                case 58:
                                case 59:
                                case 60:
                                case 61:
                                case 62:
                                case 63:
                                case 64:
                                case 65:
                                case 66:
                                case 67:
                                case 68:
                                case 69:
                                case 70:
                                case 71:
                                case 72:
                                case 73:
                                case 74:
                                case 75:
                                case 76:
                                case 77:
                                case 78:
                                case 79:
                                case 98:
                                case 80:
                                case 81:
                                case 82:
                                case 83:
                                case 84:
                                case 85:
                                case 86:
                                case 87:
                                case 88:
                                case 89:
                                case 90:
                                case 91:
                                case 92:
                                case 93:
                                case 94:
                                case 95:
                                    break;
                                }
                            }
                            if (message.customerError != null && message.hasOwnProperty("customerError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.customerError) {
                                default:
                                    return "customerError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.dateError != null && message.hasOwnProperty("dateError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.dateError) {
                                default:
                                    return "dateError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 6:
                                case 11:
                                case 12:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                    break;
                                }
                            }
                            if (message.dateRangeError != null && message.hasOwnProperty("dateRangeError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.dateRangeError) {
                                default:
                                    return "dateRangeError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            }
                            if (message.distinctError != null && message.hasOwnProperty("distinctError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.distinctError) {
                                default:
                                    return "distinctError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.feedAttributeReferenceError != null && message.hasOwnProperty("feedAttributeReferenceError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.feedAttributeReferenceError) {
                                default:
                                    return "feedAttributeReferenceError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            }
                            if (message.functionError != null && message.hasOwnProperty("functionError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.functionError) {
                                default:
                                    return "functionError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                    break;
                                }
                            }
                            if (message.functionParsingError != null && message.hasOwnProperty("functionParsingError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.functionParsingError) {
                                default:
                                    return "functionParsingError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                    break;
                                }
                            }
                            if (message.idError != null && message.hasOwnProperty("idError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.idError) {
                                default:
                                    return "idError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            if (message.imageError != null && message.hasOwnProperty("imageError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.imageError) {
                                default:
                                    return "imageError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                case 32:
                                case 33:
                                case 34:
                                case 35:
                                case 36:
                                case 37:
                                case 38:
                                    break;
                                }
                            }
                            if (message.languageCodeError != null && message.hasOwnProperty("languageCodeError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.languageCodeError) {
                                default:
                                    return "languageCodeError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.mediaBundleError != null && message.hasOwnProperty("mediaBundleError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.mediaBundleError) {
                                default:
                                    return "mediaBundleError: enum value expected";
                                case 0:
                                case 1:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                    break;
                                }
                            }
                            if (message.mediaUploadError != null && message.hasOwnProperty("mediaUploadError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.mediaUploadError) {
                                default:
                                    return "mediaUploadError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            }
                            if (message.mediaFileError != null && message.hasOwnProperty("mediaFileError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.mediaFileError) {
                                default:
                                    return "mediaFileError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                    break;
                                }
                            }
                            if (message.multiplierError != null && message.hasOwnProperty("multiplierError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.multiplierError) {
                                default:
                                    return "multiplierError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                    break;
                                }
                            }
                            if (message.newResourceCreationError != null && message.hasOwnProperty("newResourceCreationError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.newResourceCreationError) {
                                default:
                                    return "newResourceCreationError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            }
                            if (message.notEmptyError != null && message.hasOwnProperty("notEmptyError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.notEmptyError) {
                                default:
                                    return "notEmptyError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            if (message.nullError != null && message.hasOwnProperty("nullError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.nullError) {
                                default:
                                    return "nullError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            if (message.operatorError != null && message.hasOwnProperty("operatorError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.operatorError) {
                                default:
                                    return "operatorError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            if (message.rangeError != null && message.hasOwnProperty("rangeError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.rangeError) {
                                default:
                                    return "rangeError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.recommendationError != null && message.hasOwnProperty("recommendationError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.recommendationError) {
                                default:
                                    return "recommendationError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                    break;
                                }
                            }
                            if (message.regionCodeError != null && message.hasOwnProperty("regionCodeError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.regionCodeError) {
                                default:
                                    return "regionCodeError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            if (message.settingError != null && message.hasOwnProperty("settingError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.settingError) {
                                default:
                                    return "settingError: enum value expected";
                                case 0:
                                case 1:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                    break;
                                }
                            }
                            if (message.stringFormatError != null && message.hasOwnProperty("stringFormatError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.stringFormatError) {
                                default:
                                    return "stringFormatError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.stringLengthError != null && message.hasOwnProperty("stringLengthError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.stringLengthError) {
                                default:
                                    return "stringLengthError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.operationAccessDeniedError != null && message.hasOwnProperty("operationAccessDeniedError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.operationAccessDeniedError) {
                                default:
                                    return "operationAccessDeniedError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                    break;
                                }
                            }
                            if (message.resourceAccessDeniedError != null && message.hasOwnProperty("resourceAccessDeniedError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.resourceAccessDeniedError) {
                                default:
                                    return "resourceAccessDeniedError: enum value expected";
                                case 0:
                                case 1:
                                case 3:
                                    break;
                                }
                            }
                            if (message.resourceCountLimitExceededError != null && message.hasOwnProperty("resourceCountLimitExceededError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.resourceCountLimitExceededError) {
                                default:
                                    return "resourceCountLimitExceededError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                    break;
                                }
                            }
                            if (message.youtubeVideoRegistrationError != null && message.hasOwnProperty("youtubeVideoRegistrationError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.youtubeVideoRegistrationError) {
                                default:
                                    return "youtubeVideoRegistrationError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.adGroupBidModifierError != null && message.hasOwnProperty("adGroupBidModifierError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.adGroupBidModifierError) {
                                default:
                                    return "adGroupBidModifierError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.contextError != null && message.hasOwnProperty("contextError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.contextError) {
                                default:
                                    return "contextError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.fieldError != null && message.hasOwnProperty("fieldError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.fieldError) {
                                default:
                                    return "fieldError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                    break;
                                }
                            }
                            if (message.sharedSetError != null && message.hasOwnProperty("sharedSetError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.sharedSetError) {
                                default:
                                    return "sharedSetError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            }
                            if (message.sharedCriterionError != null && message.hasOwnProperty("sharedCriterionError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.sharedCriterionError) {
                                default:
                                    return "sharedCriterionError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            if (message.campaignSharedSetError != null && message.hasOwnProperty("campaignSharedSetError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.campaignSharedSetError) {
                                default:
                                    return "campaignSharedSetError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            if (message.conversionActionError != null && message.hasOwnProperty("conversionActionError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.conversionActionError) {
                                default:
                                    return "conversionActionError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                    break;
                                }
                            }
                            if (message.conversionAdjustmentUploadError != null && message.hasOwnProperty("conversionAdjustmentUploadError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.conversionAdjustmentUploadError) {
                                default:
                                    return "conversionAdjustmentUploadError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                    break;
                                }
                            }
                            if (message.conversionUploadError != null && message.hasOwnProperty("conversionUploadError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.conversionUploadError) {
                                default:
                                    return "conversionUploadError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                    break;
                                }
                            }
                            if (message.headerError != null && message.hasOwnProperty("headerError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.headerError) {
                                default:
                                    return "headerError: enum value expected";
                                case 0:
                                case 1:
                                case 3:
                                    break;
                                }
                            }
                            if (message.databaseError != null && message.hasOwnProperty("databaseError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.databaseError) {
                                default:
                                    return "databaseError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            if (message.policyFindingError != null && message.hasOwnProperty("policyFindingError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.policyFindingError) {
                                default:
                                    return "policyFindingError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.enumError != null && message.hasOwnProperty("enumError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.enumError) {
                                default:
                                    return "enumError: enum value expected";
                                case 0:
                                case 1:
                                case 3:
                                    break;
                                }
                            }
                            if (message.keywordPlanError != null && message.hasOwnProperty("keywordPlanError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.keywordPlanError) {
                                default:
                                    return "keywordPlanError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                    break;
                                }
                            }
                            if (message.keywordPlanCampaignError != null && message.hasOwnProperty("keywordPlanCampaignError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.keywordPlanCampaignError) {
                                default:
                                    return "keywordPlanCampaignError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            }
                            if (message.keywordPlanNegativeKeywordError != null && message.hasOwnProperty("keywordPlanNegativeKeywordError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.keywordPlanNegativeKeywordError) {
                                default:
                                    return "keywordPlanNegativeKeywordError: enum value expected";
                                case 0:
                                case 1:
                                    break;
                                }
                            }
                            if (message.keywordPlanAdGroupError != null && message.hasOwnProperty("keywordPlanAdGroupError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.keywordPlanAdGroupError) {
                                default:
                                    return "keywordPlanAdGroupError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.keywordPlanKeywordError != null && message.hasOwnProperty("keywordPlanKeywordError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.keywordPlanKeywordError) {
                                default:
                                    return "keywordPlanKeywordError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            }
                            if (message.keywordPlanIdeaError != null && message.hasOwnProperty("keywordPlanIdeaError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.keywordPlanIdeaError) {
                                default:
                                    return "keywordPlanIdeaError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.accountBudgetProposalError != null && message.hasOwnProperty("accountBudgetProposalError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.accountBudgetProposalError) {
                                default:
                                    return "accountBudgetProposalError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                    break;
                                }
                            }
                            if (message.userListError != null && message.hasOwnProperty("userListError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.userListError) {
                                default:
                                    return "userListError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                case 32:
                                case 33:
                                case 34:
                                case 35:
                                case 36:
                                    break;
                                }
                            }
                            if (message.changeStatusError != null && message.hasOwnProperty("changeStatusError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.changeStatusError) {
                                default:
                                    return "changeStatusError: enum value expected";
                                case 0:
                                case 1:
                                case 3:
                                    break;
                                }
                            }
                            if (message.feedError != null && message.hasOwnProperty("feedError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.feedError) {
                                default:
                                    return "feedError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                    break;
                                }
                            }
                            if (message.geoTargetConstantSuggestionError != null && message.hasOwnProperty("geoTargetConstantSuggestionError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.geoTargetConstantSuggestionError) {
                                default:
                                    return "geoTargetConstantSuggestionError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            }
                            if (message.feedItemError != null && message.hasOwnProperty("feedItemError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.feedItemError) {
                                default:
                                    return "feedItemError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                    break;
                                }
                            }
                            if (message.labelError != null && message.hasOwnProperty("labelError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.labelError) {
                                default:
                                    return "labelError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                    break;
                                }
                            }
                            if (message.billingSetupError != null && message.hasOwnProperty("billingSetupError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.billingSetupError) {
                                default:
                                    return "billingSetupError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                    break;
                                }
                            }
                            if (message.customerClientLinkError != null && message.hasOwnProperty("customerClientLinkError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.customerClientLinkError) {
                                default:
                                    return "customerClientLinkError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                    break;
                                }
                            }
                            if (message.customerManagerLinkError != null && message.hasOwnProperty("customerManagerLinkError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.customerManagerLinkError) {
                                default:
                                    return "customerManagerLinkError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                    break;
                                }
                            }
                            if (message.feedMappingError != null && message.hasOwnProperty("feedMappingError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.feedMappingError) {
                                default:
                                    return "feedMappingError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                    break;
                                }
                            }
                            if (message.customerFeedError != null && message.hasOwnProperty("customerFeedError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.customerFeedError) {
                                default:
                                    return "customerFeedError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                    break;
                                }
                            }
                            if (message.adGroupFeedError != null && message.hasOwnProperty("adGroupFeedError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.adGroupFeedError) {
                                default:
                                    return "adGroupFeedError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                    break;
                                }
                            }
                            if (message.campaignFeedError != null && message.hasOwnProperty("campaignFeedError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.campaignFeedError) {
                                default:
                                    return "campaignFeedError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                    break;
                                }
                            }
                            if (message.customInterestError != null && message.hasOwnProperty("customInterestError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.customInterestError) {
                                default:
                                    return "customInterestError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                    break;
                                }
                            }
                            if (message.extensionFeedItemError != null && message.hasOwnProperty("extensionFeedItemError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.extensionFeedItemError) {
                                default:
                                    return "extensionFeedItemError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                case 32:
                                case 33:
                                case 34:
                                case 35:
                                case 36:
                                case 37:
                                case 38:
                                case 39:
                                case 40:
                                case 41:
                                case 42:
                                case 43:
                                case 44:
                                    break;
                                }
                            }
                            if (message.adParameterError != null && message.hasOwnProperty("adParameterError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.adParameterError) {
                                default:
                                    return "adParameterError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.feedItemValidationError != null && message.hasOwnProperty("feedItemValidationError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.feedItemValidationError) {
                                default:
                                    return "feedItemValidationError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                case 32:
                                case 33:
                                case 34:
                                case 35:
                                case 36:
                                case 37:
                                case 38:
                                case 39:
                                case 40:
                                case 41:
                                case 42:
                                case 43:
                                case 44:
                                case 45:
                                case 46:
                                case 47:
                                case 48:
                                case 49:
                                case 50:
                                case 51:
                                case 52:
                                case 53:
                                case 54:
                                case 55:
                                case 56:
                                case 57:
                                case 58:
                                case 59:
                                case 60:
                                case 61:
                                case 62:
                                case 63:
                                case 64:
                                case 65:
                                case 66:
                                case 67:
                                case 68:
                                case 69:
                                case 70:
                                case 71:
                                case 72:
                                case 73:
                                case 74:
                                case 75:
                                case 76:
                                case 77:
                                case 78:
                                case 79:
                                case 80:
                                case 81:
                                case 82:
                                case 83:
                                case 84:
                                case 85:
                                case 86:
                                case 87:
                                case 88:
                                case 89:
                                case 90:
                                case 91:
                                case 92:
                                case 93:
                                case 94:
                                case 95:
                                case 96:
                                    break;
                                }
                            }
                            if (message.extensionSettingError != null && message.hasOwnProperty("extensionSettingError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.extensionSettingError) {
                                default:
                                    return "extensionSettingError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                case 32:
                                case 33:
                                case 34:
                                case 35:
                                case 36:
                                case 37:
                                case 38:
                                case 39:
                                case 40:
                                case 41:
                                case 42:
                                case 43:
                                case 45:
                                case 47:
                                case 48:
                                case 49:
                                case 50:
                                case 51:
                                case 52:
                                case 53:
                                case 54:
                                case 55:
                                case 56:
                                case 57:
                                case 58:
                                case 59:
                                case 60:
                                case 61:
                                case 62:
                                case 63:
                                case 64:
                                case 65:
                                case 66:
                                case 67:
                                    break;
                                }
                            }
                            if (message.feedItemTargetError != null && message.hasOwnProperty("feedItemTargetError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.feedItemTargetError) {
                                default:
                                    return "feedItemTargetError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            }
                            if (message.policyViolationError != null && message.hasOwnProperty("policyViolationError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.policyViolationError) {
                                default:
                                    return "policyViolationError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            if (message.mutateJobError != null && message.hasOwnProperty("mutateJobError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.mutateJobError) {
                                default:
                                    return "mutateJobError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.partialFailureError) {
                                default:
                                    return "partialFailureError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            if (message.policyValidationParameterError != null && message.hasOwnProperty("policyValidationParameterError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.policyValidationParameterError) {
                                default:
                                    return "policyValidationParameterError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            }
                            if (message.sizeLimitError != null && message.hasOwnProperty("sizeLimitError")) {
                                if (properties.errorCode === 1)
                                    return "errorCode: multiple values";
                                properties.errorCode = 1;
                                switch (message.sizeLimitError) {
                                default:
                                    return "sizeLimitError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an ErrorCode message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.ErrorCode} ErrorCode
                         */
                        ErrorCode.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.ErrorCode)
                                return object;
                            var message = new $root.google.ads.googleads.v1.errors.ErrorCode();
                            switch (object.requestError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.requestError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.requestError = 1;
                                break;
                            case "RESOURCE_NAME_MISSING":
                            case 3:
                                message.requestError = 3;
                                break;
                            case "RESOURCE_NAME_MALFORMED":
                            case 4:
                                message.requestError = 4;
                                break;
                            case "BAD_RESOURCE_ID":
                            case 17:
                                message.requestError = 17;
                                break;
                            case "INVALID_CUSTOMER_ID":
                            case 16:
                                message.requestError = 16;
                                break;
                            case "OPERATION_REQUIRED":
                            case 5:
                                message.requestError = 5;
                                break;
                            case "RESOURCE_NOT_FOUND":
                            case 6:
                                message.requestError = 6;
                                break;
                            case "INVALID_PAGE_TOKEN":
                            case 7:
                                message.requestError = 7;
                                break;
                            case "EXPIRED_PAGE_TOKEN":
                            case 8:
                                message.requestError = 8;
                                break;
                            case "INVALID_PAGE_SIZE":
                            case 22:
                                message.requestError = 22;
                                break;
                            case "REQUIRED_FIELD_MISSING":
                            case 9:
                                message.requestError = 9;
                                break;
                            case "IMMUTABLE_FIELD":
                            case 11:
                                message.requestError = 11;
                                break;
                            case "TOO_MANY_MUTATE_OPERATIONS":
                            case 13:
                                message.requestError = 13;
                                break;
                            case "CANNOT_BE_EXECUTED_BY_MANAGER_ACCOUNT":
                            case 14:
                                message.requestError = 14;
                                break;
                            case "CANNOT_MODIFY_FOREIGN_FIELD":
                            case 15:
                                message.requestError = 15;
                                break;
                            case "INVALID_ENUM_VALUE":
                            case 18:
                                message.requestError = 18;
                                break;
                            case "DEVELOPER_TOKEN_PARAMETER_MISSING":
                            case 19:
                                message.requestError = 19;
                                break;
                            case "LOGIN_CUSTOMER_ID_PARAMETER_MISSING":
                            case 20:
                                message.requestError = 20;
                                break;
                            case "VALIDATE_ONLY_REQUEST_HAS_PAGE_TOKEN":
                            case 21:
                                message.requestError = 21;
                                break;
                            }
                            switch (object.biddingStrategyError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.biddingStrategyError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.biddingStrategyError = 1;
                                break;
                            case "DUPLICATE_NAME":
                            case 2:
                                message.biddingStrategyError = 2;
                                break;
                            case "CANNOT_CHANGE_BIDDING_STRATEGY_TYPE":
                            case 3:
                                message.biddingStrategyError = 3;
                                break;
                            case "CANNOT_REMOVE_ASSOCIATED_STRATEGY":
                            case 4:
                                message.biddingStrategyError = 4;
                                break;
                            case "BIDDING_STRATEGY_NOT_SUPPORTED":
                            case 5:
                                message.biddingStrategyError = 5;
                                break;
                            case "INCOMPATIBLE_BIDDING_STRATEGY_AND_BIDDING_STRATEGY_GOAL_TYPE":
                            case 6:
                                message.biddingStrategyError = 6;
                                break;
                            }
                            switch (object.urlFieldError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.urlFieldError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.urlFieldError = 1;
                                break;
                            case "INVALID_TRACKING_URL_TEMPLATE":
                            case 2:
                                message.urlFieldError = 2;
                                break;
                            case "INVALID_TAG_IN_TRACKING_URL_TEMPLATE":
                            case 3:
                                message.urlFieldError = 3;
                                break;
                            case "MISSING_TRACKING_URL_TEMPLATE_TAG":
                            case 4:
                                message.urlFieldError = 4;
                                break;
                            case "MISSING_PROTOCOL_IN_TRACKING_URL_TEMPLATE":
                            case 5:
                                message.urlFieldError = 5;
                                break;
                            case "INVALID_PROTOCOL_IN_TRACKING_URL_TEMPLATE":
                            case 6:
                                message.urlFieldError = 6;
                                break;
                            case "MALFORMED_TRACKING_URL_TEMPLATE":
                            case 7:
                                message.urlFieldError = 7;
                                break;
                            case "MISSING_HOST_IN_TRACKING_URL_TEMPLATE":
                            case 8:
                                message.urlFieldError = 8;
                                break;
                            case "INVALID_TLD_IN_TRACKING_URL_TEMPLATE":
                            case 9:
                                message.urlFieldError = 9;
                                break;
                            case "REDUNDANT_NESTED_TRACKING_URL_TEMPLATE_TAG":
                            case 10:
                                message.urlFieldError = 10;
                                break;
                            case "INVALID_FINAL_URL":
                            case 11:
                                message.urlFieldError = 11;
                                break;
                            case "INVALID_TAG_IN_FINAL_URL":
                            case 12:
                                message.urlFieldError = 12;
                                break;
                            case "REDUNDANT_NESTED_FINAL_URL_TAG":
                            case 13:
                                message.urlFieldError = 13;
                                break;
                            case "MISSING_PROTOCOL_IN_FINAL_URL":
                            case 14:
                                message.urlFieldError = 14;
                                break;
                            case "INVALID_PROTOCOL_IN_FINAL_URL":
                            case 15:
                                message.urlFieldError = 15;
                                break;
                            case "MALFORMED_FINAL_URL":
                            case 16:
                                message.urlFieldError = 16;
                                break;
                            case "MISSING_HOST_IN_FINAL_URL":
                            case 17:
                                message.urlFieldError = 17;
                                break;
                            case "INVALID_TLD_IN_FINAL_URL":
                            case 18:
                                message.urlFieldError = 18;
                                break;
                            case "INVALID_FINAL_MOBILE_URL":
                            case 19:
                                message.urlFieldError = 19;
                                break;
                            case "INVALID_TAG_IN_FINAL_MOBILE_URL":
                            case 20:
                                message.urlFieldError = 20;
                                break;
                            case "REDUNDANT_NESTED_FINAL_MOBILE_URL_TAG":
                            case 21:
                                message.urlFieldError = 21;
                                break;
                            case "MISSING_PROTOCOL_IN_FINAL_MOBILE_URL":
                            case 22:
                                message.urlFieldError = 22;
                                break;
                            case "INVALID_PROTOCOL_IN_FINAL_MOBILE_URL":
                            case 23:
                                message.urlFieldError = 23;
                                break;
                            case "MALFORMED_FINAL_MOBILE_URL":
                            case 24:
                                message.urlFieldError = 24;
                                break;
                            case "MISSING_HOST_IN_FINAL_MOBILE_URL":
                            case 25:
                                message.urlFieldError = 25;
                                break;
                            case "INVALID_TLD_IN_FINAL_MOBILE_URL":
                            case 26:
                                message.urlFieldError = 26;
                                break;
                            case "INVALID_FINAL_APP_URL":
                            case 27:
                                message.urlFieldError = 27;
                                break;
                            case "INVALID_TAG_IN_FINAL_APP_URL":
                            case 28:
                                message.urlFieldError = 28;
                                break;
                            case "REDUNDANT_NESTED_FINAL_APP_URL_TAG":
                            case 29:
                                message.urlFieldError = 29;
                                break;
                            case "MULTIPLE_APP_URLS_FOR_OSTYPE":
                            case 30:
                                message.urlFieldError = 30;
                                break;
                            case "INVALID_OSTYPE":
                            case 31:
                                message.urlFieldError = 31;
                                break;
                            case "INVALID_PROTOCOL_FOR_APP_URL":
                            case 32:
                                message.urlFieldError = 32;
                                break;
                            case "INVALID_PACKAGE_ID_FOR_APP_URL":
                            case 33:
                                message.urlFieldError = 33;
                                break;
                            case "URL_CUSTOM_PARAMETERS_COUNT_EXCEEDS_LIMIT":
                            case 34:
                                message.urlFieldError = 34;
                                break;
                            case "INVALID_CHARACTERS_IN_URL_CUSTOM_PARAMETER_KEY":
                            case 39:
                                message.urlFieldError = 39;
                                break;
                            case "INVALID_CHARACTERS_IN_URL_CUSTOM_PARAMETER_VALUE":
                            case 40:
                                message.urlFieldError = 40;
                                break;
                            case "INVALID_TAG_IN_URL_CUSTOM_PARAMETER_VALUE":
                            case 41:
                                message.urlFieldError = 41;
                                break;
                            case "REDUNDANT_NESTED_URL_CUSTOM_PARAMETER_TAG":
                            case 42:
                                message.urlFieldError = 42;
                                break;
                            case "MISSING_PROTOCOL":
                            case 43:
                                message.urlFieldError = 43;
                                break;
                            case "INVALID_PROTOCOL":
                            case 52:
                                message.urlFieldError = 52;
                                break;
                            case "INVALID_URL":
                            case 44:
                                message.urlFieldError = 44;
                                break;
                            case "DESTINATION_URL_DEPRECATED":
                            case 45:
                                message.urlFieldError = 45;
                                break;
                            case "INVALID_TAG_IN_URL":
                            case 46:
                                message.urlFieldError = 46;
                                break;
                            case "MISSING_URL_TAG":
                            case 47:
                                message.urlFieldError = 47;
                                break;
                            case "DUPLICATE_URL_ID":
                            case 48:
                                message.urlFieldError = 48;
                                break;
                            case "INVALID_URL_ID":
                            case 49:
                                message.urlFieldError = 49;
                                break;
                            case "FINAL_URL_SUFFIX_MALFORMED":
                            case 50:
                                message.urlFieldError = 50;
                                break;
                            case "INVALID_TAG_IN_FINAL_URL_SUFFIX":
                            case 51:
                                message.urlFieldError = 51;
                                break;
                            case "INVALID_TOP_LEVEL_DOMAIN":
                            case 53:
                                message.urlFieldError = 53;
                                break;
                            case "MALFORMED_TOP_LEVEL_DOMAIN":
                            case 54:
                                message.urlFieldError = 54;
                                break;
                            case "MALFORMED_URL":
                            case 55:
                                message.urlFieldError = 55;
                                break;
                            case "MISSING_HOST":
                            case 56:
                                message.urlFieldError = 56;
                                break;
                            }
                            switch (object.listOperationError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.listOperationError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.listOperationError = 1;
                                break;
                            case "REQUIRED_FIELD_MISSING":
                            case 7:
                                message.listOperationError = 7;
                                break;
                            case "DUPLICATE_VALUES":
                            case 8:
                                message.listOperationError = 8;
                                break;
                            }
                            switch (object.queryError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.queryError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.queryError = 1;
                                break;
                            case "QUERY_ERROR":
                            case 50:
                                message.queryError = 50;
                                break;
                            case "BAD_ENUM_CONSTANT":
                            case 18:
                                message.queryError = 18;
                                break;
                            case "BAD_ESCAPE_SEQUENCE":
                            case 7:
                                message.queryError = 7;
                                break;
                            case "BAD_FIELD_NAME":
                            case 12:
                                message.queryError = 12;
                                break;
                            case "BAD_LIMIT_VALUE":
                            case 15:
                                message.queryError = 15;
                                break;
                            case "BAD_NUMBER":
                            case 5:
                                message.queryError = 5;
                                break;
                            case "BAD_OPERATOR":
                            case 3:
                                message.queryError = 3;
                                break;
                            case "BAD_PARAMETER_NAME":
                            case 61:
                                message.queryError = 61;
                                break;
                            case "BAD_PARAMETER_VALUE":
                            case 62:
                                message.queryError = 62;
                                break;
                            case "BAD_RESOURCE_TYPE_IN_FROM_CLAUSE":
                            case 45:
                                message.queryError = 45;
                                break;
                            case "BAD_SYMBOL":
                            case 2:
                                message.queryError = 2;
                                break;
                            case "BAD_VALUE":
                            case 4:
                                message.queryError = 4;
                                break;
                            case "DATE_RANGE_TOO_WIDE":
                            case 36:
                                message.queryError = 36;
                                break;
                            case "EXPECTED_AND":
                            case 30:
                                message.queryError = 30;
                                break;
                            case "EXPECTED_BY":
                            case 14:
                                message.queryError = 14;
                                break;
                            case "EXPECTED_DIMENSION_FIELD_IN_SELECT_CLAUSE":
                            case 37:
                                message.queryError = 37;
                                break;
                            case "EXPECTED_FILTERS_ON_DATE_RANGE":
                            case 55:
                                message.queryError = 55;
                                break;
                            case "EXPECTED_FROM":
                            case 44:
                                message.queryError = 44;
                                break;
                            case "EXPECTED_LIST":
                            case 41:
                                message.queryError = 41;
                                break;
                            case "EXPECTED_REFERENCED_FIELD_IN_SELECT_CLAUSE":
                            case 16:
                                message.queryError = 16;
                                break;
                            case "EXPECTED_SELECT":
                            case 13:
                                message.queryError = 13;
                                break;
                            case "EXPECTED_SINGLE_VALUE":
                            case 42:
                                message.queryError = 42;
                                break;
                            case "EXPECTED_VALUE_WITH_BETWEEN_OPERATOR":
                            case 29:
                                message.queryError = 29;
                                break;
                            case "INVALID_DATE_FORMAT":
                            case 38:
                                message.queryError = 38;
                                break;
                            case "INVALID_STRING_VALUE":
                            case 57:
                                message.queryError = 57;
                                break;
                            case "INVALID_VALUE_WITH_BETWEEN_OPERATOR":
                            case 26:
                                message.queryError = 26;
                                break;
                            case "INVALID_VALUE_WITH_DURING_OPERATOR":
                            case 22:
                                message.queryError = 22;
                                break;
                            case "INVALID_VALUE_WITH_LIKE_OPERATOR":
                            case 56:
                                message.queryError = 56;
                                break;
                            case "OPERATOR_FIELD_MISMATCH":
                            case 35:
                                message.queryError = 35;
                                break;
                            case "PROHIBITED_EMPTY_LIST_IN_CONDITION":
                            case 28:
                                message.queryError = 28;
                                break;
                            case "PROHIBITED_ENUM_CONSTANT":
                            case 54:
                                message.queryError = 54;
                                break;
                            case "PROHIBITED_FIELD_COMBINATION_IN_SELECT_CLAUSE":
                            case 31:
                                message.queryError = 31;
                                break;
                            case "PROHIBITED_FIELD_IN_ORDER_BY_CLAUSE":
                            case 40:
                                message.queryError = 40;
                                break;
                            case "PROHIBITED_FIELD_IN_SELECT_CLAUSE":
                            case 23:
                                message.queryError = 23;
                                break;
                            case "PROHIBITED_FIELD_IN_WHERE_CLAUSE":
                            case 24:
                                message.queryError = 24;
                                break;
                            case "PROHIBITED_RESOURCE_TYPE_IN_FROM_CLAUSE":
                            case 43:
                                message.queryError = 43;
                                break;
                            case "PROHIBITED_RESOURCE_TYPE_IN_SELECT_CLAUSE":
                            case 48:
                                message.queryError = 48;
                                break;
                            case "PROHIBITED_RESOURCE_TYPE_IN_WHERE_CLAUSE":
                            case 58:
                                message.queryError = 58;
                                break;
                            case "PROHIBITED_METRIC_IN_SELECT_OR_WHERE_CLAUSE":
                            case 49:
                                message.queryError = 49;
                                break;
                            case "PROHIBITED_SEGMENT_IN_SELECT_OR_WHERE_CLAUSE":
                            case 51:
                                message.queryError = 51;
                                break;
                            case "PROHIBITED_SEGMENT_WITH_METRIC_IN_SELECT_OR_WHERE_CLAUSE":
                            case 53:
                                message.queryError = 53;
                                break;
                            case "LIMIT_VALUE_TOO_LOW":
                            case 25:
                                message.queryError = 25;
                                break;
                            case "PROHIBITED_NEWLINE_IN_STRING":
                            case 8:
                                message.queryError = 8;
                                break;
                            case "PROHIBITED_VALUE_COMBINATION_IN_LIST":
                            case 10:
                                message.queryError = 10;
                                break;
                            case "PROHIBITED_VALUE_COMBINATION_WITH_BETWEEN_OPERATOR":
                            case 21:
                                message.queryError = 21;
                                break;
                            case "STRING_NOT_TERMINATED":
                            case 6:
                                message.queryError = 6;
                                break;
                            case "TOO_MANY_SEGMENTS":
                            case 34:
                                message.queryError = 34;
                                break;
                            case "UNEXPECTED_END_OF_QUERY":
                            case 9:
                                message.queryError = 9;
                                break;
                            case "UNEXPECTED_FROM_CLAUSE":
                            case 47:
                                message.queryError = 47;
                                break;
                            case "UNRECOGNIZED_FIELD":
                            case 32:
                                message.queryError = 32;
                                break;
                            case "UNEXPECTED_INPUT":
                            case 11:
                                message.queryError = 11;
                                break;
                            case "REQUESTED_METRICS_FOR_MANAGER":
                            case 59:
                                message.queryError = 59;
                                break;
                            }
                            switch (object.mutateError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.mutateError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.mutateError = 1;
                                break;
                            case "RESOURCE_NOT_FOUND":
                            case 3:
                                message.mutateError = 3;
                                break;
                            case "ID_EXISTS_IN_MULTIPLE_MUTATES":
                            case 7:
                                message.mutateError = 7;
                                break;
                            case "INCONSISTENT_FIELD_VALUES":
                            case 8:
                                message.mutateError = 8;
                                break;
                            case "MUTATE_NOT_ALLOWED":
                            case 9:
                                message.mutateError = 9;
                                break;
                            case "RESOURCE_NOT_IN_GOOGLE_ADS":
                            case 10:
                                message.mutateError = 10;
                                break;
                            case "RESOURCE_ALREADY_EXISTS":
                            case 11:
                                message.mutateError = 11;
                                break;
                            }
                            switch (object.fieldMaskError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.fieldMaskError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.fieldMaskError = 1;
                                break;
                            case "FIELD_MASK_MISSING":
                            case 5:
                                message.fieldMaskError = 5;
                                break;
                            case "FIELD_MASK_NOT_ALLOWED":
                            case 4:
                                message.fieldMaskError = 4;
                                break;
                            case "FIELD_NOT_FOUND":
                            case 2:
                                message.fieldMaskError = 2;
                                break;
                            case "FIELD_HAS_SUBFIELDS":
                            case 3:
                                message.fieldMaskError = 3;
                                break;
                            }
                            switch (object.authorizationError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.authorizationError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.authorizationError = 1;
                                break;
                            case "USER_PERMISSION_DENIED":
                            case 2:
                                message.authorizationError = 2;
                                break;
                            case "DEVELOPER_TOKEN_NOT_WHITELISTED":
                            case 3:
                                message.authorizationError = 3;
                                break;
                            case "DEVELOPER_TOKEN_PROHIBITED":
                            case 4:
                                message.authorizationError = 4;
                                break;
                            case "PROJECT_DISABLED":
                            case 5:
                                message.authorizationError = 5;
                                break;
                            case "AUTHORIZATION_ERROR":
                            case 6:
                                message.authorizationError = 6;
                                break;
                            case "ACTION_NOT_PERMITTED":
                            case 7:
                                message.authorizationError = 7;
                                break;
                            case "INCOMPLETE_SIGNUP":
                            case 8:
                                message.authorizationError = 8;
                                break;
                            case "CUSTOMER_NOT_ENABLED":
                            case 24:
                                message.authorizationError = 24;
                                break;
                            case "MISSING_TOS":
                            case 9:
                                message.authorizationError = 9;
                                break;
                            case "DEVELOPER_TOKEN_NOT_APPROVED":
                            case 10:
                                message.authorizationError = 10;
                                break;
                            }
                            switch (object.internalError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.internalError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.internalError = 1;
                                break;
                            case "INTERNAL_ERROR":
                            case 2:
                                message.internalError = 2;
                                break;
                            case "ERROR_CODE_NOT_PUBLISHED":
                            case 3:
                                message.internalError = 3;
                                break;
                            case "TRANSIENT_ERROR":
                            case 4:
                                message.internalError = 4;
                                break;
                            }
                            switch (object.quotaError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.quotaError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.quotaError = 1;
                                break;
                            case "RESOURCE_EXHAUSTED":
                            case 2:
                                message.quotaError = 2;
                                break;
                            case "ACCESS_PROHIBITED":
                            case 3:
                                message.quotaError = 3;
                                break;
                            case "RESOURCE_TEMPORARILY_EXHAUSTED":
                            case 4:
                                message.quotaError = 4;
                                break;
                            }
                            switch (object.adError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.adError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.adError = 1;
                                break;
                            case "AD_CUSTOMIZERS_NOT_SUPPORTED_FOR_AD_TYPE":
                            case 2:
                                message.adError = 2;
                                break;
                            case "APPROXIMATELY_TOO_LONG":
                            case 3:
                                message.adError = 3;
                                break;
                            case "APPROXIMATELY_TOO_SHORT":
                            case 4:
                                message.adError = 4;
                                break;
                            case "BAD_SNIPPET":
                            case 5:
                                message.adError = 5;
                                break;
                            case "CANNOT_MODIFY_AD":
                            case 6:
                                message.adError = 6;
                                break;
                            case "CANNOT_SET_BUSINESS_NAME_IF_URL_SET":
                            case 7:
                                message.adError = 7;
                                break;
                            case "CANNOT_SET_FIELD":
                            case 8:
                                message.adError = 8;
                                break;
                            case "CANNOT_SET_FIELD_WITH_ORIGIN_AD_ID_SET":
                            case 9:
                                message.adError = 9;
                                break;
                            case "CANNOT_SET_FIELD_WITH_AD_ID_SET_FOR_SHARING":
                            case 10:
                                message.adError = 10;
                                break;
                            case "CANNOT_SET_ALLOW_FLEXIBLE_COLOR_FALSE":
                            case 11:
                                message.adError = 11;
                                break;
                            case "CANNOT_SET_COLOR_CONTROL_WHEN_NATIVE_FORMAT_SETTING":
                            case 12:
                                message.adError = 12;
                                break;
                            case "CANNOT_SET_URL":
                            case 13:
                                message.adError = 13;
                                break;
                            case "CANNOT_SET_WITHOUT_FINAL_URLS":
                            case 14:
                                message.adError = 14;
                                break;
                            case "CANNOT_SET_WITH_FINAL_URLS":
                            case 15:
                                message.adError = 15;
                                break;
                            case "CANNOT_SET_WITH_URL_DATA":
                            case 17:
                                message.adError = 17;
                                break;
                            case "CANNOT_USE_AD_SUBCLASS_FOR_OPERATOR":
                            case 18:
                                message.adError = 18;
                                break;
                            case "CUSTOMER_NOT_APPROVED_MOBILEADS":
                            case 19:
                                message.adError = 19;
                                break;
                            case "CUSTOMER_NOT_APPROVED_THIRDPARTY_ADS":
                            case 20:
                                message.adError = 20;
                                break;
                            case "CUSTOMER_NOT_APPROVED_THIRDPARTY_REDIRECT_ADS":
                            case 21:
                                message.adError = 21;
                                break;
                            case "CUSTOMER_NOT_ELIGIBLE":
                            case 22:
                                message.adError = 22;
                                break;
                            case "CUSTOMER_NOT_ELIGIBLE_FOR_UPDATING_BEACON_URL":
                            case 23:
                                message.adError = 23;
                                break;
                            case "DIMENSION_ALREADY_IN_UNION":
                            case 24:
                                message.adError = 24;
                                break;
                            case "DIMENSION_MUST_BE_SET":
                            case 25:
                                message.adError = 25;
                                break;
                            case "DIMENSION_NOT_IN_UNION":
                            case 26:
                                message.adError = 26;
                                break;
                            case "DISPLAY_URL_CANNOT_BE_SPECIFIED":
                            case 27:
                                message.adError = 27;
                                break;
                            case "DOMESTIC_PHONE_NUMBER_FORMAT":
                            case 28:
                                message.adError = 28;
                                break;
                            case "EMERGENCY_PHONE_NUMBER":
                            case 29:
                                message.adError = 29;
                                break;
                            case "EMPTY_FIELD":
                            case 30:
                                message.adError = 30;
                                break;
                            case "FEED_ATTRIBUTE_MUST_HAVE_MAPPING_FOR_TYPE_ID":
                            case 31:
                                message.adError = 31;
                                break;
                            case "FEED_ATTRIBUTE_MAPPING_TYPE_MISMATCH":
                            case 32:
                                message.adError = 32;
                                break;
                            case "ILLEGAL_AD_CUSTOMIZER_TAG_USE":
                            case 33:
                                message.adError = 33;
                                break;
                            case "ILLEGAL_TAG_USE":
                            case 34:
                                message.adError = 34;
                                break;
                            case "INCONSISTENT_DIMENSIONS":
                            case 35:
                                message.adError = 35;
                                break;
                            case "INCONSISTENT_STATUS_IN_TEMPLATE_UNION":
                            case 36:
                                message.adError = 36;
                                break;
                            case "INCORRECT_LENGTH":
                            case 37:
                                message.adError = 37;
                                break;
                            case "INELIGIBLE_FOR_UPGRADE":
                            case 38:
                                message.adError = 38;
                                break;
                            case "INVALID_AD_ADDRESS_CAMPAIGN_TARGET":
                            case 39:
                                message.adError = 39;
                                break;
                            case "INVALID_AD_TYPE":
                            case 40:
                                message.adError = 40;
                                break;
                            case "INVALID_ATTRIBUTES_FOR_MOBILE_IMAGE":
                            case 41:
                                message.adError = 41;
                                break;
                            case "INVALID_ATTRIBUTES_FOR_MOBILE_TEXT":
                            case 42:
                                message.adError = 42;
                                break;
                            case "INVALID_CALL_TO_ACTION_TEXT":
                            case 43:
                                message.adError = 43;
                                break;
                            case "INVALID_CHARACTER_FOR_URL":
                            case 44:
                                message.adError = 44;
                                break;
                            case "INVALID_COUNTRY_CODE":
                            case 45:
                                message.adError = 45;
                                break;
                            case "INVALID_EXPANDED_DYNAMIC_SEARCH_AD_TAG":
                            case 47:
                                message.adError = 47;
                                break;
                            case "INVALID_INPUT":
                            case 48:
                                message.adError = 48;
                                break;
                            case "INVALID_MARKUP_LANGUAGE":
                            case 49:
                                message.adError = 49;
                                break;
                            case "INVALID_MOBILE_CARRIER":
                            case 50:
                                message.adError = 50;
                                break;
                            case "INVALID_MOBILE_CARRIER_TARGET":
                            case 51:
                                message.adError = 51;
                                break;
                            case "INVALID_NUMBER_OF_ELEMENTS":
                            case 52:
                                message.adError = 52;
                                break;
                            case "INVALID_PHONE_NUMBER_FORMAT":
                            case 53:
                                message.adError = 53;
                                break;
                            case "INVALID_RICH_MEDIA_CERTIFIED_VENDOR_FORMAT_ID":
                            case 54:
                                message.adError = 54;
                                break;
                            case "INVALID_TEMPLATE_DATA":
                            case 55:
                                message.adError = 55;
                                break;
                            case "INVALID_TEMPLATE_ELEMENT_FIELD_TYPE":
                            case 56:
                                message.adError = 56;
                                break;
                            case "INVALID_TEMPLATE_ID":
                            case 57:
                                message.adError = 57;
                                break;
                            case "LINE_TOO_WIDE":
                            case 58:
                                message.adError = 58;
                                break;
                            case "MISSING_AD_CUSTOMIZER_MAPPING":
                            case 59:
                                message.adError = 59;
                                break;
                            case "MISSING_ADDRESS_COMPONENT":
                            case 60:
                                message.adError = 60;
                                break;
                            case "MISSING_ADVERTISEMENT_NAME":
                            case 61:
                                message.adError = 61;
                                break;
                            case "MISSING_BUSINESS_NAME":
                            case 62:
                                message.adError = 62;
                                break;
                            case "MISSING_DESCRIPTION1":
                            case 63:
                                message.adError = 63;
                                break;
                            case "MISSING_DESCRIPTION2":
                            case 64:
                                message.adError = 64;
                                break;
                            case "MISSING_DESTINATION_URL_TAG":
                            case 65:
                                message.adError = 65;
                                break;
                            case "MISSING_LANDING_PAGE_URL_TAG":
                            case 66:
                                message.adError = 66;
                                break;
                            case "MISSING_DIMENSION":
                            case 67:
                                message.adError = 67;
                                break;
                            case "MISSING_DISPLAY_URL":
                            case 68:
                                message.adError = 68;
                                break;
                            case "MISSING_HEADLINE":
                            case 69:
                                message.adError = 69;
                                break;
                            case "MISSING_HEIGHT":
                            case 70:
                                message.adError = 70;
                                break;
                            case "MISSING_IMAGE":
                            case 71:
                                message.adError = 71;
                                break;
                            case "MISSING_MARKETING_IMAGE_OR_PRODUCT_VIDEOS":
                            case 72:
                                message.adError = 72;
                                break;
                            case "MISSING_MARKUP_LANGUAGES":
                            case 73:
                                message.adError = 73;
                                break;
                            case "MISSING_MOBILE_CARRIER":
                            case 74:
                                message.adError = 74;
                                break;
                            case "MISSING_PHONE":
                            case 75:
                                message.adError = 75;
                                break;
                            case "MISSING_REQUIRED_TEMPLATE_FIELDS":
                            case 76:
                                message.adError = 76;
                                break;
                            case "MISSING_TEMPLATE_FIELD_VALUE":
                            case 77:
                                message.adError = 77;
                                break;
                            case "MISSING_TEXT":
                            case 78:
                                message.adError = 78;
                                break;
                            case "MISSING_VISIBLE_URL":
                            case 79:
                                message.adError = 79;
                                break;
                            case "MISSING_WIDTH":
                            case 80:
                                message.adError = 80;
                                break;
                            case "MULTIPLE_DISTINCT_FEEDS_UNSUPPORTED":
                            case 81:
                                message.adError = 81;
                                break;
                            case "MUST_USE_TEMP_AD_UNION_ID_ON_ADD":
                            case 82:
                                message.adError = 82;
                                break;
                            case "TOO_LONG":
                            case 83:
                                message.adError = 83;
                                break;
                            case "TOO_SHORT":
                            case 84:
                                message.adError = 84;
                                break;
                            case "UNION_DIMENSIONS_CANNOT_CHANGE":
                            case 85:
                                message.adError = 85;
                                break;
                            case "UNKNOWN_ADDRESS_COMPONENT":
                            case 86:
                                message.adError = 86;
                                break;
                            case "UNKNOWN_FIELD_NAME":
                            case 87:
                                message.adError = 87;
                                break;
                            case "UNKNOWN_UNIQUE_NAME":
                            case 88:
                                message.adError = 88;
                                break;
                            case "UNSUPPORTED_DIMENSIONS":
                            case 89:
                                message.adError = 89;
                                break;
                            case "URL_INVALID_SCHEME":
                            case 90:
                                message.adError = 90;
                                break;
                            case "URL_INVALID_TOP_LEVEL_DOMAIN":
                            case 91:
                                message.adError = 91;
                                break;
                            case "URL_MALFORMED":
                            case 92:
                                message.adError = 92;
                                break;
                            case "URL_NO_HOST":
                            case 93:
                                message.adError = 93;
                                break;
                            case "URL_NOT_EQUIVALENT":
                            case 94:
                                message.adError = 94;
                                break;
                            case "URL_HOST_NAME_TOO_LONG":
                            case 95:
                                message.adError = 95;
                                break;
                            case "URL_NO_SCHEME":
                            case 96:
                                message.adError = 96;
                                break;
                            case "URL_NO_TOP_LEVEL_DOMAIN":
                            case 97:
                                message.adError = 97;
                                break;
                            case "URL_PATH_NOT_ALLOWED":
                            case 98:
                                message.adError = 98;
                                break;
                            case "URL_PORT_NOT_ALLOWED":
                            case 99:
                                message.adError = 99;
                                break;
                            case "URL_QUERY_NOT_ALLOWED":
                            case 100:
                                message.adError = 100;
                                break;
                            case "URL_SCHEME_BEFORE_EXPANDED_DYNAMIC_SEARCH_AD_TAG":
                            case 102:
                                message.adError = 102;
                                break;
                            case "USER_DOES_NOT_HAVE_ACCESS_TO_TEMPLATE":
                            case 103:
                                message.adError = 103;
                                break;
                            case "INCONSISTENT_EXPANDABLE_SETTINGS":
                            case 104:
                                message.adError = 104;
                                break;
                            case "INVALID_FORMAT":
                            case 105:
                                message.adError = 105;
                                break;
                            case "INVALID_FIELD_TEXT":
                            case 106:
                                message.adError = 106;
                                break;
                            case "ELEMENT_NOT_PRESENT":
                            case 107:
                                message.adError = 107;
                                break;
                            case "IMAGE_ERROR":
                            case 108:
                                message.adError = 108;
                                break;
                            case "VALUE_NOT_IN_RANGE":
                            case 109:
                                message.adError = 109;
                                break;
                            case "FIELD_NOT_PRESENT":
                            case 110:
                                message.adError = 110;
                                break;
                            case "ADDRESS_NOT_COMPLETE":
                            case 111:
                                message.adError = 111;
                                break;
                            case "ADDRESS_INVALID":
                            case 112:
                                message.adError = 112;
                                break;
                            case "VIDEO_RETRIEVAL_ERROR":
                            case 113:
                                message.adError = 113;
                                break;
                            case "AUDIO_ERROR":
                            case 114:
                                message.adError = 114;
                                break;
                            case "INVALID_YOUTUBE_DISPLAY_URL":
                            case 115:
                                message.adError = 115;
                                break;
                            case "TOO_MANY_PRODUCT_IMAGES":
                            case 116:
                                message.adError = 116;
                                break;
                            case "TOO_MANY_PRODUCT_VIDEOS":
                            case 117:
                                message.adError = 117;
                                break;
                            case "INCOMPATIBLE_AD_TYPE_AND_DEVICE_PREFERENCE":
                            case 118:
                                message.adError = 118;
                                break;
                            case "CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY":
                            case 119:
                                message.adError = 119;
                                break;
                            case "CARRIER_SPECIFIC_SHORT_NUMBER_NOT_ALLOWED":
                            case 120:
                                message.adError = 120;
                                break;
                            case "DISALLOWED_NUMBER_TYPE":
                            case 121:
                                message.adError = 121;
                                break;
                            case "PHONE_NUMBER_NOT_SUPPORTED_FOR_COUNTRY":
                            case 122:
                                message.adError = 122;
                                break;
                            case "PHONE_NUMBER_NOT_SUPPORTED_WITH_CALLTRACKING_FOR_COUNTRY":
                            case 123:
                                message.adError = 123;
                                break;
                            case "PREMIUM_RATE_NUMBER_NOT_ALLOWED":
                            case 124:
                                message.adError = 124;
                                break;
                            case "VANITY_PHONE_NUMBER_NOT_ALLOWED":
                            case 125:
                                message.adError = 125;
                                break;
                            case "INVALID_CALL_CONVERSION_TYPE_ID":
                            case 126:
                                message.adError = 126;
                                break;
                            case "CANNOT_DISABLE_CALL_CONVERSION_AND_SET_CONVERSION_TYPE_ID":
                            case 127:
                                message.adError = 127;
                                break;
                            case "CANNOT_SET_PATH2_WITHOUT_PATH1":
                            case 128:
                                message.adError = 128;
                                break;
                            case "MISSING_DYNAMIC_SEARCH_ADS_SETTING_DOMAIN_NAME":
                            case 129:
                                message.adError = 129;
                                break;
                            case "INCOMPATIBLE_WITH_RESTRICTION_TYPE":
                            case 130:
                                message.adError = 130;
                                break;
                            case "CUSTOMER_CONSENT_FOR_CALL_RECORDING_REQUIRED":
                            case 131:
                                message.adError = 131;
                                break;
                            case "MISSING_IMAGE_OR_MEDIA_BUNDLE":
                            case 132:
                                message.adError = 132;
                                break;
                            case "PRODUCT_TYPE_NOT_SUPPORTED_IN_THIS_CAMPAIGN":
                            case 133:
                                message.adError = 133;
                                break;
                            }
                            switch (object.adGroupError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.adGroupError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.adGroupError = 1;
                                break;
                            case "DUPLICATE_ADGROUP_NAME":
                            case 2:
                                message.adGroupError = 2;
                                break;
                            case "INVALID_ADGROUP_NAME":
                            case 3:
                                message.adGroupError = 3;
                                break;
                            case "ADVERTISER_NOT_ON_CONTENT_NETWORK":
                            case 5:
                                message.adGroupError = 5;
                                break;
                            case "BID_TOO_BIG":
                            case 6:
                                message.adGroupError = 6;
                                break;
                            case "BID_TYPE_AND_BIDDING_STRATEGY_MISMATCH":
                            case 7:
                                message.adGroupError = 7;
                                break;
                            case "MISSING_ADGROUP_NAME":
                            case 8:
                                message.adGroupError = 8;
                                break;
                            case "ADGROUP_LABEL_DOES_NOT_EXIST":
                            case 9:
                                message.adGroupError = 9;
                                break;
                            case "ADGROUP_LABEL_ALREADY_EXISTS":
                            case 10:
                                message.adGroupError = 10;
                                break;
                            case "INVALID_CONTENT_BID_CRITERION_TYPE_GROUP":
                            case 11:
                                message.adGroupError = 11;
                                break;
                            case "AD_GROUP_TYPE_NOT_VALID_FOR_ADVERTISING_CHANNEL_TYPE":
                            case 12:
                                message.adGroupError = 12;
                                break;
                            case "ADGROUP_TYPE_NOT_SUPPORTED_FOR_CAMPAIGN_SALES_COUNTRY":
                            case 13:
                                message.adGroupError = 13;
                                break;
                            case "CANNOT_ADD_ADGROUP_OF_TYPE_DSA_TO_CAMPAIGN_WITHOUT_DSA_SETTING":
                            case 14:
                                message.adGroupError = 14;
                                break;
                            }
                            switch (object.campaignBudgetError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.campaignBudgetError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.campaignBudgetError = 1;
                                break;
                            case "CAMPAIGN_BUDGET_CANNOT_BE_SHARED":
                            case 17:
                                message.campaignBudgetError = 17;
                                break;
                            case "CAMPAIGN_BUDGET_REMOVED":
                            case 2:
                                message.campaignBudgetError = 2;
                                break;
                            case "CAMPAIGN_BUDGET_IN_USE":
                            case 3:
                                message.campaignBudgetError = 3;
                                break;
                            case "CAMPAIGN_BUDGET_PERIOD_NOT_AVAILABLE":
                            case 4:
                                message.campaignBudgetError = 4;
                                break;
                            case "CANNOT_MODIFY_FIELD_OF_IMPLICITLY_SHARED_CAMPAIGN_BUDGET":
                            case 6:
                                message.campaignBudgetError = 6;
                                break;
                            case "CANNOT_UPDATE_CAMPAIGN_BUDGET_TO_IMPLICITLY_SHARED":
                            case 7:
                                message.campaignBudgetError = 7;
                                break;
                            case "CANNOT_UPDATE_CAMPAIGN_BUDGET_TO_EXPLICITLY_SHARED_WITHOUT_NAME":
                            case 8:
                                message.campaignBudgetError = 8;
                                break;
                            case "CANNOT_UPDATE_CAMPAIGN_BUDGET_TO_EXPLICITLY_SHARED":
                            case 9:
                                message.campaignBudgetError = 9;
                                break;
                            case "CANNOT_USE_IMPLICITLY_SHARED_CAMPAIGN_BUDGET_WITH_MULTIPLE_CAMPAIGNS":
                            case 10:
                                message.campaignBudgetError = 10;
                                break;
                            case "DUPLICATE_NAME":
                            case 11:
                                message.campaignBudgetError = 11;
                                break;
                            case "MONEY_AMOUNT_IN_WRONG_CURRENCY":
                            case 12:
                                message.campaignBudgetError = 12;
                                break;
                            case "MONEY_AMOUNT_LESS_THAN_CURRENCY_MINIMUM_CPC":
                            case 13:
                                message.campaignBudgetError = 13;
                                break;
                            case "MONEY_AMOUNT_TOO_LARGE":
                            case 14:
                                message.campaignBudgetError = 14;
                                break;
                            case "NEGATIVE_MONEY_AMOUNT":
                            case 15:
                                message.campaignBudgetError = 15;
                                break;
                            case "NON_MULTIPLE_OF_MINIMUM_CURRENCY_UNIT":
                            case 16:
                                message.campaignBudgetError = 16;
                                break;
                            }
                            switch (object.campaignError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.campaignError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.campaignError = 1;
                                break;
                            case "CANNOT_TARGET_CONTENT_NETWORK":
                            case 3:
                                message.campaignError = 3;
                                break;
                            case "CANNOT_TARGET_SEARCH_NETWORK":
                            case 4:
                                message.campaignError = 4;
                                break;
                            case "CANNOT_TARGET_SEARCH_NETWORK_WITHOUT_GOOGLE_SEARCH":
                            case 5:
                                message.campaignError = 5;
                                break;
                            case "CANNOT_TARGET_GOOGLE_SEARCH_FOR_CPM_CAMPAIGN":
                            case 6:
                                message.campaignError = 6;
                                break;
                            case "CAMPAIGN_MUST_TARGET_AT_LEAST_ONE_NETWORK":
                            case 7:
                                message.campaignError = 7;
                                break;
                            case "CANNOT_TARGET_PARTNER_SEARCH_NETWORK":
                            case 8:
                                message.campaignError = 8;
                                break;
                            case "CANNOT_TARGET_CONTENT_NETWORK_ONLY_WITH_CRITERIA_LEVEL_BIDDING_STRATEGY":
                            case 9:
                                message.campaignError = 9;
                                break;
                            case "CAMPAIGN_DURATION_MUST_CONTAIN_ALL_RUNNABLE_TRIALS":
                            case 10:
                                message.campaignError = 10;
                                break;
                            case "CANNOT_MODIFY_FOR_TRIAL_CAMPAIGN":
                            case 11:
                                message.campaignError = 11;
                                break;
                            case "DUPLICATE_CAMPAIGN_NAME":
                            case 12:
                                message.campaignError = 12;
                                break;
                            case "INCOMPATIBLE_CAMPAIGN_FIELD":
                            case 13:
                                message.campaignError = 13;
                                break;
                            case "INVALID_CAMPAIGN_NAME":
                            case 14:
                                message.campaignError = 14;
                                break;
                            case "INVALID_AD_SERVING_OPTIMIZATION_STATUS":
                            case 15:
                                message.campaignError = 15;
                                break;
                            case "INVALID_TRACKING_URL":
                            case 16:
                                message.campaignError = 16;
                                break;
                            case "CANNOT_SET_BOTH_TRACKING_URL_TEMPLATE_AND_TRACKING_SETTING":
                            case 17:
                                message.campaignError = 17;
                                break;
                            case "MAX_IMPRESSIONS_NOT_IN_RANGE":
                            case 18:
                                message.campaignError = 18;
                                break;
                            case "TIME_UNIT_NOT_SUPPORTED":
                            case 19:
                                message.campaignError = 19;
                                break;
                            case "INVALID_OPERATION_IF_SERVING_STATUS_HAS_ENDED":
                            case 20:
                                message.campaignError = 20;
                                break;
                            case "BUDGET_CANNOT_BE_SHARED":
                            case 21:
                                message.campaignError = 21;
                                break;
                            case "CAMPAIGN_CANNOT_USE_SHARED_BUDGET":
                            case 22:
                                message.campaignError = 22;
                                break;
                            case "CANNOT_CHANGE_BUDGET_ON_CAMPAIGN_WITH_TRIALS":
                            case 23:
                                message.campaignError = 23;
                                break;
                            case "CAMPAIGN_LABEL_DOES_NOT_EXIST":
                            case 24:
                                message.campaignError = 24;
                                break;
                            case "CAMPAIGN_LABEL_ALREADY_EXISTS":
                            case 25:
                                message.campaignError = 25;
                                break;
                            case "MISSING_SHOPPING_SETTING":
                            case 26:
                                message.campaignError = 26;
                                break;
                            case "INVALID_SHOPPING_SALES_COUNTRY":
                            case 27:
                                message.campaignError = 27;
                                break;
                            case "MISSING_UNIVERSAL_APP_CAMPAIGN_SETTING":
                            case 30:
                                message.campaignError = 30;
                                break;
                            case "ADVERTISING_CHANNEL_TYPE_NOT_AVAILABLE_FOR_ACCOUNT_TYPE":
                            case 31:
                                message.campaignError = 31;
                                break;
                            case "INVALID_ADVERTISING_CHANNEL_SUB_TYPE":
                            case 32:
                                message.campaignError = 32;
                                break;
                            case "AT_LEAST_ONE_CONVERSION_MUST_BE_SELECTED":
                            case 33:
                                message.campaignError = 33;
                                break;
                            case "CANNOT_SET_AD_ROTATION_MODE":
                            case 34:
                                message.campaignError = 34;
                                break;
                            case "CANNOT_MODIFY_START_DATE_IF_ALREADY_STARTED":
                            case 35:
                                message.campaignError = 35;
                                break;
                            case "CANNOT_SET_DATE_TO_PAST":
                            case 36:
                                message.campaignError = 36;
                                break;
                            case "MISSING_HOTEL_CUSTOMER_LINK":
                            case 37:
                                message.campaignError = 37;
                                break;
                            case "INVALID_HOTEL_CUSTOMER_LINK":
                            case 38:
                                message.campaignError = 38;
                                break;
                            case "MISSING_HOTEL_SETTING":
                            case 39:
                                message.campaignError = 39;
                                break;
                            case "CANNOT_USE_SHARED_CAMPAIGN_BUDGET_WHILE_PART_OF_CAMPAIGN_GROUP":
                            case 40:
                                message.campaignError = 40;
                                break;
                            case "APP_NOT_FOUND":
                            case 41:
                                message.campaignError = 41;
                                break;
                            }
                            switch (object.authenticationError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.authenticationError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.authenticationError = 1;
                                break;
                            case "AUTHENTICATION_ERROR":
                            case 2:
                                message.authenticationError = 2;
                                break;
                            case "CLIENT_CUSTOMER_ID_INVALID":
                            case 5:
                                message.authenticationError = 5;
                                break;
                            case "CUSTOMER_NOT_FOUND":
                            case 8:
                                message.authenticationError = 8;
                                break;
                            case "GOOGLE_ACCOUNT_DELETED":
                            case 9:
                                message.authenticationError = 9;
                                break;
                            case "GOOGLE_ACCOUNT_COOKIE_INVALID":
                            case 10:
                                message.authenticationError = 10;
                                break;
                            case "GOOGLE_ACCOUNT_AUTHENTICATION_FAILED":
                            case 25:
                                message.authenticationError = 25;
                                break;
                            case "GOOGLE_ACCOUNT_USER_AND_ADS_USER_MISMATCH":
                            case 12:
                                message.authenticationError = 12;
                                break;
                            case "LOGIN_COOKIE_REQUIRED":
                            case 13:
                                message.authenticationError = 13;
                                break;
                            case "NOT_ADS_USER":
                            case 14:
                                message.authenticationError = 14;
                                break;
                            case "OAUTH_TOKEN_INVALID":
                            case 15:
                                message.authenticationError = 15;
                                break;
                            case "OAUTH_TOKEN_EXPIRED":
                            case 16:
                                message.authenticationError = 16;
                                break;
                            case "OAUTH_TOKEN_DISABLED":
                            case 17:
                                message.authenticationError = 17;
                                break;
                            case "OAUTH_TOKEN_REVOKED":
                            case 18:
                                message.authenticationError = 18;
                                break;
                            case "OAUTH_TOKEN_HEADER_INVALID":
                            case 19:
                                message.authenticationError = 19;
                                break;
                            case "LOGIN_COOKIE_INVALID":
                            case 20:
                                message.authenticationError = 20;
                                break;
                            case "USER_ID_INVALID":
                            case 22:
                                message.authenticationError = 22;
                                break;
                            case "TWO_STEP_VERIFICATION_NOT_ENROLLED":
                            case 23:
                                message.authenticationError = 23;
                                break;
                            case "ADVANCED_PROTECTION_NOT_ENROLLED":
                            case 24:
                                message.authenticationError = 24;
                                break;
                            }
                            switch (object.adGroupCriterionError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.adGroupCriterionError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.adGroupCriterionError = 1;
                                break;
                            case "AD_GROUP_CRITERION_LABEL_DOES_NOT_EXIST":
                            case 2:
                                message.adGroupCriterionError = 2;
                                break;
                            case "AD_GROUP_CRITERION_LABEL_ALREADY_EXISTS":
                            case 3:
                                message.adGroupCriterionError = 3;
                                break;
                            case "CANNOT_ADD_LABEL_TO_NEGATIVE_CRITERION":
                            case 4:
                                message.adGroupCriterionError = 4;
                                break;
                            case "TOO_MANY_OPERATIONS":
                            case 5:
                                message.adGroupCriterionError = 5;
                                break;
                            case "CANT_UPDATE_NEGATIVE":
                            case 6:
                                message.adGroupCriterionError = 6;
                                break;
                            case "CONCRETE_TYPE_REQUIRED":
                            case 7:
                                message.adGroupCriterionError = 7;
                                break;
                            case "BID_INCOMPATIBLE_WITH_ADGROUP":
                            case 8:
                                message.adGroupCriterionError = 8;
                                break;
                            case "CANNOT_TARGET_AND_EXCLUDE":
                            case 9:
                                message.adGroupCriterionError = 9;
                                break;
                            case "ILLEGAL_URL":
                            case 10:
                                message.adGroupCriterionError = 10;
                                break;
                            case "INVALID_KEYWORD_TEXT":
                            case 11:
                                message.adGroupCriterionError = 11;
                                break;
                            case "INVALID_DESTINATION_URL":
                            case 12:
                                message.adGroupCriterionError = 12;
                                break;
                            case "MISSING_DESTINATION_URL_TAG":
                            case 13:
                                message.adGroupCriterionError = 13;
                                break;
                            case "KEYWORD_LEVEL_BID_NOT_SUPPORTED_FOR_MANUALCPM":
                            case 14:
                                message.adGroupCriterionError = 14;
                                break;
                            case "INVALID_USER_STATUS":
                            case 15:
                                message.adGroupCriterionError = 15;
                                break;
                            case "CANNOT_ADD_CRITERIA_TYPE":
                            case 16:
                                message.adGroupCriterionError = 16;
                                break;
                            case "CANNOT_EXCLUDE_CRITERIA_TYPE":
                            case 17:
                                message.adGroupCriterionError = 17;
                                break;
                            case "CAMPAIGN_TYPE_NOT_COMPATIBLE_WITH_PARTIAL_FAILURE":
                            case 27:
                                message.adGroupCriterionError = 27;
                                break;
                            case "OPERATIONS_FOR_TOO_MANY_SHOPPING_ADGROUPS":
                            case 28:
                                message.adGroupCriterionError = 28;
                                break;
                            case "CANNOT_MODIFY_URL_FIELDS_WITH_DUPLICATE_ELEMENTS":
                            case 29:
                                message.adGroupCriterionError = 29;
                                break;
                            case "CANNOT_SET_WITHOUT_FINAL_URLS":
                            case 30:
                                message.adGroupCriterionError = 30;
                                break;
                            case "CANNOT_CLEAR_FINAL_URLS_IF_FINAL_MOBILE_URLS_EXIST":
                            case 31:
                                message.adGroupCriterionError = 31;
                                break;
                            case "CANNOT_CLEAR_FINAL_URLS_IF_FINAL_APP_URLS_EXIST":
                            case 32:
                                message.adGroupCriterionError = 32;
                                break;
                            case "CANNOT_CLEAR_FINAL_URLS_IF_TRACKING_URL_TEMPLATE_EXISTS":
                            case 33:
                                message.adGroupCriterionError = 33;
                                break;
                            case "CANNOT_CLEAR_FINAL_URLS_IF_URL_CUSTOM_PARAMETERS_EXIST":
                            case 34:
                                message.adGroupCriterionError = 34;
                                break;
                            case "CANNOT_SET_BOTH_DESTINATION_URL_AND_FINAL_URLS":
                            case 35:
                                message.adGroupCriterionError = 35;
                                break;
                            case "CANNOT_SET_BOTH_DESTINATION_URL_AND_TRACKING_URL_TEMPLATE":
                            case 36:
                                message.adGroupCriterionError = 36;
                                break;
                            case "FINAL_URLS_NOT_SUPPORTED_FOR_CRITERION_TYPE":
                            case 37:
                                message.adGroupCriterionError = 37;
                                break;
                            case "FINAL_MOBILE_URLS_NOT_SUPPORTED_FOR_CRITERION_TYPE":
                            case 38:
                                message.adGroupCriterionError = 38;
                                break;
                            case "INVALID_LISTING_GROUP_HIERARCHY":
                            case 39:
                                message.adGroupCriterionError = 39;
                                break;
                            case "LISTING_GROUP_UNIT_CANNOT_HAVE_CHILDREN":
                            case 40:
                                message.adGroupCriterionError = 40;
                                break;
                            case "LISTING_GROUP_SUBDIVISION_REQUIRES_OTHERS_CASE":
                            case 41:
                                message.adGroupCriterionError = 41;
                                break;
                            case "LISTING_GROUP_REQUIRES_SAME_DIMENSION_TYPE_AS_SIBLINGS":
                            case 42:
                                message.adGroupCriterionError = 42;
                                break;
                            case "LISTING_GROUP_ALREADY_EXISTS":
                            case 43:
                                message.adGroupCriterionError = 43;
                                break;
                            case "LISTING_GROUP_DOES_NOT_EXIST":
                            case 44:
                                message.adGroupCriterionError = 44;
                                break;
                            case "LISTING_GROUP_CANNOT_BE_REMOVED":
                            case 45:
                                message.adGroupCriterionError = 45;
                                break;
                            case "INVALID_LISTING_GROUP_TYPE":
                            case 46:
                                message.adGroupCriterionError = 46;
                                break;
                            case "LISTING_GROUP_ADD_MAY_ONLY_USE_TEMP_ID":
                            case 47:
                                message.adGroupCriterionError = 47;
                                break;
                            }
                            switch (object.adCustomizerError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.adCustomizerError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.adCustomizerError = 1;
                                break;
                            case "COUNTDOWN_INVALID_DATE_FORMAT":
                            case 2:
                                message.adCustomizerError = 2;
                                break;
                            case "COUNTDOWN_DATE_IN_PAST":
                            case 3:
                                message.adCustomizerError = 3;
                                break;
                            case "COUNTDOWN_INVALID_LOCALE":
                            case 4:
                                message.adCustomizerError = 4;
                                break;
                            case "COUNTDOWN_INVALID_START_DAYS_BEFORE":
                            case 5:
                                message.adCustomizerError = 5;
                                break;
                            case "UNKNOWN_USER_LIST":
                            case 6:
                                message.adCustomizerError = 6;
                                break;
                            }
                            switch (object.adGroupAdError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.adGroupAdError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.adGroupAdError = 1;
                                break;
                            case "AD_GROUP_AD_LABEL_DOES_NOT_EXIST":
                            case 2:
                                message.adGroupAdError = 2;
                                break;
                            case "AD_GROUP_AD_LABEL_ALREADY_EXISTS":
                            case 3:
                                message.adGroupAdError = 3;
                                break;
                            case "AD_NOT_UNDER_ADGROUP":
                            case 4:
                                message.adGroupAdError = 4;
                                break;
                            case "CANNOT_OPERATE_ON_REMOVED_ADGROUPAD":
                            case 5:
                                message.adGroupAdError = 5;
                                break;
                            case "CANNOT_CREATE_DEPRECATED_ADS":
                            case 6:
                                message.adGroupAdError = 6;
                                break;
                            case "CANNOT_CREATE_TEXT_ADS":
                            case 7:
                                message.adGroupAdError = 7;
                                break;
                            case "EMPTY_FIELD":
                            case 8:
                                message.adGroupAdError = 8;
                                break;
                            case "RESOURCE_REFERENCED_IN_MULTIPLE_OPS":
                            case 9:
                                message.adGroupAdError = 9;
                                break;
                            }
                            switch (object.adSharingError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.adSharingError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.adSharingError = 1;
                                break;
                            case "AD_GROUP_ALREADY_CONTAINS_AD":
                            case 2:
                                message.adSharingError = 2;
                                break;
                            case "INCOMPATIBLE_AD_UNDER_AD_GROUP":
                            case 3:
                                message.adSharingError = 3;
                                break;
                            case "CANNOT_SHARE_INACTIVE_AD":
                            case 4:
                                message.adSharingError = 4;
                                break;
                            }
                            switch (object.adxError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.adxError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.adxError = 1;
                                break;
                            case "UNSUPPORTED_FEATURE":
                            case 2:
                                message.adxError = 2;
                                break;
                            }
                            switch (object.assetError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.assetError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.assetError = 1;
                                break;
                            case "CUSTOMER_NOT_WHITELISTED_FOR_ASSET_TYPE":
                            case 2:
                                message.assetError = 2;
                                break;
                            case "DUPLICATE_ASSET":
                            case 3:
                                message.assetError = 3;
                                break;
                            case "DUPLICATE_ASSET_NAME":
                            case 4:
                                message.assetError = 4;
                                break;
                            case "ASSET_DATA_IS_MISSING":
                            case 5:
                                message.assetError = 5;
                                break;
                            case "CANNOT_MODIFY_ASSET_NAME":
                            case 6:
                                message.assetError = 6;
                                break;
                            }
                            switch (object.biddingError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.biddingError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.biddingError = 1;
                                break;
                            case "BIDDING_STRATEGY_TRANSITION_NOT_ALLOWED":
                            case 2:
                                message.biddingError = 2;
                                break;
                            case "CANNOT_ATTACH_BIDDING_STRATEGY_TO_CAMPAIGN":
                            case 7:
                                message.biddingError = 7;
                                break;
                            case "INVALID_ANONYMOUS_BIDDING_STRATEGY_TYPE":
                            case 10:
                                message.biddingError = 10;
                                break;
                            case "INVALID_BIDDING_STRATEGY_TYPE":
                            case 14:
                                message.biddingError = 14;
                                break;
                            case "INVALID_BID":
                            case 17:
                                message.biddingError = 17;
                                break;
                            case "BIDDING_STRATEGY_NOT_AVAILABLE_FOR_ACCOUNT_TYPE":
                            case 18:
                                message.biddingError = 18;
                                break;
                            case "CONVERSION_TRACKING_NOT_ENABLED":
                            case 19:
                                message.biddingError = 19;
                                break;
                            case "NOT_ENOUGH_CONVERSIONS":
                            case 20:
                                message.biddingError = 20;
                                break;
                            case "CANNOT_CREATE_CAMPAIGN_WITH_BIDDING_STRATEGY":
                            case 21:
                                message.biddingError = 21;
                                break;
                            case "CANNOT_TARGET_CONTENT_NETWORK_ONLY_WITH_CAMPAIGN_LEVEL_POP_BIDDING_STRATEGY":
                            case 23:
                                message.biddingError = 23;
                                break;
                            case "BIDDING_STRATEGY_NOT_SUPPORTED_WITH_AD_SCHEDULE":
                            case 24:
                                message.biddingError = 24;
                                break;
                            case "PAY_PER_CONVERSION_NOT_AVAILABLE_FOR_CUSTOMER":
                            case 25:
                                message.biddingError = 25;
                                break;
                            case "PAY_PER_CONVERSION_NOT_ALLOWED_WITH_TARGET_CPA":
                            case 26:
                                message.biddingError = 26;
                                break;
                            case "BIDDING_STRATEGY_NOT_ALLOWED_FOR_SEARCH_ONLY_CAMPAIGNS":
                            case 27:
                                message.biddingError = 27;
                                break;
                            case "BIDDING_STRATEGY_NOT_SUPPORTED_IN_DRAFTS_OR_EXPERIMENTS":
                            case 28:
                                message.biddingError = 28;
                                break;
                            case "BIDDING_STRATEGY_TYPE_DOES_NOT_SUPPORT_PRODUCT_TYPE_ADGROUP_CRITERION":
                            case 29:
                                message.biddingError = 29;
                                break;
                            case "BID_TOO_SMALL":
                            case 30:
                                message.biddingError = 30;
                                break;
                            case "BID_TOO_BIG":
                            case 31:
                                message.biddingError = 31;
                                break;
                            case "BID_TOO_MANY_FRACTIONAL_DIGITS":
                            case 32:
                                message.biddingError = 32;
                                break;
                            case "INVALID_DOMAIN_NAME":
                            case 33:
                                message.biddingError = 33;
                                break;
                            case "NOT_COMPATIBLE_WITH_PAYMENT_MODE":
                            case 34:
                                message.biddingError = 34;
                                break;
                            case "NOT_COMPATIBLE_WITH_BUDGET_TYPE":
                            case 35:
                                message.biddingError = 35;
                                break;
                            }
                            switch (object.campaignCriterionError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.campaignCriterionError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.campaignCriterionError = 1;
                                break;
                            case "CONCRETE_TYPE_REQUIRED":
                            case 2:
                                message.campaignCriterionError = 2;
                                break;
                            case "INVALID_PLACEMENT_URL":
                            case 3:
                                message.campaignCriterionError = 3;
                                break;
                            case "CANNOT_EXCLUDE_CRITERIA_TYPE":
                            case 4:
                                message.campaignCriterionError = 4;
                                break;
                            case "CANNOT_SET_STATUS_FOR_CRITERIA_TYPE":
                            case 5:
                                message.campaignCriterionError = 5;
                                break;
                            case "CANNOT_SET_STATUS_FOR_EXCLUDED_CRITERIA":
                            case 6:
                                message.campaignCriterionError = 6;
                                break;
                            case "CANNOT_TARGET_AND_EXCLUDE":
                            case 7:
                                message.campaignCriterionError = 7;
                                break;
                            case "TOO_MANY_OPERATIONS":
                            case 8:
                                message.campaignCriterionError = 8;
                                break;
                            case "OPERATOR_NOT_SUPPORTED_FOR_CRITERION_TYPE":
                            case 9:
                                message.campaignCriterionError = 9;
                                break;
                            case "SHOPPING_CAMPAIGN_SALES_COUNTRY_NOT_SUPPORTED_FOR_SALES_CHANNEL":
                            case 10:
                                message.campaignCriterionError = 10;
                                break;
                            case "CANNOT_ADD_EXISTING_FIELD":
                            case 11:
                                message.campaignCriterionError = 11;
                                break;
                            case "CANNOT_UPDATE_NEGATIVE_CRITERION":
                            case 12:
                                message.campaignCriterionError = 12;
                                break;
                            }
                            switch (object.collectionSizeError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.collectionSizeError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.collectionSizeError = 1;
                                break;
                            case "TOO_FEW":
                            case 2:
                                message.collectionSizeError = 2;
                                break;
                            case "TOO_MANY":
                            case 3:
                                message.collectionSizeError = 3;
                                break;
                            }
                            switch (object.countryCodeError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.countryCodeError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.countryCodeError = 1;
                                break;
                            case "INVALID_COUNTRY_CODE":
                            case 2:
                                message.countryCodeError = 2;
                                break;
                            }
                            switch (object.criterionError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.criterionError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.criterionError = 1;
                                break;
                            case "CONCRETE_TYPE_REQUIRED":
                            case 2:
                                message.criterionError = 2;
                                break;
                            case "INVALID_EXCLUDED_CATEGORY":
                            case 3:
                                message.criterionError = 3;
                                break;
                            case "INVALID_KEYWORD_TEXT":
                            case 4:
                                message.criterionError = 4;
                                break;
                            case "KEYWORD_TEXT_TOO_LONG":
                            case 5:
                                message.criterionError = 5;
                                break;
                            case "KEYWORD_HAS_TOO_MANY_WORDS":
                            case 6:
                                message.criterionError = 6;
                                break;
                            case "KEYWORD_HAS_INVALID_CHARS":
                            case 7:
                                message.criterionError = 7;
                                break;
                            case "INVALID_PLACEMENT_URL":
                            case 8:
                                message.criterionError = 8;
                                break;
                            case "INVALID_USER_LIST":
                            case 9:
                                message.criterionError = 9;
                                break;
                            case "INVALID_USER_INTEREST":
                            case 10:
                                message.criterionError = 10;
                                break;
                            case "INVALID_FORMAT_FOR_PLACEMENT_URL":
                            case 11:
                                message.criterionError = 11;
                                break;
                            case "PLACEMENT_URL_IS_TOO_LONG":
                            case 12:
                                message.criterionError = 12;
                                break;
                            case "PLACEMENT_URL_HAS_ILLEGAL_CHAR":
                            case 13:
                                message.criterionError = 13;
                                break;
                            case "PLACEMENT_URL_HAS_MULTIPLE_SITES_IN_LINE":
                            case 14:
                                message.criterionError = 14;
                                break;
                            case "PLACEMENT_IS_NOT_AVAILABLE_FOR_TARGETING_OR_EXCLUSION":
                            case 15:
                                message.criterionError = 15;
                                break;
                            case "INVALID_TOPIC_PATH":
                            case 16:
                                message.criterionError = 16;
                                break;
                            case "INVALID_YOUTUBE_CHANNEL_ID":
                            case 17:
                                message.criterionError = 17;
                                break;
                            case "INVALID_YOUTUBE_VIDEO_ID":
                            case 18:
                                message.criterionError = 18;
                                break;
                            case "YOUTUBE_VERTICAL_CHANNEL_DEPRECATED":
                            case 19:
                                message.criterionError = 19;
                                break;
                            case "YOUTUBE_DEMOGRAPHIC_CHANNEL_DEPRECATED":
                            case 20:
                                message.criterionError = 20;
                                break;
                            case "YOUTUBE_URL_UNSUPPORTED":
                            case 21:
                                message.criterionError = 21;
                                break;
                            case "CANNOT_EXCLUDE_CRITERIA_TYPE":
                            case 22:
                                message.criterionError = 22;
                                break;
                            case "CANNOT_ADD_CRITERIA_TYPE":
                            case 23:
                                message.criterionError = 23;
                                break;
                            case "INVALID_PRODUCT_FILTER":
                            case 24:
                                message.criterionError = 24;
                                break;
                            case "PRODUCT_FILTER_TOO_LONG":
                            case 25:
                                message.criterionError = 25;
                                break;
                            case "CANNOT_EXCLUDE_SIMILAR_USER_LIST":
                            case 26:
                                message.criterionError = 26;
                                break;
                            case "CANNOT_ADD_CLOSED_USER_LIST":
                            case 27:
                                message.criterionError = 27;
                                break;
                            case "CANNOT_ADD_DISPLAY_ONLY_LISTS_TO_SEARCH_ONLY_CAMPAIGNS":
                            case 28:
                                message.criterionError = 28;
                                break;
                            case "CANNOT_ADD_DISPLAY_ONLY_LISTS_TO_SEARCH_CAMPAIGNS":
                            case 29:
                                message.criterionError = 29;
                                break;
                            case "CANNOT_ADD_DISPLAY_ONLY_LISTS_TO_SHOPPING_CAMPAIGNS":
                            case 30:
                                message.criterionError = 30;
                                break;
                            case "CANNOT_ADD_USER_INTERESTS_TO_SEARCH_CAMPAIGNS":
                            case 31:
                                message.criterionError = 31;
                                break;
                            case "CANNOT_SET_BIDS_ON_CRITERION_TYPE_IN_SEARCH_CAMPAIGNS":
                            case 32:
                                message.criterionError = 32;
                                break;
                            case "CANNOT_ADD_URLS_TO_CRITERION_TYPE_FOR_CAMPAIGN_TYPE":
                            case 33:
                                message.criterionError = 33;
                                break;
                            case "INVALID_CUSTOM_AFFINITY":
                            case 96:
                                message.criterionError = 96;
                                break;
                            case "INVALID_CUSTOM_INTENT":
                            case 97:
                                message.criterionError = 97;
                                break;
                            case "INVALID_IP_ADDRESS":
                            case 34:
                                message.criterionError = 34;
                                break;
                            case "INVALID_IP_FORMAT":
                            case 35:
                                message.criterionError = 35;
                                break;
                            case "INVALID_MOBILE_APP":
                            case 36:
                                message.criterionError = 36;
                                break;
                            case "INVALID_MOBILE_APP_CATEGORY":
                            case 37:
                                message.criterionError = 37;
                                break;
                            case "INVALID_CRITERION_ID":
                            case 38:
                                message.criterionError = 38;
                                break;
                            case "CANNOT_TARGET_CRITERION":
                            case 39:
                                message.criterionError = 39;
                                break;
                            case "CANNOT_TARGET_OBSOLETE_CRITERION":
                            case 40:
                                message.criterionError = 40;
                                break;
                            case "CRITERION_ID_AND_TYPE_MISMATCH":
                            case 41:
                                message.criterionError = 41;
                                break;
                            case "INVALID_PROXIMITY_RADIUS":
                            case 42:
                                message.criterionError = 42;
                                break;
                            case "INVALID_PROXIMITY_RADIUS_UNITS":
                            case 43:
                                message.criterionError = 43;
                                break;
                            case "INVALID_STREETADDRESS_LENGTH":
                            case 44:
                                message.criterionError = 44;
                                break;
                            case "INVALID_CITYNAME_LENGTH":
                            case 45:
                                message.criterionError = 45;
                                break;
                            case "INVALID_REGIONCODE_LENGTH":
                            case 46:
                                message.criterionError = 46;
                                break;
                            case "INVALID_REGIONNAME_LENGTH":
                            case 47:
                                message.criterionError = 47;
                                break;
                            case "INVALID_POSTALCODE_LENGTH":
                            case 48:
                                message.criterionError = 48;
                                break;
                            case "INVALID_COUNTRY_CODE":
                            case 49:
                                message.criterionError = 49;
                                break;
                            case "INVALID_LATITUDE":
                            case 50:
                                message.criterionError = 50;
                                break;
                            case "INVALID_LONGITUDE":
                            case 51:
                                message.criterionError = 51;
                                break;
                            case "PROXIMITY_GEOPOINT_AND_ADDRESS_BOTH_CANNOT_BE_NULL":
                            case 52:
                                message.criterionError = 52;
                                break;
                            case "INVALID_PROXIMITY_ADDRESS":
                            case 53:
                                message.criterionError = 53;
                                break;
                            case "INVALID_USER_DOMAIN_NAME":
                            case 54:
                                message.criterionError = 54;
                                break;
                            case "CRITERION_PARAMETER_TOO_LONG":
                            case 55:
                                message.criterionError = 55;
                                break;
                            case "AD_SCHEDULE_TIME_INTERVALS_OVERLAP":
                            case 56:
                                message.criterionError = 56;
                                break;
                            case "AD_SCHEDULE_INTERVAL_CANNOT_SPAN_MULTIPLE_DAYS":
                            case 57:
                                message.criterionError = 57;
                                break;
                            case "AD_SCHEDULE_INVALID_TIME_INTERVAL":
                            case 58:
                                message.criterionError = 58;
                                break;
                            case "AD_SCHEDULE_EXCEEDED_INTERVALS_PER_DAY_LIMIT":
                            case 59:
                                message.criterionError = 59;
                                break;
                            case "AD_SCHEDULE_CRITERION_ID_MISMATCHING_FIELDS":
                            case 60:
                                message.criterionError = 60;
                                break;
                            case "CANNOT_BID_MODIFY_CRITERION_TYPE":
                            case 61:
                                message.criterionError = 61;
                                break;
                            case "CANNOT_BID_MODIFY_CRITERION_CAMPAIGN_OPTED_OUT":
                            case 62:
                                message.criterionError = 62;
                                break;
                            case "CANNOT_BID_MODIFY_NEGATIVE_CRITERION":
                            case 63:
                                message.criterionError = 63;
                                break;
                            case "BID_MODIFIER_ALREADY_EXISTS":
                            case 64:
                                message.criterionError = 64;
                                break;
                            case "FEED_ID_NOT_ALLOWED":
                            case 65:
                                message.criterionError = 65;
                                break;
                            case "ACCOUNT_INELIGIBLE_FOR_CRITERIA_TYPE":
                            case 66:
                                message.criterionError = 66;
                                break;
                            case "CRITERIA_TYPE_INVALID_FOR_BIDDING_STRATEGY":
                            case 67:
                                message.criterionError = 67;
                                break;
                            case "CANNOT_EXCLUDE_CRITERION":
                            case 68:
                                message.criterionError = 68;
                                break;
                            case "CANNOT_REMOVE_CRITERION":
                            case 69:
                                message.criterionError = 69;
                                break;
                            case "PRODUCT_SCOPE_TOO_LONG":
                            case 70:
                                message.criterionError = 70;
                                break;
                            case "PRODUCT_SCOPE_TOO_MANY_DIMENSIONS":
                            case 71:
                                message.criterionError = 71;
                                break;
                            case "PRODUCT_PARTITION_TOO_LONG":
                            case 72:
                                message.criterionError = 72;
                                break;
                            case "PRODUCT_PARTITION_TOO_MANY_DIMENSIONS":
                            case 73:
                                message.criterionError = 73;
                                break;
                            case "INVALID_PRODUCT_DIMENSION":
                            case 74:
                                message.criterionError = 74;
                                break;
                            case "INVALID_PRODUCT_DIMENSION_TYPE":
                            case 75:
                                message.criterionError = 75;
                                break;
                            case "INVALID_PRODUCT_BIDDING_CATEGORY":
                            case 76:
                                message.criterionError = 76;
                                break;
                            case "MISSING_SHOPPING_SETTING":
                            case 77:
                                message.criterionError = 77;
                                break;
                            case "INVALID_MATCHING_FUNCTION":
                            case 78:
                                message.criterionError = 78;
                                break;
                            case "LOCATION_FILTER_NOT_ALLOWED":
                            case 79:
                                message.criterionError = 79;
                                break;
                            case "INVALID_FEED_FOR_LOCATION_FILTER":
                            case 98:
                                message.criterionError = 98;
                                break;
                            case "LOCATION_FILTER_INVALID":
                            case 80:
                                message.criterionError = 80;
                                break;
                            case "CANNOT_ATTACH_CRITERIA_AT_CAMPAIGN_AND_ADGROUP":
                            case 81:
                                message.criterionError = 81;
                                break;
                            case "HOTEL_LENGTH_OF_STAY_OVERLAPS_WITH_EXISTING_CRITERION":
                            case 82:
                                message.criterionError = 82;
                                break;
                            case "HOTEL_ADVANCE_BOOKING_WINDOW_OVERLAPS_WITH_EXISTING_CRITERION":
                            case 83:
                                message.criterionError = 83;
                                break;
                            case "FIELD_INCOMPATIBLE_WITH_NEGATIVE_TARGETING":
                            case 84:
                                message.criterionError = 84;
                                break;
                            case "INVALID_WEBPAGE_CONDITION":
                            case 85:
                                message.criterionError = 85;
                                break;
                            case "INVALID_WEBPAGE_CONDITION_URL":
                            case 86:
                                message.criterionError = 86;
                                break;
                            case "WEBPAGE_CONDITION_URL_CANNOT_BE_EMPTY":
                            case 87:
                                message.criterionError = 87;
                                break;
                            case "WEBPAGE_CONDITION_URL_UNSUPPORTED_PROTOCOL":
                            case 88:
                                message.criterionError = 88;
                                break;
                            case "WEBPAGE_CONDITION_URL_CANNOT_BE_IP_ADDRESS":
                            case 89:
                                message.criterionError = 89;
                                break;
                            case "WEBPAGE_CONDITION_URL_DOMAIN_NOT_CONSISTENT_WITH_CAMPAIGN_SETTING":
                            case 90:
                                message.criterionError = 90;
                                break;
                            case "WEBPAGE_CONDITION_URL_CANNOT_BE_PUBLIC_SUFFIX":
                            case 91:
                                message.criterionError = 91;
                                break;
                            case "WEBPAGE_CONDITION_URL_INVALID_PUBLIC_SUFFIX":
                            case 92:
                                message.criterionError = 92;
                                break;
                            case "WEBPAGE_CONDITION_URL_VALUE_TRACK_VALUE_NOT_SUPPORTED":
                            case 93:
                                message.criterionError = 93;
                                break;
                            case "WEBPAGE_CRITERION_URL_EQUALS_CAN_HAVE_ONLY_ONE_CONDITION":
                            case 94:
                                message.criterionError = 94;
                                break;
                            case "WEBPAGE_CRITERION_NOT_SUPPORTED_ON_NON_DSA_AD_GROUP":
                            case 95:
                                message.criterionError = 95;
                                break;
                            }
                            switch (object.customerError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.customerError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.customerError = 1;
                                break;
                            case "STATUS_CHANGE_DISALLOWED":
                            case 2:
                                message.customerError = 2;
                                break;
                            case "ACCOUNT_NOT_SET_UP":
                            case 3:
                                message.customerError = 3;
                                break;
                            }
                            switch (object.dateError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.dateError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.dateError = 1;
                                break;
                            case "INVALID_FIELD_VALUES_IN_DATE":
                            case 2:
                                message.dateError = 2;
                                break;
                            case "INVALID_FIELD_VALUES_IN_DATE_TIME":
                            case 3:
                                message.dateError = 3;
                                break;
                            case "INVALID_STRING_DATE":
                            case 4:
                                message.dateError = 4;
                                break;
                            case "INVALID_STRING_DATE_TIME_MICROS":
                            case 6:
                                message.dateError = 6;
                                break;
                            case "INVALID_STRING_DATE_TIME_SECONDS":
                            case 11:
                                message.dateError = 11;
                                break;
                            case "INVALID_STRING_DATE_TIME_SECONDS_WITH_OFFSET":
                            case 12:
                                message.dateError = 12;
                                break;
                            case "EARLIER_THAN_MINIMUM_DATE":
                            case 7:
                                message.dateError = 7;
                                break;
                            case "LATER_THAN_MAXIMUM_DATE":
                            case 8:
                                message.dateError = 8;
                                break;
                            case "DATE_RANGE_MINIMUM_DATE_LATER_THAN_MAXIMUM_DATE":
                            case 9:
                                message.dateError = 9;
                                break;
                            case "DATE_RANGE_MINIMUM_AND_MAXIMUM_DATES_BOTH_NULL":
                            case 10:
                                message.dateError = 10;
                                break;
                            }
                            switch (object.dateRangeError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.dateRangeError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.dateRangeError = 1;
                                break;
                            case "INVALID_DATE":
                            case 2:
                                message.dateRangeError = 2;
                                break;
                            case "START_DATE_AFTER_END_DATE":
                            case 3:
                                message.dateRangeError = 3;
                                break;
                            case "CANNOT_SET_DATE_TO_PAST":
                            case 4:
                                message.dateRangeError = 4;
                                break;
                            case "AFTER_MAXIMUM_ALLOWABLE_DATE":
                            case 5:
                                message.dateRangeError = 5;
                                break;
                            case "CANNOT_MODIFY_START_DATE_IF_ALREADY_STARTED":
                            case 6:
                                message.dateRangeError = 6;
                                break;
                            }
                            switch (object.distinctError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.distinctError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.distinctError = 1;
                                break;
                            case "DUPLICATE_ELEMENT":
                            case 2:
                                message.distinctError = 2;
                                break;
                            case "DUPLICATE_TYPE":
                            case 3:
                                message.distinctError = 3;
                                break;
                            }
                            switch (object.feedAttributeReferenceError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.feedAttributeReferenceError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.feedAttributeReferenceError = 1;
                                break;
                            case "CANNOT_REFERENCE_REMOVED_FEED":
                            case 2:
                                message.feedAttributeReferenceError = 2;
                                break;
                            case "INVALID_FEED_NAME":
                            case 3:
                                message.feedAttributeReferenceError = 3;
                                break;
                            case "INVALID_FEED_ATTRIBUTE_NAME":
                            case 4:
                                message.feedAttributeReferenceError = 4;
                                break;
                            }
                            switch (object.functionError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.functionError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.functionError = 1;
                                break;
                            case "INVALID_FUNCTION_FORMAT":
                            case 2:
                                message.functionError = 2;
                                break;
                            case "DATA_TYPE_MISMATCH":
                            case 3:
                                message.functionError = 3;
                                break;
                            case "INVALID_CONJUNCTION_OPERANDS":
                            case 4:
                                message.functionError = 4;
                                break;
                            case "INVALID_NUMBER_OF_OPERANDS":
                            case 5:
                                message.functionError = 5;
                                break;
                            case "INVALID_OPERAND_TYPE":
                            case 6:
                                message.functionError = 6;
                                break;
                            case "INVALID_OPERATOR":
                            case 7:
                                message.functionError = 7;
                                break;
                            case "INVALID_REQUEST_CONTEXT_TYPE":
                            case 8:
                                message.functionError = 8;
                                break;
                            case "INVALID_FUNCTION_FOR_CALL_PLACEHOLDER":
                            case 9:
                                message.functionError = 9;
                                break;
                            case "INVALID_FUNCTION_FOR_PLACEHOLDER":
                            case 10:
                                message.functionError = 10;
                                break;
                            case "INVALID_OPERAND":
                            case 11:
                                message.functionError = 11;
                                break;
                            case "MISSING_CONSTANT_OPERAND_VALUE":
                            case 12:
                                message.functionError = 12;
                                break;
                            case "INVALID_CONSTANT_OPERAND_VALUE":
                            case 13:
                                message.functionError = 13;
                                break;
                            case "INVALID_NESTING":
                            case 14:
                                message.functionError = 14;
                                break;
                            case "MULTIPLE_FEED_IDS_NOT_SUPPORTED":
                            case 15:
                                message.functionError = 15;
                                break;
                            case "INVALID_FUNCTION_FOR_FEED_WITH_FIXED_SCHEMA":
                            case 16:
                                message.functionError = 16;
                                break;
                            case "INVALID_ATTRIBUTE_NAME":
                            case 17:
                                message.functionError = 17;
                                break;
                            }
                            switch (object.functionParsingError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.functionParsingError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.functionParsingError = 1;
                                break;
                            case "NO_MORE_INPUT":
                            case 2:
                                message.functionParsingError = 2;
                                break;
                            case "EXPECTED_CHARACTER":
                            case 3:
                                message.functionParsingError = 3;
                                break;
                            case "UNEXPECTED_SEPARATOR":
                            case 4:
                                message.functionParsingError = 4;
                                break;
                            case "UNMATCHED_LEFT_BRACKET":
                            case 5:
                                message.functionParsingError = 5;
                                break;
                            case "UNMATCHED_RIGHT_BRACKET":
                            case 6:
                                message.functionParsingError = 6;
                                break;
                            case "TOO_MANY_NESTED_FUNCTIONS":
                            case 7:
                                message.functionParsingError = 7;
                                break;
                            case "MISSING_RIGHT_HAND_OPERAND":
                            case 8:
                                message.functionParsingError = 8;
                                break;
                            case "INVALID_OPERATOR_NAME":
                            case 9:
                                message.functionParsingError = 9;
                                break;
                            case "FEED_ATTRIBUTE_OPERAND_ARGUMENT_NOT_INTEGER":
                            case 10:
                                message.functionParsingError = 10;
                                break;
                            case "NO_OPERANDS":
                            case 11:
                                message.functionParsingError = 11;
                                break;
                            case "TOO_MANY_OPERANDS":
                            case 12:
                                message.functionParsingError = 12;
                                break;
                            }
                            switch (object.idError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.idError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.idError = 1;
                                break;
                            case "NOT_FOUND":
                            case 2:
                                message.idError = 2;
                                break;
                            }
                            switch (object.imageError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.imageError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.imageError = 1;
                                break;
                            case "INVALID_IMAGE":
                            case 2:
                                message.imageError = 2;
                                break;
                            case "STORAGE_ERROR":
                            case 3:
                                message.imageError = 3;
                                break;
                            case "BAD_REQUEST":
                            case 4:
                                message.imageError = 4;
                                break;
                            case "UNEXPECTED_SIZE":
                            case 5:
                                message.imageError = 5;
                                break;
                            case "ANIMATED_NOT_ALLOWED":
                            case 6:
                                message.imageError = 6;
                                break;
                            case "ANIMATION_TOO_LONG":
                            case 7:
                                message.imageError = 7;
                                break;
                            case "SERVER_ERROR":
                            case 8:
                                message.imageError = 8;
                                break;
                            case "CMYK_JPEG_NOT_ALLOWED":
                            case 9:
                                message.imageError = 9;
                                break;
                            case "FLASH_NOT_ALLOWED":
                            case 10:
                                message.imageError = 10;
                                break;
                            case "FLASH_WITHOUT_CLICKTAG":
                            case 11:
                                message.imageError = 11;
                                break;
                            case "FLASH_ERROR_AFTER_FIXING_CLICK_TAG":
                            case 12:
                                message.imageError = 12;
                                break;
                            case "ANIMATED_VISUAL_EFFECT":
                            case 13:
                                message.imageError = 13;
                                break;
                            case "FLASH_ERROR":
                            case 14:
                                message.imageError = 14;
                                break;
                            case "LAYOUT_PROBLEM":
                            case 15:
                                message.imageError = 15;
                                break;
                            case "PROBLEM_READING_IMAGE_FILE":
                            case 16:
                                message.imageError = 16;
                                break;
                            case "ERROR_STORING_IMAGE":
                            case 17:
                                message.imageError = 17;
                                break;
                            case "ASPECT_RATIO_NOT_ALLOWED":
                            case 18:
                                message.imageError = 18;
                                break;
                            case "FLASH_HAS_NETWORK_OBJECTS":
                            case 19:
                                message.imageError = 19;
                                break;
                            case "FLASH_HAS_NETWORK_METHODS":
                            case 20:
                                message.imageError = 20;
                                break;
                            case "FLASH_HAS_URL":
                            case 21:
                                message.imageError = 21;
                                break;
                            case "FLASH_HAS_MOUSE_TRACKING":
                            case 22:
                                message.imageError = 22;
                                break;
                            case "FLASH_HAS_RANDOM_NUM":
                            case 23:
                                message.imageError = 23;
                                break;
                            case "FLASH_SELF_TARGETS":
                            case 24:
                                message.imageError = 24;
                                break;
                            case "FLASH_BAD_GETURL_TARGET":
                            case 25:
                                message.imageError = 25;
                                break;
                            case "FLASH_VERSION_NOT_SUPPORTED":
                            case 26:
                                message.imageError = 26;
                                break;
                            case "FLASH_WITHOUT_HARD_CODED_CLICK_URL":
                            case 27:
                                message.imageError = 27;
                                break;
                            case "INVALID_FLASH_FILE":
                            case 28:
                                message.imageError = 28;
                                break;
                            case "FAILED_TO_FIX_CLICK_TAG_IN_FLASH":
                            case 29:
                                message.imageError = 29;
                                break;
                            case "FLASH_ACCESSES_NETWORK_RESOURCES":
                            case 30:
                                message.imageError = 30;
                                break;
                            case "FLASH_EXTERNAL_JS_CALL":
                            case 31:
                                message.imageError = 31;
                                break;
                            case "FLASH_EXTERNAL_FS_CALL":
                            case 32:
                                message.imageError = 32;
                                break;
                            case "FILE_TOO_LARGE":
                            case 33:
                                message.imageError = 33;
                                break;
                            case "IMAGE_DATA_TOO_LARGE":
                            case 34:
                                message.imageError = 34;
                                break;
                            case "IMAGE_PROCESSING_ERROR":
                            case 35:
                                message.imageError = 35;
                                break;
                            case "IMAGE_TOO_SMALL":
                            case 36:
                                message.imageError = 36;
                                break;
                            case "INVALID_INPUT":
                            case 37:
                                message.imageError = 37;
                                break;
                            case "PROBLEM_READING_FILE":
                            case 38:
                                message.imageError = 38;
                                break;
                            }
                            switch (object.languageCodeError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.languageCodeError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.languageCodeError = 1;
                                break;
                            case "LANGUAGE_CODE_NOT_FOUND":
                            case 2:
                                message.languageCodeError = 2;
                                break;
                            case "INVALID_LANGUAGE_CODE":
                            case 3:
                                message.languageCodeError = 3;
                                break;
                            }
                            switch (object.mediaBundleError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.mediaBundleError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.mediaBundleError = 1;
                                break;
                            case "BAD_REQUEST":
                            case 3:
                                message.mediaBundleError = 3;
                                break;
                            case "DOUBLECLICK_BUNDLE_NOT_ALLOWED":
                            case 4:
                                message.mediaBundleError = 4;
                                break;
                            case "EXTERNAL_URL_NOT_ALLOWED":
                            case 5:
                                message.mediaBundleError = 5;
                                break;
                            case "FILE_TOO_LARGE":
                            case 6:
                                message.mediaBundleError = 6;
                                break;
                            case "GOOGLE_WEB_DESIGNER_ZIP_FILE_NOT_PUBLISHED":
                            case 7:
                                message.mediaBundleError = 7;
                                break;
                            case "INVALID_INPUT":
                            case 8:
                                message.mediaBundleError = 8;
                                break;
                            case "INVALID_MEDIA_BUNDLE":
                            case 9:
                                message.mediaBundleError = 9;
                                break;
                            case "INVALID_MEDIA_BUNDLE_ENTRY":
                            case 10:
                                message.mediaBundleError = 10;
                                break;
                            case "INVALID_MIME_TYPE":
                            case 11:
                                message.mediaBundleError = 11;
                                break;
                            case "INVALID_PATH":
                            case 12:
                                message.mediaBundleError = 12;
                                break;
                            case "INVALID_URL_REFERENCE":
                            case 13:
                                message.mediaBundleError = 13;
                                break;
                            case "MEDIA_DATA_TOO_LARGE":
                            case 14:
                                message.mediaBundleError = 14;
                                break;
                            case "MISSING_PRIMARY_MEDIA_BUNDLE_ENTRY":
                            case 15:
                                message.mediaBundleError = 15;
                                break;
                            case "SERVER_ERROR":
                            case 16:
                                message.mediaBundleError = 16;
                                break;
                            case "STORAGE_ERROR":
                            case 17:
                                message.mediaBundleError = 17;
                                break;
                            case "SWIFFY_BUNDLE_NOT_ALLOWED":
                            case 18:
                                message.mediaBundleError = 18;
                                break;
                            case "TOO_MANY_FILES":
                            case 19:
                                message.mediaBundleError = 19;
                                break;
                            case "UNEXPECTED_SIZE":
                            case 20:
                                message.mediaBundleError = 20;
                                break;
                            case "UNSUPPORTED_GOOGLE_WEB_DESIGNER_ENVIRONMENT":
                            case 21:
                                message.mediaBundleError = 21;
                                break;
                            case "UNSUPPORTED_HTML5_FEATURE":
                            case 22:
                                message.mediaBundleError = 22;
                                break;
                            case "URL_IN_MEDIA_BUNDLE_NOT_SSL_COMPLIANT":
                            case 23:
                                message.mediaBundleError = 23;
                                break;
                            case "CUSTOM_EXIT_NOT_ALLOWED":
                            case 24:
                                message.mediaBundleError = 24;
                                break;
                            }
                            switch (object.mediaUploadError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.mediaUploadError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.mediaUploadError = 1;
                                break;
                            case "FILE_TOO_BIG":
                            case 2:
                                message.mediaUploadError = 2;
                                break;
                            case "UNPARSEABLE_IMAGE":
                            case 3:
                                message.mediaUploadError = 3;
                                break;
                            case "ANIMATED_IMAGE_NOT_ALLOWED":
                            case 4:
                                message.mediaUploadError = 4;
                                break;
                            case "FORMAT_NOT_ALLOWED":
                            case 5:
                                message.mediaUploadError = 5;
                                break;
                            }
                            switch (object.mediaFileError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.mediaFileError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.mediaFileError = 1;
                                break;
                            case "CANNOT_CREATE_STANDARD_ICON":
                            case 2:
                                message.mediaFileError = 2;
                                break;
                            case "CANNOT_SELECT_STANDARD_ICON_WITH_OTHER_TYPES":
                            case 3:
                                message.mediaFileError = 3;
                                break;
                            case "CANNOT_SPECIFY_MEDIA_FILE_ID_AND_DATA":
                            case 4:
                                message.mediaFileError = 4;
                                break;
                            case "DUPLICATE_MEDIA":
                            case 5:
                                message.mediaFileError = 5;
                                break;
                            case "EMPTY_FIELD":
                            case 6:
                                message.mediaFileError = 6;
                                break;
                            case "RESOURCE_REFERENCED_IN_MULTIPLE_OPS":
                            case 7:
                                message.mediaFileError = 7;
                                break;
                            case "FIELD_NOT_SUPPORTED_FOR_MEDIA_SUB_TYPE":
                            case 8:
                                message.mediaFileError = 8;
                                break;
                            case "INVALID_MEDIA_FILE_ID":
                            case 9:
                                message.mediaFileError = 9;
                                break;
                            case "INVALID_MEDIA_SUB_TYPE":
                            case 10:
                                message.mediaFileError = 10;
                                break;
                            case "INVALID_MEDIA_FILE_TYPE":
                            case 11:
                                message.mediaFileError = 11;
                                break;
                            case "INVALID_MIME_TYPE":
                            case 12:
                                message.mediaFileError = 12;
                                break;
                            case "INVALID_REFERENCE_ID":
                            case 13:
                                message.mediaFileError = 13;
                                break;
                            case "INVALID_YOU_TUBE_ID":
                            case 14:
                                message.mediaFileError = 14;
                                break;
                            case "MEDIA_FILE_FAILED_TRANSCODING":
                            case 15:
                                message.mediaFileError = 15;
                                break;
                            case "MEDIA_NOT_TRANSCODED":
                            case 16:
                                message.mediaFileError = 16;
                                break;
                            case "MEDIA_TYPE_DOES_NOT_MATCH_MEDIA_FILE_TYPE":
                            case 17:
                                message.mediaFileError = 17;
                                break;
                            case "NO_FIELDS_SPECIFIED":
                            case 18:
                                message.mediaFileError = 18;
                                break;
                            case "NULL_REFERENCE_ID_AND_MEDIA_ID":
                            case 19:
                                message.mediaFileError = 19;
                                break;
                            case "TOO_LONG":
                            case 20:
                                message.mediaFileError = 20;
                                break;
                            case "UNSUPPORTED_TYPE":
                            case 21:
                                message.mediaFileError = 21;
                                break;
                            case "YOU_TUBE_SERVICE_UNAVAILABLE":
                            case 22:
                                message.mediaFileError = 22;
                                break;
                            case "YOU_TUBE_VIDEO_HAS_NON_POSITIVE_DURATION":
                            case 23:
                                message.mediaFileError = 23;
                                break;
                            case "YOU_TUBE_VIDEO_NOT_FOUND":
                            case 24:
                                message.mediaFileError = 24;
                                break;
                            }
                            switch (object.multiplierError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.multiplierError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.multiplierError = 1;
                                break;
                            case "MULTIPLIER_TOO_HIGH":
                            case 2:
                                message.multiplierError = 2;
                                break;
                            case "MULTIPLIER_TOO_LOW":
                            case 3:
                                message.multiplierError = 3;
                                break;
                            case "TOO_MANY_FRACTIONAL_DIGITS":
                            case 4:
                                message.multiplierError = 4;
                                break;
                            case "MULTIPLIER_NOT_ALLOWED_FOR_BIDDING_STRATEGY":
                            case 5:
                                message.multiplierError = 5;
                                break;
                            case "MULTIPLIER_NOT_ALLOWED_WHEN_BASE_BID_IS_MISSING":
                            case 6:
                                message.multiplierError = 6;
                                break;
                            case "NO_MULTIPLIER_SPECIFIED":
                            case 7:
                                message.multiplierError = 7;
                                break;
                            case "MULTIPLIER_CAUSES_BID_TO_EXCEED_DAILY_BUDGET":
                            case 8:
                                message.multiplierError = 8;
                                break;
                            case "MULTIPLIER_CAUSES_BID_TO_EXCEED_MONTHLY_BUDGET":
                            case 9:
                                message.multiplierError = 9;
                                break;
                            case "MULTIPLIER_CAUSES_BID_TO_EXCEED_CUSTOM_BUDGET":
                            case 10:
                                message.multiplierError = 10;
                                break;
                            case "MULTIPLIER_CAUSES_BID_TO_EXCEED_MAX_ALLOWED_BID":
                            case 11:
                                message.multiplierError = 11;
                                break;
                            case "BID_LESS_THAN_MIN_ALLOWED_BID_WITH_MULTIPLIER":
                            case 12:
                                message.multiplierError = 12;
                                break;
                            case "MULTIPLIER_AND_BIDDING_STRATEGY_TYPE_MISMATCH":
                            case 13:
                                message.multiplierError = 13;
                                break;
                            }
                            switch (object.newResourceCreationError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.newResourceCreationError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.newResourceCreationError = 1;
                                break;
                            case "CANNOT_SET_ID_FOR_CREATE":
                            case 2:
                                message.newResourceCreationError = 2;
                                break;
                            case "DUPLICATE_TEMP_IDS":
                            case 3:
                                message.newResourceCreationError = 3;
                                break;
                            case "TEMP_ID_RESOURCE_HAD_ERRORS":
                            case 4:
                                message.newResourceCreationError = 4;
                                break;
                            }
                            switch (object.notEmptyError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.notEmptyError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.notEmptyError = 1;
                                break;
                            case "EMPTY_LIST":
                            case 2:
                                message.notEmptyError = 2;
                                break;
                            }
                            switch (object.nullError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.nullError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.nullError = 1;
                                break;
                            case "NULL_CONTENT":
                            case 2:
                                message.nullError = 2;
                                break;
                            }
                            switch (object.operatorError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.operatorError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.operatorError = 1;
                                break;
                            case "OPERATOR_NOT_SUPPORTED":
                            case 2:
                                message.operatorError = 2;
                                break;
                            }
                            switch (object.rangeError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.rangeError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.rangeError = 1;
                                break;
                            case "TOO_LOW":
                            case 2:
                                message.rangeError = 2;
                                break;
                            case "TOO_HIGH":
                            case 3:
                                message.rangeError = 3;
                                break;
                            }
                            switch (object.recommendationError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.recommendationError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.recommendationError = 1;
                                break;
                            case "BUDGET_AMOUNT_TOO_SMALL":
                            case 2:
                                message.recommendationError = 2;
                                break;
                            case "BUDGET_AMOUNT_TOO_LARGE":
                            case 3:
                                message.recommendationError = 3;
                                break;
                            case "INVALID_BUDGET_AMOUNT":
                            case 4:
                                message.recommendationError = 4;
                                break;
                            case "POLICY_ERROR":
                            case 5:
                                message.recommendationError = 5;
                                break;
                            case "INVALID_BID_AMOUNT":
                            case 6:
                                message.recommendationError = 6;
                                break;
                            case "ADGROUP_KEYWORD_LIMIT":
                            case 7:
                                message.recommendationError = 7;
                                break;
                            case "RECOMMENDATION_ALREADY_APPLIED":
                            case 8:
                                message.recommendationError = 8;
                                break;
                            case "RECOMMENDATION_INVALIDATED":
                            case 9:
                                message.recommendationError = 9;
                                break;
                            case "TOO_MANY_OPERATIONS":
                            case 10:
                                message.recommendationError = 10;
                                break;
                            case "NO_OPERATIONS":
                            case 11:
                                message.recommendationError = 11;
                                break;
                            case "DIFFERENT_TYPES_NOT_SUPPORTED":
                            case 12:
                                message.recommendationError = 12;
                                break;
                            case "DUPLICATE_RESOURCE_NAME":
                            case 13:
                                message.recommendationError = 13;
                                break;
                            case "RECOMMENDATION_ALREADY_DISMISSED":
                            case 14:
                                message.recommendationError = 14;
                                break;
                            case "INVALID_APPLY_REQUEST":
                            case 15:
                                message.recommendationError = 15;
                                break;
                            }
                            switch (object.regionCodeError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.regionCodeError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.regionCodeError = 1;
                                break;
                            case "INVALID_REGION_CODE":
                            case 2:
                                message.regionCodeError = 2;
                                break;
                            }
                            switch (object.settingError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.settingError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.settingError = 1;
                                break;
                            case "SETTING_TYPE_IS_NOT_AVAILABLE":
                            case 3:
                                message.settingError = 3;
                                break;
                            case "SETTING_TYPE_IS_NOT_COMPATIBLE_WITH_CAMPAIGN":
                            case 4:
                                message.settingError = 4;
                                break;
                            case "TARGETING_SETTING_CONTAINS_INVALID_CRITERION_TYPE_GROUP":
                            case 5:
                                message.settingError = 5;
                                break;
                            case "TARGETING_SETTING_DEMOGRAPHIC_CRITERION_TYPE_GROUPS_MUST_BE_SET_TO_TARGET_ALL":
                            case 6:
                                message.settingError = 6;
                                break;
                            case "TARGETING_SETTING_CANNOT_CHANGE_TARGET_ALL_TO_FALSE_FOR_DEMOGRAPHIC_CRITERION_TYPE_GROUP":
                            case 7:
                                message.settingError = 7;
                                break;
                            case "DYNAMIC_SEARCH_ADS_SETTING_AT_LEAST_ONE_FEED_ID_MUST_BE_PRESENT":
                            case 8:
                                message.settingError = 8;
                                break;
                            case "DYNAMIC_SEARCH_ADS_SETTING_CONTAINS_INVALID_DOMAIN_NAME":
                            case 9:
                                message.settingError = 9;
                                break;
                            case "DYNAMIC_SEARCH_ADS_SETTING_CONTAINS_SUBDOMAIN_NAME":
                            case 10:
                                message.settingError = 10;
                                break;
                            case "DYNAMIC_SEARCH_ADS_SETTING_CONTAINS_INVALID_LANGUAGE_CODE":
                            case 11:
                                message.settingError = 11;
                                break;
                            case "TARGET_ALL_IS_NOT_ALLOWED_FOR_PLACEMENT_IN_SEARCH_CAMPAIGN":
                            case 12:
                                message.settingError = 12;
                                break;
                            case "UNIVERSAL_APP_CAMPAIGN_SETTING_DUPLICATE_DESCRIPTION":
                            case 13:
                                message.settingError = 13;
                                break;
                            case "UNIVERSAL_APP_CAMPAIGN_SETTING_DESCRIPTION_LINE_WIDTH_TOO_LONG":
                            case 14:
                                message.settingError = 14;
                                break;
                            case "UNIVERSAL_APP_CAMPAIGN_SETTING_APP_ID_CANNOT_BE_MODIFIED":
                            case 15:
                                message.settingError = 15;
                                break;
                            case "TOO_MANY_YOUTUBE_MEDIA_IDS_IN_UNIVERSAL_APP_CAMPAIGN":
                            case 16:
                                message.settingError = 16;
                                break;
                            case "TOO_MANY_IMAGE_MEDIA_IDS_IN_UNIVERSAL_APP_CAMPAIGN":
                            case 17:
                                message.settingError = 17;
                                break;
                            case "MEDIA_INCOMPATIBLE_FOR_UNIVERSAL_APP_CAMPAIGN":
                            case 18:
                                message.settingError = 18;
                                break;
                            case "TOO_MANY_EXCLAMATION_MARKS":
                            case 19:
                                message.settingError = 19;
                                break;
                            }
                            switch (object.stringFormatError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.stringFormatError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.stringFormatError = 1;
                                break;
                            case "ILLEGAL_CHARS":
                            case 2:
                                message.stringFormatError = 2;
                                break;
                            case "INVALID_FORMAT":
                            case 3:
                                message.stringFormatError = 3;
                                break;
                            }
                            switch (object.stringLengthError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.stringLengthError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.stringLengthError = 1;
                                break;
                            case "TOO_SHORT":
                            case 2:
                                message.stringLengthError = 2;
                                break;
                            case "TOO_LONG":
                            case 3:
                                message.stringLengthError = 3;
                                break;
                            }
                            switch (object.operationAccessDeniedError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.operationAccessDeniedError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.operationAccessDeniedError = 1;
                                break;
                            case "ACTION_NOT_PERMITTED":
                            case 2:
                                message.operationAccessDeniedError = 2;
                                break;
                            case "CREATE_OPERATION_NOT_PERMITTED":
                            case 3:
                                message.operationAccessDeniedError = 3;
                                break;
                            case "REMOVE_OPERATION_NOT_PERMITTED":
                            case 4:
                                message.operationAccessDeniedError = 4;
                                break;
                            case "UPDATE_OPERATION_NOT_PERMITTED":
                            case 5:
                                message.operationAccessDeniedError = 5;
                                break;
                            case "MUTATE_ACTION_NOT_PERMITTED_FOR_CLIENT":
                            case 6:
                                message.operationAccessDeniedError = 6;
                                break;
                            case "OPERATION_NOT_PERMITTED_FOR_CAMPAIGN_TYPE":
                            case 7:
                                message.operationAccessDeniedError = 7;
                                break;
                            case "CREATE_AS_REMOVED_NOT_PERMITTED":
                            case 8:
                                message.operationAccessDeniedError = 8;
                                break;
                            case "OPERATION_NOT_PERMITTED_FOR_REMOVED_RESOURCE":
                            case 9:
                                message.operationAccessDeniedError = 9;
                                break;
                            case "OPERATION_NOT_PERMITTED_FOR_AD_GROUP_TYPE":
                            case 10:
                                message.operationAccessDeniedError = 10;
                                break;
                            case "MUTATE_NOT_PERMITTED_FOR_CUSTOMER":
                            case 11:
                                message.operationAccessDeniedError = 11;
                                break;
                            }
                            switch (object.resourceAccessDeniedError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.resourceAccessDeniedError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.resourceAccessDeniedError = 1;
                                break;
                            case "WRITE_ACCESS_DENIED":
                            case 3:
                                message.resourceAccessDeniedError = 3;
                                break;
                            }
                            switch (object.resourceCountLimitExceededError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.resourceCountLimitExceededError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.resourceCountLimitExceededError = 1;
                                break;
                            case "ACCOUNT_LIMIT":
                            case 2:
                                message.resourceCountLimitExceededError = 2;
                                break;
                            case "CAMPAIGN_LIMIT":
                            case 3:
                                message.resourceCountLimitExceededError = 3;
                                break;
                            case "ADGROUP_LIMIT":
                            case 4:
                                message.resourceCountLimitExceededError = 4;
                                break;
                            case "AD_GROUP_AD_LIMIT":
                            case 5:
                                message.resourceCountLimitExceededError = 5;
                                break;
                            case "AD_GROUP_CRITERION_LIMIT":
                            case 6:
                                message.resourceCountLimitExceededError = 6;
                                break;
                            case "SHARED_SET_LIMIT":
                            case 7:
                                message.resourceCountLimitExceededError = 7;
                                break;
                            case "MATCHING_FUNCTION_LIMIT":
                            case 8:
                                message.resourceCountLimitExceededError = 8;
                                break;
                            case "RESPONSE_ROW_LIMIT_EXCEEDED":
                            case 9:
                                message.resourceCountLimitExceededError = 9;
                                break;
                            }
                            switch (object.youtubeVideoRegistrationError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.youtubeVideoRegistrationError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.youtubeVideoRegistrationError = 1;
                                break;
                            case "VIDEO_NOT_FOUND":
                            case 2:
                                message.youtubeVideoRegistrationError = 2;
                                break;
                            case "VIDEO_NOT_ACCESSIBLE":
                            case 3:
                                message.youtubeVideoRegistrationError = 3;
                                break;
                            }
                            switch (object.adGroupBidModifierError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.adGroupBidModifierError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.adGroupBidModifierError = 1;
                                break;
                            case "CRITERION_ID_NOT_SUPPORTED":
                            case 2:
                                message.adGroupBidModifierError = 2;
                                break;
                            case "CANNOT_OVERRIDE_OPTED_OUT_CAMPAIGN_CRITERION_BID_MODIFIER":
                            case 3:
                                message.adGroupBidModifierError = 3;
                                break;
                            }
                            switch (object.contextError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.contextError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.contextError = 1;
                                break;
                            case "OPERATION_NOT_PERMITTED_FOR_CONTEXT":
                            case 2:
                                message.contextError = 2;
                                break;
                            case "OPERATION_NOT_PERMITTED_FOR_REMOVED_RESOURCE":
                            case 3:
                                message.contextError = 3;
                                break;
                            }
                            switch (object.fieldError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.fieldError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.fieldError = 1;
                                break;
                            case "REQUIRED":
                            case 2:
                                message.fieldError = 2;
                                break;
                            case "IMMUTABLE_FIELD":
                            case 3:
                                message.fieldError = 3;
                                break;
                            case "INVALID_VALUE":
                            case 4:
                                message.fieldError = 4;
                                break;
                            case "VALUE_MUST_BE_UNSET":
                            case 5:
                                message.fieldError = 5;
                                break;
                            case "REQUIRED_NONEMPTY_LIST":
                            case 6:
                                message.fieldError = 6;
                                break;
                            case "FIELD_CANNOT_BE_CLEARED":
                            case 7:
                                message.fieldError = 7;
                                break;
                            case "BLACKLISTED_VALUE":
                            case 8:
                                message.fieldError = 8;
                                break;
                            }
                            switch (object.sharedSetError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.sharedSetError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.sharedSetError = 1;
                                break;
                            case "CUSTOMER_CANNOT_CREATE_SHARED_SET_OF_THIS_TYPE":
                            case 2:
                                message.sharedSetError = 2;
                                break;
                            case "DUPLICATE_NAME":
                            case 3:
                                message.sharedSetError = 3;
                                break;
                            case "SHARED_SET_REMOVED":
                            case 4:
                                message.sharedSetError = 4;
                                break;
                            case "SHARED_SET_IN_USE":
                            case 5:
                                message.sharedSetError = 5;
                                break;
                            }
                            switch (object.sharedCriterionError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.sharedCriterionError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.sharedCriterionError = 1;
                                break;
                            case "CRITERION_TYPE_NOT_ALLOWED_FOR_SHARED_SET_TYPE":
                            case 2:
                                message.sharedCriterionError = 2;
                                break;
                            }
                            switch (object.campaignSharedSetError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.campaignSharedSetError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.campaignSharedSetError = 1;
                                break;
                            case "SHARED_SET_ACCESS_DENIED":
                            case 2:
                                message.campaignSharedSetError = 2;
                                break;
                            }
                            switch (object.conversionActionError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.conversionActionError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.conversionActionError = 1;
                                break;
                            case "DUPLICATE_NAME":
                            case 2:
                                message.conversionActionError = 2;
                                break;
                            case "DUPLICATE_APP_ID":
                            case 3:
                                message.conversionActionError = 3;
                                break;
                            case "TWO_CONVERSION_ACTIONS_BIDDING_ON_SAME_APP_DOWNLOAD":
                            case 4:
                                message.conversionActionError = 4;
                                break;
                            case "BIDDING_ON_SAME_APP_DOWNLOAD_AS_GLOBAL_ACTION":
                            case 5:
                                message.conversionActionError = 5;
                                break;
                            case "DATA_DRIVEN_MODEL_WAS_NEVER_GENERATED":
                            case 6:
                                message.conversionActionError = 6;
                                break;
                            case "DATA_DRIVEN_MODEL_EXPIRED":
                            case 7:
                                message.conversionActionError = 7;
                                break;
                            case "DATA_DRIVEN_MODEL_STALE":
                            case 8:
                                message.conversionActionError = 8;
                                break;
                            case "DATA_DRIVEN_MODEL_UNKNOWN":
                            case 9:
                                message.conversionActionError = 9;
                                break;
                            }
                            switch (object.conversionAdjustmentUploadError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.conversionAdjustmentUploadError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.conversionAdjustmentUploadError = 1;
                                break;
                            case "TOO_RECENT_CONVERSION_ACTION":
                            case 2:
                                message.conversionAdjustmentUploadError = 2;
                                break;
                            case "INVALID_CONVERSION_ACTION":
                            case 3:
                                message.conversionAdjustmentUploadError = 3;
                                break;
                            case "CONVERSION_ALREADY_RETRACTED":
                            case 4:
                                message.conversionAdjustmentUploadError = 4;
                                break;
                            case "CONVERSION_NOT_FOUND":
                            case 5:
                                message.conversionAdjustmentUploadError = 5;
                                break;
                            case "CONVERSION_EXPIRED":
                            case 6:
                                message.conversionAdjustmentUploadError = 6;
                                break;
                            case "ADJUSTMENT_PRECEDES_CONVERSION":
                            case 7:
                                message.conversionAdjustmentUploadError = 7;
                                break;
                            case "MORE_RECENT_RESTATEMENT_FOUND":
                            case 8:
                                message.conversionAdjustmentUploadError = 8;
                                break;
                            case "TOO_RECENT_CONVERSION":
                            case 9:
                                message.conversionAdjustmentUploadError = 9;
                                break;
                            case "CANNOT_RESTATE_CONVERSION_ACTION_THAT_ALWAYS_USES_DEFAULT_CONVERSION_VALUE":
                            case 10:
                                message.conversionAdjustmentUploadError = 10;
                                break;
                            }
                            switch (object.conversionUploadError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.conversionUploadError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.conversionUploadError = 1;
                                break;
                            case "TOO_MANY_CONVERSIONS_IN_REQUEST":
                            case 2:
                                message.conversionUploadError = 2;
                                break;
                            case "UNPARSEABLE_GCLID":
                            case 3:
                                message.conversionUploadError = 3;
                                break;
                            case "CONVERSION_PRECEDES_GCLID":
                            case 4:
                                message.conversionUploadError = 4;
                                break;
                            case "EXPIRED_GCLID":
                            case 5:
                                message.conversionUploadError = 5;
                                break;
                            case "TOO_RECENT_GCLID":
                            case 6:
                                message.conversionUploadError = 6;
                                break;
                            case "GCLID_NOT_FOUND":
                            case 7:
                                message.conversionUploadError = 7;
                                break;
                            case "UNAUTHORIZED_CUSTOMER":
                            case 8:
                                message.conversionUploadError = 8;
                                break;
                            case "INVALID_CONVERSION_ACTION":
                            case 9:
                                message.conversionUploadError = 9;
                                break;
                            case "TOO_RECENT_CONVERSION_ACTION":
                            case 10:
                                message.conversionUploadError = 10;
                                break;
                            case "CONVERSION_TRACKING_NOT_ENABLED_AT_IMPRESSION_TIME":
                            case 11:
                                message.conversionUploadError = 11;
                                break;
                            case "EXTERNAL_ATTRIBUTION_DATA_SET_FOR_NON_EXTERNALLY_ATTRIBUTED_CONVERSION_ACTION":
                            case 12:
                                message.conversionUploadError = 12;
                                break;
                            case "EXTERNAL_ATTRIBUTION_DATA_NOT_SET_FOR_EXTERNALLY_ATTRIBUTED_CONVERSION_ACTION":
                            case 13:
                                message.conversionUploadError = 13;
                                break;
                            case "ORDER_ID_NOT_PERMITTED_FOR_EXTERNALLY_ATTRIBUTED_CONVERSION_ACTION":
                            case 14:
                                message.conversionUploadError = 14;
                                break;
                            case "ORDER_ID_ALREADY_IN_USE":
                            case 15:
                                message.conversionUploadError = 15;
                                break;
                            case "DUPLICATE_ORDER_ID":
                            case 16:
                                message.conversionUploadError = 16;
                                break;
                            case "TOO_RECENT_CALL":
                            case 17:
                                message.conversionUploadError = 17;
                                break;
                            case "EXPIRED_CALL":
                            case 18:
                                message.conversionUploadError = 18;
                                break;
                            case "CALL_NOT_FOUND":
                            case 19:
                                message.conversionUploadError = 19;
                                break;
                            case "CONVERSION_PRECEDES_CALL":
                            case 20:
                                message.conversionUploadError = 20;
                                break;
                            case "CONVERSION_TRACKING_NOT_ENABLED_AT_CALL_TIME":
                            case 21:
                                message.conversionUploadError = 21;
                                break;
                            case "UNPARSEABLE_CALLERS_PHONE_NUMBER":
                            case 22:
                                message.conversionUploadError = 22;
                                break;
                            }
                            switch (object.headerError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.headerError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.headerError = 1;
                                break;
                            case "INVALID_LOGIN_CUSTOMER_ID":
                            case 3:
                                message.headerError = 3;
                                break;
                            }
                            switch (object.databaseError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.databaseError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.databaseError = 1;
                                break;
                            case "CONCURRENT_MODIFICATION":
                            case 2:
                                message.databaseError = 2;
                                break;
                            }
                            switch (object.policyFindingError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.policyFindingError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.policyFindingError = 1;
                                break;
                            case "POLICY_FINDING":
                            case 2:
                                message.policyFindingError = 2;
                                break;
                            case "POLICY_TOPIC_NOT_FOUND":
                            case 3:
                                message.policyFindingError = 3;
                                break;
                            }
                            switch (object.enumError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.enumError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.enumError = 1;
                                break;
                            case "ENUM_VALUE_NOT_PERMITTED":
                            case 3:
                                message.enumError = 3;
                                break;
                            }
                            switch (object.keywordPlanError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.keywordPlanError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.keywordPlanError = 1;
                                break;
                            case "BID_MULTIPLIER_OUT_OF_RANGE":
                            case 2:
                                message.keywordPlanError = 2;
                                break;
                            case "BID_TOO_HIGH":
                            case 3:
                                message.keywordPlanError = 3;
                                break;
                            case "BID_TOO_LOW":
                            case 4:
                                message.keywordPlanError = 4;
                                break;
                            case "BID_TOO_MANY_FRACTIONAL_DIGITS":
                            case 5:
                                message.keywordPlanError = 5;
                                break;
                            case "DAILY_BUDGET_TOO_LOW":
                            case 6:
                                message.keywordPlanError = 6;
                                break;
                            case "DAILY_BUDGET_TOO_MANY_FRACTIONAL_DIGITS":
                            case 7:
                                message.keywordPlanError = 7;
                                break;
                            case "INVALID_VALUE":
                            case 8:
                                message.keywordPlanError = 8;
                                break;
                            case "KEYWORD_PLAN_HAS_NO_KEYWORDS":
                            case 9:
                                message.keywordPlanError = 9;
                                break;
                            case "KEYWORD_PLAN_NOT_ENABLED":
                            case 10:
                                message.keywordPlanError = 10;
                                break;
                            case "KEYWORD_PLAN_NOT_FOUND":
                            case 11:
                                message.keywordPlanError = 11;
                                break;
                            case "MISSING_BID":
                            case 13:
                                message.keywordPlanError = 13;
                                break;
                            case "MISSING_FORECAST_PERIOD":
                            case 14:
                                message.keywordPlanError = 14;
                                break;
                            case "INVALID_FORECAST_DATE_RANGE":
                            case 15:
                                message.keywordPlanError = 15;
                                break;
                            case "INVALID_NAME":
                            case 16:
                                message.keywordPlanError = 16;
                                break;
                            }
                            switch (object.keywordPlanCampaignError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.keywordPlanCampaignError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.keywordPlanCampaignError = 1;
                                break;
                            case "INVALID_NAME":
                            case 2:
                                message.keywordPlanCampaignError = 2;
                                break;
                            case "INVALID_LANGUAGES":
                            case 3:
                                message.keywordPlanCampaignError = 3;
                                break;
                            case "INVALID_GEOS":
                            case 4:
                                message.keywordPlanCampaignError = 4;
                                break;
                            case "DUPLICATE_NAME":
                            case 5:
                                message.keywordPlanCampaignError = 5;
                                break;
                            case "MAX_GEOS_EXCEEDED":
                            case 6:
                                message.keywordPlanCampaignError = 6;
                                break;
                            }
                            switch (object.keywordPlanNegativeKeywordError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.keywordPlanNegativeKeywordError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.keywordPlanNegativeKeywordError = 1;
                                break;
                            }
                            switch (object.keywordPlanAdGroupError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.keywordPlanAdGroupError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.keywordPlanAdGroupError = 1;
                                break;
                            case "INVALID_NAME":
                            case 2:
                                message.keywordPlanAdGroupError = 2;
                                break;
                            case "DUPLICATE_NAME":
                            case 3:
                                message.keywordPlanAdGroupError = 3;
                                break;
                            }
                            switch (object.keywordPlanKeywordError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.keywordPlanKeywordError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.keywordPlanKeywordError = 1;
                                break;
                            case "INVALID_KEYWORD_MATCH_TYPE":
                            case 2:
                                message.keywordPlanKeywordError = 2;
                                break;
                            case "DUPLICATE_KEYWORD":
                            case 3:
                                message.keywordPlanKeywordError = 3;
                                break;
                            case "KEYWORD_TEXT_TOO_LONG":
                            case 4:
                                message.keywordPlanKeywordError = 4;
                                break;
                            case "KEYWORD_HAS_INVALID_CHARS":
                            case 5:
                                message.keywordPlanKeywordError = 5;
                                break;
                            case "KEYWORD_HAS_TOO_MANY_WORDS":
                            case 6:
                                message.keywordPlanKeywordError = 6;
                                break;
                            case "INVALID_KEYWORD_TEXT":
                            case 7:
                                message.keywordPlanKeywordError = 7;
                                break;
                            }
                            switch (object.keywordPlanIdeaError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.keywordPlanIdeaError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.keywordPlanIdeaError = 1;
                                break;
                            case "URL_CRAWL_ERROR":
                            case 2:
                                message.keywordPlanIdeaError = 2;
                                break;
                            case "INVALID_VALUE":
                            case 3:
                                message.keywordPlanIdeaError = 3;
                                break;
                            }
                            switch (object.accountBudgetProposalError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.accountBudgetProposalError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.accountBudgetProposalError = 1;
                                break;
                            case "FIELD_MASK_NOT_ALLOWED":
                            case 2:
                                message.accountBudgetProposalError = 2;
                                break;
                            case "IMMUTABLE_FIELD":
                            case 3:
                                message.accountBudgetProposalError = 3;
                                break;
                            case "REQUIRED_FIELD_MISSING":
                            case 4:
                                message.accountBudgetProposalError = 4;
                                break;
                            case "CANNOT_CANCEL_APPROVED_PROPOSAL":
                            case 5:
                                message.accountBudgetProposalError = 5;
                                break;
                            case "CANNOT_REMOVE_UNAPPROVED_BUDGET":
                            case 6:
                                message.accountBudgetProposalError = 6;
                                break;
                            case "CANNOT_REMOVE_RUNNING_BUDGET":
                            case 7:
                                message.accountBudgetProposalError = 7;
                                break;
                            case "CANNOT_END_UNAPPROVED_BUDGET":
                            case 8:
                                message.accountBudgetProposalError = 8;
                                break;
                            case "CANNOT_END_INACTIVE_BUDGET":
                            case 9:
                                message.accountBudgetProposalError = 9;
                                break;
                            case "BUDGET_NAME_REQUIRED":
                            case 10:
                                message.accountBudgetProposalError = 10;
                                break;
                            case "CANNOT_UPDATE_OLD_BUDGET":
                            case 11:
                                message.accountBudgetProposalError = 11;
                                break;
                            case "CANNOT_END_IN_PAST":
                            case 12:
                                message.accountBudgetProposalError = 12;
                                break;
                            case "CANNOT_EXTEND_END_TIME":
                            case 13:
                                message.accountBudgetProposalError = 13;
                                break;
                            case "PURCHASE_ORDER_NUMBER_REQUIRED":
                            case 14:
                                message.accountBudgetProposalError = 14;
                                break;
                            case "PENDING_UPDATE_PROPOSAL_EXISTS":
                            case 15:
                                message.accountBudgetProposalError = 15;
                                break;
                            case "MULTIPLE_BUDGETS_NOT_ALLOWED_FOR_UNAPPROVED_BILLING_SETUP":
                            case 16:
                                message.accountBudgetProposalError = 16;
                                break;
                            case "CANNOT_UPDATE_START_TIME_FOR_STARTED_BUDGET":
                            case 17:
                                message.accountBudgetProposalError = 17;
                                break;
                            case "SPENDING_LIMIT_LOWER_THAN_ACCRUED_COST_NOT_ALLOWED":
                            case 18:
                                message.accountBudgetProposalError = 18;
                                break;
                            case "UPDATE_IS_NO_OP":
                            case 19:
                                message.accountBudgetProposalError = 19;
                                break;
                            case "END_TIME_MUST_FOLLOW_START_TIME":
                            case 20:
                                message.accountBudgetProposalError = 20;
                                break;
                            case "BUDGET_DATE_RANGE_INCOMPATIBLE_WITH_BILLING_SETUP":
                            case 21:
                                message.accountBudgetProposalError = 21;
                                break;
                            case "NOT_AUTHORIZED":
                            case 22:
                                message.accountBudgetProposalError = 22;
                                break;
                            case "INVALID_BILLING_SETUP":
                            case 23:
                                message.accountBudgetProposalError = 23;
                                break;
                            }
                            switch (object.userListError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.userListError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.userListError = 1;
                                break;
                            case "EXTERNAL_REMARKETING_USER_LIST_MUTATE_NOT_SUPPORTED":
                            case 2:
                                message.userListError = 2;
                                break;
                            case "CONCRETE_TYPE_REQUIRED":
                            case 3:
                                message.userListError = 3;
                                break;
                            case "CONVERSION_TYPE_ID_REQUIRED":
                            case 4:
                                message.userListError = 4;
                                break;
                            case "DUPLICATE_CONVERSION_TYPES":
                            case 5:
                                message.userListError = 5;
                                break;
                            case "INVALID_CONVERSION_TYPE":
                            case 6:
                                message.userListError = 6;
                                break;
                            case "INVALID_DESCRIPTION":
                            case 7:
                                message.userListError = 7;
                                break;
                            case "INVALID_NAME":
                            case 8:
                                message.userListError = 8;
                                break;
                            case "INVALID_TYPE":
                            case 9:
                                message.userListError = 9;
                                break;
                            case "CAN_NOT_ADD_LOGICAL_LIST_AS_LOGICAL_LIST_OPERAND":
                            case 10:
                                message.userListError = 10;
                                break;
                            case "INVALID_USER_LIST_LOGICAL_RULE_OPERAND":
                            case 11:
                                message.userListError = 11;
                                break;
                            case "NAME_ALREADY_USED":
                            case 12:
                                message.userListError = 12;
                                break;
                            case "NEW_CONVERSION_TYPE_NAME_REQUIRED":
                            case 13:
                                message.userListError = 13;
                                break;
                            case "CONVERSION_TYPE_NAME_ALREADY_USED":
                            case 14:
                                message.userListError = 14;
                                break;
                            case "OWNERSHIP_REQUIRED_FOR_SET":
                            case 15:
                                message.userListError = 15;
                                break;
                            case "USER_LIST_MUTATE_NOT_SUPPORTED":
                            case 16:
                                message.userListError = 16;
                                break;
                            case "INVALID_RULE":
                            case 17:
                                message.userListError = 17;
                                break;
                            case "INVALID_DATE_RANGE":
                            case 27:
                                message.userListError = 27;
                                break;
                            case "CAN_NOT_MUTATE_SENSITIVE_USERLIST":
                            case 28:
                                message.userListError = 28;
                                break;
                            case "MAX_NUM_RULEBASED_USERLISTS":
                            case 29:
                                message.userListError = 29;
                                break;
                            case "CANNOT_MODIFY_BILLABLE_RECORD_COUNT":
                            case 30:
                                message.userListError = 30;
                                break;
                            case "APP_ID_NOT_SET":
                            case 31:
                                message.userListError = 31;
                                break;
                            case "USERLIST_NAME_IS_RESERVED_FOR_SYSTEM_LIST":
                            case 32:
                                message.userListError = 32;
                                break;
                            case "ADVERTISER_NOT_WHITELISTED_FOR_USING_UPLOADED_DATA":
                            case 33:
                                message.userListError = 33;
                                break;
                            case "RULE_TYPE_IS_NOT_SUPPORTED":
                            case 34:
                                message.userListError = 34;
                                break;
                            case "CAN_NOT_ADD_A_SIMILAR_USERLIST_AS_LOGICAL_LIST_OPERAND":
                            case 35:
                                message.userListError = 35;
                                break;
                            case "CAN_NOT_MIX_CRM_BASED_IN_LOGICAL_LIST_WITH_OTHER_LISTS":
                            case 36:
                                message.userListError = 36;
                                break;
                            }
                            switch (object.changeStatusError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.changeStatusError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.changeStatusError = 1;
                                break;
                            case "START_DATE_TOO_OLD":
                            case 3:
                                message.changeStatusError = 3;
                                break;
                            }
                            switch (object.feedError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.feedError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.feedError = 1;
                                break;
                            case "ATTRIBUTE_NAMES_NOT_UNIQUE":
                            case 2:
                                message.feedError = 2;
                                break;
                            case "ATTRIBUTES_DO_NOT_MATCH_EXISTING_ATTRIBUTES":
                            case 3:
                                message.feedError = 3;
                                break;
                            case "CANNOT_SPECIFY_USER_ORIGIN_FOR_SYSTEM_FEED":
                            case 4:
                                message.feedError = 4;
                                break;
                            case "CANNOT_SPECIFY_GOOGLE_ORIGIN_FOR_NON_SYSTEM_FEED":
                            case 5:
                                message.feedError = 5;
                                break;
                            case "CANNOT_SPECIFY_FEED_ATTRIBUTES_FOR_SYSTEM_FEED":
                            case 6:
                                message.feedError = 6;
                                break;
                            case "CANNOT_UPDATE_FEED_ATTRIBUTES_WITH_ORIGIN_GOOGLE":
                            case 7:
                                message.feedError = 7;
                                break;
                            case "FEED_REMOVED":
                            case 8:
                                message.feedError = 8;
                                break;
                            case "INVALID_ORIGIN_VALUE":
                            case 9:
                                message.feedError = 9;
                                break;
                            case "FEED_ORIGIN_IS_NOT_USER":
                            case 10:
                                message.feedError = 10;
                                break;
                            case "INVALID_AUTH_TOKEN_FOR_EMAIL":
                            case 11:
                                message.feedError = 11;
                                break;
                            case "INVALID_EMAIL":
                            case 12:
                                message.feedError = 12;
                                break;
                            case "DUPLICATE_FEED_NAME":
                            case 13:
                                message.feedError = 13;
                                break;
                            case "INVALID_FEED_NAME":
                            case 14:
                                message.feedError = 14;
                                break;
                            case "MISSING_OAUTH_INFO":
                            case 15:
                                message.feedError = 15;
                                break;
                            case "NEW_ATTRIBUTE_CANNOT_BE_PART_OF_UNIQUE_KEY":
                            case 16:
                                message.feedError = 16;
                                break;
                            case "TOO_MANY_ATTRIBUTES":
                            case 17:
                                message.feedError = 17;
                                break;
                            case "INVALID_BUSINESS_ACCOUNT":
                            case 18:
                                message.feedError = 18;
                                break;
                            case "BUSINESS_ACCOUNT_CANNOT_ACCESS_LOCATION_ACCOUNT":
                            case 19:
                                message.feedError = 19;
                                break;
                            case "INVALID_AFFILIATE_CHAIN_ID":
                            case 20:
                                message.feedError = 20;
                                break;
                            }
                            switch (object.geoTargetConstantSuggestionError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.geoTargetConstantSuggestionError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.geoTargetConstantSuggestionError = 1;
                                break;
                            case "LOCATION_NAME_SIZE_LIMIT":
                            case 2:
                                message.geoTargetConstantSuggestionError = 2;
                                break;
                            case "LOCATION_NAME_LIMIT":
                            case 3:
                                message.geoTargetConstantSuggestionError = 3;
                                break;
                            case "INVALID_COUNTRY_CODE":
                            case 4:
                                message.geoTargetConstantSuggestionError = 4;
                                break;
                            case "REQUEST_PARAMETERS_UNSET":
                            case 5:
                                message.geoTargetConstantSuggestionError = 5;
                                break;
                            }
                            switch (object.feedItemError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.feedItemError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.feedItemError = 1;
                                break;
                            case "CANNOT_CONVERT_ATTRIBUTE_VALUE_FROM_STRING":
                            case 2:
                                message.feedItemError = 2;
                                break;
                            case "CANNOT_OPERATE_ON_REMOVED_FEED_ITEM":
                            case 3:
                                message.feedItemError = 3;
                                break;
                            case "DATE_TIME_MUST_BE_IN_ACCOUNT_TIME_ZONE":
                            case 4:
                                message.feedItemError = 4;
                                break;
                            case "KEY_ATTRIBUTES_NOT_FOUND":
                            case 5:
                                message.feedItemError = 5;
                                break;
                            case "INVALID_URL":
                            case 6:
                                message.feedItemError = 6;
                                break;
                            case "MISSING_KEY_ATTRIBUTES":
                            case 7:
                                message.feedItemError = 7;
                                break;
                            case "KEY_ATTRIBUTES_NOT_UNIQUE":
                            case 8:
                                message.feedItemError = 8;
                                break;
                            case "CANNOT_MODIFY_KEY_ATTRIBUTE_VALUE":
                            case 9:
                                message.feedItemError = 9;
                                break;
                            case "SIZE_TOO_LARGE_FOR_MULTI_VALUE_ATTRIBUTE":
                            case 10:
                                message.feedItemError = 10;
                                break;
                            }
                            switch (object.labelError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.labelError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.labelError = 1;
                                break;
                            case "CANNOT_APPLY_INACTIVE_LABEL":
                            case 2:
                                message.labelError = 2;
                                break;
                            case "CANNOT_APPLY_LABEL_TO_DISABLED_AD_GROUP_CRITERION":
                            case 3:
                                message.labelError = 3;
                                break;
                            case "CANNOT_APPLY_LABEL_TO_NEGATIVE_AD_GROUP_CRITERION":
                            case 4:
                                message.labelError = 4;
                                break;
                            case "EXCEEDED_LABEL_LIMIT_PER_TYPE":
                            case 5:
                                message.labelError = 5;
                                break;
                            case "INVALID_RESOURCE_FOR_MANAGER_LABEL":
                            case 6:
                                message.labelError = 6;
                                break;
                            case "DUPLICATE_NAME":
                            case 7:
                                message.labelError = 7;
                                break;
                            case "INVALID_LABEL_NAME":
                            case 8:
                                message.labelError = 8;
                                break;
                            case "CANNOT_ATTACH_LABEL_TO_DRAFT":
                            case 9:
                                message.labelError = 9;
                                break;
                            case "CANNOT_ATTACH_NON_MANAGER_LABEL_TO_CUSTOMER":
                            case 10:
                                message.labelError = 10;
                                break;
                            }
                            switch (object.billingSetupError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.billingSetupError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.billingSetupError = 1;
                                break;
                            case "CANNOT_USE_EXISTING_AND_NEW_ACCOUNT":
                            case 2:
                                message.billingSetupError = 2;
                                break;
                            case "CANNOT_REMOVE_STARTED_BILLING_SETUP":
                            case 3:
                                message.billingSetupError = 3;
                                break;
                            case "CANNOT_CHANGE_BILLING_TO_SAME_PAYMENTS_ACCOUNT":
                            case 4:
                                message.billingSetupError = 4;
                                break;
                            case "BILLING_SETUP_NOT_PERMITTED_FOR_CUSTOMER_STATUS":
                            case 5:
                                message.billingSetupError = 5;
                                break;
                            case "INVALID_PAYMENTS_ACCOUNT":
                            case 6:
                                message.billingSetupError = 6;
                                break;
                            case "BILLING_SETUP_NOT_PERMITTED_FOR_CUSTOMER_CATEGORY":
                            case 7:
                                message.billingSetupError = 7;
                                break;
                            case "INVALID_START_TIME_TYPE":
                            case 8:
                                message.billingSetupError = 8;
                                break;
                            case "THIRD_PARTY_ALREADY_HAS_BILLING":
                            case 9:
                                message.billingSetupError = 9;
                                break;
                            case "BILLING_SETUP_IN_PROGRESS":
                            case 10:
                                message.billingSetupError = 10;
                                break;
                            case "NO_SIGNUP_PERMISSION":
                            case 11:
                                message.billingSetupError = 11;
                                break;
                            case "CHANGE_OF_BILL_TO_IN_PROGRESS":
                            case 12:
                                message.billingSetupError = 12;
                                break;
                            case "PAYMENTS_PROFILE_NOT_FOUND":
                            case 13:
                                message.billingSetupError = 13;
                                break;
                            case "PAYMENTS_ACCOUNT_NOT_FOUND":
                            case 14:
                                message.billingSetupError = 14;
                                break;
                            case "PAYMENTS_PROFILE_INELIGIBLE":
                            case 15:
                                message.billingSetupError = 15;
                                break;
                            case "PAYMENTS_ACCOUNT_INELIGIBLE":
                            case 16:
                                message.billingSetupError = 16;
                                break;
                            }
                            switch (object.customerClientLinkError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.customerClientLinkError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.customerClientLinkError = 1;
                                break;
                            case "CLIENT_ALREADY_INVITED_BY_THIS_MANAGER":
                            case 2:
                                message.customerClientLinkError = 2;
                                break;
                            case "CLIENT_ALREADY_MANAGED_IN_HIERARCHY":
                            case 3:
                                message.customerClientLinkError = 3;
                                break;
                            case "CYCLIC_LINK_NOT_ALLOWED":
                            case 4:
                                message.customerClientLinkError = 4;
                                break;
                            case "CUSTOMER_HAS_TOO_MANY_ACCOUNTS":
                            case 5:
                                message.customerClientLinkError = 5;
                                break;
                            case "CLIENT_HAS_TOO_MANY_INVITATIONS":
                            case 6:
                                message.customerClientLinkError = 6;
                                break;
                            case "CANNOT_HIDE_OR_UNHIDE_MANAGER_ACCOUNTS":
                            case 7:
                                message.customerClientLinkError = 7;
                                break;
                            case "CUSTOMER_HAS_TOO_MANY_ACCOUNTS_AT_MANAGER":
                            case 8:
                                message.customerClientLinkError = 8;
                                break;
                            }
                            switch (object.customerManagerLinkError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.customerManagerLinkError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.customerManagerLinkError = 1;
                                break;
                            case "NO_PENDING_INVITE":
                            case 2:
                                message.customerManagerLinkError = 2;
                                break;
                            case "SAME_CLIENT_MORE_THAN_ONCE_PER_CALL":
                            case 3:
                                message.customerManagerLinkError = 3;
                                break;
                            case "MANAGER_HAS_MAX_NUMBER_OF_LINKED_ACCOUNTS":
                            case 4:
                                message.customerManagerLinkError = 4;
                                break;
                            case "CANNOT_UNLINK_ACCOUNT_WITHOUT_ACTIVE_USER":
                            case 5:
                                message.customerManagerLinkError = 5;
                                break;
                            case "CANNOT_REMOVE_LAST_CLIENT_ACCOUNT_OWNER":
                            case 6:
                                message.customerManagerLinkError = 6;
                                break;
                            case "CANNOT_CHANGE_ROLE_BY_NON_ACCOUNT_OWNER":
                            case 7:
                                message.customerManagerLinkError = 7;
                                break;
                            case "CANNOT_CHANGE_ROLE_FOR_NON_ACTIVE_LINK_ACCOUNT":
                            case 8:
                                message.customerManagerLinkError = 8;
                                break;
                            case "DUPLICATE_CHILD_FOUND":
                            case 9:
                                message.customerManagerLinkError = 9;
                                break;
                            }
                            switch (object.feedMappingError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.feedMappingError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.feedMappingError = 1;
                                break;
                            case "INVALID_PLACEHOLDER_FIELD":
                            case 2:
                                message.feedMappingError = 2;
                                break;
                            case "INVALID_CRITERION_FIELD":
                            case 3:
                                message.feedMappingError = 3;
                                break;
                            case "INVALID_PLACEHOLDER_TYPE":
                            case 4:
                                message.feedMappingError = 4;
                                break;
                            case "INVALID_CRITERION_TYPE":
                            case 5:
                                message.feedMappingError = 5;
                                break;
                            case "NO_ATTRIBUTE_FIELD_MAPPINGS":
                            case 7:
                                message.feedMappingError = 7;
                                break;
                            case "FEED_ATTRIBUTE_TYPE_MISMATCH":
                            case 8:
                                message.feedMappingError = 8;
                                break;
                            case "CANNOT_OPERATE_ON_MAPPINGS_FOR_SYSTEM_GENERATED_FEED":
                            case 9:
                                message.feedMappingError = 9;
                                break;
                            case "MULTIPLE_MAPPINGS_FOR_PLACEHOLDER_TYPE":
                            case 10:
                                message.feedMappingError = 10;
                                break;
                            case "MULTIPLE_MAPPINGS_FOR_CRITERION_TYPE":
                            case 11:
                                message.feedMappingError = 11;
                                break;
                            case "MULTIPLE_MAPPINGS_FOR_PLACEHOLDER_FIELD":
                            case 12:
                                message.feedMappingError = 12;
                                break;
                            case "MULTIPLE_MAPPINGS_FOR_CRITERION_FIELD":
                            case 13:
                                message.feedMappingError = 13;
                                break;
                            case "UNEXPECTED_ATTRIBUTE_FIELD_MAPPINGS":
                            case 14:
                                message.feedMappingError = 14;
                                break;
                            case "LOCATION_PLACEHOLDER_ONLY_FOR_PLACES_FEEDS":
                            case 15:
                                message.feedMappingError = 15;
                                break;
                            case "CANNOT_MODIFY_MAPPINGS_FOR_TYPED_FEED":
                            case 16:
                                message.feedMappingError = 16;
                                break;
                            case "INVALID_PLACEHOLDER_TYPE_FOR_NON_SYSTEM_GENERATED_FEED":
                            case 17:
                                message.feedMappingError = 17;
                                break;
                            case "INVALID_PLACEHOLDER_TYPE_FOR_SYSTEM_GENERATED_FEED_TYPE":
                            case 18:
                                message.feedMappingError = 18;
                                break;
                            }
                            switch (object.customerFeedError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.customerFeedError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.customerFeedError = 1;
                                break;
                            case "FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE":
                            case 2:
                                message.customerFeedError = 2;
                                break;
                            case "CANNOT_CREATE_FOR_REMOVED_FEED":
                            case 3:
                                message.customerFeedError = 3;
                                break;
                            case "CANNOT_CREATE_ALREADY_EXISTING_CUSTOMER_FEED":
                            case 4:
                                message.customerFeedError = 4;
                                break;
                            case "CANNOT_MODIFY_REMOVED_CUSTOMER_FEED":
                            case 5:
                                message.customerFeedError = 5;
                                break;
                            case "INVALID_PLACEHOLDER_TYPE":
                            case 6:
                                message.customerFeedError = 6;
                                break;
                            case "MISSING_FEEDMAPPING_FOR_PLACEHOLDER_TYPE":
                            case 7:
                                message.customerFeedError = 7;
                                break;
                            case "PLACEHOLDER_TYPE_NOT_ALLOWED_ON_CUSTOMER_FEED":
                            case 8:
                                message.customerFeedError = 8;
                                break;
                            }
                            switch (object.adGroupFeedError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.adGroupFeedError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.adGroupFeedError = 1;
                                break;
                            case "FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE":
                            case 2:
                                message.adGroupFeedError = 2;
                                break;
                            case "CANNOT_CREATE_FOR_REMOVED_FEED":
                            case 3:
                                message.adGroupFeedError = 3;
                                break;
                            case "ADGROUP_FEED_ALREADY_EXISTS":
                            case 4:
                                message.adGroupFeedError = 4;
                                break;
                            case "CANNOT_OPERATE_ON_REMOVED_ADGROUP_FEED":
                            case 5:
                                message.adGroupFeedError = 5;
                                break;
                            case "INVALID_PLACEHOLDER_TYPE":
                            case 6:
                                message.adGroupFeedError = 6;
                                break;
                            case "MISSING_FEEDMAPPING_FOR_PLACEHOLDER_TYPE":
                            case 7:
                                message.adGroupFeedError = 7;
                                break;
                            case "NO_EXISTING_LOCATION_CUSTOMER_FEED":
                            case 8:
                                message.adGroupFeedError = 8;
                                break;
                            }
                            switch (object.campaignFeedError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.campaignFeedError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.campaignFeedError = 1;
                                break;
                            case "FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE":
                            case 2:
                                message.campaignFeedError = 2;
                                break;
                            case "CANNOT_CREATE_FOR_REMOVED_FEED":
                            case 4:
                                message.campaignFeedError = 4;
                                break;
                            case "CANNOT_CREATE_ALREADY_EXISTING_CAMPAIGN_FEED":
                            case 5:
                                message.campaignFeedError = 5;
                                break;
                            case "CANNOT_MODIFY_REMOVED_CAMPAIGN_FEED":
                            case 6:
                                message.campaignFeedError = 6;
                                break;
                            case "INVALID_PLACEHOLDER_TYPE":
                            case 7:
                                message.campaignFeedError = 7;
                                break;
                            case "MISSING_FEEDMAPPING_FOR_PLACEHOLDER_TYPE":
                            case 8:
                                message.campaignFeedError = 8;
                                break;
                            }
                            switch (object.customInterestError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.customInterestError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.customInterestError = 1;
                                break;
                            case "NAME_ALREADY_USED":
                            case 2:
                                message.customInterestError = 2;
                                break;
                            case "CUSTOM_INTEREST_MEMBER_ID_AND_TYPE_PARAMETER_NOT_PRESENT_IN_REMOVE":
                            case 3:
                                message.customInterestError = 3;
                                break;
                            case "TYPE_AND_PARAMETER_NOT_FOUND":
                            case 4:
                                message.customInterestError = 4;
                                break;
                            case "TYPE_AND_PARAMETER_ALREADY_EXISTED":
                            case 5:
                                message.customInterestError = 5;
                                break;
                            case "INVALID_CUSTOM_INTEREST_MEMBER_TYPE":
                            case 6:
                                message.customInterestError = 6;
                                break;
                            case "CANNOT_REMOVE_WHILE_IN_USE":
                            case 7:
                                message.customInterestError = 7;
                                break;
                            case "CANNOT_CHANGE_TYPE":
                            case 8:
                                message.customInterestError = 8;
                                break;
                            }
                            switch (object.extensionFeedItemError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.extensionFeedItemError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.extensionFeedItemError = 1;
                                break;
                            case "VALUE_OUT_OF_RANGE":
                            case 2:
                                message.extensionFeedItemError = 2;
                                break;
                            case "URL_LIST_TOO_LONG":
                            case 3:
                                message.extensionFeedItemError = 3;
                                break;
                            case "CANNOT_HAVE_RESTRICTION_ON_EMPTY_GEO_TARGETING":
                            case 4:
                                message.extensionFeedItemError = 4;
                                break;
                            case "CANNOT_SET_WITH_FINAL_URLS":
                            case 5:
                                message.extensionFeedItemError = 5;
                                break;
                            case "CANNOT_SET_WITHOUT_FINAL_URLS":
                            case 6:
                                message.extensionFeedItemError = 6;
                                break;
                            case "INVALID_PHONE_NUMBER":
                            case 7:
                                message.extensionFeedItemError = 7;
                                break;
                            case "PHONE_NUMBER_NOT_SUPPORTED_FOR_COUNTRY":
                            case 8:
                                message.extensionFeedItemError = 8;
                                break;
                            case "CARRIER_SPECIFIC_SHORT_NUMBER_NOT_ALLOWED":
                            case 9:
                                message.extensionFeedItemError = 9;
                                break;
                            case "PREMIUM_RATE_NUMBER_NOT_ALLOWED":
                            case 10:
                                message.extensionFeedItemError = 10;
                                break;
                            case "DISALLOWED_NUMBER_TYPE":
                            case 11:
                                message.extensionFeedItemError = 11;
                                break;
                            case "INVALID_DOMESTIC_PHONE_NUMBER_FORMAT":
                            case 12:
                                message.extensionFeedItemError = 12;
                                break;
                            case "VANITY_PHONE_NUMBER_NOT_ALLOWED":
                            case 13:
                                message.extensionFeedItemError = 13;
                                break;
                            case "INVALID_CALL_CONVERSION_ACTION":
                            case 14:
                                message.extensionFeedItemError = 14;
                                break;
                            case "CUSTOMER_NOT_WHITELISTED_FOR_CALLTRACKING":
                            case 15:
                                message.extensionFeedItemError = 15;
                                break;
                            case "CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY":
                            case 16:
                                message.extensionFeedItemError = 16;
                                break;
                            case "CUSTOMER_CONSENT_FOR_CALL_RECORDING_REQUIRED":
                            case 17:
                                message.extensionFeedItemError = 17;
                                break;
                            case "INVALID_APP_ID":
                            case 18:
                                message.extensionFeedItemError = 18;
                                break;
                            case "QUOTES_IN_REVIEW_EXTENSION_SNIPPET":
                            case 19:
                                message.extensionFeedItemError = 19;
                                break;
                            case "HYPHENS_IN_REVIEW_EXTENSION_SNIPPET":
                            case 20:
                                message.extensionFeedItemError = 20;
                                break;
                            case "REVIEW_EXTENSION_SOURCE_INELIGIBLE":
                            case 21:
                                message.extensionFeedItemError = 21;
                                break;
                            case "SOURCE_NAME_IN_REVIEW_EXTENSION_TEXT":
                            case 22:
                                message.extensionFeedItemError = 22;
                                break;
                            case "INCONSISTENT_CURRENCY_CODES":
                            case 23:
                                message.extensionFeedItemError = 23;
                                break;
                            case "PRICE_EXTENSION_HAS_DUPLICATED_HEADERS":
                            case 24:
                                message.extensionFeedItemError = 24;
                                break;
                            case "PRICE_ITEM_HAS_DUPLICATED_HEADER_AND_DESCRIPTION":
                            case 25:
                                message.extensionFeedItemError = 25;
                                break;
                            case "PRICE_EXTENSION_HAS_TOO_FEW_ITEMS":
                            case 26:
                                message.extensionFeedItemError = 26;
                                break;
                            case "PRICE_EXTENSION_HAS_TOO_MANY_ITEMS":
                            case 27:
                                message.extensionFeedItemError = 27;
                                break;
                            case "UNSUPPORTED_VALUE":
                            case 28:
                                message.extensionFeedItemError = 28;
                                break;
                            case "UNSUPPORTED_VALUE_IN_SELECTED_LANGUAGE":
                            case 29:
                                message.extensionFeedItemError = 29;
                                break;
                            case "INVALID_DEVICE_PREFERENCE":
                            case 30:
                                message.extensionFeedItemError = 30;
                                break;
                            case "INVALID_SCHEDULE_END":
                            case 31:
                                message.extensionFeedItemError = 31;
                                break;
                            case "DATE_TIME_MUST_BE_IN_ACCOUNT_TIME_ZONE":
                            case 32:
                                message.extensionFeedItemError = 32;
                                break;
                            case "INVALID_SNIPPETS_HEADER":
                            case 33:
                                message.extensionFeedItemError = 33;
                                break;
                            case "CANNOT_OPERATE_ON_REMOVED_FEED_ITEM":
                            case 34:
                                message.extensionFeedItemError = 34;
                                break;
                            case "PHONE_NUMBER_NOT_SUPPORTED_WITH_CALLTRACKING_FOR_COUNTRY":
                            case 35:
                                message.extensionFeedItemError = 35;
                                break;
                            case "CONFLICTING_CALL_CONVERSION_SETTINGS":
                            case 36:
                                message.extensionFeedItemError = 36;
                                break;
                            case "EXTENSION_TYPE_MISMATCH":
                            case 37:
                                message.extensionFeedItemError = 37;
                                break;
                            case "EXTENSION_SUBTYPE_REQUIRED":
                            case 38:
                                message.extensionFeedItemError = 38;
                                break;
                            case "EXTENSION_TYPE_UNSUPPORTED":
                            case 39:
                                message.extensionFeedItemError = 39;
                                break;
                            case "CANNOT_OPERATE_ON_FEED_WITH_MULTIPLE_MAPPINGS":
                            case 40:
                                message.extensionFeedItemError = 40;
                                break;
                            case "CANNOT_OPERATE_ON_FEED_WITH_KEY_ATTRIBUTES":
                            case 41:
                                message.extensionFeedItemError = 41;
                                break;
                            case "INVALID_PRICE_FORMAT":
                            case 42:
                                message.extensionFeedItemError = 42;
                                break;
                            case "PROMOTION_INVALID_TIME":
                            case 43:
                                message.extensionFeedItemError = 43;
                                break;
                            case "TOO_MANY_DECIMAL_PLACES_SPECIFIED":
                            case 44:
                                message.extensionFeedItemError = 44;
                                break;
                            }
                            switch (object.adParameterError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.adParameterError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.adParameterError = 1;
                                break;
                            case "AD_GROUP_CRITERION_MUST_BE_KEYWORD":
                            case 2:
                                message.adParameterError = 2;
                                break;
                            case "INVALID_INSERTION_TEXT_FORMAT":
                            case 3:
                                message.adParameterError = 3;
                                break;
                            }
                            switch (object.feedItemValidationError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.feedItemValidationError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.feedItemValidationError = 1;
                                break;
                            case "STRING_TOO_SHORT":
                            case 2:
                                message.feedItemValidationError = 2;
                                break;
                            case "STRING_TOO_LONG":
                            case 3:
                                message.feedItemValidationError = 3;
                                break;
                            case "VALUE_NOT_SPECIFIED":
                            case 4:
                                message.feedItemValidationError = 4;
                                break;
                            case "INVALID_DOMESTIC_PHONE_NUMBER_FORMAT":
                            case 5:
                                message.feedItemValidationError = 5;
                                break;
                            case "INVALID_PHONE_NUMBER":
                            case 6:
                                message.feedItemValidationError = 6;
                                break;
                            case "PHONE_NUMBER_NOT_SUPPORTED_FOR_COUNTRY":
                            case 7:
                                message.feedItemValidationError = 7;
                                break;
                            case "PREMIUM_RATE_NUMBER_NOT_ALLOWED":
                            case 8:
                                message.feedItemValidationError = 8;
                                break;
                            case "DISALLOWED_NUMBER_TYPE":
                            case 9:
                                message.feedItemValidationError = 9;
                                break;
                            case "VALUE_OUT_OF_RANGE":
                            case 10:
                                message.feedItemValidationError = 10;
                                break;
                            case "CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY":
                            case 11:
                                message.feedItemValidationError = 11;
                                break;
                            case "CUSTOMER_NOT_WHITELISTED_FOR_CALLTRACKING":
                            case 12:
                                message.feedItemValidationError = 12;
                                break;
                            case "INVALID_COUNTRY_CODE":
                            case 13:
                                message.feedItemValidationError = 13;
                                break;
                            case "INVALID_APP_ID":
                            case 14:
                                message.feedItemValidationError = 14;
                                break;
                            case "MISSING_ATTRIBUTES_FOR_FIELDS":
                            case 15:
                                message.feedItemValidationError = 15;
                                break;
                            case "INVALID_TYPE_ID":
                            case 16:
                                message.feedItemValidationError = 16;
                                break;
                            case "INVALID_EMAIL_ADDRESS":
                            case 17:
                                message.feedItemValidationError = 17;
                                break;
                            case "INVALID_HTTPS_URL":
                            case 18:
                                message.feedItemValidationError = 18;
                                break;
                            case "MISSING_DELIVERY_ADDRESS":
                            case 19:
                                message.feedItemValidationError = 19;
                                break;
                            case "START_DATE_AFTER_END_DATE":
                            case 20:
                                message.feedItemValidationError = 20;
                                break;
                            case "MISSING_FEED_ITEM_START_TIME":
                            case 21:
                                message.feedItemValidationError = 21;
                                break;
                            case "MISSING_FEED_ITEM_END_TIME":
                            case 22:
                                message.feedItemValidationError = 22;
                                break;
                            case "MISSING_FEED_ITEM_ID":
                            case 23:
                                message.feedItemValidationError = 23;
                                break;
                            case "VANITY_PHONE_NUMBER_NOT_ALLOWED":
                            case 24:
                                message.feedItemValidationError = 24;
                                break;
                            case "INVALID_REVIEW_EXTENSION_SNIPPET":
                            case 25:
                                message.feedItemValidationError = 25;
                                break;
                            case "INVALID_NUMBER_FORMAT":
                            case 26:
                                message.feedItemValidationError = 26;
                                break;
                            case "INVALID_DATE_FORMAT":
                            case 27:
                                message.feedItemValidationError = 27;
                                break;
                            case "INVALID_PRICE_FORMAT":
                            case 28:
                                message.feedItemValidationError = 28;
                                break;
                            case "UNKNOWN_PLACEHOLDER_FIELD":
                            case 29:
                                message.feedItemValidationError = 29;
                                break;
                            case "MISSING_ENHANCED_SITELINK_DESCRIPTION_LINE":
                            case 30:
                                message.feedItemValidationError = 30;
                                break;
                            case "REVIEW_EXTENSION_SOURCE_INELIGIBLE":
                            case 31:
                                message.feedItemValidationError = 31;
                                break;
                            case "HYPHENS_IN_REVIEW_EXTENSION_SNIPPET":
                            case 32:
                                message.feedItemValidationError = 32;
                                break;
                            case "DOUBLE_QUOTES_IN_REVIEW_EXTENSION_SNIPPET":
                            case 33:
                                message.feedItemValidationError = 33;
                                break;
                            case "QUOTES_IN_REVIEW_EXTENSION_SNIPPET":
                            case 34:
                                message.feedItemValidationError = 34;
                                break;
                            case "INVALID_FORM_ENCODED_PARAMS":
                            case 35:
                                message.feedItemValidationError = 35;
                                break;
                            case "INVALID_URL_PARAMETER_NAME":
                            case 36:
                                message.feedItemValidationError = 36;
                                break;
                            case "NO_GEOCODING_RESULT":
                            case 37:
                                message.feedItemValidationError = 37;
                                break;
                            case "SOURCE_NAME_IN_REVIEW_EXTENSION_TEXT":
                            case 38:
                                message.feedItemValidationError = 38;
                                break;
                            case "CARRIER_SPECIFIC_SHORT_NUMBER_NOT_ALLOWED":
                            case 39:
                                message.feedItemValidationError = 39;
                                break;
                            case "INVALID_PLACEHOLDER_FIELD_ID":
                            case 40:
                                message.feedItemValidationError = 40;
                                break;
                            case "INVALID_URL_TAG":
                            case 41:
                                message.feedItemValidationError = 41;
                                break;
                            case "LIST_TOO_LONG":
                            case 42:
                                message.feedItemValidationError = 42;
                                break;
                            case "INVALID_ATTRIBUTES_COMBINATION":
                            case 43:
                                message.feedItemValidationError = 43;
                                break;
                            case "DUPLICATE_VALUES":
                            case 44:
                                message.feedItemValidationError = 44;
                                break;
                            case "INVALID_CALL_CONVERSION_ACTION_ID":
                            case 45:
                                message.feedItemValidationError = 45;
                                break;
                            case "CANNOT_SET_WITHOUT_FINAL_URLS":
                            case 46:
                                message.feedItemValidationError = 46;
                                break;
                            case "APP_ID_DOESNT_EXIST_IN_APP_STORE":
                            case 47:
                                message.feedItemValidationError = 47;
                                break;
                            case "INVALID_FINAL_URL":
                            case 48:
                                message.feedItemValidationError = 48;
                                break;
                            case "INVALID_TRACKING_URL":
                            case 49:
                                message.feedItemValidationError = 49;
                                break;
                            case "INVALID_FINAL_URL_FOR_APP_DOWNLOAD_URL":
                            case 50:
                                message.feedItemValidationError = 50;
                                break;
                            case "LIST_TOO_SHORT":
                            case 51:
                                message.feedItemValidationError = 51;
                                break;
                            case "INVALID_USER_ACTION":
                            case 52:
                                message.feedItemValidationError = 52;
                                break;
                            case "INVALID_TYPE_NAME":
                            case 53:
                                message.feedItemValidationError = 53;
                                break;
                            case "INVALID_EVENT_CHANGE_STATUS":
                            case 54:
                                message.feedItemValidationError = 54;
                                break;
                            case "INVALID_SNIPPETS_HEADER":
                            case 55:
                                message.feedItemValidationError = 55;
                                break;
                            case "INVALID_ANDROID_APP_LINK":
                            case 56:
                                message.feedItemValidationError = 56;
                                break;
                            case "NUMBER_TYPE_WITH_CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY":
                            case 57:
                                message.feedItemValidationError = 57;
                                break;
                            case "RESERVED_KEYWORD_OTHER":
                            case 58:
                                message.feedItemValidationError = 58;
                                break;
                            case "DUPLICATE_OPTION_LABELS":
                            case 59:
                                message.feedItemValidationError = 59;
                                break;
                            case "DUPLICATE_OPTION_PREFILLS":
                            case 60:
                                message.feedItemValidationError = 60;
                                break;
                            case "UNEQUAL_LIST_LENGTHS":
                            case 61:
                                message.feedItemValidationError = 61;
                                break;
                            case "INCONSISTENT_CURRENCY_CODES":
                            case 62:
                                message.feedItemValidationError = 62;
                                break;
                            case "PRICE_EXTENSION_HAS_DUPLICATED_HEADERS":
                            case 63:
                                message.feedItemValidationError = 63;
                                break;
                            case "ITEM_HAS_DUPLICATED_HEADER_AND_DESCRIPTION":
                            case 64:
                                message.feedItemValidationError = 64;
                                break;
                            case "PRICE_EXTENSION_HAS_TOO_FEW_ITEMS":
                            case 65:
                                message.feedItemValidationError = 65;
                                break;
                            case "UNSUPPORTED_VALUE":
                            case 66:
                                message.feedItemValidationError = 66;
                                break;
                            case "INVALID_FINAL_MOBILE_URL":
                            case 67:
                                message.feedItemValidationError = 67;
                                break;
                            case "INVALID_KEYWORDLESS_AD_RULE_LABEL":
                            case 68:
                                message.feedItemValidationError = 68;
                                break;
                            case "VALUE_TRACK_PARAMETER_NOT_SUPPORTED":
                            case 69:
                                message.feedItemValidationError = 69;
                                break;
                            case "UNSUPPORTED_VALUE_IN_SELECTED_LANGUAGE":
                            case 70:
                                message.feedItemValidationError = 70;
                                break;
                            case "INVALID_IOS_APP_LINK":
                            case 71:
                                message.feedItemValidationError = 71;
                                break;
                            case "MISSING_IOS_APP_LINK_OR_IOS_APP_STORE_ID":
                            case 72:
                                message.feedItemValidationError = 72;
                                break;
                            case "PROMOTION_INVALID_TIME":
                            case 73:
                                message.feedItemValidationError = 73;
                                break;
                            case "PROMOTION_CANNOT_SET_PERCENT_OFF_AND_MONEY_AMOUNT_OFF":
                            case 74:
                                message.feedItemValidationError = 74;
                                break;
                            case "PROMOTION_CANNOT_SET_PROMOTION_CODE_AND_ORDERS_OVER_AMOUNT":
                            case 75:
                                message.feedItemValidationError = 75;
                                break;
                            case "TOO_MANY_DECIMAL_PLACES_SPECIFIED":
                            case 76:
                                message.feedItemValidationError = 76;
                                break;
                            case "AD_CUSTOMIZERS_NOT_ALLOWED":
                            case 77:
                                message.feedItemValidationError = 77;
                                break;
                            case "INVALID_LANGUAGE_CODE":
                            case 78:
                                message.feedItemValidationError = 78;
                                break;
                            case "UNSUPPORTED_LANGUAGE":
                            case 79:
                                message.feedItemValidationError = 79;
                                break;
                            case "IF_FUNCTION_NOT_ALLOWED":
                            case 80:
                                message.feedItemValidationError = 80;
                                break;
                            case "INVALID_FINAL_URL_SUFFIX":
                            case 81:
                                message.feedItemValidationError = 81;
                                break;
                            case "INVALID_TAG_IN_FINAL_URL_SUFFIX":
                            case 82:
                                message.feedItemValidationError = 82;
                                break;
                            case "INVALID_FINAL_URL_SUFFIX_FORMAT":
                            case 83:
                                message.feedItemValidationError = 83;
                                break;
                            case "CUSTOMER_CONSENT_FOR_CALL_RECORDING_REQUIRED":
                            case 84:
                                message.feedItemValidationError = 84;
                                break;
                            case "ONLY_ONE_DELIVERY_OPTION_IS_ALLOWED":
                            case 85:
                                message.feedItemValidationError = 85;
                                break;
                            case "NO_DELIVERY_OPTION_IS_SET":
                            case 86:
                                message.feedItemValidationError = 86;
                                break;
                            case "INVALID_CONVERSION_REPORTING_STATE":
                            case 87:
                                message.feedItemValidationError = 87;
                                break;
                            case "IMAGE_SIZE_WRONG":
                            case 88:
                                message.feedItemValidationError = 88;
                                break;
                            case "EMAIL_DELIVERY_NOT_AVAILABLE_IN_COUNTRY":
                            case 89:
                                message.feedItemValidationError = 89;
                                break;
                            case "AUTO_REPLY_NOT_AVAILABLE_IN_COUNTRY":
                            case 90:
                                message.feedItemValidationError = 90;
                                break;
                            case "INVALID_LATITUDE_VALUE":
                            case 91:
                                message.feedItemValidationError = 91;
                                break;
                            case "INVALID_LONGITUDE_VALUE":
                            case 92:
                                message.feedItemValidationError = 92;
                                break;
                            case "TOO_MANY_LABELS":
                            case 93:
                                message.feedItemValidationError = 93;
                                break;
                            case "INVALID_IMAGE_URL":
                            case 94:
                                message.feedItemValidationError = 94;
                                break;
                            case "MISSING_LATITUDE_VALUE":
                            case 95:
                                message.feedItemValidationError = 95;
                                break;
                            case "MISSING_LONGITUDE_VALUE":
                            case 96:
                                message.feedItemValidationError = 96;
                                break;
                            }
                            switch (object.extensionSettingError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.extensionSettingError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.extensionSettingError = 1;
                                break;
                            case "EXTENSIONS_REQUIRED":
                            case 2:
                                message.extensionSettingError = 2;
                                break;
                            case "FEED_TYPE_EXTENSION_TYPE_MISMATCH":
                            case 3:
                                message.extensionSettingError = 3;
                                break;
                            case "INVALID_FEED_TYPE":
                            case 4:
                                message.extensionSettingError = 4;
                                break;
                            case "INVALID_FEED_TYPE_FOR_CUSTOMER_EXTENSION_SETTING":
                            case 5:
                                message.extensionSettingError = 5;
                                break;
                            case "CANNOT_CHANGE_FEED_ITEM_ON_CREATE":
                            case 6:
                                message.extensionSettingError = 6;
                                break;
                            case "CANNOT_UPDATE_NEWLY_CREATED_EXTENSION":
                            case 7:
                                message.extensionSettingError = 7;
                                break;
                            case "NO_EXISTING_AD_GROUP_EXTENSION_SETTING_FOR_TYPE":
                            case 8:
                                message.extensionSettingError = 8;
                                break;
                            case "NO_EXISTING_CAMPAIGN_EXTENSION_SETTING_FOR_TYPE":
                            case 9:
                                message.extensionSettingError = 9;
                                break;
                            case "NO_EXISTING_CUSTOMER_EXTENSION_SETTING_FOR_TYPE":
                            case 10:
                                message.extensionSettingError = 10;
                                break;
                            case "AD_GROUP_EXTENSION_SETTING_ALREADY_EXISTS":
                            case 11:
                                message.extensionSettingError = 11;
                                break;
                            case "CAMPAIGN_EXTENSION_SETTING_ALREADY_EXISTS":
                            case 12:
                                message.extensionSettingError = 12;
                                break;
                            case "CUSTOMER_EXTENSION_SETTING_ALREADY_EXISTS":
                            case 13:
                                message.extensionSettingError = 13;
                                break;
                            case "AD_GROUP_FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE":
                            case 14:
                                message.extensionSettingError = 14;
                                break;
                            case "CAMPAIGN_FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE":
                            case 15:
                                message.extensionSettingError = 15;
                                break;
                            case "CUSTOMER_FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE":
                            case 16:
                                message.extensionSettingError = 16;
                                break;
                            case "VALUE_OUT_OF_RANGE":
                            case 17:
                                message.extensionSettingError = 17;
                                break;
                            case "CANNOT_SET_FIELD_WITH_FINAL_URLS":
                            case 18:
                                message.extensionSettingError = 18;
                                break;
                            case "FINAL_URLS_NOT_SET":
                            case 19:
                                message.extensionSettingError = 19;
                                break;
                            case "INVALID_PHONE_NUMBER":
                            case 20:
                                message.extensionSettingError = 20;
                                break;
                            case "PHONE_NUMBER_NOT_SUPPORTED_FOR_COUNTRY":
                            case 21:
                                message.extensionSettingError = 21;
                                break;
                            case "CARRIER_SPECIFIC_SHORT_NUMBER_NOT_ALLOWED":
                            case 22:
                                message.extensionSettingError = 22;
                                break;
                            case "PREMIUM_RATE_NUMBER_NOT_ALLOWED":
                            case 23:
                                message.extensionSettingError = 23;
                                break;
                            case "DISALLOWED_NUMBER_TYPE":
                            case 24:
                                message.extensionSettingError = 24;
                                break;
                            case "INVALID_DOMESTIC_PHONE_NUMBER_FORMAT":
                            case 25:
                                message.extensionSettingError = 25;
                                break;
                            case "VANITY_PHONE_NUMBER_NOT_ALLOWED":
                            case 26:
                                message.extensionSettingError = 26;
                                break;
                            case "INVALID_COUNTRY_CODE":
                            case 27:
                                message.extensionSettingError = 27;
                                break;
                            case "INVALID_CALL_CONVERSION_TYPE_ID":
                            case 28:
                                message.extensionSettingError = 28;
                                break;
                            case "CUSTOMER_NOT_WHITELISTED_FOR_CALLTRACKING":
                            case 29:
                                message.extensionSettingError = 29;
                                break;
                            case "CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY":
                            case 30:
                                message.extensionSettingError = 30;
                                break;
                            case "INVALID_APP_ID":
                            case 31:
                                message.extensionSettingError = 31;
                                break;
                            case "QUOTES_IN_REVIEW_EXTENSION_SNIPPET":
                            case 32:
                                message.extensionSettingError = 32;
                                break;
                            case "HYPHENS_IN_REVIEW_EXTENSION_SNIPPET":
                            case 33:
                                message.extensionSettingError = 33;
                                break;
                            case "REVIEW_EXTENSION_SOURCE_NOT_ELIGIBLE":
                            case 34:
                                message.extensionSettingError = 34;
                                break;
                            case "SOURCE_NAME_IN_REVIEW_EXTENSION_TEXT":
                            case 35:
                                message.extensionSettingError = 35;
                                break;
                            case "MISSING_FIELD":
                            case 36:
                                message.extensionSettingError = 36;
                                break;
                            case "INCONSISTENT_CURRENCY_CODES":
                            case 37:
                                message.extensionSettingError = 37;
                                break;
                            case "PRICE_EXTENSION_HAS_DUPLICATED_HEADERS":
                            case 38:
                                message.extensionSettingError = 38;
                                break;
                            case "PRICE_ITEM_HAS_DUPLICATED_HEADER_AND_DESCRIPTION":
                            case 39:
                                message.extensionSettingError = 39;
                                break;
                            case "PRICE_EXTENSION_HAS_TOO_FEW_ITEMS":
                            case 40:
                                message.extensionSettingError = 40;
                                break;
                            case "PRICE_EXTENSION_HAS_TOO_MANY_ITEMS":
                            case 41:
                                message.extensionSettingError = 41;
                                break;
                            case "UNSUPPORTED_VALUE":
                            case 42:
                                message.extensionSettingError = 42;
                                break;
                            case "INVALID_DEVICE_PREFERENCE":
                            case 43:
                                message.extensionSettingError = 43;
                                break;
                            case "INVALID_SCHEDULE_END":
                            case 45:
                                message.extensionSettingError = 45;
                                break;
                            case "DATE_TIME_MUST_BE_IN_ACCOUNT_TIME_ZONE":
                            case 47:
                                message.extensionSettingError = 47;
                                break;
                            case "OVERLAPPING_SCHEDULES_NOT_ALLOWED":
                            case 48:
                                message.extensionSettingError = 48;
                                break;
                            case "SCHEDULE_END_NOT_AFTER_START":
                            case 49:
                                message.extensionSettingError = 49;
                                break;
                            case "TOO_MANY_SCHEDULES_PER_DAY":
                            case 50:
                                message.extensionSettingError = 50;
                                break;
                            case "DUPLICATE_EXTENSION_FEED_ITEM_EDIT":
                            case 51:
                                message.extensionSettingError = 51;
                                break;
                            case "INVALID_SNIPPETS_HEADER":
                            case 52:
                                message.extensionSettingError = 52;
                                break;
                            case "PHONE_NUMBER_NOT_SUPPORTED_WITH_CALLTRACKING_FOR_COUNTRY":
                            case 53:
                                message.extensionSettingError = 53;
                                break;
                            case "CAMPAIGN_TARGETING_MISMATCH":
                            case 54:
                                message.extensionSettingError = 54;
                                break;
                            case "CANNOT_OPERATE_ON_REMOVED_FEED":
                            case 55:
                                message.extensionSettingError = 55;
                                break;
                            case "EXTENSION_TYPE_REQUIRED":
                            case 56:
                                message.extensionSettingError = 56;
                                break;
                            case "INCOMPATIBLE_UNDERLYING_MATCHING_FUNCTION":
                            case 57:
                                message.extensionSettingError = 57;
                                break;
                            case "START_DATE_AFTER_END_DATE":
                            case 58:
                                message.extensionSettingError = 58;
                                break;
                            case "INVALID_PRICE_FORMAT":
                            case 59:
                                message.extensionSettingError = 59;
                                break;
                            case "PROMOTION_INVALID_TIME":
                            case 60:
                                message.extensionSettingError = 60;
                                break;
                            case "PROMOTION_CANNOT_SET_PERCENT_DISCOUNT_AND_MONEY_DISCOUNT":
                            case 61:
                                message.extensionSettingError = 61;
                                break;
                            case "PROMOTION_CANNOT_SET_PROMOTION_CODE_AND_ORDERS_OVER_AMOUNT":
                            case 62:
                                message.extensionSettingError = 62;
                                break;
                            case "TOO_MANY_DECIMAL_PLACES_SPECIFIED":
                            case 63:
                                message.extensionSettingError = 63;
                                break;
                            case "INVALID_LANGUAGE_CODE":
                            case 64:
                                message.extensionSettingError = 64;
                                break;
                            case "UNSUPPORTED_LANGUAGE":
                            case 65:
                                message.extensionSettingError = 65;
                                break;
                            case "CUSTOMER_CONSENT_FOR_CALL_RECORDING_REQUIRED":
                            case 66:
                                message.extensionSettingError = 66;
                                break;
                            case "EXTENSION_SETTING_UPDATE_IS_A_NOOP":
                            case 67:
                                message.extensionSettingError = 67;
                                break;
                            }
                            switch (object.feedItemTargetError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.feedItemTargetError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.feedItemTargetError = 1;
                                break;
                            case "MUST_SET_TARGET_ONEOF_ON_CREATE":
                            case 2:
                                message.feedItemTargetError = 2;
                                break;
                            case "FEED_ITEM_TARGET_ALREADY_EXISTS":
                            case 3:
                                message.feedItemTargetError = 3;
                                break;
                            case "FEED_ITEM_SCHEDULES_CANNOT_OVERLAP":
                            case 4:
                                message.feedItemTargetError = 4;
                                break;
                            case "TARGET_LIMIT_EXCEEDED_FOR_GIVEN_TYPE":
                            case 5:
                                message.feedItemTargetError = 5;
                                break;
                            case "TOO_MANY_SCHEDULES_PER_DAY":
                            case 6:
                                message.feedItemTargetError = 6;
                                break;
                            case "CANNOT_HAVE_ENABLED_CAMPAIGN_AND_ENABLED_AD_GROUP_TARGETS":
                            case 7:
                                message.feedItemTargetError = 7;
                                break;
                            }
                            switch (object.policyViolationError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.policyViolationError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.policyViolationError = 1;
                                break;
                            case "POLICY_ERROR":
                            case 2:
                                message.policyViolationError = 2;
                                break;
                            }
                            switch (object.mutateJobError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.mutateJobError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.mutateJobError = 1;
                                break;
                            case "CANNOT_MODIFY_JOB_AFTER_JOB_STARTS_RUNNING":
                            case 2:
                                message.mutateJobError = 2;
                                break;
                            case "EMPTY_OPERATIONS":
                            case 3:
                                message.mutateJobError = 3;
                                break;
                            case "INVALID_SEQUENCE_TOKEN":
                            case 4:
                                message.mutateJobError = 4;
                                break;
                            case "RESULTS_NOT_READY":
                            case 5:
                                message.mutateJobError = 5;
                                break;
                            case "INVALID_PAGE_SIZE":
                            case 6:
                                message.mutateJobError = 6;
                                break;
                            }
                            switch (object.partialFailureError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.partialFailureError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.partialFailureError = 1;
                                break;
                            case "PARTIAL_FAILURE_MODE_REQUIRED":
                            case 2:
                                message.partialFailureError = 2;
                                break;
                            }
                            switch (object.policyValidationParameterError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.policyValidationParameterError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.policyValidationParameterError = 1;
                                break;
                            case "UNSUPPORTED_AD_TYPE_FOR_IGNORABLE_POLICY_TOPICS":
                            case 2:
                                message.policyValidationParameterError = 2;
                                break;
                            case "UNSUPPORTED_AD_TYPE_FOR_EXEMPT_POLICY_VIOLATION_KEYS":
                            case 3:
                                message.policyValidationParameterError = 3;
                                break;
                            case "CANNOT_SET_BOTH_IGNORABLE_POLICY_TOPICS_AND_EXEMPT_POLICY_VIOLATION_KEYS":
                            case 4:
                                message.policyValidationParameterError = 4;
                                break;
                            }
                            switch (object.sizeLimitError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.sizeLimitError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.sizeLimitError = 1;
                                break;
                            case "REQUEST_SIZE_LIMIT_EXCEEDED":
                            case 2:
                                message.sizeLimitError = 2;
                                break;
                            case "RESPONSE_SIZE_LIMIT_EXCEEDED":
                            case 3:
                                message.sizeLimitError = 3;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an ErrorCode message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @static
                         * @param {google.ads.googleads.v1.errors.ErrorCode} message ErrorCode
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ErrorCode.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.requestError != null && message.hasOwnProperty("requestError")) {
                                object.requestError = options.enums === String ? $root.google.ads.googleads.v1.errors.RequestErrorEnum.RequestError[message.requestError] : message.requestError;
                                if (options.oneofs)
                                    object.errorCode = "requestError";
                            }
                            if (message.biddingStrategyError != null && message.hasOwnProperty("biddingStrategyError")) {
                                object.biddingStrategyError = options.enums === String ? $root.google.ads.googleads.v1.errors.BiddingStrategyErrorEnum.BiddingStrategyError[message.biddingStrategyError] : message.biddingStrategyError;
                                if (options.oneofs)
                                    object.errorCode = "biddingStrategyError";
                            }
                            if (message.urlFieldError != null && message.hasOwnProperty("urlFieldError")) {
                                object.urlFieldError = options.enums === String ? $root.google.ads.googleads.v1.errors.UrlFieldErrorEnum.UrlFieldError[message.urlFieldError] : message.urlFieldError;
                                if (options.oneofs)
                                    object.errorCode = "urlFieldError";
                            }
                            if (message.listOperationError != null && message.hasOwnProperty("listOperationError")) {
                                object.listOperationError = options.enums === String ? $root.google.ads.googleads.v1.errors.ListOperationErrorEnum.ListOperationError[message.listOperationError] : message.listOperationError;
                                if (options.oneofs)
                                    object.errorCode = "listOperationError";
                            }
                            if (message.queryError != null && message.hasOwnProperty("queryError")) {
                                object.queryError = options.enums === String ? $root.google.ads.googleads.v1.errors.QueryErrorEnum.QueryError[message.queryError] : message.queryError;
                                if (options.oneofs)
                                    object.errorCode = "queryError";
                            }
                            if (message.mutateError != null && message.hasOwnProperty("mutateError")) {
                                object.mutateError = options.enums === String ? $root.google.ads.googleads.v1.errors.MutateErrorEnum.MutateError[message.mutateError] : message.mutateError;
                                if (options.oneofs)
                                    object.errorCode = "mutateError";
                            }
                            if (message.fieldMaskError != null && message.hasOwnProperty("fieldMaskError")) {
                                object.fieldMaskError = options.enums === String ? $root.google.ads.googleads.v1.errors.FieldMaskErrorEnum.FieldMaskError[message.fieldMaskError] : message.fieldMaskError;
                                if (options.oneofs)
                                    object.errorCode = "fieldMaskError";
                            }
                            if (message.authorizationError != null && message.hasOwnProperty("authorizationError")) {
                                object.authorizationError = options.enums === String ? $root.google.ads.googleads.v1.errors.AuthorizationErrorEnum.AuthorizationError[message.authorizationError] : message.authorizationError;
                                if (options.oneofs)
                                    object.errorCode = "authorizationError";
                            }
                            if (message.internalError != null && message.hasOwnProperty("internalError")) {
                                object.internalError = options.enums === String ? $root.google.ads.googleads.v1.errors.InternalErrorEnum.InternalError[message.internalError] : message.internalError;
                                if (options.oneofs)
                                    object.errorCode = "internalError";
                            }
                            if (message.quotaError != null && message.hasOwnProperty("quotaError")) {
                                object.quotaError = options.enums === String ? $root.google.ads.googleads.v1.errors.QuotaErrorEnum.QuotaError[message.quotaError] : message.quotaError;
                                if (options.oneofs)
                                    object.errorCode = "quotaError";
                            }
                            if (message.adError != null && message.hasOwnProperty("adError")) {
                                object.adError = options.enums === String ? $root.google.ads.googleads.v1.errors.AdErrorEnum.AdError[message.adError] : message.adError;
                                if (options.oneofs)
                                    object.errorCode = "adError";
                            }
                            if (message.adGroupError != null && message.hasOwnProperty("adGroupError")) {
                                object.adGroupError = options.enums === String ? $root.google.ads.googleads.v1.errors.AdGroupErrorEnum.AdGroupError[message.adGroupError] : message.adGroupError;
                                if (options.oneofs)
                                    object.errorCode = "adGroupError";
                            }
                            if (message.campaignBudgetError != null && message.hasOwnProperty("campaignBudgetError")) {
                                object.campaignBudgetError = options.enums === String ? $root.google.ads.googleads.v1.errors.CampaignBudgetErrorEnum.CampaignBudgetError[message.campaignBudgetError] : message.campaignBudgetError;
                                if (options.oneofs)
                                    object.errorCode = "campaignBudgetError";
                            }
                            if (message.campaignError != null && message.hasOwnProperty("campaignError")) {
                                object.campaignError = options.enums === String ? $root.google.ads.googleads.v1.errors.CampaignErrorEnum.CampaignError[message.campaignError] : message.campaignError;
                                if (options.oneofs)
                                    object.errorCode = "campaignError";
                            }
                            if (message.authenticationError != null && message.hasOwnProperty("authenticationError")) {
                                object.authenticationError = options.enums === String ? $root.google.ads.googleads.v1.errors.AuthenticationErrorEnum.AuthenticationError[message.authenticationError] : message.authenticationError;
                                if (options.oneofs)
                                    object.errorCode = "authenticationError";
                            }
                            if (message.adGroupCriterionError != null && message.hasOwnProperty("adGroupCriterionError")) {
                                object.adGroupCriterionError = options.enums === String ? $root.google.ads.googleads.v1.errors.AdGroupCriterionErrorEnum.AdGroupCriterionError[message.adGroupCriterionError] : message.adGroupCriterionError;
                                if (options.oneofs)
                                    object.errorCode = "adGroupCriterionError";
                            }
                            if (message.adCustomizerError != null && message.hasOwnProperty("adCustomizerError")) {
                                object.adCustomizerError = options.enums === String ? $root.google.ads.googleads.v1.errors.AdCustomizerErrorEnum.AdCustomizerError[message.adCustomizerError] : message.adCustomizerError;
                                if (options.oneofs)
                                    object.errorCode = "adCustomizerError";
                            }
                            if (message.adGroupAdError != null && message.hasOwnProperty("adGroupAdError")) {
                                object.adGroupAdError = options.enums === String ? $root.google.ads.googleads.v1.errors.AdGroupAdErrorEnum.AdGroupAdError[message.adGroupAdError] : message.adGroupAdError;
                                if (options.oneofs)
                                    object.errorCode = "adGroupAdError";
                            }
                            if (message.adSharingError != null && message.hasOwnProperty("adSharingError")) {
                                object.adSharingError = options.enums === String ? $root.google.ads.googleads.v1.errors.AdSharingErrorEnum.AdSharingError[message.adSharingError] : message.adSharingError;
                                if (options.oneofs)
                                    object.errorCode = "adSharingError";
                            }
                            if (message.adxError != null && message.hasOwnProperty("adxError")) {
                                object.adxError = options.enums === String ? $root.google.ads.googleads.v1.errors.AdxErrorEnum.AdxError[message.adxError] : message.adxError;
                                if (options.oneofs)
                                    object.errorCode = "adxError";
                            }
                            if (message.biddingError != null && message.hasOwnProperty("biddingError")) {
                                object.biddingError = options.enums === String ? $root.google.ads.googleads.v1.errors.BiddingErrorEnum.BiddingError[message.biddingError] : message.biddingError;
                                if (options.oneofs)
                                    object.errorCode = "biddingError";
                            }
                            if (message.campaignCriterionError != null && message.hasOwnProperty("campaignCriterionError")) {
                                object.campaignCriterionError = options.enums === String ? $root.google.ads.googleads.v1.errors.CampaignCriterionErrorEnum.CampaignCriterionError[message.campaignCriterionError] : message.campaignCriterionError;
                                if (options.oneofs)
                                    object.errorCode = "campaignCriterionError";
                            }
                            if (message.collectionSizeError != null && message.hasOwnProperty("collectionSizeError")) {
                                object.collectionSizeError = options.enums === String ? $root.google.ads.googleads.v1.errors.CollectionSizeErrorEnum.CollectionSizeError[message.collectionSizeError] : message.collectionSizeError;
                                if (options.oneofs)
                                    object.errorCode = "collectionSizeError";
                            }
                            if (message.criterionError != null && message.hasOwnProperty("criterionError")) {
                                object.criterionError = options.enums === String ? $root.google.ads.googleads.v1.errors.CriterionErrorEnum.CriterionError[message.criterionError] : message.criterionError;
                                if (options.oneofs)
                                    object.errorCode = "criterionError";
                            }
                            if (message.dateError != null && message.hasOwnProperty("dateError")) {
                                object.dateError = options.enums === String ? $root.google.ads.googleads.v1.errors.DateErrorEnum.DateError[message.dateError] : message.dateError;
                                if (options.oneofs)
                                    object.errorCode = "dateError";
                            }
                            if (message.dateRangeError != null && message.hasOwnProperty("dateRangeError")) {
                                object.dateRangeError = options.enums === String ? $root.google.ads.googleads.v1.errors.DateRangeErrorEnum.DateRangeError[message.dateRangeError] : message.dateRangeError;
                                if (options.oneofs)
                                    object.errorCode = "dateRangeError";
                            }
                            if (message.distinctError != null && message.hasOwnProperty("distinctError")) {
                                object.distinctError = options.enums === String ? $root.google.ads.googleads.v1.errors.DistinctErrorEnum.DistinctError[message.distinctError] : message.distinctError;
                                if (options.oneofs)
                                    object.errorCode = "distinctError";
                            }
                            if (message.feedAttributeReferenceError != null && message.hasOwnProperty("feedAttributeReferenceError")) {
                                object.feedAttributeReferenceError = options.enums === String ? $root.google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum.FeedAttributeReferenceError[message.feedAttributeReferenceError] : message.feedAttributeReferenceError;
                                if (options.oneofs)
                                    object.errorCode = "feedAttributeReferenceError";
                            }
                            if (message.functionError != null && message.hasOwnProperty("functionError")) {
                                object.functionError = options.enums === String ? $root.google.ads.googleads.v1.errors.FunctionErrorEnum.FunctionError[message.functionError] : message.functionError;
                                if (options.oneofs)
                                    object.errorCode = "functionError";
                            }
                            if (message.functionParsingError != null && message.hasOwnProperty("functionParsingError")) {
                                object.functionParsingError = options.enums === String ? $root.google.ads.googleads.v1.errors.FunctionParsingErrorEnum.FunctionParsingError[message.functionParsingError] : message.functionParsingError;
                                if (options.oneofs)
                                    object.errorCode = "functionParsingError";
                            }
                            if (message.idError != null && message.hasOwnProperty("idError")) {
                                object.idError = options.enums === String ? $root.google.ads.googleads.v1.errors.IdErrorEnum.IdError[message.idError] : message.idError;
                                if (options.oneofs)
                                    object.errorCode = "idError";
                            }
                            if (message.imageError != null && message.hasOwnProperty("imageError")) {
                                object.imageError = options.enums === String ? $root.google.ads.googleads.v1.errors.ImageErrorEnum.ImageError[message.imageError] : message.imageError;
                                if (options.oneofs)
                                    object.errorCode = "imageError";
                            }
                            if (message.mediaBundleError != null && message.hasOwnProperty("mediaBundleError")) {
                                object.mediaBundleError = options.enums === String ? $root.google.ads.googleads.v1.errors.MediaBundleErrorEnum.MediaBundleError[message.mediaBundleError] : message.mediaBundleError;
                                if (options.oneofs)
                                    object.errorCode = "mediaBundleError";
                            }
                            if (message.multiplierError != null && message.hasOwnProperty("multiplierError")) {
                                object.multiplierError = options.enums === String ? $root.google.ads.googleads.v1.errors.MultiplierErrorEnum.MultiplierError[message.multiplierError] : message.multiplierError;
                                if (options.oneofs)
                                    object.errorCode = "multiplierError";
                            }
                            if (message.newResourceCreationError != null && message.hasOwnProperty("newResourceCreationError")) {
                                object.newResourceCreationError = options.enums === String ? $root.google.ads.googleads.v1.errors.NewResourceCreationErrorEnum.NewResourceCreationError[message.newResourceCreationError] : message.newResourceCreationError;
                                if (options.oneofs)
                                    object.errorCode = "newResourceCreationError";
                            }
                            if (message.notEmptyError != null && message.hasOwnProperty("notEmptyError")) {
                                object.notEmptyError = options.enums === String ? $root.google.ads.googleads.v1.errors.NotEmptyErrorEnum.NotEmptyError[message.notEmptyError] : message.notEmptyError;
                                if (options.oneofs)
                                    object.errorCode = "notEmptyError";
                            }
                            if (message.nullError != null && message.hasOwnProperty("nullError")) {
                                object.nullError = options.enums === String ? $root.google.ads.googleads.v1.errors.NullErrorEnum.NullError[message.nullError] : message.nullError;
                                if (options.oneofs)
                                    object.errorCode = "nullError";
                            }
                            if (message.operatorError != null && message.hasOwnProperty("operatorError")) {
                                object.operatorError = options.enums === String ? $root.google.ads.googleads.v1.errors.OperatorErrorEnum.OperatorError[message.operatorError] : message.operatorError;
                                if (options.oneofs)
                                    object.errorCode = "operatorError";
                            }
                            if (message.rangeError != null && message.hasOwnProperty("rangeError")) {
                                object.rangeError = options.enums === String ? $root.google.ads.googleads.v1.errors.RangeErrorEnum.RangeError[message.rangeError] : message.rangeError;
                                if (options.oneofs)
                                    object.errorCode = "rangeError";
                            }
                            if (message.regionCodeError != null && message.hasOwnProperty("regionCodeError")) {
                                object.regionCodeError = options.enums === String ? $root.google.ads.googleads.v1.errors.RegionCodeErrorEnum.RegionCodeError[message.regionCodeError] : message.regionCodeError;
                                if (options.oneofs)
                                    object.errorCode = "regionCodeError";
                            }
                            if (message.settingError != null && message.hasOwnProperty("settingError")) {
                                object.settingError = options.enums === String ? $root.google.ads.googleads.v1.errors.SettingErrorEnum.SettingError[message.settingError] : message.settingError;
                                if (options.oneofs)
                                    object.errorCode = "settingError";
                            }
                            if (message.stringFormatError != null && message.hasOwnProperty("stringFormatError")) {
                                object.stringFormatError = options.enums === String ? $root.google.ads.googleads.v1.errors.StringFormatErrorEnum.StringFormatError[message.stringFormatError] : message.stringFormatError;
                                if (options.oneofs)
                                    object.errorCode = "stringFormatError";
                            }
                            if (message.stringLengthError != null && message.hasOwnProperty("stringLengthError")) {
                                object.stringLengthError = options.enums === String ? $root.google.ads.googleads.v1.errors.StringLengthErrorEnum.StringLengthError[message.stringLengthError] : message.stringLengthError;
                                if (options.oneofs)
                                    object.errorCode = "stringLengthError";
                            }
                            if (message.operationAccessDeniedError != null && message.hasOwnProperty("operationAccessDeniedError")) {
                                object.operationAccessDeniedError = options.enums === String ? $root.google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum.OperationAccessDeniedError[message.operationAccessDeniedError] : message.operationAccessDeniedError;
                                if (options.oneofs)
                                    object.errorCode = "operationAccessDeniedError";
                            }
                            if (message.resourceAccessDeniedError != null && message.hasOwnProperty("resourceAccessDeniedError")) {
                                object.resourceAccessDeniedError = options.enums === String ? $root.google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum.ResourceAccessDeniedError[message.resourceAccessDeniedError] : message.resourceAccessDeniedError;
                                if (options.oneofs)
                                    object.errorCode = "resourceAccessDeniedError";
                            }
                            if (message.resourceCountLimitExceededError != null && message.hasOwnProperty("resourceCountLimitExceededError")) {
                                object.resourceCountLimitExceededError = options.enums === String ? $root.google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum.ResourceCountLimitExceededError[message.resourceCountLimitExceededError] : message.resourceCountLimitExceededError;
                                if (options.oneofs)
                                    object.errorCode = "resourceCountLimitExceededError";
                            }
                            if (message.recommendationError != null && message.hasOwnProperty("recommendationError")) {
                                object.recommendationError = options.enums === String ? $root.google.ads.googleads.v1.errors.RecommendationErrorEnum.RecommendationError[message.recommendationError] : message.recommendationError;
                                if (options.oneofs)
                                    object.errorCode = "recommendationError";
                            }
                            if (message.adGroupBidModifierError != null && message.hasOwnProperty("adGroupBidModifierError")) {
                                object.adGroupBidModifierError = options.enums === String ? $root.google.ads.googleads.v1.errors.AdGroupBidModifierErrorEnum.AdGroupBidModifierError[message.adGroupBidModifierError] : message.adGroupBidModifierError;
                                if (options.oneofs)
                                    object.errorCode = "adGroupBidModifierError";
                            }
                            if (message.contextError != null && message.hasOwnProperty("contextError")) {
                                object.contextError = options.enums === String ? $root.google.ads.googleads.v1.errors.ContextErrorEnum.ContextError[message.contextError] : message.contextError;
                                if (options.oneofs)
                                    object.errorCode = "contextError";
                            }
                            if (message.fieldError != null && message.hasOwnProperty("fieldError")) {
                                object.fieldError = options.enums === String ? $root.google.ads.googleads.v1.errors.FieldErrorEnum.FieldError[message.fieldError] : message.fieldError;
                                if (options.oneofs)
                                    object.errorCode = "fieldError";
                            }
                            if (message.sharedSetError != null && message.hasOwnProperty("sharedSetError")) {
                                object.sharedSetError = options.enums === String ? $root.google.ads.googleads.v1.errors.SharedSetErrorEnum.SharedSetError[message.sharedSetError] : message.sharedSetError;
                                if (options.oneofs)
                                    object.errorCode = "sharedSetError";
                            }
                            if (message.sharedCriterionError != null && message.hasOwnProperty("sharedCriterionError")) {
                                object.sharedCriterionError = options.enums === String ? $root.google.ads.googleads.v1.errors.SharedCriterionErrorEnum.SharedCriterionError[message.sharedCriterionError] : message.sharedCriterionError;
                                if (options.oneofs)
                                    object.errorCode = "sharedCriterionError";
                            }
                            if (message.campaignSharedSetError != null && message.hasOwnProperty("campaignSharedSetError")) {
                                object.campaignSharedSetError = options.enums === String ? $root.google.ads.googleads.v1.errors.CampaignSharedSetErrorEnum.CampaignSharedSetError[message.campaignSharedSetError] : message.campaignSharedSetError;
                                if (options.oneofs)
                                    object.errorCode = "campaignSharedSetError";
                            }
                            if (message.conversionActionError != null && message.hasOwnProperty("conversionActionError")) {
                                object.conversionActionError = options.enums === String ? $root.google.ads.googleads.v1.errors.ConversionActionErrorEnum.ConversionActionError[message.conversionActionError] : message.conversionActionError;
                                if (options.oneofs)
                                    object.errorCode = "conversionActionError";
                            }
                            if (message.headerError != null && message.hasOwnProperty("headerError")) {
                                object.headerError = options.enums === String ? $root.google.ads.googleads.v1.errors.HeaderErrorEnum.HeaderError[message.headerError] : message.headerError;
                                if (options.oneofs)
                                    object.errorCode = "headerError";
                            }
                            if (message.databaseError != null && message.hasOwnProperty("databaseError")) {
                                object.databaseError = options.enums === String ? $root.google.ads.googleads.v1.errors.DatabaseErrorEnum.DatabaseError[message.databaseError] : message.databaseError;
                                if (options.oneofs)
                                    object.errorCode = "databaseError";
                            }
                            if (message.policyFindingError != null && message.hasOwnProperty("policyFindingError")) {
                                object.policyFindingError = options.enums === String ? $root.google.ads.googleads.v1.errors.PolicyFindingErrorEnum.PolicyFindingError[message.policyFindingError] : message.policyFindingError;
                                if (options.oneofs)
                                    object.errorCode = "policyFindingError";
                            }
                            if (message.enumError != null && message.hasOwnProperty("enumError")) {
                                object.enumError = options.enums === String ? $root.google.ads.googleads.v1.errors.EnumErrorEnum.EnumError[message.enumError] : message.enumError;
                                if (options.oneofs)
                                    object.errorCode = "enumError";
                            }
                            if (message.keywordPlanError != null && message.hasOwnProperty("keywordPlanError")) {
                                object.keywordPlanError = options.enums === String ? $root.google.ads.googleads.v1.errors.KeywordPlanErrorEnum.KeywordPlanError[message.keywordPlanError] : message.keywordPlanError;
                                if (options.oneofs)
                                    object.errorCode = "keywordPlanError";
                            }
                            if (message.keywordPlanCampaignError != null && message.hasOwnProperty("keywordPlanCampaignError")) {
                                object.keywordPlanCampaignError = options.enums === String ? $root.google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum.KeywordPlanCampaignError[message.keywordPlanCampaignError] : message.keywordPlanCampaignError;
                                if (options.oneofs)
                                    object.errorCode = "keywordPlanCampaignError";
                            }
                            if (message.keywordPlanNegativeKeywordError != null && message.hasOwnProperty("keywordPlanNegativeKeywordError")) {
                                object.keywordPlanNegativeKeywordError = options.enums === String ? $root.google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum.KeywordPlanNegativeKeywordError[message.keywordPlanNegativeKeywordError] : message.keywordPlanNegativeKeywordError;
                                if (options.oneofs)
                                    object.errorCode = "keywordPlanNegativeKeywordError";
                            }
                            if (message.keywordPlanAdGroupError != null && message.hasOwnProperty("keywordPlanAdGroupError")) {
                                object.keywordPlanAdGroupError = options.enums === String ? $root.google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum.KeywordPlanAdGroupError[message.keywordPlanAdGroupError] : message.keywordPlanAdGroupError;
                                if (options.oneofs)
                                    object.errorCode = "keywordPlanAdGroupError";
                            }
                            if (message.keywordPlanKeywordError != null && message.hasOwnProperty("keywordPlanKeywordError")) {
                                object.keywordPlanKeywordError = options.enums === String ? $root.google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum.KeywordPlanKeywordError[message.keywordPlanKeywordError] : message.keywordPlanKeywordError;
                                if (options.oneofs)
                                    object.errorCode = "keywordPlanKeywordError";
                            }
                            if (message.keywordPlanIdeaError != null && message.hasOwnProperty("keywordPlanIdeaError")) {
                                object.keywordPlanIdeaError = options.enums === String ? $root.google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum.KeywordPlanIdeaError[message.keywordPlanIdeaError] : message.keywordPlanIdeaError;
                                if (options.oneofs)
                                    object.errorCode = "keywordPlanIdeaError";
                            }
                            if (message.accountBudgetProposalError != null && message.hasOwnProperty("accountBudgetProposalError")) {
                                object.accountBudgetProposalError = options.enums === String ? $root.google.ads.googleads.v1.errors.AccountBudgetProposalErrorEnum.AccountBudgetProposalError[message.accountBudgetProposalError] : message.accountBudgetProposalError;
                                if (options.oneofs)
                                    object.errorCode = "accountBudgetProposalError";
                            }
                            if (message.userListError != null && message.hasOwnProperty("userListError")) {
                                object.userListError = options.enums === String ? $root.google.ads.googleads.v1.errors.UserListErrorEnum.UserListError[message.userListError] : message.userListError;
                                if (options.oneofs)
                                    object.errorCode = "userListError";
                            }
                            if (message.changeStatusError != null && message.hasOwnProperty("changeStatusError")) {
                                object.changeStatusError = options.enums === String ? $root.google.ads.googleads.v1.errors.ChangeStatusErrorEnum.ChangeStatusError[message.changeStatusError] : message.changeStatusError;
                                if (options.oneofs)
                                    object.errorCode = "changeStatusError";
                            }
                            if (message.feedError != null && message.hasOwnProperty("feedError")) {
                                object.feedError = options.enums === String ? $root.google.ads.googleads.v1.errors.FeedErrorEnum.FeedError[message.feedError] : message.feedError;
                                if (options.oneofs)
                                    object.errorCode = "feedError";
                            }
                            if (message.geoTargetConstantSuggestionError != null && message.hasOwnProperty("geoTargetConstantSuggestionError")) {
                                object.geoTargetConstantSuggestionError = options.enums === String ? $root.google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum.GeoTargetConstantSuggestionError[message.geoTargetConstantSuggestionError] : message.geoTargetConstantSuggestionError;
                                if (options.oneofs)
                                    object.errorCode = "geoTargetConstantSuggestionError";
                            }
                            if (message.feedItemError != null && message.hasOwnProperty("feedItemError")) {
                                object.feedItemError = options.enums === String ? $root.google.ads.googleads.v1.errors.FeedItemErrorEnum.FeedItemError[message.feedItemError] : message.feedItemError;
                                if (options.oneofs)
                                    object.errorCode = "feedItemError";
                            }
                            if (message.labelError != null && message.hasOwnProperty("labelError")) {
                                object.labelError = options.enums === String ? $root.google.ads.googleads.v1.errors.LabelErrorEnum.LabelError[message.labelError] : message.labelError;
                                if (options.oneofs)
                                    object.errorCode = "labelError";
                            }
                            if (message.mediaFileError != null && message.hasOwnProperty("mediaFileError")) {
                                object.mediaFileError = options.enums === String ? $root.google.ads.googleads.v1.errors.MediaFileErrorEnum.MediaFileError[message.mediaFileError] : message.mediaFileError;
                                if (options.oneofs)
                                    object.errorCode = "mediaFileError";
                            }
                            if (message.billingSetupError != null && message.hasOwnProperty("billingSetupError")) {
                                object.billingSetupError = options.enums === String ? $root.google.ads.googleads.v1.errors.BillingSetupErrorEnum.BillingSetupError[message.billingSetupError] : message.billingSetupError;
                                if (options.oneofs)
                                    object.errorCode = "billingSetupError";
                            }
                            if (message.customerClientLinkError != null && message.hasOwnProperty("customerClientLinkError")) {
                                object.customerClientLinkError = options.enums === String ? $root.google.ads.googleads.v1.errors.CustomerClientLinkErrorEnum.CustomerClientLinkError[message.customerClientLinkError] : message.customerClientLinkError;
                                if (options.oneofs)
                                    object.errorCode = "customerClientLinkError";
                            }
                            if (message.customerError != null && message.hasOwnProperty("customerError")) {
                                object.customerError = options.enums === String ? $root.google.ads.googleads.v1.errors.CustomerErrorEnum.CustomerError[message.customerError] : message.customerError;
                                if (options.oneofs)
                                    object.errorCode = "customerError";
                            }
                            if (message.customerManagerLinkError != null && message.hasOwnProperty("customerManagerLinkError")) {
                                object.customerManagerLinkError = options.enums === String ? $root.google.ads.googleads.v1.errors.CustomerManagerLinkErrorEnum.CustomerManagerLinkError[message.customerManagerLinkError] : message.customerManagerLinkError;
                                if (options.oneofs)
                                    object.errorCode = "customerManagerLinkError";
                            }
                            if (message.feedMappingError != null && message.hasOwnProperty("feedMappingError")) {
                                object.feedMappingError = options.enums === String ? $root.google.ads.googleads.v1.errors.FeedMappingErrorEnum.FeedMappingError[message.feedMappingError] : message.feedMappingError;
                                if (options.oneofs)
                                    object.errorCode = "feedMappingError";
                            }
                            if (message.customerFeedError != null && message.hasOwnProperty("customerFeedError")) {
                                object.customerFeedError = options.enums === String ? $root.google.ads.googleads.v1.errors.CustomerFeedErrorEnum.CustomerFeedError[message.customerFeedError] : message.customerFeedError;
                                if (options.oneofs)
                                    object.errorCode = "customerFeedError";
                            }
                            if (message.adGroupFeedError != null && message.hasOwnProperty("adGroupFeedError")) {
                                object.adGroupFeedError = options.enums === String ? $root.google.ads.googleads.v1.errors.AdGroupFeedErrorEnum.AdGroupFeedError[message.adGroupFeedError] : message.adGroupFeedError;
                                if (options.oneofs)
                                    object.errorCode = "adGroupFeedError";
                            }
                            if (message.campaignFeedError != null && message.hasOwnProperty("campaignFeedError")) {
                                object.campaignFeedError = options.enums === String ? $root.google.ads.googleads.v1.errors.CampaignFeedErrorEnum.CampaignFeedError[message.campaignFeedError] : message.campaignFeedError;
                                if (options.oneofs)
                                    object.errorCode = "campaignFeedError";
                            }
                            if (message.customInterestError != null && message.hasOwnProperty("customInterestError")) {
                                object.customInterestError = options.enums === String ? $root.google.ads.googleads.v1.errors.CustomInterestErrorEnum.CustomInterestError[message.customInterestError] : message.customInterestError;
                                if (options.oneofs)
                                    object.errorCode = "customInterestError";
                            }
                            if (message.extensionFeedItemError != null && message.hasOwnProperty("extensionFeedItemError")) {
                                object.extensionFeedItemError = options.enums === String ? $root.google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum.ExtensionFeedItemError[message.extensionFeedItemError] : message.extensionFeedItemError;
                                if (options.oneofs)
                                    object.errorCode = "extensionFeedItemError";
                            }
                            if (message.adParameterError != null && message.hasOwnProperty("adParameterError")) {
                                object.adParameterError = options.enums === String ? $root.google.ads.googleads.v1.errors.AdParameterErrorEnum.AdParameterError[message.adParameterError] : message.adParameterError;
                                if (options.oneofs)
                                    object.errorCode = "adParameterError";
                            }
                            if (message.feedItemValidationError != null && message.hasOwnProperty("feedItemValidationError")) {
                                object.feedItemValidationError = options.enums === String ? $root.google.ads.googleads.v1.errors.FeedItemValidationErrorEnum.FeedItemValidationError[message.feedItemValidationError] : message.feedItemValidationError;
                                if (options.oneofs)
                                    object.errorCode = "feedItemValidationError";
                            }
                            if (message.extensionSettingError != null && message.hasOwnProperty("extensionSettingError")) {
                                object.extensionSettingError = options.enums === String ? $root.google.ads.googleads.v1.errors.ExtensionSettingErrorEnum.ExtensionSettingError[message.extensionSettingError] : message.extensionSettingError;
                                if (options.oneofs)
                                    object.errorCode = "extensionSettingError";
                            }
                            if (message.feedItemTargetError != null && message.hasOwnProperty("feedItemTargetError")) {
                                object.feedItemTargetError = options.enums === String ? $root.google.ads.googleads.v1.errors.FeedItemTargetErrorEnum.FeedItemTargetError[message.feedItemTargetError] : message.feedItemTargetError;
                                if (options.oneofs)
                                    object.errorCode = "feedItemTargetError";
                            }
                            if (message.policyViolationError != null && message.hasOwnProperty("policyViolationError")) {
                                object.policyViolationError = options.enums === String ? $root.google.ads.googleads.v1.errors.PolicyViolationErrorEnum.PolicyViolationError[message.policyViolationError] : message.policyViolationError;
                                if (options.oneofs)
                                    object.errorCode = "policyViolationError";
                            }
                            if (message.assetError != null && message.hasOwnProperty("assetError")) {
                                object.assetError = options.enums === String ? $root.google.ads.googleads.v1.errors.AssetErrorEnum.AssetError[message.assetError] : message.assetError;
                                if (options.oneofs)
                                    object.errorCode = "assetError";
                            }
                            if (message.mutateJobError != null && message.hasOwnProperty("mutateJobError")) {
                                object.mutateJobError = options.enums === String ? $root.google.ads.googleads.v1.errors.MutateJobErrorEnum.MutateJobError[message.mutateJobError] : message.mutateJobError;
                                if (options.oneofs)
                                    object.errorCode = "mutateJobError";
                            }
                            if (message.countryCodeError != null && message.hasOwnProperty("countryCodeError")) {
                                object.countryCodeError = options.enums === String ? $root.google.ads.googleads.v1.errors.CountryCodeErrorEnum.CountryCodeError[message.countryCodeError] : message.countryCodeError;
                                if (options.oneofs)
                                    object.errorCode = "countryCodeError";
                            }
                            if (message.languageCodeError != null && message.hasOwnProperty("languageCodeError")) {
                                object.languageCodeError = options.enums === String ? $root.google.ads.googleads.v1.errors.LanguageCodeErrorEnum.LanguageCodeError[message.languageCodeError] : message.languageCodeError;
                                if (options.oneofs)
                                    object.errorCode = "languageCodeError";
                            }
                            if (message.conversionUploadError != null && message.hasOwnProperty("conversionUploadError")) {
                                object.conversionUploadError = options.enums === String ? $root.google.ads.googleads.v1.errors.ConversionUploadErrorEnum.ConversionUploadError[message.conversionUploadError] : message.conversionUploadError;
                                if (options.oneofs)
                                    object.errorCode = "conversionUploadError";
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                object.partialFailureError = options.enums === String ? $root.google.ads.googleads.v1.errors.PartialFailureErrorEnum.PartialFailureError[message.partialFailureError] : message.partialFailureError;
                                if (options.oneofs)
                                    object.errorCode = "partialFailureError";
                            }
                            if (message.policyValidationParameterError != null && message.hasOwnProperty("policyValidationParameterError")) {
                                object.policyValidationParameterError = options.enums === String ? $root.google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum.PolicyValidationParameterError[message.policyValidationParameterError] : message.policyValidationParameterError;
                                if (options.oneofs)
                                    object.errorCode = "policyValidationParameterError";
                            }
                            if (message.conversionAdjustmentUploadError != null && message.hasOwnProperty("conversionAdjustmentUploadError")) {
                                object.conversionAdjustmentUploadError = options.enums === String ? $root.google.ads.googleads.v1.errors.ConversionAdjustmentUploadErrorEnum.ConversionAdjustmentUploadError[message.conversionAdjustmentUploadError] : message.conversionAdjustmentUploadError;
                                if (options.oneofs)
                                    object.errorCode = "conversionAdjustmentUploadError";
                            }
                            if (message.mediaUploadError != null && message.hasOwnProperty("mediaUploadError")) {
                                object.mediaUploadError = options.enums === String ? $root.google.ads.googleads.v1.errors.MediaUploadErrorEnum.MediaUploadError[message.mediaUploadError] : message.mediaUploadError;
                                if (options.oneofs)
                                    object.errorCode = "mediaUploadError";
                            }
                            if (message.youtubeVideoRegistrationError != null && message.hasOwnProperty("youtubeVideoRegistrationError")) {
                                object.youtubeVideoRegistrationError = options.enums === String ? $root.google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum.YoutubeVideoRegistrationError[message.youtubeVideoRegistrationError] : message.youtubeVideoRegistrationError;
                                if (options.oneofs)
                                    object.errorCode = "youtubeVideoRegistrationError";
                            }
                            if (message.sizeLimitError != null && message.hasOwnProperty("sizeLimitError")) {
                                object.sizeLimitError = options.enums === String ? $root.google.ads.googleads.v1.errors.SizeLimitErrorEnum.SizeLimitError[message.sizeLimitError] : message.sizeLimitError;
                                if (options.oneofs)
                                    object.errorCode = "sizeLimitError";
                            }
                            return object;
                        };

                        /**
                         * Converts this ErrorCode to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.ErrorCode
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ErrorCode.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ErrorCode;
                    })();

                    errors.ErrorLocation = (function() {

                        /**
                         * Properties of an ErrorLocation.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IErrorLocation
                         * @property {Array.<google.ads.googleads.v1.errors.ErrorLocation.IFieldPathElement>|null} [fieldPathElements] ErrorLocation fieldPathElements
                         */

                        /**
                         * Constructs a new ErrorLocation.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an ErrorLocation.
                         * @implements IErrorLocation
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IErrorLocation=} [properties] Properties to set
                         */
                        function ErrorLocation(properties) {
                            this.fieldPathElements = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ErrorLocation fieldPathElements.
                         * @member {Array.<google.ads.googleads.v1.errors.ErrorLocation.IFieldPathElement>} fieldPathElements
                         * @memberof google.ads.googleads.v1.errors.ErrorLocation
                         * @instance
                         */
                        ErrorLocation.prototype.fieldPathElements = $util.emptyArray;

                        /**
                         * Creates a new ErrorLocation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.ErrorLocation
                         * @static
                         * @param {google.ads.googleads.v1.errors.IErrorLocation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.ErrorLocation} ErrorLocation instance
                         */
                        ErrorLocation.create = function create(properties) {
                            return new ErrorLocation(properties);
                        };

                        /**
                         * Encodes the specified ErrorLocation message. Does not implicitly {@link google.ads.googleads.v1.errors.ErrorLocation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.ErrorLocation
                         * @static
                         * @param {google.ads.googleads.v1.errors.IErrorLocation} message ErrorLocation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ErrorLocation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.fieldPathElements != null && message.fieldPathElements.length)
                                for (var i = 0; i < message.fieldPathElements.length; ++i)
                                    $root.google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement.encode(message.fieldPathElements[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ErrorLocation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.ErrorLocation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ErrorLocation
                         * @static
                         * @param {google.ads.googleads.v1.errors.IErrorLocation} message ErrorLocation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ErrorLocation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ErrorLocation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.ErrorLocation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.ErrorLocation} ErrorLocation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ErrorLocation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.ErrorLocation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2:
                                    if (!(message.fieldPathElements && message.fieldPathElements.length))
                                        message.fieldPathElements = [];
                                    message.fieldPathElements.push($root.google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ErrorLocation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ErrorLocation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.ErrorLocation} ErrorLocation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ErrorLocation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ErrorLocation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.ErrorLocation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ErrorLocation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.fieldPathElements != null && message.hasOwnProperty("fieldPathElements")) {
                                if (!Array.isArray(message.fieldPathElements))
                                    return "fieldPathElements: array expected";
                                for (var i = 0; i < message.fieldPathElements.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement.verify(message.fieldPathElements[i]);
                                    if (error)
                                        return "fieldPathElements." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an ErrorLocation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.ErrorLocation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.ErrorLocation} ErrorLocation
                         */
                        ErrorLocation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.ErrorLocation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.errors.ErrorLocation();
                            if (object.fieldPathElements) {
                                if (!Array.isArray(object.fieldPathElements))
                                    throw TypeError(".google.ads.googleads.v1.errors.ErrorLocation.fieldPathElements: array expected");
                                message.fieldPathElements = [];
                                for (var i = 0; i < object.fieldPathElements.length; ++i) {
                                    if (typeof object.fieldPathElements[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.errors.ErrorLocation.fieldPathElements: object expected");
                                    message.fieldPathElements[i] = $root.google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement.fromObject(object.fieldPathElements[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an ErrorLocation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.ErrorLocation
                         * @static
                         * @param {google.ads.googleads.v1.errors.ErrorLocation} message ErrorLocation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ErrorLocation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.fieldPathElements = [];
                            if (message.fieldPathElements && message.fieldPathElements.length) {
                                object.fieldPathElements = [];
                                for (var j = 0; j < message.fieldPathElements.length; ++j)
                                    object.fieldPathElements[j] = $root.google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement.toObject(message.fieldPathElements[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this ErrorLocation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.ErrorLocation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ErrorLocation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        ErrorLocation.FieldPathElement = (function() {

                            /**
                             * Properties of a FieldPathElement.
                             * @memberof google.ads.googleads.v1.errors.ErrorLocation
                             * @interface IFieldPathElement
                             * @property {string|null} [fieldName] FieldPathElement fieldName
                             * @property {google.protobuf.IInt64Value|null} [index] FieldPathElement index
                             */

                            /**
                             * Constructs a new FieldPathElement.
                             * @memberof google.ads.googleads.v1.errors.ErrorLocation
                             * @classdesc Represents a FieldPathElement.
                             * @implements IFieldPathElement
                             * @constructor
                             * @param {google.ads.googleads.v1.errors.ErrorLocation.IFieldPathElement=} [properties] Properties to set
                             */
                            function FieldPathElement(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * FieldPathElement fieldName.
                             * @member {string} fieldName
                             * @memberof google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement
                             * @instance
                             */
                            FieldPathElement.prototype.fieldName = "";

                            /**
                             * FieldPathElement index.
                             * @member {google.protobuf.IInt64Value|null|undefined} index
                             * @memberof google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement
                             * @instance
                             */
                            FieldPathElement.prototype.index = null;

                            /**
                             * Creates a new FieldPathElement instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement
                             * @static
                             * @param {google.ads.googleads.v1.errors.ErrorLocation.IFieldPathElement=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement} FieldPathElement instance
                             */
                            FieldPathElement.create = function create(properties) {
                                return new FieldPathElement(properties);
                            };

                            /**
                             * Encodes the specified FieldPathElement message. Does not implicitly {@link google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement
                             * @static
                             * @param {google.ads.googleads.v1.errors.ErrorLocation.IFieldPathElement} message FieldPathElement message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            FieldPathElement.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.fieldName != null && message.hasOwnProperty("fieldName"))
                                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.fieldName);
                                if (message.index != null && message.hasOwnProperty("index"))
                                    $root.google.protobuf.Int64Value.encode(message.index, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified FieldPathElement message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement
                             * @static
                             * @param {google.ads.googleads.v1.errors.ErrorLocation.IFieldPathElement} message FieldPathElement message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            FieldPathElement.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a FieldPathElement message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement} FieldPathElement
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            FieldPathElement.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.fieldName = reader.string();
                                        break;
                                    case 2:
                                        message.index = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a FieldPathElement message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement} FieldPathElement
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            FieldPathElement.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a FieldPathElement message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            FieldPathElement.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.fieldName != null && message.hasOwnProperty("fieldName"))
                                    if (!$util.isString(message.fieldName))
                                        return "fieldName: string expected";
                                if (message.index != null && message.hasOwnProperty("index")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.index);
                                    if (error)
                                        return "index." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a FieldPathElement message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement} FieldPathElement
                             */
                            FieldPathElement.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement();
                                if (object.fieldName != null)
                                    message.fieldName = String(object.fieldName);
                                if (object.index != null) {
                                    if (typeof object.index !== "object")
                                        throw TypeError(".google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement.index: object expected");
                                    message.index = $root.google.protobuf.Int64Value.fromObject(object.index);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a FieldPathElement message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement
                             * @static
                             * @param {google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement} message FieldPathElement
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            FieldPathElement.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.fieldName = "";
                                    object.index = null;
                                }
                                if (message.fieldName != null && message.hasOwnProperty("fieldName"))
                                    object.fieldName = message.fieldName;
                                if (message.index != null && message.hasOwnProperty("index"))
                                    object.index = $root.google.protobuf.Int64Value.toObject(message.index, options);
                                return object;
                            };

                            /**
                             * Converts this FieldPathElement to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.errors.ErrorLocation.FieldPathElement
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            FieldPathElement.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return FieldPathElement;
                        })();

                        return ErrorLocation;
                    })();

                    errors.ErrorDetails = (function() {

                        /**
                         * Properties of an ErrorDetails.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IErrorDetails
                         * @property {string|null} [unpublishedErrorCode] ErrorDetails unpublishedErrorCode
                         * @property {google.ads.googleads.v1.errors.IPolicyViolationDetails|null} [policyViolationDetails] ErrorDetails policyViolationDetails
                         * @property {google.ads.googleads.v1.errors.IPolicyFindingDetails|null} [policyFindingDetails] ErrorDetails policyFindingDetails
                         */

                        /**
                         * Constructs a new ErrorDetails.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an ErrorDetails.
                         * @implements IErrorDetails
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IErrorDetails=} [properties] Properties to set
                         */
                        function ErrorDetails(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ErrorDetails unpublishedErrorCode.
                         * @member {string} unpublishedErrorCode
                         * @memberof google.ads.googleads.v1.errors.ErrorDetails
                         * @instance
                         */
                        ErrorDetails.prototype.unpublishedErrorCode = "";

                        /**
                         * ErrorDetails policyViolationDetails.
                         * @member {google.ads.googleads.v1.errors.IPolicyViolationDetails|null|undefined} policyViolationDetails
                         * @memberof google.ads.googleads.v1.errors.ErrorDetails
                         * @instance
                         */
                        ErrorDetails.prototype.policyViolationDetails = null;

                        /**
                         * ErrorDetails policyFindingDetails.
                         * @member {google.ads.googleads.v1.errors.IPolicyFindingDetails|null|undefined} policyFindingDetails
                         * @memberof google.ads.googleads.v1.errors.ErrorDetails
                         * @instance
                         */
                        ErrorDetails.prototype.policyFindingDetails = null;

                        /**
                         * Creates a new ErrorDetails instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.ErrorDetails
                         * @static
                         * @param {google.ads.googleads.v1.errors.IErrorDetails=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.ErrorDetails} ErrorDetails instance
                         */
                        ErrorDetails.create = function create(properties) {
                            return new ErrorDetails(properties);
                        };

                        /**
                         * Encodes the specified ErrorDetails message. Does not implicitly {@link google.ads.googleads.v1.errors.ErrorDetails.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.ErrorDetails
                         * @static
                         * @param {google.ads.googleads.v1.errors.IErrorDetails} message ErrorDetails message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ErrorDetails.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.unpublishedErrorCode != null && message.hasOwnProperty("unpublishedErrorCode"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.unpublishedErrorCode);
                            if (message.policyViolationDetails != null && message.hasOwnProperty("policyViolationDetails"))
                                $root.google.ads.googleads.v1.errors.PolicyViolationDetails.encode(message.policyViolationDetails, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.policyFindingDetails != null && message.hasOwnProperty("policyFindingDetails"))
                                $root.google.ads.googleads.v1.errors.PolicyFindingDetails.encode(message.policyFindingDetails, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ErrorDetails message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.ErrorDetails.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ErrorDetails
                         * @static
                         * @param {google.ads.googleads.v1.errors.IErrorDetails} message ErrorDetails message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ErrorDetails.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ErrorDetails message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.ErrorDetails
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.ErrorDetails} ErrorDetails
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ErrorDetails.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.ErrorDetails();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.unpublishedErrorCode = reader.string();
                                    break;
                                case 2:
                                    message.policyViolationDetails = $root.google.ads.googleads.v1.errors.PolicyViolationDetails.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.policyFindingDetails = $root.google.ads.googleads.v1.errors.PolicyFindingDetails.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ErrorDetails message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ErrorDetails
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.ErrorDetails} ErrorDetails
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ErrorDetails.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ErrorDetails message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.ErrorDetails
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ErrorDetails.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.unpublishedErrorCode != null && message.hasOwnProperty("unpublishedErrorCode"))
                                if (!$util.isString(message.unpublishedErrorCode))
                                    return "unpublishedErrorCode: string expected";
                            if (message.policyViolationDetails != null && message.hasOwnProperty("policyViolationDetails")) {
                                var error = $root.google.ads.googleads.v1.errors.PolicyViolationDetails.verify(message.policyViolationDetails);
                                if (error)
                                    return "policyViolationDetails." + error;
                            }
                            if (message.policyFindingDetails != null && message.hasOwnProperty("policyFindingDetails")) {
                                var error = $root.google.ads.googleads.v1.errors.PolicyFindingDetails.verify(message.policyFindingDetails);
                                if (error)
                                    return "policyFindingDetails." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an ErrorDetails message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.ErrorDetails
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.ErrorDetails} ErrorDetails
                         */
                        ErrorDetails.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.ErrorDetails)
                                return object;
                            var message = new $root.google.ads.googleads.v1.errors.ErrorDetails();
                            if (object.unpublishedErrorCode != null)
                                message.unpublishedErrorCode = String(object.unpublishedErrorCode);
                            if (object.policyViolationDetails != null) {
                                if (typeof object.policyViolationDetails !== "object")
                                    throw TypeError(".google.ads.googleads.v1.errors.ErrorDetails.policyViolationDetails: object expected");
                                message.policyViolationDetails = $root.google.ads.googleads.v1.errors.PolicyViolationDetails.fromObject(object.policyViolationDetails);
                            }
                            if (object.policyFindingDetails != null) {
                                if (typeof object.policyFindingDetails !== "object")
                                    throw TypeError(".google.ads.googleads.v1.errors.ErrorDetails.policyFindingDetails: object expected");
                                message.policyFindingDetails = $root.google.ads.googleads.v1.errors.PolicyFindingDetails.fromObject(object.policyFindingDetails);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an ErrorDetails message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.ErrorDetails
                         * @static
                         * @param {google.ads.googleads.v1.errors.ErrorDetails} message ErrorDetails
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ErrorDetails.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.unpublishedErrorCode = "";
                                object.policyViolationDetails = null;
                                object.policyFindingDetails = null;
                            }
                            if (message.unpublishedErrorCode != null && message.hasOwnProperty("unpublishedErrorCode"))
                                object.unpublishedErrorCode = message.unpublishedErrorCode;
                            if (message.policyViolationDetails != null && message.hasOwnProperty("policyViolationDetails"))
                                object.policyViolationDetails = $root.google.ads.googleads.v1.errors.PolicyViolationDetails.toObject(message.policyViolationDetails, options);
                            if (message.policyFindingDetails != null && message.hasOwnProperty("policyFindingDetails"))
                                object.policyFindingDetails = $root.google.ads.googleads.v1.errors.PolicyFindingDetails.toObject(message.policyFindingDetails, options);
                            return object;
                        };

                        /**
                         * Converts this ErrorDetails to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.ErrorDetails
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ErrorDetails.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ErrorDetails;
                    })();

                    errors.PolicyViolationDetails = (function() {

                        /**
                         * Properties of a PolicyViolationDetails.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IPolicyViolationDetails
                         * @property {string|null} [externalPolicyDescription] PolicyViolationDetails externalPolicyDescription
                         * @property {google.ads.googleads.v1.common.IPolicyViolationKey|null} [key] PolicyViolationDetails key
                         * @property {string|null} [externalPolicyName] PolicyViolationDetails externalPolicyName
                         * @property {boolean|null} [isExemptible] PolicyViolationDetails isExemptible
                         */

                        /**
                         * Constructs a new PolicyViolationDetails.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a PolicyViolationDetails.
                         * @implements IPolicyViolationDetails
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IPolicyViolationDetails=} [properties] Properties to set
                         */
                        function PolicyViolationDetails(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * PolicyViolationDetails externalPolicyDescription.
                         * @member {string} externalPolicyDescription
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationDetails
                         * @instance
                         */
                        PolicyViolationDetails.prototype.externalPolicyDescription = "";

                        /**
                         * PolicyViolationDetails key.
                         * @member {google.ads.googleads.v1.common.IPolicyViolationKey|null|undefined} key
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationDetails
                         * @instance
                         */
                        PolicyViolationDetails.prototype.key = null;

                        /**
                         * PolicyViolationDetails externalPolicyName.
                         * @member {string} externalPolicyName
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationDetails
                         * @instance
                         */
                        PolicyViolationDetails.prototype.externalPolicyName = "";

                        /**
                         * PolicyViolationDetails isExemptible.
                         * @member {boolean} isExemptible
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationDetails
                         * @instance
                         */
                        PolicyViolationDetails.prototype.isExemptible = false;

                        /**
                         * Creates a new PolicyViolationDetails instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationDetails
                         * @static
                         * @param {google.ads.googleads.v1.errors.IPolicyViolationDetails=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.PolicyViolationDetails} PolicyViolationDetails instance
                         */
                        PolicyViolationDetails.create = function create(properties) {
                            return new PolicyViolationDetails(properties);
                        };

                        /**
                         * Encodes the specified PolicyViolationDetails message. Does not implicitly {@link google.ads.googleads.v1.errors.PolicyViolationDetails.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationDetails
                         * @static
                         * @param {google.ads.googleads.v1.errors.IPolicyViolationDetails} message PolicyViolationDetails message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyViolationDetails.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.externalPolicyDescription != null && message.hasOwnProperty("externalPolicyDescription"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.externalPolicyDescription);
                            if (message.key != null && message.hasOwnProperty("key"))
                                $root.google.ads.googleads.v1.common.PolicyViolationKey.encode(message.key, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.externalPolicyName != null && message.hasOwnProperty("externalPolicyName"))
                                writer.uint32(/* id 5, wireType 2 =*/42).string(message.externalPolicyName);
                            if (message.isExemptible != null && message.hasOwnProperty("isExemptible"))
                                writer.uint32(/* id 6, wireType 0 =*/48).bool(message.isExemptible);
                            return writer;
                        };

                        /**
                         * Encodes the specified PolicyViolationDetails message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.PolicyViolationDetails.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationDetails
                         * @static
                         * @param {google.ads.googleads.v1.errors.IPolicyViolationDetails} message PolicyViolationDetails message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyViolationDetails.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PolicyViolationDetails message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationDetails
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.PolicyViolationDetails} PolicyViolationDetails
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyViolationDetails.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.PolicyViolationDetails();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2:
                                    message.externalPolicyDescription = reader.string();
                                    break;
                                case 4:
                                    message.key = $root.google.ads.googleads.v1.common.PolicyViolationKey.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.externalPolicyName = reader.string();
                                    break;
                                case 6:
                                    message.isExemptible = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PolicyViolationDetails message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationDetails
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.PolicyViolationDetails} PolicyViolationDetails
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyViolationDetails.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PolicyViolationDetails message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationDetails
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PolicyViolationDetails.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.externalPolicyDescription != null && message.hasOwnProperty("externalPolicyDescription"))
                                if (!$util.isString(message.externalPolicyDescription))
                                    return "externalPolicyDescription: string expected";
                            if (message.key != null && message.hasOwnProperty("key")) {
                                var error = $root.google.ads.googleads.v1.common.PolicyViolationKey.verify(message.key);
                                if (error)
                                    return "key." + error;
                            }
                            if (message.externalPolicyName != null && message.hasOwnProperty("externalPolicyName"))
                                if (!$util.isString(message.externalPolicyName))
                                    return "externalPolicyName: string expected";
                            if (message.isExemptible != null && message.hasOwnProperty("isExemptible"))
                                if (typeof message.isExemptible !== "boolean")
                                    return "isExemptible: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a PolicyViolationDetails message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationDetails
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.PolicyViolationDetails} PolicyViolationDetails
                         */
                        PolicyViolationDetails.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.PolicyViolationDetails)
                                return object;
                            var message = new $root.google.ads.googleads.v1.errors.PolicyViolationDetails();
                            if (object.externalPolicyDescription != null)
                                message.externalPolicyDescription = String(object.externalPolicyDescription);
                            if (object.key != null) {
                                if (typeof object.key !== "object")
                                    throw TypeError(".google.ads.googleads.v1.errors.PolicyViolationDetails.key: object expected");
                                message.key = $root.google.ads.googleads.v1.common.PolicyViolationKey.fromObject(object.key);
                            }
                            if (object.externalPolicyName != null)
                                message.externalPolicyName = String(object.externalPolicyName);
                            if (object.isExemptible != null)
                                message.isExemptible = Boolean(object.isExemptible);
                            return message;
                        };

                        /**
                         * Creates a plain object from a PolicyViolationDetails message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationDetails
                         * @static
                         * @param {google.ads.googleads.v1.errors.PolicyViolationDetails} message PolicyViolationDetails
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PolicyViolationDetails.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.externalPolicyDescription = "";
                                object.key = null;
                                object.externalPolicyName = "";
                                object.isExemptible = false;
                            }
                            if (message.externalPolicyDescription != null && message.hasOwnProperty("externalPolicyDescription"))
                                object.externalPolicyDescription = message.externalPolicyDescription;
                            if (message.key != null && message.hasOwnProperty("key"))
                                object.key = $root.google.ads.googleads.v1.common.PolicyViolationKey.toObject(message.key, options);
                            if (message.externalPolicyName != null && message.hasOwnProperty("externalPolicyName"))
                                object.externalPolicyName = message.externalPolicyName;
                            if (message.isExemptible != null && message.hasOwnProperty("isExemptible"))
                                object.isExemptible = message.isExemptible;
                            return object;
                        };

                        /**
                         * Converts this PolicyViolationDetails to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationDetails
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PolicyViolationDetails.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return PolicyViolationDetails;
                    })();

                    errors.PolicyFindingDetails = (function() {

                        /**
                         * Properties of a PolicyFindingDetails.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IPolicyFindingDetails
                         * @property {Array.<google.ads.googleads.v1.common.IPolicyTopicEntry>|null} [policyTopicEntries] PolicyFindingDetails policyTopicEntries
                         */

                        /**
                         * Constructs a new PolicyFindingDetails.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a PolicyFindingDetails.
                         * @implements IPolicyFindingDetails
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IPolicyFindingDetails=} [properties] Properties to set
                         */
                        function PolicyFindingDetails(properties) {
                            this.policyTopicEntries = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * PolicyFindingDetails policyTopicEntries.
                         * @member {Array.<google.ads.googleads.v1.common.IPolicyTopicEntry>} policyTopicEntries
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingDetails
                         * @instance
                         */
                        PolicyFindingDetails.prototype.policyTopicEntries = $util.emptyArray;

                        /**
                         * Creates a new PolicyFindingDetails instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingDetails
                         * @static
                         * @param {google.ads.googleads.v1.errors.IPolicyFindingDetails=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.PolicyFindingDetails} PolicyFindingDetails instance
                         */
                        PolicyFindingDetails.create = function create(properties) {
                            return new PolicyFindingDetails(properties);
                        };

                        /**
                         * Encodes the specified PolicyFindingDetails message. Does not implicitly {@link google.ads.googleads.v1.errors.PolicyFindingDetails.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingDetails
                         * @static
                         * @param {google.ads.googleads.v1.errors.IPolicyFindingDetails} message PolicyFindingDetails message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyFindingDetails.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.policyTopicEntries != null && message.policyTopicEntries.length)
                                for (var i = 0; i < message.policyTopicEntries.length; ++i)
                                    $root.google.ads.googleads.v1.common.PolicyTopicEntry.encode(message.policyTopicEntries[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified PolicyFindingDetails message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.PolicyFindingDetails.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingDetails
                         * @static
                         * @param {google.ads.googleads.v1.errors.IPolicyFindingDetails} message PolicyFindingDetails message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyFindingDetails.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PolicyFindingDetails message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingDetails
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.PolicyFindingDetails} PolicyFindingDetails
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyFindingDetails.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.PolicyFindingDetails();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.policyTopicEntries && message.policyTopicEntries.length))
                                        message.policyTopicEntries = [];
                                    message.policyTopicEntries.push($root.google.ads.googleads.v1.common.PolicyTopicEntry.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PolicyFindingDetails message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingDetails
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.PolicyFindingDetails} PolicyFindingDetails
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyFindingDetails.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PolicyFindingDetails message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingDetails
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PolicyFindingDetails.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.policyTopicEntries != null && message.hasOwnProperty("policyTopicEntries")) {
                                if (!Array.isArray(message.policyTopicEntries))
                                    return "policyTopicEntries: array expected";
                                for (var i = 0; i < message.policyTopicEntries.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.PolicyTopicEntry.verify(message.policyTopicEntries[i]);
                                    if (error)
                                        return "policyTopicEntries." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a PolicyFindingDetails message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingDetails
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.PolicyFindingDetails} PolicyFindingDetails
                         */
                        PolicyFindingDetails.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.PolicyFindingDetails)
                                return object;
                            var message = new $root.google.ads.googleads.v1.errors.PolicyFindingDetails();
                            if (object.policyTopicEntries) {
                                if (!Array.isArray(object.policyTopicEntries))
                                    throw TypeError(".google.ads.googleads.v1.errors.PolicyFindingDetails.policyTopicEntries: array expected");
                                message.policyTopicEntries = [];
                                for (var i = 0; i < object.policyTopicEntries.length; ++i) {
                                    if (typeof object.policyTopicEntries[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.errors.PolicyFindingDetails.policyTopicEntries: object expected");
                                    message.policyTopicEntries[i] = $root.google.ads.googleads.v1.common.PolicyTopicEntry.fromObject(object.policyTopicEntries[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a PolicyFindingDetails message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingDetails
                         * @static
                         * @param {google.ads.googleads.v1.errors.PolicyFindingDetails} message PolicyFindingDetails
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PolicyFindingDetails.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.policyTopicEntries = [];
                            if (message.policyTopicEntries && message.policyTopicEntries.length) {
                                object.policyTopicEntries = [];
                                for (var j = 0; j < message.policyTopicEntries.length; ++j)
                                    object.policyTopicEntries[j] = $root.google.ads.googleads.v1.common.PolicyTopicEntry.toObject(message.policyTopicEntries[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this PolicyFindingDetails to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingDetails
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PolicyFindingDetails.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return PolicyFindingDetails;
                    })();

                    errors.ExtensionFeedItemErrorEnum = (function() {

                        /**
                         * Properties of an ExtensionFeedItemErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IExtensionFeedItemErrorEnum
                         */

                        /**
                         * Constructs a new ExtensionFeedItemErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an ExtensionFeedItemErrorEnum.
                         * @implements IExtensionFeedItemErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IExtensionFeedItemErrorEnum=} [properties] Properties to set
                         */
                        function ExtensionFeedItemErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ExtensionFeedItemErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IExtensionFeedItemErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum} ExtensionFeedItemErrorEnum instance
                         */
                        ExtensionFeedItemErrorEnum.create = function create(properties) {
                            return new ExtensionFeedItemErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified ExtensionFeedItemErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IExtensionFeedItemErrorEnum} message ExtensionFeedItemErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExtensionFeedItemErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ExtensionFeedItemErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IExtensionFeedItemErrorEnum} message ExtensionFeedItemErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExtensionFeedItemErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ExtensionFeedItemErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum} ExtensionFeedItemErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExtensionFeedItemErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ExtensionFeedItemErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum} ExtensionFeedItemErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExtensionFeedItemErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ExtensionFeedItemErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExtensionFeedItemErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an ExtensionFeedItemErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum} ExtensionFeedItemErrorEnum
                         */
                        ExtensionFeedItemErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum();
                        };

                        /**
                         * Creates a plain object from an ExtensionFeedItemErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum} message ExtensionFeedItemErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExtensionFeedItemErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ExtensionFeedItemErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExtensionFeedItemErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ExtensionFeedItemError enum.
                         * @name google.ads.googleads.v1.errors.ExtensionFeedItemErrorEnum.ExtensionFeedItemError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} VALUE_OUT_OF_RANGE=2 VALUE_OUT_OF_RANGE value
                         * @property {number} URL_LIST_TOO_LONG=3 URL_LIST_TOO_LONG value
                         * @property {number} CANNOT_HAVE_RESTRICTION_ON_EMPTY_GEO_TARGETING=4 CANNOT_HAVE_RESTRICTION_ON_EMPTY_GEO_TARGETING value
                         * @property {number} CANNOT_SET_WITH_FINAL_URLS=5 CANNOT_SET_WITH_FINAL_URLS value
                         * @property {number} CANNOT_SET_WITHOUT_FINAL_URLS=6 CANNOT_SET_WITHOUT_FINAL_URLS value
                         * @property {number} INVALID_PHONE_NUMBER=7 INVALID_PHONE_NUMBER value
                         * @property {number} PHONE_NUMBER_NOT_SUPPORTED_FOR_COUNTRY=8 PHONE_NUMBER_NOT_SUPPORTED_FOR_COUNTRY value
                         * @property {number} CARRIER_SPECIFIC_SHORT_NUMBER_NOT_ALLOWED=9 CARRIER_SPECIFIC_SHORT_NUMBER_NOT_ALLOWED value
                         * @property {number} PREMIUM_RATE_NUMBER_NOT_ALLOWED=10 PREMIUM_RATE_NUMBER_NOT_ALLOWED value
                         * @property {number} DISALLOWED_NUMBER_TYPE=11 DISALLOWED_NUMBER_TYPE value
                         * @property {number} INVALID_DOMESTIC_PHONE_NUMBER_FORMAT=12 INVALID_DOMESTIC_PHONE_NUMBER_FORMAT value
                         * @property {number} VANITY_PHONE_NUMBER_NOT_ALLOWED=13 VANITY_PHONE_NUMBER_NOT_ALLOWED value
                         * @property {number} INVALID_CALL_CONVERSION_ACTION=14 INVALID_CALL_CONVERSION_ACTION value
                         * @property {number} CUSTOMER_NOT_WHITELISTED_FOR_CALLTRACKING=15 CUSTOMER_NOT_WHITELISTED_FOR_CALLTRACKING value
                         * @property {number} CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY=16 CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY value
                         * @property {number} CUSTOMER_CONSENT_FOR_CALL_RECORDING_REQUIRED=17 CUSTOMER_CONSENT_FOR_CALL_RECORDING_REQUIRED value
                         * @property {number} INVALID_APP_ID=18 INVALID_APP_ID value
                         * @property {number} QUOTES_IN_REVIEW_EXTENSION_SNIPPET=19 QUOTES_IN_REVIEW_EXTENSION_SNIPPET value
                         * @property {number} HYPHENS_IN_REVIEW_EXTENSION_SNIPPET=20 HYPHENS_IN_REVIEW_EXTENSION_SNIPPET value
                         * @property {number} REVIEW_EXTENSION_SOURCE_INELIGIBLE=21 REVIEW_EXTENSION_SOURCE_INELIGIBLE value
                         * @property {number} SOURCE_NAME_IN_REVIEW_EXTENSION_TEXT=22 SOURCE_NAME_IN_REVIEW_EXTENSION_TEXT value
                         * @property {number} INCONSISTENT_CURRENCY_CODES=23 INCONSISTENT_CURRENCY_CODES value
                         * @property {number} PRICE_EXTENSION_HAS_DUPLICATED_HEADERS=24 PRICE_EXTENSION_HAS_DUPLICATED_HEADERS value
                         * @property {number} PRICE_ITEM_HAS_DUPLICATED_HEADER_AND_DESCRIPTION=25 PRICE_ITEM_HAS_DUPLICATED_HEADER_AND_DESCRIPTION value
                         * @property {number} PRICE_EXTENSION_HAS_TOO_FEW_ITEMS=26 PRICE_EXTENSION_HAS_TOO_FEW_ITEMS value
                         * @property {number} PRICE_EXTENSION_HAS_TOO_MANY_ITEMS=27 PRICE_EXTENSION_HAS_TOO_MANY_ITEMS value
                         * @property {number} UNSUPPORTED_VALUE=28 UNSUPPORTED_VALUE value
                         * @property {number} UNSUPPORTED_VALUE_IN_SELECTED_LANGUAGE=29 UNSUPPORTED_VALUE_IN_SELECTED_LANGUAGE value
                         * @property {number} INVALID_DEVICE_PREFERENCE=30 INVALID_DEVICE_PREFERENCE value
                         * @property {number} INVALID_SCHEDULE_END=31 INVALID_SCHEDULE_END value
                         * @property {number} DATE_TIME_MUST_BE_IN_ACCOUNT_TIME_ZONE=32 DATE_TIME_MUST_BE_IN_ACCOUNT_TIME_ZONE value
                         * @property {number} INVALID_SNIPPETS_HEADER=33 INVALID_SNIPPETS_HEADER value
                         * @property {number} CANNOT_OPERATE_ON_REMOVED_FEED_ITEM=34 CANNOT_OPERATE_ON_REMOVED_FEED_ITEM value
                         * @property {number} PHONE_NUMBER_NOT_SUPPORTED_WITH_CALLTRACKING_FOR_COUNTRY=35 PHONE_NUMBER_NOT_SUPPORTED_WITH_CALLTRACKING_FOR_COUNTRY value
                         * @property {number} CONFLICTING_CALL_CONVERSION_SETTINGS=36 CONFLICTING_CALL_CONVERSION_SETTINGS value
                         * @property {number} EXTENSION_TYPE_MISMATCH=37 EXTENSION_TYPE_MISMATCH value
                         * @property {number} EXTENSION_SUBTYPE_REQUIRED=38 EXTENSION_SUBTYPE_REQUIRED value
                         * @property {number} EXTENSION_TYPE_UNSUPPORTED=39 EXTENSION_TYPE_UNSUPPORTED value
                         * @property {number} CANNOT_OPERATE_ON_FEED_WITH_MULTIPLE_MAPPINGS=40 CANNOT_OPERATE_ON_FEED_WITH_MULTIPLE_MAPPINGS value
                         * @property {number} CANNOT_OPERATE_ON_FEED_WITH_KEY_ATTRIBUTES=41 CANNOT_OPERATE_ON_FEED_WITH_KEY_ATTRIBUTES value
                         * @property {number} INVALID_PRICE_FORMAT=42 INVALID_PRICE_FORMAT value
                         * @property {number} PROMOTION_INVALID_TIME=43 PROMOTION_INVALID_TIME value
                         * @property {number} TOO_MANY_DECIMAL_PLACES_SPECIFIED=44 TOO_MANY_DECIMAL_PLACES_SPECIFIED value
                         */
                        ExtensionFeedItemErrorEnum.ExtensionFeedItemError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "VALUE_OUT_OF_RANGE"] = 2;
                            values[valuesById[3] = "URL_LIST_TOO_LONG"] = 3;
                            values[valuesById[4] = "CANNOT_HAVE_RESTRICTION_ON_EMPTY_GEO_TARGETING"] = 4;
                            values[valuesById[5] = "CANNOT_SET_WITH_FINAL_URLS"] = 5;
                            values[valuesById[6] = "CANNOT_SET_WITHOUT_FINAL_URLS"] = 6;
                            values[valuesById[7] = "INVALID_PHONE_NUMBER"] = 7;
                            values[valuesById[8] = "PHONE_NUMBER_NOT_SUPPORTED_FOR_COUNTRY"] = 8;
                            values[valuesById[9] = "CARRIER_SPECIFIC_SHORT_NUMBER_NOT_ALLOWED"] = 9;
                            values[valuesById[10] = "PREMIUM_RATE_NUMBER_NOT_ALLOWED"] = 10;
                            values[valuesById[11] = "DISALLOWED_NUMBER_TYPE"] = 11;
                            values[valuesById[12] = "INVALID_DOMESTIC_PHONE_NUMBER_FORMAT"] = 12;
                            values[valuesById[13] = "VANITY_PHONE_NUMBER_NOT_ALLOWED"] = 13;
                            values[valuesById[14] = "INVALID_CALL_CONVERSION_ACTION"] = 14;
                            values[valuesById[15] = "CUSTOMER_NOT_WHITELISTED_FOR_CALLTRACKING"] = 15;
                            values[valuesById[16] = "CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY"] = 16;
                            values[valuesById[17] = "CUSTOMER_CONSENT_FOR_CALL_RECORDING_REQUIRED"] = 17;
                            values[valuesById[18] = "INVALID_APP_ID"] = 18;
                            values[valuesById[19] = "QUOTES_IN_REVIEW_EXTENSION_SNIPPET"] = 19;
                            values[valuesById[20] = "HYPHENS_IN_REVIEW_EXTENSION_SNIPPET"] = 20;
                            values[valuesById[21] = "REVIEW_EXTENSION_SOURCE_INELIGIBLE"] = 21;
                            values[valuesById[22] = "SOURCE_NAME_IN_REVIEW_EXTENSION_TEXT"] = 22;
                            values[valuesById[23] = "INCONSISTENT_CURRENCY_CODES"] = 23;
                            values[valuesById[24] = "PRICE_EXTENSION_HAS_DUPLICATED_HEADERS"] = 24;
                            values[valuesById[25] = "PRICE_ITEM_HAS_DUPLICATED_HEADER_AND_DESCRIPTION"] = 25;
                            values[valuesById[26] = "PRICE_EXTENSION_HAS_TOO_FEW_ITEMS"] = 26;
                            values[valuesById[27] = "PRICE_EXTENSION_HAS_TOO_MANY_ITEMS"] = 27;
                            values[valuesById[28] = "UNSUPPORTED_VALUE"] = 28;
                            values[valuesById[29] = "UNSUPPORTED_VALUE_IN_SELECTED_LANGUAGE"] = 29;
                            values[valuesById[30] = "INVALID_DEVICE_PREFERENCE"] = 30;
                            values[valuesById[31] = "INVALID_SCHEDULE_END"] = 31;
                            values[valuesById[32] = "DATE_TIME_MUST_BE_IN_ACCOUNT_TIME_ZONE"] = 32;
                            values[valuesById[33] = "INVALID_SNIPPETS_HEADER"] = 33;
                            values[valuesById[34] = "CANNOT_OPERATE_ON_REMOVED_FEED_ITEM"] = 34;
                            values[valuesById[35] = "PHONE_NUMBER_NOT_SUPPORTED_WITH_CALLTRACKING_FOR_COUNTRY"] = 35;
                            values[valuesById[36] = "CONFLICTING_CALL_CONVERSION_SETTINGS"] = 36;
                            values[valuesById[37] = "EXTENSION_TYPE_MISMATCH"] = 37;
                            values[valuesById[38] = "EXTENSION_SUBTYPE_REQUIRED"] = 38;
                            values[valuesById[39] = "EXTENSION_TYPE_UNSUPPORTED"] = 39;
                            values[valuesById[40] = "CANNOT_OPERATE_ON_FEED_WITH_MULTIPLE_MAPPINGS"] = 40;
                            values[valuesById[41] = "CANNOT_OPERATE_ON_FEED_WITH_KEY_ATTRIBUTES"] = 41;
                            values[valuesById[42] = "INVALID_PRICE_FORMAT"] = 42;
                            values[valuesById[43] = "PROMOTION_INVALID_TIME"] = 43;
                            values[valuesById[44] = "TOO_MANY_DECIMAL_PLACES_SPECIFIED"] = 44;
                            return values;
                        })();

                        return ExtensionFeedItemErrorEnum;
                    })();

                    errors.ExtensionSettingErrorEnum = (function() {

                        /**
                         * Properties of an ExtensionSettingErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IExtensionSettingErrorEnum
                         */

                        /**
                         * Constructs a new ExtensionSettingErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an ExtensionSettingErrorEnum.
                         * @implements IExtensionSettingErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IExtensionSettingErrorEnum=} [properties] Properties to set
                         */
                        function ExtensionSettingErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ExtensionSettingErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.ExtensionSettingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IExtensionSettingErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.ExtensionSettingErrorEnum} ExtensionSettingErrorEnum instance
                         */
                        ExtensionSettingErrorEnum.create = function create(properties) {
                            return new ExtensionSettingErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified ExtensionSettingErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.ExtensionSettingErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.ExtensionSettingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IExtensionSettingErrorEnum} message ExtensionSettingErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExtensionSettingErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ExtensionSettingErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.ExtensionSettingErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ExtensionSettingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IExtensionSettingErrorEnum} message ExtensionSettingErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExtensionSettingErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ExtensionSettingErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.ExtensionSettingErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.ExtensionSettingErrorEnum} ExtensionSettingErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExtensionSettingErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.ExtensionSettingErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ExtensionSettingErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ExtensionSettingErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.ExtensionSettingErrorEnum} ExtensionSettingErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExtensionSettingErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ExtensionSettingErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.ExtensionSettingErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExtensionSettingErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an ExtensionSettingErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.ExtensionSettingErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.ExtensionSettingErrorEnum} ExtensionSettingErrorEnum
                         */
                        ExtensionSettingErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.ExtensionSettingErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.ExtensionSettingErrorEnum();
                        };

                        /**
                         * Creates a plain object from an ExtensionSettingErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.ExtensionSettingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ExtensionSettingErrorEnum} message ExtensionSettingErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExtensionSettingErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ExtensionSettingErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.ExtensionSettingErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExtensionSettingErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ExtensionSettingError enum.
                         * @name google.ads.googleads.v1.errors.ExtensionSettingErrorEnum.ExtensionSettingError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} EXTENSIONS_REQUIRED=2 EXTENSIONS_REQUIRED value
                         * @property {number} FEED_TYPE_EXTENSION_TYPE_MISMATCH=3 FEED_TYPE_EXTENSION_TYPE_MISMATCH value
                         * @property {number} INVALID_FEED_TYPE=4 INVALID_FEED_TYPE value
                         * @property {number} INVALID_FEED_TYPE_FOR_CUSTOMER_EXTENSION_SETTING=5 INVALID_FEED_TYPE_FOR_CUSTOMER_EXTENSION_SETTING value
                         * @property {number} CANNOT_CHANGE_FEED_ITEM_ON_CREATE=6 CANNOT_CHANGE_FEED_ITEM_ON_CREATE value
                         * @property {number} CANNOT_UPDATE_NEWLY_CREATED_EXTENSION=7 CANNOT_UPDATE_NEWLY_CREATED_EXTENSION value
                         * @property {number} NO_EXISTING_AD_GROUP_EXTENSION_SETTING_FOR_TYPE=8 NO_EXISTING_AD_GROUP_EXTENSION_SETTING_FOR_TYPE value
                         * @property {number} NO_EXISTING_CAMPAIGN_EXTENSION_SETTING_FOR_TYPE=9 NO_EXISTING_CAMPAIGN_EXTENSION_SETTING_FOR_TYPE value
                         * @property {number} NO_EXISTING_CUSTOMER_EXTENSION_SETTING_FOR_TYPE=10 NO_EXISTING_CUSTOMER_EXTENSION_SETTING_FOR_TYPE value
                         * @property {number} AD_GROUP_EXTENSION_SETTING_ALREADY_EXISTS=11 AD_GROUP_EXTENSION_SETTING_ALREADY_EXISTS value
                         * @property {number} CAMPAIGN_EXTENSION_SETTING_ALREADY_EXISTS=12 CAMPAIGN_EXTENSION_SETTING_ALREADY_EXISTS value
                         * @property {number} CUSTOMER_EXTENSION_SETTING_ALREADY_EXISTS=13 CUSTOMER_EXTENSION_SETTING_ALREADY_EXISTS value
                         * @property {number} AD_GROUP_FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE=14 AD_GROUP_FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE value
                         * @property {number} CAMPAIGN_FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE=15 CAMPAIGN_FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE value
                         * @property {number} CUSTOMER_FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE=16 CUSTOMER_FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE value
                         * @property {number} VALUE_OUT_OF_RANGE=17 VALUE_OUT_OF_RANGE value
                         * @property {number} CANNOT_SET_FIELD_WITH_FINAL_URLS=18 CANNOT_SET_FIELD_WITH_FINAL_URLS value
                         * @property {number} FINAL_URLS_NOT_SET=19 FINAL_URLS_NOT_SET value
                         * @property {number} INVALID_PHONE_NUMBER=20 INVALID_PHONE_NUMBER value
                         * @property {number} PHONE_NUMBER_NOT_SUPPORTED_FOR_COUNTRY=21 PHONE_NUMBER_NOT_SUPPORTED_FOR_COUNTRY value
                         * @property {number} CARRIER_SPECIFIC_SHORT_NUMBER_NOT_ALLOWED=22 CARRIER_SPECIFIC_SHORT_NUMBER_NOT_ALLOWED value
                         * @property {number} PREMIUM_RATE_NUMBER_NOT_ALLOWED=23 PREMIUM_RATE_NUMBER_NOT_ALLOWED value
                         * @property {number} DISALLOWED_NUMBER_TYPE=24 DISALLOWED_NUMBER_TYPE value
                         * @property {number} INVALID_DOMESTIC_PHONE_NUMBER_FORMAT=25 INVALID_DOMESTIC_PHONE_NUMBER_FORMAT value
                         * @property {number} VANITY_PHONE_NUMBER_NOT_ALLOWED=26 VANITY_PHONE_NUMBER_NOT_ALLOWED value
                         * @property {number} INVALID_COUNTRY_CODE=27 INVALID_COUNTRY_CODE value
                         * @property {number} INVALID_CALL_CONVERSION_TYPE_ID=28 INVALID_CALL_CONVERSION_TYPE_ID value
                         * @property {number} CUSTOMER_NOT_WHITELISTED_FOR_CALLTRACKING=29 CUSTOMER_NOT_WHITELISTED_FOR_CALLTRACKING value
                         * @property {number} CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY=30 CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY value
                         * @property {number} INVALID_APP_ID=31 INVALID_APP_ID value
                         * @property {number} QUOTES_IN_REVIEW_EXTENSION_SNIPPET=32 QUOTES_IN_REVIEW_EXTENSION_SNIPPET value
                         * @property {number} HYPHENS_IN_REVIEW_EXTENSION_SNIPPET=33 HYPHENS_IN_REVIEW_EXTENSION_SNIPPET value
                         * @property {number} REVIEW_EXTENSION_SOURCE_NOT_ELIGIBLE=34 REVIEW_EXTENSION_SOURCE_NOT_ELIGIBLE value
                         * @property {number} SOURCE_NAME_IN_REVIEW_EXTENSION_TEXT=35 SOURCE_NAME_IN_REVIEW_EXTENSION_TEXT value
                         * @property {number} MISSING_FIELD=36 MISSING_FIELD value
                         * @property {number} INCONSISTENT_CURRENCY_CODES=37 INCONSISTENT_CURRENCY_CODES value
                         * @property {number} PRICE_EXTENSION_HAS_DUPLICATED_HEADERS=38 PRICE_EXTENSION_HAS_DUPLICATED_HEADERS value
                         * @property {number} PRICE_ITEM_HAS_DUPLICATED_HEADER_AND_DESCRIPTION=39 PRICE_ITEM_HAS_DUPLICATED_HEADER_AND_DESCRIPTION value
                         * @property {number} PRICE_EXTENSION_HAS_TOO_FEW_ITEMS=40 PRICE_EXTENSION_HAS_TOO_FEW_ITEMS value
                         * @property {number} PRICE_EXTENSION_HAS_TOO_MANY_ITEMS=41 PRICE_EXTENSION_HAS_TOO_MANY_ITEMS value
                         * @property {number} UNSUPPORTED_VALUE=42 UNSUPPORTED_VALUE value
                         * @property {number} INVALID_DEVICE_PREFERENCE=43 INVALID_DEVICE_PREFERENCE value
                         * @property {number} INVALID_SCHEDULE_END=45 INVALID_SCHEDULE_END value
                         * @property {number} DATE_TIME_MUST_BE_IN_ACCOUNT_TIME_ZONE=47 DATE_TIME_MUST_BE_IN_ACCOUNT_TIME_ZONE value
                         * @property {number} OVERLAPPING_SCHEDULES_NOT_ALLOWED=48 OVERLAPPING_SCHEDULES_NOT_ALLOWED value
                         * @property {number} SCHEDULE_END_NOT_AFTER_START=49 SCHEDULE_END_NOT_AFTER_START value
                         * @property {number} TOO_MANY_SCHEDULES_PER_DAY=50 TOO_MANY_SCHEDULES_PER_DAY value
                         * @property {number} DUPLICATE_EXTENSION_FEED_ITEM_EDIT=51 DUPLICATE_EXTENSION_FEED_ITEM_EDIT value
                         * @property {number} INVALID_SNIPPETS_HEADER=52 INVALID_SNIPPETS_HEADER value
                         * @property {number} PHONE_NUMBER_NOT_SUPPORTED_WITH_CALLTRACKING_FOR_COUNTRY=53 PHONE_NUMBER_NOT_SUPPORTED_WITH_CALLTRACKING_FOR_COUNTRY value
                         * @property {number} CAMPAIGN_TARGETING_MISMATCH=54 CAMPAIGN_TARGETING_MISMATCH value
                         * @property {number} CANNOT_OPERATE_ON_REMOVED_FEED=55 CANNOT_OPERATE_ON_REMOVED_FEED value
                         * @property {number} EXTENSION_TYPE_REQUIRED=56 EXTENSION_TYPE_REQUIRED value
                         * @property {number} INCOMPATIBLE_UNDERLYING_MATCHING_FUNCTION=57 INCOMPATIBLE_UNDERLYING_MATCHING_FUNCTION value
                         * @property {number} START_DATE_AFTER_END_DATE=58 START_DATE_AFTER_END_DATE value
                         * @property {number} INVALID_PRICE_FORMAT=59 INVALID_PRICE_FORMAT value
                         * @property {number} PROMOTION_INVALID_TIME=60 PROMOTION_INVALID_TIME value
                         * @property {number} PROMOTION_CANNOT_SET_PERCENT_DISCOUNT_AND_MONEY_DISCOUNT=61 PROMOTION_CANNOT_SET_PERCENT_DISCOUNT_AND_MONEY_DISCOUNT value
                         * @property {number} PROMOTION_CANNOT_SET_PROMOTION_CODE_AND_ORDERS_OVER_AMOUNT=62 PROMOTION_CANNOT_SET_PROMOTION_CODE_AND_ORDERS_OVER_AMOUNT value
                         * @property {number} TOO_MANY_DECIMAL_PLACES_SPECIFIED=63 TOO_MANY_DECIMAL_PLACES_SPECIFIED value
                         * @property {number} INVALID_LANGUAGE_CODE=64 INVALID_LANGUAGE_CODE value
                         * @property {number} UNSUPPORTED_LANGUAGE=65 UNSUPPORTED_LANGUAGE value
                         * @property {number} CUSTOMER_CONSENT_FOR_CALL_RECORDING_REQUIRED=66 CUSTOMER_CONSENT_FOR_CALL_RECORDING_REQUIRED value
                         * @property {number} EXTENSION_SETTING_UPDATE_IS_A_NOOP=67 EXTENSION_SETTING_UPDATE_IS_A_NOOP value
                         */
                        ExtensionSettingErrorEnum.ExtensionSettingError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "EXTENSIONS_REQUIRED"] = 2;
                            values[valuesById[3] = "FEED_TYPE_EXTENSION_TYPE_MISMATCH"] = 3;
                            values[valuesById[4] = "INVALID_FEED_TYPE"] = 4;
                            values[valuesById[5] = "INVALID_FEED_TYPE_FOR_CUSTOMER_EXTENSION_SETTING"] = 5;
                            values[valuesById[6] = "CANNOT_CHANGE_FEED_ITEM_ON_CREATE"] = 6;
                            values[valuesById[7] = "CANNOT_UPDATE_NEWLY_CREATED_EXTENSION"] = 7;
                            values[valuesById[8] = "NO_EXISTING_AD_GROUP_EXTENSION_SETTING_FOR_TYPE"] = 8;
                            values[valuesById[9] = "NO_EXISTING_CAMPAIGN_EXTENSION_SETTING_FOR_TYPE"] = 9;
                            values[valuesById[10] = "NO_EXISTING_CUSTOMER_EXTENSION_SETTING_FOR_TYPE"] = 10;
                            values[valuesById[11] = "AD_GROUP_EXTENSION_SETTING_ALREADY_EXISTS"] = 11;
                            values[valuesById[12] = "CAMPAIGN_EXTENSION_SETTING_ALREADY_EXISTS"] = 12;
                            values[valuesById[13] = "CUSTOMER_EXTENSION_SETTING_ALREADY_EXISTS"] = 13;
                            values[valuesById[14] = "AD_GROUP_FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE"] = 14;
                            values[valuesById[15] = "CAMPAIGN_FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE"] = 15;
                            values[valuesById[16] = "CUSTOMER_FEED_ALREADY_EXISTS_FOR_PLACEHOLDER_TYPE"] = 16;
                            values[valuesById[17] = "VALUE_OUT_OF_RANGE"] = 17;
                            values[valuesById[18] = "CANNOT_SET_FIELD_WITH_FINAL_URLS"] = 18;
                            values[valuesById[19] = "FINAL_URLS_NOT_SET"] = 19;
                            values[valuesById[20] = "INVALID_PHONE_NUMBER"] = 20;
                            values[valuesById[21] = "PHONE_NUMBER_NOT_SUPPORTED_FOR_COUNTRY"] = 21;
                            values[valuesById[22] = "CARRIER_SPECIFIC_SHORT_NUMBER_NOT_ALLOWED"] = 22;
                            values[valuesById[23] = "PREMIUM_RATE_NUMBER_NOT_ALLOWED"] = 23;
                            values[valuesById[24] = "DISALLOWED_NUMBER_TYPE"] = 24;
                            values[valuesById[25] = "INVALID_DOMESTIC_PHONE_NUMBER_FORMAT"] = 25;
                            values[valuesById[26] = "VANITY_PHONE_NUMBER_NOT_ALLOWED"] = 26;
                            values[valuesById[27] = "INVALID_COUNTRY_CODE"] = 27;
                            values[valuesById[28] = "INVALID_CALL_CONVERSION_TYPE_ID"] = 28;
                            values[valuesById[29] = "CUSTOMER_NOT_WHITELISTED_FOR_CALLTRACKING"] = 29;
                            values[valuesById[30] = "CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY"] = 30;
                            values[valuesById[31] = "INVALID_APP_ID"] = 31;
                            values[valuesById[32] = "QUOTES_IN_REVIEW_EXTENSION_SNIPPET"] = 32;
                            values[valuesById[33] = "HYPHENS_IN_REVIEW_EXTENSION_SNIPPET"] = 33;
                            values[valuesById[34] = "REVIEW_EXTENSION_SOURCE_NOT_ELIGIBLE"] = 34;
                            values[valuesById[35] = "SOURCE_NAME_IN_REVIEW_EXTENSION_TEXT"] = 35;
                            values[valuesById[36] = "MISSING_FIELD"] = 36;
                            values[valuesById[37] = "INCONSISTENT_CURRENCY_CODES"] = 37;
                            values[valuesById[38] = "PRICE_EXTENSION_HAS_DUPLICATED_HEADERS"] = 38;
                            values[valuesById[39] = "PRICE_ITEM_HAS_DUPLICATED_HEADER_AND_DESCRIPTION"] = 39;
                            values[valuesById[40] = "PRICE_EXTENSION_HAS_TOO_FEW_ITEMS"] = 40;
                            values[valuesById[41] = "PRICE_EXTENSION_HAS_TOO_MANY_ITEMS"] = 41;
                            values[valuesById[42] = "UNSUPPORTED_VALUE"] = 42;
                            values[valuesById[43] = "INVALID_DEVICE_PREFERENCE"] = 43;
                            values[valuesById[45] = "INVALID_SCHEDULE_END"] = 45;
                            values[valuesById[47] = "DATE_TIME_MUST_BE_IN_ACCOUNT_TIME_ZONE"] = 47;
                            values[valuesById[48] = "OVERLAPPING_SCHEDULES_NOT_ALLOWED"] = 48;
                            values[valuesById[49] = "SCHEDULE_END_NOT_AFTER_START"] = 49;
                            values[valuesById[50] = "TOO_MANY_SCHEDULES_PER_DAY"] = 50;
                            values[valuesById[51] = "DUPLICATE_EXTENSION_FEED_ITEM_EDIT"] = 51;
                            values[valuesById[52] = "INVALID_SNIPPETS_HEADER"] = 52;
                            values[valuesById[53] = "PHONE_NUMBER_NOT_SUPPORTED_WITH_CALLTRACKING_FOR_COUNTRY"] = 53;
                            values[valuesById[54] = "CAMPAIGN_TARGETING_MISMATCH"] = 54;
                            values[valuesById[55] = "CANNOT_OPERATE_ON_REMOVED_FEED"] = 55;
                            values[valuesById[56] = "EXTENSION_TYPE_REQUIRED"] = 56;
                            values[valuesById[57] = "INCOMPATIBLE_UNDERLYING_MATCHING_FUNCTION"] = 57;
                            values[valuesById[58] = "START_DATE_AFTER_END_DATE"] = 58;
                            values[valuesById[59] = "INVALID_PRICE_FORMAT"] = 59;
                            values[valuesById[60] = "PROMOTION_INVALID_TIME"] = 60;
                            values[valuesById[61] = "PROMOTION_CANNOT_SET_PERCENT_DISCOUNT_AND_MONEY_DISCOUNT"] = 61;
                            values[valuesById[62] = "PROMOTION_CANNOT_SET_PROMOTION_CODE_AND_ORDERS_OVER_AMOUNT"] = 62;
                            values[valuesById[63] = "TOO_MANY_DECIMAL_PLACES_SPECIFIED"] = 63;
                            values[valuesById[64] = "INVALID_LANGUAGE_CODE"] = 64;
                            values[valuesById[65] = "UNSUPPORTED_LANGUAGE"] = 65;
                            values[valuesById[66] = "CUSTOMER_CONSENT_FOR_CALL_RECORDING_REQUIRED"] = 66;
                            values[valuesById[67] = "EXTENSION_SETTING_UPDATE_IS_A_NOOP"] = 67;
                            return values;
                        })();

                        return ExtensionSettingErrorEnum;
                    })();

                    errors.FeedAttributeReferenceErrorEnum = (function() {

                        /**
                         * Properties of a FeedAttributeReferenceErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IFeedAttributeReferenceErrorEnum
                         */

                        /**
                         * Constructs a new FeedAttributeReferenceErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a FeedAttributeReferenceErrorEnum.
                         * @implements IFeedAttributeReferenceErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IFeedAttributeReferenceErrorEnum=} [properties] Properties to set
                         */
                        function FeedAttributeReferenceErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FeedAttributeReferenceErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFeedAttributeReferenceErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum} FeedAttributeReferenceErrorEnum instance
                         */
                        FeedAttributeReferenceErrorEnum.create = function create(properties) {
                            return new FeedAttributeReferenceErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified FeedAttributeReferenceErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFeedAttributeReferenceErrorEnum} message FeedAttributeReferenceErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedAttributeReferenceErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedAttributeReferenceErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFeedAttributeReferenceErrorEnum} message FeedAttributeReferenceErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedAttributeReferenceErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedAttributeReferenceErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum} FeedAttributeReferenceErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedAttributeReferenceErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedAttributeReferenceErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum} FeedAttributeReferenceErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedAttributeReferenceErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedAttributeReferenceErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedAttributeReferenceErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FeedAttributeReferenceErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum} FeedAttributeReferenceErrorEnum
                         */
                        FeedAttributeReferenceErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum();
                        };

                        /**
                         * Creates a plain object from a FeedAttributeReferenceErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum} message FeedAttributeReferenceErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedAttributeReferenceErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FeedAttributeReferenceErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedAttributeReferenceErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FeedAttributeReferenceError enum.
                         * @name google.ads.googleads.v1.errors.FeedAttributeReferenceErrorEnum.FeedAttributeReferenceError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CANNOT_REFERENCE_REMOVED_FEED=2 CANNOT_REFERENCE_REMOVED_FEED value
                         * @property {number} INVALID_FEED_NAME=3 INVALID_FEED_NAME value
                         * @property {number} INVALID_FEED_ATTRIBUTE_NAME=4 INVALID_FEED_ATTRIBUTE_NAME value
                         */
                        FeedAttributeReferenceErrorEnum.FeedAttributeReferenceError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CANNOT_REFERENCE_REMOVED_FEED"] = 2;
                            values[valuesById[3] = "INVALID_FEED_NAME"] = 3;
                            values[valuesById[4] = "INVALID_FEED_ATTRIBUTE_NAME"] = 4;
                            return values;
                        })();

                        return FeedAttributeReferenceErrorEnum;
                    })();

                    errors.FeedErrorEnum = (function() {

                        /**
                         * Properties of a FeedErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IFeedErrorEnum
                         */

                        /**
                         * Constructs a new FeedErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a FeedErrorEnum.
                         * @implements IFeedErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IFeedErrorEnum=} [properties] Properties to set
                         */
                        function FeedErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FeedErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.FeedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFeedErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.FeedErrorEnum} FeedErrorEnum instance
                         */
                        FeedErrorEnum.create = function create(properties) {
                            return new FeedErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified FeedErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.FeedErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.FeedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFeedErrorEnum} message FeedErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.FeedErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FeedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFeedErrorEnum} message FeedErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.FeedErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.FeedErrorEnum} FeedErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.FeedErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FeedErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.FeedErrorEnum} FeedErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.FeedErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FeedErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.FeedErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.FeedErrorEnum} FeedErrorEnum
                         */
                        FeedErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.FeedErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.FeedErrorEnum();
                        };

                        /**
                         * Creates a plain object from a FeedErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.FeedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.FeedErrorEnum} message FeedErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FeedErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.FeedErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FeedError enum.
                         * @name google.ads.googleads.v1.errors.FeedErrorEnum.FeedError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ATTRIBUTE_NAMES_NOT_UNIQUE=2 ATTRIBUTE_NAMES_NOT_UNIQUE value
                         * @property {number} ATTRIBUTES_DO_NOT_MATCH_EXISTING_ATTRIBUTES=3 ATTRIBUTES_DO_NOT_MATCH_EXISTING_ATTRIBUTES value
                         * @property {number} CANNOT_SPECIFY_USER_ORIGIN_FOR_SYSTEM_FEED=4 CANNOT_SPECIFY_USER_ORIGIN_FOR_SYSTEM_FEED value
                         * @property {number} CANNOT_SPECIFY_GOOGLE_ORIGIN_FOR_NON_SYSTEM_FEED=5 CANNOT_SPECIFY_GOOGLE_ORIGIN_FOR_NON_SYSTEM_FEED value
                         * @property {number} CANNOT_SPECIFY_FEED_ATTRIBUTES_FOR_SYSTEM_FEED=6 CANNOT_SPECIFY_FEED_ATTRIBUTES_FOR_SYSTEM_FEED value
                         * @property {number} CANNOT_UPDATE_FEED_ATTRIBUTES_WITH_ORIGIN_GOOGLE=7 CANNOT_UPDATE_FEED_ATTRIBUTES_WITH_ORIGIN_GOOGLE value
                         * @property {number} FEED_REMOVED=8 FEED_REMOVED value
                         * @property {number} INVALID_ORIGIN_VALUE=9 INVALID_ORIGIN_VALUE value
                         * @property {number} FEED_ORIGIN_IS_NOT_USER=10 FEED_ORIGIN_IS_NOT_USER value
                         * @property {number} INVALID_AUTH_TOKEN_FOR_EMAIL=11 INVALID_AUTH_TOKEN_FOR_EMAIL value
                         * @property {number} INVALID_EMAIL=12 INVALID_EMAIL value
                         * @property {number} DUPLICATE_FEED_NAME=13 DUPLICATE_FEED_NAME value
                         * @property {number} INVALID_FEED_NAME=14 INVALID_FEED_NAME value
                         * @property {number} MISSING_OAUTH_INFO=15 MISSING_OAUTH_INFO value
                         * @property {number} NEW_ATTRIBUTE_CANNOT_BE_PART_OF_UNIQUE_KEY=16 NEW_ATTRIBUTE_CANNOT_BE_PART_OF_UNIQUE_KEY value
                         * @property {number} TOO_MANY_ATTRIBUTES=17 TOO_MANY_ATTRIBUTES value
                         * @property {number} INVALID_BUSINESS_ACCOUNT=18 INVALID_BUSINESS_ACCOUNT value
                         * @property {number} BUSINESS_ACCOUNT_CANNOT_ACCESS_LOCATION_ACCOUNT=19 BUSINESS_ACCOUNT_CANNOT_ACCESS_LOCATION_ACCOUNT value
                         * @property {number} INVALID_AFFILIATE_CHAIN_ID=20 INVALID_AFFILIATE_CHAIN_ID value
                         */
                        FeedErrorEnum.FeedError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ATTRIBUTE_NAMES_NOT_UNIQUE"] = 2;
                            values[valuesById[3] = "ATTRIBUTES_DO_NOT_MATCH_EXISTING_ATTRIBUTES"] = 3;
                            values[valuesById[4] = "CANNOT_SPECIFY_USER_ORIGIN_FOR_SYSTEM_FEED"] = 4;
                            values[valuesById[5] = "CANNOT_SPECIFY_GOOGLE_ORIGIN_FOR_NON_SYSTEM_FEED"] = 5;
                            values[valuesById[6] = "CANNOT_SPECIFY_FEED_ATTRIBUTES_FOR_SYSTEM_FEED"] = 6;
                            values[valuesById[7] = "CANNOT_UPDATE_FEED_ATTRIBUTES_WITH_ORIGIN_GOOGLE"] = 7;
                            values[valuesById[8] = "FEED_REMOVED"] = 8;
                            values[valuesById[9] = "INVALID_ORIGIN_VALUE"] = 9;
                            values[valuesById[10] = "FEED_ORIGIN_IS_NOT_USER"] = 10;
                            values[valuesById[11] = "INVALID_AUTH_TOKEN_FOR_EMAIL"] = 11;
                            values[valuesById[12] = "INVALID_EMAIL"] = 12;
                            values[valuesById[13] = "DUPLICATE_FEED_NAME"] = 13;
                            values[valuesById[14] = "INVALID_FEED_NAME"] = 14;
                            values[valuesById[15] = "MISSING_OAUTH_INFO"] = 15;
                            values[valuesById[16] = "NEW_ATTRIBUTE_CANNOT_BE_PART_OF_UNIQUE_KEY"] = 16;
                            values[valuesById[17] = "TOO_MANY_ATTRIBUTES"] = 17;
                            values[valuesById[18] = "INVALID_BUSINESS_ACCOUNT"] = 18;
                            values[valuesById[19] = "BUSINESS_ACCOUNT_CANNOT_ACCESS_LOCATION_ACCOUNT"] = 19;
                            values[valuesById[20] = "INVALID_AFFILIATE_CHAIN_ID"] = 20;
                            return values;
                        })();

                        return FeedErrorEnum;
                    })();

                    errors.FeedItemErrorEnum = (function() {

                        /**
                         * Properties of a FeedItemErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IFeedItemErrorEnum
                         */

                        /**
                         * Constructs a new FeedItemErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a FeedItemErrorEnum.
                         * @implements IFeedItemErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IFeedItemErrorEnum=} [properties] Properties to set
                         */
                        function FeedItemErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FeedItemErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.FeedItemErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFeedItemErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.FeedItemErrorEnum} FeedItemErrorEnum instance
                         */
                        FeedItemErrorEnum.create = function create(properties) {
                            return new FeedItemErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified FeedItemErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.FeedItemErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.FeedItemErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFeedItemErrorEnum} message FeedItemErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedItemErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.FeedItemErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FeedItemErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFeedItemErrorEnum} message FeedItemErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedItemErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.FeedItemErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.FeedItemErrorEnum} FeedItemErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.FeedItemErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedItemErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FeedItemErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.FeedItemErrorEnum} FeedItemErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedItemErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.FeedItemErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedItemErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FeedItemErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.FeedItemErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.FeedItemErrorEnum} FeedItemErrorEnum
                         */
                        FeedItemErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.FeedItemErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.FeedItemErrorEnum();
                        };

                        /**
                         * Creates a plain object from a FeedItemErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.FeedItemErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.FeedItemErrorEnum} message FeedItemErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedItemErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FeedItemErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.FeedItemErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedItemErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FeedItemError enum.
                         * @name google.ads.googleads.v1.errors.FeedItemErrorEnum.FeedItemError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CANNOT_CONVERT_ATTRIBUTE_VALUE_FROM_STRING=2 CANNOT_CONVERT_ATTRIBUTE_VALUE_FROM_STRING value
                         * @property {number} CANNOT_OPERATE_ON_REMOVED_FEED_ITEM=3 CANNOT_OPERATE_ON_REMOVED_FEED_ITEM value
                         * @property {number} DATE_TIME_MUST_BE_IN_ACCOUNT_TIME_ZONE=4 DATE_TIME_MUST_BE_IN_ACCOUNT_TIME_ZONE value
                         * @property {number} KEY_ATTRIBUTES_NOT_FOUND=5 KEY_ATTRIBUTES_NOT_FOUND value
                         * @property {number} INVALID_URL=6 INVALID_URL value
                         * @property {number} MISSING_KEY_ATTRIBUTES=7 MISSING_KEY_ATTRIBUTES value
                         * @property {number} KEY_ATTRIBUTES_NOT_UNIQUE=8 KEY_ATTRIBUTES_NOT_UNIQUE value
                         * @property {number} CANNOT_MODIFY_KEY_ATTRIBUTE_VALUE=9 CANNOT_MODIFY_KEY_ATTRIBUTE_VALUE value
                         * @property {number} SIZE_TOO_LARGE_FOR_MULTI_VALUE_ATTRIBUTE=10 SIZE_TOO_LARGE_FOR_MULTI_VALUE_ATTRIBUTE value
                         */
                        FeedItemErrorEnum.FeedItemError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CANNOT_CONVERT_ATTRIBUTE_VALUE_FROM_STRING"] = 2;
                            values[valuesById[3] = "CANNOT_OPERATE_ON_REMOVED_FEED_ITEM"] = 3;
                            values[valuesById[4] = "DATE_TIME_MUST_BE_IN_ACCOUNT_TIME_ZONE"] = 4;
                            values[valuesById[5] = "KEY_ATTRIBUTES_NOT_FOUND"] = 5;
                            values[valuesById[6] = "INVALID_URL"] = 6;
                            values[valuesById[7] = "MISSING_KEY_ATTRIBUTES"] = 7;
                            values[valuesById[8] = "KEY_ATTRIBUTES_NOT_UNIQUE"] = 8;
                            values[valuesById[9] = "CANNOT_MODIFY_KEY_ATTRIBUTE_VALUE"] = 9;
                            values[valuesById[10] = "SIZE_TOO_LARGE_FOR_MULTI_VALUE_ATTRIBUTE"] = 10;
                            return values;
                        })();

                        return FeedItemErrorEnum;
                    })();

                    errors.FeedItemTargetErrorEnum = (function() {

                        /**
                         * Properties of a FeedItemTargetErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IFeedItemTargetErrorEnum
                         */

                        /**
                         * Constructs a new FeedItemTargetErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a FeedItemTargetErrorEnum.
                         * @implements IFeedItemTargetErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IFeedItemTargetErrorEnum=} [properties] Properties to set
                         */
                        function FeedItemTargetErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FeedItemTargetErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.FeedItemTargetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFeedItemTargetErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.FeedItemTargetErrorEnum} FeedItemTargetErrorEnum instance
                         */
                        FeedItemTargetErrorEnum.create = function create(properties) {
                            return new FeedItemTargetErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified FeedItemTargetErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.FeedItemTargetErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.FeedItemTargetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFeedItemTargetErrorEnum} message FeedItemTargetErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemTargetErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedItemTargetErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.FeedItemTargetErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FeedItemTargetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFeedItemTargetErrorEnum} message FeedItemTargetErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemTargetErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedItemTargetErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.FeedItemTargetErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.FeedItemTargetErrorEnum} FeedItemTargetErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemTargetErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.FeedItemTargetErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedItemTargetErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FeedItemTargetErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.FeedItemTargetErrorEnum} FeedItemTargetErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemTargetErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedItemTargetErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.FeedItemTargetErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedItemTargetErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FeedItemTargetErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.FeedItemTargetErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.FeedItemTargetErrorEnum} FeedItemTargetErrorEnum
                         */
                        FeedItemTargetErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.FeedItemTargetErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.FeedItemTargetErrorEnum();
                        };

                        /**
                         * Creates a plain object from a FeedItemTargetErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.FeedItemTargetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.FeedItemTargetErrorEnum} message FeedItemTargetErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedItemTargetErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FeedItemTargetErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.FeedItemTargetErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedItemTargetErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FeedItemTargetError enum.
                         * @name google.ads.googleads.v1.errors.FeedItemTargetErrorEnum.FeedItemTargetError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} MUST_SET_TARGET_ONEOF_ON_CREATE=2 MUST_SET_TARGET_ONEOF_ON_CREATE value
                         * @property {number} FEED_ITEM_TARGET_ALREADY_EXISTS=3 FEED_ITEM_TARGET_ALREADY_EXISTS value
                         * @property {number} FEED_ITEM_SCHEDULES_CANNOT_OVERLAP=4 FEED_ITEM_SCHEDULES_CANNOT_OVERLAP value
                         * @property {number} TARGET_LIMIT_EXCEEDED_FOR_GIVEN_TYPE=5 TARGET_LIMIT_EXCEEDED_FOR_GIVEN_TYPE value
                         * @property {number} TOO_MANY_SCHEDULES_PER_DAY=6 TOO_MANY_SCHEDULES_PER_DAY value
                         * @property {number} CANNOT_HAVE_ENABLED_CAMPAIGN_AND_ENABLED_AD_GROUP_TARGETS=7 CANNOT_HAVE_ENABLED_CAMPAIGN_AND_ENABLED_AD_GROUP_TARGETS value
                         */
                        FeedItemTargetErrorEnum.FeedItemTargetError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "MUST_SET_TARGET_ONEOF_ON_CREATE"] = 2;
                            values[valuesById[3] = "FEED_ITEM_TARGET_ALREADY_EXISTS"] = 3;
                            values[valuesById[4] = "FEED_ITEM_SCHEDULES_CANNOT_OVERLAP"] = 4;
                            values[valuesById[5] = "TARGET_LIMIT_EXCEEDED_FOR_GIVEN_TYPE"] = 5;
                            values[valuesById[6] = "TOO_MANY_SCHEDULES_PER_DAY"] = 6;
                            values[valuesById[7] = "CANNOT_HAVE_ENABLED_CAMPAIGN_AND_ENABLED_AD_GROUP_TARGETS"] = 7;
                            return values;
                        })();

                        return FeedItemTargetErrorEnum;
                    })();

                    errors.FeedItemValidationErrorEnum = (function() {

                        /**
                         * Properties of a FeedItemValidationErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IFeedItemValidationErrorEnum
                         */

                        /**
                         * Constructs a new FeedItemValidationErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a FeedItemValidationErrorEnum.
                         * @implements IFeedItemValidationErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IFeedItemValidationErrorEnum=} [properties] Properties to set
                         */
                        function FeedItemValidationErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FeedItemValidationErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.FeedItemValidationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFeedItemValidationErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.FeedItemValidationErrorEnum} FeedItemValidationErrorEnum instance
                         */
                        FeedItemValidationErrorEnum.create = function create(properties) {
                            return new FeedItemValidationErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified FeedItemValidationErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.FeedItemValidationErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.FeedItemValidationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFeedItemValidationErrorEnum} message FeedItemValidationErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemValidationErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedItemValidationErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.FeedItemValidationErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FeedItemValidationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFeedItemValidationErrorEnum} message FeedItemValidationErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemValidationErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedItemValidationErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.FeedItemValidationErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.FeedItemValidationErrorEnum} FeedItemValidationErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemValidationErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.FeedItemValidationErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedItemValidationErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FeedItemValidationErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.FeedItemValidationErrorEnum} FeedItemValidationErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemValidationErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedItemValidationErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.FeedItemValidationErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedItemValidationErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FeedItemValidationErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.FeedItemValidationErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.FeedItemValidationErrorEnum} FeedItemValidationErrorEnum
                         */
                        FeedItemValidationErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.FeedItemValidationErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.FeedItemValidationErrorEnum();
                        };

                        /**
                         * Creates a plain object from a FeedItemValidationErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.FeedItemValidationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.FeedItemValidationErrorEnum} message FeedItemValidationErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedItemValidationErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FeedItemValidationErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.FeedItemValidationErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedItemValidationErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FeedItemValidationError enum.
                         * @name google.ads.googleads.v1.errors.FeedItemValidationErrorEnum.FeedItemValidationError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} STRING_TOO_SHORT=2 STRING_TOO_SHORT value
                         * @property {number} STRING_TOO_LONG=3 STRING_TOO_LONG value
                         * @property {number} VALUE_NOT_SPECIFIED=4 VALUE_NOT_SPECIFIED value
                         * @property {number} INVALID_DOMESTIC_PHONE_NUMBER_FORMAT=5 INVALID_DOMESTIC_PHONE_NUMBER_FORMAT value
                         * @property {number} INVALID_PHONE_NUMBER=6 INVALID_PHONE_NUMBER value
                         * @property {number} PHONE_NUMBER_NOT_SUPPORTED_FOR_COUNTRY=7 PHONE_NUMBER_NOT_SUPPORTED_FOR_COUNTRY value
                         * @property {number} PREMIUM_RATE_NUMBER_NOT_ALLOWED=8 PREMIUM_RATE_NUMBER_NOT_ALLOWED value
                         * @property {number} DISALLOWED_NUMBER_TYPE=9 DISALLOWED_NUMBER_TYPE value
                         * @property {number} VALUE_OUT_OF_RANGE=10 VALUE_OUT_OF_RANGE value
                         * @property {number} CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY=11 CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY value
                         * @property {number} CUSTOMER_NOT_WHITELISTED_FOR_CALLTRACKING=12 CUSTOMER_NOT_WHITELISTED_FOR_CALLTRACKING value
                         * @property {number} INVALID_COUNTRY_CODE=13 INVALID_COUNTRY_CODE value
                         * @property {number} INVALID_APP_ID=14 INVALID_APP_ID value
                         * @property {number} MISSING_ATTRIBUTES_FOR_FIELDS=15 MISSING_ATTRIBUTES_FOR_FIELDS value
                         * @property {number} INVALID_TYPE_ID=16 INVALID_TYPE_ID value
                         * @property {number} INVALID_EMAIL_ADDRESS=17 INVALID_EMAIL_ADDRESS value
                         * @property {number} INVALID_HTTPS_URL=18 INVALID_HTTPS_URL value
                         * @property {number} MISSING_DELIVERY_ADDRESS=19 MISSING_DELIVERY_ADDRESS value
                         * @property {number} START_DATE_AFTER_END_DATE=20 START_DATE_AFTER_END_DATE value
                         * @property {number} MISSING_FEED_ITEM_START_TIME=21 MISSING_FEED_ITEM_START_TIME value
                         * @property {number} MISSING_FEED_ITEM_END_TIME=22 MISSING_FEED_ITEM_END_TIME value
                         * @property {number} MISSING_FEED_ITEM_ID=23 MISSING_FEED_ITEM_ID value
                         * @property {number} VANITY_PHONE_NUMBER_NOT_ALLOWED=24 VANITY_PHONE_NUMBER_NOT_ALLOWED value
                         * @property {number} INVALID_REVIEW_EXTENSION_SNIPPET=25 INVALID_REVIEW_EXTENSION_SNIPPET value
                         * @property {number} INVALID_NUMBER_FORMAT=26 INVALID_NUMBER_FORMAT value
                         * @property {number} INVALID_DATE_FORMAT=27 INVALID_DATE_FORMAT value
                         * @property {number} INVALID_PRICE_FORMAT=28 INVALID_PRICE_FORMAT value
                         * @property {number} UNKNOWN_PLACEHOLDER_FIELD=29 UNKNOWN_PLACEHOLDER_FIELD value
                         * @property {number} MISSING_ENHANCED_SITELINK_DESCRIPTION_LINE=30 MISSING_ENHANCED_SITELINK_DESCRIPTION_LINE value
                         * @property {number} REVIEW_EXTENSION_SOURCE_INELIGIBLE=31 REVIEW_EXTENSION_SOURCE_INELIGIBLE value
                         * @property {number} HYPHENS_IN_REVIEW_EXTENSION_SNIPPET=32 HYPHENS_IN_REVIEW_EXTENSION_SNIPPET value
                         * @property {number} DOUBLE_QUOTES_IN_REVIEW_EXTENSION_SNIPPET=33 DOUBLE_QUOTES_IN_REVIEW_EXTENSION_SNIPPET value
                         * @property {number} QUOTES_IN_REVIEW_EXTENSION_SNIPPET=34 QUOTES_IN_REVIEW_EXTENSION_SNIPPET value
                         * @property {number} INVALID_FORM_ENCODED_PARAMS=35 INVALID_FORM_ENCODED_PARAMS value
                         * @property {number} INVALID_URL_PARAMETER_NAME=36 INVALID_URL_PARAMETER_NAME value
                         * @property {number} NO_GEOCODING_RESULT=37 NO_GEOCODING_RESULT value
                         * @property {number} SOURCE_NAME_IN_REVIEW_EXTENSION_TEXT=38 SOURCE_NAME_IN_REVIEW_EXTENSION_TEXT value
                         * @property {number} CARRIER_SPECIFIC_SHORT_NUMBER_NOT_ALLOWED=39 CARRIER_SPECIFIC_SHORT_NUMBER_NOT_ALLOWED value
                         * @property {number} INVALID_PLACEHOLDER_FIELD_ID=40 INVALID_PLACEHOLDER_FIELD_ID value
                         * @property {number} INVALID_URL_TAG=41 INVALID_URL_TAG value
                         * @property {number} LIST_TOO_LONG=42 LIST_TOO_LONG value
                         * @property {number} INVALID_ATTRIBUTES_COMBINATION=43 INVALID_ATTRIBUTES_COMBINATION value
                         * @property {number} DUPLICATE_VALUES=44 DUPLICATE_VALUES value
                         * @property {number} INVALID_CALL_CONVERSION_ACTION_ID=45 INVALID_CALL_CONVERSION_ACTION_ID value
                         * @property {number} CANNOT_SET_WITHOUT_FINAL_URLS=46 CANNOT_SET_WITHOUT_FINAL_URLS value
                         * @property {number} APP_ID_DOESNT_EXIST_IN_APP_STORE=47 APP_ID_DOESNT_EXIST_IN_APP_STORE value
                         * @property {number} INVALID_FINAL_URL=48 INVALID_FINAL_URL value
                         * @property {number} INVALID_TRACKING_URL=49 INVALID_TRACKING_URL value
                         * @property {number} INVALID_FINAL_URL_FOR_APP_DOWNLOAD_URL=50 INVALID_FINAL_URL_FOR_APP_DOWNLOAD_URL value
                         * @property {number} LIST_TOO_SHORT=51 LIST_TOO_SHORT value
                         * @property {number} INVALID_USER_ACTION=52 INVALID_USER_ACTION value
                         * @property {number} INVALID_TYPE_NAME=53 INVALID_TYPE_NAME value
                         * @property {number} INVALID_EVENT_CHANGE_STATUS=54 INVALID_EVENT_CHANGE_STATUS value
                         * @property {number} INVALID_SNIPPETS_HEADER=55 INVALID_SNIPPETS_HEADER value
                         * @property {number} INVALID_ANDROID_APP_LINK=56 INVALID_ANDROID_APP_LINK value
                         * @property {number} NUMBER_TYPE_WITH_CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY=57 NUMBER_TYPE_WITH_CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY value
                         * @property {number} RESERVED_KEYWORD_OTHER=58 RESERVED_KEYWORD_OTHER value
                         * @property {number} DUPLICATE_OPTION_LABELS=59 DUPLICATE_OPTION_LABELS value
                         * @property {number} DUPLICATE_OPTION_PREFILLS=60 DUPLICATE_OPTION_PREFILLS value
                         * @property {number} UNEQUAL_LIST_LENGTHS=61 UNEQUAL_LIST_LENGTHS value
                         * @property {number} INCONSISTENT_CURRENCY_CODES=62 INCONSISTENT_CURRENCY_CODES value
                         * @property {number} PRICE_EXTENSION_HAS_DUPLICATED_HEADERS=63 PRICE_EXTENSION_HAS_DUPLICATED_HEADERS value
                         * @property {number} ITEM_HAS_DUPLICATED_HEADER_AND_DESCRIPTION=64 ITEM_HAS_DUPLICATED_HEADER_AND_DESCRIPTION value
                         * @property {number} PRICE_EXTENSION_HAS_TOO_FEW_ITEMS=65 PRICE_EXTENSION_HAS_TOO_FEW_ITEMS value
                         * @property {number} UNSUPPORTED_VALUE=66 UNSUPPORTED_VALUE value
                         * @property {number} INVALID_FINAL_MOBILE_URL=67 INVALID_FINAL_MOBILE_URL value
                         * @property {number} INVALID_KEYWORDLESS_AD_RULE_LABEL=68 INVALID_KEYWORDLESS_AD_RULE_LABEL value
                         * @property {number} VALUE_TRACK_PARAMETER_NOT_SUPPORTED=69 VALUE_TRACK_PARAMETER_NOT_SUPPORTED value
                         * @property {number} UNSUPPORTED_VALUE_IN_SELECTED_LANGUAGE=70 UNSUPPORTED_VALUE_IN_SELECTED_LANGUAGE value
                         * @property {number} INVALID_IOS_APP_LINK=71 INVALID_IOS_APP_LINK value
                         * @property {number} MISSING_IOS_APP_LINK_OR_IOS_APP_STORE_ID=72 MISSING_IOS_APP_LINK_OR_IOS_APP_STORE_ID value
                         * @property {number} PROMOTION_INVALID_TIME=73 PROMOTION_INVALID_TIME value
                         * @property {number} PROMOTION_CANNOT_SET_PERCENT_OFF_AND_MONEY_AMOUNT_OFF=74 PROMOTION_CANNOT_SET_PERCENT_OFF_AND_MONEY_AMOUNT_OFF value
                         * @property {number} PROMOTION_CANNOT_SET_PROMOTION_CODE_AND_ORDERS_OVER_AMOUNT=75 PROMOTION_CANNOT_SET_PROMOTION_CODE_AND_ORDERS_OVER_AMOUNT value
                         * @property {number} TOO_MANY_DECIMAL_PLACES_SPECIFIED=76 TOO_MANY_DECIMAL_PLACES_SPECIFIED value
                         * @property {number} AD_CUSTOMIZERS_NOT_ALLOWED=77 AD_CUSTOMIZERS_NOT_ALLOWED value
                         * @property {number} INVALID_LANGUAGE_CODE=78 INVALID_LANGUAGE_CODE value
                         * @property {number} UNSUPPORTED_LANGUAGE=79 UNSUPPORTED_LANGUAGE value
                         * @property {number} IF_FUNCTION_NOT_ALLOWED=80 IF_FUNCTION_NOT_ALLOWED value
                         * @property {number} INVALID_FINAL_URL_SUFFIX=81 INVALID_FINAL_URL_SUFFIX value
                         * @property {number} INVALID_TAG_IN_FINAL_URL_SUFFIX=82 INVALID_TAG_IN_FINAL_URL_SUFFIX value
                         * @property {number} INVALID_FINAL_URL_SUFFIX_FORMAT=83 INVALID_FINAL_URL_SUFFIX_FORMAT value
                         * @property {number} CUSTOMER_CONSENT_FOR_CALL_RECORDING_REQUIRED=84 CUSTOMER_CONSENT_FOR_CALL_RECORDING_REQUIRED value
                         * @property {number} ONLY_ONE_DELIVERY_OPTION_IS_ALLOWED=85 ONLY_ONE_DELIVERY_OPTION_IS_ALLOWED value
                         * @property {number} NO_DELIVERY_OPTION_IS_SET=86 NO_DELIVERY_OPTION_IS_SET value
                         * @property {number} INVALID_CONVERSION_REPORTING_STATE=87 INVALID_CONVERSION_REPORTING_STATE value
                         * @property {number} IMAGE_SIZE_WRONG=88 IMAGE_SIZE_WRONG value
                         * @property {number} EMAIL_DELIVERY_NOT_AVAILABLE_IN_COUNTRY=89 EMAIL_DELIVERY_NOT_AVAILABLE_IN_COUNTRY value
                         * @property {number} AUTO_REPLY_NOT_AVAILABLE_IN_COUNTRY=90 AUTO_REPLY_NOT_AVAILABLE_IN_COUNTRY value
                         * @property {number} INVALID_LATITUDE_VALUE=91 INVALID_LATITUDE_VALUE value
                         * @property {number} INVALID_LONGITUDE_VALUE=92 INVALID_LONGITUDE_VALUE value
                         * @property {number} TOO_MANY_LABELS=93 TOO_MANY_LABELS value
                         * @property {number} INVALID_IMAGE_URL=94 INVALID_IMAGE_URL value
                         * @property {number} MISSING_LATITUDE_VALUE=95 MISSING_LATITUDE_VALUE value
                         * @property {number} MISSING_LONGITUDE_VALUE=96 MISSING_LONGITUDE_VALUE value
                         */
                        FeedItemValidationErrorEnum.FeedItemValidationError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "STRING_TOO_SHORT"] = 2;
                            values[valuesById[3] = "STRING_TOO_LONG"] = 3;
                            values[valuesById[4] = "VALUE_NOT_SPECIFIED"] = 4;
                            values[valuesById[5] = "INVALID_DOMESTIC_PHONE_NUMBER_FORMAT"] = 5;
                            values[valuesById[6] = "INVALID_PHONE_NUMBER"] = 6;
                            values[valuesById[7] = "PHONE_NUMBER_NOT_SUPPORTED_FOR_COUNTRY"] = 7;
                            values[valuesById[8] = "PREMIUM_RATE_NUMBER_NOT_ALLOWED"] = 8;
                            values[valuesById[9] = "DISALLOWED_NUMBER_TYPE"] = 9;
                            values[valuesById[10] = "VALUE_OUT_OF_RANGE"] = 10;
                            values[valuesById[11] = "CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY"] = 11;
                            values[valuesById[12] = "CUSTOMER_NOT_WHITELISTED_FOR_CALLTRACKING"] = 12;
                            values[valuesById[13] = "INVALID_COUNTRY_CODE"] = 13;
                            values[valuesById[14] = "INVALID_APP_ID"] = 14;
                            values[valuesById[15] = "MISSING_ATTRIBUTES_FOR_FIELDS"] = 15;
                            values[valuesById[16] = "INVALID_TYPE_ID"] = 16;
                            values[valuesById[17] = "INVALID_EMAIL_ADDRESS"] = 17;
                            values[valuesById[18] = "INVALID_HTTPS_URL"] = 18;
                            values[valuesById[19] = "MISSING_DELIVERY_ADDRESS"] = 19;
                            values[valuesById[20] = "START_DATE_AFTER_END_DATE"] = 20;
                            values[valuesById[21] = "MISSING_FEED_ITEM_START_TIME"] = 21;
                            values[valuesById[22] = "MISSING_FEED_ITEM_END_TIME"] = 22;
                            values[valuesById[23] = "MISSING_FEED_ITEM_ID"] = 23;
                            values[valuesById[24] = "VANITY_PHONE_NUMBER_NOT_ALLOWED"] = 24;
                            values[valuesById[25] = "INVALID_REVIEW_EXTENSION_SNIPPET"] = 25;
                            values[valuesById[26] = "INVALID_NUMBER_FORMAT"] = 26;
                            values[valuesById[27] = "INVALID_DATE_FORMAT"] = 27;
                            values[valuesById[28] = "INVALID_PRICE_FORMAT"] = 28;
                            values[valuesById[29] = "UNKNOWN_PLACEHOLDER_FIELD"] = 29;
                            values[valuesById[30] = "MISSING_ENHANCED_SITELINK_DESCRIPTION_LINE"] = 30;
                            values[valuesById[31] = "REVIEW_EXTENSION_SOURCE_INELIGIBLE"] = 31;
                            values[valuesById[32] = "HYPHENS_IN_REVIEW_EXTENSION_SNIPPET"] = 32;
                            values[valuesById[33] = "DOUBLE_QUOTES_IN_REVIEW_EXTENSION_SNIPPET"] = 33;
                            values[valuesById[34] = "QUOTES_IN_REVIEW_EXTENSION_SNIPPET"] = 34;
                            values[valuesById[35] = "INVALID_FORM_ENCODED_PARAMS"] = 35;
                            values[valuesById[36] = "INVALID_URL_PARAMETER_NAME"] = 36;
                            values[valuesById[37] = "NO_GEOCODING_RESULT"] = 37;
                            values[valuesById[38] = "SOURCE_NAME_IN_REVIEW_EXTENSION_TEXT"] = 38;
                            values[valuesById[39] = "CARRIER_SPECIFIC_SHORT_NUMBER_NOT_ALLOWED"] = 39;
                            values[valuesById[40] = "INVALID_PLACEHOLDER_FIELD_ID"] = 40;
                            values[valuesById[41] = "INVALID_URL_TAG"] = 41;
                            values[valuesById[42] = "LIST_TOO_LONG"] = 42;
                            values[valuesById[43] = "INVALID_ATTRIBUTES_COMBINATION"] = 43;
                            values[valuesById[44] = "DUPLICATE_VALUES"] = 44;
                            values[valuesById[45] = "INVALID_CALL_CONVERSION_ACTION_ID"] = 45;
                            values[valuesById[46] = "CANNOT_SET_WITHOUT_FINAL_URLS"] = 46;
                            values[valuesById[47] = "APP_ID_DOESNT_EXIST_IN_APP_STORE"] = 47;
                            values[valuesById[48] = "INVALID_FINAL_URL"] = 48;
                            values[valuesById[49] = "INVALID_TRACKING_URL"] = 49;
                            values[valuesById[50] = "INVALID_FINAL_URL_FOR_APP_DOWNLOAD_URL"] = 50;
                            values[valuesById[51] = "LIST_TOO_SHORT"] = 51;
                            values[valuesById[52] = "INVALID_USER_ACTION"] = 52;
                            values[valuesById[53] = "INVALID_TYPE_NAME"] = 53;
                            values[valuesById[54] = "INVALID_EVENT_CHANGE_STATUS"] = 54;
                            values[valuesById[55] = "INVALID_SNIPPETS_HEADER"] = 55;
                            values[valuesById[56] = "INVALID_ANDROID_APP_LINK"] = 56;
                            values[valuesById[57] = "NUMBER_TYPE_WITH_CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY"] = 57;
                            values[valuesById[58] = "RESERVED_KEYWORD_OTHER"] = 58;
                            values[valuesById[59] = "DUPLICATE_OPTION_LABELS"] = 59;
                            values[valuesById[60] = "DUPLICATE_OPTION_PREFILLS"] = 60;
                            values[valuesById[61] = "UNEQUAL_LIST_LENGTHS"] = 61;
                            values[valuesById[62] = "INCONSISTENT_CURRENCY_CODES"] = 62;
                            values[valuesById[63] = "PRICE_EXTENSION_HAS_DUPLICATED_HEADERS"] = 63;
                            values[valuesById[64] = "ITEM_HAS_DUPLICATED_HEADER_AND_DESCRIPTION"] = 64;
                            values[valuesById[65] = "PRICE_EXTENSION_HAS_TOO_FEW_ITEMS"] = 65;
                            values[valuesById[66] = "UNSUPPORTED_VALUE"] = 66;
                            values[valuesById[67] = "INVALID_FINAL_MOBILE_URL"] = 67;
                            values[valuesById[68] = "INVALID_KEYWORDLESS_AD_RULE_LABEL"] = 68;
                            values[valuesById[69] = "VALUE_TRACK_PARAMETER_NOT_SUPPORTED"] = 69;
                            values[valuesById[70] = "UNSUPPORTED_VALUE_IN_SELECTED_LANGUAGE"] = 70;
                            values[valuesById[71] = "INVALID_IOS_APP_LINK"] = 71;
                            values[valuesById[72] = "MISSING_IOS_APP_LINK_OR_IOS_APP_STORE_ID"] = 72;
                            values[valuesById[73] = "PROMOTION_INVALID_TIME"] = 73;
                            values[valuesById[74] = "PROMOTION_CANNOT_SET_PERCENT_OFF_AND_MONEY_AMOUNT_OFF"] = 74;
                            values[valuesById[75] = "PROMOTION_CANNOT_SET_PROMOTION_CODE_AND_ORDERS_OVER_AMOUNT"] = 75;
                            values[valuesById[76] = "TOO_MANY_DECIMAL_PLACES_SPECIFIED"] = 76;
                            values[valuesById[77] = "AD_CUSTOMIZERS_NOT_ALLOWED"] = 77;
                            values[valuesById[78] = "INVALID_LANGUAGE_CODE"] = 78;
                            values[valuesById[79] = "UNSUPPORTED_LANGUAGE"] = 79;
                            values[valuesById[80] = "IF_FUNCTION_NOT_ALLOWED"] = 80;
                            values[valuesById[81] = "INVALID_FINAL_URL_SUFFIX"] = 81;
                            values[valuesById[82] = "INVALID_TAG_IN_FINAL_URL_SUFFIX"] = 82;
                            values[valuesById[83] = "INVALID_FINAL_URL_SUFFIX_FORMAT"] = 83;
                            values[valuesById[84] = "CUSTOMER_CONSENT_FOR_CALL_RECORDING_REQUIRED"] = 84;
                            values[valuesById[85] = "ONLY_ONE_DELIVERY_OPTION_IS_ALLOWED"] = 85;
                            values[valuesById[86] = "NO_DELIVERY_OPTION_IS_SET"] = 86;
                            values[valuesById[87] = "INVALID_CONVERSION_REPORTING_STATE"] = 87;
                            values[valuesById[88] = "IMAGE_SIZE_WRONG"] = 88;
                            values[valuesById[89] = "EMAIL_DELIVERY_NOT_AVAILABLE_IN_COUNTRY"] = 89;
                            values[valuesById[90] = "AUTO_REPLY_NOT_AVAILABLE_IN_COUNTRY"] = 90;
                            values[valuesById[91] = "INVALID_LATITUDE_VALUE"] = 91;
                            values[valuesById[92] = "INVALID_LONGITUDE_VALUE"] = 92;
                            values[valuesById[93] = "TOO_MANY_LABELS"] = 93;
                            values[valuesById[94] = "INVALID_IMAGE_URL"] = 94;
                            values[valuesById[95] = "MISSING_LATITUDE_VALUE"] = 95;
                            values[valuesById[96] = "MISSING_LONGITUDE_VALUE"] = 96;
                            return values;
                        })();

                        return FeedItemValidationErrorEnum;
                    })();

                    errors.FeedMappingErrorEnum = (function() {

                        /**
                         * Properties of a FeedMappingErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IFeedMappingErrorEnum
                         */

                        /**
                         * Constructs a new FeedMappingErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a FeedMappingErrorEnum.
                         * @implements IFeedMappingErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IFeedMappingErrorEnum=} [properties] Properties to set
                         */
                        function FeedMappingErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FeedMappingErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.FeedMappingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFeedMappingErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.FeedMappingErrorEnum} FeedMappingErrorEnum instance
                         */
                        FeedMappingErrorEnum.create = function create(properties) {
                            return new FeedMappingErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified FeedMappingErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.FeedMappingErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.FeedMappingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFeedMappingErrorEnum} message FeedMappingErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedMappingErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedMappingErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.FeedMappingErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FeedMappingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFeedMappingErrorEnum} message FeedMappingErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedMappingErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedMappingErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.FeedMappingErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.FeedMappingErrorEnum} FeedMappingErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedMappingErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.FeedMappingErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedMappingErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FeedMappingErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.FeedMappingErrorEnum} FeedMappingErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedMappingErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedMappingErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.FeedMappingErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedMappingErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FeedMappingErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.FeedMappingErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.FeedMappingErrorEnum} FeedMappingErrorEnum
                         */
                        FeedMappingErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.FeedMappingErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.FeedMappingErrorEnum();
                        };

                        /**
                         * Creates a plain object from a FeedMappingErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.FeedMappingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.FeedMappingErrorEnum} message FeedMappingErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedMappingErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FeedMappingErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.FeedMappingErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedMappingErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FeedMappingError enum.
                         * @name google.ads.googleads.v1.errors.FeedMappingErrorEnum.FeedMappingError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} INVALID_PLACEHOLDER_FIELD=2 INVALID_PLACEHOLDER_FIELD value
                         * @property {number} INVALID_CRITERION_FIELD=3 INVALID_CRITERION_FIELD value
                         * @property {number} INVALID_PLACEHOLDER_TYPE=4 INVALID_PLACEHOLDER_TYPE value
                         * @property {number} INVALID_CRITERION_TYPE=5 INVALID_CRITERION_TYPE value
                         * @property {number} NO_ATTRIBUTE_FIELD_MAPPINGS=7 NO_ATTRIBUTE_FIELD_MAPPINGS value
                         * @property {number} FEED_ATTRIBUTE_TYPE_MISMATCH=8 FEED_ATTRIBUTE_TYPE_MISMATCH value
                         * @property {number} CANNOT_OPERATE_ON_MAPPINGS_FOR_SYSTEM_GENERATED_FEED=9 CANNOT_OPERATE_ON_MAPPINGS_FOR_SYSTEM_GENERATED_FEED value
                         * @property {number} MULTIPLE_MAPPINGS_FOR_PLACEHOLDER_TYPE=10 MULTIPLE_MAPPINGS_FOR_PLACEHOLDER_TYPE value
                         * @property {number} MULTIPLE_MAPPINGS_FOR_CRITERION_TYPE=11 MULTIPLE_MAPPINGS_FOR_CRITERION_TYPE value
                         * @property {number} MULTIPLE_MAPPINGS_FOR_PLACEHOLDER_FIELD=12 MULTIPLE_MAPPINGS_FOR_PLACEHOLDER_FIELD value
                         * @property {number} MULTIPLE_MAPPINGS_FOR_CRITERION_FIELD=13 MULTIPLE_MAPPINGS_FOR_CRITERION_FIELD value
                         * @property {number} UNEXPECTED_ATTRIBUTE_FIELD_MAPPINGS=14 UNEXPECTED_ATTRIBUTE_FIELD_MAPPINGS value
                         * @property {number} LOCATION_PLACEHOLDER_ONLY_FOR_PLACES_FEEDS=15 LOCATION_PLACEHOLDER_ONLY_FOR_PLACES_FEEDS value
                         * @property {number} CANNOT_MODIFY_MAPPINGS_FOR_TYPED_FEED=16 CANNOT_MODIFY_MAPPINGS_FOR_TYPED_FEED value
                         * @property {number} INVALID_PLACEHOLDER_TYPE_FOR_NON_SYSTEM_GENERATED_FEED=17 INVALID_PLACEHOLDER_TYPE_FOR_NON_SYSTEM_GENERATED_FEED value
                         * @property {number} INVALID_PLACEHOLDER_TYPE_FOR_SYSTEM_GENERATED_FEED_TYPE=18 INVALID_PLACEHOLDER_TYPE_FOR_SYSTEM_GENERATED_FEED_TYPE value
                         */
                        FeedMappingErrorEnum.FeedMappingError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "INVALID_PLACEHOLDER_FIELD"] = 2;
                            values[valuesById[3] = "INVALID_CRITERION_FIELD"] = 3;
                            values[valuesById[4] = "INVALID_PLACEHOLDER_TYPE"] = 4;
                            values[valuesById[5] = "INVALID_CRITERION_TYPE"] = 5;
                            values[valuesById[7] = "NO_ATTRIBUTE_FIELD_MAPPINGS"] = 7;
                            values[valuesById[8] = "FEED_ATTRIBUTE_TYPE_MISMATCH"] = 8;
                            values[valuesById[9] = "CANNOT_OPERATE_ON_MAPPINGS_FOR_SYSTEM_GENERATED_FEED"] = 9;
                            values[valuesById[10] = "MULTIPLE_MAPPINGS_FOR_PLACEHOLDER_TYPE"] = 10;
                            values[valuesById[11] = "MULTIPLE_MAPPINGS_FOR_CRITERION_TYPE"] = 11;
                            values[valuesById[12] = "MULTIPLE_MAPPINGS_FOR_PLACEHOLDER_FIELD"] = 12;
                            values[valuesById[13] = "MULTIPLE_MAPPINGS_FOR_CRITERION_FIELD"] = 13;
                            values[valuesById[14] = "UNEXPECTED_ATTRIBUTE_FIELD_MAPPINGS"] = 14;
                            values[valuesById[15] = "LOCATION_PLACEHOLDER_ONLY_FOR_PLACES_FEEDS"] = 15;
                            values[valuesById[16] = "CANNOT_MODIFY_MAPPINGS_FOR_TYPED_FEED"] = 16;
                            values[valuesById[17] = "INVALID_PLACEHOLDER_TYPE_FOR_NON_SYSTEM_GENERATED_FEED"] = 17;
                            values[valuesById[18] = "INVALID_PLACEHOLDER_TYPE_FOR_SYSTEM_GENERATED_FEED_TYPE"] = 18;
                            return values;
                        })();

                        return FeedMappingErrorEnum;
                    })();

                    errors.FieldErrorEnum = (function() {

                        /**
                         * Properties of a FieldErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IFieldErrorEnum
                         */

                        /**
                         * Constructs a new FieldErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a FieldErrorEnum.
                         * @implements IFieldErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IFieldErrorEnum=} [properties] Properties to set
                         */
                        function FieldErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FieldErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.FieldErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFieldErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.FieldErrorEnum} FieldErrorEnum instance
                         */
                        FieldErrorEnum.create = function create(properties) {
                            return new FieldErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified FieldErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.FieldErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.FieldErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFieldErrorEnum} message FieldErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FieldErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FieldErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.FieldErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FieldErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFieldErrorEnum} message FieldErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FieldErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FieldErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.FieldErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.FieldErrorEnum} FieldErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FieldErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.FieldErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FieldErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FieldErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.FieldErrorEnum} FieldErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FieldErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FieldErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.FieldErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FieldErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FieldErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.FieldErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.FieldErrorEnum} FieldErrorEnum
                         */
                        FieldErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.FieldErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.FieldErrorEnum();
                        };

                        /**
                         * Creates a plain object from a FieldErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.FieldErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.FieldErrorEnum} message FieldErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FieldErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FieldErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.FieldErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FieldErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FieldError enum.
                         * @name google.ads.googleads.v1.errors.FieldErrorEnum.FieldError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} REQUIRED=2 REQUIRED value
                         * @property {number} IMMUTABLE_FIELD=3 IMMUTABLE_FIELD value
                         * @property {number} INVALID_VALUE=4 INVALID_VALUE value
                         * @property {number} VALUE_MUST_BE_UNSET=5 VALUE_MUST_BE_UNSET value
                         * @property {number} REQUIRED_NONEMPTY_LIST=6 REQUIRED_NONEMPTY_LIST value
                         * @property {number} FIELD_CANNOT_BE_CLEARED=7 FIELD_CANNOT_BE_CLEARED value
                         * @property {number} BLACKLISTED_VALUE=8 BLACKLISTED_VALUE value
                         */
                        FieldErrorEnum.FieldError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "REQUIRED"] = 2;
                            values[valuesById[3] = "IMMUTABLE_FIELD"] = 3;
                            values[valuesById[4] = "INVALID_VALUE"] = 4;
                            values[valuesById[5] = "VALUE_MUST_BE_UNSET"] = 5;
                            values[valuesById[6] = "REQUIRED_NONEMPTY_LIST"] = 6;
                            values[valuesById[7] = "FIELD_CANNOT_BE_CLEARED"] = 7;
                            values[valuesById[8] = "BLACKLISTED_VALUE"] = 8;
                            return values;
                        })();

                        return FieldErrorEnum;
                    })();

                    errors.FieldMaskErrorEnum = (function() {

                        /**
                         * Properties of a FieldMaskErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IFieldMaskErrorEnum
                         */

                        /**
                         * Constructs a new FieldMaskErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a FieldMaskErrorEnum.
                         * @implements IFieldMaskErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IFieldMaskErrorEnum=} [properties] Properties to set
                         */
                        function FieldMaskErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FieldMaskErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.FieldMaskErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFieldMaskErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.FieldMaskErrorEnum} FieldMaskErrorEnum instance
                         */
                        FieldMaskErrorEnum.create = function create(properties) {
                            return new FieldMaskErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified FieldMaskErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.FieldMaskErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.FieldMaskErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFieldMaskErrorEnum} message FieldMaskErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FieldMaskErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FieldMaskErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.FieldMaskErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FieldMaskErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFieldMaskErrorEnum} message FieldMaskErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FieldMaskErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FieldMaskErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.FieldMaskErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.FieldMaskErrorEnum} FieldMaskErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FieldMaskErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.FieldMaskErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FieldMaskErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FieldMaskErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.FieldMaskErrorEnum} FieldMaskErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FieldMaskErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FieldMaskErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.FieldMaskErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FieldMaskErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FieldMaskErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.FieldMaskErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.FieldMaskErrorEnum} FieldMaskErrorEnum
                         */
                        FieldMaskErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.FieldMaskErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.FieldMaskErrorEnum();
                        };

                        /**
                         * Creates a plain object from a FieldMaskErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.FieldMaskErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.FieldMaskErrorEnum} message FieldMaskErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FieldMaskErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FieldMaskErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.FieldMaskErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FieldMaskErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FieldMaskError enum.
                         * @name google.ads.googleads.v1.errors.FieldMaskErrorEnum.FieldMaskError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} FIELD_MASK_MISSING=5 FIELD_MASK_MISSING value
                         * @property {number} FIELD_MASK_NOT_ALLOWED=4 FIELD_MASK_NOT_ALLOWED value
                         * @property {number} FIELD_NOT_FOUND=2 FIELD_NOT_FOUND value
                         * @property {number} FIELD_HAS_SUBFIELDS=3 FIELD_HAS_SUBFIELDS value
                         */
                        FieldMaskErrorEnum.FieldMaskError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[5] = "FIELD_MASK_MISSING"] = 5;
                            values[valuesById[4] = "FIELD_MASK_NOT_ALLOWED"] = 4;
                            values[valuesById[2] = "FIELD_NOT_FOUND"] = 2;
                            values[valuesById[3] = "FIELD_HAS_SUBFIELDS"] = 3;
                            return values;
                        })();

                        return FieldMaskErrorEnum;
                    })();

                    errors.FunctionErrorEnum = (function() {

                        /**
                         * Properties of a FunctionErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IFunctionErrorEnum
                         */

                        /**
                         * Constructs a new FunctionErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a FunctionErrorEnum.
                         * @implements IFunctionErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IFunctionErrorEnum=} [properties] Properties to set
                         */
                        function FunctionErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FunctionErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.FunctionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFunctionErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.FunctionErrorEnum} FunctionErrorEnum instance
                         */
                        FunctionErrorEnum.create = function create(properties) {
                            return new FunctionErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified FunctionErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.FunctionErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.FunctionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFunctionErrorEnum} message FunctionErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FunctionErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FunctionErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.FunctionErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FunctionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFunctionErrorEnum} message FunctionErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FunctionErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FunctionErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.FunctionErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.FunctionErrorEnum} FunctionErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FunctionErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.FunctionErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FunctionErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FunctionErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.FunctionErrorEnum} FunctionErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FunctionErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FunctionErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.FunctionErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FunctionErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FunctionErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.FunctionErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.FunctionErrorEnum} FunctionErrorEnum
                         */
                        FunctionErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.FunctionErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.FunctionErrorEnum();
                        };

                        /**
                         * Creates a plain object from a FunctionErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.FunctionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.FunctionErrorEnum} message FunctionErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FunctionErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FunctionErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.FunctionErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FunctionErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FunctionError enum.
                         * @name google.ads.googleads.v1.errors.FunctionErrorEnum.FunctionError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} INVALID_FUNCTION_FORMAT=2 INVALID_FUNCTION_FORMAT value
                         * @property {number} DATA_TYPE_MISMATCH=3 DATA_TYPE_MISMATCH value
                         * @property {number} INVALID_CONJUNCTION_OPERANDS=4 INVALID_CONJUNCTION_OPERANDS value
                         * @property {number} INVALID_NUMBER_OF_OPERANDS=5 INVALID_NUMBER_OF_OPERANDS value
                         * @property {number} INVALID_OPERAND_TYPE=6 INVALID_OPERAND_TYPE value
                         * @property {number} INVALID_OPERATOR=7 INVALID_OPERATOR value
                         * @property {number} INVALID_REQUEST_CONTEXT_TYPE=8 INVALID_REQUEST_CONTEXT_TYPE value
                         * @property {number} INVALID_FUNCTION_FOR_CALL_PLACEHOLDER=9 INVALID_FUNCTION_FOR_CALL_PLACEHOLDER value
                         * @property {number} INVALID_FUNCTION_FOR_PLACEHOLDER=10 INVALID_FUNCTION_FOR_PLACEHOLDER value
                         * @property {number} INVALID_OPERAND=11 INVALID_OPERAND value
                         * @property {number} MISSING_CONSTANT_OPERAND_VALUE=12 MISSING_CONSTANT_OPERAND_VALUE value
                         * @property {number} INVALID_CONSTANT_OPERAND_VALUE=13 INVALID_CONSTANT_OPERAND_VALUE value
                         * @property {number} INVALID_NESTING=14 INVALID_NESTING value
                         * @property {number} MULTIPLE_FEED_IDS_NOT_SUPPORTED=15 MULTIPLE_FEED_IDS_NOT_SUPPORTED value
                         * @property {number} INVALID_FUNCTION_FOR_FEED_WITH_FIXED_SCHEMA=16 INVALID_FUNCTION_FOR_FEED_WITH_FIXED_SCHEMA value
                         * @property {number} INVALID_ATTRIBUTE_NAME=17 INVALID_ATTRIBUTE_NAME value
                         */
                        FunctionErrorEnum.FunctionError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "INVALID_FUNCTION_FORMAT"] = 2;
                            values[valuesById[3] = "DATA_TYPE_MISMATCH"] = 3;
                            values[valuesById[4] = "INVALID_CONJUNCTION_OPERANDS"] = 4;
                            values[valuesById[5] = "INVALID_NUMBER_OF_OPERANDS"] = 5;
                            values[valuesById[6] = "INVALID_OPERAND_TYPE"] = 6;
                            values[valuesById[7] = "INVALID_OPERATOR"] = 7;
                            values[valuesById[8] = "INVALID_REQUEST_CONTEXT_TYPE"] = 8;
                            values[valuesById[9] = "INVALID_FUNCTION_FOR_CALL_PLACEHOLDER"] = 9;
                            values[valuesById[10] = "INVALID_FUNCTION_FOR_PLACEHOLDER"] = 10;
                            values[valuesById[11] = "INVALID_OPERAND"] = 11;
                            values[valuesById[12] = "MISSING_CONSTANT_OPERAND_VALUE"] = 12;
                            values[valuesById[13] = "INVALID_CONSTANT_OPERAND_VALUE"] = 13;
                            values[valuesById[14] = "INVALID_NESTING"] = 14;
                            values[valuesById[15] = "MULTIPLE_FEED_IDS_NOT_SUPPORTED"] = 15;
                            values[valuesById[16] = "INVALID_FUNCTION_FOR_FEED_WITH_FIXED_SCHEMA"] = 16;
                            values[valuesById[17] = "INVALID_ATTRIBUTE_NAME"] = 17;
                            return values;
                        })();

                        return FunctionErrorEnum;
                    })();

                    errors.FunctionParsingErrorEnum = (function() {

                        /**
                         * Properties of a FunctionParsingErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IFunctionParsingErrorEnum
                         */

                        /**
                         * Constructs a new FunctionParsingErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a FunctionParsingErrorEnum.
                         * @implements IFunctionParsingErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IFunctionParsingErrorEnum=} [properties] Properties to set
                         */
                        function FunctionParsingErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FunctionParsingErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.FunctionParsingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFunctionParsingErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.FunctionParsingErrorEnum} FunctionParsingErrorEnum instance
                         */
                        FunctionParsingErrorEnum.create = function create(properties) {
                            return new FunctionParsingErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified FunctionParsingErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.FunctionParsingErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.FunctionParsingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFunctionParsingErrorEnum} message FunctionParsingErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FunctionParsingErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FunctionParsingErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.FunctionParsingErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FunctionParsingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IFunctionParsingErrorEnum} message FunctionParsingErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FunctionParsingErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FunctionParsingErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.FunctionParsingErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.FunctionParsingErrorEnum} FunctionParsingErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FunctionParsingErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.FunctionParsingErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FunctionParsingErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.FunctionParsingErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.FunctionParsingErrorEnum} FunctionParsingErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FunctionParsingErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FunctionParsingErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.FunctionParsingErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FunctionParsingErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FunctionParsingErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.FunctionParsingErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.FunctionParsingErrorEnum} FunctionParsingErrorEnum
                         */
                        FunctionParsingErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.FunctionParsingErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.FunctionParsingErrorEnum();
                        };

                        /**
                         * Creates a plain object from a FunctionParsingErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.FunctionParsingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.FunctionParsingErrorEnum} message FunctionParsingErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FunctionParsingErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FunctionParsingErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.FunctionParsingErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FunctionParsingErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FunctionParsingError enum.
                         * @name google.ads.googleads.v1.errors.FunctionParsingErrorEnum.FunctionParsingError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} NO_MORE_INPUT=2 NO_MORE_INPUT value
                         * @property {number} EXPECTED_CHARACTER=3 EXPECTED_CHARACTER value
                         * @property {number} UNEXPECTED_SEPARATOR=4 UNEXPECTED_SEPARATOR value
                         * @property {number} UNMATCHED_LEFT_BRACKET=5 UNMATCHED_LEFT_BRACKET value
                         * @property {number} UNMATCHED_RIGHT_BRACKET=6 UNMATCHED_RIGHT_BRACKET value
                         * @property {number} TOO_MANY_NESTED_FUNCTIONS=7 TOO_MANY_NESTED_FUNCTIONS value
                         * @property {number} MISSING_RIGHT_HAND_OPERAND=8 MISSING_RIGHT_HAND_OPERAND value
                         * @property {number} INVALID_OPERATOR_NAME=9 INVALID_OPERATOR_NAME value
                         * @property {number} FEED_ATTRIBUTE_OPERAND_ARGUMENT_NOT_INTEGER=10 FEED_ATTRIBUTE_OPERAND_ARGUMENT_NOT_INTEGER value
                         * @property {number} NO_OPERANDS=11 NO_OPERANDS value
                         * @property {number} TOO_MANY_OPERANDS=12 TOO_MANY_OPERANDS value
                         */
                        FunctionParsingErrorEnum.FunctionParsingError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "NO_MORE_INPUT"] = 2;
                            values[valuesById[3] = "EXPECTED_CHARACTER"] = 3;
                            values[valuesById[4] = "UNEXPECTED_SEPARATOR"] = 4;
                            values[valuesById[5] = "UNMATCHED_LEFT_BRACKET"] = 5;
                            values[valuesById[6] = "UNMATCHED_RIGHT_BRACKET"] = 6;
                            values[valuesById[7] = "TOO_MANY_NESTED_FUNCTIONS"] = 7;
                            values[valuesById[8] = "MISSING_RIGHT_HAND_OPERAND"] = 8;
                            values[valuesById[9] = "INVALID_OPERATOR_NAME"] = 9;
                            values[valuesById[10] = "FEED_ATTRIBUTE_OPERAND_ARGUMENT_NOT_INTEGER"] = 10;
                            values[valuesById[11] = "NO_OPERANDS"] = 11;
                            values[valuesById[12] = "TOO_MANY_OPERANDS"] = 12;
                            return values;
                        })();

                        return FunctionParsingErrorEnum;
                    })();

                    errors.GeoTargetConstantSuggestionErrorEnum = (function() {

                        /**
                         * Properties of a GeoTargetConstantSuggestionErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IGeoTargetConstantSuggestionErrorEnum
                         */

                        /**
                         * Constructs a new GeoTargetConstantSuggestionErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a GeoTargetConstantSuggestionErrorEnum.
                         * @implements IGeoTargetConstantSuggestionErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IGeoTargetConstantSuggestionErrorEnum=} [properties] Properties to set
                         */
                        function GeoTargetConstantSuggestionErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new GeoTargetConstantSuggestionErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IGeoTargetConstantSuggestionErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum} GeoTargetConstantSuggestionErrorEnum instance
                         */
                        GeoTargetConstantSuggestionErrorEnum.create = function create(properties) {
                            return new GeoTargetConstantSuggestionErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified GeoTargetConstantSuggestionErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IGeoTargetConstantSuggestionErrorEnum} message GeoTargetConstantSuggestionErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GeoTargetConstantSuggestionErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified GeoTargetConstantSuggestionErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IGeoTargetConstantSuggestionErrorEnum} message GeoTargetConstantSuggestionErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GeoTargetConstantSuggestionErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GeoTargetConstantSuggestionErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum} GeoTargetConstantSuggestionErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GeoTargetConstantSuggestionErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GeoTargetConstantSuggestionErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum} GeoTargetConstantSuggestionErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GeoTargetConstantSuggestionErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GeoTargetConstantSuggestionErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GeoTargetConstantSuggestionErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a GeoTargetConstantSuggestionErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum} GeoTargetConstantSuggestionErrorEnum
                         */
                        GeoTargetConstantSuggestionErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum();
                        };

                        /**
                         * Creates a plain object from a GeoTargetConstantSuggestionErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum} message GeoTargetConstantSuggestionErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GeoTargetConstantSuggestionErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this GeoTargetConstantSuggestionErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GeoTargetConstantSuggestionErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * GeoTargetConstantSuggestionError enum.
                         * @name google.ads.googleads.v1.errors.GeoTargetConstantSuggestionErrorEnum.GeoTargetConstantSuggestionError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} LOCATION_NAME_SIZE_LIMIT=2 LOCATION_NAME_SIZE_LIMIT value
                         * @property {number} LOCATION_NAME_LIMIT=3 LOCATION_NAME_LIMIT value
                         * @property {number} INVALID_COUNTRY_CODE=4 INVALID_COUNTRY_CODE value
                         * @property {number} REQUEST_PARAMETERS_UNSET=5 REQUEST_PARAMETERS_UNSET value
                         */
                        GeoTargetConstantSuggestionErrorEnum.GeoTargetConstantSuggestionError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "LOCATION_NAME_SIZE_LIMIT"] = 2;
                            values[valuesById[3] = "LOCATION_NAME_LIMIT"] = 3;
                            values[valuesById[4] = "INVALID_COUNTRY_CODE"] = 4;
                            values[valuesById[5] = "REQUEST_PARAMETERS_UNSET"] = 5;
                            return values;
                        })();

                        return GeoTargetConstantSuggestionErrorEnum;
                    })();

                    errors.HeaderErrorEnum = (function() {

                        /**
                         * Properties of a HeaderErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IHeaderErrorEnum
                         */

                        /**
                         * Constructs a new HeaderErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a HeaderErrorEnum.
                         * @implements IHeaderErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IHeaderErrorEnum=} [properties] Properties to set
                         */
                        function HeaderErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new HeaderErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.HeaderErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IHeaderErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.HeaderErrorEnum} HeaderErrorEnum instance
                         */
                        HeaderErrorEnum.create = function create(properties) {
                            return new HeaderErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified HeaderErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.HeaderErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.HeaderErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IHeaderErrorEnum} message HeaderErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HeaderErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified HeaderErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.HeaderErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.HeaderErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IHeaderErrorEnum} message HeaderErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HeaderErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a HeaderErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.HeaderErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.HeaderErrorEnum} HeaderErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HeaderErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.HeaderErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a HeaderErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.HeaderErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.HeaderErrorEnum} HeaderErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HeaderErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a HeaderErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.HeaderErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HeaderErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a HeaderErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.HeaderErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.HeaderErrorEnum} HeaderErrorEnum
                         */
                        HeaderErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.HeaderErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.HeaderErrorEnum();
                        };

                        /**
                         * Creates a plain object from a HeaderErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.HeaderErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.HeaderErrorEnum} message HeaderErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HeaderErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this HeaderErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.HeaderErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HeaderErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * HeaderError enum.
                         * @name google.ads.googleads.v1.errors.HeaderErrorEnum.HeaderError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} INVALID_LOGIN_CUSTOMER_ID=3 INVALID_LOGIN_CUSTOMER_ID value
                         */
                        HeaderErrorEnum.HeaderError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[3] = "INVALID_LOGIN_CUSTOMER_ID"] = 3;
                            return values;
                        })();

                        return HeaderErrorEnum;
                    })();

                    errors.IdErrorEnum = (function() {

                        /**
                         * Properties of an IdErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IIdErrorEnum
                         */

                        /**
                         * Constructs a new IdErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an IdErrorEnum.
                         * @implements IIdErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IIdErrorEnum=} [properties] Properties to set
                         */
                        function IdErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new IdErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.IdErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IIdErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.IdErrorEnum} IdErrorEnum instance
                         */
                        IdErrorEnum.create = function create(properties) {
                            return new IdErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified IdErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.IdErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.IdErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IIdErrorEnum} message IdErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        IdErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified IdErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.IdErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.IdErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IIdErrorEnum} message IdErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        IdErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an IdErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.IdErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.IdErrorEnum} IdErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        IdErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.IdErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an IdErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.IdErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.IdErrorEnum} IdErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        IdErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an IdErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.IdErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        IdErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an IdErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.IdErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.IdErrorEnum} IdErrorEnum
                         */
                        IdErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.IdErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.IdErrorEnum();
                        };

                        /**
                         * Creates a plain object from an IdErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.IdErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IdErrorEnum} message IdErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        IdErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this IdErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.IdErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        IdErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * IdError enum.
                         * @name google.ads.googleads.v1.errors.IdErrorEnum.IdError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} NOT_FOUND=2 NOT_FOUND value
                         */
                        IdErrorEnum.IdError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "NOT_FOUND"] = 2;
                            return values;
                        })();

                        return IdErrorEnum;
                    })();

                    errors.ImageErrorEnum = (function() {

                        /**
                         * Properties of an ImageErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IImageErrorEnum
                         */

                        /**
                         * Constructs a new ImageErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an ImageErrorEnum.
                         * @implements IImageErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IImageErrorEnum=} [properties] Properties to set
                         */
                        function ImageErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ImageErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.ImageErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IImageErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.ImageErrorEnum} ImageErrorEnum instance
                         */
                        ImageErrorEnum.create = function create(properties) {
                            return new ImageErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified ImageErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.ImageErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.ImageErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IImageErrorEnum} message ImageErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ImageErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ImageErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.ImageErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ImageErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IImageErrorEnum} message ImageErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ImageErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ImageErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.ImageErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.ImageErrorEnum} ImageErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ImageErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.ImageErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ImageErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ImageErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.ImageErrorEnum} ImageErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ImageErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ImageErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.ImageErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ImageErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an ImageErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.ImageErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.ImageErrorEnum} ImageErrorEnum
                         */
                        ImageErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.ImageErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.ImageErrorEnum();
                        };

                        /**
                         * Creates a plain object from an ImageErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.ImageErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ImageErrorEnum} message ImageErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ImageErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ImageErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.ImageErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ImageErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ImageError enum.
                         * @name google.ads.googleads.v1.errors.ImageErrorEnum.ImageError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} INVALID_IMAGE=2 INVALID_IMAGE value
                         * @property {number} STORAGE_ERROR=3 STORAGE_ERROR value
                         * @property {number} BAD_REQUEST=4 BAD_REQUEST value
                         * @property {number} UNEXPECTED_SIZE=5 UNEXPECTED_SIZE value
                         * @property {number} ANIMATED_NOT_ALLOWED=6 ANIMATED_NOT_ALLOWED value
                         * @property {number} ANIMATION_TOO_LONG=7 ANIMATION_TOO_LONG value
                         * @property {number} SERVER_ERROR=8 SERVER_ERROR value
                         * @property {number} CMYK_JPEG_NOT_ALLOWED=9 CMYK_JPEG_NOT_ALLOWED value
                         * @property {number} FLASH_NOT_ALLOWED=10 FLASH_NOT_ALLOWED value
                         * @property {number} FLASH_WITHOUT_CLICKTAG=11 FLASH_WITHOUT_CLICKTAG value
                         * @property {number} FLASH_ERROR_AFTER_FIXING_CLICK_TAG=12 FLASH_ERROR_AFTER_FIXING_CLICK_TAG value
                         * @property {number} ANIMATED_VISUAL_EFFECT=13 ANIMATED_VISUAL_EFFECT value
                         * @property {number} FLASH_ERROR=14 FLASH_ERROR value
                         * @property {number} LAYOUT_PROBLEM=15 LAYOUT_PROBLEM value
                         * @property {number} PROBLEM_READING_IMAGE_FILE=16 PROBLEM_READING_IMAGE_FILE value
                         * @property {number} ERROR_STORING_IMAGE=17 ERROR_STORING_IMAGE value
                         * @property {number} ASPECT_RATIO_NOT_ALLOWED=18 ASPECT_RATIO_NOT_ALLOWED value
                         * @property {number} FLASH_HAS_NETWORK_OBJECTS=19 FLASH_HAS_NETWORK_OBJECTS value
                         * @property {number} FLASH_HAS_NETWORK_METHODS=20 FLASH_HAS_NETWORK_METHODS value
                         * @property {number} FLASH_HAS_URL=21 FLASH_HAS_URL value
                         * @property {number} FLASH_HAS_MOUSE_TRACKING=22 FLASH_HAS_MOUSE_TRACKING value
                         * @property {number} FLASH_HAS_RANDOM_NUM=23 FLASH_HAS_RANDOM_NUM value
                         * @property {number} FLASH_SELF_TARGETS=24 FLASH_SELF_TARGETS value
                         * @property {number} FLASH_BAD_GETURL_TARGET=25 FLASH_BAD_GETURL_TARGET value
                         * @property {number} FLASH_VERSION_NOT_SUPPORTED=26 FLASH_VERSION_NOT_SUPPORTED value
                         * @property {number} FLASH_WITHOUT_HARD_CODED_CLICK_URL=27 FLASH_WITHOUT_HARD_CODED_CLICK_URL value
                         * @property {number} INVALID_FLASH_FILE=28 INVALID_FLASH_FILE value
                         * @property {number} FAILED_TO_FIX_CLICK_TAG_IN_FLASH=29 FAILED_TO_FIX_CLICK_TAG_IN_FLASH value
                         * @property {number} FLASH_ACCESSES_NETWORK_RESOURCES=30 FLASH_ACCESSES_NETWORK_RESOURCES value
                         * @property {number} FLASH_EXTERNAL_JS_CALL=31 FLASH_EXTERNAL_JS_CALL value
                         * @property {number} FLASH_EXTERNAL_FS_CALL=32 FLASH_EXTERNAL_FS_CALL value
                         * @property {number} FILE_TOO_LARGE=33 FILE_TOO_LARGE value
                         * @property {number} IMAGE_DATA_TOO_LARGE=34 IMAGE_DATA_TOO_LARGE value
                         * @property {number} IMAGE_PROCESSING_ERROR=35 IMAGE_PROCESSING_ERROR value
                         * @property {number} IMAGE_TOO_SMALL=36 IMAGE_TOO_SMALL value
                         * @property {number} INVALID_INPUT=37 INVALID_INPUT value
                         * @property {number} PROBLEM_READING_FILE=38 PROBLEM_READING_FILE value
                         */
                        ImageErrorEnum.ImageError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "INVALID_IMAGE"] = 2;
                            values[valuesById[3] = "STORAGE_ERROR"] = 3;
                            values[valuesById[4] = "BAD_REQUEST"] = 4;
                            values[valuesById[5] = "UNEXPECTED_SIZE"] = 5;
                            values[valuesById[6] = "ANIMATED_NOT_ALLOWED"] = 6;
                            values[valuesById[7] = "ANIMATION_TOO_LONG"] = 7;
                            values[valuesById[8] = "SERVER_ERROR"] = 8;
                            values[valuesById[9] = "CMYK_JPEG_NOT_ALLOWED"] = 9;
                            values[valuesById[10] = "FLASH_NOT_ALLOWED"] = 10;
                            values[valuesById[11] = "FLASH_WITHOUT_CLICKTAG"] = 11;
                            values[valuesById[12] = "FLASH_ERROR_AFTER_FIXING_CLICK_TAG"] = 12;
                            values[valuesById[13] = "ANIMATED_VISUAL_EFFECT"] = 13;
                            values[valuesById[14] = "FLASH_ERROR"] = 14;
                            values[valuesById[15] = "LAYOUT_PROBLEM"] = 15;
                            values[valuesById[16] = "PROBLEM_READING_IMAGE_FILE"] = 16;
                            values[valuesById[17] = "ERROR_STORING_IMAGE"] = 17;
                            values[valuesById[18] = "ASPECT_RATIO_NOT_ALLOWED"] = 18;
                            values[valuesById[19] = "FLASH_HAS_NETWORK_OBJECTS"] = 19;
                            values[valuesById[20] = "FLASH_HAS_NETWORK_METHODS"] = 20;
                            values[valuesById[21] = "FLASH_HAS_URL"] = 21;
                            values[valuesById[22] = "FLASH_HAS_MOUSE_TRACKING"] = 22;
                            values[valuesById[23] = "FLASH_HAS_RANDOM_NUM"] = 23;
                            values[valuesById[24] = "FLASH_SELF_TARGETS"] = 24;
                            values[valuesById[25] = "FLASH_BAD_GETURL_TARGET"] = 25;
                            values[valuesById[26] = "FLASH_VERSION_NOT_SUPPORTED"] = 26;
                            values[valuesById[27] = "FLASH_WITHOUT_HARD_CODED_CLICK_URL"] = 27;
                            values[valuesById[28] = "INVALID_FLASH_FILE"] = 28;
                            values[valuesById[29] = "FAILED_TO_FIX_CLICK_TAG_IN_FLASH"] = 29;
                            values[valuesById[30] = "FLASH_ACCESSES_NETWORK_RESOURCES"] = 30;
                            values[valuesById[31] = "FLASH_EXTERNAL_JS_CALL"] = 31;
                            values[valuesById[32] = "FLASH_EXTERNAL_FS_CALL"] = 32;
                            values[valuesById[33] = "FILE_TOO_LARGE"] = 33;
                            values[valuesById[34] = "IMAGE_DATA_TOO_LARGE"] = 34;
                            values[valuesById[35] = "IMAGE_PROCESSING_ERROR"] = 35;
                            values[valuesById[36] = "IMAGE_TOO_SMALL"] = 36;
                            values[valuesById[37] = "INVALID_INPUT"] = 37;
                            values[valuesById[38] = "PROBLEM_READING_FILE"] = 38;
                            return values;
                        })();

                        return ImageErrorEnum;
                    })();

                    errors.InternalErrorEnum = (function() {

                        /**
                         * Properties of an InternalErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IInternalErrorEnum
                         */

                        /**
                         * Constructs a new InternalErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an InternalErrorEnum.
                         * @implements IInternalErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IInternalErrorEnum=} [properties] Properties to set
                         */
                        function InternalErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new InternalErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.InternalErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IInternalErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.InternalErrorEnum} InternalErrorEnum instance
                         */
                        InternalErrorEnum.create = function create(properties) {
                            return new InternalErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified InternalErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.InternalErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.InternalErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IInternalErrorEnum} message InternalErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InternalErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified InternalErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.InternalErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.InternalErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IInternalErrorEnum} message InternalErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InternalErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an InternalErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.InternalErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.InternalErrorEnum} InternalErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InternalErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.InternalErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an InternalErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.InternalErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.InternalErrorEnum} InternalErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InternalErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an InternalErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.InternalErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InternalErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an InternalErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.InternalErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.InternalErrorEnum} InternalErrorEnum
                         */
                        InternalErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.InternalErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.InternalErrorEnum();
                        };

                        /**
                         * Creates a plain object from an InternalErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.InternalErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.InternalErrorEnum} message InternalErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InternalErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this InternalErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.InternalErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InternalErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * InternalError enum.
                         * @name google.ads.googleads.v1.errors.InternalErrorEnum.InternalError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} INTERNAL_ERROR=2 INTERNAL_ERROR value
                         * @property {number} ERROR_CODE_NOT_PUBLISHED=3 ERROR_CODE_NOT_PUBLISHED value
                         * @property {number} TRANSIENT_ERROR=4 TRANSIENT_ERROR value
                         */
                        InternalErrorEnum.InternalError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "INTERNAL_ERROR"] = 2;
                            values[valuesById[3] = "ERROR_CODE_NOT_PUBLISHED"] = 3;
                            values[valuesById[4] = "TRANSIENT_ERROR"] = 4;
                            return values;
                        })();

                        return InternalErrorEnum;
                    })();

                    errors.KeywordPlanAdGroupErrorEnum = (function() {

                        /**
                         * Properties of a KeywordPlanAdGroupErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IKeywordPlanAdGroupErrorEnum
                         */

                        /**
                         * Constructs a new KeywordPlanAdGroupErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a KeywordPlanAdGroupErrorEnum.
                         * @implements IKeywordPlanAdGroupErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanAdGroupErrorEnum=} [properties] Properties to set
                         */
                        function KeywordPlanAdGroupErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new KeywordPlanAdGroupErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanAdGroupErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum} KeywordPlanAdGroupErrorEnum instance
                         */
                        KeywordPlanAdGroupErrorEnum.create = function create(properties) {
                            return new KeywordPlanAdGroupErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanAdGroupErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanAdGroupErrorEnum} message KeywordPlanAdGroupErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanAdGroupErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanAdGroupErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanAdGroupErrorEnum} message KeywordPlanAdGroupErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanAdGroupErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanAdGroupErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum} KeywordPlanAdGroupErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanAdGroupErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanAdGroupErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum} KeywordPlanAdGroupErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanAdGroupErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanAdGroupErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanAdGroupErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanAdGroupErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum} KeywordPlanAdGroupErrorEnum
                         */
                        KeywordPlanAdGroupErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum();
                        };

                        /**
                         * Creates a plain object from a KeywordPlanAdGroupErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum} message KeywordPlanAdGroupErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanAdGroupErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this KeywordPlanAdGroupErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanAdGroupErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * KeywordPlanAdGroupError enum.
                         * @name google.ads.googleads.v1.errors.KeywordPlanAdGroupErrorEnum.KeywordPlanAdGroupError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} INVALID_NAME=2 INVALID_NAME value
                         * @property {number} DUPLICATE_NAME=3 DUPLICATE_NAME value
                         */
                        KeywordPlanAdGroupErrorEnum.KeywordPlanAdGroupError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "INVALID_NAME"] = 2;
                            values[valuesById[3] = "DUPLICATE_NAME"] = 3;
                            return values;
                        })();

                        return KeywordPlanAdGroupErrorEnum;
                    })();

                    errors.KeywordPlanCampaignErrorEnum = (function() {

                        /**
                         * Properties of a KeywordPlanCampaignErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IKeywordPlanCampaignErrorEnum
                         */

                        /**
                         * Constructs a new KeywordPlanCampaignErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a KeywordPlanCampaignErrorEnum.
                         * @implements IKeywordPlanCampaignErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanCampaignErrorEnum=} [properties] Properties to set
                         */
                        function KeywordPlanCampaignErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new KeywordPlanCampaignErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanCampaignErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum} KeywordPlanCampaignErrorEnum instance
                         */
                        KeywordPlanCampaignErrorEnum.create = function create(properties) {
                            return new KeywordPlanCampaignErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanCampaignErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanCampaignErrorEnum} message KeywordPlanCampaignErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanCampaignErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanCampaignErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanCampaignErrorEnum} message KeywordPlanCampaignErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanCampaignErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanCampaignErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum} KeywordPlanCampaignErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanCampaignErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanCampaignErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum} KeywordPlanCampaignErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanCampaignErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanCampaignErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanCampaignErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanCampaignErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum} KeywordPlanCampaignErrorEnum
                         */
                        KeywordPlanCampaignErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum();
                        };

                        /**
                         * Creates a plain object from a KeywordPlanCampaignErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum} message KeywordPlanCampaignErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanCampaignErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this KeywordPlanCampaignErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanCampaignErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * KeywordPlanCampaignError enum.
                         * @name google.ads.googleads.v1.errors.KeywordPlanCampaignErrorEnum.KeywordPlanCampaignError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} INVALID_NAME=2 INVALID_NAME value
                         * @property {number} INVALID_LANGUAGES=3 INVALID_LANGUAGES value
                         * @property {number} INVALID_GEOS=4 INVALID_GEOS value
                         * @property {number} DUPLICATE_NAME=5 DUPLICATE_NAME value
                         * @property {number} MAX_GEOS_EXCEEDED=6 MAX_GEOS_EXCEEDED value
                         */
                        KeywordPlanCampaignErrorEnum.KeywordPlanCampaignError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "INVALID_NAME"] = 2;
                            values[valuesById[3] = "INVALID_LANGUAGES"] = 3;
                            values[valuesById[4] = "INVALID_GEOS"] = 4;
                            values[valuesById[5] = "DUPLICATE_NAME"] = 5;
                            values[valuesById[6] = "MAX_GEOS_EXCEEDED"] = 6;
                            return values;
                        })();

                        return KeywordPlanCampaignErrorEnum;
                    })();

                    errors.KeywordPlanErrorEnum = (function() {

                        /**
                         * Properties of a KeywordPlanErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IKeywordPlanErrorEnum
                         */

                        /**
                         * Constructs a new KeywordPlanErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a KeywordPlanErrorEnum.
                         * @implements IKeywordPlanErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanErrorEnum=} [properties] Properties to set
                         */
                        function KeywordPlanErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new KeywordPlanErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanErrorEnum} KeywordPlanErrorEnum instance
                         */
                        KeywordPlanErrorEnum.create = function create(properties) {
                            return new KeywordPlanErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.KeywordPlanErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanErrorEnum} message KeywordPlanErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.KeywordPlanErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanErrorEnum} message KeywordPlanErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanErrorEnum} KeywordPlanErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.KeywordPlanErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanErrorEnum} KeywordPlanErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanErrorEnum} KeywordPlanErrorEnum
                         */
                        KeywordPlanErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.KeywordPlanErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.KeywordPlanErrorEnum();
                        };

                        /**
                         * Creates a plain object from a KeywordPlanErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.KeywordPlanErrorEnum} message KeywordPlanErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this KeywordPlanErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * KeywordPlanError enum.
                         * @name google.ads.googleads.v1.errors.KeywordPlanErrorEnum.KeywordPlanError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} BID_MULTIPLIER_OUT_OF_RANGE=2 BID_MULTIPLIER_OUT_OF_RANGE value
                         * @property {number} BID_TOO_HIGH=3 BID_TOO_HIGH value
                         * @property {number} BID_TOO_LOW=4 BID_TOO_LOW value
                         * @property {number} BID_TOO_MANY_FRACTIONAL_DIGITS=5 BID_TOO_MANY_FRACTIONAL_DIGITS value
                         * @property {number} DAILY_BUDGET_TOO_LOW=6 DAILY_BUDGET_TOO_LOW value
                         * @property {number} DAILY_BUDGET_TOO_MANY_FRACTIONAL_DIGITS=7 DAILY_BUDGET_TOO_MANY_FRACTIONAL_DIGITS value
                         * @property {number} INVALID_VALUE=8 INVALID_VALUE value
                         * @property {number} KEYWORD_PLAN_HAS_NO_KEYWORDS=9 KEYWORD_PLAN_HAS_NO_KEYWORDS value
                         * @property {number} KEYWORD_PLAN_NOT_ENABLED=10 KEYWORD_PLAN_NOT_ENABLED value
                         * @property {number} KEYWORD_PLAN_NOT_FOUND=11 KEYWORD_PLAN_NOT_FOUND value
                         * @property {number} MISSING_BID=13 MISSING_BID value
                         * @property {number} MISSING_FORECAST_PERIOD=14 MISSING_FORECAST_PERIOD value
                         * @property {number} INVALID_FORECAST_DATE_RANGE=15 INVALID_FORECAST_DATE_RANGE value
                         * @property {number} INVALID_NAME=16 INVALID_NAME value
                         */
                        KeywordPlanErrorEnum.KeywordPlanError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "BID_MULTIPLIER_OUT_OF_RANGE"] = 2;
                            values[valuesById[3] = "BID_TOO_HIGH"] = 3;
                            values[valuesById[4] = "BID_TOO_LOW"] = 4;
                            values[valuesById[5] = "BID_TOO_MANY_FRACTIONAL_DIGITS"] = 5;
                            values[valuesById[6] = "DAILY_BUDGET_TOO_LOW"] = 6;
                            values[valuesById[7] = "DAILY_BUDGET_TOO_MANY_FRACTIONAL_DIGITS"] = 7;
                            values[valuesById[8] = "INVALID_VALUE"] = 8;
                            values[valuesById[9] = "KEYWORD_PLAN_HAS_NO_KEYWORDS"] = 9;
                            values[valuesById[10] = "KEYWORD_PLAN_NOT_ENABLED"] = 10;
                            values[valuesById[11] = "KEYWORD_PLAN_NOT_FOUND"] = 11;
                            values[valuesById[13] = "MISSING_BID"] = 13;
                            values[valuesById[14] = "MISSING_FORECAST_PERIOD"] = 14;
                            values[valuesById[15] = "INVALID_FORECAST_DATE_RANGE"] = 15;
                            values[valuesById[16] = "INVALID_NAME"] = 16;
                            return values;
                        })();

                        return KeywordPlanErrorEnum;
                    })();

                    errors.KeywordPlanIdeaErrorEnum = (function() {

                        /**
                         * Properties of a KeywordPlanIdeaErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IKeywordPlanIdeaErrorEnum
                         */

                        /**
                         * Constructs a new KeywordPlanIdeaErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a KeywordPlanIdeaErrorEnum.
                         * @implements IKeywordPlanIdeaErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanIdeaErrorEnum=} [properties] Properties to set
                         */
                        function KeywordPlanIdeaErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new KeywordPlanIdeaErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanIdeaErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum} KeywordPlanIdeaErrorEnum instance
                         */
                        KeywordPlanIdeaErrorEnum.create = function create(properties) {
                            return new KeywordPlanIdeaErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanIdeaErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanIdeaErrorEnum} message KeywordPlanIdeaErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanIdeaErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanIdeaErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanIdeaErrorEnum} message KeywordPlanIdeaErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanIdeaErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanIdeaErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum} KeywordPlanIdeaErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanIdeaErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanIdeaErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum} KeywordPlanIdeaErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanIdeaErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanIdeaErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanIdeaErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanIdeaErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum} KeywordPlanIdeaErrorEnum
                         */
                        KeywordPlanIdeaErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum();
                        };

                        /**
                         * Creates a plain object from a KeywordPlanIdeaErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum} message KeywordPlanIdeaErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanIdeaErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this KeywordPlanIdeaErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanIdeaErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * KeywordPlanIdeaError enum.
                         * @name google.ads.googleads.v1.errors.KeywordPlanIdeaErrorEnum.KeywordPlanIdeaError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} URL_CRAWL_ERROR=2 URL_CRAWL_ERROR value
                         * @property {number} INVALID_VALUE=3 INVALID_VALUE value
                         */
                        KeywordPlanIdeaErrorEnum.KeywordPlanIdeaError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "URL_CRAWL_ERROR"] = 2;
                            values[valuesById[3] = "INVALID_VALUE"] = 3;
                            return values;
                        })();

                        return KeywordPlanIdeaErrorEnum;
                    })();

                    errors.KeywordPlanKeywordErrorEnum = (function() {

                        /**
                         * Properties of a KeywordPlanKeywordErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IKeywordPlanKeywordErrorEnum
                         */

                        /**
                         * Constructs a new KeywordPlanKeywordErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a KeywordPlanKeywordErrorEnum.
                         * @implements IKeywordPlanKeywordErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanKeywordErrorEnum=} [properties] Properties to set
                         */
                        function KeywordPlanKeywordErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new KeywordPlanKeywordErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanKeywordErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum} KeywordPlanKeywordErrorEnum instance
                         */
                        KeywordPlanKeywordErrorEnum.create = function create(properties) {
                            return new KeywordPlanKeywordErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanKeywordErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanKeywordErrorEnum} message KeywordPlanKeywordErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanKeywordErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanKeywordErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanKeywordErrorEnum} message KeywordPlanKeywordErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanKeywordErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanKeywordErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum} KeywordPlanKeywordErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanKeywordErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanKeywordErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum} KeywordPlanKeywordErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanKeywordErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanKeywordErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanKeywordErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanKeywordErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum} KeywordPlanKeywordErrorEnum
                         */
                        KeywordPlanKeywordErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum();
                        };

                        /**
                         * Creates a plain object from a KeywordPlanKeywordErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum} message KeywordPlanKeywordErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanKeywordErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this KeywordPlanKeywordErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanKeywordErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * KeywordPlanKeywordError enum.
                         * @name google.ads.googleads.v1.errors.KeywordPlanKeywordErrorEnum.KeywordPlanKeywordError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} INVALID_KEYWORD_MATCH_TYPE=2 INVALID_KEYWORD_MATCH_TYPE value
                         * @property {number} DUPLICATE_KEYWORD=3 DUPLICATE_KEYWORD value
                         * @property {number} KEYWORD_TEXT_TOO_LONG=4 KEYWORD_TEXT_TOO_LONG value
                         * @property {number} KEYWORD_HAS_INVALID_CHARS=5 KEYWORD_HAS_INVALID_CHARS value
                         * @property {number} KEYWORD_HAS_TOO_MANY_WORDS=6 KEYWORD_HAS_TOO_MANY_WORDS value
                         * @property {number} INVALID_KEYWORD_TEXT=7 INVALID_KEYWORD_TEXT value
                         */
                        KeywordPlanKeywordErrorEnum.KeywordPlanKeywordError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "INVALID_KEYWORD_MATCH_TYPE"] = 2;
                            values[valuesById[3] = "DUPLICATE_KEYWORD"] = 3;
                            values[valuesById[4] = "KEYWORD_TEXT_TOO_LONG"] = 4;
                            values[valuesById[5] = "KEYWORD_HAS_INVALID_CHARS"] = 5;
                            values[valuesById[6] = "KEYWORD_HAS_TOO_MANY_WORDS"] = 6;
                            values[valuesById[7] = "INVALID_KEYWORD_TEXT"] = 7;
                            return values;
                        })();

                        return KeywordPlanKeywordErrorEnum;
                    })();

                    errors.KeywordPlanNegativeKeywordErrorEnum = (function() {

                        /**
                         * Properties of a KeywordPlanNegativeKeywordErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IKeywordPlanNegativeKeywordErrorEnum
                         */

                        /**
                         * Constructs a new KeywordPlanNegativeKeywordErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a KeywordPlanNegativeKeywordErrorEnum.
                         * @implements IKeywordPlanNegativeKeywordErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanNegativeKeywordErrorEnum=} [properties] Properties to set
                         */
                        function KeywordPlanNegativeKeywordErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new KeywordPlanNegativeKeywordErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanNegativeKeywordErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum} KeywordPlanNegativeKeywordErrorEnum instance
                         */
                        KeywordPlanNegativeKeywordErrorEnum.create = function create(properties) {
                            return new KeywordPlanNegativeKeywordErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanNegativeKeywordErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanNegativeKeywordErrorEnum} message KeywordPlanNegativeKeywordErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanNegativeKeywordErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanNegativeKeywordErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IKeywordPlanNegativeKeywordErrorEnum} message KeywordPlanNegativeKeywordErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanNegativeKeywordErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanNegativeKeywordErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum} KeywordPlanNegativeKeywordErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanNegativeKeywordErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanNegativeKeywordErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum} KeywordPlanNegativeKeywordErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanNegativeKeywordErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanNegativeKeywordErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanNegativeKeywordErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanNegativeKeywordErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum} KeywordPlanNegativeKeywordErrorEnum
                         */
                        KeywordPlanNegativeKeywordErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum();
                        };

                        /**
                         * Creates a plain object from a KeywordPlanNegativeKeywordErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum} message KeywordPlanNegativeKeywordErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanNegativeKeywordErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this KeywordPlanNegativeKeywordErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanNegativeKeywordErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * KeywordPlanNegativeKeywordError enum.
                         * @name google.ads.googleads.v1.errors.KeywordPlanNegativeKeywordErrorEnum.KeywordPlanNegativeKeywordError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         */
                        KeywordPlanNegativeKeywordErrorEnum.KeywordPlanNegativeKeywordError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            return values;
                        })();

                        return KeywordPlanNegativeKeywordErrorEnum;
                    })();

                    errors.LabelErrorEnum = (function() {

                        /**
                         * Properties of a LabelErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ILabelErrorEnum
                         */

                        /**
                         * Constructs a new LabelErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a LabelErrorEnum.
                         * @implements ILabelErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ILabelErrorEnum=} [properties] Properties to set
                         */
                        function LabelErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new LabelErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.LabelErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ILabelErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.LabelErrorEnum} LabelErrorEnum instance
                         */
                        LabelErrorEnum.create = function create(properties) {
                            return new LabelErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified LabelErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.LabelErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.LabelErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ILabelErrorEnum} message LabelErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LabelErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified LabelErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.LabelErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.LabelErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ILabelErrorEnum} message LabelErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LabelErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LabelErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.LabelErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.LabelErrorEnum} LabelErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LabelErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.LabelErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LabelErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.LabelErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.LabelErrorEnum} LabelErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LabelErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LabelErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.LabelErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LabelErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a LabelErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.LabelErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.LabelErrorEnum} LabelErrorEnum
                         */
                        LabelErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.LabelErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.LabelErrorEnum();
                        };

                        /**
                         * Creates a plain object from a LabelErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.LabelErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.LabelErrorEnum} message LabelErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LabelErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this LabelErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.LabelErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LabelErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * LabelError enum.
                         * @name google.ads.googleads.v1.errors.LabelErrorEnum.LabelError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CANNOT_APPLY_INACTIVE_LABEL=2 CANNOT_APPLY_INACTIVE_LABEL value
                         * @property {number} CANNOT_APPLY_LABEL_TO_DISABLED_AD_GROUP_CRITERION=3 CANNOT_APPLY_LABEL_TO_DISABLED_AD_GROUP_CRITERION value
                         * @property {number} CANNOT_APPLY_LABEL_TO_NEGATIVE_AD_GROUP_CRITERION=4 CANNOT_APPLY_LABEL_TO_NEGATIVE_AD_GROUP_CRITERION value
                         * @property {number} EXCEEDED_LABEL_LIMIT_PER_TYPE=5 EXCEEDED_LABEL_LIMIT_PER_TYPE value
                         * @property {number} INVALID_RESOURCE_FOR_MANAGER_LABEL=6 INVALID_RESOURCE_FOR_MANAGER_LABEL value
                         * @property {number} DUPLICATE_NAME=7 DUPLICATE_NAME value
                         * @property {number} INVALID_LABEL_NAME=8 INVALID_LABEL_NAME value
                         * @property {number} CANNOT_ATTACH_LABEL_TO_DRAFT=9 CANNOT_ATTACH_LABEL_TO_DRAFT value
                         * @property {number} CANNOT_ATTACH_NON_MANAGER_LABEL_TO_CUSTOMER=10 CANNOT_ATTACH_NON_MANAGER_LABEL_TO_CUSTOMER value
                         */
                        LabelErrorEnum.LabelError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CANNOT_APPLY_INACTIVE_LABEL"] = 2;
                            values[valuesById[3] = "CANNOT_APPLY_LABEL_TO_DISABLED_AD_GROUP_CRITERION"] = 3;
                            values[valuesById[4] = "CANNOT_APPLY_LABEL_TO_NEGATIVE_AD_GROUP_CRITERION"] = 4;
                            values[valuesById[5] = "EXCEEDED_LABEL_LIMIT_PER_TYPE"] = 5;
                            values[valuesById[6] = "INVALID_RESOURCE_FOR_MANAGER_LABEL"] = 6;
                            values[valuesById[7] = "DUPLICATE_NAME"] = 7;
                            values[valuesById[8] = "INVALID_LABEL_NAME"] = 8;
                            values[valuesById[9] = "CANNOT_ATTACH_LABEL_TO_DRAFT"] = 9;
                            values[valuesById[10] = "CANNOT_ATTACH_NON_MANAGER_LABEL_TO_CUSTOMER"] = 10;
                            return values;
                        })();

                        return LabelErrorEnum;
                    })();

                    errors.LanguageCodeErrorEnum = (function() {

                        /**
                         * Properties of a LanguageCodeErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ILanguageCodeErrorEnum
                         */

                        /**
                         * Constructs a new LanguageCodeErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a LanguageCodeErrorEnum.
                         * @implements ILanguageCodeErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ILanguageCodeErrorEnum=} [properties] Properties to set
                         */
                        function LanguageCodeErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new LanguageCodeErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.LanguageCodeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ILanguageCodeErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.LanguageCodeErrorEnum} LanguageCodeErrorEnum instance
                         */
                        LanguageCodeErrorEnum.create = function create(properties) {
                            return new LanguageCodeErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified LanguageCodeErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.LanguageCodeErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.LanguageCodeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ILanguageCodeErrorEnum} message LanguageCodeErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LanguageCodeErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified LanguageCodeErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.LanguageCodeErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.LanguageCodeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ILanguageCodeErrorEnum} message LanguageCodeErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LanguageCodeErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LanguageCodeErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.LanguageCodeErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.LanguageCodeErrorEnum} LanguageCodeErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LanguageCodeErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.LanguageCodeErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LanguageCodeErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.LanguageCodeErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.LanguageCodeErrorEnum} LanguageCodeErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LanguageCodeErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LanguageCodeErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.LanguageCodeErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LanguageCodeErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a LanguageCodeErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.LanguageCodeErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.LanguageCodeErrorEnum} LanguageCodeErrorEnum
                         */
                        LanguageCodeErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.LanguageCodeErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.LanguageCodeErrorEnum();
                        };

                        /**
                         * Creates a plain object from a LanguageCodeErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.LanguageCodeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.LanguageCodeErrorEnum} message LanguageCodeErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LanguageCodeErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this LanguageCodeErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.LanguageCodeErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LanguageCodeErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * LanguageCodeError enum.
                         * @name google.ads.googleads.v1.errors.LanguageCodeErrorEnum.LanguageCodeError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} LANGUAGE_CODE_NOT_FOUND=2 LANGUAGE_CODE_NOT_FOUND value
                         * @property {number} INVALID_LANGUAGE_CODE=3 INVALID_LANGUAGE_CODE value
                         */
                        LanguageCodeErrorEnum.LanguageCodeError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "LANGUAGE_CODE_NOT_FOUND"] = 2;
                            values[valuesById[3] = "INVALID_LANGUAGE_CODE"] = 3;
                            return values;
                        })();

                        return LanguageCodeErrorEnum;
                    })();

                    errors.ListOperationErrorEnum = (function() {

                        /**
                         * Properties of a ListOperationErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IListOperationErrorEnum
                         */

                        /**
                         * Constructs a new ListOperationErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a ListOperationErrorEnum.
                         * @implements IListOperationErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IListOperationErrorEnum=} [properties] Properties to set
                         */
                        function ListOperationErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ListOperationErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.ListOperationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IListOperationErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.ListOperationErrorEnum} ListOperationErrorEnum instance
                         */
                        ListOperationErrorEnum.create = function create(properties) {
                            return new ListOperationErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified ListOperationErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.ListOperationErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.ListOperationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IListOperationErrorEnum} message ListOperationErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListOperationErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ListOperationErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.ListOperationErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ListOperationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IListOperationErrorEnum} message ListOperationErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListOperationErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ListOperationErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.ListOperationErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.ListOperationErrorEnum} ListOperationErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListOperationErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.ListOperationErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ListOperationErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ListOperationErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.ListOperationErrorEnum} ListOperationErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListOperationErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ListOperationErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.ListOperationErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListOperationErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ListOperationErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.ListOperationErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.ListOperationErrorEnum} ListOperationErrorEnum
                         */
                        ListOperationErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.ListOperationErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.ListOperationErrorEnum();
                        };

                        /**
                         * Creates a plain object from a ListOperationErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.ListOperationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ListOperationErrorEnum} message ListOperationErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListOperationErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ListOperationErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.ListOperationErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListOperationErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ListOperationError enum.
                         * @name google.ads.googleads.v1.errors.ListOperationErrorEnum.ListOperationError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} REQUIRED_FIELD_MISSING=7 REQUIRED_FIELD_MISSING value
                         * @property {number} DUPLICATE_VALUES=8 DUPLICATE_VALUES value
                         */
                        ListOperationErrorEnum.ListOperationError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[7] = "REQUIRED_FIELD_MISSING"] = 7;
                            values[valuesById[8] = "DUPLICATE_VALUES"] = 8;
                            return values;
                        })();

                        return ListOperationErrorEnum;
                    })();

                    errors.MediaBundleErrorEnum = (function() {

                        /**
                         * Properties of a MediaBundleErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IMediaBundleErrorEnum
                         */

                        /**
                         * Constructs a new MediaBundleErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a MediaBundleErrorEnum.
                         * @implements IMediaBundleErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IMediaBundleErrorEnum=} [properties] Properties to set
                         */
                        function MediaBundleErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new MediaBundleErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.MediaBundleErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IMediaBundleErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.MediaBundleErrorEnum} MediaBundleErrorEnum instance
                         */
                        MediaBundleErrorEnum.create = function create(properties) {
                            return new MediaBundleErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified MediaBundleErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.MediaBundleErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.MediaBundleErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IMediaBundleErrorEnum} message MediaBundleErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaBundleErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified MediaBundleErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.MediaBundleErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.MediaBundleErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IMediaBundleErrorEnum} message MediaBundleErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaBundleErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MediaBundleErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.MediaBundleErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.MediaBundleErrorEnum} MediaBundleErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaBundleErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.MediaBundleErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MediaBundleErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.MediaBundleErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.MediaBundleErrorEnum} MediaBundleErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaBundleErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MediaBundleErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.MediaBundleErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MediaBundleErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a MediaBundleErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.MediaBundleErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.MediaBundleErrorEnum} MediaBundleErrorEnum
                         */
                        MediaBundleErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.MediaBundleErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.MediaBundleErrorEnum();
                        };

                        /**
                         * Creates a plain object from a MediaBundleErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.MediaBundleErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.MediaBundleErrorEnum} message MediaBundleErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MediaBundleErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this MediaBundleErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.MediaBundleErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MediaBundleErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * MediaBundleError enum.
                         * @name google.ads.googleads.v1.errors.MediaBundleErrorEnum.MediaBundleError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} BAD_REQUEST=3 BAD_REQUEST value
                         * @property {number} DOUBLECLICK_BUNDLE_NOT_ALLOWED=4 DOUBLECLICK_BUNDLE_NOT_ALLOWED value
                         * @property {number} EXTERNAL_URL_NOT_ALLOWED=5 EXTERNAL_URL_NOT_ALLOWED value
                         * @property {number} FILE_TOO_LARGE=6 FILE_TOO_LARGE value
                         * @property {number} GOOGLE_WEB_DESIGNER_ZIP_FILE_NOT_PUBLISHED=7 GOOGLE_WEB_DESIGNER_ZIP_FILE_NOT_PUBLISHED value
                         * @property {number} INVALID_INPUT=8 INVALID_INPUT value
                         * @property {number} INVALID_MEDIA_BUNDLE=9 INVALID_MEDIA_BUNDLE value
                         * @property {number} INVALID_MEDIA_BUNDLE_ENTRY=10 INVALID_MEDIA_BUNDLE_ENTRY value
                         * @property {number} INVALID_MIME_TYPE=11 INVALID_MIME_TYPE value
                         * @property {number} INVALID_PATH=12 INVALID_PATH value
                         * @property {number} INVALID_URL_REFERENCE=13 INVALID_URL_REFERENCE value
                         * @property {number} MEDIA_DATA_TOO_LARGE=14 MEDIA_DATA_TOO_LARGE value
                         * @property {number} MISSING_PRIMARY_MEDIA_BUNDLE_ENTRY=15 MISSING_PRIMARY_MEDIA_BUNDLE_ENTRY value
                         * @property {number} SERVER_ERROR=16 SERVER_ERROR value
                         * @property {number} STORAGE_ERROR=17 STORAGE_ERROR value
                         * @property {number} SWIFFY_BUNDLE_NOT_ALLOWED=18 SWIFFY_BUNDLE_NOT_ALLOWED value
                         * @property {number} TOO_MANY_FILES=19 TOO_MANY_FILES value
                         * @property {number} UNEXPECTED_SIZE=20 UNEXPECTED_SIZE value
                         * @property {number} UNSUPPORTED_GOOGLE_WEB_DESIGNER_ENVIRONMENT=21 UNSUPPORTED_GOOGLE_WEB_DESIGNER_ENVIRONMENT value
                         * @property {number} UNSUPPORTED_HTML5_FEATURE=22 UNSUPPORTED_HTML5_FEATURE value
                         * @property {number} URL_IN_MEDIA_BUNDLE_NOT_SSL_COMPLIANT=23 URL_IN_MEDIA_BUNDLE_NOT_SSL_COMPLIANT value
                         * @property {number} CUSTOM_EXIT_NOT_ALLOWED=24 CUSTOM_EXIT_NOT_ALLOWED value
                         */
                        MediaBundleErrorEnum.MediaBundleError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[3] = "BAD_REQUEST"] = 3;
                            values[valuesById[4] = "DOUBLECLICK_BUNDLE_NOT_ALLOWED"] = 4;
                            values[valuesById[5] = "EXTERNAL_URL_NOT_ALLOWED"] = 5;
                            values[valuesById[6] = "FILE_TOO_LARGE"] = 6;
                            values[valuesById[7] = "GOOGLE_WEB_DESIGNER_ZIP_FILE_NOT_PUBLISHED"] = 7;
                            values[valuesById[8] = "INVALID_INPUT"] = 8;
                            values[valuesById[9] = "INVALID_MEDIA_BUNDLE"] = 9;
                            values[valuesById[10] = "INVALID_MEDIA_BUNDLE_ENTRY"] = 10;
                            values[valuesById[11] = "INVALID_MIME_TYPE"] = 11;
                            values[valuesById[12] = "INVALID_PATH"] = 12;
                            values[valuesById[13] = "INVALID_URL_REFERENCE"] = 13;
                            values[valuesById[14] = "MEDIA_DATA_TOO_LARGE"] = 14;
                            values[valuesById[15] = "MISSING_PRIMARY_MEDIA_BUNDLE_ENTRY"] = 15;
                            values[valuesById[16] = "SERVER_ERROR"] = 16;
                            values[valuesById[17] = "STORAGE_ERROR"] = 17;
                            values[valuesById[18] = "SWIFFY_BUNDLE_NOT_ALLOWED"] = 18;
                            values[valuesById[19] = "TOO_MANY_FILES"] = 19;
                            values[valuesById[20] = "UNEXPECTED_SIZE"] = 20;
                            values[valuesById[21] = "UNSUPPORTED_GOOGLE_WEB_DESIGNER_ENVIRONMENT"] = 21;
                            values[valuesById[22] = "UNSUPPORTED_HTML5_FEATURE"] = 22;
                            values[valuesById[23] = "URL_IN_MEDIA_BUNDLE_NOT_SSL_COMPLIANT"] = 23;
                            values[valuesById[24] = "CUSTOM_EXIT_NOT_ALLOWED"] = 24;
                            return values;
                        })();

                        return MediaBundleErrorEnum;
                    })();

                    errors.MediaFileErrorEnum = (function() {

                        /**
                         * Properties of a MediaFileErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IMediaFileErrorEnum
                         */

                        /**
                         * Constructs a new MediaFileErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a MediaFileErrorEnum.
                         * @implements IMediaFileErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IMediaFileErrorEnum=} [properties] Properties to set
                         */
                        function MediaFileErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new MediaFileErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.MediaFileErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IMediaFileErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.MediaFileErrorEnum} MediaFileErrorEnum instance
                         */
                        MediaFileErrorEnum.create = function create(properties) {
                            return new MediaFileErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified MediaFileErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.MediaFileErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.MediaFileErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IMediaFileErrorEnum} message MediaFileErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaFileErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified MediaFileErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.MediaFileErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.MediaFileErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IMediaFileErrorEnum} message MediaFileErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaFileErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MediaFileErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.MediaFileErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.MediaFileErrorEnum} MediaFileErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaFileErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.MediaFileErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MediaFileErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.MediaFileErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.MediaFileErrorEnum} MediaFileErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaFileErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MediaFileErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.MediaFileErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MediaFileErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a MediaFileErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.MediaFileErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.MediaFileErrorEnum} MediaFileErrorEnum
                         */
                        MediaFileErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.MediaFileErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.MediaFileErrorEnum();
                        };

                        /**
                         * Creates a plain object from a MediaFileErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.MediaFileErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.MediaFileErrorEnum} message MediaFileErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MediaFileErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this MediaFileErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.MediaFileErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MediaFileErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * MediaFileError enum.
                         * @name google.ads.googleads.v1.errors.MediaFileErrorEnum.MediaFileError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CANNOT_CREATE_STANDARD_ICON=2 CANNOT_CREATE_STANDARD_ICON value
                         * @property {number} CANNOT_SELECT_STANDARD_ICON_WITH_OTHER_TYPES=3 CANNOT_SELECT_STANDARD_ICON_WITH_OTHER_TYPES value
                         * @property {number} CANNOT_SPECIFY_MEDIA_FILE_ID_AND_DATA=4 CANNOT_SPECIFY_MEDIA_FILE_ID_AND_DATA value
                         * @property {number} DUPLICATE_MEDIA=5 DUPLICATE_MEDIA value
                         * @property {number} EMPTY_FIELD=6 EMPTY_FIELD value
                         * @property {number} RESOURCE_REFERENCED_IN_MULTIPLE_OPS=7 RESOURCE_REFERENCED_IN_MULTIPLE_OPS value
                         * @property {number} FIELD_NOT_SUPPORTED_FOR_MEDIA_SUB_TYPE=8 FIELD_NOT_SUPPORTED_FOR_MEDIA_SUB_TYPE value
                         * @property {number} INVALID_MEDIA_FILE_ID=9 INVALID_MEDIA_FILE_ID value
                         * @property {number} INVALID_MEDIA_SUB_TYPE=10 INVALID_MEDIA_SUB_TYPE value
                         * @property {number} INVALID_MEDIA_FILE_TYPE=11 INVALID_MEDIA_FILE_TYPE value
                         * @property {number} INVALID_MIME_TYPE=12 INVALID_MIME_TYPE value
                         * @property {number} INVALID_REFERENCE_ID=13 INVALID_REFERENCE_ID value
                         * @property {number} INVALID_YOU_TUBE_ID=14 INVALID_YOU_TUBE_ID value
                         * @property {number} MEDIA_FILE_FAILED_TRANSCODING=15 MEDIA_FILE_FAILED_TRANSCODING value
                         * @property {number} MEDIA_NOT_TRANSCODED=16 MEDIA_NOT_TRANSCODED value
                         * @property {number} MEDIA_TYPE_DOES_NOT_MATCH_MEDIA_FILE_TYPE=17 MEDIA_TYPE_DOES_NOT_MATCH_MEDIA_FILE_TYPE value
                         * @property {number} NO_FIELDS_SPECIFIED=18 NO_FIELDS_SPECIFIED value
                         * @property {number} NULL_REFERENCE_ID_AND_MEDIA_ID=19 NULL_REFERENCE_ID_AND_MEDIA_ID value
                         * @property {number} TOO_LONG=20 TOO_LONG value
                         * @property {number} UNSUPPORTED_TYPE=21 UNSUPPORTED_TYPE value
                         * @property {number} YOU_TUBE_SERVICE_UNAVAILABLE=22 YOU_TUBE_SERVICE_UNAVAILABLE value
                         * @property {number} YOU_TUBE_VIDEO_HAS_NON_POSITIVE_DURATION=23 YOU_TUBE_VIDEO_HAS_NON_POSITIVE_DURATION value
                         * @property {number} YOU_TUBE_VIDEO_NOT_FOUND=24 YOU_TUBE_VIDEO_NOT_FOUND value
                         */
                        MediaFileErrorEnum.MediaFileError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CANNOT_CREATE_STANDARD_ICON"] = 2;
                            values[valuesById[3] = "CANNOT_SELECT_STANDARD_ICON_WITH_OTHER_TYPES"] = 3;
                            values[valuesById[4] = "CANNOT_SPECIFY_MEDIA_FILE_ID_AND_DATA"] = 4;
                            values[valuesById[5] = "DUPLICATE_MEDIA"] = 5;
                            values[valuesById[6] = "EMPTY_FIELD"] = 6;
                            values[valuesById[7] = "RESOURCE_REFERENCED_IN_MULTIPLE_OPS"] = 7;
                            values[valuesById[8] = "FIELD_NOT_SUPPORTED_FOR_MEDIA_SUB_TYPE"] = 8;
                            values[valuesById[9] = "INVALID_MEDIA_FILE_ID"] = 9;
                            values[valuesById[10] = "INVALID_MEDIA_SUB_TYPE"] = 10;
                            values[valuesById[11] = "INVALID_MEDIA_FILE_TYPE"] = 11;
                            values[valuesById[12] = "INVALID_MIME_TYPE"] = 12;
                            values[valuesById[13] = "INVALID_REFERENCE_ID"] = 13;
                            values[valuesById[14] = "INVALID_YOU_TUBE_ID"] = 14;
                            values[valuesById[15] = "MEDIA_FILE_FAILED_TRANSCODING"] = 15;
                            values[valuesById[16] = "MEDIA_NOT_TRANSCODED"] = 16;
                            values[valuesById[17] = "MEDIA_TYPE_DOES_NOT_MATCH_MEDIA_FILE_TYPE"] = 17;
                            values[valuesById[18] = "NO_FIELDS_SPECIFIED"] = 18;
                            values[valuesById[19] = "NULL_REFERENCE_ID_AND_MEDIA_ID"] = 19;
                            values[valuesById[20] = "TOO_LONG"] = 20;
                            values[valuesById[21] = "UNSUPPORTED_TYPE"] = 21;
                            values[valuesById[22] = "YOU_TUBE_SERVICE_UNAVAILABLE"] = 22;
                            values[valuesById[23] = "YOU_TUBE_VIDEO_HAS_NON_POSITIVE_DURATION"] = 23;
                            values[valuesById[24] = "YOU_TUBE_VIDEO_NOT_FOUND"] = 24;
                            return values;
                        })();

                        return MediaFileErrorEnum;
                    })();

                    errors.MediaUploadErrorEnum = (function() {

                        /**
                         * Properties of a MediaUploadErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IMediaUploadErrorEnum
                         */

                        /**
                         * Constructs a new MediaUploadErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a MediaUploadErrorEnum.
                         * @implements IMediaUploadErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IMediaUploadErrorEnum=} [properties] Properties to set
                         */
                        function MediaUploadErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new MediaUploadErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.MediaUploadErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IMediaUploadErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.MediaUploadErrorEnum} MediaUploadErrorEnum instance
                         */
                        MediaUploadErrorEnum.create = function create(properties) {
                            return new MediaUploadErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified MediaUploadErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.MediaUploadErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.MediaUploadErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IMediaUploadErrorEnum} message MediaUploadErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaUploadErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified MediaUploadErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.MediaUploadErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.MediaUploadErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IMediaUploadErrorEnum} message MediaUploadErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaUploadErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MediaUploadErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.MediaUploadErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.MediaUploadErrorEnum} MediaUploadErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaUploadErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.MediaUploadErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MediaUploadErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.MediaUploadErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.MediaUploadErrorEnum} MediaUploadErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaUploadErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MediaUploadErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.MediaUploadErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MediaUploadErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a MediaUploadErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.MediaUploadErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.MediaUploadErrorEnum} MediaUploadErrorEnum
                         */
                        MediaUploadErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.MediaUploadErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.MediaUploadErrorEnum();
                        };

                        /**
                         * Creates a plain object from a MediaUploadErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.MediaUploadErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.MediaUploadErrorEnum} message MediaUploadErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MediaUploadErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this MediaUploadErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.MediaUploadErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MediaUploadErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * MediaUploadError enum.
                         * @name google.ads.googleads.v1.errors.MediaUploadErrorEnum.MediaUploadError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} FILE_TOO_BIG=2 FILE_TOO_BIG value
                         * @property {number} UNPARSEABLE_IMAGE=3 UNPARSEABLE_IMAGE value
                         * @property {number} ANIMATED_IMAGE_NOT_ALLOWED=4 ANIMATED_IMAGE_NOT_ALLOWED value
                         * @property {number} FORMAT_NOT_ALLOWED=5 FORMAT_NOT_ALLOWED value
                         */
                        MediaUploadErrorEnum.MediaUploadError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "FILE_TOO_BIG"] = 2;
                            values[valuesById[3] = "UNPARSEABLE_IMAGE"] = 3;
                            values[valuesById[4] = "ANIMATED_IMAGE_NOT_ALLOWED"] = 4;
                            values[valuesById[5] = "FORMAT_NOT_ALLOWED"] = 5;
                            return values;
                        })();

                        return MediaUploadErrorEnum;
                    })();

                    errors.MultiplierErrorEnum = (function() {

                        /**
                         * Properties of a MultiplierErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IMultiplierErrorEnum
                         */

                        /**
                         * Constructs a new MultiplierErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a MultiplierErrorEnum.
                         * @implements IMultiplierErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IMultiplierErrorEnum=} [properties] Properties to set
                         */
                        function MultiplierErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new MultiplierErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.MultiplierErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IMultiplierErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.MultiplierErrorEnum} MultiplierErrorEnum instance
                         */
                        MultiplierErrorEnum.create = function create(properties) {
                            return new MultiplierErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified MultiplierErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.MultiplierErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.MultiplierErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IMultiplierErrorEnum} message MultiplierErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MultiplierErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified MultiplierErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.MultiplierErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.MultiplierErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IMultiplierErrorEnum} message MultiplierErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MultiplierErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MultiplierErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.MultiplierErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.MultiplierErrorEnum} MultiplierErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MultiplierErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.MultiplierErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MultiplierErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.MultiplierErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.MultiplierErrorEnum} MultiplierErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MultiplierErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MultiplierErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.MultiplierErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MultiplierErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a MultiplierErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.MultiplierErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.MultiplierErrorEnum} MultiplierErrorEnum
                         */
                        MultiplierErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.MultiplierErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.MultiplierErrorEnum();
                        };

                        /**
                         * Creates a plain object from a MultiplierErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.MultiplierErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.MultiplierErrorEnum} message MultiplierErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MultiplierErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this MultiplierErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.MultiplierErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MultiplierErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * MultiplierError enum.
                         * @name google.ads.googleads.v1.errors.MultiplierErrorEnum.MultiplierError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} MULTIPLIER_TOO_HIGH=2 MULTIPLIER_TOO_HIGH value
                         * @property {number} MULTIPLIER_TOO_LOW=3 MULTIPLIER_TOO_LOW value
                         * @property {number} TOO_MANY_FRACTIONAL_DIGITS=4 TOO_MANY_FRACTIONAL_DIGITS value
                         * @property {number} MULTIPLIER_NOT_ALLOWED_FOR_BIDDING_STRATEGY=5 MULTIPLIER_NOT_ALLOWED_FOR_BIDDING_STRATEGY value
                         * @property {number} MULTIPLIER_NOT_ALLOWED_WHEN_BASE_BID_IS_MISSING=6 MULTIPLIER_NOT_ALLOWED_WHEN_BASE_BID_IS_MISSING value
                         * @property {number} NO_MULTIPLIER_SPECIFIED=7 NO_MULTIPLIER_SPECIFIED value
                         * @property {number} MULTIPLIER_CAUSES_BID_TO_EXCEED_DAILY_BUDGET=8 MULTIPLIER_CAUSES_BID_TO_EXCEED_DAILY_BUDGET value
                         * @property {number} MULTIPLIER_CAUSES_BID_TO_EXCEED_MONTHLY_BUDGET=9 MULTIPLIER_CAUSES_BID_TO_EXCEED_MONTHLY_BUDGET value
                         * @property {number} MULTIPLIER_CAUSES_BID_TO_EXCEED_CUSTOM_BUDGET=10 MULTIPLIER_CAUSES_BID_TO_EXCEED_CUSTOM_BUDGET value
                         * @property {number} MULTIPLIER_CAUSES_BID_TO_EXCEED_MAX_ALLOWED_BID=11 MULTIPLIER_CAUSES_BID_TO_EXCEED_MAX_ALLOWED_BID value
                         * @property {number} BID_LESS_THAN_MIN_ALLOWED_BID_WITH_MULTIPLIER=12 BID_LESS_THAN_MIN_ALLOWED_BID_WITH_MULTIPLIER value
                         * @property {number} MULTIPLIER_AND_BIDDING_STRATEGY_TYPE_MISMATCH=13 MULTIPLIER_AND_BIDDING_STRATEGY_TYPE_MISMATCH value
                         */
                        MultiplierErrorEnum.MultiplierError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "MULTIPLIER_TOO_HIGH"] = 2;
                            values[valuesById[3] = "MULTIPLIER_TOO_LOW"] = 3;
                            values[valuesById[4] = "TOO_MANY_FRACTIONAL_DIGITS"] = 4;
                            values[valuesById[5] = "MULTIPLIER_NOT_ALLOWED_FOR_BIDDING_STRATEGY"] = 5;
                            values[valuesById[6] = "MULTIPLIER_NOT_ALLOWED_WHEN_BASE_BID_IS_MISSING"] = 6;
                            values[valuesById[7] = "NO_MULTIPLIER_SPECIFIED"] = 7;
                            values[valuesById[8] = "MULTIPLIER_CAUSES_BID_TO_EXCEED_DAILY_BUDGET"] = 8;
                            values[valuesById[9] = "MULTIPLIER_CAUSES_BID_TO_EXCEED_MONTHLY_BUDGET"] = 9;
                            values[valuesById[10] = "MULTIPLIER_CAUSES_BID_TO_EXCEED_CUSTOM_BUDGET"] = 10;
                            values[valuesById[11] = "MULTIPLIER_CAUSES_BID_TO_EXCEED_MAX_ALLOWED_BID"] = 11;
                            values[valuesById[12] = "BID_LESS_THAN_MIN_ALLOWED_BID_WITH_MULTIPLIER"] = 12;
                            values[valuesById[13] = "MULTIPLIER_AND_BIDDING_STRATEGY_TYPE_MISMATCH"] = 13;
                            return values;
                        })();

                        return MultiplierErrorEnum;
                    })();

                    errors.MutateErrorEnum = (function() {

                        /**
                         * Properties of a MutateErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IMutateErrorEnum
                         */

                        /**
                         * Constructs a new MutateErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a MutateErrorEnum.
                         * @implements IMutateErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IMutateErrorEnum=} [properties] Properties to set
                         */
                        function MutateErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new MutateErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.MutateErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IMutateErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.MutateErrorEnum} MutateErrorEnum instance
                         */
                        MutateErrorEnum.create = function create(properties) {
                            return new MutateErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified MutateErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.MutateErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.MutateErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IMutateErrorEnum} message MutateErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.MutateErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.MutateErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IMutateErrorEnum} message MutateErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.MutateErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.MutateErrorEnum} MutateErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.MutateErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.MutateErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.MutateErrorEnum} MutateErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.MutateErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a MutateErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.MutateErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.MutateErrorEnum} MutateErrorEnum
                         */
                        MutateErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.MutateErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.MutateErrorEnum();
                        };

                        /**
                         * Creates a plain object from a MutateErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.MutateErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.MutateErrorEnum} message MutateErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this MutateErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.MutateErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * MutateError enum.
                         * @name google.ads.googleads.v1.errors.MutateErrorEnum.MutateError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} RESOURCE_NOT_FOUND=3 RESOURCE_NOT_FOUND value
                         * @property {number} ID_EXISTS_IN_MULTIPLE_MUTATES=7 ID_EXISTS_IN_MULTIPLE_MUTATES value
                         * @property {number} INCONSISTENT_FIELD_VALUES=8 INCONSISTENT_FIELD_VALUES value
                         * @property {number} MUTATE_NOT_ALLOWED=9 MUTATE_NOT_ALLOWED value
                         * @property {number} RESOURCE_NOT_IN_GOOGLE_ADS=10 RESOURCE_NOT_IN_GOOGLE_ADS value
                         * @property {number} RESOURCE_ALREADY_EXISTS=11 RESOURCE_ALREADY_EXISTS value
                         */
                        MutateErrorEnum.MutateError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[3] = "RESOURCE_NOT_FOUND"] = 3;
                            values[valuesById[7] = "ID_EXISTS_IN_MULTIPLE_MUTATES"] = 7;
                            values[valuesById[8] = "INCONSISTENT_FIELD_VALUES"] = 8;
                            values[valuesById[9] = "MUTATE_NOT_ALLOWED"] = 9;
                            values[valuesById[10] = "RESOURCE_NOT_IN_GOOGLE_ADS"] = 10;
                            values[valuesById[11] = "RESOURCE_ALREADY_EXISTS"] = 11;
                            return values;
                        })();

                        return MutateErrorEnum;
                    })();

                    errors.MutateJobErrorEnum = (function() {

                        /**
                         * Properties of a MutateJobErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IMutateJobErrorEnum
                         */

                        /**
                         * Constructs a new MutateJobErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a MutateJobErrorEnum.
                         * @implements IMutateJobErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IMutateJobErrorEnum=} [properties] Properties to set
                         */
                        function MutateJobErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new MutateJobErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.MutateJobErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IMutateJobErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.MutateJobErrorEnum} MutateJobErrorEnum instance
                         */
                        MutateJobErrorEnum.create = function create(properties) {
                            return new MutateJobErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified MutateJobErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.MutateJobErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.MutateJobErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IMutateJobErrorEnum} message MutateJobErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateJobErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateJobErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.MutateJobErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.MutateJobErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IMutateJobErrorEnum} message MutateJobErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateJobErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateJobErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.MutateJobErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.MutateJobErrorEnum} MutateJobErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateJobErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.MutateJobErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateJobErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.MutateJobErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.MutateJobErrorEnum} MutateJobErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateJobErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateJobErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.MutateJobErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateJobErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a MutateJobErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.MutateJobErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.MutateJobErrorEnum} MutateJobErrorEnum
                         */
                        MutateJobErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.MutateJobErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.MutateJobErrorEnum();
                        };

                        /**
                         * Creates a plain object from a MutateJobErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.MutateJobErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.MutateJobErrorEnum} message MutateJobErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateJobErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this MutateJobErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.MutateJobErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateJobErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * MutateJobError enum.
                         * @name google.ads.googleads.v1.errors.MutateJobErrorEnum.MutateJobError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CANNOT_MODIFY_JOB_AFTER_JOB_STARTS_RUNNING=2 CANNOT_MODIFY_JOB_AFTER_JOB_STARTS_RUNNING value
                         * @property {number} EMPTY_OPERATIONS=3 EMPTY_OPERATIONS value
                         * @property {number} INVALID_SEQUENCE_TOKEN=4 INVALID_SEQUENCE_TOKEN value
                         * @property {number} RESULTS_NOT_READY=5 RESULTS_NOT_READY value
                         * @property {number} INVALID_PAGE_SIZE=6 INVALID_PAGE_SIZE value
                         */
                        MutateJobErrorEnum.MutateJobError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CANNOT_MODIFY_JOB_AFTER_JOB_STARTS_RUNNING"] = 2;
                            values[valuesById[3] = "EMPTY_OPERATIONS"] = 3;
                            values[valuesById[4] = "INVALID_SEQUENCE_TOKEN"] = 4;
                            values[valuesById[5] = "RESULTS_NOT_READY"] = 5;
                            values[valuesById[6] = "INVALID_PAGE_SIZE"] = 6;
                            return values;
                        })();

                        return MutateJobErrorEnum;
                    })();

                    errors.NewResourceCreationErrorEnum = (function() {

                        /**
                         * Properties of a NewResourceCreationErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface INewResourceCreationErrorEnum
                         */

                        /**
                         * Constructs a new NewResourceCreationErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a NewResourceCreationErrorEnum.
                         * @implements INewResourceCreationErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.INewResourceCreationErrorEnum=} [properties] Properties to set
                         */
                        function NewResourceCreationErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new NewResourceCreationErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.NewResourceCreationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.INewResourceCreationErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.NewResourceCreationErrorEnum} NewResourceCreationErrorEnum instance
                         */
                        NewResourceCreationErrorEnum.create = function create(properties) {
                            return new NewResourceCreationErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified NewResourceCreationErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.NewResourceCreationErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.NewResourceCreationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.INewResourceCreationErrorEnum} message NewResourceCreationErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NewResourceCreationErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified NewResourceCreationErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.NewResourceCreationErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.NewResourceCreationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.INewResourceCreationErrorEnum} message NewResourceCreationErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NewResourceCreationErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a NewResourceCreationErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.NewResourceCreationErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.NewResourceCreationErrorEnum} NewResourceCreationErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NewResourceCreationErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.NewResourceCreationErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a NewResourceCreationErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.NewResourceCreationErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.NewResourceCreationErrorEnum} NewResourceCreationErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NewResourceCreationErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a NewResourceCreationErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.NewResourceCreationErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NewResourceCreationErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a NewResourceCreationErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.NewResourceCreationErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.NewResourceCreationErrorEnum} NewResourceCreationErrorEnum
                         */
                        NewResourceCreationErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.NewResourceCreationErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.NewResourceCreationErrorEnum();
                        };

                        /**
                         * Creates a plain object from a NewResourceCreationErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.NewResourceCreationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.NewResourceCreationErrorEnum} message NewResourceCreationErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NewResourceCreationErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this NewResourceCreationErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.NewResourceCreationErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NewResourceCreationErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * NewResourceCreationError enum.
                         * @name google.ads.googleads.v1.errors.NewResourceCreationErrorEnum.NewResourceCreationError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CANNOT_SET_ID_FOR_CREATE=2 CANNOT_SET_ID_FOR_CREATE value
                         * @property {number} DUPLICATE_TEMP_IDS=3 DUPLICATE_TEMP_IDS value
                         * @property {number} TEMP_ID_RESOURCE_HAD_ERRORS=4 TEMP_ID_RESOURCE_HAD_ERRORS value
                         */
                        NewResourceCreationErrorEnum.NewResourceCreationError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CANNOT_SET_ID_FOR_CREATE"] = 2;
                            values[valuesById[3] = "DUPLICATE_TEMP_IDS"] = 3;
                            values[valuesById[4] = "TEMP_ID_RESOURCE_HAD_ERRORS"] = 4;
                            return values;
                        })();

                        return NewResourceCreationErrorEnum;
                    })();

                    errors.NotEmptyErrorEnum = (function() {

                        /**
                         * Properties of a NotEmptyErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface INotEmptyErrorEnum
                         */

                        /**
                         * Constructs a new NotEmptyErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a NotEmptyErrorEnum.
                         * @implements INotEmptyErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.INotEmptyErrorEnum=} [properties] Properties to set
                         */
                        function NotEmptyErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new NotEmptyErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.NotEmptyErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.INotEmptyErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.NotEmptyErrorEnum} NotEmptyErrorEnum instance
                         */
                        NotEmptyErrorEnum.create = function create(properties) {
                            return new NotEmptyErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified NotEmptyErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.NotEmptyErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.NotEmptyErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.INotEmptyErrorEnum} message NotEmptyErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NotEmptyErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified NotEmptyErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.NotEmptyErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.NotEmptyErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.INotEmptyErrorEnum} message NotEmptyErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NotEmptyErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a NotEmptyErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.NotEmptyErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.NotEmptyErrorEnum} NotEmptyErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NotEmptyErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.NotEmptyErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a NotEmptyErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.NotEmptyErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.NotEmptyErrorEnum} NotEmptyErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NotEmptyErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a NotEmptyErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.NotEmptyErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NotEmptyErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a NotEmptyErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.NotEmptyErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.NotEmptyErrorEnum} NotEmptyErrorEnum
                         */
                        NotEmptyErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.NotEmptyErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.NotEmptyErrorEnum();
                        };

                        /**
                         * Creates a plain object from a NotEmptyErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.NotEmptyErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.NotEmptyErrorEnum} message NotEmptyErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NotEmptyErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this NotEmptyErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.NotEmptyErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NotEmptyErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * NotEmptyError enum.
                         * @name google.ads.googleads.v1.errors.NotEmptyErrorEnum.NotEmptyError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} EMPTY_LIST=2 EMPTY_LIST value
                         */
                        NotEmptyErrorEnum.NotEmptyError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "EMPTY_LIST"] = 2;
                            return values;
                        })();

                        return NotEmptyErrorEnum;
                    })();

                    errors.NullErrorEnum = (function() {

                        /**
                         * Properties of a NullErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface INullErrorEnum
                         */

                        /**
                         * Constructs a new NullErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a NullErrorEnum.
                         * @implements INullErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.INullErrorEnum=} [properties] Properties to set
                         */
                        function NullErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new NullErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.NullErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.INullErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.NullErrorEnum} NullErrorEnum instance
                         */
                        NullErrorEnum.create = function create(properties) {
                            return new NullErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified NullErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.NullErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.NullErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.INullErrorEnum} message NullErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NullErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified NullErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.NullErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.NullErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.INullErrorEnum} message NullErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NullErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a NullErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.NullErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.NullErrorEnum} NullErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NullErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.NullErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a NullErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.NullErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.NullErrorEnum} NullErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NullErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a NullErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.NullErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NullErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a NullErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.NullErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.NullErrorEnum} NullErrorEnum
                         */
                        NullErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.NullErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.NullErrorEnum();
                        };

                        /**
                         * Creates a plain object from a NullErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.NullErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.NullErrorEnum} message NullErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NullErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this NullErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.NullErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NullErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * NullError enum.
                         * @name google.ads.googleads.v1.errors.NullErrorEnum.NullError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} NULL_CONTENT=2 NULL_CONTENT value
                         */
                        NullErrorEnum.NullError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "NULL_CONTENT"] = 2;
                            return values;
                        })();

                        return NullErrorEnum;
                    })();

                    errors.OperationAccessDeniedErrorEnum = (function() {

                        /**
                         * Properties of an OperationAccessDeniedErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IOperationAccessDeniedErrorEnum
                         */

                        /**
                         * Constructs a new OperationAccessDeniedErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an OperationAccessDeniedErrorEnum.
                         * @implements IOperationAccessDeniedErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IOperationAccessDeniedErrorEnum=} [properties] Properties to set
                         */
                        function OperationAccessDeniedErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new OperationAccessDeniedErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IOperationAccessDeniedErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum} OperationAccessDeniedErrorEnum instance
                         */
                        OperationAccessDeniedErrorEnum.create = function create(properties) {
                            return new OperationAccessDeniedErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified OperationAccessDeniedErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IOperationAccessDeniedErrorEnum} message OperationAccessDeniedErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        OperationAccessDeniedErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified OperationAccessDeniedErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IOperationAccessDeniedErrorEnum} message OperationAccessDeniedErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        OperationAccessDeniedErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an OperationAccessDeniedErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum} OperationAccessDeniedErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        OperationAccessDeniedErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an OperationAccessDeniedErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum} OperationAccessDeniedErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        OperationAccessDeniedErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an OperationAccessDeniedErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        OperationAccessDeniedErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an OperationAccessDeniedErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum} OperationAccessDeniedErrorEnum
                         */
                        OperationAccessDeniedErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum();
                        };

                        /**
                         * Creates a plain object from an OperationAccessDeniedErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum} message OperationAccessDeniedErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        OperationAccessDeniedErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this OperationAccessDeniedErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        OperationAccessDeniedErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * OperationAccessDeniedError enum.
                         * @name google.ads.googleads.v1.errors.OperationAccessDeniedErrorEnum.OperationAccessDeniedError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ACTION_NOT_PERMITTED=2 ACTION_NOT_PERMITTED value
                         * @property {number} CREATE_OPERATION_NOT_PERMITTED=3 CREATE_OPERATION_NOT_PERMITTED value
                         * @property {number} REMOVE_OPERATION_NOT_PERMITTED=4 REMOVE_OPERATION_NOT_PERMITTED value
                         * @property {number} UPDATE_OPERATION_NOT_PERMITTED=5 UPDATE_OPERATION_NOT_PERMITTED value
                         * @property {number} MUTATE_ACTION_NOT_PERMITTED_FOR_CLIENT=6 MUTATE_ACTION_NOT_PERMITTED_FOR_CLIENT value
                         * @property {number} OPERATION_NOT_PERMITTED_FOR_CAMPAIGN_TYPE=7 OPERATION_NOT_PERMITTED_FOR_CAMPAIGN_TYPE value
                         * @property {number} CREATE_AS_REMOVED_NOT_PERMITTED=8 CREATE_AS_REMOVED_NOT_PERMITTED value
                         * @property {number} OPERATION_NOT_PERMITTED_FOR_REMOVED_RESOURCE=9 OPERATION_NOT_PERMITTED_FOR_REMOVED_RESOURCE value
                         * @property {number} OPERATION_NOT_PERMITTED_FOR_AD_GROUP_TYPE=10 OPERATION_NOT_PERMITTED_FOR_AD_GROUP_TYPE value
                         * @property {number} MUTATE_NOT_PERMITTED_FOR_CUSTOMER=11 MUTATE_NOT_PERMITTED_FOR_CUSTOMER value
                         */
                        OperationAccessDeniedErrorEnum.OperationAccessDeniedError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ACTION_NOT_PERMITTED"] = 2;
                            values[valuesById[3] = "CREATE_OPERATION_NOT_PERMITTED"] = 3;
                            values[valuesById[4] = "REMOVE_OPERATION_NOT_PERMITTED"] = 4;
                            values[valuesById[5] = "UPDATE_OPERATION_NOT_PERMITTED"] = 5;
                            values[valuesById[6] = "MUTATE_ACTION_NOT_PERMITTED_FOR_CLIENT"] = 6;
                            values[valuesById[7] = "OPERATION_NOT_PERMITTED_FOR_CAMPAIGN_TYPE"] = 7;
                            values[valuesById[8] = "CREATE_AS_REMOVED_NOT_PERMITTED"] = 8;
                            values[valuesById[9] = "OPERATION_NOT_PERMITTED_FOR_REMOVED_RESOURCE"] = 9;
                            values[valuesById[10] = "OPERATION_NOT_PERMITTED_FOR_AD_GROUP_TYPE"] = 10;
                            values[valuesById[11] = "MUTATE_NOT_PERMITTED_FOR_CUSTOMER"] = 11;
                            return values;
                        })();

                        return OperationAccessDeniedErrorEnum;
                    })();

                    errors.OperatorErrorEnum = (function() {

                        /**
                         * Properties of an OperatorErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IOperatorErrorEnum
                         */

                        /**
                         * Constructs a new OperatorErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an OperatorErrorEnum.
                         * @implements IOperatorErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IOperatorErrorEnum=} [properties] Properties to set
                         */
                        function OperatorErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new OperatorErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.OperatorErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IOperatorErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.OperatorErrorEnum} OperatorErrorEnum instance
                         */
                        OperatorErrorEnum.create = function create(properties) {
                            return new OperatorErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified OperatorErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.OperatorErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.OperatorErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IOperatorErrorEnum} message OperatorErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        OperatorErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified OperatorErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.OperatorErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.OperatorErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IOperatorErrorEnum} message OperatorErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        OperatorErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an OperatorErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.OperatorErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.OperatorErrorEnum} OperatorErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        OperatorErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.OperatorErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an OperatorErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.OperatorErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.OperatorErrorEnum} OperatorErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        OperatorErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an OperatorErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.OperatorErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        OperatorErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an OperatorErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.OperatorErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.OperatorErrorEnum} OperatorErrorEnum
                         */
                        OperatorErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.OperatorErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.OperatorErrorEnum();
                        };

                        /**
                         * Creates a plain object from an OperatorErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.OperatorErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.OperatorErrorEnum} message OperatorErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        OperatorErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this OperatorErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.OperatorErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        OperatorErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * OperatorError enum.
                         * @name google.ads.googleads.v1.errors.OperatorErrorEnum.OperatorError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} OPERATOR_NOT_SUPPORTED=2 OPERATOR_NOT_SUPPORTED value
                         */
                        OperatorErrorEnum.OperatorError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "OPERATOR_NOT_SUPPORTED"] = 2;
                            return values;
                        })();

                        return OperatorErrorEnum;
                    })();

                    errors.PartialFailureErrorEnum = (function() {

                        /**
                         * Properties of a PartialFailureErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IPartialFailureErrorEnum
                         */

                        /**
                         * Constructs a new PartialFailureErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a PartialFailureErrorEnum.
                         * @implements IPartialFailureErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IPartialFailureErrorEnum=} [properties] Properties to set
                         */
                        function PartialFailureErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PartialFailureErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.PartialFailureErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IPartialFailureErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.PartialFailureErrorEnum} PartialFailureErrorEnum instance
                         */
                        PartialFailureErrorEnum.create = function create(properties) {
                            return new PartialFailureErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified PartialFailureErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.PartialFailureErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.PartialFailureErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IPartialFailureErrorEnum} message PartialFailureErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PartialFailureErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PartialFailureErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.PartialFailureErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.PartialFailureErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IPartialFailureErrorEnum} message PartialFailureErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PartialFailureErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PartialFailureErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.PartialFailureErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.PartialFailureErrorEnum} PartialFailureErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PartialFailureErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.PartialFailureErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PartialFailureErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.PartialFailureErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.PartialFailureErrorEnum} PartialFailureErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PartialFailureErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PartialFailureErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.PartialFailureErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PartialFailureErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PartialFailureErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.PartialFailureErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.PartialFailureErrorEnum} PartialFailureErrorEnum
                         */
                        PartialFailureErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.PartialFailureErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.PartialFailureErrorEnum();
                        };

                        /**
                         * Creates a plain object from a PartialFailureErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.PartialFailureErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.PartialFailureErrorEnum} message PartialFailureErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PartialFailureErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PartialFailureErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.PartialFailureErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PartialFailureErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PartialFailureError enum.
                         * @name google.ads.googleads.v1.errors.PartialFailureErrorEnum.PartialFailureError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} PARTIAL_FAILURE_MODE_REQUIRED=2 PARTIAL_FAILURE_MODE_REQUIRED value
                         */
                        PartialFailureErrorEnum.PartialFailureError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "PARTIAL_FAILURE_MODE_REQUIRED"] = 2;
                            return values;
                        })();

                        return PartialFailureErrorEnum;
                    })();

                    errors.PolicyFindingErrorEnum = (function() {

                        /**
                         * Properties of a PolicyFindingErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IPolicyFindingErrorEnum
                         */

                        /**
                         * Constructs a new PolicyFindingErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a PolicyFindingErrorEnum.
                         * @implements IPolicyFindingErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IPolicyFindingErrorEnum=} [properties] Properties to set
                         */
                        function PolicyFindingErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PolicyFindingErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IPolicyFindingErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.PolicyFindingErrorEnum} PolicyFindingErrorEnum instance
                         */
                        PolicyFindingErrorEnum.create = function create(properties) {
                            return new PolicyFindingErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified PolicyFindingErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.PolicyFindingErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IPolicyFindingErrorEnum} message PolicyFindingErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyFindingErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PolicyFindingErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.PolicyFindingErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IPolicyFindingErrorEnum} message PolicyFindingErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyFindingErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PolicyFindingErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.PolicyFindingErrorEnum} PolicyFindingErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyFindingErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.PolicyFindingErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PolicyFindingErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.PolicyFindingErrorEnum} PolicyFindingErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyFindingErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PolicyFindingErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PolicyFindingErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PolicyFindingErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.PolicyFindingErrorEnum} PolicyFindingErrorEnum
                         */
                        PolicyFindingErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.PolicyFindingErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.PolicyFindingErrorEnum();
                        };

                        /**
                         * Creates a plain object from a PolicyFindingErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.PolicyFindingErrorEnum} message PolicyFindingErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PolicyFindingErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PolicyFindingErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.PolicyFindingErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PolicyFindingErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PolicyFindingError enum.
                         * @name google.ads.googleads.v1.errors.PolicyFindingErrorEnum.PolicyFindingError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} POLICY_FINDING=2 POLICY_FINDING value
                         * @property {number} POLICY_TOPIC_NOT_FOUND=3 POLICY_TOPIC_NOT_FOUND value
                         */
                        PolicyFindingErrorEnum.PolicyFindingError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "POLICY_FINDING"] = 2;
                            values[valuesById[3] = "POLICY_TOPIC_NOT_FOUND"] = 3;
                            return values;
                        })();

                        return PolicyFindingErrorEnum;
                    })();

                    errors.PolicyValidationParameterErrorEnum = (function() {

                        /**
                         * Properties of a PolicyValidationParameterErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IPolicyValidationParameterErrorEnum
                         */

                        /**
                         * Constructs a new PolicyValidationParameterErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a PolicyValidationParameterErrorEnum.
                         * @implements IPolicyValidationParameterErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IPolicyValidationParameterErrorEnum=} [properties] Properties to set
                         */
                        function PolicyValidationParameterErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PolicyValidationParameterErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IPolicyValidationParameterErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum} PolicyValidationParameterErrorEnum instance
                         */
                        PolicyValidationParameterErrorEnum.create = function create(properties) {
                            return new PolicyValidationParameterErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified PolicyValidationParameterErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IPolicyValidationParameterErrorEnum} message PolicyValidationParameterErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyValidationParameterErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PolicyValidationParameterErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IPolicyValidationParameterErrorEnum} message PolicyValidationParameterErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyValidationParameterErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PolicyValidationParameterErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum} PolicyValidationParameterErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyValidationParameterErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PolicyValidationParameterErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum} PolicyValidationParameterErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyValidationParameterErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PolicyValidationParameterErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PolicyValidationParameterErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PolicyValidationParameterErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum} PolicyValidationParameterErrorEnum
                         */
                        PolicyValidationParameterErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum();
                        };

                        /**
                         * Creates a plain object from a PolicyValidationParameterErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum} message PolicyValidationParameterErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PolicyValidationParameterErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PolicyValidationParameterErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PolicyValidationParameterErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PolicyValidationParameterError enum.
                         * @name google.ads.googleads.v1.errors.PolicyValidationParameterErrorEnum.PolicyValidationParameterError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} UNSUPPORTED_AD_TYPE_FOR_IGNORABLE_POLICY_TOPICS=2 UNSUPPORTED_AD_TYPE_FOR_IGNORABLE_POLICY_TOPICS value
                         * @property {number} UNSUPPORTED_AD_TYPE_FOR_EXEMPT_POLICY_VIOLATION_KEYS=3 UNSUPPORTED_AD_TYPE_FOR_EXEMPT_POLICY_VIOLATION_KEYS value
                         * @property {number} CANNOT_SET_BOTH_IGNORABLE_POLICY_TOPICS_AND_EXEMPT_POLICY_VIOLATION_KEYS=4 CANNOT_SET_BOTH_IGNORABLE_POLICY_TOPICS_AND_EXEMPT_POLICY_VIOLATION_KEYS value
                         */
                        PolicyValidationParameterErrorEnum.PolicyValidationParameterError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "UNSUPPORTED_AD_TYPE_FOR_IGNORABLE_POLICY_TOPICS"] = 2;
                            values[valuesById[3] = "UNSUPPORTED_AD_TYPE_FOR_EXEMPT_POLICY_VIOLATION_KEYS"] = 3;
                            values[valuesById[4] = "CANNOT_SET_BOTH_IGNORABLE_POLICY_TOPICS_AND_EXEMPT_POLICY_VIOLATION_KEYS"] = 4;
                            return values;
                        })();

                        return PolicyValidationParameterErrorEnum;
                    })();

                    errors.PolicyViolationErrorEnum = (function() {

                        /**
                         * Properties of a PolicyViolationErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IPolicyViolationErrorEnum
                         */

                        /**
                         * Constructs a new PolicyViolationErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a PolicyViolationErrorEnum.
                         * @implements IPolicyViolationErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IPolicyViolationErrorEnum=} [properties] Properties to set
                         */
                        function PolicyViolationErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PolicyViolationErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IPolicyViolationErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.PolicyViolationErrorEnum} PolicyViolationErrorEnum instance
                         */
                        PolicyViolationErrorEnum.create = function create(properties) {
                            return new PolicyViolationErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified PolicyViolationErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.PolicyViolationErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IPolicyViolationErrorEnum} message PolicyViolationErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyViolationErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PolicyViolationErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.PolicyViolationErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IPolicyViolationErrorEnum} message PolicyViolationErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyViolationErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PolicyViolationErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.PolicyViolationErrorEnum} PolicyViolationErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyViolationErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.PolicyViolationErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PolicyViolationErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.PolicyViolationErrorEnum} PolicyViolationErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyViolationErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PolicyViolationErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PolicyViolationErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PolicyViolationErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.PolicyViolationErrorEnum} PolicyViolationErrorEnum
                         */
                        PolicyViolationErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.PolicyViolationErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.PolicyViolationErrorEnum();
                        };

                        /**
                         * Creates a plain object from a PolicyViolationErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.PolicyViolationErrorEnum} message PolicyViolationErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PolicyViolationErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PolicyViolationErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.PolicyViolationErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PolicyViolationErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PolicyViolationError enum.
                         * @name google.ads.googleads.v1.errors.PolicyViolationErrorEnum.PolicyViolationError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} POLICY_ERROR=2 POLICY_ERROR value
                         */
                        PolicyViolationErrorEnum.PolicyViolationError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "POLICY_ERROR"] = 2;
                            return values;
                        })();

                        return PolicyViolationErrorEnum;
                    })();

                    errors.QueryErrorEnum = (function() {

                        /**
                         * Properties of a QueryErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IQueryErrorEnum
                         */

                        /**
                         * Constructs a new QueryErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a QueryErrorEnum.
                         * @implements IQueryErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IQueryErrorEnum=} [properties] Properties to set
                         */
                        function QueryErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new QueryErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.QueryErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IQueryErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.QueryErrorEnum} QueryErrorEnum instance
                         */
                        QueryErrorEnum.create = function create(properties) {
                            return new QueryErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified QueryErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.QueryErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.QueryErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IQueryErrorEnum} message QueryErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        QueryErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified QueryErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.QueryErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.QueryErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IQueryErrorEnum} message QueryErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        QueryErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a QueryErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.QueryErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.QueryErrorEnum} QueryErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        QueryErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.QueryErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a QueryErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.QueryErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.QueryErrorEnum} QueryErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        QueryErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a QueryErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.QueryErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        QueryErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a QueryErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.QueryErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.QueryErrorEnum} QueryErrorEnum
                         */
                        QueryErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.QueryErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.QueryErrorEnum();
                        };

                        /**
                         * Creates a plain object from a QueryErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.QueryErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.QueryErrorEnum} message QueryErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        QueryErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this QueryErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.QueryErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        QueryErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * QueryError enum.
                         * @name google.ads.googleads.v1.errors.QueryErrorEnum.QueryError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} QUERY_ERROR=50 QUERY_ERROR value
                         * @property {number} BAD_ENUM_CONSTANT=18 BAD_ENUM_CONSTANT value
                         * @property {number} BAD_ESCAPE_SEQUENCE=7 BAD_ESCAPE_SEQUENCE value
                         * @property {number} BAD_FIELD_NAME=12 BAD_FIELD_NAME value
                         * @property {number} BAD_LIMIT_VALUE=15 BAD_LIMIT_VALUE value
                         * @property {number} BAD_NUMBER=5 BAD_NUMBER value
                         * @property {number} BAD_OPERATOR=3 BAD_OPERATOR value
                         * @property {number} BAD_PARAMETER_NAME=61 BAD_PARAMETER_NAME value
                         * @property {number} BAD_PARAMETER_VALUE=62 BAD_PARAMETER_VALUE value
                         * @property {number} BAD_RESOURCE_TYPE_IN_FROM_CLAUSE=45 BAD_RESOURCE_TYPE_IN_FROM_CLAUSE value
                         * @property {number} BAD_SYMBOL=2 BAD_SYMBOL value
                         * @property {number} BAD_VALUE=4 BAD_VALUE value
                         * @property {number} DATE_RANGE_TOO_WIDE=36 DATE_RANGE_TOO_WIDE value
                         * @property {number} EXPECTED_AND=30 EXPECTED_AND value
                         * @property {number} EXPECTED_BY=14 EXPECTED_BY value
                         * @property {number} EXPECTED_DIMENSION_FIELD_IN_SELECT_CLAUSE=37 EXPECTED_DIMENSION_FIELD_IN_SELECT_CLAUSE value
                         * @property {number} EXPECTED_FILTERS_ON_DATE_RANGE=55 EXPECTED_FILTERS_ON_DATE_RANGE value
                         * @property {number} EXPECTED_FROM=44 EXPECTED_FROM value
                         * @property {number} EXPECTED_LIST=41 EXPECTED_LIST value
                         * @property {number} EXPECTED_REFERENCED_FIELD_IN_SELECT_CLAUSE=16 EXPECTED_REFERENCED_FIELD_IN_SELECT_CLAUSE value
                         * @property {number} EXPECTED_SELECT=13 EXPECTED_SELECT value
                         * @property {number} EXPECTED_SINGLE_VALUE=42 EXPECTED_SINGLE_VALUE value
                         * @property {number} EXPECTED_VALUE_WITH_BETWEEN_OPERATOR=29 EXPECTED_VALUE_WITH_BETWEEN_OPERATOR value
                         * @property {number} INVALID_DATE_FORMAT=38 INVALID_DATE_FORMAT value
                         * @property {number} INVALID_STRING_VALUE=57 INVALID_STRING_VALUE value
                         * @property {number} INVALID_VALUE_WITH_BETWEEN_OPERATOR=26 INVALID_VALUE_WITH_BETWEEN_OPERATOR value
                         * @property {number} INVALID_VALUE_WITH_DURING_OPERATOR=22 INVALID_VALUE_WITH_DURING_OPERATOR value
                         * @property {number} INVALID_VALUE_WITH_LIKE_OPERATOR=56 INVALID_VALUE_WITH_LIKE_OPERATOR value
                         * @property {number} OPERATOR_FIELD_MISMATCH=35 OPERATOR_FIELD_MISMATCH value
                         * @property {number} PROHIBITED_EMPTY_LIST_IN_CONDITION=28 PROHIBITED_EMPTY_LIST_IN_CONDITION value
                         * @property {number} PROHIBITED_ENUM_CONSTANT=54 PROHIBITED_ENUM_CONSTANT value
                         * @property {number} PROHIBITED_FIELD_COMBINATION_IN_SELECT_CLAUSE=31 PROHIBITED_FIELD_COMBINATION_IN_SELECT_CLAUSE value
                         * @property {number} PROHIBITED_FIELD_IN_ORDER_BY_CLAUSE=40 PROHIBITED_FIELD_IN_ORDER_BY_CLAUSE value
                         * @property {number} PROHIBITED_FIELD_IN_SELECT_CLAUSE=23 PROHIBITED_FIELD_IN_SELECT_CLAUSE value
                         * @property {number} PROHIBITED_FIELD_IN_WHERE_CLAUSE=24 PROHIBITED_FIELD_IN_WHERE_CLAUSE value
                         * @property {number} PROHIBITED_RESOURCE_TYPE_IN_FROM_CLAUSE=43 PROHIBITED_RESOURCE_TYPE_IN_FROM_CLAUSE value
                         * @property {number} PROHIBITED_RESOURCE_TYPE_IN_SELECT_CLAUSE=48 PROHIBITED_RESOURCE_TYPE_IN_SELECT_CLAUSE value
                         * @property {number} PROHIBITED_RESOURCE_TYPE_IN_WHERE_CLAUSE=58 PROHIBITED_RESOURCE_TYPE_IN_WHERE_CLAUSE value
                         * @property {number} PROHIBITED_METRIC_IN_SELECT_OR_WHERE_CLAUSE=49 PROHIBITED_METRIC_IN_SELECT_OR_WHERE_CLAUSE value
                         * @property {number} PROHIBITED_SEGMENT_IN_SELECT_OR_WHERE_CLAUSE=51 PROHIBITED_SEGMENT_IN_SELECT_OR_WHERE_CLAUSE value
                         * @property {number} PROHIBITED_SEGMENT_WITH_METRIC_IN_SELECT_OR_WHERE_CLAUSE=53 PROHIBITED_SEGMENT_WITH_METRIC_IN_SELECT_OR_WHERE_CLAUSE value
                         * @property {number} LIMIT_VALUE_TOO_LOW=25 LIMIT_VALUE_TOO_LOW value
                         * @property {number} PROHIBITED_NEWLINE_IN_STRING=8 PROHIBITED_NEWLINE_IN_STRING value
                         * @property {number} PROHIBITED_VALUE_COMBINATION_IN_LIST=10 PROHIBITED_VALUE_COMBINATION_IN_LIST value
                         * @property {number} PROHIBITED_VALUE_COMBINATION_WITH_BETWEEN_OPERATOR=21 PROHIBITED_VALUE_COMBINATION_WITH_BETWEEN_OPERATOR value
                         * @property {number} STRING_NOT_TERMINATED=6 STRING_NOT_TERMINATED value
                         * @property {number} TOO_MANY_SEGMENTS=34 TOO_MANY_SEGMENTS value
                         * @property {number} UNEXPECTED_END_OF_QUERY=9 UNEXPECTED_END_OF_QUERY value
                         * @property {number} UNEXPECTED_FROM_CLAUSE=47 UNEXPECTED_FROM_CLAUSE value
                         * @property {number} UNRECOGNIZED_FIELD=32 UNRECOGNIZED_FIELD value
                         * @property {number} UNEXPECTED_INPUT=11 UNEXPECTED_INPUT value
                         * @property {number} REQUESTED_METRICS_FOR_MANAGER=59 REQUESTED_METRICS_FOR_MANAGER value
                         */
                        QueryErrorEnum.QueryError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[50] = "QUERY_ERROR"] = 50;
                            values[valuesById[18] = "BAD_ENUM_CONSTANT"] = 18;
                            values[valuesById[7] = "BAD_ESCAPE_SEQUENCE"] = 7;
                            values[valuesById[12] = "BAD_FIELD_NAME"] = 12;
                            values[valuesById[15] = "BAD_LIMIT_VALUE"] = 15;
                            values[valuesById[5] = "BAD_NUMBER"] = 5;
                            values[valuesById[3] = "BAD_OPERATOR"] = 3;
                            values[valuesById[61] = "BAD_PARAMETER_NAME"] = 61;
                            values[valuesById[62] = "BAD_PARAMETER_VALUE"] = 62;
                            values[valuesById[45] = "BAD_RESOURCE_TYPE_IN_FROM_CLAUSE"] = 45;
                            values[valuesById[2] = "BAD_SYMBOL"] = 2;
                            values[valuesById[4] = "BAD_VALUE"] = 4;
                            values[valuesById[36] = "DATE_RANGE_TOO_WIDE"] = 36;
                            values[valuesById[30] = "EXPECTED_AND"] = 30;
                            values[valuesById[14] = "EXPECTED_BY"] = 14;
                            values[valuesById[37] = "EXPECTED_DIMENSION_FIELD_IN_SELECT_CLAUSE"] = 37;
                            values[valuesById[55] = "EXPECTED_FILTERS_ON_DATE_RANGE"] = 55;
                            values[valuesById[44] = "EXPECTED_FROM"] = 44;
                            values[valuesById[41] = "EXPECTED_LIST"] = 41;
                            values[valuesById[16] = "EXPECTED_REFERENCED_FIELD_IN_SELECT_CLAUSE"] = 16;
                            values[valuesById[13] = "EXPECTED_SELECT"] = 13;
                            values[valuesById[42] = "EXPECTED_SINGLE_VALUE"] = 42;
                            values[valuesById[29] = "EXPECTED_VALUE_WITH_BETWEEN_OPERATOR"] = 29;
                            values[valuesById[38] = "INVALID_DATE_FORMAT"] = 38;
                            values[valuesById[57] = "INVALID_STRING_VALUE"] = 57;
                            values[valuesById[26] = "INVALID_VALUE_WITH_BETWEEN_OPERATOR"] = 26;
                            values[valuesById[22] = "INVALID_VALUE_WITH_DURING_OPERATOR"] = 22;
                            values[valuesById[56] = "INVALID_VALUE_WITH_LIKE_OPERATOR"] = 56;
                            values[valuesById[35] = "OPERATOR_FIELD_MISMATCH"] = 35;
                            values[valuesById[28] = "PROHIBITED_EMPTY_LIST_IN_CONDITION"] = 28;
                            values[valuesById[54] = "PROHIBITED_ENUM_CONSTANT"] = 54;
                            values[valuesById[31] = "PROHIBITED_FIELD_COMBINATION_IN_SELECT_CLAUSE"] = 31;
                            values[valuesById[40] = "PROHIBITED_FIELD_IN_ORDER_BY_CLAUSE"] = 40;
                            values[valuesById[23] = "PROHIBITED_FIELD_IN_SELECT_CLAUSE"] = 23;
                            values[valuesById[24] = "PROHIBITED_FIELD_IN_WHERE_CLAUSE"] = 24;
                            values[valuesById[43] = "PROHIBITED_RESOURCE_TYPE_IN_FROM_CLAUSE"] = 43;
                            values[valuesById[48] = "PROHIBITED_RESOURCE_TYPE_IN_SELECT_CLAUSE"] = 48;
                            values[valuesById[58] = "PROHIBITED_RESOURCE_TYPE_IN_WHERE_CLAUSE"] = 58;
                            values[valuesById[49] = "PROHIBITED_METRIC_IN_SELECT_OR_WHERE_CLAUSE"] = 49;
                            values[valuesById[51] = "PROHIBITED_SEGMENT_IN_SELECT_OR_WHERE_CLAUSE"] = 51;
                            values[valuesById[53] = "PROHIBITED_SEGMENT_WITH_METRIC_IN_SELECT_OR_WHERE_CLAUSE"] = 53;
                            values[valuesById[25] = "LIMIT_VALUE_TOO_LOW"] = 25;
                            values[valuesById[8] = "PROHIBITED_NEWLINE_IN_STRING"] = 8;
                            values[valuesById[10] = "PROHIBITED_VALUE_COMBINATION_IN_LIST"] = 10;
                            values[valuesById[21] = "PROHIBITED_VALUE_COMBINATION_WITH_BETWEEN_OPERATOR"] = 21;
                            values[valuesById[6] = "STRING_NOT_TERMINATED"] = 6;
                            values[valuesById[34] = "TOO_MANY_SEGMENTS"] = 34;
                            values[valuesById[9] = "UNEXPECTED_END_OF_QUERY"] = 9;
                            values[valuesById[47] = "UNEXPECTED_FROM_CLAUSE"] = 47;
                            values[valuesById[32] = "UNRECOGNIZED_FIELD"] = 32;
                            values[valuesById[11] = "UNEXPECTED_INPUT"] = 11;
                            values[valuesById[59] = "REQUESTED_METRICS_FOR_MANAGER"] = 59;
                            return values;
                        })();

                        return QueryErrorEnum;
                    })();

                    errors.QuotaErrorEnum = (function() {

                        /**
                         * Properties of a QuotaErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IQuotaErrorEnum
                         */

                        /**
                         * Constructs a new QuotaErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a QuotaErrorEnum.
                         * @implements IQuotaErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IQuotaErrorEnum=} [properties] Properties to set
                         */
                        function QuotaErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new QuotaErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.QuotaErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IQuotaErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.QuotaErrorEnum} QuotaErrorEnum instance
                         */
                        QuotaErrorEnum.create = function create(properties) {
                            return new QuotaErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified QuotaErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.QuotaErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.QuotaErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IQuotaErrorEnum} message QuotaErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        QuotaErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified QuotaErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.QuotaErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.QuotaErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IQuotaErrorEnum} message QuotaErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        QuotaErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a QuotaErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.QuotaErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.QuotaErrorEnum} QuotaErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        QuotaErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.QuotaErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a QuotaErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.QuotaErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.QuotaErrorEnum} QuotaErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        QuotaErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a QuotaErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.QuotaErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        QuotaErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a QuotaErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.QuotaErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.QuotaErrorEnum} QuotaErrorEnum
                         */
                        QuotaErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.QuotaErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.QuotaErrorEnum();
                        };

                        /**
                         * Creates a plain object from a QuotaErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.QuotaErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.QuotaErrorEnum} message QuotaErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        QuotaErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this QuotaErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.QuotaErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        QuotaErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * QuotaError enum.
                         * @name google.ads.googleads.v1.errors.QuotaErrorEnum.QuotaError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} RESOURCE_EXHAUSTED=2 RESOURCE_EXHAUSTED value
                         * @property {number} ACCESS_PROHIBITED=3 ACCESS_PROHIBITED value
                         * @property {number} RESOURCE_TEMPORARILY_EXHAUSTED=4 RESOURCE_TEMPORARILY_EXHAUSTED value
                         */
                        QuotaErrorEnum.QuotaError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "RESOURCE_EXHAUSTED"] = 2;
                            values[valuesById[3] = "ACCESS_PROHIBITED"] = 3;
                            values[valuesById[4] = "RESOURCE_TEMPORARILY_EXHAUSTED"] = 4;
                            return values;
                        })();

                        return QuotaErrorEnum;
                    })();

                    errors.RangeErrorEnum = (function() {

                        /**
                         * Properties of a RangeErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IRangeErrorEnum
                         */

                        /**
                         * Constructs a new RangeErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a RangeErrorEnum.
                         * @implements IRangeErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IRangeErrorEnum=} [properties] Properties to set
                         */
                        function RangeErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new RangeErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.RangeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IRangeErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.RangeErrorEnum} RangeErrorEnum instance
                         */
                        RangeErrorEnum.create = function create(properties) {
                            return new RangeErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified RangeErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.RangeErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.RangeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IRangeErrorEnum} message RangeErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RangeErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified RangeErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.RangeErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.RangeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IRangeErrorEnum} message RangeErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RangeErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a RangeErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.RangeErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.RangeErrorEnum} RangeErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RangeErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.RangeErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a RangeErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.RangeErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.RangeErrorEnum} RangeErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RangeErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a RangeErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.RangeErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RangeErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a RangeErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.RangeErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.RangeErrorEnum} RangeErrorEnum
                         */
                        RangeErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.RangeErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.RangeErrorEnum();
                        };

                        /**
                         * Creates a plain object from a RangeErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.RangeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.RangeErrorEnum} message RangeErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RangeErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this RangeErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.RangeErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RangeErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * RangeError enum.
                         * @name google.ads.googleads.v1.errors.RangeErrorEnum.RangeError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} TOO_LOW=2 TOO_LOW value
                         * @property {number} TOO_HIGH=3 TOO_HIGH value
                         */
                        RangeErrorEnum.RangeError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "TOO_LOW"] = 2;
                            values[valuesById[3] = "TOO_HIGH"] = 3;
                            return values;
                        })();

                        return RangeErrorEnum;
                    })();

                    errors.RecommendationErrorEnum = (function() {

                        /**
                         * Properties of a RecommendationErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IRecommendationErrorEnum
                         */

                        /**
                         * Constructs a new RecommendationErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a RecommendationErrorEnum.
                         * @implements IRecommendationErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IRecommendationErrorEnum=} [properties] Properties to set
                         */
                        function RecommendationErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new RecommendationErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.RecommendationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IRecommendationErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.RecommendationErrorEnum} RecommendationErrorEnum instance
                         */
                        RecommendationErrorEnum.create = function create(properties) {
                            return new RecommendationErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified RecommendationErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.RecommendationErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.RecommendationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IRecommendationErrorEnum} message RecommendationErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RecommendationErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified RecommendationErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.RecommendationErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.RecommendationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IRecommendationErrorEnum} message RecommendationErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RecommendationErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a RecommendationErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.RecommendationErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.RecommendationErrorEnum} RecommendationErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RecommendationErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.RecommendationErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a RecommendationErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.RecommendationErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.RecommendationErrorEnum} RecommendationErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RecommendationErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a RecommendationErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.RecommendationErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RecommendationErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a RecommendationErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.RecommendationErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.RecommendationErrorEnum} RecommendationErrorEnum
                         */
                        RecommendationErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.RecommendationErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.RecommendationErrorEnum();
                        };

                        /**
                         * Creates a plain object from a RecommendationErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.RecommendationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.RecommendationErrorEnum} message RecommendationErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RecommendationErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this RecommendationErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.RecommendationErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RecommendationErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * RecommendationError enum.
                         * @name google.ads.googleads.v1.errors.RecommendationErrorEnum.RecommendationError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} BUDGET_AMOUNT_TOO_SMALL=2 BUDGET_AMOUNT_TOO_SMALL value
                         * @property {number} BUDGET_AMOUNT_TOO_LARGE=3 BUDGET_AMOUNT_TOO_LARGE value
                         * @property {number} INVALID_BUDGET_AMOUNT=4 INVALID_BUDGET_AMOUNT value
                         * @property {number} POLICY_ERROR=5 POLICY_ERROR value
                         * @property {number} INVALID_BID_AMOUNT=6 INVALID_BID_AMOUNT value
                         * @property {number} ADGROUP_KEYWORD_LIMIT=7 ADGROUP_KEYWORD_LIMIT value
                         * @property {number} RECOMMENDATION_ALREADY_APPLIED=8 RECOMMENDATION_ALREADY_APPLIED value
                         * @property {number} RECOMMENDATION_INVALIDATED=9 RECOMMENDATION_INVALIDATED value
                         * @property {number} TOO_MANY_OPERATIONS=10 TOO_MANY_OPERATIONS value
                         * @property {number} NO_OPERATIONS=11 NO_OPERATIONS value
                         * @property {number} DIFFERENT_TYPES_NOT_SUPPORTED=12 DIFFERENT_TYPES_NOT_SUPPORTED value
                         * @property {number} DUPLICATE_RESOURCE_NAME=13 DUPLICATE_RESOURCE_NAME value
                         * @property {number} RECOMMENDATION_ALREADY_DISMISSED=14 RECOMMENDATION_ALREADY_DISMISSED value
                         * @property {number} INVALID_APPLY_REQUEST=15 INVALID_APPLY_REQUEST value
                         */
                        RecommendationErrorEnum.RecommendationError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "BUDGET_AMOUNT_TOO_SMALL"] = 2;
                            values[valuesById[3] = "BUDGET_AMOUNT_TOO_LARGE"] = 3;
                            values[valuesById[4] = "INVALID_BUDGET_AMOUNT"] = 4;
                            values[valuesById[5] = "POLICY_ERROR"] = 5;
                            values[valuesById[6] = "INVALID_BID_AMOUNT"] = 6;
                            values[valuesById[7] = "ADGROUP_KEYWORD_LIMIT"] = 7;
                            values[valuesById[8] = "RECOMMENDATION_ALREADY_APPLIED"] = 8;
                            values[valuesById[9] = "RECOMMENDATION_INVALIDATED"] = 9;
                            values[valuesById[10] = "TOO_MANY_OPERATIONS"] = 10;
                            values[valuesById[11] = "NO_OPERATIONS"] = 11;
                            values[valuesById[12] = "DIFFERENT_TYPES_NOT_SUPPORTED"] = 12;
                            values[valuesById[13] = "DUPLICATE_RESOURCE_NAME"] = 13;
                            values[valuesById[14] = "RECOMMENDATION_ALREADY_DISMISSED"] = 14;
                            values[valuesById[15] = "INVALID_APPLY_REQUEST"] = 15;
                            return values;
                        })();

                        return RecommendationErrorEnum;
                    })();

                    errors.RegionCodeErrorEnum = (function() {

                        /**
                         * Properties of a RegionCodeErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IRegionCodeErrorEnum
                         */

                        /**
                         * Constructs a new RegionCodeErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a RegionCodeErrorEnum.
                         * @implements IRegionCodeErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IRegionCodeErrorEnum=} [properties] Properties to set
                         */
                        function RegionCodeErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new RegionCodeErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.RegionCodeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IRegionCodeErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.RegionCodeErrorEnum} RegionCodeErrorEnum instance
                         */
                        RegionCodeErrorEnum.create = function create(properties) {
                            return new RegionCodeErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified RegionCodeErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.RegionCodeErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.RegionCodeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IRegionCodeErrorEnum} message RegionCodeErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionCodeErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified RegionCodeErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.RegionCodeErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.RegionCodeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IRegionCodeErrorEnum} message RegionCodeErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionCodeErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a RegionCodeErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.RegionCodeErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.RegionCodeErrorEnum} RegionCodeErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionCodeErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.RegionCodeErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a RegionCodeErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.RegionCodeErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.RegionCodeErrorEnum} RegionCodeErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionCodeErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a RegionCodeErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.RegionCodeErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionCodeErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a RegionCodeErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.RegionCodeErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.RegionCodeErrorEnum} RegionCodeErrorEnum
                         */
                        RegionCodeErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.RegionCodeErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.RegionCodeErrorEnum();
                        };

                        /**
                         * Creates a plain object from a RegionCodeErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.RegionCodeErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.RegionCodeErrorEnum} message RegionCodeErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionCodeErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this RegionCodeErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.RegionCodeErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionCodeErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * RegionCodeError enum.
                         * @name google.ads.googleads.v1.errors.RegionCodeErrorEnum.RegionCodeError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} INVALID_REGION_CODE=2 INVALID_REGION_CODE value
                         */
                        RegionCodeErrorEnum.RegionCodeError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "INVALID_REGION_CODE"] = 2;
                            return values;
                        })();

                        return RegionCodeErrorEnum;
                    })();

                    errors.RequestErrorEnum = (function() {

                        /**
                         * Properties of a RequestErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IRequestErrorEnum
                         */

                        /**
                         * Constructs a new RequestErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a RequestErrorEnum.
                         * @implements IRequestErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IRequestErrorEnum=} [properties] Properties to set
                         */
                        function RequestErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new RequestErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.RequestErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IRequestErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.RequestErrorEnum} RequestErrorEnum instance
                         */
                        RequestErrorEnum.create = function create(properties) {
                            return new RequestErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified RequestErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.RequestErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.RequestErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IRequestErrorEnum} message RequestErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RequestErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified RequestErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.RequestErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.RequestErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IRequestErrorEnum} message RequestErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RequestErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a RequestErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.RequestErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.RequestErrorEnum} RequestErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RequestErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.RequestErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a RequestErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.RequestErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.RequestErrorEnum} RequestErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RequestErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a RequestErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.RequestErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RequestErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a RequestErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.RequestErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.RequestErrorEnum} RequestErrorEnum
                         */
                        RequestErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.RequestErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.RequestErrorEnum();
                        };

                        /**
                         * Creates a plain object from a RequestErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.RequestErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.RequestErrorEnum} message RequestErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RequestErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this RequestErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.RequestErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RequestErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * RequestError enum.
                         * @name google.ads.googleads.v1.errors.RequestErrorEnum.RequestError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} RESOURCE_NAME_MISSING=3 RESOURCE_NAME_MISSING value
                         * @property {number} RESOURCE_NAME_MALFORMED=4 RESOURCE_NAME_MALFORMED value
                         * @property {number} BAD_RESOURCE_ID=17 BAD_RESOURCE_ID value
                         * @property {number} INVALID_CUSTOMER_ID=16 INVALID_CUSTOMER_ID value
                         * @property {number} OPERATION_REQUIRED=5 OPERATION_REQUIRED value
                         * @property {number} RESOURCE_NOT_FOUND=6 RESOURCE_NOT_FOUND value
                         * @property {number} INVALID_PAGE_TOKEN=7 INVALID_PAGE_TOKEN value
                         * @property {number} EXPIRED_PAGE_TOKEN=8 EXPIRED_PAGE_TOKEN value
                         * @property {number} INVALID_PAGE_SIZE=22 INVALID_PAGE_SIZE value
                         * @property {number} REQUIRED_FIELD_MISSING=9 REQUIRED_FIELD_MISSING value
                         * @property {number} IMMUTABLE_FIELD=11 IMMUTABLE_FIELD value
                         * @property {number} TOO_MANY_MUTATE_OPERATIONS=13 TOO_MANY_MUTATE_OPERATIONS value
                         * @property {number} CANNOT_BE_EXECUTED_BY_MANAGER_ACCOUNT=14 CANNOT_BE_EXECUTED_BY_MANAGER_ACCOUNT value
                         * @property {number} CANNOT_MODIFY_FOREIGN_FIELD=15 CANNOT_MODIFY_FOREIGN_FIELD value
                         * @property {number} INVALID_ENUM_VALUE=18 INVALID_ENUM_VALUE value
                         * @property {number} DEVELOPER_TOKEN_PARAMETER_MISSING=19 DEVELOPER_TOKEN_PARAMETER_MISSING value
                         * @property {number} LOGIN_CUSTOMER_ID_PARAMETER_MISSING=20 LOGIN_CUSTOMER_ID_PARAMETER_MISSING value
                         * @property {number} VALIDATE_ONLY_REQUEST_HAS_PAGE_TOKEN=21 VALIDATE_ONLY_REQUEST_HAS_PAGE_TOKEN value
                         */
                        RequestErrorEnum.RequestError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[3] = "RESOURCE_NAME_MISSING"] = 3;
                            values[valuesById[4] = "RESOURCE_NAME_MALFORMED"] = 4;
                            values[valuesById[17] = "BAD_RESOURCE_ID"] = 17;
                            values[valuesById[16] = "INVALID_CUSTOMER_ID"] = 16;
                            values[valuesById[5] = "OPERATION_REQUIRED"] = 5;
                            values[valuesById[6] = "RESOURCE_NOT_FOUND"] = 6;
                            values[valuesById[7] = "INVALID_PAGE_TOKEN"] = 7;
                            values[valuesById[8] = "EXPIRED_PAGE_TOKEN"] = 8;
                            values[valuesById[22] = "INVALID_PAGE_SIZE"] = 22;
                            values[valuesById[9] = "REQUIRED_FIELD_MISSING"] = 9;
                            values[valuesById[11] = "IMMUTABLE_FIELD"] = 11;
                            values[valuesById[13] = "TOO_MANY_MUTATE_OPERATIONS"] = 13;
                            values[valuesById[14] = "CANNOT_BE_EXECUTED_BY_MANAGER_ACCOUNT"] = 14;
                            values[valuesById[15] = "CANNOT_MODIFY_FOREIGN_FIELD"] = 15;
                            values[valuesById[18] = "INVALID_ENUM_VALUE"] = 18;
                            values[valuesById[19] = "DEVELOPER_TOKEN_PARAMETER_MISSING"] = 19;
                            values[valuesById[20] = "LOGIN_CUSTOMER_ID_PARAMETER_MISSING"] = 20;
                            values[valuesById[21] = "VALIDATE_ONLY_REQUEST_HAS_PAGE_TOKEN"] = 21;
                            return values;
                        })();

                        return RequestErrorEnum;
                    })();

                    errors.ResourceAccessDeniedErrorEnum = (function() {

                        /**
                         * Properties of a ResourceAccessDeniedErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IResourceAccessDeniedErrorEnum
                         */

                        /**
                         * Constructs a new ResourceAccessDeniedErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a ResourceAccessDeniedErrorEnum.
                         * @implements IResourceAccessDeniedErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IResourceAccessDeniedErrorEnum=} [properties] Properties to set
                         */
                        function ResourceAccessDeniedErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ResourceAccessDeniedErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IResourceAccessDeniedErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum} ResourceAccessDeniedErrorEnum instance
                         */
                        ResourceAccessDeniedErrorEnum.create = function create(properties) {
                            return new ResourceAccessDeniedErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified ResourceAccessDeniedErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IResourceAccessDeniedErrorEnum} message ResourceAccessDeniedErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourceAccessDeniedErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ResourceAccessDeniedErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IResourceAccessDeniedErrorEnum} message ResourceAccessDeniedErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourceAccessDeniedErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ResourceAccessDeniedErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum} ResourceAccessDeniedErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourceAccessDeniedErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ResourceAccessDeniedErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum} ResourceAccessDeniedErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourceAccessDeniedErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ResourceAccessDeniedErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourceAccessDeniedErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ResourceAccessDeniedErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum} ResourceAccessDeniedErrorEnum
                         */
                        ResourceAccessDeniedErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum();
                        };

                        /**
                         * Creates a plain object from a ResourceAccessDeniedErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum} message ResourceAccessDeniedErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourceAccessDeniedErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ResourceAccessDeniedErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourceAccessDeniedErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ResourceAccessDeniedError enum.
                         * @name google.ads.googleads.v1.errors.ResourceAccessDeniedErrorEnum.ResourceAccessDeniedError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} WRITE_ACCESS_DENIED=3 WRITE_ACCESS_DENIED value
                         */
                        ResourceAccessDeniedErrorEnum.ResourceAccessDeniedError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[3] = "WRITE_ACCESS_DENIED"] = 3;
                            return values;
                        })();

                        return ResourceAccessDeniedErrorEnum;
                    })();

                    errors.ResourceCountLimitExceededErrorEnum = (function() {

                        /**
                         * Properties of a ResourceCountLimitExceededErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IResourceCountLimitExceededErrorEnum
                         */

                        /**
                         * Constructs a new ResourceCountLimitExceededErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a ResourceCountLimitExceededErrorEnum.
                         * @implements IResourceCountLimitExceededErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IResourceCountLimitExceededErrorEnum=} [properties] Properties to set
                         */
                        function ResourceCountLimitExceededErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ResourceCountLimitExceededErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IResourceCountLimitExceededErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum} ResourceCountLimitExceededErrorEnum instance
                         */
                        ResourceCountLimitExceededErrorEnum.create = function create(properties) {
                            return new ResourceCountLimitExceededErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified ResourceCountLimitExceededErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IResourceCountLimitExceededErrorEnum} message ResourceCountLimitExceededErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourceCountLimitExceededErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ResourceCountLimitExceededErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IResourceCountLimitExceededErrorEnum} message ResourceCountLimitExceededErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourceCountLimitExceededErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ResourceCountLimitExceededErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum} ResourceCountLimitExceededErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourceCountLimitExceededErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ResourceCountLimitExceededErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum} ResourceCountLimitExceededErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourceCountLimitExceededErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ResourceCountLimitExceededErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourceCountLimitExceededErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ResourceCountLimitExceededErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum} ResourceCountLimitExceededErrorEnum
                         */
                        ResourceCountLimitExceededErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum();
                        };

                        /**
                         * Creates a plain object from a ResourceCountLimitExceededErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum} message ResourceCountLimitExceededErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourceCountLimitExceededErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ResourceCountLimitExceededErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourceCountLimitExceededErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ResourceCountLimitExceededError enum.
                         * @name google.ads.googleads.v1.errors.ResourceCountLimitExceededErrorEnum.ResourceCountLimitExceededError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ACCOUNT_LIMIT=2 ACCOUNT_LIMIT value
                         * @property {number} CAMPAIGN_LIMIT=3 CAMPAIGN_LIMIT value
                         * @property {number} ADGROUP_LIMIT=4 ADGROUP_LIMIT value
                         * @property {number} AD_GROUP_AD_LIMIT=5 AD_GROUP_AD_LIMIT value
                         * @property {number} AD_GROUP_CRITERION_LIMIT=6 AD_GROUP_CRITERION_LIMIT value
                         * @property {number} SHARED_SET_LIMIT=7 SHARED_SET_LIMIT value
                         * @property {number} MATCHING_FUNCTION_LIMIT=8 MATCHING_FUNCTION_LIMIT value
                         * @property {number} RESPONSE_ROW_LIMIT_EXCEEDED=9 RESPONSE_ROW_LIMIT_EXCEEDED value
                         */
                        ResourceCountLimitExceededErrorEnum.ResourceCountLimitExceededError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ACCOUNT_LIMIT"] = 2;
                            values[valuesById[3] = "CAMPAIGN_LIMIT"] = 3;
                            values[valuesById[4] = "ADGROUP_LIMIT"] = 4;
                            values[valuesById[5] = "AD_GROUP_AD_LIMIT"] = 5;
                            values[valuesById[6] = "AD_GROUP_CRITERION_LIMIT"] = 6;
                            values[valuesById[7] = "SHARED_SET_LIMIT"] = 7;
                            values[valuesById[8] = "MATCHING_FUNCTION_LIMIT"] = 8;
                            values[valuesById[9] = "RESPONSE_ROW_LIMIT_EXCEEDED"] = 9;
                            return values;
                        })();

                        return ResourceCountLimitExceededErrorEnum;
                    })();

                    errors.SettingErrorEnum = (function() {

                        /**
                         * Properties of a SettingErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ISettingErrorEnum
                         */

                        /**
                         * Constructs a new SettingErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a SettingErrorEnum.
                         * @implements ISettingErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ISettingErrorEnum=} [properties] Properties to set
                         */
                        function SettingErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new SettingErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.SettingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ISettingErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.SettingErrorEnum} SettingErrorEnum instance
                         */
                        SettingErrorEnum.create = function create(properties) {
                            return new SettingErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified SettingErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.SettingErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.SettingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ISettingErrorEnum} message SettingErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SettingErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified SettingErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.SettingErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.SettingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ISettingErrorEnum} message SettingErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SettingErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SettingErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.SettingErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.SettingErrorEnum} SettingErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SettingErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.SettingErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SettingErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.SettingErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.SettingErrorEnum} SettingErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SettingErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SettingErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.SettingErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SettingErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a SettingErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.SettingErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.SettingErrorEnum} SettingErrorEnum
                         */
                        SettingErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.SettingErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.SettingErrorEnum();
                        };

                        /**
                         * Creates a plain object from a SettingErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.SettingErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.SettingErrorEnum} message SettingErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SettingErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this SettingErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.SettingErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SettingErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * SettingError enum.
                         * @name google.ads.googleads.v1.errors.SettingErrorEnum.SettingError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} SETTING_TYPE_IS_NOT_AVAILABLE=3 SETTING_TYPE_IS_NOT_AVAILABLE value
                         * @property {number} SETTING_TYPE_IS_NOT_COMPATIBLE_WITH_CAMPAIGN=4 SETTING_TYPE_IS_NOT_COMPATIBLE_WITH_CAMPAIGN value
                         * @property {number} TARGETING_SETTING_CONTAINS_INVALID_CRITERION_TYPE_GROUP=5 TARGETING_SETTING_CONTAINS_INVALID_CRITERION_TYPE_GROUP value
                         * @property {number} TARGETING_SETTING_DEMOGRAPHIC_CRITERION_TYPE_GROUPS_MUST_BE_SET_TO_TARGET_ALL=6 TARGETING_SETTING_DEMOGRAPHIC_CRITERION_TYPE_GROUPS_MUST_BE_SET_TO_TARGET_ALL value
                         * @property {number} TARGETING_SETTING_CANNOT_CHANGE_TARGET_ALL_TO_FALSE_FOR_DEMOGRAPHIC_CRITERION_TYPE_GROUP=7 TARGETING_SETTING_CANNOT_CHANGE_TARGET_ALL_TO_FALSE_FOR_DEMOGRAPHIC_CRITERION_TYPE_GROUP value
                         * @property {number} DYNAMIC_SEARCH_ADS_SETTING_AT_LEAST_ONE_FEED_ID_MUST_BE_PRESENT=8 DYNAMIC_SEARCH_ADS_SETTING_AT_LEAST_ONE_FEED_ID_MUST_BE_PRESENT value
                         * @property {number} DYNAMIC_SEARCH_ADS_SETTING_CONTAINS_INVALID_DOMAIN_NAME=9 DYNAMIC_SEARCH_ADS_SETTING_CONTAINS_INVALID_DOMAIN_NAME value
                         * @property {number} DYNAMIC_SEARCH_ADS_SETTING_CONTAINS_SUBDOMAIN_NAME=10 DYNAMIC_SEARCH_ADS_SETTING_CONTAINS_SUBDOMAIN_NAME value
                         * @property {number} DYNAMIC_SEARCH_ADS_SETTING_CONTAINS_INVALID_LANGUAGE_CODE=11 DYNAMIC_SEARCH_ADS_SETTING_CONTAINS_INVALID_LANGUAGE_CODE value
                         * @property {number} TARGET_ALL_IS_NOT_ALLOWED_FOR_PLACEMENT_IN_SEARCH_CAMPAIGN=12 TARGET_ALL_IS_NOT_ALLOWED_FOR_PLACEMENT_IN_SEARCH_CAMPAIGN value
                         * @property {number} UNIVERSAL_APP_CAMPAIGN_SETTING_DUPLICATE_DESCRIPTION=13 UNIVERSAL_APP_CAMPAIGN_SETTING_DUPLICATE_DESCRIPTION value
                         * @property {number} UNIVERSAL_APP_CAMPAIGN_SETTING_DESCRIPTION_LINE_WIDTH_TOO_LONG=14 UNIVERSAL_APP_CAMPAIGN_SETTING_DESCRIPTION_LINE_WIDTH_TOO_LONG value
                         * @property {number} UNIVERSAL_APP_CAMPAIGN_SETTING_APP_ID_CANNOT_BE_MODIFIED=15 UNIVERSAL_APP_CAMPAIGN_SETTING_APP_ID_CANNOT_BE_MODIFIED value
                         * @property {number} TOO_MANY_YOUTUBE_MEDIA_IDS_IN_UNIVERSAL_APP_CAMPAIGN=16 TOO_MANY_YOUTUBE_MEDIA_IDS_IN_UNIVERSAL_APP_CAMPAIGN value
                         * @property {number} TOO_MANY_IMAGE_MEDIA_IDS_IN_UNIVERSAL_APP_CAMPAIGN=17 TOO_MANY_IMAGE_MEDIA_IDS_IN_UNIVERSAL_APP_CAMPAIGN value
                         * @property {number} MEDIA_INCOMPATIBLE_FOR_UNIVERSAL_APP_CAMPAIGN=18 MEDIA_INCOMPATIBLE_FOR_UNIVERSAL_APP_CAMPAIGN value
                         * @property {number} TOO_MANY_EXCLAMATION_MARKS=19 TOO_MANY_EXCLAMATION_MARKS value
                         */
                        SettingErrorEnum.SettingError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[3] = "SETTING_TYPE_IS_NOT_AVAILABLE"] = 3;
                            values[valuesById[4] = "SETTING_TYPE_IS_NOT_COMPATIBLE_WITH_CAMPAIGN"] = 4;
                            values[valuesById[5] = "TARGETING_SETTING_CONTAINS_INVALID_CRITERION_TYPE_GROUP"] = 5;
                            values[valuesById[6] = "TARGETING_SETTING_DEMOGRAPHIC_CRITERION_TYPE_GROUPS_MUST_BE_SET_TO_TARGET_ALL"] = 6;
                            values[valuesById[7] = "TARGETING_SETTING_CANNOT_CHANGE_TARGET_ALL_TO_FALSE_FOR_DEMOGRAPHIC_CRITERION_TYPE_GROUP"] = 7;
                            values[valuesById[8] = "DYNAMIC_SEARCH_ADS_SETTING_AT_LEAST_ONE_FEED_ID_MUST_BE_PRESENT"] = 8;
                            values[valuesById[9] = "DYNAMIC_SEARCH_ADS_SETTING_CONTAINS_INVALID_DOMAIN_NAME"] = 9;
                            values[valuesById[10] = "DYNAMIC_SEARCH_ADS_SETTING_CONTAINS_SUBDOMAIN_NAME"] = 10;
                            values[valuesById[11] = "DYNAMIC_SEARCH_ADS_SETTING_CONTAINS_INVALID_LANGUAGE_CODE"] = 11;
                            values[valuesById[12] = "TARGET_ALL_IS_NOT_ALLOWED_FOR_PLACEMENT_IN_SEARCH_CAMPAIGN"] = 12;
                            values[valuesById[13] = "UNIVERSAL_APP_CAMPAIGN_SETTING_DUPLICATE_DESCRIPTION"] = 13;
                            values[valuesById[14] = "UNIVERSAL_APP_CAMPAIGN_SETTING_DESCRIPTION_LINE_WIDTH_TOO_LONG"] = 14;
                            values[valuesById[15] = "UNIVERSAL_APP_CAMPAIGN_SETTING_APP_ID_CANNOT_BE_MODIFIED"] = 15;
                            values[valuesById[16] = "TOO_MANY_YOUTUBE_MEDIA_IDS_IN_UNIVERSAL_APP_CAMPAIGN"] = 16;
                            values[valuesById[17] = "TOO_MANY_IMAGE_MEDIA_IDS_IN_UNIVERSAL_APP_CAMPAIGN"] = 17;
                            values[valuesById[18] = "MEDIA_INCOMPATIBLE_FOR_UNIVERSAL_APP_CAMPAIGN"] = 18;
                            values[valuesById[19] = "TOO_MANY_EXCLAMATION_MARKS"] = 19;
                            return values;
                        })();

                        return SettingErrorEnum;
                    })();

                    errors.SharedCriterionErrorEnum = (function() {

                        /**
                         * Properties of a SharedCriterionErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ISharedCriterionErrorEnum
                         */

                        /**
                         * Constructs a new SharedCriterionErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a SharedCriterionErrorEnum.
                         * @implements ISharedCriterionErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ISharedCriterionErrorEnum=} [properties] Properties to set
                         */
                        function SharedCriterionErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new SharedCriterionErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.SharedCriterionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ISharedCriterionErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.SharedCriterionErrorEnum} SharedCriterionErrorEnum instance
                         */
                        SharedCriterionErrorEnum.create = function create(properties) {
                            return new SharedCriterionErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified SharedCriterionErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.SharedCriterionErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.SharedCriterionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ISharedCriterionErrorEnum} message SharedCriterionErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SharedCriterionErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified SharedCriterionErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.SharedCriterionErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.SharedCriterionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ISharedCriterionErrorEnum} message SharedCriterionErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SharedCriterionErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SharedCriterionErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.SharedCriterionErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.SharedCriterionErrorEnum} SharedCriterionErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SharedCriterionErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.SharedCriterionErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SharedCriterionErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.SharedCriterionErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.SharedCriterionErrorEnum} SharedCriterionErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SharedCriterionErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SharedCriterionErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.SharedCriterionErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SharedCriterionErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a SharedCriterionErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.SharedCriterionErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.SharedCriterionErrorEnum} SharedCriterionErrorEnum
                         */
                        SharedCriterionErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.SharedCriterionErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.SharedCriterionErrorEnum();
                        };

                        /**
                         * Creates a plain object from a SharedCriterionErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.SharedCriterionErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.SharedCriterionErrorEnum} message SharedCriterionErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SharedCriterionErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this SharedCriterionErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.SharedCriterionErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SharedCriterionErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * SharedCriterionError enum.
                         * @name google.ads.googleads.v1.errors.SharedCriterionErrorEnum.SharedCriterionError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CRITERION_TYPE_NOT_ALLOWED_FOR_SHARED_SET_TYPE=2 CRITERION_TYPE_NOT_ALLOWED_FOR_SHARED_SET_TYPE value
                         */
                        SharedCriterionErrorEnum.SharedCriterionError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CRITERION_TYPE_NOT_ALLOWED_FOR_SHARED_SET_TYPE"] = 2;
                            return values;
                        })();

                        return SharedCriterionErrorEnum;
                    })();

                    errors.SharedSetErrorEnum = (function() {

                        /**
                         * Properties of a SharedSetErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ISharedSetErrorEnum
                         */

                        /**
                         * Constructs a new SharedSetErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a SharedSetErrorEnum.
                         * @implements ISharedSetErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ISharedSetErrorEnum=} [properties] Properties to set
                         */
                        function SharedSetErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new SharedSetErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.SharedSetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ISharedSetErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.SharedSetErrorEnum} SharedSetErrorEnum instance
                         */
                        SharedSetErrorEnum.create = function create(properties) {
                            return new SharedSetErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified SharedSetErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.SharedSetErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.SharedSetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ISharedSetErrorEnum} message SharedSetErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SharedSetErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified SharedSetErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.SharedSetErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.SharedSetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ISharedSetErrorEnum} message SharedSetErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SharedSetErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SharedSetErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.SharedSetErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.SharedSetErrorEnum} SharedSetErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SharedSetErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.SharedSetErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SharedSetErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.SharedSetErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.SharedSetErrorEnum} SharedSetErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SharedSetErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SharedSetErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.SharedSetErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SharedSetErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a SharedSetErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.SharedSetErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.SharedSetErrorEnum} SharedSetErrorEnum
                         */
                        SharedSetErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.SharedSetErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.SharedSetErrorEnum();
                        };

                        /**
                         * Creates a plain object from a SharedSetErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.SharedSetErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.SharedSetErrorEnum} message SharedSetErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SharedSetErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this SharedSetErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.SharedSetErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SharedSetErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * SharedSetError enum.
                         * @name google.ads.googleads.v1.errors.SharedSetErrorEnum.SharedSetError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CUSTOMER_CANNOT_CREATE_SHARED_SET_OF_THIS_TYPE=2 CUSTOMER_CANNOT_CREATE_SHARED_SET_OF_THIS_TYPE value
                         * @property {number} DUPLICATE_NAME=3 DUPLICATE_NAME value
                         * @property {number} SHARED_SET_REMOVED=4 SHARED_SET_REMOVED value
                         * @property {number} SHARED_SET_IN_USE=5 SHARED_SET_IN_USE value
                         */
                        SharedSetErrorEnum.SharedSetError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CUSTOMER_CANNOT_CREATE_SHARED_SET_OF_THIS_TYPE"] = 2;
                            values[valuesById[3] = "DUPLICATE_NAME"] = 3;
                            values[valuesById[4] = "SHARED_SET_REMOVED"] = 4;
                            values[valuesById[5] = "SHARED_SET_IN_USE"] = 5;
                            return values;
                        })();

                        return SharedSetErrorEnum;
                    })();

                    errors.SizeLimitErrorEnum = (function() {

                        /**
                         * Properties of a SizeLimitErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface ISizeLimitErrorEnum
                         */

                        /**
                         * Constructs a new SizeLimitErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a SizeLimitErrorEnum.
                         * @implements ISizeLimitErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.ISizeLimitErrorEnum=} [properties] Properties to set
                         */
                        function SizeLimitErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new SizeLimitErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.SizeLimitErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ISizeLimitErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.SizeLimitErrorEnum} SizeLimitErrorEnum instance
                         */
                        SizeLimitErrorEnum.create = function create(properties) {
                            return new SizeLimitErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified SizeLimitErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.SizeLimitErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.SizeLimitErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ISizeLimitErrorEnum} message SizeLimitErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SizeLimitErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified SizeLimitErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.SizeLimitErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.SizeLimitErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.ISizeLimitErrorEnum} message SizeLimitErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SizeLimitErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SizeLimitErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.SizeLimitErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.SizeLimitErrorEnum} SizeLimitErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SizeLimitErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.SizeLimitErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SizeLimitErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.SizeLimitErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.SizeLimitErrorEnum} SizeLimitErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SizeLimitErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SizeLimitErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.SizeLimitErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SizeLimitErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a SizeLimitErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.SizeLimitErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.SizeLimitErrorEnum} SizeLimitErrorEnum
                         */
                        SizeLimitErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.SizeLimitErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.SizeLimitErrorEnum();
                        };

                        /**
                         * Creates a plain object from a SizeLimitErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.SizeLimitErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.SizeLimitErrorEnum} message SizeLimitErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SizeLimitErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this SizeLimitErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.SizeLimitErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SizeLimitErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * SizeLimitError enum.
                         * @name google.ads.googleads.v1.errors.SizeLimitErrorEnum.SizeLimitError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} REQUEST_SIZE_LIMIT_EXCEEDED=2 REQUEST_SIZE_LIMIT_EXCEEDED value
                         * @property {number} RESPONSE_SIZE_LIMIT_EXCEEDED=3 RESPONSE_SIZE_LIMIT_EXCEEDED value
                         */
                        SizeLimitErrorEnum.SizeLimitError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "REQUEST_SIZE_LIMIT_EXCEEDED"] = 2;
                            values[valuesById[3] = "RESPONSE_SIZE_LIMIT_EXCEEDED"] = 3;
                            return values;
                        })();

                        return SizeLimitErrorEnum;
                    })();

                    errors.StringFormatErrorEnum = (function() {

                        /**
                         * Properties of a StringFormatErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IStringFormatErrorEnum
                         */

                        /**
                         * Constructs a new StringFormatErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a StringFormatErrorEnum.
                         * @implements IStringFormatErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IStringFormatErrorEnum=} [properties] Properties to set
                         */
                        function StringFormatErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new StringFormatErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.StringFormatErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IStringFormatErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.StringFormatErrorEnum} StringFormatErrorEnum instance
                         */
                        StringFormatErrorEnum.create = function create(properties) {
                            return new StringFormatErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified StringFormatErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.StringFormatErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.StringFormatErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IStringFormatErrorEnum} message StringFormatErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StringFormatErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified StringFormatErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.StringFormatErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.StringFormatErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IStringFormatErrorEnum} message StringFormatErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StringFormatErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a StringFormatErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.StringFormatErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.StringFormatErrorEnum} StringFormatErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StringFormatErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.StringFormatErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a StringFormatErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.StringFormatErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.StringFormatErrorEnum} StringFormatErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StringFormatErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a StringFormatErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.StringFormatErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        StringFormatErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a StringFormatErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.StringFormatErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.StringFormatErrorEnum} StringFormatErrorEnum
                         */
                        StringFormatErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.StringFormatErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.StringFormatErrorEnum();
                        };

                        /**
                         * Creates a plain object from a StringFormatErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.StringFormatErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.StringFormatErrorEnum} message StringFormatErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        StringFormatErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this StringFormatErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.StringFormatErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        StringFormatErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * StringFormatError enum.
                         * @name google.ads.googleads.v1.errors.StringFormatErrorEnum.StringFormatError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ILLEGAL_CHARS=2 ILLEGAL_CHARS value
                         * @property {number} INVALID_FORMAT=3 INVALID_FORMAT value
                         */
                        StringFormatErrorEnum.StringFormatError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ILLEGAL_CHARS"] = 2;
                            values[valuesById[3] = "INVALID_FORMAT"] = 3;
                            return values;
                        })();

                        return StringFormatErrorEnum;
                    })();

                    errors.StringLengthErrorEnum = (function() {

                        /**
                         * Properties of a StringLengthErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IStringLengthErrorEnum
                         */

                        /**
                         * Constructs a new StringLengthErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a StringLengthErrorEnum.
                         * @implements IStringLengthErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IStringLengthErrorEnum=} [properties] Properties to set
                         */
                        function StringLengthErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new StringLengthErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.StringLengthErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IStringLengthErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.StringLengthErrorEnum} StringLengthErrorEnum instance
                         */
                        StringLengthErrorEnum.create = function create(properties) {
                            return new StringLengthErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified StringLengthErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.StringLengthErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.StringLengthErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IStringLengthErrorEnum} message StringLengthErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StringLengthErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified StringLengthErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.StringLengthErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.StringLengthErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IStringLengthErrorEnum} message StringLengthErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StringLengthErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a StringLengthErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.StringLengthErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.StringLengthErrorEnum} StringLengthErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StringLengthErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.StringLengthErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a StringLengthErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.StringLengthErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.StringLengthErrorEnum} StringLengthErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StringLengthErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a StringLengthErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.StringLengthErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        StringLengthErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a StringLengthErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.StringLengthErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.StringLengthErrorEnum} StringLengthErrorEnum
                         */
                        StringLengthErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.StringLengthErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.StringLengthErrorEnum();
                        };

                        /**
                         * Creates a plain object from a StringLengthErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.StringLengthErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.StringLengthErrorEnum} message StringLengthErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        StringLengthErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this StringLengthErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.StringLengthErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        StringLengthErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * StringLengthError enum.
                         * @name google.ads.googleads.v1.errors.StringLengthErrorEnum.StringLengthError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} TOO_SHORT=2 TOO_SHORT value
                         * @property {number} TOO_LONG=3 TOO_LONG value
                         */
                        StringLengthErrorEnum.StringLengthError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "TOO_SHORT"] = 2;
                            values[valuesById[3] = "TOO_LONG"] = 3;
                            return values;
                        })();

                        return StringLengthErrorEnum;
                    })();

                    errors.UrlFieldErrorEnum = (function() {

                        /**
                         * Properties of an UrlFieldErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IUrlFieldErrorEnum
                         */

                        /**
                         * Constructs a new UrlFieldErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents an UrlFieldErrorEnum.
                         * @implements IUrlFieldErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IUrlFieldErrorEnum=} [properties] Properties to set
                         */
                        function UrlFieldErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new UrlFieldErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.UrlFieldErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IUrlFieldErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.UrlFieldErrorEnum} UrlFieldErrorEnum instance
                         */
                        UrlFieldErrorEnum.create = function create(properties) {
                            return new UrlFieldErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified UrlFieldErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.UrlFieldErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.UrlFieldErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IUrlFieldErrorEnum} message UrlFieldErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlFieldErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified UrlFieldErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.UrlFieldErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.UrlFieldErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IUrlFieldErrorEnum} message UrlFieldErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlFieldErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an UrlFieldErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.UrlFieldErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.UrlFieldErrorEnum} UrlFieldErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlFieldErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.UrlFieldErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an UrlFieldErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.UrlFieldErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.UrlFieldErrorEnum} UrlFieldErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlFieldErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an UrlFieldErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.UrlFieldErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UrlFieldErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an UrlFieldErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.UrlFieldErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.UrlFieldErrorEnum} UrlFieldErrorEnum
                         */
                        UrlFieldErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.UrlFieldErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.UrlFieldErrorEnum();
                        };

                        /**
                         * Creates a plain object from an UrlFieldErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.UrlFieldErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.UrlFieldErrorEnum} message UrlFieldErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UrlFieldErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this UrlFieldErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.UrlFieldErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UrlFieldErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * UrlFieldError enum.
                         * @name google.ads.googleads.v1.errors.UrlFieldErrorEnum.UrlFieldError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} INVALID_TRACKING_URL_TEMPLATE=2 INVALID_TRACKING_URL_TEMPLATE value
                         * @property {number} INVALID_TAG_IN_TRACKING_URL_TEMPLATE=3 INVALID_TAG_IN_TRACKING_URL_TEMPLATE value
                         * @property {number} MISSING_TRACKING_URL_TEMPLATE_TAG=4 MISSING_TRACKING_URL_TEMPLATE_TAG value
                         * @property {number} MISSING_PROTOCOL_IN_TRACKING_URL_TEMPLATE=5 MISSING_PROTOCOL_IN_TRACKING_URL_TEMPLATE value
                         * @property {number} INVALID_PROTOCOL_IN_TRACKING_URL_TEMPLATE=6 INVALID_PROTOCOL_IN_TRACKING_URL_TEMPLATE value
                         * @property {number} MALFORMED_TRACKING_URL_TEMPLATE=7 MALFORMED_TRACKING_URL_TEMPLATE value
                         * @property {number} MISSING_HOST_IN_TRACKING_URL_TEMPLATE=8 MISSING_HOST_IN_TRACKING_URL_TEMPLATE value
                         * @property {number} INVALID_TLD_IN_TRACKING_URL_TEMPLATE=9 INVALID_TLD_IN_TRACKING_URL_TEMPLATE value
                         * @property {number} REDUNDANT_NESTED_TRACKING_URL_TEMPLATE_TAG=10 REDUNDANT_NESTED_TRACKING_URL_TEMPLATE_TAG value
                         * @property {number} INVALID_FINAL_URL=11 INVALID_FINAL_URL value
                         * @property {number} INVALID_TAG_IN_FINAL_URL=12 INVALID_TAG_IN_FINAL_URL value
                         * @property {number} REDUNDANT_NESTED_FINAL_URL_TAG=13 REDUNDANT_NESTED_FINAL_URL_TAG value
                         * @property {number} MISSING_PROTOCOL_IN_FINAL_URL=14 MISSING_PROTOCOL_IN_FINAL_URL value
                         * @property {number} INVALID_PROTOCOL_IN_FINAL_URL=15 INVALID_PROTOCOL_IN_FINAL_URL value
                         * @property {number} MALFORMED_FINAL_URL=16 MALFORMED_FINAL_URL value
                         * @property {number} MISSING_HOST_IN_FINAL_URL=17 MISSING_HOST_IN_FINAL_URL value
                         * @property {number} INVALID_TLD_IN_FINAL_URL=18 INVALID_TLD_IN_FINAL_URL value
                         * @property {number} INVALID_FINAL_MOBILE_URL=19 INVALID_FINAL_MOBILE_URL value
                         * @property {number} INVALID_TAG_IN_FINAL_MOBILE_URL=20 INVALID_TAG_IN_FINAL_MOBILE_URL value
                         * @property {number} REDUNDANT_NESTED_FINAL_MOBILE_URL_TAG=21 REDUNDANT_NESTED_FINAL_MOBILE_URL_TAG value
                         * @property {number} MISSING_PROTOCOL_IN_FINAL_MOBILE_URL=22 MISSING_PROTOCOL_IN_FINAL_MOBILE_URL value
                         * @property {number} INVALID_PROTOCOL_IN_FINAL_MOBILE_URL=23 INVALID_PROTOCOL_IN_FINAL_MOBILE_URL value
                         * @property {number} MALFORMED_FINAL_MOBILE_URL=24 MALFORMED_FINAL_MOBILE_URL value
                         * @property {number} MISSING_HOST_IN_FINAL_MOBILE_URL=25 MISSING_HOST_IN_FINAL_MOBILE_URL value
                         * @property {number} INVALID_TLD_IN_FINAL_MOBILE_URL=26 INVALID_TLD_IN_FINAL_MOBILE_URL value
                         * @property {number} INVALID_FINAL_APP_URL=27 INVALID_FINAL_APP_URL value
                         * @property {number} INVALID_TAG_IN_FINAL_APP_URL=28 INVALID_TAG_IN_FINAL_APP_URL value
                         * @property {number} REDUNDANT_NESTED_FINAL_APP_URL_TAG=29 REDUNDANT_NESTED_FINAL_APP_URL_TAG value
                         * @property {number} MULTIPLE_APP_URLS_FOR_OSTYPE=30 MULTIPLE_APP_URLS_FOR_OSTYPE value
                         * @property {number} INVALID_OSTYPE=31 INVALID_OSTYPE value
                         * @property {number} INVALID_PROTOCOL_FOR_APP_URL=32 INVALID_PROTOCOL_FOR_APP_URL value
                         * @property {number} INVALID_PACKAGE_ID_FOR_APP_URL=33 INVALID_PACKAGE_ID_FOR_APP_URL value
                         * @property {number} URL_CUSTOM_PARAMETERS_COUNT_EXCEEDS_LIMIT=34 URL_CUSTOM_PARAMETERS_COUNT_EXCEEDS_LIMIT value
                         * @property {number} INVALID_CHARACTERS_IN_URL_CUSTOM_PARAMETER_KEY=39 INVALID_CHARACTERS_IN_URL_CUSTOM_PARAMETER_KEY value
                         * @property {number} INVALID_CHARACTERS_IN_URL_CUSTOM_PARAMETER_VALUE=40 INVALID_CHARACTERS_IN_URL_CUSTOM_PARAMETER_VALUE value
                         * @property {number} INVALID_TAG_IN_URL_CUSTOM_PARAMETER_VALUE=41 INVALID_TAG_IN_URL_CUSTOM_PARAMETER_VALUE value
                         * @property {number} REDUNDANT_NESTED_URL_CUSTOM_PARAMETER_TAG=42 REDUNDANT_NESTED_URL_CUSTOM_PARAMETER_TAG value
                         * @property {number} MISSING_PROTOCOL=43 MISSING_PROTOCOL value
                         * @property {number} INVALID_PROTOCOL=52 INVALID_PROTOCOL value
                         * @property {number} INVALID_URL=44 INVALID_URL value
                         * @property {number} DESTINATION_URL_DEPRECATED=45 DESTINATION_URL_DEPRECATED value
                         * @property {number} INVALID_TAG_IN_URL=46 INVALID_TAG_IN_URL value
                         * @property {number} MISSING_URL_TAG=47 MISSING_URL_TAG value
                         * @property {number} DUPLICATE_URL_ID=48 DUPLICATE_URL_ID value
                         * @property {number} INVALID_URL_ID=49 INVALID_URL_ID value
                         * @property {number} FINAL_URL_SUFFIX_MALFORMED=50 FINAL_URL_SUFFIX_MALFORMED value
                         * @property {number} INVALID_TAG_IN_FINAL_URL_SUFFIX=51 INVALID_TAG_IN_FINAL_URL_SUFFIX value
                         * @property {number} INVALID_TOP_LEVEL_DOMAIN=53 INVALID_TOP_LEVEL_DOMAIN value
                         * @property {number} MALFORMED_TOP_LEVEL_DOMAIN=54 MALFORMED_TOP_LEVEL_DOMAIN value
                         * @property {number} MALFORMED_URL=55 MALFORMED_URL value
                         * @property {number} MISSING_HOST=56 MISSING_HOST value
                         */
                        UrlFieldErrorEnum.UrlFieldError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "INVALID_TRACKING_URL_TEMPLATE"] = 2;
                            values[valuesById[3] = "INVALID_TAG_IN_TRACKING_URL_TEMPLATE"] = 3;
                            values[valuesById[4] = "MISSING_TRACKING_URL_TEMPLATE_TAG"] = 4;
                            values[valuesById[5] = "MISSING_PROTOCOL_IN_TRACKING_URL_TEMPLATE"] = 5;
                            values[valuesById[6] = "INVALID_PROTOCOL_IN_TRACKING_URL_TEMPLATE"] = 6;
                            values[valuesById[7] = "MALFORMED_TRACKING_URL_TEMPLATE"] = 7;
                            values[valuesById[8] = "MISSING_HOST_IN_TRACKING_URL_TEMPLATE"] = 8;
                            values[valuesById[9] = "INVALID_TLD_IN_TRACKING_URL_TEMPLATE"] = 9;
                            values[valuesById[10] = "REDUNDANT_NESTED_TRACKING_URL_TEMPLATE_TAG"] = 10;
                            values[valuesById[11] = "INVALID_FINAL_URL"] = 11;
                            values[valuesById[12] = "INVALID_TAG_IN_FINAL_URL"] = 12;
                            values[valuesById[13] = "REDUNDANT_NESTED_FINAL_URL_TAG"] = 13;
                            values[valuesById[14] = "MISSING_PROTOCOL_IN_FINAL_URL"] = 14;
                            values[valuesById[15] = "INVALID_PROTOCOL_IN_FINAL_URL"] = 15;
                            values[valuesById[16] = "MALFORMED_FINAL_URL"] = 16;
                            values[valuesById[17] = "MISSING_HOST_IN_FINAL_URL"] = 17;
                            values[valuesById[18] = "INVALID_TLD_IN_FINAL_URL"] = 18;
                            values[valuesById[19] = "INVALID_FINAL_MOBILE_URL"] = 19;
                            values[valuesById[20] = "INVALID_TAG_IN_FINAL_MOBILE_URL"] = 20;
                            values[valuesById[21] = "REDUNDANT_NESTED_FINAL_MOBILE_URL_TAG"] = 21;
                            values[valuesById[22] = "MISSING_PROTOCOL_IN_FINAL_MOBILE_URL"] = 22;
                            values[valuesById[23] = "INVALID_PROTOCOL_IN_FINAL_MOBILE_URL"] = 23;
                            values[valuesById[24] = "MALFORMED_FINAL_MOBILE_URL"] = 24;
                            values[valuesById[25] = "MISSING_HOST_IN_FINAL_MOBILE_URL"] = 25;
                            values[valuesById[26] = "INVALID_TLD_IN_FINAL_MOBILE_URL"] = 26;
                            values[valuesById[27] = "INVALID_FINAL_APP_URL"] = 27;
                            values[valuesById[28] = "INVALID_TAG_IN_FINAL_APP_URL"] = 28;
                            values[valuesById[29] = "REDUNDANT_NESTED_FINAL_APP_URL_TAG"] = 29;
                            values[valuesById[30] = "MULTIPLE_APP_URLS_FOR_OSTYPE"] = 30;
                            values[valuesById[31] = "INVALID_OSTYPE"] = 31;
                            values[valuesById[32] = "INVALID_PROTOCOL_FOR_APP_URL"] = 32;
                            values[valuesById[33] = "INVALID_PACKAGE_ID_FOR_APP_URL"] = 33;
                            values[valuesById[34] = "URL_CUSTOM_PARAMETERS_COUNT_EXCEEDS_LIMIT"] = 34;
                            values[valuesById[39] = "INVALID_CHARACTERS_IN_URL_CUSTOM_PARAMETER_KEY"] = 39;
                            values[valuesById[40] = "INVALID_CHARACTERS_IN_URL_CUSTOM_PARAMETER_VALUE"] = 40;
                            values[valuesById[41] = "INVALID_TAG_IN_URL_CUSTOM_PARAMETER_VALUE"] = 41;
                            values[valuesById[42] = "REDUNDANT_NESTED_URL_CUSTOM_PARAMETER_TAG"] = 42;
                            values[valuesById[43] = "MISSING_PROTOCOL"] = 43;
                            values[valuesById[52] = "INVALID_PROTOCOL"] = 52;
                            values[valuesById[44] = "INVALID_URL"] = 44;
                            values[valuesById[45] = "DESTINATION_URL_DEPRECATED"] = 45;
                            values[valuesById[46] = "INVALID_TAG_IN_URL"] = 46;
                            values[valuesById[47] = "MISSING_URL_TAG"] = 47;
                            values[valuesById[48] = "DUPLICATE_URL_ID"] = 48;
                            values[valuesById[49] = "INVALID_URL_ID"] = 49;
                            values[valuesById[50] = "FINAL_URL_SUFFIX_MALFORMED"] = 50;
                            values[valuesById[51] = "INVALID_TAG_IN_FINAL_URL_SUFFIX"] = 51;
                            values[valuesById[53] = "INVALID_TOP_LEVEL_DOMAIN"] = 53;
                            values[valuesById[54] = "MALFORMED_TOP_LEVEL_DOMAIN"] = 54;
                            values[valuesById[55] = "MALFORMED_URL"] = 55;
                            values[valuesById[56] = "MISSING_HOST"] = 56;
                            return values;
                        })();

                        return UrlFieldErrorEnum;
                    })();

                    errors.UserListErrorEnum = (function() {

                        /**
                         * Properties of a UserListErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IUserListErrorEnum
                         */

                        /**
                         * Constructs a new UserListErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a UserListErrorEnum.
                         * @implements IUserListErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IUserListErrorEnum=} [properties] Properties to set
                         */
                        function UserListErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new UserListErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.UserListErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IUserListErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.UserListErrorEnum} UserListErrorEnum instance
                         */
                        UserListErrorEnum.create = function create(properties) {
                            return new UserListErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified UserListErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.UserListErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.UserListErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IUserListErrorEnum} message UserListErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.UserListErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.UserListErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IUserListErrorEnum} message UserListErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.UserListErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.UserListErrorEnum} UserListErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.UserListErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.UserListErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.UserListErrorEnum} UserListErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.UserListErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a UserListErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.UserListErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.UserListErrorEnum} UserListErrorEnum
                         */
                        UserListErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.UserListErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.UserListErrorEnum();
                        };

                        /**
                         * Creates a plain object from a UserListErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.UserListErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.UserListErrorEnum} message UserListErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this UserListErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.UserListErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * UserListError enum.
                         * @name google.ads.googleads.v1.errors.UserListErrorEnum.UserListError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} EXTERNAL_REMARKETING_USER_LIST_MUTATE_NOT_SUPPORTED=2 EXTERNAL_REMARKETING_USER_LIST_MUTATE_NOT_SUPPORTED value
                         * @property {number} CONCRETE_TYPE_REQUIRED=3 CONCRETE_TYPE_REQUIRED value
                         * @property {number} CONVERSION_TYPE_ID_REQUIRED=4 CONVERSION_TYPE_ID_REQUIRED value
                         * @property {number} DUPLICATE_CONVERSION_TYPES=5 DUPLICATE_CONVERSION_TYPES value
                         * @property {number} INVALID_CONVERSION_TYPE=6 INVALID_CONVERSION_TYPE value
                         * @property {number} INVALID_DESCRIPTION=7 INVALID_DESCRIPTION value
                         * @property {number} INVALID_NAME=8 INVALID_NAME value
                         * @property {number} INVALID_TYPE=9 INVALID_TYPE value
                         * @property {number} CAN_NOT_ADD_LOGICAL_LIST_AS_LOGICAL_LIST_OPERAND=10 CAN_NOT_ADD_LOGICAL_LIST_AS_LOGICAL_LIST_OPERAND value
                         * @property {number} INVALID_USER_LIST_LOGICAL_RULE_OPERAND=11 INVALID_USER_LIST_LOGICAL_RULE_OPERAND value
                         * @property {number} NAME_ALREADY_USED=12 NAME_ALREADY_USED value
                         * @property {number} NEW_CONVERSION_TYPE_NAME_REQUIRED=13 NEW_CONVERSION_TYPE_NAME_REQUIRED value
                         * @property {number} CONVERSION_TYPE_NAME_ALREADY_USED=14 CONVERSION_TYPE_NAME_ALREADY_USED value
                         * @property {number} OWNERSHIP_REQUIRED_FOR_SET=15 OWNERSHIP_REQUIRED_FOR_SET value
                         * @property {number} USER_LIST_MUTATE_NOT_SUPPORTED=16 USER_LIST_MUTATE_NOT_SUPPORTED value
                         * @property {number} INVALID_RULE=17 INVALID_RULE value
                         * @property {number} INVALID_DATE_RANGE=27 INVALID_DATE_RANGE value
                         * @property {number} CAN_NOT_MUTATE_SENSITIVE_USERLIST=28 CAN_NOT_MUTATE_SENSITIVE_USERLIST value
                         * @property {number} MAX_NUM_RULEBASED_USERLISTS=29 MAX_NUM_RULEBASED_USERLISTS value
                         * @property {number} CANNOT_MODIFY_BILLABLE_RECORD_COUNT=30 CANNOT_MODIFY_BILLABLE_RECORD_COUNT value
                         * @property {number} APP_ID_NOT_SET=31 APP_ID_NOT_SET value
                         * @property {number} USERLIST_NAME_IS_RESERVED_FOR_SYSTEM_LIST=32 USERLIST_NAME_IS_RESERVED_FOR_SYSTEM_LIST value
                         * @property {number} ADVERTISER_NOT_WHITELISTED_FOR_USING_UPLOADED_DATA=33 ADVERTISER_NOT_WHITELISTED_FOR_USING_UPLOADED_DATA value
                         * @property {number} RULE_TYPE_IS_NOT_SUPPORTED=34 RULE_TYPE_IS_NOT_SUPPORTED value
                         * @property {number} CAN_NOT_ADD_A_SIMILAR_USERLIST_AS_LOGICAL_LIST_OPERAND=35 CAN_NOT_ADD_A_SIMILAR_USERLIST_AS_LOGICAL_LIST_OPERAND value
                         * @property {number} CAN_NOT_MIX_CRM_BASED_IN_LOGICAL_LIST_WITH_OTHER_LISTS=36 CAN_NOT_MIX_CRM_BASED_IN_LOGICAL_LIST_WITH_OTHER_LISTS value
                         */
                        UserListErrorEnum.UserListError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "EXTERNAL_REMARKETING_USER_LIST_MUTATE_NOT_SUPPORTED"] = 2;
                            values[valuesById[3] = "CONCRETE_TYPE_REQUIRED"] = 3;
                            values[valuesById[4] = "CONVERSION_TYPE_ID_REQUIRED"] = 4;
                            values[valuesById[5] = "DUPLICATE_CONVERSION_TYPES"] = 5;
                            values[valuesById[6] = "INVALID_CONVERSION_TYPE"] = 6;
                            values[valuesById[7] = "INVALID_DESCRIPTION"] = 7;
                            values[valuesById[8] = "INVALID_NAME"] = 8;
                            values[valuesById[9] = "INVALID_TYPE"] = 9;
                            values[valuesById[10] = "CAN_NOT_ADD_LOGICAL_LIST_AS_LOGICAL_LIST_OPERAND"] = 10;
                            values[valuesById[11] = "INVALID_USER_LIST_LOGICAL_RULE_OPERAND"] = 11;
                            values[valuesById[12] = "NAME_ALREADY_USED"] = 12;
                            values[valuesById[13] = "NEW_CONVERSION_TYPE_NAME_REQUIRED"] = 13;
                            values[valuesById[14] = "CONVERSION_TYPE_NAME_ALREADY_USED"] = 14;
                            values[valuesById[15] = "OWNERSHIP_REQUIRED_FOR_SET"] = 15;
                            values[valuesById[16] = "USER_LIST_MUTATE_NOT_SUPPORTED"] = 16;
                            values[valuesById[17] = "INVALID_RULE"] = 17;
                            values[valuesById[27] = "INVALID_DATE_RANGE"] = 27;
                            values[valuesById[28] = "CAN_NOT_MUTATE_SENSITIVE_USERLIST"] = 28;
                            values[valuesById[29] = "MAX_NUM_RULEBASED_USERLISTS"] = 29;
                            values[valuesById[30] = "CANNOT_MODIFY_BILLABLE_RECORD_COUNT"] = 30;
                            values[valuesById[31] = "APP_ID_NOT_SET"] = 31;
                            values[valuesById[32] = "USERLIST_NAME_IS_RESERVED_FOR_SYSTEM_LIST"] = 32;
                            values[valuesById[33] = "ADVERTISER_NOT_WHITELISTED_FOR_USING_UPLOADED_DATA"] = 33;
                            values[valuesById[34] = "RULE_TYPE_IS_NOT_SUPPORTED"] = 34;
                            values[valuesById[35] = "CAN_NOT_ADD_A_SIMILAR_USERLIST_AS_LOGICAL_LIST_OPERAND"] = 35;
                            values[valuesById[36] = "CAN_NOT_MIX_CRM_BASED_IN_LOGICAL_LIST_WITH_OTHER_LISTS"] = 36;
                            return values;
                        })();

                        return UserListErrorEnum;
                    })();

                    errors.YoutubeVideoRegistrationErrorEnum = (function() {

                        /**
                         * Properties of a YoutubeVideoRegistrationErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @interface IYoutubeVideoRegistrationErrorEnum
                         */

                        /**
                         * Constructs a new YoutubeVideoRegistrationErrorEnum.
                         * @memberof google.ads.googleads.v1.errors
                         * @classdesc Represents a YoutubeVideoRegistrationErrorEnum.
                         * @implements IYoutubeVideoRegistrationErrorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.errors.IYoutubeVideoRegistrationErrorEnum=} [properties] Properties to set
                         */
                        function YoutubeVideoRegistrationErrorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new YoutubeVideoRegistrationErrorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IYoutubeVideoRegistrationErrorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum} YoutubeVideoRegistrationErrorEnum instance
                         */
                        YoutubeVideoRegistrationErrorEnum.create = function create(properties) {
                            return new YoutubeVideoRegistrationErrorEnum(properties);
                        };

                        /**
                         * Encodes the specified YoutubeVideoRegistrationErrorEnum message. Does not implicitly {@link google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IYoutubeVideoRegistrationErrorEnum} message YoutubeVideoRegistrationErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        YoutubeVideoRegistrationErrorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified YoutubeVideoRegistrationErrorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.IYoutubeVideoRegistrationErrorEnum} message YoutubeVideoRegistrationErrorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        YoutubeVideoRegistrationErrorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a YoutubeVideoRegistrationErrorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum} YoutubeVideoRegistrationErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        YoutubeVideoRegistrationErrorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a YoutubeVideoRegistrationErrorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum} YoutubeVideoRegistrationErrorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        YoutubeVideoRegistrationErrorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a YoutubeVideoRegistrationErrorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        YoutubeVideoRegistrationErrorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a YoutubeVideoRegistrationErrorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum} YoutubeVideoRegistrationErrorEnum
                         */
                        YoutubeVideoRegistrationErrorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum();
                        };

                        /**
                         * Creates a plain object from a YoutubeVideoRegistrationErrorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum
                         * @static
                         * @param {google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum} message YoutubeVideoRegistrationErrorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        YoutubeVideoRegistrationErrorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this YoutubeVideoRegistrationErrorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        YoutubeVideoRegistrationErrorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * YoutubeVideoRegistrationError enum.
                         * @name google.ads.googleads.v1.errors.YoutubeVideoRegistrationErrorEnum.YoutubeVideoRegistrationError
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} VIDEO_NOT_FOUND=2 VIDEO_NOT_FOUND value
                         * @property {number} VIDEO_NOT_ACCESSIBLE=3 VIDEO_NOT_ACCESSIBLE value
                         */
                        YoutubeVideoRegistrationErrorEnum.YoutubeVideoRegistrationError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "VIDEO_NOT_FOUND"] = 2;
                            values[valuesById[3] = "VIDEO_NOT_ACCESSIBLE"] = 3;
                            return values;
                        })();

                        return YoutubeVideoRegistrationErrorEnum;
                    })();

                    return errors;
                })();

                v1.enums = (function() {

                    /**
                     * Namespace enums.
                     * @memberof google.ads.googleads.v1
                     * @namespace
                     */
                    var enums = {};

                    enums.AccessReasonEnum = (function() {

                        /**
                         * Properties of an AccessReasonEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAccessReasonEnum
                         */

                        /**
                         * Constructs a new AccessReasonEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AccessReasonEnum.
                         * @implements IAccessReasonEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAccessReasonEnum=} [properties] Properties to set
                         */
                        function AccessReasonEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AccessReasonEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AccessReasonEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAccessReasonEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AccessReasonEnum} AccessReasonEnum instance
                         */
                        AccessReasonEnum.create = function create(properties) {
                            return new AccessReasonEnum(properties);
                        };

                        /**
                         * Encodes the specified AccessReasonEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AccessReasonEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AccessReasonEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAccessReasonEnum} message AccessReasonEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessReasonEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AccessReasonEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AccessReasonEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AccessReasonEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAccessReasonEnum} message AccessReasonEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessReasonEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AccessReasonEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AccessReasonEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AccessReasonEnum} AccessReasonEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessReasonEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AccessReasonEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AccessReasonEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AccessReasonEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AccessReasonEnum} AccessReasonEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessReasonEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AccessReasonEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AccessReasonEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessReasonEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AccessReasonEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AccessReasonEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AccessReasonEnum} AccessReasonEnum
                         */
                        AccessReasonEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AccessReasonEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AccessReasonEnum();
                        };

                        /**
                         * Creates a plain object from an AccessReasonEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AccessReasonEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AccessReasonEnum} message AccessReasonEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessReasonEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AccessReasonEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AccessReasonEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessReasonEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AccessReason enum.
                         * @name google.ads.googleads.v1.enums.AccessReasonEnum.AccessReason
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} OWNED=2 OWNED value
                         * @property {number} SHARED=3 SHARED value
                         * @property {number} LICENSED=4 LICENSED value
                         * @property {number} SUBSCRIBED=5 SUBSCRIBED value
                         * @property {number} AFFILIATED=6 AFFILIATED value
                         */
                        AccessReasonEnum.AccessReason = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "OWNED"] = 2;
                            values[valuesById[3] = "SHARED"] = 3;
                            values[valuesById[4] = "LICENSED"] = 4;
                            values[valuesById[5] = "SUBSCRIBED"] = 5;
                            values[valuesById[6] = "AFFILIATED"] = 6;
                            return values;
                        })();

                        return AccessReasonEnum;
                    })();

                    enums.AccountBudgetProposalStatusEnum = (function() {

                        /**
                         * Properties of an AccountBudgetProposalStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAccountBudgetProposalStatusEnum
                         */

                        /**
                         * Constructs a new AccountBudgetProposalStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AccountBudgetProposalStatusEnum.
                         * @implements IAccountBudgetProposalStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAccountBudgetProposalStatusEnum=} [properties] Properties to set
                         */
                        function AccountBudgetProposalStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AccountBudgetProposalStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAccountBudgetProposalStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum} AccountBudgetProposalStatusEnum instance
                         */
                        AccountBudgetProposalStatusEnum.create = function create(properties) {
                            return new AccountBudgetProposalStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified AccountBudgetProposalStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAccountBudgetProposalStatusEnum} message AccountBudgetProposalStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccountBudgetProposalStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AccountBudgetProposalStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAccountBudgetProposalStatusEnum} message AccountBudgetProposalStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccountBudgetProposalStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AccountBudgetProposalStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum} AccountBudgetProposalStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccountBudgetProposalStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AccountBudgetProposalStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum} AccountBudgetProposalStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccountBudgetProposalStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AccountBudgetProposalStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccountBudgetProposalStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AccountBudgetProposalStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum} AccountBudgetProposalStatusEnum
                         */
                        AccountBudgetProposalStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum();
                        };

                        /**
                         * Creates a plain object from an AccountBudgetProposalStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum} message AccountBudgetProposalStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccountBudgetProposalStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AccountBudgetProposalStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccountBudgetProposalStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AccountBudgetProposalStatus enum.
                         * @name google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum.AccountBudgetProposalStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} PENDING=2 PENDING value
                         * @property {number} APPROVED_HELD=3 APPROVED_HELD value
                         * @property {number} APPROVED=4 APPROVED value
                         * @property {number} CANCELLED=5 CANCELLED value
                         * @property {number} REJECTED=6 REJECTED value
                         */
                        AccountBudgetProposalStatusEnum.AccountBudgetProposalStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "PENDING"] = 2;
                            values[valuesById[3] = "APPROVED_HELD"] = 3;
                            values[valuesById[4] = "APPROVED"] = 4;
                            values[valuesById[5] = "CANCELLED"] = 5;
                            values[valuesById[6] = "REJECTED"] = 6;
                            return values;
                        })();

                        return AccountBudgetProposalStatusEnum;
                    })();

                    enums.AccountBudgetProposalTypeEnum = (function() {

                        /**
                         * Properties of an AccountBudgetProposalTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAccountBudgetProposalTypeEnum
                         */

                        /**
                         * Constructs a new AccountBudgetProposalTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AccountBudgetProposalTypeEnum.
                         * @implements IAccountBudgetProposalTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAccountBudgetProposalTypeEnum=} [properties] Properties to set
                         */
                        function AccountBudgetProposalTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AccountBudgetProposalTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAccountBudgetProposalTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum} AccountBudgetProposalTypeEnum instance
                         */
                        AccountBudgetProposalTypeEnum.create = function create(properties) {
                            return new AccountBudgetProposalTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified AccountBudgetProposalTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAccountBudgetProposalTypeEnum} message AccountBudgetProposalTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccountBudgetProposalTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AccountBudgetProposalTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAccountBudgetProposalTypeEnum} message AccountBudgetProposalTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccountBudgetProposalTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AccountBudgetProposalTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum} AccountBudgetProposalTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccountBudgetProposalTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AccountBudgetProposalTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum} AccountBudgetProposalTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccountBudgetProposalTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AccountBudgetProposalTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccountBudgetProposalTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AccountBudgetProposalTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum} AccountBudgetProposalTypeEnum
                         */
                        AccountBudgetProposalTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum();
                        };

                        /**
                         * Creates a plain object from an AccountBudgetProposalTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum} message AccountBudgetProposalTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccountBudgetProposalTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AccountBudgetProposalTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccountBudgetProposalTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AccountBudgetProposalType enum.
                         * @name google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum.AccountBudgetProposalType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CREATE=2 CREATE value
                         * @property {number} UPDATE=3 UPDATE value
                         * @property {number} END=4 END value
                         * @property {number} REMOVE=5 REMOVE value
                         */
                        AccountBudgetProposalTypeEnum.AccountBudgetProposalType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CREATE"] = 2;
                            values[valuesById[3] = "UPDATE"] = 3;
                            values[valuesById[4] = "END"] = 4;
                            values[valuesById[5] = "REMOVE"] = 5;
                            return values;
                        })();

                        return AccountBudgetProposalTypeEnum;
                    })();

                    enums.AccountBudgetStatusEnum = (function() {

                        /**
                         * Properties of an AccountBudgetStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAccountBudgetStatusEnum
                         */

                        /**
                         * Constructs a new AccountBudgetStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AccountBudgetStatusEnum.
                         * @implements IAccountBudgetStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAccountBudgetStatusEnum=} [properties] Properties to set
                         */
                        function AccountBudgetStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AccountBudgetStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAccountBudgetStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AccountBudgetStatusEnum} AccountBudgetStatusEnum instance
                         */
                        AccountBudgetStatusEnum.create = function create(properties) {
                            return new AccountBudgetStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified AccountBudgetStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AccountBudgetStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAccountBudgetStatusEnum} message AccountBudgetStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccountBudgetStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AccountBudgetStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AccountBudgetStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAccountBudgetStatusEnum} message AccountBudgetStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccountBudgetStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AccountBudgetStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AccountBudgetStatusEnum} AccountBudgetStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccountBudgetStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AccountBudgetStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AccountBudgetStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AccountBudgetStatusEnum} AccountBudgetStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccountBudgetStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AccountBudgetStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccountBudgetStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AccountBudgetStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AccountBudgetStatusEnum} AccountBudgetStatusEnum
                         */
                        AccountBudgetStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AccountBudgetStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AccountBudgetStatusEnum();
                        };

                        /**
                         * Creates a plain object from an AccountBudgetStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AccountBudgetStatusEnum} message AccountBudgetStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccountBudgetStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AccountBudgetStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AccountBudgetStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccountBudgetStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AccountBudgetStatus enum.
                         * @name google.ads.googleads.v1.enums.AccountBudgetStatusEnum.AccountBudgetStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} PENDING=2 PENDING value
                         * @property {number} APPROVED=3 APPROVED value
                         * @property {number} CANCELLED=4 CANCELLED value
                         */
                        AccountBudgetStatusEnum.AccountBudgetStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "PENDING"] = 2;
                            values[valuesById[3] = "APPROVED"] = 3;
                            values[valuesById[4] = "CANCELLED"] = 4;
                            return values;
                        })();

                        return AccountBudgetStatusEnum;
                    })();

                    enums.AdCustomizerPlaceholderFieldEnum = (function() {

                        /**
                         * Properties of an AdCustomizerPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAdCustomizerPlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new AdCustomizerPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AdCustomizerPlaceholderFieldEnum.
                         * @implements IAdCustomizerPlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAdCustomizerPlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function AdCustomizerPlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdCustomizerPlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdCustomizerPlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum} AdCustomizerPlaceholderFieldEnum instance
                         */
                        AdCustomizerPlaceholderFieldEnum.create = function create(properties) {
                            return new AdCustomizerPlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified AdCustomizerPlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdCustomizerPlaceholderFieldEnum} message AdCustomizerPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdCustomizerPlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdCustomizerPlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdCustomizerPlaceholderFieldEnum} message AdCustomizerPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdCustomizerPlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdCustomizerPlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum} AdCustomizerPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdCustomizerPlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdCustomizerPlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum} AdCustomizerPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdCustomizerPlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdCustomizerPlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdCustomizerPlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdCustomizerPlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum} AdCustomizerPlaceholderFieldEnum
                         */
                        AdCustomizerPlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from an AdCustomizerPlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum} message AdCustomizerPlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdCustomizerPlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdCustomizerPlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdCustomizerPlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdCustomizerPlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum.AdCustomizerPlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} INTEGER=2 INTEGER value
                         * @property {number} PRICE=3 PRICE value
                         * @property {number} DATE=4 DATE value
                         * @property {number} STRING=5 STRING value
                         */
                        AdCustomizerPlaceholderFieldEnum.AdCustomizerPlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "INTEGER"] = 2;
                            values[valuesById[3] = "PRICE"] = 3;
                            values[valuesById[4] = "DATE"] = 4;
                            values[valuesById[5] = "STRING"] = 5;
                            return values;
                        })();

                        return AdCustomizerPlaceholderFieldEnum;
                    })();

                    enums.AdGroupAdRotationModeEnum = (function() {

                        /**
                         * Properties of an AdGroupAdRotationModeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAdGroupAdRotationModeEnum
                         */

                        /**
                         * Constructs a new AdGroupAdRotationModeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AdGroupAdRotationModeEnum.
                         * @implements IAdGroupAdRotationModeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAdGroupAdRotationModeEnum=} [properties] Properties to set
                         */
                        function AdGroupAdRotationModeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdGroupAdRotationModeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdGroupAdRotationModeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum} AdGroupAdRotationModeEnum instance
                         */
                        AdGroupAdRotationModeEnum.create = function create(properties) {
                            return new AdGroupAdRotationModeEnum(properties);
                        };

                        /**
                         * Encodes the specified AdGroupAdRotationModeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdGroupAdRotationModeEnum} message AdGroupAdRotationModeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupAdRotationModeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupAdRotationModeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdGroupAdRotationModeEnum} message AdGroupAdRotationModeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupAdRotationModeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupAdRotationModeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum} AdGroupAdRotationModeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupAdRotationModeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupAdRotationModeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum} AdGroupAdRotationModeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupAdRotationModeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupAdRotationModeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupAdRotationModeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdGroupAdRotationModeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum} AdGroupAdRotationModeEnum
                         */
                        AdGroupAdRotationModeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum();
                        };

                        /**
                         * Creates a plain object from an AdGroupAdRotationModeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum} message AdGroupAdRotationModeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupAdRotationModeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdGroupAdRotationModeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupAdRotationModeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdGroupAdRotationMode enum.
                         * @name google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum.AdGroupAdRotationMode
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} OPTIMIZE=2 OPTIMIZE value
                         * @property {number} ROTATE_FOREVER=3 ROTATE_FOREVER value
                         */
                        AdGroupAdRotationModeEnum.AdGroupAdRotationMode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "OPTIMIZE"] = 2;
                            values[valuesById[3] = "ROTATE_FOREVER"] = 3;
                            return values;
                        })();

                        return AdGroupAdRotationModeEnum;
                    })();

                    enums.AdGroupAdStatusEnum = (function() {

                        /**
                         * Properties of an AdGroupAdStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAdGroupAdStatusEnum
                         */

                        /**
                         * Constructs a new AdGroupAdStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AdGroupAdStatusEnum.
                         * @implements IAdGroupAdStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAdGroupAdStatusEnum=} [properties] Properties to set
                         */
                        function AdGroupAdStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdGroupAdStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AdGroupAdStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdGroupAdStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AdGroupAdStatusEnum} AdGroupAdStatusEnum instance
                         */
                        AdGroupAdStatusEnum.create = function create(properties) {
                            return new AdGroupAdStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified AdGroupAdStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AdGroupAdStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AdGroupAdStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdGroupAdStatusEnum} message AdGroupAdStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupAdStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupAdStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AdGroupAdStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdGroupAdStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdGroupAdStatusEnum} message AdGroupAdStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupAdStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupAdStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AdGroupAdStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AdGroupAdStatusEnum} AdGroupAdStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupAdStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AdGroupAdStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupAdStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdGroupAdStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AdGroupAdStatusEnum} AdGroupAdStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupAdStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupAdStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AdGroupAdStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupAdStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdGroupAdStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AdGroupAdStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AdGroupAdStatusEnum} AdGroupAdStatusEnum
                         */
                        AdGroupAdStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AdGroupAdStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AdGroupAdStatusEnum();
                        };

                        /**
                         * Creates a plain object from an AdGroupAdStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AdGroupAdStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AdGroupAdStatusEnum} message AdGroupAdStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupAdStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdGroupAdStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AdGroupAdStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupAdStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdGroupAdStatus enum.
                         * @name google.ads.googleads.v1.enums.AdGroupAdStatusEnum.AdGroupAdStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENABLED=2 ENABLED value
                         * @property {number} PAUSED=3 PAUSED value
                         * @property {number} REMOVED=4 REMOVED value
                         */
                        AdGroupAdStatusEnum.AdGroupAdStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENABLED"] = 2;
                            values[valuesById[3] = "PAUSED"] = 3;
                            values[valuesById[4] = "REMOVED"] = 4;
                            return values;
                        })();

                        return AdGroupAdStatusEnum;
                    })();

                    enums.AdGroupCriterionApprovalStatusEnum = (function() {

                        /**
                         * Properties of an AdGroupCriterionApprovalStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAdGroupCriterionApprovalStatusEnum
                         */

                        /**
                         * Constructs a new AdGroupCriterionApprovalStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AdGroupCriterionApprovalStatusEnum.
                         * @implements IAdGroupCriterionApprovalStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAdGroupCriterionApprovalStatusEnum=} [properties] Properties to set
                         */
                        function AdGroupCriterionApprovalStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdGroupCriterionApprovalStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdGroupCriterionApprovalStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum} AdGroupCriterionApprovalStatusEnum instance
                         */
                        AdGroupCriterionApprovalStatusEnum.create = function create(properties) {
                            return new AdGroupCriterionApprovalStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified AdGroupCriterionApprovalStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdGroupCriterionApprovalStatusEnum} message AdGroupCriterionApprovalStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupCriterionApprovalStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupCriterionApprovalStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdGroupCriterionApprovalStatusEnum} message AdGroupCriterionApprovalStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupCriterionApprovalStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupCriterionApprovalStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum} AdGroupCriterionApprovalStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupCriterionApprovalStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupCriterionApprovalStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum} AdGroupCriterionApprovalStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupCriterionApprovalStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupCriterionApprovalStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupCriterionApprovalStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdGroupCriterionApprovalStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum} AdGroupCriterionApprovalStatusEnum
                         */
                        AdGroupCriterionApprovalStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum();
                        };

                        /**
                         * Creates a plain object from an AdGroupCriterionApprovalStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum} message AdGroupCriterionApprovalStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupCriterionApprovalStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdGroupCriterionApprovalStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupCriterionApprovalStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdGroupCriterionApprovalStatus enum.
                         * @name google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum.AdGroupCriterionApprovalStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} APPROVED=2 APPROVED value
                         * @property {number} DISAPPROVED=3 DISAPPROVED value
                         * @property {number} PENDING_REVIEW=4 PENDING_REVIEW value
                         * @property {number} UNDER_REVIEW=5 UNDER_REVIEW value
                         */
                        AdGroupCriterionApprovalStatusEnum.AdGroupCriterionApprovalStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "APPROVED"] = 2;
                            values[valuesById[3] = "DISAPPROVED"] = 3;
                            values[valuesById[4] = "PENDING_REVIEW"] = 4;
                            values[valuesById[5] = "UNDER_REVIEW"] = 5;
                            return values;
                        })();

                        return AdGroupCriterionApprovalStatusEnum;
                    })();

                    enums.AdGroupCriterionStatusEnum = (function() {

                        /**
                         * Properties of an AdGroupCriterionStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAdGroupCriterionStatusEnum
                         */

                        /**
                         * Constructs a new AdGroupCriterionStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AdGroupCriterionStatusEnum.
                         * @implements IAdGroupCriterionStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAdGroupCriterionStatusEnum=} [properties] Properties to set
                         */
                        function AdGroupCriterionStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdGroupCriterionStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdGroupCriterionStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum} AdGroupCriterionStatusEnum instance
                         */
                        AdGroupCriterionStatusEnum.create = function create(properties) {
                            return new AdGroupCriterionStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified AdGroupCriterionStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdGroupCriterionStatusEnum} message AdGroupCriterionStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupCriterionStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupCriterionStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdGroupCriterionStatusEnum} message AdGroupCriterionStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupCriterionStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupCriterionStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum} AdGroupCriterionStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupCriterionStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupCriterionStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum} AdGroupCriterionStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupCriterionStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupCriterionStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupCriterionStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdGroupCriterionStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum} AdGroupCriterionStatusEnum
                         */
                        AdGroupCriterionStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum();
                        };

                        /**
                         * Creates a plain object from an AdGroupCriterionStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum} message AdGroupCriterionStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupCriterionStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdGroupCriterionStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupCriterionStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdGroupCriterionStatus enum.
                         * @name google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum.AdGroupCriterionStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENABLED=2 ENABLED value
                         * @property {number} PAUSED=3 PAUSED value
                         * @property {number} REMOVED=4 REMOVED value
                         */
                        AdGroupCriterionStatusEnum.AdGroupCriterionStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENABLED"] = 2;
                            values[valuesById[3] = "PAUSED"] = 3;
                            values[valuesById[4] = "REMOVED"] = 4;
                            return values;
                        })();

                        return AdGroupCriterionStatusEnum;
                    })();

                    enums.AdGroupStatusEnum = (function() {

                        /**
                         * Properties of an AdGroupStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAdGroupStatusEnum
                         */

                        /**
                         * Constructs a new AdGroupStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AdGroupStatusEnum.
                         * @implements IAdGroupStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAdGroupStatusEnum=} [properties] Properties to set
                         */
                        function AdGroupStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdGroupStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AdGroupStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdGroupStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AdGroupStatusEnum} AdGroupStatusEnum instance
                         */
                        AdGroupStatusEnum.create = function create(properties) {
                            return new AdGroupStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified AdGroupStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AdGroupStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AdGroupStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdGroupStatusEnum} message AdGroupStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AdGroupStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdGroupStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdGroupStatusEnum} message AdGroupStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AdGroupStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AdGroupStatusEnum} AdGroupStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AdGroupStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdGroupStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AdGroupStatusEnum} AdGroupStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AdGroupStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdGroupStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AdGroupStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AdGroupStatusEnum} AdGroupStatusEnum
                         */
                        AdGroupStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AdGroupStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AdGroupStatusEnum();
                        };

                        /**
                         * Creates a plain object from an AdGroupStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AdGroupStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AdGroupStatusEnum} message AdGroupStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdGroupStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AdGroupStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdGroupStatus enum.
                         * @name google.ads.googleads.v1.enums.AdGroupStatusEnum.AdGroupStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENABLED=2 ENABLED value
                         * @property {number} PAUSED=3 PAUSED value
                         * @property {number} REMOVED=4 REMOVED value
                         */
                        AdGroupStatusEnum.AdGroupStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENABLED"] = 2;
                            values[valuesById[3] = "PAUSED"] = 3;
                            values[valuesById[4] = "REMOVED"] = 4;
                            return values;
                        })();

                        return AdGroupStatusEnum;
                    })();

                    enums.AdGroupTypeEnum = (function() {

                        /**
                         * Properties of an AdGroupTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAdGroupTypeEnum
                         */

                        /**
                         * Constructs a new AdGroupTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AdGroupTypeEnum.
                         * @implements IAdGroupTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAdGroupTypeEnum=} [properties] Properties to set
                         */
                        function AdGroupTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdGroupTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AdGroupTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdGroupTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AdGroupTypeEnum} AdGroupTypeEnum instance
                         */
                        AdGroupTypeEnum.create = function create(properties) {
                            return new AdGroupTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified AdGroupTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AdGroupTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AdGroupTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdGroupTypeEnum} message AdGroupTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AdGroupTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdGroupTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdGroupTypeEnum} message AdGroupTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AdGroupTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AdGroupTypeEnum} AdGroupTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AdGroupTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdGroupTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AdGroupTypeEnum} AdGroupTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AdGroupTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdGroupTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AdGroupTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AdGroupTypeEnum} AdGroupTypeEnum
                         */
                        AdGroupTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AdGroupTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AdGroupTypeEnum();
                        };

                        /**
                         * Creates a plain object from an AdGroupTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AdGroupTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AdGroupTypeEnum} message AdGroupTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdGroupTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AdGroupTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdGroupType enum.
                         * @name google.ads.googleads.v1.enums.AdGroupTypeEnum.AdGroupType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} SEARCH_STANDARD=2 SEARCH_STANDARD value
                         * @property {number} DISPLAY_STANDARD=3 DISPLAY_STANDARD value
                         * @property {number} SHOPPING_PRODUCT_ADS=4 SHOPPING_PRODUCT_ADS value
                         * @property {number} HOTEL_ADS=6 HOTEL_ADS value
                         * @property {number} SHOPPING_SMART_ADS=7 SHOPPING_SMART_ADS value
                         * @property {number} VIDEO_BUMPER=8 VIDEO_BUMPER value
                         * @property {number} VIDEO_TRUE_VIEW_IN_STREAM=9 VIDEO_TRUE_VIEW_IN_STREAM value
                         * @property {number} VIDEO_TRUE_VIEW_IN_DISPLAY=10 VIDEO_TRUE_VIEW_IN_DISPLAY value
                         * @property {number} VIDEO_NON_SKIPPABLE_IN_STREAM=11 VIDEO_NON_SKIPPABLE_IN_STREAM value
                         * @property {number} VIDEO_OUTSTREAM=12 VIDEO_OUTSTREAM value
                         * @property {number} SEARCH_DYNAMIC_ADS=13 SEARCH_DYNAMIC_ADS value
                         */
                        AdGroupTypeEnum.AdGroupType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "SEARCH_STANDARD"] = 2;
                            values[valuesById[3] = "DISPLAY_STANDARD"] = 3;
                            values[valuesById[4] = "SHOPPING_PRODUCT_ADS"] = 4;
                            values[valuesById[6] = "HOTEL_ADS"] = 6;
                            values[valuesById[7] = "SHOPPING_SMART_ADS"] = 7;
                            values[valuesById[8] = "VIDEO_BUMPER"] = 8;
                            values[valuesById[9] = "VIDEO_TRUE_VIEW_IN_STREAM"] = 9;
                            values[valuesById[10] = "VIDEO_TRUE_VIEW_IN_DISPLAY"] = 10;
                            values[valuesById[11] = "VIDEO_NON_SKIPPABLE_IN_STREAM"] = 11;
                            values[valuesById[12] = "VIDEO_OUTSTREAM"] = 12;
                            values[valuesById[13] = "SEARCH_DYNAMIC_ADS"] = 13;
                            return values;
                        })();

                        return AdGroupTypeEnum;
                    })();

                    enums.AdNetworkTypeEnum = (function() {

                        /**
                         * Properties of an AdNetworkTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAdNetworkTypeEnum
                         */

                        /**
                         * Constructs a new AdNetworkTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AdNetworkTypeEnum.
                         * @implements IAdNetworkTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAdNetworkTypeEnum=} [properties] Properties to set
                         */
                        function AdNetworkTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdNetworkTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AdNetworkTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdNetworkTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AdNetworkTypeEnum} AdNetworkTypeEnum instance
                         */
                        AdNetworkTypeEnum.create = function create(properties) {
                            return new AdNetworkTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified AdNetworkTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AdNetworkTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AdNetworkTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdNetworkTypeEnum} message AdNetworkTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdNetworkTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdNetworkTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AdNetworkTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdNetworkTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdNetworkTypeEnum} message AdNetworkTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdNetworkTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdNetworkTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AdNetworkTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AdNetworkTypeEnum} AdNetworkTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdNetworkTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AdNetworkTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdNetworkTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdNetworkTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AdNetworkTypeEnum} AdNetworkTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdNetworkTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdNetworkTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AdNetworkTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdNetworkTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdNetworkTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AdNetworkTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AdNetworkTypeEnum} AdNetworkTypeEnum
                         */
                        AdNetworkTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AdNetworkTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AdNetworkTypeEnum();
                        };

                        /**
                         * Creates a plain object from an AdNetworkTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AdNetworkTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AdNetworkTypeEnum} message AdNetworkTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdNetworkTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdNetworkTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AdNetworkTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdNetworkTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdNetworkType enum.
                         * @name google.ads.googleads.v1.enums.AdNetworkTypeEnum.AdNetworkType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} SEARCH=2 SEARCH value
                         * @property {number} SEARCH_PARTNERS=3 SEARCH_PARTNERS value
                         * @property {number} CONTENT=4 CONTENT value
                         * @property {number} YOUTUBE_SEARCH=5 YOUTUBE_SEARCH value
                         * @property {number} YOUTUBE_WATCH=6 YOUTUBE_WATCH value
                         * @property {number} MIXED=7 MIXED value
                         */
                        AdNetworkTypeEnum.AdNetworkType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "SEARCH"] = 2;
                            values[valuesById[3] = "SEARCH_PARTNERS"] = 3;
                            values[valuesById[4] = "CONTENT"] = 4;
                            values[valuesById[5] = "YOUTUBE_SEARCH"] = 5;
                            values[valuesById[6] = "YOUTUBE_WATCH"] = 6;
                            values[valuesById[7] = "MIXED"] = 7;
                            return values;
                        })();

                        return AdNetworkTypeEnum;
                    })();

                    enums.AdServingOptimizationStatusEnum = (function() {

                        /**
                         * Properties of an AdServingOptimizationStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAdServingOptimizationStatusEnum
                         */

                        /**
                         * Constructs a new AdServingOptimizationStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AdServingOptimizationStatusEnum.
                         * @implements IAdServingOptimizationStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAdServingOptimizationStatusEnum=} [properties] Properties to set
                         */
                        function AdServingOptimizationStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdServingOptimizationStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdServingOptimizationStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum} AdServingOptimizationStatusEnum instance
                         */
                        AdServingOptimizationStatusEnum.create = function create(properties) {
                            return new AdServingOptimizationStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified AdServingOptimizationStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdServingOptimizationStatusEnum} message AdServingOptimizationStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdServingOptimizationStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdServingOptimizationStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdServingOptimizationStatusEnum} message AdServingOptimizationStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdServingOptimizationStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdServingOptimizationStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum} AdServingOptimizationStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdServingOptimizationStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdServingOptimizationStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum} AdServingOptimizationStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdServingOptimizationStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdServingOptimizationStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdServingOptimizationStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdServingOptimizationStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum} AdServingOptimizationStatusEnum
                         */
                        AdServingOptimizationStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum();
                        };

                        /**
                         * Creates a plain object from an AdServingOptimizationStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum} message AdServingOptimizationStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdServingOptimizationStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdServingOptimizationStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdServingOptimizationStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdServingOptimizationStatus enum.
                         * @name google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum.AdServingOptimizationStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} OPTIMIZE=2 OPTIMIZE value
                         * @property {number} CONVERSION_OPTIMIZE=3 CONVERSION_OPTIMIZE value
                         * @property {number} ROTATE=4 ROTATE value
                         * @property {number} ROTATE_INDEFINITELY=5 ROTATE_INDEFINITELY value
                         * @property {number} UNAVAILABLE=6 UNAVAILABLE value
                         */
                        AdServingOptimizationStatusEnum.AdServingOptimizationStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "OPTIMIZE"] = 2;
                            values[valuesById[3] = "CONVERSION_OPTIMIZE"] = 3;
                            values[valuesById[4] = "ROTATE"] = 4;
                            values[valuesById[5] = "ROTATE_INDEFINITELY"] = 5;
                            values[valuesById[6] = "UNAVAILABLE"] = 6;
                            return values;
                        })();

                        return AdServingOptimizationStatusEnum;
                    })();

                    enums.AdStrengthEnum = (function() {

                        /**
                         * Properties of an AdStrengthEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAdStrengthEnum
                         */

                        /**
                         * Constructs a new AdStrengthEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AdStrengthEnum.
                         * @implements IAdStrengthEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAdStrengthEnum=} [properties] Properties to set
                         */
                        function AdStrengthEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdStrengthEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AdStrengthEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdStrengthEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AdStrengthEnum} AdStrengthEnum instance
                         */
                        AdStrengthEnum.create = function create(properties) {
                            return new AdStrengthEnum(properties);
                        };

                        /**
                         * Encodes the specified AdStrengthEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AdStrengthEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AdStrengthEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdStrengthEnum} message AdStrengthEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdStrengthEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdStrengthEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AdStrengthEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdStrengthEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdStrengthEnum} message AdStrengthEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdStrengthEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdStrengthEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AdStrengthEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AdStrengthEnum} AdStrengthEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdStrengthEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AdStrengthEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdStrengthEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdStrengthEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AdStrengthEnum} AdStrengthEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdStrengthEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdStrengthEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AdStrengthEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdStrengthEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdStrengthEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AdStrengthEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AdStrengthEnum} AdStrengthEnum
                         */
                        AdStrengthEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AdStrengthEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AdStrengthEnum();
                        };

                        /**
                         * Creates a plain object from an AdStrengthEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AdStrengthEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AdStrengthEnum} message AdStrengthEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdStrengthEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdStrengthEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AdStrengthEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdStrengthEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdStrength enum.
                         * @name google.ads.googleads.v1.enums.AdStrengthEnum.AdStrength
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} PENDING=2 PENDING value
                         * @property {number} NO_ADS=3 NO_ADS value
                         * @property {number} POOR=4 POOR value
                         * @property {number} AVERAGE=5 AVERAGE value
                         * @property {number} GOOD=6 GOOD value
                         * @property {number} EXCELLENT=7 EXCELLENT value
                         */
                        AdStrengthEnum.AdStrength = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "PENDING"] = 2;
                            values[valuesById[3] = "NO_ADS"] = 3;
                            values[valuesById[4] = "POOR"] = 4;
                            values[valuesById[5] = "AVERAGE"] = 5;
                            values[valuesById[6] = "GOOD"] = 6;
                            values[valuesById[7] = "EXCELLENT"] = 7;
                            return values;
                        })();

                        return AdStrengthEnum;
                    })();

                    enums.AdTypeEnum = (function() {

                        /**
                         * Properties of an AdTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAdTypeEnum
                         */

                        /**
                         * Constructs a new AdTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AdTypeEnum.
                         * @implements IAdTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAdTypeEnum=} [properties] Properties to set
                         */
                        function AdTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AdTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AdTypeEnum} AdTypeEnum instance
                         */
                        AdTypeEnum.create = function create(properties) {
                            return new AdTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified AdTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AdTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AdTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdTypeEnum} message AdTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AdTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdTypeEnum} message AdTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AdTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AdTypeEnum} AdTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AdTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AdTypeEnum} AdTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AdTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AdTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AdTypeEnum} AdTypeEnum
                         */
                        AdTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AdTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AdTypeEnum();
                        };

                        /**
                         * Creates a plain object from an AdTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AdTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AdTypeEnum} message AdTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AdTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdType enum.
                         * @name google.ads.googleads.v1.enums.AdTypeEnum.AdType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} TEXT_AD=2 TEXT_AD value
                         * @property {number} EXPANDED_TEXT_AD=3 EXPANDED_TEXT_AD value
                         * @property {number} CALL_ONLY_AD=6 CALL_ONLY_AD value
                         * @property {number} EXPANDED_DYNAMIC_SEARCH_AD=7 EXPANDED_DYNAMIC_SEARCH_AD value
                         * @property {number} HOTEL_AD=8 HOTEL_AD value
                         * @property {number} SHOPPING_SMART_AD=9 SHOPPING_SMART_AD value
                         * @property {number} SHOPPING_PRODUCT_AD=10 SHOPPING_PRODUCT_AD value
                         * @property {number} VIDEO_AD=12 VIDEO_AD value
                         * @property {number} GMAIL_AD=13 GMAIL_AD value
                         * @property {number} IMAGE_AD=14 IMAGE_AD value
                         * @property {number} RESPONSIVE_SEARCH_AD=15 RESPONSIVE_SEARCH_AD value
                         * @property {number} LEGACY_RESPONSIVE_DISPLAY_AD=16 LEGACY_RESPONSIVE_DISPLAY_AD value
                         * @property {number} APP_AD=17 APP_AD value
                         * @property {number} LEGACY_APP_INSTALL_AD=18 LEGACY_APP_INSTALL_AD value
                         * @property {number} RESPONSIVE_DISPLAY_AD=19 RESPONSIVE_DISPLAY_AD value
                         * @property {number} HTML5_UPLOAD_AD=21 HTML5_UPLOAD_AD value
                         * @property {number} DYNAMIC_HTML5_AD=22 DYNAMIC_HTML5_AD value
                         * @property {number} APP_ENGAGEMENT_AD=23 APP_ENGAGEMENT_AD value
                         */
                        AdTypeEnum.AdType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "TEXT_AD"] = 2;
                            values[valuesById[3] = "EXPANDED_TEXT_AD"] = 3;
                            values[valuesById[6] = "CALL_ONLY_AD"] = 6;
                            values[valuesById[7] = "EXPANDED_DYNAMIC_SEARCH_AD"] = 7;
                            values[valuesById[8] = "HOTEL_AD"] = 8;
                            values[valuesById[9] = "SHOPPING_SMART_AD"] = 9;
                            values[valuesById[10] = "SHOPPING_PRODUCT_AD"] = 10;
                            values[valuesById[12] = "VIDEO_AD"] = 12;
                            values[valuesById[13] = "GMAIL_AD"] = 13;
                            values[valuesById[14] = "IMAGE_AD"] = 14;
                            values[valuesById[15] = "RESPONSIVE_SEARCH_AD"] = 15;
                            values[valuesById[16] = "LEGACY_RESPONSIVE_DISPLAY_AD"] = 16;
                            values[valuesById[17] = "APP_AD"] = 17;
                            values[valuesById[18] = "LEGACY_APP_INSTALL_AD"] = 18;
                            values[valuesById[19] = "RESPONSIVE_DISPLAY_AD"] = 19;
                            values[valuesById[21] = "HTML5_UPLOAD_AD"] = 21;
                            values[valuesById[22] = "DYNAMIC_HTML5_AD"] = 22;
                            values[valuesById[23] = "APP_ENGAGEMENT_AD"] = 23;
                            return values;
                        })();

                        return AdTypeEnum;
                    })();

                    enums.AdvertisingChannelSubTypeEnum = (function() {

                        /**
                         * Properties of an AdvertisingChannelSubTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAdvertisingChannelSubTypeEnum
                         */

                        /**
                         * Constructs a new AdvertisingChannelSubTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AdvertisingChannelSubTypeEnum.
                         * @implements IAdvertisingChannelSubTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAdvertisingChannelSubTypeEnum=} [properties] Properties to set
                         */
                        function AdvertisingChannelSubTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdvertisingChannelSubTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdvertisingChannelSubTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum} AdvertisingChannelSubTypeEnum instance
                         */
                        AdvertisingChannelSubTypeEnum.create = function create(properties) {
                            return new AdvertisingChannelSubTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified AdvertisingChannelSubTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdvertisingChannelSubTypeEnum} message AdvertisingChannelSubTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdvertisingChannelSubTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdvertisingChannelSubTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdvertisingChannelSubTypeEnum} message AdvertisingChannelSubTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdvertisingChannelSubTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdvertisingChannelSubTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum} AdvertisingChannelSubTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdvertisingChannelSubTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdvertisingChannelSubTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum} AdvertisingChannelSubTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdvertisingChannelSubTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdvertisingChannelSubTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdvertisingChannelSubTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdvertisingChannelSubTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum} AdvertisingChannelSubTypeEnum
                         */
                        AdvertisingChannelSubTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum();
                        };

                        /**
                         * Creates a plain object from an AdvertisingChannelSubTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum} message AdvertisingChannelSubTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdvertisingChannelSubTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdvertisingChannelSubTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdvertisingChannelSubTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdvertisingChannelSubType enum.
                         * @name google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum.AdvertisingChannelSubType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} SEARCH_MOBILE_APP=2 SEARCH_MOBILE_APP value
                         * @property {number} DISPLAY_MOBILE_APP=3 DISPLAY_MOBILE_APP value
                         * @property {number} SEARCH_EXPRESS=4 SEARCH_EXPRESS value
                         * @property {number} DISPLAY_EXPRESS=5 DISPLAY_EXPRESS value
                         * @property {number} SHOPPING_SMART_ADS=6 SHOPPING_SMART_ADS value
                         * @property {number} DISPLAY_GMAIL_AD=7 DISPLAY_GMAIL_AD value
                         * @property {number} DISPLAY_SMART_CAMPAIGN=8 DISPLAY_SMART_CAMPAIGN value
                         * @property {number} VIDEO_OUTSTREAM=9 VIDEO_OUTSTREAM value
                         * @property {number} VIDEO_ACTION=10 VIDEO_ACTION value
                         * @property {number} VIDEO_NON_SKIPPABLE=11 VIDEO_NON_SKIPPABLE value
                         * @property {number} APP_CAMPAIGN=12 APP_CAMPAIGN value
                         * @property {number} APP_CAMPAIGN_FOR_ENGAGEMENT=13 APP_CAMPAIGN_FOR_ENGAGEMENT value
                         */
                        AdvertisingChannelSubTypeEnum.AdvertisingChannelSubType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "SEARCH_MOBILE_APP"] = 2;
                            values[valuesById[3] = "DISPLAY_MOBILE_APP"] = 3;
                            values[valuesById[4] = "SEARCH_EXPRESS"] = 4;
                            values[valuesById[5] = "DISPLAY_EXPRESS"] = 5;
                            values[valuesById[6] = "SHOPPING_SMART_ADS"] = 6;
                            values[valuesById[7] = "DISPLAY_GMAIL_AD"] = 7;
                            values[valuesById[8] = "DISPLAY_SMART_CAMPAIGN"] = 8;
                            values[valuesById[9] = "VIDEO_OUTSTREAM"] = 9;
                            values[valuesById[10] = "VIDEO_ACTION"] = 10;
                            values[valuesById[11] = "VIDEO_NON_SKIPPABLE"] = 11;
                            values[valuesById[12] = "APP_CAMPAIGN"] = 12;
                            values[valuesById[13] = "APP_CAMPAIGN_FOR_ENGAGEMENT"] = 13;
                            return values;
                        })();

                        return AdvertisingChannelSubTypeEnum;
                    })();

                    enums.AdvertisingChannelTypeEnum = (function() {

                        /**
                         * Properties of an AdvertisingChannelTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAdvertisingChannelTypeEnum
                         */

                        /**
                         * Constructs a new AdvertisingChannelTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AdvertisingChannelTypeEnum.
                         * @implements IAdvertisingChannelTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAdvertisingChannelTypeEnum=} [properties] Properties to set
                         */
                        function AdvertisingChannelTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AdvertisingChannelTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdvertisingChannelTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum} AdvertisingChannelTypeEnum instance
                         */
                        AdvertisingChannelTypeEnum.create = function create(properties) {
                            return new AdvertisingChannelTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified AdvertisingChannelTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdvertisingChannelTypeEnum} message AdvertisingChannelTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdvertisingChannelTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdvertisingChannelTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAdvertisingChannelTypeEnum} message AdvertisingChannelTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdvertisingChannelTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdvertisingChannelTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum} AdvertisingChannelTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdvertisingChannelTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdvertisingChannelTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum} AdvertisingChannelTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdvertisingChannelTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdvertisingChannelTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdvertisingChannelTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AdvertisingChannelTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum} AdvertisingChannelTypeEnum
                         */
                        AdvertisingChannelTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum();
                        };

                        /**
                         * Creates a plain object from an AdvertisingChannelTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum} message AdvertisingChannelTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdvertisingChannelTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AdvertisingChannelTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdvertisingChannelTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AdvertisingChannelType enum.
                         * @name google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum.AdvertisingChannelType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} SEARCH=2 SEARCH value
                         * @property {number} DISPLAY=3 DISPLAY value
                         * @property {number} SHOPPING=4 SHOPPING value
                         * @property {number} HOTEL=5 HOTEL value
                         * @property {number} VIDEO=6 VIDEO value
                         * @property {number} MULTI_CHANNEL=7 MULTI_CHANNEL value
                         */
                        AdvertisingChannelTypeEnum.AdvertisingChannelType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "SEARCH"] = 2;
                            values[valuesById[3] = "DISPLAY"] = 3;
                            values[valuesById[4] = "SHOPPING"] = 4;
                            values[valuesById[5] = "HOTEL"] = 5;
                            values[valuesById[6] = "VIDEO"] = 6;
                            values[valuesById[7] = "MULTI_CHANNEL"] = 7;
                            return values;
                        })();

                        return AdvertisingChannelTypeEnum;
                    })();

                    enums.AffiliateLocationFeedRelationshipTypeEnum = (function() {

                        /**
                         * Properties of an AffiliateLocationFeedRelationshipTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAffiliateLocationFeedRelationshipTypeEnum
                         */

                        /**
                         * Constructs a new AffiliateLocationFeedRelationshipTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AffiliateLocationFeedRelationshipTypeEnum.
                         * @implements IAffiliateLocationFeedRelationshipTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAffiliateLocationFeedRelationshipTypeEnum=} [properties] Properties to set
                         */
                        function AffiliateLocationFeedRelationshipTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AffiliateLocationFeedRelationshipTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAffiliateLocationFeedRelationshipTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum} AffiliateLocationFeedRelationshipTypeEnum instance
                         */
                        AffiliateLocationFeedRelationshipTypeEnum.create = function create(properties) {
                            return new AffiliateLocationFeedRelationshipTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified AffiliateLocationFeedRelationshipTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAffiliateLocationFeedRelationshipTypeEnum} message AffiliateLocationFeedRelationshipTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AffiliateLocationFeedRelationshipTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AffiliateLocationFeedRelationshipTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAffiliateLocationFeedRelationshipTypeEnum} message AffiliateLocationFeedRelationshipTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AffiliateLocationFeedRelationshipTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AffiliateLocationFeedRelationshipTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum} AffiliateLocationFeedRelationshipTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AffiliateLocationFeedRelationshipTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AffiliateLocationFeedRelationshipTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum} AffiliateLocationFeedRelationshipTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AffiliateLocationFeedRelationshipTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AffiliateLocationFeedRelationshipTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AffiliateLocationFeedRelationshipTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AffiliateLocationFeedRelationshipTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum} AffiliateLocationFeedRelationshipTypeEnum
                         */
                        AffiliateLocationFeedRelationshipTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum();
                        };

                        /**
                         * Creates a plain object from an AffiliateLocationFeedRelationshipTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum} message AffiliateLocationFeedRelationshipTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AffiliateLocationFeedRelationshipTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AffiliateLocationFeedRelationshipTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AffiliateLocationFeedRelationshipTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AffiliateLocationFeedRelationshipType enum.
                         * @name google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum.AffiliateLocationFeedRelationshipType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} GENERAL_RETAILER=2 GENERAL_RETAILER value
                         */
                        AffiliateLocationFeedRelationshipTypeEnum.AffiliateLocationFeedRelationshipType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "GENERAL_RETAILER"] = 2;
                            return values;
                        })();

                        return AffiliateLocationFeedRelationshipTypeEnum;
                    })();

                    enums.AffiliateLocationPlaceholderFieldEnum = (function() {

                        /**
                         * Properties of an AffiliateLocationPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAffiliateLocationPlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new AffiliateLocationPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AffiliateLocationPlaceholderFieldEnum.
                         * @implements IAffiliateLocationPlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAffiliateLocationPlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function AffiliateLocationPlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AffiliateLocationPlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAffiliateLocationPlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum} AffiliateLocationPlaceholderFieldEnum instance
                         */
                        AffiliateLocationPlaceholderFieldEnum.create = function create(properties) {
                            return new AffiliateLocationPlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified AffiliateLocationPlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAffiliateLocationPlaceholderFieldEnum} message AffiliateLocationPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AffiliateLocationPlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AffiliateLocationPlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAffiliateLocationPlaceholderFieldEnum} message AffiliateLocationPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AffiliateLocationPlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AffiliateLocationPlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum} AffiliateLocationPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AffiliateLocationPlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AffiliateLocationPlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum} AffiliateLocationPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AffiliateLocationPlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AffiliateLocationPlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AffiliateLocationPlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AffiliateLocationPlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum} AffiliateLocationPlaceholderFieldEnum
                         */
                        AffiliateLocationPlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from an AffiliateLocationPlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum} message AffiliateLocationPlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AffiliateLocationPlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AffiliateLocationPlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AffiliateLocationPlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AffiliateLocationPlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum.AffiliateLocationPlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} BUSINESS_NAME=2 BUSINESS_NAME value
                         * @property {number} ADDRESS_LINE_1=3 ADDRESS_LINE_1 value
                         * @property {number} ADDRESS_LINE_2=4 ADDRESS_LINE_2 value
                         * @property {number} CITY=5 CITY value
                         * @property {number} PROVINCE=6 PROVINCE value
                         * @property {number} POSTAL_CODE=7 POSTAL_CODE value
                         * @property {number} COUNTRY_CODE=8 COUNTRY_CODE value
                         * @property {number} PHONE_NUMBER=9 PHONE_NUMBER value
                         * @property {number} LANGUAGE_CODE=10 LANGUAGE_CODE value
                         * @property {number} CHAIN_ID=11 CHAIN_ID value
                         * @property {number} CHAIN_NAME=12 CHAIN_NAME value
                         */
                        AffiliateLocationPlaceholderFieldEnum.AffiliateLocationPlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "BUSINESS_NAME"] = 2;
                            values[valuesById[3] = "ADDRESS_LINE_1"] = 3;
                            values[valuesById[4] = "ADDRESS_LINE_2"] = 4;
                            values[valuesById[5] = "CITY"] = 5;
                            values[valuesById[6] = "PROVINCE"] = 6;
                            values[valuesById[7] = "POSTAL_CODE"] = 7;
                            values[valuesById[8] = "COUNTRY_CODE"] = 8;
                            values[valuesById[9] = "PHONE_NUMBER"] = 9;
                            values[valuesById[10] = "LANGUAGE_CODE"] = 10;
                            values[valuesById[11] = "CHAIN_ID"] = 11;
                            values[valuesById[12] = "CHAIN_NAME"] = 12;
                            return values;
                        })();

                        return AffiliateLocationPlaceholderFieldEnum;
                    })();

                    enums.AgeRangeTypeEnum = (function() {

                        /**
                         * Properties of an AgeRangeTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAgeRangeTypeEnum
                         */

                        /**
                         * Constructs a new AgeRangeTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AgeRangeTypeEnum.
                         * @implements IAgeRangeTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAgeRangeTypeEnum=} [properties] Properties to set
                         */
                        function AgeRangeTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AgeRangeTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AgeRangeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAgeRangeTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AgeRangeTypeEnum} AgeRangeTypeEnum instance
                         */
                        AgeRangeTypeEnum.create = function create(properties) {
                            return new AgeRangeTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified AgeRangeTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AgeRangeTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AgeRangeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAgeRangeTypeEnum} message AgeRangeTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AgeRangeTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AgeRangeTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AgeRangeTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AgeRangeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAgeRangeTypeEnum} message AgeRangeTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AgeRangeTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AgeRangeTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AgeRangeTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AgeRangeTypeEnum} AgeRangeTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AgeRangeTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AgeRangeTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AgeRangeTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AgeRangeTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AgeRangeTypeEnum} AgeRangeTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AgeRangeTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AgeRangeTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AgeRangeTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AgeRangeTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AgeRangeTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AgeRangeTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AgeRangeTypeEnum} AgeRangeTypeEnum
                         */
                        AgeRangeTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AgeRangeTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AgeRangeTypeEnum();
                        };

                        /**
                         * Creates a plain object from an AgeRangeTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AgeRangeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AgeRangeTypeEnum} message AgeRangeTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AgeRangeTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AgeRangeTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AgeRangeTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AgeRangeTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AgeRangeType enum.
                         * @name google.ads.googleads.v1.enums.AgeRangeTypeEnum.AgeRangeType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} AGE_RANGE_18_24=503001 AGE_RANGE_18_24 value
                         * @property {number} AGE_RANGE_25_34=503002 AGE_RANGE_25_34 value
                         * @property {number} AGE_RANGE_35_44=503003 AGE_RANGE_35_44 value
                         * @property {number} AGE_RANGE_45_54=503004 AGE_RANGE_45_54 value
                         * @property {number} AGE_RANGE_55_64=503005 AGE_RANGE_55_64 value
                         * @property {number} AGE_RANGE_65_UP=503006 AGE_RANGE_65_UP value
                         * @property {number} AGE_RANGE_UNDETERMINED=503999 AGE_RANGE_UNDETERMINED value
                         */
                        AgeRangeTypeEnum.AgeRangeType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[503001] = "AGE_RANGE_18_24"] = 503001;
                            values[valuesById[503002] = "AGE_RANGE_25_34"] = 503002;
                            values[valuesById[503003] = "AGE_RANGE_35_44"] = 503003;
                            values[valuesById[503004] = "AGE_RANGE_45_54"] = 503004;
                            values[valuesById[503005] = "AGE_RANGE_55_64"] = 503005;
                            values[valuesById[503006] = "AGE_RANGE_65_UP"] = 503006;
                            values[valuesById[503999] = "AGE_RANGE_UNDETERMINED"] = 503999;
                            return values;
                        })();

                        return AgeRangeTypeEnum;
                    })();

                    enums.AppCampaignAppStoreEnum = (function() {

                        /**
                         * Properties of an AppCampaignAppStoreEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAppCampaignAppStoreEnum
                         */

                        /**
                         * Constructs a new AppCampaignAppStoreEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AppCampaignAppStoreEnum.
                         * @implements IAppCampaignAppStoreEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAppCampaignAppStoreEnum=} [properties] Properties to set
                         */
                        function AppCampaignAppStoreEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AppCampaignAppStoreEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AppCampaignAppStoreEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAppCampaignAppStoreEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AppCampaignAppStoreEnum} AppCampaignAppStoreEnum instance
                         */
                        AppCampaignAppStoreEnum.create = function create(properties) {
                            return new AppCampaignAppStoreEnum(properties);
                        };

                        /**
                         * Encodes the specified AppCampaignAppStoreEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AppCampaignAppStoreEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AppCampaignAppStoreEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAppCampaignAppStoreEnum} message AppCampaignAppStoreEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppCampaignAppStoreEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AppCampaignAppStoreEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AppCampaignAppStoreEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AppCampaignAppStoreEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAppCampaignAppStoreEnum} message AppCampaignAppStoreEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppCampaignAppStoreEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AppCampaignAppStoreEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AppCampaignAppStoreEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AppCampaignAppStoreEnum} AppCampaignAppStoreEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppCampaignAppStoreEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AppCampaignAppStoreEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AppCampaignAppStoreEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AppCampaignAppStoreEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AppCampaignAppStoreEnum} AppCampaignAppStoreEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppCampaignAppStoreEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AppCampaignAppStoreEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AppCampaignAppStoreEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AppCampaignAppStoreEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AppCampaignAppStoreEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AppCampaignAppStoreEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AppCampaignAppStoreEnum} AppCampaignAppStoreEnum
                         */
                        AppCampaignAppStoreEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AppCampaignAppStoreEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AppCampaignAppStoreEnum();
                        };

                        /**
                         * Creates a plain object from an AppCampaignAppStoreEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AppCampaignAppStoreEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AppCampaignAppStoreEnum} message AppCampaignAppStoreEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AppCampaignAppStoreEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AppCampaignAppStoreEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AppCampaignAppStoreEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AppCampaignAppStoreEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AppCampaignAppStore enum.
                         * @name google.ads.googleads.v1.enums.AppCampaignAppStoreEnum.AppCampaignAppStore
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} APPLE_APP_STORE=2 APPLE_APP_STORE value
                         * @property {number} GOOGLE_APP_STORE=3 GOOGLE_APP_STORE value
                         */
                        AppCampaignAppStoreEnum.AppCampaignAppStore = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "APPLE_APP_STORE"] = 2;
                            values[valuesById[3] = "GOOGLE_APP_STORE"] = 3;
                            return values;
                        })();

                        return AppCampaignAppStoreEnum;
                    })();

                    enums.AppCampaignBiddingStrategyGoalTypeEnum = (function() {

                        /**
                         * Properties of an AppCampaignBiddingStrategyGoalTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAppCampaignBiddingStrategyGoalTypeEnum
                         */

                        /**
                         * Constructs a new AppCampaignBiddingStrategyGoalTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AppCampaignBiddingStrategyGoalTypeEnum.
                         * @implements IAppCampaignBiddingStrategyGoalTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAppCampaignBiddingStrategyGoalTypeEnum=} [properties] Properties to set
                         */
                        function AppCampaignBiddingStrategyGoalTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AppCampaignBiddingStrategyGoalTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAppCampaignBiddingStrategyGoalTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum} AppCampaignBiddingStrategyGoalTypeEnum instance
                         */
                        AppCampaignBiddingStrategyGoalTypeEnum.create = function create(properties) {
                            return new AppCampaignBiddingStrategyGoalTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified AppCampaignBiddingStrategyGoalTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAppCampaignBiddingStrategyGoalTypeEnum} message AppCampaignBiddingStrategyGoalTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppCampaignBiddingStrategyGoalTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AppCampaignBiddingStrategyGoalTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAppCampaignBiddingStrategyGoalTypeEnum} message AppCampaignBiddingStrategyGoalTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppCampaignBiddingStrategyGoalTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AppCampaignBiddingStrategyGoalTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum} AppCampaignBiddingStrategyGoalTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppCampaignBiddingStrategyGoalTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AppCampaignBiddingStrategyGoalTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum} AppCampaignBiddingStrategyGoalTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppCampaignBiddingStrategyGoalTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AppCampaignBiddingStrategyGoalTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AppCampaignBiddingStrategyGoalTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AppCampaignBiddingStrategyGoalTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum} AppCampaignBiddingStrategyGoalTypeEnum
                         */
                        AppCampaignBiddingStrategyGoalTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum();
                        };

                        /**
                         * Creates a plain object from an AppCampaignBiddingStrategyGoalTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum} message AppCampaignBiddingStrategyGoalTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AppCampaignBiddingStrategyGoalTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AppCampaignBiddingStrategyGoalTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AppCampaignBiddingStrategyGoalTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AppCampaignBiddingStrategyGoalType enum.
                         * @name google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum.AppCampaignBiddingStrategyGoalType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} OPTIMIZE_INSTALLS_TARGET_INSTALL_COST=2 OPTIMIZE_INSTALLS_TARGET_INSTALL_COST value
                         * @property {number} OPTIMIZE_IN_APP_CONVERSIONS_TARGET_INSTALL_COST=3 OPTIMIZE_IN_APP_CONVERSIONS_TARGET_INSTALL_COST value
                         * @property {number} OPTIMIZE_IN_APP_CONVERSIONS_TARGET_CONVERSION_COST=4 OPTIMIZE_IN_APP_CONVERSIONS_TARGET_CONVERSION_COST value
                         * @property {number} OPTIMIZE_RETURN_ON_ADVERTISING_SPEND=5 OPTIMIZE_RETURN_ON_ADVERTISING_SPEND value
                         */
                        AppCampaignBiddingStrategyGoalTypeEnum.AppCampaignBiddingStrategyGoalType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "OPTIMIZE_INSTALLS_TARGET_INSTALL_COST"] = 2;
                            values[valuesById[3] = "OPTIMIZE_IN_APP_CONVERSIONS_TARGET_INSTALL_COST"] = 3;
                            values[valuesById[4] = "OPTIMIZE_IN_APP_CONVERSIONS_TARGET_CONVERSION_COST"] = 4;
                            values[valuesById[5] = "OPTIMIZE_RETURN_ON_ADVERTISING_SPEND"] = 5;
                            return values;
                        })();

                        return AppCampaignBiddingStrategyGoalTypeEnum;
                    })();

                    enums.AppPaymentModelTypeEnum = (function() {

                        /**
                         * Properties of an AppPaymentModelTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAppPaymentModelTypeEnum
                         */

                        /**
                         * Constructs a new AppPaymentModelTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AppPaymentModelTypeEnum.
                         * @implements IAppPaymentModelTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAppPaymentModelTypeEnum=} [properties] Properties to set
                         */
                        function AppPaymentModelTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AppPaymentModelTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AppPaymentModelTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAppPaymentModelTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AppPaymentModelTypeEnum} AppPaymentModelTypeEnum instance
                         */
                        AppPaymentModelTypeEnum.create = function create(properties) {
                            return new AppPaymentModelTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified AppPaymentModelTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AppPaymentModelTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AppPaymentModelTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAppPaymentModelTypeEnum} message AppPaymentModelTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppPaymentModelTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AppPaymentModelTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AppPaymentModelTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AppPaymentModelTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAppPaymentModelTypeEnum} message AppPaymentModelTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppPaymentModelTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AppPaymentModelTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AppPaymentModelTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AppPaymentModelTypeEnum} AppPaymentModelTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppPaymentModelTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AppPaymentModelTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AppPaymentModelTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AppPaymentModelTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AppPaymentModelTypeEnum} AppPaymentModelTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppPaymentModelTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AppPaymentModelTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AppPaymentModelTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AppPaymentModelTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AppPaymentModelTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AppPaymentModelTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AppPaymentModelTypeEnum} AppPaymentModelTypeEnum
                         */
                        AppPaymentModelTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AppPaymentModelTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AppPaymentModelTypeEnum();
                        };

                        /**
                         * Creates a plain object from an AppPaymentModelTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AppPaymentModelTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AppPaymentModelTypeEnum} message AppPaymentModelTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AppPaymentModelTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AppPaymentModelTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AppPaymentModelTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AppPaymentModelTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AppPaymentModelType enum.
                         * @name google.ads.googleads.v1.enums.AppPaymentModelTypeEnum.AppPaymentModelType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} PAID=30 PAID value
                         */
                        AppPaymentModelTypeEnum.AppPaymentModelType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[30] = "PAID"] = 30;
                            return values;
                        })();

                        return AppPaymentModelTypeEnum;
                    })();

                    enums.AppPlaceholderFieldEnum = (function() {

                        /**
                         * Properties of an AppPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAppPlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new AppPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AppPlaceholderFieldEnum.
                         * @implements IAppPlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAppPlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function AppPlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AppPlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AppPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAppPlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AppPlaceholderFieldEnum} AppPlaceholderFieldEnum instance
                         */
                        AppPlaceholderFieldEnum.create = function create(properties) {
                            return new AppPlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified AppPlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AppPlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AppPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAppPlaceholderFieldEnum} message AppPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppPlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AppPlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AppPlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AppPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAppPlaceholderFieldEnum} message AppPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppPlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AppPlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AppPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AppPlaceholderFieldEnum} AppPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppPlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AppPlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AppPlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AppPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AppPlaceholderFieldEnum} AppPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppPlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AppPlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AppPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AppPlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AppPlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AppPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AppPlaceholderFieldEnum} AppPlaceholderFieldEnum
                         */
                        AppPlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AppPlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AppPlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from an AppPlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AppPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AppPlaceholderFieldEnum} message AppPlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AppPlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AppPlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AppPlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AppPlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AppPlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.AppPlaceholderFieldEnum.AppPlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} STORE=2 STORE value
                         * @property {number} ID=3 ID value
                         * @property {number} LINK_TEXT=4 LINK_TEXT value
                         * @property {number} URL=5 URL value
                         * @property {number} FINAL_URLS=6 FINAL_URLS value
                         * @property {number} FINAL_MOBILE_URLS=7 FINAL_MOBILE_URLS value
                         * @property {number} TRACKING_URL=8 TRACKING_URL value
                         * @property {number} FINAL_URL_SUFFIX=9 FINAL_URL_SUFFIX value
                         */
                        AppPlaceholderFieldEnum.AppPlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "STORE"] = 2;
                            values[valuesById[3] = "ID"] = 3;
                            values[valuesById[4] = "LINK_TEXT"] = 4;
                            values[valuesById[5] = "URL"] = 5;
                            values[valuesById[6] = "FINAL_URLS"] = 6;
                            values[valuesById[7] = "FINAL_MOBILE_URLS"] = 7;
                            values[valuesById[8] = "TRACKING_URL"] = 8;
                            values[valuesById[9] = "FINAL_URL_SUFFIX"] = 9;
                            return values;
                        })();

                        return AppPlaceholderFieldEnum;
                    })();

                    enums.AppStoreEnum = (function() {

                        /**
                         * Properties of an AppStoreEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAppStoreEnum
                         */

                        /**
                         * Constructs a new AppStoreEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AppStoreEnum.
                         * @implements IAppStoreEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAppStoreEnum=} [properties] Properties to set
                         */
                        function AppStoreEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AppStoreEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AppStoreEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAppStoreEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AppStoreEnum} AppStoreEnum instance
                         */
                        AppStoreEnum.create = function create(properties) {
                            return new AppStoreEnum(properties);
                        };

                        /**
                         * Encodes the specified AppStoreEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AppStoreEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AppStoreEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAppStoreEnum} message AppStoreEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppStoreEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AppStoreEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AppStoreEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AppStoreEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAppStoreEnum} message AppStoreEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppStoreEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AppStoreEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AppStoreEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AppStoreEnum} AppStoreEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppStoreEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AppStoreEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AppStoreEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AppStoreEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AppStoreEnum} AppStoreEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppStoreEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AppStoreEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AppStoreEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AppStoreEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AppStoreEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AppStoreEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AppStoreEnum} AppStoreEnum
                         */
                        AppStoreEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AppStoreEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AppStoreEnum();
                        };

                        /**
                         * Creates a plain object from an AppStoreEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AppStoreEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AppStoreEnum} message AppStoreEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AppStoreEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AppStoreEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AppStoreEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AppStoreEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AppStore enum.
                         * @name google.ads.googleads.v1.enums.AppStoreEnum.AppStore
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} APPLE_ITUNES=2 APPLE_ITUNES value
                         * @property {number} GOOGLE_PLAY=3 GOOGLE_PLAY value
                         */
                        AppStoreEnum.AppStore = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "APPLE_ITUNES"] = 2;
                            values[valuesById[3] = "GOOGLE_PLAY"] = 3;
                            return values;
                        })();

                        return AppStoreEnum;
                    })();

                    enums.AppUrlOperatingSystemTypeEnum = (function() {

                        /**
                         * Properties of an AppUrlOperatingSystemTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAppUrlOperatingSystemTypeEnum
                         */

                        /**
                         * Constructs a new AppUrlOperatingSystemTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AppUrlOperatingSystemTypeEnum.
                         * @implements IAppUrlOperatingSystemTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAppUrlOperatingSystemTypeEnum=} [properties] Properties to set
                         */
                        function AppUrlOperatingSystemTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AppUrlOperatingSystemTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAppUrlOperatingSystemTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum} AppUrlOperatingSystemTypeEnum instance
                         */
                        AppUrlOperatingSystemTypeEnum.create = function create(properties) {
                            return new AppUrlOperatingSystemTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified AppUrlOperatingSystemTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAppUrlOperatingSystemTypeEnum} message AppUrlOperatingSystemTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppUrlOperatingSystemTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AppUrlOperatingSystemTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAppUrlOperatingSystemTypeEnum} message AppUrlOperatingSystemTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AppUrlOperatingSystemTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AppUrlOperatingSystemTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum} AppUrlOperatingSystemTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppUrlOperatingSystemTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AppUrlOperatingSystemTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum} AppUrlOperatingSystemTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AppUrlOperatingSystemTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AppUrlOperatingSystemTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AppUrlOperatingSystemTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AppUrlOperatingSystemTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum} AppUrlOperatingSystemTypeEnum
                         */
                        AppUrlOperatingSystemTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum();
                        };

                        /**
                         * Creates a plain object from an AppUrlOperatingSystemTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum} message AppUrlOperatingSystemTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AppUrlOperatingSystemTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AppUrlOperatingSystemTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AppUrlOperatingSystemTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AppUrlOperatingSystemType enum.
                         * @name google.ads.googleads.v1.enums.AppUrlOperatingSystemTypeEnum.AppUrlOperatingSystemType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} IOS=2 IOS value
                         * @property {number} ANDROID=3 ANDROID value
                         */
                        AppUrlOperatingSystemTypeEnum.AppUrlOperatingSystemType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "IOS"] = 2;
                            values[valuesById[3] = "ANDROID"] = 3;
                            return values;
                        })();

                        return AppUrlOperatingSystemTypeEnum;
                    })();

                    enums.AssetTypeEnum = (function() {

                        /**
                         * Properties of an AssetTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAssetTypeEnum
                         */

                        /**
                         * Constructs a new AssetTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AssetTypeEnum.
                         * @implements IAssetTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAssetTypeEnum=} [properties] Properties to set
                         */
                        function AssetTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AssetTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AssetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAssetTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AssetTypeEnum} AssetTypeEnum instance
                         */
                        AssetTypeEnum.create = function create(properties) {
                            return new AssetTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified AssetTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AssetTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AssetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAssetTypeEnum} message AssetTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AssetTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AssetTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AssetTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AssetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAssetTypeEnum} message AssetTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AssetTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AssetTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AssetTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AssetTypeEnum} AssetTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AssetTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AssetTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AssetTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AssetTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AssetTypeEnum} AssetTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AssetTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AssetTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AssetTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AssetTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AssetTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AssetTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AssetTypeEnum} AssetTypeEnum
                         */
                        AssetTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AssetTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AssetTypeEnum();
                        };

                        /**
                         * Creates a plain object from an AssetTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AssetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AssetTypeEnum} message AssetTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AssetTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AssetTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AssetTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AssetTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AssetType enum.
                         * @name google.ads.googleads.v1.enums.AssetTypeEnum.AssetType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} YOUTUBE_VIDEO=2 YOUTUBE_VIDEO value
                         * @property {number} MEDIA_BUNDLE=3 MEDIA_BUNDLE value
                         * @property {number} IMAGE=4 IMAGE value
                         * @property {number} TEXT=5 TEXT value
                         */
                        AssetTypeEnum.AssetType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "YOUTUBE_VIDEO"] = 2;
                            values[valuesById[3] = "MEDIA_BUNDLE"] = 3;
                            values[valuesById[4] = "IMAGE"] = 4;
                            values[valuesById[5] = "TEXT"] = 5;
                            return values;
                        })();

                        return AssetTypeEnum;
                    })();

                    enums.AttributionModelEnum = (function() {

                        /**
                         * Properties of an AttributionModelEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IAttributionModelEnum
                         */

                        /**
                         * Constructs a new AttributionModelEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an AttributionModelEnum.
                         * @implements IAttributionModelEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IAttributionModelEnum=} [properties] Properties to set
                         */
                        function AttributionModelEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new AttributionModelEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.AttributionModelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAttributionModelEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.AttributionModelEnum} AttributionModelEnum instance
                         */
                        AttributionModelEnum.create = function create(properties) {
                            return new AttributionModelEnum(properties);
                        };

                        /**
                         * Encodes the specified AttributionModelEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.AttributionModelEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.AttributionModelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAttributionModelEnum} message AttributionModelEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AttributionModelEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified AttributionModelEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.AttributionModelEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AttributionModelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IAttributionModelEnum} message AttributionModelEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AttributionModelEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AttributionModelEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.AttributionModelEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.AttributionModelEnum} AttributionModelEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AttributionModelEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.AttributionModelEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AttributionModelEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.AttributionModelEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.AttributionModelEnum} AttributionModelEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AttributionModelEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AttributionModelEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.AttributionModelEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AttributionModelEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an AttributionModelEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.AttributionModelEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.AttributionModelEnum} AttributionModelEnum
                         */
                        AttributionModelEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.AttributionModelEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.AttributionModelEnum();
                        };

                        /**
                         * Creates a plain object from an AttributionModelEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.AttributionModelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.AttributionModelEnum} message AttributionModelEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AttributionModelEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this AttributionModelEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.AttributionModelEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AttributionModelEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * AttributionModel enum.
                         * @name google.ads.googleads.v1.enums.AttributionModelEnum.AttributionModel
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} EXTERNAL=100 EXTERNAL value
                         * @property {number} GOOGLE_ADS_LAST_CLICK=101 GOOGLE_ADS_LAST_CLICK value
                         * @property {number} GOOGLE_SEARCH_ATTRIBUTION_FIRST_CLICK=102 GOOGLE_SEARCH_ATTRIBUTION_FIRST_CLICK value
                         * @property {number} GOOGLE_SEARCH_ATTRIBUTION_LINEAR=103 GOOGLE_SEARCH_ATTRIBUTION_LINEAR value
                         * @property {number} GOOGLE_SEARCH_ATTRIBUTION_TIME_DECAY=104 GOOGLE_SEARCH_ATTRIBUTION_TIME_DECAY value
                         * @property {number} GOOGLE_SEARCH_ATTRIBUTION_POSITION_BASED=105 GOOGLE_SEARCH_ATTRIBUTION_POSITION_BASED value
                         * @property {number} GOOGLE_SEARCH_ATTRIBUTION_DATA_DRIVEN=106 GOOGLE_SEARCH_ATTRIBUTION_DATA_DRIVEN value
                         */
                        AttributionModelEnum.AttributionModel = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[100] = "EXTERNAL"] = 100;
                            values[valuesById[101] = "GOOGLE_ADS_LAST_CLICK"] = 101;
                            values[valuesById[102] = "GOOGLE_SEARCH_ATTRIBUTION_FIRST_CLICK"] = 102;
                            values[valuesById[103] = "GOOGLE_SEARCH_ATTRIBUTION_LINEAR"] = 103;
                            values[valuesById[104] = "GOOGLE_SEARCH_ATTRIBUTION_TIME_DECAY"] = 104;
                            values[valuesById[105] = "GOOGLE_SEARCH_ATTRIBUTION_POSITION_BASED"] = 105;
                            values[valuesById[106] = "GOOGLE_SEARCH_ATTRIBUTION_DATA_DRIVEN"] = 106;
                            return values;
                        })();

                        return AttributionModelEnum;
                    })();

                    enums.BidModifierSourceEnum = (function() {

                        /**
                         * Properties of a BidModifierSourceEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IBidModifierSourceEnum
                         */

                        /**
                         * Constructs a new BidModifierSourceEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a BidModifierSourceEnum.
                         * @implements IBidModifierSourceEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IBidModifierSourceEnum=} [properties] Properties to set
                         */
                        function BidModifierSourceEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new BidModifierSourceEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.BidModifierSourceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBidModifierSourceEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.BidModifierSourceEnum} BidModifierSourceEnum instance
                         */
                        BidModifierSourceEnum.create = function create(properties) {
                            return new BidModifierSourceEnum(properties);
                        };

                        /**
                         * Encodes the specified BidModifierSourceEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.BidModifierSourceEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.BidModifierSourceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBidModifierSourceEnum} message BidModifierSourceEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BidModifierSourceEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified BidModifierSourceEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.BidModifierSourceEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BidModifierSourceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBidModifierSourceEnum} message BidModifierSourceEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BidModifierSourceEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BidModifierSourceEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.BidModifierSourceEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.BidModifierSourceEnum} BidModifierSourceEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BidModifierSourceEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.BidModifierSourceEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BidModifierSourceEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BidModifierSourceEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.BidModifierSourceEnum} BidModifierSourceEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BidModifierSourceEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BidModifierSourceEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.BidModifierSourceEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BidModifierSourceEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a BidModifierSourceEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.BidModifierSourceEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.BidModifierSourceEnum} BidModifierSourceEnum
                         */
                        BidModifierSourceEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.BidModifierSourceEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.BidModifierSourceEnum();
                        };

                        /**
                         * Creates a plain object from a BidModifierSourceEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.BidModifierSourceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.BidModifierSourceEnum} message BidModifierSourceEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BidModifierSourceEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this BidModifierSourceEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.BidModifierSourceEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BidModifierSourceEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * BidModifierSource enum.
                         * @name google.ads.googleads.v1.enums.BidModifierSourceEnum.BidModifierSource
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CAMPAIGN=2 CAMPAIGN value
                         * @property {number} AD_GROUP=3 AD_GROUP value
                         */
                        BidModifierSourceEnum.BidModifierSource = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CAMPAIGN"] = 2;
                            values[valuesById[3] = "AD_GROUP"] = 3;
                            return values;
                        })();

                        return BidModifierSourceEnum;
                    })();

                    enums.BiddingSourceEnum = (function() {

                        /**
                         * Properties of a BiddingSourceEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IBiddingSourceEnum
                         */

                        /**
                         * Constructs a new BiddingSourceEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a BiddingSourceEnum.
                         * @implements IBiddingSourceEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IBiddingSourceEnum=} [properties] Properties to set
                         */
                        function BiddingSourceEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new BiddingSourceEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.BiddingSourceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBiddingSourceEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.BiddingSourceEnum} BiddingSourceEnum instance
                         */
                        BiddingSourceEnum.create = function create(properties) {
                            return new BiddingSourceEnum(properties);
                        };

                        /**
                         * Encodes the specified BiddingSourceEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.BiddingSourceEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.BiddingSourceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBiddingSourceEnum} message BiddingSourceEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BiddingSourceEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified BiddingSourceEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.BiddingSourceEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BiddingSourceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBiddingSourceEnum} message BiddingSourceEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BiddingSourceEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BiddingSourceEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.BiddingSourceEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.BiddingSourceEnum} BiddingSourceEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BiddingSourceEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.BiddingSourceEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BiddingSourceEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BiddingSourceEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.BiddingSourceEnum} BiddingSourceEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BiddingSourceEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BiddingSourceEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.BiddingSourceEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BiddingSourceEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a BiddingSourceEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.BiddingSourceEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.BiddingSourceEnum} BiddingSourceEnum
                         */
                        BiddingSourceEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.BiddingSourceEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.BiddingSourceEnum();
                        };

                        /**
                         * Creates a plain object from a BiddingSourceEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.BiddingSourceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.BiddingSourceEnum} message BiddingSourceEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BiddingSourceEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this BiddingSourceEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.BiddingSourceEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BiddingSourceEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * BiddingSource enum.
                         * @name google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CAMPAIGN_BIDDING_STRATEGY=5 CAMPAIGN_BIDDING_STRATEGY value
                         * @property {number} AD_GROUP=6 AD_GROUP value
                         * @property {number} AD_GROUP_CRITERION=7 AD_GROUP_CRITERION value
                         */
                        BiddingSourceEnum.BiddingSource = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[5] = "CAMPAIGN_BIDDING_STRATEGY"] = 5;
                            values[valuesById[6] = "AD_GROUP"] = 6;
                            values[valuesById[7] = "AD_GROUP_CRITERION"] = 7;
                            return values;
                        })();

                        return BiddingSourceEnum;
                    })();

                    enums.BiddingStrategyStatusEnum = (function() {

                        /**
                         * Properties of a BiddingStrategyStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IBiddingStrategyStatusEnum
                         */

                        /**
                         * Constructs a new BiddingStrategyStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a BiddingStrategyStatusEnum.
                         * @implements IBiddingStrategyStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IBiddingStrategyStatusEnum=} [properties] Properties to set
                         */
                        function BiddingStrategyStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new BiddingStrategyStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.BiddingStrategyStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBiddingStrategyStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.BiddingStrategyStatusEnum} BiddingStrategyStatusEnum instance
                         */
                        BiddingStrategyStatusEnum.create = function create(properties) {
                            return new BiddingStrategyStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified BiddingStrategyStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.BiddingStrategyStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.BiddingStrategyStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBiddingStrategyStatusEnum} message BiddingStrategyStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BiddingStrategyStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified BiddingStrategyStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.BiddingStrategyStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BiddingStrategyStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBiddingStrategyStatusEnum} message BiddingStrategyStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BiddingStrategyStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BiddingStrategyStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.BiddingStrategyStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.BiddingStrategyStatusEnum} BiddingStrategyStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BiddingStrategyStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.BiddingStrategyStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BiddingStrategyStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BiddingStrategyStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.BiddingStrategyStatusEnum} BiddingStrategyStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BiddingStrategyStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BiddingStrategyStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.BiddingStrategyStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BiddingStrategyStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a BiddingStrategyStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.BiddingStrategyStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.BiddingStrategyStatusEnum} BiddingStrategyStatusEnum
                         */
                        BiddingStrategyStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.BiddingStrategyStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.BiddingStrategyStatusEnum();
                        };

                        /**
                         * Creates a plain object from a BiddingStrategyStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.BiddingStrategyStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.BiddingStrategyStatusEnum} message BiddingStrategyStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BiddingStrategyStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this BiddingStrategyStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.BiddingStrategyStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BiddingStrategyStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * BiddingStrategyStatus enum.
                         * @name google.ads.googleads.v1.enums.BiddingStrategyStatusEnum.BiddingStrategyStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENABLED=2 ENABLED value
                         * @property {number} REMOVED=4 REMOVED value
                         */
                        BiddingStrategyStatusEnum.BiddingStrategyStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENABLED"] = 2;
                            values[valuesById[4] = "REMOVED"] = 4;
                            return values;
                        })();

                        return BiddingStrategyStatusEnum;
                    })();

                    enums.BiddingStrategyTypeEnum = (function() {

                        /**
                         * Properties of a BiddingStrategyTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IBiddingStrategyTypeEnum
                         */

                        /**
                         * Constructs a new BiddingStrategyTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a BiddingStrategyTypeEnum.
                         * @implements IBiddingStrategyTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IBiddingStrategyTypeEnum=} [properties] Properties to set
                         */
                        function BiddingStrategyTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new BiddingStrategyTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.BiddingStrategyTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBiddingStrategyTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.BiddingStrategyTypeEnum} BiddingStrategyTypeEnum instance
                         */
                        BiddingStrategyTypeEnum.create = function create(properties) {
                            return new BiddingStrategyTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified BiddingStrategyTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.BiddingStrategyTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.BiddingStrategyTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBiddingStrategyTypeEnum} message BiddingStrategyTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BiddingStrategyTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified BiddingStrategyTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.BiddingStrategyTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BiddingStrategyTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBiddingStrategyTypeEnum} message BiddingStrategyTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BiddingStrategyTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BiddingStrategyTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.BiddingStrategyTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.BiddingStrategyTypeEnum} BiddingStrategyTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BiddingStrategyTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.BiddingStrategyTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BiddingStrategyTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BiddingStrategyTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.BiddingStrategyTypeEnum} BiddingStrategyTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BiddingStrategyTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BiddingStrategyTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.BiddingStrategyTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BiddingStrategyTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a BiddingStrategyTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.BiddingStrategyTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.BiddingStrategyTypeEnum} BiddingStrategyTypeEnum
                         */
                        BiddingStrategyTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.BiddingStrategyTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.BiddingStrategyTypeEnum();
                        };

                        /**
                         * Creates a plain object from a BiddingStrategyTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.BiddingStrategyTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.BiddingStrategyTypeEnum} message BiddingStrategyTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BiddingStrategyTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this BiddingStrategyTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.BiddingStrategyTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BiddingStrategyTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * BiddingStrategyType enum.
                         * @name google.ads.googleads.v1.enums.BiddingStrategyTypeEnum.BiddingStrategyType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENHANCED_CPC=2 ENHANCED_CPC value
                         * @property {number} MANUAL_CPC=3 MANUAL_CPC value
                         * @property {number} MANUAL_CPM=4 MANUAL_CPM value
                         * @property {number} MANUAL_CPV=13 MANUAL_CPV value
                         * @property {number} MAXIMIZE_CONVERSIONS=10 MAXIMIZE_CONVERSIONS value
                         * @property {number} MAXIMIZE_CONVERSION_VALUE=11 MAXIMIZE_CONVERSION_VALUE value
                         * @property {number} PAGE_ONE_PROMOTED=5 PAGE_ONE_PROMOTED value
                         * @property {number} PERCENT_CPC=12 PERCENT_CPC value
                         * @property {number} TARGET_CPA=6 TARGET_CPA value
                         * @property {number} TARGET_CPM=14 TARGET_CPM value
                         * @property {number} TARGET_IMPRESSION_SHARE=15 TARGET_IMPRESSION_SHARE value
                         * @property {number} TARGET_OUTRANK_SHARE=7 TARGET_OUTRANK_SHARE value
                         * @property {number} TARGET_ROAS=8 TARGET_ROAS value
                         * @property {number} TARGET_SPEND=9 TARGET_SPEND value
                         */
                        BiddingStrategyTypeEnum.BiddingStrategyType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENHANCED_CPC"] = 2;
                            values[valuesById[3] = "MANUAL_CPC"] = 3;
                            values[valuesById[4] = "MANUAL_CPM"] = 4;
                            values[valuesById[13] = "MANUAL_CPV"] = 13;
                            values[valuesById[10] = "MAXIMIZE_CONVERSIONS"] = 10;
                            values[valuesById[11] = "MAXIMIZE_CONVERSION_VALUE"] = 11;
                            values[valuesById[5] = "PAGE_ONE_PROMOTED"] = 5;
                            values[valuesById[12] = "PERCENT_CPC"] = 12;
                            values[valuesById[6] = "TARGET_CPA"] = 6;
                            values[valuesById[14] = "TARGET_CPM"] = 14;
                            values[valuesById[15] = "TARGET_IMPRESSION_SHARE"] = 15;
                            values[valuesById[7] = "TARGET_OUTRANK_SHARE"] = 7;
                            values[valuesById[8] = "TARGET_ROAS"] = 8;
                            values[valuesById[9] = "TARGET_SPEND"] = 9;
                            return values;
                        })();

                        return BiddingStrategyTypeEnum;
                    })();

                    enums.BillingSetupStatusEnum = (function() {

                        /**
                         * Properties of a BillingSetupStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IBillingSetupStatusEnum
                         */

                        /**
                         * Constructs a new BillingSetupStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a BillingSetupStatusEnum.
                         * @implements IBillingSetupStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IBillingSetupStatusEnum=} [properties] Properties to set
                         */
                        function BillingSetupStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new BillingSetupStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.BillingSetupStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBillingSetupStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.BillingSetupStatusEnum} BillingSetupStatusEnum instance
                         */
                        BillingSetupStatusEnum.create = function create(properties) {
                            return new BillingSetupStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified BillingSetupStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.BillingSetupStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.BillingSetupStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBillingSetupStatusEnum} message BillingSetupStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BillingSetupStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified BillingSetupStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.BillingSetupStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BillingSetupStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBillingSetupStatusEnum} message BillingSetupStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BillingSetupStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BillingSetupStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.BillingSetupStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.BillingSetupStatusEnum} BillingSetupStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BillingSetupStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.BillingSetupStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BillingSetupStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BillingSetupStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.BillingSetupStatusEnum} BillingSetupStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BillingSetupStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BillingSetupStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.BillingSetupStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BillingSetupStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a BillingSetupStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.BillingSetupStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.BillingSetupStatusEnum} BillingSetupStatusEnum
                         */
                        BillingSetupStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.BillingSetupStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.BillingSetupStatusEnum();
                        };

                        /**
                         * Creates a plain object from a BillingSetupStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.BillingSetupStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.BillingSetupStatusEnum} message BillingSetupStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BillingSetupStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this BillingSetupStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.BillingSetupStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BillingSetupStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * BillingSetupStatus enum.
                         * @name google.ads.googleads.v1.enums.BillingSetupStatusEnum.BillingSetupStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} PENDING=2 PENDING value
                         * @property {number} APPROVED_HELD=3 APPROVED_HELD value
                         * @property {number} APPROVED=4 APPROVED value
                         * @property {number} CANCELLED=5 CANCELLED value
                         */
                        BillingSetupStatusEnum.BillingSetupStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "PENDING"] = 2;
                            values[valuesById[3] = "APPROVED_HELD"] = 3;
                            values[valuesById[4] = "APPROVED"] = 4;
                            values[valuesById[5] = "CANCELLED"] = 5;
                            return values;
                        })();

                        return BillingSetupStatusEnum;
                    })();

                    enums.BrandSafetySuitabilityEnum = (function() {

                        /**
                         * Properties of a BrandSafetySuitabilityEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IBrandSafetySuitabilityEnum
                         */

                        /**
                         * Constructs a new BrandSafetySuitabilityEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a BrandSafetySuitabilityEnum.
                         * @implements IBrandSafetySuitabilityEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IBrandSafetySuitabilityEnum=} [properties] Properties to set
                         */
                        function BrandSafetySuitabilityEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new BrandSafetySuitabilityEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBrandSafetySuitabilityEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum} BrandSafetySuitabilityEnum instance
                         */
                        BrandSafetySuitabilityEnum.create = function create(properties) {
                            return new BrandSafetySuitabilityEnum(properties);
                        };

                        /**
                         * Encodes the specified BrandSafetySuitabilityEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBrandSafetySuitabilityEnum} message BrandSafetySuitabilityEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BrandSafetySuitabilityEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified BrandSafetySuitabilityEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBrandSafetySuitabilityEnum} message BrandSafetySuitabilityEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BrandSafetySuitabilityEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BrandSafetySuitabilityEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum} BrandSafetySuitabilityEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BrandSafetySuitabilityEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BrandSafetySuitabilityEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum} BrandSafetySuitabilityEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BrandSafetySuitabilityEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BrandSafetySuitabilityEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BrandSafetySuitabilityEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a BrandSafetySuitabilityEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum} BrandSafetySuitabilityEnum
                         */
                        BrandSafetySuitabilityEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum();
                        };

                        /**
                         * Creates a plain object from a BrandSafetySuitabilityEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum} message BrandSafetySuitabilityEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BrandSafetySuitabilityEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this BrandSafetySuitabilityEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BrandSafetySuitabilityEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * BrandSafetySuitability enum.
                         * @name google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum.BrandSafetySuitability
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} EXPANDED_INVENTORY=2 EXPANDED_INVENTORY value
                         * @property {number} STANDARD_INVENTORY=3 STANDARD_INVENTORY value
                         * @property {number} LIMITED_INVENTORY=4 LIMITED_INVENTORY value
                         */
                        BrandSafetySuitabilityEnum.BrandSafetySuitability = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "EXPANDED_INVENTORY"] = 2;
                            values[valuesById[3] = "STANDARD_INVENTORY"] = 3;
                            values[valuesById[4] = "LIMITED_INVENTORY"] = 4;
                            return values;
                        })();

                        return BrandSafetySuitabilityEnum;
                    })();

                    enums.BudgetDeliveryMethodEnum = (function() {

                        /**
                         * Properties of a BudgetDeliveryMethodEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IBudgetDeliveryMethodEnum
                         */

                        /**
                         * Constructs a new BudgetDeliveryMethodEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a BudgetDeliveryMethodEnum.
                         * @implements IBudgetDeliveryMethodEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IBudgetDeliveryMethodEnum=} [properties] Properties to set
                         */
                        function BudgetDeliveryMethodEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new BudgetDeliveryMethodEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBudgetDeliveryMethodEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum} BudgetDeliveryMethodEnum instance
                         */
                        BudgetDeliveryMethodEnum.create = function create(properties) {
                            return new BudgetDeliveryMethodEnum(properties);
                        };

                        /**
                         * Encodes the specified BudgetDeliveryMethodEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBudgetDeliveryMethodEnum} message BudgetDeliveryMethodEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BudgetDeliveryMethodEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified BudgetDeliveryMethodEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBudgetDeliveryMethodEnum} message BudgetDeliveryMethodEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BudgetDeliveryMethodEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BudgetDeliveryMethodEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum} BudgetDeliveryMethodEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BudgetDeliveryMethodEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BudgetDeliveryMethodEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum} BudgetDeliveryMethodEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BudgetDeliveryMethodEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BudgetDeliveryMethodEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BudgetDeliveryMethodEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a BudgetDeliveryMethodEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum} BudgetDeliveryMethodEnum
                         */
                        BudgetDeliveryMethodEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum();
                        };

                        /**
                         * Creates a plain object from a BudgetDeliveryMethodEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum} message BudgetDeliveryMethodEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BudgetDeliveryMethodEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this BudgetDeliveryMethodEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BudgetDeliveryMethodEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * BudgetDeliveryMethod enum.
                         * @name google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum.BudgetDeliveryMethod
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} STANDARD=2 STANDARD value
                         * @property {number} ACCELERATED=3 ACCELERATED value
                         */
                        BudgetDeliveryMethodEnum.BudgetDeliveryMethod = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "STANDARD"] = 2;
                            values[valuesById[3] = "ACCELERATED"] = 3;
                            return values;
                        })();

                        return BudgetDeliveryMethodEnum;
                    })();

                    enums.BudgetPeriodEnum = (function() {

                        /**
                         * Properties of a BudgetPeriodEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IBudgetPeriodEnum
                         */

                        /**
                         * Constructs a new BudgetPeriodEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a BudgetPeriodEnum.
                         * @implements IBudgetPeriodEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IBudgetPeriodEnum=} [properties] Properties to set
                         */
                        function BudgetPeriodEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new BudgetPeriodEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.BudgetPeriodEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBudgetPeriodEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.BudgetPeriodEnum} BudgetPeriodEnum instance
                         */
                        BudgetPeriodEnum.create = function create(properties) {
                            return new BudgetPeriodEnum(properties);
                        };

                        /**
                         * Encodes the specified BudgetPeriodEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.BudgetPeriodEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.BudgetPeriodEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBudgetPeriodEnum} message BudgetPeriodEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BudgetPeriodEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified BudgetPeriodEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.BudgetPeriodEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BudgetPeriodEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBudgetPeriodEnum} message BudgetPeriodEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BudgetPeriodEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BudgetPeriodEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.BudgetPeriodEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.BudgetPeriodEnum} BudgetPeriodEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BudgetPeriodEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.BudgetPeriodEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BudgetPeriodEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BudgetPeriodEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.BudgetPeriodEnum} BudgetPeriodEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BudgetPeriodEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BudgetPeriodEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.BudgetPeriodEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BudgetPeriodEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a BudgetPeriodEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.BudgetPeriodEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.BudgetPeriodEnum} BudgetPeriodEnum
                         */
                        BudgetPeriodEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.BudgetPeriodEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.BudgetPeriodEnum();
                        };

                        /**
                         * Creates a plain object from a BudgetPeriodEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.BudgetPeriodEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.BudgetPeriodEnum} message BudgetPeriodEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BudgetPeriodEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this BudgetPeriodEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.BudgetPeriodEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BudgetPeriodEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * BudgetPeriod enum.
                         * @name google.ads.googleads.v1.enums.BudgetPeriodEnum.BudgetPeriod
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} DAILY=2 DAILY value
                         * @property {number} CUSTOM=3 CUSTOM value
                         * @property {number} FIXED_DAILY=4 FIXED_DAILY value
                         */
                        BudgetPeriodEnum.BudgetPeriod = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "DAILY"] = 2;
                            values[valuesById[3] = "CUSTOM"] = 3;
                            values[valuesById[4] = "FIXED_DAILY"] = 4;
                            return values;
                        })();

                        return BudgetPeriodEnum;
                    })();

                    enums.BudgetStatusEnum = (function() {

                        /**
                         * Properties of a BudgetStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IBudgetStatusEnum
                         */

                        /**
                         * Constructs a new BudgetStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a BudgetStatusEnum.
                         * @implements IBudgetStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IBudgetStatusEnum=} [properties] Properties to set
                         */
                        function BudgetStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new BudgetStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.BudgetStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBudgetStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.BudgetStatusEnum} BudgetStatusEnum instance
                         */
                        BudgetStatusEnum.create = function create(properties) {
                            return new BudgetStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified BudgetStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.BudgetStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.BudgetStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBudgetStatusEnum} message BudgetStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BudgetStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified BudgetStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.BudgetStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BudgetStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBudgetStatusEnum} message BudgetStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BudgetStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BudgetStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.BudgetStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.BudgetStatusEnum} BudgetStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BudgetStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.BudgetStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BudgetStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BudgetStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.BudgetStatusEnum} BudgetStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BudgetStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BudgetStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.BudgetStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BudgetStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a BudgetStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.BudgetStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.BudgetStatusEnum} BudgetStatusEnum
                         */
                        BudgetStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.BudgetStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.BudgetStatusEnum();
                        };

                        /**
                         * Creates a plain object from a BudgetStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.BudgetStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.BudgetStatusEnum} message BudgetStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BudgetStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this BudgetStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.BudgetStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BudgetStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * BudgetStatus enum.
                         * @name google.ads.googleads.v1.enums.BudgetStatusEnum.BudgetStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENABLED=2 ENABLED value
                         * @property {number} REMOVED=3 REMOVED value
                         */
                        BudgetStatusEnum.BudgetStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENABLED"] = 2;
                            values[valuesById[3] = "REMOVED"] = 3;
                            return values;
                        })();

                        return BudgetStatusEnum;
                    })();

                    enums.BudgetTypeEnum = (function() {

                        /**
                         * Properties of a BudgetTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IBudgetTypeEnum
                         */

                        /**
                         * Constructs a new BudgetTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a BudgetTypeEnum.
                         * @implements IBudgetTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IBudgetTypeEnum=} [properties] Properties to set
                         */
                        function BudgetTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new BudgetTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.BudgetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBudgetTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.BudgetTypeEnum} BudgetTypeEnum instance
                         */
                        BudgetTypeEnum.create = function create(properties) {
                            return new BudgetTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified BudgetTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.BudgetTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.BudgetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBudgetTypeEnum} message BudgetTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BudgetTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified BudgetTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.BudgetTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BudgetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IBudgetTypeEnum} message BudgetTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BudgetTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BudgetTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.BudgetTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.BudgetTypeEnum} BudgetTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BudgetTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.BudgetTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BudgetTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.BudgetTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.BudgetTypeEnum} BudgetTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BudgetTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BudgetTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.BudgetTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BudgetTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a BudgetTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.BudgetTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.BudgetTypeEnum} BudgetTypeEnum
                         */
                        BudgetTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.BudgetTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.BudgetTypeEnum();
                        };

                        /**
                         * Creates a plain object from a BudgetTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.BudgetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.BudgetTypeEnum} message BudgetTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BudgetTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this BudgetTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.BudgetTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BudgetTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * BudgetType enum.
                         * @name google.ads.googleads.v1.enums.BudgetTypeEnum.BudgetType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} STANDARD=2 STANDARD value
                         * @property {number} HOTEL_ADS_COMMISSION=3 HOTEL_ADS_COMMISSION value
                         * @property {number} FIXED_CPA=4 FIXED_CPA value
                         */
                        BudgetTypeEnum.BudgetType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "STANDARD"] = 2;
                            values[valuesById[3] = "HOTEL_ADS_COMMISSION"] = 3;
                            values[valuesById[4] = "FIXED_CPA"] = 4;
                            return values;
                        })();

                        return BudgetTypeEnum;
                    })();

                    enums.CallConversionReportingStateEnum = (function() {

                        /**
                         * Properties of a CallConversionReportingStateEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ICallConversionReportingStateEnum
                         */

                        /**
                         * Constructs a new CallConversionReportingStateEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a CallConversionReportingStateEnum.
                         * @implements ICallConversionReportingStateEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ICallConversionReportingStateEnum=} [properties] Properties to set
                         */
                        function CallConversionReportingStateEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CallConversionReportingStateEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.CallConversionReportingStateEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICallConversionReportingStateEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.CallConversionReportingStateEnum} CallConversionReportingStateEnum instance
                         */
                        CallConversionReportingStateEnum.create = function create(properties) {
                            return new CallConversionReportingStateEnum(properties);
                        };

                        /**
                         * Encodes the specified CallConversionReportingStateEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.CallConversionReportingStateEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.CallConversionReportingStateEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICallConversionReportingStateEnum} message CallConversionReportingStateEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CallConversionReportingStateEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CallConversionReportingStateEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.CallConversionReportingStateEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CallConversionReportingStateEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICallConversionReportingStateEnum} message CallConversionReportingStateEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CallConversionReportingStateEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CallConversionReportingStateEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.CallConversionReportingStateEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.CallConversionReportingStateEnum} CallConversionReportingStateEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CallConversionReportingStateEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.CallConversionReportingStateEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CallConversionReportingStateEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CallConversionReportingStateEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.CallConversionReportingStateEnum} CallConversionReportingStateEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CallConversionReportingStateEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CallConversionReportingStateEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.CallConversionReportingStateEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CallConversionReportingStateEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CallConversionReportingStateEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.CallConversionReportingStateEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.CallConversionReportingStateEnum} CallConversionReportingStateEnum
                         */
                        CallConversionReportingStateEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.CallConversionReportingStateEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.CallConversionReportingStateEnum();
                        };

                        /**
                         * Creates a plain object from a CallConversionReportingStateEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.CallConversionReportingStateEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.CallConversionReportingStateEnum} message CallConversionReportingStateEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CallConversionReportingStateEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CallConversionReportingStateEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.CallConversionReportingStateEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CallConversionReportingStateEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CallConversionReportingState enum.
                         * @name google.ads.googleads.v1.enums.CallConversionReportingStateEnum.CallConversionReportingState
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} DISABLED=2 DISABLED value
                         * @property {number} USE_ACCOUNT_LEVEL_CALL_CONVERSION_ACTION=3 USE_ACCOUNT_LEVEL_CALL_CONVERSION_ACTION value
                         * @property {number} USE_RESOURCE_LEVEL_CALL_CONVERSION_ACTION=4 USE_RESOURCE_LEVEL_CALL_CONVERSION_ACTION value
                         */
                        CallConversionReportingStateEnum.CallConversionReportingState = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "DISABLED"] = 2;
                            values[valuesById[3] = "USE_ACCOUNT_LEVEL_CALL_CONVERSION_ACTION"] = 3;
                            values[valuesById[4] = "USE_RESOURCE_LEVEL_CALL_CONVERSION_ACTION"] = 4;
                            return values;
                        })();

                        return CallConversionReportingStateEnum;
                    })();

                    enums.CallPlaceholderFieldEnum = (function() {

                        /**
                         * Properties of a CallPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ICallPlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new CallPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a CallPlaceholderFieldEnum.
                         * @implements ICallPlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ICallPlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function CallPlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CallPlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.CallPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICallPlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.CallPlaceholderFieldEnum} CallPlaceholderFieldEnum instance
                         */
                        CallPlaceholderFieldEnum.create = function create(properties) {
                            return new CallPlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified CallPlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.CallPlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.CallPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICallPlaceholderFieldEnum} message CallPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CallPlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CallPlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.CallPlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CallPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICallPlaceholderFieldEnum} message CallPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CallPlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CallPlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.CallPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.CallPlaceholderFieldEnum} CallPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CallPlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.CallPlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CallPlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CallPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.CallPlaceholderFieldEnum} CallPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CallPlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CallPlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.CallPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CallPlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CallPlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.CallPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.CallPlaceholderFieldEnum} CallPlaceholderFieldEnum
                         */
                        CallPlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.CallPlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.CallPlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from a CallPlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.CallPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.CallPlaceholderFieldEnum} message CallPlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CallPlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CallPlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.CallPlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CallPlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CallPlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.CallPlaceholderFieldEnum.CallPlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} PHONE_NUMBER=2 PHONE_NUMBER value
                         * @property {number} COUNTRY_CODE=3 COUNTRY_CODE value
                         * @property {number} TRACKED=4 TRACKED value
                         * @property {number} CONVERSION_TYPE_ID=5 CONVERSION_TYPE_ID value
                         * @property {number} CONVERSION_REPORTING_STATE=6 CONVERSION_REPORTING_STATE value
                         */
                        CallPlaceholderFieldEnum.CallPlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "PHONE_NUMBER"] = 2;
                            values[valuesById[3] = "COUNTRY_CODE"] = 3;
                            values[valuesById[4] = "TRACKED"] = 4;
                            values[valuesById[5] = "CONVERSION_TYPE_ID"] = 5;
                            values[valuesById[6] = "CONVERSION_REPORTING_STATE"] = 6;
                            return values;
                        })();

                        return CallPlaceholderFieldEnum;
                    })();

                    enums.CalloutPlaceholderFieldEnum = (function() {

                        /**
                         * Properties of a CalloutPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ICalloutPlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new CalloutPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a CalloutPlaceholderFieldEnum.
                         * @implements ICalloutPlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ICalloutPlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function CalloutPlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CalloutPlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICalloutPlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum} CalloutPlaceholderFieldEnum instance
                         */
                        CalloutPlaceholderFieldEnum.create = function create(properties) {
                            return new CalloutPlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified CalloutPlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICalloutPlaceholderFieldEnum} message CalloutPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CalloutPlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CalloutPlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICalloutPlaceholderFieldEnum} message CalloutPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CalloutPlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CalloutPlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum} CalloutPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CalloutPlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CalloutPlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum} CalloutPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CalloutPlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CalloutPlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CalloutPlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CalloutPlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum} CalloutPlaceholderFieldEnum
                         */
                        CalloutPlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from a CalloutPlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum} message CalloutPlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CalloutPlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CalloutPlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CalloutPlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CalloutPlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum.CalloutPlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CALLOUT_TEXT=2 CALLOUT_TEXT value
                         */
                        CalloutPlaceholderFieldEnum.CalloutPlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CALLOUT_TEXT"] = 2;
                            return values;
                        })();

                        return CalloutPlaceholderFieldEnum;
                    })();

                    enums.CampaignExperimentTypeEnum = (function() {

                        /**
                         * Properties of a CampaignExperimentTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ICampaignExperimentTypeEnum
                         */

                        /**
                         * Constructs a new CampaignExperimentTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a CampaignExperimentTypeEnum.
                         * @implements ICampaignExperimentTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ICampaignExperimentTypeEnum=} [properties] Properties to set
                         */
                        function CampaignExperimentTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CampaignExperimentTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.CampaignExperimentTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICampaignExperimentTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.CampaignExperimentTypeEnum} CampaignExperimentTypeEnum instance
                         */
                        CampaignExperimentTypeEnum.create = function create(properties) {
                            return new CampaignExperimentTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified CampaignExperimentTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.CampaignExperimentTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.CampaignExperimentTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICampaignExperimentTypeEnum} message CampaignExperimentTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignExperimentTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignExperimentTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.CampaignExperimentTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CampaignExperimentTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICampaignExperimentTypeEnum} message CampaignExperimentTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignExperimentTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignExperimentTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.CampaignExperimentTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.CampaignExperimentTypeEnum} CampaignExperimentTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignExperimentTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.CampaignExperimentTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignExperimentTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CampaignExperimentTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.CampaignExperimentTypeEnum} CampaignExperimentTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignExperimentTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignExperimentTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.CampaignExperimentTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignExperimentTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CampaignExperimentTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.CampaignExperimentTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.CampaignExperimentTypeEnum} CampaignExperimentTypeEnum
                         */
                        CampaignExperimentTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.CampaignExperimentTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.CampaignExperimentTypeEnum();
                        };

                        /**
                         * Creates a plain object from a CampaignExperimentTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.CampaignExperimentTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.CampaignExperimentTypeEnum} message CampaignExperimentTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignExperimentTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CampaignExperimentTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.CampaignExperimentTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignExperimentTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CampaignExperimentType enum.
                         * @name google.ads.googleads.v1.enums.CampaignExperimentTypeEnum.CampaignExperimentType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} BASE=2 BASE value
                         * @property {number} DRAFT=3 DRAFT value
                         * @property {number} EXPERIMENT=4 EXPERIMENT value
                         */
                        CampaignExperimentTypeEnum.CampaignExperimentType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "BASE"] = 2;
                            values[valuesById[3] = "DRAFT"] = 3;
                            values[valuesById[4] = "EXPERIMENT"] = 4;
                            return values;
                        })();

                        return CampaignExperimentTypeEnum;
                    })();

                    enums.CampaignServingStatusEnum = (function() {

                        /**
                         * Properties of a CampaignServingStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ICampaignServingStatusEnum
                         */

                        /**
                         * Constructs a new CampaignServingStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a CampaignServingStatusEnum.
                         * @implements ICampaignServingStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ICampaignServingStatusEnum=} [properties] Properties to set
                         */
                        function CampaignServingStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CampaignServingStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.CampaignServingStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICampaignServingStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.CampaignServingStatusEnum} CampaignServingStatusEnum instance
                         */
                        CampaignServingStatusEnum.create = function create(properties) {
                            return new CampaignServingStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified CampaignServingStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.CampaignServingStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.CampaignServingStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICampaignServingStatusEnum} message CampaignServingStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignServingStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignServingStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.CampaignServingStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CampaignServingStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICampaignServingStatusEnum} message CampaignServingStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignServingStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignServingStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.CampaignServingStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.CampaignServingStatusEnum} CampaignServingStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignServingStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.CampaignServingStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignServingStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CampaignServingStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.CampaignServingStatusEnum} CampaignServingStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignServingStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignServingStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.CampaignServingStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignServingStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CampaignServingStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.CampaignServingStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.CampaignServingStatusEnum} CampaignServingStatusEnum
                         */
                        CampaignServingStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.CampaignServingStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.CampaignServingStatusEnum();
                        };

                        /**
                         * Creates a plain object from a CampaignServingStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.CampaignServingStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.CampaignServingStatusEnum} message CampaignServingStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignServingStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CampaignServingStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.CampaignServingStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignServingStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CampaignServingStatus enum.
                         * @name google.ads.googleads.v1.enums.CampaignServingStatusEnum.CampaignServingStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} SERVING=2 SERVING value
                         * @property {number} NONE=3 NONE value
                         * @property {number} ENDED=4 ENDED value
                         * @property {number} PENDING=5 PENDING value
                         * @property {number} SUSPENDED=6 SUSPENDED value
                         */
                        CampaignServingStatusEnum.CampaignServingStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "SERVING"] = 2;
                            values[valuesById[3] = "NONE"] = 3;
                            values[valuesById[4] = "ENDED"] = 4;
                            values[valuesById[5] = "PENDING"] = 5;
                            values[valuesById[6] = "SUSPENDED"] = 6;
                            return values;
                        })();

                        return CampaignServingStatusEnum;
                    })();

                    enums.CampaignSharedSetStatusEnum = (function() {

                        /**
                         * Properties of a CampaignSharedSetStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ICampaignSharedSetStatusEnum
                         */

                        /**
                         * Constructs a new CampaignSharedSetStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a CampaignSharedSetStatusEnum.
                         * @implements ICampaignSharedSetStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ICampaignSharedSetStatusEnum=} [properties] Properties to set
                         */
                        function CampaignSharedSetStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CampaignSharedSetStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICampaignSharedSetStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum} CampaignSharedSetStatusEnum instance
                         */
                        CampaignSharedSetStatusEnum.create = function create(properties) {
                            return new CampaignSharedSetStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified CampaignSharedSetStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICampaignSharedSetStatusEnum} message CampaignSharedSetStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignSharedSetStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignSharedSetStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICampaignSharedSetStatusEnum} message CampaignSharedSetStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignSharedSetStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignSharedSetStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum} CampaignSharedSetStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignSharedSetStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignSharedSetStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum} CampaignSharedSetStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignSharedSetStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignSharedSetStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignSharedSetStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CampaignSharedSetStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum} CampaignSharedSetStatusEnum
                         */
                        CampaignSharedSetStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum();
                        };

                        /**
                         * Creates a plain object from a CampaignSharedSetStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum} message CampaignSharedSetStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignSharedSetStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CampaignSharedSetStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignSharedSetStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CampaignSharedSetStatus enum.
                         * @name google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum.CampaignSharedSetStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENABLED=2 ENABLED value
                         * @property {number} REMOVED=3 REMOVED value
                         */
                        CampaignSharedSetStatusEnum.CampaignSharedSetStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENABLED"] = 2;
                            values[valuesById[3] = "REMOVED"] = 3;
                            return values;
                        })();

                        return CampaignSharedSetStatusEnum;
                    })();

                    enums.CampaignStatusEnum = (function() {

                        /**
                         * Properties of a CampaignStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ICampaignStatusEnum
                         */

                        /**
                         * Constructs a new CampaignStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a CampaignStatusEnum.
                         * @implements ICampaignStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ICampaignStatusEnum=} [properties] Properties to set
                         */
                        function CampaignStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CampaignStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.CampaignStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICampaignStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.CampaignStatusEnum} CampaignStatusEnum instance
                         */
                        CampaignStatusEnum.create = function create(properties) {
                            return new CampaignStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified CampaignStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.CampaignStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.CampaignStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICampaignStatusEnum} message CampaignStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.CampaignStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CampaignStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICampaignStatusEnum} message CampaignStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.CampaignStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.CampaignStatusEnum} CampaignStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.CampaignStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CampaignStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.CampaignStatusEnum} CampaignStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.CampaignStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CampaignStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.CampaignStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.CampaignStatusEnum} CampaignStatusEnum
                         */
                        CampaignStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.CampaignStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.CampaignStatusEnum();
                        };

                        /**
                         * Creates a plain object from a CampaignStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.CampaignStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.CampaignStatusEnum} message CampaignStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CampaignStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.CampaignStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CampaignStatus enum.
                         * @name google.ads.googleads.v1.enums.CampaignStatusEnum.CampaignStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENABLED=2 ENABLED value
                         * @property {number} PAUSED=3 PAUSED value
                         * @property {number} REMOVED=4 REMOVED value
                         */
                        CampaignStatusEnum.CampaignStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENABLED"] = 2;
                            values[valuesById[3] = "PAUSED"] = 3;
                            values[valuesById[4] = "REMOVED"] = 4;
                            return values;
                        })();

                        return CampaignStatusEnum;
                    })();

                    enums.ChangeStatusOperationEnum = (function() {

                        /**
                         * Properties of a ChangeStatusOperationEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IChangeStatusOperationEnum
                         */

                        /**
                         * Constructs a new ChangeStatusOperationEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ChangeStatusOperationEnum.
                         * @implements IChangeStatusOperationEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IChangeStatusOperationEnum=} [properties] Properties to set
                         */
                        function ChangeStatusOperationEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ChangeStatusOperationEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ChangeStatusOperationEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IChangeStatusOperationEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ChangeStatusOperationEnum} ChangeStatusOperationEnum instance
                         */
                        ChangeStatusOperationEnum.create = function create(properties) {
                            return new ChangeStatusOperationEnum(properties);
                        };

                        /**
                         * Encodes the specified ChangeStatusOperationEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ChangeStatusOperationEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ChangeStatusOperationEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IChangeStatusOperationEnum} message ChangeStatusOperationEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChangeStatusOperationEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ChangeStatusOperationEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ChangeStatusOperationEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ChangeStatusOperationEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IChangeStatusOperationEnum} message ChangeStatusOperationEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChangeStatusOperationEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ChangeStatusOperationEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ChangeStatusOperationEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ChangeStatusOperationEnum} ChangeStatusOperationEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChangeStatusOperationEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ChangeStatusOperationEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ChangeStatusOperationEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ChangeStatusOperationEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ChangeStatusOperationEnum} ChangeStatusOperationEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChangeStatusOperationEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ChangeStatusOperationEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ChangeStatusOperationEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ChangeStatusOperationEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ChangeStatusOperationEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ChangeStatusOperationEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ChangeStatusOperationEnum} ChangeStatusOperationEnum
                         */
                        ChangeStatusOperationEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ChangeStatusOperationEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ChangeStatusOperationEnum();
                        };

                        /**
                         * Creates a plain object from a ChangeStatusOperationEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ChangeStatusOperationEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ChangeStatusOperationEnum} message ChangeStatusOperationEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ChangeStatusOperationEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ChangeStatusOperationEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ChangeStatusOperationEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ChangeStatusOperationEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ChangeStatusOperation enum.
                         * @name google.ads.googleads.v1.enums.ChangeStatusOperationEnum.ChangeStatusOperation
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ADDED=2 ADDED value
                         * @property {number} CHANGED=3 CHANGED value
                         * @property {number} REMOVED=4 REMOVED value
                         */
                        ChangeStatusOperationEnum.ChangeStatusOperation = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ADDED"] = 2;
                            values[valuesById[3] = "CHANGED"] = 3;
                            values[valuesById[4] = "REMOVED"] = 4;
                            return values;
                        })();

                        return ChangeStatusOperationEnum;
                    })();

                    enums.ChangeStatusResourceTypeEnum = (function() {

                        /**
                         * Properties of a ChangeStatusResourceTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IChangeStatusResourceTypeEnum
                         */

                        /**
                         * Constructs a new ChangeStatusResourceTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ChangeStatusResourceTypeEnum.
                         * @implements IChangeStatusResourceTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IChangeStatusResourceTypeEnum=} [properties] Properties to set
                         */
                        function ChangeStatusResourceTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ChangeStatusResourceTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IChangeStatusResourceTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum} ChangeStatusResourceTypeEnum instance
                         */
                        ChangeStatusResourceTypeEnum.create = function create(properties) {
                            return new ChangeStatusResourceTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified ChangeStatusResourceTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IChangeStatusResourceTypeEnum} message ChangeStatusResourceTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChangeStatusResourceTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ChangeStatusResourceTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IChangeStatusResourceTypeEnum} message ChangeStatusResourceTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChangeStatusResourceTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ChangeStatusResourceTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum} ChangeStatusResourceTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChangeStatusResourceTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ChangeStatusResourceTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum} ChangeStatusResourceTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChangeStatusResourceTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ChangeStatusResourceTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ChangeStatusResourceTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ChangeStatusResourceTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum} ChangeStatusResourceTypeEnum
                         */
                        ChangeStatusResourceTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum();
                        };

                        /**
                         * Creates a plain object from a ChangeStatusResourceTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum} message ChangeStatusResourceTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ChangeStatusResourceTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ChangeStatusResourceTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ChangeStatusResourceTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ChangeStatusResourceType enum.
                         * @name google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum.ChangeStatusResourceType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} AD_GROUP=3 AD_GROUP value
                         * @property {number} AD_GROUP_AD=4 AD_GROUP_AD value
                         * @property {number} AD_GROUP_CRITERION=5 AD_GROUP_CRITERION value
                         * @property {number} CAMPAIGN=6 CAMPAIGN value
                         * @property {number} CAMPAIGN_CRITERION=7 CAMPAIGN_CRITERION value
                         * @property {number} FEED=9 FEED value
                         * @property {number} FEED_ITEM=10 FEED_ITEM value
                         * @property {number} AD_GROUP_FEED=11 AD_GROUP_FEED value
                         * @property {number} CAMPAIGN_FEED=12 CAMPAIGN_FEED value
                         * @property {number} AD_GROUP_BID_MODIFIER=13 AD_GROUP_BID_MODIFIER value
                         */
                        ChangeStatusResourceTypeEnum.ChangeStatusResourceType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[3] = "AD_GROUP"] = 3;
                            values[valuesById[4] = "AD_GROUP_AD"] = 4;
                            values[valuesById[5] = "AD_GROUP_CRITERION"] = 5;
                            values[valuesById[6] = "CAMPAIGN"] = 6;
                            values[valuesById[7] = "CAMPAIGN_CRITERION"] = 7;
                            values[valuesById[9] = "FEED"] = 9;
                            values[valuesById[10] = "FEED_ITEM"] = 10;
                            values[valuesById[11] = "AD_GROUP_FEED"] = 11;
                            values[valuesById[12] = "CAMPAIGN_FEED"] = 12;
                            values[valuesById[13] = "AD_GROUP_BID_MODIFIER"] = 13;
                            return values;
                        })();

                        return ChangeStatusResourceTypeEnum;
                    })();

                    enums.ClickTypeEnum = (function() {

                        /**
                         * Properties of a ClickTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IClickTypeEnum
                         */

                        /**
                         * Constructs a new ClickTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ClickTypeEnum.
                         * @implements IClickTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IClickTypeEnum=} [properties] Properties to set
                         */
                        function ClickTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ClickTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ClickTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IClickTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ClickTypeEnum} ClickTypeEnum instance
                         */
                        ClickTypeEnum.create = function create(properties) {
                            return new ClickTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified ClickTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ClickTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ClickTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IClickTypeEnum} message ClickTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ClickTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ClickTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ClickTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ClickTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IClickTypeEnum} message ClickTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ClickTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ClickTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ClickTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ClickTypeEnum} ClickTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ClickTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ClickTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ClickTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ClickTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ClickTypeEnum} ClickTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ClickTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ClickTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ClickTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ClickTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ClickTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ClickTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ClickTypeEnum} ClickTypeEnum
                         */
                        ClickTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ClickTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ClickTypeEnum();
                        };

                        /**
                         * Creates a plain object from a ClickTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ClickTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ClickTypeEnum} message ClickTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ClickTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ClickTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ClickTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ClickTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ClickType enum.
                         * @name google.ads.googleads.v1.enums.ClickTypeEnum.ClickType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} APP_DEEPLINK=2 APP_DEEPLINK value
                         * @property {number} BREADCRUMBS=3 BREADCRUMBS value
                         * @property {number} BROADBAND_PLAN=4 BROADBAND_PLAN value
                         * @property {number} CALL_TRACKING=5 CALL_TRACKING value
                         * @property {number} CALLS=6 CALLS value
                         * @property {number} CLICK_ON_ENGAGEMENT_AD=7 CLICK_ON_ENGAGEMENT_AD value
                         * @property {number} GET_DIRECTIONS=8 GET_DIRECTIONS value
                         * @property {number} LOCATION_EXPANSION=9 LOCATION_EXPANSION value
                         * @property {number} LOCATION_FORMAT_CALL=10 LOCATION_FORMAT_CALL value
                         * @property {number} LOCATION_FORMAT_DIRECTIONS=11 LOCATION_FORMAT_DIRECTIONS value
                         * @property {number} LOCATION_FORMAT_IMAGE=12 LOCATION_FORMAT_IMAGE value
                         * @property {number} LOCATION_FORMAT_LANDING_PAGE=13 LOCATION_FORMAT_LANDING_PAGE value
                         * @property {number} LOCATION_FORMAT_MAP=14 LOCATION_FORMAT_MAP value
                         * @property {number} LOCATION_FORMAT_STORE_INFO=15 LOCATION_FORMAT_STORE_INFO value
                         * @property {number} LOCATION_FORMAT_TEXT=16 LOCATION_FORMAT_TEXT value
                         * @property {number} MOBILE_CALL_TRACKING=17 MOBILE_CALL_TRACKING value
                         * @property {number} OFFER_PRINTS=18 OFFER_PRINTS value
                         * @property {number} OTHER=19 OTHER value
                         * @property {number} PRODUCT_EXTENSION_CLICKS=20 PRODUCT_EXTENSION_CLICKS value
                         * @property {number} PRODUCT_LISTING_AD_CLICKS=21 PRODUCT_LISTING_AD_CLICKS value
                         * @property {number} SITELINKS=22 SITELINKS value
                         * @property {number} STORE_LOCATOR=23 STORE_LOCATOR value
                         * @property {number} URL_CLICKS=25 URL_CLICKS value
                         * @property {number} VIDEO_APP_STORE_CLICKS=26 VIDEO_APP_STORE_CLICKS value
                         * @property {number} VIDEO_CALL_TO_ACTION_CLICKS=27 VIDEO_CALL_TO_ACTION_CLICKS value
                         * @property {number} VIDEO_CARD_ACTION_HEADLINE_CLICKS=28 VIDEO_CARD_ACTION_HEADLINE_CLICKS value
                         * @property {number} VIDEO_END_CAP_CLICKS=29 VIDEO_END_CAP_CLICKS value
                         * @property {number} VIDEO_WEBSITE_CLICKS=30 VIDEO_WEBSITE_CLICKS value
                         * @property {number} VISUAL_SITELINKS=31 VISUAL_SITELINKS value
                         * @property {number} WIRELESS_PLAN=32 WIRELESS_PLAN value
                         * @property {number} PRODUCT_LISTING_AD_LOCAL=33 PRODUCT_LISTING_AD_LOCAL value
                         * @property {number} PRODUCT_LISTING_AD_MULTICHANNEL_LOCAL=34 PRODUCT_LISTING_AD_MULTICHANNEL_LOCAL value
                         * @property {number} PRODUCT_LISTING_AD_MULTICHANNEL_ONLINE=35 PRODUCT_LISTING_AD_MULTICHANNEL_ONLINE value
                         * @property {number} PRODUCT_LISTING_ADS_COUPON=36 PRODUCT_LISTING_ADS_COUPON value
                         * @property {number} PRODUCT_LISTING_AD_TRANSACTABLE=37 PRODUCT_LISTING_AD_TRANSACTABLE value
                         * @property {number} PRODUCT_AD_APP_DEEPLINK=38 PRODUCT_AD_APP_DEEPLINK value
                         * @property {number} SHOWCASE_AD_CATEGORY_LINK=39 SHOWCASE_AD_CATEGORY_LINK value
                         * @property {number} SHOWCASE_AD_LOCAL_STOREFRONT_LINK=40 SHOWCASE_AD_LOCAL_STOREFRONT_LINK value
                         * @property {number} SHOWCASE_AD_ONLINE_PRODUCT_LINK=42 SHOWCASE_AD_ONLINE_PRODUCT_LINK value
                         * @property {number} SHOWCASE_AD_LOCAL_PRODUCT_LINK=43 SHOWCASE_AD_LOCAL_PRODUCT_LINK value
                         * @property {number} PROMOTION_EXTENSION=44 PROMOTION_EXTENSION value
                         * @property {number} SWIPEABLE_GALLERY_AD_HEADLINE=45 SWIPEABLE_GALLERY_AD_HEADLINE value
                         * @property {number} SWIPEABLE_GALLERY_AD_SWIPES=46 SWIPEABLE_GALLERY_AD_SWIPES value
                         * @property {number} SWIPEABLE_GALLERY_AD_SEE_MORE=47 SWIPEABLE_GALLERY_AD_SEE_MORE value
                         * @property {number} SWIPEABLE_GALLERY_AD_SITELINK_ONE=48 SWIPEABLE_GALLERY_AD_SITELINK_ONE value
                         * @property {number} SWIPEABLE_GALLERY_AD_SITELINK_TWO=49 SWIPEABLE_GALLERY_AD_SITELINK_TWO value
                         * @property {number} SWIPEABLE_GALLERY_AD_SITELINK_THREE=50 SWIPEABLE_GALLERY_AD_SITELINK_THREE value
                         * @property {number} SWIPEABLE_GALLERY_AD_SITELINK_FOUR=51 SWIPEABLE_GALLERY_AD_SITELINK_FOUR value
                         * @property {number} SWIPEABLE_GALLERY_AD_SITELINK_FIVE=52 SWIPEABLE_GALLERY_AD_SITELINK_FIVE value
                         * @property {number} HOTEL_PRICE=53 HOTEL_PRICE value
                         * @property {number} PRICE_EXTENSION=54 PRICE_EXTENSION value
                         * @property {number} HOTEL_BOOK_ON_GOOGLE_ROOM_SELECTION=55 HOTEL_BOOK_ON_GOOGLE_ROOM_SELECTION value
                         */
                        ClickTypeEnum.ClickType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "APP_DEEPLINK"] = 2;
                            values[valuesById[3] = "BREADCRUMBS"] = 3;
                            values[valuesById[4] = "BROADBAND_PLAN"] = 4;
                            values[valuesById[5] = "CALL_TRACKING"] = 5;
                            values[valuesById[6] = "CALLS"] = 6;
                            values[valuesById[7] = "CLICK_ON_ENGAGEMENT_AD"] = 7;
                            values[valuesById[8] = "GET_DIRECTIONS"] = 8;
                            values[valuesById[9] = "LOCATION_EXPANSION"] = 9;
                            values[valuesById[10] = "LOCATION_FORMAT_CALL"] = 10;
                            values[valuesById[11] = "LOCATION_FORMAT_DIRECTIONS"] = 11;
                            values[valuesById[12] = "LOCATION_FORMAT_IMAGE"] = 12;
                            values[valuesById[13] = "LOCATION_FORMAT_LANDING_PAGE"] = 13;
                            values[valuesById[14] = "LOCATION_FORMAT_MAP"] = 14;
                            values[valuesById[15] = "LOCATION_FORMAT_STORE_INFO"] = 15;
                            values[valuesById[16] = "LOCATION_FORMAT_TEXT"] = 16;
                            values[valuesById[17] = "MOBILE_CALL_TRACKING"] = 17;
                            values[valuesById[18] = "OFFER_PRINTS"] = 18;
                            values[valuesById[19] = "OTHER"] = 19;
                            values[valuesById[20] = "PRODUCT_EXTENSION_CLICKS"] = 20;
                            values[valuesById[21] = "PRODUCT_LISTING_AD_CLICKS"] = 21;
                            values[valuesById[22] = "SITELINKS"] = 22;
                            values[valuesById[23] = "STORE_LOCATOR"] = 23;
                            values[valuesById[25] = "URL_CLICKS"] = 25;
                            values[valuesById[26] = "VIDEO_APP_STORE_CLICKS"] = 26;
                            values[valuesById[27] = "VIDEO_CALL_TO_ACTION_CLICKS"] = 27;
                            values[valuesById[28] = "VIDEO_CARD_ACTION_HEADLINE_CLICKS"] = 28;
                            values[valuesById[29] = "VIDEO_END_CAP_CLICKS"] = 29;
                            values[valuesById[30] = "VIDEO_WEBSITE_CLICKS"] = 30;
                            values[valuesById[31] = "VISUAL_SITELINKS"] = 31;
                            values[valuesById[32] = "WIRELESS_PLAN"] = 32;
                            values[valuesById[33] = "PRODUCT_LISTING_AD_LOCAL"] = 33;
                            values[valuesById[34] = "PRODUCT_LISTING_AD_MULTICHANNEL_LOCAL"] = 34;
                            values[valuesById[35] = "PRODUCT_LISTING_AD_MULTICHANNEL_ONLINE"] = 35;
                            values[valuesById[36] = "PRODUCT_LISTING_ADS_COUPON"] = 36;
                            values[valuesById[37] = "PRODUCT_LISTING_AD_TRANSACTABLE"] = 37;
                            values[valuesById[38] = "PRODUCT_AD_APP_DEEPLINK"] = 38;
                            values[valuesById[39] = "SHOWCASE_AD_CATEGORY_LINK"] = 39;
                            values[valuesById[40] = "SHOWCASE_AD_LOCAL_STOREFRONT_LINK"] = 40;
                            values[valuesById[42] = "SHOWCASE_AD_ONLINE_PRODUCT_LINK"] = 42;
                            values[valuesById[43] = "SHOWCASE_AD_LOCAL_PRODUCT_LINK"] = 43;
                            values[valuesById[44] = "PROMOTION_EXTENSION"] = 44;
                            values[valuesById[45] = "SWIPEABLE_GALLERY_AD_HEADLINE"] = 45;
                            values[valuesById[46] = "SWIPEABLE_GALLERY_AD_SWIPES"] = 46;
                            values[valuesById[47] = "SWIPEABLE_GALLERY_AD_SEE_MORE"] = 47;
                            values[valuesById[48] = "SWIPEABLE_GALLERY_AD_SITELINK_ONE"] = 48;
                            values[valuesById[49] = "SWIPEABLE_GALLERY_AD_SITELINK_TWO"] = 49;
                            values[valuesById[50] = "SWIPEABLE_GALLERY_AD_SITELINK_THREE"] = 50;
                            values[valuesById[51] = "SWIPEABLE_GALLERY_AD_SITELINK_FOUR"] = 51;
                            values[valuesById[52] = "SWIPEABLE_GALLERY_AD_SITELINK_FIVE"] = 52;
                            values[valuesById[53] = "HOTEL_PRICE"] = 53;
                            values[valuesById[54] = "PRICE_EXTENSION"] = 54;
                            values[valuesById[55] = "HOTEL_BOOK_ON_GOOGLE_ROOM_SELECTION"] = 55;
                            return values;
                        })();

                        return ClickTypeEnum;
                    })();

                    enums.ContentLabelTypeEnum = (function() {

                        /**
                         * Properties of a ContentLabelTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IContentLabelTypeEnum
                         */

                        /**
                         * Constructs a new ContentLabelTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ContentLabelTypeEnum.
                         * @implements IContentLabelTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IContentLabelTypeEnum=} [properties] Properties to set
                         */
                        function ContentLabelTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ContentLabelTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ContentLabelTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IContentLabelTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ContentLabelTypeEnum} ContentLabelTypeEnum instance
                         */
                        ContentLabelTypeEnum.create = function create(properties) {
                            return new ContentLabelTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified ContentLabelTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ContentLabelTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ContentLabelTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IContentLabelTypeEnum} message ContentLabelTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ContentLabelTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ContentLabelTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ContentLabelTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ContentLabelTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IContentLabelTypeEnum} message ContentLabelTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ContentLabelTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ContentLabelTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ContentLabelTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ContentLabelTypeEnum} ContentLabelTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ContentLabelTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ContentLabelTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ContentLabelTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ContentLabelTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ContentLabelTypeEnum} ContentLabelTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ContentLabelTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ContentLabelTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ContentLabelTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ContentLabelTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ContentLabelTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ContentLabelTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ContentLabelTypeEnum} ContentLabelTypeEnum
                         */
                        ContentLabelTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ContentLabelTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ContentLabelTypeEnum();
                        };

                        /**
                         * Creates a plain object from a ContentLabelTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ContentLabelTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ContentLabelTypeEnum} message ContentLabelTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ContentLabelTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ContentLabelTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ContentLabelTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ContentLabelTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ContentLabelType enum.
                         * @name google.ads.googleads.v1.enums.ContentLabelTypeEnum.ContentLabelType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} SEXUALLY_SUGGESTIVE=2 SEXUALLY_SUGGESTIVE value
                         * @property {number} BELOW_THE_FOLD=3 BELOW_THE_FOLD value
                         * @property {number} PARKED_DOMAIN=4 PARKED_DOMAIN value
                         * @property {number} GAME=5 GAME value
                         * @property {number} JUVENILE=6 JUVENILE value
                         * @property {number} PROFANITY=7 PROFANITY value
                         * @property {number} TRAGEDY=8 TRAGEDY value
                         * @property {number} VIDEO=9 VIDEO value
                         * @property {number} VIDEO_RATING_DV_G=10 VIDEO_RATING_DV_G value
                         * @property {number} VIDEO_RATING_DV_PG=11 VIDEO_RATING_DV_PG value
                         * @property {number} VIDEO_RATING_DV_T=12 VIDEO_RATING_DV_T value
                         * @property {number} VIDEO_RATING_DV_MA=13 VIDEO_RATING_DV_MA value
                         * @property {number} VIDEO_NOT_YET_RATED=14 VIDEO_NOT_YET_RATED value
                         * @property {number} EMBEDDED_VIDEO=15 EMBEDDED_VIDEO value
                         * @property {number} LIVE_STREAMING_VIDEO=16 LIVE_STREAMING_VIDEO value
                         */
                        ContentLabelTypeEnum.ContentLabelType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "SEXUALLY_SUGGESTIVE"] = 2;
                            values[valuesById[3] = "BELOW_THE_FOLD"] = 3;
                            values[valuesById[4] = "PARKED_DOMAIN"] = 4;
                            values[valuesById[5] = "GAME"] = 5;
                            values[valuesById[6] = "JUVENILE"] = 6;
                            values[valuesById[7] = "PROFANITY"] = 7;
                            values[valuesById[8] = "TRAGEDY"] = 8;
                            values[valuesById[9] = "VIDEO"] = 9;
                            values[valuesById[10] = "VIDEO_RATING_DV_G"] = 10;
                            values[valuesById[11] = "VIDEO_RATING_DV_PG"] = 11;
                            values[valuesById[12] = "VIDEO_RATING_DV_T"] = 12;
                            values[valuesById[13] = "VIDEO_RATING_DV_MA"] = 13;
                            values[valuesById[14] = "VIDEO_NOT_YET_RATED"] = 14;
                            values[valuesById[15] = "EMBEDDED_VIDEO"] = 15;
                            values[valuesById[16] = "LIVE_STREAMING_VIDEO"] = 16;
                            return values;
                        })();

                        return ContentLabelTypeEnum;
                    })();

                    enums.ConversionActionCategoryEnum = (function() {

                        /**
                         * Properties of a ConversionActionCategoryEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IConversionActionCategoryEnum
                         */

                        /**
                         * Constructs a new ConversionActionCategoryEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ConversionActionCategoryEnum.
                         * @implements IConversionActionCategoryEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IConversionActionCategoryEnum=} [properties] Properties to set
                         */
                        function ConversionActionCategoryEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ConversionActionCategoryEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ConversionActionCategoryEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionActionCategoryEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ConversionActionCategoryEnum} ConversionActionCategoryEnum instance
                         */
                        ConversionActionCategoryEnum.create = function create(properties) {
                            return new ConversionActionCategoryEnum(properties);
                        };

                        /**
                         * Encodes the specified ConversionActionCategoryEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ConversionActionCategoryEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ConversionActionCategoryEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionActionCategoryEnum} message ConversionActionCategoryEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionActionCategoryEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ConversionActionCategoryEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ConversionActionCategoryEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ConversionActionCategoryEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionActionCategoryEnum} message ConversionActionCategoryEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionActionCategoryEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ConversionActionCategoryEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ConversionActionCategoryEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ConversionActionCategoryEnum} ConversionActionCategoryEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionActionCategoryEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ConversionActionCategoryEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ConversionActionCategoryEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ConversionActionCategoryEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ConversionActionCategoryEnum} ConversionActionCategoryEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionActionCategoryEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ConversionActionCategoryEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ConversionActionCategoryEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConversionActionCategoryEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ConversionActionCategoryEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ConversionActionCategoryEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ConversionActionCategoryEnum} ConversionActionCategoryEnum
                         */
                        ConversionActionCategoryEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ConversionActionCategoryEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ConversionActionCategoryEnum();
                        };

                        /**
                         * Creates a plain object from a ConversionActionCategoryEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ConversionActionCategoryEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ConversionActionCategoryEnum} message ConversionActionCategoryEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConversionActionCategoryEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ConversionActionCategoryEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ConversionActionCategoryEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConversionActionCategoryEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ConversionActionCategory enum.
                         * @name google.ads.googleads.v1.enums.ConversionActionCategoryEnum.ConversionActionCategory
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} DEFAULT=2 DEFAULT value
                         * @property {number} PAGE_VIEW=3 PAGE_VIEW value
                         * @property {number} PURCHASE=4 PURCHASE value
                         * @property {number} SIGNUP=5 SIGNUP value
                         * @property {number} LEAD=6 LEAD value
                         * @property {number} DOWNLOAD=7 DOWNLOAD value
                         */
                        ConversionActionCategoryEnum.ConversionActionCategory = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "DEFAULT"] = 2;
                            values[valuesById[3] = "PAGE_VIEW"] = 3;
                            values[valuesById[4] = "PURCHASE"] = 4;
                            values[valuesById[5] = "SIGNUP"] = 5;
                            values[valuesById[6] = "LEAD"] = 6;
                            values[valuesById[7] = "DOWNLOAD"] = 7;
                            return values;
                        })();

                        return ConversionActionCategoryEnum;
                    })();

                    enums.ConversionActionCountingTypeEnum = (function() {

                        /**
                         * Properties of a ConversionActionCountingTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IConversionActionCountingTypeEnum
                         */

                        /**
                         * Constructs a new ConversionActionCountingTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ConversionActionCountingTypeEnum.
                         * @implements IConversionActionCountingTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IConversionActionCountingTypeEnum=} [properties] Properties to set
                         */
                        function ConversionActionCountingTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ConversionActionCountingTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionActionCountingTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum} ConversionActionCountingTypeEnum instance
                         */
                        ConversionActionCountingTypeEnum.create = function create(properties) {
                            return new ConversionActionCountingTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified ConversionActionCountingTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionActionCountingTypeEnum} message ConversionActionCountingTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionActionCountingTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ConversionActionCountingTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionActionCountingTypeEnum} message ConversionActionCountingTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionActionCountingTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ConversionActionCountingTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum} ConversionActionCountingTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionActionCountingTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ConversionActionCountingTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum} ConversionActionCountingTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionActionCountingTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ConversionActionCountingTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConversionActionCountingTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ConversionActionCountingTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum} ConversionActionCountingTypeEnum
                         */
                        ConversionActionCountingTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum();
                        };

                        /**
                         * Creates a plain object from a ConversionActionCountingTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum} message ConversionActionCountingTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConversionActionCountingTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ConversionActionCountingTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConversionActionCountingTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ConversionActionCountingType enum.
                         * @name google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum.ConversionActionCountingType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ONE_PER_CLICK=2 ONE_PER_CLICK value
                         * @property {number} MANY_PER_CLICK=3 MANY_PER_CLICK value
                         */
                        ConversionActionCountingTypeEnum.ConversionActionCountingType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ONE_PER_CLICK"] = 2;
                            values[valuesById[3] = "MANY_PER_CLICK"] = 3;
                            return values;
                        })();

                        return ConversionActionCountingTypeEnum;
                    })();

                    enums.ConversionActionStatusEnum = (function() {

                        /**
                         * Properties of a ConversionActionStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IConversionActionStatusEnum
                         */

                        /**
                         * Constructs a new ConversionActionStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ConversionActionStatusEnum.
                         * @implements IConversionActionStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IConversionActionStatusEnum=} [properties] Properties to set
                         */
                        function ConversionActionStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ConversionActionStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ConversionActionStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionActionStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ConversionActionStatusEnum} ConversionActionStatusEnum instance
                         */
                        ConversionActionStatusEnum.create = function create(properties) {
                            return new ConversionActionStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified ConversionActionStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ConversionActionStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ConversionActionStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionActionStatusEnum} message ConversionActionStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionActionStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ConversionActionStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ConversionActionStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ConversionActionStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionActionStatusEnum} message ConversionActionStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionActionStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ConversionActionStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ConversionActionStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ConversionActionStatusEnum} ConversionActionStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionActionStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ConversionActionStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ConversionActionStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ConversionActionStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ConversionActionStatusEnum} ConversionActionStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionActionStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ConversionActionStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ConversionActionStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConversionActionStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ConversionActionStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ConversionActionStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ConversionActionStatusEnum} ConversionActionStatusEnum
                         */
                        ConversionActionStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ConversionActionStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ConversionActionStatusEnum();
                        };

                        /**
                         * Creates a plain object from a ConversionActionStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ConversionActionStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ConversionActionStatusEnum} message ConversionActionStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConversionActionStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ConversionActionStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ConversionActionStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConversionActionStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ConversionActionStatus enum.
                         * @name google.ads.googleads.v1.enums.ConversionActionStatusEnum.ConversionActionStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENABLED=2 ENABLED value
                         * @property {number} REMOVED=3 REMOVED value
                         * @property {number} HIDDEN=4 HIDDEN value
                         */
                        ConversionActionStatusEnum.ConversionActionStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENABLED"] = 2;
                            values[valuesById[3] = "REMOVED"] = 3;
                            values[valuesById[4] = "HIDDEN"] = 4;
                            return values;
                        })();

                        return ConversionActionStatusEnum;
                    })();

                    enums.ConversionActionTypeEnum = (function() {

                        /**
                         * Properties of a ConversionActionTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IConversionActionTypeEnum
                         */

                        /**
                         * Constructs a new ConversionActionTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ConversionActionTypeEnum.
                         * @implements IConversionActionTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IConversionActionTypeEnum=} [properties] Properties to set
                         */
                        function ConversionActionTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ConversionActionTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ConversionActionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionActionTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ConversionActionTypeEnum} ConversionActionTypeEnum instance
                         */
                        ConversionActionTypeEnum.create = function create(properties) {
                            return new ConversionActionTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified ConversionActionTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ConversionActionTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ConversionActionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionActionTypeEnum} message ConversionActionTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionActionTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ConversionActionTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ConversionActionTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ConversionActionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionActionTypeEnum} message ConversionActionTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionActionTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ConversionActionTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ConversionActionTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ConversionActionTypeEnum} ConversionActionTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionActionTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ConversionActionTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ConversionActionTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ConversionActionTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ConversionActionTypeEnum} ConversionActionTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionActionTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ConversionActionTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ConversionActionTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConversionActionTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ConversionActionTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ConversionActionTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ConversionActionTypeEnum} ConversionActionTypeEnum
                         */
                        ConversionActionTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ConversionActionTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ConversionActionTypeEnum();
                        };

                        /**
                         * Creates a plain object from a ConversionActionTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ConversionActionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ConversionActionTypeEnum} message ConversionActionTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConversionActionTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ConversionActionTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ConversionActionTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConversionActionTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ConversionActionType enum.
                         * @name google.ads.googleads.v1.enums.ConversionActionTypeEnum.ConversionActionType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} AD_CALL=2 AD_CALL value
                         * @property {number} CLICK_TO_CALL=3 CLICK_TO_CALL value
                         * @property {number} GOOGLE_PLAY_DOWNLOAD=4 GOOGLE_PLAY_DOWNLOAD value
                         * @property {number} GOOGLE_PLAY_IN_APP_PURCHASE=5 GOOGLE_PLAY_IN_APP_PURCHASE value
                         * @property {number} UPLOAD_CALLS=6 UPLOAD_CALLS value
                         * @property {number} UPLOAD_CLICKS=7 UPLOAD_CLICKS value
                         * @property {number} WEBPAGE=8 WEBPAGE value
                         * @property {number} WEBSITE_CALL=9 WEBSITE_CALL value
                         */
                        ConversionActionTypeEnum.ConversionActionType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "AD_CALL"] = 2;
                            values[valuesById[3] = "CLICK_TO_CALL"] = 3;
                            values[valuesById[4] = "GOOGLE_PLAY_DOWNLOAD"] = 4;
                            values[valuesById[5] = "GOOGLE_PLAY_IN_APP_PURCHASE"] = 5;
                            values[valuesById[6] = "UPLOAD_CALLS"] = 6;
                            values[valuesById[7] = "UPLOAD_CLICKS"] = 7;
                            values[valuesById[8] = "WEBPAGE"] = 8;
                            values[valuesById[9] = "WEBSITE_CALL"] = 9;
                            return values;
                        })();

                        return ConversionActionTypeEnum;
                    })();

                    enums.ConversionAdjustmentTypeEnum = (function() {

                        /**
                         * Properties of a ConversionAdjustmentTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IConversionAdjustmentTypeEnum
                         */

                        /**
                         * Constructs a new ConversionAdjustmentTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ConversionAdjustmentTypeEnum.
                         * @implements IConversionAdjustmentTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IConversionAdjustmentTypeEnum=} [properties] Properties to set
                         */
                        function ConversionAdjustmentTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ConversionAdjustmentTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionAdjustmentTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum} ConversionAdjustmentTypeEnum instance
                         */
                        ConversionAdjustmentTypeEnum.create = function create(properties) {
                            return new ConversionAdjustmentTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified ConversionAdjustmentTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionAdjustmentTypeEnum} message ConversionAdjustmentTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionAdjustmentTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ConversionAdjustmentTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionAdjustmentTypeEnum} message ConversionAdjustmentTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionAdjustmentTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ConversionAdjustmentTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum} ConversionAdjustmentTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionAdjustmentTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ConversionAdjustmentTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum} ConversionAdjustmentTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionAdjustmentTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ConversionAdjustmentTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConversionAdjustmentTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ConversionAdjustmentTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum} ConversionAdjustmentTypeEnum
                         */
                        ConversionAdjustmentTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum();
                        };

                        /**
                         * Creates a plain object from a ConversionAdjustmentTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum} message ConversionAdjustmentTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConversionAdjustmentTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ConversionAdjustmentTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConversionAdjustmentTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ConversionAdjustmentType enum.
                         * @name google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum.ConversionAdjustmentType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} RETRACTION=2 RETRACTION value
                         * @property {number} RESTATEMENT=3 RESTATEMENT value
                         */
                        ConversionAdjustmentTypeEnum.ConversionAdjustmentType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "RETRACTION"] = 2;
                            values[valuesById[3] = "RESTATEMENT"] = 3;
                            return values;
                        })();

                        return ConversionAdjustmentTypeEnum;
                    })();

                    enums.ConversionAttributionEventTypeEnum = (function() {

                        /**
                         * Properties of a ConversionAttributionEventTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IConversionAttributionEventTypeEnum
                         */

                        /**
                         * Constructs a new ConversionAttributionEventTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ConversionAttributionEventTypeEnum.
                         * @implements IConversionAttributionEventTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IConversionAttributionEventTypeEnum=} [properties] Properties to set
                         */
                        function ConversionAttributionEventTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ConversionAttributionEventTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionAttributionEventTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum} ConversionAttributionEventTypeEnum instance
                         */
                        ConversionAttributionEventTypeEnum.create = function create(properties) {
                            return new ConversionAttributionEventTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified ConversionAttributionEventTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionAttributionEventTypeEnum} message ConversionAttributionEventTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionAttributionEventTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ConversionAttributionEventTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionAttributionEventTypeEnum} message ConversionAttributionEventTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionAttributionEventTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ConversionAttributionEventTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum} ConversionAttributionEventTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionAttributionEventTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ConversionAttributionEventTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum} ConversionAttributionEventTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionAttributionEventTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ConversionAttributionEventTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConversionAttributionEventTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ConversionAttributionEventTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum} ConversionAttributionEventTypeEnum
                         */
                        ConversionAttributionEventTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum();
                        };

                        /**
                         * Creates a plain object from a ConversionAttributionEventTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum} message ConversionAttributionEventTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConversionAttributionEventTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ConversionAttributionEventTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConversionAttributionEventTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ConversionAttributionEventType enum.
                         * @name google.ads.googleads.v1.enums.ConversionAttributionEventTypeEnum.ConversionAttributionEventType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} IMPRESSION=2 IMPRESSION value
                         * @property {number} INTERACTION=3 INTERACTION value
                         */
                        ConversionAttributionEventTypeEnum.ConversionAttributionEventType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "IMPRESSION"] = 2;
                            values[valuesById[3] = "INTERACTION"] = 3;
                            return values;
                        })();

                        return ConversionAttributionEventTypeEnum;
                    })();

                    enums.ConversionLagBucketEnum = (function() {

                        /**
                         * Properties of a ConversionLagBucketEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IConversionLagBucketEnum
                         */

                        /**
                         * Constructs a new ConversionLagBucketEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ConversionLagBucketEnum.
                         * @implements IConversionLagBucketEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IConversionLagBucketEnum=} [properties] Properties to set
                         */
                        function ConversionLagBucketEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ConversionLagBucketEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ConversionLagBucketEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionLagBucketEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ConversionLagBucketEnum} ConversionLagBucketEnum instance
                         */
                        ConversionLagBucketEnum.create = function create(properties) {
                            return new ConversionLagBucketEnum(properties);
                        };

                        /**
                         * Encodes the specified ConversionLagBucketEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ConversionLagBucketEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ConversionLagBucketEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionLagBucketEnum} message ConversionLagBucketEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionLagBucketEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ConversionLagBucketEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ConversionLagBucketEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ConversionLagBucketEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionLagBucketEnum} message ConversionLagBucketEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionLagBucketEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ConversionLagBucketEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ConversionLagBucketEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ConversionLagBucketEnum} ConversionLagBucketEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionLagBucketEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ConversionLagBucketEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ConversionLagBucketEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ConversionLagBucketEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ConversionLagBucketEnum} ConversionLagBucketEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionLagBucketEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ConversionLagBucketEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ConversionLagBucketEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConversionLagBucketEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ConversionLagBucketEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ConversionLagBucketEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ConversionLagBucketEnum} ConversionLagBucketEnum
                         */
                        ConversionLagBucketEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ConversionLagBucketEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ConversionLagBucketEnum();
                        };

                        /**
                         * Creates a plain object from a ConversionLagBucketEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ConversionLagBucketEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ConversionLagBucketEnum} message ConversionLagBucketEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConversionLagBucketEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ConversionLagBucketEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ConversionLagBucketEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConversionLagBucketEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ConversionLagBucket enum.
                         * @name google.ads.googleads.v1.enums.ConversionLagBucketEnum.ConversionLagBucket
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} LESS_THAN_ONE_DAY=2 LESS_THAN_ONE_DAY value
                         * @property {number} ONE_TO_TWO_DAYS=3 ONE_TO_TWO_DAYS value
                         * @property {number} TWO_TO_THREE_DAYS=4 TWO_TO_THREE_DAYS value
                         * @property {number} THREE_TO_FOUR_DAYS=5 THREE_TO_FOUR_DAYS value
                         * @property {number} FOUR_TO_FIVE_DAYS=6 FOUR_TO_FIVE_DAYS value
                         * @property {number} FIVE_TO_SIX_DAYS=7 FIVE_TO_SIX_DAYS value
                         * @property {number} SIX_TO_SEVEN_DAYS=8 SIX_TO_SEVEN_DAYS value
                         * @property {number} SEVEN_TO_EIGHT_DAYS=9 SEVEN_TO_EIGHT_DAYS value
                         * @property {number} EIGHT_TO_NINE_DAYS=10 EIGHT_TO_NINE_DAYS value
                         * @property {number} NINE_TO_TEN_DAYS=11 NINE_TO_TEN_DAYS value
                         * @property {number} TEN_TO_ELEVEN_DAYS=12 TEN_TO_ELEVEN_DAYS value
                         * @property {number} ELEVEN_TO_TWELVE_DAYS=13 ELEVEN_TO_TWELVE_DAYS value
                         * @property {number} TWELVE_TO_THIRTEEN_DAYS=14 TWELVE_TO_THIRTEEN_DAYS value
                         * @property {number} THIRTEEN_TO_FOURTEEN_DAYS=15 THIRTEEN_TO_FOURTEEN_DAYS value
                         * @property {number} FOURTEEN_TO_TWENTY_ONE_DAYS=16 FOURTEEN_TO_TWENTY_ONE_DAYS value
                         * @property {number} TWENTY_ONE_TO_THIRTY_DAYS=17 TWENTY_ONE_TO_THIRTY_DAYS value
                         * @property {number} THIRTY_TO_FORTY_FIVE_DAYS=18 THIRTY_TO_FORTY_FIVE_DAYS value
                         * @property {number} FORTY_FIVE_TO_SIXTY_DAYS=19 FORTY_FIVE_TO_SIXTY_DAYS value
                         * @property {number} SIXTY_TO_NINETY_DAYS=20 SIXTY_TO_NINETY_DAYS value
                         */
                        ConversionLagBucketEnum.ConversionLagBucket = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "LESS_THAN_ONE_DAY"] = 2;
                            values[valuesById[3] = "ONE_TO_TWO_DAYS"] = 3;
                            values[valuesById[4] = "TWO_TO_THREE_DAYS"] = 4;
                            values[valuesById[5] = "THREE_TO_FOUR_DAYS"] = 5;
                            values[valuesById[6] = "FOUR_TO_FIVE_DAYS"] = 6;
                            values[valuesById[7] = "FIVE_TO_SIX_DAYS"] = 7;
                            values[valuesById[8] = "SIX_TO_SEVEN_DAYS"] = 8;
                            values[valuesById[9] = "SEVEN_TO_EIGHT_DAYS"] = 9;
                            values[valuesById[10] = "EIGHT_TO_NINE_DAYS"] = 10;
                            values[valuesById[11] = "NINE_TO_TEN_DAYS"] = 11;
                            values[valuesById[12] = "TEN_TO_ELEVEN_DAYS"] = 12;
                            values[valuesById[13] = "ELEVEN_TO_TWELVE_DAYS"] = 13;
                            values[valuesById[14] = "TWELVE_TO_THIRTEEN_DAYS"] = 14;
                            values[valuesById[15] = "THIRTEEN_TO_FOURTEEN_DAYS"] = 15;
                            values[valuesById[16] = "FOURTEEN_TO_TWENTY_ONE_DAYS"] = 16;
                            values[valuesById[17] = "TWENTY_ONE_TO_THIRTY_DAYS"] = 17;
                            values[valuesById[18] = "THIRTY_TO_FORTY_FIVE_DAYS"] = 18;
                            values[valuesById[19] = "FORTY_FIVE_TO_SIXTY_DAYS"] = 19;
                            values[valuesById[20] = "SIXTY_TO_NINETY_DAYS"] = 20;
                            return values;
                        })();

                        return ConversionLagBucketEnum;
                    })();

                    enums.ConversionOrAdjustmentLagBucketEnum = (function() {

                        /**
                         * Properties of a ConversionOrAdjustmentLagBucketEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IConversionOrAdjustmentLagBucketEnum
                         */

                        /**
                         * Constructs a new ConversionOrAdjustmentLagBucketEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ConversionOrAdjustmentLagBucketEnum.
                         * @implements IConversionOrAdjustmentLagBucketEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IConversionOrAdjustmentLagBucketEnum=} [properties] Properties to set
                         */
                        function ConversionOrAdjustmentLagBucketEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ConversionOrAdjustmentLagBucketEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionOrAdjustmentLagBucketEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum} ConversionOrAdjustmentLagBucketEnum instance
                         */
                        ConversionOrAdjustmentLagBucketEnum.create = function create(properties) {
                            return new ConversionOrAdjustmentLagBucketEnum(properties);
                        };

                        /**
                         * Encodes the specified ConversionOrAdjustmentLagBucketEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionOrAdjustmentLagBucketEnum} message ConversionOrAdjustmentLagBucketEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionOrAdjustmentLagBucketEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ConversionOrAdjustmentLagBucketEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IConversionOrAdjustmentLagBucketEnum} message ConversionOrAdjustmentLagBucketEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionOrAdjustmentLagBucketEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ConversionOrAdjustmentLagBucketEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum} ConversionOrAdjustmentLagBucketEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionOrAdjustmentLagBucketEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ConversionOrAdjustmentLagBucketEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum} ConversionOrAdjustmentLagBucketEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionOrAdjustmentLagBucketEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ConversionOrAdjustmentLagBucketEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConversionOrAdjustmentLagBucketEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ConversionOrAdjustmentLagBucketEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum} ConversionOrAdjustmentLagBucketEnum
                         */
                        ConversionOrAdjustmentLagBucketEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum();
                        };

                        /**
                         * Creates a plain object from a ConversionOrAdjustmentLagBucketEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum} message ConversionOrAdjustmentLagBucketEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConversionOrAdjustmentLagBucketEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ConversionOrAdjustmentLagBucketEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConversionOrAdjustmentLagBucketEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ConversionOrAdjustmentLagBucket enum.
                         * @name google.ads.googleads.v1.enums.ConversionOrAdjustmentLagBucketEnum.ConversionOrAdjustmentLagBucket
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CONVERSION_LESS_THAN_ONE_DAY=2 CONVERSION_LESS_THAN_ONE_DAY value
                         * @property {number} CONVERSION_ONE_TO_TWO_DAYS=3 CONVERSION_ONE_TO_TWO_DAYS value
                         * @property {number} CONVERSION_TWO_TO_THREE_DAYS=4 CONVERSION_TWO_TO_THREE_DAYS value
                         * @property {number} CONVERSION_THREE_TO_FOUR_DAYS=5 CONVERSION_THREE_TO_FOUR_DAYS value
                         * @property {number} CONVERSION_FOUR_TO_FIVE_DAYS=6 CONVERSION_FOUR_TO_FIVE_DAYS value
                         * @property {number} CONVERSION_FIVE_TO_SIX_DAYS=7 CONVERSION_FIVE_TO_SIX_DAYS value
                         * @property {number} CONVERSION_SIX_TO_SEVEN_DAYS=8 CONVERSION_SIX_TO_SEVEN_DAYS value
                         * @property {number} CONVERSION_SEVEN_TO_EIGHT_DAYS=9 CONVERSION_SEVEN_TO_EIGHT_DAYS value
                         * @property {number} CONVERSION_EIGHT_TO_NINE_DAYS=10 CONVERSION_EIGHT_TO_NINE_DAYS value
                         * @property {number} CONVERSION_NINE_TO_TEN_DAYS=11 CONVERSION_NINE_TO_TEN_DAYS value
                         * @property {number} CONVERSION_TEN_TO_ELEVEN_DAYS=12 CONVERSION_TEN_TO_ELEVEN_DAYS value
                         * @property {number} CONVERSION_ELEVEN_TO_TWELVE_DAYS=13 CONVERSION_ELEVEN_TO_TWELVE_DAYS value
                         * @property {number} CONVERSION_TWELVE_TO_THIRTEEN_DAYS=14 CONVERSION_TWELVE_TO_THIRTEEN_DAYS value
                         * @property {number} CONVERSION_THIRTEEN_TO_FOURTEEN_DAYS=15 CONVERSION_THIRTEEN_TO_FOURTEEN_DAYS value
                         * @property {number} CONVERSION_FOURTEEN_TO_TWENTY_ONE_DAYS=16 CONVERSION_FOURTEEN_TO_TWENTY_ONE_DAYS value
                         * @property {number} CONVERSION_TWENTY_ONE_TO_THIRTY_DAYS=17 CONVERSION_TWENTY_ONE_TO_THIRTY_DAYS value
                         * @property {number} CONVERSION_THIRTY_TO_FORTY_FIVE_DAYS=18 CONVERSION_THIRTY_TO_FORTY_FIVE_DAYS value
                         * @property {number} CONVERSION_FORTY_FIVE_TO_SIXTY_DAYS=19 CONVERSION_FORTY_FIVE_TO_SIXTY_DAYS value
                         * @property {number} CONVERSION_SIXTY_TO_NINETY_DAYS=20 CONVERSION_SIXTY_TO_NINETY_DAYS value
                         * @property {number} ADJUSTMENT_LESS_THAN_ONE_DAY=21 ADJUSTMENT_LESS_THAN_ONE_DAY value
                         * @property {number} ADJUSTMENT_ONE_TO_TWO_DAYS=22 ADJUSTMENT_ONE_TO_TWO_DAYS value
                         * @property {number} ADJUSTMENT_TWO_TO_THREE_DAYS=23 ADJUSTMENT_TWO_TO_THREE_DAYS value
                         * @property {number} ADJUSTMENT_THREE_TO_FOUR_DAYS=24 ADJUSTMENT_THREE_TO_FOUR_DAYS value
                         * @property {number} ADJUSTMENT_FOUR_TO_FIVE_DAYS=25 ADJUSTMENT_FOUR_TO_FIVE_DAYS value
                         * @property {number} ADJUSTMENT_FIVE_TO_SIX_DAYS=26 ADJUSTMENT_FIVE_TO_SIX_DAYS value
                         * @property {number} ADJUSTMENT_SIX_TO_SEVEN_DAYS=27 ADJUSTMENT_SIX_TO_SEVEN_DAYS value
                         * @property {number} ADJUSTMENT_SEVEN_TO_EIGHT_DAYS=28 ADJUSTMENT_SEVEN_TO_EIGHT_DAYS value
                         * @property {number} ADJUSTMENT_EIGHT_TO_NINE_DAYS=29 ADJUSTMENT_EIGHT_TO_NINE_DAYS value
                         * @property {number} ADJUSTMENT_NINE_TO_TEN_DAYS=30 ADJUSTMENT_NINE_TO_TEN_DAYS value
                         * @property {number} ADJUSTMENT_TEN_TO_ELEVEN_DAYS=31 ADJUSTMENT_TEN_TO_ELEVEN_DAYS value
                         * @property {number} ADJUSTMENT_ELEVEN_TO_TWELVE_DAYS=32 ADJUSTMENT_ELEVEN_TO_TWELVE_DAYS value
                         * @property {number} ADJUSTMENT_TWELVE_TO_THIRTEEN_DAYS=33 ADJUSTMENT_TWELVE_TO_THIRTEEN_DAYS value
                         * @property {number} ADJUSTMENT_THIRTEEN_TO_FOURTEEN_DAYS=34 ADJUSTMENT_THIRTEEN_TO_FOURTEEN_DAYS value
                         * @property {number} ADJUSTMENT_FOURTEEN_TO_TWENTY_ONE_DAYS=35 ADJUSTMENT_FOURTEEN_TO_TWENTY_ONE_DAYS value
                         * @property {number} ADJUSTMENT_TWENTY_ONE_TO_THIRTY_DAYS=36 ADJUSTMENT_TWENTY_ONE_TO_THIRTY_DAYS value
                         * @property {number} ADJUSTMENT_THIRTY_TO_FORTY_FIVE_DAYS=37 ADJUSTMENT_THIRTY_TO_FORTY_FIVE_DAYS value
                         * @property {number} ADJUSTMENT_FORTY_FIVE_TO_SIXTY_DAYS=38 ADJUSTMENT_FORTY_FIVE_TO_SIXTY_DAYS value
                         * @property {number} ADJUSTMENT_SIXTY_TO_NINETY_DAYS=39 ADJUSTMENT_SIXTY_TO_NINETY_DAYS value
                         * @property {number} ADJUSTMENT_NINETY_TO_ONE_HUNDRED_AND_FORTY_FIVE_DAYS=40 ADJUSTMENT_NINETY_TO_ONE_HUNDRED_AND_FORTY_FIVE_DAYS value
                         * @property {number} CONVERSION_UNKNOWN=41 CONVERSION_UNKNOWN value
                         * @property {number} ADJUSTMENT_UNKNOWN=42 ADJUSTMENT_UNKNOWN value
                         */
                        ConversionOrAdjustmentLagBucketEnum.ConversionOrAdjustmentLagBucket = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CONVERSION_LESS_THAN_ONE_DAY"] = 2;
                            values[valuesById[3] = "CONVERSION_ONE_TO_TWO_DAYS"] = 3;
                            values[valuesById[4] = "CONVERSION_TWO_TO_THREE_DAYS"] = 4;
                            values[valuesById[5] = "CONVERSION_THREE_TO_FOUR_DAYS"] = 5;
                            values[valuesById[6] = "CONVERSION_FOUR_TO_FIVE_DAYS"] = 6;
                            values[valuesById[7] = "CONVERSION_FIVE_TO_SIX_DAYS"] = 7;
                            values[valuesById[8] = "CONVERSION_SIX_TO_SEVEN_DAYS"] = 8;
                            values[valuesById[9] = "CONVERSION_SEVEN_TO_EIGHT_DAYS"] = 9;
                            values[valuesById[10] = "CONVERSION_EIGHT_TO_NINE_DAYS"] = 10;
                            values[valuesById[11] = "CONVERSION_NINE_TO_TEN_DAYS"] = 11;
                            values[valuesById[12] = "CONVERSION_TEN_TO_ELEVEN_DAYS"] = 12;
                            values[valuesById[13] = "CONVERSION_ELEVEN_TO_TWELVE_DAYS"] = 13;
                            values[valuesById[14] = "CONVERSION_TWELVE_TO_THIRTEEN_DAYS"] = 14;
                            values[valuesById[15] = "CONVERSION_THIRTEEN_TO_FOURTEEN_DAYS"] = 15;
                            values[valuesById[16] = "CONVERSION_FOURTEEN_TO_TWENTY_ONE_DAYS"] = 16;
                            values[valuesById[17] = "CONVERSION_TWENTY_ONE_TO_THIRTY_DAYS"] = 17;
                            values[valuesById[18] = "CONVERSION_THIRTY_TO_FORTY_FIVE_DAYS"] = 18;
                            values[valuesById[19] = "CONVERSION_FORTY_FIVE_TO_SIXTY_DAYS"] = 19;
                            values[valuesById[20] = "CONVERSION_SIXTY_TO_NINETY_DAYS"] = 20;
                            values[valuesById[21] = "ADJUSTMENT_LESS_THAN_ONE_DAY"] = 21;
                            values[valuesById[22] = "ADJUSTMENT_ONE_TO_TWO_DAYS"] = 22;
                            values[valuesById[23] = "ADJUSTMENT_TWO_TO_THREE_DAYS"] = 23;
                            values[valuesById[24] = "ADJUSTMENT_THREE_TO_FOUR_DAYS"] = 24;
                            values[valuesById[25] = "ADJUSTMENT_FOUR_TO_FIVE_DAYS"] = 25;
                            values[valuesById[26] = "ADJUSTMENT_FIVE_TO_SIX_DAYS"] = 26;
                            values[valuesById[27] = "ADJUSTMENT_SIX_TO_SEVEN_DAYS"] = 27;
                            values[valuesById[28] = "ADJUSTMENT_SEVEN_TO_EIGHT_DAYS"] = 28;
                            values[valuesById[29] = "ADJUSTMENT_EIGHT_TO_NINE_DAYS"] = 29;
                            values[valuesById[30] = "ADJUSTMENT_NINE_TO_TEN_DAYS"] = 30;
                            values[valuesById[31] = "ADJUSTMENT_TEN_TO_ELEVEN_DAYS"] = 31;
                            values[valuesById[32] = "ADJUSTMENT_ELEVEN_TO_TWELVE_DAYS"] = 32;
                            values[valuesById[33] = "ADJUSTMENT_TWELVE_TO_THIRTEEN_DAYS"] = 33;
                            values[valuesById[34] = "ADJUSTMENT_THIRTEEN_TO_FOURTEEN_DAYS"] = 34;
                            values[valuesById[35] = "ADJUSTMENT_FOURTEEN_TO_TWENTY_ONE_DAYS"] = 35;
                            values[valuesById[36] = "ADJUSTMENT_TWENTY_ONE_TO_THIRTY_DAYS"] = 36;
                            values[valuesById[37] = "ADJUSTMENT_THIRTY_TO_FORTY_FIVE_DAYS"] = 37;
                            values[valuesById[38] = "ADJUSTMENT_FORTY_FIVE_TO_SIXTY_DAYS"] = 38;
                            values[valuesById[39] = "ADJUSTMENT_SIXTY_TO_NINETY_DAYS"] = 39;
                            values[valuesById[40] = "ADJUSTMENT_NINETY_TO_ONE_HUNDRED_AND_FORTY_FIVE_DAYS"] = 40;
                            values[valuesById[41] = "CONVERSION_UNKNOWN"] = 41;
                            values[valuesById[42] = "ADJUSTMENT_UNKNOWN"] = 42;
                            return values;
                        })();

                        return ConversionOrAdjustmentLagBucketEnum;
                    })();

                    enums.CriterionCategoryChannelAvailabilityModeEnum = (function() {

                        /**
                         * Properties of a CriterionCategoryChannelAvailabilityModeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ICriterionCategoryChannelAvailabilityModeEnum
                         */

                        /**
                         * Constructs a new CriterionCategoryChannelAvailabilityModeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a CriterionCategoryChannelAvailabilityModeEnum.
                         * @implements ICriterionCategoryChannelAvailabilityModeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ICriterionCategoryChannelAvailabilityModeEnum=} [properties] Properties to set
                         */
                        function CriterionCategoryChannelAvailabilityModeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CriterionCategoryChannelAvailabilityModeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICriterionCategoryChannelAvailabilityModeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum} CriterionCategoryChannelAvailabilityModeEnum instance
                         */
                        CriterionCategoryChannelAvailabilityModeEnum.create = function create(properties) {
                            return new CriterionCategoryChannelAvailabilityModeEnum(properties);
                        };

                        /**
                         * Encodes the specified CriterionCategoryChannelAvailabilityModeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICriterionCategoryChannelAvailabilityModeEnum} message CriterionCategoryChannelAvailabilityModeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CriterionCategoryChannelAvailabilityModeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CriterionCategoryChannelAvailabilityModeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICriterionCategoryChannelAvailabilityModeEnum} message CriterionCategoryChannelAvailabilityModeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CriterionCategoryChannelAvailabilityModeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CriterionCategoryChannelAvailabilityModeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum} CriterionCategoryChannelAvailabilityModeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CriterionCategoryChannelAvailabilityModeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CriterionCategoryChannelAvailabilityModeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum} CriterionCategoryChannelAvailabilityModeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CriterionCategoryChannelAvailabilityModeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CriterionCategoryChannelAvailabilityModeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CriterionCategoryChannelAvailabilityModeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CriterionCategoryChannelAvailabilityModeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum} CriterionCategoryChannelAvailabilityModeEnum
                         */
                        CriterionCategoryChannelAvailabilityModeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum();
                        };

                        /**
                         * Creates a plain object from a CriterionCategoryChannelAvailabilityModeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum} message CriterionCategoryChannelAvailabilityModeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CriterionCategoryChannelAvailabilityModeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CriterionCategoryChannelAvailabilityModeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CriterionCategoryChannelAvailabilityModeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CriterionCategoryChannelAvailabilityMode enum.
                         * @name google.ads.googleads.v1.enums.CriterionCategoryChannelAvailabilityModeEnum.CriterionCategoryChannelAvailabilityMode
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ALL_CHANNELS=2 ALL_CHANNELS value
                         * @property {number} CHANNEL_TYPE_AND_ALL_SUBTYPES=3 CHANNEL_TYPE_AND_ALL_SUBTYPES value
                         * @property {number} CHANNEL_TYPE_AND_SUBSET_SUBTYPES=4 CHANNEL_TYPE_AND_SUBSET_SUBTYPES value
                         */
                        CriterionCategoryChannelAvailabilityModeEnum.CriterionCategoryChannelAvailabilityMode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ALL_CHANNELS"] = 2;
                            values[valuesById[3] = "CHANNEL_TYPE_AND_ALL_SUBTYPES"] = 3;
                            values[valuesById[4] = "CHANNEL_TYPE_AND_SUBSET_SUBTYPES"] = 4;
                            return values;
                        })();

                        return CriterionCategoryChannelAvailabilityModeEnum;
                    })();

                    enums.CriterionCategoryLocaleAvailabilityModeEnum = (function() {

                        /**
                         * Properties of a CriterionCategoryLocaleAvailabilityModeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ICriterionCategoryLocaleAvailabilityModeEnum
                         */

                        /**
                         * Constructs a new CriterionCategoryLocaleAvailabilityModeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a CriterionCategoryLocaleAvailabilityModeEnum.
                         * @implements ICriterionCategoryLocaleAvailabilityModeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ICriterionCategoryLocaleAvailabilityModeEnum=} [properties] Properties to set
                         */
                        function CriterionCategoryLocaleAvailabilityModeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CriterionCategoryLocaleAvailabilityModeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICriterionCategoryLocaleAvailabilityModeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum} CriterionCategoryLocaleAvailabilityModeEnum instance
                         */
                        CriterionCategoryLocaleAvailabilityModeEnum.create = function create(properties) {
                            return new CriterionCategoryLocaleAvailabilityModeEnum(properties);
                        };

                        /**
                         * Encodes the specified CriterionCategoryLocaleAvailabilityModeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICriterionCategoryLocaleAvailabilityModeEnum} message CriterionCategoryLocaleAvailabilityModeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CriterionCategoryLocaleAvailabilityModeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CriterionCategoryLocaleAvailabilityModeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICriterionCategoryLocaleAvailabilityModeEnum} message CriterionCategoryLocaleAvailabilityModeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CriterionCategoryLocaleAvailabilityModeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CriterionCategoryLocaleAvailabilityModeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum} CriterionCategoryLocaleAvailabilityModeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CriterionCategoryLocaleAvailabilityModeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CriterionCategoryLocaleAvailabilityModeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum} CriterionCategoryLocaleAvailabilityModeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CriterionCategoryLocaleAvailabilityModeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CriterionCategoryLocaleAvailabilityModeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CriterionCategoryLocaleAvailabilityModeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CriterionCategoryLocaleAvailabilityModeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum} CriterionCategoryLocaleAvailabilityModeEnum
                         */
                        CriterionCategoryLocaleAvailabilityModeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum();
                        };

                        /**
                         * Creates a plain object from a CriterionCategoryLocaleAvailabilityModeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum} message CriterionCategoryLocaleAvailabilityModeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CriterionCategoryLocaleAvailabilityModeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CriterionCategoryLocaleAvailabilityModeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CriterionCategoryLocaleAvailabilityModeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CriterionCategoryLocaleAvailabilityMode enum.
                         * @name google.ads.googleads.v1.enums.CriterionCategoryLocaleAvailabilityModeEnum.CriterionCategoryLocaleAvailabilityMode
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ALL_LOCALES=2 ALL_LOCALES value
                         * @property {number} COUNTRY_AND_ALL_LANGUAGES=3 COUNTRY_AND_ALL_LANGUAGES value
                         * @property {number} LANGUAGE_AND_ALL_COUNTRIES=4 LANGUAGE_AND_ALL_COUNTRIES value
                         * @property {number} COUNTRY_AND_LANGUAGE=5 COUNTRY_AND_LANGUAGE value
                         */
                        CriterionCategoryLocaleAvailabilityModeEnum.CriterionCategoryLocaleAvailabilityMode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ALL_LOCALES"] = 2;
                            values[valuesById[3] = "COUNTRY_AND_ALL_LANGUAGES"] = 3;
                            values[valuesById[4] = "LANGUAGE_AND_ALL_COUNTRIES"] = 4;
                            values[valuesById[5] = "COUNTRY_AND_LANGUAGE"] = 5;
                            return values;
                        })();

                        return CriterionCategoryLocaleAvailabilityModeEnum;
                    })();

                    enums.CriterionSystemServingStatusEnum = (function() {

                        /**
                         * Properties of a CriterionSystemServingStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ICriterionSystemServingStatusEnum
                         */

                        /**
                         * Constructs a new CriterionSystemServingStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a CriterionSystemServingStatusEnum.
                         * @implements ICriterionSystemServingStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ICriterionSystemServingStatusEnum=} [properties] Properties to set
                         */
                        function CriterionSystemServingStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CriterionSystemServingStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICriterionSystemServingStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum} CriterionSystemServingStatusEnum instance
                         */
                        CriterionSystemServingStatusEnum.create = function create(properties) {
                            return new CriterionSystemServingStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified CriterionSystemServingStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICriterionSystemServingStatusEnum} message CriterionSystemServingStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CriterionSystemServingStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CriterionSystemServingStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICriterionSystemServingStatusEnum} message CriterionSystemServingStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CriterionSystemServingStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CriterionSystemServingStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum} CriterionSystemServingStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CriterionSystemServingStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CriterionSystemServingStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum} CriterionSystemServingStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CriterionSystemServingStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CriterionSystemServingStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CriterionSystemServingStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CriterionSystemServingStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum} CriterionSystemServingStatusEnum
                         */
                        CriterionSystemServingStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum();
                        };

                        /**
                         * Creates a plain object from a CriterionSystemServingStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum} message CriterionSystemServingStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CriterionSystemServingStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CriterionSystemServingStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CriterionSystemServingStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CriterionSystemServingStatus enum.
                         * @name google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum.CriterionSystemServingStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ELIGIBLE=2 ELIGIBLE value
                         * @property {number} RARELY_SERVED=3 RARELY_SERVED value
                         */
                        CriterionSystemServingStatusEnum.CriterionSystemServingStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ELIGIBLE"] = 2;
                            values[valuesById[3] = "RARELY_SERVED"] = 3;
                            return values;
                        })();

                        return CriterionSystemServingStatusEnum;
                    })();

                    enums.CriterionTypeEnum = (function() {

                        /**
                         * Properties of a CriterionTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ICriterionTypeEnum
                         */

                        /**
                         * Constructs a new CriterionTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a CriterionTypeEnum.
                         * @implements ICriterionTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ICriterionTypeEnum=} [properties] Properties to set
                         */
                        function CriterionTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CriterionTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.CriterionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICriterionTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.CriterionTypeEnum} CriterionTypeEnum instance
                         */
                        CriterionTypeEnum.create = function create(properties) {
                            return new CriterionTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified CriterionTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.CriterionTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.CriterionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICriterionTypeEnum} message CriterionTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CriterionTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CriterionTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.CriterionTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CriterionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICriterionTypeEnum} message CriterionTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CriterionTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CriterionTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.CriterionTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.CriterionTypeEnum} CriterionTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CriterionTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.CriterionTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CriterionTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CriterionTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.CriterionTypeEnum} CriterionTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CriterionTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CriterionTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.CriterionTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CriterionTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CriterionTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.CriterionTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.CriterionTypeEnum} CriterionTypeEnum
                         */
                        CriterionTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.CriterionTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.CriterionTypeEnum();
                        };

                        /**
                         * Creates a plain object from a CriterionTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.CriterionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.CriterionTypeEnum} message CriterionTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CriterionTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CriterionTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.CriterionTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CriterionTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CriterionType enum.
                         * @name google.ads.googleads.v1.enums.CriterionTypeEnum.CriterionType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} KEYWORD=2 KEYWORD value
                         * @property {number} PLACEMENT=3 PLACEMENT value
                         * @property {number} MOBILE_APP_CATEGORY=4 MOBILE_APP_CATEGORY value
                         * @property {number} MOBILE_APPLICATION=5 MOBILE_APPLICATION value
                         * @property {number} DEVICE=6 DEVICE value
                         * @property {number} LOCATION=7 LOCATION value
                         * @property {number} LISTING_GROUP=8 LISTING_GROUP value
                         * @property {number} AD_SCHEDULE=9 AD_SCHEDULE value
                         * @property {number} AGE_RANGE=10 AGE_RANGE value
                         * @property {number} GENDER=11 GENDER value
                         * @property {number} INCOME_RANGE=12 INCOME_RANGE value
                         * @property {number} PARENTAL_STATUS=13 PARENTAL_STATUS value
                         * @property {number} YOUTUBE_VIDEO=14 YOUTUBE_VIDEO value
                         * @property {number} YOUTUBE_CHANNEL=15 YOUTUBE_CHANNEL value
                         * @property {number} USER_LIST=16 USER_LIST value
                         * @property {number} PROXIMITY=17 PROXIMITY value
                         * @property {number} TOPIC=18 TOPIC value
                         * @property {number} LISTING_SCOPE=19 LISTING_SCOPE value
                         * @property {number} LANGUAGE=20 LANGUAGE value
                         * @property {number} IP_BLOCK=21 IP_BLOCK value
                         * @property {number} CONTENT_LABEL=22 CONTENT_LABEL value
                         * @property {number} CARRIER=23 CARRIER value
                         * @property {number} USER_INTEREST=24 USER_INTEREST value
                         * @property {number} WEBPAGE=25 WEBPAGE value
                         * @property {number} OPERATING_SYSTEM_VERSION=26 OPERATING_SYSTEM_VERSION value
                         * @property {number} APP_PAYMENT_MODEL=27 APP_PAYMENT_MODEL value
                         * @property {number} MOBILE_DEVICE=28 MOBILE_DEVICE value
                         * @property {number} CUSTOM_AFFINITY=29 CUSTOM_AFFINITY value
                         * @property {number} CUSTOM_INTENT=30 CUSTOM_INTENT value
                         * @property {number} LOCATION_GROUP=31 LOCATION_GROUP value
                         */
                        CriterionTypeEnum.CriterionType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "KEYWORD"] = 2;
                            values[valuesById[3] = "PLACEMENT"] = 3;
                            values[valuesById[4] = "MOBILE_APP_CATEGORY"] = 4;
                            values[valuesById[5] = "MOBILE_APPLICATION"] = 5;
                            values[valuesById[6] = "DEVICE"] = 6;
                            values[valuesById[7] = "LOCATION"] = 7;
                            values[valuesById[8] = "LISTING_GROUP"] = 8;
                            values[valuesById[9] = "AD_SCHEDULE"] = 9;
                            values[valuesById[10] = "AGE_RANGE"] = 10;
                            values[valuesById[11] = "GENDER"] = 11;
                            values[valuesById[12] = "INCOME_RANGE"] = 12;
                            values[valuesById[13] = "PARENTAL_STATUS"] = 13;
                            values[valuesById[14] = "YOUTUBE_VIDEO"] = 14;
                            values[valuesById[15] = "YOUTUBE_CHANNEL"] = 15;
                            values[valuesById[16] = "USER_LIST"] = 16;
                            values[valuesById[17] = "PROXIMITY"] = 17;
                            values[valuesById[18] = "TOPIC"] = 18;
                            values[valuesById[19] = "LISTING_SCOPE"] = 19;
                            values[valuesById[20] = "LANGUAGE"] = 20;
                            values[valuesById[21] = "IP_BLOCK"] = 21;
                            values[valuesById[22] = "CONTENT_LABEL"] = 22;
                            values[valuesById[23] = "CARRIER"] = 23;
                            values[valuesById[24] = "USER_INTEREST"] = 24;
                            values[valuesById[25] = "WEBPAGE"] = 25;
                            values[valuesById[26] = "OPERATING_SYSTEM_VERSION"] = 26;
                            values[valuesById[27] = "APP_PAYMENT_MODEL"] = 27;
                            values[valuesById[28] = "MOBILE_DEVICE"] = 28;
                            values[valuesById[29] = "CUSTOM_AFFINITY"] = 29;
                            values[valuesById[30] = "CUSTOM_INTENT"] = 30;
                            values[valuesById[31] = "LOCATION_GROUP"] = 31;
                            return values;
                        })();

                        return CriterionTypeEnum;
                    })();

                    enums.CustomInterestMemberTypeEnum = (function() {

                        /**
                         * Properties of a CustomInterestMemberTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ICustomInterestMemberTypeEnum
                         */

                        /**
                         * Constructs a new CustomInterestMemberTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a CustomInterestMemberTypeEnum.
                         * @implements ICustomInterestMemberTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ICustomInterestMemberTypeEnum=} [properties] Properties to set
                         */
                        function CustomInterestMemberTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CustomInterestMemberTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICustomInterestMemberTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum} CustomInterestMemberTypeEnum instance
                         */
                        CustomInterestMemberTypeEnum.create = function create(properties) {
                            return new CustomInterestMemberTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified CustomInterestMemberTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICustomInterestMemberTypeEnum} message CustomInterestMemberTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomInterestMemberTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomInterestMemberTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICustomInterestMemberTypeEnum} message CustomInterestMemberTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomInterestMemberTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomInterestMemberTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum} CustomInterestMemberTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomInterestMemberTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomInterestMemberTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum} CustomInterestMemberTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomInterestMemberTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomInterestMemberTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomInterestMemberTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CustomInterestMemberTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum} CustomInterestMemberTypeEnum
                         */
                        CustomInterestMemberTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum();
                        };

                        /**
                         * Creates a plain object from a CustomInterestMemberTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum} message CustomInterestMemberTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomInterestMemberTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CustomInterestMemberTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomInterestMemberTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CustomInterestMemberType enum.
                         * @name google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum.CustomInterestMemberType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} KEYWORD=2 KEYWORD value
                         * @property {number} URL=3 URL value
                         */
                        CustomInterestMemberTypeEnum.CustomInterestMemberType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "KEYWORD"] = 2;
                            values[valuesById[3] = "URL"] = 3;
                            return values;
                        })();

                        return CustomInterestMemberTypeEnum;
                    })();

                    enums.CustomInterestStatusEnum = (function() {

                        /**
                         * Properties of a CustomInterestStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ICustomInterestStatusEnum
                         */

                        /**
                         * Constructs a new CustomInterestStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a CustomInterestStatusEnum.
                         * @implements ICustomInterestStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ICustomInterestStatusEnum=} [properties] Properties to set
                         */
                        function CustomInterestStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CustomInterestStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.CustomInterestStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICustomInterestStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.CustomInterestStatusEnum} CustomInterestStatusEnum instance
                         */
                        CustomInterestStatusEnum.create = function create(properties) {
                            return new CustomInterestStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified CustomInterestStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.CustomInterestStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.CustomInterestStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICustomInterestStatusEnum} message CustomInterestStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomInterestStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomInterestStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.CustomInterestStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CustomInterestStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICustomInterestStatusEnum} message CustomInterestStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomInterestStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomInterestStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.CustomInterestStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.CustomInterestStatusEnum} CustomInterestStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomInterestStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.CustomInterestStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomInterestStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CustomInterestStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.CustomInterestStatusEnum} CustomInterestStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomInterestStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomInterestStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.CustomInterestStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomInterestStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CustomInterestStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.CustomInterestStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.CustomInterestStatusEnum} CustomInterestStatusEnum
                         */
                        CustomInterestStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.CustomInterestStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.CustomInterestStatusEnum();
                        };

                        /**
                         * Creates a plain object from a CustomInterestStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.CustomInterestStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.CustomInterestStatusEnum} message CustomInterestStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomInterestStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CustomInterestStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.CustomInterestStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomInterestStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CustomInterestStatus enum.
                         * @name google.ads.googleads.v1.enums.CustomInterestStatusEnum.CustomInterestStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENABLED=2 ENABLED value
                         * @property {number} REMOVED=3 REMOVED value
                         */
                        CustomInterestStatusEnum.CustomInterestStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENABLED"] = 2;
                            values[valuesById[3] = "REMOVED"] = 3;
                            return values;
                        })();

                        return CustomInterestStatusEnum;
                    })();

                    enums.CustomInterestTypeEnum = (function() {

                        /**
                         * Properties of a CustomInterestTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ICustomInterestTypeEnum
                         */

                        /**
                         * Constructs a new CustomInterestTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a CustomInterestTypeEnum.
                         * @implements ICustomInterestTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ICustomInterestTypeEnum=} [properties] Properties to set
                         */
                        function CustomInterestTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CustomInterestTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.CustomInterestTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICustomInterestTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.CustomInterestTypeEnum} CustomInterestTypeEnum instance
                         */
                        CustomInterestTypeEnum.create = function create(properties) {
                            return new CustomInterestTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified CustomInterestTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.CustomInterestTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.CustomInterestTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICustomInterestTypeEnum} message CustomInterestTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomInterestTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomInterestTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.CustomInterestTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CustomInterestTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICustomInterestTypeEnum} message CustomInterestTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomInterestTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomInterestTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.CustomInterestTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.CustomInterestTypeEnum} CustomInterestTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomInterestTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.CustomInterestTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomInterestTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CustomInterestTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.CustomInterestTypeEnum} CustomInterestTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomInterestTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomInterestTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.CustomInterestTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomInterestTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CustomInterestTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.CustomInterestTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.CustomInterestTypeEnum} CustomInterestTypeEnum
                         */
                        CustomInterestTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.CustomInterestTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.CustomInterestTypeEnum();
                        };

                        /**
                         * Creates a plain object from a CustomInterestTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.CustomInterestTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.CustomInterestTypeEnum} message CustomInterestTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomInterestTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CustomInterestTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.CustomInterestTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomInterestTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CustomInterestType enum.
                         * @name google.ads.googleads.v1.enums.CustomInterestTypeEnum.CustomInterestType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CUSTOM_AFFINITY=2 CUSTOM_AFFINITY value
                         * @property {number} CUSTOM_INTENT=3 CUSTOM_INTENT value
                         */
                        CustomInterestTypeEnum.CustomInterestType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CUSTOM_AFFINITY"] = 2;
                            values[valuesById[3] = "CUSTOM_INTENT"] = 3;
                            return values;
                        })();

                        return CustomInterestTypeEnum;
                    })();

                    enums.CustomPlaceholderFieldEnum = (function() {

                        /**
                         * Properties of a CustomPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ICustomPlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new CustomPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a CustomPlaceholderFieldEnum.
                         * @implements ICustomPlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ICustomPlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function CustomPlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CustomPlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICustomPlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum} CustomPlaceholderFieldEnum instance
                         */
                        CustomPlaceholderFieldEnum.create = function create(properties) {
                            return new CustomPlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified CustomPlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICustomPlaceholderFieldEnum} message CustomPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomPlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomPlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICustomPlaceholderFieldEnum} message CustomPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomPlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomPlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum} CustomPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomPlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomPlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum} CustomPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomPlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomPlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomPlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CustomPlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum} CustomPlaceholderFieldEnum
                         */
                        CustomPlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from a CustomPlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum} message CustomPlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomPlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CustomPlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomPlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CustomPlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum.CustomPlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ID=2 ID value
                         * @property {number} ID2=3 ID2 value
                         * @property {number} ITEM_TITLE=4 ITEM_TITLE value
                         * @property {number} ITEM_SUBTITLE=5 ITEM_SUBTITLE value
                         * @property {number} ITEM_DESCRIPTION=6 ITEM_DESCRIPTION value
                         * @property {number} ITEM_ADDRESS=7 ITEM_ADDRESS value
                         * @property {number} PRICE=8 PRICE value
                         * @property {number} FORMATTED_PRICE=9 FORMATTED_PRICE value
                         * @property {number} SALE_PRICE=10 SALE_PRICE value
                         * @property {number} FORMATTED_SALE_PRICE=11 FORMATTED_SALE_PRICE value
                         * @property {number} IMAGE_URL=12 IMAGE_URL value
                         * @property {number} ITEM_CATEGORY=13 ITEM_CATEGORY value
                         * @property {number} FINAL_URLS=14 FINAL_URLS value
                         * @property {number} FINAL_MOBILE_URLS=15 FINAL_MOBILE_URLS value
                         * @property {number} TRACKING_URL=16 TRACKING_URL value
                         * @property {number} CONTEXTUAL_KEYWORDS=17 CONTEXTUAL_KEYWORDS value
                         * @property {number} ANDROID_APP_LINK=18 ANDROID_APP_LINK value
                         * @property {number} SIMILAR_IDS=19 SIMILAR_IDS value
                         * @property {number} IOS_APP_LINK=20 IOS_APP_LINK value
                         * @property {number} IOS_APP_STORE_ID=21 IOS_APP_STORE_ID value
                         */
                        CustomPlaceholderFieldEnum.CustomPlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ID"] = 2;
                            values[valuesById[3] = "ID2"] = 3;
                            values[valuesById[4] = "ITEM_TITLE"] = 4;
                            values[valuesById[5] = "ITEM_SUBTITLE"] = 5;
                            values[valuesById[6] = "ITEM_DESCRIPTION"] = 6;
                            values[valuesById[7] = "ITEM_ADDRESS"] = 7;
                            values[valuesById[8] = "PRICE"] = 8;
                            values[valuesById[9] = "FORMATTED_PRICE"] = 9;
                            values[valuesById[10] = "SALE_PRICE"] = 10;
                            values[valuesById[11] = "FORMATTED_SALE_PRICE"] = 11;
                            values[valuesById[12] = "IMAGE_URL"] = 12;
                            values[valuesById[13] = "ITEM_CATEGORY"] = 13;
                            values[valuesById[14] = "FINAL_URLS"] = 14;
                            values[valuesById[15] = "FINAL_MOBILE_URLS"] = 15;
                            values[valuesById[16] = "TRACKING_URL"] = 16;
                            values[valuesById[17] = "CONTEXTUAL_KEYWORDS"] = 17;
                            values[valuesById[18] = "ANDROID_APP_LINK"] = 18;
                            values[valuesById[19] = "SIMILAR_IDS"] = 19;
                            values[valuesById[20] = "IOS_APP_LINK"] = 20;
                            values[valuesById[21] = "IOS_APP_STORE_ID"] = 21;
                            return values;
                        })();

                        return CustomPlaceholderFieldEnum;
                    })();

                    enums.CustomerMatchUploadKeyTypeEnum = (function() {

                        /**
                         * Properties of a CustomerMatchUploadKeyTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ICustomerMatchUploadKeyTypeEnum
                         */

                        /**
                         * Constructs a new CustomerMatchUploadKeyTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a CustomerMatchUploadKeyTypeEnum.
                         * @implements ICustomerMatchUploadKeyTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ICustomerMatchUploadKeyTypeEnum=} [properties] Properties to set
                         */
                        function CustomerMatchUploadKeyTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CustomerMatchUploadKeyTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICustomerMatchUploadKeyTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum} CustomerMatchUploadKeyTypeEnum instance
                         */
                        CustomerMatchUploadKeyTypeEnum.create = function create(properties) {
                            return new CustomerMatchUploadKeyTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified CustomerMatchUploadKeyTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICustomerMatchUploadKeyTypeEnum} message CustomerMatchUploadKeyTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerMatchUploadKeyTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerMatchUploadKeyTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICustomerMatchUploadKeyTypeEnum} message CustomerMatchUploadKeyTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerMatchUploadKeyTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerMatchUploadKeyTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum} CustomerMatchUploadKeyTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerMatchUploadKeyTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerMatchUploadKeyTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum} CustomerMatchUploadKeyTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerMatchUploadKeyTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerMatchUploadKeyTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerMatchUploadKeyTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CustomerMatchUploadKeyTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum} CustomerMatchUploadKeyTypeEnum
                         */
                        CustomerMatchUploadKeyTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum();
                        };

                        /**
                         * Creates a plain object from a CustomerMatchUploadKeyTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum} message CustomerMatchUploadKeyTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerMatchUploadKeyTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CustomerMatchUploadKeyTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerMatchUploadKeyTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CustomerMatchUploadKeyType enum.
                         * @name google.ads.googleads.v1.enums.CustomerMatchUploadKeyTypeEnum.CustomerMatchUploadKeyType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CONTACT_INFO=2 CONTACT_INFO value
                         * @property {number} CRM_ID=3 CRM_ID value
                         * @property {number} MOBILE_ADVERTISING_ID=4 MOBILE_ADVERTISING_ID value
                         */
                        CustomerMatchUploadKeyTypeEnum.CustomerMatchUploadKeyType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CONTACT_INFO"] = 2;
                            values[valuesById[3] = "CRM_ID"] = 3;
                            values[valuesById[4] = "MOBILE_ADVERTISING_ID"] = 4;
                            return values;
                        })();

                        return CustomerMatchUploadKeyTypeEnum;
                    })();

                    enums.CustomerPayPerConversionEligibilityFailureReasonEnum = (function() {

                        /**
                         * Properties of a CustomerPayPerConversionEligibilityFailureReasonEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ICustomerPayPerConversionEligibilityFailureReasonEnum
                         */

                        /**
                         * Constructs a new CustomerPayPerConversionEligibilityFailureReasonEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a CustomerPayPerConversionEligibilityFailureReasonEnum.
                         * @implements ICustomerPayPerConversionEligibilityFailureReasonEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ICustomerPayPerConversionEligibilityFailureReasonEnum=} [properties] Properties to set
                         */
                        function CustomerPayPerConversionEligibilityFailureReasonEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new CustomerPayPerConversionEligibilityFailureReasonEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICustomerPayPerConversionEligibilityFailureReasonEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum} CustomerPayPerConversionEligibilityFailureReasonEnum instance
                         */
                        CustomerPayPerConversionEligibilityFailureReasonEnum.create = function create(properties) {
                            return new CustomerPayPerConversionEligibilityFailureReasonEnum(properties);
                        };

                        /**
                         * Encodes the specified CustomerPayPerConversionEligibilityFailureReasonEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICustomerPayPerConversionEligibilityFailureReasonEnum} message CustomerPayPerConversionEligibilityFailureReasonEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerPayPerConversionEligibilityFailureReasonEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerPayPerConversionEligibilityFailureReasonEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ICustomerPayPerConversionEligibilityFailureReasonEnum} message CustomerPayPerConversionEligibilityFailureReasonEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerPayPerConversionEligibilityFailureReasonEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerPayPerConversionEligibilityFailureReasonEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum} CustomerPayPerConversionEligibilityFailureReasonEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerPayPerConversionEligibilityFailureReasonEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerPayPerConversionEligibilityFailureReasonEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum} CustomerPayPerConversionEligibilityFailureReasonEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerPayPerConversionEligibilityFailureReasonEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerPayPerConversionEligibilityFailureReasonEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerPayPerConversionEligibilityFailureReasonEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a CustomerPayPerConversionEligibilityFailureReasonEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum} CustomerPayPerConversionEligibilityFailureReasonEnum
                         */
                        CustomerPayPerConversionEligibilityFailureReasonEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum();
                        };

                        /**
                         * Creates a plain object from a CustomerPayPerConversionEligibilityFailureReasonEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum} message CustomerPayPerConversionEligibilityFailureReasonEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerPayPerConversionEligibilityFailureReasonEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this CustomerPayPerConversionEligibilityFailureReasonEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerPayPerConversionEligibilityFailureReasonEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * CustomerPayPerConversionEligibilityFailureReason enum.
                         * @name google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum.CustomerPayPerConversionEligibilityFailureReason
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} NOT_ENOUGH_CONVERSIONS=2 NOT_ENOUGH_CONVERSIONS value
                         * @property {number} CONVERSION_LAG_TOO_HIGH=3 CONVERSION_LAG_TOO_HIGH value
                         * @property {number} HAS_CAMPAIGN_WITH_SHARED_BUDGET=4 HAS_CAMPAIGN_WITH_SHARED_BUDGET value
                         * @property {number} HAS_UPLOAD_CLICKS_CONVERSION=5 HAS_UPLOAD_CLICKS_CONVERSION value
                         * @property {number} AVERAGE_DAILY_SPEND_TOO_HIGH=6 AVERAGE_DAILY_SPEND_TOO_HIGH value
                         * @property {number} ANALYSIS_NOT_COMPLETE=7 ANALYSIS_NOT_COMPLETE value
                         * @property {number} OTHER=8 OTHER value
                         */
                        CustomerPayPerConversionEligibilityFailureReasonEnum.CustomerPayPerConversionEligibilityFailureReason = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "NOT_ENOUGH_CONVERSIONS"] = 2;
                            values[valuesById[3] = "CONVERSION_LAG_TOO_HIGH"] = 3;
                            values[valuesById[4] = "HAS_CAMPAIGN_WITH_SHARED_BUDGET"] = 4;
                            values[valuesById[5] = "HAS_UPLOAD_CLICKS_CONVERSION"] = 5;
                            values[valuesById[6] = "AVERAGE_DAILY_SPEND_TOO_HIGH"] = 6;
                            values[valuesById[7] = "ANALYSIS_NOT_COMPLETE"] = 7;
                            values[valuesById[8] = "OTHER"] = 8;
                            return values;
                        })();

                        return CustomerPayPerConversionEligibilityFailureReasonEnum;
                    })();

                    enums.DataDrivenModelStatusEnum = (function() {

                        /**
                         * Properties of a DataDrivenModelStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IDataDrivenModelStatusEnum
                         */

                        /**
                         * Constructs a new DataDrivenModelStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a DataDrivenModelStatusEnum.
                         * @implements IDataDrivenModelStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IDataDrivenModelStatusEnum=} [properties] Properties to set
                         */
                        function DataDrivenModelStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new DataDrivenModelStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.DataDrivenModelStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IDataDrivenModelStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.DataDrivenModelStatusEnum} DataDrivenModelStatusEnum instance
                         */
                        DataDrivenModelStatusEnum.create = function create(properties) {
                            return new DataDrivenModelStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified DataDrivenModelStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.DataDrivenModelStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.DataDrivenModelStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IDataDrivenModelStatusEnum} message DataDrivenModelStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DataDrivenModelStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified DataDrivenModelStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.DataDrivenModelStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.DataDrivenModelStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IDataDrivenModelStatusEnum} message DataDrivenModelStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DataDrivenModelStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DataDrivenModelStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.DataDrivenModelStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.DataDrivenModelStatusEnum} DataDrivenModelStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DataDrivenModelStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.DataDrivenModelStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DataDrivenModelStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.DataDrivenModelStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.DataDrivenModelStatusEnum} DataDrivenModelStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DataDrivenModelStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DataDrivenModelStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.DataDrivenModelStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DataDrivenModelStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a DataDrivenModelStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.DataDrivenModelStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.DataDrivenModelStatusEnum} DataDrivenModelStatusEnum
                         */
                        DataDrivenModelStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.DataDrivenModelStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.DataDrivenModelStatusEnum();
                        };

                        /**
                         * Creates a plain object from a DataDrivenModelStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.DataDrivenModelStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.DataDrivenModelStatusEnum} message DataDrivenModelStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DataDrivenModelStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this DataDrivenModelStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.DataDrivenModelStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DataDrivenModelStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * DataDrivenModelStatus enum.
                         * @name google.ads.googleads.v1.enums.DataDrivenModelStatusEnum.DataDrivenModelStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} AVAILABLE=2 AVAILABLE value
                         * @property {number} STALE=3 STALE value
                         * @property {number} EXPIRED=4 EXPIRED value
                         * @property {number} NEVER_GENERATED=5 NEVER_GENERATED value
                         */
                        DataDrivenModelStatusEnum.DataDrivenModelStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "AVAILABLE"] = 2;
                            values[valuesById[3] = "STALE"] = 3;
                            values[valuesById[4] = "EXPIRED"] = 4;
                            values[valuesById[5] = "NEVER_GENERATED"] = 5;
                            return values;
                        })();

                        return DataDrivenModelStatusEnum;
                    })();

                    enums.DayOfWeekEnum = (function() {

                        /**
                         * Properties of a DayOfWeekEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IDayOfWeekEnum
                         */

                        /**
                         * Constructs a new DayOfWeekEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a DayOfWeekEnum.
                         * @implements IDayOfWeekEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IDayOfWeekEnum=} [properties] Properties to set
                         */
                        function DayOfWeekEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new DayOfWeekEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.DayOfWeekEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IDayOfWeekEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.DayOfWeekEnum} DayOfWeekEnum instance
                         */
                        DayOfWeekEnum.create = function create(properties) {
                            return new DayOfWeekEnum(properties);
                        };

                        /**
                         * Encodes the specified DayOfWeekEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.DayOfWeekEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.DayOfWeekEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IDayOfWeekEnum} message DayOfWeekEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DayOfWeekEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified DayOfWeekEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.DayOfWeekEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.DayOfWeekEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IDayOfWeekEnum} message DayOfWeekEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DayOfWeekEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DayOfWeekEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.DayOfWeekEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.DayOfWeekEnum} DayOfWeekEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DayOfWeekEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.DayOfWeekEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DayOfWeekEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.DayOfWeekEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.DayOfWeekEnum} DayOfWeekEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DayOfWeekEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DayOfWeekEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.DayOfWeekEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DayOfWeekEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a DayOfWeekEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.DayOfWeekEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.DayOfWeekEnum} DayOfWeekEnum
                         */
                        DayOfWeekEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.DayOfWeekEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.DayOfWeekEnum();
                        };

                        /**
                         * Creates a plain object from a DayOfWeekEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.DayOfWeekEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.DayOfWeekEnum} message DayOfWeekEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DayOfWeekEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this DayOfWeekEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.DayOfWeekEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DayOfWeekEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * DayOfWeek enum.
                         * @name google.ads.googleads.v1.enums.DayOfWeekEnum.DayOfWeek
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} MONDAY=2 MONDAY value
                         * @property {number} TUESDAY=3 TUESDAY value
                         * @property {number} WEDNESDAY=4 WEDNESDAY value
                         * @property {number} THURSDAY=5 THURSDAY value
                         * @property {number} FRIDAY=6 FRIDAY value
                         * @property {number} SATURDAY=7 SATURDAY value
                         * @property {number} SUNDAY=8 SUNDAY value
                         */
                        DayOfWeekEnum.DayOfWeek = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "MONDAY"] = 2;
                            values[valuesById[3] = "TUESDAY"] = 3;
                            values[valuesById[4] = "WEDNESDAY"] = 4;
                            values[valuesById[5] = "THURSDAY"] = 5;
                            values[valuesById[6] = "FRIDAY"] = 6;
                            values[valuesById[7] = "SATURDAY"] = 7;
                            values[valuesById[8] = "SUNDAY"] = 8;
                            return values;
                        })();

                        return DayOfWeekEnum;
                    })();

                    enums.DeviceEnum = (function() {

                        /**
                         * Properties of a DeviceEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IDeviceEnum
                         */

                        /**
                         * Constructs a new DeviceEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a DeviceEnum.
                         * @implements IDeviceEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IDeviceEnum=} [properties] Properties to set
                         */
                        function DeviceEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new DeviceEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.DeviceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IDeviceEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.DeviceEnum} DeviceEnum instance
                         */
                        DeviceEnum.create = function create(properties) {
                            return new DeviceEnum(properties);
                        };

                        /**
                         * Encodes the specified DeviceEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.DeviceEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.DeviceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IDeviceEnum} message DeviceEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeviceEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified DeviceEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.DeviceEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.DeviceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IDeviceEnum} message DeviceEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeviceEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DeviceEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.DeviceEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.DeviceEnum} DeviceEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeviceEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.DeviceEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DeviceEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.DeviceEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.DeviceEnum} DeviceEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeviceEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DeviceEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.DeviceEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeviceEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a DeviceEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.DeviceEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.DeviceEnum} DeviceEnum
                         */
                        DeviceEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.DeviceEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.DeviceEnum();
                        };

                        /**
                         * Creates a plain object from a DeviceEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.DeviceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.DeviceEnum} message DeviceEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeviceEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this DeviceEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.DeviceEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeviceEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * Device enum.
                         * @name google.ads.googleads.v1.enums.DeviceEnum.Device
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} MOBILE=2 MOBILE value
                         * @property {number} TABLET=3 TABLET value
                         * @property {number} DESKTOP=4 DESKTOP value
                         * @property {number} OTHER=5 OTHER value
                         */
                        DeviceEnum.Device = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "MOBILE"] = 2;
                            values[valuesById[3] = "TABLET"] = 3;
                            values[valuesById[4] = "DESKTOP"] = 4;
                            values[valuesById[5] = "OTHER"] = 5;
                            return values;
                        })();

                        return DeviceEnum;
                    })();

                    enums.DisplayAdFormatSettingEnum = (function() {

                        /**
                         * Properties of a DisplayAdFormatSettingEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IDisplayAdFormatSettingEnum
                         */

                        /**
                         * Constructs a new DisplayAdFormatSettingEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a DisplayAdFormatSettingEnum.
                         * @implements IDisplayAdFormatSettingEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IDisplayAdFormatSettingEnum=} [properties] Properties to set
                         */
                        function DisplayAdFormatSettingEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new DisplayAdFormatSettingEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IDisplayAdFormatSettingEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum} DisplayAdFormatSettingEnum instance
                         */
                        DisplayAdFormatSettingEnum.create = function create(properties) {
                            return new DisplayAdFormatSettingEnum(properties);
                        };

                        /**
                         * Encodes the specified DisplayAdFormatSettingEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IDisplayAdFormatSettingEnum} message DisplayAdFormatSettingEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisplayAdFormatSettingEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified DisplayAdFormatSettingEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IDisplayAdFormatSettingEnum} message DisplayAdFormatSettingEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisplayAdFormatSettingEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DisplayAdFormatSettingEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum} DisplayAdFormatSettingEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisplayAdFormatSettingEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DisplayAdFormatSettingEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum} DisplayAdFormatSettingEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisplayAdFormatSettingEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DisplayAdFormatSettingEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DisplayAdFormatSettingEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a DisplayAdFormatSettingEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum} DisplayAdFormatSettingEnum
                         */
                        DisplayAdFormatSettingEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum();
                        };

                        /**
                         * Creates a plain object from a DisplayAdFormatSettingEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum} message DisplayAdFormatSettingEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DisplayAdFormatSettingEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this DisplayAdFormatSettingEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DisplayAdFormatSettingEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * DisplayAdFormatSetting enum.
                         * @name google.ads.googleads.v1.enums.DisplayAdFormatSettingEnum.DisplayAdFormatSetting
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ALL_FORMATS=2 ALL_FORMATS value
                         * @property {number} NON_NATIVE=3 NON_NATIVE value
                         * @property {number} NATIVE=4 NATIVE value
                         */
                        DisplayAdFormatSettingEnum.DisplayAdFormatSetting = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ALL_FORMATS"] = 2;
                            values[valuesById[3] = "NON_NATIVE"] = 3;
                            values[valuesById[4] = "NATIVE"] = 4;
                            return values;
                        })();

                        return DisplayAdFormatSettingEnum;
                    })();

                    enums.DisplayUploadProductTypeEnum = (function() {

                        /**
                         * Properties of a DisplayUploadProductTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IDisplayUploadProductTypeEnum
                         */

                        /**
                         * Constructs a new DisplayUploadProductTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a DisplayUploadProductTypeEnum.
                         * @implements IDisplayUploadProductTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IDisplayUploadProductTypeEnum=} [properties] Properties to set
                         */
                        function DisplayUploadProductTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new DisplayUploadProductTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IDisplayUploadProductTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum} DisplayUploadProductTypeEnum instance
                         */
                        DisplayUploadProductTypeEnum.create = function create(properties) {
                            return new DisplayUploadProductTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified DisplayUploadProductTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IDisplayUploadProductTypeEnum} message DisplayUploadProductTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisplayUploadProductTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified DisplayUploadProductTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IDisplayUploadProductTypeEnum} message DisplayUploadProductTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisplayUploadProductTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DisplayUploadProductTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum} DisplayUploadProductTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisplayUploadProductTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DisplayUploadProductTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum} DisplayUploadProductTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisplayUploadProductTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DisplayUploadProductTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DisplayUploadProductTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a DisplayUploadProductTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum} DisplayUploadProductTypeEnum
                         */
                        DisplayUploadProductTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum();
                        };

                        /**
                         * Creates a plain object from a DisplayUploadProductTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum} message DisplayUploadProductTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DisplayUploadProductTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this DisplayUploadProductTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DisplayUploadProductTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * DisplayUploadProductType enum.
                         * @name google.ads.googleads.v1.enums.DisplayUploadProductTypeEnum.DisplayUploadProductType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} HTML5_UPLOAD_AD=2 HTML5_UPLOAD_AD value
                         * @property {number} DYNAMIC_HTML5_EDUCATION_AD=3 DYNAMIC_HTML5_EDUCATION_AD value
                         * @property {number} DYNAMIC_HTML5_FLIGHT_AD=4 DYNAMIC_HTML5_FLIGHT_AD value
                         * @property {number} DYNAMIC_HTML5_HOTEL_RENTAL_AD=5 DYNAMIC_HTML5_HOTEL_RENTAL_AD value
                         * @property {number} DYNAMIC_HTML5_JOB_AD=6 DYNAMIC_HTML5_JOB_AD value
                         * @property {number} DYNAMIC_HTML5_LOCAL_AD=7 DYNAMIC_HTML5_LOCAL_AD value
                         * @property {number} DYNAMIC_HTML5_REAL_ESTATE_AD=8 DYNAMIC_HTML5_REAL_ESTATE_AD value
                         * @property {number} DYNAMIC_HTML5_CUSTOM_AD=9 DYNAMIC_HTML5_CUSTOM_AD value
                         * @property {number} DYNAMIC_HTML5_TRAVEL_AD=10 DYNAMIC_HTML5_TRAVEL_AD value
                         * @property {number} DYNAMIC_HTML5_HOTEL_AD=11 DYNAMIC_HTML5_HOTEL_AD value
                         */
                        DisplayUploadProductTypeEnum.DisplayUploadProductType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "HTML5_UPLOAD_AD"] = 2;
                            values[valuesById[3] = "DYNAMIC_HTML5_EDUCATION_AD"] = 3;
                            values[valuesById[4] = "DYNAMIC_HTML5_FLIGHT_AD"] = 4;
                            values[valuesById[5] = "DYNAMIC_HTML5_HOTEL_RENTAL_AD"] = 5;
                            values[valuesById[6] = "DYNAMIC_HTML5_JOB_AD"] = 6;
                            values[valuesById[7] = "DYNAMIC_HTML5_LOCAL_AD"] = 7;
                            values[valuesById[8] = "DYNAMIC_HTML5_REAL_ESTATE_AD"] = 8;
                            values[valuesById[9] = "DYNAMIC_HTML5_CUSTOM_AD"] = 9;
                            values[valuesById[10] = "DYNAMIC_HTML5_TRAVEL_AD"] = 10;
                            values[valuesById[11] = "DYNAMIC_HTML5_HOTEL_AD"] = 11;
                            return values;
                        })();

                        return DisplayUploadProductTypeEnum;
                    })();

                    enums.DsaPageFeedCriterionFieldEnum = (function() {

                        /**
                         * Properties of a DsaPageFeedCriterionFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IDsaPageFeedCriterionFieldEnum
                         */

                        /**
                         * Constructs a new DsaPageFeedCriterionFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a DsaPageFeedCriterionFieldEnum.
                         * @implements IDsaPageFeedCriterionFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IDsaPageFeedCriterionFieldEnum=} [properties] Properties to set
                         */
                        function DsaPageFeedCriterionFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new DsaPageFeedCriterionFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IDsaPageFeedCriterionFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum} DsaPageFeedCriterionFieldEnum instance
                         */
                        DsaPageFeedCriterionFieldEnum.create = function create(properties) {
                            return new DsaPageFeedCriterionFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified DsaPageFeedCriterionFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IDsaPageFeedCriterionFieldEnum} message DsaPageFeedCriterionFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DsaPageFeedCriterionFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified DsaPageFeedCriterionFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IDsaPageFeedCriterionFieldEnum} message DsaPageFeedCriterionFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DsaPageFeedCriterionFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DsaPageFeedCriterionFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum} DsaPageFeedCriterionFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DsaPageFeedCriterionFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DsaPageFeedCriterionFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum} DsaPageFeedCriterionFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DsaPageFeedCriterionFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DsaPageFeedCriterionFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DsaPageFeedCriterionFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a DsaPageFeedCriterionFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum} DsaPageFeedCriterionFieldEnum
                         */
                        DsaPageFeedCriterionFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum();
                        };

                        /**
                         * Creates a plain object from a DsaPageFeedCriterionFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum} message DsaPageFeedCriterionFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DsaPageFeedCriterionFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this DsaPageFeedCriterionFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DsaPageFeedCriterionFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * DsaPageFeedCriterionField enum.
                         * @name google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum.DsaPageFeedCriterionField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} PAGE_URL=2 PAGE_URL value
                         * @property {number} LABEL=3 LABEL value
                         */
                        DsaPageFeedCriterionFieldEnum.DsaPageFeedCriterionField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "PAGE_URL"] = 2;
                            values[valuesById[3] = "LABEL"] = 3;
                            return values;
                        })();

                        return DsaPageFeedCriterionFieldEnum;
                    })();

                    enums.EducationPlaceholderFieldEnum = (function() {

                        /**
                         * Properties of an EducationPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IEducationPlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new EducationPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an EducationPlaceholderFieldEnum.
                         * @implements IEducationPlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IEducationPlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function EducationPlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new EducationPlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IEducationPlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum} EducationPlaceholderFieldEnum instance
                         */
                        EducationPlaceholderFieldEnum.create = function create(properties) {
                            return new EducationPlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified EducationPlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IEducationPlaceholderFieldEnum} message EducationPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        EducationPlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified EducationPlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IEducationPlaceholderFieldEnum} message EducationPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        EducationPlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an EducationPlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum} EducationPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        EducationPlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an EducationPlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum} EducationPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        EducationPlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an EducationPlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        EducationPlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an EducationPlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum} EducationPlaceholderFieldEnum
                         */
                        EducationPlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from an EducationPlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum} message EducationPlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        EducationPlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this EducationPlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        EducationPlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * EducationPlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum.EducationPlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} PROGRAM_ID=2 PROGRAM_ID value
                         * @property {number} LOCATION_ID=3 LOCATION_ID value
                         * @property {number} PROGRAM_NAME=4 PROGRAM_NAME value
                         * @property {number} AREA_OF_STUDY=5 AREA_OF_STUDY value
                         * @property {number} PROGRAM_DESCRIPTION=6 PROGRAM_DESCRIPTION value
                         * @property {number} SCHOOL_NAME=7 SCHOOL_NAME value
                         * @property {number} ADDRESS=8 ADDRESS value
                         * @property {number} THUMBNAIL_IMAGE_URL=9 THUMBNAIL_IMAGE_URL value
                         * @property {number} ALTERNATIVE_THUMBNAIL_IMAGE_URL=10 ALTERNATIVE_THUMBNAIL_IMAGE_URL value
                         * @property {number} FINAL_URLS=11 FINAL_URLS value
                         * @property {number} FINAL_MOBILE_URLS=12 FINAL_MOBILE_URLS value
                         * @property {number} TRACKING_URL=13 TRACKING_URL value
                         * @property {number} CONTEXTUAL_KEYWORDS=14 CONTEXTUAL_KEYWORDS value
                         * @property {number} ANDROID_APP_LINK=15 ANDROID_APP_LINK value
                         * @property {number} SIMILAR_PROGRAM_IDS=16 SIMILAR_PROGRAM_IDS value
                         * @property {number} IOS_APP_LINK=17 IOS_APP_LINK value
                         * @property {number} IOS_APP_STORE_ID=18 IOS_APP_STORE_ID value
                         */
                        EducationPlaceholderFieldEnum.EducationPlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "PROGRAM_ID"] = 2;
                            values[valuesById[3] = "LOCATION_ID"] = 3;
                            values[valuesById[4] = "PROGRAM_NAME"] = 4;
                            values[valuesById[5] = "AREA_OF_STUDY"] = 5;
                            values[valuesById[6] = "PROGRAM_DESCRIPTION"] = 6;
                            values[valuesById[7] = "SCHOOL_NAME"] = 7;
                            values[valuesById[8] = "ADDRESS"] = 8;
                            values[valuesById[9] = "THUMBNAIL_IMAGE_URL"] = 9;
                            values[valuesById[10] = "ALTERNATIVE_THUMBNAIL_IMAGE_URL"] = 10;
                            values[valuesById[11] = "FINAL_URLS"] = 11;
                            values[valuesById[12] = "FINAL_MOBILE_URLS"] = 12;
                            values[valuesById[13] = "TRACKING_URL"] = 13;
                            values[valuesById[14] = "CONTEXTUAL_KEYWORDS"] = 14;
                            values[valuesById[15] = "ANDROID_APP_LINK"] = 15;
                            values[valuesById[16] = "SIMILAR_PROGRAM_IDS"] = 16;
                            values[valuesById[17] = "IOS_APP_LINK"] = 17;
                            values[valuesById[18] = "IOS_APP_STORE_ID"] = 18;
                            return values;
                        })();

                        return EducationPlaceholderFieldEnum;
                    })();

                    enums.ExtensionSettingDeviceEnum = (function() {

                        /**
                         * Properties of an ExtensionSettingDeviceEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IExtensionSettingDeviceEnum
                         */

                        /**
                         * Constructs a new ExtensionSettingDeviceEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an ExtensionSettingDeviceEnum.
                         * @implements IExtensionSettingDeviceEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IExtensionSettingDeviceEnum=} [properties] Properties to set
                         */
                        function ExtensionSettingDeviceEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ExtensionSettingDeviceEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IExtensionSettingDeviceEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum} ExtensionSettingDeviceEnum instance
                         */
                        ExtensionSettingDeviceEnum.create = function create(properties) {
                            return new ExtensionSettingDeviceEnum(properties);
                        };

                        /**
                         * Encodes the specified ExtensionSettingDeviceEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IExtensionSettingDeviceEnum} message ExtensionSettingDeviceEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExtensionSettingDeviceEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ExtensionSettingDeviceEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IExtensionSettingDeviceEnum} message ExtensionSettingDeviceEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExtensionSettingDeviceEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ExtensionSettingDeviceEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum} ExtensionSettingDeviceEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExtensionSettingDeviceEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ExtensionSettingDeviceEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum} ExtensionSettingDeviceEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExtensionSettingDeviceEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ExtensionSettingDeviceEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExtensionSettingDeviceEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an ExtensionSettingDeviceEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum} ExtensionSettingDeviceEnum
                         */
                        ExtensionSettingDeviceEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum();
                        };

                        /**
                         * Creates a plain object from an ExtensionSettingDeviceEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum} message ExtensionSettingDeviceEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExtensionSettingDeviceEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ExtensionSettingDeviceEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExtensionSettingDeviceEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ExtensionSettingDevice enum.
                         * @name google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum.ExtensionSettingDevice
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} MOBILE=2 MOBILE value
                         * @property {number} DESKTOP=3 DESKTOP value
                         */
                        ExtensionSettingDeviceEnum.ExtensionSettingDevice = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "MOBILE"] = 2;
                            values[valuesById[3] = "DESKTOP"] = 3;
                            return values;
                        })();

                        return ExtensionSettingDeviceEnum;
                    })();

                    enums.ExtensionTypeEnum = (function() {

                        /**
                         * Properties of an ExtensionTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IExtensionTypeEnum
                         */

                        /**
                         * Constructs a new ExtensionTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an ExtensionTypeEnum.
                         * @implements IExtensionTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IExtensionTypeEnum=} [properties] Properties to set
                         */
                        function ExtensionTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ExtensionTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ExtensionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IExtensionTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ExtensionTypeEnum} ExtensionTypeEnum instance
                         */
                        ExtensionTypeEnum.create = function create(properties) {
                            return new ExtensionTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified ExtensionTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ExtensionTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ExtensionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IExtensionTypeEnum} message ExtensionTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExtensionTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ExtensionTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ExtensionTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ExtensionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IExtensionTypeEnum} message ExtensionTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExtensionTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ExtensionTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ExtensionTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ExtensionTypeEnum} ExtensionTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExtensionTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ExtensionTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ExtensionTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ExtensionTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ExtensionTypeEnum} ExtensionTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExtensionTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ExtensionTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ExtensionTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExtensionTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an ExtensionTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ExtensionTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ExtensionTypeEnum} ExtensionTypeEnum
                         */
                        ExtensionTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ExtensionTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ExtensionTypeEnum();
                        };

                        /**
                         * Creates a plain object from an ExtensionTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ExtensionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ExtensionTypeEnum} message ExtensionTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExtensionTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ExtensionTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ExtensionTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExtensionTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ExtensionType enum.
                         * @name google.ads.googleads.v1.enums.ExtensionTypeEnum.ExtensionType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} NONE=2 NONE value
                         * @property {number} APP=3 APP value
                         * @property {number} CALL=4 CALL value
                         * @property {number} CALLOUT=5 CALLOUT value
                         * @property {number} MESSAGE=6 MESSAGE value
                         * @property {number} PRICE=7 PRICE value
                         * @property {number} PROMOTION=8 PROMOTION value
                         * @property {number} REVIEW=9 REVIEW value
                         * @property {number} SITELINK=10 SITELINK value
                         * @property {number} STRUCTURED_SNIPPET=11 STRUCTURED_SNIPPET value
                         * @property {number} LOCATION=12 LOCATION value
                         * @property {number} AFFILIATE_LOCATION=13 AFFILIATE_LOCATION value
                         */
                        ExtensionTypeEnum.ExtensionType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "NONE"] = 2;
                            values[valuesById[3] = "APP"] = 3;
                            values[valuesById[4] = "CALL"] = 4;
                            values[valuesById[5] = "CALLOUT"] = 5;
                            values[valuesById[6] = "MESSAGE"] = 6;
                            values[valuesById[7] = "PRICE"] = 7;
                            values[valuesById[8] = "PROMOTION"] = 8;
                            values[valuesById[9] = "REVIEW"] = 9;
                            values[valuesById[10] = "SITELINK"] = 10;
                            values[valuesById[11] = "STRUCTURED_SNIPPET"] = 11;
                            values[valuesById[12] = "LOCATION"] = 12;
                            values[valuesById[13] = "AFFILIATE_LOCATION"] = 13;
                            return values;
                        })();

                        return ExtensionTypeEnum;
                    })();

                    enums.ExternalConversionSourceEnum = (function() {

                        /**
                         * Properties of an ExternalConversionSourceEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IExternalConversionSourceEnum
                         */

                        /**
                         * Constructs a new ExternalConversionSourceEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an ExternalConversionSourceEnum.
                         * @implements IExternalConversionSourceEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IExternalConversionSourceEnum=} [properties] Properties to set
                         */
                        function ExternalConversionSourceEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ExternalConversionSourceEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ExternalConversionSourceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IExternalConversionSourceEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ExternalConversionSourceEnum} ExternalConversionSourceEnum instance
                         */
                        ExternalConversionSourceEnum.create = function create(properties) {
                            return new ExternalConversionSourceEnum(properties);
                        };

                        /**
                         * Encodes the specified ExternalConversionSourceEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ExternalConversionSourceEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ExternalConversionSourceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IExternalConversionSourceEnum} message ExternalConversionSourceEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExternalConversionSourceEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ExternalConversionSourceEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ExternalConversionSourceEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ExternalConversionSourceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IExternalConversionSourceEnum} message ExternalConversionSourceEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExternalConversionSourceEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ExternalConversionSourceEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ExternalConversionSourceEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ExternalConversionSourceEnum} ExternalConversionSourceEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExternalConversionSourceEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ExternalConversionSourceEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ExternalConversionSourceEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ExternalConversionSourceEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ExternalConversionSourceEnum} ExternalConversionSourceEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExternalConversionSourceEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ExternalConversionSourceEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ExternalConversionSourceEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExternalConversionSourceEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an ExternalConversionSourceEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ExternalConversionSourceEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ExternalConversionSourceEnum} ExternalConversionSourceEnum
                         */
                        ExternalConversionSourceEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ExternalConversionSourceEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ExternalConversionSourceEnum();
                        };

                        /**
                         * Creates a plain object from an ExternalConversionSourceEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ExternalConversionSourceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ExternalConversionSourceEnum} message ExternalConversionSourceEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExternalConversionSourceEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ExternalConversionSourceEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ExternalConversionSourceEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExternalConversionSourceEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ExternalConversionSource enum.
                         * @name google.ads.googleads.v1.enums.ExternalConversionSourceEnum.ExternalConversionSource
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} WEBPAGE=2 WEBPAGE value
                         * @property {number} ANALYTICS=3 ANALYTICS value
                         * @property {number} UPLOAD=4 UPLOAD value
                         * @property {number} AD_CALL_METRICS=5 AD_CALL_METRICS value
                         * @property {number} WEBSITE_CALL_METRICS=6 WEBSITE_CALL_METRICS value
                         * @property {number} STORE_VISITS=7 STORE_VISITS value
                         * @property {number} ANDROID_IN_APP=8 ANDROID_IN_APP value
                         * @property {number} IOS_IN_APP=9 IOS_IN_APP value
                         * @property {number} IOS_FIRST_OPEN=10 IOS_FIRST_OPEN value
                         * @property {number} APP_UNSPECIFIED=11 APP_UNSPECIFIED value
                         * @property {number} ANDROID_FIRST_OPEN=12 ANDROID_FIRST_OPEN value
                         * @property {number} UPLOAD_CALLS=13 UPLOAD_CALLS value
                         * @property {number} FIREBASE=14 FIREBASE value
                         * @property {number} CLICK_TO_CALL=15 CLICK_TO_CALL value
                         * @property {number} SALESFORCE=16 SALESFORCE value
                         * @property {number} STORE_SALES_CRM=17 STORE_SALES_CRM value
                         * @property {number} STORE_SALES_PAYMENT_NETWORK=18 STORE_SALES_PAYMENT_NETWORK value
                         * @property {number} GOOGLE_PLAY=19 GOOGLE_PLAY value
                         * @property {number} THIRD_PARTY_APP_ANALYTICS=20 THIRD_PARTY_APP_ANALYTICS value
                         * @property {number} GOOGLE_ATTRIBUTION=21 GOOGLE_ATTRIBUTION value
                         * @property {number} STORE_SALES_DIRECT=22 STORE_SALES_DIRECT value
                         */
                        ExternalConversionSourceEnum.ExternalConversionSource = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "WEBPAGE"] = 2;
                            values[valuesById[3] = "ANALYTICS"] = 3;
                            values[valuesById[4] = "UPLOAD"] = 4;
                            values[valuesById[5] = "AD_CALL_METRICS"] = 5;
                            values[valuesById[6] = "WEBSITE_CALL_METRICS"] = 6;
                            values[valuesById[7] = "STORE_VISITS"] = 7;
                            values[valuesById[8] = "ANDROID_IN_APP"] = 8;
                            values[valuesById[9] = "IOS_IN_APP"] = 9;
                            values[valuesById[10] = "IOS_FIRST_OPEN"] = 10;
                            values[valuesById[11] = "APP_UNSPECIFIED"] = 11;
                            values[valuesById[12] = "ANDROID_FIRST_OPEN"] = 12;
                            values[valuesById[13] = "UPLOAD_CALLS"] = 13;
                            values[valuesById[14] = "FIREBASE"] = 14;
                            values[valuesById[15] = "CLICK_TO_CALL"] = 15;
                            values[valuesById[16] = "SALESFORCE"] = 16;
                            values[valuesById[17] = "STORE_SALES_CRM"] = 17;
                            values[valuesById[18] = "STORE_SALES_PAYMENT_NETWORK"] = 18;
                            values[valuesById[19] = "GOOGLE_PLAY"] = 19;
                            values[valuesById[20] = "THIRD_PARTY_APP_ANALYTICS"] = 20;
                            values[valuesById[21] = "GOOGLE_ATTRIBUTION"] = 21;
                            values[valuesById[22] = "STORE_SALES_DIRECT"] = 22;
                            return values;
                        })();

                        return ExternalConversionSourceEnum;
                    })();

                    enums.FeedAttributeTypeEnum = (function() {

                        /**
                         * Properties of a FeedAttributeTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IFeedAttributeTypeEnum
                         */

                        /**
                         * Constructs a new FeedAttributeTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a FeedAttributeTypeEnum.
                         * @implements IFeedAttributeTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IFeedAttributeTypeEnum=} [properties] Properties to set
                         */
                        function FeedAttributeTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FeedAttributeTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.FeedAttributeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedAttributeTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.FeedAttributeTypeEnum} FeedAttributeTypeEnum instance
                         */
                        FeedAttributeTypeEnum.create = function create(properties) {
                            return new FeedAttributeTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified FeedAttributeTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.FeedAttributeTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.FeedAttributeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedAttributeTypeEnum} message FeedAttributeTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedAttributeTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedAttributeTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.FeedAttributeTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedAttributeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedAttributeTypeEnum} message FeedAttributeTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedAttributeTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedAttributeTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.FeedAttributeTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.FeedAttributeTypeEnum} FeedAttributeTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedAttributeTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.FeedAttributeTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedAttributeTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedAttributeTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.FeedAttributeTypeEnum} FeedAttributeTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedAttributeTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedAttributeTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.FeedAttributeTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedAttributeTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FeedAttributeTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.FeedAttributeTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.FeedAttributeTypeEnum} FeedAttributeTypeEnum
                         */
                        FeedAttributeTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.FeedAttributeTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.FeedAttributeTypeEnum();
                        };

                        /**
                         * Creates a plain object from a FeedAttributeTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.FeedAttributeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.FeedAttributeTypeEnum} message FeedAttributeTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedAttributeTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FeedAttributeTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.FeedAttributeTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedAttributeTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FeedAttributeType enum.
                         * @name google.ads.googleads.v1.enums.FeedAttributeTypeEnum.FeedAttributeType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} INT64=2 INT64 value
                         * @property {number} DOUBLE=3 DOUBLE value
                         * @property {number} STRING=4 STRING value
                         * @property {number} BOOLEAN=5 BOOLEAN value
                         * @property {number} URL=6 URL value
                         * @property {number} DATE_TIME=7 DATE_TIME value
                         * @property {number} INT64_LIST=8 INT64_LIST value
                         * @property {number} DOUBLE_LIST=9 DOUBLE_LIST value
                         * @property {number} STRING_LIST=10 STRING_LIST value
                         * @property {number} BOOLEAN_LIST=11 BOOLEAN_LIST value
                         * @property {number} URL_LIST=12 URL_LIST value
                         * @property {number} DATE_TIME_LIST=13 DATE_TIME_LIST value
                         * @property {number} PRICE=14 PRICE value
                         */
                        FeedAttributeTypeEnum.FeedAttributeType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "INT64"] = 2;
                            values[valuesById[3] = "DOUBLE"] = 3;
                            values[valuesById[4] = "STRING"] = 4;
                            values[valuesById[5] = "BOOLEAN"] = 5;
                            values[valuesById[6] = "URL"] = 6;
                            values[valuesById[7] = "DATE_TIME"] = 7;
                            values[valuesById[8] = "INT64_LIST"] = 8;
                            values[valuesById[9] = "DOUBLE_LIST"] = 9;
                            values[valuesById[10] = "STRING_LIST"] = 10;
                            values[valuesById[11] = "BOOLEAN_LIST"] = 11;
                            values[valuesById[12] = "URL_LIST"] = 12;
                            values[valuesById[13] = "DATE_TIME_LIST"] = 13;
                            values[valuesById[14] = "PRICE"] = 14;
                            return values;
                        })();

                        return FeedAttributeTypeEnum;
                    })();

                    enums.FeedItemQualityApprovalStatusEnum = (function() {

                        /**
                         * Properties of a FeedItemQualityApprovalStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IFeedItemQualityApprovalStatusEnum
                         */

                        /**
                         * Constructs a new FeedItemQualityApprovalStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a FeedItemQualityApprovalStatusEnum.
                         * @implements IFeedItemQualityApprovalStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IFeedItemQualityApprovalStatusEnum=} [properties] Properties to set
                         */
                        function FeedItemQualityApprovalStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FeedItemQualityApprovalStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedItemQualityApprovalStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum} FeedItemQualityApprovalStatusEnum instance
                         */
                        FeedItemQualityApprovalStatusEnum.create = function create(properties) {
                            return new FeedItemQualityApprovalStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified FeedItemQualityApprovalStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedItemQualityApprovalStatusEnum} message FeedItemQualityApprovalStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemQualityApprovalStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedItemQualityApprovalStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedItemQualityApprovalStatusEnum} message FeedItemQualityApprovalStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemQualityApprovalStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedItemQualityApprovalStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum} FeedItemQualityApprovalStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemQualityApprovalStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedItemQualityApprovalStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum} FeedItemQualityApprovalStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemQualityApprovalStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedItemQualityApprovalStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedItemQualityApprovalStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FeedItemQualityApprovalStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum} FeedItemQualityApprovalStatusEnum
                         */
                        FeedItemQualityApprovalStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum();
                        };

                        /**
                         * Creates a plain object from a FeedItemQualityApprovalStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum} message FeedItemQualityApprovalStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedItemQualityApprovalStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FeedItemQualityApprovalStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedItemQualityApprovalStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FeedItemQualityApprovalStatus enum.
                         * @name google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum.FeedItemQualityApprovalStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} APPROVED=2 APPROVED value
                         * @property {number} DISAPPROVED=3 DISAPPROVED value
                         */
                        FeedItemQualityApprovalStatusEnum.FeedItemQualityApprovalStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "APPROVED"] = 2;
                            values[valuesById[3] = "DISAPPROVED"] = 3;
                            return values;
                        })();

                        return FeedItemQualityApprovalStatusEnum;
                    })();

                    enums.FeedItemQualityDisapprovalReasonEnum = (function() {

                        /**
                         * Properties of a FeedItemQualityDisapprovalReasonEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IFeedItemQualityDisapprovalReasonEnum
                         */

                        /**
                         * Constructs a new FeedItemQualityDisapprovalReasonEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a FeedItemQualityDisapprovalReasonEnum.
                         * @implements IFeedItemQualityDisapprovalReasonEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IFeedItemQualityDisapprovalReasonEnum=} [properties] Properties to set
                         */
                        function FeedItemQualityDisapprovalReasonEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FeedItemQualityDisapprovalReasonEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedItemQualityDisapprovalReasonEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum} FeedItemQualityDisapprovalReasonEnum instance
                         */
                        FeedItemQualityDisapprovalReasonEnum.create = function create(properties) {
                            return new FeedItemQualityDisapprovalReasonEnum(properties);
                        };

                        /**
                         * Encodes the specified FeedItemQualityDisapprovalReasonEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedItemQualityDisapprovalReasonEnum} message FeedItemQualityDisapprovalReasonEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemQualityDisapprovalReasonEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedItemQualityDisapprovalReasonEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedItemQualityDisapprovalReasonEnum} message FeedItemQualityDisapprovalReasonEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemQualityDisapprovalReasonEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedItemQualityDisapprovalReasonEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum} FeedItemQualityDisapprovalReasonEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemQualityDisapprovalReasonEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedItemQualityDisapprovalReasonEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum} FeedItemQualityDisapprovalReasonEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemQualityDisapprovalReasonEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedItemQualityDisapprovalReasonEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedItemQualityDisapprovalReasonEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FeedItemQualityDisapprovalReasonEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum} FeedItemQualityDisapprovalReasonEnum
                         */
                        FeedItemQualityDisapprovalReasonEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum();
                        };

                        /**
                         * Creates a plain object from a FeedItemQualityDisapprovalReasonEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum} message FeedItemQualityDisapprovalReasonEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedItemQualityDisapprovalReasonEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FeedItemQualityDisapprovalReasonEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedItemQualityDisapprovalReasonEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FeedItemQualityDisapprovalReason enum.
                         * @name google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum.FeedItemQualityDisapprovalReason
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} PRICE_TABLE_REPETITIVE_HEADERS=2 PRICE_TABLE_REPETITIVE_HEADERS value
                         * @property {number} PRICE_TABLE_REPETITIVE_DESCRIPTION=3 PRICE_TABLE_REPETITIVE_DESCRIPTION value
                         * @property {number} PRICE_TABLE_INCONSISTENT_ROWS=4 PRICE_TABLE_INCONSISTENT_ROWS value
                         * @property {number} PRICE_DESCRIPTION_HAS_PRICE_QUALIFIERS=5 PRICE_DESCRIPTION_HAS_PRICE_QUALIFIERS value
                         * @property {number} PRICE_UNSUPPORTED_LANGUAGE=6 PRICE_UNSUPPORTED_LANGUAGE value
                         * @property {number} PRICE_TABLE_ROW_HEADER_TABLE_TYPE_MISMATCH=7 PRICE_TABLE_ROW_HEADER_TABLE_TYPE_MISMATCH value
                         * @property {number} PRICE_TABLE_ROW_HEADER_HAS_PROMOTIONAL_TEXT=8 PRICE_TABLE_ROW_HEADER_HAS_PROMOTIONAL_TEXT value
                         * @property {number} PRICE_TABLE_ROW_DESCRIPTION_NOT_RELEVANT=9 PRICE_TABLE_ROW_DESCRIPTION_NOT_RELEVANT value
                         * @property {number} PRICE_TABLE_ROW_DESCRIPTION_HAS_PROMOTIONAL_TEXT=10 PRICE_TABLE_ROW_DESCRIPTION_HAS_PROMOTIONAL_TEXT value
                         * @property {number} PRICE_TABLE_ROW_HEADER_DESCRIPTION_REPETITIVE=11 PRICE_TABLE_ROW_HEADER_DESCRIPTION_REPETITIVE value
                         * @property {number} PRICE_TABLE_ROW_UNRATEABLE=12 PRICE_TABLE_ROW_UNRATEABLE value
                         * @property {number} PRICE_TABLE_ROW_PRICE_INVALID=13 PRICE_TABLE_ROW_PRICE_INVALID value
                         * @property {number} PRICE_TABLE_ROW_URL_INVALID=14 PRICE_TABLE_ROW_URL_INVALID value
                         * @property {number} PRICE_HEADER_OR_DESCRIPTION_HAS_PRICE=15 PRICE_HEADER_OR_DESCRIPTION_HAS_PRICE value
                         * @property {number} STRUCTURED_SNIPPETS_HEADER_POLICY_VIOLATED=16 STRUCTURED_SNIPPETS_HEADER_POLICY_VIOLATED value
                         * @property {number} STRUCTURED_SNIPPETS_REPEATED_VALUES=17 STRUCTURED_SNIPPETS_REPEATED_VALUES value
                         * @property {number} STRUCTURED_SNIPPETS_EDITORIAL_GUIDELINES=18 STRUCTURED_SNIPPETS_EDITORIAL_GUIDELINES value
                         * @property {number} STRUCTURED_SNIPPETS_HAS_PROMOTIONAL_TEXT=19 STRUCTURED_SNIPPETS_HAS_PROMOTIONAL_TEXT value
                         */
                        FeedItemQualityDisapprovalReasonEnum.FeedItemQualityDisapprovalReason = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "PRICE_TABLE_REPETITIVE_HEADERS"] = 2;
                            values[valuesById[3] = "PRICE_TABLE_REPETITIVE_DESCRIPTION"] = 3;
                            values[valuesById[4] = "PRICE_TABLE_INCONSISTENT_ROWS"] = 4;
                            values[valuesById[5] = "PRICE_DESCRIPTION_HAS_PRICE_QUALIFIERS"] = 5;
                            values[valuesById[6] = "PRICE_UNSUPPORTED_LANGUAGE"] = 6;
                            values[valuesById[7] = "PRICE_TABLE_ROW_HEADER_TABLE_TYPE_MISMATCH"] = 7;
                            values[valuesById[8] = "PRICE_TABLE_ROW_HEADER_HAS_PROMOTIONAL_TEXT"] = 8;
                            values[valuesById[9] = "PRICE_TABLE_ROW_DESCRIPTION_NOT_RELEVANT"] = 9;
                            values[valuesById[10] = "PRICE_TABLE_ROW_DESCRIPTION_HAS_PROMOTIONAL_TEXT"] = 10;
                            values[valuesById[11] = "PRICE_TABLE_ROW_HEADER_DESCRIPTION_REPETITIVE"] = 11;
                            values[valuesById[12] = "PRICE_TABLE_ROW_UNRATEABLE"] = 12;
                            values[valuesById[13] = "PRICE_TABLE_ROW_PRICE_INVALID"] = 13;
                            values[valuesById[14] = "PRICE_TABLE_ROW_URL_INVALID"] = 14;
                            values[valuesById[15] = "PRICE_HEADER_OR_DESCRIPTION_HAS_PRICE"] = 15;
                            values[valuesById[16] = "STRUCTURED_SNIPPETS_HEADER_POLICY_VIOLATED"] = 16;
                            values[valuesById[17] = "STRUCTURED_SNIPPETS_REPEATED_VALUES"] = 17;
                            values[valuesById[18] = "STRUCTURED_SNIPPETS_EDITORIAL_GUIDELINES"] = 18;
                            values[valuesById[19] = "STRUCTURED_SNIPPETS_HAS_PROMOTIONAL_TEXT"] = 19;
                            return values;
                        })();

                        return FeedItemQualityDisapprovalReasonEnum;
                    })();

                    enums.FeedItemStatusEnum = (function() {

                        /**
                         * Properties of a FeedItemStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IFeedItemStatusEnum
                         */

                        /**
                         * Constructs a new FeedItemStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a FeedItemStatusEnum.
                         * @implements IFeedItemStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IFeedItemStatusEnum=} [properties] Properties to set
                         */
                        function FeedItemStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FeedItemStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.FeedItemStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedItemStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.FeedItemStatusEnum} FeedItemStatusEnum instance
                         */
                        FeedItemStatusEnum.create = function create(properties) {
                            return new FeedItemStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified FeedItemStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.FeedItemStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.FeedItemStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedItemStatusEnum} message FeedItemStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedItemStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.FeedItemStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedItemStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedItemStatusEnum} message FeedItemStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedItemStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.FeedItemStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.FeedItemStatusEnum} FeedItemStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.FeedItemStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedItemStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedItemStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.FeedItemStatusEnum} FeedItemStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedItemStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.FeedItemStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedItemStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FeedItemStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.FeedItemStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.FeedItemStatusEnum} FeedItemStatusEnum
                         */
                        FeedItemStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.FeedItemStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.FeedItemStatusEnum();
                        };

                        /**
                         * Creates a plain object from a FeedItemStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.FeedItemStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.FeedItemStatusEnum} message FeedItemStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedItemStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FeedItemStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.FeedItemStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedItemStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FeedItemStatus enum.
                         * @name google.ads.googleads.v1.enums.FeedItemStatusEnum.FeedItemStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENABLED=2 ENABLED value
                         * @property {number} REMOVED=3 REMOVED value
                         */
                        FeedItemStatusEnum.FeedItemStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENABLED"] = 2;
                            values[valuesById[3] = "REMOVED"] = 3;
                            return values;
                        })();

                        return FeedItemStatusEnum;
                    })();

                    enums.FeedItemTargetDeviceEnum = (function() {

                        /**
                         * Properties of a FeedItemTargetDeviceEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IFeedItemTargetDeviceEnum
                         */

                        /**
                         * Constructs a new FeedItemTargetDeviceEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a FeedItemTargetDeviceEnum.
                         * @implements IFeedItemTargetDeviceEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IFeedItemTargetDeviceEnum=} [properties] Properties to set
                         */
                        function FeedItemTargetDeviceEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FeedItemTargetDeviceEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedItemTargetDeviceEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum} FeedItemTargetDeviceEnum instance
                         */
                        FeedItemTargetDeviceEnum.create = function create(properties) {
                            return new FeedItemTargetDeviceEnum(properties);
                        };

                        /**
                         * Encodes the specified FeedItemTargetDeviceEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedItemTargetDeviceEnum} message FeedItemTargetDeviceEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemTargetDeviceEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedItemTargetDeviceEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedItemTargetDeviceEnum} message FeedItemTargetDeviceEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemTargetDeviceEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedItemTargetDeviceEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum} FeedItemTargetDeviceEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemTargetDeviceEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedItemTargetDeviceEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum} FeedItemTargetDeviceEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemTargetDeviceEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedItemTargetDeviceEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedItemTargetDeviceEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FeedItemTargetDeviceEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum} FeedItemTargetDeviceEnum
                         */
                        FeedItemTargetDeviceEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum();
                        };

                        /**
                         * Creates a plain object from a FeedItemTargetDeviceEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum} message FeedItemTargetDeviceEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedItemTargetDeviceEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FeedItemTargetDeviceEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedItemTargetDeviceEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FeedItemTargetDevice enum.
                         * @name google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum.FeedItemTargetDevice
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} MOBILE=2 MOBILE value
                         */
                        FeedItemTargetDeviceEnum.FeedItemTargetDevice = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "MOBILE"] = 2;
                            return values;
                        })();

                        return FeedItemTargetDeviceEnum;
                    })();

                    enums.FeedItemTargetTypeEnum = (function() {

                        /**
                         * Properties of a FeedItemTargetTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IFeedItemTargetTypeEnum
                         */

                        /**
                         * Constructs a new FeedItemTargetTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a FeedItemTargetTypeEnum.
                         * @implements IFeedItemTargetTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IFeedItemTargetTypeEnum=} [properties] Properties to set
                         */
                        function FeedItemTargetTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FeedItemTargetTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.FeedItemTargetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedItemTargetTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.FeedItemTargetTypeEnum} FeedItemTargetTypeEnum instance
                         */
                        FeedItemTargetTypeEnum.create = function create(properties) {
                            return new FeedItemTargetTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified FeedItemTargetTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.FeedItemTargetTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.FeedItemTargetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedItemTargetTypeEnum} message FeedItemTargetTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemTargetTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedItemTargetTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.FeedItemTargetTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedItemTargetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedItemTargetTypeEnum} message FeedItemTargetTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemTargetTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedItemTargetTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.FeedItemTargetTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.FeedItemTargetTypeEnum} FeedItemTargetTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemTargetTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.FeedItemTargetTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedItemTargetTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedItemTargetTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.FeedItemTargetTypeEnum} FeedItemTargetTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemTargetTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedItemTargetTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.FeedItemTargetTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedItemTargetTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FeedItemTargetTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.FeedItemTargetTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.FeedItemTargetTypeEnum} FeedItemTargetTypeEnum
                         */
                        FeedItemTargetTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.FeedItemTargetTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.FeedItemTargetTypeEnum();
                        };

                        /**
                         * Creates a plain object from a FeedItemTargetTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.FeedItemTargetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.FeedItemTargetTypeEnum} message FeedItemTargetTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedItemTargetTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FeedItemTargetTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.FeedItemTargetTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedItemTargetTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FeedItemTargetType enum.
                         * @name google.ads.googleads.v1.enums.FeedItemTargetTypeEnum.FeedItemTargetType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CAMPAIGN=2 CAMPAIGN value
                         * @property {number} AD_GROUP=3 AD_GROUP value
                         * @property {number} CRITERION=4 CRITERION value
                         */
                        FeedItemTargetTypeEnum.FeedItemTargetType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CAMPAIGN"] = 2;
                            values[valuesById[3] = "AD_GROUP"] = 3;
                            values[valuesById[4] = "CRITERION"] = 4;
                            return values;
                        })();

                        return FeedItemTargetTypeEnum;
                    })();

                    enums.FeedItemValidationStatusEnum = (function() {

                        /**
                         * Properties of a FeedItemValidationStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IFeedItemValidationStatusEnum
                         */

                        /**
                         * Constructs a new FeedItemValidationStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a FeedItemValidationStatusEnum.
                         * @implements IFeedItemValidationStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IFeedItemValidationStatusEnum=} [properties] Properties to set
                         */
                        function FeedItemValidationStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FeedItemValidationStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.FeedItemValidationStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedItemValidationStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.FeedItemValidationStatusEnum} FeedItemValidationStatusEnum instance
                         */
                        FeedItemValidationStatusEnum.create = function create(properties) {
                            return new FeedItemValidationStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified FeedItemValidationStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.FeedItemValidationStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.FeedItemValidationStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedItemValidationStatusEnum} message FeedItemValidationStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemValidationStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedItemValidationStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.FeedItemValidationStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedItemValidationStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedItemValidationStatusEnum} message FeedItemValidationStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemValidationStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedItemValidationStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.FeedItemValidationStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.FeedItemValidationStatusEnum} FeedItemValidationStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemValidationStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.FeedItemValidationStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedItemValidationStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedItemValidationStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.FeedItemValidationStatusEnum} FeedItemValidationStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemValidationStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedItemValidationStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.FeedItemValidationStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedItemValidationStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FeedItemValidationStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.FeedItemValidationStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.FeedItemValidationStatusEnum} FeedItemValidationStatusEnum
                         */
                        FeedItemValidationStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.FeedItemValidationStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.FeedItemValidationStatusEnum();
                        };

                        /**
                         * Creates a plain object from a FeedItemValidationStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.FeedItemValidationStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.FeedItemValidationStatusEnum} message FeedItemValidationStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedItemValidationStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FeedItemValidationStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.FeedItemValidationStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedItemValidationStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FeedItemValidationStatus enum.
                         * @name google.ads.googleads.v1.enums.FeedItemValidationStatusEnum.FeedItemValidationStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} PENDING=2 PENDING value
                         * @property {number} INVALID=3 INVALID value
                         * @property {number} VALID=4 VALID value
                         */
                        FeedItemValidationStatusEnum.FeedItemValidationStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "PENDING"] = 2;
                            values[valuesById[3] = "INVALID"] = 3;
                            values[valuesById[4] = "VALID"] = 4;
                            return values;
                        })();

                        return FeedItemValidationStatusEnum;
                    })();

                    enums.FeedLinkStatusEnum = (function() {

                        /**
                         * Properties of a FeedLinkStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IFeedLinkStatusEnum
                         */

                        /**
                         * Constructs a new FeedLinkStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a FeedLinkStatusEnum.
                         * @implements IFeedLinkStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IFeedLinkStatusEnum=} [properties] Properties to set
                         */
                        function FeedLinkStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FeedLinkStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.FeedLinkStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedLinkStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.FeedLinkStatusEnum} FeedLinkStatusEnum instance
                         */
                        FeedLinkStatusEnum.create = function create(properties) {
                            return new FeedLinkStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified FeedLinkStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.FeedLinkStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.FeedLinkStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedLinkStatusEnum} message FeedLinkStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedLinkStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedLinkStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.FeedLinkStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedLinkStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedLinkStatusEnum} message FeedLinkStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedLinkStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedLinkStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.FeedLinkStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.FeedLinkStatusEnum} FeedLinkStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedLinkStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.FeedLinkStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedLinkStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedLinkStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.FeedLinkStatusEnum} FeedLinkStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedLinkStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedLinkStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.FeedLinkStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedLinkStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FeedLinkStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.FeedLinkStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.FeedLinkStatusEnum} FeedLinkStatusEnum
                         */
                        FeedLinkStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.FeedLinkStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.FeedLinkStatusEnum();
                        };

                        /**
                         * Creates a plain object from a FeedLinkStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.FeedLinkStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.FeedLinkStatusEnum} message FeedLinkStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedLinkStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FeedLinkStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.FeedLinkStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedLinkStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FeedLinkStatus enum.
                         * @name google.ads.googleads.v1.enums.FeedLinkStatusEnum.FeedLinkStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENABLED=2 ENABLED value
                         * @property {number} REMOVED=3 REMOVED value
                         */
                        FeedLinkStatusEnum.FeedLinkStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENABLED"] = 2;
                            values[valuesById[3] = "REMOVED"] = 3;
                            return values;
                        })();

                        return FeedLinkStatusEnum;
                    })();

                    enums.FeedMappingCriterionTypeEnum = (function() {

                        /**
                         * Properties of a FeedMappingCriterionTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IFeedMappingCriterionTypeEnum
                         */

                        /**
                         * Constructs a new FeedMappingCriterionTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a FeedMappingCriterionTypeEnum.
                         * @implements IFeedMappingCriterionTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IFeedMappingCriterionTypeEnum=} [properties] Properties to set
                         */
                        function FeedMappingCriterionTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FeedMappingCriterionTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedMappingCriterionTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum} FeedMappingCriterionTypeEnum instance
                         */
                        FeedMappingCriterionTypeEnum.create = function create(properties) {
                            return new FeedMappingCriterionTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified FeedMappingCriterionTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedMappingCriterionTypeEnum} message FeedMappingCriterionTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedMappingCriterionTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedMappingCriterionTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedMappingCriterionTypeEnum} message FeedMappingCriterionTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedMappingCriterionTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedMappingCriterionTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum} FeedMappingCriterionTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedMappingCriterionTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedMappingCriterionTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum} FeedMappingCriterionTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedMappingCriterionTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedMappingCriterionTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedMappingCriterionTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FeedMappingCriterionTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum} FeedMappingCriterionTypeEnum
                         */
                        FeedMappingCriterionTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum();
                        };

                        /**
                         * Creates a plain object from a FeedMappingCriterionTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum} message FeedMappingCriterionTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedMappingCriterionTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FeedMappingCriterionTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedMappingCriterionTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FeedMappingCriterionType enum.
                         * @name google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum.FeedMappingCriterionType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} LOCATION_EXTENSION_TARGETING=4 LOCATION_EXTENSION_TARGETING value
                         * @property {number} DSA_PAGE_FEED=3 DSA_PAGE_FEED value
                         */
                        FeedMappingCriterionTypeEnum.FeedMappingCriterionType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[4] = "LOCATION_EXTENSION_TARGETING"] = 4;
                            values[valuesById[3] = "DSA_PAGE_FEED"] = 3;
                            return values;
                        })();

                        return FeedMappingCriterionTypeEnum;
                    })();

                    enums.FeedMappingStatusEnum = (function() {

                        /**
                         * Properties of a FeedMappingStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IFeedMappingStatusEnum
                         */

                        /**
                         * Constructs a new FeedMappingStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a FeedMappingStatusEnum.
                         * @implements IFeedMappingStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IFeedMappingStatusEnum=} [properties] Properties to set
                         */
                        function FeedMappingStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FeedMappingStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.FeedMappingStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedMappingStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.FeedMappingStatusEnum} FeedMappingStatusEnum instance
                         */
                        FeedMappingStatusEnum.create = function create(properties) {
                            return new FeedMappingStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified FeedMappingStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.FeedMappingStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.FeedMappingStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedMappingStatusEnum} message FeedMappingStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedMappingStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedMappingStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.FeedMappingStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedMappingStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedMappingStatusEnum} message FeedMappingStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedMappingStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedMappingStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.FeedMappingStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.FeedMappingStatusEnum} FeedMappingStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedMappingStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.FeedMappingStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedMappingStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedMappingStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.FeedMappingStatusEnum} FeedMappingStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedMappingStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedMappingStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.FeedMappingStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedMappingStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FeedMappingStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.FeedMappingStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.FeedMappingStatusEnum} FeedMappingStatusEnum
                         */
                        FeedMappingStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.FeedMappingStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.FeedMappingStatusEnum();
                        };

                        /**
                         * Creates a plain object from a FeedMappingStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.FeedMappingStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.FeedMappingStatusEnum} message FeedMappingStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedMappingStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FeedMappingStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.FeedMappingStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedMappingStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FeedMappingStatus enum.
                         * @name google.ads.googleads.v1.enums.FeedMappingStatusEnum.FeedMappingStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENABLED=2 ENABLED value
                         * @property {number} REMOVED=3 REMOVED value
                         */
                        FeedMappingStatusEnum.FeedMappingStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENABLED"] = 2;
                            values[valuesById[3] = "REMOVED"] = 3;
                            return values;
                        })();

                        return FeedMappingStatusEnum;
                    })();

                    enums.FeedOriginEnum = (function() {

                        /**
                         * Properties of a FeedOriginEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IFeedOriginEnum
                         */

                        /**
                         * Constructs a new FeedOriginEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a FeedOriginEnum.
                         * @implements IFeedOriginEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IFeedOriginEnum=} [properties] Properties to set
                         */
                        function FeedOriginEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FeedOriginEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.FeedOriginEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedOriginEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.FeedOriginEnum} FeedOriginEnum instance
                         */
                        FeedOriginEnum.create = function create(properties) {
                            return new FeedOriginEnum(properties);
                        };

                        /**
                         * Encodes the specified FeedOriginEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.FeedOriginEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.FeedOriginEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedOriginEnum} message FeedOriginEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedOriginEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedOriginEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.FeedOriginEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedOriginEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedOriginEnum} message FeedOriginEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedOriginEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedOriginEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.FeedOriginEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.FeedOriginEnum} FeedOriginEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedOriginEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.FeedOriginEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedOriginEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedOriginEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.FeedOriginEnum} FeedOriginEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedOriginEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedOriginEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.FeedOriginEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedOriginEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FeedOriginEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.FeedOriginEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.FeedOriginEnum} FeedOriginEnum
                         */
                        FeedOriginEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.FeedOriginEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.FeedOriginEnum();
                        };

                        /**
                         * Creates a plain object from a FeedOriginEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.FeedOriginEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.FeedOriginEnum} message FeedOriginEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedOriginEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FeedOriginEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.FeedOriginEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedOriginEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FeedOrigin enum.
                         * @name google.ads.googleads.v1.enums.FeedOriginEnum.FeedOrigin
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} USER=2 USER value
                         * @property {number} GOOGLE=3 GOOGLE value
                         */
                        FeedOriginEnum.FeedOrigin = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "USER"] = 2;
                            values[valuesById[3] = "GOOGLE"] = 3;
                            return values;
                        })();

                        return FeedOriginEnum;
                    })();

                    enums.FeedStatusEnum = (function() {

                        /**
                         * Properties of a FeedStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IFeedStatusEnum
                         */

                        /**
                         * Constructs a new FeedStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a FeedStatusEnum.
                         * @implements IFeedStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IFeedStatusEnum=} [properties] Properties to set
                         */
                        function FeedStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FeedStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.FeedStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.FeedStatusEnum} FeedStatusEnum instance
                         */
                        FeedStatusEnum.create = function create(properties) {
                            return new FeedStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified FeedStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.FeedStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.FeedStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedStatusEnum} message FeedStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.FeedStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFeedStatusEnum} message FeedStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.FeedStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.FeedStatusEnum} FeedStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.FeedStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FeedStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.FeedStatusEnum} FeedStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.FeedStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FeedStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.FeedStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.FeedStatusEnum} FeedStatusEnum
                         */
                        FeedStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.FeedStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.FeedStatusEnum();
                        };

                        /**
                         * Creates a plain object from a FeedStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.FeedStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.FeedStatusEnum} message FeedStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FeedStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.FeedStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FeedStatus enum.
                         * @name google.ads.googleads.v1.enums.FeedStatusEnum.FeedStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENABLED=2 ENABLED value
                         * @property {number} REMOVED=3 REMOVED value
                         */
                        FeedStatusEnum.FeedStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENABLED"] = 2;
                            values[valuesById[3] = "REMOVED"] = 3;
                            return values;
                        })();

                        return FeedStatusEnum;
                    })();

                    enums.FlightPlaceholderFieldEnum = (function() {

                        /**
                         * Properties of a FlightPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IFlightPlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new FlightPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a FlightPlaceholderFieldEnum.
                         * @implements IFlightPlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IFlightPlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function FlightPlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FlightPlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFlightPlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum} FlightPlaceholderFieldEnum instance
                         */
                        FlightPlaceholderFieldEnum.create = function create(properties) {
                            return new FlightPlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified FlightPlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFlightPlaceholderFieldEnum} message FlightPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FlightPlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FlightPlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFlightPlaceholderFieldEnum} message FlightPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FlightPlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FlightPlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum} FlightPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FlightPlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FlightPlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum} FlightPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FlightPlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FlightPlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FlightPlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FlightPlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum} FlightPlaceholderFieldEnum
                         */
                        FlightPlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from a FlightPlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum} message FlightPlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FlightPlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FlightPlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FlightPlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FlightPlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum.FlightPlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} DESTINATION_ID=2 DESTINATION_ID value
                         * @property {number} ORIGIN_ID=3 ORIGIN_ID value
                         * @property {number} FLIGHT_DESCRIPTION=4 FLIGHT_DESCRIPTION value
                         * @property {number} ORIGIN_NAME=5 ORIGIN_NAME value
                         * @property {number} DESTINATION_NAME=6 DESTINATION_NAME value
                         * @property {number} FLIGHT_PRICE=7 FLIGHT_PRICE value
                         * @property {number} FORMATTED_PRICE=8 FORMATTED_PRICE value
                         * @property {number} FLIGHT_SALE_PRICE=9 FLIGHT_SALE_PRICE value
                         * @property {number} FORMATTED_SALE_PRICE=10 FORMATTED_SALE_PRICE value
                         * @property {number} IMAGE_URL=11 IMAGE_URL value
                         * @property {number} FINAL_URLS=12 FINAL_URLS value
                         * @property {number} FINAL_MOBILE_URLS=13 FINAL_MOBILE_URLS value
                         * @property {number} TRACKING_URL=14 TRACKING_URL value
                         * @property {number} ANDROID_APP_LINK=15 ANDROID_APP_LINK value
                         * @property {number} SIMILAR_DESTINATION_IDS=16 SIMILAR_DESTINATION_IDS value
                         * @property {number} IOS_APP_LINK=17 IOS_APP_LINK value
                         * @property {number} IOS_APP_STORE_ID=18 IOS_APP_STORE_ID value
                         */
                        FlightPlaceholderFieldEnum.FlightPlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "DESTINATION_ID"] = 2;
                            values[valuesById[3] = "ORIGIN_ID"] = 3;
                            values[valuesById[4] = "FLIGHT_DESCRIPTION"] = 4;
                            values[valuesById[5] = "ORIGIN_NAME"] = 5;
                            values[valuesById[6] = "DESTINATION_NAME"] = 6;
                            values[valuesById[7] = "FLIGHT_PRICE"] = 7;
                            values[valuesById[8] = "FORMATTED_PRICE"] = 8;
                            values[valuesById[9] = "FLIGHT_SALE_PRICE"] = 9;
                            values[valuesById[10] = "FORMATTED_SALE_PRICE"] = 10;
                            values[valuesById[11] = "IMAGE_URL"] = 11;
                            values[valuesById[12] = "FINAL_URLS"] = 12;
                            values[valuesById[13] = "FINAL_MOBILE_URLS"] = 13;
                            values[valuesById[14] = "TRACKING_URL"] = 14;
                            values[valuesById[15] = "ANDROID_APP_LINK"] = 15;
                            values[valuesById[16] = "SIMILAR_DESTINATION_IDS"] = 16;
                            values[valuesById[17] = "IOS_APP_LINK"] = 17;
                            values[valuesById[18] = "IOS_APP_STORE_ID"] = 18;
                            return values;
                        })();

                        return FlightPlaceholderFieldEnum;
                    })();

                    enums.FrequencyCapEventTypeEnum = (function() {

                        /**
                         * Properties of a FrequencyCapEventTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IFrequencyCapEventTypeEnum
                         */

                        /**
                         * Constructs a new FrequencyCapEventTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a FrequencyCapEventTypeEnum.
                         * @implements IFrequencyCapEventTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IFrequencyCapEventTypeEnum=} [properties] Properties to set
                         */
                        function FrequencyCapEventTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FrequencyCapEventTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFrequencyCapEventTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum} FrequencyCapEventTypeEnum instance
                         */
                        FrequencyCapEventTypeEnum.create = function create(properties) {
                            return new FrequencyCapEventTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified FrequencyCapEventTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFrequencyCapEventTypeEnum} message FrequencyCapEventTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FrequencyCapEventTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FrequencyCapEventTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFrequencyCapEventTypeEnum} message FrequencyCapEventTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FrequencyCapEventTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FrequencyCapEventTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum} FrequencyCapEventTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FrequencyCapEventTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FrequencyCapEventTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum} FrequencyCapEventTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FrequencyCapEventTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FrequencyCapEventTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FrequencyCapEventTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FrequencyCapEventTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum} FrequencyCapEventTypeEnum
                         */
                        FrequencyCapEventTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum();
                        };

                        /**
                         * Creates a plain object from a FrequencyCapEventTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum} message FrequencyCapEventTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FrequencyCapEventTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FrequencyCapEventTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FrequencyCapEventTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FrequencyCapEventType enum.
                         * @name google.ads.googleads.v1.enums.FrequencyCapEventTypeEnum.FrequencyCapEventType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} IMPRESSION=2 IMPRESSION value
                         * @property {number} VIDEO_VIEW=3 VIDEO_VIEW value
                         */
                        FrequencyCapEventTypeEnum.FrequencyCapEventType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "IMPRESSION"] = 2;
                            values[valuesById[3] = "VIDEO_VIEW"] = 3;
                            return values;
                        })();

                        return FrequencyCapEventTypeEnum;
                    })();

                    enums.FrequencyCapLevelEnum = (function() {

                        /**
                         * Properties of a FrequencyCapLevelEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IFrequencyCapLevelEnum
                         */

                        /**
                         * Constructs a new FrequencyCapLevelEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a FrequencyCapLevelEnum.
                         * @implements IFrequencyCapLevelEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IFrequencyCapLevelEnum=} [properties] Properties to set
                         */
                        function FrequencyCapLevelEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FrequencyCapLevelEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapLevelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFrequencyCapLevelEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.FrequencyCapLevelEnum} FrequencyCapLevelEnum instance
                         */
                        FrequencyCapLevelEnum.create = function create(properties) {
                            return new FrequencyCapLevelEnum(properties);
                        };

                        /**
                         * Encodes the specified FrequencyCapLevelEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.FrequencyCapLevelEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapLevelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFrequencyCapLevelEnum} message FrequencyCapLevelEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FrequencyCapLevelEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FrequencyCapLevelEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.FrequencyCapLevelEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapLevelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFrequencyCapLevelEnum} message FrequencyCapLevelEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FrequencyCapLevelEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FrequencyCapLevelEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapLevelEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.FrequencyCapLevelEnum} FrequencyCapLevelEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FrequencyCapLevelEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.FrequencyCapLevelEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FrequencyCapLevelEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapLevelEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.FrequencyCapLevelEnum} FrequencyCapLevelEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FrequencyCapLevelEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FrequencyCapLevelEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapLevelEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FrequencyCapLevelEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FrequencyCapLevelEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapLevelEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.FrequencyCapLevelEnum} FrequencyCapLevelEnum
                         */
                        FrequencyCapLevelEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.FrequencyCapLevelEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.FrequencyCapLevelEnum();
                        };

                        /**
                         * Creates a plain object from a FrequencyCapLevelEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapLevelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.FrequencyCapLevelEnum} message FrequencyCapLevelEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FrequencyCapLevelEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FrequencyCapLevelEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapLevelEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FrequencyCapLevelEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FrequencyCapLevel enum.
                         * @name google.ads.googleads.v1.enums.FrequencyCapLevelEnum.FrequencyCapLevel
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} AD_GROUP_AD=2 AD_GROUP_AD value
                         * @property {number} AD_GROUP=3 AD_GROUP value
                         * @property {number} CAMPAIGN=4 CAMPAIGN value
                         */
                        FrequencyCapLevelEnum.FrequencyCapLevel = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "AD_GROUP_AD"] = 2;
                            values[valuesById[3] = "AD_GROUP"] = 3;
                            values[valuesById[4] = "CAMPAIGN"] = 4;
                            return values;
                        })();

                        return FrequencyCapLevelEnum;
                    })();

                    enums.FrequencyCapTimeUnitEnum = (function() {

                        /**
                         * Properties of a FrequencyCapTimeUnitEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IFrequencyCapTimeUnitEnum
                         */

                        /**
                         * Constructs a new FrequencyCapTimeUnitEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a FrequencyCapTimeUnitEnum.
                         * @implements IFrequencyCapTimeUnitEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IFrequencyCapTimeUnitEnum=} [properties] Properties to set
                         */
                        function FrequencyCapTimeUnitEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new FrequencyCapTimeUnitEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFrequencyCapTimeUnitEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum} FrequencyCapTimeUnitEnum instance
                         */
                        FrequencyCapTimeUnitEnum.create = function create(properties) {
                            return new FrequencyCapTimeUnitEnum(properties);
                        };

                        /**
                         * Encodes the specified FrequencyCapTimeUnitEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFrequencyCapTimeUnitEnum} message FrequencyCapTimeUnitEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FrequencyCapTimeUnitEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified FrequencyCapTimeUnitEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IFrequencyCapTimeUnitEnum} message FrequencyCapTimeUnitEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FrequencyCapTimeUnitEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FrequencyCapTimeUnitEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum} FrequencyCapTimeUnitEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FrequencyCapTimeUnitEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FrequencyCapTimeUnitEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum} FrequencyCapTimeUnitEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FrequencyCapTimeUnitEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FrequencyCapTimeUnitEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FrequencyCapTimeUnitEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a FrequencyCapTimeUnitEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum} FrequencyCapTimeUnitEnum
                         */
                        FrequencyCapTimeUnitEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum();
                        };

                        /**
                         * Creates a plain object from a FrequencyCapTimeUnitEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum} message FrequencyCapTimeUnitEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FrequencyCapTimeUnitEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this FrequencyCapTimeUnitEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FrequencyCapTimeUnitEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * FrequencyCapTimeUnit enum.
                         * @name google.ads.googleads.v1.enums.FrequencyCapTimeUnitEnum.FrequencyCapTimeUnit
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} DAY=2 DAY value
                         * @property {number} WEEK=3 WEEK value
                         * @property {number} MONTH=4 MONTH value
                         */
                        FrequencyCapTimeUnitEnum.FrequencyCapTimeUnit = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "DAY"] = 2;
                            values[valuesById[3] = "WEEK"] = 3;
                            values[valuesById[4] = "MONTH"] = 4;
                            return values;
                        })();

                        return FrequencyCapTimeUnitEnum;
                    })();

                    enums.GenderTypeEnum = (function() {

                        /**
                         * Properties of a GenderTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IGenderTypeEnum
                         */

                        /**
                         * Constructs a new GenderTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a GenderTypeEnum.
                         * @implements IGenderTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IGenderTypeEnum=} [properties] Properties to set
                         */
                        function GenderTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new GenderTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.GenderTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IGenderTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.GenderTypeEnum} GenderTypeEnum instance
                         */
                        GenderTypeEnum.create = function create(properties) {
                            return new GenderTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified GenderTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.GenderTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.GenderTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IGenderTypeEnum} message GenderTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenderTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified GenderTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.GenderTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.GenderTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IGenderTypeEnum} message GenderTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenderTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GenderTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.GenderTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.GenderTypeEnum} GenderTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenderTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.GenderTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GenderTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.GenderTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.GenderTypeEnum} GenderTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenderTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GenderTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.GenderTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GenderTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a GenderTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.GenderTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.GenderTypeEnum} GenderTypeEnum
                         */
                        GenderTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.GenderTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.GenderTypeEnum();
                        };

                        /**
                         * Creates a plain object from a GenderTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.GenderTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.GenderTypeEnum} message GenderTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GenderTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this GenderTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.GenderTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GenderTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * GenderType enum.
                         * @name google.ads.googleads.v1.enums.GenderTypeEnum.GenderType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} MALE=10 MALE value
                         * @property {number} FEMALE=11 FEMALE value
                         * @property {number} UNDETERMINED=20 UNDETERMINED value
                         */
                        GenderTypeEnum.GenderType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[10] = "MALE"] = 10;
                            values[valuesById[11] = "FEMALE"] = 11;
                            values[valuesById[20] = "UNDETERMINED"] = 20;
                            return values;
                        })();

                        return GenderTypeEnum;
                    })();

                    enums.GeoTargetConstantStatusEnum = (function() {

                        /**
                         * Properties of a GeoTargetConstantStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IGeoTargetConstantStatusEnum
                         */

                        /**
                         * Constructs a new GeoTargetConstantStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a GeoTargetConstantStatusEnum.
                         * @implements IGeoTargetConstantStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IGeoTargetConstantStatusEnum=} [properties] Properties to set
                         */
                        function GeoTargetConstantStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new GeoTargetConstantStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IGeoTargetConstantStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum} GeoTargetConstantStatusEnum instance
                         */
                        GeoTargetConstantStatusEnum.create = function create(properties) {
                            return new GeoTargetConstantStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified GeoTargetConstantStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IGeoTargetConstantStatusEnum} message GeoTargetConstantStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GeoTargetConstantStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified GeoTargetConstantStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IGeoTargetConstantStatusEnum} message GeoTargetConstantStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GeoTargetConstantStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GeoTargetConstantStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum} GeoTargetConstantStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GeoTargetConstantStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GeoTargetConstantStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum} GeoTargetConstantStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GeoTargetConstantStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GeoTargetConstantStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GeoTargetConstantStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a GeoTargetConstantStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum} GeoTargetConstantStatusEnum
                         */
                        GeoTargetConstantStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum();
                        };

                        /**
                         * Creates a plain object from a GeoTargetConstantStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum} message GeoTargetConstantStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GeoTargetConstantStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this GeoTargetConstantStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GeoTargetConstantStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * GeoTargetConstantStatus enum.
                         * @name google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum.GeoTargetConstantStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENABLED=2 ENABLED value
                         * @property {number} REMOVAL_PLANNED=3 REMOVAL_PLANNED value
                         */
                        GeoTargetConstantStatusEnum.GeoTargetConstantStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENABLED"] = 2;
                            values[valuesById[3] = "REMOVAL_PLANNED"] = 3;
                            return values;
                        })();

                        return GeoTargetConstantStatusEnum;
                    })();

                    enums.GeoTargetingRestrictionEnum = (function() {

                        /**
                         * Properties of a GeoTargetingRestrictionEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IGeoTargetingRestrictionEnum
                         */

                        /**
                         * Constructs a new GeoTargetingRestrictionEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a GeoTargetingRestrictionEnum.
                         * @implements IGeoTargetingRestrictionEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IGeoTargetingRestrictionEnum=} [properties] Properties to set
                         */
                        function GeoTargetingRestrictionEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new GeoTargetingRestrictionEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IGeoTargetingRestrictionEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum} GeoTargetingRestrictionEnum instance
                         */
                        GeoTargetingRestrictionEnum.create = function create(properties) {
                            return new GeoTargetingRestrictionEnum(properties);
                        };

                        /**
                         * Encodes the specified GeoTargetingRestrictionEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IGeoTargetingRestrictionEnum} message GeoTargetingRestrictionEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GeoTargetingRestrictionEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified GeoTargetingRestrictionEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IGeoTargetingRestrictionEnum} message GeoTargetingRestrictionEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GeoTargetingRestrictionEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GeoTargetingRestrictionEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum} GeoTargetingRestrictionEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GeoTargetingRestrictionEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GeoTargetingRestrictionEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum} GeoTargetingRestrictionEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GeoTargetingRestrictionEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GeoTargetingRestrictionEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GeoTargetingRestrictionEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a GeoTargetingRestrictionEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum} GeoTargetingRestrictionEnum
                         */
                        GeoTargetingRestrictionEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum();
                        };

                        /**
                         * Creates a plain object from a GeoTargetingRestrictionEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum} message GeoTargetingRestrictionEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GeoTargetingRestrictionEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this GeoTargetingRestrictionEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GeoTargetingRestrictionEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * GeoTargetingRestriction enum.
                         * @name google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum.GeoTargetingRestriction
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} LOCATION_OF_PRESENCE=2 LOCATION_OF_PRESENCE value
                         */
                        GeoTargetingRestrictionEnum.GeoTargetingRestriction = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "LOCATION_OF_PRESENCE"] = 2;
                            return values;
                        })();

                        return GeoTargetingRestrictionEnum;
                    })();

                    enums.GeoTargetingTypeEnum = (function() {

                        /**
                         * Properties of a GeoTargetingTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IGeoTargetingTypeEnum
                         */

                        /**
                         * Constructs a new GeoTargetingTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a GeoTargetingTypeEnum.
                         * @implements IGeoTargetingTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IGeoTargetingTypeEnum=} [properties] Properties to set
                         */
                        function GeoTargetingTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new GeoTargetingTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.GeoTargetingTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IGeoTargetingTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.GeoTargetingTypeEnum} GeoTargetingTypeEnum instance
                         */
                        GeoTargetingTypeEnum.create = function create(properties) {
                            return new GeoTargetingTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified GeoTargetingTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.GeoTargetingTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.GeoTargetingTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IGeoTargetingTypeEnum} message GeoTargetingTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GeoTargetingTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified GeoTargetingTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.GeoTargetingTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.GeoTargetingTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IGeoTargetingTypeEnum} message GeoTargetingTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GeoTargetingTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GeoTargetingTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.GeoTargetingTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.GeoTargetingTypeEnum} GeoTargetingTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GeoTargetingTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.GeoTargetingTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GeoTargetingTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.GeoTargetingTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.GeoTargetingTypeEnum} GeoTargetingTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GeoTargetingTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GeoTargetingTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.GeoTargetingTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GeoTargetingTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a GeoTargetingTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.GeoTargetingTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.GeoTargetingTypeEnum} GeoTargetingTypeEnum
                         */
                        GeoTargetingTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.GeoTargetingTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.GeoTargetingTypeEnum();
                        };

                        /**
                         * Creates a plain object from a GeoTargetingTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.GeoTargetingTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.GeoTargetingTypeEnum} message GeoTargetingTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GeoTargetingTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this GeoTargetingTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.GeoTargetingTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GeoTargetingTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * GeoTargetingType enum.
                         * @name google.ads.googleads.v1.enums.GeoTargetingTypeEnum.GeoTargetingType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} AREA_OF_INTEREST=2 AREA_OF_INTEREST value
                         * @property {number} LOCATION_OF_PRESENCE=3 LOCATION_OF_PRESENCE value
                         */
                        GeoTargetingTypeEnum.GeoTargetingType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "AREA_OF_INTEREST"] = 2;
                            values[valuesById[3] = "LOCATION_OF_PRESENCE"] = 3;
                            return values;
                        })();

                        return GeoTargetingTypeEnum;
                    })();

                    enums.GoogleAdsFieldCategoryEnum = (function() {

                        /**
                         * Properties of a GoogleAdsFieldCategoryEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IGoogleAdsFieldCategoryEnum
                         */

                        /**
                         * Constructs a new GoogleAdsFieldCategoryEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a GoogleAdsFieldCategoryEnum.
                         * @implements IGoogleAdsFieldCategoryEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IGoogleAdsFieldCategoryEnum=} [properties] Properties to set
                         */
                        function GoogleAdsFieldCategoryEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new GoogleAdsFieldCategoryEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IGoogleAdsFieldCategoryEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum} GoogleAdsFieldCategoryEnum instance
                         */
                        GoogleAdsFieldCategoryEnum.create = function create(properties) {
                            return new GoogleAdsFieldCategoryEnum(properties);
                        };

                        /**
                         * Encodes the specified GoogleAdsFieldCategoryEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IGoogleAdsFieldCategoryEnum} message GoogleAdsFieldCategoryEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GoogleAdsFieldCategoryEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified GoogleAdsFieldCategoryEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IGoogleAdsFieldCategoryEnum} message GoogleAdsFieldCategoryEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GoogleAdsFieldCategoryEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GoogleAdsFieldCategoryEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum} GoogleAdsFieldCategoryEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GoogleAdsFieldCategoryEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GoogleAdsFieldCategoryEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum} GoogleAdsFieldCategoryEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GoogleAdsFieldCategoryEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GoogleAdsFieldCategoryEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GoogleAdsFieldCategoryEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a GoogleAdsFieldCategoryEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum} GoogleAdsFieldCategoryEnum
                         */
                        GoogleAdsFieldCategoryEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum();
                        };

                        /**
                         * Creates a plain object from a GoogleAdsFieldCategoryEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum} message GoogleAdsFieldCategoryEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GoogleAdsFieldCategoryEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this GoogleAdsFieldCategoryEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GoogleAdsFieldCategoryEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * GoogleAdsFieldCategory enum.
                         * @name google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum.GoogleAdsFieldCategory
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} RESOURCE=2 RESOURCE value
                         * @property {number} ATTRIBUTE=3 ATTRIBUTE value
                         * @property {number} SEGMENT=5 SEGMENT value
                         * @property {number} METRIC=6 METRIC value
                         */
                        GoogleAdsFieldCategoryEnum.GoogleAdsFieldCategory = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "RESOURCE"] = 2;
                            values[valuesById[3] = "ATTRIBUTE"] = 3;
                            values[valuesById[5] = "SEGMENT"] = 5;
                            values[valuesById[6] = "METRIC"] = 6;
                            return values;
                        })();

                        return GoogleAdsFieldCategoryEnum;
                    })();

                    enums.GoogleAdsFieldDataTypeEnum = (function() {

                        /**
                         * Properties of a GoogleAdsFieldDataTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IGoogleAdsFieldDataTypeEnum
                         */

                        /**
                         * Constructs a new GoogleAdsFieldDataTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a GoogleAdsFieldDataTypeEnum.
                         * @implements IGoogleAdsFieldDataTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IGoogleAdsFieldDataTypeEnum=} [properties] Properties to set
                         */
                        function GoogleAdsFieldDataTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new GoogleAdsFieldDataTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IGoogleAdsFieldDataTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum} GoogleAdsFieldDataTypeEnum instance
                         */
                        GoogleAdsFieldDataTypeEnum.create = function create(properties) {
                            return new GoogleAdsFieldDataTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified GoogleAdsFieldDataTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IGoogleAdsFieldDataTypeEnum} message GoogleAdsFieldDataTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GoogleAdsFieldDataTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified GoogleAdsFieldDataTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IGoogleAdsFieldDataTypeEnum} message GoogleAdsFieldDataTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GoogleAdsFieldDataTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GoogleAdsFieldDataTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum} GoogleAdsFieldDataTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GoogleAdsFieldDataTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GoogleAdsFieldDataTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum} GoogleAdsFieldDataTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GoogleAdsFieldDataTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GoogleAdsFieldDataTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GoogleAdsFieldDataTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a GoogleAdsFieldDataTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum} GoogleAdsFieldDataTypeEnum
                         */
                        GoogleAdsFieldDataTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum();
                        };

                        /**
                         * Creates a plain object from a GoogleAdsFieldDataTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum} message GoogleAdsFieldDataTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GoogleAdsFieldDataTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this GoogleAdsFieldDataTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GoogleAdsFieldDataTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * GoogleAdsFieldDataType enum.
                         * @name google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum.GoogleAdsFieldDataType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} BOOLEAN=2 BOOLEAN value
                         * @property {number} DATE=3 DATE value
                         * @property {number} DOUBLE=4 DOUBLE value
                         * @property {number} ENUM=5 ENUM value
                         * @property {number} FLOAT=6 FLOAT value
                         * @property {number} INT32=7 INT32 value
                         * @property {number} INT64=8 INT64 value
                         * @property {number} MESSAGE=9 MESSAGE value
                         * @property {number} RESOURCE_NAME=10 RESOURCE_NAME value
                         * @property {number} STRING=11 STRING value
                         */
                        GoogleAdsFieldDataTypeEnum.GoogleAdsFieldDataType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "BOOLEAN"] = 2;
                            values[valuesById[3] = "DATE"] = 3;
                            values[valuesById[4] = "DOUBLE"] = 4;
                            values[valuesById[5] = "ENUM"] = 5;
                            values[valuesById[6] = "FLOAT"] = 6;
                            values[valuesById[7] = "INT32"] = 7;
                            values[valuesById[8] = "INT64"] = 8;
                            values[valuesById[9] = "MESSAGE"] = 9;
                            values[valuesById[10] = "RESOURCE_NAME"] = 10;
                            values[valuesById[11] = "STRING"] = 11;
                            return values;
                        })();

                        return GoogleAdsFieldDataTypeEnum;
                    })();

                    enums.HotelDateSelectionTypeEnum = (function() {

                        /**
                         * Properties of a HotelDateSelectionTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IHotelDateSelectionTypeEnum
                         */

                        /**
                         * Constructs a new HotelDateSelectionTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a HotelDateSelectionTypeEnum.
                         * @implements IHotelDateSelectionTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IHotelDateSelectionTypeEnum=} [properties] Properties to set
                         */
                        function HotelDateSelectionTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new HotelDateSelectionTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IHotelDateSelectionTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum} HotelDateSelectionTypeEnum instance
                         */
                        HotelDateSelectionTypeEnum.create = function create(properties) {
                            return new HotelDateSelectionTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified HotelDateSelectionTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IHotelDateSelectionTypeEnum} message HotelDateSelectionTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelDateSelectionTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified HotelDateSelectionTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IHotelDateSelectionTypeEnum} message HotelDateSelectionTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelDateSelectionTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a HotelDateSelectionTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum} HotelDateSelectionTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelDateSelectionTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a HotelDateSelectionTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum} HotelDateSelectionTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelDateSelectionTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a HotelDateSelectionTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HotelDateSelectionTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a HotelDateSelectionTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum} HotelDateSelectionTypeEnum
                         */
                        HotelDateSelectionTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum();
                        };

                        /**
                         * Creates a plain object from a HotelDateSelectionTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum} message HotelDateSelectionTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HotelDateSelectionTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this HotelDateSelectionTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HotelDateSelectionTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * HotelDateSelectionType enum.
                         * @name google.ads.googleads.v1.enums.HotelDateSelectionTypeEnum.HotelDateSelectionType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} DEFAULT_SELECTION=50 DEFAULT_SELECTION value
                         * @property {number} USER_SELECTED=51 USER_SELECTED value
                         */
                        HotelDateSelectionTypeEnum.HotelDateSelectionType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[50] = "DEFAULT_SELECTION"] = 50;
                            values[valuesById[51] = "USER_SELECTED"] = 51;
                            return values;
                        })();

                        return HotelDateSelectionTypeEnum;
                    })();

                    enums.HotelPlaceholderFieldEnum = (function() {

                        /**
                         * Properties of a HotelPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IHotelPlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new HotelPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a HotelPlaceholderFieldEnum.
                         * @implements IHotelPlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IHotelPlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function HotelPlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new HotelPlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IHotelPlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum} HotelPlaceholderFieldEnum instance
                         */
                        HotelPlaceholderFieldEnum.create = function create(properties) {
                            return new HotelPlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified HotelPlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IHotelPlaceholderFieldEnum} message HotelPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelPlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified HotelPlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IHotelPlaceholderFieldEnum} message HotelPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelPlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a HotelPlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum} HotelPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelPlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a HotelPlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum} HotelPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelPlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a HotelPlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HotelPlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a HotelPlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum} HotelPlaceholderFieldEnum
                         */
                        HotelPlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from a HotelPlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum} message HotelPlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HotelPlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this HotelPlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HotelPlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * HotelPlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum.HotelPlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} PROPERTY_ID=2 PROPERTY_ID value
                         * @property {number} PROPERTY_NAME=3 PROPERTY_NAME value
                         * @property {number} DESTINATION_NAME=4 DESTINATION_NAME value
                         * @property {number} DESCRIPTION=5 DESCRIPTION value
                         * @property {number} ADDRESS=6 ADDRESS value
                         * @property {number} PRICE=7 PRICE value
                         * @property {number} FORMATTED_PRICE=8 FORMATTED_PRICE value
                         * @property {number} SALE_PRICE=9 SALE_PRICE value
                         * @property {number} FORMATTED_SALE_PRICE=10 FORMATTED_SALE_PRICE value
                         * @property {number} IMAGE_URL=11 IMAGE_URL value
                         * @property {number} CATEGORY=12 CATEGORY value
                         * @property {number} STAR_RATING=13 STAR_RATING value
                         * @property {number} CONTEXTUAL_KEYWORDS=14 CONTEXTUAL_KEYWORDS value
                         * @property {number} FINAL_URLS=15 FINAL_URLS value
                         * @property {number} FINAL_MOBILE_URLS=16 FINAL_MOBILE_URLS value
                         * @property {number} TRACKING_URL=17 TRACKING_URL value
                         * @property {number} ANDROID_APP_LINK=18 ANDROID_APP_LINK value
                         * @property {number} SIMILAR_PROPERTY_IDS=19 SIMILAR_PROPERTY_IDS value
                         * @property {number} IOS_APP_LINK=20 IOS_APP_LINK value
                         * @property {number} IOS_APP_STORE_ID=21 IOS_APP_STORE_ID value
                         */
                        HotelPlaceholderFieldEnum.HotelPlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "PROPERTY_ID"] = 2;
                            values[valuesById[3] = "PROPERTY_NAME"] = 3;
                            values[valuesById[4] = "DESTINATION_NAME"] = 4;
                            values[valuesById[5] = "DESCRIPTION"] = 5;
                            values[valuesById[6] = "ADDRESS"] = 6;
                            values[valuesById[7] = "PRICE"] = 7;
                            values[valuesById[8] = "FORMATTED_PRICE"] = 8;
                            values[valuesById[9] = "SALE_PRICE"] = 9;
                            values[valuesById[10] = "FORMATTED_SALE_PRICE"] = 10;
                            values[valuesById[11] = "IMAGE_URL"] = 11;
                            values[valuesById[12] = "CATEGORY"] = 12;
                            values[valuesById[13] = "STAR_RATING"] = 13;
                            values[valuesById[14] = "CONTEXTUAL_KEYWORDS"] = 14;
                            values[valuesById[15] = "FINAL_URLS"] = 15;
                            values[valuesById[16] = "FINAL_MOBILE_URLS"] = 16;
                            values[valuesById[17] = "TRACKING_URL"] = 17;
                            values[valuesById[18] = "ANDROID_APP_LINK"] = 18;
                            values[valuesById[19] = "SIMILAR_PROPERTY_IDS"] = 19;
                            values[valuesById[20] = "IOS_APP_LINK"] = 20;
                            values[valuesById[21] = "IOS_APP_STORE_ID"] = 21;
                            return values;
                        })();

                        return HotelPlaceholderFieldEnum;
                    })();

                    enums.IncomeRangeTypeEnum = (function() {

                        /**
                         * Properties of an IncomeRangeTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IIncomeRangeTypeEnum
                         */

                        /**
                         * Constructs a new IncomeRangeTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an IncomeRangeTypeEnum.
                         * @implements IIncomeRangeTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IIncomeRangeTypeEnum=} [properties] Properties to set
                         */
                        function IncomeRangeTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new IncomeRangeTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.IncomeRangeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IIncomeRangeTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.IncomeRangeTypeEnum} IncomeRangeTypeEnum instance
                         */
                        IncomeRangeTypeEnum.create = function create(properties) {
                            return new IncomeRangeTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified IncomeRangeTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.IncomeRangeTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.IncomeRangeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IIncomeRangeTypeEnum} message IncomeRangeTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        IncomeRangeTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified IncomeRangeTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.IncomeRangeTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.IncomeRangeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IIncomeRangeTypeEnum} message IncomeRangeTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        IncomeRangeTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an IncomeRangeTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.IncomeRangeTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.IncomeRangeTypeEnum} IncomeRangeTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        IncomeRangeTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.IncomeRangeTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an IncomeRangeTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.IncomeRangeTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.IncomeRangeTypeEnum} IncomeRangeTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        IncomeRangeTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an IncomeRangeTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.IncomeRangeTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        IncomeRangeTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an IncomeRangeTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.IncomeRangeTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.IncomeRangeTypeEnum} IncomeRangeTypeEnum
                         */
                        IncomeRangeTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.IncomeRangeTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.IncomeRangeTypeEnum();
                        };

                        /**
                         * Creates a plain object from an IncomeRangeTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.IncomeRangeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IncomeRangeTypeEnum} message IncomeRangeTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        IncomeRangeTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this IncomeRangeTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.IncomeRangeTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        IncomeRangeTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * IncomeRangeType enum.
                         * @name google.ads.googleads.v1.enums.IncomeRangeTypeEnum.IncomeRangeType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} INCOME_RANGE_0_50=510001 INCOME_RANGE_0_50 value
                         * @property {number} INCOME_RANGE_50_60=510002 INCOME_RANGE_50_60 value
                         * @property {number} INCOME_RANGE_60_70=510003 INCOME_RANGE_60_70 value
                         * @property {number} INCOME_RANGE_70_80=510004 INCOME_RANGE_70_80 value
                         * @property {number} INCOME_RANGE_80_90=510005 INCOME_RANGE_80_90 value
                         * @property {number} INCOME_RANGE_90_UP=510006 INCOME_RANGE_90_UP value
                         * @property {number} INCOME_RANGE_UNDETERMINED=510000 INCOME_RANGE_UNDETERMINED value
                         */
                        IncomeRangeTypeEnum.IncomeRangeType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[510001] = "INCOME_RANGE_0_50"] = 510001;
                            values[valuesById[510002] = "INCOME_RANGE_50_60"] = 510002;
                            values[valuesById[510003] = "INCOME_RANGE_60_70"] = 510003;
                            values[valuesById[510004] = "INCOME_RANGE_70_80"] = 510004;
                            values[valuesById[510005] = "INCOME_RANGE_80_90"] = 510005;
                            values[valuesById[510006] = "INCOME_RANGE_90_UP"] = 510006;
                            values[valuesById[510000] = "INCOME_RANGE_UNDETERMINED"] = 510000;
                            return values;
                        })();

                        return IncomeRangeTypeEnum;
                    })();

                    enums.InteractionEventTypeEnum = (function() {

                        /**
                         * Properties of an InteractionEventTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IInteractionEventTypeEnum
                         */

                        /**
                         * Constructs a new InteractionEventTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an InteractionEventTypeEnum.
                         * @implements IInteractionEventTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IInteractionEventTypeEnum=} [properties] Properties to set
                         */
                        function InteractionEventTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new InteractionEventTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.InteractionEventTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IInteractionEventTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.InteractionEventTypeEnum} InteractionEventTypeEnum instance
                         */
                        InteractionEventTypeEnum.create = function create(properties) {
                            return new InteractionEventTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified InteractionEventTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.InteractionEventTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.InteractionEventTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IInteractionEventTypeEnum} message InteractionEventTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InteractionEventTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified InteractionEventTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.InteractionEventTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.InteractionEventTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IInteractionEventTypeEnum} message InteractionEventTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InteractionEventTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an InteractionEventTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.InteractionEventTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.InteractionEventTypeEnum} InteractionEventTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InteractionEventTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.InteractionEventTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an InteractionEventTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.InteractionEventTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.InteractionEventTypeEnum} InteractionEventTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InteractionEventTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an InteractionEventTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.InteractionEventTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InteractionEventTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an InteractionEventTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.InteractionEventTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.InteractionEventTypeEnum} InteractionEventTypeEnum
                         */
                        InteractionEventTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.InteractionEventTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.InteractionEventTypeEnum();
                        };

                        /**
                         * Creates a plain object from an InteractionEventTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.InteractionEventTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.InteractionEventTypeEnum} message InteractionEventTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InteractionEventTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this InteractionEventTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.InteractionEventTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InteractionEventTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * InteractionEventType enum.
                         * @name google.ads.googleads.v1.enums.InteractionEventTypeEnum.InteractionEventType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CLICK=2 CLICK value
                         * @property {number} ENGAGEMENT=3 ENGAGEMENT value
                         * @property {number} VIDEO_VIEW=4 VIDEO_VIEW value
                         * @property {number} NONE=5 NONE value
                         */
                        InteractionEventTypeEnum.InteractionEventType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CLICK"] = 2;
                            values[valuesById[3] = "ENGAGEMENT"] = 3;
                            values[valuesById[4] = "VIDEO_VIEW"] = 4;
                            values[valuesById[5] = "NONE"] = 5;
                            return values;
                        })();

                        return InteractionEventTypeEnum;
                    })();

                    enums.InteractionTypeEnum = (function() {

                        /**
                         * Properties of an InteractionTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IInteractionTypeEnum
                         */

                        /**
                         * Constructs a new InteractionTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an InteractionTypeEnum.
                         * @implements IInteractionTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IInteractionTypeEnum=} [properties] Properties to set
                         */
                        function InteractionTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new InteractionTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.InteractionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IInteractionTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.InteractionTypeEnum} InteractionTypeEnum instance
                         */
                        InteractionTypeEnum.create = function create(properties) {
                            return new InteractionTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified InteractionTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.InteractionTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.InteractionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IInteractionTypeEnum} message InteractionTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InteractionTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified InteractionTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.InteractionTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.InteractionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IInteractionTypeEnum} message InteractionTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InteractionTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an InteractionTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.InteractionTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.InteractionTypeEnum} InteractionTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InteractionTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.InteractionTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an InteractionTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.InteractionTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.InteractionTypeEnum} InteractionTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InteractionTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an InteractionTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.InteractionTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InteractionTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an InteractionTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.InteractionTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.InteractionTypeEnum} InteractionTypeEnum
                         */
                        InteractionTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.InteractionTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.InteractionTypeEnum();
                        };

                        /**
                         * Creates a plain object from an InteractionTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.InteractionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.InteractionTypeEnum} message InteractionTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InteractionTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this InteractionTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.InteractionTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InteractionTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * InteractionType enum.
                         * @name google.ads.googleads.v1.enums.InteractionTypeEnum.InteractionType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CALLS=8000 CALLS value
                         */
                        InteractionTypeEnum.InteractionType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[8000] = "CALLS"] = 8000;
                            return values;
                        })();

                        return InteractionTypeEnum;
                    })();

                    enums.JobPlaceholderFieldEnum = (function() {

                        /**
                         * Properties of a JobPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IJobPlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new JobPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a JobPlaceholderFieldEnum.
                         * @implements IJobPlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IJobPlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function JobPlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new JobPlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.JobPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IJobPlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.JobPlaceholderFieldEnum} JobPlaceholderFieldEnum instance
                         */
                        JobPlaceholderFieldEnum.create = function create(properties) {
                            return new JobPlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified JobPlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.JobPlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.JobPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IJobPlaceholderFieldEnum} message JobPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        JobPlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified JobPlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.JobPlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.JobPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IJobPlaceholderFieldEnum} message JobPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        JobPlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a JobPlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.JobPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.JobPlaceholderFieldEnum} JobPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        JobPlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.JobPlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a JobPlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.JobPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.JobPlaceholderFieldEnum} JobPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        JobPlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a JobPlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.JobPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        JobPlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a JobPlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.JobPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.JobPlaceholderFieldEnum} JobPlaceholderFieldEnum
                         */
                        JobPlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.JobPlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.JobPlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from a JobPlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.JobPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.JobPlaceholderFieldEnum} message JobPlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        JobPlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this JobPlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.JobPlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        JobPlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * JobPlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.JobPlaceholderFieldEnum.JobPlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} JOB_ID=2 JOB_ID value
                         * @property {number} LOCATION_ID=3 LOCATION_ID value
                         * @property {number} TITLE=4 TITLE value
                         * @property {number} SUBTITLE=5 SUBTITLE value
                         * @property {number} DESCRIPTION=6 DESCRIPTION value
                         * @property {number} IMAGE_URL=7 IMAGE_URL value
                         * @property {number} CATEGORY=8 CATEGORY value
                         * @property {number} CONTEXTUAL_KEYWORDS=9 CONTEXTUAL_KEYWORDS value
                         * @property {number} ADDRESS=10 ADDRESS value
                         * @property {number} SALARY=11 SALARY value
                         * @property {number} FINAL_URLS=12 FINAL_URLS value
                         * @property {number} FINAL_MOBILE_URLS=14 FINAL_MOBILE_URLS value
                         * @property {number} TRACKING_URL=15 TRACKING_URL value
                         * @property {number} ANDROID_APP_LINK=16 ANDROID_APP_LINK value
                         * @property {number} SIMILAR_JOB_IDS=17 SIMILAR_JOB_IDS value
                         * @property {number} IOS_APP_LINK=18 IOS_APP_LINK value
                         * @property {number} IOS_APP_STORE_ID=19 IOS_APP_STORE_ID value
                         */
                        JobPlaceholderFieldEnum.JobPlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "JOB_ID"] = 2;
                            values[valuesById[3] = "LOCATION_ID"] = 3;
                            values[valuesById[4] = "TITLE"] = 4;
                            values[valuesById[5] = "SUBTITLE"] = 5;
                            values[valuesById[6] = "DESCRIPTION"] = 6;
                            values[valuesById[7] = "IMAGE_URL"] = 7;
                            values[valuesById[8] = "CATEGORY"] = 8;
                            values[valuesById[9] = "CONTEXTUAL_KEYWORDS"] = 9;
                            values[valuesById[10] = "ADDRESS"] = 10;
                            values[valuesById[11] = "SALARY"] = 11;
                            values[valuesById[12] = "FINAL_URLS"] = 12;
                            values[valuesById[14] = "FINAL_MOBILE_URLS"] = 14;
                            values[valuesById[15] = "TRACKING_URL"] = 15;
                            values[valuesById[16] = "ANDROID_APP_LINK"] = 16;
                            values[valuesById[17] = "SIMILAR_JOB_IDS"] = 17;
                            values[valuesById[18] = "IOS_APP_LINK"] = 18;
                            values[valuesById[19] = "IOS_APP_STORE_ID"] = 19;
                            return values;
                        })();

                        return JobPlaceholderFieldEnum;
                    })();

                    enums.KeywordMatchTypeEnum = (function() {

                        /**
                         * Properties of a KeywordMatchTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IKeywordMatchTypeEnum
                         */

                        /**
                         * Constructs a new KeywordMatchTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a KeywordMatchTypeEnum.
                         * @implements IKeywordMatchTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IKeywordMatchTypeEnum=} [properties] Properties to set
                         */
                        function KeywordMatchTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new KeywordMatchTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.KeywordMatchTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IKeywordMatchTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.KeywordMatchTypeEnum} KeywordMatchTypeEnum instance
                         */
                        KeywordMatchTypeEnum.create = function create(properties) {
                            return new KeywordMatchTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified KeywordMatchTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.KeywordMatchTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.KeywordMatchTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IKeywordMatchTypeEnum} message KeywordMatchTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordMatchTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordMatchTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.KeywordMatchTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.KeywordMatchTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IKeywordMatchTypeEnum} message KeywordMatchTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordMatchTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordMatchTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.KeywordMatchTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.KeywordMatchTypeEnum} KeywordMatchTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordMatchTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.KeywordMatchTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordMatchTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.KeywordMatchTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.KeywordMatchTypeEnum} KeywordMatchTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordMatchTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordMatchTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.KeywordMatchTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordMatchTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a KeywordMatchTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.KeywordMatchTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.KeywordMatchTypeEnum} KeywordMatchTypeEnum
                         */
                        KeywordMatchTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.KeywordMatchTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.KeywordMatchTypeEnum();
                        };

                        /**
                         * Creates a plain object from a KeywordMatchTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.KeywordMatchTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.KeywordMatchTypeEnum} message KeywordMatchTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordMatchTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this KeywordMatchTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.KeywordMatchTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordMatchTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * KeywordMatchType enum.
                         * @name google.ads.googleads.v1.enums.KeywordMatchTypeEnum.KeywordMatchType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} EXACT=2 EXACT value
                         * @property {number} PHRASE=3 PHRASE value
                         * @property {number} BROAD=4 BROAD value
                         */
                        KeywordMatchTypeEnum.KeywordMatchType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "EXACT"] = 2;
                            values[valuesById[3] = "PHRASE"] = 3;
                            values[valuesById[4] = "BROAD"] = 4;
                            return values;
                        })();

                        return KeywordMatchTypeEnum;
                    })();

                    enums.KeywordPlanCompetitionLevelEnum = (function() {

                        /**
                         * Properties of a KeywordPlanCompetitionLevelEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IKeywordPlanCompetitionLevelEnum
                         */

                        /**
                         * Constructs a new KeywordPlanCompetitionLevelEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a KeywordPlanCompetitionLevelEnum.
                         * @implements IKeywordPlanCompetitionLevelEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IKeywordPlanCompetitionLevelEnum=} [properties] Properties to set
                         */
                        function KeywordPlanCompetitionLevelEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new KeywordPlanCompetitionLevelEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IKeywordPlanCompetitionLevelEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum} KeywordPlanCompetitionLevelEnum instance
                         */
                        KeywordPlanCompetitionLevelEnum.create = function create(properties) {
                            return new KeywordPlanCompetitionLevelEnum(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanCompetitionLevelEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IKeywordPlanCompetitionLevelEnum} message KeywordPlanCompetitionLevelEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanCompetitionLevelEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanCompetitionLevelEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IKeywordPlanCompetitionLevelEnum} message KeywordPlanCompetitionLevelEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanCompetitionLevelEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanCompetitionLevelEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum} KeywordPlanCompetitionLevelEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanCompetitionLevelEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanCompetitionLevelEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum} KeywordPlanCompetitionLevelEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanCompetitionLevelEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanCompetitionLevelEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanCompetitionLevelEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanCompetitionLevelEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum} KeywordPlanCompetitionLevelEnum
                         */
                        KeywordPlanCompetitionLevelEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum();
                        };

                        /**
                         * Creates a plain object from a KeywordPlanCompetitionLevelEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum} message KeywordPlanCompetitionLevelEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanCompetitionLevelEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this KeywordPlanCompetitionLevelEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanCompetitionLevelEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * KeywordPlanCompetitionLevel enum.
                         * @name google.ads.googleads.v1.enums.KeywordPlanCompetitionLevelEnum.KeywordPlanCompetitionLevel
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} LOW=2 LOW value
                         * @property {number} MEDIUM=3 MEDIUM value
                         * @property {number} HIGH=4 HIGH value
                         */
                        KeywordPlanCompetitionLevelEnum.KeywordPlanCompetitionLevel = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "LOW"] = 2;
                            values[valuesById[3] = "MEDIUM"] = 3;
                            values[valuesById[4] = "HIGH"] = 4;
                            return values;
                        })();

                        return KeywordPlanCompetitionLevelEnum;
                    })();

                    enums.KeywordPlanForecastIntervalEnum = (function() {

                        /**
                         * Properties of a KeywordPlanForecastIntervalEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IKeywordPlanForecastIntervalEnum
                         */

                        /**
                         * Constructs a new KeywordPlanForecastIntervalEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a KeywordPlanForecastIntervalEnum.
                         * @implements IKeywordPlanForecastIntervalEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IKeywordPlanForecastIntervalEnum=} [properties] Properties to set
                         */
                        function KeywordPlanForecastIntervalEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new KeywordPlanForecastIntervalEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IKeywordPlanForecastIntervalEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum} KeywordPlanForecastIntervalEnum instance
                         */
                        KeywordPlanForecastIntervalEnum.create = function create(properties) {
                            return new KeywordPlanForecastIntervalEnum(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanForecastIntervalEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IKeywordPlanForecastIntervalEnum} message KeywordPlanForecastIntervalEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanForecastIntervalEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanForecastIntervalEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IKeywordPlanForecastIntervalEnum} message KeywordPlanForecastIntervalEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanForecastIntervalEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanForecastIntervalEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum} KeywordPlanForecastIntervalEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanForecastIntervalEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanForecastIntervalEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum} KeywordPlanForecastIntervalEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanForecastIntervalEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanForecastIntervalEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanForecastIntervalEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanForecastIntervalEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum} KeywordPlanForecastIntervalEnum
                         */
                        KeywordPlanForecastIntervalEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum();
                        };

                        /**
                         * Creates a plain object from a KeywordPlanForecastIntervalEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum} message KeywordPlanForecastIntervalEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanForecastIntervalEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this KeywordPlanForecastIntervalEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanForecastIntervalEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * KeywordPlanForecastInterval enum.
                         * @name google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum.KeywordPlanForecastInterval
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} NEXT_WEEK=3 NEXT_WEEK value
                         * @property {number} NEXT_MONTH=4 NEXT_MONTH value
                         * @property {number} NEXT_QUARTER=5 NEXT_QUARTER value
                         */
                        KeywordPlanForecastIntervalEnum.KeywordPlanForecastInterval = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[3] = "NEXT_WEEK"] = 3;
                            values[valuesById[4] = "NEXT_MONTH"] = 4;
                            values[valuesById[5] = "NEXT_QUARTER"] = 5;
                            return values;
                        })();

                        return KeywordPlanForecastIntervalEnum;
                    })();

                    enums.KeywordPlanNetworkEnum = (function() {

                        /**
                         * Properties of a KeywordPlanNetworkEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IKeywordPlanNetworkEnum
                         */

                        /**
                         * Constructs a new KeywordPlanNetworkEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a KeywordPlanNetworkEnum.
                         * @implements IKeywordPlanNetworkEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IKeywordPlanNetworkEnum=} [properties] Properties to set
                         */
                        function KeywordPlanNetworkEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new KeywordPlanNetworkEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanNetworkEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IKeywordPlanNetworkEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.KeywordPlanNetworkEnum} KeywordPlanNetworkEnum instance
                         */
                        KeywordPlanNetworkEnum.create = function create(properties) {
                            return new KeywordPlanNetworkEnum(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanNetworkEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.KeywordPlanNetworkEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanNetworkEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IKeywordPlanNetworkEnum} message KeywordPlanNetworkEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanNetworkEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanNetworkEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.KeywordPlanNetworkEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanNetworkEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IKeywordPlanNetworkEnum} message KeywordPlanNetworkEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanNetworkEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanNetworkEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanNetworkEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.KeywordPlanNetworkEnum} KeywordPlanNetworkEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanNetworkEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.KeywordPlanNetworkEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanNetworkEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanNetworkEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.KeywordPlanNetworkEnum} KeywordPlanNetworkEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanNetworkEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanNetworkEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanNetworkEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanNetworkEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanNetworkEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanNetworkEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.KeywordPlanNetworkEnum} KeywordPlanNetworkEnum
                         */
                        KeywordPlanNetworkEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.KeywordPlanNetworkEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.KeywordPlanNetworkEnum();
                        };

                        /**
                         * Creates a plain object from a KeywordPlanNetworkEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanNetworkEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.KeywordPlanNetworkEnum} message KeywordPlanNetworkEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanNetworkEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this KeywordPlanNetworkEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.KeywordPlanNetworkEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanNetworkEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * KeywordPlanNetwork enum.
                         * @name google.ads.googleads.v1.enums.KeywordPlanNetworkEnum.KeywordPlanNetwork
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} GOOGLE_SEARCH=2 GOOGLE_SEARCH value
                         * @property {number} GOOGLE_SEARCH_AND_PARTNERS=3 GOOGLE_SEARCH_AND_PARTNERS value
                         */
                        KeywordPlanNetworkEnum.KeywordPlanNetwork = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "GOOGLE_SEARCH"] = 2;
                            values[valuesById[3] = "GOOGLE_SEARCH_AND_PARTNERS"] = 3;
                            return values;
                        })();

                        return KeywordPlanNetworkEnum;
                    })();

                    enums.LabelStatusEnum = (function() {

                        /**
                         * Properties of a LabelStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ILabelStatusEnum
                         */

                        /**
                         * Constructs a new LabelStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a LabelStatusEnum.
                         * @implements ILabelStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ILabelStatusEnum=} [properties] Properties to set
                         */
                        function LabelStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new LabelStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.LabelStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ILabelStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.LabelStatusEnum} LabelStatusEnum instance
                         */
                        LabelStatusEnum.create = function create(properties) {
                            return new LabelStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified LabelStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.LabelStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.LabelStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ILabelStatusEnum} message LabelStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LabelStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified LabelStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.LabelStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.LabelStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ILabelStatusEnum} message LabelStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LabelStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LabelStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.LabelStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.LabelStatusEnum} LabelStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LabelStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.LabelStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LabelStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.LabelStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.LabelStatusEnum} LabelStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LabelStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LabelStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.LabelStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LabelStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a LabelStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.LabelStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.LabelStatusEnum} LabelStatusEnum
                         */
                        LabelStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.LabelStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.LabelStatusEnum();
                        };

                        /**
                         * Creates a plain object from a LabelStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.LabelStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.LabelStatusEnum} message LabelStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LabelStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this LabelStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.LabelStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LabelStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * LabelStatus enum.
                         * @name google.ads.googleads.v1.enums.LabelStatusEnum.LabelStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENABLED=2 ENABLED value
                         * @property {number} REMOVED=3 REMOVED value
                         */
                        LabelStatusEnum.LabelStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENABLED"] = 2;
                            values[valuesById[3] = "REMOVED"] = 3;
                            return values;
                        })();

                        return LabelStatusEnum;
                    })();

                    enums.LegacyAppInstallAdAppStoreEnum = (function() {

                        /**
                         * Properties of a LegacyAppInstallAdAppStoreEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ILegacyAppInstallAdAppStoreEnum
                         */

                        /**
                         * Constructs a new LegacyAppInstallAdAppStoreEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a LegacyAppInstallAdAppStoreEnum.
                         * @implements ILegacyAppInstallAdAppStoreEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ILegacyAppInstallAdAppStoreEnum=} [properties] Properties to set
                         */
                        function LegacyAppInstallAdAppStoreEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new LegacyAppInstallAdAppStoreEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ILegacyAppInstallAdAppStoreEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum} LegacyAppInstallAdAppStoreEnum instance
                         */
                        LegacyAppInstallAdAppStoreEnum.create = function create(properties) {
                            return new LegacyAppInstallAdAppStoreEnum(properties);
                        };

                        /**
                         * Encodes the specified LegacyAppInstallAdAppStoreEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ILegacyAppInstallAdAppStoreEnum} message LegacyAppInstallAdAppStoreEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LegacyAppInstallAdAppStoreEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified LegacyAppInstallAdAppStoreEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ILegacyAppInstallAdAppStoreEnum} message LegacyAppInstallAdAppStoreEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LegacyAppInstallAdAppStoreEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LegacyAppInstallAdAppStoreEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum} LegacyAppInstallAdAppStoreEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LegacyAppInstallAdAppStoreEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LegacyAppInstallAdAppStoreEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum} LegacyAppInstallAdAppStoreEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LegacyAppInstallAdAppStoreEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LegacyAppInstallAdAppStoreEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LegacyAppInstallAdAppStoreEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a LegacyAppInstallAdAppStoreEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum} LegacyAppInstallAdAppStoreEnum
                         */
                        LegacyAppInstallAdAppStoreEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum();
                        };

                        /**
                         * Creates a plain object from a LegacyAppInstallAdAppStoreEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum} message LegacyAppInstallAdAppStoreEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LegacyAppInstallAdAppStoreEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this LegacyAppInstallAdAppStoreEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LegacyAppInstallAdAppStoreEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * LegacyAppInstallAdAppStore enum.
                         * @name google.ads.googleads.v1.enums.LegacyAppInstallAdAppStoreEnum.LegacyAppInstallAdAppStore
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} APPLE_APP_STORE=2 APPLE_APP_STORE value
                         * @property {number} GOOGLE_PLAY=3 GOOGLE_PLAY value
                         * @property {number} WINDOWS_STORE=4 WINDOWS_STORE value
                         * @property {number} WINDOWS_PHONE_STORE=5 WINDOWS_PHONE_STORE value
                         * @property {number} CN_APP_STORE=6 CN_APP_STORE value
                         */
                        LegacyAppInstallAdAppStoreEnum.LegacyAppInstallAdAppStore = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "APPLE_APP_STORE"] = 2;
                            values[valuesById[3] = "GOOGLE_PLAY"] = 3;
                            values[valuesById[4] = "WINDOWS_STORE"] = 4;
                            values[valuesById[5] = "WINDOWS_PHONE_STORE"] = 5;
                            values[valuesById[6] = "CN_APP_STORE"] = 6;
                            return values;
                        })();

                        return LegacyAppInstallAdAppStoreEnum;
                    })();

                    enums.ListingCustomAttributeIndexEnum = (function() {

                        /**
                         * Properties of a ListingCustomAttributeIndexEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IListingCustomAttributeIndexEnum
                         */

                        /**
                         * Constructs a new ListingCustomAttributeIndexEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ListingCustomAttributeIndexEnum.
                         * @implements IListingCustomAttributeIndexEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IListingCustomAttributeIndexEnum=} [properties] Properties to set
                         */
                        function ListingCustomAttributeIndexEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ListingCustomAttributeIndexEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IListingCustomAttributeIndexEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum} ListingCustomAttributeIndexEnum instance
                         */
                        ListingCustomAttributeIndexEnum.create = function create(properties) {
                            return new ListingCustomAttributeIndexEnum(properties);
                        };

                        /**
                         * Encodes the specified ListingCustomAttributeIndexEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IListingCustomAttributeIndexEnum} message ListingCustomAttributeIndexEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListingCustomAttributeIndexEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ListingCustomAttributeIndexEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IListingCustomAttributeIndexEnum} message ListingCustomAttributeIndexEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListingCustomAttributeIndexEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ListingCustomAttributeIndexEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum} ListingCustomAttributeIndexEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListingCustomAttributeIndexEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ListingCustomAttributeIndexEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum} ListingCustomAttributeIndexEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListingCustomAttributeIndexEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ListingCustomAttributeIndexEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListingCustomAttributeIndexEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ListingCustomAttributeIndexEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum} ListingCustomAttributeIndexEnum
                         */
                        ListingCustomAttributeIndexEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum();
                        };

                        /**
                         * Creates a plain object from a ListingCustomAttributeIndexEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum} message ListingCustomAttributeIndexEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListingCustomAttributeIndexEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ListingCustomAttributeIndexEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListingCustomAttributeIndexEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ListingCustomAttributeIndex enum.
                         * @name google.ads.googleads.v1.enums.ListingCustomAttributeIndexEnum.ListingCustomAttributeIndex
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} INDEX0=7 INDEX0 value
                         * @property {number} INDEX1=8 INDEX1 value
                         * @property {number} INDEX2=9 INDEX2 value
                         * @property {number} INDEX3=10 INDEX3 value
                         * @property {number} INDEX4=11 INDEX4 value
                         */
                        ListingCustomAttributeIndexEnum.ListingCustomAttributeIndex = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[7] = "INDEX0"] = 7;
                            values[valuesById[8] = "INDEX1"] = 8;
                            values[valuesById[9] = "INDEX2"] = 9;
                            values[valuesById[10] = "INDEX3"] = 10;
                            values[valuesById[11] = "INDEX4"] = 11;
                            return values;
                        })();

                        return ListingCustomAttributeIndexEnum;
                    })();

                    enums.ListingGroupTypeEnum = (function() {

                        /**
                         * Properties of a ListingGroupTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IListingGroupTypeEnum
                         */

                        /**
                         * Constructs a new ListingGroupTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ListingGroupTypeEnum.
                         * @implements IListingGroupTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IListingGroupTypeEnum=} [properties] Properties to set
                         */
                        function ListingGroupTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ListingGroupTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ListingGroupTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IListingGroupTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ListingGroupTypeEnum} ListingGroupTypeEnum instance
                         */
                        ListingGroupTypeEnum.create = function create(properties) {
                            return new ListingGroupTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified ListingGroupTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ListingGroupTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ListingGroupTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IListingGroupTypeEnum} message ListingGroupTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListingGroupTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ListingGroupTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ListingGroupTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ListingGroupTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IListingGroupTypeEnum} message ListingGroupTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListingGroupTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ListingGroupTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ListingGroupTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ListingGroupTypeEnum} ListingGroupTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListingGroupTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ListingGroupTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ListingGroupTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ListingGroupTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ListingGroupTypeEnum} ListingGroupTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListingGroupTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ListingGroupTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ListingGroupTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListingGroupTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ListingGroupTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ListingGroupTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ListingGroupTypeEnum} ListingGroupTypeEnum
                         */
                        ListingGroupTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ListingGroupTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ListingGroupTypeEnum();
                        };

                        /**
                         * Creates a plain object from a ListingGroupTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ListingGroupTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ListingGroupTypeEnum} message ListingGroupTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListingGroupTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ListingGroupTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ListingGroupTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListingGroupTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ListingGroupType enum.
                         * @name google.ads.googleads.v1.enums.ListingGroupTypeEnum.ListingGroupType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} SUBDIVISION=2 SUBDIVISION value
                         * @property {number} UNIT=3 UNIT value
                         */
                        ListingGroupTypeEnum.ListingGroupType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "SUBDIVISION"] = 2;
                            values[valuesById[3] = "UNIT"] = 3;
                            return values;
                        })();

                        return ListingGroupTypeEnum;
                    })();

                    enums.LocalPlaceholderFieldEnum = (function() {

                        /**
                         * Properties of a LocalPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ILocalPlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new LocalPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a LocalPlaceholderFieldEnum.
                         * @implements ILocalPlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ILocalPlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function LocalPlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new LocalPlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ILocalPlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum} LocalPlaceholderFieldEnum instance
                         */
                        LocalPlaceholderFieldEnum.create = function create(properties) {
                            return new LocalPlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified LocalPlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ILocalPlaceholderFieldEnum} message LocalPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocalPlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified LocalPlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ILocalPlaceholderFieldEnum} message LocalPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocalPlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LocalPlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum} LocalPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocalPlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LocalPlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum} LocalPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocalPlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LocalPlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LocalPlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a LocalPlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum} LocalPlaceholderFieldEnum
                         */
                        LocalPlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from a LocalPlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum} message LocalPlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LocalPlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this LocalPlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LocalPlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * LocalPlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum.LocalPlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} DEAL_ID=2 DEAL_ID value
                         * @property {number} DEAL_NAME=3 DEAL_NAME value
                         * @property {number} SUBTITLE=4 SUBTITLE value
                         * @property {number} DESCRIPTION=5 DESCRIPTION value
                         * @property {number} PRICE=6 PRICE value
                         * @property {number} FORMATTED_PRICE=7 FORMATTED_PRICE value
                         * @property {number} SALE_PRICE=8 SALE_PRICE value
                         * @property {number} FORMATTED_SALE_PRICE=9 FORMATTED_SALE_PRICE value
                         * @property {number} IMAGE_URL=10 IMAGE_URL value
                         * @property {number} ADDRESS=11 ADDRESS value
                         * @property {number} CATEGORY=12 CATEGORY value
                         * @property {number} CONTEXTUAL_KEYWORDS=13 CONTEXTUAL_KEYWORDS value
                         * @property {number} FINAL_URLS=14 FINAL_URLS value
                         * @property {number} FINAL_MOBILE_URLS=15 FINAL_MOBILE_URLS value
                         * @property {number} TRACKING_URL=16 TRACKING_URL value
                         * @property {number} ANDROID_APP_LINK=17 ANDROID_APP_LINK value
                         * @property {number} SIMILAR_DEAL_IDS=18 SIMILAR_DEAL_IDS value
                         * @property {number} IOS_APP_LINK=19 IOS_APP_LINK value
                         * @property {number} IOS_APP_STORE_ID=20 IOS_APP_STORE_ID value
                         */
                        LocalPlaceholderFieldEnum.LocalPlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "DEAL_ID"] = 2;
                            values[valuesById[3] = "DEAL_NAME"] = 3;
                            values[valuesById[4] = "SUBTITLE"] = 4;
                            values[valuesById[5] = "DESCRIPTION"] = 5;
                            values[valuesById[6] = "PRICE"] = 6;
                            values[valuesById[7] = "FORMATTED_PRICE"] = 7;
                            values[valuesById[8] = "SALE_PRICE"] = 8;
                            values[valuesById[9] = "FORMATTED_SALE_PRICE"] = 9;
                            values[valuesById[10] = "IMAGE_URL"] = 10;
                            values[valuesById[11] = "ADDRESS"] = 11;
                            values[valuesById[12] = "CATEGORY"] = 12;
                            values[valuesById[13] = "CONTEXTUAL_KEYWORDS"] = 13;
                            values[valuesById[14] = "FINAL_URLS"] = 14;
                            values[valuesById[15] = "FINAL_MOBILE_URLS"] = 15;
                            values[valuesById[16] = "TRACKING_URL"] = 16;
                            values[valuesById[17] = "ANDROID_APP_LINK"] = 17;
                            values[valuesById[18] = "SIMILAR_DEAL_IDS"] = 18;
                            values[valuesById[19] = "IOS_APP_LINK"] = 19;
                            values[valuesById[20] = "IOS_APP_STORE_ID"] = 20;
                            return values;
                        })();

                        return LocalPlaceholderFieldEnum;
                    })();

                    enums.LocationExtensionTargetingCriterionFieldEnum = (function() {

                        /**
                         * Properties of a LocationExtensionTargetingCriterionFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ILocationExtensionTargetingCriterionFieldEnum
                         */

                        /**
                         * Constructs a new LocationExtensionTargetingCriterionFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a LocationExtensionTargetingCriterionFieldEnum.
                         * @implements ILocationExtensionTargetingCriterionFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ILocationExtensionTargetingCriterionFieldEnum=} [properties] Properties to set
                         */
                        function LocationExtensionTargetingCriterionFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new LocationExtensionTargetingCriterionFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ILocationExtensionTargetingCriterionFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum} LocationExtensionTargetingCriterionFieldEnum instance
                         */
                        LocationExtensionTargetingCriterionFieldEnum.create = function create(properties) {
                            return new LocationExtensionTargetingCriterionFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified LocationExtensionTargetingCriterionFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ILocationExtensionTargetingCriterionFieldEnum} message LocationExtensionTargetingCriterionFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationExtensionTargetingCriterionFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified LocationExtensionTargetingCriterionFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ILocationExtensionTargetingCriterionFieldEnum} message LocationExtensionTargetingCriterionFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationExtensionTargetingCriterionFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LocationExtensionTargetingCriterionFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum} LocationExtensionTargetingCriterionFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationExtensionTargetingCriterionFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LocationExtensionTargetingCriterionFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum} LocationExtensionTargetingCriterionFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationExtensionTargetingCriterionFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LocationExtensionTargetingCriterionFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LocationExtensionTargetingCriterionFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a LocationExtensionTargetingCriterionFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum} LocationExtensionTargetingCriterionFieldEnum
                         */
                        LocationExtensionTargetingCriterionFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum();
                        };

                        /**
                         * Creates a plain object from a LocationExtensionTargetingCriterionFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum} message LocationExtensionTargetingCriterionFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LocationExtensionTargetingCriterionFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this LocationExtensionTargetingCriterionFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LocationExtensionTargetingCriterionFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * LocationExtensionTargetingCriterionField enum.
                         * @name google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum.LocationExtensionTargetingCriterionField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ADDRESS_LINE_1=2 ADDRESS_LINE_1 value
                         * @property {number} ADDRESS_LINE_2=3 ADDRESS_LINE_2 value
                         * @property {number} CITY=4 CITY value
                         * @property {number} PROVINCE=5 PROVINCE value
                         * @property {number} POSTAL_CODE=6 POSTAL_CODE value
                         * @property {number} COUNTRY_CODE=7 COUNTRY_CODE value
                         */
                        LocationExtensionTargetingCriterionFieldEnum.LocationExtensionTargetingCriterionField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ADDRESS_LINE_1"] = 2;
                            values[valuesById[3] = "ADDRESS_LINE_2"] = 3;
                            values[valuesById[4] = "CITY"] = 4;
                            values[valuesById[5] = "PROVINCE"] = 5;
                            values[valuesById[6] = "POSTAL_CODE"] = 6;
                            values[valuesById[7] = "COUNTRY_CODE"] = 7;
                            return values;
                        })();

                        return LocationExtensionTargetingCriterionFieldEnum;
                    })();

                    enums.LocationGroupRadiusUnitsEnum = (function() {

                        /**
                         * Properties of a LocationGroupRadiusUnitsEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ILocationGroupRadiusUnitsEnum
                         */

                        /**
                         * Constructs a new LocationGroupRadiusUnitsEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a LocationGroupRadiusUnitsEnum.
                         * @implements ILocationGroupRadiusUnitsEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ILocationGroupRadiusUnitsEnum=} [properties] Properties to set
                         */
                        function LocationGroupRadiusUnitsEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new LocationGroupRadiusUnitsEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ILocationGroupRadiusUnitsEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum} LocationGroupRadiusUnitsEnum instance
                         */
                        LocationGroupRadiusUnitsEnum.create = function create(properties) {
                            return new LocationGroupRadiusUnitsEnum(properties);
                        };

                        /**
                         * Encodes the specified LocationGroupRadiusUnitsEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ILocationGroupRadiusUnitsEnum} message LocationGroupRadiusUnitsEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationGroupRadiusUnitsEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified LocationGroupRadiusUnitsEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ILocationGroupRadiusUnitsEnum} message LocationGroupRadiusUnitsEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationGroupRadiusUnitsEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LocationGroupRadiusUnitsEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum} LocationGroupRadiusUnitsEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationGroupRadiusUnitsEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LocationGroupRadiusUnitsEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum} LocationGroupRadiusUnitsEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationGroupRadiusUnitsEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LocationGroupRadiusUnitsEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LocationGroupRadiusUnitsEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a LocationGroupRadiusUnitsEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum} LocationGroupRadiusUnitsEnum
                         */
                        LocationGroupRadiusUnitsEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum();
                        };

                        /**
                         * Creates a plain object from a LocationGroupRadiusUnitsEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum} message LocationGroupRadiusUnitsEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LocationGroupRadiusUnitsEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this LocationGroupRadiusUnitsEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LocationGroupRadiusUnitsEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * LocationGroupRadiusUnits enum.
                         * @name google.ads.googleads.v1.enums.LocationGroupRadiusUnitsEnum.LocationGroupRadiusUnits
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} METERS=2 METERS value
                         * @property {number} MILES=3 MILES value
                         */
                        LocationGroupRadiusUnitsEnum.LocationGroupRadiusUnits = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "METERS"] = 2;
                            values[valuesById[3] = "MILES"] = 3;
                            return values;
                        })();

                        return LocationGroupRadiusUnitsEnum;
                    })();

                    enums.LocationPlaceholderFieldEnum = (function() {

                        /**
                         * Properties of a LocationPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ILocationPlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new LocationPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a LocationPlaceholderFieldEnum.
                         * @implements ILocationPlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ILocationPlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function LocationPlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new LocationPlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ILocationPlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum} LocationPlaceholderFieldEnum instance
                         */
                        LocationPlaceholderFieldEnum.create = function create(properties) {
                            return new LocationPlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified LocationPlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ILocationPlaceholderFieldEnum} message LocationPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationPlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified LocationPlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ILocationPlaceholderFieldEnum} message LocationPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationPlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LocationPlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum} LocationPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationPlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LocationPlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum} LocationPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationPlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LocationPlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LocationPlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a LocationPlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum} LocationPlaceholderFieldEnum
                         */
                        LocationPlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from a LocationPlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum} message LocationPlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LocationPlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this LocationPlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LocationPlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * LocationPlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum.LocationPlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} BUSINESS_NAME=2 BUSINESS_NAME value
                         * @property {number} ADDRESS_LINE_1=3 ADDRESS_LINE_1 value
                         * @property {number} ADDRESS_LINE_2=4 ADDRESS_LINE_2 value
                         * @property {number} CITY=5 CITY value
                         * @property {number} PROVINCE=6 PROVINCE value
                         * @property {number} POSTAL_CODE=7 POSTAL_CODE value
                         * @property {number} COUNTRY_CODE=8 COUNTRY_CODE value
                         * @property {number} PHONE_NUMBER=9 PHONE_NUMBER value
                         */
                        LocationPlaceholderFieldEnum.LocationPlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "BUSINESS_NAME"] = 2;
                            values[valuesById[3] = "ADDRESS_LINE_1"] = 3;
                            values[valuesById[4] = "ADDRESS_LINE_2"] = 4;
                            values[valuesById[5] = "CITY"] = 5;
                            values[valuesById[6] = "PROVINCE"] = 6;
                            values[valuesById[7] = "POSTAL_CODE"] = 7;
                            values[valuesById[8] = "COUNTRY_CODE"] = 8;
                            values[valuesById[9] = "PHONE_NUMBER"] = 9;
                            return values;
                        })();

                        return LocationPlaceholderFieldEnum;
                    })();

                    enums.ManagerLinkStatusEnum = (function() {

                        /**
                         * Properties of a ManagerLinkStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IManagerLinkStatusEnum
                         */

                        /**
                         * Constructs a new ManagerLinkStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ManagerLinkStatusEnum.
                         * @implements IManagerLinkStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IManagerLinkStatusEnum=} [properties] Properties to set
                         */
                        function ManagerLinkStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ManagerLinkStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ManagerLinkStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IManagerLinkStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ManagerLinkStatusEnum} ManagerLinkStatusEnum instance
                         */
                        ManagerLinkStatusEnum.create = function create(properties) {
                            return new ManagerLinkStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified ManagerLinkStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ManagerLinkStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ManagerLinkStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IManagerLinkStatusEnum} message ManagerLinkStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ManagerLinkStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ManagerLinkStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ManagerLinkStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ManagerLinkStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IManagerLinkStatusEnum} message ManagerLinkStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ManagerLinkStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ManagerLinkStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ManagerLinkStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ManagerLinkStatusEnum} ManagerLinkStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ManagerLinkStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ManagerLinkStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ManagerLinkStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ManagerLinkStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ManagerLinkStatusEnum} ManagerLinkStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ManagerLinkStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ManagerLinkStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ManagerLinkStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ManagerLinkStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ManagerLinkStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ManagerLinkStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ManagerLinkStatusEnum} ManagerLinkStatusEnum
                         */
                        ManagerLinkStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ManagerLinkStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ManagerLinkStatusEnum();
                        };

                        /**
                         * Creates a plain object from a ManagerLinkStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ManagerLinkStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ManagerLinkStatusEnum} message ManagerLinkStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ManagerLinkStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ManagerLinkStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ManagerLinkStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ManagerLinkStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ManagerLinkStatus enum.
                         * @name google.ads.googleads.v1.enums.ManagerLinkStatusEnum.ManagerLinkStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ACTIVE=2 ACTIVE value
                         * @property {number} INACTIVE=3 INACTIVE value
                         * @property {number} PENDING=4 PENDING value
                         * @property {number} REFUSED=5 REFUSED value
                         * @property {number} CANCELED=6 CANCELED value
                         */
                        ManagerLinkStatusEnum.ManagerLinkStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ACTIVE"] = 2;
                            values[valuesById[3] = "INACTIVE"] = 3;
                            values[valuesById[4] = "PENDING"] = 4;
                            values[valuesById[5] = "REFUSED"] = 5;
                            values[valuesById[6] = "CANCELED"] = 6;
                            return values;
                        })();

                        return ManagerLinkStatusEnum;
                    })();

                    enums.MatchingFunctionContextTypeEnum = (function() {

                        /**
                         * Properties of a MatchingFunctionContextTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IMatchingFunctionContextTypeEnum
                         */

                        /**
                         * Constructs a new MatchingFunctionContextTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a MatchingFunctionContextTypeEnum.
                         * @implements IMatchingFunctionContextTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IMatchingFunctionContextTypeEnum=} [properties] Properties to set
                         */
                        function MatchingFunctionContextTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new MatchingFunctionContextTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMatchingFunctionContextTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum} MatchingFunctionContextTypeEnum instance
                         */
                        MatchingFunctionContextTypeEnum.create = function create(properties) {
                            return new MatchingFunctionContextTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified MatchingFunctionContextTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMatchingFunctionContextTypeEnum} message MatchingFunctionContextTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MatchingFunctionContextTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified MatchingFunctionContextTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMatchingFunctionContextTypeEnum} message MatchingFunctionContextTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MatchingFunctionContextTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MatchingFunctionContextTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum} MatchingFunctionContextTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MatchingFunctionContextTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MatchingFunctionContextTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum} MatchingFunctionContextTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MatchingFunctionContextTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MatchingFunctionContextTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MatchingFunctionContextTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a MatchingFunctionContextTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum} MatchingFunctionContextTypeEnum
                         */
                        MatchingFunctionContextTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum();
                        };

                        /**
                         * Creates a plain object from a MatchingFunctionContextTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum} message MatchingFunctionContextTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MatchingFunctionContextTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this MatchingFunctionContextTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MatchingFunctionContextTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * MatchingFunctionContextType enum.
                         * @name google.ads.googleads.v1.enums.MatchingFunctionContextTypeEnum.MatchingFunctionContextType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} FEED_ITEM_ID=2 FEED_ITEM_ID value
                         * @property {number} DEVICE_NAME=3 DEVICE_NAME value
                         */
                        MatchingFunctionContextTypeEnum.MatchingFunctionContextType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "FEED_ITEM_ID"] = 2;
                            values[valuesById[3] = "DEVICE_NAME"] = 3;
                            return values;
                        })();

                        return MatchingFunctionContextTypeEnum;
                    })();

                    enums.MatchingFunctionOperatorEnum = (function() {

                        /**
                         * Properties of a MatchingFunctionOperatorEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IMatchingFunctionOperatorEnum
                         */

                        /**
                         * Constructs a new MatchingFunctionOperatorEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a MatchingFunctionOperatorEnum.
                         * @implements IMatchingFunctionOperatorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IMatchingFunctionOperatorEnum=} [properties] Properties to set
                         */
                        function MatchingFunctionOperatorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new MatchingFunctionOperatorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMatchingFunctionOperatorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum} MatchingFunctionOperatorEnum instance
                         */
                        MatchingFunctionOperatorEnum.create = function create(properties) {
                            return new MatchingFunctionOperatorEnum(properties);
                        };

                        /**
                         * Encodes the specified MatchingFunctionOperatorEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMatchingFunctionOperatorEnum} message MatchingFunctionOperatorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MatchingFunctionOperatorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified MatchingFunctionOperatorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMatchingFunctionOperatorEnum} message MatchingFunctionOperatorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MatchingFunctionOperatorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MatchingFunctionOperatorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum} MatchingFunctionOperatorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MatchingFunctionOperatorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MatchingFunctionOperatorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum} MatchingFunctionOperatorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MatchingFunctionOperatorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MatchingFunctionOperatorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MatchingFunctionOperatorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a MatchingFunctionOperatorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum} MatchingFunctionOperatorEnum
                         */
                        MatchingFunctionOperatorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum();
                        };

                        /**
                         * Creates a plain object from a MatchingFunctionOperatorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum} message MatchingFunctionOperatorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MatchingFunctionOperatorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this MatchingFunctionOperatorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MatchingFunctionOperatorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * MatchingFunctionOperator enum.
                         * @name google.ads.googleads.v1.enums.MatchingFunctionOperatorEnum.MatchingFunctionOperator
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} IN=2 IN value
                         * @property {number} IDENTITY=3 IDENTITY value
                         * @property {number} EQUALS=4 EQUALS value
                         * @property {number} AND=5 AND value
                         * @property {number} CONTAINS_ANY=6 CONTAINS_ANY value
                         */
                        MatchingFunctionOperatorEnum.MatchingFunctionOperator = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "IN"] = 2;
                            values[valuesById[3] = "IDENTITY"] = 3;
                            values[valuesById[4] = "EQUALS"] = 4;
                            values[valuesById[5] = "AND"] = 5;
                            values[valuesById[6] = "CONTAINS_ANY"] = 6;
                            return values;
                        })();

                        return MatchingFunctionOperatorEnum;
                    })();

                    enums.MediaTypeEnum = (function() {

                        /**
                         * Properties of a MediaTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IMediaTypeEnum
                         */

                        /**
                         * Constructs a new MediaTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a MediaTypeEnum.
                         * @implements IMediaTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IMediaTypeEnum=} [properties] Properties to set
                         */
                        function MediaTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new MediaTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.MediaTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMediaTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.MediaTypeEnum} MediaTypeEnum instance
                         */
                        MediaTypeEnum.create = function create(properties) {
                            return new MediaTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified MediaTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.MediaTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.MediaTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMediaTypeEnum} message MediaTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified MediaTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.MediaTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MediaTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMediaTypeEnum} message MediaTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MediaTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.MediaTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.MediaTypeEnum} MediaTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.MediaTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MediaTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MediaTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.MediaTypeEnum} MediaTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MediaTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.MediaTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MediaTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a MediaTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.MediaTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.MediaTypeEnum} MediaTypeEnum
                         */
                        MediaTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.MediaTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.MediaTypeEnum();
                        };

                        /**
                         * Creates a plain object from a MediaTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.MediaTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.MediaTypeEnum} message MediaTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MediaTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this MediaTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.MediaTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MediaTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * MediaType enum.
                         * @name google.ads.googleads.v1.enums.MediaTypeEnum.MediaType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} IMAGE=2 IMAGE value
                         * @property {number} ICON=3 ICON value
                         * @property {number} MEDIA_BUNDLE=4 MEDIA_BUNDLE value
                         * @property {number} AUDIO=5 AUDIO value
                         * @property {number} VIDEO=6 VIDEO value
                         * @property {number} DYNAMIC_IMAGE=7 DYNAMIC_IMAGE value
                         */
                        MediaTypeEnum.MediaType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "IMAGE"] = 2;
                            values[valuesById[3] = "ICON"] = 3;
                            values[valuesById[4] = "MEDIA_BUNDLE"] = 4;
                            values[valuesById[5] = "AUDIO"] = 5;
                            values[valuesById[6] = "VIDEO"] = 6;
                            values[valuesById[7] = "DYNAMIC_IMAGE"] = 7;
                            return values;
                        })();

                        return MediaTypeEnum;
                    })();

                    enums.MerchantCenterLinkStatusEnum = (function() {

                        /**
                         * Properties of a MerchantCenterLinkStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IMerchantCenterLinkStatusEnum
                         */

                        /**
                         * Constructs a new MerchantCenterLinkStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a MerchantCenterLinkStatusEnum.
                         * @implements IMerchantCenterLinkStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IMerchantCenterLinkStatusEnum=} [properties] Properties to set
                         */
                        function MerchantCenterLinkStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new MerchantCenterLinkStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMerchantCenterLinkStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum} MerchantCenterLinkStatusEnum instance
                         */
                        MerchantCenterLinkStatusEnum.create = function create(properties) {
                            return new MerchantCenterLinkStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified MerchantCenterLinkStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMerchantCenterLinkStatusEnum} message MerchantCenterLinkStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MerchantCenterLinkStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified MerchantCenterLinkStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMerchantCenterLinkStatusEnum} message MerchantCenterLinkStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MerchantCenterLinkStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MerchantCenterLinkStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum} MerchantCenterLinkStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MerchantCenterLinkStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MerchantCenterLinkStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum} MerchantCenterLinkStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MerchantCenterLinkStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MerchantCenterLinkStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MerchantCenterLinkStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a MerchantCenterLinkStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum} MerchantCenterLinkStatusEnum
                         */
                        MerchantCenterLinkStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum();
                        };

                        /**
                         * Creates a plain object from a MerchantCenterLinkStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum} message MerchantCenterLinkStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MerchantCenterLinkStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this MerchantCenterLinkStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MerchantCenterLinkStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * MerchantCenterLinkStatus enum.
                         * @name google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum.MerchantCenterLinkStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENABLED=2 ENABLED value
                         * @property {number} PENDING=3 PENDING value
                         */
                        MerchantCenterLinkStatusEnum.MerchantCenterLinkStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENABLED"] = 2;
                            values[valuesById[3] = "PENDING"] = 3;
                            return values;
                        })();

                        return MerchantCenterLinkStatusEnum;
                    })();

                    enums.MessagePlaceholderFieldEnum = (function() {

                        /**
                         * Properties of a MessagePlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IMessagePlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new MessagePlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a MessagePlaceholderFieldEnum.
                         * @implements IMessagePlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IMessagePlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function MessagePlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new MessagePlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMessagePlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum} MessagePlaceholderFieldEnum instance
                         */
                        MessagePlaceholderFieldEnum.create = function create(properties) {
                            return new MessagePlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified MessagePlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMessagePlaceholderFieldEnum} message MessagePlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MessagePlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified MessagePlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMessagePlaceholderFieldEnum} message MessagePlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MessagePlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MessagePlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum} MessagePlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MessagePlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MessagePlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum} MessagePlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MessagePlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MessagePlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MessagePlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a MessagePlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum} MessagePlaceholderFieldEnum
                         */
                        MessagePlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from a MessagePlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum} message MessagePlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MessagePlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this MessagePlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MessagePlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * MessagePlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum.MessagePlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} BUSINESS_NAME=2 BUSINESS_NAME value
                         * @property {number} COUNTRY_CODE=3 COUNTRY_CODE value
                         * @property {number} PHONE_NUMBER=4 PHONE_NUMBER value
                         * @property {number} MESSAGE_EXTENSION_TEXT=5 MESSAGE_EXTENSION_TEXT value
                         * @property {number} MESSAGE_TEXT=6 MESSAGE_TEXT value
                         */
                        MessagePlaceholderFieldEnum.MessagePlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "BUSINESS_NAME"] = 2;
                            values[valuesById[3] = "COUNTRY_CODE"] = 3;
                            values[valuesById[4] = "PHONE_NUMBER"] = 4;
                            values[valuesById[5] = "MESSAGE_EXTENSION_TEXT"] = 5;
                            values[valuesById[6] = "MESSAGE_TEXT"] = 6;
                            return values;
                        })();

                        return MessagePlaceholderFieldEnum;
                    })();

                    enums.MimeTypeEnum = (function() {

                        /**
                         * Properties of a MimeTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IMimeTypeEnum
                         */

                        /**
                         * Constructs a new MimeTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a MimeTypeEnum.
                         * @implements IMimeTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IMimeTypeEnum=} [properties] Properties to set
                         */
                        function MimeTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new MimeTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.MimeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMimeTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.MimeTypeEnum} MimeTypeEnum instance
                         */
                        MimeTypeEnum.create = function create(properties) {
                            return new MimeTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified MimeTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.MimeTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.MimeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMimeTypeEnum} message MimeTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MimeTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified MimeTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.MimeTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MimeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMimeTypeEnum} message MimeTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MimeTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MimeTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.MimeTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.MimeTypeEnum} MimeTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MimeTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.MimeTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MimeTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MimeTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.MimeTypeEnum} MimeTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MimeTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MimeTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.MimeTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MimeTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a MimeTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.MimeTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.MimeTypeEnum} MimeTypeEnum
                         */
                        MimeTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.MimeTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.MimeTypeEnum();
                        };

                        /**
                         * Creates a plain object from a MimeTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.MimeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.MimeTypeEnum} message MimeTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MimeTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this MimeTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.MimeTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MimeTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * MimeType enum.
                         * @name google.ads.googleads.v1.enums.MimeTypeEnum.MimeType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} IMAGE_JPEG=2 IMAGE_JPEG value
                         * @property {number} IMAGE_GIF=3 IMAGE_GIF value
                         * @property {number} IMAGE_PNG=4 IMAGE_PNG value
                         * @property {number} FLASH=5 FLASH value
                         * @property {number} TEXT_HTML=6 TEXT_HTML value
                         * @property {number} PDF=7 PDF value
                         * @property {number} MSWORD=8 MSWORD value
                         * @property {number} MSEXCEL=9 MSEXCEL value
                         * @property {number} RTF=10 RTF value
                         * @property {number} AUDIO_WAV=11 AUDIO_WAV value
                         * @property {number} AUDIO_MP3=12 AUDIO_MP3 value
                         * @property {number} HTML5_AD_ZIP=13 HTML5_AD_ZIP value
                         */
                        MimeTypeEnum.MimeType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "IMAGE_JPEG"] = 2;
                            values[valuesById[3] = "IMAGE_GIF"] = 3;
                            values[valuesById[4] = "IMAGE_PNG"] = 4;
                            values[valuesById[5] = "FLASH"] = 5;
                            values[valuesById[6] = "TEXT_HTML"] = 6;
                            values[valuesById[7] = "PDF"] = 7;
                            values[valuesById[8] = "MSWORD"] = 8;
                            values[valuesById[9] = "MSEXCEL"] = 9;
                            values[valuesById[10] = "RTF"] = 10;
                            values[valuesById[11] = "AUDIO_WAV"] = 11;
                            values[valuesById[12] = "AUDIO_MP3"] = 12;
                            values[valuesById[13] = "HTML5_AD_ZIP"] = 13;
                            return values;
                        })();

                        return MimeTypeEnum;
                    })();

                    enums.MinuteOfHourEnum = (function() {

                        /**
                         * Properties of a MinuteOfHourEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IMinuteOfHourEnum
                         */

                        /**
                         * Constructs a new MinuteOfHourEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a MinuteOfHourEnum.
                         * @implements IMinuteOfHourEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IMinuteOfHourEnum=} [properties] Properties to set
                         */
                        function MinuteOfHourEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new MinuteOfHourEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.MinuteOfHourEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMinuteOfHourEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.MinuteOfHourEnum} MinuteOfHourEnum instance
                         */
                        MinuteOfHourEnum.create = function create(properties) {
                            return new MinuteOfHourEnum(properties);
                        };

                        /**
                         * Encodes the specified MinuteOfHourEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.MinuteOfHourEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.MinuteOfHourEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMinuteOfHourEnum} message MinuteOfHourEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MinuteOfHourEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified MinuteOfHourEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.MinuteOfHourEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MinuteOfHourEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMinuteOfHourEnum} message MinuteOfHourEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MinuteOfHourEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MinuteOfHourEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.MinuteOfHourEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.MinuteOfHourEnum} MinuteOfHourEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MinuteOfHourEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.MinuteOfHourEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MinuteOfHourEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MinuteOfHourEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.MinuteOfHourEnum} MinuteOfHourEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MinuteOfHourEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MinuteOfHourEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.MinuteOfHourEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MinuteOfHourEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a MinuteOfHourEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.MinuteOfHourEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.MinuteOfHourEnum} MinuteOfHourEnum
                         */
                        MinuteOfHourEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.MinuteOfHourEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.MinuteOfHourEnum();
                        };

                        /**
                         * Creates a plain object from a MinuteOfHourEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.MinuteOfHourEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.MinuteOfHourEnum} message MinuteOfHourEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MinuteOfHourEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this MinuteOfHourEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.MinuteOfHourEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MinuteOfHourEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * MinuteOfHour enum.
                         * @name google.ads.googleads.v1.enums.MinuteOfHourEnum.MinuteOfHour
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ZERO=2 ZERO value
                         * @property {number} FIFTEEN=3 FIFTEEN value
                         * @property {number} THIRTY=4 THIRTY value
                         * @property {number} FORTY_FIVE=5 FORTY_FIVE value
                         */
                        MinuteOfHourEnum.MinuteOfHour = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ZERO"] = 2;
                            values[valuesById[3] = "FIFTEEN"] = 3;
                            values[valuesById[4] = "THIRTY"] = 4;
                            values[valuesById[5] = "FORTY_FIVE"] = 5;
                            return values;
                        })();

                        return MinuteOfHourEnum;
                    })();

                    enums.MobileDeviceTypeEnum = (function() {

                        /**
                         * Properties of a MobileDeviceTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IMobileDeviceTypeEnum
                         */

                        /**
                         * Constructs a new MobileDeviceTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a MobileDeviceTypeEnum.
                         * @implements IMobileDeviceTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IMobileDeviceTypeEnum=} [properties] Properties to set
                         */
                        function MobileDeviceTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new MobileDeviceTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.MobileDeviceTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMobileDeviceTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.MobileDeviceTypeEnum} MobileDeviceTypeEnum instance
                         */
                        MobileDeviceTypeEnum.create = function create(properties) {
                            return new MobileDeviceTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified MobileDeviceTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.MobileDeviceTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.MobileDeviceTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMobileDeviceTypeEnum} message MobileDeviceTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MobileDeviceTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified MobileDeviceTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.MobileDeviceTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MobileDeviceTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMobileDeviceTypeEnum} message MobileDeviceTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MobileDeviceTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MobileDeviceTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.MobileDeviceTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.MobileDeviceTypeEnum} MobileDeviceTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MobileDeviceTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.MobileDeviceTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MobileDeviceTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MobileDeviceTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.MobileDeviceTypeEnum} MobileDeviceTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MobileDeviceTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MobileDeviceTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.MobileDeviceTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MobileDeviceTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a MobileDeviceTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.MobileDeviceTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.MobileDeviceTypeEnum} MobileDeviceTypeEnum
                         */
                        MobileDeviceTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.MobileDeviceTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.MobileDeviceTypeEnum();
                        };

                        /**
                         * Creates a plain object from a MobileDeviceTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.MobileDeviceTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.MobileDeviceTypeEnum} message MobileDeviceTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MobileDeviceTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this MobileDeviceTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.MobileDeviceTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MobileDeviceTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * MobileDeviceType enum.
                         * @name google.ads.googleads.v1.enums.MobileDeviceTypeEnum.MobileDeviceType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} MOBILE=2 MOBILE value
                         * @property {number} TABLET=3 TABLET value
                         */
                        MobileDeviceTypeEnum.MobileDeviceType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "MOBILE"] = 2;
                            values[valuesById[3] = "TABLET"] = 3;
                            return values;
                        })();

                        return MobileDeviceTypeEnum;
                    })();

                    enums.MonthOfYearEnum = (function() {

                        /**
                         * Properties of a MonthOfYearEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IMonthOfYearEnum
                         */

                        /**
                         * Constructs a new MonthOfYearEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a MonthOfYearEnum.
                         * @implements IMonthOfYearEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IMonthOfYearEnum=} [properties] Properties to set
                         */
                        function MonthOfYearEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new MonthOfYearEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.MonthOfYearEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMonthOfYearEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.MonthOfYearEnum} MonthOfYearEnum instance
                         */
                        MonthOfYearEnum.create = function create(properties) {
                            return new MonthOfYearEnum(properties);
                        };

                        /**
                         * Encodes the specified MonthOfYearEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.MonthOfYearEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.MonthOfYearEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMonthOfYearEnum} message MonthOfYearEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MonthOfYearEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified MonthOfYearEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.MonthOfYearEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MonthOfYearEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMonthOfYearEnum} message MonthOfYearEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MonthOfYearEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MonthOfYearEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.MonthOfYearEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.MonthOfYearEnum} MonthOfYearEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MonthOfYearEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.MonthOfYearEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MonthOfYearEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MonthOfYearEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.MonthOfYearEnum} MonthOfYearEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MonthOfYearEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MonthOfYearEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.MonthOfYearEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MonthOfYearEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a MonthOfYearEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.MonthOfYearEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.MonthOfYearEnum} MonthOfYearEnum
                         */
                        MonthOfYearEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.MonthOfYearEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.MonthOfYearEnum();
                        };

                        /**
                         * Creates a plain object from a MonthOfYearEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.MonthOfYearEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.MonthOfYearEnum} message MonthOfYearEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MonthOfYearEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this MonthOfYearEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.MonthOfYearEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MonthOfYearEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * MonthOfYear enum.
                         * @name google.ads.googleads.v1.enums.MonthOfYearEnum.MonthOfYear
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} JANUARY=2 JANUARY value
                         * @property {number} FEBRUARY=3 FEBRUARY value
                         * @property {number} MARCH=4 MARCH value
                         * @property {number} APRIL=5 APRIL value
                         * @property {number} MAY=6 MAY value
                         * @property {number} JUNE=7 JUNE value
                         * @property {number} JULY=8 JULY value
                         * @property {number} AUGUST=9 AUGUST value
                         * @property {number} SEPTEMBER=10 SEPTEMBER value
                         * @property {number} OCTOBER=11 OCTOBER value
                         * @property {number} NOVEMBER=12 NOVEMBER value
                         * @property {number} DECEMBER=13 DECEMBER value
                         */
                        MonthOfYearEnum.MonthOfYear = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "JANUARY"] = 2;
                            values[valuesById[3] = "FEBRUARY"] = 3;
                            values[valuesById[4] = "MARCH"] = 4;
                            values[valuesById[5] = "APRIL"] = 5;
                            values[valuesById[6] = "MAY"] = 6;
                            values[valuesById[7] = "JUNE"] = 7;
                            values[valuesById[8] = "JULY"] = 8;
                            values[valuesById[9] = "AUGUST"] = 9;
                            values[valuesById[10] = "SEPTEMBER"] = 10;
                            values[valuesById[11] = "OCTOBER"] = 11;
                            values[valuesById[12] = "NOVEMBER"] = 12;
                            values[valuesById[13] = "DECEMBER"] = 13;
                            return values;
                        })();

                        return MonthOfYearEnum;
                    })();

                    enums.MutateJobStatusEnum = (function() {

                        /**
                         * Properties of a MutateJobStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IMutateJobStatusEnum
                         */

                        /**
                         * Constructs a new MutateJobStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a MutateJobStatusEnum.
                         * @implements IMutateJobStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IMutateJobStatusEnum=} [properties] Properties to set
                         */
                        function MutateJobStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new MutateJobStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.MutateJobStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMutateJobStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.MutateJobStatusEnum} MutateJobStatusEnum instance
                         */
                        MutateJobStatusEnum.create = function create(properties) {
                            return new MutateJobStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified MutateJobStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.MutateJobStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.MutateJobStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMutateJobStatusEnum} message MutateJobStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateJobStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateJobStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.MutateJobStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MutateJobStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IMutateJobStatusEnum} message MutateJobStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateJobStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateJobStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.MutateJobStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.MutateJobStatusEnum} MutateJobStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateJobStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.MutateJobStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateJobStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.MutateJobStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.MutateJobStatusEnum} MutateJobStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateJobStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateJobStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.MutateJobStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateJobStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a MutateJobStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.MutateJobStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.MutateJobStatusEnum} MutateJobStatusEnum
                         */
                        MutateJobStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.MutateJobStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.MutateJobStatusEnum();
                        };

                        /**
                         * Creates a plain object from a MutateJobStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.MutateJobStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.MutateJobStatusEnum} message MutateJobStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateJobStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this MutateJobStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.MutateJobStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateJobStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * MutateJobStatus enum.
                         * @name google.ads.googleads.v1.enums.MutateJobStatusEnum.MutateJobStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} PENDING=2 PENDING value
                         * @property {number} RUNNING=3 RUNNING value
                         * @property {number} DONE=4 DONE value
                         */
                        MutateJobStatusEnum.MutateJobStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "PENDING"] = 2;
                            values[valuesById[3] = "RUNNING"] = 3;
                            values[valuesById[4] = "DONE"] = 4;
                            return values;
                        })();

                        return MutateJobStatusEnum;
                    })();

                    enums.NegativeGeoTargetTypeEnum = (function() {

                        /**
                         * Properties of a NegativeGeoTargetTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface INegativeGeoTargetTypeEnum
                         */

                        /**
                         * Constructs a new NegativeGeoTargetTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a NegativeGeoTargetTypeEnum.
                         * @implements INegativeGeoTargetTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.INegativeGeoTargetTypeEnum=} [properties] Properties to set
                         */
                        function NegativeGeoTargetTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new NegativeGeoTargetTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.INegativeGeoTargetTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum} NegativeGeoTargetTypeEnum instance
                         */
                        NegativeGeoTargetTypeEnum.create = function create(properties) {
                            return new NegativeGeoTargetTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified NegativeGeoTargetTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.INegativeGeoTargetTypeEnum} message NegativeGeoTargetTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NegativeGeoTargetTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified NegativeGeoTargetTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.INegativeGeoTargetTypeEnum} message NegativeGeoTargetTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NegativeGeoTargetTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a NegativeGeoTargetTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum} NegativeGeoTargetTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NegativeGeoTargetTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a NegativeGeoTargetTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum} NegativeGeoTargetTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NegativeGeoTargetTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a NegativeGeoTargetTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NegativeGeoTargetTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a NegativeGeoTargetTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum} NegativeGeoTargetTypeEnum
                         */
                        NegativeGeoTargetTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum();
                        };

                        /**
                         * Creates a plain object from a NegativeGeoTargetTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum} message NegativeGeoTargetTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NegativeGeoTargetTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this NegativeGeoTargetTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NegativeGeoTargetTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * NegativeGeoTargetType enum.
                         * @name google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum.NegativeGeoTargetType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} DONT_CARE=2 DONT_CARE value
                         * @property {number} LOCATION_OF_PRESENCE=3 LOCATION_OF_PRESENCE value
                         */
                        NegativeGeoTargetTypeEnum.NegativeGeoTargetType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "DONT_CARE"] = 2;
                            values[valuesById[3] = "LOCATION_OF_PRESENCE"] = 3;
                            return values;
                        })();

                        return NegativeGeoTargetTypeEnum;
                    })();

                    enums.OperatingSystemVersionOperatorTypeEnum = (function() {

                        /**
                         * Properties of an OperatingSystemVersionOperatorTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IOperatingSystemVersionOperatorTypeEnum
                         */

                        /**
                         * Constructs a new OperatingSystemVersionOperatorTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents an OperatingSystemVersionOperatorTypeEnum.
                         * @implements IOperatingSystemVersionOperatorTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IOperatingSystemVersionOperatorTypeEnum=} [properties] Properties to set
                         */
                        function OperatingSystemVersionOperatorTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new OperatingSystemVersionOperatorTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IOperatingSystemVersionOperatorTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum} OperatingSystemVersionOperatorTypeEnum instance
                         */
                        OperatingSystemVersionOperatorTypeEnum.create = function create(properties) {
                            return new OperatingSystemVersionOperatorTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified OperatingSystemVersionOperatorTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IOperatingSystemVersionOperatorTypeEnum} message OperatingSystemVersionOperatorTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        OperatingSystemVersionOperatorTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified OperatingSystemVersionOperatorTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IOperatingSystemVersionOperatorTypeEnum} message OperatingSystemVersionOperatorTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        OperatingSystemVersionOperatorTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an OperatingSystemVersionOperatorTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum} OperatingSystemVersionOperatorTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        OperatingSystemVersionOperatorTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an OperatingSystemVersionOperatorTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum} OperatingSystemVersionOperatorTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        OperatingSystemVersionOperatorTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an OperatingSystemVersionOperatorTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        OperatingSystemVersionOperatorTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates an OperatingSystemVersionOperatorTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum} OperatingSystemVersionOperatorTypeEnum
                         */
                        OperatingSystemVersionOperatorTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum();
                        };

                        /**
                         * Creates a plain object from an OperatingSystemVersionOperatorTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum} message OperatingSystemVersionOperatorTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        OperatingSystemVersionOperatorTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this OperatingSystemVersionOperatorTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        OperatingSystemVersionOperatorTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * OperatingSystemVersionOperatorType enum.
                         * @name google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum.OperatingSystemVersionOperatorType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} EQUALS_TO=2 EQUALS_TO value
                         * @property {number} GREATER_THAN_EQUALS_TO=4 GREATER_THAN_EQUALS_TO value
                         */
                        OperatingSystemVersionOperatorTypeEnum.OperatingSystemVersionOperatorType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "EQUALS_TO"] = 2;
                            values[valuesById[4] = "GREATER_THAN_EQUALS_TO"] = 4;
                            return values;
                        })();

                        return OperatingSystemVersionOperatorTypeEnum;
                    })();

                    enums.PageOnePromotedStrategyGoalEnum = (function() {

                        /**
                         * Properties of a PageOnePromotedStrategyGoalEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IPageOnePromotedStrategyGoalEnum
                         */

                        /**
                         * Constructs a new PageOnePromotedStrategyGoalEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a PageOnePromotedStrategyGoalEnum.
                         * @implements IPageOnePromotedStrategyGoalEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IPageOnePromotedStrategyGoalEnum=} [properties] Properties to set
                         */
                        function PageOnePromotedStrategyGoalEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PageOnePromotedStrategyGoalEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPageOnePromotedStrategyGoalEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum} PageOnePromotedStrategyGoalEnum instance
                         */
                        PageOnePromotedStrategyGoalEnum.create = function create(properties) {
                            return new PageOnePromotedStrategyGoalEnum(properties);
                        };

                        /**
                         * Encodes the specified PageOnePromotedStrategyGoalEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPageOnePromotedStrategyGoalEnum} message PageOnePromotedStrategyGoalEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PageOnePromotedStrategyGoalEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PageOnePromotedStrategyGoalEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPageOnePromotedStrategyGoalEnum} message PageOnePromotedStrategyGoalEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PageOnePromotedStrategyGoalEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PageOnePromotedStrategyGoalEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum} PageOnePromotedStrategyGoalEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PageOnePromotedStrategyGoalEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PageOnePromotedStrategyGoalEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum} PageOnePromotedStrategyGoalEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PageOnePromotedStrategyGoalEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PageOnePromotedStrategyGoalEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PageOnePromotedStrategyGoalEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PageOnePromotedStrategyGoalEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum} PageOnePromotedStrategyGoalEnum
                         */
                        PageOnePromotedStrategyGoalEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum();
                        };

                        /**
                         * Creates a plain object from a PageOnePromotedStrategyGoalEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum} message PageOnePromotedStrategyGoalEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PageOnePromotedStrategyGoalEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PageOnePromotedStrategyGoalEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PageOnePromotedStrategyGoalEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PageOnePromotedStrategyGoal enum.
                         * @name google.ads.googleads.v1.enums.PageOnePromotedStrategyGoalEnum.PageOnePromotedStrategyGoal
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} FIRST_PAGE=2 FIRST_PAGE value
                         * @property {number} FIRST_PAGE_PROMOTED=3 FIRST_PAGE_PROMOTED value
                         */
                        PageOnePromotedStrategyGoalEnum.PageOnePromotedStrategyGoal = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "FIRST_PAGE"] = 2;
                            values[valuesById[3] = "FIRST_PAGE_PROMOTED"] = 3;
                            return values;
                        })();

                        return PageOnePromotedStrategyGoalEnum;
                    })();

                    enums.ParentalStatusTypeEnum = (function() {

                        /**
                         * Properties of a ParentalStatusTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IParentalStatusTypeEnum
                         */

                        /**
                         * Constructs a new ParentalStatusTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ParentalStatusTypeEnum.
                         * @implements IParentalStatusTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IParentalStatusTypeEnum=} [properties] Properties to set
                         */
                        function ParentalStatusTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ParentalStatusTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ParentalStatusTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IParentalStatusTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ParentalStatusTypeEnum} ParentalStatusTypeEnum instance
                         */
                        ParentalStatusTypeEnum.create = function create(properties) {
                            return new ParentalStatusTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified ParentalStatusTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ParentalStatusTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ParentalStatusTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IParentalStatusTypeEnum} message ParentalStatusTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ParentalStatusTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ParentalStatusTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ParentalStatusTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ParentalStatusTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IParentalStatusTypeEnum} message ParentalStatusTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ParentalStatusTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ParentalStatusTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ParentalStatusTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ParentalStatusTypeEnum} ParentalStatusTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ParentalStatusTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ParentalStatusTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ParentalStatusTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ParentalStatusTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ParentalStatusTypeEnum} ParentalStatusTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ParentalStatusTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ParentalStatusTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ParentalStatusTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ParentalStatusTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ParentalStatusTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ParentalStatusTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ParentalStatusTypeEnum} ParentalStatusTypeEnum
                         */
                        ParentalStatusTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ParentalStatusTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ParentalStatusTypeEnum();
                        };

                        /**
                         * Creates a plain object from a ParentalStatusTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ParentalStatusTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ParentalStatusTypeEnum} message ParentalStatusTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ParentalStatusTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ParentalStatusTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ParentalStatusTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ParentalStatusTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ParentalStatusType enum.
                         * @name google.ads.googleads.v1.enums.ParentalStatusTypeEnum.ParentalStatusType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} PARENT=300 PARENT value
                         * @property {number} NOT_A_PARENT=301 NOT_A_PARENT value
                         * @property {number} UNDETERMINED=302 UNDETERMINED value
                         */
                        ParentalStatusTypeEnum.ParentalStatusType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[300] = "PARENT"] = 300;
                            values[valuesById[301] = "NOT_A_PARENT"] = 301;
                            values[valuesById[302] = "UNDETERMINED"] = 302;
                            return values;
                        })();

                        return ParentalStatusTypeEnum;
                    })();

                    enums.PaymentModeEnum = (function() {

                        /**
                         * Properties of a PaymentModeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IPaymentModeEnum
                         */

                        /**
                         * Constructs a new PaymentModeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a PaymentModeEnum.
                         * @implements IPaymentModeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IPaymentModeEnum=} [properties] Properties to set
                         */
                        function PaymentModeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PaymentModeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.PaymentModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPaymentModeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.PaymentModeEnum} PaymentModeEnum instance
                         */
                        PaymentModeEnum.create = function create(properties) {
                            return new PaymentModeEnum(properties);
                        };

                        /**
                         * Encodes the specified PaymentModeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.PaymentModeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.PaymentModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPaymentModeEnum} message PaymentModeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PaymentModeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PaymentModeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.PaymentModeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PaymentModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPaymentModeEnum} message PaymentModeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PaymentModeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PaymentModeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.PaymentModeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.PaymentModeEnum} PaymentModeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PaymentModeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.PaymentModeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PaymentModeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PaymentModeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.PaymentModeEnum} PaymentModeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PaymentModeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PaymentModeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.PaymentModeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PaymentModeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PaymentModeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.PaymentModeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.PaymentModeEnum} PaymentModeEnum
                         */
                        PaymentModeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.PaymentModeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.PaymentModeEnum();
                        };

                        /**
                         * Creates a plain object from a PaymentModeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.PaymentModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.PaymentModeEnum} message PaymentModeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PaymentModeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PaymentModeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.PaymentModeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PaymentModeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PaymentMode enum.
                         * @name google.ads.googleads.v1.enums.PaymentModeEnum.PaymentMode
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CLICKS=4 CLICKS value
                         * @property {number} CONVERSION_VALUE=5 CONVERSION_VALUE value
                         * @property {number} CONVERSIONS=6 CONVERSIONS value
                         */
                        PaymentModeEnum.PaymentMode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[4] = "CLICKS"] = 4;
                            values[valuesById[5] = "CONVERSION_VALUE"] = 5;
                            values[valuesById[6] = "CONVERSIONS"] = 6;
                            return values;
                        })();

                        return PaymentModeEnum;
                    })();

                    enums.PlaceholderTypeEnum = (function() {

                        /**
                         * Properties of a PlaceholderTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IPlaceholderTypeEnum
                         */

                        /**
                         * Constructs a new PlaceholderTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a PlaceholderTypeEnum.
                         * @implements IPlaceholderTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IPlaceholderTypeEnum=} [properties] Properties to set
                         */
                        function PlaceholderTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PlaceholderTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.PlaceholderTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPlaceholderTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.PlaceholderTypeEnum} PlaceholderTypeEnum instance
                         */
                        PlaceholderTypeEnum.create = function create(properties) {
                            return new PlaceholderTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified PlaceholderTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.PlaceholderTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.PlaceholderTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPlaceholderTypeEnum} message PlaceholderTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PlaceholderTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PlaceholderTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.PlaceholderTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PlaceholderTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPlaceholderTypeEnum} message PlaceholderTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PlaceholderTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PlaceholderTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.PlaceholderTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.PlaceholderTypeEnum} PlaceholderTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PlaceholderTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.PlaceholderTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PlaceholderTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PlaceholderTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.PlaceholderTypeEnum} PlaceholderTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PlaceholderTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PlaceholderTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.PlaceholderTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PlaceholderTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PlaceholderTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.PlaceholderTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.PlaceholderTypeEnum} PlaceholderTypeEnum
                         */
                        PlaceholderTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.PlaceholderTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.PlaceholderTypeEnum();
                        };

                        /**
                         * Creates a plain object from a PlaceholderTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.PlaceholderTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.PlaceholderTypeEnum} message PlaceholderTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PlaceholderTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PlaceholderTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.PlaceholderTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PlaceholderTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PlaceholderType enum.
                         * @name google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} SITELINK=2 SITELINK value
                         * @property {number} CALL=3 CALL value
                         * @property {number} APP=4 APP value
                         * @property {number} LOCATION=5 LOCATION value
                         * @property {number} AFFILIATE_LOCATION=6 AFFILIATE_LOCATION value
                         * @property {number} CALLOUT=7 CALLOUT value
                         * @property {number} STRUCTURED_SNIPPET=8 STRUCTURED_SNIPPET value
                         * @property {number} MESSAGE=9 MESSAGE value
                         * @property {number} PRICE=10 PRICE value
                         * @property {number} PROMOTION=11 PROMOTION value
                         * @property {number} AD_CUSTOMIZER=12 AD_CUSTOMIZER value
                         * @property {number} DYNAMIC_EDUCATION=13 DYNAMIC_EDUCATION value
                         * @property {number} DYNAMIC_FLIGHT=14 DYNAMIC_FLIGHT value
                         * @property {number} DYNAMIC_CUSTOM=15 DYNAMIC_CUSTOM value
                         * @property {number} DYNAMIC_HOTEL=16 DYNAMIC_HOTEL value
                         * @property {number} DYNAMIC_REAL_ESTATE=17 DYNAMIC_REAL_ESTATE value
                         * @property {number} DYNAMIC_TRAVEL=18 DYNAMIC_TRAVEL value
                         * @property {number} DYNAMIC_LOCAL=19 DYNAMIC_LOCAL value
                         * @property {number} DYNAMIC_JOB=20 DYNAMIC_JOB value
                         */
                        PlaceholderTypeEnum.PlaceholderType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "SITELINK"] = 2;
                            values[valuesById[3] = "CALL"] = 3;
                            values[valuesById[4] = "APP"] = 4;
                            values[valuesById[5] = "LOCATION"] = 5;
                            values[valuesById[6] = "AFFILIATE_LOCATION"] = 6;
                            values[valuesById[7] = "CALLOUT"] = 7;
                            values[valuesById[8] = "STRUCTURED_SNIPPET"] = 8;
                            values[valuesById[9] = "MESSAGE"] = 9;
                            values[valuesById[10] = "PRICE"] = 10;
                            values[valuesById[11] = "PROMOTION"] = 11;
                            values[valuesById[12] = "AD_CUSTOMIZER"] = 12;
                            values[valuesById[13] = "DYNAMIC_EDUCATION"] = 13;
                            values[valuesById[14] = "DYNAMIC_FLIGHT"] = 14;
                            values[valuesById[15] = "DYNAMIC_CUSTOM"] = 15;
                            values[valuesById[16] = "DYNAMIC_HOTEL"] = 16;
                            values[valuesById[17] = "DYNAMIC_REAL_ESTATE"] = 17;
                            values[valuesById[18] = "DYNAMIC_TRAVEL"] = 18;
                            values[valuesById[19] = "DYNAMIC_LOCAL"] = 19;
                            values[valuesById[20] = "DYNAMIC_JOB"] = 20;
                            return values;
                        })();

                        return PlaceholderTypeEnum;
                    })();

                    enums.PlacementTypeEnum = (function() {

                        /**
                         * Properties of a PlacementTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IPlacementTypeEnum
                         */

                        /**
                         * Constructs a new PlacementTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a PlacementTypeEnum.
                         * @implements IPlacementTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IPlacementTypeEnum=} [properties] Properties to set
                         */
                        function PlacementTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PlacementTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.PlacementTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPlacementTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.PlacementTypeEnum} PlacementTypeEnum instance
                         */
                        PlacementTypeEnum.create = function create(properties) {
                            return new PlacementTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified PlacementTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.PlacementTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.PlacementTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPlacementTypeEnum} message PlacementTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PlacementTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PlacementTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.PlacementTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PlacementTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPlacementTypeEnum} message PlacementTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PlacementTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PlacementTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.PlacementTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.PlacementTypeEnum} PlacementTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PlacementTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.PlacementTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PlacementTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PlacementTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.PlacementTypeEnum} PlacementTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PlacementTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PlacementTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.PlacementTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PlacementTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PlacementTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.PlacementTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.PlacementTypeEnum} PlacementTypeEnum
                         */
                        PlacementTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.PlacementTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.PlacementTypeEnum();
                        };

                        /**
                         * Creates a plain object from a PlacementTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.PlacementTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.PlacementTypeEnum} message PlacementTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PlacementTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PlacementTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.PlacementTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PlacementTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PlacementType enum.
                         * @name google.ads.googleads.v1.enums.PlacementTypeEnum.PlacementType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} WEBSITE=2 WEBSITE value
                         * @property {number} MOBILE_APP_CATEGORY=3 MOBILE_APP_CATEGORY value
                         * @property {number} MOBILE_APPLICATION=4 MOBILE_APPLICATION value
                         * @property {number} YOUTUBE_VIDEO=5 YOUTUBE_VIDEO value
                         * @property {number} YOUTUBE_CHANNEL=6 YOUTUBE_CHANNEL value
                         */
                        PlacementTypeEnum.PlacementType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "WEBSITE"] = 2;
                            values[valuesById[3] = "MOBILE_APP_CATEGORY"] = 3;
                            values[valuesById[4] = "MOBILE_APPLICATION"] = 4;
                            values[valuesById[5] = "YOUTUBE_VIDEO"] = 5;
                            values[valuesById[6] = "YOUTUBE_CHANNEL"] = 6;
                            return values;
                        })();

                        return PlacementTypeEnum;
                    })();

                    enums.PolicyApprovalStatusEnum = (function() {

                        /**
                         * Properties of a PolicyApprovalStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IPolicyApprovalStatusEnum
                         */

                        /**
                         * Constructs a new PolicyApprovalStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a PolicyApprovalStatusEnum.
                         * @implements IPolicyApprovalStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IPolicyApprovalStatusEnum=} [properties] Properties to set
                         */
                        function PolicyApprovalStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PolicyApprovalStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.PolicyApprovalStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPolicyApprovalStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.PolicyApprovalStatusEnum} PolicyApprovalStatusEnum instance
                         */
                        PolicyApprovalStatusEnum.create = function create(properties) {
                            return new PolicyApprovalStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified PolicyApprovalStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.PolicyApprovalStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.PolicyApprovalStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPolicyApprovalStatusEnum} message PolicyApprovalStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyApprovalStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PolicyApprovalStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.PolicyApprovalStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PolicyApprovalStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPolicyApprovalStatusEnum} message PolicyApprovalStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyApprovalStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PolicyApprovalStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.PolicyApprovalStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.PolicyApprovalStatusEnum} PolicyApprovalStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyApprovalStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.PolicyApprovalStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PolicyApprovalStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PolicyApprovalStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.PolicyApprovalStatusEnum} PolicyApprovalStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyApprovalStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PolicyApprovalStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.PolicyApprovalStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PolicyApprovalStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PolicyApprovalStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.PolicyApprovalStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.PolicyApprovalStatusEnum} PolicyApprovalStatusEnum
                         */
                        PolicyApprovalStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.PolicyApprovalStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.PolicyApprovalStatusEnum();
                        };

                        /**
                         * Creates a plain object from a PolicyApprovalStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.PolicyApprovalStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.PolicyApprovalStatusEnum} message PolicyApprovalStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PolicyApprovalStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PolicyApprovalStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.PolicyApprovalStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PolicyApprovalStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PolicyApprovalStatus enum.
                         * @name google.ads.googleads.v1.enums.PolicyApprovalStatusEnum.PolicyApprovalStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} DISAPPROVED=2 DISAPPROVED value
                         * @property {number} APPROVED_LIMITED=3 APPROVED_LIMITED value
                         * @property {number} APPROVED=4 APPROVED value
                         * @property {number} AREA_OF_INTEREST_ONLY=5 AREA_OF_INTEREST_ONLY value
                         */
                        PolicyApprovalStatusEnum.PolicyApprovalStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "DISAPPROVED"] = 2;
                            values[valuesById[3] = "APPROVED_LIMITED"] = 3;
                            values[valuesById[4] = "APPROVED"] = 4;
                            values[valuesById[5] = "AREA_OF_INTEREST_ONLY"] = 5;
                            return values;
                        })();

                        return PolicyApprovalStatusEnum;
                    })();

                    enums.PolicyReviewStatusEnum = (function() {

                        /**
                         * Properties of a PolicyReviewStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IPolicyReviewStatusEnum
                         */

                        /**
                         * Constructs a new PolicyReviewStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a PolicyReviewStatusEnum.
                         * @implements IPolicyReviewStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IPolicyReviewStatusEnum=} [properties] Properties to set
                         */
                        function PolicyReviewStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PolicyReviewStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.PolicyReviewStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPolicyReviewStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.PolicyReviewStatusEnum} PolicyReviewStatusEnum instance
                         */
                        PolicyReviewStatusEnum.create = function create(properties) {
                            return new PolicyReviewStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified PolicyReviewStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.PolicyReviewStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.PolicyReviewStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPolicyReviewStatusEnum} message PolicyReviewStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyReviewStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PolicyReviewStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.PolicyReviewStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PolicyReviewStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPolicyReviewStatusEnum} message PolicyReviewStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyReviewStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PolicyReviewStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.PolicyReviewStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.PolicyReviewStatusEnum} PolicyReviewStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyReviewStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.PolicyReviewStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PolicyReviewStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PolicyReviewStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.PolicyReviewStatusEnum} PolicyReviewStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyReviewStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PolicyReviewStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.PolicyReviewStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PolicyReviewStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PolicyReviewStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.PolicyReviewStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.PolicyReviewStatusEnum} PolicyReviewStatusEnum
                         */
                        PolicyReviewStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.PolicyReviewStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.PolicyReviewStatusEnum();
                        };

                        /**
                         * Creates a plain object from a PolicyReviewStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.PolicyReviewStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.PolicyReviewStatusEnum} message PolicyReviewStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PolicyReviewStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PolicyReviewStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.PolicyReviewStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PolicyReviewStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PolicyReviewStatus enum.
                         * @name google.ads.googleads.v1.enums.PolicyReviewStatusEnum.PolicyReviewStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} REVIEW_IN_PROGRESS=2 REVIEW_IN_PROGRESS value
                         * @property {number} REVIEWED=3 REVIEWED value
                         * @property {number} UNDER_APPEAL=4 UNDER_APPEAL value
                         */
                        PolicyReviewStatusEnum.PolicyReviewStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "REVIEW_IN_PROGRESS"] = 2;
                            values[valuesById[3] = "REVIEWED"] = 3;
                            values[valuesById[4] = "UNDER_APPEAL"] = 4;
                            return values;
                        })();

                        return PolicyReviewStatusEnum;
                    })();

                    enums.PolicyTopicEntryTypeEnum = (function() {

                        /**
                         * Properties of a PolicyTopicEntryTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IPolicyTopicEntryTypeEnum
                         */

                        /**
                         * Constructs a new PolicyTopicEntryTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a PolicyTopicEntryTypeEnum.
                         * @implements IPolicyTopicEntryTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IPolicyTopicEntryTypeEnum=} [properties] Properties to set
                         */
                        function PolicyTopicEntryTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PolicyTopicEntryTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPolicyTopicEntryTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum} PolicyTopicEntryTypeEnum instance
                         */
                        PolicyTopicEntryTypeEnum.create = function create(properties) {
                            return new PolicyTopicEntryTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified PolicyTopicEntryTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPolicyTopicEntryTypeEnum} message PolicyTopicEntryTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyTopicEntryTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PolicyTopicEntryTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPolicyTopicEntryTypeEnum} message PolicyTopicEntryTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyTopicEntryTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PolicyTopicEntryTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum} PolicyTopicEntryTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyTopicEntryTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PolicyTopicEntryTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum} PolicyTopicEntryTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyTopicEntryTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PolicyTopicEntryTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PolicyTopicEntryTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PolicyTopicEntryTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum} PolicyTopicEntryTypeEnum
                         */
                        PolicyTopicEntryTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum();
                        };

                        /**
                         * Creates a plain object from a PolicyTopicEntryTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum} message PolicyTopicEntryTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PolicyTopicEntryTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PolicyTopicEntryTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PolicyTopicEntryTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PolicyTopicEntryType enum.
                         * @name google.ads.googleads.v1.enums.PolicyTopicEntryTypeEnum.PolicyTopicEntryType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} PROHIBITED=2 PROHIBITED value
                         * @property {number} LIMITED=4 LIMITED value
                         * @property {number} FULLY_LIMITED=8 FULLY_LIMITED value
                         * @property {number} DESCRIPTIVE=5 DESCRIPTIVE value
                         * @property {number} BROADENING=6 BROADENING value
                         * @property {number} AREA_OF_INTEREST_ONLY=7 AREA_OF_INTEREST_ONLY value
                         */
                        PolicyTopicEntryTypeEnum.PolicyTopicEntryType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "PROHIBITED"] = 2;
                            values[valuesById[4] = "LIMITED"] = 4;
                            values[valuesById[8] = "FULLY_LIMITED"] = 8;
                            values[valuesById[5] = "DESCRIPTIVE"] = 5;
                            values[valuesById[6] = "BROADENING"] = 6;
                            values[valuesById[7] = "AREA_OF_INTEREST_ONLY"] = 7;
                            return values;
                        })();

                        return PolicyTopicEntryTypeEnum;
                    })();

                    enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum = (function() {

                        /**
                         * Properties of a PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IPolicyTopicEvidenceDestinationMismatchUrlTypeEnum
                         */

                        /**
                         * Constructs a new PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.
                         * @implements IPolicyTopicEvidenceDestinationMismatchUrlTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IPolicyTopicEvidenceDestinationMismatchUrlTypeEnum=} [properties] Properties to set
                         */
                        function PolicyTopicEvidenceDestinationMismatchUrlTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PolicyTopicEvidenceDestinationMismatchUrlTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPolicyTopicEvidenceDestinationMismatchUrlTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum} PolicyTopicEvidenceDestinationMismatchUrlTypeEnum instance
                         */
                        PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.create = function create(properties) {
                            return new PolicyTopicEvidenceDestinationMismatchUrlTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified PolicyTopicEvidenceDestinationMismatchUrlTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPolicyTopicEvidenceDestinationMismatchUrlTypeEnum} message PolicyTopicEvidenceDestinationMismatchUrlTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PolicyTopicEvidenceDestinationMismatchUrlTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPolicyTopicEvidenceDestinationMismatchUrlTypeEnum} message PolicyTopicEvidenceDestinationMismatchUrlTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PolicyTopicEvidenceDestinationMismatchUrlTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum} PolicyTopicEvidenceDestinationMismatchUrlTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PolicyTopicEvidenceDestinationMismatchUrlTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum} PolicyTopicEvidenceDestinationMismatchUrlTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PolicyTopicEvidenceDestinationMismatchUrlTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PolicyTopicEvidenceDestinationMismatchUrlTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum} PolicyTopicEvidenceDestinationMismatchUrlTypeEnum
                         */
                        PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum();
                        };

                        /**
                         * Creates a plain object from a PolicyTopicEvidenceDestinationMismatchUrlTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum} message PolicyTopicEvidenceDestinationMismatchUrlTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PolicyTopicEvidenceDestinationMismatchUrlTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PolicyTopicEvidenceDestinationMismatchUrlType enum.
                         * @name google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.PolicyTopicEvidenceDestinationMismatchUrlType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} DISPLAY_URL=2 DISPLAY_URL value
                         * @property {number} FINAL_URL=3 FINAL_URL value
                         * @property {number} FINAL_MOBILE_URL=4 FINAL_MOBILE_URL value
                         * @property {number} TRACKING_URL=5 TRACKING_URL value
                         * @property {number} MOBILE_TRACKING_URL=6 MOBILE_TRACKING_URL value
                         */
                        PolicyTopicEvidenceDestinationMismatchUrlTypeEnum.PolicyTopicEvidenceDestinationMismatchUrlType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "DISPLAY_URL"] = 2;
                            values[valuesById[3] = "FINAL_URL"] = 3;
                            values[valuesById[4] = "FINAL_MOBILE_URL"] = 4;
                            values[valuesById[5] = "TRACKING_URL"] = 5;
                            values[valuesById[6] = "MOBILE_TRACKING_URL"] = 6;
                            return values;
                        })();

                        return PolicyTopicEvidenceDestinationMismatchUrlTypeEnum;
                    })();

                    enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum = (function() {

                        /**
                         * Properties of a PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IPolicyTopicEvidenceDestinationNotWorkingDeviceEnum
                         */

                        /**
                         * Constructs a new PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.
                         * @implements IPolicyTopicEvidenceDestinationNotWorkingDeviceEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IPolicyTopicEvidenceDestinationNotWorkingDeviceEnum=} [properties] Properties to set
                         */
                        function PolicyTopicEvidenceDestinationNotWorkingDeviceEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PolicyTopicEvidenceDestinationNotWorkingDeviceEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPolicyTopicEvidenceDestinationNotWorkingDeviceEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum} PolicyTopicEvidenceDestinationNotWorkingDeviceEnum instance
                         */
                        PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.create = function create(properties) {
                            return new PolicyTopicEvidenceDestinationNotWorkingDeviceEnum(properties);
                        };

                        /**
                         * Encodes the specified PolicyTopicEvidenceDestinationNotWorkingDeviceEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPolicyTopicEvidenceDestinationNotWorkingDeviceEnum} message PolicyTopicEvidenceDestinationNotWorkingDeviceEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PolicyTopicEvidenceDestinationNotWorkingDeviceEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPolicyTopicEvidenceDestinationNotWorkingDeviceEnum} message PolicyTopicEvidenceDestinationNotWorkingDeviceEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PolicyTopicEvidenceDestinationNotWorkingDeviceEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum} PolicyTopicEvidenceDestinationNotWorkingDeviceEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PolicyTopicEvidenceDestinationNotWorkingDeviceEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum} PolicyTopicEvidenceDestinationNotWorkingDeviceEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PolicyTopicEvidenceDestinationNotWorkingDeviceEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PolicyTopicEvidenceDestinationNotWorkingDeviceEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum} PolicyTopicEvidenceDestinationNotWorkingDeviceEnum
                         */
                        PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum();
                        };

                        /**
                         * Creates a plain object from a PolicyTopicEvidenceDestinationNotWorkingDeviceEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum} message PolicyTopicEvidenceDestinationNotWorkingDeviceEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PolicyTopicEvidenceDestinationNotWorkingDeviceEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PolicyTopicEvidenceDestinationNotWorkingDevice enum.
                         * @name google.ads.googleads.v1.enums.PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.PolicyTopicEvidenceDestinationNotWorkingDevice
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} DESKTOP=2 DESKTOP value
                         * @property {number} ANDROID=3 ANDROID value
                         * @property {number} IOS=4 IOS value
                         */
                        PolicyTopicEvidenceDestinationNotWorkingDeviceEnum.PolicyTopicEvidenceDestinationNotWorkingDevice = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "DESKTOP"] = 2;
                            values[valuesById[3] = "ANDROID"] = 3;
                            values[valuesById[4] = "IOS"] = 4;
                            return values;
                        })();

                        return PolicyTopicEvidenceDestinationNotWorkingDeviceEnum;
                    })();

                    enums.PositiveGeoTargetTypeEnum = (function() {

                        /**
                         * Properties of a PositiveGeoTargetTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IPositiveGeoTargetTypeEnum
                         */

                        /**
                         * Constructs a new PositiveGeoTargetTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a PositiveGeoTargetTypeEnum.
                         * @implements IPositiveGeoTargetTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IPositiveGeoTargetTypeEnum=} [properties] Properties to set
                         */
                        function PositiveGeoTargetTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PositiveGeoTargetTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPositiveGeoTargetTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum} PositiveGeoTargetTypeEnum instance
                         */
                        PositiveGeoTargetTypeEnum.create = function create(properties) {
                            return new PositiveGeoTargetTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified PositiveGeoTargetTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPositiveGeoTargetTypeEnum} message PositiveGeoTargetTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PositiveGeoTargetTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PositiveGeoTargetTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPositiveGeoTargetTypeEnum} message PositiveGeoTargetTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PositiveGeoTargetTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PositiveGeoTargetTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum} PositiveGeoTargetTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PositiveGeoTargetTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PositiveGeoTargetTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum} PositiveGeoTargetTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PositiveGeoTargetTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PositiveGeoTargetTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PositiveGeoTargetTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PositiveGeoTargetTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum} PositiveGeoTargetTypeEnum
                         */
                        PositiveGeoTargetTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum();
                        };

                        /**
                         * Creates a plain object from a PositiveGeoTargetTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum} message PositiveGeoTargetTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PositiveGeoTargetTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PositiveGeoTargetTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PositiveGeoTargetTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PositiveGeoTargetType enum.
                         * @name google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum.PositiveGeoTargetType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} DONT_CARE=2 DONT_CARE value
                         * @property {number} AREA_OF_INTEREST=3 AREA_OF_INTEREST value
                         * @property {number} LOCATION_OF_PRESENCE=4 LOCATION_OF_PRESENCE value
                         */
                        PositiveGeoTargetTypeEnum.PositiveGeoTargetType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "DONT_CARE"] = 2;
                            values[valuesById[3] = "AREA_OF_INTEREST"] = 3;
                            values[valuesById[4] = "LOCATION_OF_PRESENCE"] = 4;
                            return values;
                        })();

                        return PositiveGeoTargetTypeEnum;
                    })();

                    enums.PreferredContentTypeEnum = (function() {

                        /**
                         * Properties of a PreferredContentTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IPreferredContentTypeEnum
                         */

                        /**
                         * Constructs a new PreferredContentTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a PreferredContentTypeEnum.
                         * @implements IPreferredContentTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IPreferredContentTypeEnum=} [properties] Properties to set
                         */
                        function PreferredContentTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PreferredContentTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.PreferredContentTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPreferredContentTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.PreferredContentTypeEnum} PreferredContentTypeEnum instance
                         */
                        PreferredContentTypeEnum.create = function create(properties) {
                            return new PreferredContentTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified PreferredContentTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.PreferredContentTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.PreferredContentTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPreferredContentTypeEnum} message PreferredContentTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PreferredContentTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PreferredContentTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.PreferredContentTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PreferredContentTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPreferredContentTypeEnum} message PreferredContentTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PreferredContentTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PreferredContentTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.PreferredContentTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.PreferredContentTypeEnum} PreferredContentTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PreferredContentTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.PreferredContentTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PreferredContentTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PreferredContentTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.PreferredContentTypeEnum} PreferredContentTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PreferredContentTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PreferredContentTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.PreferredContentTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PreferredContentTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PreferredContentTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.PreferredContentTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.PreferredContentTypeEnum} PreferredContentTypeEnum
                         */
                        PreferredContentTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.PreferredContentTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.PreferredContentTypeEnum();
                        };

                        /**
                         * Creates a plain object from a PreferredContentTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.PreferredContentTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.PreferredContentTypeEnum} message PreferredContentTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PreferredContentTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PreferredContentTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.PreferredContentTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PreferredContentTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PreferredContentType enum.
                         * @name google.ads.googleads.v1.enums.PreferredContentTypeEnum.PreferredContentType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} YOUTUBE_TOP_CONTENT=400 YOUTUBE_TOP_CONTENT value
                         */
                        PreferredContentTypeEnum.PreferredContentType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[400] = "YOUTUBE_TOP_CONTENT"] = 400;
                            return values;
                        })();

                        return PreferredContentTypeEnum;
                    })();

                    enums.PriceExtensionPriceQualifierEnum = (function() {

                        /**
                         * Properties of a PriceExtensionPriceQualifierEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IPriceExtensionPriceQualifierEnum
                         */

                        /**
                         * Constructs a new PriceExtensionPriceQualifierEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a PriceExtensionPriceQualifierEnum.
                         * @implements IPriceExtensionPriceQualifierEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IPriceExtensionPriceQualifierEnum=} [properties] Properties to set
                         */
                        function PriceExtensionPriceQualifierEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PriceExtensionPriceQualifierEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPriceExtensionPriceQualifierEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum} PriceExtensionPriceQualifierEnum instance
                         */
                        PriceExtensionPriceQualifierEnum.create = function create(properties) {
                            return new PriceExtensionPriceQualifierEnum(properties);
                        };

                        /**
                         * Encodes the specified PriceExtensionPriceQualifierEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPriceExtensionPriceQualifierEnum} message PriceExtensionPriceQualifierEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PriceExtensionPriceQualifierEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PriceExtensionPriceQualifierEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPriceExtensionPriceQualifierEnum} message PriceExtensionPriceQualifierEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PriceExtensionPriceQualifierEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PriceExtensionPriceQualifierEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum} PriceExtensionPriceQualifierEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PriceExtensionPriceQualifierEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PriceExtensionPriceQualifierEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum} PriceExtensionPriceQualifierEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PriceExtensionPriceQualifierEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PriceExtensionPriceQualifierEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PriceExtensionPriceQualifierEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PriceExtensionPriceQualifierEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum} PriceExtensionPriceQualifierEnum
                         */
                        PriceExtensionPriceQualifierEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum();
                        };

                        /**
                         * Creates a plain object from a PriceExtensionPriceQualifierEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum} message PriceExtensionPriceQualifierEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PriceExtensionPriceQualifierEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PriceExtensionPriceQualifierEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PriceExtensionPriceQualifierEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PriceExtensionPriceQualifier enum.
                         * @name google.ads.googleads.v1.enums.PriceExtensionPriceQualifierEnum.PriceExtensionPriceQualifier
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} FROM=2 FROM value
                         * @property {number} UP_TO=3 UP_TO value
                         * @property {number} AVERAGE=4 AVERAGE value
                         */
                        PriceExtensionPriceQualifierEnum.PriceExtensionPriceQualifier = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "FROM"] = 2;
                            values[valuesById[3] = "UP_TO"] = 3;
                            values[valuesById[4] = "AVERAGE"] = 4;
                            return values;
                        })();

                        return PriceExtensionPriceQualifierEnum;
                    })();

                    enums.PriceExtensionPriceUnitEnum = (function() {

                        /**
                         * Properties of a PriceExtensionPriceUnitEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IPriceExtensionPriceUnitEnum
                         */

                        /**
                         * Constructs a new PriceExtensionPriceUnitEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a PriceExtensionPriceUnitEnum.
                         * @implements IPriceExtensionPriceUnitEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IPriceExtensionPriceUnitEnum=} [properties] Properties to set
                         */
                        function PriceExtensionPriceUnitEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PriceExtensionPriceUnitEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPriceExtensionPriceUnitEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum} PriceExtensionPriceUnitEnum instance
                         */
                        PriceExtensionPriceUnitEnum.create = function create(properties) {
                            return new PriceExtensionPriceUnitEnum(properties);
                        };

                        /**
                         * Encodes the specified PriceExtensionPriceUnitEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPriceExtensionPriceUnitEnum} message PriceExtensionPriceUnitEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PriceExtensionPriceUnitEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PriceExtensionPriceUnitEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPriceExtensionPriceUnitEnum} message PriceExtensionPriceUnitEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PriceExtensionPriceUnitEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PriceExtensionPriceUnitEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum} PriceExtensionPriceUnitEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PriceExtensionPriceUnitEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PriceExtensionPriceUnitEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum} PriceExtensionPriceUnitEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PriceExtensionPriceUnitEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PriceExtensionPriceUnitEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PriceExtensionPriceUnitEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PriceExtensionPriceUnitEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum} PriceExtensionPriceUnitEnum
                         */
                        PriceExtensionPriceUnitEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum();
                        };

                        /**
                         * Creates a plain object from a PriceExtensionPriceUnitEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum} message PriceExtensionPriceUnitEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PriceExtensionPriceUnitEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PriceExtensionPriceUnitEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PriceExtensionPriceUnitEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PriceExtensionPriceUnit enum.
                         * @name google.ads.googleads.v1.enums.PriceExtensionPriceUnitEnum.PriceExtensionPriceUnit
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} PER_HOUR=2 PER_HOUR value
                         * @property {number} PER_DAY=3 PER_DAY value
                         * @property {number} PER_WEEK=4 PER_WEEK value
                         * @property {number} PER_MONTH=5 PER_MONTH value
                         * @property {number} PER_YEAR=6 PER_YEAR value
                         * @property {number} PER_NIGHT=7 PER_NIGHT value
                         */
                        PriceExtensionPriceUnitEnum.PriceExtensionPriceUnit = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "PER_HOUR"] = 2;
                            values[valuesById[3] = "PER_DAY"] = 3;
                            values[valuesById[4] = "PER_WEEK"] = 4;
                            values[valuesById[5] = "PER_MONTH"] = 5;
                            values[valuesById[6] = "PER_YEAR"] = 6;
                            values[valuesById[7] = "PER_NIGHT"] = 7;
                            return values;
                        })();

                        return PriceExtensionPriceUnitEnum;
                    })();

                    enums.PriceExtensionTypeEnum = (function() {

                        /**
                         * Properties of a PriceExtensionTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IPriceExtensionTypeEnum
                         */

                        /**
                         * Constructs a new PriceExtensionTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a PriceExtensionTypeEnum.
                         * @implements IPriceExtensionTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IPriceExtensionTypeEnum=} [properties] Properties to set
                         */
                        function PriceExtensionTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PriceExtensionTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPriceExtensionTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.PriceExtensionTypeEnum} PriceExtensionTypeEnum instance
                         */
                        PriceExtensionTypeEnum.create = function create(properties) {
                            return new PriceExtensionTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified PriceExtensionTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.PriceExtensionTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPriceExtensionTypeEnum} message PriceExtensionTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PriceExtensionTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PriceExtensionTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.PriceExtensionTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPriceExtensionTypeEnum} message PriceExtensionTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PriceExtensionTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PriceExtensionTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.PriceExtensionTypeEnum} PriceExtensionTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PriceExtensionTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.PriceExtensionTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PriceExtensionTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.PriceExtensionTypeEnum} PriceExtensionTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PriceExtensionTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PriceExtensionTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PriceExtensionTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PriceExtensionTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.PriceExtensionTypeEnum} PriceExtensionTypeEnum
                         */
                        PriceExtensionTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.PriceExtensionTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.PriceExtensionTypeEnum();
                        };

                        /**
                         * Creates a plain object from a PriceExtensionTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.PriceExtensionTypeEnum} message PriceExtensionTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PriceExtensionTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PriceExtensionTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.PriceExtensionTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PriceExtensionTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PriceExtensionType enum.
                         * @name google.ads.googleads.v1.enums.PriceExtensionTypeEnum.PriceExtensionType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} BRANDS=2 BRANDS value
                         * @property {number} EVENTS=3 EVENTS value
                         * @property {number} LOCATIONS=4 LOCATIONS value
                         * @property {number} NEIGHBORHOODS=5 NEIGHBORHOODS value
                         * @property {number} PRODUCT_CATEGORIES=6 PRODUCT_CATEGORIES value
                         * @property {number} PRODUCT_TIERS=7 PRODUCT_TIERS value
                         * @property {number} SERVICES=8 SERVICES value
                         * @property {number} SERVICE_CATEGORIES=9 SERVICE_CATEGORIES value
                         * @property {number} SERVICE_TIERS=10 SERVICE_TIERS value
                         */
                        PriceExtensionTypeEnum.PriceExtensionType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "BRANDS"] = 2;
                            values[valuesById[3] = "EVENTS"] = 3;
                            values[valuesById[4] = "LOCATIONS"] = 4;
                            values[valuesById[5] = "NEIGHBORHOODS"] = 5;
                            values[valuesById[6] = "PRODUCT_CATEGORIES"] = 6;
                            values[valuesById[7] = "PRODUCT_TIERS"] = 7;
                            values[valuesById[8] = "SERVICES"] = 8;
                            values[valuesById[9] = "SERVICE_CATEGORIES"] = 9;
                            values[valuesById[10] = "SERVICE_TIERS"] = 10;
                            return values;
                        })();

                        return PriceExtensionTypeEnum;
                    })();

                    enums.PricePlaceholderFieldEnum = (function() {

                        /**
                         * Properties of a PricePlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IPricePlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new PricePlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a PricePlaceholderFieldEnum.
                         * @implements IPricePlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IPricePlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function PricePlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PricePlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.PricePlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPricePlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.PricePlaceholderFieldEnum} PricePlaceholderFieldEnum instance
                         */
                        PricePlaceholderFieldEnum.create = function create(properties) {
                            return new PricePlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified PricePlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.PricePlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.PricePlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPricePlaceholderFieldEnum} message PricePlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PricePlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PricePlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.PricePlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PricePlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPricePlaceholderFieldEnum} message PricePlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PricePlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PricePlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.PricePlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.PricePlaceholderFieldEnum} PricePlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PricePlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.PricePlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PricePlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PricePlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.PricePlaceholderFieldEnum} PricePlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PricePlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PricePlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.PricePlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PricePlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PricePlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.PricePlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.PricePlaceholderFieldEnum} PricePlaceholderFieldEnum
                         */
                        PricePlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.PricePlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.PricePlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from a PricePlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.PricePlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.PricePlaceholderFieldEnum} message PricePlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PricePlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PricePlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.PricePlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PricePlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PricePlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.PricePlaceholderFieldEnum.PricePlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} TYPE=2 TYPE value
                         * @property {number} PRICE_QUALIFIER=3 PRICE_QUALIFIER value
                         * @property {number} TRACKING_TEMPLATE=4 TRACKING_TEMPLATE value
                         * @property {number} LANGUAGE=5 LANGUAGE value
                         * @property {number} FINAL_URL_SUFFIX=6 FINAL_URL_SUFFIX value
                         * @property {number} ITEM_1_HEADER=100 ITEM_1_HEADER value
                         * @property {number} ITEM_1_DESCRIPTION=101 ITEM_1_DESCRIPTION value
                         * @property {number} ITEM_1_PRICE=102 ITEM_1_PRICE value
                         * @property {number} ITEM_1_UNIT=103 ITEM_1_UNIT value
                         * @property {number} ITEM_1_FINAL_URLS=104 ITEM_1_FINAL_URLS value
                         * @property {number} ITEM_1_FINAL_MOBILE_URLS=105 ITEM_1_FINAL_MOBILE_URLS value
                         * @property {number} ITEM_2_HEADER=200 ITEM_2_HEADER value
                         * @property {number} ITEM_2_DESCRIPTION=201 ITEM_2_DESCRIPTION value
                         * @property {number} ITEM_2_PRICE=202 ITEM_2_PRICE value
                         * @property {number} ITEM_2_UNIT=203 ITEM_2_UNIT value
                         * @property {number} ITEM_2_FINAL_URLS=204 ITEM_2_FINAL_URLS value
                         * @property {number} ITEM_2_FINAL_MOBILE_URLS=205 ITEM_2_FINAL_MOBILE_URLS value
                         * @property {number} ITEM_3_HEADER=300 ITEM_3_HEADER value
                         * @property {number} ITEM_3_DESCRIPTION=301 ITEM_3_DESCRIPTION value
                         * @property {number} ITEM_3_PRICE=302 ITEM_3_PRICE value
                         * @property {number} ITEM_3_UNIT=303 ITEM_3_UNIT value
                         * @property {number} ITEM_3_FINAL_URLS=304 ITEM_3_FINAL_URLS value
                         * @property {number} ITEM_3_FINAL_MOBILE_URLS=305 ITEM_3_FINAL_MOBILE_URLS value
                         * @property {number} ITEM_4_HEADER=400 ITEM_4_HEADER value
                         * @property {number} ITEM_4_DESCRIPTION=401 ITEM_4_DESCRIPTION value
                         * @property {number} ITEM_4_PRICE=402 ITEM_4_PRICE value
                         * @property {number} ITEM_4_UNIT=403 ITEM_4_UNIT value
                         * @property {number} ITEM_4_FINAL_URLS=404 ITEM_4_FINAL_URLS value
                         * @property {number} ITEM_4_FINAL_MOBILE_URLS=405 ITEM_4_FINAL_MOBILE_URLS value
                         * @property {number} ITEM_5_HEADER=500 ITEM_5_HEADER value
                         * @property {number} ITEM_5_DESCRIPTION=501 ITEM_5_DESCRIPTION value
                         * @property {number} ITEM_5_PRICE=502 ITEM_5_PRICE value
                         * @property {number} ITEM_5_UNIT=503 ITEM_5_UNIT value
                         * @property {number} ITEM_5_FINAL_URLS=504 ITEM_5_FINAL_URLS value
                         * @property {number} ITEM_5_FINAL_MOBILE_URLS=505 ITEM_5_FINAL_MOBILE_URLS value
                         * @property {number} ITEM_6_HEADER=600 ITEM_6_HEADER value
                         * @property {number} ITEM_6_DESCRIPTION=601 ITEM_6_DESCRIPTION value
                         * @property {number} ITEM_6_PRICE=602 ITEM_6_PRICE value
                         * @property {number} ITEM_6_UNIT=603 ITEM_6_UNIT value
                         * @property {number} ITEM_6_FINAL_URLS=604 ITEM_6_FINAL_URLS value
                         * @property {number} ITEM_6_FINAL_MOBILE_URLS=605 ITEM_6_FINAL_MOBILE_URLS value
                         * @property {number} ITEM_7_HEADER=700 ITEM_7_HEADER value
                         * @property {number} ITEM_7_DESCRIPTION=701 ITEM_7_DESCRIPTION value
                         * @property {number} ITEM_7_PRICE=702 ITEM_7_PRICE value
                         * @property {number} ITEM_7_UNIT=703 ITEM_7_UNIT value
                         * @property {number} ITEM_7_FINAL_URLS=704 ITEM_7_FINAL_URLS value
                         * @property {number} ITEM_7_FINAL_MOBILE_URLS=705 ITEM_7_FINAL_MOBILE_URLS value
                         * @property {number} ITEM_8_HEADER=800 ITEM_8_HEADER value
                         * @property {number} ITEM_8_DESCRIPTION=801 ITEM_8_DESCRIPTION value
                         * @property {number} ITEM_8_PRICE=802 ITEM_8_PRICE value
                         * @property {number} ITEM_8_UNIT=803 ITEM_8_UNIT value
                         * @property {number} ITEM_8_FINAL_URLS=804 ITEM_8_FINAL_URLS value
                         * @property {number} ITEM_8_FINAL_MOBILE_URLS=805 ITEM_8_FINAL_MOBILE_URLS value
                         */
                        PricePlaceholderFieldEnum.PricePlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "TYPE"] = 2;
                            values[valuesById[3] = "PRICE_QUALIFIER"] = 3;
                            values[valuesById[4] = "TRACKING_TEMPLATE"] = 4;
                            values[valuesById[5] = "LANGUAGE"] = 5;
                            values[valuesById[6] = "FINAL_URL_SUFFIX"] = 6;
                            values[valuesById[100] = "ITEM_1_HEADER"] = 100;
                            values[valuesById[101] = "ITEM_1_DESCRIPTION"] = 101;
                            values[valuesById[102] = "ITEM_1_PRICE"] = 102;
                            values[valuesById[103] = "ITEM_1_UNIT"] = 103;
                            values[valuesById[104] = "ITEM_1_FINAL_URLS"] = 104;
                            values[valuesById[105] = "ITEM_1_FINAL_MOBILE_URLS"] = 105;
                            values[valuesById[200] = "ITEM_2_HEADER"] = 200;
                            values[valuesById[201] = "ITEM_2_DESCRIPTION"] = 201;
                            values[valuesById[202] = "ITEM_2_PRICE"] = 202;
                            values[valuesById[203] = "ITEM_2_UNIT"] = 203;
                            values[valuesById[204] = "ITEM_2_FINAL_URLS"] = 204;
                            values[valuesById[205] = "ITEM_2_FINAL_MOBILE_URLS"] = 205;
                            values[valuesById[300] = "ITEM_3_HEADER"] = 300;
                            values[valuesById[301] = "ITEM_3_DESCRIPTION"] = 301;
                            values[valuesById[302] = "ITEM_3_PRICE"] = 302;
                            values[valuesById[303] = "ITEM_3_UNIT"] = 303;
                            values[valuesById[304] = "ITEM_3_FINAL_URLS"] = 304;
                            values[valuesById[305] = "ITEM_3_FINAL_MOBILE_URLS"] = 305;
                            values[valuesById[400] = "ITEM_4_HEADER"] = 400;
                            values[valuesById[401] = "ITEM_4_DESCRIPTION"] = 401;
                            values[valuesById[402] = "ITEM_4_PRICE"] = 402;
                            values[valuesById[403] = "ITEM_4_UNIT"] = 403;
                            values[valuesById[404] = "ITEM_4_FINAL_URLS"] = 404;
                            values[valuesById[405] = "ITEM_4_FINAL_MOBILE_URLS"] = 405;
                            values[valuesById[500] = "ITEM_5_HEADER"] = 500;
                            values[valuesById[501] = "ITEM_5_DESCRIPTION"] = 501;
                            values[valuesById[502] = "ITEM_5_PRICE"] = 502;
                            values[valuesById[503] = "ITEM_5_UNIT"] = 503;
                            values[valuesById[504] = "ITEM_5_FINAL_URLS"] = 504;
                            values[valuesById[505] = "ITEM_5_FINAL_MOBILE_URLS"] = 505;
                            values[valuesById[600] = "ITEM_6_HEADER"] = 600;
                            values[valuesById[601] = "ITEM_6_DESCRIPTION"] = 601;
                            values[valuesById[602] = "ITEM_6_PRICE"] = 602;
                            values[valuesById[603] = "ITEM_6_UNIT"] = 603;
                            values[valuesById[604] = "ITEM_6_FINAL_URLS"] = 604;
                            values[valuesById[605] = "ITEM_6_FINAL_MOBILE_URLS"] = 605;
                            values[valuesById[700] = "ITEM_7_HEADER"] = 700;
                            values[valuesById[701] = "ITEM_7_DESCRIPTION"] = 701;
                            values[valuesById[702] = "ITEM_7_PRICE"] = 702;
                            values[valuesById[703] = "ITEM_7_UNIT"] = 703;
                            values[valuesById[704] = "ITEM_7_FINAL_URLS"] = 704;
                            values[valuesById[705] = "ITEM_7_FINAL_MOBILE_URLS"] = 705;
                            values[valuesById[800] = "ITEM_8_HEADER"] = 800;
                            values[valuesById[801] = "ITEM_8_DESCRIPTION"] = 801;
                            values[valuesById[802] = "ITEM_8_PRICE"] = 802;
                            values[valuesById[803] = "ITEM_8_UNIT"] = 803;
                            values[valuesById[804] = "ITEM_8_FINAL_URLS"] = 804;
                            values[valuesById[805] = "ITEM_8_FINAL_MOBILE_URLS"] = 805;
                            return values;
                        })();

                        return PricePlaceholderFieldEnum;
                    })();

                    enums.ProductBiddingCategoryLevelEnum = (function() {

                        /**
                         * Properties of a ProductBiddingCategoryLevelEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IProductBiddingCategoryLevelEnum
                         */

                        /**
                         * Constructs a new ProductBiddingCategoryLevelEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ProductBiddingCategoryLevelEnum.
                         * @implements IProductBiddingCategoryLevelEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IProductBiddingCategoryLevelEnum=} [properties] Properties to set
                         */
                        function ProductBiddingCategoryLevelEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ProductBiddingCategoryLevelEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProductBiddingCategoryLevelEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum} ProductBiddingCategoryLevelEnum instance
                         */
                        ProductBiddingCategoryLevelEnum.create = function create(properties) {
                            return new ProductBiddingCategoryLevelEnum(properties);
                        };

                        /**
                         * Encodes the specified ProductBiddingCategoryLevelEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProductBiddingCategoryLevelEnum} message ProductBiddingCategoryLevelEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductBiddingCategoryLevelEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ProductBiddingCategoryLevelEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProductBiddingCategoryLevelEnum} message ProductBiddingCategoryLevelEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductBiddingCategoryLevelEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ProductBiddingCategoryLevelEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum} ProductBiddingCategoryLevelEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductBiddingCategoryLevelEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ProductBiddingCategoryLevelEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum} ProductBiddingCategoryLevelEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductBiddingCategoryLevelEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ProductBiddingCategoryLevelEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProductBiddingCategoryLevelEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ProductBiddingCategoryLevelEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum} ProductBiddingCategoryLevelEnum
                         */
                        ProductBiddingCategoryLevelEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum();
                        };

                        /**
                         * Creates a plain object from a ProductBiddingCategoryLevelEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum} message ProductBiddingCategoryLevelEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProductBiddingCategoryLevelEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ProductBiddingCategoryLevelEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProductBiddingCategoryLevelEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ProductBiddingCategoryLevel enum.
                         * @name google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum.ProductBiddingCategoryLevel
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} LEVEL1=2 LEVEL1 value
                         * @property {number} LEVEL2=3 LEVEL2 value
                         * @property {number} LEVEL3=4 LEVEL3 value
                         * @property {number} LEVEL4=5 LEVEL4 value
                         * @property {number} LEVEL5=6 LEVEL5 value
                         */
                        ProductBiddingCategoryLevelEnum.ProductBiddingCategoryLevel = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "LEVEL1"] = 2;
                            values[valuesById[3] = "LEVEL2"] = 3;
                            values[valuesById[4] = "LEVEL3"] = 4;
                            values[valuesById[5] = "LEVEL4"] = 5;
                            values[valuesById[6] = "LEVEL5"] = 6;
                            return values;
                        })();

                        return ProductBiddingCategoryLevelEnum;
                    })();

                    enums.ProductBiddingCategoryStatusEnum = (function() {

                        /**
                         * Properties of a ProductBiddingCategoryStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IProductBiddingCategoryStatusEnum
                         */

                        /**
                         * Constructs a new ProductBiddingCategoryStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ProductBiddingCategoryStatusEnum.
                         * @implements IProductBiddingCategoryStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IProductBiddingCategoryStatusEnum=} [properties] Properties to set
                         */
                        function ProductBiddingCategoryStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ProductBiddingCategoryStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProductBiddingCategoryStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum} ProductBiddingCategoryStatusEnum instance
                         */
                        ProductBiddingCategoryStatusEnum.create = function create(properties) {
                            return new ProductBiddingCategoryStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified ProductBiddingCategoryStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProductBiddingCategoryStatusEnum} message ProductBiddingCategoryStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductBiddingCategoryStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ProductBiddingCategoryStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProductBiddingCategoryStatusEnum} message ProductBiddingCategoryStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductBiddingCategoryStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ProductBiddingCategoryStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum} ProductBiddingCategoryStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductBiddingCategoryStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ProductBiddingCategoryStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum} ProductBiddingCategoryStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductBiddingCategoryStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ProductBiddingCategoryStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProductBiddingCategoryStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ProductBiddingCategoryStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum} ProductBiddingCategoryStatusEnum
                         */
                        ProductBiddingCategoryStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum();
                        };

                        /**
                         * Creates a plain object from a ProductBiddingCategoryStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum} message ProductBiddingCategoryStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProductBiddingCategoryStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ProductBiddingCategoryStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProductBiddingCategoryStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ProductBiddingCategoryStatus enum.
                         * @name google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum.ProductBiddingCategoryStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ACTIVE=2 ACTIVE value
                         * @property {number} OBSOLETE=3 OBSOLETE value
                         */
                        ProductBiddingCategoryStatusEnum.ProductBiddingCategoryStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ACTIVE"] = 2;
                            values[valuesById[3] = "OBSOLETE"] = 3;
                            return values;
                        })();

                        return ProductBiddingCategoryStatusEnum;
                    })();

                    enums.ProductChannelEnum = (function() {

                        /**
                         * Properties of a ProductChannelEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IProductChannelEnum
                         */

                        /**
                         * Constructs a new ProductChannelEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ProductChannelEnum.
                         * @implements IProductChannelEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IProductChannelEnum=} [properties] Properties to set
                         */
                        function ProductChannelEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ProductChannelEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ProductChannelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProductChannelEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ProductChannelEnum} ProductChannelEnum instance
                         */
                        ProductChannelEnum.create = function create(properties) {
                            return new ProductChannelEnum(properties);
                        };

                        /**
                         * Encodes the specified ProductChannelEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ProductChannelEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ProductChannelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProductChannelEnum} message ProductChannelEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductChannelEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ProductChannelEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ProductChannelEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ProductChannelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProductChannelEnum} message ProductChannelEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductChannelEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ProductChannelEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ProductChannelEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ProductChannelEnum} ProductChannelEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductChannelEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ProductChannelEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ProductChannelEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ProductChannelEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ProductChannelEnum} ProductChannelEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductChannelEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ProductChannelEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ProductChannelEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProductChannelEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ProductChannelEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ProductChannelEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ProductChannelEnum} ProductChannelEnum
                         */
                        ProductChannelEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ProductChannelEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ProductChannelEnum();
                        };

                        /**
                         * Creates a plain object from a ProductChannelEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ProductChannelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ProductChannelEnum} message ProductChannelEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProductChannelEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ProductChannelEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ProductChannelEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProductChannelEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ProductChannel enum.
                         * @name google.ads.googleads.v1.enums.ProductChannelEnum.ProductChannel
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ONLINE=2 ONLINE value
                         * @property {number} LOCAL=3 LOCAL value
                         */
                        ProductChannelEnum.ProductChannel = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ONLINE"] = 2;
                            values[valuesById[3] = "LOCAL"] = 3;
                            return values;
                        })();

                        return ProductChannelEnum;
                    })();

                    enums.ProductChannelExclusivityEnum = (function() {

                        /**
                         * Properties of a ProductChannelExclusivityEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IProductChannelExclusivityEnum
                         */

                        /**
                         * Constructs a new ProductChannelExclusivityEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ProductChannelExclusivityEnum.
                         * @implements IProductChannelExclusivityEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IProductChannelExclusivityEnum=} [properties] Properties to set
                         */
                        function ProductChannelExclusivityEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ProductChannelExclusivityEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ProductChannelExclusivityEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProductChannelExclusivityEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ProductChannelExclusivityEnum} ProductChannelExclusivityEnum instance
                         */
                        ProductChannelExclusivityEnum.create = function create(properties) {
                            return new ProductChannelExclusivityEnum(properties);
                        };

                        /**
                         * Encodes the specified ProductChannelExclusivityEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ProductChannelExclusivityEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ProductChannelExclusivityEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProductChannelExclusivityEnum} message ProductChannelExclusivityEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductChannelExclusivityEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ProductChannelExclusivityEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ProductChannelExclusivityEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ProductChannelExclusivityEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProductChannelExclusivityEnum} message ProductChannelExclusivityEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductChannelExclusivityEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ProductChannelExclusivityEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ProductChannelExclusivityEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ProductChannelExclusivityEnum} ProductChannelExclusivityEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductChannelExclusivityEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ProductChannelExclusivityEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ProductChannelExclusivityEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ProductChannelExclusivityEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ProductChannelExclusivityEnum} ProductChannelExclusivityEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductChannelExclusivityEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ProductChannelExclusivityEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ProductChannelExclusivityEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProductChannelExclusivityEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ProductChannelExclusivityEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ProductChannelExclusivityEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ProductChannelExclusivityEnum} ProductChannelExclusivityEnum
                         */
                        ProductChannelExclusivityEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ProductChannelExclusivityEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ProductChannelExclusivityEnum();
                        };

                        /**
                         * Creates a plain object from a ProductChannelExclusivityEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ProductChannelExclusivityEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ProductChannelExclusivityEnum} message ProductChannelExclusivityEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProductChannelExclusivityEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ProductChannelExclusivityEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ProductChannelExclusivityEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProductChannelExclusivityEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ProductChannelExclusivity enum.
                         * @name google.ads.googleads.v1.enums.ProductChannelExclusivityEnum.ProductChannelExclusivity
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} SINGLE_CHANNEL=2 SINGLE_CHANNEL value
                         * @property {number} MULTI_CHANNEL=3 MULTI_CHANNEL value
                         */
                        ProductChannelExclusivityEnum.ProductChannelExclusivity = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "SINGLE_CHANNEL"] = 2;
                            values[valuesById[3] = "MULTI_CHANNEL"] = 3;
                            return values;
                        })();

                        return ProductChannelExclusivityEnum;
                    })();

                    enums.ProductConditionEnum = (function() {

                        /**
                         * Properties of a ProductConditionEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IProductConditionEnum
                         */

                        /**
                         * Constructs a new ProductConditionEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ProductConditionEnum.
                         * @implements IProductConditionEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IProductConditionEnum=} [properties] Properties to set
                         */
                        function ProductConditionEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ProductConditionEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ProductConditionEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProductConditionEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ProductConditionEnum} ProductConditionEnum instance
                         */
                        ProductConditionEnum.create = function create(properties) {
                            return new ProductConditionEnum(properties);
                        };

                        /**
                         * Encodes the specified ProductConditionEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ProductConditionEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ProductConditionEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProductConditionEnum} message ProductConditionEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductConditionEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ProductConditionEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ProductConditionEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ProductConditionEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProductConditionEnum} message ProductConditionEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductConditionEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ProductConditionEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ProductConditionEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ProductConditionEnum} ProductConditionEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductConditionEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ProductConditionEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ProductConditionEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ProductConditionEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ProductConditionEnum} ProductConditionEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductConditionEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ProductConditionEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ProductConditionEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProductConditionEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ProductConditionEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ProductConditionEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ProductConditionEnum} ProductConditionEnum
                         */
                        ProductConditionEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ProductConditionEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ProductConditionEnum();
                        };

                        /**
                         * Creates a plain object from a ProductConditionEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ProductConditionEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ProductConditionEnum} message ProductConditionEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProductConditionEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ProductConditionEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ProductConditionEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProductConditionEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ProductCondition enum.
                         * @name google.ads.googleads.v1.enums.ProductConditionEnum.ProductCondition
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} NEW=3 NEW value
                         * @property {number} REFURBISHED=4 REFURBISHED value
                         * @property {number} USED=5 USED value
                         */
                        ProductConditionEnum.ProductCondition = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[3] = "NEW"] = 3;
                            values[valuesById[4] = "REFURBISHED"] = 4;
                            values[valuesById[5] = "USED"] = 5;
                            return values;
                        })();

                        return ProductConditionEnum;
                    })();

                    enums.ProductTypeLevelEnum = (function() {

                        /**
                         * Properties of a ProductTypeLevelEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IProductTypeLevelEnum
                         */

                        /**
                         * Constructs a new ProductTypeLevelEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ProductTypeLevelEnum.
                         * @implements IProductTypeLevelEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IProductTypeLevelEnum=} [properties] Properties to set
                         */
                        function ProductTypeLevelEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ProductTypeLevelEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ProductTypeLevelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProductTypeLevelEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ProductTypeLevelEnum} ProductTypeLevelEnum instance
                         */
                        ProductTypeLevelEnum.create = function create(properties) {
                            return new ProductTypeLevelEnum(properties);
                        };

                        /**
                         * Encodes the specified ProductTypeLevelEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ProductTypeLevelEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ProductTypeLevelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProductTypeLevelEnum} message ProductTypeLevelEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductTypeLevelEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ProductTypeLevelEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ProductTypeLevelEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ProductTypeLevelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProductTypeLevelEnum} message ProductTypeLevelEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductTypeLevelEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ProductTypeLevelEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ProductTypeLevelEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ProductTypeLevelEnum} ProductTypeLevelEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductTypeLevelEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ProductTypeLevelEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ProductTypeLevelEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ProductTypeLevelEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ProductTypeLevelEnum} ProductTypeLevelEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductTypeLevelEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ProductTypeLevelEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ProductTypeLevelEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProductTypeLevelEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ProductTypeLevelEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ProductTypeLevelEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ProductTypeLevelEnum} ProductTypeLevelEnum
                         */
                        ProductTypeLevelEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ProductTypeLevelEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ProductTypeLevelEnum();
                        };

                        /**
                         * Creates a plain object from a ProductTypeLevelEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ProductTypeLevelEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ProductTypeLevelEnum} message ProductTypeLevelEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProductTypeLevelEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ProductTypeLevelEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ProductTypeLevelEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProductTypeLevelEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ProductTypeLevel enum.
                         * @name google.ads.googleads.v1.enums.ProductTypeLevelEnum.ProductTypeLevel
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} LEVEL1=7 LEVEL1 value
                         * @property {number} LEVEL2=8 LEVEL2 value
                         * @property {number} LEVEL3=9 LEVEL3 value
                         * @property {number} LEVEL4=10 LEVEL4 value
                         * @property {number} LEVEL5=11 LEVEL5 value
                         */
                        ProductTypeLevelEnum.ProductTypeLevel = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[7] = "LEVEL1"] = 7;
                            values[valuesById[8] = "LEVEL2"] = 8;
                            values[valuesById[9] = "LEVEL3"] = 9;
                            values[valuesById[10] = "LEVEL4"] = 10;
                            values[valuesById[11] = "LEVEL5"] = 11;
                            return values;
                        })();

                        return ProductTypeLevelEnum;
                    })();

                    enums.PromotionExtensionDiscountModifierEnum = (function() {

                        /**
                         * Properties of a PromotionExtensionDiscountModifierEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IPromotionExtensionDiscountModifierEnum
                         */

                        /**
                         * Constructs a new PromotionExtensionDiscountModifierEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a PromotionExtensionDiscountModifierEnum.
                         * @implements IPromotionExtensionDiscountModifierEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IPromotionExtensionDiscountModifierEnum=} [properties] Properties to set
                         */
                        function PromotionExtensionDiscountModifierEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PromotionExtensionDiscountModifierEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPromotionExtensionDiscountModifierEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum} PromotionExtensionDiscountModifierEnum instance
                         */
                        PromotionExtensionDiscountModifierEnum.create = function create(properties) {
                            return new PromotionExtensionDiscountModifierEnum(properties);
                        };

                        /**
                         * Encodes the specified PromotionExtensionDiscountModifierEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPromotionExtensionDiscountModifierEnum} message PromotionExtensionDiscountModifierEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PromotionExtensionDiscountModifierEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PromotionExtensionDiscountModifierEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPromotionExtensionDiscountModifierEnum} message PromotionExtensionDiscountModifierEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PromotionExtensionDiscountModifierEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PromotionExtensionDiscountModifierEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum} PromotionExtensionDiscountModifierEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PromotionExtensionDiscountModifierEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PromotionExtensionDiscountModifierEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum} PromotionExtensionDiscountModifierEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PromotionExtensionDiscountModifierEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PromotionExtensionDiscountModifierEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PromotionExtensionDiscountModifierEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PromotionExtensionDiscountModifierEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum} PromotionExtensionDiscountModifierEnum
                         */
                        PromotionExtensionDiscountModifierEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum();
                        };

                        /**
                         * Creates a plain object from a PromotionExtensionDiscountModifierEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum} message PromotionExtensionDiscountModifierEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PromotionExtensionDiscountModifierEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PromotionExtensionDiscountModifierEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PromotionExtensionDiscountModifierEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PromotionExtensionDiscountModifier enum.
                         * @name google.ads.googleads.v1.enums.PromotionExtensionDiscountModifierEnum.PromotionExtensionDiscountModifier
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} UP_TO=2 UP_TO value
                         */
                        PromotionExtensionDiscountModifierEnum.PromotionExtensionDiscountModifier = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "UP_TO"] = 2;
                            return values;
                        })();

                        return PromotionExtensionDiscountModifierEnum;
                    })();

                    enums.PromotionExtensionOccasionEnum = (function() {

                        /**
                         * Properties of a PromotionExtensionOccasionEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IPromotionExtensionOccasionEnum
                         */

                        /**
                         * Constructs a new PromotionExtensionOccasionEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a PromotionExtensionOccasionEnum.
                         * @implements IPromotionExtensionOccasionEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IPromotionExtensionOccasionEnum=} [properties] Properties to set
                         */
                        function PromotionExtensionOccasionEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PromotionExtensionOccasionEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPromotionExtensionOccasionEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum} PromotionExtensionOccasionEnum instance
                         */
                        PromotionExtensionOccasionEnum.create = function create(properties) {
                            return new PromotionExtensionOccasionEnum(properties);
                        };

                        /**
                         * Encodes the specified PromotionExtensionOccasionEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPromotionExtensionOccasionEnum} message PromotionExtensionOccasionEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PromotionExtensionOccasionEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PromotionExtensionOccasionEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPromotionExtensionOccasionEnum} message PromotionExtensionOccasionEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PromotionExtensionOccasionEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PromotionExtensionOccasionEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum} PromotionExtensionOccasionEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PromotionExtensionOccasionEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PromotionExtensionOccasionEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum} PromotionExtensionOccasionEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PromotionExtensionOccasionEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PromotionExtensionOccasionEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PromotionExtensionOccasionEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PromotionExtensionOccasionEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum} PromotionExtensionOccasionEnum
                         */
                        PromotionExtensionOccasionEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum();
                        };

                        /**
                         * Creates a plain object from a PromotionExtensionOccasionEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum} message PromotionExtensionOccasionEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PromotionExtensionOccasionEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PromotionExtensionOccasionEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PromotionExtensionOccasionEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PromotionExtensionOccasion enum.
                         * @name google.ads.googleads.v1.enums.PromotionExtensionOccasionEnum.PromotionExtensionOccasion
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} NEW_YEARS=2 NEW_YEARS value
                         * @property {number} CHINESE_NEW_YEAR=3 CHINESE_NEW_YEAR value
                         * @property {number} VALENTINES_DAY=4 VALENTINES_DAY value
                         * @property {number} EASTER=5 EASTER value
                         * @property {number} MOTHERS_DAY=6 MOTHERS_DAY value
                         * @property {number} FATHERS_DAY=7 FATHERS_DAY value
                         * @property {number} LABOR_DAY=8 LABOR_DAY value
                         * @property {number} BACK_TO_SCHOOL=9 BACK_TO_SCHOOL value
                         * @property {number} HALLOWEEN=10 HALLOWEEN value
                         * @property {number} BLACK_FRIDAY=11 BLACK_FRIDAY value
                         * @property {number} CYBER_MONDAY=12 CYBER_MONDAY value
                         * @property {number} CHRISTMAS=13 CHRISTMAS value
                         * @property {number} BOXING_DAY=14 BOXING_DAY value
                         * @property {number} INDEPENDENCE_DAY=15 INDEPENDENCE_DAY value
                         * @property {number} NATIONAL_DAY=16 NATIONAL_DAY value
                         * @property {number} END_OF_SEASON=17 END_OF_SEASON value
                         * @property {number} WINTER_SALE=18 WINTER_SALE value
                         * @property {number} SUMMER_SALE=19 SUMMER_SALE value
                         * @property {number} FALL_SALE=20 FALL_SALE value
                         * @property {number} SPRING_SALE=21 SPRING_SALE value
                         * @property {number} RAMADAN=22 RAMADAN value
                         * @property {number} EID_AL_FITR=23 EID_AL_FITR value
                         * @property {number} EID_AL_ADHA=24 EID_AL_ADHA value
                         * @property {number} SINGLES_DAY=25 SINGLES_DAY value
                         * @property {number} WOMENS_DAY=26 WOMENS_DAY value
                         * @property {number} HOLI=27 HOLI value
                         * @property {number} PARENTS_DAY=28 PARENTS_DAY value
                         * @property {number} ST_NICHOLAS_DAY=29 ST_NICHOLAS_DAY value
                         * @property {number} CARNIVAL=30 CARNIVAL value
                         * @property {number} EPIPHANY=31 EPIPHANY value
                         * @property {number} ROSH_HASHANAH=32 ROSH_HASHANAH value
                         * @property {number} PASSOVER=33 PASSOVER value
                         * @property {number} HANUKKAH=34 HANUKKAH value
                         * @property {number} DIWALI=35 DIWALI value
                         * @property {number} NAVRATRI=36 NAVRATRI value
                         * @property {number} SONGKRAN=37 SONGKRAN value
                         * @property {number} YEAR_END_GIFT=38 YEAR_END_GIFT value
                         */
                        PromotionExtensionOccasionEnum.PromotionExtensionOccasion = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "NEW_YEARS"] = 2;
                            values[valuesById[3] = "CHINESE_NEW_YEAR"] = 3;
                            values[valuesById[4] = "VALENTINES_DAY"] = 4;
                            values[valuesById[5] = "EASTER"] = 5;
                            values[valuesById[6] = "MOTHERS_DAY"] = 6;
                            values[valuesById[7] = "FATHERS_DAY"] = 7;
                            values[valuesById[8] = "LABOR_DAY"] = 8;
                            values[valuesById[9] = "BACK_TO_SCHOOL"] = 9;
                            values[valuesById[10] = "HALLOWEEN"] = 10;
                            values[valuesById[11] = "BLACK_FRIDAY"] = 11;
                            values[valuesById[12] = "CYBER_MONDAY"] = 12;
                            values[valuesById[13] = "CHRISTMAS"] = 13;
                            values[valuesById[14] = "BOXING_DAY"] = 14;
                            values[valuesById[15] = "INDEPENDENCE_DAY"] = 15;
                            values[valuesById[16] = "NATIONAL_DAY"] = 16;
                            values[valuesById[17] = "END_OF_SEASON"] = 17;
                            values[valuesById[18] = "WINTER_SALE"] = 18;
                            values[valuesById[19] = "SUMMER_SALE"] = 19;
                            values[valuesById[20] = "FALL_SALE"] = 20;
                            values[valuesById[21] = "SPRING_SALE"] = 21;
                            values[valuesById[22] = "RAMADAN"] = 22;
                            values[valuesById[23] = "EID_AL_FITR"] = 23;
                            values[valuesById[24] = "EID_AL_ADHA"] = 24;
                            values[valuesById[25] = "SINGLES_DAY"] = 25;
                            values[valuesById[26] = "WOMENS_DAY"] = 26;
                            values[valuesById[27] = "HOLI"] = 27;
                            values[valuesById[28] = "PARENTS_DAY"] = 28;
                            values[valuesById[29] = "ST_NICHOLAS_DAY"] = 29;
                            values[valuesById[30] = "CARNIVAL"] = 30;
                            values[valuesById[31] = "EPIPHANY"] = 31;
                            values[valuesById[32] = "ROSH_HASHANAH"] = 32;
                            values[valuesById[33] = "PASSOVER"] = 33;
                            values[valuesById[34] = "HANUKKAH"] = 34;
                            values[valuesById[35] = "DIWALI"] = 35;
                            values[valuesById[36] = "NAVRATRI"] = 36;
                            values[valuesById[37] = "SONGKRAN"] = 37;
                            values[valuesById[38] = "YEAR_END_GIFT"] = 38;
                            return values;
                        })();

                        return PromotionExtensionOccasionEnum;
                    })();

                    enums.PromotionPlaceholderFieldEnum = (function() {

                        /**
                         * Properties of a PromotionPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IPromotionPlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new PromotionPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a PromotionPlaceholderFieldEnum.
                         * @implements IPromotionPlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IPromotionPlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function PromotionPlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new PromotionPlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPromotionPlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum} PromotionPlaceholderFieldEnum instance
                         */
                        PromotionPlaceholderFieldEnum.create = function create(properties) {
                            return new PromotionPlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified PromotionPlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPromotionPlaceholderFieldEnum} message PromotionPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PromotionPlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified PromotionPlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IPromotionPlaceholderFieldEnum} message PromotionPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PromotionPlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PromotionPlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum} PromotionPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PromotionPlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PromotionPlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum} PromotionPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PromotionPlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PromotionPlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PromotionPlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a PromotionPlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum} PromotionPlaceholderFieldEnum
                         */
                        PromotionPlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from a PromotionPlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum} message PromotionPlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PromotionPlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this PromotionPlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PromotionPlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * PromotionPlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum.PromotionPlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} PROMOTION_TARGET=2 PROMOTION_TARGET value
                         * @property {number} DISCOUNT_MODIFIER=3 DISCOUNT_MODIFIER value
                         * @property {number} PERCENT_OFF=4 PERCENT_OFF value
                         * @property {number} MONEY_AMOUNT_OFF=5 MONEY_AMOUNT_OFF value
                         * @property {number} PROMOTION_CODE=6 PROMOTION_CODE value
                         * @property {number} ORDERS_OVER_AMOUNT=7 ORDERS_OVER_AMOUNT value
                         * @property {number} PROMOTION_START=8 PROMOTION_START value
                         * @property {number} PROMOTION_END=9 PROMOTION_END value
                         * @property {number} OCCASION=10 OCCASION value
                         * @property {number} FINAL_URLS=11 FINAL_URLS value
                         * @property {number} FINAL_MOBILE_URLS=12 FINAL_MOBILE_URLS value
                         * @property {number} TRACKING_URL=13 TRACKING_URL value
                         * @property {number} LANGUAGE=14 LANGUAGE value
                         * @property {number} FINAL_URL_SUFFIX=15 FINAL_URL_SUFFIX value
                         */
                        PromotionPlaceholderFieldEnum.PromotionPlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "PROMOTION_TARGET"] = 2;
                            values[valuesById[3] = "DISCOUNT_MODIFIER"] = 3;
                            values[valuesById[4] = "PERCENT_OFF"] = 4;
                            values[valuesById[5] = "MONEY_AMOUNT_OFF"] = 5;
                            values[valuesById[6] = "PROMOTION_CODE"] = 6;
                            values[valuesById[7] = "ORDERS_OVER_AMOUNT"] = 7;
                            values[valuesById[8] = "PROMOTION_START"] = 8;
                            values[valuesById[9] = "PROMOTION_END"] = 9;
                            values[valuesById[10] = "OCCASION"] = 10;
                            values[valuesById[11] = "FINAL_URLS"] = 11;
                            values[valuesById[12] = "FINAL_MOBILE_URLS"] = 12;
                            values[valuesById[13] = "TRACKING_URL"] = 13;
                            values[valuesById[14] = "LANGUAGE"] = 14;
                            values[valuesById[15] = "FINAL_URL_SUFFIX"] = 15;
                            return values;
                        })();

                        return PromotionPlaceholderFieldEnum;
                    })();

                    enums.ProximityRadiusUnitsEnum = (function() {

                        /**
                         * Properties of a ProximityRadiusUnitsEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IProximityRadiusUnitsEnum
                         */

                        /**
                         * Constructs a new ProximityRadiusUnitsEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ProximityRadiusUnitsEnum.
                         * @implements IProximityRadiusUnitsEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IProximityRadiusUnitsEnum=} [properties] Properties to set
                         */
                        function ProximityRadiusUnitsEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ProximityRadiusUnitsEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProximityRadiusUnitsEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum} ProximityRadiusUnitsEnum instance
                         */
                        ProximityRadiusUnitsEnum.create = function create(properties) {
                            return new ProximityRadiusUnitsEnum(properties);
                        };

                        /**
                         * Encodes the specified ProximityRadiusUnitsEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProximityRadiusUnitsEnum} message ProximityRadiusUnitsEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProximityRadiusUnitsEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ProximityRadiusUnitsEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IProximityRadiusUnitsEnum} message ProximityRadiusUnitsEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProximityRadiusUnitsEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ProximityRadiusUnitsEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum} ProximityRadiusUnitsEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProximityRadiusUnitsEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ProximityRadiusUnitsEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum} ProximityRadiusUnitsEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProximityRadiusUnitsEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ProximityRadiusUnitsEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProximityRadiusUnitsEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ProximityRadiusUnitsEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum} ProximityRadiusUnitsEnum
                         */
                        ProximityRadiusUnitsEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum();
                        };

                        /**
                         * Creates a plain object from a ProximityRadiusUnitsEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum} message ProximityRadiusUnitsEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProximityRadiusUnitsEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ProximityRadiusUnitsEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProximityRadiusUnitsEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ProximityRadiusUnits enum.
                         * @name google.ads.googleads.v1.enums.ProximityRadiusUnitsEnum.ProximityRadiusUnits
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} MILES=2 MILES value
                         * @property {number} KILOMETERS=3 KILOMETERS value
                         */
                        ProximityRadiusUnitsEnum.ProximityRadiusUnits = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "MILES"] = 2;
                            values[valuesById[3] = "KILOMETERS"] = 3;
                            return values;
                        })();

                        return ProximityRadiusUnitsEnum;
                    })();

                    enums.QualityScoreBucketEnum = (function() {

                        /**
                         * Properties of a QualityScoreBucketEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IQualityScoreBucketEnum
                         */

                        /**
                         * Constructs a new QualityScoreBucketEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a QualityScoreBucketEnum.
                         * @implements IQualityScoreBucketEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IQualityScoreBucketEnum=} [properties] Properties to set
                         */
                        function QualityScoreBucketEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new QualityScoreBucketEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.QualityScoreBucketEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IQualityScoreBucketEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.QualityScoreBucketEnum} QualityScoreBucketEnum instance
                         */
                        QualityScoreBucketEnum.create = function create(properties) {
                            return new QualityScoreBucketEnum(properties);
                        };

                        /**
                         * Encodes the specified QualityScoreBucketEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.QualityScoreBucketEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.QualityScoreBucketEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IQualityScoreBucketEnum} message QualityScoreBucketEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        QualityScoreBucketEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified QualityScoreBucketEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.QualityScoreBucketEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.QualityScoreBucketEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IQualityScoreBucketEnum} message QualityScoreBucketEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        QualityScoreBucketEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a QualityScoreBucketEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.QualityScoreBucketEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.QualityScoreBucketEnum} QualityScoreBucketEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        QualityScoreBucketEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.QualityScoreBucketEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a QualityScoreBucketEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.QualityScoreBucketEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.QualityScoreBucketEnum} QualityScoreBucketEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        QualityScoreBucketEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a QualityScoreBucketEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.QualityScoreBucketEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        QualityScoreBucketEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a QualityScoreBucketEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.QualityScoreBucketEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.QualityScoreBucketEnum} QualityScoreBucketEnum
                         */
                        QualityScoreBucketEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.QualityScoreBucketEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.QualityScoreBucketEnum();
                        };

                        /**
                         * Creates a plain object from a QualityScoreBucketEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.QualityScoreBucketEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.QualityScoreBucketEnum} message QualityScoreBucketEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        QualityScoreBucketEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this QualityScoreBucketEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.QualityScoreBucketEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        QualityScoreBucketEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * QualityScoreBucket enum.
                         * @name google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} BELOW_AVERAGE=2 BELOW_AVERAGE value
                         * @property {number} AVERAGE=3 AVERAGE value
                         * @property {number} ABOVE_AVERAGE=4 ABOVE_AVERAGE value
                         */
                        QualityScoreBucketEnum.QualityScoreBucket = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "BELOW_AVERAGE"] = 2;
                            values[valuesById[3] = "AVERAGE"] = 3;
                            values[valuesById[4] = "ABOVE_AVERAGE"] = 4;
                            return values;
                        })();

                        return QualityScoreBucketEnum;
                    })();

                    enums.RealEstatePlaceholderFieldEnum = (function() {

                        /**
                         * Properties of a RealEstatePlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IRealEstatePlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new RealEstatePlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a RealEstatePlaceholderFieldEnum.
                         * @implements IRealEstatePlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IRealEstatePlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function RealEstatePlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new RealEstatePlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IRealEstatePlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum} RealEstatePlaceholderFieldEnum instance
                         */
                        RealEstatePlaceholderFieldEnum.create = function create(properties) {
                            return new RealEstatePlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified RealEstatePlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IRealEstatePlaceholderFieldEnum} message RealEstatePlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RealEstatePlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified RealEstatePlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IRealEstatePlaceholderFieldEnum} message RealEstatePlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RealEstatePlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a RealEstatePlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum} RealEstatePlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RealEstatePlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a RealEstatePlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum} RealEstatePlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RealEstatePlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a RealEstatePlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RealEstatePlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a RealEstatePlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum} RealEstatePlaceholderFieldEnum
                         */
                        RealEstatePlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from a RealEstatePlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum} message RealEstatePlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RealEstatePlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this RealEstatePlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RealEstatePlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * RealEstatePlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum.RealEstatePlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} LISTING_ID=2 LISTING_ID value
                         * @property {number} LISTING_NAME=3 LISTING_NAME value
                         * @property {number} CITY_NAME=4 CITY_NAME value
                         * @property {number} DESCRIPTION=5 DESCRIPTION value
                         * @property {number} ADDRESS=6 ADDRESS value
                         * @property {number} PRICE=7 PRICE value
                         * @property {number} FORMATTED_PRICE=8 FORMATTED_PRICE value
                         * @property {number} IMAGE_URL=9 IMAGE_URL value
                         * @property {number} PROPERTY_TYPE=10 PROPERTY_TYPE value
                         * @property {number} LISTING_TYPE=11 LISTING_TYPE value
                         * @property {number} CONTEXTUAL_KEYWORDS=12 CONTEXTUAL_KEYWORDS value
                         * @property {number} FINAL_URLS=13 FINAL_URLS value
                         * @property {number} FINAL_MOBILE_URLS=14 FINAL_MOBILE_URLS value
                         * @property {number} TRACKING_URL=15 TRACKING_URL value
                         * @property {number} ANDROID_APP_LINK=16 ANDROID_APP_LINK value
                         * @property {number} SIMILAR_LISTING_IDS=17 SIMILAR_LISTING_IDS value
                         * @property {number} IOS_APP_LINK=18 IOS_APP_LINK value
                         * @property {number} IOS_APP_STORE_ID=19 IOS_APP_STORE_ID value
                         */
                        RealEstatePlaceholderFieldEnum.RealEstatePlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "LISTING_ID"] = 2;
                            values[valuesById[3] = "LISTING_NAME"] = 3;
                            values[valuesById[4] = "CITY_NAME"] = 4;
                            values[valuesById[5] = "DESCRIPTION"] = 5;
                            values[valuesById[6] = "ADDRESS"] = 6;
                            values[valuesById[7] = "PRICE"] = 7;
                            values[valuesById[8] = "FORMATTED_PRICE"] = 8;
                            values[valuesById[9] = "IMAGE_URL"] = 9;
                            values[valuesById[10] = "PROPERTY_TYPE"] = 10;
                            values[valuesById[11] = "LISTING_TYPE"] = 11;
                            values[valuesById[12] = "CONTEXTUAL_KEYWORDS"] = 12;
                            values[valuesById[13] = "FINAL_URLS"] = 13;
                            values[valuesById[14] = "FINAL_MOBILE_URLS"] = 14;
                            values[valuesById[15] = "TRACKING_URL"] = 15;
                            values[valuesById[16] = "ANDROID_APP_LINK"] = 16;
                            values[valuesById[17] = "SIMILAR_LISTING_IDS"] = 17;
                            values[valuesById[18] = "IOS_APP_LINK"] = 18;
                            values[valuesById[19] = "IOS_APP_STORE_ID"] = 19;
                            return values;
                        })();

                        return RealEstatePlaceholderFieldEnum;
                    })();

                    enums.RecommendationTypeEnum = (function() {

                        /**
                         * Properties of a RecommendationTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IRecommendationTypeEnum
                         */

                        /**
                         * Constructs a new RecommendationTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a RecommendationTypeEnum.
                         * @implements IRecommendationTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IRecommendationTypeEnum=} [properties] Properties to set
                         */
                        function RecommendationTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new RecommendationTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.RecommendationTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IRecommendationTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.RecommendationTypeEnum} RecommendationTypeEnum instance
                         */
                        RecommendationTypeEnum.create = function create(properties) {
                            return new RecommendationTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified RecommendationTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.RecommendationTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.RecommendationTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IRecommendationTypeEnum} message RecommendationTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RecommendationTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified RecommendationTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.RecommendationTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.RecommendationTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IRecommendationTypeEnum} message RecommendationTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RecommendationTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a RecommendationTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.RecommendationTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.RecommendationTypeEnum} RecommendationTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RecommendationTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.RecommendationTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a RecommendationTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.RecommendationTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.RecommendationTypeEnum} RecommendationTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RecommendationTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a RecommendationTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.RecommendationTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RecommendationTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a RecommendationTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.RecommendationTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.RecommendationTypeEnum} RecommendationTypeEnum
                         */
                        RecommendationTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.RecommendationTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.RecommendationTypeEnum();
                        };

                        /**
                         * Creates a plain object from a RecommendationTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.RecommendationTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.RecommendationTypeEnum} message RecommendationTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RecommendationTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this RecommendationTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.RecommendationTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RecommendationTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * RecommendationType enum.
                         * @name google.ads.googleads.v1.enums.RecommendationTypeEnum.RecommendationType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CAMPAIGN_BUDGET=2 CAMPAIGN_BUDGET value
                         * @property {number} KEYWORD=3 KEYWORD value
                         * @property {number} TEXT_AD=4 TEXT_AD value
                         * @property {number} TARGET_CPA_OPT_IN=5 TARGET_CPA_OPT_IN value
                         * @property {number} MAXIMIZE_CONVERSIONS_OPT_IN=6 MAXIMIZE_CONVERSIONS_OPT_IN value
                         * @property {number} ENHANCED_CPC_OPT_IN=7 ENHANCED_CPC_OPT_IN value
                         * @property {number} SEARCH_PARTNERS_OPT_IN=8 SEARCH_PARTNERS_OPT_IN value
                         * @property {number} MAXIMIZE_CLICKS_OPT_IN=9 MAXIMIZE_CLICKS_OPT_IN value
                         * @property {number} OPTIMIZE_AD_ROTATION=10 OPTIMIZE_AD_ROTATION value
                         * @property {number} CALLOUT_EXTENSION=11 CALLOUT_EXTENSION value
                         * @property {number} SITELINK_EXTENSION=12 SITELINK_EXTENSION value
                         * @property {number} CALL_EXTENSION=13 CALL_EXTENSION value
                         * @property {number} KEYWORD_MATCH_TYPE=14 KEYWORD_MATCH_TYPE value
                         * @property {number} MOVE_UNUSED_BUDGET=15 MOVE_UNUSED_BUDGET value
                         */
                        RecommendationTypeEnum.RecommendationType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CAMPAIGN_BUDGET"] = 2;
                            values[valuesById[3] = "KEYWORD"] = 3;
                            values[valuesById[4] = "TEXT_AD"] = 4;
                            values[valuesById[5] = "TARGET_CPA_OPT_IN"] = 5;
                            values[valuesById[6] = "MAXIMIZE_CONVERSIONS_OPT_IN"] = 6;
                            values[valuesById[7] = "ENHANCED_CPC_OPT_IN"] = 7;
                            values[valuesById[8] = "SEARCH_PARTNERS_OPT_IN"] = 8;
                            values[valuesById[9] = "MAXIMIZE_CLICKS_OPT_IN"] = 9;
                            values[valuesById[10] = "OPTIMIZE_AD_ROTATION"] = 10;
                            values[valuesById[11] = "CALLOUT_EXTENSION"] = 11;
                            values[valuesById[12] = "SITELINK_EXTENSION"] = 12;
                            values[valuesById[13] = "CALL_EXTENSION"] = 13;
                            values[valuesById[14] = "KEYWORD_MATCH_TYPE"] = 14;
                            values[valuesById[15] = "MOVE_UNUSED_BUDGET"] = 15;
                            return values;
                        })();

                        return RecommendationTypeEnum;
                    })();

                    enums.SearchEngineResultsPageTypeEnum = (function() {

                        /**
                         * Properties of a SearchEngineResultsPageTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ISearchEngineResultsPageTypeEnum
                         */

                        /**
                         * Constructs a new SearchEngineResultsPageTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a SearchEngineResultsPageTypeEnum.
                         * @implements ISearchEngineResultsPageTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ISearchEngineResultsPageTypeEnum=} [properties] Properties to set
                         */
                        function SearchEngineResultsPageTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new SearchEngineResultsPageTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISearchEngineResultsPageTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum} SearchEngineResultsPageTypeEnum instance
                         */
                        SearchEngineResultsPageTypeEnum.create = function create(properties) {
                            return new SearchEngineResultsPageTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified SearchEngineResultsPageTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISearchEngineResultsPageTypeEnum} message SearchEngineResultsPageTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchEngineResultsPageTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified SearchEngineResultsPageTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISearchEngineResultsPageTypeEnum} message SearchEngineResultsPageTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchEngineResultsPageTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SearchEngineResultsPageTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum} SearchEngineResultsPageTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchEngineResultsPageTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SearchEngineResultsPageTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum} SearchEngineResultsPageTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchEngineResultsPageTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SearchEngineResultsPageTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SearchEngineResultsPageTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a SearchEngineResultsPageTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum} SearchEngineResultsPageTypeEnum
                         */
                        SearchEngineResultsPageTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum();
                        };

                        /**
                         * Creates a plain object from a SearchEngineResultsPageTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum} message SearchEngineResultsPageTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SearchEngineResultsPageTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this SearchEngineResultsPageTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SearchEngineResultsPageTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * SearchEngineResultsPageType enum.
                         * @name google.ads.googleads.v1.enums.SearchEngineResultsPageTypeEnum.SearchEngineResultsPageType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ADS_ONLY=2 ADS_ONLY value
                         * @property {number} ORGANIC_ONLY=3 ORGANIC_ONLY value
                         * @property {number} ADS_AND_ORGANIC=4 ADS_AND_ORGANIC value
                         */
                        SearchEngineResultsPageTypeEnum.SearchEngineResultsPageType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ADS_ONLY"] = 2;
                            values[valuesById[3] = "ORGANIC_ONLY"] = 3;
                            values[valuesById[4] = "ADS_AND_ORGANIC"] = 4;
                            return values;
                        })();

                        return SearchEngineResultsPageTypeEnum;
                    })();

                    enums.SearchTermMatchTypeEnum = (function() {

                        /**
                         * Properties of a SearchTermMatchTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ISearchTermMatchTypeEnum
                         */

                        /**
                         * Constructs a new SearchTermMatchTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a SearchTermMatchTypeEnum.
                         * @implements ISearchTermMatchTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ISearchTermMatchTypeEnum=} [properties] Properties to set
                         */
                        function SearchTermMatchTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new SearchTermMatchTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.SearchTermMatchTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISearchTermMatchTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.SearchTermMatchTypeEnum} SearchTermMatchTypeEnum instance
                         */
                        SearchTermMatchTypeEnum.create = function create(properties) {
                            return new SearchTermMatchTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified SearchTermMatchTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.SearchTermMatchTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.SearchTermMatchTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISearchTermMatchTypeEnum} message SearchTermMatchTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchTermMatchTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified SearchTermMatchTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.SearchTermMatchTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SearchTermMatchTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISearchTermMatchTypeEnum} message SearchTermMatchTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchTermMatchTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SearchTermMatchTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.SearchTermMatchTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.SearchTermMatchTypeEnum} SearchTermMatchTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchTermMatchTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.SearchTermMatchTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SearchTermMatchTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SearchTermMatchTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.SearchTermMatchTypeEnum} SearchTermMatchTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchTermMatchTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SearchTermMatchTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.SearchTermMatchTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SearchTermMatchTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a SearchTermMatchTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.SearchTermMatchTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.SearchTermMatchTypeEnum} SearchTermMatchTypeEnum
                         */
                        SearchTermMatchTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.SearchTermMatchTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.SearchTermMatchTypeEnum();
                        };

                        /**
                         * Creates a plain object from a SearchTermMatchTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.SearchTermMatchTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.SearchTermMatchTypeEnum} message SearchTermMatchTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SearchTermMatchTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this SearchTermMatchTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.SearchTermMatchTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SearchTermMatchTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * SearchTermMatchType enum.
                         * @name google.ads.googleads.v1.enums.SearchTermMatchTypeEnum.SearchTermMatchType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} BROAD=2 BROAD value
                         * @property {number} EXACT=3 EXACT value
                         * @property {number} PHRASE=4 PHRASE value
                         * @property {number} NEAR_EXACT=5 NEAR_EXACT value
                         * @property {number} NEAR_PHRASE=6 NEAR_PHRASE value
                         */
                        SearchTermMatchTypeEnum.SearchTermMatchType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "BROAD"] = 2;
                            values[valuesById[3] = "EXACT"] = 3;
                            values[valuesById[4] = "PHRASE"] = 4;
                            values[valuesById[5] = "NEAR_EXACT"] = 5;
                            values[valuesById[6] = "NEAR_PHRASE"] = 6;
                            return values;
                        })();

                        return SearchTermMatchTypeEnum;
                    })();

                    enums.SearchTermTargetingStatusEnum = (function() {

                        /**
                         * Properties of a SearchTermTargetingStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ISearchTermTargetingStatusEnum
                         */

                        /**
                         * Constructs a new SearchTermTargetingStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a SearchTermTargetingStatusEnum.
                         * @implements ISearchTermTargetingStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ISearchTermTargetingStatusEnum=} [properties] Properties to set
                         */
                        function SearchTermTargetingStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new SearchTermTargetingStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISearchTermTargetingStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum} SearchTermTargetingStatusEnum instance
                         */
                        SearchTermTargetingStatusEnum.create = function create(properties) {
                            return new SearchTermTargetingStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified SearchTermTargetingStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISearchTermTargetingStatusEnum} message SearchTermTargetingStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchTermTargetingStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified SearchTermTargetingStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISearchTermTargetingStatusEnum} message SearchTermTargetingStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchTermTargetingStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SearchTermTargetingStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum} SearchTermTargetingStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchTermTargetingStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SearchTermTargetingStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum} SearchTermTargetingStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchTermTargetingStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SearchTermTargetingStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SearchTermTargetingStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a SearchTermTargetingStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum} SearchTermTargetingStatusEnum
                         */
                        SearchTermTargetingStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum();
                        };

                        /**
                         * Creates a plain object from a SearchTermTargetingStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum} message SearchTermTargetingStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SearchTermTargetingStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this SearchTermTargetingStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SearchTermTargetingStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * SearchTermTargetingStatus enum.
                         * @name google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum.SearchTermTargetingStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ADDED=2 ADDED value
                         * @property {number} EXCLUDED=3 EXCLUDED value
                         * @property {number} ADDED_EXCLUDED=4 ADDED_EXCLUDED value
                         * @property {number} NONE=5 NONE value
                         */
                        SearchTermTargetingStatusEnum.SearchTermTargetingStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ADDED"] = 2;
                            values[valuesById[3] = "EXCLUDED"] = 3;
                            values[valuesById[4] = "ADDED_EXCLUDED"] = 4;
                            values[valuesById[5] = "NONE"] = 5;
                            return values;
                        })();

                        return SearchTermTargetingStatusEnum;
                    })();

                    enums.ServedAssetFieldTypeEnum = (function() {

                        /**
                         * Properties of a ServedAssetFieldTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IServedAssetFieldTypeEnum
                         */

                        /**
                         * Constructs a new ServedAssetFieldTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a ServedAssetFieldTypeEnum.
                         * @implements IServedAssetFieldTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IServedAssetFieldTypeEnum=} [properties] Properties to set
                         */
                        function ServedAssetFieldTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ServedAssetFieldTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IServedAssetFieldTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum} ServedAssetFieldTypeEnum instance
                         */
                        ServedAssetFieldTypeEnum.create = function create(properties) {
                            return new ServedAssetFieldTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified ServedAssetFieldTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IServedAssetFieldTypeEnum} message ServedAssetFieldTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ServedAssetFieldTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ServedAssetFieldTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IServedAssetFieldTypeEnum} message ServedAssetFieldTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ServedAssetFieldTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ServedAssetFieldTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum} ServedAssetFieldTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ServedAssetFieldTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ServedAssetFieldTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum} ServedAssetFieldTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ServedAssetFieldTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ServedAssetFieldTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ServedAssetFieldTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ServedAssetFieldTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum} ServedAssetFieldTypeEnum
                         */
                        ServedAssetFieldTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum();
                        };

                        /**
                         * Creates a plain object from a ServedAssetFieldTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum} message ServedAssetFieldTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ServedAssetFieldTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ServedAssetFieldTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ServedAssetFieldTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * ServedAssetFieldType enum.
                         * @name google.ads.googleads.v1.enums.ServedAssetFieldTypeEnum.ServedAssetFieldType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} HEADLINE_1=2 HEADLINE_1 value
                         * @property {number} HEADLINE_2=3 HEADLINE_2 value
                         * @property {number} HEADLINE_3=4 HEADLINE_3 value
                         * @property {number} DESCRIPTION_1=5 DESCRIPTION_1 value
                         * @property {number} DESCRIPTION_2=6 DESCRIPTION_2 value
                         */
                        ServedAssetFieldTypeEnum.ServedAssetFieldType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "HEADLINE_1"] = 2;
                            values[valuesById[3] = "HEADLINE_2"] = 3;
                            values[valuesById[4] = "HEADLINE_3"] = 4;
                            values[valuesById[5] = "DESCRIPTION_1"] = 5;
                            values[valuesById[6] = "DESCRIPTION_2"] = 6;
                            return values;
                        })();

                        return ServedAssetFieldTypeEnum;
                    })();

                    enums.SharedSetStatusEnum = (function() {

                        /**
                         * Properties of a SharedSetStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ISharedSetStatusEnum
                         */

                        /**
                         * Constructs a new SharedSetStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a SharedSetStatusEnum.
                         * @implements ISharedSetStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ISharedSetStatusEnum=} [properties] Properties to set
                         */
                        function SharedSetStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new SharedSetStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.SharedSetStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISharedSetStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.SharedSetStatusEnum} SharedSetStatusEnum instance
                         */
                        SharedSetStatusEnum.create = function create(properties) {
                            return new SharedSetStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified SharedSetStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.SharedSetStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.SharedSetStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISharedSetStatusEnum} message SharedSetStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SharedSetStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified SharedSetStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.SharedSetStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SharedSetStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISharedSetStatusEnum} message SharedSetStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SharedSetStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SharedSetStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.SharedSetStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.SharedSetStatusEnum} SharedSetStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SharedSetStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.SharedSetStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SharedSetStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SharedSetStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.SharedSetStatusEnum} SharedSetStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SharedSetStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SharedSetStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.SharedSetStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SharedSetStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a SharedSetStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.SharedSetStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.SharedSetStatusEnum} SharedSetStatusEnum
                         */
                        SharedSetStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.SharedSetStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.SharedSetStatusEnum();
                        };

                        /**
                         * Creates a plain object from a SharedSetStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.SharedSetStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.SharedSetStatusEnum} message SharedSetStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SharedSetStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this SharedSetStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.SharedSetStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SharedSetStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * SharedSetStatus enum.
                         * @name google.ads.googleads.v1.enums.SharedSetStatusEnum.SharedSetStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENABLED=2 ENABLED value
                         * @property {number} REMOVED=3 REMOVED value
                         */
                        SharedSetStatusEnum.SharedSetStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENABLED"] = 2;
                            values[valuesById[3] = "REMOVED"] = 3;
                            return values;
                        })();

                        return SharedSetStatusEnum;
                    })();

                    enums.SharedSetTypeEnum = (function() {

                        /**
                         * Properties of a SharedSetTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ISharedSetTypeEnum
                         */

                        /**
                         * Constructs a new SharedSetTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a SharedSetTypeEnum.
                         * @implements ISharedSetTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ISharedSetTypeEnum=} [properties] Properties to set
                         */
                        function SharedSetTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new SharedSetTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.SharedSetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISharedSetTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.SharedSetTypeEnum} SharedSetTypeEnum instance
                         */
                        SharedSetTypeEnum.create = function create(properties) {
                            return new SharedSetTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified SharedSetTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.SharedSetTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.SharedSetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISharedSetTypeEnum} message SharedSetTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SharedSetTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified SharedSetTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.SharedSetTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SharedSetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISharedSetTypeEnum} message SharedSetTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SharedSetTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SharedSetTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.SharedSetTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.SharedSetTypeEnum} SharedSetTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SharedSetTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.SharedSetTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SharedSetTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SharedSetTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.SharedSetTypeEnum} SharedSetTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SharedSetTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SharedSetTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.SharedSetTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SharedSetTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a SharedSetTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.SharedSetTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.SharedSetTypeEnum} SharedSetTypeEnum
                         */
                        SharedSetTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.SharedSetTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.SharedSetTypeEnum();
                        };

                        /**
                         * Creates a plain object from a SharedSetTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.SharedSetTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.SharedSetTypeEnum} message SharedSetTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SharedSetTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this SharedSetTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.SharedSetTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SharedSetTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * SharedSetType enum.
                         * @name google.ads.googleads.v1.enums.SharedSetTypeEnum.SharedSetType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} NEGATIVE_KEYWORDS=2 NEGATIVE_KEYWORDS value
                         * @property {number} NEGATIVE_PLACEMENTS=3 NEGATIVE_PLACEMENTS value
                         */
                        SharedSetTypeEnum.SharedSetType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "NEGATIVE_KEYWORDS"] = 2;
                            values[valuesById[3] = "NEGATIVE_PLACEMENTS"] = 3;
                            return values;
                        })();

                        return SharedSetTypeEnum;
                    })();

                    enums.SimulationModificationMethodEnum = (function() {

                        /**
                         * Properties of a SimulationModificationMethodEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ISimulationModificationMethodEnum
                         */

                        /**
                         * Constructs a new SimulationModificationMethodEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a SimulationModificationMethodEnum.
                         * @implements ISimulationModificationMethodEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ISimulationModificationMethodEnum=} [properties] Properties to set
                         */
                        function SimulationModificationMethodEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new SimulationModificationMethodEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.SimulationModificationMethodEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISimulationModificationMethodEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.SimulationModificationMethodEnum} SimulationModificationMethodEnum instance
                         */
                        SimulationModificationMethodEnum.create = function create(properties) {
                            return new SimulationModificationMethodEnum(properties);
                        };

                        /**
                         * Encodes the specified SimulationModificationMethodEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.SimulationModificationMethodEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.SimulationModificationMethodEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISimulationModificationMethodEnum} message SimulationModificationMethodEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SimulationModificationMethodEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified SimulationModificationMethodEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.SimulationModificationMethodEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SimulationModificationMethodEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISimulationModificationMethodEnum} message SimulationModificationMethodEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SimulationModificationMethodEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SimulationModificationMethodEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.SimulationModificationMethodEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.SimulationModificationMethodEnum} SimulationModificationMethodEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SimulationModificationMethodEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.SimulationModificationMethodEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SimulationModificationMethodEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SimulationModificationMethodEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.SimulationModificationMethodEnum} SimulationModificationMethodEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SimulationModificationMethodEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SimulationModificationMethodEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.SimulationModificationMethodEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SimulationModificationMethodEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a SimulationModificationMethodEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.SimulationModificationMethodEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.SimulationModificationMethodEnum} SimulationModificationMethodEnum
                         */
                        SimulationModificationMethodEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.SimulationModificationMethodEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.SimulationModificationMethodEnum();
                        };

                        /**
                         * Creates a plain object from a SimulationModificationMethodEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.SimulationModificationMethodEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.SimulationModificationMethodEnum} message SimulationModificationMethodEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SimulationModificationMethodEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this SimulationModificationMethodEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.SimulationModificationMethodEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SimulationModificationMethodEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * SimulationModificationMethod enum.
                         * @name google.ads.googleads.v1.enums.SimulationModificationMethodEnum.SimulationModificationMethod
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} UNIFORM=2 UNIFORM value
                         * @property {number} DEFAULT=3 DEFAULT value
                         */
                        SimulationModificationMethodEnum.SimulationModificationMethod = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "UNIFORM"] = 2;
                            values[valuesById[3] = "DEFAULT"] = 3;
                            return values;
                        })();

                        return SimulationModificationMethodEnum;
                    })();

                    enums.SimulationTypeEnum = (function() {

                        /**
                         * Properties of a SimulationTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ISimulationTypeEnum
                         */

                        /**
                         * Constructs a new SimulationTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a SimulationTypeEnum.
                         * @implements ISimulationTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ISimulationTypeEnum=} [properties] Properties to set
                         */
                        function SimulationTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new SimulationTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.SimulationTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISimulationTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.SimulationTypeEnum} SimulationTypeEnum instance
                         */
                        SimulationTypeEnum.create = function create(properties) {
                            return new SimulationTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified SimulationTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.SimulationTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.SimulationTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISimulationTypeEnum} message SimulationTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SimulationTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified SimulationTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.SimulationTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SimulationTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISimulationTypeEnum} message SimulationTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SimulationTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SimulationTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.SimulationTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.SimulationTypeEnum} SimulationTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SimulationTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.SimulationTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SimulationTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SimulationTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.SimulationTypeEnum} SimulationTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SimulationTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SimulationTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.SimulationTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SimulationTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a SimulationTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.SimulationTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.SimulationTypeEnum} SimulationTypeEnum
                         */
                        SimulationTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.SimulationTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.SimulationTypeEnum();
                        };

                        /**
                         * Creates a plain object from a SimulationTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.SimulationTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.SimulationTypeEnum} message SimulationTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SimulationTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this SimulationTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.SimulationTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SimulationTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * SimulationType enum.
                         * @name google.ads.googleads.v1.enums.SimulationTypeEnum.SimulationType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CPC_BID=2 CPC_BID value
                         * @property {number} CPV_BID=3 CPV_BID value
                         * @property {number} TARGET_CPA=4 TARGET_CPA value
                         * @property {number} BID_MODIFIER=5 BID_MODIFIER value
                         */
                        SimulationTypeEnum.SimulationType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CPC_BID"] = 2;
                            values[valuesById[3] = "CPV_BID"] = 3;
                            values[valuesById[4] = "TARGET_CPA"] = 4;
                            values[valuesById[5] = "BID_MODIFIER"] = 5;
                            return values;
                        })();

                        return SimulationTypeEnum;
                    })();

                    enums.SitelinkPlaceholderFieldEnum = (function() {

                        /**
                         * Properties of a SitelinkPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ISitelinkPlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new SitelinkPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a SitelinkPlaceholderFieldEnum.
                         * @implements ISitelinkPlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ISitelinkPlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function SitelinkPlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new SitelinkPlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISitelinkPlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum} SitelinkPlaceholderFieldEnum instance
                         */
                        SitelinkPlaceholderFieldEnum.create = function create(properties) {
                            return new SitelinkPlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified SitelinkPlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISitelinkPlaceholderFieldEnum} message SitelinkPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SitelinkPlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified SitelinkPlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISitelinkPlaceholderFieldEnum} message SitelinkPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SitelinkPlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SitelinkPlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum} SitelinkPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SitelinkPlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SitelinkPlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum} SitelinkPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SitelinkPlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SitelinkPlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SitelinkPlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a SitelinkPlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum} SitelinkPlaceholderFieldEnum
                         */
                        SitelinkPlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from a SitelinkPlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum} message SitelinkPlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SitelinkPlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this SitelinkPlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SitelinkPlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * SitelinkPlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum.SitelinkPlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} TEXT=2 TEXT value
                         * @property {number} LINE_1=3 LINE_1 value
                         * @property {number} LINE_2=4 LINE_2 value
                         * @property {number} FINAL_URLS=5 FINAL_URLS value
                         * @property {number} FINAL_MOBILE_URLS=6 FINAL_MOBILE_URLS value
                         * @property {number} TRACKING_URL=7 TRACKING_URL value
                         * @property {number} FINAL_URL_SUFFIX=8 FINAL_URL_SUFFIX value
                         */
                        SitelinkPlaceholderFieldEnum.SitelinkPlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "TEXT"] = 2;
                            values[valuesById[3] = "LINE_1"] = 3;
                            values[valuesById[4] = "LINE_2"] = 4;
                            values[valuesById[5] = "FINAL_URLS"] = 5;
                            values[valuesById[6] = "FINAL_MOBILE_URLS"] = 6;
                            values[valuesById[7] = "TRACKING_URL"] = 7;
                            values[valuesById[8] = "FINAL_URL_SUFFIX"] = 8;
                            return values;
                        })();

                        return SitelinkPlaceholderFieldEnum;
                    })();

                    enums.SlotEnum = (function() {

                        /**
                         * Properties of a SlotEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ISlotEnum
                         */

                        /**
                         * Constructs a new SlotEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a SlotEnum.
                         * @implements ISlotEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ISlotEnum=} [properties] Properties to set
                         */
                        function SlotEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new SlotEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.SlotEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISlotEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.SlotEnum} SlotEnum instance
                         */
                        SlotEnum.create = function create(properties) {
                            return new SlotEnum(properties);
                        };

                        /**
                         * Encodes the specified SlotEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.SlotEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.SlotEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISlotEnum} message SlotEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SlotEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified SlotEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.SlotEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SlotEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISlotEnum} message SlotEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SlotEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SlotEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.SlotEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.SlotEnum} SlotEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SlotEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.SlotEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SlotEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SlotEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.SlotEnum} SlotEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SlotEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SlotEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.SlotEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SlotEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a SlotEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.SlotEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.SlotEnum} SlotEnum
                         */
                        SlotEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.SlotEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.SlotEnum();
                        };

                        /**
                         * Creates a plain object from a SlotEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.SlotEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.SlotEnum} message SlotEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SlotEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this SlotEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.SlotEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SlotEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * Slot enum.
                         * @name google.ads.googleads.v1.enums.SlotEnum.Slot
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} SEARCH_SIDE=2 SEARCH_SIDE value
                         * @property {number} SEARCH_TOP=3 SEARCH_TOP value
                         * @property {number} SEARCH_OTHER=4 SEARCH_OTHER value
                         * @property {number} CONTENT=5 CONTENT value
                         * @property {number} SEARCH_PARTNER_TOP=6 SEARCH_PARTNER_TOP value
                         * @property {number} SEARCH_PARTNER_OTHER=7 SEARCH_PARTNER_OTHER value
                         * @property {number} MIXED=8 MIXED value
                         */
                        SlotEnum.Slot = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "SEARCH_SIDE"] = 2;
                            values[valuesById[3] = "SEARCH_TOP"] = 3;
                            values[valuesById[4] = "SEARCH_OTHER"] = 4;
                            values[valuesById[5] = "CONTENT"] = 5;
                            values[valuesById[6] = "SEARCH_PARTNER_TOP"] = 6;
                            values[valuesById[7] = "SEARCH_PARTNER_OTHER"] = 7;
                            values[valuesById[8] = "MIXED"] = 8;
                            return values;
                        })();

                        return SlotEnum;
                    })();

                    enums.SpendingLimitTypeEnum = (function() {

                        /**
                         * Properties of a SpendingLimitTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ISpendingLimitTypeEnum
                         */

                        /**
                         * Constructs a new SpendingLimitTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a SpendingLimitTypeEnum.
                         * @implements ISpendingLimitTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ISpendingLimitTypeEnum=} [properties] Properties to set
                         */
                        function SpendingLimitTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new SpendingLimitTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.SpendingLimitTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISpendingLimitTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.SpendingLimitTypeEnum} SpendingLimitTypeEnum instance
                         */
                        SpendingLimitTypeEnum.create = function create(properties) {
                            return new SpendingLimitTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified SpendingLimitTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.SpendingLimitTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.SpendingLimitTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISpendingLimitTypeEnum} message SpendingLimitTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SpendingLimitTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified SpendingLimitTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.SpendingLimitTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SpendingLimitTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISpendingLimitTypeEnum} message SpendingLimitTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SpendingLimitTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SpendingLimitTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.SpendingLimitTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.SpendingLimitTypeEnum} SpendingLimitTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SpendingLimitTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.SpendingLimitTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SpendingLimitTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SpendingLimitTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.SpendingLimitTypeEnum} SpendingLimitTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SpendingLimitTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SpendingLimitTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.SpendingLimitTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SpendingLimitTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a SpendingLimitTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.SpendingLimitTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.SpendingLimitTypeEnum} SpendingLimitTypeEnum
                         */
                        SpendingLimitTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.SpendingLimitTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.SpendingLimitTypeEnum();
                        };

                        /**
                         * Creates a plain object from a SpendingLimitTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.SpendingLimitTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.SpendingLimitTypeEnum} message SpendingLimitTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SpendingLimitTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this SpendingLimitTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.SpendingLimitTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SpendingLimitTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * SpendingLimitType enum.
                         * @name google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} INFINITE=2 INFINITE value
                         */
                        SpendingLimitTypeEnum.SpendingLimitType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "INFINITE"] = 2;
                            return values;
                        })();

                        return SpendingLimitTypeEnum;
                    })();

                    enums.StructuredSnippetPlaceholderFieldEnum = (function() {

                        /**
                         * Properties of a StructuredSnippetPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IStructuredSnippetPlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new StructuredSnippetPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a StructuredSnippetPlaceholderFieldEnum.
                         * @implements IStructuredSnippetPlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IStructuredSnippetPlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function StructuredSnippetPlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new StructuredSnippetPlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IStructuredSnippetPlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum} StructuredSnippetPlaceholderFieldEnum instance
                         */
                        StructuredSnippetPlaceholderFieldEnum.create = function create(properties) {
                            return new StructuredSnippetPlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified StructuredSnippetPlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IStructuredSnippetPlaceholderFieldEnum} message StructuredSnippetPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StructuredSnippetPlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified StructuredSnippetPlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IStructuredSnippetPlaceholderFieldEnum} message StructuredSnippetPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StructuredSnippetPlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a StructuredSnippetPlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum} StructuredSnippetPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StructuredSnippetPlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a StructuredSnippetPlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum} StructuredSnippetPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StructuredSnippetPlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a StructuredSnippetPlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        StructuredSnippetPlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a StructuredSnippetPlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum} StructuredSnippetPlaceholderFieldEnum
                         */
                        StructuredSnippetPlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from a StructuredSnippetPlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum} message StructuredSnippetPlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        StructuredSnippetPlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this StructuredSnippetPlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        StructuredSnippetPlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * StructuredSnippetPlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum.StructuredSnippetPlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} HEADER=2 HEADER value
                         * @property {number} SNIPPETS=3 SNIPPETS value
                         */
                        StructuredSnippetPlaceholderFieldEnum.StructuredSnippetPlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "HEADER"] = 2;
                            values[valuesById[3] = "SNIPPETS"] = 3;
                            return values;
                        })();

                        return StructuredSnippetPlaceholderFieldEnum;
                    })();

                    enums.SystemManagedResourceSourceEnum = (function() {

                        /**
                         * Properties of a SystemManagedResourceSourceEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ISystemManagedResourceSourceEnum
                         */

                        /**
                         * Constructs a new SystemManagedResourceSourceEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a SystemManagedResourceSourceEnum.
                         * @implements ISystemManagedResourceSourceEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ISystemManagedResourceSourceEnum=} [properties] Properties to set
                         */
                        function SystemManagedResourceSourceEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new SystemManagedResourceSourceEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISystemManagedResourceSourceEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum} SystemManagedResourceSourceEnum instance
                         */
                        SystemManagedResourceSourceEnum.create = function create(properties) {
                            return new SystemManagedResourceSourceEnum(properties);
                        };

                        /**
                         * Encodes the specified SystemManagedResourceSourceEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISystemManagedResourceSourceEnum} message SystemManagedResourceSourceEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SystemManagedResourceSourceEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified SystemManagedResourceSourceEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ISystemManagedResourceSourceEnum} message SystemManagedResourceSourceEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SystemManagedResourceSourceEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SystemManagedResourceSourceEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum} SystemManagedResourceSourceEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SystemManagedResourceSourceEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SystemManagedResourceSourceEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum} SystemManagedResourceSourceEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SystemManagedResourceSourceEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SystemManagedResourceSourceEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SystemManagedResourceSourceEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a SystemManagedResourceSourceEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum} SystemManagedResourceSourceEnum
                         */
                        SystemManagedResourceSourceEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum();
                        };

                        /**
                         * Creates a plain object from a SystemManagedResourceSourceEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum} message SystemManagedResourceSourceEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SystemManagedResourceSourceEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this SystemManagedResourceSourceEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SystemManagedResourceSourceEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * SystemManagedResourceSource enum.
                         * @name google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum.SystemManagedResourceSource
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} AD_VARIATIONS=2 AD_VARIATIONS value
                         */
                        SystemManagedResourceSourceEnum.SystemManagedResourceSource = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "AD_VARIATIONS"] = 2;
                            return values;
                        })();

                        return SystemManagedResourceSourceEnum;
                    })();

                    enums.TargetCpaOptInRecommendationGoalEnum = (function() {

                        /**
                         * Properties of a TargetCpaOptInRecommendationGoalEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ITargetCpaOptInRecommendationGoalEnum
                         */

                        /**
                         * Constructs a new TargetCpaOptInRecommendationGoalEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a TargetCpaOptInRecommendationGoalEnum.
                         * @implements ITargetCpaOptInRecommendationGoalEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ITargetCpaOptInRecommendationGoalEnum=} [properties] Properties to set
                         */
                        function TargetCpaOptInRecommendationGoalEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new TargetCpaOptInRecommendationGoalEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITargetCpaOptInRecommendationGoalEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum} TargetCpaOptInRecommendationGoalEnum instance
                         */
                        TargetCpaOptInRecommendationGoalEnum.create = function create(properties) {
                            return new TargetCpaOptInRecommendationGoalEnum(properties);
                        };

                        /**
                         * Encodes the specified TargetCpaOptInRecommendationGoalEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITargetCpaOptInRecommendationGoalEnum} message TargetCpaOptInRecommendationGoalEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetCpaOptInRecommendationGoalEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified TargetCpaOptInRecommendationGoalEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITargetCpaOptInRecommendationGoalEnum} message TargetCpaOptInRecommendationGoalEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetCpaOptInRecommendationGoalEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TargetCpaOptInRecommendationGoalEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum} TargetCpaOptInRecommendationGoalEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetCpaOptInRecommendationGoalEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TargetCpaOptInRecommendationGoalEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum} TargetCpaOptInRecommendationGoalEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetCpaOptInRecommendationGoalEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TargetCpaOptInRecommendationGoalEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetCpaOptInRecommendationGoalEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a TargetCpaOptInRecommendationGoalEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum} TargetCpaOptInRecommendationGoalEnum
                         */
                        TargetCpaOptInRecommendationGoalEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum();
                        };

                        /**
                         * Creates a plain object from a TargetCpaOptInRecommendationGoalEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum} message TargetCpaOptInRecommendationGoalEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetCpaOptInRecommendationGoalEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this TargetCpaOptInRecommendationGoalEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetCpaOptInRecommendationGoalEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * TargetCpaOptInRecommendationGoal enum.
                         * @name google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum.TargetCpaOptInRecommendationGoal
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} SAME_COST=2 SAME_COST value
                         * @property {number} SAME_CONVERSIONS=3 SAME_CONVERSIONS value
                         * @property {number} SAME_CPA=4 SAME_CPA value
                         * @property {number} CLOSEST_CPA=5 CLOSEST_CPA value
                         */
                        TargetCpaOptInRecommendationGoalEnum.TargetCpaOptInRecommendationGoal = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "SAME_COST"] = 2;
                            values[valuesById[3] = "SAME_CONVERSIONS"] = 3;
                            values[valuesById[4] = "SAME_CPA"] = 4;
                            values[valuesById[5] = "CLOSEST_CPA"] = 5;
                            return values;
                        })();

                        return TargetCpaOptInRecommendationGoalEnum;
                    })();

                    enums.TargetImpressionShareLocationEnum = (function() {

                        /**
                         * Properties of a TargetImpressionShareLocationEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ITargetImpressionShareLocationEnum
                         */

                        /**
                         * Constructs a new TargetImpressionShareLocationEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a TargetImpressionShareLocationEnum.
                         * @implements ITargetImpressionShareLocationEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ITargetImpressionShareLocationEnum=} [properties] Properties to set
                         */
                        function TargetImpressionShareLocationEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new TargetImpressionShareLocationEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITargetImpressionShareLocationEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum} TargetImpressionShareLocationEnum instance
                         */
                        TargetImpressionShareLocationEnum.create = function create(properties) {
                            return new TargetImpressionShareLocationEnum(properties);
                        };

                        /**
                         * Encodes the specified TargetImpressionShareLocationEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITargetImpressionShareLocationEnum} message TargetImpressionShareLocationEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetImpressionShareLocationEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified TargetImpressionShareLocationEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITargetImpressionShareLocationEnum} message TargetImpressionShareLocationEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetImpressionShareLocationEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TargetImpressionShareLocationEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum} TargetImpressionShareLocationEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetImpressionShareLocationEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TargetImpressionShareLocationEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum} TargetImpressionShareLocationEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetImpressionShareLocationEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TargetImpressionShareLocationEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetImpressionShareLocationEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a TargetImpressionShareLocationEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum} TargetImpressionShareLocationEnum
                         */
                        TargetImpressionShareLocationEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum();
                        };

                        /**
                         * Creates a plain object from a TargetImpressionShareLocationEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum} message TargetImpressionShareLocationEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetImpressionShareLocationEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this TargetImpressionShareLocationEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetImpressionShareLocationEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * TargetImpressionShareLocation enum.
                         * @name google.ads.googleads.v1.enums.TargetImpressionShareLocationEnum.TargetImpressionShareLocation
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ANYWHERE_ON_PAGE=2 ANYWHERE_ON_PAGE value
                         * @property {number} TOP_OF_PAGE=3 TOP_OF_PAGE value
                         * @property {number} ABSOLUTE_TOP_OF_PAGE=4 ABSOLUTE_TOP_OF_PAGE value
                         */
                        TargetImpressionShareLocationEnum.TargetImpressionShareLocation = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ANYWHERE_ON_PAGE"] = 2;
                            values[valuesById[3] = "TOP_OF_PAGE"] = 3;
                            values[valuesById[4] = "ABSOLUTE_TOP_OF_PAGE"] = 4;
                            return values;
                        })();

                        return TargetImpressionShareLocationEnum;
                    })();

                    enums.TargetingDimensionEnum = (function() {

                        /**
                         * Properties of a TargetingDimensionEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ITargetingDimensionEnum
                         */

                        /**
                         * Constructs a new TargetingDimensionEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a TargetingDimensionEnum.
                         * @implements ITargetingDimensionEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ITargetingDimensionEnum=} [properties] Properties to set
                         */
                        function TargetingDimensionEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new TargetingDimensionEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.TargetingDimensionEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITargetingDimensionEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.TargetingDimensionEnum} TargetingDimensionEnum instance
                         */
                        TargetingDimensionEnum.create = function create(properties) {
                            return new TargetingDimensionEnum(properties);
                        };

                        /**
                         * Encodes the specified TargetingDimensionEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.TargetingDimensionEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.TargetingDimensionEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITargetingDimensionEnum} message TargetingDimensionEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetingDimensionEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified TargetingDimensionEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.TargetingDimensionEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.TargetingDimensionEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITargetingDimensionEnum} message TargetingDimensionEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetingDimensionEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TargetingDimensionEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.TargetingDimensionEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.TargetingDimensionEnum} TargetingDimensionEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetingDimensionEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.TargetingDimensionEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TargetingDimensionEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.TargetingDimensionEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.TargetingDimensionEnum} TargetingDimensionEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetingDimensionEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TargetingDimensionEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.TargetingDimensionEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetingDimensionEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a TargetingDimensionEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.TargetingDimensionEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.TargetingDimensionEnum} TargetingDimensionEnum
                         */
                        TargetingDimensionEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.TargetingDimensionEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.TargetingDimensionEnum();
                        };

                        /**
                         * Creates a plain object from a TargetingDimensionEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.TargetingDimensionEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.TargetingDimensionEnum} message TargetingDimensionEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetingDimensionEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this TargetingDimensionEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.TargetingDimensionEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetingDimensionEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * TargetingDimension enum.
                         * @name google.ads.googleads.v1.enums.TargetingDimensionEnum.TargetingDimension
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} KEYWORD=2 KEYWORD value
                         * @property {number} AUDIENCE=3 AUDIENCE value
                         * @property {number} TOPIC=4 TOPIC value
                         * @property {number} GENDER=5 GENDER value
                         * @property {number} AGE_RANGE=6 AGE_RANGE value
                         * @property {number} PLACEMENT=7 PLACEMENT value
                         * @property {number} PARENTAL_STATUS=8 PARENTAL_STATUS value
                         * @property {number} INCOME_RANGE=9 INCOME_RANGE value
                         */
                        TargetingDimensionEnum.TargetingDimension = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "KEYWORD"] = 2;
                            values[valuesById[3] = "AUDIENCE"] = 3;
                            values[valuesById[4] = "TOPIC"] = 4;
                            values[valuesById[5] = "GENDER"] = 5;
                            values[valuesById[6] = "AGE_RANGE"] = 6;
                            values[valuesById[7] = "PLACEMENT"] = 7;
                            values[valuesById[8] = "PARENTAL_STATUS"] = 8;
                            values[valuesById[9] = "INCOME_RANGE"] = 9;
                            return values;
                        })();

                        return TargetingDimensionEnum;
                    })();

                    enums.TimeTypeEnum = (function() {

                        /**
                         * Properties of a TimeTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ITimeTypeEnum
                         */

                        /**
                         * Constructs a new TimeTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a TimeTypeEnum.
                         * @implements ITimeTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ITimeTypeEnum=} [properties] Properties to set
                         */
                        function TimeTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new TimeTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.TimeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITimeTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.TimeTypeEnum} TimeTypeEnum instance
                         */
                        TimeTypeEnum.create = function create(properties) {
                            return new TimeTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified TimeTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.TimeTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.TimeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITimeTypeEnum} message TimeTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TimeTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified TimeTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.TimeTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.TimeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITimeTypeEnum} message TimeTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TimeTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TimeTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.TimeTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.TimeTypeEnum} TimeTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TimeTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.TimeTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TimeTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.TimeTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.TimeTypeEnum} TimeTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TimeTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TimeTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.TimeTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TimeTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a TimeTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.TimeTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.TimeTypeEnum} TimeTypeEnum
                         */
                        TimeTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.TimeTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.TimeTypeEnum();
                        };

                        /**
                         * Creates a plain object from a TimeTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.TimeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.TimeTypeEnum} message TimeTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TimeTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this TimeTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.TimeTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TimeTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * TimeType enum.
                         * @name google.ads.googleads.v1.enums.TimeTypeEnum.TimeType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} NOW=2 NOW value
                         * @property {number} FOREVER=3 FOREVER value
                         */
                        TimeTypeEnum.TimeType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "NOW"] = 2;
                            values[valuesById[3] = "FOREVER"] = 3;
                            return values;
                        })();

                        return TimeTypeEnum;
                    })();

                    enums.TrackingCodePageFormatEnum = (function() {

                        /**
                         * Properties of a TrackingCodePageFormatEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ITrackingCodePageFormatEnum
                         */

                        /**
                         * Constructs a new TrackingCodePageFormatEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a TrackingCodePageFormatEnum.
                         * @implements ITrackingCodePageFormatEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ITrackingCodePageFormatEnum=} [properties] Properties to set
                         */
                        function TrackingCodePageFormatEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new TrackingCodePageFormatEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.TrackingCodePageFormatEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITrackingCodePageFormatEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.TrackingCodePageFormatEnum} TrackingCodePageFormatEnum instance
                         */
                        TrackingCodePageFormatEnum.create = function create(properties) {
                            return new TrackingCodePageFormatEnum(properties);
                        };

                        /**
                         * Encodes the specified TrackingCodePageFormatEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.TrackingCodePageFormatEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.TrackingCodePageFormatEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITrackingCodePageFormatEnum} message TrackingCodePageFormatEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TrackingCodePageFormatEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified TrackingCodePageFormatEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.TrackingCodePageFormatEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.TrackingCodePageFormatEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITrackingCodePageFormatEnum} message TrackingCodePageFormatEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TrackingCodePageFormatEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TrackingCodePageFormatEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.TrackingCodePageFormatEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.TrackingCodePageFormatEnum} TrackingCodePageFormatEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TrackingCodePageFormatEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.TrackingCodePageFormatEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TrackingCodePageFormatEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.TrackingCodePageFormatEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.TrackingCodePageFormatEnum} TrackingCodePageFormatEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TrackingCodePageFormatEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TrackingCodePageFormatEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.TrackingCodePageFormatEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TrackingCodePageFormatEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a TrackingCodePageFormatEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.TrackingCodePageFormatEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.TrackingCodePageFormatEnum} TrackingCodePageFormatEnum
                         */
                        TrackingCodePageFormatEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.TrackingCodePageFormatEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.TrackingCodePageFormatEnum();
                        };

                        /**
                         * Creates a plain object from a TrackingCodePageFormatEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.TrackingCodePageFormatEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.TrackingCodePageFormatEnum} message TrackingCodePageFormatEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TrackingCodePageFormatEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this TrackingCodePageFormatEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.TrackingCodePageFormatEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TrackingCodePageFormatEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * TrackingCodePageFormat enum.
                         * @name google.ads.googleads.v1.enums.TrackingCodePageFormatEnum.TrackingCodePageFormat
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} HTML=2 HTML value
                         * @property {number} AMP=3 AMP value
                         */
                        TrackingCodePageFormatEnum.TrackingCodePageFormat = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "HTML"] = 2;
                            values[valuesById[3] = "AMP"] = 3;
                            return values;
                        })();

                        return TrackingCodePageFormatEnum;
                    })();

                    enums.TrackingCodeTypeEnum = (function() {

                        /**
                         * Properties of a TrackingCodeTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ITrackingCodeTypeEnum
                         */

                        /**
                         * Constructs a new TrackingCodeTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a TrackingCodeTypeEnum.
                         * @implements ITrackingCodeTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ITrackingCodeTypeEnum=} [properties] Properties to set
                         */
                        function TrackingCodeTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new TrackingCodeTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.TrackingCodeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITrackingCodeTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.TrackingCodeTypeEnum} TrackingCodeTypeEnum instance
                         */
                        TrackingCodeTypeEnum.create = function create(properties) {
                            return new TrackingCodeTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified TrackingCodeTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.TrackingCodeTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.TrackingCodeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITrackingCodeTypeEnum} message TrackingCodeTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TrackingCodeTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified TrackingCodeTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.TrackingCodeTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.TrackingCodeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITrackingCodeTypeEnum} message TrackingCodeTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TrackingCodeTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TrackingCodeTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.TrackingCodeTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.TrackingCodeTypeEnum} TrackingCodeTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TrackingCodeTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.TrackingCodeTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TrackingCodeTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.TrackingCodeTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.TrackingCodeTypeEnum} TrackingCodeTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TrackingCodeTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TrackingCodeTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.TrackingCodeTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TrackingCodeTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a TrackingCodeTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.TrackingCodeTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.TrackingCodeTypeEnum} TrackingCodeTypeEnum
                         */
                        TrackingCodeTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.TrackingCodeTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.TrackingCodeTypeEnum();
                        };

                        /**
                         * Creates a plain object from a TrackingCodeTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.TrackingCodeTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.TrackingCodeTypeEnum} message TrackingCodeTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TrackingCodeTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this TrackingCodeTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.TrackingCodeTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TrackingCodeTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * TrackingCodeType enum.
                         * @name google.ads.googleads.v1.enums.TrackingCodeTypeEnum.TrackingCodeType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} WEBPAGE=2 WEBPAGE value
                         * @property {number} WEBPAGE_ONCLICK=3 WEBPAGE_ONCLICK value
                         * @property {number} CLICK_TO_CALL=4 CLICK_TO_CALL value
                         */
                        TrackingCodeTypeEnum.TrackingCodeType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "WEBPAGE"] = 2;
                            values[valuesById[3] = "WEBPAGE_ONCLICK"] = 3;
                            values[valuesById[4] = "CLICK_TO_CALL"] = 4;
                            return values;
                        })();

                        return TrackingCodeTypeEnum;
                    })();

                    enums.TravelPlaceholderFieldEnum = (function() {

                        /**
                         * Properties of a TravelPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface ITravelPlaceholderFieldEnum
                         */

                        /**
                         * Constructs a new TravelPlaceholderFieldEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a TravelPlaceholderFieldEnum.
                         * @implements ITravelPlaceholderFieldEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.ITravelPlaceholderFieldEnum=} [properties] Properties to set
                         */
                        function TravelPlaceholderFieldEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new TravelPlaceholderFieldEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITravelPlaceholderFieldEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum} TravelPlaceholderFieldEnum instance
                         */
                        TravelPlaceholderFieldEnum.create = function create(properties) {
                            return new TravelPlaceholderFieldEnum(properties);
                        };

                        /**
                         * Encodes the specified TravelPlaceholderFieldEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITravelPlaceholderFieldEnum} message TravelPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TravelPlaceholderFieldEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified TravelPlaceholderFieldEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.ITravelPlaceholderFieldEnum} message TravelPlaceholderFieldEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TravelPlaceholderFieldEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TravelPlaceholderFieldEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum} TravelPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TravelPlaceholderFieldEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TravelPlaceholderFieldEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum} TravelPlaceholderFieldEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TravelPlaceholderFieldEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TravelPlaceholderFieldEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TravelPlaceholderFieldEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a TravelPlaceholderFieldEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum} TravelPlaceholderFieldEnum
                         */
                        TravelPlaceholderFieldEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum();
                        };

                        /**
                         * Creates a plain object from a TravelPlaceholderFieldEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum} message TravelPlaceholderFieldEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TravelPlaceholderFieldEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this TravelPlaceholderFieldEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TravelPlaceholderFieldEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * TravelPlaceholderField enum.
                         * @name google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum.TravelPlaceholderField
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} DESTINATION_ID=2 DESTINATION_ID value
                         * @property {number} ORIGIN_ID=3 ORIGIN_ID value
                         * @property {number} TITLE=4 TITLE value
                         * @property {number} DESTINATION_NAME=5 DESTINATION_NAME value
                         * @property {number} ORIGIN_NAME=6 ORIGIN_NAME value
                         * @property {number} PRICE=7 PRICE value
                         * @property {number} FORMATTED_PRICE=8 FORMATTED_PRICE value
                         * @property {number} SALE_PRICE=9 SALE_PRICE value
                         * @property {number} FORMATTED_SALE_PRICE=10 FORMATTED_SALE_PRICE value
                         * @property {number} IMAGE_URL=11 IMAGE_URL value
                         * @property {number} CATEGORY=12 CATEGORY value
                         * @property {number} CONTEXTUAL_KEYWORDS=13 CONTEXTUAL_KEYWORDS value
                         * @property {number} DESTINATION_ADDRESS=14 DESTINATION_ADDRESS value
                         * @property {number} FINAL_URL=15 FINAL_URL value
                         * @property {number} FINAL_MOBILE_URLS=16 FINAL_MOBILE_URLS value
                         * @property {number} TRACKING_URL=17 TRACKING_URL value
                         * @property {number} ANDROID_APP_LINK=18 ANDROID_APP_LINK value
                         * @property {number} SIMILAR_DESTINATION_IDS=19 SIMILAR_DESTINATION_IDS value
                         * @property {number} IOS_APP_LINK=20 IOS_APP_LINK value
                         * @property {number} IOS_APP_STORE_ID=21 IOS_APP_STORE_ID value
                         */
                        TravelPlaceholderFieldEnum.TravelPlaceholderField = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "DESTINATION_ID"] = 2;
                            values[valuesById[3] = "ORIGIN_ID"] = 3;
                            values[valuesById[4] = "TITLE"] = 4;
                            values[valuesById[5] = "DESTINATION_NAME"] = 5;
                            values[valuesById[6] = "ORIGIN_NAME"] = 6;
                            values[valuesById[7] = "PRICE"] = 7;
                            values[valuesById[8] = "FORMATTED_PRICE"] = 8;
                            values[valuesById[9] = "SALE_PRICE"] = 9;
                            values[valuesById[10] = "FORMATTED_SALE_PRICE"] = 10;
                            values[valuesById[11] = "IMAGE_URL"] = 11;
                            values[valuesById[12] = "CATEGORY"] = 12;
                            values[valuesById[13] = "CONTEXTUAL_KEYWORDS"] = 13;
                            values[valuesById[14] = "DESTINATION_ADDRESS"] = 14;
                            values[valuesById[15] = "FINAL_URL"] = 15;
                            values[valuesById[16] = "FINAL_MOBILE_URLS"] = 16;
                            values[valuesById[17] = "TRACKING_URL"] = 17;
                            values[valuesById[18] = "ANDROID_APP_LINK"] = 18;
                            values[valuesById[19] = "SIMILAR_DESTINATION_IDS"] = 19;
                            values[valuesById[20] = "IOS_APP_LINK"] = 20;
                            values[valuesById[21] = "IOS_APP_STORE_ID"] = 21;
                            return values;
                        })();

                        return TravelPlaceholderFieldEnum;
                    })();

                    enums.UserInterestTaxonomyTypeEnum = (function() {

                        /**
                         * Properties of a UserInterestTaxonomyTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IUserInterestTaxonomyTypeEnum
                         */

                        /**
                         * Constructs a new UserInterestTaxonomyTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a UserInterestTaxonomyTypeEnum.
                         * @implements IUserInterestTaxonomyTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IUserInterestTaxonomyTypeEnum=} [properties] Properties to set
                         */
                        function UserInterestTaxonomyTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new UserInterestTaxonomyTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserInterestTaxonomyTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum} UserInterestTaxonomyTypeEnum instance
                         */
                        UserInterestTaxonomyTypeEnum.create = function create(properties) {
                            return new UserInterestTaxonomyTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified UserInterestTaxonomyTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserInterestTaxonomyTypeEnum} message UserInterestTaxonomyTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserInterestTaxonomyTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserInterestTaxonomyTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserInterestTaxonomyTypeEnum} message UserInterestTaxonomyTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserInterestTaxonomyTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserInterestTaxonomyTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum} UserInterestTaxonomyTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserInterestTaxonomyTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserInterestTaxonomyTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum} UserInterestTaxonomyTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserInterestTaxonomyTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserInterestTaxonomyTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserInterestTaxonomyTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a UserInterestTaxonomyTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum} UserInterestTaxonomyTypeEnum
                         */
                        UserInterestTaxonomyTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum();
                        };

                        /**
                         * Creates a plain object from a UserInterestTaxonomyTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum} message UserInterestTaxonomyTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserInterestTaxonomyTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this UserInterestTaxonomyTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserInterestTaxonomyTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * UserInterestTaxonomyType enum.
                         * @name google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum.UserInterestTaxonomyType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} AFFINITY=2 AFFINITY value
                         * @property {number} IN_MARKET=3 IN_MARKET value
                         * @property {number} MOBILE_APP_INSTALL_USER=4 MOBILE_APP_INSTALL_USER value
                         * @property {number} VERTICAL_GEO=5 VERTICAL_GEO value
                         * @property {number} NEW_SMART_PHONE_USER=6 NEW_SMART_PHONE_USER value
                         */
                        UserInterestTaxonomyTypeEnum.UserInterestTaxonomyType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "AFFINITY"] = 2;
                            values[valuesById[3] = "IN_MARKET"] = 3;
                            values[valuesById[4] = "MOBILE_APP_INSTALL_USER"] = 4;
                            values[valuesById[5] = "VERTICAL_GEO"] = 5;
                            values[valuesById[6] = "NEW_SMART_PHONE_USER"] = 6;
                            return values;
                        })();

                        return UserInterestTaxonomyTypeEnum;
                    })();

                    enums.UserListAccessStatusEnum = (function() {

                        /**
                         * Properties of a UserListAccessStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IUserListAccessStatusEnum
                         */

                        /**
                         * Constructs a new UserListAccessStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a UserListAccessStatusEnum.
                         * @implements IUserListAccessStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IUserListAccessStatusEnum=} [properties] Properties to set
                         */
                        function UserListAccessStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new UserListAccessStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.UserListAccessStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListAccessStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.UserListAccessStatusEnum} UserListAccessStatusEnum instance
                         */
                        UserListAccessStatusEnum.create = function create(properties) {
                            return new UserListAccessStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified UserListAccessStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.UserListAccessStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.UserListAccessStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListAccessStatusEnum} message UserListAccessStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListAccessStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListAccessStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.UserListAccessStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListAccessStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListAccessStatusEnum} message UserListAccessStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListAccessStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListAccessStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.UserListAccessStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.UserListAccessStatusEnum} UserListAccessStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListAccessStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.UserListAccessStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListAccessStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListAccessStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.UserListAccessStatusEnum} UserListAccessStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListAccessStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListAccessStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.UserListAccessStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListAccessStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a UserListAccessStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.UserListAccessStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.UserListAccessStatusEnum} UserListAccessStatusEnum
                         */
                        UserListAccessStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.UserListAccessStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.UserListAccessStatusEnum();
                        };

                        /**
                         * Creates a plain object from a UserListAccessStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.UserListAccessStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.UserListAccessStatusEnum} message UserListAccessStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListAccessStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this UserListAccessStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.UserListAccessStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListAccessStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * UserListAccessStatus enum.
                         * @name google.ads.googleads.v1.enums.UserListAccessStatusEnum.UserListAccessStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ENABLED=2 ENABLED value
                         * @property {number} DISABLED=3 DISABLED value
                         */
                        UserListAccessStatusEnum.UserListAccessStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ENABLED"] = 2;
                            values[valuesById[3] = "DISABLED"] = 3;
                            return values;
                        })();

                        return UserListAccessStatusEnum;
                    })();

                    enums.UserListClosingReasonEnum = (function() {

                        /**
                         * Properties of a UserListClosingReasonEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IUserListClosingReasonEnum
                         */

                        /**
                         * Constructs a new UserListClosingReasonEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a UserListClosingReasonEnum.
                         * @implements IUserListClosingReasonEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IUserListClosingReasonEnum=} [properties] Properties to set
                         */
                        function UserListClosingReasonEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new UserListClosingReasonEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.UserListClosingReasonEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListClosingReasonEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.UserListClosingReasonEnum} UserListClosingReasonEnum instance
                         */
                        UserListClosingReasonEnum.create = function create(properties) {
                            return new UserListClosingReasonEnum(properties);
                        };

                        /**
                         * Encodes the specified UserListClosingReasonEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.UserListClosingReasonEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.UserListClosingReasonEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListClosingReasonEnum} message UserListClosingReasonEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListClosingReasonEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListClosingReasonEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.UserListClosingReasonEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListClosingReasonEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListClosingReasonEnum} message UserListClosingReasonEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListClosingReasonEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListClosingReasonEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.UserListClosingReasonEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.UserListClosingReasonEnum} UserListClosingReasonEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListClosingReasonEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.UserListClosingReasonEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListClosingReasonEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListClosingReasonEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.UserListClosingReasonEnum} UserListClosingReasonEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListClosingReasonEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListClosingReasonEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.UserListClosingReasonEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListClosingReasonEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a UserListClosingReasonEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.UserListClosingReasonEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.UserListClosingReasonEnum} UserListClosingReasonEnum
                         */
                        UserListClosingReasonEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.UserListClosingReasonEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.UserListClosingReasonEnum();
                        };

                        /**
                         * Creates a plain object from a UserListClosingReasonEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.UserListClosingReasonEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.UserListClosingReasonEnum} message UserListClosingReasonEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListClosingReasonEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this UserListClosingReasonEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.UserListClosingReasonEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListClosingReasonEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * UserListClosingReason enum.
                         * @name google.ads.googleads.v1.enums.UserListClosingReasonEnum.UserListClosingReason
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} UNUSED=2 UNUSED value
                         */
                        UserListClosingReasonEnum.UserListClosingReason = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "UNUSED"] = 2;
                            return values;
                        })();

                        return UserListClosingReasonEnum;
                    })();

                    enums.UserListCombinedRuleOperatorEnum = (function() {

                        /**
                         * Properties of a UserListCombinedRuleOperatorEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IUserListCombinedRuleOperatorEnum
                         */

                        /**
                         * Constructs a new UserListCombinedRuleOperatorEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a UserListCombinedRuleOperatorEnum.
                         * @implements IUserListCombinedRuleOperatorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IUserListCombinedRuleOperatorEnum=} [properties] Properties to set
                         */
                        function UserListCombinedRuleOperatorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new UserListCombinedRuleOperatorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListCombinedRuleOperatorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum} UserListCombinedRuleOperatorEnum instance
                         */
                        UserListCombinedRuleOperatorEnum.create = function create(properties) {
                            return new UserListCombinedRuleOperatorEnum(properties);
                        };

                        /**
                         * Encodes the specified UserListCombinedRuleOperatorEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListCombinedRuleOperatorEnum} message UserListCombinedRuleOperatorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListCombinedRuleOperatorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListCombinedRuleOperatorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListCombinedRuleOperatorEnum} message UserListCombinedRuleOperatorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListCombinedRuleOperatorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListCombinedRuleOperatorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum} UserListCombinedRuleOperatorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListCombinedRuleOperatorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListCombinedRuleOperatorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum} UserListCombinedRuleOperatorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListCombinedRuleOperatorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListCombinedRuleOperatorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListCombinedRuleOperatorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a UserListCombinedRuleOperatorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum} UserListCombinedRuleOperatorEnum
                         */
                        UserListCombinedRuleOperatorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum();
                        };

                        /**
                         * Creates a plain object from a UserListCombinedRuleOperatorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum} message UserListCombinedRuleOperatorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListCombinedRuleOperatorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this UserListCombinedRuleOperatorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListCombinedRuleOperatorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * UserListCombinedRuleOperator enum.
                         * @name google.ads.googleads.v1.enums.UserListCombinedRuleOperatorEnum.UserListCombinedRuleOperator
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} AND=2 AND value
                         * @property {number} AND_NOT=3 AND_NOT value
                         */
                        UserListCombinedRuleOperatorEnum.UserListCombinedRuleOperator = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "AND"] = 2;
                            values[valuesById[3] = "AND_NOT"] = 3;
                            return values;
                        })();

                        return UserListCombinedRuleOperatorEnum;
                    })();

                    enums.UserListCrmDataSourceTypeEnum = (function() {

                        /**
                         * Properties of a UserListCrmDataSourceTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IUserListCrmDataSourceTypeEnum
                         */

                        /**
                         * Constructs a new UserListCrmDataSourceTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a UserListCrmDataSourceTypeEnum.
                         * @implements IUserListCrmDataSourceTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IUserListCrmDataSourceTypeEnum=} [properties] Properties to set
                         */
                        function UserListCrmDataSourceTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new UserListCrmDataSourceTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListCrmDataSourceTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum} UserListCrmDataSourceTypeEnum instance
                         */
                        UserListCrmDataSourceTypeEnum.create = function create(properties) {
                            return new UserListCrmDataSourceTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified UserListCrmDataSourceTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListCrmDataSourceTypeEnum} message UserListCrmDataSourceTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListCrmDataSourceTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListCrmDataSourceTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListCrmDataSourceTypeEnum} message UserListCrmDataSourceTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListCrmDataSourceTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListCrmDataSourceTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum} UserListCrmDataSourceTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListCrmDataSourceTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListCrmDataSourceTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum} UserListCrmDataSourceTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListCrmDataSourceTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListCrmDataSourceTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListCrmDataSourceTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a UserListCrmDataSourceTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum} UserListCrmDataSourceTypeEnum
                         */
                        UserListCrmDataSourceTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum();
                        };

                        /**
                         * Creates a plain object from a UserListCrmDataSourceTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum} message UserListCrmDataSourceTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListCrmDataSourceTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this UserListCrmDataSourceTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListCrmDataSourceTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * UserListCrmDataSourceType enum.
                         * @name google.ads.googleads.v1.enums.UserListCrmDataSourceTypeEnum.UserListCrmDataSourceType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} FIRST_PARTY=2 FIRST_PARTY value
                         * @property {number} THIRD_PARTY_CREDIT_BUREAU=3 THIRD_PARTY_CREDIT_BUREAU value
                         * @property {number} THIRD_PARTY_VOTER_FILE=4 THIRD_PARTY_VOTER_FILE value
                         */
                        UserListCrmDataSourceTypeEnum.UserListCrmDataSourceType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "FIRST_PARTY"] = 2;
                            values[valuesById[3] = "THIRD_PARTY_CREDIT_BUREAU"] = 3;
                            values[valuesById[4] = "THIRD_PARTY_VOTER_FILE"] = 4;
                            return values;
                        })();

                        return UserListCrmDataSourceTypeEnum;
                    })();

                    enums.UserListDateRuleItemOperatorEnum = (function() {

                        /**
                         * Properties of a UserListDateRuleItemOperatorEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IUserListDateRuleItemOperatorEnum
                         */

                        /**
                         * Constructs a new UserListDateRuleItemOperatorEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a UserListDateRuleItemOperatorEnum.
                         * @implements IUserListDateRuleItemOperatorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IUserListDateRuleItemOperatorEnum=} [properties] Properties to set
                         */
                        function UserListDateRuleItemOperatorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new UserListDateRuleItemOperatorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListDateRuleItemOperatorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum} UserListDateRuleItemOperatorEnum instance
                         */
                        UserListDateRuleItemOperatorEnum.create = function create(properties) {
                            return new UserListDateRuleItemOperatorEnum(properties);
                        };

                        /**
                         * Encodes the specified UserListDateRuleItemOperatorEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListDateRuleItemOperatorEnum} message UserListDateRuleItemOperatorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListDateRuleItemOperatorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListDateRuleItemOperatorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListDateRuleItemOperatorEnum} message UserListDateRuleItemOperatorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListDateRuleItemOperatorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListDateRuleItemOperatorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum} UserListDateRuleItemOperatorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListDateRuleItemOperatorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListDateRuleItemOperatorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum} UserListDateRuleItemOperatorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListDateRuleItemOperatorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListDateRuleItemOperatorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListDateRuleItemOperatorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a UserListDateRuleItemOperatorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum} UserListDateRuleItemOperatorEnum
                         */
                        UserListDateRuleItemOperatorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum();
                        };

                        /**
                         * Creates a plain object from a UserListDateRuleItemOperatorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum} message UserListDateRuleItemOperatorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListDateRuleItemOperatorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this UserListDateRuleItemOperatorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListDateRuleItemOperatorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * UserListDateRuleItemOperator enum.
                         * @name google.ads.googleads.v1.enums.UserListDateRuleItemOperatorEnum.UserListDateRuleItemOperator
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} EQUALS=2 EQUALS value
                         * @property {number} NOT_EQUALS=3 NOT_EQUALS value
                         * @property {number} BEFORE=4 BEFORE value
                         * @property {number} AFTER=5 AFTER value
                         */
                        UserListDateRuleItemOperatorEnum.UserListDateRuleItemOperator = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "EQUALS"] = 2;
                            values[valuesById[3] = "NOT_EQUALS"] = 3;
                            values[valuesById[4] = "BEFORE"] = 4;
                            values[valuesById[5] = "AFTER"] = 5;
                            return values;
                        })();

                        return UserListDateRuleItemOperatorEnum;
                    })();

                    enums.UserListLogicalRuleOperatorEnum = (function() {

                        /**
                         * Properties of a UserListLogicalRuleOperatorEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IUserListLogicalRuleOperatorEnum
                         */

                        /**
                         * Constructs a new UserListLogicalRuleOperatorEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a UserListLogicalRuleOperatorEnum.
                         * @implements IUserListLogicalRuleOperatorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IUserListLogicalRuleOperatorEnum=} [properties] Properties to set
                         */
                        function UserListLogicalRuleOperatorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new UserListLogicalRuleOperatorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListLogicalRuleOperatorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum} UserListLogicalRuleOperatorEnum instance
                         */
                        UserListLogicalRuleOperatorEnum.create = function create(properties) {
                            return new UserListLogicalRuleOperatorEnum(properties);
                        };

                        /**
                         * Encodes the specified UserListLogicalRuleOperatorEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListLogicalRuleOperatorEnum} message UserListLogicalRuleOperatorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListLogicalRuleOperatorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListLogicalRuleOperatorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListLogicalRuleOperatorEnum} message UserListLogicalRuleOperatorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListLogicalRuleOperatorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListLogicalRuleOperatorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum} UserListLogicalRuleOperatorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListLogicalRuleOperatorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListLogicalRuleOperatorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum} UserListLogicalRuleOperatorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListLogicalRuleOperatorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListLogicalRuleOperatorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListLogicalRuleOperatorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a UserListLogicalRuleOperatorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum} UserListLogicalRuleOperatorEnum
                         */
                        UserListLogicalRuleOperatorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum();
                        };

                        /**
                         * Creates a plain object from a UserListLogicalRuleOperatorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum} message UserListLogicalRuleOperatorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListLogicalRuleOperatorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this UserListLogicalRuleOperatorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListLogicalRuleOperatorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * UserListLogicalRuleOperator enum.
                         * @name google.ads.googleads.v1.enums.UserListLogicalRuleOperatorEnum.UserListLogicalRuleOperator
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ALL=2 ALL value
                         * @property {number} ANY=3 ANY value
                         * @property {number} NONE=4 NONE value
                         */
                        UserListLogicalRuleOperatorEnum.UserListLogicalRuleOperator = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ALL"] = 2;
                            values[valuesById[3] = "ANY"] = 3;
                            values[valuesById[4] = "NONE"] = 4;
                            return values;
                        })();

                        return UserListLogicalRuleOperatorEnum;
                    })();

                    enums.UserListMembershipStatusEnum = (function() {

                        /**
                         * Properties of a UserListMembershipStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IUserListMembershipStatusEnum
                         */

                        /**
                         * Constructs a new UserListMembershipStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a UserListMembershipStatusEnum.
                         * @implements IUserListMembershipStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IUserListMembershipStatusEnum=} [properties] Properties to set
                         */
                        function UserListMembershipStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new UserListMembershipStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.UserListMembershipStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListMembershipStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.UserListMembershipStatusEnum} UserListMembershipStatusEnum instance
                         */
                        UserListMembershipStatusEnum.create = function create(properties) {
                            return new UserListMembershipStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified UserListMembershipStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.UserListMembershipStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.UserListMembershipStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListMembershipStatusEnum} message UserListMembershipStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListMembershipStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListMembershipStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.UserListMembershipStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListMembershipStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListMembershipStatusEnum} message UserListMembershipStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListMembershipStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListMembershipStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.UserListMembershipStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.UserListMembershipStatusEnum} UserListMembershipStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListMembershipStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.UserListMembershipStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListMembershipStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListMembershipStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.UserListMembershipStatusEnum} UserListMembershipStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListMembershipStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListMembershipStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.UserListMembershipStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListMembershipStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a UserListMembershipStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.UserListMembershipStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.UserListMembershipStatusEnum} UserListMembershipStatusEnum
                         */
                        UserListMembershipStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.UserListMembershipStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.UserListMembershipStatusEnum();
                        };

                        /**
                         * Creates a plain object from a UserListMembershipStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.UserListMembershipStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.UserListMembershipStatusEnum} message UserListMembershipStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListMembershipStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this UserListMembershipStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.UserListMembershipStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListMembershipStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * UserListMembershipStatus enum.
                         * @name google.ads.googleads.v1.enums.UserListMembershipStatusEnum.UserListMembershipStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} OPEN=2 OPEN value
                         * @property {number} CLOSED=3 CLOSED value
                         */
                        UserListMembershipStatusEnum.UserListMembershipStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "OPEN"] = 2;
                            values[valuesById[3] = "CLOSED"] = 3;
                            return values;
                        })();

                        return UserListMembershipStatusEnum;
                    })();

                    enums.UserListNumberRuleItemOperatorEnum = (function() {

                        /**
                         * Properties of a UserListNumberRuleItemOperatorEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IUserListNumberRuleItemOperatorEnum
                         */

                        /**
                         * Constructs a new UserListNumberRuleItemOperatorEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a UserListNumberRuleItemOperatorEnum.
                         * @implements IUserListNumberRuleItemOperatorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IUserListNumberRuleItemOperatorEnum=} [properties] Properties to set
                         */
                        function UserListNumberRuleItemOperatorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new UserListNumberRuleItemOperatorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListNumberRuleItemOperatorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum} UserListNumberRuleItemOperatorEnum instance
                         */
                        UserListNumberRuleItemOperatorEnum.create = function create(properties) {
                            return new UserListNumberRuleItemOperatorEnum(properties);
                        };

                        /**
                         * Encodes the specified UserListNumberRuleItemOperatorEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListNumberRuleItemOperatorEnum} message UserListNumberRuleItemOperatorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListNumberRuleItemOperatorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListNumberRuleItemOperatorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListNumberRuleItemOperatorEnum} message UserListNumberRuleItemOperatorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListNumberRuleItemOperatorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListNumberRuleItemOperatorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum} UserListNumberRuleItemOperatorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListNumberRuleItemOperatorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListNumberRuleItemOperatorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum} UserListNumberRuleItemOperatorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListNumberRuleItemOperatorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListNumberRuleItemOperatorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListNumberRuleItemOperatorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a UserListNumberRuleItemOperatorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum} UserListNumberRuleItemOperatorEnum
                         */
                        UserListNumberRuleItemOperatorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum();
                        };

                        /**
                         * Creates a plain object from a UserListNumberRuleItemOperatorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum} message UserListNumberRuleItemOperatorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListNumberRuleItemOperatorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this UserListNumberRuleItemOperatorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListNumberRuleItemOperatorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * UserListNumberRuleItemOperator enum.
                         * @name google.ads.googleads.v1.enums.UserListNumberRuleItemOperatorEnum.UserListNumberRuleItemOperator
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} GREATER_THAN=2 GREATER_THAN value
                         * @property {number} GREATER_THAN_OR_EQUAL=3 GREATER_THAN_OR_EQUAL value
                         * @property {number} EQUALS=4 EQUALS value
                         * @property {number} NOT_EQUALS=5 NOT_EQUALS value
                         * @property {number} LESS_THAN=6 LESS_THAN value
                         * @property {number} LESS_THAN_OR_EQUAL=7 LESS_THAN_OR_EQUAL value
                         */
                        UserListNumberRuleItemOperatorEnum.UserListNumberRuleItemOperator = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "GREATER_THAN"] = 2;
                            values[valuesById[3] = "GREATER_THAN_OR_EQUAL"] = 3;
                            values[valuesById[4] = "EQUALS"] = 4;
                            values[valuesById[5] = "NOT_EQUALS"] = 5;
                            values[valuesById[6] = "LESS_THAN"] = 6;
                            values[valuesById[7] = "LESS_THAN_OR_EQUAL"] = 7;
                            return values;
                        })();

                        return UserListNumberRuleItemOperatorEnum;
                    })();

                    enums.UserListPrepopulationStatusEnum = (function() {

                        /**
                         * Properties of a UserListPrepopulationStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IUserListPrepopulationStatusEnum
                         */

                        /**
                         * Constructs a new UserListPrepopulationStatusEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a UserListPrepopulationStatusEnum.
                         * @implements IUserListPrepopulationStatusEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IUserListPrepopulationStatusEnum=} [properties] Properties to set
                         */
                        function UserListPrepopulationStatusEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new UserListPrepopulationStatusEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListPrepopulationStatusEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum} UserListPrepopulationStatusEnum instance
                         */
                        UserListPrepopulationStatusEnum.create = function create(properties) {
                            return new UserListPrepopulationStatusEnum(properties);
                        };

                        /**
                         * Encodes the specified UserListPrepopulationStatusEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListPrepopulationStatusEnum} message UserListPrepopulationStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListPrepopulationStatusEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListPrepopulationStatusEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListPrepopulationStatusEnum} message UserListPrepopulationStatusEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListPrepopulationStatusEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListPrepopulationStatusEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum} UserListPrepopulationStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListPrepopulationStatusEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListPrepopulationStatusEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum} UserListPrepopulationStatusEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListPrepopulationStatusEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListPrepopulationStatusEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListPrepopulationStatusEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a UserListPrepopulationStatusEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum} UserListPrepopulationStatusEnum
                         */
                        UserListPrepopulationStatusEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum();
                        };

                        /**
                         * Creates a plain object from a UserListPrepopulationStatusEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum} message UserListPrepopulationStatusEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListPrepopulationStatusEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this UserListPrepopulationStatusEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListPrepopulationStatusEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * UserListPrepopulationStatus enum.
                         * @name google.ads.googleads.v1.enums.UserListPrepopulationStatusEnum.UserListPrepopulationStatus
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} REQUESTED=2 REQUESTED value
                         * @property {number} FINISHED=3 FINISHED value
                         * @property {number} FAILED=4 FAILED value
                         */
                        UserListPrepopulationStatusEnum.UserListPrepopulationStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "REQUESTED"] = 2;
                            values[valuesById[3] = "FINISHED"] = 3;
                            values[valuesById[4] = "FAILED"] = 4;
                            return values;
                        })();

                        return UserListPrepopulationStatusEnum;
                    })();

                    enums.UserListRuleTypeEnum = (function() {

                        /**
                         * Properties of a UserListRuleTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IUserListRuleTypeEnum
                         */

                        /**
                         * Constructs a new UserListRuleTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a UserListRuleTypeEnum.
                         * @implements IUserListRuleTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IUserListRuleTypeEnum=} [properties] Properties to set
                         */
                        function UserListRuleTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new UserListRuleTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.UserListRuleTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListRuleTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.UserListRuleTypeEnum} UserListRuleTypeEnum instance
                         */
                        UserListRuleTypeEnum.create = function create(properties) {
                            return new UserListRuleTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified UserListRuleTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.UserListRuleTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.UserListRuleTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListRuleTypeEnum} message UserListRuleTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListRuleTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListRuleTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.UserListRuleTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListRuleTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListRuleTypeEnum} message UserListRuleTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListRuleTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListRuleTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.UserListRuleTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.UserListRuleTypeEnum} UserListRuleTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListRuleTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.UserListRuleTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListRuleTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListRuleTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.UserListRuleTypeEnum} UserListRuleTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListRuleTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListRuleTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.UserListRuleTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListRuleTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a UserListRuleTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.UserListRuleTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.UserListRuleTypeEnum} UserListRuleTypeEnum
                         */
                        UserListRuleTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.UserListRuleTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.UserListRuleTypeEnum();
                        };

                        /**
                         * Creates a plain object from a UserListRuleTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.UserListRuleTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.UserListRuleTypeEnum} message UserListRuleTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListRuleTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this UserListRuleTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.UserListRuleTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListRuleTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * UserListRuleType enum.
                         * @name google.ads.googleads.v1.enums.UserListRuleTypeEnum.UserListRuleType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} AND_OF_ORS=2 AND_OF_ORS value
                         * @property {number} OR_OF_ANDS=3 OR_OF_ANDS value
                         */
                        UserListRuleTypeEnum.UserListRuleType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "AND_OF_ORS"] = 2;
                            values[valuesById[3] = "OR_OF_ANDS"] = 3;
                            return values;
                        })();

                        return UserListRuleTypeEnum;
                    })();

                    enums.UserListSizeRangeEnum = (function() {

                        /**
                         * Properties of a UserListSizeRangeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IUserListSizeRangeEnum
                         */

                        /**
                         * Constructs a new UserListSizeRangeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a UserListSizeRangeEnum.
                         * @implements IUserListSizeRangeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IUserListSizeRangeEnum=} [properties] Properties to set
                         */
                        function UserListSizeRangeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new UserListSizeRangeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.UserListSizeRangeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListSizeRangeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.UserListSizeRangeEnum} UserListSizeRangeEnum instance
                         */
                        UserListSizeRangeEnum.create = function create(properties) {
                            return new UserListSizeRangeEnum(properties);
                        };

                        /**
                         * Encodes the specified UserListSizeRangeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.UserListSizeRangeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.UserListSizeRangeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListSizeRangeEnum} message UserListSizeRangeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListSizeRangeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListSizeRangeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.UserListSizeRangeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListSizeRangeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListSizeRangeEnum} message UserListSizeRangeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListSizeRangeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListSizeRangeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.UserListSizeRangeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.UserListSizeRangeEnum} UserListSizeRangeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListSizeRangeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.UserListSizeRangeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListSizeRangeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListSizeRangeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.UserListSizeRangeEnum} UserListSizeRangeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListSizeRangeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListSizeRangeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.UserListSizeRangeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListSizeRangeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a UserListSizeRangeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.UserListSizeRangeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.UserListSizeRangeEnum} UserListSizeRangeEnum
                         */
                        UserListSizeRangeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.UserListSizeRangeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.UserListSizeRangeEnum();
                        };

                        /**
                         * Creates a plain object from a UserListSizeRangeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.UserListSizeRangeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.UserListSizeRangeEnum} message UserListSizeRangeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListSizeRangeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this UserListSizeRangeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.UserListSizeRangeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListSizeRangeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * UserListSizeRange enum.
                         * @name google.ads.googleads.v1.enums.UserListSizeRangeEnum.UserListSizeRange
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} LESS_THAN_FIVE_HUNDRED=2 LESS_THAN_FIVE_HUNDRED value
                         * @property {number} LESS_THAN_ONE_THOUSAND=3 LESS_THAN_ONE_THOUSAND value
                         * @property {number} ONE_THOUSAND_TO_TEN_THOUSAND=4 ONE_THOUSAND_TO_TEN_THOUSAND value
                         * @property {number} TEN_THOUSAND_TO_FIFTY_THOUSAND=5 TEN_THOUSAND_TO_FIFTY_THOUSAND value
                         * @property {number} FIFTY_THOUSAND_TO_ONE_HUNDRED_THOUSAND=6 FIFTY_THOUSAND_TO_ONE_HUNDRED_THOUSAND value
                         * @property {number} ONE_HUNDRED_THOUSAND_TO_THREE_HUNDRED_THOUSAND=7 ONE_HUNDRED_THOUSAND_TO_THREE_HUNDRED_THOUSAND value
                         * @property {number} THREE_HUNDRED_THOUSAND_TO_FIVE_HUNDRED_THOUSAND=8 THREE_HUNDRED_THOUSAND_TO_FIVE_HUNDRED_THOUSAND value
                         * @property {number} FIVE_HUNDRED_THOUSAND_TO_ONE_MILLION=9 FIVE_HUNDRED_THOUSAND_TO_ONE_MILLION value
                         * @property {number} ONE_MILLION_TO_TWO_MILLION=10 ONE_MILLION_TO_TWO_MILLION value
                         * @property {number} TWO_MILLION_TO_THREE_MILLION=11 TWO_MILLION_TO_THREE_MILLION value
                         * @property {number} THREE_MILLION_TO_FIVE_MILLION=12 THREE_MILLION_TO_FIVE_MILLION value
                         * @property {number} FIVE_MILLION_TO_TEN_MILLION=13 FIVE_MILLION_TO_TEN_MILLION value
                         * @property {number} TEN_MILLION_TO_TWENTY_MILLION=14 TEN_MILLION_TO_TWENTY_MILLION value
                         * @property {number} TWENTY_MILLION_TO_THIRTY_MILLION=15 TWENTY_MILLION_TO_THIRTY_MILLION value
                         * @property {number} THIRTY_MILLION_TO_FIFTY_MILLION=16 THIRTY_MILLION_TO_FIFTY_MILLION value
                         * @property {number} OVER_FIFTY_MILLION=17 OVER_FIFTY_MILLION value
                         */
                        UserListSizeRangeEnum.UserListSizeRange = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "LESS_THAN_FIVE_HUNDRED"] = 2;
                            values[valuesById[3] = "LESS_THAN_ONE_THOUSAND"] = 3;
                            values[valuesById[4] = "ONE_THOUSAND_TO_TEN_THOUSAND"] = 4;
                            values[valuesById[5] = "TEN_THOUSAND_TO_FIFTY_THOUSAND"] = 5;
                            values[valuesById[6] = "FIFTY_THOUSAND_TO_ONE_HUNDRED_THOUSAND"] = 6;
                            values[valuesById[7] = "ONE_HUNDRED_THOUSAND_TO_THREE_HUNDRED_THOUSAND"] = 7;
                            values[valuesById[8] = "THREE_HUNDRED_THOUSAND_TO_FIVE_HUNDRED_THOUSAND"] = 8;
                            values[valuesById[9] = "FIVE_HUNDRED_THOUSAND_TO_ONE_MILLION"] = 9;
                            values[valuesById[10] = "ONE_MILLION_TO_TWO_MILLION"] = 10;
                            values[valuesById[11] = "TWO_MILLION_TO_THREE_MILLION"] = 11;
                            values[valuesById[12] = "THREE_MILLION_TO_FIVE_MILLION"] = 12;
                            values[valuesById[13] = "FIVE_MILLION_TO_TEN_MILLION"] = 13;
                            values[valuesById[14] = "TEN_MILLION_TO_TWENTY_MILLION"] = 14;
                            values[valuesById[15] = "TWENTY_MILLION_TO_THIRTY_MILLION"] = 15;
                            values[valuesById[16] = "THIRTY_MILLION_TO_FIFTY_MILLION"] = 16;
                            values[valuesById[17] = "OVER_FIFTY_MILLION"] = 17;
                            return values;
                        })();

                        return UserListSizeRangeEnum;
                    })();

                    enums.UserListStringRuleItemOperatorEnum = (function() {

                        /**
                         * Properties of a UserListStringRuleItemOperatorEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IUserListStringRuleItemOperatorEnum
                         */

                        /**
                         * Constructs a new UserListStringRuleItemOperatorEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a UserListStringRuleItemOperatorEnum.
                         * @implements IUserListStringRuleItemOperatorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IUserListStringRuleItemOperatorEnum=} [properties] Properties to set
                         */
                        function UserListStringRuleItemOperatorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new UserListStringRuleItemOperatorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListStringRuleItemOperatorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum} UserListStringRuleItemOperatorEnum instance
                         */
                        UserListStringRuleItemOperatorEnum.create = function create(properties) {
                            return new UserListStringRuleItemOperatorEnum(properties);
                        };

                        /**
                         * Encodes the specified UserListStringRuleItemOperatorEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListStringRuleItemOperatorEnum} message UserListStringRuleItemOperatorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListStringRuleItemOperatorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListStringRuleItemOperatorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListStringRuleItemOperatorEnum} message UserListStringRuleItemOperatorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListStringRuleItemOperatorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListStringRuleItemOperatorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum} UserListStringRuleItemOperatorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListStringRuleItemOperatorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListStringRuleItemOperatorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum} UserListStringRuleItemOperatorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListStringRuleItemOperatorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListStringRuleItemOperatorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListStringRuleItemOperatorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a UserListStringRuleItemOperatorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum} UserListStringRuleItemOperatorEnum
                         */
                        UserListStringRuleItemOperatorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum();
                        };

                        /**
                         * Creates a plain object from a UserListStringRuleItemOperatorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum} message UserListStringRuleItemOperatorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListStringRuleItemOperatorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this UserListStringRuleItemOperatorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListStringRuleItemOperatorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * UserListStringRuleItemOperator enum.
                         * @name google.ads.googleads.v1.enums.UserListStringRuleItemOperatorEnum.UserListStringRuleItemOperator
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} CONTAINS=2 CONTAINS value
                         * @property {number} EQUALS=3 EQUALS value
                         * @property {number} STARTS_WITH=4 STARTS_WITH value
                         * @property {number} ENDS_WITH=5 ENDS_WITH value
                         * @property {number} NOT_EQUALS=6 NOT_EQUALS value
                         * @property {number} NOT_CONTAINS=7 NOT_CONTAINS value
                         * @property {number} NOT_STARTS_WITH=8 NOT_STARTS_WITH value
                         * @property {number} NOT_ENDS_WITH=9 NOT_ENDS_WITH value
                         */
                        UserListStringRuleItemOperatorEnum.UserListStringRuleItemOperator = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "CONTAINS"] = 2;
                            values[valuesById[3] = "EQUALS"] = 3;
                            values[valuesById[4] = "STARTS_WITH"] = 4;
                            values[valuesById[5] = "ENDS_WITH"] = 5;
                            values[valuesById[6] = "NOT_EQUALS"] = 6;
                            values[valuesById[7] = "NOT_CONTAINS"] = 7;
                            values[valuesById[8] = "NOT_STARTS_WITH"] = 8;
                            values[valuesById[9] = "NOT_ENDS_WITH"] = 9;
                            return values;
                        })();

                        return UserListStringRuleItemOperatorEnum;
                    })();

                    enums.UserListTypeEnum = (function() {

                        /**
                         * Properties of a UserListTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IUserListTypeEnum
                         */

                        /**
                         * Constructs a new UserListTypeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a UserListTypeEnum.
                         * @implements IUserListTypeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IUserListTypeEnum=} [properties] Properties to set
                         */
                        function UserListTypeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new UserListTypeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.UserListTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListTypeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.UserListTypeEnum} UserListTypeEnum instance
                         */
                        UserListTypeEnum.create = function create(properties) {
                            return new UserListTypeEnum(properties);
                        };

                        /**
                         * Encodes the specified UserListTypeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.UserListTypeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.UserListTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListTypeEnum} message UserListTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListTypeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListTypeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.UserListTypeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IUserListTypeEnum} message UserListTypeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListTypeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListTypeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.UserListTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.UserListTypeEnum} UserListTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListTypeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.UserListTypeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListTypeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.UserListTypeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.UserListTypeEnum} UserListTypeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListTypeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListTypeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.UserListTypeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListTypeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a UserListTypeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.UserListTypeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.UserListTypeEnum} UserListTypeEnum
                         */
                        UserListTypeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.UserListTypeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.UserListTypeEnum();
                        };

                        /**
                         * Creates a plain object from a UserListTypeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.UserListTypeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.UserListTypeEnum} message UserListTypeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListTypeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this UserListTypeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.UserListTypeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListTypeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * UserListType enum.
                         * @name google.ads.googleads.v1.enums.UserListTypeEnum.UserListType
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} REMARKETING=2 REMARKETING value
                         * @property {number} LOGICAL=3 LOGICAL value
                         * @property {number} EXTERNAL_REMARKETING=4 EXTERNAL_REMARKETING value
                         * @property {number} RULE_BASED=5 RULE_BASED value
                         * @property {number} SIMILAR=6 SIMILAR value
                         * @property {number} CRM_BASED=7 CRM_BASED value
                         */
                        UserListTypeEnum.UserListType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "REMARKETING"] = 2;
                            values[valuesById[3] = "LOGICAL"] = 3;
                            values[valuesById[4] = "EXTERNAL_REMARKETING"] = 4;
                            values[valuesById[5] = "RULE_BASED"] = 5;
                            values[valuesById[6] = "SIMILAR"] = 6;
                            values[valuesById[7] = "CRM_BASED"] = 7;
                            return values;
                        })();

                        return UserListTypeEnum;
                    })();

                    enums.VanityPharmaDisplayUrlModeEnum = (function() {

                        /**
                         * Properties of a VanityPharmaDisplayUrlModeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IVanityPharmaDisplayUrlModeEnum
                         */

                        /**
                         * Constructs a new VanityPharmaDisplayUrlModeEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a VanityPharmaDisplayUrlModeEnum.
                         * @implements IVanityPharmaDisplayUrlModeEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IVanityPharmaDisplayUrlModeEnum=} [properties] Properties to set
                         */
                        function VanityPharmaDisplayUrlModeEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new VanityPharmaDisplayUrlModeEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IVanityPharmaDisplayUrlModeEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum} VanityPharmaDisplayUrlModeEnum instance
                         */
                        VanityPharmaDisplayUrlModeEnum.create = function create(properties) {
                            return new VanityPharmaDisplayUrlModeEnum(properties);
                        };

                        /**
                         * Encodes the specified VanityPharmaDisplayUrlModeEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IVanityPharmaDisplayUrlModeEnum} message VanityPharmaDisplayUrlModeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VanityPharmaDisplayUrlModeEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified VanityPharmaDisplayUrlModeEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IVanityPharmaDisplayUrlModeEnum} message VanityPharmaDisplayUrlModeEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VanityPharmaDisplayUrlModeEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a VanityPharmaDisplayUrlModeEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum} VanityPharmaDisplayUrlModeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VanityPharmaDisplayUrlModeEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a VanityPharmaDisplayUrlModeEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum} VanityPharmaDisplayUrlModeEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VanityPharmaDisplayUrlModeEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a VanityPharmaDisplayUrlModeEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VanityPharmaDisplayUrlModeEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a VanityPharmaDisplayUrlModeEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum} VanityPharmaDisplayUrlModeEnum
                         */
                        VanityPharmaDisplayUrlModeEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum();
                        };

                        /**
                         * Creates a plain object from a VanityPharmaDisplayUrlModeEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum} message VanityPharmaDisplayUrlModeEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VanityPharmaDisplayUrlModeEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this VanityPharmaDisplayUrlModeEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VanityPharmaDisplayUrlModeEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * VanityPharmaDisplayUrlMode enum.
                         * @name google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum.VanityPharmaDisplayUrlMode
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} MANUFACTURER_WEBSITE_URL=2 MANUFACTURER_WEBSITE_URL value
                         * @property {number} WEBSITE_DESCRIPTION=3 WEBSITE_DESCRIPTION value
                         */
                        VanityPharmaDisplayUrlModeEnum.VanityPharmaDisplayUrlMode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "MANUFACTURER_WEBSITE_URL"] = 2;
                            values[valuesById[3] = "WEBSITE_DESCRIPTION"] = 3;
                            return values;
                        })();

                        return VanityPharmaDisplayUrlModeEnum;
                    })();

                    enums.VanityPharmaTextEnum = (function() {

                        /**
                         * Properties of a VanityPharmaTextEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IVanityPharmaTextEnum
                         */

                        /**
                         * Constructs a new VanityPharmaTextEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a VanityPharmaTextEnum.
                         * @implements IVanityPharmaTextEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IVanityPharmaTextEnum=} [properties] Properties to set
                         */
                        function VanityPharmaTextEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new VanityPharmaTextEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.VanityPharmaTextEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IVanityPharmaTextEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.VanityPharmaTextEnum} VanityPharmaTextEnum instance
                         */
                        VanityPharmaTextEnum.create = function create(properties) {
                            return new VanityPharmaTextEnum(properties);
                        };

                        /**
                         * Encodes the specified VanityPharmaTextEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.VanityPharmaTextEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.VanityPharmaTextEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IVanityPharmaTextEnum} message VanityPharmaTextEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VanityPharmaTextEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified VanityPharmaTextEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.VanityPharmaTextEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.VanityPharmaTextEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IVanityPharmaTextEnum} message VanityPharmaTextEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VanityPharmaTextEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a VanityPharmaTextEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.VanityPharmaTextEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.VanityPharmaTextEnum} VanityPharmaTextEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VanityPharmaTextEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.VanityPharmaTextEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a VanityPharmaTextEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.VanityPharmaTextEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.VanityPharmaTextEnum} VanityPharmaTextEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VanityPharmaTextEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a VanityPharmaTextEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.VanityPharmaTextEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VanityPharmaTextEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a VanityPharmaTextEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.VanityPharmaTextEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.VanityPharmaTextEnum} VanityPharmaTextEnum
                         */
                        VanityPharmaTextEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.VanityPharmaTextEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.VanityPharmaTextEnum();
                        };

                        /**
                         * Creates a plain object from a VanityPharmaTextEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.VanityPharmaTextEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.VanityPharmaTextEnum} message VanityPharmaTextEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VanityPharmaTextEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this VanityPharmaTextEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.VanityPharmaTextEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VanityPharmaTextEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * VanityPharmaText enum.
                         * @name google.ads.googleads.v1.enums.VanityPharmaTextEnum.VanityPharmaText
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} PRESCRIPTION_TREATMENT_WEBSITE_EN=2 PRESCRIPTION_TREATMENT_WEBSITE_EN value
                         * @property {number} PRESCRIPTION_TREATMENT_WEBSITE_ES=3 PRESCRIPTION_TREATMENT_WEBSITE_ES value
                         * @property {number} PRESCRIPTION_DEVICE_WEBSITE_EN=4 PRESCRIPTION_DEVICE_WEBSITE_EN value
                         * @property {number} PRESCRIPTION_DEVICE_WEBSITE_ES=5 PRESCRIPTION_DEVICE_WEBSITE_ES value
                         * @property {number} MEDICAL_DEVICE_WEBSITE_EN=6 MEDICAL_DEVICE_WEBSITE_EN value
                         * @property {number} MEDICAL_DEVICE_WEBSITE_ES=7 MEDICAL_DEVICE_WEBSITE_ES value
                         * @property {number} PREVENTATIVE_TREATMENT_WEBSITE_EN=8 PREVENTATIVE_TREATMENT_WEBSITE_EN value
                         * @property {number} PREVENTATIVE_TREATMENT_WEBSITE_ES=9 PREVENTATIVE_TREATMENT_WEBSITE_ES value
                         * @property {number} PRESCRIPTION_CONTRACEPTION_WEBSITE_EN=10 PRESCRIPTION_CONTRACEPTION_WEBSITE_EN value
                         * @property {number} PRESCRIPTION_CONTRACEPTION_WEBSITE_ES=11 PRESCRIPTION_CONTRACEPTION_WEBSITE_ES value
                         * @property {number} PRESCRIPTION_VACCINE_WEBSITE_EN=12 PRESCRIPTION_VACCINE_WEBSITE_EN value
                         * @property {number} PRESCRIPTION_VACCINE_WEBSITE_ES=13 PRESCRIPTION_VACCINE_WEBSITE_ES value
                         */
                        VanityPharmaTextEnum.VanityPharmaText = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "PRESCRIPTION_TREATMENT_WEBSITE_EN"] = 2;
                            values[valuesById[3] = "PRESCRIPTION_TREATMENT_WEBSITE_ES"] = 3;
                            values[valuesById[4] = "PRESCRIPTION_DEVICE_WEBSITE_EN"] = 4;
                            values[valuesById[5] = "PRESCRIPTION_DEVICE_WEBSITE_ES"] = 5;
                            values[valuesById[6] = "MEDICAL_DEVICE_WEBSITE_EN"] = 6;
                            values[valuesById[7] = "MEDICAL_DEVICE_WEBSITE_ES"] = 7;
                            values[valuesById[8] = "PREVENTATIVE_TREATMENT_WEBSITE_EN"] = 8;
                            values[valuesById[9] = "PREVENTATIVE_TREATMENT_WEBSITE_ES"] = 9;
                            values[valuesById[10] = "PRESCRIPTION_CONTRACEPTION_WEBSITE_EN"] = 10;
                            values[valuesById[11] = "PRESCRIPTION_CONTRACEPTION_WEBSITE_ES"] = 11;
                            values[valuesById[12] = "PRESCRIPTION_VACCINE_WEBSITE_EN"] = 12;
                            values[valuesById[13] = "PRESCRIPTION_VACCINE_WEBSITE_ES"] = 13;
                            return values;
                        })();

                        return VanityPharmaTextEnum;
                    })();

                    enums.WebpageConditionOperandEnum = (function() {

                        /**
                         * Properties of a WebpageConditionOperandEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IWebpageConditionOperandEnum
                         */

                        /**
                         * Constructs a new WebpageConditionOperandEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a WebpageConditionOperandEnum.
                         * @implements IWebpageConditionOperandEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IWebpageConditionOperandEnum=} [properties] Properties to set
                         */
                        function WebpageConditionOperandEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new WebpageConditionOperandEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.WebpageConditionOperandEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IWebpageConditionOperandEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.WebpageConditionOperandEnum} WebpageConditionOperandEnum instance
                         */
                        WebpageConditionOperandEnum.create = function create(properties) {
                            return new WebpageConditionOperandEnum(properties);
                        };

                        /**
                         * Encodes the specified WebpageConditionOperandEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.WebpageConditionOperandEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.WebpageConditionOperandEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IWebpageConditionOperandEnum} message WebpageConditionOperandEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WebpageConditionOperandEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified WebpageConditionOperandEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.WebpageConditionOperandEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.WebpageConditionOperandEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IWebpageConditionOperandEnum} message WebpageConditionOperandEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WebpageConditionOperandEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a WebpageConditionOperandEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.WebpageConditionOperandEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.WebpageConditionOperandEnum} WebpageConditionOperandEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WebpageConditionOperandEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.WebpageConditionOperandEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a WebpageConditionOperandEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.WebpageConditionOperandEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.WebpageConditionOperandEnum} WebpageConditionOperandEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WebpageConditionOperandEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a WebpageConditionOperandEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.WebpageConditionOperandEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        WebpageConditionOperandEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a WebpageConditionOperandEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.WebpageConditionOperandEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.WebpageConditionOperandEnum} WebpageConditionOperandEnum
                         */
                        WebpageConditionOperandEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.WebpageConditionOperandEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.WebpageConditionOperandEnum();
                        };

                        /**
                         * Creates a plain object from a WebpageConditionOperandEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.WebpageConditionOperandEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.WebpageConditionOperandEnum} message WebpageConditionOperandEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        WebpageConditionOperandEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this WebpageConditionOperandEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.WebpageConditionOperandEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        WebpageConditionOperandEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * WebpageConditionOperand enum.
                         * @name google.ads.googleads.v1.enums.WebpageConditionOperandEnum.WebpageConditionOperand
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} URL=2 URL value
                         * @property {number} CATEGORY=3 CATEGORY value
                         * @property {number} PAGE_TITLE=4 PAGE_TITLE value
                         * @property {number} PAGE_CONTENT=5 PAGE_CONTENT value
                         * @property {number} CUSTOM_LABEL=6 CUSTOM_LABEL value
                         */
                        WebpageConditionOperandEnum.WebpageConditionOperand = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "URL"] = 2;
                            values[valuesById[3] = "CATEGORY"] = 3;
                            values[valuesById[4] = "PAGE_TITLE"] = 4;
                            values[valuesById[5] = "PAGE_CONTENT"] = 5;
                            values[valuesById[6] = "CUSTOM_LABEL"] = 6;
                            return values;
                        })();

                        return WebpageConditionOperandEnum;
                    })();

                    enums.WebpageConditionOperatorEnum = (function() {

                        /**
                         * Properties of a WebpageConditionOperatorEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @interface IWebpageConditionOperatorEnum
                         */

                        /**
                         * Constructs a new WebpageConditionOperatorEnum.
                         * @memberof google.ads.googleads.v1.enums
                         * @classdesc Represents a WebpageConditionOperatorEnum.
                         * @implements IWebpageConditionOperatorEnum
                         * @constructor
                         * @param {google.ads.googleads.v1.enums.IWebpageConditionOperatorEnum=} [properties] Properties to set
                         */
                        function WebpageConditionOperatorEnum(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new WebpageConditionOperatorEnum instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.enums.WebpageConditionOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IWebpageConditionOperatorEnum=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.enums.WebpageConditionOperatorEnum} WebpageConditionOperatorEnum instance
                         */
                        WebpageConditionOperatorEnum.create = function create(properties) {
                            return new WebpageConditionOperatorEnum(properties);
                        };

                        /**
                         * Encodes the specified WebpageConditionOperatorEnum message. Does not implicitly {@link google.ads.googleads.v1.enums.WebpageConditionOperatorEnum.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.enums.WebpageConditionOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IWebpageConditionOperatorEnum} message WebpageConditionOperatorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WebpageConditionOperatorEnum.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified WebpageConditionOperatorEnum message, length delimited. Does not implicitly {@link google.ads.googleads.v1.enums.WebpageConditionOperatorEnum.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.enums.WebpageConditionOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.IWebpageConditionOperatorEnum} message WebpageConditionOperatorEnum message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WebpageConditionOperatorEnum.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a WebpageConditionOperatorEnum message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.enums.WebpageConditionOperatorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.enums.WebpageConditionOperatorEnum} WebpageConditionOperatorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WebpageConditionOperatorEnum.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.enums.WebpageConditionOperatorEnum();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a WebpageConditionOperatorEnum message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.enums.WebpageConditionOperatorEnum
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.enums.WebpageConditionOperatorEnum} WebpageConditionOperatorEnum
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WebpageConditionOperatorEnum.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a WebpageConditionOperatorEnum message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.enums.WebpageConditionOperatorEnum
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        WebpageConditionOperatorEnum.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a WebpageConditionOperatorEnum message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.enums.WebpageConditionOperatorEnum
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.enums.WebpageConditionOperatorEnum} WebpageConditionOperatorEnum
                         */
                        WebpageConditionOperatorEnum.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.enums.WebpageConditionOperatorEnum)
                                return object;
                            return new $root.google.ads.googleads.v1.enums.WebpageConditionOperatorEnum();
                        };

                        /**
                         * Creates a plain object from a WebpageConditionOperatorEnum message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.enums.WebpageConditionOperatorEnum
                         * @static
                         * @param {google.ads.googleads.v1.enums.WebpageConditionOperatorEnum} message WebpageConditionOperatorEnum
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        WebpageConditionOperatorEnum.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this WebpageConditionOperatorEnum to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.enums.WebpageConditionOperatorEnum
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        WebpageConditionOperatorEnum.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * WebpageConditionOperator enum.
                         * @name google.ads.googleads.v1.enums.WebpageConditionOperatorEnum.WebpageConditionOperator
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} EQUALS=2 EQUALS value
                         * @property {number} CONTAINS=3 CONTAINS value
                         */
                        WebpageConditionOperatorEnum.WebpageConditionOperator = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "EQUALS"] = 2;
                            values[valuesById[3] = "CONTAINS"] = 3;
                            return values;
                        })();

                        return WebpageConditionOperatorEnum;
                    })();

                    return enums;
                })();

                v1.resources = (function() {

                    /**
                     * Namespace resources.
                     * @memberof google.ads.googleads.v1
                     * @namespace
                     */
                    var resources = {};

                    resources.AccountBudget = (function() {

                        /**
                         * Properties of an AccountBudget.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAccountBudget
                         * @property {string|null} [resourceName] AccountBudget resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] AccountBudget id
                         * @property {google.protobuf.IStringValue|null} [billingSetup] AccountBudget billingSetup
                         * @property {google.ads.googleads.v1.enums.AccountBudgetStatusEnum.AccountBudgetStatus|null} [status] AccountBudget status
                         * @property {google.protobuf.IStringValue|null} [name] AccountBudget name
                         * @property {google.protobuf.IStringValue|null} [proposedStartDateTime] AccountBudget proposedStartDateTime
                         * @property {google.protobuf.IStringValue|null} [approvedStartDateTime] AccountBudget approvedStartDateTime
                         * @property {google.protobuf.IInt64Value|null} [totalAdjustmentsMicros] AccountBudget totalAdjustmentsMicros
                         * @property {google.protobuf.IInt64Value|null} [amountServedMicros] AccountBudget amountServedMicros
                         * @property {google.protobuf.IStringValue|null} [purchaseOrderNumber] AccountBudget purchaseOrderNumber
                         * @property {google.protobuf.IStringValue|null} [notes] AccountBudget notes
                         * @property {google.ads.googleads.v1.resources.AccountBudget.IPendingAccountBudgetProposal|null} [pendingProposal] AccountBudget pendingProposal
                         * @property {google.protobuf.IStringValue|null} [proposedEndDateTime] AccountBudget proposedEndDateTime
                         * @property {google.ads.googleads.v1.enums.TimeTypeEnum.TimeType|null} [proposedEndTimeType] AccountBudget proposedEndTimeType
                         * @property {google.protobuf.IStringValue|null} [approvedEndDateTime] AccountBudget approvedEndDateTime
                         * @property {google.ads.googleads.v1.enums.TimeTypeEnum.TimeType|null} [approvedEndTimeType] AccountBudget approvedEndTimeType
                         * @property {google.protobuf.IInt64Value|null} [proposedSpendingLimitMicros] AccountBudget proposedSpendingLimitMicros
                         * @property {google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType|null} [proposedSpendingLimitType] AccountBudget proposedSpendingLimitType
                         * @property {google.protobuf.IInt64Value|null} [approvedSpendingLimitMicros] AccountBudget approvedSpendingLimitMicros
                         * @property {google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType|null} [approvedSpendingLimitType] AccountBudget approvedSpendingLimitType
                         * @property {google.protobuf.IInt64Value|null} [adjustedSpendingLimitMicros] AccountBudget adjustedSpendingLimitMicros
                         * @property {google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType|null} [adjustedSpendingLimitType] AccountBudget adjustedSpendingLimitType
                         */

                        /**
                         * Constructs a new AccountBudget.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AccountBudget.
                         * @implements IAccountBudget
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAccountBudget=} [properties] Properties to set
                         */
                        function AccountBudget(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AccountBudget resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.resourceName = "";

                        /**
                         * AccountBudget id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.id = null;

                        /**
                         * AccountBudget billingSetup.
                         * @member {google.protobuf.IStringValue|null|undefined} billingSetup
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.billingSetup = null;

                        /**
                         * AccountBudget status.
                         * @member {google.ads.googleads.v1.enums.AccountBudgetStatusEnum.AccountBudgetStatus} status
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.status = 0;

                        /**
                         * AccountBudget name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.name = null;

                        /**
                         * AccountBudget proposedStartDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} proposedStartDateTime
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.proposedStartDateTime = null;

                        /**
                         * AccountBudget approvedStartDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} approvedStartDateTime
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.approvedStartDateTime = null;

                        /**
                         * AccountBudget totalAdjustmentsMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} totalAdjustmentsMicros
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.totalAdjustmentsMicros = null;

                        /**
                         * AccountBudget amountServedMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} amountServedMicros
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.amountServedMicros = null;

                        /**
                         * AccountBudget purchaseOrderNumber.
                         * @member {google.protobuf.IStringValue|null|undefined} purchaseOrderNumber
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.purchaseOrderNumber = null;

                        /**
                         * AccountBudget notes.
                         * @member {google.protobuf.IStringValue|null|undefined} notes
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.notes = null;

                        /**
                         * AccountBudget pendingProposal.
                         * @member {google.ads.googleads.v1.resources.AccountBudget.IPendingAccountBudgetProposal|null|undefined} pendingProposal
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.pendingProposal = null;

                        /**
                         * AccountBudget proposedEndDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} proposedEndDateTime
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.proposedEndDateTime = null;

                        /**
                         * AccountBudget proposedEndTimeType.
                         * @member {google.ads.googleads.v1.enums.TimeTypeEnum.TimeType} proposedEndTimeType
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.proposedEndTimeType = 0;

                        /**
                         * AccountBudget approvedEndDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} approvedEndDateTime
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.approvedEndDateTime = null;

                        /**
                         * AccountBudget approvedEndTimeType.
                         * @member {google.ads.googleads.v1.enums.TimeTypeEnum.TimeType} approvedEndTimeType
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.approvedEndTimeType = 0;

                        /**
                         * AccountBudget proposedSpendingLimitMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} proposedSpendingLimitMicros
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.proposedSpendingLimitMicros = null;

                        /**
                         * AccountBudget proposedSpendingLimitType.
                         * @member {google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType} proposedSpendingLimitType
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.proposedSpendingLimitType = 0;

                        /**
                         * AccountBudget approvedSpendingLimitMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} approvedSpendingLimitMicros
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.approvedSpendingLimitMicros = null;

                        /**
                         * AccountBudget approvedSpendingLimitType.
                         * @member {google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType} approvedSpendingLimitType
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.approvedSpendingLimitType = 0;

                        /**
                         * AccountBudget adjustedSpendingLimitMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} adjustedSpendingLimitMicros
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.adjustedSpendingLimitMicros = null;

                        /**
                         * AccountBudget adjustedSpendingLimitType.
                         * @member {google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType} adjustedSpendingLimitType
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        AccountBudget.prototype.adjustedSpendingLimitType = 0;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AccountBudget proposedEndTime.
                         * @member {"proposedEndDateTime"|"proposedEndTimeType"|undefined} proposedEndTime
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        Object.defineProperty(AccountBudget.prototype, "proposedEndTime", {
                            get: $util.oneOfGetter($oneOfFields = ["proposedEndDateTime", "proposedEndTimeType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * AccountBudget approvedEndTime.
                         * @member {"approvedEndDateTime"|"approvedEndTimeType"|undefined} approvedEndTime
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        Object.defineProperty(AccountBudget.prototype, "approvedEndTime", {
                            get: $util.oneOfGetter($oneOfFields = ["approvedEndDateTime", "approvedEndTimeType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * AccountBudget proposedSpendingLimit.
                         * @member {"proposedSpendingLimitMicros"|"proposedSpendingLimitType"|undefined} proposedSpendingLimit
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        Object.defineProperty(AccountBudget.prototype, "proposedSpendingLimit", {
                            get: $util.oneOfGetter($oneOfFields = ["proposedSpendingLimitMicros", "proposedSpendingLimitType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * AccountBudget approvedSpendingLimit.
                         * @member {"approvedSpendingLimitMicros"|"approvedSpendingLimitType"|undefined} approvedSpendingLimit
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        Object.defineProperty(AccountBudget.prototype, "approvedSpendingLimit", {
                            get: $util.oneOfGetter($oneOfFields = ["approvedSpendingLimitMicros", "approvedSpendingLimitType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * AccountBudget adjustedSpendingLimit.
                         * @member {"adjustedSpendingLimitMicros"|"adjustedSpendingLimitType"|undefined} adjustedSpendingLimit
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         */
                        Object.defineProperty(AccountBudget.prototype, "adjustedSpendingLimit", {
                            get: $util.oneOfGetter($oneOfFields = ["adjustedSpendingLimitMicros", "adjustedSpendingLimitType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AccountBudget instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAccountBudget=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AccountBudget} AccountBudget instance
                         */
                        AccountBudget.create = function create(properties) {
                            return new AccountBudget(properties);
                        };

                        /**
                         * Encodes the specified AccountBudget message. Does not implicitly {@link google.ads.googleads.v1.resources.AccountBudget.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAccountBudget} message AccountBudget message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccountBudget.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.billingSetup != null && message.hasOwnProperty("billingSetup"))
                                $root.google.protobuf.StringValue.encode(message.billingSetup, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.status);
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.proposedStartDateTime != null && message.hasOwnProperty("proposedStartDateTime"))
                                $root.google.protobuf.StringValue.encode(message.proposedStartDateTime, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.approvedStartDateTime != null && message.hasOwnProperty("approvedStartDateTime"))
                                $root.google.protobuf.StringValue.encode(message.approvedStartDateTime, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.proposedEndDateTime != null && message.hasOwnProperty("proposedEndDateTime"))
                                $root.google.protobuf.StringValue.encode(message.proposedEndDateTime, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.proposedEndTimeType != null && message.hasOwnProperty("proposedEndTimeType"))
                                writer.uint32(/* id 9, wireType 0 =*/72).int32(message.proposedEndTimeType);
                            if (message.approvedEndDateTime != null && message.hasOwnProperty("approvedEndDateTime"))
                                $root.google.protobuf.StringValue.encode(message.approvedEndDateTime, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.approvedEndTimeType != null && message.hasOwnProperty("approvedEndTimeType"))
                                writer.uint32(/* id 11, wireType 0 =*/88).int32(message.approvedEndTimeType);
                            if (message.proposedSpendingLimitMicros != null && message.hasOwnProperty("proposedSpendingLimitMicros"))
                                $root.google.protobuf.Int64Value.encode(message.proposedSpendingLimitMicros, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.proposedSpendingLimitType != null && message.hasOwnProperty("proposedSpendingLimitType"))
                                writer.uint32(/* id 13, wireType 0 =*/104).int32(message.proposedSpendingLimitType);
                            if (message.approvedSpendingLimitMicros != null && message.hasOwnProperty("approvedSpendingLimitMicros"))
                                $root.google.protobuf.Int64Value.encode(message.approvedSpendingLimitMicros, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.approvedSpendingLimitType != null && message.hasOwnProperty("approvedSpendingLimitType"))
                                writer.uint32(/* id 15, wireType 0 =*/120).int32(message.approvedSpendingLimitType);
                            if (message.adjustedSpendingLimitMicros != null && message.hasOwnProperty("adjustedSpendingLimitMicros"))
                                $root.google.protobuf.Int64Value.encode(message.adjustedSpendingLimitMicros, writer.uint32(/* id 16, wireType 2 =*/130).fork()).ldelim();
                            if (message.adjustedSpendingLimitType != null && message.hasOwnProperty("adjustedSpendingLimitType"))
                                writer.uint32(/* id 17, wireType 0 =*/136).int32(message.adjustedSpendingLimitType);
                            if (message.totalAdjustmentsMicros != null && message.hasOwnProperty("totalAdjustmentsMicros"))
                                $root.google.protobuf.Int64Value.encode(message.totalAdjustmentsMicros, writer.uint32(/* id 18, wireType 2 =*/146).fork()).ldelim();
                            if (message.amountServedMicros != null && message.hasOwnProperty("amountServedMicros"))
                                $root.google.protobuf.Int64Value.encode(message.amountServedMicros, writer.uint32(/* id 19, wireType 2 =*/154).fork()).ldelim();
                            if (message.purchaseOrderNumber != null && message.hasOwnProperty("purchaseOrderNumber"))
                                $root.google.protobuf.StringValue.encode(message.purchaseOrderNumber, writer.uint32(/* id 20, wireType 2 =*/162).fork()).ldelim();
                            if (message.notes != null && message.hasOwnProperty("notes"))
                                $root.google.protobuf.StringValue.encode(message.notes, writer.uint32(/* id 21, wireType 2 =*/170).fork()).ldelim();
                            if (message.pendingProposal != null && message.hasOwnProperty("pendingProposal"))
                                $root.google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal.encode(message.pendingProposal, writer.uint32(/* id 22, wireType 2 =*/178).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AccountBudget message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AccountBudget.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAccountBudget} message AccountBudget message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccountBudget.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AccountBudget message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AccountBudget} AccountBudget
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccountBudget.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AccountBudget();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.billingSetup = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.status = reader.int32();
                                    break;
                                case 5:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.proposedStartDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.approvedStartDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 18:
                                    message.totalAdjustmentsMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 19:
                                    message.amountServedMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 20:
                                    message.purchaseOrderNumber = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 21:
                                    message.notes = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 22:
                                    message.pendingProposal = $root.google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.proposedEndDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.proposedEndTimeType = reader.int32();
                                    break;
                                case 10:
                                    message.approvedEndDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.approvedEndTimeType = reader.int32();
                                    break;
                                case 12:
                                    message.proposedSpendingLimitMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 13:
                                    message.proposedSpendingLimitType = reader.int32();
                                    break;
                                case 14:
                                    message.approvedSpendingLimitMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 15:
                                    message.approvedSpendingLimitType = reader.int32();
                                    break;
                                case 16:
                                    message.adjustedSpendingLimitMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 17:
                                    message.adjustedSpendingLimitType = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AccountBudget message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AccountBudget} AccountBudget
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccountBudget.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AccountBudget message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccountBudget.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.billingSetup != null && message.hasOwnProperty("billingSetup")) {
                                var error = $root.google.protobuf.StringValue.verify(message.billingSetup);
                                if (error)
                                    return "billingSetup." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.proposedStartDateTime != null && message.hasOwnProperty("proposedStartDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.proposedStartDateTime);
                                if (error)
                                    return "proposedStartDateTime." + error;
                            }
                            if (message.approvedStartDateTime != null && message.hasOwnProperty("approvedStartDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.approvedStartDateTime);
                                if (error)
                                    return "approvedStartDateTime." + error;
                            }
                            if (message.totalAdjustmentsMicros != null && message.hasOwnProperty("totalAdjustmentsMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.totalAdjustmentsMicros);
                                if (error)
                                    return "totalAdjustmentsMicros." + error;
                            }
                            if (message.amountServedMicros != null && message.hasOwnProperty("amountServedMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.amountServedMicros);
                                if (error)
                                    return "amountServedMicros." + error;
                            }
                            if (message.purchaseOrderNumber != null && message.hasOwnProperty("purchaseOrderNumber")) {
                                var error = $root.google.protobuf.StringValue.verify(message.purchaseOrderNumber);
                                if (error)
                                    return "purchaseOrderNumber." + error;
                            }
                            if (message.notes != null && message.hasOwnProperty("notes")) {
                                var error = $root.google.protobuf.StringValue.verify(message.notes);
                                if (error)
                                    return "notes." + error;
                            }
                            if (message.pendingProposal != null && message.hasOwnProperty("pendingProposal")) {
                                var error = $root.google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal.verify(message.pendingProposal);
                                if (error)
                                    return "pendingProposal." + error;
                            }
                            if (message.proposedEndDateTime != null && message.hasOwnProperty("proposedEndDateTime")) {
                                properties.proposedEndTime = 1;
                                {
                                    var error = $root.google.protobuf.StringValue.verify(message.proposedEndDateTime);
                                    if (error)
                                        return "proposedEndDateTime." + error;
                                }
                            }
                            if (message.proposedEndTimeType != null && message.hasOwnProperty("proposedEndTimeType")) {
                                if (properties.proposedEndTime === 1)
                                    return "proposedEndTime: multiple values";
                                properties.proposedEndTime = 1;
                                switch (message.proposedEndTimeType) {
                                default:
                                    return "proposedEndTimeType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.approvedEndDateTime != null && message.hasOwnProperty("approvedEndDateTime")) {
                                properties.approvedEndTime = 1;
                                {
                                    var error = $root.google.protobuf.StringValue.verify(message.approvedEndDateTime);
                                    if (error)
                                        return "approvedEndDateTime." + error;
                                }
                            }
                            if (message.approvedEndTimeType != null && message.hasOwnProperty("approvedEndTimeType")) {
                                if (properties.approvedEndTime === 1)
                                    return "approvedEndTime: multiple values";
                                properties.approvedEndTime = 1;
                                switch (message.approvedEndTimeType) {
                                default:
                                    return "approvedEndTimeType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.proposedSpendingLimitMicros != null && message.hasOwnProperty("proposedSpendingLimitMicros")) {
                                properties.proposedSpendingLimit = 1;
                                {
                                    var error = $root.google.protobuf.Int64Value.verify(message.proposedSpendingLimitMicros);
                                    if (error)
                                        return "proposedSpendingLimitMicros." + error;
                                }
                            }
                            if (message.proposedSpendingLimitType != null && message.hasOwnProperty("proposedSpendingLimitType")) {
                                if (properties.proposedSpendingLimit === 1)
                                    return "proposedSpendingLimit: multiple values";
                                properties.proposedSpendingLimit = 1;
                                switch (message.proposedSpendingLimitType) {
                                default:
                                    return "proposedSpendingLimitType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            if (message.approvedSpendingLimitMicros != null && message.hasOwnProperty("approvedSpendingLimitMicros")) {
                                properties.approvedSpendingLimit = 1;
                                {
                                    var error = $root.google.protobuf.Int64Value.verify(message.approvedSpendingLimitMicros);
                                    if (error)
                                        return "approvedSpendingLimitMicros." + error;
                                }
                            }
                            if (message.approvedSpendingLimitType != null && message.hasOwnProperty("approvedSpendingLimitType")) {
                                if (properties.approvedSpendingLimit === 1)
                                    return "approvedSpendingLimit: multiple values";
                                properties.approvedSpendingLimit = 1;
                                switch (message.approvedSpendingLimitType) {
                                default:
                                    return "approvedSpendingLimitType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            if (message.adjustedSpendingLimitMicros != null && message.hasOwnProperty("adjustedSpendingLimitMicros")) {
                                properties.adjustedSpendingLimit = 1;
                                {
                                    var error = $root.google.protobuf.Int64Value.verify(message.adjustedSpendingLimitMicros);
                                    if (error)
                                        return "adjustedSpendingLimitMicros." + error;
                                }
                            }
                            if (message.adjustedSpendingLimitType != null && message.hasOwnProperty("adjustedSpendingLimitType")) {
                                if (properties.adjustedSpendingLimit === 1)
                                    return "adjustedSpendingLimit: multiple values";
                                properties.adjustedSpendingLimit = 1;
                                switch (message.adjustedSpendingLimitType) {
                                default:
                                    return "adjustedSpendingLimitType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an AccountBudget message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AccountBudget} AccountBudget
                         */
                        AccountBudget.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AccountBudget)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AccountBudget();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.billingSetup != null) {
                                if (typeof object.billingSetup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.billingSetup: object expected");
                                message.billingSetup = $root.google.protobuf.StringValue.fromObject(object.billingSetup);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "PENDING":
                            case 2:
                                message.status = 2;
                                break;
                            case "APPROVED":
                            case 3:
                                message.status = 3;
                                break;
                            case "CANCELLED":
                            case 4:
                                message.status = 4;
                                break;
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            if (object.proposedStartDateTime != null) {
                                if (typeof object.proposedStartDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.proposedStartDateTime: object expected");
                                message.proposedStartDateTime = $root.google.protobuf.StringValue.fromObject(object.proposedStartDateTime);
                            }
                            if (object.approvedStartDateTime != null) {
                                if (typeof object.approvedStartDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.approvedStartDateTime: object expected");
                                message.approvedStartDateTime = $root.google.protobuf.StringValue.fromObject(object.approvedStartDateTime);
                            }
                            if (object.totalAdjustmentsMicros != null) {
                                if (typeof object.totalAdjustmentsMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.totalAdjustmentsMicros: object expected");
                                message.totalAdjustmentsMicros = $root.google.protobuf.Int64Value.fromObject(object.totalAdjustmentsMicros);
                            }
                            if (object.amountServedMicros != null) {
                                if (typeof object.amountServedMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.amountServedMicros: object expected");
                                message.amountServedMicros = $root.google.protobuf.Int64Value.fromObject(object.amountServedMicros);
                            }
                            if (object.purchaseOrderNumber != null) {
                                if (typeof object.purchaseOrderNumber !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.purchaseOrderNumber: object expected");
                                message.purchaseOrderNumber = $root.google.protobuf.StringValue.fromObject(object.purchaseOrderNumber);
                            }
                            if (object.notes != null) {
                                if (typeof object.notes !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.notes: object expected");
                                message.notes = $root.google.protobuf.StringValue.fromObject(object.notes);
                            }
                            if (object.pendingProposal != null) {
                                if (typeof object.pendingProposal !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.pendingProposal: object expected");
                                message.pendingProposal = $root.google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal.fromObject(object.pendingProposal);
                            }
                            if (object.proposedEndDateTime != null) {
                                if (typeof object.proposedEndDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.proposedEndDateTime: object expected");
                                message.proposedEndDateTime = $root.google.protobuf.StringValue.fromObject(object.proposedEndDateTime);
                            }
                            switch (object.proposedEndTimeType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.proposedEndTimeType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.proposedEndTimeType = 1;
                                break;
                            case "NOW":
                            case 2:
                                message.proposedEndTimeType = 2;
                                break;
                            case "FOREVER":
                            case 3:
                                message.proposedEndTimeType = 3;
                                break;
                            }
                            if (object.approvedEndDateTime != null) {
                                if (typeof object.approvedEndDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.approvedEndDateTime: object expected");
                                message.approvedEndDateTime = $root.google.protobuf.StringValue.fromObject(object.approvedEndDateTime);
                            }
                            switch (object.approvedEndTimeType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.approvedEndTimeType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.approvedEndTimeType = 1;
                                break;
                            case "NOW":
                            case 2:
                                message.approvedEndTimeType = 2;
                                break;
                            case "FOREVER":
                            case 3:
                                message.approvedEndTimeType = 3;
                                break;
                            }
                            if (object.proposedSpendingLimitMicros != null) {
                                if (typeof object.proposedSpendingLimitMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.proposedSpendingLimitMicros: object expected");
                                message.proposedSpendingLimitMicros = $root.google.protobuf.Int64Value.fromObject(object.proposedSpendingLimitMicros);
                            }
                            switch (object.proposedSpendingLimitType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.proposedSpendingLimitType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.proposedSpendingLimitType = 1;
                                break;
                            case "INFINITE":
                            case 2:
                                message.proposedSpendingLimitType = 2;
                                break;
                            }
                            if (object.approvedSpendingLimitMicros != null) {
                                if (typeof object.approvedSpendingLimitMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.approvedSpendingLimitMicros: object expected");
                                message.approvedSpendingLimitMicros = $root.google.protobuf.Int64Value.fromObject(object.approvedSpendingLimitMicros);
                            }
                            switch (object.approvedSpendingLimitType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.approvedSpendingLimitType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.approvedSpendingLimitType = 1;
                                break;
                            case "INFINITE":
                            case 2:
                                message.approvedSpendingLimitType = 2;
                                break;
                            }
                            if (object.adjustedSpendingLimitMicros != null) {
                                if (typeof object.adjustedSpendingLimitMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.adjustedSpendingLimitMicros: object expected");
                                message.adjustedSpendingLimitMicros = $root.google.protobuf.Int64Value.fromObject(object.adjustedSpendingLimitMicros);
                            }
                            switch (object.adjustedSpendingLimitType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.adjustedSpendingLimitType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.adjustedSpendingLimitType = 1;
                                break;
                            case "INFINITE":
                            case 2:
                                message.adjustedSpendingLimitType = 2;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AccountBudget message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @static
                         * @param {google.ads.googleads.v1.resources.AccountBudget} message AccountBudget
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccountBudget.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.billingSetup = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                                object.name = null;
                                object.proposedStartDateTime = null;
                                object.approvedStartDateTime = null;
                                object.totalAdjustmentsMicros = null;
                                object.amountServedMicros = null;
                                object.purchaseOrderNumber = null;
                                object.notes = null;
                                object.pendingProposal = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.billingSetup != null && message.hasOwnProperty("billingSetup"))
                                object.billingSetup = $root.google.protobuf.StringValue.toObject(message.billingSetup, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.AccountBudgetStatusEnum.AccountBudgetStatus[message.status] : message.status;
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.proposedStartDateTime != null && message.hasOwnProperty("proposedStartDateTime"))
                                object.proposedStartDateTime = $root.google.protobuf.StringValue.toObject(message.proposedStartDateTime, options);
                            if (message.approvedStartDateTime != null && message.hasOwnProperty("approvedStartDateTime"))
                                object.approvedStartDateTime = $root.google.protobuf.StringValue.toObject(message.approvedStartDateTime, options);
                            if (message.proposedEndDateTime != null && message.hasOwnProperty("proposedEndDateTime")) {
                                object.proposedEndDateTime = $root.google.protobuf.StringValue.toObject(message.proposedEndDateTime, options);
                                if (options.oneofs)
                                    object.proposedEndTime = "proposedEndDateTime";
                            }
                            if (message.proposedEndTimeType != null && message.hasOwnProperty("proposedEndTimeType")) {
                                object.proposedEndTimeType = options.enums === String ? $root.google.ads.googleads.v1.enums.TimeTypeEnum.TimeType[message.proposedEndTimeType] : message.proposedEndTimeType;
                                if (options.oneofs)
                                    object.proposedEndTime = "proposedEndTimeType";
                            }
                            if (message.approvedEndDateTime != null && message.hasOwnProperty("approvedEndDateTime")) {
                                object.approvedEndDateTime = $root.google.protobuf.StringValue.toObject(message.approvedEndDateTime, options);
                                if (options.oneofs)
                                    object.approvedEndTime = "approvedEndDateTime";
                            }
                            if (message.approvedEndTimeType != null && message.hasOwnProperty("approvedEndTimeType")) {
                                object.approvedEndTimeType = options.enums === String ? $root.google.ads.googleads.v1.enums.TimeTypeEnum.TimeType[message.approvedEndTimeType] : message.approvedEndTimeType;
                                if (options.oneofs)
                                    object.approvedEndTime = "approvedEndTimeType";
                            }
                            if (message.proposedSpendingLimitMicros != null && message.hasOwnProperty("proposedSpendingLimitMicros")) {
                                object.proposedSpendingLimitMicros = $root.google.protobuf.Int64Value.toObject(message.proposedSpendingLimitMicros, options);
                                if (options.oneofs)
                                    object.proposedSpendingLimit = "proposedSpendingLimitMicros";
                            }
                            if (message.proposedSpendingLimitType != null && message.hasOwnProperty("proposedSpendingLimitType")) {
                                object.proposedSpendingLimitType = options.enums === String ? $root.google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType[message.proposedSpendingLimitType] : message.proposedSpendingLimitType;
                                if (options.oneofs)
                                    object.proposedSpendingLimit = "proposedSpendingLimitType";
                            }
                            if (message.approvedSpendingLimitMicros != null && message.hasOwnProperty("approvedSpendingLimitMicros")) {
                                object.approvedSpendingLimitMicros = $root.google.protobuf.Int64Value.toObject(message.approvedSpendingLimitMicros, options);
                                if (options.oneofs)
                                    object.approvedSpendingLimit = "approvedSpendingLimitMicros";
                            }
                            if (message.approvedSpendingLimitType != null && message.hasOwnProperty("approvedSpendingLimitType")) {
                                object.approvedSpendingLimitType = options.enums === String ? $root.google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType[message.approvedSpendingLimitType] : message.approvedSpendingLimitType;
                                if (options.oneofs)
                                    object.approvedSpendingLimit = "approvedSpendingLimitType";
                            }
                            if (message.adjustedSpendingLimitMicros != null && message.hasOwnProperty("adjustedSpendingLimitMicros")) {
                                object.adjustedSpendingLimitMicros = $root.google.protobuf.Int64Value.toObject(message.adjustedSpendingLimitMicros, options);
                                if (options.oneofs)
                                    object.adjustedSpendingLimit = "adjustedSpendingLimitMicros";
                            }
                            if (message.adjustedSpendingLimitType != null && message.hasOwnProperty("adjustedSpendingLimitType")) {
                                object.adjustedSpendingLimitType = options.enums === String ? $root.google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType[message.adjustedSpendingLimitType] : message.adjustedSpendingLimitType;
                                if (options.oneofs)
                                    object.adjustedSpendingLimit = "adjustedSpendingLimitType";
                            }
                            if (message.totalAdjustmentsMicros != null && message.hasOwnProperty("totalAdjustmentsMicros"))
                                object.totalAdjustmentsMicros = $root.google.protobuf.Int64Value.toObject(message.totalAdjustmentsMicros, options);
                            if (message.amountServedMicros != null && message.hasOwnProperty("amountServedMicros"))
                                object.amountServedMicros = $root.google.protobuf.Int64Value.toObject(message.amountServedMicros, options);
                            if (message.purchaseOrderNumber != null && message.hasOwnProperty("purchaseOrderNumber"))
                                object.purchaseOrderNumber = $root.google.protobuf.StringValue.toObject(message.purchaseOrderNumber, options);
                            if (message.notes != null && message.hasOwnProperty("notes"))
                                object.notes = $root.google.protobuf.StringValue.toObject(message.notes, options);
                            if (message.pendingProposal != null && message.hasOwnProperty("pendingProposal"))
                                object.pendingProposal = $root.google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal.toObject(message.pendingProposal, options);
                            return object;
                        };

                        /**
                         * Converts this AccountBudget to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AccountBudget
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccountBudget.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        AccountBudget.PendingAccountBudgetProposal = (function() {

                            /**
                             * Properties of a PendingAccountBudgetProposal.
                             * @memberof google.ads.googleads.v1.resources.AccountBudget
                             * @interface IPendingAccountBudgetProposal
                             * @property {google.protobuf.IStringValue|null} [accountBudgetProposal] PendingAccountBudgetProposal accountBudgetProposal
                             * @property {google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum.AccountBudgetProposalType|null} [proposalType] PendingAccountBudgetProposal proposalType
                             * @property {google.protobuf.IStringValue|null} [name] PendingAccountBudgetProposal name
                             * @property {google.protobuf.IStringValue|null} [startDateTime] PendingAccountBudgetProposal startDateTime
                             * @property {google.protobuf.IStringValue|null} [purchaseOrderNumber] PendingAccountBudgetProposal purchaseOrderNumber
                             * @property {google.protobuf.IStringValue|null} [notes] PendingAccountBudgetProposal notes
                             * @property {google.protobuf.IStringValue|null} [creationDateTime] PendingAccountBudgetProposal creationDateTime
                             * @property {google.protobuf.IStringValue|null} [endDateTime] PendingAccountBudgetProposal endDateTime
                             * @property {google.ads.googleads.v1.enums.TimeTypeEnum.TimeType|null} [endTimeType] PendingAccountBudgetProposal endTimeType
                             * @property {google.protobuf.IInt64Value|null} [spendingLimitMicros] PendingAccountBudgetProposal spendingLimitMicros
                             * @property {google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType|null} [spendingLimitType] PendingAccountBudgetProposal spendingLimitType
                             */

                            /**
                             * Constructs a new PendingAccountBudgetProposal.
                             * @memberof google.ads.googleads.v1.resources.AccountBudget
                             * @classdesc Represents a PendingAccountBudgetProposal.
                             * @implements IPendingAccountBudgetProposal
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.AccountBudget.IPendingAccountBudgetProposal=} [properties] Properties to set
                             */
                            function PendingAccountBudgetProposal(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * PendingAccountBudgetProposal accountBudgetProposal.
                             * @member {google.protobuf.IStringValue|null|undefined} accountBudgetProposal
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @instance
                             */
                            PendingAccountBudgetProposal.prototype.accountBudgetProposal = null;

                            /**
                             * PendingAccountBudgetProposal proposalType.
                             * @member {google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum.AccountBudgetProposalType} proposalType
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @instance
                             */
                            PendingAccountBudgetProposal.prototype.proposalType = 0;

                            /**
                             * PendingAccountBudgetProposal name.
                             * @member {google.protobuf.IStringValue|null|undefined} name
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @instance
                             */
                            PendingAccountBudgetProposal.prototype.name = null;

                            /**
                             * PendingAccountBudgetProposal startDateTime.
                             * @member {google.protobuf.IStringValue|null|undefined} startDateTime
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @instance
                             */
                            PendingAccountBudgetProposal.prototype.startDateTime = null;

                            /**
                             * PendingAccountBudgetProposal purchaseOrderNumber.
                             * @member {google.protobuf.IStringValue|null|undefined} purchaseOrderNumber
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @instance
                             */
                            PendingAccountBudgetProposal.prototype.purchaseOrderNumber = null;

                            /**
                             * PendingAccountBudgetProposal notes.
                             * @member {google.protobuf.IStringValue|null|undefined} notes
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @instance
                             */
                            PendingAccountBudgetProposal.prototype.notes = null;

                            /**
                             * PendingAccountBudgetProposal creationDateTime.
                             * @member {google.protobuf.IStringValue|null|undefined} creationDateTime
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @instance
                             */
                            PendingAccountBudgetProposal.prototype.creationDateTime = null;

                            /**
                             * PendingAccountBudgetProposal endDateTime.
                             * @member {google.protobuf.IStringValue|null|undefined} endDateTime
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @instance
                             */
                            PendingAccountBudgetProposal.prototype.endDateTime = null;

                            /**
                             * PendingAccountBudgetProposal endTimeType.
                             * @member {google.ads.googleads.v1.enums.TimeTypeEnum.TimeType} endTimeType
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @instance
                             */
                            PendingAccountBudgetProposal.prototype.endTimeType = 0;

                            /**
                             * PendingAccountBudgetProposal spendingLimitMicros.
                             * @member {google.protobuf.IInt64Value|null|undefined} spendingLimitMicros
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @instance
                             */
                            PendingAccountBudgetProposal.prototype.spendingLimitMicros = null;

                            /**
                             * PendingAccountBudgetProposal spendingLimitType.
                             * @member {google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType} spendingLimitType
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @instance
                             */
                            PendingAccountBudgetProposal.prototype.spendingLimitType = 0;

                            // OneOf field names bound to virtual getters and setters
                            var $oneOfFields;

                            /**
                             * PendingAccountBudgetProposal endTime.
                             * @member {"endDateTime"|"endTimeType"|undefined} endTime
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @instance
                             */
                            Object.defineProperty(PendingAccountBudgetProposal.prototype, "endTime", {
                                get: $util.oneOfGetter($oneOfFields = ["endDateTime", "endTimeType"]),
                                set: $util.oneOfSetter($oneOfFields)
                            });

                            /**
                             * PendingAccountBudgetProposal spendingLimit.
                             * @member {"spendingLimitMicros"|"spendingLimitType"|undefined} spendingLimit
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @instance
                             */
                            Object.defineProperty(PendingAccountBudgetProposal.prototype, "spendingLimit", {
                                get: $util.oneOfGetter($oneOfFields = ["spendingLimitMicros", "spendingLimitType"]),
                                set: $util.oneOfSetter($oneOfFields)
                            });

                            /**
                             * Creates a new PendingAccountBudgetProposal instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @static
                             * @param {google.ads.googleads.v1.resources.AccountBudget.IPendingAccountBudgetProposal=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal} PendingAccountBudgetProposal instance
                             */
                            PendingAccountBudgetProposal.create = function create(properties) {
                                return new PendingAccountBudgetProposal(properties);
                            };

                            /**
                             * Encodes the specified PendingAccountBudgetProposal message. Does not implicitly {@link google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @static
                             * @param {google.ads.googleads.v1.resources.AccountBudget.IPendingAccountBudgetProposal} message PendingAccountBudgetProposal message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            PendingAccountBudgetProposal.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.accountBudgetProposal != null && message.hasOwnProperty("accountBudgetProposal"))
                                    $root.google.protobuf.StringValue.encode(message.accountBudgetProposal, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.proposalType != null && message.hasOwnProperty("proposalType"))
                                    writer.uint32(/* id 2, wireType 0 =*/16).int32(message.proposalType);
                                if (message.name != null && message.hasOwnProperty("name"))
                                    $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                                if (message.startDateTime != null && message.hasOwnProperty("startDateTime"))
                                    $root.google.protobuf.StringValue.encode(message.startDateTime, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                                if (message.endDateTime != null && message.hasOwnProperty("endDateTime"))
                                    $root.google.protobuf.StringValue.encode(message.endDateTime, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                                if (message.endTimeType != null && message.hasOwnProperty("endTimeType"))
                                    writer.uint32(/* id 6, wireType 0 =*/48).int32(message.endTimeType);
                                if (message.spendingLimitMicros != null && message.hasOwnProperty("spendingLimitMicros"))
                                    $root.google.protobuf.Int64Value.encode(message.spendingLimitMicros, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                                if (message.spendingLimitType != null && message.hasOwnProperty("spendingLimitType"))
                                    writer.uint32(/* id 8, wireType 0 =*/64).int32(message.spendingLimitType);
                                if (message.purchaseOrderNumber != null && message.hasOwnProperty("purchaseOrderNumber"))
                                    $root.google.protobuf.StringValue.encode(message.purchaseOrderNumber, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                                if (message.notes != null && message.hasOwnProperty("notes"))
                                    $root.google.protobuf.StringValue.encode(message.notes, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                                if (message.creationDateTime != null && message.hasOwnProperty("creationDateTime"))
                                    $root.google.protobuf.StringValue.encode(message.creationDateTime, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified PendingAccountBudgetProposal message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @static
                             * @param {google.ads.googleads.v1.resources.AccountBudget.IPendingAccountBudgetProposal} message PendingAccountBudgetProposal message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            PendingAccountBudgetProposal.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a PendingAccountBudgetProposal message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal} PendingAccountBudgetProposal
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            PendingAccountBudgetProposal.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.accountBudgetProposal = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.proposalType = reader.int32();
                                        break;
                                    case 3:
                                        message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 4:
                                        message.startDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 9:
                                        message.purchaseOrderNumber = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 10:
                                        message.notes = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 11:
                                        message.creationDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 5:
                                        message.endDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 6:
                                        message.endTimeType = reader.int32();
                                        break;
                                    case 7:
                                        message.spendingLimitMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    case 8:
                                        message.spendingLimitType = reader.int32();
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a PendingAccountBudgetProposal message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal} PendingAccountBudgetProposal
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            PendingAccountBudgetProposal.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a PendingAccountBudgetProposal message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            PendingAccountBudgetProposal.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                var properties = {};
                                if (message.accountBudgetProposal != null && message.hasOwnProperty("accountBudgetProposal")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.accountBudgetProposal);
                                    if (error)
                                        return "accountBudgetProposal." + error;
                                }
                                if (message.proposalType != null && message.hasOwnProperty("proposalType"))
                                    switch (message.proposalType) {
                                    default:
                                        return "proposalType: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                    case 5:
                                        break;
                                    }
                                if (message.name != null && message.hasOwnProperty("name")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.name);
                                    if (error)
                                        return "name." + error;
                                }
                                if (message.startDateTime != null && message.hasOwnProperty("startDateTime")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.startDateTime);
                                    if (error)
                                        return "startDateTime." + error;
                                }
                                if (message.purchaseOrderNumber != null && message.hasOwnProperty("purchaseOrderNumber")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.purchaseOrderNumber);
                                    if (error)
                                        return "purchaseOrderNumber." + error;
                                }
                                if (message.notes != null && message.hasOwnProperty("notes")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.notes);
                                    if (error)
                                        return "notes." + error;
                                }
                                if (message.creationDateTime != null && message.hasOwnProperty("creationDateTime")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.creationDateTime);
                                    if (error)
                                        return "creationDateTime." + error;
                                }
                                if (message.endDateTime != null && message.hasOwnProperty("endDateTime")) {
                                    properties.endTime = 1;
                                    {
                                        var error = $root.google.protobuf.StringValue.verify(message.endDateTime);
                                        if (error)
                                            return "endDateTime." + error;
                                    }
                                }
                                if (message.endTimeType != null && message.hasOwnProperty("endTimeType")) {
                                    if (properties.endTime === 1)
                                        return "endTime: multiple values";
                                    properties.endTime = 1;
                                    switch (message.endTimeType) {
                                    default:
                                        return "endTimeType: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                        break;
                                    }
                                }
                                if (message.spendingLimitMicros != null && message.hasOwnProperty("spendingLimitMicros")) {
                                    properties.spendingLimit = 1;
                                    {
                                        var error = $root.google.protobuf.Int64Value.verify(message.spendingLimitMicros);
                                        if (error)
                                            return "spendingLimitMicros." + error;
                                    }
                                }
                                if (message.spendingLimitType != null && message.hasOwnProperty("spendingLimitType")) {
                                    if (properties.spendingLimit === 1)
                                        return "spendingLimit: multiple values";
                                    properties.spendingLimit = 1;
                                    switch (message.spendingLimitType) {
                                    default:
                                        return "spendingLimitType: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                        break;
                                    }
                                }
                                return null;
                            };

                            /**
                             * Creates a PendingAccountBudgetProposal message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal} PendingAccountBudgetProposal
                             */
                            PendingAccountBudgetProposal.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal();
                                if (object.accountBudgetProposal != null) {
                                    if (typeof object.accountBudgetProposal !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal.accountBudgetProposal: object expected");
                                    message.accountBudgetProposal = $root.google.protobuf.StringValue.fromObject(object.accountBudgetProposal);
                                }
                                switch (object.proposalType) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.proposalType = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.proposalType = 1;
                                    break;
                                case "CREATE":
                                case 2:
                                    message.proposalType = 2;
                                    break;
                                case "UPDATE":
                                case 3:
                                    message.proposalType = 3;
                                    break;
                                case "END":
                                case 4:
                                    message.proposalType = 4;
                                    break;
                                case "REMOVE":
                                case 5:
                                    message.proposalType = 5;
                                    break;
                                }
                                if (object.name != null) {
                                    if (typeof object.name !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal.name: object expected");
                                    message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                                }
                                if (object.startDateTime != null) {
                                    if (typeof object.startDateTime !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal.startDateTime: object expected");
                                    message.startDateTime = $root.google.protobuf.StringValue.fromObject(object.startDateTime);
                                }
                                if (object.purchaseOrderNumber != null) {
                                    if (typeof object.purchaseOrderNumber !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal.purchaseOrderNumber: object expected");
                                    message.purchaseOrderNumber = $root.google.protobuf.StringValue.fromObject(object.purchaseOrderNumber);
                                }
                                if (object.notes != null) {
                                    if (typeof object.notes !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal.notes: object expected");
                                    message.notes = $root.google.protobuf.StringValue.fromObject(object.notes);
                                }
                                if (object.creationDateTime != null) {
                                    if (typeof object.creationDateTime !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal.creationDateTime: object expected");
                                    message.creationDateTime = $root.google.protobuf.StringValue.fromObject(object.creationDateTime);
                                }
                                if (object.endDateTime != null) {
                                    if (typeof object.endDateTime !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal.endDateTime: object expected");
                                    message.endDateTime = $root.google.protobuf.StringValue.fromObject(object.endDateTime);
                                }
                                switch (object.endTimeType) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.endTimeType = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.endTimeType = 1;
                                    break;
                                case "NOW":
                                case 2:
                                    message.endTimeType = 2;
                                    break;
                                case "FOREVER":
                                case 3:
                                    message.endTimeType = 3;
                                    break;
                                }
                                if (object.spendingLimitMicros != null) {
                                    if (typeof object.spendingLimitMicros !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal.spendingLimitMicros: object expected");
                                    message.spendingLimitMicros = $root.google.protobuf.Int64Value.fromObject(object.spendingLimitMicros);
                                }
                                switch (object.spendingLimitType) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.spendingLimitType = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.spendingLimitType = 1;
                                    break;
                                case "INFINITE":
                                case 2:
                                    message.spendingLimitType = 2;
                                    break;
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a PendingAccountBudgetProposal message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @static
                             * @param {google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal} message PendingAccountBudgetProposal
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            PendingAccountBudgetProposal.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.accountBudgetProposal = null;
                                    object.proposalType = options.enums === String ? "UNSPECIFIED" : 0;
                                    object.name = null;
                                    object.startDateTime = null;
                                    object.purchaseOrderNumber = null;
                                    object.notes = null;
                                    object.creationDateTime = null;
                                }
                                if (message.accountBudgetProposal != null && message.hasOwnProperty("accountBudgetProposal"))
                                    object.accountBudgetProposal = $root.google.protobuf.StringValue.toObject(message.accountBudgetProposal, options);
                                if (message.proposalType != null && message.hasOwnProperty("proposalType"))
                                    object.proposalType = options.enums === String ? $root.google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum.AccountBudgetProposalType[message.proposalType] : message.proposalType;
                                if (message.name != null && message.hasOwnProperty("name"))
                                    object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                                if (message.startDateTime != null && message.hasOwnProperty("startDateTime"))
                                    object.startDateTime = $root.google.protobuf.StringValue.toObject(message.startDateTime, options);
                                if (message.endDateTime != null && message.hasOwnProperty("endDateTime")) {
                                    object.endDateTime = $root.google.protobuf.StringValue.toObject(message.endDateTime, options);
                                    if (options.oneofs)
                                        object.endTime = "endDateTime";
                                }
                                if (message.endTimeType != null && message.hasOwnProperty("endTimeType")) {
                                    object.endTimeType = options.enums === String ? $root.google.ads.googleads.v1.enums.TimeTypeEnum.TimeType[message.endTimeType] : message.endTimeType;
                                    if (options.oneofs)
                                        object.endTime = "endTimeType";
                                }
                                if (message.spendingLimitMicros != null && message.hasOwnProperty("spendingLimitMicros")) {
                                    object.spendingLimitMicros = $root.google.protobuf.Int64Value.toObject(message.spendingLimitMicros, options);
                                    if (options.oneofs)
                                        object.spendingLimit = "spendingLimitMicros";
                                }
                                if (message.spendingLimitType != null && message.hasOwnProperty("spendingLimitType")) {
                                    object.spendingLimitType = options.enums === String ? $root.google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType[message.spendingLimitType] : message.spendingLimitType;
                                    if (options.oneofs)
                                        object.spendingLimit = "spendingLimitType";
                                }
                                if (message.purchaseOrderNumber != null && message.hasOwnProperty("purchaseOrderNumber"))
                                    object.purchaseOrderNumber = $root.google.protobuf.StringValue.toObject(message.purchaseOrderNumber, options);
                                if (message.notes != null && message.hasOwnProperty("notes"))
                                    object.notes = $root.google.protobuf.StringValue.toObject(message.notes, options);
                                if (message.creationDateTime != null && message.hasOwnProperty("creationDateTime"))
                                    object.creationDateTime = $root.google.protobuf.StringValue.toObject(message.creationDateTime, options);
                                return object;
                            };

                            /**
                             * Converts this PendingAccountBudgetProposal to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.AccountBudget.PendingAccountBudgetProposal
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            PendingAccountBudgetProposal.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return PendingAccountBudgetProposal;
                        })();

                        return AccountBudget;
                    })();

                    resources.AccountBudgetProposal = (function() {

                        /**
                         * Properties of an AccountBudgetProposal.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAccountBudgetProposal
                         * @property {string|null} [resourceName] AccountBudgetProposal resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] AccountBudgetProposal id
                         * @property {google.protobuf.IStringValue|null} [billingSetup] AccountBudgetProposal billingSetup
                         * @property {google.protobuf.IStringValue|null} [accountBudget] AccountBudgetProposal accountBudget
                         * @property {google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum.AccountBudgetProposalType|null} [proposalType] AccountBudgetProposal proposalType
                         * @property {google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum.AccountBudgetProposalStatus|null} [status] AccountBudgetProposal status
                         * @property {google.protobuf.IStringValue|null} [proposedName] AccountBudgetProposal proposedName
                         * @property {google.protobuf.IStringValue|null} [approvedStartDateTime] AccountBudgetProposal approvedStartDateTime
                         * @property {google.protobuf.IStringValue|null} [proposedPurchaseOrderNumber] AccountBudgetProposal proposedPurchaseOrderNumber
                         * @property {google.protobuf.IStringValue|null} [proposedNotes] AccountBudgetProposal proposedNotes
                         * @property {google.protobuf.IStringValue|null} [creationDateTime] AccountBudgetProposal creationDateTime
                         * @property {google.protobuf.IStringValue|null} [approvalDateTime] AccountBudgetProposal approvalDateTime
                         * @property {google.protobuf.IStringValue|null} [proposedStartDateTime] AccountBudgetProposal proposedStartDateTime
                         * @property {google.ads.googleads.v1.enums.TimeTypeEnum.TimeType|null} [proposedStartTimeType] AccountBudgetProposal proposedStartTimeType
                         * @property {google.protobuf.IStringValue|null} [proposedEndDateTime] AccountBudgetProposal proposedEndDateTime
                         * @property {google.ads.googleads.v1.enums.TimeTypeEnum.TimeType|null} [proposedEndTimeType] AccountBudgetProposal proposedEndTimeType
                         * @property {google.protobuf.IStringValue|null} [approvedEndDateTime] AccountBudgetProposal approvedEndDateTime
                         * @property {google.ads.googleads.v1.enums.TimeTypeEnum.TimeType|null} [approvedEndTimeType] AccountBudgetProposal approvedEndTimeType
                         * @property {google.protobuf.IInt64Value|null} [proposedSpendingLimitMicros] AccountBudgetProposal proposedSpendingLimitMicros
                         * @property {google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType|null} [proposedSpendingLimitType] AccountBudgetProposal proposedSpendingLimitType
                         * @property {google.protobuf.IInt64Value|null} [approvedSpendingLimitMicros] AccountBudgetProposal approvedSpendingLimitMicros
                         * @property {google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType|null} [approvedSpendingLimitType] AccountBudgetProposal approvedSpendingLimitType
                         */

                        /**
                         * Constructs a new AccountBudgetProposal.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AccountBudgetProposal.
                         * @implements IAccountBudgetProposal
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAccountBudgetProposal=} [properties] Properties to set
                         */
                        function AccountBudgetProposal(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AccountBudgetProposal resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.resourceName = "";

                        /**
                         * AccountBudgetProposal id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.id = null;

                        /**
                         * AccountBudgetProposal billingSetup.
                         * @member {google.protobuf.IStringValue|null|undefined} billingSetup
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.billingSetup = null;

                        /**
                         * AccountBudgetProposal accountBudget.
                         * @member {google.protobuf.IStringValue|null|undefined} accountBudget
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.accountBudget = null;

                        /**
                         * AccountBudgetProposal proposalType.
                         * @member {google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum.AccountBudgetProposalType} proposalType
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.proposalType = 0;

                        /**
                         * AccountBudgetProposal status.
                         * @member {google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum.AccountBudgetProposalStatus} status
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.status = 0;

                        /**
                         * AccountBudgetProposal proposedName.
                         * @member {google.protobuf.IStringValue|null|undefined} proposedName
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.proposedName = null;

                        /**
                         * AccountBudgetProposal approvedStartDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} approvedStartDateTime
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.approvedStartDateTime = null;

                        /**
                         * AccountBudgetProposal proposedPurchaseOrderNumber.
                         * @member {google.protobuf.IStringValue|null|undefined} proposedPurchaseOrderNumber
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.proposedPurchaseOrderNumber = null;

                        /**
                         * AccountBudgetProposal proposedNotes.
                         * @member {google.protobuf.IStringValue|null|undefined} proposedNotes
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.proposedNotes = null;

                        /**
                         * AccountBudgetProposal creationDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} creationDateTime
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.creationDateTime = null;

                        /**
                         * AccountBudgetProposal approvalDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} approvalDateTime
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.approvalDateTime = null;

                        /**
                         * AccountBudgetProposal proposedStartDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} proposedStartDateTime
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.proposedStartDateTime = null;

                        /**
                         * AccountBudgetProposal proposedStartTimeType.
                         * @member {google.ads.googleads.v1.enums.TimeTypeEnum.TimeType} proposedStartTimeType
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.proposedStartTimeType = 0;

                        /**
                         * AccountBudgetProposal proposedEndDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} proposedEndDateTime
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.proposedEndDateTime = null;

                        /**
                         * AccountBudgetProposal proposedEndTimeType.
                         * @member {google.ads.googleads.v1.enums.TimeTypeEnum.TimeType} proposedEndTimeType
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.proposedEndTimeType = 0;

                        /**
                         * AccountBudgetProposal approvedEndDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} approvedEndDateTime
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.approvedEndDateTime = null;

                        /**
                         * AccountBudgetProposal approvedEndTimeType.
                         * @member {google.ads.googleads.v1.enums.TimeTypeEnum.TimeType} approvedEndTimeType
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.approvedEndTimeType = 0;

                        /**
                         * AccountBudgetProposal proposedSpendingLimitMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} proposedSpendingLimitMicros
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.proposedSpendingLimitMicros = null;

                        /**
                         * AccountBudgetProposal proposedSpendingLimitType.
                         * @member {google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType} proposedSpendingLimitType
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.proposedSpendingLimitType = 0;

                        /**
                         * AccountBudgetProposal approvedSpendingLimitMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} approvedSpendingLimitMicros
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.approvedSpendingLimitMicros = null;

                        /**
                         * AccountBudgetProposal approvedSpendingLimitType.
                         * @member {google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType} approvedSpendingLimitType
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        AccountBudgetProposal.prototype.approvedSpendingLimitType = 0;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AccountBudgetProposal proposedStartTime.
                         * @member {"proposedStartDateTime"|"proposedStartTimeType"|undefined} proposedStartTime
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        Object.defineProperty(AccountBudgetProposal.prototype, "proposedStartTime", {
                            get: $util.oneOfGetter($oneOfFields = ["proposedStartDateTime", "proposedStartTimeType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * AccountBudgetProposal proposedEndTime.
                         * @member {"proposedEndDateTime"|"proposedEndTimeType"|undefined} proposedEndTime
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        Object.defineProperty(AccountBudgetProposal.prototype, "proposedEndTime", {
                            get: $util.oneOfGetter($oneOfFields = ["proposedEndDateTime", "proposedEndTimeType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * AccountBudgetProposal approvedEndTime.
                         * @member {"approvedEndDateTime"|"approvedEndTimeType"|undefined} approvedEndTime
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        Object.defineProperty(AccountBudgetProposal.prototype, "approvedEndTime", {
                            get: $util.oneOfGetter($oneOfFields = ["approvedEndDateTime", "approvedEndTimeType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * AccountBudgetProposal proposedSpendingLimit.
                         * @member {"proposedSpendingLimitMicros"|"proposedSpendingLimitType"|undefined} proposedSpendingLimit
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        Object.defineProperty(AccountBudgetProposal.prototype, "proposedSpendingLimit", {
                            get: $util.oneOfGetter($oneOfFields = ["proposedSpendingLimitMicros", "proposedSpendingLimitType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * AccountBudgetProposal approvedSpendingLimit.
                         * @member {"approvedSpendingLimitMicros"|"approvedSpendingLimitType"|undefined} approvedSpendingLimit
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         */
                        Object.defineProperty(AccountBudgetProposal.prototype, "approvedSpendingLimit", {
                            get: $util.oneOfGetter($oneOfFields = ["approvedSpendingLimitMicros", "approvedSpendingLimitType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AccountBudgetProposal instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAccountBudgetProposal=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AccountBudgetProposal} AccountBudgetProposal instance
                         */
                        AccountBudgetProposal.create = function create(properties) {
                            return new AccountBudgetProposal(properties);
                        };

                        /**
                         * Encodes the specified AccountBudgetProposal message. Does not implicitly {@link google.ads.googleads.v1.resources.AccountBudgetProposal.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAccountBudgetProposal} message AccountBudgetProposal message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccountBudgetProposal.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.billingSetup != null && message.hasOwnProperty("billingSetup"))
                                $root.google.protobuf.StringValue.encode(message.billingSetup, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.accountBudget != null && message.hasOwnProperty("accountBudget"))
                                $root.google.protobuf.StringValue.encode(message.accountBudget, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.proposalType != null && message.hasOwnProperty("proposalType"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.proposalType);
                            if (message.proposedName != null && message.hasOwnProperty("proposedName"))
                                $root.google.protobuf.StringValue.encode(message.proposedName, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.proposedStartTimeType != null && message.hasOwnProperty("proposedStartTimeType"))
                                writer.uint32(/* id 7, wireType 0 =*/56).int32(message.proposedStartTimeType);
                            if (message.proposedEndTimeType != null && message.hasOwnProperty("proposedEndTimeType"))
                                writer.uint32(/* id 9, wireType 0 =*/72).int32(message.proposedEndTimeType);
                            if (message.proposedSpendingLimitMicros != null && message.hasOwnProperty("proposedSpendingLimitMicros"))
                                $root.google.protobuf.Int64Value.encode(message.proposedSpendingLimitMicros, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.proposedSpendingLimitType != null && message.hasOwnProperty("proposedSpendingLimitType"))
                                writer.uint32(/* id 11, wireType 0 =*/88).int32(message.proposedSpendingLimitType);
                            if (message.proposedPurchaseOrderNumber != null && message.hasOwnProperty("proposedPurchaseOrderNumber"))
                                $root.google.protobuf.StringValue.encode(message.proposedPurchaseOrderNumber, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.proposedNotes != null && message.hasOwnProperty("proposedNotes"))
                                $root.google.protobuf.StringValue.encode(message.proposedNotes, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 15, wireType 0 =*/120).int32(message.status);
                            if (message.creationDateTime != null && message.hasOwnProperty("creationDateTime"))
                                $root.google.protobuf.StringValue.encode(message.creationDateTime, writer.uint32(/* id 16, wireType 2 =*/130).fork()).ldelim();
                            if (message.approvalDateTime != null && message.hasOwnProperty("approvalDateTime"))
                                $root.google.protobuf.StringValue.encode(message.approvalDateTime, writer.uint32(/* id 17, wireType 2 =*/138).fork()).ldelim();
                            if (message.proposedStartDateTime != null && message.hasOwnProperty("proposedStartDateTime"))
                                $root.google.protobuf.StringValue.encode(message.proposedStartDateTime, writer.uint32(/* id 18, wireType 2 =*/146).fork()).ldelim();
                            if (message.proposedEndDateTime != null && message.hasOwnProperty("proposedEndDateTime"))
                                $root.google.protobuf.StringValue.encode(message.proposedEndDateTime, writer.uint32(/* id 19, wireType 2 =*/154).fork()).ldelim();
                            if (message.approvedStartDateTime != null && message.hasOwnProperty("approvedStartDateTime"))
                                $root.google.protobuf.StringValue.encode(message.approvedStartDateTime, writer.uint32(/* id 20, wireType 2 =*/162).fork()).ldelim();
                            if (message.approvedEndDateTime != null && message.hasOwnProperty("approvedEndDateTime"))
                                $root.google.protobuf.StringValue.encode(message.approvedEndDateTime, writer.uint32(/* id 21, wireType 2 =*/170).fork()).ldelim();
                            if (message.approvedEndTimeType != null && message.hasOwnProperty("approvedEndTimeType"))
                                writer.uint32(/* id 22, wireType 0 =*/176).int32(message.approvedEndTimeType);
                            if (message.approvedSpendingLimitMicros != null && message.hasOwnProperty("approvedSpendingLimitMicros"))
                                $root.google.protobuf.Int64Value.encode(message.approvedSpendingLimitMicros, writer.uint32(/* id 23, wireType 2 =*/186).fork()).ldelim();
                            if (message.approvedSpendingLimitType != null && message.hasOwnProperty("approvedSpendingLimitType"))
                                writer.uint32(/* id 24, wireType 0 =*/192).int32(message.approvedSpendingLimitType);
                            return writer;
                        };

                        /**
                         * Encodes the specified AccountBudgetProposal message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AccountBudgetProposal.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAccountBudgetProposal} message AccountBudgetProposal message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccountBudgetProposal.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AccountBudgetProposal message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AccountBudgetProposal} AccountBudgetProposal
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccountBudgetProposal.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AccountBudgetProposal();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 14:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.billingSetup = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.accountBudget = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.proposalType = reader.int32();
                                    break;
                                case 15:
                                    message.status = reader.int32();
                                    break;
                                case 5:
                                    message.proposedName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 20:
                                    message.approvedStartDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.proposedPurchaseOrderNumber = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 13:
                                    message.proposedNotes = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 16:
                                    message.creationDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 17:
                                    message.approvalDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 18:
                                    message.proposedStartDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.proposedStartTimeType = reader.int32();
                                    break;
                                case 19:
                                    message.proposedEndDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.proposedEndTimeType = reader.int32();
                                    break;
                                case 21:
                                    message.approvedEndDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 22:
                                    message.approvedEndTimeType = reader.int32();
                                    break;
                                case 10:
                                    message.proposedSpendingLimitMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.proposedSpendingLimitType = reader.int32();
                                    break;
                                case 23:
                                    message.approvedSpendingLimitMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 24:
                                    message.approvedSpendingLimitType = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AccountBudgetProposal message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AccountBudgetProposal} AccountBudgetProposal
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccountBudgetProposal.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AccountBudgetProposal message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccountBudgetProposal.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.billingSetup != null && message.hasOwnProperty("billingSetup")) {
                                var error = $root.google.protobuf.StringValue.verify(message.billingSetup);
                                if (error)
                                    return "billingSetup." + error;
                            }
                            if (message.accountBudget != null && message.hasOwnProperty("accountBudget")) {
                                var error = $root.google.protobuf.StringValue.verify(message.accountBudget);
                                if (error)
                                    return "accountBudget." + error;
                            }
                            if (message.proposalType != null && message.hasOwnProperty("proposalType"))
                                switch (message.proposalType) {
                                default:
                                    return "proposalType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            if (message.proposedName != null && message.hasOwnProperty("proposedName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.proposedName);
                                if (error)
                                    return "proposedName." + error;
                            }
                            if (message.approvedStartDateTime != null && message.hasOwnProperty("approvedStartDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.approvedStartDateTime);
                                if (error)
                                    return "approvedStartDateTime." + error;
                            }
                            if (message.proposedPurchaseOrderNumber != null && message.hasOwnProperty("proposedPurchaseOrderNumber")) {
                                var error = $root.google.protobuf.StringValue.verify(message.proposedPurchaseOrderNumber);
                                if (error)
                                    return "proposedPurchaseOrderNumber." + error;
                            }
                            if (message.proposedNotes != null && message.hasOwnProperty("proposedNotes")) {
                                var error = $root.google.protobuf.StringValue.verify(message.proposedNotes);
                                if (error)
                                    return "proposedNotes." + error;
                            }
                            if (message.creationDateTime != null && message.hasOwnProperty("creationDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.creationDateTime);
                                if (error)
                                    return "creationDateTime." + error;
                            }
                            if (message.approvalDateTime != null && message.hasOwnProperty("approvalDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.approvalDateTime);
                                if (error)
                                    return "approvalDateTime." + error;
                            }
                            if (message.proposedStartDateTime != null && message.hasOwnProperty("proposedStartDateTime")) {
                                properties.proposedStartTime = 1;
                                {
                                    var error = $root.google.protobuf.StringValue.verify(message.proposedStartDateTime);
                                    if (error)
                                        return "proposedStartDateTime." + error;
                                }
                            }
                            if (message.proposedStartTimeType != null && message.hasOwnProperty("proposedStartTimeType")) {
                                if (properties.proposedStartTime === 1)
                                    return "proposedStartTime: multiple values";
                                properties.proposedStartTime = 1;
                                switch (message.proposedStartTimeType) {
                                default:
                                    return "proposedStartTimeType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.proposedEndDateTime != null && message.hasOwnProperty("proposedEndDateTime")) {
                                properties.proposedEndTime = 1;
                                {
                                    var error = $root.google.protobuf.StringValue.verify(message.proposedEndDateTime);
                                    if (error)
                                        return "proposedEndDateTime." + error;
                                }
                            }
                            if (message.proposedEndTimeType != null && message.hasOwnProperty("proposedEndTimeType")) {
                                if (properties.proposedEndTime === 1)
                                    return "proposedEndTime: multiple values";
                                properties.proposedEndTime = 1;
                                switch (message.proposedEndTimeType) {
                                default:
                                    return "proposedEndTimeType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.approvedEndDateTime != null && message.hasOwnProperty("approvedEndDateTime")) {
                                properties.approvedEndTime = 1;
                                {
                                    var error = $root.google.protobuf.StringValue.verify(message.approvedEndDateTime);
                                    if (error)
                                        return "approvedEndDateTime." + error;
                                }
                            }
                            if (message.approvedEndTimeType != null && message.hasOwnProperty("approvedEndTimeType")) {
                                if (properties.approvedEndTime === 1)
                                    return "approvedEndTime: multiple values";
                                properties.approvedEndTime = 1;
                                switch (message.approvedEndTimeType) {
                                default:
                                    return "approvedEndTimeType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.proposedSpendingLimitMicros != null && message.hasOwnProperty("proposedSpendingLimitMicros")) {
                                properties.proposedSpendingLimit = 1;
                                {
                                    var error = $root.google.protobuf.Int64Value.verify(message.proposedSpendingLimitMicros);
                                    if (error)
                                        return "proposedSpendingLimitMicros." + error;
                                }
                            }
                            if (message.proposedSpendingLimitType != null && message.hasOwnProperty("proposedSpendingLimitType")) {
                                if (properties.proposedSpendingLimit === 1)
                                    return "proposedSpendingLimit: multiple values";
                                properties.proposedSpendingLimit = 1;
                                switch (message.proposedSpendingLimitType) {
                                default:
                                    return "proposedSpendingLimitType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            if (message.approvedSpendingLimitMicros != null && message.hasOwnProperty("approvedSpendingLimitMicros")) {
                                properties.approvedSpendingLimit = 1;
                                {
                                    var error = $root.google.protobuf.Int64Value.verify(message.approvedSpendingLimitMicros);
                                    if (error)
                                        return "approvedSpendingLimitMicros." + error;
                                }
                            }
                            if (message.approvedSpendingLimitType != null && message.hasOwnProperty("approvedSpendingLimitType")) {
                                if (properties.approvedSpendingLimit === 1)
                                    return "approvedSpendingLimit: multiple values";
                                properties.approvedSpendingLimit = 1;
                                switch (message.approvedSpendingLimitType) {
                                default:
                                    return "approvedSpendingLimitType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an AccountBudgetProposal message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AccountBudgetProposal} AccountBudgetProposal
                         */
                        AccountBudgetProposal.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AccountBudgetProposal)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AccountBudgetProposal();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudgetProposal.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.billingSetup != null) {
                                if (typeof object.billingSetup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudgetProposal.billingSetup: object expected");
                                message.billingSetup = $root.google.protobuf.StringValue.fromObject(object.billingSetup);
                            }
                            if (object.accountBudget != null) {
                                if (typeof object.accountBudget !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudgetProposal.accountBudget: object expected");
                                message.accountBudget = $root.google.protobuf.StringValue.fromObject(object.accountBudget);
                            }
                            switch (object.proposalType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.proposalType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.proposalType = 1;
                                break;
                            case "CREATE":
                            case 2:
                                message.proposalType = 2;
                                break;
                            case "UPDATE":
                            case 3:
                                message.proposalType = 3;
                                break;
                            case "END":
                            case 4:
                                message.proposalType = 4;
                                break;
                            case "REMOVE":
                            case 5:
                                message.proposalType = 5;
                                break;
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "PENDING":
                            case 2:
                                message.status = 2;
                                break;
                            case "APPROVED_HELD":
                            case 3:
                                message.status = 3;
                                break;
                            case "APPROVED":
                            case 4:
                                message.status = 4;
                                break;
                            case "CANCELLED":
                            case 5:
                                message.status = 5;
                                break;
                            case "REJECTED":
                            case 6:
                                message.status = 6;
                                break;
                            }
                            if (object.proposedName != null) {
                                if (typeof object.proposedName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudgetProposal.proposedName: object expected");
                                message.proposedName = $root.google.protobuf.StringValue.fromObject(object.proposedName);
                            }
                            if (object.approvedStartDateTime != null) {
                                if (typeof object.approvedStartDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudgetProposal.approvedStartDateTime: object expected");
                                message.approvedStartDateTime = $root.google.protobuf.StringValue.fromObject(object.approvedStartDateTime);
                            }
                            if (object.proposedPurchaseOrderNumber != null) {
                                if (typeof object.proposedPurchaseOrderNumber !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudgetProposal.proposedPurchaseOrderNumber: object expected");
                                message.proposedPurchaseOrderNumber = $root.google.protobuf.StringValue.fromObject(object.proposedPurchaseOrderNumber);
                            }
                            if (object.proposedNotes != null) {
                                if (typeof object.proposedNotes !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudgetProposal.proposedNotes: object expected");
                                message.proposedNotes = $root.google.protobuf.StringValue.fromObject(object.proposedNotes);
                            }
                            if (object.creationDateTime != null) {
                                if (typeof object.creationDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudgetProposal.creationDateTime: object expected");
                                message.creationDateTime = $root.google.protobuf.StringValue.fromObject(object.creationDateTime);
                            }
                            if (object.approvalDateTime != null) {
                                if (typeof object.approvalDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudgetProposal.approvalDateTime: object expected");
                                message.approvalDateTime = $root.google.protobuf.StringValue.fromObject(object.approvalDateTime);
                            }
                            if (object.proposedStartDateTime != null) {
                                if (typeof object.proposedStartDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudgetProposal.proposedStartDateTime: object expected");
                                message.proposedStartDateTime = $root.google.protobuf.StringValue.fromObject(object.proposedStartDateTime);
                            }
                            switch (object.proposedStartTimeType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.proposedStartTimeType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.proposedStartTimeType = 1;
                                break;
                            case "NOW":
                            case 2:
                                message.proposedStartTimeType = 2;
                                break;
                            case "FOREVER":
                            case 3:
                                message.proposedStartTimeType = 3;
                                break;
                            }
                            if (object.proposedEndDateTime != null) {
                                if (typeof object.proposedEndDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudgetProposal.proposedEndDateTime: object expected");
                                message.proposedEndDateTime = $root.google.protobuf.StringValue.fromObject(object.proposedEndDateTime);
                            }
                            switch (object.proposedEndTimeType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.proposedEndTimeType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.proposedEndTimeType = 1;
                                break;
                            case "NOW":
                            case 2:
                                message.proposedEndTimeType = 2;
                                break;
                            case "FOREVER":
                            case 3:
                                message.proposedEndTimeType = 3;
                                break;
                            }
                            if (object.approvedEndDateTime != null) {
                                if (typeof object.approvedEndDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudgetProposal.approvedEndDateTime: object expected");
                                message.approvedEndDateTime = $root.google.protobuf.StringValue.fromObject(object.approvedEndDateTime);
                            }
                            switch (object.approvedEndTimeType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.approvedEndTimeType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.approvedEndTimeType = 1;
                                break;
                            case "NOW":
                            case 2:
                                message.approvedEndTimeType = 2;
                                break;
                            case "FOREVER":
                            case 3:
                                message.approvedEndTimeType = 3;
                                break;
                            }
                            if (object.proposedSpendingLimitMicros != null) {
                                if (typeof object.proposedSpendingLimitMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudgetProposal.proposedSpendingLimitMicros: object expected");
                                message.proposedSpendingLimitMicros = $root.google.protobuf.Int64Value.fromObject(object.proposedSpendingLimitMicros);
                            }
                            switch (object.proposedSpendingLimitType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.proposedSpendingLimitType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.proposedSpendingLimitType = 1;
                                break;
                            case "INFINITE":
                            case 2:
                                message.proposedSpendingLimitType = 2;
                                break;
                            }
                            if (object.approvedSpendingLimitMicros != null) {
                                if (typeof object.approvedSpendingLimitMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AccountBudgetProposal.approvedSpendingLimitMicros: object expected");
                                message.approvedSpendingLimitMicros = $root.google.protobuf.Int64Value.fromObject(object.approvedSpendingLimitMicros);
                            }
                            switch (object.approvedSpendingLimitType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.approvedSpendingLimitType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.approvedSpendingLimitType = 1;
                                break;
                            case "INFINITE":
                            case 2:
                                message.approvedSpendingLimitType = 2;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AccountBudgetProposal message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @static
                         * @param {google.ads.googleads.v1.resources.AccountBudgetProposal} message AccountBudgetProposal
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccountBudgetProposal.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.billingSetup = null;
                                object.accountBudget = null;
                                object.proposalType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.proposedName = null;
                                object.proposedPurchaseOrderNumber = null;
                                object.proposedNotes = null;
                                object.id = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                                object.creationDateTime = null;
                                object.approvalDateTime = null;
                                object.approvedStartDateTime = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.billingSetup != null && message.hasOwnProperty("billingSetup"))
                                object.billingSetup = $root.google.protobuf.StringValue.toObject(message.billingSetup, options);
                            if (message.accountBudget != null && message.hasOwnProperty("accountBudget"))
                                object.accountBudget = $root.google.protobuf.StringValue.toObject(message.accountBudget, options);
                            if (message.proposalType != null && message.hasOwnProperty("proposalType"))
                                object.proposalType = options.enums === String ? $root.google.ads.googleads.v1.enums.AccountBudgetProposalTypeEnum.AccountBudgetProposalType[message.proposalType] : message.proposalType;
                            if (message.proposedName != null && message.hasOwnProperty("proposedName"))
                                object.proposedName = $root.google.protobuf.StringValue.toObject(message.proposedName, options);
                            if (message.proposedStartTimeType != null && message.hasOwnProperty("proposedStartTimeType")) {
                                object.proposedStartTimeType = options.enums === String ? $root.google.ads.googleads.v1.enums.TimeTypeEnum.TimeType[message.proposedStartTimeType] : message.proposedStartTimeType;
                                if (options.oneofs)
                                    object.proposedStartTime = "proposedStartTimeType";
                            }
                            if (message.proposedEndTimeType != null && message.hasOwnProperty("proposedEndTimeType")) {
                                object.proposedEndTimeType = options.enums === String ? $root.google.ads.googleads.v1.enums.TimeTypeEnum.TimeType[message.proposedEndTimeType] : message.proposedEndTimeType;
                                if (options.oneofs)
                                    object.proposedEndTime = "proposedEndTimeType";
                            }
                            if (message.proposedSpendingLimitMicros != null && message.hasOwnProperty("proposedSpendingLimitMicros")) {
                                object.proposedSpendingLimitMicros = $root.google.protobuf.Int64Value.toObject(message.proposedSpendingLimitMicros, options);
                                if (options.oneofs)
                                    object.proposedSpendingLimit = "proposedSpendingLimitMicros";
                            }
                            if (message.proposedSpendingLimitType != null && message.hasOwnProperty("proposedSpendingLimitType")) {
                                object.proposedSpendingLimitType = options.enums === String ? $root.google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType[message.proposedSpendingLimitType] : message.proposedSpendingLimitType;
                                if (options.oneofs)
                                    object.proposedSpendingLimit = "proposedSpendingLimitType";
                            }
                            if (message.proposedPurchaseOrderNumber != null && message.hasOwnProperty("proposedPurchaseOrderNumber"))
                                object.proposedPurchaseOrderNumber = $root.google.protobuf.StringValue.toObject(message.proposedPurchaseOrderNumber, options);
                            if (message.proposedNotes != null && message.hasOwnProperty("proposedNotes"))
                                object.proposedNotes = $root.google.protobuf.StringValue.toObject(message.proposedNotes, options);
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.AccountBudgetProposalStatusEnum.AccountBudgetProposalStatus[message.status] : message.status;
                            if (message.creationDateTime != null && message.hasOwnProperty("creationDateTime"))
                                object.creationDateTime = $root.google.protobuf.StringValue.toObject(message.creationDateTime, options);
                            if (message.approvalDateTime != null && message.hasOwnProperty("approvalDateTime"))
                                object.approvalDateTime = $root.google.protobuf.StringValue.toObject(message.approvalDateTime, options);
                            if (message.proposedStartDateTime != null && message.hasOwnProperty("proposedStartDateTime")) {
                                object.proposedStartDateTime = $root.google.protobuf.StringValue.toObject(message.proposedStartDateTime, options);
                                if (options.oneofs)
                                    object.proposedStartTime = "proposedStartDateTime";
                            }
                            if (message.proposedEndDateTime != null && message.hasOwnProperty("proposedEndDateTime")) {
                                object.proposedEndDateTime = $root.google.protobuf.StringValue.toObject(message.proposedEndDateTime, options);
                                if (options.oneofs)
                                    object.proposedEndTime = "proposedEndDateTime";
                            }
                            if (message.approvedStartDateTime != null && message.hasOwnProperty("approvedStartDateTime"))
                                object.approvedStartDateTime = $root.google.protobuf.StringValue.toObject(message.approvedStartDateTime, options);
                            if (message.approvedEndDateTime != null && message.hasOwnProperty("approvedEndDateTime")) {
                                object.approvedEndDateTime = $root.google.protobuf.StringValue.toObject(message.approvedEndDateTime, options);
                                if (options.oneofs)
                                    object.approvedEndTime = "approvedEndDateTime";
                            }
                            if (message.approvedEndTimeType != null && message.hasOwnProperty("approvedEndTimeType")) {
                                object.approvedEndTimeType = options.enums === String ? $root.google.ads.googleads.v1.enums.TimeTypeEnum.TimeType[message.approvedEndTimeType] : message.approvedEndTimeType;
                                if (options.oneofs)
                                    object.approvedEndTime = "approvedEndTimeType";
                            }
                            if (message.approvedSpendingLimitMicros != null && message.hasOwnProperty("approvedSpendingLimitMicros")) {
                                object.approvedSpendingLimitMicros = $root.google.protobuf.Int64Value.toObject(message.approvedSpendingLimitMicros, options);
                                if (options.oneofs)
                                    object.approvedSpendingLimit = "approvedSpendingLimitMicros";
                            }
                            if (message.approvedSpendingLimitType != null && message.hasOwnProperty("approvedSpendingLimitType")) {
                                object.approvedSpendingLimitType = options.enums === String ? $root.google.ads.googleads.v1.enums.SpendingLimitTypeEnum.SpendingLimitType[message.approvedSpendingLimitType] : message.approvedSpendingLimitType;
                                if (options.oneofs)
                                    object.approvedSpendingLimit = "approvedSpendingLimitType";
                            }
                            return object;
                        };

                        /**
                         * Converts this AccountBudgetProposal to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AccountBudgetProposal
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccountBudgetProposal.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AccountBudgetProposal;
                    })();

                    resources.Ad = (function() {

                        /**
                         * Properties of an Ad.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAd
                         * @property {google.protobuf.IInt64Value|null} [id] Ad id
                         * @property {Array.<google.protobuf.IStringValue>|null} [finalUrls] Ad finalUrls
                         * @property {Array.<google.ads.googleads.v1.common.IFinalAppUrl>|null} [finalAppUrls] Ad finalAppUrls
                         * @property {Array.<google.protobuf.IStringValue>|null} [finalMobileUrls] Ad finalMobileUrls
                         * @property {google.protobuf.IStringValue|null} [trackingUrlTemplate] Ad trackingUrlTemplate
                         * @property {Array.<google.ads.googleads.v1.common.ICustomParameter>|null} [urlCustomParameters] Ad urlCustomParameters
                         * @property {google.protobuf.IStringValue|null} [displayUrl] Ad displayUrl
                         * @property {google.ads.googleads.v1.enums.AdTypeEnum.AdType|null} [type] Ad type
                         * @property {google.protobuf.IBoolValue|null} [addedByGoogleAds] Ad addedByGoogleAds
                         * @property {google.ads.googleads.v1.enums.DeviceEnum.Device|null} [devicePreference] Ad devicePreference
                         * @property {Array.<google.ads.googleads.v1.common.IUrlCollection>|null} [urlCollections] Ad urlCollections
                         * @property {google.protobuf.IStringValue|null} [name] Ad name
                         * @property {google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum.SystemManagedResourceSource|null} [systemManagedResourceSource] Ad systemManagedResourceSource
                         * @property {google.ads.googleads.v1.common.ITextAdInfo|null} [textAd] Ad textAd
                         * @property {google.ads.googleads.v1.common.IExpandedTextAdInfo|null} [expandedTextAd] Ad expandedTextAd
                         * @property {google.ads.googleads.v1.common.ICallOnlyAdInfo|null} [callOnlyAd] Ad callOnlyAd
                         * @property {google.ads.googleads.v1.common.IExpandedDynamicSearchAdInfo|null} [expandedDynamicSearchAd] Ad expandedDynamicSearchAd
                         * @property {google.ads.googleads.v1.common.IHotelAdInfo|null} [hotelAd] Ad hotelAd
                         * @property {google.ads.googleads.v1.common.IShoppingSmartAdInfo|null} [shoppingSmartAd] Ad shoppingSmartAd
                         * @property {google.ads.googleads.v1.common.IShoppingProductAdInfo|null} [shoppingProductAd] Ad shoppingProductAd
                         * @property {google.ads.googleads.v1.common.IGmailAdInfo|null} [gmailAd] Ad gmailAd
                         * @property {google.ads.googleads.v1.common.IImageAdInfo|null} [imageAd] Ad imageAd
                         * @property {google.ads.googleads.v1.common.IVideoAdInfo|null} [videoAd] Ad videoAd
                         * @property {google.ads.googleads.v1.common.IResponsiveSearchAdInfo|null} [responsiveSearchAd] Ad responsiveSearchAd
                         * @property {google.ads.googleads.v1.common.ILegacyResponsiveDisplayAdInfo|null} [legacyResponsiveDisplayAd] Ad legacyResponsiveDisplayAd
                         * @property {google.ads.googleads.v1.common.IAppAdInfo|null} [appAd] Ad appAd
                         * @property {google.ads.googleads.v1.common.ILegacyAppInstallAdInfo|null} [legacyAppInstallAd] Ad legacyAppInstallAd
                         * @property {google.ads.googleads.v1.common.IResponsiveDisplayAdInfo|null} [responsiveDisplayAd] Ad responsiveDisplayAd
                         * @property {google.ads.googleads.v1.common.IDisplayUploadAdInfo|null} [displayUploadAd] Ad displayUploadAd
                         * @property {google.ads.googleads.v1.common.IAppEngagementAdInfo|null} [appEngagementAd] Ad appEngagementAd
                         */

                        /**
                         * Constructs a new Ad.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an Ad.
                         * @implements IAd
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAd=} [properties] Properties to set
                         */
                        function Ad(properties) {
                            this.finalUrls = [];
                            this.finalAppUrls = [];
                            this.finalMobileUrls = [];
                            this.urlCustomParameters = [];
                            this.urlCollections = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Ad id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.id = null;

                        /**
                         * Ad finalUrls.
                         * @member {Array.<google.protobuf.IStringValue>} finalUrls
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.finalUrls = $util.emptyArray;

                        /**
                         * Ad finalAppUrls.
                         * @member {Array.<google.ads.googleads.v1.common.IFinalAppUrl>} finalAppUrls
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.finalAppUrls = $util.emptyArray;

                        /**
                         * Ad finalMobileUrls.
                         * @member {Array.<google.protobuf.IStringValue>} finalMobileUrls
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.finalMobileUrls = $util.emptyArray;

                        /**
                         * Ad trackingUrlTemplate.
                         * @member {google.protobuf.IStringValue|null|undefined} trackingUrlTemplate
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.trackingUrlTemplate = null;

                        /**
                         * Ad urlCustomParameters.
                         * @member {Array.<google.ads.googleads.v1.common.ICustomParameter>} urlCustomParameters
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.urlCustomParameters = $util.emptyArray;

                        /**
                         * Ad displayUrl.
                         * @member {google.protobuf.IStringValue|null|undefined} displayUrl
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.displayUrl = null;

                        /**
                         * Ad type.
                         * @member {google.ads.googleads.v1.enums.AdTypeEnum.AdType} type
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.type = 0;

                        /**
                         * Ad addedByGoogleAds.
                         * @member {google.protobuf.IBoolValue|null|undefined} addedByGoogleAds
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.addedByGoogleAds = null;

                        /**
                         * Ad devicePreference.
                         * @member {google.ads.googleads.v1.enums.DeviceEnum.Device} devicePreference
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.devicePreference = 0;

                        /**
                         * Ad urlCollections.
                         * @member {Array.<google.ads.googleads.v1.common.IUrlCollection>} urlCollections
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.urlCollections = $util.emptyArray;

                        /**
                         * Ad name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.name = null;

                        /**
                         * Ad systemManagedResourceSource.
                         * @member {google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum.SystemManagedResourceSource} systemManagedResourceSource
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.systemManagedResourceSource = 0;

                        /**
                         * Ad textAd.
                         * @member {google.ads.googleads.v1.common.ITextAdInfo|null|undefined} textAd
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.textAd = null;

                        /**
                         * Ad expandedTextAd.
                         * @member {google.ads.googleads.v1.common.IExpandedTextAdInfo|null|undefined} expandedTextAd
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.expandedTextAd = null;

                        /**
                         * Ad callOnlyAd.
                         * @member {google.ads.googleads.v1.common.ICallOnlyAdInfo|null|undefined} callOnlyAd
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.callOnlyAd = null;

                        /**
                         * Ad expandedDynamicSearchAd.
                         * @member {google.ads.googleads.v1.common.IExpandedDynamicSearchAdInfo|null|undefined} expandedDynamicSearchAd
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.expandedDynamicSearchAd = null;

                        /**
                         * Ad hotelAd.
                         * @member {google.ads.googleads.v1.common.IHotelAdInfo|null|undefined} hotelAd
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.hotelAd = null;

                        /**
                         * Ad shoppingSmartAd.
                         * @member {google.ads.googleads.v1.common.IShoppingSmartAdInfo|null|undefined} shoppingSmartAd
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.shoppingSmartAd = null;

                        /**
                         * Ad shoppingProductAd.
                         * @member {google.ads.googleads.v1.common.IShoppingProductAdInfo|null|undefined} shoppingProductAd
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.shoppingProductAd = null;

                        /**
                         * Ad gmailAd.
                         * @member {google.ads.googleads.v1.common.IGmailAdInfo|null|undefined} gmailAd
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.gmailAd = null;

                        /**
                         * Ad imageAd.
                         * @member {google.ads.googleads.v1.common.IImageAdInfo|null|undefined} imageAd
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.imageAd = null;

                        /**
                         * Ad videoAd.
                         * @member {google.ads.googleads.v1.common.IVideoAdInfo|null|undefined} videoAd
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.videoAd = null;

                        /**
                         * Ad responsiveSearchAd.
                         * @member {google.ads.googleads.v1.common.IResponsiveSearchAdInfo|null|undefined} responsiveSearchAd
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.responsiveSearchAd = null;

                        /**
                         * Ad legacyResponsiveDisplayAd.
                         * @member {google.ads.googleads.v1.common.ILegacyResponsiveDisplayAdInfo|null|undefined} legacyResponsiveDisplayAd
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.legacyResponsiveDisplayAd = null;

                        /**
                         * Ad appAd.
                         * @member {google.ads.googleads.v1.common.IAppAdInfo|null|undefined} appAd
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.appAd = null;

                        /**
                         * Ad legacyAppInstallAd.
                         * @member {google.ads.googleads.v1.common.ILegacyAppInstallAdInfo|null|undefined} legacyAppInstallAd
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.legacyAppInstallAd = null;

                        /**
                         * Ad responsiveDisplayAd.
                         * @member {google.ads.googleads.v1.common.IResponsiveDisplayAdInfo|null|undefined} responsiveDisplayAd
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.responsiveDisplayAd = null;

                        /**
                         * Ad displayUploadAd.
                         * @member {google.ads.googleads.v1.common.IDisplayUploadAdInfo|null|undefined} displayUploadAd
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.displayUploadAd = null;

                        /**
                         * Ad appEngagementAd.
                         * @member {google.ads.googleads.v1.common.IAppEngagementAdInfo|null|undefined} appEngagementAd
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Ad.prototype.appEngagementAd = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * Ad adData.
                         * @member {"textAd"|"expandedTextAd"|"callOnlyAd"|"expandedDynamicSearchAd"|"hotelAd"|"shoppingSmartAd"|"shoppingProductAd"|"gmailAd"|"imageAd"|"videoAd"|"responsiveSearchAd"|"legacyResponsiveDisplayAd"|"appAd"|"legacyAppInstallAd"|"responsiveDisplayAd"|"displayUploadAd"|"appEngagementAd"|undefined} adData
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         */
                        Object.defineProperty(Ad.prototype, "adData", {
                            get: $util.oneOfGetter($oneOfFields = ["textAd", "expandedTextAd", "callOnlyAd", "expandedDynamicSearchAd", "hotelAd", "shoppingSmartAd", "shoppingProductAd", "gmailAd", "imageAd", "videoAd", "responsiveSearchAd", "legacyResponsiveDisplayAd", "appAd", "legacyAppInstallAd", "responsiveDisplayAd", "displayUploadAd", "appEngagementAd"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new Ad instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAd=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.Ad} Ad instance
                         */
                        Ad.create = function create(properties) {
                            return new Ad(properties);
                        };

                        /**
                         * Encodes the specified Ad message. Does not implicitly {@link google.ads.googleads.v1.resources.Ad.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAd} message Ad message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Ad.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.finalUrls != null && message.finalUrls.length)
                                for (var i = 0; i < message.finalUrls.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.finalUrls[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.displayUrl != null && message.hasOwnProperty("displayUrl"))
                                $root.google.protobuf.StringValue.encode(message.displayUrl, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.type);
                            if (message.textAd != null && message.hasOwnProperty("textAd"))
                                $root.google.ads.googleads.v1.common.TextAdInfo.encode(message.textAd, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.expandedTextAd != null && message.hasOwnProperty("expandedTextAd"))
                                $root.google.ads.googleads.v1.common.ExpandedTextAdInfo.encode(message.expandedTextAd, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.urlCustomParameters != null && message.urlCustomParameters.length)
                                for (var i = 0; i < message.urlCustomParameters.length; ++i)
                                    $root.google.ads.googleads.v1.common.CustomParameter.encode(message.urlCustomParameters[i], writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                $root.google.protobuf.StringValue.encode(message.trackingUrlTemplate, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.callOnlyAd != null && message.hasOwnProperty("callOnlyAd"))
                                $root.google.ads.googleads.v1.common.CallOnlyAdInfo.encode(message.callOnlyAd, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                            if (message.expandedDynamicSearchAd != null && message.hasOwnProperty("expandedDynamicSearchAd"))
                                $root.google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo.encode(message.expandedDynamicSearchAd, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.hotelAd != null && message.hasOwnProperty("hotelAd"))
                                $root.google.ads.googleads.v1.common.HotelAdInfo.encode(message.hotelAd, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
                            if (message.finalMobileUrls != null && message.finalMobileUrls.length)
                                for (var i = 0; i < message.finalMobileUrls.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.finalMobileUrls[i], writer.uint32(/* id 16, wireType 2 =*/130).fork()).ldelim();
                            if (message.shoppingSmartAd != null && message.hasOwnProperty("shoppingSmartAd"))
                                $root.google.ads.googleads.v1.common.ShoppingSmartAdInfo.encode(message.shoppingSmartAd, writer.uint32(/* id 17, wireType 2 =*/138).fork()).ldelim();
                            if (message.shoppingProductAd != null && message.hasOwnProperty("shoppingProductAd"))
                                $root.google.ads.googleads.v1.common.ShoppingProductAdInfo.encode(message.shoppingProductAd, writer.uint32(/* id 18, wireType 2 =*/146).fork()).ldelim();
                            if (message.addedByGoogleAds != null && message.hasOwnProperty("addedByGoogleAds"))
                                $root.google.protobuf.BoolValue.encode(message.addedByGoogleAds, writer.uint32(/* id 19, wireType 2 =*/154).fork()).ldelim();
                            if (message.devicePreference != null && message.hasOwnProperty("devicePreference"))
                                writer.uint32(/* id 20, wireType 0 =*/160).int32(message.devicePreference);
                            if (message.gmailAd != null && message.hasOwnProperty("gmailAd"))
                                $root.google.ads.googleads.v1.common.GmailAdInfo.encode(message.gmailAd, writer.uint32(/* id 21, wireType 2 =*/170).fork()).ldelim();
                            if (message.imageAd != null && message.hasOwnProperty("imageAd"))
                                $root.google.ads.googleads.v1.common.ImageAdInfo.encode(message.imageAd, writer.uint32(/* id 22, wireType 2 =*/178).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 23, wireType 2 =*/186).fork()).ldelim();
                            if (message.videoAd != null && message.hasOwnProperty("videoAd"))
                                $root.google.ads.googleads.v1.common.VideoAdInfo.encode(message.videoAd, writer.uint32(/* id 24, wireType 2 =*/194).fork()).ldelim();
                            if (message.responsiveSearchAd != null && message.hasOwnProperty("responsiveSearchAd"))
                                $root.google.ads.googleads.v1.common.ResponsiveSearchAdInfo.encode(message.responsiveSearchAd, writer.uint32(/* id 25, wireType 2 =*/202).fork()).ldelim();
                            if (message.urlCollections != null && message.urlCollections.length)
                                for (var i = 0; i < message.urlCollections.length; ++i)
                                    $root.google.ads.googleads.v1.common.UrlCollection.encode(message.urlCollections[i], writer.uint32(/* id 26, wireType 2 =*/210).fork()).ldelim();
                            if (message.systemManagedResourceSource != null && message.hasOwnProperty("systemManagedResourceSource"))
                                writer.uint32(/* id 27, wireType 0 =*/216).int32(message.systemManagedResourceSource);
                            if (message.legacyResponsiveDisplayAd != null && message.hasOwnProperty("legacyResponsiveDisplayAd"))
                                $root.google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.encode(message.legacyResponsiveDisplayAd, writer.uint32(/* id 28, wireType 2 =*/226).fork()).ldelim();
                            if (message.appAd != null && message.hasOwnProperty("appAd"))
                                $root.google.ads.googleads.v1.common.AppAdInfo.encode(message.appAd, writer.uint32(/* id 29, wireType 2 =*/234).fork()).ldelim();
                            if (message.legacyAppInstallAd != null && message.hasOwnProperty("legacyAppInstallAd"))
                                $root.google.ads.googleads.v1.common.LegacyAppInstallAdInfo.encode(message.legacyAppInstallAd, writer.uint32(/* id 30, wireType 2 =*/242).fork()).ldelim();
                            if (message.responsiveDisplayAd != null && message.hasOwnProperty("responsiveDisplayAd"))
                                $root.google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.encode(message.responsiveDisplayAd, writer.uint32(/* id 31, wireType 2 =*/250).fork()).ldelim();
                            if (message.displayUploadAd != null && message.hasOwnProperty("displayUploadAd"))
                                $root.google.ads.googleads.v1.common.DisplayUploadAdInfo.encode(message.displayUploadAd, writer.uint32(/* id 33, wireType 2 =*/266).fork()).ldelim();
                            if (message.appEngagementAd != null && message.hasOwnProperty("appEngagementAd"))
                                $root.google.ads.googleads.v1.common.AppEngagementAdInfo.encode(message.appEngagementAd, writer.uint32(/* id 34, wireType 2 =*/274).fork()).ldelim();
                            if (message.finalAppUrls != null && message.finalAppUrls.length)
                                for (var i = 0; i < message.finalAppUrls.length; ++i)
                                    $root.google.ads.googleads.v1.common.FinalAppUrl.encode(message.finalAppUrls[i], writer.uint32(/* id 35, wireType 2 =*/282).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified Ad message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Ad.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAd} message Ad message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Ad.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an Ad message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.Ad} Ad
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Ad.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Ad();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.finalUrls && message.finalUrls.length))
                                        message.finalUrls = [];
                                    message.finalUrls.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 35:
                                    if (!(message.finalAppUrls && message.finalAppUrls.length))
                                        message.finalAppUrls = [];
                                    message.finalAppUrls.push($root.google.ads.googleads.v1.common.FinalAppUrl.decode(reader, reader.uint32()));
                                    break;
                                case 16:
                                    if (!(message.finalMobileUrls && message.finalMobileUrls.length))
                                        message.finalMobileUrls = [];
                                    message.finalMobileUrls.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 12:
                                    message.trackingUrlTemplate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    if (!(message.urlCustomParameters && message.urlCustomParameters.length))
                                        message.urlCustomParameters = [];
                                    message.urlCustomParameters.push($root.google.ads.googleads.v1.common.CustomParameter.decode(reader, reader.uint32()));
                                    break;
                                case 4:
                                    message.displayUrl = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.type = reader.int32();
                                    break;
                                case 19:
                                    message.addedByGoogleAds = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 20:
                                    message.devicePreference = reader.int32();
                                    break;
                                case 26:
                                    if (!(message.urlCollections && message.urlCollections.length))
                                        message.urlCollections = [];
                                    message.urlCollections.push($root.google.ads.googleads.v1.common.UrlCollection.decode(reader, reader.uint32()));
                                    break;
                                case 23:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 27:
                                    message.systemManagedResourceSource = reader.int32();
                                    break;
                                case 6:
                                    message.textAd = $root.google.ads.googleads.v1.common.TextAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.expandedTextAd = $root.google.ads.googleads.v1.common.ExpandedTextAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 13:
                                    message.callOnlyAd = $root.google.ads.googleads.v1.common.CallOnlyAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 14:
                                    message.expandedDynamicSearchAd = $root.google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 15:
                                    message.hotelAd = $root.google.ads.googleads.v1.common.HotelAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 17:
                                    message.shoppingSmartAd = $root.google.ads.googleads.v1.common.ShoppingSmartAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 18:
                                    message.shoppingProductAd = $root.google.ads.googleads.v1.common.ShoppingProductAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 21:
                                    message.gmailAd = $root.google.ads.googleads.v1.common.GmailAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 22:
                                    message.imageAd = $root.google.ads.googleads.v1.common.ImageAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 24:
                                    message.videoAd = $root.google.ads.googleads.v1.common.VideoAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 25:
                                    message.responsiveSearchAd = $root.google.ads.googleads.v1.common.ResponsiveSearchAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 28:
                                    message.legacyResponsiveDisplayAd = $root.google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 29:
                                    message.appAd = $root.google.ads.googleads.v1.common.AppAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 30:
                                    message.legacyAppInstallAd = $root.google.ads.googleads.v1.common.LegacyAppInstallAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 31:
                                    message.responsiveDisplayAd = $root.google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 33:
                                    message.displayUploadAd = $root.google.ads.googleads.v1.common.DisplayUploadAdInfo.decode(reader, reader.uint32());
                                    break;
                                case 34:
                                    message.appEngagementAd = $root.google.ads.googleads.v1.common.AppEngagementAdInfo.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an Ad message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.Ad} Ad
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Ad.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an Ad message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Ad.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.finalUrls != null && message.hasOwnProperty("finalUrls")) {
                                if (!Array.isArray(message.finalUrls))
                                    return "finalUrls: array expected";
                                for (var i = 0; i < message.finalUrls.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.finalUrls[i]);
                                    if (error)
                                        return "finalUrls." + error;
                                }
                            }
                            if (message.finalAppUrls != null && message.hasOwnProperty("finalAppUrls")) {
                                if (!Array.isArray(message.finalAppUrls))
                                    return "finalAppUrls: array expected";
                                for (var i = 0; i < message.finalAppUrls.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.FinalAppUrl.verify(message.finalAppUrls[i]);
                                    if (error)
                                        return "finalAppUrls." + error;
                                }
                            }
                            if (message.finalMobileUrls != null && message.hasOwnProperty("finalMobileUrls")) {
                                if (!Array.isArray(message.finalMobileUrls))
                                    return "finalMobileUrls: array expected";
                                for (var i = 0; i < message.finalMobileUrls.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.finalMobileUrls[i]);
                                    if (error)
                                        return "finalMobileUrls." + error;
                                }
                            }
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.trackingUrlTemplate);
                                if (error)
                                    return "trackingUrlTemplate." + error;
                            }
                            if (message.urlCustomParameters != null && message.hasOwnProperty("urlCustomParameters")) {
                                if (!Array.isArray(message.urlCustomParameters))
                                    return "urlCustomParameters: array expected";
                                for (var i = 0; i < message.urlCustomParameters.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.CustomParameter.verify(message.urlCustomParameters[i]);
                                    if (error)
                                        return "urlCustomParameters." + error;
                                }
                            }
                            if (message.displayUrl != null && message.hasOwnProperty("displayUrl")) {
                                var error = $root.google.protobuf.StringValue.verify(message.displayUrl);
                                if (error)
                                    return "displayUrl." + error;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 21:
                                case 22:
                                case 23:
                                    break;
                                }
                            if (message.addedByGoogleAds != null && message.hasOwnProperty("addedByGoogleAds")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.addedByGoogleAds);
                                if (error)
                                    return "addedByGoogleAds." + error;
                            }
                            if (message.devicePreference != null && message.hasOwnProperty("devicePreference"))
                                switch (message.devicePreference) {
                                default:
                                    return "devicePreference: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            if (message.urlCollections != null && message.hasOwnProperty("urlCollections")) {
                                if (!Array.isArray(message.urlCollections))
                                    return "urlCollections: array expected";
                                for (var i = 0; i < message.urlCollections.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.UrlCollection.verify(message.urlCollections[i]);
                                    if (error)
                                        return "urlCollections." + error;
                                }
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.systemManagedResourceSource != null && message.hasOwnProperty("systemManagedResourceSource"))
                                switch (message.systemManagedResourceSource) {
                                default:
                                    return "systemManagedResourceSource: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            if (message.textAd != null && message.hasOwnProperty("textAd")) {
                                properties.adData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.TextAdInfo.verify(message.textAd);
                                    if (error)
                                        return "textAd." + error;
                                }
                            }
                            if (message.expandedTextAd != null && message.hasOwnProperty("expandedTextAd")) {
                                if (properties.adData === 1)
                                    return "adData: multiple values";
                                properties.adData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ExpandedTextAdInfo.verify(message.expandedTextAd);
                                    if (error)
                                        return "expandedTextAd." + error;
                                }
                            }
                            if (message.callOnlyAd != null && message.hasOwnProperty("callOnlyAd")) {
                                if (properties.adData === 1)
                                    return "adData: multiple values";
                                properties.adData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.CallOnlyAdInfo.verify(message.callOnlyAd);
                                    if (error)
                                        return "callOnlyAd." + error;
                                }
                            }
                            if (message.expandedDynamicSearchAd != null && message.hasOwnProperty("expandedDynamicSearchAd")) {
                                if (properties.adData === 1)
                                    return "adData: multiple values";
                                properties.adData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo.verify(message.expandedDynamicSearchAd);
                                    if (error)
                                        return "expandedDynamicSearchAd." + error;
                                }
                            }
                            if (message.hotelAd != null && message.hasOwnProperty("hotelAd")) {
                                if (properties.adData === 1)
                                    return "adData: multiple values";
                                properties.adData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.HotelAdInfo.verify(message.hotelAd);
                                    if (error)
                                        return "hotelAd." + error;
                                }
                            }
                            if (message.shoppingSmartAd != null && message.hasOwnProperty("shoppingSmartAd")) {
                                if (properties.adData === 1)
                                    return "adData: multiple values";
                                properties.adData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ShoppingSmartAdInfo.verify(message.shoppingSmartAd);
                                    if (error)
                                        return "shoppingSmartAd." + error;
                                }
                            }
                            if (message.shoppingProductAd != null && message.hasOwnProperty("shoppingProductAd")) {
                                if (properties.adData === 1)
                                    return "adData: multiple values";
                                properties.adData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ShoppingProductAdInfo.verify(message.shoppingProductAd);
                                    if (error)
                                        return "shoppingProductAd." + error;
                                }
                            }
                            if (message.gmailAd != null && message.hasOwnProperty("gmailAd")) {
                                if (properties.adData === 1)
                                    return "adData: multiple values";
                                properties.adData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.GmailAdInfo.verify(message.gmailAd);
                                    if (error)
                                        return "gmailAd." + error;
                                }
                            }
                            if (message.imageAd != null && message.hasOwnProperty("imageAd")) {
                                if (properties.adData === 1)
                                    return "adData: multiple values";
                                properties.adData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ImageAdInfo.verify(message.imageAd);
                                    if (error)
                                        return "imageAd." + error;
                                }
                            }
                            if (message.videoAd != null && message.hasOwnProperty("videoAd")) {
                                if (properties.adData === 1)
                                    return "adData: multiple values";
                                properties.adData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.VideoAdInfo.verify(message.videoAd);
                                    if (error)
                                        return "videoAd." + error;
                                }
                            }
                            if (message.responsiveSearchAd != null && message.hasOwnProperty("responsiveSearchAd")) {
                                if (properties.adData === 1)
                                    return "adData: multiple values";
                                properties.adData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ResponsiveSearchAdInfo.verify(message.responsiveSearchAd);
                                    if (error)
                                        return "responsiveSearchAd." + error;
                                }
                            }
                            if (message.legacyResponsiveDisplayAd != null && message.hasOwnProperty("legacyResponsiveDisplayAd")) {
                                if (properties.adData === 1)
                                    return "adData: multiple values";
                                properties.adData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.verify(message.legacyResponsiveDisplayAd);
                                    if (error)
                                        return "legacyResponsiveDisplayAd." + error;
                                }
                            }
                            if (message.appAd != null && message.hasOwnProperty("appAd")) {
                                if (properties.adData === 1)
                                    return "adData: multiple values";
                                properties.adData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.AppAdInfo.verify(message.appAd);
                                    if (error)
                                        return "appAd." + error;
                                }
                            }
                            if (message.legacyAppInstallAd != null && message.hasOwnProperty("legacyAppInstallAd")) {
                                if (properties.adData === 1)
                                    return "adData: multiple values";
                                properties.adData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.LegacyAppInstallAdInfo.verify(message.legacyAppInstallAd);
                                    if (error)
                                        return "legacyAppInstallAd." + error;
                                }
                            }
                            if (message.responsiveDisplayAd != null && message.hasOwnProperty("responsiveDisplayAd")) {
                                if (properties.adData === 1)
                                    return "adData: multiple values";
                                properties.adData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.verify(message.responsiveDisplayAd);
                                    if (error)
                                        return "responsiveDisplayAd." + error;
                                }
                            }
                            if (message.displayUploadAd != null && message.hasOwnProperty("displayUploadAd")) {
                                if (properties.adData === 1)
                                    return "adData: multiple values";
                                properties.adData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.DisplayUploadAdInfo.verify(message.displayUploadAd);
                                    if (error)
                                        return "displayUploadAd." + error;
                                }
                            }
                            if (message.appEngagementAd != null && message.hasOwnProperty("appEngagementAd")) {
                                if (properties.adData === 1)
                                    return "adData: multiple values";
                                properties.adData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.AppEngagementAdInfo.verify(message.appEngagementAd);
                                    if (error)
                                        return "appEngagementAd." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an Ad message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.Ad} Ad
                         */
                        Ad.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.Ad)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.Ad();
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.finalUrls) {
                                if (!Array.isArray(object.finalUrls))
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.finalUrls: array expected");
                                message.finalUrls = [];
                                for (var i = 0; i < object.finalUrls.length; ++i) {
                                    if (typeof object.finalUrls[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Ad.finalUrls: object expected");
                                    message.finalUrls[i] = $root.google.protobuf.StringValue.fromObject(object.finalUrls[i]);
                                }
                            }
                            if (object.finalAppUrls) {
                                if (!Array.isArray(object.finalAppUrls))
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.finalAppUrls: array expected");
                                message.finalAppUrls = [];
                                for (var i = 0; i < object.finalAppUrls.length; ++i) {
                                    if (typeof object.finalAppUrls[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Ad.finalAppUrls: object expected");
                                    message.finalAppUrls[i] = $root.google.ads.googleads.v1.common.FinalAppUrl.fromObject(object.finalAppUrls[i]);
                                }
                            }
                            if (object.finalMobileUrls) {
                                if (!Array.isArray(object.finalMobileUrls))
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.finalMobileUrls: array expected");
                                message.finalMobileUrls = [];
                                for (var i = 0; i < object.finalMobileUrls.length; ++i) {
                                    if (typeof object.finalMobileUrls[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Ad.finalMobileUrls: object expected");
                                    message.finalMobileUrls[i] = $root.google.protobuf.StringValue.fromObject(object.finalMobileUrls[i]);
                                }
                            }
                            if (object.trackingUrlTemplate != null) {
                                if (typeof object.trackingUrlTemplate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.trackingUrlTemplate: object expected");
                                message.trackingUrlTemplate = $root.google.protobuf.StringValue.fromObject(object.trackingUrlTemplate);
                            }
                            if (object.urlCustomParameters) {
                                if (!Array.isArray(object.urlCustomParameters))
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.urlCustomParameters: array expected");
                                message.urlCustomParameters = [];
                                for (var i = 0; i < object.urlCustomParameters.length; ++i) {
                                    if (typeof object.urlCustomParameters[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Ad.urlCustomParameters: object expected");
                                    message.urlCustomParameters[i] = $root.google.ads.googleads.v1.common.CustomParameter.fromObject(object.urlCustomParameters[i]);
                                }
                            }
                            if (object.displayUrl != null) {
                                if (typeof object.displayUrl !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.displayUrl: object expected");
                                message.displayUrl = $root.google.protobuf.StringValue.fromObject(object.displayUrl);
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "TEXT_AD":
                            case 2:
                                message.type = 2;
                                break;
                            case "EXPANDED_TEXT_AD":
                            case 3:
                                message.type = 3;
                                break;
                            case "CALL_ONLY_AD":
                            case 6:
                                message.type = 6;
                                break;
                            case "EXPANDED_DYNAMIC_SEARCH_AD":
                            case 7:
                                message.type = 7;
                                break;
                            case "HOTEL_AD":
                            case 8:
                                message.type = 8;
                                break;
                            case "SHOPPING_SMART_AD":
                            case 9:
                                message.type = 9;
                                break;
                            case "SHOPPING_PRODUCT_AD":
                            case 10:
                                message.type = 10;
                                break;
                            case "VIDEO_AD":
                            case 12:
                                message.type = 12;
                                break;
                            case "GMAIL_AD":
                            case 13:
                                message.type = 13;
                                break;
                            case "IMAGE_AD":
                            case 14:
                                message.type = 14;
                                break;
                            case "RESPONSIVE_SEARCH_AD":
                            case 15:
                                message.type = 15;
                                break;
                            case "LEGACY_RESPONSIVE_DISPLAY_AD":
                            case 16:
                                message.type = 16;
                                break;
                            case "APP_AD":
                            case 17:
                                message.type = 17;
                                break;
                            case "LEGACY_APP_INSTALL_AD":
                            case 18:
                                message.type = 18;
                                break;
                            case "RESPONSIVE_DISPLAY_AD":
                            case 19:
                                message.type = 19;
                                break;
                            case "HTML5_UPLOAD_AD":
                            case 21:
                                message.type = 21;
                                break;
                            case "DYNAMIC_HTML5_AD":
                            case 22:
                                message.type = 22;
                                break;
                            case "APP_ENGAGEMENT_AD":
                            case 23:
                                message.type = 23;
                                break;
                            }
                            if (object.addedByGoogleAds != null) {
                                if (typeof object.addedByGoogleAds !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.addedByGoogleAds: object expected");
                                message.addedByGoogleAds = $root.google.protobuf.BoolValue.fromObject(object.addedByGoogleAds);
                            }
                            switch (object.devicePreference) {
                            case "UNSPECIFIED":
                            case 0:
                                message.devicePreference = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.devicePreference = 1;
                                break;
                            case "MOBILE":
                            case 2:
                                message.devicePreference = 2;
                                break;
                            case "TABLET":
                            case 3:
                                message.devicePreference = 3;
                                break;
                            case "DESKTOP":
                            case 4:
                                message.devicePreference = 4;
                                break;
                            case "OTHER":
                            case 5:
                                message.devicePreference = 5;
                                break;
                            }
                            if (object.urlCollections) {
                                if (!Array.isArray(object.urlCollections))
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.urlCollections: array expected");
                                message.urlCollections = [];
                                for (var i = 0; i < object.urlCollections.length; ++i) {
                                    if (typeof object.urlCollections[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Ad.urlCollections: object expected");
                                    message.urlCollections[i] = $root.google.ads.googleads.v1.common.UrlCollection.fromObject(object.urlCollections[i]);
                                }
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            switch (object.systemManagedResourceSource) {
                            case "UNSPECIFIED":
                            case 0:
                                message.systemManagedResourceSource = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.systemManagedResourceSource = 1;
                                break;
                            case "AD_VARIATIONS":
                            case 2:
                                message.systemManagedResourceSource = 2;
                                break;
                            }
                            if (object.textAd != null) {
                                if (typeof object.textAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.textAd: object expected");
                                message.textAd = $root.google.ads.googleads.v1.common.TextAdInfo.fromObject(object.textAd);
                            }
                            if (object.expandedTextAd != null) {
                                if (typeof object.expandedTextAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.expandedTextAd: object expected");
                                message.expandedTextAd = $root.google.ads.googleads.v1.common.ExpandedTextAdInfo.fromObject(object.expandedTextAd);
                            }
                            if (object.callOnlyAd != null) {
                                if (typeof object.callOnlyAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.callOnlyAd: object expected");
                                message.callOnlyAd = $root.google.ads.googleads.v1.common.CallOnlyAdInfo.fromObject(object.callOnlyAd);
                            }
                            if (object.expandedDynamicSearchAd != null) {
                                if (typeof object.expandedDynamicSearchAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.expandedDynamicSearchAd: object expected");
                                message.expandedDynamicSearchAd = $root.google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo.fromObject(object.expandedDynamicSearchAd);
                            }
                            if (object.hotelAd != null) {
                                if (typeof object.hotelAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.hotelAd: object expected");
                                message.hotelAd = $root.google.ads.googleads.v1.common.HotelAdInfo.fromObject(object.hotelAd);
                            }
                            if (object.shoppingSmartAd != null) {
                                if (typeof object.shoppingSmartAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.shoppingSmartAd: object expected");
                                message.shoppingSmartAd = $root.google.ads.googleads.v1.common.ShoppingSmartAdInfo.fromObject(object.shoppingSmartAd);
                            }
                            if (object.shoppingProductAd != null) {
                                if (typeof object.shoppingProductAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.shoppingProductAd: object expected");
                                message.shoppingProductAd = $root.google.ads.googleads.v1.common.ShoppingProductAdInfo.fromObject(object.shoppingProductAd);
                            }
                            if (object.gmailAd != null) {
                                if (typeof object.gmailAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.gmailAd: object expected");
                                message.gmailAd = $root.google.ads.googleads.v1.common.GmailAdInfo.fromObject(object.gmailAd);
                            }
                            if (object.imageAd != null) {
                                if (typeof object.imageAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.imageAd: object expected");
                                message.imageAd = $root.google.ads.googleads.v1.common.ImageAdInfo.fromObject(object.imageAd);
                            }
                            if (object.videoAd != null) {
                                if (typeof object.videoAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.videoAd: object expected");
                                message.videoAd = $root.google.ads.googleads.v1.common.VideoAdInfo.fromObject(object.videoAd);
                            }
                            if (object.responsiveSearchAd != null) {
                                if (typeof object.responsiveSearchAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.responsiveSearchAd: object expected");
                                message.responsiveSearchAd = $root.google.ads.googleads.v1.common.ResponsiveSearchAdInfo.fromObject(object.responsiveSearchAd);
                            }
                            if (object.legacyResponsiveDisplayAd != null) {
                                if (typeof object.legacyResponsiveDisplayAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.legacyResponsiveDisplayAd: object expected");
                                message.legacyResponsiveDisplayAd = $root.google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.fromObject(object.legacyResponsiveDisplayAd);
                            }
                            if (object.appAd != null) {
                                if (typeof object.appAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.appAd: object expected");
                                message.appAd = $root.google.ads.googleads.v1.common.AppAdInfo.fromObject(object.appAd);
                            }
                            if (object.legacyAppInstallAd != null) {
                                if (typeof object.legacyAppInstallAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.legacyAppInstallAd: object expected");
                                message.legacyAppInstallAd = $root.google.ads.googleads.v1.common.LegacyAppInstallAdInfo.fromObject(object.legacyAppInstallAd);
                            }
                            if (object.responsiveDisplayAd != null) {
                                if (typeof object.responsiveDisplayAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.responsiveDisplayAd: object expected");
                                message.responsiveDisplayAd = $root.google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.fromObject(object.responsiveDisplayAd);
                            }
                            if (object.displayUploadAd != null) {
                                if (typeof object.displayUploadAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.displayUploadAd: object expected");
                                message.displayUploadAd = $root.google.ads.googleads.v1.common.DisplayUploadAdInfo.fromObject(object.displayUploadAd);
                            }
                            if (object.appEngagementAd != null) {
                                if (typeof object.appEngagementAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Ad.appEngagementAd: object expected");
                                message.appEngagementAd = $root.google.ads.googleads.v1.common.AppEngagementAdInfo.fromObject(object.appEngagementAd);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an Ad message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @static
                         * @param {google.ads.googleads.v1.resources.Ad} message Ad
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Ad.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.finalUrls = [];
                                object.urlCustomParameters = [];
                                object.finalMobileUrls = [];
                                object.urlCollections = [];
                                object.finalAppUrls = [];
                            }
                            if (options.defaults) {
                                object.id = null;
                                object.displayUrl = null;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.trackingUrlTemplate = null;
                                object.addedByGoogleAds = null;
                                object.devicePreference = options.enums === String ? "UNSPECIFIED" : 0;
                                object.name = null;
                                object.systemManagedResourceSource = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.finalUrls && message.finalUrls.length) {
                                object.finalUrls = [];
                                for (var j = 0; j < message.finalUrls.length; ++j)
                                    object.finalUrls[j] = $root.google.protobuf.StringValue.toObject(message.finalUrls[j], options);
                            }
                            if (message.displayUrl != null && message.hasOwnProperty("displayUrl"))
                                object.displayUrl = $root.google.protobuf.StringValue.toObject(message.displayUrl, options);
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.AdTypeEnum.AdType[message.type] : message.type;
                            if (message.textAd != null && message.hasOwnProperty("textAd")) {
                                object.textAd = $root.google.ads.googleads.v1.common.TextAdInfo.toObject(message.textAd, options);
                                if (options.oneofs)
                                    object.adData = "textAd";
                            }
                            if (message.expandedTextAd != null && message.hasOwnProperty("expandedTextAd")) {
                                object.expandedTextAd = $root.google.ads.googleads.v1.common.ExpandedTextAdInfo.toObject(message.expandedTextAd, options);
                                if (options.oneofs)
                                    object.adData = "expandedTextAd";
                            }
                            if (message.urlCustomParameters && message.urlCustomParameters.length) {
                                object.urlCustomParameters = [];
                                for (var j = 0; j < message.urlCustomParameters.length; ++j)
                                    object.urlCustomParameters[j] = $root.google.ads.googleads.v1.common.CustomParameter.toObject(message.urlCustomParameters[j], options);
                            }
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                object.trackingUrlTemplate = $root.google.protobuf.StringValue.toObject(message.trackingUrlTemplate, options);
                            if (message.callOnlyAd != null && message.hasOwnProperty("callOnlyAd")) {
                                object.callOnlyAd = $root.google.ads.googleads.v1.common.CallOnlyAdInfo.toObject(message.callOnlyAd, options);
                                if (options.oneofs)
                                    object.adData = "callOnlyAd";
                            }
                            if (message.expandedDynamicSearchAd != null && message.hasOwnProperty("expandedDynamicSearchAd")) {
                                object.expandedDynamicSearchAd = $root.google.ads.googleads.v1.common.ExpandedDynamicSearchAdInfo.toObject(message.expandedDynamicSearchAd, options);
                                if (options.oneofs)
                                    object.adData = "expandedDynamicSearchAd";
                            }
                            if (message.hotelAd != null && message.hasOwnProperty("hotelAd")) {
                                object.hotelAd = $root.google.ads.googleads.v1.common.HotelAdInfo.toObject(message.hotelAd, options);
                                if (options.oneofs)
                                    object.adData = "hotelAd";
                            }
                            if (message.finalMobileUrls && message.finalMobileUrls.length) {
                                object.finalMobileUrls = [];
                                for (var j = 0; j < message.finalMobileUrls.length; ++j)
                                    object.finalMobileUrls[j] = $root.google.protobuf.StringValue.toObject(message.finalMobileUrls[j], options);
                            }
                            if (message.shoppingSmartAd != null && message.hasOwnProperty("shoppingSmartAd")) {
                                object.shoppingSmartAd = $root.google.ads.googleads.v1.common.ShoppingSmartAdInfo.toObject(message.shoppingSmartAd, options);
                                if (options.oneofs)
                                    object.adData = "shoppingSmartAd";
                            }
                            if (message.shoppingProductAd != null && message.hasOwnProperty("shoppingProductAd")) {
                                object.shoppingProductAd = $root.google.ads.googleads.v1.common.ShoppingProductAdInfo.toObject(message.shoppingProductAd, options);
                                if (options.oneofs)
                                    object.adData = "shoppingProductAd";
                            }
                            if (message.addedByGoogleAds != null && message.hasOwnProperty("addedByGoogleAds"))
                                object.addedByGoogleAds = $root.google.protobuf.BoolValue.toObject(message.addedByGoogleAds, options);
                            if (message.devicePreference != null && message.hasOwnProperty("devicePreference"))
                                object.devicePreference = options.enums === String ? $root.google.ads.googleads.v1.enums.DeviceEnum.Device[message.devicePreference] : message.devicePreference;
                            if (message.gmailAd != null && message.hasOwnProperty("gmailAd")) {
                                object.gmailAd = $root.google.ads.googleads.v1.common.GmailAdInfo.toObject(message.gmailAd, options);
                                if (options.oneofs)
                                    object.adData = "gmailAd";
                            }
                            if (message.imageAd != null && message.hasOwnProperty("imageAd")) {
                                object.imageAd = $root.google.ads.googleads.v1.common.ImageAdInfo.toObject(message.imageAd, options);
                                if (options.oneofs)
                                    object.adData = "imageAd";
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.videoAd != null && message.hasOwnProperty("videoAd")) {
                                object.videoAd = $root.google.ads.googleads.v1.common.VideoAdInfo.toObject(message.videoAd, options);
                                if (options.oneofs)
                                    object.adData = "videoAd";
                            }
                            if (message.responsiveSearchAd != null && message.hasOwnProperty("responsiveSearchAd")) {
                                object.responsiveSearchAd = $root.google.ads.googleads.v1.common.ResponsiveSearchAdInfo.toObject(message.responsiveSearchAd, options);
                                if (options.oneofs)
                                    object.adData = "responsiveSearchAd";
                            }
                            if (message.urlCollections && message.urlCollections.length) {
                                object.urlCollections = [];
                                for (var j = 0; j < message.urlCollections.length; ++j)
                                    object.urlCollections[j] = $root.google.ads.googleads.v1.common.UrlCollection.toObject(message.urlCollections[j], options);
                            }
                            if (message.systemManagedResourceSource != null && message.hasOwnProperty("systemManagedResourceSource"))
                                object.systemManagedResourceSource = options.enums === String ? $root.google.ads.googleads.v1.enums.SystemManagedResourceSourceEnum.SystemManagedResourceSource[message.systemManagedResourceSource] : message.systemManagedResourceSource;
                            if (message.legacyResponsiveDisplayAd != null && message.hasOwnProperty("legacyResponsiveDisplayAd")) {
                                object.legacyResponsiveDisplayAd = $root.google.ads.googleads.v1.common.LegacyResponsiveDisplayAdInfo.toObject(message.legacyResponsiveDisplayAd, options);
                                if (options.oneofs)
                                    object.adData = "legacyResponsiveDisplayAd";
                            }
                            if (message.appAd != null && message.hasOwnProperty("appAd")) {
                                object.appAd = $root.google.ads.googleads.v1.common.AppAdInfo.toObject(message.appAd, options);
                                if (options.oneofs)
                                    object.adData = "appAd";
                            }
                            if (message.legacyAppInstallAd != null && message.hasOwnProperty("legacyAppInstallAd")) {
                                object.legacyAppInstallAd = $root.google.ads.googleads.v1.common.LegacyAppInstallAdInfo.toObject(message.legacyAppInstallAd, options);
                                if (options.oneofs)
                                    object.adData = "legacyAppInstallAd";
                            }
                            if (message.responsiveDisplayAd != null && message.hasOwnProperty("responsiveDisplayAd")) {
                                object.responsiveDisplayAd = $root.google.ads.googleads.v1.common.ResponsiveDisplayAdInfo.toObject(message.responsiveDisplayAd, options);
                                if (options.oneofs)
                                    object.adData = "responsiveDisplayAd";
                            }
                            if (message.displayUploadAd != null && message.hasOwnProperty("displayUploadAd")) {
                                object.displayUploadAd = $root.google.ads.googleads.v1.common.DisplayUploadAdInfo.toObject(message.displayUploadAd, options);
                                if (options.oneofs)
                                    object.adData = "displayUploadAd";
                            }
                            if (message.appEngagementAd != null && message.hasOwnProperty("appEngagementAd")) {
                                object.appEngagementAd = $root.google.ads.googleads.v1.common.AppEngagementAdInfo.toObject(message.appEngagementAd, options);
                                if (options.oneofs)
                                    object.adData = "appEngagementAd";
                            }
                            if (message.finalAppUrls && message.finalAppUrls.length) {
                                object.finalAppUrls = [];
                                for (var j = 0; j < message.finalAppUrls.length; ++j)
                                    object.finalAppUrls[j] = $root.google.ads.googleads.v1.common.FinalAppUrl.toObject(message.finalAppUrls[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this Ad to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.Ad
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Ad.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return Ad;
                    })();

                    resources.AdGroup = (function() {

                        /**
                         * Properties of an AdGroup.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAdGroup
                         * @property {string|null} [resourceName] AdGroup resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] AdGroup id
                         * @property {google.protobuf.IStringValue|null} [name] AdGroup name
                         * @property {google.ads.googleads.v1.enums.AdGroupStatusEnum.AdGroupStatus|null} [status] AdGroup status
                         * @property {google.ads.googleads.v1.enums.AdGroupTypeEnum.AdGroupType|null} [type] AdGroup type
                         * @property {google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum.AdGroupAdRotationMode|null} [adRotationMode] AdGroup adRotationMode
                         * @property {google.protobuf.IStringValue|null} [trackingUrlTemplate] AdGroup trackingUrlTemplate
                         * @property {Array.<google.ads.googleads.v1.common.ICustomParameter>|null} [urlCustomParameters] AdGroup urlCustomParameters
                         * @property {google.protobuf.IStringValue|null} [campaign] AdGroup campaign
                         * @property {google.protobuf.IInt64Value|null} [cpcBidMicros] AdGroup cpcBidMicros
                         * @property {google.protobuf.IInt64Value|null} [cpmBidMicros] AdGroup cpmBidMicros
                         * @property {google.protobuf.IInt64Value|null} [targetCpaMicros] AdGroup targetCpaMicros
                         * @property {google.protobuf.IInt64Value|null} [cpvBidMicros] AdGroup cpvBidMicros
                         * @property {google.protobuf.IInt64Value|null} [targetCpmMicros] AdGroup targetCpmMicros
                         * @property {google.protobuf.IDoubleValue|null} [targetRoas] AdGroup targetRoas
                         * @property {google.protobuf.IInt64Value|null} [percentCpcBidMicros] AdGroup percentCpcBidMicros
                         * @property {google.ads.googleads.v1.common.IExplorerAutoOptimizerSetting|null} [explorerAutoOptimizerSetting] AdGroup explorerAutoOptimizerSetting
                         * @property {google.ads.googleads.v1.enums.TargetingDimensionEnum.TargetingDimension|null} [displayCustomBidDimension] AdGroup displayCustomBidDimension
                         * @property {google.protobuf.IStringValue|null} [finalUrlSuffix] AdGroup finalUrlSuffix
                         * @property {google.ads.googleads.v1.common.ITargetingSetting|null} [targetingSetting] AdGroup targetingSetting
                         * @property {google.protobuf.IInt64Value|null} [effectiveTargetCpaMicros] AdGroup effectiveTargetCpaMicros
                         * @property {google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource|null} [effectiveTargetCpaSource] AdGroup effectiveTargetCpaSource
                         * @property {google.protobuf.IDoubleValue|null} [effectiveTargetRoas] AdGroup effectiveTargetRoas
                         * @property {google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource|null} [effectiveTargetRoasSource] AdGroup effectiveTargetRoasSource
                         */

                        /**
                         * Constructs a new AdGroup.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AdGroup.
                         * @implements IAdGroup
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAdGroup=} [properties] Properties to set
                         */
                        function AdGroup(properties) {
                            this.urlCustomParameters = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroup resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.resourceName = "";

                        /**
                         * AdGroup id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.id = null;

                        /**
                         * AdGroup name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.name = null;

                        /**
                         * AdGroup status.
                         * @member {google.ads.googleads.v1.enums.AdGroupStatusEnum.AdGroupStatus} status
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.status = 0;

                        /**
                         * AdGroup type.
                         * @member {google.ads.googleads.v1.enums.AdGroupTypeEnum.AdGroupType} type
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.type = 0;

                        /**
                         * AdGroup adRotationMode.
                         * @member {google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum.AdGroupAdRotationMode} adRotationMode
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.adRotationMode = 0;

                        /**
                         * AdGroup trackingUrlTemplate.
                         * @member {google.protobuf.IStringValue|null|undefined} trackingUrlTemplate
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.trackingUrlTemplate = null;

                        /**
                         * AdGroup urlCustomParameters.
                         * @member {Array.<google.ads.googleads.v1.common.ICustomParameter>} urlCustomParameters
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.urlCustomParameters = $util.emptyArray;

                        /**
                         * AdGroup campaign.
                         * @member {google.protobuf.IStringValue|null|undefined} campaign
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.campaign = null;

                        /**
                         * AdGroup cpcBidMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpcBidMicros
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.cpcBidMicros = null;

                        /**
                         * AdGroup cpmBidMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpmBidMicros
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.cpmBidMicros = null;

                        /**
                         * AdGroup targetCpaMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} targetCpaMicros
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.targetCpaMicros = null;

                        /**
                         * AdGroup cpvBidMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpvBidMicros
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.cpvBidMicros = null;

                        /**
                         * AdGroup targetCpmMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} targetCpmMicros
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.targetCpmMicros = null;

                        /**
                         * AdGroup targetRoas.
                         * @member {google.protobuf.IDoubleValue|null|undefined} targetRoas
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.targetRoas = null;

                        /**
                         * AdGroup percentCpcBidMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} percentCpcBidMicros
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.percentCpcBidMicros = null;

                        /**
                         * AdGroup explorerAutoOptimizerSetting.
                         * @member {google.ads.googleads.v1.common.IExplorerAutoOptimizerSetting|null|undefined} explorerAutoOptimizerSetting
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.explorerAutoOptimizerSetting = null;

                        /**
                         * AdGroup displayCustomBidDimension.
                         * @member {google.ads.googleads.v1.enums.TargetingDimensionEnum.TargetingDimension} displayCustomBidDimension
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.displayCustomBidDimension = 0;

                        /**
                         * AdGroup finalUrlSuffix.
                         * @member {google.protobuf.IStringValue|null|undefined} finalUrlSuffix
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.finalUrlSuffix = null;

                        /**
                         * AdGroup targetingSetting.
                         * @member {google.ads.googleads.v1.common.ITargetingSetting|null|undefined} targetingSetting
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.targetingSetting = null;

                        /**
                         * AdGroup effectiveTargetCpaMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} effectiveTargetCpaMicros
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.effectiveTargetCpaMicros = null;

                        /**
                         * AdGroup effectiveTargetCpaSource.
                         * @member {google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource} effectiveTargetCpaSource
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.effectiveTargetCpaSource = 0;

                        /**
                         * AdGroup effectiveTargetRoas.
                         * @member {google.protobuf.IDoubleValue|null|undefined} effectiveTargetRoas
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.effectiveTargetRoas = null;

                        /**
                         * AdGroup effectiveTargetRoasSource.
                         * @member {google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource} effectiveTargetRoasSource
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         */
                        AdGroup.prototype.effectiveTargetRoasSource = 0;

                        /**
                         * Creates a new AdGroup instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroup=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AdGroup} AdGroup instance
                         */
                        AdGroup.create = function create(properties) {
                            return new AdGroup(properties);
                        };

                        /**
                         * Encodes the specified AdGroup message. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroup.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroup} message AdGroup message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroup.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.status);
                            if (message.urlCustomParameters != null && message.urlCustomParameters.length)
                                for (var i = 0; i < message.urlCustomParameters.length; ++i)
                                    $root.google.ads.googleads.v1.common.CustomParameter.encode(message.urlCustomParameters[i], writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                $root.google.protobuf.StringValue.encode(message.campaign, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 12, wireType 0 =*/96).int32(message.type);
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                $root.google.protobuf.StringValue.encode(message.trackingUrlTemplate, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                            if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpcBidMicros, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.cpmBidMicros != null && message.hasOwnProperty("cpmBidMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpmBidMicros, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
                            if (message.cpvBidMicros != null && message.hasOwnProperty("cpvBidMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpvBidMicros, writer.uint32(/* id 17, wireType 2 =*/138).fork()).ldelim();
                            if (message.percentCpcBidMicros != null && message.hasOwnProperty("percentCpcBidMicros"))
                                $root.google.protobuf.Int64Value.encode(message.percentCpcBidMicros, writer.uint32(/* id 20, wireType 2 =*/162).fork()).ldelim();
                            if (message.explorerAutoOptimizerSetting != null && message.hasOwnProperty("explorerAutoOptimizerSetting"))
                                $root.google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting.encode(message.explorerAutoOptimizerSetting, writer.uint32(/* id 21, wireType 2 =*/170).fork()).ldelim();
                            if (message.adRotationMode != null && message.hasOwnProperty("adRotationMode"))
                                writer.uint32(/* id 22, wireType 0 =*/176).int32(message.adRotationMode);
                            if (message.displayCustomBidDimension != null && message.hasOwnProperty("displayCustomBidDimension"))
                                writer.uint32(/* id 23, wireType 0 =*/184).int32(message.displayCustomBidDimension);
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix"))
                                $root.google.protobuf.StringValue.encode(message.finalUrlSuffix, writer.uint32(/* id 24, wireType 2 =*/194).fork()).ldelim();
                            if (message.targetingSetting != null && message.hasOwnProperty("targetingSetting"))
                                $root.google.ads.googleads.v1.common.TargetingSetting.encode(message.targetingSetting, writer.uint32(/* id 25, wireType 2 =*/202).fork()).ldelim();
                            if (message.targetCpmMicros != null && message.hasOwnProperty("targetCpmMicros"))
                                $root.google.protobuf.Int64Value.encode(message.targetCpmMicros, writer.uint32(/* id 26, wireType 2 =*/210).fork()).ldelim();
                            if (message.targetCpaMicros != null && message.hasOwnProperty("targetCpaMicros"))
                                $root.google.protobuf.Int64Value.encode(message.targetCpaMicros, writer.uint32(/* id 27, wireType 2 =*/218).fork()).ldelim();
                            if (message.effectiveTargetCpaMicros != null && message.hasOwnProperty("effectiveTargetCpaMicros"))
                                $root.google.protobuf.Int64Value.encode(message.effectiveTargetCpaMicros, writer.uint32(/* id 28, wireType 2 =*/226).fork()).ldelim();
                            if (message.effectiveTargetCpaSource != null && message.hasOwnProperty("effectiveTargetCpaSource"))
                                writer.uint32(/* id 29, wireType 0 =*/232).int32(message.effectiveTargetCpaSource);
                            if (message.targetRoas != null && message.hasOwnProperty("targetRoas"))
                                $root.google.protobuf.DoubleValue.encode(message.targetRoas, writer.uint32(/* id 30, wireType 2 =*/242).fork()).ldelim();
                            if (message.effectiveTargetRoas != null && message.hasOwnProperty("effectiveTargetRoas"))
                                $root.google.protobuf.DoubleValue.encode(message.effectiveTargetRoas, writer.uint32(/* id 31, wireType 2 =*/250).fork()).ldelim();
                            if (message.effectiveTargetRoasSource != null && message.hasOwnProperty("effectiveTargetRoasSource"))
                                writer.uint32(/* id 32, wireType 0 =*/256).int32(message.effectiveTargetRoasSource);
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroup message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroup.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroup} message AdGroup message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroup.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroup message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AdGroup} AdGroup
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroup.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AdGroup();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 3:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.status = reader.int32();
                                    break;
                                case 12:
                                    message.type = reader.int32();
                                    break;
                                case 22:
                                    message.adRotationMode = reader.int32();
                                    break;
                                case 13:
                                    message.trackingUrlTemplate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    if (!(message.urlCustomParameters && message.urlCustomParameters.length))
                                        message.urlCustomParameters = [];
                                    message.urlCustomParameters.push($root.google.ads.googleads.v1.common.CustomParameter.decode(reader, reader.uint32()));
                                    break;
                                case 10:
                                    message.campaign = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 14:
                                    message.cpcBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 15:
                                    message.cpmBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 27:
                                    message.targetCpaMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 17:
                                    message.cpvBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 26:
                                    message.targetCpmMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 30:
                                    message.targetRoas = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 20:
                                    message.percentCpcBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 21:
                                    message.explorerAutoOptimizerSetting = $root.google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting.decode(reader, reader.uint32());
                                    break;
                                case 23:
                                    message.displayCustomBidDimension = reader.int32();
                                    break;
                                case 24:
                                    message.finalUrlSuffix = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 25:
                                    message.targetingSetting = $root.google.ads.googleads.v1.common.TargetingSetting.decode(reader, reader.uint32());
                                    break;
                                case 28:
                                    message.effectiveTargetCpaMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 29:
                                    message.effectiveTargetCpaSource = reader.int32();
                                    break;
                                case 31:
                                    message.effectiveTargetRoas = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 32:
                                    message.effectiveTargetRoasSource = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroup message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AdGroup} AdGroup
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroup.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroup message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroup.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                    break;
                                }
                            if (message.adRotationMode != null && message.hasOwnProperty("adRotationMode"))
                                switch (message.adRotationMode) {
                                default:
                                    return "adRotationMode: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.trackingUrlTemplate);
                                if (error)
                                    return "trackingUrlTemplate." + error;
                            }
                            if (message.urlCustomParameters != null && message.hasOwnProperty("urlCustomParameters")) {
                                if (!Array.isArray(message.urlCustomParameters))
                                    return "urlCustomParameters: array expected";
                                for (var i = 0; i < message.urlCustomParameters.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.CustomParameter.verify(message.urlCustomParameters[i]);
                                    if (error)
                                        return "urlCustomParameters." + error;
                                }
                            }
                            if (message.campaign != null && message.hasOwnProperty("campaign")) {
                                var error = $root.google.protobuf.StringValue.verify(message.campaign);
                                if (error)
                                    return "campaign." + error;
                            }
                            if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpcBidMicros);
                                if (error)
                                    return "cpcBidMicros." + error;
                            }
                            if (message.cpmBidMicros != null && message.hasOwnProperty("cpmBidMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpmBidMicros);
                                if (error)
                                    return "cpmBidMicros." + error;
                            }
                            if (message.targetCpaMicros != null && message.hasOwnProperty("targetCpaMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.targetCpaMicros);
                                if (error)
                                    return "targetCpaMicros." + error;
                            }
                            if (message.cpvBidMicros != null && message.hasOwnProperty("cpvBidMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpvBidMicros);
                                if (error)
                                    return "cpvBidMicros." + error;
                            }
                            if (message.targetCpmMicros != null && message.hasOwnProperty("targetCpmMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.targetCpmMicros);
                                if (error)
                                    return "targetCpmMicros." + error;
                            }
                            if (message.targetRoas != null && message.hasOwnProperty("targetRoas")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.targetRoas);
                                if (error)
                                    return "targetRoas." + error;
                            }
                            if (message.percentCpcBidMicros != null && message.hasOwnProperty("percentCpcBidMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.percentCpcBidMicros);
                                if (error)
                                    return "percentCpcBidMicros." + error;
                            }
                            if (message.explorerAutoOptimizerSetting != null && message.hasOwnProperty("explorerAutoOptimizerSetting")) {
                                var error = $root.google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting.verify(message.explorerAutoOptimizerSetting);
                                if (error)
                                    return "explorerAutoOptimizerSetting." + error;
                            }
                            if (message.displayCustomBidDimension != null && message.hasOwnProperty("displayCustomBidDimension"))
                                switch (message.displayCustomBidDimension) {
                                default:
                                    return "displayCustomBidDimension: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                    break;
                                }
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix")) {
                                var error = $root.google.protobuf.StringValue.verify(message.finalUrlSuffix);
                                if (error)
                                    return "finalUrlSuffix." + error;
                            }
                            if (message.targetingSetting != null && message.hasOwnProperty("targetingSetting")) {
                                var error = $root.google.ads.googleads.v1.common.TargetingSetting.verify(message.targetingSetting);
                                if (error)
                                    return "targetingSetting." + error;
                            }
                            if (message.effectiveTargetCpaMicros != null && message.hasOwnProperty("effectiveTargetCpaMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.effectiveTargetCpaMicros);
                                if (error)
                                    return "effectiveTargetCpaMicros." + error;
                            }
                            if (message.effectiveTargetCpaSource != null && message.hasOwnProperty("effectiveTargetCpaSource"))
                                switch (message.effectiveTargetCpaSource) {
                                default:
                                    return "effectiveTargetCpaSource: enum value expected";
                                case 0:
                                case 1:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            if (message.effectiveTargetRoas != null && message.hasOwnProperty("effectiveTargetRoas")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.effectiveTargetRoas);
                                if (error)
                                    return "effectiveTargetRoas." + error;
                            }
                            if (message.effectiveTargetRoasSource != null && message.hasOwnProperty("effectiveTargetRoasSource"))
                                switch (message.effectiveTargetRoasSource) {
                                default:
                                    return "effectiveTargetRoasSource: enum value expected";
                                case 0:
                                case 1:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates an AdGroup message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AdGroup} AdGroup
                         */
                        AdGroup.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AdGroup)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AdGroup();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroup.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroup.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "PAUSED":
                            case 3:
                                message.status = 3;
                                break;
                            case "REMOVED":
                            case 4:
                                message.status = 4;
                                break;
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "SEARCH_STANDARD":
                            case 2:
                                message.type = 2;
                                break;
                            case "DISPLAY_STANDARD":
                            case 3:
                                message.type = 3;
                                break;
                            case "SHOPPING_PRODUCT_ADS":
                            case 4:
                                message.type = 4;
                                break;
                            case "HOTEL_ADS":
                            case 6:
                                message.type = 6;
                                break;
                            case "SHOPPING_SMART_ADS":
                            case 7:
                                message.type = 7;
                                break;
                            case "VIDEO_BUMPER":
                            case 8:
                                message.type = 8;
                                break;
                            case "VIDEO_TRUE_VIEW_IN_STREAM":
                            case 9:
                                message.type = 9;
                                break;
                            case "VIDEO_TRUE_VIEW_IN_DISPLAY":
                            case 10:
                                message.type = 10;
                                break;
                            case "VIDEO_NON_SKIPPABLE_IN_STREAM":
                            case 11:
                                message.type = 11;
                                break;
                            case "VIDEO_OUTSTREAM":
                            case 12:
                                message.type = 12;
                                break;
                            case "SEARCH_DYNAMIC_ADS":
                            case 13:
                                message.type = 13;
                                break;
                            }
                            switch (object.adRotationMode) {
                            case "UNSPECIFIED":
                            case 0:
                                message.adRotationMode = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.adRotationMode = 1;
                                break;
                            case "OPTIMIZE":
                            case 2:
                                message.adRotationMode = 2;
                                break;
                            case "ROTATE_FOREVER":
                            case 3:
                                message.adRotationMode = 3;
                                break;
                            }
                            if (object.trackingUrlTemplate != null) {
                                if (typeof object.trackingUrlTemplate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroup.trackingUrlTemplate: object expected");
                                message.trackingUrlTemplate = $root.google.protobuf.StringValue.fromObject(object.trackingUrlTemplate);
                            }
                            if (object.urlCustomParameters) {
                                if (!Array.isArray(object.urlCustomParameters))
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroup.urlCustomParameters: array expected");
                                message.urlCustomParameters = [];
                                for (var i = 0; i < object.urlCustomParameters.length; ++i) {
                                    if (typeof object.urlCustomParameters[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AdGroup.urlCustomParameters: object expected");
                                    message.urlCustomParameters[i] = $root.google.ads.googleads.v1.common.CustomParameter.fromObject(object.urlCustomParameters[i]);
                                }
                            }
                            if (object.campaign != null) {
                                if (typeof object.campaign !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroup.campaign: object expected");
                                message.campaign = $root.google.protobuf.StringValue.fromObject(object.campaign);
                            }
                            if (object.cpcBidMicros != null) {
                                if (typeof object.cpcBidMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroup.cpcBidMicros: object expected");
                                message.cpcBidMicros = $root.google.protobuf.Int64Value.fromObject(object.cpcBidMicros);
                            }
                            if (object.cpmBidMicros != null) {
                                if (typeof object.cpmBidMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroup.cpmBidMicros: object expected");
                                message.cpmBidMicros = $root.google.protobuf.Int64Value.fromObject(object.cpmBidMicros);
                            }
                            if (object.targetCpaMicros != null) {
                                if (typeof object.targetCpaMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroup.targetCpaMicros: object expected");
                                message.targetCpaMicros = $root.google.protobuf.Int64Value.fromObject(object.targetCpaMicros);
                            }
                            if (object.cpvBidMicros != null) {
                                if (typeof object.cpvBidMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroup.cpvBidMicros: object expected");
                                message.cpvBidMicros = $root.google.protobuf.Int64Value.fromObject(object.cpvBidMicros);
                            }
                            if (object.targetCpmMicros != null) {
                                if (typeof object.targetCpmMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroup.targetCpmMicros: object expected");
                                message.targetCpmMicros = $root.google.protobuf.Int64Value.fromObject(object.targetCpmMicros);
                            }
                            if (object.targetRoas != null) {
                                if (typeof object.targetRoas !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroup.targetRoas: object expected");
                                message.targetRoas = $root.google.protobuf.DoubleValue.fromObject(object.targetRoas);
                            }
                            if (object.percentCpcBidMicros != null) {
                                if (typeof object.percentCpcBidMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroup.percentCpcBidMicros: object expected");
                                message.percentCpcBidMicros = $root.google.protobuf.Int64Value.fromObject(object.percentCpcBidMicros);
                            }
                            if (object.explorerAutoOptimizerSetting != null) {
                                if (typeof object.explorerAutoOptimizerSetting !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroup.explorerAutoOptimizerSetting: object expected");
                                message.explorerAutoOptimizerSetting = $root.google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting.fromObject(object.explorerAutoOptimizerSetting);
                            }
                            switch (object.displayCustomBidDimension) {
                            case "UNSPECIFIED":
                            case 0:
                                message.displayCustomBidDimension = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.displayCustomBidDimension = 1;
                                break;
                            case "KEYWORD":
                            case 2:
                                message.displayCustomBidDimension = 2;
                                break;
                            case "AUDIENCE":
                            case 3:
                                message.displayCustomBidDimension = 3;
                                break;
                            case "TOPIC":
                            case 4:
                                message.displayCustomBidDimension = 4;
                                break;
                            case "GENDER":
                            case 5:
                                message.displayCustomBidDimension = 5;
                                break;
                            case "AGE_RANGE":
                            case 6:
                                message.displayCustomBidDimension = 6;
                                break;
                            case "PLACEMENT":
                            case 7:
                                message.displayCustomBidDimension = 7;
                                break;
                            case "PARENTAL_STATUS":
                            case 8:
                                message.displayCustomBidDimension = 8;
                                break;
                            case "INCOME_RANGE":
                            case 9:
                                message.displayCustomBidDimension = 9;
                                break;
                            }
                            if (object.finalUrlSuffix != null) {
                                if (typeof object.finalUrlSuffix !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroup.finalUrlSuffix: object expected");
                                message.finalUrlSuffix = $root.google.protobuf.StringValue.fromObject(object.finalUrlSuffix);
                            }
                            if (object.targetingSetting != null) {
                                if (typeof object.targetingSetting !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroup.targetingSetting: object expected");
                                message.targetingSetting = $root.google.ads.googleads.v1.common.TargetingSetting.fromObject(object.targetingSetting);
                            }
                            if (object.effectiveTargetCpaMicros != null) {
                                if (typeof object.effectiveTargetCpaMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroup.effectiveTargetCpaMicros: object expected");
                                message.effectiveTargetCpaMicros = $root.google.protobuf.Int64Value.fromObject(object.effectiveTargetCpaMicros);
                            }
                            switch (object.effectiveTargetCpaSource) {
                            case "UNSPECIFIED":
                            case 0:
                                message.effectiveTargetCpaSource = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.effectiveTargetCpaSource = 1;
                                break;
                            case "CAMPAIGN_BIDDING_STRATEGY":
                            case 5:
                                message.effectiveTargetCpaSource = 5;
                                break;
                            case "AD_GROUP":
                            case 6:
                                message.effectiveTargetCpaSource = 6;
                                break;
                            case "AD_GROUP_CRITERION":
                            case 7:
                                message.effectiveTargetCpaSource = 7;
                                break;
                            }
                            if (object.effectiveTargetRoas != null) {
                                if (typeof object.effectiveTargetRoas !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroup.effectiveTargetRoas: object expected");
                                message.effectiveTargetRoas = $root.google.protobuf.DoubleValue.fromObject(object.effectiveTargetRoas);
                            }
                            switch (object.effectiveTargetRoasSource) {
                            case "UNSPECIFIED":
                            case 0:
                                message.effectiveTargetRoasSource = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.effectiveTargetRoasSource = 1;
                                break;
                            case "CAMPAIGN_BIDDING_STRATEGY":
                            case 5:
                                message.effectiveTargetRoasSource = 5;
                                break;
                            case "AD_GROUP":
                            case 6:
                                message.effectiveTargetRoasSource = 6;
                                break;
                            case "AD_GROUP_CRITERION":
                            case 7:
                                message.effectiveTargetRoasSource = 7;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroup message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @static
                         * @param {google.ads.googleads.v1.resources.AdGroup} message AdGroup
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroup.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.urlCustomParameters = [];
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.name = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                                object.campaign = null;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.trackingUrlTemplate = null;
                                object.cpcBidMicros = null;
                                object.cpmBidMicros = null;
                                object.cpvBidMicros = null;
                                object.percentCpcBidMicros = null;
                                object.explorerAutoOptimizerSetting = null;
                                object.adRotationMode = options.enums === String ? "UNSPECIFIED" : 0;
                                object.displayCustomBidDimension = options.enums === String ? "UNSPECIFIED" : 0;
                                object.finalUrlSuffix = null;
                                object.targetingSetting = null;
                                object.targetCpmMicros = null;
                                object.targetCpaMicros = null;
                                object.effectiveTargetCpaMicros = null;
                                object.effectiveTargetCpaSource = options.enums === String ? "UNSPECIFIED" : 0;
                                object.targetRoas = null;
                                object.effectiveTargetRoas = null;
                                object.effectiveTargetRoasSource = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.AdGroupStatusEnum.AdGroupStatus[message.status] : message.status;
                            if (message.urlCustomParameters && message.urlCustomParameters.length) {
                                object.urlCustomParameters = [];
                                for (var j = 0; j < message.urlCustomParameters.length; ++j)
                                    object.urlCustomParameters[j] = $root.google.ads.googleads.v1.common.CustomParameter.toObject(message.urlCustomParameters[j], options);
                            }
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                object.campaign = $root.google.protobuf.StringValue.toObject(message.campaign, options);
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.AdGroupTypeEnum.AdGroupType[message.type] : message.type;
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                object.trackingUrlTemplate = $root.google.protobuf.StringValue.toObject(message.trackingUrlTemplate, options);
                            if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros"))
                                object.cpcBidMicros = $root.google.protobuf.Int64Value.toObject(message.cpcBidMicros, options);
                            if (message.cpmBidMicros != null && message.hasOwnProperty("cpmBidMicros"))
                                object.cpmBidMicros = $root.google.protobuf.Int64Value.toObject(message.cpmBidMicros, options);
                            if (message.cpvBidMicros != null && message.hasOwnProperty("cpvBidMicros"))
                                object.cpvBidMicros = $root.google.protobuf.Int64Value.toObject(message.cpvBidMicros, options);
                            if (message.percentCpcBidMicros != null && message.hasOwnProperty("percentCpcBidMicros"))
                                object.percentCpcBidMicros = $root.google.protobuf.Int64Value.toObject(message.percentCpcBidMicros, options);
                            if (message.explorerAutoOptimizerSetting != null && message.hasOwnProperty("explorerAutoOptimizerSetting"))
                                object.explorerAutoOptimizerSetting = $root.google.ads.googleads.v1.common.ExplorerAutoOptimizerSetting.toObject(message.explorerAutoOptimizerSetting, options);
                            if (message.adRotationMode != null && message.hasOwnProperty("adRotationMode"))
                                object.adRotationMode = options.enums === String ? $root.google.ads.googleads.v1.enums.AdGroupAdRotationModeEnum.AdGroupAdRotationMode[message.adRotationMode] : message.adRotationMode;
                            if (message.displayCustomBidDimension != null && message.hasOwnProperty("displayCustomBidDimension"))
                                object.displayCustomBidDimension = options.enums === String ? $root.google.ads.googleads.v1.enums.TargetingDimensionEnum.TargetingDimension[message.displayCustomBidDimension] : message.displayCustomBidDimension;
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix"))
                                object.finalUrlSuffix = $root.google.protobuf.StringValue.toObject(message.finalUrlSuffix, options);
                            if (message.targetingSetting != null && message.hasOwnProperty("targetingSetting"))
                                object.targetingSetting = $root.google.ads.googleads.v1.common.TargetingSetting.toObject(message.targetingSetting, options);
                            if (message.targetCpmMicros != null && message.hasOwnProperty("targetCpmMicros"))
                                object.targetCpmMicros = $root.google.protobuf.Int64Value.toObject(message.targetCpmMicros, options);
                            if (message.targetCpaMicros != null && message.hasOwnProperty("targetCpaMicros"))
                                object.targetCpaMicros = $root.google.protobuf.Int64Value.toObject(message.targetCpaMicros, options);
                            if (message.effectiveTargetCpaMicros != null && message.hasOwnProperty("effectiveTargetCpaMicros"))
                                object.effectiveTargetCpaMicros = $root.google.protobuf.Int64Value.toObject(message.effectiveTargetCpaMicros, options);
                            if (message.effectiveTargetCpaSource != null && message.hasOwnProperty("effectiveTargetCpaSource"))
                                object.effectiveTargetCpaSource = options.enums === String ? $root.google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource[message.effectiveTargetCpaSource] : message.effectiveTargetCpaSource;
                            if (message.targetRoas != null && message.hasOwnProperty("targetRoas"))
                                object.targetRoas = $root.google.protobuf.DoubleValue.toObject(message.targetRoas, options);
                            if (message.effectiveTargetRoas != null && message.hasOwnProperty("effectiveTargetRoas"))
                                object.effectiveTargetRoas = $root.google.protobuf.DoubleValue.toObject(message.effectiveTargetRoas, options);
                            if (message.effectiveTargetRoasSource != null && message.hasOwnProperty("effectiveTargetRoasSource"))
                                object.effectiveTargetRoasSource = options.enums === String ? $root.google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource[message.effectiveTargetRoasSource] : message.effectiveTargetRoasSource;
                            return object;
                        };

                        /**
                         * Converts this AdGroup to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AdGroup
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroup.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroup;
                    })();

                    resources.AdGroupAd = (function() {

                        /**
                         * Properties of an AdGroupAd.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAdGroupAd
                         * @property {string|null} [resourceName] AdGroupAd resourceName
                         * @property {google.ads.googleads.v1.enums.AdGroupAdStatusEnum.AdGroupAdStatus|null} [status] AdGroupAd status
                         * @property {google.protobuf.IStringValue|null} [adGroup] AdGroupAd adGroup
                         * @property {google.ads.googleads.v1.resources.IAd|null} [ad] AdGroupAd ad
                         * @property {google.ads.googleads.v1.resources.IAdGroupAdPolicySummary|null} [policySummary] AdGroupAd policySummary
                         * @property {google.ads.googleads.v1.enums.AdStrengthEnum.AdStrength|null} [adStrength] AdGroupAd adStrength
                         */

                        /**
                         * Constructs a new AdGroupAd.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AdGroupAd.
                         * @implements IAdGroupAd
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAdGroupAd=} [properties] Properties to set
                         */
                        function AdGroupAd(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupAd resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.AdGroupAd
                         * @instance
                         */
                        AdGroupAd.prototype.resourceName = "";

                        /**
                         * AdGroupAd status.
                         * @member {google.ads.googleads.v1.enums.AdGroupAdStatusEnum.AdGroupAdStatus} status
                         * @memberof google.ads.googleads.v1.resources.AdGroupAd
                         * @instance
                         */
                        AdGroupAd.prototype.status = 0;

                        /**
                         * AdGroupAd adGroup.
                         * @member {google.protobuf.IStringValue|null|undefined} adGroup
                         * @memberof google.ads.googleads.v1.resources.AdGroupAd
                         * @instance
                         */
                        AdGroupAd.prototype.adGroup = null;

                        /**
                         * AdGroupAd ad.
                         * @member {google.ads.googleads.v1.resources.IAd|null|undefined} ad
                         * @memberof google.ads.googleads.v1.resources.AdGroupAd
                         * @instance
                         */
                        AdGroupAd.prototype.ad = null;

                        /**
                         * AdGroupAd policySummary.
                         * @member {google.ads.googleads.v1.resources.IAdGroupAdPolicySummary|null|undefined} policySummary
                         * @memberof google.ads.googleads.v1.resources.AdGroupAd
                         * @instance
                         */
                        AdGroupAd.prototype.policySummary = null;

                        /**
                         * AdGroupAd adStrength.
                         * @member {google.ads.googleads.v1.enums.AdStrengthEnum.AdStrength} adStrength
                         * @memberof google.ads.googleads.v1.resources.AdGroupAd
                         * @instance
                         */
                        AdGroupAd.prototype.adStrength = 0;

                        /**
                         * Creates a new AdGroupAd instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AdGroupAd
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupAd=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AdGroupAd} AdGroupAd instance
                         */
                        AdGroupAd.create = function create(properties) {
                            return new AdGroupAd(properties);
                        };

                        /**
                         * Encodes the specified AdGroupAd message. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupAd.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AdGroupAd
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupAd} message AdGroupAd message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupAd.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.status);
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                $root.google.protobuf.StringValue.encode(message.adGroup, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.ad != null && message.hasOwnProperty("ad"))
                                $root.google.ads.googleads.v1.resources.Ad.encode(message.ad, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.policySummary != null && message.hasOwnProperty("policySummary"))
                                $root.google.ads.googleads.v1.resources.AdGroupAdPolicySummary.encode(message.policySummary, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.adStrength != null && message.hasOwnProperty("adStrength"))
                                writer.uint32(/* id 7, wireType 0 =*/56).int32(message.adStrength);
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupAd message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupAd.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupAd
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupAd} message AdGroupAd message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupAd.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupAd message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AdGroupAd
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AdGroupAd} AdGroupAd
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupAd.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AdGroupAd();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 3:
                                    message.status = reader.int32();
                                    break;
                                case 4:
                                    message.adGroup = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.ad = $root.google.ads.googleads.v1.resources.Ad.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.policySummary = $root.google.ads.googleads.v1.resources.AdGroupAdPolicySummary.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.adStrength = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupAd message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupAd
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AdGroupAd} AdGroupAd
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupAd.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupAd message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AdGroupAd
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupAd.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.adGroup != null && message.hasOwnProperty("adGroup")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adGroup);
                                if (error)
                                    return "adGroup." + error;
                            }
                            if (message.ad != null && message.hasOwnProperty("ad")) {
                                var error = $root.google.ads.googleads.v1.resources.Ad.verify(message.ad);
                                if (error)
                                    return "ad." + error;
                            }
                            if (message.policySummary != null && message.hasOwnProperty("policySummary")) {
                                var error = $root.google.ads.googleads.v1.resources.AdGroupAdPolicySummary.verify(message.policySummary);
                                if (error)
                                    return "policySummary." + error;
                            }
                            if (message.adStrength != null && message.hasOwnProperty("adStrength"))
                                switch (message.adStrength) {
                                default:
                                    return "adStrength: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates an AdGroupAd message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupAd
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AdGroupAd} AdGroupAd
                         */
                        AdGroupAd.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AdGroupAd)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AdGroupAd();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "PAUSED":
                            case 3:
                                message.status = 3;
                                break;
                            case "REMOVED":
                            case 4:
                                message.status = 4;
                                break;
                            }
                            if (object.adGroup != null) {
                                if (typeof object.adGroup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupAd.adGroup: object expected");
                                message.adGroup = $root.google.protobuf.StringValue.fromObject(object.adGroup);
                            }
                            if (object.ad != null) {
                                if (typeof object.ad !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupAd.ad: object expected");
                                message.ad = $root.google.ads.googleads.v1.resources.Ad.fromObject(object.ad);
                            }
                            if (object.policySummary != null) {
                                if (typeof object.policySummary !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupAd.policySummary: object expected");
                                message.policySummary = $root.google.ads.googleads.v1.resources.AdGroupAdPolicySummary.fromObject(object.policySummary);
                            }
                            switch (object.adStrength) {
                            case "UNSPECIFIED":
                            case 0:
                                message.adStrength = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.adStrength = 1;
                                break;
                            case "PENDING":
                            case 2:
                                message.adStrength = 2;
                                break;
                            case "NO_ADS":
                            case 3:
                                message.adStrength = 3;
                                break;
                            case "POOR":
                            case 4:
                                message.adStrength = 4;
                                break;
                            case "AVERAGE":
                            case 5:
                                message.adStrength = 5;
                                break;
                            case "GOOD":
                            case 6:
                                message.adStrength = 6;
                                break;
                            case "EXCELLENT":
                            case 7:
                                message.adStrength = 7;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupAd message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupAd
                         * @static
                         * @param {google.ads.googleads.v1.resources.AdGroupAd} message AdGroupAd
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupAd.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                                object.adGroup = null;
                                object.ad = null;
                                object.policySummary = null;
                                object.adStrength = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.AdGroupAdStatusEnum.AdGroupAdStatus[message.status] : message.status;
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                object.adGroup = $root.google.protobuf.StringValue.toObject(message.adGroup, options);
                            if (message.ad != null && message.hasOwnProperty("ad"))
                                object.ad = $root.google.ads.googleads.v1.resources.Ad.toObject(message.ad, options);
                            if (message.policySummary != null && message.hasOwnProperty("policySummary"))
                                object.policySummary = $root.google.ads.googleads.v1.resources.AdGroupAdPolicySummary.toObject(message.policySummary, options);
                            if (message.adStrength != null && message.hasOwnProperty("adStrength"))
                                object.adStrength = options.enums === String ? $root.google.ads.googleads.v1.enums.AdStrengthEnum.AdStrength[message.adStrength] : message.adStrength;
                            return object;
                        };

                        /**
                         * Converts this AdGroupAd to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AdGroupAd
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupAd.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupAd;
                    })();

                    resources.AdGroupAdPolicySummary = (function() {

                        /**
                         * Properties of an AdGroupAdPolicySummary.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAdGroupAdPolicySummary
                         * @property {Array.<google.ads.googleads.v1.common.IPolicyTopicEntry>|null} [policyTopicEntries] AdGroupAdPolicySummary policyTopicEntries
                         * @property {google.ads.googleads.v1.enums.PolicyReviewStatusEnum.PolicyReviewStatus|null} [reviewStatus] AdGroupAdPolicySummary reviewStatus
                         * @property {google.ads.googleads.v1.enums.PolicyApprovalStatusEnum.PolicyApprovalStatus|null} [approvalStatus] AdGroupAdPolicySummary approvalStatus
                         */

                        /**
                         * Constructs a new AdGroupAdPolicySummary.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AdGroupAdPolicySummary.
                         * @implements IAdGroupAdPolicySummary
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAdGroupAdPolicySummary=} [properties] Properties to set
                         */
                        function AdGroupAdPolicySummary(properties) {
                            this.policyTopicEntries = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupAdPolicySummary policyTopicEntries.
                         * @member {Array.<google.ads.googleads.v1.common.IPolicyTopicEntry>} policyTopicEntries
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdPolicySummary
                         * @instance
                         */
                        AdGroupAdPolicySummary.prototype.policyTopicEntries = $util.emptyArray;

                        /**
                         * AdGroupAdPolicySummary reviewStatus.
                         * @member {google.ads.googleads.v1.enums.PolicyReviewStatusEnum.PolicyReviewStatus} reviewStatus
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdPolicySummary
                         * @instance
                         */
                        AdGroupAdPolicySummary.prototype.reviewStatus = 0;

                        /**
                         * AdGroupAdPolicySummary approvalStatus.
                         * @member {google.ads.googleads.v1.enums.PolicyApprovalStatusEnum.PolicyApprovalStatus} approvalStatus
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdPolicySummary
                         * @instance
                         */
                        AdGroupAdPolicySummary.prototype.approvalStatus = 0;

                        /**
                         * Creates a new AdGroupAdPolicySummary instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdPolicySummary
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupAdPolicySummary=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AdGroupAdPolicySummary} AdGroupAdPolicySummary instance
                         */
                        AdGroupAdPolicySummary.create = function create(properties) {
                            return new AdGroupAdPolicySummary(properties);
                        };

                        /**
                         * Encodes the specified AdGroupAdPolicySummary message. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupAdPolicySummary.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdPolicySummary
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupAdPolicySummary} message AdGroupAdPolicySummary message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupAdPolicySummary.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.policyTopicEntries != null && message.policyTopicEntries.length)
                                for (var i = 0; i < message.policyTopicEntries.length; ++i)
                                    $root.google.ads.googleads.v1.common.PolicyTopicEntry.encode(message.policyTopicEntries[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.reviewStatus != null && message.hasOwnProperty("reviewStatus"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.reviewStatus);
                            if (message.approvalStatus != null && message.hasOwnProperty("approvalStatus"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.approvalStatus);
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupAdPolicySummary message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupAdPolicySummary.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdPolicySummary
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupAdPolicySummary} message AdGroupAdPolicySummary message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupAdPolicySummary.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupAdPolicySummary message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdPolicySummary
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AdGroupAdPolicySummary} AdGroupAdPolicySummary
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupAdPolicySummary.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AdGroupAdPolicySummary();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.policyTopicEntries && message.policyTopicEntries.length))
                                        message.policyTopicEntries = [];
                                    message.policyTopicEntries.push($root.google.ads.googleads.v1.common.PolicyTopicEntry.decode(reader, reader.uint32()));
                                    break;
                                case 2:
                                    message.reviewStatus = reader.int32();
                                    break;
                                case 3:
                                    message.approvalStatus = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupAdPolicySummary message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdPolicySummary
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AdGroupAdPolicySummary} AdGroupAdPolicySummary
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupAdPolicySummary.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupAdPolicySummary message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdPolicySummary
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupAdPolicySummary.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.policyTopicEntries != null && message.hasOwnProperty("policyTopicEntries")) {
                                if (!Array.isArray(message.policyTopicEntries))
                                    return "policyTopicEntries: array expected";
                                for (var i = 0; i < message.policyTopicEntries.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.PolicyTopicEntry.verify(message.policyTopicEntries[i]);
                                    if (error)
                                        return "policyTopicEntries." + error;
                                }
                            }
                            if (message.reviewStatus != null && message.hasOwnProperty("reviewStatus"))
                                switch (message.reviewStatus) {
                                default:
                                    return "reviewStatus: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.approvalStatus != null && message.hasOwnProperty("approvalStatus"))
                                switch (message.approvalStatus) {
                                default:
                                    return "approvalStatus: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates an AdGroupAdPolicySummary message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdPolicySummary
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AdGroupAdPolicySummary} AdGroupAdPolicySummary
                         */
                        AdGroupAdPolicySummary.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AdGroupAdPolicySummary)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AdGroupAdPolicySummary();
                            if (object.policyTopicEntries) {
                                if (!Array.isArray(object.policyTopicEntries))
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupAdPolicySummary.policyTopicEntries: array expected");
                                message.policyTopicEntries = [];
                                for (var i = 0; i < object.policyTopicEntries.length; ++i) {
                                    if (typeof object.policyTopicEntries[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AdGroupAdPolicySummary.policyTopicEntries: object expected");
                                    message.policyTopicEntries[i] = $root.google.ads.googleads.v1.common.PolicyTopicEntry.fromObject(object.policyTopicEntries[i]);
                                }
                            }
                            switch (object.reviewStatus) {
                            case "UNSPECIFIED":
                            case 0:
                                message.reviewStatus = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.reviewStatus = 1;
                                break;
                            case "REVIEW_IN_PROGRESS":
                            case 2:
                                message.reviewStatus = 2;
                                break;
                            case "REVIEWED":
                            case 3:
                                message.reviewStatus = 3;
                                break;
                            case "UNDER_APPEAL":
                            case 4:
                                message.reviewStatus = 4;
                                break;
                            }
                            switch (object.approvalStatus) {
                            case "UNSPECIFIED":
                            case 0:
                                message.approvalStatus = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.approvalStatus = 1;
                                break;
                            case "DISAPPROVED":
                            case 2:
                                message.approvalStatus = 2;
                                break;
                            case "APPROVED_LIMITED":
                            case 3:
                                message.approvalStatus = 3;
                                break;
                            case "APPROVED":
                            case 4:
                                message.approvalStatus = 4;
                                break;
                            case "AREA_OF_INTEREST_ONLY":
                            case 5:
                                message.approvalStatus = 5;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupAdPolicySummary message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdPolicySummary
                         * @static
                         * @param {google.ads.googleads.v1.resources.AdGroupAdPolicySummary} message AdGroupAdPolicySummary
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupAdPolicySummary.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.policyTopicEntries = [];
                            if (options.defaults) {
                                object.reviewStatus = options.enums === String ? "UNSPECIFIED" : 0;
                                object.approvalStatus = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.policyTopicEntries && message.policyTopicEntries.length) {
                                object.policyTopicEntries = [];
                                for (var j = 0; j < message.policyTopicEntries.length; ++j)
                                    object.policyTopicEntries[j] = $root.google.ads.googleads.v1.common.PolicyTopicEntry.toObject(message.policyTopicEntries[j], options);
                            }
                            if (message.reviewStatus != null && message.hasOwnProperty("reviewStatus"))
                                object.reviewStatus = options.enums === String ? $root.google.ads.googleads.v1.enums.PolicyReviewStatusEnum.PolicyReviewStatus[message.reviewStatus] : message.reviewStatus;
                            if (message.approvalStatus != null && message.hasOwnProperty("approvalStatus"))
                                object.approvalStatus = options.enums === String ? $root.google.ads.googleads.v1.enums.PolicyApprovalStatusEnum.PolicyApprovalStatus[message.approvalStatus] : message.approvalStatus;
                            return object;
                        };

                        /**
                         * Converts this AdGroupAdPolicySummary to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdPolicySummary
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupAdPolicySummary.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupAdPolicySummary;
                    })();

                    resources.AdGroupAdLabel = (function() {

                        /**
                         * Properties of an AdGroupAdLabel.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAdGroupAdLabel
                         * @property {string|null} [resourceName] AdGroupAdLabel resourceName
                         * @property {google.protobuf.IStringValue|null} [adGroupAd] AdGroupAdLabel adGroupAd
                         * @property {google.protobuf.IStringValue|null} [label] AdGroupAdLabel label
                         */

                        /**
                         * Constructs a new AdGroupAdLabel.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AdGroupAdLabel.
                         * @implements IAdGroupAdLabel
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAdGroupAdLabel=} [properties] Properties to set
                         */
                        function AdGroupAdLabel(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupAdLabel resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdLabel
                         * @instance
                         */
                        AdGroupAdLabel.prototype.resourceName = "";

                        /**
                         * AdGroupAdLabel adGroupAd.
                         * @member {google.protobuf.IStringValue|null|undefined} adGroupAd
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdLabel
                         * @instance
                         */
                        AdGroupAdLabel.prototype.adGroupAd = null;

                        /**
                         * AdGroupAdLabel label.
                         * @member {google.protobuf.IStringValue|null|undefined} label
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdLabel
                         * @instance
                         */
                        AdGroupAdLabel.prototype.label = null;

                        /**
                         * Creates a new AdGroupAdLabel instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupAdLabel=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AdGroupAdLabel} AdGroupAdLabel instance
                         */
                        AdGroupAdLabel.create = function create(properties) {
                            return new AdGroupAdLabel(properties);
                        };

                        /**
                         * Encodes the specified AdGroupAdLabel message. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupAdLabel.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupAdLabel} message AdGroupAdLabel message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupAdLabel.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.adGroupAd != null && message.hasOwnProperty("adGroupAd"))
                                $root.google.protobuf.StringValue.encode(message.adGroupAd, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.label != null && message.hasOwnProperty("label"))
                                $root.google.protobuf.StringValue.encode(message.label, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupAdLabel message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupAdLabel.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupAdLabel} message AdGroupAdLabel message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupAdLabel.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupAdLabel message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdLabel
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AdGroupAdLabel} AdGroupAdLabel
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupAdLabel.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AdGroupAdLabel();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.adGroupAd = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.label = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupAdLabel message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdLabel
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AdGroupAdLabel} AdGroupAdLabel
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupAdLabel.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupAdLabel message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdLabel
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupAdLabel.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.adGroupAd != null && message.hasOwnProperty("adGroupAd")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adGroupAd);
                                if (error)
                                    return "adGroupAd." + error;
                            }
                            if (message.label != null && message.hasOwnProperty("label")) {
                                var error = $root.google.protobuf.StringValue.verify(message.label);
                                if (error)
                                    return "label." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an AdGroupAdLabel message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdLabel
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AdGroupAdLabel} AdGroupAdLabel
                         */
                        AdGroupAdLabel.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AdGroupAdLabel)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AdGroupAdLabel();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.adGroupAd != null) {
                                if (typeof object.adGroupAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupAdLabel.adGroupAd: object expected");
                                message.adGroupAd = $root.google.protobuf.StringValue.fromObject(object.adGroupAd);
                            }
                            if (object.label != null) {
                                if (typeof object.label !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupAdLabel.label: object expected");
                                message.label = $root.google.protobuf.StringValue.fromObject(object.label);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupAdLabel message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.AdGroupAdLabel} message AdGroupAdLabel
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupAdLabel.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.adGroupAd = null;
                                object.label = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.adGroupAd != null && message.hasOwnProperty("adGroupAd"))
                                object.adGroupAd = $root.google.protobuf.StringValue.toObject(message.adGroupAd, options);
                            if (message.label != null && message.hasOwnProperty("label"))
                                object.label = $root.google.protobuf.StringValue.toObject(message.label, options);
                            return object;
                        };

                        /**
                         * Converts this AdGroupAdLabel to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AdGroupAdLabel
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupAdLabel.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupAdLabel;
                    })();

                    resources.AdGroupAudienceView = (function() {

                        /**
                         * Properties of an AdGroupAudienceView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAdGroupAudienceView
                         * @property {string|null} [resourceName] AdGroupAudienceView resourceName
                         */

                        /**
                         * Constructs a new AdGroupAudienceView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AdGroupAudienceView.
                         * @implements IAdGroupAudienceView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAdGroupAudienceView=} [properties] Properties to set
                         */
                        function AdGroupAudienceView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupAudienceView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.AdGroupAudienceView
                         * @instance
                         */
                        AdGroupAudienceView.prototype.resourceName = "";

                        /**
                         * Creates a new AdGroupAudienceView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AdGroupAudienceView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupAudienceView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AdGroupAudienceView} AdGroupAudienceView instance
                         */
                        AdGroupAudienceView.create = function create(properties) {
                            return new AdGroupAudienceView(properties);
                        };

                        /**
                         * Encodes the specified AdGroupAudienceView message. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupAudienceView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AdGroupAudienceView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupAudienceView} message AdGroupAudienceView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupAudienceView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupAudienceView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupAudienceView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupAudienceView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupAudienceView} message AdGroupAudienceView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupAudienceView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupAudienceView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AdGroupAudienceView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AdGroupAudienceView} AdGroupAudienceView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupAudienceView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AdGroupAudienceView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupAudienceView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupAudienceView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AdGroupAudienceView} AdGroupAudienceView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupAudienceView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupAudienceView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AdGroupAudienceView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupAudienceView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates an AdGroupAudienceView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupAudienceView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AdGroupAudienceView} AdGroupAudienceView
                         */
                        AdGroupAudienceView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AdGroupAudienceView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AdGroupAudienceView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupAudienceView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupAudienceView
                         * @static
                         * @param {google.ads.googleads.v1.resources.AdGroupAudienceView} message AdGroupAudienceView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupAudienceView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this AdGroupAudienceView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AdGroupAudienceView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupAudienceView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupAudienceView;
                    })();

                    resources.AdGroupBidModifier = (function() {

                        /**
                         * Properties of an AdGroupBidModifier.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAdGroupBidModifier
                         * @property {string|null} [resourceName] AdGroupBidModifier resourceName
                         * @property {google.protobuf.IStringValue|null} [adGroup] AdGroupBidModifier adGroup
                         * @property {google.protobuf.IInt64Value|null} [criterionId] AdGroupBidModifier criterionId
                         * @property {google.protobuf.IDoubleValue|null} [bidModifier] AdGroupBidModifier bidModifier
                         * @property {google.protobuf.IStringValue|null} [baseAdGroup] AdGroupBidModifier baseAdGroup
                         * @property {google.ads.googleads.v1.enums.BidModifierSourceEnum.BidModifierSource|null} [bidModifierSource] AdGroupBidModifier bidModifierSource
                         * @property {google.ads.googleads.v1.common.IHotelDateSelectionTypeInfo|null} [hotelDateSelectionType] AdGroupBidModifier hotelDateSelectionType
                         * @property {google.ads.googleads.v1.common.IHotelAdvanceBookingWindowInfo|null} [hotelAdvanceBookingWindow] AdGroupBidModifier hotelAdvanceBookingWindow
                         * @property {google.ads.googleads.v1.common.IHotelLengthOfStayInfo|null} [hotelLengthOfStay] AdGroupBidModifier hotelLengthOfStay
                         * @property {google.ads.googleads.v1.common.IHotelCheckInDayInfo|null} [hotelCheckInDay] AdGroupBidModifier hotelCheckInDay
                         * @property {google.ads.googleads.v1.common.IDeviceInfo|null} [device] AdGroupBidModifier device
                         * @property {google.ads.googleads.v1.common.IPreferredContentInfo|null} [preferredContent] AdGroupBidModifier preferredContent
                         */

                        /**
                         * Constructs a new AdGroupBidModifier.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AdGroupBidModifier.
                         * @implements IAdGroupBidModifier
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAdGroupBidModifier=} [properties] Properties to set
                         */
                        function AdGroupBidModifier(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupBidModifier resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @instance
                         */
                        AdGroupBidModifier.prototype.resourceName = "";

                        /**
                         * AdGroupBidModifier adGroup.
                         * @member {google.protobuf.IStringValue|null|undefined} adGroup
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @instance
                         */
                        AdGroupBidModifier.prototype.adGroup = null;

                        /**
                         * AdGroupBidModifier criterionId.
                         * @member {google.protobuf.IInt64Value|null|undefined} criterionId
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @instance
                         */
                        AdGroupBidModifier.prototype.criterionId = null;

                        /**
                         * AdGroupBidModifier bidModifier.
                         * @member {google.protobuf.IDoubleValue|null|undefined} bidModifier
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @instance
                         */
                        AdGroupBidModifier.prototype.bidModifier = null;

                        /**
                         * AdGroupBidModifier baseAdGroup.
                         * @member {google.protobuf.IStringValue|null|undefined} baseAdGroup
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @instance
                         */
                        AdGroupBidModifier.prototype.baseAdGroup = null;

                        /**
                         * AdGroupBidModifier bidModifierSource.
                         * @member {google.ads.googleads.v1.enums.BidModifierSourceEnum.BidModifierSource} bidModifierSource
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @instance
                         */
                        AdGroupBidModifier.prototype.bidModifierSource = 0;

                        /**
                         * AdGroupBidModifier hotelDateSelectionType.
                         * @member {google.ads.googleads.v1.common.IHotelDateSelectionTypeInfo|null|undefined} hotelDateSelectionType
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @instance
                         */
                        AdGroupBidModifier.prototype.hotelDateSelectionType = null;

                        /**
                         * AdGroupBidModifier hotelAdvanceBookingWindow.
                         * @member {google.ads.googleads.v1.common.IHotelAdvanceBookingWindowInfo|null|undefined} hotelAdvanceBookingWindow
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @instance
                         */
                        AdGroupBidModifier.prototype.hotelAdvanceBookingWindow = null;

                        /**
                         * AdGroupBidModifier hotelLengthOfStay.
                         * @member {google.ads.googleads.v1.common.IHotelLengthOfStayInfo|null|undefined} hotelLengthOfStay
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @instance
                         */
                        AdGroupBidModifier.prototype.hotelLengthOfStay = null;

                        /**
                         * AdGroupBidModifier hotelCheckInDay.
                         * @member {google.ads.googleads.v1.common.IHotelCheckInDayInfo|null|undefined} hotelCheckInDay
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @instance
                         */
                        AdGroupBidModifier.prototype.hotelCheckInDay = null;

                        /**
                         * AdGroupBidModifier device.
                         * @member {google.ads.googleads.v1.common.IDeviceInfo|null|undefined} device
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @instance
                         */
                        AdGroupBidModifier.prototype.device = null;

                        /**
                         * AdGroupBidModifier preferredContent.
                         * @member {google.ads.googleads.v1.common.IPreferredContentInfo|null|undefined} preferredContent
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @instance
                         */
                        AdGroupBidModifier.prototype.preferredContent = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AdGroupBidModifier criterion.
                         * @member {"hotelDateSelectionType"|"hotelAdvanceBookingWindow"|"hotelLengthOfStay"|"hotelCheckInDay"|"device"|"preferredContent"|undefined} criterion
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @instance
                         */
                        Object.defineProperty(AdGroupBidModifier.prototype, "criterion", {
                            get: $util.oneOfGetter($oneOfFields = ["hotelDateSelectionType", "hotelAdvanceBookingWindow", "hotelLengthOfStay", "hotelCheckInDay", "device", "preferredContent"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AdGroupBidModifier instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupBidModifier=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AdGroupBidModifier} AdGroupBidModifier instance
                         */
                        AdGroupBidModifier.create = function create(properties) {
                            return new AdGroupBidModifier(properties);
                        };

                        /**
                         * Encodes the specified AdGroupBidModifier message. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupBidModifier.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupBidModifier} message AdGroupBidModifier message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupBidModifier.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                $root.google.protobuf.StringValue.encode(message.adGroup, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.criterionId != null && message.hasOwnProperty("criterionId"))
                                $root.google.protobuf.Int64Value.encode(message.criterionId, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.bidModifier != null && message.hasOwnProperty("bidModifier"))
                                $root.google.protobuf.DoubleValue.encode(message.bidModifier, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.hotelDateSelectionType != null && message.hasOwnProperty("hotelDateSelectionType"))
                                $root.google.ads.googleads.v1.common.HotelDateSelectionTypeInfo.encode(message.hotelDateSelectionType, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.hotelAdvanceBookingWindow != null && message.hasOwnProperty("hotelAdvanceBookingWindow"))
                                $root.google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo.encode(message.hotelAdvanceBookingWindow, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.hotelLengthOfStay != null && message.hasOwnProperty("hotelLengthOfStay"))
                                $root.google.ads.googleads.v1.common.HotelLengthOfStayInfo.encode(message.hotelLengthOfStay, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.hotelCheckInDay != null && message.hasOwnProperty("hotelCheckInDay"))
                                $root.google.ads.googleads.v1.common.HotelCheckInDayInfo.encode(message.hotelCheckInDay, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.baseAdGroup != null && message.hasOwnProperty("baseAdGroup"))
                                $root.google.protobuf.StringValue.encode(message.baseAdGroup, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.bidModifierSource != null && message.hasOwnProperty("bidModifierSource"))
                                writer.uint32(/* id 10, wireType 0 =*/80).int32(message.bidModifierSource);
                            if (message.device != null && message.hasOwnProperty("device"))
                                $root.google.ads.googleads.v1.common.DeviceInfo.encode(message.device, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.preferredContent != null && message.hasOwnProperty("preferredContent"))
                                $root.google.ads.googleads.v1.common.PreferredContentInfo.encode(message.preferredContent, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupBidModifier message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupBidModifier.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupBidModifier} message AdGroupBidModifier message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupBidModifier.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupBidModifier message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AdGroupBidModifier} AdGroupBidModifier
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupBidModifier.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AdGroupBidModifier();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.adGroup = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.criterionId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.bidModifier = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.baseAdGroup = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.bidModifierSource = reader.int32();
                                    break;
                                case 5:
                                    message.hotelDateSelectionType = $root.google.ads.googleads.v1.common.HotelDateSelectionTypeInfo.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.hotelAdvanceBookingWindow = $root.google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.hotelLengthOfStay = $root.google.ads.googleads.v1.common.HotelLengthOfStayInfo.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.hotelCheckInDay = $root.google.ads.googleads.v1.common.HotelCheckInDayInfo.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.device = $root.google.ads.googleads.v1.common.DeviceInfo.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.preferredContent = $root.google.ads.googleads.v1.common.PreferredContentInfo.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupBidModifier message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AdGroupBidModifier} AdGroupBidModifier
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupBidModifier.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupBidModifier message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupBidModifier.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.adGroup != null && message.hasOwnProperty("adGroup")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adGroup);
                                if (error)
                                    return "adGroup." + error;
                            }
                            if (message.criterionId != null && message.hasOwnProperty("criterionId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.criterionId);
                                if (error)
                                    return "criterionId." + error;
                            }
                            if (message.bidModifier != null && message.hasOwnProperty("bidModifier")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.bidModifier);
                                if (error)
                                    return "bidModifier." + error;
                            }
                            if (message.baseAdGroup != null && message.hasOwnProperty("baseAdGroup")) {
                                var error = $root.google.protobuf.StringValue.verify(message.baseAdGroup);
                                if (error)
                                    return "baseAdGroup." + error;
                            }
                            if (message.bidModifierSource != null && message.hasOwnProperty("bidModifierSource"))
                                switch (message.bidModifierSource) {
                                default:
                                    return "bidModifierSource: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.hotelDateSelectionType != null && message.hasOwnProperty("hotelDateSelectionType")) {
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.HotelDateSelectionTypeInfo.verify(message.hotelDateSelectionType);
                                    if (error)
                                        return "hotelDateSelectionType." + error;
                                }
                            }
                            if (message.hotelAdvanceBookingWindow != null && message.hasOwnProperty("hotelAdvanceBookingWindow")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo.verify(message.hotelAdvanceBookingWindow);
                                    if (error)
                                        return "hotelAdvanceBookingWindow." + error;
                                }
                            }
                            if (message.hotelLengthOfStay != null && message.hasOwnProperty("hotelLengthOfStay")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.HotelLengthOfStayInfo.verify(message.hotelLengthOfStay);
                                    if (error)
                                        return "hotelLengthOfStay." + error;
                                }
                            }
                            if (message.hotelCheckInDay != null && message.hasOwnProperty("hotelCheckInDay")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.HotelCheckInDayInfo.verify(message.hotelCheckInDay);
                                    if (error)
                                        return "hotelCheckInDay." + error;
                                }
                            }
                            if (message.device != null && message.hasOwnProperty("device")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.DeviceInfo.verify(message.device);
                                    if (error)
                                        return "device." + error;
                                }
                            }
                            if (message.preferredContent != null && message.hasOwnProperty("preferredContent")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.PreferredContentInfo.verify(message.preferredContent);
                                    if (error)
                                        return "preferredContent." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an AdGroupBidModifier message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AdGroupBidModifier} AdGroupBidModifier
                         */
                        AdGroupBidModifier.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AdGroupBidModifier)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AdGroupBidModifier();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.adGroup != null) {
                                if (typeof object.adGroup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupBidModifier.adGroup: object expected");
                                message.adGroup = $root.google.protobuf.StringValue.fromObject(object.adGroup);
                            }
                            if (object.criterionId != null) {
                                if (typeof object.criterionId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupBidModifier.criterionId: object expected");
                                message.criterionId = $root.google.protobuf.Int64Value.fromObject(object.criterionId);
                            }
                            if (object.bidModifier != null) {
                                if (typeof object.bidModifier !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupBidModifier.bidModifier: object expected");
                                message.bidModifier = $root.google.protobuf.DoubleValue.fromObject(object.bidModifier);
                            }
                            if (object.baseAdGroup != null) {
                                if (typeof object.baseAdGroup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupBidModifier.baseAdGroup: object expected");
                                message.baseAdGroup = $root.google.protobuf.StringValue.fromObject(object.baseAdGroup);
                            }
                            switch (object.bidModifierSource) {
                            case "UNSPECIFIED":
                            case 0:
                                message.bidModifierSource = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.bidModifierSource = 1;
                                break;
                            case "CAMPAIGN":
                            case 2:
                                message.bidModifierSource = 2;
                                break;
                            case "AD_GROUP":
                            case 3:
                                message.bidModifierSource = 3;
                                break;
                            }
                            if (object.hotelDateSelectionType != null) {
                                if (typeof object.hotelDateSelectionType !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupBidModifier.hotelDateSelectionType: object expected");
                                message.hotelDateSelectionType = $root.google.ads.googleads.v1.common.HotelDateSelectionTypeInfo.fromObject(object.hotelDateSelectionType);
                            }
                            if (object.hotelAdvanceBookingWindow != null) {
                                if (typeof object.hotelAdvanceBookingWindow !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupBidModifier.hotelAdvanceBookingWindow: object expected");
                                message.hotelAdvanceBookingWindow = $root.google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo.fromObject(object.hotelAdvanceBookingWindow);
                            }
                            if (object.hotelLengthOfStay != null) {
                                if (typeof object.hotelLengthOfStay !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupBidModifier.hotelLengthOfStay: object expected");
                                message.hotelLengthOfStay = $root.google.ads.googleads.v1.common.HotelLengthOfStayInfo.fromObject(object.hotelLengthOfStay);
                            }
                            if (object.hotelCheckInDay != null) {
                                if (typeof object.hotelCheckInDay !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupBidModifier.hotelCheckInDay: object expected");
                                message.hotelCheckInDay = $root.google.ads.googleads.v1.common.HotelCheckInDayInfo.fromObject(object.hotelCheckInDay);
                            }
                            if (object.device != null) {
                                if (typeof object.device !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupBidModifier.device: object expected");
                                message.device = $root.google.ads.googleads.v1.common.DeviceInfo.fromObject(object.device);
                            }
                            if (object.preferredContent != null) {
                                if (typeof object.preferredContent !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupBidModifier.preferredContent: object expected");
                                message.preferredContent = $root.google.ads.googleads.v1.common.PreferredContentInfo.fromObject(object.preferredContent);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupBidModifier message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @static
                         * @param {google.ads.googleads.v1.resources.AdGroupBidModifier} message AdGroupBidModifier
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupBidModifier.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.adGroup = null;
                                object.criterionId = null;
                                object.bidModifier = null;
                                object.baseAdGroup = null;
                                object.bidModifierSource = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                object.adGroup = $root.google.protobuf.StringValue.toObject(message.adGroup, options);
                            if (message.criterionId != null && message.hasOwnProperty("criterionId"))
                                object.criterionId = $root.google.protobuf.Int64Value.toObject(message.criterionId, options);
                            if (message.bidModifier != null && message.hasOwnProperty("bidModifier"))
                                object.bidModifier = $root.google.protobuf.DoubleValue.toObject(message.bidModifier, options);
                            if (message.hotelDateSelectionType != null && message.hasOwnProperty("hotelDateSelectionType")) {
                                object.hotelDateSelectionType = $root.google.ads.googleads.v1.common.HotelDateSelectionTypeInfo.toObject(message.hotelDateSelectionType, options);
                                if (options.oneofs)
                                    object.criterion = "hotelDateSelectionType";
                            }
                            if (message.hotelAdvanceBookingWindow != null && message.hasOwnProperty("hotelAdvanceBookingWindow")) {
                                object.hotelAdvanceBookingWindow = $root.google.ads.googleads.v1.common.HotelAdvanceBookingWindowInfo.toObject(message.hotelAdvanceBookingWindow, options);
                                if (options.oneofs)
                                    object.criterion = "hotelAdvanceBookingWindow";
                            }
                            if (message.hotelLengthOfStay != null && message.hasOwnProperty("hotelLengthOfStay")) {
                                object.hotelLengthOfStay = $root.google.ads.googleads.v1.common.HotelLengthOfStayInfo.toObject(message.hotelLengthOfStay, options);
                                if (options.oneofs)
                                    object.criterion = "hotelLengthOfStay";
                            }
                            if (message.hotelCheckInDay != null && message.hasOwnProperty("hotelCheckInDay")) {
                                object.hotelCheckInDay = $root.google.ads.googleads.v1.common.HotelCheckInDayInfo.toObject(message.hotelCheckInDay, options);
                                if (options.oneofs)
                                    object.criterion = "hotelCheckInDay";
                            }
                            if (message.baseAdGroup != null && message.hasOwnProperty("baseAdGroup"))
                                object.baseAdGroup = $root.google.protobuf.StringValue.toObject(message.baseAdGroup, options);
                            if (message.bidModifierSource != null && message.hasOwnProperty("bidModifierSource"))
                                object.bidModifierSource = options.enums === String ? $root.google.ads.googleads.v1.enums.BidModifierSourceEnum.BidModifierSource[message.bidModifierSource] : message.bidModifierSource;
                            if (message.device != null && message.hasOwnProperty("device")) {
                                object.device = $root.google.ads.googleads.v1.common.DeviceInfo.toObject(message.device, options);
                                if (options.oneofs)
                                    object.criterion = "device";
                            }
                            if (message.preferredContent != null && message.hasOwnProperty("preferredContent")) {
                                object.preferredContent = $root.google.ads.googleads.v1.common.PreferredContentInfo.toObject(message.preferredContent, options);
                                if (options.oneofs)
                                    object.criterion = "preferredContent";
                            }
                            return object;
                        };

                        /**
                         * Converts this AdGroupBidModifier to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AdGroupBidModifier
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupBidModifier.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupBidModifier;
                    })();

                    resources.AdGroupCriterion = (function() {

                        /**
                         * Properties of an AdGroupCriterion.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAdGroupCriterion
                         * @property {string|null} [resourceName] AdGroupCriterion resourceName
                         * @property {google.protobuf.IInt64Value|null} [criterionId] AdGroupCriterion criterionId
                         * @property {google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum.AdGroupCriterionStatus|null} [status] AdGroupCriterion status
                         * @property {google.ads.googleads.v1.resources.AdGroupCriterion.IQualityInfo|null} [qualityInfo] AdGroupCriterion qualityInfo
                         * @property {google.protobuf.IStringValue|null} [adGroup] AdGroupCriterion adGroup
                         * @property {google.ads.googleads.v1.enums.CriterionTypeEnum.CriterionType|null} [type] AdGroupCriterion type
                         * @property {google.protobuf.IBoolValue|null} [negative] AdGroupCriterion negative
                         * @property {google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum.CriterionSystemServingStatus|null} [systemServingStatus] AdGroupCriterion systemServingStatus
                         * @property {google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum.AdGroupCriterionApprovalStatus|null} [approvalStatus] AdGroupCriterion approvalStatus
                         * @property {google.protobuf.IDoubleValue|null} [bidModifier] AdGroupCriterion bidModifier
                         * @property {google.protobuf.IInt64Value|null} [cpcBidMicros] AdGroupCriterion cpcBidMicros
                         * @property {google.protobuf.IInt64Value|null} [cpmBidMicros] AdGroupCriterion cpmBidMicros
                         * @property {google.protobuf.IInt64Value|null} [cpvBidMicros] AdGroupCriterion cpvBidMicros
                         * @property {google.protobuf.IInt64Value|null} [percentCpcBidMicros] AdGroupCriterion percentCpcBidMicros
                         * @property {google.protobuf.IInt64Value|null} [effectiveCpcBidMicros] AdGroupCriterion effectiveCpcBidMicros
                         * @property {google.protobuf.IInt64Value|null} [effectiveCpmBidMicros] AdGroupCriterion effectiveCpmBidMicros
                         * @property {google.protobuf.IInt64Value|null} [effectiveCpvBidMicros] AdGroupCriterion effectiveCpvBidMicros
                         * @property {google.protobuf.IInt64Value|null} [effectivePercentCpcBidMicros] AdGroupCriterion effectivePercentCpcBidMicros
                         * @property {google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource|null} [effectiveCpcBidSource] AdGroupCriterion effectiveCpcBidSource
                         * @property {google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource|null} [effectiveCpmBidSource] AdGroupCriterion effectiveCpmBidSource
                         * @property {google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource|null} [effectiveCpvBidSource] AdGroupCriterion effectiveCpvBidSource
                         * @property {google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource|null} [effectivePercentCpcBidSource] AdGroupCriterion effectivePercentCpcBidSource
                         * @property {google.ads.googleads.v1.resources.AdGroupCriterion.IPositionEstimates|null} [positionEstimates] AdGroupCriterion positionEstimates
                         * @property {Array.<google.protobuf.IStringValue>|null} [finalUrls] AdGroupCriterion finalUrls
                         * @property {Array.<google.protobuf.IStringValue>|null} [finalMobileUrls] AdGroupCriterion finalMobileUrls
                         * @property {google.protobuf.IStringValue|null} [finalUrlSuffix] AdGroupCriterion finalUrlSuffix
                         * @property {google.protobuf.IStringValue|null} [trackingUrlTemplate] AdGroupCriterion trackingUrlTemplate
                         * @property {Array.<google.ads.googleads.v1.common.ICustomParameter>|null} [urlCustomParameters] AdGroupCriterion urlCustomParameters
                         * @property {google.ads.googleads.v1.common.IKeywordInfo|null} [keyword] AdGroupCriterion keyword
                         * @property {google.ads.googleads.v1.common.IPlacementInfo|null} [placement] AdGroupCriterion placement
                         * @property {google.ads.googleads.v1.common.IMobileAppCategoryInfo|null} [mobileAppCategory] AdGroupCriterion mobileAppCategory
                         * @property {google.ads.googleads.v1.common.IMobileApplicationInfo|null} [mobileApplication] AdGroupCriterion mobileApplication
                         * @property {google.ads.googleads.v1.common.IListingGroupInfo|null} [listingGroup] AdGroupCriterion listingGroup
                         * @property {google.ads.googleads.v1.common.IAgeRangeInfo|null} [ageRange] AdGroupCriterion ageRange
                         * @property {google.ads.googleads.v1.common.IGenderInfo|null} [gender] AdGroupCriterion gender
                         * @property {google.ads.googleads.v1.common.IIncomeRangeInfo|null} [incomeRange] AdGroupCriterion incomeRange
                         * @property {google.ads.googleads.v1.common.IParentalStatusInfo|null} [parentalStatus] AdGroupCriterion parentalStatus
                         * @property {google.ads.googleads.v1.common.IUserListInfo|null} [userList] AdGroupCriterion userList
                         * @property {google.ads.googleads.v1.common.IYouTubeVideoInfo|null} [youtubeVideo] AdGroupCriterion youtubeVideo
                         * @property {google.ads.googleads.v1.common.IYouTubeChannelInfo|null} [youtubeChannel] AdGroupCriterion youtubeChannel
                         * @property {google.ads.googleads.v1.common.ITopicInfo|null} [topic] AdGroupCriterion topic
                         * @property {google.ads.googleads.v1.common.IUserInterestInfo|null} [userInterest] AdGroupCriterion userInterest
                         * @property {google.ads.googleads.v1.common.IWebpageInfo|null} [webpage] AdGroupCriterion webpage
                         * @property {google.ads.googleads.v1.common.IAppPaymentModelInfo|null} [appPaymentModel] AdGroupCriterion appPaymentModel
                         * @property {google.ads.googleads.v1.common.ICustomAffinityInfo|null} [customAffinity] AdGroupCriterion customAffinity
                         * @property {google.ads.googleads.v1.common.ICustomIntentInfo|null} [customIntent] AdGroupCriterion customIntent
                         */

                        /**
                         * Constructs a new AdGroupCriterion.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AdGroupCriterion.
                         * @implements IAdGroupCriterion
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAdGroupCriterion=} [properties] Properties to set
                         */
                        function AdGroupCriterion(properties) {
                            this.finalUrls = [];
                            this.finalMobileUrls = [];
                            this.urlCustomParameters = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupCriterion resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.resourceName = "";

                        /**
                         * AdGroupCriterion criterionId.
                         * @member {google.protobuf.IInt64Value|null|undefined} criterionId
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.criterionId = null;

                        /**
                         * AdGroupCriterion status.
                         * @member {google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum.AdGroupCriterionStatus} status
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.status = 0;

                        /**
                         * AdGroupCriterion qualityInfo.
                         * @member {google.ads.googleads.v1.resources.AdGroupCriterion.IQualityInfo|null|undefined} qualityInfo
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.qualityInfo = null;

                        /**
                         * AdGroupCriterion adGroup.
                         * @member {google.protobuf.IStringValue|null|undefined} adGroup
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.adGroup = null;

                        /**
                         * AdGroupCriterion type.
                         * @member {google.ads.googleads.v1.enums.CriterionTypeEnum.CriterionType} type
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.type = 0;

                        /**
                         * AdGroupCriterion negative.
                         * @member {google.protobuf.IBoolValue|null|undefined} negative
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.negative = null;

                        /**
                         * AdGroupCriterion systemServingStatus.
                         * @member {google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum.CriterionSystemServingStatus} systemServingStatus
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.systemServingStatus = 0;

                        /**
                         * AdGroupCriterion approvalStatus.
                         * @member {google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum.AdGroupCriterionApprovalStatus} approvalStatus
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.approvalStatus = 0;

                        /**
                         * AdGroupCriterion bidModifier.
                         * @member {google.protobuf.IDoubleValue|null|undefined} bidModifier
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.bidModifier = null;

                        /**
                         * AdGroupCriterion cpcBidMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpcBidMicros
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.cpcBidMicros = null;

                        /**
                         * AdGroupCriterion cpmBidMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpmBidMicros
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.cpmBidMicros = null;

                        /**
                         * AdGroupCriterion cpvBidMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpvBidMicros
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.cpvBidMicros = null;

                        /**
                         * AdGroupCriterion percentCpcBidMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} percentCpcBidMicros
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.percentCpcBidMicros = null;

                        /**
                         * AdGroupCriterion effectiveCpcBidMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} effectiveCpcBidMicros
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.effectiveCpcBidMicros = null;

                        /**
                         * AdGroupCriterion effectiveCpmBidMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} effectiveCpmBidMicros
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.effectiveCpmBidMicros = null;

                        /**
                         * AdGroupCriterion effectiveCpvBidMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} effectiveCpvBidMicros
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.effectiveCpvBidMicros = null;

                        /**
                         * AdGroupCriterion effectivePercentCpcBidMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} effectivePercentCpcBidMicros
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.effectivePercentCpcBidMicros = null;

                        /**
                         * AdGroupCriterion effectiveCpcBidSource.
                         * @member {google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource} effectiveCpcBidSource
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.effectiveCpcBidSource = 0;

                        /**
                         * AdGroupCriterion effectiveCpmBidSource.
                         * @member {google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource} effectiveCpmBidSource
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.effectiveCpmBidSource = 0;

                        /**
                         * AdGroupCriterion effectiveCpvBidSource.
                         * @member {google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource} effectiveCpvBidSource
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.effectiveCpvBidSource = 0;

                        /**
                         * AdGroupCriterion effectivePercentCpcBidSource.
                         * @member {google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource} effectivePercentCpcBidSource
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.effectivePercentCpcBidSource = 0;

                        /**
                         * AdGroupCriterion positionEstimates.
                         * @member {google.ads.googleads.v1.resources.AdGroupCriterion.IPositionEstimates|null|undefined} positionEstimates
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.positionEstimates = null;

                        /**
                         * AdGroupCriterion finalUrls.
                         * @member {Array.<google.protobuf.IStringValue>} finalUrls
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.finalUrls = $util.emptyArray;

                        /**
                         * AdGroupCriterion finalMobileUrls.
                         * @member {Array.<google.protobuf.IStringValue>} finalMobileUrls
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.finalMobileUrls = $util.emptyArray;

                        /**
                         * AdGroupCriterion finalUrlSuffix.
                         * @member {google.protobuf.IStringValue|null|undefined} finalUrlSuffix
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.finalUrlSuffix = null;

                        /**
                         * AdGroupCriterion trackingUrlTemplate.
                         * @member {google.protobuf.IStringValue|null|undefined} trackingUrlTemplate
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.trackingUrlTemplate = null;

                        /**
                         * AdGroupCriterion urlCustomParameters.
                         * @member {Array.<google.ads.googleads.v1.common.ICustomParameter>} urlCustomParameters
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.urlCustomParameters = $util.emptyArray;

                        /**
                         * AdGroupCriterion keyword.
                         * @member {google.ads.googleads.v1.common.IKeywordInfo|null|undefined} keyword
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.keyword = null;

                        /**
                         * AdGroupCriterion placement.
                         * @member {google.ads.googleads.v1.common.IPlacementInfo|null|undefined} placement
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.placement = null;

                        /**
                         * AdGroupCriterion mobileAppCategory.
                         * @member {google.ads.googleads.v1.common.IMobileAppCategoryInfo|null|undefined} mobileAppCategory
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.mobileAppCategory = null;

                        /**
                         * AdGroupCriterion mobileApplication.
                         * @member {google.ads.googleads.v1.common.IMobileApplicationInfo|null|undefined} mobileApplication
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.mobileApplication = null;

                        /**
                         * AdGroupCriterion listingGroup.
                         * @member {google.ads.googleads.v1.common.IListingGroupInfo|null|undefined} listingGroup
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.listingGroup = null;

                        /**
                         * AdGroupCriterion ageRange.
                         * @member {google.ads.googleads.v1.common.IAgeRangeInfo|null|undefined} ageRange
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.ageRange = null;

                        /**
                         * AdGroupCriterion gender.
                         * @member {google.ads.googleads.v1.common.IGenderInfo|null|undefined} gender
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.gender = null;

                        /**
                         * AdGroupCriterion incomeRange.
                         * @member {google.ads.googleads.v1.common.IIncomeRangeInfo|null|undefined} incomeRange
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.incomeRange = null;

                        /**
                         * AdGroupCriterion parentalStatus.
                         * @member {google.ads.googleads.v1.common.IParentalStatusInfo|null|undefined} parentalStatus
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.parentalStatus = null;

                        /**
                         * AdGroupCriterion userList.
                         * @member {google.ads.googleads.v1.common.IUserListInfo|null|undefined} userList
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.userList = null;

                        /**
                         * AdGroupCriterion youtubeVideo.
                         * @member {google.ads.googleads.v1.common.IYouTubeVideoInfo|null|undefined} youtubeVideo
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.youtubeVideo = null;

                        /**
                         * AdGroupCriterion youtubeChannel.
                         * @member {google.ads.googleads.v1.common.IYouTubeChannelInfo|null|undefined} youtubeChannel
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.youtubeChannel = null;

                        /**
                         * AdGroupCriterion topic.
                         * @member {google.ads.googleads.v1.common.ITopicInfo|null|undefined} topic
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.topic = null;

                        /**
                         * AdGroupCriterion userInterest.
                         * @member {google.ads.googleads.v1.common.IUserInterestInfo|null|undefined} userInterest
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.userInterest = null;

                        /**
                         * AdGroupCriterion webpage.
                         * @member {google.ads.googleads.v1.common.IWebpageInfo|null|undefined} webpage
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.webpage = null;

                        /**
                         * AdGroupCriterion appPaymentModel.
                         * @member {google.ads.googleads.v1.common.IAppPaymentModelInfo|null|undefined} appPaymentModel
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.appPaymentModel = null;

                        /**
                         * AdGroupCriterion customAffinity.
                         * @member {google.ads.googleads.v1.common.ICustomAffinityInfo|null|undefined} customAffinity
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.customAffinity = null;

                        /**
                         * AdGroupCriterion customIntent.
                         * @member {google.ads.googleads.v1.common.ICustomIntentInfo|null|undefined} customIntent
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        AdGroupCriterion.prototype.customIntent = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AdGroupCriterion criterion.
                         * @member {"keyword"|"placement"|"mobileAppCategory"|"mobileApplication"|"listingGroup"|"ageRange"|"gender"|"incomeRange"|"parentalStatus"|"userList"|"youtubeVideo"|"youtubeChannel"|"topic"|"userInterest"|"webpage"|"appPaymentModel"|"customAffinity"|"customIntent"|undefined} criterion
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         */
                        Object.defineProperty(AdGroupCriterion.prototype, "criterion", {
                            get: $util.oneOfGetter($oneOfFields = ["keyword", "placement", "mobileAppCategory", "mobileApplication", "listingGroup", "ageRange", "gender", "incomeRange", "parentalStatus", "userList", "youtubeVideo", "youtubeChannel", "topic", "userInterest", "webpage", "appPaymentModel", "customAffinity", "customIntent"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AdGroupCriterion instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupCriterion=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AdGroupCriterion} AdGroupCriterion instance
                         */
                        AdGroupCriterion.create = function create(properties) {
                            return new AdGroupCriterion(properties);
                        };

                        /**
                         * Encodes the specified AdGroupCriterion message. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupCriterion.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupCriterion} message AdGroupCriterion message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupCriterion.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.status);
                            if (message.qualityInfo != null && message.hasOwnProperty("qualityInfo"))
                                $root.google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo.encode(message.qualityInfo, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                $root.google.protobuf.StringValue.encode(message.adGroup, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.positionEstimates != null && message.hasOwnProperty("positionEstimates"))
                                $root.google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates.encode(message.positionEstimates, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.finalUrls != null && message.finalUrls.length)
                                for (var i = 0; i < message.finalUrls.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.finalUrls[i], writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                $root.google.protobuf.StringValue.encode(message.trackingUrlTemplate, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                            if (message.urlCustomParameters != null && message.urlCustomParameters.length)
                                for (var i = 0; i < message.urlCustomParameters.length; ++i)
                                    $root.google.ads.googleads.v1.common.CustomParameter.encode(message.urlCustomParameters[i], writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpcBidMicros, writer.uint32(/* id 16, wireType 2 =*/130).fork()).ldelim();
                            if (message.cpmBidMicros != null && message.hasOwnProperty("cpmBidMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpmBidMicros, writer.uint32(/* id 17, wireType 2 =*/138).fork()).ldelim();
                            if (message.effectiveCpcBidMicros != null && message.hasOwnProperty("effectiveCpcBidMicros"))
                                $root.google.protobuf.Int64Value.encode(message.effectiveCpcBidMicros, writer.uint32(/* id 18, wireType 2 =*/146).fork()).ldelim();
                            if (message.effectiveCpmBidMicros != null && message.hasOwnProperty("effectiveCpmBidMicros"))
                                $root.google.protobuf.Int64Value.encode(message.effectiveCpmBidMicros, writer.uint32(/* id 19, wireType 2 =*/154).fork()).ldelim();
                            if (message.effectiveCpvBidMicros != null && message.hasOwnProperty("effectiveCpvBidMicros"))
                                $root.google.protobuf.Int64Value.encode(message.effectiveCpvBidMicros, writer.uint32(/* id 20, wireType 2 =*/162).fork()).ldelim();
                            if (message.effectiveCpcBidSource != null && message.hasOwnProperty("effectiveCpcBidSource"))
                                writer.uint32(/* id 21, wireType 0 =*/168).int32(message.effectiveCpcBidSource);
                            if (message.effectiveCpmBidSource != null && message.hasOwnProperty("effectiveCpmBidSource"))
                                writer.uint32(/* id 22, wireType 0 =*/176).int32(message.effectiveCpmBidSource);
                            if (message.effectiveCpvBidSource != null && message.hasOwnProperty("effectiveCpvBidSource"))
                                writer.uint32(/* id 23, wireType 0 =*/184).int32(message.effectiveCpvBidSource);
                            if (message.cpvBidMicros != null && message.hasOwnProperty("cpvBidMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpvBidMicros, writer.uint32(/* id 24, wireType 2 =*/194).fork()).ldelim();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 25, wireType 0 =*/200).int32(message.type);
                            if (message.criterionId != null && message.hasOwnProperty("criterionId"))
                                $root.google.protobuf.Int64Value.encode(message.criterionId, writer.uint32(/* id 26, wireType 2 =*/210).fork()).ldelim();
                            if (message.keyword != null && message.hasOwnProperty("keyword"))
                                $root.google.ads.googleads.v1.common.KeywordInfo.encode(message.keyword, writer.uint32(/* id 27, wireType 2 =*/218).fork()).ldelim();
                            if (message.placement != null && message.hasOwnProperty("placement"))
                                $root.google.ads.googleads.v1.common.PlacementInfo.encode(message.placement, writer.uint32(/* id 28, wireType 2 =*/226).fork()).ldelim();
                            if (message.mobileAppCategory != null && message.hasOwnProperty("mobileAppCategory"))
                                $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.encode(message.mobileAppCategory, writer.uint32(/* id 29, wireType 2 =*/234).fork()).ldelim();
                            if (message.mobileApplication != null && message.hasOwnProperty("mobileApplication"))
                                $root.google.ads.googleads.v1.common.MobileApplicationInfo.encode(message.mobileApplication, writer.uint32(/* id 30, wireType 2 =*/242).fork()).ldelim();
                            if (message.negative != null && message.hasOwnProperty("negative"))
                                $root.google.protobuf.BoolValue.encode(message.negative, writer.uint32(/* id 31, wireType 2 =*/250).fork()).ldelim();
                            if (message.listingGroup != null && message.hasOwnProperty("listingGroup"))
                                $root.google.ads.googleads.v1.common.ListingGroupInfo.encode(message.listingGroup, writer.uint32(/* id 32, wireType 2 =*/258).fork()).ldelim();
                            if (message.percentCpcBidMicros != null && message.hasOwnProperty("percentCpcBidMicros"))
                                $root.google.protobuf.Int64Value.encode(message.percentCpcBidMicros, writer.uint32(/* id 33, wireType 2 =*/266).fork()).ldelim();
                            if (message.effectivePercentCpcBidMicros != null && message.hasOwnProperty("effectivePercentCpcBidMicros"))
                                $root.google.protobuf.Int64Value.encode(message.effectivePercentCpcBidMicros, writer.uint32(/* id 34, wireType 2 =*/274).fork()).ldelim();
                            if (message.effectivePercentCpcBidSource != null && message.hasOwnProperty("effectivePercentCpcBidSource"))
                                writer.uint32(/* id 35, wireType 0 =*/280).int32(message.effectivePercentCpcBidSource);
                            if (message.ageRange != null && message.hasOwnProperty("ageRange"))
                                $root.google.ads.googleads.v1.common.AgeRangeInfo.encode(message.ageRange, writer.uint32(/* id 36, wireType 2 =*/290).fork()).ldelim();
                            if (message.gender != null && message.hasOwnProperty("gender"))
                                $root.google.ads.googleads.v1.common.GenderInfo.encode(message.gender, writer.uint32(/* id 37, wireType 2 =*/298).fork()).ldelim();
                            if (message.incomeRange != null && message.hasOwnProperty("incomeRange"))
                                $root.google.ads.googleads.v1.common.IncomeRangeInfo.encode(message.incomeRange, writer.uint32(/* id 38, wireType 2 =*/306).fork()).ldelim();
                            if (message.parentalStatus != null && message.hasOwnProperty("parentalStatus"))
                                $root.google.ads.googleads.v1.common.ParentalStatusInfo.encode(message.parentalStatus, writer.uint32(/* id 39, wireType 2 =*/314).fork()).ldelim();
                            if (message.youtubeVideo != null && message.hasOwnProperty("youtubeVideo"))
                                $root.google.ads.googleads.v1.common.YouTubeVideoInfo.encode(message.youtubeVideo, writer.uint32(/* id 40, wireType 2 =*/322).fork()).ldelim();
                            if (message.youtubeChannel != null && message.hasOwnProperty("youtubeChannel"))
                                $root.google.ads.googleads.v1.common.YouTubeChannelInfo.encode(message.youtubeChannel, writer.uint32(/* id 41, wireType 2 =*/330).fork()).ldelim();
                            if (message.userList != null && message.hasOwnProperty("userList"))
                                $root.google.ads.googleads.v1.common.UserListInfo.encode(message.userList, writer.uint32(/* id 42, wireType 2 =*/338).fork()).ldelim();
                            if (message.topic != null && message.hasOwnProperty("topic"))
                                $root.google.ads.googleads.v1.common.TopicInfo.encode(message.topic, writer.uint32(/* id 43, wireType 2 =*/346).fork()).ldelim();
                            if (message.bidModifier != null && message.hasOwnProperty("bidModifier"))
                                $root.google.protobuf.DoubleValue.encode(message.bidModifier, writer.uint32(/* id 44, wireType 2 =*/354).fork()).ldelim();
                            if (message.userInterest != null && message.hasOwnProperty("userInterest"))
                                $root.google.ads.googleads.v1.common.UserInterestInfo.encode(message.userInterest, writer.uint32(/* id 45, wireType 2 =*/362).fork()).ldelim();
                            if (message.webpage != null && message.hasOwnProperty("webpage"))
                                $root.google.ads.googleads.v1.common.WebpageInfo.encode(message.webpage, writer.uint32(/* id 46, wireType 2 =*/370).fork()).ldelim();
                            if (message.appPaymentModel != null && message.hasOwnProperty("appPaymentModel"))
                                $root.google.ads.googleads.v1.common.AppPaymentModelInfo.encode(message.appPaymentModel, writer.uint32(/* id 47, wireType 2 =*/378).fork()).ldelim();
                            if (message.customAffinity != null && message.hasOwnProperty("customAffinity"))
                                $root.google.ads.googleads.v1.common.CustomAffinityInfo.encode(message.customAffinity, writer.uint32(/* id 48, wireType 2 =*/386).fork()).ldelim();
                            if (message.customIntent != null && message.hasOwnProperty("customIntent"))
                                $root.google.ads.googleads.v1.common.CustomIntentInfo.encode(message.customIntent, writer.uint32(/* id 49, wireType 2 =*/394).fork()).ldelim();
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix"))
                                $root.google.protobuf.StringValue.encode(message.finalUrlSuffix, writer.uint32(/* id 50, wireType 2 =*/402).fork()).ldelim();
                            if (message.finalMobileUrls != null && message.finalMobileUrls.length)
                                for (var i = 0; i < message.finalMobileUrls.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.finalMobileUrls[i], writer.uint32(/* id 51, wireType 2 =*/410).fork()).ldelim();
                            if (message.systemServingStatus != null && message.hasOwnProperty("systemServingStatus"))
                                writer.uint32(/* id 52, wireType 0 =*/416).int32(message.systemServingStatus);
                            if (message.approvalStatus != null && message.hasOwnProperty("approvalStatus"))
                                writer.uint32(/* id 53, wireType 0 =*/424).int32(message.approvalStatus);
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupCriterion message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupCriterion.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupCriterion} message AdGroupCriterion message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupCriterion.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupCriterion message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AdGroupCriterion} AdGroupCriterion
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupCriterion.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AdGroupCriterion();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 26:
                                    message.criterionId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.status = reader.int32();
                                    break;
                                case 4:
                                    message.qualityInfo = $root.google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.adGroup = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 25:
                                    message.type = reader.int32();
                                    break;
                                case 31:
                                    message.negative = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 52:
                                    message.systemServingStatus = reader.int32();
                                    break;
                                case 53:
                                    message.approvalStatus = reader.int32();
                                    break;
                                case 44:
                                    message.bidModifier = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 16:
                                    message.cpcBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 17:
                                    message.cpmBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 24:
                                    message.cpvBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 33:
                                    message.percentCpcBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 18:
                                    message.effectiveCpcBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 19:
                                    message.effectiveCpmBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 20:
                                    message.effectiveCpvBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 34:
                                    message.effectivePercentCpcBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 21:
                                    message.effectiveCpcBidSource = reader.int32();
                                    break;
                                case 22:
                                    message.effectiveCpmBidSource = reader.int32();
                                    break;
                                case 23:
                                    message.effectiveCpvBidSource = reader.int32();
                                    break;
                                case 35:
                                    message.effectivePercentCpcBidSource = reader.int32();
                                    break;
                                case 10:
                                    message.positionEstimates = $root.google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    if (!(message.finalUrls && message.finalUrls.length))
                                        message.finalUrls = [];
                                    message.finalUrls.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 51:
                                    if (!(message.finalMobileUrls && message.finalMobileUrls.length))
                                        message.finalMobileUrls = [];
                                    message.finalMobileUrls.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 50:
                                    message.finalUrlSuffix = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 13:
                                    message.trackingUrlTemplate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 14:
                                    if (!(message.urlCustomParameters && message.urlCustomParameters.length))
                                        message.urlCustomParameters = [];
                                    message.urlCustomParameters.push($root.google.ads.googleads.v1.common.CustomParameter.decode(reader, reader.uint32()));
                                    break;
                                case 27:
                                    message.keyword = $root.google.ads.googleads.v1.common.KeywordInfo.decode(reader, reader.uint32());
                                    break;
                                case 28:
                                    message.placement = $root.google.ads.googleads.v1.common.PlacementInfo.decode(reader, reader.uint32());
                                    break;
                                case 29:
                                    message.mobileAppCategory = $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.decode(reader, reader.uint32());
                                    break;
                                case 30:
                                    message.mobileApplication = $root.google.ads.googleads.v1.common.MobileApplicationInfo.decode(reader, reader.uint32());
                                    break;
                                case 32:
                                    message.listingGroup = $root.google.ads.googleads.v1.common.ListingGroupInfo.decode(reader, reader.uint32());
                                    break;
                                case 36:
                                    message.ageRange = $root.google.ads.googleads.v1.common.AgeRangeInfo.decode(reader, reader.uint32());
                                    break;
                                case 37:
                                    message.gender = $root.google.ads.googleads.v1.common.GenderInfo.decode(reader, reader.uint32());
                                    break;
                                case 38:
                                    message.incomeRange = $root.google.ads.googleads.v1.common.IncomeRangeInfo.decode(reader, reader.uint32());
                                    break;
                                case 39:
                                    message.parentalStatus = $root.google.ads.googleads.v1.common.ParentalStatusInfo.decode(reader, reader.uint32());
                                    break;
                                case 42:
                                    message.userList = $root.google.ads.googleads.v1.common.UserListInfo.decode(reader, reader.uint32());
                                    break;
                                case 40:
                                    message.youtubeVideo = $root.google.ads.googleads.v1.common.YouTubeVideoInfo.decode(reader, reader.uint32());
                                    break;
                                case 41:
                                    message.youtubeChannel = $root.google.ads.googleads.v1.common.YouTubeChannelInfo.decode(reader, reader.uint32());
                                    break;
                                case 43:
                                    message.topic = $root.google.ads.googleads.v1.common.TopicInfo.decode(reader, reader.uint32());
                                    break;
                                case 45:
                                    message.userInterest = $root.google.ads.googleads.v1.common.UserInterestInfo.decode(reader, reader.uint32());
                                    break;
                                case 46:
                                    message.webpage = $root.google.ads.googleads.v1.common.WebpageInfo.decode(reader, reader.uint32());
                                    break;
                                case 47:
                                    message.appPaymentModel = $root.google.ads.googleads.v1.common.AppPaymentModelInfo.decode(reader, reader.uint32());
                                    break;
                                case 48:
                                    message.customAffinity = $root.google.ads.googleads.v1.common.CustomAffinityInfo.decode(reader, reader.uint32());
                                    break;
                                case 49:
                                    message.customIntent = $root.google.ads.googleads.v1.common.CustomIntentInfo.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupCriterion message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AdGroupCriterion} AdGroupCriterion
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupCriterion.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupCriterion message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupCriterion.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.criterionId != null && message.hasOwnProperty("criterionId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.criterionId);
                                if (error)
                                    return "criterionId." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.qualityInfo != null && message.hasOwnProperty("qualityInfo")) {
                                var error = $root.google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo.verify(message.qualityInfo);
                                if (error)
                                    return "qualityInfo." + error;
                            }
                            if (message.adGroup != null && message.hasOwnProperty("adGroup")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adGroup);
                                if (error)
                                    return "adGroup." + error;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                    break;
                                }
                            if (message.negative != null && message.hasOwnProperty("negative")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.negative);
                                if (error)
                                    return "negative." + error;
                            }
                            if (message.systemServingStatus != null && message.hasOwnProperty("systemServingStatus"))
                                switch (message.systemServingStatus) {
                                default:
                                    return "systemServingStatus: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.approvalStatus != null && message.hasOwnProperty("approvalStatus"))
                                switch (message.approvalStatus) {
                                default:
                                    return "approvalStatus: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            if (message.bidModifier != null && message.hasOwnProperty("bidModifier")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.bidModifier);
                                if (error)
                                    return "bidModifier." + error;
                            }
                            if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpcBidMicros);
                                if (error)
                                    return "cpcBidMicros." + error;
                            }
                            if (message.cpmBidMicros != null && message.hasOwnProperty("cpmBidMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpmBidMicros);
                                if (error)
                                    return "cpmBidMicros." + error;
                            }
                            if (message.cpvBidMicros != null && message.hasOwnProperty("cpvBidMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpvBidMicros);
                                if (error)
                                    return "cpvBidMicros." + error;
                            }
                            if (message.percentCpcBidMicros != null && message.hasOwnProperty("percentCpcBidMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.percentCpcBidMicros);
                                if (error)
                                    return "percentCpcBidMicros." + error;
                            }
                            if (message.effectiveCpcBidMicros != null && message.hasOwnProperty("effectiveCpcBidMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.effectiveCpcBidMicros);
                                if (error)
                                    return "effectiveCpcBidMicros." + error;
                            }
                            if (message.effectiveCpmBidMicros != null && message.hasOwnProperty("effectiveCpmBidMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.effectiveCpmBidMicros);
                                if (error)
                                    return "effectiveCpmBidMicros." + error;
                            }
                            if (message.effectiveCpvBidMicros != null && message.hasOwnProperty("effectiveCpvBidMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.effectiveCpvBidMicros);
                                if (error)
                                    return "effectiveCpvBidMicros." + error;
                            }
                            if (message.effectivePercentCpcBidMicros != null && message.hasOwnProperty("effectivePercentCpcBidMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.effectivePercentCpcBidMicros);
                                if (error)
                                    return "effectivePercentCpcBidMicros." + error;
                            }
                            if (message.effectiveCpcBidSource != null && message.hasOwnProperty("effectiveCpcBidSource"))
                                switch (message.effectiveCpcBidSource) {
                                default:
                                    return "effectiveCpcBidSource: enum value expected";
                                case 0:
                                case 1:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            if (message.effectiveCpmBidSource != null && message.hasOwnProperty("effectiveCpmBidSource"))
                                switch (message.effectiveCpmBidSource) {
                                default:
                                    return "effectiveCpmBidSource: enum value expected";
                                case 0:
                                case 1:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            if (message.effectiveCpvBidSource != null && message.hasOwnProperty("effectiveCpvBidSource"))
                                switch (message.effectiveCpvBidSource) {
                                default:
                                    return "effectiveCpvBidSource: enum value expected";
                                case 0:
                                case 1:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            if (message.effectivePercentCpcBidSource != null && message.hasOwnProperty("effectivePercentCpcBidSource"))
                                switch (message.effectivePercentCpcBidSource) {
                                default:
                                    return "effectivePercentCpcBidSource: enum value expected";
                                case 0:
                                case 1:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            if (message.positionEstimates != null && message.hasOwnProperty("positionEstimates")) {
                                var error = $root.google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates.verify(message.positionEstimates);
                                if (error)
                                    return "positionEstimates." + error;
                            }
                            if (message.finalUrls != null && message.hasOwnProperty("finalUrls")) {
                                if (!Array.isArray(message.finalUrls))
                                    return "finalUrls: array expected";
                                for (var i = 0; i < message.finalUrls.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.finalUrls[i]);
                                    if (error)
                                        return "finalUrls." + error;
                                }
                            }
                            if (message.finalMobileUrls != null && message.hasOwnProperty("finalMobileUrls")) {
                                if (!Array.isArray(message.finalMobileUrls))
                                    return "finalMobileUrls: array expected";
                                for (var i = 0; i < message.finalMobileUrls.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.finalMobileUrls[i]);
                                    if (error)
                                        return "finalMobileUrls." + error;
                                }
                            }
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix")) {
                                var error = $root.google.protobuf.StringValue.verify(message.finalUrlSuffix);
                                if (error)
                                    return "finalUrlSuffix." + error;
                            }
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.trackingUrlTemplate);
                                if (error)
                                    return "trackingUrlTemplate." + error;
                            }
                            if (message.urlCustomParameters != null && message.hasOwnProperty("urlCustomParameters")) {
                                if (!Array.isArray(message.urlCustomParameters))
                                    return "urlCustomParameters: array expected";
                                for (var i = 0; i < message.urlCustomParameters.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.CustomParameter.verify(message.urlCustomParameters[i]);
                                    if (error)
                                        return "urlCustomParameters." + error;
                                }
                            }
                            if (message.keyword != null && message.hasOwnProperty("keyword")) {
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.KeywordInfo.verify(message.keyword);
                                    if (error)
                                        return "keyword." + error;
                                }
                            }
                            if (message.placement != null && message.hasOwnProperty("placement")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.PlacementInfo.verify(message.placement);
                                    if (error)
                                        return "placement." + error;
                                }
                            }
                            if (message.mobileAppCategory != null && message.hasOwnProperty("mobileAppCategory")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.verify(message.mobileAppCategory);
                                    if (error)
                                        return "mobileAppCategory." + error;
                                }
                            }
                            if (message.mobileApplication != null && message.hasOwnProperty("mobileApplication")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.MobileApplicationInfo.verify(message.mobileApplication);
                                    if (error)
                                        return "mobileApplication." + error;
                                }
                            }
                            if (message.listingGroup != null && message.hasOwnProperty("listingGroup")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ListingGroupInfo.verify(message.listingGroup);
                                    if (error)
                                        return "listingGroup." + error;
                                }
                            }
                            if (message.ageRange != null && message.hasOwnProperty("ageRange")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.AgeRangeInfo.verify(message.ageRange);
                                    if (error)
                                        return "ageRange." + error;
                                }
                            }
                            if (message.gender != null && message.hasOwnProperty("gender")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.GenderInfo.verify(message.gender);
                                    if (error)
                                        return "gender." + error;
                                }
                            }
                            if (message.incomeRange != null && message.hasOwnProperty("incomeRange")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.IncomeRangeInfo.verify(message.incomeRange);
                                    if (error)
                                        return "incomeRange." + error;
                                }
                            }
                            if (message.parentalStatus != null && message.hasOwnProperty("parentalStatus")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ParentalStatusInfo.verify(message.parentalStatus);
                                    if (error)
                                        return "parentalStatus." + error;
                                }
                            }
                            if (message.userList != null && message.hasOwnProperty("userList")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.UserListInfo.verify(message.userList);
                                    if (error)
                                        return "userList." + error;
                                }
                            }
                            if (message.youtubeVideo != null && message.hasOwnProperty("youtubeVideo")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.YouTubeVideoInfo.verify(message.youtubeVideo);
                                    if (error)
                                        return "youtubeVideo." + error;
                                }
                            }
                            if (message.youtubeChannel != null && message.hasOwnProperty("youtubeChannel")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.YouTubeChannelInfo.verify(message.youtubeChannel);
                                    if (error)
                                        return "youtubeChannel." + error;
                                }
                            }
                            if (message.topic != null && message.hasOwnProperty("topic")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.TopicInfo.verify(message.topic);
                                    if (error)
                                        return "topic." + error;
                                }
                            }
                            if (message.userInterest != null && message.hasOwnProperty("userInterest")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.UserInterestInfo.verify(message.userInterest);
                                    if (error)
                                        return "userInterest." + error;
                                }
                            }
                            if (message.webpage != null && message.hasOwnProperty("webpage")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.WebpageInfo.verify(message.webpage);
                                    if (error)
                                        return "webpage." + error;
                                }
                            }
                            if (message.appPaymentModel != null && message.hasOwnProperty("appPaymentModel")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.AppPaymentModelInfo.verify(message.appPaymentModel);
                                    if (error)
                                        return "appPaymentModel." + error;
                                }
                            }
                            if (message.customAffinity != null && message.hasOwnProperty("customAffinity")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.CustomAffinityInfo.verify(message.customAffinity);
                                    if (error)
                                        return "customAffinity." + error;
                                }
                            }
                            if (message.customIntent != null && message.hasOwnProperty("customIntent")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.CustomIntentInfo.verify(message.customIntent);
                                    if (error)
                                        return "customIntent." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an AdGroupCriterion message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AdGroupCriterion} AdGroupCriterion
                         */
                        AdGroupCriterion.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AdGroupCriterion)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AdGroupCriterion();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.criterionId != null) {
                                if (typeof object.criterionId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.criterionId: object expected");
                                message.criterionId = $root.google.protobuf.Int64Value.fromObject(object.criterionId);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "PAUSED":
                            case 3:
                                message.status = 3;
                                break;
                            case "REMOVED":
                            case 4:
                                message.status = 4;
                                break;
                            }
                            if (object.qualityInfo != null) {
                                if (typeof object.qualityInfo !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.qualityInfo: object expected");
                                message.qualityInfo = $root.google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo.fromObject(object.qualityInfo);
                            }
                            if (object.adGroup != null) {
                                if (typeof object.adGroup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.adGroup: object expected");
                                message.adGroup = $root.google.protobuf.StringValue.fromObject(object.adGroup);
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "KEYWORD":
                            case 2:
                                message.type = 2;
                                break;
                            case "PLACEMENT":
                            case 3:
                                message.type = 3;
                                break;
                            case "MOBILE_APP_CATEGORY":
                            case 4:
                                message.type = 4;
                                break;
                            case "MOBILE_APPLICATION":
                            case 5:
                                message.type = 5;
                                break;
                            case "DEVICE":
                            case 6:
                                message.type = 6;
                                break;
                            case "LOCATION":
                            case 7:
                                message.type = 7;
                                break;
                            case "LISTING_GROUP":
                            case 8:
                                message.type = 8;
                                break;
                            case "AD_SCHEDULE":
                            case 9:
                                message.type = 9;
                                break;
                            case "AGE_RANGE":
                            case 10:
                                message.type = 10;
                                break;
                            case "GENDER":
                            case 11:
                                message.type = 11;
                                break;
                            case "INCOME_RANGE":
                            case 12:
                                message.type = 12;
                                break;
                            case "PARENTAL_STATUS":
                            case 13:
                                message.type = 13;
                                break;
                            case "YOUTUBE_VIDEO":
                            case 14:
                                message.type = 14;
                                break;
                            case "YOUTUBE_CHANNEL":
                            case 15:
                                message.type = 15;
                                break;
                            case "USER_LIST":
                            case 16:
                                message.type = 16;
                                break;
                            case "PROXIMITY":
                            case 17:
                                message.type = 17;
                                break;
                            case "TOPIC":
                            case 18:
                                message.type = 18;
                                break;
                            case "LISTING_SCOPE":
                            case 19:
                                message.type = 19;
                                break;
                            case "LANGUAGE":
                            case 20:
                                message.type = 20;
                                break;
                            case "IP_BLOCK":
                            case 21:
                                message.type = 21;
                                break;
                            case "CONTENT_LABEL":
                            case 22:
                                message.type = 22;
                                break;
                            case "CARRIER":
                            case 23:
                                message.type = 23;
                                break;
                            case "USER_INTEREST":
                            case 24:
                                message.type = 24;
                                break;
                            case "WEBPAGE":
                            case 25:
                                message.type = 25;
                                break;
                            case "OPERATING_SYSTEM_VERSION":
                            case 26:
                                message.type = 26;
                                break;
                            case "APP_PAYMENT_MODEL":
                            case 27:
                                message.type = 27;
                                break;
                            case "MOBILE_DEVICE":
                            case 28:
                                message.type = 28;
                                break;
                            case "CUSTOM_AFFINITY":
                            case 29:
                                message.type = 29;
                                break;
                            case "CUSTOM_INTENT":
                            case 30:
                                message.type = 30;
                                break;
                            case "LOCATION_GROUP":
                            case 31:
                                message.type = 31;
                                break;
                            }
                            if (object.negative != null) {
                                if (typeof object.negative !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.negative: object expected");
                                message.negative = $root.google.protobuf.BoolValue.fromObject(object.negative);
                            }
                            switch (object.systemServingStatus) {
                            case "UNSPECIFIED":
                            case 0:
                                message.systemServingStatus = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.systemServingStatus = 1;
                                break;
                            case "ELIGIBLE":
                            case 2:
                                message.systemServingStatus = 2;
                                break;
                            case "RARELY_SERVED":
                            case 3:
                                message.systemServingStatus = 3;
                                break;
                            }
                            switch (object.approvalStatus) {
                            case "UNSPECIFIED":
                            case 0:
                                message.approvalStatus = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.approvalStatus = 1;
                                break;
                            case "APPROVED":
                            case 2:
                                message.approvalStatus = 2;
                                break;
                            case "DISAPPROVED":
                            case 3:
                                message.approvalStatus = 3;
                                break;
                            case "PENDING_REVIEW":
                            case 4:
                                message.approvalStatus = 4;
                                break;
                            case "UNDER_REVIEW":
                            case 5:
                                message.approvalStatus = 5;
                                break;
                            }
                            if (object.bidModifier != null) {
                                if (typeof object.bidModifier !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.bidModifier: object expected");
                                message.bidModifier = $root.google.protobuf.DoubleValue.fromObject(object.bidModifier);
                            }
                            if (object.cpcBidMicros != null) {
                                if (typeof object.cpcBidMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.cpcBidMicros: object expected");
                                message.cpcBidMicros = $root.google.protobuf.Int64Value.fromObject(object.cpcBidMicros);
                            }
                            if (object.cpmBidMicros != null) {
                                if (typeof object.cpmBidMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.cpmBidMicros: object expected");
                                message.cpmBidMicros = $root.google.protobuf.Int64Value.fromObject(object.cpmBidMicros);
                            }
                            if (object.cpvBidMicros != null) {
                                if (typeof object.cpvBidMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.cpvBidMicros: object expected");
                                message.cpvBidMicros = $root.google.protobuf.Int64Value.fromObject(object.cpvBidMicros);
                            }
                            if (object.percentCpcBidMicros != null) {
                                if (typeof object.percentCpcBidMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.percentCpcBidMicros: object expected");
                                message.percentCpcBidMicros = $root.google.protobuf.Int64Value.fromObject(object.percentCpcBidMicros);
                            }
                            if (object.effectiveCpcBidMicros != null) {
                                if (typeof object.effectiveCpcBidMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.effectiveCpcBidMicros: object expected");
                                message.effectiveCpcBidMicros = $root.google.protobuf.Int64Value.fromObject(object.effectiveCpcBidMicros);
                            }
                            if (object.effectiveCpmBidMicros != null) {
                                if (typeof object.effectiveCpmBidMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.effectiveCpmBidMicros: object expected");
                                message.effectiveCpmBidMicros = $root.google.protobuf.Int64Value.fromObject(object.effectiveCpmBidMicros);
                            }
                            if (object.effectiveCpvBidMicros != null) {
                                if (typeof object.effectiveCpvBidMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.effectiveCpvBidMicros: object expected");
                                message.effectiveCpvBidMicros = $root.google.protobuf.Int64Value.fromObject(object.effectiveCpvBidMicros);
                            }
                            if (object.effectivePercentCpcBidMicros != null) {
                                if (typeof object.effectivePercentCpcBidMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.effectivePercentCpcBidMicros: object expected");
                                message.effectivePercentCpcBidMicros = $root.google.protobuf.Int64Value.fromObject(object.effectivePercentCpcBidMicros);
                            }
                            switch (object.effectiveCpcBidSource) {
                            case "UNSPECIFIED":
                            case 0:
                                message.effectiveCpcBidSource = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.effectiveCpcBidSource = 1;
                                break;
                            case "CAMPAIGN_BIDDING_STRATEGY":
                            case 5:
                                message.effectiveCpcBidSource = 5;
                                break;
                            case "AD_GROUP":
                            case 6:
                                message.effectiveCpcBidSource = 6;
                                break;
                            case "AD_GROUP_CRITERION":
                            case 7:
                                message.effectiveCpcBidSource = 7;
                                break;
                            }
                            switch (object.effectiveCpmBidSource) {
                            case "UNSPECIFIED":
                            case 0:
                                message.effectiveCpmBidSource = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.effectiveCpmBidSource = 1;
                                break;
                            case "CAMPAIGN_BIDDING_STRATEGY":
                            case 5:
                                message.effectiveCpmBidSource = 5;
                                break;
                            case "AD_GROUP":
                            case 6:
                                message.effectiveCpmBidSource = 6;
                                break;
                            case "AD_GROUP_CRITERION":
                            case 7:
                                message.effectiveCpmBidSource = 7;
                                break;
                            }
                            switch (object.effectiveCpvBidSource) {
                            case "UNSPECIFIED":
                            case 0:
                                message.effectiveCpvBidSource = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.effectiveCpvBidSource = 1;
                                break;
                            case "CAMPAIGN_BIDDING_STRATEGY":
                            case 5:
                                message.effectiveCpvBidSource = 5;
                                break;
                            case "AD_GROUP":
                            case 6:
                                message.effectiveCpvBidSource = 6;
                                break;
                            case "AD_GROUP_CRITERION":
                            case 7:
                                message.effectiveCpvBidSource = 7;
                                break;
                            }
                            switch (object.effectivePercentCpcBidSource) {
                            case "UNSPECIFIED":
                            case 0:
                                message.effectivePercentCpcBidSource = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.effectivePercentCpcBidSource = 1;
                                break;
                            case "CAMPAIGN_BIDDING_STRATEGY":
                            case 5:
                                message.effectivePercentCpcBidSource = 5;
                                break;
                            case "AD_GROUP":
                            case 6:
                                message.effectivePercentCpcBidSource = 6;
                                break;
                            case "AD_GROUP_CRITERION":
                            case 7:
                                message.effectivePercentCpcBidSource = 7;
                                break;
                            }
                            if (object.positionEstimates != null) {
                                if (typeof object.positionEstimates !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.positionEstimates: object expected");
                                message.positionEstimates = $root.google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates.fromObject(object.positionEstimates);
                            }
                            if (object.finalUrls) {
                                if (!Array.isArray(object.finalUrls))
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.finalUrls: array expected");
                                message.finalUrls = [];
                                for (var i = 0; i < object.finalUrls.length; ++i) {
                                    if (typeof object.finalUrls[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.finalUrls: object expected");
                                    message.finalUrls[i] = $root.google.protobuf.StringValue.fromObject(object.finalUrls[i]);
                                }
                            }
                            if (object.finalMobileUrls) {
                                if (!Array.isArray(object.finalMobileUrls))
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.finalMobileUrls: array expected");
                                message.finalMobileUrls = [];
                                for (var i = 0; i < object.finalMobileUrls.length; ++i) {
                                    if (typeof object.finalMobileUrls[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.finalMobileUrls: object expected");
                                    message.finalMobileUrls[i] = $root.google.protobuf.StringValue.fromObject(object.finalMobileUrls[i]);
                                }
                            }
                            if (object.finalUrlSuffix != null) {
                                if (typeof object.finalUrlSuffix !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.finalUrlSuffix: object expected");
                                message.finalUrlSuffix = $root.google.protobuf.StringValue.fromObject(object.finalUrlSuffix);
                            }
                            if (object.trackingUrlTemplate != null) {
                                if (typeof object.trackingUrlTemplate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.trackingUrlTemplate: object expected");
                                message.trackingUrlTemplate = $root.google.protobuf.StringValue.fromObject(object.trackingUrlTemplate);
                            }
                            if (object.urlCustomParameters) {
                                if (!Array.isArray(object.urlCustomParameters))
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.urlCustomParameters: array expected");
                                message.urlCustomParameters = [];
                                for (var i = 0; i < object.urlCustomParameters.length; ++i) {
                                    if (typeof object.urlCustomParameters[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.urlCustomParameters: object expected");
                                    message.urlCustomParameters[i] = $root.google.ads.googleads.v1.common.CustomParameter.fromObject(object.urlCustomParameters[i]);
                                }
                            }
                            if (object.keyword != null) {
                                if (typeof object.keyword !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.keyword: object expected");
                                message.keyword = $root.google.ads.googleads.v1.common.KeywordInfo.fromObject(object.keyword);
                            }
                            if (object.placement != null) {
                                if (typeof object.placement !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.placement: object expected");
                                message.placement = $root.google.ads.googleads.v1.common.PlacementInfo.fromObject(object.placement);
                            }
                            if (object.mobileAppCategory != null) {
                                if (typeof object.mobileAppCategory !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.mobileAppCategory: object expected");
                                message.mobileAppCategory = $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.fromObject(object.mobileAppCategory);
                            }
                            if (object.mobileApplication != null) {
                                if (typeof object.mobileApplication !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.mobileApplication: object expected");
                                message.mobileApplication = $root.google.ads.googleads.v1.common.MobileApplicationInfo.fromObject(object.mobileApplication);
                            }
                            if (object.listingGroup != null) {
                                if (typeof object.listingGroup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.listingGroup: object expected");
                                message.listingGroup = $root.google.ads.googleads.v1.common.ListingGroupInfo.fromObject(object.listingGroup);
                            }
                            if (object.ageRange != null) {
                                if (typeof object.ageRange !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.ageRange: object expected");
                                message.ageRange = $root.google.ads.googleads.v1.common.AgeRangeInfo.fromObject(object.ageRange);
                            }
                            if (object.gender != null) {
                                if (typeof object.gender !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.gender: object expected");
                                message.gender = $root.google.ads.googleads.v1.common.GenderInfo.fromObject(object.gender);
                            }
                            if (object.incomeRange != null) {
                                if (typeof object.incomeRange !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.incomeRange: object expected");
                                message.incomeRange = $root.google.ads.googleads.v1.common.IncomeRangeInfo.fromObject(object.incomeRange);
                            }
                            if (object.parentalStatus != null) {
                                if (typeof object.parentalStatus !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.parentalStatus: object expected");
                                message.parentalStatus = $root.google.ads.googleads.v1.common.ParentalStatusInfo.fromObject(object.parentalStatus);
                            }
                            if (object.userList != null) {
                                if (typeof object.userList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.userList: object expected");
                                message.userList = $root.google.ads.googleads.v1.common.UserListInfo.fromObject(object.userList);
                            }
                            if (object.youtubeVideo != null) {
                                if (typeof object.youtubeVideo !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.youtubeVideo: object expected");
                                message.youtubeVideo = $root.google.ads.googleads.v1.common.YouTubeVideoInfo.fromObject(object.youtubeVideo);
                            }
                            if (object.youtubeChannel != null) {
                                if (typeof object.youtubeChannel !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.youtubeChannel: object expected");
                                message.youtubeChannel = $root.google.ads.googleads.v1.common.YouTubeChannelInfo.fromObject(object.youtubeChannel);
                            }
                            if (object.topic != null) {
                                if (typeof object.topic !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.topic: object expected");
                                message.topic = $root.google.ads.googleads.v1.common.TopicInfo.fromObject(object.topic);
                            }
                            if (object.userInterest != null) {
                                if (typeof object.userInterest !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.userInterest: object expected");
                                message.userInterest = $root.google.ads.googleads.v1.common.UserInterestInfo.fromObject(object.userInterest);
                            }
                            if (object.webpage != null) {
                                if (typeof object.webpage !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.webpage: object expected");
                                message.webpage = $root.google.ads.googleads.v1.common.WebpageInfo.fromObject(object.webpage);
                            }
                            if (object.appPaymentModel != null) {
                                if (typeof object.appPaymentModel !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.appPaymentModel: object expected");
                                message.appPaymentModel = $root.google.ads.googleads.v1.common.AppPaymentModelInfo.fromObject(object.appPaymentModel);
                            }
                            if (object.customAffinity != null) {
                                if (typeof object.customAffinity !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.customAffinity: object expected");
                                message.customAffinity = $root.google.ads.googleads.v1.common.CustomAffinityInfo.fromObject(object.customAffinity);
                            }
                            if (object.customIntent != null) {
                                if (typeof object.customIntent !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.customIntent: object expected");
                                message.customIntent = $root.google.ads.googleads.v1.common.CustomIntentInfo.fromObject(object.customIntent);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupCriterion message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @static
                         * @param {google.ads.googleads.v1.resources.AdGroupCriterion} message AdGroupCriterion
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupCriterion.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.finalUrls = [];
                                object.urlCustomParameters = [];
                                object.finalMobileUrls = [];
                            }
                            if (options.defaults) {
                                object.resourceName = "";
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                                object.qualityInfo = null;
                                object.adGroup = null;
                                object.positionEstimates = null;
                                object.trackingUrlTemplate = null;
                                object.cpcBidMicros = null;
                                object.cpmBidMicros = null;
                                object.effectiveCpcBidMicros = null;
                                object.effectiveCpmBidMicros = null;
                                object.effectiveCpvBidMicros = null;
                                object.effectiveCpcBidSource = options.enums === String ? "UNSPECIFIED" : 0;
                                object.effectiveCpmBidSource = options.enums === String ? "UNSPECIFIED" : 0;
                                object.effectiveCpvBidSource = options.enums === String ? "UNSPECIFIED" : 0;
                                object.cpvBidMicros = null;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.criterionId = null;
                                object.negative = null;
                                object.percentCpcBidMicros = null;
                                object.effectivePercentCpcBidMicros = null;
                                object.effectivePercentCpcBidSource = options.enums === String ? "UNSPECIFIED" : 0;
                                object.bidModifier = null;
                                object.finalUrlSuffix = null;
                                object.systemServingStatus = options.enums === String ? "UNSPECIFIED" : 0;
                                object.approvalStatus = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.AdGroupCriterionStatusEnum.AdGroupCriterionStatus[message.status] : message.status;
                            if (message.qualityInfo != null && message.hasOwnProperty("qualityInfo"))
                                object.qualityInfo = $root.google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo.toObject(message.qualityInfo, options);
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                object.adGroup = $root.google.protobuf.StringValue.toObject(message.adGroup, options);
                            if (message.positionEstimates != null && message.hasOwnProperty("positionEstimates"))
                                object.positionEstimates = $root.google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates.toObject(message.positionEstimates, options);
                            if (message.finalUrls && message.finalUrls.length) {
                                object.finalUrls = [];
                                for (var j = 0; j < message.finalUrls.length; ++j)
                                    object.finalUrls[j] = $root.google.protobuf.StringValue.toObject(message.finalUrls[j], options);
                            }
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                object.trackingUrlTemplate = $root.google.protobuf.StringValue.toObject(message.trackingUrlTemplate, options);
                            if (message.urlCustomParameters && message.urlCustomParameters.length) {
                                object.urlCustomParameters = [];
                                for (var j = 0; j < message.urlCustomParameters.length; ++j)
                                    object.urlCustomParameters[j] = $root.google.ads.googleads.v1.common.CustomParameter.toObject(message.urlCustomParameters[j], options);
                            }
                            if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros"))
                                object.cpcBidMicros = $root.google.protobuf.Int64Value.toObject(message.cpcBidMicros, options);
                            if (message.cpmBidMicros != null && message.hasOwnProperty("cpmBidMicros"))
                                object.cpmBidMicros = $root.google.protobuf.Int64Value.toObject(message.cpmBidMicros, options);
                            if (message.effectiveCpcBidMicros != null && message.hasOwnProperty("effectiveCpcBidMicros"))
                                object.effectiveCpcBidMicros = $root.google.protobuf.Int64Value.toObject(message.effectiveCpcBidMicros, options);
                            if (message.effectiveCpmBidMicros != null && message.hasOwnProperty("effectiveCpmBidMicros"))
                                object.effectiveCpmBidMicros = $root.google.protobuf.Int64Value.toObject(message.effectiveCpmBidMicros, options);
                            if (message.effectiveCpvBidMicros != null && message.hasOwnProperty("effectiveCpvBidMicros"))
                                object.effectiveCpvBidMicros = $root.google.protobuf.Int64Value.toObject(message.effectiveCpvBidMicros, options);
                            if (message.effectiveCpcBidSource != null && message.hasOwnProperty("effectiveCpcBidSource"))
                                object.effectiveCpcBidSource = options.enums === String ? $root.google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource[message.effectiveCpcBidSource] : message.effectiveCpcBidSource;
                            if (message.effectiveCpmBidSource != null && message.hasOwnProperty("effectiveCpmBidSource"))
                                object.effectiveCpmBidSource = options.enums === String ? $root.google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource[message.effectiveCpmBidSource] : message.effectiveCpmBidSource;
                            if (message.effectiveCpvBidSource != null && message.hasOwnProperty("effectiveCpvBidSource"))
                                object.effectiveCpvBidSource = options.enums === String ? $root.google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource[message.effectiveCpvBidSource] : message.effectiveCpvBidSource;
                            if (message.cpvBidMicros != null && message.hasOwnProperty("cpvBidMicros"))
                                object.cpvBidMicros = $root.google.protobuf.Int64Value.toObject(message.cpvBidMicros, options);
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.CriterionTypeEnum.CriterionType[message.type] : message.type;
                            if (message.criterionId != null && message.hasOwnProperty("criterionId"))
                                object.criterionId = $root.google.protobuf.Int64Value.toObject(message.criterionId, options);
                            if (message.keyword != null && message.hasOwnProperty("keyword")) {
                                object.keyword = $root.google.ads.googleads.v1.common.KeywordInfo.toObject(message.keyword, options);
                                if (options.oneofs)
                                    object.criterion = "keyword";
                            }
                            if (message.placement != null && message.hasOwnProperty("placement")) {
                                object.placement = $root.google.ads.googleads.v1.common.PlacementInfo.toObject(message.placement, options);
                                if (options.oneofs)
                                    object.criterion = "placement";
                            }
                            if (message.mobileAppCategory != null && message.hasOwnProperty("mobileAppCategory")) {
                                object.mobileAppCategory = $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.toObject(message.mobileAppCategory, options);
                                if (options.oneofs)
                                    object.criterion = "mobileAppCategory";
                            }
                            if (message.mobileApplication != null && message.hasOwnProperty("mobileApplication")) {
                                object.mobileApplication = $root.google.ads.googleads.v1.common.MobileApplicationInfo.toObject(message.mobileApplication, options);
                                if (options.oneofs)
                                    object.criterion = "mobileApplication";
                            }
                            if (message.negative != null && message.hasOwnProperty("negative"))
                                object.negative = $root.google.protobuf.BoolValue.toObject(message.negative, options);
                            if (message.listingGroup != null && message.hasOwnProperty("listingGroup")) {
                                object.listingGroup = $root.google.ads.googleads.v1.common.ListingGroupInfo.toObject(message.listingGroup, options);
                                if (options.oneofs)
                                    object.criterion = "listingGroup";
                            }
                            if (message.percentCpcBidMicros != null && message.hasOwnProperty("percentCpcBidMicros"))
                                object.percentCpcBidMicros = $root.google.protobuf.Int64Value.toObject(message.percentCpcBidMicros, options);
                            if (message.effectivePercentCpcBidMicros != null && message.hasOwnProperty("effectivePercentCpcBidMicros"))
                                object.effectivePercentCpcBidMicros = $root.google.protobuf.Int64Value.toObject(message.effectivePercentCpcBidMicros, options);
                            if (message.effectivePercentCpcBidSource != null && message.hasOwnProperty("effectivePercentCpcBidSource"))
                                object.effectivePercentCpcBidSource = options.enums === String ? $root.google.ads.googleads.v1.enums.BiddingSourceEnum.BiddingSource[message.effectivePercentCpcBidSource] : message.effectivePercentCpcBidSource;
                            if (message.ageRange != null && message.hasOwnProperty("ageRange")) {
                                object.ageRange = $root.google.ads.googleads.v1.common.AgeRangeInfo.toObject(message.ageRange, options);
                                if (options.oneofs)
                                    object.criterion = "ageRange";
                            }
                            if (message.gender != null && message.hasOwnProperty("gender")) {
                                object.gender = $root.google.ads.googleads.v1.common.GenderInfo.toObject(message.gender, options);
                                if (options.oneofs)
                                    object.criterion = "gender";
                            }
                            if (message.incomeRange != null && message.hasOwnProperty("incomeRange")) {
                                object.incomeRange = $root.google.ads.googleads.v1.common.IncomeRangeInfo.toObject(message.incomeRange, options);
                                if (options.oneofs)
                                    object.criterion = "incomeRange";
                            }
                            if (message.parentalStatus != null && message.hasOwnProperty("parentalStatus")) {
                                object.parentalStatus = $root.google.ads.googleads.v1.common.ParentalStatusInfo.toObject(message.parentalStatus, options);
                                if (options.oneofs)
                                    object.criterion = "parentalStatus";
                            }
                            if (message.youtubeVideo != null && message.hasOwnProperty("youtubeVideo")) {
                                object.youtubeVideo = $root.google.ads.googleads.v1.common.YouTubeVideoInfo.toObject(message.youtubeVideo, options);
                                if (options.oneofs)
                                    object.criterion = "youtubeVideo";
                            }
                            if (message.youtubeChannel != null && message.hasOwnProperty("youtubeChannel")) {
                                object.youtubeChannel = $root.google.ads.googleads.v1.common.YouTubeChannelInfo.toObject(message.youtubeChannel, options);
                                if (options.oneofs)
                                    object.criterion = "youtubeChannel";
                            }
                            if (message.userList != null && message.hasOwnProperty("userList")) {
                                object.userList = $root.google.ads.googleads.v1.common.UserListInfo.toObject(message.userList, options);
                                if (options.oneofs)
                                    object.criterion = "userList";
                            }
                            if (message.topic != null && message.hasOwnProperty("topic")) {
                                object.topic = $root.google.ads.googleads.v1.common.TopicInfo.toObject(message.topic, options);
                                if (options.oneofs)
                                    object.criterion = "topic";
                            }
                            if (message.bidModifier != null && message.hasOwnProperty("bidModifier"))
                                object.bidModifier = $root.google.protobuf.DoubleValue.toObject(message.bidModifier, options);
                            if (message.userInterest != null && message.hasOwnProperty("userInterest")) {
                                object.userInterest = $root.google.ads.googleads.v1.common.UserInterestInfo.toObject(message.userInterest, options);
                                if (options.oneofs)
                                    object.criterion = "userInterest";
                            }
                            if (message.webpage != null && message.hasOwnProperty("webpage")) {
                                object.webpage = $root.google.ads.googleads.v1.common.WebpageInfo.toObject(message.webpage, options);
                                if (options.oneofs)
                                    object.criterion = "webpage";
                            }
                            if (message.appPaymentModel != null && message.hasOwnProperty("appPaymentModel")) {
                                object.appPaymentModel = $root.google.ads.googleads.v1.common.AppPaymentModelInfo.toObject(message.appPaymentModel, options);
                                if (options.oneofs)
                                    object.criterion = "appPaymentModel";
                            }
                            if (message.customAffinity != null && message.hasOwnProperty("customAffinity")) {
                                object.customAffinity = $root.google.ads.googleads.v1.common.CustomAffinityInfo.toObject(message.customAffinity, options);
                                if (options.oneofs)
                                    object.criterion = "customAffinity";
                            }
                            if (message.customIntent != null && message.hasOwnProperty("customIntent")) {
                                object.customIntent = $root.google.ads.googleads.v1.common.CustomIntentInfo.toObject(message.customIntent, options);
                                if (options.oneofs)
                                    object.criterion = "customIntent";
                            }
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix"))
                                object.finalUrlSuffix = $root.google.protobuf.StringValue.toObject(message.finalUrlSuffix, options);
                            if (message.finalMobileUrls && message.finalMobileUrls.length) {
                                object.finalMobileUrls = [];
                                for (var j = 0; j < message.finalMobileUrls.length; ++j)
                                    object.finalMobileUrls[j] = $root.google.protobuf.StringValue.toObject(message.finalMobileUrls[j], options);
                            }
                            if (message.systemServingStatus != null && message.hasOwnProperty("systemServingStatus"))
                                object.systemServingStatus = options.enums === String ? $root.google.ads.googleads.v1.enums.CriterionSystemServingStatusEnum.CriterionSystemServingStatus[message.systemServingStatus] : message.systemServingStatus;
                            if (message.approvalStatus != null && message.hasOwnProperty("approvalStatus"))
                                object.approvalStatus = options.enums === String ? $root.google.ads.googleads.v1.enums.AdGroupCriterionApprovalStatusEnum.AdGroupCriterionApprovalStatus[message.approvalStatus] : message.approvalStatus;
                            return object;
                        };

                        /**
                         * Converts this AdGroupCriterion to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupCriterion.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        AdGroupCriterion.QualityInfo = (function() {

                            /**
                             * Properties of a QualityInfo.
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                             * @interface IQualityInfo
                             * @property {google.protobuf.IInt32Value|null} [qualityScore] QualityInfo qualityScore
                             * @property {google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket|null} [creativeQualityScore] QualityInfo creativeQualityScore
                             * @property {google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket|null} [postClickQualityScore] QualityInfo postClickQualityScore
                             * @property {google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket|null} [searchPredictedCtr] QualityInfo searchPredictedCtr
                             */

                            /**
                             * Constructs a new QualityInfo.
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                             * @classdesc Represents a QualityInfo.
                             * @implements IQualityInfo
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.AdGroupCriterion.IQualityInfo=} [properties] Properties to set
                             */
                            function QualityInfo(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * QualityInfo qualityScore.
                             * @member {google.protobuf.IInt32Value|null|undefined} qualityScore
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo
                             * @instance
                             */
                            QualityInfo.prototype.qualityScore = null;

                            /**
                             * QualityInfo creativeQualityScore.
                             * @member {google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket} creativeQualityScore
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo
                             * @instance
                             */
                            QualityInfo.prototype.creativeQualityScore = 0;

                            /**
                             * QualityInfo postClickQualityScore.
                             * @member {google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket} postClickQualityScore
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo
                             * @instance
                             */
                            QualityInfo.prototype.postClickQualityScore = 0;

                            /**
                             * QualityInfo searchPredictedCtr.
                             * @member {google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket} searchPredictedCtr
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo
                             * @instance
                             */
                            QualityInfo.prototype.searchPredictedCtr = 0;

                            /**
                             * Creates a new QualityInfo instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo
                             * @static
                             * @param {google.ads.googleads.v1.resources.AdGroupCriterion.IQualityInfo=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo} QualityInfo instance
                             */
                            QualityInfo.create = function create(properties) {
                                return new QualityInfo(properties);
                            };

                            /**
                             * Encodes the specified QualityInfo message. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo
                             * @static
                             * @param {google.ads.googleads.v1.resources.AdGroupCriterion.IQualityInfo} message QualityInfo message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            QualityInfo.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.qualityScore != null && message.hasOwnProperty("qualityScore"))
                                    $root.google.protobuf.Int32Value.encode(message.qualityScore, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.creativeQualityScore != null && message.hasOwnProperty("creativeQualityScore"))
                                    writer.uint32(/* id 2, wireType 0 =*/16).int32(message.creativeQualityScore);
                                if (message.postClickQualityScore != null && message.hasOwnProperty("postClickQualityScore"))
                                    writer.uint32(/* id 3, wireType 0 =*/24).int32(message.postClickQualityScore);
                                if (message.searchPredictedCtr != null && message.hasOwnProperty("searchPredictedCtr"))
                                    writer.uint32(/* id 4, wireType 0 =*/32).int32(message.searchPredictedCtr);
                                return writer;
                            };

                            /**
                             * Encodes the specified QualityInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo
                             * @static
                             * @param {google.ads.googleads.v1.resources.AdGroupCriterion.IQualityInfo} message QualityInfo message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            QualityInfo.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a QualityInfo message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo} QualityInfo
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            QualityInfo.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.qualityScore = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.creativeQualityScore = reader.int32();
                                        break;
                                    case 3:
                                        message.postClickQualityScore = reader.int32();
                                        break;
                                    case 4:
                                        message.searchPredictedCtr = reader.int32();
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a QualityInfo message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo} QualityInfo
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            QualityInfo.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a QualityInfo message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            QualityInfo.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.qualityScore != null && message.hasOwnProperty("qualityScore")) {
                                    var error = $root.google.protobuf.Int32Value.verify(message.qualityScore);
                                    if (error)
                                        return "qualityScore." + error;
                                }
                                if (message.creativeQualityScore != null && message.hasOwnProperty("creativeQualityScore"))
                                    switch (message.creativeQualityScore) {
                                    default:
                                        return "creativeQualityScore: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                        break;
                                    }
                                if (message.postClickQualityScore != null && message.hasOwnProperty("postClickQualityScore"))
                                    switch (message.postClickQualityScore) {
                                    default:
                                        return "postClickQualityScore: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                        break;
                                    }
                                if (message.searchPredictedCtr != null && message.hasOwnProperty("searchPredictedCtr"))
                                    switch (message.searchPredictedCtr) {
                                    default:
                                        return "searchPredictedCtr: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                        break;
                                    }
                                return null;
                            };

                            /**
                             * Creates a QualityInfo message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo} QualityInfo
                             */
                            QualityInfo.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo();
                                if (object.qualityScore != null) {
                                    if (typeof object.qualityScore !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo.qualityScore: object expected");
                                    message.qualityScore = $root.google.protobuf.Int32Value.fromObject(object.qualityScore);
                                }
                                switch (object.creativeQualityScore) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.creativeQualityScore = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.creativeQualityScore = 1;
                                    break;
                                case "BELOW_AVERAGE":
                                case 2:
                                    message.creativeQualityScore = 2;
                                    break;
                                case "AVERAGE":
                                case 3:
                                    message.creativeQualityScore = 3;
                                    break;
                                case "ABOVE_AVERAGE":
                                case 4:
                                    message.creativeQualityScore = 4;
                                    break;
                                }
                                switch (object.postClickQualityScore) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.postClickQualityScore = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.postClickQualityScore = 1;
                                    break;
                                case "BELOW_AVERAGE":
                                case 2:
                                    message.postClickQualityScore = 2;
                                    break;
                                case "AVERAGE":
                                case 3:
                                    message.postClickQualityScore = 3;
                                    break;
                                case "ABOVE_AVERAGE":
                                case 4:
                                    message.postClickQualityScore = 4;
                                    break;
                                }
                                switch (object.searchPredictedCtr) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.searchPredictedCtr = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.searchPredictedCtr = 1;
                                    break;
                                case "BELOW_AVERAGE":
                                case 2:
                                    message.searchPredictedCtr = 2;
                                    break;
                                case "AVERAGE":
                                case 3:
                                    message.searchPredictedCtr = 3;
                                    break;
                                case "ABOVE_AVERAGE":
                                case 4:
                                    message.searchPredictedCtr = 4;
                                    break;
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a QualityInfo message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo
                             * @static
                             * @param {google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo} message QualityInfo
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            QualityInfo.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.qualityScore = null;
                                    object.creativeQualityScore = options.enums === String ? "UNSPECIFIED" : 0;
                                    object.postClickQualityScore = options.enums === String ? "UNSPECIFIED" : 0;
                                    object.searchPredictedCtr = options.enums === String ? "UNSPECIFIED" : 0;
                                }
                                if (message.qualityScore != null && message.hasOwnProperty("qualityScore"))
                                    object.qualityScore = $root.google.protobuf.Int32Value.toObject(message.qualityScore, options);
                                if (message.creativeQualityScore != null && message.hasOwnProperty("creativeQualityScore"))
                                    object.creativeQualityScore = options.enums === String ? $root.google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket[message.creativeQualityScore] : message.creativeQualityScore;
                                if (message.postClickQualityScore != null && message.hasOwnProperty("postClickQualityScore"))
                                    object.postClickQualityScore = options.enums === String ? $root.google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket[message.postClickQualityScore] : message.postClickQualityScore;
                                if (message.searchPredictedCtr != null && message.hasOwnProperty("searchPredictedCtr"))
                                    object.searchPredictedCtr = options.enums === String ? $root.google.ads.googleads.v1.enums.QualityScoreBucketEnum.QualityScoreBucket[message.searchPredictedCtr] : message.searchPredictedCtr;
                                return object;
                            };

                            /**
                             * Converts this QualityInfo to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.QualityInfo
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            QualityInfo.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return QualityInfo;
                        })();

                        AdGroupCriterion.PositionEstimates = (function() {

                            /**
                             * Properties of a PositionEstimates.
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                             * @interface IPositionEstimates
                             * @property {google.protobuf.IInt64Value|null} [firstPageCpcMicros] PositionEstimates firstPageCpcMicros
                             * @property {google.protobuf.IInt64Value|null} [firstPositionCpcMicros] PositionEstimates firstPositionCpcMicros
                             * @property {google.protobuf.IInt64Value|null} [topOfPageCpcMicros] PositionEstimates topOfPageCpcMicros
                             * @property {google.protobuf.IInt64Value|null} [estimatedAddClicksAtFirstPositionCpc] PositionEstimates estimatedAddClicksAtFirstPositionCpc
                             * @property {google.protobuf.IInt64Value|null} [estimatedAddCostAtFirstPositionCpc] PositionEstimates estimatedAddCostAtFirstPositionCpc
                             */

                            /**
                             * Constructs a new PositionEstimates.
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion
                             * @classdesc Represents a PositionEstimates.
                             * @implements IPositionEstimates
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.AdGroupCriterion.IPositionEstimates=} [properties] Properties to set
                             */
                            function PositionEstimates(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * PositionEstimates firstPageCpcMicros.
                             * @member {google.protobuf.IInt64Value|null|undefined} firstPageCpcMicros
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates
                             * @instance
                             */
                            PositionEstimates.prototype.firstPageCpcMicros = null;

                            /**
                             * PositionEstimates firstPositionCpcMicros.
                             * @member {google.protobuf.IInt64Value|null|undefined} firstPositionCpcMicros
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates
                             * @instance
                             */
                            PositionEstimates.prototype.firstPositionCpcMicros = null;

                            /**
                             * PositionEstimates topOfPageCpcMicros.
                             * @member {google.protobuf.IInt64Value|null|undefined} topOfPageCpcMicros
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates
                             * @instance
                             */
                            PositionEstimates.prototype.topOfPageCpcMicros = null;

                            /**
                             * PositionEstimates estimatedAddClicksAtFirstPositionCpc.
                             * @member {google.protobuf.IInt64Value|null|undefined} estimatedAddClicksAtFirstPositionCpc
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates
                             * @instance
                             */
                            PositionEstimates.prototype.estimatedAddClicksAtFirstPositionCpc = null;

                            /**
                             * PositionEstimates estimatedAddCostAtFirstPositionCpc.
                             * @member {google.protobuf.IInt64Value|null|undefined} estimatedAddCostAtFirstPositionCpc
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates
                             * @instance
                             */
                            PositionEstimates.prototype.estimatedAddCostAtFirstPositionCpc = null;

                            /**
                             * Creates a new PositionEstimates instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates
                             * @static
                             * @param {google.ads.googleads.v1.resources.AdGroupCriterion.IPositionEstimates=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates} PositionEstimates instance
                             */
                            PositionEstimates.create = function create(properties) {
                                return new PositionEstimates(properties);
                            };

                            /**
                             * Encodes the specified PositionEstimates message. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates
                             * @static
                             * @param {google.ads.googleads.v1.resources.AdGroupCriterion.IPositionEstimates} message PositionEstimates message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            PositionEstimates.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.firstPageCpcMicros != null && message.hasOwnProperty("firstPageCpcMicros"))
                                    $root.google.protobuf.Int64Value.encode(message.firstPageCpcMicros, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.firstPositionCpcMicros != null && message.hasOwnProperty("firstPositionCpcMicros"))
                                    $root.google.protobuf.Int64Value.encode(message.firstPositionCpcMicros, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                if (message.topOfPageCpcMicros != null && message.hasOwnProperty("topOfPageCpcMicros"))
                                    $root.google.protobuf.Int64Value.encode(message.topOfPageCpcMicros, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                                if (message.estimatedAddClicksAtFirstPositionCpc != null && message.hasOwnProperty("estimatedAddClicksAtFirstPositionCpc"))
                                    $root.google.protobuf.Int64Value.encode(message.estimatedAddClicksAtFirstPositionCpc, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                                if (message.estimatedAddCostAtFirstPositionCpc != null && message.hasOwnProperty("estimatedAddCostAtFirstPositionCpc"))
                                    $root.google.protobuf.Int64Value.encode(message.estimatedAddCostAtFirstPositionCpc, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified PositionEstimates message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates
                             * @static
                             * @param {google.ads.googleads.v1.resources.AdGroupCriterion.IPositionEstimates} message PositionEstimates message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            PositionEstimates.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a PositionEstimates message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates} PositionEstimates
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            PositionEstimates.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.firstPageCpcMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.firstPositionCpcMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    case 3:
                                        message.topOfPageCpcMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    case 4:
                                        message.estimatedAddClicksAtFirstPositionCpc = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    case 5:
                                        message.estimatedAddCostAtFirstPositionCpc = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a PositionEstimates message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates} PositionEstimates
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            PositionEstimates.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a PositionEstimates message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            PositionEstimates.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.firstPageCpcMicros != null && message.hasOwnProperty("firstPageCpcMicros")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.firstPageCpcMicros);
                                    if (error)
                                        return "firstPageCpcMicros." + error;
                                }
                                if (message.firstPositionCpcMicros != null && message.hasOwnProperty("firstPositionCpcMicros")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.firstPositionCpcMicros);
                                    if (error)
                                        return "firstPositionCpcMicros." + error;
                                }
                                if (message.topOfPageCpcMicros != null && message.hasOwnProperty("topOfPageCpcMicros")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.topOfPageCpcMicros);
                                    if (error)
                                        return "topOfPageCpcMicros." + error;
                                }
                                if (message.estimatedAddClicksAtFirstPositionCpc != null && message.hasOwnProperty("estimatedAddClicksAtFirstPositionCpc")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.estimatedAddClicksAtFirstPositionCpc);
                                    if (error)
                                        return "estimatedAddClicksAtFirstPositionCpc." + error;
                                }
                                if (message.estimatedAddCostAtFirstPositionCpc != null && message.hasOwnProperty("estimatedAddCostAtFirstPositionCpc")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.estimatedAddCostAtFirstPositionCpc);
                                    if (error)
                                        return "estimatedAddCostAtFirstPositionCpc." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a PositionEstimates message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates} PositionEstimates
                             */
                            PositionEstimates.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates();
                                if (object.firstPageCpcMicros != null) {
                                    if (typeof object.firstPageCpcMicros !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates.firstPageCpcMicros: object expected");
                                    message.firstPageCpcMicros = $root.google.protobuf.Int64Value.fromObject(object.firstPageCpcMicros);
                                }
                                if (object.firstPositionCpcMicros != null) {
                                    if (typeof object.firstPositionCpcMicros !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates.firstPositionCpcMicros: object expected");
                                    message.firstPositionCpcMicros = $root.google.protobuf.Int64Value.fromObject(object.firstPositionCpcMicros);
                                }
                                if (object.topOfPageCpcMicros != null) {
                                    if (typeof object.topOfPageCpcMicros !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates.topOfPageCpcMicros: object expected");
                                    message.topOfPageCpcMicros = $root.google.protobuf.Int64Value.fromObject(object.topOfPageCpcMicros);
                                }
                                if (object.estimatedAddClicksAtFirstPositionCpc != null) {
                                    if (typeof object.estimatedAddClicksAtFirstPositionCpc !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates.estimatedAddClicksAtFirstPositionCpc: object expected");
                                    message.estimatedAddClicksAtFirstPositionCpc = $root.google.protobuf.Int64Value.fromObject(object.estimatedAddClicksAtFirstPositionCpc);
                                }
                                if (object.estimatedAddCostAtFirstPositionCpc != null) {
                                    if (typeof object.estimatedAddCostAtFirstPositionCpc !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates.estimatedAddCostAtFirstPositionCpc: object expected");
                                    message.estimatedAddCostAtFirstPositionCpc = $root.google.protobuf.Int64Value.fromObject(object.estimatedAddCostAtFirstPositionCpc);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a PositionEstimates message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates
                             * @static
                             * @param {google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates} message PositionEstimates
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            PositionEstimates.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.firstPageCpcMicros = null;
                                    object.firstPositionCpcMicros = null;
                                    object.topOfPageCpcMicros = null;
                                    object.estimatedAddClicksAtFirstPositionCpc = null;
                                    object.estimatedAddCostAtFirstPositionCpc = null;
                                }
                                if (message.firstPageCpcMicros != null && message.hasOwnProperty("firstPageCpcMicros"))
                                    object.firstPageCpcMicros = $root.google.protobuf.Int64Value.toObject(message.firstPageCpcMicros, options);
                                if (message.firstPositionCpcMicros != null && message.hasOwnProperty("firstPositionCpcMicros"))
                                    object.firstPositionCpcMicros = $root.google.protobuf.Int64Value.toObject(message.firstPositionCpcMicros, options);
                                if (message.topOfPageCpcMicros != null && message.hasOwnProperty("topOfPageCpcMicros"))
                                    object.topOfPageCpcMicros = $root.google.protobuf.Int64Value.toObject(message.topOfPageCpcMicros, options);
                                if (message.estimatedAddClicksAtFirstPositionCpc != null && message.hasOwnProperty("estimatedAddClicksAtFirstPositionCpc"))
                                    object.estimatedAddClicksAtFirstPositionCpc = $root.google.protobuf.Int64Value.toObject(message.estimatedAddClicksAtFirstPositionCpc, options);
                                if (message.estimatedAddCostAtFirstPositionCpc != null && message.hasOwnProperty("estimatedAddCostAtFirstPositionCpc"))
                                    object.estimatedAddCostAtFirstPositionCpc = $root.google.protobuf.Int64Value.toObject(message.estimatedAddCostAtFirstPositionCpc, options);
                                return object;
                            };

                            /**
                             * Converts this PositionEstimates to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.AdGroupCriterion.PositionEstimates
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            PositionEstimates.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return PositionEstimates;
                        })();

                        return AdGroupCriterion;
                    })();

                    resources.AdGroupCriterionLabel = (function() {

                        /**
                         * Properties of an AdGroupCriterionLabel.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAdGroupCriterionLabel
                         * @property {string|null} [resourceName] AdGroupCriterionLabel resourceName
                         * @property {google.protobuf.IStringValue|null} [adGroupCriterion] AdGroupCriterionLabel adGroupCriterion
                         * @property {google.protobuf.IStringValue|null} [label] AdGroupCriterionLabel label
                         */

                        /**
                         * Constructs a new AdGroupCriterionLabel.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AdGroupCriterionLabel.
                         * @implements IAdGroupCriterionLabel
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAdGroupCriterionLabel=} [properties] Properties to set
                         */
                        function AdGroupCriterionLabel(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupCriterionLabel resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionLabel
                         * @instance
                         */
                        AdGroupCriterionLabel.prototype.resourceName = "";

                        /**
                         * AdGroupCriterionLabel adGroupCriterion.
                         * @member {google.protobuf.IStringValue|null|undefined} adGroupCriterion
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionLabel
                         * @instance
                         */
                        AdGroupCriterionLabel.prototype.adGroupCriterion = null;

                        /**
                         * AdGroupCriterionLabel label.
                         * @member {google.protobuf.IStringValue|null|undefined} label
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionLabel
                         * @instance
                         */
                        AdGroupCriterionLabel.prototype.label = null;

                        /**
                         * Creates a new AdGroupCriterionLabel instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupCriterionLabel=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AdGroupCriterionLabel} AdGroupCriterionLabel instance
                         */
                        AdGroupCriterionLabel.create = function create(properties) {
                            return new AdGroupCriterionLabel(properties);
                        };

                        /**
                         * Encodes the specified AdGroupCriterionLabel message. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupCriterionLabel.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupCriterionLabel} message AdGroupCriterionLabel message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupCriterionLabel.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.adGroupCriterion != null && message.hasOwnProperty("adGroupCriterion"))
                                $root.google.protobuf.StringValue.encode(message.adGroupCriterion, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.label != null && message.hasOwnProperty("label"))
                                $root.google.protobuf.StringValue.encode(message.label, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupCriterionLabel message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupCriterionLabel.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupCriterionLabel} message AdGroupCriterionLabel message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupCriterionLabel.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupCriterionLabel message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionLabel
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AdGroupCriterionLabel} AdGroupCriterionLabel
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupCriterionLabel.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AdGroupCriterionLabel();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.adGroupCriterion = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.label = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupCriterionLabel message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionLabel
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AdGroupCriterionLabel} AdGroupCriterionLabel
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupCriterionLabel.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupCriterionLabel message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionLabel
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupCriterionLabel.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.adGroupCriterion != null && message.hasOwnProperty("adGroupCriterion")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adGroupCriterion);
                                if (error)
                                    return "adGroupCriterion." + error;
                            }
                            if (message.label != null && message.hasOwnProperty("label")) {
                                var error = $root.google.protobuf.StringValue.verify(message.label);
                                if (error)
                                    return "label." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an AdGroupCriterionLabel message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionLabel
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AdGroupCriterionLabel} AdGroupCriterionLabel
                         */
                        AdGroupCriterionLabel.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AdGroupCriterionLabel)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AdGroupCriterionLabel();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.adGroupCriterion != null) {
                                if (typeof object.adGroupCriterion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterionLabel.adGroupCriterion: object expected");
                                message.adGroupCriterion = $root.google.protobuf.StringValue.fromObject(object.adGroupCriterion);
                            }
                            if (object.label != null) {
                                if (typeof object.label !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterionLabel.label: object expected");
                                message.label = $root.google.protobuf.StringValue.fromObject(object.label);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupCriterionLabel message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.AdGroupCriterionLabel} message AdGroupCriterionLabel
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupCriterionLabel.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.adGroupCriterion = null;
                                object.label = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.adGroupCriterion != null && message.hasOwnProperty("adGroupCriterion"))
                                object.adGroupCriterion = $root.google.protobuf.StringValue.toObject(message.adGroupCriterion, options);
                            if (message.label != null && message.hasOwnProperty("label"))
                                object.label = $root.google.protobuf.StringValue.toObject(message.label, options);
                            return object;
                        };

                        /**
                         * Converts this AdGroupCriterionLabel to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionLabel
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupCriterionLabel.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupCriterionLabel;
                    })();

                    resources.AdGroupCriterionSimulation = (function() {

                        /**
                         * Properties of an AdGroupCriterionSimulation.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAdGroupCriterionSimulation
                         * @property {string|null} [resourceName] AdGroupCriterionSimulation resourceName
                         * @property {google.protobuf.IInt64Value|null} [adGroupId] AdGroupCriterionSimulation adGroupId
                         * @property {google.protobuf.IInt64Value|null} [criterionId] AdGroupCriterionSimulation criterionId
                         * @property {google.ads.googleads.v1.enums.SimulationTypeEnum.SimulationType|null} [type] AdGroupCriterionSimulation type
                         * @property {google.ads.googleads.v1.enums.SimulationModificationMethodEnum.SimulationModificationMethod|null} [modificationMethod] AdGroupCriterionSimulation modificationMethod
                         * @property {google.protobuf.IStringValue|null} [startDate] AdGroupCriterionSimulation startDate
                         * @property {google.protobuf.IStringValue|null} [endDate] AdGroupCriterionSimulation endDate
                         * @property {google.ads.googleads.v1.common.ICpcBidSimulationPointList|null} [cpcBidPointList] AdGroupCriterionSimulation cpcBidPointList
                         */

                        /**
                         * Constructs a new AdGroupCriterionSimulation.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AdGroupCriterionSimulation.
                         * @implements IAdGroupCriterionSimulation
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAdGroupCriterionSimulation=} [properties] Properties to set
                         */
                        function AdGroupCriterionSimulation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupCriterionSimulation resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionSimulation
                         * @instance
                         */
                        AdGroupCriterionSimulation.prototype.resourceName = "";

                        /**
                         * AdGroupCriterionSimulation adGroupId.
                         * @member {google.protobuf.IInt64Value|null|undefined} adGroupId
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionSimulation
                         * @instance
                         */
                        AdGroupCriterionSimulation.prototype.adGroupId = null;

                        /**
                         * AdGroupCriterionSimulation criterionId.
                         * @member {google.protobuf.IInt64Value|null|undefined} criterionId
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionSimulation
                         * @instance
                         */
                        AdGroupCriterionSimulation.prototype.criterionId = null;

                        /**
                         * AdGroupCriterionSimulation type.
                         * @member {google.ads.googleads.v1.enums.SimulationTypeEnum.SimulationType} type
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionSimulation
                         * @instance
                         */
                        AdGroupCriterionSimulation.prototype.type = 0;

                        /**
                         * AdGroupCriterionSimulation modificationMethod.
                         * @member {google.ads.googleads.v1.enums.SimulationModificationMethodEnum.SimulationModificationMethod} modificationMethod
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionSimulation
                         * @instance
                         */
                        AdGroupCriterionSimulation.prototype.modificationMethod = 0;

                        /**
                         * AdGroupCriterionSimulation startDate.
                         * @member {google.protobuf.IStringValue|null|undefined} startDate
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionSimulation
                         * @instance
                         */
                        AdGroupCriterionSimulation.prototype.startDate = null;

                        /**
                         * AdGroupCriterionSimulation endDate.
                         * @member {google.protobuf.IStringValue|null|undefined} endDate
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionSimulation
                         * @instance
                         */
                        AdGroupCriterionSimulation.prototype.endDate = null;

                        /**
                         * AdGroupCriterionSimulation cpcBidPointList.
                         * @member {google.ads.googleads.v1.common.ICpcBidSimulationPointList|null|undefined} cpcBidPointList
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionSimulation
                         * @instance
                         */
                        AdGroupCriterionSimulation.prototype.cpcBidPointList = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AdGroupCriterionSimulation pointList.
                         * @member {"cpcBidPointList"|undefined} pointList
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionSimulation
                         * @instance
                         */
                        Object.defineProperty(AdGroupCriterionSimulation.prototype, "pointList", {
                            get: $util.oneOfGetter($oneOfFields = ["cpcBidPointList"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AdGroupCriterionSimulation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionSimulation
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupCriterionSimulation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AdGroupCriterionSimulation} AdGroupCriterionSimulation instance
                         */
                        AdGroupCriterionSimulation.create = function create(properties) {
                            return new AdGroupCriterionSimulation(properties);
                        };

                        /**
                         * Encodes the specified AdGroupCriterionSimulation message. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupCriterionSimulation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionSimulation
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupCriterionSimulation} message AdGroupCriterionSimulation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupCriterionSimulation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.adGroupId != null && message.hasOwnProperty("adGroupId"))
                                $root.google.protobuf.Int64Value.encode(message.adGroupId, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.criterionId != null && message.hasOwnProperty("criterionId"))
                                $root.google.protobuf.Int64Value.encode(message.criterionId, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.type);
                            if (message.modificationMethod != null && message.hasOwnProperty("modificationMethod"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.modificationMethod);
                            if (message.startDate != null && message.hasOwnProperty("startDate"))
                                $root.google.protobuf.StringValue.encode(message.startDate, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.endDate != null && message.hasOwnProperty("endDate"))
                                $root.google.protobuf.StringValue.encode(message.endDate, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.cpcBidPointList != null && message.hasOwnProperty("cpcBidPointList"))
                                $root.google.ads.googleads.v1.common.CpcBidSimulationPointList.encode(message.cpcBidPointList, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupCriterionSimulation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupCriterionSimulation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionSimulation
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupCriterionSimulation} message AdGroupCriterionSimulation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupCriterionSimulation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupCriterionSimulation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionSimulation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AdGroupCriterionSimulation} AdGroupCriterionSimulation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupCriterionSimulation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AdGroupCriterionSimulation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.adGroupId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.criterionId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.type = reader.int32();
                                    break;
                                case 5:
                                    message.modificationMethod = reader.int32();
                                    break;
                                case 6:
                                    message.startDate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.endDate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.cpcBidPointList = $root.google.ads.googleads.v1.common.CpcBidSimulationPointList.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupCriterionSimulation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionSimulation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AdGroupCriterionSimulation} AdGroupCriterionSimulation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupCriterionSimulation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupCriterionSimulation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionSimulation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupCriterionSimulation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.adGroupId != null && message.hasOwnProperty("adGroupId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.adGroupId);
                                if (error)
                                    return "adGroupId." + error;
                            }
                            if (message.criterionId != null && message.hasOwnProperty("criterionId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.criterionId);
                                if (error)
                                    return "criterionId." + error;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            if (message.modificationMethod != null && message.hasOwnProperty("modificationMethod"))
                                switch (message.modificationMethod) {
                                default:
                                    return "modificationMethod: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.startDate != null && message.hasOwnProperty("startDate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.startDate);
                                if (error)
                                    return "startDate." + error;
                            }
                            if (message.endDate != null && message.hasOwnProperty("endDate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.endDate);
                                if (error)
                                    return "endDate." + error;
                            }
                            if (message.cpcBidPointList != null && message.hasOwnProperty("cpcBidPointList")) {
                                properties.pointList = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.CpcBidSimulationPointList.verify(message.cpcBidPointList);
                                    if (error)
                                        return "cpcBidPointList." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an AdGroupCriterionSimulation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionSimulation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AdGroupCriterionSimulation} AdGroupCriterionSimulation
                         */
                        AdGroupCriterionSimulation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AdGroupCriterionSimulation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AdGroupCriterionSimulation();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.adGroupId != null) {
                                if (typeof object.adGroupId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterionSimulation.adGroupId: object expected");
                                message.adGroupId = $root.google.protobuf.Int64Value.fromObject(object.adGroupId);
                            }
                            if (object.criterionId != null) {
                                if (typeof object.criterionId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterionSimulation.criterionId: object expected");
                                message.criterionId = $root.google.protobuf.Int64Value.fromObject(object.criterionId);
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "CPC_BID":
                            case 2:
                                message.type = 2;
                                break;
                            case "CPV_BID":
                            case 3:
                                message.type = 3;
                                break;
                            case "TARGET_CPA":
                            case 4:
                                message.type = 4;
                                break;
                            case "BID_MODIFIER":
                            case 5:
                                message.type = 5;
                                break;
                            }
                            switch (object.modificationMethod) {
                            case "UNSPECIFIED":
                            case 0:
                                message.modificationMethod = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.modificationMethod = 1;
                                break;
                            case "UNIFORM":
                            case 2:
                                message.modificationMethod = 2;
                                break;
                            case "DEFAULT":
                            case 3:
                                message.modificationMethod = 3;
                                break;
                            }
                            if (object.startDate != null) {
                                if (typeof object.startDate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterionSimulation.startDate: object expected");
                                message.startDate = $root.google.protobuf.StringValue.fromObject(object.startDate);
                            }
                            if (object.endDate != null) {
                                if (typeof object.endDate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterionSimulation.endDate: object expected");
                                message.endDate = $root.google.protobuf.StringValue.fromObject(object.endDate);
                            }
                            if (object.cpcBidPointList != null) {
                                if (typeof object.cpcBidPointList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupCriterionSimulation.cpcBidPointList: object expected");
                                message.cpcBidPointList = $root.google.ads.googleads.v1.common.CpcBidSimulationPointList.fromObject(object.cpcBidPointList);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupCriterionSimulation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionSimulation
                         * @static
                         * @param {google.ads.googleads.v1.resources.AdGroupCriterionSimulation} message AdGroupCriterionSimulation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupCriterionSimulation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.adGroupId = null;
                                object.criterionId = null;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.modificationMethod = options.enums === String ? "UNSPECIFIED" : 0;
                                object.startDate = null;
                                object.endDate = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.adGroupId != null && message.hasOwnProperty("adGroupId"))
                                object.adGroupId = $root.google.protobuf.Int64Value.toObject(message.adGroupId, options);
                            if (message.criterionId != null && message.hasOwnProperty("criterionId"))
                                object.criterionId = $root.google.protobuf.Int64Value.toObject(message.criterionId, options);
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.SimulationTypeEnum.SimulationType[message.type] : message.type;
                            if (message.modificationMethod != null && message.hasOwnProperty("modificationMethod"))
                                object.modificationMethod = options.enums === String ? $root.google.ads.googleads.v1.enums.SimulationModificationMethodEnum.SimulationModificationMethod[message.modificationMethod] : message.modificationMethod;
                            if (message.startDate != null && message.hasOwnProperty("startDate"))
                                object.startDate = $root.google.protobuf.StringValue.toObject(message.startDate, options);
                            if (message.endDate != null && message.hasOwnProperty("endDate"))
                                object.endDate = $root.google.protobuf.StringValue.toObject(message.endDate, options);
                            if (message.cpcBidPointList != null && message.hasOwnProperty("cpcBidPointList")) {
                                object.cpcBidPointList = $root.google.ads.googleads.v1.common.CpcBidSimulationPointList.toObject(message.cpcBidPointList, options);
                                if (options.oneofs)
                                    object.pointList = "cpcBidPointList";
                            }
                            return object;
                        };

                        /**
                         * Converts this AdGroupCriterionSimulation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AdGroupCriterionSimulation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupCriterionSimulation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupCriterionSimulation;
                    })();

                    resources.AdGroupExtensionSetting = (function() {

                        /**
                         * Properties of an AdGroupExtensionSetting.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAdGroupExtensionSetting
                         * @property {string|null} [resourceName] AdGroupExtensionSetting resourceName
                         * @property {google.ads.googleads.v1.enums.ExtensionTypeEnum.ExtensionType|null} [extensionType] AdGroupExtensionSetting extensionType
                         * @property {google.protobuf.IStringValue|null} [adGroup] AdGroupExtensionSetting adGroup
                         * @property {Array.<google.protobuf.IStringValue>|null} [extensionFeedItems] AdGroupExtensionSetting extensionFeedItems
                         * @property {google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum.ExtensionSettingDevice|null} [device] AdGroupExtensionSetting device
                         */

                        /**
                         * Constructs a new AdGroupExtensionSetting.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AdGroupExtensionSetting.
                         * @implements IAdGroupExtensionSetting
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAdGroupExtensionSetting=} [properties] Properties to set
                         */
                        function AdGroupExtensionSetting(properties) {
                            this.extensionFeedItems = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupExtensionSetting resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.AdGroupExtensionSetting
                         * @instance
                         */
                        AdGroupExtensionSetting.prototype.resourceName = "";

                        /**
                         * AdGroupExtensionSetting extensionType.
                         * @member {google.ads.googleads.v1.enums.ExtensionTypeEnum.ExtensionType} extensionType
                         * @memberof google.ads.googleads.v1.resources.AdGroupExtensionSetting
                         * @instance
                         */
                        AdGroupExtensionSetting.prototype.extensionType = 0;

                        /**
                         * AdGroupExtensionSetting adGroup.
                         * @member {google.protobuf.IStringValue|null|undefined} adGroup
                         * @memberof google.ads.googleads.v1.resources.AdGroupExtensionSetting
                         * @instance
                         */
                        AdGroupExtensionSetting.prototype.adGroup = null;

                        /**
                         * AdGroupExtensionSetting extensionFeedItems.
                         * @member {Array.<google.protobuf.IStringValue>} extensionFeedItems
                         * @memberof google.ads.googleads.v1.resources.AdGroupExtensionSetting
                         * @instance
                         */
                        AdGroupExtensionSetting.prototype.extensionFeedItems = $util.emptyArray;

                        /**
                         * AdGroupExtensionSetting device.
                         * @member {google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum.ExtensionSettingDevice} device
                         * @memberof google.ads.googleads.v1.resources.AdGroupExtensionSetting
                         * @instance
                         */
                        AdGroupExtensionSetting.prototype.device = 0;

                        /**
                         * Creates a new AdGroupExtensionSetting instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AdGroupExtensionSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupExtensionSetting=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AdGroupExtensionSetting} AdGroupExtensionSetting instance
                         */
                        AdGroupExtensionSetting.create = function create(properties) {
                            return new AdGroupExtensionSetting(properties);
                        };

                        /**
                         * Encodes the specified AdGroupExtensionSetting message. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupExtensionSetting.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AdGroupExtensionSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupExtensionSetting} message AdGroupExtensionSetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupExtensionSetting.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.extensionType != null && message.hasOwnProperty("extensionType"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.extensionType);
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                $root.google.protobuf.StringValue.encode(message.adGroup, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.extensionFeedItems != null && message.extensionFeedItems.length)
                                for (var i = 0; i < message.extensionFeedItems.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.extensionFeedItems[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.device != null && message.hasOwnProperty("device"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.device);
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupExtensionSetting message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupExtensionSetting.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupExtensionSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupExtensionSetting} message AdGroupExtensionSetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupExtensionSetting.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupExtensionSetting message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AdGroupExtensionSetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AdGroupExtensionSetting} AdGroupExtensionSetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupExtensionSetting.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.extensionType = reader.int32();
                                    break;
                                case 3:
                                    message.adGroup = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    if (!(message.extensionFeedItems && message.extensionFeedItems.length))
                                        message.extensionFeedItems = [];
                                    message.extensionFeedItems.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 5:
                                    message.device = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupExtensionSetting message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupExtensionSetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AdGroupExtensionSetting} AdGroupExtensionSetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupExtensionSetting.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupExtensionSetting message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AdGroupExtensionSetting
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupExtensionSetting.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.extensionType != null && message.hasOwnProperty("extensionType"))
                                switch (message.extensionType) {
                                default:
                                    return "extensionType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                    break;
                                }
                            if (message.adGroup != null && message.hasOwnProperty("adGroup")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adGroup);
                                if (error)
                                    return "adGroup." + error;
                            }
                            if (message.extensionFeedItems != null && message.hasOwnProperty("extensionFeedItems")) {
                                if (!Array.isArray(message.extensionFeedItems))
                                    return "extensionFeedItems: array expected";
                                for (var i = 0; i < message.extensionFeedItems.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.extensionFeedItems[i]);
                                    if (error)
                                        return "extensionFeedItems." + error;
                                }
                            }
                            if (message.device != null && message.hasOwnProperty("device"))
                                switch (message.device) {
                                default:
                                    return "device: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates an AdGroupExtensionSetting message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupExtensionSetting
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AdGroupExtensionSetting} AdGroupExtensionSetting
                         */
                        AdGroupExtensionSetting.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            switch (object.extensionType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.extensionType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.extensionType = 1;
                                break;
                            case "NONE":
                            case 2:
                                message.extensionType = 2;
                                break;
                            case "APP":
                            case 3:
                                message.extensionType = 3;
                                break;
                            case "CALL":
                            case 4:
                                message.extensionType = 4;
                                break;
                            case "CALLOUT":
                            case 5:
                                message.extensionType = 5;
                                break;
                            case "MESSAGE":
                            case 6:
                                message.extensionType = 6;
                                break;
                            case "PRICE":
                            case 7:
                                message.extensionType = 7;
                                break;
                            case "PROMOTION":
                            case 8:
                                message.extensionType = 8;
                                break;
                            case "REVIEW":
                            case 9:
                                message.extensionType = 9;
                                break;
                            case "SITELINK":
                            case 10:
                                message.extensionType = 10;
                                break;
                            case "STRUCTURED_SNIPPET":
                            case 11:
                                message.extensionType = 11;
                                break;
                            case "LOCATION":
                            case 12:
                                message.extensionType = 12;
                                break;
                            case "AFFILIATE_LOCATION":
                            case 13:
                                message.extensionType = 13;
                                break;
                            }
                            if (object.adGroup != null) {
                                if (typeof object.adGroup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupExtensionSetting.adGroup: object expected");
                                message.adGroup = $root.google.protobuf.StringValue.fromObject(object.adGroup);
                            }
                            if (object.extensionFeedItems) {
                                if (!Array.isArray(object.extensionFeedItems))
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupExtensionSetting.extensionFeedItems: array expected");
                                message.extensionFeedItems = [];
                                for (var i = 0; i < object.extensionFeedItems.length; ++i) {
                                    if (typeof object.extensionFeedItems[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.AdGroupExtensionSetting.extensionFeedItems: object expected");
                                    message.extensionFeedItems[i] = $root.google.protobuf.StringValue.fromObject(object.extensionFeedItems[i]);
                                }
                            }
                            switch (object.device) {
                            case "UNSPECIFIED":
                            case 0:
                                message.device = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.device = 1;
                                break;
                            case "MOBILE":
                            case 2:
                                message.device = 2;
                                break;
                            case "DESKTOP":
                            case 3:
                                message.device = 3;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupExtensionSetting message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupExtensionSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.AdGroupExtensionSetting} message AdGroupExtensionSetting
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupExtensionSetting.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.extensionFeedItems = [];
                            if (options.defaults) {
                                object.resourceName = "";
                                object.extensionType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.adGroup = null;
                                object.device = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.extensionType != null && message.hasOwnProperty("extensionType"))
                                object.extensionType = options.enums === String ? $root.google.ads.googleads.v1.enums.ExtensionTypeEnum.ExtensionType[message.extensionType] : message.extensionType;
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                object.adGroup = $root.google.protobuf.StringValue.toObject(message.adGroup, options);
                            if (message.extensionFeedItems && message.extensionFeedItems.length) {
                                object.extensionFeedItems = [];
                                for (var j = 0; j < message.extensionFeedItems.length; ++j)
                                    object.extensionFeedItems[j] = $root.google.protobuf.StringValue.toObject(message.extensionFeedItems[j], options);
                            }
                            if (message.device != null && message.hasOwnProperty("device"))
                                object.device = options.enums === String ? $root.google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum.ExtensionSettingDevice[message.device] : message.device;
                            return object;
                        };

                        /**
                         * Converts this AdGroupExtensionSetting to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AdGroupExtensionSetting
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupExtensionSetting.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupExtensionSetting;
                    })();

                    resources.AdGroupFeed = (function() {

                        /**
                         * Properties of an AdGroupFeed.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAdGroupFeed
                         * @property {string|null} [resourceName] AdGroupFeed resourceName
                         * @property {google.protobuf.IStringValue|null} [feed] AdGroupFeed feed
                         * @property {google.protobuf.IStringValue|null} [adGroup] AdGroupFeed adGroup
                         * @property {Array.<google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType>|null} [placeholderTypes] AdGroupFeed placeholderTypes
                         * @property {google.ads.googleads.v1.common.IMatchingFunction|null} [matchingFunction] AdGroupFeed matchingFunction
                         * @property {google.ads.googleads.v1.enums.FeedLinkStatusEnum.FeedLinkStatus|null} [status] AdGroupFeed status
                         */

                        /**
                         * Constructs a new AdGroupFeed.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AdGroupFeed.
                         * @implements IAdGroupFeed
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAdGroupFeed=} [properties] Properties to set
                         */
                        function AdGroupFeed(properties) {
                            this.placeholderTypes = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupFeed resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.AdGroupFeed
                         * @instance
                         */
                        AdGroupFeed.prototype.resourceName = "";

                        /**
                         * AdGroupFeed feed.
                         * @member {google.protobuf.IStringValue|null|undefined} feed
                         * @memberof google.ads.googleads.v1.resources.AdGroupFeed
                         * @instance
                         */
                        AdGroupFeed.prototype.feed = null;

                        /**
                         * AdGroupFeed adGroup.
                         * @member {google.protobuf.IStringValue|null|undefined} adGroup
                         * @memberof google.ads.googleads.v1.resources.AdGroupFeed
                         * @instance
                         */
                        AdGroupFeed.prototype.adGroup = null;

                        /**
                         * AdGroupFeed placeholderTypes.
                         * @member {Array.<google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType>} placeholderTypes
                         * @memberof google.ads.googleads.v1.resources.AdGroupFeed
                         * @instance
                         */
                        AdGroupFeed.prototype.placeholderTypes = $util.emptyArray;

                        /**
                         * AdGroupFeed matchingFunction.
                         * @member {google.ads.googleads.v1.common.IMatchingFunction|null|undefined} matchingFunction
                         * @memberof google.ads.googleads.v1.resources.AdGroupFeed
                         * @instance
                         */
                        AdGroupFeed.prototype.matchingFunction = null;

                        /**
                         * AdGroupFeed status.
                         * @member {google.ads.googleads.v1.enums.FeedLinkStatusEnum.FeedLinkStatus} status
                         * @memberof google.ads.googleads.v1.resources.AdGroupFeed
                         * @instance
                         */
                        AdGroupFeed.prototype.status = 0;

                        /**
                         * Creates a new AdGroupFeed instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AdGroupFeed
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupFeed=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AdGroupFeed} AdGroupFeed instance
                         */
                        AdGroupFeed.create = function create(properties) {
                            return new AdGroupFeed(properties);
                        };

                        /**
                         * Encodes the specified AdGroupFeed message. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupFeed.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AdGroupFeed
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupFeed} message AdGroupFeed message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupFeed.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.feed != null && message.hasOwnProperty("feed"))
                                $root.google.protobuf.StringValue.encode(message.feed, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                $root.google.protobuf.StringValue.encode(message.adGroup, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.placeholderTypes != null && message.placeholderTypes.length) {
                                writer.uint32(/* id 4, wireType 2 =*/34).fork();
                                for (var i = 0; i < message.placeholderTypes.length; ++i)
                                    writer.int32(message.placeholderTypes[i]);
                                writer.ldelim();
                            }
                            if (message.matchingFunction != null && message.hasOwnProperty("matchingFunction"))
                                $root.google.ads.googleads.v1.common.MatchingFunction.encode(message.matchingFunction, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.status);
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupFeed message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupFeed.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupFeed
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupFeed} message AdGroupFeed message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupFeed.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupFeed message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AdGroupFeed
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AdGroupFeed} AdGroupFeed
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupFeed.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AdGroupFeed();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.feed = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.adGroup = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    if (!(message.placeholderTypes && message.placeholderTypes.length))
                                        message.placeholderTypes = [];
                                    if ((tag & 7) === 2) {
                                        var end2 = reader.uint32() + reader.pos;
                                        while (reader.pos < end2)
                                            message.placeholderTypes.push(reader.int32());
                                    } else
                                        message.placeholderTypes.push(reader.int32());
                                    break;
                                case 5:
                                    message.matchingFunction = $root.google.ads.googleads.v1.common.MatchingFunction.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.status = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupFeed message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupFeed
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AdGroupFeed} AdGroupFeed
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupFeed.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupFeed message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AdGroupFeed
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupFeed.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.feed != null && message.hasOwnProperty("feed")) {
                                var error = $root.google.protobuf.StringValue.verify(message.feed);
                                if (error)
                                    return "feed." + error;
                            }
                            if (message.adGroup != null && message.hasOwnProperty("adGroup")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adGroup);
                                if (error)
                                    return "adGroup." + error;
                            }
                            if (message.placeholderTypes != null && message.hasOwnProperty("placeholderTypes")) {
                                if (!Array.isArray(message.placeholderTypes))
                                    return "placeholderTypes: array expected";
                                for (var i = 0; i < message.placeholderTypes.length; ++i)
                                    switch (message.placeholderTypes[i]) {
                                    default:
                                        return "placeholderTypes: enum value[] expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                    case 5:
                                    case 6:
                                    case 7:
                                    case 8:
                                    case 9:
                                    case 10:
                                    case 11:
                                    case 12:
                                    case 13:
                                    case 14:
                                    case 15:
                                    case 16:
                                    case 17:
                                    case 18:
                                    case 19:
                                    case 20:
                                        break;
                                    }
                            }
                            if (message.matchingFunction != null && message.hasOwnProperty("matchingFunction")) {
                                var error = $root.google.ads.googleads.v1.common.MatchingFunction.verify(message.matchingFunction);
                                if (error)
                                    return "matchingFunction." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates an AdGroupFeed message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupFeed
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AdGroupFeed} AdGroupFeed
                         */
                        AdGroupFeed.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AdGroupFeed)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AdGroupFeed();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.feed != null) {
                                if (typeof object.feed !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupFeed.feed: object expected");
                                message.feed = $root.google.protobuf.StringValue.fromObject(object.feed);
                            }
                            if (object.adGroup != null) {
                                if (typeof object.adGroup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupFeed.adGroup: object expected");
                                message.adGroup = $root.google.protobuf.StringValue.fromObject(object.adGroup);
                            }
                            if (object.placeholderTypes) {
                                if (!Array.isArray(object.placeholderTypes))
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupFeed.placeholderTypes: array expected");
                                message.placeholderTypes = [];
                                for (var i = 0; i < object.placeholderTypes.length; ++i)
                                    switch (object.placeholderTypes[i]) {
                                    default:
                                    case "UNSPECIFIED":
                                    case 0:
                                        message.placeholderTypes[i] = 0;
                                        break;
                                    case "UNKNOWN":
                                    case 1:
                                        message.placeholderTypes[i] = 1;
                                        break;
                                    case "SITELINK":
                                    case 2:
                                        message.placeholderTypes[i] = 2;
                                        break;
                                    case "CALL":
                                    case 3:
                                        message.placeholderTypes[i] = 3;
                                        break;
                                    case "APP":
                                    case 4:
                                        message.placeholderTypes[i] = 4;
                                        break;
                                    case "LOCATION":
                                    case 5:
                                        message.placeholderTypes[i] = 5;
                                        break;
                                    case "AFFILIATE_LOCATION":
                                    case 6:
                                        message.placeholderTypes[i] = 6;
                                        break;
                                    case "CALLOUT":
                                    case 7:
                                        message.placeholderTypes[i] = 7;
                                        break;
                                    case "STRUCTURED_SNIPPET":
                                    case 8:
                                        message.placeholderTypes[i] = 8;
                                        break;
                                    case "MESSAGE":
                                    case 9:
                                        message.placeholderTypes[i] = 9;
                                        break;
                                    case "PRICE":
                                    case 10:
                                        message.placeholderTypes[i] = 10;
                                        break;
                                    case "PROMOTION":
                                    case 11:
                                        message.placeholderTypes[i] = 11;
                                        break;
                                    case "AD_CUSTOMIZER":
                                    case 12:
                                        message.placeholderTypes[i] = 12;
                                        break;
                                    case "DYNAMIC_EDUCATION":
                                    case 13:
                                        message.placeholderTypes[i] = 13;
                                        break;
                                    case "DYNAMIC_FLIGHT":
                                    case 14:
                                        message.placeholderTypes[i] = 14;
                                        break;
                                    case "DYNAMIC_CUSTOM":
                                    case 15:
                                        message.placeholderTypes[i] = 15;
                                        break;
                                    case "DYNAMIC_HOTEL":
                                    case 16:
                                        message.placeholderTypes[i] = 16;
                                        break;
                                    case "DYNAMIC_REAL_ESTATE":
                                    case 17:
                                        message.placeholderTypes[i] = 17;
                                        break;
                                    case "DYNAMIC_TRAVEL":
                                    case 18:
                                        message.placeholderTypes[i] = 18;
                                        break;
                                    case "DYNAMIC_LOCAL":
                                    case 19:
                                        message.placeholderTypes[i] = 19;
                                        break;
                                    case "DYNAMIC_JOB":
                                    case 20:
                                        message.placeholderTypes[i] = 20;
                                        break;
                                    }
                            }
                            if (object.matchingFunction != null) {
                                if (typeof object.matchingFunction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupFeed.matchingFunction: object expected");
                                message.matchingFunction = $root.google.ads.googleads.v1.common.MatchingFunction.fromObject(object.matchingFunction);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "REMOVED":
                            case 3:
                                message.status = 3;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupFeed message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupFeed
                         * @static
                         * @param {google.ads.googleads.v1.resources.AdGroupFeed} message AdGroupFeed
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupFeed.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.placeholderTypes = [];
                            if (options.defaults) {
                                object.resourceName = "";
                                object.feed = null;
                                object.adGroup = null;
                                object.matchingFunction = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.feed != null && message.hasOwnProperty("feed"))
                                object.feed = $root.google.protobuf.StringValue.toObject(message.feed, options);
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                object.adGroup = $root.google.protobuf.StringValue.toObject(message.adGroup, options);
                            if (message.placeholderTypes && message.placeholderTypes.length) {
                                object.placeholderTypes = [];
                                for (var j = 0; j < message.placeholderTypes.length; ++j)
                                    object.placeholderTypes[j] = options.enums === String ? $root.google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType[message.placeholderTypes[j]] : message.placeholderTypes[j];
                            }
                            if (message.matchingFunction != null && message.hasOwnProperty("matchingFunction"))
                                object.matchingFunction = $root.google.ads.googleads.v1.common.MatchingFunction.toObject(message.matchingFunction, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.FeedLinkStatusEnum.FeedLinkStatus[message.status] : message.status;
                            return object;
                        };

                        /**
                         * Converts this AdGroupFeed to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AdGroupFeed
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupFeed.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupFeed;
                    })();

                    resources.AdGroupLabel = (function() {

                        /**
                         * Properties of an AdGroupLabel.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAdGroupLabel
                         * @property {string|null} [resourceName] AdGroupLabel resourceName
                         * @property {google.protobuf.IStringValue|null} [adGroup] AdGroupLabel adGroup
                         * @property {google.protobuf.IStringValue|null} [label] AdGroupLabel label
                         */

                        /**
                         * Constructs a new AdGroupLabel.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AdGroupLabel.
                         * @implements IAdGroupLabel
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAdGroupLabel=} [properties] Properties to set
                         */
                        function AdGroupLabel(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupLabel resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.AdGroupLabel
                         * @instance
                         */
                        AdGroupLabel.prototype.resourceName = "";

                        /**
                         * AdGroupLabel adGroup.
                         * @member {google.protobuf.IStringValue|null|undefined} adGroup
                         * @memberof google.ads.googleads.v1.resources.AdGroupLabel
                         * @instance
                         */
                        AdGroupLabel.prototype.adGroup = null;

                        /**
                         * AdGroupLabel label.
                         * @member {google.protobuf.IStringValue|null|undefined} label
                         * @memberof google.ads.googleads.v1.resources.AdGroupLabel
                         * @instance
                         */
                        AdGroupLabel.prototype.label = null;

                        /**
                         * Creates a new AdGroupLabel instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AdGroupLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupLabel=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AdGroupLabel} AdGroupLabel instance
                         */
                        AdGroupLabel.create = function create(properties) {
                            return new AdGroupLabel(properties);
                        };

                        /**
                         * Encodes the specified AdGroupLabel message. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupLabel.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AdGroupLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupLabel} message AdGroupLabel message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupLabel.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                $root.google.protobuf.StringValue.encode(message.adGroup, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.label != null && message.hasOwnProperty("label"))
                                $root.google.protobuf.StringValue.encode(message.label, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupLabel message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupLabel.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupLabel} message AdGroupLabel message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupLabel.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupLabel message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AdGroupLabel
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AdGroupLabel} AdGroupLabel
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupLabel.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AdGroupLabel();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.adGroup = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.label = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupLabel message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupLabel
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AdGroupLabel} AdGroupLabel
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupLabel.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupLabel message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AdGroupLabel
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupLabel.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.adGroup != null && message.hasOwnProperty("adGroup")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adGroup);
                                if (error)
                                    return "adGroup." + error;
                            }
                            if (message.label != null && message.hasOwnProperty("label")) {
                                var error = $root.google.protobuf.StringValue.verify(message.label);
                                if (error)
                                    return "label." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an AdGroupLabel message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupLabel
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AdGroupLabel} AdGroupLabel
                         */
                        AdGroupLabel.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AdGroupLabel)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AdGroupLabel();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.adGroup != null) {
                                if (typeof object.adGroup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupLabel.adGroup: object expected");
                                message.adGroup = $root.google.protobuf.StringValue.fromObject(object.adGroup);
                            }
                            if (object.label != null) {
                                if (typeof object.label !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupLabel.label: object expected");
                                message.label = $root.google.protobuf.StringValue.fromObject(object.label);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupLabel message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.AdGroupLabel} message AdGroupLabel
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupLabel.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.adGroup = null;
                                object.label = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                object.adGroup = $root.google.protobuf.StringValue.toObject(message.adGroup, options);
                            if (message.label != null && message.hasOwnProperty("label"))
                                object.label = $root.google.protobuf.StringValue.toObject(message.label, options);
                            return object;
                        };

                        /**
                         * Converts this AdGroupLabel to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AdGroupLabel
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupLabel.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupLabel;
                    })();

                    resources.AdGroupSimulation = (function() {

                        /**
                         * Properties of an AdGroupSimulation.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAdGroupSimulation
                         * @property {string|null} [resourceName] AdGroupSimulation resourceName
                         * @property {google.protobuf.IInt64Value|null} [adGroupId] AdGroupSimulation adGroupId
                         * @property {google.ads.googleads.v1.enums.SimulationTypeEnum.SimulationType|null} [type] AdGroupSimulation type
                         * @property {google.ads.googleads.v1.enums.SimulationModificationMethodEnum.SimulationModificationMethod|null} [modificationMethod] AdGroupSimulation modificationMethod
                         * @property {google.protobuf.IStringValue|null} [startDate] AdGroupSimulation startDate
                         * @property {google.protobuf.IStringValue|null} [endDate] AdGroupSimulation endDate
                         * @property {google.ads.googleads.v1.common.ICpcBidSimulationPointList|null} [cpcBidPointList] AdGroupSimulation cpcBidPointList
                         * @property {google.ads.googleads.v1.common.ITargetCpaSimulationPointList|null} [targetCpaPointList] AdGroupSimulation targetCpaPointList
                         */

                        /**
                         * Constructs a new AdGroupSimulation.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AdGroupSimulation.
                         * @implements IAdGroupSimulation
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAdGroupSimulation=} [properties] Properties to set
                         */
                        function AdGroupSimulation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupSimulation resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.AdGroupSimulation
                         * @instance
                         */
                        AdGroupSimulation.prototype.resourceName = "";

                        /**
                         * AdGroupSimulation adGroupId.
                         * @member {google.protobuf.IInt64Value|null|undefined} adGroupId
                         * @memberof google.ads.googleads.v1.resources.AdGroupSimulation
                         * @instance
                         */
                        AdGroupSimulation.prototype.adGroupId = null;

                        /**
                         * AdGroupSimulation type.
                         * @member {google.ads.googleads.v1.enums.SimulationTypeEnum.SimulationType} type
                         * @memberof google.ads.googleads.v1.resources.AdGroupSimulation
                         * @instance
                         */
                        AdGroupSimulation.prototype.type = 0;

                        /**
                         * AdGroupSimulation modificationMethod.
                         * @member {google.ads.googleads.v1.enums.SimulationModificationMethodEnum.SimulationModificationMethod} modificationMethod
                         * @memberof google.ads.googleads.v1.resources.AdGroupSimulation
                         * @instance
                         */
                        AdGroupSimulation.prototype.modificationMethod = 0;

                        /**
                         * AdGroupSimulation startDate.
                         * @member {google.protobuf.IStringValue|null|undefined} startDate
                         * @memberof google.ads.googleads.v1.resources.AdGroupSimulation
                         * @instance
                         */
                        AdGroupSimulation.prototype.startDate = null;

                        /**
                         * AdGroupSimulation endDate.
                         * @member {google.protobuf.IStringValue|null|undefined} endDate
                         * @memberof google.ads.googleads.v1.resources.AdGroupSimulation
                         * @instance
                         */
                        AdGroupSimulation.prototype.endDate = null;

                        /**
                         * AdGroupSimulation cpcBidPointList.
                         * @member {google.ads.googleads.v1.common.ICpcBidSimulationPointList|null|undefined} cpcBidPointList
                         * @memberof google.ads.googleads.v1.resources.AdGroupSimulation
                         * @instance
                         */
                        AdGroupSimulation.prototype.cpcBidPointList = null;

                        /**
                         * AdGroupSimulation targetCpaPointList.
                         * @member {google.ads.googleads.v1.common.ITargetCpaSimulationPointList|null|undefined} targetCpaPointList
                         * @memberof google.ads.googleads.v1.resources.AdGroupSimulation
                         * @instance
                         */
                        AdGroupSimulation.prototype.targetCpaPointList = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AdGroupSimulation pointList.
                         * @member {"cpcBidPointList"|"targetCpaPointList"|undefined} pointList
                         * @memberof google.ads.googleads.v1.resources.AdGroupSimulation
                         * @instance
                         */
                        Object.defineProperty(AdGroupSimulation.prototype, "pointList", {
                            get: $util.oneOfGetter($oneOfFields = ["cpcBidPointList", "targetCpaPointList"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AdGroupSimulation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AdGroupSimulation
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupSimulation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AdGroupSimulation} AdGroupSimulation instance
                         */
                        AdGroupSimulation.create = function create(properties) {
                            return new AdGroupSimulation(properties);
                        };

                        /**
                         * Encodes the specified AdGroupSimulation message. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupSimulation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AdGroupSimulation
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupSimulation} message AdGroupSimulation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupSimulation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.adGroupId != null && message.hasOwnProperty("adGroupId"))
                                $root.google.protobuf.Int64Value.encode(message.adGroupId, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.type);
                            if (message.modificationMethod != null && message.hasOwnProperty("modificationMethod"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.modificationMethod);
                            if (message.startDate != null && message.hasOwnProperty("startDate"))
                                $root.google.protobuf.StringValue.encode(message.startDate, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.endDate != null && message.hasOwnProperty("endDate"))
                                $root.google.protobuf.StringValue.encode(message.endDate, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.cpcBidPointList != null && message.hasOwnProperty("cpcBidPointList"))
                                $root.google.ads.googleads.v1.common.CpcBidSimulationPointList.encode(message.cpcBidPointList, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.targetCpaPointList != null && message.hasOwnProperty("targetCpaPointList"))
                                $root.google.ads.googleads.v1.common.TargetCpaSimulationPointList.encode(message.targetCpaPointList, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupSimulation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AdGroupSimulation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupSimulation
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdGroupSimulation} message AdGroupSimulation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupSimulation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupSimulation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AdGroupSimulation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AdGroupSimulation} AdGroupSimulation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupSimulation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AdGroupSimulation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.adGroupId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.type = reader.int32();
                                    break;
                                case 4:
                                    message.modificationMethod = reader.int32();
                                    break;
                                case 5:
                                    message.startDate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.endDate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.cpcBidPointList = $root.google.ads.googleads.v1.common.CpcBidSimulationPointList.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.targetCpaPointList = $root.google.ads.googleads.v1.common.TargetCpaSimulationPointList.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupSimulation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdGroupSimulation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AdGroupSimulation} AdGroupSimulation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupSimulation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupSimulation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AdGroupSimulation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupSimulation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.adGroupId != null && message.hasOwnProperty("adGroupId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.adGroupId);
                                if (error)
                                    return "adGroupId." + error;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            if (message.modificationMethod != null && message.hasOwnProperty("modificationMethod"))
                                switch (message.modificationMethod) {
                                default:
                                    return "modificationMethod: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.startDate != null && message.hasOwnProperty("startDate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.startDate);
                                if (error)
                                    return "startDate." + error;
                            }
                            if (message.endDate != null && message.hasOwnProperty("endDate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.endDate);
                                if (error)
                                    return "endDate." + error;
                            }
                            if (message.cpcBidPointList != null && message.hasOwnProperty("cpcBidPointList")) {
                                properties.pointList = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.CpcBidSimulationPointList.verify(message.cpcBidPointList);
                                    if (error)
                                        return "cpcBidPointList." + error;
                                }
                            }
                            if (message.targetCpaPointList != null && message.hasOwnProperty("targetCpaPointList")) {
                                if (properties.pointList === 1)
                                    return "pointList: multiple values";
                                properties.pointList = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.TargetCpaSimulationPointList.verify(message.targetCpaPointList);
                                    if (error)
                                        return "targetCpaPointList." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an AdGroupSimulation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupSimulation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AdGroupSimulation} AdGroupSimulation
                         */
                        AdGroupSimulation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AdGroupSimulation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AdGroupSimulation();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.adGroupId != null) {
                                if (typeof object.adGroupId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupSimulation.adGroupId: object expected");
                                message.adGroupId = $root.google.protobuf.Int64Value.fromObject(object.adGroupId);
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "CPC_BID":
                            case 2:
                                message.type = 2;
                                break;
                            case "CPV_BID":
                            case 3:
                                message.type = 3;
                                break;
                            case "TARGET_CPA":
                            case 4:
                                message.type = 4;
                                break;
                            case "BID_MODIFIER":
                            case 5:
                                message.type = 5;
                                break;
                            }
                            switch (object.modificationMethod) {
                            case "UNSPECIFIED":
                            case 0:
                                message.modificationMethod = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.modificationMethod = 1;
                                break;
                            case "UNIFORM":
                            case 2:
                                message.modificationMethod = 2;
                                break;
                            case "DEFAULT":
                            case 3:
                                message.modificationMethod = 3;
                                break;
                            }
                            if (object.startDate != null) {
                                if (typeof object.startDate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupSimulation.startDate: object expected");
                                message.startDate = $root.google.protobuf.StringValue.fromObject(object.startDate);
                            }
                            if (object.endDate != null) {
                                if (typeof object.endDate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupSimulation.endDate: object expected");
                                message.endDate = $root.google.protobuf.StringValue.fromObject(object.endDate);
                            }
                            if (object.cpcBidPointList != null) {
                                if (typeof object.cpcBidPointList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupSimulation.cpcBidPointList: object expected");
                                message.cpcBidPointList = $root.google.ads.googleads.v1.common.CpcBidSimulationPointList.fromObject(object.cpcBidPointList);
                            }
                            if (object.targetCpaPointList != null) {
                                if (typeof object.targetCpaPointList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdGroupSimulation.targetCpaPointList: object expected");
                                message.targetCpaPointList = $root.google.ads.googleads.v1.common.TargetCpaSimulationPointList.fromObject(object.targetCpaPointList);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupSimulation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AdGroupSimulation
                         * @static
                         * @param {google.ads.googleads.v1.resources.AdGroupSimulation} message AdGroupSimulation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupSimulation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.adGroupId = null;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.modificationMethod = options.enums === String ? "UNSPECIFIED" : 0;
                                object.startDate = null;
                                object.endDate = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.adGroupId != null && message.hasOwnProperty("adGroupId"))
                                object.adGroupId = $root.google.protobuf.Int64Value.toObject(message.adGroupId, options);
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.SimulationTypeEnum.SimulationType[message.type] : message.type;
                            if (message.modificationMethod != null && message.hasOwnProperty("modificationMethod"))
                                object.modificationMethod = options.enums === String ? $root.google.ads.googleads.v1.enums.SimulationModificationMethodEnum.SimulationModificationMethod[message.modificationMethod] : message.modificationMethod;
                            if (message.startDate != null && message.hasOwnProperty("startDate"))
                                object.startDate = $root.google.protobuf.StringValue.toObject(message.startDate, options);
                            if (message.endDate != null && message.hasOwnProperty("endDate"))
                                object.endDate = $root.google.protobuf.StringValue.toObject(message.endDate, options);
                            if (message.cpcBidPointList != null && message.hasOwnProperty("cpcBidPointList")) {
                                object.cpcBidPointList = $root.google.ads.googleads.v1.common.CpcBidSimulationPointList.toObject(message.cpcBidPointList, options);
                                if (options.oneofs)
                                    object.pointList = "cpcBidPointList";
                            }
                            if (message.targetCpaPointList != null && message.hasOwnProperty("targetCpaPointList")) {
                                object.targetCpaPointList = $root.google.ads.googleads.v1.common.TargetCpaSimulationPointList.toObject(message.targetCpaPointList, options);
                                if (options.oneofs)
                                    object.pointList = "targetCpaPointList";
                            }
                            return object;
                        };

                        /**
                         * Converts this AdGroupSimulation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AdGroupSimulation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupSimulation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupSimulation;
                    })();

                    resources.AdParameter = (function() {

                        /**
                         * Properties of an AdParameter.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAdParameter
                         * @property {string|null} [resourceName] AdParameter resourceName
                         * @property {google.protobuf.IStringValue|null} [adGroupCriterion] AdParameter adGroupCriterion
                         * @property {google.protobuf.IInt64Value|null} [parameterIndex] AdParameter parameterIndex
                         * @property {google.protobuf.IStringValue|null} [insertionText] AdParameter insertionText
                         */

                        /**
                         * Constructs a new AdParameter.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AdParameter.
                         * @implements IAdParameter
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAdParameter=} [properties] Properties to set
                         */
                        function AdParameter(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdParameter resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.AdParameter
                         * @instance
                         */
                        AdParameter.prototype.resourceName = "";

                        /**
                         * AdParameter adGroupCriterion.
                         * @member {google.protobuf.IStringValue|null|undefined} adGroupCriterion
                         * @memberof google.ads.googleads.v1.resources.AdParameter
                         * @instance
                         */
                        AdParameter.prototype.adGroupCriterion = null;

                        /**
                         * AdParameter parameterIndex.
                         * @member {google.protobuf.IInt64Value|null|undefined} parameterIndex
                         * @memberof google.ads.googleads.v1.resources.AdParameter
                         * @instance
                         */
                        AdParameter.prototype.parameterIndex = null;

                        /**
                         * AdParameter insertionText.
                         * @member {google.protobuf.IStringValue|null|undefined} insertionText
                         * @memberof google.ads.googleads.v1.resources.AdParameter
                         * @instance
                         */
                        AdParameter.prototype.insertionText = null;

                        /**
                         * Creates a new AdParameter instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AdParameter
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdParameter=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AdParameter} AdParameter instance
                         */
                        AdParameter.create = function create(properties) {
                            return new AdParameter(properties);
                        };

                        /**
                         * Encodes the specified AdParameter message. Does not implicitly {@link google.ads.googleads.v1.resources.AdParameter.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AdParameter
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdParameter} message AdParameter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdParameter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.adGroupCriterion != null && message.hasOwnProperty("adGroupCriterion"))
                                $root.google.protobuf.StringValue.encode(message.adGroupCriterion, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.parameterIndex != null && message.hasOwnProperty("parameterIndex"))
                                $root.google.protobuf.Int64Value.encode(message.parameterIndex, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.insertionText != null && message.hasOwnProperty("insertionText"))
                                $root.google.protobuf.StringValue.encode(message.insertionText, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdParameter message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AdParameter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdParameter
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdParameter} message AdParameter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdParameter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdParameter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AdParameter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AdParameter} AdParameter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdParameter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AdParameter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.adGroupCriterion = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.parameterIndex = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.insertionText = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdParameter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdParameter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AdParameter} AdParameter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdParameter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdParameter message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AdParameter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdParameter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.adGroupCriterion != null && message.hasOwnProperty("adGroupCriterion")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adGroupCriterion);
                                if (error)
                                    return "adGroupCriterion." + error;
                            }
                            if (message.parameterIndex != null && message.hasOwnProperty("parameterIndex")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.parameterIndex);
                                if (error)
                                    return "parameterIndex." + error;
                            }
                            if (message.insertionText != null && message.hasOwnProperty("insertionText")) {
                                var error = $root.google.protobuf.StringValue.verify(message.insertionText);
                                if (error)
                                    return "insertionText." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an AdParameter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AdParameter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AdParameter} AdParameter
                         */
                        AdParameter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AdParameter)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AdParameter();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.adGroupCriterion != null) {
                                if (typeof object.adGroupCriterion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdParameter.adGroupCriterion: object expected");
                                message.adGroupCriterion = $root.google.protobuf.StringValue.fromObject(object.adGroupCriterion);
                            }
                            if (object.parameterIndex != null) {
                                if (typeof object.parameterIndex !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdParameter.parameterIndex: object expected");
                                message.parameterIndex = $root.google.protobuf.Int64Value.fromObject(object.parameterIndex);
                            }
                            if (object.insertionText != null) {
                                if (typeof object.insertionText !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AdParameter.insertionText: object expected");
                                message.insertionText = $root.google.protobuf.StringValue.fromObject(object.insertionText);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdParameter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AdParameter
                         * @static
                         * @param {google.ads.googleads.v1.resources.AdParameter} message AdParameter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdParameter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.adGroupCriterion = null;
                                object.parameterIndex = null;
                                object.insertionText = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.adGroupCriterion != null && message.hasOwnProperty("adGroupCriterion"))
                                object.adGroupCriterion = $root.google.protobuf.StringValue.toObject(message.adGroupCriterion, options);
                            if (message.parameterIndex != null && message.hasOwnProperty("parameterIndex"))
                                object.parameterIndex = $root.google.protobuf.Int64Value.toObject(message.parameterIndex, options);
                            if (message.insertionText != null && message.hasOwnProperty("insertionText"))
                                object.insertionText = $root.google.protobuf.StringValue.toObject(message.insertionText, options);
                            return object;
                        };

                        /**
                         * Converts this AdParameter to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AdParameter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdParameter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdParameter;
                    })();

                    resources.AdScheduleView = (function() {

                        /**
                         * Properties of an AdScheduleView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAdScheduleView
                         * @property {string|null} [resourceName] AdScheduleView resourceName
                         */

                        /**
                         * Constructs a new AdScheduleView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AdScheduleView.
                         * @implements IAdScheduleView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAdScheduleView=} [properties] Properties to set
                         */
                        function AdScheduleView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdScheduleView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.AdScheduleView
                         * @instance
                         */
                        AdScheduleView.prototype.resourceName = "";

                        /**
                         * Creates a new AdScheduleView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AdScheduleView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdScheduleView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AdScheduleView} AdScheduleView instance
                         */
                        AdScheduleView.create = function create(properties) {
                            return new AdScheduleView(properties);
                        };

                        /**
                         * Encodes the specified AdScheduleView message. Does not implicitly {@link google.ads.googleads.v1.resources.AdScheduleView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AdScheduleView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdScheduleView} message AdScheduleView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdScheduleView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified AdScheduleView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AdScheduleView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdScheduleView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAdScheduleView} message AdScheduleView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdScheduleView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdScheduleView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AdScheduleView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AdScheduleView} AdScheduleView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdScheduleView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AdScheduleView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdScheduleView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AdScheduleView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AdScheduleView} AdScheduleView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdScheduleView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdScheduleView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AdScheduleView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdScheduleView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates an AdScheduleView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AdScheduleView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AdScheduleView} AdScheduleView
                         */
                        AdScheduleView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AdScheduleView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AdScheduleView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdScheduleView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AdScheduleView
                         * @static
                         * @param {google.ads.googleads.v1.resources.AdScheduleView} message AdScheduleView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdScheduleView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this AdScheduleView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AdScheduleView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdScheduleView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdScheduleView;
                    })();

                    resources.AgeRangeView = (function() {

                        /**
                         * Properties of an AgeRangeView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAgeRangeView
                         * @property {string|null} [resourceName] AgeRangeView resourceName
                         */

                        /**
                         * Constructs a new AgeRangeView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AgeRangeView.
                         * @implements IAgeRangeView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAgeRangeView=} [properties] Properties to set
                         */
                        function AgeRangeView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AgeRangeView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.AgeRangeView
                         * @instance
                         */
                        AgeRangeView.prototype.resourceName = "";

                        /**
                         * Creates a new AgeRangeView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AgeRangeView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAgeRangeView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AgeRangeView} AgeRangeView instance
                         */
                        AgeRangeView.create = function create(properties) {
                            return new AgeRangeView(properties);
                        };

                        /**
                         * Encodes the specified AgeRangeView message. Does not implicitly {@link google.ads.googleads.v1.resources.AgeRangeView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AgeRangeView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAgeRangeView} message AgeRangeView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AgeRangeView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified AgeRangeView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AgeRangeView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AgeRangeView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAgeRangeView} message AgeRangeView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AgeRangeView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AgeRangeView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AgeRangeView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AgeRangeView} AgeRangeView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AgeRangeView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AgeRangeView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AgeRangeView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AgeRangeView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AgeRangeView} AgeRangeView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AgeRangeView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AgeRangeView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AgeRangeView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AgeRangeView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates an AgeRangeView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AgeRangeView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AgeRangeView} AgeRangeView
                         */
                        AgeRangeView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AgeRangeView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AgeRangeView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from an AgeRangeView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AgeRangeView
                         * @static
                         * @param {google.ads.googleads.v1.resources.AgeRangeView} message AgeRangeView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AgeRangeView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this AgeRangeView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AgeRangeView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AgeRangeView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AgeRangeView;
                    })();

                    resources.Asset = (function() {

                        /**
                         * Properties of an Asset.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAsset
                         * @property {string|null} [resourceName] Asset resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] Asset id
                         * @property {google.protobuf.IStringValue|null} [name] Asset name
                         * @property {google.ads.googleads.v1.enums.AssetTypeEnum.AssetType|null} [type] Asset type
                         * @property {google.ads.googleads.v1.common.IYoutubeVideoAsset|null} [youtubeVideoAsset] Asset youtubeVideoAsset
                         * @property {google.ads.googleads.v1.common.IMediaBundleAsset|null} [mediaBundleAsset] Asset mediaBundleAsset
                         * @property {google.ads.googleads.v1.common.IImageAsset|null} [imageAsset] Asset imageAsset
                         * @property {google.ads.googleads.v1.common.ITextAsset|null} [textAsset] Asset textAsset
                         */

                        /**
                         * Constructs a new Asset.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an Asset.
                         * @implements IAsset
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAsset=} [properties] Properties to set
                         */
                        function Asset(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Asset resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.Asset
                         * @instance
                         */
                        Asset.prototype.resourceName = "";

                        /**
                         * Asset id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.Asset
                         * @instance
                         */
                        Asset.prototype.id = null;

                        /**
                         * Asset name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.Asset
                         * @instance
                         */
                        Asset.prototype.name = null;

                        /**
                         * Asset type.
                         * @member {google.ads.googleads.v1.enums.AssetTypeEnum.AssetType} type
                         * @memberof google.ads.googleads.v1.resources.Asset
                         * @instance
                         */
                        Asset.prototype.type = 0;

                        /**
                         * Asset youtubeVideoAsset.
                         * @member {google.ads.googleads.v1.common.IYoutubeVideoAsset|null|undefined} youtubeVideoAsset
                         * @memberof google.ads.googleads.v1.resources.Asset
                         * @instance
                         */
                        Asset.prototype.youtubeVideoAsset = null;

                        /**
                         * Asset mediaBundleAsset.
                         * @member {google.ads.googleads.v1.common.IMediaBundleAsset|null|undefined} mediaBundleAsset
                         * @memberof google.ads.googleads.v1.resources.Asset
                         * @instance
                         */
                        Asset.prototype.mediaBundleAsset = null;

                        /**
                         * Asset imageAsset.
                         * @member {google.ads.googleads.v1.common.IImageAsset|null|undefined} imageAsset
                         * @memberof google.ads.googleads.v1.resources.Asset
                         * @instance
                         */
                        Asset.prototype.imageAsset = null;

                        /**
                         * Asset textAsset.
                         * @member {google.ads.googleads.v1.common.ITextAsset|null|undefined} textAsset
                         * @memberof google.ads.googleads.v1.resources.Asset
                         * @instance
                         */
                        Asset.prototype.textAsset = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * Asset assetData.
                         * @member {"youtubeVideoAsset"|"mediaBundleAsset"|"imageAsset"|"textAsset"|undefined} assetData
                         * @memberof google.ads.googleads.v1.resources.Asset
                         * @instance
                         */
                        Object.defineProperty(Asset.prototype, "assetData", {
                            get: $util.oneOfGetter($oneOfFields = ["youtubeVideoAsset", "mediaBundleAsset", "imageAsset", "textAsset"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new Asset instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.Asset
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAsset=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.Asset} Asset instance
                         */
                        Asset.create = function create(properties) {
                            return new Asset(properties);
                        };

                        /**
                         * Encodes the specified Asset message. Does not implicitly {@link google.ads.googleads.v1.resources.Asset.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.Asset
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAsset} message Asset message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Asset.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.type);
                            if (message.youtubeVideoAsset != null && message.hasOwnProperty("youtubeVideoAsset"))
                                $root.google.ads.googleads.v1.common.YoutubeVideoAsset.encode(message.youtubeVideoAsset, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.mediaBundleAsset != null && message.hasOwnProperty("mediaBundleAsset"))
                                $root.google.ads.googleads.v1.common.MediaBundleAsset.encode(message.mediaBundleAsset, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.imageAsset != null && message.hasOwnProperty("imageAsset"))
                                $root.google.ads.googleads.v1.common.ImageAsset.encode(message.imageAsset, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.textAsset != null && message.hasOwnProperty("textAsset"))
                                $root.google.ads.googleads.v1.common.TextAsset.encode(message.textAsset, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified Asset message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Asset.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.Asset
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAsset} message Asset message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Asset.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an Asset message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.Asset
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.Asset} Asset
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Asset.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Asset();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.type = reader.int32();
                                    break;
                                case 5:
                                    message.youtubeVideoAsset = $root.google.ads.googleads.v1.common.YoutubeVideoAsset.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.mediaBundleAsset = $root.google.ads.googleads.v1.common.MediaBundleAsset.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.imageAsset = $root.google.ads.googleads.v1.common.ImageAsset.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.textAsset = $root.google.ads.googleads.v1.common.TextAsset.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an Asset message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.Asset
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.Asset} Asset
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Asset.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an Asset message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.Asset
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Asset.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            if (message.youtubeVideoAsset != null && message.hasOwnProperty("youtubeVideoAsset")) {
                                properties.assetData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.YoutubeVideoAsset.verify(message.youtubeVideoAsset);
                                    if (error)
                                        return "youtubeVideoAsset." + error;
                                }
                            }
                            if (message.mediaBundleAsset != null && message.hasOwnProperty("mediaBundleAsset")) {
                                if (properties.assetData === 1)
                                    return "assetData: multiple values";
                                properties.assetData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.MediaBundleAsset.verify(message.mediaBundleAsset);
                                    if (error)
                                        return "mediaBundleAsset." + error;
                                }
                            }
                            if (message.imageAsset != null && message.hasOwnProperty("imageAsset")) {
                                if (properties.assetData === 1)
                                    return "assetData: multiple values";
                                properties.assetData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ImageAsset.verify(message.imageAsset);
                                    if (error)
                                        return "imageAsset." + error;
                                }
                            }
                            if (message.textAsset != null && message.hasOwnProperty("textAsset")) {
                                if (properties.assetData === 1)
                                    return "assetData: multiple values";
                                properties.assetData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.TextAsset.verify(message.textAsset);
                                    if (error)
                                        return "textAsset." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an Asset message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.Asset
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.Asset} Asset
                         */
                        Asset.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.Asset)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.Asset();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Asset.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Asset.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "YOUTUBE_VIDEO":
                            case 2:
                                message.type = 2;
                                break;
                            case "MEDIA_BUNDLE":
                            case 3:
                                message.type = 3;
                                break;
                            case "IMAGE":
                            case 4:
                                message.type = 4;
                                break;
                            case "TEXT":
                            case 5:
                                message.type = 5;
                                break;
                            }
                            if (object.youtubeVideoAsset != null) {
                                if (typeof object.youtubeVideoAsset !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Asset.youtubeVideoAsset: object expected");
                                message.youtubeVideoAsset = $root.google.ads.googleads.v1.common.YoutubeVideoAsset.fromObject(object.youtubeVideoAsset);
                            }
                            if (object.mediaBundleAsset != null) {
                                if (typeof object.mediaBundleAsset !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Asset.mediaBundleAsset: object expected");
                                message.mediaBundleAsset = $root.google.ads.googleads.v1.common.MediaBundleAsset.fromObject(object.mediaBundleAsset);
                            }
                            if (object.imageAsset != null) {
                                if (typeof object.imageAsset !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Asset.imageAsset: object expected");
                                message.imageAsset = $root.google.ads.googleads.v1.common.ImageAsset.fromObject(object.imageAsset);
                            }
                            if (object.textAsset != null) {
                                if (typeof object.textAsset !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Asset.textAsset: object expected");
                                message.textAsset = $root.google.ads.googleads.v1.common.TextAsset.fromObject(object.textAsset);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an Asset message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.Asset
                         * @static
                         * @param {google.ads.googleads.v1.resources.Asset} message Asset
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Asset.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.name = null;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.AssetTypeEnum.AssetType[message.type] : message.type;
                            if (message.youtubeVideoAsset != null && message.hasOwnProperty("youtubeVideoAsset")) {
                                object.youtubeVideoAsset = $root.google.ads.googleads.v1.common.YoutubeVideoAsset.toObject(message.youtubeVideoAsset, options);
                                if (options.oneofs)
                                    object.assetData = "youtubeVideoAsset";
                            }
                            if (message.mediaBundleAsset != null && message.hasOwnProperty("mediaBundleAsset")) {
                                object.mediaBundleAsset = $root.google.ads.googleads.v1.common.MediaBundleAsset.toObject(message.mediaBundleAsset, options);
                                if (options.oneofs)
                                    object.assetData = "mediaBundleAsset";
                            }
                            if (message.imageAsset != null && message.hasOwnProperty("imageAsset")) {
                                object.imageAsset = $root.google.ads.googleads.v1.common.ImageAsset.toObject(message.imageAsset, options);
                                if (options.oneofs)
                                    object.assetData = "imageAsset";
                            }
                            if (message.textAsset != null && message.hasOwnProperty("textAsset")) {
                                object.textAsset = $root.google.ads.googleads.v1.common.TextAsset.toObject(message.textAsset, options);
                                if (options.oneofs)
                                    object.assetData = "textAsset";
                            }
                            return object;
                        };

                        /**
                         * Converts this Asset to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.Asset
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Asset.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return Asset;
                    })();

                    resources.BiddingStrategy = (function() {

                        /**
                         * Properties of a BiddingStrategy.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IBiddingStrategy
                         * @property {string|null} [resourceName] BiddingStrategy resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] BiddingStrategy id
                         * @property {google.protobuf.IStringValue|null} [name] BiddingStrategy name
                         * @property {google.ads.googleads.v1.enums.BiddingStrategyStatusEnum.BiddingStrategyStatus|null} [status] BiddingStrategy status
                         * @property {google.ads.googleads.v1.enums.BiddingStrategyTypeEnum.BiddingStrategyType|null} [type] BiddingStrategy type
                         * @property {google.protobuf.IInt64Value|null} [campaignCount] BiddingStrategy campaignCount
                         * @property {google.protobuf.IInt64Value|null} [nonRemovedCampaignCount] BiddingStrategy nonRemovedCampaignCount
                         * @property {google.ads.googleads.v1.common.IEnhancedCpc|null} [enhancedCpc] BiddingStrategy enhancedCpc
                         * @property {google.ads.googleads.v1.common.IPageOnePromoted|null} [pageOnePromoted] BiddingStrategy pageOnePromoted
                         * @property {google.ads.googleads.v1.common.ITargetCpa|null} [targetCpa] BiddingStrategy targetCpa
                         * @property {google.ads.googleads.v1.common.ITargetImpressionShare|null} [targetImpressionShare] BiddingStrategy targetImpressionShare
                         * @property {google.ads.googleads.v1.common.ITargetOutrankShare|null} [targetOutrankShare] BiddingStrategy targetOutrankShare
                         * @property {google.ads.googleads.v1.common.ITargetRoas|null} [targetRoas] BiddingStrategy targetRoas
                         * @property {google.ads.googleads.v1.common.ITargetSpend|null} [targetSpend] BiddingStrategy targetSpend
                         */

                        /**
                         * Constructs a new BiddingStrategy.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a BiddingStrategy.
                         * @implements IBiddingStrategy
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IBiddingStrategy=} [properties] Properties to set
                         */
                        function BiddingStrategy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * BiddingStrategy resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @instance
                         */
                        BiddingStrategy.prototype.resourceName = "";

                        /**
                         * BiddingStrategy id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @instance
                         */
                        BiddingStrategy.prototype.id = null;

                        /**
                         * BiddingStrategy name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @instance
                         */
                        BiddingStrategy.prototype.name = null;

                        /**
                         * BiddingStrategy status.
                         * @member {google.ads.googleads.v1.enums.BiddingStrategyStatusEnum.BiddingStrategyStatus} status
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @instance
                         */
                        BiddingStrategy.prototype.status = 0;

                        /**
                         * BiddingStrategy type.
                         * @member {google.ads.googleads.v1.enums.BiddingStrategyTypeEnum.BiddingStrategyType} type
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @instance
                         */
                        BiddingStrategy.prototype.type = 0;

                        /**
                         * BiddingStrategy campaignCount.
                         * @member {google.protobuf.IInt64Value|null|undefined} campaignCount
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @instance
                         */
                        BiddingStrategy.prototype.campaignCount = null;

                        /**
                         * BiddingStrategy nonRemovedCampaignCount.
                         * @member {google.protobuf.IInt64Value|null|undefined} nonRemovedCampaignCount
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @instance
                         */
                        BiddingStrategy.prototype.nonRemovedCampaignCount = null;

                        /**
                         * BiddingStrategy enhancedCpc.
                         * @member {google.ads.googleads.v1.common.IEnhancedCpc|null|undefined} enhancedCpc
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @instance
                         */
                        BiddingStrategy.prototype.enhancedCpc = null;

                        /**
                         * BiddingStrategy pageOnePromoted.
                         * @member {google.ads.googleads.v1.common.IPageOnePromoted|null|undefined} pageOnePromoted
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @instance
                         */
                        BiddingStrategy.prototype.pageOnePromoted = null;

                        /**
                         * BiddingStrategy targetCpa.
                         * @member {google.ads.googleads.v1.common.ITargetCpa|null|undefined} targetCpa
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @instance
                         */
                        BiddingStrategy.prototype.targetCpa = null;

                        /**
                         * BiddingStrategy targetImpressionShare.
                         * @member {google.ads.googleads.v1.common.ITargetImpressionShare|null|undefined} targetImpressionShare
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @instance
                         */
                        BiddingStrategy.prototype.targetImpressionShare = null;

                        /**
                         * BiddingStrategy targetOutrankShare.
                         * @member {google.ads.googleads.v1.common.ITargetOutrankShare|null|undefined} targetOutrankShare
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @instance
                         */
                        BiddingStrategy.prototype.targetOutrankShare = null;

                        /**
                         * BiddingStrategy targetRoas.
                         * @member {google.ads.googleads.v1.common.ITargetRoas|null|undefined} targetRoas
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @instance
                         */
                        BiddingStrategy.prototype.targetRoas = null;

                        /**
                         * BiddingStrategy targetSpend.
                         * @member {google.ads.googleads.v1.common.ITargetSpend|null|undefined} targetSpend
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @instance
                         */
                        BiddingStrategy.prototype.targetSpend = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * BiddingStrategy scheme.
                         * @member {"enhancedCpc"|"pageOnePromoted"|"targetCpa"|"targetImpressionShare"|"targetOutrankShare"|"targetRoas"|"targetSpend"|undefined} scheme
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @instance
                         */
                        Object.defineProperty(BiddingStrategy.prototype, "scheme", {
                            get: $util.oneOfGetter($oneOfFields = ["enhancedCpc", "pageOnePromoted", "targetCpa", "targetImpressionShare", "targetOutrankShare", "targetRoas", "targetSpend"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new BiddingStrategy instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @static
                         * @param {google.ads.googleads.v1.resources.IBiddingStrategy=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.BiddingStrategy} BiddingStrategy instance
                         */
                        BiddingStrategy.create = function create(properties) {
                            return new BiddingStrategy(properties);
                        };

                        /**
                         * Encodes the specified BiddingStrategy message. Does not implicitly {@link google.ads.googleads.v1.resources.BiddingStrategy.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @static
                         * @param {google.ads.googleads.v1.resources.IBiddingStrategy} message BiddingStrategy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BiddingStrategy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.type);
                            if (message.enhancedCpc != null && message.hasOwnProperty("enhancedCpc"))
                                $root.google.ads.googleads.v1.common.EnhancedCpc.encode(message.enhancedCpc, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.pageOnePromoted != null && message.hasOwnProperty("pageOnePromoted"))
                                $root.google.ads.googleads.v1.common.PageOnePromoted.encode(message.pageOnePromoted, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.targetCpa != null && message.hasOwnProperty("targetCpa"))
                                $root.google.ads.googleads.v1.common.TargetCpa.encode(message.targetCpa, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.targetOutrankShare != null && message.hasOwnProperty("targetOutrankShare"))
                                $root.google.ads.googleads.v1.common.TargetOutrankShare.encode(message.targetOutrankShare, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.targetRoas != null && message.hasOwnProperty("targetRoas"))
                                $root.google.ads.googleads.v1.common.TargetRoas.encode(message.targetRoas, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.targetSpend != null && message.hasOwnProperty("targetSpend"))
                                $root.google.ads.googleads.v1.common.TargetSpend.encode(message.targetSpend, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.campaignCount != null && message.hasOwnProperty("campaignCount"))
                                $root.google.protobuf.Int64Value.encode(message.campaignCount, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                            if (message.nonRemovedCampaignCount != null && message.hasOwnProperty("nonRemovedCampaignCount"))
                                $root.google.protobuf.Int64Value.encode(message.nonRemovedCampaignCount, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 15, wireType 0 =*/120).int32(message.status);
                            if (message.targetImpressionShare != null && message.hasOwnProperty("targetImpressionShare"))
                                $root.google.ads.googleads.v1.common.TargetImpressionShare.encode(message.targetImpressionShare, writer.uint32(/* id 48, wireType 2 =*/386).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified BiddingStrategy message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.BiddingStrategy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @static
                         * @param {google.ads.googleads.v1.resources.IBiddingStrategy} message BiddingStrategy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BiddingStrategy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BiddingStrategy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.BiddingStrategy} BiddingStrategy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BiddingStrategy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.BiddingStrategy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 3:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 15:
                                    message.status = reader.int32();
                                    break;
                                case 5:
                                    message.type = reader.int32();
                                    break;
                                case 13:
                                    message.campaignCount = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 14:
                                    message.nonRemovedCampaignCount = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.enhancedCpc = $root.google.ads.googleads.v1.common.EnhancedCpc.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.pageOnePromoted = $root.google.ads.googleads.v1.common.PageOnePromoted.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.targetCpa = $root.google.ads.googleads.v1.common.TargetCpa.decode(reader, reader.uint32());
                                    break;
                                case 48:
                                    message.targetImpressionShare = $root.google.ads.googleads.v1.common.TargetImpressionShare.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.targetOutrankShare = $root.google.ads.googleads.v1.common.TargetOutrankShare.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.targetRoas = $root.google.ads.googleads.v1.common.TargetRoas.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.targetSpend = $root.google.ads.googleads.v1.common.TargetSpend.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BiddingStrategy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.BiddingStrategy} BiddingStrategy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BiddingStrategy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BiddingStrategy message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BiddingStrategy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 4:
                                    break;
                                }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 13:
                                case 10:
                                case 11:
                                case 5:
                                case 12:
                                case 6:
                                case 14:
                                case 15:
                                case 7:
                                case 8:
                                case 9:
                                    break;
                                }
                            if (message.campaignCount != null && message.hasOwnProperty("campaignCount")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.campaignCount);
                                if (error)
                                    return "campaignCount." + error;
                            }
                            if (message.nonRemovedCampaignCount != null && message.hasOwnProperty("nonRemovedCampaignCount")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.nonRemovedCampaignCount);
                                if (error)
                                    return "nonRemovedCampaignCount." + error;
                            }
                            if (message.enhancedCpc != null && message.hasOwnProperty("enhancedCpc")) {
                                properties.scheme = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.EnhancedCpc.verify(message.enhancedCpc);
                                    if (error)
                                        return "enhancedCpc." + error;
                                }
                            }
                            if (message.pageOnePromoted != null && message.hasOwnProperty("pageOnePromoted")) {
                                if (properties.scheme === 1)
                                    return "scheme: multiple values";
                                properties.scheme = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.PageOnePromoted.verify(message.pageOnePromoted);
                                    if (error)
                                        return "pageOnePromoted." + error;
                                }
                            }
                            if (message.targetCpa != null && message.hasOwnProperty("targetCpa")) {
                                if (properties.scheme === 1)
                                    return "scheme: multiple values";
                                properties.scheme = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.TargetCpa.verify(message.targetCpa);
                                    if (error)
                                        return "targetCpa." + error;
                                }
                            }
                            if (message.targetImpressionShare != null && message.hasOwnProperty("targetImpressionShare")) {
                                if (properties.scheme === 1)
                                    return "scheme: multiple values";
                                properties.scheme = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.TargetImpressionShare.verify(message.targetImpressionShare);
                                    if (error)
                                        return "targetImpressionShare." + error;
                                }
                            }
                            if (message.targetOutrankShare != null && message.hasOwnProperty("targetOutrankShare")) {
                                if (properties.scheme === 1)
                                    return "scheme: multiple values";
                                properties.scheme = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.TargetOutrankShare.verify(message.targetOutrankShare);
                                    if (error)
                                        return "targetOutrankShare." + error;
                                }
                            }
                            if (message.targetRoas != null && message.hasOwnProperty("targetRoas")) {
                                if (properties.scheme === 1)
                                    return "scheme: multiple values";
                                properties.scheme = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.TargetRoas.verify(message.targetRoas);
                                    if (error)
                                        return "targetRoas." + error;
                                }
                            }
                            if (message.targetSpend != null && message.hasOwnProperty("targetSpend")) {
                                if (properties.scheme === 1)
                                    return "scheme: multiple values";
                                properties.scheme = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.TargetSpend.verify(message.targetSpend);
                                    if (error)
                                        return "targetSpend." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a BiddingStrategy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.BiddingStrategy} BiddingStrategy
                         */
                        BiddingStrategy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.BiddingStrategy)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.BiddingStrategy();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.BiddingStrategy.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.BiddingStrategy.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "REMOVED":
                            case 4:
                                message.status = 4;
                                break;
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "ENHANCED_CPC":
                            case 2:
                                message.type = 2;
                                break;
                            case "MANUAL_CPC":
                            case 3:
                                message.type = 3;
                                break;
                            case "MANUAL_CPM":
                            case 4:
                                message.type = 4;
                                break;
                            case "MANUAL_CPV":
                            case 13:
                                message.type = 13;
                                break;
                            case "MAXIMIZE_CONVERSIONS":
                            case 10:
                                message.type = 10;
                                break;
                            case "MAXIMIZE_CONVERSION_VALUE":
                            case 11:
                                message.type = 11;
                                break;
                            case "PAGE_ONE_PROMOTED":
                            case 5:
                                message.type = 5;
                                break;
                            case "PERCENT_CPC":
                            case 12:
                                message.type = 12;
                                break;
                            case "TARGET_CPA":
                            case 6:
                                message.type = 6;
                                break;
                            case "TARGET_CPM":
                            case 14:
                                message.type = 14;
                                break;
                            case "TARGET_IMPRESSION_SHARE":
                            case 15:
                                message.type = 15;
                                break;
                            case "TARGET_OUTRANK_SHARE":
                            case 7:
                                message.type = 7;
                                break;
                            case "TARGET_ROAS":
                            case 8:
                                message.type = 8;
                                break;
                            case "TARGET_SPEND":
                            case 9:
                                message.type = 9;
                                break;
                            }
                            if (object.campaignCount != null) {
                                if (typeof object.campaignCount !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.BiddingStrategy.campaignCount: object expected");
                                message.campaignCount = $root.google.protobuf.Int64Value.fromObject(object.campaignCount);
                            }
                            if (object.nonRemovedCampaignCount != null) {
                                if (typeof object.nonRemovedCampaignCount !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.BiddingStrategy.nonRemovedCampaignCount: object expected");
                                message.nonRemovedCampaignCount = $root.google.protobuf.Int64Value.fromObject(object.nonRemovedCampaignCount);
                            }
                            if (object.enhancedCpc != null) {
                                if (typeof object.enhancedCpc !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.BiddingStrategy.enhancedCpc: object expected");
                                message.enhancedCpc = $root.google.ads.googleads.v1.common.EnhancedCpc.fromObject(object.enhancedCpc);
                            }
                            if (object.pageOnePromoted != null) {
                                if (typeof object.pageOnePromoted !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.BiddingStrategy.pageOnePromoted: object expected");
                                message.pageOnePromoted = $root.google.ads.googleads.v1.common.PageOnePromoted.fromObject(object.pageOnePromoted);
                            }
                            if (object.targetCpa != null) {
                                if (typeof object.targetCpa !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.BiddingStrategy.targetCpa: object expected");
                                message.targetCpa = $root.google.ads.googleads.v1.common.TargetCpa.fromObject(object.targetCpa);
                            }
                            if (object.targetImpressionShare != null) {
                                if (typeof object.targetImpressionShare !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.BiddingStrategy.targetImpressionShare: object expected");
                                message.targetImpressionShare = $root.google.ads.googleads.v1.common.TargetImpressionShare.fromObject(object.targetImpressionShare);
                            }
                            if (object.targetOutrankShare != null) {
                                if (typeof object.targetOutrankShare !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.BiddingStrategy.targetOutrankShare: object expected");
                                message.targetOutrankShare = $root.google.ads.googleads.v1.common.TargetOutrankShare.fromObject(object.targetOutrankShare);
                            }
                            if (object.targetRoas != null) {
                                if (typeof object.targetRoas !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.BiddingStrategy.targetRoas: object expected");
                                message.targetRoas = $root.google.ads.googleads.v1.common.TargetRoas.fromObject(object.targetRoas);
                            }
                            if (object.targetSpend != null) {
                                if (typeof object.targetSpend !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.BiddingStrategy.targetSpend: object expected");
                                message.targetSpend = $root.google.ads.googleads.v1.common.TargetSpend.fromObject(object.targetSpend);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a BiddingStrategy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @static
                         * @param {google.ads.googleads.v1.resources.BiddingStrategy} message BiddingStrategy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BiddingStrategy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.name = null;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.campaignCount = null;
                                object.nonRemovedCampaignCount = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.BiddingStrategyTypeEnum.BiddingStrategyType[message.type] : message.type;
                            if (message.enhancedCpc != null && message.hasOwnProperty("enhancedCpc")) {
                                object.enhancedCpc = $root.google.ads.googleads.v1.common.EnhancedCpc.toObject(message.enhancedCpc, options);
                                if (options.oneofs)
                                    object.scheme = "enhancedCpc";
                            }
                            if (message.pageOnePromoted != null && message.hasOwnProperty("pageOnePromoted")) {
                                object.pageOnePromoted = $root.google.ads.googleads.v1.common.PageOnePromoted.toObject(message.pageOnePromoted, options);
                                if (options.oneofs)
                                    object.scheme = "pageOnePromoted";
                            }
                            if (message.targetCpa != null && message.hasOwnProperty("targetCpa")) {
                                object.targetCpa = $root.google.ads.googleads.v1.common.TargetCpa.toObject(message.targetCpa, options);
                                if (options.oneofs)
                                    object.scheme = "targetCpa";
                            }
                            if (message.targetOutrankShare != null && message.hasOwnProperty("targetOutrankShare")) {
                                object.targetOutrankShare = $root.google.ads.googleads.v1.common.TargetOutrankShare.toObject(message.targetOutrankShare, options);
                                if (options.oneofs)
                                    object.scheme = "targetOutrankShare";
                            }
                            if (message.targetRoas != null && message.hasOwnProperty("targetRoas")) {
                                object.targetRoas = $root.google.ads.googleads.v1.common.TargetRoas.toObject(message.targetRoas, options);
                                if (options.oneofs)
                                    object.scheme = "targetRoas";
                            }
                            if (message.targetSpend != null && message.hasOwnProperty("targetSpend")) {
                                object.targetSpend = $root.google.ads.googleads.v1.common.TargetSpend.toObject(message.targetSpend, options);
                                if (options.oneofs)
                                    object.scheme = "targetSpend";
                            }
                            if (message.campaignCount != null && message.hasOwnProperty("campaignCount"))
                                object.campaignCount = $root.google.protobuf.Int64Value.toObject(message.campaignCount, options);
                            if (message.nonRemovedCampaignCount != null && message.hasOwnProperty("nonRemovedCampaignCount"))
                                object.nonRemovedCampaignCount = $root.google.protobuf.Int64Value.toObject(message.nonRemovedCampaignCount, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.BiddingStrategyStatusEnum.BiddingStrategyStatus[message.status] : message.status;
                            if (message.targetImpressionShare != null && message.hasOwnProperty("targetImpressionShare")) {
                                object.targetImpressionShare = $root.google.ads.googleads.v1.common.TargetImpressionShare.toObject(message.targetImpressionShare, options);
                                if (options.oneofs)
                                    object.scheme = "targetImpressionShare";
                            }
                            return object;
                        };

                        /**
                         * Converts this BiddingStrategy to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.BiddingStrategy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BiddingStrategy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return BiddingStrategy;
                    })();

                    resources.BillingSetup = (function() {

                        /**
                         * Properties of a BillingSetup.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IBillingSetup
                         * @property {string|null} [resourceName] BillingSetup resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] BillingSetup id
                         * @property {google.ads.googleads.v1.enums.BillingSetupStatusEnum.BillingSetupStatus|null} [status] BillingSetup status
                         * @property {google.protobuf.IStringValue|null} [paymentsAccount] BillingSetup paymentsAccount
                         * @property {google.ads.googleads.v1.resources.BillingSetup.IPaymentsAccountInfo|null} [paymentsAccountInfo] BillingSetup paymentsAccountInfo
                         * @property {google.protobuf.IStringValue|null} [startDateTime] BillingSetup startDateTime
                         * @property {google.ads.googleads.v1.enums.TimeTypeEnum.TimeType|null} [startTimeType] BillingSetup startTimeType
                         * @property {google.protobuf.IStringValue|null} [endDateTime] BillingSetup endDateTime
                         * @property {google.ads.googleads.v1.enums.TimeTypeEnum.TimeType|null} [endTimeType] BillingSetup endTimeType
                         */

                        /**
                         * Constructs a new BillingSetup.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a BillingSetup.
                         * @implements IBillingSetup
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IBillingSetup=} [properties] Properties to set
                         */
                        function BillingSetup(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * BillingSetup resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @instance
                         */
                        BillingSetup.prototype.resourceName = "";

                        /**
                         * BillingSetup id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @instance
                         */
                        BillingSetup.prototype.id = null;

                        /**
                         * BillingSetup status.
                         * @member {google.ads.googleads.v1.enums.BillingSetupStatusEnum.BillingSetupStatus} status
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @instance
                         */
                        BillingSetup.prototype.status = 0;

                        /**
                         * BillingSetup paymentsAccount.
                         * @member {google.protobuf.IStringValue|null|undefined} paymentsAccount
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @instance
                         */
                        BillingSetup.prototype.paymentsAccount = null;

                        /**
                         * BillingSetup paymentsAccountInfo.
                         * @member {google.ads.googleads.v1.resources.BillingSetup.IPaymentsAccountInfo|null|undefined} paymentsAccountInfo
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @instance
                         */
                        BillingSetup.prototype.paymentsAccountInfo = null;

                        /**
                         * BillingSetup startDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} startDateTime
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @instance
                         */
                        BillingSetup.prototype.startDateTime = null;

                        /**
                         * BillingSetup startTimeType.
                         * @member {google.ads.googleads.v1.enums.TimeTypeEnum.TimeType} startTimeType
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @instance
                         */
                        BillingSetup.prototype.startTimeType = 0;

                        /**
                         * BillingSetup endDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} endDateTime
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @instance
                         */
                        BillingSetup.prototype.endDateTime = null;

                        /**
                         * BillingSetup endTimeType.
                         * @member {google.ads.googleads.v1.enums.TimeTypeEnum.TimeType} endTimeType
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @instance
                         */
                        BillingSetup.prototype.endTimeType = 0;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * BillingSetup startTime.
                         * @member {"startDateTime"|"startTimeType"|undefined} startTime
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @instance
                         */
                        Object.defineProperty(BillingSetup.prototype, "startTime", {
                            get: $util.oneOfGetter($oneOfFields = ["startDateTime", "startTimeType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * BillingSetup endTime.
                         * @member {"endDateTime"|"endTimeType"|undefined} endTime
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @instance
                         */
                        Object.defineProperty(BillingSetup.prototype, "endTime", {
                            get: $util.oneOfGetter($oneOfFields = ["endDateTime", "endTimeType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new BillingSetup instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @static
                         * @param {google.ads.googleads.v1.resources.IBillingSetup=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.BillingSetup} BillingSetup instance
                         */
                        BillingSetup.create = function create(properties) {
                            return new BillingSetup(properties);
                        };

                        /**
                         * Encodes the specified BillingSetup message. Does not implicitly {@link google.ads.googleads.v1.resources.BillingSetup.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @static
                         * @param {google.ads.googleads.v1.resources.IBillingSetup} message BillingSetup message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BillingSetup.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.status);
                            if (message.startDateTime != null && message.hasOwnProperty("startDateTime"))
                                $root.google.protobuf.StringValue.encode(message.startDateTime, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.startTimeType != null && message.hasOwnProperty("startTimeType"))
                                writer.uint32(/* id 10, wireType 0 =*/80).int32(message.startTimeType);
                            if (message.paymentsAccount != null && message.hasOwnProperty("paymentsAccount"))
                                $root.google.protobuf.StringValue.encode(message.paymentsAccount, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.paymentsAccountInfo != null && message.hasOwnProperty("paymentsAccountInfo"))
                                $root.google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo.encode(message.paymentsAccountInfo, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.endDateTime != null && message.hasOwnProperty("endDateTime"))
                                $root.google.protobuf.StringValue.encode(message.endDateTime, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                            if (message.endTimeType != null && message.hasOwnProperty("endTimeType"))
                                writer.uint32(/* id 14, wireType 0 =*/112).int32(message.endTimeType);
                            return writer;
                        };

                        /**
                         * Encodes the specified BillingSetup message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.BillingSetup.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @static
                         * @param {google.ads.googleads.v1.resources.IBillingSetup} message BillingSetup message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BillingSetup.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BillingSetup message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.BillingSetup} BillingSetup
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BillingSetup.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.BillingSetup();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.status = reader.int32();
                                    break;
                                case 11:
                                    message.paymentsAccount = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.paymentsAccountInfo = $root.google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.startDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.startTimeType = reader.int32();
                                    break;
                                case 13:
                                    message.endDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 14:
                                    message.endTimeType = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BillingSetup message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.BillingSetup} BillingSetup
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BillingSetup.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BillingSetup message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BillingSetup.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            if (message.paymentsAccount != null && message.hasOwnProperty("paymentsAccount")) {
                                var error = $root.google.protobuf.StringValue.verify(message.paymentsAccount);
                                if (error)
                                    return "paymentsAccount." + error;
                            }
                            if (message.paymentsAccountInfo != null && message.hasOwnProperty("paymentsAccountInfo")) {
                                var error = $root.google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo.verify(message.paymentsAccountInfo);
                                if (error)
                                    return "paymentsAccountInfo." + error;
                            }
                            if (message.startDateTime != null && message.hasOwnProperty("startDateTime")) {
                                properties.startTime = 1;
                                {
                                    var error = $root.google.protobuf.StringValue.verify(message.startDateTime);
                                    if (error)
                                        return "startDateTime." + error;
                                }
                            }
                            if (message.startTimeType != null && message.hasOwnProperty("startTimeType")) {
                                if (properties.startTime === 1)
                                    return "startTime: multiple values";
                                properties.startTime = 1;
                                switch (message.startTimeType) {
                                default:
                                    return "startTimeType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.endDateTime != null && message.hasOwnProperty("endDateTime")) {
                                properties.endTime = 1;
                                {
                                    var error = $root.google.protobuf.StringValue.verify(message.endDateTime);
                                    if (error)
                                        return "endDateTime." + error;
                                }
                            }
                            if (message.endTimeType != null && message.hasOwnProperty("endTimeType")) {
                                if (properties.endTime === 1)
                                    return "endTime: multiple values";
                                properties.endTime = 1;
                                switch (message.endTimeType) {
                                default:
                                    return "endTimeType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a BillingSetup message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.BillingSetup} BillingSetup
                         */
                        BillingSetup.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.BillingSetup)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.BillingSetup();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.BillingSetup.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "PENDING":
                            case 2:
                                message.status = 2;
                                break;
                            case "APPROVED_HELD":
                            case 3:
                                message.status = 3;
                                break;
                            case "APPROVED":
                            case 4:
                                message.status = 4;
                                break;
                            case "CANCELLED":
                            case 5:
                                message.status = 5;
                                break;
                            }
                            if (object.paymentsAccount != null) {
                                if (typeof object.paymentsAccount !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.BillingSetup.paymentsAccount: object expected");
                                message.paymentsAccount = $root.google.protobuf.StringValue.fromObject(object.paymentsAccount);
                            }
                            if (object.paymentsAccountInfo != null) {
                                if (typeof object.paymentsAccountInfo !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.BillingSetup.paymentsAccountInfo: object expected");
                                message.paymentsAccountInfo = $root.google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo.fromObject(object.paymentsAccountInfo);
                            }
                            if (object.startDateTime != null) {
                                if (typeof object.startDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.BillingSetup.startDateTime: object expected");
                                message.startDateTime = $root.google.protobuf.StringValue.fromObject(object.startDateTime);
                            }
                            switch (object.startTimeType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.startTimeType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.startTimeType = 1;
                                break;
                            case "NOW":
                            case 2:
                                message.startTimeType = 2;
                                break;
                            case "FOREVER":
                            case 3:
                                message.startTimeType = 3;
                                break;
                            }
                            if (object.endDateTime != null) {
                                if (typeof object.endDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.BillingSetup.endDateTime: object expected");
                                message.endDateTime = $root.google.protobuf.StringValue.fromObject(object.endDateTime);
                            }
                            switch (object.endTimeType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.endTimeType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.endTimeType = 1;
                                break;
                            case "NOW":
                            case 2:
                                message.endTimeType = 2;
                                break;
                            case "FOREVER":
                            case 3:
                                message.endTimeType = 3;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a BillingSetup message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @static
                         * @param {google.ads.googleads.v1.resources.BillingSetup} message BillingSetup
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BillingSetup.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                                object.paymentsAccount = null;
                                object.paymentsAccountInfo = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.BillingSetupStatusEnum.BillingSetupStatus[message.status] : message.status;
                            if (message.startDateTime != null && message.hasOwnProperty("startDateTime")) {
                                object.startDateTime = $root.google.protobuf.StringValue.toObject(message.startDateTime, options);
                                if (options.oneofs)
                                    object.startTime = "startDateTime";
                            }
                            if (message.startTimeType != null && message.hasOwnProperty("startTimeType")) {
                                object.startTimeType = options.enums === String ? $root.google.ads.googleads.v1.enums.TimeTypeEnum.TimeType[message.startTimeType] : message.startTimeType;
                                if (options.oneofs)
                                    object.startTime = "startTimeType";
                            }
                            if (message.paymentsAccount != null && message.hasOwnProperty("paymentsAccount"))
                                object.paymentsAccount = $root.google.protobuf.StringValue.toObject(message.paymentsAccount, options);
                            if (message.paymentsAccountInfo != null && message.hasOwnProperty("paymentsAccountInfo"))
                                object.paymentsAccountInfo = $root.google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo.toObject(message.paymentsAccountInfo, options);
                            if (message.endDateTime != null && message.hasOwnProperty("endDateTime")) {
                                object.endDateTime = $root.google.protobuf.StringValue.toObject(message.endDateTime, options);
                                if (options.oneofs)
                                    object.endTime = "endDateTime";
                            }
                            if (message.endTimeType != null && message.hasOwnProperty("endTimeType")) {
                                object.endTimeType = options.enums === String ? $root.google.ads.googleads.v1.enums.TimeTypeEnum.TimeType[message.endTimeType] : message.endTimeType;
                                if (options.oneofs)
                                    object.endTime = "endTimeType";
                            }
                            return object;
                        };

                        /**
                         * Converts this BillingSetup to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.BillingSetup
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BillingSetup.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        BillingSetup.PaymentsAccountInfo = (function() {

                            /**
                             * Properties of a PaymentsAccountInfo.
                             * @memberof google.ads.googleads.v1.resources.BillingSetup
                             * @interface IPaymentsAccountInfo
                             * @property {google.protobuf.IStringValue|null} [paymentsAccountId] PaymentsAccountInfo paymentsAccountId
                             * @property {google.protobuf.IStringValue|null} [paymentsAccountName] PaymentsAccountInfo paymentsAccountName
                             * @property {google.protobuf.IStringValue|null} [paymentsProfileId] PaymentsAccountInfo paymentsProfileId
                             * @property {google.protobuf.IStringValue|null} [paymentsProfileName] PaymentsAccountInfo paymentsProfileName
                             * @property {google.protobuf.IStringValue|null} [secondaryPaymentsProfileId] PaymentsAccountInfo secondaryPaymentsProfileId
                             */

                            /**
                             * Constructs a new PaymentsAccountInfo.
                             * @memberof google.ads.googleads.v1.resources.BillingSetup
                             * @classdesc Represents a PaymentsAccountInfo.
                             * @implements IPaymentsAccountInfo
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.BillingSetup.IPaymentsAccountInfo=} [properties] Properties to set
                             */
                            function PaymentsAccountInfo(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * PaymentsAccountInfo paymentsAccountId.
                             * @member {google.protobuf.IStringValue|null|undefined} paymentsAccountId
                             * @memberof google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo
                             * @instance
                             */
                            PaymentsAccountInfo.prototype.paymentsAccountId = null;

                            /**
                             * PaymentsAccountInfo paymentsAccountName.
                             * @member {google.protobuf.IStringValue|null|undefined} paymentsAccountName
                             * @memberof google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo
                             * @instance
                             */
                            PaymentsAccountInfo.prototype.paymentsAccountName = null;

                            /**
                             * PaymentsAccountInfo paymentsProfileId.
                             * @member {google.protobuf.IStringValue|null|undefined} paymentsProfileId
                             * @memberof google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo
                             * @instance
                             */
                            PaymentsAccountInfo.prototype.paymentsProfileId = null;

                            /**
                             * PaymentsAccountInfo paymentsProfileName.
                             * @member {google.protobuf.IStringValue|null|undefined} paymentsProfileName
                             * @memberof google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo
                             * @instance
                             */
                            PaymentsAccountInfo.prototype.paymentsProfileName = null;

                            /**
                             * PaymentsAccountInfo secondaryPaymentsProfileId.
                             * @member {google.protobuf.IStringValue|null|undefined} secondaryPaymentsProfileId
                             * @memberof google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo
                             * @instance
                             */
                            PaymentsAccountInfo.prototype.secondaryPaymentsProfileId = null;

                            /**
                             * Creates a new PaymentsAccountInfo instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo
                             * @static
                             * @param {google.ads.googleads.v1.resources.BillingSetup.IPaymentsAccountInfo=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo} PaymentsAccountInfo instance
                             */
                            PaymentsAccountInfo.create = function create(properties) {
                                return new PaymentsAccountInfo(properties);
                            };

                            /**
                             * Encodes the specified PaymentsAccountInfo message. Does not implicitly {@link google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo
                             * @static
                             * @param {google.ads.googleads.v1.resources.BillingSetup.IPaymentsAccountInfo} message PaymentsAccountInfo message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            PaymentsAccountInfo.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.paymentsAccountId != null && message.hasOwnProperty("paymentsAccountId"))
                                    $root.google.protobuf.StringValue.encode(message.paymentsAccountId, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.paymentsAccountName != null && message.hasOwnProperty("paymentsAccountName"))
                                    $root.google.protobuf.StringValue.encode(message.paymentsAccountName, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                if (message.paymentsProfileId != null && message.hasOwnProperty("paymentsProfileId"))
                                    $root.google.protobuf.StringValue.encode(message.paymentsProfileId, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                                if (message.paymentsProfileName != null && message.hasOwnProperty("paymentsProfileName"))
                                    $root.google.protobuf.StringValue.encode(message.paymentsProfileName, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                                if (message.secondaryPaymentsProfileId != null && message.hasOwnProperty("secondaryPaymentsProfileId"))
                                    $root.google.protobuf.StringValue.encode(message.secondaryPaymentsProfileId, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified PaymentsAccountInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo
                             * @static
                             * @param {google.ads.googleads.v1.resources.BillingSetup.IPaymentsAccountInfo} message PaymentsAccountInfo message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            PaymentsAccountInfo.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a PaymentsAccountInfo message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo} PaymentsAccountInfo
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            PaymentsAccountInfo.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.paymentsAccountId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.paymentsAccountName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 3:
                                        message.paymentsProfileId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 4:
                                        message.paymentsProfileName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 5:
                                        message.secondaryPaymentsProfileId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a PaymentsAccountInfo message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo} PaymentsAccountInfo
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            PaymentsAccountInfo.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a PaymentsAccountInfo message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            PaymentsAccountInfo.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.paymentsAccountId != null && message.hasOwnProperty("paymentsAccountId")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.paymentsAccountId);
                                    if (error)
                                        return "paymentsAccountId." + error;
                                }
                                if (message.paymentsAccountName != null && message.hasOwnProperty("paymentsAccountName")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.paymentsAccountName);
                                    if (error)
                                        return "paymentsAccountName." + error;
                                }
                                if (message.paymentsProfileId != null && message.hasOwnProperty("paymentsProfileId")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.paymentsProfileId);
                                    if (error)
                                        return "paymentsProfileId." + error;
                                }
                                if (message.paymentsProfileName != null && message.hasOwnProperty("paymentsProfileName")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.paymentsProfileName);
                                    if (error)
                                        return "paymentsProfileName." + error;
                                }
                                if (message.secondaryPaymentsProfileId != null && message.hasOwnProperty("secondaryPaymentsProfileId")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.secondaryPaymentsProfileId);
                                    if (error)
                                        return "secondaryPaymentsProfileId." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a PaymentsAccountInfo message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo} PaymentsAccountInfo
                             */
                            PaymentsAccountInfo.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo();
                                if (object.paymentsAccountId != null) {
                                    if (typeof object.paymentsAccountId !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo.paymentsAccountId: object expected");
                                    message.paymentsAccountId = $root.google.protobuf.StringValue.fromObject(object.paymentsAccountId);
                                }
                                if (object.paymentsAccountName != null) {
                                    if (typeof object.paymentsAccountName !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo.paymentsAccountName: object expected");
                                    message.paymentsAccountName = $root.google.protobuf.StringValue.fromObject(object.paymentsAccountName);
                                }
                                if (object.paymentsProfileId != null) {
                                    if (typeof object.paymentsProfileId !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo.paymentsProfileId: object expected");
                                    message.paymentsProfileId = $root.google.protobuf.StringValue.fromObject(object.paymentsProfileId);
                                }
                                if (object.paymentsProfileName != null) {
                                    if (typeof object.paymentsProfileName !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo.paymentsProfileName: object expected");
                                    message.paymentsProfileName = $root.google.protobuf.StringValue.fromObject(object.paymentsProfileName);
                                }
                                if (object.secondaryPaymentsProfileId != null) {
                                    if (typeof object.secondaryPaymentsProfileId !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo.secondaryPaymentsProfileId: object expected");
                                    message.secondaryPaymentsProfileId = $root.google.protobuf.StringValue.fromObject(object.secondaryPaymentsProfileId);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a PaymentsAccountInfo message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo
                             * @static
                             * @param {google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo} message PaymentsAccountInfo
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            PaymentsAccountInfo.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.paymentsAccountId = null;
                                    object.paymentsAccountName = null;
                                    object.paymentsProfileId = null;
                                    object.paymentsProfileName = null;
                                    object.secondaryPaymentsProfileId = null;
                                }
                                if (message.paymentsAccountId != null && message.hasOwnProperty("paymentsAccountId"))
                                    object.paymentsAccountId = $root.google.protobuf.StringValue.toObject(message.paymentsAccountId, options);
                                if (message.paymentsAccountName != null && message.hasOwnProperty("paymentsAccountName"))
                                    object.paymentsAccountName = $root.google.protobuf.StringValue.toObject(message.paymentsAccountName, options);
                                if (message.paymentsProfileId != null && message.hasOwnProperty("paymentsProfileId"))
                                    object.paymentsProfileId = $root.google.protobuf.StringValue.toObject(message.paymentsProfileId, options);
                                if (message.paymentsProfileName != null && message.hasOwnProperty("paymentsProfileName"))
                                    object.paymentsProfileName = $root.google.protobuf.StringValue.toObject(message.paymentsProfileName, options);
                                if (message.secondaryPaymentsProfileId != null && message.hasOwnProperty("secondaryPaymentsProfileId"))
                                    object.secondaryPaymentsProfileId = $root.google.protobuf.StringValue.toObject(message.secondaryPaymentsProfileId, options);
                                return object;
                            };

                            /**
                             * Converts this PaymentsAccountInfo to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.BillingSetup.PaymentsAccountInfo
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            PaymentsAccountInfo.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return PaymentsAccountInfo;
                        })();

                        return BillingSetup;
                    })();

                    resources.Campaign = (function() {

                        /**
                         * Properties of a Campaign.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICampaign
                         * @property {string|null} [resourceName] Campaign resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] Campaign id
                         * @property {google.protobuf.IStringValue|null} [name] Campaign name
                         * @property {google.ads.googleads.v1.enums.CampaignStatusEnum.CampaignStatus|null} [status] Campaign status
                         * @property {google.ads.googleads.v1.enums.CampaignServingStatusEnum.CampaignServingStatus|null} [servingStatus] Campaign servingStatus
                         * @property {google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum.AdServingOptimizationStatus|null} [adServingOptimizationStatus] Campaign adServingOptimizationStatus
                         * @property {google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum.AdvertisingChannelType|null} [advertisingChannelType] Campaign advertisingChannelType
                         * @property {google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum.AdvertisingChannelSubType|null} [advertisingChannelSubType] Campaign advertisingChannelSubType
                         * @property {google.protobuf.IStringValue|null} [trackingUrlTemplate] Campaign trackingUrlTemplate
                         * @property {Array.<google.ads.googleads.v1.common.ICustomParameter>|null} [urlCustomParameters] Campaign urlCustomParameters
                         * @property {google.ads.googleads.v1.common.IRealTimeBiddingSetting|null} [realTimeBiddingSetting] Campaign realTimeBiddingSetting
                         * @property {google.ads.googleads.v1.resources.Campaign.INetworkSettings|null} [networkSettings] Campaign networkSettings
                         * @property {google.ads.googleads.v1.resources.Campaign.IHotelSettingInfo|null} [hotelSetting] Campaign hotelSetting
                         * @property {google.ads.googleads.v1.resources.Campaign.IDynamicSearchAdsSetting|null} [dynamicSearchAdsSetting] Campaign dynamicSearchAdsSetting
                         * @property {google.ads.googleads.v1.resources.Campaign.IShoppingSetting|null} [shoppingSetting] Campaign shoppingSetting
                         * @property {google.ads.googleads.v1.common.ITargetingSetting|null} [targetingSetting] Campaign targetingSetting
                         * @property {google.ads.googleads.v1.resources.Campaign.IGeoTargetTypeSetting|null} [geoTargetTypeSetting] Campaign geoTargetTypeSetting
                         * @property {google.ads.googleads.v1.resources.Campaign.IAppCampaignSetting|null} [appCampaignSetting] Campaign appCampaignSetting
                         * @property {google.ads.googleads.v1.enums.CampaignExperimentTypeEnum.CampaignExperimentType|null} [experimentType] Campaign experimentType
                         * @property {google.protobuf.IStringValue|null} [baseCampaign] Campaign baseCampaign
                         * @property {google.protobuf.IStringValue|null} [campaignBudget] Campaign campaignBudget
                         * @property {google.ads.googleads.v1.enums.BiddingStrategyTypeEnum.BiddingStrategyType|null} [biddingStrategyType] Campaign biddingStrategyType
                         * @property {google.protobuf.IStringValue|null} [startDate] Campaign startDate
                         * @property {google.protobuf.IStringValue|null} [endDate] Campaign endDate
                         * @property {google.protobuf.IStringValue|null} [finalUrlSuffix] Campaign finalUrlSuffix
                         * @property {Array.<google.ads.googleads.v1.common.IFrequencyCapEntry>|null} [frequencyCaps] Campaign frequencyCaps
                         * @property {google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum.BrandSafetySuitability|null} [videoBrandSafetySuitability] Campaign videoBrandSafetySuitability
                         * @property {google.ads.googleads.v1.resources.Campaign.IVanityPharma|null} [vanityPharma] Campaign vanityPharma
                         * @property {google.ads.googleads.v1.resources.Campaign.ISelectiveOptimization|null} [selectiveOptimization] Campaign selectiveOptimization
                         * @property {google.ads.googleads.v1.resources.Campaign.ITrackingSetting|null} [trackingSetting] Campaign trackingSetting
                         * @property {google.ads.googleads.v1.enums.PaymentModeEnum.PaymentMode|null} [paymentMode] Campaign paymentMode
                         * @property {google.protobuf.IStringValue|null} [biddingStrategy] Campaign biddingStrategy
                         * @property {google.ads.googleads.v1.common.ICommission|null} [commission] Campaign commission
                         * @property {google.ads.googleads.v1.common.IManualCpc|null} [manualCpc] Campaign manualCpc
                         * @property {google.ads.googleads.v1.common.IManualCpm|null} [manualCpm] Campaign manualCpm
                         * @property {google.ads.googleads.v1.common.IManualCpv|null} [manualCpv] Campaign manualCpv
                         * @property {google.ads.googleads.v1.common.IMaximizeConversions|null} [maximizeConversions] Campaign maximizeConversions
                         * @property {google.ads.googleads.v1.common.IMaximizeConversionValue|null} [maximizeConversionValue] Campaign maximizeConversionValue
                         * @property {google.ads.googleads.v1.common.ITargetCpa|null} [targetCpa] Campaign targetCpa
                         * @property {google.ads.googleads.v1.common.ITargetImpressionShare|null} [targetImpressionShare] Campaign targetImpressionShare
                         * @property {google.ads.googleads.v1.common.ITargetRoas|null} [targetRoas] Campaign targetRoas
                         * @property {google.ads.googleads.v1.common.ITargetSpend|null} [targetSpend] Campaign targetSpend
                         * @property {google.ads.googleads.v1.common.IPercentCpc|null} [percentCpc] Campaign percentCpc
                         * @property {google.ads.googleads.v1.common.ITargetCpm|null} [targetCpm] Campaign targetCpm
                         */

                        /**
                         * Constructs a new Campaign.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a Campaign.
                         * @implements ICampaign
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICampaign=} [properties] Properties to set
                         */
                        function Campaign(properties) {
                            this.urlCustomParameters = [];
                            this.frequencyCaps = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Campaign resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.resourceName = "";

                        /**
                         * Campaign id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.id = null;

                        /**
                         * Campaign name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.name = null;

                        /**
                         * Campaign status.
                         * @member {google.ads.googleads.v1.enums.CampaignStatusEnum.CampaignStatus} status
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.status = 0;

                        /**
                         * Campaign servingStatus.
                         * @member {google.ads.googleads.v1.enums.CampaignServingStatusEnum.CampaignServingStatus} servingStatus
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.servingStatus = 0;

                        /**
                         * Campaign adServingOptimizationStatus.
                         * @member {google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum.AdServingOptimizationStatus} adServingOptimizationStatus
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.adServingOptimizationStatus = 0;

                        /**
                         * Campaign advertisingChannelType.
                         * @member {google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum.AdvertisingChannelType} advertisingChannelType
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.advertisingChannelType = 0;

                        /**
                         * Campaign advertisingChannelSubType.
                         * @member {google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum.AdvertisingChannelSubType} advertisingChannelSubType
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.advertisingChannelSubType = 0;

                        /**
                         * Campaign trackingUrlTemplate.
                         * @member {google.protobuf.IStringValue|null|undefined} trackingUrlTemplate
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.trackingUrlTemplate = null;

                        /**
                         * Campaign urlCustomParameters.
                         * @member {Array.<google.ads.googleads.v1.common.ICustomParameter>} urlCustomParameters
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.urlCustomParameters = $util.emptyArray;

                        /**
                         * Campaign realTimeBiddingSetting.
                         * @member {google.ads.googleads.v1.common.IRealTimeBiddingSetting|null|undefined} realTimeBiddingSetting
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.realTimeBiddingSetting = null;

                        /**
                         * Campaign networkSettings.
                         * @member {google.ads.googleads.v1.resources.Campaign.INetworkSettings|null|undefined} networkSettings
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.networkSettings = null;

                        /**
                         * Campaign hotelSetting.
                         * @member {google.ads.googleads.v1.resources.Campaign.IHotelSettingInfo|null|undefined} hotelSetting
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.hotelSetting = null;

                        /**
                         * Campaign dynamicSearchAdsSetting.
                         * @member {google.ads.googleads.v1.resources.Campaign.IDynamicSearchAdsSetting|null|undefined} dynamicSearchAdsSetting
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.dynamicSearchAdsSetting = null;

                        /**
                         * Campaign shoppingSetting.
                         * @member {google.ads.googleads.v1.resources.Campaign.IShoppingSetting|null|undefined} shoppingSetting
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.shoppingSetting = null;

                        /**
                         * Campaign targetingSetting.
                         * @member {google.ads.googleads.v1.common.ITargetingSetting|null|undefined} targetingSetting
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.targetingSetting = null;

                        /**
                         * Campaign geoTargetTypeSetting.
                         * @member {google.ads.googleads.v1.resources.Campaign.IGeoTargetTypeSetting|null|undefined} geoTargetTypeSetting
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.geoTargetTypeSetting = null;

                        /**
                         * Campaign appCampaignSetting.
                         * @member {google.ads.googleads.v1.resources.Campaign.IAppCampaignSetting|null|undefined} appCampaignSetting
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.appCampaignSetting = null;

                        /**
                         * Campaign experimentType.
                         * @member {google.ads.googleads.v1.enums.CampaignExperimentTypeEnum.CampaignExperimentType} experimentType
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.experimentType = 0;

                        /**
                         * Campaign baseCampaign.
                         * @member {google.protobuf.IStringValue|null|undefined} baseCampaign
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.baseCampaign = null;

                        /**
                         * Campaign campaignBudget.
                         * @member {google.protobuf.IStringValue|null|undefined} campaignBudget
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.campaignBudget = null;

                        /**
                         * Campaign biddingStrategyType.
                         * @member {google.ads.googleads.v1.enums.BiddingStrategyTypeEnum.BiddingStrategyType} biddingStrategyType
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.biddingStrategyType = 0;

                        /**
                         * Campaign startDate.
                         * @member {google.protobuf.IStringValue|null|undefined} startDate
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.startDate = null;

                        /**
                         * Campaign endDate.
                         * @member {google.protobuf.IStringValue|null|undefined} endDate
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.endDate = null;

                        /**
                         * Campaign finalUrlSuffix.
                         * @member {google.protobuf.IStringValue|null|undefined} finalUrlSuffix
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.finalUrlSuffix = null;

                        /**
                         * Campaign frequencyCaps.
                         * @member {Array.<google.ads.googleads.v1.common.IFrequencyCapEntry>} frequencyCaps
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.frequencyCaps = $util.emptyArray;

                        /**
                         * Campaign videoBrandSafetySuitability.
                         * @member {google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum.BrandSafetySuitability} videoBrandSafetySuitability
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.videoBrandSafetySuitability = 0;

                        /**
                         * Campaign vanityPharma.
                         * @member {google.ads.googleads.v1.resources.Campaign.IVanityPharma|null|undefined} vanityPharma
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.vanityPharma = null;

                        /**
                         * Campaign selectiveOptimization.
                         * @member {google.ads.googleads.v1.resources.Campaign.ISelectiveOptimization|null|undefined} selectiveOptimization
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.selectiveOptimization = null;

                        /**
                         * Campaign trackingSetting.
                         * @member {google.ads.googleads.v1.resources.Campaign.ITrackingSetting|null|undefined} trackingSetting
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.trackingSetting = null;

                        /**
                         * Campaign paymentMode.
                         * @member {google.ads.googleads.v1.enums.PaymentModeEnum.PaymentMode} paymentMode
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.paymentMode = 0;

                        /**
                         * Campaign biddingStrategy.
                         * @member {google.protobuf.IStringValue|null|undefined} biddingStrategy
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.biddingStrategy = null;

                        /**
                         * Campaign commission.
                         * @member {google.ads.googleads.v1.common.ICommission|null|undefined} commission
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.commission = null;

                        /**
                         * Campaign manualCpc.
                         * @member {google.ads.googleads.v1.common.IManualCpc|null|undefined} manualCpc
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.manualCpc = null;

                        /**
                         * Campaign manualCpm.
                         * @member {google.ads.googleads.v1.common.IManualCpm|null|undefined} manualCpm
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.manualCpm = null;

                        /**
                         * Campaign manualCpv.
                         * @member {google.ads.googleads.v1.common.IManualCpv|null|undefined} manualCpv
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.manualCpv = null;

                        /**
                         * Campaign maximizeConversions.
                         * @member {google.ads.googleads.v1.common.IMaximizeConversions|null|undefined} maximizeConversions
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.maximizeConversions = null;

                        /**
                         * Campaign maximizeConversionValue.
                         * @member {google.ads.googleads.v1.common.IMaximizeConversionValue|null|undefined} maximizeConversionValue
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.maximizeConversionValue = null;

                        /**
                         * Campaign targetCpa.
                         * @member {google.ads.googleads.v1.common.ITargetCpa|null|undefined} targetCpa
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.targetCpa = null;

                        /**
                         * Campaign targetImpressionShare.
                         * @member {google.ads.googleads.v1.common.ITargetImpressionShare|null|undefined} targetImpressionShare
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.targetImpressionShare = null;

                        /**
                         * Campaign targetRoas.
                         * @member {google.ads.googleads.v1.common.ITargetRoas|null|undefined} targetRoas
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.targetRoas = null;

                        /**
                         * Campaign targetSpend.
                         * @member {google.ads.googleads.v1.common.ITargetSpend|null|undefined} targetSpend
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.targetSpend = null;

                        /**
                         * Campaign percentCpc.
                         * @member {google.ads.googleads.v1.common.IPercentCpc|null|undefined} percentCpc
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.percentCpc = null;

                        /**
                         * Campaign targetCpm.
                         * @member {google.ads.googleads.v1.common.ITargetCpm|null|undefined} targetCpm
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Campaign.prototype.targetCpm = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * Campaign campaignBiddingStrategy.
                         * @member {"biddingStrategy"|"commission"|"manualCpc"|"manualCpm"|"manualCpv"|"maximizeConversions"|"maximizeConversionValue"|"targetCpa"|"targetImpressionShare"|"targetRoas"|"targetSpend"|"percentCpc"|"targetCpm"|undefined} campaignBiddingStrategy
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         */
                        Object.defineProperty(Campaign.prototype, "campaignBiddingStrategy", {
                            get: $util.oneOfGetter($oneOfFields = ["biddingStrategy", "commission", "manualCpc", "manualCpm", "manualCpv", "maximizeConversions", "maximizeConversionValue", "targetCpa", "targetImpressionShare", "targetRoas", "targetSpend", "percentCpc", "targetCpm"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new Campaign instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaign=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.Campaign} Campaign instance
                         */
                        Campaign.create = function create(properties) {
                            return new Campaign(properties);
                        };

                        /**
                         * Encodes the specified Campaign message. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaign} message Campaign message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Campaign.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.status);
                            if (message.campaignBudget != null && message.hasOwnProperty("campaignBudget"))
                                $root.google.protobuf.StringValue.encode(message.campaignBudget, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.adServingOptimizationStatus != null && message.hasOwnProperty("adServingOptimizationStatus"))
                                writer.uint32(/* id 8, wireType 0 =*/64).int32(message.adServingOptimizationStatus);
                            if (message.advertisingChannelType != null && message.hasOwnProperty("advertisingChannelType"))
                                writer.uint32(/* id 9, wireType 0 =*/72).int32(message.advertisingChannelType);
                            if (message.advertisingChannelSubType != null && message.hasOwnProperty("advertisingChannelSubType"))
                                writer.uint32(/* id 10, wireType 0 =*/80).int32(message.advertisingChannelSubType);
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                $root.google.protobuf.StringValue.encode(message.trackingUrlTemplate, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.urlCustomParameters != null && message.urlCustomParameters.length)
                                for (var i = 0; i < message.urlCustomParameters.length; ++i)
                                    $root.google.ads.googleads.v1.common.CustomParameter.encode(message.urlCustomParameters[i], writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.networkSettings != null && message.hasOwnProperty("networkSettings"))
                                $root.google.ads.googleads.v1.resources.Campaign.NetworkSettings.encode(message.networkSettings, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.experimentType != null && message.hasOwnProperty("experimentType"))
                                writer.uint32(/* id 17, wireType 0 =*/136).int32(message.experimentType);
                            if (message.startDate != null && message.hasOwnProperty("startDate"))
                                $root.google.protobuf.StringValue.encode(message.startDate, writer.uint32(/* id 19, wireType 2 =*/154).fork()).ldelim();
                            if (message.endDate != null && message.hasOwnProperty("endDate"))
                                $root.google.protobuf.StringValue.encode(message.endDate, writer.uint32(/* id 20, wireType 2 =*/162).fork()).ldelim();
                            if (message.servingStatus != null && message.hasOwnProperty("servingStatus"))
                                writer.uint32(/* id 21, wireType 0 =*/168).int32(message.servingStatus);
                            if (message.biddingStrategyType != null && message.hasOwnProperty("biddingStrategyType"))
                                writer.uint32(/* id 22, wireType 0 =*/176).int32(message.biddingStrategyType);
                            if (message.biddingStrategy != null && message.hasOwnProperty("biddingStrategy"))
                                $root.google.protobuf.StringValue.encode(message.biddingStrategy, writer.uint32(/* id 23, wireType 2 =*/186).fork()).ldelim();
                            if (message.manualCpc != null && message.hasOwnProperty("manualCpc"))
                                $root.google.ads.googleads.v1.common.ManualCpc.encode(message.manualCpc, writer.uint32(/* id 24, wireType 2 =*/194).fork()).ldelim();
                            if (message.manualCpm != null && message.hasOwnProperty("manualCpm"))
                                $root.google.ads.googleads.v1.common.ManualCpm.encode(message.manualCpm, writer.uint32(/* id 25, wireType 2 =*/202).fork()).ldelim();
                            if (message.targetCpa != null && message.hasOwnProperty("targetCpa"))
                                $root.google.ads.googleads.v1.common.TargetCpa.encode(message.targetCpa, writer.uint32(/* id 26, wireType 2 =*/210).fork()).ldelim();
                            if (message.targetSpend != null && message.hasOwnProperty("targetSpend"))
                                $root.google.ads.googleads.v1.common.TargetSpend.encode(message.targetSpend, writer.uint32(/* id 27, wireType 2 =*/218).fork()).ldelim();
                            if (message.baseCampaign != null && message.hasOwnProperty("baseCampaign"))
                                $root.google.protobuf.StringValue.encode(message.baseCampaign, writer.uint32(/* id 28, wireType 2 =*/226).fork()).ldelim();
                            if (message.targetRoas != null && message.hasOwnProperty("targetRoas"))
                                $root.google.ads.googleads.v1.common.TargetRoas.encode(message.targetRoas, writer.uint32(/* id 29, wireType 2 =*/234).fork()).ldelim();
                            if (message.maximizeConversions != null && message.hasOwnProperty("maximizeConversions"))
                                $root.google.ads.googleads.v1.common.MaximizeConversions.encode(message.maximizeConversions, writer.uint32(/* id 30, wireType 2 =*/242).fork()).ldelim();
                            if (message.maximizeConversionValue != null && message.hasOwnProperty("maximizeConversionValue"))
                                $root.google.ads.googleads.v1.common.MaximizeConversionValue.encode(message.maximizeConversionValue, writer.uint32(/* id 31, wireType 2 =*/250).fork()).ldelim();
                            if (message.hotelSetting != null && message.hasOwnProperty("hotelSetting"))
                                $root.google.ads.googleads.v1.resources.Campaign.HotelSettingInfo.encode(message.hotelSetting, writer.uint32(/* id 32, wireType 2 =*/258).fork()).ldelim();
                            if (message.dynamicSearchAdsSetting != null && message.hasOwnProperty("dynamicSearchAdsSetting"))
                                $root.google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting.encode(message.dynamicSearchAdsSetting, writer.uint32(/* id 33, wireType 2 =*/266).fork()).ldelim();
                            if (message.percentCpc != null && message.hasOwnProperty("percentCpc"))
                                $root.google.ads.googleads.v1.common.PercentCpc.encode(message.percentCpc, writer.uint32(/* id 34, wireType 2 =*/274).fork()).ldelim();
                            if (message.shoppingSetting != null && message.hasOwnProperty("shoppingSetting"))
                                $root.google.ads.googleads.v1.resources.Campaign.ShoppingSetting.encode(message.shoppingSetting, writer.uint32(/* id 36, wireType 2 =*/290).fork()).ldelim();
                            if (message.manualCpv != null && message.hasOwnProperty("manualCpv"))
                                $root.google.ads.googleads.v1.common.ManualCpv.encode(message.manualCpv, writer.uint32(/* id 37, wireType 2 =*/298).fork()).ldelim();
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix"))
                                $root.google.protobuf.StringValue.encode(message.finalUrlSuffix, writer.uint32(/* id 38, wireType 2 =*/306).fork()).ldelim();
                            if (message.realTimeBiddingSetting != null && message.hasOwnProperty("realTimeBiddingSetting"))
                                $root.google.ads.googleads.v1.common.RealTimeBiddingSetting.encode(message.realTimeBiddingSetting, writer.uint32(/* id 39, wireType 2 =*/314).fork()).ldelim();
                            if (message.frequencyCaps != null && message.frequencyCaps.length)
                                for (var i = 0; i < message.frequencyCaps.length; ++i)
                                    $root.google.ads.googleads.v1.common.FrequencyCapEntry.encode(message.frequencyCaps[i], writer.uint32(/* id 40, wireType 2 =*/322).fork()).ldelim();
                            if (message.targetCpm != null && message.hasOwnProperty("targetCpm"))
                                $root.google.ads.googleads.v1.common.TargetCpm.encode(message.targetCpm, writer.uint32(/* id 41, wireType 2 =*/330).fork()).ldelim();
                            if (message.videoBrandSafetySuitability != null && message.hasOwnProperty("videoBrandSafetySuitability"))
                                writer.uint32(/* id 42, wireType 0 =*/336).int32(message.videoBrandSafetySuitability);
                            if (message.targetingSetting != null && message.hasOwnProperty("targetingSetting"))
                                $root.google.ads.googleads.v1.common.TargetingSetting.encode(message.targetingSetting, writer.uint32(/* id 43, wireType 2 =*/346).fork()).ldelim();
                            if (message.vanityPharma != null && message.hasOwnProperty("vanityPharma"))
                                $root.google.ads.googleads.v1.resources.Campaign.VanityPharma.encode(message.vanityPharma, writer.uint32(/* id 44, wireType 2 =*/354).fork()).ldelim();
                            if (message.selectiveOptimization != null && message.hasOwnProperty("selectiveOptimization"))
                                $root.google.ads.googleads.v1.resources.Campaign.SelectiveOptimization.encode(message.selectiveOptimization, writer.uint32(/* id 45, wireType 2 =*/362).fork()).ldelim();
                            if (message.trackingSetting != null && message.hasOwnProperty("trackingSetting"))
                                $root.google.ads.googleads.v1.resources.Campaign.TrackingSetting.encode(message.trackingSetting, writer.uint32(/* id 46, wireType 2 =*/370).fork()).ldelim();
                            if (message.geoTargetTypeSetting != null && message.hasOwnProperty("geoTargetTypeSetting"))
                                $root.google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting.encode(message.geoTargetTypeSetting, writer.uint32(/* id 47, wireType 2 =*/378).fork()).ldelim();
                            if (message.targetImpressionShare != null && message.hasOwnProperty("targetImpressionShare"))
                                $root.google.ads.googleads.v1.common.TargetImpressionShare.encode(message.targetImpressionShare, writer.uint32(/* id 48, wireType 2 =*/386).fork()).ldelim();
                            if (message.commission != null && message.hasOwnProperty("commission"))
                                $root.google.ads.googleads.v1.common.Commission.encode(message.commission, writer.uint32(/* id 49, wireType 2 =*/394).fork()).ldelim();
                            if (message.appCampaignSetting != null && message.hasOwnProperty("appCampaignSetting"))
                                $root.google.ads.googleads.v1.resources.Campaign.AppCampaignSetting.encode(message.appCampaignSetting, writer.uint32(/* id 51, wireType 2 =*/410).fork()).ldelim();
                            if (message.paymentMode != null && message.hasOwnProperty("paymentMode"))
                                writer.uint32(/* id 52, wireType 0 =*/416).int32(message.paymentMode);
                            return writer;
                        };

                        /**
                         * Encodes the specified Campaign message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaign} message Campaign message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Campaign.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a Campaign message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.Campaign} Campaign
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Campaign.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Campaign();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 3:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.status = reader.int32();
                                    break;
                                case 21:
                                    message.servingStatus = reader.int32();
                                    break;
                                case 8:
                                    message.adServingOptimizationStatus = reader.int32();
                                    break;
                                case 9:
                                    message.advertisingChannelType = reader.int32();
                                    break;
                                case 10:
                                    message.advertisingChannelSubType = reader.int32();
                                    break;
                                case 11:
                                    message.trackingUrlTemplate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    if (!(message.urlCustomParameters && message.urlCustomParameters.length))
                                        message.urlCustomParameters = [];
                                    message.urlCustomParameters.push($root.google.ads.googleads.v1.common.CustomParameter.decode(reader, reader.uint32()));
                                    break;
                                case 39:
                                    message.realTimeBiddingSetting = $root.google.ads.googleads.v1.common.RealTimeBiddingSetting.decode(reader, reader.uint32());
                                    break;
                                case 14:
                                    message.networkSettings = $root.google.ads.googleads.v1.resources.Campaign.NetworkSettings.decode(reader, reader.uint32());
                                    break;
                                case 32:
                                    message.hotelSetting = $root.google.ads.googleads.v1.resources.Campaign.HotelSettingInfo.decode(reader, reader.uint32());
                                    break;
                                case 33:
                                    message.dynamicSearchAdsSetting = $root.google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting.decode(reader, reader.uint32());
                                    break;
                                case 36:
                                    message.shoppingSetting = $root.google.ads.googleads.v1.resources.Campaign.ShoppingSetting.decode(reader, reader.uint32());
                                    break;
                                case 43:
                                    message.targetingSetting = $root.google.ads.googleads.v1.common.TargetingSetting.decode(reader, reader.uint32());
                                    break;
                                case 47:
                                    message.geoTargetTypeSetting = $root.google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting.decode(reader, reader.uint32());
                                    break;
                                case 51:
                                    message.appCampaignSetting = $root.google.ads.googleads.v1.resources.Campaign.AppCampaignSetting.decode(reader, reader.uint32());
                                    break;
                                case 17:
                                    message.experimentType = reader.int32();
                                    break;
                                case 28:
                                    message.baseCampaign = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.campaignBudget = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 22:
                                    message.biddingStrategyType = reader.int32();
                                    break;
                                case 19:
                                    message.startDate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 20:
                                    message.endDate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 38:
                                    message.finalUrlSuffix = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 40:
                                    if (!(message.frequencyCaps && message.frequencyCaps.length))
                                        message.frequencyCaps = [];
                                    message.frequencyCaps.push($root.google.ads.googleads.v1.common.FrequencyCapEntry.decode(reader, reader.uint32()));
                                    break;
                                case 42:
                                    message.videoBrandSafetySuitability = reader.int32();
                                    break;
                                case 44:
                                    message.vanityPharma = $root.google.ads.googleads.v1.resources.Campaign.VanityPharma.decode(reader, reader.uint32());
                                    break;
                                case 45:
                                    message.selectiveOptimization = $root.google.ads.googleads.v1.resources.Campaign.SelectiveOptimization.decode(reader, reader.uint32());
                                    break;
                                case 46:
                                    message.trackingSetting = $root.google.ads.googleads.v1.resources.Campaign.TrackingSetting.decode(reader, reader.uint32());
                                    break;
                                case 52:
                                    message.paymentMode = reader.int32();
                                    break;
                                case 23:
                                    message.biddingStrategy = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 49:
                                    message.commission = $root.google.ads.googleads.v1.common.Commission.decode(reader, reader.uint32());
                                    break;
                                case 24:
                                    message.manualCpc = $root.google.ads.googleads.v1.common.ManualCpc.decode(reader, reader.uint32());
                                    break;
                                case 25:
                                    message.manualCpm = $root.google.ads.googleads.v1.common.ManualCpm.decode(reader, reader.uint32());
                                    break;
                                case 37:
                                    message.manualCpv = $root.google.ads.googleads.v1.common.ManualCpv.decode(reader, reader.uint32());
                                    break;
                                case 30:
                                    message.maximizeConversions = $root.google.ads.googleads.v1.common.MaximizeConversions.decode(reader, reader.uint32());
                                    break;
                                case 31:
                                    message.maximizeConversionValue = $root.google.ads.googleads.v1.common.MaximizeConversionValue.decode(reader, reader.uint32());
                                    break;
                                case 26:
                                    message.targetCpa = $root.google.ads.googleads.v1.common.TargetCpa.decode(reader, reader.uint32());
                                    break;
                                case 48:
                                    message.targetImpressionShare = $root.google.ads.googleads.v1.common.TargetImpressionShare.decode(reader, reader.uint32());
                                    break;
                                case 29:
                                    message.targetRoas = $root.google.ads.googleads.v1.common.TargetRoas.decode(reader, reader.uint32());
                                    break;
                                case 27:
                                    message.targetSpend = $root.google.ads.googleads.v1.common.TargetSpend.decode(reader, reader.uint32());
                                    break;
                                case 34:
                                    message.percentCpc = $root.google.ads.googleads.v1.common.PercentCpc.decode(reader, reader.uint32());
                                    break;
                                case 41:
                                    message.targetCpm = $root.google.ads.googleads.v1.common.TargetCpm.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a Campaign message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.Campaign} Campaign
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Campaign.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a Campaign message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Campaign.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.servingStatus != null && message.hasOwnProperty("servingStatus"))
                                switch (message.servingStatus) {
                                default:
                                    return "servingStatus: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            if (message.adServingOptimizationStatus != null && message.hasOwnProperty("adServingOptimizationStatus"))
                                switch (message.adServingOptimizationStatus) {
                                default:
                                    return "adServingOptimizationStatus: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            if (message.advertisingChannelType != null && message.hasOwnProperty("advertisingChannelType"))
                                switch (message.advertisingChannelType) {
                                default:
                                    return "advertisingChannelType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            if (message.advertisingChannelSubType != null && message.hasOwnProperty("advertisingChannelSubType"))
                                switch (message.advertisingChannelSubType) {
                                default:
                                    return "advertisingChannelSubType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                    break;
                                }
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.trackingUrlTemplate);
                                if (error)
                                    return "trackingUrlTemplate." + error;
                            }
                            if (message.urlCustomParameters != null && message.hasOwnProperty("urlCustomParameters")) {
                                if (!Array.isArray(message.urlCustomParameters))
                                    return "urlCustomParameters: array expected";
                                for (var i = 0; i < message.urlCustomParameters.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.CustomParameter.verify(message.urlCustomParameters[i]);
                                    if (error)
                                        return "urlCustomParameters." + error;
                                }
                            }
                            if (message.realTimeBiddingSetting != null && message.hasOwnProperty("realTimeBiddingSetting")) {
                                var error = $root.google.ads.googleads.v1.common.RealTimeBiddingSetting.verify(message.realTimeBiddingSetting);
                                if (error)
                                    return "realTimeBiddingSetting." + error;
                            }
                            if (message.networkSettings != null && message.hasOwnProperty("networkSettings")) {
                                var error = $root.google.ads.googleads.v1.resources.Campaign.NetworkSettings.verify(message.networkSettings);
                                if (error)
                                    return "networkSettings." + error;
                            }
                            if (message.hotelSetting != null && message.hasOwnProperty("hotelSetting")) {
                                var error = $root.google.ads.googleads.v1.resources.Campaign.HotelSettingInfo.verify(message.hotelSetting);
                                if (error)
                                    return "hotelSetting." + error;
                            }
                            if (message.dynamicSearchAdsSetting != null && message.hasOwnProperty("dynamicSearchAdsSetting")) {
                                var error = $root.google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting.verify(message.dynamicSearchAdsSetting);
                                if (error)
                                    return "dynamicSearchAdsSetting." + error;
                            }
                            if (message.shoppingSetting != null && message.hasOwnProperty("shoppingSetting")) {
                                var error = $root.google.ads.googleads.v1.resources.Campaign.ShoppingSetting.verify(message.shoppingSetting);
                                if (error)
                                    return "shoppingSetting." + error;
                            }
                            if (message.targetingSetting != null && message.hasOwnProperty("targetingSetting")) {
                                var error = $root.google.ads.googleads.v1.common.TargetingSetting.verify(message.targetingSetting);
                                if (error)
                                    return "targetingSetting." + error;
                            }
                            if (message.geoTargetTypeSetting != null && message.hasOwnProperty("geoTargetTypeSetting")) {
                                var error = $root.google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting.verify(message.geoTargetTypeSetting);
                                if (error)
                                    return "geoTargetTypeSetting." + error;
                            }
                            if (message.appCampaignSetting != null && message.hasOwnProperty("appCampaignSetting")) {
                                var error = $root.google.ads.googleads.v1.resources.Campaign.AppCampaignSetting.verify(message.appCampaignSetting);
                                if (error)
                                    return "appCampaignSetting." + error;
                            }
                            if (message.experimentType != null && message.hasOwnProperty("experimentType"))
                                switch (message.experimentType) {
                                default:
                                    return "experimentType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.baseCampaign != null && message.hasOwnProperty("baseCampaign")) {
                                var error = $root.google.protobuf.StringValue.verify(message.baseCampaign);
                                if (error)
                                    return "baseCampaign." + error;
                            }
                            if (message.campaignBudget != null && message.hasOwnProperty("campaignBudget")) {
                                var error = $root.google.protobuf.StringValue.verify(message.campaignBudget);
                                if (error)
                                    return "campaignBudget." + error;
                            }
                            if (message.biddingStrategyType != null && message.hasOwnProperty("biddingStrategyType"))
                                switch (message.biddingStrategyType) {
                                default:
                                    return "biddingStrategyType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 13:
                                case 10:
                                case 11:
                                case 5:
                                case 12:
                                case 6:
                                case 14:
                                case 15:
                                case 7:
                                case 8:
                                case 9:
                                    break;
                                }
                            if (message.startDate != null && message.hasOwnProperty("startDate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.startDate);
                                if (error)
                                    return "startDate." + error;
                            }
                            if (message.endDate != null && message.hasOwnProperty("endDate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.endDate);
                                if (error)
                                    return "endDate." + error;
                            }
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix")) {
                                var error = $root.google.protobuf.StringValue.verify(message.finalUrlSuffix);
                                if (error)
                                    return "finalUrlSuffix." + error;
                            }
                            if (message.frequencyCaps != null && message.hasOwnProperty("frequencyCaps")) {
                                if (!Array.isArray(message.frequencyCaps))
                                    return "frequencyCaps: array expected";
                                for (var i = 0; i < message.frequencyCaps.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.FrequencyCapEntry.verify(message.frequencyCaps[i]);
                                    if (error)
                                        return "frequencyCaps." + error;
                                }
                            }
                            if (message.videoBrandSafetySuitability != null && message.hasOwnProperty("videoBrandSafetySuitability"))
                                switch (message.videoBrandSafetySuitability) {
                                default:
                                    return "videoBrandSafetySuitability: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.vanityPharma != null && message.hasOwnProperty("vanityPharma")) {
                                var error = $root.google.ads.googleads.v1.resources.Campaign.VanityPharma.verify(message.vanityPharma);
                                if (error)
                                    return "vanityPharma." + error;
                            }
                            if (message.selectiveOptimization != null && message.hasOwnProperty("selectiveOptimization")) {
                                var error = $root.google.ads.googleads.v1.resources.Campaign.SelectiveOptimization.verify(message.selectiveOptimization);
                                if (error)
                                    return "selectiveOptimization." + error;
                            }
                            if (message.trackingSetting != null && message.hasOwnProperty("trackingSetting")) {
                                var error = $root.google.ads.googleads.v1.resources.Campaign.TrackingSetting.verify(message.trackingSetting);
                                if (error)
                                    return "trackingSetting." + error;
                            }
                            if (message.paymentMode != null && message.hasOwnProperty("paymentMode"))
                                switch (message.paymentMode) {
                                default:
                                    return "paymentMode: enum value expected";
                                case 0:
                                case 1:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            if (message.biddingStrategy != null && message.hasOwnProperty("biddingStrategy")) {
                                properties.campaignBiddingStrategy = 1;
                                {
                                    var error = $root.google.protobuf.StringValue.verify(message.biddingStrategy);
                                    if (error)
                                        return "biddingStrategy." + error;
                                }
                            }
                            if (message.commission != null && message.hasOwnProperty("commission")) {
                                if (properties.campaignBiddingStrategy === 1)
                                    return "campaignBiddingStrategy: multiple values";
                                properties.campaignBiddingStrategy = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.Commission.verify(message.commission);
                                    if (error)
                                        return "commission." + error;
                                }
                            }
                            if (message.manualCpc != null && message.hasOwnProperty("manualCpc")) {
                                if (properties.campaignBiddingStrategy === 1)
                                    return "campaignBiddingStrategy: multiple values";
                                properties.campaignBiddingStrategy = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ManualCpc.verify(message.manualCpc);
                                    if (error)
                                        return "manualCpc." + error;
                                }
                            }
                            if (message.manualCpm != null && message.hasOwnProperty("manualCpm")) {
                                if (properties.campaignBiddingStrategy === 1)
                                    return "campaignBiddingStrategy: multiple values";
                                properties.campaignBiddingStrategy = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ManualCpm.verify(message.manualCpm);
                                    if (error)
                                        return "manualCpm." + error;
                                }
                            }
                            if (message.manualCpv != null && message.hasOwnProperty("manualCpv")) {
                                if (properties.campaignBiddingStrategy === 1)
                                    return "campaignBiddingStrategy: multiple values";
                                properties.campaignBiddingStrategy = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ManualCpv.verify(message.manualCpv);
                                    if (error)
                                        return "manualCpv." + error;
                                }
                            }
                            if (message.maximizeConversions != null && message.hasOwnProperty("maximizeConversions")) {
                                if (properties.campaignBiddingStrategy === 1)
                                    return "campaignBiddingStrategy: multiple values";
                                properties.campaignBiddingStrategy = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.MaximizeConversions.verify(message.maximizeConversions);
                                    if (error)
                                        return "maximizeConversions." + error;
                                }
                            }
                            if (message.maximizeConversionValue != null && message.hasOwnProperty("maximizeConversionValue")) {
                                if (properties.campaignBiddingStrategy === 1)
                                    return "campaignBiddingStrategy: multiple values";
                                properties.campaignBiddingStrategy = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.MaximizeConversionValue.verify(message.maximizeConversionValue);
                                    if (error)
                                        return "maximizeConversionValue." + error;
                                }
                            }
                            if (message.targetCpa != null && message.hasOwnProperty("targetCpa")) {
                                if (properties.campaignBiddingStrategy === 1)
                                    return "campaignBiddingStrategy: multiple values";
                                properties.campaignBiddingStrategy = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.TargetCpa.verify(message.targetCpa);
                                    if (error)
                                        return "targetCpa." + error;
                                }
                            }
                            if (message.targetImpressionShare != null && message.hasOwnProperty("targetImpressionShare")) {
                                if (properties.campaignBiddingStrategy === 1)
                                    return "campaignBiddingStrategy: multiple values";
                                properties.campaignBiddingStrategy = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.TargetImpressionShare.verify(message.targetImpressionShare);
                                    if (error)
                                        return "targetImpressionShare." + error;
                                }
                            }
                            if (message.targetRoas != null && message.hasOwnProperty("targetRoas")) {
                                if (properties.campaignBiddingStrategy === 1)
                                    return "campaignBiddingStrategy: multiple values";
                                properties.campaignBiddingStrategy = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.TargetRoas.verify(message.targetRoas);
                                    if (error)
                                        return "targetRoas." + error;
                                }
                            }
                            if (message.targetSpend != null && message.hasOwnProperty("targetSpend")) {
                                if (properties.campaignBiddingStrategy === 1)
                                    return "campaignBiddingStrategy: multiple values";
                                properties.campaignBiddingStrategy = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.TargetSpend.verify(message.targetSpend);
                                    if (error)
                                        return "targetSpend." + error;
                                }
                            }
                            if (message.percentCpc != null && message.hasOwnProperty("percentCpc")) {
                                if (properties.campaignBiddingStrategy === 1)
                                    return "campaignBiddingStrategy: multiple values";
                                properties.campaignBiddingStrategy = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.PercentCpc.verify(message.percentCpc);
                                    if (error)
                                        return "percentCpc." + error;
                                }
                            }
                            if (message.targetCpm != null && message.hasOwnProperty("targetCpm")) {
                                if (properties.campaignBiddingStrategy === 1)
                                    return "campaignBiddingStrategy: multiple values";
                                properties.campaignBiddingStrategy = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.TargetCpm.verify(message.targetCpm);
                                    if (error)
                                        return "targetCpm." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a Campaign message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.Campaign} Campaign
                         */
                        Campaign.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.Campaign)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.Campaign();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "PAUSED":
                            case 3:
                                message.status = 3;
                                break;
                            case "REMOVED":
                            case 4:
                                message.status = 4;
                                break;
                            }
                            switch (object.servingStatus) {
                            case "UNSPECIFIED":
                            case 0:
                                message.servingStatus = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.servingStatus = 1;
                                break;
                            case "SERVING":
                            case 2:
                                message.servingStatus = 2;
                                break;
                            case "NONE":
                            case 3:
                                message.servingStatus = 3;
                                break;
                            case "ENDED":
                            case 4:
                                message.servingStatus = 4;
                                break;
                            case "PENDING":
                            case 5:
                                message.servingStatus = 5;
                                break;
                            case "SUSPENDED":
                            case 6:
                                message.servingStatus = 6;
                                break;
                            }
                            switch (object.adServingOptimizationStatus) {
                            case "UNSPECIFIED":
                            case 0:
                                message.adServingOptimizationStatus = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.adServingOptimizationStatus = 1;
                                break;
                            case "OPTIMIZE":
                            case 2:
                                message.adServingOptimizationStatus = 2;
                                break;
                            case "CONVERSION_OPTIMIZE":
                            case 3:
                                message.adServingOptimizationStatus = 3;
                                break;
                            case "ROTATE":
                            case 4:
                                message.adServingOptimizationStatus = 4;
                                break;
                            case "ROTATE_INDEFINITELY":
                            case 5:
                                message.adServingOptimizationStatus = 5;
                                break;
                            case "UNAVAILABLE":
                            case 6:
                                message.adServingOptimizationStatus = 6;
                                break;
                            }
                            switch (object.advertisingChannelType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.advertisingChannelType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.advertisingChannelType = 1;
                                break;
                            case "SEARCH":
                            case 2:
                                message.advertisingChannelType = 2;
                                break;
                            case "DISPLAY":
                            case 3:
                                message.advertisingChannelType = 3;
                                break;
                            case "SHOPPING":
                            case 4:
                                message.advertisingChannelType = 4;
                                break;
                            case "HOTEL":
                            case 5:
                                message.advertisingChannelType = 5;
                                break;
                            case "VIDEO":
                            case 6:
                                message.advertisingChannelType = 6;
                                break;
                            case "MULTI_CHANNEL":
                            case 7:
                                message.advertisingChannelType = 7;
                                break;
                            }
                            switch (object.advertisingChannelSubType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.advertisingChannelSubType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.advertisingChannelSubType = 1;
                                break;
                            case "SEARCH_MOBILE_APP":
                            case 2:
                                message.advertisingChannelSubType = 2;
                                break;
                            case "DISPLAY_MOBILE_APP":
                            case 3:
                                message.advertisingChannelSubType = 3;
                                break;
                            case "SEARCH_EXPRESS":
                            case 4:
                                message.advertisingChannelSubType = 4;
                                break;
                            case "DISPLAY_EXPRESS":
                            case 5:
                                message.advertisingChannelSubType = 5;
                                break;
                            case "SHOPPING_SMART_ADS":
                            case 6:
                                message.advertisingChannelSubType = 6;
                                break;
                            case "DISPLAY_GMAIL_AD":
                            case 7:
                                message.advertisingChannelSubType = 7;
                                break;
                            case "DISPLAY_SMART_CAMPAIGN":
                            case 8:
                                message.advertisingChannelSubType = 8;
                                break;
                            case "VIDEO_OUTSTREAM":
                            case 9:
                                message.advertisingChannelSubType = 9;
                                break;
                            case "VIDEO_ACTION":
                            case 10:
                                message.advertisingChannelSubType = 10;
                                break;
                            case "VIDEO_NON_SKIPPABLE":
                            case 11:
                                message.advertisingChannelSubType = 11;
                                break;
                            case "APP_CAMPAIGN":
                            case 12:
                                message.advertisingChannelSubType = 12;
                                break;
                            case "APP_CAMPAIGN_FOR_ENGAGEMENT":
                            case 13:
                                message.advertisingChannelSubType = 13;
                                break;
                            }
                            if (object.trackingUrlTemplate != null) {
                                if (typeof object.trackingUrlTemplate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.trackingUrlTemplate: object expected");
                                message.trackingUrlTemplate = $root.google.protobuf.StringValue.fromObject(object.trackingUrlTemplate);
                            }
                            if (object.urlCustomParameters) {
                                if (!Array.isArray(object.urlCustomParameters))
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.urlCustomParameters: array expected");
                                message.urlCustomParameters = [];
                                for (var i = 0; i < object.urlCustomParameters.length; ++i) {
                                    if (typeof object.urlCustomParameters[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Campaign.urlCustomParameters: object expected");
                                    message.urlCustomParameters[i] = $root.google.ads.googleads.v1.common.CustomParameter.fromObject(object.urlCustomParameters[i]);
                                }
                            }
                            if (object.realTimeBiddingSetting != null) {
                                if (typeof object.realTimeBiddingSetting !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.realTimeBiddingSetting: object expected");
                                message.realTimeBiddingSetting = $root.google.ads.googleads.v1.common.RealTimeBiddingSetting.fromObject(object.realTimeBiddingSetting);
                            }
                            if (object.networkSettings != null) {
                                if (typeof object.networkSettings !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.networkSettings: object expected");
                                message.networkSettings = $root.google.ads.googleads.v1.resources.Campaign.NetworkSettings.fromObject(object.networkSettings);
                            }
                            if (object.hotelSetting != null) {
                                if (typeof object.hotelSetting !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.hotelSetting: object expected");
                                message.hotelSetting = $root.google.ads.googleads.v1.resources.Campaign.HotelSettingInfo.fromObject(object.hotelSetting);
                            }
                            if (object.dynamicSearchAdsSetting != null) {
                                if (typeof object.dynamicSearchAdsSetting !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.dynamicSearchAdsSetting: object expected");
                                message.dynamicSearchAdsSetting = $root.google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting.fromObject(object.dynamicSearchAdsSetting);
                            }
                            if (object.shoppingSetting != null) {
                                if (typeof object.shoppingSetting !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.shoppingSetting: object expected");
                                message.shoppingSetting = $root.google.ads.googleads.v1.resources.Campaign.ShoppingSetting.fromObject(object.shoppingSetting);
                            }
                            if (object.targetingSetting != null) {
                                if (typeof object.targetingSetting !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.targetingSetting: object expected");
                                message.targetingSetting = $root.google.ads.googleads.v1.common.TargetingSetting.fromObject(object.targetingSetting);
                            }
                            if (object.geoTargetTypeSetting != null) {
                                if (typeof object.geoTargetTypeSetting !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.geoTargetTypeSetting: object expected");
                                message.geoTargetTypeSetting = $root.google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting.fromObject(object.geoTargetTypeSetting);
                            }
                            if (object.appCampaignSetting != null) {
                                if (typeof object.appCampaignSetting !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.appCampaignSetting: object expected");
                                message.appCampaignSetting = $root.google.ads.googleads.v1.resources.Campaign.AppCampaignSetting.fromObject(object.appCampaignSetting);
                            }
                            switch (object.experimentType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.experimentType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.experimentType = 1;
                                break;
                            case "BASE":
                            case 2:
                                message.experimentType = 2;
                                break;
                            case "DRAFT":
                            case 3:
                                message.experimentType = 3;
                                break;
                            case "EXPERIMENT":
                            case 4:
                                message.experimentType = 4;
                                break;
                            }
                            if (object.baseCampaign != null) {
                                if (typeof object.baseCampaign !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.baseCampaign: object expected");
                                message.baseCampaign = $root.google.protobuf.StringValue.fromObject(object.baseCampaign);
                            }
                            if (object.campaignBudget != null) {
                                if (typeof object.campaignBudget !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.campaignBudget: object expected");
                                message.campaignBudget = $root.google.protobuf.StringValue.fromObject(object.campaignBudget);
                            }
                            switch (object.biddingStrategyType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.biddingStrategyType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.biddingStrategyType = 1;
                                break;
                            case "ENHANCED_CPC":
                            case 2:
                                message.biddingStrategyType = 2;
                                break;
                            case "MANUAL_CPC":
                            case 3:
                                message.biddingStrategyType = 3;
                                break;
                            case "MANUAL_CPM":
                            case 4:
                                message.biddingStrategyType = 4;
                                break;
                            case "MANUAL_CPV":
                            case 13:
                                message.biddingStrategyType = 13;
                                break;
                            case "MAXIMIZE_CONVERSIONS":
                            case 10:
                                message.biddingStrategyType = 10;
                                break;
                            case "MAXIMIZE_CONVERSION_VALUE":
                            case 11:
                                message.biddingStrategyType = 11;
                                break;
                            case "PAGE_ONE_PROMOTED":
                            case 5:
                                message.biddingStrategyType = 5;
                                break;
                            case "PERCENT_CPC":
                            case 12:
                                message.biddingStrategyType = 12;
                                break;
                            case "TARGET_CPA":
                            case 6:
                                message.biddingStrategyType = 6;
                                break;
                            case "TARGET_CPM":
                            case 14:
                                message.biddingStrategyType = 14;
                                break;
                            case "TARGET_IMPRESSION_SHARE":
                            case 15:
                                message.biddingStrategyType = 15;
                                break;
                            case "TARGET_OUTRANK_SHARE":
                            case 7:
                                message.biddingStrategyType = 7;
                                break;
                            case "TARGET_ROAS":
                            case 8:
                                message.biddingStrategyType = 8;
                                break;
                            case "TARGET_SPEND":
                            case 9:
                                message.biddingStrategyType = 9;
                                break;
                            }
                            if (object.startDate != null) {
                                if (typeof object.startDate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.startDate: object expected");
                                message.startDate = $root.google.protobuf.StringValue.fromObject(object.startDate);
                            }
                            if (object.endDate != null) {
                                if (typeof object.endDate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.endDate: object expected");
                                message.endDate = $root.google.protobuf.StringValue.fromObject(object.endDate);
                            }
                            if (object.finalUrlSuffix != null) {
                                if (typeof object.finalUrlSuffix !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.finalUrlSuffix: object expected");
                                message.finalUrlSuffix = $root.google.protobuf.StringValue.fromObject(object.finalUrlSuffix);
                            }
                            if (object.frequencyCaps) {
                                if (!Array.isArray(object.frequencyCaps))
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.frequencyCaps: array expected");
                                message.frequencyCaps = [];
                                for (var i = 0; i < object.frequencyCaps.length; ++i) {
                                    if (typeof object.frequencyCaps[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Campaign.frequencyCaps: object expected");
                                    message.frequencyCaps[i] = $root.google.ads.googleads.v1.common.FrequencyCapEntry.fromObject(object.frequencyCaps[i]);
                                }
                            }
                            switch (object.videoBrandSafetySuitability) {
                            case "UNSPECIFIED":
                            case 0:
                                message.videoBrandSafetySuitability = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.videoBrandSafetySuitability = 1;
                                break;
                            case "EXPANDED_INVENTORY":
                            case 2:
                                message.videoBrandSafetySuitability = 2;
                                break;
                            case "STANDARD_INVENTORY":
                            case 3:
                                message.videoBrandSafetySuitability = 3;
                                break;
                            case "LIMITED_INVENTORY":
                            case 4:
                                message.videoBrandSafetySuitability = 4;
                                break;
                            }
                            if (object.vanityPharma != null) {
                                if (typeof object.vanityPharma !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.vanityPharma: object expected");
                                message.vanityPharma = $root.google.ads.googleads.v1.resources.Campaign.VanityPharma.fromObject(object.vanityPharma);
                            }
                            if (object.selectiveOptimization != null) {
                                if (typeof object.selectiveOptimization !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.selectiveOptimization: object expected");
                                message.selectiveOptimization = $root.google.ads.googleads.v1.resources.Campaign.SelectiveOptimization.fromObject(object.selectiveOptimization);
                            }
                            if (object.trackingSetting != null) {
                                if (typeof object.trackingSetting !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.trackingSetting: object expected");
                                message.trackingSetting = $root.google.ads.googleads.v1.resources.Campaign.TrackingSetting.fromObject(object.trackingSetting);
                            }
                            switch (object.paymentMode) {
                            case "UNSPECIFIED":
                            case 0:
                                message.paymentMode = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.paymentMode = 1;
                                break;
                            case "CLICKS":
                            case 4:
                                message.paymentMode = 4;
                                break;
                            case "CONVERSION_VALUE":
                            case 5:
                                message.paymentMode = 5;
                                break;
                            case "CONVERSIONS":
                            case 6:
                                message.paymentMode = 6;
                                break;
                            }
                            if (object.biddingStrategy != null) {
                                if (typeof object.biddingStrategy !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.biddingStrategy: object expected");
                                message.biddingStrategy = $root.google.protobuf.StringValue.fromObject(object.biddingStrategy);
                            }
                            if (object.commission != null) {
                                if (typeof object.commission !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.commission: object expected");
                                message.commission = $root.google.ads.googleads.v1.common.Commission.fromObject(object.commission);
                            }
                            if (object.manualCpc != null) {
                                if (typeof object.manualCpc !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.manualCpc: object expected");
                                message.manualCpc = $root.google.ads.googleads.v1.common.ManualCpc.fromObject(object.manualCpc);
                            }
                            if (object.manualCpm != null) {
                                if (typeof object.manualCpm !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.manualCpm: object expected");
                                message.manualCpm = $root.google.ads.googleads.v1.common.ManualCpm.fromObject(object.manualCpm);
                            }
                            if (object.manualCpv != null) {
                                if (typeof object.manualCpv !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.manualCpv: object expected");
                                message.manualCpv = $root.google.ads.googleads.v1.common.ManualCpv.fromObject(object.manualCpv);
                            }
                            if (object.maximizeConversions != null) {
                                if (typeof object.maximizeConversions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.maximizeConversions: object expected");
                                message.maximizeConversions = $root.google.ads.googleads.v1.common.MaximizeConversions.fromObject(object.maximizeConversions);
                            }
                            if (object.maximizeConversionValue != null) {
                                if (typeof object.maximizeConversionValue !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.maximizeConversionValue: object expected");
                                message.maximizeConversionValue = $root.google.ads.googleads.v1.common.MaximizeConversionValue.fromObject(object.maximizeConversionValue);
                            }
                            if (object.targetCpa != null) {
                                if (typeof object.targetCpa !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.targetCpa: object expected");
                                message.targetCpa = $root.google.ads.googleads.v1.common.TargetCpa.fromObject(object.targetCpa);
                            }
                            if (object.targetImpressionShare != null) {
                                if (typeof object.targetImpressionShare !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.targetImpressionShare: object expected");
                                message.targetImpressionShare = $root.google.ads.googleads.v1.common.TargetImpressionShare.fromObject(object.targetImpressionShare);
                            }
                            if (object.targetRoas != null) {
                                if (typeof object.targetRoas !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.targetRoas: object expected");
                                message.targetRoas = $root.google.ads.googleads.v1.common.TargetRoas.fromObject(object.targetRoas);
                            }
                            if (object.targetSpend != null) {
                                if (typeof object.targetSpend !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.targetSpend: object expected");
                                message.targetSpend = $root.google.ads.googleads.v1.common.TargetSpend.fromObject(object.targetSpend);
                            }
                            if (object.percentCpc != null) {
                                if (typeof object.percentCpc !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.percentCpc: object expected");
                                message.percentCpc = $root.google.ads.googleads.v1.common.PercentCpc.fromObject(object.percentCpc);
                            }
                            if (object.targetCpm != null) {
                                if (typeof object.targetCpm !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Campaign.targetCpm: object expected");
                                message.targetCpm = $root.google.ads.googleads.v1.common.TargetCpm.fromObject(object.targetCpm);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a Campaign message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @static
                         * @param {google.ads.googleads.v1.resources.Campaign} message Campaign
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Campaign.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.urlCustomParameters = [];
                                object.frequencyCaps = [];
                            }
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.name = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                                object.campaignBudget = null;
                                object.adServingOptimizationStatus = options.enums === String ? "UNSPECIFIED" : 0;
                                object.advertisingChannelType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.advertisingChannelSubType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.trackingUrlTemplate = null;
                                object.networkSettings = null;
                                object.experimentType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.startDate = null;
                                object.endDate = null;
                                object.servingStatus = options.enums === String ? "UNSPECIFIED" : 0;
                                object.biddingStrategyType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.baseCampaign = null;
                                object.hotelSetting = null;
                                object.dynamicSearchAdsSetting = null;
                                object.shoppingSetting = null;
                                object.finalUrlSuffix = null;
                                object.realTimeBiddingSetting = null;
                                object.videoBrandSafetySuitability = options.enums === String ? "UNSPECIFIED" : 0;
                                object.targetingSetting = null;
                                object.vanityPharma = null;
                                object.selectiveOptimization = null;
                                object.trackingSetting = null;
                                object.geoTargetTypeSetting = null;
                                object.appCampaignSetting = null;
                                object.paymentMode = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.CampaignStatusEnum.CampaignStatus[message.status] : message.status;
                            if (message.campaignBudget != null && message.hasOwnProperty("campaignBudget"))
                                object.campaignBudget = $root.google.protobuf.StringValue.toObject(message.campaignBudget, options);
                            if (message.adServingOptimizationStatus != null && message.hasOwnProperty("adServingOptimizationStatus"))
                                object.adServingOptimizationStatus = options.enums === String ? $root.google.ads.googleads.v1.enums.AdServingOptimizationStatusEnum.AdServingOptimizationStatus[message.adServingOptimizationStatus] : message.adServingOptimizationStatus;
                            if (message.advertisingChannelType != null && message.hasOwnProperty("advertisingChannelType"))
                                object.advertisingChannelType = options.enums === String ? $root.google.ads.googleads.v1.enums.AdvertisingChannelTypeEnum.AdvertisingChannelType[message.advertisingChannelType] : message.advertisingChannelType;
                            if (message.advertisingChannelSubType != null && message.hasOwnProperty("advertisingChannelSubType"))
                                object.advertisingChannelSubType = options.enums === String ? $root.google.ads.googleads.v1.enums.AdvertisingChannelSubTypeEnum.AdvertisingChannelSubType[message.advertisingChannelSubType] : message.advertisingChannelSubType;
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                object.trackingUrlTemplate = $root.google.protobuf.StringValue.toObject(message.trackingUrlTemplate, options);
                            if (message.urlCustomParameters && message.urlCustomParameters.length) {
                                object.urlCustomParameters = [];
                                for (var j = 0; j < message.urlCustomParameters.length; ++j)
                                    object.urlCustomParameters[j] = $root.google.ads.googleads.v1.common.CustomParameter.toObject(message.urlCustomParameters[j], options);
                            }
                            if (message.networkSettings != null && message.hasOwnProperty("networkSettings"))
                                object.networkSettings = $root.google.ads.googleads.v1.resources.Campaign.NetworkSettings.toObject(message.networkSettings, options);
                            if (message.experimentType != null && message.hasOwnProperty("experimentType"))
                                object.experimentType = options.enums === String ? $root.google.ads.googleads.v1.enums.CampaignExperimentTypeEnum.CampaignExperimentType[message.experimentType] : message.experimentType;
                            if (message.startDate != null && message.hasOwnProperty("startDate"))
                                object.startDate = $root.google.protobuf.StringValue.toObject(message.startDate, options);
                            if (message.endDate != null && message.hasOwnProperty("endDate"))
                                object.endDate = $root.google.protobuf.StringValue.toObject(message.endDate, options);
                            if (message.servingStatus != null && message.hasOwnProperty("servingStatus"))
                                object.servingStatus = options.enums === String ? $root.google.ads.googleads.v1.enums.CampaignServingStatusEnum.CampaignServingStatus[message.servingStatus] : message.servingStatus;
                            if (message.biddingStrategyType != null && message.hasOwnProperty("biddingStrategyType"))
                                object.biddingStrategyType = options.enums === String ? $root.google.ads.googleads.v1.enums.BiddingStrategyTypeEnum.BiddingStrategyType[message.biddingStrategyType] : message.biddingStrategyType;
                            if (message.biddingStrategy != null && message.hasOwnProperty("biddingStrategy")) {
                                object.biddingStrategy = $root.google.protobuf.StringValue.toObject(message.biddingStrategy, options);
                                if (options.oneofs)
                                    object.campaignBiddingStrategy = "biddingStrategy";
                            }
                            if (message.manualCpc != null && message.hasOwnProperty("manualCpc")) {
                                object.manualCpc = $root.google.ads.googleads.v1.common.ManualCpc.toObject(message.manualCpc, options);
                                if (options.oneofs)
                                    object.campaignBiddingStrategy = "manualCpc";
                            }
                            if (message.manualCpm != null && message.hasOwnProperty("manualCpm")) {
                                object.manualCpm = $root.google.ads.googleads.v1.common.ManualCpm.toObject(message.manualCpm, options);
                                if (options.oneofs)
                                    object.campaignBiddingStrategy = "manualCpm";
                            }
                            if (message.targetCpa != null && message.hasOwnProperty("targetCpa")) {
                                object.targetCpa = $root.google.ads.googleads.v1.common.TargetCpa.toObject(message.targetCpa, options);
                                if (options.oneofs)
                                    object.campaignBiddingStrategy = "targetCpa";
                            }
                            if (message.targetSpend != null && message.hasOwnProperty("targetSpend")) {
                                object.targetSpend = $root.google.ads.googleads.v1.common.TargetSpend.toObject(message.targetSpend, options);
                                if (options.oneofs)
                                    object.campaignBiddingStrategy = "targetSpend";
                            }
                            if (message.baseCampaign != null && message.hasOwnProperty("baseCampaign"))
                                object.baseCampaign = $root.google.protobuf.StringValue.toObject(message.baseCampaign, options);
                            if (message.targetRoas != null && message.hasOwnProperty("targetRoas")) {
                                object.targetRoas = $root.google.ads.googleads.v1.common.TargetRoas.toObject(message.targetRoas, options);
                                if (options.oneofs)
                                    object.campaignBiddingStrategy = "targetRoas";
                            }
                            if (message.maximizeConversions != null && message.hasOwnProperty("maximizeConversions")) {
                                object.maximizeConversions = $root.google.ads.googleads.v1.common.MaximizeConversions.toObject(message.maximizeConversions, options);
                                if (options.oneofs)
                                    object.campaignBiddingStrategy = "maximizeConversions";
                            }
                            if (message.maximizeConversionValue != null && message.hasOwnProperty("maximizeConversionValue")) {
                                object.maximizeConversionValue = $root.google.ads.googleads.v1.common.MaximizeConversionValue.toObject(message.maximizeConversionValue, options);
                                if (options.oneofs)
                                    object.campaignBiddingStrategy = "maximizeConversionValue";
                            }
                            if (message.hotelSetting != null && message.hasOwnProperty("hotelSetting"))
                                object.hotelSetting = $root.google.ads.googleads.v1.resources.Campaign.HotelSettingInfo.toObject(message.hotelSetting, options);
                            if (message.dynamicSearchAdsSetting != null && message.hasOwnProperty("dynamicSearchAdsSetting"))
                                object.dynamicSearchAdsSetting = $root.google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting.toObject(message.dynamicSearchAdsSetting, options);
                            if (message.percentCpc != null && message.hasOwnProperty("percentCpc")) {
                                object.percentCpc = $root.google.ads.googleads.v1.common.PercentCpc.toObject(message.percentCpc, options);
                                if (options.oneofs)
                                    object.campaignBiddingStrategy = "percentCpc";
                            }
                            if (message.shoppingSetting != null && message.hasOwnProperty("shoppingSetting"))
                                object.shoppingSetting = $root.google.ads.googleads.v1.resources.Campaign.ShoppingSetting.toObject(message.shoppingSetting, options);
                            if (message.manualCpv != null && message.hasOwnProperty("manualCpv")) {
                                object.manualCpv = $root.google.ads.googleads.v1.common.ManualCpv.toObject(message.manualCpv, options);
                                if (options.oneofs)
                                    object.campaignBiddingStrategy = "manualCpv";
                            }
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix"))
                                object.finalUrlSuffix = $root.google.protobuf.StringValue.toObject(message.finalUrlSuffix, options);
                            if (message.realTimeBiddingSetting != null && message.hasOwnProperty("realTimeBiddingSetting"))
                                object.realTimeBiddingSetting = $root.google.ads.googleads.v1.common.RealTimeBiddingSetting.toObject(message.realTimeBiddingSetting, options);
                            if (message.frequencyCaps && message.frequencyCaps.length) {
                                object.frequencyCaps = [];
                                for (var j = 0; j < message.frequencyCaps.length; ++j)
                                    object.frequencyCaps[j] = $root.google.ads.googleads.v1.common.FrequencyCapEntry.toObject(message.frequencyCaps[j], options);
                            }
                            if (message.targetCpm != null && message.hasOwnProperty("targetCpm")) {
                                object.targetCpm = $root.google.ads.googleads.v1.common.TargetCpm.toObject(message.targetCpm, options);
                                if (options.oneofs)
                                    object.campaignBiddingStrategy = "targetCpm";
                            }
                            if (message.videoBrandSafetySuitability != null && message.hasOwnProperty("videoBrandSafetySuitability"))
                                object.videoBrandSafetySuitability = options.enums === String ? $root.google.ads.googleads.v1.enums.BrandSafetySuitabilityEnum.BrandSafetySuitability[message.videoBrandSafetySuitability] : message.videoBrandSafetySuitability;
                            if (message.targetingSetting != null && message.hasOwnProperty("targetingSetting"))
                                object.targetingSetting = $root.google.ads.googleads.v1.common.TargetingSetting.toObject(message.targetingSetting, options);
                            if (message.vanityPharma != null && message.hasOwnProperty("vanityPharma"))
                                object.vanityPharma = $root.google.ads.googleads.v1.resources.Campaign.VanityPharma.toObject(message.vanityPharma, options);
                            if (message.selectiveOptimization != null && message.hasOwnProperty("selectiveOptimization"))
                                object.selectiveOptimization = $root.google.ads.googleads.v1.resources.Campaign.SelectiveOptimization.toObject(message.selectiveOptimization, options);
                            if (message.trackingSetting != null && message.hasOwnProperty("trackingSetting"))
                                object.trackingSetting = $root.google.ads.googleads.v1.resources.Campaign.TrackingSetting.toObject(message.trackingSetting, options);
                            if (message.geoTargetTypeSetting != null && message.hasOwnProperty("geoTargetTypeSetting"))
                                object.geoTargetTypeSetting = $root.google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting.toObject(message.geoTargetTypeSetting, options);
                            if (message.targetImpressionShare != null && message.hasOwnProperty("targetImpressionShare")) {
                                object.targetImpressionShare = $root.google.ads.googleads.v1.common.TargetImpressionShare.toObject(message.targetImpressionShare, options);
                                if (options.oneofs)
                                    object.campaignBiddingStrategy = "targetImpressionShare";
                            }
                            if (message.commission != null && message.hasOwnProperty("commission")) {
                                object.commission = $root.google.ads.googleads.v1.common.Commission.toObject(message.commission, options);
                                if (options.oneofs)
                                    object.campaignBiddingStrategy = "commission";
                            }
                            if (message.appCampaignSetting != null && message.hasOwnProperty("appCampaignSetting"))
                                object.appCampaignSetting = $root.google.ads.googleads.v1.resources.Campaign.AppCampaignSetting.toObject(message.appCampaignSetting, options);
                            if (message.paymentMode != null && message.hasOwnProperty("paymentMode"))
                                object.paymentMode = options.enums === String ? $root.google.ads.googleads.v1.enums.PaymentModeEnum.PaymentMode[message.paymentMode] : message.paymentMode;
                            return object;
                        };

                        /**
                         * Converts this Campaign to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.Campaign
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Campaign.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        Campaign.NetworkSettings = (function() {

                            /**
                             * Properties of a NetworkSettings.
                             * @memberof google.ads.googleads.v1.resources.Campaign
                             * @interface INetworkSettings
                             * @property {google.protobuf.IBoolValue|null} [targetGoogleSearch] NetworkSettings targetGoogleSearch
                             * @property {google.protobuf.IBoolValue|null} [targetSearchNetwork] NetworkSettings targetSearchNetwork
                             * @property {google.protobuf.IBoolValue|null} [targetContentNetwork] NetworkSettings targetContentNetwork
                             * @property {google.protobuf.IBoolValue|null} [targetPartnerSearchNetwork] NetworkSettings targetPartnerSearchNetwork
                             */

                            /**
                             * Constructs a new NetworkSettings.
                             * @memberof google.ads.googleads.v1.resources.Campaign
                             * @classdesc Represents a NetworkSettings.
                             * @implements INetworkSettings
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Campaign.INetworkSettings=} [properties] Properties to set
                             */
                            function NetworkSettings(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * NetworkSettings targetGoogleSearch.
                             * @member {google.protobuf.IBoolValue|null|undefined} targetGoogleSearch
                             * @memberof google.ads.googleads.v1.resources.Campaign.NetworkSettings
                             * @instance
                             */
                            NetworkSettings.prototype.targetGoogleSearch = null;

                            /**
                             * NetworkSettings targetSearchNetwork.
                             * @member {google.protobuf.IBoolValue|null|undefined} targetSearchNetwork
                             * @memberof google.ads.googleads.v1.resources.Campaign.NetworkSettings
                             * @instance
                             */
                            NetworkSettings.prototype.targetSearchNetwork = null;

                            /**
                             * NetworkSettings targetContentNetwork.
                             * @member {google.protobuf.IBoolValue|null|undefined} targetContentNetwork
                             * @memberof google.ads.googleads.v1.resources.Campaign.NetworkSettings
                             * @instance
                             */
                            NetworkSettings.prototype.targetContentNetwork = null;

                            /**
                             * NetworkSettings targetPartnerSearchNetwork.
                             * @member {google.protobuf.IBoolValue|null|undefined} targetPartnerSearchNetwork
                             * @memberof google.ads.googleads.v1.resources.Campaign.NetworkSettings
                             * @instance
                             */
                            NetworkSettings.prototype.targetPartnerSearchNetwork = null;

                            /**
                             * Creates a new NetworkSettings instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Campaign.NetworkSettings
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.INetworkSettings=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Campaign.NetworkSettings} NetworkSettings instance
                             */
                            NetworkSettings.create = function create(properties) {
                                return new NetworkSettings(properties);
                            };

                            /**
                             * Encodes the specified NetworkSettings message. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.NetworkSettings.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Campaign.NetworkSettings
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.INetworkSettings} message NetworkSettings message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            NetworkSettings.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.targetGoogleSearch != null && message.hasOwnProperty("targetGoogleSearch"))
                                    $root.google.protobuf.BoolValue.encode(message.targetGoogleSearch, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.targetSearchNetwork != null && message.hasOwnProperty("targetSearchNetwork"))
                                    $root.google.protobuf.BoolValue.encode(message.targetSearchNetwork, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                if (message.targetContentNetwork != null && message.hasOwnProperty("targetContentNetwork"))
                                    $root.google.protobuf.BoolValue.encode(message.targetContentNetwork, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                                if (message.targetPartnerSearchNetwork != null && message.hasOwnProperty("targetPartnerSearchNetwork"))
                                    $root.google.protobuf.BoolValue.encode(message.targetPartnerSearchNetwork, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified NetworkSettings message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.NetworkSettings.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Campaign.NetworkSettings
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.INetworkSettings} message NetworkSettings message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            NetworkSettings.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a NetworkSettings message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Campaign.NetworkSettings
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Campaign.NetworkSettings} NetworkSettings
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            NetworkSettings.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Campaign.NetworkSettings();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.targetGoogleSearch = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.targetSearchNetwork = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    case 3:
                                        message.targetContentNetwork = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    case 4:
                                        message.targetPartnerSearchNetwork = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a NetworkSettings message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Campaign.NetworkSettings
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Campaign.NetworkSettings} NetworkSettings
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            NetworkSettings.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a NetworkSettings message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Campaign.NetworkSettings
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            NetworkSettings.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.targetGoogleSearch != null && message.hasOwnProperty("targetGoogleSearch")) {
                                    var error = $root.google.protobuf.BoolValue.verify(message.targetGoogleSearch);
                                    if (error)
                                        return "targetGoogleSearch." + error;
                                }
                                if (message.targetSearchNetwork != null && message.hasOwnProperty("targetSearchNetwork")) {
                                    var error = $root.google.protobuf.BoolValue.verify(message.targetSearchNetwork);
                                    if (error)
                                        return "targetSearchNetwork." + error;
                                }
                                if (message.targetContentNetwork != null && message.hasOwnProperty("targetContentNetwork")) {
                                    var error = $root.google.protobuf.BoolValue.verify(message.targetContentNetwork);
                                    if (error)
                                        return "targetContentNetwork." + error;
                                }
                                if (message.targetPartnerSearchNetwork != null && message.hasOwnProperty("targetPartnerSearchNetwork")) {
                                    var error = $root.google.protobuf.BoolValue.verify(message.targetPartnerSearchNetwork);
                                    if (error)
                                        return "targetPartnerSearchNetwork." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a NetworkSettings message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Campaign.NetworkSettings
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Campaign.NetworkSettings} NetworkSettings
                             */
                            NetworkSettings.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Campaign.NetworkSettings)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Campaign.NetworkSettings();
                                if (object.targetGoogleSearch != null) {
                                    if (typeof object.targetGoogleSearch !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Campaign.NetworkSettings.targetGoogleSearch: object expected");
                                    message.targetGoogleSearch = $root.google.protobuf.BoolValue.fromObject(object.targetGoogleSearch);
                                }
                                if (object.targetSearchNetwork != null) {
                                    if (typeof object.targetSearchNetwork !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Campaign.NetworkSettings.targetSearchNetwork: object expected");
                                    message.targetSearchNetwork = $root.google.protobuf.BoolValue.fromObject(object.targetSearchNetwork);
                                }
                                if (object.targetContentNetwork != null) {
                                    if (typeof object.targetContentNetwork !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Campaign.NetworkSettings.targetContentNetwork: object expected");
                                    message.targetContentNetwork = $root.google.protobuf.BoolValue.fromObject(object.targetContentNetwork);
                                }
                                if (object.targetPartnerSearchNetwork != null) {
                                    if (typeof object.targetPartnerSearchNetwork !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Campaign.NetworkSettings.targetPartnerSearchNetwork: object expected");
                                    message.targetPartnerSearchNetwork = $root.google.protobuf.BoolValue.fromObject(object.targetPartnerSearchNetwork);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a NetworkSettings message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Campaign.NetworkSettings
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.NetworkSettings} message NetworkSettings
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            NetworkSettings.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.targetGoogleSearch = null;
                                    object.targetSearchNetwork = null;
                                    object.targetContentNetwork = null;
                                    object.targetPartnerSearchNetwork = null;
                                }
                                if (message.targetGoogleSearch != null && message.hasOwnProperty("targetGoogleSearch"))
                                    object.targetGoogleSearch = $root.google.protobuf.BoolValue.toObject(message.targetGoogleSearch, options);
                                if (message.targetSearchNetwork != null && message.hasOwnProperty("targetSearchNetwork"))
                                    object.targetSearchNetwork = $root.google.protobuf.BoolValue.toObject(message.targetSearchNetwork, options);
                                if (message.targetContentNetwork != null && message.hasOwnProperty("targetContentNetwork"))
                                    object.targetContentNetwork = $root.google.protobuf.BoolValue.toObject(message.targetContentNetwork, options);
                                if (message.targetPartnerSearchNetwork != null && message.hasOwnProperty("targetPartnerSearchNetwork"))
                                    object.targetPartnerSearchNetwork = $root.google.protobuf.BoolValue.toObject(message.targetPartnerSearchNetwork, options);
                                return object;
                            };

                            /**
                             * Converts this NetworkSettings to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Campaign.NetworkSettings
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            NetworkSettings.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return NetworkSettings;
                        })();

                        Campaign.HotelSettingInfo = (function() {

                            /**
                             * Properties of a HotelSettingInfo.
                             * @memberof google.ads.googleads.v1.resources.Campaign
                             * @interface IHotelSettingInfo
                             * @property {google.protobuf.IInt64Value|null} [hotelCenterId] HotelSettingInfo hotelCenterId
                             */

                            /**
                             * Constructs a new HotelSettingInfo.
                             * @memberof google.ads.googleads.v1.resources.Campaign
                             * @classdesc Represents a HotelSettingInfo.
                             * @implements IHotelSettingInfo
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Campaign.IHotelSettingInfo=} [properties] Properties to set
                             */
                            function HotelSettingInfo(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * HotelSettingInfo hotelCenterId.
                             * @member {google.protobuf.IInt64Value|null|undefined} hotelCenterId
                             * @memberof google.ads.googleads.v1.resources.Campaign.HotelSettingInfo
                             * @instance
                             */
                            HotelSettingInfo.prototype.hotelCenterId = null;

                            /**
                             * Creates a new HotelSettingInfo instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Campaign.HotelSettingInfo
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.IHotelSettingInfo=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Campaign.HotelSettingInfo} HotelSettingInfo instance
                             */
                            HotelSettingInfo.create = function create(properties) {
                                return new HotelSettingInfo(properties);
                            };

                            /**
                             * Encodes the specified HotelSettingInfo message. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.HotelSettingInfo.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Campaign.HotelSettingInfo
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.IHotelSettingInfo} message HotelSettingInfo message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            HotelSettingInfo.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.hotelCenterId != null && message.hasOwnProperty("hotelCenterId"))
                                    $root.google.protobuf.Int64Value.encode(message.hotelCenterId, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified HotelSettingInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.HotelSettingInfo.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Campaign.HotelSettingInfo
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.IHotelSettingInfo} message HotelSettingInfo message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            HotelSettingInfo.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a HotelSettingInfo message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Campaign.HotelSettingInfo
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Campaign.HotelSettingInfo} HotelSettingInfo
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            HotelSettingInfo.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Campaign.HotelSettingInfo();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.hotelCenterId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a HotelSettingInfo message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Campaign.HotelSettingInfo
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Campaign.HotelSettingInfo} HotelSettingInfo
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            HotelSettingInfo.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a HotelSettingInfo message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Campaign.HotelSettingInfo
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            HotelSettingInfo.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.hotelCenterId != null && message.hasOwnProperty("hotelCenterId")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.hotelCenterId);
                                    if (error)
                                        return "hotelCenterId." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a HotelSettingInfo message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Campaign.HotelSettingInfo
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Campaign.HotelSettingInfo} HotelSettingInfo
                             */
                            HotelSettingInfo.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Campaign.HotelSettingInfo)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Campaign.HotelSettingInfo();
                                if (object.hotelCenterId != null) {
                                    if (typeof object.hotelCenterId !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Campaign.HotelSettingInfo.hotelCenterId: object expected");
                                    message.hotelCenterId = $root.google.protobuf.Int64Value.fromObject(object.hotelCenterId);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a HotelSettingInfo message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Campaign.HotelSettingInfo
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.HotelSettingInfo} message HotelSettingInfo
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            HotelSettingInfo.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults)
                                    object.hotelCenterId = null;
                                if (message.hotelCenterId != null && message.hasOwnProperty("hotelCenterId"))
                                    object.hotelCenterId = $root.google.protobuf.Int64Value.toObject(message.hotelCenterId, options);
                                return object;
                            };

                            /**
                             * Converts this HotelSettingInfo to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Campaign.HotelSettingInfo
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            HotelSettingInfo.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return HotelSettingInfo;
                        })();

                        Campaign.DynamicSearchAdsSetting = (function() {

                            /**
                             * Properties of a DynamicSearchAdsSetting.
                             * @memberof google.ads.googleads.v1.resources.Campaign
                             * @interface IDynamicSearchAdsSetting
                             * @property {google.protobuf.IStringValue|null} [domainName] DynamicSearchAdsSetting domainName
                             * @property {google.protobuf.IStringValue|null} [languageCode] DynamicSearchAdsSetting languageCode
                             * @property {google.protobuf.IBoolValue|null} [useSuppliedUrlsOnly] DynamicSearchAdsSetting useSuppliedUrlsOnly
                             * @property {Array.<google.protobuf.IStringValue>|null} [feeds] DynamicSearchAdsSetting feeds
                             */

                            /**
                             * Constructs a new DynamicSearchAdsSetting.
                             * @memberof google.ads.googleads.v1.resources.Campaign
                             * @classdesc Represents a DynamicSearchAdsSetting.
                             * @implements IDynamicSearchAdsSetting
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Campaign.IDynamicSearchAdsSetting=} [properties] Properties to set
                             */
                            function DynamicSearchAdsSetting(properties) {
                                this.feeds = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * DynamicSearchAdsSetting domainName.
                             * @member {google.protobuf.IStringValue|null|undefined} domainName
                             * @memberof google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting
                             * @instance
                             */
                            DynamicSearchAdsSetting.prototype.domainName = null;

                            /**
                             * DynamicSearchAdsSetting languageCode.
                             * @member {google.protobuf.IStringValue|null|undefined} languageCode
                             * @memberof google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting
                             * @instance
                             */
                            DynamicSearchAdsSetting.prototype.languageCode = null;

                            /**
                             * DynamicSearchAdsSetting useSuppliedUrlsOnly.
                             * @member {google.protobuf.IBoolValue|null|undefined} useSuppliedUrlsOnly
                             * @memberof google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting
                             * @instance
                             */
                            DynamicSearchAdsSetting.prototype.useSuppliedUrlsOnly = null;

                            /**
                             * DynamicSearchAdsSetting feeds.
                             * @member {Array.<google.protobuf.IStringValue>} feeds
                             * @memberof google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting
                             * @instance
                             */
                            DynamicSearchAdsSetting.prototype.feeds = $util.emptyArray;

                            /**
                             * Creates a new DynamicSearchAdsSetting instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.IDynamicSearchAdsSetting=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting} DynamicSearchAdsSetting instance
                             */
                            DynamicSearchAdsSetting.create = function create(properties) {
                                return new DynamicSearchAdsSetting(properties);
                            };

                            /**
                             * Encodes the specified DynamicSearchAdsSetting message. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.IDynamicSearchAdsSetting} message DynamicSearchAdsSetting message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            DynamicSearchAdsSetting.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.domainName != null && message.hasOwnProperty("domainName"))
                                    $root.google.protobuf.StringValue.encode(message.domainName, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.languageCode != null && message.hasOwnProperty("languageCode"))
                                    $root.google.protobuf.StringValue.encode(message.languageCode, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                if (message.useSuppliedUrlsOnly != null && message.hasOwnProperty("useSuppliedUrlsOnly"))
                                    $root.google.protobuf.BoolValue.encode(message.useSuppliedUrlsOnly, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                                if (message.feeds != null && message.feeds.length)
                                    for (var i = 0; i < message.feeds.length; ++i)
                                        $root.google.protobuf.StringValue.encode(message.feeds[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified DynamicSearchAdsSetting message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.IDynamicSearchAdsSetting} message DynamicSearchAdsSetting message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            DynamicSearchAdsSetting.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a DynamicSearchAdsSetting message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting} DynamicSearchAdsSetting
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            DynamicSearchAdsSetting.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.domainName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.languageCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 3:
                                        message.useSuppliedUrlsOnly = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    case 5:
                                        if (!(message.feeds && message.feeds.length))
                                            message.feeds = [];
                                        message.feeds.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a DynamicSearchAdsSetting message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting} DynamicSearchAdsSetting
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            DynamicSearchAdsSetting.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a DynamicSearchAdsSetting message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            DynamicSearchAdsSetting.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.domainName != null && message.hasOwnProperty("domainName")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.domainName);
                                    if (error)
                                        return "domainName." + error;
                                }
                                if (message.languageCode != null && message.hasOwnProperty("languageCode")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.languageCode);
                                    if (error)
                                        return "languageCode." + error;
                                }
                                if (message.useSuppliedUrlsOnly != null && message.hasOwnProperty("useSuppliedUrlsOnly")) {
                                    var error = $root.google.protobuf.BoolValue.verify(message.useSuppliedUrlsOnly);
                                    if (error)
                                        return "useSuppliedUrlsOnly." + error;
                                }
                                if (message.feeds != null && message.hasOwnProperty("feeds")) {
                                    if (!Array.isArray(message.feeds))
                                        return "feeds: array expected";
                                    for (var i = 0; i < message.feeds.length; ++i) {
                                        var error = $root.google.protobuf.StringValue.verify(message.feeds[i]);
                                        if (error)
                                            return "feeds." + error;
                                    }
                                }
                                return null;
                            };

                            /**
                             * Creates a DynamicSearchAdsSetting message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting} DynamicSearchAdsSetting
                             */
                            DynamicSearchAdsSetting.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting();
                                if (object.domainName != null) {
                                    if (typeof object.domainName !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting.domainName: object expected");
                                    message.domainName = $root.google.protobuf.StringValue.fromObject(object.domainName);
                                }
                                if (object.languageCode != null) {
                                    if (typeof object.languageCode !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting.languageCode: object expected");
                                    message.languageCode = $root.google.protobuf.StringValue.fromObject(object.languageCode);
                                }
                                if (object.useSuppliedUrlsOnly != null) {
                                    if (typeof object.useSuppliedUrlsOnly !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting.useSuppliedUrlsOnly: object expected");
                                    message.useSuppliedUrlsOnly = $root.google.protobuf.BoolValue.fromObject(object.useSuppliedUrlsOnly);
                                }
                                if (object.feeds) {
                                    if (!Array.isArray(object.feeds))
                                        throw TypeError(".google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting.feeds: array expected");
                                    message.feeds = [];
                                    for (var i = 0; i < object.feeds.length; ++i) {
                                        if (typeof object.feeds[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting.feeds: object expected");
                                        message.feeds[i] = $root.google.protobuf.StringValue.fromObject(object.feeds[i]);
                                    }
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a DynamicSearchAdsSetting message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting} message DynamicSearchAdsSetting
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            DynamicSearchAdsSetting.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.feeds = [];
                                if (options.defaults) {
                                    object.domainName = null;
                                    object.languageCode = null;
                                    object.useSuppliedUrlsOnly = null;
                                }
                                if (message.domainName != null && message.hasOwnProperty("domainName"))
                                    object.domainName = $root.google.protobuf.StringValue.toObject(message.domainName, options);
                                if (message.languageCode != null && message.hasOwnProperty("languageCode"))
                                    object.languageCode = $root.google.protobuf.StringValue.toObject(message.languageCode, options);
                                if (message.useSuppliedUrlsOnly != null && message.hasOwnProperty("useSuppliedUrlsOnly"))
                                    object.useSuppliedUrlsOnly = $root.google.protobuf.BoolValue.toObject(message.useSuppliedUrlsOnly, options);
                                if (message.feeds && message.feeds.length) {
                                    object.feeds = [];
                                    for (var j = 0; j < message.feeds.length; ++j)
                                        object.feeds[j] = $root.google.protobuf.StringValue.toObject(message.feeds[j], options);
                                }
                                return object;
                            };

                            /**
                             * Converts this DynamicSearchAdsSetting to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Campaign.DynamicSearchAdsSetting
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            DynamicSearchAdsSetting.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return DynamicSearchAdsSetting;
                        })();

                        Campaign.TrackingSetting = (function() {

                            /**
                             * Properties of a TrackingSetting.
                             * @memberof google.ads.googleads.v1.resources.Campaign
                             * @interface ITrackingSetting
                             * @property {google.protobuf.IStringValue|null} [trackingUrl] TrackingSetting trackingUrl
                             */

                            /**
                             * Constructs a new TrackingSetting.
                             * @memberof google.ads.googleads.v1.resources.Campaign
                             * @classdesc Represents a TrackingSetting.
                             * @implements ITrackingSetting
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Campaign.ITrackingSetting=} [properties] Properties to set
                             */
                            function TrackingSetting(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * TrackingSetting trackingUrl.
                             * @member {google.protobuf.IStringValue|null|undefined} trackingUrl
                             * @memberof google.ads.googleads.v1.resources.Campaign.TrackingSetting
                             * @instance
                             */
                            TrackingSetting.prototype.trackingUrl = null;

                            /**
                             * Creates a new TrackingSetting instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Campaign.TrackingSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.ITrackingSetting=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Campaign.TrackingSetting} TrackingSetting instance
                             */
                            TrackingSetting.create = function create(properties) {
                                return new TrackingSetting(properties);
                            };

                            /**
                             * Encodes the specified TrackingSetting message. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.TrackingSetting.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Campaign.TrackingSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.ITrackingSetting} message TrackingSetting message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            TrackingSetting.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.trackingUrl != null && message.hasOwnProperty("trackingUrl"))
                                    $root.google.protobuf.StringValue.encode(message.trackingUrl, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified TrackingSetting message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.TrackingSetting.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Campaign.TrackingSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.ITrackingSetting} message TrackingSetting message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            TrackingSetting.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a TrackingSetting message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Campaign.TrackingSetting
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Campaign.TrackingSetting} TrackingSetting
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            TrackingSetting.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Campaign.TrackingSetting();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.trackingUrl = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a TrackingSetting message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Campaign.TrackingSetting
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Campaign.TrackingSetting} TrackingSetting
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            TrackingSetting.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a TrackingSetting message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Campaign.TrackingSetting
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            TrackingSetting.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.trackingUrl != null && message.hasOwnProperty("trackingUrl")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.trackingUrl);
                                    if (error)
                                        return "trackingUrl." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a TrackingSetting message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Campaign.TrackingSetting
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Campaign.TrackingSetting} TrackingSetting
                             */
                            TrackingSetting.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Campaign.TrackingSetting)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Campaign.TrackingSetting();
                                if (object.trackingUrl != null) {
                                    if (typeof object.trackingUrl !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Campaign.TrackingSetting.trackingUrl: object expected");
                                    message.trackingUrl = $root.google.protobuf.StringValue.fromObject(object.trackingUrl);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a TrackingSetting message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Campaign.TrackingSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.TrackingSetting} message TrackingSetting
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            TrackingSetting.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults)
                                    object.trackingUrl = null;
                                if (message.trackingUrl != null && message.hasOwnProperty("trackingUrl"))
                                    object.trackingUrl = $root.google.protobuf.StringValue.toObject(message.trackingUrl, options);
                                return object;
                            };

                            /**
                             * Converts this TrackingSetting to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Campaign.TrackingSetting
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            TrackingSetting.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return TrackingSetting;
                        })();

                        Campaign.GeoTargetTypeSetting = (function() {

                            /**
                             * Properties of a GeoTargetTypeSetting.
                             * @memberof google.ads.googleads.v1.resources.Campaign
                             * @interface IGeoTargetTypeSetting
                             * @property {google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum.PositiveGeoTargetType|null} [positiveGeoTargetType] GeoTargetTypeSetting positiveGeoTargetType
                             * @property {google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum.NegativeGeoTargetType|null} [negativeGeoTargetType] GeoTargetTypeSetting negativeGeoTargetType
                             */

                            /**
                             * Constructs a new GeoTargetTypeSetting.
                             * @memberof google.ads.googleads.v1.resources.Campaign
                             * @classdesc Represents a GeoTargetTypeSetting.
                             * @implements IGeoTargetTypeSetting
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Campaign.IGeoTargetTypeSetting=} [properties] Properties to set
                             */
                            function GeoTargetTypeSetting(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * GeoTargetTypeSetting positiveGeoTargetType.
                             * @member {google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum.PositiveGeoTargetType} positiveGeoTargetType
                             * @memberof google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting
                             * @instance
                             */
                            GeoTargetTypeSetting.prototype.positiveGeoTargetType = 0;

                            /**
                             * GeoTargetTypeSetting negativeGeoTargetType.
                             * @member {google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum.NegativeGeoTargetType} negativeGeoTargetType
                             * @memberof google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting
                             * @instance
                             */
                            GeoTargetTypeSetting.prototype.negativeGeoTargetType = 0;

                            /**
                             * Creates a new GeoTargetTypeSetting instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.IGeoTargetTypeSetting=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting} GeoTargetTypeSetting instance
                             */
                            GeoTargetTypeSetting.create = function create(properties) {
                                return new GeoTargetTypeSetting(properties);
                            };

                            /**
                             * Encodes the specified GeoTargetTypeSetting message. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.IGeoTargetTypeSetting} message GeoTargetTypeSetting message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            GeoTargetTypeSetting.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.positiveGeoTargetType != null && message.hasOwnProperty("positiveGeoTargetType"))
                                    writer.uint32(/* id 1, wireType 0 =*/8).int32(message.positiveGeoTargetType);
                                if (message.negativeGeoTargetType != null && message.hasOwnProperty("negativeGeoTargetType"))
                                    writer.uint32(/* id 2, wireType 0 =*/16).int32(message.negativeGeoTargetType);
                                return writer;
                            };

                            /**
                             * Encodes the specified GeoTargetTypeSetting message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.IGeoTargetTypeSetting} message GeoTargetTypeSetting message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            GeoTargetTypeSetting.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a GeoTargetTypeSetting message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting} GeoTargetTypeSetting
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            GeoTargetTypeSetting.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.positiveGeoTargetType = reader.int32();
                                        break;
                                    case 2:
                                        message.negativeGeoTargetType = reader.int32();
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a GeoTargetTypeSetting message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting} GeoTargetTypeSetting
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            GeoTargetTypeSetting.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a GeoTargetTypeSetting message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            GeoTargetTypeSetting.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.positiveGeoTargetType != null && message.hasOwnProperty("positiveGeoTargetType"))
                                    switch (message.positiveGeoTargetType) {
                                    default:
                                        return "positiveGeoTargetType: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                        break;
                                    }
                                if (message.negativeGeoTargetType != null && message.hasOwnProperty("negativeGeoTargetType"))
                                    switch (message.negativeGeoTargetType) {
                                    default:
                                        return "negativeGeoTargetType: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                        break;
                                    }
                                return null;
                            };

                            /**
                             * Creates a GeoTargetTypeSetting message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting} GeoTargetTypeSetting
                             */
                            GeoTargetTypeSetting.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting();
                                switch (object.positiveGeoTargetType) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.positiveGeoTargetType = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.positiveGeoTargetType = 1;
                                    break;
                                case "DONT_CARE":
                                case 2:
                                    message.positiveGeoTargetType = 2;
                                    break;
                                case "AREA_OF_INTEREST":
                                case 3:
                                    message.positiveGeoTargetType = 3;
                                    break;
                                case "LOCATION_OF_PRESENCE":
                                case 4:
                                    message.positiveGeoTargetType = 4;
                                    break;
                                }
                                switch (object.negativeGeoTargetType) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.negativeGeoTargetType = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.negativeGeoTargetType = 1;
                                    break;
                                case "DONT_CARE":
                                case 2:
                                    message.negativeGeoTargetType = 2;
                                    break;
                                case "LOCATION_OF_PRESENCE":
                                case 3:
                                    message.negativeGeoTargetType = 3;
                                    break;
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a GeoTargetTypeSetting message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting} message GeoTargetTypeSetting
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            GeoTargetTypeSetting.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.positiveGeoTargetType = options.enums === String ? "UNSPECIFIED" : 0;
                                    object.negativeGeoTargetType = options.enums === String ? "UNSPECIFIED" : 0;
                                }
                                if (message.positiveGeoTargetType != null && message.hasOwnProperty("positiveGeoTargetType"))
                                    object.positiveGeoTargetType = options.enums === String ? $root.google.ads.googleads.v1.enums.PositiveGeoTargetTypeEnum.PositiveGeoTargetType[message.positiveGeoTargetType] : message.positiveGeoTargetType;
                                if (message.negativeGeoTargetType != null && message.hasOwnProperty("negativeGeoTargetType"))
                                    object.negativeGeoTargetType = options.enums === String ? $root.google.ads.googleads.v1.enums.NegativeGeoTargetTypeEnum.NegativeGeoTargetType[message.negativeGeoTargetType] : message.negativeGeoTargetType;
                                return object;
                            };

                            /**
                             * Converts this GeoTargetTypeSetting to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Campaign.GeoTargetTypeSetting
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            GeoTargetTypeSetting.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return GeoTargetTypeSetting;
                        })();

                        Campaign.SelectiveOptimization = (function() {

                            /**
                             * Properties of a SelectiveOptimization.
                             * @memberof google.ads.googleads.v1.resources.Campaign
                             * @interface ISelectiveOptimization
                             * @property {Array.<google.protobuf.IStringValue>|null} [conversionActions] SelectiveOptimization conversionActions
                             */

                            /**
                             * Constructs a new SelectiveOptimization.
                             * @memberof google.ads.googleads.v1.resources.Campaign
                             * @classdesc Represents a SelectiveOptimization.
                             * @implements ISelectiveOptimization
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Campaign.ISelectiveOptimization=} [properties] Properties to set
                             */
                            function SelectiveOptimization(properties) {
                                this.conversionActions = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * SelectiveOptimization conversionActions.
                             * @member {Array.<google.protobuf.IStringValue>} conversionActions
                             * @memberof google.ads.googleads.v1.resources.Campaign.SelectiveOptimization
                             * @instance
                             */
                            SelectiveOptimization.prototype.conversionActions = $util.emptyArray;

                            /**
                             * Creates a new SelectiveOptimization instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Campaign.SelectiveOptimization
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.ISelectiveOptimization=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Campaign.SelectiveOptimization} SelectiveOptimization instance
                             */
                            SelectiveOptimization.create = function create(properties) {
                                return new SelectiveOptimization(properties);
                            };

                            /**
                             * Encodes the specified SelectiveOptimization message. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.SelectiveOptimization.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Campaign.SelectiveOptimization
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.ISelectiveOptimization} message SelectiveOptimization message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            SelectiveOptimization.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.conversionActions != null && message.conversionActions.length)
                                    for (var i = 0; i < message.conversionActions.length; ++i)
                                        $root.google.protobuf.StringValue.encode(message.conversionActions[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified SelectiveOptimization message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.SelectiveOptimization.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Campaign.SelectiveOptimization
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.ISelectiveOptimization} message SelectiveOptimization message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            SelectiveOptimization.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a SelectiveOptimization message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Campaign.SelectiveOptimization
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Campaign.SelectiveOptimization} SelectiveOptimization
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            SelectiveOptimization.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Campaign.SelectiveOptimization();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        if (!(message.conversionActions && message.conversionActions.length))
                                            message.conversionActions = [];
                                        message.conversionActions.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a SelectiveOptimization message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Campaign.SelectiveOptimization
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Campaign.SelectiveOptimization} SelectiveOptimization
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            SelectiveOptimization.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a SelectiveOptimization message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Campaign.SelectiveOptimization
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            SelectiveOptimization.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.conversionActions != null && message.hasOwnProperty("conversionActions")) {
                                    if (!Array.isArray(message.conversionActions))
                                        return "conversionActions: array expected";
                                    for (var i = 0; i < message.conversionActions.length; ++i) {
                                        var error = $root.google.protobuf.StringValue.verify(message.conversionActions[i]);
                                        if (error)
                                            return "conversionActions." + error;
                                    }
                                }
                                return null;
                            };

                            /**
                             * Creates a SelectiveOptimization message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Campaign.SelectiveOptimization
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Campaign.SelectiveOptimization} SelectiveOptimization
                             */
                            SelectiveOptimization.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Campaign.SelectiveOptimization)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Campaign.SelectiveOptimization();
                                if (object.conversionActions) {
                                    if (!Array.isArray(object.conversionActions))
                                        throw TypeError(".google.ads.googleads.v1.resources.Campaign.SelectiveOptimization.conversionActions: array expected");
                                    message.conversionActions = [];
                                    for (var i = 0; i < object.conversionActions.length; ++i) {
                                        if (typeof object.conversionActions[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.resources.Campaign.SelectiveOptimization.conversionActions: object expected");
                                        message.conversionActions[i] = $root.google.protobuf.StringValue.fromObject(object.conversionActions[i]);
                                    }
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a SelectiveOptimization message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Campaign.SelectiveOptimization
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.SelectiveOptimization} message SelectiveOptimization
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            SelectiveOptimization.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.conversionActions = [];
                                if (message.conversionActions && message.conversionActions.length) {
                                    object.conversionActions = [];
                                    for (var j = 0; j < message.conversionActions.length; ++j)
                                        object.conversionActions[j] = $root.google.protobuf.StringValue.toObject(message.conversionActions[j], options);
                                }
                                return object;
                            };

                            /**
                             * Converts this SelectiveOptimization to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Campaign.SelectiveOptimization
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            SelectiveOptimization.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return SelectiveOptimization;
                        })();

                        Campaign.ShoppingSetting = (function() {

                            /**
                             * Properties of a ShoppingSetting.
                             * @memberof google.ads.googleads.v1.resources.Campaign
                             * @interface IShoppingSetting
                             * @property {google.protobuf.IInt64Value|null} [merchantId] ShoppingSetting merchantId
                             * @property {google.protobuf.IStringValue|null} [salesCountry] ShoppingSetting salesCountry
                             * @property {google.protobuf.IInt32Value|null} [campaignPriority] ShoppingSetting campaignPriority
                             * @property {google.protobuf.IBoolValue|null} [enableLocal] ShoppingSetting enableLocal
                             */

                            /**
                             * Constructs a new ShoppingSetting.
                             * @memberof google.ads.googleads.v1.resources.Campaign
                             * @classdesc Represents a ShoppingSetting.
                             * @implements IShoppingSetting
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Campaign.IShoppingSetting=} [properties] Properties to set
                             */
                            function ShoppingSetting(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * ShoppingSetting merchantId.
                             * @member {google.protobuf.IInt64Value|null|undefined} merchantId
                             * @memberof google.ads.googleads.v1.resources.Campaign.ShoppingSetting
                             * @instance
                             */
                            ShoppingSetting.prototype.merchantId = null;

                            /**
                             * ShoppingSetting salesCountry.
                             * @member {google.protobuf.IStringValue|null|undefined} salesCountry
                             * @memberof google.ads.googleads.v1.resources.Campaign.ShoppingSetting
                             * @instance
                             */
                            ShoppingSetting.prototype.salesCountry = null;

                            /**
                             * ShoppingSetting campaignPriority.
                             * @member {google.protobuf.IInt32Value|null|undefined} campaignPriority
                             * @memberof google.ads.googleads.v1.resources.Campaign.ShoppingSetting
                             * @instance
                             */
                            ShoppingSetting.prototype.campaignPriority = null;

                            /**
                             * ShoppingSetting enableLocal.
                             * @member {google.protobuf.IBoolValue|null|undefined} enableLocal
                             * @memberof google.ads.googleads.v1.resources.Campaign.ShoppingSetting
                             * @instance
                             */
                            ShoppingSetting.prototype.enableLocal = null;

                            /**
                             * Creates a new ShoppingSetting instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Campaign.ShoppingSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.IShoppingSetting=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Campaign.ShoppingSetting} ShoppingSetting instance
                             */
                            ShoppingSetting.create = function create(properties) {
                                return new ShoppingSetting(properties);
                            };

                            /**
                             * Encodes the specified ShoppingSetting message. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.ShoppingSetting.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Campaign.ShoppingSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.IShoppingSetting} message ShoppingSetting message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            ShoppingSetting.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.merchantId != null && message.hasOwnProperty("merchantId"))
                                    $root.google.protobuf.Int64Value.encode(message.merchantId, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.salesCountry != null && message.hasOwnProperty("salesCountry"))
                                    $root.google.protobuf.StringValue.encode(message.salesCountry, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                if (message.campaignPriority != null && message.hasOwnProperty("campaignPriority"))
                                    $root.google.protobuf.Int32Value.encode(message.campaignPriority, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                                if (message.enableLocal != null && message.hasOwnProperty("enableLocal"))
                                    $root.google.protobuf.BoolValue.encode(message.enableLocal, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified ShoppingSetting message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.ShoppingSetting.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Campaign.ShoppingSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.IShoppingSetting} message ShoppingSetting message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            ShoppingSetting.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a ShoppingSetting message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Campaign.ShoppingSetting
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Campaign.ShoppingSetting} ShoppingSetting
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            ShoppingSetting.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Campaign.ShoppingSetting();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.merchantId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.salesCountry = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 3:
                                        message.campaignPriority = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                        break;
                                    case 4:
                                        message.enableLocal = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a ShoppingSetting message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Campaign.ShoppingSetting
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Campaign.ShoppingSetting} ShoppingSetting
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            ShoppingSetting.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a ShoppingSetting message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Campaign.ShoppingSetting
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            ShoppingSetting.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.merchantId != null && message.hasOwnProperty("merchantId")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.merchantId);
                                    if (error)
                                        return "merchantId." + error;
                                }
                                if (message.salesCountry != null && message.hasOwnProperty("salesCountry")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.salesCountry);
                                    if (error)
                                        return "salesCountry." + error;
                                }
                                if (message.campaignPriority != null && message.hasOwnProperty("campaignPriority")) {
                                    var error = $root.google.protobuf.Int32Value.verify(message.campaignPriority);
                                    if (error)
                                        return "campaignPriority." + error;
                                }
                                if (message.enableLocal != null && message.hasOwnProperty("enableLocal")) {
                                    var error = $root.google.protobuf.BoolValue.verify(message.enableLocal);
                                    if (error)
                                        return "enableLocal." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a ShoppingSetting message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Campaign.ShoppingSetting
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Campaign.ShoppingSetting} ShoppingSetting
                             */
                            ShoppingSetting.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Campaign.ShoppingSetting)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Campaign.ShoppingSetting();
                                if (object.merchantId != null) {
                                    if (typeof object.merchantId !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Campaign.ShoppingSetting.merchantId: object expected");
                                    message.merchantId = $root.google.protobuf.Int64Value.fromObject(object.merchantId);
                                }
                                if (object.salesCountry != null) {
                                    if (typeof object.salesCountry !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Campaign.ShoppingSetting.salesCountry: object expected");
                                    message.salesCountry = $root.google.protobuf.StringValue.fromObject(object.salesCountry);
                                }
                                if (object.campaignPriority != null) {
                                    if (typeof object.campaignPriority !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Campaign.ShoppingSetting.campaignPriority: object expected");
                                    message.campaignPriority = $root.google.protobuf.Int32Value.fromObject(object.campaignPriority);
                                }
                                if (object.enableLocal != null) {
                                    if (typeof object.enableLocal !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Campaign.ShoppingSetting.enableLocal: object expected");
                                    message.enableLocal = $root.google.protobuf.BoolValue.fromObject(object.enableLocal);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a ShoppingSetting message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Campaign.ShoppingSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.ShoppingSetting} message ShoppingSetting
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            ShoppingSetting.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.merchantId = null;
                                    object.salesCountry = null;
                                    object.campaignPriority = null;
                                    object.enableLocal = null;
                                }
                                if (message.merchantId != null && message.hasOwnProperty("merchantId"))
                                    object.merchantId = $root.google.protobuf.Int64Value.toObject(message.merchantId, options);
                                if (message.salesCountry != null && message.hasOwnProperty("salesCountry"))
                                    object.salesCountry = $root.google.protobuf.StringValue.toObject(message.salesCountry, options);
                                if (message.campaignPriority != null && message.hasOwnProperty("campaignPriority"))
                                    object.campaignPriority = $root.google.protobuf.Int32Value.toObject(message.campaignPriority, options);
                                if (message.enableLocal != null && message.hasOwnProperty("enableLocal"))
                                    object.enableLocal = $root.google.protobuf.BoolValue.toObject(message.enableLocal, options);
                                return object;
                            };

                            /**
                             * Converts this ShoppingSetting to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Campaign.ShoppingSetting
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            ShoppingSetting.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return ShoppingSetting;
                        })();

                        Campaign.AppCampaignSetting = (function() {

                            /**
                             * Properties of an AppCampaignSetting.
                             * @memberof google.ads.googleads.v1.resources.Campaign
                             * @interface IAppCampaignSetting
                             * @property {google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum.AppCampaignBiddingStrategyGoalType|null} [biddingStrategyGoalType] AppCampaignSetting biddingStrategyGoalType
                             * @property {google.protobuf.IStringValue|null} [appId] AppCampaignSetting appId
                             * @property {google.ads.googleads.v1.enums.AppCampaignAppStoreEnum.AppCampaignAppStore|null} [appStore] AppCampaignSetting appStore
                             */

                            /**
                             * Constructs a new AppCampaignSetting.
                             * @memberof google.ads.googleads.v1.resources.Campaign
                             * @classdesc Represents an AppCampaignSetting.
                             * @implements IAppCampaignSetting
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Campaign.IAppCampaignSetting=} [properties] Properties to set
                             */
                            function AppCampaignSetting(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * AppCampaignSetting biddingStrategyGoalType.
                             * @member {google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum.AppCampaignBiddingStrategyGoalType} biddingStrategyGoalType
                             * @memberof google.ads.googleads.v1.resources.Campaign.AppCampaignSetting
                             * @instance
                             */
                            AppCampaignSetting.prototype.biddingStrategyGoalType = 0;

                            /**
                             * AppCampaignSetting appId.
                             * @member {google.protobuf.IStringValue|null|undefined} appId
                             * @memberof google.ads.googleads.v1.resources.Campaign.AppCampaignSetting
                             * @instance
                             */
                            AppCampaignSetting.prototype.appId = null;

                            /**
                             * AppCampaignSetting appStore.
                             * @member {google.ads.googleads.v1.enums.AppCampaignAppStoreEnum.AppCampaignAppStore} appStore
                             * @memberof google.ads.googleads.v1.resources.Campaign.AppCampaignSetting
                             * @instance
                             */
                            AppCampaignSetting.prototype.appStore = 0;

                            /**
                             * Creates a new AppCampaignSetting instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Campaign.AppCampaignSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.IAppCampaignSetting=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Campaign.AppCampaignSetting} AppCampaignSetting instance
                             */
                            AppCampaignSetting.create = function create(properties) {
                                return new AppCampaignSetting(properties);
                            };

                            /**
                             * Encodes the specified AppCampaignSetting message. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.AppCampaignSetting.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Campaign.AppCampaignSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.IAppCampaignSetting} message AppCampaignSetting message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            AppCampaignSetting.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.biddingStrategyGoalType != null && message.hasOwnProperty("biddingStrategyGoalType"))
                                    writer.uint32(/* id 1, wireType 0 =*/8).int32(message.biddingStrategyGoalType);
                                if (message.appId != null && message.hasOwnProperty("appId"))
                                    $root.google.protobuf.StringValue.encode(message.appId, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                if (message.appStore != null && message.hasOwnProperty("appStore"))
                                    writer.uint32(/* id 3, wireType 0 =*/24).int32(message.appStore);
                                return writer;
                            };

                            /**
                             * Encodes the specified AppCampaignSetting message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.AppCampaignSetting.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Campaign.AppCampaignSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.IAppCampaignSetting} message AppCampaignSetting message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            AppCampaignSetting.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes an AppCampaignSetting message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Campaign.AppCampaignSetting
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Campaign.AppCampaignSetting} AppCampaignSetting
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            AppCampaignSetting.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Campaign.AppCampaignSetting();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.biddingStrategyGoalType = reader.int32();
                                        break;
                                    case 2:
                                        message.appId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 3:
                                        message.appStore = reader.int32();
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes an AppCampaignSetting message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Campaign.AppCampaignSetting
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Campaign.AppCampaignSetting} AppCampaignSetting
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            AppCampaignSetting.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies an AppCampaignSetting message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Campaign.AppCampaignSetting
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            AppCampaignSetting.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.biddingStrategyGoalType != null && message.hasOwnProperty("biddingStrategyGoalType"))
                                    switch (message.biddingStrategyGoalType) {
                                    default:
                                        return "biddingStrategyGoalType: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                    case 5:
                                        break;
                                    }
                                if (message.appId != null && message.hasOwnProperty("appId")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.appId);
                                    if (error)
                                        return "appId." + error;
                                }
                                if (message.appStore != null && message.hasOwnProperty("appStore"))
                                    switch (message.appStore) {
                                    default:
                                        return "appStore: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                        break;
                                    }
                                return null;
                            };

                            /**
                             * Creates an AppCampaignSetting message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Campaign.AppCampaignSetting
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Campaign.AppCampaignSetting} AppCampaignSetting
                             */
                            AppCampaignSetting.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Campaign.AppCampaignSetting)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Campaign.AppCampaignSetting();
                                switch (object.biddingStrategyGoalType) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.biddingStrategyGoalType = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.biddingStrategyGoalType = 1;
                                    break;
                                case "OPTIMIZE_INSTALLS_TARGET_INSTALL_COST":
                                case 2:
                                    message.biddingStrategyGoalType = 2;
                                    break;
                                case "OPTIMIZE_IN_APP_CONVERSIONS_TARGET_INSTALL_COST":
                                case 3:
                                    message.biddingStrategyGoalType = 3;
                                    break;
                                case "OPTIMIZE_IN_APP_CONVERSIONS_TARGET_CONVERSION_COST":
                                case 4:
                                    message.biddingStrategyGoalType = 4;
                                    break;
                                case "OPTIMIZE_RETURN_ON_ADVERTISING_SPEND":
                                case 5:
                                    message.biddingStrategyGoalType = 5;
                                    break;
                                }
                                if (object.appId != null) {
                                    if (typeof object.appId !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Campaign.AppCampaignSetting.appId: object expected");
                                    message.appId = $root.google.protobuf.StringValue.fromObject(object.appId);
                                }
                                switch (object.appStore) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.appStore = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.appStore = 1;
                                    break;
                                case "APPLE_APP_STORE":
                                case 2:
                                    message.appStore = 2;
                                    break;
                                case "GOOGLE_APP_STORE":
                                case 3:
                                    message.appStore = 3;
                                    break;
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from an AppCampaignSetting message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Campaign.AppCampaignSetting
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.AppCampaignSetting} message AppCampaignSetting
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            AppCampaignSetting.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.biddingStrategyGoalType = options.enums === String ? "UNSPECIFIED" : 0;
                                    object.appId = null;
                                    object.appStore = options.enums === String ? "UNSPECIFIED" : 0;
                                }
                                if (message.biddingStrategyGoalType != null && message.hasOwnProperty("biddingStrategyGoalType"))
                                    object.biddingStrategyGoalType = options.enums === String ? $root.google.ads.googleads.v1.enums.AppCampaignBiddingStrategyGoalTypeEnum.AppCampaignBiddingStrategyGoalType[message.biddingStrategyGoalType] : message.biddingStrategyGoalType;
                                if (message.appId != null && message.hasOwnProperty("appId"))
                                    object.appId = $root.google.protobuf.StringValue.toObject(message.appId, options);
                                if (message.appStore != null && message.hasOwnProperty("appStore"))
                                    object.appStore = options.enums === String ? $root.google.ads.googleads.v1.enums.AppCampaignAppStoreEnum.AppCampaignAppStore[message.appStore] : message.appStore;
                                return object;
                            };

                            /**
                             * Converts this AppCampaignSetting to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Campaign.AppCampaignSetting
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            AppCampaignSetting.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return AppCampaignSetting;
                        })();

                        Campaign.VanityPharma = (function() {

                            /**
                             * Properties of a VanityPharma.
                             * @memberof google.ads.googleads.v1.resources.Campaign
                             * @interface IVanityPharma
                             * @property {google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum.VanityPharmaDisplayUrlMode|null} [vanityPharmaDisplayUrlMode] VanityPharma vanityPharmaDisplayUrlMode
                             * @property {google.ads.googleads.v1.enums.VanityPharmaTextEnum.VanityPharmaText|null} [vanityPharmaText] VanityPharma vanityPharmaText
                             */

                            /**
                             * Constructs a new VanityPharma.
                             * @memberof google.ads.googleads.v1.resources.Campaign
                             * @classdesc Represents a VanityPharma.
                             * @implements IVanityPharma
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Campaign.IVanityPharma=} [properties] Properties to set
                             */
                            function VanityPharma(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * VanityPharma vanityPharmaDisplayUrlMode.
                             * @member {google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum.VanityPharmaDisplayUrlMode} vanityPharmaDisplayUrlMode
                             * @memberof google.ads.googleads.v1.resources.Campaign.VanityPharma
                             * @instance
                             */
                            VanityPharma.prototype.vanityPharmaDisplayUrlMode = 0;

                            /**
                             * VanityPharma vanityPharmaText.
                             * @member {google.ads.googleads.v1.enums.VanityPharmaTextEnum.VanityPharmaText} vanityPharmaText
                             * @memberof google.ads.googleads.v1.resources.Campaign.VanityPharma
                             * @instance
                             */
                            VanityPharma.prototype.vanityPharmaText = 0;

                            /**
                             * Creates a new VanityPharma instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Campaign.VanityPharma
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.IVanityPharma=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Campaign.VanityPharma} VanityPharma instance
                             */
                            VanityPharma.create = function create(properties) {
                                return new VanityPharma(properties);
                            };

                            /**
                             * Encodes the specified VanityPharma message. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.VanityPharma.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Campaign.VanityPharma
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.IVanityPharma} message VanityPharma message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            VanityPharma.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.vanityPharmaDisplayUrlMode != null && message.hasOwnProperty("vanityPharmaDisplayUrlMode"))
                                    writer.uint32(/* id 1, wireType 0 =*/8).int32(message.vanityPharmaDisplayUrlMode);
                                if (message.vanityPharmaText != null && message.hasOwnProperty("vanityPharmaText"))
                                    writer.uint32(/* id 2, wireType 0 =*/16).int32(message.vanityPharmaText);
                                return writer;
                            };

                            /**
                             * Encodes the specified VanityPharma message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Campaign.VanityPharma.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Campaign.VanityPharma
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.IVanityPharma} message VanityPharma message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            VanityPharma.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a VanityPharma message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Campaign.VanityPharma
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Campaign.VanityPharma} VanityPharma
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            VanityPharma.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Campaign.VanityPharma();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.vanityPharmaDisplayUrlMode = reader.int32();
                                        break;
                                    case 2:
                                        message.vanityPharmaText = reader.int32();
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a VanityPharma message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Campaign.VanityPharma
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Campaign.VanityPharma} VanityPharma
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            VanityPharma.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a VanityPharma message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Campaign.VanityPharma
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            VanityPharma.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.vanityPharmaDisplayUrlMode != null && message.hasOwnProperty("vanityPharmaDisplayUrlMode"))
                                    switch (message.vanityPharmaDisplayUrlMode) {
                                    default:
                                        return "vanityPharmaDisplayUrlMode: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                        break;
                                    }
                                if (message.vanityPharmaText != null && message.hasOwnProperty("vanityPharmaText"))
                                    switch (message.vanityPharmaText) {
                                    default:
                                        return "vanityPharmaText: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                    case 5:
                                    case 6:
                                    case 7:
                                    case 8:
                                    case 9:
                                    case 10:
                                    case 11:
                                    case 12:
                                    case 13:
                                        break;
                                    }
                                return null;
                            };

                            /**
                             * Creates a VanityPharma message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Campaign.VanityPharma
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Campaign.VanityPharma} VanityPharma
                             */
                            VanityPharma.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Campaign.VanityPharma)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Campaign.VanityPharma();
                                switch (object.vanityPharmaDisplayUrlMode) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.vanityPharmaDisplayUrlMode = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.vanityPharmaDisplayUrlMode = 1;
                                    break;
                                case "MANUFACTURER_WEBSITE_URL":
                                case 2:
                                    message.vanityPharmaDisplayUrlMode = 2;
                                    break;
                                case "WEBSITE_DESCRIPTION":
                                case 3:
                                    message.vanityPharmaDisplayUrlMode = 3;
                                    break;
                                }
                                switch (object.vanityPharmaText) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.vanityPharmaText = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.vanityPharmaText = 1;
                                    break;
                                case "PRESCRIPTION_TREATMENT_WEBSITE_EN":
                                case 2:
                                    message.vanityPharmaText = 2;
                                    break;
                                case "PRESCRIPTION_TREATMENT_WEBSITE_ES":
                                case 3:
                                    message.vanityPharmaText = 3;
                                    break;
                                case "PRESCRIPTION_DEVICE_WEBSITE_EN":
                                case 4:
                                    message.vanityPharmaText = 4;
                                    break;
                                case "PRESCRIPTION_DEVICE_WEBSITE_ES":
                                case 5:
                                    message.vanityPharmaText = 5;
                                    break;
                                case "MEDICAL_DEVICE_WEBSITE_EN":
                                case 6:
                                    message.vanityPharmaText = 6;
                                    break;
                                case "MEDICAL_DEVICE_WEBSITE_ES":
                                case 7:
                                    message.vanityPharmaText = 7;
                                    break;
                                case "PREVENTATIVE_TREATMENT_WEBSITE_EN":
                                case 8:
                                    message.vanityPharmaText = 8;
                                    break;
                                case "PREVENTATIVE_TREATMENT_WEBSITE_ES":
                                case 9:
                                    message.vanityPharmaText = 9;
                                    break;
                                case "PRESCRIPTION_CONTRACEPTION_WEBSITE_EN":
                                case 10:
                                    message.vanityPharmaText = 10;
                                    break;
                                case "PRESCRIPTION_CONTRACEPTION_WEBSITE_ES":
                                case 11:
                                    message.vanityPharmaText = 11;
                                    break;
                                case "PRESCRIPTION_VACCINE_WEBSITE_EN":
                                case 12:
                                    message.vanityPharmaText = 12;
                                    break;
                                case "PRESCRIPTION_VACCINE_WEBSITE_ES":
                                case 13:
                                    message.vanityPharmaText = 13;
                                    break;
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a VanityPharma message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Campaign.VanityPharma
                             * @static
                             * @param {google.ads.googleads.v1.resources.Campaign.VanityPharma} message VanityPharma
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            VanityPharma.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.vanityPharmaDisplayUrlMode = options.enums === String ? "UNSPECIFIED" : 0;
                                    object.vanityPharmaText = options.enums === String ? "UNSPECIFIED" : 0;
                                }
                                if (message.vanityPharmaDisplayUrlMode != null && message.hasOwnProperty("vanityPharmaDisplayUrlMode"))
                                    object.vanityPharmaDisplayUrlMode = options.enums === String ? $root.google.ads.googleads.v1.enums.VanityPharmaDisplayUrlModeEnum.VanityPharmaDisplayUrlMode[message.vanityPharmaDisplayUrlMode] : message.vanityPharmaDisplayUrlMode;
                                if (message.vanityPharmaText != null && message.hasOwnProperty("vanityPharmaText"))
                                    object.vanityPharmaText = options.enums === String ? $root.google.ads.googleads.v1.enums.VanityPharmaTextEnum.VanityPharmaText[message.vanityPharmaText] : message.vanityPharmaText;
                                return object;
                            };

                            /**
                             * Converts this VanityPharma to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Campaign.VanityPharma
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            VanityPharma.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return VanityPharma;
                        })();

                        return Campaign;
                    })();

                    resources.CampaignAudienceView = (function() {

                        /**
                         * Properties of a CampaignAudienceView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICampaignAudienceView
                         * @property {string|null} [resourceName] CampaignAudienceView resourceName
                         */

                        /**
                         * Constructs a new CampaignAudienceView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CampaignAudienceView.
                         * @implements ICampaignAudienceView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICampaignAudienceView=} [properties] Properties to set
                         */
                        function CampaignAudienceView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CampaignAudienceView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.CampaignAudienceView
                         * @instance
                         */
                        CampaignAudienceView.prototype.resourceName = "";

                        /**
                         * Creates a new CampaignAudienceView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CampaignAudienceView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignAudienceView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CampaignAudienceView} CampaignAudienceView instance
                         */
                        CampaignAudienceView.create = function create(properties) {
                            return new CampaignAudienceView(properties);
                        };

                        /**
                         * Encodes the specified CampaignAudienceView message. Does not implicitly {@link google.ads.googleads.v1.resources.CampaignAudienceView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CampaignAudienceView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignAudienceView} message CampaignAudienceView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignAudienceView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignAudienceView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CampaignAudienceView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CampaignAudienceView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignAudienceView} message CampaignAudienceView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignAudienceView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignAudienceView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CampaignAudienceView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CampaignAudienceView} CampaignAudienceView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignAudienceView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CampaignAudienceView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignAudienceView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CampaignAudienceView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CampaignAudienceView} CampaignAudienceView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignAudienceView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignAudienceView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CampaignAudienceView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignAudienceView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a CampaignAudienceView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CampaignAudienceView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CampaignAudienceView} CampaignAudienceView
                         */
                        CampaignAudienceView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CampaignAudienceView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CampaignAudienceView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a CampaignAudienceView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CampaignAudienceView
                         * @static
                         * @param {google.ads.googleads.v1.resources.CampaignAudienceView} message CampaignAudienceView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignAudienceView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this CampaignAudienceView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CampaignAudienceView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignAudienceView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CampaignAudienceView;
                    })();

                    resources.CampaignBidModifier = (function() {

                        /**
                         * Properties of a CampaignBidModifier.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICampaignBidModifier
                         * @property {string|null} [resourceName] CampaignBidModifier resourceName
                         * @property {google.protobuf.IStringValue|null} [campaign] CampaignBidModifier campaign
                         * @property {google.protobuf.IInt64Value|null} [criterionId] CampaignBidModifier criterionId
                         * @property {google.protobuf.IDoubleValue|null} [bidModifier] CampaignBidModifier bidModifier
                         * @property {google.ads.googleads.v1.common.IInteractionTypeInfo|null} [interactionType] CampaignBidModifier interactionType
                         */

                        /**
                         * Constructs a new CampaignBidModifier.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CampaignBidModifier.
                         * @implements ICampaignBidModifier
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICampaignBidModifier=} [properties] Properties to set
                         */
                        function CampaignBidModifier(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CampaignBidModifier resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.CampaignBidModifier
                         * @instance
                         */
                        CampaignBidModifier.prototype.resourceName = "";

                        /**
                         * CampaignBidModifier campaign.
                         * @member {google.protobuf.IStringValue|null|undefined} campaign
                         * @memberof google.ads.googleads.v1.resources.CampaignBidModifier
                         * @instance
                         */
                        CampaignBidModifier.prototype.campaign = null;

                        /**
                         * CampaignBidModifier criterionId.
                         * @member {google.protobuf.IInt64Value|null|undefined} criterionId
                         * @memberof google.ads.googleads.v1.resources.CampaignBidModifier
                         * @instance
                         */
                        CampaignBidModifier.prototype.criterionId = null;

                        /**
                         * CampaignBidModifier bidModifier.
                         * @member {google.protobuf.IDoubleValue|null|undefined} bidModifier
                         * @memberof google.ads.googleads.v1.resources.CampaignBidModifier
                         * @instance
                         */
                        CampaignBidModifier.prototype.bidModifier = null;

                        /**
                         * CampaignBidModifier interactionType.
                         * @member {google.ads.googleads.v1.common.IInteractionTypeInfo|null|undefined} interactionType
                         * @memberof google.ads.googleads.v1.resources.CampaignBidModifier
                         * @instance
                         */
                        CampaignBidModifier.prototype.interactionType = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CampaignBidModifier criterion.
                         * @member {"interactionType"|undefined} criterion
                         * @memberof google.ads.googleads.v1.resources.CampaignBidModifier
                         * @instance
                         */
                        Object.defineProperty(CampaignBidModifier.prototype, "criterion", {
                            get: $util.oneOfGetter($oneOfFields = ["interactionType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CampaignBidModifier instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CampaignBidModifier
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignBidModifier=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CampaignBidModifier} CampaignBidModifier instance
                         */
                        CampaignBidModifier.create = function create(properties) {
                            return new CampaignBidModifier(properties);
                        };

                        /**
                         * Encodes the specified CampaignBidModifier message. Does not implicitly {@link google.ads.googleads.v1.resources.CampaignBidModifier.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CampaignBidModifier
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignBidModifier} message CampaignBidModifier message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignBidModifier.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                $root.google.protobuf.StringValue.encode(message.campaign, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.criterionId != null && message.hasOwnProperty("criterionId"))
                                $root.google.protobuf.Int64Value.encode(message.criterionId, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.bidModifier != null && message.hasOwnProperty("bidModifier"))
                                $root.google.protobuf.DoubleValue.encode(message.bidModifier, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.interactionType != null && message.hasOwnProperty("interactionType"))
                                $root.google.ads.googleads.v1.common.InteractionTypeInfo.encode(message.interactionType, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignBidModifier message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CampaignBidModifier.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CampaignBidModifier
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignBidModifier} message CampaignBidModifier message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignBidModifier.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignBidModifier message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CampaignBidModifier
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CampaignBidModifier} CampaignBidModifier
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignBidModifier.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CampaignBidModifier();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.campaign = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.criterionId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.bidModifier = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.interactionType = $root.google.ads.googleads.v1.common.InteractionTypeInfo.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignBidModifier message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CampaignBidModifier
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CampaignBidModifier} CampaignBidModifier
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignBidModifier.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignBidModifier message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CampaignBidModifier
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignBidModifier.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.campaign != null && message.hasOwnProperty("campaign")) {
                                var error = $root.google.protobuf.StringValue.verify(message.campaign);
                                if (error)
                                    return "campaign." + error;
                            }
                            if (message.criterionId != null && message.hasOwnProperty("criterionId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.criterionId);
                                if (error)
                                    return "criterionId." + error;
                            }
                            if (message.bidModifier != null && message.hasOwnProperty("bidModifier")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.bidModifier);
                                if (error)
                                    return "bidModifier." + error;
                            }
                            if (message.interactionType != null && message.hasOwnProperty("interactionType")) {
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.InteractionTypeInfo.verify(message.interactionType);
                                    if (error)
                                        return "interactionType." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a CampaignBidModifier message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CampaignBidModifier
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CampaignBidModifier} CampaignBidModifier
                         */
                        CampaignBidModifier.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CampaignBidModifier)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CampaignBidModifier();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.campaign != null) {
                                if (typeof object.campaign !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignBidModifier.campaign: object expected");
                                message.campaign = $root.google.protobuf.StringValue.fromObject(object.campaign);
                            }
                            if (object.criterionId != null) {
                                if (typeof object.criterionId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignBidModifier.criterionId: object expected");
                                message.criterionId = $root.google.protobuf.Int64Value.fromObject(object.criterionId);
                            }
                            if (object.bidModifier != null) {
                                if (typeof object.bidModifier !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignBidModifier.bidModifier: object expected");
                                message.bidModifier = $root.google.protobuf.DoubleValue.fromObject(object.bidModifier);
                            }
                            if (object.interactionType != null) {
                                if (typeof object.interactionType !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignBidModifier.interactionType: object expected");
                                message.interactionType = $root.google.ads.googleads.v1.common.InteractionTypeInfo.fromObject(object.interactionType);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CampaignBidModifier message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CampaignBidModifier
                         * @static
                         * @param {google.ads.googleads.v1.resources.CampaignBidModifier} message CampaignBidModifier
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignBidModifier.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.campaign = null;
                                object.criterionId = null;
                                object.bidModifier = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                object.campaign = $root.google.protobuf.StringValue.toObject(message.campaign, options);
                            if (message.criterionId != null && message.hasOwnProperty("criterionId"))
                                object.criterionId = $root.google.protobuf.Int64Value.toObject(message.criterionId, options);
                            if (message.bidModifier != null && message.hasOwnProperty("bidModifier"))
                                object.bidModifier = $root.google.protobuf.DoubleValue.toObject(message.bidModifier, options);
                            if (message.interactionType != null && message.hasOwnProperty("interactionType")) {
                                object.interactionType = $root.google.ads.googleads.v1.common.InteractionTypeInfo.toObject(message.interactionType, options);
                                if (options.oneofs)
                                    object.criterion = "interactionType";
                            }
                            return object;
                        };

                        /**
                         * Converts this CampaignBidModifier to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CampaignBidModifier
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignBidModifier.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CampaignBidModifier;
                    })();

                    resources.CampaignBudget = (function() {

                        /**
                         * Properties of a CampaignBudget.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICampaignBudget
                         * @property {string|null} [resourceName] CampaignBudget resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] CampaignBudget id
                         * @property {google.protobuf.IStringValue|null} [name] CampaignBudget name
                         * @property {google.protobuf.IInt64Value|null} [amountMicros] CampaignBudget amountMicros
                         * @property {google.protobuf.IInt64Value|null} [totalAmountMicros] CampaignBudget totalAmountMicros
                         * @property {google.ads.googleads.v1.enums.BudgetStatusEnum.BudgetStatus|null} [status] CampaignBudget status
                         * @property {google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum.BudgetDeliveryMethod|null} [deliveryMethod] CampaignBudget deliveryMethod
                         * @property {google.protobuf.IBoolValue|null} [explicitlyShared] CampaignBudget explicitlyShared
                         * @property {google.protobuf.IInt64Value|null} [referenceCount] CampaignBudget referenceCount
                         * @property {google.protobuf.IBoolValue|null} [hasRecommendedBudget] CampaignBudget hasRecommendedBudget
                         * @property {google.protobuf.IInt64Value|null} [recommendedBudgetAmountMicros] CampaignBudget recommendedBudgetAmountMicros
                         * @property {google.ads.googleads.v1.enums.BudgetPeriodEnum.BudgetPeriod|null} [period] CampaignBudget period
                         * @property {google.protobuf.IInt64Value|null} [recommendedBudgetEstimatedChangeWeeklyClicks] CampaignBudget recommendedBudgetEstimatedChangeWeeklyClicks
                         * @property {google.protobuf.IInt64Value|null} [recommendedBudgetEstimatedChangeWeeklyCostMicros] CampaignBudget recommendedBudgetEstimatedChangeWeeklyCostMicros
                         * @property {google.protobuf.IInt64Value|null} [recommendedBudgetEstimatedChangeWeeklyInteractions] CampaignBudget recommendedBudgetEstimatedChangeWeeklyInteractions
                         * @property {google.protobuf.IInt64Value|null} [recommendedBudgetEstimatedChangeWeeklyViews] CampaignBudget recommendedBudgetEstimatedChangeWeeklyViews
                         * @property {google.ads.googleads.v1.enums.BudgetTypeEnum.BudgetType|null} [type] CampaignBudget type
                         */

                        /**
                         * Constructs a new CampaignBudget.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CampaignBudget.
                         * @implements ICampaignBudget
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICampaignBudget=} [properties] Properties to set
                         */
                        function CampaignBudget(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CampaignBudget resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @instance
                         */
                        CampaignBudget.prototype.resourceName = "";

                        /**
                         * CampaignBudget id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @instance
                         */
                        CampaignBudget.prototype.id = null;

                        /**
                         * CampaignBudget name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @instance
                         */
                        CampaignBudget.prototype.name = null;

                        /**
                         * CampaignBudget amountMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} amountMicros
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @instance
                         */
                        CampaignBudget.prototype.amountMicros = null;

                        /**
                         * CampaignBudget totalAmountMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} totalAmountMicros
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @instance
                         */
                        CampaignBudget.prototype.totalAmountMicros = null;

                        /**
                         * CampaignBudget status.
                         * @member {google.ads.googleads.v1.enums.BudgetStatusEnum.BudgetStatus} status
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @instance
                         */
                        CampaignBudget.prototype.status = 0;

                        /**
                         * CampaignBudget deliveryMethod.
                         * @member {google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum.BudgetDeliveryMethod} deliveryMethod
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @instance
                         */
                        CampaignBudget.prototype.deliveryMethod = 0;

                        /**
                         * CampaignBudget explicitlyShared.
                         * @member {google.protobuf.IBoolValue|null|undefined} explicitlyShared
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @instance
                         */
                        CampaignBudget.prototype.explicitlyShared = null;

                        /**
                         * CampaignBudget referenceCount.
                         * @member {google.protobuf.IInt64Value|null|undefined} referenceCount
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @instance
                         */
                        CampaignBudget.prototype.referenceCount = null;

                        /**
                         * CampaignBudget hasRecommendedBudget.
                         * @member {google.protobuf.IBoolValue|null|undefined} hasRecommendedBudget
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @instance
                         */
                        CampaignBudget.prototype.hasRecommendedBudget = null;

                        /**
                         * CampaignBudget recommendedBudgetAmountMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} recommendedBudgetAmountMicros
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @instance
                         */
                        CampaignBudget.prototype.recommendedBudgetAmountMicros = null;

                        /**
                         * CampaignBudget period.
                         * @member {google.ads.googleads.v1.enums.BudgetPeriodEnum.BudgetPeriod} period
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @instance
                         */
                        CampaignBudget.prototype.period = 0;

                        /**
                         * CampaignBudget recommendedBudgetEstimatedChangeWeeklyClicks.
                         * @member {google.protobuf.IInt64Value|null|undefined} recommendedBudgetEstimatedChangeWeeklyClicks
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @instance
                         */
                        CampaignBudget.prototype.recommendedBudgetEstimatedChangeWeeklyClicks = null;

                        /**
                         * CampaignBudget recommendedBudgetEstimatedChangeWeeklyCostMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} recommendedBudgetEstimatedChangeWeeklyCostMicros
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @instance
                         */
                        CampaignBudget.prototype.recommendedBudgetEstimatedChangeWeeklyCostMicros = null;

                        /**
                         * CampaignBudget recommendedBudgetEstimatedChangeWeeklyInteractions.
                         * @member {google.protobuf.IInt64Value|null|undefined} recommendedBudgetEstimatedChangeWeeklyInteractions
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @instance
                         */
                        CampaignBudget.prototype.recommendedBudgetEstimatedChangeWeeklyInteractions = null;

                        /**
                         * CampaignBudget recommendedBudgetEstimatedChangeWeeklyViews.
                         * @member {google.protobuf.IInt64Value|null|undefined} recommendedBudgetEstimatedChangeWeeklyViews
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @instance
                         */
                        CampaignBudget.prototype.recommendedBudgetEstimatedChangeWeeklyViews = null;

                        /**
                         * CampaignBudget type.
                         * @member {google.ads.googleads.v1.enums.BudgetTypeEnum.BudgetType} type
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @instance
                         */
                        CampaignBudget.prototype.type = 0;

                        /**
                         * Creates a new CampaignBudget instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignBudget=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CampaignBudget} CampaignBudget instance
                         */
                        CampaignBudget.create = function create(properties) {
                            return new CampaignBudget(properties);
                        };

                        /**
                         * Encodes the specified CampaignBudget message. Does not implicitly {@link google.ads.googleads.v1.resources.CampaignBudget.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignBudget} message CampaignBudget message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignBudget.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.amountMicros != null && message.hasOwnProperty("amountMicros"))
                                $root.google.protobuf.Int64Value.encode(message.amountMicros, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.status);
                            if (message.deliveryMethod != null && message.hasOwnProperty("deliveryMethod"))
                                writer.uint32(/* id 7, wireType 0 =*/56).int32(message.deliveryMethod);
                            if (message.explicitlyShared != null && message.hasOwnProperty("explicitlyShared"))
                                $root.google.protobuf.BoolValue.encode(message.explicitlyShared, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.referenceCount != null && message.hasOwnProperty("referenceCount"))
                                $root.google.protobuf.Int64Value.encode(message.referenceCount, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.totalAmountMicros != null && message.hasOwnProperty("totalAmountMicros"))
                                $root.google.protobuf.Int64Value.encode(message.totalAmountMicros, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.hasRecommendedBudget != null && message.hasOwnProperty("hasRecommendedBudget"))
                                $root.google.protobuf.BoolValue.encode(message.hasRecommendedBudget, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.recommendedBudgetAmountMicros != null && message.hasOwnProperty("recommendedBudgetAmountMicros"))
                                $root.google.protobuf.Int64Value.encode(message.recommendedBudgetAmountMicros, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.period != null && message.hasOwnProperty("period"))
                                writer.uint32(/* id 13, wireType 0 =*/104).int32(message.period);
                            if (message.recommendedBudgetEstimatedChangeWeeklyClicks != null && message.hasOwnProperty("recommendedBudgetEstimatedChangeWeeklyClicks"))
                                $root.google.protobuf.Int64Value.encode(message.recommendedBudgetEstimatedChangeWeeklyClicks, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.recommendedBudgetEstimatedChangeWeeklyCostMicros != null && message.hasOwnProperty("recommendedBudgetEstimatedChangeWeeklyCostMicros"))
                                $root.google.protobuf.Int64Value.encode(message.recommendedBudgetEstimatedChangeWeeklyCostMicros, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
                            if (message.recommendedBudgetEstimatedChangeWeeklyInteractions != null && message.hasOwnProperty("recommendedBudgetEstimatedChangeWeeklyInteractions"))
                                $root.google.protobuf.Int64Value.encode(message.recommendedBudgetEstimatedChangeWeeklyInteractions, writer.uint32(/* id 16, wireType 2 =*/130).fork()).ldelim();
                            if (message.recommendedBudgetEstimatedChangeWeeklyViews != null && message.hasOwnProperty("recommendedBudgetEstimatedChangeWeeklyViews"))
                                $root.google.protobuf.Int64Value.encode(message.recommendedBudgetEstimatedChangeWeeklyViews, writer.uint32(/* id 17, wireType 2 =*/138).fork()).ldelim();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 18, wireType 0 =*/144).int32(message.type);
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignBudget message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CampaignBudget.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignBudget} message CampaignBudget message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignBudget.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignBudget message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CampaignBudget} CampaignBudget
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignBudget.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CampaignBudget();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 3:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.amountMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.totalAmountMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.status = reader.int32();
                                    break;
                                case 7:
                                    message.deliveryMethod = reader.int32();
                                    break;
                                case 8:
                                    message.explicitlyShared = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.referenceCount = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.hasRecommendedBudget = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.recommendedBudgetAmountMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 13:
                                    message.period = reader.int32();
                                    break;
                                case 14:
                                    message.recommendedBudgetEstimatedChangeWeeklyClicks = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 15:
                                    message.recommendedBudgetEstimatedChangeWeeklyCostMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 16:
                                    message.recommendedBudgetEstimatedChangeWeeklyInteractions = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 17:
                                    message.recommendedBudgetEstimatedChangeWeeklyViews = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 18:
                                    message.type = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignBudget message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CampaignBudget} CampaignBudget
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignBudget.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignBudget message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignBudget.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.amountMicros != null && message.hasOwnProperty("amountMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.amountMicros);
                                if (error)
                                    return "amountMicros." + error;
                            }
                            if (message.totalAmountMicros != null && message.hasOwnProperty("totalAmountMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.totalAmountMicros);
                                if (error)
                                    return "totalAmountMicros." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.deliveryMethod != null && message.hasOwnProperty("deliveryMethod"))
                                switch (message.deliveryMethod) {
                                default:
                                    return "deliveryMethod: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.explicitlyShared != null && message.hasOwnProperty("explicitlyShared")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.explicitlyShared);
                                if (error)
                                    return "explicitlyShared." + error;
                            }
                            if (message.referenceCount != null && message.hasOwnProperty("referenceCount")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.referenceCount);
                                if (error)
                                    return "referenceCount." + error;
                            }
                            if (message.hasRecommendedBudget != null && message.hasOwnProperty("hasRecommendedBudget")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.hasRecommendedBudget);
                                if (error)
                                    return "hasRecommendedBudget." + error;
                            }
                            if (message.recommendedBudgetAmountMicros != null && message.hasOwnProperty("recommendedBudgetAmountMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.recommendedBudgetAmountMicros);
                                if (error)
                                    return "recommendedBudgetAmountMicros." + error;
                            }
                            if (message.period != null && message.hasOwnProperty("period"))
                                switch (message.period) {
                                default:
                                    return "period: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.recommendedBudgetEstimatedChangeWeeklyClicks != null && message.hasOwnProperty("recommendedBudgetEstimatedChangeWeeklyClicks")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.recommendedBudgetEstimatedChangeWeeklyClicks);
                                if (error)
                                    return "recommendedBudgetEstimatedChangeWeeklyClicks." + error;
                            }
                            if (message.recommendedBudgetEstimatedChangeWeeklyCostMicros != null && message.hasOwnProperty("recommendedBudgetEstimatedChangeWeeklyCostMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.recommendedBudgetEstimatedChangeWeeklyCostMicros);
                                if (error)
                                    return "recommendedBudgetEstimatedChangeWeeklyCostMicros." + error;
                            }
                            if (message.recommendedBudgetEstimatedChangeWeeklyInteractions != null && message.hasOwnProperty("recommendedBudgetEstimatedChangeWeeklyInteractions")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.recommendedBudgetEstimatedChangeWeeklyInteractions);
                                if (error)
                                    return "recommendedBudgetEstimatedChangeWeeklyInteractions." + error;
                            }
                            if (message.recommendedBudgetEstimatedChangeWeeklyViews != null && message.hasOwnProperty("recommendedBudgetEstimatedChangeWeeklyViews")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.recommendedBudgetEstimatedChangeWeeklyViews);
                                if (error)
                                    return "recommendedBudgetEstimatedChangeWeeklyViews." + error;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a CampaignBudget message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CampaignBudget} CampaignBudget
                         */
                        CampaignBudget.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CampaignBudget)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CampaignBudget();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignBudget.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignBudget.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            if (object.amountMicros != null) {
                                if (typeof object.amountMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignBudget.amountMicros: object expected");
                                message.amountMicros = $root.google.protobuf.Int64Value.fromObject(object.amountMicros);
                            }
                            if (object.totalAmountMicros != null) {
                                if (typeof object.totalAmountMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignBudget.totalAmountMicros: object expected");
                                message.totalAmountMicros = $root.google.protobuf.Int64Value.fromObject(object.totalAmountMicros);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "REMOVED":
                            case 3:
                                message.status = 3;
                                break;
                            }
                            switch (object.deliveryMethod) {
                            case "UNSPECIFIED":
                            case 0:
                                message.deliveryMethod = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.deliveryMethod = 1;
                                break;
                            case "STANDARD":
                            case 2:
                                message.deliveryMethod = 2;
                                break;
                            case "ACCELERATED":
                            case 3:
                                message.deliveryMethod = 3;
                                break;
                            }
                            if (object.explicitlyShared != null) {
                                if (typeof object.explicitlyShared !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignBudget.explicitlyShared: object expected");
                                message.explicitlyShared = $root.google.protobuf.BoolValue.fromObject(object.explicitlyShared);
                            }
                            if (object.referenceCount != null) {
                                if (typeof object.referenceCount !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignBudget.referenceCount: object expected");
                                message.referenceCount = $root.google.protobuf.Int64Value.fromObject(object.referenceCount);
                            }
                            if (object.hasRecommendedBudget != null) {
                                if (typeof object.hasRecommendedBudget !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignBudget.hasRecommendedBudget: object expected");
                                message.hasRecommendedBudget = $root.google.protobuf.BoolValue.fromObject(object.hasRecommendedBudget);
                            }
                            if (object.recommendedBudgetAmountMicros != null) {
                                if (typeof object.recommendedBudgetAmountMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignBudget.recommendedBudgetAmountMicros: object expected");
                                message.recommendedBudgetAmountMicros = $root.google.protobuf.Int64Value.fromObject(object.recommendedBudgetAmountMicros);
                            }
                            switch (object.period) {
                            case "UNSPECIFIED":
                            case 0:
                                message.period = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.period = 1;
                                break;
                            case "DAILY":
                            case 2:
                                message.period = 2;
                                break;
                            case "CUSTOM":
                            case 3:
                                message.period = 3;
                                break;
                            case "FIXED_DAILY":
                            case 4:
                                message.period = 4;
                                break;
                            }
                            if (object.recommendedBudgetEstimatedChangeWeeklyClicks != null) {
                                if (typeof object.recommendedBudgetEstimatedChangeWeeklyClicks !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignBudget.recommendedBudgetEstimatedChangeWeeklyClicks: object expected");
                                message.recommendedBudgetEstimatedChangeWeeklyClicks = $root.google.protobuf.Int64Value.fromObject(object.recommendedBudgetEstimatedChangeWeeklyClicks);
                            }
                            if (object.recommendedBudgetEstimatedChangeWeeklyCostMicros != null) {
                                if (typeof object.recommendedBudgetEstimatedChangeWeeklyCostMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignBudget.recommendedBudgetEstimatedChangeWeeklyCostMicros: object expected");
                                message.recommendedBudgetEstimatedChangeWeeklyCostMicros = $root.google.protobuf.Int64Value.fromObject(object.recommendedBudgetEstimatedChangeWeeklyCostMicros);
                            }
                            if (object.recommendedBudgetEstimatedChangeWeeklyInteractions != null) {
                                if (typeof object.recommendedBudgetEstimatedChangeWeeklyInteractions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignBudget.recommendedBudgetEstimatedChangeWeeklyInteractions: object expected");
                                message.recommendedBudgetEstimatedChangeWeeklyInteractions = $root.google.protobuf.Int64Value.fromObject(object.recommendedBudgetEstimatedChangeWeeklyInteractions);
                            }
                            if (object.recommendedBudgetEstimatedChangeWeeklyViews != null) {
                                if (typeof object.recommendedBudgetEstimatedChangeWeeklyViews !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignBudget.recommendedBudgetEstimatedChangeWeeklyViews: object expected");
                                message.recommendedBudgetEstimatedChangeWeeklyViews = $root.google.protobuf.Int64Value.fromObject(object.recommendedBudgetEstimatedChangeWeeklyViews);
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "STANDARD":
                            case 2:
                                message.type = 2;
                                break;
                            case "HOTEL_ADS_COMMISSION":
                            case 3:
                                message.type = 3;
                                break;
                            case "FIXED_CPA":
                            case 4:
                                message.type = 4;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CampaignBudget message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @static
                         * @param {google.ads.googleads.v1.resources.CampaignBudget} message CampaignBudget
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignBudget.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.name = null;
                                object.amountMicros = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                                object.deliveryMethod = options.enums === String ? "UNSPECIFIED" : 0;
                                object.explicitlyShared = null;
                                object.referenceCount = null;
                                object.totalAmountMicros = null;
                                object.hasRecommendedBudget = null;
                                object.recommendedBudgetAmountMicros = null;
                                object.period = options.enums === String ? "UNSPECIFIED" : 0;
                                object.recommendedBudgetEstimatedChangeWeeklyClicks = null;
                                object.recommendedBudgetEstimatedChangeWeeklyCostMicros = null;
                                object.recommendedBudgetEstimatedChangeWeeklyInteractions = null;
                                object.recommendedBudgetEstimatedChangeWeeklyViews = null;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.amountMicros != null && message.hasOwnProperty("amountMicros"))
                                object.amountMicros = $root.google.protobuf.Int64Value.toObject(message.amountMicros, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.BudgetStatusEnum.BudgetStatus[message.status] : message.status;
                            if (message.deliveryMethod != null && message.hasOwnProperty("deliveryMethod"))
                                object.deliveryMethod = options.enums === String ? $root.google.ads.googleads.v1.enums.BudgetDeliveryMethodEnum.BudgetDeliveryMethod[message.deliveryMethod] : message.deliveryMethod;
                            if (message.explicitlyShared != null && message.hasOwnProperty("explicitlyShared"))
                                object.explicitlyShared = $root.google.protobuf.BoolValue.toObject(message.explicitlyShared, options);
                            if (message.referenceCount != null && message.hasOwnProperty("referenceCount"))
                                object.referenceCount = $root.google.protobuf.Int64Value.toObject(message.referenceCount, options);
                            if (message.totalAmountMicros != null && message.hasOwnProperty("totalAmountMicros"))
                                object.totalAmountMicros = $root.google.protobuf.Int64Value.toObject(message.totalAmountMicros, options);
                            if (message.hasRecommendedBudget != null && message.hasOwnProperty("hasRecommendedBudget"))
                                object.hasRecommendedBudget = $root.google.protobuf.BoolValue.toObject(message.hasRecommendedBudget, options);
                            if (message.recommendedBudgetAmountMicros != null && message.hasOwnProperty("recommendedBudgetAmountMicros"))
                                object.recommendedBudgetAmountMicros = $root.google.protobuf.Int64Value.toObject(message.recommendedBudgetAmountMicros, options);
                            if (message.period != null && message.hasOwnProperty("period"))
                                object.period = options.enums === String ? $root.google.ads.googleads.v1.enums.BudgetPeriodEnum.BudgetPeriod[message.period] : message.period;
                            if (message.recommendedBudgetEstimatedChangeWeeklyClicks != null && message.hasOwnProperty("recommendedBudgetEstimatedChangeWeeklyClicks"))
                                object.recommendedBudgetEstimatedChangeWeeklyClicks = $root.google.protobuf.Int64Value.toObject(message.recommendedBudgetEstimatedChangeWeeklyClicks, options);
                            if (message.recommendedBudgetEstimatedChangeWeeklyCostMicros != null && message.hasOwnProperty("recommendedBudgetEstimatedChangeWeeklyCostMicros"))
                                object.recommendedBudgetEstimatedChangeWeeklyCostMicros = $root.google.protobuf.Int64Value.toObject(message.recommendedBudgetEstimatedChangeWeeklyCostMicros, options);
                            if (message.recommendedBudgetEstimatedChangeWeeklyInteractions != null && message.hasOwnProperty("recommendedBudgetEstimatedChangeWeeklyInteractions"))
                                object.recommendedBudgetEstimatedChangeWeeklyInteractions = $root.google.protobuf.Int64Value.toObject(message.recommendedBudgetEstimatedChangeWeeklyInteractions, options);
                            if (message.recommendedBudgetEstimatedChangeWeeklyViews != null && message.hasOwnProperty("recommendedBudgetEstimatedChangeWeeklyViews"))
                                object.recommendedBudgetEstimatedChangeWeeklyViews = $root.google.protobuf.Int64Value.toObject(message.recommendedBudgetEstimatedChangeWeeklyViews, options);
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.BudgetTypeEnum.BudgetType[message.type] : message.type;
                            return object;
                        };

                        /**
                         * Converts this CampaignBudget to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CampaignBudget
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignBudget.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CampaignBudget;
                    })();

                    resources.CampaignCriterion = (function() {

                        /**
                         * Properties of a CampaignCriterion.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICampaignCriterion
                         * @property {string|null} [resourceName] CampaignCriterion resourceName
                         * @property {google.protobuf.IStringValue|null} [campaign] CampaignCriterion campaign
                         * @property {google.protobuf.IInt64Value|null} [criterionId] CampaignCriterion criterionId
                         * @property {google.protobuf.IFloatValue|null} [bidModifier] CampaignCriterion bidModifier
                         * @property {google.protobuf.IBoolValue|null} [negative] CampaignCriterion negative
                         * @property {google.ads.googleads.v1.enums.CriterionTypeEnum.CriterionType|null} [type] CampaignCriterion type
                         * @property {google.ads.googleads.v1.common.IKeywordInfo|null} [keyword] CampaignCriterion keyword
                         * @property {google.ads.googleads.v1.common.IPlacementInfo|null} [placement] CampaignCriterion placement
                         * @property {google.ads.googleads.v1.common.IMobileAppCategoryInfo|null} [mobileAppCategory] CampaignCriterion mobileAppCategory
                         * @property {google.ads.googleads.v1.common.IMobileApplicationInfo|null} [mobileApplication] CampaignCriterion mobileApplication
                         * @property {google.ads.googleads.v1.common.ILocationInfo|null} [location] CampaignCriterion location
                         * @property {google.ads.googleads.v1.common.IDeviceInfo|null} [device] CampaignCriterion device
                         * @property {google.ads.googleads.v1.common.IAdScheduleInfo|null} [adSchedule] CampaignCriterion adSchedule
                         * @property {google.ads.googleads.v1.common.IAgeRangeInfo|null} [ageRange] CampaignCriterion ageRange
                         * @property {google.ads.googleads.v1.common.IGenderInfo|null} [gender] CampaignCriterion gender
                         * @property {google.ads.googleads.v1.common.IIncomeRangeInfo|null} [incomeRange] CampaignCriterion incomeRange
                         * @property {google.ads.googleads.v1.common.IParentalStatusInfo|null} [parentalStatus] CampaignCriterion parentalStatus
                         * @property {google.ads.googleads.v1.common.IUserListInfo|null} [userList] CampaignCriterion userList
                         * @property {google.ads.googleads.v1.common.IYouTubeVideoInfo|null} [youtubeVideo] CampaignCriterion youtubeVideo
                         * @property {google.ads.googleads.v1.common.IYouTubeChannelInfo|null} [youtubeChannel] CampaignCriterion youtubeChannel
                         * @property {google.ads.googleads.v1.common.IProximityInfo|null} [proximity] CampaignCriterion proximity
                         * @property {google.ads.googleads.v1.common.ITopicInfo|null} [topic] CampaignCriterion topic
                         * @property {google.ads.googleads.v1.common.IListingScopeInfo|null} [listingScope] CampaignCriterion listingScope
                         * @property {google.ads.googleads.v1.common.ILanguageInfo|null} [language] CampaignCriterion language
                         * @property {google.ads.googleads.v1.common.IIpBlockInfo|null} [ipBlock] CampaignCriterion ipBlock
                         * @property {google.ads.googleads.v1.common.IContentLabelInfo|null} [contentLabel] CampaignCriterion contentLabel
                         * @property {google.ads.googleads.v1.common.ICarrierInfo|null} [carrier] CampaignCriterion carrier
                         * @property {google.ads.googleads.v1.common.IUserInterestInfo|null} [userInterest] CampaignCriterion userInterest
                         * @property {google.ads.googleads.v1.common.IWebpageInfo|null} [webpage] CampaignCriterion webpage
                         * @property {google.ads.googleads.v1.common.IOperatingSystemVersionInfo|null} [operatingSystemVersion] CampaignCriterion operatingSystemVersion
                         * @property {google.ads.googleads.v1.common.IMobileDeviceInfo|null} [mobileDevice] CampaignCriterion mobileDevice
                         * @property {google.ads.googleads.v1.common.ILocationGroupInfo|null} [locationGroup] CampaignCriterion locationGroup
                         */

                        /**
                         * Constructs a new CampaignCriterion.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CampaignCriterion.
                         * @implements ICampaignCriterion
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICampaignCriterion=} [properties] Properties to set
                         */
                        function CampaignCriterion(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CampaignCriterion resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.resourceName = "";

                        /**
                         * CampaignCriterion campaign.
                         * @member {google.protobuf.IStringValue|null|undefined} campaign
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.campaign = null;

                        /**
                         * CampaignCriterion criterionId.
                         * @member {google.protobuf.IInt64Value|null|undefined} criterionId
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.criterionId = null;

                        /**
                         * CampaignCriterion bidModifier.
                         * @member {google.protobuf.IFloatValue|null|undefined} bidModifier
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.bidModifier = null;

                        /**
                         * CampaignCriterion negative.
                         * @member {google.protobuf.IBoolValue|null|undefined} negative
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.negative = null;

                        /**
                         * CampaignCriterion type.
                         * @member {google.ads.googleads.v1.enums.CriterionTypeEnum.CriterionType} type
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.type = 0;

                        /**
                         * CampaignCriterion keyword.
                         * @member {google.ads.googleads.v1.common.IKeywordInfo|null|undefined} keyword
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.keyword = null;

                        /**
                         * CampaignCriterion placement.
                         * @member {google.ads.googleads.v1.common.IPlacementInfo|null|undefined} placement
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.placement = null;

                        /**
                         * CampaignCriterion mobileAppCategory.
                         * @member {google.ads.googleads.v1.common.IMobileAppCategoryInfo|null|undefined} mobileAppCategory
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.mobileAppCategory = null;

                        /**
                         * CampaignCriterion mobileApplication.
                         * @member {google.ads.googleads.v1.common.IMobileApplicationInfo|null|undefined} mobileApplication
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.mobileApplication = null;

                        /**
                         * CampaignCriterion location.
                         * @member {google.ads.googleads.v1.common.ILocationInfo|null|undefined} location
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.location = null;

                        /**
                         * CampaignCriterion device.
                         * @member {google.ads.googleads.v1.common.IDeviceInfo|null|undefined} device
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.device = null;

                        /**
                         * CampaignCriterion adSchedule.
                         * @member {google.ads.googleads.v1.common.IAdScheduleInfo|null|undefined} adSchedule
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.adSchedule = null;

                        /**
                         * CampaignCriterion ageRange.
                         * @member {google.ads.googleads.v1.common.IAgeRangeInfo|null|undefined} ageRange
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.ageRange = null;

                        /**
                         * CampaignCriterion gender.
                         * @member {google.ads.googleads.v1.common.IGenderInfo|null|undefined} gender
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.gender = null;

                        /**
                         * CampaignCriterion incomeRange.
                         * @member {google.ads.googleads.v1.common.IIncomeRangeInfo|null|undefined} incomeRange
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.incomeRange = null;

                        /**
                         * CampaignCriterion parentalStatus.
                         * @member {google.ads.googleads.v1.common.IParentalStatusInfo|null|undefined} parentalStatus
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.parentalStatus = null;

                        /**
                         * CampaignCriterion userList.
                         * @member {google.ads.googleads.v1.common.IUserListInfo|null|undefined} userList
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.userList = null;

                        /**
                         * CampaignCriterion youtubeVideo.
                         * @member {google.ads.googleads.v1.common.IYouTubeVideoInfo|null|undefined} youtubeVideo
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.youtubeVideo = null;

                        /**
                         * CampaignCriterion youtubeChannel.
                         * @member {google.ads.googleads.v1.common.IYouTubeChannelInfo|null|undefined} youtubeChannel
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.youtubeChannel = null;

                        /**
                         * CampaignCriterion proximity.
                         * @member {google.ads.googleads.v1.common.IProximityInfo|null|undefined} proximity
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.proximity = null;

                        /**
                         * CampaignCriterion topic.
                         * @member {google.ads.googleads.v1.common.ITopicInfo|null|undefined} topic
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.topic = null;

                        /**
                         * CampaignCriterion listingScope.
                         * @member {google.ads.googleads.v1.common.IListingScopeInfo|null|undefined} listingScope
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.listingScope = null;

                        /**
                         * CampaignCriterion language.
                         * @member {google.ads.googleads.v1.common.ILanguageInfo|null|undefined} language
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.language = null;

                        /**
                         * CampaignCriterion ipBlock.
                         * @member {google.ads.googleads.v1.common.IIpBlockInfo|null|undefined} ipBlock
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.ipBlock = null;

                        /**
                         * CampaignCriterion contentLabel.
                         * @member {google.ads.googleads.v1.common.IContentLabelInfo|null|undefined} contentLabel
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.contentLabel = null;

                        /**
                         * CampaignCriterion carrier.
                         * @member {google.ads.googleads.v1.common.ICarrierInfo|null|undefined} carrier
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.carrier = null;

                        /**
                         * CampaignCriterion userInterest.
                         * @member {google.ads.googleads.v1.common.IUserInterestInfo|null|undefined} userInterest
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.userInterest = null;

                        /**
                         * CampaignCriterion webpage.
                         * @member {google.ads.googleads.v1.common.IWebpageInfo|null|undefined} webpage
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.webpage = null;

                        /**
                         * CampaignCriterion operatingSystemVersion.
                         * @member {google.ads.googleads.v1.common.IOperatingSystemVersionInfo|null|undefined} operatingSystemVersion
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.operatingSystemVersion = null;

                        /**
                         * CampaignCriterion mobileDevice.
                         * @member {google.ads.googleads.v1.common.IMobileDeviceInfo|null|undefined} mobileDevice
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.mobileDevice = null;

                        /**
                         * CampaignCriterion locationGroup.
                         * @member {google.ads.googleads.v1.common.ILocationGroupInfo|null|undefined} locationGroup
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        CampaignCriterion.prototype.locationGroup = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CampaignCriterion criterion.
                         * @member {"keyword"|"placement"|"mobileAppCategory"|"mobileApplication"|"location"|"device"|"adSchedule"|"ageRange"|"gender"|"incomeRange"|"parentalStatus"|"userList"|"youtubeVideo"|"youtubeChannel"|"proximity"|"topic"|"listingScope"|"language"|"ipBlock"|"contentLabel"|"carrier"|"userInterest"|"webpage"|"operatingSystemVersion"|"mobileDevice"|"locationGroup"|undefined} criterion
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         */
                        Object.defineProperty(CampaignCriterion.prototype, "criterion", {
                            get: $util.oneOfGetter($oneOfFields = ["keyword", "placement", "mobileAppCategory", "mobileApplication", "location", "device", "adSchedule", "ageRange", "gender", "incomeRange", "parentalStatus", "userList", "youtubeVideo", "youtubeChannel", "proximity", "topic", "listingScope", "language", "ipBlock", "contentLabel", "carrier", "userInterest", "webpage", "operatingSystemVersion", "mobileDevice", "locationGroup"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CampaignCriterion instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignCriterion=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CampaignCriterion} CampaignCriterion instance
                         */
                        CampaignCriterion.create = function create(properties) {
                            return new CampaignCriterion(properties);
                        };

                        /**
                         * Encodes the specified CampaignCriterion message. Does not implicitly {@link google.ads.googleads.v1.resources.CampaignCriterion.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignCriterion} message CampaignCriterion message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignCriterion.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                $root.google.protobuf.StringValue.encode(message.campaign, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.criterionId != null && message.hasOwnProperty("criterionId"))
                                $root.google.protobuf.Int64Value.encode(message.criterionId, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.type);
                            if (message.negative != null && message.hasOwnProperty("negative"))
                                $root.google.protobuf.BoolValue.encode(message.negative, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.keyword != null && message.hasOwnProperty("keyword"))
                                $root.google.ads.googleads.v1.common.KeywordInfo.encode(message.keyword, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.placement != null && message.hasOwnProperty("placement"))
                                $root.google.ads.googleads.v1.common.PlacementInfo.encode(message.placement, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.mobileAppCategory != null && message.hasOwnProperty("mobileAppCategory"))
                                $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.encode(message.mobileAppCategory, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.mobileApplication != null && message.hasOwnProperty("mobileApplication"))
                                $root.google.ads.googleads.v1.common.MobileApplicationInfo.encode(message.mobileApplication, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.location != null && message.hasOwnProperty("location"))
                                $root.google.ads.googleads.v1.common.LocationInfo.encode(message.location, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.device != null && message.hasOwnProperty("device"))
                                $root.google.ads.googleads.v1.common.DeviceInfo.encode(message.device, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                            if (message.bidModifier != null && message.hasOwnProperty("bidModifier"))
                                $root.google.protobuf.FloatValue.encode(message.bidModifier, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.adSchedule != null && message.hasOwnProperty("adSchedule"))
                                $root.google.ads.googleads.v1.common.AdScheduleInfo.encode(message.adSchedule, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
                            if (message.ageRange != null && message.hasOwnProperty("ageRange"))
                                $root.google.ads.googleads.v1.common.AgeRangeInfo.encode(message.ageRange, writer.uint32(/* id 16, wireType 2 =*/130).fork()).ldelim();
                            if (message.gender != null && message.hasOwnProperty("gender"))
                                $root.google.ads.googleads.v1.common.GenderInfo.encode(message.gender, writer.uint32(/* id 17, wireType 2 =*/138).fork()).ldelim();
                            if (message.incomeRange != null && message.hasOwnProperty("incomeRange"))
                                $root.google.ads.googleads.v1.common.IncomeRangeInfo.encode(message.incomeRange, writer.uint32(/* id 18, wireType 2 =*/146).fork()).ldelim();
                            if (message.parentalStatus != null && message.hasOwnProperty("parentalStatus"))
                                $root.google.ads.googleads.v1.common.ParentalStatusInfo.encode(message.parentalStatus, writer.uint32(/* id 19, wireType 2 =*/154).fork()).ldelim();
                            if (message.youtubeVideo != null && message.hasOwnProperty("youtubeVideo"))
                                $root.google.ads.googleads.v1.common.YouTubeVideoInfo.encode(message.youtubeVideo, writer.uint32(/* id 20, wireType 2 =*/162).fork()).ldelim();
                            if (message.youtubeChannel != null && message.hasOwnProperty("youtubeChannel"))
                                $root.google.ads.googleads.v1.common.YouTubeChannelInfo.encode(message.youtubeChannel, writer.uint32(/* id 21, wireType 2 =*/170).fork()).ldelim();
                            if (message.userList != null && message.hasOwnProperty("userList"))
                                $root.google.ads.googleads.v1.common.UserListInfo.encode(message.userList, writer.uint32(/* id 22, wireType 2 =*/178).fork()).ldelim();
                            if (message.proximity != null && message.hasOwnProperty("proximity"))
                                $root.google.ads.googleads.v1.common.ProximityInfo.encode(message.proximity, writer.uint32(/* id 23, wireType 2 =*/186).fork()).ldelim();
                            if (message.topic != null && message.hasOwnProperty("topic"))
                                $root.google.ads.googleads.v1.common.TopicInfo.encode(message.topic, writer.uint32(/* id 24, wireType 2 =*/194).fork()).ldelim();
                            if (message.listingScope != null && message.hasOwnProperty("listingScope"))
                                $root.google.ads.googleads.v1.common.ListingScopeInfo.encode(message.listingScope, writer.uint32(/* id 25, wireType 2 =*/202).fork()).ldelim();
                            if (message.language != null && message.hasOwnProperty("language"))
                                $root.google.ads.googleads.v1.common.LanguageInfo.encode(message.language, writer.uint32(/* id 26, wireType 2 =*/210).fork()).ldelim();
                            if (message.ipBlock != null && message.hasOwnProperty("ipBlock"))
                                $root.google.ads.googleads.v1.common.IpBlockInfo.encode(message.ipBlock, writer.uint32(/* id 27, wireType 2 =*/218).fork()).ldelim();
                            if (message.contentLabel != null && message.hasOwnProperty("contentLabel"))
                                $root.google.ads.googleads.v1.common.ContentLabelInfo.encode(message.contentLabel, writer.uint32(/* id 28, wireType 2 =*/226).fork()).ldelim();
                            if (message.carrier != null && message.hasOwnProperty("carrier"))
                                $root.google.ads.googleads.v1.common.CarrierInfo.encode(message.carrier, writer.uint32(/* id 29, wireType 2 =*/234).fork()).ldelim();
                            if (message.userInterest != null && message.hasOwnProperty("userInterest"))
                                $root.google.ads.googleads.v1.common.UserInterestInfo.encode(message.userInterest, writer.uint32(/* id 30, wireType 2 =*/242).fork()).ldelim();
                            if (message.webpage != null && message.hasOwnProperty("webpage"))
                                $root.google.ads.googleads.v1.common.WebpageInfo.encode(message.webpage, writer.uint32(/* id 31, wireType 2 =*/250).fork()).ldelim();
                            if (message.operatingSystemVersion != null && message.hasOwnProperty("operatingSystemVersion"))
                                $root.google.ads.googleads.v1.common.OperatingSystemVersionInfo.encode(message.operatingSystemVersion, writer.uint32(/* id 32, wireType 2 =*/258).fork()).ldelim();
                            if (message.mobileDevice != null && message.hasOwnProperty("mobileDevice"))
                                $root.google.ads.googleads.v1.common.MobileDeviceInfo.encode(message.mobileDevice, writer.uint32(/* id 33, wireType 2 =*/266).fork()).ldelim();
                            if (message.locationGroup != null && message.hasOwnProperty("locationGroup"))
                                $root.google.ads.googleads.v1.common.LocationGroupInfo.encode(message.locationGroup, writer.uint32(/* id 34, wireType 2 =*/274).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignCriterion message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CampaignCriterion.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignCriterion} message CampaignCriterion message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignCriterion.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignCriterion message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CampaignCriterion} CampaignCriterion
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignCriterion.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CampaignCriterion();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 4:
                                    message.campaign = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.criterionId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 14:
                                    message.bidModifier = $root.google.protobuf.FloatValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.negative = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.type = reader.int32();
                                    break;
                                case 8:
                                    message.keyword = $root.google.ads.googleads.v1.common.KeywordInfo.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.placement = $root.google.ads.googleads.v1.common.PlacementInfo.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.mobileAppCategory = $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.mobileApplication = $root.google.ads.googleads.v1.common.MobileApplicationInfo.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.location = $root.google.ads.googleads.v1.common.LocationInfo.decode(reader, reader.uint32());
                                    break;
                                case 13:
                                    message.device = $root.google.ads.googleads.v1.common.DeviceInfo.decode(reader, reader.uint32());
                                    break;
                                case 15:
                                    message.adSchedule = $root.google.ads.googleads.v1.common.AdScheduleInfo.decode(reader, reader.uint32());
                                    break;
                                case 16:
                                    message.ageRange = $root.google.ads.googleads.v1.common.AgeRangeInfo.decode(reader, reader.uint32());
                                    break;
                                case 17:
                                    message.gender = $root.google.ads.googleads.v1.common.GenderInfo.decode(reader, reader.uint32());
                                    break;
                                case 18:
                                    message.incomeRange = $root.google.ads.googleads.v1.common.IncomeRangeInfo.decode(reader, reader.uint32());
                                    break;
                                case 19:
                                    message.parentalStatus = $root.google.ads.googleads.v1.common.ParentalStatusInfo.decode(reader, reader.uint32());
                                    break;
                                case 22:
                                    message.userList = $root.google.ads.googleads.v1.common.UserListInfo.decode(reader, reader.uint32());
                                    break;
                                case 20:
                                    message.youtubeVideo = $root.google.ads.googleads.v1.common.YouTubeVideoInfo.decode(reader, reader.uint32());
                                    break;
                                case 21:
                                    message.youtubeChannel = $root.google.ads.googleads.v1.common.YouTubeChannelInfo.decode(reader, reader.uint32());
                                    break;
                                case 23:
                                    message.proximity = $root.google.ads.googleads.v1.common.ProximityInfo.decode(reader, reader.uint32());
                                    break;
                                case 24:
                                    message.topic = $root.google.ads.googleads.v1.common.TopicInfo.decode(reader, reader.uint32());
                                    break;
                                case 25:
                                    message.listingScope = $root.google.ads.googleads.v1.common.ListingScopeInfo.decode(reader, reader.uint32());
                                    break;
                                case 26:
                                    message.language = $root.google.ads.googleads.v1.common.LanguageInfo.decode(reader, reader.uint32());
                                    break;
                                case 27:
                                    message.ipBlock = $root.google.ads.googleads.v1.common.IpBlockInfo.decode(reader, reader.uint32());
                                    break;
                                case 28:
                                    message.contentLabel = $root.google.ads.googleads.v1.common.ContentLabelInfo.decode(reader, reader.uint32());
                                    break;
                                case 29:
                                    message.carrier = $root.google.ads.googleads.v1.common.CarrierInfo.decode(reader, reader.uint32());
                                    break;
                                case 30:
                                    message.userInterest = $root.google.ads.googleads.v1.common.UserInterestInfo.decode(reader, reader.uint32());
                                    break;
                                case 31:
                                    message.webpage = $root.google.ads.googleads.v1.common.WebpageInfo.decode(reader, reader.uint32());
                                    break;
                                case 32:
                                    message.operatingSystemVersion = $root.google.ads.googleads.v1.common.OperatingSystemVersionInfo.decode(reader, reader.uint32());
                                    break;
                                case 33:
                                    message.mobileDevice = $root.google.ads.googleads.v1.common.MobileDeviceInfo.decode(reader, reader.uint32());
                                    break;
                                case 34:
                                    message.locationGroup = $root.google.ads.googleads.v1.common.LocationGroupInfo.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignCriterion message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CampaignCriterion} CampaignCriterion
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignCriterion.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignCriterion message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignCriterion.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.campaign != null && message.hasOwnProperty("campaign")) {
                                var error = $root.google.protobuf.StringValue.verify(message.campaign);
                                if (error)
                                    return "campaign." + error;
                            }
                            if (message.criterionId != null && message.hasOwnProperty("criterionId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.criterionId);
                                if (error)
                                    return "criterionId." + error;
                            }
                            if (message.bidModifier != null && message.hasOwnProperty("bidModifier")) {
                                var error = $root.google.protobuf.FloatValue.verify(message.bidModifier);
                                if (error)
                                    return "bidModifier." + error;
                            }
                            if (message.negative != null && message.hasOwnProperty("negative")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.negative);
                                if (error)
                                    return "negative." + error;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                    break;
                                }
                            if (message.keyword != null && message.hasOwnProperty("keyword")) {
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.KeywordInfo.verify(message.keyword);
                                    if (error)
                                        return "keyword." + error;
                                }
                            }
                            if (message.placement != null && message.hasOwnProperty("placement")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.PlacementInfo.verify(message.placement);
                                    if (error)
                                        return "placement." + error;
                                }
                            }
                            if (message.mobileAppCategory != null && message.hasOwnProperty("mobileAppCategory")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.verify(message.mobileAppCategory);
                                    if (error)
                                        return "mobileAppCategory." + error;
                                }
                            }
                            if (message.mobileApplication != null && message.hasOwnProperty("mobileApplication")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.MobileApplicationInfo.verify(message.mobileApplication);
                                    if (error)
                                        return "mobileApplication." + error;
                                }
                            }
                            if (message.location != null && message.hasOwnProperty("location")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.LocationInfo.verify(message.location);
                                    if (error)
                                        return "location." + error;
                                }
                            }
                            if (message.device != null && message.hasOwnProperty("device")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.DeviceInfo.verify(message.device);
                                    if (error)
                                        return "device." + error;
                                }
                            }
                            if (message.adSchedule != null && message.hasOwnProperty("adSchedule")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.AdScheduleInfo.verify(message.adSchedule);
                                    if (error)
                                        return "adSchedule." + error;
                                }
                            }
                            if (message.ageRange != null && message.hasOwnProperty("ageRange")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.AgeRangeInfo.verify(message.ageRange);
                                    if (error)
                                        return "ageRange." + error;
                                }
                            }
                            if (message.gender != null && message.hasOwnProperty("gender")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.GenderInfo.verify(message.gender);
                                    if (error)
                                        return "gender." + error;
                                }
                            }
                            if (message.incomeRange != null && message.hasOwnProperty("incomeRange")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.IncomeRangeInfo.verify(message.incomeRange);
                                    if (error)
                                        return "incomeRange." + error;
                                }
                            }
                            if (message.parentalStatus != null && message.hasOwnProperty("parentalStatus")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ParentalStatusInfo.verify(message.parentalStatus);
                                    if (error)
                                        return "parentalStatus." + error;
                                }
                            }
                            if (message.userList != null && message.hasOwnProperty("userList")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.UserListInfo.verify(message.userList);
                                    if (error)
                                        return "userList." + error;
                                }
                            }
                            if (message.youtubeVideo != null && message.hasOwnProperty("youtubeVideo")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.YouTubeVideoInfo.verify(message.youtubeVideo);
                                    if (error)
                                        return "youtubeVideo." + error;
                                }
                            }
                            if (message.youtubeChannel != null && message.hasOwnProperty("youtubeChannel")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.YouTubeChannelInfo.verify(message.youtubeChannel);
                                    if (error)
                                        return "youtubeChannel." + error;
                                }
                            }
                            if (message.proximity != null && message.hasOwnProperty("proximity")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ProximityInfo.verify(message.proximity);
                                    if (error)
                                        return "proximity." + error;
                                }
                            }
                            if (message.topic != null && message.hasOwnProperty("topic")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.TopicInfo.verify(message.topic);
                                    if (error)
                                        return "topic." + error;
                                }
                            }
                            if (message.listingScope != null && message.hasOwnProperty("listingScope")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ListingScopeInfo.verify(message.listingScope);
                                    if (error)
                                        return "listingScope." + error;
                                }
                            }
                            if (message.language != null && message.hasOwnProperty("language")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.LanguageInfo.verify(message.language);
                                    if (error)
                                        return "language." + error;
                                }
                            }
                            if (message.ipBlock != null && message.hasOwnProperty("ipBlock")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.IpBlockInfo.verify(message.ipBlock);
                                    if (error)
                                        return "ipBlock." + error;
                                }
                            }
                            if (message.contentLabel != null && message.hasOwnProperty("contentLabel")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ContentLabelInfo.verify(message.contentLabel);
                                    if (error)
                                        return "contentLabel." + error;
                                }
                            }
                            if (message.carrier != null && message.hasOwnProperty("carrier")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.CarrierInfo.verify(message.carrier);
                                    if (error)
                                        return "carrier." + error;
                                }
                            }
                            if (message.userInterest != null && message.hasOwnProperty("userInterest")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.UserInterestInfo.verify(message.userInterest);
                                    if (error)
                                        return "userInterest." + error;
                                }
                            }
                            if (message.webpage != null && message.hasOwnProperty("webpage")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.WebpageInfo.verify(message.webpage);
                                    if (error)
                                        return "webpage." + error;
                                }
                            }
                            if (message.operatingSystemVersion != null && message.hasOwnProperty("operatingSystemVersion")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.OperatingSystemVersionInfo.verify(message.operatingSystemVersion);
                                    if (error)
                                        return "operatingSystemVersion." + error;
                                }
                            }
                            if (message.mobileDevice != null && message.hasOwnProperty("mobileDevice")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.MobileDeviceInfo.verify(message.mobileDevice);
                                    if (error)
                                        return "mobileDevice." + error;
                                }
                            }
                            if (message.locationGroup != null && message.hasOwnProperty("locationGroup")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.LocationGroupInfo.verify(message.locationGroup);
                                    if (error)
                                        return "locationGroup." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a CampaignCriterion message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CampaignCriterion} CampaignCriterion
                         */
                        CampaignCriterion.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CampaignCriterion)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CampaignCriterion();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.campaign != null) {
                                if (typeof object.campaign !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.campaign: object expected");
                                message.campaign = $root.google.protobuf.StringValue.fromObject(object.campaign);
                            }
                            if (object.criterionId != null) {
                                if (typeof object.criterionId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.criterionId: object expected");
                                message.criterionId = $root.google.protobuf.Int64Value.fromObject(object.criterionId);
                            }
                            if (object.bidModifier != null) {
                                if (typeof object.bidModifier !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.bidModifier: object expected");
                                message.bidModifier = $root.google.protobuf.FloatValue.fromObject(object.bidModifier);
                            }
                            if (object.negative != null) {
                                if (typeof object.negative !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.negative: object expected");
                                message.negative = $root.google.protobuf.BoolValue.fromObject(object.negative);
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "KEYWORD":
                            case 2:
                                message.type = 2;
                                break;
                            case "PLACEMENT":
                            case 3:
                                message.type = 3;
                                break;
                            case "MOBILE_APP_CATEGORY":
                            case 4:
                                message.type = 4;
                                break;
                            case "MOBILE_APPLICATION":
                            case 5:
                                message.type = 5;
                                break;
                            case "DEVICE":
                            case 6:
                                message.type = 6;
                                break;
                            case "LOCATION":
                            case 7:
                                message.type = 7;
                                break;
                            case "LISTING_GROUP":
                            case 8:
                                message.type = 8;
                                break;
                            case "AD_SCHEDULE":
                            case 9:
                                message.type = 9;
                                break;
                            case "AGE_RANGE":
                            case 10:
                                message.type = 10;
                                break;
                            case "GENDER":
                            case 11:
                                message.type = 11;
                                break;
                            case "INCOME_RANGE":
                            case 12:
                                message.type = 12;
                                break;
                            case "PARENTAL_STATUS":
                            case 13:
                                message.type = 13;
                                break;
                            case "YOUTUBE_VIDEO":
                            case 14:
                                message.type = 14;
                                break;
                            case "YOUTUBE_CHANNEL":
                            case 15:
                                message.type = 15;
                                break;
                            case "USER_LIST":
                            case 16:
                                message.type = 16;
                                break;
                            case "PROXIMITY":
                            case 17:
                                message.type = 17;
                                break;
                            case "TOPIC":
                            case 18:
                                message.type = 18;
                                break;
                            case "LISTING_SCOPE":
                            case 19:
                                message.type = 19;
                                break;
                            case "LANGUAGE":
                            case 20:
                                message.type = 20;
                                break;
                            case "IP_BLOCK":
                            case 21:
                                message.type = 21;
                                break;
                            case "CONTENT_LABEL":
                            case 22:
                                message.type = 22;
                                break;
                            case "CARRIER":
                            case 23:
                                message.type = 23;
                                break;
                            case "USER_INTEREST":
                            case 24:
                                message.type = 24;
                                break;
                            case "WEBPAGE":
                            case 25:
                                message.type = 25;
                                break;
                            case "OPERATING_SYSTEM_VERSION":
                            case 26:
                                message.type = 26;
                                break;
                            case "APP_PAYMENT_MODEL":
                            case 27:
                                message.type = 27;
                                break;
                            case "MOBILE_DEVICE":
                            case 28:
                                message.type = 28;
                                break;
                            case "CUSTOM_AFFINITY":
                            case 29:
                                message.type = 29;
                                break;
                            case "CUSTOM_INTENT":
                            case 30:
                                message.type = 30;
                                break;
                            case "LOCATION_GROUP":
                            case 31:
                                message.type = 31;
                                break;
                            }
                            if (object.keyword != null) {
                                if (typeof object.keyword !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.keyword: object expected");
                                message.keyword = $root.google.ads.googleads.v1.common.KeywordInfo.fromObject(object.keyword);
                            }
                            if (object.placement != null) {
                                if (typeof object.placement !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.placement: object expected");
                                message.placement = $root.google.ads.googleads.v1.common.PlacementInfo.fromObject(object.placement);
                            }
                            if (object.mobileAppCategory != null) {
                                if (typeof object.mobileAppCategory !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.mobileAppCategory: object expected");
                                message.mobileAppCategory = $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.fromObject(object.mobileAppCategory);
                            }
                            if (object.mobileApplication != null) {
                                if (typeof object.mobileApplication !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.mobileApplication: object expected");
                                message.mobileApplication = $root.google.ads.googleads.v1.common.MobileApplicationInfo.fromObject(object.mobileApplication);
                            }
                            if (object.location != null) {
                                if (typeof object.location !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.location: object expected");
                                message.location = $root.google.ads.googleads.v1.common.LocationInfo.fromObject(object.location);
                            }
                            if (object.device != null) {
                                if (typeof object.device !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.device: object expected");
                                message.device = $root.google.ads.googleads.v1.common.DeviceInfo.fromObject(object.device);
                            }
                            if (object.adSchedule != null) {
                                if (typeof object.adSchedule !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.adSchedule: object expected");
                                message.adSchedule = $root.google.ads.googleads.v1.common.AdScheduleInfo.fromObject(object.adSchedule);
                            }
                            if (object.ageRange != null) {
                                if (typeof object.ageRange !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.ageRange: object expected");
                                message.ageRange = $root.google.ads.googleads.v1.common.AgeRangeInfo.fromObject(object.ageRange);
                            }
                            if (object.gender != null) {
                                if (typeof object.gender !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.gender: object expected");
                                message.gender = $root.google.ads.googleads.v1.common.GenderInfo.fromObject(object.gender);
                            }
                            if (object.incomeRange != null) {
                                if (typeof object.incomeRange !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.incomeRange: object expected");
                                message.incomeRange = $root.google.ads.googleads.v1.common.IncomeRangeInfo.fromObject(object.incomeRange);
                            }
                            if (object.parentalStatus != null) {
                                if (typeof object.parentalStatus !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.parentalStatus: object expected");
                                message.parentalStatus = $root.google.ads.googleads.v1.common.ParentalStatusInfo.fromObject(object.parentalStatus);
                            }
                            if (object.userList != null) {
                                if (typeof object.userList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.userList: object expected");
                                message.userList = $root.google.ads.googleads.v1.common.UserListInfo.fromObject(object.userList);
                            }
                            if (object.youtubeVideo != null) {
                                if (typeof object.youtubeVideo !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.youtubeVideo: object expected");
                                message.youtubeVideo = $root.google.ads.googleads.v1.common.YouTubeVideoInfo.fromObject(object.youtubeVideo);
                            }
                            if (object.youtubeChannel != null) {
                                if (typeof object.youtubeChannel !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.youtubeChannel: object expected");
                                message.youtubeChannel = $root.google.ads.googleads.v1.common.YouTubeChannelInfo.fromObject(object.youtubeChannel);
                            }
                            if (object.proximity != null) {
                                if (typeof object.proximity !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.proximity: object expected");
                                message.proximity = $root.google.ads.googleads.v1.common.ProximityInfo.fromObject(object.proximity);
                            }
                            if (object.topic != null) {
                                if (typeof object.topic !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.topic: object expected");
                                message.topic = $root.google.ads.googleads.v1.common.TopicInfo.fromObject(object.topic);
                            }
                            if (object.listingScope != null) {
                                if (typeof object.listingScope !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.listingScope: object expected");
                                message.listingScope = $root.google.ads.googleads.v1.common.ListingScopeInfo.fromObject(object.listingScope);
                            }
                            if (object.language != null) {
                                if (typeof object.language !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.language: object expected");
                                message.language = $root.google.ads.googleads.v1.common.LanguageInfo.fromObject(object.language);
                            }
                            if (object.ipBlock != null) {
                                if (typeof object.ipBlock !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.ipBlock: object expected");
                                message.ipBlock = $root.google.ads.googleads.v1.common.IpBlockInfo.fromObject(object.ipBlock);
                            }
                            if (object.contentLabel != null) {
                                if (typeof object.contentLabel !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.contentLabel: object expected");
                                message.contentLabel = $root.google.ads.googleads.v1.common.ContentLabelInfo.fromObject(object.contentLabel);
                            }
                            if (object.carrier != null) {
                                if (typeof object.carrier !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.carrier: object expected");
                                message.carrier = $root.google.ads.googleads.v1.common.CarrierInfo.fromObject(object.carrier);
                            }
                            if (object.userInterest != null) {
                                if (typeof object.userInterest !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.userInterest: object expected");
                                message.userInterest = $root.google.ads.googleads.v1.common.UserInterestInfo.fromObject(object.userInterest);
                            }
                            if (object.webpage != null) {
                                if (typeof object.webpage !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.webpage: object expected");
                                message.webpage = $root.google.ads.googleads.v1.common.WebpageInfo.fromObject(object.webpage);
                            }
                            if (object.operatingSystemVersion != null) {
                                if (typeof object.operatingSystemVersion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.operatingSystemVersion: object expected");
                                message.operatingSystemVersion = $root.google.ads.googleads.v1.common.OperatingSystemVersionInfo.fromObject(object.operatingSystemVersion);
                            }
                            if (object.mobileDevice != null) {
                                if (typeof object.mobileDevice !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.mobileDevice: object expected");
                                message.mobileDevice = $root.google.ads.googleads.v1.common.MobileDeviceInfo.fromObject(object.mobileDevice);
                            }
                            if (object.locationGroup != null) {
                                if (typeof object.locationGroup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterion.locationGroup: object expected");
                                message.locationGroup = $root.google.ads.googleads.v1.common.LocationGroupInfo.fromObject(object.locationGroup);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CampaignCriterion message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @static
                         * @param {google.ads.googleads.v1.resources.CampaignCriterion} message CampaignCriterion
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignCriterion.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.campaign = null;
                                object.criterionId = null;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.negative = null;
                                object.bidModifier = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                object.campaign = $root.google.protobuf.StringValue.toObject(message.campaign, options);
                            if (message.criterionId != null && message.hasOwnProperty("criterionId"))
                                object.criterionId = $root.google.protobuf.Int64Value.toObject(message.criterionId, options);
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.CriterionTypeEnum.CriterionType[message.type] : message.type;
                            if (message.negative != null && message.hasOwnProperty("negative"))
                                object.negative = $root.google.protobuf.BoolValue.toObject(message.negative, options);
                            if (message.keyword != null && message.hasOwnProperty("keyword")) {
                                object.keyword = $root.google.ads.googleads.v1.common.KeywordInfo.toObject(message.keyword, options);
                                if (options.oneofs)
                                    object.criterion = "keyword";
                            }
                            if (message.placement != null && message.hasOwnProperty("placement")) {
                                object.placement = $root.google.ads.googleads.v1.common.PlacementInfo.toObject(message.placement, options);
                                if (options.oneofs)
                                    object.criterion = "placement";
                            }
                            if (message.mobileAppCategory != null && message.hasOwnProperty("mobileAppCategory")) {
                                object.mobileAppCategory = $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.toObject(message.mobileAppCategory, options);
                                if (options.oneofs)
                                    object.criterion = "mobileAppCategory";
                            }
                            if (message.mobileApplication != null && message.hasOwnProperty("mobileApplication")) {
                                object.mobileApplication = $root.google.ads.googleads.v1.common.MobileApplicationInfo.toObject(message.mobileApplication, options);
                                if (options.oneofs)
                                    object.criterion = "mobileApplication";
                            }
                            if (message.location != null && message.hasOwnProperty("location")) {
                                object.location = $root.google.ads.googleads.v1.common.LocationInfo.toObject(message.location, options);
                                if (options.oneofs)
                                    object.criterion = "location";
                            }
                            if (message.device != null && message.hasOwnProperty("device")) {
                                object.device = $root.google.ads.googleads.v1.common.DeviceInfo.toObject(message.device, options);
                                if (options.oneofs)
                                    object.criterion = "device";
                            }
                            if (message.bidModifier != null && message.hasOwnProperty("bidModifier"))
                                object.bidModifier = $root.google.protobuf.FloatValue.toObject(message.bidModifier, options);
                            if (message.adSchedule != null && message.hasOwnProperty("adSchedule")) {
                                object.adSchedule = $root.google.ads.googleads.v1.common.AdScheduleInfo.toObject(message.adSchedule, options);
                                if (options.oneofs)
                                    object.criterion = "adSchedule";
                            }
                            if (message.ageRange != null && message.hasOwnProperty("ageRange")) {
                                object.ageRange = $root.google.ads.googleads.v1.common.AgeRangeInfo.toObject(message.ageRange, options);
                                if (options.oneofs)
                                    object.criterion = "ageRange";
                            }
                            if (message.gender != null && message.hasOwnProperty("gender")) {
                                object.gender = $root.google.ads.googleads.v1.common.GenderInfo.toObject(message.gender, options);
                                if (options.oneofs)
                                    object.criterion = "gender";
                            }
                            if (message.incomeRange != null && message.hasOwnProperty("incomeRange")) {
                                object.incomeRange = $root.google.ads.googleads.v1.common.IncomeRangeInfo.toObject(message.incomeRange, options);
                                if (options.oneofs)
                                    object.criterion = "incomeRange";
                            }
                            if (message.parentalStatus != null && message.hasOwnProperty("parentalStatus")) {
                                object.parentalStatus = $root.google.ads.googleads.v1.common.ParentalStatusInfo.toObject(message.parentalStatus, options);
                                if (options.oneofs)
                                    object.criterion = "parentalStatus";
                            }
                            if (message.youtubeVideo != null && message.hasOwnProperty("youtubeVideo")) {
                                object.youtubeVideo = $root.google.ads.googleads.v1.common.YouTubeVideoInfo.toObject(message.youtubeVideo, options);
                                if (options.oneofs)
                                    object.criterion = "youtubeVideo";
                            }
                            if (message.youtubeChannel != null && message.hasOwnProperty("youtubeChannel")) {
                                object.youtubeChannel = $root.google.ads.googleads.v1.common.YouTubeChannelInfo.toObject(message.youtubeChannel, options);
                                if (options.oneofs)
                                    object.criterion = "youtubeChannel";
                            }
                            if (message.userList != null && message.hasOwnProperty("userList")) {
                                object.userList = $root.google.ads.googleads.v1.common.UserListInfo.toObject(message.userList, options);
                                if (options.oneofs)
                                    object.criterion = "userList";
                            }
                            if (message.proximity != null && message.hasOwnProperty("proximity")) {
                                object.proximity = $root.google.ads.googleads.v1.common.ProximityInfo.toObject(message.proximity, options);
                                if (options.oneofs)
                                    object.criterion = "proximity";
                            }
                            if (message.topic != null && message.hasOwnProperty("topic")) {
                                object.topic = $root.google.ads.googleads.v1.common.TopicInfo.toObject(message.topic, options);
                                if (options.oneofs)
                                    object.criterion = "topic";
                            }
                            if (message.listingScope != null && message.hasOwnProperty("listingScope")) {
                                object.listingScope = $root.google.ads.googleads.v1.common.ListingScopeInfo.toObject(message.listingScope, options);
                                if (options.oneofs)
                                    object.criterion = "listingScope";
                            }
                            if (message.language != null && message.hasOwnProperty("language")) {
                                object.language = $root.google.ads.googleads.v1.common.LanguageInfo.toObject(message.language, options);
                                if (options.oneofs)
                                    object.criterion = "language";
                            }
                            if (message.ipBlock != null && message.hasOwnProperty("ipBlock")) {
                                object.ipBlock = $root.google.ads.googleads.v1.common.IpBlockInfo.toObject(message.ipBlock, options);
                                if (options.oneofs)
                                    object.criterion = "ipBlock";
                            }
                            if (message.contentLabel != null && message.hasOwnProperty("contentLabel")) {
                                object.contentLabel = $root.google.ads.googleads.v1.common.ContentLabelInfo.toObject(message.contentLabel, options);
                                if (options.oneofs)
                                    object.criterion = "contentLabel";
                            }
                            if (message.carrier != null && message.hasOwnProperty("carrier")) {
                                object.carrier = $root.google.ads.googleads.v1.common.CarrierInfo.toObject(message.carrier, options);
                                if (options.oneofs)
                                    object.criterion = "carrier";
                            }
                            if (message.userInterest != null && message.hasOwnProperty("userInterest")) {
                                object.userInterest = $root.google.ads.googleads.v1.common.UserInterestInfo.toObject(message.userInterest, options);
                                if (options.oneofs)
                                    object.criterion = "userInterest";
                            }
                            if (message.webpage != null && message.hasOwnProperty("webpage")) {
                                object.webpage = $root.google.ads.googleads.v1.common.WebpageInfo.toObject(message.webpage, options);
                                if (options.oneofs)
                                    object.criterion = "webpage";
                            }
                            if (message.operatingSystemVersion != null && message.hasOwnProperty("operatingSystemVersion")) {
                                object.operatingSystemVersion = $root.google.ads.googleads.v1.common.OperatingSystemVersionInfo.toObject(message.operatingSystemVersion, options);
                                if (options.oneofs)
                                    object.criterion = "operatingSystemVersion";
                            }
                            if (message.mobileDevice != null && message.hasOwnProperty("mobileDevice")) {
                                object.mobileDevice = $root.google.ads.googleads.v1.common.MobileDeviceInfo.toObject(message.mobileDevice, options);
                                if (options.oneofs)
                                    object.criterion = "mobileDevice";
                            }
                            if (message.locationGroup != null && message.hasOwnProperty("locationGroup")) {
                                object.locationGroup = $root.google.ads.googleads.v1.common.LocationGroupInfo.toObject(message.locationGroup, options);
                                if (options.oneofs)
                                    object.criterion = "locationGroup";
                            }
                            return object;
                        };

                        /**
                         * Converts this CampaignCriterion to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterion
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignCriterion.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CampaignCriterion;
                    })();

                    resources.CampaignCriterionSimulation = (function() {

                        /**
                         * Properties of a CampaignCriterionSimulation.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICampaignCriterionSimulation
                         * @property {string|null} [resourceName] CampaignCriterionSimulation resourceName
                         * @property {google.protobuf.IInt64Value|null} [campaignId] CampaignCriterionSimulation campaignId
                         * @property {google.protobuf.IInt64Value|null} [criterionId] CampaignCriterionSimulation criterionId
                         * @property {google.ads.googleads.v1.enums.SimulationTypeEnum.SimulationType|null} [type] CampaignCriterionSimulation type
                         * @property {google.ads.googleads.v1.enums.SimulationModificationMethodEnum.SimulationModificationMethod|null} [modificationMethod] CampaignCriterionSimulation modificationMethod
                         * @property {google.protobuf.IStringValue|null} [startDate] CampaignCriterionSimulation startDate
                         * @property {google.protobuf.IStringValue|null} [endDate] CampaignCriterionSimulation endDate
                         * @property {google.ads.googleads.v1.common.IBidModifierSimulationPointList|null} [bidModifierPointList] CampaignCriterionSimulation bidModifierPointList
                         */

                        /**
                         * Constructs a new CampaignCriterionSimulation.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CampaignCriterionSimulation.
                         * @implements ICampaignCriterionSimulation
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICampaignCriterionSimulation=} [properties] Properties to set
                         */
                        function CampaignCriterionSimulation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CampaignCriterionSimulation resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterionSimulation
                         * @instance
                         */
                        CampaignCriterionSimulation.prototype.resourceName = "";

                        /**
                         * CampaignCriterionSimulation campaignId.
                         * @member {google.protobuf.IInt64Value|null|undefined} campaignId
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterionSimulation
                         * @instance
                         */
                        CampaignCriterionSimulation.prototype.campaignId = null;

                        /**
                         * CampaignCriterionSimulation criterionId.
                         * @member {google.protobuf.IInt64Value|null|undefined} criterionId
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterionSimulation
                         * @instance
                         */
                        CampaignCriterionSimulation.prototype.criterionId = null;

                        /**
                         * CampaignCriterionSimulation type.
                         * @member {google.ads.googleads.v1.enums.SimulationTypeEnum.SimulationType} type
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterionSimulation
                         * @instance
                         */
                        CampaignCriterionSimulation.prototype.type = 0;

                        /**
                         * CampaignCriterionSimulation modificationMethod.
                         * @member {google.ads.googleads.v1.enums.SimulationModificationMethodEnum.SimulationModificationMethod} modificationMethod
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterionSimulation
                         * @instance
                         */
                        CampaignCriterionSimulation.prototype.modificationMethod = 0;

                        /**
                         * CampaignCriterionSimulation startDate.
                         * @member {google.protobuf.IStringValue|null|undefined} startDate
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterionSimulation
                         * @instance
                         */
                        CampaignCriterionSimulation.prototype.startDate = null;

                        /**
                         * CampaignCriterionSimulation endDate.
                         * @member {google.protobuf.IStringValue|null|undefined} endDate
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterionSimulation
                         * @instance
                         */
                        CampaignCriterionSimulation.prototype.endDate = null;

                        /**
                         * CampaignCriterionSimulation bidModifierPointList.
                         * @member {google.ads.googleads.v1.common.IBidModifierSimulationPointList|null|undefined} bidModifierPointList
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterionSimulation
                         * @instance
                         */
                        CampaignCriterionSimulation.prototype.bidModifierPointList = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CampaignCriterionSimulation pointList.
                         * @member {"bidModifierPointList"|undefined} pointList
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterionSimulation
                         * @instance
                         */
                        Object.defineProperty(CampaignCriterionSimulation.prototype, "pointList", {
                            get: $util.oneOfGetter($oneOfFields = ["bidModifierPointList"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CampaignCriterionSimulation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterionSimulation
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignCriterionSimulation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CampaignCriterionSimulation} CampaignCriterionSimulation instance
                         */
                        CampaignCriterionSimulation.create = function create(properties) {
                            return new CampaignCriterionSimulation(properties);
                        };

                        /**
                         * Encodes the specified CampaignCriterionSimulation message. Does not implicitly {@link google.ads.googleads.v1.resources.CampaignCriterionSimulation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterionSimulation
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignCriterionSimulation} message CampaignCriterionSimulation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignCriterionSimulation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.campaignId != null && message.hasOwnProperty("campaignId"))
                                $root.google.protobuf.Int64Value.encode(message.campaignId, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.criterionId != null && message.hasOwnProperty("criterionId"))
                                $root.google.protobuf.Int64Value.encode(message.criterionId, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.type);
                            if (message.modificationMethod != null && message.hasOwnProperty("modificationMethod"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.modificationMethod);
                            if (message.startDate != null && message.hasOwnProperty("startDate"))
                                $root.google.protobuf.StringValue.encode(message.startDate, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.endDate != null && message.hasOwnProperty("endDate"))
                                $root.google.protobuf.StringValue.encode(message.endDate, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.bidModifierPointList != null && message.hasOwnProperty("bidModifierPointList"))
                                $root.google.ads.googleads.v1.common.BidModifierSimulationPointList.encode(message.bidModifierPointList, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignCriterionSimulation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CampaignCriterionSimulation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterionSimulation
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignCriterionSimulation} message CampaignCriterionSimulation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignCriterionSimulation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignCriterionSimulation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterionSimulation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CampaignCriterionSimulation} CampaignCriterionSimulation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignCriterionSimulation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CampaignCriterionSimulation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.campaignId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.criterionId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.type = reader.int32();
                                    break;
                                case 5:
                                    message.modificationMethod = reader.int32();
                                    break;
                                case 6:
                                    message.startDate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.endDate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.bidModifierPointList = $root.google.ads.googleads.v1.common.BidModifierSimulationPointList.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignCriterionSimulation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterionSimulation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CampaignCriterionSimulation} CampaignCriterionSimulation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignCriterionSimulation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignCriterionSimulation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterionSimulation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignCriterionSimulation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.campaignId != null && message.hasOwnProperty("campaignId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.campaignId);
                                if (error)
                                    return "campaignId." + error;
                            }
                            if (message.criterionId != null && message.hasOwnProperty("criterionId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.criterionId);
                                if (error)
                                    return "criterionId." + error;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            if (message.modificationMethod != null && message.hasOwnProperty("modificationMethod"))
                                switch (message.modificationMethod) {
                                default:
                                    return "modificationMethod: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.startDate != null && message.hasOwnProperty("startDate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.startDate);
                                if (error)
                                    return "startDate." + error;
                            }
                            if (message.endDate != null && message.hasOwnProperty("endDate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.endDate);
                                if (error)
                                    return "endDate." + error;
                            }
                            if (message.bidModifierPointList != null && message.hasOwnProperty("bidModifierPointList")) {
                                properties.pointList = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.BidModifierSimulationPointList.verify(message.bidModifierPointList);
                                    if (error)
                                        return "bidModifierPointList." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a CampaignCriterionSimulation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterionSimulation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CampaignCriterionSimulation} CampaignCriterionSimulation
                         */
                        CampaignCriterionSimulation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CampaignCriterionSimulation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CampaignCriterionSimulation();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.campaignId != null) {
                                if (typeof object.campaignId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterionSimulation.campaignId: object expected");
                                message.campaignId = $root.google.protobuf.Int64Value.fromObject(object.campaignId);
                            }
                            if (object.criterionId != null) {
                                if (typeof object.criterionId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterionSimulation.criterionId: object expected");
                                message.criterionId = $root.google.protobuf.Int64Value.fromObject(object.criterionId);
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "CPC_BID":
                            case 2:
                                message.type = 2;
                                break;
                            case "CPV_BID":
                            case 3:
                                message.type = 3;
                                break;
                            case "TARGET_CPA":
                            case 4:
                                message.type = 4;
                                break;
                            case "BID_MODIFIER":
                            case 5:
                                message.type = 5;
                                break;
                            }
                            switch (object.modificationMethod) {
                            case "UNSPECIFIED":
                            case 0:
                                message.modificationMethod = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.modificationMethod = 1;
                                break;
                            case "UNIFORM":
                            case 2:
                                message.modificationMethod = 2;
                                break;
                            case "DEFAULT":
                            case 3:
                                message.modificationMethod = 3;
                                break;
                            }
                            if (object.startDate != null) {
                                if (typeof object.startDate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterionSimulation.startDate: object expected");
                                message.startDate = $root.google.protobuf.StringValue.fromObject(object.startDate);
                            }
                            if (object.endDate != null) {
                                if (typeof object.endDate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterionSimulation.endDate: object expected");
                                message.endDate = $root.google.protobuf.StringValue.fromObject(object.endDate);
                            }
                            if (object.bidModifierPointList != null) {
                                if (typeof object.bidModifierPointList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignCriterionSimulation.bidModifierPointList: object expected");
                                message.bidModifierPointList = $root.google.ads.googleads.v1.common.BidModifierSimulationPointList.fromObject(object.bidModifierPointList);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CampaignCriterionSimulation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterionSimulation
                         * @static
                         * @param {google.ads.googleads.v1.resources.CampaignCriterionSimulation} message CampaignCriterionSimulation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignCriterionSimulation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.campaignId = null;
                                object.criterionId = null;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.modificationMethod = options.enums === String ? "UNSPECIFIED" : 0;
                                object.startDate = null;
                                object.endDate = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.campaignId != null && message.hasOwnProperty("campaignId"))
                                object.campaignId = $root.google.protobuf.Int64Value.toObject(message.campaignId, options);
                            if (message.criterionId != null && message.hasOwnProperty("criterionId"))
                                object.criterionId = $root.google.protobuf.Int64Value.toObject(message.criterionId, options);
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.SimulationTypeEnum.SimulationType[message.type] : message.type;
                            if (message.modificationMethod != null && message.hasOwnProperty("modificationMethod"))
                                object.modificationMethod = options.enums === String ? $root.google.ads.googleads.v1.enums.SimulationModificationMethodEnum.SimulationModificationMethod[message.modificationMethod] : message.modificationMethod;
                            if (message.startDate != null && message.hasOwnProperty("startDate"))
                                object.startDate = $root.google.protobuf.StringValue.toObject(message.startDate, options);
                            if (message.endDate != null && message.hasOwnProperty("endDate"))
                                object.endDate = $root.google.protobuf.StringValue.toObject(message.endDate, options);
                            if (message.bidModifierPointList != null && message.hasOwnProperty("bidModifierPointList")) {
                                object.bidModifierPointList = $root.google.ads.googleads.v1.common.BidModifierSimulationPointList.toObject(message.bidModifierPointList, options);
                                if (options.oneofs)
                                    object.pointList = "bidModifierPointList";
                            }
                            return object;
                        };

                        /**
                         * Converts this CampaignCriterionSimulation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CampaignCriterionSimulation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignCriterionSimulation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CampaignCriterionSimulation;
                    })();

                    resources.CampaignExtensionSetting = (function() {

                        /**
                         * Properties of a CampaignExtensionSetting.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICampaignExtensionSetting
                         * @property {string|null} [resourceName] CampaignExtensionSetting resourceName
                         * @property {google.ads.googleads.v1.enums.ExtensionTypeEnum.ExtensionType|null} [extensionType] CampaignExtensionSetting extensionType
                         * @property {google.protobuf.IStringValue|null} [campaign] CampaignExtensionSetting campaign
                         * @property {Array.<google.protobuf.IStringValue>|null} [extensionFeedItems] CampaignExtensionSetting extensionFeedItems
                         * @property {google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum.ExtensionSettingDevice|null} [device] CampaignExtensionSetting device
                         */

                        /**
                         * Constructs a new CampaignExtensionSetting.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CampaignExtensionSetting.
                         * @implements ICampaignExtensionSetting
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICampaignExtensionSetting=} [properties] Properties to set
                         */
                        function CampaignExtensionSetting(properties) {
                            this.extensionFeedItems = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CampaignExtensionSetting resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.CampaignExtensionSetting
                         * @instance
                         */
                        CampaignExtensionSetting.prototype.resourceName = "";

                        /**
                         * CampaignExtensionSetting extensionType.
                         * @member {google.ads.googleads.v1.enums.ExtensionTypeEnum.ExtensionType} extensionType
                         * @memberof google.ads.googleads.v1.resources.CampaignExtensionSetting
                         * @instance
                         */
                        CampaignExtensionSetting.prototype.extensionType = 0;

                        /**
                         * CampaignExtensionSetting campaign.
                         * @member {google.protobuf.IStringValue|null|undefined} campaign
                         * @memberof google.ads.googleads.v1.resources.CampaignExtensionSetting
                         * @instance
                         */
                        CampaignExtensionSetting.prototype.campaign = null;

                        /**
                         * CampaignExtensionSetting extensionFeedItems.
                         * @member {Array.<google.protobuf.IStringValue>} extensionFeedItems
                         * @memberof google.ads.googleads.v1.resources.CampaignExtensionSetting
                         * @instance
                         */
                        CampaignExtensionSetting.prototype.extensionFeedItems = $util.emptyArray;

                        /**
                         * CampaignExtensionSetting device.
                         * @member {google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum.ExtensionSettingDevice} device
                         * @memberof google.ads.googleads.v1.resources.CampaignExtensionSetting
                         * @instance
                         */
                        CampaignExtensionSetting.prototype.device = 0;

                        /**
                         * Creates a new CampaignExtensionSetting instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CampaignExtensionSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignExtensionSetting=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CampaignExtensionSetting} CampaignExtensionSetting instance
                         */
                        CampaignExtensionSetting.create = function create(properties) {
                            return new CampaignExtensionSetting(properties);
                        };

                        /**
                         * Encodes the specified CampaignExtensionSetting message. Does not implicitly {@link google.ads.googleads.v1.resources.CampaignExtensionSetting.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CampaignExtensionSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignExtensionSetting} message CampaignExtensionSetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignExtensionSetting.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.extensionType != null && message.hasOwnProperty("extensionType"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.extensionType);
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                $root.google.protobuf.StringValue.encode(message.campaign, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.extensionFeedItems != null && message.extensionFeedItems.length)
                                for (var i = 0; i < message.extensionFeedItems.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.extensionFeedItems[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.device != null && message.hasOwnProperty("device"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.device);
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignExtensionSetting message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CampaignExtensionSetting.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CampaignExtensionSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignExtensionSetting} message CampaignExtensionSetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignExtensionSetting.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignExtensionSetting message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CampaignExtensionSetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CampaignExtensionSetting} CampaignExtensionSetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignExtensionSetting.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CampaignExtensionSetting();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.extensionType = reader.int32();
                                    break;
                                case 3:
                                    message.campaign = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    if (!(message.extensionFeedItems && message.extensionFeedItems.length))
                                        message.extensionFeedItems = [];
                                    message.extensionFeedItems.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 5:
                                    message.device = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignExtensionSetting message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CampaignExtensionSetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CampaignExtensionSetting} CampaignExtensionSetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignExtensionSetting.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignExtensionSetting message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CampaignExtensionSetting
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignExtensionSetting.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.extensionType != null && message.hasOwnProperty("extensionType"))
                                switch (message.extensionType) {
                                default:
                                    return "extensionType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                    break;
                                }
                            if (message.campaign != null && message.hasOwnProperty("campaign")) {
                                var error = $root.google.protobuf.StringValue.verify(message.campaign);
                                if (error)
                                    return "campaign." + error;
                            }
                            if (message.extensionFeedItems != null && message.hasOwnProperty("extensionFeedItems")) {
                                if (!Array.isArray(message.extensionFeedItems))
                                    return "extensionFeedItems: array expected";
                                for (var i = 0; i < message.extensionFeedItems.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.extensionFeedItems[i]);
                                    if (error)
                                        return "extensionFeedItems." + error;
                                }
                            }
                            if (message.device != null && message.hasOwnProperty("device"))
                                switch (message.device) {
                                default:
                                    return "device: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a CampaignExtensionSetting message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CampaignExtensionSetting
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CampaignExtensionSetting} CampaignExtensionSetting
                         */
                        CampaignExtensionSetting.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CampaignExtensionSetting)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CampaignExtensionSetting();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            switch (object.extensionType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.extensionType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.extensionType = 1;
                                break;
                            case "NONE":
                            case 2:
                                message.extensionType = 2;
                                break;
                            case "APP":
                            case 3:
                                message.extensionType = 3;
                                break;
                            case "CALL":
                            case 4:
                                message.extensionType = 4;
                                break;
                            case "CALLOUT":
                            case 5:
                                message.extensionType = 5;
                                break;
                            case "MESSAGE":
                            case 6:
                                message.extensionType = 6;
                                break;
                            case "PRICE":
                            case 7:
                                message.extensionType = 7;
                                break;
                            case "PROMOTION":
                            case 8:
                                message.extensionType = 8;
                                break;
                            case "REVIEW":
                            case 9:
                                message.extensionType = 9;
                                break;
                            case "SITELINK":
                            case 10:
                                message.extensionType = 10;
                                break;
                            case "STRUCTURED_SNIPPET":
                            case 11:
                                message.extensionType = 11;
                                break;
                            case "LOCATION":
                            case 12:
                                message.extensionType = 12;
                                break;
                            case "AFFILIATE_LOCATION":
                            case 13:
                                message.extensionType = 13;
                                break;
                            }
                            if (object.campaign != null) {
                                if (typeof object.campaign !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignExtensionSetting.campaign: object expected");
                                message.campaign = $root.google.protobuf.StringValue.fromObject(object.campaign);
                            }
                            if (object.extensionFeedItems) {
                                if (!Array.isArray(object.extensionFeedItems))
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignExtensionSetting.extensionFeedItems: array expected");
                                message.extensionFeedItems = [];
                                for (var i = 0; i < object.extensionFeedItems.length; ++i) {
                                    if (typeof object.extensionFeedItems[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.CampaignExtensionSetting.extensionFeedItems: object expected");
                                    message.extensionFeedItems[i] = $root.google.protobuf.StringValue.fromObject(object.extensionFeedItems[i]);
                                }
                            }
                            switch (object.device) {
                            case "UNSPECIFIED":
                            case 0:
                                message.device = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.device = 1;
                                break;
                            case "MOBILE":
                            case 2:
                                message.device = 2;
                                break;
                            case "DESKTOP":
                            case 3:
                                message.device = 3;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CampaignExtensionSetting message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CampaignExtensionSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.CampaignExtensionSetting} message CampaignExtensionSetting
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignExtensionSetting.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.extensionFeedItems = [];
                            if (options.defaults) {
                                object.resourceName = "";
                                object.extensionType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.campaign = null;
                                object.device = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.extensionType != null && message.hasOwnProperty("extensionType"))
                                object.extensionType = options.enums === String ? $root.google.ads.googleads.v1.enums.ExtensionTypeEnum.ExtensionType[message.extensionType] : message.extensionType;
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                object.campaign = $root.google.protobuf.StringValue.toObject(message.campaign, options);
                            if (message.extensionFeedItems && message.extensionFeedItems.length) {
                                object.extensionFeedItems = [];
                                for (var j = 0; j < message.extensionFeedItems.length; ++j)
                                    object.extensionFeedItems[j] = $root.google.protobuf.StringValue.toObject(message.extensionFeedItems[j], options);
                            }
                            if (message.device != null && message.hasOwnProperty("device"))
                                object.device = options.enums === String ? $root.google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum.ExtensionSettingDevice[message.device] : message.device;
                            return object;
                        };

                        /**
                         * Converts this CampaignExtensionSetting to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CampaignExtensionSetting
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignExtensionSetting.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CampaignExtensionSetting;
                    })();

                    resources.CampaignFeed = (function() {

                        /**
                         * Properties of a CampaignFeed.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICampaignFeed
                         * @property {string|null} [resourceName] CampaignFeed resourceName
                         * @property {google.protobuf.IStringValue|null} [feed] CampaignFeed feed
                         * @property {google.protobuf.IStringValue|null} [campaign] CampaignFeed campaign
                         * @property {Array.<google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType>|null} [placeholderTypes] CampaignFeed placeholderTypes
                         * @property {google.ads.googleads.v1.common.IMatchingFunction|null} [matchingFunction] CampaignFeed matchingFunction
                         * @property {google.ads.googleads.v1.enums.FeedLinkStatusEnum.FeedLinkStatus|null} [status] CampaignFeed status
                         */

                        /**
                         * Constructs a new CampaignFeed.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CampaignFeed.
                         * @implements ICampaignFeed
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICampaignFeed=} [properties] Properties to set
                         */
                        function CampaignFeed(properties) {
                            this.placeholderTypes = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CampaignFeed resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.CampaignFeed
                         * @instance
                         */
                        CampaignFeed.prototype.resourceName = "";

                        /**
                         * CampaignFeed feed.
                         * @member {google.protobuf.IStringValue|null|undefined} feed
                         * @memberof google.ads.googleads.v1.resources.CampaignFeed
                         * @instance
                         */
                        CampaignFeed.prototype.feed = null;

                        /**
                         * CampaignFeed campaign.
                         * @member {google.protobuf.IStringValue|null|undefined} campaign
                         * @memberof google.ads.googleads.v1.resources.CampaignFeed
                         * @instance
                         */
                        CampaignFeed.prototype.campaign = null;

                        /**
                         * CampaignFeed placeholderTypes.
                         * @member {Array.<google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType>} placeholderTypes
                         * @memberof google.ads.googleads.v1.resources.CampaignFeed
                         * @instance
                         */
                        CampaignFeed.prototype.placeholderTypes = $util.emptyArray;

                        /**
                         * CampaignFeed matchingFunction.
                         * @member {google.ads.googleads.v1.common.IMatchingFunction|null|undefined} matchingFunction
                         * @memberof google.ads.googleads.v1.resources.CampaignFeed
                         * @instance
                         */
                        CampaignFeed.prototype.matchingFunction = null;

                        /**
                         * CampaignFeed status.
                         * @member {google.ads.googleads.v1.enums.FeedLinkStatusEnum.FeedLinkStatus} status
                         * @memberof google.ads.googleads.v1.resources.CampaignFeed
                         * @instance
                         */
                        CampaignFeed.prototype.status = 0;

                        /**
                         * Creates a new CampaignFeed instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CampaignFeed
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignFeed=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CampaignFeed} CampaignFeed instance
                         */
                        CampaignFeed.create = function create(properties) {
                            return new CampaignFeed(properties);
                        };

                        /**
                         * Encodes the specified CampaignFeed message. Does not implicitly {@link google.ads.googleads.v1.resources.CampaignFeed.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CampaignFeed
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignFeed} message CampaignFeed message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignFeed.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.feed != null && message.hasOwnProperty("feed"))
                                $root.google.protobuf.StringValue.encode(message.feed, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                $root.google.protobuf.StringValue.encode(message.campaign, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.placeholderTypes != null && message.placeholderTypes.length) {
                                writer.uint32(/* id 4, wireType 2 =*/34).fork();
                                for (var i = 0; i < message.placeholderTypes.length; ++i)
                                    writer.int32(message.placeholderTypes[i]);
                                writer.ldelim();
                            }
                            if (message.matchingFunction != null && message.hasOwnProperty("matchingFunction"))
                                $root.google.ads.googleads.v1.common.MatchingFunction.encode(message.matchingFunction, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.status);
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignFeed message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CampaignFeed.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CampaignFeed
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignFeed} message CampaignFeed message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignFeed.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignFeed message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CampaignFeed
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CampaignFeed} CampaignFeed
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignFeed.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CampaignFeed();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.feed = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.campaign = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    if (!(message.placeholderTypes && message.placeholderTypes.length))
                                        message.placeholderTypes = [];
                                    if ((tag & 7) === 2) {
                                        var end2 = reader.uint32() + reader.pos;
                                        while (reader.pos < end2)
                                            message.placeholderTypes.push(reader.int32());
                                    } else
                                        message.placeholderTypes.push(reader.int32());
                                    break;
                                case 5:
                                    message.matchingFunction = $root.google.ads.googleads.v1.common.MatchingFunction.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.status = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignFeed message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CampaignFeed
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CampaignFeed} CampaignFeed
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignFeed.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignFeed message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CampaignFeed
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignFeed.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.feed != null && message.hasOwnProperty("feed")) {
                                var error = $root.google.protobuf.StringValue.verify(message.feed);
                                if (error)
                                    return "feed." + error;
                            }
                            if (message.campaign != null && message.hasOwnProperty("campaign")) {
                                var error = $root.google.protobuf.StringValue.verify(message.campaign);
                                if (error)
                                    return "campaign." + error;
                            }
                            if (message.placeholderTypes != null && message.hasOwnProperty("placeholderTypes")) {
                                if (!Array.isArray(message.placeholderTypes))
                                    return "placeholderTypes: array expected";
                                for (var i = 0; i < message.placeholderTypes.length; ++i)
                                    switch (message.placeholderTypes[i]) {
                                    default:
                                        return "placeholderTypes: enum value[] expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                    case 5:
                                    case 6:
                                    case 7:
                                    case 8:
                                    case 9:
                                    case 10:
                                    case 11:
                                    case 12:
                                    case 13:
                                    case 14:
                                    case 15:
                                    case 16:
                                    case 17:
                                    case 18:
                                    case 19:
                                    case 20:
                                        break;
                                    }
                            }
                            if (message.matchingFunction != null && message.hasOwnProperty("matchingFunction")) {
                                var error = $root.google.ads.googleads.v1.common.MatchingFunction.verify(message.matchingFunction);
                                if (error)
                                    return "matchingFunction." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a CampaignFeed message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CampaignFeed
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CampaignFeed} CampaignFeed
                         */
                        CampaignFeed.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CampaignFeed)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CampaignFeed();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.feed != null) {
                                if (typeof object.feed !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignFeed.feed: object expected");
                                message.feed = $root.google.protobuf.StringValue.fromObject(object.feed);
                            }
                            if (object.campaign != null) {
                                if (typeof object.campaign !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignFeed.campaign: object expected");
                                message.campaign = $root.google.protobuf.StringValue.fromObject(object.campaign);
                            }
                            if (object.placeholderTypes) {
                                if (!Array.isArray(object.placeholderTypes))
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignFeed.placeholderTypes: array expected");
                                message.placeholderTypes = [];
                                for (var i = 0; i < object.placeholderTypes.length; ++i)
                                    switch (object.placeholderTypes[i]) {
                                    default:
                                    case "UNSPECIFIED":
                                    case 0:
                                        message.placeholderTypes[i] = 0;
                                        break;
                                    case "UNKNOWN":
                                    case 1:
                                        message.placeholderTypes[i] = 1;
                                        break;
                                    case "SITELINK":
                                    case 2:
                                        message.placeholderTypes[i] = 2;
                                        break;
                                    case "CALL":
                                    case 3:
                                        message.placeholderTypes[i] = 3;
                                        break;
                                    case "APP":
                                    case 4:
                                        message.placeholderTypes[i] = 4;
                                        break;
                                    case "LOCATION":
                                    case 5:
                                        message.placeholderTypes[i] = 5;
                                        break;
                                    case "AFFILIATE_LOCATION":
                                    case 6:
                                        message.placeholderTypes[i] = 6;
                                        break;
                                    case "CALLOUT":
                                    case 7:
                                        message.placeholderTypes[i] = 7;
                                        break;
                                    case "STRUCTURED_SNIPPET":
                                    case 8:
                                        message.placeholderTypes[i] = 8;
                                        break;
                                    case "MESSAGE":
                                    case 9:
                                        message.placeholderTypes[i] = 9;
                                        break;
                                    case "PRICE":
                                    case 10:
                                        message.placeholderTypes[i] = 10;
                                        break;
                                    case "PROMOTION":
                                    case 11:
                                        message.placeholderTypes[i] = 11;
                                        break;
                                    case "AD_CUSTOMIZER":
                                    case 12:
                                        message.placeholderTypes[i] = 12;
                                        break;
                                    case "DYNAMIC_EDUCATION":
                                    case 13:
                                        message.placeholderTypes[i] = 13;
                                        break;
                                    case "DYNAMIC_FLIGHT":
                                    case 14:
                                        message.placeholderTypes[i] = 14;
                                        break;
                                    case "DYNAMIC_CUSTOM":
                                    case 15:
                                        message.placeholderTypes[i] = 15;
                                        break;
                                    case "DYNAMIC_HOTEL":
                                    case 16:
                                        message.placeholderTypes[i] = 16;
                                        break;
                                    case "DYNAMIC_REAL_ESTATE":
                                    case 17:
                                        message.placeholderTypes[i] = 17;
                                        break;
                                    case "DYNAMIC_TRAVEL":
                                    case 18:
                                        message.placeholderTypes[i] = 18;
                                        break;
                                    case "DYNAMIC_LOCAL":
                                    case 19:
                                        message.placeholderTypes[i] = 19;
                                        break;
                                    case "DYNAMIC_JOB":
                                    case 20:
                                        message.placeholderTypes[i] = 20;
                                        break;
                                    }
                            }
                            if (object.matchingFunction != null) {
                                if (typeof object.matchingFunction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignFeed.matchingFunction: object expected");
                                message.matchingFunction = $root.google.ads.googleads.v1.common.MatchingFunction.fromObject(object.matchingFunction);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "REMOVED":
                            case 3:
                                message.status = 3;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CampaignFeed message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CampaignFeed
                         * @static
                         * @param {google.ads.googleads.v1.resources.CampaignFeed} message CampaignFeed
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignFeed.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.placeholderTypes = [];
                            if (options.defaults) {
                                object.resourceName = "";
                                object.feed = null;
                                object.campaign = null;
                                object.matchingFunction = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.feed != null && message.hasOwnProperty("feed"))
                                object.feed = $root.google.protobuf.StringValue.toObject(message.feed, options);
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                object.campaign = $root.google.protobuf.StringValue.toObject(message.campaign, options);
                            if (message.placeholderTypes && message.placeholderTypes.length) {
                                object.placeholderTypes = [];
                                for (var j = 0; j < message.placeholderTypes.length; ++j)
                                    object.placeholderTypes[j] = options.enums === String ? $root.google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType[message.placeholderTypes[j]] : message.placeholderTypes[j];
                            }
                            if (message.matchingFunction != null && message.hasOwnProperty("matchingFunction"))
                                object.matchingFunction = $root.google.ads.googleads.v1.common.MatchingFunction.toObject(message.matchingFunction, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.FeedLinkStatusEnum.FeedLinkStatus[message.status] : message.status;
                            return object;
                        };

                        /**
                         * Converts this CampaignFeed to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CampaignFeed
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignFeed.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CampaignFeed;
                    })();

                    resources.CampaignLabel = (function() {

                        /**
                         * Properties of a CampaignLabel.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICampaignLabel
                         * @property {string|null} [resourceName] CampaignLabel resourceName
                         * @property {google.protobuf.IStringValue|null} [campaign] CampaignLabel campaign
                         * @property {google.protobuf.IStringValue|null} [label] CampaignLabel label
                         */

                        /**
                         * Constructs a new CampaignLabel.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CampaignLabel.
                         * @implements ICampaignLabel
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICampaignLabel=} [properties] Properties to set
                         */
                        function CampaignLabel(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CampaignLabel resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.CampaignLabel
                         * @instance
                         */
                        CampaignLabel.prototype.resourceName = "";

                        /**
                         * CampaignLabel campaign.
                         * @member {google.protobuf.IStringValue|null|undefined} campaign
                         * @memberof google.ads.googleads.v1.resources.CampaignLabel
                         * @instance
                         */
                        CampaignLabel.prototype.campaign = null;

                        /**
                         * CampaignLabel label.
                         * @member {google.protobuf.IStringValue|null|undefined} label
                         * @memberof google.ads.googleads.v1.resources.CampaignLabel
                         * @instance
                         */
                        CampaignLabel.prototype.label = null;

                        /**
                         * Creates a new CampaignLabel instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CampaignLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignLabel=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CampaignLabel} CampaignLabel instance
                         */
                        CampaignLabel.create = function create(properties) {
                            return new CampaignLabel(properties);
                        };

                        /**
                         * Encodes the specified CampaignLabel message. Does not implicitly {@link google.ads.googleads.v1.resources.CampaignLabel.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CampaignLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignLabel} message CampaignLabel message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignLabel.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                $root.google.protobuf.StringValue.encode(message.campaign, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.label != null && message.hasOwnProperty("label"))
                                $root.google.protobuf.StringValue.encode(message.label, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignLabel message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CampaignLabel.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CampaignLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignLabel} message CampaignLabel message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignLabel.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignLabel message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CampaignLabel
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CampaignLabel} CampaignLabel
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignLabel.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CampaignLabel();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.campaign = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.label = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignLabel message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CampaignLabel
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CampaignLabel} CampaignLabel
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignLabel.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignLabel message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CampaignLabel
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignLabel.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.campaign != null && message.hasOwnProperty("campaign")) {
                                var error = $root.google.protobuf.StringValue.verify(message.campaign);
                                if (error)
                                    return "campaign." + error;
                            }
                            if (message.label != null && message.hasOwnProperty("label")) {
                                var error = $root.google.protobuf.StringValue.verify(message.label);
                                if (error)
                                    return "label." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CampaignLabel message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CampaignLabel
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CampaignLabel} CampaignLabel
                         */
                        CampaignLabel.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CampaignLabel)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CampaignLabel();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.campaign != null) {
                                if (typeof object.campaign !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignLabel.campaign: object expected");
                                message.campaign = $root.google.protobuf.StringValue.fromObject(object.campaign);
                            }
                            if (object.label != null) {
                                if (typeof object.label !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignLabel.label: object expected");
                                message.label = $root.google.protobuf.StringValue.fromObject(object.label);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CampaignLabel message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CampaignLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.CampaignLabel} message CampaignLabel
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignLabel.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.campaign = null;
                                object.label = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                object.campaign = $root.google.protobuf.StringValue.toObject(message.campaign, options);
                            if (message.label != null && message.hasOwnProperty("label"))
                                object.label = $root.google.protobuf.StringValue.toObject(message.label, options);
                            return object;
                        };

                        /**
                         * Converts this CampaignLabel to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CampaignLabel
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignLabel.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CampaignLabel;
                    })();

                    resources.CampaignSharedSet = (function() {

                        /**
                         * Properties of a CampaignSharedSet.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICampaignSharedSet
                         * @property {string|null} [resourceName] CampaignSharedSet resourceName
                         * @property {google.protobuf.IStringValue|null} [campaign] CampaignSharedSet campaign
                         * @property {google.protobuf.IStringValue|null} [sharedSet] CampaignSharedSet sharedSet
                         * @property {google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum.CampaignSharedSetStatus|null} [status] CampaignSharedSet status
                         */

                        /**
                         * Constructs a new CampaignSharedSet.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CampaignSharedSet.
                         * @implements ICampaignSharedSet
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICampaignSharedSet=} [properties] Properties to set
                         */
                        function CampaignSharedSet(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CampaignSharedSet resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.CampaignSharedSet
                         * @instance
                         */
                        CampaignSharedSet.prototype.resourceName = "";

                        /**
                         * CampaignSharedSet campaign.
                         * @member {google.protobuf.IStringValue|null|undefined} campaign
                         * @memberof google.ads.googleads.v1.resources.CampaignSharedSet
                         * @instance
                         */
                        CampaignSharedSet.prototype.campaign = null;

                        /**
                         * CampaignSharedSet sharedSet.
                         * @member {google.protobuf.IStringValue|null|undefined} sharedSet
                         * @memberof google.ads.googleads.v1.resources.CampaignSharedSet
                         * @instance
                         */
                        CampaignSharedSet.prototype.sharedSet = null;

                        /**
                         * CampaignSharedSet status.
                         * @member {google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum.CampaignSharedSetStatus} status
                         * @memberof google.ads.googleads.v1.resources.CampaignSharedSet
                         * @instance
                         */
                        CampaignSharedSet.prototype.status = 0;

                        /**
                         * Creates a new CampaignSharedSet instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CampaignSharedSet
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignSharedSet=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CampaignSharedSet} CampaignSharedSet instance
                         */
                        CampaignSharedSet.create = function create(properties) {
                            return new CampaignSharedSet(properties);
                        };

                        /**
                         * Encodes the specified CampaignSharedSet message. Does not implicitly {@link google.ads.googleads.v1.resources.CampaignSharedSet.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CampaignSharedSet
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignSharedSet} message CampaignSharedSet message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignSharedSet.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.status);
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                $root.google.protobuf.StringValue.encode(message.campaign, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.sharedSet != null && message.hasOwnProperty("sharedSet"))
                                $root.google.protobuf.StringValue.encode(message.sharedSet, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignSharedSet message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CampaignSharedSet.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CampaignSharedSet
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICampaignSharedSet} message CampaignSharedSet message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignSharedSet.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignSharedSet message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CampaignSharedSet
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CampaignSharedSet} CampaignSharedSet
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignSharedSet.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CampaignSharedSet();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 3:
                                    message.campaign = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.sharedSet = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.status = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignSharedSet message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CampaignSharedSet
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CampaignSharedSet} CampaignSharedSet
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignSharedSet.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignSharedSet message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CampaignSharedSet
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignSharedSet.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.campaign != null && message.hasOwnProperty("campaign")) {
                                var error = $root.google.protobuf.StringValue.verify(message.campaign);
                                if (error)
                                    return "campaign." + error;
                            }
                            if (message.sharedSet != null && message.hasOwnProperty("sharedSet")) {
                                var error = $root.google.protobuf.StringValue.verify(message.sharedSet);
                                if (error)
                                    return "sharedSet." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a CampaignSharedSet message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CampaignSharedSet
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CampaignSharedSet} CampaignSharedSet
                         */
                        CampaignSharedSet.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CampaignSharedSet)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CampaignSharedSet();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.campaign != null) {
                                if (typeof object.campaign !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignSharedSet.campaign: object expected");
                                message.campaign = $root.google.protobuf.StringValue.fromObject(object.campaign);
                            }
                            if (object.sharedSet != null) {
                                if (typeof object.sharedSet !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CampaignSharedSet.sharedSet: object expected");
                                message.sharedSet = $root.google.protobuf.StringValue.fromObject(object.sharedSet);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "REMOVED":
                            case 3:
                                message.status = 3;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CampaignSharedSet message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CampaignSharedSet
                         * @static
                         * @param {google.ads.googleads.v1.resources.CampaignSharedSet} message CampaignSharedSet
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignSharedSet.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                                object.campaign = null;
                                object.sharedSet = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.CampaignSharedSetStatusEnum.CampaignSharedSetStatus[message.status] : message.status;
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                object.campaign = $root.google.protobuf.StringValue.toObject(message.campaign, options);
                            if (message.sharedSet != null && message.hasOwnProperty("sharedSet"))
                                object.sharedSet = $root.google.protobuf.StringValue.toObject(message.sharedSet, options);
                            return object;
                        };

                        /**
                         * Converts this CampaignSharedSet to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CampaignSharedSet
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignSharedSet.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CampaignSharedSet;
                    })();

                    resources.CarrierConstant = (function() {

                        /**
                         * Properties of a CarrierConstant.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICarrierConstant
                         * @property {string|null} [resourceName] CarrierConstant resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] CarrierConstant id
                         * @property {google.protobuf.IStringValue|null} [name] CarrierConstant name
                         * @property {google.protobuf.IStringValue|null} [countryCode] CarrierConstant countryCode
                         */

                        /**
                         * Constructs a new CarrierConstant.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CarrierConstant.
                         * @implements ICarrierConstant
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICarrierConstant=} [properties] Properties to set
                         */
                        function CarrierConstant(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CarrierConstant resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.CarrierConstant
                         * @instance
                         */
                        CarrierConstant.prototype.resourceName = "";

                        /**
                         * CarrierConstant id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.CarrierConstant
                         * @instance
                         */
                        CarrierConstant.prototype.id = null;

                        /**
                         * CarrierConstant name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.CarrierConstant
                         * @instance
                         */
                        CarrierConstant.prototype.name = null;

                        /**
                         * CarrierConstant countryCode.
                         * @member {google.protobuf.IStringValue|null|undefined} countryCode
                         * @memberof google.ads.googleads.v1.resources.CarrierConstant
                         * @instance
                         */
                        CarrierConstant.prototype.countryCode = null;

                        /**
                         * Creates a new CarrierConstant instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CarrierConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICarrierConstant=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CarrierConstant} CarrierConstant instance
                         */
                        CarrierConstant.create = function create(properties) {
                            return new CarrierConstant(properties);
                        };

                        /**
                         * Encodes the specified CarrierConstant message. Does not implicitly {@link google.ads.googleads.v1.resources.CarrierConstant.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CarrierConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICarrierConstant} message CarrierConstant message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CarrierConstant.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                $root.google.protobuf.StringValue.encode(message.countryCode, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CarrierConstant message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CarrierConstant.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CarrierConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICarrierConstant} message CarrierConstant message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CarrierConstant.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CarrierConstant message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CarrierConstant
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CarrierConstant} CarrierConstant
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CarrierConstant.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CarrierConstant();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.countryCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CarrierConstant message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CarrierConstant
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CarrierConstant} CarrierConstant
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CarrierConstant.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CarrierConstant message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CarrierConstant
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CarrierConstant.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.countryCode != null && message.hasOwnProperty("countryCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.countryCode);
                                if (error)
                                    return "countryCode." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CarrierConstant message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CarrierConstant
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CarrierConstant} CarrierConstant
                         */
                        CarrierConstant.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CarrierConstant)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CarrierConstant();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CarrierConstant.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CarrierConstant.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            if (object.countryCode != null) {
                                if (typeof object.countryCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CarrierConstant.countryCode: object expected");
                                message.countryCode = $root.google.protobuf.StringValue.fromObject(object.countryCode);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CarrierConstant message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CarrierConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.CarrierConstant} message CarrierConstant
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CarrierConstant.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.name = null;
                                object.countryCode = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                object.countryCode = $root.google.protobuf.StringValue.toObject(message.countryCode, options);
                            return object;
                        };

                        /**
                         * Converts this CarrierConstant to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CarrierConstant
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CarrierConstant.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CarrierConstant;
                    })();

                    resources.ChangeStatus = (function() {

                        /**
                         * Properties of a ChangeStatus.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IChangeStatus
                         * @property {string|null} [resourceName] ChangeStatus resourceName
                         * @property {google.protobuf.IStringValue|null} [lastChangeDateTime] ChangeStatus lastChangeDateTime
                         * @property {google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum.ChangeStatusResourceType|null} [resourceType] ChangeStatus resourceType
                         * @property {google.protobuf.IStringValue|null} [campaign] ChangeStatus campaign
                         * @property {google.protobuf.IStringValue|null} [adGroup] ChangeStatus adGroup
                         * @property {google.ads.googleads.v1.enums.ChangeStatusOperationEnum.ChangeStatusOperation|null} [resourceStatus] ChangeStatus resourceStatus
                         * @property {google.protobuf.IStringValue|null} [adGroupAd] ChangeStatus adGroupAd
                         * @property {google.protobuf.IStringValue|null} [adGroupCriterion] ChangeStatus adGroupCriterion
                         * @property {google.protobuf.IStringValue|null} [campaignCriterion] ChangeStatus campaignCriterion
                         * @property {google.protobuf.IStringValue|null} [feed] ChangeStatus feed
                         * @property {google.protobuf.IStringValue|null} [feedItem] ChangeStatus feedItem
                         * @property {google.protobuf.IStringValue|null} [adGroupFeed] ChangeStatus adGroupFeed
                         * @property {google.protobuf.IStringValue|null} [campaignFeed] ChangeStatus campaignFeed
                         * @property {google.protobuf.IStringValue|null} [adGroupBidModifier] ChangeStatus adGroupBidModifier
                         */

                        /**
                         * Constructs a new ChangeStatus.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a ChangeStatus.
                         * @implements IChangeStatus
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IChangeStatus=} [properties] Properties to set
                         */
                        function ChangeStatus(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ChangeStatus resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @instance
                         */
                        ChangeStatus.prototype.resourceName = "";

                        /**
                         * ChangeStatus lastChangeDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} lastChangeDateTime
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @instance
                         */
                        ChangeStatus.prototype.lastChangeDateTime = null;

                        /**
                         * ChangeStatus resourceType.
                         * @member {google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum.ChangeStatusResourceType} resourceType
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @instance
                         */
                        ChangeStatus.prototype.resourceType = 0;

                        /**
                         * ChangeStatus campaign.
                         * @member {google.protobuf.IStringValue|null|undefined} campaign
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @instance
                         */
                        ChangeStatus.prototype.campaign = null;

                        /**
                         * ChangeStatus adGroup.
                         * @member {google.protobuf.IStringValue|null|undefined} adGroup
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @instance
                         */
                        ChangeStatus.prototype.adGroup = null;

                        /**
                         * ChangeStatus resourceStatus.
                         * @member {google.ads.googleads.v1.enums.ChangeStatusOperationEnum.ChangeStatusOperation} resourceStatus
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @instance
                         */
                        ChangeStatus.prototype.resourceStatus = 0;

                        /**
                         * ChangeStatus adGroupAd.
                         * @member {google.protobuf.IStringValue|null|undefined} adGroupAd
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @instance
                         */
                        ChangeStatus.prototype.adGroupAd = null;

                        /**
                         * ChangeStatus adGroupCriterion.
                         * @member {google.protobuf.IStringValue|null|undefined} adGroupCriterion
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @instance
                         */
                        ChangeStatus.prototype.adGroupCriterion = null;

                        /**
                         * ChangeStatus campaignCriterion.
                         * @member {google.protobuf.IStringValue|null|undefined} campaignCriterion
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @instance
                         */
                        ChangeStatus.prototype.campaignCriterion = null;

                        /**
                         * ChangeStatus feed.
                         * @member {google.protobuf.IStringValue|null|undefined} feed
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @instance
                         */
                        ChangeStatus.prototype.feed = null;

                        /**
                         * ChangeStatus feedItem.
                         * @member {google.protobuf.IStringValue|null|undefined} feedItem
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @instance
                         */
                        ChangeStatus.prototype.feedItem = null;

                        /**
                         * ChangeStatus adGroupFeed.
                         * @member {google.protobuf.IStringValue|null|undefined} adGroupFeed
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @instance
                         */
                        ChangeStatus.prototype.adGroupFeed = null;

                        /**
                         * ChangeStatus campaignFeed.
                         * @member {google.protobuf.IStringValue|null|undefined} campaignFeed
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @instance
                         */
                        ChangeStatus.prototype.campaignFeed = null;

                        /**
                         * ChangeStatus adGroupBidModifier.
                         * @member {google.protobuf.IStringValue|null|undefined} adGroupBidModifier
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @instance
                         */
                        ChangeStatus.prototype.adGroupBidModifier = null;

                        /**
                         * Creates a new ChangeStatus instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @static
                         * @param {google.ads.googleads.v1.resources.IChangeStatus=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.ChangeStatus} ChangeStatus instance
                         */
                        ChangeStatus.create = function create(properties) {
                            return new ChangeStatus(properties);
                        };

                        /**
                         * Encodes the specified ChangeStatus message. Does not implicitly {@link google.ads.googleads.v1.resources.ChangeStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @static
                         * @param {google.ads.googleads.v1.resources.IChangeStatus} message ChangeStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChangeStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.lastChangeDateTime != null && message.hasOwnProperty("lastChangeDateTime"))
                                $root.google.protobuf.StringValue.encode(message.lastChangeDateTime, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.resourceType != null && message.hasOwnProperty("resourceType"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.resourceType);
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                $root.google.protobuf.StringValue.encode(message.campaign, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                $root.google.protobuf.StringValue.encode(message.adGroup, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.resourceStatus != null && message.hasOwnProperty("resourceStatus"))
                                writer.uint32(/* id 8, wireType 0 =*/64).int32(message.resourceStatus);
                            if (message.adGroupAd != null && message.hasOwnProperty("adGroupAd"))
                                $root.google.protobuf.StringValue.encode(message.adGroupAd, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.adGroupCriterion != null && message.hasOwnProperty("adGroupCriterion"))
                                $root.google.protobuf.StringValue.encode(message.adGroupCriterion, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.campaignCriterion != null && message.hasOwnProperty("campaignCriterion"))
                                $root.google.protobuf.StringValue.encode(message.campaignCriterion, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.feed != null && message.hasOwnProperty("feed"))
                                $root.google.protobuf.StringValue.encode(message.feed, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.feedItem != null && message.hasOwnProperty("feedItem"))
                                $root.google.protobuf.StringValue.encode(message.feedItem, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                            if (message.adGroupFeed != null && message.hasOwnProperty("adGroupFeed"))
                                $root.google.protobuf.StringValue.encode(message.adGroupFeed, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.campaignFeed != null && message.hasOwnProperty("campaignFeed"))
                                $root.google.protobuf.StringValue.encode(message.campaignFeed, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
                            if (message.adGroupBidModifier != null && message.hasOwnProperty("adGroupBidModifier"))
                                $root.google.protobuf.StringValue.encode(message.adGroupBidModifier, writer.uint32(/* id 16, wireType 2 =*/130).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ChangeStatus message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.ChangeStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @static
                         * @param {google.ads.googleads.v1.resources.IChangeStatus} message ChangeStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChangeStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ChangeStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.ChangeStatus} ChangeStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChangeStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.ChangeStatus();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 3:
                                    message.lastChangeDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.resourceType = reader.int32();
                                    break;
                                case 5:
                                    message.campaign = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.adGroup = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.resourceStatus = reader.int32();
                                    break;
                                case 9:
                                    message.adGroupAd = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.adGroupCriterion = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.campaignCriterion = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.feed = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 13:
                                    message.feedItem = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 14:
                                    message.adGroupFeed = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 15:
                                    message.campaignFeed = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 16:
                                    message.adGroupBidModifier = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ChangeStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.ChangeStatus} ChangeStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChangeStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ChangeStatus message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ChangeStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.lastChangeDateTime != null && message.hasOwnProperty("lastChangeDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.lastChangeDateTime);
                                if (error)
                                    return "lastChangeDateTime." + error;
                            }
                            if (message.resourceType != null && message.hasOwnProperty("resourceType"))
                                switch (message.resourceType) {
                                default:
                                    return "resourceType: enum value expected";
                                case 0:
                                case 1:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                    break;
                                }
                            if (message.campaign != null && message.hasOwnProperty("campaign")) {
                                var error = $root.google.protobuf.StringValue.verify(message.campaign);
                                if (error)
                                    return "campaign." + error;
                            }
                            if (message.adGroup != null && message.hasOwnProperty("adGroup")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adGroup);
                                if (error)
                                    return "adGroup." + error;
                            }
                            if (message.resourceStatus != null && message.hasOwnProperty("resourceStatus"))
                                switch (message.resourceStatus) {
                                default:
                                    return "resourceStatus: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.adGroupAd != null && message.hasOwnProperty("adGroupAd")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adGroupAd);
                                if (error)
                                    return "adGroupAd." + error;
                            }
                            if (message.adGroupCriterion != null && message.hasOwnProperty("adGroupCriterion")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adGroupCriterion);
                                if (error)
                                    return "adGroupCriterion." + error;
                            }
                            if (message.campaignCriterion != null && message.hasOwnProperty("campaignCriterion")) {
                                var error = $root.google.protobuf.StringValue.verify(message.campaignCriterion);
                                if (error)
                                    return "campaignCriterion." + error;
                            }
                            if (message.feed != null && message.hasOwnProperty("feed")) {
                                var error = $root.google.protobuf.StringValue.verify(message.feed);
                                if (error)
                                    return "feed." + error;
                            }
                            if (message.feedItem != null && message.hasOwnProperty("feedItem")) {
                                var error = $root.google.protobuf.StringValue.verify(message.feedItem);
                                if (error)
                                    return "feedItem." + error;
                            }
                            if (message.adGroupFeed != null && message.hasOwnProperty("adGroupFeed")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adGroupFeed);
                                if (error)
                                    return "adGroupFeed." + error;
                            }
                            if (message.campaignFeed != null && message.hasOwnProperty("campaignFeed")) {
                                var error = $root.google.protobuf.StringValue.verify(message.campaignFeed);
                                if (error)
                                    return "campaignFeed." + error;
                            }
                            if (message.adGroupBidModifier != null && message.hasOwnProperty("adGroupBidModifier")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adGroupBidModifier);
                                if (error)
                                    return "adGroupBidModifier." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a ChangeStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.ChangeStatus} ChangeStatus
                         */
                        ChangeStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.ChangeStatus)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.ChangeStatus();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.lastChangeDateTime != null) {
                                if (typeof object.lastChangeDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ChangeStatus.lastChangeDateTime: object expected");
                                message.lastChangeDateTime = $root.google.protobuf.StringValue.fromObject(object.lastChangeDateTime);
                            }
                            switch (object.resourceType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.resourceType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.resourceType = 1;
                                break;
                            case "AD_GROUP":
                            case 3:
                                message.resourceType = 3;
                                break;
                            case "AD_GROUP_AD":
                            case 4:
                                message.resourceType = 4;
                                break;
                            case "AD_GROUP_CRITERION":
                            case 5:
                                message.resourceType = 5;
                                break;
                            case "CAMPAIGN":
                            case 6:
                                message.resourceType = 6;
                                break;
                            case "CAMPAIGN_CRITERION":
                            case 7:
                                message.resourceType = 7;
                                break;
                            case "FEED":
                            case 9:
                                message.resourceType = 9;
                                break;
                            case "FEED_ITEM":
                            case 10:
                                message.resourceType = 10;
                                break;
                            case "AD_GROUP_FEED":
                            case 11:
                                message.resourceType = 11;
                                break;
                            case "CAMPAIGN_FEED":
                            case 12:
                                message.resourceType = 12;
                                break;
                            case "AD_GROUP_BID_MODIFIER":
                            case 13:
                                message.resourceType = 13;
                                break;
                            }
                            if (object.campaign != null) {
                                if (typeof object.campaign !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ChangeStatus.campaign: object expected");
                                message.campaign = $root.google.protobuf.StringValue.fromObject(object.campaign);
                            }
                            if (object.adGroup != null) {
                                if (typeof object.adGroup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ChangeStatus.adGroup: object expected");
                                message.adGroup = $root.google.protobuf.StringValue.fromObject(object.adGroup);
                            }
                            switch (object.resourceStatus) {
                            case "UNSPECIFIED":
                            case 0:
                                message.resourceStatus = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.resourceStatus = 1;
                                break;
                            case "ADDED":
                            case 2:
                                message.resourceStatus = 2;
                                break;
                            case "CHANGED":
                            case 3:
                                message.resourceStatus = 3;
                                break;
                            case "REMOVED":
                            case 4:
                                message.resourceStatus = 4;
                                break;
                            }
                            if (object.adGroupAd != null) {
                                if (typeof object.adGroupAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ChangeStatus.adGroupAd: object expected");
                                message.adGroupAd = $root.google.protobuf.StringValue.fromObject(object.adGroupAd);
                            }
                            if (object.adGroupCriterion != null) {
                                if (typeof object.adGroupCriterion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ChangeStatus.adGroupCriterion: object expected");
                                message.adGroupCriterion = $root.google.protobuf.StringValue.fromObject(object.adGroupCriterion);
                            }
                            if (object.campaignCriterion != null) {
                                if (typeof object.campaignCriterion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ChangeStatus.campaignCriterion: object expected");
                                message.campaignCriterion = $root.google.protobuf.StringValue.fromObject(object.campaignCriterion);
                            }
                            if (object.feed != null) {
                                if (typeof object.feed !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ChangeStatus.feed: object expected");
                                message.feed = $root.google.protobuf.StringValue.fromObject(object.feed);
                            }
                            if (object.feedItem != null) {
                                if (typeof object.feedItem !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ChangeStatus.feedItem: object expected");
                                message.feedItem = $root.google.protobuf.StringValue.fromObject(object.feedItem);
                            }
                            if (object.adGroupFeed != null) {
                                if (typeof object.adGroupFeed !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ChangeStatus.adGroupFeed: object expected");
                                message.adGroupFeed = $root.google.protobuf.StringValue.fromObject(object.adGroupFeed);
                            }
                            if (object.campaignFeed != null) {
                                if (typeof object.campaignFeed !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ChangeStatus.campaignFeed: object expected");
                                message.campaignFeed = $root.google.protobuf.StringValue.fromObject(object.campaignFeed);
                            }
                            if (object.adGroupBidModifier != null) {
                                if (typeof object.adGroupBidModifier !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ChangeStatus.adGroupBidModifier: object expected");
                                message.adGroupBidModifier = $root.google.protobuf.StringValue.fromObject(object.adGroupBidModifier);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ChangeStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @static
                         * @param {google.ads.googleads.v1.resources.ChangeStatus} message ChangeStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ChangeStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.lastChangeDateTime = null;
                                object.resourceType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.campaign = null;
                                object.adGroup = null;
                                object.resourceStatus = options.enums === String ? "UNSPECIFIED" : 0;
                                object.adGroupAd = null;
                                object.adGroupCriterion = null;
                                object.campaignCriterion = null;
                                object.feed = null;
                                object.feedItem = null;
                                object.adGroupFeed = null;
                                object.campaignFeed = null;
                                object.adGroupBidModifier = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.lastChangeDateTime != null && message.hasOwnProperty("lastChangeDateTime"))
                                object.lastChangeDateTime = $root.google.protobuf.StringValue.toObject(message.lastChangeDateTime, options);
                            if (message.resourceType != null && message.hasOwnProperty("resourceType"))
                                object.resourceType = options.enums === String ? $root.google.ads.googleads.v1.enums.ChangeStatusResourceTypeEnum.ChangeStatusResourceType[message.resourceType] : message.resourceType;
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                object.campaign = $root.google.protobuf.StringValue.toObject(message.campaign, options);
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                object.adGroup = $root.google.protobuf.StringValue.toObject(message.adGroup, options);
                            if (message.resourceStatus != null && message.hasOwnProperty("resourceStatus"))
                                object.resourceStatus = options.enums === String ? $root.google.ads.googleads.v1.enums.ChangeStatusOperationEnum.ChangeStatusOperation[message.resourceStatus] : message.resourceStatus;
                            if (message.adGroupAd != null && message.hasOwnProperty("adGroupAd"))
                                object.adGroupAd = $root.google.protobuf.StringValue.toObject(message.adGroupAd, options);
                            if (message.adGroupCriterion != null && message.hasOwnProperty("adGroupCriterion"))
                                object.adGroupCriterion = $root.google.protobuf.StringValue.toObject(message.adGroupCriterion, options);
                            if (message.campaignCriterion != null && message.hasOwnProperty("campaignCriterion"))
                                object.campaignCriterion = $root.google.protobuf.StringValue.toObject(message.campaignCriterion, options);
                            if (message.feed != null && message.hasOwnProperty("feed"))
                                object.feed = $root.google.protobuf.StringValue.toObject(message.feed, options);
                            if (message.feedItem != null && message.hasOwnProperty("feedItem"))
                                object.feedItem = $root.google.protobuf.StringValue.toObject(message.feedItem, options);
                            if (message.adGroupFeed != null && message.hasOwnProperty("adGroupFeed"))
                                object.adGroupFeed = $root.google.protobuf.StringValue.toObject(message.adGroupFeed, options);
                            if (message.campaignFeed != null && message.hasOwnProperty("campaignFeed"))
                                object.campaignFeed = $root.google.protobuf.StringValue.toObject(message.campaignFeed, options);
                            if (message.adGroupBidModifier != null && message.hasOwnProperty("adGroupBidModifier"))
                                object.adGroupBidModifier = $root.google.protobuf.StringValue.toObject(message.adGroupBidModifier, options);
                            return object;
                        };

                        /**
                         * Converts this ChangeStatus to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.ChangeStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ChangeStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ChangeStatus;
                    })();

                    resources.ClickView = (function() {

                        /**
                         * Properties of a ClickView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IClickView
                         * @property {string|null} [resourceName] ClickView resourceName
                         * @property {google.protobuf.IStringValue|null} [gclid] ClickView gclid
                         * @property {google.ads.googleads.v1.common.IClickLocation|null} [areaOfInterest] ClickView areaOfInterest
                         * @property {google.ads.googleads.v1.common.IClickLocation|null} [locationOfPresence] ClickView locationOfPresence
                         * @property {google.protobuf.IInt64Value|null} [pageNumber] ClickView pageNumber
                         */

                        /**
                         * Constructs a new ClickView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a ClickView.
                         * @implements IClickView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IClickView=} [properties] Properties to set
                         */
                        function ClickView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ClickView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.ClickView
                         * @instance
                         */
                        ClickView.prototype.resourceName = "";

                        /**
                         * ClickView gclid.
                         * @member {google.protobuf.IStringValue|null|undefined} gclid
                         * @memberof google.ads.googleads.v1.resources.ClickView
                         * @instance
                         */
                        ClickView.prototype.gclid = null;

                        /**
                         * ClickView areaOfInterest.
                         * @member {google.ads.googleads.v1.common.IClickLocation|null|undefined} areaOfInterest
                         * @memberof google.ads.googleads.v1.resources.ClickView
                         * @instance
                         */
                        ClickView.prototype.areaOfInterest = null;

                        /**
                         * ClickView locationOfPresence.
                         * @member {google.ads.googleads.v1.common.IClickLocation|null|undefined} locationOfPresence
                         * @memberof google.ads.googleads.v1.resources.ClickView
                         * @instance
                         */
                        ClickView.prototype.locationOfPresence = null;

                        /**
                         * ClickView pageNumber.
                         * @member {google.protobuf.IInt64Value|null|undefined} pageNumber
                         * @memberof google.ads.googleads.v1.resources.ClickView
                         * @instance
                         */
                        ClickView.prototype.pageNumber = null;

                        /**
                         * Creates a new ClickView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.ClickView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IClickView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.ClickView} ClickView instance
                         */
                        ClickView.create = function create(properties) {
                            return new ClickView(properties);
                        };

                        /**
                         * Encodes the specified ClickView message. Does not implicitly {@link google.ads.googleads.v1.resources.ClickView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.ClickView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IClickView} message ClickView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ClickView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.gclid != null && message.hasOwnProperty("gclid"))
                                $root.google.protobuf.StringValue.encode(message.gclid, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.areaOfInterest != null && message.hasOwnProperty("areaOfInterest"))
                                $root.google.ads.googleads.v1.common.ClickLocation.encode(message.areaOfInterest, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.locationOfPresence != null && message.hasOwnProperty("locationOfPresence"))
                                $root.google.ads.googleads.v1.common.ClickLocation.encode(message.locationOfPresence, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.pageNumber != null && message.hasOwnProperty("pageNumber"))
                                $root.google.protobuf.Int64Value.encode(message.pageNumber, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ClickView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.ClickView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ClickView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IClickView} message ClickView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ClickView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ClickView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.ClickView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.ClickView} ClickView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ClickView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.ClickView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.gclid = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.areaOfInterest = $root.google.ads.googleads.v1.common.ClickLocation.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.locationOfPresence = $root.google.ads.googleads.v1.common.ClickLocation.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.pageNumber = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ClickView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ClickView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.ClickView} ClickView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ClickView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ClickView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.ClickView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ClickView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.gclid != null && message.hasOwnProperty("gclid")) {
                                var error = $root.google.protobuf.StringValue.verify(message.gclid);
                                if (error)
                                    return "gclid." + error;
                            }
                            if (message.areaOfInterest != null && message.hasOwnProperty("areaOfInterest")) {
                                var error = $root.google.ads.googleads.v1.common.ClickLocation.verify(message.areaOfInterest);
                                if (error)
                                    return "areaOfInterest." + error;
                            }
                            if (message.locationOfPresence != null && message.hasOwnProperty("locationOfPresence")) {
                                var error = $root.google.ads.googleads.v1.common.ClickLocation.verify(message.locationOfPresence);
                                if (error)
                                    return "locationOfPresence." + error;
                            }
                            if (message.pageNumber != null && message.hasOwnProperty("pageNumber")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.pageNumber);
                                if (error)
                                    return "pageNumber." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a ClickView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.ClickView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.ClickView} ClickView
                         */
                        ClickView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.ClickView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.ClickView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.gclid != null) {
                                if (typeof object.gclid !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ClickView.gclid: object expected");
                                message.gclid = $root.google.protobuf.StringValue.fromObject(object.gclid);
                            }
                            if (object.areaOfInterest != null) {
                                if (typeof object.areaOfInterest !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ClickView.areaOfInterest: object expected");
                                message.areaOfInterest = $root.google.ads.googleads.v1.common.ClickLocation.fromObject(object.areaOfInterest);
                            }
                            if (object.locationOfPresence != null) {
                                if (typeof object.locationOfPresence !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ClickView.locationOfPresence: object expected");
                                message.locationOfPresence = $root.google.ads.googleads.v1.common.ClickLocation.fromObject(object.locationOfPresence);
                            }
                            if (object.pageNumber != null) {
                                if (typeof object.pageNumber !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ClickView.pageNumber: object expected");
                                message.pageNumber = $root.google.protobuf.Int64Value.fromObject(object.pageNumber);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ClickView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.ClickView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ClickView} message ClickView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ClickView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.gclid = null;
                                object.areaOfInterest = null;
                                object.locationOfPresence = null;
                                object.pageNumber = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.gclid != null && message.hasOwnProperty("gclid"))
                                object.gclid = $root.google.protobuf.StringValue.toObject(message.gclid, options);
                            if (message.areaOfInterest != null && message.hasOwnProperty("areaOfInterest"))
                                object.areaOfInterest = $root.google.ads.googleads.v1.common.ClickLocation.toObject(message.areaOfInterest, options);
                            if (message.locationOfPresence != null && message.hasOwnProperty("locationOfPresence"))
                                object.locationOfPresence = $root.google.ads.googleads.v1.common.ClickLocation.toObject(message.locationOfPresence, options);
                            if (message.pageNumber != null && message.hasOwnProperty("pageNumber"))
                                object.pageNumber = $root.google.protobuf.Int64Value.toObject(message.pageNumber, options);
                            return object;
                        };

                        /**
                         * Converts this ClickView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.ClickView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ClickView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ClickView;
                    })();

                    resources.ConversionAction = (function() {

                        /**
                         * Properties of a ConversionAction.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IConversionAction
                         * @property {string|null} [resourceName] ConversionAction resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] ConversionAction id
                         * @property {google.protobuf.IStringValue|null} [name] ConversionAction name
                         * @property {google.ads.googleads.v1.enums.ConversionActionStatusEnum.ConversionActionStatus|null} [status] ConversionAction status
                         * @property {google.ads.googleads.v1.enums.ConversionActionTypeEnum.ConversionActionType|null} [type] ConversionAction type
                         * @property {google.ads.googleads.v1.enums.ConversionActionCategoryEnum.ConversionActionCategory|null} [category] ConversionAction category
                         * @property {google.protobuf.IStringValue|null} [ownerCustomer] ConversionAction ownerCustomer
                         * @property {google.protobuf.IBoolValue|null} [includeInConversionsMetric] ConversionAction includeInConversionsMetric
                         * @property {google.protobuf.IInt64Value|null} [clickThroughLookbackWindowDays] ConversionAction clickThroughLookbackWindowDays
                         * @property {google.protobuf.IInt64Value|null} [viewThroughLookbackWindowDays] ConversionAction viewThroughLookbackWindowDays
                         * @property {google.ads.googleads.v1.resources.ConversionAction.IValueSettings|null} [valueSettings] ConversionAction valueSettings
                         * @property {google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum.ConversionActionCountingType|null} [countingType] ConversionAction countingType
                         * @property {google.ads.googleads.v1.resources.ConversionAction.IAttributionModelSettings|null} [attributionModelSettings] ConversionAction attributionModelSettings
                         * @property {Array.<google.ads.googleads.v1.common.ITagSnippet>|null} [tagSnippets] ConversionAction tagSnippets
                         * @property {google.protobuf.IInt64Value|null} [phoneCallDurationSeconds] ConversionAction phoneCallDurationSeconds
                         * @property {google.protobuf.IStringValue|null} [appId] ConversionAction appId
                         */

                        /**
                         * Constructs a new ConversionAction.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a ConversionAction.
                         * @implements IConversionAction
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IConversionAction=} [properties] Properties to set
                         */
                        function ConversionAction(properties) {
                            this.tagSnippets = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ConversionAction resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @instance
                         */
                        ConversionAction.prototype.resourceName = "";

                        /**
                         * ConversionAction id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @instance
                         */
                        ConversionAction.prototype.id = null;

                        /**
                         * ConversionAction name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @instance
                         */
                        ConversionAction.prototype.name = null;

                        /**
                         * ConversionAction status.
                         * @member {google.ads.googleads.v1.enums.ConversionActionStatusEnum.ConversionActionStatus} status
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @instance
                         */
                        ConversionAction.prototype.status = 0;

                        /**
                         * ConversionAction type.
                         * @member {google.ads.googleads.v1.enums.ConversionActionTypeEnum.ConversionActionType} type
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @instance
                         */
                        ConversionAction.prototype.type = 0;

                        /**
                         * ConversionAction category.
                         * @member {google.ads.googleads.v1.enums.ConversionActionCategoryEnum.ConversionActionCategory} category
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @instance
                         */
                        ConversionAction.prototype.category = 0;

                        /**
                         * ConversionAction ownerCustomer.
                         * @member {google.protobuf.IStringValue|null|undefined} ownerCustomer
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @instance
                         */
                        ConversionAction.prototype.ownerCustomer = null;

                        /**
                         * ConversionAction includeInConversionsMetric.
                         * @member {google.protobuf.IBoolValue|null|undefined} includeInConversionsMetric
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @instance
                         */
                        ConversionAction.prototype.includeInConversionsMetric = null;

                        /**
                         * ConversionAction clickThroughLookbackWindowDays.
                         * @member {google.protobuf.IInt64Value|null|undefined} clickThroughLookbackWindowDays
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @instance
                         */
                        ConversionAction.prototype.clickThroughLookbackWindowDays = null;

                        /**
                         * ConversionAction viewThroughLookbackWindowDays.
                         * @member {google.protobuf.IInt64Value|null|undefined} viewThroughLookbackWindowDays
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @instance
                         */
                        ConversionAction.prototype.viewThroughLookbackWindowDays = null;

                        /**
                         * ConversionAction valueSettings.
                         * @member {google.ads.googleads.v1.resources.ConversionAction.IValueSettings|null|undefined} valueSettings
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @instance
                         */
                        ConversionAction.prototype.valueSettings = null;

                        /**
                         * ConversionAction countingType.
                         * @member {google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum.ConversionActionCountingType} countingType
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @instance
                         */
                        ConversionAction.prototype.countingType = 0;

                        /**
                         * ConversionAction attributionModelSettings.
                         * @member {google.ads.googleads.v1.resources.ConversionAction.IAttributionModelSettings|null|undefined} attributionModelSettings
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @instance
                         */
                        ConversionAction.prototype.attributionModelSettings = null;

                        /**
                         * ConversionAction tagSnippets.
                         * @member {Array.<google.ads.googleads.v1.common.ITagSnippet>} tagSnippets
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @instance
                         */
                        ConversionAction.prototype.tagSnippets = $util.emptyArray;

                        /**
                         * ConversionAction phoneCallDurationSeconds.
                         * @member {google.protobuf.IInt64Value|null|undefined} phoneCallDurationSeconds
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @instance
                         */
                        ConversionAction.prototype.phoneCallDurationSeconds = null;

                        /**
                         * ConversionAction appId.
                         * @member {google.protobuf.IStringValue|null|undefined} appId
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @instance
                         */
                        ConversionAction.prototype.appId = null;

                        /**
                         * Creates a new ConversionAction instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @static
                         * @param {google.ads.googleads.v1.resources.IConversionAction=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.ConversionAction} ConversionAction instance
                         */
                        ConversionAction.create = function create(properties) {
                            return new ConversionAction(properties);
                        };

                        /**
                         * Encodes the specified ConversionAction message. Does not implicitly {@link google.ads.googleads.v1.resources.ConversionAction.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @static
                         * @param {google.ads.googleads.v1.resources.IConversionAction} message ConversionAction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionAction.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.status);
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.type);
                            if (message.category != null && message.hasOwnProperty("category"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.category);
                            if (message.ownerCustomer != null && message.hasOwnProperty("ownerCustomer"))
                                $root.google.protobuf.StringValue.encode(message.ownerCustomer, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.includeInConversionsMetric != null && message.hasOwnProperty("includeInConversionsMetric"))
                                $root.google.protobuf.BoolValue.encode(message.includeInConversionsMetric, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.clickThroughLookbackWindowDays != null && message.hasOwnProperty("clickThroughLookbackWindowDays"))
                                $root.google.protobuf.Int64Value.encode(message.clickThroughLookbackWindowDays, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.viewThroughLookbackWindowDays != null && message.hasOwnProperty("viewThroughLookbackWindowDays"))
                                $root.google.protobuf.Int64Value.encode(message.viewThroughLookbackWindowDays, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.valueSettings != null && message.hasOwnProperty("valueSettings"))
                                $root.google.ads.googleads.v1.resources.ConversionAction.ValueSettings.encode(message.valueSettings, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.countingType != null && message.hasOwnProperty("countingType"))
                                writer.uint32(/* id 12, wireType 0 =*/96).int32(message.countingType);
                            if (message.attributionModelSettings != null && message.hasOwnProperty("attributionModelSettings"))
                                $root.google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings.encode(message.attributionModelSettings, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                            if (message.tagSnippets != null && message.tagSnippets.length)
                                for (var i = 0; i < message.tagSnippets.length; ++i)
                                    $root.google.ads.googleads.v1.common.TagSnippet.encode(message.tagSnippets[i], writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.phoneCallDurationSeconds != null && message.hasOwnProperty("phoneCallDurationSeconds"))
                                $root.google.protobuf.Int64Value.encode(message.phoneCallDurationSeconds, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
                            if (message.appId != null && message.hasOwnProperty("appId"))
                                $root.google.protobuf.StringValue.encode(message.appId, writer.uint32(/* id 16, wireType 2 =*/130).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ConversionAction message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.ConversionAction.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @static
                         * @param {google.ads.googleads.v1.resources.IConversionAction} message ConversionAction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionAction.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ConversionAction message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.ConversionAction} ConversionAction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionAction.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.ConversionAction();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.status = reader.int32();
                                    break;
                                case 5:
                                    message.type = reader.int32();
                                    break;
                                case 6:
                                    message.category = reader.int32();
                                    break;
                                case 7:
                                    message.ownerCustomer = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.includeInConversionsMetric = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.clickThroughLookbackWindowDays = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.viewThroughLookbackWindowDays = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.valueSettings = $root.google.ads.googleads.v1.resources.ConversionAction.ValueSettings.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.countingType = reader.int32();
                                    break;
                                case 13:
                                    message.attributionModelSettings = $root.google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings.decode(reader, reader.uint32());
                                    break;
                                case 14:
                                    if (!(message.tagSnippets && message.tagSnippets.length))
                                        message.tagSnippets = [];
                                    message.tagSnippets.push($root.google.ads.googleads.v1.common.TagSnippet.decode(reader, reader.uint32()));
                                    break;
                                case 15:
                                    message.phoneCallDurationSeconds = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 16:
                                    message.appId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ConversionAction message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.ConversionAction} ConversionAction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionAction.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ConversionAction message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConversionAction.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                    break;
                                }
                            if (message.category != null && message.hasOwnProperty("category"))
                                switch (message.category) {
                                default:
                                    return "category: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            if (message.ownerCustomer != null && message.hasOwnProperty("ownerCustomer")) {
                                var error = $root.google.protobuf.StringValue.verify(message.ownerCustomer);
                                if (error)
                                    return "ownerCustomer." + error;
                            }
                            if (message.includeInConversionsMetric != null && message.hasOwnProperty("includeInConversionsMetric")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.includeInConversionsMetric);
                                if (error)
                                    return "includeInConversionsMetric." + error;
                            }
                            if (message.clickThroughLookbackWindowDays != null && message.hasOwnProperty("clickThroughLookbackWindowDays")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.clickThroughLookbackWindowDays);
                                if (error)
                                    return "clickThroughLookbackWindowDays." + error;
                            }
                            if (message.viewThroughLookbackWindowDays != null && message.hasOwnProperty("viewThroughLookbackWindowDays")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.viewThroughLookbackWindowDays);
                                if (error)
                                    return "viewThroughLookbackWindowDays." + error;
                            }
                            if (message.valueSettings != null && message.hasOwnProperty("valueSettings")) {
                                var error = $root.google.ads.googleads.v1.resources.ConversionAction.ValueSettings.verify(message.valueSettings);
                                if (error)
                                    return "valueSettings." + error;
                            }
                            if (message.countingType != null && message.hasOwnProperty("countingType"))
                                switch (message.countingType) {
                                default:
                                    return "countingType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.attributionModelSettings != null && message.hasOwnProperty("attributionModelSettings")) {
                                var error = $root.google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings.verify(message.attributionModelSettings);
                                if (error)
                                    return "attributionModelSettings." + error;
                            }
                            if (message.tagSnippets != null && message.hasOwnProperty("tagSnippets")) {
                                if (!Array.isArray(message.tagSnippets))
                                    return "tagSnippets: array expected";
                                for (var i = 0; i < message.tagSnippets.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.TagSnippet.verify(message.tagSnippets[i]);
                                    if (error)
                                        return "tagSnippets." + error;
                                }
                            }
                            if (message.phoneCallDurationSeconds != null && message.hasOwnProperty("phoneCallDurationSeconds")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.phoneCallDurationSeconds);
                                if (error)
                                    return "phoneCallDurationSeconds." + error;
                            }
                            if (message.appId != null && message.hasOwnProperty("appId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.appId);
                                if (error)
                                    return "appId." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a ConversionAction message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.ConversionAction} ConversionAction
                         */
                        ConversionAction.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.ConversionAction)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.ConversionAction();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ConversionAction.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ConversionAction.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "REMOVED":
                            case 3:
                                message.status = 3;
                                break;
                            case "HIDDEN":
                            case 4:
                                message.status = 4;
                                break;
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "AD_CALL":
                            case 2:
                                message.type = 2;
                                break;
                            case "CLICK_TO_CALL":
                            case 3:
                                message.type = 3;
                                break;
                            case "GOOGLE_PLAY_DOWNLOAD":
                            case 4:
                                message.type = 4;
                                break;
                            case "GOOGLE_PLAY_IN_APP_PURCHASE":
                            case 5:
                                message.type = 5;
                                break;
                            case "UPLOAD_CALLS":
                            case 6:
                                message.type = 6;
                                break;
                            case "UPLOAD_CLICKS":
                            case 7:
                                message.type = 7;
                                break;
                            case "WEBPAGE":
                            case 8:
                                message.type = 8;
                                break;
                            case "WEBSITE_CALL":
                            case 9:
                                message.type = 9;
                                break;
                            }
                            switch (object.category) {
                            case "UNSPECIFIED":
                            case 0:
                                message.category = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.category = 1;
                                break;
                            case "DEFAULT":
                            case 2:
                                message.category = 2;
                                break;
                            case "PAGE_VIEW":
                            case 3:
                                message.category = 3;
                                break;
                            case "PURCHASE":
                            case 4:
                                message.category = 4;
                                break;
                            case "SIGNUP":
                            case 5:
                                message.category = 5;
                                break;
                            case "LEAD":
                            case 6:
                                message.category = 6;
                                break;
                            case "DOWNLOAD":
                            case 7:
                                message.category = 7;
                                break;
                            }
                            if (object.ownerCustomer != null) {
                                if (typeof object.ownerCustomer !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ConversionAction.ownerCustomer: object expected");
                                message.ownerCustomer = $root.google.protobuf.StringValue.fromObject(object.ownerCustomer);
                            }
                            if (object.includeInConversionsMetric != null) {
                                if (typeof object.includeInConversionsMetric !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ConversionAction.includeInConversionsMetric: object expected");
                                message.includeInConversionsMetric = $root.google.protobuf.BoolValue.fromObject(object.includeInConversionsMetric);
                            }
                            if (object.clickThroughLookbackWindowDays != null) {
                                if (typeof object.clickThroughLookbackWindowDays !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ConversionAction.clickThroughLookbackWindowDays: object expected");
                                message.clickThroughLookbackWindowDays = $root.google.protobuf.Int64Value.fromObject(object.clickThroughLookbackWindowDays);
                            }
                            if (object.viewThroughLookbackWindowDays != null) {
                                if (typeof object.viewThroughLookbackWindowDays !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ConversionAction.viewThroughLookbackWindowDays: object expected");
                                message.viewThroughLookbackWindowDays = $root.google.protobuf.Int64Value.fromObject(object.viewThroughLookbackWindowDays);
                            }
                            if (object.valueSettings != null) {
                                if (typeof object.valueSettings !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ConversionAction.valueSettings: object expected");
                                message.valueSettings = $root.google.ads.googleads.v1.resources.ConversionAction.ValueSettings.fromObject(object.valueSettings);
                            }
                            switch (object.countingType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.countingType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.countingType = 1;
                                break;
                            case "ONE_PER_CLICK":
                            case 2:
                                message.countingType = 2;
                                break;
                            case "MANY_PER_CLICK":
                            case 3:
                                message.countingType = 3;
                                break;
                            }
                            if (object.attributionModelSettings != null) {
                                if (typeof object.attributionModelSettings !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ConversionAction.attributionModelSettings: object expected");
                                message.attributionModelSettings = $root.google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings.fromObject(object.attributionModelSettings);
                            }
                            if (object.tagSnippets) {
                                if (!Array.isArray(object.tagSnippets))
                                    throw TypeError(".google.ads.googleads.v1.resources.ConversionAction.tagSnippets: array expected");
                                message.tagSnippets = [];
                                for (var i = 0; i < object.tagSnippets.length; ++i) {
                                    if (typeof object.tagSnippets[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.ConversionAction.tagSnippets: object expected");
                                    message.tagSnippets[i] = $root.google.ads.googleads.v1.common.TagSnippet.fromObject(object.tagSnippets[i]);
                                }
                            }
                            if (object.phoneCallDurationSeconds != null) {
                                if (typeof object.phoneCallDurationSeconds !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ConversionAction.phoneCallDurationSeconds: object expected");
                                message.phoneCallDurationSeconds = $root.google.protobuf.Int64Value.fromObject(object.phoneCallDurationSeconds);
                            }
                            if (object.appId != null) {
                                if (typeof object.appId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ConversionAction.appId: object expected");
                                message.appId = $root.google.protobuf.StringValue.fromObject(object.appId);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ConversionAction message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @static
                         * @param {google.ads.googleads.v1.resources.ConversionAction} message ConversionAction
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConversionAction.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.tagSnippets = [];
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.name = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.category = options.enums === String ? "UNSPECIFIED" : 0;
                                object.ownerCustomer = null;
                                object.includeInConversionsMetric = null;
                                object.clickThroughLookbackWindowDays = null;
                                object.viewThroughLookbackWindowDays = null;
                                object.valueSettings = null;
                                object.countingType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.attributionModelSettings = null;
                                object.phoneCallDurationSeconds = null;
                                object.appId = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.ConversionActionStatusEnum.ConversionActionStatus[message.status] : message.status;
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.ConversionActionTypeEnum.ConversionActionType[message.type] : message.type;
                            if (message.category != null && message.hasOwnProperty("category"))
                                object.category = options.enums === String ? $root.google.ads.googleads.v1.enums.ConversionActionCategoryEnum.ConversionActionCategory[message.category] : message.category;
                            if (message.ownerCustomer != null && message.hasOwnProperty("ownerCustomer"))
                                object.ownerCustomer = $root.google.protobuf.StringValue.toObject(message.ownerCustomer, options);
                            if (message.includeInConversionsMetric != null && message.hasOwnProperty("includeInConversionsMetric"))
                                object.includeInConversionsMetric = $root.google.protobuf.BoolValue.toObject(message.includeInConversionsMetric, options);
                            if (message.clickThroughLookbackWindowDays != null && message.hasOwnProperty("clickThroughLookbackWindowDays"))
                                object.clickThroughLookbackWindowDays = $root.google.protobuf.Int64Value.toObject(message.clickThroughLookbackWindowDays, options);
                            if (message.viewThroughLookbackWindowDays != null && message.hasOwnProperty("viewThroughLookbackWindowDays"))
                                object.viewThroughLookbackWindowDays = $root.google.protobuf.Int64Value.toObject(message.viewThroughLookbackWindowDays, options);
                            if (message.valueSettings != null && message.hasOwnProperty("valueSettings"))
                                object.valueSettings = $root.google.ads.googleads.v1.resources.ConversionAction.ValueSettings.toObject(message.valueSettings, options);
                            if (message.countingType != null && message.hasOwnProperty("countingType"))
                                object.countingType = options.enums === String ? $root.google.ads.googleads.v1.enums.ConversionActionCountingTypeEnum.ConversionActionCountingType[message.countingType] : message.countingType;
                            if (message.attributionModelSettings != null && message.hasOwnProperty("attributionModelSettings"))
                                object.attributionModelSettings = $root.google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings.toObject(message.attributionModelSettings, options);
                            if (message.tagSnippets && message.tagSnippets.length) {
                                object.tagSnippets = [];
                                for (var j = 0; j < message.tagSnippets.length; ++j)
                                    object.tagSnippets[j] = $root.google.ads.googleads.v1.common.TagSnippet.toObject(message.tagSnippets[j], options);
                            }
                            if (message.phoneCallDurationSeconds != null && message.hasOwnProperty("phoneCallDurationSeconds"))
                                object.phoneCallDurationSeconds = $root.google.protobuf.Int64Value.toObject(message.phoneCallDurationSeconds, options);
                            if (message.appId != null && message.hasOwnProperty("appId"))
                                object.appId = $root.google.protobuf.StringValue.toObject(message.appId, options);
                            return object;
                        };

                        /**
                         * Converts this ConversionAction to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.ConversionAction
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConversionAction.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        ConversionAction.AttributionModelSettings = (function() {

                            /**
                             * Properties of an AttributionModelSettings.
                             * @memberof google.ads.googleads.v1.resources.ConversionAction
                             * @interface IAttributionModelSettings
                             * @property {google.ads.googleads.v1.enums.AttributionModelEnum.AttributionModel|null} [attributionModel] AttributionModelSettings attributionModel
                             * @property {google.ads.googleads.v1.enums.DataDrivenModelStatusEnum.DataDrivenModelStatus|null} [dataDrivenModelStatus] AttributionModelSettings dataDrivenModelStatus
                             */

                            /**
                             * Constructs a new AttributionModelSettings.
                             * @memberof google.ads.googleads.v1.resources.ConversionAction
                             * @classdesc Represents an AttributionModelSettings.
                             * @implements IAttributionModelSettings
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.ConversionAction.IAttributionModelSettings=} [properties] Properties to set
                             */
                            function AttributionModelSettings(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * AttributionModelSettings attributionModel.
                             * @member {google.ads.googleads.v1.enums.AttributionModelEnum.AttributionModel} attributionModel
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings
                             * @instance
                             */
                            AttributionModelSettings.prototype.attributionModel = 0;

                            /**
                             * AttributionModelSettings dataDrivenModelStatus.
                             * @member {google.ads.googleads.v1.enums.DataDrivenModelStatusEnum.DataDrivenModelStatus} dataDrivenModelStatus
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings
                             * @instance
                             */
                            AttributionModelSettings.prototype.dataDrivenModelStatus = 0;

                            /**
                             * Creates a new AttributionModelSettings instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings
                             * @static
                             * @param {google.ads.googleads.v1.resources.ConversionAction.IAttributionModelSettings=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings} AttributionModelSettings instance
                             */
                            AttributionModelSettings.create = function create(properties) {
                                return new AttributionModelSettings(properties);
                            };

                            /**
                             * Encodes the specified AttributionModelSettings message. Does not implicitly {@link google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings
                             * @static
                             * @param {google.ads.googleads.v1.resources.ConversionAction.IAttributionModelSettings} message AttributionModelSettings message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            AttributionModelSettings.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.attributionModel != null && message.hasOwnProperty("attributionModel"))
                                    writer.uint32(/* id 1, wireType 0 =*/8).int32(message.attributionModel);
                                if (message.dataDrivenModelStatus != null && message.hasOwnProperty("dataDrivenModelStatus"))
                                    writer.uint32(/* id 2, wireType 0 =*/16).int32(message.dataDrivenModelStatus);
                                return writer;
                            };

                            /**
                             * Encodes the specified AttributionModelSettings message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings
                             * @static
                             * @param {google.ads.googleads.v1.resources.ConversionAction.IAttributionModelSettings} message AttributionModelSettings message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            AttributionModelSettings.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes an AttributionModelSettings message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings} AttributionModelSettings
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            AttributionModelSettings.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.attributionModel = reader.int32();
                                        break;
                                    case 2:
                                        message.dataDrivenModelStatus = reader.int32();
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes an AttributionModelSettings message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings} AttributionModelSettings
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            AttributionModelSettings.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies an AttributionModelSettings message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            AttributionModelSettings.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.attributionModel != null && message.hasOwnProperty("attributionModel"))
                                    switch (message.attributionModel) {
                                    default:
                                        return "attributionModel: enum value expected";
                                    case 0:
                                    case 1:
                                    case 100:
                                    case 101:
                                    case 102:
                                    case 103:
                                    case 104:
                                    case 105:
                                    case 106:
                                        break;
                                    }
                                if (message.dataDrivenModelStatus != null && message.hasOwnProperty("dataDrivenModelStatus"))
                                    switch (message.dataDrivenModelStatus) {
                                    default:
                                        return "dataDrivenModelStatus: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                    case 5:
                                        break;
                                    }
                                return null;
                            };

                            /**
                             * Creates an AttributionModelSettings message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings} AttributionModelSettings
                             */
                            AttributionModelSettings.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings();
                                switch (object.attributionModel) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.attributionModel = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.attributionModel = 1;
                                    break;
                                case "EXTERNAL":
                                case 100:
                                    message.attributionModel = 100;
                                    break;
                                case "GOOGLE_ADS_LAST_CLICK":
                                case 101:
                                    message.attributionModel = 101;
                                    break;
                                case "GOOGLE_SEARCH_ATTRIBUTION_FIRST_CLICK":
                                case 102:
                                    message.attributionModel = 102;
                                    break;
                                case "GOOGLE_SEARCH_ATTRIBUTION_LINEAR":
                                case 103:
                                    message.attributionModel = 103;
                                    break;
                                case "GOOGLE_SEARCH_ATTRIBUTION_TIME_DECAY":
                                case 104:
                                    message.attributionModel = 104;
                                    break;
                                case "GOOGLE_SEARCH_ATTRIBUTION_POSITION_BASED":
                                case 105:
                                    message.attributionModel = 105;
                                    break;
                                case "GOOGLE_SEARCH_ATTRIBUTION_DATA_DRIVEN":
                                case 106:
                                    message.attributionModel = 106;
                                    break;
                                }
                                switch (object.dataDrivenModelStatus) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.dataDrivenModelStatus = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.dataDrivenModelStatus = 1;
                                    break;
                                case "AVAILABLE":
                                case 2:
                                    message.dataDrivenModelStatus = 2;
                                    break;
                                case "STALE":
                                case 3:
                                    message.dataDrivenModelStatus = 3;
                                    break;
                                case "EXPIRED":
                                case 4:
                                    message.dataDrivenModelStatus = 4;
                                    break;
                                case "NEVER_GENERATED":
                                case 5:
                                    message.dataDrivenModelStatus = 5;
                                    break;
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from an AttributionModelSettings message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings
                             * @static
                             * @param {google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings} message AttributionModelSettings
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            AttributionModelSettings.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.attributionModel = options.enums === String ? "UNSPECIFIED" : 0;
                                    object.dataDrivenModelStatus = options.enums === String ? "UNSPECIFIED" : 0;
                                }
                                if (message.attributionModel != null && message.hasOwnProperty("attributionModel"))
                                    object.attributionModel = options.enums === String ? $root.google.ads.googleads.v1.enums.AttributionModelEnum.AttributionModel[message.attributionModel] : message.attributionModel;
                                if (message.dataDrivenModelStatus != null && message.hasOwnProperty("dataDrivenModelStatus"))
                                    object.dataDrivenModelStatus = options.enums === String ? $root.google.ads.googleads.v1.enums.DataDrivenModelStatusEnum.DataDrivenModelStatus[message.dataDrivenModelStatus] : message.dataDrivenModelStatus;
                                return object;
                            };

                            /**
                             * Converts this AttributionModelSettings to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.AttributionModelSettings
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            AttributionModelSettings.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return AttributionModelSettings;
                        })();

                        ConversionAction.ValueSettings = (function() {

                            /**
                             * Properties of a ValueSettings.
                             * @memberof google.ads.googleads.v1.resources.ConversionAction
                             * @interface IValueSettings
                             * @property {google.protobuf.IDoubleValue|null} [defaultValue] ValueSettings defaultValue
                             * @property {google.protobuf.IStringValue|null} [defaultCurrencyCode] ValueSettings defaultCurrencyCode
                             * @property {google.protobuf.IBoolValue|null} [alwaysUseDefaultValue] ValueSettings alwaysUseDefaultValue
                             */

                            /**
                             * Constructs a new ValueSettings.
                             * @memberof google.ads.googleads.v1.resources.ConversionAction
                             * @classdesc Represents a ValueSettings.
                             * @implements IValueSettings
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.ConversionAction.IValueSettings=} [properties] Properties to set
                             */
                            function ValueSettings(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * ValueSettings defaultValue.
                             * @member {google.protobuf.IDoubleValue|null|undefined} defaultValue
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.ValueSettings
                             * @instance
                             */
                            ValueSettings.prototype.defaultValue = null;

                            /**
                             * ValueSettings defaultCurrencyCode.
                             * @member {google.protobuf.IStringValue|null|undefined} defaultCurrencyCode
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.ValueSettings
                             * @instance
                             */
                            ValueSettings.prototype.defaultCurrencyCode = null;

                            /**
                             * ValueSettings alwaysUseDefaultValue.
                             * @member {google.protobuf.IBoolValue|null|undefined} alwaysUseDefaultValue
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.ValueSettings
                             * @instance
                             */
                            ValueSettings.prototype.alwaysUseDefaultValue = null;

                            /**
                             * Creates a new ValueSettings instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.ValueSettings
                             * @static
                             * @param {google.ads.googleads.v1.resources.ConversionAction.IValueSettings=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.ConversionAction.ValueSettings} ValueSettings instance
                             */
                            ValueSettings.create = function create(properties) {
                                return new ValueSettings(properties);
                            };

                            /**
                             * Encodes the specified ValueSettings message. Does not implicitly {@link google.ads.googleads.v1.resources.ConversionAction.ValueSettings.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.ValueSettings
                             * @static
                             * @param {google.ads.googleads.v1.resources.ConversionAction.IValueSettings} message ValueSettings message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            ValueSettings.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.defaultValue != null && message.hasOwnProperty("defaultValue"))
                                    $root.google.protobuf.DoubleValue.encode(message.defaultValue, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.defaultCurrencyCode != null && message.hasOwnProperty("defaultCurrencyCode"))
                                    $root.google.protobuf.StringValue.encode(message.defaultCurrencyCode, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                if (message.alwaysUseDefaultValue != null && message.hasOwnProperty("alwaysUseDefaultValue"))
                                    $root.google.protobuf.BoolValue.encode(message.alwaysUseDefaultValue, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified ValueSettings message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.ConversionAction.ValueSettings.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.ValueSettings
                             * @static
                             * @param {google.ads.googleads.v1.resources.ConversionAction.IValueSettings} message ValueSettings message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            ValueSettings.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a ValueSettings message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.ValueSettings
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.ConversionAction.ValueSettings} ValueSettings
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            ValueSettings.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.ConversionAction.ValueSettings();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.defaultValue = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.defaultCurrencyCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 3:
                                        message.alwaysUseDefaultValue = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a ValueSettings message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.ValueSettings
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.ConversionAction.ValueSettings} ValueSettings
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            ValueSettings.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a ValueSettings message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.ValueSettings
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            ValueSettings.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.defaultValue != null && message.hasOwnProperty("defaultValue")) {
                                    var error = $root.google.protobuf.DoubleValue.verify(message.defaultValue);
                                    if (error)
                                        return "defaultValue." + error;
                                }
                                if (message.defaultCurrencyCode != null && message.hasOwnProperty("defaultCurrencyCode")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.defaultCurrencyCode);
                                    if (error)
                                        return "defaultCurrencyCode." + error;
                                }
                                if (message.alwaysUseDefaultValue != null && message.hasOwnProperty("alwaysUseDefaultValue")) {
                                    var error = $root.google.protobuf.BoolValue.verify(message.alwaysUseDefaultValue);
                                    if (error)
                                        return "alwaysUseDefaultValue." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a ValueSettings message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.ValueSettings
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.ConversionAction.ValueSettings} ValueSettings
                             */
                            ValueSettings.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.ConversionAction.ValueSettings)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.ConversionAction.ValueSettings();
                                if (object.defaultValue != null) {
                                    if (typeof object.defaultValue !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.ConversionAction.ValueSettings.defaultValue: object expected");
                                    message.defaultValue = $root.google.protobuf.DoubleValue.fromObject(object.defaultValue);
                                }
                                if (object.defaultCurrencyCode != null) {
                                    if (typeof object.defaultCurrencyCode !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.ConversionAction.ValueSettings.defaultCurrencyCode: object expected");
                                    message.defaultCurrencyCode = $root.google.protobuf.StringValue.fromObject(object.defaultCurrencyCode);
                                }
                                if (object.alwaysUseDefaultValue != null) {
                                    if (typeof object.alwaysUseDefaultValue !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.ConversionAction.ValueSettings.alwaysUseDefaultValue: object expected");
                                    message.alwaysUseDefaultValue = $root.google.protobuf.BoolValue.fromObject(object.alwaysUseDefaultValue);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a ValueSettings message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.ValueSettings
                             * @static
                             * @param {google.ads.googleads.v1.resources.ConversionAction.ValueSettings} message ValueSettings
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            ValueSettings.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.defaultValue = null;
                                    object.defaultCurrencyCode = null;
                                    object.alwaysUseDefaultValue = null;
                                }
                                if (message.defaultValue != null && message.hasOwnProperty("defaultValue"))
                                    object.defaultValue = $root.google.protobuf.DoubleValue.toObject(message.defaultValue, options);
                                if (message.defaultCurrencyCode != null && message.hasOwnProperty("defaultCurrencyCode"))
                                    object.defaultCurrencyCode = $root.google.protobuf.StringValue.toObject(message.defaultCurrencyCode, options);
                                if (message.alwaysUseDefaultValue != null && message.hasOwnProperty("alwaysUseDefaultValue"))
                                    object.alwaysUseDefaultValue = $root.google.protobuf.BoolValue.toObject(message.alwaysUseDefaultValue, options);
                                return object;
                            };

                            /**
                             * Converts this ValueSettings to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.ConversionAction.ValueSettings
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            ValueSettings.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return ValueSettings;
                        })();

                        return ConversionAction;
                    })();

                    resources.CustomInterest = (function() {

                        /**
                         * Properties of a CustomInterest.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICustomInterest
                         * @property {string|null} [resourceName] CustomInterest resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] CustomInterest id
                         * @property {google.ads.googleads.v1.enums.CustomInterestStatusEnum.CustomInterestStatus|null} [status] CustomInterest status
                         * @property {google.protobuf.IStringValue|null} [name] CustomInterest name
                         * @property {google.ads.googleads.v1.enums.CustomInterestTypeEnum.CustomInterestType|null} [type] CustomInterest type
                         * @property {google.protobuf.IStringValue|null} [description] CustomInterest description
                         * @property {Array.<google.ads.googleads.v1.resources.ICustomInterestMember>|null} [members] CustomInterest members
                         */

                        /**
                         * Constructs a new CustomInterest.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CustomInterest.
                         * @implements ICustomInterest
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICustomInterest=} [properties] Properties to set
                         */
                        function CustomInterest(properties) {
                            this.members = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomInterest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.CustomInterest
                         * @instance
                         */
                        CustomInterest.prototype.resourceName = "";

                        /**
                         * CustomInterest id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.CustomInterest
                         * @instance
                         */
                        CustomInterest.prototype.id = null;

                        /**
                         * CustomInterest status.
                         * @member {google.ads.googleads.v1.enums.CustomInterestStatusEnum.CustomInterestStatus} status
                         * @memberof google.ads.googleads.v1.resources.CustomInterest
                         * @instance
                         */
                        CustomInterest.prototype.status = 0;

                        /**
                         * CustomInterest name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.CustomInterest
                         * @instance
                         */
                        CustomInterest.prototype.name = null;

                        /**
                         * CustomInterest type.
                         * @member {google.ads.googleads.v1.enums.CustomInterestTypeEnum.CustomInterestType} type
                         * @memberof google.ads.googleads.v1.resources.CustomInterest
                         * @instance
                         */
                        CustomInterest.prototype.type = 0;

                        /**
                         * CustomInterest description.
                         * @member {google.protobuf.IStringValue|null|undefined} description
                         * @memberof google.ads.googleads.v1.resources.CustomInterest
                         * @instance
                         */
                        CustomInterest.prototype.description = null;

                        /**
                         * CustomInterest members.
                         * @member {Array.<google.ads.googleads.v1.resources.ICustomInterestMember>} members
                         * @memberof google.ads.googleads.v1.resources.CustomInterest
                         * @instance
                         */
                        CustomInterest.prototype.members = $util.emptyArray;

                        /**
                         * Creates a new CustomInterest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CustomInterest
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomInterest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CustomInterest} CustomInterest instance
                         */
                        CustomInterest.create = function create(properties) {
                            return new CustomInterest(properties);
                        };

                        /**
                         * Encodes the specified CustomInterest message. Does not implicitly {@link google.ads.googleads.v1.resources.CustomInterest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CustomInterest
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomInterest} message CustomInterest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomInterest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.status);
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.type);
                            if (message.description != null && message.hasOwnProperty("description"))
                                $root.google.protobuf.StringValue.encode(message.description, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.members != null && message.members.length)
                                for (var i = 0; i < message.members.length; ++i)
                                    $root.google.ads.googleads.v1.resources.CustomInterestMember.encode(message.members[i], writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomInterest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CustomInterest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CustomInterest
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomInterest} message CustomInterest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomInterest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomInterest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CustomInterest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CustomInterest} CustomInterest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomInterest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CustomInterest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.status = reader.int32();
                                    break;
                                case 4:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.type = reader.int32();
                                    break;
                                case 6:
                                    message.description = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    if (!(message.members && message.members.length))
                                        message.members = [];
                                    message.members.push($root.google.ads.googleads.v1.resources.CustomInterestMember.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomInterest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CustomInterest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CustomInterest} CustomInterest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomInterest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomInterest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CustomInterest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomInterest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                var error = $root.google.protobuf.StringValue.verify(message.description);
                                if (error)
                                    return "description." + error;
                            }
                            if (message.members != null && message.hasOwnProperty("members")) {
                                if (!Array.isArray(message.members))
                                    return "members: array expected";
                                for (var i = 0; i < message.members.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.resources.CustomInterestMember.verify(message.members[i]);
                                    if (error)
                                        return "members." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a CustomInterest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CustomInterest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CustomInterest} CustomInterest
                         */
                        CustomInterest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CustomInterest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CustomInterest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomInterest.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "REMOVED":
                            case 3:
                                message.status = 3;
                                break;
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomInterest.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "CUSTOM_AFFINITY":
                            case 2:
                                message.type = 2;
                                break;
                            case "CUSTOM_INTENT":
                            case 3:
                                message.type = 3;
                                break;
                            }
                            if (object.description != null) {
                                if (typeof object.description !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomInterest.description: object expected");
                                message.description = $root.google.protobuf.StringValue.fromObject(object.description);
                            }
                            if (object.members) {
                                if (!Array.isArray(object.members))
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomInterest.members: array expected");
                                message.members = [];
                                for (var i = 0; i < object.members.length; ++i) {
                                    if (typeof object.members[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.CustomInterest.members: object expected");
                                    message.members[i] = $root.google.ads.googleads.v1.resources.CustomInterestMember.fromObject(object.members[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomInterest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CustomInterest
                         * @static
                         * @param {google.ads.googleads.v1.resources.CustomInterest} message CustomInterest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomInterest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.members = [];
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                                object.name = null;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.description = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.CustomInterestStatusEnum.CustomInterestStatus[message.status] : message.status;
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.CustomInterestTypeEnum.CustomInterestType[message.type] : message.type;
                            if (message.description != null && message.hasOwnProperty("description"))
                                object.description = $root.google.protobuf.StringValue.toObject(message.description, options);
                            if (message.members && message.members.length) {
                                object.members = [];
                                for (var j = 0; j < message.members.length; ++j)
                                    object.members[j] = $root.google.ads.googleads.v1.resources.CustomInterestMember.toObject(message.members[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this CustomInterest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CustomInterest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomInterest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomInterest;
                    })();

                    resources.CustomInterestMember = (function() {

                        /**
                         * Properties of a CustomInterestMember.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICustomInterestMember
                         * @property {google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum.CustomInterestMemberType|null} [memberType] CustomInterestMember memberType
                         * @property {google.protobuf.IStringValue|null} [parameter] CustomInterestMember parameter
                         */

                        /**
                         * Constructs a new CustomInterestMember.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CustomInterestMember.
                         * @implements ICustomInterestMember
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICustomInterestMember=} [properties] Properties to set
                         */
                        function CustomInterestMember(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomInterestMember memberType.
                         * @member {google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum.CustomInterestMemberType} memberType
                         * @memberof google.ads.googleads.v1.resources.CustomInterestMember
                         * @instance
                         */
                        CustomInterestMember.prototype.memberType = 0;

                        /**
                         * CustomInterestMember parameter.
                         * @member {google.protobuf.IStringValue|null|undefined} parameter
                         * @memberof google.ads.googleads.v1.resources.CustomInterestMember
                         * @instance
                         */
                        CustomInterestMember.prototype.parameter = null;

                        /**
                         * Creates a new CustomInterestMember instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CustomInterestMember
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomInterestMember=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CustomInterestMember} CustomInterestMember instance
                         */
                        CustomInterestMember.create = function create(properties) {
                            return new CustomInterestMember(properties);
                        };

                        /**
                         * Encodes the specified CustomInterestMember message. Does not implicitly {@link google.ads.googleads.v1.resources.CustomInterestMember.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CustomInterestMember
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomInterestMember} message CustomInterestMember message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomInterestMember.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.memberType != null && message.hasOwnProperty("memberType"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.memberType);
                            if (message.parameter != null && message.hasOwnProperty("parameter"))
                                $root.google.protobuf.StringValue.encode(message.parameter, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomInterestMember message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CustomInterestMember.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CustomInterestMember
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomInterestMember} message CustomInterestMember message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomInterestMember.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomInterestMember message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CustomInterestMember
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CustomInterestMember} CustomInterestMember
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomInterestMember.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CustomInterestMember();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.memberType = reader.int32();
                                    break;
                                case 2:
                                    message.parameter = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomInterestMember message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CustomInterestMember
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CustomInterestMember} CustomInterestMember
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomInterestMember.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomInterestMember message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CustomInterestMember
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomInterestMember.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.memberType != null && message.hasOwnProperty("memberType"))
                                switch (message.memberType) {
                                default:
                                    return "memberType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.parameter != null && message.hasOwnProperty("parameter")) {
                                var error = $root.google.protobuf.StringValue.verify(message.parameter);
                                if (error)
                                    return "parameter." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CustomInterestMember message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CustomInterestMember
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CustomInterestMember} CustomInterestMember
                         */
                        CustomInterestMember.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CustomInterestMember)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CustomInterestMember();
                            switch (object.memberType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.memberType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.memberType = 1;
                                break;
                            case "KEYWORD":
                            case 2:
                                message.memberType = 2;
                                break;
                            case "URL":
                            case 3:
                                message.memberType = 3;
                                break;
                            }
                            if (object.parameter != null) {
                                if (typeof object.parameter !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomInterestMember.parameter: object expected");
                                message.parameter = $root.google.protobuf.StringValue.fromObject(object.parameter);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomInterestMember message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CustomInterestMember
                         * @static
                         * @param {google.ads.googleads.v1.resources.CustomInterestMember} message CustomInterestMember
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomInterestMember.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.memberType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.parameter = null;
                            }
                            if (message.memberType != null && message.hasOwnProperty("memberType"))
                                object.memberType = options.enums === String ? $root.google.ads.googleads.v1.enums.CustomInterestMemberTypeEnum.CustomInterestMemberType[message.memberType] : message.memberType;
                            if (message.parameter != null && message.hasOwnProperty("parameter"))
                                object.parameter = $root.google.protobuf.StringValue.toObject(message.parameter, options);
                            return object;
                        };

                        /**
                         * Converts this CustomInterestMember to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CustomInterestMember
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomInterestMember.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomInterestMember;
                    })();

                    resources.Customer = (function() {

                        /**
                         * Properties of a Customer.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICustomer
                         * @property {string|null} [resourceName] Customer resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] Customer id
                         * @property {google.protobuf.IStringValue|null} [descriptiveName] Customer descriptiveName
                         * @property {google.protobuf.IStringValue|null} [currencyCode] Customer currencyCode
                         * @property {google.protobuf.IStringValue|null} [timeZone] Customer timeZone
                         * @property {google.protobuf.IStringValue|null} [trackingUrlTemplate] Customer trackingUrlTemplate
                         * @property {google.protobuf.IStringValue|null} [finalUrlSuffix] Customer finalUrlSuffix
                         * @property {google.protobuf.IBoolValue|null} [autoTaggingEnabled] Customer autoTaggingEnabled
                         * @property {google.protobuf.IBoolValue|null} [hasPartnersBadge] Customer hasPartnersBadge
                         * @property {google.protobuf.IBoolValue|null} [manager] Customer manager
                         * @property {google.protobuf.IBoolValue|null} [testAccount] Customer testAccount
                         * @property {google.ads.googleads.v1.resources.ICallReportingSetting|null} [callReportingSetting] Customer callReportingSetting
                         * @property {google.ads.googleads.v1.resources.IConversionTrackingSetting|null} [conversionTrackingSetting] Customer conversionTrackingSetting
                         * @property {google.ads.googleads.v1.resources.IRemarketingSetting|null} [remarketingSetting] Customer remarketingSetting
                         * @property {Array.<google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum.CustomerPayPerConversionEligibilityFailureReason>|null} [payPerConversionEligibilityFailureReasons] Customer payPerConversionEligibilityFailureReasons
                         */

                        /**
                         * Constructs a new Customer.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a Customer.
                         * @implements ICustomer
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICustomer=} [properties] Properties to set
                         */
                        function Customer(properties) {
                            this.payPerConversionEligibilityFailureReasons = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Customer resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @instance
                         */
                        Customer.prototype.resourceName = "";

                        /**
                         * Customer id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @instance
                         */
                        Customer.prototype.id = null;

                        /**
                         * Customer descriptiveName.
                         * @member {google.protobuf.IStringValue|null|undefined} descriptiveName
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @instance
                         */
                        Customer.prototype.descriptiveName = null;

                        /**
                         * Customer currencyCode.
                         * @member {google.protobuf.IStringValue|null|undefined} currencyCode
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @instance
                         */
                        Customer.prototype.currencyCode = null;

                        /**
                         * Customer timeZone.
                         * @member {google.protobuf.IStringValue|null|undefined} timeZone
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @instance
                         */
                        Customer.prototype.timeZone = null;

                        /**
                         * Customer trackingUrlTemplate.
                         * @member {google.protobuf.IStringValue|null|undefined} trackingUrlTemplate
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @instance
                         */
                        Customer.prototype.trackingUrlTemplate = null;

                        /**
                         * Customer finalUrlSuffix.
                         * @member {google.protobuf.IStringValue|null|undefined} finalUrlSuffix
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @instance
                         */
                        Customer.prototype.finalUrlSuffix = null;

                        /**
                         * Customer autoTaggingEnabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} autoTaggingEnabled
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @instance
                         */
                        Customer.prototype.autoTaggingEnabled = null;

                        /**
                         * Customer hasPartnersBadge.
                         * @member {google.protobuf.IBoolValue|null|undefined} hasPartnersBadge
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @instance
                         */
                        Customer.prototype.hasPartnersBadge = null;

                        /**
                         * Customer manager.
                         * @member {google.protobuf.IBoolValue|null|undefined} manager
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @instance
                         */
                        Customer.prototype.manager = null;

                        /**
                         * Customer testAccount.
                         * @member {google.protobuf.IBoolValue|null|undefined} testAccount
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @instance
                         */
                        Customer.prototype.testAccount = null;

                        /**
                         * Customer callReportingSetting.
                         * @member {google.ads.googleads.v1.resources.ICallReportingSetting|null|undefined} callReportingSetting
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @instance
                         */
                        Customer.prototype.callReportingSetting = null;

                        /**
                         * Customer conversionTrackingSetting.
                         * @member {google.ads.googleads.v1.resources.IConversionTrackingSetting|null|undefined} conversionTrackingSetting
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @instance
                         */
                        Customer.prototype.conversionTrackingSetting = null;

                        /**
                         * Customer remarketingSetting.
                         * @member {google.ads.googleads.v1.resources.IRemarketingSetting|null|undefined} remarketingSetting
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @instance
                         */
                        Customer.prototype.remarketingSetting = null;

                        /**
                         * Customer payPerConversionEligibilityFailureReasons.
                         * @member {Array.<google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum.CustomerPayPerConversionEligibilityFailureReason>} payPerConversionEligibilityFailureReasons
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @instance
                         */
                        Customer.prototype.payPerConversionEligibilityFailureReasons = $util.emptyArray;

                        /**
                         * Creates a new Customer instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomer=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.Customer} Customer instance
                         */
                        Customer.create = function create(properties) {
                            return new Customer(properties);
                        };

                        /**
                         * Encodes the specified Customer message. Does not implicitly {@link google.ads.googleads.v1.resources.Customer.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomer} message Customer message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Customer.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.descriptiveName != null && message.hasOwnProperty("descriptiveName"))
                                $root.google.protobuf.StringValue.encode(message.descriptiveName, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode"))
                                $root.google.protobuf.StringValue.encode(message.currencyCode, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.timeZone != null && message.hasOwnProperty("timeZone"))
                                $root.google.protobuf.StringValue.encode(message.timeZone, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                $root.google.protobuf.StringValue.encode(message.trackingUrlTemplate, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.autoTaggingEnabled != null && message.hasOwnProperty("autoTaggingEnabled"))
                                $root.google.protobuf.BoolValue.encode(message.autoTaggingEnabled, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.hasPartnersBadge != null && message.hasOwnProperty("hasPartnersBadge"))
                                $root.google.protobuf.BoolValue.encode(message.hasPartnersBadge, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.callReportingSetting != null && message.hasOwnProperty("callReportingSetting"))
                                $root.google.ads.googleads.v1.resources.CallReportingSetting.encode(message.callReportingSetting, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix"))
                                $root.google.protobuf.StringValue.encode(message.finalUrlSuffix, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.manager != null && message.hasOwnProperty("manager"))
                                $root.google.protobuf.BoolValue.encode(message.manager, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.testAccount != null && message.hasOwnProperty("testAccount"))
                                $root.google.protobuf.BoolValue.encode(message.testAccount, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                            if (message.conversionTrackingSetting != null && message.hasOwnProperty("conversionTrackingSetting"))
                                $root.google.ads.googleads.v1.resources.ConversionTrackingSetting.encode(message.conversionTrackingSetting, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.remarketingSetting != null && message.hasOwnProperty("remarketingSetting"))
                                $root.google.ads.googleads.v1.resources.RemarketingSetting.encode(message.remarketingSetting, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
                            if (message.payPerConversionEligibilityFailureReasons != null && message.payPerConversionEligibilityFailureReasons.length) {
                                writer.uint32(/* id 16, wireType 2 =*/130).fork();
                                for (var i = 0; i < message.payPerConversionEligibilityFailureReasons.length; ++i)
                                    writer.int32(message.payPerConversionEligibilityFailureReasons[i]);
                                writer.ldelim();
                            }
                            return writer;
                        };

                        /**
                         * Encodes the specified Customer message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Customer.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomer} message Customer message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Customer.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a Customer message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.Customer} Customer
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Customer.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Customer();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 3:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.descriptiveName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.currencyCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.timeZone = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.trackingUrlTemplate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.finalUrlSuffix = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.autoTaggingEnabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.hasPartnersBadge = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.manager = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 13:
                                    message.testAccount = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.callReportingSetting = $root.google.ads.googleads.v1.resources.CallReportingSetting.decode(reader, reader.uint32());
                                    break;
                                case 14:
                                    message.conversionTrackingSetting = $root.google.ads.googleads.v1.resources.ConversionTrackingSetting.decode(reader, reader.uint32());
                                    break;
                                case 15:
                                    message.remarketingSetting = $root.google.ads.googleads.v1.resources.RemarketingSetting.decode(reader, reader.uint32());
                                    break;
                                case 16:
                                    if (!(message.payPerConversionEligibilityFailureReasons && message.payPerConversionEligibilityFailureReasons.length))
                                        message.payPerConversionEligibilityFailureReasons = [];
                                    if ((tag & 7) === 2) {
                                        var end2 = reader.uint32() + reader.pos;
                                        while (reader.pos < end2)
                                            message.payPerConversionEligibilityFailureReasons.push(reader.int32());
                                    } else
                                        message.payPerConversionEligibilityFailureReasons.push(reader.int32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a Customer message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.Customer} Customer
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Customer.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a Customer message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Customer.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.descriptiveName != null && message.hasOwnProperty("descriptiveName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.descriptiveName);
                                if (error)
                                    return "descriptiveName." + error;
                            }
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.currencyCode);
                                if (error)
                                    return "currencyCode." + error;
                            }
                            if (message.timeZone != null && message.hasOwnProperty("timeZone")) {
                                var error = $root.google.protobuf.StringValue.verify(message.timeZone);
                                if (error)
                                    return "timeZone." + error;
                            }
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate")) {
                                var error = $root.google.protobuf.StringValue.verify(message.trackingUrlTemplate);
                                if (error)
                                    return "trackingUrlTemplate." + error;
                            }
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix")) {
                                var error = $root.google.protobuf.StringValue.verify(message.finalUrlSuffix);
                                if (error)
                                    return "finalUrlSuffix." + error;
                            }
                            if (message.autoTaggingEnabled != null && message.hasOwnProperty("autoTaggingEnabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.autoTaggingEnabled);
                                if (error)
                                    return "autoTaggingEnabled." + error;
                            }
                            if (message.hasPartnersBadge != null && message.hasOwnProperty("hasPartnersBadge")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.hasPartnersBadge);
                                if (error)
                                    return "hasPartnersBadge." + error;
                            }
                            if (message.manager != null && message.hasOwnProperty("manager")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.manager);
                                if (error)
                                    return "manager." + error;
                            }
                            if (message.testAccount != null && message.hasOwnProperty("testAccount")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.testAccount);
                                if (error)
                                    return "testAccount." + error;
                            }
                            if (message.callReportingSetting != null && message.hasOwnProperty("callReportingSetting")) {
                                var error = $root.google.ads.googleads.v1.resources.CallReportingSetting.verify(message.callReportingSetting);
                                if (error)
                                    return "callReportingSetting." + error;
                            }
                            if (message.conversionTrackingSetting != null && message.hasOwnProperty("conversionTrackingSetting")) {
                                var error = $root.google.ads.googleads.v1.resources.ConversionTrackingSetting.verify(message.conversionTrackingSetting);
                                if (error)
                                    return "conversionTrackingSetting." + error;
                            }
                            if (message.remarketingSetting != null && message.hasOwnProperty("remarketingSetting")) {
                                var error = $root.google.ads.googleads.v1.resources.RemarketingSetting.verify(message.remarketingSetting);
                                if (error)
                                    return "remarketingSetting." + error;
                            }
                            if (message.payPerConversionEligibilityFailureReasons != null && message.hasOwnProperty("payPerConversionEligibilityFailureReasons")) {
                                if (!Array.isArray(message.payPerConversionEligibilityFailureReasons))
                                    return "payPerConversionEligibilityFailureReasons: array expected";
                                for (var i = 0; i < message.payPerConversionEligibilityFailureReasons.length; ++i)
                                    switch (message.payPerConversionEligibilityFailureReasons[i]) {
                                    default:
                                        return "payPerConversionEligibilityFailureReasons: enum value[] expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                    case 5:
                                    case 6:
                                    case 7:
                                    case 8:
                                        break;
                                    }
                            }
                            return null;
                        };

                        /**
                         * Creates a Customer message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.Customer} Customer
                         */
                        Customer.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.Customer)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.Customer();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Customer.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.descriptiveName != null) {
                                if (typeof object.descriptiveName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Customer.descriptiveName: object expected");
                                message.descriptiveName = $root.google.protobuf.StringValue.fromObject(object.descriptiveName);
                            }
                            if (object.currencyCode != null) {
                                if (typeof object.currencyCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Customer.currencyCode: object expected");
                                message.currencyCode = $root.google.protobuf.StringValue.fromObject(object.currencyCode);
                            }
                            if (object.timeZone != null) {
                                if (typeof object.timeZone !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Customer.timeZone: object expected");
                                message.timeZone = $root.google.protobuf.StringValue.fromObject(object.timeZone);
                            }
                            if (object.trackingUrlTemplate != null) {
                                if (typeof object.trackingUrlTemplate !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Customer.trackingUrlTemplate: object expected");
                                message.trackingUrlTemplate = $root.google.protobuf.StringValue.fromObject(object.trackingUrlTemplate);
                            }
                            if (object.finalUrlSuffix != null) {
                                if (typeof object.finalUrlSuffix !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Customer.finalUrlSuffix: object expected");
                                message.finalUrlSuffix = $root.google.protobuf.StringValue.fromObject(object.finalUrlSuffix);
                            }
                            if (object.autoTaggingEnabled != null) {
                                if (typeof object.autoTaggingEnabled !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Customer.autoTaggingEnabled: object expected");
                                message.autoTaggingEnabled = $root.google.protobuf.BoolValue.fromObject(object.autoTaggingEnabled);
                            }
                            if (object.hasPartnersBadge != null) {
                                if (typeof object.hasPartnersBadge !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Customer.hasPartnersBadge: object expected");
                                message.hasPartnersBadge = $root.google.protobuf.BoolValue.fromObject(object.hasPartnersBadge);
                            }
                            if (object.manager != null) {
                                if (typeof object.manager !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Customer.manager: object expected");
                                message.manager = $root.google.protobuf.BoolValue.fromObject(object.manager);
                            }
                            if (object.testAccount != null) {
                                if (typeof object.testAccount !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Customer.testAccount: object expected");
                                message.testAccount = $root.google.protobuf.BoolValue.fromObject(object.testAccount);
                            }
                            if (object.callReportingSetting != null) {
                                if (typeof object.callReportingSetting !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Customer.callReportingSetting: object expected");
                                message.callReportingSetting = $root.google.ads.googleads.v1.resources.CallReportingSetting.fromObject(object.callReportingSetting);
                            }
                            if (object.conversionTrackingSetting != null) {
                                if (typeof object.conversionTrackingSetting !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Customer.conversionTrackingSetting: object expected");
                                message.conversionTrackingSetting = $root.google.ads.googleads.v1.resources.ConversionTrackingSetting.fromObject(object.conversionTrackingSetting);
                            }
                            if (object.remarketingSetting != null) {
                                if (typeof object.remarketingSetting !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Customer.remarketingSetting: object expected");
                                message.remarketingSetting = $root.google.ads.googleads.v1.resources.RemarketingSetting.fromObject(object.remarketingSetting);
                            }
                            if (object.payPerConversionEligibilityFailureReasons) {
                                if (!Array.isArray(object.payPerConversionEligibilityFailureReasons))
                                    throw TypeError(".google.ads.googleads.v1.resources.Customer.payPerConversionEligibilityFailureReasons: array expected");
                                message.payPerConversionEligibilityFailureReasons = [];
                                for (var i = 0; i < object.payPerConversionEligibilityFailureReasons.length; ++i)
                                    switch (object.payPerConversionEligibilityFailureReasons[i]) {
                                    default:
                                    case "UNSPECIFIED":
                                    case 0:
                                        message.payPerConversionEligibilityFailureReasons[i] = 0;
                                        break;
                                    case "UNKNOWN":
                                    case 1:
                                        message.payPerConversionEligibilityFailureReasons[i] = 1;
                                        break;
                                    case "NOT_ENOUGH_CONVERSIONS":
                                    case 2:
                                        message.payPerConversionEligibilityFailureReasons[i] = 2;
                                        break;
                                    case "CONVERSION_LAG_TOO_HIGH":
                                    case 3:
                                        message.payPerConversionEligibilityFailureReasons[i] = 3;
                                        break;
                                    case "HAS_CAMPAIGN_WITH_SHARED_BUDGET":
                                    case 4:
                                        message.payPerConversionEligibilityFailureReasons[i] = 4;
                                        break;
                                    case "HAS_UPLOAD_CLICKS_CONVERSION":
                                    case 5:
                                        message.payPerConversionEligibilityFailureReasons[i] = 5;
                                        break;
                                    case "AVERAGE_DAILY_SPEND_TOO_HIGH":
                                    case 6:
                                        message.payPerConversionEligibilityFailureReasons[i] = 6;
                                        break;
                                    case "ANALYSIS_NOT_COMPLETE":
                                    case 7:
                                        message.payPerConversionEligibilityFailureReasons[i] = 7;
                                        break;
                                    case "OTHER":
                                    case 8:
                                        message.payPerConversionEligibilityFailureReasons[i] = 8;
                                        break;
                                    }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a Customer message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @static
                         * @param {google.ads.googleads.v1.resources.Customer} message Customer
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Customer.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.payPerConversionEligibilityFailureReasons = [];
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.descriptiveName = null;
                                object.currencyCode = null;
                                object.timeZone = null;
                                object.trackingUrlTemplate = null;
                                object.autoTaggingEnabled = null;
                                object.hasPartnersBadge = null;
                                object.callReportingSetting = null;
                                object.finalUrlSuffix = null;
                                object.manager = null;
                                object.testAccount = null;
                                object.conversionTrackingSetting = null;
                                object.remarketingSetting = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.descriptiveName != null && message.hasOwnProperty("descriptiveName"))
                                object.descriptiveName = $root.google.protobuf.StringValue.toObject(message.descriptiveName, options);
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode"))
                                object.currencyCode = $root.google.protobuf.StringValue.toObject(message.currencyCode, options);
                            if (message.timeZone != null && message.hasOwnProperty("timeZone"))
                                object.timeZone = $root.google.protobuf.StringValue.toObject(message.timeZone, options);
                            if (message.trackingUrlTemplate != null && message.hasOwnProperty("trackingUrlTemplate"))
                                object.trackingUrlTemplate = $root.google.protobuf.StringValue.toObject(message.trackingUrlTemplate, options);
                            if (message.autoTaggingEnabled != null && message.hasOwnProperty("autoTaggingEnabled"))
                                object.autoTaggingEnabled = $root.google.protobuf.BoolValue.toObject(message.autoTaggingEnabled, options);
                            if (message.hasPartnersBadge != null && message.hasOwnProperty("hasPartnersBadge"))
                                object.hasPartnersBadge = $root.google.protobuf.BoolValue.toObject(message.hasPartnersBadge, options);
                            if (message.callReportingSetting != null && message.hasOwnProperty("callReportingSetting"))
                                object.callReportingSetting = $root.google.ads.googleads.v1.resources.CallReportingSetting.toObject(message.callReportingSetting, options);
                            if (message.finalUrlSuffix != null && message.hasOwnProperty("finalUrlSuffix"))
                                object.finalUrlSuffix = $root.google.protobuf.StringValue.toObject(message.finalUrlSuffix, options);
                            if (message.manager != null && message.hasOwnProperty("manager"))
                                object.manager = $root.google.protobuf.BoolValue.toObject(message.manager, options);
                            if (message.testAccount != null && message.hasOwnProperty("testAccount"))
                                object.testAccount = $root.google.protobuf.BoolValue.toObject(message.testAccount, options);
                            if (message.conversionTrackingSetting != null && message.hasOwnProperty("conversionTrackingSetting"))
                                object.conversionTrackingSetting = $root.google.ads.googleads.v1.resources.ConversionTrackingSetting.toObject(message.conversionTrackingSetting, options);
                            if (message.remarketingSetting != null && message.hasOwnProperty("remarketingSetting"))
                                object.remarketingSetting = $root.google.ads.googleads.v1.resources.RemarketingSetting.toObject(message.remarketingSetting, options);
                            if (message.payPerConversionEligibilityFailureReasons && message.payPerConversionEligibilityFailureReasons.length) {
                                object.payPerConversionEligibilityFailureReasons = [];
                                for (var j = 0; j < message.payPerConversionEligibilityFailureReasons.length; ++j)
                                    object.payPerConversionEligibilityFailureReasons[j] = options.enums === String ? $root.google.ads.googleads.v1.enums.CustomerPayPerConversionEligibilityFailureReasonEnum.CustomerPayPerConversionEligibilityFailureReason[message.payPerConversionEligibilityFailureReasons[j]] : message.payPerConversionEligibilityFailureReasons[j];
                            }
                            return object;
                        };

                        /**
                         * Converts this Customer to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.Customer
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Customer.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return Customer;
                    })();

                    resources.CallReportingSetting = (function() {

                        /**
                         * Properties of a CallReportingSetting.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICallReportingSetting
                         * @property {google.protobuf.IBoolValue|null} [callReportingEnabled] CallReportingSetting callReportingEnabled
                         * @property {google.protobuf.IBoolValue|null} [callConversionReportingEnabled] CallReportingSetting callConversionReportingEnabled
                         * @property {google.protobuf.IStringValue|null} [callConversionAction] CallReportingSetting callConversionAction
                         */

                        /**
                         * Constructs a new CallReportingSetting.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CallReportingSetting.
                         * @implements ICallReportingSetting
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICallReportingSetting=} [properties] Properties to set
                         */
                        function CallReportingSetting(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CallReportingSetting callReportingEnabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} callReportingEnabled
                         * @memberof google.ads.googleads.v1.resources.CallReportingSetting
                         * @instance
                         */
                        CallReportingSetting.prototype.callReportingEnabled = null;

                        /**
                         * CallReportingSetting callConversionReportingEnabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} callConversionReportingEnabled
                         * @memberof google.ads.googleads.v1.resources.CallReportingSetting
                         * @instance
                         */
                        CallReportingSetting.prototype.callConversionReportingEnabled = null;

                        /**
                         * CallReportingSetting callConversionAction.
                         * @member {google.protobuf.IStringValue|null|undefined} callConversionAction
                         * @memberof google.ads.googleads.v1.resources.CallReportingSetting
                         * @instance
                         */
                        CallReportingSetting.prototype.callConversionAction = null;

                        /**
                         * Creates a new CallReportingSetting instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CallReportingSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICallReportingSetting=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CallReportingSetting} CallReportingSetting instance
                         */
                        CallReportingSetting.create = function create(properties) {
                            return new CallReportingSetting(properties);
                        };

                        /**
                         * Encodes the specified CallReportingSetting message. Does not implicitly {@link google.ads.googleads.v1.resources.CallReportingSetting.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CallReportingSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICallReportingSetting} message CallReportingSetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CallReportingSetting.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.callReportingEnabled != null && message.hasOwnProperty("callReportingEnabled"))
                                $root.google.protobuf.BoolValue.encode(message.callReportingEnabled, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.callConversionReportingEnabled != null && message.hasOwnProperty("callConversionReportingEnabled"))
                                $root.google.protobuf.BoolValue.encode(message.callConversionReportingEnabled, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.callConversionAction != null && message.hasOwnProperty("callConversionAction"))
                                $root.google.protobuf.StringValue.encode(message.callConversionAction, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CallReportingSetting message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CallReportingSetting.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CallReportingSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICallReportingSetting} message CallReportingSetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CallReportingSetting.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CallReportingSetting message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CallReportingSetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CallReportingSetting} CallReportingSetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CallReportingSetting.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CallReportingSetting();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.callReportingEnabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.callConversionReportingEnabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.callConversionAction = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CallReportingSetting message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CallReportingSetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CallReportingSetting} CallReportingSetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CallReportingSetting.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CallReportingSetting message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CallReportingSetting
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CallReportingSetting.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.callReportingEnabled != null && message.hasOwnProperty("callReportingEnabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.callReportingEnabled);
                                if (error)
                                    return "callReportingEnabled." + error;
                            }
                            if (message.callConversionReportingEnabled != null && message.hasOwnProperty("callConversionReportingEnabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.callConversionReportingEnabled);
                                if (error)
                                    return "callConversionReportingEnabled." + error;
                            }
                            if (message.callConversionAction != null && message.hasOwnProperty("callConversionAction")) {
                                var error = $root.google.protobuf.StringValue.verify(message.callConversionAction);
                                if (error)
                                    return "callConversionAction." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CallReportingSetting message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CallReportingSetting
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CallReportingSetting} CallReportingSetting
                         */
                        CallReportingSetting.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CallReportingSetting)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CallReportingSetting();
                            if (object.callReportingEnabled != null) {
                                if (typeof object.callReportingEnabled !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CallReportingSetting.callReportingEnabled: object expected");
                                message.callReportingEnabled = $root.google.protobuf.BoolValue.fromObject(object.callReportingEnabled);
                            }
                            if (object.callConversionReportingEnabled != null) {
                                if (typeof object.callConversionReportingEnabled !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CallReportingSetting.callConversionReportingEnabled: object expected");
                                message.callConversionReportingEnabled = $root.google.protobuf.BoolValue.fromObject(object.callConversionReportingEnabled);
                            }
                            if (object.callConversionAction != null) {
                                if (typeof object.callConversionAction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CallReportingSetting.callConversionAction: object expected");
                                message.callConversionAction = $root.google.protobuf.StringValue.fromObject(object.callConversionAction);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CallReportingSetting message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CallReportingSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.CallReportingSetting} message CallReportingSetting
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CallReportingSetting.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.callReportingEnabled = null;
                                object.callConversionReportingEnabled = null;
                                object.callConversionAction = null;
                            }
                            if (message.callReportingEnabled != null && message.hasOwnProperty("callReportingEnabled"))
                                object.callReportingEnabled = $root.google.protobuf.BoolValue.toObject(message.callReportingEnabled, options);
                            if (message.callConversionReportingEnabled != null && message.hasOwnProperty("callConversionReportingEnabled"))
                                object.callConversionReportingEnabled = $root.google.protobuf.BoolValue.toObject(message.callConversionReportingEnabled, options);
                            if (message.callConversionAction != null && message.hasOwnProperty("callConversionAction"))
                                object.callConversionAction = $root.google.protobuf.StringValue.toObject(message.callConversionAction, options);
                            return object;
                        };

                        /**
                         * Converts this CallReportingSetting to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CallReportingSetting
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CallReportingSetting.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CallReportingSetting;
                    })();

                    resources.ConversionTrackingSetting = (function() {

                        /**
                         * Properties of a ConversionTrackingSetting.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IConversionTrackingSetting
                         * @property {google.protobuf.IInt64Value|null} [conversionTrackingId] ConversionTrackingSetting conversionTrackingId
                         * @property {google.protobuf.IInt64Value|null} [crossAccountConversionTrackingId] ConversionTrackingSetting crossAccountConversionTrackingId
                         */

                        /**
                         * Constructs a new ConversionTrackingSetting.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a ConversionTrackingSetting.
                         * @implements IConversionTrackingSetting
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IConversionTrackingSetting=} [properties] Properties to set
                         */
                        function ConversionTrackingSetting(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ConversionTrackingSetting conversionTrackingId.
                         * @member {google.protobuf.IInt64Value|null|undefined} conversionTrackingId
                         * @memberof google.ads.googleads.v1.resources.ConversionTrackingSetting
                         * @instance
                         */
                        ConversionTrackingSetting.prototype.conversionTrackingId = null;

                        /**
                         * ConversionTrackingSetting crossAccountConversionTrackingId.
                         * @member {google.protobuf.IInt64Value|null|undefined} crossAccountConversionTrackingId
                         * @memberof google.ads.googleads.v1.resources.ConversionTrackingSetting
                         * @instance
                         */
                        ConversionTrackingSetting.prototype.crossAccountConversionTrackingId = null;

                        /**
                         * Creates a new ConversionTrackingSetting instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.ConversionTrackingSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.IConversionTrackingSetting=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.ConversionTrackingSetting} ConversionTrackingSetting instance
                         */
                        ConversionTrackingSetting.create = function create(properties) {
                            return new ConversionTrackingSetting(properties);
                        };

                        /**
                         * Encodes the specified ConversionTrackingSetting message. Does not implicitly {@link google.ads.googleads.v1.resources.ConversionTrackingSetting.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.ConversionTrackingSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.IConversionTrackingSetting} message ConversionTrackingSetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionTrackingSetting.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.conversionTrackingId != null && message.hasOwnProperty("conversionTrackingId"))
                                $root.google.protobuf.Int64Value.encode(message.conversionTrackingId, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.crossAccountConversionTrackingId != null && message.hasOwnProperty("crossAccountConversionTrackingId"))
                                $root.google.protobuf.Int64Value.encode(message.crossAccountConversionTrackingId, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ConversionTrackingSetting message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.ConversionTrackingSetting.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ConversionTrackingSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.IConversionTrackingSetting} message ConversionTrackingSetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionTrackingSetting.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ConversionTrackingSetting message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.ConversionTrackingSetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.ConversionTrackingSetting} ConversionTrackingSetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionTrackingSetting.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.ConversionTrackingSetting();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.conversionTrackingId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.crossAccountConversionTrackingId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ConversionTrackingSetting message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ConversionTrackingSetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.ConversionTrackingSetting} ConversionTrackingSetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionTrackingSetting.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ConversionTrackingSetting message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.ConversionTrackingSetting
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConversionTrackingSetting.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.conversionTrackingId != null && message.hasOwnProperty("conversionTrackingId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.conversionTrackingId);
                                if (error)
                                    return "conversionTrackingId." + error;
                            }
                            if (message.crossAccountConversionTrackingId != null && message.hasOwnProperty("crossAccountConversionTrackingId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.crossAccountConversionTrackingId);
                                if (error)
                                    return "crossAccountConversionTrackingId." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a ConversionTrackingSetting message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.ConversionTrackingSetting
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.ConversionTrackingSetting} ConversionTrackingSetting
                         */
                        ConversionTrackingSetting.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.ConversionTrackingSetting)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.ConversionTrackingSetting();
                            if (object.conversionTrackingId != null) {
                                if (typeof object.conversionTrackingId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ConversionTrackingSetting.conversionTrackingId: object expected");
                                message.conversionTrackingId = $root.google.protobuf.Int64Value.fromObject(object.conversionTrackingId);
                            }
                            if (object.crossAccountConversionTrackingId != null) {
                                if (typeof object.crossAccountConversionTrackingId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ConversionTrackingSetting.crossAccountConversionTrackingId: object expected");
                                message.crossAccountConversionTrackingId = $root.google.protobuf.Int64Value.fromObject(object.crossAccountConversionTrackingId);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ConversionTrackingSetting message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.ConversionTrackingSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.ConversionTrackingSetting} message ConversionTrackingSetting
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConversionTrackingSetting.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.conversionTrackingId = null;
                                object.crossAccountConversionTrackingId = null;
                            }
                            if (message.conversionTrackingId != null && message.hasOwnProperty("conversionTrackingId"))
                                object.conversionTrackingId = $root.google.protobuf.Int64Value.toObject(message.conversionTrackingId, options);
                            if (message.crossAccountConversionTrackingId != null && message.hasOwnProperty("crossAccountConversionTrackingId"))
                                object.crossAccountConversionTrackingId = $root.google.protobuf.Int64Value.toObject(message.crossAccountConversionTrackingId, options);
                            return object;
                        };

                        /**
                         * Converts this ConversionTrackingSetting to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.ConversionTrackingSetting
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConversionTrackingSetting.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ConversionTrackingSetting;
                    })();

                    resources.RemarketingSetting = (function() {

                        /**
                         * Properties of a RemarketingSetting.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IRemarketingSetting
                         * @property {google.protobuf.IStringValue|null} [googleGlobalSiteTag] RemarketingSetting googleGlobalSiteTag
                         */

                        /**
                         * Constructs a new RemarketingSetting.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a RemarketingSetting.
                         * @implements IRemarketingSetting
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IRemarketingSetting=} [properties] Properties to set
                         */
                        function RemarketingSetting(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * RemarketingSetting googleGlobalSiteTag.
                         * @member {google.protobuf.IStringValue|null|undefined} googleGlobalSiteTag
                         * @memberof google.ads.googleads.v1.resources.RemarketingSetting
                         * @instance
                         */
                        RemarketingSetting.prototype.googleGlobalSiteTag = null;

                        /**
                         * Creates a new RemarketingSetting instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.RemarketingSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.IRemarketingSetting=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.RemarketingSetting} RemarketingSetting instance
                         */
                        RemarketingSetting.create = function create(properties) {
                            return new RemarketingSetting(properties);
                        };

                        /**
                         * Encodes the specified RemarketingSetting message. Does not implicitly {@link google.ads.googleads.v1.resources.RemarketingSetting.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.RemarketingSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.IRemarketingSetting} message RemarketingSetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemarketingSetting.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.googleGlobalSiteTag != null && message.hasOwnProperty("googleGlobalSiteTag"))
                                $root.google.protobuf.StringValue.encode(message.googleGlobalSiteTag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified RemarketingSetting message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.RemarketingSetting.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.RemarketingSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.IRemarketingSetting} message RemarketingSetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemarketingSetting.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a RemarketingSetting message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.RemarketingSetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.RemarketingSetting} RemarketingSetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemarketingSetting.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.RemarketingSetting();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.googleGlobalSiteTag = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a RemarketingSetting message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.RemarketingSetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.RemarketingSetting} RemarketingSetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemarketingSetting.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a RemarketingSetting message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.RemarketingSetting
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RemarketingSetting.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.googleGlobalSiteTag != null && message.hasOwnProperty("googleGlobalSiteTag")) {
                                var error = $root.google.protobuf.StringValue.verify(message.googleGlobalSiteTag);
                                if (error)
                                    return "googleGlobalSiteTag." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a RemarketingSetting message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.RemarketingSetting
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.RemarketingSetting} RemarketingSetting
                         */
                        RemarketingSetting.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.RemarketingSetting)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.RemarketingSetting();
                            if (object.googleGlobalSiteTag != null) {
                                if (typeof object.googleGlobalSiteTag !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.RemarketingSetting.googleGlobalSiteTag: object expected");
                                message.googleGlobalSiteTag = $root.google.protobuf.StringValue.fromObject(object.googleGlobalSiteTag);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a RemarketingSetting message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.RemarketingSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.RemarketingSetting} message RemarketingSetting
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RemarketingSetting.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.googleGlobalSiteTag = null;
                            if (message.googleGlobalSiteTag != null && message.hasOwnProperty("googleGlobalSiteTag"))
                                object.googleGlobalSiteTag = $root.google.protobuf.StringValue.toObject(message.googleGlobalSiteTag, options);
                            return object;
                        };

                        /**
                         * Converts this RemarketingSetting to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.RemarketingSetting
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RemarketingSetting.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return RemarketingSetting;
                    })();

                    resources.CustomerClient = (function() {

                        /**
                         * Properties of a CustomerClient.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICustomerClient
                         * @property {string|null} [resourceName] CustomerClient resourceName
                         * @property {google.protobuf.IStringValue|null} [clientCustomer] CustomerClient clientCustomer
                         * @property {google.protobuf.IBoolValue|null} [hidden] CustomerClient hidden
                         * @property {google.protobuf.IInt64Value|null} [level] CustomerClient level
                         */

                        /**
                         * Constructs a new CustomerClient.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CustomerClient.
                         * @implements ICustomerClient
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICustomerClient=} [properties] Properties to set
                         */
                        function CustomerClient(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomerClient resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.CustomerClient
                         * @instance
                         */
                        CustomerClient.prototype.resourceName = "";

                        /**
                         * CustomerClient clientCustomer.
                         * @member {google.protobuf.IStringValue|null|undefined} clientCustomer
                         * @memberof google.ads.googleads.v1.resources.CustomerClient
                         * @instance
                         */
                        CustomerClient.prototype.clientCustomer = null;

                        /**
                         * CustomerClient hidden.
                         * @member {google.protobuf.IBoolValue|null|undefined} hidden
                         * @memberof google.ads.googleads.v1.resources.CustomerClient
                         * @instance
                         */
                        CustomerClient.prototype.hidden = null;

                        /**
                         * CustomerClient level.
                         * @member {google.protobuf.IInt64Value|null|undefined} level
                         * @memberof google.ads.googleads.v1.resources.CustomerClient
                         * @instance
                         */
                        CustomerClient.prototype.level = null;

                        /**
                         * Creates a new CustomerClient instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CustomerClient
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerClient=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CustomerClient} CustomerClient instance
                         */
                        CustomerClient.create = function create(properties) {
                            return new CustomerClient(properties);
                        };

                        /**
                         * Encodes the specified CustomerClient message. Does not implicitly {@link google.ads.googleads.v1.resources.CustomerClient.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CustomerClient
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerClient} message CustomerClient message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerClient.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.clientCustomer != null && message.hasOwnProperty("clientCustomer"))
                                $root.google.protobuf.StringValue.encode(message.clientCustomer, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.hidden != null && message.hasOwnProperty("hidden"))
                                $root.google.protobuf.BoolValue.encode(message.hidden, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.level != null && message.hasOwnProperty("level"))
                                $root.google.protobuf.Int64Value.encode(message.level, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerClient message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CustomerClient.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CustomerClient
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerClient} message CustomerClient message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerClient.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerClient message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CustomerClient
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CustomerClient} CustomerClient
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerClient.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CustomerClient();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 3:
                                    message.clientCustomer = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.hidden = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.level = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerClient message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CustomerClient
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CustomerClient} CustomerClient
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerClient.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerClient message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CustomerClient
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerClient.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.clientCustomer != null && message.hasOwnProperty("clientCustomer")) {
                                var error = $root.google.protobuf.StringValue.verify(message.clientCustomer);
                                if (error)
                                    return "clientCustomer." + error;
                            }
                            if (message.hidden != null && message.hasOwnProperty("hidden")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.hidden);
                                if (error)
                                    return "hidden." + error;
                            }
                            if (message.level != null && message.hasOwnProperty("level")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.level);
                                if (error)
                                    return "level." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CustomerClient message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CustomerClient
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CustomerClient} CustomerClient
                         */
                        CustomerClient.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CustomerClient)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CustomerClient();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.clientCustomer != null) {
                                if (typeof object.clientCustomer !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerClient.clientCustomer: object expected");
                                message.clientCustomer = $root.google.protobuf.StringValue.fromObject(object.clientCustomer);
                            }
                            if (object.hidden != null) {
                                if (typeof object.hidden !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerClient.hidden: object expected");
                                message.hidden = $root.google.protobuf.BoolValue.fromObject(object.hidden);
                            }
                            if (object.level != null) {
                                if (typeof object.level !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerClient.level: object expected");
                                message.level = $root.google.protobuf.Int64Value.fromObject(object.level);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomerClient message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CustomerClient
                         * @static
                         * @param {google.ads.googleads.v1.resources.CustomerClient} message CustomerClient
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerClient.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.clientCustomer = null;
                                object.hidden = null;
                                object.level = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.clientCustomer != null && message.hasOwnProperty("clientCustomer"))
                                object.clientCustomer = $root.google.protobuf.StringValue.toObject(message.clientCustomer, options);
                            if (message.hidden != null && message.hasOwnProperty("hidden"))
                                object.hidden = $root.google.protobuf.BoolValue.toObject(message.hidden, options);
                            if (message.level != null && message.hasOwnProperty("level"))
                                object.level = $root.google.protobuf.Int64Value.toObject(message.level, options);
                            return object;
                        };

                        /**
                         * Converts this CustomerClient to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CustomerClient
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerClient.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomerClient;
                    })();

                    resources.CustomerClientLink = (function() {

                        /**
                         * Properties of a CustomerClientLink.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICustomerClientLink
                         * @property {string|null} [resourceName] CustomerClientLink resourceName
                         * @property {google.protobuf.IStringValue|null} [clientCustomer] CustomerClientLink clientCustomer
                         * @property {google.protobuf.IInt64Value|null} [managerLinkId] CustomerClientLink managerLinkId
                         * @property {google.ads.googleads.v1.enums.ManagerLinkStatusEnum.ManagerLinkStatus|null} [status] CustomerClientLink status
                         * @property {google.protobuf.IBoolValue|null} [hidden] CustomerClientLink hidden
                         */

                        /**
                         * Constructs a new CustomerClientLink.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CustomerClientLink.
                         * @implements ICustomerClientLink
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICustomerClientLink=} [properties] Properties to set
                         */
                        function CustomerClientLink(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomerClientLink resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.CustomerClientLink
                         * @instance
                         */
                        CustomerClientLink.prototype.resourceName = "";

                        /**
                         * CustomerClientLink clientCustomer.
                         * @member {google.protobuf.IStringValue|null|undefined} clientCustomer
                         * @memberof google.ads.googleads.v1.resources.CustomerClientLink
                         * @instance
                         */
                        CustomerClientLink.prototype.clientCustomer = null;

                        /**
                         * CustomerClientLink managerLinkId.
                         * @member {google.protobuf.IInt64Value|null|undefined} managerLinkId
                         * @memberof google.ads.googleads.v1.resources.CustomerClientLink
                         * @instance
                         */
                        CustomerClientLink.prototype.managerLinkId = null;

                        /**
                         * CustomerClientLink status.
                         * @member {google.ads.googleads.v1.enums.ManagerLinkStatusEnum.ManagerLinkStatus} status
                         * @memberof google.ads.googleads.v1.resources.CustomerClientLink
                         * @instance
                         */
                        CustomerClientLink.prototype.status = 0;

                        /**
                         * CustomerClientLink hidden.
                         * @member {google.protobuf.IBoolValue|null|undefined} hidden
                         * @memberof google.ads.googleads.v1.resources.CustomerClientLink
                         * @instance
                         */
                        CustomerClientLink.prototype.hidden = null;

                        /**
                         * Creates a new CustomerClientLink instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CustomerClientLink
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerClientLink=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CustomerClientLink} CustomerClientLink instance
                         */
                        CustomerClientLink.create = function create(properties) {
                            return new CustomerClientLink(properties);
                        };

                        /**
                         * Encodes the specified CustomerClientLink message. Does not implicitly {@link google.ads.googleads.v1.resources.CustomerClientLink.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CustomerClientLink
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerClientLink} message CustomerClientLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerClientLink.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.clientCustomer != null && message.hasOwnProperty("clientCustomer"))
                                $root.google.protobuf.StringValue.encode(message.clientCustomer, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.managerLinkId != null && message.hasOwnProperty("managerLinkId"))
                                $root.google.protobuf.Int64Value.encode(message.managerLinkId, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.status);
                            if (message.hidden != null && message.hasOwnProperty("hidden"))
                                $root.google.protobuf.BoolValue.encode(message.hidden, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerClientLink message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CustomerClientLink.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CustomerClientLink
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerClientLink} message CustomerClientLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerClientLink.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerClientLink message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CustomerClientLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CustomerClientLink} CustomerClientLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerClientLink.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CustomerClientLink();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 3:
                                    message.clientCustomer = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.managerLinkId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.status = reader.int32();
                                    break;
                                case 6:
                                    message.hidden = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerClientLink message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CustomerClientLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CustomerClientLink} CustomerClientLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerClientLink.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerClientLink message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CustomerClientLink
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerClientLink.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.clientCustomer != null && message.hasOwnProperty("clientCustomer")) {
                                var error = $root.google.protobuf.StringValue.verify(message.clientCustomer);
                                if (error)
                                    return "clientCustomer." + error;
                            }
                            if (message.managerLinkId != null && message.hasOwnProperty("managerLinkId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.managerLinkId);
                                if (error)
                                    return "managerLinkId." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            if (message.hidden != null && message.hasOwnProperty("hidden")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.hidden);
                                if (error)
                                    return "hidden." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CustomerClientLink message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CustomerClientLink
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CustomerClientLink} CustomerClientLink
                         */
                        CustomerClientLink.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CustomerClientLink)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CustomerClientLink();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.clientCustomer != null) {
                                if (typeof object.clientCustomer !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerClientLink.clientCustomer: object expected");
                                message.clientCustomer = $root.google.protobuf.StringValue.fromObject(object.clientCustomer);
                            }
                            if (object.managerLinkId != null) {
                                if (typeof object.managerLinkId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerClientLink.managerLinkId: object expected");
                                message.managerLinkId = $root.google.protobuf.Int64Value.fromObject(object.managerLinkId);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ACTIVE":
                            case 2:
                                message.status = 2;
                                break;
                            case "INACTIVE":
                            case 3:
                                message.status = 3;
                                break;
                            case "PENDING":
                            case 4:
                                message.status = 4;
                                break;
                            case "REFUSED":
                            case 5:
                                message.status = 5;
                                break;
                            case "CANCELED":
                            case 6:
                                message.status = 6;
                                break;
                            }
                            if (object.hidden != null) {
                                if (typeof object.hidden !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerClientLink.hidden: object expected");
                                message.hidden = $root.google.protobuf.BoolValue.fromObject(object.hidden);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomerClientLink message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CustomerClientLink
                         * @static
                         * @param {google.ads.googleads.v1.resources.CustomerClientLink} message CustomerClientLink
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerClientLink.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.clientCustomer = null;
                                object.managerLinkId = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                                object.hidden = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.clientCustomer != null && message.hasOwnProperty("clientCustomer"))
                                object.clientCustomer = $root.google.protobuf.StringValue.toObject(message.clientCustomer, options);
                            if (message.managerLinkId != null && message.hasOwnProperty("managerLinkId"))
                                object.managerLinkId = $root.google.protobuf.Int64Value.toObject(message.managerLinkId, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.ManagerLinkStatusEnum.ManagerLinkStatus[message.status] : message.status;
                            if (message.hidden != null && message.hasOwnProperty("hidden"))
                                object.hidden = $root.google.protobuf.BoolValue.toObject(message.hidden, options);
                            return object;
                        };

                        /**
                         * Converts this CustomerClientLink to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CustomerClientLink
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerClientLink.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomerClientLink;
                    })();

                    resources.CustomerExtensionSetting = (function() {

                        /**
                         * Properties of a CustomerExtensionSetting.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICustomerExtensionSetting
                         * @property {string|null} [resourceName] CustomerExtensionSetting resourceName
                         * @property {google.ads.googleads.v1.enums.ExtensionTypeEnum.ExtensionType|null} [extensionType] CustomerExtensionSetting extensionType
                         * @property {Array.<google.protobuf.IStringValue>|null} [extensionFeedItems] CustomerExtensionSetting extensionFeedItems
                         * @property {google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum.ExtensionSettingDevice|null} [device] CustomerExtensionSetting device
                         */

                        /**
                         * Constructs a new CustomerExtensionSetting.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CustomerExtensionSetting.
                         * @implements ICustomerExtensionSetting
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICustomerExtensionSetting=} [properties] Properties to set
                         */
                        function CustomerExtensionSetting(properties) {
                            this.extensionFeedItems = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomerExtensionSetting resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.CustomerExtensionSetting
                         * @instance
                         */
                        CustomerExtensionSetting.prototype.resourceName = "";

                        /**
                         * CustomerExtensionSetting extensionType.
                         * @member {google.ads.googleads.v1.enums.ExtensionTypeEnum.ExtensionType} extensionType
                         * @memberof google.ads.googleads.v1.resources.CustomerExtensionSetting
                         * @instance
                         */
                        CustomerExtensionSetting.prototype.extensionType = 0;

                        /**
                         * CustomerExtensionSetting extensionFeedItems.
                         * @member {Array.<google.protobuf.IStringValue>} extensionFeedItems
                         * @memberof google.ads.googleads.v1.resources.CustomerExtensionSetting
                         * @instance
                         */
                        CustomerExtensionSetting.prototype.extensionFeedItems = $util.emptyArray;

                        /**
                         * CustomerExtensionSetting device.
                         * @member {google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum.ExtensionSettingDevice} device
                         * @memberof google.ads.googleads.v1.resources.CustomerExtensionSetting
                         * @instance
                         */
                        CustomerExtensionSetting.prototype.device = 0;

                        /**
                         * Creates a new CustomerExtensionSetting instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CustomerExtensionSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerExtensionSetting=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CustomerExtensionSetting} CustomerExtensionSetting instance
                         */
                        CustomerExtensionSetting.create = function create(properties) {
                            return new CustomerExtensionSetting(properties);
                        };

                        /**
                         * Encodes the specified CustomerExtensionSetting message. Does not implicitly {@link google.ads.googleads.v1.resources.CustomerExtensionSetting.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CustomerExtensionSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerExtensionSetting} message CustomerExtensionSetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerExtensionSetting.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.extensionType != null && message.hasOwnProperty("extensionType"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.extensionType);
                            if (message.extensionFeedItems != null && message.extensionFeedItems.length)
                                for (var i = 0; i < message.extensionFeedItems.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.extensionFeedItems[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.device != null && message.hasOwnProperty("device"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.device);
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerExtensionSetting message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CustomerExtensionSetting.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CustomerExtensionSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerExtensionSetting} message CustomerExtensionSetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerExtensionSetting.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerExtensionSetting message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CustomerExtensionSetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CustomerExtensionSetting} CustomerExtensionSetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerExtensionSetting.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CustomerExtensionSetting();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.extensionType = reader.int32();
                                    break;
                                case 3:
                                    if (!(message.extensionFeedItems && message.extensionFeedItems.length))
                                        message.extensionFeedItems = [];
                                    message.extensionFeedItems.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 4:
                                    message.device = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerExtensionSetting message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CustomerExtensionSetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CustomerExtensionSetting} CustomerExtensionSetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerExtensionSetting.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerExtensionSetting message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CustomerExtensionSetting
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerExtensionSetting.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.extensionType != null && message.hasOwnProperty("extensionType"))
                                switch (message.extensionType) {
                                default:
                                    return "extensionType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                    break;
                                }
                            if (message.extensionFeedItems != null && message.hasOwnProperty("extensionFeedItems")) {
                                if (!Array.isArray(message.extensionFeedItems))
                                    return "extensionFeedItems: array expected";
                                for (var i = 0; i < message.extensionFeedItems.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.extensionFeedItems[i]);
                                    if (error)
                                        return "extensionFeedItems." + error;
                                }
                            }
                            if (message.device != null && message.hasOwnProperty("device"))
                                switch (message.device) {
                                default:
                                    return "device: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a CustomerExtensionSetting message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CustomerExtensionSetting
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CustomerExtensionSetting} CustomerExtensionSetting
                         */
                        CustomerExtensionSetting.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CustomerExtensionSetting)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CustomerExtensionSetting();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            switch (object.extensionType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.extensionType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.extensionType = 1;
                                break;
                            case "NONE":
                            case 2:
                                message.extensionType = 2;
                                break;
                            case "APP":
                            case 3:
                                message.extensionType = 3;
                                break;
                            case "CALL":
                            case 4:
                                message.extensionType = 4;
                                break;
                            case "CALLOUT":
                            case 5:
                                message.extensionType = 5;
                                break;
                            case "MESSAGE":
                            case 6:
                                message.extensionType = 6;
                                break;
                            case "PRICE":
                            case 7:
                                message.extensionType = 7;
                                break;
                            case "PROMOTION":
                            case 8:
                                message.extensionType = 8;
                                break;
                            case "REVIEW":
                            case 9:
                                message.extensionType = 9;
                                break;
                            case "SITELINK":
                            case 10:
                                message.extensionType = 10;
                                break;
                            case "STRUCTURED_SNIPPET":
                            case 11:
                                message.extensionType = 11;
                                break;
                            case "LOCATION":
                            case 12:
                                message.extensionType = 12;
                                break;
                            case "AFFILIATE_LOCATION":
                            case 13:
                                message.extensionType = 13;
                                break;
                            }
                            if (object.extensionFeedItems) {
                                if (!Array.isArray(object.extensionFeedItems))
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerExtensionSetting.extensionFeedItems: array expected");
                                message.extensionFeedItems = [];
                                for (var i = 0; i < object.extensionFeedItems.length; ++i) {
                                    if (typeof object.extensionFeedItems[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.CustomerExtensionSetting.extensionFeedItems: object expected");
                                    message.extensionFeedItems[i] = $root.google.protobuf.StringValue.fromObject(object.extensionFeedItems[i]);
                                }
                            }
                            switch (object.device) {
                            case "UNSPECIFIED":
                            case 0:
                                message.device = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.device = 1;
                                break;
                            case "MOBILE":
                            case 2:
                                message.device = 2;
                                break;
                            case "DESKTOP":
                            case 3:
                                message.device = 3;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomerExtensionSetting message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CustomerExtensionSetting
                         * @static
                         * @param {google.ads.googleads.v1.resources.CustomerExtensionSetting} message CustomerExtensionSetting
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerExtensionSetting.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.extensionFeedItems = [];
                            if (options.defaults) {
                                object.resourceName = "";
                                object.extensionType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.device = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.extensionType != null && message.hasOwnProperty("extensionType"))
                                object.extensionType = options.enums === String ? $root.google.ads.googleads.v1.enums.ExtensionTypeEnum.ExtensionType[message.extensionType] : message.extensionType;
                            if (message.extensionFeedItems && message.extensionFeedItems.length) {
                                object.extensionFeedItems = [];
                                for (var j = 0; j < message.extensionFeedItems.length; ++j)
                                    object.extensionFeedItems[j] = $root.google.protobuf.StringValue.toObject(message.extensionFeedItems[j], options);
                            }
                            if (message.device != null && message.hasOwnProperty("device"))
                                object.device = options.enums === String ? $root.google.ads.googleads.v1.enums.ExtensionSettingDeviceEnum.ExtensionSettingDevice[message.device] : message.device;
                            return object;
                        };

                        /**
                         * Converts this CustomerExtensionSetting to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CustomerExtensionSetting
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerExtensionSetting.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomerExtensionSetting;
                    })();

                    resources.CustomerFeed = (function() {

                        /**
                         * Properties of a CustomerFeed.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICustomerFeed
                         * @property {string|null} [resourceName] CustomerFeed resourceName
                         * @property {google.protobuf.IStringValue|null} [feed] CustomerFeed feed
                         * @property {Array.<google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType>|null} [placeholderTypes] CustomerFeed placeholderTypes
                         * @property {google.ads.googleads.v1.common.IMatchingFunction|null} [matchingFunction] CustomerFeed matchingFunction
                         * @property {google.ads.googleads.v1.enums.FeedLinkStatusEnum.FeedLinkStatus|null} [status] CustomerFeed status
                         */

                        /**
                         * Constructs a new CustomerFeed.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CustomerFeed.
                         * @implements ICustomerFeed
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICustomerFeed=} [properties] Properties to set
                         */
                        function CustomerFeed(properties) {
                            this.placeholderTypes = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomerFeed resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.CustomerFeed
                         * @instance
                         */
                        CustomerFeed.prototype.resourceName = "";

                        /**
                         * CustomerFeed feed.
                         * @member {google.protobuf.IStringValue|null|undefined} feed
                         * @memberof google.ads.googleads.v1.resources.CustomerFeed
                         * @instance
                         */
                        CustomerFeed.prototype.feed = null;

                        /**
                         * CustomerFeed placeholderTypes.
                         * @member {Array.<google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType>} placeholderTypes
                         * @memberof google.ads.googleads.v1.resources.CustomerFeed
                         * @instance
                         */
                        CustomerFeed.prototype.placeholderTypes = $util.emptyArray;

                        /**
                         * CustomerFeed matchingFunction.
                         * @member {google.ads.googleads.v1.common.IMatchingFunction|null|undefined} matchingFunction
                         * @memberof google.ads.googleads.v1.resources.CustomerFeed
                         * @instance
                         */
                        CustomerFeed.prototype.matchingFunction = null;

                        /**
                         * CustomerFeed status.
                         * @member {google.ads.googleads.v1.enums.FeedLinkStatusEnum.FeedLinkStatus} status
                         * @memberof google.ads.googleads.v1.resources.CustomerFeed
                         * @instance
                         */
                        CustomerFeed.prototype.status = 0;

                        /**
                         * Creates a new CustomerFeed instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CustomerFeed
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerFeed=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CustomerFeed} CustomerFeed instance
                         */
                        CustomerFeed.create = function create(properties) {
                            return new CustomerFeed(properties);
                        };

                        /**
                         * Encodes the specified CustomerFeed message. Does not implicitly {@link google.ads.googleads.v1.resources.CustomerFeed.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CustomerFeed
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerFeed} message CustomerFeed message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerFeed.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.feed != null && message.hasOwnProperty("feed"))
                                $root.google.protobuf.StringValue.encode(message.feed, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.placeholderTypes != null && message.placeholderTypes.length) {
                                writer.uint32(/* id 3, wireType 2 =*/26).fork();
                                for (var i = 0; i < message.placeholderTypes.length; ++i)
                                    writer.int32(message.placeholderTypes[i]);
                                writer.ldelim();
                            }
                            if (message.matchingFunction != null && message.hasOwnProperty("matchingFunction"))
                                $root.google.ads.googleads.v1.common.MatchingFunction.encode(message.matchingFunction, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.status);
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerFeed message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CustomerFeed.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CustomerFeed
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerFeed} message CustomerFeed message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerFeed.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerFeed message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CustomerFeed
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CustomerFeed} CustomerFeed
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerFeed.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CustomerFeed();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.feed = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    if (!(message.placeholderTypes && message.placeholderTypes.length))
                                        message.placeholderTypes = [];
                                    if ((tag & 7) === 2) {
                                        var end2 = reader.uint32() + reader.pos;
                                        while (reader.pos < end2)
                                            message.placeholderTypes.push(reader.int32());
                                    } else
                                        message.placeholderTypes.push(reader.int32());
                                    break;
                                case 4:
                                    message.matchingFunction = $root.google.ads.googleads.v1.common.MatchingFunction.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.status = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerFeed message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CustomerFeed
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CustomerFeed} CustomerFeed
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerFeed.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerFeed message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CustomerFeed
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerFeed.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.feed != null && message.hasOwnProperty("feed")) {
                                var error = $root.google.protobuf.StringValue.verify(message.feed);
                                if (error)
                                    return "feed." + error;
                            }
                            if (message.placeholderTypes != null && message.hasOwnProperty("placeholderTypes")) {
                                if (!Array.isArray(message.placeholderTypes))
                                    return "placeholderTypes: array expected";
                                for (var i = 0; i < message.placeholderTypes.length; ++i)
                                    switch (message.placeholderTypes[i]) {
                                    default:
                                        return "placeholderTypes: enum value[] expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                    case 5:
                                    case 6:
                                    case 7:
                                    case 8:
                                    case 9:
                                    case 10:
                                    case 11:
                                    case 12:
                                    case 13:
                                    case 14:
                                    case 15:
                                    case 16:
                                    case 17:
                                    case 18:
                                    case 19:
                                    case 20:
                                        break;
                                    }
                            }
                            if (message.matchingFunction != null && message.hasOwnProperty("matchingFunction")) {
                                var error = $root.google.ads.googleads.v1.common.MatchingFunction.verify(message.matchingFunction);
                                if (error)
                                    return "matchingFunction." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a CustomerFeed message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CustomerFeed
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CustomerFeed} CustomerFeed
                         */
                        CustomerFeed.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CustomerFeed)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CustomerFeed();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.feed != null) {
                                if (typeof object.feed !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerFeed.feed: object expected");
                                message.feed = $root.google.protobuf.StringValue.fromObject(object.feed);
                            }
                            if (object.placeholderTypes) {
                                if (!Array.isArray(object.placeholderTypes))
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerFeed.placeholderTypes: array expected");
                                message.placeholderTypes = [];
                                for (var i = 0; i < object.placeholderTypes.length; ++i)
                                    switch (object.placeholderTypes[i]) {
                                    default:
                                    case "UNSPECIFIED":
                                    case 0:
                                        message.placeholderTypes[i] = 0;
                                        break;
                                    case "UNKNOWN":
                                    case 1:
                                        message.placeholderTypes[i] = 1;
                                        break;
                                    case "SITELINK":
                                    case 2:
                                        message.placeholderTypes[i] = 2;
                                        break;
                                    case "CALL":
                                    case 3:
                                        message.placeholderTypes[i] = 3;
                                        break;
                                    case "APP":
                                    case 4:
                                        message.placeholderTypes[i] = 4;
                                        break;
                                    case "LOCATION":
                                    case 5:
                                        message.placeholderTypes[i] = 5;
                                        break;
                                    case "AFFILIATE_LOCATION":
                                    case 6:
                                        message.placeholderTypes[i] = 6;
                                        break;
                                    case "CALLOUT":
                                    case 7:
                                        message.placeholderTypes[i] = 7;
                                        break;
                                    case "STRUCTURED_SNIPPET":
                                    case 8:
                                        message.placeholderTypes[i] = 8;
                                        break;
                                    case "MESSAGE":
                                    case 9:
                                        message.placeholderTypes[i] = 9;
                                        break;
                                    case "PRICE":
                                    case 10:
                                        message.placeholderTypes[i] = 10;
                                        break;
                                    case "PROMOTION":
                                    case 11:
                                        message.placeholderTypes[i] = 11;
                                        break;
                                    case "AD_CUSTOMIZER":
                                    case 12:
                                        message.placeholderTypes[i] = 12;
                                        break;
                                    case "DYNAMIC_EDUCATION":
                                    case 13:
                                        message.placeholderTypes[i] = 13;
                                        break;
                                    case "DYNAMIC_FLIGHT":
                                    case 14:
                                        message.placeholderTypes[i] = 14;
                                        break;
                                    case "DYNAMIC_CUSTOM":
                                    case 15:
                                        message.placeholderTypes[i] = 15;
                                        break;
                                    case "DYNAMIC_HOTEL":
                                    case 16:
                                        message.placeholderTypes[i] = 16;
                                        break;
                                    case "DYNAMIC_REAL_ESTATE":
                                    case 17:
                                        message.placeholderTypes[i] = 17;
                                        break;
                                    case "DYNAMIC_TRAVEL":
                                    case 18:
                                        message.placeholderTypes[i] = 18;
                                        break;
                                    case "DYNAMIC_LOCAL":
                                    case 19:
                                        message.placeholderTypes[i] = 19;
                                        break;
                                    case "DYNAMIC_JOB":
                                    case 20:
                                        message.placeholderTypes[i] = 20;
                                        break;
                                    }
                            }
                            if (object.matchingFunction != null) {
                                if (typeof object.matchingFunction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerFeed.matchingFunction: object expected");
                                message.matchingFunction = $root.google.ads.googleads.v1.common.MatchingFunction.fromObject(object.matchingFunction);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "REMOVED":
                            case 3:
                                message.status = 3;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomerFeed message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CustomerFeed
                         * @static
                         * @param {google.ads.googleads.v1.resources.CustomerFeed} message CustomerFeed
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerFeed.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.placeholderTypes = [];
                            if (options.defaults) {
                                object.resourceName = "";
                                object.feed = null;
                                object.matchingFunction = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.feed != null && message.hasOwnProperty("feed"))
                                object.feed = $root.google.protobuf.StringValue.toObject(message.feed, options);
                            if (message.placeholderTypes && message.placeholderTypes.length) {
                                object.placeholderTypes = [];
                                for (var j = 0; j < message.placeholderTypes.length; ++j)
                                    object.placeholderTypes[j] = options.enums === String ? $root.google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType[message.placeholderTypes[j]] : message.placeholderTypes[j];
                            }
                            if (message.matchingFunction != null && message.hasOwnProperty("matchingFunction"))
                                object.matchingFunction = $root.google.ads.googleads.v1.common.MatchingFunction.toObject(message.matchingFunction, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.FeedLinkStatusEnum.FeedLinkStatus[message.status] : message.status;
                            return object;
                        };

                        /**
                         * Converts this CustomerFeed to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CustomerFeed
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerFeed.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomerFeed;
                    })();

                    resources.CustomerLabel = (function() {

                        /**
                         * Properties of a CustomerLabel.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICustomerLabel
                         * @property {string|null} [resourceName] CustomerLabel resourceName
                         * @property {google.protobuf.IStringValue|null} [customer] CustomerLabel customer
                         * @property {google.protobuf.IStringValue|null} [label] CustomerLabel label
                         */

                        /**
                         * Constructs a new CustomerLabel.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CustomerLabel.
                         * @implements ICustomerLabel
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICustomerLabel=} [properties] Properties to set
                         */
                        function CustomerLabel(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomerLabel resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.CustomerLabel
                         * @instance
                         */
                        CustomerLabel.prototype.resourceName = "";

                        /**
                         * CustomerLabel customer.
                         * @member {google.protobuf.IStringValue|null|undefined} customer
                         * @memberof google.ads.googleads.v1.resources.CustomerLabel
                         * @instance
                         */
                        CustomerLabel.prototype.customer = null;

                        /**
                         * CustomerLabel label.
                         * @member {google.protobuf.IStringValue|null|undefined} label
                         * @memberof google.ads.googleads.v1.resources.CustomerLabel
                         * @instance
                         */
                        CustomerLabel.prototype.label = null;

                        /**
                         * Creates a new CustomerLabel instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CustomerLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerLabel=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CustomerLabel} CustomerLabel instance
                         */
                        CustomerLabel.create = function create(properties) {
                            return new CustomerLabel(properties);
                        };

                        /**
                         * Encodes the specified CustomerLabel message. Does not implicitly {@link google.ads.googleads.v1.resources.CustomerLabel.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CustomerLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerLabel} message CustomerLabel message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerLabel.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.customer != null && message.hasOwnProperty("customer"))
                                $root.google.protobuf.StringValue.encode(message.customer, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.label != null && message.hasOwnProperty("label"))
                                $root.google.protobuf.StringValue.encode(message.label, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerLabel message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CustomerLabel.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CustomerLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerLabel} message CustomerLabel message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerLabel.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerLabel message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CustomerLabel
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CustomerLabel} CustomerLabel
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerLabel.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CustomerLabel();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.customer = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.label = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerLabel message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CustomerLabel
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CustomerLabel} CustomerLabel
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerLabel.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerLabel message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CustomerLabel
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerLabel.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.customer != null && message.hasOwnProperty("customer")) {
                                var error = $root.google.protobuf.StringValue.verify(message.customer);
                                if (error)
                                    return "customer." + error;
                            }
                            if (message.label != null && message.hasOwnProperty("label")) {
                                var error = $root.google.protobuf.StringValue.verify(message.label);
                                if (error)
                                    return "label." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CustomerLabel message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CustomerLabel
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CustomerLabel} CustomerLabel
                         */
                        CustomerLabel.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CustomerLabel)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CustomerLabel();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.customer != null) {
                                if (typeof object.customer !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerLabel.customer: object expected");
                                message.customer = $root.google.protobuf.StringValue.fromObject(object.customer);
                            }
                            if (object.label != null) {
                                if (typeof object.label !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerLabel.label: object expected");
                                message.label = $root.google.protobuf.StringValue.fromObject(object.label);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomerLabel message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CustomerLabel
                         * @static
                         * @param {google.ads.googleads.v1.resources.CustomerLabel} message CustomerLabel
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerLabel.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.customer = null;
                                object.label = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.customer != null && message.hasOwnProperty("customer"))
                                object.customer = $root.google.protobuf.StringValue.toObject(message.customer, options);
                            if (message.label != null && message.hasOwnProperty("label"))
                                object.label = $root.google.protobuf.StringValue.toObject(message.label, options);
                            return object;
                        };

                        /**
                         * Converts this CustomerLabel to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CustomerLabel
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerLabel.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomerLabel;
                    })();

                    resources.CustomerManagerLink = (function() {

                        /**
                         * Properties of a CustomerManagerLink.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICustomerManagerLink
                         * @property {string|null} [resourceName] CustomerManagerLink resourceName
                         * @property {google.protobuf.IStringValue|null} [managerCustomer] CustomerManagerLink managerCustomer
                         * @property {google.protobuf.IInt64Value|null} [managerLinkId] CustomerManagerLink managerLinkId
                         * @property {google.ads.googleads.v1.enums.ManagerLinkStatusEnum.ManagerLinkStatus|null} [status] CustomerManagerLink status
                         */

                        /**
                         * Constructs a new CustomerManagerLink.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CustomerManagerLink.
                         * @implements ICustomerManagerLink
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICustomerManagerLink=} [properties] Properties to set
                         */
                        function CustomerManagerLink(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomerManagerLink resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.CustomerManagerLink
                         * @instance
                         */
                        CustomerManagerLink.prototype.resourceName = "";

                        /**
                         * CustomerManagerLink managerCustomer.
                         * @member {google.protobuf.IStringValue|null|undefined} managerCustomer
                         * @memberof google.ads.googleads.v1.resources.CustomerManagerLink
                         * @instance
                         */
                        CustomerManagerLink.prototype.managerCustomer = null;

                        /**
                         * CustomerManagerLink managerLinkId.
                         * @member {google.protobuf.IInt64Value|null|undefined} managerLinkId
                         * @memberof google.ads.googleads.v1.resources.CustomerManagerLink
                         * @instance
                         */
                        CustomerManagerLink.prototype.managerLinkId = null;

                        /**
                         * CustomerManagerLink status.
                         * @member {google.ads.googleads.v1.enums.ManagerLinkStatusEnum.ManagerLinkStatus} status
                         * @memberof google.ads.googleads.v1.resources.CustomerManagerLink
                         * @instance
                         */
                        CustomerManagerLink.prototype.status = 0;

                        /**
                         * Creates a new CustomerManagerLink instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CustomerManagerLink
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerManagerLink=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CustomerManagerLink} CustomerManagerLink instance
                         */
                        CustomerManagerLink.create = function create(properties) {
                            return new CustomerManagerLink(properties);
                        };

                        /**
                         * Encodes the specified CustomerManagerLink message. Does not implicitly {@link google.ads.googleads.v1.resources.CustomerManagerLink.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CustomerManagerLink
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerManagerLink} message CustomerManagerLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerManagerLink.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.managerCustomer != null && message.hasOwnProperty("managerCustomer"))
                                $root.google.protobuf.StringValue.encode(message.managerCustomer, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.managerLinkId != null && message.hasOwnProperty("managerLinkId"))
                                $root.google.protobuf.Int64Value.encode(message.managerLinkId, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.status);
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerManagerLink message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CustomerManagerLink.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CustomerManagerLink
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerManagerLink} message CustomerManagerLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerManagerLink.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerManagerLink message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CustomerManagerLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CustomerManagerLink} CustomerManagerLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerManagerLink.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CustomerManagerLink();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 3:
                                    message.managerCustomer = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.managerLinkId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.status = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerManagerLink message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CustomerManagerLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CustomerManagerLink} CustomerManagerLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerManagerLink.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerManagerLink message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CustomerManagerLink
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerManagerLink.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.managerCustomer != null && message.hasOwnProperty("managerCustomer")) {
                                var error = $root.google.protobuf.StringValue.verify(message.managerCustomer);
                                if (error)
                                    return "managerCustomer." + error;
                            }
                            if (message.managerLinkId != null && message.hasOwnProperty("managerLinkId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.managerLinkId);
                                if (error)
                                    return "managerLinkId." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a CustomerManagerLink message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CustomerManagerLink
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CustomerManagerLink} CustomerManagerLink
                         */
                        CustomerManagerLink.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CustomerManagerLink)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CustomerManagerLink();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.managerCustomer != null) {
                                if (typeof object.managerCustomer !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerManagerLink.managerCustomer: object expected");
                                message.managerCustomer = $root.google.protobuf.StringValue.fromObject(object.managerCustomer);
                            }
                            if (object.managerLinkId != null) {
                                if (typeof object.managerLinkId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerManagerLink.managerLinkId: object expected");
                                message.managerLinkId = $root.google.protobuf.Int64Value.fromObject(object.managerLinkId);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ACTIVE":
                            case 2:
                                message.status = 2;
                                break;
                            case "INACTIVE":
                            case 3:
                                message.status = 3;
                                break;
                            case "PENDING":
                            case 4:
                                message.status = 4;
                                break;
                            case "REFUSED":
                            case 5:
                                message.status = 5;
                                break;
                            case "CANCELED":
                            case 6:
                                message.status = 6;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomerManagerLink message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CustomerManagerLink
                         * @static
                         * @param {google.ads.googleads.v1.resources.CustomerManagerLink} message CustomerManagerLink
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerManagerLink.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.managerCustomer = null;
                                object.managerLinkId = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.managerCustomer != null && message.hasOwnProperty("managerCustomer"))
                                object.managerCustomer = $root.google.protobuf.StringValue.toObject(message.managerCustomer, options);
                            if (message.managerLinkId != null && message.hasOwnProperty("managerLinkId"))
                                object.managerLinkId = $root.google.protobuf.Int64Value.toObject(message.managerLinkId, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.ManagerLinkStatusEnum.ManagerLinkStatus[message.status] : message.status;
                            return object;
                        };

                        /**
                         * Converts this CustomerManagerLink to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CustomerManagerLink
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerManagerLink.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomerManagerLink;
                    })();

                    resources.CustomerNegativeCriterion = (function() {

                        /**
                         * Properties of a CustomerNegativeCriterion.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ICustomerNegativeCriterion
                         * @property {string|null} [resourceName] CustomerNegativeCriterion resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] CustomerNegativeCriterion id
                         * @property {google.ads.googleads.v1.enums.CriterionTypeEnum.CriterionType|null} [type] CustomerNegativeCriterion type
                         * @property {google.ads.googleads.v1.common.IContentLabelInfo|null} [contentLabel] CustomerNegativeCriterion contentLabel
                         * @property {google.ads.googleads.v1.common.IMobileApplicationInfo|null} [mobileApplication] CustomerNegativeCriterion mobileApplication
                         * @property {google.ads.googleads.v1.common.IMobileAppCategoryInfo|null} [mobileAppCategory] CustomerNegativeCriterion mobileAppCategory
                         * @property {google.ads.googleads.v1.common.IPlacementInfo|null} [placement] CustomerNegativeCriterion placement
                         * @property {google.ads.googleads.v1.common.IYouTubeVideoInfo|null} [youtubeVideo] CustomerNegativeCriterion youtubeVideo
                         * @property {google.ads.googleads.v1.common.IYouTubeChannelInfo|null} [youtubeChannel] CustomerNegativeCriterion youtubeChannel
                         */

                        /**
                         * Constructs a new CustomerNegativeCriterion.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a CustomerNegativeCriterion.
                         * @implements ICustomerNegativeCriterion
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ICustomerNegativeCriterion=} [properties] Properties to set
                         */
                        function CustomerNegativeCriterion(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomerNegativeCriterion resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @instance
                         */
                        CustomerNegativeCriterion.prototype.resourceName = "";

                        /**
                         * CustomerNegativeCriterion id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @instance
                         */
                        CustomerNegativeCriterion.prototype.id = null;

                        /**
                         * CustomerNegativeCriterion type.
                         * @member {google.ads.googleads.v1.enums.CriterionTypeEnum.CriterionType} type
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @instance
                         */
                        CustomerNegativeCriterion.prototype.type = 0;

                        /**
                         * CustomerNegativeCriterion contentLabel.
                         * @member {google.ads.googleads.v1.common.IContentLabelInfo|null|undefined} contentLabel
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @instance
                         */
                        CustomerNegativeCriterion.prototype.contentLabel = null;

                        /**
                         * CustomerNegativeCriterion mobileApplication.
                         * @member {google.ads.googleads.v1.common.IMobileApplicationInfo|null|undefined} mobileApplication
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @instance
                         */
                        CustomerNegativeCriterion.prototype.mobileApplication = null;

                        /**
                         * CustomerNegativeCriterion mobileAppCategory.
                         * @member {google.ads.googleads.v1.common.IMobileAppCategoryInfo|null|undefined} mobileAppCategory
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @instance
                         */
                        CustomerNegativeCriterion.prototype.mobileAppCategory = null;

                        /**
                         * CustomerNegativeCriterion placement.
                         * @member {google.ads.googleads.v1.common.IPlacementInfo|null|undefined} placement
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @instance
                         */
                        CustomerNegativeCriterion.prototype.placement = null;

                        /**
                         * CustomerNegativeCriterion youtubeVideo.
                         * @member {google.ads.googleads.v1.common.IYouTubeVideoInfo|null|undefined} youtubeVideo
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @instance
                         */
                        CustomerNegativeCriterion.prototype.youtubeVideo = null;

                        /**
                         * CustomerNegativeCriterion youtubeChannel.
                         * @member {google.ads.googleads.v1.common.IYouTubeChannelInfo|null|undefined} youtubeChannel
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @instance
                         */
                        CustomerNegativeCriterion.prototype.youtubeChannel = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CustomerNegativeCriterion criterion.
                         * @member {"contentLabel"|"mobileApplication"|"mobileAppCategory"|"placement"|"youtubeVideo"|"youtubeChannel"|undefined} criterion
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @instance
                         */
                        Object.defineProperty(CustomerNegativeCriterion.prototype, "criterion", {
                            get: $util.oneOfGetter($oneOfFields = ["contentLabel", "mobileApplication", "mobileAppCategory", "placement", "youtubeVideo", "youtubeChannel"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CustomerNegativeCriterion instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerNegativeCriterion=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.CustomerNegativeCriterion} CustomerNegativeCriterion instance
                         */
                        CustomerNegativeCriterion.create = function create(properties) {
                            return new CustomerNegativeCriterion(properties);
                        };

                        /**
                         * Encodes the specified CustomerNegativeCriterion message. Does not implicitly {@link google.ads.googleads.v1.resources.CustomerNegativeCriterion.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerNegativeCriterion} message CustomerNegativeCriterion message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerNegativeCriterion.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.type);
                            if (message.contentLabel != null && message.hasOwnProperty("contentLabel"))
                                $root.google.ads.googleads.v1.common.ContentLabelInfo.encode(message.contentLabel, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.mobileApplication != null && message.hasOwnProperty("mobileApplication"))
                                $root.google.ads.googleads.v1.common.MobileApplicationInfo.encode(message.mobileApplication, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.mobileAppCategory != null && message.hasOwnProperty("mobileAppCategory"))
                                $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.encode(message.mobileAppCategory, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.placement != null && message.hasOwnProperty("placement"))
                                $root.google.ads.googleads.v1.common.PlacementInfo.encode(message.placement, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.youtubeVideo != null && message.hasOwnProperty("youtubeVideo"))
                                $root.google.ads.googleads.v1.common.YouTubeVideoInfo.encode(message.youtubeVideo, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.youtubeChannel != null && message.hasOwnProperty("youtubeChannel"))
                                $root.google.ads.googleads.v1.common.YouTubeChannelInfo.encode(message.youtubeChannel, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerNegativeCriterion message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.CustomerNegativeCriterion.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @static
                         * @param {google.ads.googleads.v1.resources.ICustomerNegativeCriterion} message CustomerNegativeCriterion message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerNegativeCriterion.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerNegativeCriterion message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.CustomerNegativeCriterion} CustomerNegativeCriterion
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerNegativeCriterion.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.CustomerNegativeCriterion();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.type = reader.int32();
                                    break;
                                case 4:
                                    message.contentLabel = $root.google.ads.googleads.v1.common.ContentLabelInfo.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.mobileApplication = $root.google.ads.googleads.v1.common.MobileApplicationInfo.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.mobileAppCategory = $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.placement = $root.google.ads.googleads.v1.common.PlacementInfo.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.youtubeVideo = $root.google.ads.googleads.v1.common.YouTubeVideoInfo.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.youtubeChannel = $root.google.ads.googleads.v1.common.YouTubeChannelInfo.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerNegativeCriterion message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.CustomerNegativeCriterion} CustomerNegativeCriterion
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerNegativeCriterion.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerNegativeCriterion message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerNegativeCriterion.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                    break;
                                }
                            if (message.contentLabel != null && message.hasOwnProperty("contentLabel")) {
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.ContentLabelInfo.verify(message.contentLabel);
                                    if (error)
                                        return "contentLabel." + error;
                                }
                            }
                            if (message.mobileApplication != null && message.hasOwnProperty("mobileApplication")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.MobileApplicationInfo.verify(message.mobileApplication);
                                    if (error)
                                        return "mobileApplication." + error;
                                }
                            }
                            if (message.mobileAppCategory != null && message.hasOwnProperty("mobileAppCategory")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.verify(message.mobileAppCategory);
                                    if (error)
                                        return "mobileAppCategory." + error;
                                }
                            }
                            if (message.placement != null && message.hasOwnProperty("placement")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.PlacementInfo.verify(message.placement);
                                    if (error)
                                        return "placement." + error;
                                }
                            }
                            if (message.youtubeVideo != null && message.hasOwnProperty("youtubeVideo")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.YouTubeVideoInfo.verify(message.youtubeVideo);
                                    if (error)
                                        return "youtubeVideo." + error;
                                }
                            }
                            if (message.youtubeChannel != null && message.hasOwnProperty("youtubeChannel")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.YouTubeChannelInfo.verify(message.youtubeChannel);
                                    if (error)
                                        return "youtubeChannel." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a CustomerNegativeCriterion message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.CustomerNegativeCriterion} CustomerNegativeCriterion
                         */
                        CustomerNegativeCriterion.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.CustomerNegativeCriterion)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.CustomerNegativeCriterion();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerNegativeCriterion.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "KEYWORD":
                            case 2:
                                message.type = 2;
                                break;
                            case "PLACEMENT":
                            case 3:
                                message.type = 3;
                                break;
                            case "MOBILE_APP_CATEGORY":
                            case 4:
                                message.type = 4;
                                break;
                            case "MOBILE_APPLICATION":
                            case 5:
                                message.type = 5;
                                break;
                            case "DEVICE":
                            case 6:
                                message.type = 6;
                                break;
                            case "LOCATION":
                            case 7:
                                message.type = 7;
                                break;
                            case "LISTING_GROUP":
                            case 8:
                                message.type = 8;
                                break;
                            case "AD_SCHEDULE":
                            case 9:
                                message.type = 9;
                                break;
                            case "AGE_RANGE":
                            case 10:
                                message.type = 10;
                                break;
                            case "GENDER":
                            case 11:
                                message.type = 11;
                                break;
                            case "INCOME_RANGE":
                            case 12:
                                message.type = 12;
                                break;
                            case "PARENTAL_STATUS":
                            case 13:
                                message.type = 13;
                                break;
                            case "YOUTUBE_VIDEO":
                            case 14:
                                message.type = 14;
                                break;
                            case "YOUTUBE_CHANNEL":
                            case 15:
                                message.type = 15;
                                break;
                            case "USER_LIST":
                            case 16:
                                message.type = 16;
                                break;
                            case "PROXIMITY":
                            case 17:
                                message.type = 17;
                                break;
                            case "TOPIC":
                            case 18:
                                message.type = 18;
                                break;
                            case "LISTING_SCOPE":
                            case 19:
                                message.type = 19;
                                break;
                            case "LANGUAGE":
                            case 20:
                                message.type = 20;
                                break;
                            case "IP_BLOCK":
                            case 21:
                                message.type = 21;
                                break;
                            case "CONTENT_LABEL":
                            case 22:
                                message.type = 22;
                                break;
                            case "CARRIER":
                            case 23:
                                message.type = 23;
                                break;
                            case "USER_INTEREST":
                            case 24:
                                message.type = 24;
                                break;
                            case "WEBPAGE":
                            case 25:
                                message.type = 25;
                                break;
                            case "OPERATING_SYSTEM_VERSION":
                            case 26:
                                message.type = 26;
                                break;
                            case "APP_PAYMENT_MODEL":
                            case 27:
                                message.type = 27;
                                break;
                            case "MOBILE_DEVICE":
                            case 28:
                                message.type = 28;
                                break;
                            case "CUSTOM_AFFINITY":
                            case 29:
                                message.type = 29;
                                break;
                            case "CUSTOM_INTENT":
                            case 30:
                                message.type = 30;
                                break;
                            case "LOCATION_GROUP":
                            case 31:
                                message.type = 31;
                                break;
                            }
                            if (object.contentLabel != null) {
                                if (typeof object.contentLabel !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerNegativeCriterion.contentLabel: object expected");
                                message.contentLabel = $root.google.ads.googleads.v1.common.ContentLabelInfo.fromObject(object.contentLabel);
                            }
                            if (object.mobileApplication != null) {
                                if (typeof object.mobileApplication !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerNegativeCriterion.mobileApplication: object expected");
                                message.mobileApplication = $root.google.ads.googleads.v1.common.MobileApplicationInfo.fromObject(object.mobileApplication);
                            }
                            if (object.mobileAppCategory != null) {
                                if (typeof object.mobileAppCategory !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerNegativeCriterion.mobileAppCategory: object expected");
                                message.mobileAppCategory = $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.fromObject(object.mobileAppCategory);
                            }
                            if (object.placement != null) {
                                if (typeof object.placement !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerNegativeCriterion.placement: object expected");
                                message.placement = $root.google.ads.googleads.v1.common.PlacementInfo.fromObject(object.placement);
                            }
                            if (object.youtubeVideo != null) {
                                if (typeof object.youtubeVideo !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerNegativeCriterion.youtubeVideo: object expected");
                                message.youtubeVideo = $root.google.ads.googleads.v1.common.YouTubeVideoInfo.fromObject(object.youtubeVideo);
                            }
                            if (object.youtubeChannel != null) {
                                if (typeof object.youtubeChannel !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.CustomerNegativeCriterion.youtubeChannel: object expected");
                                message.youtubeChannel = $root.google.ads.googleads.v1.common.YouTubeChannelInfo.fromObject(object.youtubeChannel);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomerNegativeCriterion message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @static
                         * @param {google.ads.googleads.v1.resources.CustomerNegativeCriterion} message CustomerNegativeCriterion
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerNegativeCriterion.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.CriterionTypeEnum.CriterionType[message.type] : message.type;
                            if (message.contentLabel != null && message.hasOwnProperty("contentLabel")) {
                                object.contentLabel = $root.google.ads.googleads.v1.common.ContentLabelInfo.toObject(message.contentLabel, options);
                                if (options.oneofs)
                                    object.criterion = "contentLabel";
                            }
                            if (message.mobileApplication != null && message.hasOwnProperty("mobileApplication")) {
                                object.mobileApplication = $root.google.ads.googleads.v1.common.MobileApplicationInfo.toObject(message.mobileApplication, options);
                                if (options.oneofs)
                                    object.criterion = "mobileApplication";
                            }
                            if (message.mobileAppCategory != null && message.hasOwnProperty("mobileAppCategory")) {
                                object.mobileAppCategory = $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.toObject(message.mobileAppCategory, options);
                                if (options.oneofs)
                                    object.criterion = "mobileAppCategory";
                            }
                            if (message.placement != null && message.hasOwnProperty("placement")) {
                                object.placement = $root.google.ads.googleads.v1.common.PlacementInfo.toObject(message.placement, options);
                                if (options.oneofs)
                                    object.criterion = "placement";
                            }
                            if (message.youtubeVideo != null && message.hasOwnProperty("youtubeVideo")) {
                                object.youtubeVideo = $root.google.ads.googleads.v1.common.YouTubeVideoInfo.toObject(message.youtubeVideo, options);
                                if (options.oneofs)
                                    object.criterion = "youtubeVideo";
                            }
                            if (message.youtubeChannel != null && message.hasOwnProperty("youtubeChannel")) {
                                object.youtubeChannel = $root.google.ads.googleads.v1.common.YouTubeChannelInfo.toObject(message.youtubeChannel, options);
                                if (options.oneofs)
                                    object.criterion = "youtubeChannel";
                            }
                            return object;
                        };

                        /**
                         * Converts this CustomerNegativeCriterion to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.CustomerNegativeCriterion
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerNegativeCriterion.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomerNegativeCriterion;
                    })();

                    resources.DetailPlacementView = (function() {

                        /**
                         * Properties of a DetailPlacementView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IDetailPlacementView
                         * @property {string|null} [resourceName] DetailPlacementView resourceName
                         * @property {google.protobuf.IStringValue|null} [placement] DetailPlacementView placement
                         * @property {google.protobuf.IStringValue|null} [displayName] DetailPlacementView displayName
                         * @property {google.protobuf.IStringValue|null} [groupPlacementTargetUrl] DetailPlacementView groupPlacementTargetUrl
                         * @property {google.protobuf.IStringValue|null} [targetUrl] DetailPlacementView targetUrl
                         * @property {google.ads.googleads.v1.enums.PlacementTypeEnum.PlacementType|null} [placementType] DetailPlacementView placementType
                         */

                        /**
                         * Constructs a new DetailPlacementView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a DetailPlacementView.
                         * @implements IDetailPlacementView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IDetailPlacementView=} [properties] Properties to set
                         */
                        function DetailPlacementView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * DetailPlacementView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.DetailPlacementView
                         * @instance
                         */
                        DetailPlacementView.prototype.resourceName = "";

                        /**
                         * DetailPlacementView placement.
                         * @member {google.protobuf.IStringValue|null|undefined} placement
                         * @memberof google.ads.googleads.v1.resources.DetailPlacementView
                         * @instance
                         */
                        DetailPlacementView.prototype.placement = null;

                        /**
                         * DetailPlacementView displayName.
                         * @member {google.protobuf.IStringValue|null|undefined} displayName
                         * @memberof google.ads.googleads.v1.resources.DetailPlacementView
                         * @instance
                         */
                        DetailPlacementView.prototype.displayName = null;

                        /**
                         * DetailPlacementView groupPlacementTargetUrl.
                         * @member {google.protobuf.IStringValue|null|undefined} groupPlacementTargetUrl
                         * @memberof google.ads.googleads.v1.resources.DetailPlacementView
                         * @instance
                         */
                        DetailPlacementView.prototype.groupPlacementTargetUrl = null;

                        /**
                         * DetailPlacementView targetUrl.
                         * @member {google.protobuf.IStringValue|null|undefined} targetUrl
                         * @memberof google.ads.googleads.v1.resources.DetailPlacementView
                         * @instance
                         */
                        DetailPlacementView.prototype.targetUrl = null;

                        /**
                         * DetailPlacementView placementType.
                         * @member {google.ads.googleads.v1.enums.PlacementTypeEnum.PlacementType} placementType
                         * @memberof google.ads.googleads.v1.resources.DetailPlacementView
                         * @instance
                         */
                        DetailPlacementView.prototype.placementType = 0;

                        /**
                         * Creates a new DetailPlacementView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.DetailPlacementView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IDetailPlacementView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.DetailPlacementView} DetailPlacementView instance
                         */
                        DetailPlacementView.create = function create(properties) {
                            return new DetailPlacementView(properties);
                        };

                        /**
                         * Encodes the specified DetailPlacementView message. Does not implicitly {@link google.ads.googleads.v1.resources.DetailPlacementView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.DetailPlacementView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IDetailPlacementView} message DetailPlacementView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DetailPlacementView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.placement != null && message.hasOwnProperty("placement"))
                                $root.google.protobuf.StringValue.encode(message.placement, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                $root.google.protobuf.StringValue.encode(message.displayName, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.groupPlacementTargetUrl != null && message.hasOwnProperty("groupPlacementTargetUrl"))
                                $root.google.protobuf.StringValue.encode(message.groupPlacementTargetUrl, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.targetUrl != null && message.hasOwnProperty("targetUrl"))
                                $root.google.protobuf.StringValue.encode(message.targetUrl, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.placementType != null && message.hasOwnProperty("placementType"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.placementType);
                            return writer;
                        };

                        /**
                         * Encodes the specified DetailPlacementView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.DetailPlacementView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.DetailPlacementView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IDetailPlacementView} message DetailPlacementView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DetailPlacementView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DetailPlacementView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.DetailPlacementView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.DetailPlacementView} DetailPlacementView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DetailPlacementView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.DetailPlacementView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.placement = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.displayName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.groupPlacementTargetUrl = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.targetUrl = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.placementType = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DetailPlacementView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.DetailPlacementView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.DetailPlacementView} DetailPlacementView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DetailPlacementView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DetailPlacementView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.DetailPlacementView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DetailPlacementView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.placement != null && message.hasOwnProperty("placement")) {
                                var error = $root.google.protobuf.StringValue.verify(message.placement);
                                if (error)
                                    return "placement." + error;
                            }
                            if (message.displayName != null && message.hasOwnProperty("displayName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.displayName);
                                if (error)
                                    return "displayName." + error;
                            }
                            if (message.groupPlacementTargetUrl != null && message.hasOwnProperty("groupPlacementTargetUrl")) {
                                var error = $root.google.protobuf.StringValue.verify(message.groupPlacementTargetUrl);
                                if (error)
                                    return "groupPlacementTargetUrl." + error;
                            }
                            if (message.targetUrl != null && message.hasOwnProperty("targetUrl")) {
                                var error = $root.google.protobuf.StringValue.verify(message.targetUrl);
                                if (error)
                                    return "targetUrl." + error;
                            }
                            if (message.placementType != null && message.hasOwnProperty("placementType"))
                                switch (message.placementType) {
                                default:
                                    return "placementType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a DetailPlacementView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.DetailPlacementView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.DetailPlacementView} DetailPlacementView
                         */
                        DetailPlacementView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.DetailPlacementView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.DetailPlacementView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.placement != null) {
                                if (typeof object.placement !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.DetailPlacementView.placement: object expected");
                                message.placement = $root.google.protobuf.StringValue.fromObject(object.placement);
                            }
                            if (object.displayName != null) {
                                if (typeof object.displayName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.DetailPlacementView.displayName: object expected");
                                message.displayName = $root.google.protobuf.StringValue.fromObject(object.displayName);
                            }
                            if (object.groupPlacementTargetUrl != null) {
                                if (typeof object.groupPlacementTargetUrl !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.DetailPlacementView.groupPlacementTargetUrl: object expected");
                                message.groupPlacementTargetUrl = $root.google.protobuf.StringValue.fromObject(object.groupPlacementTargetUrl);
                            }
                            if (object.targetUrl != null) {
                                if (typeof object.targetUrl !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.DetailPlacementView.targetUrl: object expected");
                                message.targetUrl = $root.google.protobuf.StringValue.fromObject(object.targetUrl);
                            }
                            switch (object.placementType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.placementType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.placementType = 1;
                                break;
                            case "WEBSITE":
                            case 2:
                                message.placementType = 2;
                                break;
                            case "MOBILE_APP_CATEGORY":
                            case 3:
                                message.placementType = 3;
                                break;
                            case "MOBILE_APPLICATION":
                            case 4:
                                message.placementType = 4;
                                break;
                            case "YOUTUBE_VIDEO":
                            case 5:
                                message.placementType = 5;
                                break;
                            case "YOUTUBE_CHANNEL":
                            case 6:
                                message.placementType = 6;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a DetailPlacementView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.DetailPlacementView
                         * @static
                         * @param {google.ads.googleads.v1.resources.DetailPlacementView} message DetailPlacementView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DetailPlacementView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.placement = null;
                                object.displayName = null;
                                object.groupPlacementTargetUrl = null;
                                object.targetUrl = null;
                                object.placementType = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.placement != null && message.hasOwnProperty("placement"))
                                object.placement = $root.google.protobuf.StringValue.toObject(message.placement, options);
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = $root.google.protobuf.StringValue.toObject(message.displayName, options);
                            if (message.groupPlacementTargetUrl != null && message.hasOwnProperty("groupPlacementTargetUrl"))
                                object.groupPlacementTargetUrl = $root.google.protobuf.StringValue.toObject(message.groupPlacementTargetUrl, options);
                            if (message.targetUrl != null && message.hasOwnProperty("targetUrl"))
                                object.targetUrl = $root.google.protobuf.StringValue.toObject(message.targetUrl, options);
                            if (message.placementType != null && message.hasOwnProperty("placementType"))
                                object.placementType = options.enums === String ? $root.google.ads.googleads.v1.enums.PlacementTypeEnum.PlacementType[message.placementType] : message.placementType;
                            return object;
                        };

                        /**
                         * Converts this DetailPlacementView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.DetailPlacementView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DetailPlacementView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return DetailPlacementView;
                    })();

                    resources.DisplayKeywordView = (function() {

                        /**
                         * Properties of a DisplayKeywordView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IDisplayKeywordView
                         * @property {string|null} [resourceName] DisplayKeywordView resourceName
                         */

                        /**
                         * Constructs a new DisplayKeywordView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a DisplayKeywordView.
                         * @implements IDisplayKeywordView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IDisplayKeywordView=} [properties] Properties to set
                         */
                        function DisplayKeywordView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * DisplayKeywordView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.DisplayKeywordView
                         * @instance
                         */
                        DisplayKeywordView.prototype.resourceName = "";

                        /**
                         * Creates a new DisplayKeywordView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.DisplayKeywordView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IDisplayKeywordView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.DisplayKeywordView} DisplayKeywordView instance
                         */
                        DisplayKeywordView.create = function create(properties) {
                            return new DisplayKeywordView(properties);
                        };

                        /**
                         * Encodes the specified DisplayKeywordView message. Does not implicitly {@link google.ads.googleads.v1.resources.DisplayKeywordView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.DisplayKeywordView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IDisplayKeywordView} message DisplayKeywordView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisplayKeywordView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified DisplayKeywordView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.DisplayKeywordView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.DisplayKeywordView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IDisplayKeywordView} message DisplayKeywordView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisplayKeywordView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DisplayKeywordView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.DisplayKeywordView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.DisplayKeywordView} DisplayKeywordView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisplayKeywordView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.DisplayKeywordView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DisplayKeywordView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.DisplayKeywordView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.DisplayKeywordView} DisplayKeywordView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisplayKeywordView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DisplayKeywordView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.DisplayKeywordView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DisplayKeywordView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a DisplayKeywordView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.DisplayKeywordView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.DisplayKeywordView} DisplayKeywordView
                         */
                        DisplayKeywordView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.DisplayKeywordView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.DisplayKeywordView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a DisplayKeywordView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.DisplayKeywordView
                         * @static
                         * @param {google.ads.googleads.v1.resources.DisplayKeywordView} message DisplayKeywordView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DisplayKeywordView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this DisplayKeywordView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.DisplayKeywordView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DisplayKeywordView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return DisplayKeywordView;
                    })();

                    resources.DomainCategory = (function() {

                        /**
                         * Properties of a DomainCategory.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IDomainCategory
                         * @property {string|null} [resourceName] DomainCategory resourceName
                         * @property {google.protobuf.IStringValue|null} [campaign] DomainCategory campaign
                         * @property {google.protobuf.IStringValue|null} [category] DomainCategory category
                         * @property {google.protobuf.IStringValue|null} [languageCode] DomainCategory languageCode
                         * @property {google.protobuf.IStringValue|null} [domain] DomainCategory domain
                         * @property {google.protobuf.IDoubleValue|null} [coverageFraction] DomainCategory coverageFraction
                         * @property {google.protobuf.IInt64Value|null} [categoryRank] DomainCategory categoryRank
                         * @property {google.protobuf.IBoolValue|null} [hasChildren] DomainCategory hasChildren
                         * @property {google.protobuf.IInt64Value|null} [recommendedCpcBidMicros] DomainCategory recommendedCpcBidMicros
                         */

                        /**
                         * Constructs a new DomainCategory.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a DomainCategory.
                         * @implements IDomainCategory
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IDomainCategory=} [properties] Properties to set
                         */
                        function DomainCategory(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * DomainCategory resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.DomainCategory
                         * @instance
                         */
                        DomainCategory.prototype.resourceName = "";

                        /**
                         * DomainCategory campaign.
                         * @member {google.protobuf.IStringValue|null|undefined} campaign
                         * @memberof google.ads.googleads.v1.resources.DomainCategory
                         * @instance
                         */
                        DomainCategory.prototype.campaign = null;

                        /**
                         * DomainCategory category.
                         * @member {google.protobuf.IStringValue|null|undefined} category
                         * @memberof google.ads.googleads.v1.resources.DomainCategory
                         * @instance
                         */
                        DomainCategory.prototype.category = null;

                        /**
                         * DomainCategory languageCode.
                         * @member {google.protobuf.IStringValue|null|undefined} languageCode
                         * @memberof google.ads.googleads.v1.resources.DomainCategory
                         * @instance
                         */
                        DomainCategory.prototype.languageCode = null;

                        /**
                         * DomainCategory domain.
                         * @member {google.protobuf.IStringValue|null|undefined} domain
                         * @memberof google.ads.googleads.v1.resources.DomainCategory
                         * @instance
                         */
                        DomainCategory.prototype.domain = null;

                        /**
                         * DomainCategory coverageFraction.
                         * @member {google.protobuf.IDoubleValue|null|undefined} coverageFraction
                         * @memberof google.ads.googleads.v1.resources.DomainCategory
                         * @instance
                         */
                        DomainCategory.prototype.coverageFraction = null;

                        /**
                         * DomainCategory categoryRank.
                         * @member {google.protobuf.IInt64Value|null|undefined} categoryRank
                         * @memberof google.ads.googleads.v1.resources.DomainCategory
                         * @instance
                         */
                        DomainCategory.prototype.categoryRank = null;

                        /**
                         * DomainCategory hasChildren.
                         * @member {google.protobuf.IBoolValue|null|undefined} hasChildren
                         * @memberof google.ads.googleads.v1.resources.DomainCategory
                         * @instance
                         */
                        DomainCategory.prototype.hasChildren = null;

                        /**
                         * DomainCategory recommendedCpcBidMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} recommendedCpcBidMicros
                         * @memberof google.ads.googleads.v1.resources.DomainCategory
                         * @instance
                         */
                        DomainCategory.prototype.recommendedCpcBidMicros = null;

                        /**
                         * Creates a new DomainCategory instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.DomainCategory
                         * @static
                         * @param {google.ads.googleads.v1.resources.IDomainCategory=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.DomainCategory} DomainCategory instance
                         */
                        DomainCategory.create = function create(properties) {
                            return new DomainCategory(properties);
                        };

                        /**
                         * Encodes the specified DomainCategory message. Does not implicitly {@link google.ads.googleads.v1.resources.DomainCategory.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.DomainCategory
                         * @static
                         * @param {google.ads.googleads.v1.resources.IDomainCategory} message DomainCategory message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DomainCategory.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                $root.google.protobuf.StringValue.encode(message.campaign, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.category != null && message.hasOwnProperty("category"))
                                $root.google.protobuf.StringValue.encode(message.category, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.languageCode != null && message.hasOwnProperty("languageCode"))
                                $root.google.protobuf.StringValue.encode(message.languageCode, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.domain != null && message.hasOwnProperty("domain"))
                                $root.google.protobuf.StringValue.encode(message.domain, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.coverageFraction != null && message.hasOwnProperty("coverageFraction"))
                                $root.google.protobuf.DoubleValue.encode(message.coverageFraction, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.categoryRank != null && message.hasOwnProperty("categoryRank"))
                                $root.google.protobuf.Int64Value.encode(message.categoryRank, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.hasChildren != null && message.hasOwnProperty("hasChildren"))
                                $root.google.protobuf.BoolValue.encode(message.hasChildren, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.recommendedCpcBidMicros != null && message.hasOwnProperty("recommendedCpcBidMicros"))
                                $root.google.protobuf.Int64Value.encode(message.recommendedCpcBidMicros, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified DomainCategory message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.DomainCategory.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.DomainCategory
                         * @static
                         * @param {google.ads.googleads.v1.resources.IDomainCategory} message DomainCategory message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DomainCategory.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DomainCategory message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.DomainCategory
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.DomainCategory} DomainCategory
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DomainCategory.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.DomainCategory();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.campaign = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.category = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.languageCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.domain = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.coverageFraction = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.categoryRank = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.hasChildren = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.recommendedCpcBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DomainCategory message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.DomainCategory
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.DomainCategory} DomainCategory
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DomainCategory.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DomainCategory message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.DomainCategory
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DomainCategory.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.campaign != null && message.hasOwnProperty("campaign")) {
                                var error = $root.google.protobuf.StringValue.verify(message.campaign);
                                if (error)
                                    return "campaign." + error;
                            }
                            if (message.category != null && message.hasOwnProperty("category")) {
                                var error = $root.google.protobuf.StringValue.verify(message.category);
                                if (error)
                                    return "category." + error;
                            }
                            if (message.languageCode != null && message.hasOwnProperty("languageCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.languageCode);
                                if (error)
                                    return "languageCode." + error;
                            }
                            if (message.domain != null && message.hasOwnProperty("domain")) {
                                var error = $root.google.protobuf.StringValue.verify(message.domain);
                                if (error)
                                    return "domain." + error;
                            }
                            if (message.coverageFraction != null && message.hasOwnProperty("coverageFraction")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.coverageFraction);
                                if (error)
                                    return "coverageFraction." + error;
                            }
                            if (message.categoryRank != null && message.hasOwnProperty("categoryRank")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.categoryRank);
                                if (error)
                                    return "categoryRank." + error;
                            }
                            if (message.hasChildren != null && message.hasOwnProperty("hasChildren")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.hasChildren);
                                if (error)
                                    return "hasChildren." + error;
                            }
                            if (message.recommendedCpcBidMicros != null && message.hasOwnProperty("recommendedCpcBidMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.recommendedCpcBidMicros);
                                if (error)
                                    return "recommendedCpcBidMicros." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a DomainCategory message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.DomainCategory
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.DomainCategory} DomainCategory
                         */
                        DomainCategory.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.DomainCategory)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.DomainCategory();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.campaign != null) {
                                if (typeof object.campaign !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.DomainCategory.campaign: object expected");
                                message.campaign = $root.google.protobuf.StringValue.fromObject(object.campaign);
                            }
                            if (object.category != null) {
                                if (typeof object.category !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.DomainCategory.category: object expected");
                                message.category = $root.google.protobuf.StringValue.fromObject(object.category);
                            }
                            if (object.languageCode != null) {
                                if (typeof object.languageCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.DomainCategory.languageCode: object expected");
                                message.languageCode = $root.google.protobuf.StringValue.fromObject(object.languageCode);
                            }
                            if (object.domain != null) {
                                if (typeof object.domain !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.DomainCategory.domain: object expected");
                                message.domain = $root.google.protobuf.StringValue.fromObject(object.domain);
                            }
                            if (object.coverageFraction != null) {
                                if (typeof object.coverageFraction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.DomainCategory.coverageFraction: object expected");
                                message.coverageFraction = $root.google.protobuf.DoubleValue.fromObject(object.coverageFraction);
                            }
                            if (object.categoryRank != null) {
                                if (typeof object.categoryRank !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.DomainCategory.categoryRank: object expected");
                                message.categoryRank = $root.google.protobuf.Int64Value.fromObject(object.categoryRank);
                            }
                            if (object.hasChildren != null) {
                                if (typeof object.hasChildren !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.DomainCategory.hasChildren: object expected");
                                message.hasChildren = $root.google.protobuf.BoolValue.fromObject(object.hasChildren);
                            }
                            if (object.recommendedCpcBidMicros != null) {
                                if (typeof object.recommendedCpcBidMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.DomainCategory.recommendedCpcBidMicros: object expected");
                                message.recommendedCpcBidMicros = $root.google.protobuf.Int64Value.fromObject(object.recommendedCpcBidMicros);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a DomainCategory message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.DomainCategory
                         * @static
                         * @param {google.ads.googleads.v1.resources.DomainCategory} message DomainCategory
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DomainCategory.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.campaign = null;
                                object.category = null;
                                object.languageCode = null;
                                object.domain = null;
                                object.coverageFraction = null;
                                object.categoryRank = null;
                                object.hasChildren = null;
                                object.recommendedCpcBidMicros = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                object.campaign = $root.google.protobuf.StringValue.toObject(message.campaign, options);
                            if (message.category != null && message.hasOwnProperty("category"))
                                object.category = $root.google.protobuf.StringValue.toObject(message.category, options);
                            if (message.languageCode != null && message.hasOwnProperty("languageCode"))
                                object.languageCode = $root.google.protobuf.StringValue.toObject(message.languageCode, options);
                            if (message.domain != null && message.hasOwnProperty("domain"))
                                object.domain = $root.google.protobuf.StringValue.toObject(message.domain, options);
                            if (message.coverageFraction != null && message.hasOwnProperty("coverageFraction"))
                                object.coverageFraction = $root.google.protobuf.DoubleValue.toObject(message.coverageFraction, options);
                            if (message.categoryRank != null && message.hasOwnProperty("categoryRank"))
                                object.categoryRank = $root.google.protobuf.Int64Value.toObject(message.categoryRank, options);
                            if (message.hasChildren != null && message.hasOwnProperty("hasChildren"))
                                object.hasChildren = $root.google.protobuf.BoolValue.toObject(message.hasChildren, options);
                            if (message.recommendedCpcBidMicros != null && message.hasOwnProperty("recommendedCpcBidMicros"))
                                object.recommendedCpcBidMicros = $root.google.protobuf.Int64Value.toObject(message.recommendedCpcBidMicros, options);
                            return object;
                        };

                        /**
                         * Converts this DomainCategory to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.DomainCategory
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DomainCategory.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return DomainCategory;
                    })();

                    resources.DynamicSearchAdsSearchTermView = (function() {

                        /**
                         * Properties of a DynamicSearchAdsSearchTermView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IDynamicSearchAdsSearchTermView
                         * @property {string|null} [resourceName] DynamicSearchAdsSearchTermView resourceName
                         * @property {google.protobuf.IStringValue|null} [searchTerm] DynamicSearchAdsSearchTermView searchTerm
                         * @property {google.protobuf.IStringValue|null} [headline] DynamicSearchAdsSearchTermView headline
                         * @property {google.protobuf.IStringValue|null} [landingPage] DynamicSearchAdsSearchTermView landingPage
                         * @property {google.protobuf.IStringValue|null} [pageUrl] DynamicSearchAdsSearchTermView pageUrl
                         */

                        /**
                         * Constructs a new DynamicSearchAdsSearchTermView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a DynamicSearchAdsSearchTermView.
                         * @implements IDynamicSearchAdsSearchTermView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IDynamicSearchAdsSearchTermView=} [properties] Properties to set
                         */
                        function DynamicSearchAdsSearchTermView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * DynamicSearchAdsSearchTermView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView
                         * @instance
                         */
                        DynamicSearchAdsSearchTermView.prototype.resourceName = "";

                        /**
                         * DynamicSearchAdsSearchTermView searchTerm.
                         * @member {google.protobuf.IStringValue|null|undefined} searchTerm
                         * @memberof google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView
                         * @instance
                         */
                        DynamicSearchAdsSearchTermView.prototype.searchTerm = null;

                        /**
                         * DynamicSearchAdsSearchTermView headline.
                         * @member {google.protobuf.IStringValue|null|undefined} headline
                         * @memberof google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView
                         * @instance
                         */
                        DynamicSearchAdsSearchTermView.prototype.headline = null;

                        /**
                         * DynamicSearchAdsSearchTermView landingPage.
                         * @member {google.protobuf.IStringValue|null|undefined} landingPage
                         * @memberof google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView
                         * @instance
                         */
                        DynamicSearchAdsSearchTermView.prototype.landingPage = null;

                        /**
                         * DynamicSearchAdsSearchTermView pageUrl.
                         * @member {google.protobuf.IStringValue|null|undefined} pageUrl
                         * @memberof google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView
                         * @instance
                         */
                        DynamicSearchAdsSearchTermView.prototype.pageUrl = null;

                        /**
                         * Creates a new DynamicSearchAdsSearchTermView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IDynamicSearchAdsSearchTermView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView} DynamicSearchAdsSearchTermView instance
                         */
                        DynamicSearchAdsSearchTermView.create = function create(properties) {
                            return new DynamicSearchAdsSearchTermView(properties);
                        };

                        /**
                         * Encodes the specified DynamicSearchAdsSearchTermView message. Does not implicitly {@link google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IDynamicSearchAdsSearchTermView} message DynamicSearchAdsSearchTermView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DynamicSearchAdsSearchTermView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.searchTerm != null && message.hasOwnProperty("searchTerm"))
                                $root.google.protobuf.StringValue.encode(message.searchTerm, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.headline != null && message.hasOwnProperty("headline"))
                                $root.google.protobuf.StringValue.encode(message.headline, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.landingPage != null && message.hasOwnProperty("landingPage"))
                                $root.google.protobuf.StringValue.encode(message.landingPage, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.pageUrl != null && message.hasOwnProperty("pageUrl"))
                                $root.google.protobuf.StringValue.encode(message.pageUrl, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified DynamicSearchAdsSearchTermView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IDynamicSearchAdsSearchTermView} message DynamicSearchAdsSearchTermView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DynamicSearchAdsSearchTermView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DynamicSearchAdsSearchTermView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView} DynamicSearchAdsSearchTermView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DynamicSearchAdsSearchTermView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.searchTerm = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.headline = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.landingPage = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.pageUrl = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DynamicSearchAdsSearchTermView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView} DynamicSearchAdsSearchTermView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DynamicSearchAdsSearchTermView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DynamicSearchAdsSearchTermView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DynamicSearchAdsSearchTermView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.searchTerm != null && message.hasOwnProperty("searchTerm")) {
                                var error = $root.google.protobuf.StringValue.verify(message.searchTerm);
                                if (error)
                                    return "searchTerm." + error;
                            }
                            if (message.headline != null && message.hasOwnProperty("headline")) {
                                var error = $root.google.protobuf.StringValue.verify(message.headline);
                                if (error)
                                    return "headline." + error;
                            }
                            if (message.landingPage != null && message.hasOwnProperty("landingPage")) {
                                var error = $root.google.protobuf.StringValue.verify(message.landingPage);
                                if (error)
                                    return "landingPage." + error;
                            }
                            if (message.pageUrl != null && message.hasOwnProperty("pageUrl")) {
                                var error = $root.google.protobuf.StringValue.verify(message.pageUrl);
                                if (error)
                                    return "pageUrl." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a DynamicSearchAdsSearchTermView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView} DynamicSearchAdsSearchTermView
                         */
                        DynamicSearchAdsSearchTermView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.searchTerm != null) {
                                if (typeof object.searchTerm !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView.searchTerm: object expected");
                                message.searchTerm = $root.google.protobuf.StringValue.fromObject(object.searchTerm);
                            }
                            if (object.headline != null) {
                                if (typeof object.headline !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView.headline: object expected");
                                message.headline = $root.google.protobuf.StringValue.fromObject(object.headline);
                            }
                            if (object.landingPage != null) {
                                if (typeof object.landingPage !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView.landingPage: object expected");
                                message.landingPage = $root.google.protobuf.StringValue.fromObject(object.landingPage);
                            }
                            if (object.pageUrl != null) {
                                if (typeof object.pageUrl !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView.pageUrl: object expected");
                                message.pageUrl = $root.google.protobuf.StringValue.fromObject(object.pageUrl);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a DynamicSearchAdsSearchTermView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView
                         * @static
                         * @param {google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView} message DynamicSearchAdsSearchTermView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DynamicSearchAdsSearchTermView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.searchTerm = null;
                                object.headline = null;
                                object.landingPage = null;
                                object.pageUrl = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.searchTerm != null && message.hasOwnProperty("searchTerm"))
                                object.searchTerm = $root.google.protobuf.StringValue.toObject(message.searchTerm, options);
                            if (message.headline != null && message.hasOwnProperty("headline"))
                                object.headline = $root.google.protobuf.StringValue.toObject(message.headline, options);
                            if (message.landingPage != null && message.hasOwnProperty("landingPage"))
                                object.landingPage = $root.google.protobuf.StringValue.toObject(message.landingPage, options);
                            if (message.pageUrl != null && message.hasOwnProperty("pageUrl"))
                                object.pageUrl = $root.google.protobuf.StringValue.toObject(message.pageUrl, options);
                            return object;
                        };

                        /**
                         * Converts this DynamicSearchAdsSearchTermView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DynamicSearchAdsSearchTermView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return DynamicSearchAdsSearchTermView;
                    })();

                    resources.ExpandedLandingPageView = (function() {

                        /**
                         * Properties of an ExpandedLandingPageView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IExpandedLandingPageView
                         * @property {string|null} [resourceName] ExpandedLandingPageView resourceName
                         * @property {google.protobuf.IStringValue|null} [expandedFinalUrl] ExpandedLandingPageView expandedFinalUrl
                         */

                        /**
                         * Constructs a new ExpandedLandingPageView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an ExpandedLandingPageView.
                         * @implements IExpandedLandingPageView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IExpandedLandingPageView=} [properties] Properties to set
                         */
                        function ExpandedLandingPageView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ExpandedLandingPageView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.ExpandedLandingPageView
                         * @instance
                         */
                        ExpandedLandingPageView.prototype.resourceName = "";

                        /**
                         * ExpandedLandingPageView expandedFinalUrl.
                         * @member {google.protobuf.IStringValue|null|undefined} expandedFinalUrl
                         * @memberof google.ads.googleads.v1.resources.ExpandedLandingPageView
                         * @instance
                         */
                        ExpandedLandingPageView.prototype.expandedFinalUrl = null;

                        /**
                         * Creates a new ExpandedLandingPageView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.ExpandedLandingPageView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IExpandedLandingPageView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.ExpandedLandingPageView} ExpandedLandingPageView instance
                         */
                        ExpandedLandingPageView.create = function create(properties) {
                            return new ExpandedLandingPageView(properties);
                        };

                        /**
                         * Encodes the specified ExpandedLandingPageView message. Does not implicitly {@link google.ads.googleads.v1.resources.ExpandedLandingPageView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.ExpandedLandingPageView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IExpandedLandingPageView} message ExpandedLandingPageView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExpandedLandingPageView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.expandedFinalUrl != null && message.hasOwnProperty("expandedFinalUrl"))
                                $root.google.protobuf.StringValue.encode(message.expandedFinalUrl, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ExpandedLandingPageView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.ExpandedLandingPageView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ExpandedLandingPageView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IExpandedLandingPageView} message ExpandedLandingPageView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExpandedLandingPageView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ExpandedLandingPageView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.ExpandedLandingPageView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.ExpandedLandingPageView} ExpandedLandingPageView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExpandedLandingPageView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.ExpandedLandingPageView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.expandedFinalUrl = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ExpandedLandingPageView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ExpandedLandingPageView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.ExpandedLandingPageView} ExpandedLandingPageView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExpandedLandingPageView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ExpandedLandingPageView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.ExpandedLandingPageView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExpandedLandingPageView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.expandedFinalUrl != null && message.hasOwnProperty("expandedFinalUrl")) {
                                var error = $root.google.protobuf.StringValue.verify(message.expandedFinalUrl);
                                if (error)
                                    return "expandedFinalUrl." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an ExpandedLandingPageView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.ExpandedLandingPageView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.ExpandedLandingPageView} ExpandedLandingPageView
                         */
                        ExpandedLandingPageView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.ExpandedLandingPageView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.ExpandedLandingPageView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.expandedFinalUrl != null) {
                                if (typeof object.expandedFinalUrl !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ExpandedLandingPageView.expandedFinalUrl: object expected");
                                message.expandedFinalUrl = $root.google.protobuf.StringValue.fromObject(object.expandedFinalUrl);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an ExpandedLandingPageView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.ExpandedLandingPageView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ExpandedLandingPageView} message ExpandedLandingPageView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExpandedLandingPageView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.expandedFinalUrl = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.expandedFinalUrl != null && message.hasOwnProperty("expandedFinalUrl"))
                                object.expandedFinalUrl = $root.google.protobuf.StringValue.toObject(message.expandedFinalUrl, options);
                            return object;
                        };

                        /**
                         * Converts this ExpandedLandingPageView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.ExpandedLandingPageView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExpandedLandingPageView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ExpandedLandingPageView;
                    })();

                    resources.ExtensionFeedItem = (function() {

                        /**
                         * Properties of an ExtensionFeedItem.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IExtensionFeedItem
                         * @property {string|null} [resourceName] ExtensionFeedItem resourceName
                         * @property {google.ads.googleads.v1.enums.ExtensionTypeEnum.ExtensionType|null} [extensionType] ExtensionFeedItem extensionType
                         * @property {google.protobuf.IStringValue|null} [startDateTime] ExtensionFeedItem startDateTime
                         * @property {google.protobuf.IStringValue|null} [endDateTime] ExtensionFeedItem endDateTime
                         * @property {Array.<google.ads.googleads.v1.common.IAdScheduleInfo>|null} [adSchedules] ExtensionFeedItem adSchedules
                         * @property {google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum.FeedItemTargetDevice|null} [device] ExtensionFeedItem device
                         * @property {google.ads.googleads.v1.enums.FeedItemStatusEnum.FeedItemStatus|null} [status] ExtensionFeedItem status
                         * @property {google.ads.googleads.v1.common.ISitelinkFeedItem|null} [sitelinkFeedItem] ExtensionFeedItem sitelinkFeedItem
                         * @property {google.ads.googleads.v1.common.IStructuredSnippetFeedItem|null} [structuredSnippetFeedItem] ExtensionFeedItem structuredSnippetFeedItem
                         * @property {google.ads.googleads.v1.common.IAppFeedItem|null} [appFeedItem] ExtensionFeedItem appFeedItem
                         * @property {google.ads.googleads.v1.common.ICallFeedItem|null} [callFeedItem] ExtensionFeedItem callFeedItem
                         * @property {google.ads.googleads.v1.common.ICalloutFeedItem|null} [calloutFeedItem] ExtensionFeedItem calloutFeedItem
                         * @property {google.ads.googleads.v1.common.ITextMessageFeedItem|null} [textMessageFeedItem] ExtensionFeedItem textMessageFeedItem
                         * @property {google.ads.googleads.v1.common.IPriceFeedItem|null} [priceFeedItem] ExtensionFeedItem priceFeedItem
                         * @property {google.ads.googleads.v1.common.IPromotionFeedItem|null} [promotionFeedItem] ExtensionFeedItem promotionFeedItem
                         * @property {google.ads.googleads.v1.common.ILocationFeedItem|null} [locationFeedItem] ExtensionFeedItem locationFeedItem
                         * @property {google.ads.googleads.v1.common.IAffiliateLocationFeedItem|null} [affiliateLocationFeedItem] ExtensionFeedItem affiliateLocationFeedItem
                         */

                        /**
                         * Constructs a new ExtensionFeedItem.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an ExtensionFeedItem.
                         * @implements IExtensionFeedItem
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IExtensionFeedItem=} [properties] Properties to set
                         */
                        function ExtensionFeedItem(properties) {
                            this.adSchedules = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ExtensionFeedItem resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         */
                        ExtensionFeedItem.prototype.resourceName = "";

                        /**
                         * ExtensionFeedItem extensionType.
                         * @member {google.ads.googleads.v1.enums.ExtensionTypeEnum.ExtensionType} extensionType
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         */
                        ExtensionFeedItem.prototype.extensionType = 0;

                        /**
                         * ExtensionFeedItem startDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} startDateTime
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         */
                        ExtensionFeedItem.prototype.startDateTime = null;

                        /**
                         * ExtensionFeedItem endDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} endDateTime
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         */
                        ExtensionFeedItem.prototype.endDateTime = null;

                        /**
                         * ExtensionFeedItem adSchedules.
                         * @member {Array.<google.ads.googleads.v1.common.IAdScheduleInfo>} adSchedules
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         */
                        ExtensionFeedItem.prototype.adSchedules = $util.emptyArray;

                        /**
                         * ExtensionFeedItem device.
                         * @member {google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum.FeedItemTargetDevice} device
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         */
                        ExtensionFeedItem.prototype.device = 0;

                        /**
                         * ExtensionFeedItem status.
                         * @member {google.ads.googleads.v1.enums.FeedItemStatusEnum.FeedItemStatus} status
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         */
                        ExtensionFeedItem.prototype.status = 0;

                        /**
                         * ExtensionFeedItem sitelinkFeedItem.
                         * @member {google.ads.googleads.v1.common.ISitelinkFeedItem|null|undefined} sitelinkFeedItem
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         */
                        ExtensionFeedItem.prototype.sitelinkFeedItem = null;

                        /**
                         * ExtensionFeedItem structuredSnippetFeedItem.
                         * @member {google.ads.googleads.v1.common.IStructuredSnippetFeedItem|null|undefined} structuredSnippetFeedItem
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         */
                        ExtensionFeedItem.prototype.structuredSnippetFeedItem = null;

                        /**
                         * ExtensionFeedItem appFeedItem.
                         * @member {google.ads.googleads.v1.common.IAppFeedItem|null|undefined} appFeedItem
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         */
                        ExtensionFeedItem.prototype.appFeedItem = null;

                        /**
                         * ExtensionFeedItem callFeedItem.
                         * @member {google.ads.googleads.v1.common.ICallFeedItem|null|undefined} callFeedItem
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         */
                        ExtensionFeedItem.prototype.callFeedItem = null;

                        /**
                         * ExtensionFeedItem calloutFeedItem.
                         * @member {google.ads.googleads.v1.common.ICalloutFeedItem|null|undefined} calloutFeedItem
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         */
                        ExtensionFeedItem.prototype.calloutFeedItem = null;

                        /**
                         * ExtensionFeedItem textMessageFeedItem.
                         * @member {google.ads.googleads.v1.common.ITextMessageFeedItem|null|undefined} textMessageFeedItem
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         */
                        ExtensionFeedItem.prototype.textMessageFeedItem = null;

                        /**
                         * ExtensionFeedItem priceFeedItem.
                         * @member {google.ads.googleads.v1.common.IPriceFeedItem|null|undefined} priceFeedItem
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         */
                        ExtensionFeedItem.prototype.priceFeedItem = null;

                        /**
                         * ExtensionFeedItem promotionFeedItem.
                         * @member {google.ads.googleads.v1.common.IPromotionFeedItem|null|undefined} promotionFeedItem
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         */
                        ExtensionFeedItem.prototype.promotionFeedItem = null;

                        /**
                         * ExtensionFeedItem locationFeedItem.
                         * @member {google.ads.googleads.v1.common.ILocationFeedItem|null|undefined} locationFeedItem
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         */
                        ExtensionFeedItem.prototype.locationFeedItem = null;

                        /**
                         * ExtensionFeedItem affiliateLocationFeedItem.
                         * @member {google.ads.googleads.v1.common.IAffiliateLocationFeedItem|null|undefined} affiliateLocationFeedItem
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         */
                        ExtensionFeedItem.prototype.affiliateLocationFeedItem = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * ExtensionFeedItem extension.
                         * @member {"sitelinkFeedItem"|"structuredSnippetFeedItem"|"appFeedItem"|"callFeedItem"|"calloutFeedItem"|"textMessageFeedItem"|"priceFeedItem"|"promotionFeedItem"|"locationFeedItem"|"affiliateLocationFeedItem"|undefined} extension
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         */
                        Object.defineProperty(ExtensionFeedItem.prototype, "extension", {
                            get: $util.oneOfGetter($oneOfFields = ["sitelinkFeedItem", "structuredSnippetFeedItem", "appFeedItem", "callFeedItem", "calloutFeedItem", "textMessageFeedItem", "priceFeedItem", "promotionFeedItem", "locationFeedItem", "affiliateLocationFeedItem"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new ExtensionFeedItem instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.resources.IExtensionFeedItem=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.ExtensionFeedItem} ExtensionFeedItem instance
                         */
                        ExtensionFeedItem.create = function create(properties) {
                            return new ExtensionFeedItem(properties);
                        };

                        /**
                         * Encodes the specified ExtensionFeedItem message. Does not implicitly {@link google.ads.googleads.v1.resources.ExtensionFeedItem.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.resources.IExtensionFeedItem} message ExtensionFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExtensionFeedItem.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.sitelinkFeedItem != null && message.hasOwnProperty("sitelinkFeedItem"))
                                $root.google.ads.googleads.v1.common.SitelinkFeedItem.encode(message.sitelinkFeedItem, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.structuredSnippetFeedItem != null && message.hasOwnProperty("structuredSnippetFeedItem"))
                                $root.google.ads.googleads.v1.common.StructuredSnippetFeedItem.encode(message.structuredSnippetFeedItem, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.status);
                            if (message.startDateTime != null && message.hasOwnProperty("startDateTime"))
                                $root.google.protobuf.StringValue.encode(message.startDateTime, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.endDateTime != null && message.hasOwnProperty("endDateTime"))
                                $root.google.protobuf.StringValue.encode(message.endDateTime, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.appFeedItem != null && message.hasOwnProperty("appFeedItem"))
                                $root.google.ads.googleads.v1.common.AppFeedItem.encode(message.appFeedItem, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.callFeedItem != null && message.hasOwnProperty("callFeedItem"))
                                $root.google.ads.googleads.v1.common.CallFeedItem.encode(message.callFeedItem, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.calloutFeedItem != null && message.hasOwnProperty("calloutFeedItem"))
                                $root.google.ads.googleads.v1.common.CalloutFeedItem.encode(message.calloutFeedItem, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.textMessageFeedItem != null && message.hasOwnProperty("textMessageFeedItem"))
                                $root.google.ads.googleads.v1.common.TextMessageFeedItem.encode(message.textMessageFeedItem, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.priceFeedItem != null && message.hasOwnProperty("priceFeedItem"))
                                $root.google.ads.googleads.v1.common.PriceFeedItem.encode(message.priceFeedItem, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.promotionFeedItem != null && message.hasOwnProperty("promotionFeedItem"))
                                $root.google.ads.googleads.v1.common.PromotionFeedItem.encode(message.promotionFeedItem, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.extensionType != null && message.hasOwnProperty("extensionType"))
                                writer.uint32(/* id 13, wireType 0 =*/104).int32(message.extensionType);
                            if (message.locationFeedItem != null && message.hasOwnProperty("locationFeedItem"))
                                $root.google.ads.googleads.v1.common.LocationFeedItem.encode(message.locationFeedItem, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.affiliateLocationFeedItem != null && message.hasOwnProperty("affiliateLocationFeedItem"))
                                $root.google.ads.googleads.v1.common.AffiliateLocationFeedItem.encode(message.affiliateLocationFeedItem, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
                            if (message.adSchedules != null && message.adSchedules.length)
                                for (var i = 0; i < message.adSchedules.length; ++i)
                                    $root.google.ads.googleads.v1.common.AdScheduleInfo.encode(message.adSchedules[i], writer.uint32(/* id 16, wireType 2 =*/130).fork()).ldelim();
                            if (message.device != null && message.hasOwnProperty("device"))
                                writer.uint32(/* id 17, wireType 0 =*/136).int32(message.device);
                            return writer;
                        };

                        /**
                         * Encodes the specified ExtensionFeedItem message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.ExtensionFeedItem.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.resources.IExtensionFeedItem} message ExtensionFeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExtensionFeedItem.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ExtensionFeedItem message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.ExtensionFeedItem} ExtensionFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExtensionFeedItem.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.ExtensionFeedItem();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 13:
                                    message.extensionType = reader.int32();
                                    break;
                                case 5:
                                    message.startDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.endDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 16:
                                    if (!(message.adSchedules && message.adSchedules.length))
                                        message.adSchedules = [];
                                    message.adSchedules.push($root.google.ads.googleads.v1.common.AdScheduleInfo.decode(reader, reader.uint32()));
                                    break;
                                case 17:
                                    message.device = reader.int32();
                                    break;
                                case 4:
                                    message.status = reader.int32();
                                    break;
                                case 2:
                                    message.sitelinkFeedItem = $root.google.ads.googleads.v1.common.SitelinkFeedItem.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.structuredSnippetFeedItem = $root.google.ads.googleads.v1.common.StructuredSnippetFeedItem.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.appFeedItem = $root.google.ads.googleads.v1.common.AppFeedItem.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.callFeedItem = $root.google.ads.googleads.v1.common.CallFeedItem.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.calloutFeedItem = $root.google.ads.googleads.v1.common.CalloutFeedItem.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.textMessageFeedItem = $root.google.ads.googleads.v1.common.TextMessageFeedItem.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.priceFeedItem = $root.google.ads.googleads.v1.common.PriceFeedItem.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.promotionFeedItem = $root.google.ads.googleads.v1.common.PromotionFeedItem.decode(reader, reader.uint32());
                                    break;
                                case 14:
                                    message.locationFeedItem = $root.google.ads.googleads.v1.common.LocationFeedItem.decode(reader, reader.uint32());
                                    break;
                                case 15:
                                    message.affiliateLocationFeedItem = $root.google.ads.googleads.v1.common.AffiliateLocationFeedItem.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ExtensionFeedItem message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.ExtensionFeedItem} ExtensionFeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExtensionFeedItem.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ExtensionFeedItem message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExtensionFeedItem.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.extensionType != null && message.hasOwnProperty("extensionType"))
                                switch (message.extensionType) {
                                default:
                                    return "extensionType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                    break;
                                }
                            if (message.startDateTime != null && message.hasOwnProperty("startDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.startDateTime);
                                if (error)
                                    return "startDateTime." + error;
                            }
                            if (message.endDateTime != null && message.hasOwnProperty("endDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.endDateTime);
                                if (error)
                                    return "endDateTime." + error;
                            }
                            if (message.adSchedules != null && message.hasOwnProperty("adSchedules")) {
                                if (!Array.isArray(message.adSchedules))
                                    return "adSchedules: array expected";
                                for (var i = 0; i < message.adSchedules.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.AdScheduleInfo.verify(message.adSchedules[i]);
                                    if (error)
                                        return "adSchedules." + error;
                                }
                            }
                            if (message.device != null && message.hasOwnProperty("device"))
                                switch (message.device) {
                                default:
                                    return "device: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.sitelinkFeedItem != null && message.hasOwnProperty("sitelinkFeedItem")) {
                                properties.extension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.SitelinkFeedItem.verify(message.sitelinkFeedItem);
                                    if (error)
                                        return "sitelinkFeedItem." + error;
                                }
                            }
                            if (message.structuredSnippetFeedItem != null && message.hasOwnProperty("structuredSnippetFeedItem")) {
                                if (properties.extension === 1)
                                    return "extension: multiple values";
                                properties.extension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.StructuredSnippetFeedItem.verify(message.structuredSnippetFeedItem);
                                    if (error)
                                        return "structuredSnippetFeedItem." + error;
                                }
                            }
                            if (message.appFeedItem != null && message.hasOwnProperty("appFeedItem")) {
                                if (properties.extension === 1)
                                    return "extension: multiple values";
                                properties.extension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.AppFeedItem.verify(message.appFeedItem);
                                    if (error)
                                        return "appFeedItem." + error;
                                }
                            }
                            if (message.callFeedItem != null && message.hasOwnProperty("callFeedItem")) {
                                if (properties.extension === 1)
                                    return "extension: multiple values";
                                properties.extension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.CallFeedItem.verify(message.callFeedItem);
                                    if (error)
                                        return "callFeedItem." + error;
                                }
                            }
                            if (message.calloutFeedItem != null && message.hasOwnProperty("calloutFeedItem")) {
                                if (properties.extension === 1)
                                    return "extension: multiple values";
                                properties.extension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.CalloutFeedItem.verify(message.calloutFeedItem);
                                    if (error)
                                        return "calloutFeedItem." + error;
                                }
                            }
                            if (message.textMessageFeedItem != null && message.hasOwnProperty("textMessageFeedItem")) {
                                if (properties.extension === 1)
                                    return "extension: multiple values";
                                properties.extension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.TextMessageFeedItem.verify(message.textMessageFeedItem);
                                    if (error)
                                        return "textMessageFeedItem." + error;
                                }
                            }
                            if (message.priceFeedItem != null && message.hasOwnProperty("priceFeedItem")) {
                                if (properties.extension === 1)
                                    return "extension: multiple values";
                                properties.extension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.PriceFeedItem.verify(message.priceFeedItem);
                                    if (error)
                                        return "priceFeedItem." + error;
                                }
                            }
                            if (message.promotionFeedItem != null && message.hasOwnProperty("promotionFeedItem")) {
                                if (properties.extension === 1)
                                    return "extension: multiple values";
                                properties.extension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.PromotionFeedItem.verify(message.promotionFeedItem);
                                    if (error)
                                        return "promotionFeedItem." + error;
                                }
                            }
                            if (message.locationFeedItem != null && message.hasOwnProperty("locationFeedItem")) {
                                if (properties.extension === 1)
                                    return "extension: multiple values";
                                properties.extension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.LocationFeedItem.verify(message.locationFeedItem);
                                    if (error)
                                        return "locationFeedItem." + error;
                                }
                            }
                            if (message.affiliateLocationFeedItem != null && message.hasOwnProperty("affiliateLocationFeedItem")) {
                                if (properties.extension === 1)
                                    return "extension: multiple values";
                                properties.extension = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.AffiliateLocationFeedItem.verify(message.affiliateLocationFeedItem);
                                    if (error)
                                        return "affiliateLocationFeedItem." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an ExtensionFeedItem message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.ExtensionFeedItem} ExtensionFeedItem
                         */
                        ExtensionFeedItem.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.ExtensionFeedItem)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.ExtensionFeedItem();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            switch (object.extensionType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.extensionType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.extensionType = 1;
                                break;
                            case "NONE":
                            case 2:
                                message.extensionType = 2;
                                break;
                            case "APP":
                            case 3:
                                message.extensionType = 3;
                                break;
                            case "CALL":
                            case 4:
                                message.extensionType = 4;
                                break;
                            case "CALLOUT":
                            case 5:
                                message.extensionType = 5;
                                break;
                            case "MESSAGE":
                            case 6:
                                message.extensionType = 6;
                                break;
                            case "PRICE":
                            case 7:
                                message.extensionType = 7;
                                break;
                            case "PROMOTION":
                            case 8:
                                message.extensionType = 8;
                                break;
                            case "REVIEW":
                            case 9:
                                message.extensionType = 9;
                                break;
                            case "SITELINK":
                            case 10:
                                message.extensionType = 10;
                                break;
                            case "STRUCTURED_SNIPPET":
                            case 11:
                                message.extensionType = 11;
                                break;
                            case "LOCATION":
                            case 12:
                                message.extensionType = 12;
                                break;
                            case "AFFILIATE_LOCATION":
                            case 13:
                                message.extensionType = 13;
                                break;
                            }
                            if (object.startDateTime != null) {
                                if (typeof object.startDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ExtensionFeedItem.startDateTime: object expected");
                                message.startDateTime = $root.google.protobuf.StringValue.fromObject(object.startDateTime);
                            }
                            if (object.endDateTime != null) {
                                if (typeof object.endDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ExtensionFeedItem.endDateTime: object expected");
                                message.endDateTime = $root.google.protobuf.StringValue.fromObject(object.endDateTime);
                            }
                            if (object.adSchedules) {
                                if (!Array.isArray(object.adSchedules))
                                    throw TypeError(".google.ads.googleads.v1.resources.ExtensionFeedItem.adSchedules: array expected");
                                message.adSchedules = [];
                                for (var i = 0; i < object.adSchedules.length; ++i) {
                                    if (typeof object.adSchedules[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.ExtensionFeedItem.adSchedules: object expected");
                                    message.adSchedules[i] = $root.google.ads.googleads.v1.common.AdScheduleInfo.fromObject(object.adSchedules[i]);
                                }
                            }
                            switch (object.device) {
                            case "UNSPECIFIED":
                            case 0:
                                message.device = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.device = 1;
                                break;
                            case "MOBILE":
                            case 2:
                                message.device = 2;
                                break;
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "REMOVED":
                            case 3:
                                message.status = 3;
                                break;
                            }
                            if (object.sitelinkFeedItem != null) {
                                if (typeof object.sitelinkFeedItem !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ExtensionFeedItem.sitelinkFeedItem: object expected");
                                message.sitelinkFeedItem = $root.google.ads.googleads.v1.common.SitelinkFeedItem.fromObject(object.sitelinkFeedItem);
                            }
                            if (object.structuredSnippetFeedItem != null) {
                                if (typeof object.structuredSnippetFeedItem !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ExtensionFeedItem.structuredSnippetFeedItem: object expected");
                                message.structuredSnippetFeedItem = $root.google.ads.googleads.v1.common.StructuredSnippetFeedItem.fromObject(object.structuredSnippetFeedItem);
                            }
                            if (object.appFeedItem != null) {
                                if (typeof object.appFeedItem !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ExtensionFeedItem.appFeedItem: object expected");
                                message.appFeedItem = $root.google.ads.googleads.v1.common.AppFeedItem.fromObject(object.appFeedItem);
                            }
                            if (object.callFeedItem != null) {
                                if (typeof object.callFeedItem !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ExtensionFeedItem.callFeedItem: object expected");
                                message.callFeedItem = $root.google.ads.googleads.v1.common.CallFeedItem.fromObject(object.callFeedItem);
                            }
                            if (object.calloutFeedItem != null) {
                                if (typeof object.calloutFeedItem !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ExtensionFeedItem.calloutFeedItem: object expected");
                                message.calloutFeedItem = $root.google.ads.googleads.v1.common.CalloutFeedItem.fromObject(object.calloutFeedItem);
                            }
                            if (object.textMessageFeedItem != null) {
                                if (typeof object.textMessageFeedItem !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ExtensionFeedItem.textMessageFeedItem: object expected");
                                message.textMessageFeedItem = $root.google.ads.googleads.v1.common.TextMessageFeedItem.fromObject(object.textMessageFeedItem);
                            }
                            if (object.priceFeedItem != null) {
                                if (typeof object.priceFeedItem !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ExtensionFeedItem.priceFeedItem: object expected");
                                message.priceFeedItem = $root.google.ads.googleads.v1.common.PriceFeedItem.fromObject(object.priceFeedItem);
                            }
                            if (object.promotionFeedItem != null) {
                                if (typeof object.promotionFeedItem !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ExtensionFeedItem.promotionFeedItem: object expected");
                                message.promotionFeedItem = $root.google.ads.googleads.v1.common.PromotionFeedItem.fromObject(object.promotionFeedItem);
                            }
                            if (object.locationFeedItem != null) {
                                if (typeof object.locationFeedItem !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ExtensionFeedItem.locationFeedItem: object expected");
                                message.locationFeedItem = $root.google.ads.googleads.v1.common.LocationFeedItem.fromObject(object.locationFeedItem);
                            }
                            if (object.affiliateLocationFeedItem != null) {
                                if (typeof object.affiliateLocationFeedItem !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ExtensionFeedItem.affiliateLocationFeedItem: object expected");
                                message.affiliateLocationFeedItem = $root.google.ads.googleads.v1.common.AffiliateLocationFeedItem.fromObject(object.affiliateLocationFeedItem);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an ExtensionFeedItem message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @static
                         * @param {google.ads.googleads.v1.resources.ExtensionFeedItem} message ExtensionFeedItem
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExtensionFeedItem.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.adSchedules = [];
                            if (options.defaults) {
                                object.resourceName = "";
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                                object.startDateTime = null;
                                object.endDateTime = null;
                                object.extensionType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.device = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.sitelinkFeedItem != null && message.hasOwnProperty("sitelinkFeedItem")) {
                                object.sitelinkFeedItem = $root.google.ads.googleads.v1.common.SitelinkFeedItem.toObject(message.sitelinkFeedItem, options);
                                if (options.oneofs)
                                    object.extension = "sitelinkFeedItem";
                            }
                            if (message.structuredSnippetFeedItem != null && message.hasOwnProperty("structuredSnippetFeedItem")) {
                                object.structuredSnippetFeedItem = $root.google.ads.googleads.v1.common.StructuredSnippetFeedItem.toObject(message.structuredSnippetFeedItem, options);
                                if (options.oneofs)
                                    object.extension = "structuredSnippetFeedItem";
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.FeedItemStatusEnum.FeedItemStatus[message.status] : message.status;
                            if (message.startDateTime != null && message.hasOwnProperty("startDateTime"))
                                object.startDateTime = $root.google.protobuf.StringValue.toObject(message.startDateTime, options);
                            if (message.endDateTime != null && message.hasOwnProperty("endDateTime"))
                                object.endDateTime = $root.google.protobuf.StringValue.toObject(message.endDateTime, options);
                            if (message.appFeedItem != null && message.hasOwnProperty("appFeedItem")) {
                                object.appFeedItem = $root.google.ads.googleads.v1.common.AppFeedItem.toObject(message.appFeedItem, options);
                                if (options.oneofs)
                                    object.extension = "appFeedItem";
                            }
                            if (message.callFeedItem != null && message.hasOwnProperty("callFeedItem")) {
                                object.callFeedItem = $root.google.ads.googleads.v1.common.CallFeedItem.toObject(message.callFeedItem, options);
                                if (options.oneofs)
                                    object.extension = "callFeedItem";
                            }
                            if (message.calloutFeedItem != null && message.hasOwnProperty("calloutFeedItem")) {
                                object.calloutFeedItem = $root.google.ads.googleads.v1.common.CalloutFeedItem.toObject(message.calloutFeedItem, options);
                                if (options.oneofs)
                                    object.extension = "calloutFeedItem";
                            }
                            if (message.textMessageFeedItem != null && message.hasOwnProperty("textMessageFeedItem")) {
                                object.textMessageFeedItem = $root.google.ads.googleads.v1.common.TextMessageFeedItem.toObject(message.textMessageFeedItem, options);
                                if (options.oneofs)
                                    object.extension = "textMessageFeedItem";
                            }
                            if (message.priceFeedItem != null && message.hasOwnProperty("priceFeedItem")) {
                                object.priceFeedItem = $root.google.ads.googleads.v1.common.PriceFeedItem.toObject(message.priceFeedItem, options);
                                if (options.oneofs)
                                    object.extension = "priceFeedItem";
                            }
                            if (message.promotionFeedItem != null && message.hasOwnProperty("promotionFeedItem")) {
                                object.promotionFeedItem = $root.google.ads.googleads.v1.common.PromotionFeedItem.toObject(message.promotionFeedItem, options);
                                if (options.oneofs)
                                    object.extension = "promotionFeedItem";
                            }
                            if (message.extensionType != null && message.hasOwnProperty("extensionType"))
                                object.extensionType = options.enums === String ? $root.google.ads.googleads.v1.enums.ExtensionTypeEnum.ExtensionType[message.extensionType] : message.extensionType;
                            if (message.locationFeedItem != null && message.hasOwnProperty("locationFeedItem")) {
                                object.locationFeedItem = $root.google.ads.googleads.v1.common.LocationFeedItem.toObject(message.locationFeedItem, options);
                                if (options.oneofs)
                                    object.extension = "locationFeedItem";
                            }
                            if (message.affiliateLocationFeedItem != null && message.hasOwnProperty("affiliateLocationFeedItem")) {
                                object.affiliateLocationFeedItem = $root.google.ads.googleads.v1.common.AffiliateLocationFeedItem.toObject(message.affiliateLocationFeedItem, options);
                                if (options.oneofs)
                                    object.extension = "affiliateLocationFeedItem";
                            }
                            if (message.adSchedules && message.adSchedules.length) {
                                object.adSchedules = [];
                                for (var j = 0; j < message.adSchedules.length; ++j)
                                    object.adSchedules[j] = $root.google.ads.googleads.v1.common.AdScheduleInfo.toObject(message.adSchedules[j], options);
                            }
                            if (message.device != null && message.hasOwnProperty("device"))
                                object.device = options.enums === String ? $root.google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum.FeedItemTargetDevice[message.device] : message.device;
                            return object;
                        };

                        /**
                         * Converts this ExtensionFeedItem to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.ExtensionFeedItem
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExtensionFeedItem.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ExtensionFeedItem;
                    })();

                    resources.Feed = (function() {

                        /**
                         * Properties of a Feed.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IFeed
                         * @property {string|null} [resourceName] Feed resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] Feed id
                         * @property {google.protobuf.IStringValue|null} [name] Feed name
                         * @property {Array.<google.ads.googleads.v1.resources.IFeedAttribute>|null} [attributes] Feed attributes
                         * @property {Array.<google.ads.googleads.v1.resources.IFeedAttributeOperation>|null} [attributeOperations] Feed attributeOperations
                         * @property {google.ads.googleads.v1.enums.FeedOriginEnum.FeedOrigin|null} [origin] Feed origin
                         * @property {google.ads.googleads.v1.enums.FeedStatusEnum.FeedStatus|null} [status] Feed status
                         * @property {google.ads.googleads.v1.resources.Feed.IPlacesLocationFeedData|null} [placesLocationFeedData] Feed placesLocationFeedData
                         * @property {google.ads.googleads.v1.resources.Feed.IAffiliateLocationFeedData|null} [affiliateLocationFeedData] Feed affiliateLocationFeedData
                         */

                        /**
                         * Constructs a new Feed.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a Feed.
                         * @implements IFeed
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IFeed=} [properties] Properties to set
                         */
                        function Feed(properties) {
                            this.attributes = [];
                            this.attributeOperations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Feed resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @instance
                         */
                        Feed.prototype.resourceName = "";

                        /**
                         * Feed id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @instance
                         */
                        Feed.prototype.id = null;

                        /**
                         * Feed name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @instance
                         */
                        Feed.prototype.name = null;

                        /**
                         * Feed attributes.
                         * @member {Array.<google.ads.googleads.v1.resources.IFeedAttribute>} attributes
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @instance
                         */
                        Feed.prototype.attributes = $util.emptyArray;

                        /**
                         * Feed attributeOperations.
                         * @member {Array.<google.ads.googleads.v1.resources.IFeedAttributeOperation>} attributeOperations
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @instance
                         */
                        Feed.prototype.attributeOperations = $util.emptyArray;

                        /**
                         * Feed origin.
                         * @member {google.ads.googleads.v1.enums.FeedOriginEnum.FeedOrigin} origin
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @instance
                         */
                        Feed.prototype.origin = 0;

                        /**
                         * Feed status.
                         * @member {google.ads.googleads.v1.enums.FeedStatusEnum.FeedStatus} status
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @instance
                         */
                        Feed.prototype.status = 0;

                        /**
                         * Feed placesLocationFeedData.
                         * @member {google.ads.googleads.v1.resources.Feed.IPlacesLocationFeedData|null|undefined} placesLocationFeedData
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @instance
                         */
                        Feed.prototype.placesLocationFeedData = null;

                        /**
                         * Feed affiliateLocationFeedData.
                         * @member {google.ads.googleads.v1.resources.Feed.IAffiliateLocationFeedData|null|undefined} affiliateLocationFeedData
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @instance
                         */
                        Feed.prototype.affiliateLocationFeedData = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * Feed systemFeedGenerationData.
                         * @member {"placesLocationFeedData"|"affiliateLocationFeedData"|undefined} systemFeedGenerationData
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @instance
                         */
                        Object.defineProperty(Feed.prototype, "systemFeedGenerationData", {
                            get: $util.oneOfGetter($oneOfFields = ["placesLocationFeedData", "affiliateLocationFeedData"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new Feed instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeed=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.Feed} Feed instance
                         */
                        Feed.create = function create(properties) {
                            return new Feed(properties);
                        };

                        /**
                         * Encodes the specified Feed message. Does not implicitly {@link google.ads.googleads.v1.resources.Feed.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeed} message Feed message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Feed.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.attributes != null && message.attributes.length)
                                for (var i = 0; i < message.attributes.length; ++i)
                                    $root.google.ads.googleads.v1.resources.FeedAttribute.encode(message.attributes[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.origin != null && message.hasOwnProperty("origin"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.origin);
                            if (message.placesLocationFeedData != null && message.hasOwnProperty("placesLocationFeedData"))
                                $root.google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.encode(message.placesLocationFeedData, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.affiliateLocationFeedData != null && message.hasOwnProperty("affiliateLocationFeedData"))
                                $root.google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData.encode(message.affiliateLocationFeedData, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 8, wireType 0 =*/64).int32(message.status);
                            if (message.attributeOperations != null && message.attributeOperations.length)
                                for (var i = 0; i < message.attributeOperations.length; ++i)
                                    $root.google.ads.googleads.v1.resources.FeedAttributeOperation.encode(message.attributeOperations[i], writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified Feed message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Feed.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeed} message Feed message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Feed.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a Feed message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.Feed} Feed
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Feed.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Feed();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    if (!(message.attributes && message.attributes.length))
                                        message.attributes = [];
                                    message.attributes.push($root.google.ads.googleads.v1.resources.FeedAttribute.decode(reader, reader.uint32()));
                                    break;
                                case 9:
                                    if (!(message.attributeOperations && message.attributeOperations.length))
                                        message.attributeOperations = [];
                                    message.attributeOperations.push($root.google.ads.googleads.v1.resources.FeedAttributeOperation.decode(reader, reader.uint32()));
                                    break;
                                case 5:
                                    message.origin = reader.int32();
                                    break;
                                case 8:
                                    message.status = reader.int32();
                                    break;
                                case 6:
                                    message.placesLocationFeedData = $root.google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.affiliateLocationFeedData = $root.google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a Feed message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.Feed} Feed
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Feed.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a Feed message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Feed.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.attributes != null && message.hasOwnProperty("attributes")) {
                                if (!Array.isArray(message.attributes))
                                    return "attributes: array expected";
                                for (var i = 0; i < message.attributes.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.resources.FeedAttribute.verify(message.attributes[i]);
                                    if (error)
                                        return "attributes." + error;
                                }
                            }
                            if (message.attributeOperations != null && message.hasOwnProperty("attributeOperations")) {
                                if (!Array.isArray(message.attributeOperations))
                                    return "attributeOperations: array expected";
                                for (var i = 0; i < message.attributeOperations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.resources.FeedAttributeOperation.verify(message.attributeOperations[i]);
                                    if (error)
                                        return "attributeOperations." + error;
                                }
                            }
                            if (message.origin != null && message.hasOwnProperty("origin"))
                                switch (message.origin) {
                                default:
                                    return "origin: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.placesLocationFeedData != null && message.hasOwnProperty("placesLocationFeedData")) {
                                properties.systemFeedGenerationData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.verify(message.placesLocationFeedData);
                                    if (error)
                                        return "placesLocationFeedData." + error;
                                }
                            }
                            if (message.affiliateLocationFeedData != null && message.hasOwnProperty("affiliateLocationFeedData")) {
                                if (properties.systemFeedGenerationData === 1)
                                    return "systemFeedGenerationData: multiple values";
                                properties.systemFeedGenerationData = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData.verify(message.affiliateLocationFeedData);
                                    if (error)
                                        return "affiliateLocationFeedData." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a Feed message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.Feed} Feed
                         */
                        Feed.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.Feed)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.Feed();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Feed.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Feed.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            if (object.attributes) {
                                if (!Array.isArray(object.attributes))
                                    throw TypeError(".google.ads.googleads.v1.resources.Feed.attributes: array expected");
                                message.attributes = [];
                                for (var i = 0; i < object.attributes.length; ++i) {
                                    if (typeof object.attributes[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Feed.attributes: object expected");
                                    message.attributes[i] = $root.google.ads.googleads.v1.resources.FeedAttribute.fromObject(object.attributes[i]);
                                }
                            }
                            if (object.attributeOperations) {
                                if (!Array.isArray(object.attributeOperations))
                                    throw TypeError(".google.ads.googleads.v1.resources.Feed.attributeOperations: array expected");
                                message.attributeOperations = [];
                                for (var i = 0; i < object.attributeOperations.length; ++i) {
                                    if (typeof object.attributeOperations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Feed.attributeOperations: object expected");
                                    message.attributeOperations[i] = $root.google.ads.googleads.v1.resources.FeedAttributeOperation.fromObject(object.attributeOperations[i]);
                                }
                            }
                            switch (object.origin) {
                            case "UNSPECIFIED":
                            case 0:
                                message.origin = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.origin = 1;
                                break;
                            case "USER":
                            case 2:
                                message.origin = 2;
                                break;
                            case "GOOGLE":
                            case 3:
                                message.origin = 3;
                                break;
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "REMOVED":
                            case 3:
                                message.status = 3;
                                break;
                            }
                            if (object.placesLocationFeedData != null) {
                                if (typeof object.placesLocationFeedData !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Feed.placesLocationFeedData: object expected");
                                message.placesLocationFeedData = $root.google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.fromObject(object.placesLocationFeedData);
                            }
                            if (object.affiliateLocationFeedData != null) {
                                if (typeof object.affiliateLocationFeedData !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Feed.affiliateLocationFeedData: object expected");
                                message.affiliateLocationFeedData = $root.google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData.fromObject(object.affiliateLocationFeedData);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a Feed message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @static
                         * @param {google.ads.googleads.v1.resources.Feed} message Feed
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Feed.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.attributes = [];
                                object.attributeOperations = [];
                            }
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.name = null;
                                object.origin = options.enums === String ? "UNSPECIFIED" : 0;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.attributes && message.attributes.length) {
                                object.attributes = [];
                                for (var j = 0; j < message.attributes.length; ++j)
                                    object.attributes[j] = $root.google.ads.googleads.v1.resources.FeedAttribute.toObject(message.attributes[j], options);
                            }
                            if (message.origin != null && message.hasOwnProperty("origin"))
                                object.origin = options.enums === String ? $root.google.ads.googleads.v1.enums.FeedOriginEnum.FeedOrigin[message.origin] : message.origin;
                            if (message.placesLocationFeedData != null && message.hasOwnProperty("placesLocationFeedData")) {
                                object.placesLocationFeedData = $root.google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.toObject(message.placesLocationFeedData, options);
                                if (options.oneofs)
                                    object.systemFeedGenerationData = "placesLocationFeedData";
                            }
                            if (message.affiliateLocationFeedData != null && message.hasOwnProperty("affiliateLocationFeedData")) {
                                object.affiliateLocationFeedData = $root.google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData.toObject(message.affiliateLocationFeedData, options);
                                if (options.oneofs)
                                    object.systemFeedGenerationData = "affiliateLocationFeedData";
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.FeedStatusEnum.FeedStatus[message.status] : message.status;
                            if (message.attributeOperations && message.attributeOperations.length) {
                                object.attributeOperations = [];
                                for (var j = 0; j < message.attributeOperations.length; ++j)
                                    object.attributeOperations[j] = $root.google.ads.googleads.v1.resources.FeedAttributeOperation.toObject(message.attributeOperations[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this Feed to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.Feed
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Feed.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        Feed.PlacesLocationFeedData = (function() {

                            /**
                             * Properties of a PlacesLocationFeedData.
                             * @memberof google.ads.googleads.v1.resources.Feed
                             * @interface IPlacesLocationFeedData
                             * @property {google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.IOAuthInfo|null} [oauthInfo] PlacesLocationFeedData oauthInfo
                             * @property {google.protobuf.IStringValue|null} [emailAddress] PlacesLocationFeedData emailAddress
                             * @property {google.protobuf.IStringValue|null} [businessAccountId] PlacesLocationFeedData businessAccountId
                             * @property {google.protobuf.IStringValue|null} [businessNameFilter] PlacesLocationFeedData businessNameFilter
                             * @property {Array.<google.protobuf.IStringValue>|null} [categoryFilters] PlacesLocationFeedData categoryFilters
                             * @property {Array.<google.protobuf.IStringValue>|null} [labelFilters] PlacesLocationFeedData labelFilters
                             */

                            /**
                             * Constructs a new PlacesLocationFeedData.
                             * @memberof google.ads.googleads.v1.resources.Feed
                             * @classdesc Represents a PlacesLocationFeedData.
                             * @implements IPlacesLocationFeedData
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Feed.IPlacesLocationFeedData=} [properties] Properties to set
                             */
                            function PlacesLocationFeedData(properties) {
                                this.categoryFilters = [];
                                this.labelFilters = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * PlacesLocationFeedData oauthInfo.
                             * @member {google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.IOAuthInfo|null|undefined} oauthInfo
                             * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData
                             * @instance
                             */
                            PlacesLocationFeedData.prototype.oauthInfo = null;

                            /**
                             * PlacesLocationFeedData emailAddress.
                             * @member {google.protobuf.IStringValue|null|undefined} emailAddress
                             * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData
                             * @instance
                             */
                            PlacesLocationFeedData.prototype.emailAddress = null;

                            /**
                             * PlacesLocationFeedData businessAccountId.
                             * @member {google.protobuf.IStringValue|null|undefined} businessAccountId
                             * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData
                             * @instance
                             */
                            PlacesLocationFeedData.prototype.businessAccountId = null;

                            /**
                             * PlacesLocationFeedData businessNameFilter.
                             * @member {google.protobuf.IStringValue|null|undefined} businessNameFilter
                             * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData
                             * @instance
                             */
                            PlacesLocationFeedData.prototype.businessNameFilter = null;

                            /**
                             * PlacesLocationFeedData categoryFilters.
                             * @member {Array.<google.protobuf.IStringValue>} categoryFilters
                             * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData
                             * @instance
                             */
                            PlacesLocationFeedData.prototype.categoryFilters = $util.emptyArray;

                            /**
                             * PlacesLocationFeedData labelFilters.
                             * @member {Array.<google.protobuf.IStringValue>} labelFilters
                             * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData
                             * @instance
                             */
                            PlacesLocationFeedData.prototype.labelFilters = $util.emptyArray;

                            /**
                             * Creates a new PlacesLocationFeedData instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData
                             * @static
                             * @param {google.ads.googleads.v1.resources.Feed.IPlacesLocationFeedData=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData} PlacesLocationFeedData instance
                             */
                            PlacesLocationFeedData.create = function create(properties) {
                                return new PlacesLocationFeedData(properties);
                            };

                            /**
                             * Encodes the specified PlacesLocationFeedData message. Does not implicitly {@link google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData
                             * @static
                             * @param {google.ads.googleads.v1.resources.Feed.IPlacesLocationFeedData} message PlacesLocationFeedData message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            PlacesLocationFeedData.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.oauthInfo != null && message.hasOwnProperty("oauthInfo"))
                                    $root.google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo.encode(message.oauthInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.emailAddress != null && message.hasOwnProperty("emailAddress"))
                                    $root.google.protobuf.StringValue.encode(message.emailAddress, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                if (message.businessNameFilter != null && message.hasOwnProperty("businessNameFilter"))
                                    $root.google.protobuf.StringValue.encode(message.businessNameFilter, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                                if (message.categoryFilters != null && message.categoryFilters.length)
                                    for (var i = 0; i < message.categoryFilters.length; ++i)
                                        $root.google.protobuf.StringValue.encode(message.categoryFilters[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                                if (message.labelFilters != null && message.labelFilters.length)
                                    for (var i = 0; i < message.labelFilters.length; ++i)
                                        $root.google.protobuf.StringValue.encode(message.labelFilters[i], writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                                if (message.businessAccountId != null && message.hasOwnProperty("businessAccountId"))
                                    $root.google.protobuf.StringValue.encode(message.businessAccountId, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified PlacesLocationFeedData message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData
                             * @static
                             * @param {google.ads.googleads.v1.resources.Feed.IPlacesLocationFeedData} message PlacesLocationFeedData message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            PlacesLocationFeedData.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a PlacesLocationFeedData message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData} PlacesLocationFeedData
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            PlacesLocationFeedData.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.oauthInfo = $root.google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.emailAddress = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 10:
                                        message.businessAccountId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 4:
                                        message.businessNameFilter = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 5:
                                        if (!(message.categoryFilters && message.categoryFilters.length))
                                            message.categoryFilters = [];
                                        message.categoryFilters.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                        break;
                                    case 6:
                                        if (!(message.labelFilters && message.labelFilters.length))
                                            message.labelFilters = [];
                                        message.labelFilters.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a PlacesLocationFeedData message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData} PlacesLocationFeedData
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            PlacesLocationFeedData.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a PlacesLocationFeedData message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            PlacesLocationFeedData.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.oauthInfo != null && message.hasOwnProperty("oauthInfo")) {
                                    var error = $root.google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo.verify(message.oauthInfo);
                                    if (error)
                                        return "oauthInfo." + error;
                                }
                                if (message.emailAddress != null && message.hasOwnProperty("emailAddress")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.emailAddress);
                                    if (error)
                                        return "emailAddress." + error;
                                }
                                if (message.businessAccountId != null && message.hasOwnProperty("businessAccountId")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.businessAccountId);
                                    if (error)
                                        return "businessAccountId." + error;
                                }
                                if (message.businessNameFilter != null && message.hasOwnProperty("businessNameFilter")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.businessNameFilter);
                                    if (error)
                                        return "businessNameFilter." + error;
                                }
                                if (message.categoryFilters != null && message.hasOwnProperty("categoryFilters")) {
                                    if (!Array.isArray(message.categoryFilters))
                                        return "categoryFilters: array expected";
                                    for (var i = 0; i < message.categoryFilters.length; ++i) {
                                        var error = $root.google.protobuf.StringValue.verify(message.categoryFilters[i]);
                                        if (error)
                                            return "categoryFilters." + error;
                                    }
                                }
                                if (message.labelFilters != null && message.hasOwnProperty("labelFilters")) {
                                    if (!Array.isArray(message.labelFilters))
                                        return "labelFilters: array expected";
                                    for (var i = 0; i < message.labelFilters.length; ++i) {
                                        var error = $root.google.protobuf.StringValue.verify(message.labelFilters[i]);
                                        if (error)
                                            return "labelFilters." + error;
                                    }
                                }
                                return null;
                            };

                            /**
                             * Creates a PlacesLocationFeedData message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData} PlacesLocationFeedData
                             */
                            PlacesLocationFeedData.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData();
                                if (object.oauthInfo != null) {
                                    if (typeof object.oauthInfo !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.oauthInfo: object expected");
                                    message.oauthInfo = $root.google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo.fromObject(object.oauthInfo);
                                }
                                if (object.emailAddress != null) {
                                    if (typeof object.emailAddress !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.emailAddress: object expected");
                                    message.emailAddress = $root.google.protobuf.StringValue.fromObject(object.emailAddress);
                                }
                                if (object.businessAccountId != null) {
                                    if (typeof object.businessAccountId !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.businessAccountId: object expected");
                                    message.businessAccountId = $root.google.protobuf.StringValue.fromObject(object.businessAccountId);
                                }
                                if (object.businessNameFilter != null) {
                                    if (typeof object.businessNameFilter !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.businessNameFilter: object expected");
                                    message.businessNameFilter = $root.google.protobuf.StringValue.fromObject(object.businessNameFilter);
                                }
                                if (object.categoryFilters) {
                                    if (!Array.isArray(object.categoryFilters))
                                        throw TypeError(".google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.categoryFilters: array expected");
                                    message.categoryFilters = [];
                                    for (var i = 0; i < object.categoryFilters.length; ++i) {
                                        if (typeof object.categoryFilters[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.categoryFilters: object expected");
                                        message.categoryFilters[i] = $root.google.protobuf.StringValue.fromObject(object.categoryFilters[i]);
                                    }
                                }
                                if (object.labelFilters) {
                                    if (!Array.isArray(object.labelFilters))
                                        throw TypeError(".google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.labelFilters: array expected");
                                    message.labelFilters = [];
                                    for (var i = 0; i < object.labelFilters.length; ++i) {
                                        if (typeof object.labelFilters[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.labelFilters: object expected");
                                        message.labelFilters[i] = $root.google.protobuf.StringValue.fromObject(object.labelFilters[i]);
                                    }
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a PlacesLocationFeedData message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData
                             * @static
                             * @param {google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData} message PlacesLocationFeedData
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            PlacesLocationFeedData.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults) {
                                    object.categoryFilters = [];
                                    object.labelFilters = [];
                                }
                                if (options.defaults) {
                                    object.oauthInfo = null;
                                    object.emailAddress = null;
                                    object.businessNameFilter = null;
                                    object.businessAccountId = null;
                                }
                                if (message.oauthInfo != null && message.hasOwnProperty("oauthInfo"))
                                    object.oauthInfo = $root.google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo.toObject(message.oauthInfo, options);
                                if (message.emailAddress != null && message.hasOwnProperty("emailAddress"))
                                    object.emailAddress = $root.google.protobuf.StringValue.toObject(message.emailAddress, options);
                                if (message.businessNameFilter != null && message.hasOwnProperty("businessNameFilter"))
                                    object.businessNameFilter = $root.google.protobuf.StringValue.toObject(message.businessNameFilter, options);
                                if (message.categoryFilters && message.categoryFilters.length) {
                                    object.categoryFilters = [];
                                    for (var j = 0; j < message.categoryFilters.length; ++j)
                                        object.categoryFilters[j] = $root.google.protobuf.StringValue.toObject(message.categoryFilters[j], options);
                                }
                                if (message.labelFilters && message.labelFilters.length) {
                                    object.labelFilters = [];
                                    for (var j = 0; j < message.labelFilters.length; ++j)
                                        object.labelFilters[j] = $root.google.protobuf.StringValue.toObject(message.labelFilters[j], options);
                                }
                                if (message.businessAccountId != null && message.hasOwnProperty("businessAccountId"))
                                    object.businessAccountId = $root.google.protobuf.StringValue.toObject(message.businessAccountId, options);
                                return object;
                            };

                            /**
                             * Converts this PlacesLocationFeedData to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            PlacesLocationFeedData.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            PlacesLocationFeedData.OAuthInfo = (function() {

                                /**
                                 * Properties of a OAuthInfo.
                                 * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData
                                 * @interface IOAuthInfo
                                 * @property {google.protobuf.IStringValue|null} [httpMethod] OAuthInfo httpMethod
                                 * @property {google.protobuf.IStringValue|null} [httpRequestUrl] OAuthInfo httpRequestUrl
                                 * @property {google.protobuf.IStringValue|null} [httpAuthorizationHeader] OAuthInfo httpAuthorizationHeader
                                 */

                                /**
                                 * Constructs a new OAuthInfo.
                                 * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData
                                 * @classdesc Represents a OAuthInfo.
                                 * @implements IOAuthInfo
                                 * @constructor
                                 * @param {google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.IOAuthInfo=} [properties] Properties to set
                                 */
                                function OAuthInfo(properties) {
                                    if (properties)
                                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                            if (properties[keys[i]] != null)
                                                this[keys[i]] = properties[keys[i]];
                                }

                                /**
                                 * OAuthInfo httpMethod.
                                 * @member {google.protobuf.IStringValue|null|undefined} httpMethod
                                 * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo
                                 * @instance
                                 */
                                OAuthInfo.prototype.httpMethod = null;

                                /**
                                 * OAuthInfo httpRequestUrl.
                                 * @member {google.protobuf.IStringValue|null|undefined} httpRequestUrl
                                 * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo
                                 * @instance
                                 */
                                OAuthInfo.prototype.httpRequestUrl = null;

                                /**
                                 * OAuthInfo httpAuthorizationHeader.
                                 * @member {google.protobuf.IStringValue|null|undefined} httpAuthorizationHeader
                                 * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo
                                 * @instance
                                 */
                                OAuthInfo.prototype.httpAuthorizationHeader = null;

                                /**
                                 * Creates a new OAuthInfo instance using the specified properties.
                                 * @function create
                                 * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo
                                 * @static
                                 * @param {google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.IOAuthInfo=} [properties] Properties to set
                                 * @returns {google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo} OAuthInfo instance
                                 */
                                OAuthInfo.create = function create(properties) {
                                    return new OAuthInfo(properties);
                                };

                                /**
                                 * Encodes the specified OAuthInfo message. Does not implicitly {@link google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo.verify|verify} messages.
                                 * @function encode
                                 * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo
                                 * @static
                                 * @param {google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.IOAuthInfo} message OAuthInfo message or plain object to encode
                                 * @param {$protobuf.Writer} [writer] Writer to encode to
                                 * @returns {$protobuf.Writer} Writer
                                 */
                                OAuthInfo.encode = function encode(message, writer) {
                                    if (!writer)
                                        writer = $Writer.create();
                                    if (message.httpMethod != null && message.hasOwnProperty("httpMethod"))
                                        $root.google.protobuf.StringValue.encode(message.httpMethod, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                    if (message.httpRequestUrl != null && message.hasOwnProperty("httpRequestUrl"))
                                        $root.google.protobuf.StringValue.encode(message.httpRequestUrl, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                    if (message.httpAuthorizationHeader != null && message.hasOwnProperty("httpAuthorizationHeader"))
                                        $root.google.protobuf.StringValue.encode(message.httpAuthorizationHeader, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                                    return writer;
                                };

                                /**
                                 * Encodes the specified OAuthInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo.verify|verify} messages.
                                 * @function encodeDelimited
                                 * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo
                                 * @static
                                 * @param {google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.IOAuthInfo} message OAuthInfo message or plain object to encode
                                 * @param {$protobuf.Writer} [writer] Writer to encode to
                                 * @returns {$protobuf.Writer} Writer
                                 */
                                OAuthInfo.encodeDelimited = function encodeDelimited(message, writer) {
                                    return this.encode(message, writer).ldelim();
                                };

                                /**
                                 * Decodes a OAuthInfo message from the specified reader or buffer.
                                 * @function decode
                                 * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo
                                 * @static
                                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                                 * @param {number} [length] Message length if known beforehand
                                 * @returns {google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo} OAuthInfo
                                 * @throws {Error} If the payload is not a reader or valid buffer
                                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                                 */
                                OAuthInfo.decode = function decode(reader, length) {
                                    if (!(reader instanceof $Reader))
                                        reader = $Reader.create(reader);
                                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo();
                                    while (reader.pos < end) {
                                        var tag = reader.uint32();
                                        switch (tag >>> 3) {
                                        case 1:
                                            message.httpMethod = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                            break;
                                        case 2:
                                            message.httpRequestUrl = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                            break;
                                        case 3:
                                            message.httpAuthorizationHeader = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                            break;
                                        default:
                                            reader.skipType(tag & 7);
                                            break;
                                        }
                                    }
                                    return message;
                                };

                                /**
                                 * Decodes a OAuthInfo message from the specified reader or buffer, length delimited.
                                 * @function decodeDelimited
                                 * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo
                                 * @static
                                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                                 * @returns {google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo} OAuthInfo
                                 * @throws {Error} If the payload is not a reader or valid buffer
                                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                                 */
                                OAuthInfo.decodeDelimited = function decodeDelimited(reader) {
                                    if (!(reader instanceof $Reader))
                                        reader = new $Reader(reader);
                                    return this.decode(reader, reader.uint32());
                                };

                                /**
                                 * Verifies a OAuthInfo message.
                                 * @function verify
                                 * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo
                                 * @static
                                 * @param {Object.<string,*>} message Plain object to verify
                                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                                 */
                                OAuthInfo.verify = function verify(message) {
                                    if (typeof message !== "object" || message === null)
                                        return "object expected";
                                    if (message.httpMethod != null && message.hasOwnProperty("httpMethod")) {
                                        var error = $root.google.protobuf.StringValue.verify(message.httpMethod);
                                        if (error)
                                            return "httpMethod." + error;
                                    }
                                    if (message.httpRequestUrl != null && message.hasOwnProperty("httpRequestUrl")) {
                                        var error = $root.google.protobuf.StringValue.verify(message.httpRequestUrl);
                                        if (error)
                                            return "httpRequestUrl." + error;
                                    }
                                    if (message.httpAuthorizationHeader != null && message.hasOwnProperty("httpAuthorizationHeader")) {
                                        var error = $root.google.protobuf.StringValue.verify(message.httpAuthorizationHeader);
                                        if (error)
                                            return "httpAuthorizationHeader." + error;
                                    }
                                    return null;
                                };

                                /**
                                 * Creates a OAuthInfo message from a plain object. Also converts values to their respective internal types.
                                 * @function fromObject
                                 * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo
                                 * @static
                                 * @param {Object.<string,*>} object Plain object
                                 * @returns {google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo} OAuthInfo
                                 */
                                OAuthInfo.fromObject = function fromObject(object) {
                                    if (object instanceof $root.google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo)
                                        return object;
                                    var message = new $root.google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo();
                                    if (object.httpMethod != null) {
                                        if (typeof object.httpMethod !== "object")
                                            throw TypeError(".google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo.httpMethod: object expected");
                                        message.httpMethod = $root.google.protobuf.StringValue.fromObject(object.httpMethod);
                                    }
                                    if (object.httpRequestUrl != null) {
                                        if (typeof object.httpRequestUrl !== "object")
                                            throw TypeError(".google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo.httpRequestUrl: object expected");
                                        message.httpRequestUrl = $root.google.protobuf.StringValue.fromObject(object.httpRequestUrl);
                                    }
                                    if (object.httpAuthorizationHeader != null) {
                                        if (typeof object.httpAuthorizationHeader !== "object")
                                            throw TypeError(".google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo.httpAuthorizationHeader: object expected");
                                        message.httpAuthorizationHeader = $root.google.protobuf.StringValue.fromObject(object.httpAuthorizationHeader);
                                    }
                                    return message;
                                };

                                /**
                                 * Creates a plain object from a OAuthInfo message. Also converts values to other types if specified.
                                 * @function toObject
                                 * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo
                                 * @static
                                 * @param {google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo} message OAuthInfo
                                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                                 * @returns {Object.<string,*>} Plain object
                                 */
                                OAuthInfo.toObject = function toObject(message, options) {
                                    if (!options)
                                        options = {};
                                    var object = {};
                                    if (options.defaults) {
                                        object.httpMethod = null;
                                        object.httpRequestUrl = null;
                                        object.httpAuthorizationHeader = null;
                                    }
                                    if (message.httpMethod != null && message.hasOwnProperty("httpMethod"))
                                        object.httpMethod = $root.google.protobuf.StringValue.toObject(message.httpMethod, options);
                                    if (message.httpRequestUrl != null && message.hasOwnProperty("httpRequestUrl"))
                                        object.httpRequestUrl = $root.google.protobuf.StringValue.toObject(message.httpRequestUrl, options);
                                    if (message.httpAuthorizationHeader != null && message.hasOwnProperty("httpAuthorizationHeader"))
                                        object.httpAuthorizationHeader = $root.google.protobuf.StringValue.toObject(message.httpAuthorizationHeader, options);
                                    return object;
                                };

                                /**
                                 * Converts this OAuthInfo to JSON.
                                 * @function toJSON
                                 * @memberof google.ads.googleads.v1.resources.Feed.PlacesLocationFeedData.OAuthInfo
                                 * @instance
                                 * @returns {Object.<string,*>} JSON object
                                 */
                                OAuthInfo.prototype.toJSON = function toJSON() {
                                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                                };

                                return OAuthInfo;
                            })();

                            return PlacesLocationFeedData;
                        })();

                        Feed.AffiliateLocationFeedData = (function() {

                            /**
                             * Properties of an AffiliateLocationFeedData.
                             * @memberof google.ads.googleads.v1.resources.Feed
                             * @interface IAffiliateLocationFeedData
                             * @property {Array.<google.protobuf.IInt64Value>|null} [chainIds] AffiliateLocationFeedData chainIds
                             * @property {google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum.AffiliateLocationFeedRelationshipType|null} [relationshipType] AffiliateLocationFeedData relationshipType
                             */

                            /**
                             * Constructs a new AffiliateLocationFeedData.
                             * @memberof google.ads.googleads.v1.resources.Feed
                             * @classdesc Represents an AffiliateLocationFeedData.
                             * @implements IAffiliateLocationFeedData
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Feed.IAffiliateLocationFeedData=} [properties] Properties to set
                             */
                            function AffiliateLocationFeedData(properties) {
                                this.chainIds = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * AffiliateLocationFeedData chainIds.
                             * @member {Array.<google.protobuf.IInt64Value>} chainIds
                             * @memberof google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData
                             * @instance
                             */
                            AffiliateLocationFeedData.prototype.chainIds = $util.emptyArray;

                            /**
                             * AffiliateLocationFeedData relationshipType.
                             * @member {google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum.AffiliateLocationFeedRelationshipType} relationshipType
                             * @memberof google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData
                             * @instance
                             */
                            AffiliateLocationFeedData.prototype.relationshipType = 0;

                            /**
                             * Creates a new AffiliateLocationFeedData instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData
                             * @static
                             * @param {google.ads.googleads.v1.resources.Feed.IAffiliateLocationFeedData=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData} AffiliateLocationFeedData instance
                             */
                            AffiliateLocationFeedData.create = function create(properties) {
                                return new AffiliateLocationFeedData(properties);
                            };

                            /**
                             * Encodes the specified AffiliateLocationFeedData message. Does not implicitly {@link google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData
                             * @static
                             * @param {google.ads.googleads.v1.resources.Feed.IAffiliateLocationFeedData} message AffiliateLocationFeedData message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            AffiliateLocationFeedData.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.chainIds != null && message.chainIds.length)
                                    for (var i = 0; i < message.chainIds.length; ++i)
                                        $root.google.protobuf.Int64Value.encode(message.chainIds[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.relationshipType != null && message.hasOwnProperty("relationshipType"))
                                    writer.uint32(/* id 2, wireType 0 =*/16).int32(message.relationshipType);
                                return writer;
                            };

                            /**
                             * Encodes the specified AffiliateLocationFeedData message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData
                             * @static
                             * @param {google.ads.googleads.v1.resources.Feed.IAffiliateLocationFeedData} message AffiliateLocationFeedData message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            AffiliateLocationFeedData.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes an AffiliateLocationFeedData message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData} AffiliateLocationFeedData
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            AffiliateLocationFeedData.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        if (!(message.chainIds && message.chainIds.length))
                                            message.chainIds = [];
                                        message.chainIds.push($root.google.protobuf.Int64Value.decode(reader, reader.uint32()));
                                        break;
                                    case 2:
                                        message.relationshipType = reader.int32();
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes an AffiliateLocationFeedData message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData} AffiliateLocationFeedData
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            AffiliateLocationFeedData.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies an AffiliateLocationFeedData message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            AffiliateLocationFeedData.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.chainIds != null && message.hasOwnProperty("chainIds")) {
                                    if (!Array.isArray(message.chainIds))
                                        return "chainIds: array expected";
                                    for (var i = 0; i < message.chainIds.length; ++i) {
                                        var error = $root.google.protobuf.Int64Value.verify(message.chainIds[i]);
                                        if (error)
                                            return "chainIds." + error;
                                    }
                                }
                                if (message.relationshipType != null && message.hasOwnProperty("relationshipType"))
                                    switch (message.relationshipType) {
                                    default:
                                        return "relationshipType: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                        break;
                                    }
                                return null;
                            };

                            /**
                             * Creates an AffiliateLocationFeedData message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData} AffiliateLocationFeedData
                             */
                            AffiliateLocationFeedData.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData();
                                if (object.chainIds) {
                                    if (!Array.isArray(object.chainIds))
                                        throw TypeError(".google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData.chainIds: array expected");
                                    message.chainIds = [];
                                    for (var i = 0; i < object.chainIds.length; ++i) {
                                        if (typeof object.chainIds[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData.chainIds: object expected");
                                        message.chainIds[i] = $root.google.protobuf.Int64Value.fromObject(object.chainIds[i]);
                                    }
                                }
                                switch (object.relationshipType) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.relationshipType = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.relationshipType = 1;
                                    break;
                                case "GENERAL_RETAILER":
                                case 2:
                                    message.relationshipType = 2;
                                    break;
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from an AffiliateLocationFeedData message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData
                             * @static
                             * @param {google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData} message AffiliateLocationFeedData
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            AffiliateLocationFeedData.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.chainIds = [];
                                if (options.defaults)
                                    object.relationshipType = options.enums === String ? "UNSPECIFIED" : 0;
                                if (message.chainIds && message.chainIds.length) {
                                    object.chainIds = [];
                                    for (var j = 0; j < message.chainIds.length; ++j)
                                        object.chainIds[j] = $root.google.protobuf.Int64Value.toObject(message.chainIds[j], options);
                                }
                                if (message.relationshipType != null && message.hasOwnProperty("relationshipType"))
                                    object.relationshipType = options.enums === String ? $root.google.ads.googleads.v1.enums.AffiliateLocationFeedRelationshipTypeEnum.AffiliateLocationFeedRelationshipType[message.relationshipType] : message.relationshipType;
                                return object;
                            };

                            /**
                             * Converts this AffiliateLocationFeedData to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Feed.AffiliateLocationFeedData
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            AffiliateLocationFeedData.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return AffiliateLocationFeedData;
                        })();

                        return Feed;
                    })();

                    resources.FeedAttribute = (function() {

                        /**
                         * Properties of a FeedAttribute.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IFeedAttribute
                         * @property {google.protobuf.IInt64Value|null} [id] FeedAttribute id
                         * @property {google.protobuf.IStringValue|null} [name] FeedAttribute name
                         * @property {google.ads.googleads.v1.enums.FeedAttributeTypeEnum.FeedAttributeType|null} [type] FeedAttribute type
                         * @property {google.protobuf.IBoolValue|null} [isPartOfKey] FeedAttribute isPartOfKey
                         */

                        /**
                         * Constructs a new FeedAttribute.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a FeedAttribute.
                         * @implements IFeedAttribute
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IFeedAttribute=} [properties] Properties to set
                         */
                        function FeedAttribute(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * FeedAttribute id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.FeedAttribute
                         * @instance
                         */
                        FeedAttribute.prototype.id = null;

                        /**
                         * FeedAttribute name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.FeedAttribute
                         * @instance
                         */
                        FeedAttribute.prototype.name = null;

                        /**
                         * FeedAttribute type.
                         * @member {google.ads.googleads.v1.enums.FeedAttributeTypeEnum.FeedAttributeType} type
                         * @memberof google.ads.googleads.v1.resources.FeedAttribute
                         * @instance
                         */
                        FeedAttribute.prototype.type = 0;

                        /**
                         * FeedAttribute isPartOfKey.
                         * @member {google.protobuf.IBoolValue|null|undefined} isPartOfKey
                         * @memberof google.ads.googleads.v1.resources.FeedAttribute
                         * @instance
                         */
                        FeedAttribute.prototype.isPartOfKey = null;

                        /**
                         * Creates a new FeedAttribute instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.FeedAttribute
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedAttribute=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.FeedAttribute} FeedAttribute instance
                         */
                        FeedAttribute.create = function create(properties) {
                            return new FeedAttribute(properties);
                        };

                        /**
                         * Encodes the specified FeedAttribute message. Does not implicitly {@link google.ads.googleads.v1.resources.FeedAttribute.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.FeedAttribute
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedAttribute} message FeedAttribute message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedAttribute.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.type);
                            if (message.isPartOfKey != null && message.hasOwnProperty("isPartOfKey"))
                                $root.google.protobuf.BoolValue.encode(message.isPartOfKey, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedAttribute message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.FeedAttribute.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.FeedAttribute
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedAttribute} message FeedAttribute message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedAttribute.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedAttribute message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.FeedAttribute
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.FeedAttribute} FeedAttribute
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedAttribute.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.FeedAttribute();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.type = reader.int32();
                                    break;
                                case 4:
                                    message.isPartOfKey = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedAttribute message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.FeedAttribute
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.FeedAttribute} FeedAttribute
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedAttribute.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedAttribute message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.FeedAttribute
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedAttribute.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                    break;
                                }
                            if (message.isPartOfKey != null && message.hasOwnProperty("isPartOfKey")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.isPartOfKey);
                                if (error)
                                    return "isPartOfKey." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a FeedAttribute message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.FeedAttribute
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.FeedAttribute} FeedAttribute
                         */
                        FeedAttribute.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.FeedAttribute)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.FeedAttribute();
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedAttribute.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedAttribute.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "INT64":
                            case 2:
                                message.type = 2;
                                break;
                            case "DOUBLE":
                            case 3:
                                message.type = 3;
                                break;
                            case "STRING":
                            case 4:
                                message.type = 4;
                                break;
                            case "BOOLEAN":
                            case 5:
                                message.type = 5;
                                break;
                            case "URL":
                            case 6:
                                message.type = 6;
                                break;
                            case "DATE_TIME":
                            case 7:
                                message.type = 7;
                                break;
                            case "INT64_LIST":
                            case 8:
                                message.type = 8;
                                break;
                            case "DOUBLE_LIST":
                            case 9:
                                message.type = 9;
                                break;
                            case "STRING_LIST":
                            case 10:
                                message.type = 10;
                                break;
                            case "BOOLEAN_LIST":
                            case 11:
                                message.type = 11;
                                break;
                            case "URL_LIST":
                            case 12:
                                message.type = 12;
                                break;
                            case "DATE_TIME_LIST":
                            case 13:
                                message.type = 13;
                                break;
                            case "PRICE":
                            case 14:
                                message.type = 14;
                                break;
                            }
                            if (object.isPartOfKey != null) {
                                if (typeof object.isPartOfKey !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedAttribute.isPartOfKey: object expected");
                                message.isPartOfKey = $root.google.protobuf.BoolValue.fromObject(object.isPartOfKey);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a FeedAttribute message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.FeedAttribute
                         * @static
                         * @param {google.ads.googleads.v1.resources.FeedAttribute} message FeedAttribute
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedAttribute.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.id = null;
                                object.name = null;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.isPartOfKey = null;
                            }
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.FeedAttributeTypeEnum.FeedAttributeType[message.type] : message.type;
                            if (message.isPartOfKey != null && message.hasOwnProperty("isPartOfKey"))
                                object.isPartOfKey = $root.google.protobuf.BoolValue.toObject(message.isPartOfKey, options);
                            return object;
                        };

                        /**
                         * Converts this FeedAttribute to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.FeedAttribute
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedAttribute.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return FeedAttribute;
                    })();

                    resources.FeedAttributeOperation = (function() {

                        /**
                         * Properties of a FeedAttributeOperation.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IFeedAttributeOperation
                         * @property {google.ads.googleads.v1.resources.FeedAttributeOperation.Operator|null} [operator] FeedAttributeOperation operator
                         * @property {google.ads.googleads.v1.resources.IFeedAttribute|null} [value] FeedAttributeOperation value
                         */

                        /**
                         * Constructs a new FeedAttributeOperation.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a FeedAttributeOperation.
                         * @implements IFeedAttributeOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IFeedAttributeOperation=} [properties] Properties to set
                         */
                        function FeedAttributeOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * FeedAttributeOperation operator.
                         * @member {google.ads.googleads.v1.resources.FeedAttributeOperation.Operator} operator
                         * @memberof google.ads.googleads.v1.resources.FeedAttributeOperation
                         * @instance
                         */
                        FeedAttributeOperation.prototype.operator = 0;

                        /**
                         * FeedAttributeOperation value.
                         * @member {google.ads.googleads.v1.resources.IFeedAttribute|null|undefined} value
                         * @memberof google.ads.googleads.v1.resources.FeedAttributeOperation
                         * @instance
                         */
                        FeedAttributeOperation.prototype.value = null;

                        /**
                         * Creates a new FeedAttributeOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.FeedAttributeOperation
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedAttributeOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.FeedAttributeOperation} FeedAttributeOperation instance
                         */
                        FeedAttributeOperation.create = function create(properties) {
                            return new FeedAttributeOperation(properties);
                        };

                        /**
                         * Encodes the specified FeedAttributeOperation message. Does not implicitly {@link google.ads.googleads.v1.resources.FeedAttributeOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.FeedAttributeOperation
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedAttributeOperation} message FeedAttributeOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedAttributeOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.operator);
                            if (message.value != null && message.hasOwnProperty("value"))
                                $root.google.ads.googleads.v1.resources.FeedAttribute.encode(message.value, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedAttributeOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.FeedAttributeOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.FeedAttributeOperation
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedAttributeOperation} message FeedAttributeOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedAttributeOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedAttributeOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.FeedAttributeOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.FeedAttributeOperation} FeedAttributeOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedAttributeOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.FeedAttributeOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.operator = reader.int32();
                                    break;
                                case 2:
                                    message.value = $root.google.ads.googleads.v1.resources.FeedAttribute.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedAttributeOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.FeedAttributeOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.FeedAttributeOperation} FeedAttributeOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedAttributeOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedAttributeOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.FeedAttributeOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedAttributeOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                switch (message.operator) {
                                default:
                                    return "operator: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                var error = $root.google.ads.googleads.v1.resources.FeedAttribute.verify(message.value);
                                if (error)
                                    return "value." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a FeedAttributeOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.FeedAttributeOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.FeedAttributeOperation} FeedAttributeOperation
                         */
                        FeedAttributeOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.FeedAttributeOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.FeedAttributeOperation();
                            switch (object.operator) {
                            case "UNSPECIFIED":
                            case 0:
                                message.operator = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.operator = 1;
                                break;
                            case "ADD":
                            case 2:
                                message.operator = 2;
                                break;
                            }
                            if (object.value != null) {
                                if (typeof object.value !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedAttributeOperation.value: object expected");
                                message.value = $root.google.ads.googleads.v1.resources.FeedAttribute.fromObject(object.value);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a FeedAttributeOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.FeedAttributeOperation
                         * @static
                         * @param {google.ads.googleads.v1.resources.FeedAttributeOperation} message FeedAttributeOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedAttributeOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.operator = options.enums === String ? "UNSPECIFIED" : 0;
                                object.value = null;
                            }
                            if (message.operator != null && message.hasOwnProperty("operator"))
                                object.operator = options.enums === String ? $root.google.ads.googleads.v1.resources.FeedAttributeOperation.Operator[message.operator] : message.operator;
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = $root.google.ads.googleads.v1.resources.FeedAttribute.toObject(message.value, options);
                            return object;
                        };

                        /**
                         * Converts this FeedAttributeOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.FeedAttributeOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedAttributeOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        /**
                         * Operator enum.
                         * @name google.ads.googleads.v1.resources.FeedAttributeOperation.Operator
                         * @enum {string}
                         * @property {number} UNSPECIFIED=0 UNSPECIFIED value
                         * @property {number} UNKNOWN=1 UNKNOWN value
                         * @property {number} ADD=2 ADD value
                         */
                        FeedAttributeOperation.Operator = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNSPECIFIED"] = 0;
                            values[valuesById[1] = "UNKNOWN"] = 1;
                            values[valuesById[2] = "ADD"] = 2;
                            return values;
                        })();

                        return FeedAttributeOperation;
                    })();

                    resources.FeedItem = (function() {

                        /**
                         * Properties of a FeedItem.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IFeedItem
                         * @property {string|null} [resourceName] FeedItem resourceName
                         * @property {google.protobuf.IStringValue|null} [feed] FeedItem feed
                         * @property {google.protobuf.IInt64Value|null} [id] FeedItem id
                         * @property {google.protobuf.IStringValue|null} [startDateTime] FeedItem startDateTime
                         * @property {google.protobuf.IStringValue|null} [endDateTime] FeedItem endDateTime
                         * @property {Array.<google.ads.googleads.v1.resources.IFeedItemAttributeValue>|null} [attributeValues] FeedItem attributeValues
                         * @property {google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum.GeoTargetingRestriction|null} [geoTargetingRestriction] FeedItem geoTargetingRestriction
                         * @property {Array.<google.ads.googleads.v1.common.ICustomParameter>|null} [urlCustomParameters] FeedItem urlCustomParameters
                         * @property {google.ads.googleads.v1.enums.FeedItemStatusEnum.FeedItemStatus|null} [status] FeedItem status
                         * @property {Array.<google.ads.googleads.v1.resources.IFeedItemPlaceholderPolicyInfo>|null} [policyInfos] FeedItem policyInfos
                         */

                        /**
                         * Constructs a new FeedItem.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a FeedItem.
                         * @implements IFeedItem
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IFeedItem=} [properties] Properties to set
                         */
                        function FeedItem(properties) {
                            this.attributeValues = [];
                            this.urlCustomParameters = [];
                            this.policyInfos = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * FeedItem resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @instance
                         */
                        FeedItem.prototype.resourceName = "";

                        /**
                         * FeedItem feed.
                         * @member {google.protobuf.IStringValue|null|undefined} feed
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @instance
                         */
                        FeedItem.prototype.feed = null;

                        /**
                         * FeedItem id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @instance
                         */
                        FeedItem.prototype.id = null;

                        /**
                         * FeedItem startDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} startDateTime
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @instance
                         */
                        FeedItem.prototype.startDateTime = null;

                        /**
                         * FeedItem endDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} endDateTime
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @instance
                         */
                        FeedItem.prototype.endDateTime = null;

                        /**
                         * FeedItem attributeValues.
                         * @member {Array.<google.ads.googleads.v1.resources.IFeedItemAttributeValue>} attributeValues
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @instance
                         */
                        FeedItem.prototype.attributeValues = $util.emptyArray;

                        /**
                         * FeedItem geoTargetingRestriction.
                         * @member {google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum.GeoTargetingRestriction} geoTargetingRestriction
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @instance
                         */
                        FeedItem.prototype.geoTargetingRestriction = 0;

                        /**
                         * FeedItem urlCustomParameters.
                         * @member {Array.<google.ads.googleads.v1.common.ICustomParameter>} urlCustomParameters
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @instance
                         */
                        FeedItem.prototype.urlCustomParameters = $util.emptyArray;

                        /**
                         * FeedItem status.
                         * @member {google.ads.googleads.v1.enums.FeedItemStatusEnum.FeedItemStatus} status
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @instance
                         */
                        FeedItem.prototype.status = 0;

                        /**
                         * FeedItem policyInfos.
                         * @member {Array.<google.ads.googleads.v1.resources.IFeedItemPlaceholderPolicyInfo>} policyInfos
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @instance
                         */
                        FeedItem.prototype.policyInfos = $util.emptyArray;

                        /**
                         * Creates a new FeedItem instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedItem=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.FeedItem} FeedItem instance
                         */
                        FeedItem.create = function create(properties) {
                            return new FeedItem(properties);
                        };

                        /**
                         * Encodes the specified FeedItem message. Does not implicitly {@link google.ads.googleads.v1.resources.FeedItem.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedItem} message FeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItem.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.feed != null && message.hasOwnProperty("feed"))
                                $root.google.protobuf.StringValue.encode(message.feed, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.startDateTime != null && message.hasOwnProperty("startDateTime"))
                                $root.google.protobuf.StringValue.encode(message.startDateTime, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.endDateTime != null && message.hasOwnProperty("endDateTime"))
                                $root.google.protobuf.StringValue.encode(message.endDateTime, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.attributeValues != null && message.attributeValues.length)
                                for (var i = 0; i < message.attributeValues.length; ++i)
                                    $root.google.ads.googleads.v1.resources.FeedItemAttributeValue.encode(message.attributeValues[i], writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.geoTargetingRestriction != null && message.hasOwnProperty("geoTargetingRestriction"))
                                writer.uint32(/* id 7, wireType 0 =*/56).int32(message.geoTargetingRestriction);
                            if (message.urlCustomParameters != null && message.urlCustomParameters.length)
                                for (var i = 0; i < message.urlCustomParameters.length; ++i)
                                    $root.google.ads.googleads.v1.common.CustomParameter.encode(message.urlCustomParameters[i], writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 9, wireType 0 =*/72).int32(message.status);
                            if (message.policyInfos != null && message.policyInfos.length)
                                for (var i = 0; i < message.policyInfos.length; ++i)
                                    $root.google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo.encode(message.policyInfos[i], writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedItem message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.FeedItem.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedItem} message FeedItem message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItem.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedItem message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.FeedItem} FeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItem.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.FeedItem();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.feed = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.startDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.endDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    if (!(message.attributeValues && message.attributeValues.length))
                                        message.attributeValues = [];
                                    message.attributeValues.push($root.google.ads.googleads.v1.resources.FeedItemAttributeValue.decode(reader, reader.uint32()));
                                    break;
                                case 7:
                                    message.geoTargetingRestriction = reader.int32();
                                    break;
                                case 8:
                                    if (!(message.urlCustomParameters && message.urlCustomParameters.length))
                                        message.urlCustomParameters = [];
                                    message.urlCustomParameters.push($root.google.ads.googleads.v1.common.CustomParameter.decode(reader, reader.uint32()));
                                    break;
                                case 9:
                                    message.status = reader.int32();
                                    break;
                                case 10:
                                    if (!(message.policyInfos && message.policyInfos.length))
                                        message.policyInfos = [];
                                    message.policyInfos.push($root.google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedItem message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.FeedItem} FeedItem
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItem.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedItem message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedItem.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.feed != null && message.hasOwnProperty("feed")) {
                                var error = $root.google.protobuf.StringValue.verify(message.feed);
                                if (error)
                                    return "feed." + error;
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.startDateTime != null && message.hasOwnProperty("startDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.startDateTime);
                                if (error)
                                    return "startDateTime." + error;
                            }
                            if (message.endDateTime != null && message.hasOwnProperty("endDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.endDateTime);
                                if (error)
                                    return "endDateTime." + error;
                            }
                            if (message.attributeValues != null && message.hasOwnProperty("attributeValues")) {
                                if (!Array.isArray(message.attributeValues))
                                    return "attributeValues: array expected";
                                for (var i = 0; i < message.attributeValues.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.resources.FeedItemAttributeValue.verify(message.attributeValues[i]);
                                    if (error)
                                        return "attributeValues." + error;
                                }
                            }
                            if (message.geoTargetingRestriction != null && message.hasOwnProperty("geoTargetingRestriction"))
                                switch (message.geoTargetingRestriction) {
                                default:
                                    return "geoTargetingRestriction: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            if (message.urlCustomParameters != null && message.hasOwnProperty("urlCustomParameters")) {
                                if (!Array.isArray(message.urlCustomParameters))
                                    return "urlCustomParameters: array expected";
                                for (var i = 0; i < message.urlCustomParameters.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.CustomParameter.verify(message.urlCustomParameters[i]);
                                    if (error)
                                        return "urlCustomParameters." + error;
                                }
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.policyInfos != null && message.hasOwnProperty("policyInfos")) {
                                if (!Array.isArray(message.policyInfos))
                                    return "policyInfos: array expected";
                                for (var i = 0; i < message.policyInfos.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo.verify(message.policyInfos[i]);
                                    if (error)
                                        return "policyInfos." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a FeedItem message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.FeedItem} FeedItem
                         */
                        FeedItem.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.FeedItem)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.FeedItem();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.feed != null) {
                                if (typeof object.feed !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItem.feed: object expected");
                                message.feed = $root.google.protobuf.StringValue.fromObject(object.feed);
                            }
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItem.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.startDateTime != null) {
                                if (typeof object.startDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItem.startDateTime: object expected");
                                message.startDateTime = $root.google.protobuf.StringValue.fromObject(object.startDateTime);
                            }
                            if (object.endDateTime != null) {
                                if (typeof object.endDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItem.endDateTime: object expected");
                                message.endDateTime = $root.google.protobuf.StringValue.fromObject(object.endDateTime);
                            }
                            if (object.attributeValues) {
                                if (!Array.isArray(object.attributeValues))
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItem.attributeValues: array expected");
                                message.attributeValues = [];
                                for (var i = 0; i < object.attributeValues.length; ++i) {
                                    if (typeof object.attributeValues[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.FeedItem.attributeValues: object expected");
                                    message.attributeValues[i] = $root.google.ads.googleads.v1.resources.FeedItemAttributeValue.fromObject(object.attributeValues[i]);
                                }
                            }
                            switch (object.geoTargetingRestriction) {
                            case "UNSPECIFIED":
                            case 0:
                                message.geoTargetingRestriction = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.geoTargetingRestriction = 1;
                                break;
                            case "LOCATION_OF_PRESENCE":
                            case 2:
                                message.geoTargetingRestriction = 2;
                                break;
                            }
                            if (object.urlCustomParameters) {
                                if (!Array.isArray(object.urlCustomParameters))
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItem.urlCustomParameters: array expected");
                                message.urlCustomParameters = [];
                                for (var i = 0; i < object.urlCustomParameters.length; ++i) {
                                    if (typeof object.urlCustomParameters[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.FeedItem.urlCustomParameters: object expected");
                                    message.urlCustomParameters[i] = $root.google.ads.googleads.v1.common.CustomParameter.fromObject(object.urlCustomParameters[i]);
                                }
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "REMOVED":
                            case 3:
                                message.status = 3;
                                break;
                            }
                            if (object.policyInfos) {
                                if (!Array.isArray(object.policyInfos))
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItem.policyInfos: array expected");
                                message.policyInfos = [];
                                for (var i = 0; i < object.policyInfos.length; ++i) {
                                    if (typeof object.policyInfos[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.FeedItem.policyInfos: object expected");
                                    message.policyInfos[i] = $root.google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo.fromObject(object.policyInfos[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a FeedItem message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @static
                         * @param {google.ads.googleads.v1.resources.FeedItem} message FeedItem
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedItem.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.attributeValues = [];
                                object.urlCustomParameters = [];
                                object.policyInfos = [];
                            }
                            if (options.defaults) {
                                object.resourceName = "";
                                object.feed = null;
                                object.id = null;
                                object.startDateTime = null;
                                object.endDateTime = null;
                                object.geoTargetingRestriction = options.enums === String ? "UNSPECIFIED" : 0;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.feed != null && message.hasOwnProperty("feed"))
                                object.feed = $root.google.protobuf.StringValue.toObject(message.feed, options);
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.startDateTime != null && message.hasOwnProperty("startDateTime"))
                                object.startDateTime = $root.google.protobuf.StringValue.toObject(message.startDateTime, options);
                            if (message.endDateTime != null && message.hasOwnProperty("endDateTime"))
                                object.endDateTime = $root.google.protobuf.StringValue.toObject(message.endDateTime, options);
                            if (message.attributeValues && message.attributeValues.length) {
                                object.attributeValues = [];
                                for (var j = 0; j < message.attributeValues.length; ++j)
                                    object.attributeValues[j] = $root.google.ads.googleads.v1.resources.FeedItemAttributeValue.toObject(message.attributeValues[j], options);
                            }
                            if (message.geoTargetingRestriction != null && message.hasOwnProperty("geoTargetingRestriction"))
                                object.geoTargetingRestriction = options.enums === String ? $root.google.ads.googleads.v1.enums.GeoTargetingRestrictionEnum.GeoTargetingRestriction[message.geoTargetingRestriction] : message.geoTargetingRestriction;
                            if (message.urlCustomParameters && message.urlCustomParameters.length) {
                                object.urlCustomParameters = [];
                                for (var j = 0; j < message.urlCustomParameters.length; ++j)
                                    object.urlCustomParameters[j] = $root.google.ads.googleads.v1.common.CustomParameter.toObject(message.urlCustomParameters[j], options);
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.FeedItemStatusEnum.FeedItemStatus[message.status] : message.status;
                            if (message.policyInfos && message.policyInfos.length) {
                                object.policyInfos = [];
                                for (var j = 0; j < message.policyInfos.length; ++j)
                                    object.policyInfos[j] = $root.google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo.toObject(message.policyInfos[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this FeedItem to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.FeedItem
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedItem.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return FeedItem;
                    })();

                    resources.FeedItemAttributeValue = (function() {

                        /**
                         * Properties of a FeedItemAttributeValue.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IFeedItemAttributeValue
                         * @property {google.protobuf.IInt64Value|null} [feedAttributeId] FeedItemAttributeValue feedAttributeId
                         * @property {google.protobuf.IInt64Value|null} [integerValue] FeedItemAttributeValue integerValue
                         * @property {google.protobuf.IBoolValue|null} [booleanValue] FeedItemAttributeValue booleanValue
                         * @property {google.protobuf.IStringValue|null} [stringValue] FeedItemAttributeValue stringValue
                         * @property {google.protobuf.IDoubleValue|null} [doubleValue] FeedItemAttributeValue doubleValue
                         * @property {google.ads.googleads.v1.common.IMoney|null} [priceValue] FeedItemAttributeValue priceValue
                         * @property {Array.<google.protobuf.IInt64Value>|null} [integerValues] FeedItemAttributeValue integerValues
                         * @property {Array.<google.protobuf.IBoolValue>|null} [booleanValues] FeedItemAttributeValue booleanValues
                         * @property {Array.<google.protobuf.IStringValue>|null} [stringValues] FeedItemAttributeValue stringValues
                         * @property {Array.<google.protobuf.IDoubleValue>|null} [doubleValues] FeedItemAttributeValue doubleValues
                         */

                        /**
                         * Constructs a new FeedItemAttributeValue.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a FeedItemAttributeValue.
                         * @implements IFeedItemAttributeValue
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IFeedItemAttributeValue=} [properties] Properties to set
                         */
                        function FeedItemAttributeValue(properties) {
                            this.integerValues = [];
                            this.booleanValues = [];
                            this.stringValues = [];
                            this.doubleValues = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * FeedItemAttributeValue feedAttributeId.
                         * @member {google.protobuf.IInt64Value|null|undefined} feedAttributeId
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @instance
                         */
                        FeedItemAttributeValue.prototype.feedAttributeId = null;

                        /**
                         * FeedItemAttributeValue integerValue.
                         * @member {google.protobuf.IInt64Value|null|undefined} integerValue
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @instance
                         */
                        FeedItemAttributeValue.prototype.integerValue = null;

                        /**
                         * FeedItemAttributeValue booleanValue.
                         * @member {google.protobuf.IBoolValue|null|undefined} booleanValue
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @instance
                         */
                        FeedItemAttributeValue.prototype.booleanValue = null;

                        /**
                         * FeedItemAttributeValue stringValue.
                         * @member {google.protobuf.IStringValue|null|undefined} stringValue
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @instance
                         */
                        FeedItemAttributeValue.prototype.stringValue = null;

                        /**
                         * FeedItemAttributeValue doubleValue.
                         * @member {google.protobuf.IDoubleValue|null|undefined} doubleValue
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @instance
                         */
                        FeedItemAttributeValue.prototype.doubleValue = null;

                        /**
                         * FeedItemAttributeValue priceValue.
                         * @member {google.ads.googleads.v1.common.IMoney|null|undefined} priceValue
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @instance
                         */
                        FeedItemAttributeValue.prototype.priceValue = null;

                        /**
                         * FeedItemAttributeValue integerValues.
                         * @member {Array.<google.protobuf.IInt64Value>} integerValues
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @instance
                         */
                        FeedItemAttributeValue.prototype.integerValues = $util.emptyArray;

                        /**
                         * FeedItemAttributeValue booleanValues.
                         * @member {Array.<google.protobuf.IBoolValue>} booleanValues
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @instance
                         */
                        FeedItemAttributeValue.prototype.booleanValues = $util.emptyArray;

                        /**
                         * FeedItemAttributeValue stringValues.
                         * @member {Array.<google.protobuf.IStringValue>} stringValues
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @instance
                         */
                        FeedItemAttributeValue.prototype.stringValues = $util.emptyArray;

                        /**
                         * FeedItemAttributeValue doubleValues.
                         * @member {Array.<google.protobuf.IDoubleValue>} doubleValues
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @instance
                         */
                        FeedItemAttributeValue.prototype.doubleValues = $util.emptyArray;

                        /**
                         * Creates a new FeedItemAttributeValue instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedItemAttributeValue=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.FeedItemAttributeValue} FeedItemAttributeValue instance
                         */
                        FeedItemAttributeValue.create = function create(properties) {
                            return new FeedItemAttributeValue(properties);
                        };

                        /**
                         * Encodes the specified FeedItemAttributeValue message. Does not implicitly {@link google.ads.googleads.v1.resources.FeedItemAttributeValue.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedItemAttributeValue} message FeedItemAttributeValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemAttributeValue.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.feedAttributeId != null && message.hasOwnProperty("feedAttributeId"))
                                $root.google.protobuf.Int64Value.encode(message.feedAttributeId, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.integerValue != null && message.hasOwnProperty("integerValue"))
                                $root.google.protobuf.Int64Value.encode(message.integerValue, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.booleanValue != null && message.hasOwnProperty("booleanValue"))
                                $root.google.protobuf.BoolValue.encode(message.booleanValue, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.stringValue != null && message.hasOwnProperty("stringValue"))
                                $root.google.protobuf.StringValue.encode(message.stringValue, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.doubleValue != null && message.hasOwnProperty("doubleValue"))
                                $root.google.protobuf.DoubleValue.encode(message.doubleValue, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.priceValue != null && message.hasOwnProperty("priceValue"))
                                $root.google.ads.googleads.v1.common.Money.encode(message.priceValue, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.integerValues != null && message.integerValues.length)
                                for (var i = 0; i < message.integerValues.length; ++i)
                                    $root.google.protobuf.Int64Value.encode(message.integerValues[i], writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.booleanValues != null && message.booleanValues.length)
                                for (var i = 0; i < message.booleanValues.length; ++i)
                                    $root.google.protobuf.BoolValue.encode(message.booleanValues[i], writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.stringValues != null && message.stringValues.length)
                                for (var i = 0; i < message.stringValues.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.stringValues[i], writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.doubleValues != null && message.doubleValues.length)
                                for (var i = 0; i < message.doubleValues.length; ++i)
                                    $root.google.protobuf.DoubleValue.encode(message.doubleValues[i], writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedItemAttributeValue message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.FeedItemAttributeValue.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedItemAttributeValue} message FeedItemAttributeValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemAttributeValue.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedItemAttributeValue message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.FeedItemAttributeValue} FeedItemAttributeValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemAttributeValue.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.FeedItemAttributeValue();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.feedAttributeId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.integerValue = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.booleanValue = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.stringValue = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.doubleValue = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.priceValue = $root.google.ads.googleads.v1.common.Money.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    if (!(message.integerValues && message.integerValues.length))
                                        message.integerValues = [];
                                    message.integerValues.push($root.google.protobuf.Int64Value.decode(reader, reader.uint32()));
                                    break;
                                case 8:
                                    if (!(message.booleanValues && message.booleanValues.length))
                                        message.booleanValues = [];
                                    message.booleanValues.push($root.google.protobuf.BoolValue.decode(reader, reader.uint32()));
                                    break;
                                case 9:
                                    if (!(message.stringValues && message.stringValues.length))
                                        message.stringValues = [];
                                    message.stringValues.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 10:
                                    if (!(message.doubleValues && message.doubleValues.length))
                                        message.doubleValues = [];
                                    message.doubleValues.push($root.google.protobuf.DoubleValue.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedItemAttributeValue message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.FeedItemAttributeValue} FeedItemAttributeValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemAttributeValue.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedItemAttributeValue message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedItemAttributeValue.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.feedAttributeId != null && message.hasOwnProperty("feedAttributeId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.feedAttributeId);
                                if (error)
                                    return "feedAttributeId." + error;
                            }
                            if (message.integerValue != null && message.hasOwnProperty("integerValue")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.integerValue);
                                if (error)
                                    return "integerValue." + error;
                            }
                            if (message.booleanValue != null && message.hasOwnProperty("booleanValue")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.booleanValue);
                                if (error)
                                    return "booleanValue." + error;
                            }
                            if (message.stringValue != null && message.hasOwnProperty("stringValue")) {
                                var error = $root.google.protobuf.StringValue.verify(message.stringValue);
                                if (error)
                                    return "stringValue." + error;
                            }
                            if (message.doubleValue != null && message.hasOwnProperty("doubleValue")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.doubleValue);
                                if (error)
                                    return "doubleValue." + error;
                            }
                            if (message.priceValue != null && message.hasOwnProperty("priceValue")) {
                                var error = $root.google.ads.googleads.v1.common.Money.verify(message.priceValue);
                                if (error)
                                    return "priceValue." + error;
                            }
                            if (message.integerValues != null && message.hasOwnProperty("integerValues")) {
                                if (!Array.isArray(message.integerValues))
                                    return "integerValues: array expected";
                                for (var i = 0; i < message.integerValues.length; ++i) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.integerValues[i]);
                                    if (error)
                                        return "integerValues." + error;
                                }
                            }
                            if (message.booleanValues != null && message.hasOwnProperty("booleanValues")) {
                                if (!Array.isArray(message.booleanValues))
                                    return "booleanValues: array expected";
                                for (var i = 0; i < message.booleanValues.length; ++i) {
                                    var error = $root.google.protobuf.BoolValue.verify(message.booleanValues[i]);
                                    if (error)
                                        return "booleanValues." + error;
                                }
                            }
                            if (message.stringValues != null && message.hasOwnProperty("stringValues")) {
                                if (!Array.isArray(message.stringValues))
                                    return "stringValues: array expected";
                                for (var i = 0; i < message.stringValues.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.stringValues[i]);
                                    if (error)
                                        return "stringValues." + error;
                                }
                            }
                            if (message.doubleValues != null && message.hasOwnProperty("doubleValues")) {
                                if (!Array.isArray(message.doubleValues))
                                    return "doubleValues: array expected";
                                for (var i = 0; i < message.doubleValues.length; ++i) {
                                    var error = $root.google.protobuf.DoubleValue.verify(message.doubleValues[i]);
                                    if (error)
                                        return "doubleValues." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a FeedItemAttributeValue message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.FeedItemAttributeValue} FeedItemAttributeValue
                         */
                        FeedItemAttributeValue.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.FeedItemAttributeValue)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.FeedItemAttributeValue();
                            if (object.feedAttributeId != null) {
                                if (typeof object.feedAttributeId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemAttributeValue.feedAttributeId: object expected");
                                message.feedAttributeId = $root.google.protobuf.Int64Value.fromObject(object.feedAttributeId);
                            }
                            if (object.integerValue != null) {
                                if (typeof object.integerValue !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemAttributeValue.integerValue: object expected");
                                message.integerValue = $root.google.protobuf.Int64Value.fromObject(object.integerValue);
                            }
                            if (object.booleanValue != null) {
                                if (typeof object.booleanValue !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemAttributeValue.booleanValue: object expected");
                                message.booleanValue = $root.google.protobuf.BoolValue.fromObject(object.booleanValue);
                            }
                            if (object.stringValue != null) {
                                if (typeof object.stringValue !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemAttributeValue.stringValue: object expected");
                                message.stringValue = $root.google.protobuf.StringValue.fromObject(object.stringValue);
                            }
                            if (object.doubleValue != null) {
                                if (typeof object.doubleValue !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemAttributeValue.doubleValue: object expected");
                                message.doubleValue = $root.google.protobuf.DoubleValue.fromObject(object.doubleValue);
                            }
                            if (object.priceValue != null) {
                                if (typeof object.priceValue !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemAttributeValue.priceValue: object expected");
                                message.priceValue = $root.google.ads.googleads.v1.common.Money.fromObject(object.priceValue);
                            }
                            if (object.integerValues) {
                                if (!Array.isArray(object.integerValues))
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemAttributeValue.integerValues: array expected");
                                message.integerValues = [];
                                for (var i = 0; i < object.integerValues.length; ++i) {
                                    if (typeof object.integerValues[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.FeedItemAttributeValue.integerValues: object expected");
                                    message.integerValues[i] = $root.google.protobuf.Int64Value.fromObject(object.integerValues[i]);
                                }
                            }
                            if (object.booleanValues) {
                                if (!Array.isArray(object.booleanValues))
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemAttributeValue.booleanValues: array expected");
                                message.booleanValues = [];
                                for (var i = 0; i < object.booleanValues.length; ++i) {
                                    if (typeof object.booleanValues[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.FeedItemAttributeValue.booleanValues: object expected");
                                    message.booleanValues[i] = $root.google.protobuf.BoolValue.fromObject(object.booleanValues[i]);
                                }
                            }
                            if (object.stringValues) {
                                if (!Array.isArray(object.stringValues))
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemAttributeValue.stringValues: array expected");
                                message.stringValues = [];
                                for (var i = 0; i < object.stringValues.length; ++i) {
                                    if (typeof object.stringValues[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.FeedItemAttributeValue.stringValues: object expected");
                                    message.stringValues[i] = $root.google.protobuf.StringValue.fromObject(object.stringValues[i]);
                                }
                            }
                            if (object.doubleValues) {
                                if (!Array.isArray(object.doubleValues))
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemAttributeValue.doubleValues: array expected");
                                message.doubleValues = [];
                                for (var i = 0; i < object.doubleValues.length; ++i) {
                                    if (typeof object.doubleValues[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.FeedItemAttributeValue.doubleValues: object expected");
                                    message.doubleValues[i] = $root.google.protobuf.DoubleValue.fromObject(object.doubleValues[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a FeedItemAttributeValue message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @static
                         * @param {google.ads.googleads.v1.resources.FeedItemAttributeValue} message FeedItemAttributeValue
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedItemAttributeValue.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.integerValues = [];
                                object.booleanValues = [];
                                object.stringValues = [];
                                object.doubleValues = [];
                            }
                            if (options.defaults) {
                                object.feedAttributeId = null;
                                object.integerValue = null;
                                object.booleanValue = null;
                                object.stringValue = null;
                                object.doubleValue = null;
                                object.priceValue = null;
                            }
                            if (message.feedAttributeId != null && message.hasOwnProperty("feedAttributeId"))
                                object.feedAttributeId = $root.google.protobuf.Int64Value.toObject(message.feedAttributeId, options);
                            if (message.integerValue != null && message.hasOwnProperty("integerValue"))
                                object.integerValue = $root.google.protobuf.Int64Value.toObject(message.integerValue, options);
                            if (message.booleanValue != null && message.hasOwnProperty("booleanValue"))
                                object.booleanValue = $root.google.protobuf.BoolValue.toObject(message.booleanValue, options);
                            if (message.stringValue != null && message.hasOwnProperty("stringValue"))
                                object.stringValue = $root.google.protobuf.StringValue.toObject(message.stringValue, options);
                            if (message.doubleValue != null && message.hasOwnProperty("doubleValue"))
                                object.doubleValue = $root.google.protobuf.DoubleValue.toObject(message.doubleValue, options);
                            if (message.priceValue != null && message.hasOwnProperty("priceValue"))
                                object.priceValue = $root.google.ads.googleads.v1.common.Money.toObject(message.priceValue, options);
                            if (message.integerValues && message.integerValues.length) {
                                object.integerValues = [];
                                for (var j = 0; j < message.integerValues.length; ++j)
                                    object.integerValues[j] = $root.google.protobuf.Int64Value.toObject(message.integerValues[j], options);
                            }
                            if (message.booleanValues && message.booleanValues.length) {
                                object.booleanValues = [];
                                for (var j = 0; j < message.booleanValues.length; ++j)
                                    object.booleanValues[j] = $root.google.protobuf.BoolValue.toObject(message.booleanValues[j], options);
                            }
                            if (message.stringValues && message.stringValues.length) {
                                object.stringValues = [];
                                for (var j = 0; j < message.stringValues.length; ++j)
                                    object.stringValues[j] = $root.google.protobuf.StringValue.toObject(message.stringValues[j], options);
                            }
                            if (message.doubleValues && message.doubleValues.length) {
                                object.doubleValues = [];
                                for (var j = 0; j < message.doubleValues.length; ++j)
                                    object.doubleValues[j] = $root.google.protobuf.DoubleValue.toObject(message.doubleValues[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this FeedItemAttributeValue to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.FeedItemAttributeValue
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedItemAttributeValue.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return FeedItemAttributeValue;
                    })();

                    resources.FeedItemPlaceholderPolicyInfo = (function() {

                        /**
                         * Properties of a FeedItemPlaceholderPolicyInfo.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IFeedItemPlaceholderPolicyInfo
                         * @property {google.protobuf.IInt32Value|null} [placeholderType] FeedItemPlaceholderPolicyInfo placeholderType
                         * @property {google.protobuf.IStringValue|null} [feedMappingResourceName] FeedItemPlaceholderPolicyInfo feedMappingResourceName
                         * @property {google.ads.googleads.v1.enums.PolicyReviewStatusEnum.PolicyReviewStatus|null} [reviewStatus] FeedItemPlaceholderPolicyInfo reviewStatus
                         * @property {google.ads.googleads.v1.enums.PolicyApprovalStatusEnum.PolicyApprovalStatus|null} [approvalStatus] FeedItemPlaceholderPolicyInfo approvalStatus
                         * @property {Array.<google.ads.googleads.v1.common.IPolicyTopicEntry>|null} [policyTopicEntries] FeedItemPlaceholderPolicyInfo policyTopicEntries
                         * @property {google.ads.googleads.v1.enums.FeedItemValidationStatusEnum.FeedItemValidationStatus|null} [validationStatus] FeedItemPlaceholderPolicyInfo validationStatus
                         * @property {Array.<google.ads.googleads.v1.resources.IFeedItemValidationError>|null} [validationErrors] FeedItemPlaceholderPolicyInfo validationErrors
                         * @property {google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum.FeedItemQualityApprovalStatus|null} [qualityApprovalStatus] FeedItemPlaceholderPolicyInfo qualityApprovalStatus
                         * @property {Array.<google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum.FeedItemQualityDisapprovalReason>|null} [qualityDisapprovalReasons] FeedItemPlaceholderPolicyInfo qualityDisapprovalReasons
                         */

                        /**
                         * Constructs a new FeedItemPlaceholderPolicyInfo.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a FeedItemPlaceholderPolicyInfo.
                         * @implements IFeedItemPlaceholderPolicyInfo
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IFeedItemPlaceholderPolicyInfo=} [properties] Properties to set
                         */
                        function FeedItemPlaceholderPolicyInfo(properties) {
                            this.policyTopicEntries = [];
                            this.validationErrors = [];
                            this.qualityDisapprovalReasons = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * FeedItemPlaceholderPolicyInfo placeholderType.
                         * @member {google.protobuf.IInt32Value|null|undefined} placeholderType
                         * @memberof google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo
                         * @instance
                         */
                        FeedItemPlaceholderPolicyInfo.prototype.placeholderType = null;

                        /**
                         * FeedItemPlaceholderPolicyInfo feedMappingResourceName.
                         * @member {google.protobuf.IStringValue|null|undefined} feedMappingResourceName
                         * @memberof google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo
                         * @instance
                         */
                        FeedItemPlaceholderPolicyInfo.prototype.feedMappingResourceName = null;

                        /**
                         * FeedItemPlaceholderPolicyInfo reviewStatus.
                         * @member {google.ads.googleads.v1.enums.PolicyReviewStatusEnum.PolicyReviewStatus} reviewStatus
                         * @memberof google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo
                         * @instance
                         */
                        FeedItemPlaceholderPolicyInfo.prototype.reviewStatus = 0;

                        /**
                         * FeedItemPlaceholderPolicyInfo approvalStatus.
                         * @member {google.ads.googleads.v1.enums.PolicyApprovalStatusEnum.PolicyApprovalStatus} approvalStatus
                         * @memberof google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo
                         * @instance
                         */
                        FeedItemPlaceholderPolicyInfo.prototype.approvalStatus = 0;

                        /**
                         * FeedItemPlaceholderPolicyInfo policyTopicEntries.
                         * @member {Array.<google.ads.googleads.v1.common.IPolicyTopicEntry>} policyTopicEntries
                         * @memberof google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo
                         * @instance
                         */
                        FeedItemPlaceholderPolicyInfo.prototype.policyTopicEntries = $util.emptyArray;

                        /**
                         * FeedItemPlaceholderPolicyInfo validationStatus.
                         * @member {google.ads.googleads.v1.enums.FeedItemValidationStatusEnum.FeedItemValidationStatus} validationStatus
                         * @memberof google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo
                         * @instance
                         */
                        FeedItemPlaceholderPolicyInfo.prototype.validationStatus = 0;

                        /**
                         * FeedItemPlaceholderPolicyInfo validationErrors.
                         * @member {Array.<google.ads.googleads.v1.resources.IFeedItemValidationError>} validationErrors
                         * @memberof google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo
                         * @instance
                         */
                        FeedItemPlaceholderPolicyInfo.prototype.validationErrors = $util.emptyArray;

                        /**
                         * FeedItemPlaceholderPolicyInfo qualityApprovalStatus.
                         * @member {google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum.FeedItemQualityApprovalStatus} qualityApprovalStatus
                         * @memberof google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo
                         * @instance
                         */
                        FeedItemPlaceholderPolicyInfo.prototype.qualityApprovalStatus = 0;

                        /**
                         * FeedItemPlaceholderPolicyInfo qualityDisapprovalReasons.
                         * @member {Array.<google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum.FeedItemQualityDisapprovalReason>} qualityDisapprovalReasons
                         * @memberof google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo
                         * @instance
                         */
                        FeedItemPlaceholderPolicyInfo.prototype.qualityDisapprovalReasons = $util.emptyArray;

                        /**
                         * Creates a new FeedItemPlaceholderPolicyInfo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedItemPlaceholderPolicyInfo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo} FeedItemPlaceholderPolicyInfo instance
                         */
                        FeedItemPlaceholderPolicyInfo.create = function create(properties) {
                            return new FeedItemPlaceholderPolicyInfo(properties);
                        };

                        /**
                         * Encodes the specified FeedItemPlaceholderPolicyInfo message. Does not implicitly {@link google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedItemPlaceholderPolicyInfo} message FeedItemPlaceholderPolicyInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemPlaceholderPolicyInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.placeholderType != null && message.hasOwnProperty("placeholderType"))
                                $root.google.protobuf.Int32Value.encode(message.placeholderType, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.feedMappingResourceName != null && message.hasOwnProperty("feedMappingResourceName"))
                                $root.google.protobuf.StringValue.encode(message.feedMappingResourceName, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.reviewStatus != null && message.hasOwnProperty("reviewStatus"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.reviewStatus);
                            if (message.approvalStatus != null && message.hasOwnProperty("approvalStatus"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.approvalStatus);
                            if (message.policyTopicEntries != null && message.policyTopicEntries.length)
                                for (var i = 0; i < message.policyTopicEntries.length; ++i)
                                    $root.google.ads.googleads.v1.common.PolicyTopicEntry.encode(message.policyTopicEntries[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.validationStatus != null && message.hasOwnProperty("validationStatus"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.validationStatus);
                            if (message.validationErrors != null && message.validationErrors.length)
                                for (var i = 0; i < message.validationErrors.length; ++i)
                                    $root.google.ads.googleads.v1.resources.FeedItemValidationError.encode(message.validationErrors[i], writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.qualityApprovalStatus != null && message.hasOwnProperty("qualityApprovalStatus"))
                                writer.uint32(/* id 8, wireType 0 =*/64).int32(message.qualityApprovalStatus);
                            if (message.qualityDisapprovalReasons != null && message.qualityDisapprovalReasons.length) {
                                writer.uint32(/* id 9, wireType 2 =*/74).fork();
                                for (var i = 0; i < message.qualityDisapprovalReasons.length; ++i)
                                    writer.int32(message.qualityDisapprovalReasons[i]);
                                writer.ldelim();
                            }
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedItemPlaceholderPolicyInfo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedItemPlaceholderPolicyInfo} message FeedItemPlaceholderPolicyInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemPlaceholderPolicyInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedItemPlaceholderPolicyInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo} FeedItemPlaceholderPolicyInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemPlaceholderPolicyInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.placeholderType = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.feedMappingResourceName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.reviewStatus = reader.int32();
                                    break;
                                case 4:
                                    message.approvalStatus = reader.int32();
                                    break;
                                case 5:
                                    if (!(message.policyTopicEntries && message.policyTopicEntries.length))
                                        message.policyTopicEntries = [];
                                    message.policyTopicEntries.push($root.google.ads.googleads.v1.common.PolicyTopicEntry.decode(reader, reader.uint32()));
                                    break;
                                case 6:
                                    message.validationStatus = reader.int32();
                                    break;
                                case 7:
                                    if (!(message.validationErrors && message.validationErrors.length))
                                        message.validationErrors = [];
                                    message.validationErrors.push($root.google.ads.googleads.v1.resources.FeedItemValidationError.decode(reader, reader.uint32()));
                                    break;
                                case 8:
                                    message.qualityApprovalStatus = reader.int32();
                                    break;
                                case 9:
                                    if (!(message.qualityDisapprovalReasons && message.qualityDisapprovalReasons.length))
                                        message.qualityDisapprovalReasons = [];
                                    if ((tag & 7) === 2) {
                                        var end2 = reader.uint32() + reader.pos;
                                        while (reader.pos < end2)
                                            message.qualityDisapprovalReasons.push(reader.int32());
                                    } else
                                        message.qualityDisapprovalReasons.push(reader.int32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedItemPlaceholderPolicyInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo} FeedItemPlaceholderPolicyInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemPlaceholderPolicyInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedItemPlaceholderPolicyInfo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedItemPlaceholderPolicyInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.placeholderType != null && message.hasOwnProperty("placeholderType")) {
                                var error = $root.google.protobuf.Int32Value.verify(message.placeholderType);
                                if (error)
                                    return "placeholderType." + error;
                            }
                            if (message.feedMappingResourceName != null && message.hasOwnProperty("feedMappingResourceName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.feedMappingResourceName);
                                if (error)
                                    return "feedMappingResourceName." + error;
                            }
                            if (message.reviewStatus != null && message.hasOwnProperty("reviewStatus"))
                                switch (message.reviewStatus) {
                                default:
                                    return "reviewStatus: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.approvalStatus != null && message.hasOwnProperty("approvalStatus"))
                                switch (message.approvalStatus) {
                                default:
                                    return "approvalStatus: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            if (message.policyTopicEntries != null && message.hasOwnProperty("policyTopicEntries")) {
                                if (!Array.isArray(message.policyTopicEntries))
                                    return "policyTopicEntries: array expected";
                                for (var i = 0; i < message.policyTopicEntries.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.PolicyTopicEntry.verify(message.policyTopicEntries[i]);
                                    if (error)
                                        return "policyTopicEntries." + error;
                                }
                            }
                            if (message.validationStatus != null && message.hasOwnProperty("validationStatus"))
                                switch (message.validationStatus) {
                                default:
                                    return "validationStatus: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.validationErrors != null && message.hasOwnProperty("validationErrors")) {
                                if (!Array.isArray(message.validationErrors))
                                    return "validationErrors: array expected";
                                for (var i = 0; i < message.validationErrors.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.resources.FeedItemValidationError.verify(message.validationErrors[i]);
                                    if (error)
                                        return "validationErrors." + error;
                                }
                            }
                            if (message.qualityApprovalStatus != null && message.hasOwnProperty("qualityApprovalStatus"))
                                switch (message.qualityApprovalStatus) {
                                default:
                                    return "qualityApprovalStatus: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.qualityDisapprovalReasons != null && message.hasOwnProperty("qualityDisapprovalReasons")) {
                                if (!Array.isArray(message.qualityDisapprovalReasons))
                                    return "qualityDisapprovalReasons: array expected";
                                for (var i = 0; i < message.qualityDisapprovalReasons.length; ++i)
                                    switch (message.qualityDisapprovalReasons[i]) {
                                    default:
                                        return "qualityDisapprovalReasons: enum value[] expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                    case 5:
                                    case 6:
                                    case 7:
                                    case 8:
                                    case 9:
                                    case 10:
                                    case 11:
                                    case 12:
                                    case 13:
                                    case 14:
                                    case 15:
                                    case 16:
                                    case 17:
                                    case 18:
                                    case 19:
                                        break;
                                    }
                            }
                            return null;
                        };

                        /**
                         * Creates a FeedItemPlaceholderPolicyInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo} FeedItemPlaceholderPolicyInfo
                         */
                        FeedItemPlaceholderPolicyInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo();
                            if (object.placeholderType != null) {
                                if (typeof object.placeholderType !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo.placeholderType: object expected");
                                message.placeholderType = $root.google.protobuf.Int32Value.fromObject(object.placeholderType);
                            }
                            if (object.feedMappingResourceName != null) {
                                if (typeof object.feedMappingResourceName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo.feedMappingResourceName: object expected");
                                message.feedMappingResourceName = $root.google.protobuf.StringValue.fromObject(object.feedMappingResourceName);
                            }
                            switch (object.reviewStatus) {
                            case "UNSPECIFIED":
                            case 0:
                                message.reviewStatus = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.reviewStatus = 1;
                                break;
                            case "REVIEW_IN_PROGRESS":
                            case 2:
                                message.reviewStatus = 2;
                                break;
                            case "REVIEWED":
                            case 3:
                                message.reviewStatus = 3;
                                break;
                            case "UNDER_APPEAL":
                            case 4:
                                message.reviewStatus = 4;
                                break;
                            }
                            switch (object.approvalStatus) {
                            case "UNSPECIFIED":
                            case 0:
                                message.approvalStatus = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.approvalStatus = 1;
                                break;
                            case "DISAPPROVED":
                            case 2:
                                message.approvalStatus = 2;
                                break;
                            case "APPROVED_LIMITED":
                            case 3:
                                message.approvalStatus = 3;
                                break;
                            case "APPROVED":
                            case 4:
                                message.approvalStatus = 4;
                                break;
                            case "AREA_OF_INTEREST_ONLY":
                            case 5:
                                message.approvalStatus = 5;
                                break;
                            }
                            if (object.policyTopicEntries) {
                                if (!Array.isArray(object.policyTopicEntries))
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo.policyTopicEntries: array expected");
                                message.policyTopicEntries = [];
                                for (var i = 0; i < object.policyTopicEntries.length; ++i) {
                                    if (typeof object.policyTopicEntries[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo.policyTopicEntries: object expected");
                                    message.policyTopicEntries[i] = $root.google.ads.googleads.v1.common.PolicyTopicEntry.fromObject(object.policyTopicEntries[i]);
                                }
                            }
                            switch (object.validationStatus) {
                            case "UNSPECIFIED":
                            case 0:
                                message.validationStatus = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.validationStatus = 1;
                                break;
                            case "PENDING":
                            case 2:
                                message.validationStatus = 2;
                                break;
                            case "INVALID":
                            case 3:
                                message.validationStatus = 3;
                                break;
                            case "VALID":
                            case 4:
                                message.validationStatus = 4;
                                break;
                            }
                            if (object.validationErrors) {
                                if (!Array.isArray(object.validationErrors))
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo.validationErrors: array expected");
                                message.validationErrors = [];
                                for (var i = 0; i < object.validationErrors.length; ++i) {
                                    if (typeof object.validationErrors[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo.validationErrors: object expected");
                                    message.validationErrors[i] = $root.google.ads.googleads.v1.resources.FeedItemValidationError.fromObject(object.validationErrors[i]);
                                }
                            }
                            switch (object.qualityApprovalStatus) {
                            case "UNSPECIFIED":
                            case 0:
                                message.qualityApprovalStatus = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.qualityApprovalStatus = 1;
                                break;
                            case "APPROVED":
                            case 2:
                                message.qualityApprovalStatus = 2;
                                break;
                            case "DISAPPROVED":
                            case 3:
                                message.qualityApprovalStatus = 3;
                                break;
                            }
                            if (object.qualityDisapprovalReasons) {
                                if (!Array.isArray(object.qualityDisapprovalReasons))
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo.qualityDisapprovalReasons: array expected");
                                message.qualityDisapprovalReasons = [];
                                for (var i = 0; i < object.qualityDisapprovalReasons.length; ++i)
                                    switch (object.qualityDisapprovalReasons[i]) {
                                    default:
                                    case "UNSPECIFIED":
                                    case 0:
                                        message.qualityDisapprovalReasons[i] = 0;
                                        break;
                                    case "UNKNOWN":
                                    case 1:
                                        message.qualityDisapprovalReasons[i] = 1;
                                        break;
                                    case "PRICE_TABLE_REPETITIVE_HEADERS":
                                    case 2:
                                        message.qualityDisapprovalReasons[i] = 2;
                                        break;
                                    case "PRICE_TABLE_REPETITIVE_DESCRIPTION":
                                    case 3:
                                        message.qualityDisapprovalReasons[i] = 3;
                                        break;
                                    case "PRICE_TABLE_INCONSISTENT_ROWS":
                                    case 4:
                                        message.qualityDisapprovalReasons[i] = 4;
                                        break;
                                    case "PRICE_DESCRIPTION_HAS_PRICE_QUALIFIERS":
                                    case 5:
                                        message.qualityDisapprovalReasons[i] = 5;
                                        break;
                                    case "PRICE_UNSUPPORTED_LANGUAGE":
                                    case 6:
                                        message.qualityDisapprovalReasons[i] = 6;
                                        break;
                                    case "PRICE_TABLE_ROW_HEADER_TABLE_TYPE_MISMATCH":
                                    case 7:
                                        message.qualityDisapprovalReasons[i] = 7;
                                        break;
                                    case "PRICE_TABLE_ROW_HEADER_HAS_PROMOTIONAL_TEXT":
                                    case 8:
                                        message.qualityDisapprovalReasons[i] = 8;
                                        break;
                                    case "PRICE_TABLE_ROW_DESCRIPTION_NOT_RELEVANT":
                                    case 9:
                                        message.qualityDisapprovalReasons[i] = 9;
                                        break;
                                    case "PRICE_TABLE_ROW_DESCRIPTION_HAS_PROMOTIONAL_TEXT":
                                    case 10:
                                        message.qualityDisapprovalReasons[i] = 10;
                                        break;
                                    case "PRICE_TABLE_ROW_HEADER_DESCRIPTION_REPETITIVE":
                                    case 11:
                                        message.qualityDisapprovalReasons[i] = 11;
                                        break;
                                    case "PRICE_TABLE_ROW_UNRATEABLE":
                                    case 12:
                                        message.qualityDisapprovalReasons[i] = 12;
                                        break;
                                    case "PRICE_TABLE_ROW_PRICE_INVALID":
                                    case 13:
                                        message.qualityDisapprovalReasons[i] = 13;
                                        break;
                                    case "PRICE_TABLE_ROW_URL_INVALID":
                                    case 14:
                                        message.qualityDisapprovalReasons[i] = 14;
                                        break;
                                    case "PRICE_HEADER_OR_DESCRIPTION_HAS_PRICE":
                                    case 15:
                                        message.qualityDisapprovalReasons[i] = 15;
                                        break;
                                    case "STRUCTURED_SNIPPETS_HEADER_POLICY_VIOLATED":
                                    case 16:
                                        message.qualityDisapprovalReasons[i] = 16;
                                        break;
                                    case "STRUCTURED_SNIPPETS_REPEATED_VALUES":
                                    case 17:
                                        message.qualityDisapprovalReasons[i] = 17;
                                        break;
                                    case "STRUCTURED_SNIPPETS_EDITORIAL_GUIDELINES":
                                    case 18:
                                        message.qualityDisapprovalReasons[i] = 18;
                                        break;
                                    case "STRUCTURED_SNIPPETS_HAS_PROMOTIONAL_TEXT":
                                    case 19:
                                        message.qualityDisapprovalReasons[i] = 19;
                                        break;
                                    }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a FeedItemPlaceholderPolicyInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo
                         * @static
                         * @param {google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo} message FeedItemPlaceholderPolicyInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedItemPlaceholderPolicyInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.policyTopicEntries = [];
                                object.validationErrors = [];
                                object.qualityDisapprovalReasons = [];
                            }
                            if (options.defaults) {
                                object.placeholderType = null;
                                object.feedMappingResourceName = null;
                                object.reviewStatus = options.enums === String ? "UNSPECIFIED" : 0;
                                object.approvalStatus = options.enums === String ? "UNSPECIFIED" : 0;
                                object.validationStatus = options.enums === String ? "UNSPECIFIED" : 0;
                                object.qualityApprovalStatus = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.placeholderType != null && message.hasOwnProperty("placeholderType"))
                                object.placeholderType = $root.google.protobuf.Int32Value.toObject(message.placeholderType, options);
                            if (message.feedMappingResourceName != null && message.hasOwnProperty("feedMappingResourceName"))
                                object.feedMappingResourceName = $root.google.protobuf.StringValue.toObject(message.feedMappingResourceName, options);
                            if (message.reviewStatus != null && message.hasOwnProperty("reviewStatus"))
                                object.reviewStatus = options.enums === String ? $root.google.ads.googleads.v1.enums.PolicyReviewStatusEnum.PolicyReviewStatus[message.reviewStatus] : message.reviewStatus;
                            if (message.approvalStatus != null && message.hasOwnProperty("approvalStatus"))
                                object.approvalStatus = options.enums === String ? $root.google.ads.googleads.v1.enums.PolicyApprovalStatusEnum.PolicyApprovalStatus[message.approvalStatus] : message.approvalStatus;
                            if (message.policyTopicEntries && message.policyTopicEntries.length) {
                                object.policyTopicEntries = [];
                                for (var j = 0; j < message.policyTopicEntries.length; ++j)
                                    object.policyTopicEntries[j] = $root.google.ads.googleads.v1.common.PolicyTopicEntry.toObject(message.policyTopicEntries[j], options);
                            }
                            if (message.validationStatus != null && message.hasOwnProperty("validationStatus"))
                                object.validationStatus = options.enums === String ? $root.google.ads.googleads.v1.enums.FeedItemValidationStatusEnum.FeedItemValidationStatus[message.validationStatus] : message.validationStatus;
                            if (message.validationErrors && message.validationErrors.length) {
                                object.validationErrors = [];
                                for (var j = 0; j < message.validationErrors.length; ++j)
                                    object.validationErrors[j] = $root.google.ads.googleads.v1.resources.FeedItemValidationError.toObject(message.validationErrors[j], options);
                            }
                            if (message.qualityApprovalStatus != null && message.hasOwnProperty("qualityApprovalStatus"))
                                object.qualityApprovalStatus = options.enums === String ? $root.google.ads.googleads.v1.enums.FeedItemQualityApprovalStatusEnum.FeedItemQualityApprovalStatus[message.qualityApprovalStatus] : message.qualityApprovalStatus;
                            if (message.qualityDisapprovalReasons && message.qualityDisapprovalReasons.length) {
                                object.qualityDisapprovalReasons = [];
                                for (var j = 0; j < message.qualityDisapprovalReasons.length; ++j)
                                    object.qualityDisapprovalReasons[j] = options.enums === String ? $root.google.ads.googleads.v1.enums.FeedItemQualityDisapprovalReasonEnum.FeedItemQualityDisapprovalReason[message.qualityDisapprovalReasons[j]] : message.qualityDisapprovalReasons[j];
                            }
                            return object;
                        };

                        /**
                         * Converts this FeedItemPlaceholderPolicyInfo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.FeedItemPlaceholderPolicyInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedItemPlaceholderPolicyInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return FeedItemPlaceholderPolicyInfo;
                    })();

                    resources.FeedItemValidationError = (function() {

                        /**
                         * Properties of a FeedItemValidationError.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IFeedItemValidationError
                         * @property {google.ads.googleads.v1.errors.FeedItemValidationErrorEnum.FeedItemValidationError|null} [validationError] FeedItemValidationError validationError
                         * @property {google.protobuf.IStringValue|null} [description] FeedItemValidationError description
                         * @property {Array.<google.protobuf.IInt64Value>|null} [feedAttributeIds] FeedItemValidationError feedAttributeIds
                         * @property {google.protobuf.IStringValue|null} [extraInfo] FeedItemValidationError extraInfo
                         */

                        /**
                         * Constructs a new FeedItemValidationError.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a FeedItemValidationError.
                         * @implements IFeedItemValidationError
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IFeedItemValidationError=} [properties] Properties to set
                         */
                        function FeedItemValidationError(properties) {
                            this.feedAttributeIds = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * FeedItemValidationError validationError.
                         * @member {google.ads.googleads.v1.errors.FeedItemValidationErrorEnum.FeedItemValidationError} validationError
                         * @memberof google.ads.googleads.v1.resources.FeedItemValidationError
                         * @instance
                         */
                        FeedItemValidationError.prototype.validationError = 0;

                        /**
                         * FeedItemValidationError description.
                         * @member {google.protobuf.IStringValue|null|undefined} description
                         * @memberof google.ads.googleads.v1.resources.FeedItemValidationError
                         * @instance
                         */
                        FeedItemValidationError.prototype.description = null;

                        /**
                         * FeedItemValidationError feedAttributeIds.
                         * @member {Array.<google.protobuf.IInt64Value>} feedAttributeIds
                         * @memberof google.ads.googleads.v1.resources.FeedItemValidationError
                         * @instance
                         */
                        FeedItemValidationError.prototype.feedAttributeIds = $util.emptyArray;

                        /**
                         * FeedItemValidationError extraInfo.
                         * @member {google.protobuf.IStringValue|null|undefined} extraInfo
                         * @memberof google.ads.googleads.v1.resources.FeedItemValidationError
                         * @instance
                         */
                        FeedItemValidationError.prototype.extraInfo = null;

                        /**
                         * Creates a new FeedItemValidationError instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.FeedItemValidationError
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedItemValidationError=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.FeedItemValidationError} FeedItemValidationError instance
                         */
                        FeedItemValidationError.create = function create(properties) {
                            return new FeedItemValidationError(properties);
                        };

                        /**
                         * Encodes the specified FeedItemValidationError message. Does not implicitly {@link google.ads.googleads.v1.resources.FeedItemValidationError.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.FeedItemValidationError
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedItemValidationError} message FeedItemValidationError message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemValidationError.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.validationError != null && message.hasOwnProperty("validationError"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.validationError);
                            if (message.description != null && message.hasOwnProperty("description"))
                                $root.google.protobuf.StringValue.encode(message.description, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.feedAttributeIds != null && message.feedAttributeIds.length)
                                for (var i = 0; i < message.feedAttributeIds.length; ++i)
                                    $root.google.protobuf.Int64Value.encode(message.feedAttributeIds[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.extraInfo != null && message.hasOwnProperty("extraInfo"))
                                $root.google.protobuf.StringValue.encode(message.extraInfo, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedItemValidationError message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.FeedItemValidationError.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.FeedItemValidationError
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedItemValidationError} message FeedItemValidationError message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemValidationError.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedItemValidationError message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.FeedItemValidationError
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.FeedItemValidationError} FeedItemValidationError
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemValidationError.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.FeedItemValidationError();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.validationError = reader.int32();
                                    break;
                                case 2:
                                    message.description = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    if (!(message.feedAttributeIds && message.feedAttributeIds.length))
                                        message.feedAttributeIds = [];
                                    message.feedAttributeIds.push($root.google.protobuf.Int64Value.decode(reader, reader.uint32()));
                                    break;
                                case 5:
                                    message.extraInfo = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedItemValidationError message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.FeedItemValidationError
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.FeedItemValidationError} FeedItemValidationError
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemValidationError.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedItemValidationError message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.FeedItemValidationError
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedItemValidationError.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.validationError != null && message.hasOwnProperty("validationError"))
                                switch (message.validationError) {
                                default:
                                    return "validationError: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                case 32:
                                case 33:
                                case 34:
                                case 35:
                                case 36:
                                case 37:
                                case 38:
                                case 39:
                                case 40:
                                case 41:
                                case 42:
                                case 43:
                                case 44:
                                case 45:
                                case 46:
                                case 47:
                                case 48:
                                case 49:
                                case 50:
                                case 51:
                                case 52:
                                case 53:
                                case 54:
                                case 55:
                                case 56:
                                case 57:
                                case 58:
                                case 59:
                                case 60:
                                case 61:
                                case 62:
                                case 63:
                                case 64:
                                case 65:
                                case 66:
                                case 67:
                                case 68:
                                case 69:
                                case 70:
                                case 71:
                                case 72:
                                case 73:
                                case 74:
                                case 75:
                                case 76:
                                case 77:
                                case 78:
                                case 79:
                                case 80:
                                case 81:
                                case 82:
                                case 83:
                                case 84:
                                case 85:
                                case 86:
                                case 87:
                                case 88:
                                case 89:
                                case 90:
                                case 91:
                                case 92:
                                case 93:
                                case 94:
                                case 95:
                                case 96:
                                    break;
                                }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                var error = $root.google.protobuf.StringValue.verify(message.description);
                                if (error)
                                    return "description." + error;
                            }
                            if (message.feedAttributeIds != null && message.hasOwnProperty("feedAttributeIds")) {
                                if (!Array.isArray(message.feedAttributeIds))
                                    return "feedAttributeIds: array expected";
                                for (var i = 0; i < message.feedAttributeIds.length; ++i) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.feedAttributeIds[i]);
                                    if (error)
                                        return "feedAttributeIds." + error;
                                }
                            }
                            if (message.extraInfo != null && message.hasOwnProperty("extraInfo")) {
                                var error = $root.google.protobuf.StringValue.verify(message.extraInfo);
                                if (error)
                                    return "extraInfo." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a FeedItemValidationError message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.FeedItemValidationError
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.FeedItemValidationError} FeedItemValidationError
                         */
                        FeedItemValidationError.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.FeedItemValidationError)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.FeedItemValidationError();
                            switch (object.validationError) {
                            case "UNSPECIFIED":
                            case 0:
                                message.validationError = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.validationError = 1;
                                break;
                            case "STRING_TOO_SHORT":
                            case 2:
                                message.validationError = 2;
                                break;
                            case "STRING_TOO_LONG":
                            case 3:
                                message.validationError = 3;
                                break;
                            case "VALUE_NOT_SPECIFIED":
                            case 4:
                                message.validationError = 4;
                                break;
                            case "INVALID_DOMESTIC_PHONE_NUMBER_FORMAT":
                            case 5:
                                message.validationError = 5;
                                break;
                            case "INVALID_PHONE_NUMBER":
                            case 6:
                                message.validationError = 6;
                                break;
                            case "PHONE_NUMBER_NOT_SUPPORTED_FOR_COUNTRY":
                            case 7:
                                message.validationError = 7;
                                break;
                            case "PREMIUM_RATE_NUMBER_NOT_ALLOWED":
                            case 8:
                                message.validationError = 8;
                                break;
                            case "DISALLOWED_NUMBER_TYPE":
                            case 9:
                                message.validationError = 9;
                                break;
                            case "VALUE_OUT_OF_RANGE":
                            case 10:
                                message.validationError = 10;
                                break;
                            case "CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY":
                            case 11:
                                message.validationError = 11;
                                break;
                            case "CUSTOMER_NOT_WHITELISTED_FOR_CALLTRACKING":
                            case 12:
                                message.validationError = 12;
                                break;
                            case "INVALID_COUNTRY_CODE":
                            case 13:
                                message.validationError = 13;
                                break;
                            case "INVALID_APP_ID":
                            case 14:
                                message.validationError = 14;
                                break;
                            case "MISSING_ATTRIBUTES_FOR_FIELDS":
                            case 15:
                                message.validationError = 15;
                                break;
                            case "INVALID_TYPE_ID":
                            case 16:
                                message.validationError = 16;
                                break;
                            case "INVALID_EMAIL_ADDRESS":
                            case 17:
                                message.validationError = 17;
                                break;
                            case "INVALID_HTTPS_URL":
                            case 18:
                                message.validationError = 18;
                                break;
                            case "MISSING_DELIVERY_ADDRESS":
                            case 19:
                                message.validationError = 19;
                                break;
                            case "START_DATE_AFTER_END_DATE":
                            case 20:
                                message.validationError = 20;
                                break;
                            case "MISSING_FEED_ITEM_START_TIME":
                            case 21:
                                message.validationError = 21;
                                break;
                            case "MISSING_FEED_ITEM_END_TIME":
                            case 22:
                                message.validationError = 22;
                                break;
                            case "MISSING_FEED_ITEM_ID":
                            case 23:
                                message.validationError = 23;
                                break;
                            case "VANITY_PHONE_NUMBER_NOT_ALLOWED":
                            case 24:
                                message.validationError = 24;
                                break;
                            case "INVALID_REVIEW_EXTENSION_SNIPPET":
                            case 25:
                                message.validationError = 25;
                                break;
                            case "INVALID_NUMBER_FORMAT":
                            case 26:
                                message.validationError = 26;
                                break;
                            case "INVALID_DATE_FORMAT":
                            case 27:
                                message.validationError = 27;
                                break;
                            case "INVALID_PRICE_FORMAT":
                            case 28:
                                message.validationError = 28;
                                break;
                            case "UNKNOWN_PLACEHOLDER_FIELD":
                            case 29:
                                message.validationError = 29;
                                break;
                            case "MISSING_ENHANCED_SITELINK_DESCRIPTION_LINE":
                            case 30:
                                message.validationError = 30;
                                break;
                            case "REVIEW_EXTENSION_SOURCE_INELIGIBLE":
                            case 31:
                                message.validationError = 31;
                                break;
                            case "HYPHENS_IN_REVIEW_EXTENSION_SNIPPET":
                            case 32:
                                message.validationError = 32;
                                break;
                            case "DOUBLE_QUOTES_IN_REVIEW_EXTENSION_SNIPPET":
                            case 33:
                                message.validationError = 33;
                                break;
                            case "QUOTES_IN_REVIEW_EXTENSION_SNIPPET":
                            case 34:
                                message.validationError = 34;
                                break;
                            case "INVALID_FORM_ENCODED_PARAMS":
                            case 35:
                                message.validationError = 35;
                                break;
                            case "INVALID_URL_PARAMETER_NAME":
                            case 36:
                                message.validationError = 36;
                                break;
                            case "NO_GEOCODING_RESULT":
                            case 37:
                                message.validationError = 37;
                                break;
                            case "SOURCE_NAME_IN_REVIEW_EXTENSION_TEXT":
                            case 38:
                                message.validationError = 38;
                                break;
                            case "CARRIER_SPECIFIC_SHORT_NUMBER_NOT_ALLOWED":
                            case 39:
                                message.validationError = 39;
                                break;
                            case "INVALID_PLACEHOLDER_FIELD_ID":
                            case 40:
                                message.validationError = 40;
                                break;
                            case "INVALID_URL_TAG":
                            case 41:
                                message.validationError = 41;
                                break;
                            case "LIST_TOO_LONG":
                            case 42:
                                message.validationError = 42;
                                break;
                            case "INVALID_ATTRIBUTES_COMBINATION":
                            case 43:
                                message.validationError = 43;
                                break;
                            case "DUPLICATE_VALUES":
                            case 44:
                                message.validationError = 44;
                                break;
                            case "INVALID_CALL_CONVERSION_ACTION_ID":
                            case 45:
                                message.validationError = 45;
                                break;
                            case "CANNOT_SET_WITHOUT_FINAL_URLS":
                            case 46:
                                message.validationError = 46;
                                break;
                            case "APP_ID_DOESNT_EXIST_IN_APP_STORE":
                            case 47:
                                message.validationError = 47;
                                break;
                            case "INVALID_FINAL_URL":
                            case 48:
                                message.validationError = 48;
                                break;
                            case "INVALID_TRACKING_URL":
                            case 49:
                                message.validationError = 49;
                                break;
                            case "INVALID_FINAL_URL_FOR_APP_DOWNLOAD_URL":
                            case 50:
                                message.validationError = 50;
                                break;
                            case "LIST_TOO_SHORT":
                            case 51:
                                message.validationError = 51;
                                break;
                            case "INVALID_USER_ACTION":
                            case 52:
                                message.validationError = 52;
                                break;
                            case "INVALID_TYPE_NAME":
                            case 53:
                                message.validationError = 53;
                                break;
                            case "INVALID_EVENT_CHANGE_STATUS":
                            case 54:
                                message.validationError = 54;
                                break;
                            case "INVALID_SNIPPETS_HEADER":
                            case 55:
                                message.validationError = 55;
                                break;
                            case "INVALID_ANDROID_APP_LINK":
                            case 56:
                                message.validationError = 56;
                                break;
                            case "NUMBER_TYPE_WITH_CALLTRACKING_NOT_SUPPORTED_FOR_COUNTRY":
                            case 57:
                                message.validationError = 57;
                                break;
                            case "RESERVED_KEYWORD_OTHER":
                            case 58:
                                message.validationError = 58;
                                break;
                            case "DUPLICATE_OPTION_LABELS":
                            case 59:
                                message.validationError = 59;
                                break;
                            case "DUPLICATE_OPTION_PREFILLS":
                            case 60:
                                message.validationError = 60;
                                break;
                            case "UNEQUAL_LIST_LENGTHS":
                            case 61:
                                message.validationError = 61;
                                break;
                            case "INCONSISTENT_CURRENCY_CODES":
                            case 62:
                                message.validationError = 62;
                                break;
                            case "PRICE_EXTENSION_HAS_DUPLICATED_HEADERS":
                            case 63:
                                message.validationError = 63;
                                break;
                            case "ITEM_HAS_DUPLICATED_HEADER_AND_DESCRIPTION":
                            case 64:
                                message.validationError = 64;
                                break;
                            case "PRICE_EXTENSION_HAS_TOO_FEW_ITEMS":
                            case 65:
                                message.validationError = 65;
                                break;
                            case "UNSUPPORTED_VALUE":
                            case 66:
                                message.validationError = 66;
                                break;
                            case "INVALID_FINAL_MOBILE_URL":
                            case 67:
                                message.validationError = 67;
                                break;
                            case "INVALID_KEYWORDLESS_AD_RULE_LABEL":
                            case 68:
                                message.validationError = 68;
                                break;
                            case "VALUE_TRACK_PARAMETER_NOT_SUPPORTED":
                            case 69:
                                message.validationError = 69;
                                break;
                            case "UNSUPPORTED_VALUE_IN_SELECTED_LANGUAGE":
                            case 70:
                                message.validationError = 70;
                                break;
                            case "INVALID_IOS_APP_LINK":
                            case 71:
                                message.validationError = 71;
                                break;
                            case "MISSING_IOS_APP_LINK_OR_IOS_APP_STORE_ID":
                            case 72:
                                message.validationError = 72;
                                break;
                            case "PROMOTION_INVALID_TIME":
                            case 73:
                                message.validationError = 73;
                                break;
                            case "PROMOTION_CANNOT_SET_PERCENT_OFF_AND_MONEY_AMOUNT_OFF":
                            case 74:
                                message.validationError = 74;
                                break;
                            case "PROMOTION_CANNOT_SET_PROMOTION_CODE_AND_ORDERS_OVER_AMOUNT":
                            case 75:
                                message.validationError = 75;
                                break;
                            case "TOO_MANY_DECIMAL_PLACES_SPECIFIED":
                            case 76:
                                message.validationError = 76;
                                break;
                            case "AD_CUSTOMIZERS_NOT_ALLOWED":
                            case 77:
                                message.validationError = 77;
                                break;
                            case "INVALID_LANGUAGE_CODE":
                            case 78:
                                message.validationError = 78;
                                break;
                            case "UNSUPPORTED_LANGUAGE":
                            case 79:
                                message.validationError = 79;
                                break;
                            case "IF_FUNCTION_NOT_ALLOWED":
                            case 80:
                                message.validationError = 80;
                                break;
                            case "INVALID_FINAL_URL_SUFFIX":
                            case 81:
                                message.validationError = 81;
                                break;
                            case "INVALID_TAG_IN_FINAL_URL_SUFFIX":
                            case 82:
                                message.validationError = 82;
                                break;
                            case "INVALID_FINAL_URL_SUFFIX_FORMAT":
                            case 83:
                                message.validationError = 83;
                                break;
                            case "CUSTOMER_CONSENT_FOR_CALL_RECORDING_REQUIRED":
                            case 84:
                                message.validationError = 84;
                                break;
                            case "ONLY_ONE_DELIVERY_OPTION_IS_ALLOWED":
                            case 85:
                                message.validationError = 85;
                                break;
                            case "NO_DELIVERY_OPTION_IS_SET":
                            case 86:
                                message.validationError = 86;
                                break;
                            case "INVALID_CONVERSION_REPORTING_STATE":
                            case 87:
                                message.validationError = 87;
                                break;
                            case "IMAGE_SIZE_WRONG":
                            case 88:
                                message.validationError = 88;
                                break;
                            case "EMAIL_DELIVERY_NOT_AVAILABLE_IN_COUNTRY":
                            case 89:
                                message.validationError = 89;
                                break;
                            case "AUTO_REPLY_NOT_AVAILABLE_IN_COUNTRY":
                            case 90:
                                message.validationError = 90;
                                break;
                            case "INVALID_LATITUDE_VALUE":
                            case 91:
                                message.validationError = 91;
                                break;
                            case "INVALID_LONGITUDE_VALUE":
                            case 92:
                                message.validationError = 92;
                                break;
                            case "TOO_MANY_LABELS":
                            case 93:
                                message.validationError = 93;
                                break;
                            case "INVALID_IMAGE_URL":
                            case 94:
                                message.validationError = 94;
                                break;
                            case "MISSING_LATITUDE_VALUE":
                            case 95:
                                message.validationError = 95;
                                break;
                            case "MISSING_LONGITUDE_VALUE":
                            case 96:
                                message.validationError = 96;
                                break;
                            }
                            if (object.description != null) {
                                if (typeof object.description !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemValidationError.description: object expected");
                                message.description = $root.google.protobuf.StringValue.fromObject(object.description);
                            }
                            if (object.feedAttributeIds) {
                                if (!Array.isArray(object.feedAttributeIds))
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemValidationError.feedAttributeIds: array expected");
                                message.feedAttributeIds = [];
                                for (var i = 0; i < object.feedAttributeIds.length; ++i) {
                                    if (typeof object.feedAttributeIds[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.FeedItemValidationError.feedAttributeIds: object expected");
                                    message.feedAttributeIds[i] = $root.google.protobuf.Int64Value.fromObject(object.feedAttributeIds[i]);
                                }
                            }
                            if (object.extraInfo != null) {
                                if (typeof object.extraInfo !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemValidationError.extraInfo: object expected");
                                message.extraInfo = $root.google.protobuf.StringValue.fromObject(object.extraInfo);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a FeedItemValidationError message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.FeedItemValidationError
                         * @static
                         * @param {google.ads.googleads.v1.resources.FeedItemValidationError} message FeedItemValidationError
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedItemValidationError.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.feedAttributeIds = [];
                            if (options.defaults) {
                                object.validationError = options.enums === String ? "UNSPECIFIED" : 0;
                                object.description = null;
                                object.extraInfo = null;
                            }
                            if (message.validationError != null && message.hasOwnProperty("validationError"))
                                object.validationError = options.enums === String ? $root.google.ads.googleads.v1.errors.FeedItemValidationErrorEnum.FeedItemValidationError[message.validationError] : message.validationError;
                            if (message.description != null && message.hasOwnProperty("description"))
                                object.description = $root.google.protobuf.StringValue.toObject(message.description, options);
                            if (message.feedAttributeIds && message.feedAttributeIds.length) {
                                object.feedAttributeIds = [];
                                for (var j = 0; j < message.feedAttributeIds.length; ++j)
                                    object.feedAttributeIds[j] = $root.google.protobuf.Int64Value.toObject(message.feedAttributeIds[j], options);
                            }
                            if (message.extraInfo != null && message.hasOwnProperty("extraInfo"))
                                object.extraInfo = $root.google.protobuf.StringValue.toObject(message.extraInfo, options);
                            return object;
                        };

                        /**
                         * Converts this FeedItemValidationError to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.FeedItemValidationError
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedItemValidationError.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return FeedItemValidationError;
                    })();

                    resources.FeedItemTarget = (function() {

                        /**
                         * Properties of a FeedItemTarget.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IFeedItemTarget
                         * @property {string|null} [resourceName] FeedItemTarget resourceName
                         * @property {google.protobuf.IStringValue|null} [feedItem] FeedItemTarget feedItem
                         * @property {google.ads.googleads.v1.enums.FeedItemTargetTypeEnum.FeedItemTargetType|null} [feedItemTargetType] FeedItemTarget feedItemTargetType
                         * @property {google.protobuf.IInt64Value|null} [feedItemTargetId] FeedItemTarget feedItemTargetId
                         * @property {google.protobuf.IStringValue|null} [campaign] FeedItemTarget campaign
                         * @property {google.protobuf.IStringValue|null} [adGroup] FeedItemTarget adGroup
                         * @property {google.ads.googleads.v1.common.IKeywordInfo|null} [keyword] FeedItemTarget keyword
                         * @property {google.protobuf.IStringValue|null} [geoTargetConstant] FeedItemTarget geoTargetConstant
                         * @property {google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum.FeedItemTargetDevice|null} [device] FeedItemTarget device
                         * @property {google.ads.googleads.v1.common.IAdScheduleInfo|null} [adSchedule] FeedItemTarget adSchedule
                         */

                        /**
                         * Constructs a new FeedItemTarget.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a FeedItemTarget.
                         * @implements IFeedItemTarget
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IFeedItemTarget=} [properties] Properties to set
                         */
                        function FeedItemTarget(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * FeedItemTarget resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @instance
                         */
                        FeedItemTarget.prototype.resourceName = "";

                        /**
                         * FeedItemTarget feedItem.
                         * @member {google.protobuf.IStringValue|null|undefined} feedItem
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @instance
                         */
                        FeedItemTarget.prototype.feedItem = null;

                        /**
                         * FeedItemTarget feedItemTargetType.
                         * @member {google.ads.googleads.v1.enums.FeedItemTargetTypeEnum.FeedItemTargetType} feedItemTargetType
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @instance
                         */
                        FeedItemTarget.prototype.feedItemTargetType = 0;

                        /**
                         * FeedItemTarget feedItemTargetId.
                         * @member {google.protobuf.IInt64Value|null|undefined} feedItemTargetId
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @instance
                         */
                        FeedItemTarget.prototype.feedItemTargetId = null;

                        /**
                         * FeedItemTarget campaign.
                         * @member {google.protobuf.IStringValue|null|undefined} campaign
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @instance
                         */
                        FeedItemTarget.prototype.campaign = null;

                        /**
                         * FeedItemTarget adGroup.
                         * @member {google.protobuf.IStringValue|null|undefined} adGroup
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @instance
                         */
                        FeedItemTarget.prototype.adGroup = null;

                        /**
                         * FeedItemTarget keyword.
                         * @member {google.ads.googleads.v1.common.IKeywordInfo|null|undefined} keyword
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @instance
                         */
                        FeedItemTarget.prototype.keyword = null;

                        /**
                         * FeedItemTarget geoTargetConstant.
                         * @member {google.protobuf.IStringValue|null|undefined} geoTargetConstant
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @instance
                         */
                        FeedItemTarget.prototype.geoTargetConstant = null;

                        /**
                         * FeedItemTarget device.
                         * @member {google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum.FeedItemTargetDevice} device
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @instance
                         */
                        FeedItemTarget.prototype.device = 0;

                        /**
                         * FeedItemTarget adSchedule.
                         * @member {google.ads.googleads.v1.common.IAdScheduleInfo|null|undefined} adSchedule
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @instance
                         */
                        FeedItemTarget.prototype.adSchedule = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * FeedItemTarget target.
                         * @member {"campaign"|"adGroup"|"keyword"|"geoTargetConstant"|"device"|"adSchedule"|undefined} target
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @instance
                         */
                        Object.defineProperty(FeedItemTarget.prototype, "target", {
                            get: $util.oneOfGetter($oneOfFields = ["campaign", "adGroup", "keyword", "geoTargetConstant", "device", "adSchedule"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new FeedItemTarget instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedItemTarget=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.FeedItemTarget} FeedItemTarget instance
                         */
                        FeedItemTarget.create = function create(properties) {
                            return new FeedItemTarget(properties);
                        };

                        /**
                         * Encodes the specified FeedItemTarget message. Does not implicitly {@link google.ads.googleads.v1.resources.FeedItemTarget.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedItemTarget} message FeedItemTarget message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemTarget.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.feedItem != null && message.hasOwnProperty("feedItem"))
                                $root.google.protobuf.StringValue.encode(message.feedItem, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.feedItemTargetType != null && message.hasOwnProperty("feedItemTargetType"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.feedItemTargetType);
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                $root.google.protobuf.StringValue.encode(message.campaign, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                $root.google.protobuf.StringValue.encode(message.adGroup, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.feedItemTargetId != null && message.hasOwnProperty("feedItemTargetId"))
                                $root.google.protobuf.Int64Value.encode(message.feedItemTargetId, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.keyword != null && message.hasOwnProperty("keyword"))
                                $root.google.ads.googleads.v1.common.KeywordInfo.encode(message.keyword, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.geoTargetConstant != null && message.hasOwnProperty("geoTargetConstant"))
                                $root.google.protobuf.StringValue.encode(message.geoTargetConstant, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.device != null && message.hasOwnProperty("device"))
                                writer.uint32(/* id 9, wireType 0 =*/72).int32(message.device);
                            if (message.adSchedule != null && message.hasOwnProperty("adSchedule"))
                                $root.google.ads.googleads.v1.common.AdScheduleInfo.encode(message.adSchedule, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedItemTarget message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.FeedItemTarget.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedItemTarget} message FeedItemTarget message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemTarget.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedItemTarget message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.FeedItemTarget} FeedItemTarget
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemTarget.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.FeedItemTarget();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.feedItem = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.feedItemTargetType = reader.int32();
                                    break;
                                case 6:
                                    message.feedItemTargetId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.campaign = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.adGroup = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.keyword = $root.google.ads.googleads.v1.common.KeywordInfo.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.geoTargetConstant = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.device = reader.int32();
                                    break;
                                case 10:
                                    message.adSchedule = $root.google.ads.googleads.v1.common.AdScheduleInfo.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedItemTarget message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.FeedItemTarget} FeedItemTarget
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemTarget.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedItemTarget message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedItemTarget.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.feedItem != null && message.hasOwnProperty("feedItem")) {
                                var error = $root.google.protobuf.StringValue.verify(message.feedItem);
                                if (error)
                                    return "feedItem." + error;
                            }
                            if (message.feedItemTargetType != null && message.hasOwnProperty("feedItemTargetType"))
                                switch (message.feedItemTargetType) {
                                default:
                                    return "feedItemTargetType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.feedItemTargetId != null && message.hasOwnProperty("feedItemTargetId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.feedItemTargetId);
                                if (error)
                                    return "feedItemTargetId." + error;
                            }
                            if (message.campaign != null && message.hasOwnProperty("campaign")) {
                                properties.target = 1;
                                {
                                    var error = $root.google.protobuf.StringValue.verify(message.campaign);
                                    if (error)
                                        return "campaign." + error;
                                }
                            }
                            if (message.adGroup != null && message.hasOwnProperty("adGroup")) {
                                if (properties.target === 1)
                                    return "target: multiple values";
                                properties.target = 1;
                                {
                                    var error = $root.google.protobuf.StringValue.verify(message.adGroup);
                                    if (error)
                                        return "adGroup." + error;
                                }
                            }
                            if (message.keyword != null && message.hasOwnProperty("keyword")) {
                                if (properties.target === 1)
                                    return "target: multiple values";
                                properties.target = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.KeywordInfo.verify(message.keyword);
                                    if (error)
                                        return "keyword." + error;
                                }
                            }
                            if (message.geoTargetConstant != null && message.hasOwnProperty("geoTargetConstant")) {
                                if (properties.target === 1)
                                    return "target: multiple values";
                                properties.target = 1;
                                {
                                    var error = $root.google.protobuf.StringValue.verify(message.geoTargetConstant);
                                    if (error)
                                        return "geoTargetConstant." + error;
                                }
                            }
                            if (message.device != null && message.hasOwnProperty("device")) {
                                if (properties.target === 1)
                                    return "target: multiple values";
                                properties.target = 1;
                                switch (message.device) {
                                default:
                                    return "device: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            if (message.adSchedule != null && message.hasOwnProperty("adSchedule")) {
                                if (properties.target === 1)
                                    return "target: multiple values";
                                properties.target = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.AdScheduleInfo.verify(message.adSchedule);
                                    if (error)
                                        return "adSchedule." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a FeedItemTarget message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.FeedItemTarget} FeedItemTarget
                         */
                        FeedItemTarget.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.FeedItemTarget)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.FeedItemTarget();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.feedItem != null) {
                                if (typeof object.feedItem !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemTarget.feedItem: object expected");
                                message.feedItem = $root.google.protobuf.StringValue.fromObject(object.feedItem);
                            }
                            switch (object.feedItemTargetType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.feedItemTargetType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.feedItemTargetType = 1;
                                break;
                            case "CAMPAIGN":
                            case 2:
                                message.feedItemTargetType = 2;
                                break;
                            case "AD_GROUP":
                            case 3:
                                message.feedItemTargetType = 3;
                                break;
                            case "CRITERION":
                            case 4:
                                message.feedItemTargetType = 4;
                                break;
                            }
                            if (object.feedItemTargetId != null) {
                                if (typeof object.feedItemTargetId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemTarget.feedItemTargetId: object expected");
                                message.feedItemTargetId = $root.google.protobuf.Int64Value.fromObject(object.feedItemTargetId);
                            }
                            if (object.campaign != null) {
                                if (typeof object.campaign !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemTarget.campaign: object expected");
                                message.campaign = $root.google.protobuf.StringValue.fromObject(object.campaign);
                            }
                            if (object.adGroup != null) {
                                if (typeof object.adGroup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemTarget.adGroup: object expected");
                                message.adGroup = $root.google.protobuf.StringValue.fromObject(object.adGroup);
                            }
                            if (object.keyword != null) {
                                if (typeof object.keyword !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemTarget.keyword: object expected");
                                message.keyword = $root.google.ads.googleads.v1.common.KeywordInfo.fromObject(object.keyword);
                            }
                            if (object.geoTargetConstant != null) {
                                if (typeof object.geoTargetConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemTarget.geoTargetConstant: object expected");
                                message.geoTargetConstant = $root.google.protobuf.StringValue.fromObject(object.geoTargetConstant);
                            }
                            switch (object.device) {
                            case "UNSPECIFIED":
                            case 0:
                                message.device = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.device = 1;
                                break;
                            case "MOBILE":
                            case 2:
                                message.device = 2;
                                break;
                            }
                            if (object.adSchedule != null) {
                                if (typeof object.adSchedule !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedItemTarget.adSchedule: object expected");
                                message.adSchedule = $root.google.ads.googleads.v1.common.AdScheduleInfo.fromObject(object.adSchedule);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a FeedItemTarget message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @static
                         * @param {google.ads.googleads.v1.resources.FeedItemTarget} message FeedItemTarget
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedItemTarget.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.feedItem = null;
                                object.feedItemTargetType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.feedItemTargetId = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.feedItem != null && message.hasOwnProperty("feedItem"))
                                object.feedItem = $root.google.protobuf.StringValue.toObject(message.feedItem, options);
                            if (message.feedItemTargetType != null && message.hasOwnProperty("feedItemTargetType"))
                                object.feedItemTargetType = options.enums === String ? $root.google.ads.googleads.v1.enums.FeedItemTargetTypeEnum.FeedItemTargetType[message.feedItemTargetType] : message.feedItemTargetType;
                            if (message.campaign != null && message.hasOwnProperty("campaign")) {
                                object.campaign = $root.google.protobuf.StringValue.toObject(message.campaign, options);
                                if (options.oneofs)
                                    object.target = "campaign";
                            }
                            if (message.adGroup != null && message.hasOwnProperty("adGroup")) {
                                object.adGroup = $root.google.protobuf.StringValue.toObject(message.adGroup, options);
                                if (options.oneofs)
                                    object.target = "adGroup";
                            }
                            if (message.feedItemTargetId != null && message.hasOwnProperty("feedItemTargetId"))
                                object.feedItemTargetId = $root.google.protobuf.Int64Value.toObject(message.feedItemTargetId, options);
                            if (message.keyword != null && message.hasOwnProperty("keyword")) {
                                object.keyword = $root.google.ads.googleads.v1.common.KeywordInfo.toObject(message.keyword, options);
                                if (options.oneofs)
                                    object.target = "keyword";
                            }
                            if (message.geoTargetConstant != null && message.hasOwnProperty("geoTargetConstant")) {
                                object.geoTargetConstant = $root.google.protobuf.StringValue.toObject(message.geoTargetConstant, options);
                                if (options.oneofs)
                                    object.target = "geoTargetConstant";
                            }
                            if (message.device != null && message.hasOwnProperty("device")) {
                                object.device = options.enums === String ? $root.google.ads.googleads.v1.enums.FeedItemTargetDeviceEnum.FeedItemTargetDevice[message.device] : message.device;
                                if (options.oneofs)
                                    object.target = "device";
                            }
                            if (message.adSchedule != null && message.hasOwnProperty("adSchedule")) {
                                object.adSchedule = $root.google.ads.googleads.v1.common.AdScheduleInfo.toObject(message.adSchedule, options);
                                if (options.oneofs)
                                    object.target = "adSchedule";
                            }
                            return object;
                        };

                        /**
                         * Converts this FeedItemTarget to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.FeedItemTarget
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedItemTarget.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return FeedItemTarget;
                    })();

                    resources.FeedMapping = (function() {

                        /**
                         * Properties of a FeedMapping.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IFeedMapping
                         * @property {string|null} [resourceName] FeedMapping resourceName
                         * @property {google.protobuf.IStringValue|null} [feed] FeedMapping feed
                         * @property {Array.<google.ads.googleads.v1.resources.IAttributeFieldMapping>|null} [attributeFieldMappings] FeedMapping attributeFieldMappings
                         * @property {google.ads.googleads.v1.enums.FeedMappingStatusEnum.FeedMappingStatus|null} [status] FeedMapping status
                         * @property {google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType|null} [placeholderType] FeedMapping placeholderType
                         * @property {google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum.FeedMappingCriterionType|null} [criterionType] FeedMapping criterionType
                         */

                        /**
                         * Constructs a new FeedMapping.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a FeedMapping.
                         * @implements IFeedMapping
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IFeedMapping=} [properties] Properties to set
                         */
                        function FeedMapping(properties) {
                            this.attributeFieldMappings = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * FeedMapping resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.FeedMapping
                         * @instance
                         */
                        FeedMapping.prototype.resourceName = "";

                        /**
                         * FeedMapping feed.
                         * @member {google.protobuf.IStringValue|null|undefined} feed
                         * @memberof google.ads.googleads.v1.resources.FeedMapping
                         * @instance
                         */
                        FeedMapping.prototype.feed = null;

                        /**
                         * FeedMapping attributeFieldMappings.
                         * @member {Array.<google.ads.googleads.v1.resources.IAttributeFieldMapping>} attributeFieldMappings
                         * @memberof google.ads.googleads.v1.resources.FeedMapping
                         * @instance
                         */
                        FeedMapping.prototype.attributeFieldMappings = $util.emptyArray;

                        /**
                         * FeedMapping status.
                         * @member {google.ads.googleads.v1.enums.FeedMappingStatusEnum.FeedMappingStatus} status
                         * @memberof google.ads.googleads.v1.resources.FeedMapping
                         * @instance
                         */
                        FeedMapping.prototype.status = 0;

                        /**
                         * FeedMapping placeholderType.
                         * @member {google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType} placeholderType
                         * @memberof google.ads.googleads.v1.resources.FeedMapping
                         * @instance
                         */
                        FeedMapping.prototype.placeholderType = 0;

                        /**
                         * FeedMapping criterionType.
                         * @member {google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum.FeedMappingCriterionType} criterionType
                         * @memberof google.ads.googleads.v1.resources.FeedMapping
                         * @instance
                         */
                        FeedMapping.prototype.criterionType = 0;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * FeedMapping target.
                         * @member {"placeholderType"|"criterionType"|undefined} target
                         * @memberof google.ads.googleads.v1.resources.FeedMapping
                         * @instance
                         */
                        Object.defineProperty(FeedMapping.prototype, "target", {
                            get: $util.oneOfGetter($oneOfFields = ["placeholderType", "criterionType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new FeedMapping instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.FeedMapping
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedMapping=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.FeedMapping} FeedMapping instance
                         */
                        FeedMapping.create = function create(properties) {
                            return new FeedMapping(properties);
                        };

                        /**
                         * Encodes the specified FeedMapping message. Does not implicitly {@link google.ads.googleads.v1.resources.FeedMapping.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.FeedMapping
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedMapping} message FeedMapping message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedMapping.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.feed != null && message.hasOwnProperty("feed"))
                                $root.google.protobuf.StringValue.encode(message.feed, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.placeholderType != null && message.hasOwnProperty("placeholderType"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.placeholderType);
                            if (message.criterionType != null && message.hasOwnProperty("criterionType"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.criterionType);
                            if (message.attributeFieldMappings != null && message.attributeFieldMappings.length)
                                for (var i = 0; i < message.attributeFieldMappings.length; ++i)
                                    $root.google.ads.googleads.v1.resources.AttributeFieldMapping.encode(message.attributeFieldMappings[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.status);
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedMapping message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.FeedMapping.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.FeedMapping
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedMapping} message FeedMapping message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedMapping.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedMapping message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.FeedMapping
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.FeedMapping} FeedMapping
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedMapping.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.FeedMapping();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.feed = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    if (!(message.attributeFieldMappings && message.attributeFieldMappings.length))
                                        message.attributeFieldMappings = [];
                                    message.attributeFieldMappings.push($root.google.ads.googleads.v1.resources.AttributeFieldMapping.decode(reader, reader.uint32()));
                                    break;
                                case 6:
                                    message.status = reader.int32();
                                    break;
                                case 3:
                                    message.placeholderType = reader.int32();
                                    break;
                                case 4:
                                    message.criterionType = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedMapping message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.FeedMapping
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.FeedMapping} FeedMapping
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedMapping.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedMapping message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.FeedMapping
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedMapping.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.feed != null && message.hasOwnProperty("feed")) {
                                var error = $root.google.protobuf.StringValue.verify(message.feed);
                                if (error)
                                    return "feed." + error;
                            }
                            if (message.attributeFieldMappings != null && message.hasOwnProperty("attributeFieldMappings")) {
                                if (!Array.isArray(message.attributeFieldMappings))
                                    return "attributeFieldMappings: array expected";
                                for (var i = 0; i < message.attributeFieldMappings.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.resources.AttributeFieldMapping.verify(message.attributeFieldMappings[i]);
                                    if (error)
                                        return "attributeFieldMappings." + error;
                                }
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.placeholderType != null && message.hasOwnProperty("placeholderType")) {
                                properties.target = 1;
                                switch (message.placeholderType) {
                                default:
                                    return "placeholderType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                    break;
                                }
                            }
                            if (message.criterionType != null && message.hasOwnProperty("criterionType")) {
                                if (properties.target === 1)
                                    return "target: multiple values";
                                properties.target = 1;
                                switch (message.criterionType) {
                                default:
                                    return "criterionType: enum value expected";
                                case 0:
                                case 1:
                                case 4:
                                case 3:
                                    break;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a FeedMapping message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.FeedMapping
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.FeedMapping} FeedMapping
                         */
                        FeedMapping.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.FeedMapping)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.FeedMapping();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.feed != null) {
                                if (typeof object.feed !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedMapping.feed: object expected");
                                message.feed = $root.google.protobuf.StringValue.fromObject(object.feed);
                            }
                            if (object.attributeFieldMappings) {
                                if (!Array.isArray(object.attributeFieldMappings))
                                    throw TypeError(".google.ads.googleads.v1.resources.FeedMapping.attributeFieldMappings: array expected");
                                message.attributeFieldMappings = [];
                                for (var i = 0; i < object.attributeFieldMappings.length; ++i) {
                                    if (typeof object.attributeFieldMappings[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.FeedMapping.attributeFieldMappings: object expected");
                                    message.attributeFieldMappings[i] = $root.google.ads.googleads.v1.resources.AttributeFieldMapping.fromObject(object.attributeFieldMappings[i]);
                                }
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "REMOVED":
                            case 3:
                                message.status = 3;
                                break;
                            }
                            switch (object.placeholderType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.placeholderType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.placeholderType = 1;
                                break;
                            case "SITELINK":
                            case 2:
                                message.placeholderType = 2;
                                break;
                            case "CALL":
                            case 3:
                                message.placeholderType = 3;
                                break;
                            case "APP":
                            case 4:
                                message.placeholderType = 4;
                                break;
                            case "LOCATION":
                            case 5:
                                message.placeholderType = 5;
                                break;
                            case "AFFILIATE_LOCATION":
                            case 6:
                                message.placeholderType = 6;
                                break;
                            case "CALLOUT":
                            case 7:
                                message.placeholderType = 7;
                                break;
                            case "STRUCTURED_SNIPPET":
                            case 8:
                                message.placeholderType = 8;
                                break;
                            case "MESSAGE":
                            case 9:
                                message.placeholderType = 9;
                                break;
                            case "PRICE":
                            case 10:
                                message.placeholderType = 10;
                                break;
                            case "PROMOTION":
                            case 11:
                                message.placeholderType = 11;
                                break;
                            case "AD_CUSTOMIZER":
                            case 12:
                                message.placeholderType = 12;
                                break;
                            case "DYNAMIC_EDUCATION":
                            case 13:
                                message.placeholderType = 13;
                                break;
                            case "DYNAMIC_FLIGHT":
                            case 14:
                                message.placeholderType = 14;
                                break;
                            case "DYNAMIC_CUSTOM":
                            case 15:
                                message.placeholderType = 15;
                                break;
                            case "DYNAMIC_HOTEL":
                            case 16:
                                message.placeholderType = 16;
                                break;
                            case "DYNAMIC_REAL_ESTATE":
                            case 17:
                                message.placeholderType = 17;
                                break;
                            case "DYNAMIC_TRAVEL":
                            case 18:
                                message.placeholderType = 18;
                                break;
                            case "DYNAMIC_LOCAL":
                            case 19:
                                message.placeholderType = 19;
                                break;
                            case "DYNAMIC_JOB":
                            case 20:
                                message.placeholderType = 20;
                                break;
                            }
                            switch (object.criterionType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.criterionType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.criterionType = 1;
                                break;
                            case "LOCATION_EXTENSION_TARGETING":
                            case 4:
                                message.criterionType = 4;
                                break;
                            case "DSA_PAGE_FEED":
                            case 3:
                                message.criterionType = 3;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a FeedMapping message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.FeedMapping
                         * @static
                         * @param {google.ads.googleads.v1.resources.FeedMapping} message FeedMapping
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedMapping.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.attributeFieldMappings = [];
                            if (options.defaults) {
                                object.resourceName = "";
                                object.feed = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.feed != null && message.hasOwnProperty("feed"))
                                object.feed = $root.google.protobuf.StringValue.toObject(message.feed, options);
                            if (message.placeholderType != null && message.hasOwnProperty("placeholderType")) {
                                object.placeholderType = options.enums === String ? $root.google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType[message.placeholderType] : message.placeholderType;
                                if (options.oneofs)
                                    object.target = "placeholderType";
                            }
                            if (message.criterionType != null && message.hasOwnProperty("criterionType")) {
                                object.criterionType = options.enums === String ? $root.google.ads.googleads.v1.enums.FeedMappingCriterionTypeEnum.FeedMappingCriterionType[message.criterionType] : message.criterionType;
                                if (options.oneofs)
                                    object.target = "criterionType";
                            }
                            if (message.attributeFieldMappings && message.attributeFieldMappings.length) {
                                object.attributeFieldMappings = [];
                                for (var j = 0; j < message.attributeFieldMappings.length; ++j)
                                    object.attributeFieldMappings[j] = $root.google.ads.googleads.v1.resources.AttributeFieldMapping.toObject(message.attributeFieldMappings[j], options);
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.FeedMappingStatusEnum.FeedMappingStatus[message.status] : message.status;
                            return object;
                        };

                        /**
                         * Converts this FeedMapping to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.FeedMapping
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedMapping.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return FeedMapping;
                    })();

                    resources.AttributeFieldMapping = (function() {

                        /**
                         * Properties of an AttributeFieldMapping.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IAttributeFieldMapping
                         * @property {google.protobuf.IInt64Value|null} [feedAttributeId] AttributeFieldMapping feedAttributeId
                         * @property {google.protobuf.IInt64Value|null} [fieldId] AttributeFieldMapping fieldId
                         * @property {google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum.SitelinkPlaceholderField|null} [sitelinkField] AttributeFieldMapping sitelinkField
                         * @property {google.ads.googleads.v1.enums.CallPlaceholderFieldEnum.CallPlaceholderField|null} [callField] AttributeFieldMapping callField
                         * @property {google.ads.googleads.v1.enums.AppPlaceholderFieldEnum.AppPlaceholderField|null} [appField] AttributeFieldMapping appField
                         * @property {google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum.LocationPlaceholderField|null} [locationField] AttributeFieldMapping locationField
                         * @property {google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum.AffiliateLocationPlaceholderField|null} [affiliateLocationField] AttributeFieldMapping affiliateLocationField
                         * @property {google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum.CalloutPlaceholderField|null} [calloutField] AttributeFieldMapping calloutField
                         * @property {google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum.StructuredSnippetPlaceholderField|null} [structuredSnippetField] AttributeFieldMapping structuredSnippetField
                         * @property {google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum.MessagePlaceholderField|null} [messageField] AttributeFieldMapping messageField
                         * @property {google.ads.googleads.v1.enums.PricePlaceholderFieldEnum.PricePlaceholderField|null} [priceField] AttributeFieldMapping priceField
                         * @property {google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum.PromotionPlaceholderField|null} [promotionField] AttributeFieldMapping promotionField
                         * @property {google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum.AdCustomizerPlaceholderField|null} [adCustomizerField] AttributeFieldMapping adCustomizerField
                         * @property {google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum.DsaPageFeedCriterionField|null} [dsaPageFeedField] AttributeFieldMapping dsaPageFeedField
                         * @property {google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum.LocationExtensionTargetingCriterionField|null} [locationExtensionTargetingField] AttributeFieldMapping locationExtensionTargetingField
                         * @property {google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum.EducationPlaceholderField|null} [educationField] AttributeFieldMapping educationField
                         * @property {google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum.FlightPlaceholderField|null} [flightField] AttributeFieldMapping flightField
                         * @property {google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum.CustomPlaceholderField|null} [customField] AttributeFieldMapping customField
                         * @property {google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum.HotelPlaceholderField|null} [hotelField] AttributeFieldMapping hotelField
                         * @property {google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum.RealEstatePlaceholderField|null} [realEstateField] AttributeFieldMapping realEstateField
                         * @property {google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum.TravelPlaceholderField|null} [travelField] AttributeFieldMapping travelField
                         * @property {google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum.LocalPlaceholderField|null} [localField] AttributeFieldMapping localField
                         * @property {google.ads.googleads.v1.enums.JobPlaceholderFieldEnum.JobPlaceholderField|null} [jobField] AttributeFieldMapping jobField
                         */

                        /**
                         * Constructs a new AttributeFieldMapping.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an AttributeFieldMapping.
                         * @implements IAttributeFieldMapping
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IAttributeFieldMapping=} [properties] Properties to set
                         */
                        function AttributeFieldMapping(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AttributeFieldMapping feedAttributeId.
                         * @member {google.protobuf.IInt64Value|null|undefined} feedAttributeId
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.feedAttributeId = null;

                        /**
                         * AttributeFieldMapping fieldId.
                         * @member {google.protobuf.IInt64Value|null|undefined} fieldId
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.fieldId = null;

                        /**
                         * AttributeFieldMapping sitelinkField.
                         * @member {google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum.SitelinkPlaceholderField} sitelinkField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.sitelinkField = 0;

                        /**
                         * AttributeFieldMapping callField.
                         * @member {google.ads.googleads.v1.enums.CallPlaceholderFieldEnum.CallPlaceholderField} callField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.callField = 0;

                        /**
                         * AttributeFieldMapping appField.
                         * @member {google.ads.googleads.v1.enums.AppPlaceholderFieldEnum.AppPlaceholderField} appField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.appField = 0;

                        /**
                         * AttributeFieldMapping locationField.
                         * @member {google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum.LocationPlaceholderField} locationField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.locationField = 0;

                        /**
                         * AttributeFieldMapping affiliateLocationField.
                         * @member {google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum.AffiliateLocationPlaceholderField} affiliateLocationField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.affiliateLocationField = 0;

                        /**
                         * AttributeFieldMapping calloutField.
                         * @member {google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum.CalloutPlaceholderField} calloutField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.calloutField = 0;

                        /**
                         * AttributeFieldMapping structuredSnippetField.
                         * @member {google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum.StructuredSnippetPlaceholderField} structuredSnippetField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.structuredSnippetField = 0;

                        /**
                         * AttributeFieldMapping messageField.
                         * @member {google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum.MessagePlaceholderField} messageField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.messageField = 0;

                        /**
                         * AttributeFieldMapping priceField.
                         * @member {google.ads.googleads.v1.enums.PricePlaceholderFieldEnum.PricePlaceholderField} priceField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.priceField = 0;

                        /**
                         * AttributeFieldMapping promotionField.
                         * @member {google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum.PromotionPlaceholderField} promotionField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.promotionField = 0;

                        /**
                         * AttributeFieldMapping adCustomizerField.
                         * @member {google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum.AdCustomizerPlaceholderField} adCustomizerField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.adCustomizerField = 0;

                        /**
                         * AttributeFieldMapping dsaPageFeedField.
                         * @member {google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum.DsaPageFeedCriterionField} dsaPageFeedField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.dsaPageFeedField = 0;

                        /**
                         * AttributeFieldMapping locationExtensionTargetingField.
                         * @member {google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum.LocationExtensionTargetingCriterionField} locationExtensionTargetingField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.locationExtensionTargetingField = 0;

                        /**
                         * AttributeFieldMapping educationField.
                         * @member {google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum.EducationPlaceholderField} educationField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.educationField = 0;

                        /**
                         * AttributeFieldMapping flightField.
                         * @member {google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum.FlightPlaceholderField} flightField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.flightField = 0;

                        /**
                         * AttributeFieldMapping customField.
                         * @member {google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum.CustomPlaceholderField} customField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.customField = 0;

                        /**
                         * AttributeFieldMapping hotelField.
                         * @member {google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum.HotelPlaceholderField} hotelField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.hotelField = 0;

                        /**
                         * AttributeFieldMapping realEstateField.
                         * @member {google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum.RealEstatePlaceholderField} realEstateField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.realEstateField = 0;

                        /**
                         * AttributeFieldMapping travelField.
                         * @member {google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum.TravelPlaceholderField} travelField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.travelField = 0;

                        /**
                         * AttributeFieldMapping localField.
                         * @member {google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum.LocalPlaceholderField} localField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.localField = 0;

                        /**
                         * AttributeFieldMapping jobField.
                         * @member {google.ads.googleads.v1.enums.JobPlaceholderFieldEnum.JobPlaceholderField} jobField
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        AttributeFieldMapping.prototype.jobField = 0;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AttributeFieldMapping field.
                         * @member {"sitelinkField"|"callField"|"appField"|"locationField"|"affiliateLocationField"|"calloutField"|"structuredSnippetField"|"messageField"|"priceField"|"promotionField"|"adCustomizerField"|"dsaPageFeedField"|"locationExtensionTargetingField"|"educationField"|"flightField"|"customField"|"hotelField"|"realEstateField"|"travelField"|"localField"|"jobField"|undefined} field
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         */
                        Object.defineProperty(AttributeFieldMapping.prototype, "field", {
                            get: $util.oneOfGetter($oneOfFields = ["sitelinkField", "callField", "appField", "locationField", "affiliateLocationField", "calloutField", "structuredSnippetField", "messageField", "priceField", "promotionField", "adCustomizerField", "dsaPageFeedField", "locationExtensionTargetingField", "educationField", "flightField", "customField", "hotelField", "realEstateField", "travelField", "localField", "jobField"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AttributeFieldMapping instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAttributeFieldMapping=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.AttributeFieldMapping} AttributeFieldMapping instance
                         */
                        AttributeFieldMapping.create = function create(properties) {
                            return new AttributeFieldMapping(properties);
                        };

                        /**
                         * Encodes the specified AttributeFieldMapping message. Does not implicitly {@link google.ads.googleads.v1.resources.AttributeFieldMapping.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAttributeFieldMapping} message AttributeFieldMapping message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AttributeFieldMapping.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.feedAttributeId != null && message.hasOwnProperty("feedAttributeId"))
                                $root.google.protobuf.Int64Value.encode(message.feedAttributeId, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.fieldId != null && message.hasOwnProperty("fieldId"))
                                $root.google.protobuf.Int64Value.encode(message.fieldId, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.sitelinkField != null && message.hasOwnProperty("sitelinkField"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.sitelinkField);
                            if (message.callField != null && message.hasOwnProperty("callField"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.callField);
                            if (message.appField != null && message.hasOwnProperty("appField"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.appField);
                            if (message.locationField != null && message.hasOwnProperty("locationField"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.locationField);
                            if (message.affiliateLocationField != null && message.hasOwnProperty("affiliateLocationField"))
                                writer.uint32(/* id 7, wireType 0 =*/56).int32(message.affiliateLocationField);
                            if (message.calloutField != null && message.hasOwnProperty("calloutField"))
                                writer.uint32(/* id 8, wireType 0 =*/64).int32(message.calloutField);
                            if (message.structuredSnippetField != null && message.hasOwnProperty("structuredSnippetField"))
                                writer.uint32(/* id 9, wireType 0 =*/72).int32(message.structuredSnippetField);
                            if (message.messageField != null && message.hasOwnProperty("messageField"))
                                writer.uint32(/* id 10, wireType 0 =*/80).int32(message.messageField);
                            if (message.priceField != null && message.hasOwnProperty("priceField"))
                                writer.uint32(/* id 11, wireType 0 =*/88).int32(message.priceField);
                            if (message.promotionField != null && message.hasOwnProperty("promotionField"))
                                writer.uint32(/* id 12, wireType 0 =*/96).int32(message.promotionField);
                            if (message.adCustomizerField != null && message.hasOwnProperty("adCustomizerField"))
                                writer.uint32(/* id 13, wireType 0 =*/104).int32(message.adCustomizerField);
                            if (message.dsaPageFeedField != null && message.hasOwnProperty("dsaPageFeedField"))
                                writer.uint32(/* id 14, wireType 0 =*/112).int32(message.dsaPageFeedField);
                            if (message.locationExtensionTargetingField != null && message.hasOwnProperty("locationExtensionTargetingField"))
                                writer.uint32(/* id 15, wireType 0 =*/120).int32(message.locationExtensionTargetingField);
                            if (message.educationField != null && message.hasOwnProperty("educationField"))
                                writer.uint32(/* id 16, wireType 0 =*/128).int32(message.educationField);
                            if (message.flightField != null && message.hasOwnProperty("flightField"))
                                writer.uint32(/* id 17, wireType 0 =*/136).int32(message.flightField);
                            if (message.customField != null && message.hasOwnProperty("customField"))
                                writer.uint32(/* id 18, wireType 0 =*/144).int32(message.customField);
                            if (message.hotelField != null && message.hasOwnProperty("hotelField"))
                                writer.uint32(/* id 19, wireType 0 =*/152).int32(message.hotelField);
                            if (message.realEstateField != null && message.hasOwnProperty("realEstateField"))
                                writer.uint32(/* id 20, wireType 0 =*/160).int32(message.realEstateField);
                            if (message.travelField != null && message.hasOwnProperty("travelField"))
                                writer.uint32(/* id 21, wireType 0 =*/168).int32(message.travelField);
                            if (message.localField != null && message.hasOwnProperty("localField"))
                                writer.uint32(/* id 22, wireType 0 =*/176).int32(message.localField);
                            if (message.jobField != null && message.hasOwnProperty("jobField"))
                                writer.uint32(/* id 23, wireType 0 =*/184).int32(message.jobField);
                            return writer;
                        };

                        /**
                         * Encodes the specified AttributeFieldMapping message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.AttributeFieldMapping.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @static
                         * @param {google.ads.googleads.v1.resources.IAttributeFieldMapping} message AttributeFieldMapping message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AttributeFieldMapping.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AttributeFieldMapping message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.AttributeFieldMapping} AttributeFieldMapping
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AttributeFieldMapping.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.AttributeFieldMapping();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.feedAttributeId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.fieldId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.sitelinkField = reader.int32();
                                    break;
                                case 4:
                                    message.callField = reader.int32();
                                    break;
                                case 5:
                                    message.appField = reader.int32();
                                    break;
                                case 6:
                                    message.locationField = reader.int32();
                                    break;
                                case 7:
                                    message.affiliateLocationField = reader.int32();
                                    break;
                                case 8:
                                    message.calloutField = reader.int32();
                                    break;
                                case 9:
                                    message.structuredSnippetField = reader.int32();
                                    break;
                                case 10:
                                    message.messageField = reader.int32();
                                    break;
                                case 11:
                                    message.priceField = reader.int32();
                                    break;
                                case 12:
                                    message.promotionField = reader.int32();
                                    break;
                                case 13:
                                    message.adCustomizerField = reader.int32();
                                    break;
                                case 14:
                                    message.dsaPageFeedField = reader.int32();
                                    break;
                                case 15:
                                    message.locationExtensionTargetingField = reader.int32();
                                    break;
                                case 16:
                                    message.educationField = reader.int32();
                                    break;
                                case 17:
                                    message.flightField = reader.int32();
                                    break;
                                case 18:
                                    message.customField = reader.int32();
                                    break;
                                case 19:
                                    message.hotelField = reader.int32();
                                    break;
                                case 20:
                                    message.realEstateField = reader.int32();
                                    break;
                                case 21:
                                    message.travelField = reader.int32();
                                    break;
                                case 22:
                                    message.localField = reader.int32();
                                    break;
                                case 23:
                                    message.jobField = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AttributeFieldMapping message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.AttributeFieldMapping} AttributeFieldMapping
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AttributeFieldMapping.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AttributeFieldMapping message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AttributeFieldMapping.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.feedAttributeId != null && message.hasOwnProperty("feedAttributeId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.feedAttributeId);
                                if (error)
                                    return "feedAttributeId." + error;
                            }
                            if (message.fieldId != null && message.hasOwnProperty("fieldId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.fieldId);
                                if (error)
                                    return "fieldId." + error;
                            }
                            if (message.sitelinkField != null && message.hasOwnProperty("sitelinkField")) {
                                properties.field = 1;
                                switch (message.sitelinkField) {
                                default:
                                    return "sitelinkField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                    break;
                                }
                            }
                            if (message.callField != null && message.hasOwnProperty("callField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.callField) {
                                default:
                                    return "callField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            }
                            if (message.appField != null && message.hasOwnProperty("appField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.appField) {
                                default:
                                    return "appField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                    break;
                                }
                            }
                            if (message.locationField != null && message.hasOwnProperty("locationField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.locationField) {
                                default:
                                    return "locationField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                    break;
                                }
                            }
                            if (message.affiliateLocationField != null && message.hasOwnProperty("affiliateLocationField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.affiliateLocationField) {
                                default:
                                    return "affiliateLocationField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                    break;
                                }
                            }
                            if (message.calloutField != null && message.hasOwnProperty("calloutField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.calloutField) {
                                default:
                                    return "calloutField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            }
                            if (message.structuredSnippetField != null && message.hasOwnProperty("structuredSnippetField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.structuredSnippetField) {
                                default:
                                    return "structuredSnippetField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.messageField != null && message.hasOwnProperty("messageField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.messageField) {
                                default:
                                    return "messageField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            }
                            if (message.priceField != null && message.hasOwnProperty("priceField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.priceField) {
                                default:
                                    return "priceField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 100:
                                case 101:
                                case 102:
                                case 103:
                                case 104:
                                case 105:
                                case 200:
                                case 201:
                                case 202:
                                case 203:
                                case 204:
                                case 205:
                                case 300:
                                case 301:
                                case 302:
                                case 303:
                                case 304:
                                case 305:
                                case 400:
                                case 401:
                                case 402:
                                case 403:
                                case 404:
                                case 405:
                                case 500:
                                case 501:
                                case 502:
                                case 503:
                                case 504:
                                case 505:
                                case 600:
                                case 601:
                                case 602:
                                case 603:
                                case 604:
                                case 605:
                                case 700:
                                case 701:
                                case 702:
                                case 703:
                                case 704:
                                case 705:
                                case 800:
                                case 801:
                                case 802:
                                case 803:
                                case 804:
                                case 805:
                                    break;
                                }
                            }
                            if (message.promotionField != null && message.hasOwnProperty("promotionField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.promotionField) {
                                default:
                                    return "promotionField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                    break;
                                }
                            }
                            if (message.adCustomizerField != null && message.hasOwnProperty("adCustomizerField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.adCustomizerField) {
                                default:
                                    return "adCustomizerField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            }
                            if (message.dsaPageFeedField != null && message.hasOwnProperty("dsaPageFeedField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.dsaPageFeedField) {
                                default:
                                    return "dsaPageFeedField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            }
                            if (message.locationExtensionTargetingField != null && message.hasOwnProperty("locationExtensionTargetingField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.locationExtensionTargetingField) {
                                default:
                                    return "locationExtensionTargetingField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            }
                            if (message.educationField != null && message.hasOwnProperty("educationField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.educationField) {
                                default:
                                    return "educationField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                    break;
                                }
                            }
                            if (message.flightField != null && message.hasOwnProperty("flightField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.flightField) {
                                default:
                                    return "flightField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                    break;
                                }
                            }
                            if (message.customField != null && message.hasOwnProperty("customField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.customField) {
                                default:
                                    return "customField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                    break;
                                }
                            }
                            if (message.hotelField != null && message.hasOwnProperty("hotelField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.hotelField) {
                                default:
                                    return "hotelField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                    break;
                                }
                            }
                            if (message.realEstateField != null && message.hasOwnProperty("realEstateField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.realEstateField) {
                                default:
                                    return "realEstateField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                    break;
                                }
                            }
                            if (message.travelField != null && message.hasOwnProperty("travelField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.travelField) {
                                default:
                                    return "travelField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                    break;
                                }
                            }
                            if (message.localField != null && message.hasOwnProperty("localField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.localField) {
                                default:
                                    return "localField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                    break;
                                }
                            }
                            if (message.jobField != null && message.hasOwnProperty("jobField")) {
                                if (properties.field === 1)
                                    return "field: multiple values";
                                properties.field = 1;
                                switch (message.jobField) {
                                default:
                                    return "jobField: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                    break;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an AttributeFieldMapping message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.AttributeFieldMapping} AttributeFieldMapping
                         */
                        AttributeFieldMapping.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.AttributeFieldMapping)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.AttributeFieldMapping();
                            if (object.feedAttributeId != null) {
                                if (typeof object.feedAttributeId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AttributeFieldMapping.feedAttributeId: object expected");
                                message.feedAttributeId = $root.google.protobuf.Int64Value.fromObject(object.feedAttributeId);
                            }
                            if (object.fieldId != null) {
                                if (typeof object.fieldId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.AttributeFieldMapping.fieldId: object expected");
                                message.fieldId = $root.google.protobuf.Int64Value.fromObject(object.fieldId);
                            }
                            switch (object.sitelinkField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.sitelinkField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.sitelinkField = 1;
                                break;
                            case "TEXT":
                            case 2:
                                message.sitelinkField = 2;
                                break;
                            case "LINE_1":
                            case 3:
                                message.sitelinkField = 3;
                                break;
                            case "LINE_2":
                            case 4:
                                message.sitelinkField = 4;
                                break;
                            case "FINAL_URLS":
                            case 5:
                                message.sitelinkField = 5;
                                break;
                            case "FINAL_MOBILE_URLS":
                            case 6:
                                message.sitelinkField = 6;
                                break;
                            case "TRACKING_URL":
                            case 7:
                                message.sitelinkField = 7;
                                break;
                            case "FINAL_URL_SUFFIX":
                            case 8:
                                message.sitelinkField = 8;
                                break;
                            }
                            switch (object.callField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.callField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.callField = 1;
                                break;
                            case "PHONE_NUMBER":
                            case 2:
                                message.callField = 2;
                                break;
                            case "COUNTRY_CODE":
                            case 3:
                                message.callField = 3;
                                break;
                            case "TRACKED":
                            case 4:
                                message.callField = 4;
                                break;
                            case "CONVERSION_TYPE_ID":
                            case 5:
                                message.callField = 5;
                                break;
                            case "CONVERSION_REPORTING_STATE":
                            case 6:
                                message.callField = 6;
                                break;
                            }
                            switch (object.appField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.appField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.appField = 1;
                                break;
                            case "STORE":
                            case 2:
                                message.appField = 2;
                                break;
                            case "ID":
                            case 3:
                                message.appField = 3;
                                break;
                            case "LINK_TEXT":
                            case 4:
                                message.appField = 4;
                                break;
                            case "URL":
                            case 5:
                                message.appField = 5;
                                break;
                            case "FINAL_URLS":
                            case 6:
                                message.appField = 6;
                                break;
                            case "FINAL_MOBILE_URLS":
                            case 7:
                                message.appField = 7;
                                break;
                            case "TRACKING_URL":
                            case 8:
                                message.appField = 8;
                                break;
                            case "FINAL_URL_SUFFIX":
                            case 9:
                                message.appField = 9;
                                break;
                            }
                            switch (object.locationField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.locationField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.locationField = 1;
                                break;
                            case "BUSINESS_NAME":
                            case 2:
                                message.locationField = 2;
                                break;
                            case "ADDRESS_LINE_1":
                            case 3:
                                message.locationField = 3;
                                break;
                            case "ADDRESS_LINE_2":
                            case 4:
                                message.locationField = 4;
                                break;
                            case "CITY":
                            case 5:
                                message.locationField = 5;
                                break;
                            case "PROVINCE":
                            case 6:
                                message.locationField = 6;
                                break;
                            case "POSTAL_CODE":
                            case 7:
                                message.locationField = 7;
                                break;
                            case "COUNTRY_CODE":
                            case 8:
                                message.locationField = 8;
                                break;
                            case "PHONE_NUMBER":
                            case 9:
                                message.locationField = 9;
                                break;
                            }
                            switch (object.affiliateLocationField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.affiliateLocationField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.affiliateLocationField = 1;
                                break;
                            case "BUSINESS_NAME":
                            case 2:
                                message.affiliateLocationField = 2;
                                break;
                            case "ADDRESS_LINE_1":
                            case 3:
                                message.affiliateLocationField = 3;
                                break;
                            case "ADDRESS_LINE_2":
                            case 4:
                                message.affiliateLocationField = 4;
                                break;
                            case "CITY":
                            case 5:
                                message.affiliateLocationField = 5;
                                break;
                            case "PROVINCE":
                            case 6:
                                message.affiliateLocationField = 6;
                                break;
                            case "POSTAL_CODE":
                            case 7:
                                message.affiliateLocationField = 7;
                                break;
                            case "COUNTRY_CODE":
                            case 8:
                                message.affiliateLocationField = 8;
                                break;
                            case "PHONE_NUMBER":
                            case 9:
                                message.affiliateLocationField = 9;
                                break;
                            case "LANGUAGE_CODE":
                            case 10:
                                message.affiliateLocationField = 10;
                                break;
                            case "CHAIN_ID":
                            case 11:
                                message.affiliateLocationField = 11;
                                break;
                            case "CHAIN_NAME":
                            case 12:
                                message.affiliateLocationField = 12;
                                break;
                            }
                            switch (object.calloutField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.calloutField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.calloutField = 1;
                                break;
                            case "CALLOUT_TEXT":
                            case 2:
                                message.calloutField = 2;
                                break;
                            }
                            switch (object.structuredSnippetField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.structuredSnippetField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.structuredSnippetField = 1;
                                break;
                            case "HEADER":
                            case 2:
                                message.structuredSnippetField = 2;
                                break;
                            case "SNIPPETS":
                            case 3:
                                message.structuredSnippetField = 3;
                                break;
                            }
                            switch (object.messageField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.messageField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.messageField = 1;
                                break;
                            case "BUSINESS_NAME":
                            case 2:
                                message.messageField = 2;
                                break;
                            case "COUNTRY_CODE":
                            case 3:
                                message.messageField = 3;
                                break;
                            case "PHONE_NUMBER":
                            case 4:
                                message.messageField = 4;
                                break;
                            case "MESSAGE_EXTENSION_TEXT":
                            case 5:
                                message.messageField = 5;
                                break;
                            case "MESSAGE_TEXT":
                            case 6:
                                message.messageField = 6;
                                break;
                            }
                            switch (object.priceField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.priceField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.priceField = 1;
                                break;
                            case "TYPE":
                            case 2:
                                message.priceField = 2;
                                break;
                            case "PRICE_QUALIFIER":
                            case 3:
                                message.priceField = 3;
                                break;
                            case "TRACKING_TEMPLATE":
                            case 4:
                                message.priceField = 4;
                                break;
                            case "LANGUAGE":
                            case 5:
                                message.priceField = 5;
                                break;
                            case "FINAL_URL_SUFFIX":
                            case 6:
                                message.priceField = 6;
                                break;
                            case "ITEM_1_HEADER":
                            case 100:
                                message.priceField = 100;
                                break;
                            case "ITEM_1_DESCRIPTION":
                            case 101:
                                message.priceField = 101;
                                break;
                            case "ITEM_1_PRICE":
                            case 102:
                                message.priceField = 102;
                                break;
                            case "ITEM_1_UNIT":
                            case 103:
                                message.priceField = 103;
                                break;
                            case "ITEM_1_FINAL_URLS":
                            case 104:
                                message.priceField = 104;
                                break;
                            case "ITEM_1_FINAL_MOBILE_URLS":
                            case 105:
                                message.priceField = 105;
                                break;
                            case "ITEM_2_HEADER":
                            case 200:
                                message.priceField = 200;
                                break;
                            case "ITEM_2_DESCRIPTION":
                            case 201:
                                message.priceField = 201;
                                break;
                            case "ITEM_2_PRICE":
                            case 202:
                                message.priceField = 202;
                                break;
                            case "ITEM_2_UNIT":
                            case 203:
                                message.priceField = 203;
                                break;
                            case "ITEM_2_FINAL_URLS":
                            case 204:
                                message.priceField = 204;
                                break;
                            case "ITEM_2_FINAL_MOBILE_URLS":
                            case 205:
                                message.priceField = 205;
                                break;
                            case "ITEM_3_HEADER":
                            case 300:
                                message.priceField = 300;
                                break;
                            case "ITEM_3_DESCRIPTION":
                            case 301:
                                message.priceField = 301;
                                break;
                            case "ITEM_3_PRICE":
                            case 302:
                                message.priceField = 302;
                                break;
                            case "ITEM_3_UNIT":
                            case 303:
                                message.priceField = 303;
                                break;
                            case "ITEM_3_FINAL_URLS":
                            case 304:
                                message.priceField = 304;
                                break;
                            case "ITEM_3_FINAL_MOBILE_URLS":
                            case 305:
                                message.priceField = 305;
                                break;
                            case "ITEM_4_HEADER":
                            case 400:
                                message.priceField = 400;
                                break;
                            case "ITEM_4_DESCRIPTION":
                            case 401:
                                message.priceField = 401;
                                break;
                            case "ITEM_4_PRICE":
                            case 402:
                                message.priceField = 402;
                                break;
                            case "ITEM_4_UNIT":
                            case 403:
                                message.priceField = 403;
                                break;
                            case "ITEM_4_FINAL_URLS":
                            case 404:
                                message.priceField = 404;
                                break;
                            case "ITEM_4_FINAL_MOBILE_URLS":
                            case 405:
                                message.priceField = 405;
                                break;
                            case "ITEM_5_HEADER":
                            case 500:
                                message.priceField = 500;
                                break;
                            case "ITEM_5_DESCRIPTION":
                            case 501:
                                message.priceField = 501;
                                break;
                            case "ITEM_5_PRICE":
                            case 502:
                                message.priceField = 502;
                                break;
                            case "ITEM_5_UNIT":
                            case 503:
                                message.priceField = 503;
                                break;
                            case "ITEM_5_FINAL_URLS":
                            case 504:
                                message.priceField = 504;
                                break;
                            case "ITEM_5_FINAL_MOBILE_URLS":
                            case 505:
                                message.priceField = 505;
                                break;
                            case "ITEM_6_HEADER":
                            case 600:
                                message.priceField = 600;
                                break;
                            case "ITEM_6_DESCRIPTION":
                            case 601:
                                message.priceField = 601;
                                break;
                            case "ITEM_6_PRICE":
                            case 602:
                                message.priceField = 602;
                                break;
                            case "ITEM_6_UNIT":
                            case 603:
                                message.priceField = 603;
                                break;
                            case "ITEM_6_FINAL_URLS":
                            case 604:
                                message.priceField = 604;
                                break;
                            case "ITEM_6_FINAL_MOBILE_URLS":
                            case 605:
                                message.priceField = 605;
                                break;
                            case "ITEM_7_HEADER":
                            case 700:
                                message.priceField = 700;
                                break;
                            case "ITEM_7_DESCRIPTION":
                            case 701:
                                message.priceField = 701;
                                break;
                            case "ITEM_7_PRICE":
                            case 702:
                                message.priceField = 702;
                                break;
                            case "ITEM_7_UNIT":
                            case 703:
                                message.priceField = 703;
                                break;
                            case "ITEM_7_FINAL_URLS":
                            case 704:
                                message.priceField = 704;
                                break;
                            case "ITEM_7_FINAL_MOBILE_URLS":
                            case 705:
                                message.priceField = 705;
                                break;
                            case "ITEM_8_HEADER":
                            case 800:
                                message.priceField = 800;
                                break;
                            case "ITEM_8_DESCRIPTION":
                            case 801:
                                message.priceField = 801;
                                break;
                            case "ITEM_8_PRICE":
                            case 802:
                                message.priceField = 802;
                                break;
                            case "ITEM_8_UNIT":
                            case 803:
                                message.priceField = 803;
                                break;
                            case "ITEM_8_FINAL_URLS":
                            case 804:
                                message.priceField = 804;
                                break;
                            case "ITEM_8_FINAL_MOBILE_URLS":
                            case 805:
                                message.priceField = 805;
                                break;
                            }
                            switch (object.promotionField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.promotionField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.promotionField = 1;
                                break;
                            case "PROMOTION_TARGET":
                            case 2:
                                message.promotionField = 2;
                                break;
                            case "DISCOUNT_MODIFIER":
                            case 3:
                                message.promotionField = 3;
                                break;
                            case "PERCENT_OFF":
                            case 4:
                                message.promotionField = 4;
                                break;
                            case "MONEY_AMOUNT_OFF":
                            case 5:
                                message.promotionField = 5;
                                break;
                            case "PROMOTION_CODE":
                            case 6:
                                message.promotionField = 6;
                                break;
                            case "ORDERS_OVER_AMOUNT":
                            case 7:
                                message.promotionField = 7;
                                break;
                            case "PROMOTION_START":
                            case 8:
                                message.promotionField = 8;
                                break;
                            case "PROMOTION_END":
                            case 9:
                                message.promotionField = 9;
                                break;
                            case "OCCASION":
                            case 10:
                                message.promotionField = 10;
                                break;
                            case "FINAL_URLS":
                            case 11:
                                message.promotionField = 11;
                                break;
                            case "FINAL_MOBILE_URLS":
                            case 12:
                                message.promotionField = 12;
                                break;
                            case "TRACKING_URL":
                            case 13:
                                message.promotionField = 13;
                                break;
                            case "LANGUAGE":
                            case 14:
                                message.promotionField = 14;
                                break;
                            case "FINAL_URL_SUFFIX":
                            case 15:
                                message.promotionField = 15;
                                break;
                            }
                            switch (object.adCustomizerField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.adCustomizerField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.adCustomizerField = 1;
                                break;
                            case "INTEGER":
                            case 2:
                                message.adCustomizerField = 2;
                                break;
                            case "PRICE":
                            case 3:
                                message.adCustomizerField = 3;
                                break;
                            case "DATE":
                            case 4:
                                message.adCustomizerField = 4;
                                break;
                            case "STRING":
                            case 5:
                                message.adCustomizerField = 5;
                                break;
                            }
                            switch (object.dsaPageFeedField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.dsaPageFeedField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.dsaPageFeedField = 1;
                                break;
                            case "PAGE_URL":
                            case 2:
                                message.dsaPageFeedField = 2;
                                break;
                            case "LABEL":
                            case 3:
                                message.dsaPageFeedField = 3;
                                break;
                            }
                            switch (object.locationExtensionTargetingField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.locationExtensionTargetingField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.locationExtensionTargetingField = 1;
                                break;
                            case "ADDRESS_LINE_1":
                            case 2:
                                message.locationExtensionTargetingField = 2;
                                break;
                            case "ADDRESS_LINE_2":
                            case 3:
                                message.locationExtensionTargetingField = 3;
                                break;
                            case "CITY":
                            case 4:
                                message.locationExtensionTargetingField = 4;
                                break;
                            case "PROVINCE":
                            case 5:
                                message.locationExtensionTargetingField = 5;
                                break;
                            case "POSTAL_CODE":
                            case 6:
                                message.locationExtensionTargetingField = 6;
                                break;
                            case "COUNTRY_CODE":
                            case 7:
                                message.locationExtensionTargetingField = 7;
                                break;
                            }
                            switch (object.educationField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.educationField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.educationField = 1;
                                break;
                            case "PROGRAM_ID":
                            case 2:
                                message.educationField = 2;
                                break;
                            case "LOCATION_ID":
                            case 3:
                                message.educationField = 3;
                                break;
                            case "PROGRAM_NAME":
                            case 4:
                                message.educationField = 4;
                                break;
                            case "AREA_OF_STUDY":
                            case 5:
                                message.educationField = 5;
                                break;
                            case "PROGRAM_DESCRIPTION":
                            case 6:
                                message.educationField = 6;
                                break;
                            case "SCHOOL_NAME":
                            case 7:
                                message.educationField = 7;
                                break;
                            case "ADDRESS":
                            case 8:
                                message.educationField = 8;
                                break;
                            case "THUMBNAIL_IMAGE_URL":
                            case 9:
                                message.educationField = 9;
                                break;
                            case "ALTERNATIVE_THUMBNAIL_IMAGE_URL":
                            case 10:
                                message.educationField = 10;
                                break;
                            case "FINAL_URLS":
                            case 11:
                                message.educationField = 11;
                                break;
                            case "FINAL_MOBILE_URLS":
                            case 12:
                                message.educationField = 12;
                                break;
                            case "TRACKING_URL":
                            case 13:
                                message.educationField = 13;
                                break;
                            case "CONTEXTUAL_KEYWORDS":
                            case 14:
                                message.educationField = 14;
                                break;
                            case "ANDROID_APP_LINK":
                            case 15:
                                message.educationField = 15;
                                break;
                            case "SIMILAR_PROGRAM_IDS":
                            case 16:
                                message.educationField = 16;
                                break;
                            case "IOS_APP_LINK":
                            case 17:
                                message.educationField = 17;
                                break;
                            case "IOS_APP_STORE_ID":
                            case 18:
                                message.educationField = 18;
                                break;
                            }
                            switch (object.flightField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.flightField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.flightField = 1;
                                break;
                            case "DESTINATION_ID":
                            case 2:
                                message.flightField = 2;
                                break;
                            case "ORIGIN_ID":
                            case 3:
                                message.flightField = 3;
                                break;
                            case "FLIGHT_DESCRIPTION":
                            case 4:
                                message.flightField = 4;
                                break;
                            case "ORIGIN_NAME":
                            case 5:
                                message.flightField = 5;
                                break;
                            case "DESTINATION_NAME":
                            case 6:
                                message.flightField = 6;
                                break;
                            case "FLIGHT_PRICE":
                            case 7:
                                message.flightField = 7;
                                break;
                            case "FORMATTED_PRICE":
                            case 8:
                                message.flightField = 8;
                                break;
                            case "FLIGHT_SALE_PRICE":
                            case 9:
                                message.flightField = 9;
                                break;
                            case "FORMATTED_SALE_PRICE":
                            case 10:
                                message.flightField = 10;
                                break;
                            case "IMAGE_URL":
                            case 11:
                                message.flightField = 11;
                                break;
                            case "FINAL_URLS":
                            case 12:
                                message.flightField = 12;
                                break;
                            case "FINAL_MOBILE_URLS":
                            case 13:
                                message.flightField = 13;
                                break;
                            case "TRACKING_URL":
                            case 14:
                                message.flightField = 14;
                                break;
                            case "ANDROID_APP_LINK":
                            case 15:
                                message.flightField = 15;
                                break;
                            case "SIMILAR_DESTINATION_IDS":
                            case 16:
                                message.flightField = 16;
                                break;
                            case "IOS_APP_LINK":
                            case 17:
                                message.flightField = 17;
                                break;
                            case "IOS_APP_STORE_ID":
                            case 18:
                                message.flightField = 18;
                                break;
                            }
                            switch (object.customField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.customField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.customField = 1;
                                break;
                            case "ID":
                            case 2:
                                message.customField = 2;
                                break;
                            case "ID2":
                            case 3:
                                message.customField = 3;
                                break;
                            case "ITEM_TITLE":
                            case 4:
                                message.customField = 4;
                                break;
                            case "ITEM_SUBTITLE":
                            case 5:
                                message.customField = 5;
                                break;
                            case "ITEM_DESCRIPTION":
                            case 6:
                                message.customField = 6;
                                break;
                            case "ITEM_ADDRESS":
                            case 7:
                                message.customField = 7;
                                break;
                            case "PRICE":
                            case 8:
                                message.customField = 8;
                                break;
                            case "FORMATTED_PRICE":
                            case 9:
                                message.customField = 9;
                                break;
                            case "SALE_PRICE":
                            case 10:
                                message.customField = 10;
                                break;
                            case "FORMATTED_SALE_PRICE":
                            case 11:
                                message.customField = 11;
                                break;
                            case "IMAGE_URL":
                            case 12:
                                message.customField = 12;
                                break;
                            case "ITEM_CATEGORY":
                            case 13:
                                message.customField = 13;
                                break;
                            case "FINAL_URLS":
                            case 14:
                                message.customField = 14;
                                break;
                            case "FINAL_MOBILE_URLS":
                            case 15:
                                message.customField = 15;
                                break;
                            case "TRACKING_URL":
                            case 16:
                                message.customField = 16;
                                break;
                            case "CONTEXTUAL_KEYWORDS":
                            case 17:
                                message.customField = 17;
                                break;
                            case "ANDROID_APP_LINK":
                            case 18:
                                message.customField = 18;
                                break;
                            case "SIMILAR_IDS":
                            case 19:
                                message.customField = 19;
                                break;
                            case "IOS_APP_LINK":
                            case 20:
                                message.customField = 20;
                                break;
                            case "IOS_APP_STORE_ID":
                            case 21:
                                message.customField = 21;
                                break;
                            }
                            switch (object.hotelField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.hotelField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.hotelField = 1;
                                break;
                            case "PROPERTY_ID":
                            case 2:
                                message.hotelField = 2;
                                break;
                            case "PROPERTY_NAME":
                            case 3:
                                message.hotelField = 3;
                                break;
                            case "DESTINATION_NAME":
                            case 4:
                                message.hotelField = 4;
                                break;
                            case "DESCRIPTION":
                            case 5:
                                message.hotelField = 5;
                                break;
                            case "ADDRESS":
                            case 6:
                                message.hotelField = 6;
                                break;
                            case "PRICE":
                            case 7:
                                message.hotelField = 7;
                                break;
                            case "FORMATTED_PRICE":
                            case 8:
                                message.hotelField = 8;
                                break;
                            case "SALE_PRICE":
                            case 9:
                                message.hotelField = 9;
                                break;
                            case "FORMATTED_SALE_PRICE":
                            case 10:
                                message.hotelField = 10;
                                break;
                            case "IMAGE_URL":
                            case 11:
                                message.hotelField = 11;
                                break;
                            case "CATEGORY":
                            case 12:
                                message.hotelField = 12;
                                break;
                            case "STAR_RATING":
                            case 13:
                                message.hotelField = 13;
                                break;
                            case "CONTEXTUAL_KEYWORDS":
                            case 14:
                                message.hotelField = 14;
                                break;
                            case "FINAL_URLS":
                            case 15:
                                message.hotelField = 15;
                                break;
                            case "FINAL_MOBILE_URLS":
                            case 16:
                                message.hotelField = 16;
                                break;
                            case "TRACKING_URL":
                            case 17:
                                message.hotelField = 17;
                                break;
                            case "ANDROID_APP_LINK":
                            case 18:
                                message.hotelField = 18;
                                break;
                            case "SIMILAR_PROPERTY_IDS":
                            case 19:
                                message.hotelField = 19;
                                break;
                            case "IOS_APP_LINK":
                            case 20:
                                message.hotelField = 20;
                                break;
                            case "IOS_APP_STORE_ID":
                            case 21:
                                message.hotelField = 21;
                                break;
                            }
                            switch (object.realEstateField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.realEstateField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.realEstateField = 1;
                                break;
                            case "LISTING_ID":
                            case 2:
                                message.realEstateField = 2;
                                break;
                            case "LISTING_NAME":
                            case 3:
                                message.realEstateField = 3;
                                break;
                            case "CITY_NAME":
                            case 4:
                                message.realEstateField = 4;
                                break;
                            case "DESCRIPTION":
                            case 5:
                                message.realEstateField = 5;
                                break;
                            case "ADDRESS":
                            case 6:
                                message.realEstateField = 6;
                                break;
                            case "PRICE":
                            case 7:
                                message.realEstateField = 7;
                                break;
                            case "FORMATTED_PRICE":
                            case 8:
                                message.realEstateField = 8;
                                break;
                            case "IMAGE_URL":
                            case 9:
                                message.realEstateField = 9;
                                break;
                            case "PROPERTY_TYPE":
                            case 10:
                                message.realEstateField = 10;
                                break;
                            case "LISTING_TYPE":
                            case 11:
                                message.realEstateField = 11;
                                break;
                            case "CONTEXTUAL_KEYWORDS":
                            case 12:
                                message.realEstateField = 12;
                                break;
                            case "FINAL_URLS":
                            case 13:
                                message.realEstateField = 13;
                                break;
                            case "FINAL_MOBILE_URLS":
                            case 14:
                                message.realEstateField = 14;
                                break;
                            case "TRACKING_URL":
                            case 15:
                                message.realEstateField = 15;
                                break;
                            case "ANDROID_APP_LINK":
                            case 16:
                                message.realEstateField = 16;
                                break;
                            case "SIMILAR_LISTING_IDS":
                            case 17:
                                message.realEstateField = 17;
                                break;
                            case "IOS_APP_LINK":
                            case 18:
                                message.realEstateField = 18;
                                break;
                            case "IOS_APP_STORE_ID":
                            case 19:
                                message.realEstateField = 19;
                                break;
                            }
                            switch (object.travelField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.travelField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.travelField = 1;
                                break;
                            case "DESTINATION_ID":
                            case 2:
                                message.travelField = 2;
                                break;
                            case "ORIGIN_ID":
                            case 3:
                                message.travelField = 3;
                                break;
                            case "TITLE":
                            case 4:
                                message.travelField = 4;
                                break;
                            case "DESTINATION_NAME":
                            case 5:
                                message.travelField = 5;
                                break;
                            case "ORIGIN_NAME":
                            case 6:
                                message.travelField = 6;
                                break;
                            case "PRICE":
                            case 7:
                                message.travelField = 7;
                                break;
                            case "FORMATTED_PRICE":
                            case 8:
                                message.travelField = 8;
                                break;
                            case "SALE_PRICE":
                            case 9:
                                message.travelField = 9;
                                break;
                            case "FORMATTED_SALE_PRICE":
                            case 10:
                                message.travelField = 10;
                                break;
                            case "IMAGE_URL":
                            case 11:
                                message.travelField = 11;
                                break;
                            case "CATEGORY":
                            case 12:
                                message.travelField = 12;
                                break;
                            case "CONTEXTUAL_KEYWORDS":
                            case 13:
                                message.travelField = 13;
                                break;
                            case "DESTINATION_ADDRESS":
                            case 14:
                                message.travelField = 14;
                                break;
                            case "FINAL_URL":
                            case 15:
                                message.travelField = 15;
                                break;
                            case "FINAL_MOBILE_URLS":
                            case 16:
                                message.travelField = 16;
                                break;
                            case "TRACKING_URL":
                            case 17:
                                message.travelField = 17;
                                break;
                            case "ANDROID_APP_LINK":
                            case 18:
                                message.travelField = 18;
                                break;
                            case "SIMILAR_DESTINATION_IDS":
                            case 19:
                                message.travelField = 19;
                                break;
                            case "IOS_APP_LINK":
                            case 20:
                                message.travelField = 20;
                                break;
                            case "IOS_APP_STORE_ID":
                            case 21:
                                message.travelField = 21;
                                break;
                            }
                            switch (object.localField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.localField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.localField = 1;
                                break;
                            case "DEAL_ID":
                            case 2:
                                message.localField = 2;
                                break;
                            case "DEAL_NAME":
                            case 3:
                                message.localField = 3;
                                break;
                            case "SUBTITLE":
                            case 4:
                                message.localField = 4;
                                break;
                            case "DESCRIPTION":
                            case 5:
                                message.localField = 5;
                                break;
                            case "PRICE":
                            case 6:
                                message.localField = 6;
                                break;
                            case "FORMATTED_PRICE":
                            case 7:
                                message.localField = 7;
                                break;
                            case "SALE_PRICE":
                            case 8:
                                message.localField = 8;
                                break;
                            case "FORMATTED_SALE_PRICE":
                            case 9:
                                message.localField = 9;
                                break;
                            case "IMAGE_URL":
                            case 10:
                                message.localField = 10;
                                break;
                            case "ADDRESS":
                            case 11:
                                message.localField = 11;
                                break;
                            case "CATEGORY":
                            case 12:
                                message.localField = 12;
                                break;
                            case "CONTEXTUAL_KEYWORDS":
                            case 13:
                                message.localField = 13;
                                break;
                            case "FINAL_URLS":
                            case 14:
                                message.localField = 14;
                                break;
                            case "FINAL_MOBILE_URLS":
                            case 15:
                                message.localField = 15;
                                break;
                            case "TRACKING_URL":
                            case 16:
                                message.localField = 16;
                                break;
                            case "ANDROID_APP_LINK":
                            case 17:
                                message.localField = 17;
                                break;
                            case "SIMILAR_DEAL_IDS":
                            case 18:
                                message.localField = 18;
                                break;
                            case "IOS_APP_LINK":
                            case 19:
                                message.localField = 19;
                                break;
                            case "IOS_APP_STORE_ID":
                            case 20:
                                message.localField = 20;
                                break;
                            }
                            switch (object.jobField) {
                            case "UNSPECIFIED":
                            case 0:
                                message.jobField = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.jobField = 1;
                                break;
                            case "JOB_ID":
                            case 2:
                                message.jobField = 2;
                                break;
                            case "LOCATION_ID":
                            case 3:
                                message.jobField = 3;
                                break;
                            case "TITLE":
                            case 4:
                                message.jobField = 4;
                                break;
                            case "SUBTITLE":
                            case 5:
                                message.jobField = 5;
                                break;
                            case "DESCRIPTION":
                            case 6:
                                message.jobField = 6;
                                break;
                            case "IMAGE_URL":
                            case 7:
                                message.jobField = 7;
                                break;
                            case "CATEGORY":
                            case 8:
                                message.jobField = 8;
                                break;
                            case "CONTEXTUAL_KEYWORDS":
                            case 9:
                                message.jobField = 9;
                                break;
                            case "ADDRESS":
                            case 10:
                                message.jobField = 10;
                                break;
                            case "SALARY":
                            case 11:
                                message.jobField = 11;
                                break;
                            case "FINAL_URLS":
                            case 12:
                                message.jobField = 12;
                                break;
                            case "FINAL_MOBILE_URLS":
                            case 14:
                                message.jobField = 14;
                                break;
                            case "TRACKING_URL":
                            case 15:
                                message.jobField = 15;
                                break;
                            case "ANDROID_APP_LINK":
                            case 16:
                                message.jobField = 16;
                                break;
                            case "SIMILAR_JOB_IDS":
                            case 17:
                                message.jobField = 17;
                                break;
                            case "IOS_APP_LINK":
                            case 18:
                                message.jobField = 18;
                                break;
                            case "IOS_APP_STORE_ID":
                            case 19:
                                message.jobField = 19;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AttributeFieldMapping message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @static
                         * @param {google.ads.googleads.v1.resources.AttributeFieldMapping} message AttributeFieldMapping
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AttributeFieldMapping.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.feedAttributeId = null;
                                object.fieldId = null;
                            }
                            if (message.feedAttributeId != null && message.hasOwnProperty("feedAttributeId"))
                                object.feedAttributeId = $root.google.protobuf.Int64Value.toObject(message.feedAttributeId, options);
                            if (message.fieldId != null && message.hasOwnProperty("fieldId"))
                                object.fieldId = $root.google.protobuf.Int64Value.toObject(message.fieldId, options);
                            if (message.sitelinkField != null && message.hasOwnProperty("sitelinkField")) {
                                object.sitelinkField = options.enums === String ? $root.google.ads.googleads.v1.enums.SitelinkPlaceholderFieldEnum.SitelinkPlaceholderField[message.sitelinkField] : message.sitelinkField;
                                if (options.oneofs)
                                    object.field = "sitelinkField";
                            }
                            if (message.callField != null && message.hasOwnProperty("callField")) {
                                object.callField = options.enums === String ? $root.google.ads.googleads.v1.enums.CallPlaceholderFieldEnum.CallPlaceholderField[message.callField] : message.callField;
                                if (options.oneofs)
                                    object.field = "callField";
                            }
                            if (message.appField != null && message.hasOwnProperty("appField")) {
                                object.appField = options.enums === String ? $root.google.ads.googleads.v1.enums.AppPlaceholderFieldEnum.AppPlaceholderField[message.appField] : message.appField;
                                if (options.oneofs)
                                    object.field = "appField";
                            }
                            if (message.locationField != null && message.hasOwnProperty("locationField")) {
                                object.locationField = options.enums === String ? $root.google.ads.googleads.v1.enums.LocationPlaceholderFieldEnum.LocationPlaceholderField[message.locationField] : message.locationField;
                                if (options.oneofs)
                                    object.field = "locationField";
                            }
                            if (message.affiliateLocationField != null && message.hasOwnProperty("affiliateLocationField")) {
                                object.affiliateLocationField = options.enums === String ? $root.google.ads.googleads.v1.enums.AffiliateLocationPlaceholderFieldEnum.AffiliateLocationPlaceholderField[message.affiliateLocationField] : message.affiliateLocationField;
                                if (options.oneofs)
                                    object.field = "affiliateLocationField";
                            }
                            if (message.calloutField != null && message.hasOwnProperty("calloutField")) {
                                object.calloutField = options.enums === String ? $root.google.ads.googleads.v1.enums.CalloutPlaceholderFieldEnum.CalloutPlaceholderField[message.calloutField] : message.calloutField;
                                if (options.oneofs)
                                    object.field = "calloutField";
                            }
                            if (message.structuredSnippetField != null && message.hasOwnProperty("structuredSnippetField")) {
                                object.structuredSnippetField = options.enums === String ? $root.google.ads.googleads.v1.enums.StructuredSnippetPlaceholderFieldEnum.StructuredSnippetPlaceholderField[message.structuredSnippetField] : message.structuredSnippetField;
                                if (options.oneofs)
                                    object.field = "structuredSnippetField";
                            }
                            if (message.messageField != null && message.hasOwnProperty("messageField")) {
                                object.messageField = options.enums === String ? $root.google.ads.googleads.v1.enums.MessagePlaceholderFieldEnum.MessagePlaceholderField[message.messageField] : message.messageField;
                                if (options.oneofs)
                                    object.field = "messageField";
                            }
                            if (message.priceField != null && message.hasOwnProperty("priceField")) {
                                object.priceField = options.enums === String ? $root.google.ads.googleads.v1.enums.PricePlaceholderFieldEnum.PricePlaceholderField[message.priceField] : message.priceField;
                                if (options.oneofs)
                                    object.field = "priceField";
                            }
                            if (message.promotionField != null && message.hasOwnProperty("promotionField")) {
                                object.promotionField = options.enums === String ? $root.google.ads.googleads.v1.enums.PromotionPlaceholderFieldEnum.PromotionPlaceholderField[message.promotionField] : message.promotionField;
                                if (options.oneofs)
                                    object.field = "promotionField";
                            }
                            if (message.adCustomizerField != null && message.hasOwnProperty("adCustomizerField")) {
                                object.adCustomizerField = options.enums === String ? $root.google.ads.googleads.v1.enums.AdCustomizerPlaceholderFieldEnum.AdCustomizerPlaceholderField[message.adCustomizerField] : message.adCustomizerField;
                                if (options.oneofs)
                                    object.field = "adCustomizerField";
                            }
                            if (message.dsaPageFeedField != null && message.hasOwnProperty("dsaPageFeedField")) {
                                object.dsaPageFeedField = options.enums === String ? $root.google.ads.googleads.v1.enums.DsaPageFeedCriterionFieldEnum.DsaPageFeedCriterionField[message.dsaPageFeedField] : message.dsaPageFeedField;
                                if (options.oneofs)
                                    object.field = "dsaPageFeedField";
                            }
                            if (message.locationExtensionTargetingField != null && message.hasOwnProperty("locationExtensionTargetingField")) {
                                object.locationExtensionTargetingField = options.enums === String ? $root.google.ads.googleads.v1.enums.LocationExtensionTargetingCriterionFieldEnum.LocationExtensionTargetingCriterionField[message.locationExtensionTargetingField] : message.locationExtensionTargetingField;
                                if (options.oneofs)
                                    object.field = "locationExtensionTargetingField";
                            }
                            if (message.educationField != null && message.hasOwnProperty("educationField")) {
                                object.educationField = options.enums === String ? $root.google.ads.googleads.v1.enums.EducationPlaceholderFieldEnum.EducationPlaceholderField[message.educationField] : message.educationField;
                                if (options.oneofs)
                                    object.field = "educationField";
                            }
                            if (message.flightField != null && message.hasOwnProperty("flightField")) {
                                object.flightField = options.enums === String ? $root.google.ads.googleads.v1.enums.FlightPlaceholderFieldEnum.FlightPlaceholderField[message.flightField] : message.flightField;
                                if (options.oneofs)
                                    object.field = "flightField";
                            }
                            if (message.customField != null && message.hasOwnProperty("customField")) {
                                object.customField = options.enums === String ? $root.google.ads.googleads.v1.enums.CustomPlaceholderFieldEnum.CustomPlaceholderField[message.customField] : message.customField;
                                if (options.oneofs)
                                    object.field = "customField";
                            }
                            if (message.hotelField != null && message.hasOwnProperty("hotelField")) {
                                object.hotelField = options.enums === String ? $root.google.ads.googleads.v1.enums.HotelPlaceholderFieldEnum.HotelPlaceholderField[message.hotelField] : message.hotelField;
                                if (options.oneofs)
                                    object.field = "hotelField";
                            }
                            if (message.realEstateField != null && message.hasOwnProperty("realEstateField")) {
                                object.realEstateField = options.enums === String ? $root.google.ads.googleads.v1.enums.RealEstatePlaceholderFieldEnum.RealEstatePlaceholderField[message.realEstateField] : message.realEstateField;
                                if (options.oneofs)
                                    object.field = "realEstateField";
                            }
                            if (message.travelField != null && message.hasOwnProperty("travelField")) {
                                object.travelField = options.enums === String ? $root.google.ads.googleads.v1.enums.TravelPlaceholderFieldEnum.TravelPlaceholderField[message.travelField] : message.travelField;
                                if (options.oneofs)
                                    object.field = "travelField";
                            }
                            if (message.localField != null && message.hasOwnProperty("localField")) {
                                object.localField = options.enums === String ? $root.google.ads.googleads.v1.enums.LocalPlaceholderFieldEnum.LocalPlaceholderField[message.localField] : message.localField;
                                if (options.oneofs)
                                    object.field = "localField";
                            }
                            if (message.jobField != null && message.hasOwnProperty("jobField")) {
                                object.jobField = options.enums === String ? $root.google.ads.googleads.v1.enums.JobPlaceholderFieldEnum.JobPlaceholderField[message.jobField] : message.jobField;
                                if (options.oneofs)
                                    object.field = "jobField";
                            }
                            return object;
                        };

                        /**
                         * Converts this AttributeFieldMapping to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.AttributeFieldMapping
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AttributeFieldMapping.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AttributeFieldMapping;
                    })();

                    resources.FeedPlaceholderView = (function() {

                        /**
                         * Properties of a FeedPlaceholderView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IFeedPlaceholderView
                         * @property {string|null} [resourceName] FeedPlaceholderView resourceName
                         * @property {google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType|null} [placeholderType] FeedPlaceholderView placeholderType
                         */

                        /**
                         * Constructs a new FeedPlaceholderView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a FeedPlaceholderView.
                         * @implements IFeedPlaceholderView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IFeedPlaceholderView=} [properties] Properties to set
                         */
                        function FeedPlaceholderView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * FeedPlaceholderView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.FeedPlaceholderView
                         * @instance
                         */
                        FeedPlaceholderView.prototype.resourceName = "";

                        /**
                         * FeedPlaceholderView placeholderType.
                         * @member {google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType} placeholderType
                         * @memberof google.ads.googleads.v1.resources.FeedPlaceholderView
                         * @instance
                         */
                        FeedPlaceholderView.prototype.placeholderType = 0;

                        /**
                         * Creates a new FeedPlaceholderView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.FeedPlaceholderView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedPlaceholderView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.FeedPlaceholderView} FeedPlaceholderView instance
                         */
                        FeedPlaceholderView.create = function create(properties) {
                            return new FeedPlaceholderView(properties);
                        };

                        /**
                         * Encodes the specified FeedPlaceholderView message. Does not implicitly {@link google.ads.googleads.v1.resources.FeedPlaceholderView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.FeedPlaceholderView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedPlaceholderView} message FeedPlaceholderView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedPlaceholderView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.placeholderType != null && message.hasOwnProperty("placeholderType"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.placeholderType);
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedPlaceholderView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.FeedPlaceholderView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.FeedPlaceholderView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IFeedPlaceholderView} message FeedPlaceholderView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedPlaceholderView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedPlaceholderView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.FeedPlaceholderView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.FeedPlaceholderView} FeedPlaceholderView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedPlaceholderView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.FeedPlaceholderView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.placeholderType = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedPlaceholderView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.FeedPlaceholderView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.FeedPlaceholderView} FeedPlaceholderView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedPlaceholderView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedPlaceholderView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.FeedPlaceholderView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedPlaceholderView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.placeholderType != null && message.hasOwnProperty("placeholderType"))
                                switch (message.placeholderType) {
                                default:
                                    return "placeholderType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a FeedPlaceholderView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.FeedPlaceholderView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.FeedPlaceholderView} FeedPlaceholderView
                         */
                        FeedPlaceholderView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.FeedPlaceholderView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.FeedPlaceholderView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            switch (object.placeholderType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.placeholderType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.placeholderType = 1;
                                break;
                            case "SITELINK":
                            case 2:
                                message.placeholderType = 2;
                                break;
                            case "CALL":
                            case 3:
                                message.placeholderType = 3;
                                break;
                            case "APP":
                            case 4:
                                message.placeholderType = 4;
                                break;
                            case "LOCATION":
                            case 5:
                                message.placeholderType = 5;
                                break;
                            case "AFFILIATE_LOCATION":
                            case 6:
                                message.placeholderType = 6;
                                break;
                            case "CALLOUT":
                            case 7:
                                message.placeholderType = 7;
                                break;
                            case "STRUCTURED_SNIPPET":
                            case 8:
                                message.placeholderType = 8;
                                break;
                            case "MESSAGE":
                            case 9:
                                message.placeholderType = 9;
                                break;
                            case "PRICE":
                            case 10:
                                message.placeholderType = 10;
                                break;
                            case "PROMOTION":
                            case 11:
                                message.placeholderType = 11;
                                break;
                            case "AD_CUSTOMIZER":
                            case 12:
                                message.placeholderType = 12;
                                break;
                            case "DYNAMIC_EDUCATION":
                            case 13:
                                message.placeholderType = 13;
                                break;
                            case "DYNAMIC_FLIGHT":
                            case 14:
                                message.placeholderType = 14;
                                break;
                            case "DYNAMIC_CUSTOM":
                            case 15:
                                message.placeholderType = 15;
                                break;
                            case "DYNAMIC_HOTEL":
                            case 16:
                                message.placeholderType = 16;
                                break;
                            case "DYNAMIC_REAL_ESTATE":
                            case 17:
                                message.placeholderType = 17;
                                break;
                            case "DYNAMIC_TRAVEL":
                            case 18:
                                message.placeholderType = 18;
                                break;
                            case "DYNAMIC_LOCAL":
                            case 19:
                                message.placeholderType = 19;
                                break;
                            case "DYNAMIC_JOB":
                            case 20:
                                message.placeholderType = 20;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a FeedPlaceholderView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.FeedPlaceholderView
                         * @static
                         * @param {google.ads.googleads.v1.resources.FeedPlaceholderView} message FeedPlaceholderView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedPlaceholderView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.placeholderType = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.placeholderType != null && message.hasOwnProperty("placeholderType"))
                                object.placeholderType = options.enums === String ? $root.google.ads.googleads.v1.enums.PlaceholderTypeEnum.PlaceholderType[message.placeholderType] : message.placeholderType;
                            return object;
                        };

                        /**
                         * Converts this FeedPlaceholderView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.FeedPlaceholderView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedPlaceholderView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return FeedPlaceholderView;
                    })();

                    resources.GenderView = (function() {

                        /**
                         * Properties of a GenderView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IGenderView
                         * @property {string|null} [resourceName] GenderView resourceName
                         */

                        /**
                         * Constructs a new GenderView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a GenderView.
                         * @implements IGenderView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IGenderView=} [properties] Properties to set
                         */
                        function GenderView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GenderView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.GenderView
                         * @instance
                         */
                        GenderView.prototype.resourceName = "";

                        /**
                         * Creates a new GenderView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.GenderView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IGenderView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.GenderView} GenderView instance
                         */
                        GenderView.create = function create(properties) {
                            return new GenderView(properties);
                        };

                        /**
                         * Encodes the specified GenderView message. Does not implicitly {@link google.ads.googleads.v1.resources.GenderView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.GenderView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IGenderView} message GenderView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenderView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GenderView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.GenderView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.GenderView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IGenderView} message GenderView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenderView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GenderView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.GenderView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.GenderView} GenderView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenderView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.GenderView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GenderView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.GenderView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.GenderView} GenderView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenderView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GenderView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.GenderView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GenderView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GenderView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.GenderView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.GenderView} GenderView
                         */
                        GenderView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.GenderView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.GenderView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GenderView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.GenderView
                         * @static
                         * @param {google.ads.googleads.v1.resources.GenderView} message GenderView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GenderView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GenderView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.GenderView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GenderView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GenderView;
                    })();

                    resources.GeoTargetConstant = (function() {

                        /**
                         * Properties of a GeoTargetConstant.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IGeoTargetConstant
                         * @property {string|null} [resourceName] GeoTargetConstant resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] GeoTargetConstant id
                         * @property {google.protobuf.IStringValue|null} [name] GeoTargetConstant name
                         * @property {google.protobuf.IStringValue|null} [countryCode] GeoTargetConstant countryCode
                         * @property {google.protobuf.IStringValue|null} [targetType] GeoTargetConstant targetType
                         * @property {google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum.GeoTargetConstantStatus|null} [status] GeoTargetConstant status
                         * @property {google.protobuf.IStringValue|null} [canonicalName] GeoTargetConstant canonicalName
                         */

                        /**
                         * Constructs a new GeoTargetConstant.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a GeoTargetConstant.
                         * @implements IGeoTargetConstant
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IGeoTargetConstant=} [properties] Properties to set
                         */
                        function GeoTargetConstant(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GeoTargetConstant resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.GeoTargetConstant
                         * @instance
                         */
                        GeoTargetConstant.prototype.resourceName = "";

                        /**
                         * GeoTargetConstant id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.GeoTargetConstant
                         * @instance
                         */
                        GeoTargetConstant.prototype.id = null;

                        /**
                         * GeoTargetConstant name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.GeoTargetConstant
                         * @instance
                         */
                        GeoTargetConstant.prototype.name = null;

                        /**
                         * GeoTargetConstant countryCode.
                         * @member {google.protobuf.IStringValue|null|undefined} countryCode
                         * @memberof google.ads.googleads.v1.resources.GeoTargetConstant
                         * @instance
                         */
                        GeoTargetConstant.prototype.countryCode = null;

                        /**
                         * GeoTargetConstant targetType.
                         * @member {google.protobuf.IStringValue|null|undefined} targetType
                         * @memberof google.ads.googleads.v1.resources.GeoTargetConstant
                         * @instance
                         */
                        GeoTargetConstant.prototype.targetType = null;

                        /**
                         * GeoTargetConstant status.
                         * @member {google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum.GeoTargetConstantStatus} status
                         * @memberof google.ads.googleads.v1.resources.GeoTargetConstant
                         * @instance
                         */
                        GeoTargetConstant.prototype.status = 0;

                        /**
                         * GeoTargetConstant canonicalName.
                         * @member {google.protobuf.IStringValue|null|undefined} canonicalName
                         * @memberof google.ads.googleads.v1.resources.GeoTargetConstant
                         * @instance
                         */
                        GeoTargetConstant.prototype.canonicalName = null;

                        /**
                         * Creates a new GeoTargetConstant instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.GeoTargetConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.IGeoTargetConstant=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.GeoTargetConstant} GeoTargetConstant instance
                         */
                        GeoTargetConstant.create = function create(properties) {
                            return new GeoTargetConstant(properties);
                        };

                        /**
                         * Encodes the specified GeoTargetConstant message. Does not implicitly {@link google.ads.googleads.v1.resources.GeoTargetConstant.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.GeoTargetConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.IGeoTargetConstant} message GeoTargetConstant message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GeoTargetConstant.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                $root.google.protobuf.StringValue.encode(message.countryCode, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.targetType != null && message.hasOwnProperty("targetType"))
                                $root.google.protobuf.StringValue.encode(message.targetType, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 7, wireType 0 =*/56).int32(message.status);
                            if (message.canonicalName != null && message.hasOwnProperty("canonicalName"))
                                $root.google.protobuf.StringValue.encode(message.canonicalName, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified GeoTargetConstant message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.GeoTargetConstant.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.GeoTargetConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.IGeoTargetConstant} message GeoTargetConstant message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GeoTargetConstant.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GeoTargetConstant message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.GeoTargetConstant
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.GeoTargetConstant} GeoTargetConstant
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GeoTargetConstant.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.GeoTargetConstant();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 3:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.countryCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.targetType = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.status = reader.int32();
                                    break;
                                case 8:
                                    message.canonicalName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GeoTargetConstant message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.GeoTargetConstant
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.GeoTargetConstant} GeoTargetConstant
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GeoTargetConstant.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GeoTargetConstant message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.GeoTargetConstant
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GeoTargetConstant.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.countryCode != null && message.hasOwnProperty("countryCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.countryCode);
                                if (error)
                                    return "countryCode." + error;
                            }
                            if (message.targetType != null && message.hasOwnProperty("targetType")) {
                                var error = $root.google.protobuf.StringValue.verify(message.targetType);
                                if (error)
                                    return "targetType." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.canonicalName != null && message.hasOwnProperty("canonicalName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.canonicalName);
                                if (error)
                                    return "canonicalName." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a GeoTargetConstant message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.GeoTargetConstant
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.GeoTargetConstant} GeoTargetConstant
                         */
                        GeoTargetConstant.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.GeoTargetConstant)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.GeoTargetConstant();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.GeoTargetConstant.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.GeoTargetConstant.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            if (object.countryCode != null) {
                                if (typeof object.countryCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.GeoTargetConstant.countryCode: object expected");
                                message.countryCode = $root.google.protobuf.StringValue.fromObject(object.countryCode);
                            }
                            if (object.targetType != null) {
                                if (typeof object.targetType !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.GeoTargetConstant.targetType: object expected");
                                message.targetType = $root.google.protobuf.StringValue.fromObject(object.targetType);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "REMOVAL_PLANNED":
                            case 3:
                                message.status = 3;
                                break;
                            }
                            if (object.canonicalName != null) {
                                if (typeof object.canonicalName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.GeoTargetConstant.canonicalName: object expected");
                                message.canonicalName = $root.google.protobuf.StringValue.fromObject(object.canonicalName);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a GeoTargetConstant message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.GeoTargetConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.GeoTargetConstant} message GeoTargetConstant
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GeoTargetConstant.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.name = null;
                                object.countryCode = null;
                                object.targetType = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                                object.canonicalName = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                object.countryCode = $root.google.protobuf.StringValue.toObject(message.countryCode, options);
                            if (message.targetType != null && message.hasOwnProperty("targetType"))
                                object.targetType = $root.google.protobuf.StringValue.toObject(message.targetType, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.GeoTargetConstantStatusEnum.GeoTargetConstantStatus[message.status] : message.status;
                            if (message.canonicalName != null && message.hasOwnProperty("canonicalName"))
                                object.canonicalName = $root.google.protobuf.StringValue.toObject(message.canonicalName, options);
                            return object;
                        };

                        /**
                         * Converts this GeoTargetConstant to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.GeoTargetConstant
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GeoTargetConstant.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GeoTargetConstant;
                    })();

                    resources.GeographicView = (function() {

                        /**
                         * Properties of a GeographicView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IGeographicView
                         * @property {string|null} [resourceName] GeographicView resourceName
                         * @property {google.protobuf.IStringValue|null} [countryGeoTargetConstant] GeographicView countryGeoTargetConstant
                         * @property {google.ads.googleads.v1.enums.GeoTargetingTypeEnum.GeoTargetingType|null} [locationType] GeographicView locationType
                         */

                        /**
                         * Constructs a new GeographicView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a GeographicView.
                         * @implements IGeographicView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IGeographicView=} [properties] Properties to set
                         */
                        function GeographicView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GeographicView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.GeographicView
                         * @instance
                         */
                        GeographicView.prototype.resourceName = "";

                        /**
                         * GeographicView countryGeoTargetConstant.
                         * @member {google.protobuf.IStringValue|null|undefined} countryGeoTargetConstant
                         * @memberof google.ads.googleads.v1.resources.GeographicView
                         * @instance
                         */
                        GeographicView.prototype.countryGeoTargetConstant = null;

                        /**
                         * GeographicView locationType.
                         * @member {google.ads.googleads.v1.enums.GeoTargetingTypeEnum.GeoTargetingType} locationType
                         * @memberof google.ads.googleads.v1.resources.GeographicView
                         * @instance
                         */
                        GeographicView.prototype.locationType = 0;

                        /**
                         * Creates a new GeographicView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.GeographicView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IGeographicView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.GeographicView} GeographicView instance
                         */
                        GeographicView.create = function create(properties) {
                            return new GeographicView(properties);
                        };

                        /**
                         * Encodes the specified GeographicView message. Does not implicitly {@link google.ads.googleads.v1.resources.GeographicView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.GeographicView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IGeographicView} message GeographicView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GeographicView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.countryGeoTargetConstant != null && message.hasOwnProperty("countryGeoTargetConstant"))
                                $root.google.protobuf.StringValue.encode(message.countryGeoTargetConstant, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.locationType != null && message.hasOwnProperty("locationType"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.locationType);
                            return writer;
                        };

                        /**
                         * Encodes the specified GeographicView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.GeographicView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.GeographicView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IGeographicView} message GeographicView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GeographicView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GeographicView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.GeographicView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.GeographicView} GeographicView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GeographicView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.GeographicView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.countryGeoTargetConstant = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.locationType = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GeographicView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.GeographicView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.GeographicView} GeographicView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GeographicView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GeographicView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.GeographicView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GeographicView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.countryGeoTargetConstant != null && message.hasOwnProperty("countryGeoTargetConstant")) {
                                var error = $root.google.protobuf.StringValue.verify(message.countryGeoTargetConstant);
                                if (error)
                                    return "countryGeoTargetConstant." + error;
                            }
                            if (message.locationType != null && message.hasOwnProperty("locationType"))
                                switch (message.locationType) {
                                default:
                                    return "locationType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a GeographicView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.GeographicView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.GeographicView} GeographicView
                         */
                        GeographicView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.GeographicView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.GeographicView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.countryGeoTargetConstant != null) {
                                if (typeof object.countryGeoTargetConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.GeographicView.countryGeoTargetConstant: object expected");
                                message.countryGeoTargetConstant = $root.google.protobuf.StringValue.fromObject(object.countryGeoTargetConstant);
                            }
                            switch (object.locationType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.locationType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.locationType = 1;
                                break;
                            case "AREA_OF_INTEREST":
                            case 2:
                                message.locationType = 2;
                                break;
                            case "LOCATION_OF_PRESENCE":
                            case 3:
                                message.locationType = 3;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a GeographicView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.GeographicView
                         * @static
                         * @param {google.ads.googleads.v1.resources.GeographicView} message GeographicView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GeographicView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.countryGeoTargetConstant = null;
                                object.locationType = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.countryGeoTargetConstant != null && message.hasOwnProperty("countryGeoTargetConstant"))
                                object.countryGeoTargetConstant = $root.google.protobuf.StringValue.toObject(message.countryGeoTargetConstant, options);
                            if (message.locationType != null && message.hasOwnProperty("locationType"))
                                object.locationType = options.enums === String ? $root.google.ads.googleads.v1.enums.GeoTargetingTypeEnum.GeoTargetingType[message.locationType] : message.locationType;
                            return object;
                        };

                        /**
                         * Converts this GeographicView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.GeographicView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GeographicView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GeographicView;
                    })();

                    resources.GoogleAdsField = (function() {

                        /**
                         * Properties of a GoogleAdsField.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IGoogleAdsField
                         * @property {string|null} [resourceName] GoogleAdsField resourceName
                         * @property {google.protobuf.IStringValue|null} [name] GoogleAdsField name
                         * @property {google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum.GoogleAdsFieldCategory|null} [category] GoogleAdsField category
                         * @property {google.protobuf.IBoolValue|null} [selectable] GoogleAdsField selectable
                         * @property {google.protobuf.IBoolValue|null} [filterable] GoogleAdsField filterable
                         * @property {google.protobuf.IBoolValue|null} [sortable] GoogleAdsField sortable
                         * @property {Array.<google.protobuf.IStringValue>|null} [selectableWith] GoogleAdsField selectableWith
                         * @property {Array.<google.protobuf.IStringValue>|null} [attributeResources] GoogleAdsField attributeResources
                         * @property {Array.<google.protobuf.IStringValue>|null} [metrics] GoogleAdsField metrics
                         * @property {Array.<google.protobuf.IStringValue>|null} [segments] GoogleAdsField segments
                         * @property {Array.<google.protobuf.IStringValue>|null} [enumValues] GoogleAdsField enumValues
                         * @property {google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum.GoogleAdsFieldDataType|null} [dataType] GoogleAdsField dataType
                         * @property {google.protobuf.IStringValue|null} [typeUrl] GoogleAdsField typeUrl
                         * @property {google.protobuf.IBoolValue|null} [isRepeated] GoogleAdsField isRepeated
                         */

                        /**
                         * Constructs a new GoogleAdsField.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a GoogleAdsField.
                         * @implements IGoogleAdsField
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IGoogleAdsField=} [properties] Properties to set
                         */
                        function GoogleAdsField(properties) {
                            this.selectableWith = [];
                            this.attributeResources = [];
                            this.metrics = [];
                            this.segments = [];
                            this.enumValues = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GoogleAdsField resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @instance
                         */
                        GoogleAdsField.prototype.resourceName = "";

                        /**
                         * GoogleAdsField name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @instance
                         */
                        GoogleAdsField.prototype.name = null;

                        /**
                         * GoogleAdsField category.
                         * @member {google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum.GoogleAdsFieldCategory} category
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @instance
                         */
                        GoogleAdsField.prototype.category = 0;

                        /**
                         * GoogleAdsField selectable.
                         * @member {google.protobuf.IBoolValue|null|undefined} selectable
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @instance
                         */
                        GoogleAdsField.prototype.selectable = null;

                        /**
                         * GoogleAdsField filterable.
                         * @member {google.protobuf.IBoolValue|null|undefined} filterable
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @instance
                         */
                        GoogleAdsField.prototype.filterable = null;

                        /**
                         * GoogleAdsField sortable.
                         * @member {google.protobuf.IBoolValue|null|undefined} sortable
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @instance
                         */
                        GoogleAdsField.prototype.sortable = null;

                        /**
                         * GoogleAdsField selectableWith.
                         * @member {Array.<google.protobuf.IStringValue>} selectableWith
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @instance
                         */
                        GoogleAdsField.prototype.selectableWith = $util.emptyArray;

                        /**
                         * GoogleAdsField attributeResources.
                         * @member {Array.<google.protobuf.IStringValue>} attributeResources
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @instance
                         */
                        GoogleAdsField.prototype.attributeResources = $util.emptyArray;

                        /**
                         * GoogleAdsField metrics.
                         * @member {Array.<google.protobuf.IStringValue>} metrics
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @instance
                         */
                        GoogleAdsField.prototype.metrics = $util.emptyArray;

                        /**
                         * GoogleAdsField segments.
                         * @member {Array.<google.protobuf.IStringValue>} segments
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @instance
                         */
                        GoogleAdsField.prototype.segments = $util.emptyArray;

                        /**
                         * GoogleAdsField enumValues.
                         * @member {Array.<google.protobuf.IStringValue>} enumValues
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @instance
                         */
                        GoogleAdsField.prototype.enumValues = $util.emptyArray;

                        /**
                         * GoogleAdsField dataType.
                         * @member {google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum.GoogleAdsFieldDataType} dataType
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @instance
                         */
                        GoogleAdsField.prototype.dataType = 0;

                        /**
                         * GoogleAdsField typeUrl.
                         * @member {google.protobuf.IStringValue|null|undefined} typeUrl
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @instance
                         */
                        GoogleAdsField.prototype.typeUrl = null;

                        /**
                         * GoogleAdsField isRepeated.
                         * @member {google.protobuf.IBoolValue|null|undefined} isRepeated
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @instance
                         */
                        GoogleAdsField.prototype.isRepeated = null;

                        /**
                         * Creates a new GoogleAdsField instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @static
                         * @param {google.ads.googleads.v1.resources.IGoogleAdsField=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.GoogleAdsField} GoogleAdsField instance
                         */
                        GoogleAdsField.create = function create(properties) {
                            return new GoogleAdsField(properties);
                        };

                        /**
                         * Encodes the specified GoogleAdsField message. Does not implicitly {@link google.ads.googleads.v1.resources.GoogleAdsField.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @static
                         * @param {google.ads.googleads.v1.resources.IGoogleAdsField} message GoogleAdsField message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GoogleAdsField.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.category != null && message.hasOwnProperty("category"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.category);
                            if (message.selectable != null && message.hasOwnProperty("selectable"))
                                $root.google.protobuf.BoolValue.encode(message.selectable, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.filterable != null && message.hasOwnProperty("filterable"))
                                $root.google.protobuf.BoolValue.encode(message.filterable, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.sortable != null && message.hasOwnProperty("sortable"))
                                $root.google.protobuf.BoolValue.encode(message.sortable, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.selectableWith != null && message.selectableWith.length)
                                for (var i = 0; i < message.selectableWith.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.selectableWith[i], writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.attributeResources != null && message.attributeResources.length)
                                for (var i = 0; i < message.attributeResources.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.attributeResources[i], writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.metrics != null && message.metrics.length)
                                for (var i = 0; i < message.metrics.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.metrics[i], writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.segments != null && message.segments.length)
                                for (var i = 0; i < message.segments.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.segments[i], writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.enumValues != null && message.enumValues.length)
                                for (var i = 0; i < message.enumValues.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.enumValues[i], writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.dataType != null && message.hasOwnProperty("dataType"))
                                writer.uint32(/* id 12, wireType 0 =*/96).int32(message.dataType);
                            if (message.typeUrl != null && message.hasOwnProperty("typeUrl"))
                                $root.google.protobuf.StringValue.encode(message.typeUrl, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                            if (message.isRepeated != null && message.hasOwnProperty("isRepeated"))
                                $root.google.protobuf.BoolValue.encode(message.isRepeated, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified GoogleAdsField message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.GoogleAdsField.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @static
                         * @param {google.ads.googleads.v1.resources.IGoogleAdsField} message GoogleAdsField message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GoogleAdsField.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GoogleAdsField message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.GoogleAdsField} GoogleAdsField
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GoogleAdsField.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.GoogleAdsField();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.category = reader.int32();
                                    break;
                                case 4:
                                    message.selectable = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.filterable = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.sortable = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    if (!(message.selectableWith && message.selectableWith.length))
                                        message.selectableWith = [];
                                    message.selectableWith.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 8:
                                    if (!(message.attributeResources && message.attributeResources.length))
                                        message.attributeResources = [];
                                    message.attributeResources.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 9:
                                    if (!(message.metrics && message.metrics.length))
                                        message.metrics = [];
                                    message.metrics.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 10:
                                    if (!(message.segments && message.segments.length))
                                        message.segments = [];
                                    message.segments.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 11:
                                    if (!(message.enumValues && message.enumValues.length))
                                        message.enumValues = [];
                                    message.enumValues.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 12:
                                    message.dataType = reader.int32();
                                    break;
                                case 13:
                                    message.typeUrl = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 14:
                                    message.isRepeated = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GoogleAdsField message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.GoogleAdsField} GoogleAdsField
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GoogleAdsField.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GoogleAdsField message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GoogleAdsField.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.category != null && message.hasOwnProperty("category"))
                                switch (message.category) {
                                default:
                                    return "category: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 5:
                                case 6:
                                    break;
                                }
                            if (message.selectable != null && message.hasOwnProperty("selectable")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.selectable);
                                if (error)
                                    return "selectable." + error;
                            }
                            if (message.filterable != null && message.hasOwnProperty("filterable")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.filterable);
                                if (error)
                                    return "filterable." + error;
                            }
                            if (message.sortable != null && message.hasOwnProperty("sortable")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.sortable);
                                if (error)
                                    return "sortable." + error;
                            }
                            if (message.selectableWith != null && message.hasOwnProperty("selectableWith")) {
                                if (!Array.isArray(message.selectableWith))
                                    return "selectableWith: array expected";
                                for (var i = 0; i < message.selectableWith.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.selectableWith[i]);
                                    if (error)
                                        return "selectableWith." + error;
                                }
                            }
                            if (message.attributeResources != null && message.hasOwnProperty("attributeResources")) {
                                if (!Array.isArray(message.attributeResources))
                                    return "attributeResources: array expected";
                                for (var i = 0; i < message.attributeResources.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.attributeResources[i]);
                                    if (error)
                                        return "attributeResources." + error;
                                }
                            }
                            if (message.metrics != null && message.hasOwnProperty("metrics")) {
                                if (!Array.isArray(message.metrics))
                                    return "metrics: array expected";
                                for (var i = 0; i < message.metrics.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.metrics[i]);
                                    if (error)
                                        return "metrics." + error;
                                }
                            }
                            if (message.segments != null && message.hasOwnProperty("segments")) {
                                if (!Array.isArray(message.segments))
                                    return "segments: array expected";
                                for (var i = 0; i < message.segments.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.segments[i]);
                                    if (error)
                                        return "segments." + error;
                                }
                            }
                            if (message.enumValues != null && message.hasOwnProperty("enumValues")) {
                                if (!Array.isArray(message.enumValues))
                                    return "enumValues: array expected";
                                for (var i = 0; i < message.enumValues.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.enumValues[i]);
                                    if (error)
                                        return "enumValues." + error;
                                }
                            }
                            if (message.dataType != null && message.hasOwnProperty("dataType"))
                                switch (message.dataType) {
                                default:
                                    return "dataType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                    break;
                                }
                            if (message.typeUrl != null && message.hasOwnProperty("typeUrl")) {
                                var error = $root.google.protobuf.StringValue.verify(message.typeUrl);
                                if (error)
                                    return "typeUrl." + error;
                            }
                            if (message.isRepeated != null && message.hasOwnProperty("isRepeated")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.isRepeated);
                                if (error)
                                    return "isRepeated." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a GoogleAdsField message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.GoogleAdsField} GoogleAdsField
                         */
                        GoogleAdsField.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.GoogleAdsField)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.GoogleAdsField();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.GoogleAdsField.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            switch (object.category) {
                            case "UNSPECIFIED":
                            case 0:
                                message.category = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.category = 1;
                                break;
                            case "RESOURCE":
                            case 2:
                                message.category = 2;
                                break;
                            case "ATTRIBUTE":
                            case 3:
                                message.category = 3;
                                break;
                            case "SEGMENT":
                            case 5:
                                message.category = 5;
                                break;
                            case "METRIC":
                            case 6:
                                message.category = 6;
                                break;
                            }
                            if (object.selectable != null) {
                                if (typeof object.selectable !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.GoogleAdsField.selectable: object expected");
                                message.selectable = $root.google.protobuf.BoolValue.fromObject(object.selectable);
                            }
                            if (object.filterable != null) {
                                if (typeof object.filterable !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.GoogleAdsField.filterable: object expected");
                                message.filterable = $root.google.protobuf.BoolValue.fromObject(object.filterable);
                            }
                            if (object.sortable != null) {
                                if (typeof object.sortable !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.GoogleAdsField.sortable: object expected");
                                message.sortable = $root.google.protobuf.BoolValue.fromObject(object.sortable);
                            }
                            if (object.selectableWith) {
                                if (!Array.isArray(object.selectableWith))
                                    throw TypeError(".google.ads.googleads.v1.resources.GoogleAdsField.selectableWith: array expected");
                                message.selectableWith = [];
                                for (var i = 0; i < object.selectableWith.length; ++i) {
                                    if (typeof object.selectableWith[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.GoogleAdsField.selectableWith: object expected");
                                    message.selectableWith[i] = $root.google.protobuf.StringValue.fromObject(object.selectableWith[i]);
                                }
                            }
                            if (object.attributeResources) {
                                if (!Array.isArray(object.attributeResources))
                                    throw TypeError(".google.ads.googleads.v1.resources.GoogleAdsField.attributeResources: array expected");
                                message.attributeResources = [];
                                for (var i = 0; i < object.attributeResources.length; ++i) {
                                    if (typeof object.attributeResources[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.GoogleAdsField.attributeResources: object expected");
                                    message.attributeResources[i] = $root.google.protobuf.StringValue.fromObject(object.attributeResources[i]);
                                }
                            }
                            if (object.metrics) {
                                if (!Array.isArray(object.metrics))
                                    throw TypeError(".google.ads.googleads.v1.resources.GoogleAdsField.metrics: array expected");
                                message.metrics = [];
                                for (var i = 0; i < object.metrics.length; ++i) {
                                    if (typeof object.metrics[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.GoogleAdsField.metrics: object expected");
                                    message.metrics[i] = $root.google.protobuf.StringValue.fromObject(object.metrics[i]);
                                }
                            }
                            if (object.segments) {
                                if (!Array.isArray(object.segments))
                                    throw TypeError(".google.ads.googleads.v1.resources.GoogleAdsField.segments: array expected");
                                message.segments = [];
                                for (var i = 0; i < object.segments.length; ++i) {
                                    if (typeof object.segments[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.GoogleAdsField.segments: object expected");
                                    message.segments[i] = $root.google.protobuf.StringValue.fromObject(object.segments[i]);
                                }
                            }
                            if (object.enumValues) {
                                if (!Array.isArray(object.enumValues))
                                    throw TypeError(".google.ads.googleads.v1.resources.GoogleAdsField.enumValues: array expected");
                                message.enumValues = [];
                                for (var i = 0; i < object.enumValues.length; ++i) {
                                    if (typeof object.enumValues[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.GoogleAdsField.enumValues: object expected");
                                    message.enumValues[i] = $root.google.protobuf.StringValue.fromObject(object.enumValues[i]);
                                }
                            }
                            switch (object.dataType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.dataType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.dataType = 1;
                                break;
                            case "BOOLEAN":
                            case 2:
                                message.dataType = 2;
                                break;
                            case "DATE":
                            case 3:
                                message.dataType = 3;
                                break;
                            case "DOUBLE":
                            case 4:
                                message.dataType = 4;
                                break;
                            case "ENUM":
                            case 5:
                                message.dataType = 5;
                                break;
                            case "FLOAT":
                            case 6:
                                message.dataType = 6;
                                break;
                            case "INT32":
                            case 7:
                                message.dataType = 7;
                                break;
                            case "INT64":
                            case 8:
                                message.dataType = 8;
                                break;
                            case "MESSAGE":
                            case 9:
                                message.dataType = 9;
                                break;
                            case "RESOURCE_NAME":
                            case 10:
                                message.dataType = 10;
                                break;
                            case "STRING":
                            case 11:
                                message.dataType = 11;
                                break;
                            }
                            if (object.typeUrl != null) {
                                if (typeof object.typeUrl !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.GoogleAdsField.typeUrl: object expected");
                                message.typeUrl = $root.google.protobuf.StringValue.fromObject(object.typeUrl);
                            }
                            if (object.isRepeated != null) {
                                if (typeof object.isRepeated !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.GoogleAdsField.isRepeated: object expected");
                                message.isRepeated = $root.google.protobuf.BoolValue.fromObject(object.isRepeated);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a GoogleAdsField message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @static
                         * @param {google.ads.googleads.v1.resources.GoogleAdsField} message GoogleAdsField
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GoogleAdsField.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.selectableWith = [];
                                object.attributeResources = [];
                                object.metrics = [];
                                object.segments = [];
                                object.enumValues = [];
                            }
                            if (options.defaults) {
                                object.resourceName = "";
                                object.name = null;
                                object.category = options.enums === String ? "UNSPECIFIED" : 0;
                                object.selectable = null;
                                object.filterable = null;
                                object.sortable = null;
                                object.dataType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.typeUrl = null;
                                object.isRepeated = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.category != null && message.hasOwnProperty("category"))
                                object.category = options.enums === String ? $root.google.ads.googleads.v1.enums.GoogleAdsFieldCategoryEnum.GoogleAdsFieldCategory[message.category] : message.category;
                            if (message.selectable != null && message.hasOwnProperty("selectable"))
                                object.selectable = $root.google.protobuf.BoolValue.toObject(message.selectable, options);
                            if (message.filterable != null && message.hasOwnProperty("filterable"))
                                object.filterable = $root.google.protobuf.BoolValue.toObject(message.filterable, options);
                            if (message.sortable != null && message.hasOwnProperty("sortable"))
                                object.sortable = $root.google.protobuf.BoolValue.toObject(message.sortable, options);
                            if (message.selectableWith && message.selectableWith.length) {
                                object.selectableWith = [];
                                for (var j = 0; j < message.selectableWith.length; ++j)
                                    object.selectableWith[j] = $root.google.protobuf.StringValue.toObject(message.selectableWith[j], options);
                            }
                            if (message.attributeResources && message.attributeResources.length) {
                                object.attributeResources = [];
                                for (var j = 0; j < message.attributeResources.length; ++j)
                                    object.attributeResources[j] = $root.google.protobuf.StringValue.toObject(message.attributeResources[j], options);
                            }
                            if (message.metrics && message.metrics.length) {
                                object.metrics = [];
                                for (var j = 0; j < message.metrics.length; ++j)
                                    object.metrics[j] = $root.google.protobuf.StringValue.toObject(message.metrics[j], options);
                            }
                            if (message.segments && message.segments.length) {
                                object.segments = [];
                                for (var j = 0; j < message.segments.length; ++j)
                                    object.segments[j] = $root.google.protobuf.StringValue.toObject(message.segments[j], options);
                            }
                            if (message.enumValues && message.enumValues.length) {
                                object.enumValues = [];
                                for (var j = 0; j < message.enumValues.length; ++j)
                                    object.enumValues[j] = $root.google.protobuf.StringValue.toObject(message.enumValues[j], options);
                            }
                            if (message.dataType != null && message.hasOwnProperty("dataType"))
                                object.dataType = options.enums === String ? $root.google.ads.googleads.v1.enums.GoogleAdsFieldDataTypeEnum.GoogleAdsFieldDataType[message.dataType] : message.dataType;
                            if (message.typeUrl != null && message.hasOwnProperty("typeUrl"))
                                object.typeUrl = $root.google.protobuf.StringValue.toObject(message.typeUrl, options);
                            if (message.isRepeated != null && message.hasOwnProperty("isRepeated"))
                                object.isRepeated = $root.google.protobuf.BoolValue.toObject(message.isRepeated, options);
                            return object;
                        };

                        /**
                         * Converts this GoogleAdsField to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.GoogleAdsField
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GoogleAdsField.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GoogleAdsField;
                    })();

                    resources.GroupPlacementView = (function() {

                        /**
                         * Properties of a GroupPlacementView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IGroupPlacementView
                         * @property {string|null} [resourceName] GroupPlacementView resourceName
                         * @property {google.protobuf.IStringValue|null} [placement] GroupPlacementView placement
                         * @property {google.protobuf.IStringValue|null} [displayName] GroupPlacementView displayName
                         * @property {google.protobuf.IStringValue|null} [targetUrl] GroupPlacementView targetUrl
                         * @property {google.ads.googleads.v1.enums.PlacementTypeEnum.PlacementType|null} [placementType] GroupPlacementView placementType
                         */

                        /**
                         * Constructs a new GroupPlacementView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a GroupPlacementView.
                         * @implements IGroupPlacementView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IGroupPlacementView=} [properties] Properties to set
                         */
                        function GroupPlacementView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GroupPlacementView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.GroupPlacementView
                         * @instance
                         */
                        GroupPlacementView.prototype.resourceName = "";

                        /**
                         * GroupPlacementView placement.
                         * @member {google.protobuf.IStringValue|null|undefined} placement
                         * @memberof google.ads.googleads.v1.resources.GroupPlacementView
                         * @instance
                         */
                        GroupPlacementView.prototype.placement = null;

                        /**
                         * GroupPlacementView displayName.
                         * @member {google.protobuf.IStringValue|null|undefined} displayName
                         * @memberof google.ads.googleads.v1.resources.GroupPlacementView
                         * @instance
                         */
                        GroupPlacementView.prototype.displayName = null;

                        /**
                         * GroupPlacementView targetUrl.
                         * @member {google.protobuf.IStringValue|null|undefined} targetUrl
                         * @memberof google.ads.googleads.v1.resources.GroupPlacementView
                         * @instance
                         */
                        GroupPlacementView.prototype.targetUrl = null;

                        /**
                         * GroupPlacementView placementType.
                         * @member {google.ads.googleads.v1.enums.PlacementTypeEnum.PlacementType} placementType
                         * @memberof google.ads.googleads.v1.resources.GroupPlacementView
                         * @instance
                         */
                        GroupPlacementView.prototype.placementType = 0;

                        /**
                         * Creates a new GroupPlacementView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.GroupPlacementView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IGroupPlacementView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.GroupPlacementView} GroupPlacementView instance
                         */
                        GroupPlacementView.create = function create(properties) {
                            return new GroupPlacementView(properties);
                        };

                        /**
                         * Encodes the specified GroupPlacementView message. Does not implicitly {@link google.ads.googleads.v1.resources.GroupPlacementView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.GroupPlacementView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IGroupPlacementView} message GroupPlacementView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GroupPlacementView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.placement != null && message.hasOwnProperty("placement"))
                                $root.google.protobuf.StringValue.encode(message.placement, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                $root.google.protobuf.StringValue.encode(message.displayName, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.targetUrl != null && message.hasOwnProperty("targetUrl"))
                                $root.google.protobuf.StringValue.encode(message.targetUrl, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.placementType != null && message.hasOwnProperty("placementType"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.placementType);
                            return writer;
                        };

                        /**
                         * Encodes the specified GroupPlacementView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.GroupPlacementView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.GroupPlacementView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IGroupPlacementView} message GroupPlacementView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GroupPlacementView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GroupPlacementView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.GroupPlacementView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.GroupPlacementView} GroupPlacementView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GroupPlacementView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.GroupPlacementView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.placement = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.displayName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.targetUrl = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.placementType = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GroupPlacementView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.GroupPlacementView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.GroupPlacementView} GroupPlacementView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GroupPlacementView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GroupPlacementView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.GroupPlacementView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GroupPlacementView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.placement != null && message.hasOwnProperty("placement")) {
                                var error = $root.google.protobuf.StringValue.verify(message.placement);
                                if (error)
                                    return "placement." + error;
                            }
                            if (message.displayName != null && message.hasOwnProperty("displayName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.displayName);
                                if (error)
                                    return "displayName." + error;
                            }
                            if (message.targetUrl != null && message.hasOwnProperty("targetUrl")) {
                                var error = $root.google.protobuf.StringValue.verify(message.targetUrl);
                                if (error)
                                    return "targetUrl." + error;
                            }
                            if (message.placementType != null && message.hasOwnProperty("placementType"))
                                switch (message.placementType) {
                                default:
                                    return "placementType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a GroupPlacementView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.GroupPlacementView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.GroupPlacementView} GroupPlacementView
                         */
                        GroupPlacementView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.GroupPlacementView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.GroupPlacementView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.placement != null) {
                                if (typeof object.placement !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.GroupPlacementView.placement: object expected");
                                message.placement = $root.google.protobuf.StringValue.fromObject(object.placement);
                            }
                            if (object.displayName != null) {
                                if (typeof object.displayName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.GroupPlacementView.displayName: object expected");
                                message.displayName = $root.google.protobuf.StringValue.fromObject(object.displayName);
                            }
                            if (object.targetUrl != null) {
                                if (typeof object.targetUrl !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.GroupPlacementView.targetUrl: object expected");
                                message.targetUrl = $root.google.protobuf.StringValue.fromObject(object.targetUrl);
                            }
                            switch (object.placementType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.placementType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.placementType = 1;
                                break;
                            case "WEBSITE":
                            case 2:
                                message.placementType = 2;
                                break;
                            case "MOBILE_APP_CATEGORY":
                            case 3:
                                message.placementType = 3;
                                break;
                            case "MOBILE_APPLICATION":
                            case 4:
                                message.placementType = 4;
                                break;
                            case "YOUTUBE_VIDEO":
                            case 5:
                                message.placementType = 5;
                                break;
                            case "YOUTUBE_CHANNEL":
                            case 6:
                                message.placementType = 6;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a GroupPlacementView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.GroupPlacementView
                         * @static
                         * @param {google.ads.googleads.v1.resources.GroupPlacementView} message GroupPlacementView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GroupPlacementView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.placement = null;
                                object.displayName = null;
                                object.targetUrl = null;
                                object.placementType = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.placement != null && message.hasOwnProperty("placement"))
                                object.placement = $root.google.protobuf.StringValue.toObject(message.placement, options);
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = $root.google.protobuf.StringValue.toObject(message.displayName, options);
                            if (message.targetUrl != null && message.hasOwnProperty("targetUrl"))
                                object.targetUrl = $root.google.protobuf.StringValue.toObject(message.targetUrl, options);
                            if (message.placementType != null && message.hasOwnProperty("placementType"))
                                object.placementType = options.enums === String ? $root.google.ads.googleads.v1.enums.PlacementTypeEnum.PlacementType[message.placementType] : message.placementType;
                            return object;
                        };

                        /**
                         * Converts this GroupPlacementView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.GroupPlacementView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GroupPlacementView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GroupPlacementView;
                    })();

                    resources.HotelGroupView = (function() {

                        /**
                         * Properties of a HotelGroupView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IHotelGroupView
                         * @property {string|null} [resourceName] HotelGroupView resourceName
                         */

                        /**
                         * Constructs a new HotelGroupView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a HotelGroupView.
                         * @implements IHotelGroupView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IHotelGroupView=} [properties] Properties to set
                         */
                        function HotelGroupView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * HotelGroupView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.HotelGroupView
                         * @instance
                         */
                        HotelGroupView.prototype.resourceName = "";

                        /**
                         * Creates a new HotelGroupView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.HotelGroupView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IHotelGroupView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.HotelGroupView} HotelGroupView instance
                         */
                        HotelGroupView.create = function create(properties) {
                            return new HotelGroupView(properties);
                        };

                        /**
                         * Encodes the specified HotelGroupView message. Does not implicitly {@link google.ads.googleads.v1.resources.HotelGroupView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.HotelGroupView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IHotelGroupView} message HotelGroupView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelGroupView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified HotelGroupView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.HotelGroupView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.HotelGroupView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IHotelGroupView} message HotelGroupView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelGroupView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a HotelGroupView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.HotelGroupView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.HotelGroupView} HotelGroupView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelGroupView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.HotelGroupView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a HotelGroupView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.HotelGroupView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.HotelGroupView} HotelGroupView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelGroupView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a HotelGroupView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.HotelGroupView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HotelGroupView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a HotelGroupView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.HotelGroupView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.HotelGroupView} HotelGroupView
                         */
                        HotelGroupView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.HotelGroupView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.HotelGroupView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a HotelGroupView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.HotelGroupView
                         * @static
                         * @param {google.ads.googleads.v1.resources.HotelGroupView} message HotelGroupView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HotelGroupView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this HotelGroupView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.HotelGroupView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HotelGroupView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return HotelGroupView;
                    })();

                    resources.HotelPerformanceView = (function() {

                        /**
                         * Properties of a HotelPerformanceView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IHotelPerformanceView
                         * @property {string|null} [resourceName] HotelPerformanceView resourceName
                         */

                        /**
                         * Constructs a new HotelPerformanceView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a HotelPerformanceView.
                         * @implements IHotelPerformanceView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IHotelPerformanceView=} [properties] Properties to set
                         */
                        function HotelPerformanceView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * HotelPerformanceView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.HotelPerformanceView
                         * @instance
                         */
                        HotelPerformanceView.prototype.resourceName = "";

                        /**
                         * Creates a new HotelPerformanceView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.HotelPerformanceView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IHotelPerformanceView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.HotelPerformanceView} HotelPerformanceView instance
                         */
                        HotelPerformanceView.create = function create(properties) {
                            return new HotelPerformanceView(properties);
                        };

                        /**
                         * Encodes the specified HotelPerformanceView message. Does not implicitly {@link google.ads.googleads.v1.resources.HotelPerformanceView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.HotelPerformanceView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IHotelPerformanceView} message HotelPerformanceView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelPerformanceView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified HotelPerformanceView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.HotelPerformanceView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.HotelPerformanceView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IHotelPerformanceView} message HotelPerformanceView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HotelPerformanceView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a HotelPerformanceView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.HotelPerformanceView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.HotelPerformanceView} HotelPerformanceView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelPerformanceView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.HotelPerformanceView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a HotelPerformanceView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.HotelPerformanceView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.HotelPerformanceView} HotelPerformanceView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HotelPerformanceView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a HotelPerformanceView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.HotelPerformanceView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HotelPerformanceView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a HotelPerformanceView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.HotelPerformanceView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.HotelPerformanceView} HotelPerformanceView
                         */
                        HotelPerformanceView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.HotelPerformanceView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.HotelPerformanceView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a HotelPerformanceView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.HotelPerformanceView
                         * @static
                         * @param {google.ads.googleads.v1.resources.HotelPerformanceView} message HotelPerformanceView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HotelPerformanceView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this HotelPerformanceView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.HotelPerformanceView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HotelPerformanceView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return HotelPerformanceView;
                    })();

                    resources.KeywordPlan = (function() {

                        /**
                         * Properties of a KeywordPlan.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IKeywordPlan
                         * @property {string|null} [resourceName] KeywordPlan resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] KeywordPlan id
                         * @property {google.protobuf.IStringValue|null} [name] KeywordPlan name
                         * @property {google.ads.googleads.v1.resources.IKeywordPlanForecastPeriod|null} [forecastPeriod] KeywordPlan forecastPeriod
                         */

                        /**
                         * Constructs a new KeywordPlan.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a KeywordPlan.
                         * @implements IKeywordPlan
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IKeywordPlan=} [properties] Properties to set
                         */
                        function KeywordPlan(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordPlan resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.KeywordPlan
                         * @instance
                         */
                        KeywordPlan.prototype.resourceName = "";

                        /**
                         * KeywordPlan id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.KeywordPlan
                         * @instance
                         */
                        KeywordPlan.prototype.id = null;

                        /**
                         * KeywordPlan name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.KeywordPlan
                         * @instance
                         */
                        KeywordPlan.prototype.name = null;

                        /**
                         * KeywordPlan forecastPeriod.
                         * @member {google.ads.googleads.v1.resources.IKeywordPlanForecastPeriod|null|undefined} forecastPeriod
                         * @memberof google.ads.googleads.v1.resources.KeywordPlan
                         * @instance
                         */
                        KeywordPlan.prototype.forecastPeriod = null;

                        /**
                         * Creates a new KeywordPlan instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.KeywordPlan
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlan=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.KeywordPlan} KeywordPlan instance
                         */
                        KeywordPlan.create = function create(properties) {
                            return new KeywordPlan(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlan message. Does not implicitly {@link google.ads.googleads.v1.resources.KeywordPlan.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.KeywordPlan
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlan} message KeywordPlan message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlan.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.forecastPeriod != null && message.hasOwnProperty("forecastPeriod"))
                                $root.google.ads.googleads.v1.resources.KeywordPlanForecastPeriod.encode(message.forecastPeriod, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlan message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.KeywordPlan.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.KeywordPlan
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlan} message KeywordPlan message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlan.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlan message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.KeywordPlan
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.KeywordPlan} KeywordPlan
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlan.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.KeywordPlan();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.forecastPeriod = $root.google.ads.googleads.v1.resources.KeywordPlanForecastPeriod.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlan message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.KeywordPlan
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.KeywordPlan} KeywordPlan
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlan.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlan message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.KeywordPlan
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlan.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.forecastPeriod != null && message.hasOwnProperty("forecastPeriod")) {
                                var error = $root.google.ads.googleads.v1.resources.KeywordPlanForecastPeriod.verify(message.forecastPeriod);
                                if (error)
                                    return "forecastPeriod." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a KeywordPlan message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.KeywordPlan
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.KeywordPlan} KeywordPlan
                         */
                        KeywordPlan.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.KeywordPlan)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.KeywordPlan();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlan.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlan.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            if (object.forecastPeriod != null) {
                                if (typeof object.forecastPeriod !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlan.forecastPeriod: object expected");
                                message.forecastPeriod = $root.google.ads.googleads.v1.resources.KeywordPlanForecastPeriod.fromObject(object.forecastPeriod);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordPlan message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.KeywordPlan
                         * @static
                         * @param {google.ads.googleads.v1.resources.KeywordPlan} message KeywordPlan
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlan.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.name = null;
                                object.forecastPeriod = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.forecastPeriod != null && message.hasOwnProperty("forecastPeriod"))
                                object.forecastPeriod = $root.google.ads.googleads.v1.resources.KeywordPlanForecastPeriod.toObject(message.forecastPeriod, options);
                            return object;
                        };

                        /**
                         * Converts this KeywordPlan to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.KeywordPlan
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlan.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordPlan;
                    })();

                    resources.KeywordPlanForecastPeriod = (function() {

                        /**
                         * Properties of a KeywordPlanForecastPeriod.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IKeywordPlanForecastPeriod
                         * @property {google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum.KeywordPlanForecastInterval|null} [dateInterval] KeywordPlanForecastPeriod dateInterval
                         * @property {google.ads.googleads.v1.common.IDateRange|null} [dateRange] KeywordPlanForecastPeriod dateRange
                         */

                        /**
                         * Constructs a new KeywordPlanForecastPeriod.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a KeywordPlanForecastPeriod.
                         * @implements IKeywordPlanForecastPeriod
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanForecastPeriod=} [properties] Properties to set
                         */
                        function KeywordPlanForecastPeriod(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordPlanForecastPeriod dateInterval.
                         * @member {google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum.KeywordPlanForecastInterval} dateInterval
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanForecastPeriod
                         * @instance
                         */
                        KeywordPlanForecastPeriod.prototype.dateInterval = 0;

                        /**
                         * KeywordPlanForecastPeriod dateRange.
                         * @member {google.ads.googleads.v1.common.IDateRange|null|undefined} dateRange
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanForecastPeriod
                         * @instance
                         */
                        KeywordPlanForecastPeriod.prototype.dateRange = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * KeywordPlanForecastPeriod interval.
                         * @member {"dateInterval"|"dateRange"|undefined} interval
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanForecastPeriod
                         * @instance
                         */
                        Object.defineProperty(KeywordPlanForecastPeriod.prototype, "interval", {
                            get: $util.oneOfGetter($oneOfFields = ["dateInterval", "dateRange"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new KeywordPlanForecastPeriod instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanForecastPeriod
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanForecastPeriod=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanForecastPeriod} KeywordPlanForecastPeriod instance
                         */
                        KeywordPlanForecastPeriod.create = function create(properties) {
                            return new KeywordPlanForecastPeriod(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanForecastPeriod message. Does not implicitly {@link google.ads.googleads.v1.resources.KeywordPlanForecastPeriod.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanForecastPeriod
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanForecastPeriod} message KeywordPlanForecastPeriod message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanForecastPeriod.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dateInterval != null && message.hasOwnProperty("dateInterval"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.dateInterval);
                            if (message.dateRange != null && message.hasOwnProperty("dateRange"))
                                $root.google.ads.googleads.v1.common.DateRange.encode(message.dateRange, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanForecastPeriod message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.KeywordPlanForecastPeriod.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanForecastPeriod
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanForecastPeriod} message KeywordPlanForecastPeriod message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanForecastPeriod.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanForecastPeriod message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanForecastPeriod
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanForecastPeriod} KeywordPlanForecastPeriod
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanForecastPeriod.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.KeywordPlanForecastPeriod();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.dateInterval = reader.int32();
                                    break;
                                case 2:
                                    message.dateRange = $root.google.ads.googleads.v1.common.DateRange.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanForecastPeriod message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanForecastPeriod
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanForecastPeriod} KeywordPlanForecastPeriod
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanForecastPeriod.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanForecastPeriod message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanForecastPeriod
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanForecastPeriod.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.dateInterval != null && message.hasOwnProperty("dateInterval")) {
                                properties.interval = 1;
                                switch (message.dateInterval) {
                                default:
                                    return "dateInterval: enum value expected";
                                case 0:
                                case 1:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            }
                            if (message.dateRange != null && message.hasOwnProperty("dateRange")) {
                                if (properties.interval === 1)
                                    return "interval: multiple values";
                                properties.interval = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.DateRange.verify(message.dateRange);
                                    if (error)
                                        return "dateRange." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanForecastPeriod message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanForecastPeriod
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanForecastPeriod} KeywordPlanForecastPeriod
                         */
                        KeywordPlanForecastPeriod.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.KeywordPlanForecastPeriod)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.KeywordPlanForecastPeriod();
                            switch (object.dateInterval) {
                            case "UNSPECIFIED":
                            case 0:
                                message.dateInterval = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.dateInterval = 1;
                                break;
                            case "NEXT_WEEK":
                            case 3:
                                message.dateInterval = 3;
                                break;
                            case "NEXT_MONTH":
                            case 4:
                                message.dateInterval = 4;
                                break;
                            case "NEXT_QUARTER":
                            case 5:
                                message.dateInterval = 5;
                                break;
                            }
                            if (object.dateRange != null) {
                                if (typeof object.dateRange !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanForecastPeriod.dateRange: object expected");
                                message.dateRange = $root.google.ads.googleads.v1.common.DateRange.fromObject(object.dateRange);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordPlanForecastPeriod message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanForecastPeriod
                         * @static
                         * @param {google.ads.googleads.v1.resources.KeywordPlanForecastPeriod} message KeywordPlanForecastPeriod
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanForecastPeriod.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.dateInterval != null && message.hasOwnProperty("dateInterval")) {
                                object.dateInterval = options.enums === String ? $root.google.ads.googleads.v1.enums.KeywordPlanForecastIntervalEnum.KeywordPlanForecastInterval[message.dateInterval] : message.dateInterval;
                                if (options.oneofs)
                                    object.interval = "dateInterval";
                            }
                            if (message.dateRange != null && message.hasOwnProperty("dateRange")) {
                                object.dateRange = $root.google.ads.googleads.v1.common.DateRange.toObject(message.dateRange, options);
                                if (options.oneofs)
                                    object.interval = "dateRange";
                            }
                            return object;
                        };

                        /**
                         * Converts this KeywordPlanForecastPeriod to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanForecastPeriod
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanForecastPeriod.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordPlanForecastPeriod;
                    })();

                    resources.KeywordPlanAdGroup = (function() {

                        /**
                         * Properties of a KeywordPlanAdGroup.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IKeywordPlanAdGroup
                         * @property {string|null} [resourceName] KeywordPlanAdGroup resourceName
                         * @property {google.protobuf.IStringValue|null} [keywordPlanCampaign] KeywordPlanAdGroup keywordPlanCampaign
                         * @property {google.protobuf.IInt64Value|null} [id] KeywordPlanAdGroup id
                         * @property {google.protobuf.IStringValue|null} [name] KeywordPlanAdGroup name
                         * @property {google.protobuf.IInt64Value|null} [cpcBidMicros] KeywordPlanAdGroup cpcBidMicros
                         */

                        /**
                         * Constructs a new KeywordPlanAdGroup.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a KeywordPlanAdGroup.
                         * @implements IKeywordPlanAdGroup
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanAdGroup=} [properties] Properties to set
                         */
                        function KeywordPlanAdGroup(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordPlanAdGroup resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanAdGroup
                         * @instance
                         */
                        KeywordPlanAdGroup.prototype.resourceName = "";

                        /**
                         * KeywordPlanAdGroup keywordPlanCampaign.
                         * @member {google.protobuf.IStringValue|null|undefined} keywordPlanCampaign
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanAdGroup
                         * @instance
                         */
                        KeywordPlanAdGroup.prototype.keywordPlanCampaign = null;

                        /**
                         * KeywordPlanAdGroup id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanAdGroup
                         * @instance
                         */
                        KeywordPlanAdGroup.prototype.id = null;

                        /**
                         * KeywordPlanAdGroup name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanAdGroup
                         * @instance
                         */
                        KeywordPlanAdGroup.prototype.name = null;

                        /**
                         * KeywordPlanAdGroup cpcBidMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpcBidMicros
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanAdGroup
                         * @instance
                         */
                        KeywordPlanAdGroup.prototype.cpcBidMicros = null;

                        /**
                         * Creates a new KeywordPlanAdGroup instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanAdGroup
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanAdGroup=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanAdGroup} KeywordPlanAdGroup instance
                         */
                        KeywordPlanAdGroup.create = function create(properties) {
                            return new KeywordPlanAdGroup(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanAdGroup message. Does not implicitly {@link google.ads.googleads.v1.resources.KeywordPlanAdGroup.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanAdGroup
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanAdGroup} message KeywordPlanAdGroup message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanAdGroup.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.keywordPlanCampaign != null && message.hasOwnProperty("keywordPlanCampaign"))
                                $root.google.protobuf.StringValue.encode(message.keywordPlanCampaign, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpcBidMicros, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanAdGroup message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.KeywordPlanAdGroup.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanAdGroup
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanAdGroup} message KeywordPlanAdGroup message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanAdGroup.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanAdGroup message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanAdGroup
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanAdGroup} KeywordPlanAdGroup
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanAdGroup.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.keywordPlanCampaign = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.cpcBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanAdGroup message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanAdGroup
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanAdGroup} KeywordPlanAdGroup
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanAdGroup.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanAdGroup message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanAdGroup
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanAdGroup.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.keywordPlanCampaign != null && message.hasOwnProperty("keywordPlanCampaign")) {
                                var error = $root.google.protobuf.StringValue.verify(message.keywordPlanCampaign);
                                if (error)
                                    return "keywordPlanCampaign." + error;
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpcBidMicros);
                                if (error)
                                    return "cpcBidMicros." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanAdGroup message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanAdGroup
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanAdGroup} KeywordPlanAdGroup
                         */
                        KeywordPlanAdGroup.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.keywordPlanCampaign != null) {
                                if (typeof object.keywordPlanCampaign !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanAdGroup.keywordPlanCampaign: object expected");
                                message.keywordPlanCampaign = $root.google.protobuf.StringValue.fromObject(object.keywordPlanCampaign);
                            }
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanAdGroup.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanAdGroup.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            if (object.cpcBidMicros != null) {
                                if (typeof object.cpcBidMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanAdGroup.cpcBidMicros: object expected");
                                message.cpcBidMicros = $root.google.protobuf.Int64Value.fromObject(object.cpcBidMicros);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordPlanAdGroup message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanAdGroup
                         * @static
                         * @param {google.ads.googleads.v1.resources.KeywordPlanAdGroup} message KeywordPlanAdGroup
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanAdGroup.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.keywordPlanCampaign = null;
                                object.id = null;
                                object.name = null;
                                object.cpcBidMicros = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.keywordPlanCampaign != null && message.hasOwnProperty("keywordPlanCampaign"))
                                object.keywordPlanCampaign = $root.google.protobuf.StringValue.toObject(message.keywordPlanCampaign, options);
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros"))
                                object.cpcBidMicros = $root.google.protobuf.Int64Value.toObject(message.cpcBidMicros, options);
                            return object;
                        };

                        /**
                         * Converts this KeywordPlanAdGroup to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanAdGroup
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanAdGroup.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordPlanAdGroup;
                    })();

                    resources.KeywordPlanCampaign = (function() {

                        /**
                         * Properties of a KeywordPlanCampaign.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IKeywordPlanCampaign
                         * @property {string|null} [resourceName] KeywordPlanCampaign resourceName
                         * @property {google.protobuf.IStringValue|null} [keywordPlan] KeywordPlanCampaign keywordPlan
                         * @property {google.protobuf.IInt64Value|null} [id] KeywordPlanCampaign id
                         * @property {google.protobuf.IStringValue|null} [name] KeywordPlanCampaign name
                         * @property {Array.<google.protobuf.IStringValue>|null} [languageConstants] KeywordPlanCampaign languageConstants
                         * @property {google.ads.googleads.v1.enums.KeywordPlanNetworkEnum.KeywordPlanNetwork|null} [keywordPlanNetwork] KeywordPlanCampaign keywordPlanNetwork
                         * @property {google.protobuf.IInt64Value|null} [cpcBidMicros] KeywordPlanCampaign cpcBidMicros
                         * @property {Array.<google.ads.googleads.v1.resources.IKeywordPlanGeoTarget>|null} [geoTargets] KeywordPlanCampaign geoTargets
                         */

                        /**
                         * Constructs a new KeywordPlanCampaign.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a KeywordPlanCampaign.
                         * @implements IKeywordPlanCampaign
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanCampaign=} [properties] Properties to set
                         */
                        function KeywordPlanCampaign(properties) {
                            this.languageConstants = [];
                            this.geoTargets = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordPlanCampaign resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanCampaign
                         * @instance
                         */
                        KeywordPlanCampaign.prototype.resourceName = "";

                        /**
                         * KeywordPlanCampaign keywordPlan.
                         * @member {google.protobuf.IStringValue|null|undefined} keywordPlan
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanCampaign
                         * @instance
                         */
                        KeywordPlanCampaign.prototype.keywordPlan = null;

                        /**
                         * KeywordPlanCampaign id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanCampaign
                         * @instance
                         */
                        KeywordPlanCampaign.prototype.id = null;

                        /**
                         * KeywordPlanCampaign name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanCampaign
                         * @instance
                         */
                        KeywordPlanCampaign.prototype.name = null;

                        /**
                         * KeywordPlanCampaign languageConstants.
                         * @member {Array.<google.protobuf.IStringValue>} languageConstants
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanCampaign
                         * @instance
                         */
                        KeywordPlanCampaign.prototype.languageConstants = $util.emptyArray;

                        /**
                         * KeywordPlanCampaign keywordPlanNetwork.
                         * @member {google.ads.googleads.v1.enums.KeywordPlanNetworkEnum.KeywordPlanNetwork} keywordPlanNetwork
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanCampaign
                         * @instance
                         */
                        KeywordPlanCampaign.prototype.keywordPlanNetwork = 0;

                        /**
                         * KeywordPlanCampaign cpcBidMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpcBidMicros
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanCampaign
                         * @instance
                         */
                        KeywordPlanCampaign.prototype.cpcBidMicros = null;

                        /**
                         * KeywordPlanCampaign geoTargets.
                         * @member {Array.<google.ads.googleads.v1.resources.IKeywordPlanGeoTarget>} geoTargets
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanCampaign
                         * @instance
                         */
                        KeywordPlanCampaign.prototype.geoTargets = $util.emptyArray;

                        /**
                         * Creates a new KeywordPlanCampaign instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanCampaign
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanCampaign=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanCampaign} KeywordPlanCampaign instance
                         */
                        KeywordPlanCampaign.create = function create(properties) {
                            return new KeywordPlanCampaign(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanCampaign message. Does not implicitly {@link google.ads.googleads.v1.resources.KeywordPlanCampaign.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanCampaign
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanCampaign} message KeywordPlanCampaign message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanCampaign.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.keywordPlan != null && message.hasOwnProperty("keywordPlan"))
                                $root.google.protobuf.StringValue.encode(message.keywordPlan, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.languageConstants != null && message.languageConstants.length)
                                for (var i = 0; i < message.languageConstants.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.languageConstants[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.keywordPlanNetwork != null && message.hasOwnProperty("keywordPlanNetwork"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.keywordPlanNetwork);
                            if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpcBidMicros, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.geoTargets != null && message.geoTargets.length)
                                for (var i = 0; i < message.geoTargets.length; ++i)
                                    $root.google.ads.googleads.v1.resources.KeywordPlanGeoTarget.encode(message.geoTargets[i], writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanCampaign message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.KeywordPlanCampaign.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanCampaign
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanCampaign} message KeywordPlanCampaign message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanCampaign.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanCampaign message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanCampaign
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanCampaign} KeywordPlanCampaign
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanCampaign.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.KeywordPlanCampaign();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.keywordPlan = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    if (!(message.languageConstants && message.languageConstants.length))
                                        message.languageConstants = [];
                                    message.languageConstants.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 6:
                                    message.keywordPlanNetwork = reader.int32();
                                    break;
                                case 7:
                                    message.cpcBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    if (!(message.geoTargets && message.geoTargets.length))
                                        message.geoTargets = [];
                                    message.geoTargets.push($root.google.ads.googleads.v1.resources.KeywordPlanGeoTarget.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanCampaign message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanCampaign
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanCampaign} KeywordPlanCampaign
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanCampaign.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanCampaign message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanCampaign
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanCampaign.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.keywordPlan != null && message.hasOwnProperty("keywordPlan")) {
                                var error = $root.google.protobuf.StringValue.verify(message.keywordPlan);
                                if (error)
                                    return "keywordPlan." + error;
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.languageConstants != null && message.hasOwnProperty("languageConstants")) {
                                if (!Array.isArray(message.languageConstants))
                                    return "languageConstants: array expected";
                                for (var i = 0; i < message.languageConstants.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.languageConstants[i]);
                                    if (error)
                                        return "languageConstants." + error;
                                }
                            }
                            if (message.keywordPlanNetwork != null && message.hasOwnProperty("keywordPlanNetwork"))
                                switch (message.keywordPlanNetwork) {
                                default:
                                    return "keywordPlanNetwork: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpcBidMicros);
                                if (error)
                                    return "cpcBidMicros." + error;
                            }
                            if (message.geoTargets != null && message.hasOwnProperty("geoTargets")) {
                                if (!Array.isArray(message.geoTargets))
                                    return "geoTargets: array expected";
                                for (var i = 0; i < message.geoTargets.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.resources.KeywordPlanGeoTarget.verify(message.geoTargets[i]);
                                    if (error)
                                        return "geoTargets." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanCampaign message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanCampaign
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanCampaign} KeywordPlanCampaign
                         */
                        KeywordPlanCampaign.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.KeywordPlanCampaign)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.KeywordPlanCampaign();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.keywordPlan != null) {
                                if (typeof object.keywordPlan !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanCampaign.keywordPlan: object expected");
                                message.keywordPlan = $root.google.protobuf.StringValue.fromObject(object.keywordPlan);
                            }
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanCampaign.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanCampaign.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            if (object.languageConstants) {
                                if (!Array.isArray(object.languageConstants))
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanCampaign.languageConstants: array expected");
                                message.languageConstants = [];
                                for (var i = 0; i < object.languageConstants.length; ++i) {
                                    if (typeof object.languageConstants[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanCampaign.languageConstants: object expected");
                                    message.languageConstants[i] = $root.google.protobuf.StringValue.fromObject(object.languageConstants[i]);
                                }
                            }
                            switch (object.keywordPlanNetwork) {
                            case "UNSPECIFIED":
                            case 0:
                                message.keywordPlanNetwork = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.keywordPlanNetwork = 1;
                                break;
                            case "GOOGLE_SEARCH":
                            case 2:
                                message.keywordPlanNetwork = 2;
                                break;
                            case "GOOGLE_SEARCH_AND_PARTNERS":
                            case 3:
                                message.keywordPlanNetwork = 3;
                                break;
                            }
                            if (object.cpcBidMicros != null) {
                                if (typeof object.cpcBidMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanCampaign.cpcBidMicros: object expected");
                                message.cpcBidMicros = $root.google.protobuf.Int64Value.fromObject(object.cpcBidMicros);
                            }
                            if (object.geoTargets) {
                                if (!Array.isArray(object.geoTargets))
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanCampaign.geoTargets: array expected");
                                message.geoTargets = [];
                                for (var i = 0; i < object.geoTargets.length; ++i) {
                                    if (typeof object.geoTargets[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanCampaign.geoTargets: object expected");
                                    message.geoTargets[i] = $root.google.ads.googleads.v1.resources.KeywordPlanGeoTarget.fromObject(object.geoTargets[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordPlanCampaign message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanCampaign
                         * @static
                         * @param {google.ads.googleads.v1.resources.KeywordPlanCampaign} message KeywordPlanCampaign
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanCampaign.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.languageConstants = [];
                                object.geoTargets = [];
                            }
                            if (options.defaults) {
                                object.resourceName = "";
                                object.keywordPlan = null;
                                object.id = null;
                                object.name = null;
                                object.keywordPlanNetwork = options.enums === String ? "UNSPECIFIED" : 0;
                                object.cpcBidMicros = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.keywordPlan != null && message.hasOwnProperty("keywordPlan"))
                                object.keywordPlan = $root.google.protobuf.StringValue.toObject(message.keywordPlan, options);
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.languageConstants && message.languageConstants.length) {
                                object.languageConstants = [];
                                for (var j = 0; j < message.languageConstants.length; ++j)
                                    object.languageConstants[j] = $root.google.protobuf.StringValue.toObject(message.languageConstants[j], options);
                            }
                            if (message.keywordPlanNetwork != null && message.hasOwnProperty("keywordPlanNetwork"))
                                object.keywordPlanNetwork = options.enums === String ? $root.google.ads.googleads.v1.enums.KeywordPlanNetworkEnum.KeywordPlanNetwork[message.keywordPlanNetwork] : message.keywordPlanNetwork;
                            if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros"))
                                object.cpcBidMicros = $root.google.protobuf.Int64Value.toObject(message.cpcBidMicros, options);
                            if (message.geoTargets && message.geoTargets.length) {
                                object.geoTargets = [];
                                for (var j = 0; j < message.geoTargets.length; ++j)
                                    object.geoTargets[j] = $root.google.ads.googleads.v1.resources.KeywordPlanGeoTarget.toObject(message.geoTargets[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this KeywordPlanCampaign to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanCampaign
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanCampaign.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordPlanCampaign;
                    })();

                    resources.KeywordPlanGeoTarget = (function() {

                        /**
                         * Properties of a KeywordPlanGeoTarget.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IKeywordPlanGeoTarget
                         * @property {google.protobuf.IStringValue|null} [geoTargetConstant] KeywordPlanGeoTarget geoTargetConstant
                         */

                        /**
                         * Constructs a new KeywordPlanGeoTarget.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a KeywordPlanGeoTarget.
                         * @implements IKeywordPlanGeoTarget
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanGeoTarget=} [properties] Properties to set
                         */
                        function KeywordPlanGeoTarget(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordPlanGeoTarget geoTargetConstant.
                         * @member {google.protobuf.IStringValue|null|undefined} geoTargetConstant
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanGeoTarget
                         * @instance
                         */
                        KeywordPlanGeoTarget.prototype.geoTargetConstant = null;

                        /**
                         * Creates a new KeywordPlanGeoTarget instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanGeoTarget
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanGeoTarget=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanGeoTarget} KeywordPlanGeoTarget instance
                         */
                        KeywordPlanGeoTarget.create = function create(properties) {
                            return new KeywordPlanGeoTarget(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanGeoTarget message. Does not implicitly {@link google.ads.googleads.v1.resources.KeywordPlanGeoTarget.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanGeoTarget
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanGeoTarget} message KeywordPlanGeoTarget message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanGeoTarget.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.geoTargetConstant != null && message.hasOwnProperty("geoTargetConstant"))
                                $root.google.protobuf.StringValue.encode(message.geoTargetConstant, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanGeoTarget message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.KeywordPlanGeoTarget.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanGeoTarget
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanGeoTarget} message KeywordPlanGeoTarget message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanGeoTarget.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanGeoTarget message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanGeoTarget
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanGeoTarget} KeywordPlanGeoTarget
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanGeoTarget.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.KeywordPlanGeoTarget();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.geoTargetConstant = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanGeoTarget message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanGeoTarget
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanGeoTarget} KeywordPlanGeoTarget
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanGeoTarget.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanGeoTarget message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanGeoTarget
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanGeoTarget.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.geoTargetConstant != null && message.hasOwnProperty("geoTargetConstant")) {
                                var error = $root.google.protobuf.StringValue.verify(message.geoTargetConstant);
                                if (error)
                                    return "geoTargetConstant." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanGeoTarget message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanGeoTarget
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanGeoTarget} KeywordPlanGeoTarget
                         */
                        KeywordPlanGeoTarget.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.KeywordPlanGeoTarget)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.KeywordPlanGeoTarget();
                            if (object.geoTargetConstant != null) {
                                if (typeof object.geoTargetConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanGeoTarget.geoTargetConstant: object expected");
                                message.geoTargetConstant = $root.google.protobuf.StringValue.fromObject(object.geoTargetConstant);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordPlanGeoTarget message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanGeoTarget
                         * @static
                         * @param {google.ads.googleads.v1.resources.KeywordPlanGeoTarget} message KeywordPlanGeoTarget
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanGeoTarget.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.geoTargetConstant = null;
                            if (message.geoTargetConstant != null && message.hasOwnProperty("geoTargetConstant"))
                                object.geoTargetConstant = $root.google.protobuf.StringValue.toObject(message.geoTargetConstant, options);
                            return object;
                        };

                        /**
                         * Converts this KeywordPlanGeoTarget to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanGeoTarget
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanGeoTarget.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordPlanGeoTarget;
                    })();

                    resources.KeywordPlanKeyword = (function() {

                        /**
                         * Properties of a KeywordPlanKeyword.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IKeywordPlanKeyword
                         * @property {string|null} [resourceName] KeywordPlanKeyword resourceName
                         * @property {google.protobuf.IStringValue|null} [keywordPlanAdGroup] KeywordPlanKeyword keywordPlanAdGroup
                         * @property {google.protobuf.IInt64Value|null} [id] KeywordPlanKeyword id
                         * @property {google.protobuf.IStringValue|null} [text] KeywordPlanKeyword text
                         * @property {google.ads.googleads.v1.enums.KeywordMatchTypeEnum.KeywordMatchType|null} [matchType] KeywordPlanKeyword matchType
                         * @property {google.protobuf.IInt64Value|null} [cpcBidMicros] KeywordPlanKeyword cpcBidMicros
                         */

                        /**
                         * Constructs a new KeywordPlanKeyword.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a KeywordPlanKeyword.
                         * @implements IKeywordPlanKeyword
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanKeyword=} [properties] Properties to set
                         */
                        function KeywordPlanKeyword(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordPlanKeyword resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanKeyword
                         * @instance
                         */
                        KeywordPlanKeyword.prototype.resourceName = "";

                        /**
                         * KeywordPlanKeyword keywordPlanAdGroup.
                         * @member {google.protobuf.IStringValue|null|undefined} keywordPlanAdGroup
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanKeyword
                         * @instance
                         */
                        KeywordPlanKeyword.prototype.keywordPlanAdGroup = null;

                        /**
                         * KeywordPlanKeyword id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanKeyword
                         * @instance
                         */
                        KeywordPlanKeyword.prototype.id = null;

                        /**
                         * KeywordPlanKeyword text.
                         * @member {google.protobuf.IStringValue|null|undefined} text
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanKeyword
                         * @instance
                         */
                        KeywordPlanKeyword.prototype.text = null;

                        /**
                         * KeywordPlanKeyword matchType.
                         * @member {google.ads.googleads.v1.enums.KeywordMatchTypeEnum.KeywordMatchType} matchType
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanKeyword
                         * @instance
                         */
                        KeywordPlanKeyword.prototype.matchType = 0;

                        /**
                         * KeywordPlanKeyword cpcBidMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} cpcBidMicros
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanKeyword
                         * @instance
                         */
                        KeywordPlanKeyword.prototype.cpcBidMicros = null;

                        /**
                         * Creates a new KeywordPlanKeyword instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanKeyword
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanKeyword=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanKeyword} KeywordPlanKeyword instance
                         */
                        KeywordPlanKeyword.create = function create(properties) {
                            return new KeywordPlanKeyword(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanKeyword message. Does not implicitly {@link google.ads.googleads.v1.resources.KeywordPlanKeyword.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanKeyword
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanKeyword} message KeywordPlanKeyword message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanKeyword.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.keywordPlanAdGroup != null && message.hasOwnProperty("keywordPlanAdGroup"))
                                $root.google.protobuf.StringValue.encode(message.keywordPlanAdGroup, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.text != null && message.hasOwnProperty("text"))
                                $root.google.protobuf.StringValue.encode(message.text, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.matchType != null && message.hasOwnProperty("matchType"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.matchType);
                            if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros"))
                                $root.google.protobuf.Int64Value.encode(message.cpcBidMicros, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanKeyword message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.KeywordPlanKeyword.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanKeyword
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanKeyword} message KeywordPlanKeyword message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanKeyword.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanKeyword message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanKeyword
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanKeyword} KeywordPlanKeyword
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanKeyword.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.KeywordPlanKeyword();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.keywordPlanAdGroup = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.text = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.matchType = reader.int32();
                                    break;
                                case 6:
                                    message.cpcBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanKeyword message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanKeyword
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanKeyword} KeywordPlanKeyword
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanKeyword.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanKeyword message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanKeyword
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanKeyword.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.keywordPlanAdGroup != null && message.hasOwnProperty("keywordPlanAdGroup")) {
                                var error = $root.google.protobuf.StringValue.verify(message.keywordPlanAdGroup);
                                if (error)
                                    return "keywordPlanAdGroup." + error;
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.text != null && message.hasOwnProperty("text")) {
                                var error = $root.google.protobuf.StringValue.verify(message.text);
                                if (error)
                                    return "text." + error;
                            }
                            if (message.matchType != null && message.hasOwnProperty("matchType"))
                                switch (message.matchType) {
                                default:
                                    return "matchType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.cpcBidMicros);
                                if (error)
                                    return "cpcBidMicros." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanKeyword message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanKeyword
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanKeyword} KeywordPlanKeyword
                         */
                        KeywordPlanKeyword.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.KeywordPlanKeyword)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.KeywordPlanKeyword();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.keywordPlanAdGroup != null) {
                                if (typeof object.keywordPlanAdGroup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanKeyword.keywordPlanAdGroup: object expected");
                                message.keywordPlanAdGroup = $root.google.protobuf.StringValue.fromObject(object.keywordPlanAdGroup);
                            }
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanKeyword.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.text != null) {
                                if (typeof object.text !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanKeyword.text: object expected");
                                message.text = $root.google.protobuf.StringValue.fromObject(object.text);
                            }
                            switch (object.matchType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.matchType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.matchType = 1;
                                break;
                            case "EXACT":
                            case 2:
                                message.matchType = 2;
                                break;
                            case "PHRASE":
                            case 3:
                                message.matchType = 3;
                                break;
                            case "BROAD":
                            case 4:
                                message.matchType = 4;
                                break;
                            }
                            if (object.cpcBidMicros != null) {
                                if (typeof object.cpcBidMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanKeyword.cpcBidMicros: object expected");
                                message.cpcBidMicros = $root.google.protobuf.Int64Value.fromObject(object.cpcBidMicros);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordPlanKeyword message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanKeyword
                         * @static
                         * @param {google.ads.googleads.v1.resources.KeywordPlanKeyword} message KeywordPlanKeyword
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanKeyword.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.keywordPlanAdGroup = null;
                                object.id = null;
                                object.text = null;
                                object.matchType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.cpcBidMicros = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.keywordPlanAdGroup != null && message.hasOwnProperty("keywordPlanAdGroup"))
                                object.keywordPlanAdGroup = $root.google.protobuf.StringValue.toObject(message.keywordPlanAdGroup, options);
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.text != null && message.hasOwnProperty("text"))
                                object.text = $root.google.protobuf.StringValue.toObject(message.text, options);
                            if (message.matchType != null && message.hasOwnProperty("matchType"))
                                object.matchType = options.enums === String ? $root.google.ads.googleads.v1.enums.KeywordMatchTypeEnum.KeywordMatchType[message.matchType] : message.matchType;
                            if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros"))
                                object.cpcBidMicros = $root.google.protobuf.Int64Value.toObject(message.cpcBidMicros, options);
                            return object;
                        };

                        /**
                         * Converts this KeywordPlanKeyword to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanKeyword
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanKeyword.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordPlanKeyword;
                    })();

                    resources.KeywordPlanNegativeKeyword = (function() {

                        /**
                         * Properties of a KeywordPlanNegativeKeyword.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IKeywordPlanNegativeKeyword
                         * @property {string|null} [resourceName] KeywordPlanNegativeKeyword resourceName
                         * @property {google.protobuf.IStringValue|null} [keywordPlanCampaign] KeywordPlanNegativeKeyword keywordPlanCampaign
                         * @property {google.protobuf.IInt64Value|null} [id] KeywordPlanNegativeKeyword id
                         * @property {google.protobuf.IStringValue|null} [text] KeywordPlanNegativeKeyword text
                         * @property {google.ads.googleads.v1.enums.KeywordMatchTypeEnum.KeywordMatchType|null} [matchType] KeywordPlanNegativeKeyword matchType
                         */

                        /**
                         * Constructs a new KeywordPlanNegativeKeyword.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a KeywordPlanNegativeKeyword.
                         * @implements IKeywordPlanNegativeKeyword
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanNegativeKeyword=} [properties] Properties to set
                         */
                        function KeywordPlanNegativeKeyword(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordPlanNegativeKeyword resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword
                         * @instance
                         */
                        KeywordPlanNegativeKeyword.prototype.resourceName = "";

                        /**
                         * KeywordPlanNegativeKeyword keywordPlanCampaign.
                         * @member {google.protobuf.IStringValue|null|undefined} keywordPlanCampaign
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword
                         * @instance
                         */
                        KeywordPlanNegativeKeyword.prototype.keywordPlanCampaign = null;

                        /**
                         * KeywordPlanNegativeKeyword id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword
                         * @instance
                         */
                        KeywordPlanNegativeKeyword.prototype.id = null;

                        /**
                         * KeywordPlanNegativeKeyword text.
                         * @member {google.protobuf.IStringValue|null|undefined} text
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword
                         * @instance
                         */
                        KeywordPlanNegativeKeyword.prototype.text = null;

                        /**
                         * KeywordPlanNegativeKeyword matchType.
                         * @member {google.ads.googleads.v1.enums.KeywordMatchTypeEnum.KeywordMatchType} matchType
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword
                         * @instance
                         */
                        KeywordPlanNegativeKeyword.prototype.matchType = 0;

                        /**
                         * Creates a new KeywordPlanNegativeKeyword instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanNegativeKeyword=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword} KeywordPlanNegativeKeyword instance
                         */
                        KeywordPlanNegativeKeyword.create = function create(properties) {
                            return new KeywordPlanNegativeKeyword(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanNegativeKeyword message. Does not implicitly {@link google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanNegativeKeyword} message KeywordPlanNegativeKeyword message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanNegativeKeyword.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.keywordPlanCampaign != null && message.hasOwnProperty("keywordPlanCampaign"))
                                $root.google.protobuf.StringValue.encode(message.keywordPlanCampaign, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.text != null && message.hasOwnProperty("text"))
                                $root.google.protobuf.StringValue.encode(message.text, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.matchType != null && message.hasOwnProperty("matchType"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.matchType);
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanNegativeKeyword message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordPlanNegativeKeyword} message KeywordPlanNegativeKeyword message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanNegativeKeyword.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanNegativeKeyword message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword} KeywordPlanNegativeKeyword
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanNegativeKeyword.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.keywordPlanCampaign = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.text = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.matchType = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanNegativeKeyword message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword} KeywordPlanNegativeKeyword
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanNegativeKeyword.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanNegativeKeyword message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanNegativeKeyword.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.keywordPlanCampaign != null && message.hasOwnProperty("keywordPlanCampaign")) {
                                var error = $root.google.protobuf.StringValue.verify(message.keywordPlanCampaign);
                                if (error)
                                    return "keywordPlanCampaign." + error;
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.text != null && message.hasOwnProperty("text")) {
                                var error = $root.google.protobuf.StringValue.verify(message.text);
                                if (error)
                                    return "text." + error;
                            }
                            if (message.matchType != null && message.hasOwnProperty("matchType"))
                                switch (message.matchType) {
                                default:
                                    return "matchType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanNegativeKeyword message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword} KeywordPlanNegativeKeyword
                         */
                        KeywordPlanNegativeKeyword.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.keywordPlanCampaign != null) {
                                if (typeof object.keywordPlanCampaign !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.keywordPlanCampaign: object expected");
                                message.keywordPlanCampaign = $root.google.protobuf.StringValue.fromObject(object.keywordPlanCampaign);
                            }
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.text != null) {
                                if (typeof object.text !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.text: object expected");
                                message.text = $root.google.protobuf.StringValue.fromObject(object.text);
                            }
                            switch (object.matchType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.matchType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.matchType = 1;
                                break;
                            case "EXACT":
                            case 2:
                                message.matchType = 2;
                                break;
                            case "PHRASE":
                            case 3:
                                message.matchType = 3;
                                break;
                            case "BROAD":
                            case 4:
                                message.matchType = 4;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordPlanNegativeKeyword message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword
                         * @static
                         * @param {google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword} message KeywordPlanNegativeKeyword
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanNegativeKeyword.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.keywordPlanCampaign = null;
                                object.id = null;
                                object.text = null;
                                object.matchType = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.keywordPlanCampaign != null && message.hasOwnProperty("keywordPlanCampaign"))
                                object.keywordPlanCampaign = $root.google.protobuf.StringValue.toObject(message.keywordPlanCampaign, options);
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.text != null && message.hasOwnProperty("text"))
                                object.text = $root.google.protobuf.StringValue.toObject(message.text, options);
                            if (message.matchType != null && message.hasOwnProperty("matchType"))
                                object.matchType = options.enums === String ? $root.google.ads.googleads.v1.enums.KeywordMatchTypeEnum.KeywordMatchType[message.matchType] : message.matchType;
                            return object;
                        };

                        /**
                         * Converts this KeywordPlanNegativeKeyword to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanNegativeKeyword.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordPlanNegativeKeyword;
                    })();

                    resources.KeywordView = (function() {

                        /**
                         * Properties of a KeywordView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IKeywordView
                         * @property {string|null} [resourceName] KeywordView resourceName
                         */

                        /**
                         * Constructs a new KeywordView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a KeywordView.
                         * @implements IKeywordView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IKeywordView=} [properties] Properties to set
                         */
                        function KeywordView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.KeywordView
                         * @instance
                         */
                        KeywordView.prototype.resourceName = "";

                        /**
                         * Creates a new KeywordView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.KeywordView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.KeywordView} KeywordView instance
                         */
                        KeywordView.create = function create(properties) {
                            return new KeywordView(properties);
                        };

                        /**
                         * Encodes the specified KeywordView message. Does not implicitly {@link google.ads.googleads.v1.resources.KeywordView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.KeywordView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordView} message KeywordView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.KeywordView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.KeywordView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IKeywordView} message KeywordView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.KeywordView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.KeywordView} KeywordView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.KeywordView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.KeywordView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.KeywordView} KeywordView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.KeywordView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a KeywordView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.KeywordView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.KeywordView} KeywordView
                         */
                        KeywordView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.KeywordView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.KeywordView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.KeywordView
                         * @static
                         * @param {google.ads.googleads.v1.resources.KeywordView} message KeywordView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this KeywordView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.KeywordView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordView;
                    })();

                    resources.Label = (function() {

                        /**
                         * Properties of a Label.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ILabel
                         * @property {string|null} [resourceName] Label resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] Label id
                         * @property {google.protobuf.IStringValue|null} [name] Label name
                         * @property {google.ads.googleads.v1.enums.LabelStatusEnum.LabelStatus|null} [status] Label status
                         * @property {google.ads.googleads.v1.common.ITextLabel|null} [textLabel] Label textLabel
                         */

                        /**
                         * Constructs a new Label.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a Label.
                         * @implements ILabel
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ILabel=} [properties] Properties to set
                         */
                        function Label(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Label resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.Label
                         * @instance
                         */
                        Label.prototype.resourceName = "";

                        /**
                         * Label id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.Label
                         * @instance
                         */
                        Label.prototype.id = null;

                        /**
                         * Label name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.Label
                         * @instance
                         */
                        Label.prototype.name = null;

                        /**
                         * Label status.
                         * @member {google.ads.googleads.v1.enums.LabelStatusEnum.LabelStatus} status
                         * @memberof google.ads.googleads.v1.resources.Label
                         * @instance
                         */
                        Label.prototype.status = 0;

                        /**
                         * Label textLabel.
                         * @member {google.ads.googleads.v1.common.ITextLabel|null|undefined} textLabel
                         * @memberof google.ads.googleads.v1.resources.Label
                         * @instance
                         */
                        Label.prototype.textLabel = null;

                        /**
                         * Creates a new Label instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.Label
                         * @static
                         * @param {google.ads.googleads.v1.resources.ILabel=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.Label} Label instance
                         */
                        Label.create = function create(properties) {
                            return new Label(properties);
                        };

                        /**
                         * Encodes the specified Label message. Does not implicitly {@link google.ads.googleads.v1.resources.Label.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.Label
                         * @static
                         * @param {google.ads.googleads.v1.resources.ILabel} message Label message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Label.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.status);
                            if (message.textLabel != null && message.hasOwnProperty("textLabel"))
                                $root.google.ads.googleads.v1.common.TextLabel.encode(message.textLabel, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified Label message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Label.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.Label
                         * @static
                         * @param {google.ads.googleads.v1.resources.ILabel} message Label message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Label.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a Label message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.Label
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.Label} Label
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Label.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Label();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.status = reader.int32();
                                    break;
                                case 5:
                                    message.textLabel = $root.google.ads.googleads.v1.common.TextLabel.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a Label message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.Label
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.Label} Label
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Label.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a Label message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.Label
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Label.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.textLabel != null && message.hasOwnProperty("textLabel")) {
                                var error = $root.google.ads.googleads.v1.common.TextLabel.verify(message.textLabel);
                                if (error)
                                    return "textLabel." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a Label message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.Label
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.Label} Label
                         */
                        Label.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.Label)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.Label();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Label.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Label.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "REMOVED":
                            case 3:
                                message.status = 3;
                                break;
                            }
                            if (object.textLabel != null) {
                                if (typeof object.textLabel !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Label.textLabel: object expected");
                                message.textLabel = $root.google.ads.googleads.v1.common.TextLabel.fromObject(object.textLabel);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a Label message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.Label
                         * @static
                         * @param {google.ads.googleads.v1.resources.Label} message Label
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Label.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.name = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                                object.textLabel = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.LabelStatusEnum.LabelStatus[message.status] : message.status;
                            if (message.textLabel != null && message.hasOwnProperty("textLabel"))
                                object.textLabel = $root.google.ads.googleads.v1.common.TextLabel.toObject(message.textLabel, options);
                            return object;
                        };

                        /**
                         * Converts this Label to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.Label
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Label.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return Label;
                    })();

                    resources.LandingPageView = (function() {

                        /**
                         * Properties of a LandingPageView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ILandingPageView
                         * @property {string|null} [resourceName] LandingPageView resourceName
                         * @property {google.protobuf.IStringValue|null} [unexpandedFinalUrl] LandingPageView unexpandedFinalUrl
                         */

                        /**
                         * Constructs a new LandingPageView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a LandingPageView.
                         * @implements ILandingPageView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ILandingPageView=} [properties] Properties to set
                         */
                        function LandingPageView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * LandingPageView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.LandingPageView
                         * @instance
                         */
                        LandingPageView.prototype.resourceName = "";

                        /**
                         * LandingPageView unexpandedFinalUrl.
                         * @member {google.protobuf.IStringValue|null|undefined} unexpandedFinalUrl
                         * @memberof google.ads.googleads.v1.resources.LandingPageView
                         * @instance
                         */
                        LandingPageView.prototype.unexpandedFinalUrl = null;

                        /**
                         * Creates a new LandingPageView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.LandingPageView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ILandingPageView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.LandingPageView} LandingPageView instance
                         */
                        LandingPageView.create = function create(properties) {
                            return new LandingPageView(properties);
                        };

                        /**
                         * Encodes the specified LandingPageView message. Does not implicitly {@link google.ads.googleads.v1.resources.LandingPageView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.LandingPageView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ILandingPageView} message LandingPageView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LandingPageView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.unexpandedFinalUrl != null && message.hasOwnProperty("unexpandedFinalUrl"))
                                $root.google.protobuf.StringValue.encode(message.unexpandedFinalUrl, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified LandingPageView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.LandingPageView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.LandingPageView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ILandingPageView} message LandingPageView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LandingPageView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LandingPageView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.LandingPageView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.LandingPageView} LandingPageView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LandingPageView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.LandingPageView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.unexpandedFinalUrl = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LandingPageView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.LandingPageView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.LandingPageView} LandingPageView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LandingPageView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LandingPageView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.LandingPageView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LandingPageView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.unexpandedFinalUrl != null && message.hasOwnProperty("unexpandedFinalUrl")) {
                                var error = $root.google.protobuf.StringValue.verify(message.unexpandedFinalUrl);
                                if (error)
                                    return "unexpandedFinalUrl." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a LandingPageView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.LandingPageView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.LandingPageView} LandingPageView
                         */
                        LandingPageView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.LandingPageView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.LandingPageView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.unexpandedFinalUrl != null) {
                                if (typeof object.unexpandedFinalUrl !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.LandingPageView.unexpandedFinalUrl: object expected");
                                message.unexpandedFinalUrl = $root.google.protobuf.StringValue.fromObject(object.unexpandedFinalUrl);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a LandingPageView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.LandingPageView
                         * @static
                         * @param {google.ads.googleads.v1.resources.LandingPageView} message LandingPageView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LandingPageView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.unexpandedFinalUrl = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.unexpandedFinalUrl != null && message.hasOwnProperty("unexpandedFinalUrl"))
                                object.unexpandedFinalUrl = $root.google.protobuf.StringValue.toObject(message.unexpandedFinalUrl, options);
                            return object;
                        };

                        /**
                         * Converts this LandingPageView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.LandingPageView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LandingPageView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return LandingPageView;
                    })();

                    resources.LanguageConstant = (function() {

                        /**
                         * Properties of a LanguageConstant.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ILanguageConstant
                         * @property {string|null} [resourceName] LanguageConstant resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] LanguageConstant id
                         * @property {google.protobuf.IStringValue|null} [code] LanguageConstant code
                         * @property {google.protobuf.IStringValue|null} [name] LanguageConstant name
                         * @property {google.protobuf.IBoolValue|null} [targetable] LanguageConstant targetable
                         */

                        /**
                         * Constructs a new LanguageConstant.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a LanguageConstant.
                         * @implements ILanguageConstant
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ILanguageConstant=} [properties] Properties to set
                         */
                        function LanguageConstant(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * LanguageConstant resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.LanguageConstant
                         * @instance
                         */
                        LanguageConstant.prototype.resourceName = "";

                        /**
                         * LanguageConstant id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.LanguageConstant
                         * @instance
                         */
                        LanguageConstant.prototype.id = null;

                        /**
                         * LanguageConstant code.
                         * @member {google.protobuf.IStringValue|null|undefined} code
                         * @memberof google.ads.googleads.v1.resources.LanguageConstant
                         * @instance
                         */
                        LanguageConstant.prototype.code = null;

                        /**
                         * LanguageConstant name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.LanguageConstant
                         * @instance
                         */
                        LanguageConstant.prototype.name = null;

                        /**
                         * LanguageConstant targetable.
                         * @member {google.protobuf.IBoolValue|null|undefined} targetable
                         * @memberof google.ads.googleads.v1.resources.LanguageConstant
                         * @instance
                         */
                        LanguageConstant.prototype.targetable = null;

                        /**
                         * Creates a new LanguageConstant instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.LanguageConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.ILanguageConstant=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.LanguageConstant} LanguageConstant instance
                         */
                        LanguageConstant.create = function create(properties) {
                            return new LanguageConstant(properties);
                        };

                        /**
                         * Encodes the specified LanguageConstant message. Does not implicitly {@link google.ads.googleads.v1.resources.LanguageConstant.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.LanguageConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.ILanguageConstant} message LanguageConstant message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LanguageConstant.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.code != null && message.hasOwnProperty("code"))
                                $root.google.protobuf.StringValue.encode(message.code, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.targetable != null && message.hasOwnProperty("targetable"))
                                $root.google.protobuf.BoolValue.encode(message.targetable, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified LanguageConstant message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.LanguageConstant.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.LanguageConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.ILanguageConstant} message LanguageConstant message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LanguageConstant.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LanguageConstant message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.LanguageConstant
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.LanguageConstant} LanguageConstant
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LanguageConstant.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.LanguageConstant();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.code = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.targetable = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LanguageConstant message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.LanguageConstant
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.LanguageConstant} LanguageConstant
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LanguageConstant.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LanguageConstant message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.LanguageConstant
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LanguageConstant.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.code != null && message.hasOwnProperty("code")) {
                                var error = $root.google.protobuf.StringValue.verify(message.code);
                                if (error)
                                    return "code." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.targetable != null && message.hasOwnProperty("targetable")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.targetable);
                                if (error)
                                    return "targetable." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a LanguageConstant message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.LanguageConstant
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.LanguageConstant} LanguageConstant
                         */
                        LanguageConstant.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.LanguageConstant)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.LanguageConstant();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.LanguageConstant.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.code != null) {
                                if (typeof object.code !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.LanguageConstant.code: object expected");
                                message.code = $root.google.protobuf.StringValue.fromObject(object.code);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.LanguageConstant.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            if (object.targetable != null) {
                                if (typeof object.targetable !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.LanguageConstant.targetable: object expected");
                                message.targetable = $root.google.protobuf.BoolValue.fromObject(object.targetable);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a LanguageConstant message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.LanguageConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.LanguageConstant} message LanguageConstant
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LanguageConstant.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.code = null;
                                object.name = null;
                                object.targetable = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.code != null && message.hasOwnProperty("code"))
                                object.code = $root.google.protobuf.StringValue.toObject(message.code, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.targetable != null && message.hasOwnProperty("targetable"))
                                object.targetable = $root.google.protobuf.BoolValue.toObject(message.targetable, options);
                            return object;
                        };

                        /**
                         * Converts this LanguageConstant to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.LanguageConstant
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LanguageConstant.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return LanguageConstant;
                    })();

                    resources.LocationView = (function() {

                        /**
                         * Properties of a LocationView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ILocationView
                         * @property {string|null} [resourceName] LocationView resourceName
                         */

                        /**
                         * Constructs a new LocationView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a LocationView.
                         * @implements ILocationView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ILocationView=} [properties] Properties to set
                         */
                        function LocationView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * LocationView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.LocationView
                         * @instance
                         */
                        LocationView.prototype.resourceName = "";

                        /**
                         * Creates a new LocationView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.LocationView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ILocationView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.LocationView} LocationView instance
                         */
                        LocationView.create = function create(properties) {
                            return new LocationView(properties);
                        };

                        /**
                         * Encodes the specified LocationView message. Does not implicitly {@link google.ads.googleads.v1.resources.LocationView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.LocationView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ILocationView} message LocationView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified LocationView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.LocationView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.LocationView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ILocationView} message LocationView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LocationView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.LocationView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.LocationView} LocationView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.LocationView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LocationView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.LocationView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.LocationView} LocationView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LocationView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.LocationView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LocationView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a LocationView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.LocationView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.LocationView} LocationView
                         */
                        LocationView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.LocationView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.LocationView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a LocationView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.LocationView
                         * @static
                         * @param {google.ads.googleads.v1.resources.LocationView} message LocationView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LocationView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this LocationView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.LocationView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LocationView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return LocationView;
                    })();

                    resources.ManagedPlacementView = (function() {

                        /**
                         * Properties of a ManagedPlacementView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IManagedPlacementView
                         * @property {string|null} [resourceName] ManagedPlacementView resourceName
                         */

                        /**
                         * Constructs a new ManagedPlacementView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a ManagedPlacementView.
                         * @implements IManagedPlacementView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IManagedPlacementView=} [properties] Properties to set
                         */
                        function ManagedPlacementView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ManagedPlacementView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.ManagedPlacementView
                         * @instance
                         */
                        ManagedPlacementView.prototype.resourceName = "";

                        /**
                         * Creates a new ManagedPlacementView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.ManagedPlacementView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IManagedPlacementView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.ManagedPlacementView} ManagedPlacementView instance
                         */
                        ManagedPlacementView.create = function create(properties) {
                            return new ManagedPlacementView(properties);
                        };

                        /**
                         * Encodes the specified ManagedPlacementView message. Does not implicitly {@link google.ads.googleads.v1.resources.ManagedPlacementView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.ManagedPlacementView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IManagedPlacementView} message ManagedPlacementView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ManagedPlacementView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified ManagedPlacementView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.ManagedPlacementView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ManagedPlacementView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IManagedPlacementView} message ManagedPlacementView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ManagedPlacementView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ManagedPlacementView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.ManagedPlacementView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.ManagedPlacementView} ManagedPlacementView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ManagedPlacementView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.ManagedPlacementView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ManagedPlacementView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ManagedPlacementView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.ManagedPlacementView} ManagedPlacementView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ManagedPlacementView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ManagedPlacementView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.ManagedPlacementView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ManagedPlacementView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a ManagedPlacementView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.ManagedPlacementView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.ManagedPlacementView} ManagedPlacementView
                         */
                        ManagedPlacementView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.ManagedPlacementView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.ManagedPlacementView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a ManagedPlacementView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.ManagedPlacementView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ManagedPlacementView} message ManagedPlacementView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ManagedPlacementView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this ManagedPlacementView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.ManagedPlacementView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ManagedPlacementView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ManagedPlacementView;
                    })();

                    resources.MediaFile = (function() {

                        /**
                         * Properties of a MediaFile.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IMediaFile
                         * @property {string|null} [resourceName] MediaFile resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] MediaFile id
                         * @property {google.ads.googleads.v1.enums.MediaTypeEnum.MediaType|null} [type] MediaFile type
                         * @property {google.ads.googleads.v1.enums.MimeTypeEnum.MimeType|null} [mimeType] MediaFile mimeType
                         * @property {google.protobuf.IStringValue|null} [sourceUrl] MediaFile sourceUrl
                         * @property {google.protobuf.IStringValue|null} [name] MediaFile name
                         * @property {google.protobuf.IInt64Value|null} [fileSize] MediaFile fileSize
                         * @property {google.ads.googleads.v1.resources.IMediaImage|null} [image] MediaFile image
                         * @property {google.ads.googleads.v1.resources.IMediaBundle|null} [mediaBundle] MediaFile mediaBundle
                         * @property {google.ads.googleads.v1.resources.IMediaAudio|null} [audio] MediaFile audio
                         * @property {google.ads.googleads.v1.resources.IMediaVideo|null} [video] MediaFile video
                         */

                        /**
                         * Constructs a new MediaFile.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a MediaFile.
                         * @implements IMediaFile
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IMediaFile=} [properties] Properties to set
                         */
                        function MediaFile(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MediaFile resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @instance
                         */
                        MediaFile.prototype.resourceName = "";

                        /**
                         * MediaFile id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @instance
                         */
                        MediaFile.prototype.id = null;

                        /**
                         * MediaFile type.
                         * @member {google.ads.googleads.v1.enums.MediaTypeEnum.MediaType} type
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @instance
                         */
                        MediaFile.prototype.type = 0;

                        /**
                         * MediaFile mimeType.
                         * @member {google.ads.googleads.v1.enums.MimeTypeEnum.MimeType} mimeType
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @instance
                         */
                        MediaFile.prototype.mimeType = 0;

                        /**
                         * MediaFile sourceUrl.
                         * @member {google.protobuf.IStringValue|null|undefined} sourceUrl
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @instance
                         */
                        MediaFile.prototype.sourceUrl = null;

                        /**
                         * MediaFile name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @instance
                         */
                        MediaFile.prototype.name = null;

                        /**
                         * MediaFile fileSize.
                         * @member {google.protobuf.IInt64Value|null|undefined} fileSize
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @instance
                         */
                        MediaFile.prototype.fileSize = null;

                        /**
                         * MediaFile image.
                         * @member {google.ads.googleads.v1.resources.IMediaImage|null|undefined} image
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @instance
                         */
                        MediaFile.prototype.image = null;

                        /**
                         * MediaFile mediaBundle.
                         * @member {google.ads.googleads.v1.resources.IMediaBundle|null|undefined} mediaBundle
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @instance
                         */
                        MediaFile.prototype.mediaBundle = null;

                        /**
                         * MediaFile audio.
                         * @member {google.ads.googleads.v1.resources.IMediaAudio|null|undefined} audio
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @instance
                         */
                        MediaFile.prototype.audio = null;

                        /**
                         * MediaFile video.
                         * @member {google.ads.googleads.v1.resources.IMediaVideo|null|undefined} video
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @instance
                         */
                        MediaFile.prototype.video = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * MediaFile mediatype.
                         * @member {"image"|"mediaBundle"|"audio"|"video"|undefined} mediatype
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @instance
                         */
                        Object.defineProperty(MediaFile.prototype, "mediatype", {
                            get: $util.oneOfGetter($oneOfFields = ["image", "mediaBundle", "audio", "video"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new MediaFile instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMediaFile=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.MediaFile} MediaFile instance
                         */
                        MediaFile.create = function create(properties) {
                            return new MediaFile(properties);
                        };

                        /**
                         * Encodes the specified MediaFile message. Does not implicitly {@link google.ads.googleads.v1.resources.MediaFile.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMediaFile} message MediaFile message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaFile.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.image != null && message.hasOwnProperty("image"))
                                $root.google.ads.googleads.v1.resources.MediaImage.encode(message.image, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.mediaBundle != null && message.hasOwnProperty("mediaBundle"))
                                $root.google.ads.googleads.v1.resources.MediaBundle.encode(message.mediaBundle, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.type);
                            if (message.mimeType != null && message.hasOwnProperty("mimeType"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.mimeType);
                            if (message.sourceUrl != null && message.hasOwnProperty("sourceUrl"))
                                $root.google.protobuf.StringValue.encode(message.sourceUrl, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.fileSize != null && message.hasOwnProperty("fileSize"))
                                $root.google.protobuf.Int64Value.encode(message.fileSize, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.audio != null && message.hasOwnProperty("audio"))
                                $root.google.ads.googleads.v1.resources.MediaAudio.encode(message.audio, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.video != null && message.hasOwnProperty("video"))
                                $root.google.ads.googleads.v1.resources.MediaVideo.encode(message.video, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MediaFile message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.MediaFile.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMediaFile} message MediaFile message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaFile.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MediaFile message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.MediaFile} MediaFile
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaFile.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.MediaFile();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.type = reader.int32();
                                    break;
                                case 6:
                                    message.mimeType = reader.int32();
                                    break;
                                case 7:
                                    message.sourceUrl = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.fileSize = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.image = $root.google.ads.googleads.v1.resources.MediaImage.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.mediaBundle = $root.google.ads.googleads.v1.resources.MediaBundle.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.audio = $root.google.ads.googleads.v1.resources.MediaAudio.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.video = $root.google.ads.googleads.v1.resources.MediaVideo.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MediaFile message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.MediaFile} MediaFile
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaFile.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MediaFile message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MediaFile.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            if (message.mimeType != null && message.hasOwnProperty("mimeType"))
                                switch (message.mimeType) {
                                default:
                                    return "mimeType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                    break;
                                }
                            if (message.sourceUrl != null && message.hasOwnProperty("sourceUrl")) {
                                var error = $root.google.protobuf.StringValue.verify(message.sourceUrl);
                                if (error)
                                    return "sourceUrl." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.fileSize != null && message.hasOwnProperty("fileSize")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.fileSize);
                                if (error)
                                    return "fileSize." + error;
                            }
                            if (message.image != null && message.hasOwnProperty("image")) {
                                properties.mediatype = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.MediaImage.verify(message.image);
                                    if (error)
                                        return "image." + error;
                                }
                            }
                            if (message.mediaBundle != null && message.hasOwnProperty("mediaBundle")) {
                                if (properties.mediatype === 1)
                                    return "mediatype: multiple values";
                                properties.mediatype = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.MediaBundle.verify(message.mediaBundle);
                                    if (error)
                                        return "mediaBundle." + error;
                                }
                            }
                            if (message.audio != null && message.hasOwnProperty("audio")) {
                                if (properties.mediatype === 1)
                                    return "mediatype: multiple values";
                                properties.mediatype = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.MediaAudio.verify(message.audio);
                                    if (error)
                                        return "audio." + error;
                                }
                            }
                            if (message.video != null && message.hasOwnProperty("video")) {
                                if (properties.mediatype === 1)
                                    return "mediatype: multiple values";
                                properties.mediatype = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.MediaVideo.verify(message.video);
                                    if (error)
                                        return "video." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MediaFile message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.MediaFile} MediaFile
                         */
                        MediaFile.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.MediaFile)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.MediaFile();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MediaFile.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "IMAGE":
                            case 2:
                                message.type = 2;
                                break;
                            case "ICON":
                            case 3:
                                message.type = 3;
                                break;
                            case "MEDIA_BUNDLE":
                            case 4:
                                message.type = 4;
                                break;
                            case "AUDIO":
                            case 5:
                                message.type = 5;
                                break;
                            case "VIDEO":
                            case 6:
                                message.type = 6;
                                break;
                            case "DYNAMIC_IMAGE":
                            case 7:
                                message.type = 7;
                                break;
                            }
                            switch (object.mimeType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.mimeType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.mimeType = 1;
                                break;
                            case "IMAGE_JPEG":
                            case 2:
                                message.mimeType = 2;
                                break;
                            case "IMAGE_GIF":
                            case 3:
                                message.mimeType = 3;
                                break;
                            case "IMAGE_PNG":
                            case 4:
                                message.mimeType = 4;
                                break;
                            case "FLASH":
                            case 5:
                                message.mimeType = 5;
                                break;
                            case "TEXT_HTML":
                            case 6:
                                message.mimeType = 6;
                                break;
                            case "PDF":
                            case 7:
                                message.mimeType = 7;
                                break;
                            case "MSWORD":
                            case 8:
                                message.mimeType = 8;
                                break;
                            case "MSEXCEL":
                            case 9:
                                message.mimeType = 9;
                                break;
                            case "RTF":
                            case 10:
                                message.mimeType = 10;
                                break;
                            case "AUDIO_WAV":
                            case 11:
                                message.mimeType = 11;
                                break;
                            case "AUDIO_MP3":
                            case 12:
                                message.mimeType = 12;
                                break;
                            case "HTML5_AD_ZIP":
                            case 13:
                                message.mimeType = 13;
                                break;
                            }
                            if (object.sourceUrl != null) {
                                if (typeof object.sourceUrl !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MediaFile.sourceUrl: object expected");
                                message.sourceUrl = $root.google.protobuf.StringValue.fromObject(object.sourceUrl);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MediaFile.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            if (object.fileSize != null) {
                                if (typeof object.fileSize !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MediaFile.fileSize: object expected");
                                message.fileSize = $root.google.protobuf.Int64Value.fromObject(object.fileSize);
                            }
                            if (object.image != null) {
                                if (typeof object.image !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MediaFile.image: object expected");
                                message.image = $root.google.ads.googleads.v1.resources.MediaImage.fromObject(object.image);
                            }
                            if (object.mediaBundle != null) {
                                if (typeof object.mediaBundle !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MediaFile.mediaBundle: object expected");
                                message.mediaBundle = $root.google.ads.googleads.v1.resources.MediaBundle.fromObject(object.mediaBundle);
                            }
                            if (object.audio != null) {
                                if (typeof object.audio !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MediaFile.audio: object expected");
                                message.audio = $root.google.ads.googleads.v1.resources.MediaAudio.fromObject(object.audio);
                            }
                            if (object.video != null) {
                                if (typeof object.video !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MediaFile.video: object expected");
                                message.video = $root.google.ads.googleads.v1.resources.MediaVideo.fromObject(object.video);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MediaFile message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @static
                         * @param {google.ads.googleads.v1.resources.MediaFile} message MediaFile
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MediaFile.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.mimeType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.sourceUrl = null;
                                object.name = null;
                                object.fileSize = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.image != null && message.hasOwnProperty("image")) {
                                object.image = $root.google.ads.googleads.v1.resources.MediaImage.toObject(message.image, options);
                                if (options.oneofs)
                                    object.mediatype = "image";
                            }
                            if (message.mediaBundle != null && message.hasOwnProperty("mediaBundle")) {
                                object.mediaBundle = $root.google.ads.googleads.v1.resources.MediaBundle.toObject(message.mediaBundle, options);
                                if (options.oneofs)
                                    object.mediatype = "mediaBundle";
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.MediaTypeEnum.MediaType[message.type] : message.type;
                            if (message.mimeType != null && message.hasOwnProperty("mimeType"))
                                object.mimeType = options.enums === String ? $root.google.ads.googleads.v1.enums.MimeTypeEnum.MimeType[message.mimeType] : message.mimeType;
                            if (message.sourceUrl != null && message.hasOwnProperty("sourceUrl"))
                                object.sourceUrl = $root.google.protobuf.StringValue.toObject(message.sourceUrl, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.fileSize != null && message.hasOwnProperty("fileSize"))
                                object.fileSize = $root.google.protobuf.Int64Value.toObject(message.fileSize, options);
                            if (message.audio != null && message.hasOwnProperty("audio")) {
                                object.audio = $root.google.ads.googleads.v1.resources.MediaAudio.toObject(message.audio, options);
                                if (options.oneofs)
                                    object.mediatype = "audio";
                            }
                            if (message.video != null && message.hasOwnProperty("video")) {
                                object.video = $root.google.ads.googleads.v1.resources.MediaVideo.toObject(message.video, options);
                                if (options.oneofs)
                                    object.mediatype = "video";
                            }
                            return object;
                        };

                        /**
                         * Converts this MediaFile to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.MediaFile
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MediaFile.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MediaFile;
                    })();

                    resources.MediaImage = (function() {

                        /**
                         * Properties of a MediaImage.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IMediaImage
                         * @property {google.protobuf.IBytesValue|null} [data] MediaImage data
                         */

                        /**
                         * Constructs a new MediaImage.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a MediaImage.
                         * @implements IMediaImage
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IMediaImage=} [properties] Properties to set
                         */
                        function MediaImage(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MediaImage data.
                         * @member {google.protobuf.IBytesValue|null|undefined} data
                         * @memberof google.ads.googleads.v1.resources.MediaImage
                         * @instance
                         */
                        MediaImage.prototype.data = null;

                        /**
                         * Creates a new MediaImage instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.MediaImage
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMediaImage=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.MediaImage} MediaImage instance
                         */
                        MediaImage.create = function create(properties) {
                            return new MediaImage(properties);
                        };

                        /**
                         * Encodes the specified MediaImage message. Does not implicitly {@link google.ads.googleads.v1.resources.MediaImage.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.MediaImage
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMediaImage} message MediaImage message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaImage.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.data != null && message.hasOwnProperty("data"))
                                $root.google.protobuf.BytesValue.encode(message.data, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MediaImage message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.MediaImage.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.MediaImage
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMediaImage} message MediaImage message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaImage.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MediaImage message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.MediaImage
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.MediaImage} MediaImage
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaImage.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.MediaImage();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.data = $root.google.protobuf.BytesValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MediaImage message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.MediaImage
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.MediaImage} MediaImage
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaImage.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MediaImage message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.MediaImage
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MediaImage.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.data != null && message.hasOwnProperty("data")) {
                                var error = $root.google.protobuf.BytesValue.verify(message.data);
                                if (error)
                                    return "data." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MediaImage message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.MediaImage
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.MediaImage} MediaImage
                         */
                        MediaImage.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.MediaImage)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.MediaImage();
                            if (object.data != null) {
                                if (typeof object.data !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MediaImage.data: object expected");
                                message.data = $root.google.protobuf.BytesValue.fromObject(object.data);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MediaImage message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.MediaImage
                         * @static
                         * @param {google.ads.googleads.v1.resources.MediaImage} message MediaImage
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MediaImage.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.data = null;
                            if (message.data != null && message.hasOwnProperty("data"))
                                object.data = $root.google.protobuf.BytesValue.toObject(message.data, options);
                            return object;
                        };

                        /**
                         * Converts this MediaImage to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.MediaImage
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MediaImage.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MediaImage;
                    })();

                    resources.MediaBundle = (function() {

                        /**
                         * Properties of a MediaBundle.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IMediaBundle
                         * @property {google.protobuf.IBytesValue|null} [data] MediaBundle data
                         */

                        /**
                         * Constructs a new MediaBundle.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a MediaBundle.
                         * @implements IMediaBundle
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IMediaBundle=} [properties] Properties to set
                         */
                        function MediaBundle(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MediaBundle data.
                         * @member {google.protobuf.IBytesValue|null|undefined} data
                         * @memberof google.ads.googleads.v1.resources.MediaBundle
                         * @instance
                         */
                        MediaBundle.prototype.data = null;

                        /**
                         * Creates a new MediaBundle instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.MediaBundle
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMediaBundle=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.MediaBundle} MediaBundle instance
                         */
                        MediaBundle.create = function create(properties) {
                            return new MediaBundle(properties);
                        };

                        /**
                         * Encodes the specified MediaBundle message. Does not implicitly {@link google.ads.googleads.v1.resources.MediaBundle.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.MediaBundle
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMediaBundle} message MediaBundle message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaBundle.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.data != null && message.hasOwnProperty("data"))
                                $root.google.protobuf.BytesValue.encode(message.data, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MediaBundle message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.MediaBundle.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.MediaBundle
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMediaBundle} message MediaBundle message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaBundle.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MediaBundle message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.MediaBundle
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.MediaBundle} MediaBundle
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaBundle.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.MediaBundle();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.data = $root.google.protobuf.BytesValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MediaBundle message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.MediaBundle
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.MediaBundle} MediaBundle
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaBundle.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MediaBundle message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.MediaBundle
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MediaBundle.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.data != null && message.hasOwnProperty("data")) {
                                var error = $root.google.protobuf.BytesValue.verify(message.data);
                                if (error)
                                    return "data." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MediaBundle message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.MediaBundle
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.MediaBundle} MediaBundle
                         */
                        MediaBundle.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.MediaBundle)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.MediaBundle();
                            if (object.data != null) {
                                if (typeof object.data !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MediaBundle.data: object expected");
                                message.data = $root.google.protobuf.BytesValue.fromObject(object.data);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MediaBundle message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.MediaBundle
                         * @static
                         * @param {google.ads.googleads.v1.resources.MediaBundle} message MediaBundle
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MediaBundle.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.data = null;
                            if (message.data != null && message.hasOwnProperty("data"))
                                object.data = $root.google.protobuf.BytesValue.toObject(message.data, options);
                            return object;
                        };

                        /**
                         * Converts this MediaBundle to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.MediaBundle
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MediaBundle.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MediaBundle;
                    })();

                    resources.MediaAudio = (function() {

                        /**
                         * Properties of a MediaAudio.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IMediaAudio
                         * @property {google.protobuf.IInt64Value|null} [adDurationMillis] MediaAudio adDurationMillis
                         */

                        /**
                         * Constructs a new MediaAudio.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a MediaAudio.
                         * @implements IMediaAudio
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IMediaAudio=} [properties] Properties to set
                         */
                        function MediaAudio(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MediaAudio adDurationMillis.
                         * @member {google.protobuf.IInt64Value|null|undefined} adDurationMillis
                         * @memberof google.ads.googleads.v1.resources.MediaAudio
                         * @instance
                         */
                        MediaAudio.prototype.adDurationMillis = null;

                        /**
                         * Creates a new MediaAudio instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.MediaAudio
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMediaAudio=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.MediaAudio} MediaAudio instance
                         */
                        MediaAudio.create = function create(properties) {
                            return new MediaAudio(properties);
                        };

                        /**
                         * Encodes the specified MediaAudio message. Does not implicitly {@link google.ads.googleads.v1.resources.MediaAudio.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.MediaAudio
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMediaAudio} message MediaAudio message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaAudio.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.adDurationMillis != null && message.hasOwnProperty("adDurationMillis"))
                                $root.google.protobuf.Int64Value.encode(message.adDurationMillis, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MediaAudio message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.MediaAudio.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.MediaAudio
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMediaAudio} message MediaAudio message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaAudio.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MediaAudio message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.MediaAudio
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.MediaAudio} MediaAudio
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaAudio.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.MediaAudio();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.adDurationMillis = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MediaAudio message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.MediaAudio
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.MediaAudio} MediaAudio
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaAudio.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MediaAudio message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.MediaAudio
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MediaAudio.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.adDurationMillis != null && message.hasOwnProperty("adDurationMillis")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.adDurationMillis);
                                if (error)
                                    return "adDurationMillis." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MediaAudio message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.MediaAudio
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.MediaAudio} MediaAudio
                         */
                        MediaAudio.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.MediaAudio)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.MediaAudio();
                            if (object.adDurationMillis != null) {
                                if (typeof object.adDurationMillis !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MediaAudio.adDurationMillis: object expected");
                                message.adDurationMillis = $root.google.protobuf.Int64Value.fromObject(object.adDurationMillis);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MediaAudio message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.MediaAudio
                         * @static
                         * @param {google.ads.googleads.v1.resources.MediaAudio} message MediaAudio
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MediaAudio.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.adDurationMillis = null;
                            if (message.adDurationMillis != null && message.hasOwnProperty("adDurationMillis"))
                                object.adDurationMillis = $root.google.protobuf.Int64Value.toObject(message.adDurationMillis, options);
                            return object;
                        };

                        /**
                         * Converts this MediaAudio to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.MediaAudio
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MediaAudio.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MediaAudio;
                    })();

                    resources.MediaVideo = (function() {

                        /**
                         * Properties of a MediaVideo.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IMediaVideo
                         * @property {google.protobuf.IInt64Value|null} [adDurationMillis] MediaVideo adDurationMillis
                         * @property {google.protobuf.IStringValue|null} [youtubeVideoId] MediaVideo youtubeVideoId
                         * @property {google.protobuf.IStringValue|null} [advertisingIdCode] MediaVideo advertisingIdCode
                         * @property {google.protobuf.IStringValue|null} [isciCode] MediaVideo isciCode
                         */

                        /**
                         * Constructs a new MediaVideo.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a MediaVideo.
                         * @implements IMediaVideo
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IMediaVideo=} [properties] Properties to set
                         */
                        function MediaVideo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MediaVideo adDurationMillis.
                         * @member {google.protobuf.IInt64Value|null|undefined} adDurationMillis
                         * @memberof google.ads.googleads.v1.resources.MediaVideo
                         * @instance
                         */
                        MediaVideo.prototype.adDurationMillis = null;

                        /**
                         * MediaVideo youtubeVideoId.
                         * @member {google.protobuf.IStringValue|null|undefined} youtubeVideoId
                         * @memberof google.ads.googleads.v1.resources.MediaVideo
                         * @instance
                         */
                        MediaVideo.prototype.youtubeVideoId = null;

                        /**
                         * MediaVideo advertisingIdCode.
                         * @member {google.protobuf.IStringValue|null|undefined} advertisingIdCode
                         * @memberof google.ads.googleads.v1.resources.MediaVideo
                         * @instance
                         */
                        MediaVideo.prototype.advertisingIdCode = null;

                        /**
                         * MediaVideo isciCode.
                         * @member {google.protobuf.IStringValue|null|undefined} isciCode
                         * @memberof google.ads.googleads.v1.resources.MediaVideo
                         * @instance
                         */
                        MediaVideo.prototype.isciCode = null;

                        /**
                         * Creates a new MediaVideo instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.MediaVideo
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMediaVideo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.MediaVideo} MediaVideo instance
                         */
                        MediaVideo.create = function create(properties) {
                            return new MediaVideo(properties);
                        };

                        /**
                         * Encodes the specified MediaVideo message. Does not implicitly {@link google.ads.googleads.v1.resources.MediaVideo.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.MediaVideo
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMediaVideo} message MediaVideo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaVideo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.adDurationMillis != null && message.hasOwnProperty("adDurationMillis"))
                                $root.google.protobuf.Int64Value.encode(message.adDurationMillis, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.youtubeVideoId != null && message.hasOwnProperty("youtubeVideoId"))
                                $root.google.protobuf.StringValue.encode(message.youtubeVideoId, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.advertisingIdCode != null && message.hasOwnProperty("advertisingIdCode"))
                                $root.google.protobuf.StringValue.encode(message.advertisingIdCode, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.isciCode != null && message.hasOwnProperty("isciCode"))
                                $root.google.protobuf.StringValue.encode(message.isciCode, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MediaVideo message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.MediaVideo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.MediaVideo
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMediaVideo} message MediaVideo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaVideo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MediaVideo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.MediaVideo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.MediaVideo} MediaVideo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaVideo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.MediaVideo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.adDurationMillis = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.youtubeVideoId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.advertisingIdCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.isciCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MediaVideo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.MediaVideo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.MediaVideo} MediaVideo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaVideo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MediaVideo message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.MediaVideo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MediaVideo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.adDurationMillis != null && message.hasOwnProperty("adDurationMillis")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.adDurationMillis);
                                if (error)
                                    return "adDurationMillis." + error;
                            }
                            if (message.youtubeVideoId != null && message.hasOwnProperty("youtubeVideoId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.youtubeVideoId);
                                if (error)
                                    return "youtubeVideoId." + error;
                            }
                            if (message.advertisingIdCode != null && message.hasOwnProperty("advertisingIdCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.advertisingIdCode);
                                if (error)
                                    return "advertisingIdCode." + error;
                            }
                            if (message.isciCode != null && message.hasOwnProperty("isciCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.isciCode);
                                if (error)
                                    return "isciCode." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MediaVideo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.MediaVideo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.MediaVideo} MediaVideo
                         */
                        MediaVideo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.MediaVideo)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.MediaVideo();
                            if (object.adDurationMillis != null) {
                                if (typeof object.adDurationMillis !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MediaVideo.adDurationMillis: object expected");
                                message.adDurationMillis = $root.google.protobuf.Int64Value.fromObject(object.adDurationMillis);
                            }
                            if (object.youtubeVideoId != null) {
                                if (typeof object.youtubeVideoId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MediaVideo.youtubeVideoId: object expected");
                                message.youtubeVideoId = $root.google.protobuf.StringValue.fromObject(object.youtubeVideoId);
                            }
                            if (object.advertisingIdCode != null) {
                                if (typeof object.advertisingIdCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MediaVideo.advertisingIdCode: object expected");
                                message.advertisingIdCode = $root.google.protobuf.StringValue.fromObject(object.advertisingIdCode);
                            }
                            if (object.isciCode != null) {
                                if (typeof object.isciCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MediaVideo.isciCode: object expected");
                                message.isciCode = $root.google.protobuf.StringValue.fromObject(object.isciCode);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MediaVideo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.MediaVideo
                         * @static
                         * @param {google.ads.googleads.v1.resources.MediaVideo} message MediaVideo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MediaVideo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.adDurationMillis = null;
                                object.youtubeVideoId = null;
                                object.advertisingIdCode = null;
                                object.isciCode = null;
                            }
                            if (message.adDurationMillis != null && message.hasOwnProperty("adDurationMillis"))
                                object.adDurationMillis = $root.google.protobuf.Int64Value.toObject(message.adDurationMillis, options);
                            if (message.youtubeVideoId != null && message.hasOwnProperty("youtubeVideoId"))
                                object.youtubeVideoId = $root.google.protobuf.StringValue.toObject(message.youtubeVideoId, options);
                            if (message.advertisingIdCode != null && message.hasOwnProperty("advertisingIdCode"))
                                object.advertisingIdCode = $root.google.protobuf.StringValue.toObject(message.advertisingIdCode, options);
                            if (message.isciCode != null && message.hasOwnProperty("isciCode"))
                                object.isciCode = $root.google.protobuf.StringValue.toObject(message.isciCode, options);
                            return object;
                        };

                        /**
                         * Converts this MediaVideo to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.MediaVideo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MediaVideo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MediaVideo;
                    })();

                    resources.MerchantCenterLink = (function() {

                        /**
                         * Properties of a MerchantCenterLink.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IMerchantCenterLink
                         * @property {string|null} [resourceName] MerchantCenterLink resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] MerchantCenterLink id
                         * @property {google.protobuf.IStringValue|null} [merchantCenterAccountName] MerchantCenterLink merchantCenterAccountName
                         * @property {google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum.MerchantCenterLinkStatus|null} [status] MerchantCenterLink status
                         */

                        /**
                         * Constructs a new MerchantCenterLink.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a MerchantCenterLink.
                         * @implements IMerchantCenterLink
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IMerchantCenterLink=} [properties] Properties to set
                         */
                        function MerchantCenterLink(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MerchantCenterLink resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.MerchantCenterLink
                         * @instance
                         */
                        MerchantCenterLink.prototype.resourceName = "";

                        /**
                         * MerchantCenterLink id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.MerchantCenterLink
                         * @instance
                         */
                        MerchantCenterLink.prototype.id = null;

                        /**
                         * MerchantCenterLink merchantCenterAccountName.
                         * @member {google.protobuf.IStringValue|null|undefined} merchantCenterAccountName
                         * @memberof google.ads.googleads.v1.resources.MerchantCenterLink
                         * @instance
                         */
                        MerchantCenterLink.prototype.merchantCenterAccountName = null;

                        /**
                         * MerchantCenterLink status.
                         * @member {google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum.MerchantCenterLinkStatus} status
                         * @memberof google.ads.googleads.v1.resources.MerchantCenterLink
                         * @instance
                         */
                        MerchantCenterLink.prototype.status = 0;

                        /**
                         * Creates a new MerchantCenterLink instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.MerchantCenterLink
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMerchantCenterLink=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.MerchantCenterLink} MerchantCenterLink instance
                         */
                        MerchantCenterLink.create = function create(properties) {
                            return new MerchantCenterLink(properties);
                        };

                        /**
                         * Encodes the specified MerchantCenterLink message. Does not implicitly {@link google.ads.googleads.v1.resources.MerchantCenterLink.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.MerchantCenterLink
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMerchantCenterLink} message MerchantCenterLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MerchantCenterLink.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.merchantCenterAccountName != null && message.hasOwnProperty("merchantCenterAccountName"))
                                $root.google.protobuf.StringValue.encode(message.merchantCenterAccountName, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.status);
                            return writer;
                        };

                        /**
                         * Encodes the specified MerchantCenterLink message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.MerchantCenterLink.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.MerchantCenterLink
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMerchantCenterLink} message MerchantCenterLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MerchantCenterLink.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MerchantCenterLink message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.MerchantCenterLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.MerchantCenterLink} MerchantCenterLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MerchantCenterLink.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.MerchantCenterLink();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 3:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.merchantCenterAccountName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.status = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MerchantCenterLink message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.MerchantCenterLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.MerchantCenterLink} MerchantCenterLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MerchantCenterLink.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MerchantCenterLink message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.MerchantCenterLink
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MerchantCenterLink.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.merchantCenterAccountName != null && message.hasOwnProperty("merchantCenterAccountName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.merchantCenterAccountName);
                                if (error)
                                    return "merchantCenterAccountName." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a MerchantCenterLink message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.MerchantCenterLink
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.MerchantCenterLink} MerchantCenterLink
                         */
                        MerchantCenterLink.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.MerchantCenterLink)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.MerchantCenterLink();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MerchantCenterLink.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.merchantCenterAccountName != null) {
                                if (typeof object.merchantCenterAccountName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MerchantCenterLink.merchantCenterAccountName: object expected");
                                message.merchantCenterAccountName = $root.google.protobuf.StringValue.fromObject(object.merchantCenterAccountName);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "PENDING":
                            case 3:
                                message.status = 3;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MerchantCenterLink message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.MerchantCenterLink
                         * @static
                         * @param {google.ads.googleads.v1.resources.MerchantCenterLink} message MerchantCenterLink
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MerchantCenterLink.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.merchantCenterAccountName = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.merchantCenterAccountName != null && message.hasOwnProperty("merchantCenterAccountName"))
                                object.merchantCenterAccountName = $root.google.protobuf.StringValue.toObject(message.merchantCenterAccountName, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.MerchantCenterLinkStatusEnum.MerchantCenterLinkStatus[message.status] : message.status;
                            return object;
                        };

                        /**
                         * Converts this MerchantCenterLink to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.MerchantCenterLink
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MerchantCenterLink.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MerchantCenterLink;
                    })();

                    resources.MobileAppCategoryConstant = (function() {

                        /**
                         * Properties of a MobileAppCategoryConstant.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IMobileAppCategoryConstant
                         * @property {string|null} [resourceName] MobileAppCategoryConstant resourceName
                         * @property {google.protobuf.IInt32Value|null} [id] MobileAppCategoryConstant id
                         * @property {google.protobuf.IStringValue|null} [name] MobileAppCategoryConstant name
                         */

                        /**
                         * Constructs a new MobileAppCategoryConstant.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a MobileAppCategoryConstant.
                         * @implements IMobileAppCategoryConstant
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IMobileAppCategoryConstant=} [properties] Properties to set
                         */
                        function MobileAppCategoryConstant(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MobileAppCategoryConstant resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.MobileAppCategoryConstant
                         * @instance
                         */
                        MobileAppCategoryConstant.prototype.resourceName = "";

                        /**
                         * MobileAppCategoryConstant id.
                         * @member {google.protobuf.IInt32Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.MobileAppCategoryConstant
                         * @instance
                         */
                        MobileAppCategoryConstant.prototype.id = null;

                        /**
                         * MobileAppCategoryConstant name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.MobileAppCategoryConstant
                         * @instance
                         */
                        MobileAppCategoryConstant.prototype.name = null;

                        /**
                         * Creates a new MobileAppCategoryConstant instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.MobileAppCategoryConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMobileAppCategoryConstant=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.MobileAppCategoryConstant} MobileAppCategoryConstant instance
                         */
                        MobileAppCategoryConstant.create = function create(properties) {
                            return new MobileAppCategoryConstant(properties);
                        };

                        /**
                         * Encodes the specified MobileAppCategoryConstant message. Does not implicitly {@link google.ads.googleads.v1.resources.MobileAppCategoryConstant.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.MobileAppCategoryConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMobileAppCategoryConstant} message MobileAppCategoryConstant message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MobileAppCategoryConstant.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int32Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MobileAppCategoryConstant message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.MobileAppCategoryConstant.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.MobileAppCategoryConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMobileAppCategoryConstant} message MobileAppCategoryConstant message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MobileAppCategoryConstant.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MobileAppCategoryConstant message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.MobileAppCategoryConstant
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.MobileAppCategoryConstant} MobileAppCategoryConstant
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MobileAppCategoryConstant.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.MobileAppCategoryConstant();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MobileAppCategoryConstant message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.MobileAppCategoryConstant
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.MobileAppCategoryConstant} MobileAppCategoryConstant
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MobileAppCategoryConstant.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MobileAppCategoryConstant message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.MobileAppCategoryConstant
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MobileAppCategoryConstant.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int32Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MobileAppCategoryConstant message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.MobileAppCategoryConstant
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.MobileAppCategoryConstant} MobileAppCategoryConstant
                         */
                        MobileAppCategoryConstant.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.MobileAppCategoryConstant)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.MobileAppCategoryConstant();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MobileAppCategoryConstant.id: object expected");
                                message.id = $root.google.protobuf.Int32Value.fromObject(object.id);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MobileAppCategoryConstant.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MobileAppCategoryConstant message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.MobileAppCategoryConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.MobileAppCategoryConstant} message MobileAppCategoryConstant
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MobileAppCategoryConstant.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.name = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int32Value.toObject(message.id, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            return object;
                        };

                        /**
                         * Converts this MobileAppCategoryConstant to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.MobileAppCategoryConstant
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MobileAppCategoryConstant.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MobileAppCategoryConstant;
                    })();

                    resources.MobileDeviceConstant = (function() {

                        /**
                         * Properties of a MobileDeviceConstant.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IMobileDeviceConstant
                         * @property {string|null} [resourceName] MobileDeviceConstant resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] MobileDeviceConstant id
                         * @property {google.protobuf.IStringValue|null} [name] MobileDeviceConstant name
                         * @property {google.protobuf.IStringValue|null} [manufacturerName] MobileDeviceConstant manufacturerName
                         * @property {google.protobuf.IStringValue|null} [operatingSystemName] MobileDeviceConstant operatingSystemName
                         * @property {google.ads.googleads.v1.enums.MobileDeviceTypeEnum.MobileDeviceType|null} [type] MobileDeviceConstant type
                         */

                        /**
                         * Constructs a new MobileDeviceConstant.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a MobileDeviceConstant.
                         * @implements IMobileDeviceConstant
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IMobileDeviceConstant=} [properties] Properties to set
                         */
                        function MobileDeviceConstant(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MobileDeviceConstant resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.MobileDeviceConstant
                         * @instance
                         */
                        MobileDeviceConstant.prototype.resourceName = "";

                        /**
                         * MobileDeviceConstant id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.MobileDeviceConstant
                         * @instance
                         */
                        MobileDeviceConstant.prototype.id = null;

                        /**
                         * MobileDeviceConstant name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.MobileDeviceConstant
                         * @instance
                         */
                        MobileDeviceConstant.prototype.name = null;

                        /**
                         * MobileDeviceConstant manufacturerName.
                         * @member {google.protobuf.IStringValue|null|undefined} manufacturerName
                         * @memberof google.ads.googleads.v1.resources.MobileDeviceConstant
                         * @instance
                         */
                        MobileDeviceConstant.prototype.manufacturerName = null;

                        /**
                         * MobileDeviceConstant operatingSystemName.
                         * @member {google.protobuf.IStringValue|null|undefined} operatingSystemName
                         * @memberof google.ads.googleads.v1.resources.MobileDeviceConstant
                         * @instance
                         */
                        MobileDeviceConstant.prototype.operatingSystemName = null;

                        /**
                         * MobileDeviceConstant type.
                         * @member {google.ads.googleads.v1.enums.MobileDeviceTypeEnum.MobileDeviceType} type
                         * @memberof google.ads.googleads.v1.resources.MobileDeviceConstant
                         * @instance
                         */
                        MobileDeviceConstant.prototype.type = 0;

                        /**
                         * Creates a new MobileDeviceConstant instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.MobileDeviceConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMobileDeviceConstant=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.MobileDeviceConstant} MobileDeviceConstant instance
                         */
                        MobileDeviceConstant.create = function create(properties) {
                            return new MobileDeviceConstant(properties);
                        };

                        /**
                         * Encodes the specified MobileDeviceConstant message. Does not implicitly {@link google.ads.googleads.v1.resources.MobileDeviceConstant.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.MobileDeviceConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMobileDeviceConstant} message MobileDeviceConstant message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MobileDeviceConstant.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.manufacturerName != null && message.hasOwnProperty("manufacturerName"))
                                $root.google.protobuf.StringValue.encode(message.manufacturerName, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.operatingSystemName != null && message.hasOwnProperty("operatingSystemName"))
                                $root.google.protobuf.StringValue.encode(message.operatingSystemName, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.type);
                            return writer;
                        };

                        /**
                         * Encodes the specified MobileDeviceConstant message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.MobileDeviceConstant.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.MobileDeviceConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMobileDeviceConstant} message MobileDeviceConstant message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MobileDeviceConstant.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MobileDeviceConstant message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.MobileDeviceConstant
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.MobileDeviceConstant} MobileDeviceConstant
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MobileDeviceConstant.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.MobileDeviceConstant();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.manufacturerName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.operatingSystemName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.type = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MobileDeviceConstant message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.MobileDeviceConstant
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.MobileDeviceConstant} MobileDeviceConstant
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MobileDeviceConstant.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MobileDeviceConstant message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.MobileDeviceConstant
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MobileDeviceConstant.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.manufacturerName != null && message.hasOwnProperty("manufacturerName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.manufacturerName);
                                if (error)
                                    return "manufacturerName." + error;
                            }
                            if (message.operatingSystemName != null && message.hasOwnProperty("operatingSystemName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.operatingSystemName);
                                if (error)
                                    return "operatingSystemName." + error;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a MobileDeviceConstant message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.MobileDeviceConstant
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.MobileDeviceConstant} MobileDeviceConstant
                         */
                        MobileDeviceConstant.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.MobileDeviceConstant)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.MobileDeviceConstant();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MobileDeviceConstant.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MobileDeviceConstant.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            if (object.manufacturerName != null) {
                                if (typeof object.manufacturerName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MobileDeviceConstant.manufacturerName: object expected");
                                message.manufacturerName = $root.google.protobuf.StringValue.fromObject(object.manufacturerName);
                            }
                            if (object.operatingSystemName != null) {
                                if (typeof object.operatingSystemName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MobileDeviceConstant.operatingSystemName: object expected");
                                message.operatingSystemName = $root.google.protobuf.StringValue.fromObject(object.operatingSystemName);
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "MOBILE":
                            case 2:
                                message.type = 2;
                                break;
                            case "TABLET":
                            case 3:
                                message.type = 3;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MobileDeviceConstant message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.MobileDeviceConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.MobileDeviceConstant} message MobileDeviceConstant
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MobileDeviceConstant.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.name = null;
                                object.manufacturerName = null;
                                object.operatingSystemName = null;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.manufacturerName != null && message.hasOwnProperty("manufacturerName"))
                                object.manufacturerName = $root.google.protobuf.StringValue.toObject(message.manufacturerName, options);
                            if (message.operatingSystemName != null && message.hasOwnProperty("operatingSystemName"))
                                object.operatingSystemName = $root.google.protobuf.StringValue.toObject(message.operatingSystemName, options);
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.MobileDeviceTypeEnum.MobileDeviceType[message.type] : message.type;
                            return object;
                        };

                        /**
                         * Converts this MobileDeviceConstant to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.MobileDeviceConstant
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MobileDeviceConstant.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MobileDeviceConstant;
                    })();

                    resources.MutateJob = (function() {

                        /**
                         * Properties of a MutateJob.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IMutateJob
                         * @property {string|null} [resourceName] MutateJob resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] MutateJob id
                         * @property {google.protobuf.IStringValue|null} [nextAddSequenceToken] MutateJob nextAddSequenceToken
                         * @property {google.ads.googleads.v1.resources.MutateJob.IMutateJobMetadata|null} [metadata] MutateJob metadata
                         * @property {google.ads.googleads.v1.enums.MutateJobStatusEnum.MutateJobStatus|null} [status] MutateJob status
                         * @property {google.protobuf.IStringValue|null} [longRunningOperation] MutateJob longRunningOperation
                         */

                        /**
                         * Constructs a new MutateJob.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a MutateJob.
                         * @implements IMutateJob
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IMutateJob=} [properties] Properties to set
                         */
                        function MutateJob(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateJob resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.MutateJob
                         * @instance
                         */
                        MutateJob.prototype.resourceName = "";

                        /**
                         * MutateJob id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.MutateJob
                         * @instance
                         */
                        MutateJob.prototype.id = null;

                        /**
                         * MutateJob nextAddSequenceToken.
                         * @member {google.protobuf.IStringValue|null|undefined} nextAddSequenceToken
                         * @memberof google.ads.googleads.v1.resources.MutateJob
                         * @instance
                         */
                        MutateJob.prototype.nextAddSequenceToken = null;

                        /**
                         * MutateJob metadata.
                         * @member {google.ads.googleads.v1.resources.MutateJob.IMutateJobMetadata|null|undefined} metadata
                         * @memberof google.ads.googleads.v1.resources.MutateJob
                         * @instance
                         */
                        MutateJob.prototype.metadata = null;

                        /**
                         * MutateJob status.
                         * @member {google.ads.googleads.v1.enums.MutateJobStatusEnum.MutateJobStatus} status
                         * @memberof google.ads.googleads.v1.resources.MutateJob
                         * @instance
                         */
                        MutateJob.prototype.status = 0;

                        /**
                         * MutateJob longRunningOperation.
                         * @member {google.protobuf.IStringValue|null|undefined} longRunningOperation
                         * @memberof google.ads.googleads.v1.resources.MutateJob
                         * @instance
                         */
                        MutateJob.prototype.longRunningOperation = null;

                        /**
                         * Creates a new MutateJob instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.MutateJob
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMutateJob=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.MutateJob} MutateJob instance
                         */
                        MutateJob.create = function create(properties) {
                            return new MutateJob(properties);
                        };

                        /**
                         * Encodes the specified MutateJob message. Does not implicitly {@link google.ads.googleads.v1.resources.MutateJob.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.MutateJob
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMutateJob} message MutateJob message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateJob.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.nextAddSequenceToken != null && message.hasOwnProperty("nextAddSequenceToken"))
                                $root.google.protobuf.StringValue.encode(message.nextAddSequenceToken, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.metadata != null && message.hasOwnProperty("metadata"))
                                $root.google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata.encode(message.metadata, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.status);
                            if (message.longRunningOperation != null && message.hasOwnProperty("longRunningOperation"))
                                $root.google.protobuf.StringValue.encode(message.longRunningOperation, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateJob message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.MutateJob.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.MutateJob
                         * @static
                         * @param {google.ads.googleads.v1.resources.IMutateJob} message MutateJob message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateJob.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateJob message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.MutateJob
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.MutateJob} MutateJob
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateJob.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.MutateJob();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.nextAddSequenceToken = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.metadata = $root.google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.status = reader.int32();
                                    break;
                                case 6:
                                    message.longRunningOperation = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateJob message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.MutateJob
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.MutateJob} MutateJob
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateJob.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateJob message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.MutateJob
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateJob.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.nextAddSequenceToken != null && message.hasOwnProperty("nextAddSequenceToken")) {
                                var error = $root.google.protobuf.StringValue.verify(message.nextAddSequenceToken);
                                if (error)
                                    return "nextAddSequenceToken." + error;
                            }
                            if (message.metadata != null && message.hasOwnProperty("metadata")) {
                                var error = $root.google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata.verify(message.metadata);
                                if (error)
                                    return "metadata." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                    break;
                                }
                            if (message.longRunningOperation != null && message.hasOwnProperty("longRunningOperation")) {
                                var error = $root.google.protobuf.StringValue.verify(message.longRunningOperation);
                                if (error)
                                    return "longRunningOperation." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateJob message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.MutateJob
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.MutateJob} MutateJob
                         */
                        MutateJob.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.MutateJob)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.MutateJob();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MutateJob.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.nextAddSequenceToken != null) {
                                if (typeof object.nextAddSequenceToken !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MutateJob.nextAddSequenceToken: object expected");
                                message.nextAddSequenceToken = $root.google.protobuf.StringValue.fromObject(object.nextAddSequenceToken);
                            }
                            if (object.metadata != null) {
                                if (typeof object.metadata !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MutateJob.metadata: object expected");
                                message.metadata = $root.google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata.fromObject(object.metadata);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "PENDING":
                            case 2:
                                message.status = 2;
                                break;
                            case "RUNNING":
                            case 3:
                                message.status = 3;
                                break;
                            case "DONE":
                            case 4:
                                message.status = 4;
                                break;
                            }
                            if (object.longRunningOperation != null) {
                                if (typeof object.longRunningOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.MutateJob.longRunningOperation: object expected");
                                message.longRunningOperation = $root.google.protobuf.StringValue.fromObject(object.longRunningOperation);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateJob message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.MutateJob
                         * @static
                         * @param {google.ads.googleads.v1.resources.MutateJob} message MutateJob
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateJob.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.nextAddSequenceToken = null;
                                object.metadata = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                                object.longRunningOperation = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.nextAddSequenceToken != null && message.hasOwnProperty("nextAddSequenceToken"))
                                object.nextAddSequenceToken = $root.google.protobuf.StringValue.toObject(message.nextAddSequenceToken, options);
                            if (message.metadata != null && message.hasOwnProperty("metadata"))
                                object.metadata = $root.google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata.toObject(message.metadata, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.MutateJobStatusEnum.MutateJobStatus[message.status] : message.status;
                            if (message.longRunningOperation != null && message.hasOwnProperty("longRunningOperation"))
                                object.longRunningOperation = $root.google.protobuf.StringValue.toObject(message.longRunningOperation, options);
                            return object;
                        };

                        /**
                         * Converts this MutateJob to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.MutateJob
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateJob.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        MutateJob.MutateJobMetadata = (function() {

                            /**
                             * Properties of a MutateJobMetadata.
                             * @memberof google.ads.googleads.v1.resources.MutateJob
                             * @interface IMutateJobMetadata
                             * @property {google.protobuf.IStringValue|null} [creationDateTime] MutateJobMetadata creationDateTime
                             * @property {google.protobuf.IStringValue|null} [completionDateTime] MutateJobMetadata completionDateTime
                             * @property {google.protobuf.IDoubleValue|null} [estimatedCompletionRatio] MutateJobMetadata estimatedCompletionRatio
                             * @property {google.protobuf.IInt64Value|null} [operationCount] MutateJobMetadata operationCount
                             * @property {google.protobuf.IInt64Value|null} [executedOperationCount] MutateJobMetadata executedOperationCount
                             */

                            /**
                             * Constructs a new MutateJobMetadata.
                             * @memberof google.ads.googleads.v1.resources.MutateJob
                             * @classdesc Represents a MutateJobMetadata.
                             * @implements IMutateJobMetadata
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.MutateJob.IMutateJobMetadata=} [properties] Properties to set
                             */
                            function MutateJobMetadata(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * MutateJobMetadata creationDateTime.
                             * @member {google.protobuf.IStringValue|null|undefined} creationDateTime
                             * @memberof google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata
                             * @instance
                             */
                            MutateJobMetadata.prototype.creationDateTime = null;

                            /**
                             * MutateJobMetadata completionDateTime.
                             * @member {google.protobuf.IStringValue|null|undefined} completionDateTime
                             * @memberof google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata
                             * @instance
                             */
                            MutateJobMetadata.prototype.completionDateTime = null;

                            /**
                             * MutateJobMetadata estimatedCompletionRatio.
                             * @member {google.protobuf.IDoubleValue|null|undefined} estimatedCompletionRatio
                             * @memberof google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata
                             * @instance
                             */
                            MutateJobMetadata.prototype.estimatedCompletionRatio = null;

                            /**
                             * MutateJobMetadata operationCount.
                             * @member {google.protobuf.IInt64Value|null|undefined} operationCount
                             * @memberof google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata
                             * @instance
                             */
                            MutateJobMetadata.prototype.operationCount = null;

                            /**
                             * MutateJobMetadata executedOperationCount.
                             * @member {google.protobuf.IInt64Value|null|undefined} executedOperationCount
                             * @memberof google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata
                             * @instance
                             */
                            MutateJobMetadata.prototype.executedOperationCount = null;

                            /**
                             * Creates a new MutateJobMetadata instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata
                             * @static
                             * @param {google.ads.googleads.v1.resources.MutateJob.IMutateJobMetadata=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata} MutateJobMetadata instance
                             */
                            MutateJobMetadata.create = function create(properties) {
                                return new MutateJobMetadata(properties);
                            };

                            /**
                             * Encodes the specified MutateJobMetadata message. Does not implicitly {@link google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata
                             * @static
                             * @param {google.ads.googleads.v1.resources.MutateJob.IMutateJobMetadata} message MutateJobMetadata message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            MutateJobMetadata.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.creationDateTime != null && message.hasOwnProperty("creationDateTime"))
                                    $root.google.protobuf.StringValue.encode(message.creationDateTime, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.completionDateTime != null && message.hasOwnProperty("completionDateTime"))
                                    $root.google.protobuf.StringValue.encode(message.completionDateTime, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                if (message.estimatedCompletionRatio != null && message.hasOwnProperty("estimatedCompletionRatio"))
                                    $root.google.protobuf.DoubleValue.encode(message.estimatedCompletionRatio, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                                if (message.operationCount != null && message.hasOwnProperty("operationCount"))
                                    $root.google.protobuf.Int64Value.encode(message.operationCount, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                                if (message.executedOperationCount != null && message.hasOwnProperty("executedOperationCount"))
                                    $root.google.protobuf.Int64Value.encode(message.executedOperationCount, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified MutateJobMetadata message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata
                             * @static
                             * @param {google.ads.googleads.v1.resources.MutateJob.IMutateJobMetadata} message MutateJobMetadata message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            MutateJobMetadata.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a MutateJobMetadata message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata} MutateJobMetadata
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            MutateJobMetadata.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.creationDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.completionDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 3:
                                        message.estimatedCompletionRatio = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                        break;
                                    case 4:
                                        message.operationCount = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    case 5:
                                        message.executedOperationCount = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a MutateJobMetadata message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata} MutateJobMetadata
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            MutateJobMetadata.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a MutateJobMetadata message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            MutateJobMetadata.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.creationDateTime != null && message.hasOwnProperty("creationDateTime")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.creationDateTime);
                                    if (error)
                                        return "creationDateTime." + error;
                                }
                                if (message.completionDateTime != null && message.hasOwnProperty("completionDateTime")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.completionDateTime);
                                    if (error)
                                        return "completionDateTime." + error;
                                }
                                if (message.estimatedCompletionRatio != null && message.hasOwnProperty("estimatedCompletionRatio")) {
                                    var error = $root.google.protobuf.DoubleValue.verify(message.estimatedCompletionRatio);
                                    if (error)
                                        return "estimatedCompletionRatio." + error;
                                }
                                if (message.operationCount != null && message.hasOwnProperty("operationCount")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.operationCount);
                                    if (error)
                                        return "operationCount." + error;
                                }
                                if (message.executedOperationCount != null && message.hasOwnProperty("executedOperationCount")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.executedOperationCount);
                                    if (error)
                                        return "executedOperationCount." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a MutateJobMetadata message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata} MutateJobMetadata
                             */
                            MutateJobMetadata.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata();
                                if (object.creationDateTime != null) {
                                    if (typeof object.creationDateTime !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata.creationDateTime: object expected");
                                    message.creationDateTime = $root.google.protobuf.StringValue.fromObject(object.creationDateTime);
                                }
                                if (object.completionDateTime != null) {
                                    if (typeof object.completionDateTime !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata.completionDateTime: object expected");
                                    message.completionDateTime = $root.google.protobuf.StringValue.fromObject(object.completionDateTime);
                                }
                                if (object.estimatedCompletionRatio != null) {
                                    if (typeof object.estimatedCompletionRatio !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata.estimatedCompletionRatio: object expected");
                                    message.estimatedCompletionRatio = $root.google.protobuf.DoubleValue.fromObject(object.estimatedCompletionRatio);
                                }
                                if (object.operationCount != null) {
                                    if (typeof object.operationCount !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata.operationCount: object expected");
                                    message.operationCount = $root.google.protobuf.Int64Value.fromObject(object.operationCount);
                                }
                                if (object.executedOperationCount != null) {
                                    if (typeof object.executedOperationCount !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata.executedOperationCount: object expected");
                                    message.executedOperationCount = $root.google.protobuf.Int64Value.fromObject(object.executedOperationCount);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a MutateJobMetadata message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata
                             * @static
                             * @param {google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata} message MutateJobMetadata
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            MutateJobMetadata.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.creationDateTime = null;
                                    object.completionDateTime = null;
                                    object.estimatedCompletionRatio = null;
                                    object.operationCount = null;
                                    object.executedOperationCount = null;
                                }
                                if (message.creationDateTime != null && message.hasOwnProperty("creationDateTime"))
                                    object.creationDateTime = $root.google.protobuf.StringValue.toObject(message.creationDateTime, options);
                                if (message.completionDateTime != null && message.hasOwnProperty("completionDateTime"))
                                    object.completionDateTime = $root.google.protobuf.StringValue.toObject(message.completionDateTime, options);
                                if (message.estimatedCompletionRatio != null && message.hasOwnProperty("estimatedCompletionRatio"))
                                    object.estimatedCompletionRatio = $root.google.protobuf.DoubleValue.toObject(message.estimatedCompletionRatio, options);
                                if (message.operationCount != null && message.hasOwnProperty("operationCount"))
                                    object.operationCount = $root.google.protobuf.Int64Value.toObject(message.operationCount, options);
                                if (message.executedOperationCount != null && message.hasOwnProperty("executedOperationCount"))
                                    object.executedOperationCount = $root.google.protobuf.Int64Value.toObject(message.executedOperationCount, options);
                                return object;
                            };

                            /**
                             * Converts this MutateJobMetadata to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.MutateJob.MutateJobMetadata
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            MutateJobMetadata.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return MutateJobMetadata;
                        })();

                        return MutateJob;
                    })();

                    resources.OperatingSystemVersionConstant = (function() {

                        /**
                         * Properties of an OperatingSystemVersionConstant.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IOperatingSystemVersionConstant
                         * @property {string|null} [resourceName] OperatingSystemVersionConstant resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] OperatingSystemVersionConstant id
                         * @property {google.protobuf.IStringValue|null} [name] OperatingSystemVersionConstant name
                         * @property {google.protobuf.IInt32Value|null} [osMajorVersion] OperatingSystemVersionConstant osMajorVersion
                         * @property {google.protobuf.IInt32Value|null} [osMinorVersion] OperatingSystemVersionConstant osMinorVersion
                         * @property {google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum.OperatingSystemVersionOperatorType|null} [operatorType] OperatingSystemVersionConstant operatorType
                         */

                        /**
                         * Constructs a new OperatingSystemVersionConstant.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents an OperatingSystemVersionConstant.
                         * @implements IOperatingSystemVersionConstant
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IOperatingSystemVersionConstant=} [properties] Properties to set
                         */
                        function OperatingSystemVersionConstant(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * OperatingSystemVersionConstant resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.OperatingSystemVersionConstant
                         * @instance
                         */
                        OperatingSystemVersionConstant.prototype.resourceName = "";

                        /**
                         * OperatingSystemVersionConstant id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.OperatingSystemVersionConstant
                         * @instance
                         */
                        OperatingSystemVersionConstant.prototype.id = null;

                        /**
                         * OperatingSystemVersionConstant name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.OperatingSystemVersionConstant
                         * @instance
                         */
                        OperatingSystemVersionConstant.prototype.name = null;

                        /**
                         * OperatingSystemVersionConstant osMajorVersion.
                         * @member {google.protobuf.IInt32Value|null|undefined} osMajorVersion
                         * @memberof google.ads.googleads.v1.resources.OperatingSystemVersionConstant
                         * @instance
                         */
                        OperatingSystemVersionConstant.prototype.osMajorVersion = null;

                        /**
                         * OperatingSystemVersionConstant osMinorVersion.
                         * @member {google.protobuf.IInt32Value|null|undefined} osMinorVersion
                         * @memberof google.ads.googleads.v1.resources.OperatingSystemVersionConstant
                         * @instance
                         */
                        OperatingSystemVersionConstant.prototype.osMinorVersion = null;

                        /**
                         * OperatingSystemVersionConstant operatorType.
                         * @member {google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum.OperatingSystemVersionOperatorType} operatorType
                         * @memberof google.ads.googleads.v1.resources.OperatingSystemVersionConstant
                         * @instance
                         */
                        OperatingSystemVersionConstant.prototype.operatorType = 0;

                        /**
                         * Creates a new OperatingSystemVersionConstant instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.OperatingSystemVersionConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.IOperatingSystemVersionConstant=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.OperatingSystemVersionConstant} OperatingSystemVersionConstant instance
                         */
                        OperatingSystemVersionConstant.create = function create(properties) {
                            return new OperatingSystemVersionConstant(properties);
                        };

                        /**
                         * Encodes the specified OperatingSystemVersionConstant message. Does not implicitly {@link google.ads.googleads.v1.resources.OperatingSystemVersionConstant.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.OperatingSystemVersionConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.IOperatingSystemVersionConstant} message OperatingSystemVersionConstant message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        OperatingSystemVersionConstant.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.osMajorVersion != null && message.hasOwnProperty("osMajorVersion"))
                                $root.google.protobuf.Int32Value.encode(message.osMajorVersion, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.osMinorVersion != null && message.hasOwnProperty("osMinorVersion"))
                                $root.google.protobuf.Int32Value.encode(message.osMinorVersion, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.operatorType != null && message.hasOwnProperty("operatorType"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.operatorType);
                            return writer;
                        };

                        /**
                         * Encodes the specified OperatingSystemVersionConstant message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.OperatingSystemVersionConstant.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.OperatingSystemVersionConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.IOperatingSystemVersionConstant} message OperatingSystemVersionConstant message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        OperatingSystemVersionConstant.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an OperatingSystemVersionConstant message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.OperatingSystemVersionConstant
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.OperatingSystemVersionConstant} OperatingSystemVersionConstant
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        OperatingSystemVersionConstant.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.OperatingSystemVersionConstant();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.osMajorVersion = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.osMinorVersion = $root.google.protobuf.Int32Value.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.operatorType = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an OperatingSystemVersionConstant message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.OperatingSystemVersionConstant
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.OperatingSystemVersionConstant} OperatingSystemVersionConstant
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        OperatingSystemVersionConstant.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an OperatingSystemVersionConstant message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.OperatingSystemVersionConstant
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        OperatingSystemVersionConstant.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.osMajorVersion != null && message.hasOwnProperty("osMajorVersion")) {
                                var error = $root.google.protobuf.Int32Value.verify(message.osMajorVersion);
                                if (error)
                                    return "osMajorVersion." + error;
                            }
                            if (message.osMinorVersion != null && message.hasOwnProperty("osMinorVersion")) {
                                var error = $root.google.protobuf.Int32Value.verify(message.osMinorVersion);
                                if (error)
                                    return "osMinorVersion." + error;
                            }
                            if (message.operatorType != null && message.hasOwnProperty("operatorType"))
                                switch (message.operatorType) {
                                default:
                                    return "operatorType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 4:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates an OperatingSystemVersionConstant message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.OperatingSystemVersionConstant
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.OperatingSystemVersionConstant} OperatingSystemVersionConstant
                         */
                        OperatingSystemVersionConstant.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.OperatingSystemVersionConstant)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.OperatingSystemVersionConstant();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.OperatingSystemVersionConstant.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.OperatingSystemVersionConstant.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            if (object.osMajorVersion != null) {
                                if (typeof object.osMajorVersion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.OperatingSystemVersionConstant.osMajorVersion: object expected");
                                message.osMajorVersion = $root.google.protobuf.Int32Value.fromObject(object.osMajorVersion);
                            }
                            if (object.osMinorVersion != null) {
                                if (typeof object.osMinorVersion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.OperatingSystemVersionConstant.osMinorVersion: object expected");
                                message.osMinorVersion = $root.google.protobuf.Int32Value.fromObject(object.osMinorVersion);
                            }
                            switch (object.operatorType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.operatorType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.operatorType = 1;
                                break;
                            case "EQUALS_TO":
                            case 2:
                                message.operatorType = 2;
                                break;
                            case "GREATER_THAN_EQUALS_TO":
                            case 4:
                                message.operatorType = 4;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an OperatingSystemVersionConstant message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.OperatingSystemVersionConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.OperatingSystemVersionConstant} message OperatingSystemVersionConstant
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        OperatingSystemVersionConstant.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.name = null;
                                object.osMajorVersion = null;
                                object.osMinorVersion = null;
                                object.operatorType = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.osMajorVersion != null && message.hasOwnProperty("osMajorVersion"))
                                object.osMajorVersion = $root.google.protobuf.Int32Value.toObject(message.osMajorVersion, options);
                            if (message.osMinorVersion != null && message.hasOwnProperty("osMinorVersion"))
                                object.osMinorVersion = $root.google.protobuf.Int32Value.toObject(message.osMinorVersion, options);
                            if (message.operatorType != null && message.hasOwnProperty("operatorType"))
                                object.operatorType = options.enums === String ? $root.google.ads.googleads.v1.enums.OperatingSystemVersionOperatorTypeEnum.OperatingSystemVersionOperatorType[message.operatorType] : message.operatorType;
                            return object;
                        };

                        /**
                         * Converts this OperatingSystemVersionConstant to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.OperatingSystemVersionConstant
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        OperatingSystemVersionConstant.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return OperatingSystemVersionConstant;
                    })();

                    resources.PaidOrganicSearchTermView = (function() {

                        /**
                         * Properties of a PaidOrganicSearchTermView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IPaidOrganicSearchTermView
                         * @property {string|null} [resourceName] PaidOrganicSearchTermView resourceName
                         * @property {google.protobuf.IStringValue|null} [searchTerm] PaidOrganicSearchTermView searchTerm
                         */

                        /**
                         * Constructs a new PaidOrganicSearchTermView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a PaidOrganicSearchTermView.
                         * @implements IPaidOrganicSearchTermView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IPaidOrganicSearchTermView=} [properties] Properties to set
                         */
                        function PaidOrganicSearchTermView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * PaidOrganicSearchTermView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.PaidOrganicSearchTermView
                         * @instance
                         */
                        PaidOrganicSearchTermView.prototype.resourceName = "";

                        /**
                         * PaidOrganicSearchTermView searchTerm.
                         * @member {google.protobuf.IStringValue|null|undefined} searchTerm
                         * @memberof google.ads.googleads.v1.resources.PaidOrganicSearchTermView
                         * @instance
                         */
                        PaidOrganicSearchTermView.prototype.searchTerm = null;

                        /**
                         * Creates a new PaidOrganicSearchTermView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.PaidOrganicSearchTermView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IPaidOrganicSearchTermView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.PaidOrganicSearchTermView} PaidOrganicSearchTermView instance
                         */
                        PaidOrganicSearchTermView.create = function create(properties) {
                            return new PaidOrganicSearchTermView(properties);
                        };

                        /**
                         * Encodes the specified PaidOrganicSearchTermView message. Does not implicitly {@link google.ads.googleads.v1.resources.PaidOrganicSearchTermView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.PaidOrganicSearchTermView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IPaidOrganicSearchTermView} message PaidOrganicSearchTermView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PaidOrganicSearchTermView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.searchTerm != null && message.hasOwnProperty("searchTerm"))
                                $root.google.protobuf.StringValue.encode(message.searchTerm, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified PaidOrganicSearchTermView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.PaidOrganicSearchTermView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.PaidOrganicSearchTermView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IPaidOrganicSearchTermView} message PaidOrganicSearchTermView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PaidOrganicSearchTermView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PaidOrganicSearchTermView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.PaidOrganicSearchTermView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.PaidOrganicSearchTermView} PaidOrganicSearchTermView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PaidOrganicSearchTermView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.PaidOrganicSearchTermView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.searchTerm = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PaidOrganicSearchTermView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.PaidOrganicSearchTermView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.PaidOrganicSearchTermView} PaidOrganicSearchTermView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PaidOrganicSearchTermView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PaidOrganicSearchTermView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.PaidOrganicSearchTermView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PaidOrganicSearchTermView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.searchTerm != null && message.hasOwnProperty("searchTerm")) {
                                var error = $root.google.protobuf.StringValue.verify(message.searchTerm);
                                if (error)
                                    return "searchTerm." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a PaidOrganicSearchTermView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.PaidOrganicSearchTermView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.PaidOrganicSearchTermView} PaidOrganicSearchTermView
                         */
                        PaidOrganicSearchTermView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.PaidOrganicSearchTermView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.PaidOrganicSearchTermView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.searchTerm != null) {
                                if (typeof object.searchTerm !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.PaidOrganicSearchTermView.searchTerm: object expected");
                                message.searchTerm = $root.google.protobuf.StringValue.fromObject(object.searchTerm);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a PaidOrganicSearchTermView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.PaidOrganicSearchTermView
                         * @static
                         * @param {google.ads.googleads.v1.resources.PaidOrganicSearchTermView} message PaidOrganicSearchTermView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PaidOrganicSearchTermView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.searchTerm = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.searchTerm != null && message.hasOwnProperty("searchTerm"))
                                object.searchTerm = $root.google.protobuf.StringValue.toObject(message.searchTerm, options);
                            return object;
                        };

                        /**
                         * Converts this PaidOrganicSearchTermView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.PaidOrganicSearchTermView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PaidOrganicSearchTermView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return PaidOrganicSearchTermView;
                    })();

                    resources.ParentalStatusView = (function() {

                        /**
                         * Properties of a ParentalStatusView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IParentalStatusView
                         * @property {string|null} [resourceName] ParentalStatusView resourceName
                         */

                        /**
                         * Constructs a new ParentalStatusView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a ParentalStatusView.
                         * @implements IParentalStatusView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IParentalStatusView=} [properties] Properties to set
                         */
                        function ParentalStatusView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ParentalStatusView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.ParentalStatusView
                         * @instance
                         */
                        ParentalStatusView.prototype.resourceName = "";

                        /**
                         * Creates a new ParentalStatusView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.ParentalStatusView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IParentalStatusView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.ParentalStatusView} ParentalStatusView instance
                         */
                        ParentalStatusView.create = function create(properties) {
                            return new ParentalStatusView(properties);
                        };

                        /**
                         * Encodes the specified ParentalStatusView message. Does not implicitly {@link google.ads.googleads.v1.resources.ParentalStatusView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.ParentalStatusView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IParentalStatusView} message ParentalStatusView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ParentalStatusView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified ParentalStatusView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.ParentalStatusView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ParentalStatusView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IParentalStatusView} message ParentalStatusView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ParentalStatusView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ParentalStatusView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.ParentalStatusView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.ParentalStatusView} ParentalStatusView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ParentalStatusView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.ParentalStatusView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ParentalStatusView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ParentalStatusView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.ParentalStatusView} ParentalStatusView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ParentalStatusView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ParentalStatusView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.ParentalStatusView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ParentalStatusView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a ParentalStatusView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.ParentalStatusView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.ParentalStatusView} ParentalStatusView
                         */
                        ParentalStatusView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.ParentalStatusView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.ParentalStatusView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a ParentalStatusView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.ParentalStatusView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ParentalStatusView} message ParentalStatusView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ParentalStatusView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this ParentalStatusView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.ParentalStatusView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ParentalStatusView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ParentalStatusView;
                    })();

                    resources.PaymentsAccount = (function() {

                        /**
                         * Properties of a PaymentsAccount.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IPaymentsAccount
                         * @property {string|null} [resourceName] PaymentsAccount resourceName
                         * @property {google.protobuf.IStringValue|null} [paymentsAccountId] PaymentsAccount paymentsAccountId
                         * @property {google.protobuf.IStringValue|null} [name] PaymentsAccount name
                         * @property {google.protobuf.IStringValue|null} [currencyCode] PaymentsAccount currencyCode
                         * @property {google.protobuf.IStringValue|null} [paymentsProfileId] PaymentsAccount paymentsProfileId
                         * @property {google.protobuf.IStringValue|null} [secondaryPaymentsProfileId] PaymentsAccount secondaryPaymentsProfileId
                         */

                        /**
                         * Constructs a new PaymentsAccount.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a PaymentsAccount.
                         * @implements IPaymentsAccount
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IPaymentsAccount=} [properties] Properties to set
                         */
                        function PaymentsAccount(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * PaymentsAccount resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.PaymentsAccount
                         * @instance
                         */
                        PaymentsAccount.prototype.resourceName = "";

                        /**
                         * PaymentsAccount paymentsAccountId.
                         * @member {google.protobuf.IStringValue|null|undefined} paymentsAccountId
                         * @memberof google.ads.googleads.v1.resources.PaymentsAccount
                         * @instance
                         */
                        PaymentsAccount.prototype.paymentsAccountId = null;

                        /**
                         * PaymentsAccount name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.PaymentsAccount
                         * @instance
                         */
                        PaymentsAccount.prototype.name = null;

                        /**
                         * PaymentsAccount currencyCode.
                         * @member {google.protobuf.IStringValue|null|undefined} currencyCode
                         * @memberof google.ads.googleads.v1.resources.PaymentsAccount
                         * @instance
                         */
                        PaymentsAccount.prototype.currencyCode = null;

                        /**
                         * PaymentsAccount paymentsProfileId.
                         * @member {google.protobuf.IStringValue|null|undefined} paymentsProfileId
                         * @memberof google.ads.googleads.v1.resources.PaymentsAccount
                         * @instance
                         */
                        PaymentsAccount.prototype.paymentsProfileId = null;

                        /**
                         * PaymentsAccount secondaryPaymentsProfileId.
                         * @member {google.protobuf.IStringValue|null|undefined} secondaryPaymentsProfileId
                         * @memberof google.ads.googleads.v1.resources.PaymentsAccount
                         * @instance
                         */
                        PaymentsAccount.prototype.secondaryPaymentsProfileId = null;

                        /**
                         * Creates a new PaymentsAccount instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.PaymentsAccount
                         * @static
                         * @param {google.ads.googleads.v1.resources.IPaymentsAccount=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.PaymentsAccount} PaymentsAccount instance
                         */
                        PaymentsAccount.create = function create(properties) {
                            return new PaymentsAccount(properties);
                        };

                        /**
                         * Encodes the specified PaymentsAccount message. Does not implicitly {@link google.ads.googleads.v1.resources.PaymentsAccount.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.PaymentsAccount
                         * @static
                         * @param {google.ads.googleads.v1.resources.IPaymentsAccount} message PaymentsAccount message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PaymentsAccount.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.paymentsAccountId != null && message.hasOwnProperty("paymentsAccountId"))
                                $root.google.protobuf.StringValue.encode(message.paymentsAccountId, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode"))
                                $root.google.protobuf.StringValue.encode(message.currencyCode, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.paymentsProfileId != null && message.hasOwnProperty("paymentsProfileId"))
                                $root.google.protobuf.StringValue.encode(message.paymentsProfileId, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.secondaryPaymentsProfileId != null && message.hasOwnProperty("secondaryPaymentsProfileId"))
                                $root.google.protobuf.StringValue.encode(message.secondaryPaymentsProfileId, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified PaymentsAccount message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.PaymentsAccount.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.PaymentsAccount
                         * @static
                         * @param {google.ads.googleads.v1.resources.IPaymentsAccount} message PaymentsAccount message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PaymentsAccount.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a PaymentsAccount message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.PaymentsAccount
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.PaymentsAccount} PaymentsAccount
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PaymentsAccount.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.PaymentsAccount();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.paymentsAccountId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.currencyCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.paymentsProfileId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.secondaryPaymentsProfileId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a PaymentsAccount message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.PaymentsAccount
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.PaymentsAccount} PaymentsAccount
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PaymentsAccount.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a PaymentsAccount message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.PaymentsAccount
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PaymentsAccount.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.paymentsAccountId != null && message.hasOwnProperty("paymentsAccountId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.paymentsAccountId);
                                if (error)
                                    return "paymentsAccountId." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.currencyCode);
                                if (error)
                                    return "currencyCode." + error;
                            }
                            if (message.paymentsProfileId != null && message.hasOwnProperty("paymentsProfileId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.paymentsProfileId);
                                if (error)
                                    return "paymentsProfileId." + error;
                            }
                            if (message.secondaryPaymentsProfileId != null && message.hasOwnProperty("secondaryPaymentsProfileId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.secondaryPaymentsProfileId);
                                if (error)
                                    return "secondaryPaymentsProfileId." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a PaymentsAccount message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.PaymentsAccount
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.PaymentsAccount} PaymentsAccount
                         */
                        PaymentsAccount.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.PaymentsAccount)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.PaymentsAccount();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.paymentsAccountId != null) {
                                if (typeof object.paymentsAccountId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.PaymentsAccount.paymentsAccountId: object expected");
                                message.paymentsAccountId = $root.google.protobuf.StringValue.fromObject(object.paymentsAccountId);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.PaymentsAccount.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            if (object.currencyCode != null) {
                                if (typeof object.currencyCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.PaymentsAccount.currencyCode: object expected");
                                message.currencyCode = $root.google.protobuf.StringValue.fromObject(object.currencyCode);
                            }
                            if (object.paymentsProfileId != null) {
                                if (typeof object.paymentsProfileId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.PaymentsAccount.paymentsProfileId: object expected");
                                message.paymentsProfileId = $root.google.protobuf.StringValue.fromObject(object.paymentsProfileId);
                            }
                            if (object.secondaryPaymentsProfileId != null) {
                                if (typeof object.secondaryPaymentsProfileId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.PaymentsAccount.secondaryPaymentsProfileId: object expected");
                                message.secondaryPaymentsProfileId = $root.google.protobuf.StringValue.fromObject(object.secondaryPaymentsProfileId);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a PaymentsAccount message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.PaymentsAccount
                         * @static
                         * @param {google.ads.googleads.v1.resources.PaymentsAccount} message PaymentsAccount
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PaymentsAccount.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.paymentsAccountId = null;
                                object.name = null;
                                object.currencyCode = null;
                                object.paymentsProfileId = null;
                                object.secondaryPaymentsProfileId = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.paymentsAccountId != null && message.hasOwnProperty("paymentsAccountId"))
                                object.paymentsAccountId = $root.google.protobuf.StringValue.toObject(message.paymentsAccountId, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode"))
                                object.currencyCode = $root.google.protobuf.StringValue.toObject(message.currencyCode, options);
                            if (message.paymentsProfileId != null && message.hasOwnProperty("paymentsProfileId"))
                                object.paymentsProfileId = $root.google.protobuf.StringValue.toObject(message.paymentsProfileId, options);
                            if (message.secondaryPaymentsProfileId != null && message.hasOwnProperty("secondaryPaymentsProfileId"))
                                object.secondaryPaymentsProfileId = $root.google.protobuf.StringValue.toObject(message.secondaryPaymentsProfileId, options);
                            return object;
                        };

                        /**
                         * Converts this PaymentsAccount to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.PaymentsAccount
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PaymentsAccount.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return PaymentsAccount;
                    })();

                    resources.ProductBiddingCategoryConstant = (function() {

                        /**
                         * Properties of a ProductBiddingCategoryConstant.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IProductBiddingCategoryConstant
                         * @property {string|null} [resourceName] ProductBiddingCategoryConstant resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] ProductBiddingCategoryConstant id
                         * @property {google.protobuf.IStringValue|null} [countryCode] ProductBiddingCategoryConstant countryCode
                         * @property {google.protobuf.IStringValue|null} [productBiddingCategoryConstantParent] ProductBiddingCategoryConstant productBiddingCategoryConstantParent
                         * @property {google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum.ProductBiddingCategoryLevel|null} [level] ProductBiddingCategoryConstant level
                         * @property {google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum.ProductBiddingCategoryStatus|null} [status] ProductBiddingCategoryConstant status
                         * @property {google.protobuf.IStringValue|null} [languageCode] ProductBiddingCategoryConstant languageCode
                         * @property {google.protobuf.IStringValue|null} [localizedName] ProductBiddingCategoryConstant localizedName
                         */

                        /**
                         * Constructs a new ProductBiddingCategoryConstant.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a ProductBiddingCategoryConstant.
                         * @implements IProductBiddingCategoryConstant
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IProductBiddingCategoryConstant=} [properties] Properties to set
                         */
                        function ProductBiddingCategoryConstant(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ProductBiddingCategoryConstant resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.ProductBiddingCategoryConstant
                         * @instance
                         */
                        ProductBiddingCategoryConstant.prototype.resourceName = "";

                        /**
                         * ProductBiddingCategoryConstant id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.ProductBiddingCategoryConstant
                         * @instance
                         */
                        ProductBiddingCategoryConstant.prototype.id = null;

                        /**
                         * ProductBiddingCategoryConstant countryCode.
                         * @member {google.protobuf.IStringValue|null|undefined} countryCode
                         * @memberof google.ads.googleads.v1.resources.ProductBiddingCategoryConstant
                         * @instance
                         */
                        ProductBiddingCategoryConstant.prototype.countryCode = null;

                        /**
                         * ProductBiddingCategoryConstant productBiddingCategoryConstantParent.
                         * @member {google.protobuf.IStringValue|null|undefined} productBiddingCategoryConstantParent
                         * @memberof google.ads.googleads.v1.resources.ProductBiddingCategoryConstant
                         * @instance
                         */
                        ProductBiddingCategoryConstant.prototype.productBiddingCategoryConstantParent = null;

                        /**
                         * ProductBiddingCategoryConstant level.
                         * @member {google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum.ProductBiddingCategoryLevel} level
                         * @memberof google.ads.googleads.v1.resources.ProductBiddingCategoryConstant
                         * @instance
                         */
                        ProductBiddingCategoryConstant.prototype.level = 0;

                        /**
                         * ProductBiddingCategoryConstant status.
                         * @member {google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum.ProductBiddingCategoryStatus} status
                         * @memberof google.ads.googleads.v1.resources.ProductBiddingCategoryConstant
                         * @instance
                         */
                        ProductBiddingCategoryConstant.prototype.status = 0;

                        /**
                         * ProductBiddingCategoryConstant languageCode.
                         * @member {google.protobuf.IStringValue|null|undefined} languageCode
                         * @memberof google.ads.googleads.v1.resources.ProductBiddingCategoryConstant
                         * @instance
                         */
                        ProductBiddingCategoryConstant.prototype.languageCode = null;

                        /**
                         * ProductBiddingCategoryConstant localizedName.
                         * @member {google.protobuf.IStringValue|null|undefined} localizedName
                         * @memberof google.ads.googleads.v1.resources.ProductBiddingCategoryConstant
                         * @instance
                         */
                        ProductBiddingCategoryConstant.prototype.localizedName = null;

                        /**
                         * Creates a new ProductBiddingCategoryConstant instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.ProductBiddingCategoryConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.IProductBiddingCategoryConstant=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.ProductBiddingCategoryConstant} ProductBiddingCategoryConstant instance
                         */
                        ProductBiddingCategoryConstant.create = function create(properties) {
                            return new ProductBiddingCategoryConstant(properties);
                        };

                        /**
                         * Encodes the specified ProductBiddingCategoryConstant message. Does not implicitly {@link google.ads.googleads.v1.resources.ProductBiddingCategoryConstant.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.ProductBiddingCategoryConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.IProductBiddingCategoryConstant} message ProductBiddingCategoryConstant message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductBiddingCategoryConstant.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                $root.google.protobuf.StringValue.encode(message.countryCode, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.productBiddingCategoryConstantParent != null && message.hasOwnProperty("productBiddingCategoryConstantParent"))
                                $root.google.protobuf.StringValue.encode(message.productBiddingCategoryConstantParent, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.level != null && message.hasOwnProperty("level"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.level);
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.status);
                            if (message.languageCode != null && message.hasOwnProperty("languageCode"))
                                $root.google.protobuf.StringValue.encode(message.languageCode, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.localizedName != null && message.hasOwnProperty("localizedName"))
                                $root.google.protobuf.StringValue.encode(message.localizedName, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ProductBiddingCategoryConstant message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.ProductBiddingCategoryConstant.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ProductBiddingCategoryConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.IProductBiddingCategoryConstant} message ProductBiddingCategoryConstant message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductBiddingCategoryConstant.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ProductBiddingCategoryConstant message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.ProductBiddingCategoryConstant
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.ProductBiddingCategoryConstant} ProductBiddingCategoryConstant
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductBiddingCategoryConstant.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.ProductBiddingCategoryConstant();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.countryCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.productBiddingCategoryConstantParent = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.level = reader.int32();
                                    break;
                                case 6:
                                    message.status = reader.int32();
                                    break;
                                case 7:
                                    message.languageCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.localizedName = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ProductBiddingCategoryConstant message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ProductBiddingCategoryConstant
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.ProductBiddingCategoryConstant} ProductBiddingCategoryConstant
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductBiddingCategoryConstant.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ProductBiddingCategoryConstant message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.ProductBiddingCategoryConstant
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProductBiddingCategoryConstant.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.countryCode != null && message.hasOwnProperty("countryCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.countryCode);
                                if (error)
                                    return "countryCode." + error;
                            }
                            if (message.productBiddingCategoryConstantParent != null && message.hasOwnProperty("productBiddingCategoryConstantParent")) {
                                var error = $root.google.protobuf.StringValue.verify(message.productBiddingCategoryConstantParent);
                                if (error)
                                    return "productBiddingCategoryConstantParent." + error;
                            }
                            if (message.level != null && message.hasOwnProperty("level"))
                                switch (message.level) {
                                default:
                                    return "level: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.languageCode != null && message.hasOwnProperty("languageCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.languageCode);
                                if (error)
                                    return "languageCode." + error;
                            }
                            if (message.localizedName != null && message.hasOwnProperty("localizedName")) {
                                var error = $root.google.protobuf.StringValue.verify(message.localizedName);
                                if (error)
                                    return "localizedName." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a ProductBiddingCategoryConstant message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.ProductBiddingCategoryConstant
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.ProductBiddingCategoryConstant} ProductBiddingCategoryConstant
                         */
                        ProductBiddingCategoryConstant.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.ProductBiddingCategoryConstant)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.ProductBiddingCategoryConstant();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ProductBiddingCategoryConstant.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.countryCode != null) {
                                if (typeof object.countryCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ProductBiddingCategoryConstant.countryCode: object expected");
                                message.countryCode = $root.google.protobuf.StringValue.fromObject(object.countryCode);
                            }
                            if (object.productBiddingCategoryConstantParent != null) {
                                if (typeof object.productBiddingCategoryConstantParent !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ProductBiddingCategoryConstant.productBiddingCategoryConstantParent: object expected");
                                message.productBiddingCategoryConstantParent = $root.google.protobuf.StringValue.fromObject(object.productBiddingCategoryConstantParent);
                            }
                            switch (object.level) {
                            case "UNSPECIFIED":
                            case 0:
                                message.level = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.level = 1;
                                break;
                            case "LEVEL1":
                            case 2:
                                message.level = 2;
                                break;
                            case "LEVEL2":
                            case 3:
                                message.level = 3;
                                break;
                            case "LEVEL3":
                            case 4:
                                message.level = 4;
                                break;
                            case "LEVEL4":
                            case 5:
                                message.level = 5;
                                break;
                            case "LEVEL5":
                            case 6:
                                message.level = 6;
                                break;
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ACTIVE":
                            case 2:
                                message.status = 2;
                                break;
                            case "OBSOLETE":
                            case 3:
                                message.status = 3;
                                break;
                            }
                            if (object.languageCode != null) {
                                if (typeof object.languageCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ProductBiddingCategoryConstant.languageCode: object expected");
                                message.languageCode = $root.google.protobuf.StringValue.fromObject(object.languageCode);
                            }
                            if (object.localizedName != null) {
                                if (typeof object.localizedName !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.ProductBiddingCategoryConstant.localizedName: object expected");
                                message.localizedName = $root.google.protobuf.StringValue.fromObject(object.localizedName);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ProductBiddingCategoryConstant message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.ProductBiddingCategoryConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.ProductBiddingCategoryConstant} message ProductBiddingCategoryConstant
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProductBiddingCategoryConstant.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.countryCode = null;
                                object.productBiddingCategoryConstantParent = null;
                                object.level = options.enums === String ? "UNSPECIFIED" : 0;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                                object.languageCode = null;
                                object.localizedName = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                object.countryCode = $root.google.protobuf.StringValue.toObject(message.countryCode, options);
                            if (message.productBiddingCategoryConstantParent != null && message.hasOwnProperty("productBiddingCategoryConstantParent"))
                                object.productBiddingCategoryConstantParent = $root.google.protobuf.StringValue.toObject(message.productBiddingCategoryConstantParent, options);
                            if (message.level != null && message.hasOwnProperty("level"))
                                object.level = options.enums === String ? $root.google.ads.googleads.v1.enums.ProductBiddingCategoryLevelEnum.ProductBiddingCategoryLevel[message.level] : message.level;
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.ProductBiddingCategoryStatusEnum.ProductBiddingCategoryStatus[message.status] : message.status;
                            if (message.languageCode != null && message.hasOwnProperty("languageCode"))
                                object.languageCode = $root.google.protobuf.StringValue.toObject(message.languageCode, options);
                            if (message.localizedName != null && message.hasOwnProperty("localizedName"))
                                object.localizedName = $root.google.protobuf.StringValue.toObject(message.localizedName, options);
                            return object;
                        };

                        /**
                         * Converts this ProductBiddingCategoryConstant to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.ProductBiddingCategoryConstant
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProductBiddingCategoryConstant.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ProductBiddingCategoryConstant;
                    })();

                    resources.ProductGroupView = (function() {

                        /**
                         * Properties of a ProductGroupView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IProductGroupView
                         * @property {string|null} [resourceName] ProductGroupView resourceName
                         */

                        /**
                         * Constructs a new ProductGroupView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a ProductGroupView.
                         * @implements IProductGroupView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IProductGroupView=} [properties] Properties to set
                         */
                        function ProductGroupView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ProductGroupView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.ProductGroupView
                         * @instance
                         */
                        ProductGroupView.prototype.resourceName = "";

                        /**
                         * Creates a new ProductGroupView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.ProductGroupView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IProductGroupView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.ProductGroupView} ProductGroupView instance
                         */
                        ProductGroupView.create = function create(properties) {
                            return new ProductGroupView(properties);
                        };

                        /**
                         * Encodes the specified ProductGroupView message. Does not implicitly {@link google.ads.googleads.v1.resources.ProductGroupView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.ProductGroupView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IProductGroupView} message ProductGroupView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductGroupView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified ProductGroupView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.ProductGroupView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ProductGroupView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IProductGroupView} message ProductGroupView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProductGroupView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ProductGroupView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.ProductGroupView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.ProductGroupView} ProductGroupView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductGroupView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.ProductGroupView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ProductGroupView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ProductGroupView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.ProductGroupView} ProductGroupView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProductGroupView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ProductGroupView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.ProductGroupView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProductGroupView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a ProductGroupView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.ProductGroupView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.ProductGroupView} ProductGroupView
                         */
                        ProductGroupView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.ProductGroupView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.ProductGroupView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a ProductGroupView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.ProductGroupView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ProductGroupView} message ProductGroupView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProductGroupView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this ProductGroupView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.ProductGroupView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProductGroupView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ProductGroupView;
                    })();

                    resources.Recommendation = (function() {

                        /**
                         * Properties of a Recommendation.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IRecommendation
                         * @property {string|null} [resourceName] Recommendation resourceName
                         * @property {google.ads.googleads.v1.enums.RecommendationTypeEnum.RecommendationType|null} [type] Recommendation type
                         * @property {google.ads.googleads.v1.resources.Recommendation.IRecommendationImpact|null} [impact] Recommendation impact
                         * @property {google.protobuf.IStringValue|null} [campaignBudget] Recommendation campaignBudget
                         * @property {google.protobuf.IStringValue|null} [campaign] Recommendation campaign
                         * @property {google.protobuf.IStringValue|null} [adGroup] Recommendation adGroup
                         * @property {google.protobuf.IBoolValue|null} [dismissed] Recommendation dismissed
                         * @property {google.ads.googleads.v1.resources.Recommendation.ICampaignBudgetRecommendation|null} [campaignBudgetRecommendation] Recommendation campaignBudgetRecommendation
                         * @property {google.ads.googleads.v1.resources.Recommendation.IKeywordRecommendation|null} [keywordRecommendation] Recommendation keywordRecommendation
                         * @property {google.ads.googleads.v1.resources.Recommendation.ITextAdRecommendation|null} [textAdRecommendation] Recommendation textAdRecommendation
                         * @property {google.ads.googleads.v1.resources.Recommendation.ITargetCpaOptInRecommendation|null} [targetCpaOptInRecommendation] Recommendation targetCpaOptInRecommendation
                         * @property {google.ads.googleads.v1.resources.Recommendation.IMaximizeConversionsOptInRecommendation|null} [maximizeConversionsOptInRecommendation] Recommendation maximizeConversionsOptInRecommendation
                         * @property {google.ads.googleads.v1.resources.Recommendation.IEnhancedCpcOptInRecommendation|null} [enhancedCpcOptInRecommendation] Recommendation enhancedCpcOptInRecommendation
                         * @property {google.ads.googleads.v1.resources.Recommendation.ISearchPartnersOptInRecommendation|null} [searchPartnersOptInRecommendation] Recommendation searchPartnersOptInRecommendation
                         * @property {google.ads.googleads.v1.resources.Recommendation.IMaximizeClicksOptInRecommendation|null} [maximizeClicksOptInRecommendation] Recommendation maximizeClicksOptInRecommendation
                         * @property {google.ads.googleads.v1.resources.Recommendation.IOptimizeAdRotationRecommendation|null} [optimizeAdRotationRecommendation] Recommendation optimizeAdRotationRecommendation
                         * @property {google.ads.googleads.v1.resources.Recommendation.ICalloutExtensionRecommendation|null} [calloutExtensionRecommendation] Recommendation calloutExtensionRecommendation
                         * @property {google.ads.googleads.v1.resources.Recommendation.ISitelinkExtensionRecommendation|null} [sitelinkExtensionRecommendation] Recommendation sitelinkExtensionRecommendation
                         * @property {google.ads.googleads.v1.resources.Recommendation.ICallExtensionRecommendation|null} [callExtensionRecommendation] Recommendation callExtensionRecommendation
                         * @property {google.ads.googleads.v1.resources.Recommendation.IKeywordMatchTypeRecommendation|null} [keywordMatchTypeRecommendation] Recommendation keywordMatchTypeRecommendation
                         * @property {google.ads.googleads.v1.resources.Recommendation.IMoveUnusedBudgetRecommendation|null} [moveUnusedBudgetRecommendation] Recommendation moveUnusedBudgetRecommendation
                         */

                        /**
                         * Constructs a new Recommendation.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a Recommendation.
                         * @implements IRecommendation
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IRecommendation=} [properties] Properties to set
                         */
                        function Recommendation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Recommendation resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.resourceName = "";

                        /**
                         * Recommendation type.
                         * @member {google.ads.googleads.v1.enums.RecommendationTypeEnum.RecommendationType} type
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.type = 0;

                        /**
                         * Recommendation impact.
                         * @member {google.ads.googleads.v1.resources.Recommendation.IRecommendationImpact|null|undefined} impact
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.impact = null;

                        /**
                         * Recommendation campaignBudget.
                         * @member {google.protobuf.IStringValue|null|undefined} campaignBudget
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.campaignBudget = null;

                        /**
                         * Recommendation campaign.
                         * @member {google.protobuf.IStringValue|null|undefined} campaign
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.campaign = null;

                        /**
                         * Recommendation adGroup.
                         * @member {google.protobuf.IStringValue|null|undefined} adGroup
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.adGroup = null;

                        /**
                         * Recommendation dismissed.
                         * @member {google.protobuf.IBoolValue|null|undefined} dismissed
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.dismissed = null;

                        /**
                         * Recommendation campaignBudgetRecommendation.
                         * @member {google.ads.googleads.v1.resources.Recommendation.ICampaignBudgetRecommendation|null|undefined} campaignBudgetRecommendation
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.campaignBudgetRecommendation = null;

                        /**
                         * Recommendation keywordRecommendation.
                         * @member {google.ads.googleads.v1.resources.Recommendation.IKeywordRecommendation|null|undefined} keywordRecommendation
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.keywordRecommendation = null;

                        /**
                         * Recommendation textAdRecommendation.
                         * @member {google.ads.googleads.v1.resources.Recommendation.ITextAdRecommendation|null|undefined} textAdRecommendation
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.textAdRecommendation = null;

                        /**
                         * Recommendation targetCpaOptInRecommendation.
                         * @member {google.ads.googleads.v1.resources.Recommendation.ITargetCpaOptInRecommendation|null|undefined} targetCpaOptInRecommendation
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.targetCpaOptInRecommendation = null;

                        /**
                         * Recommendation maximizeConversionsOptInRecommendation.
                         * @member {google.ads.googleads.v1.resources.Recommendation.IMaximizeConversionsOptInRecommendation|null|undefined} maximizeConversionsOptInRecommendation
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.maximizeConversionsOptInRecommendation = null;

                        /**
                         * Recommendation enhancedCpcOptInRecommendation.
                         * @member {google.ads.googleads.v1.resources.Recommendation.IEnhancedCpcOptInRecommendation|null|undefined} enhancedCpcOptInRecommendation
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.enhancedCpcOptInRecommendation = null;

                        /**
                         * Recommendation searchPartnersOptInRecommendation.
                         * @member {google.ads.googleads.v1.resources.Recommendation.ISearchPartnersOptInRecommendation|null|undefined} searchPartnersOptInRecommendation
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.searchPartnersOptInRecommendation = null;

                        /**
                         * Recommendation maximizeClicksOptInRecommendation.
                         * @member {google.ads.googleads.v1.resources.Recommendation.IMaximizeClicksOptInRecommendation|null|undefined} maximizeClicksOptInRecommendation
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.maximizeClicksOptInRecommendation = null;

                        /**
                         * Recommendation optimizeAdRotationRecommendation.
                         * @member {google.ads.googleads.v1.resources.Recommendation.IOptimizeAdRotationRecommendation|null|undefined} optimizeAdRotationRecommendation
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.optimizeAdRotationRecommendation = null;

                        /**
                         * Recommendation calloutExtensionRecommendation.
                         * @member {google.ads.googleads.v1.resources.Recommendation.ICalloutExtensionRecommendation|null|undefined} calloutExtensionRecommendation
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.calloutExtensionRecommendation = null;

                        /**
                         * Recommendation sitelinkExtensionRecommendation.
                         * @member {google.ads.googleads.v1.resources.Recommendation.ISitelinkExtensionRecommendation|null|undefined} sitelinkExtensionRecommendation
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.sitelinkExtensionRecommendation = null;

                        /**
                         * Recommendation callExtensionRecommendation.
                         * @member {google.ads.googleads.v1.resources.Recommendation.ICallExtensionRecommendation|null|undefined} callExtensionRecommendation
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.callExtensionRecommendation = null;

                        /**
                         * Recommendation keywordMatchTypeRecommendation.
                         * @member {google.ads.googleads.v1.resources.Recommendation.IKeywordMatchTypeRecommendation|null|undefined} keywordMatchTypeRecommendation
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.keywordMatchTypeRecommendation = null;

                        /**
                         * Recommendation moveUnusedBudgetRecommendation.
                         * @member {google.ads.googleads.v1.resources.Recommendation.IMoveUnusedBudgetRecommendation|null|undefined} moveUnusedBudgetRecommendation
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Recommendation.prototype.moveUnusedBudgetRecommendation = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * Recommendation recommendation.
                         * @member {"campaignBudgetRecommendation"|"keywordRecommendation"|"textAdRecommendation"|"targetCpaOptInRecommendation"|"maximizeConversionsOptInRecommendation"|"enhancedCpcOptInRecommendation"|"searchPartnersOptInRecommendation"|"maximizeClicksOptInRecommendation"|"optimizeAdRotationRecommendation"|"calloutExtensionRecommendation"|"sitelinkExtensionRecommendation"|"callExtensionRecommendation"|"keywordMatchTypeRecommendation"|"moveUnusedBudgetRecommendation"|undefined} recommendation
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         */
                        Object.defineProperty(Recommendation.prototype, "recommendation", {
                            get: $util.oneOfGetter($oneOfFields = ["campaignBudgetRecommendation", "keywordRecommendation", "textAdRecommendation", "targetCpaOptInRecommendation", "maximizeConversionsOptInRecommendation", "enhancedCpcOptInRecommendation", "searchPartnersOptInRecommendation", "maximizeClicksOptInRecommendation", "optimizeAdRotationRecommendation", "calloutExtensionRecommendation", "sitelinkExtensionRecommendation", "callExtensionRecommendation", "keywordMatchTypeRecommendation", "moveUnusedBudgetRecommendation"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new Recommendation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @static
                         * @param {google.ads.googleads.v1.resources.IRecommendation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.Recommendation} Recommendation instance
                         */
                        Recommendation.create = function create(properties) {
                            return new Recommendation(properties);
                        };

                        /**
                         * Encodes the specified Recommendation message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @static
                         * @param {google.ads.googleads.v1.resources.IRecommendation} message Recommendation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Recommendation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.type);
                            if (message.impact != null && message.hasOwnProperty("impact"))
                                $root.google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.encode(message.impact, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.campaignBudgetRecommendation != null && message.hasOwnProperty("campaignBudgetRecommendation"))
                                $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.encode(message.campaignBudgetRecommendation, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.campaignBudget != null && message.hasOwnProperty("campaignBudget"))
                                $root.google.protobuf.StringValue.encode(message.campaignBudget, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                $root.google.protobuf.StringValue.encode(message.campaign, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                $root.google.protobuf.StringValue.encode(message.adGroup, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.keywordRecommendation != null && message.hasOwnProperty("keywordRecommendation"))
                                $root.google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation.encode(message.keywordRecommendation, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.textAdRecommendation != null && message.hasOwnProperty("textAdRecommendation"))
                                $root.google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation.encode(message.textAdRecommendation, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.targetCpaOptInRecommendation != null && message.hasOwnProperty("targetCpaOptInRecommendation"))
                                $root.google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.encode(message.targetCpaOptInRecommendation, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.maximizeConversionsOptInRecommendation != null && message.hasOwnProperty("maximizeConversionsOptInRecommendation"))
                                $root.google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation.encode(message.maximizeConversionsOptInRecommendation, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.enhancedCpcOptInRecommendation != null && message.hasOwnProperty("enhancedCpcOptInRecommendation"))
                                $root.google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation.encode(message.enhancedCpcOptInRecommendation, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.dismissed != null && message.hasOwnProperty("dismissed"))
                                $root.google.protobuf.BoolValue.encode(message.dismissed, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                            if (message.searchPartnersOptInRecommendation != null && message.hasOwnProperty("searchPartnersOptInRecommendation"))
                                $root.google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation.encode(message.searchPartnersOptInRecommendation, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.maximizeClicksOptInRecommendation != null && message.hasOwnProperty("maximizeClicksOptInRecommendation"))
                                $root.google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation.encode(message.maximizeClicksOptInRecommendation, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
                            if (message.optimizeAdRotationRecommendation != null && message.hasOwnProperty("optimizeAdRotationRecommendation"))
                                $root.google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation.encode(message.optimizeAdRotationRecommendation, writer.uint32(/* id 16, wireType 2 =*/130).fork()).ldelim();
                            if (message.calloutExtensionRecommendation != null && message.hasOwnProperty("calloutExtensionRecommendation"))
                                $root.google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation.encode(message.calloutExtensionRecommendation, writer.uint32(/* id 17, wireType 2 =*/138).fork()).ldelim();
                            if (message.sitelinkExtensionRecommendation != null && message.hasOwnProperty("sitelinkExtensionRecommendation"))
                                $root.google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation.encode(message.sitelinkExtensionRecommendation, writer.uint32(/* id 18, wireType 2 =*/146).fork()).ldelim();
                            if (message.callExtensionRecommendation != null && message.hasOwnProperty("callExtensionRecommendation"))
                                $root.google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation.encode(message.callExtensionRecommendation, writer.uint32(/* id 19, wireType 2 =*/154).fork()).ldelim();
                            if (message.keywordMatchTypeRecommendation != null && message.hasOwnProperty("keywordMatchTypeRecommendation"))
                                $root.google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation.encode(message.keywordMatchTypeRecommendation, writer.uint32(/* id 20, wireType 2 =*/162).fork()).ldelim();
                            if (message.moveUnusedBudgetRecommendation != null && message.hasOwnProperty("moveUnusedBudgetRecommendation"))
                                $root.google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation.encode(message.moveUnusedBudgetRecommendation, writer.uint32(/* id 21, wireType 2 =*/170).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified Recommendation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @static
                         * @param {google.ads.googleads.v1.resources.IRecommendation} message Recommendation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Recommendation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a Recommendation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.Recommendation} Recommendation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Recommendation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.type = reader.int32();
                                    break;
                                case 3:
                                    message.impact = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.campaignBudget = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.campaign = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.adGroup = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 13:
                                    message.dismissed = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.campaignBudgetRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.keywordRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.textAdRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.targetCpaOptInRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.maximizeConversionsOptInRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.enhancedCpcOptInRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation.decode(reader, reader.uint32());
                                    break;
                                case 14:
                                    message.searchPartnersOptInRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation.decode(reader, reader.uint32());
                                    break;
                                case 15:
                                    message.maximizeClicksOptInRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation.decode(reader, reader.uint32());
                                    break;
                                case 16:
                                    message.optimizeAdRotationRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation.decode(reader, reader.uint32());
                                    break;
                                case 17:
                                    message.calloutExtensionRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation.decode(reader, reader.uint32());
                                    break;
                                case 18:
                                    message.sitelinkExtensionRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation.decode(reader, reader.uint32());
                                    break;
                                case 19:
                                    message.callExtensionRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation.decode(reader, reader.uint32());
                                    break;
                                case 20:
                                    message.keywordMatchTypeRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation.decode(reader, reader.uint32());
                                    break;
                                case 21:
                                    message.moveUnusedBudgetRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a Recommendation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.Recommendation} Recommendation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Recommendation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a Recommendation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Recommendation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                    break;
                                }
                            if (message.impact != null && message.hasOwnProperty("impact")) {
                                var error = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.verify(message.impact);
                                if (error)
                                    return "impact." + error;
                            }
                            if (message.campaignBudget != null && message.hasOwnProperty("campaignBudget")) {
                                var error = $root.google.protobuf.StringValue.verify(message.campaignBudget);
                                if (error)
                                    return "campaignBudget." + error;
                            }
                            if (message.campaign != null && message.hasOwnProperty("campaign")) {
                                var error = $root.google.protobuf.StringValue.verify(message.campaign);
                                if (error)
                                    return "campaign." + error;
                            }
                            if (message.adGroup != null && message.hasOwnProperty("adGroup")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adGroup);
                                if (error)
                                    return "adGroup." + error;
                            }
                            if (message.dismissed != null && message.hasOwnProperty("dismissed")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.dismissed);
                                if (error)
                                    return "dismissed." + error;
                            }
                            if (message.campaignBudgetRecommendation != null && message.hasOwnProperty("campaignBudgetRecommendation")) {
                                properties.recommendation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.verify(message.campaignBudgetRecommendation);
                                    if (error)
                                        return "campaignBudgetRecommendation." + error;
                                }
                            }
                            if (message.keywordRecommendation != null && message.hasOwnProperty("keywordRecommendation")) {
                                if (properties.recommendation === 1)
                                    return "recommendation: multiple values";
                                properties.recommendation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation.verify(message.keywordRecommendation);
                                    if (error)
                                        return "keywordRecommendation." + error;
                                }
                            }
                            if (message.textAdRecommendation != null && message.hasOwnProperty("textAdRecommendation")) {
                                if (properties.recommendation === 1)
                                    return "recommendation: multiple values";
                                properties.recommendation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation.verify(message.textAdRecommendation);
                                    if (error)
                                        return "textAdRecommendation." + error;
                                }
                            }
                            if (message.targetCpaOptInRecommendation != null && message.hasOwnProperty("targetCpaOptInRecommendation")) {
                                if (properties.recommendation === 1)
                                    return "recommendation: multiple values";
                                properties.recommendation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.verify(message.targetCpaOptInRecommendation);
                                    if (error)
                                        return "targetCpaOptInRecommendation." + error;
                                }
                            }
                            if (message.maximizeConversionsOptInRecommendation != null && message.hasOwnProperty("maximizeConversionsOptInRecommendation")) {
                                if (properties.recommendation === 1)
                                    return "recommendation: multiple values";
                                properties.recommendation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation.verify(message.maximizeConversionsOptInRecommendation);
                                    if (error)
                                        return "maximizeConversionsOptInRecommendation." + error;
                                }
                            }
                            if (message.enhancedCpcOptInRecommendation != null && message.hasOwnProperty("enhancedCpcOptInRecommendation")) {
                                if (properties.recommendation === 1)
                                    return "recommendation: multiple values";
                                properties.recommendation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation.verify(message.enhancedCpcOptInRecommendation);
                                    if (error)
                                        return "enhancedCpcOptInRecommendation." + error;
                                }
                            }
                            if (message.searchPartnersOptInRecommendation != null && message.hasOwnProperty("searchPartnersOptInRecommendation")) {
                                if (properties.recommendation === 1)
                                    return "recommendation: multiple values";
                                properties.recommendation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation.verify(message.searchPartnersOptInRecommendation);
                                    if (error)
                                        return "searchPartnersOptInRecommendation." + error;
                                }
                            }
                            if (message.maximizeClicksOptInRecommendation != null && message.hasOwnProperty("maximizeClicksOptInRecommendation")) {
                                if (properties.recommendation === 1)
                                    return "recommendation: multiple values";
                                properties.recommendation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation.verify(message.maximizeClicksOptInRecommendation);
                                    if (error)
                                        return "maximizeClicksOptInRecommendation." + error;
                                }
                            }
                            if (message.optimizeAdRotationRecommendation != null && message.hasOwnProperty("optimizeAdRotationRecommendation")) {
                                if (properties.recommendation === 1)
                                    return "recommendation: multiple values";
                                properties.recommendation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation.verify(message.optimizeAdRotationRecommendation);
                                    if (error)
                                        return "optimizeAdRotationRecommendation." + error;
                                }
                            }
                            if (message.calloutExtensionRecommendation != null && message.hasOwnProperty("calloutExtensionRecommendation")) {
                                if (properties.recommendation === 1)
                                    return "recommendation: multiple values";
                                properties.recommendation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation.verify(message.calloutExtensionRecommendation);
                                    if (error)
                                        return "calloutExtensionRecommendation." + error;
                                }
                            }
                            if (message.sitelinkExtensionRecommendation != null && message.hasOwnProperty("sitelinkExtensionRecommendation")) {
                                if (properties.recommendation === 1)
                                    return "recommendation: multiple values";
                                properties.recommendation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation.verify(message.sitelinkExtensionRecommendation);
                                    if (error)
                                        return "sitelinkExtensionRecommendation." + error;
                                }
                            }
                            if (message.callExtensionRecommendation != null && message.hasOwnProperty("callExtensionRecommendation")) {
                                if (properties.recommendation === 1)
                                    return "recommendation: multiple values";
                                properties.recommendation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation.verify(message.callExtensionRecommendation);
                                    if (error)
                                        return "callExtensionRecommendation." + error;
                                }
                            }
                            if (message.keywordMatchTypeRecommendation != null && message.hasOwnProperty("keywordMatchTypeRecommendation")) {
                                if (properties.recommendation === 1)
                                    return "recommendation: multiple values";
                                properties.recommendation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation.verify(message.keywordMatchTypeRecommendation);
                                    if (error)
                                        return "keywordMatchTypeRecommendation." + error;
                                }
                            }
                            if (message.moveUnusedBudgetRecommendation != null && message.hasOwnProperty("moveUnusedBudgetRecommendation")) {
                                if (properties.recommendation === 1)
                                    return "recommendation: multiple values";
                                properties.recommendation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation.verify(message.moveUnusedBudgetRecommendation);
                                    if (error)
                                        return "moveUnusedBudgetRecommendation." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a Recommendation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.Recommendation} Recommendation
                         */
                        Recommendation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.Recommendation();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "CAMPAIGN_BUDGET":
                            case 2:
                                message.type = 2;
                                break;
                            case "KEYWORD":
                            case 3:
                                message.type = 3;
                                break;
                            case "TEXT_AD":
                            case 4:
                                message.type = 4;
                                break;
                            case "TARGET_CPA_OPT_IN":
                            case 5:
                                message.type = 5;
                                break;
                            case "MAXIMIZE_CONVERSIONS_OPT_IN":
                            case 6:
                                message.type = 6;
                                break;
                            case "ENHANCED_CPC_OPT_IN":
                            case 7:
                                message.type = 7;
                                break;
                            case "SEARCH_PARTNERS_OPT_IN":
                            case 8:
                                message.type = 8;
                                break;
                            case "MAXIMIZE_CLICKS_OPT_IN":
                            case 9:
                                message.type = 9;
                                break;
                            case "OPTIMIZE_AD_ROTATION":
                            case 10:
                                message.type = 10;
                                break;
                            case "CALLOUT_EXTENSION":
                            case 11:
                                message.type = 11;
                                break;
                            case "SITELINK_EXTENSION":
                            case 12:
                                message.type = 12;
                                break;
                            case "CALL_EXTENSION":
                            case 13:
                                message.type = 13;
                                break;
                            case "KEYWORD_MATCH_TYPE":
                            case 14:
                                message.type = 14;
                                break;
                            case "MOVE_UNUSED_BUDGET":
                            case 15:
                                message.type = 15;
                                break;
                            }
                            if (object.impact != null) {
                                if (typeof object.impact !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.impact: object expected");
                                message.impact = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.fromObject(object.impact);
                            }
                            if (object.campaignBudget != null) {
                                if (typeof object.campaignBudget !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.campaignBudget: object expected");
                                message.campaignBudget = $root.google.protobuf.StringValue.fromObject(object.campaignBudget);
                            }
                            if (object.campaign != null) {
                                if (typeof object.campaign !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.campaign: object expected");
                                message.campaign = $root.google.protobuf.StringValue.fromObject(object.campaign);
                            }
                            if (object.adGroup != null) {
                                if (typeof object.adGroup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.adGroup: object expected");
                                message.adGroup = $root.google.protobuf.StringValue.fromObject(object.adGroup);
                            }
                            if (object.dismissed != null) {
                                if (typeof object.dismissed !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.dismissed: object expected");
                                message.dismissed = $root.google.protobuf.BoolValue.fromObject(object.dismissed);
                            }
                            if (object.campaignBudgetRecommendation != null) {
                                if (typeof object.campaignBudgetRecommendation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.campaignBudgetRecommendation: object expected");
                                message.campaignBudgetRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.fromObject(object.campaignBudgetRecommendation);
                            }
                            if (object.keywordRecommendation != null) {
                                if (typeof object.keywordRecommendation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.keywordRecommendation: object expected");
                                message.keywordRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation.fromObject(object.keywordRecommendation);
                            }
                            if (object.textAdRecommendation != null) {
                                if (typeof object.textAdRecommendation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.textAdRecommendation: object expected");
                                message.textAdRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation.fromObject(object.textAdRecommendation);
                            }
                            if (object.targetCpaOptInRecommendation != null) {
                                if (typeof object.targetCpaOptInRecommendation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.targetCpaOptInRecommendation: object expected");
                                message.targetCpaOptInRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.fromObject(object.targetCpaOptInRecommendation);
                            }
                            if (object.maximizeConversionsOptInRecommendation != null) {
                                if (typeof object.maximizeConversionsOptInRecommendation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.maximizeConversionsOptInRecommendation: object expected");
                                message.maximizeConversionsOptInRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation.fromObject(object.maximizeConversionsOptInRecommendation);
                            }
                            if (object.enhancedCpcOptInRecommendation != null) {
                                if (typeof object.enhancedCpcOptInRecommendation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.enhancedCpcOptInRecommendation: object expected");
                                message.enhancedCpcOptInRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation.fromObject(object.enhancedCpcOptInRecommendation);
                            }
                            if (object.searchPartnersOptInRecommendation != null) {
                                if (typeof object.searchPartnersOptInRecommendation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.searchPartnersOptInRecommendation: object expected");
                                message.searchPartnersOptInRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation.fromObject(object.searchPartnersOptInRecommendation);
                            }
                            if (object.maximizeClicksOptInRecommendation != null) {
                                if (typeof object.maximizeClicksOptInRecommendation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.maximizeClicksOptInRecommendation: object expected");
                                message.maximizeClicksOptInRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation.fromObject(object.maximizeClicksOptInRecommendation);
                            }
                            if (object.optimizeAdRotationRecommendation != null) {
                                if (typeof object.optimizeAdRotationRecommendation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.optimizeAdRotationRecommendation: object expected");
                                message.optimizeAdRotationRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation.fromObject(object.optimizeAdRotationRecommendation);
                            }
                            if (object.calloutExtensionRecommendation != null) {
                                if (typeof object.calloutExtensionRecommendation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.calloutExtensionRecommendation: object expected");
                                message.calloutExtensionRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation.fromObject(object.calloutExtensionRecommendation);
                            }
                            if (object.sitelinkExtensionRecommendation != null) {
                                if (typeof object.sitelinkExtensionRecommendation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.sitelinkExtensionRecommendation: object expected");
                                message.sitelinkExtensionRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation.fromObject(object.sitelinkExtensionRecommendation);
                            }
                            if (object.callExtensionRecommendation != null) {
                                if (typeof object.callExtensionRecommendation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.callExtensionRecommendation: object expected");
                                message.callExtensionRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation.fromObject(object.callExtensionRecommendation);
                            }
                            if (object.keywordMatchTypeRecommendation != null) {
                                if (typeof object.keywordMatchTypeRecommendation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.keywordMatchTypeRecommendation: object expected");
                                message.keywordMatchTypeRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation.fromObject(object.keywordMatchTypeRecommendation);
                            }
                            if (object.moveUnusedBudgetRecommendation != null) {
                                if (typeof object.moveUnusedBudgetRecommendation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Recommendation.moveUnusedBudgetRecommendation: object expected");
                                message.moveUnusedBudgetRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation.fromObject(object.moveUnusedBudgetRecommendation);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a Recommendation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @static
                         * @param {google.ads.googleads.v1.resources.Recommendation} message Recommendation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Recommendation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.impact = null;
                                object.campaignBudget = null;
                                object.campaign = null;
                                object.adGroup = null;
                                object.dismissed = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.RecommendationTypeEnum.RecommendationType[message.type] : message.type;
                            if (message.impact != null && message.hasOwnProperty("impact"))
                                object.impact = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.toObject(message.impact, options);
                            if (message.campaignBudgetRecommendation != null && message.hasOwnProperty("campaignBudgetRecommendation")) {
                                object.campaignBudgetRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.toObject(message.campaignBudgetRecommendation, options);
                                if (options.oneofs)
                                    object.recommendation = "campaignBudgetRecommendation";
                            }
                            if (message.campaignBudget != null && message.hasOwnProperty("campaignBudget"))
                                object.campaignBudget = $root.google.protobuf.StringValue.toObject(message.campaignBudget, options);
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                object.campaign = $root.google.protobuf.StringValue.toObject(message.campaign, options);
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                object.adGroup = $root.google.protobuf.StringValue.toObject(message.adGroup, options);
                            if (message.keywordRecommendation != null && message.hasOwnProperty("keywordRecommendation")) {
                                object.keywordRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation.toObject(message.keywordRecommendation, options);
                                if (options.oneofs)
                                    object.recommendation = "keywordRecommendation";
                            }
                            if (message.textAdRecommendation != null && message.hasOwnProperty("textAdRecommendation")) {
                                object.textAdRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation.toObject(message.textAdRecommendation, options);
                                if (options.oneofs)
                                    object.recommendation = "textAdRecommendation";
                            }
                            if (message.targetCpaOptInRecommendation != null && message.hasOwnProperty("targetCpaOptInRecommendation")) {
                                object.targetCpaOptInRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.toObject(message.targetCpaOptInRecommendation, options);
                                if (options.oneofs)
                                    object.recommendation = "targetCpaOptInRecommendation";
                            }
                            if (message.maximizeConversionsOptInRecommendation != null && message.hasOwnProperty("maximizeConversionsOptInRecommendation")) {
                                object.maximizeConversionsOptInRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation.toObject(message.maximizeConversionsOptInRecommendation, options);
                                if (options.oneofs)
                                    object.recommendation = "maximizeConversionsOptInRecommendation";
                            }
                            if (message.enhancedCpcOptInRecommendation != null && message.hasOwnProperty("enhancedCpcOptInRecommendation")) {
                                object.enhancedCpcOptInRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation.toObject(message.enhancedCpcOptInRecommendation, options);
                                if (options.oneofs)
                                    object.recommendation = "enhancedCpcOptInRecommendation";
                            }
                            if (message.dismissed != null && message.hasOwnProperty("dismissed"))
                                object.dismissed = $root.google.protobuf.BoolValue.toObject(message.dismissed, options);
                            if (message.searchPartnersOptInRecommendation != null && message.hasOwnProperty("searchPartnersOptInRecommendation")) {
                                object.searchPartnersOptInRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation.toObject(message.searchPartnersOptInRecommendation, options);
                                if (options.oneofs)
                                    object.recommendation = "searchPartnersOptInRecommendation";
                            }
                            if (message.maximizeClicksOptInRecommendation != null && message.hasOwnProperty("maximizeClicksOptInRecommendation")) {
                                object.maximizeClicksOptInRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation.toObject(message.maximizeClicksOptInRecommendation, options);
                                if (options.oneofs)
                                    object.recommendation = "maximizeClicksOptInRecommendation";
                            }
                            if (message.optimizeAdRotationRecommendation != null && message.hasOwnProperty("optimizeAdRotationRecommendation")) {
                                object.optimizeAdRotationRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation.toObject(message.optimizeAdRotationRecommendation, options);
                                if (options.oneofs)
                                    object.recommendation = "optimizeAdRotationRecommendation";
                            }
                            if (message.calloutExtensionRecommendation != null && message.hasOwnProperty("calloutExtensionRecommendation")) {
                                object.calloutExtensionRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation.toObject(message.calloutExtensionRecommendation, options);
                                if (options.oneofs)
                                    object.recommendation = "calloutExtensionRecommendation";
                            }
                            if (message.sitelinkExtensionRecommendation != null && message.hasOwnProperty("sitelinkExtensionRecommendation")) {
                                object.sitelinkExtensionRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation.toObject(message.sitelinkExtensionRecommendation, options);
                                if (options.oneofs)
                                    object.recommendation = "sitelinkExtensionRecommendation";
                            }
                            if (message.callExtensionRecommendation != null && message.hasOwnProperty("callExtensionRecommendation")) {
                                object.callExtensionRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation.toObject(message.callExtensionRecommendation, options);
                                if (options.oneofs)
                                    object.recommendation = "callExtensionRecommendation";
                            }
                            if (message.keywordMatchTypeRecommendation != null && message.hasOwnProperty("keywordMatchTypeRecommendation")) {
                                object.keywordMatchTypeRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation.toObject(message.keywordMatchTypeRecommendation, options);
                                if (options.oneofs)
                                    object.recommendation = "keywordMatchTypeRecommendation";
                            }
                            if (message.moveUnusedBudgetRecommendation != null && message.hasOwnProperty("moveUnusedBudgetRecommendation")) {
                                object.moveUnusedBudgetRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation.toObject(message.moveUnusedBudgetRecommendation, options);
                                if (options.oneofs)
                                    object.recommendation = "moveUnusedBudgetRecommendation";
                            }
                            return object;
                        };

                        /**
                         * Converts this Recommendation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.Recommendation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Recommendation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        Recommendation.RecommendationImpact = (function() {

                            /**
                             * Properties of a RecommendationImpact.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @interface IRecommendationImpact
                             * @property {google.ads.googleads.v1.resources.Recommendation.IRecommendationMetrics|null} [baseMetrics] RecommendationImpact baseMetrics
                             * @property {google.ads.googleads.v1.resources.Recommendation.IRecommendationMetrics|null} [potentialMetrics] RecommendationImpact potentialMetrics
                             */

                            /**
                             * Constructs a new RecommendationImpact.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @classdesc Represents a RecommendationImpact.
                             * @implements IRecommendationImpact
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Recommendation.IRecommendationImpact=} [properties] Properties to set
                             */
                            function RecommendationImpact(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * RecommendationImpact baseMetrics.
                             * @member {google.ads.googleads.v1.resources.Recommendation.IRecommendationMetrics|null|undefined} baseMetrics
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationImpact
                             * @instance
                             */
                            RecommendationImpact.prototype.baseMetrics = null;

                            /**
                             * RecommendationImpact potentialMetrics.
                             * @member {google.ads.googleads.v1.resources.Recommendation.IRecommendationMetrics|null|undefined} potentialMetrics
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationImpact
                             * @instance
                             */
                            RecommendationImpact.prototype.potentialMetrics = null;

                            /**
                             * Creates a new RecommendationImpact instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationImpact
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IRecommendationImpact=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Recommendation.RecommendationImpact} RecommendationImpact instance
                             */
                            RecommendationImpact.create = function create(properties) {
                                return new RecommendationImpact(properties);
                            };

                            /**
                             * Encodes the specified RecommendationImpact message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationImpact
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IRecommendationImpact} message RecommendationImpact message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            RecommendationImpact.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.baseMetrics != null && message.hasOwnProperty("baseMetrics"))
                                    $root.google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics.encode(message.baseMetrics, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.potentialMetrics != null && message.hasOwnProperty("potentialMetrics"))
                                    $root.google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics.encode(message.potentialMetrics, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified RecommendationImpact message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationImpact
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IRecommendationImpact} message RecommendationImpact message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            RecommendationImpact.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a RecommendationImpact message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationImpact
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Recommendation.RecommendationImpact} RecommendationImpact
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            RecommendationImpact.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation.RecommendationImpact();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.baseMetrics = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.potentialMetrics = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a RecommendationImpact message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationImpact
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Recommendation.RecommendationImpact} RecommendationImpact
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            RecommendationImpact.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a RecommendationImpact message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationImpact
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            RecommendationImpact.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.baseMetrics != null && message.hasOwnProperty("baseMetrics")) {
                                    var error = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics.verify(message.baseMetrics);
                                    if (error)
                                        return "baseMetrics." + error;
                                }
                                if (message.potentialMetrics != null && message.hasOwnProperty("potentialMetrics")) {
                                    var error = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics.verify(message.potentialMetrics);
                                    if (error)
                                        return "potentialMetrics." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a RecommendationImpact message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationImpact
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Recommendation.RecommendationImpact} RecommendationImpact
                             */
                            RecommendationImpact.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation.RecommendationImpact)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Recommendation.RecommendationImpact();
                                if (object.baseMetrics != null) {
                                    if (typeof object.baseMetrics !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.baseMetrics: object expected");
                                    message.baseMetrics = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics.fromObject(object.baseMetrics);
                                }
                                if (object.potentialMetrics != null) {
                                    if (typeof object.potentialMetrics !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.potentialMetrics: object expected");
                                    message.potentialMetrics = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics.fromObject(object.potentialMetrics);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a RecommendationImpact message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationImpact
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.RecommendationImpact} message RecommendationImpact
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            RecommendationImpact.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.baseMetrics = null;
                                    object.potentialMetrics = null;
                                }
                                if (message.baseMetrics != null && message.hasOwnProperty("baseMetrics"))
                                    object.baseMetrics = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics.toObject(message.baseMetrics, options);
                                if (message.potentialMetrics != null && message.hasOwnProperty("potentialMetrics"))
                                    object.potentialMetrics = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics.toObject(message.potentialMetrics, options);
                                return object;
                            };

                            /**
                             * Converts this RecommendationImpact to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationImpact
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            RecommendationImpact.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return RecommendationImpact;
                        })();

                        Recommendation.RecommendationMetrics = (function() {

                            /**
                             * Properties of a RecommendationMetrics.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @interface IRecommendationMetrics
                             * @property {google.protobuf.IDoubleValue|null} [impressions] RecommendationMetrics impressions
                             * @property {google.protobuf.IDoubleValue|null} [clicks] RecommendationMetrics clicks
                             * @property {google.protobuf.IInt64Value|null} [costMicros] RecommendationMetrics costMicros
                             * @property {google.protobuf.IDoubleValue|null} [conversions] RecommendationMetrics conversions
                             * @property {google.protobuf.IDoubleValue|null} [videoViews] RecommendationMetrics videoViews
                             */

                            /**
                             * Constructs a new RecommendationMetrics.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @classdesc Represents a RecommendationMetrics.
                             * @implements IRecommendationMetrics
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Recommendation.IRecommendationMetrics=} [properties] Properties to set
                             */
                            function RecommendationMetrics(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * RecommendationMetrics impressions.
                             * @member {google.protobuf.IDoubleValue|null|undefined} impressions
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics
                             * @instance
                             */
                            RecommendationMetrics.prototype.impressions = null;

                            /**
                             * RecommendationMetrics clicks.
                             * @member {google.protobuf.IDoubleValue|null|undefined} clicks
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics
                             * @instance
                             */
                            RecommendationMetrics.prototype.clicks = null;

                            /**
                             * RecommendationMetrics costMicros.
                             * @member {google.protobuf.IInt64Value|null|undefined} costMicros
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics
                             * @instance
                             */
                            RecommendationMetrics.prototype.costMicros = null;

                            /**
                             * RecommendationMetrics conversions.
                             * @member {google.protobuf.IDoubleValue|null|undefined} conversions
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics
                             * @instance
                             */
                            RecommendationMetrics.prototype.conversions = null;

                            /**
                             * RecommendationMetrics videoViews.
                             * @member {google.protobuf.IDoubleValue|null|undefined} videoViews
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics
                             * @instance
                             */
                            RecommendationMetrics.prototype.videoViews = null;

                            /**
                             * Creates a new RecommendationMetrics instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IRecommendationMetrics=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics} RecommendationMetrics instance
                             */
                            RecommendationMetrics.create = function create(properties) {
                                return new RecommendationMetrics(properties);
                            };

                            /**
                             * Encodes the specified RecommendationMetrics message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IRecommendationMetrics} message RecommendationMetrics message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            RecommendationMetrics.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.impressions != null && message.hasOwnProperty("impressions"))
                                    $root.google.protobuf.DoubleValue.encode(message.impressions, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.clicks != null && message.hasOwnProperty("clicks"))
                                    $root.google.protobuf.DoubleValue.encode(message.clicks, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                if (message.costMicros != null && message.hasOwnProperty("costMicros"))
                                    $root.google.protobuf.Int64Value.encode(message.costMicros, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                                if (message.conversions != null && message.hasOwnProperty("conversions"))
                                    $root.google.protobuf.DoubleValue.encode(message.conversions, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                                if (message.videoViews != null && message.hasOwnProperty("videoViews"))
                                    $root.google.protobuf.DoubleValue.encode(message.videoViews, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified RecommendationMetrics message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IRecommendationMetrics} message RecommendationMetrics message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            RecommendationMetrics.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a RecommendationMetrics message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics} RecommendationMetrics
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            RecommendationMetrics.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.impressions = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.clicks = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                        break;
                                    case 3:
                                        message.costMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    case 4:
                                        message.conversions = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                        break;
                                    case 5:
                                        message.videoViews = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a RecommendationMetrics message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics} RecommendationMetrics
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            RecommendationMetrics.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a RecommendationMetrics message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            RecommendationMetrics.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.impressions != null && message.hasOwnProperty("impressions")) {
                                    var error = $root.google.protobuf.DoubleValue.verify(message.impressions);
                                    if (error)
                                        return "impressions." + error;
                                }
                                if (message.clicks != null && message.hasOwnProperty("clicks")) {
                                    var error = $root.google.protobuf.DoubleValue.verify(message.clicks);
                                    if (error)
                                        return "clicks." + error;
                                }
                                if (message.costMicros != null && message.hasOwnProperty("costMicros")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.costMicros);
                                    if (error)
                                        return "costMicros." + error;
                                }
                                if (message.conversions != null && message.hasOwnProperty("conversions")) {
                                    var error = $root.google.protobuf.DoubleValue.verify(message.conversions);
                                    if (error)
                                        return "conversions." + error;
                                }
                                if (message.videoViews != null && message.hasOwnProperty("videoViews")) {
                                    var error = $root.google.protobuf.DoubleValue.verify(message.videoViews);
                                    if (error)
                                        return "videoViews." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a RecommendationMetrics message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics} RecommendationMetrics
                             */
                            RecommendationMetrics.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics();
                                if (object.impressions != null) {
                                    if (typeof object.impressions !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics.impressions: object expected");
                                    message.impressions = $root.google.protobuf.DoubleValue.fromObject(object.impressions);
                                }
                                if (object.clicks != null) {
                                    if (typeof object.clicks !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics.clicks: object expected");
                                    message.clicks = $root.google.protobuf.DoubleValue.fromObject(object.clicks);
                                }
                                if (object.costMicros != null) {
                                    if (typeof object.costMicros !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics.costMicros: object expected");
                                    message.costMicros = $root.google.protobuf.Int64Value.fromObject(object.costMicros);
                                }
                                if (object.conversions != null) {
                                    if (typeof object.conversions !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics.conversions: object expected");
                                    message.conversions = $root.google.protobuf.DoubleValue.fromObject(object.conversions);
                                }
                                if (object.videoViews != null) {
                                    if (typeof object.videoViews !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics.videoViews: object expected");
                                    message.videoViews = $root.google.protobuf.DoubleValue.fromObject(object.videoViews);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a RecommendationMetrics message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics} message RecommendationMetrics
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            RecommendationMetrics.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.impressions = null;
                                    object.clicks = null;
                                    object.costMicros = null;
                                    object.conversions = null;
                                    object.videoViews = null;
                                }
                                if (message.impressions != null && message.hasOwnProperty("impressions"))
                                    object.impressions = $root.google.protobuf.DoubleValue.toObject(message.impressions, options);
                                if (message.clicks != null && message.hasOwnProperty("clicks"))
                                    object.clicks = $root.google.protobuf.DoubleValue.toObject(message.clicks, options);
                                if (message.costMicros != null && message.hasOwnProperty("costMicros"))
                                    object.costMicros = $root.google.protobuf.Int64Value.toObject(message.costMicros, options);
                                if (message.conversions != null && message.hasOwnProperty("conversions"))
                                    object.conversions = $root.google.protobuf.DoubleValue.toObject(message.conversions, options);
                                if (message.videoViews != null && message.hasOwnProperty("videoViews"))
                                    object.videoViews = $root.google.protobuf.DoubleValue.toObject(message.videoViews, options);
                                return object;
                            };

                            /**
                             * Converts this RecommendationMetrics to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Recommendation.RecommendationMetrics
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            RecommendationMetrics.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return RecommendationMetrics;
                        })();

                        Recommendation.CampaignBudgetRecommendation = (function() {

                            /**
                             * Properties of a CampaignBudgetRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @interface ICampaignBudgetRecommendation
                             * @property {google.protobuf.IInt64Value|null} [currentBudgetAmountMicros] CampaignBudgetRecommendation currentBudgetAmountMicros
                             * @property {google.protobuf.IInt64Value|null} [recommendedBudgetAmountMicros] CampaignBudgetRecommendation recommendedBudgetAmountMicros
                             * @property {Array.<google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.ICampaignBudgetRecommendationOption>|null} [budgetOptions] CampaignBudgetRecommendation budgetOptions
                             */

                            /**
                             * Constructs a new CampaignBudgetRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @classdesc Represents a CampaignBudgetRecommendation.
                             * @implements ICampaignBudgetRecommendation
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Recommendation.ICampaignBudgetRecommendation=} [properties] Properties to set
                             */
                            function CampaignBudgetRecommendation(properties) {
                                this.budgetOptions = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * CampaignBudgetRecommendation currentBudgetAmountMicros.
                             * @member {google.protobuf.IInt64Value|null|undefined} currentBudgetAmountMicros
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation
                             * @instance
                             */
                            CampaignBudgetRecommendation.prototype.currentBudgetAmountMicros = null;

                            /**
                             * CampaignBudgetRecommendation recommendedBudgetAmountMicros.
                             * @member {google.protobuf.IInt64Value|null|undefined} recommendedBudgetAmountMicros
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation
                             * @instance
                             */
                            CampaignBudgetRecommendation.prototype.recommendedBudgetAmountMicros = null;

                            /**
                             * CampaignBudgetRecommendation budgetOptions.
                             * @member {Array.<google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.ICampaignBudgetRecommendationOption>} budgetOptions
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation
                             * @instance
                             */
                            CampaignBudgetRecommendation.prototype.budgetOptions = $util.emptyArray;

                            /**
                             * Creates a new CampaignBudgetRecommendation instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ICampaignBudgetRecommendation=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation} CampaignBudgetRecommendation instance
                             */
                            CampaignBudgetRecommendation.create = function create(properties) {
                                return new CampaignBudgetRecommendation(properties);
                            };

                            /**
                             * Encodes the specified CampaignBudgetRecommendation message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ICampaignBudgetRecommendation} message CampaignBudgetRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            CampaignBudgetRecommendation.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.currentBudgetAmountMicros != null && message.hasOwnProperty("currentBudgetAmountMicros"))
                                    $root.google.protobuf.Int64Value.encode(message.currentBudgetAmountMicros, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.recommendedBudgetAmountMicros != null && message.hasOwnProperty("recommendedBudgetAmountMicros"))
                                    $root.google.protobuf.Int64Value.encode(message.recommendedBudgetAmountMicros, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                if (message.budgetOptions != null && message.budgetOptions.length)
                                    for (var i = 0; i < message.budgetOptions.length; ++i)
                                        $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption.encode(message.budgetOptions[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified CampaignBudgetRecommendation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ICampaignBudgetRecommendation} message CampaignBudgetRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            CampaignBudgetRecommendation.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a CampaignBudgetRecommendation message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation} CampaignBudgetRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            CampaignBudgetRecommendation.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.currentBudgetAmountMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.recommendedBudgetAmountMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    case 3:
                                        if (!(message.budgetOptions && message.budgetOptions.length))
                                            message.budgetOptions = [];
                                        message.budgetOptions.push($root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption.decode(reader, reader.uint32()));
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a CampaignBudgetRecommendation message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation} CampaignBudgetRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            CampaignBudgetRecommendation.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a CampaignBudgetRecommendation message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            CampaignBudgetRecommendation.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.currentBudgetAmountMicros != null && message.hasOwnProperty("currentBudgetAmountMicros")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.currentBudgetAmountMicros);
                                    if (error)
                                        return "currentBudgetAmountMicros." + error;
                                }
                                if (message.recommendedBudgetAmountMicros != null && message.hasOwnProperty("recommendedBudgetAmountMicros")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.recommendedBudgetAmountMicros);
                                    if (error)
                                        return "recommendedBudgetAmountMicros." + error;
                                }
                                if (message.budgetOptions != null && message.hasOwnProperty("budgetOptions")) {
                                    if (!Array.isArray(message.budgetOptions))
                                        return "budgetOptions: array expected";
                                    for (var i = 0; i < message.budgetOptions.length; ++i) {
                                        var error = $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption.verify(message.budgetOptions[i]);
                                        if (error)
                                            return "budgetOptions." + error;
                                    }
                                }
                                return null;
                            };

                            /**
                             * Creates a CampaignBudgetRecommendation message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation} CampaignBudgetRecommendation
                             */
                            CampaignBudgetRecommendation.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation();
                                if (object.currentBudgetAmountMicros != null) {
                                    if (typeof object.currentBudgetAmountMicros !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.currentBudgetAmountMicros: object expected");
                                    message.currentBudgetAmountMicros = $root.google.protobuf.Int64Value.fromObject(object.currentBudgetAmountMicros);
                                }
                                if (object.recommendedBudgetAmountMicros != null) {
                                    if (typeof object.recommendedBudgetAmountMicros !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.recommendedBudgetAmountMicros: object expected");
                                    message.recommendedBudgetAmountMicros = $root.google.protobuf.Int64Value.fromObject(object.recommendedBudgetAmountMicros);
                                }
                                if (object.budgetOptions) {
                                    if (!Array.isArray(object.budgetOptions))
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.budgetOptions: array expected");
                                    message.budgetOptions = [];
                                    for (var i = 0; i < object.budgetOptions.length; ++i) {
                                        if (typeof object.budgetOptions[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.budgetOptions: object expected");
                                        message.budgetOptions[i] = $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption.fromObject(object.budgetOptions[i]);
                                    }
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a CampaignBudgetRecommendation message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation} message CampaignBudgetRecommendation
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            CampaignBudgetRecommendation.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.budgetOptions = [];
                                if (options.defaults) {
                                    object.currentBudgetAmountMicros = null;
                                    object.recommendedBudgetAmountMicros = null;
                                }
                                if (message.currentBudgetAmountMicros != null && message.hasOwnProperty("currentBudgetAmountMicros"))
                                    object.currentBudgetAmountMicros = $root.google.protobuf.Int64Value.toObject(message.currentBudgetAmountMicros, options);
                                if (message.recommendedBudgetAmountMicros != null && message.hasOwnProperty("recommendedBudgetAmountMicros"))
                                    object.recommendedBudgetAmountMicros = $root.google.protobuf.Int64Value.toObject(message.recommendedBudgetAmountMicros, options);
                                if (message.budgetOptions && message.budgetOptions.length) {
                                    object.budgetOptions = [];
                                    for (var j = 0; j < message.budgetOptions.length; ++j)
                                        object.budgetOptions[j] = $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption.toObject(message.budgetOptions[j], options);
                                }
                                return object;
                            };

                            /**
                             * Converts this CampaignBudgetRecommendation to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            CampaignBudgetRecommendation.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            CampaignBudgetRecommendation.CampaignBudgetRecommendationOption = (function() {

                                /**
                                 * Properties of a CampaignBudgetRecommendationOption.
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation
                                 * @interface ICampaignBudgetRecommendationOption
                                 * @property {google.protobuf.IInt64Value|null} [budgetAmountMicros] CampaignBudgetRecommendationOption budgetAmountMicros
                                 * @property {google.ads.googleads.v1.resources.Recommendation.IRecommendationImpact|null} [impact] CampaignBudgetRecommendationOption impact
                                 */

                                /**
                                 * Constructs a new CampaignBudgetRecommendationOption.
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation
                                 * @classdesc Represents a CampaignBudgetRecommendationOption.
                                 * @implements ICampaignBudgetRecommendationOption
                                 * @constructor
                                 * @param {google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.ICampaignBudgetRecommendationOption=} [properties] Properties to set
                                 */
                                function CampaignBudgetRecommendationOption(properties) {
                                    if (properties)
                                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                            if (properties[keys[i]] != null)
                                                this[keys[i]] = properties[keys[i]];
                                }

                                /**
                                 * CampaignBudgetRecommendationOption budgetAmountMicros.
                                 * @member {google.protobuf.IInt64Value|null|undefined} budgetAmountMicros
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption
                                 * @instance
                                 */
                                CampaignBudgetRecommendationOption.prototype.budgetAmountMicros = null;

                                /**
                                 * CampaignBudgetRecommendationOption impact.
                                 * @member {google.ads.googleads.v1.resources.Recommendation.IRecommendationImpact|null|undefined} impact
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption
                                 * @instance
                                 */
                                CampaignBudgetRecommendationOption.prototype.impact = null;

                                /**
                                 * Creates a new CampaignBudgetRecommendationOption instance using the specified properties.
                                 * @function create
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption
                                 * @static
                                 * @param {google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.ICampaignBudgetRecommendationOption=} [properties] Properties to set
                                 * @returns {google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption} CampaignBudgetRecommendationOption instance
                                 */
                                CampaignBudgetRecommendationOption.create = function create(properties) {
                                    return new CampaignBudgetRecommendationOption(properties);
                                };

                                /**
                                 * Encodes the specified CampaignBudgetRecommendationOption message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption.verify|verify} messages.
                                 * @function encode
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption
                                 * @static
                                 * @param {google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.ICampaignBudgetRecommendationOption} message CampaignBudgetRecommendationOption message or plain object to encode
                                 * @param {$protobuf.Writer} [writer] Writer to encode to
                                 * @returns {$protobuf.Writer} Writer
                                 */
                                CampaignBudgetRecommendationOption.encode = function encode(message, writer) {
                                    if (!writer)
                                        writer = $Writer.create();
                                    if (message.budgetAmountMicros != null && message.hasOwnProperty("budgetAmountMicros"))
                                        $root.google.protobuf.Int64Value.encode(message.budgetAmountMicros, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                    if (message.impact != null && message.hasOwnProperty("impact"))
                                        $root.google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.encode(message.impact, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                    return writer;
                                };

                                /**
                                 * Encodes the specified CampaignBudgetRecommendationOption message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption.verify|verify} messages.
                                 * @function encodeDelimited
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption
                                 * @static
                                 * @param {google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.ICampaignBudgetRecommendationOption} message CampaignBudgetRecommendationOption message or plain object to encode
                                 * @param {$protobuf.Writer} [writer] Writer to encode to
                                 * @returns {$protobuf.Writer} Writer
                                 */
                                CampaignBudgetRecommendationOption.encodeDelimited = function encodeDelimited(message, writer) {
                                    return this.encode(message, writer).ldelim();
                                };

                                /**
                                 * Decodes a CampaignBudgetRecommendationOption message from the specified reader or buffer.
                                 * @function decode
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption
                                 * @static
                                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                                 * @param {number} [length] Message length if known beforehand
                                 * @returns {google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption} CampaignBudgetRecommendationOption
                                 * @throws {Error} If the payload is not a reader or valid buffer
                                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                                 */
                                CampaignBudgetRecommendationOption.decode = function decode(reader, length) {
                                    if (!(reader instanceof $Reader))
                                        reader = $Reader.create(reader);
                                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption();
                                    while (reader.pos < end) {
                                        var tag = reader.uint32();
                                        switch (tag >>> 3) {
                                        case 1:
                                            message.budgetAmountMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                            break;
                                        case 2:
                                            message.impact = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.decode(reader, reader.uint32());
                                            break;
                                        default:
                                            reader.skipType(tag & 7);
                                            break;
                                        }
                                    }
                                    return message;
                                };

                                /**
                                 * Decodes a CampaignBudgetRecommendationOption message from the specified reader or buffer, length delimited.
                                 * @function decodeDelimited
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption
                                 * @static
                                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                                 * @returns {google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption} CampaignBudgetRecommendationOption
                                 * @throws {Error} If the payload is not a reader or valid buffer
                                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                                 */
                                CampaignBudgetRecommendationOption.decodeDelimited = function decodeDelimited(reader) {
                                    if (!(reader instanceof $Reader))
                                        reader = new $Reader(reader);
                                    return this.decode(reader, reader.uint32());
                                };

                                /**
                                 * Verifies a CampaignBudgetRecommendationOption message.
                                 * @function verify
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption
                                 * @static
                                 * @param {Object.<string,*>} message Plain object to verify
                                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                                 */
                                CampaignBudgetRecommendationOption.verify = function verify(message) {
                                    if (typeof message !== "object" || message === null)
                                        return "object expected";
                                    if (message.budgetAmountMicros != null && message.hasOwnProperty("budgetAmountMicros")) {
                                        var error = $root.google.protobuf.Int64Value.verify(message.budgetAmountMicros);
                                        if (error)
                                            return "budgetAmountMicros." + error;
                                    }
                                    if (message.impact != null && message.hasOwnProperty("impact")) {
                                        var error = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.verify(message.impact);
                                        if (error)
                                            return "impact." + error;
                                    }
                                    return null;
                                };

                                /**
                                 * Creates a CampaignBudgetRecommendationOption message from a plain object. Also converts values to their respective internal types.
                                 * @function fromObject
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption
                                 * @static
                                 * @param {Object.<string,*>} object Plain object
                                 * @returns {google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption} CampaignBudgetRecommendationOption
                                 */
                                CampaignBudgetRecommendationOption.fromObject = function fromObject(object) {
                                    if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption)
                                        return object;
                                    var message = new $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption();
                                    if (object.budgetAmountMicros != null) {
                                        if (typeof object.budgetAmountMicros !== "object")
                                            throw TypeError(".google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption.budgetAmountMicros: object expected");
                                        message.budgetAmountMicros = $root.google.protobuf.Int64Value.fromObject(object.budgetAmountMicros);
                                    }
                                    if (object.impact != null) {
                                        if (typeof object.impact !== "object")
                                            throw TypeError(".google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption.impact: object expected");
                                        message.impact = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.fromObject(object.impact);
                                    }
                                    return message;
                                };

                                /**
                                 * Creates a plain object from a CampaignBudgetRecommendationOption message. Also converts values to other types if specified.
                                 * @function toObject
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption
                                 * @static
                                 * @param {google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption} message CampaignBudgetRecommendationOption
                                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                                 * @returns {Object.<string,*>} Plain object
                                 */
                                CampaignBudgetRecommendationOption.toObject = function toObject(message, options) {
                                    if (!options)
                                        options = {};
                                    var object = {};
                                    if (options.defaults) {
                                        object.budgetAmountMicros = null;
                                        object.impact = null;
                                    }
                                    if (message.budgetAmountMicros != null && message.hasOwnProperty("budgetAmountMicros"))
                                        object.budgetAmountMicros = $root.google.protobuf.Int64Value.toObject(message.budgetAmountMicros, options);
                                    if (message.impact != null && message.hasOwnProperty("impact"))
                                        object.impact = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.toObject(message.impact, options);
                                    return object;
                                };

                                /**
                                 * Converts this CampaignBudgetRecommendationOption to JSON.
                                 * @function toJSON
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.CampaignBudgetRecommendationOption
                                 * @instance
                                 * @returns {Object.<string,*>} JSON object
                                 */
                                CampaignBudgetRecommendationOption.prototype.toJSON = function toJSON() {
                                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                                };

                                return CampaignBudgetRecommendationOption;
                            })();

                            return CampaignBudgetRecommendation;
                        })();

                        Recommendation.KeywordRecommendation = (function() {

                            /**
                             * Properties of a KeywordRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @interface IKeywordRecommendation
                             * @property {google.ads.googleads.v1.common.IKeywordInfo|null} [keyword] KeywordRecommendation keyword
                             * @property {google.protobuf.IInt64Value|null} [recommendedCpcBidMicros] KeywordRecommendation recommendedCpcBidMicros
                             */

                            /**
                             * Constructs a new KeywordRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @classdesc Represents a KeywordRecommendation.
                             * @implements IKeywordRecommendation
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Recommendation.IKeywordRecommendation=} [properties] Properties to set
                             */
                            function KeywordRecommendation(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * KeywordRecommendation keyword.
                             * @member {google.ads.googleads.v1.common.IKeywordInfo|null|undefined} keyword
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation
                             * @instance
                             */
                            KeywordRecommendation.prototype.keyword = null;

                            /**
                             * KeywordRecommendation recommendedCpcBidMicros.
                             * @member {google.protobuf.IInt64Value|null|undefined} recommendedCpcBidMicros
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation
                             * @instance
                             */
                            KeywordRecommendation.prototype.recommendedCpcBidMicros = null;

                            /**
                             * Creates a new KeywordRecommendation instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IKeywordRecommendation=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation} KeywordRecommendation instance
                             */
                            KeywordRecommendation.create = function create(properties) {
                                return new KeywordRecommendation(properties);
                            };

                            /**
                             * Encodes the specified KeywordRecommendation message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IKeywordRecommendation} message KeywordRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            KeywordRecommendation.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.keyword != null && message.hasOwnProperty("keyword"))
                                    $root.google.ads.googleads.v1.common.KeywordInfo.encode(message.keyword, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.recommendedCpcBidMicros != null && message.hasOwnProperty("recommendedCpcBidMicros"))
                                    $root.google.protobuf.Int64Value.encode(message.recommendedCpcBidMicros, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified KeywordRecommendation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IKeywordRecommendation} message KeywordRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            KeywordRecommendation.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a KeywordRecommendation message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation} KeywordRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            KeywordRecommendation.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.keyword = $root.google.ads.googleads.v1.common.KeywordInfo.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.recommendedCpcBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a KeywordRecommendation message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation} KeywordRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            KeywordRecommendation.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a KeywordRecommendation message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            KeywordRecommendation.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.keyword != null && message.hasOwnProperty("keyword")) {
                                    var error = $root.google.ads.googleads.v1.common.KeywordInfo.verify(message.keyword);
                                    if (error)
                                        return "keyword." + error;
                                }
                                if (message.recommendedCpcBidMicros != null && message.hasOwnProperty("recommendedCpcBidMicros")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.recommendedCpcBidMicros);
                                    if (error)
                                        return "recommendedCpcBidMicros." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a KeywordRecommendation message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation} KeywordRecommendation
                             */
                            KeywordRecommendation.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation();
                                if (object.keyword != null) {
                                    if (typeof object.keyword !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation.keyword: object expected");
                                    message.keyword = $root.google.ads.googleads.v1.common.KeywordInfo.fromObject(object.keyword);
                                }
                                if (object.recommendedCpcBidMicros != null) {
                                    if (typeof object.recommendedCpcBidMicros !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation.recommendedCpcBidMicros: object expected");
                                    message.recommendedCpcBidMicros = $root.google.protobuf.Int64Value.fromObject(object.recommendedCpcBidMicros);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a KeywordRecommendation message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation} message KeywordRecommendation
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            KeywordRecommendation.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.keyword = null;
                                    object.recommendedCpcBidMicros = null;
                                }
                                if (message.keyword != null && message.hasOwnProperty("keyword"))
                                    object.keyword = $root.google.ads.googleads.v1.common.KeywordInfo.toObject(message.keyword, options);
                                if (message.recommendedCpcBidMicros != null && message.hasOwnProperty("recommendedCpcBidMicros"))
                                    object.recommendedCpcBidMicros = $root.google.protobuf.Int64Value.toObject(message.recommendedCpcBidMicros, options);
                                return object;
                            };

                            /**
                             * Converts this KeywordRecommendation to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordRecommendation
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            KeywordRecommendation.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return KeywordRecommendation;
                        })();

                        Recommendation.TextAdRecommendation = (function() {

                            /**
                             * Properties of a TextAdRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @interface ITextAdRecommendation
                             * @property {google.ads.googleads.v1.resources.IAd|null} [ad] TextAdRecommendation ad
                             * @property {google.protobuf.IStringValue|null} [creationDate] TextAdRecommendation creationDate
                             * @property {google.protobuf.IStringValue|null} [autoApplyDate] TextAdRecommendation autoApplyDate
                             */

                            /**
                             * Constructs a new TextAdRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @classdesc Represents a TextAdRecommendation.
                             * @implements ITextAdRecommendation
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Recommendation.ITextAdRecommendation=} [properties] Properties to set
                             */
                            function TextAdRecommendation(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * TextAdRecommendation ad.
                             * @member {google.ads.googleads.v1.resources.IAd|null|undefined} ad
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation
                             * @instance
                             */
                            TextAdRecommendation.prototype.ad = null;

                            /**
                             * TextAdRecommendation creationDate.
                             * @member {google.protobuf.IStringValue|null|undefined} creationDate
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation
                             * @instance
                             */
                            TextAdRecommendation.prototype.creationDate = null;

                            /**
                             * TextAdRecommendation autoApplyDate.
                             * @member {google.protobuf.IStringValue|null|undefined} autoApplyDate
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation
                             * @instance
                             */
                            TextAdRecommendation.prototype.autoApplyDate = null;

                            /**
                             * Creates a new TextAdRecommendation instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ITextAdRecommendation=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation} TextAdRecommendation instance
                             */
                            TextAdRecommendation.create = function create(properties) {
                                return new TextAdRecommendation(properties);
                            };

                            /**
                             * Encodes the specified TextAdRecommendation message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ITextAdRecommendation} message TextAdRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            TextAdRecommendation.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.ad != null && message.hasOwnProperty("ad"))
                                    $root.google.ads.googleads.v1.resources.Ad.encode(message.ad, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.creationDate != null && message.hasOwnProperty("creationDate"))
                                    $root.google.protobuf.StringValue.encode(message.creationDate, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                if (message.autoApplyDate != null && message.hasOwnProperty("autoApplyDate"))
                                    $root.google.protobuf.StringValue.encode(message.autoApplyDate, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified TextAdRecommendation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ITextAdRecommendation} message TextAdRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            TextAdRecommendation.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a TextAdRecommendation message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation} TextAdRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            TextAdRecommendation.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.ad = $root.google.ads.googleads.v1.resources.Ad.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.creationDate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 3:
                                        message.autoApplyDate = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a TextAdRecommendation message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation} TextAdRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            TextAdRecommendation.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a TextAdRecommendation message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            TextAdRecommendation.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.ad != null && message.hasOwnProperty("ad")) {
                                    var error = $root.google.ads.googleads.v1.resources.Ad.verify(message.ad);
                                    if (error)
                                        return "ad." + error;
                                }
                                if (message.creationDate != null && message.hasOwnProperty("creationDate")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.creationDate);
                                    if (error)
                                        return "creationDate." + error;
                                }
                                if (message.autoApplyDate != null && message.hasOwnProperty("autoApplyDate")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.autoApplyDate);
                                    if (error)
                                        return "autoApplyDate." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a TextAdRecommendation message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation} TextAdRecommendation
                             */
                            TextAdRecommendation.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation();
                                if (object.ad != null) {
                                    if (typeof object.ad !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation.ad: object expected");
                                    message.ad = $root.google.ads.googleads.v1.resources.Ad.fromObject(object.ad);
                                }
                                if (object.creationDate != null) {
                                    if (typeof object.creationDate !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation.creationDate: object expected");
                                    message.creationDate = $root.google.protobuf.StringValue.fromObject(object.creationDate);
                                }
                                if (object.autoApplyDate != null) {
                                    if (typeof object.autoApplyDate !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation.autoApplyDate: object expected");
                                    message.autoApplyDate = $root.google.protobuf.StringValue.fromObject(object.autoApplyDate);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a TextAdRecommendation message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation} message TextAdRecommendation
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            TextAdRecommendation.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.ad = null;
                                    object.creationDate = null;
                                    object.autoApplyDate = null;
                                }
                                if (message.ad != null && message.hasOwnProperty("ad"))
                                    object.ad = $root.google.ads.googleads.v1.resources.Ad.toObject(message.ad, options);
                                if (message.creationDate != null && message.hasOwnProperty("creationDate"))
                                    object.creationDate = $root.google.protobuf.StringValue.toObject(message.creationDate, options);
                                if (message.autoApplyDate != null && message.hasOwnProperty("autoApplyDate"))
                                    object.autoApplyDate = $root.google.protobuf.StringValue.toObject(message.autoApplyDate, options);
                                return object;
                            };

                            /**
                             * Converts this TextAdRecommendation to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TextAdRecommendation
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            TextAdRecommendation.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return TextAdRecommendation;
                        })();

                        Recommendation.TargetCpaOptInRecommendation = (function() {

                            /**
                             * Properties of a TargetCpaOptInRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @interface ITargetCpaOptInRecommendation
                             * @property {Array.<google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.ITargetCpaOptInRecommendationOption>|null} [options] TargetCpaOptInRecommendation options
                             * @property {google.protobuf.IInt64Value|null} [recommendedTargetCpaMicros] TargetCpaOptInRecommendation recommendedTargetCpaMicros
                             */

                            /**
                             * Constructs a new TargetCpaOptInRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @classdesc Represents a TargetCpaOptInRecommendation.
                             * @implements ITargetCpaOptInRecommendation
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Recommendation.ITargetCpaOptInRecommendation=} [properties] Properties to set
                             */
                            function TargetCpaOptInRecommendation(properties) {
                                this.options = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * TargetCpaOptInRecommendation options.
                             * @member {Array.<google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.ITargetCpaOptInRecommendationOption>} options
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation
                             * @instance
                             */
                            TargetCpaOptInRecommendation.prototype.options = $util.emptyArray;

                            /**
                             * TargetCpaOptInRecommendation recommendedTargetCpaMicros.
                             * @member {google.protobuf.IInt64Value|null|undefined} recommendedTargetCpaMicros
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation
                             * @instance
                             */
                            TargetCpaOptInRecommendation.prototype.recommendedTargetCpaMicros = null;

                            /**
                             * Creates a new TargetCpaOptInRecommendation instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ITargetCpaOptInRecommendation=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation} TargetCpaOptInRecommendation instance
                             */
                            TargetCpaOptInRecommendation.create = function create(properties) {
                                return new TargetCpaOptInRecommendation(properties);
                            };

                            /**
                             * Encodes the specified TargetCpaOptInRecommendation message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ITargetCpaOptInRecommendation} message TargetCpaOptInRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            TargetCpaOptInRecommendation.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.options != null && message.options.length)
                                    for (var i = 0; i < message.options.length; ++i)
                                        $root.google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption.encode(message.options[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.recommendedTargetCpaMicros != null && message.hasOwnProperty("recommendedTargetCpaMicros"))
                                    $root.google.protobuf.Int64Value.encode(message.recommendedTargetCpaMicros, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified TargetCpaOptInRecommendation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ITargetCpaOptInRecommendation} message TargetCpaOptInRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            TargetCpaOptInRecommendation.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a TargetCpaOptInRecommendation message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation} TargetCpaOptInRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            TargetCpaOptInRecommendation.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        if (!(message.options && message.options.length))
                                            message.options = [];
                                        message.options.push($root.google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption.decode(reader, reader.uint32()));
                                        break;
                                    case 2:
                                        message.recommendedTargetCpaMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a TargetCpaOptInRecommendation message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation} TargetCpaOptInRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            TargetCpaOptInRecommendation.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a TargetCpaOptInRecommendation message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            TargetCpaOptInRecommendation.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.options != null && message.hasOwnProperty("options")) {
                                    if (!Array.isArray(message.options))
                                        return "options: array expected";
                                    for (var i = 0; i < message.options.length; ++i) {
                                        var error = $root.google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption.verify(message.options[i]);
                                        if (error)
                                            return "options." + error;
                                    }
                                }
                                if (message.recommendedTargetCpaMicros != null && message.hasOwnProperty("recommendedTargetCpaMicros")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.recommendedTargetCpaMicros);
                                    if (error)
                                        return "recommendedTargetCpaMicros." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a TargetCpaOptInRecommendation message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation} TargetCpaOptInRecommendation
                             */
                            TargetCpaOptInRecommendation.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation();
                                if (object.options) {
                                    if (!Array.isArray(object.options))
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.options: array expected");
                                    message.options = [];
                                    for (var i = 0; i < object.options.length; ++i) {
                                        if (typeof object.options[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.options: object expected");
                                        message.options[i] = $root.google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption.fromObject(object.options[i]);
                                    }
                                }
                                if (object.recommendedTargetCpaMicros != null) {
                                    if (typeof object.recommendedTargetCpaMicros !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.recommendedTargetCpaMicros: object expected");
                                    message.recommendedTargetCpaMicros = $root.google.protobuf.Int64Value.fromObject(object.recommendedTargetCpaMicros);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a TargetCpaOptInRecommendation message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation} message TargetCpaOptInRecommendation
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            TargetCpaOptInRecommendation.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.options = [];
                                if (options.defaults)
                                    object.recommendedTargetCpaMicros = null;
                                if (message.options && message.options.length) {
                                    object.options = [];
                                    for (var j = 0; j < message.options.length; ++j)
                                        object.options[j] = $root.google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption.toObject(message.options[j], options);
                                }
                                if (message.recommendedTargetCpaMicros != null && message.hasOwnProperty("recommendedTargetCpaMicros"))
                                    object.recommendedTargetCpaMicros = $root.google.protobuf.Int64Value.toObject(message.recommendedTargetCpaMicros, options);
                                return object;
                            };

                            /**
                             * Converts this TargetCpaOptInRecommendation to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            TargetCpaOptInRecommendation.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption = (function() {

                                /**
                                 * Properties of a TargetCpaOptInRecommendationOption.
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation
                                 * @interface ITargetCpaOptInRecommendationOption
                                 * @property {google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum.TargetCpaOptInRecommendationGoal|null} [goal] TargetCpaOptInRecommendationOption goal
                                 * @property {google.protobuf.IInt64Value|null} [targetCpaMicros] TargetCpaOptInRecommendationOption targetCpaMicros
                                 * @property {google.protobuf.IInt64Value|null} [requiredCampaignBudgetAmountMicros] TargetCpaOptInRecommendationOption requiredCampaignBudgetAmountMicros
                                 * @property {google.ads.googleads.v1.resources.Recommendation.IRecommendationImpact|null} [impact] TargetCpaOptInRecommendationOption impact
                                 */

                                /**
                                 * Constructs a new TargetCpaOptInRecommendationOption.
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation
                                 * @classdesc Represents a TargetCpaOptInRecommendationOption.
                                 * @implements ITargetCpaOptInRecommendationOption
                                 * @constructor
                                 * @param {google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.ITargetCpaOptInRecommendationOption=} [properties] Properties to set
                                 */
                                function TargetCpaOptInRecommendationOption(properties) {
                                    if (properties)
                                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                            if (properties[keys[i]] != null)
                                                this[keys[i]] = properties[keys[i]];
                                }

                                /**
                                 * TargetCpaOptInRecommendationOption goal.
                                 * @member {google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum.TargetCpaOptInRecommendationGoal} goal
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption
                                 * @instance
                                 */
                                TargetCpaOptInRecommendationOption.prototype.goal = 0;

                                /**
                                 * TargetCpaOptInRecommendationOption targetCpaMicros.
                                 * @member {google.protobuf.IInt64Value|null|undefined} targetCpaMicros
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption
                                 * @instance
                                 */
                                TargetCpaOptInRecommendationOption.prototype.targetCpaMicros = null;

                                /**
                                 * TargetCpaOptInRecommendationOption requiredCampaignBudgetAmountMicros.
                                 * @member {google.protobuf.IInt64Value|null|undefined} requiredCampaignBudgetAmountMicros
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption
                                 * @instance
                                 */
                                TargetCpaOptInRecommendationOption.prototype.requiredCampaignBudgetAmountMicros = null;

                                /**
                                 * TargetCpaOptInRecommendationOption impact.
                                 * @member {google.ads.googleads.v1.resources.Recommendation.IRecommendationImpact|null|undefined} impact
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption
                                 * @instance
                                 */
                                TargetCpaOptInRecommendationOption.prototype.impact = null;

                                /**
                                 * Creates a new TargetCpaOptInRecommendationOption instance using the specified properties.
                                 * @function create
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption
                                 * @static
                                 * @param {google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.ITargetCpaOptInRecommendationOption=} [properties] Properties to set
                                 * @returns {google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption} TargetCpaOptInRecommendationOption instance
                                 */
                                TargetCpaOptInRecommendationOption.create = function create(properties) {
                                    return new TargetCpaOptInRecommendationOption(properties);
                                };

                                /**
                                 * Encodes the specified TargetCpaOptInRecommendationOption message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption.verify|verify} messages.
                                 * @function encode
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption
                                 * @static
                                 * @param {google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.ITargetCpaOptInRecommendationOption} message TargetCpaOptInRecommendationOption message or plain object to encode
                                 * @param {$protobuf.Writer} [writer] Writer to encode to
                                 * @returns {$protobuf.Writer} Writer
                                 */
                                TargetCpaOptInRecommendationOption.encode = function encode(message, writer) {
                                    if (!writer)
                                        writer = $Writer.create();
                                    if (message.goal != null && message.hasOwnProperty("goal"))
                                        writer.uint32(/* id 1, wireType 0 =*/8).int32(message.goal);
                                    if (message.targetCpaMicros != null && message.hasOwnProperty("targetCpaMicros"))
                                        $root.google.protobuf.Int64Value.encode(message.targetCpaMicros, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                    if (message.requiredCampaignBudgetAmountMicros != null && message.hasOwnProperty("requiredCampaignBudgetAmountMicros"))
                                        $root.google.protobuf.Int64Value.encode(message.requiredCampaignBudgetAmountMicros, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                                    if (message.impact != null && message.hasOwnProperty("impact"))
                                        $root.google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.encode(message.impact, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                                    return writer;
                                };

                                /**
                                 * Encodes the specified TargetCpaOptInRecommendationOption message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption.verify|verify} messages.
                                 * @function encodeDelimited
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption
                                 * @static
                                 * @param {google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.ITargetCpaOptInRecommendationOption} message TargetCpaOptInRecommendationOption message or plain object to encode
                                 * @param {$protobuf.Writer} [writer] Writer to encode to
                                 * @returns {$protobuf.Writer} Writer
                                 */
                                TargetCpaOptInRecommendationOption.encodeDelimited = function encodeDelimited(message, writer) {
                                    return this.encode(message, writer).ldelim();
                                };

                                /**
                                 * Decodes a TargetCpaOptInRecommendationOption message from the specified reader or buffer.
                                 * @function decode
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption
                                 * @static
                                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                                 * @param {number} [length] Message length if known beforehand
                                 * @returns {google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption} TargetCpaOptInRecommendationOption
                                 * @throws {Error} If the payload is not a reader or valid buffer
                                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                                 */
                                TargetCpaOptInRecommendationOption.decode = function decode(reader, length) {
                                    if (!(reader instanceof $Reader))
                                        reader = $Reader.create(reader);
                                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption();
                                    while (reader.pos < end) {
                                        var tag = reader.uint32();
                                        switch (tag >>> 3) {
                                        case 1:
                                            message.goal = reader.int32();
                                            break;
                                        case 2:
                                            message.targetCpaMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                            break;
                                        case 3:
                                            message.requiredCampaignBudgetAmountMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                            break;
                                        case 4:
                                            message.impact = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.decode(reader, reader.uint32());
                                            break;
                                        default:
                                            reader.skipType(tag & 7);
                                            break;
                                        }
                                    }
                                    return message;
                                };

                                /**
                                 * Decodes a TargetCpaOptInRecommendationOption message from the specified reader or buffer, length delimited.
                                 * @function decodeDelimited
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption
                                 * @static
                                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                                 * @returns {google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption} TargetCpaOptInRecommendationOption
                                 * @throws {Error} If the payload is not a reader or valid buffer
                                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                                 */
                                TargetCpaOptInRecommendationOption.decodeDelimited = function decodeDelimited(reader) {
                                    if (!(reader instanceof $Reader))
                                        reader = new $Reader(reader);
                                    return this.decode(reader, reader.uint32());
                                };

                                /**
                                 * Verifies a TargetCpaOptInRecommendationOption message.
                                 * @function verify
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption
                                 * @static
                                 * @param {Object.<string,*>} message Plain object to verify
                                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                                 */
                                TargetCpaOptInRecommendationOption.verify = function verify(message) {
                                    if (typeof message !== "object" || message === null)
                                        return "object expected";
                                    if (message.goal != null && message.hasOwnProperty("goal"))
                                        switch (message.goal) {
                                        default:
                                            return "goal: enum value expected";
                                        case 0:
                                        case 1:
                                        case 2:
                                        case 3:
                                        case 4:
                                        case 5:
                                            break;
                                        }
                                    if (message.targetCpaMicros != null && message.hasOwnProperty("targetCpaMicros")) {
                                        var error = $root.google.protobuf.Int64Value.verify(message.targetCpaMicros);
                                        if (error)
                                            return "targetCpaMicros." + error;
                                    }
                                    if (message.requiredCampaignBudgetAmountMicros != null && message.hasOwnProperty("requiredCampaignBudgetAmountMicros")) {
                                        var error = $root.google.protobuf.Int64Value.verify(message.requiredCampaignBudgetAmountMicros);
                                        if (error)
                                            return "requiredCampaignBudgetAmountMicros." + error;
                                    }
                                    if (message.impact != null && message.hasOwnProperty("impact")) {
                                        var error = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.verify(message.impact);
                                        if (error)
                                            return "impact." + error;
                                    }
                                    return null;
                                };

                                /**
                                 * Creates a TargetCpaOptInRecommendationOption message from a plain object. Also converts values to their respective internal types.
                                 * @function fromObject
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption
                                 * @static
                                 * @param {Object.<string,*>} object Plain object
                                 * @returns {google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption} TargetCpaOptInRecommendationOption
                                 */
                                TargetCpaOptInRecommendationOption.fromObject = function fromObject(object) {
                                    if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption)
                                        return object;
                                    var message = new $root.google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption();
                                    switch (object.goal) {
                                    case "UNSPECIFIED":
                                    case 0:
                                        message.goal = 0;
                                        break;
                                    case "UNKNOWN":
                                    case 1:
                                        message.goal = 1;
                                        break;
                                    case "SAME_COST":
                                    case 2:
                                        message.goal = 2;
                                        break;
                                    case "SAME_CONVERSIONS":
                                    case 3:
                                        message.goal = 3;
                                        break;
                                    case "SAME_CPA":
                                    case 4:
                                        message.goal = 4;
                                        break;
                                    case "CLOSEST_CPA":
                                    case 5:
                                        message.goal = 5;
                                        break;
                                    }
                                    if (object.targetCpaMicros != null) {
                                        if (typeof object.targetCpaMicros !== "object")
                                            throw TypeError(".google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption.targetCpaMicros: object expected");
                                        message.targetCpaMicros = $root.google.protobuf.Int64Value.fromObject(object.targetCpaMicros);
                                    }
                                    if (object.requiredCampaignBudgetAmountMicros != null) {
                                        if (typeof object.requiredCampaignBudgetAmountMicros !== "object")
                                            throw TypeError(".google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption.requiredCampaignBudgetAmountMicros: object expected");
                                        message.requiredCampaignBudgetAmountMicros = $root.google.protobuf.Int64Value.fromObject(object.requiredCampaignBudgetAmountMicros);
                                    }
                                    if (object.impact != null) {
                                        if (typeof object.impact !== "object")
                                            throw TypeError(".google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption.impact: object expected");
                                        message.impact = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.fromObject(object.impact);
                                    }
                                    return message;
                                };

                                /**
                                 * Creates a plain object from a TargetCpaOptInRecommendationOption message. Also converts values to other types if specified.
                                 * @function toObject
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption
                                 * @static
                                 * @param {google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption} message TargetCpaOptInRecommendationOption
                                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                                 * @returns {Object.<string,*>} Plain object
                                 */
                                TargetCpaOptInRecommendationOption.toObject = function toObject(message, options) {
                                    if (!options)
                                        options = {};
                                    var object = {};
                                    if (options.defaults) {
                                        object.goal = options.enums === String ? "UNSPECIFIED" : 0;
                                        object.targetCpaMicros = null;
                                        object.requiredCampaignBudgetAmountMicros = null;
                                        object.impact = null;
                                    }
                                    if (message.goal != null && message.hasOwnProperty("goal"))
                                        object.goal = options.enums === String ? $root.google.ads.googleads.v1.enums.TargetCpaOptInRecommendationGoalEnum.TargetCpaOptInRecommendationGoal[message.goal] : message.goal;
                                    if (message.targetCpaMicros != null && message.hasOwnProperty("targetCpaMicros"))
                                        object.targetCpaMicros = $root.google.protobuf.Int64Value.toObject(message.targetCpaMicros, options);
                                    if (message.requiredCampaignBudgetAmountMicros != null && message.hasOwnProperty("requiredCampaignBudgetAmountMicros"))
                                        object.requiredCampaignBudgetAmountMicros = $root.google.protobuf.Int64Value.toObject(message.requiredCampaignBudgetAmountMicros, options);
                                    if (message.impact != null && message.hasOwnProperty("impact"))
                                        object.impact = $root.google.ads.googleads.v1.resources.Recommendation.RecommendationImpact.toObject(message.impact, options);
                                    return object;
                                };

                                /**
                                 * Converts this TargetCpaOptInRecommendationOption to JSON.
                                 * @function toJSON
                                 * @memberof google.ads.googleads.v1.resources.Recommendation.TargetCpaOptInRecommendation.TargetCpaOptInRecommendationOption
                                 * @instance
                                 * @returns {Object.<string,*>} JSON object
                                 */
                                TargetCpaOptInRecommendationOption.prototype.toJSON = function toJSON() {
                                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                                };

                                return TargetCpaOptInRecommendationOption;
                            })();

                            return TargetCpaOptInRecommendation;
                        })();

                        Recommendation.KeywordMatchTypeRecommendation = (function() {

                            /**
                             * Properties of a KeywordMatchTypeRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @interface IKeywordMatchTypeRecommendation
                             * @property {google.ads.googleads.v1.common.IKeywordInfo|null} [keyword] KeywordMatchTypeRecommendation keyword
                             * @property {google.ads.googleads.v1.enums.KeywordMatchTypeEnum.KeywordMatchType|null} [recommendedMatchType] KeywordMatchTypeRecommendation recommendedMatchType
                             */

                            /**
                             * Constructs a new KeywordMatchTypeRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @classdesc Represents a KeywordMatchTypeRecommendation.
                             * @implements IKeywordMatchTypeRecommendation
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Recommendation.IKeywordMatchTypeRecommendation=} [properties] Properties to set
                             */
                            function KeywordMatchTypeRecommendation(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * KeywordMatchTypeRecommendation keyword.
                             * @member {google.ads.googleads.v1.common.IKeywordInfo|null|undefined} keyword
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation
                             * @instance
                             */
                            KeywordMatchTypeRecommendation.prototype.keyword = null;

                            /**
                             * KeywordMatchTypeRecommendation recommendedMatchType.
                             * @member {google.ads.googleads.v1.enums.KeywordMatchTypeEnum.KeywordMatchType} recommendedMatchType
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation
                             * @instance
                             */
                            KeywordMatchTypeRecommendation.prototype.recommendedMatchType = 0;

                            /**
                             * Creates a new KeywordMatchTypeRecommendation instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IKeywordMatchTypeRecommendation=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation} KeywordMatchTypeRecommendation instance
                             */
                            KeywordMatchTypeRecommendation.create = function create(properties) {
                                return new KeywordMatchTypeRecommendation(properties);
                            };

                            /**
                             * Encodes the specified KeywordMatchTypeRecommendation message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IKeywordMatchTypeRecommendation} message KeywordMatchTypeRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            KeywordMatchTypeRecommendation.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.keyword != null && message.hasOwnProperty("keyword"))
                                    $root.google.ads.googleads.v1.common.KeywordInfo.encode(message.keyword, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.recommendedMatchType != null && message.hasOwnProperty("recommendedMatchType"))
                                    writer.uint32(/* id 2, wireType 0 =*/16).int32(message.recommendedMatchType);
                                return writer;
                            };

                            /**
                             * Encodes the specified KeywordMatchTypeRecommendation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IKeywordMatchTypeRecommendation} message KeywordMatchTypeRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            KeywordMatchTypeRecommendation.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a KeywordMatchTypeRecommendation message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation} KeywordMatchTypeRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            KeywordMatchTypeRecommendation.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.keyword = $root.google.ads.googleads.v1.common.KeywordInfo.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.recommendedMatchType = reader.int32();
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a KeywordMatchTypeRecommendation message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation} KeywordMatchTypeRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            KeywordMatchTypeRecommendation.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a KeywordMatchTypeRecommendation message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            KeywordMatchTypeRecommendation.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.keyword != null && message.hasOwnProperty("keyword")) {
                                    var error = $root.google.ads.googleads.v1.common.KeywordInfo.verify(message.keyword);
                                    if (error)
                                        return "keyword." + error;
                                }
                                if (message.recommendedMatchType != null && message.hasOwnProperty("recommendedMatchType"))
                                    switch (message.recommendedMatchType) {
                                    default:
                                        return "recommendedMatchType: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                        break;
                                    }
                                return null;
                            };

                            /**
                             * Creates a KeywordMatchTypeRecommendation message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation} KeywordMatchTypeRecommendation
                             */
                            KeywordMatchTypeRecommendation.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation();
                                if (object.keyword != null) {
                                    if (typeof object.keyword !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation.keyword: object expected");
                                    message.keyword = $root.google.ads.googleads.v1.common.KeywordInfo.fromObject(object.keyword);
                                }
                                switch (object.recommendedMatchType) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.recommendedMatchType = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.recommendedMatchType = 1;
                                    break;
                                case "EXACT":
                                case 2:
                                    message.recommendedMatchType = 2;
                                    break;
                                case "PHRASE":
                                case 3:
                                    message.recommendedMatchType = 3;
                                    break;
                                case "BROAD":
                                case 4:
                                    message.recommendedMatchType = 4;
                                    break;
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a KeywordMatchTypeRecommendation message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation} message KeywordMatchTypeRecommendation
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            KeywordMatchTypeRecommendation.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.keyword = null;
                                    object.recommendedMatchType = options.enums === String ? "UNSPECIFIED" : 0;
                                }
                                if (message.keyword != null && message.hasOwnProperty("keyword"))
                                    object.keyword = $root.google.ads.googleads.v1.common.KeywordInfo.toObject(message.keyword, options);
                                if (message.recommendedMatchType != null && message.hasOwnProperty("recommendedMatchType"))
                                    object.recommendedMatchType = options.enums === String ? $root.google.ads.googleads.v1.enums.KeywordMatchTypeEnum.KeywordMatchType[message.recommendedMatchType] : message.recommendedMatchType;
                                return object;
                            };

                            /**
                             * Converts this KeywordMatchTypeRecommendation to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Recommendation.KeywordMatchTypeRecommendation
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            KeywordMatchTypeRecommendation.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return KeywordMatchTypeRecommendation;
                        })();

                        Recommendation.MaximizeConversionsOptInRecommendation = (function() {

                            /**
                             * Properties of a MaximizeConversionsOptInRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @interface IMaximizeConversionsOptInRecommendation
                             * @property {google.protobuf.IInt64Value|null} [recommendedBudgetAmountMicros] MaximizeConversionsOptInRecommendation recommendedBudgetAmountMicros
                             */

                            /**
                             * Constructs a new MaximizeConversionsOptInRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @classdesc Represents a MaximizeConversionsOptInRecommendation.
                             * @implements IMaximizeConversionsOptInRecommendation
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Recommendation.IMaximizeConversionsOptInRecommendation=} [properties] Properties to set
                             */
                            function MaximizeConversionsOptInRecommendation(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * MaximizeConversionsOptInRecommendation recommendedBudgetAmountMicros.
                             * @member {google.protobuf.IInt64Value|null|undefined} recommendedBudgetAmountMicros
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation
                             * @instance
                             */
                            MaximizeConversionsOptInRecommendation.prototype.recommendedBudgetAmountMicros = null;

                            /**
                             * Creates a new MaximizeConversionsOptInRecommendation instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IMaximizeConversionsOptInRecommendation=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation} MaximizeConversionsOptInRecommendation instance
                             */
                            MaximizeConversionsOptInRecommendation.create = function create(properties) {
                                return new MaximizeConversionsOptInRecommendation(properties);
                            };

                            /**
                             * Encodes the specified MaximizeConversionsOptInRecommendation message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IMaximizeConversionsOptInRecommendation} message MaximizeConversionsOptInRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            MaximizeConversionsOptInRecommendation.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.recommendedBudgetAmountMicros != null && message.hasOwnProperty("recommendedBudgetAmountMicros"))
                                    $root.google.protobuf.Int64Value.encode(message.recommendedBudgetAmountMicros, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified MaximizeConversionsOptInRecommendation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IMaximizeConversionsOptInRecommendation} message MaximizeConversionsOptInRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            MaximizeConversionsOptInRecommendation.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a MaximizeConversionsOptInRecommendation message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation} MaximizeConversionsOptInRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            MaximizeConversionsOptInRecommendation.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.recommendedBudgetAmountMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a MaximizeConversionsOptInRecommendation message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation} MaximizeConversionsOptInRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            MaximizeConversionsOptInRecommendation.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a MaximizeConversionsOptInRecommendation message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            MaximizeConversionsOptInRecommendation.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.recommendedBudgetAmountMicros != null && message.hasOwnProperty("recommendedBudgetAmountMicros")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.recommendedBudgetAmountMicros);
                                    if (error)
                                        return "recommendedBudgetAmountMicros." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a MaximizeConversionsOptInRecommendation message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation} MaximizeConversionsOptInRecommendation
                             */
                            MaximizeConversionsOptInRecommendation.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation();
                                if (object.recommendedBudgetAmountMicros != null) {
                                    if (typeof object.recommendedBudgetAmountMicros !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation.recommendedBudgetAmountMicros: object expected");
                                    message.recommendedBudgetAmountMicros = $root.google.protobuf.Int64Value.fromObject(object.recommendedBudgetAmountMicros);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a MaximizeConversionsOptInRecommendation message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation} message MaximizeConversionsOptInRecommendation
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            MaximizeConversionsOptInRecommendation.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults)
                                    object.recommendedBudgetAmountMicros = null;
                                if (message.recommendedBudgetAmountMicros != null && message.hasOwnProperty("recommendedBudgetAmountMicros"))
                                    object.recommendedBudgetAmountMicros = $root.google.protobuf.Int64Value.toObject(message.recommendedBudgetAmountMicros, options);
                                return object;
                            };

                            /**
                             * Converts this MaximizeConversionsOptInRecommendation to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeConversionsOptInRecommendation
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            MaximizeConversionsOptInRecommendation.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return MaximizeConversionsOptInRecommendation;
                        })();

                        Recommendation.EnhancedCpcOptInRecommendation = (function() {

                            /**
                             * Properties of an EnhancedCpcOptInRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @interface IEnhancedCpcOptInRecommendation
                             */

                            /**
                             * Constructs a new EnhancedCpcOptInRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @classdesc Represents an EnhancedCpcOptInRecommendation.
                             * @implements IEnhancedCpcOptInRecommendation
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Recommendation.IEnhancedCpcOptInRecommendation=} [properties] Properties to set
                             */
                            function EnhancedCpcOptInRecommendation(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * Creates a new EnhancedCpcOptInRecommendation instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IEnhancedCpcOptInRecommendation=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation} EnhancedCpcOptInRecommendation instance
                             */
                            EnhancedCpcOptInRecommendation.create = function create(properties) {
                                return new EnhancedCpcOptInRecommendation(properties);
                            };

                            /**
                             * Encodes the specified EnhancedCpcOptInRecommendation message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IEnhancedCpcOptInRecommendation} message EnhancedCpcOptInRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            EnhancedCpcOptInRecommendation.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                return writer;
                            };

                            /**
                             * Encodes the specified EnhancedCpcOptInRecommendation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IEnhancedCpcOptInRecommendation} message EnhancedCpcOptInRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            EnhancedCpcOptInRecommendation.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes an EnhancedCpcOptInRecommendation message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation} EnhancedCpcOptInRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            EnhancedCpcOptInRecommendation.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes an EnhancedCpcOptInRecommendation message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation} EnhancedCpcOptInRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            EnhancedCpcOptInRecommendation.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies an EnhancedCpcOptInRecommendation message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            EnhancedCpcOptInRecommendation.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                return null;
                            };

                            /**
                             * Creates an EnhancedCpcOptInRecommendation message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation} EnhancedCpcOptInRecommendation
                             */
                            EnhancedCpcOptInRecommendation.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation)
                                    return object;
                                return new $root.google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation();
                            };

                            /**
                             * Creates a plain object from an EnhancedCpcOptInRecommendation message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation} message EnhancedCpcOptInRecommendation
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            EnhancedCpcOptInRecommendation.toObject = function toObject() {
                                return {};
                            };

                            /**
                             * Converts this EnhancedCpcOptInRecommendation to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Recommendation.EnhancedCpcOptInRecommendation
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            EnhancedCpcOptInRecommendation.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return EnhancedCpcOptInRecommendation;
                        })();

                        Recommendation.CallExtensionRecommendation = (function() {

                            /**
                             * Properties of a CallExtensionRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @interface ICallExtensionRecommendation
                             * @property {Array.<google.ads.googleads.v1.common.ICallFeedItem>|null} [recommendedExtensions] CallExtensionRecommendation recommendedExtensions
                             */

                            /**
                             * Constructs a new CallExtensionRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @classdesc Represents a CallExtensionRecommendation.
                             * @implements ICallExtensionRecommendation
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Recommendation.ICallExtensionRecommendation=} [properties] Properties to set
                             */
                            function CallExtensionRecommendation(properties) {
                                this.recommendedExtensions = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * CallExtensionRecommendation recommendedExtensions.
                             * @member {Array.<google.ads.googleads.v1.common.ICallFeedItem>} recommendedExtensions
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation
                             * @instance
                             */
                            CallExtensionRecommendation.prototype.recommendedExtensions = $util.emptyArray;

                            /**
                             * Creates a new CallExtensionRecommendation instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ICallExtensionRecommendation=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation} CallExtensionRecommendation instance
                             */
                            CallExtensionRecommendation.create = function create(properties) {
                                return new CallExtensionRecommendation(properties);
                            };

                            /**
                             * Encodes the specified CallExtensionRecommendation message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ICallExtensionRecommendation} message CallExtensionRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            CallExtensionRecommendation.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.recommendedExtensions != null && message.recommendedExtensions.length)
                                    for (var i = 0; i < message.recommendedExtensions.length; ++i)
                                        $root.google.ads.googleads.v1.common.CallFeedItem.encode(message.recommendedExtensions[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified CallExtensionRecommendation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ICallExtensionRecommendation} message CallExtensionRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            CallExtensionRecommendation.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a CallExtensionRecommendation message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation} CallExtensionRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            CallExtensionRecommendation.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        if (!(message.recommendedExtensions && message.recommendedExtensions.length))
                                            message.recommendedExtensions = [];
                                        message.recommendedExtensions.push($root.google.ads.googleads.v1.common.CallFeedItem.decode(reader, reader.uint32()));
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a CallExtensionRecommendation message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation} CallExtensionRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            CallExtensionRecommendation.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a CallExtensionRecommendation message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            CallExtensionRecommendation.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.recommendedExtensions != null && message.hasOwnProperty("recommendedExtensions")) {
                                    if (!Array.isArray(message.recommendedExtensions))
                                        return "recommendedExtensions: array expected";
                                    for (var i = 0; i < message.recommendedExtensions.length; ++i) {
                                        var error = $root.google.ads.googleads.v1.common.CallFeedItem.verify(message.recommendedExtensions[i]);
                                        if (error)
                                            return "recommendedExtensions." + error;
                                    }
                                }
                                return null;
                            };

                            /**
                             * Creates a CallExtensionRecommendation message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation} CallExtensionRecommendation
                             */
                            CallExtensionRecommendation.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation();
                                if (object.recommendedExtensions) {
                                    if (!Array.isArray(object.recommendedExtensions))
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation.recommendedExtensions: array expected");
                                    message.recommendedExtensions = [];
                                    for (var i = 0; i < object.recommendedExtensions.length; ++i) {
                                        if (typeof object.recommendedExtensions[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation.recommendedExtensions: object expected");
                                        message.recommendedExtensions[i] = $root.google.ads.googleads.v1.common.CallFeedItem.fromObject(object.recommendedExtensions[i]);
                                    }
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a CallExtensionRecommendation message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation} message CallExtensionRecommendation
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            CallExtensionRecommendation.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.recommendedExtensions = [];
                                if (message.recommendedExtensions && message.recommendedExtensions.length) {
                                    object.recommendedExtensions = [];
                                    for (var j = 0; j < message.recommendedExtensions.length; ++j)
                                        object.recommendedExtensions[j] = $root.google.ads.googleads.v1.common.CallFeedItem.toObject(message.recommendedExtensions[j], options);
                                }
                                return object;
                            };

                            /**
                             * Converts this CallExtensionRecommendation to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CallExtensionRecommendation
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            CallExtensionRecommendation.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return CallExtensionRecommendation;
                        })();

                        Recommendation.SearchPartnersOptInRecommendation = (function() {

                            /**
                             * Properties of a SearchPartnersOptInRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @interface ISearchPartnersOptInRecommendation
                             */

                            /**
                             * Constructs a new SearchPartnersOptInRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @classdesc Represents a SearchPartnersOptInRecommendation.
                             * @implements ISearchPartnersOptInRecommendation
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Recommendation.ISearchPartnersOptInRecommendation=} [properties] Properties to set
                             */
                            function SearchPartnersOptInRecommendation(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * Creates a new SearchPartnersOptInRecommendation instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ISearchPartnersOptInRecommendation=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation} SearchPartnersOptInRecommendation instance
                             */
                            SearchPartnersOptInRecommendation.create = function create(properties) {
                                return new SearchPartnersOptInRecommendation(properties);
                            };

                            /**
                             * Encodes the specified SearchPartnersOptInRecommendation message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ISearchPartnersOptInRecommendation} message SearchPartnersOptInRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            SearchPartnersOptInRecommendation.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                return writer;
                            };

                            /**
                             * Encodes the specified SearchPartnersOptInRecommendation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ISearchPartnersOptInRecommendation} message SearchPartnersOptInRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            SearchPartnersOptInRecommendation.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a SearchPartnersOptInRecommendation message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation} SearchPartnersOptInRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            SearchPartnersOptInRecommendation.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a SearchPartnersOptInRecommendation message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation} SearchPartnersOptInRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            SearchPartnersOptInRecommendation.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a SearchPartnersOptInRecommendation message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            SearchPartnersOptInRecommendation.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                return null;
                            };

                            /**
                             * Creates a SearchPartnersOptInRecommendation message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation} SearchPartnersOptInRecommendation
                             */
                            SearchPartnersOptInRecommendation.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation)
                                    return object;
                                return new $root.google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation();
                            };

                            /**
                             * Creates a plain object from a SearchPartnersOptInRecommendation message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation} message SearchPartnersOptInRecommendation
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            SearchPartnersOptInRecommendation.toObject = function toObject() {
                                return {};
                            };

                            /**
                             * Converts this SearchPartnersOptInRecommendation to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SearchPartnersOptInRecommendation
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            SearchPartnersOptInRecommendation.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return SearchPartnersOptInRecommendation;
                        })();

                        Recommendation.MaximizeClicksOptInRecommendation = (function() {

                            /**
                             * Properties of a MaximizeClicksOptInRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @interface IMaximizeClicksOptInRecommendation
                             * @property {google.protobuf.IInt64Value|null} [recommendedBudgetAmountMicros] MaximizeClicksOptInRecommendation recommendedBudgetAmountMicros
                             */

                            /**
                             * Constructs a new MaximizeClicksOptInRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @classdesc Represents a MaximizeClicksOptInRecommendation.
                             * @implements IMaximizeClicksOptInRecommendation
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Recommendation.IMaximizeClicksOptInRecommendation=} [properties] Properties to set
                             */
                            function MaximizeClicksOptInRecommendation(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * MaximizeClicksOptInRecommendation recommendedBudgetAmountMicros.
                             * @member {google.protobuf.IInt64Value|null|undefined} recommendedBudgetAmountMicros
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation
                             * @instance
                             */
                            MaximizeClicksOptInRecommendation.prototype.recommendedBudgetAmountMicros = null;

                            /**
                             * Creates a new MaximizeClicksOptInRecommendation instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IMaximizeClicksOptInRecommendation=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation} MaximizeClicksOptInRecommendation instance
                             */
                            MaximizeClicksOptInRecommendation.create = function create(properties) {
                                return new MaximizeClicksOptInRecommendation(properties);
                            };

                            /**
                             * Encodes the specified MaximizeClicksOptInRecommendation message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IMaximizeClicksOptInRecommendation} message MaximizeClicksOptInRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            MaximizeClicksOptInRecommendation.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.recommendedBudgetAmountMicros != null && message.hasOwnProperty("recommendedBudgetAmountMicros"))
                                    $root.google.protobuf.Int64Value.encode(message.recommendedBudgetAmountMicros, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified MaximizeClicksOptInRecommendation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IMaximizeClicksOptInRecommendation} message MaximizeClicksOptInRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            MaximizeClicksOptInRecommendation.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a MaximizeClicksOptInRecommendation message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation} MaximizeClicksOptInRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            MaximizeClicksOptInRecommendation.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.recommendedBudgetAmountMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a MaximizeClicksOptInRecommendation message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation} MaximizeClicksOptInRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            MaximizeClicksOptInRecommendation.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a MaximizeClicksOptInRecommendation message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            MaximizeClicksOptInRecommendation.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.recommendedBudgetAmountMicros != null && message.hasOwnProperty("recommendedBudgetAmountMicros")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.recommendedBudgetAmountMicros);
                                    if (error)
                                        return "recommendedBudgetAmountMicros." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a MaximizeClicksOptInRecommendation message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation} MaximizeClicksOptInRecommendation
                             */
                            MaximizeClicksOptInRecommendation.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation();
                                if (object.recommendedBudgetAmountMicros != null) {
                                    if (typeof object.recommendedBudgetAmountMicros !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation.recommendedBudgetAmountMicros: object expected");
                                    message.recommendedBudgetAmountMicros = $root.google.protobuf.Int64Value.fromObject(object.recommendedBudgetAmountMicros);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a MaximizeClicksOptInRecommendation message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation} message MaximizeClicksOptInRecommendation
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            MaximizeClicksOptInRecommendation.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults)
                                    object.recommendedBudgetAmountMicros = null;
                                if (message.recommendedBudgetAmountMicros != null && message.hasOwnProperty("recommendedBudgetAmountMicros"))
                                    object.recommendedBudgetAmountMicros = $root.google.protobuf.Int64Value.toObject(message.recommendedBudgetAmountMicros, options);
                                return object;
                            };

                            /**
                             * Converts this MaximizeClicksOptInRecommendation to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MaximizeClicksOptInRecommendation
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            MaximizeClicksOptInRecommendation.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return MaximizeClicksOptInRecommendation;
                        })();

                        Recommendation.OptimizeAdRotationRecommendation = (function() {

                            /**
                             * Properties of an OptimizeAdRotationRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @interface IOptimizeAdRotationRecommendation
                             */

                            /**
                             * Constructs a new OptimizeAdRotationRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @classdesc Represents an OptimizeAdRotationRecommendation.
                             * @implements IOptimizeAdRotationRecommendation
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Recommendation.IOptimizeAdRotationRecommendation=} [properties] Properties to set
                             */
                            function OptimizeAdRotationRecommendation(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * Creates a new OptimizeAdRotationRecommendation instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IOptimizeAdRotationRecommendation=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation} OptimizeAdRotationRecommendation instance
                             */
                            OptimizeAdRotationRecommendation.create = function create(properties) {
                                return new OptimizeAdRotationRecommendation(properties);
                            };

                            /**
                             * Encodes the specified OptimizeAdRotationRecommendation message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IOptimizeAdRotationRecommendation} message OptimizeAdRotationRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            OptimizeAdRotationRecommendation.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                return writer;
                            };

                            /**
                             * Encodes the specified OptimizeAdRotationRecommendation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IOptimizeAdRotationRecommendation} message OptimizeAdRotationRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            OptimizeAdRotationRecommendation.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes an OptimizeAdRotationRecommendation message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation} OptimizeAdRotationRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            OptimizeAdRotationRecommendation.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes an OptimizeAdRotationRecommendation message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation} OptimizeAdRotationRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            OptimizeAdRotationRecommendation.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies an OptimizeAdRotationRecommendation message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            OptimizeAdRotationRecommendation.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                return null;
                            };

                            /**
                             * Creates an OptimizeAdRotationRecommendation message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation} OptimizeAdRotationRecommendation
                             */
                            OptimizeAdRotationRecommendation.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation)
                                    return object;
                                return new $root.google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation();
                            };

                            /**
                             * Creates a plain object from an OptimizeAdRotationRecommendation message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation} message OptimizeAdRotationRecommendation
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            OptimizeAdRotationRecommendation.toObject = function toObject() {
                                return {};
                            };

                            /**
                             * Converts this OptimizeAdRotationRecommendation to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Recommendation.OptimizeAdRotationRecommendation
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            OptimizeAdRotationRecommendation.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return OptimizeAdRotationRecommendation;
                        })();

                        Recommendation.MoveUnusedBudgetRecommendation = (function() {

                            /**
                             * Properties of a MoveUnusedBudgetRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @interface IMoveUnusedBudgetRecommendation
                             * @property {google.protobuf.IStringValue|null} [excessCampaignBudget] MoveUnusedBudgetRecommendation excessCampaignBudget
                             * @property {google.ads.googleads.v1.resources.Recommendation.ICampaignBudgetRecommendation|null} [budgetRecommendation] MoveUnusedBudgetRecommendation budgetRecommendation
                             */

                            /**
                             * Constructs a new MoveUnusedBudgetRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @classdesc Represents a MoveUnusedBudgetRecommendation.
                             * @implements IMoveUnusedBudgetRecommendation
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Recommendation.IMoveUnusedBudgetRecommendation=} [properties] Properties to set
                             */
                            function MoveUnusedBudgetRecommendation(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * MoveUnusedBudgetRecommendation excessCampaignBudget.
                             * @member {google.protobuf.IStringValue|null|undefined} excessCampaignBudget
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation
                             * @instance
                             */
                            MoveUnusedBudgetRecommendation.prototype.excessCampaignBudget = null;

                            /**
                             * MoveUnusedBudgetRecommendation budgetRecommendation.
                             * @member {google.ads.googleads.v1.resources.Recommendation.ICampaignBudgetRecommendation|null|undefined} budgetRecommendation
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation
                             * @instance
                             */
                            MoveUnusedBudgetRecommendation.prototype.budgetRecommendation = null;

                            /**
                             * Creates a new MoveUnusedBudgetRecommendation instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IMoveUnusedBudgetRecommendation=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation} MoveUnusedBudgetRecommendation instance
                             */
                            MoveUnusedBudgetRecommendation.create = function create(properties) {
                                return new MoveUnusedBudgetRecommendation(properties);
                            };

                            /**
                             * Encodes the specified MoveUnusedBudgetRecommendation message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IMoveUnusedBudgetRecommendation} message MoveUnusedBudgetRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            MoveUnusedBudgetRecommendation.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.excessCampaignBudget != null && message.hasOwnProperty("excessCampaignBudget"))
                                    $root.google.protobuf.StringValue.encode(message.excessCampaignBudget, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.budgetRecommendation != null && message.hasOwnProperty("budgetRecommendation"))
                                    $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.encode(message.budgetRecommendation, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified MoveUnusedBudgetRecommendation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.IMoveUnusedBudgetRecommendation} message MoveUnusedBudgetRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            MoveUnusedBudgetRecommendation.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a MoveUnusedBudgetRecommendation message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation} MoveUnusedBudgetRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            MoveUnusedBudgetRecommendation.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.excessCampaignBudget = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.budgetRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a MoveUnusedBudgetRecommendation message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation} MoveUnusedBudgetRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            MoveUnusedBudgetRecommendation.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a MoveUnusedBudgetRecommendation message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            MoveUnusedBudgetRecommendation.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.excessCampaignBudget != null && message.hasOwnProperty("excessCampaignBudget")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.excessCampaignBudget);
                                    if (error)
                                        return "excessCampaignBudget." + error;
                                }
                                if (message.budgetRecommendation != null && message.hasOwnProperty("budgetRecommendation")) {
                                    var error = $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.verify(message.budgetRecommendation);
                                    if (error)
                                        return "budgetRecommendation." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a MoveUnusedBudgetRecommendation message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation} MoveUnusedBudgetRecommendation
                             */
                            MoveUnusedBudgetRecommendation.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation();
                                if (object.excessCampaignBudget != null) {
                                    if (typeof object.excessCampaignBudget !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation.excessCampaignBudget: object expected");
                                    message.excessCampaignBudget = $root.google.protobuf.StringValue.fromObject(object.excessCampaignBudget);
                                }
                                if (object.budgetRecommendation != null) {
                                    if (typeof object.budgetRecommendation !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation.budgetRecommendation: object expected");
                                    message.budgetRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.fromObject(object.budgetRecommendation);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a MoveUnusedBudgetRecommendation message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation} message MoveUnusedBudgetRecommendation
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            MoveUnusedBudgetRecommendation.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.excessCampaignBudget = null;
                                    object.budgetRecommendation = null;
                                }
                                if (message.excessCampaignBudget != null && message.hasOwnProperty("excessCampaignBudget"))
                                    object.excessCampaignBudget = $root.google.protobuf.StringValue.toObject(message.excessCampaignBudget, options);
                                if (message.budgetRecommendation != null && message.hasOwnProperty("budgetRecommendation"))
                                    object.budgetRecommendation = $root.google.ads.googleads.v1.resources.Recommendation.CampaignBudgetRecommendation.toObject(message.budgetRecommendation, options);
                                return object;
                            };

                            /**
                             * Converts this MoveUnusedBudgetRecommendation to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Recommendation.MoveUnusedBudgetRecommendation
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            MoveUnusedBudgetRecommendation.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return MoveUnusedBudgetRecommendation;
                        })();

                        Recommendation.CalloutExtensionRecommendation = (function() {

                            /**
                             * Properties of a CalloutExtensionRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @interface ICalloutExtensionRecommendation
                             * @property {Array.<google.ads.googleads.v1.common.ICalloutFeedItem>|null} [recommendedExtensions] CalloutExtensionRecommendation recommendedExtensions
                             */

                            /**
                             * Constructs a new CalloutExtensionRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @classdesc Represents a CalloutExtensionRecommendation.
                             * @implements ICalloutExtensionRecommendation
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Recommendation.ICalloutExtensionRecommendation=} [properties] Properties to set
                             */
                            function CalloutExtensionRecommendation(properties) {
                                this.recommendedExtensions = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * CalloutExtensionRecommendation recommendedExtensions.
                             * @member {Array.<google.ads.googleads.v1.common.ICalloutFeedItem>} recommendedExtensions
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation
                             * @instance
                             */
                            CalloutExtensionRecommendation.prototype.recommendedExtensions = $util.emptyArray;

                            /**
                             * Creates a new CalloutExtensionRecommendation instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ICalloutExtensionRecommendation=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation} CalloutExtensionRecommendation instance
                             */
                            CalloutExtensionRecommendation.create = function create(properties) {
                                return new CalloutExtensionRecommendation(properties);
                            };

                            /**
                             * Encodes the specified CalloutExtensionRecommendation message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ICalloutExtensionRecommendation} message CalloutExtensionRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            CalloutExtensionRecommendation.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.recommendedExtensions != null && message.recommendedExtensions.length)
                                    for (var i = 0; i < message.recommendedExtensions.length; ++i)
                                        $root.google.ads.googleads.v1.common.CalloutFeedItem.encode(message.recommendedExtensions[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified CalloutExtensionRecommendation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ICalloutExtensionRecommendation} message CalloutExtensionRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            CalloutExtensionRecommendation.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a CalloutExtensionRecommendation message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation} CalloutExtensionRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            CalloutExtensionRecommendation.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        if (!(message.recommendedExtensions && message.recommendedExtensions.length))
                                            message.recommendedExtensions = [];
                                        message.recommendedExtensions.push($root.google.ads.googleads.v1.common.CalloutFeedItem.decode(reader, reader.uint32()));
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a CalloutExtensionRecommendation message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation} CalloutExtensionRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            CalloutExtensionRecommendation.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a CalloutExtensionRecommendation message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            CalloutExtensionRecommendation.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.recommendedExtensions != null && message.hasOwnProperty("recommendedExtensions")) {
                                    if (!Array.isArray(message.recommendedExtensions))
                                        return "recommendedExtensions: array expected";
                                    for (var i = 0; i < message.recommendedExtensions.length; ++i) {
                                        var error = $root.google.ads.googleads.v1.common.CalloutFeedItem.verify(message.recommendedExtensions[i]);
                                        if (error)
                                            return "recommendedExtensions." + error;
                                    }
                                }
                                return null;
                            };

                            /**
                             * Creates a CalloutExtensionRecommendation message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation} CalloutExtensionRecommendation
                             */
                            CalloutExtensionRecommendation.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation();
                                if (object.recommendedExtensions) {
                                    if (!Array.isArray(object.recommendedExtensions))
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation.recommendedExtensions: array expected");
                                    message.recommendedExtensions = [];
                                    for (var i = 0; i < object.recommendedExtensions.length; ++i) {
                                        if (typeof object.recommendedExtensions[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation.recommendedExtensions: object expected");
                                        message.recommendedExtensions[i] = $root.google.ads.googleads.v1.common.CalloutFeedItem.fromObject(object.recommendedExtensions[i]);
                                    }
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a CalloutExtensionRecommendation message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation} message CalloutExtensionRecommendation
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            CalloutExtensionRecommendation.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.recommendedExtensions = [];
                                if (message.recommendedExtensions && message.recommendedExtensions.length) {
                                    object.recommendedExtensions = [];
                                    for (var j = 0; j < message.recommendedExtensions.length; ++j)
                                        object.recommendedExtensions[j] = $root.google.ads.googleads.v1.common.CalloutFeedItem.toObject(message.recommendedExtensions[j], options);
                                }
                                return object;
                            };

                            /**
                             * Converts this CalloutExtensionRecommendation to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Recommendation.CalloutExtensionRecommendation
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            CalloutExtensionRecommendation.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return CalloutExtensionRecommendation;
                        })();

                        Recommendation.SitelinkExtensionRecommendation = (function() {

                            /**
                             * Properties of a SitelinkExtensionRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @interface ISitelinkExtensionRecommendation
                             * @property {Array.<google.ads.googleads.v1.common.ISitelinkFeedItem>|null} [recommendedExtensions] SitelinkExtensionRecommendation recommendedExtensions
                             */

                            /**
                             * Constructs a new SitelinkExtensionRecommendation.
                             * @memberof google.ads.googleads.v1.resources.Recommendation
                             * @classdesc Represents a SitelinkExtensionRecommendation.
                             * @implements ISitelinkExtensionRecommendation
                             * @constructor
                             * @param {google.ads.googleads.v1.resources.Recommendation.ISitelinkExtensionRecommendation=} [properties] Properties to set
                             */
                            function SitelinkExtensionRecommendation(properties) {
                                this.recommendedExtensions = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * SitelinkExtensionRecommendation recommendedExtensions.
                             * @member {Array.<google.ads.googleads.v1.common.ISitelinkFeedItem>} recommendedExtensions
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation
                             * @instance
                             */
                            SitelinkExtensionRecommendation.prototype.recommendedExtensions = $util.emptyArray;

                            /**
                             * Creates a new SitelinkExtensionRecommendation instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ISitelinkExtensionRecommendation=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation} SitelinkExtensionRecommendation instance
                             */
                            SitelinkExtensionRecommendation.create = function create(properties) {
                                return new SitelinkExtensionRecommendation(properties);
                            };

                            /**
                             * Encodes the specified SitelinkExtensionRecommendation message. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ISitelinkExtensionRecommendation} message SitelinkExtensionRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            SitelinkExtensionRecommendation.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.recommendedExtensions != null && message.recommendedExtensions.length)
                                    for (var i = 0; i < message.recommendedExtensions.length; ++i)
                                        $root.google.ads.googleads.v1.common.SitelinkFeedItem.encode(message.recommendedExtensions[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified SitelinkExtensionRecommendation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.ISitelinkExtensionRecommendation} message SitelinkExtensionRecommendation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            SitelinkExtensionRecommendation.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a SitelinkExtensionRecommendation message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation} SitelinkExtensionRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            SitelinkExtensionRecommendation.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        if (!(message.recommendedExtensions && message.recommendedExtensions.length))
                                            message.recommendedExtensions = [];
                                        message.recommendedExtensions.push($root.google.ads.googleads.v1.common.SitelinkFeedItem.decode(reader, reader.uint32()));
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a SitelinkExtensionRecommendation message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation} SitelinkExtensionRecommendation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            SitelinkExtensionRecommendation.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a SitelinkExtensionRecommendation message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            SitelinkExtensionRecommendation.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.recommendedExtensions != null && message.hasOwnProperty("recommendedExtensions")) {
                                    if (!Array.isArray(message.recommendedExtensions))
                                        return "recommendedExtensions: array expected";
                                    for (var i = 0; i < message.recommendedExtensions.length; ++i) {
                                        var error = $root.google.ads.googleads.v1.common.SitelinkFeedItem.verify(message.recommendedExtensions[i]);
                                        if (error)
                                            return "recommendedExtensions." + error;
                                    }
                                }
                                return null;
                            };

                            /**
                             * Creates a SitelinkExtensionRecommendation message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation} SitelinkExtensionRecommendation
                             */
                            SitelinkExtensionRecommendation.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation();
                                if (object.recommendedExtensions) {
                                    if (!Array.isArray(object.recommendedExtensions))
                                        throw TypeError(".google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation.recommendedExtensions: array expected");
                                    message.recommendedExtensions = [];
                                    for (var i = 0; i < object.recommendedExtensions.length; ++i) {
                                        if (typeof object.recommendedExtensions[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation.recommendedExtensions: object expected");
                                        message.recommendedExtensions[i] = $root.google.ads.googleads.v1.common.SitelinkFeedItem.fromObject(object.recommendedExtensions[i]);
                                    }
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a SitelinkExtensionRecommendation message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation
                             * @static
                             * @param {google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation} message SitelinkExtensionRecommendation
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            SitelinkExtensionRecommendation.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.recommendedExtensions = [];
                                if (message.recommendedExtensions && message.recommendedExtensions.length) {
                                    object.recommendedExtensions = [];
                                    for (var j = 0; j < message.recommendedExtensions.length; ++j)
                                        object.recommendedExtensions[j] = $root.google.ads.googleads.v1.common.SitelinkFeedItem.toObject(message.recommendedExtensions[j], options);
                                }
                                return object;
                            };

                            /**
                             * Converts this SitelinkExtensionRecommendation to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.resources.Recommendation.SitelinkExtensionRecommendation
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            SitelinkExtensionRecommendation.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return SitelinkExtensionRecommendation;
                        })();

                        return Recommendation;
                    })();

                    resources.RemarketingAction = (function() {

                        /**
                         * Properties of a RemarketingAction.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IRemarketingAction
                         * @property {string|null} [resourceName] RemarketingAction resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] RemarketingAction id
                         * @property {google.protobuf.IStringValue|null} [name] RemarketingAction name
                         * @property {Array.<google.ads.googleads.v1.common.ITagSnippet>|null} [tagSnippets] RemarketingAction tagSnippets
                         */

                        /**
                         * Constructs a new RemarketingAction.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a RemarketingAction.
                         * @implements IRemarketingAction
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IRemarketingAction=} [properties] Properties to set
                         */
                        function RemarketingAction(properties) {
                            this.tagSnippets = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * RemarketingAction resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.RemarketingAction
                         * @instance
                         */
                        RemarketingAction.prototype.resourceName = "";

                        /**
                         * RemarketingAction id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.RemarketingAction
                         * @instance
                         */
                        RemarketingAction.prototype.id = null;

                        /**
                         * RemarketingAction name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.RemarketingAction
                         * @instance
                         */
                        RemarketingAction.prototype.name = null;

                        /**
                         * RemarketingAction tagSnippets.
                         * @member {Array.<google.ads.googleads.v1.common.ITagSnippet>} tagSnippets
                         * @memberof google.ads.googleads.v1.resources.RemarketingAction
                         * @instance
                         */
                        RemarketingAction.prototype.tagSnippets = $util.emptyArray;

                        /**
                         * Creates a new RemarketingAction instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.RemarketingAction
                         * @static
                         * @param {google.ads.googleads.v1.resources.IRemarketingAction=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.RemarketingAction} RemarketingAction instance
                         */
                        RemarketingAction.create = function create(properties) {
                            return new RemarketingAction(properties);
                        };

                        /**
                         * Encodes the specified RemarketingAction message. Does not implicitly {@link google.ads.googleads.v1.resources.RemarketingAction.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.RemarketingAction
                         * @static
                         * @param {google.ads.googleads.v1.resources.IRemarketingAction} message RemarketingAction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemarketingAction.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.tagSnippets != null && message.tagSnippets.length)
                                for (var i = 0; i < message.tagSnippets.length; ++i)
                                    $root.google.ads.googleads.v1.common.TagSnippet.encode(message.tagSnippets[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified RemarketingAction message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.RemarketingAction.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.RemarketingAction
                         * @static
                         * @param {google.ads.googleads.v1.resources.IRemarketingAction} message RemarketingAction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemarketingAction.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a RemarketingAction message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.RemarketingAction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.RemarketingAction} RemarketingAction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemarketingAction.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.RemarketingAction();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    if (!(message.tagSnippets && message.tagSnippets.length))
                                        message.tagSnippets = [];
                                    message.tagSnippets.push($root.google.ads.googleads.v1.common.TagSnippet.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a RemarketingAction message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.RemarketingAction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.RemarketingAction} RemarketingAction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemarketingAction.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a RemarketingAction message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.RemarketingAction
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RemarketingAction.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.tagSnippets != null && message.hasOwnProperty("tagSnippets")) {
                                if (!Array.isArray(message.tagSnippets))
                                    return "tagSnippets: array expected";
                                for (var i = 0; i < message.tagSnippets.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.TagSnippet.verify(message.tagSnippets[i]);
                                    if (error)
                                        return "tagSnippets." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a RemarketingAction message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.RemarketingAction
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.RemarketingAction} RemarketingAction
                         */
                        RemarketingAction.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.RemarketingAction)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.RemarketingAction();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.RemarketingAction.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.RemarketingAction.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            if (object.tagSnippets) {
                                if (!Array.isArray(object.tagSnippets))
                                    throw TypeError(".google.ads.googleads.v1.resources.RemarketingAction.tagSnippets: array expected");
                                message.tagSnippets = [];
                                for (var i = 0; i < object.tagSnippets.length; ++i) {
                                    if (typeof object.tagSnippets[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.RemarketingAction.tagSnippets: object expected");
                                    message.tagSnippets[i] = $root.google.ads.googleads.v1.common.TagSnippet.fromObject(object.tagSnippets[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a RemarketingAction message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.RemarketingAction
                         * @static
                         * @param {google.ads.googleads.v1.resources.RemarketingAction} message RemarketingAction
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RemarketingAction.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.tagSnippets = [];
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.name = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.tagSnippets && message.tagSnippets.length) {
                                object.tagSnippets = [];
                                for (var j = 0; j < message.tagSnippets.length; ++j)
                                    object.tagSnippets[j] = $root.google.ads.googleads.v1.common.TagSnippet.toObject(message.tagSnippets[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this RemarketingAction to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.RemarketingAction
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RemarketingAction.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return RemarketingAction;
                    })();

                    resources.SearchTermView = (function() {

                        /**
                         * Properties of a SearchTermView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ISearchTermView
                         * @property {string|null} [resourceName] SearchTermView resourceName
                         * @property {google.protobuf.IStringValue|null} [searchTerm] SearchTermView searchTerm
                         * @property {google.protobuf.IStringValue|null} [adGroup] SearchTermView adGroup
                         * @property {google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum.SearchTermTargetingStatus|null} [status] SearchTermView status
                         */

                        /**
                         * Constructs a new SearchTermView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a SearchTermView.
                         * @implements ISearchTermView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ISearchTermView=} [properties] Properties to set
                         */
                        function SearchTermView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * SearchTermView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.SearchTermView
                         * @instance
                         */
                        SearchTermView.prototype.resourceName = "";

                        /**
                         * SearchTermView searchTerm.
                         * @member {google.protobuf.IStringValue|null|undefined} searchTerm
                         * @memberof google.ads.googleads.v1.resources.SearchTermView
                         * @instance
                         */
                        SearchTermView.prototype.searchTerm = null;

                        /**
                         * SearchTermView adGroup.
                         * @member {google.protobuf.IStringValue|null|undefined} adGroup
                         * @memberof google.ads.googleads.v1.resources.SearchTermView
                         * @instance
                         */
                        SearchTermView.prototype.adGroup = null;

                        /**
                         * SearchTermView status.
                         * @member {google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum.SearchTermTargetingStatus} status
                         * @memberof google.ads.googleads.v1.resources.SearchTermView
                         * @instance
                         */
                        SearchTermView.prototype.status = 0;

                        /**
                         * Creates a new SearchTermView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.SearchTermView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ISearchTermView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.SearchTermView} SearchTermView instance
                         */
                        SearchTermView.create = function create(properties) {
                            return new SearchTermView(properties);
                        };

                        /**
                         * Encodes the specified SearchTermView message. Does not implicitly {@link google.ads.googleads.v1.resources.SearchTermView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.SearchTermView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ISearchTermView} message SearchTermView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchTermView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.searchTerm != null && message.hasOwnProperty("searchTerm"))
                                $root.google.protobuf.StringValue.encode(message.searchTerm, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                $root.google.protobuf.StringValue.encode(message.adGroup, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.status);
                            return writer;
                        };

                        /**
                         * Encodes the specified SearchTermView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.SearchTermView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.SearchTermView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ISearchTermView} message SearchTermView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchTermView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SearchTermView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.SearchTermView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.SearchTermView} SearchTermView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchTermView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.SearchTermView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.searchTerm = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.adGroup = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.status = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SearchTermView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.SearchTermView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.SearchTermView} SearchTermView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchTermView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SearchTermView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.SearchTermView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SearchTermView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.searchTerm != null && message.hasOwnProperty("searchTerm")) {
                                var error = $root.google.protobuf.StringValue.verify(message.searchTerm);
                                if (error)
                                    return "searchTerm." + error;
                            }
                            if (message.adGroup != null && message.hasOwnProperty("adGroup")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adGroup);
                                if (error)
                                    return "adGroup." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            return null;
                        };

                        /**
                         * Creates a SearchTermView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.SearchTermView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.SearchTermView} SearchTermView
                         */
                        SearchTermView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.SearchTermView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.SearchTermView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.searchTerm != null) {
                                if (typeof object.searchTerm !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.SearchTermView.searchTerm: object expected");
                                message.searchTerm = $root.google.protobuf.StringValue.fromObject(object.searchTerm);
                            }
                            if (object.adGroup != null) {
                                if (typeof object.adGroup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.SearchTermView.adGroup: object expected");
                                message.adGroup = $root.google.protobuf.StringValue.fromObject(object.adGroup);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ADDED":
                            case 2:
                                message.status = 2;
                                break;
                            case "EXCLUDED":
                            case 3:
                                message.status = 3;
                                break;
                            case "ADDED_EXCLUDED":
                            case 4:
                                message.status = 4;
                                break;
                            case "NONE":
                            case 5:
                                message.status = 5;
                                break;
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a SearchTermView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.SearchTermView
                         * @static
                         * @param {google.ads.googleads.v1.resources.SearchTermView} message SearchTermView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SearchTermView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.searchTerm = null;
                                object.adGroup = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.searchTerm != null && message.hasOwnProperty("searchTerm"))
                                object.searchTerm = $root.google.protobuf.StringValue.toObject(message.searchTerm, options);
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                object.adGroup = $root.google.protobuf.StringValue.toObject(message.adGroup, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.SearchTermTargetingStatusEnum.SearchTermTargetingStatus[message.status] : message.status;
                            return object;
                        };

                        /**
                         * Converts this SearchTermView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.SearchTermView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SearchTermView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return SearchTermView;
                    })();

                    resources.SharedCriterion = (function() {

                        /**
                         * Properties of a SharedCriterion.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ISharedCriterion
                         * @property {string|null} [resourceName] SharedCriterion resourceName
                         * @property {google.protobuf.IStringValue|null} [sharedSet] SharedCriterion sharedSet
                         * @property {google.protobuf.IInt64Value|null} [criterionId] SharedCriterion criterionId
                         * @property {google.ads.googleads.v1.enums.CriterionTypeEnum.CriterionType|null} [type] SharedCriterion type
                         * @property {google.ads.googleads.v1.common.IKeywordInfo|null} [keyword] SharedCriterion keyword
                         * @property {google.ads.googleads.v1.common.IYouTubeVideoInfo|null} [youtubeVideo] SharedCriterion youtubeVideo
                         * @property {google.ads.googleads.v1.common.IYouTubeChannelInfo|null} [youtubeChannel] SharedCriterion youtubeChannel
                         * @property {google.ads.googleads.v1.common.IPlacementInfo|null} [placement] SharedCriterion placement
                         * @property {google.ads.googleads.v1.common.IMobileAppCategoryInfo|null} [mobileAppCategory] SharedCriterion mobileAppCategory
                         * @property {google.ads.googleads.v1.common.IMobileApplicationInfo|null} [mobileApplication] SharedCriterion mobileApplication
                         */

                        /**
                         * Constructs a new SharedCriterion.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a SharedCriterion.
                         * @implements ISharedCriterion
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ISharedCriterion=} [properties] Properties to set
                         */
                        function SharedCriterion(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * SharedCriterion resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @instance
                         */
                        SharedCriterion.prototype.resourceName = "";

                        /**
                         * SharedCriterion sharedSet.
                         * @member {google.protobuf.IStringValue|null|undefined} sharedSet
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @instance
                         */
                        SharedCriterion.prototype.sharedSet = null;

                        /**
                         * SharedCriterion criterionId.
                         * @member {google.protobuf.IInt64Value|null|undefined} criterionId
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @instance
                         */
                        SharedCriterion.prototype.criterionId = null;

                        /**
                         * SharedCriterion type.
                         * @member {google.ads.googleads.v1.enums.CriterionTypeEnum.CriterionType} type
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @instance
                         */
                        SharedCriterion.prototype.type = 0;

                        /**
                         * SharedCriterion keyword.
                         * @member {google.ads.googleads.v1.common.IKeywordInfo|null|undefined} keyword
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @instance
                         */
                        SharedCriterion.prototype.keyword = null;

                        /**
                         * SharedCriterion youtubeVideo.
                         * @member {google.ads.googleads.v1.common.IYouTubeVideoInfo|null|undefined} youtubeVideo
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @instance
                         */
                        SharedCriterion.prototype.youtubeVideo = null;

                        /**
                         * SharedCriterion youtubeChannel.
                         * @member {google.ads.googleads.v1.common.IYouTubeChannelInfo|null|undefined} youtubeChannel
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @instance
                         */
                        SharedCriterion.prototype.youtubeChannel = null;

                        /**
                         * SharedCriterion placement.
                         * @member {google.ads.googleads.v1.common.IPlacementInfo|null|undefined} placement
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @instance
                         */
                        SharedCriterion.prototype.placement = null;

                        /**
                         * SharedCriterion mobileAppCategory.
                         * @member {google.ads.googleads.v1.common.IMobileAppCategoryInfo|null|undefined} mobileAppCategory
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @instance
                         */
                        SharedCriterion.prototype.mobileAppCategory = null;

                        /**
                         * SharedCriterion mobileApplication.
                         * @member {google.ads.googleads.v1.common.IMobileApplicationInfo|null|undefined} mobileApplication
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @instance
                         */
                        SharedCriterion.prototype.mobileApplication = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * SharedCriterion criterion.
                         * @member {"keyword"|"youtubeVideo"|"youtubeChannel"|"placement"|"mobileAppCategory"|"mobileApplication"|undefined} criterion
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @instance
                         */
                        Object.defineProperty(SharedCriterion.prototype, "criterion", {
                            get: $util.oneOfGetter($oneOfFields = ["keyword", "youtubeVideo", "youtubeChannel", "placement", "mobileAppCategory", "mobileApplication"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new SharedCriterion instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @static
                         * @param {google.ads.googleads.v1.resources.ISharedCriterion=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.SharedCriterion} SharedCriterion instance
                         */
                        SharedCriterion.create = function create(properties) {
                            return new SharedCriterion(properties);
                        };

                        /**
                         * Encodes the specified SharedCriterion message. Does not implicitly {@link google.ads.googleads.v1.resources.SharedCriterion.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @static
                         * @param {google.ads.googleads.v1.resources.ISharedCriterion} message SharedCriterion message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SharedCriterion.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.sharedSet != null && message.hasOwnProperty("sharedSet"))
                                $root.google.protobuf.StringValue.encode(message.sharedSet, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.keyword != null && message.hasOwnProperty("keyword"))
                                $root.google.ads.googleads.v1.common.KeywordInfo.encode(message.keyword, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.type);
                            if (message.youtubeVideo != null && message.hasOwnProperty("youtubeVideo"))
                                $root.google.ads.googleads.v1.common.YouTubeVideoInfo.encode(message.youtubeVideo, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.youtubeChannel != null && message.hasOwnProperty("youtubeChannel"))
                                $root.google.ads.googleads.v1.common.YouTubeChannelInfo.encode(message.youtubeChannel, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.placement != null && message.hasOwnProperty("placement"))
                                $root.google.ads.googleads.v1.common.PlacementInfo.encode(message.placement, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.mobileAppCategory != null && message.hasOwnProperty("mobileAppCategory"))
                                $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.encode(message.mobileAppCategory, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.mobileApplication != null && message.hasOwnProperty("mobileApplication"))
                                $root.google.ads.googleads.v1.common.MobileApplicationInfo.encode(message.mobileApplication, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.criterionId != null && message.hasOwnProperty("criterionId"))
                                $root.google.protobuf.Int64Value.encode(message.criterionId, writer.uint32(/* id 26, wireType 2 =*/210).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified SharedCriterion message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.SharedCriterion.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @static
                         * @param {google.ads.googleads.v1.resources.ISharedCriterion} message SharedCriterion message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SharedCriterion.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SharedCriterion message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.SharedCriterion} SharedCriterion
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SharedCriterion.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.SharedCriterion();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.sharedSet = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 26:
                                    message.criterionId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.type = reader.int32();
                                    break;
                                case 3:
                                    message.keyword = $root.google.ads.googleads.v1.common.KeywordInfo.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.youtubeVideo = $root.google.ads.googleads.v1.common.YouTubeVideoInfo.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.youtubeChannel = $root.google.ads.googleads.v1.common.YouTubeChannelInfo.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.placement = $root.google.ads.googleads.v1.common.PlacementInfo.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.mobileAppCategory = $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.mobileApplication = $root.google.ads.googleads.v1.common.MobileApplicationInfo.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SharedCriterion message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.SharedCriterion} SharedCriterion
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SharedCriterion.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SharedCriterion message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SharedCriterion.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.sharedSet != null && message.hasOwnProperty("sharedSet")) {
                                var error = $root.google.protobuf.StringValue.verify(message.sharedSet);
                                if (error)
                                    return "sharedSet." + error;
                            }
                            if (message.criterionId != null && message.hasOwnProperty("criterionId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.criterionId);
                                if (error)
                                    return "criterionId." + error;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                    break;
                                }
                            if (message.keyword != null && message.hasOwnProperty("keyword")) {
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.KeywordInfo.verify(message.keyword);
                                    if (error)
                                        return "keyword." + error;
                                }
                            }
                            if (message.youtubeVideo != null && message.hasOwnProperty("youtubeVideo")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.YouTubeVideoInfo.verify(message.youtubeVideo);
                                    if (error)
                                        return "youtubeVideo." + error;
                                }
                            }
                            if (message.youtubeChannel != null && message.hasOwnProperty("youtubeChannel")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.YouTubeChannelInfo.verify(message.youtubeChannel);
                                    if (error)
                                        return "youtubeChannel." + error;
                                }
                            }
                            if (message.placement != null && message.hasOwnProperty("placement")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.PlacementInfo.verify(message.placement);
                                    if (error)
                                        return "placement." + error;
                                }
                            }
                            if (message.mobileAppCategory != null && message.hasOwnProperty("mobileAppCategory")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.verify(message.mobileAppCategory);
                                    if (error)
                                        return "mobileAppCategory." + error;
                                }
                            }
                            if (message.mobileApplication != null && message.hasOwnProperty("mobileApplication")) {
                                if (properties.criterion === 1)
                                    return "criterion: multiple values";
                                properties.criterion = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.MobileApplicationInfo.verify(message.mobileApplication);
                                    if (error)
                                        return "mobileApplication." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a SharedCriterion message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.SharedCriterion} SharedCriterion
                         */
                        SharedCriterion.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.SharedCriterion)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.SharedCriterion();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.sharedSet != null) {
                                if (typeof object.sharedSet !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.SharedCriterion.sharedSet: object expected");
                                message.sharedSet = $root.google.protobuf.StringValue.fromObject(object.sharedSet);
                            }
                            if (object.criterionId != null) {
                                if (typeof object.criterionId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.SharedCriterion.criterionId: object expected");
                                message.criterionId = $root.google.protobuf.Int64Value.fromObject(object.criterionId);
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "KEYWORD":
                            case 2:
                                message.type = 2;
                                break;
                            case "PLACEMENT":
                            case 3:
                                message.type = 3;
                                break;
                            case "MOBILE_APP_CATEGORY":
                            case 4:
                                message.type = 4;
                                break;
                            case "MOBILE_APPLICATION":
                            case 5:
                                message.type = 5;
                                break;
                            case "DEVICE":
                            case 6:
                                message.type = 6;
                                break;
                            case "LOCATION":
                            case 7:
                                message.type = 7;
                                break;
                            case "LISTING_GROUP":
                            case 8:
                                message.type = 8;
                                break;
                            case "AD_SCHEDULE":
                            case 9:
                                message.type = 9;
                                break;
                            case "AGE_RANGE":
                            case 10:
                                message.type = 10;
                                break;
                            case "GENDER":
                            case 11:
                                message.type = 11;
                                break;
                            case "INCOME_RANGE":
                            case 12:
                                message.type = 12;
                                break;
                            case "PARENTAL_STATUS":
                            case 13:
                                message.type = 13;
                                break;
                            case "YOUTUBE_VIDEO":
                            case 14:
                                message.type = 14;
                                break;
                            case "YOUTUBE_CHANNEL":
                            case 15:
                                message.type = 15;
                                break;
                            case "USER_LIST":
                            case 16:
                                message.type = 16;
                                break;
                            case "PROXIMITY":
                            case 17:
                                message.type = 17;
                                break;
                            case "TOPIC":
                            case 18:
                                message.type = 18;
                                break;
                            case "LISTING_SCOPE":
                            case 19:
                                message.type = 19;
                                break;
                            case "LANGUAGE":
                            case 20:
                                message.type = 20;
                                break;
                            case "IP_BLOCK":
                            case 21:
                                message.type = 21;
                                break;
                            case "CONTENT_LABEL":
                            case 22:
                                message.type = 22;
                                break;
                            case "CARRIER":
                            case 23:
                                message.type = 23;
                                break;
                            case "USER_INTEREST":
                            case 24:
                                message.type = 24;
                                break;
                            case "WEBPAGE":
                            case 25:
                                message.type = 25;
                                break;
                            case "OPERATING_SYSTEM_VERSION":
                            case 26:
                                message.type = 26;
                                break;
                            case "APP_PAYMENT_MODEL":
                            case 27:
                                message.type = 27;
                                break;
                            case "MOBILE_DEVICE":
                            case 28:
                                message.type = 28;
                                break;
                            case "CUSTOM_AFFINITY":
                            case 29:
                                message.type = 29;
                                break;
                            case "CUSTOM_INTENT":
                            case 30:
                                message.type = 30;
                                break;
                            case "LOCATION_GROUP":
                            case 31:
                                message.type = 31;
                                break;
                            }
                            if (object.keyword != null) {
                                if (typeof object.keyword !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.SharedCriterion.keyword: object expected");
                                message.keyword = $root.google.ads.googleads.v1.common.KeywordInfo.fromObject(object.keyword);
                            }
                            if (object.youtubeVideo != null) {
                                if (typeof object.youtubeVideo !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.SharedCriterion.youtubeVideo: object expected");
                                message.youtubeVideo = $root.google.ads.googleads.v1.common.YouTubeVideoInfo.fromObject(object.youtubeVideo);
                            }
                            if (object.youtubeChannel != null) {
                                if (typeof object.youtubeChannel !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.SharedCriterion.youtubeChannel: object expected");
                                message.youtubeChannel = $root.google.ads.googleads.v1.common.YouTubeChannelInfo.fromObject(object.youtubeChannel);
                            }
                            if (object.placement != null) {
                                if (typeof object.placement !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.SharedCriterion.placement: object expected");
                                message.placement = $root.google.ads.googleads.v1.common.PlacementInfo.fromObject(object.placement);
                            }
                            if (object.mobileAppCategory != null) {
                                if (typeof object.mobileAppCategory !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.SharedCriterion.mobileAppCategory: object expected");
                                message.mobileAppCategory = $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.fromObject(object.mobileAppCategory);
                            }
                            if (object.mobileApplication != null) {
                                if (typeof object.mobileApplication !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.SharedCriterion.mobileApplication: object expected");
                                message.mobileApplication = $root.google.ads.googleads.v1.common.MobileApplicationInfo.fromObject(object.mobileApplication);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a SharedCriterion message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @static
                         * @param {google.ads.googleads.v1.resources.SharedCriterion} message SharedCriterion
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SharedCriterion.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.sharedSet = null;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.criterionId = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.sharedSet != null && message.hasOwnProperty("sharedSet"))
                                object.sharedSet = $root.google.protobuf.StringValue.toObject(message.sharedSet, options);
                            if (message.keyword != null && message.hasOwnProperty("keyword")) {
                                object.keyword = $root.google.ads.googleads.v1.common.KeywordInfo.toObject(message.keyword, options);
                                if (options.oneofs)
                                    object.criterion = "keyword";
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.CriterionTypeEnum.CriterionType[message.type] : message.type;
                            if (message.youtubeVideo != null && message.hasOwnProperty("youtubeVideo")) {
                                object.youtubeVideo = $root.google.ads.googleads.v1.common.YouTubeVideoInfo.toObject(message.youtubeVideo, options);
                                if (options.oneofs)
                                    object.criterion = "youtubeVideo";
                            }
                            if (message.youtubeChannel != null && message.hasOwnProperty("youtubeChannel")) {
                                object.youtubeChannel = $root.google.ads.googleads.v1.common.YouTubeChannelInfo.toObject(message.youtubeChannel, options);
                                if (options.oneofs)
                                    object.criterion = "youtubeChannel";
                            }
                            if (message.placement != null && message.hasOwnProperty("placement")) {
                                object.placement = $root.google.ads.googleads.v1.common.PlacementInfo.toObject(message.placement, options);
                                if (options.oneofs)
                                    object.criterion = "placement";
                            }
                            if (message.mobileAppCategory != null && message.hasOwnProperty("mobileAppCategory")) {
                                object.mobileAppCategory = $root.google.ads.googleads.v1.common.MobileAppCategoryInfo.toObject(message.mobileAppCategory, options);
                                if (options.oneofs)
                                    object.criterion = "mobileAppCategory";
                            }
                            if (message.mobileApplication != null && message.hasOwnProperty("mobileApplication")) {
                                object.mobileApplication = $root.google.ads.googleads.v1.common.MobileApplicationInfo.toObject(message.mobileApplication, options);
                                if (options.oneofs)
                                    object.criterion = "mobileApplication";
                            }
                            if (message.criterionId != null && message.hasOwnProperty("criterionId"))
                                object.criterionId = $root.google.protobuf.Int64Value.toObject(message.criterionId, options);
                            return object;
                        };

                        /**
                         * Converts this SharedCriterion to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.SharedCriterion
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SharedCriterion.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return SharedCriterion;
                    })();

                    resources.SharedSet = (function() {

                        /**
                         * Properties of a SharedSet.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ISharedSet
                         * @property {string|null} [resourceName] SharedSet resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] SharedSet id
                         * @property {google.ads.googleads.v1.enums.SharedSetTypeEnum.SharedSetType|null} [type] SharedSet type
                         * @property {google.protobuf.IStringValue|null} [name] SharedSet name
                         * @property {google.ads.googleads.v1.enums.SharedSetStatusEnum.SharedSetStatus|null} [status] SharedSet status
                         * @property {google.protobuf.IInt64Value|null} [memberCount] SharedSet memberCount
                         * @property {google.protobuf.IInt64Value|null} [referenceCount] SharedSet referenceCount
                         */

                        /**
                         * Constructs a new SharedSet.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a SharedSet.
                         * @implements ISharedSet
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ISharedSet=} [properties] Properties to set
                         */
                        function SharedSet(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * SharedSet resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.SharedSet
                         * @instance
                         */
                        SharedSet.prototype.resourceName = "";

                        /**
                         * SharedSet id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.SharedSet
                         * @instance
                         */
                        SharedSet.prototype.id = null;

                        /**
                         * SharedSet type.
                         * @member {google.ads.googleads.v1.enums.SharedSetTypeEnum.SharedSetType} type
                         * @memberof google.ads.googleads.v1.resources.SharedSet
                         * @instance
                         */
                        SharedSet.prototype.type = 0;

                        /**
                         * SharedSet name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.SharedSet
                         * @instance
                         */
                        SharedSet.prototype.name = null;

                        /**
                         * SharedSet status.
                         * @member {google.ads.googleads.v1.enums.SharedSetStatusEnum.SharedSetStatus} status
                         * @memberof google.ads.googleads.v1.resources.SharedSet
                         * @instance
                         */
                        SharedSet.prototype.status = 0;

                        /**
                         * SharedSet memberCount.
                         * @member {google.protobuf.IInt64Value|null|undefined} memberCount
                         * @memberof google.ads.googleads.v1.resources.SharedSet
                         * @instance
                         */
                        SharedSet.prototype.memberCount = null;

                        /**
                         * SharedSet referenceCount.
                         * @member {google.protobuf.IInt64Value|null|undefined} referenceCount
                         * @memberof google.ads.googleads.v1.resources.SharedSet
                         * @instance
                         */
                        SharedSet.prototype.referenceCount = null;

                        /**
                         * Creates a new SharedSet instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.SharedSet
                         * @static
                         * @param {google.ads.googleads.v1.resources.ISharedSet=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.SharedSet} SharedSet instance
                         */
                        SharedSet.create = function create(properties) {
                            return new SharedSet(properties);
                        };

                        /**
                         * Encodes the specified SharedSet message. Does not implicitly {@link google.ads.googleads.v1.resources.SharedSet.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.SharedSet
                         * @static
                         * @param {google.ads.googleads.v1.resources.ISharedSet} message SharedSet message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SharedSet.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.type);
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.status);
                            if (message.memberCount != null && message.hasOwnProperty("memberCount"))
                                $root.google.protobuf.Int64Value.encode(message.memberCount, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.referenceCount != null && message.hasOwnProperty("referenceCount"))
                                $root.google.protobuf.Int64Value.encode(message.referenceCount, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified SharedSet message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.SharedSet.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.SharedSet
                         * @static
                         * @param {google.ads.googleads.v1.resources.ISharedSet} message SharedSet message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SharedSet.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SharedSet message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.SharedSet
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.SharedSet} SharedSet
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SharedSet.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.SharedSet();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.type = reader.int32();
                                    break;
                                case 4:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.status = reader.int32();
                                    break;
                                case 6:
                                    message.memberCount = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.referenceCount = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SharedSet message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.SharedSet
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.SharedSet} SharedSet
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SharedSet.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SharedSet message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.SharedSet
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SharedSet.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status"))
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.memberCount != null && message.hasOwnProperty("memberCount")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.memberCount);
                                if (error)
                                    return "memberCount." + error;
                            }
                            if (message.referenceCount != null && message.hasOwnProperty("referenceCount")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.referenceCount);
                                if (error)
                                    return "referenceCount." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a SharedSet message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.SharedSet
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.SharedSet} SharedSet
                         */
                        SharedSet.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.SharedSet)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.SharedSet();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.SharedSet.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "NEGATIVE_KEYWORDS":
                            case 2:
                                message.type = 2;
                                break;
                            case "NEGATIVE_PLACEMENTS":
                            case 3:
                                message.type = 3;
                                break;
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.SharedSet.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            switch (object.status) {
                            case "UNSPECIFIED":
                            case 0:
                                message.status = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.status = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.status = 2;
                                break;
                            case "REMOVED":
                            case 3:
                                message.status = 3;
                                break;
                            }
                            if (object.memberCount != null) {
                                if (typeof object.memberCount !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.SharedSet.memberCount: object expected");
                                message.memberCount = $root.google.protobuf.Int64Value.fromObject(object.memberCount);
                            }
                            if (object.referenceCount != null) {
                                if (typeof object.referenceCount !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.SharedSet.referenceCount: object expected");
                                message.referenceCount = $root.google.protobuf.Int64Value.fromObject(object.referenceCount);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a SharedSet message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.SharedSet
                         * @static
                         * @param {google.ads.googleads.v1.resources.SharedSet} message SharedSet
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SharedSet.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.name = null;
                                object.status = options.enums === String ? "UNSPECIFIED" : 0;
                                object.memberCount = null;
                                object.referenceCount = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.SharedSetTypeEnum.SharedSetType[message.type] : message.type;
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = options.enums === String ? $root.google.ads.googleads.v1.enums.SharedSetStatusEnum.SharedSetStatus[message.status] : message.status;
                            if (message.memberCount != null && message.hasOwnProperty("memberCount"))
                                object.memberCount = $root.google.protobuf.Int64Value.toObject(message.memberCount, options);
                            if (message.referenceCount != null && message.hasOwnProperty("referenceCount"))
                                object.referenceCount = $root.google.protobuf.Int64Value.toObject(message.referenceCount, options);
                            return object;
                        };

                        /**
                         * Converts this SharedSet to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.SharedSet
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SharedSet.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return SharedSet;
                    })();

                    resources.ShoppingPerformanceView = (function() {

                        /**
                         * Properties of a ShoppingPerformanceView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IShoppingPerformanceView
                         * @property {string|null} [resourceName] ShoppingPerformanceView resourceName
                         */

                        /**
                         * Constructs a new ShoppingPerformanceView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a ShoppingPerformanceView.
                         * @implements IShoppingPerformanceView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IShoppingPerformanceView=} [properties] Properties to set
                         */
                        function ShoppingPerformanceView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ShoppingPerformanceView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.ShoppingPerformanceView
                         * @instance
                         */
                        ShoppingPerformanceView.prototype.resourceName = "";

                        /**
                         * Creates a new ShoppingPerformanceView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.ShoppingPerformanceView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IShoppingPerformanceView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.ShoppingPerformanceView} ShoppingPerformanceView instance
                         */
                        ShoppingPerformanceView.create = function create(properties) {
                            return new ShoppingPerformanceView(properties);
                        };

                        /**
                         * Encodes the specified ShoppingPerformanceView message. Does not implicitly {@link google.ads.googleads.v1.resources.ShoppingPerformanceView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.ShoppingPerformanceView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IShoppingPerformanceView} message ShoppingPerformanceView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ShoppingPerformanceView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified ShoppingPerformanceView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.ShoppingPerformanceView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ShoppingPerformanceView
                         * @static
                         * @param {google.ads.googleads.v1.resources.IShoppingPerformanceView} message ShoppingPerformanceView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ShoppingPerformanceView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ShoppingPerformanceView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.ShoppingPerformanceView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.ShoppingPerformanceView} ShoppingPerformanceView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ShoppingPerformanceView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.ShoppingPerformanceView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ShoppingPerformanceView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.ShoppingPerformanceView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.ShoppingPerformanceView} ShoppingPerformanceView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ShoppingPerformanceView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ShoppingPerformanceView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.ShoppingPerformanceView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ShoppingPerformanceView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a ShoppingPerformanceView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.ShoppingPerformanceView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.ShoppingPerformanceView} ShoppingPerformanceView
                         */
                        ShoppingPerformanceView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.ShoppingPerformanceView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.ShoppingPerformanceView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a ShoppingPerformanceView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.ShoppingPerformanceView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ShoppingPerformanceView} message ShoppingPerformanceView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ShoppingPerformanceView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this ShoppingPerformanceView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.ShoppingPerformanceView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ShoppingPerformanceView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ShoppingPerformanceView;
                    })();

                    resources.TopicConstant = (function() {

                        /**
                         * Properties of a TopicConstant.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ITopicConstant
                         * @property {string|null} [resourceName] TopicConstant resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] TopicConstant id
                         * @property {google.protobuf.IStringValue|null} [topicConstantParent] TopicConstant topicConstantParent
                         * @property {Array.<google.protobuf.IStringValue>|null} [path] TopicConstant path
                         */

                        /**
                         * Constructs a new TopicConstant.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a TopicConstant.
                         * @implements ITopicConstant
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ITopicConstant=} [properties] Properties to set
                         */
                        function TopicConstant(properties) {
                            this.path = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * TopicConstant resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.TopicConstant
                         * @instance
                         */
                        TopicConstant.prototype.resourceName = "";

                        /**
                         * TopicConstant id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.TopicConstant
                         * @instance
                         */
                        TopicConstant.prototype.id = null;

                        /**
                         * TopicConstant topicConstantParent.
                         * @member {google.protobuf.IStringValue|null|undefined} topicConstantParent
                         * @memberof google.ads.googleads.v1.resources.TopicConstant
                         * @instance
                         */
                        TopicConstant.prototype.topicConstantParent = null;

                        /**
                         * TopicConstant path.
                         * @member {Array.<google.protobuf.IStringValue>} path
                         * @memberof google.ads.googleads.v1.resources.TopicConstant
                         * @instance
                         */
                        TopicConstant.prototype.path = $util.emptyArray;

                        /**
                         * Creates a new TopicConstant instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.TopicConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.ITopicConstant=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.TopicConstant} TopicConstant instance
                         */
                        TopicConstant.create = function create(properties) {
                            return new TopicConstant(properties);
                        };

                        /**
                         * Encodes the specified TopicConstant message. Does not implicitly {@link google.ads.googleads.v1.resources.TopicConstant.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.TopicConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.ITopicConstant} message TopicConstant message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TopicConstant.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.topicConstantParent != null && message.hasOwnProperty("topicConstantParent"))
                                $root.google.protobuf.StringValue.encode(message.topicConstantParent, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.path != null && message.path.length)
                                for (var i = 0; i < message.path.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.path[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified TopicConstant message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.TopicConstant.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.TopicConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.ITopicConstant} message TopicConstant message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TopicConstant.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TopicConstant message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.TopicConstant
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.TopicConstant} TopicConstant
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TopicConstant.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.TopicConstant();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.topicConstantParent = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    if (!(message.path && message.path.length))
                                        message.path = [];
                                    message.path.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TopicConstant message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.TopicConstant
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.TopicConstant} TopicConstant
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TopicConstant.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TopicConstant message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.TopicConstant
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TopicConstant.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.topicConstantParent != null && message.hasOwnProperty("topicConstantParent")) {
                                var error = $root.google.protobuf.StringValue.verify(message.topicConstantParent);
                                if (error)
                                    return "topicConstantParent." + error;
                            }
                            if (message.path != null && message.hasOwnProperty("path")) {
                                if (!Array.isArray(message.path))
                                    return "path: array expected";
                                for (var i = 0; i < message.path.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.path[i]);
                                    if (error)
                                        return "path." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a TopicConstant message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.TopicConstant
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.TopicConstant} TopicConstant
                         */
                        TopicConstant.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.TopicConstant)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.TopicConstant();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.TopicConstant.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.topicConstantParent != null) {
                                if (typeof object.topicConstantParent !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.TopicConstant.topicConstantParent: object expected");
                                message.topicConstantParent = $root.google.protobuf.StringValue.fromObject(object.topicConstantParent);
                            }
                            if (object.path) {
                                if (!Array.isArray(object.path))
                                    throw TypeError(".google.ads.googleads.v1.resources.TopicConstant.path: array expected");
                                message.path = [];
                                for (var i = 0; i < object.path.length; ++i) {
                                    if (typeof object.path[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.TopicConstant.path: object expected");
                                    message.path[i] = $root.google.protobuf.StringValue.fromObject(object.path[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a TopicConstant message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.TopicConstant
                         * @static
                         * @param {google.ads.googleads.v1.resources.TopicConstant} message TopicConstant
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TopicConstant.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.path = [];
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.topicConstantParent = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.topicConstantParent != null && message.hasOwnProperty("topicConstantParent"))
                                object.topicConstantParent = $root.google.protobuf.StringValue.toObject(message.topicConstantParent, options);
                            if (message.path && message.path.length) {
                                object.path = [];
                                for (var j = 0; j < message.path.length; ++j)
                                    object.path[j] = $root.google.protobuf.StringValue.toObject(message.path[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this TopicConstant to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.TopicConstant
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TopicConstant.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return TopicConstant;
                    })();

                    resources.TopicView = (function() {

                        /**
                         * Properties of a TopicView.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface ITopicView
                         * @property {string|null} [resourceName] TopicView resourceName
                         */

                        /**
                         * Constructs a new TopicView.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a TopicView.
                         * @implements ITopicView
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.ITopicView=} [properties] Properties to set
                         */
                        function TopicView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * TopicView resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.TopicView
                         * @instance
                         */
                        TopicView.prototype.resourceName = "";

                        /**
                         * Creates a new TopicView instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.TopicView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ITopicView=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.TopicView} TopicView instance
                         */
                        TopicView.create = function create(properties) {
                            return new TopicView(properties);
                        };

                        /**
                         * Encodes the specified TopicView message. Does not implicitly {@link google.ads.googleads.v1.resources.TopicView.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.TopicView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ITopicView} message TopicView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TopicView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified TopicView message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.TopicView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.TopicView
                         * @static
                         * @param {google.ads.googleads.v1.resources.ITopicView} message TopicView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TopicView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a TopicView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.TopicView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.TopicView} TopicView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TopicView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.TopicView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a TopicView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.TopicView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.TopicView} TopicView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TopicView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a TopicView message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.TopicView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TopicView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a TopicView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.TopicView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.TopicView} TopicView
                         */
                        TopicView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.TopicView)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.TopicView();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a TopicView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.TopicView
                         * @static
                         * @param {google.ads.googleads.v1.resources.TopicView} message TopicView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TopicView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this TopicView to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.TopicView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TopicView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return TopicView;
                    })();

                    resources.UserInterest = (function() {

                        /**
                         * Properties of a UserInterest.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IUserInterest
                         * @property {string|null} [resourceName] UserInterest resourceName
                         * @property {google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum.UserInterestTaxonomyType|null} [taxonomyType] UserInterest taxonomyType
                         * @property {google.protobuf.IInt64Value|null} [userInterestId] UserInterest userInterestId
                         * @property {google.protobuf.IStringValue|null} [name] UserInterest name
                         * @property {google.protobuf.IStringValue|null} [userInterestParent] UserInterest userInterestParent
                         * @property {google.protobuf.IBoolValue|null} [launchedToAll] UserInterest launchedToAll
                         * @property {Array.<google.ads.googleads.v1.common.ICriterionCategoryAvailability>|null} [availabilities] UserInterest availabilities
                         */

                        /**
                         * Constructs a new UserInterest.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a UserInterest.
                         * @implements IUserInterest
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IUserInterest=} [properties] Properties to set
                         */
                        function UserInterest(properties) {
                            this.availabilities = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UserInterest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.UserInterest
                         * @instance
                         */
                        UserInterest.prototype.resourceName = "";

                        /**
                         * UserInterest taxonomyType.
                         * @member {google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum.UserInterestTaxonomyType} taxonomyType
                         * @memberof google.ads.googleads.v1.resources.UserInterest
                         * @instance
                         */
                        UserInterest.prototype.taxonomyType = 0;

                        /**
                         * UserInterest userInterestId.
                         * @member {google.protobuf.IInt64Value|null|undefined} userInterestId
                         * @memberof google.ads.googleads.v1.resources.UserInterest
                         * @instance
                         */
                        UserInterest.prototype.userInterestId = null;

                        /**
                         * UserInterest name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.UserInterest
                         * @instance
                         */
                        UserInterest.prototype.name = null;

                        /**
                         * UserInterest userInterestParent.
                         * @member {google.protobuf.IStringValue|null|undefined} userInterestParent
                         * @memberof google.ads.googleads.v1.resources.UserInterest
                         * @instance
                         */
                        UserInterest.prototype.userInterestParent = null;

                        /**
                         * UserInterest launchedToAll.
                         * @member {google.protobuf.IBoolValue|null|undefined} launchedToAll
                         * @memberof google.ads.googleads.v1.resources.UserInterest
                         * @instance
                         */
                        UserInterest.prototype.launchedToAll = null;

                        /**
                         * UserInterest availabilities.
                         * @member {Array.<google.ads.googleads.v1.common.ICriterionCategoryAvailability>} availabilities
                         * @memberof google.ads.googleads.v1.resources.UserInterest
                         * @instance
                         */
                        UserInterest.prototype.availabilities = $util.emptyArray;

                        /**
                         * Creates a new UserInterest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.UserInterest
                         * @static
                         * @param {google.ads.googleads.v1.resources.IUserInterest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.UserInterest} UserInterest instance
                         */
                        UserInterest.create = function create(properties) {
                            return new UserInterest(properties);
                        };

                        /**
                         * Encodes the specified UserInterest message. Does not implicitly {@link google.ads.googleads.v1.resources.UserInterest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.UserInterest
                         * @static
                         * @param {google.ads.googleads.v1.resources.IUserInterest} message UserInterest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserInterest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.taxonomyType != null && message.hasOwnProperty("taxonomyType"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.taxonomyType);
                            if (message.userInterestId != null && message.hasOwnProperty("userInterestId"))
                                $root.google.protobuf.Int64Value.encode(message.userInterestId, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.userInterestParent != null && message.hasOwnProperty("userInterestParent"))
                                $root.google.protobuf.StringValue.encode(message.userInterestParent, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.launchedToAll != null && message.hasOwnProperty("launchedToAll"))
                                $root.google.protobuf.BoolValue.encode(message.launchedToAll, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.availabilities != null && message.availabilities.length)
                                for (var i = 0; i < message.availabilities.length; ++i)
                                    $root.google.ads.googleads.v1.common.CriterionCategoryAvailability.encode(message.availabilities[i], writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserInterest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.UserInterest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.UserInterest
                         * @static
                         * @param {google.ads.googleads.v1.resources.IUserInterest} message UserInterest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserInterest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserInterest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.UserInterest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.UserInterest} UserInterest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserInterest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.UserInterest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.taxonomyType = reader.int32();
                                    break;
                                case 3:
                                    message.userInterestId = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.userInterestParent = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.launchedToAll = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    if (!(message.availabilities && message.availabilities.length))
                                        message.availabilities = [];
                                    message.availabilities.push($root.google.ads.googleads.v1.common.CriterionCategoryAvailability.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserInterest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.UserInterest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.UserInterest} UserInterest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserInterest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserInterest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.UserInterest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserInterest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.taxonomyType != null && message.hasOwnProperty("taxonomyType"))
                                switch (message.taxonomyType) {
                                default:
                                    return "taxonomyType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            if (message.userInterestId != null && message.hasOwnProperty("userInterestId")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.userInterestId);
                                if (error)
                                    return "userInterestId." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.userInterestParent != null && message.hasOwnProperty("userInterestParent")) {
                                var error = $root.google.protobuf.StringValue.verify(message.userInterestParent);
                                if (error)
                                    return "userInterestParent." + error;
                            }
                            if (message.launchedToAll != null && message.hasOwnProperty("launchedToAll")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.launchedToAll);
                                if (error)
                                    return "launchedToAll." + error;
                            }
                            if (message.availabilities != null && message.hasOwnProperty("availabilities")) {
                                if (!Array.isArray(message.availabilities))
                                    return "availabilities: array expected";
                                for (var i = 0; i < message.availabilities.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.CriterionCategoryAvailability.verify(message.availabilities[i]);
                                    if (error)
                                        return "availabilities." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a UserInterest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.UserInterest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.UserInterest} UserInterest
                         */
                        UserInterest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.UserInterest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.UserInterest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            switch (object.taxonomyType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.taxonomyType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.taxonomyType = 1;
                                break;
                            case "AFFINITY":
                            case 2:
                                message.taxonomyType = 2;
                                break;
                            case "IN_MARKET":
                            case 3:
                                message.taxonomyType = 3;
                                break;
                            case "MOBILE_APP_INSTALL_USER":
                            case 4:
                                message.taxonomyType = 4;
                                break;
                            case "VERTICAL_GEO":
                            case 5:
                                message.taxonomyType = 5;
                                break;
                            case "NEW_SMART_PHONE_USER":
                            case 6:
                                message.taxonomyType = 6;
                                break;
                            }
                            if (object.userInterestId != null) {
                                if (typeof object.userInterestId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserInterest.userInterestId: object expected");
                                message.userInterestId = $root.google.protobuf.Int64Value.fromObject(object.userInterestId);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserInterest.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            if (object.userInterestParent != null) {
                                if (typeof object.userInterestParent !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserInterest.userInterestParent: object expected");
                                message.userInterestParent = $root.google.protobuf.StringValue.fromObject(object.userInterestParent);
                            }
                            if (object.launchedToAll != null) {
                                if (typeof object.launchedToAll !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserInterest.launchedToAll: object expected");
                                message.launchedToAll = $root.google.protobuf.BoolValue.fromObject(object.launchedToAll);
                            }
                            if (object.availabilities) {
                                if (!Array.isArray(object.availabilities))
                                    throw TypeError(".google.ads.googleads.v1.resources.UserInterest.availabilities: array expected");
                                message.availabilities = [];
                                for (var i = 0; i < object.availabilities.length; ++i) {
                                    if (typeof object.availabilities[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.resources.UserInterest.availabilities: object expected");
                                    message.availabilities[i] = $root.google.ads.googleads.v1.common.CriterionCategoryAvailability.fromObject(object.availabilities[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a UserInterest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.UserInterest
                         * @static
                         * @param {google.ads.googleads.v1.resources.UserInterest} message UserInterest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserInterest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.availabilities = [];
                            if (options.defaults) {
                                object.resourceName = "";
                                object.taxonomyType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.userInterestId = null;
                                object.name = null;
                                object.userInterestParent = null;
                                object.launchedToAll = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.taxonomyType != null && message.hasOwnProperty("taxonomyType"))
                                object.taxonomyType = options.enums === String ? $root.google.ads.googleads.v1.enums.UserInterestTaxonomyTypeEnum.UserInterestTaxonomyType[message.taxonomyType] : message.taxonomyType;
                            if (message.userInterestId != null && message.hasOwnProperty("userInterestId"))
                                object.userInterestId = $root.google.protobuf.Int64Value.toObject(message.userInterestId, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.userInterestParent != null && message.hasOwnProperty("userInterestParent"))
                                object.userInterestParent = $root.google.protobuf.StringValue.toObject(message.userInterestParent, options);
                            if (message.launchedToAll != null && message.hasOwnProperty("launchedToAll"))
                                object.launchedToAll = $root.google.protobuf.BoolValue.toObject(message.launchedToAll, options);
                            if (message.availabilities && message.availabilities.length) {
                                object.availabilities = [];
                                for (var j = 0; j < message.availabilities.length; ++j)
                                    object.availabilities[j] = $root.google.ads.googleads.v1.common.CriterionCategoryAvailability.toObject(message.availabilities[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this UserInterest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.UserInterest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserInterest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UserInterest;
                    })();

                    resources.UserList = (function() {

                        /**
                         * Properties of a UserList.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IUserList
                         * @property {string|null} [resourceName] UserList resourceName
                         * @property {google.protobuf.IInt64Value|null} [id] UserList id
                         * @property {google.protobuf.IBoolValue|null} [readOnly] UserList readOnly
                         * @property {google.protobuf.IStringValue|null} [name] UserList name
                         * @property {google.protobuf.IStringValue|null} [description] UserList description
                         * @property {google.ads.googleads.v1.enums.UserListMembershipStatusEnum.UserListMembershipStatus|null} [membershipStatus] UserList membershipStatus
                         * @property {google.protobuf.IStringValue|null} [integrationCode] UserList integrationCode
                         * @property {google.protobuf.IInt64Value|null} [membershipLifeSpan] UserList membershipLifeSpan
                         * @property {google.protobuf.IInt64Value|null} [sizeForDisplay] UserList sizeForDisplay
                         * @property {google.ads.googleads.v1.enums.UserListSizeRangeEnum.UserListSizeRange|null} [sizeRangeForDisplay] UserList sizeRangeForDisplay
                         * @property {google.protobuf.IInt64Value|null} [sizeForSearch] UserList sizeForSearch
                         * @property {google.ads.googleads.v1.enums.UserListSizeRangeEnum.UserListSizeRange|null} [sizeRangeForSearch] UserList sizeRangeForSearch
                         * @property {google.ads.googleads.v1.enums.UserListTypeEnum.UserListType|null} [type] UserList type
                         * @property {google.ads.googleads.v1.enums.UserListClosingReasonEnum.UserListClosingReason|null} [closingReason] UserList closingReason
                         * @property {google.ads.googleads.v1.enums.AccessReasonEnum.AccessReason|null} [accessReason] UserList accessReason
                         * @property {google.ads.googleads.v1.enums.UserListAccessStatusEnum.UserListAccessStatus|null} [accountUserListStatus] UserList accountUserListStatus
                         * @property {google.protobuf.IBoolValue|null} [eligibleForSearch] UserList eligibleForSearch
                         * @property {google.protobuf.IBoolValue|null} [eligibleForDisplay] UserList eligibleForDisplay
                         * @property {google.ads.googleads.v1.common.ICrmBasedUserListInfo|null} [crmBasedUserList] UserList crmBasedUserList
                         * @property {google.ads.googleads.v1.common.ISimilarUserListInfo|null} [similarUserList] UserList similarUserList
                         * @property {google.ads.googleads.v1.common.IRuleBasedUserListInfo|null} [ruleBasedUserList] UserList ruleBasedUserList
                         * @property {google.ads.googleads.v1.common.ILogicalUserListInfo|null} [logicalUserList] UserList logicalUserList
                         * @property {google.ads.googleads.v1.common.IBasicUserListInfo|null} [basicUserList] UserList basicUserList
                         */

                        /**
                         * Constructs a new UserList.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a UserList.
                         * @implements IUserList
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IUserList=} [properties] Properties to set
                         */
                        function UserList(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UserList resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.resourceName = "";

                        /**
                         * UserList id.
                         * @member {google.protobuf.IInt64Value|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.id = null;

                        /**
                         * UserList readOnly.
                         * @member {google.protobuf.IBoolValue|null|undefined} readOnly
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.readOnly = null;

                        /**
                         * UserList name.
                         * @member {google.protobuf.IStringValue|null|undefined} name
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.name = null;

                        /**
                         * UserList description.
                         * @member {google.protobuf.IStringValue|null|undefined} description
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.description = null;

                        /**
                         * UserList membershipStatus.
                         * @member {google.ads.googleads.v1.enums.UserListMembershipStatusEnum.UserListMembershipStatus} membershipStatus
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.membershipStatus = 0;

                        /**
                         * UserList integrationCode.
                         * @member {google.protobuf.IStringValue|null|undefined} integrationCode
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.integrationCode = null;

                        /**
                         * UserList membershipLifeSpan.
                         * @member {google.protobuf.IInt64Value|null|undefined} membershipLifeSpan
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.membershipLifeSpan = null;

                        /**
                         * UserList sizeForDisplay.
                         * @member {google.protobuf.IInt64Value|null|undefined} sizeForDisplay
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.sizeForDisplay = null;

                        /**
                         * UserList sizeRangeForDisplay.
                         * @member {google.ads.googleads.v1.enums.UserListSizeRangeEnum.UserListSizeRange} sizeRangeForDisplay
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.sizeRangeForDisplay = 0;

                        /**
                         * UserList sizeForSearch.
                         * @member {google.protobuf.IInt64Value|null|undefined} sizeForSearch
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.sizeForSearch = null;

                        /**
                         * UserList sizeRangeForSearch.
                         * @member {google.ads.googleads.v1.enums.UserListSizeRangeEnum.UserListSizeRange} sizeRangeForSearch
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.sizeRangeForSearch = 0;

                        /**
                         * UserList type.
                         * @member {google.ads.googleads.v1.enums.UserListTypeEnum.UserListType} type
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.type = 0;

                        /**
                         * UserList closingReason.
                         * @member {google.ads.googleads.v1.enums.UserListClosingReasonEnum.UserListClosingReason} closingReason
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.closingReason = 0;

                        /**
                         * UserList accessReason.
                         * @member {google.ads.googleads.v1.enums.AccessReasonEnum.AccessReason} accessReason
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.accessReason = 0;

                        /**
                         * UserList accountUserListStatus.
                         * @member {google.ads.googleads.v1.enums.UserListAccessStatusEnum.UserListAccessStatus} accountUserListStatus
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.accountUserListStatus = 0;

                        /**
                         * UserList eligibleForSearch.
                         * @member {google.protobuf.IBoolValue|null|undefined} eligibleForSearch
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.eligibleForSearch = null;

                        /**
                         * UserList eligibleForDisplay.
                         * @member {google.protobuf.IBoolValue|null|undefined} eligibleForDisplay
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.eligibleForDisplay = null;

                        /**
                         * UserList crmBasedUserList.
                         * @member {google.ads.googleads.v1.common.ICrmBasedUserListInfo|null|undefined} crmBasedUserList
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.crmBasedUserList = null;

                        /**
                         * UserList similarUserList.
                         * @member {google.ads.googleads.v1.common.ISimilarUserListInfo|null|undefined} similarUserList
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.similarUserList = null;

                        /**
                         * UserList ruleBasedUserList.
                         * @member {google.ads.googleads.v1.common.IRuleBasedUserListInfo|null|undefined} ruleBasedUserList
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.ruleBasedUserList = null;

                        /**
                         * UserList logicalUserList.
                         * @member {google.ads.googleads.v1.common.ILogicalUserListInfo|null|undefined} logicalUserList
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.logicalUserList = null;

                        /**
                         * UserList basicUserList.
                         * @member {google.ads.googleads.v1.common.IBasicUserListInfo|null|undefined} basicUserList
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        UserList.prototype.basicUserList = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * UserList userList.
                         * @member {"crmBasedUserList"|"similarUserList"|"ruleBasedUserList"|"logicalUserList"|"basicUserList"|undefined} userList
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         */
                        Object.defineProperty(UserList.prototype, "userList", {
                            get: $util.oneOfGetter($oneOfFields = ["crmBasedUserList", "similarUserList", "ruleBasedUserList", "logicalUserList", "basicUserList"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new UserList instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @static
                         * @param {google.ads.googleads.v1.resources.IUserList=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.UserList} UserList instance
                         */
                        UserList.create = function create(properties) {
                            return new UserList(properties);
                        };

                        /**
                         * Encodes the specified UserList message. Does not implicitly {@link google.ads.googleads.v1.resources.UserList.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @static
                         * @param {google.ads.googleads.v1.resources.IUserList} message UserList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.Int64Value.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.readOnly != null && message.hasOwnProperty("readOnly"))
                                $root.google.protobuf.BoolValue.encode(message.readOnly, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.name != null && message.hasOwnProperty("name"))
                                $root.google.protobuf.StringValue.encode(message.name, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.description != null && message.hasOwnProperty("description"))
                                $root.google.protobuf.StringValue.encode(message.description, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.membershipStatus != null && message.hasOwnProperty("membershipStatus"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.membershipStatus);
                            if (message.integrationCode != null && message.hasOwnProperty("integrationCode"))
                                $root.google.protobuf.StringValue.encode(message.integrationCode, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.membershipLifeSpan != null && message.hasOwnProperty("membershipLifeSpan"))
                                $root.google.protobuf.Int64Value.encode(message.membershipLifeSpan, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.sizeForDisplay != null && message.hasOwnProperty("sizeForDisplay"))
                                $root.google.protobuf.Int64Value.encode(message.sizeForDisplay, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            if (message.sizeRangeForDisplay != null && message.hasOwnProperty("sizeRangeForDisplay"))
                                writer.uint32(/* id 10, wireType 0 =*/80).int32(message.sizeRangeForDisplay);
                            if (message.sizeForSearch != null && message.hasOwnProperty("sizeForSearch"))
                                $root.google.protobuf.Int64Value.encode(message.sizeForSearch, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.sizeRangeForSearch != null && message.hasOwnProperty("sizeRangeForSearch"))
                                writer.uint32(/* id 12, wireType 0 =*/96).int32(message.sizeRangeForSearch);
                            if (message.type != null && message.hasOwnProperty("type"))
                                writer.uint32(/* id 13, wireType 0 =*/104).int32(message.type);
                            if (message.closingReason != null && message.hasOwnProperty("closingReason"))
                                writer.uint32(/* id 14, wireType 0 =*/112).int32(message.closingReason);
                            if (message.accessReason != null && message.hasOwnProperty("accessReason"))
                                writer.uint32(/* id 15, wireType 0 =*/120).int32(message.accessReason);
                            if (message.accountUserListStatus != null && message.hasOwnProperty("accountUserListStatus"))
                                writer.uint32(/* id 16, wireType 0 =*/128).int32(message.accountUserListStatus);
                            if (message.eligibleForSearch != null && message.hasOwnProperty("eligibleForSearch"))
                                $root.google.protobuf.BoolValue.encode(message.eligibleForSearch, writer.uint32(/* id 17, wireType 2 =*/138).fork()).ldelim();
                            if (message.eligibleForDisplay != null && message.hasOwnProperty("eligibleForDisplay"))
                                $root.google.protobuf.BoolValue.encode(message.eligibleForDisplay, writer.uint32(/* id 18, wireType 2 =*/146).fork()).ldelim();
                            if (message.crmBasedUserList != null && message.hasOwnProperty("crmBasedUserList"))
                                $root.google.ads.googleads.v1.common.CrmBasedUserListInfo.encode(message.crmBasedUserList, writer.uint32(/* id 19, wireType 2 =*/154).fork()).ldelim();
                            if (message.similarUserList != null && message.hasOwnProperty("similarUserList"))
                                $root.google.ads.googleads.v1.common.SimilarUserListInfo.encode(message.similarUserList, writer.uint32(/* id 20, wireType 2 =*/162).fork()).ldelim();
                            if (message.ruleBasedUserList != null && message.hasOwnProperty("ruleBasedUserList"))
                                $root.google.ads.googleads.v1.common.RuleBasedUserListInfo.encode(message.ruleBasedUserList, writer.uint32(/* id 21, wireType 2 =*/170).fork()).ldelim();
                            if (message.logicalUserList != null && message.hasOwnProperty("logicalUserList"))
                                $root.google.ads.googleads.v1.common.LogicalUserListInfo.encode(message.logicalUserList, writer.uint32(/* id 22, wireType 2 =*/178).fork()).ldelim();
                            if (message.basicUserList != null && message.hasOwnProperty("basicUserList"))
                                $root.google.ads.googleads.v1.common.BasicUserListInfo.encode(message.basicUserList, writer.uint32(/* id 23, wireType 2 =*/186).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserList message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.UserList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @static
                         * @param {google.ads.googleads.v1.resources.IUserList} message UserList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.UserList} UserList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.UserList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.readOnly = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.name = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.description = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.membershipStatus = reader.int32();
                                    break;
                                case 7:
                                    message.integrationCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.membershipLifeSpan = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.sizeForDisplay = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.sizeRangeForDisplay = reader.int32();
                                    break;
                                case 11:
                                    message.sizeForSearch = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.sizeRangeForSearch = reader.int32();
                                    break;
                                case 13:
                                    message.type = reader.int32();
                                    break;
                                case 14:
                                    message.closingReason = reader.int32();
                                    break;
                                case 15:
                                    message.accessReason = reader.int32();
                                    break;
                                case 16:
                                    message.accountUserListStatus = reader.int32();
                                    break;
                                case 17:
                                    message.eligibleForSearch = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 18:
                                    message.eligibleForDisplay = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                    break;
                                case 19:
                                    message.crmBasedUserList = $root.google.ads.googleads.v1.common.CrmBasedUserListInfo.decode(reader, reader.uint32());
                                    break;
                                case 20:
                                    message.similarUserList = $root.google.ads.googleads.v1.common.SimilarUserListInfo.decode(reader, reader.uint32());
                                    break;
                                case 21:
                                    message.ruleBasedUserList = $root.google.ads.googleads.v1.common.RuleBasedUserListInfo.decode(reader, reader.uint32());
                                    break;
                                case 22:
                                    message.logicalUserList = $root.google.ads.googleads.v1.common.LogicalUserListInfo.decode(reader, reader.uint32());
                                    break;
                                case 23:
                                    message.basicUserList = $root.google.ads.googleads.v1.common.BasicUserListInfo.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.UserList} UserList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserList message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.readOnly != null && message.hasOwnProperty("readOnly")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.readOnly);
                                if (error)
                                    return "readOnly." + error;
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                var error = $root.google.protobuf.StringValue.verify(message.name);
                                if (error)
                                    return "name." + error;
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                var error = $root.google.protobuf.StringValue.verify(message.description);
                                if (error)
                                    return "description." + error;
                            }
                            if (message.membershipStatus != null && message.hasOwnProperty("membershipStatus"))
                                switch (message.membershipStatus) {
                                default:
                                    return "membershipStatus: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.integrationCode != null && message.hasOwnProperty("integrationCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.integrationCode);
                                if (error)
                                    return "integrationCode." + error;
                            }
                            if (message.membershipLifeSpan != null && message.hasOwnProperty("membershipLifeSpan")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.membershipLifeSpan);
                                if (error)
                                    return "membershipLifeSpan." + error;
                            }
                            if (message.sizeForDisplay != null && message.hasOwnProperty("sizeForDisplay")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.sizeForDisplay);
                                if (error)
                                    return "sizeForDisplay." + error;
                            }
                            if (message.sizeRangeForDisplay != null && message.hasOwnProperty("sizeRangeForDisplay"))
                                switch (message.sizeRangeForDisplay) {
                                default:
                                    return "sizeRangeForDisplay: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                    break;
                                }
                            if (message.sizeForSearch != null && message.hasOwnProperty("sizeForSearch")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.sizeForSearch);
                                if (error)
                                    return "sizeForSearch." + error;
                            }
                            if (message.sizeRangeForSearch != null && message.hasOwnProperty("sizeRangeForSearch"))
                                switch (message.sizeRangeForSearch) {
                                default:
                                    return "sizeRangeForSearch: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                    break;
                                }
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            if (message.closingReason != null && message.hasOwnProperty("closingReason"))
                                switch (message.closingReason) {
                                default:
                                    return "closingReason: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            if (message.accessReason != null && message.hasOwnProperty("accessReason"))
                                switch (message.accessReason) {
                                default:
                                    return "accessReason: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            if (message.accountUserListStatus != null && message.hasOwnProperty("accountUserListStatus"))
                                switch (message.accountUserListStatus) {
                                default:
                                    return "accountUserListStatus: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.eligibleForSearch != null && message.hasOwnProperty("eligibleForSearch")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.eligibleForSearch);
                                if (error)
                                    return "eligibleForSearch." + error;
                            }
                            if (message.eligibleForDisplay != null && message.hasOwnProperty("eligibleForDisplay")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.eligibleForDisplay);
                                if (error)
                                    return "eligibleForDisplay." + error;
                            }
                            if (message.crmBasedUserList != null && message.hasOwnProperty("crmBasedUserList")) {
                                properties.userList = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.CrmBasedUserListInfo.verify(message.crmBasedUserList);
                                    if (error)
                                        return "crmBasedUserList." + error;
                                }
                            }
                            if (message.similarUserList != null && message.hasOwnProperty("similarUserList")) {
                                if (properties.userList === 1)
                                    return "userList: multiple values";
                                properties.userList = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.SimilarUserListInfo.verify(message.similarUserList);
                                    if (error)
                                        return "similarUserList." + error;
                                }
                            }
                            if (message.ruleBasedUserList != null && message.hasOwnProperty("ruleBasedUserList")) {
                                if (properties.userList === 1)
                                    return "userList: multiple values";
                                properties.userList = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.RuleBasedUserListInfo.verify(message.ruleBasedUserList);
                                    if (error)
                                        return "ruleBasedUserList." + error;
                                }
                            }
                            if (message.logicalUserList != null && message.hasOwnProperty("logicalUserList")) {
                                if (properties.userList === 1)
                                    return "userList: multiple values";
                                properties.userList = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.LogicalUserListInfo.verify(message.logicalUserList);
                                    if (error)
                                        return "logicalUserList." + error;
                                }
                            }
                            if (message.basicUserList != null && message.hasOwnProperty("basicUserList")) {
                                if (properties.userList === 1)
                                    return "userList: multiple values";
                                properties.userList = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.common.BasicUserListInfo.verify(message.basicUserList);
                                    if (error)
                                        return "basicUserList." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a UserList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.UserList} UserList
                         */
                        UserList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.UserList)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.UserList();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserList.id: object expected");
                                message.id = $root.google.protobuf.Int64Value.fromObject(object.id);
                            }
                            if (object.readOnly != null) {
                                if (typeof object.readOnly !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserList.readOnly: object expected");
                                message.readOnly = $root.google.protobuf.BoolValue.fromObject(object.readOnly);
                            }
                            if (object.name != null) {
                                if (typeof object.name !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserList.name: object expected");
                                message.name = $root.google.protobuf.StringValue.fromObject(object.name);
                            }
                            if (object.description != null) {
                                if (typeof object.description !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserList.description: object expected");
                                message.description = $root.google.protobuf.StringValue.fromObject(object.description);
                            }
                            switch (object.membershipStatus) {
                            case "UNSPECIFIED":
                            case 0:
                                message.membershipStatus = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.membershipStatus = 1;
                                break;
                            case "OPEN":
                            case 2:
                                message.membershipStatus = 2;
                                break;
                            case "CLOSED":
                            case 3:
                                message.membershipStatus = 3;
                                break;
                            }
                            if (object.integrationCode != null) {
                                if (typeof object.integrationCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserList.integrationCode: object expected");
                                message.integrationCode = $root.google.protobuf.StringValue.fromObject(object.integrationCode);
                            }
                            if (object.membershipLifeSpan != null) {
                                if (typeof object.membershipLifeSpan !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserList.membershipLifeSpan: object expected");
                                message.membershipLifeSpan = $root.google.protobuf.Int64Value.fromObject(object.membershipLifeSpan);
                            }
                            if (object.sizeForDisplay != null) {
                                if (typeof object.sizeForDisplay !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserList.sizeForDisplay: object expected");
                                message.sizeForDisplay = $root.google.protobuf.Int64Value.fromObject(object.sizeForDisplay);
                            }
                            switch (object.sizeRangeForDisplay) {
                            case "UNSPECIFIED":
                            case 0:
                                message.sizeRangeForDisplay = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.sizeRangeForDisplay = 1;
                                break;
                            case "LESS_THAN_FIVE_HUNDRED":
                            case 2:
                                message.sizeRangeForDisplay = 2;
                                break;
                            case "LESS_THAN_ONE_THOUSAND":
                            case 3:
                                message.sizeRangeForDisplay = 3;
                                break;
                            case "ONE_THOUSAND_TO_TEN_THOUSAND":
                            case 4:
                                message.sizeRangeForDisplay = 4;
                                break;
                            case "TEN_THOUSAND_TO_FIFTY_THOUSAND":
                            case 5:
                                message.sizeRangeForDisplay = 5;
                                break;
                            case "FIFTY_THOUSAND_TO_ONE_HUNDRED_THOUSAND":
                            case 6:
                                message.sizeRangeForDisplay = 6;
                                break;
                            case "ONE_HUNDRED_THOUSAND_TO_THREE_HUNDRED_THOUSAND":
                            case 7:
                                message.sizeRangeForDisplay = 7;
                                break;
                            case "THREE_HUNDRED_THOUSAND_TO_FIVE_HUNDRED_THOUSAND":
                            case 8:
                                message.sizeRangeForDisplay = 8;
                                break;
                            case "FIVE_HUNDRED_THOUSAND_TO_ONE_MILLION":
                            case 9:
                                message.sizeRangeForDisplay = 9;
                                break;
                            case "ONE_MILLION_TO_TWO_MILLION":
                            case 10:
                                message.sizeRangeForDisplay = 10;
                                break;
                            case "TWO_MILLION_TO_THREE_MILLION":
                            case 11:
                                message.sizeRangeForDisplay = 11;
                                break;
                            case "THREE_MILLION_TO_FIVE_MILLION":
                            case 12:
                                message.sizeRangeForDisplay = 12;
                                break;
                            case "FIVE_MILLION_TO_TEN_MILLION":
                            case 13:
                                message.sizeRangeForDisplay = 13;
                                break;
                            case "TEN_MILLION_TO_TWENTY_MILLION":
                            case 14:
                                message.sizeRangeForDisplay = 14;
                                break;
                            case "TWENTY_MILLION_TO_THIRTY_MILLION":
                            case 15:
                                message.sizeRangeForDisplay = 15;
                                break;
                            case "THIRTY_MILLION_TO_FIFTY_MILLION":
                            case 16:
                                message.sizeRangeForDisplay = 16;
                                break;
                            case "OVER_FIFTY_MILLION":
                            case 17:
                                message.sizeRangeForDisplay = 17;
                                break;
                            }
                            if (object.sizeForSearch != null) {
                                if (typeof object.sizeForSearch !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserList.sizeForSearch: object expected");
                                message.sizeForSearch = $root.google.protobuf.Int64Value.fromObject(object.sizeForSearch);
                            }
                            switch (object.sizeRangeForSearch) {
                            case "UNSPECIFIED":
                            case 0:
                                message.sizeRangeForSearch = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.sizeRangeForSearch = 1;
                                break;
                            case "LESS_THAN_FIVE_HUNDRED":
                            case 2:
                                message.sizeRangeForSearch = 2;
                                break;
                            case "LESS_THAN_ONE_THOUSAND":
                            case 3:
                                message.sizeRangeForSearch = 3;
                                break;
                            case "ONE_THOUSAND_TO_TEN_THOUSAND":
                            case 4:
                                message.sizeRangeForSearch = 4;
                                break;
                            case "TEN_THOUSAND_TO_FIFTY_THOUSAND":
                            case 5:
                                message.sizeRangeForSearch = 5;
                                break;
                            case "FIFTY_THOUSAND_TO_ONE_HUNDRED_THOUSAND":
                            case 6:
                                message.sizeRangeForSearch = 6;
                                break;
                            case "ONE_HUNDRED_THOUSAND_TO_THREE_HUNDRED_THOUSAND":
                            case 7:
                                message.sizeRangeForSearch = 7;
                                break;
                            case "THREE_HUNDRED_THOUSAND_TO_FIVE_HUNDRED_THOUSAND":
                            case 8:
                                message.sizeRangeForSearch = 8;
                                break;
                            case "FIVE_HUNDRED_THOUSAND_TO_ONE_MILLION":
                            case 9:
                                message.sizeRangeForSearch = 9;
                                break;
                            case "ONE_MILLION_TO_TWO_MILLION":
                            case 10:
                                message.sizeRangeForSearch = 10;
                                break;
                            case "TWO_MILLION_TO_THREE_MILLION":
                            case 11:
                                message.sizeRangeForSearch = 11;
                                break;
                            case "THREE_MILLION_TO_FIVE_MILLION":
                            case 12:
                                message.sizeRangeForSearch = 12;
                                break;
                            case "FIVE_MILLION_TO_TEN_MILLION":
                            case 13:
                                message.sizeRangeForSearch = 13;
                                break;
                            case "TEN_MILLION_TO_TWENTY_MILLION":
                            case 14:
                                message.sizeRangeForSearch = 14;
                                break;
                            case "TWENTY_MILLION_TO_THIRTY_MILLION":
                            case 15:
                                message.sizeRangeForSearch = 15;
                                break;
                            case "THIRTY_MILLION_TO_FIFTY_MILLION":
                            case 16:
                                message.sizeRangeForSearch = 16;
                                break;
                            case "OVER_FIFTY_MILLION":
                            case 17:
                                message.sizeRangeForSearch = 17;
                                break;
                            }
                            switch (object.type) {
                            case "UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.type = 1;
                                break;
                            case "REMARKETING":
                            case 2:
                                message.type = 2;
                                break;
                            case "LOGICAL":
                            case 3:
                                message.type = 3;
                                break;
                            case "EXTERNAL_REMARKETING":
                            case 4:
                                message.type = 4;
                                break;
                            case "RULE_BASED":
                            case 5:
                                message.type = 5;
                                break;
                            case "SIMILAR":
                            case 6:
                                message.type = 6;
                                break;
                            case "CRM_BASED":
                            case 7:
                                message.type = 7;
                                break;
                            }
                            switch (object.closingReason) {
                            case "UNSPECIFIED":
                            case 0:
                                message.closingReason = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.closingReason = 1;
                                break;
                            case "UNUSED":
                            case 2:
                                message.closingReason = 2;
                                break;
                            }
                            switch (object.accessReason) {
                            case "UNSPECIFIED":
                            case 0:
                                message.accessReason = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.accessReason = 1;
                                break;
                            case "OWNED":
                            case 2:
                                message.accessReason = 2;
                                break;
                            case "SHARED":
                            case 3:
                                message.accessReason = 3;
                                break;
                            case "LICENSED":
                            case 4:
                                message.accessReason = 4;
                                break;
                            case "SUBSCRIBED":
                            case 5:
                                message.accessReason = 5;
                                break;
                            case "AFFILIATED":
                            case 6:
                                message.accessReason = 6;
                                break;
                            }
                            switch (object.accountUserListStatus) {
                            case "UNSPECIFIED":
                            case 0:
                                message.accountUserListStatus = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.accountUserListStatus = 1;
                                break;
                            case "ENABLED":
                            case 2:
                                message.accountUserListStatus = 2;
                                break;
                            case "DISABLED":
                            case 3:
                                message.accountUserListStatus = 3;
                                break;
                            }
                            if (object.eligibleForSearch != null) {
                                if (typeof object.eligibleForSearch !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserList.eligibleForSearch: object expected");
                                message.eligibleForSearch = $root.google.protobuf.BoolValue.fromObject(object.eligibleForSearch);
                            }
                            if (object.eligibleForDisplay != null) {
                                if (typeof object.eligibleForDisplay !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserList.eligibleForDisplay: object expected");
                                message.eligibleForDisplay = $root.google.protobuf.BoolValue.fromObject(object.eligibleForDisplay);
                            }
                            if (object.crmBasedUserList != null) {
                                if (typeof object.crmBasedUserList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserList.crmBasedUserList: object expected");
                                message.crmBasedUserList = $root.google.ads.googleads.v1.common.CrmBasedUserListInfo.fromObject(object.crmBasedUserList);
                            }
                            if (object.similarUserList != null) {
                                if (typeof object.similarUserList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserList.similarUserList: object expected");
                                message.similarUserList = $root.google.ads.googleads.v1.common.SimilarUserListInfo.fromObject(object.similarUserList);
                            }
                            if (object.ruleBasedUserList != null) {
                                if (typeof object.ruleBasedUserList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserList.ruleBasedUserList: object expected");
                                message.ruleBasedUserList = $root.google.ads.googleads.v1.common.RuleBasedUserListInfo.fromObject(object.ruleBasedUserList);
                            }
                            if (object.logicalUserList != null) {
                                if (typeof object.logicalUserList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserList.logicalUserList: object expected");
                                message.logicalUserList = $root.google.ads.googleads.v1.common.LogicalUserListInfo.fromObject(object.logicalUserList);
                            }
                            if (object.basicUserList != null) {
                                if (typeof object.basicUserList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.UserList.basicUserList: object expected");
                                message.basicUserList = $root.google.ads.googleads.v1.common.BasicUserListInfo.fromObject(object.basicUserList);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a UserList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @static
                         * @param {google.ads.googleads.v1.resources.UserList} message UserList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.readOnly = null;
                                object.name = null;
                                object.description = null;
                                object.membershipStatus = options.enums === String ? "UNSPECIFIED" : 0;
                                object.integrationCode = null;
                                object.membershipLifeSpan = null;
                                object.sizeForDisplay = null;
                                object.sizeRangeForDisplay = options.enums === String ? "UNSPECIFIED" : 0;
                                object.sizeForSearch = null;
                                object.sizeRangeForSearch = options.enums === String ? "UNSPECIFIED" : 0;
                                object.type = options.enums === String ? "UNSPECIFIED" : 0;
                                object.closingReason = options.enums === String ? "UNSPECIFIED" : 0;
                                object.accessReason = options.enums === String ? "UNSPECIFIED" : 0;
                                object.accountUserListStatus = options.enums === String ? "UNSPECIFIED" : 0;
                                object.eligibleForSearch = null;
                                object.eligibleForDisplay = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.Int64Value.toObject(message.id, options);
                            if (message.readOnly != null && message.hasOwnProperty("readOnly"))
                                object.readOnly = $root.google.protobuf.BoolValue.toObject(message.readOnly, options);
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = $root.google.protobuf.StringValue.toObject(message.name, options);
                            if (message.description != null && message.hasOwnProperty("description"))
                                object.description = $root.google.protobuf.StringValue.toObject(message.description, options);
                            if (message.membershipStatus != null && message.hasOwnProperty("membershipStatus"))
                                object.membershipStatus = options.enums === String ? $root.google.ads.googleads.v1.enums.UserListMembershipStatusEnum.UserListMembershipStatus[message.membershipStatus] : message.membershipStatus;
                            if (message.integrationCode != null && message.hasOwnProperty("integrationCode"))
                                object.integrationCode = $root.google.protobuf.StringValue.toObject(message.integrationCode, options);
                            if (message.membershipLifeSpan != null && message.hasOwnProperty("membershipLifeSpan"))
                                object.membershipLifeSpan = $root.google.protobuf.Int64Value.toObject(message.membershipLifeSpan, options);
                            if (message.sizeForDisplay != null && message.hasOwnProperty("sizeForDisplay"))
                                object.sizeForDisplay = $root.google.protobuf.Int64Value.toObject(message.sizeForDisplay, options);
                            if (message.sizeRangeForDisplay != null && message.hasOwnProperty("sizeRangeForDisplay"))
                                object.sizeRangeForDisplay = options.enums === String ? $root.google.ads.googleads.v1.enums.UserListSizeRangeEnum.UserListSizeRange[message.sizeRangeForDisplay] : message.sizeRangeForDisplay;
                            if (message.sizeForSearch != null && message.hasOwnProperty("sizeForSearch"))
                                object.sizeForSearch = $root.google.protobuf.Int64Value.toObject(message.sizeForSearch, options);
                            if (message.sizeRangeForSearch != null && message.hasOwnProperty("sizeRangeForSearch"))
                                object.sizeRangeForSearch = options.enums === String ? $root.google.ads.googleads.v1.enums.UserListSizeRangeEnum.UserListSizeRange[message.sizeRangeForSearch] : message.sizeRangeForSearch;
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.ads.googleads.v1.enums.UserListTypeEnum.UserListType[message.type] : message.type;
                            if (message.closingReason != null && message.hasOwnProperty("closingReason"))
                                object.closingReason = options.enums === String ? $root.google.ads.googleads.v1.enums.UserListClosingReasonEnum.UserListClosingReason[message.closingReason] : message.closingReason;
                            if (message.accessReason != null && message.hasOwnProperty("accessReason"))
                                object.accessReason = options.enums === String ? $root.google.ads.googleads.v1.enums.AccessReasonEnum.AccessReason[message.accessReason] : message.accessReason;
                            if (message.accountUserListStatus != null && message.hasOwnProperty("accountUserListStatus"))
                                object.accountUserListStatus = options.enums === String ? $root.google.ads.googleads.v1.enums.UserListAccessStatusEnum.UserListAccessStatus[message.accountUserListStatus] : message.accountUserListStatus;
                            if (message.eligibleForSearch != null && message.hasOwnProperty("eligibleForSearch"))
                                object.eligibleForSearch = $root.google.protobuf.BoolValue.toObject(message.eligibleForSearch, options);
                            if (message.eligibleForDisplay != null && message.hasOwnProperty("eligibleForDisplay"))
                                object.eligibleForDisplay = $root.google.protobuf.BoolValue.toObject(message.eligibleForDisplay, options);
                            if (message.crmBasedUserList != null && message.hasOwnProperty("crmBasedUserList")) {
                                object.crmBasedUserList = $root.google.ads.googleads.v1.common.CrmBasedUserListInfo.toObject(message.crmBasedUserList, options);
                                if (options.oneofs)
                                    object.userList = "crmBasedUserList";
                            }
                            if (message.similarUserList != null && message.hasOwnProperty("similarUserList")) {
                                object.similarUserList = $root.google.ads.googleads.v1.common.SimilarUserListInfo.toObject(message.similarUserList, options);
                                if (options.oneofs)
                                    object.userList = "similarUserList";
                            }
                            if (message.ruleBasedUserList != null && message.hasOwnProperty("ruleBasedUserList")) {
                                object.ruleBasedUserList = $root.google.ads.googleads.v1.common.RuleBasedUserListInfo.toObject(message.ruleBasedUserList, options);
                                if (options.oneofs)
                                    object.userList = "ruleBasedUserList";
                            }
                            if (message.logicalUserList != null && message.hasOwnProperty("logicalUserList")) {
                                object.logicalUserList = $root.google.ads.googleads.v1.common.LogicalUserListInfo.toObject(message.logicalUserList, options);
                                if (options.oneofs)
                                    object.userList = "logicalUserList";
                            }
                            if (message.basicUserList != null && message.hasOwnProperty("basicUserList")) {
                                object.basicUserList = $root.google.ads.googleads.v1.common.BasicUserListInfo.toObject(message.basicUserList, options);
                                if (options.oneofs)
                                    object.userList = "basicUserList";
                            }
                            return object;
                        };

                        /**
                         * Converts this UserList to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.UserList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UserList;
                    })();

                    resources.Video = (function() {

                        /**
                         * Properties of a Video.
                         * @memberof google.ads.googleads.v1.resources
                         * @interface IVideo
                         * @property {string|null} [resourceName] Video resourceName
                         * @property {google.protobuf.IStringValue|null} [id] Video id
                         * @property {google.protobuf.IStringValue|null} [channelId] Video channelId
                         * @property {google.protobuf.IInt64Value|null} [durationMillis] Video durationMillis
                         * @property {google.protobuf.IStringValue|null} [title] Video title
                         */

                        /**
                         * Constructs a new Video.
                         * @memberof google.ads.googleads.v1.resources
                         * @classdesc Represents a Video.
                         * @implements IVideo
                         * @constructor
                         * @param {google.ads.googleads.v1.resources.IVideo=} [properties] Properties to set
                         */
                        function Video(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Video resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.resources.Video
                         * @instance
                         */
                        Video.prototype.resourceName = "";

                        /**
                         * Video id.
                         * @member {google.protobuf.IStringValue|null|undefined} id
                         * @memberof google.ads.googleads.v1.resources.Video
                         * @instance
                         */
                        Video.prototype.id = null;

                        /**
                         * Video channelId.
                         * @member {google.protobuf.IStringValue|null|undefined} channelId
                         * @memberof google.ads.googleads.v1.resources.Video
                         * @instance
                         */
                        Video.prototype.channelId = null;

                        /**
                         * Video durationMillis.
                         * @member {google.protobuf.IInt64Value|null|undefined} durationMillis
                         * @memberof google.ads.googleads.v1.resources.Video
                         * @instance
                         */
                        Video.prototype.durationMillis = null;

                        /**
                         * Video title.
                         * @member {google.protobuf.IStringValue|null|undefined} title
                         * @memberof google.ads.googleads.v1.resources.Video
                         * @instance
                         */
                        Video.prototype.title = null;

                        /**
                         * Creates a new Video instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.resources.Video
                         * @static
                         * @param {google.ads.googleads.v1.resources.IVideo=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.resources.Video} Video instance
                         */
                        Video.create = function create(properties) {
                            return new Video(properties);
                        };

                        /**
                         * Encodes the specified Video message. Does not implicitly {@link google.ads.googleads.v1.resources.Video.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.resources.Video
                         * @static
                         * @param {google.ads.googleads.v1.resources.IVideo} message Video message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Video.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.id != null && message.hasOwnProperty("id"))
                                $root.google.protobuf.StringValue.encode(message.id, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.channelId != null && message.hasOwnProperty("channelId"))
                                $root.google.protobuf.StringValue.encode(message.channelId, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.durationMillis != null && message.hasOwnProperty("durationMillis"))
                                $root.google.protobuf.Int64Value.encode(message.durationMillis, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.title != null && message.hasOwnProperty("title"))
                                $root.google.protobuf.StringValue.encode(message.title, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified Video message, length delimited. Does not implicitly {@link google.ads.googleads.v1.resources.Video.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.resources.Video
                         * @static
                         * @param {google.ads.googleads.v1.resources.IVideo} message Video message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Video.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a Video message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.resources.Video
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.resources.Video} Video
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Video.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.resources.Video();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.id = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.channelId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.durationMillis = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.title = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a Video message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.resources.Video
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.resources.Video} Video
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Video.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a Video message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.resources.Video
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Video.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.id != null && message.hasOwnProperty("id")) {
                                var error = $root.google.protobuf.StringValue.verify(message.id);
                                if (error)
                                    return "id." + error;
                            }
                            if (message.channelId != null && message.hasOwnProperty("channelId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.channelId);
                                if (error)
                                    return "channelId." + error;
                            }
                            if (message.durationMillis != null && message.hasOwnProperty("durationMillis")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.durationMillis);
                                if (error)
                                    return "durationMillis." + error;
                            }
                            if (message.title != null && message.hasOwnProperty("title")) {
                                var error = $root.google.protobuf.StringValue.verify(message.title);
                                if (error)
                                    return "title." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a Video message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.resources.Video
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.resources.Video} Video
                         */
                        Video.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.resources.Video)
                                return object;
                            var message = new $root.google.ads.googleads.v1.resources.Video();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.id != null) {
                                if (typeof object.id !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Video.id: object expected");
                                message.id = $root.google.protobuf.StringValue.fromObject(object.id);
                            }
                            if (object.channelId != null) {
                                if (typeof object.channelId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Video.channelId: object expected");
                                message.channelId = $root.google.protobuf.StringValue.fromObject(object.channelId);
                            }
                            if (object.durationMillis != null) {
                                if (typeof object.durationMillis !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Video.durationMillis: object expected");
                                message.durationMillis = $root.google.protobuf.Int64Value.fromObject(object.durationMillis);
                            }
                            if (object.title != null) {
                                if (typeof object.title !== "object")
                                    throw TypeError(".google.ads.googleads.v1.resources.Video.title: object expected");
                                message.title = $root.google.protobuf.StringValue.fromObject(object.title);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a Video message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.resources.Video
                         * @static
                         * @param {google.ads.googleads.v1.resources.Video} message Video
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Video.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.id = null;
                                object.channelId = null;
                                object.durationMillis = null;
                                object.title = null;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = $root.google.protobuf.StringValue.toObject(message.id, options);
                            if (message.channelId != null && message.hasOwnProperty("channelId"))
                                object.channelId = $root.google.protobuf.StringValue.toObject(message.channelId, options);
                            if (message.durationMillis != null && message.hasOwnProperty("durationMillis"))
                                object.durationMillis = $root.google.protobuf.Int64Value.toObject(message.durationMillis, options);
                            if (message.title != null && message.hasOwnProperty("title"))
                                object.title = $root.google.protobuf.StringValue.toObject(message.title, options);
                            return object;
                        };

                        /**
                         * Converts this Video to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.resources.Video
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Video.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return Video;
                    })();

                    return resources;
                })();

                v1.services = (function() {

                    /**
                     * Namespace services.
                     * @memberof google.ads.googleads.v1
                     * @namespace
                     */
                    var services = {};

                    services.AccountBudgetProposalService = (function() {

                        /**
                         * Constructs a new AccountBudgetProposalService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AccountBudgetProposalService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AccountBudgetProposalService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (AccountBudgetProposalService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AccountBudgetProposalService;

                        /**
                         * Creates new AccountBudgetProposalService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AccountBudgetProposalService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AccountBudgetProposalService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AccountBudgetProposalService#getAccountBudgetProposal}.
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalService
                         * @typedef GetAccountBudgetProposalCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.AccountBudgetProposal} [response] AccountBudgetProposal
                         */

                        /**
                         * Calls GetAccountBudgetProposal.
                         * @function getAccountBudgetProposal
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAccountBudgetProposalRequest} request GetAccountBudgetProposalRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AccountBudgetProposalService.GetAccountBudgetProposalCallback} callback Node-style callback called with the error, if any, and AccountBudgetProposal
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AccountBudgetProposalService.prototype.getAccountBudgetProposal = function getAccountBudgetProposal(request, callback) {
                            return this.rpcCall(getAccountBudgetProposal, $root.google.ads.googleads.v1.services.GetAccountBudgetProposalRequest, $root.google.ads.googleads.v1.resources.AccountBudgetProposal, request, callback);
                        }, "name", { value: "GetAccountBudgetProposal" });

                        /**
                         * Calls GetAccountBudgetProposal.
                         * @function getAccountBudgetProposal
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAccountBudgetProposalRequest} request GetAccountBudgetProposalRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.AccountBudgetProposal>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AccountBudgetProposalService#mutateAccountBudgetProposal}.
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalService
                         * @typedef MutateAccountBudgetProposalCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse} [response] MutateAccountBudgetProposalResponse
                         */

                        /**
                         * Calls MutateAccountBudgetProposal.
                         * @function mutateAccountBudgetProposal
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAccountBudgetProposalRequest} request MutateAccountBudgetProposalRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AccountBudgetProposalService.MutateAccountBudgetProposalCallback} callback Node-style callback called with the error, if any, and MutateAccountBudgetProposalResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AccountBudgetProposalService.prototype.mutateAccountBudgetProposal = function mutateAccountBudgetProposal(request, callback) {
                            return this.rpcCall(mutateAccountBudgetProposal, $root.google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest, $root.google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse, request, callback);
                        }, "name", { value: "MutateAccountBudgetProposal" });

                        /**
                         * Calls MutateAccountBudgetProposal.
                         * @function mutateAccountBudgetProposal
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAccountBudgetProposalRequest} request MutateAccountBudgetProposalRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse>} Promise
                         * @variation 2
                         */

                        return AccountBudgetProposalService;
                    })();

                    services.GetAccountBudgetProposalRequest = (function() {

                        /**
                         * Properties of a GetAccountBudgetProposalRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetAccountBudgetProposalRequest
                         * @property {string|null} [resourceName] GetAccountBudgetProposalRequest resourceName
                         */

                        /**
                         * Constructs a new GetAccountBudgetProposalRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetAccountBudgetProposalRequest.
                         * @implements IGetAccountBudgetProposalRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetAccountBudgetProposalRequest=} [properties] Properties to set
                         */
                        function GetAccountBudgetProposalRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetAccountBudgetProposalRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetProposalRequest
                         * @instance
                         */
                        GetAccountBudgetProposalRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetAccountBudgetProposalRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetProposalRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAccountBudgetProposalRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetAccountBudgetProposalRequest} GetAccountBudgetProposalRequest instance
                         */
                        GetAccountBudgetProposalRequest.create = function create(properties) {
                            return new GetAccountBudgetProposalRequest(properties);
                        };

                        /**
                         * Encodes the specified GetAccountBudgetProposalRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetAccountBudgetProposalRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetProposalRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAccountBudgetProposalRequest} message GetAccountBudgetProposalRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAccountBudgetProposalRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetAccountBudgetProposalRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetAccountBudgetProposalRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetProposalRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAccountBudgetProposalRequest} message GetAccountBudgetProposalRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAccountBudgetProposalRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetAccountBudgetProposalRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetProposalRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetAccountBudgetProposalRequest} GetAccountBudgetProposalRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAccountBudgetProposalRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetAccountBudgetProposalRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetAccountBudgetProposalRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetProposalRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetAccountBudgetProposalRequest} GetAccountBudgetProposalRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAccountBudgetProposalRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetAccountBudgetProposalRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetProposalRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAccountBudgetProposalRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetAccountBudgetProposalRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetProposalRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetAccountBudgetProposalRequest} GetAccountBudgetProposalRequest
                         */
                        GetAccountBudgetProposalRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetAccountBudgetProposalRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetAccountBudgetProposalRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetAccountBudgetProposalRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetProposalRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetAccountBudgetProposalRequest} message GetAccountBudgetProposalRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAccountBudgetProposalRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetAccountBudgetProposalRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetProposalRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAccountBudgetProposalRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetAccountBudgetProposalRequest;
                    })();

                    services.MutateAccountBudgetProposalRequest = (function() {

                        /**
                         * Properties of a MutateAccountBudgetProposalRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAccountBudgetProposalRequest
                         * @property {string|null} [customerId] MutateAccountBudgetProposalRequest customerId
                         * @property {google.ads.googleads.v1.services.IAccountBudgetProposalOperation|null} [operation] MutateAccountBudgetProposalRequest operation
                         * @property {boolean|null} [validateOnly] MutateAccountBudgetProposalRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateAccountBudgetProposalRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAccountBudgetProposalRequest.
                         * @implements IMutateAccountBudgetProposalRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAccountBudgetProposalRequest=} [properties] Properties to set
                         */
                        function MutateAccountBudgetProposalRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAccountBudgetProposalRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest
                         * @instance
                         */
                        MutateAccountBudgetProposalRequest.prototype.customerId = "";

                        /**
                         * MutateAccountBudgetProposalRequest operation.
                         * @member {google.ads.googleads.v1.services.IAccountBudgetProposalOperation|null|undefined} operation
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest
                         * @instance
                         */
                        MutateAccountBudgetProposalRequest.prototype.operation = null;

                        /**
                         * MutateAccountBudgetProposalRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest
                         * @instance
                         */
                        MutateAccountBudgetProposalRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateAccountBudgetProposalRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAccountBudgetProposalRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest} MutateAccountBudgetProposalRequest instance
                         */
                        MutateAccountBudgetProposalRequest.create = function create(properties) {
                            return new MutateAccountBudgetProposalRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateAccountBudgetProposalRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAccountBudgetProposalRequest} message MutateAccountBudgetProposalRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAccountBudgetProposalRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                $root.google.ads.googleads.v1.services.AccountBudgetProposalOperation.encode(message.operation, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAccountBudgetProposalRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAccountBudgetProposalRequest} message MutateAccountBudgetProposalRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAccountBudgetProposalRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAccountBudgetProposalRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest} MutateAccountBudgetProposalRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAccountBudgetProposalRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    message.operation = $root.google.ads.googleads.v1.services.AccountBudgetProposalOperation.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAccountBudgetProposalRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest} MutateAccountBudgetProposalRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAccountBudgetProposalRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAccountBudgetProposalRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAccountBudgetProposalRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operation != null && message.hasOwnProperty("operation")) {
                                var error = $root.google.ads.googleads.v1.services.AccountBudgetProposalOperation.verify(message.operation);
                                if (error)
                                    return "operation." + error;
                            }
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAccountBudgetProposalRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest} MutateAccountBudgetProposalRequest
                         */
                        MutateAccountBudgetProposalRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operation != null) {
                                if (typeof object.operation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest.operation: object expected");
                                message.operation = $root.google.ads.googleads.v1.services.AccountBudgetProposalOperation.fromObject(object.operation);
                            }
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAccountBudgetProposalRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest} message MutateAccountBudgetProposalRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAccountBudgetProposalRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.customerId = "";
                                object.operation = null;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = $root.google.ads.googleads.v1.services.AccountBudgetProposalOperation.toObject(message.operation, options);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateAccountBudgetProposalRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAccountBudgetProposalRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAccountBudgetProposalRequest;
                    })();

                    services.AccountBudgetProposalOperation = (function() {

                        /**
                         * Properties of an AccountBudgetProposalOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IAccountBudgetProposalOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] AccountBudgetProposalOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IAccountBudgetProposal|null} [create] AccountBudgetProposalOperation create
                         * @property {string|null} [remove] AccountBudgetProposalOperation remove
                         */

                        /**
                         * Constructs a new AccountBudgetProposalOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AccountBudgetProposalOperation.
                         * @implements IAccountBudgetProposalOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IAccountBudgetProposalOperation=} [properties] Properties to set
                         */
                        function AccountBudgetProposalOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AccountBudgetProposalOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalOperation
                         * @instance
                         */
                        AccountBudgetProposalOperation.prototype.updateMask = null;

                        /**
                         * AccountBudgetProposalOperation create.
                         * @member {google.ads.googleads.v1.resources.IAccountBudgetProposal|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalOperation
                         * @instance
                         */
                        AccountBudgetProposalOperation.prototype.create = null;

                        /**
                         * AccountBudgetProposalOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalOperation
                         * @instance
                         */
                        AccountBudgetProposalOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AccountBudgetProposalOperation operation.
                         * @member {"create"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalOperation
                         * @instance
                         */
                        Object.defineProperty(AccountBudgetProposalOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AccountBudgetProposalOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAccountBudgetProposalOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.AccountBudgetProposalOperation} AccountBudgetProposalOperation instance
                         */
                        AccountBudgetProposalOperation.create = function create(properties) {
                            return new AccountBudgetProposalOperation(properties);
                        };

                        /**
                         * Encodes the specified AccountBudgetProposalOperation message. Does not implicitly {@link google.ads.googleads.v1.services.AccountBudgetProposalOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAccountBudgetProposalOperation} message AccountBudgetProposalOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccountBudgetProposalOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.remove);
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.AccountBudgetProposal.encode(message.create, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AccountBudgetProposalOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.AccountBudgetProposalOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAccountBudgetProposalOperation} message AccountBudgetProposalOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccountBudgetProposalOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AccountBudgetProposalOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.AccountBudgetProposalOperation} AccountBudgetProposalOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccountBudgetProposalOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.AccountBudgetProposalOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.create = $root.google.ads.googleads.v1.resources.AccountBudgetProposal.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AccountBudgetProposalOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.AccountBudgetProposalOperation} AccountBudgetProposalOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccountBudgetProposalOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AccountBudgetProposalOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccountBudgetProposalOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.AccountBudgetProposal.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates an AccountBudgetProposalOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.AccountBudgetProposalOperation} AccountBudgetProposalOperation
                         */
                        AccountBudgetProposalOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.AccountBudgetProposalOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.AccountBudgetProposalOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AccountBudgetProposalOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AccountBudgetProposalOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.AccountBudgetProposal.fromObject(object.create);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from an AccountBudgetProposalOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.AccountBudgetProposalOperation} message AccountBudgetProposalOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccountBudgetProposalOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.AccountBudgetProposal.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this AccountBudgetProposalOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.AccountBudgetProposalOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccountBudgetProposalOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AccountBudgetProposalOperation;
                    })();

                    services.MutateAccountBudgetProposalResponse = (function() {

                        /**
                         * Properties of a MutateAccountBudgetProposalResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAccountBudgetProposalResponse
                         * @property {google.ads.googleads.v1.services.IMutateAccountBudgetProposalResult|null} [result] MutateAccountBudgetProposalResponse result
                         */

                        /**
                         * Constructs a new MutateAccountBudgetProposalResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAccountBudgetProposalResponse.
                         * @implements IMutateAccountBudgetProposalResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAccountBudgetProposalResponse=} [properties] Properties to set
                         */
                        function MutateAccountBudgetProposalResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAccountBudgetProposalResponse result.
                         * @member {google.ads.googleads.v1.services.IMutateAccountBudgetProposalResult|null|undefined} result
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse
                         * @instance
                         */
                        MutateAccountBudgetProposalResponse.prototype.result = null;

                        /**
                         * Creates a new MutateAccountBudgetProposalResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAccountBudgetProposalResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse} MutateAccountBudgetProposalResponse instance
                         */
                        MutateAccountBudgetProposalResponse.create = function create(properties) {
                            return new MutateAccountBudgetProposalResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateAccountBudgetProposalResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAccountBudgetProposalResponse} message MutateAccountBudgetProposalResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAccountBudgetProposalResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.result != null && message.hasOwnProperty("result"))
                                $root.google.ads.googleads.v1.services.MutateAccountBudgetProposalResult.encode(message.result, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAccountBudgetProposalResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAccountBudgetProposalResponse} message MutateAccountBudgetProposalResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAccountBudgetProposalResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAccountBudgetProposalResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse} MutateAccountBudgetProposalResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAccountBudgetProposalResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2:
                                    message.result = $root.google.ads.googleads.v1.services.MutateAccountBudgetProposalResult.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAccountBudgetProposalResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse} MutateAccountBudgetProposalResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAccountBudgetProposalResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAccountBudgetProposalResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAccountBudgetProposalResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.result != null && message.hasOwnProperty("result")) {
                                var error = $root.google.ads.googleads.v1.services.MutateAccountBudgetProposalResult.verify(message.result);
                                if (error)
                                    return "result." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateAccountBudgetProposalResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse} MutateAccountBudgetProposalResponse
                         */
                        MutateAccountBudgetProposalResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse();
                            if (object.result != null) {
                                if (typeof object.result !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse.result: object expected");
                                message.result = $root.google.ads.googleads.v1.services.MutateAccountBudgetProposalResult.fromObject(object.result);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAccountBudgetProposalResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse} message MutateAccountBudgetProposalResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAccountBudgetProposalResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.result = null;
                            if (message.result != null && message.hasOwnProperty("result"))
                                object.result = $root.google.ads.googleads.v1.services.MutateAccountBudgetProposalResult.toObject(message.result, options);
                            return object;
                        };

                        /**
                         * Converts this MutateAccountBudgetProposalResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAccountBudgetProposalResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAccountBudgetProposalResponse;
                    })();

                    services.MutateAccountBudgetProposalResult = (function() {

                        /**
                         * Properties of a MutateAccountBudgetProposalResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAccountBudgetProposalResult
                         * @property {string|null} [resourceName] MutateAccountBudgetProposalResult resourceName
                         */

                        /**
                         * Constructs a new MutateAccountBudgetProposalResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAccountBudgetProposalResult.
                         * @implements IMutateAccountBudgetProposalResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAccountBudgetProposalResult=} [properties] Properties to set
                         */
                        function MutateAccountBudgetProposalResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAccountBudgetProposalResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResult
                         * @instance
                         */
                        MutateAccountBudgetProposalResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateAccountBudgetProposalResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAccountBudgetProposalResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAccountBudgetProposalResult} MutateAccountBudgetProposalResult instance
                         */
                        MutateAccountBudgetProposalResult.create = function create(properties) {
                            return new MutateAccountBudgetProposalResult(properties);
                        };

                        /**
                         * Encodes the specified MutateAccountBudgetProposalResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAccountBudgetProposalResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAccountBudgetProposalResult} message MutateAccountBudgetProposalResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAccountBudgetProposalResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAccountBudgetProposalResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAccountBudgetProposalResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAccountBudgetProposalResult} message MutateAccountBudgetProposalResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAccountBudgetProposalResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAccountBudgetProposalResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAccountBudgetProposalResult} MutateAccountBudgetProposalResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAccountBudgetProposalResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAccountBudgetProposalResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAccountBudgetProposalResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAccountBudgetProposalResult} MutateAccountBudgetProposalResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAccountBudgetProposalResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAccountBudgetProposalResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAccountBudgetProposalResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAccountBudgetProposalResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAccountBudgetProposalResult} MutateAccountBudgetProposalResult
                         */
                        MutateAccountBudgetProposalResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAccountBudgetProposalResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAccountBudgetProposalResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAccountBudgetProposalResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAccountBudgetProposalResult} message MutateAccountBudgetProposalResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAccountBudgetProposalResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateAccountBudgetProposalResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAccountBudgetProposalResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAccountBudgetProposalResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAccountBudgetProposalResult;
                    })();

                    services.AccountBudgetService = (function() {

                        /**
                         * Constructs a new AccountBudgetService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AccountBudgetService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AccountBudgetService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (AccountBudgetService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AccountBudgetService;

                        /**
                         * Creates new AccountBudgetService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AccountBudgetService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AccountBudgetService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AccountBudgetService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AccountBudgetService#getAccountBudget}.
                         * @memberof google.ads.googleads.v1.services.AccountBudgetService
                         * @typedef GetAccountBudgetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.AccountBudget} [response] AccountBudget
                         */

                        /**
                         * Calls GetAccountBudget.
                         * @function getAccountBudget
                         * @memberof google.ads.googleads.v1.services.AccountBudgetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAccountBudgetRequest} request GetAccountBudgetRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AccountBudgetService.GetAccountBudgetCallback} callback Node-style callback called with the error, if any, and AccountBudget
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AccountBudgetService.prototype.getAccountBudget = function getAccountBudget(request, callback) {
                            return this.rpcCall(getAccountBudget, $root.google.ads.googleads.v1.services.GetAccountBudgetRequest, $root.google.ads.googleads.v1.resources.AccountBudget, request, callback);
                        }, "name", { value: "GetAccountBudget" });

                        /**
                         * Calls GetAccountBudget.
                         * @function getAccountBudget
                         * @memberof google.ads.googleads.v1.services.AccountBudgetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAccountBudgetRequest} request GetAccountBudgetRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.AccountBudget>} Promise
                         * @variation 2
                         */

                        return AccountBudgetService;
                    })();

                    services.GetAccountBudgetRequest = (function() {

                        /**
                         * Properties of a GetAccountBudgetRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetAccountBudgetRequest
                         * @property {string|null} [resourceName] GetAccountBudgetRequest resourceName
                         */

                        /**
                         * Constructs a new GetAccountBudgetRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetAccountBudgetRequest.
                         * @implements IGetAccountBudgetRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetAccountBudgetRequest=} [properties] Properties to set
                         */
                        function GetAccountBudgetRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetAccountBudgetRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetRequest
                         * @instance
                         */
                        GetAccountBudgetRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetAccountBudgetRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAccountBudgetRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetAccountBudgetRequest} GetAccountBudgetRequest instance
                         */
                        GetAccountBudgetRequest.create = function create(properties) {
                            return new GetAccountBudgetRequest(properties);
                        };

                        /**
                         * Encodes the specified GetAccountBudgetRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetAccountBudgetRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAccountBudgetRequest} message GetAccountBudgetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAccountBudgetRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetAccountBudgetRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetAccountBudgetRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAccountBudgetRequest} message GetAccountBudgetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAccountBudgetRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetAccountBudgetRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetAccountBudgetRequest} GetAccountBudgetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAccountBudgetRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetAccountBudgetRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetAccountBudgetRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetAccountBudgetRequest} GetAccountBudgetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAccountBudgetRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetAccountBudgetRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAccountBudgetRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetAccountBudgetRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetAccountBudgetRequest} GetAccountBudgetRequest
                         */
                        GetAccountBudgetRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetAccountBudgetRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetAccountBudgetRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetAccountBudgetRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetAccountBudgetRequest} message GetAccountBudgetRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAccountBudgetRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetAccountBudgetRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetAccountBudgetRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAccountBudgetRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetAccountBudgetRequest;
                    })();

                    services.AdGroupAdLabelService = (function() {

                        /**
                         * Constructs a new AdGroupAdLabelService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupAdLabelService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AdGroupAdLabelService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (AdGroupAdLabelService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AdGroupAdLabelService;

                        /**
                         * Creates new AdGroupAdLabelService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AdGroupAdLabelService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AdGroupAdLabelService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupAdLabelService#getAdGroupAdLabel}.
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelService
                         * @typedef GetAdGroupAdLabelCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.AdGroupAdLabel} [response] AdGroupAdLabel
                         */

                        /**
                         * Calls GetAdGroupAdLabel.
                         * @function getAdGroupAdLabel
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupAdLabelRequest} request GetAdGroupAdLabelRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupAdLabelService.GetAdGroupAdLabelCallback} callback Node-style callback called with the error, if any, and AdGroupAdLabel
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupAdLabelService.prototype.getAdGroupAdLabel = function getAdGroupAdLabel(request, callback) {
                            return this.rpcCall(getAdGroupAdLabel, $root.google.ads.googleads.v1.services.GetAdGroupAdLabelRequest, $root.google.ads.googleads.v1.resources.AdGroupAdLabel, request, callback);
                        }, "name", { value: "GetAdGroupAdLabel" });

                        /**
                         * Calls GetAdGroupAdLabel.
                         * @function getAdGroupAdLabel
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupAdLabelRequest} request GetAdGroupAdLabelRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.AdGroupAdLabel>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupAdLabelService#mutateAdGroupAdLabels}.
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelService
                         * @typedef MutateAdGroupAdLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse} [response] MutateAdGroupAdLabelsResponse
                         */

                        /**
                         * Calls MutateAdGroupAdLabels.
                         * @function mutateAdGroupAdLabels
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdLabelsRequest} request MutateAdGroupAdLabelsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupAdLabelService.MutateAdGroupAdLabelsCallback} callback Node-style callback called with the error, if any, and MutateAdGroupAdLabelsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupAdLabelService.prototype.mutateAdGroupAdLabels = function mutateAdGroupAdLabels(request, callback) {
                            return this.rpcCall(mutateAdGroupAdLabels, $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest, $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse, request, callback);
                        }, "name", { value: "MutateAdGroupAdLabels" });

                        /**
                         * Calls MutateAdGroupAdLabels.
                         * @function mutateAdGroupAdLabels
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdLabelsRequest} request MutateAdGroupAdLabelsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse>} Promise
                         * @variation 2
                         */

                        return AdGroupAdLabelService;
                    })();

                    services.GetAdGroupAdLabelRequest = (function() {

                        /**
                         * Properties of a GetAdGroupAdLabelRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetAdGroupAdLabelRequest
                         * @property {string|null} [resourceName] GetAdGroupAdLabelRequest resourceName
                         */

                        /**
                         * Constructs a new GetAdGroupAdLabelRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetAdGroupAdLabelRequest.
                         * @implements IGetAdGroupAdLabelRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetAdGroupAdLabelRequest=} [properties] Properties to set
                         */
                        function GetAdGroupAdLabelRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetAdGroupAdLabelRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdLabelRequest
                         * @instance
                         */
                        GetAdGroupAdLabelRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetAdGroupAdLabelRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupAdLabelRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetAdGroupAdLabelRequest} GetAdGroupAdLabelRequest instance
                         */
                        GetAdGroupAdLabelRequest.create = function create(properties) {
                            return new GetAdGroupAdLabelRequest(properties);
                        };

                        /**
                         * Encodes the specified GetAdGroupAdLabelRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupAdLabelRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupAdLabelRequest} message GetAdGroupAdLabelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupAdLabelRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetAdGroupAdLabelRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupAdLabelRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupAdLabelRequest} message GetAdGroupAdLabelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupAdLabelRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetAdGroupAdLabelRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdLabelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetAdGroupAdLabelRequest} GetAdGroupAdLabelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupAdLabelRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetAdGroupAdLabelRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetAdGroupAdLabelRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdLabelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetAdGroupAdLabelRequest} GetAdGroupAdLabelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupAdLabelRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetAdGroupAdLabelRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdLabelRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAdGroupAdLabelRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetAdGroupAdLabelRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdLabelRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetAdGroupAdLabelRequest} GetAdGroupAdLabelRequest
                         */
                        GetAdGroupAdLabelRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetAdGroupAdLabelRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetAdGroupAdLabelRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetAdGroupAdLabelRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetAdGroupAdLabelRequest} message GetAdGroupAdLabelRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAdGroupAdLabelRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetAdGroupAdLabelRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdLabelRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAdGroupAdLabelRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetAdGroupAdLabelRequest;
                    })();

                    services.MutateAdGroupAdLabelsRequest = (function() {

                        /**
                         * Properties of a MutateAdGroupAdLabelsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupAdLabelsRequest
                         * @property {string|null} [customerId] MutateAdGroupAdLabelsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IAdGroupAdLabelOperation>|null} [operations] MutateAdGroupAdLabelsRequest operations
                         * @property {boolean|null} [partialFailure] MutateAdGroupAdLabelsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateAdGroupAdLabelsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateAdGroupAdLabelsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupAdLabelsRequest.
                         * @implements IMutateAdGroupAdLabelsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdLabelsRequest=} [properties] Properties to set
                         */
                        function MutateAdGroupAdLabelsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupAdLabelsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest
                         * @instance
                         */
                        MutateAdGroupAdLabelsRequest.prototype.customerId = "";

                        /**
                         * MutateAdGroupAdLabelsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IAdGroupAdLabelOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest
                         * @instance
                         */
                        MutateAdGroupAdLabelsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateAdGroupAdLabelsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest
                         * @instance
                         */
                        MutateAdGroupAdLabelsRequest.prototype.partialFailure = false;

                        /**
                         * MutateAdGroupAdLabelsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest
                         * @instance
                         */
                        MutateAdGroupAdLabelsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateAdGroupAdLabelsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdLabelsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest} MutateAdGroupAdLabelsRequest instance
                         */
                        MutateAdGroupAdLabelsRequest.create = function create(properties) {
                            return new MutateAdGroupAdLabelsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupAdLabelsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdLabelsRequest} message MutateAdGroupAdLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupAdLabelsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.AdGroupAdLabelOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupAdLabelsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdLabelsRequest} message MutateAdGroupAdLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupAdLabelsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupAdLabelsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest} MutateAdGroupAdLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupAdLabelsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.AdGroupAdLabelOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupAdLabelsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest} MutateAdGroupAdLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupAdLabelsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupAdLabelsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupAdLabelsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.AdGroupAdLabelOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupAdLabelsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest} MutateAdGroupAdLabelsRequest
                         */
                        MutateAdGroupAdLabelsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.AdGroupAdLabelOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupAdLabelsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest} message MutateAdGroupAdLabelsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupAdLabelsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.AdGroupAdLabelOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupAdLabelsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupAdLabelsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupAdLabelsRequest;
                    })();

                    services.AdGroupAdLabelOperation = (function() {

                        /**
                         * Properties of an AdGroupAdLabelOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IAdGroupAdLabelOperation
                         * @property {google.ads.googleads.v1.resources.IAdGroupAdLabel|null} [create] AdGroupAdLabelOperation create
                         * @property {string|null} [remove] AdGroupAdLabelOperation remove
                         */

                        /**
                         * Constructs a new AdGroupAdLabelOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupAdLabelOperation.
                         * @implements IAdGroupAdLabelOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IAdGroupAdLabelOperation=} [properties] Properties to set
                         */
                        function AdGroupAdLabelOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupAdLabelOperation create.
                         * @member {google.ads.googleads.v1.resources.IAdGroupAdLabel|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelOperation
                         * @instance
                         */
                        AdGroupAdLabelOperation.prototype.create = null;

                        /**
                         * AdGroupAdLabelOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelOperation
                         * @instance
                         */
                        AdGroupAdLabelOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AdGroupAdLabelOperation operation.
                         * @member {"create"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelOperation
                         * @instance
                         */
                        Object.defineProperty(AdGroupAdLabelOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AdGroupAdLabelOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupAdLabelOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.AdGroupAdLabelOperation} AdGroupAdLabelOperation instance
                         */
                        AdGroupAdLabelOperation.create = function create(properties) {
                            return new AdGroupAdLabelOperation(properties);
                        };

                        /**
                         * Encodes the specified AdGroupAdLabelOperation message. Does not implicitly {@link google.ads.googleads.v1.services.AdGroupAdLabelOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupAdLabelOperation} message AdGroupAdLabelOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupAdLabelOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.AdGroupAdLabel.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.remove);
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupAdLabelOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.AdGroupAdLabelOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupAdLabelOperation} message AdGroupAdLabelOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupAdLabelOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupAdLabelOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.AdGroupAdLabelOperation} AdGroupAdLabelOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupAdLabelOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.AdGroupAdLabelOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.AdGroupAdLabel.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupAdLabelOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.AdGroupAdLabelOperation} AdGroupAdLabelOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupAdLabelOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupAdLabelOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupAdLabelOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.AdGroupAdLabel.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates an AdGroupAdLabelOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.AdGroupAdLabelOperation} AdGroupAdLabelOperation
                         */
                        AdGroupAdLabelOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.AdGroupAdLabelOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.AdGroupAdLabelOperation();
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupAdLabelOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.AdGroupAdLabel.fromObject(object.create);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupAdLabelOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.AdGroupAdLabelOperation} message AdGroupAdLabelOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupAdLabelOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.AdGroupAdLabel.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            return object;
                        };

                        /**
                         * Converts this AdGroupAdLabelOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.AdGroupAdLabelOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupAdLabelOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupAdLabelOperation;
                    })();

                    services.MutateAdGroupAdLabelsResponse = (function() {

                        /**
                         * Properties of a MutateAdGroupAdLabelsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupAdLabelsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateAdGroupAdLabelsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateAdGroupAdLabelResult>|null} [results] MutateAdGroupAdLabelsResponse results
                         */

                        /**
                         * Constructs a new MutateAdGroupAdLabelsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupAdLabelsResponse.
                         * @implements IMutateAdGroupAdLabelsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdLabelsResponse=} [properties] Properties to set
                         */
                        function MutateAdGroupAdLabelsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupAdLabelsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse
                         * @instance
                         */
                        MutateAdGroupAdLabelsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateAdGroupAdLabelsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateAdGroupAdLabelResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse
                         * @instance
                         */
                        MutateAdGroupAdLabelsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateAdGroupAdLabelsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdLabelsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse} MutateAdGroupAdLabelsResponse instance
                         */
                        MutateAdGroupAdLabelsResponse.create = function create(properties) {
                            return new MutateAdGroupAdLabelsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupAdLabelsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdLabelsResponse} message MutateAdGroupAdLabelsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupAdLabelsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupAdLabelsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdLabelsResponse} message MutateAdGroupAdLabelsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupAdLabelsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupAdLabelsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse} MutateAdGroupAdLabelsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupAdLabelsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateAdGroupAdLabelResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupAdLabelsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse} MutateAdGroupAdLabelsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupAdLabelsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupAdLabelsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupAdLabelsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupAdLabelsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse} MutateAdGroupAdLabelsResponse
                         */
                        MutateAdGroupAdLabelsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupAdLabelsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse} message MutateAdGroupAdLabelsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupAdLabelsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupAdLabelsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupAdLabelsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupAdLabelsResponse;
                    })();

                    services.MutateAdGroupAdLabelResult = (function() {

                        /**
                         * Properties of a MutateAdGroupAdLabelResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupAdLabelResult
                         * @property {string|null} [resourceName] MutateAdGroupAdLabelResult resourceName
                         */

                        /**
                         * Constructs a new MutateAdGroupAdLabelResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupAdLabelResult.
                         * @implements IMutateAdGroupAdLabelResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdLabelResult=} [properties] Properties to set
                         */
                        function MutateAdGroupAdLabelResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupAdLabelResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelResult
                         * @instance
                         */
                        MutateAdGroupAdLabelResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateAdGroupAdLabelResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdLabelResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdLabelResult} MutateAdGroupAdLabelResult instance
                         */
                        MutateAdGroupAdLabelResult.create = function create(properties) {
                            return new MutateAdGroupAdLabelResult(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupAdLabelResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupAdLabelResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdLabelResult} message MutateAdGroupAdLabelResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupAdLabelResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupAdLabelResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupAdLabelResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdLabelResult} message MutateAdGroupAdLabelResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupAdLabelResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupAdLabelResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdLabelResult} MutateAdGroupAdLabelResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupAdLabelResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupAdLabelResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdLabelResult} MutateAdGroupAdLabelResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupAdLabelResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupAdLabelResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupAdLabelResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupAdLabelResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdLabelResult} MutateAdGroupAdLabelResult
                         */
                        MutateAdGroupAdLabelResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupAdLabelResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupAdLabelResult} message MutateAdGroupAdLabelResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupAdLabelResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupAdLabelResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdLabelResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupAdLabelResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupAdLabelResult;
                    })();

                    services.AdGroupAdService = (function() {

                        /**
                         * Constructs a new AdGroupAdService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupAdService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AdGroupAdService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (AdGroupAdService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AdGroupAdService;

                        /**
                         * Creates new AdGroupAdService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupAdService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AdGroupAdService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AdGroupAdService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupAdService#getAdGroupAd}.
                         * @memberof google.ads.googleads.v1.services.AdGroupAdService
                         * @typedef GetAdGroupAdCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.AdGroupAd} [response] AdGroupAd
                         */

                        /**
                         * Calls GetAdGroupAd.
                         * @function getAdGroupAd
                         * @memberof google.ads.googleads.v1.services.AdGroupAdService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupAdRequest} request GetAdGroupAdRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupAdService.GetAdGroupAdCallback} callback Node-style callback called with the error, if any, and AdGroupAd
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupAdService.prototype.getAdGroupAd = function getAdGroupAd(request, callback) {
                            return this.rpcCall(getAdGroupAd, $root.google.ads.googleads.v1.services.GetAdGroupAdRequest, $root.google.ads.googleads.v1.resources.AdGroupAd, request, callback);
                        }, "name", { value: "GetAdGroupAd" });

                        /**
                         * Calls GetAdGroupAd.
                         * @function getAdGroupAd
                         * @memberof google.ads.googleads.v1.services.AdGroupAdService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupAdRequest} request GetAdGroupAdRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.AdGroupAd>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupAdService#mutateAdGroupAds}.
                         * @memberof google.ads.googleads.v1.services.AdGroupAdService
                         * @typedef MutateAdGroupAdsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateAdGroupAdsResponse} [response] MutateAdGroupAdsResponse
                         */

                        /**
                         * Calls MutateAdGroupAds.
                         * @function mutateAdGroupAds
                         * @memberof google.ads.googleads.v1.services.AdGroupAdService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdsRequest} request MutateAdGroupAdsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupAdService.MutateAdGroupAdsCallback} callback Node-style callback called with the error, if any, and MutateAdGroupAdsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupAdService.prototype.mutateAdGroupAds = function mutateAdGroupAds(request, callback) {
                            return this.rpcCall(mutateAdGroupAds, $root.google.ads.googleads.v1.services.MutateAdGroupAdsRequest, $root.google.ads.googleads.v1.services.MutateAdGroupAdsResponse, request, callback);
                        }, "name", { value: "MutateAdGroupAds" });

                        /**
                         * Calls MutateAdGroupAds.
                         * @function mutateAdGroupAds
                         * @memberof google.ads.googleads.v1.services.AdGroupAdService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdsRequest} request MutateAdGroupAdsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateAdGroupAdsResponse>} Promise
                         * @variation 2
                         */

                        return AdGroupAdService;
                    })();

                    services.GetAdGroupAdRequest = (function() {

                        /**
                         * Properties of a GetAdGroupAdRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetAdGroupAdRequest
                         * @property {string|null} [resourceName] GetAdGroupAdRequest resourceName
                         */

                        /**
                         * Constructs a new GetAdGroupAdRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetAdGroupAdRequest.
                         * @implements IGetAdGroupAdRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetAdGroupAdRequest=} [properties] Properties to set
                         */
                        function GetAdGroupAdRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetAdGroupAdRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdRequest
                         * @instance
                         */
                        GetAdGroupAdRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetAdGroupAdRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupAdRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetAdGroupAdRequest} GetAdGroupAdRequest instance
                         */
                        GetAdGroupAdRequest.create = function create(properties) {
                            return new GetAdGroupAdRequest(properties);
                        };

                        /**
                         * Encodes the specified GetAdGroupAdRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupAdRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupAdRequest} message GetAdGroupAdRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupAdRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetAdGroupAdRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupAdRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupAdRequest} message GetAdGroupAdRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupAdRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetAdGroupAdRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetAdGroupAdRequest} GetAdGroupAdRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupAdRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetAdGroupAdRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetAdGroupAdRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetAdGroupAdRequest} GetAdGroupAdRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupAdRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetAdGroupAdRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAdGroupAdRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetAdGroupAdRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetAdGroupAdRequest} GetAdGroupAdRequest
                         */
                        GetAdGroupAdRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetAdGroupAdRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetAdGroupAdRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetAdGroupAdRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetAdGroupAdRequest} message GetAdGroupAdRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAdGroupAdRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetAdGroupAdRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAdRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAdGroupAdRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetAdGroupAdRequest;
                    })();

                    services.MutateAdGroupAdsRequest = (function() {

                        /**
                         * Properties of a MutateAdGroupAdsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupAdsRequest
                         * @property {string|null} [customerId] MutateAdGroupAdsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IAdGroupAdOperation>|null} [operations] MutateAdGroupAdsRequest operations
                         * @property {boolean|null} [partialFailure] MutateAdGroupAdsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateAdGroupAdsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateAdGroupAdsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupAdsRequest.
                         * @implements IMutateAdGroupAdsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdsRequest=} [properties] Properties to set
                         */
                        function MutateAdGroupAdsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupAdsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsRequest
                         * @instance
                         */
                        MutateAdGroupAdsRequest.prototype.customerId = "";

                        /**
                         * MutateAdGroupAdsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IAdGroupAdOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsRequest
                         * @instance
                         */
                        MutateAdGroupAdsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateAdGroupAdsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsRequest
                         * @instance
                         */
                        MutateAdGroupAdsRequest.prototype.partialFailure = false;

                        /**
                         * MutateAdGroupAdsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsRequest
                         * @instance
                         */
                        MutateAdGroupAdsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateAdGroupAdsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdsRequest} MutateAdGroupAdsRequest instance
                         */
                        MutateAdGroupAdsRequest.create = function create(properties) {
                            return new MutateAdGroupAdsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupAdsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupAdsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdsRequest} message MutateAdGroupAdsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupAdsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.AdGroupAdOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupAdsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupAdsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdsRequest} message MutateAdGroupAdsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupAdsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupAdsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdsRequest} MutateAdGroupAdsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupAdsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupAdsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.AdGroupAdOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupAdsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdsRequest} MutateAdGroupAdsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupAdsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupAdsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupAdsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.AdGroupAdOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupAdsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdsRequest} MutateAdGroupAdsRequest
                         */
                        MutateAdGroupAdsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupAdsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupAdsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupAdsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupAdsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.AdGroupAdOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupAdsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupAdsRequest} message MutateAdGroupAdsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupAdsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.AdGroupAdOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupAdsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupAdsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupAdsRequest;
                    })();

                    services.AdGroupAdOperation = (function() {

                        /**
                         * Properties of an AdGroupAdOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IAdGroupAdOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] AdGroupAdOperation updateMask
                         * @property {google.ads.googleads.v1.common.IPolicyValidationParameter|null} [policyValidationParameter] AdGroupAdOperation policyValidationParameter
                         * @property {google.ads.googleads.v1.resources.IAdGroupAd|null} [create] AdGroupAdOperation create
                         * @property {google.ads.googleads.v1.resources.IAdGroupAd|null} [update] AdGroupAdOperation update
                         * @property {string|null} [remove] AdGroupAdOperation remove
                         */

                        /**
                         * Constructs a new AdGroupAdOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupAdOperation.
                         * @implements IAdGroupAdOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IAdGroupAdOperation=} [properties] Properties to set
                         */
                        function AdGroupAdOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupAdOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.AdGroupAdOperation
                         * @instance
                         */
                        AdGroupAdOperation.prototype.updateMask = null;

                        /**
                         * AdGroupAdOperation policyValidationParameter.
                         * @member {google.ads.googleads.v1.common.IPolicyValidationParameter|null|undefined} policyValidationParameter
                         * @memberof google.ads.googleads.v1.services.AdGroupAdOperation
                         * @instance
                         */
                        AdGroupAdOperation.prototype.policyValidationParameter = null;

                        /**
                         * AdGroupAdOperation create.
                         * @member {google.ads.googleads.v1.resources.IAdGroupAd|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.AdGroupAdOperation
                         * @instance
                         */
                        AdGroupAdOperation.prototype.create = null;

                        /**
                         * AdGroupAdOperation update.
                         * @member {google.ads.googleads.v1.resources.IAdGroupAd|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.AdGroupAdOperation
                         * @instance
                         */
                        AdGroupAdOperation.prototype.update = null;

                        /**
                         * AdGroupAdOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.AdGroupAdOperation
                         * @instance
                         */
                        AdGroupAdOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AdGroupAdOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.AdGroupAdOperation
                         * @instance
                         */
                        Object.defineProperty(AdGroupAdOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AdGroupAdOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupAdOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupAdOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.AdGroupAdOperation} AdGroupAdOperation instance
                         */
                        AdGroupAdOperation.create = function create(properties) {
                            return new AdGroupAdOperation(properties);
                        };

                        /**
                         * Encodes the specified AdGroupAdOperation message. Does not implicitly {@link google.ads.googleads.v1.services.AdGroupAdOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.AdGroupAdOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupAdOperation} message AdGroupAdOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupAdOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.AdGroupAd.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.AdGroupAd.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.policyValidationParameter != null && message.hasOwnProperty("policyValidationParameter"))
                                $root.google.ads.googleads.v1.common.PolicyValidationParameter.encode(message.policyValidationParameter, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupAdOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.AdGroupAdOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdGroupAdOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupAdOperation} message AdGroupAdOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupAdOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupAdOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.AdGroupAdOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.AdGroupAdOperation} AdGroupAdOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupAdOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.AdGroupAdOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.policyValidationParameter = $root.google.ads.googleads.v1.common.PolicyValidationParameter.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.AdGroupAd.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.AdGroupAd.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupAdOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdGroupAdOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.AdGroupAdOperation} AdGroupAdOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupAdOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupAdOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.AdGroupAdOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupAdOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.policyValidationParameter != null && message.hasOwnProperty("policyValidationParameter")) {
                                var error = $root.google.ads.googleads.v1.common.PolicyValidationParameter.verify(message.policyValidationParameter);
                                if (error)
                                    return "policyValidationParameter." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.AdGroupAd.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.AdGroupAd.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates an AdGroupAdOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.AdGroupAdOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.AdGroupAdOperation} AdGroupAdOperation
                         */
                        AdGroupAdOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.AdGroupAdOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.AdGroupAdOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupAdOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.policyValidationParameter != null) {
                                if (typeof object.policyValidationParameter !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupAdOperation.policyValidationParameter: object expected");
                                message.policyValidationParameter = $root.google.ads.googleads.v1.common.PolicyValidationParameter.fromObject(object.policyValidationParameter);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupAdOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.AdGroupAd.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupAdOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.AdGroupAd.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupAdOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.AdGroupAdOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.AdGroupAdOperation} message AdGroupAdOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupAdOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.updateMask = null;
                                object.policyValidationParameter = null;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.AdGroupAd.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.AdGroupAd.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            if (message.policyValidationParameter != null && message.hasOwnProperty("policyValidationParameter"))
                                object.policyValidationParameter = $root.google.ads.googleads.v1.common.PolicyValidationParameter.toObject(message.policyValidationParameter, options);
                            return object;
                        };

                        /**
                         * Converts this AdGroupAdOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.AdGroupAdOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupAdOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupAdOperation;
                    })();

                    services.MutateAdGroupAdsResponse = (function() {

                        /**
                         * Properties of a MutateAdGroupAdsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupAdsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateAdGroupAdsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateAdGroupAdResult>|null} [results] MutateAdGroupAdsResponse results
                         */

                        /**
                         * Constructs a new MutateAdGroupAdsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupAdsResponse.
                         * @implements IMutateAdGroupAdsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdsResponse=} [properties] Properties to set
                         */
                        function MutateAdGroupAdsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupAdsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsResponse
                         * @instance
                         */
                        MutateAdGroupAdsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateAdGroupAdsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateAdGroupAdResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsResponse
                         * @instance
                         */
                        MutateAdGroupAdsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateAdGroupAdsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdsResponse} MutateAdGroupAdsResponse instance
                         */
                        MutateAdGroupAdsResponse.create = function create(properties) {
                            return new MutateAdGroupAdsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupAdsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupAdsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdsResponse} message MutateAdGroupAdsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupAdsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateAdGroupAdResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupAdsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupAdsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdsResponse} message MutateAdGroupAdsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupAdsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupAdsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdsResponse} MutateAdGroupAdsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupAdsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupAdsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateAdGroupAdResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupAdsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdsResponse} MutateAdGroupAdsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupAdsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupAdsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupAdsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdGroupAdResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupAdsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdsResponse} MutateAdGroupAdsResponse
                         */
                        MutateAdGroupAdsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupAdsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupAdsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupAdsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupAdsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupAdsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateAdGroupAdResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupAdsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupAdsResponse} message MutateAdGroupAdsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupAdsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateAdGroupAdResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupAdsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupAdsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupAdsResponse;
                    })();

                    services.MutateAdGroupAdResult = (function() {

                        /**
                         * Properties of a MutateAdGroupAdResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupAdResult
                         * @property {string|null} [resourceName] MutateAdGroupAdResult resourceName
                         */

                        /**
                         * Constructs a new MutateAdGroupAdResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupAdResult.
                         * @implements IMutateAdGroupAdResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdResult=} [properties] Properties to set
                         */
                        function MutateAdGroupAdResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupAdResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdResult
                         * @instance
                         */
                        MutateAdGroupAdResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateAdGroupAdResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdResult} MutateAdGroupAdResult instance
                         */
                        MutateAdGroupAdResult.create = function create(properties) {
                            return new MutateAdGroupAdResult(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupAdResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupAdResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdResult} message MutateAdGroupAdResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupAdResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupAdResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupAdResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupAdResult} message MutateAdGroupAdResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupAdResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupAdResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdResult} MutateAdGroupAdResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupAdResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupAdResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupAdResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdResult} MutateAdGroupAdResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupAdResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupAdResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupAdResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupAdResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupAdResult} MutateAdGroupAdResult
                         */
                        MutateAdGroupAdResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupAdResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupAdResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupAdResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupAdResult} message MutateAdGroupAdResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupAdResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupAdResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupAdResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupAdResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupAdResult;
                    })();

                    services.AdGroupAudienceViewService = (function() {

                        /**
                         * Constructs a new AdGroupAudienceViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupAudienceViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AdGroupAudienceViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (AdGroupAudienceViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AdGroupAudienceViewService;

                        /**
                         * Creates new AdGroupAudienceViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupAudienceViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AdGroupAudienceViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AdGroupAudienceViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupAudienceViewService#getAdGroupAudienceView}.
                         * @memberof google.ads.googleads.v1.services.AdGroupAudienceViewService
                         * @typedef GetAdGroupAudienceViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.AdGroupAudienceView} [response] AdGroupAudienceView
                         */

                        /**
                         * Calls GetAdGroupAudienceView.
                         * @function getAdGroupAudienceView
                         * @memberof google.ads.googleads.v1.services.AdGroupAudienceViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupAudienceViewRequest} request GetAdGroupAudienceViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupAudienceViewService.GetAdGroupAudienceViewCallback} callback Node-style callback called with the error, if any, and AdGroupAudienceView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupAudienceViewService.prototype.getAdGroupAudienceView = function getAdGroupAudienceView(request, callback) {
                            return this.rpcCall(getAdGroupAudienceView, $root.google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest, $root.google.ads.googleads.v1.resources.AdGroupAudienceView, request, callback);
                        }, "name", { value: "GetAdGroupAudienceView" });

                        /**
                         * Calls GetAdGroupAudienceView.
                         * @function getAdGroupAudienceView
                         * @memberof google.ads.googleads.v1.services.AdGroupAudienceViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupAudienceViewRequest} request GetAdGroupAudienceViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.AdGroupAudienceView>} Promise
                         * @variation 2
                         */

                        return AdGroupAudienceViewService;
                    })();

                    services.GetAdGroupAudienceViewRequest = (function() {

                        /**
                         * Properties of a GetAdGroupAudienceViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetAdGroupAudienceViewRequest
                         * @property {string|null} [resourceName] GetAdGroupAudienceViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetAdGroupAudienceViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetAdGroupAudienceViewRequest.
                         * @implements IGetAdGroupAudienceViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetAdGroupAudienceViewRequest=} [properties] Properties to set
                         */
                        function GetAdGroupAudienceViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetAdGroupAudienceViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest
                         * @instance
                         */
                        GetAdGroupAudienceViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetAdGroupAudienceViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupAudienceViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest} GetAdGroupAudienceViewRequest instance
                         */
                        GetAdGroupAudienceViewRequest.create = function create(properties) {
                            return new GetAdGroupAudienceViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetAdGroupAudienceViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupAudienceViewRequest} message GetAdGroupAudienceViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupAudienceViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetAdGroupAudienceViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupAudienceViewRequest} message GetAdGroupAudienceViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupAudienceViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetAdGroupAudienceViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest} GetAdGroupAudienceViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupAudienceViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetAdGroupAudienceViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest} GetAdGroupAudienceViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupAudienceViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetAdGroupAudienceViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAdGroupAudienceViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetAdGroupAudienceViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest} GetAdGroupAudienceViewRequest
                         */
                        GetAdGroupAudienceViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetAdGroupAudienceViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest} message GetAdGroupAudienceViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAdGroupAudienceViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetAdGroupAudienceViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetAdGroupAudienceViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAdGroupAudienceViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetAdGroupAudienceViewRequest;
                    })();

                    services.AdGroupBidModifierService = (function() {

                        /**
                         * Constructs a new AdGroupBidModifierService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupBidModifierService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AdGroupBidModifierService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (AdGroupBidModifierService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AdGroupBidModifierService;

                        /**
                         * Creates new AdGroupBidModifierService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AdGroupBidModifierService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AdGroupBidModifierService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupBidModifierService#getAdGroupBidModifier}.
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierService
                         * @typedef GetAdGroupBidModifierCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.AdGroupBidModifier} [response] AdGroupBidModifier
                         */

                        /**
                         * Calls GetAdGroupBidModifier.
                         * @function getAdGroupBidModifier
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupBidModifierRequest} request GetAdGroupBidModifierRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupBidModifierService.GetAdGroupBidModifierCallback} callback Node-style callback called with the error, if any, and AdGroupBidModifier
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupBidModifierService.prototype.getAdGroupBidModifier = function getAdGroupBidModifier(request, callback) {
                            return this.rpcCall(getAdGroupBidModifier, $root.google.ads.googleads.v1.services.GetAdGroupBidModifierRequest, $root.google.ads.googleads.v1.resources.AdGroupBidModifier, request, callback);
                        }, "name", { value: "GetAdGroupBidModifier" });

                        /**
                         * Calls GetAdGroupBidModifier.
                         * @function getAdGroupBidModifier
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupBidModifierRequest} request GetAdGroupBidModifierRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.AdGroupBidModifier>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupBidModifierService#mutateAdGroupBidModifiers}.
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierService
                         * @typedef MutateAdGroupBidModifiersCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse} [response] MutateAdGroupBidModifiersResponse
                         */

                        /**
                         * Calls MutateAdGroupBidModifiers.
                         * @function mutateAdGroupBidModifiers
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupBidModifiersRequest} request MutateAdGroupBidModifiersRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupBidModifierService.MutateAdGroupBidModifiersCallback} callback Node-style callback called with the error, if any, and MutateAdGroupBidModifiersResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupBidModifierService.prototype.mutateAdGroupBidModifiers = function mutateAdGroupBidModifiers(request, callback) {
                            return this.rpcCall(mutateAdGroupBidModifiers, $root.google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest, $root.google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse, request, callback);
                        }, "name", { value: "MutateAdGroupBidModifiers" });

                        /**
                         * Calls MutateAdGroupBidModifiers.
                         * @function mutateAdGroupBidModifiers
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupBidModifiersRequest} request MutateAdGroupBidModifiersRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse>} Promise
                         * @variation 2
                         */

                        return AdGroupBidModifierService;
                    })();

                    services.GetAdGroupBidModifierRequest = (function() {

                        /**
                         * Properties of a GetAdGroupBidModifierRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetAdGroupBidModifierRequest
                         * @property {string|null} [resourceName] GetAdGroupBidModifierRequest resourceName
                         */

                        /**
                         * Constructs a new GetAdGroupBidModifierRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetAdGroupBidModifierRequest.
                         * @implements IGetAdGroupBidModifierRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetAdGroupBidModifierRequest=} [properties] Properties to set
                         */
                        function GetAdGroupBidModifierRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetAdGroupBidModifierRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetAdGroupBidModifierRequest
                         * @instance
                         */
                        GetAdGroupBidModifierRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetAdGroupBidModifierRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetAdGroupBidModifierRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupBidModifierRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetAdGroupBidModifierRequest} GetAdGroupBidModifierRequest instance
                         */
                        GetAdGroupBidModifierRequest.create = function create(properties) {
                            return new GetAdGroupBidModifierRequest(properties);
                        };

                        /**
                         * Encodes the specified GetAdGroupBidModifierRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupBidModifierRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupBidModifierRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupBidModifierRequest} message GetAdGroupBidModifierRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupBidModifierRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetAdGroupBidModifierRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupBidModifierRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupBidModifierRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupBidModifierRequest} message GetAdGroupBidModifierRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupBidModifierRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetAdGroupBidModifierRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupBidModifierRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetAdGroupBidModifierRequest} GetAdGroupBidModifierRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupBidModifierRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetAdGroupBidModifierRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetAdGroupBidModifierRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupBidModifierRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetAdGroupBidModifierRequest} GetAdGroupBidModifierRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupBidModifierRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetAdGroupBidModifierRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetAdGroupBidModifierRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAdGroupBidModifierRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetAdGroupBidModifierRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupBidModifierRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetAdGroupBidModifierRequest} GetAdGroupBidModifierRequest
                         */
                        GetAdGroupBidModifierRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetAdGroupBidModifierRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetAdGroupBidModifierRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetAdGroupBidModifierRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupBidModifierRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetAdGroupBidModifierRequest} message GetAdGroupBidModifierRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAdGroupBidModifierRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetAdGroupBidModifierRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetAdGroupBidModifierRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAdGroupBidModifierRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetAdGroupBidModifierRequest;
                    })();

                    services.MutateAdGroupBidModifiersRequest = (function() {

                        /**
                         * Properties of a MutateAdGroupBidModifiersRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupBidModifiersRequest
                         * @property {string|null} [customerId] MutateAdGroupBidModifiersRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IAdGroupBidModifierOperation>|null} [operations] MutateAdGroupBidModifiersRequest operations
                         * @property {boolean|null} [partialFailure] MutateAdGroupBidModifiersRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateAdGroupBidModifiersRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateAdGroupBidModifiersRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupBidModifiersRequest.
                         * @implements IMutateAdGroupBidModifiersRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupBidModifiersRequest=} [properties] Properties to set
                         */
                        function MutateAdGroupBidModifiersRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupBidModifiersRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest
                         * @instance
                         */
                        MutateAdGroupBidModifiersRequest.prototype.customerId = "";

                        /**
                         * MutateAdGroupBidModifiersRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IAdGroupBidModifierOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest
                         * @instance
                         */
                        MutateAdGroupBidModifiersRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateAdGroupBidModifiersRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest
                         * @instance
                         */
                        MutateAdGroupBidModifiersRequest.prototype.partialFailure = false;

                        /**
                         * MutateAdGroupBidModifiersRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest
                         * @instance
                         */
                        MutateAdGroupBidModifiersRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateAdGroupBidModifiersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupBidModifiersRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest} MutateAdGroupBidModifiersRequest instance
                         */
                        MutateAdGroupBidModifiersRequest.create = function create(properties) {
                            return new MutateAdGroupBidModifiersRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupBidModifiersRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupBidModifiersRequest} message MutateAdGroupBidModifiersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupBidModifiersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.AdGroupBidModifierOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupBidModifiersRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupBidModifiersRequest} message MutateAdGroupBidModifiersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupBidModifiersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupBidModifiersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest} MutateAdGroupBidModifiersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupBidModifiersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.AdGroupBidModifierOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupBidModifiersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest} MutateAdGroupBidModifiersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupBidModifiersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupBidModifiersRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupBidModifiersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.AdGroupBidModifierOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupBidModifiersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest} MutateAdGroupBidModifiersRequest
                         */
                        MutateAdGroupBidModifiersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.AdGroupBidModifierOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupBidModifiersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest} message MutateAdGroupBidModifiersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupBidModifiersRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.AdGroupBidModifierOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupBidModifiersRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupBidModifiersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupBidModifiersRequest;
                    })();

                    services.AdGroupBidModifierOperation = (function() {

                        /**
                         * Properties of an AdGroupBidModifierOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IAdGroupBidModifierOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] AdGroupBidModifierOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IAdGroupBidModifier|null} [create] AdGroupBidModifierOperation create
                         * @property {google.ads.googleads.v1.resources.IAdGroupBidModifier|null} [update] AdGroupBidModifierOperation update
                         * @property {string|null} [remove] AdGroupBidModifierOperation remove
                         */

                        /**
                         * Constructs a new AdGroupBidModifierOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupBidModifierOperation.
                         * @implements IAdGroupBidModifierOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IAdGroupBidModifierOperation=} [properties] Properties to set
                         */
                        function AdGroupBidModifierOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupBidModifierOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierOperation
                         * @instance
                         */
                        AdGroupBidModifierOperation.prototype.updateMask = null;

                        /**
                         * AdGroupBidModifierOperation create.
                         * @member {google.ads.googleads.v1.resources.IAdGroupBidModifier|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierOperation
                         * @instance
                         */
                        AdGroupBidModifierOperation.prototype.create = null;

                        /**
                         * AdGroupBidModifierOperation update.
                         * @member {google.ads.googleads.v1.resources.IAdGroupBidModifier|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierOperation
                         * @instance
                         */
                        AdGroupBidModifierOperation.prototype.update = null;

                        /**
                         * AdGroupBidModifierOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierOperation
                         * @instance
                         */
                        AdGroupBidModifierOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AdGroupBidModifierOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierOperation
                         * @instance
                         */
                        Object.defineProperty(AdGroupBidModifierOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AdGroupBidModifierOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupBidModifierOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.AdGroupBidModifierOperation} AdGroupBidModifierOperation instance
                         */
                        AdGroupBidModifierOperation.create = function create(properties) {
                            return new AdGroupBidModifierOperation(properties);
                        };

                        /**
                         * Encodes the specified AdGroupBidModifierOperation message. Does not implicitly {@link google.ads.googleads.v1.services.AdGroupBidModifierOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupBidModifierOperation} message AdGroupBidModifierOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupBidModifierOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.AdGroupBidModifier.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.AdGroupBidModifier.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupBidModifierOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.AdGroupBidModifierOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupBidModifierOperation} message AdGroupBidModifierOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupBidModifierOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupBidModifierOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.AdGroupBidModifierOperation} AdGroupBidModifierOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupBidModifierOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.AdGroupBidModifierOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.AdGroupBidModifier.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.AdGroupBidModifier.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupBidModifierOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.AdGroupBidModifierOperation} AdGroupBidModifierOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupBidModifierOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupBidModifierOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupBidModifierOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.AdGroupBidModifier.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.AdGroupBidModifier.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates an AdGroupBidModifierOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.AdGroupBidModifierOperation} AdGroupBidModifierOperation
                         */
                        AdGroupBidModifierOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.AdGroupBidModifierOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.AdGroupBidModifierOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupBidModifierOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupBidModifierOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.AdGroupBidModifier.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupBidModifierOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.AdGroupBidModifier.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupBidModifierOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.AdGroupBidModifierOperation} message AdGroupBidModifierOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupBidModifierOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.AdGroupBidModifier.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.AdGroupBidModifier.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this AdGroupBidModifierOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.AdGroupBidModifierOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupBidModifierOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupBidModifierOperation;
                    })();

                    services.MutateAdGroupBidModifiersResponse = (function() {

                        /**
                         * Properties of a MutateAdGroupBidModifiersResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupBidModifiersResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateAdGroupBidModifiersResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateAdGroupBidModifierResult>|null} [results] MutateAdGroupBidModifiersResponse results
                         */

                        /**
                         * Constructs a new MutateAdGroupBidModifiersResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupBidModifiersResponse.
                         * @implements IMutateAdGroupBidModifiersResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupBidModifiersResponse=} [properties] Properties to set
                         */
                        function MutateAdGroupBidModifiersResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupBidModifiersResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse
                         * @instance
                         */
                        MutateAdGroupBidModifiersResponse.prototype.partialFailureError = null;

                        /**
                         * MutateAdGroupBidModifiersResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateAdGroupBidModifierResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse
                         * @instance
                         */
                        MutateAdGroupBidModifiersResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateAdGroupBidModifiersResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupBidModifiersResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse} MutateAdGroupBidModifiersResponse instance
                         */
                        MutateAdGroupBidModifiersResponse.create = function create(properties) {
                            return new MutateAdGroupBidModifiersResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupBidModifiersResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupBidModifiersResponse} message MutateAdGroupBidModifiersResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupBidModifiersResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateAdGroupBidModifierResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupBidModifiersResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupBidModifiersResponse} message MutateAdGroupBidModifiersResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupBidModifiersResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupBidModifiersResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse} MutateAdGroupBidModifiersResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupBidModifiersResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateAdGroupBidModifierResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupBidModifiersResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse} MutateAdGroupBidModifiersResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupBidModifiersResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupBidModifiersResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupBidModifiersResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdGroupBidModifierResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupBidModifiersResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse} MutateAdGroupBidModifiersResponse
                         */
                        MutateAdGroupBidModifiersResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateAdGroupBidModifierResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupBidModifiersResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse} message MutateAdGroupBidModifiersResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupBidModifiersResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateAdGroupBidModifierResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupBidModifiersResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifiersResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupBidModifiersResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupBidModifiersResponse;
                    })();

                    services.MutateAdGroupBidModifierResult = (function() {

                        /**
                         * Properties of a MutateAdGroupBidModifierResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupBidModifierResult
                         * @property {string|null} [resourceName] MutateAdGroupBidModifierResult resourceName
                         */

                        /**
                         * Constructs a new MutateAdGroupBidModifierResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupBidModifierResult.
                         * @implements IMutateAdGroupBidModifierResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupBidModifierResult=} [properties] Properties to set
                         */
                        function MutateAdGroupBidModifierResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupBidModifierResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifierResult
                         * @instance
                         */
                        MutateAdGroupBidModifierResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateAdGroupBidModifierResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifierResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupBidModifierResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupBidModifierResult} MutateAdGroupBidModifierResult instance
                         */
                        MutateAdGroupBidModifierResult.create = function create(properties) {
                            return new MutateAdGroupBidModifierResult(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupBidModifierResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupBidModifierResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifierResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupBidModifierResult} message MutateAdGroupBidModifierResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupBidModifierResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupBidModifierResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupBidModifierResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifierResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupBidModifierResult} message MutateAdGroupBidModifierResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupBidModifierResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupBidModifierResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifierResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupBidModifierResult} MutateAdGroupBidModifierResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupBidModifierResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupBidModifierResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupBidModifierResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifierResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupBidModifierResult} MutateAdGroupBidModifierResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupBidModifierResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupBidModifierResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifierResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupBidModifierResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupBidModifierResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifierResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupBidModifierResult} MutateAdGroupBidModifierResult
                         */
                        MutateAdGroupBidModifierResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupBidModifierResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupBidModifierResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupBidModifierResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifierResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupBidModifierResult} message MutateAdGroupBidModifierResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupBidModifierResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupBidModifierResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupBidModifierResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupBidModifierResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupBidModifierResult;
                    })();

                    services.AdGroupCriterionLabelService = (function() {

                        /**
                         * Constructs a new AdGroupCriterionLabelService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupCriterionLabelService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AdGroupCriterionLabelService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (AdGroupCriterionLabelService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AdGroupCriterionLabelService;

                        /**
                         * Creates new AdGroupCriterionLabelService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AdGroupCriterionLabelService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AdGroupCriterionLabelService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupCriterionLabelService#getAdGroupCriterionLabel}.
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelService
                         * @typedef GetAdGroupCriterionLabelCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.AdGroupCriterionLabel} [response] AdGroupCriterionLabel
                         */

                        /**
                         * Calls GetAdGroupCriterionLabel.
                         * @function getAdGroupCriterionLabel
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupCriterionLabelRequest} request GetAdGroupCriterionLabelRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupCriterionLabelService.GetAdGroupCriterionLabelCallback} callback Node-style callback called with the error, if any, and AdGroupCriterionLabel
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupCriterionLabelService.prototype.getAdGroupCriterionLabel = function getAdGroupCriterionLabel(request, callback) {
                            return this.rpcCall(getAdGroupCriterionLabel, $root.google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest, $root.google.ads.googleads.v1.resources.AdGroupCriterionLabel, request, callback);
                        }, "name", { value: "GetAdGroupCriterionLabel" });

                        /**
                         * Calls GetAdGroupCriterionLabel.
                         * @function getAdGroupCriterionLabel
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupCriterionLabelRequest} request GetAdGroupCriterionLabelRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.AdGroupCriterionLabel>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupCriterionLabelService#mutateAdGroupCriterionLabels}.
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelService
                         * @typedef MutateAdGroupCriterionLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse} [response] MutateAdGroupCriterionLabelsResponse
                         */

                        /**
                         * Calls MutateAdGroupCriterionLabels.
                         * @function mutateAdGroupCriterionLabels
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriterionLabelsRequest} request MutateAdGroupCriterionLabelsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupCriterionLabelService.MutateAdGroupCriterionLabelsCallback} callback Node-style callback called with the error, if any, and MutateAdGroupCriterionLabelsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupCriterionLabelService.prototype.mutateAdGroupCriterionLabels = function mutateAdGroupCriterionLabels(request, callback) {
                            return this.rpcCall(mutateAdGroupCriterionLabels, $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest, $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse, request, callback);
                        }, "name", { value: "MutateAdGroupCriterionLabels" });

                        /**
                         * Calls MutateAdGroupCriterionLabels.
                         * @function mutateAdGroupCriterionLabels
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriterionLabelsRequest} request MutateAdGroupCriterionLabelsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse>} Promise
                         * @variation 2
                         */

                        return AdGroupCriterionLabelService;
                    })();

                    services.GetAdGroupCriterionLabelRequest = (function() {

                        /**
                         * Properties of a GetAdGroupCriterionLabelRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetAdGroupCriterionLabelRequest
                         * @property {string|null} [resourceName] GetAdGroupCriterionLabelRequest resourceName
                         */

                        /**
                         * Constructs a new GetAdGroupCriterionLabelRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetAdGroupCriterionLabelRequest.
                         * @implements IGetAdGroupCriterionLabelRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetAdGroupCriterionLabelRequest=} [properties] Properties to set
                         */
                        function GetAdGroupCriterionLabelRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetAdGroupCriterionLabelRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest
                         * @instance
                         */
                        GetAdGroupCriterionLabelRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetAdGroupCriterionLabelRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupCriterionLabelRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest} GetAdGroupCriterionLabelRequest instance
                         */
                        GetAdGroupCriterionLabelRequest.create = function create(properties) {
                            return new GetAdGroupCriterionLabelRequest(properties);
                        };

                        /**
                         * Encodes the specified GetAdGroupCriterionLabelRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupCriterionLabelRequest} message GetAdGroupCriterionLabelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupCriterionLabelRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetAdGroupCriterionLabelRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupCriterionLabelRequest} message GetAdGroupCriterionLabelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupCriterionLabelRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetAdGroupCriterionLabelRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest} GetAdGroupCriterionLabelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupCriterionLabelRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetAdGroupCriterionLabelRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest} GetAdGroupCriterionLabelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupCriterionLabelRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetAdGroupCriterionLabelRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAdGroupCriterionLabelRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetAdGroupCriterionLabelRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest} GetAdGroupCriterionLabelRequest
                         */
                        GetAdGroupCriterionLabelRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetAdGroupCriterionLabelRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest} message GetAdGroupCriterionLabelRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAdGroupCriterionLabelRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetAdGroupCriterionLabelRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionLabelRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAdGroupCriterionLabelRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetAdGroupCriterionLabelRequest;
                    })();

                    services.MutateAdGroupCriterionLabelsRequest = (function() {

                        /**
                         * Properties of a MutateAdGroupCriterionLabelsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupCriterionLabelsRequest
                         * @property {string|null} [customerId] MutateAdGroupCriterionLabelsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IAdGroupCriterionLabelOperation>|null} [operations] MutateAdGroupCriterionLabelsRequest operations
                         * @property {boolean|null} [partialFailure] MutateAdGroupCriterionLabelsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateAdGroupCriterionLabelsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateAdGroupCriterionLabelsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupCriterionLabelsRequest.
                         * @implements IMutateAdGroupCriterionLabelsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriterionLabelsRequest=} [properties] Properties to set
                         */
                        function MutateAdGroupCriterionLabelsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupCriterionLabelsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest
                         * @instance
                         */
                        MutateAdGroupCriterionLabelsRequest.prototype.customerId = "";

                        /**
                         * MutateAdGroupCriterionLabelsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IAdGroupCriterionLabelOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest
                         * @instance
                         */
                        MutateAdGroupCriterionLabelsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateAdGroupCriterionLabelsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest
                         * @instance
                         */
                        MutateAdGroupCriterionLabelsRequest.prototype.partialFailure = false;

                        /**
                         * MutateAdGroupCriterionLabelsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest
                         * @instance
                         */
                        MutateAdGroupCriterionLabelsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateAdGroupCriterionLabelsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriterionLabelsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest} MutateAdGroupCriterionLabelsRequest instance
                         */
                        MutateAdGroupCriterionLabelsRequest.create = function create(properties) {
                            return new MutateAdGroupCriterionLabelsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupCriterionLabelsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriterionLabelsRequest} message MutateAdGroupCriterionLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupCriterionLabelsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.AdGroupCriterionLabelOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupCriterionLabelsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriterionLabelsRequest} message MutateAdGroupCriterionLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupCriterionLabelsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupCriterionLabelsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest} MutateAdGroupCriterionLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupCriterionLabelsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.AdGroupCriterionLabelOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupCriterionLabelsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest} MutateAdGroupCriterionLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupCriterionLabelsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupCriterionLabelsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupCriterionLabelsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.AdGroupCriterionLabelOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupCriterionLabelsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest} MutateAdGroupCriterionLabelsRequest
                         */
                        MutateAdGroupCriterionLabelsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.AdGroupCriterionLabelOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupCriterionLabelsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest} message MutateAdGroupCriterionLabelsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupCriterionLabelsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.AdGroupCriterionLabelOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupCriterionLabelsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupCriterionLabelsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupCriterionLabelsRequest;
                    })();

                    services.AdGroupCriterionLabelOperation = (function() {

                        /**
                         * Properties of an AdGroupCriterionLabelOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IAdGroupCriterionLabelOperation
                         * @property {google.ads.googleads.v1.resources.IAdGroupCriterionLabel|null} [create] AdGroupCriterionLabelOperation create
                         * @property {string|null} [remove] AdGroupCriterionLabelOperation remove
                         */

                        /**
                         * Constructs a new AdGroupCriterionLabelOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupCriterionLabelOperation.
                         * @implements IAdGroupCriterionLabelOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IAdGroupCriterionLabelOperation=} [properties] Properties to set
                         */
                        function AdGroupCriterionLabelOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupCriterionLabelOperation create.
                         * @member {google.ads.googleads.v1.resources.IAdGroupCriterionLabel|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelOperation
                         * @instance
                         */
                        AdGroupCriterionLabelOperation.prototype.create = null;

                        /**
                         * AdGroupCriterionLabelOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelOperation
                         * @instance
                         */
                        AdGroupCriterionLabelOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AdGroupCriterionLabelOperation operation.
                         * @member {"create"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelOperation
                         * @instance
                         */
                        Object.defineProperty(AdGroupCriterionLabelOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AdGroupCriterionLabelOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupCriterionLabelOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.AdGroupCriterionLabelOperation} AdGroupCriterionLabelOperation instance
                         */
                        AdGroupCriterionLabelOperation.create = function create(properties) {
                            return new AdGroupCriterionLabelOperation(properties);
                        };

                        /**
                         * Encodes the specified AdGroupCriterionLabelOperation message. Does not implicitly {@link google.ads.googleads.v1.services.AdGroupCriterionLabelOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupCriterionLabelOperation} message AdGroupCriterionLabelOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupCriterionLabelOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.AdGroupCriterionLabel.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.remove);
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupCriterionLabelOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.AdGroupCriterionLabelOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupCriterionLabelOperation} message AdGroupCriterionLabelOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupCriterionLabelOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupCriterionLabelOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.AdGroupCriterionLabelOperation} AdGroupCriterionLabelOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupCriterionLabelOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.AdGroupCriterionLabelOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.AdGroupCriterionLabel.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupCriterionLabelOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.AdGroupCriterionLabelOperation} AdGroupCriterionLabelOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupCriterionLabelOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupCriterionLabelOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupCriterionLabelOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.AdGroupCriterionLabel.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates an AdGroupCriterionLabelOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.AdGroupCriterionLabelOperation} AdGroupCriterionLabelOperation
                         */
                        AdGroupCriterionLabelOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.AdGroupCriterionLabelOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.AdGroupCriterionLabelOperation();
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupCriterionLabelOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.AdGroupCriterionLabel.fromObject(object.create);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupCriterionLabelOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.AdGroupCriterionLabelOperation} message AdGroupCriterionLabelOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupCriterionLabelOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.AdGroupCriterionLabel.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            return object;
                        };

                        /**
                         * Converts this AdGroupCriterionLabelOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionLabelOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupCriterionLabelOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupCriterionLabelOperation;
                    })();

                    services.MutateAdGroupCriterionLabelsResponse = (function() {

                        /**
                         * Properties of a MutateAdGroupCriterionLabelsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupCriterionLabelsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateAdGroupCriterionLabelsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateAdGroupCriterionLabelResult>|null} [results] MutateAdGroupCriterionLabelsResponse results
                         */

                        /**
                         * Constructs a new MutateAdGroupCriterionLabelsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupCriterionLabelsResponse.
                         * @implements IMutateAdGroupCriterionLabelsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriterionLabelsResponse=} [properties] Properties to set
                         */
                        function MutateAdGroupCriterionLabelsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupCriterionLabelsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse
                         * @instance
                         */
                        MutateAdGroupCriterionLabelsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateAdGroupCriterionLabelsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateAdGroupCriterionLabelResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse
                         * @instance
                         */
                        MutateAdGroupCriterionLabelsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateAdGroupCriterionLabelsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriterionLabelsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse} MutateAdGroupCriterionLabelsResponse instance
                         */
                        MutateAdGroupCriterionLabelsResponse.create = function create(properties) {
                            return new MutateAdGroupCriterionLabelsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupCriterionLabelsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriterionLabelsResponse} message MutateAdGroupCriterionLabelsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupCriterionLabelsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupCriterionLabelsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriterionLabelsResponse} message MutateAdGroupCriterionLabelsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupCriterionLabelsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupCriterionLabelsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse} MutateAdGroupCriterionLabelsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupCriterionLabelsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupCriterionLabelsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse} MutateAdGroupCriterionLabelsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupCriterionLabelsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupCriterionLabelsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupCriterionLabelsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupCriterionLabelsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse} MutateAdGroupCriterionLabelsResponse
                         */
                        MutateAdGroupCriterionLabelsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupCriterionLabelsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse} message MutateAdGroupCriterionLabelsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupCriterionLabelsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupCriterionLabelsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupCriterionLabelsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupCriterionLabelsResponse;
                    })();

                    services.MutateAdGroupCriterionLabelResult = (function() {

                        /**
                         * Properties of a MutateAdGroupCriterionLabelResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupCriterionLabelResult
                         * @property {string|null} [resourceName] MutateAdGroupCriterionLabelResult resourceName
                         */

                        /**
                         * Constructs a new MutateAdGroupCriterionLabelResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupCriterionLabelResult.
                         * @implements IMutateAdGroupCriterionLabelResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriterionLabelResult=} [properties] Properties to set
                         */
                        function MutateAdGroupCriterionLabelResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupCriterionLabelResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult
                         * @instance
                         */
                        MutateAdGroupCriterionLabelResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateAdGroupCriterionLabelResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriterionLabelResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult} MutateAdGroupCriterionLabelResult instance
                         */
                        MutateAdGroupCriterionLabelResult.create = function create(properties) {
                            return new MutateAdGroupCriterionLabelResult(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupCriterionLabelResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriterionLabelResult} message MutateAdGroupCriterionLabelResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupCriterionLabelResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupCriterionLabelResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriterionLabelResult} message MutateAdGroupCriterionLabelResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupCriterionLabelResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupCriterionLabelResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult} MutateAdGroupCriterionLabelResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupCriterionLabelResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupCriterionLabelResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult} MutateAdGroupCriterionLabelResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupCriterionLabelResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupCriterionLabelResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupCriterionLabelResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupCriterionLabelResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult} MutateAdGroupCriterionLabelResult
                         */
                        MutateAdGroupCriterionLabelResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupCriterionLabelResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult} message MutateAdGroupCriterionLabelResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupCriterionLabelResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupCriterionLabelResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupCriterionLabelResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupCriterionLabelResult;
                    })();

                    services.AdGroupCriterionService = (function() {

                        /**
                         * Constructs a new AdGroupCriterionService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupCriterionService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AdGroupCriterionService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (AdGroupCriterionService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AdGroupCriterionService;

                        /**
                         * Creates new AdGroupCriterionService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AdGroupCriterionService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AdGroupCriterionService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupCriterionService#getAdGroupCriterion}.
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionService
                         * @typedef GetAdGroupCriterionCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.AdGroupCriterion} [response] AdGroupCriterion
                         */

                        /**
                         * Calls GetAdGroupCriterion.
                         * @function getAdGroupCriterion
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupCriterionRequest} request GetAdGroupCriterionRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupCriterionService.GetAdGroupCriterionCallback} callback Node-style callback called with the error, if any, and AdGroupCriterion
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupCriterionService.prototype.getAdGroupCriterion = function getAdGroupCriterion(request, callback) {
                            return this.rpcCall(getAdGroupCriterion, $root.google.ads.googleads.v1.services.GetAdGroupCriterionRequest, $root.google.ads.googleads.v1.resources.AdGroupCriterion, request, callback);
                        }, "name", { value: "GetAdGroupCriterion" });

                        /**
                         * Calls GetAdGroupCriterion.
                         * @function getAdGroupCriterion
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupCriterionRequest} request GetAdGroupCriterionRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.AdGroupCriterion>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupCriterionService#mutateAdGroupCriteria}.
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionService
                         * @typedef MutateAdGroupCriteriaCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse} [response] MutateAdGroupCriteriaResponse
                         */

                        /**
                         * Calls MutateAdGroupCriteria.
                         * @function mutateAdGroupCriteria
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriteriaRequest} request MutateAdGroupCriteriaRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupCriterionService.MutateAdGroupCriteriaCallback} callback Node-style callback called with the error, if any, and MutateAdGroupCriteriaResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupCriterionService.prototype.mutateAdGroupCriteria = function mutateAdGroupCriteria(request, callback) {
                            return this.rpcCall(mutateAdGroupCriteria, $root.google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest, $root.google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse, request, callback);
                        }, "name", { value: "MutateAdGroupCriteria" });

                        /**
                         * Calls MutateAdGroupCriteria.
                         * @function mutateAdGroupCriteria
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriteriaRequest} request MutateAdGroupCriteriaRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse>} Promise
                         * @variation 2
                         */

                        return AdGroupCriterionService;
                    })();

                    services.GetAdGroupCriterionRequest = (function() {

                        /**
                         * Properties of a GetAdGroupCriterionRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetAdGroupCriterionRequest
                         * @property {string|null} [resourceName] GetAdGroupCriterionRequest resourceName
                         */

                        /**
                         * Constructs a new GetAdGroupCriterionRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetAdGroupCriterionRequest.
                         * @implements IGetAdGroupCriterionRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetAdGroupCriterionRequest=} [properties] Properties to set
                         */
                        function GetAdGroupCriterionRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetAdGroupCriterionRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionRequest
                         * @instance
                         */
                        GetAdGroupCriterionRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetAdGroupCriterionRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupCriterionRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetAdGroupCriterionRequest} GetAdGroupCriterionRequest instance
                         */
                        GetAdGroupCriterionRequest.create = function create(properties) {
                            return new GetAdGroupCriterionRequest(properties);
                        };

                        /**
                         * Encodes the specified GetAdGroupCriterionRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupCriterionRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupCriterionRequest} message GetAdGroupCriterionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupCriterionRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetAdGroupCriterionRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupCriterionRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupCriterionRequest} message GetAdGroupCriterionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupCriterionRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetAdGroupCriterionRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetAdGroupCriterionRequest} GetAdGroupCriterionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupCriterionRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetAdGroupCriterionRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetAdGroupCriterionRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetAdGroupCriterionRequest} GetAdGroupCriterionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupCriterionRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetAdGroupCriterionRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAdGroupCriterionRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetAdGroupCriterionRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetAdGroupCriterionRequest} GetAdGroupCriterionRequest
                         */
                        GetAdGroupCriterionRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetAdGroupCriterionRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetAdGroupCriterionRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetAdGroupCriterionRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetAdGroupCriterionRequest} message GetAdGroupCriterionRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAdGroupCriterionRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetAdGroupCriterionRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAdGroupCriterionRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetAdGroupCriterionRequest;
                    })();

                    services.MutateAdGroupCriteriaRequest = (function() {

                        /**
                         * Properties of a MutateAdGroupCriteriaRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupCriteriaRequest
                         * @property {string|null} [customerId] MutateAdGroupCriteriaRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IAdGroupCriterionOperation>|null} [operations] MutateAdGroupCriteriaRequest operations
                         * @property {boolean|null} [partialFailure] MutateAdGroupCriteriaRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateAdGroupCriteriaRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateAdGroupCriteriaRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupCriteriaRequest.
                         * @implements IMutateAdGroupCriteriaRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriteriaRequest=} [properties] Properties to set
                         */
                        function MutateAdGroupCriteriaRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupCriteriaRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest
                         * @instance
                         */
                        MutateAdGroupCriteriaRequest.prototype.customerId = "";

                        /**
                         * MutateAdGroupCriteriaRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IAdGroupCriterionOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest
                         * @instance
                         */
                        MutateAdGroupCriteriaRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateAdGroupCriteriaRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest
                         * @instance
                         */
                        MutateAdGroupCriteriaRequest.prototype.partialFailure = false;

                        /**
                         * MutateAdGroupCriteriaRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest
                         * @instance
                         */
                        MutateAdGroupCriteriaRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateAdGroupCriteriaRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriteriaRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest} MutateAdGroupCriteriaRequest instance
                         */
                        MutateAdGroupCriteriaRequest.create = function create(properties) {
                            return new MutateAdGroupCriteriaRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupCriteriaRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriteriaRequest} message MutateAdGroupCriteriaRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupCriteriaRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.AdGroupCriterionOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupCriteriaRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriteriaRequest} message MutateAdGroupCriteriaRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupCriteriaRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupCriteriaRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest} MutateAdGroupCriteriaRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupCriteriaRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.AdGroupCriterionOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupCriteriaRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest} MutateAdGroupCriteriaRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupCriteriaRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupCriteriaRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupCriteriaRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.AdGroupCriterionOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupCriteriaRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest} MutateAdGroupCriteriaRequest
                         */
                        MutateAdGroupCriteriaRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.AdGroupCriterionOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupCriteriaRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest} message MutateAdGroupCriteriaRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupCriteriaRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.AdGroupCriterionOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupCriteriaRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupCriteriaRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupCriteriaRequest;
                    })();

                    services.AdGroupCriterionOperation = (function() {

                        /**
                         * Properties of an AdGroupCriterionOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IAdGroupCriterionOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] AdGroupCriterionOperation updateMask
                         * @property {Array.<google.ads.googleads.v1.common.IPolicyViolationKey>|null} [exemptPolicyViolationKeys] AdGroupCriterionOperation exemptPolicyViolationKeys
                         * @property {google.ads.googleads.v1.resources.IAdGroupCriterion|null} [create] AdGroupCriterionOperation create
                         * @property {google.ads.googleads.v1.resources.IAdGroupCriterion|null} [update] AdGroupCriterionOperation update
                         * @property {string|null} [remove] AdGroupCriterionOperation remove
                         */

                        /**
                         * Constructs a new AdGroupCriterionOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupCriterionOperation.
                         * @implements IAdGroupCriterionOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IAdGroupCriterionOperation=} [properties] Properties to set
                         */
                        function AdGroupCriterionOperation(properties) {
                            this.exemptPolicyViolationKeys = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupCriterionOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionOperation
                         * @instance
                         */
                        AdGroupCriterionOperation.prototype.updateMask = null;

                        /**
                         * AdGroupCriterionOperation exemptPolicyViolationKeys.
                         * @member {Array.<google.ads.googleads.v1.common.IPolicyViolationKey>} exemptPolicyViolationKeys
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionOperation
                         * @instance
                         */
                        AdGroupCriterionOperation.prototype.exemptPolicyViolationKeys = $util.emptyArray;

                        /**
                         * AdGroupCriterionOperation create.
                         * @member {google.ads.googleads.v1.resources.IAdGroupCriterion|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionOperation
                         * @instance
                         */
                        AdGroupCriterionOperation.prototype.create = null;

                        /**
                         * AdGroupCriterionOperation update.
                         * @member {google.ads.googleads.v1.resources.IAdGroupCriterion|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionOperation
                         * @instance
                         */
                        AdGroupCriterionOperation.prototype.update = null;

                        /**
                         * AdGroupCriterionOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionOperation
                         * @instance
                         */
                        AdGroupCriterionOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AdGroupCriterionOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionOperation
                         * @instance
                         */
                        Object.defineProperty(AdGroupCriterionOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AdGroupCriterionOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupCriterionOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.AdGroupCriterionOperation} AdGroupCriterionOperation instance
                         */
                        AdGroupCriterionOperation.create = function create(properties) {
                            return new AdGroupCriterionOperation(properties);
                        };

                        /**
                         * Encodes the specified AdGroupCriterionOperation message. Does not implicitly {@link google.ads.googleads.v1.services.AdGroupCriterionOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupCriterionOperation} message AdGroupCriterionOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupCriterionOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.AdGroupCriterion.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.AdGroupCriterion.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.exemptPolicyViolationKeys != null && message.exemptPolicyViolationKeys.length)
                                for (var i = 0; i < message.exemptPolicyViolationKeys.length; ++i)
                                    $root.google.ads.googleads.v1.common.PolicyViolationKey.encode(message.exemptPolicyViolationKeys[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupCriterionOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.AdGroupCriterionOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupCriterionOperation} message AdGroupCriterionOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupCriterionOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupCriterionOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.AdGroupCriterionOperation} AdGroupCriterionOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupCriterionOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.AdGroupCriterionOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    if (!(message.exemptPolicyViolationKeys && message.exemptPolicyViolationKeys.length))
                                        message.exemptPolicyViolationKeys = [];
                                    message.exemptPolicyViolationKeys.push($root.google.ads.googleads.v1.common.PolicyViolationKey.decode(reader, reader.uint32()));
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.AdGroupCriterion.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.AdGroupCriterion.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupCriterionOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.AdGroupCriterionOperation} AdGroupCriterionOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupCriterionOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupCriterionOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupCriterionOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.exemptPolicyViolationKeys != null && message.hasOwnProperty("exemptPolicyViolationKeys")) {
                                if (!Array.isArray(message.exemptPolicyViolationKeys))
                                    return "exemptPolicyViolationKeys: array expected";
                                for (var i = 0; i < message.exemptPolicyViolationKeys.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.common.PolicyViolationKey.verify(message.exemptPolicyViolationKeys[i]);
                                    if (error)
                                        return "exemptPolicyViolationKeys." + error;
                                }
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.AdGroupCriterion.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.AdGroupCriterion.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates an AdGroupCriterionOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.AdGroupCriterionOperation} AdGroupCriterionOperation
                         */
                        AdGroupCriterionOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.AdGroupCriterionOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.AdGroupCriterionOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupCriterionOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.exemptPolicyViolationKeys) {
                                if (!Array.isArray(object.exemptPolicyViolationKeys))
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupCriterionOperation.exemptPolicyViolationKeys: array expected");
                                message.exemptPolicyViolationKeys = [];
                                for (var i = 0; i < object.exemptPolicyViolationKeys.length; ++i) {
                                    if (typeof object.exemptPolicyViolationKeys[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.AdGroupCriterionOperation.exemptPolicyViolationKeys: object expected");
                                    message.exemptPolicyViolationKeys[i] = $root.google.ads.googleads.v1.common.PolicyViolationKey.fromObject(object.exemptPolicyViolationKeys[i]);
                                }
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupCriterionOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.AdGroupCriterion.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupCriterionOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.AdGroupCriterion.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupCriterionOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.AdGroupCriterionOperation} message AdGroupCriterionOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupCriterionOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.exemptPolicyViolationKeys = [];
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.AdGroupCriterion.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.AdGroupCriterion.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            if (message.exemptPolicyViolationKeys && message.exemptPolicyViolationKeys.length) {
                                object.exemptPolicyViolationKeys = [];
                                for (var j = 0; j < message.exemptPolicyViolationKeys.length; ++j)
                                    object.exemptPolicyViolationKeys[j] = $root.google.ads.googleads.v1.common.PolicyViolationKey.toObject(message.exemptPolicyViolationKeys[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this AdGroupCriterionOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupCriterionOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupCriterionOperation;
                    })();

                    services.MutateAdGroupCriteriaResponse = (function() {

                        /**
                         * Properties of a MutateAdGroupCriteriaResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupCriteriaResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateAdGroupCriteriaResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateAdGroupCriterionResult>|null} [results] MutateAdGroupCriteriaResponse results
                         */

                        /**
                         * Constructs a new MutateAdGroupCriteriaResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupCriteriaResponse.
                         * @implements IMutateAdGroupCriteriaResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriteriaResponse=} [properties] Properties to set
                         */
                        function MutateAdGroupCriteriaResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupCriteriaResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse
                         * @instance
                         */
                        MutateAdGroupCriteriaResponse.prototype.partialFailureError = null;

                        /**
                         * MutateAdGroupCriteriaResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateAdGroupCriterionResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse
                         * @instance
                         */
                        MutateAdGroupCriteriaResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateAdGroupCriteriaResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriteriaResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse} MutateAdGroupCriteriaResponse instance
                         */
                        MutateAdGroupCriteriaResponse.create = function create(properties) {
                            return new MutateAdGroupCriteriaResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupCriteriaResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriteriaResponse} message MutateAdGroupCriteriaResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupCriteriaResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateAdGroupCriterionResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupCriteriaResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriteriaResponse} message MutateAdGroupCriteriaResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupCriteriaResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupCriteriaResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse} MutateAdGroupCriteriaResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupCriteriaResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateAdGroupCriterionResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupCriteriaResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse} MutateAdGroupCriteriaResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupCriteriaResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupCriteriaResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupCriteriaResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdGroupCriterionResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupCriteriaResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse} MutateAdGroupCriteriaResponse
                         */
                        MutateAdGroupCriteriaResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateAdGroupCriterionResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupCriteriaResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse} message MutateAdGroupCriteriaResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupCriteriaResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateAdGroupCriterionResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupCriteriaResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriteriaResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupCriteriaResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupCriteriaResponse;
                    })();

                    services.MutateAdGroupCriterionResult = (function() {

                        /**
                         * Properties of a MutateAdGroupCriterionResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupCriterionResult
                         * @property {string|null} [resourceName] MutateAdGroupCriterionResult resourceName
                         */

                        /**
                         * Constructs a new MutateAdGroupCriterionResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupCriterionResult.
                         * @implements IMutateAdGroupCriterionResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriterionResult=} [properties] Properties to set
                         */
                        function MutateAdGroupCriterionResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupCriterionResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionResult
                         * @instance
                         */
                        MutateAdGroupCriterionResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateAdGroupCriterionResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriterionResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriterionResult} MutateAdGroupCriterionResult instance
                         */
                        MutateAdGroupCriterionResult.create = function create(properties) {
                            return new MutateAdGroupCriterionResult(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupCriterionResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupCriterionResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriterionResult} message MutateAdGroupCriterionResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupCriterionResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupCriterionResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupCriterionResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupCriterionResult} message MutateAdGroupCriterionResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupCriterionResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupCriterionResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriterionResult} MutateAdGroupCriterionResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupCriterionResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupCriterionResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupCriterionResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriterionResult} MutateAdGroupCriterionResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupCriterionResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupCriterionResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupCriterionResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupCriterionResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupCriterionResult} MutateAdGroupCriterionResult
                         */
                        MutateAdGroupCriterionResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupCriterionResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupCriterionResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupCriterionResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupCriterionResult} message MutateAdGroupCriterionResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupCriterionResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupCriterionResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupCriterionResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupCriterionResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupCriterionResult;
                    })();

                    services.AdGroupCriterionSimulationService = (function() {

                        /**
                         * Constructs a new AdGroupCriterionSimulationService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupCriterionSimulationService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AdGroupCriterionSimulationService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (AdGroupCriterionSimulationService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AdGroupCriterionSimulationService;

                        /**
                         * Creates new AdGroupCriterionSimulationService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionSimulationService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AdGroupCriterionSimulationService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AdGroupCriterionSimulationService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupCriterionSimulationService#getAdGroupCriterionSimulation}.
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionSimulationService
                         * @typedef GetAdGroupCriterionSimulationCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.AdGroupCriterionSimulation} [response] AdGroupCriterionSimulation
                         */

                        /**
                         * Calls GetAdGroupCriterionSimulation.
                         * @function getAdGroupCriterionSimulation
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionSimulationService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupCriterionSimulationRequest} request GetAdGroupCriterionSimulationRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupCriterionSimulationService.GetAdGroupCriterionSimulationCallback} callback Node-style callback called with the error, if any, and AdGroupCriterionSimulation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupCriterionSimulationService.prototype.getAdGroupCriterionSimulation = function getAdGroupCriterionSimulation(request, callback) {
                            return this.rpcCall(getAdGroupCriterionSimulation, $root.google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest, $root.google.ads.googleads.v1.resources.AdGroupCriterionSimulation, request, callback);
                        }, "name", { value: "GetAdGroupCriterionSimulation" });

                        /**
                         * Calls GetAdGroupCriterionSimulation.
                         * @function getAdGroupCriterionSimulation
                         * @memberof google.ads.googleads.v1.services.AdGroupCriterionSimulationService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupCriterionSimulationRequest} request GetAdGroupCriterionSimulationRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.AdGroupCriterionSimulation>} Promise
                         * @variation 2
                         */

                        return AdGroupCriterionSimulationService;
                    })();

                    services.GetAdGroupCriterionSimulationRequest = (function() {

                        /**
                         * Properties of a GetAdGroupCriterionSimulationRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetAdGroupCriterionSimulationRequest
                         * @property {string|null} [resourceName] GetAdGroupCriterionSimulationRequest resourceName
                         */

                        /**
                         * Constructs a new GetAdGroupCriterionSimulationRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetAdGroupCriterionSimulationRequest.
                         * @implements IGetAdGroupCriterionSimulationRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetAdGroupCriterionSimulationRequest=} [properties] Properties to set
                         */
                        function GetAdGroupCriterionSimulationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetAdGroupCriterionSimulationRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest
                         * @instance
                         */
                        GetAdGroupCriterionSimulationRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetAdGroupCriterionSimulationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupCriterionSimulationRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest} GetAdGroupCriterionSimulationRequest instance
                         */
                        GetAdGroupCriterionSimulationRequest.create = function create(properties) {
                            return new GetAdGroupCriterionSimulationRequest(properties);
                        };

                        /**
                         * Encodes the specified GetAdGroupCriterionSimulationRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupCriterionSimulationRequest} message GetAdGroupCriterionSimulationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupCriterionSimulationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetAdGroupCriterionSimulationRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupCriterionSimulationRequest} message GetAdGroupCriterionSimulationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupCriterionSimulationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetAdGroupCriterionSimulationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest} GetAdGroupCriterionSimulationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupCriterionSimulationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetAdGroupCriterionSimulationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest} GetAdGroupCriterionSimulationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupCriterionSimulationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetAdGroupCriterionSimulationRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAdGroupCriterionSimulationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetAdGroupCriterionSimulationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest} GetAdGroupCriterionSimulationRequest
                         */
                        GetAdGroupCriterionSimulationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetAdGroupCriterionSimulationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest} message GetAdGroupCriterionSimulationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAdGroupCriterionSimulationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetAdGroupCriterionSimulationRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetAdGroupCriterionSimulationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAdGroupCriterionSimulationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetAdGroupCriterionSimulationRequest;
                    })();

                    services.AdGroupExtensionSettingService = (function() {

                        /**
                         * Constructs a new AdGroupExtensionSettingService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupExtensionSettingService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AdGroupExtensionSettingService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (AdGroupExtensionSettingService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AdGroupExtensionSettingService;

                        /**
                         * Creates new AdGroupExtensionSettingService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AdGroupExtensionSettingService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AdGroupExtensionSettingService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupExtensionSettingService#getAdGroupExtensionSetting}.
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingService
                         * @typedef GetAdGroupExtensionSettingCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.AdGroupExtensionSetting} [response] AdGroupExtensionSetting
                         */

                        /**
                         * Calls GetAdGroupExtensionSetting.
                         * @function getAdGroupExtensionSetting
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupExtensionSettingRequest} request GetAdGroupExtensionSettingRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupExtensionSettingService.GetAdGroupExtensionSettingCallback} callback Node-style callback called with the error, if any, and AdGroupExtensionSetting
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupExtensionSettingService.prototype.getAdGroupExtensionSetting = function getAdGroupExtensionSetting(request, callback) {
                            return this.rpcCall(getAdGroupExtensionSetting, $root.google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest, $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting, request, callback);
                        }, "name", { value: "GetAdGroupExtensionSetting" });

                        /**
                         * Calls GetAdGroupExtensionSetting.
                         * @function getAdGroupExtensionSetting
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupExtensionSettingRequest} request GetAdGroupExtensionSettingRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.AdGroupExtensionSetting>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupExtensionSettingService#mutateAdGroupExtensionSettings}.
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingService
                         * @typedef MutateAdGroupExtensionSettingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse} [response] MutateAdGroupExtensionSettingsResponse
                         */

                        /**
                         * Calls MutateAdGroupExtensionSettings.
                         * @function mutateAdGroupExtensionSettings
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupExtensionSettingsRequest} request MutateAdGroupExtensionSettingsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupExtensionSettingService.MutateAdGroupExtensionSettingsCallback} callback Node-style callback called with the error, if any, and MutateAdGroupExtensionSettingsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupExtensionSettingService.prototype.mutateAdGroupExtensionSettings = function mutateAdGroupExtensionSettings(request, callback) {
                            return this.rpcCall(mutateAdGroupExtensionSettings, $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest, $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse, request, callback);
                        }, "name", { value: "MutateAdGroupExtensionSettings" });

                        /**
                         * Calls MutateAdGroupExtensionSettings.
                         * @function mutateAdGroupExtensionSettings
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupExtensionSettingsRequest} request MutateAdGroupExtensionSettingsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse>} Promise
                         * @variation 2
                         */

                        return AdGroupExtensionSettingService;
                    })();

                    services.GetAdGroupExtensionSettingRequest = (function() {

                        /**
                         * Properties of a GetAdGroupExtensionSettingRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetAdGroupExtensionSettingRequest
                         * @property {string|null} [resourceName] GetAdGroupExtensionSettingRequest resourceName
                         */

                        /**
                         * Constructs a new GetAdGroupExtensionSettingRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetAdGroupExtensionSettingRequest.
                         * @implements IGetAdGroupExtensionSettingRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetAdGroupExtensionSettingRequest=} [properties] Properties to set
                         */
                        function GetAdGroupExtensionSettingRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetAdGroupExtensionSettingRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest
                         * @instance
                         */
                        GetAdGroupExtensionSettingRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetAdGroupExtensionSettingRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupExtensionSettingRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest} GetAdGroupExtensionSettingRequest instance
                         */
                        GetAdGroupExtensionSettingRequest.create = function create(properties) {
                            return new GetAdGroupExtensionSettingRequest(properties);
                        };

                        /**
                         * Encodes the specified GetAdGroupExtensionSettingRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupExtensionSettingRequest} message GetAdGroupExtensionSettingRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupExtensionSettingRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetAdGroupExtensionSettingRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupExtensionSettingRequest} message GetAdGroupExtensionSettingRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupExtensionSettingRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetAdGroupExtensionSettingRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest} GetAdGroupExtensionSettingRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupExtensionSettingRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetAdGroupExtensionSettingRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest} GetAdGroupExtensionSettingRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupExtensionSettingRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetAdGroupExtensionSettingRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAdGroupExtensionSettingRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetAdGroupExtensionSettingRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest} GetAdGroupExtensionSettingRequest
                         */
                        GetAdGroupExtensionSettingRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetAdGroupExtensionSettingRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest} message GetAdGroupExtensionSettingRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAdGroupExtensionSettingRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetAdGroupExtensionSettingRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetAdGroupExtensionSettingRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAdGroupExtensionSettingRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetAdGroupExtensionSettingRequest;
                    })();

                    services.MutateAdGroupExtensionSettingsRequest = (function() {

                        /**
                         * Properties of a MutateAdGroupExtensionSettingsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupExtensionSettingsRequest
                         * @property {string|null} [customerId] MutateAdGroupExtensionSettingsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IAdGroupExtensionSettingOperation>|null} [operations] MutateAdGroupExtensionSettingsRequest operations
                         * @property {boolean|null} [partialFailure] MutateAdGroupExtensionSettingsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateAdGroupExtensionSettingsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateAdGroupExtensionSettingsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupExtensionSettingsRequest.
                         * @implements IMutateAdGroupExtensionSettingsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupExtensionSettingsRequest=} [properties] Properties to set
                         */
                        function MutateAdGroupExtensionSettingsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupExtensionSettingsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest
                         * @instance
                         */
                        MutateAdGroupExtensionSettingsRequest.prototype.customerId = "";

                        /**
                         * MutateAdGroupExtensionSettingsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IAdGroupExtensionSettingOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest
                         * @instance
                         */
                        MutateAdGroupExtensionSettingsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateAdGroupExtensionSettingsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest
                         * @instance
                         */
                        MutateAdGroupExtensionSettingsRequest.prototype.partialFailure = false;

                        /**
                         * MutateAdGroupExtensionSettingsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest
                         * @instance
                         */
                        MutateAdGroupExtensionSettingsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateAdGroupExtensionSettingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupExtensionSettingsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest} MutateAdGroupExtensionSettingsRequest instance
                         */
                        MutateAdGroupExtensionSettingsRequest.create = function create(properties) {
                            return new MutateAdGroupExtensionSettingsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupExtensionSettingsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupExtensionSettingsRequest} message MutateAdGroupExtensionSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupExtensionSettingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.AdGroupExtensionSettingOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupExtensionSettingsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupExtensionSettingsRequest} message MutateAdGroupExtensionSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupExtensionSettingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupExtensionSettingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest} MutateAdGroupExtensionSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupExtensionSettingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.AdGroupExtensionSettingOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupExtensionSettingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest} MutateAdGroupExtensionSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupExtensionSettingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupExtensionSettingsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupExtensionSettingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.AdGroupExtensionSettingOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupExtensionSettingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest} MutateAdGroupExtensionSettingsRequest
                         */
                        MutateAdGroupExtensionSettingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.AdGroupExtensionSettingOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupExtensionSettingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest} message MutateAdGroupExtensionSettingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupExtensionSettingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.AdGroupExtensionSettingOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupExtensionSettingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupExtensionSettingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupExtensionSettingsRequest;
                    })();

                    services.AdGroupExtensionSettingOperation = (function() {

                        /**
                         * Properties of an AdGroupExtensionSettingOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IAdGroupExtensionSettingOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] AdGroupExtensionSettingOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IAdGroupExtensionSetting|null} [create] AdGroupExtensionSettingOperation create
                         * @property {google.ads.googleads.v1.resources.IAdGroupExtensionSetting|null} [update] AdGroupExtensionSettingOperation update
                         * @property {string|null} [remove] AdGroupExtensionSettingOperation remove
                         */

                        /**
                         * Constructs a new AdGroupExtensionSettingOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupExtensionSettingOperation.
                         * @implements IAdGroupExtensionSettingOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IAdGroupExtensionSettingOperation=} [properties] Properties to set
                         */
                        function AdGroupExtensionSettingOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupExtensionSettingOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingOperation
                         * @instance
                         */
                        AdGroupExtensionSettingOperation.prototype.updateMask = null;

                        /**
                         * AdGroupExtensionSettingOperation create.
                         * @member {google.ads.googleads.v1.resources.IAdGroupExtensionSetting|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingOperation
                         * @instance
                         */
                        AdGroupExtensionSettingOperation.prototype.create = null;

                        /**
                         * AdGroupExtensionSettingOperation update.
                         * @member {google.ads.googleads.v1.resources.IAdGroupExtensionSetting|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingOperation
                         * @instance
                         */
                        AdGroupExtensionSettingOperation.prototype.update = null;

                        /**
                         * AdGroupExtensionSettingOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingOperation
                         * @instance
                         */
                        AdGroupExtensionSettingOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AdGroupExtensionSettingOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingOperation
                         * @instance
                         */
                        Object.defineProperty(AdGroupExtensionSettingOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AdGroupExtensionSettingOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupExtensionSettingOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.AdGroupExtensionSettingOperation} AdGroupExtensionSettingOperation instance
                         */
                        AdGroupExtensionSettingOperation.create = function create(properties) {
                            return new AdGroupExtensionSettingOperation(properties);
                        };

                        /**
                         * Encodes the specified AdGroupExtensionSettingOperation message. Does not implicitly {@link google.ads.googleads.v1.services.AdGroupExtensionSettingOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupExtensionSettingOperation} message AdGroupExtensionSettingOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupExtensionSettingOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupExtensionSettingOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.AdGroupExtensionSettingOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupExtensionSettingOperation} message AdGroupExtensionSettingOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupExtensionSettingOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupExtensionSettingOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.AdGroupExtensionSettingOperation} AdGroupExtensionSettingOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupExtensionSettingOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.AdGroupExtensionSettingOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupExtensionSettingOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.AdGroupExtensionSettingOperation} AdGroupExtensionSettingOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupExtensionSettingOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupExtensionSettingOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupExtensionSettingOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates an AdGroupExtensionSettingOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.AdGroupExtensionSettingOperation} AdGroupExtensionSettingOperation
                         */
                        AdGroupExtensionSettingOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.AdGroupExtensionSettingOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.AdGroupExtensionSettingOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupExtensionSettingOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupExtensionSettingOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupExtensionSettingOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupExtensionSettingOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.AdGroupExtensionSettingOperation} message AdGroupExtensionSettingOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupExtensionSettingOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this AdGroupExtensionSettingOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.AdGroupExtensionSettingOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupExtensionSettingOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupExtensionSettingOperation;
                    })();

                    services.MutateAdGroupExtensionSettingsResponse = (function() {

                        /**
                         * Properties of a MutateAdGroupExtensionSettingsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupExtensionSettingsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateAdGroupExtensionSettingsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateAdGroupExtensionSettingResult>|null} [results] MutateAdGroupExtensionSettingsResponse results
                         */

                        /**
                         * Constructs a new MutateAdGroupExtensionSettingsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupExtensionSettingsResponse.
                         * @implements IMutateAdGroupExtensionSettingsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupExtensionSettingsResponse=} [properties] Properties to set
                         */
                        function MutateAdGroupExtensionSettingsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupExtensionSettingsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse
                         * @instance
                         */
                        MutateAdGroupExtensionSettingsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateAdGroupExtensionSettingsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateAdGroupExtensionSettingResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse
                         * @instance
                         */
                        MutateAdGroupExtensionSettingsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateAdGroupExtensionSettingsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupExtensionSettingsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse} MutateAdGroupExtensionSettingsResponse instance
                         */
                        MutateAdGroupExtensionSettingsResponse.create = function create(properties) {
                            return new MutateAdGroupExtensionSettingsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupExtensionSettingsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupExtensionSettingsResponse} message MutateAdGroupExtensionSettingsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupExtensionSettingsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupExtensionSettingsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupExtensionSettingsResponse} message MutateAdGroupExtensionSettingsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupExtensionSettingsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupExtensionSettingsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse} MutateAdGroupExtensionSettingsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupExtensionSettingsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupExtensionSettingsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse} MutateAdGroupExtensionSettingsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupExtensionSettingsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupExtensionSettingsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupExtensionSettingsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupExtensionSettingsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse} MutateAdGroupExtensionSettingsResponse
                         */
                        MutateAdGroupExtensionSettingsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupExtensionSettingsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse} message MutateAdGroupExtensionSettingsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupExtensionSettingsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupExtensionSettingsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupExtensionSettingsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupExtensionSettingsResponse;
                    })();

                    services.MutateAdGroupExtensionSettingResult = (function() {

                        /**
                         * Properties of a MutateAdGroupExtensionSettingResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupExtensionSettingResult
                         * @property {string|null} [resourceName] MutateAdGroupExtensionSettingResult resourceName
                         */

                        /**
                         * Constructs a new MutateAdGroupExtensionSettingResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupExtensionSettingResult.
                         * @implements IMutateAdGroupExtensionSettingResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupExtensionSettingResult=} [properties] Properties to set
                         */
                        function MutateAdGroupExtensionSettingResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupExtensionSettingResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult
                         * @instance
                         */
                        MutateAdGroupExtensionSettingResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateAdGroupExtensionSettingResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupExtensionSettingResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult} MutateAdGroupExtensionSettingResult instance
                         */
                        MutateAdGroupExtensionSettingResult.create = function create(properties) {
                            return new MutateAdGroupExtensionSettingResult(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupExtensionSettingResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupExtensionSettingResult} message MutateAdGroupExtensionSettingResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupExtensionSettingResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupExtensionSettingResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupExtensionSettingResult} message MutateAdGroupExtensionSettingResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupExtensionSettingResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupExtensionSettingResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult} MutateAdGroupExtensionSettingResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupExtensionSettingResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupExtensionSettingResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult} MutateAdGroupExtensionSettingResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupExtensionSettingResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupExtensionSettingResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupExtensionSettingResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupExtensionSettingResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult} MutateAdGroupExtensionSettingResult
                         */
                        MutateAdGroupExtensionSettingResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupExtensionSettingResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult} message MutateAdGroupExtensionSettingResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupExtensionSettingResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupExtensionSettingResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupExtensionSettingResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupExtensionSettingResult;
                    })();

                    services.AdGroupFeedService = (function() {

                        /**
                         * Constructs a new AdGroupFeedService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupFeedService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AdGroupFeedService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (AdGroupFeedService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AdGroupFeedService;

                        /**
                         * Creates new AdGroupFeedService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AdGroupFeedService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AdGroupFeedService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupFeedService#getAdGroupFeed}.
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedService
                         * @typedef GetAdGroupFeedCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.AdGroupFeed} [response] AdGroupFeed
                         */

                        /**
                         * Calls GetAdGroupFeed.
                         * @function getAdGroupFeed
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupFeedRequest} request GetAdGroupFeedRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupFeedService.GetAdGroupFeedCallback} callback Node-style callback called with the error, if any, and AdGroupFeed
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupFeedService.prototype.getAdGroupFeed = function getAdGroupFeed(request, callback) {
                            return this.rpcCall(getAdGroupFeed, $root.google.ads.googleads.v1.services.GetAdGroupFeedRequest, $root.google.ads.googleads.v1.resources.AdGroupFeed, request, callback);
                        }, "name", { value: "GetAdGroupFeed" });

                        /**
                         * Calls GetAdGroupFeed.
                         * @function getAdGroupFeed
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupFeedRequest} request GetAdGroupFeedRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.AdGroupFeed>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupFeedService#mutateAdGroupFeeds}.
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedService
                         * @typedef MutateAdGroupFeedsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateAdGroupFeedsResponse} [response] MutateAdGroupFeedsResponse
                         */

                        /**
                         * Calls MutateAdGroupFeeds.
                         * @function mutateAdGroupFeeds
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupFeedsRequest} request MutateAdGroupFeedsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupFeedService.MutateAdGroupFeedsCallback} callback Node-style callback called with the error, if any, and MutateAdGroupFeedsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupFeedService.prototype.mutateAdGroupFeeds = function mutateAdGroupFeeds(request, callback) {
                            return this.rpcCall(mutateAdGroupFeeds, $root.google.ads.googleads.v1.services.MutateAdGroupFeedsRequest, $root.google.ads.googleads.v1.services.MutateAdGroupFeedsResponse, request, callback);
                        }, "name", { value: "MutateAdGroupFeeds" });

                        /**
                         * Calls MutateAdGroupFeeds.
                         * @function mutateAdGroupFeeds
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupFeedsRequest} request MutateAdGroupFeedsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateAdGroupFeedsResponse>} Promise
                         * @variation 2
                         */

                        return AdGroupFeedService;
                    })();

                    services.GetAdGroupFeedRequest = (function() {

                        /**
                         * Properties of a GetAdGroupFeedRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetAdGroupFeedRequest
                         * @property {string|null} [resourceName] GetAdGroupFeedRequest resourceName
                         */

                        /**
                         * Constructs a new GetAdGroupFeedRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetAdGroupFeedRequest.
                         * @implements IGetAdGroupFeedRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetAdGroupFeedRequest=} [properties] Properties to set
                         */
                        function GetAdGroupFeedRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetAdGroupFeedRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetAdGroupFeedRequest
                         * @instance
                         */
                        GetAdGroupFeedRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetAdGroupFeedRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetAdGroupFeedRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupFeedRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetAdGroupFeedRequest} GetAdGroupFeedRequest instance
                         */
                        GetAdGroupFeedRequest.create = function create(properties) {
                            return new GetAdGroupFeedRequest(properties);
                        };

                        /**
                         * Encodes the specified GetAdGroupFeedRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupFeedRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupFeedRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupFeedRequest} message GetAdGroupFeedRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupFeedRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetAdGroupFeedRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupFeedRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupFeedRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupFeedRequest} message GetAdGroupFeedRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupFeedRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetAdGroupFeedRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupFeedRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetAdGroupFeedRequest} GetAdGroupFeedRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupFeedRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetAdGroupFeedRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetAdGroupFeedRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupFeedRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetAdGroupFeedRequest} GetAdGroupFeedRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupFeedRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetAdGroupFeedRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetAdGroupFeedRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAdGroupFeedRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetAdGroupFeedRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupFeedRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetAdGroupFeedRequest} GetAdGroupFeedRequest
                         */
                        GetAdGroupFeedRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetAdGroupFeedRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetAdGroupFeedRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetAdGroupFeedRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupFeedRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetAdGroupFeedRequest} message GetAdGroupFeedRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAdGroupFeedRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetAdGroupFeedRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetAdGroupFeedRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAdGroupFeedRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetAdGroupFeedRequest;
                    })();

                    services.MutateAdGroupFeedsRequest = (function() {

                        /**
                         * Properties of a MutateAdGroupFeedsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupFeedsRequest
                         * @property {string|null} [customerId] MutateAdGroupFeedsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IAdGroupFeedOperation>|null} [operations] MutateAdGroupFeedsRequest operations
                         * @property {boolean|null} [partialFailure] MutateAdGroupFeedsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateAdGroupFeedsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateAdGroupFeedsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupFeedsRequest.
                         * @implements IMutateAdGroupFeedsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupFeedsRequest=} [properties] Properties to set
                         */
                        function MutateAdGroupFeedsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupFeedsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsRequest
                         * @instance
                         */
                        MutateAdGroupFeedsRequest.prototype.customerId = "";

                        /**
                         * MutateAdGroupFeedsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IAdGroupFeedOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsRequest
                         * @instance
                         */
                        MutateAdGroupFeedsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateAdGroupFeedsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsRequest
                         * @instance
                         */
                        MutateAdGroupFeedsRequest.prototype.partialFailure = false;

                        /**
                         * MutateAdGroupFeedsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsRequest
                         * @instance
                         */
                        MutateAdGroupFeedsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateAdGroupFeedsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupFeedsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupFeedsRequest} MutateAdGroupFeedsRequest instance
                         */
                        MutateAdGroupFeedsRequest.create = function create(properties) {
                            return new MutateAdGroupFeedsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupFeedsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupFeedsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupFeedsRequest} message MutateAdGroupFeedsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupFeedsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.AdGroupFeedOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupFeedsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupFeedsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupFeedsRequest} message MutateAdGroupFeedsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupFeedsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupFeedsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupFeedsRequest} MutateAdGroupFeedsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupFeedsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupFeedsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.AdGroupFeedOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupFeedsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupFeedsRequest} MutateAdGroupFeedsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupFeedsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupFeedsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupFeedsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.AdGroupFeedOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupFeedsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupFeedsRequest} MutateAdGroupFeedsRequest
                         */
                        MutateAdGroupFeedsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupFeedsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupFeedsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupFeedsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupFeedsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.AdGroupFeedOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupFeedsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupFeedsRequest} message MutateAdGroupFeedsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupFeedsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.AdGroupFeedOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupFeedsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupFeedsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupFeedsRequest;
                    })();

                    services.AdGroupFeedOperation = (function() {

                        /**
                         * Properties of an AdGroupFeedOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IAdGroupFeedOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] AdGroupFeedOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IAdGroupFeed|null} [create] AdGroupFeedOperation create
                         * @property {google.ads.googleads.v1.resources.IAdGroupFeed|null} [update] AdGroupFeedOperation update
                         * @property {string|null} [remove] AdGroupFeedOperation remove
                         */

                        /**
                         * Constructs a new AdGroupFeedOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupFeedOperation.
                         * @implements IAdGroupFeedOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IAdGroupFeedOperation=} [properties] Properties to set
                         */
                        function AdGroupFeedOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupFeedOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedOperation
                         * @instance
                         */
                        AdGroupFeedOperation.prototype.updateMask = null;

                        /**
                         * AdGroupFeedOperation create.
                         * @member {google.ads.googleads.v1.resources.IAdGroupFeed|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedOperation
                         * @instance
                         */
                        AdGroupFeedOperation.prototype.create = null;

                        /**
                         * AdGroupFeedOperation update.
                         * @member {google.ads.googleads.v1.resources.IAdGroupFeed|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedOperation
                         * @instance
                         */
                        AdGroupFeedOperation.prototype.update = null;

                        /**
                         * AdGroupFeedOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedOperation
                         * @instance
                         */
                        AdGroupFeedOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AdGroupFeedOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedOperation
                         * @instance
                         */
                        Object.defineProperty(AdGroupFeedOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AdGroupFeedOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupFeedOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.AdGroupFeedOperation} AdGroupFeedOperation instance
                         */
                        AdGroupFeedOperation.create = function create(properties) {
                            return new AdGroupFeedOperation(properties);
                        };

                        /**
                         * Encodes the specified AdGroupFeedOperation message. Does not implicitly {@link google.ads.googleads.v1.services.AdGroupFeedOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupFeedOperation} message AdGroupFeedOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupFeedOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.AdGroupFeed.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.AdGroupFeed.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupFeedOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.AdGroupFeedOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupFeedOperation} message AdGroupFeedOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupFeedOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupFeedOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.AdGroupFeedOperation} AdGroupFeedOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupFeedOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.AdGroupFeedOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.AdGroupFeed.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.AdGroupFeed.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupFeedOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.AdGroupFeedOperation} AdGroupFeedOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupFeedOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupFeedOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupFeedOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.AdGroupFeed.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.AdGroupFeed.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates an AdGroupFeedOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.AdGroupFeedOperation} AdGroupFeedOperation
                         */
                        AdGroupFeedOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.AdGroupFeedOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.AdGroupFeedOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupFeedOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupFeedOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.AdGroupFeed.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupFeedOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.AdGroupFeed.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupFeedOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.AdGroupFeedOperation} message AdGroupFeedOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupFeedOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.AdGroupFeed.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.AdGroupFeed.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this AdGroupFeedOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.AdGroupFeedOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupFeedOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupFeedOperation;
                    })();

                    services.MutateAdGroupFeedsResponse = (function() {

                        /**
                         * Properties of a MutateAdGroupFeedsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupFeedsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateAdGroupFeedsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateAdGroupFeedResult>|null} [results] MutateAdGroupFeedsResponse results
                         */

                        /**
                         * Constructs a new MutateAdGroupFeedsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupFeedsResponse.
                         * @implements IMutateAdGroupFeedsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupFeedsResponse=} [properties] Properties to set
                         */
                        function MutateAdGroupFeedsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupFeedsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsResponse
                         * @instance
                         */
                        MutateAdGroupFeedsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateAdGroupFeedsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateAdGroupFeedResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsResponse
                         * @instance
                         */
                        MutateAdGroupFeedsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateAdGroupFeedsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupFeedsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupFeedsResponse} MutateAdGroupFeedsResponse instance
                         */
                        MutateAdGroupFeedsResponse.create = function create(properties) {
                            return new MutateAdGroupFeedsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupFeedsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupFeedsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupFeedsResponse} message MutateAdGroupFeedsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupFeedsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateAdGroupFeedResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupFeedsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupFeedsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupFeedsResponse} message MutateAdGroupFeedsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupFeedsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupFeedsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupFeedsResponse} MutateAdGroupFeedsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupFeedsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupFeedsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateAdGroupFeedResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupFeedsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupFeedsResponse} MutateAdGroupFeedsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupFeedsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupFeedsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupFeedsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdGroupFeedResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupFeedsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupFeedsResponse} MutateAdGroupFeedsResponse
                         */
                        MutateAdGroupFeedsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupFeedsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupFeedsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupFeedsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupFeedsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupFeedsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateAdGroupFeedResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupFeedsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupFeedsResponse} message MutateAdGroupFeedsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupFeedsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateAdGroupFeedResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupFeedsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupFeedsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupFeedsResponse;
                    })();

                    services.MutateAdGroupFeedResult = (function() {

                        /**
                         * Properties of a MutateAdGroupFeedResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupFeedResult
                         * @property {string|null} [resourceName] MutateAdGroupFeedResult resourceName
                         */

                        /**
                         * Constructs a new MutateAdGroupFeedResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupFeedResult.
                         * @implements IMutateAdGroupFeedResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupFeedResult=} [properties] Properties to set
                         */
                        function MutateAdGroupFeedResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupFeedResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedResult
                         * @instance
                         */
                        MutateAdGroupFeedResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateAdGroupFeedResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupFeedResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupFeedResult} MutateAdGroupFeedResult instance
                         */
                        MutateAdGroupFeedResult.create = function create(properties) {
                            return new MutateAdGroupFeedResult(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupFeedResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupFeedResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupFeedResult} message MutateAdGroupFeedResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupFeedResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupFeedResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupFeedResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupFeedResult} message MutateAdGroupFeedResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupFeedResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupFeedResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupFeedResult} MutateAdGroupFeedResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupFeedResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupFeedResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupFeedResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupFeedResult} MutateAdGroupFeedResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupFeedResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupFeedResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupFeedResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupFeedResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupFeedResult} MutateAdGroupFeedResult
                         */
                        MutateAdGroupFeedResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupFeedResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupFeedResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupFeedResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupFeedResult} message MutateAdGroupFeedResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupFeedResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupFeedResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupFeedResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupFeedResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupFeedResult;
                    })();

                    services.AdGroupLabelService = (function() {

                        /**
                         * Constructs a new AdGroupLabelService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupLabelService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AdGroupLabelService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (AdGroupLabelService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AdGroupLabelService;

                        /**
                         * Creates new AdGroupLabelService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AdGroupLabelService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AdGroupLabelService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupLabelService#getAdGroupLabel}.
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelService
                         * @typedef GetAdGroupLabelCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.AdGroupLabel} [response] AdGroupLabel
                         */

                        /**
                         * Calls GetAdGroupLabel.
                         * @function getAdGroupLabel
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupLabelRequest} request GetAdGroupLabelRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupLabelService.GetAdGroupLabelCallback} callback Node-style callback called with the error, if any, and AdGroupLabel
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupLabelService.prototype.getAdGroupLabel = function getAdGroupLabel(request, callback) {
                            return this.rpcCall(getAdGroupLabel, $root.google.ads.googleads.v1.services.GetAdGroupLabelRequest, $root.google.ads.googleads.v1.resources.AdGroupLabel, request, callback);
                        }, "name", { value: "GetAdGroupLabel" });

                        /**
                         * Calls GetAdGroupLabel.
                         * @function getAdGroupLabel
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupLabelRequest} request GetAdGroupLabelRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.AdGroupLabel>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupLabelService#mutateAdGroupLabels}.
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelService
                         * @typedef MutateAdGroupLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateAdGroupLabelsResponse} [response] MutateAdGroupLabelsResponse
                         */

                        /**
                         * Calls MutateAdGroupLabels.
                         * @function mutateAdGroupLabels
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupLabelsRequest} request MutateAdGroupLabelsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupLabelService.MutateAdGroupLabelsCallback} callback Node-style callback called with the error, if any, and MutateAdGroupLabelsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupLabelService.prototype.mutateAdGroupLabels = function mutateAdGroupLabels(request, callback) {
                            return this.rpcCall(mutateAdGroupLabels, $root.google.ads.googleads.v1.services.MutateAdGroupLabelsRequest, $root.google.ads.googleads.v1.services.MutateAdGroupLabelsResponse, request, callback);
                        }, "name", { value: "MutateAdGroupLabels" });

                        /**
                         * Calls MutateAdGroupLabels.
                         * @function mutateAdGroupLabels
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupLabelsRequest} request MutateAdGroupLabelsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateAdGroupLabelsResponse>} Promise
                         * @variation 2
                         */

                        return AdGroupLabelService;
                    })();

                    services.GetAdGroupLabelRequest = (function() {

                        /**
                         * Properties of a GetAdGroupLabelRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetAdGroupLabelRequest
                         * @property {string|null} [resourceName] GetAdGroupLabelRequest resourceName
                         */

                        /**
                         * Constructs a new GetAdGroupLabelRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetAdGroupLabelRequest.
                         * @implements IGetAdGroupLabelRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetAdGroupLabelRequest=} [properties] Properties to set
                         */
                        function GetAdGroupLabelRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetAdGroupLabelRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetAdGroupLabelRequest
                         * @instance
                         */
                        GetAdGroupLabelRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetAdGroupLabelRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetAdGroupLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupLabelRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetAdGroupLabelRequest} GetAdGroupLabelRequest instance
                         */
                        GetAdGroupLabelRequest.create = function create(properties) {
                            return new GetAdGroupLabelRequest(properties);
                        };

                        /**
                         * Encodes the specified GetAdGroupLabelRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupLabelRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupLabelRequest} message GetAdGroupLabelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupLabelRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetAdGroupLabelRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupLabelRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupLabelRequest} message GetAdGroupLabelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupLabelRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetAdGroupLabelRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupLabelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetAdGroupLabelRequest} GetAdGroupLabelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupLabelRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetAdGroupLabelRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetAdGroupLabelRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupLabelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetAdGroupLabelRequest} GetAdGroupLabelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupLabelRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetAdGroupLabelRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetAdGroupLabelRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAdGroupLabelRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetAdGroupLabelRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupLabelRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetAdGroupLabelRequest} GetAdGroupLabelRequest
                         */
                        GetAdGroupLabelRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetAdGroupLabelRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetAdGroupLabelRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetAdGroupLabelRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetAdGroupLabelRequest} message GetAdGroupLabelRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAdGroupLabelRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetAdGroupLabelRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetAdGroupLabelRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAdGroupLabelRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetAdGroupLabelRequest;
                    })();

                    services.MutateAdGroupLabelsRequest = (function() {

                        /**
                         * Properties of a MutateAdGroupLabelsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupLabelsRequest
                         * @property {string|null} [customerId] MutateAdGroupLabelsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IAdGroupLabelOperation>|null} [operations] MutateAdGroupLabelsRequest operations
                         * @property {boolean|null} [partialFailure] MutateAdGroupLabelsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateAdGroupLabelsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateAdGroupLabelsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupLabelsRequest.
                         * @implements IMutateAdGroupLabelsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupLabelsRequest=} [properties] Properties to set
                         */
                        function MutateAdGroupLabelsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupLabelsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsRequest
                         * @instance
                         */
                        MutateAdGroupLabelsRequest.prototype.customerId = "";

                        /**
                         * MutateAdGroupLabelsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IAdGroupLabelOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsRequest
                         * @instance
                         */
                        MutateAdGroupLabelsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateAdGroupLabelsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsRequest
                         * @instance
                         */
                        MutateAdGroupLabelsRequest.prototype.partialFailure = false;

                        /**
                         * MutateAdGroupLabelsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsRequest
                         * @instance
                         */
                        MutateAdGroupLabelsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateAdGroupLabelsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupLabelsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupLabelsRequest} MutateAdGroupLabelsRequest instance
                         */
                        MutateAdGroupLabelsRequest.create = function create(properties) {
                            return new MutateAdGroupLabelsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupLabelsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupLabelsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupLabelsRequest} message MutateAdGroupLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupLabelsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.AdGroupLabelOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupLabelsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupLabelsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupLabelsRequest} message MutateAdGroupLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupLabelsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupLabelsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupLabelsRequest} MutateAdGroupLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupLabelsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupLabelsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.AdGroupLabelOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupLabelsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupLabelsRequest} MutateAdGroupLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupLabelsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupLabelsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupLabelsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.AdGroupLabelOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupLabelsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupLabelsRequest} MutateAdGroupLabelsRequest
                         */
                        MutateAdGroupLabelsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupLabelsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupLabelsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupLabelsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupLabelsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.AdGroupLabelOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupLabelsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupLabelsRequest} message MutateAdGroupLabelsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupLabelsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.AdGroupLabelOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupLabelsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupLabelsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupLabelsRequest;
                    })();

                    services.AdGroupLabelOperation = (function() {

                        /**
                         * Properties of an AdGroupLabelOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IAdGroupLabelOperation
                         * @property {google.ads.googleads.v1.resources.IAdGroupLabel|null} [create] AdGroupLabelOperation create
                         * @property {string|null} [remove] AdGroupLabelOperation remove
                         */

                        /**
                         * Constructs a new AdGroupLabelOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupLabelOperation.
                         * @implements IAdGroupLabelOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IAdGroupLabelOperation=} [properties] Properties to set
                         */
                        function AdGroupLabelOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupLabelOperation create.
                         * @member {google.ads.googleads.v1.resources.IAdGroupLabel|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelOperation
                         * @instance
                         */
                        AdGroupLabelOperation.prototype.create = null;

                        /**
                         * AdGroupLabelOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelOperation
                         * @instance
                         */
                        AdGroupLabelOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AdGroupLabelOperation operation.
                         * @member {"create"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelOperation
                         * @instance
                         */
                        Object.defineProperty(AdGroupLabelOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AdGroupLabelOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupLabelOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.AdGroupLabelOperation} AdGroupLabelOperation instance
                         */
                        AdGroupLabelOperation.create = function create(properties) {
                            return new AdGroupLabelOperation(properties);
                        };

                        /**
                         * Encodes the specified AdGroupLabelOperation message. Does not implicitly {@link google.ads.googleads.v1.services.AdGroupLabelOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupLabelOperation} message AdGroupLabelOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupLabelOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.AdGroupLabel.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.remove);
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupLabelOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.AdGroupLabelOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupLabelOperation} message AdGroupLabelOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupLabelOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupLabelOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.AdGroupLabelOperation} AdGroupLabelOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupLabelOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.AdGroupLabelOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.AdGroupLabel.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupLabelOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.AdGroupLabelOperation} AdGroupLabelOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupLabelOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupLabelOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupLabelOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.AdGroupLabel.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates an AdGroupLabelOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.AdGroupLabelOperation} AdGroupLabelOperation
                         */
                        AdGroupLabelOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.AdGroupLabelOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.AdGroupLabelOperation();
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupLabelOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.AdGroupLabel.fromObject(object.create);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupLabelOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.AdGroupLabelOperation} message AdGroupLabelOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupLabelOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.AdGroupLabel.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            return object;
                        };

                        /**
                         * Converts this AdGroupLabelOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.AdGroupLabelOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupLabelOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupLabelOperation;
                    })();

                    services.MutateAdGroupLabelsResponse = (function() {

                        /**
                         * Properties of a MutateAdGroupLabelsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupLabelsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateAdGroupLabelsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateAdGroupLabelResult>|null} [results] MutateAdGroupLabelsResponse results
                         */

                        /**
                         * Constructs a new MutateAdGroupLabelsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupLabelsResponse.
                         * @implements IMutateAdGroupLabelsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupLabelsResponse=} [properties] Properties to set
                         */
                        function MutateAdGroupLabelsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupLabelsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsResponse
                         * @instance
                         */
                        MutateAdGroupLabelsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateAdGroupLabelsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateAdGroupLabelResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsResponse
                         * @instance
                         */
                        MutateAdGroupLabelsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateAdGroupLabelsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupLabelsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupLabelsResponse} MutateAdGroupLabelsResponse instance
                         */
                        MutateAdGroupLabelsResponse.create = function create(properties) {
                            return new MutateAdGroupLabelsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupLabelsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupLabelsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupLabelsResponse} message MutateAdGroupLabelsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupLabelsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateAdGroupLabelResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupLabelsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupLabelsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupLabelsResponse} message MutateAdGroupLabelsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupLabelsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupLabelsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupLabelsResponse} MutateAdGroupLabelsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupLabelsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupLabelsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateAdGroupLabelResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupLabelsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupLabelsResponse} MutateAdGroupLabelsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupLabelsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupLabelsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupLabelsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdGroupLabelResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupLabelsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupLabelsResponse} MutateAdGroupLabelsResponse
                         */
                        MutateAdGroupLabelsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupLabelsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupLabelsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupLabelsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupLabelsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupLabelsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateAdGroupLabelResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupLabelsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupLabelsResponse} message MutateAdGroupLabelsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupLabelsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateAdGroupLabelResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupLabelsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupLabelsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupLabelsResponse;
                    })();

                    services.MutateAdGroupLabelResult = (function() {

                        /**
                         * Properties of a MutateAdGroupLabelResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupLabelResult
                         * @property {string|null} [resourceName] MutateAdGroupLabelResult resourceName
                         */

                        /**
                         * Constructs a new MutateAdGroupLabelResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupLabelResult.
                         * @implements IMutateAdGroupLabelResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupLabelResult=} [properties] Properties to set
                         */
                        function MutateAdGroupLabelResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupLabelResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelResult
                         * @instance
                         */
                        MutateAdGroupLabelResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateAdGroupLabelResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupLabelResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupLabelResult} MutateAdGroupLabelResult instance
                         */
                        MutateAdGroupLabelResult.create = function create(properties) {
                            return new MutateAdGroupLabelResult(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupLabelResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupLabelResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupLabelResult} message MutateAdGroupLabelResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupLabelResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupLabelResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupLabelResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupLabelResult} message MutateAdGroupLabelResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupLabelResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupLabelResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupLabelResult} MutateAdGroupLabelResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupLabelResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupLabelResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupLabelResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupLabelResult} MutateAdGroupLabelResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupLabelResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupLabelResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupLabelResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupLabelResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupLabelResult} MutateAdGroupLabelResult
                         */
                        MutateAdGroupLabelResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupLabelResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupLabelResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupLabelResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupLabelResult} message MutateAdGroupLabelResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupLabelResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupLabelResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupLabelResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupLabelResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupLabelResult;
                    })();

                    services.AdGroupService = (function() {

                        /**
                         * Constructs a new AdGroupService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AdGroupService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (AdGroupService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AdGroupService;

                        /**
                         * Creates new AdGroupService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AdGroupService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AdGroupService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupService#getAdGroup}.
                         * @memberof google.ads.googleads.v1.services.AdGroupService
                         * @typedef GetAdGroupCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.AdGroup} [response] AdGroup
                         */

                        /**
                         * Calls GetAdGroup.
                         * @function getAdGroup
                         * @memberof google.ads.googleads.v1.services.AdGroupService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupRequest} request GetAdGroupRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupService.GetAdGroupCallback} callback Node-style callback called with the error, if any, and AdGroup
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupService.prototype.getAdGroup = function getAdGroup(request, callback) {
                            return this.rpcCall(getAdGroup, $root.google.ads.googleads.v1.services.GetAdGroupRequest, $root.google.ads.googleads.v1.resources.AdGroup, request, callback);
                        }, "name", { value: "GetAdGroup" });

                        /**
                         * Calls GetAdGroup.
                         * @function getAdGroup
                         * @memberof google.ads.googleads.v1.services.AdGroupService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupRequest} request GetAdGroupRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.AdGroup>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupService#mutateAdGroups}.
                         * @memberof google.ads.googleads.v1.services.AdGroupService
                         * @typedef MutateAdGroupsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateAdGroupsResponse} [response] MutateAdGroupsResponse
                         */

                        /**
                         * Calls MutateAdGroups.
                         * @function mutateAdGroups
                         * @memberof google.ads.googleads.v1.services.AdGroupService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupsRequest} request MutateAdGroupsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupService.MutateAdGroupsCallback} callback Node-style callback called with the error, if any, and MutateAdGroupsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupService.prototype.mutateAdGroups = function mutateAdGroups(request, callback) {
                            return this.rpcCall(mutateAdGroups, $root.google.ads.googleads.v1.services.MutateAdGroupsRequest, $root.google.ads.googleads.v1.services.MutateAdGroupsResponse, request, callback);
                        }, "name", { value: "MutateAdGroups" });

                        /**
                         * Calls MutateAdGroups.
                         * @function mutateAdGroups
                         * @memberof google.ads.googleads.v1.services.AdGroupService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupsRequest} request MutateAdGroupsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateAdGroupsResponse>} Promise
                         * @variation 2
                         */

                        return AdGroupService;
                    })();

                    services.GetAdGroupRequest = (function() {

                        /**
                         * Properties of a GetAdGroupRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetAdGroupRequest
                         * @property {string|null} [resourceName] GetAdGroupRequest resourceName
                         */

                        /**
                         * Constructs a new GetAdGroupRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetAdGroupRequest.
                         * @implements IGetAdGroupRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetAdGroupRequest=} [properties] Properties to set
                         */
                        function GetAdGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetAdGroupRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetAdGroupRequest
                         * @instance
                         */
                        GetAdGroupRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetAdGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetAdGroupRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetAdGroupRequest} GetAdGroupRequest instance
                         */
                        GetAdGroupRequest.create = function create(properties) {
                            return new GetAdGroupRequest(properties);
                        };

                        /**
                         * Encodes the specified GetAdGroupRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupRequest} message GetAdGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetAdGroupRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupRequest} message GetAdGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetAdGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetAdGroupRequest} GetAdGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetAdGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetAdGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetAdGroupRequest} GetAdGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetAdGroupRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetAdGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAdGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetAdGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetAdGroupRequest} GetAdGroupRequest
                         */
                        GetAdGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetAdGroupRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetAdGroupRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetAdGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetAdGroupRequest} message GetAdGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAdGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetAdGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetAdGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAdGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetAdGroupRequest;
                    })();

                    services.MutateAdGroupsRequest = (function() {

                        /**
                         * Properties of a MutateAdGroupsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupsRequest
                         * @property {string|null} [customerId] MutateAdGroupsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IAdGroupOperation>|null} [operations] MutateAdGroupsRequest operations
                         * @property {boolean|null} [partialFailure] MutateAdGroupsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateAdGroupsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateAdGroupsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupsRequest.
                         * @implements IMutateAdGroupsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupsRequest=} [properties] Properties to set
                         */
                        function MutateAdGroupsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsRequest
                         * @instance
                         */
                        MutateAdGroupsRequest.prototype.customerId = "";

                        /**
                         * MutateAdGroupsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IAdGroupOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsRequest
                         * @instance
                         */
                        MutateAdGroupsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateAdGroupsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsRequest
                         * @instance
                         */
                        MutateAdGroupsRequest.prototype.partialFailure = false;

                        /**
                         * MutateAdGroupsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsRequest
                         * @instance
                         */
                        MutateAdGroupsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateAdGroupsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupsRequest} MutateAdGroupsRequest instance
                         */
                        MutateAdGroupsRequest.create = function create(properties) {
                            return new MutateAdGroupsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupsRequest} message MutateAdGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.AdGroupOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupsRequest} message MutateAdGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupsRequest} MutateAdGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.AdGroupOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupsRequest} MutateAdGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.AdGroupOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupsRequest} MutateAdGroupsRequest
                         */
                        MutateAdGroupsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.AdGroupOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupsRequest} message MutateAdGroupsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.AdGroupOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupsRequest;
                    })();

                    services.AdGroupOperation = (function() {

                        /**
                         * Properties of an AdGroupOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IAdGroupOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] AdGroupOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IAdGroup|null} [create] AdGroupOperation create
                         * @property {google.ads.googleads.v1.resources.IAdGroup|null} [update] AdGroupOperation update
                         * @property {string|null} [remove] AdGroupOperation remove
                         */

                        /**
                         * Constructs a new AdGroupOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupOperation.
                         * @implements IAdGroupOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IAdGroupOperation=} [properties] Properties to set
                         */
                        function AdGroupOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdGroupOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.AdGroupOperation
                         * @instance
                         */
                        AdGroupOperation.prototype.updateMask = null;

                        /**
                         * AdGroupOperation create.
                         * @member {google.ads.googleads.v1.resources.IAdGroup|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.AdGroupOperation
                         * @instance
                         */
                        AdGroupOperation.prototype.create = null;

                        /**
                         * AdGroupOperation update.
                         * @member {google.ads.googleads.v1.resources.IAdGroup|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.AdGroupOperation
                         * @instance
                         */
                        AdGroupOperation.prototype.update = null;

                        /**
                         * AdGroupOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.AdGroupOperation
                         * @instance
                         */
                        AdGroupOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AdGroupOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.AdGroupOperation
                         * @instance
                         */
                        Object.defineProperty(AdGroupOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AdGroupOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.AdGroupOperation} AdGroupOperation instance
                         */
                        AdGroupOperation.create = function create(properties) {
                            return new AdGroupOperation(properties);
                        };

                        /**
                         * Encodes the specified AdGroupOperation message. Does not implicitly {@link google.ads.googleads.v1.services.AdGroupOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.AdGroupOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupOperation} message AdGroupOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.AdGroup.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.AdGroup.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdGroupOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.AdGroupOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdGroupOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdGroupOperation} message AdGroupOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdGroupOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdGroupOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.AdGroupOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.AdGroupOperation} AdGroupOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.AdGroupOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.AdGroup.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.AdGroup.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdGroupOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdGroupOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.AdGroupOperation} AdGroupOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdGroupOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdGroupOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.AdGroupOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdGroupOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.AdGroup.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.AdGroup.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates an AdGroupOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.AdGroupOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.AdGroupOperation} AdGroupOperation
                         */
                        AdGroupOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.AdGroupOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.AdGroupOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.AdGroup.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdGroupOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.AdGroup.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdGroupOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.AdGroupOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.AdGroupOperation} message AdGroupOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdGroupOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.AdGroup.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.AdGroup.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this AdGroupOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.AdGroupOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdGroupOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdGroupOperation;
                    })();

                    services.MutateAdGroupsResponse = (function() {

                        /**
                         * Properties of a MutateAdGroupsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateAdGroupsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateAdGroupResult>|null} [results] MutateAdGroupsResponse results
                         */

                        /**
                         * Constructs a new MutateAdGroupsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupsResponse.
                         * @implements IMutateAdGroupsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupsResponse=} [properties] Properties to set
                         */
                        function MutateAdGroupsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsResponse
                         * @instance
                         */
                        MutateAdGroupsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateAdGroupsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateAdGroupResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsResponse
                         * @instance
                         */
                        MutateAdGroupsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateAdGroupsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupsResponse} MutateAdGroupsResponse instance
                         */
                        MutateAdGroupsResponse.create = function create(properties) {
                            return new MutateAdGroupsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupsResponse} message MutateAdGroupsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateAdGroupResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupsResponse} message MutateAdGroupsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupsResponse} MutateAdGroupsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateAdGroupResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupsResponse} MutateAdGroupsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdGroupResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupsResponse} MutateAdGroupsResponse
                         */
                        MutateAdGroupsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdGroupsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateAdGroupResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupsResponse} message MutateAdGroupsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateAdGroupResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupsResponse;
                    })();

                    services.MutateAdGroupResult = (function() {

                        /**
                         * Properties of a MutateAdGroupResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdGroupResult
                         * @property {string|null} [resourceName] MutateAdGroupResult resourceName
                         */

                        /**
                         * Constructs a new MutateAdGroupResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdGroupResult.
                         * @implements IMutateAdGroupResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupResult=} [properties] Properties to set
                         */
                        function MutateAdGroupResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdGroupResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupResult
                         * @instance
                         */
                        MutateAdGroupResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateAdGroupResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupResult} MutateAdGroupResult instance
                         */
                        MutateAdGroupResult.create = function create(properties) {
                            return new MutateAdGroupResult(properties);
                        };

                        /**
                         * Encodes the specified MutateAdGroupResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupResult} message MutateAdGroupResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdGroupResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdGroupResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdGroupResult} message MutateAdGroupResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdGroupResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdGroupResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupResult} MutateAdGroupResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdGroupResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdGroupResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupResult} MutateAdGroupResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdGroupResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdGroupResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdGroupResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdGroupResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdGroupResult} MutateAdGroupResult
                         */
                        MutateAdGroupResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdGroupResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdGroupResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdGroupResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdGroupResult} message MutateAdGroupResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdGroupResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateAdGroupResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdGroupResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdGroupResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdGroupResult;
                    })();

                    services.AdGroupSimulationService = (function() {

                        /**
                         * Constructs a new AdGroupSimulationService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdGroupSimulationService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AdGroupSimulationService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (AdGroupSimulationService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AdGroupSimulationService;

                        /**
                         * Creates new AdGroupSimulationService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdGroupSimulationService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AdGroupSimulationService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AdGroupSimulationService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdGroupSimulationService#getAdGroupSimulation}.
                         * @memberof google.ads.googleads.v1.services.AdGroupSimulationService
                         * @typedef GetAdGroupSimulationCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.AdGroupSimulation} [response] AdGroupSimulation
                         */

                        /**
                         * Calls GetAdGroupSimulation.
                         * @function getAdGroupSimulation
                         * @memberof google.ads.googleads.v1.services.AdGroupSimulationService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupSimulationRequest} request GetAdGroupSimulationRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdGroupSimulationService.GetAdGroupSimulationCallback} callback Node-style callback called with the error, if any, and AdGroupSimulation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdGroupSimulationService.prototype.getAdGroupSimulation = function getAdGroupSimulation(request, callback) {
                            return this.rpcCall(getAdGroupSimulation, $root.google.ads.googleads.v1.services.GetAdGroupSimulationRequest, $root.google.ads.googleads.v1.resources.AdGroupSimulation, request, callback);
                        }, "name", { value: "GetAdGroupSimulation" });

                        /**
                         * Calls GetAdGroupSimulation.
                         * @function getAdGroupSimulation
                         * @memberof google.ads.googleads.v1.services.AdGroupSimulationService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdGroupSimulationRequest} request GetAdGroupSimulationRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.AdGroupSimulation>} Promise
                         * @variation 2
                         */

                        return AdGroupSimulationService;
                    })();

                    services.GetAdGroupSimulationRequest = (function() {

                        /**
                         * Properties of a GetAdGroupSimulationRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetAdGroupSimulationRequest
                         * @property {string|null} [resourceName] GetAdGroupSimulationRequest resourceName
                         */

                        /**
                         * Constructs a new GetAdGroupSimulationRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetAdGroupSimulationRequest.
                         * @implements IGetAdGroupSimulationRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetAdGroupSimulationRequest=} [properties] Properties to set
                         */
                        function GetAdGroupSimulationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetAdGroupSimulationRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetAdGroupSimulationRequest
                         * @instance
                         */
                        GetAdGroupSimulationRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetAdGroupSimulationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetAdGroupSimulationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupSimulationRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetAdGroupSimulationRequest} GetAdGroupSimulationRequest instance
                         */
                        GetAdGroupSimulationRequest.create = function create(properties) {
                            return new GetAdGroupSimulationRequest(properties);
                        };

                        /**
                         * Encodes the specified GetAdGroupSimulationRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupSimulationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupSimulationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupSimulationRequest} message GetAdGroupSimulationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupSimulationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetAdGroupSimulationRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetAdGroupSimulationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupSimulationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdGroupSimulationRequest} message GetAdGroupSimulationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdGroupSimulationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetAdGroupSimulationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetAdGroupSimulationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetAdGroupSimulationRequest} GetAdGroupSimulationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupSimulationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetAdGroupSimulationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetAdGroupSimulationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdGroupSimulationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetAdGroupSimulationRequest} GetAdGroupSimulationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdGroupSimulationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetAdGroupSimulationRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetAdGroupSimulationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAdGroupSimulationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetAdGroupSimulationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupSimulationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetAdGroupSimulationRequest} GetAdGroupSimulationRequest
                         */
                        GetAdGroupSimulationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetAdGroupSimulationRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetAdGroupSimulationRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetAdGroupSimulationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetAdGroupSimulationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetAdGroupSimulationRequest} message GetAdGroupSimulationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAdGroupSimulationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetAdGroupSimulationRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetAdGroupSimulationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAdGroupSimulationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetAdGroupSimulationRequest;
                    })();

                    services.AdParameterService = (function() {

                        /**
                         * Constructs a new AdParameterService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdParameterService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AdParameterService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (AdParameterService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AdParameterService;

                        /**
                         * Creates new AdParameterService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdParameterService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AdParameterService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AdParameterService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdParameterService#getAdParameter}.
                         * @memberof google.ads.googleads.v1.services.AdParameterService
                         * @typedef GetAdParameterCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.AdParameter} [response] AdParameter
                         */

                        /**
                         * Calls GetAdParameter.
                         * @function getAdParameter
                         * @memberof google.ads.googleads.v1.services.AdParameterService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdParameterRequest} request GetAdParameterRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdParameterService.GetAdParameterCallback} callback Node-style callback called with the error, if any, and AdParameter
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdParameterService.prototype.getAdParameter = function getAdParameter(request, callback) {
                            return this.rpcCall(getAdParameter, $root.google.ads.googleads.v1.services.GetAdParameterRequest, $root.google.ads.googleads.v1.resources.AdParameter, request, callback);
                        }, "name", { value: "GetAdParameter" });

                        /**
                         * Calls GetAdParameter.
                         * @function getAdParameter
                         * @memberof google.ads.googleads.v1.services.AdParameterService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdParameterRequest} request GetAdParameterRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.AdParameter>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdParameterService#mutateAdParameters}.
                         * @memberof google.ads.googleads.v1.services.AdParameterService
                         * @typedef MutateAdParametersCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateAdParametersResponse} [response] MutateAdParametersResponse
                         */

                        /**
                         * Calls MutateAdParameters.
                         * @function mutateAdParameters
                         * @memberof google.ads.googleads.v1.services.AdParameterService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdParametersRequest} request MutateAdParametersRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdParameterService.MutateAdParametersCallback} callback Node-style callback called with the error, if any, and MutateAdParametersResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdParameterService.prototype.mutateAdParameters = function mutateAdParameters(request, callback) {
                            return this.rpcCall(mutateAdParameters, $root.google.ads.googleads.v1.services.MutateAdParametersRequest, $root.google.ads.googleads.v1.services.MutateAdParametersResponse, request, callback);
                        }, "name", { value: "MutateAdParameters" });

                        /**
                         * Calls MutateAdParameters.
                         * @function mutateAdParameters
                         * @memberof google.ads.googleads.v1.services.AdParameterService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAdParametersRequest} request MutateAdParametersRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateAdParametersResponse>} Promise
                         * @variation 2
                         */

                        return AdParameterService;
                    })();

                    services.GetAdParameterRequest = (function() {

                        /**
                         * Properties of a GetAdParameterRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetAdParameterRequest
                         * @property {string|null} [resourceName] GetAdParameterRequest resourceName
                         */

                        /**
                         * Constructs a new GetAdParameterRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetAdParameterRequest.
                         * @implements IGetAdParameterRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetAdParameterRequest=} [properties] Properties to set
                         */
                        function GetAdParameterRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetAdParameterRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetAdParameterRequest
                         * @instance
                         */
                        GetAdParameterRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetAdParameterRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetAdParameterRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdParameterRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetAdParameterRequest} GetAdParameterRequest instance
                         */
                        GetAdParameterRequest.create = function create(properties) {
                            return new GetAdParameterRequest(properties);
                        };

                        /**
                         * Encodes the specified GetAdParameterRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetAdParameterRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetAdParameterRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdParameterRequest} message GetAdParameterRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdParameterRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetAdParameterRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetAdParameterRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdParameterRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdParameterRequest} message GetAdParameterRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdParameterRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetAdParameterRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetAdParameterRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetAdParameterRequest} GetAdParameterRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdParameterRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetAdParameterRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetAdParameterRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdParameterRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetAdParameterRequest} GetAdParameterRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdParameterRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetAdParameterRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetAdParameterRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAdParameterRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetAdParameterRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetAdParameterRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetAdParameterRequest} GetAdParameterRequest
                         */
                        GetAdParameterRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetAdParameterRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetAdParameterRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetAdParameterRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetAdParameterRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetAdParameterRequest} message GetAdParameterRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAdParameterRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetAdParameterRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetAdParameterRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAdParameterRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetAdParameterRequest;
                    })();

                    services.MutateAdParametersRequest = (function() {

                        /**
                         * Properties of a MutateAdParametersRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdParametersRequest
                         * @property {string|null} [customerId] MutateAdParametersRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IAdParameterOperation>|null} [operations] MutateAdParametersRequest operations
                         * @property {boolean|null} [partialFailure] MutateAdParametersRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateAdParametersRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateAdParametersRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdParametersRequest.
                         * @implements IMutateAdParametersRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdParametersRequest=} [properties] Properties to set
                         */
                        function MutateAdParametersRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdParametersRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersRequest
                         * @instance
                         */
                        MutateAdParametersRequest.prototype.customerId = "";

                        /**
                         * MutateAdParametersRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IAdParameterOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersRequest
                         * @instance
                         */
                        MutateAdParametersRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateAdParametersRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersRequest
                         * @instance
                         */
                        MutateAdParametersRequest.prototype.partialFailure = false;

                        /**
                         * MutateAdParametersRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersRequest
                         * @instance
                         */
                        MutateAdParametersRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateAdParametersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdParametersRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdParametersRequest} MutateAdParametersRequest instance
                         */
                        MutateAdParametersRequest.create = function create(properties) {
                            return new MutateAdParametersRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateAdParametersRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdParametersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdParametersRequest} message MutateAdParametersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdParametersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.AdParameterOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdParametersRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdParametersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdParametersRequest} message MutateAdParametersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdParametersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdParametersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdParametersRequest} MutateAdParametersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdParametersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdParametersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.AdParameterOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdParametersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdParametersRequest} MutateAdParametersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdParametersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdParametersRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdParametersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.AdParameterOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdParametersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdParametersRequest} MutateAdParametersRequest
                         */
                        MutateAdParametersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdParametersRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdParametersRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdParametersRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdParametersRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.AdParameterOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdParametersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdParametersRequest} message MutateAdParametersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdParametersRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.AdParameterOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateAdParametersRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdParametersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdParametersRequest;
                    })();

                    services.AdParameterOperation = (function() {

                        /**
                         * Properties of an AdParameterOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IAdParameterOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] AdParameterOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IAdParameter|null} [create] AdParameterOperation create
                         * @property {google.ads.googleads.v1.resources.IAdParameter|null} [update] AdParameterOperation update
                         * @property {string|null} [remove] AdParameterOperation remove
                         */

                        /**
                         * Constructs a new AdParameterOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdParameterOperation.
                         * @implements IAdParameterOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IAdParameterOperation=} [properties] Properties to set
                         */
                        function AdParameterOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AdParameterOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.AdParameterOperation
                         * @instance
                         */
                        AdParameterOperation.prototype.updateMask = null;

                        /**
                         * AdParameterOperation create.
                         * @member {google.ads.googleads.v1.resources.IAdParameter|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.AdParameterOperation
                         * @instance
                         */
                        AdParameterOperation.prototype.create = null;

                        /**
                         * AdParameterOperation update.
                         * @member {google.ads.googleads.v1.resources.IAdParameter|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.AdParameterOperation
                         * @instance
                         */
                        AdParameterOperation.prototype.update = null;

                        /**
                         * AdParameterOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.AdParameterOperation
                         * @instance
                         */
                        AdParameterOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AdParameterOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.AdParameterOperation
                         * @instance
                         */
                        Object.defineProperty(AdParameterOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AdParameterOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdParameterOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdParameterOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.AdParameterOperation} AdParameterOperation instance
                         */
                        AdParameterOperation.create = function create(properties) {
                            return new AdParameterOperation(properties);
                        };

                        /**
                         * Encodes the specified AdParameterOperation message. Does not implicitly {@link google.ads.googleads.v1.services.AdParameterOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.AdParameterOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdParameterOperation} message AdParameterOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdParameterOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.AdParameter.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.AdParameter.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AdParameterOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.AdParameterOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdParameterOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAdParameterOperation} message AdParameterOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdParameterOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AdParameterOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.AdParameterOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.AdParameterOperation} AdParameterOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdParameterOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.AdParameterOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.AdParameter.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.AdParameter.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AdParameterOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.AdParameterOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.AdParameterOperation} AdParameterOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdParameterOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AdParameterOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.AdParameterOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdParameterOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.AdParameter.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.AdParameter.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates an AdParameterOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.AdParameterOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.AdParameterOperation} AdParameterOperation
                         */
                        AdParameterOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.AdParameterOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.AdParameterOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdParameterOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdParameterOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.AdParameter.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AdParameterOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.AdParameter.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from an AdParameterOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.AdParameterOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.AdParameterOperation} message AdParameterOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdParameterOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.AdParameter.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.AdParameter.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this AdParameterOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.AdParameterOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdParameterOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AdParameterOperation;
                    })();

                    services.MutateAdParametersResponse = (function() {

                        /**
                         * Properties of a MutateAdParametersResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdParametersResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateAdParametersResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateAdParameterResult>|null} [results] MutateAdParametersResponse results
                         */

                        /**
                         * Constructs a new MutateAdParametersResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdParametersResponse.
                         * @implements IMutateAdParametersResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdParametersResponse=} [properties] Properties to set
                         */
                        function MutateAdParametersResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdParametersResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersResponse
                         * @instance
                         */
                        MutateAdParametersResponse.prototype.partialFailureError = null;

                        /**
                         * MutateAdParametersResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateAdParameterResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersResponse
                         * @instance
                         */
                        MutateAdParametersResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateAdParametersResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdParametersResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdParametersResponse} MutateAdParametersResponse instance
                         */
                        MutateAdParametersResponse.create = function create(properties) {
                            return new MutateAdParametersResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateAdParametersResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdParametersResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdParametersResponse} message MutateAdParametersResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdParametersResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateAdParameterResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdParametersResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdParametersResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdParametersResponse} message MutateAdParametersResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdParametersResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdParametersResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdParametersResponse} MutateAdParametersResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdParametersResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdParametersResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateAdParameterResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdParametersResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdParametersResponse} MutateAdParametersResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdParametersResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdParametersResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdParametersResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdParameterResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateAdParametersResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdParametersResponse} MutateAdParametersResponse
                         */
                        MutateAdParametersResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdParametersResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdParametersResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdParametersResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAdParametersResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAdParametersResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateAdParameterResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdParametersResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdParametersResponse} message MutateAdParametersResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdParametersResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateAdParameterResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateAdParametersResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdParametersResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdParametersResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdParametersResponse;
                    })();

                    services.MutateAdParameterResult = (function() {

                        /**
                         * Properties of a MutateAdParameterResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAdParameterResult
                         * @property {string|null} [resourceName] MutateAdParameterResult resourceName
                         */

                        /**
                         * Constructs a new MutateAdParameterResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAdParameterResult.
                         * @implements IMutateAdParameterResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAdParameterResult=} [properties] Properties to set
                         */
                        function MutateAdParameterResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAdParameterResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateAdParameterResult
                         * @instance
                         */
                        MutateAdParameterResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateAdParameterResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAdParameterResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdParameterResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAdParameterResult} MutateAdParameterResult instance
                         */
                        MutateAdParameterResult.create = function create(properties) {
                            return new MutateAdParameterResult(properties);
                        };

                        /**
                         * Encodes the specified MutateAdParameterResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdParameterResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAdParameterResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdParameterResult} message MutateAdParameterResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdParameterResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAdParameterResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAdParameterResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdParameterResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAdParameterResult} message MutateAdParameterResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAdParameterResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAdParameterResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAdParameterResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAdParameterResult} MutateAdParameterResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdParameterResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAdParameterResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAdParameterResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAdParameterResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAdParameterResult} MutateAdParameterResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAdParameterResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAdParameterResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAdParameterResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAdParameterResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAdParameterResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAdParameterResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAdParameterResult} MutateAdParameterResult
                         */
                        MutateAdParameterResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAdParameterResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAdParameterResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAdParameterResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAdParameterResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAdParameterResult} message MutateAdParameterResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAdParameterResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateAdParameterResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAdParameterResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAdParameterResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAdParameterResult;
                    })();

                    services.AdScheduleViewService = (function() {

                        /**
                         * Constructs a new AdScheduleViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AdScheduleViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AdScheduleViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (AdScheduleViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AdScheduleViewService;

                        /**
                         * Creates new AdScheduleViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AdScheduleViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AdScheduleViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AdScheduleViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AdScheduleViewService#getAdScheduleView}.
                         * @memberof google.ads.googleads.v1.services.AdScheduleViewService
                         * @typedef GetAdScheduleViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.AdScheduleView} [response] AdScheduleView
                         */

                        /**
                         * Calls GetAdScheduleView.
                         * @function getAdScheduleView
                         * @memberof google.ads.googleads.v1.services.AdScheduleViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdScheduleViewRequest} request GetAdScheduleViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AdScheduleViewService.GetAdScheduleViewCallback} callback Node-style callback called with the error, if any, and AdScheduleView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AdScheduleViewService.prototype.getAdScheduleView = function getAdScheduleView(request, callback) {
                            return this.rpcCall(getAdScheduleView, $root.google.ads.googleads.v1.services.GetAdScheduleViewRequest, $root.google.ads.googleads.v1.resources.AdScheduleView, request, callback);
                        }, "name", { value: "GetAdScheduleView" });

                        /**
                         * Calls GetAdScheduleView.
                         * @function getAdScheduleView
                         * @memberof google.ads.googleads.v1.services.AdScheduleViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAdScheduleViewRequest} request GetAdScheduleViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.AdScheduleView>} Promise
                         * @variation 2
                         */

                        return AdScheduleViewService;
                    })();

                    services.GetAdScheduleViewRequest = (function() {

                        /**
                         * Properties of a GetAdScheduleViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetAdScheduleViewRequest
                         * @property {string|null} [resourceName] GetAdScheduleViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetAdScheduleViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetAdScheduleViewRequest.
                         * @implements IGetAdScheduleViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetAdScheduleViewRequest=} [properties] Properties to set
                         */
                        function GetAdScheduleViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetAdScheduleViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetAdScheduleViewRequest
                         * @instance
                         */
                        GetAdScheduleViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetAdScheduleViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetAdScheduleViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdScheduleViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetAdScheduleViewRequest} GetAdScheduleViewRequest instance
                         */
                        GetAdScheduleViewRequest.create = function create(properties) {
                            return new GetAdScheduleViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetAdScheduleViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetAdScheduleViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetAdScheduleViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdScheduleViewRequest} message GetAdScheduleViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdScheduleViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetAdScheduleViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetAdScheduleViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdScheduleViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAdScheduleViewRequest} message GetAdScheduleViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdScheduleViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetAdScheduleViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetAdScheduleViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetAdScheduleViewRequest} GetAdScheduleViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdScheduleViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetAdScheduleViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetAdScheduleViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAdScheduleViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetAdScheduleViewRequest} GetAdScheduleViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdScheduleViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetAdScheduleViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetAdScheduleViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAdScheduleViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetAdScheduleViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetAdScheduleViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetAdScheduleViewRequest} GetAdScheduleViewRequest
                         */
                        GetAdScheduleViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetAdScheduleViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetAdScheduleViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetAdScheduleViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetAdScheduleViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetAdScheduleViewRequest} message GetAdScheduleViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAdScheduleViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetAdScheduleViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetAdScheduleViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAdScheduleViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetAdScheduleViewRequest;
                    })();

                    services.AgeRangeViewService = (function() {

                        /**
                         * Constructs a new AgeRangeViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AgeRangeViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AgeRangeViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (AgeRangeViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AgeRangeViewService;

                        /**
                         * Creates new AgeRangeViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AgeRangeViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AgeRangeViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AgeRangeViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AgeRangeViewService#getAgeRangeView}.
                         * @memberof google.ads.googleads.v1.services.AgeRangeViewService
                         * @typedef GetAgeRangeViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.AgeRangeView} [response] AgeRangeView
                         */

                        /**
                         * Calls GetAgeRangeView.
                         * @function getAgeRangeView
                         * @memberof google.ads.googleads.v1.services.AgeRangeViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAgeRangeViewRequest} request GetAgeRangeViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AgeRangeViewService.GetAgeRangeViewCallback} callback Node-style callback called with the error, if any, and AgeRangeView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AgeRangeViewService.prototype.getAgeRangeView = function getAgeRangeView(request, callback) {
                            return this.rpcCall(getAgeRangeView, $root.google.ads.googleads.v1.services.GetAgeRangeViewRequest, $root.google.ads.googleads.v1.resources.AgeRangeView, request, callback);
                        }, "name", { value: "GetAgeRangeView" });

                        /**
                         * Calls GetAgeRangeView.
                         * @function getAgeRangeView
                         * @memberof google.ads.googleads.v1.services.AgeRangeViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAgeRangeViewRequest} request GetAgeRangeViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.AgeRangeView>} Promise
                         * @variation 2
                         */

                        return AgeRangeViewService;
                    })();

                    services.GetAgeRangeViewRequest = (function() {

                        /**
                         * Properties of a GetAgeRangeViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetAgeRangeViewRequest
                         * @property {string|null} [resourceName] GetAgeRangeViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetAgeRangeViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetAgeRangeViewRequest.
                         * @implements IGetAgeRangeViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetAgeRangeViewRequest=} [properties] Properties to set
                         */
                        function GetAgeRangeViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetAgeRangeViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetAgeRangeViewRequest
                         * @instance
                         */
                        GetAgeRangeViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetAgeRangeViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetAgeRangeViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAgeRangeViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetAgeRangeViewRequest} GetAgeRangeViewRequest instance
                         */
                        GetAgeRangeViewRequest.create = function create(properties) {
                            return new GetAgeRangeViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetAgeRangeViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetAgeRangeViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetAgeRangeViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAgeRangeViewRequest} message GetAgeRangeViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAgeRangeViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetAgeRangeViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetAgeRangeViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAgeRangeViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAgeRangeViewRequest} message GetAgeRangeViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAgeRangeViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetAgeRangeViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetAgeRangeViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetAgeRangeViewRequest} GetAgeRangeViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAgeRangeViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetAgeRangeViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetAgeRangeViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAgeRangeViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetAgeRangeViewRequest} GetAgeRangeViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAgeRangeViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetAgeRangeViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetAgeRangeViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAgeRangeViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetAgeRangeViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetAgeRangeViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetAgeRangeViewRequest} GetAgeRangeViewRequest
                         */
                        GetAgeRangeViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetAgeRangeViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetAgeRangeViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetAgeRangeViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetAgeRangeViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetAgeRangeViewRequest} message GetAgeRangeViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAgeRangeViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetAgeRangeViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetAgeRangeViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAgeRangeViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetAgeRangeViewRequest;
                    })();

                    services.AssetService = (function() {

                        /**
                         * Constructs a new AssetService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AssetService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AssetService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (AssetService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AssetService;

                        /**
                         * Creates new AssetService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AssetService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AssetService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AssetService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AssetService#getAsset}.
                         * @memberof google.ads.googleads.v1.services.AssetService
                         * @typedef GetAssetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.Asset} [response] Asset
                         */

                        /**
                         * Calls GetAsset.
                         * @function getAsset
                         * @memberof google.ads.googleads.v1.services.AssetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAssetRequest} request GetAssetRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AssetService.GetAssetCallback} callback Node-style callback called with the error, if any, and Asset
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AssetService.prototype.getAsset = function getAsset(request, callback) {
                            return this.rpcCall(getAsset, $root.google.ads.googleads.v1.services.GetAssetRequest, $root.google.ads.googleads.v1.resources.Asset, request, callback);
                        }, "name", { value: "GetAsset" });

                        /**
                         * Calls GetAsset.
                         * @function getAsset
                         * @memberof google.ads.googleads.v1.services.AssetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetAssetRequest} request GetAssetRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.Asset>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.AssetService#mutateAssets}.
                         * @memberof google.ads.googleads.v1.services.AssetService
                         * @typedef MutateAssetsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateAssetsResponse} [response] MutateAssetsResponse
                         */

                        /**
                         * Calls MutateAssets.
                         * @function mutateAssets
                         * @memberof google.ads.googleads.v1.services.AssetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAssetsRequest} request MutateAssetsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.AssetService.MutateAssetsCallback} callback Node-style callback called with the error, if any, and MutateAssetsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AssetService.prototype.mutateAssets = function mutateAssets(request, callback) {
                            return this.rpcCall(mutateAssets, $root.google.ads.googleads.v1.services.MutateAssetsRequest, $root.google.ads.googleads.v1.services.MutateAssetsResponse, request, callback);
                        }, "name", { value: "MutateAssets" });

                        /**
                         * Calls MutateAssets.
                         * @function mutateAssets
                         * @memberof google.ads.googleads.v1.services.AssetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateAssetsRequest} request MutateAssetsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateAssetsResponse>} Promise
                         * @variation 2
                         */

                        return AssetService;
                    })();

                    services.GetAssetRequest = (function() {

                        /**
                         * Properties of a GetAssetRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetAssetRequest
                         * @property {string|null} [resourceName] GetAssetRequest resourceName
                         */

                        /**
                         * Constructs a new GetAssetRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetAssetRequest.
                         * @implements IGetAssetRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetAssetRequest=} [properties] Properties to set
                         */
                        function GetAssetRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetAssetRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetAssetRequest
                         * @instance
                         */
                        GetAssetRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetAssetRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetAssetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAssetRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetAssetRequest} GetAssetRequest instance
                         */
                        GetAssetRequest.create = function create(properties) {
                            return new GetAssetRequest(properties);
                        };

                        /**
                         * Encodes the specified GetAssetRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetAssetRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetAssetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAssetRequest} message GetAssetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAssetRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetAssetRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetAssetRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAssetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetAssetRequest} message GetAssetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAssetRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetAssetRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetAssetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetAssetRequest} GetAssetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAssetRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetAssetRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetAssetRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetAssetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetAssetRequest} GetAssetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAssetRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetAssetRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetAssetRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAssetRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetAssetRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetAssetRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetAssetRequest} GetAssetRequest
                         */
                        GetAssetRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetAssetRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetAssetRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetAssetRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetAssetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetAssetRequest} message GetAssetRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAssetRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetAssetRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetAssetRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAssetRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetAssetRequest;
                    })();

                    services.MutateAssetsRequest = (function() {

                        /**
                         * Properties of a MutateAssetsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAssetsRequest
                         * @property {string|null} [customerId] MutateAssetsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IAssetOperation>|null} [operations] MutateAssetsRequest operations
                         */

                        /**
                         * Constructs a new MutateAssetsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAssetsRequest.
                         * @implements IMutateAssetsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAssetsRequest=} [properties] Properties to set
                         */
                        function MutateAssetsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAssetsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateAssetsRequest
                         * @instance
                         */
                        MutateAssetsRequest.prototype.customerId = "";

                        /**
                         * MutateAssetsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IAssetOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateAssetsRequest
                         * @instance
                         */
                        MutateAssetsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * Creates a new MutateAssetsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAssetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAssetsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAssetsRequest} MutateAssetsRequest instance
                         */
                        MutateAssetsRequest.create = function create(properties) {
                            return new MutateAssetsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateAssetsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAssetsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAssetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAssetsRequest} message MutateAssetsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAssetsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.AssetOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAssetsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAssetsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAssetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAssetsRequest} message MutateAssetsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAssetsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAssetsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAssetsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAssetsRequest} MutateAssetsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAssetsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAssetsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.AssetOperation.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAssetsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAssetsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAssetsRequest} MutateAssetsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAssetsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAssetsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAssetsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAssetsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.AssetOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateAssetsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAssetsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAssetsRequest} MutateAssetsRequest
                         */
                        MutateAssetsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAssetsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAssetsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAssetsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAssetsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.AssetOperation.fromObject(object.operations[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAssetsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAssetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAssetsRequest} message MutateAssetsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAssetsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults)
                                object.customerId = "";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.AssetOperation.toObject(message.operations[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this MutateAssetsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAssetsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAssetsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAssetsRequest;
                    })();

                    services.AssetOperation = (function() {

                        /**
                         * Properties of an AssetOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IAssetOperation
                         * @property {google.ads.googleads.v1.resources.IAsset|null} [create] AssetOperation create
                         */

                        /**
                         * Constructs a new AssetOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AssetOperation.
                         * @implements IAssetOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IAssetOperation=} [properties] Properties to set
                         */
                        function AssetOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AssetOperation create.
                         * @member {google.ads.googleads.v1.resources.IAsset|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.AssetOperation
                         * @instance
                         */
                        AssetOperation.prototype.create = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * AssetOperation operation.
                         * @member {"create"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.AssetOperation
                         * @instance
                         */
                        Object.defineProperty(AssetOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new AssetOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AssetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAssetOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.AssetOperation} AssetOperation instance
                         */
                        AssetOperation.create = function create(properties) {
                            return new AssetOperation(properties);
                        };

                        /**
                         * Encodes the specified AssetOperation message. Does not implicitly {@link google.ads.googleads.v1.services.AssetOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.AssetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAssetOperation} message AssetOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AssetOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.Asset.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AssetOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.AssetOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.AssetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IAssetOperation} message AssetOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AssetOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AssetOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.AssetOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.AssetOperation} AssetOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AssetOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.AssetOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.Asset.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AssetOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.AssetOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.AssetOperation} AssetOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AssetOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AssetOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.AssetOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AssetOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Asset.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an AssetOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.AssetOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.AssetOperation} AssetOperation
                         */
                        AssetOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.AssetOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.AssetOperation();
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.AssetOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.Asset.fromObject(object.create);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AssetOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.AssetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.AssetOperation} message AssetOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AssetOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.Asset.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            return object;
                        };

                        /**
                         * Converts this AssetOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.AssetOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AssetOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AssetOperation;
                    })();

                    services.MutateAssetsResponse = (function() {

                        /**
                         * Properties of a MutateAssetsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAssetsResponse
                         * @property {Array.<google.ads.googleads.v1.services.IMutateAssetResult>|null} [results] MutateAssetsResponse results
                         */

                        /**
                         * Constructs a new MutateAssetsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAssetsResponse.
                         * @implements IMutateAssetsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAssetsResponse=} [properties] Properties to set
                         */
                        function MutateAssetsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAssetsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateAssetResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateAssetsResponse
                         * @instance
                         */
                        MutateAssetsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateAssetsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAssetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAssetsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAssetsResponse} MutateAssetsResponse instance
                         */
                        MutateAssetsResponse.create = function create(properties) {
                            return new MutateAssetsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateAssetsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAssetsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAssetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAssetsResponse} message MutateAssetsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAssetsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateAssetResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAssetsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAssetsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAssetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAssetsResponse} message MutateAssetsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAssetsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAssetsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAssetsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAssetsResponse} MutateAssetsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAssetsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAssetsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateAssetResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAssetsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAssetsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAssetsResponse} MutateAssetsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAssetsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAssetsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAssetsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAssetsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateAssetResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateAssetsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAssetsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAssetsResponse} MutateAssetsResponse
                         */
                        MutateAssetsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAssetsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAssetsResponse();
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateAssetsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateAssetsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateAssetResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAssetsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAssetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAssetsResponse} message MutateAssetsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAssetsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateAssetResult.toObject(message.results[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this MutateAssetsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAssetsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAssetsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAssetsResponse;
                    })();

                    services.MutateAssetResult = (function() {

                        /**
                         * Properties of a MutateAssetResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateAssetResult
                         * @property {string|null} [resourceName] MutateAssetResult resourceName
                         */

                        /**
                         * Constructs a new MutateAssetResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateAssetResult.
                         * @implements IMutateAssetResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateAssetResult=} [properties] Properties to set
                         */
                        function MutateAssetResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateAssetResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateAssetResult
                         * @instance
                         */
                        MutateAssetResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateAssetResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateAssetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAssetResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateAssetResult} MutateAssetResult instance
                         */
                        MutateAssetResult.create = function create(properties) {
                            return new MutateAssetResult(properties);
                        };

                        /**
                         * Encodes the specified MutateAssetResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateAssetResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateAssetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAssetResult} message MutateAssetResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAssetResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateAssetResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateAssetResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAssetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateAssetResult} message MutateAssetResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateAssetResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateAssetResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateAssetResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateAssetResult} MutateAssetResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAssetResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateAssetResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateAssetResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateAssetResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateAssetResult} MutateAssetResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateAssetResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateAssetResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateAssetResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateAssetResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateAssetResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateAssetResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateAssetResult} MutateAssetResult
                         */
                        MutateAssetResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateAssetResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateAssetResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateAssetResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateAssetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateAssetResult} message MutateAssetResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateAssetResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateAssetResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateAssetResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateAssetResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateAssetResult;
                    })();

                    services.BiddingStrategyService = (function() {

                        /**
                         * Constructs a new BiddingStrategyService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a BiddingStrategyService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function BiddingStrategyService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (BiddingStrategyService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = BiddingStrategyService;

                        /**
                         * Creates new BiddingStrategyService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {BiddingStrategyService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        BiddingStrategyService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.BiddingStrategyService#getBiddingStrategy}.
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyService
                         * @typedef GetBiddingStrategyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.BiddingStrategy} [response] BiddingStrategy
                         */

                        /**
                         * Calls GetBiddingStrategy.
                         * @function getBiddingStrategy
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetBiddingStrategyRequest} request GetBiddingStrategyRequest message or plain object
                         * @param {google.ads.googleads.v1.services.BiddingStrategyService.GetBiddingStrategyCallback} callback Node-style callback called with the error, if any, and BiddingStrategy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BiddingStrategyService.prototype.getBiddingStrategy = function getBiddingStrategy(request, callback) {
                            return this.rpcCall(getBiddingStrategy, $root.google.ads.googleads.v1.services.GetBiddingStrategyRequest, $root.google.ads.googleads.v1.resources.BiddingStrategy, request, callback);
                        }, "name", { value: "GetBiddingStrategy" });

                        /**
                         * Calls GetBiddingStrategy.
                         * @function getBiddingStrategy
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetBiddingStrategyRequest} request GetBiddingStrategyRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.BiddingStrategy>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.BiddingStrategyService#mutateBiddingStrategies}.
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyService
                         * @typedef MutateBiddingStrategiesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateBiddingStrategiesResponse} [response] MutateBiddingStrategiesResponse
                         */

                        /**
                         * Calls MutateBiddingStrategies.
                         * @function mutateBiddingStrategies
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateBiddingStrategiesRequest} request MutateBiddingStrategiesRequest message or plain object
                         * @param {google.ads.googleads.v1.services.BiddingStrategyService.MutateBiddingStrategiesCallback} callback Node-style callback called with the error, if any, and MutateBiddingStrategiesResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BiddingStrategyService.prototype.mutateBiddingStrategies = function mutateBiddingStrategies(request, callback) {
                            return this.rpcCall(mutateBiddingStrategies, $root.google.ads.googleads.v1.services.MutateBiddingStrategiesRequest, $root.google.ads.googleads.v1.services.MutateBiddingStrategiesResponse, request, callback);
                        }, "name", { value: "MutateBiddingStrategies" });

                        /**
                         * Calls MutateBiddingStrategies.
                         * @function mutateBiddingStrategies
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateBiddingStrategiesRequest} request MutateBiddingStrategiesRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateBiddingStrategiesResponse>} Promise
                         * @variation 2
                         */

                        return BiddingStrategyService;
                    })();

                    services.GetBiddingStrategyRequest = (function() {

                        /**
                         * Properties of a GetBiddingStrategyRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetBiddingStrategyRequest
                         * @property {string|null} [resourceName] GetBiddingStrategyRequest resourceName
                         */

                        /**
                         * Constructs a new GetBiddingStrategyRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetBiddingStrategyRequest.
                         * @implements IGetBiddingStrategyRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetBiddingStrategyRequest=} [properties] Properties to set
                         */
                        function GetBiddingStrategyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetBiddingStrategyRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetBiddingStrategyRequest
                         * @instance
                         */
                        GetBiddingStrategyRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetBiddingStrategyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetBiddingStrategyRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetBiddingStrategyRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetBiddingStrategyRequest} GetBiddingStrategyRequest instance
                         */
                        GetBiddingStrategyRequest.create = function create(properties) {
                            return new GetBiddingStrategyRequest(properties);
                        };

                        /**
                         * Encodes the specified GetBiddingStrategyRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetBiddingStrategyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetBiddingStrategyRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetBiddingStrategyRequest} message GetBiddingStrategyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetBiddingStrategyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetBiddingStrategyRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetBiddingStrategyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetBiddingStrategyRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetBiddingStrategyRequest} message GetBiddingStrategyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetBiddingStrategyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetBiddingStrategyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetBiddingStrategyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetBiddingStrategyRequest} GetBiddingStrategyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetBiddingStrategyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetBiddingStrategyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetBiddingStrategyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetBiddingStrategyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetBiddingStrategyRequest} GetBiddingStrategyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetBiddingStrategyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetBiddingStrategyRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetBiddingStrategyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetBiddingStrategyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetBiddingStrategyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetBiddingStrategyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetBiddingStrategyRequest} GetBiddingStrategyRequest
                         */
                        GetBiddingStrategyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetBiddingStrategyRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetBiddingStrategyRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetBiddingStrategyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetBiddingStrategyRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetBiddingStrategyRequest} message GetBiddingStrategyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetBiddingStrategyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetBiddingStrategyRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetBiddingStrategyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetBiddingStrategyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetBiddingStrategyRequest;
                    })();

                    services.MutateBiddingStrategiesRequest = (function() {

                        /**
                         * Properties of a MutateBiddingStrategiesRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateBiddingStrategiesRequest
                         * @property {string|null} [customerId] MutateBiddingStrategiesRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IBiddingStrategyOperation>|null} [operations] MutateBiddingStrategiesRequest operations
                         * @property {boolean|null} [partialFailure] MutateBiddingStrategiesRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateBiddingStrategiesRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateBiddingStrategiesRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateBiddingStrategiesRequest.
                         * @implements IMutateBiddingStrategiesRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateBiddingStrategiesRequest=} [properties] Properties to set
                         */
                        function MutateBiddingStrategiesRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateBiddingStrategiesRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesRequest
                         * @instance
                         */
                        MutateBiddingStrategiesRequest.prototype.customerId = "";

                        /**
                         * MutateBiddingStrategiesRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IBiddingStrategyOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesRequest
                         * @instance
                         */
                        MutateBiddingStrategiesRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateBiddingStrategiesRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesRequest
                         * @instance
                         */
                        MutateBiddingStrategiesRequest.prototype.partialFailure = false;

                        /**
                         * MutateBiddingStrategiesRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesRequest
                         * @instance
                         */
                        MutateBiddingStrategiesRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateBiddingStrategiesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateBiddingStrategiesRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateBiddingStrategiesRequest} MutateBiddingStrategiesRequest instance
                         */
                        MutateBiddingStrategiesRequest.create = function create(properties) {
                            return new MutateBiddingStrategiesRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateBiddingStrategiesRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateBiddingStrategiesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateBiddingStrategiesRequest} message MutateBiddingStrategiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateBiddingStrategiesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.BiddingStrategyOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateBiddingStrategiesRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateBiddingStrategiesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateBiddingStrategiesRequest} message MutateBiddingStrategiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateBiddingStrategiesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateBiddingStrategiesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateBiddingStrategiesRequest} MutateBiddingStrategiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateBiddingStrategiesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateBiddingStrategiesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.BiddingStrategyOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateBiddingStrategiesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateBiddingStrategiesRequest} MutateBiddingStrategiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateBiddingStrategiesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateBiddingStrategiesRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateBiddingStrategiesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.BiddingStrategyOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateBiddingStrategiesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateBiddingStrategiesRequest} MutateBiddingStrategiesRequest
                         */
                        MutateBiddingStrategiesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateBiddingStrategiesRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateBiddingStrategiesRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateBiddingStrategiesRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateBiddingStrategiesRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.BiddingStrategyOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateBiddingStrategiesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateBiddingStrategiesRequest} message MutateBiddingStrategiesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateBiddingStrategiesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.BiddingStrategyOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateBiddingStrategiesRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateBiddingStrategiesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateBiddingStrategiesRequest;
                    })();

                    services.BiddingStrategyOperation = (function() {

                        /**
                         * Properties of a BiddingStrategyOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IBiddingStrategyOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] BiddingStrategyOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IBiddingStrategy|null} [create] BiddingStrategyOperation create
                         * @property {google.ads.googleads.v1.resources.IBiddingStrategy|null} [update] BiddingStrategyOperation update
                         * @property {string|null} [remove] BiddingStrategyOperation remove
                         */

                        /**
                         * Constructs a new BiddingStrategyOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a BiddingStrategyOperation.
                         * @implements IBiddingStrategyOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IBiddingStrategyOperation=} [properties] Properties to set
                         */
                        function BiddingStrategyOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * BiddingStrategyOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyOperation
                         * @instance
                         */
                        BiddingStrategyOperation.prototype.updateMask = null;

                        /**
                         * BiddingStrategyOperation create.
                         * @member {google.ads.googleads.v1.resources.IBiddingStrategy|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyOperation
                         * @instance
                         */
                        BiddingStrategyOperation.prototype.create = null;

                        /**
                         * BiddingStrategyOperation update.
                         * @member {google.ads.googleads.v1.resources.IBiddingStrategy|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyOperation
                         * @instance
                         */
                        BiddingStrategyOperation.prototype.update = null;

                        /**
                         * BiddingStrategyOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyOperation
                         * @instance
                         */
                        BiddingStrategyOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * BiddingStrategyOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyOperation
                         * @instance
                         */
                        Object.defineProperty(BiddingStrategyOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new BiddingStrategyOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IBiddingStrategyOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.BiddingStrategyOperation} BiddingStrategyOperation instance
                         */
                        BiddingStrategyOperation.create = function create(properties) {
                            return new BiddingStrategyOperation(properties);
                        };

                        /**
                         * Encodes the specified BiddingStrategyOperation message. Does not implicitly {@link google.ads.googleads.v1.services.BiddingStrategyOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IBiddingStrategyOperation} message BiddingStrategyOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BiddingStrategyOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.BiddingStrategy.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.BiddingStrategy.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified BiddingStrategyOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.BiddingStrategyOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IBiddingStrategyOperation} message BiddingStrategyOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BiddingStrategyOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BiddingStrategyOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.BiddingStrategyOperation} BiddingStrategyOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BiddingStrategyOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.BiddingStrategyOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.BiddingStrategy.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.BiddingStrategy.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BiddingStrategyOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.BiddingStrategyOperation} BiddingStrategyOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BiddingStrategyOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BiddingStrategyOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BiddingStrategyOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.BiddingStrategy.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.BiddingStrategy.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a BiddingStrategyOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.BiddingStrategyOperation} BiddingStrategyOperation
                         */
                        BiddingStrategyOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.BiddingStrategyOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.BiddingStrategyOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.BiddingStrategyOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.BiddingStrategyOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.BiddingStrategy.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.BiddingStrategyOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.BiddingStrategy.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a BiddingStrategyOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.BiddingStrategyOperation} message BiddingStrategyOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BiddingStrategyOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.BiddingStrategy.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.BiddingStrategy.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this BiddingStrategyOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.BiddingStrategyOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BiddingStrategyOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return BiddingStrategyOperation;
                    })();

                    services.MutateBiddingStrategiesResponse = (function() {

                        /**
                         * Properties of a MutateBiddingStrategiesResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateBiddingStrategiesResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateBiddingStrategiesResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateBiddingStrategyResult>|null} [results] MutateBiddingStrategiesResponse results
                         */

                        /**
                         * Constructs a new MutateBiddingStrategiesResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateBiddingStrategiesResponse.
                         * @implements IMutateBiddingStrategiesResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateBiddingStrategiesResponse=} [properties] Properties to set
                         */
                        function MutateBiddingStrategiesResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateBiddingStrategiesResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesResponse
                         * @instance
                         */
                        MutateBiddingStrategiesResponse.prototype.partialFailureError = null;

                        /**
                         * MutateBiddingStrategiesResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateBiddingStrategyResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesResponse
                         * @instance
                         */
                        MutateBiddingStrategiesResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateBiddingStrategiesResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateBiddingStrategiesResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateBiddingStrategiesResponse} MutateBiddingStrategiesResponse instance
                         */
                        MutateBiddingStrategiesResponse.create = function create(properties) {
                            return new MutateBiddingStrategiesResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateBiddingStrategiesResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateBiddingStrategiesResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateBiddingStrategiesResponse} message MutateBiddingStrategiesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateBiddingStrategiesResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateBiddingStrategyResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateBiddingStrategiesResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateBiddingStrategiesResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateBiddingStrategiesResponse} message MutateBiddingStrategiesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateBiddingStrategiesResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateBiddingStrategiesResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateBiddingStrategiesResponse} MutateBiddingStrategiesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateBiddingStrategiesResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateBiddingStrategiesResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateBiddingStrategyResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateBiddingStrategiesResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateBiddingStrategiesResponse} MutateBiddingStrategiesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateBiddingStrategiesResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateBiddingStrategiesResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateBiddingStrategiesResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateBiddingStrategyResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateBiddingStrategiesResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateBiddingStrategiesResponse} MutateBiddingStrategiesResponse
                         */
                        MutateBiddingStrategiesResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateBiddingStrategiesResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateBiddingStrategiesResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateBiddingStrategiesResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateBiddingStrategiesResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateBiddingStrategiesResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateBiddingStrategyResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateBiddingStrategiesResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateBiddingStrategiesResponse} message MutateBiddingStrategiesResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateBiddingStrategiesResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateBiddingStrategyResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateBiddingStrategiesResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategiesResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateBiddingStrategiesResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateBiddingStrategiesResponse;
                    })();

                    services.MutateBiddingStrategyResult = (function() {

                        /**
                         * Properties of a MutateBiddingStrategyResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateBiddingStrategyResult
                         * @property {string|null} [resourceName] MutateBiddingStrategyResult resourceName
                         */

                        /**
                         * Constructs a new MutateBiddingStrategyResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateBiddingStrategyResult.
                         * @implements IMutateBiddingStrategyResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateBiddingStrategyResult=} [properties] Properties to set
                         */
                        function MutateBiddingStrategyResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateBiddingStrategyResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategyResult
                         * @instance
                         */
                        MutateBiddingStrategyResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateBiddingStrategyResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategyResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateBiddingStrategyResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateBiddingStrategyResult} MutateBiddingStrategyResult instance
                         */
                        MutateBiddingStrategyResult.create = function create(properties) {
                            return new MutateBiddingStrategyResult(properties);
                        };

                        /**
                         * Encodes the specified MutateBiddingStrategyResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateBiddingStrategyResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategyResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateBiddingStrategyResult} message MutateBiddingStrategyResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateBiddingStrategyResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateBiddingStrategyResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateBiddingStrategyResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategyResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateBiddingStrategyResult} message MutateBiddingStrategyResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateBiddingStrategyResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateBiddingStrategyResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategyResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateBiddingStrategyResult} MutateBiddingStrategyResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateBiddingStrategyResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateBiddingStrategyResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateBiddingStrategyResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategyResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateBiddingStrategyResult} MutateBiddingStrategyResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateBiddingStrategyResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateBiddingStrategyResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategyResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateBiddingStrategyResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateBiddingStrategyResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategyResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateBiddingStrategyResult} MutateBiddingStrategyResult
                         */
                        MutateBiddingStrategyResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateBiddingStrategyResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateBiddingStrategyResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateBiddingStrategyResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategyResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateBiddingStrategyResult} message MutateBiddingStrategyResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateBiddingStrategyResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateBiddingStrategyResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateBiddingStrategyResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateBiddingStrategyResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateBiddingStrategyResult;
                    })();

                    services.BillingSetupService = (function() {

                        /**
                         * Constructs a new BillingSetupService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a BillingSetupService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function BillingSetupService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (BillingSetupService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = BillingSetupService;

                        /**
                         * Creates new BillingSetupService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.BillingSetupService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {BillingSetupService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        BillingSetupService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.BillingSetupService#getBillingSetup}.
                         * @memberof google.ads.googleads.v1.services.BillingSetupService
                         * @typedef GetBillingSetupCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.BillingSetup} [response] BillingSetup
                         */

                        /**
                         * Calls GetBillingSetup.
                         * @function getBillingSetup
                         * @memberof google.ads.googleads.v1.services.BillingSetupService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetBillingSetupRequest} request GetBillingSetupRequest message or plain object
                         * @param {google.ads.googleads.v1.services.BillingSetupService.GetBillingSetupCallback} callback Node-style callback called with the error, if any, and BillingSetup
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BillingSetupService.prototype.getBillingSetup = function getBillingSetup(request, callback) {
                            return this.rpcCall(getBillingSetup, $root.google.ads.googleads.v1.services.GetBillingSetupRequest, $root.google.ads.googleads.v1.resources.BillingSetup, request, callback);
                        }, "name", { value: "GetBillingSetup" });

                        /**
                         * Calls GetBillingSetup.
                         * @function getBillingSetup
                         * @memberof google.ads.googleads.v1.services.BillingSetupService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetBillingSetupRequest} request GetBillingSetupRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.BillingSetup>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.BillingSetupService#mutateBillingSetup}.
                         * @memberof google.ads.googleads.v1.services.BillingSetupService
                         * @typedef MutateBillingSetupCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateBillingSetupResponse} [response] MutateBillingSetupResponse
                         */

                        /**
                         * Calls MutateBillingSetup.
                         * @function mutateBillingSetup
                         * @memberof google.ads.googleads.v1.services.BillingSetupService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateBillingSetupRequest} request MutateBillingSetupRequest message or plain object
                         * @param {google.ads.googleads.v1.services.BillingSetupService.MutateBillingSetupCallback} callback Node-style callback called with the error, if any, and MutateBillingSetupResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BillingSetupService.prototype.mutateBillingSetup = function mutateBillingSetup(request, callback) {
                            return this.rpcCall(mutateBillingSetup, $root.google.ads.googleads.v1.services.MutateBillingSetupRequest, $root.google.ads.googleads.v1.services.MutateBillingSetupResponse, request, callback);
                        }, "name", { value: "MutateBillingSetup" });

                        /**
                         * Calls MutateBillingSetup.
                         * @function mutateBillingSetup
                         * @memberof google.ads.googleads.v1.services.BillingSetupService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateBillingSetupRequest} request MutateBillingSetupRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateBillingSetupResponse>} Promise
                         * @variation 2
                         */

                        return BillingSetupService;
                    })();

                    services.GetBillingSetupRequest = (function() {

                        /**
                         * Properties of a GetBillingSetupRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetBillingSetupRequest
                         * @property {string|null} [resourceName] GetBillingSetupRequest resourceName
                         */

                        /**
                         * Constructs a new GetBillingSetupRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetBillingSetupRequest.
                         * @implements IGetBillingSetupRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetBillingSetupRequest=} [properties] Properties to set
                         */
                        function GetBillingSetupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetBillingSetupRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetBillingSetupRequest
                         * @instance
                         */
                        GetBillingSetupRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetBillingSetupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetBillingSetupRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetBillingSetupRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetBillingSetupRequest} GetBillingSetupRequest instance
                         */
                        GetBillingSetupRequest.create = function create(properties) {
                            return new GetBillingSetupRequest(properties);
                        };

                        /**
                         * Encodes the specified GetBillingSetupRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetBillingSetupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetBillingSetupRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetBillingSetupRequest} message GetBillingSetupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetBillingSetupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetBillingSetupRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetBillingSetupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetBillingSetupRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetBillingSetupRequest} message GetBillingSetupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetBillingSetupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetBillingSetupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetBillingSetupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetBillingSetupRequest} GetBillingSetupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetBillingSetupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetBillingSetupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetBillingSetupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetBillingSetupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetBillingSetupRequest} GetBillingSetupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetBillingSetupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetBillingSetupRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetBillingSetupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetBillingSetupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetBillingSetupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetBillingSetupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetBillingSetupRequest} GetBillingSetupRequest
                         */
                        GetBillingSetupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetBillingSetupRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetBillingSetupRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetBillingSetupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetBillingSetupRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetBillingSetupRequest} message GetBillingSetupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetBillingSetupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetBillingSetupRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetBillingSetupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetBillingSetupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetBillingSetupRequest;
                    })();

                    services.MutateBillingSetupRequest = (function() {

                        /**
                         * Properties of a MutateBillingSetupRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateBillingSetupRequest
                         * @property {string|null} [customerId] MutateBillingSetupRequest customerId
                         * @property {google.ads.googleads.v1.services.IBillingSetupOperation|null} [operation] MutateBillingSetupRequest operation
                         */

                        /**
                         * Constructs a new MutateBillingSetupRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateBillingSetupRequest.
                         * @implements IMutateBillingSetupRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateBillingSetupRequest=} [properties] Properties to set
                         */
                        function MutateBillingSetupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateBillingSetupRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupRequest
                         * @instance
                         */
                        MutateBillingSetupRequest.prototype.customerId = "";

                        /**
                         * MutateBillingSetupRequest operation.
                         * @member {google.ads.googleads.v1.services.IBillingSetupOperation|null|undefined} operation
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupRequest
                         * @instance
                         */
                        MutateBillingSetupRequest.prototype.operation = null;

                        /**
                         * Creates a new MutateBillingSetupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateBillingSetupRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateBillingSetupRequest} MutateBillingSetupRequest instance
                         */
                        MutateBillingSetupRequest.create = function create(properties) {
                            return new MutateBillingSetupRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateBillingSetupRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateBillingSetupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateBillingSetupRequest} message MutateBillingSetupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateBillingSetupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                $root.google.ads.googleads.v1.services.BillingSetupOperation.encode(message.operation, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateBillingSetupRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateBillingSetupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateBillingSetupRequest} message MutateBillingSetupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateBillingSetupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateBillingSetupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateBillingSetupRequest} MutateBillingSetupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateBillingSetupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateBillingSetupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    message.operation = $root.google.ads.googleads.v1.services.BillingSetupOperation.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateBillingSetupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateBillingSetupRequest} MutateBillingSetupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateBillingSetupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateBillingSetupRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateBillingSetupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operation != null && message.hasOwnProperty("operation")) {
                                var error = $root.google.ads.googleads.v1.services.BillingSetupOperation.verify(message.operation);
                                if (error)
                                    return "operation." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateBillingSetupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateBillingSetupRequest} MutateBillingSetupRequest
                         */
                        MutateBillingSetupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateBillingSetupRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateBillingSetupRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operation != null) {
                                if (typeof object.operation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateBillingSetupRequest.operation: object expected");
                                message.operation = $root.google.ads.googleads.v1.services.BillingSetupOperation.fromObject(object.operation);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateBillingSetupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateBillingSetupRequest} message MutateBillingSetupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateBillingSetupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.customerId = "";
                                object.operation = null;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = $root.google.ads.googleads.v1.services.BillingSetupOperation.toObject(message.operation, options);
                            return object;
                        };

                        /**
                         * Converts this MutateBillingSetupRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateBillingSetupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateBillingSetupRequest;
                    })();

                    services.BillingSetupOperation = (function() {

                        /**
                         * Properties of a BillingSetupOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IBillingSetupOperation
                         * @property {google.ads.googleads.v1.resources.IBillingSetup|null} [create] BillingSetupOperation create
                         * @property {string|null} [remove] BillingSetupOperation remove
                         */

                        /**
                         * Constructs a new BillingSetupOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a BillingSetupOperation.
                         * @implements IBillingSetupOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IBillingSetupOperation=} [properties] Properties to set
                         */
                        function BillingSetupOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * BillingSetupOperation create.
                         * @member {google.ads.googleads.v1.resources.IBillingSetup|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.BillingSetupOperation
                         * @instance
                         */
                        BillingSetupOperation.prototype.create = null;

                        /**
                         * BillingSetupOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.BillingSetupOperation
                         * @instance
                         */
                        BillingSetupOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * BillingSetupOperation operation.
                         * @member {"create"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.BillingSetupOperation
                         * @instance
                         */
                        Object.defineProperty(BillingSetupOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new BillingSetupOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.BillingSetupOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IBillingSetupOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.BillingSetupOperation} BillingSetupOperation instance
                         */
                        BillingSetupOperation.create = function create(properties) {
                            return new BillingSetupOperation(properties);
                        };

                        /**
                         * Encodes the specified BillingSetupOperation message. Does not implicitly {@link google.ads.googleads.v1.services.BillingSetupOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.BillingSetupOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IBillingSetupOperation} message BillingSetupOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BillingSetupOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.remove);
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.BillingSetup.encode(message.create, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified BillingSetupOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.BillingSetupOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.BillingSetupOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IBillingSetupOperation} message BillingSetupOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BillingSetupOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a BillingSetupOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.BillingSetupOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.BillingSetupOperation} BillingSetupOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BillingSetupOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.BillingSetupOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2:
                                    message.create = $root.google.ads.googleads.v1.resources.BillingSetup.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a BillingSetupOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.BillingSetupOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.BillingSetupOperation} BillingSetupOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BillingSetupOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a BillingSetupOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.BillingSetupOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BillingSetupOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.BillingSetup.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a BillingSetupOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.BillingSetupOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.BillingSetupOperation} BillingSetupOperation
                         */
                        BillingSetupOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.BillingSetupOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.BillingSetupOperation();
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.BillingSetupOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.BillingSetup.fromObject(object.create);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a BillingSetupOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.BillingSetupOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.BillingSetupOperation} message BillingSetupOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BillingSetupOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.BillingSetup.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            return object;
                        };

                        /**
                         * Converts this BillingSetupOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.BillingSetupOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BillingSetupOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return BillingSetupOperation;
                    })();

                    services.MutateBillingSetupResponse = (function() {

                        /**
                         * Properties of a MutateBillingSetupResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateBillingSetupResponse
                         * @property {google.ads.googleads.v1.services.IMutateBillingSetupResult|null} [result] MutateBillingSetupResponse result
                         */

                        /**
                         * Constructs a new MutateBillingSetupResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateBillingSetupResponse.
                         * @implements IMutateBillingSetupResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateBillingSetupResponse=} [properties] Properties to set
                         */
                        function MutateBillingSetupResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateBillingSetupResponse result.
                         * @member {google.ads.googleads.v1.services.IMutateBillingSetupResult|null|undefined} result
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResponse
                         * @instance
                         */
                        MutateBillingSetupResponse.prototype.result = null;

                        /**
                         * Creates a new MutateBillingSetupResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateBillingSetupResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateBillingSetupResponse} MutateBillingSetupResponse instance
                         */
                        MutateBillingSetupResponse.create = function create(properties) {
                            return new MutateBillingSetupResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateBillingSetupResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateBillingSetupResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateBillingSetupResponse} message MutateBillingSetupResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateBillingSetupResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.result != null && message.hasOwnProperty("result"))
                                $root.google.ads.googleads.v1.services.MutateBillingSetupResult.encode(message.result, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateBillingSetupResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateBillingSetupResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateBillingSetupResponse} message MutateBillingSetupResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateBillingSetupResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateBillingSetupResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateBillingSetupResponse} MutateBillingSetupResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateBillingSetupResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateBillingSetupResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.result = $root.google.ads.googleads.v1.services.MutateBillingSetupResult.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateBillingSetupResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateBillingSetupResponse} MutateBillingSetupResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateBillingSetupResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateBillingSetupResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateBillingSetupResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.result != null && message.hasOwnProperty("result")) {
                                var error = $root.google.ads.googleads.v1.services.MutateBillingSetupResult.verify(message.result);
                                if (error)
                                    return "result." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateBillingSetupResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateBillingSetupResponse} MutateBillingSetupResponse
                         */
                        MutateBillingSetupResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateBillingSetupResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateBillingSetupResponse();
                            if (object.result != null) {
                                if (typeof object.result !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateBillingSetupResponse.result: object expected");
                                message.result = $root.google.ads.googleads.v1.services.MutateBillingSetupResult.fromObject(object.result);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateBillingSetupResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateBillingSetupResponse} message MutateBillingSetupResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateBillingSetupResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.result = null;
                            if (message.result != null && message.hasOwnProperty("result"))
                                object.result = $root.google.ads.googleads.v1.services.MutateBillingSetupResult.toObject(message.result, options);
                            return object;
                        };

                        /**
                         * Converts this MutateBillingSetupResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateBillingSetupResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateBillingSetupResponse;
                    })();

                    services.MutateBillingSetupResult = (function() {

                        /**
                         * Properties of a MutateBillingSetupResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateBillingSetupResult
                         * @property {string|null} [resourceName] MutateBillingSetupResult resourceName
                         */

                        /**
                         * Constructs a new MutateBillingSetupResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateBillingSetupResult.
                         * @implements IMutateBillingSetupResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateBillingSetupResult=} [properties] Properties to set
                         */
                        function MutateBillingSetupResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateBillingSetupResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResult
                         * @instance
                         */
                        MutateBillingSetupResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateBillingSetupResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateBillingSetupResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateBillingSetupResult} MutateBillingSetupResult instance
                         */
                        MutateBillingSetupResult.create = function create(properties) {
                            return new MutateBillingSetupResult(properties);
                        };

                        /**
                         * Encodes the specified MutateBillingSetupResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateBillingSetupResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateBillingSetupResult} message MutateBillingSetupResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateBillingSetupResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateBillingSetupResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateBillingSetupResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateBillingSetupResult} message MutateBillingSetupResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateBillingSetupResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateBillingSetupResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateBillingSetupResult} MutateBillingSetupResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateBillingSetupResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateBillingSetupResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateBillingSetupResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateBillingSetupResult} MutateBillingSetupResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateBillingSetupResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateBillingSetupResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateBillingSetupResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateBillingSetupResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateBillingSetupResult} MutateBillingSetupResult
                         */
                        MutateBillingSetupResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateBillingSetupResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateBillingSetupResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateBillingSetupResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateBillingSetupResult} message MutateBillingSetupResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateBillingSetupResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateBillingSetupResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateBillingSetupResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateBillingSetupResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateBillingSetupResult;
                    })();

                    services.CampaignAudienceViewService = (function() {

                        /**
                         * Constructs a new CampaignAudienceViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CampaignAudienceViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CampaignAudienceViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CampaignAudienceViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CampaignAudienceViewService;

                        /**
                         * Creates new CampaignAudienceViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CampaignAudienceViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CampaignAudienceViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CampaignAudienceViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CampaignAudienceViewService#getCampaignAudienceView}.
                         * @memberof google.ads.googleads.v1.services.CampaignAudienceViewService
                         * @typedef GetCampaignAudienceViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.CampaignAudienceView} [response] CampaignAudienceView
                         */

                        /**
                         * Calls GetCampaignAudienceView.
                         * @function getCampaignAudienceView
                         * @memberof google.ads.googleads.v1.services.CampaignAudienceViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignAudienceViewRequest} request GetCampaignAudienceViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CampaignAudienceViewService.GetCampaignAudienceViewCallback} callback Node-style callback called with the error, if any, and CampaignAudienceView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CampaignAudienceViewService.prototype.getCampaignAudienceView = function getCampaignAudienceView(request, callback) {
                            return this.rpcCall(getCampaignAudienceView, $root.google.ads.googleads.v1.services.GetCampaignAudienceViewRequest, $root.google.ads.googleads.v1.resources.CampaignAudienceView, request, callback);
                        }, "name", { value: "GetCampaignAudienceView" });

                        /**
                         * Calls GetCampaignAudienceView.
                         * @function getCampaignAudienceView
                         * @memberof google.ads.googleads.v1.services.CampaignAudienceViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignAudienceViewRequest} request GetCampaignAudienceViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.CampaignAudienceView>} Promise
                         * @variation 2
                         */

                        return CampaignAudienceViewService;
                    })();

                    services.GetCampaignAudienceViewRequest = (function() {

                        /**
                         * Properties of a GetCampaignAudienceViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCampaignAudienceViewRequest
                         * @property {string|null} [resourceName] GetCampaignAudienceViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetCampaignAudienceViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCampaignAudienceViewRequest.
                         * @implements IGetCampaignAudienceViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCampaignAudienceViewRequest=} [properties] Properties to set
                         */
                        function GetCampaignAudienceViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCampaignAudienceViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCampaignAudienceViewRequest
                         * @instance
                         */
                        GetCampaignAudienceViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCampaignAudienceViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCampaignAudienceViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignAudienceViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCampaignAudienceViewRequest} GetCampaignAudienceViewRequest instance
                         */
                        GetCampaignAudienceViewRequest.create = function create(properties) {
                            return new GetCampaignAudienceViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCampaignAudienceViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignAudienceViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCampaignAudienceViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignAudienceViewRequest} message GetCampaignAudienceViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignAudienceViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCampaignAudienceViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignAudienceViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignAudienceViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignAudienceViewRequest} message GetCampaignAudienceViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignAudienceViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCampaignAudienceViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCampaignAudienceViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCampaignAudienceViewRequest} GetCampaignAudienceViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignAudienceViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCampaignAudienceViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCampaignAudienceViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignAudienceViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCampaignAudienceViewRequest} GetCampaignAudienceViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignAudienceViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCampaignAudienceViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCampaignAudienceViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCampaignAudienceViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCampaignAudienceViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignAudienceViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCampaignAudienceViewRequest} GetCampaignAudienceViewRequest
                         */
                        GetCampaignAudienceViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCampaignAudienceViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCampaignAudienceViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCampaignAudienceViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignAudienceViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCampaignAudienceViewRequest} message GetCampaignAudienceViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCampaignAudienceViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCampaignAudienceViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCampaignAudienceViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCampaignAudienceViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCampaignAudienceViewRequest;
                    })();

                    services.CampaignBidModifierService = (function() {

                        /**
                         * Constructs a new CampaignBidModifierService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CampaignBidModifierService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CampaignBidModifierService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CampaignBidModifierService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CampaignBidModifierService;

                        /**
                         * Creates new CampaignBidModifierService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CampaignBidModifierService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CampaignBidModifierService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CampaignBidModifierService#getCampaignBidModifier}.
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierService
                         * @typedef GetCampaignBidModifierCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.CampaignBidModifier} [response] CampaignBidModifier
                         */

                        /**
                         * Calls GetCampaignBidModifier.
                         * @function getCampaignBidModifier
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignBidModifierRequest} request GetCampaignBidModifierRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CampaignBidModifierService.GetCampaignBidModifierCallback} callback Node-style callback called with the error, if any, and CampaignBidModifier
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CampaignBidModifierService.prototype.getCampaignBidModifier = function getCampaignBidModifier(request, callback) {
                            return this.rpcCall(getCampaignBidModifier, $root.google.ads.googleads.v1.services.GetCampaignBidModifierRequest, $root.google.ads.googleads.v1.resources.CampaignBidModifier, request, callback);
                        }, "name", { value: "GetCampaignBidModifier" });

                        /**
                         * Calls GetCampaignBidModifier.
                         * @function getCampaignBidModifier
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignBidModifierRequest} request GetCampaignBidModifierRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.CampaignBidModifier>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CampaignBidModifierService#mutateCampaignBidModifiers}.
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierService
                         * @typedef MutateCampaignBidModifiersCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse} [response] MutateCampaignBidModifiersResponse
                         */

                        /**
                         * Calls MutateCampaignBidModifiers.
                         * @function mutateCampaignBidModifiers
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBidModifiersRequest} request MutateCampaignBidModifiersRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CampaignBidModifierService.MutateCampaignBidModifiersCallback} callback Node-style callback called with the error, if any, and MutateCampaignBidModifiersResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CampaignBidModifierService.prototype.mutateCampaignBidModifiers = function mutateCampaignBidModifiers(request, callback) {
                            return this.rpcCall(mutateCampaignBidModifiers, $root.google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest, $root.google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse, request, callback);
                        }, "name", { value: "MutateCampaignBidModifiers" });

                        /**
                         * Calls MutateCampaignBidModifiers.
                         * @function mutateCampaignBidModifiers
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBidModifiersRequest} request MutateCampaignBidModifiersRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse>} Promise
                         * @variation 2
                         */

                        return CampaignBidModifierService;
                    })();

                    services.GetCampaignBidModifierRequest = (function() {

                        /**
                         * Properties of a GetCampaignBidModifierRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCampaignBidModifierRequest
                         * @property {string|null} [resourceName] GetCampaignBidModifierRequest resourceName
                         */

                        /**
                         * Constructs a new GetCampaignBidModifierRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCampaignBidModifierRequest.
                         * @implements IGetCampaignBidModifierRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCampaignBidModifierRequest=} [properties] Properties to set
                         */
                        function GetCampaignBidModifierRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCampaignBidModifierRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCampaignBidModifierRequest
                         * @instance
                         */
                        GetCampaignBidModifierRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCampaignBidModifierRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCampaignBidModifierRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignBidModifierRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCampaignBidModifierRequest} GetCampaignBidModifierRequest instance
                         */
                        GetCampaignBidModifierRequest.create = function create(properties) {
                            return new GetCampaignBidModifierRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCampaignBidModifierRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignBidModifierRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCampaignBidModifierRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignBidModifierRequest} message GetCampaignBidModifierRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignBidModifierRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCampaignBidModifierRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignBidModifierRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignBidModifierRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignBidModifierRequest} message GetCampaignBidModifierRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignBidModifierRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCampaignBidModifierRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCampaignBidModifierRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCampaignBidModifierRequest} GetCampaignBidModifierRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignBidModifierRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCampaignBidModifierRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCampaignBidModifierRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignBidModifierRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCampaignBidModifierRequest} GetCampaignBidModifierRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignBidModifierRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCampaignBidModifierRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCampaignBidModifierRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCampaignBidModifierRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCampaignBidModifierRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignBidModifierRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCampaignBidModifierRequest} GetCampaignBidModifierRequest
                         */
                        GetCampaignBidModifierRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCampaignBidModifierRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCampaignBidModifierRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCampaignBidModifierRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignBidModifierRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCampaignBidModifierRequest} message GetCampaignBidModifierRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCampaignBidModifierRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCampaignBidModifierRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCampaignBidModifierRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCampaignBidModifierRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCampaignBidModifierRequest;
                    })();

                    services.MutateCampaignBidModifiersRequest = (function() {

                        /**
                         * Properties of a MutateCampaignBidModifiersRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignBidModifiersRequest
                         * @property {string|null} [customerId] MutateCampaignBidModifiersRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.ICampaignBidModifierOperation>|null} [operations] MutateCampaignBidModifiersRequest operations
                         * @property {boolean|null} [partialFailure] MutateCampaignBidModifiersRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateCampaignBidModifiersRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateCampaignBidModifiersRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignBidModifiersRequest.
                         * @implements IMutateCampaignBidModifiersRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBidModifiersRequest=} [properties] Properties to set
                         */
                        function MutateCampaignBidModifiersRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignBidModifiersRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest
                         * @instance
                         */
                        MutateCampaignBidModifiersRequest.prototype.customerId = "";

                        /**
                         * MutateCampaignBidModifiersRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.ICampaignBidModifierOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest
                         * @instance
                         */
                        MutateCampaignBidModifiersRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateCampaignBidModifiersRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest
                         * @instance
                         */
                        MutateCampaignBidModifiersRequest.prototype.partialFailure = false;

                        /**
                         * MutateCampaignBidModifiersRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest
                         * @instance
                         */
                        MutateCampaignBidModifiersRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateCampaignBidModifiersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBidModifiersRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest} MutateCampaignBidModifiersRequest instance
                         */
                        MutateCampaignBidModifiersRequest.create = function create(properties) {
                            return new MutateCampaignBidModifiersRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignBidModifiersRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBidModifiersRequest} message MutateCampaignBidModifiersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignBidModifiersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.CampaignBidModifierOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignBidModifiersRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBidModifiersRequest} message MutateCampaignBidModifiersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignBidModifiersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignBidModifiersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest} MutateCampaignBidModifiersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignBidModifiersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.CampaignBidModifierOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignBidModifiersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest} MutateCampaignBidModifiersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignBidModifiersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignBidModifiersRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignBidModifiersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.CampaignBidModifierOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignBidModifiersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest} MutateCampaignBidModifiersRequest
                         */
                        MutateCampaignBidModifiersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.CampaignBidModifierOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignBidModifiersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest} message MutateCampaignBidModifiersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignBidModifiersRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.CampaignBidModifierOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignBidModifiersRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignBidModifiersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignBidModifiersRequest;
                    })();

                    services.CampaignBidModifierOperation = (function() {

                        /**
                         * Properties of a CampaignBidModifierOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICampaignBidModifierOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] CampaignBidModifierOperation updateMask
                         * @property {google.ads.googleads.v1.resources.ICampaignBidModifier|null} [create] CampaignBidModifierOperation create
                         * @property {google.ads.googleads.v1.resources.ICampaignBidModifier|null} [update] CampaignBidModifierOperation update
                         * @property {string|null} [remove] CampaignBidModifierOperation remove
                         */

                        /**
                         * Constructs a new CampaignBidModifierOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CampaignBidModifierOperation.
                         * @implements ICampaignBidModifierOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICampaignBidModifierOperation=} [properties] Properties to set
                         */
                        function CampaignBidModifierOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CampaignBidModifierOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierOperation
                         * @instance
                         */
                        CampaignBidModifierOperation.prototype.updateMask = null;

                        /**
                         * CampaignBidModifierOperation create.
                         * @member {google.ads.googleads.v1.resources.ICampaignBidModifier|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierOperation
                         * @instance
                         */
                        CampaignBidModifierOperation.prototype.create = null;

                        /**
                         * CampaignBidModifierOperation update.
                         * @member {google.ads.googleads.v1.resources.ICampaignBidModifier|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierOperation
                         * @instance
                         */
                        CampaignBidModifierOperation.prototype.update = null;

                        /**
                         * CampaignBidModifierOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierOperation
                         * @instance
                         */
                        CampaignBidModifierOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CampaignBidModifierOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierOperation
                         * @instance
                         */
                        Object.defineProperty(CampaignBidModifierOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CampaignBidModifierOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignBidModifierOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CampaignBidModifierOperation} CampaignBidModifierOperation instance
                         */
                        CampaignBidModifierOperation.create = function create(properties) {
                            return new CampaignBidModifierOperation(properties);
                        };

                        /**
                         * Encodes the specified CampaignBidModifierOperation message. Does not implicitly {@link google.ads.googleads.v1.services.CampaignBidModifierOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignBidModifierOperation} message CampaignBidModifierOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignBidModifierOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.CampaignBidModifier.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.CampaignBidModifier.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignBidModifierOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CampaignBidModifierOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignBidModifierOperation} message CampaignBidModifierOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignBidModifierOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignBidModifierOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CampaignBidModifierOperation} CampaignBidModifierOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignBidModifierOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CampaignBidModifierOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.CampaignBidModifier.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.CampaignBidModifier.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignBidModifierOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CampaignBidModifierOperation} CampaignBidModifierOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignBidModifierOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignBidModifierOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignBidModifierOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CampaignBidModifier.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CampaignBidModifier.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a CampaignBidModifierOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CampaignBidModifierOperation} CampaignBidModifierOperation
                         */
                        CampaignBidModifierOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CampaignBidModifierOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CampaignBidModifierOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignBidModifierOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignBidModifierOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.CampaignBidModifier.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignBidModifierOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.CampaignBidModifier.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a CampaignBidModifierOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.CampaignBidModifierOperation} message CampaignBidModifierOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignBidModifierOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.CampaignBidModifier.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.CampaignBidModifier.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this CampaignBidModifierOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CampaignBidModifierOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignBidModifierOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CampaignBidModifierOperation;
                    })();

                    services.MutateCampaignBidModifiersResponse = (function() {

                        /**
                         * Properties of a MutateCampaignBidModifiersResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignBidModifiersResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateCampaignBidModifiersResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateCampaignBidModifierResult>|null} [results] MutateCampaignBidModifiersResponse results
                         */

                        /**
                         * Constructs a new MutateCampaignBidModifiersResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignBidModifiersResponse.
                         * @implements IMutateCampaignBidModifiersResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBidModifiersResponse=} [properties] Properties to set
                         */
                        function MutateCampaignBidModifiersResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignBidModifiersResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse
                         * @instance
                         */
                        MutateCampaignBidModifiersResponse.prototype.partialFailureError = null;

                        /**
                         * MutateCampaignBidModifiersResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateCampaignBidModifierResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse
                         * @instance
                         */
                        MutateCampaignBidModifiersResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateCampaignBidModifiersResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBidModifiersResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse} MutateCampaignBidModifiersResponse instance
                         */
                        MutateCampaignBidModifiersResponse.create = function create(properties) {
                            return new MutateCampaignBidModifiersResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignBidModifiersResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBidModifiersResponse} message MutateCampaignBidModifiersResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignBidModifiersResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateCampaignBidModifierResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignBidModifiersResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBidModifiersResponse} message MutateCampaignBidModifiersResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignBidModifiersResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignBidModifiersResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse} MutateCampaignBidModifiersResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignBidModifiersResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateCampaignBidModifierResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignBidModifiersResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse} MutateCampaignBidModifiersResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignBidModifiersResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignBidModifiersResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignBidModifiersResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateCampaignBidModifierResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignBidModifiersResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse} MutateCampaignBidModifiersResponse
                         */
                        MutateCampaignBidModifiersResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateCampaignBidModifierResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignBidModifiersResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse} message MutateCampaignBidModifiersResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignBidModifiersResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateCampaignBidModifierResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignBidModifiersResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifiersResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignBidModifiersResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignBidModifiersResponse;
                    })();

                    services.MutateCampaignBidModifierResult = (function() {

                        /**
                         * Properties of a MutateCampaignBidModifierResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignBidModifierResult
                         * @property {string|null} [resourceName] MutateCampaignBidModifierResult resourceName
                         */

                        /**
                         * Constructs a new MutateCampaignBidModifierResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignBidModifierResult.
                         * @implements IMutateCampaignBidModifierResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBidModifierResult=} [properties] Properties to set
                         */
                        function MutateCampaignBidModifierResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignBidModifierResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifierResult
                         * @instance
                         */
                        MutateCampaignBidModifierResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateCampaignBidModifierResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifierResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBidModifierResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBidModifierResult} MutateCampaignBidModifierResult instance
                         */
                        MutateCampaignBidModifierResult.create = function create(properties) {
                            return new MutateCampaignBidModifierResult(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignBidModifierResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignBidModifierResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifierResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBidModifierResult} message MutateCampaignBidModifierResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignBidModifierResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignBidModifierResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignBidModifierResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifierResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBidModifierResult} message MutateCampaignBidModifierResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignBidModifierResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignBidModifierResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifierResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBidModifierResult} MutateCampaignBidModifierResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignBidModifierResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignBidModifierResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignBidModifierResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifierResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBidModifierResult} MutateCampaignBidModifierResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignBidModifierResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignBidModifierResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifierResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignBidModifierResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignBidModifierResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifierResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBidModifierResult} MutateCampaignBidModifierResult
                         */
                        MutateCampaignBidModifierResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignBidModifierResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignBidModifierResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignBidModifierResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifierResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignBidModifierResult} message MutateCampaignBidModifierResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignBidModifierResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignBidModifierResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBidModifierResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignBidModifierResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignBidModifierResult;
                    })();

                    services.CampaignBudgetService = (function() {

                        /**
                         * Constructs a new CampaignBudgetService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CampaignBudgetService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CampaignBudgetService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CampaignBudgetService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CampaignBudgetService;

                        /**
                         * Creates new CampaignBudgetService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CampaignBudgetService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CampaignBudgetService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CampaignBudgetService#getCampaignBudget}.
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetService
                         * @typedef GetCampaignBudgetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.CampaignBudget} [response] CampaignBudget
                         */

                        /**
                         * Calls GetCampaignBudget.
                         * @function getCampaignBudget
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignBudgetRequest} request GetCampaignBudgetRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CampaignBudgetService.GetCampaignBudgetCallback} callback Node-style callback called with the error, if any, and CampaignBudget
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CampaignBudgetService.prototype.getCampaignBudget = function getCampaignBudget(request, callback) {
                            return this.rpcCall(getCampaignBudget, $root.google.ads.googleads.v1.services.GetCampaignBudgetRequest, $root.google.ads.googleads.v1.resources.CampaignBudget, request, callback);
                        }, "name", { value: "GetCampaignBudget" });

                        /**
                         * Calls GetCampaignBudget.
                         * @function getCampaignBudget
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignBudgetRequest} request GetCampaignBudgetRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.CampaignBudget>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CampaignBudgetService#mutateCampaignBudgets}.
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetService
                         * @typedef MutateCampaignBudgetsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateCampaignBudgetsResponse} [response] MutateCampaignBudgetsResponse
                         */

                        /**
                         * Calls MutateCampaignBudgets.
                         * @function mutateCampaignBudgets
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBudgetsRequest} request MutateCampaignBudgetsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CampaignBudgetService.MutateCampaignBudgetsCallback} callback Node-style callback called with the error, if any, and MutateCampaignBudgetsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CampaignBudgetService.prototype.mutateCampaignBudgets = function mutateCampaignBudgets(request, callback) {
                            return this.rpcCall(mutateCampaignBudgets, $root.google.ads.googleads.v1.services.MutateCampaignBudgetsRequest, $root.google.ads.googleads.v1.services.MutateCampaignBudgetsResponse, request, callback);
                        }, "name", { value: "MutateCampaignBudgets" });

                        /**
                         * Calls MutateCampaignBudgets.
                         * @function mutateCampaignBudgets
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBudgetsRequest} request MutateCampaignBudgetsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateCampaignBudgetsResponse>} Promise
                         * @variation 2
                         */

                        return CampaignBudgetService;
                    })();

                    services.GetCampaignBudgetRequest = (function() {

                        /**
                         * Properties of a GetCampaignBudgetRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCampaignBudgetRequest
                         * @property {string|null} [resourceName] GetCampaignBudgetRequest resourceName
                         */

                        /**
                         * Constructs a new GetCampaignBudgetRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCampaignBudgetRequest.
                         * @implements IGetCampaignBudgetRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCampaignBudgetRequest=} [properties] Properties to set
                         */
                        function GetCampaignBudgetRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCampaignBudgetRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCampaignBudgetRequest
                         * @instance
                         */
                        GetCampaignBudgetRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCampaignBudgetRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCampaignBudgetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignBudgetRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCampaignBudgetRequest} GetCampaignBudgetRequest instance
                         */
                        GetCampaignBudgetRequest.create = function create(properties) {
                            return new GetCampaignBudgetRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCampaignBudgetRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignBudgetRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCampaignBudgetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignBudgetRequest} message GetCampaignBudgetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignBudgetRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCampaignBudgetRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignBudgetRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignBudgetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignBudgetRequest} message GetCampaignBudgetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignBudgetRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCampaignBudgetRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCampaignBudgetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCampaignBudgetRequest} GetCampaignBudgetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignBudgetRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCampaignBudgetRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCampaignBudgetRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignBudgetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCampaignBudgetRequest} GetCampaignBudgetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignBudgetRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCampaignBudgetRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCampaignBudgetRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCampaignBudgetRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCampaignBudgetRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignBudgetRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCampaignBudgetRequest} GetCampaignBudgetRequest
                         */
                        GetCampaignBudgetRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCampaignBudgetRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCampaignBudgetRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCampaignBudgetRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignBudgetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCampaignBudgetRequest} message GetCampaignBudgetRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCampaignBudgetRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCampaignBudgetRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCampaignBudgetRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCampaignBudgetRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCampaignBudgetRequest;
                    })();

                    services.MutateCampaignBudgetsRequest = (function() {

                        /**
                         * Properties of a MutateCampaignBudgetsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignBudgetsRequest
                         * @property {string|null} [customerId] MutateCampaignBudgetsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.ICampaignBudgetOperation>|null} [operations] MutateCampaignBudgetsRequest operations
                         * @property {boolean|null} [partialFailure] MutateCampaignBudgetsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateCampaignBudgetsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateCampaignBudgetsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignBudgetsRequest.
                         * @implements IMutateCampaignBudgetsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBudgetsRequest=} [properties] Properties to set
                         */
                        function MutateCampaignBudgetsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignBudgetsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsRequest
                         * @instance
                         */
                        MutateCampaignBudgetsRequest.prototype.customerId = "";

                        /**
                         * MutateCampaignBudgetsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.ICampaignBudgetOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsRequest
                         * @instance
                         */
                        MutateCampaignBudgetsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateCampaignBudgetsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsRequest
                         * @instance
                         */
                        MutateCampaignBudgetsRequest.prototype.partialFailure = false;

                        /**
                         * MutateCampaignBudgetsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsRequest
                         * @instance
                         */
                        MutateCampaignBudgetsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateCampaignBudgetsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBudgetsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBudgetsRequest} MutateCampaignBudgetsRequest instance
                         */
                        MutateCampaignBudgetsRequest.create = function create(properties) {
                            return new MutateCampaignBudgetsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignBudgetsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignBudgetsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBudgetsRequest} message MutateCampaignBudgetsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignBudgetsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.CampaignBudgetOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignBudgetsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignBudgetsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBudgetsRequest} message MutateCampaignBudgetsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignBudgetsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignBudgetsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBudgetsRequest} MutateCampaignBudgetsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignBudgetsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignBudgetsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.CampaignBudgetOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignBudgetsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBudgetsRequest} MutateCampaignBudgetsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignBudgetsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignBudgetsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignBudgetsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.CampaignBudgetOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignBudgetsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBudgetsRequest} MutateCampaignBudgetsRequest
                         */
                        MutateCampaignBudgetsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignBudgetsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignBudgetsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignBudgetsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCampaignBudgetsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.CampaignBudgetOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignBudgetsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignBudgetsRequest} message MutateCampaignBudgetsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignBudgetsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.CampaignBudgetOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignBudgetsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignBudgetsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignBudgetsRequest;
                    })();

                    services.CampaignBudgetOperation = (function() {

                        /**
                         * Properties of a CampaignBudgetOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICampaignBudgetOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] CampaignBudgetOperation updateMask
                         * @property {google.ads.googleads.v1.resources.ICampaignBudget|null} [create] CampaignBudgetOperation create
                         * @property {google.ads.googleads.v1.resources.ICampaignBudget|null} [update] CampaignBudgetOperation update
                         * @property {string|null} [remove] CampaignBudgetOperation remove
                         */

                        /**
                         * Constructs a new CampaignBudgetOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CampaignBudgetOperation.
                         * @implements ICampaignBudgetOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICampaignBudgetOperation=} [properties] Properties to set
                         */
                        function CampaignBudgetOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CampaignBudgetOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetOperation
                         * @instance
                         */
                        CampaignBudgetOperation.prototype.updateMask = null;

                        /**
                         * CampaignBudgetOperation create.
                         * @member {google.ads.googleads.v1.resources.ICampaignBudget|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetOperation
                         * @instance
                         */
                        CampaignBudgetOperation.prototype.create = null;

                        /**
                         * CampaignBudgetOperation update.
                         * @member {google.ads.googleads.v1.resources.ICampaignBudget|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetOperation
                         * @instance
                         */
                        CampaignBudgetOperation.prototype.update = null;

                        /**
                         * CampaignBudgetOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetOperation
                         * @instance
                         */
                        CampaignBudgetOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CampaignBudgetOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetOperation
                         * @instance
                         */
                        Object.defineProperty(CampaignBudgetOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CampaignBudgetOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignBudgetOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CampaignBudgetOperation} CampaignBudgetOperation instance
                         */
                        CampaignBudgetOperation.create = function create(properties) {
                            return new CampaignBudgetOperation(properties);
                        };

                        /**
                         * Encodes the specified CampaignBudgetOperation message. Does not implicitly {@link google.ads.googleads.v1.services.CampaignBudgetOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignBudgetOperation} message CampaignBudgetOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignBudgetOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.CampaignBudget.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.CampaignBudget.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignBudgetOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CampaignBudgetOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignBudgetOperation} message CampaignBudgetOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignBudgetOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignBudgetOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CampaignBudgetOperation} CampaignBudgetOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignBudgetOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CampaignBudgetOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.CampaignBudget.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.CampaignBudget.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignBudgetOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CampaignBudgetOperation} CampaignBudgetOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignBudgetOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignBudgetOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignBudgetOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CampaignBudget.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CampaignBudget.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a CampaignBudgetOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CampaignBudgetOperation} CampaignBudgetOperation
                         */
                        CampaignBudgetOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CampaignBudgetOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CampaignBudgetOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignBudgetOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignBudgetOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.CampaignBudget.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignBudgetOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.CampaignBudget.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a CampaignBudgetOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.CampaignBudgetOperation} message CampaignBudgetOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignBudgetOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.CampaignBudget.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.CampaignBudget.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this CampaignBudgetOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CampaignBudgetOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignBudgetOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CampaignBudgetOperation;
                    })();

                    services.MutateCampaignBudgetsResponse = (function() {

                        /**
                         * Properties of a MutateCampaignBudgetsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignBudgetsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateCampaignBudgetsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateCampaignBudgetResult>|null} [results] MutateCampaignBudgetsResponse results
                         */

                        /**
                         * Constructs a new MutateCampaignBudgetsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignBudgetsResponse.
                         * @implements IMutateCampaignBudgetsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBudgetsResponse=} [properties] Properties to set
                         */
                        function MutateCampaignBudgetsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignBudgetsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsResponse
                         * @instance
                         */
                        MutateCampaignBudgetsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateCampaignBudgetsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateCampaignBudgetResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsResponse
                         * @instance
                         */
                        MutateCampaignBudgetsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateCampaignBudgetsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBudgetsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBudgetsResponse} MutateCampaignBudgetsResponse instance
                         */
                        MutateCampaignBudgetsResponse.create = function create(properties) {
                            return new MutateCampaignBudgetsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignBudgetsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignBudgetsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBudgetsResponse} message MutateCampaignBudgetsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignBudgetsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateCampaignBudgetResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignBudgetsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignBudgetsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBudgetsResponse} message MutateCampaignBudgetsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignBudgetsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignBudgetsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBudgetsResponse} MutateCampaignBudgetsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignBudgetsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignBudgetsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateCampaignBudgetResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignBudgetsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBudgetsResponse} MutateCampaignBudgetsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignBudgetsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignBudgetsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignBudgetsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateCampaignBudgetResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignBudgetsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBudgetsResponse} MutateCampaignBudgetsResponse
                         */
                        MutateCampaignBudgetsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignBudgetsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignBudgetsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignBudgetsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignBudgetsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCampaignBudgetsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateCampaignBudgetResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignBudgetsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignBudgetsResponse} message MutateCampaignBudgetsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignBudgetsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateCampaignBudgetResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignBudgetsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignBudgetsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignBudgetsResponse;
                    })();

                    services.MutateCampaignBudgetResult = (function() {

                        /**
                         * Properties of a MutateCampaignBudgetResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignBudgetResult
                         * @property {string|null} [resourceName] MutateCampaignBudgetResult resourceName
                         */

                        /**
                         * Constructs a new MutateCampaignBudgetResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignBudgetResult.
                         * @implements IMutateCampaignBudgetResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBudgetResult=} [properties] Properties to set
                         */
                        function MutateCampaignBudgetResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignBudgetResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetResult
                         * @instance
                         */
                        MutateCampaignBudgetResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateCampaignBudgetResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBudgetResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBudgetResult} MutateCampaignBudgetResult instance
                         */
                        MutateCampaignBudgetResult.create = function create(properties) {
                            return new MutateCampaignBudgetResult(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignBudgetResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignBudgetResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBudgetResult} message MutateCampaignBudgetResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignBudgetResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignBudgetResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignBudgetResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignBudgetResult} message MutateCampaignBudgetResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignBudgetResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignBudgetResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBudgetResult} MutateCampaignBudgetResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignBudgetResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignBudgetResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignBudgetResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBudgetResult} MutateCampaignBudgetResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignBudgetResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignBudgetResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignBudgetResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignBudgetResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignBudgetResult} MutateCampaignBudgetResult
                         */
                        MutateCampaignBudgetResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignBudgetResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignBudgetResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignBudgetResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignBudgetResult} message MutateCampaignBudgetResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignBudgetResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignBudgetResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignBudgetResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignBudgetResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignBudgetResult;
                    })();

                    services.CampaignCriterionService = (function() {

                        /**
                         * Constructs a new CampaignCriterionService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CampaignCriterionService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CampaignCriterionService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CampaignCriterionService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CampaignCriterionService;

                        /**
                         * Creates new CampaignCriterionService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CampaignCriterionService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CampaignCriterionService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CampaignCriterionService#getCampaignCriterion}.
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionService
                         * @typedef GetCampaignCriterionCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.CampaignCriterion} [response] CampaignCriterion
                         */

                        /**
                         * Calls GetCampaignCriterion.
                         * @function getCampaignCriterion
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignCriterionRequest} request GetCampaignCriterionRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CampaignCriterionService.GetCampaignCriterionCallback} callback Node-style callback called with the error, if any, and CampaignCriterion
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CampaignCriterionService.prototype.getCampaignCriterion = function getCampaignCriterion(request, callback) {
                            return this.rpcCall(getCampaignCriterion, $root.google.ads.googleads.v1.services.GetCampaignCriterionRequest, $root.google.ads.googleads.v1.resources.CampaignCriterion, request, callback);
                        }, "name", { value: "GetCampaignCriterion" });

                        /**
                         * Calls GetCampaignCriterion.
                         * @function getCampaignCriterion
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignCriterionRequest} request GetCampaignCriterionRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.CampaignCriterion>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CampaignCriterionService#mutateCampaignCriteria}.
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionService
                         * @typedef MutateCampaignCriteriaCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateCampaignCriteriaResponse} [response] MutateCampaignCriteriaResponse
                         */

                        /**
                         * Calls MutateCampaignCriteria.
                         * @function mutateCampaignCriteria
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCampaignCriteriaRequest} request MutateCampaignCriteriaRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CampaignCriterionService.MutateCampaignCriteriaCallback} callback Node-style callback called with the error, if any, and MutateCampaignCriteriaResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CampaignCriterionService.prototype.mutateCampaignCriteria = function mutateCampaignCriteria(request, callback) {
                            return this.rpcCall(mutateCampaignCriteria, $root.google.ads.googleads.v1.services.MutateCampaignCriteriaRequest, $root.google.ads.googleads.v1.services.MutateCampaignCriteriaResponse, request, callback);
                        }, "name", { value: "MutateCampaignCriteria" });

                        /**
                         * Calls MutateCampaignCriteria.
                         * @function mutateCampaignCriteria
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCampaignCriteriaRequest} request MutateCampaignCriteriaRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateCampaignCriteriaResponse>} Promise
                         * @variation 2
                         */

                        return CampaignCriterionService;
                    })();

                    services.GetCampaignCriterionRequest = (function() {

                        /**
                         * Properties of a GetCampaignCriterionRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCampaignCriterionRequest
                         * @property {string|null} [resourceName] GetCampaignCriterionRequest resourceName
                         */

                        /**
                         * Constructs a new GetCampaignCriterionRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCampaignCriterionRequest.
                         * @implements IGetCampaignCriterionRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCampaignCriterionRequest=} [properties] Properties to set
                         */
                        function GetCampaignCriterionRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCampaignCriterionRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionRequest
                         * @instance
                         */
                        GetCampaignCriterionRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCampaignCriterionRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignCriterionRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCampaignCriterionRequest} GetCampaignCriterionRequest instance
                         */
                        GetCampaignCriterionRequest.create = function create(properties) {
                            return new GetCampaignCriterionRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCampaignCriterionRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignCriterionRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignCriterionRequest} message GetCampaignCriterionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignCriterionRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCampaignCriterionRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignCriterionRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignCriterionRequest} message GetCampaignCriterionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignCriterionRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCampaignCriterionRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCampaignCriterionRequest} GetCampaignCriterionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignCriterionRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCampaignCriterionRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCampaignCriterionRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCampaignCriterionRequest} GetCampaignCriterionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignCriterionRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCampaignCriterionRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCampaignCriterionRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCampaignCriterionRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCampaignCriterionRequest} GetCampaignCriterionRequest
                         */
                        GetCampaignCriterionRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCampaignCriterionRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCampaignCriterionRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCampaignCriterionRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCampaignCriterionRequest} message GetCampaignCriterionRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCampaignCriterionRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCampaignCriterionRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCampaignCriterionRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCampaignCriterionRequest;
                    })();

                    services.MutateCampaignCriteriaRequest = (function() {

                        /**
                         * Properties of a MutateCampaignCriteriaRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignCriteriaRequest
                         * @property {string|null} [customerId] MutateCampaignCriteriaRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.ICampaignCriterionOperation>|null} [operations] MutateCampaignCriteriaRequest operations
                         * @property {boolean|null} [partialFailure] MutateCampaignCriteriaRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateCampaignCriteriaRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateCampaignCriteriaRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignCriteriaRequest.
                         * @implements IMutateCampaignCriteriaRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignCriteriaRequest=} [properties] Properties to set
                         */
                        function MutateCampaignCriteriaRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignCriteriaRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaRequest
                         * @instance
                         */
                        MutateCampaignCriteriaRequest.prototype.customerId = "";

                        /**
                         * MutateCampaignCriteriaRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.ICampaignCriterionOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaRequest
                         * @instance
                         */
                        MutateCampaignCriteriaRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateCampaignCriteriaRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaRequest
                         * @instance
                         */
                        MutateCampaignCriteriaRequest.prototype.partialFailure = false;

                        /**
                         * MutateCampaignCriteriaRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaRequest
                         * @instance
                         */
                        MutateCampaignCriteriaRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateCampaignCriteriaRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignCriteriaRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignCriteriaRequest} MutateCampaignCriteriaRequest instance
                         */
                        MutateCampaignCriteriaRequest.create = function create(properties) {
                            return new MutateCampaignCriteriaRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignCriteriaRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignCriteriaRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignCriteriaRequest} message MutateCampaignCriteriaRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignCriteriaRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.CampaignCriterionOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignCriteriaRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignCriteriaRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignCriteriaRequest} message MutateCampaignCriteriaRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignCriteriaRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignCriteriaRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignCriteriaRequest} MutateCampaignCriteriaRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignCriteriaRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignCriteriaRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.CampaignCriterionOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignCriteriaRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignCriteriaRequest} MutateCampaignCriteriaRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignCriteriaRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignCriteriaRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignCriteriaRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.CampaignCriterionOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignCriteriaRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignCriteriaRequest} MutateCampaignCriteriaRequest
                         */
                        MutateCampaignCriteriaRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignCriteriaRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignCriteriaRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignCriteriaRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCampaignCriteriaRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.CampaignCriterionOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignCriteriaRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignCriteriaRequest} message MutateCampaignCriteriaRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignCriteriaRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.CampaignCriterionOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignCriteriaRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignCriteriaRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignCriteriaRequest;
                    })();

                    services.CampaignCriterionOperation = (function() {

                        /**
                         * Properties of a CampaignCriterionOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICampaignCriterionOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] CampaignCriterionOperation updateMask
                         * @property {google.ads.googleads.v1.resources.ICampaignCriterion|null} [create] CampaignCriterionOperation create
                         * @property {google.ads.googleads.v1.resources.ICampaignCriterion|null} [update] CampaignCriterionOperation update
                         * @property {string|null} [remove] CampaignCriterionOperation remove
                         */

                        /**
                         * Constructs a new CampaignCriterionOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CampaignCriterionOperation.
                         * @implements ICampaignCriterionOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICampaignCriterionOperation=} [properties] Properties to set
                         */
                        function CampaignCriterionOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CampaignCriterionOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionOperation
                         * @instance
                         */
                        CampaignCriterionOperation.prototype.updateMask = null;

                        /**
                         * CampaignCriterionOperation create.
                         * @member {google.ads.googleads.v1.resources.ICampaignCriterion|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionOperation
                         * @instance
                         */
                        CampaignCriterionOperation.prototype.create = null;

                        /**
                         * CampaignCriterionOperation update.
                         * @member {google.ads.googleads.v1.resources.ICampaignCriterion|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionOperation
                         * @instance
                         */
                        CampaignCriterionOperation.prototype.update = null;

                        /**
                         * CampaignCriterionOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionOperation
                         * @instance
                         */
                        CampaignCriterionOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CampaignCriterionOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionOperation
                         * @instance
                         */
                        Object.defineProperty(CampaignCriterionOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CampaignCriterionOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignCriterionOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CampaignCriterionOperation} CampaignCriterionOperation instance
                         */
                        CampaignCriterionOperation.create = function create(properties) {
                            return new CampaignCriterionOperation(properties);
                        };

                        /**
                         * Encodes the specified CampaignCriterionOperation message. Does not implicitly {@link google.ads.googleads.v1.services.CampaignCriterionOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignCriterionOperation} message CampaignCriterionOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignCriterionOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.CampaignCriterion.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.CampaignCriterion.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignCriterionOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CampaignCriterionOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignCriterionOperation} message CampaignCriterionOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignCriterionOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignCriterionOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CampaignCriterionOperation} CampaignCriterionOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignCriterionOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CampaignCriterionOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.CampaignCriterion.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.CampaignCriterion.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignCriterionOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CampaignCriterionOperation} CampaignCriterionOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignCriterionOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignCriterionOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignCriterionOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CampaignCriterion.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CampaignCriterion.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a CampaignCriterionOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CampaignCriterionOperation} CampaignCriterionOperation
                         */
                        CampaignCriterionOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CampaignCriterionOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CampaignCriterionOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignCriterionOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignCriterionOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.CampaignCriterion.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignCriterionOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.CampaignCriterion.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a CampaignCriterionOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.CampaignCriterionOperation} message CampaignCriterionOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignCriterionOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.CampaignCriterion.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.CampaignCriterion.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this CampaignCriterionOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignCriterionOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CampaignCriterionOperation;
                    })();

                    services.MutateCampaignCriteriaResponse = (function() {

                        /**
                         * Properties of a MutateCampaignCriteriaResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignCriteriaResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateCampaignCriteriaResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateCampaignCriterionResult>|null} [results] MutateCampaignCriteriaResponse results
                         */

                        /**
                         * Constructs a new MutateCampaignCriteriaResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignCriteriaResponse.
                         * @implements IMutateCampaignCriteriaResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignCriteriaResponse=} [properties] Properties to set
                         */
                        function MutateCampaignCriteriaResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignCriteriaResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaResponse
                         * @instance
                         */
                        MutateCampaignCriteriaResponse.prototype.partialFailureError = null;

                        /**
                         * MutateCampaignCriteriaResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateCampaignCriterionResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaResponse
                         * @instance
                         */
                        MutateCampaignCriteriaResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateCampaignCriteriaResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignCriteriaResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignCriteriaResponse} MutateCampaignCriteriaResponse instance
                         */
                        MutateCampaignCriteriaResponse.create = function create(properties) {
                            return new MutateCampaignCriteriaResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignCriteriaResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignCriteriaResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignCriteriaResponse} message MutateCampaignCriteriaResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignCriteriaResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateCampaignCriterionResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignCriteriaResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignCriteriaResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignCriteriaResponse} message MutateCampaignCriteriaResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignCriteriaResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignCriteriaResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignCriteriaResponse} MutateCampaignCriteriaResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignCriteriaResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignCriteriaResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateCampaignCriterionResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignCriteriaResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignCriteriaResponse} MutateCampaignCriteriaResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignCriteriaResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignCriteriaResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignCriteriaResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateCampaignCriterionResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignCriteriaResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignCriteriaResponse} MutateCampaignCriteriaResponse
                         */
                        MutateCampaignCriteriaResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignCriteriaResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignCriteriaResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignCriteriaResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignCriteriaResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCampaignCriteriaResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateCampaignCriterionResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignCriteriaResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignCriteriaResponse} message MutateCampaignCriteriaResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignCriteriaResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateCampaignCriterionResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignCriteriaResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriteriaResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignCriteriaResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignCriteriaResponse;
                    })();

                    services.MutateCampaignCriterionResult = (function() {

                        /**
                         * Properties of a MutateCampaignCriterionResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignCriterionResult
                         * @property {string|null} [resourceName] MutateCampaignCriterionResult resourceName
                         */

                        /**
                         * Constructs a new MutateCampaignCriterionResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignCriterionResult.
                         * @implements IMutateCampaignCriterionResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignCriterionResult=} [properties] Properties to set
                         */
                        function MutateCampaignCriterionResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignCriterionResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriterionResult
                         * @instance
                         */
                        MutateCampaignCriterionResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateCampaignCriterionResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriterionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignCriterionResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignCriterionResult} MutateCampaignCriterionResult instance
                         */
                        MutateCampaignCriterionResult.create = function create(properties) {
                            return new MutateCampaignCriterionResult(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignCriterionResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignCriterionResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriterionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignCriterionResult} message MutateCampaignCriterionResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignCriterionResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignCriterionResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignCriterionResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriterionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignCriterionResult} message MutateCampaignCriterionResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignCriterionResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignCriterionResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriterionResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignCriterionResult} MutateCampaignCriterionResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignCriterionResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignCriterionResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignCriterionResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriterionResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignCriterionResult} MutateCampaignCriterionResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignCriterionResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignCriterionResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriterionResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignCriterionResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignCriterionResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriterionResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignCriterionResult} MutateCampaignCriterionResult
                         */
                        MutateCampaignCriterionResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignCriterionResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignCriterionResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignCriterionResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriterionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignCriterionResult} message MutateCampaignCriterionResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignCriterionResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignCriterionResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignCriterionResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignCriterionResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignCriterionResult;
                    })();

                    services.CampaignCriterionSimulationService = (function() {

                        /**
                         * Constructs a new CampaignCriterionSimulationService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CampaignCriterionSimulationService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CampaignCriterionSimulationService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CampaignCriterionSimulationService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CampaignCriterionSimulationService;

                        /**
                         * Creates new CampaignCriterionSimulationService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionSimulationService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CampaignCriterionSimulationService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CampaignCriterionSimulationService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CampaignCriterionSimulationService#getCampaignCriterionSimulation}.
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionSimulationService
                         * @typedef GetCampaignCriterionSimulationCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.CampaignCriterionSimulation} [response] CampaignCriterionSimulation
                         */

                        /**
                         * Calls GetCampaignCriterionSimulation.
                         * @function getCampaignCriterionSimulation
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionSimulationService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignCriterionSimulationRequest} request GetCampaignCriterionSimulationRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CampaignCriterionSimulationService.GetCampaignCriterionSimulationCallback} callback Node-style callback called with the error, if any, and CampaignCriterionSimulation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CampaignCriterionSimulationService.prototype.getCampaignCriterionSimulation = function getCampaignCriterionSimulation(request, callback) {
                            return this.rpcCall(getCampaignCriterionSimulation, $root.google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest, $root.google.ads.googleads.v1.resources.CampaignCriterionSimulation, request, callback);
                        }, "name", { value: "GetCampaignCriterionSimulation" });

                        /**
                         * Calls GetCampaignCriterionSimulation.
                         * @function getCampaignCriterionSimulation
                         * @memberof google.ads.googleads.v1.services.CampaignCriterionSimulationService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignCriterionSimulationRequest} request GetCampaignCriterionSimulationRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.CampaignCriterionSimulation>} Promise
                         * @variation 2
                         */

                        return CampaignCriterionSimulationService;
                    })();

                    services.GetCampaignCriterionSimulationRequest = (function() {

                        /**
                         * Properties of a GetCampaignCriterionSimulationRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCampaignCriterionSimulationRequest
                         * @property {string|null} [resourceName] GetCampaignCriterionSimulationRequest resourceName
                         */

                        /**
                         * Constructs a new GetCampaignCriterionSimulationRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCampaignCriterionSimulationRequest.
                         * @implements IGetCampaignCriterionSimulationRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCampaignCriterionSimulationRequest=} [properties] Properties to set
                         */
                        function GetCampaignCriterionSimulationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCampaignCriterionSimulationRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest
                         * @instance
                         */
                        GetCampaignCriterionSimulationRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCampaignCriterionSimulationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignCriterionSimulationRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest} GetCampaignCriterionSimulationRequest instance
                         */
                        GetCampaignCriterionSimulationRequest.create = function create(properties) {
                            return new GetCampaignCriterionSimulationRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCampaignCriterionSimulationRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignCriterionSimulationRequest} message GetCampaignCriterionSimulationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignCriterionSimulationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCampaignCriterionSimulationRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignCriterionSimulationRequest} message GetCampaignCriterionSimulationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignCriterionSimulationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCampaignCriterionSimulationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest} GetCampaignCriterionSimulationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignCriterionSimulationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCampaignCriterionSimulationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest} GetCampaignCriterionSimulationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignCriterionSimulationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCampaignCriterionSimulationRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCampaignCriterionSimulationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCampaignCriterionSimulationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest} GetCampaignCriterionSimulationRequest
                         */
                        GetCampaignCriterionSimulationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCampaignCriterionSimulationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest} message GetCampaignCriterionSimulationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCampaignCriterionSimulationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCampaignCriterionSimulationRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCampaignCriterionSimulationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCampaignCriterionSimulationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCampaignCriterionSimulationRequest;
                    })();

                    services.CampaignExtensionSettingService = (function() {

                        /**
                         * Constructs a new CampaignExtensionSettingService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CampaignExtensionSettingService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CampaignExtensionSettingService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CampaignExtensionSettingService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CampaignExtensionSettingService;

                        /**
                         * Creates new CampaignExtensionSettingService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CampaignExtensionSettingService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CampaignExtensionSettingService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CampaignExtensionSettingService#getCampaignExtensionSetting}.
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingService
                         * @typedef GetCampaignExtensionSettingCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.CampaignExtensionSetting} [response] CampaignExtensionSetting
                         */

                        /**
                         * Calls GetCampaignExtensionSetting.
                         * @function getCampaignExtensionSetting
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignExtensionSettingRequest} request GetCampaignExtensionSettingRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CampaignExtensionSettingService.GetCampaignExtensionSettingCallback} callback Node-style callback called with the error, if any, and CampaignExtensionSetting
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CampaignExtensionSettingService.prototype.getCampaignExtensionSetting = function getCampaignExtensionSetting(request, callback) {
                            return this.rpcCall(getCampaignExtensionSetting, $root.google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest, $root.google.ads.googleads.v1.resources.CampaignExtensionSetting, request, callback);
                        }, "name", { value: "GetCampaignExtensionSetting" });

                        /**
                         * Calls GetCampaignExtensionSetting.
                         * @function getCampaignExtensionSetting
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignExtensionSettingRequest} request GetCampaignExtensionSettingRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.CampaignExtensionSetting>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CampaignExtensionSettingService#mutateCampaignExtensionSettings}.
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingService
                         * @typedef MutateCampaignExtensionSettingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse} [response] MutateCampaignExtensionSettingsResponse
                         */

                        /**
                         * Calls MutateCampaignExtensionSettings.
                         * @function mutateCampaignExtensionSettings
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCampaignExtensionSettingsRequest} request MutateCampaignExtensionSettingsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CampaignExtensionSettingService.MutateCampaignExtensionSettingsCallback} callback Node-style callback called with the error, if any, and MutateCampaignExtensionSettingsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CampaignExtensionSettingService.prototype.mutateCampaignExtensionSettings = function mutateCampaignExtensionSettings(request, callback) {
                            return this.rpcCall(mutateCampaignExtensionSettings, $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest, $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse, request, callback);
                        }, "name", { value: "MutateCampaignExtensionSettings" });

                        /**
                         * Calls MutateCampaignExtensionSettings.
                         * @function mutateCampaignExtensionSettings
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCampaignExtensionSettingsRequest} request MutateCampaignExtensionSettingsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse>} Promise
                         * @variation 2
                         */

                        return CampaignExtensionSettingService;
                    })();

                    services.GetCampaignExtensionSettingRequest = (function() {

                        /**
                         * Properties of a GetCampaignExtensionSettingRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCampaignExtensionSettingRequest
                         * @property {string|null} [resourceName] GetCampaignExtensionSettingRequest resourceName
                         */

                        /**
                         * Constructs a new GetCampaignExtensionSettingRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCampaignExtensionSettingRequest.
                         * @implements IGetCampaignExtensionSettingRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCampaignExtensionSettingRequest=} [properties] Properties to set
                         */
                        function GetCampaignExtensionSettingRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCampaignExtensionSettingRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest
                         * @instance
                         */
                        GetCampaignExtensionSettingRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCampaignExtensionSettingRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignExtensionSettingRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest} GetCampaignExtensionSettingRequest instance
                         */
                        GetCampaignExtensionSettingRequest.create = function create(properties) {
                            return new GetCampaignExtensionSettingRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCampaignExtensionSettingRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignExtensionSettingRequest} message GetCampaignExtensionSettingRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignExtensionSettingRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCampaignExtensionSettingRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignExtensionSettingRequest} message GetCampaignExtensionSettingRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignExtensionSettingRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCampaignExtensionSettingRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest} GetCampaignExtensionSettingRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignExtensionSettingRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCampaignExtensionSettingRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest} GetCampaignExtensionSettingRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignExtensionSettingRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCampaignExtensionSettingRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCampaignExtensionSettingRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCampaignExtensionSettingRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest} GetCampaignExtensionSettingRequest
                         */
                        GetCampaignExtensionSettingRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCampaignExtensionSettingRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest} message GetCampaignExtensionSettingRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCampaignExtensionSettingRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCampaignExtensionSettingRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCampaignExtensionSettingRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCampaignExtensionSettingRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCampaignExtensionSettingRequest;
                    })();

                    services.MutateCampaignExtensionSettingsRequest = (function() {

                        /**
                         * Properties of a MutateCampaignExtensionSettingsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignExtensionSettingsRequest
                         * @property {string|null} [customerId] MutateCampaignExtensionSettingsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.ICampaignExtensionSettingOperation>|null} [operations] MutateCampaignExtensionSettingsRequest operations
                         * @property {boolean|null} [partialFailure] MutateCampaignExtensionSettingsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateCampaignExtensionSettingsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateCampaignExtensionSettingsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignExtensionSettingsRequest.
                         * @implements IMutateCampaignExtensionSettingsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignExtensionSettingsRequest=} [properties] Properties to set
                         */
                        function MutateCampaignExtensionSettingsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignExtensionSettingsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest
                         * @instance
                         */
                        MutateCampaignExtensionSettingsRequest.prototype.customerId = "";

                        /**
                         * MutateCampaignExtensionSettingsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.ICampaignExtensionSettingOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest
                         * @instance
                         */
                        MutateCampaignExtensionSettingsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateCampaignExtensionSettingsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest
                         * @instance
                         */
                        MutateCampaignExtensionSettingsRequest.prototype.partialFailure = false;

                        /**
                         * MutateCampaignExtensionSettingsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest
                         * @instance
                         */
                        MutateCampaignExtensionSettingsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateCampaignExtensionSettingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignExtensionSettingsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest} MutateCampaignExtensionSettingsRequest instance
                         */
                        MutateCampaignExtensionSettingsRequest.create = function create(properties) {
                            return new MutateCampaignExtensionSettingsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignExtensionSettingsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignExtensionSettingsRequest} message MutateCampaignExtensionSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignExtensionSettingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.CampaignExtensionSettingOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignExtensionSettingsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignExtensionSettingsRequest} message MutateCampaignExtensionSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignExtensionSettingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignExtensionSettingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest} MutateCampaignExtensionSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignExtensionSettingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.CampaignExtensionSettingOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignExtensionSettingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest} MutateCampaignExtensionSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignExtensionSettingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignExtensionSettingsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignExtensionSettingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.CampaignExtensionSettingOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignExtensionSettingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest} MutateCampaignExtensionSettingsRequest
                         */
                        MutateCampaignExtensionSettingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.CampaignExtensionSettingOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignExtensionSettingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest} message MutateCampaignExtensionSettingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignExtensionSettingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.CampaignExtensionSettingOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignExtensionSettingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignExtensionSettingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignExtensionSettingsRequest;
                    })();

                    services.CampaignExtensionSettingOperation = (function() {

                        /**
                         * Properties of a CampaignExtensionSettingOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICampaignExtensionSettingOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] CampaignExtensionSettingOperation updateMask
                         * @property {google.ads.googleads.v1.resources.ICampaignExtensionSetting|null} [create] CampaignExtensionSettingOperation create
                         * @property {google.ads.googleads.v1.resources.ICampaignExtensionSetting|null} [update] CampaignExtensionSettingOperation update
                         * @property {string|null} [remove] CampaignExtensionSettingOperation remove
                         */

                        /**
                         * Constructs a new CampaignExtensionSettingOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CampaignExtensionSettingOperation.
                         * @implements ICampaignExtensionSettingOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICampaignExtensionSettingOperation=} [properties] Properties to set
                         */
                        function CampaignExtensionSettingOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CampaignExtensionSettingOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingOperation
                         * @instance
                         */
                        CampaignExtensionSettingOperation.prototype.updateMask = null;

                        /**
                         * CampaignExtensionSettingOperation create.
                         * @member {google.ads.googleads.v1.resources.ICampaignExtensionSetting|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingOperation
                         * @instance
                         */
                        CampaignExtensionSettingOperation.prototype.create = null;

                        /**
                         * CampaignExtensionSettingOperation update.
                         * @member {google.ads.googleads.v1.resources.ICampaignExtensionSetting|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingOperation
                         * @instance
                         */
                        CampaignExtensionSettingOperation.prototype.update = null;

                        /**
                         * CampaignExtensionSettingOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingOperation
                         * @instance
                         */
                        CampaignExtensionSettingOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CampaignExtensionSettingOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingOperation
                         * @instance
                         */
                        Object.defineProperty(CampaignExtensionSettingOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CampaignExtensionSettingOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignExtensionSettingOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CampaignExtensionSettingOperation} CampaignExtensionSettingOperation instance
                         */
                        CampaignExtensionSettingOperation.create = function create(properties) {
                            return new CampaignExtensionSettingOperation(properties);
                        };

                        /**
                         * Encodes the specified CampaignExtensionSettingOperation message. Does not implicitly {@link google.ads.googleads.v1.services.CampaignExtensionSettingOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignExtensionSettingOperation} message CampaignExtensionSettingOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignExtensionSettingOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.CampaignExtensionSetting.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.CampaignExtensionSetting.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignExtensionSettingOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CampaignExtensionSettingOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignExtensionSettingOperation} message CampaignExtensionSettingOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignExtensionSettingOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignExtensionSettingOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CampaignExtensionSettingOperation} CampaignExtensionSettingOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignExtensionSettingOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CampaignExtensionSettingOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.CampaignExtensionSetting.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.CampaignExtensionSetting.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignExtensionSettingOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CampaignExtensionSettingOperation} CampaignExtensionSettingOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignExtensionSettingOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignExtensionSettingOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignExtensionSettingOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CampaignExtensionSetting.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CampaignExtensionSetting.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a CampaignExtensionSettingOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CampaignExtensionSettingOperation} CampaignExtensionSettingOperation
                         */
                        CampaignExtensionSettingOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CampaignExtensionSettingOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CampaignExtensionSettingOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignExtensionSettingOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignExtensionSettingOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.CampaignExtensionSetting.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignExtensionSettingOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.CampaignExtensionSetting.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a CampaignExtensionSettingOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.CampaignExtensionSettingOperation} message CampaignExtensionSettingOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignExtensionSettingOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.CampaignExtensionSetting.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.CampaignExtensionSetting.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this CampaignExtensionSettingOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CampaignExtensionSettingOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignExtensionSettingOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CampaignExtensionSettingOperation;
                    })();

                    services.MutateCampaignExtensionSettingsResponse = (function() {

                        /**
                         * Properties of a MutateCampaignExtensionSettingsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignExtensionSettingsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateCampaignExtensionSettingsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateCampaignExtensionSettingResult>|null} [results] MutateCampaignExtensionSettingsResponse results
                         */

                        /**
                         * Constructs a new MutateCampaignExtensionSettingsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignExtensionSettingsResponse.
                         * @implements IMutateCampaignExtensionSettingsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignExtensionSettingsResponse=} [properties] Properties to set
                         */
                        function MutateCampaignExtensionSettingsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignExtensionSettingsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse
                         * @instance
                         */
                        MutateCampaignExtensionSettingsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateCampaignExtensionSettingsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateCampaignExtensionSettingResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse
                         * @instance
                         */
                        MutateCampaignExtensionSettingsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateCampaignExtensionSettingsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignExtensionSettingsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse} MutateCampaignExtensionSettingsResponse instance
                         */
                        MutateCampaignExtensionSettingsResponse.create = function create(properties) {
                            return new MutateCampaignExtensionSettingsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignExtensionSettingsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignExtensionSettingsResponse} message MutateCampaignExtensionSettingsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignExtensionSettingsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignExtensionSettingsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignExtensionSettingsResponse} message MutateCampaignExtensionSettingsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignExtensionSettingsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignExtensionSettingsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse} MutateCampaignExtensionSettingsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignExtensionSettingsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignExtensionSettingsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse} MutateCampaignExtensionSettingsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignExtensionSettingsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignExtensionSettingsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignExtensionSettingsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignExtensionSettingsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse} MutateCampaignExtensionSettingsResponse
                         */
                        MutateCampaignExtensionSettingsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignExtensionSettingsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse} message MutateCampaignExtensionSettingsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignExtensionSettingsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignExtensionSettingsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignExtensionSettingsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignExtensionSettingsResponse;
                    })();

                    services.MutateCampaignExtensionSettingResult = (function() {

                        /**
                         * Properties of a MutateCampaignExtensionSettingResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignExtensionSettingResult
                         * @property {string|null} [resourceName] MutateCampaignExtensionSettingResult resourceName
                         */

                        /**
                         * Constructs a new MutateCampaignExtensionSettingResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignExtensionSettingResult.
                         * @implements IMutateCampaignExtensionSettingResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignExtensionSettingResult=} [properties] Properties to set
                         */
                        function MutateCampaignExtensionSettingResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignExtensionSettingResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult
                         * @instance
                         */
                        MutateCampaignExtensionSettingResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateCampaignExtensionSettingResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignExtensionSettingResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult} MutateCampaignExtensionSettingResult instance
                         */
                        MutateCampaignExtensionSettingResult.create = function create(properties) {
                            return new MutateCampaignExtensionSettingResult(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignExtensionSettingResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignExtensionSettingResult} message MutateCampaignExtensionSettingResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignExtensionSettingResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignExtensionSettingResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignExtensionSettingResult} message MutateCampaignExtensionSettingResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignExtensionSettingResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignExtensionSettingResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult} MutateCampaignExtensionSettingResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignExtensionSettingResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignExtensionSettingResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult} MutateCampaignExtensionSettingResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignExtensionSettingResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignExtensionSettingResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignExtensionSettingResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignExtensionSettingResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult} MutateCampaignExtensionSettingResult
                         */
                        MutateCampaignExtensionSettingResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignExtensionSettingResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult} message MutateCampaignExtensionSettingResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignExtensionSettingResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignExtensionSettingResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignExtensionSettingResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignExtensionSettingResult;
                    })();

                    services.CampaignFeedService = (function() {

                        /**
                         * Constructs a new CampaignFeedService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CampaignFeedService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CampaignFeedService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CampaignFeedService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CampaignFeedService;

                        /**
                         * Creates new CampaignFeedService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CampaignFeedService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CampaignFeedService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CampaignFeedService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CampaignFeedService#getCampaignFeed}.
                         * @memberof google.ads.googleads.v1.services.CampaignFeedService
                         * @typedef GetCampaignFeedCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.CampaignFeed} [response] CampaignFeed
                         */

                        /**
                         * Calls GetCampaignFeed.
                         * @function getCampaignFeed
                         * @memberof google.ads.googleads.v1.services.CampaignFeedService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignFeedRequest} request GetCampaignFeedRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CampaignFeedService.GetCampaignFeedCallback} callback Node-style callback called with the error, if any, and CampaignFeed
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CampaignFeedService.prototype.getCampaignFeed = function getCampaignFeed(request, callback) {
                            return this.rpcCall(getCampaignFeed, $root.google.ads.googleads.v1.services.GetCampaignFeedRequest, $root.google.ads.googleads.v1.resources.CampaignFeed, request, callback);
                        }, "name", { value: "GetCampaignFeed" });

                        /**
                         * Calls GetCampaignFeed.
                         * @function getCampaignFeed
                         * @memberof google.ads.googleads.v1.services.CampaignFeedService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignFeedRequest} request GetCampaignFeedRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.CampaignFeed>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CampaignFeedService#mutateCampaignFeeds}.
                         * @memberof google.ads.googleads.v1.services.CampaignFeedService
                         * @typedef MutateCampaignFeedsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateCampaignFeedsResponse} [response] MutateCampaignFeedsResponse
                         */

                        /**
                         * Calls MutateCampaignFeeds.
                         * @function mutateCampaignFeeds
                         * @memberof google.ads.googleads.v1.services.CampaignFeedService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCampaignFeedsRequest} request MutateCampaignFeedsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CampaignFeedService.MutateCampaignFeedsCallback} callback Node-style callback called with the error, if any, and MutateCampaignFeedsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CampaignFeedService.prototype.mutateCampaignFeeds = function mutateCampaignFeeds(request, callback) {
                            return this.rpcCall(mutateCampaignFeeds, $root.google.ads.googleads.v1.services.MutateCampaignFeedsRequest, $root.google.ads.googleads.v1.services.MutateCampaignFeedsResponse, request, callback);
                        }, "name", { value: "MutateCampaignFeeds" });

                        /**
                         * Calls MutateCampaignFeeds.
                         * @function mutateCampaignFeeds
                         * @memberof google.ads.googleads.v1.services.CampaignFeedService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCampaignFeedsRequest} request MutateCampaignFeedsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateCampaignFeedsResponse>} Promise
                         * @variation 2
                         */

                        return CampaignFeedService;
                    })();

                    services.GetCampaignFeedRequest = (function() {

                        /**
                         * Properties of a GetCampaignFeedRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCampaignFeedRequest
                         * @property {string|null} [resourceName] GetCampaignFeedRequest resourceName
                         */

                        /**
                         * Constructs a new GetCampaignFeedRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCampaignFeedRequest.
                         * @implements IGetCampaignFeedRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCampaignFeedRequest=} [properties] Properties to set
                         */
                        function GetCampaignFeedRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCampaignFeedRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCampaignFeedRequest
                         * @instance
                         */
                        GetCampaignFeedRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCampaignFeedRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCampaignFeedRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignFeedRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCampaignFeedRequest} GetCampaignFeedRequest instance
                         */
                        GetCampaignFeedRequest.create = function create(properties) {
                            return new GetCampaignFeedRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCampaignFeedRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignFeedRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCampaignFeedRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignFeedRequest} message GetCampaignFeedRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignFeedRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCampaignFeedRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignFeedRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignFeedRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignFeedRequest} message GetCampaignFeedRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignFeedRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCampaignFeedRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCampaignFeedRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCampaignFeedRequest} GetCampaignFeedRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignFeedRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCampaignFeedRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCampaignFeedRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignFeedRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCampaignFeedRequest} GetCampaignFeedRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignFeedRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCampaignFeedRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCampaignFeedRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCampaignFeedRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCampaignFeedRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignFeedRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCampaignFeedRequest} GetCampaignFeedRequest
                         */
                        GetCampaignFeedRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCampaignFeedRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCampaignFeedRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCampaignFeedRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignFeedRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCampaignFeedRequest} message GetCampaignFeedRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCampaignFeedRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCampaignFeedRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCampaignFeedRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCampaignFeedRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCampaignFeedRequest;
                    })();

                    services.MutateCampaignFeedsRequest = (function() {

                        /**
                         * Properties of a MutateCampaignFeedsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignFeedsRequest
                         * @property {string|null} [customerId] MutateCampaignFeedsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.ICampaignFeedOperation>|null} [operations] MutateCampaignFeedsRequest operations
                         * @property {boolean|null} [partialFailure] MutateCampaignFeedsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateCampaignFeedsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateCampaignFeedsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignFeedsRequest.
                         * @implements IMutateCampaignFeedsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignFeedsRequest=} [properties] Properties to set
                         */
                        function MutateCampaignFeedsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignFeedsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsRequest
                         * @instance
                         */
                        MutateCampaignFeedsRequest.prototype.customerId = "";

                        /**
                         * MutateCampaignFeedsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.ICampaignFeedOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsRequest
                         * @instance
                         */
                        MutateCampaignFeedsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateCampaignFeedsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsRequest
                         * @instance
                         */
                        MutateCampaignFeedsRequest.prototype.partialFailure = false;

                        /**
                         * MutateCampaignFeedsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsRequest
                         * @instance
                         */
                        MutateCampaignFeedsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateCampaignFeedsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignFeedsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignFeedsRequest} MutateCampaignFeedsRequest instance
                         */
                        MutateCampaignFeedsRequest.create = function create(properties) {
                            return new MutateCampaignFeedsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignFeedsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignFeedsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignFeedsRequest} message MutateCampaignFeedsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignFeedsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.CampaignFeedOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignFeedsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignFeedsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignFeedsRequest} message MutateCampaignFeedsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignFeedsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignFeedsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignFeedsRequest} MutateCampaignFeedsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignFeedsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignFeedsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.CampaignFeedOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignFeedsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignFeedsRequest} MutateCampaignFeedsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignFeedsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignFeedsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignFeedsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.CampaignFeedOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignFeedsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignFeedsRequest} MutateCampaignFeedsRequest
                         */
                        MutateCampaignFeedsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignFeedsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignFeedsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignFeedsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCampaignFeedsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.CampaignFeedOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignFeedsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignFeedsRequest} message MutateCampaignFeedsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignFeedsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.CampaignFeedOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignFeedsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignFeedsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignFeedsRequest;
                    })();

                    services.CampaignFeedOperation = (function() {

                        /**
                         * Properties of a CampaignFeedOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICampaignFeedOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] CampaignFeedOperation updateMask
                         * @property {google.ads.googleads.v1.resources.ICampaignFeed|null} [create] CampaignFeedOperation create
                         * @property {google.ads.googleads.v1.resources.ICampaignFeed|null} [update] CampaignFeedOperation update
                         * @property {string|null} [remove] CampaignFeedOperation remove
                         */

                        /**
                         * Constructs a new CampaignFeedOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CampaignFeedOperation.
                         * @implements ICampaignFeedOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICampaignFeedOperation=} [properties] Properties to set
                         */
                        function CampaignFeedOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CampaignFeedOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.CampaignFeedOperation
                         * @instance
                         */
                        CampaignFeedOperation.prototype.updateMask = null;

                        /**
                         * CampaignFeedOperation create.
                         * @member {google.ads.googleads.v1.resources.ICampaignFeed|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.CampaignFeedOperation
                         * @instance
                         */
                        CampaignFeedOperation.prototype.create = null;

                        /**
                         * CampaignFeedOperation update.
                         * @member {google.ads.googleads.v1.resources.ICampaignFeed|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.CampaignFeedOperation
                         * @instance
                         */
                        CampaignFeedOperation.prototype.update = null;

                        /**
                         * CampaignFeedOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.CampaignFeedOperation
                         * @instance
                         */
                        CampaignFeedOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CampaignFeedOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.CampaignFeedOperation
                         * @instance
                         */
                        Object.defineProperty(CampaignFeedOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CampaignFeedOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CampaignFeedOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignFeedOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CampaignFeedOperation} CampaignFeedOperation instance
                         */
                        CampaignFeedOperation.create = function create(properties) {
                            return new CampaignFeedOperation(properties);
                        };

                        /**
                         * Encodes the specified CampaignFeedOperation message. Does not implicitly {@link google.ads.googleads.v1.services.CampaignFeedOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CampaignFeedOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignFeedOperation} message CampaignFeedOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignFeedOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.CampaignFeed.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.CampaignFeed.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignFeedOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CampaignFeedOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CampaignFeedOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignFeedOperation} message CampaignFeedOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignFeedOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignFeedOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CampaignFeedOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CampaignFeedOperation} CampaignFeedOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignFeedOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CampaignFeedOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.CampaignFeed.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.CampaignFeed.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignFeedOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CampaignFeedOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CampaignFeedOperation} CampaignFeedOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignFeedOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignFeedOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CampaignFeedOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignFeedOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CampaignFeed.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CampaignFeed.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a CampaignFeedOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CampaignFeedOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CampaignFeedOperation} CampaignFeedOperation
                         */
                        CampaignFeedOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CampaignFeedOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CampaignFeedOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignFeedOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignFeedOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.CampaignFeed.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignFeedOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.CampaignFeed.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a CampaignFeedOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CampaignFeedOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.CampaignFeedOperation} message CampaignFeedOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignFeedOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.CampaignFeed.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.CampaignFeed.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this CampaignFeedOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CampaignFeedOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignFeedOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CampaignFeedOperation;
                    })();

                    services.MutateCampaignFeedsResponse = (function() {

                        /**
                         * Properties of a MutateCampaignFeedsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignFeedsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateCampaignFeedsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateCampaignFeedResult>|null} [results] MutateCampaignFeedsResponse results
                         */

                        /**
                         * Constructs a new MutateCampaignFeedsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignFeedsResponse.
                         * @implements IMutateCampaignFeedsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignFeedsResponse=} [properties] Properties to set
                         */
                        function MutateCampaignFeedsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignFeedsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsResponse
                         * @instance
                         */
                        MutateCampaignFeedsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateCampaignFeedsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateCampaignFeedResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsResponse
                         * @instance
                         */
                        MutateCampaignFeedsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateCampaignFeedsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignFeedsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignFeedsResponse} MutateCampaignFeedsResponse instance
                         */
                        MutateCampaignFeedsResponse.create = function create(properties) {
                            return new MutateCampaignFeedsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignFeedsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignFeedsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignFeedsResponse} message MutateCampaignFeedsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignFeedsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateCampaignFeedResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignFeedsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignFeedsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignFeedsResponse} message MutateCampaignFeedsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignFeedsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignFeedsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignFeedsResponse} MutateCampaignFeedsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignFeedsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignFeedsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateCampaignFeedResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignFeedsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignFeedsResponse} MutateCampaignFeedsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignFeedsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignFeedsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignFeedsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateCampaignFeedResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignFeedsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignFeedsResponse} MutateCampaignFeedsResponse
                         */
                        MutateCampaignFeedsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignFeedsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignFeedsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignFeedsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignFeedsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCampaignFeedsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateCampaignFeedResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignFeedsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignFeedsResponse} message MutateCampaignFeedsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignFeedsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateCampaignFeedResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignFeedsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignFeedsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignFeedsResponse;
                    })();

                    services.MutateCampaignFeedResult = (function() {

                        /**
                         * Properties of a MutateCampaignFeedResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignFeedResult
                         * @property {string|null} [resourceName] MutateCampaignFeedResult resourceName
                         */

                        /**
                         * Constructs a new MutateCampaignFeedResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignFeedResult.
                         * @implements IMutateCampaignFeedResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignFeedResult=} [properties] Properties to set
                         */
                        function MutateCampaignFeedResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignFeedResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedResult
                         * @instance
                         */
                        MutateCampaignFeedResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateCampaignFeedResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignFeedResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignFeedResult} MutateCampaignFeedResult instance
                         */
                        MutateCampaignFeedResult.create = function create(properties) {
                            return new MutateCampaignFeedResult(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignFeedResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignFeedResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignFeedResult} message MutateCampaignFeedResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignFeedResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignFeedResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignFeedResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignFeedResult} message MutateCampaignFeedResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignFeedResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignFeedResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignFeedResult} MutateCampaignFeedResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignFeedResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignFeedResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignFeedResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignFeedResult} MutateCampaignFeedResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignFeedResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignFeedResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignFeedResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignFeedResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignFeedResult} MutateCampaignFeedResult
                         */
                        MutateCampaignFeedResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignFeedResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignFeedResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignFeedResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignFeedResult} message MutateCampaignFeedResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignFeedResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignFeedResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignFeedResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignFeedResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignFeedResult;
                    })();

                    services.CampaignLabelService = (function() {

                        /**
                         * Constructs a new CampaignLabelService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CampaignLabelService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CampaignLabelService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CampaignLabelService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CampaignLabelService;

                        /**
                         * Creates new CampaignLabelService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CampaignLabelService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CampaignLabelService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CampaignLabelService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CampaignLabelService#getCampaignLabel}.
                         * @memberof google.ads.googleads.v1.services.CampaignLabelService
                         * @typedef GetCampaignLabelCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.CampaignLabel} [response] CampaignLabel
                         */

                        /**
                         * Calls GetCampaignLabel.
                         * @function getCampaignLabel
                         * @memberof google.ads.googleads.v1.services.CampaignLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignLabelRequest} request GetCampaignLabelRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CampaignLabelService.GetCampaignLabelCallback} callback Node-style callback called with the error, if any, and CampaignLabel
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CampaignLabelService.prototype.getCampaignLabel = function getCampaignLabel(request, callback) {
                            return this.rpcCall(getCampaignLabel, $root.google.ads.googleads.v1.services.GetCampaignLabelRequest, $root.google.ads.googleads.v1.resources.CampaignLabel, request, callback);
                        }, "name", { value: "GetCampaignLabel" });

                        /**
                         * Calls GetCampaignLabel.
                         * @function getCampaignLabel
                         * @memberof google.ads.googleads.v1.services.CampaignLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignLabelRequest} request GetCampaignLabelRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.CampaignLabel>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CampaignLabelService#mutateCampaignLabels}.
                         * @memberof google.ads.googleads.v1.services.CampaignLabelService
                         * @typedef MutateCampaignLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateCampaignLabelsResponse} [response] MutateCampaignLabelsResponse
                         */

                        /**
                         * Calls MutateCampaignLabels.
                         * @function mutateCampaignLabels
                         * @memberof google.ads.googleads.v1.services.CampaignLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCampaignLabelsRequest} request MutateCampaignLabelsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CampaignLabelService.MutateCampaignLabelsCallback} callback Node-style callback called with the error, if any, and MutateCampaignLabelsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CampaignLabelService.prototype.mutateCampaignLabels = function mutateCampaignLabels(request, callback) {
                            return this.rpcCall(mutateCampaignLabels, $root.google.ads.googleads.v1.services.MutateCampaignLabelsRequest, $root.google.ads.googleads.v1.services.MutateCampaignLabelsResponse, request, callback);
                        }, "name", { value: "MutateCampaignLabels" });

                        /**
                         * Calls MutateCampaignLabels.
                         * @function mutateCampaignLabels
                         * @memberof google.ads.googleads.v1.services.CampaignLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCampaignLabelsRequest} request MutateCampaignLabelsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateCampaignLabelsResponse>} Promise
                         * @variation 2
                         */

                        return CampaignLabelService;
                    })();

                    services.GetCampaignLabelRequest = (function() {

                        /**
                         * Properties of a GetCampaignLabelRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCampaignLabelRequest
                         * @property {string|null} [resourceName] GetCampaignLabelRequest resourceName
                         */

                        /**
                         * Constructs a new GetCampaignLabelRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCampaignLabelRequest.
                         * @implements IGetCampaignLabelRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCampaignLabelRequest=} [properties] Properties to set
                         */
                        function GetCampaignLabelRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCampaignLabelRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCampaignLabelRequest
                         * @instance
                         */
                        GetCampaignLabelRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCampaignLabelRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCampaignLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignLabelRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCampaignLabelRequest} GetCampaignLabelRequest instance
                         */
                        GetCampaignLabelRequest.create = function create(properties) {
                            return new GetCampaignLabelRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCampaignLabelRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignLabelRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCampaignLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignLabelRequest} message GetCampaignLabelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignLabelRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCampaignLabelRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignLabelRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignLabelRequest} message GetCampaignLabelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignLabelRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCampaignLabelRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCampaignLabelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCampaignLabelRequest} GetCampaignLabelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignLabelRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCampaignLabelRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCampaignLabelRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignLabelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCampaignLabelRequest} GetCampaignLabelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignLabelRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCampaignLabelRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCampaignLabelRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCampaignLabelRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCampaignLabelRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignLabelRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCampaignLabelRequest} GetCampaignLabelRequest
                         */
                        GetCampaignLabelRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCampaignLabelRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCampaignLabelRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCampaignLabelRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCampaignLabelRequest} message GetCampaignLabelRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCampaignLabelRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCampaignLabelRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCampaignLabelRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCampaignLabelRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCampaignLabelRequest;
                    })();

                    services.MutateCampaignLabelsRequest = (function() {

                        /**
                         * Properties of a MutateCampaignLabelsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignLabelsRequest
                         * @property {string|null} [customerId] MutateCampaignLabelsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.ICampaignLabelOperation>|null} [operations] MutateCampaignLabelsRequest operations
                         * @property {boolean|null} [partialFailure] MutateCampaignLabelsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateCampaignLabelsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateCampaignLabelsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignLabelsRequest.
                         * @implements IMutateCampaignLabelsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignLabelsRequest=} [properties] Properties to set
                         */
                        function MutateCampaignLabelsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignLabelsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsRequest
                         * @instance
                         */
                        MutateCampaignLabelsRequest.prototype.customerId = "";

                        /**
                         * MutateCampaignLabelsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.ICampaignLabelOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsRequest
                         * @instance
                         */
                        MutateCampaignLabelsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateCampaignLabelsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsRequest
                         * @instance
                         */
                        MutateCampaignLabelsRequest.prototype.partialFailure = false;

                        /**
                         * MutateCampaignLabelsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsRequest
                         * @instance
                         */
                        MutateCampaignLabelsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateCampaignLabelsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignLabelsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignLabelsRequest} MutateCampaignLabelsRequest instance
                         */
                        MutateCampaignLabelsRequest.create = function create(properties) {
                            return new MutateCampaignLabelsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignLabelsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignLabelsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignLabelsRequest} message MutateCampaignLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignLabelsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.CampaignLabelOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignLabelsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignLabelsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignLabelsRequest} message MutateCampaignLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignLabelsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignLabelsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignLabelsRequest} MutateCampaignLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignLabelsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignLabelsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.CampaignLabelOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignLabelsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignLabelsRequest} MutateCampaignLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignLabelsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignLabelsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignLabelsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.CampaignLabelOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignLabelsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignLabelsRequest} MutateCampaignLabelsRequest
                         */
                        MutateCampaignLabelsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignLabelsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignLabelsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignLabelsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCampaignLabelsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.CampaignLabelOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignLabelsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignLabelsRequest} message MutateCampaignLabelsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignLabelsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.CampaignLabelOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignLabelsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignLabelsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignLabelsRequest;
                    })();

                    services.CampaignLabelOperation = (function() {

                        /**
                         * Properties of a CampaignLabelOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICampaignLabelOperation
                         * @property {google.ads.googleads.v1.resources.ICampaignLabel|null} [create] CampaignLabelOperation create
                         * @property {string|null} [remove] CampaignLabelOperation remove
                         */

                        /**
                         * Constructs a new CampaignLabelOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CampaignLabelOperation.
                         * @implements ICampaignLabelOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICampaignLabelOperation=} [properties] Properties to set
                         */
                        function CampaignLabelOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CampaignLabelOperation create.
                         * @member {google.ads.googleads.v1.resources.ICampaignLabel|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.CampaignLabelOperation
                         * @instance
                         */
                        CampaignLabelOperation.prototype.create = null;

                        /**
                         * CampaignLabelOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.CampaignLabelOperation
                         * @instance
                         */
                        CampaignLabelOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CampaignLabelOperation operation.
                         * @member {"create"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.CampaignLabelOperation
                         * @instance
                         */
                        Object.defineProperty(CampaignLabelOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CampaignLabelOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CampaignLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignLabelOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CampaignLabelOperation} CampaignLabelOperation instance
                         */
                        CampaignLabelOperation.create = function create(properties) {
                            return new CampaignLabelOperation(properties);
                        };

                        /**
                         * Encodes the specified CampaignLabelOperation message. Does not implicitly {@link google.ads.googleads.v1.services.CampaignLabelOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CampaignLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignLabelOperation} message CampaignLabelOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignLabelOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.CampaignLabel.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.remove);
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignLabelOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CampaignLabelOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CampaignLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignLabelOperation} message CampaignLabelOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignLabelOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignLabelOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CampaignLabelOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CampaignLabelOperation} CampaignLabelOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignLabelOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CampaignLabelOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.CampaignLabel.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignLabelOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CampaignLabelOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CampaignLabelOperation} CampaignLabelOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignLabelOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignLabelOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CampaignLabelOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignLabelOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CampaignLabel.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a CampaignLabelOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CampaignLabelOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CampaignLabelOperation} CampaignLabelOperation
                         */
                        CampaignLabelOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CampaignLabelOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CampaignLabelOperation();
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignLabelOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.CampaignLabel.fromObject(object.create);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a CampaignLabelOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CampaignLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.CampaignLabelOperation} message CampaignLabelOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignLabelOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.CampaignLabel.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            return object;
                        };

                        /**
                         * Converts this CampaignLabelOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CampaignLabelOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignLabelOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CampaignLabelOperation;
                    })();

                    services.MutateCampaignLabelsResponse = (function() {

                        /**
                         * Properties of a MutateCampaignLabelsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignLabelsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateCampaignLabelsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateCampaignLabelResult>|null} [results] MutateCampaignLabelsResponse results
                         */

                        /**
                         * Constructs a new MutateCampaignLabelsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignLabelsResponse.
                         * @implements IMutateCampaignLabelsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignLabelsResponse=} [properties] Properties to set
                         */
                        function MutateCampaignLabelsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignLabelsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsResponse
                         * @instance
                         */
                        MutateCampaignLabelsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateCampaignLabelsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateCampaignLabelResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsResponse
                         * @instance
                         */
                        MutateCampaignLabelsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateCampaignLabelsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignLabelsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignLabelsResponse} MutateCampaignLabelsResponse instance
                         */
                        MutateCampaignLabelsResponse.create = function create(properties) {
                            return new MutateCampaignLabelsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignLabelsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignLabelsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignLabelsResponse} message MutateCampaignLabelsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignLabelsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateCampaignLabelResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignLabelsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignLabelsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignLabelsResponse} message MutateCampaignLabelsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignLabelsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignLabelsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignLabelsResponse} MutateCampaignLabelsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignLabelsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignLabelsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateCampaignLabelResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignLabelsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignLabelsResponse} MutateCampaignLabelsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignLabelsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignLabelsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignLabelsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateCampaignLabelResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignLabelsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignLabelsResponse} MutateCampaignLabelsResponse
                         */
                        MutateCampaignLabelsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignLabelsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignLabelsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignLabelsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignLabelsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCampaignLabelsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateCampaignLabelResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignLabelsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignLabelsResponse} message MutateCampaignLabelsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignLabelsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateCampaignLabelResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignLabelsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignLabelsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignLabelsResponse;
                    })();

                    services.MutateCampaignLabelResult = (function() {

                        /**
                         * Properties of a MutateCampaignLabelResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignLabelResult
                         * @property {string|null} [resourceName] MutateCampaignLabelResult resourceName
                         */

                        /**
                         * Constructs a new MutateCampaignLabelResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignLabelResult.
                         * @implements IMutateCampaignLabelResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignLabelResult=} [properties] Properties to set
                         */
                        function MutateCampaignLabelResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignLabelResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelResult
                         * @instance
                         */
                        MutateCampaignLabelResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateCampaignLabelResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignLabelResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignLabelResult} MutateCampaignLabelResult instance
                         */
                        MutateCampaignLabelResult.create = function create(properties) {
                            return new MutateCampaignLabelResult(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignLabelResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignLabelResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignLabelResult} message MutateCampaignLabelResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignLabelResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignLabelResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignLabelResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignLabelResult} message MutateCampaignLabelResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignLabelResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignLabelResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignLabelResult} MutateCampaignLabelResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignLabelResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignLabelResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignLabelResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignLabelResult} MutateCampaignLabelResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignLabelResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignLabelResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignLabelResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignLabelResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignLabelResult} MutateCampaignLabelResult
                         */
                        MutateCampaignLabelResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignLabelResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignLabelResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignLabelResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignLabelResult} message MutateCampaignLabelResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignLabelResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignLabelResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignLabelResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignLabelResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignLabelResult;
                    })();

                    services.CampaignService = (function() {

                        /**
                         * Constructs a new CampaignService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CampaignService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CampaignService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CampaignService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CampaignService;

                        /**
                         * Creates new CampaignService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CampaignService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CampaignService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CampaignService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CampaignService#getCampaign}.
                         * @memberof google.ads.googleads.v1.services.CampaignService
                         * @typedef GetCampaignCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.Campaign} [response] Campaign
                         */

                        /**
                         * Calls GetCampaign.
                         * @function getCampaign
                         * @memberof google.ads.googleads.v1.services.CampaignService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignRequest} request GetCampaignRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CampaignService.GetCampaignCallback} callback Node-style callback called with the error, if any, and Campaign
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CampaignService.prototype.getCampaign = function getCampaign(request, callback) {
                            return this.rpcCall(getCampaign, $root.google.ads.googleads.v1.services.GetCampaignRequest, $root.google.ads.googleads.v1.resources.Campaign, request, callback);
                        }, "name", { value: "GetCampaign" });

                        /**
                         * Calls GetCampaign.
                         * @function getCampaign
                         * @memberof google.ads.googleads.v1.services.CampaignService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignRequest} request GetCampaignRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.Campaign>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CampaignService#mutateCampaigns}.
                         * @memberof google.ads.googleads.v1.services.CampaignService
                         * @typedef MutateCampaignsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateCampaignsResponse} [response] MutateCampaignsResponse
                         */

                        /**
                         * Calls MutateCampaigns.
                         * @function mutateCampaigns
                         * @memberof google.ads.googleads.v1.services.CampaignService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCampaignsRequest} request MutateCampaignsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CampaignService.MutateCampaignsCallback} callback Node-style callback called with the error, if any, and MutateCampaignsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CampaignService.prototype.mutateCampaigns = function mutateCampaigns(request, callback) {
                            return this.rpcCall(mutateCampaigns, $root.google.ads.googleads.v1.services.MutateCampaignsRequest, $root.google.ads.googleads.v1.services.MutateCampaignsResponse, request, callback);
                        }, "name", { value: "MutateCampaigns" });

                        /**
                         * Calls MutateCampaigns.
                         * @function mutateCampaigns
                         * @memberof google.ads.googleads.v1.services.CampaignService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCampaignsRequest} request MutateCampaignsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateCampaignsResponse>} Promise
                         * @variation 2
                         */

                        return CampaignService;
                    })();

                    services.GetCampaignRequest = (function() {

                        /**
                         * Properties of a GetCampaignRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCampaignRequest
                         * @property {string|null} [resourceName] GetCampaignRequest resourceName
                         */

                        /**
                         * Constructs a new GetCampaignRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCampaignRequest.
                         * @implements IGetCampaignRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCampaignRequest=} [properties] Properties to set
                         */
                        function GetCampaignRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCampaignRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCampaignRequest
                         * @instance
                         */
                        GetCampaignRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCampaignRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCampaignRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCampaignRequest} GetCampaignRequest instance
                         */
                        GetCampaignRequest.create = function create(properties) {
                            return new GetCampaignRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCampaignRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCampaignRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignRequest} message GetCampaignRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCampaignRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignRequest} message GetCampaignRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCampaignRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCampaignRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCampaignRequest} GetCampaignRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCampaignRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCampaignRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCampaignRequest} GetCampaignRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCampaignRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCampaignRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCampaignRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCampaignRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCampaignRequest} GetCampaignRequest
                         */
                        GetCampaignRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCampaignRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCampaignRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCampaignRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCampaignRequest} message GetCampaignRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCampaignRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCampaignRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCampaignRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCampaignRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCampaignRequest;
                    })();

                    services.MutateCampaignsRequest = (function() {

                        /**
                         * Properties of a MutateCampaignsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignsRequest
                         * @property {string|null} [customerId] MutateCampaignsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.ICampaignOperation>|null} [operations] MutateCampaignsRequest operations
                         * @property {boolean|null} [partialFailure] MutateCampaignsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateCampaignsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateCampaignsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignsRequest.
                         * @implements IMutateCampaignsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignsRequest=} [properties] Properties to set
                         */
                        function MutateCampaignsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsRequest
                         * @instance
                         */
                        MutateCampaignsRequest.prototype.customerId = "";

                        /**
                         * MutateCampaignsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.ICampaignOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsRequest
                         * @instance
                         */
                        MutateCampaignsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateCampaignsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsRequest
                         * @instance
                         */
                        MutateCampaignsRequest.prototype.partialFailure = false;

                        /**
                         * MutateCampaignsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsRequest
                         * @instance
                         */
                        MutateCampaignsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateCampaignsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignsRequest} MutateCampaignsRequest instance
                         */
                        MutateCampaignsRequest.create = function create(properties) {
                            return new MutateCampaignsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignsRequest} message MutateCampaignsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.CampaignOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignsRequest} message MutateCampaignsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignsRequest} MutateCampaignsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.CampaignOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignsRequest} MutateCampaignsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.CampaignOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignsRequest} MutateCampaignsRequest
                         */
                        MutateCampaignsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCampaignsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.CampaignOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignsRequest} message MutateCampaignsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.CampaignOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignsRequest;
                    })();

                    services.CampaignOperation = (function() {

                        /**
                         * Properties of a CampaignOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICampaignOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] CampaignOperation updateMask
                         * @property {google.ads.googleads.v1.resources.ICampaign|null} [create] CampaignOperation create
                         * @property {google.ads.googleads.v1.resources.ICampaign|null} [update] CampaignOperation update
                         * @property {string|null} [remove] CampaignOperation remove
                         */

                        /**
                         * Constructs a new CampaignOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CampaignOperation.
                         * @implements ICampaignOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICampaignOperation=} [properties] Properties to set
                         */
                        function CampaignOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CampaignOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.CampaignOperation
                         * @instance
                         */
                        CampaignOperation.prototype.updateMask = null;

                        /**
                         * CampaignOperation create.
                         * @member {google.ads.googleads.v1.resources.ICampaign|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.CampaignOperation
                         * @instance
                         */
                        CampaignOperation.prototype.create = null;

                        /**
                         * CampaignOperation update.
                         * @member {google.ads.googleads.v1.resources.ICampaign|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.CampaignOperation
                         * @instance
                         */
                        CampaignOperation.prototype.update = null;

                        /**
                         * CampaignOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.CampaignOperation
                         * @instance
                         */
                        CampaignOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CampaignOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.CampaignOperation
                         * @instance
                         */
                        Object.defineProperty(CampaignOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CampaignOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CampaignOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CampaignOperation} CampaignOperation instance
                         */
                        CampaignOperation.create = function create(properties) {
                            return new CampaignOperation(properties);
                        };

                        /**
                         * Encodes the specified CampaignOperation message. Does not implicitly {@link google.ads.googleads.v1.services.CampaignOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CampaignOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignOperation} message CampaignOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.Campaign.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.Campaign.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CampaignOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CampaignOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignOperation} message CampaignOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CampaignOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CampaignOperation} CampaignOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CampaignOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.Campaign.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.Campaign.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CampaignOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CampaignOperation} CampaignOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CampaignOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Campaign.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Campaign.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a CampaignOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CampaignOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CampaignOperation} CampaignOperation
                         */
                        CampaignOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CampaignOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CampaignOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.Campaign.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.Campaign.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a CampaignOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CampaignOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.CampaignOperation} message CampaignOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.Campaign.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.Campaign.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this CampaignOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CampaignOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CampaignOperation;
                    })();

                    services.MutateCampaignsResponse = (function() {

                        /**
                         * Properties of a MutateCampaignsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateCampaignsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateCampaignResult>|null} [results] MutateCampaignsResponse results
                         */

                        /**
                         * Constructs a new MutateCampaignsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignsResponse.
                         * @implements IMutateCampaignsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignsResponse=} [properties] Properties to set
                         */
                        function MutateCampaignsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsResponse
                         * @instance
                         */
                        MutateCampaignsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateCampaignsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateCampaignResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsResponse
                         * @instance
                         */
                        MutateCampaignsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateCampaignsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignsResponse} MutateCampaignsResponse instance
                         */
                        MutateCampaignsResponse.create = function create(properties) {
                            return new MutateCampaignsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignsResponse} message MutateCampaignsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateCampaignResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignsResponse} message MutateCampaignsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignsResponse} MutateCampaignsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateCampaignResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignsResponse} MutateCampaignsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateCampaignResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignsResponse} MutateCampaignsResponse
                         */
                        MutateCampaignsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCampaignsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateCampaignResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignsResponse} message MutateCampaignsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateCampaignResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignsResponse;
                    })();

                    services.MutateCampaignResult = (function() {

                        /**
                         * Properties of a MutateCampaignResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignResult
                         * @property {string|null} [resourceName] MutateCampaignResult resourceName
                         */

                        /**
                         * Constructs a new MutateCampaignResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignResult.
                         * @implements IMutateCampaignResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignResult=} [properties] Properties to set
                         */
                        function MutateCampaignResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateCampaignResult
                         * @instance
                         */
                        MutateCampaignResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateCampaignResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignResult} MutateCampaignResult instance
                         */
                        MutateCampaignResult.create = function create(properties) {
                            return new MutateCampaignResult(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignResult} message MutateCampaignResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignResult} message MutateCampaignResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignResult} MutateCampaignResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignResult} MutateCampaignResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignResult} MutateCampaignResult
                         */
                        MutateCampaignResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignResult} message MutateCampaignResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignResult;
                    })();

                    services.CampaignSharedSetService = (function() {

                        /**
                         * Constructs a new CampaignSharedSetService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CampaignSharedSetService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CampaignSharedSetService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CampaignSharedSetService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CampaignSharedSetService;

                        /**
                         * Creates new CampaignSharedSetService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CampaignSharedSetService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CampaignSharedSetService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CampaignSharedSetService#getCampaignSharedSet}.
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetService
                         * @typedef GetCampaignSharedSetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.CampaignSharedSet} [response] CampaignSharedSet
                         */

                        /**
                         * Calls GetCampaignSharedSet.
                         * @function getCampaignSharedSet
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignSharedSetRequest} request GetCampaignSharedSetRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CampaignSharedSetService.GetCampaignSharedSetCallback} callback Node-style callback called with the error, if any, and CampaignSharedSet
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CampaignSharedSetService.prototype.getCampaignSharedSet = function getCampaignSharedSet(request, callback) {
                            return this.rpcCall(getCampaignSharedSet, $root.google.ads.googleads.v1.services.GetCampaignSharedSetRequest, $root.google.ads.googleads.v1.resources.CampaignSharedSet, request, callback);
                        }, "name", { value: "GetCampaignSharedSet" });

                        /**
                         * Calls GetCampaignSharedSet.
                         * @function getCampaignSharedSet
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCampaignSharedSetRequest} request GetCampaignSharedSetRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.CampaignSharedSet>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CampaignSharedSetService#mutateCampaignSharedSets}.
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetService
                         * @typedef MutateCampaignSharedSetsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse} [response] MutateCampaignSharedSetsResponse
                         */

                        /**
                         * Calls MutateCampaignSharedSets.
                         * @function mutateCampaignSharedSets
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCampaignSharedSetsRequest} request MutateCampaignSharedSetsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CampaignSharedSetService.MutateCampaignSharedSetsCallback} callback Node-style callback called with the error, if any, and MutateCampaignSharedSetsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CampaignSharedSetService.prototype.mutateCampaignSharedSets = function mutateCampaignSharedSets(request, callback) {
                            return this.rpcCall(mutateCampaignSharedSets, $root.google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest, $root.google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse, request, callback);
                        }, "name", { value: "MutateCampaignSharedSets" });

                        /**
                         * Calls MutateCampaignSharedSets.
                         * @function mutateCampaignSharedSets
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCampaignSharedSetsRequest} request MutateCampaignSharedSetsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse>} Promise
                         * @variation 2
                         */

                        return CampaignSharedSetService;
                    })();

                    services.GetCampaignSharedSetRequest = (function() {

                        /**
                         * Properties of a GetCampaignSharedSetRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCampaignSharedSetRequest
                         * @property {string|null} [resourceName] GetCampaignSharedSetRequest resourceName
                         */

                        /**
                         * Constructs a new GetCampaignSharedSetRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCampaignSharedSetRequest.
                         * @implements IGetCampaignSharedSetRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCampaignSharedSetRequest=} [properties] Properties to set
                         */
                        function GetCampaignSharedSetRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCampaignSharedSetRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCampaignSharedSetRequest
                         * @instance
                         */
                        GetCampaignSharedSetRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCampaignSharedSetRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCampaignSharedSetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignSharedSetRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCampaignSharedSetRequest} GetCampaignSharedSetRequest instance
                         */
                        GetCampaignSharedSetRequest.create = function create(properties) {
                            return new GetCampaignSharedSetRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCampaignSharedSetRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignSharedSetRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCampaignSharedSetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignSharedSetRequest} message GetCampaignSharedSetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignSharedSetRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCampaignSharedSetRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCampaignSharedSetRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignSharedSetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCampaignSharedSetRequest} message GetCampaignSharedSetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCampaignSharedSetRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCampaignSharedSetRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCampaignSharedSetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCampaignSharedSetRequest} GetCampaignSharedSetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignSharedSetRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCampaignSharedSetRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCampaignSharedSetRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCampaignSharedSetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCampaignSharedSetRequest} GetCampaignSharedSetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCampaignSharedSetRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCampaignSharedSetRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCampaignSharedSetRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCampaignSharedSetRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCampaignSharedSetRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignSharedSetRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCampaignSharedSetRequest} GetCampaignSharedSetRequest
                         */
                        GetCampaignSharedSetRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCampaignSharedSetRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCampaignSharedSetRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCampaignSharedSetRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCampaignSharedSetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCampaignSharedSetRequest} message GetCampaignSharedSetRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCampaignSharedSetRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCampaignSharedSetRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCampaignSharedSetRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCampaignSharedSetRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCampaignSharedSetRequest;
                    })();

                    services.MutateCampaignSharedSetsRequest = (function() {

                        /**
                         * Properties of a MutateCampaignSharedSetsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignSharedSetsRequest
                         * @property {string|null} [customerId] MutateCampaignSharedSetsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.ICampaignSharedSetOperation>|null} [operations] MutateCampaignSharedSetsRequest operations
                         * @property {boolean|null} [partialFailure] MutateCampaignSharedSetsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateCampaignSharedSetsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateCampaignSharedSetsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignSharedSetsRequest.
                         * @implements IMutateCampaignSharedSetsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignSharedSetsRequest=} [properties] Properties to set
                         */
                        function MutateCampaignSharedSetsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignSharedSetsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest
                         * @instance
                         */
                        MutateCampaignSharedSetsRequest.prototype.customerId = "";

                        /**
                         * MutateCampaignSharedSetsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.ICampaignSharedSetOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest
                         * @instance
                         */
                        MutateCampaignSharedSetsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateCampaignSharedSetsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest
                         * @instance
                         */
                        MutateCampaignSharedSetsRequest.prototype.partialFailure = false;

                        /**
                         * MutateCampaignSharedSetsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest
                         * @instance
                         */
                        MutateCampaignSharedSetsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateCampaignSharedSetsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignSharedSetsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest} MutateCampaignSharedSetsRequest instance
                         */
                        MutateCampaignSharedSetsRequest.create = function create(properties) {
                            return new MutateCampaignSharedSetsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignSharedSetsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignSharedSetsRequest} message MutateCampaignSharedSetsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignSharedSetsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.CampaignSharedSetOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignSharedSetsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignSharedSetsRequest} message MutateCampaignSharedSetsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignSharedSetsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignSharedSetsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest} MutateCampaignSharedSetsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignSharedSetsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.CampaignSharedSetOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignSharedSetsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest} MutateCampaignSharedSetsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignSharedSetsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignSharedSetsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignSharedSetsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.CampaignSharedSetOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignSharedSetsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest} MutateCampaignSharedSetsRequest
                         */
                        MutateCampaignSharedSetsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.CampaignSharedSetOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignSharedSetsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest} message MutateCampaignSharedSetsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignSharedSetsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.CampaignSharedSetOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignSharedSetsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignSharedSetsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignSharedSetsRequest;
                    })();

                    services.CampaignSharedSetOperation = (function() {

                        /**
                         * Properties of a CampaignSharedSetOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICampaignSharedSetOperation
                         * @property {google.ads.googleads.v1.resources.ICampaignSharedSet|null} [create] CampaignSharedSetOperation create
                         * @property {string|null} [remove] CampaignSharedSetOperation remove
                         */

                        /**
                         * Constructs a new CampaignSharedSetOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CampaignSharedSetOperation.
                         * @implements ICampaignSharedSetOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICampaignSharedSetOperation=} [properties] Properties to set
                         */
                        function CampaignSharedSetOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CampaignSharedSetOperation create.
                         * @member {google.ads.googleads.v1.resources.ICampaignSharedSet|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetOperation
                         * @instance
                         */
                        CampaignSharedSetOperation.prototype.create = null;

                        /**
                         * CampaignSharedSetOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetOperation
                         * @instance
                         */
                        CampaignSharedSetOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CampaignSharedSetOperation operation.
                         * @member {"create"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetOperation
                         * @instance
                         */
                        Object.defineProperty(CampaignSharedSetOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CampaignSharedSetOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignSharedSetOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CampaignSharedSetOperation} CampaignSharedSetOperation instance
                         */
                        CampaignSharedSetOperation.create = function create(properties) {
                            return new CampaignSharedSetOperation(properties);
                        };

                        /**
                         * Encodes the specified CampaignSharedSetOperation message. Does not implicitly {@link google.ads.googleads.v1.services.CampaignSharedSetOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignSharedSetOperation} message CampaignSharedSetOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignSharedSetOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.CampaignSharedSet.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            return writer;
                        };

                        /**
                         * Encodes the specified CampaignSharedSetOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CampaignSharedSetOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICampaignSharedSetOperation} message CampaignSharedSetOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CampaignSharedSetOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CampaignSharedSetOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CampaignSharedSetOperation} CampaignSharedSetOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignSharedSetOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CampaignSharedSetOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.CampaignSharedSet.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CampaignSharedSetOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CampaignSharedSetOperation} CampaignSharedSetOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CampaignSharedSetOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CampaignSharedSetOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CampaignSharedSetOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CampaignSharedSet.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a CampaignSharedSetOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CampaignSharedSetOperation} CampaignSharedSetOperation
                         */
                        CampaignSharedSetOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CampaignSharedSetOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CampaignSharedSetOperation();
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CampaignSharedSetOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.CampaignSharedSet.fromObject(object.create);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a CampaignSharedSetOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.CampaignSharedSetOperation} message CampaignSharedSetOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CampaignSharedSetOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.CampaignSharedSet.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            return object;
                        };

                        /**
                         * Converts this CampaignSharedSetOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CampaignSharedSetOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CampaignSharedSetOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CampaignSharedSetOperation;
                    })();

                    services.MutateCampaignSharedSetsResponse = (function() {

                        /**
                         * Properties of a MutateCampaignSharedSetsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignSharedSetsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateCampaignSharedSetsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateCampaignSharedSetResult>|null} [results] MutateCampaignSharedSetsResponse results
                         */

                        /**
                         * Constructs a new MutateCampaignSharedSetsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignSharedSetsResponse.
                         * @implements IMutateCampaignSharedSetsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignSharedSetsResponse=} [properties] Properties to set
                         */
                        function MutateCampaignSharedSetsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignSharedSetsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse
                         * @instance
                         */
                        MutateCampaignSharedSetsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateCampaignSharedSetsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateCampaignSharedSetResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse
                         * @instance
                         */
                        MutateCampaignSharedSetsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateCampaignSharedSetsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignSharedSetsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse} MutateCampaignSharedSetsResponse instance
                         */
                        MutateCampaignSharedSetsResponse.create = function create(properties) {
                            return new MutateCampaignSharedSetsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignSharedSetsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignSharedSetsResponse} message MutateCampaignSharedSetsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignSharedSetsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateCampaignSharedSetResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignSharedSetsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignSharedSetsResponse} message MutateCampaignSharedSetsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignSharedSetsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignSharedSetsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse} MutateCampaignSharedSetsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignSharedSetsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateCampaignSharedSetResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignSharedSetsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse} MutateCampaignSharedSetsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignSharedSetsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignSharedSetsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignSharedSetsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateCampaignSharedSetResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignSharedSetsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse} MutateCampaignSharedSetsResponse
                         */
                        MutateCampaignSharedSetsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateCampaignSharedSetResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignSharedSetsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse} message MutateCampaignSharedSetsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignSharedSetsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateCampaignSharedSetResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignSharedSetsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignSharedSetsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignSharedSetsResponse;
                    })();

                    services.MutateCampaignSharedSetResult = (function() {

                        /**
                         * Properties of a MutateCampaignSharedSetResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCampaignSharedSetResult
                         * @property {string|null} [resourceName] MutateCampaignSharedSetResult resourceName
                         */

                        /**
                         * Constructs a new MutateCampaignSharedSetResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCampaignSharedSetResult.
                         * @implements IMutateCampaignSharedSetResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCampaignSharedSetResult=} [properties] Properties to set
                         */
                        function MutateCampaignSharedSetResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCampaignSharedSetResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetResult
                         * @instance
                         */
                        MutateCampaignSharedSetResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateCampaignSharedSetResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignSharedSetResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCampaignSharedSetResult} MutateCampaignSharedSetResult instance
                         */
                        MutateCampaignSharedSetResult.create = function create(properties) {
                            return new MutateCampaignSharedSetResult(properties);
                        };

                        /**
                         * Encodes the specified MutateCampaignSharedSetResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignSharedSetResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignSharedSetResult} message MutateCampaignSharedSetResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignSharedSetResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCampaignSharedSetResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCampaignSharedSetResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCampaignSharedSetResult} message MutateCampaignSharedSetResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCampaignSharedSetResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCampaignSharedSetResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCampaignSharedSetResult} MutateCampaignSharedSetResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignSharedSetResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCampaignSharedSetResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCampaignSharedSetResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCampaignSharedSetResult} MutateCampaignSharedSetResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCampaignSharedSetResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCampaignSharedSetResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCampaignSharedSetResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCampaignSharedSetResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCampaignSharedSetResult} MutateCampaignSharedSetResult
                         */
                        MutateCampaignSharedSetResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCampaignSharedSetResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCampaignSharedSetResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCampaignSharedSetResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCampaignSharedSetResult} message MutateCampaignSharedSetResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCampaignSharedSetResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateCampaignSharedSetResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCampaignSharedSetResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCampaignSharedSetResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCampaignSharedSetResult;
                    })();

                    services.CarrierConstantService = (function() {

                        /**
                         * Constructs a new CarrierConstantService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CarrierConstantService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CarrierConstantService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CarrierConstantService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CarrierConstantService;

                        /**
                         * Creates new CarrierConstantService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CarrierConstantService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CarrierConstantService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CarrierConstantService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CarrierConstantService#getCarrierConstant}.
                         * @memberof google.ads.googleads.v1.services.CarrierConstantService
                         * @typedef GetCarrierConstantCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.CarrierConstant} [response] CarrierConstant
                         */

                        /**
                         * Calls GetCarrierConstant.
                         * @function getCarrierConstant
                         * @memberof google.ads.googleads.v1.services.CarrierConstantService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCarrierConstantRequest} request GetCarrierConstantRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CarrierConstantService.GetCarrierConstantCallback} callback Node-style callback called with the error, if any, and CarrierConstant
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CarrierConstantService.prototype.getCarrierConstant = function getCarrierConstant(request, callback) {
                            return this.rpcCall(getCarrierConstant, $root.google.ads.googleads.v1.services.GetCarrierConstantRequest, $root.google.ads.googleads.v1.resources.CarrierConstant, request, callback);
                        }, "name", { value: "GetCarrierConstant" });

                        /**
                         * Calls GetCarrierConstant.
                         * @function getCarrierConstant
                         * @memberof google.ads.googleads.v1.services.CarrierConstantService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCarrierConstantRequest} request GetCarrierConstantRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.CarrierConstant>} Promise
                         * @variation 2
                         */

                        return CarrierConstantService;
                    })();

                    services.GetCarrierConstantRequest = (function() {

                        /**
                         * Properties of a GetCarrierConstantRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCarrierConstantRequest
                         * @property {string|null} [resourceName] GetCarrierConstantRequest resourceName
                         */

                        /**
                         * Constructs a new GetCarrierConstantRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCarrierConstantRequest.
                         * @implements IGetCarrierConstantRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCarrierConstantRequest=} [properties] Properties to set
                         */
                        function GetCarrierConstantRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCarrierConstantRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCarrierConstantRequest
                         * @instance
                         */
                        GetCarrierConstantRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCarrierConstantRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCarrierConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCarrierConstantRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCarrierConstantRequest} GetCarrierConstantRequest instance
                         */
                        GetCarrierConstantRequest.create = function create(properties) {
                            return new GetCarrierConstantRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCarrierConstantRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCarrierConstantRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCarrierConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCarrierConstantRequest} message GetCarrierConstantRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCarrierConstantRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCarrierConstantRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCarrierConstantRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCarrierConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCarrierConstantRequest} message GetCarrierConstantRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCarrierConstantRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCarrierConstantRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCarrierConstantRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCarrierConstantRequest} GetCarrierConstantRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCarrierConstantRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCarrierConstantRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCarrierConstantRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCarrierConstantRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCarrierConstantRequest} GetCarrierConstantRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCarrierConstantRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCarrierConstantRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCarrierConstantRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCarrierConstantRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCarrierConstantRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCarrierConstantRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCarrierConstantRequest} GetCarrierConstantRequest
                         */
                        GetCarrierConstantRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCarrierConstantRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCarrierConstantRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCarrierConstantRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCarrierConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCarrierConstantRequest} message GetCarrierConstantRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCarrierConstantRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCarrierConstantRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCarrierConstantRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCarrierConstantRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCarrierConstantRequest;
                    })();

                    services.ChangeStatusService = (function() {

                        /**
                         * Constructs a new ChangeStatusService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ChangeStatusService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function ChangeStatusService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (ChangeStatusService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = ChangeStatusService;

                        /**
                         * Creates new ChangeStatusService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ChangeStatusService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {ChangeStatusService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        ChangeStatusService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.ChangeStatusService#getChangeStatus}.
                         * @memberof google.ads.googleads.v1.services.ChangeStatusService
                         * @typedef GetChangeStatusCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.ChangeStatus} [response] ChangeStatus
                         */

                        /**
                         * Calls GetChangeStatus.
                         * @function getChangeStatus
                         * @memberof google.ads.googleads.v1.services.ChangeStatusService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetChangeStatusRequest} request GetChangeStatusRequest message or plain object
                         * @param {google.ads.googleads.v1.services.ChangeStatusService.GetChangeStatusCallback} callback Node-style callback called with the error, if any, and ChangeStatus
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ChangeStatusService.prototype.getChangeStatus = function getChangeStatus(request, callback) {
                            return this.rpcCall(getChangeStatus, $root.google.ads.googleads.v1.services.GetChangeStatusRequest, $root.google.ads.googleads.v1.resources.ChangeStatus, request, callback);
                        }, "name", { value: "GetChangeStatus" });

                        /**
                         * Calls GetChangeStatus.
                         * @function getChangeStatus
                         * @memberof google.ads.googleads.v1.services.ChangeStatusService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetChangeStatusRequest} request GetChangeStatusRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.ChangeStatus>} Promise
                         * @variation 2
                         */

                        return ChangeStatusService;
                    })();

                    services.GetChangeStatusRequest = (function() {

                        /**
                         * Properties of a GetChangeStatusRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetChangeStatusRequest
                         * @property {string|null} [resourceName] GetChangeStatusRequest resourceName
                         */

                        /**
                         * Constructs a new GetChangeStatusRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetChangeStatusRequest.
                         * @implements IGetChangeStatusRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetChangeStatusRequest=} [properties] Properties to set
                         */
                        function GetChangeStatusRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetChangeStatusRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetChangeStatusRequest
                         * @instance
                         */
                        GetChangeStatusRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetChangeStatusRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetChangeStatusRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetChangeStatusRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetChangeStatusRequest} GetChangeStatusRequest instance
                         */
                        GetChangeStatusRequest.create = function create(properties) {
                            return new GetChangeStatusRequest(properties);
                        };

                        /**
                         * Encodes the specified GetChangeStatusRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetChangeStatusRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetChangeStatusRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetChangeStatusRequest} message GetChangeStatusRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetChangeStatusRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetChangeStatusRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetChangeStatusRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetChangeStatusRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetChangeStatusRequest} message GetChangeStatusRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetChangeStatusRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetChangeStatusRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetChangeStatusRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetChangeStatusRequest} GetChangeStatusRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetChangeStatusRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetChangeStatusRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetChangeStatusRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetChangeStatusRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetChangeStatusRequest} GetChangeStatusRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetChangeStatusRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetChangeStatusRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetChangeStatusRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetChangeStatusRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetChangeStatusRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetChangeStatusRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetChangeStatusRequest} GetChangeStatusRequest
                         */
                        GetChangeStatusRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetChangeStatusRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetChangeStatusRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetChangeStatusRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetChangeStatusRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetChangeStatusRequest} message GetChangeStatusRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetChangeStatusRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetChangeStatusRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetChangeStatusRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetChangeStatusRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetChangeStatusRequest;
                    })();

                    services.ClickViewService = (function() {

                        /**
                         * Constructs a new ClickViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ClickViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function ClickViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (ClickViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = ClickViewService;

                        /**
                         * Creates new ClickViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ClickViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {ClickViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        ClickViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.ClickViewService#getClickView}.
                         * @memberof google.ads.googleads.v1.services.ClickViewService
                         * @typedef GetClickViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.ClickView} [response] ClickView
                         */

                        /**
                         * Calls GetClickView.
                         * @function getClickView
                         * @memberof google.ads.googleads.v1.services.ClickViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetClickViewRequest} request GetClickViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.ClickViewService.GetClickViewCallback} callback Node-style callback called with the error, if any, and ClickView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ClickViewService.prototype.getClickView = function getClickView(request, callback) {
                            return this.rpcCall(getClickView, $root.google.ads.googleads.v1.services.GetClickViewRequest, $root.google.ads.googleads.v1.resources.ClickView, request, callback);
                        }, "name", { value: "GetClickView" });

                        /**
                         * Calls GetClickView.
                         * @function getClickView
                         * @memberof google.ads.googleads.v1.services.ClickViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetClickViewRequest} request GetClickViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.ClickView>} Promise
                         * @variation 2
                         */

                        return ClickViewService;
                    })();

                    services.GetClickViewRequest = (function() {

                        /**
                         * Properties of a GetClickViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetClickViewRequest
                         * @property {string|null} [resourceName] GetClickViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetClickViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetClickViewRequest.
                         * @implements IGetClickViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetClickViewRequest=} [properties] Properties to set
                         */
                        function GetClickViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetClickViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetClickViewRequest
                         * @instance
                         */
                        GetClickViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetClickViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetClickViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetClickViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetClickViewRequest} GetClickViewRequest instance
                         */
                        GetClickViewRequest.create = function create(properties) {
                            return new GetClickViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetClickViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetClickViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetClickViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetClickViewRequest} message GetClickViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetClickViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetClickViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetClickViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetClickViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetClickViewRequest} message GetClickViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetClickViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetClickViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetClickViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetClickViewRequest} GetClickViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetClickViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetClickViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetClickViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetClickViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetClickViewRequest} GetClickViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetClickViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetClickViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetClickViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetClickViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetClickViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetClickViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetClickViewRequest} GetClickViewRequest
                         */
                        GetClickViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetClickViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetClickViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetClickViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetClickViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetClickViewRequest} message GetClickViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetClickViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetClickViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetClickViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetClickViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetClickViewRequest;
                    })();

                    services.ConversionActionService = (function() {

                        /**
                         * Constructs a new ConversionActionService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ConversionActionService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function ConversionActionService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (ConversionActionService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = ConversionActionService;

                        /**
                         * Creates new ConversionActionService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ConversionActionService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {ConversionActionService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        ConversionActionService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.ConversionActionService#getConversionAction}.
                         * @memberof google.ads.googleads.v1.services.ConversionActionService
                         * @typedef GetConversionActionCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.ConversionAction} [response] ConversionAction
                         */

                        /**
                         * Calls GetConversionAction.
                         * @function getConversionAction
                         * @memberof google.ads.googleads.v1.services.ConversionActionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetConversionActionRequest} request GetConversionActionRequest message or plain object
                         * @param {google.ads.googleads.v1.services.ConversionActionService.GetConversionActionCallback} callback Node-style callback called with the error, if any, and ConversionAction
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ConversionActionService.prototype.getConversionAction = function getConversionAction(request, callback) {
                            return this.rpcCall(getConversionAction, $root.google.ads.googleads.v1.services.GetConversionActionRequest, $root.google.ads.googleads.v1.resources.ConversionAction, request, callback);
                        }, "name", { value: "GetConversionAction" });

                        /**
                         * Calls GetConversionAction.
                         * @function getConversionAction
                         * @memberof google.ads.googleads.v1.services.ConversionActionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetConversionActionRequest} request GetConversionActionRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.ConversionAction>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.ConversionActionService#mutateConversionActions}.
                         * @memberof google.ads.googleads.v1.services.ConversionActionService
                         * @typedef MutateConversionActionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateConversionActionsResponse} [response] MutateConversionActionsResponse
                         */

                        /**
                         * Calls MutateConversionActions.
                         * @function mutateConversionActions
                         * @memberof google.ads.googleads.v1.services.ConversionActionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateConversionActionsRequest} request MutateConversionActionsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.ConversionActionService.MutateConversionActionsCallback} callback Node-style callback called with the error, if any, and MutateConversionActionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ConversionActionService.prototype.mutateConversionActions = function mutateConversionActions(request, callback) {
                            return this.rpcCall(mutateConversionActions, $root.google.ads.googleads.v1.services.MutateConversionActionsRequest, $root.google.ads.googleads.v1.services.MutateConversionActionsResponse, request, callback);
                        }, "name", { value: "MutateConversionActions" });

                        /**
                         * Calls MutateConversionActions.
                         * @function mutateConversionActions
                         * @memberof google.ads.googleads.v1.services.ConversionActionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateConversionActionsRequest} request MutateConversionActionsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateConversionActionsResponse>} Promise
                         * @variation 2
                         */

                        return ConversionActionService;
                    })();

                    services.GetConversionActionRequest = (function() {

                        /**
                         * Properties of a GetConversionActionRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetConversionActionRequest
                         * @property {string|null} [resourceName] GetConversionActionRequest resourceName
                         */

                        /**
                         * Constructs a new GetConversionActionRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetConversionActionRequest.
                         * @implements IGetConversionActionRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetConversionActionRequest=} [properties] Properties to set
                         */
                        function GetConversionActionRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetConversionActionRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetConversionActionRequest
                         * @instance
                         */
                        GetConversionActionRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetConversionActionRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetConversionActionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetConversionActionRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetConversionActionRequest} GetConversionActionRequest instance
                         */
                        GetConversionActionRequest.create = function create(properties) {
                            return new GetConversionActionRequest(properties);
                        };

                        /**
                         * Encodes the specified GetConversionActionRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetConversionActionRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetConversionActionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetConversionActionRequest} message GetConversionActionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetConversionActionRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetConversionActionRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetConversionActionRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetConversionActionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetConversionActionRequest} message GetConversionActionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetConversionActionRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetConversionActionRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetConversionActionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetConversionActionRequest} GetConversionActionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetConversionActionRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetConversionActionRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetConversionActionRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetConversionActionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetConversionActionRequest} GetConversionActionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetConversionActionRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetConversionActionRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetConversionActionRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetConversionActionRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetConversionActionRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetConversionActionRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetConversionActionRequest} GetConversionActionRequest
                         */
                        GetConversionActionRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetConversionActionRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetConversionActionRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetConversionActionRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetConversionActionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetConversionActionRequest} message GetConversionActionRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetConversionActionRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetConversionActionRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetConversionActionRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetConversionActionRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetConversionActionRequest;
                    })();

                    services.MutateConversionActionsRequest = (function() {

                        /**
                         * Properties of a MutateConversionActionsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateConversionActionsRequest
                         * @property {string|null} [customerId] MutateConversionActionsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IConversionActionOperation>|null} [operations] MutateConversionActionsRequest operations
                         * @property {boolean|null} [partialFailure] MutateConversionActionsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateConversionActionsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateConversionActionsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateConversionActionsRequest.
                         * @implements IMutateConversionActionsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateConversionActionsRequest=} [properties] Properties to set
                         */
                        function MutateConversionActionsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateConversionActionsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsRequest
                         * @instance
                         */
                        MutateConversionActionsRequest.prototype.customerId = "";

                        /**
                         * MutateConversionActionsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IConversionActionOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsRequest
                         * @instance
                         */
                        MutateConversionActionsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateConversionActionsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsRequest
                         * @instance
                         */
                        MutateConversionActionsRequest.prototype.partialFailure = false;

                        /**
                         * MutateConversionActionsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsRequest
                         * @instance
                         */
                        MutateConversionActionsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateConversionActionsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateConversionActionsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateConversionActionsRequest} MutateConversionActionsRequest instance
                         */
                        MutateConversionActionsRequest.create = function create(properties) {
                            return new MutateConversionActionsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateConversionActionsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateConversionActionsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateConversionActionsRequest} message MutateConversionActionsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateConversionActionsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.ConversionActionOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateConversionActionsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateConversionActionsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateConversionActionsRequest} message MutateConversionActionsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateConversionActionsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateConversionActionsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateConversionActionsRequest} MutateConversionActionsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateConversionActionsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateConversionActionsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.ConversionActionOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateConversionActionsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateConversionActionsRequest} MutateConversionActionsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateConversionActionsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateConversionActionsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateConversionActionsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.ConversionActionOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateConversionActionsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateConversionActionsRequest} MutateConversionActionsRequest
                         */
                        MutateConversionActionsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateConversionActionsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateConversionActionsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateConversionActionsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateConversionActionsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.ConversionActionOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateConversionActionsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateConversionActionsRequest} message MutateConversionActionsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateConversionActionsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.ConversionActionOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateConversionActionsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateConversionActionsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateConversionActionsRequest;
                    })();

                    services.ConversionActionOperation = (function() {

                        /**
                         * Properties of a ConversionActionOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IConversionActionOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] ConversionActionOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IConversionAction|null} [create] ConversionActionOperation create
                         * @property {google.ads.googleads.v1.resources.IConversionAction|null} [update] ConversionActionOperation update
                         * @property {string|null} [remove] ConversionActionOperation remove
                         */

                        /**
                         * Constructs a new ConversionActionOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ConversionActionOperation.
                         * @implements IConversionActionOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IConversionActionOperation=} [properties] Properties to set
                         */
                        function ConversionActionOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ConversionActionOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.ConversionActionOperation
                         * @instance
                         */
                        ConversionActionOperation.prototype.updateMask = null;

                        /**
                         * ConversionActionOperation create.
                         * @member {google.ads.googleads.v1.resources.IConversionAction|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.ConversionActionOperation
                         * @instance
                         */
                        ConversionActionOperation.prototype.create = null;

                        /**
                         * ConversionActionOperation update.
                         * @member {google.ads.googleads.v1.resources.IConversionAction|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.ConversionActionOperation
                         * @instance
                         */
                        ConversionActionOperation.prototype.update = null;

                        /**
                         * ConversionActionOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.ConversionActionOperation
                         * @instance
                         */
                        ConversionActionOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * ConversionActionOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.ConversionActionOperation
                         * @instance
                         */
                        Object.defineProperty(ConversionActionOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new ConversionActionOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ConversionActionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IConversionActionOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ConversionActionOperation} ConversionActionOperation instance
                         */
                        ConversionActionOperation.create = function create(properties) {
                            return new ConversionActionOperation(properties);
                        };

                        /**
                         * Encodes the specified ConversionActionOperation message. Does not implicitly {@link google.ads.googleads.v1.services.ConversionActionOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ConversionActionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IConversionActionOperation} message ConversionActionOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionActionOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.ConversionAction.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.ConversionAction.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ConversionActionOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ConversionActionOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ConversionActionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IConversionActionOperation} message ConversionActionOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionActionOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ConversionActionOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ConversionActionOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ConversionActionOperation} ConversionActionOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionActionOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ConversionActionOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.ConversionAction.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.ConversionAction.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ConversionActionOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ConversionActionOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ConversionActionOperation} ConversionActionOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionActionOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ConversionActionOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ConversionActionOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConversionActionOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.ConversionAction.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.ConversionAction.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a ConversionActionOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ConversionActionOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ConversionActionOperation} ConversionActionOperation
                         */
                        ConversionActionOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ConversionActionOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ConversionActionOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ConversionActionOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ConversionActionOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.ConversionAction.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ConversionActionOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.ConversionAction.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a ConversionActionOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ConversionActionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ConversionActionOperation} message ConversionActionOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConversionActionOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.ConversionAction.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.ConversionAction.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this ConversionActionOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ConversionActionOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConversionActionOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ConversionActionOperation;
                    })();

                    services.MutateConversionActionsResponse = (function() {

                        /**
                         * Properties of a MutateConversionActionsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateConversionActionsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateConversionActionsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateConversionActionResult>|null} [results] MutateConversionActionsResponse results
                         */

                        /**
                         * Constructs a new MutateConversionActionsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateConversionActionsResponse.
                         * @implements IMutateConversionActionsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateConversionActionsResponse=} [properties] Properties to set
                         */
                        function MutateConversionActionsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateConversionActionsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsResponse
                         * @instance
                         */
                        MutateConversionActionsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateConversionActionsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateConversionActionResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsResponse
                         * @instance
                         */
                        MutateConversionActionsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateConversionActionsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateConversionActionsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateConversionActionsResponse} MutateConversionActionsResponse instance
                         */
                        MutateConversionActionsResponse.create = function create(properties) {
                            return new MutateConversionActionsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateConversionActionsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateConversionActionsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateConversionActionsResponse} message MutateConversionActionsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateConversionActionsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateConversionActionResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateConversionActionsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateConversionActionsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateConversionActionsResponse} message MutateConversionActionsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateConversionActionsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateConversionActionsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateConversionActionsResponse} MutateConversionActionsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateConversionActionsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateConversionActionsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateConversionActionResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateConversionActionsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateConversionActionsResponse} MutateConversionActionsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateConversionActionsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateConversionActionsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateConversionActionsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateConversionActionResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateConversionActionsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateConversionActionsResponse} MutateConversionActionsResponse
                         */
                        MutateConversionActionsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateConversionActionsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateConversionActionsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateConversionActionsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateConversionActionsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateConversionActionsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateConversionActionResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateConversionActionsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateConversionActionsResponse} message MutateConversionActionsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateConversionActionsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateConversionActionResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateConversionActionsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateConversionActionsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateConversionActionsResponse;
                    })();

                    services.MutateConversionActionResult = (function() {

                        /**
                         * Properties of a MutateConversionActionResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateConversionActionResult
                         * @property {string|null} [resourceName] MutateConversionActionResult resourceName
                         */

                        /**
                         * Constructs a new MutateConversionActionResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateConversionActionResult.
                         * @implements IMutateConversionActionResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateConversionActionResult=} [properties] Properties to set
                         */
                        function MutateConversionActionResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateConversionActionResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionResult
                         * @instance
                         */
                        MutateConversionActionResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateConversionActionResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateConversionActionResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateConversionActionResult} MutateConversionActionResult instance
                         */
                        MutateConversionActionResult.create = function create(properties) {
                            return new MutateConversionActionResult(properties);
                        };

                        /**
                         * Encodes the specified MutateConversionActionResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateConversionActionResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateConversionActionResult} message MutateConversionActionResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateConversionActionResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateConversionActionResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateConversionActionResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateConversionActionResult} message MutateConversionActionResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateConversionActionResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateConversionActionResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateConversionActionResult} MutateConversionActionResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateConversionActionResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateConversionActionResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateConversionActionResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateConversionActionResult} MutateConversionActionResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateConversionActionResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateConversionActionResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateConversionActionResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateConversionActionResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateConversionActionResult} MutateConversionActionResult
                         */
                        MutateConversionActionResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateConversionActionResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateConversionActionResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateConversionActionResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateConversionActionResult} message MutateConversionActionResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateConversionActionResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateConversionActionResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateConversionActionResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateConversionActionResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateConversionActionResult;
                    })();

                    services.ConversionAdjustmentUploadService = (function() {

                        /**
                         * Constructs a new ConversionAdjustmentUploadService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ConversionAdjustmentUploadService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function ConversionAdjustmentUploadService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (ConversionAdjustmentUploadService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = ConversionAdjustmentUploadService;

                        /**
                         * Creates new ConversionAdjustmentUploadService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentUploadService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {ConversionAdjustmentUploadService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        ConversionAdjustmentUploadService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.ConversionAdjustmentUploadService#uploadConversionAdjustments}.
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentUploadService
                         * @typedef UploadConversionAdjustmentsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse} [response] UploadConversionAdjustmentsResponse
                         */

                        /**
                         * Calls UploadConversionAdjustments.
                         * @function uploadConversionAdjustments
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentUploadService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IUploadConversionAdjustmentsRequest} request UploadConversionAdjustmentsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.ConversionAdjustmentUploadService.UploadConversionAdjustmentsCallback} callback Node-style callback called with the error, if any, and UploadConversionAdjustmentsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ConversionAdjustmentUploadService.prototype.uploadConversionAdjustments = function uploadConversionAdjustments(request, callback) {
                            return this.rpcCall(uploadConversionAdjustments, $root.google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest, $root.google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse, request, callback);
                        }, "name", { value: "UploadConversionAdjustments" });

                        /**
                         * Calls UploadConversionAdjustments.
                         * @function uploadConversionAdjustments
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentUploadService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IUploadConversionAdjustmentsRequest} request UploadConversionAdjustmentsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse>} Promise
                         * @variation 2
                         */

                        return ConversionAdjustmentUploadService;
                    })();

                    services.UploadConversionAdjustmentsRequest = (function() {

                        /**
                         * Properties of an UploadConversionAdjustmentsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IUploadConversionAdjustmentsRequest
                         * @property {string|null} [customerId] UploadConversionAdjustmentsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IConversionAdjustment>|null} [conversionAdjustments] UploadConversionAdjustmentsRequest conversionAdjustments
                         * @property {boolean|null} [partialFailure] UploadConversionAdjustmentsRequest partialFailure
                         */

                        /**
                         * Constructs a new UploadConversionAdjustmentsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an UploadConversionAdjustmentsRequest.
                         * @implements IUploadConversionAdjustmentsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IUploadConversionAdjustmentsRequest=} [properties] Properties to set
                         */
                        function UploadConversionAdjustmentsRequest(properties) {
                            this.conversionAdjustments = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UploadConversionAdjustmentsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest
                         * @instance
                         */
                        UploadConversionAdjustmentsRequest.prototype.customerId = "";

                        /**
                         * UploadConversionAdjustmentsRequest conversionAdjustments.
                         * @member {Array.<google.ads.googleads.v1.services.IConversionAdjustment>} conversionAdjustments
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest
                         * @instance
                         */
                        UploadConversionAdjustmentsRequest.prototype.conversionAdjustments = $util.emptyArray;

                        /**
                         * UploadConversionAdjustmentsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest
                         * @instance
                         */
                        UploadConversionAdjustmentsRequest.prototype.partialFailure = false;

                        /**
                         * Creates a new UploadConversionAdjustmentsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IUploadConversionAdjustmentsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest} UploadConversionAdjustmentsRequest instance
                         */
                        UploadConversionAdjustmentsRequest.create = function create(properties) {
                            return new UploadConversionAdjustmentsRequest(properties);
                        };

                        /**
                         * Encodes the specified UploadConversionAdjustmentsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IUploadConversionAdjustmentsRequest} message UploadConversionAdjustmentsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UploadConversionAdjustmentsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.conversionAdjustments != null && message.conversionAdjustments.length)
                                for (var i = 0; i < message.conversionAdjustments.length; ++i)
                                    $root.google.ads.googleads.v1.services.ConversionAdjustment.encode(message.conversionAdjustments[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            return writer;
                        };

                        /**
                         * Encodes the specified UploadConversionAdjustmentsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IUploadConversionAdjustmentsRequest} message UploadConversionAdjustmentsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UploadConversionAdjustmentsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an UploadConversionAdjustmentsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest} UploadConversionAdjustmentsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UploadConversionAdjustmentsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.conversionAdjustments && message.conversionAdjustments.length))
                                        message.conversionAdjustments = [];
                                    message.conversionAdjustments.push($root.google.ads.googleads.v1.services.ConversionAdjustment.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an UploadConversionAdjustmentsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest} UploadConversionAdjustmentsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UploadConversionAdjustmentsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an UploadConversionAdjustmentsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UploadConversionAdjustmentsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.conversionAdjustments != null && message.hasOwnProperty("conversionAdjustments")) {
                                if (!Array.isArray(message.conversionAdjustments))
                                    return "conversionAdjustments: array expected";
                                for (var i = 0; i < message.conversionAdjustments.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.ConversionAdjustment.verify(message.conversionAdjustments[i]);
                                    if (error)
                                        return "conversionAdjustments." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            return null;
                        };

                        /**
                         * Creates an UploadConversionAdjustmentsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest} UploadConversionAdjustmentsRequest
                         */
                        UploadConversionAdjustmentsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.conversionAdjustments) {
                                if (!Array.isArray(object.conversionAdjustments))
                                    throw TypeError(".google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest.conversionAdjustments: array expected");
                                message.conversionAdjustments = [];
                                for (var i = 0; i < object.conversionAdjustments.length; ++i) {
                                    if (typeof object.conversionAdjustments[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest.conversionAdjustments: object expected");
                                    message.conversionAdjustments[i] = $root.google.ads.googleads.v1.services.ConversionAdjustment.fromObject(object.conversionAdjustments[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            return message;
                        };

                        /**
                         * Creates a plain object from an UploadConversionAdjustmentsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest} message UploadConversionAdjustmentsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UploadConversionAdjustmentsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.conversionAdjustments = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.conversionAdjustments && message.conversionAdjustments.length) {
                                object.conversionAdjustments = [];
                                for (var j = 0; j < message.conversionAdjustments.length; ++j)
                                    object.conversionAdjustments[j] = $root.google.ads.googleads.v1.services.ConversionAdjustment.toObject(message.conversionAdjustments[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            return object;
                        };

                        /**
                         * Converts this UploadConversionAdjustmentsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UploadConversionAdjustmentsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UploadConversionAdjustmentsRequest;
                    })();

                    services.UploadConversionAdjustmentsResponse = (function() {

                        /**
                         * Properties of an UploadConversionAdjustmentsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IUploadConversionAdjustmentsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] UploadConversionAdjustmentsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IConversionAdjustmentResult>|null} [results] UploadConversionAdjustmentsResponse results
                         */

                        /**
                         * Constructs a new UploadConversionAdjustmentsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an UploadConversionAdjustmentsResponse.
                         * @implements IUploadConversionAdjustmentsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IUploadConversionAdjustmentsResponse=} [properties] Properties to set
                         */
                        function UploadConversionAdjustmentsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UploadConversionAdjustmentsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse
                         * @instance
                         */
                        UploadConversionAdjustmentsResponse.prototype.partialFailureError = null;

                        /**
                         * UploadConversionAdjustmentsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IConversionAdjustmentResult>} results
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse
                         * @instance
                         */
                        UploadConversionAdjustmentsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new UploadConversionAdjustmentsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IUploadConversionAdjustmentsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse} UploadConversionAdjustmentsResponse instance
                         */
                        UploadConversionAdjustmentsResponse.create = function create(properties) {
                            return new UploadConversionAdjustmentsResponse(properties);
                        };

                        /**
                         * Encodes the specified UploadConversionAdjustmentsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IUploadConversionAdjustmentsResponse} message UploadConversionAdjustmentsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UploadConversionAdjustmentsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.ConversionAdjustmentResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified UploadConversionAdjustmentsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IUploadConversionAdjustmentsResponse} message UploadConversionAdjustmentsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UploadConversionAdjustmentsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an UploadConversionAdjustmentsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse} UploadConversionAdjustmentsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UploadConversionAdjustmentsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.ConversionAdjustmentResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an UploadConversionAdjustmentsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse} UploadConversionAdjustmentsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UploadConversionAdjustmentsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an UploadConversionAdjustmentsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UploadConversionAdjustmentsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.ConversionAdjustmentResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an UploadConversionAdjustmentsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse} UploadConversionAdjustmentsResponse
                         */
                        UploadConversionAdjustmentsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.ConversionAdjustmentResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an UploadConversionAdjustmentsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse} message UploadConversionAdjustmentsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UploadConversionAdjustmentsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.ConversionAdjustmentResult.toObject(message.results[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this UploadConversionAdjustmentsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.UploadConversionAdjustmentsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UploadConversionAdjustmentsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UploadConversionAdjustmentsResponse;
                    })();

                    services.ConversionAdjustment = (function() {

                        /**
                         * Properties of a ConversionAdjustment.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IConversionAdjustment
                         * @property {google.protobuf.IStringValue|null} [conversionAction] ConversionAdjustment conversionAction
                         * @property {google.protobuf.IStringValue|null} [adjustmentDateTime] ConversionAdjustment adjustmentDateTime
                         * @property {google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum.ConversionAdjustmentType|null} [adjustmentType] ConversionAdjustment adjustmentType
                         * @property {google.ads.googleads.v1.services.IRestatementValue|null} [restatementValue] ConversionAdjustment restatementValue
                         * @property {google.ads.googleads.v1.services.IGclidDateTimePair|null} [gclidDateTimePair] ConversionAdjustment gclidDateTimePair
                         * @property {google.protobuf.IStringValue|null} [orderId] ConversionAdjustment orderId
                         */

                        /**
                         * Constructs a new ConversionAdjustment.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ConversionAdjustment.
                         * @implements IConversionAdjustment
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IConversionAdjustment=} [properties] Properties to set
                         */
                        function ConversionAdjustment(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ConversionAdjustment conversionAction.
                         * @member {google.protobuf.IStringValue|null|undefined} conversionAction
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustment
                         * @instance
                         */
                        ConversionAdjustment.prototype.conversionAction = null;

                        /**
                         * ConversionAdjustment adjustmentDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} adjustmentDateTime
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustment
                         * @instance
                         */
                        ConversionAdjustment.prototype.adjustmentDateTime = null;

                        /**
                         * ConversionAdjustment adjustmentType.
                         * @member {google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum.ConversionAdjustmentType} adjustmentType
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustment
                         * @instance
                         */
                        ConversionAdjustment.prototype.adjustmentType = 0;

                        /**
                         * ConversionAdjustment restatementValue.
                         * @member {google.ads.googleads.v1.services.IRestatementValue|null|undefined} restatementValue
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustment
                         * @instance
                         */
                        ConversionAdjustment.prototype.restatementValue = null;

                        /**
                         * ConversionAdjustment gclidDateTimePair.
                         * @member {google.ads.googleads.v1.services.IGclidDateTimePair|null|undefined} gclidDateTimePair
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustment
                         * @instance
                         */
                        ConversionAdjustment.prototype.gclidDateTimePair = null;

                        /**
                         * ConversionAdjustment orderId.
                         * @member {google.protobuf.IStringValue|null|undefined} orderId
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustment
                         * @instance
                         */
                        ConversionAdjustment.prototype.orderId = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * ConversionAdjustment conversionIdentifier.
                         * @member {"gclidDateTimePair"|"orderId"|undefined} conversionIdentifier
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustment
                         * @instance
                         */
                        Object.defineProperty(ConversionAdjustment.prototype, "conversionIdentifier", {
                            get: $util.oneOfGetter($oneOfFields = ["gclidDateTimePair", "orderId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new ConversionAdjustment instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustment
                         * @static
                         * @param {google.ads.googleads.v1.services.IConversionAdjustment=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ConversionAdjustment} ConversionAdjustment instance
                         */
                        ConversionAdjustment.create = function create(properties) {
                            return new ConversionAdjustment(properties);
                        };

                        /**
                         * Encodes the specified ConversionAdjustment message. Does not implicitly {@link google.ads.googleads.v1.services.ConversionAdjustment.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustment
                         * @static
                         * @param {google.ads.googleads.v1.services.IConversionAdjustment} message ConversionAdjustment message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionAdjustment.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.gclidDateTimePair != null && message.hasOwnProperty("gclidDateTimePair"))
                                $root.google.ads.googleads.v1.services.GclidDateTimePair.encode(message.gclidDateTimePair, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.orderId != null && message.hasOwnProperty("orderId"))
                                $root.google.protobuf.StringValue.encode(message.orderId, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                $root.google.protobuf.StringValue.encode(message.conversionAction, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.adjustmentDateTime != null && message.hasOwnProperty("adjustmentDateTime"))
                                $root.google.protobuf.StringValue.encode(message.adjustmentDateTime, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.adjustmentType != null && message.hasOwnProperty("adjustmentType"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.adjustmentType);
                            if (message.restatementValue != null && message.hasOwnProperty("restatementValue"))
                                $root.google.ads.googleads.v1.services.RestatementValue.encode(message.restatementValue, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ConversionAdjustment message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ConversionAdjustment.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustment
                         * @static
                         * @param {google.ads.googleads.v1.services.IConversionAdjustment} message ConversionAdjustment message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionAdjustment.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ConversionAdjustment message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustment
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ConversionAdjustment} ConversionAdjustment
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionAdjustment.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ConversionAdjustment();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.conversionAction = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.adjustmentDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.adjustmentType = reader.int32();
                                    break;
                                case 6:
                                    message.restatementValue = $root.google.ads.googleads.v1.services.RestatementValue.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.gclidDateTimePair = $root.google.ads.googleads.v1.services.GclidDateTimePair.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.orderId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ConversionAdjustment message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustment
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ConversionAdjustment} ConversionAdjustment
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionAdjustment.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ConversionAdjustment message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustment
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConversionAdjustment.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction")) {
                                var error = $root.google.protobuf.StringValue.verify(message.conversionAction);
                                if (error)
                                    return "conversionAction." + error;
                            }
                            if (message.adjustmentDateTime != null && message.hasOwnProperty("adjustmentDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adjustmentDateTime);
                                if (error)
                                    return "adjustmentDateTime." + error;
                            }
                            if (message.adjustmentType != null && message.hasOwnProperty("adjustmentType"))
                                switch (message.adjustmentType) {
                                default:
                                    return "adjustmentType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.restatementValue != null && message.hasOwnProperty("restatementValue")) {
                                var error = $root.google.ads.googleads.v1.services.RestatementValue.verify(message.restatementValue);
                                if (error)
                                    return "restatementValue." + error;
                            }
                            if (message.gclidDateTimePair != null && message.hasOwnProperty("gclidDateTimePair")) {
                                properties.conversionIdentifier = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.GclidDateTimePair.verify(message.gclidDateTimePair);
                                    if (error)
                                        return "gclidDateTimePair." + error;
                                }
                            }
                            if (message.orderId != null && message.hasOwnProperty("orderId")) {
                                if (properties.conversionIdentifier === 1)
                                    return "conversionIdentifier: multiple values";
                                properties.conversionIdentifier = 1;
                                {
                                    var error = $root.google.protobuf.StringValue.verify(message.orderId);
                                    if (error)
                                        return "orderId." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a ConversionAdjustment message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustment
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ConversionAdjustment} ConversionAdjustment
                         */
                        ConversionAdjustment.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ConversionAdjustment)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ConversionAdjustment();
                            if (object.conversionAction != null) {
                                if (typeof object.conversionAction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ConversionAdjustment.conversionAction: object expected");
                                message.conversionAction = $root.google.protobuf.StringValue.fromObject(object.conversionAction);
                            }
                            if (object.adjustmentDateTime != null) {
                                if (typeof object.adjustmentDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ConversionAdjustment.adjustmentDateTime: object expected");
                                message.adjustmentDateTime = $root.google.protobuf.StringValue.fromObject(object.adjustmentDateTime);
                            }
                            switch (object.adjustmentType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.adjustmentType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.adjustmentType = 1;
                                break;
                            case "RETRACTION":
                            case 2:
                                message.adjustmentType = 2;
                                break;
                            case "RESTATEMENT":
                            case 3:
                                message.adjustmentType = 3;
                                break;
                            }
                            if (object.restatementValue != null) {
                                if (typeof object.restatementValue !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ConversionAdjustment.restatementValue: object expected");
                                message.restatementValue = $root.google.ads.googleads.v1.services.RestatementValue.fromObject(object.restatementValue);
                            }
                            if (object.gclidDateTimePair != null) {
                                if (typeof object.gclidDateTimePair !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ConversionAdjustment.gclidDateTimePair: object expected");
                                message.gclidDateTimePair = $root.google.ads.googleads.v1.services.GclidDateTimePair.fromObject(object.gclidDateTimePair);
                            }
                            if (object.orderId != null) {
                                if (typeof object.orderId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ConversionAdjustment.orderId: object expected");
                                message.orderId = $root.google.protobuf.StringValue.fromObject(object.orderId);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ConversionAdjustment message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustment
                         * @static
                         * @param {google.ads.googleads.v1.services.ConversionAdjustment} message ConversionAdjustment
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConversionAdjustment.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.conversionAction = null;
                                object.adjustmentDateTime = null;
                                object.adjustmentType = options.enums === String ? "UNSPECIFIED" : 0;
                                object.restatementValue = null;
                            }
                            if (message.gclidDateTimePair != null && message.hasOwnProperty("gclidDateTimePair")) {
                                object.gclidDateTimePair = $root.google.ads.googleads.v1.services.GclidDateTimePair.toObject(message.gclidDateTimePair, options);
                                if (options.oneofs)
                                    object.conversionIdentifier = "gclidDateTimePair";
                            }
                            if (message.orderId != null && message.hasOwnProperty("orderId")) {
                                object.orderId = $root.google.protobuf.StringValue.toObject(message.orderId, options);
                                if (options.oneofs)
                                    object.conversionIdentifier = "orderId";
                            }
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                object.conversionAction = $root.google.protobuf.StringValue.toObject(message.conversionAction, options);
                            if (message.adjustmentDateTime != null && message.hasOwnProperty("adjustmentDateTime"))
                                object.adjustmentDateTime = $root.google.protobuf.StringValue.toObject(message.adjustmentDateTime, options);
                            if (message.adjustmentType != null && message.hasOwnProperty("adjustmentType"))
                                object.adjustmentType = options.enums === String ? $root.google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum.ConversionAdjustmentType[message.adjustmentType] : message.adjustmentType;
                            if (message.restatementValue != null && message.hasOwnProperty("restatementValue"))
                                object.restatementValue = $root.google.ads.googleads.v1.services.RestatementValue.toObject(message.restatementValue, options);
                            return object;
                        };

                        /**
                         * Converts this ConversionAdjustment to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustment
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConversionAdjustment.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ConversionAdjustment;
                    })();

                    services.RestatementValue = (function() {

                        /**
                         * Properties of a RestatementValue.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IRestatementValue
                         * @property {google.protobuf.IDoubleValue|null} [adjustedValue] RestatementValue adjustedValue
                         * @property {google.protobuf.IStringValue|null} [currencyCode] RestatementValue currencyCode
                         */

                        /**
                         * Constructs a new RestatementValue.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a RestatementValue.
                         * @implements IRestatementValue
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IRestatementValue=} [properties] Properties to set
                         */
                        function RestatementValue(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * RestatementValue adjustedValue.
                         * @member {google.protobuf.IDoubleValue|null|undefined} adjustedValue
                         * @memberof google.ads.googleads.v1.services.RestatementValue
                         * @instance
                         */
                        RestatementValue.prototype.adjustedValue = null;

                        /**
                         * RestatementValue currencyCode.
                         * @member {google.protobuf.IStringValue|null|undefined} currencyCode
                         * @memberof google.ads.googleads.v1.services.RestatementValue
                         * @instance
                         */
                        RestatementValue.prototype.currencyCode = null;

                        /**
                         * Creates a new RestatementValue instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.RestatementValue
                         * @static
                         * @param {google.ads.googleads.v1.services.IRestatementValue=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.RestatementValue} RestatementValue instance
                         */
                        RestatementValue.create = function create(properties) {
                            return new RestatementValue(properties);
                        };

                        /**
                         * Encodes the specified RestatementValue message. Does not implicitly {@link google.ads.googleads.v1.services.RestatementValue.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.RestatementValue
                         * @static
                         * @param {google.ads.googleads.v1.services.IRestatementValue} message RestatementValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RestatementValue.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.adjustedValue != null && message.hasOwnProperty("adjustedValue"))
                                $root.google.protobuf.DoubleValue.encode(message.adjustedValue, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode"))
                                $root.google.protobuf.StringValue.encode(message.currencyCode, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified RestatementValue message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.RestatementValue.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.RestatementValue
                         * @static
                         * @param {google.ads.googleads.v1.services.IRestatementValue} message RestatementValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RestatementValue.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a RestatementValue message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.RestatementValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.RestatementValue} RestatementValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RestatementValue.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.RestatementValue();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.adjustedValue = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.currencyCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a RestatementValue message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.RestatementValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.RestatementValue} RestatementValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RestatementValue.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a RestatementValue message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.RestatementValue
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RestatementValue.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.adjustedValue != null && message.hasOwnProperty("adjustedValue")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.adjustedValue);
                                if (error)
                                    return "adjustedValue." + error;
                            }
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.currencyCode);
                                if (error)
                                    return "currencyCode." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a RestatementValue message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.RestatementValue
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.RestatementValue} RestatementValue
                         */
                        RestatementValue.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.RestatementValue)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.RestatementValue();
                            if (object.adjustedValue != null) {
                                if (typeof object.adjustedValue !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.RestatementValue.adjustedValue: object expected");
                                message.adjustedValue = $root.google.protobuf.DoubleValue.fromObject(object.adjustedValue);
                            }
                            if (object.currencyCode != null) {
                                if (typeof object.currencyCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.RestatementValue.currencyCode: object expected");
                                message.currencyCode = $root.google.protobuf.StringValue.fromObject(object.currencyCode);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a RestatementValue message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.RestatementValue
                         * @static
                         * @param {google.ads.googleads.v1.services.RestatementValue} message RestatementValue
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RestatementValue.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.adjustedValue = null;
                                object.currencyCode = null;
                            }
                            if (message.adjustedValue != null && message.hasOwnProperty("adjustedValue"))
                                object.adjustedValue = $root.google.protobuf.DoubleValue.toObject(message.adjustedValue, options);
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode"))
                                object.currencyCode = $root.google.protobuf.StringValue.toObject(message.currencyCode, options);
                            return object;
                        };

                        /**
                         * Converts this RestatementValue to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.RestatementValue
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RestatementValue.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return RestatementValue;
                    })();

                    services.GclidDateTimePair = (function() {

                        /**
                         * Properties of a GclidDateTimePair.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGclidDateTimePair
                         * @property {google.protobuf.IStringValue|null} [gclid] GclidDateTimePair gclid
                         * @property {google.protobuf.IStringValue|null} [conversionDateTime] GclidDateTimePair conversionDateTime
                         */

                        /**
                         * Constructs a new GclidDateTimePair.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GclidDateTimePair.
                         * @implements IGclidDateTimePair
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGclidDateTimePair=} [properties] Properties to set
                         */
                        function GclidDateTimePair(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GclidDateTimePair gclid.
                         * @member {google.protobuf.IStringValue|null|undefined} gclid
                         * @memberof google.ads.googleads.v1.services.GclidDateTimePair
                         * @instance
                         */
                        GclidDateTimePair.prototype.gclid = null;

                        /**
                         * GclidDateTimePair conversionDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} conversionDateTime
                         * @memberof google.ads.googleads.v1.services.GclidDateTimePair
                         * @instance
                         */
                        GclidDateTimePair.prototype.conversionDateTime = null;

                        /**
                         * Creates a new GclidDateTimePair instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GclidDateTimePair
                         * @static
                         * @param {google.ads.googleads.v1.services.IGclidDateTimePair=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GclidDateTimePair} GclidDateTimePair instance
                         */
                        GclidDateTimePair.create = function create(properties) {
                            return new GclidDateTimePair(properties);
                        };

                        /**
                         * Encodes the specified GclidDateTimePair message. Does not implicitly {@link google.ads.googleads.v1.services.GclidDateTimePair.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GclidDateTimePair
                         * @static
                         * @param {google.ads.googleads.v1.services.IGclidDateTimePair} message GclidDateTimePair message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GclidDateTimePair.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.gclid != null && message.hasOwnProperty("gclid"))
                                $root.google.protobuf.StringValue.encode(message.gclid, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.conversionDateTime != null && message.hasOwnProperty("conversionDateTime"))
                                $root.google.protobuf.StringValue.encode(message.conversionDateTime, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified GclidDateTimePair message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GclidDateTimePair.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GclidDateTimePair
                         * @static
                         * @param {google.ads.googleads.v1.services.IGclidDateTimePair} message GclidDateTimePair message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GclidDateTimePair.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GclidDateTimePair message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GclidDateTimePair
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GclidDateTimePair} GclidDateTimePair
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GclidDateTimePair.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GclidDateTimePair();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.gclid = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.conversionDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GclidDateTimePair message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GclidDateTimePair
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GclidDateTimePair} GclidDateTimePair
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GclidDateTimePair.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GclidDateTimePair message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GclidDateTimePair
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GclidDateTimePair.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.gclid != null && message.hasOwnProperty("gclid")) {
                                var error = $root.google.protobuf.StringValue.verify(message.gclid);
                                if (error)
                                    return "gclid." + error;
                            }
                            if (message.conversionDateTime != null && message.hasOwnProperty("conversionDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.conversionDateTime);
                                if (error)
                                    return "conversionDateTime." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a GclidDateTimePair message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GclidDateTimePair
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GclidDateTimePair} GclidDateTimePair
                         */
                        GclidDateTimePair.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GclidDateTimePair)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GclidDateTimePair();
                            if (object.gclid != null) {
                                if (typeof object.gclid !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GclidDateTimePair.gclid: object expected");
                                message.gclid = $root.google.protobuf.StringValue.fromObject(object.gclid);
                            }
                            if (object.conversionDateTime != null) {
                                if (typeof object.conversionDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GclidDateTimePair.conversionDateTime: object expected");
                                message.conversionDateTime = $root.google.protobuf.StringValue.fromObject(object.conversionDateTime);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a GclidDateTimePair message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GclidDateTimePair
                         * @static
                         * @param {google.ads.googleads.v1.services.GclidDateTimePair} message GclidDateTimePair
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GclidDateTimePair.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.gclid = null;
                                object.conversionDateTime = null;
                            }
                            if (message.gclid != null && message.hasOwnProperty("gclid"))
                                object.gclid = $root.google.protobuf.StringValue.toObject(message.gclid, options);
                            if (message.conversionDateTime != null && message.hasOwnProperty("conversionDateTime"))
                                object.conversionDateTime = $root.google.protobuf.StringValue.toObject(message.conversionDateTime, options);
                            return object;
                        };

                        /**
                         * Converts this GclidDateTimePair to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GclidDateTimePair
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GclidDateTimePair.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GclidDateTimePair;
                    })();

                    services.ConversionAdjustmentResult = (function() {

                        /**
                         * Properties of a ConversionAdjustmentResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IConversionAdjustmentResult
                         * @property {google.protobuf.IStringValue|null} [conversionAction] ConversionAdjustmentResult conversionAction
                         * @property {google.protobuf.IStringValue|null} [adjustmentDateTime] ConversionAdjustmentResult adjustmentDateTime
                         * @property {google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum.ConversionAdjustmentType|null} [adjustmentType] ConversionAdjustmentResult adjustmentType
                         * @property {google.ads.googleads.v1.services.IGclidDateTimePair|null} [gclidDateTimePair] ConversionAdjustmentResult gclidDateTimePair
                         * @property {google.protobuf.IStringValue|null} [orderId] ConversionAdjustmentResult orderId
                         */

                        /**
                         * Constructs a new ConversionAdjustmentResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ConversionAdjustmentResult.
                         * @implements IConversionAdjustmentResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IConversionAdjustmentResult=} [properties] Properties to set
                         */
                        function ConversionAdjustmentResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ConversionAdjustmentResult conversionAction.
                         * @member {google.protobuf.IStringValue|null|undefined} conversionAction
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentResult
                         * @instance
                         */
                        ConversionAdjustmentResult.prototype.conversionAction = null;

                        /**
                         * ConversionAdjustmentResult adjustmentDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} adjustmentDateTime
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentResult
                         * @instance
                         */
                        ConversionAdjustmentResult.prototype.adjustmentDateTime = null;

                        /**
                         * ConversionAdjustmentResult adjustmentType.
                         * @member {google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum.ConversionAdjustmentType} adjustmentType
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentResult
                         * @instance
                         */
                        ConversionAdjustmentResult.prototype.adjustmentType = 0;

                        /**
                         * ConversionAdjustmentResult gclidDateTimePair.
                         * @member {google.ads.googleads.v1.services.IGclidDateTimePair|null|undefined} gclidDateTimePair
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentResult
                         * @instance
                         */
                        ConversionAdjustmentResult.prototype.gclidDateTimePair = null;

                        /**
                         * ConversionAdjustmentResult orderId.
                         * @member {google.protobuf.IStringValue|null|undefined} orderId
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentResult
                         * @instance
                         */
                        ConversionAdjustmentResult.prototype.orderId = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * ConversionAdjustmentResult conversionIdentifier.
                         * @member {"gclidDateTimePair"|"orderId"|undefined} conversionIdentifier
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentResult
                         * @instance
                         */
                        Object.defineProperty(ConversionAdjustmentResult.prototype, "conversionIdentifier", {
                            get: $util.oneOfGetter($oneOfFields = ["gclidDateTimePair", "orderId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new ConversionAdjustmentResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IConversionAdjustmentResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ConversionAdjustmentResult} ConversionAdjustmentResult instance
                         */
                        ConversionAdjustmentResult.create = function create(properties) {
                            return new ConversionAdjustmentResult(properties);
                        };

                        /**
                         * Encodes the specified ConversionAdjustmentResult message. Does not implicitly {@link google.ads.googleads.v1.services.ConversionAdjustmentResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IConversionAdjustmentResult} message ConversionAdjustmentResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionAdjustmentResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.gclidDateTimePair != null && message.hasOwnProperty("gclidDateTimePair"))
                                $root.google.ads.googleads.v1.services.GclidDateTimePair.encode(message.gclidDateTimePair, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.orderId != null && message.hasOwnProperty("orderId"))
                                $root.google.protobuf.StringValue.encode(message.orderId, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                $root.google.protobuf.StringValue.encode(message.conversionAction, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.adjustmentDateTime != null && message.hasOwnProperty("adjustmentDateTime"))
                                $root.google.protobuf.StringValue.encode(message.adjustmentDateTime, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.adjustmentType != null && message.hasOwnProperty("adjustmentType"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.adjustmentType);
                            return writer;
                        };

                        /**
                         * Encodes the specified ConversionAdjustmentResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ConversionAdjustmentResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IConversionAdjustmentResult} message ConversionAdjustmentResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionAdjustmentResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ConversionAdjustmentResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ConversionAdjustmentResult} ConversionAdjustmentResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionAdjustmentResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ConversionAdjustmentResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.conversionAction = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.adjustmentDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.adjustmentType = reader.int32();
                                    break;
                                case 1:
                                    message.gclidDateTimePair = $root.google.ads.googleads.v1.services.GclidDateTimePair.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.orderId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ConversionAdjustmentResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ConversionAdjustmentResult} ConversionAdjustmentResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionAdjustmentResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ConversionAdjustmentResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConversionAdjustmentResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction")) {
                                var error = $root.google.protobuf.StringValue.verify(message.conversionAction);
                                if (error)
                                    return "conversionAction." + error;
                            }
                            if (message.adjustmentDateTime != null && message.hasOwnProperty("adjustmentDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.adjustmentDateTime);
                                if (error)
                                    return "adjustmentDateTime." + error;
                            }
                            if (message.adjustmentType != null && message.hasOwnProperty("adjustmentType"))
                                switch (message.adjustmentType) {
                                default:
                                    return "adjustmentType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.gclidDateTimePair != null && message.hasOwnProperty("gclidDateTimePair")) {
                                properties.conversionIdentifier = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.GclidDateTimePair.verify(message.gclidDateTimePair);
                                    if (error)
                                        return "gclidDateTimePair." + error;
                                }
                            }
                            if (message.orderId != null && message.hasOwnProperty("orderId")) {
                                if (properties.conversionIdentifier === 1)
                                    return "conversionIdentifier: multiple values";
                                properties.conversionIdentifier = 1;
                                {
                                    var error = $root.google.protobuf.StringValue.verify(message.orderId);
                                    if (error)
                                        return "orderId." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a ConversionAdjustmentResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ConversionAdjustmentResult} ConversionAdjustmentResult
                         */
                        ConversionAdjustmentResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ConversionAdjustmentResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ConversionAdjustmentResult();
                            if (object.conversionAction != null) {
                                if (typeof object.conversionAction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ConversionAdjustmentResult.conversionAction: object expected");
                                message.conversionAction = $root.google.protobuf.StringValue.fromObject(object.conversionAction);
                            }
                            if (object.adjustmentDateTime != null) {
                                if (typeof object.adjustmentDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ConversionAdjustmentResult.adjustmentDateTime: object expected");
                                message.adjustmentDateTime = $root.google.protobuf.StringValue.fromObject(object.adjustmentDateTime);
                            }
                            switch (object.adjustmentType) {
                            case "UNSPECIFIED":
                            case 0:
                                message.adjustmentType = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.adjustmentType = 1;
                                break;
                            case "RETRACTION":
                            case 2:
                                message.adjustmentType = 2;
                                break;
                            case "RESTATEMENT":
                            case 3:
                                message.adjustmentType = 3;
                                break;
                            }
                            if (object.gclidDateTimePair != null) {
                                if (typeof object.gclidDateTimePair !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ConversionAdjustmentResult.gclidDateTimePair: object expected");
                                message.gclidDateTimePair = $root.google.ads.googleads.v1.services.GclidDateTimePair.fromObject(object.gclidDateTimePair);
                            }
                            if (object.orderId != null) {
                                if (typeof object.orderId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ConversionAdjustmentResult.orderId: object expected");
                                message.orderId = $root.google.protobuf.StringValue.fromObject(object.orderId);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ConversionAdjustmentResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentResult
                         * @static
                         * @param {google.ads.googleads.v1.services.ConversionAdjustmentResult} message ConversionAdjustmentResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConversionAdjustmentResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.conversionAction = null;
                                object.adjustmentDateTime = null;
                                object.adjustmentType = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.gclidDateTimePair != null && message.hasOwnProperty("gclidDateTimePair")) {
                                object.gclidDateTimePair = $root.google.ads.googleads.v1.services.GclidDateTimePair.toObject(message.gclidDateTimePair, options);
                                if (options.oneofs)
                                    object.conversionIdentifier = "gclidDateTimePair";
                            }
                            if (message.orderId != null && message.hasOwnProperty("orderId")) {
                                object.orderId = $root.google.protobuf.StringValue.toObject(message.orderId, options);
                                if (options.oneofs)
                                    object.conversionIdentifier = "orderId";
                            }
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                object.conversionAction = $root.google.protobuf.StringValue.toObject(message.conversionAction, options);
                            if (message.adjustmentDateTime != null && message.hasOwnProperty("adjustmentDateTime"))
                                object.adjustmentDateTime = $root.google.protobuf.StringValue.toObject(message.adjustmentDateTime, options);
                            if (message.adjustmentType != null && message.hasOwnProperty("adjustmentType"))
                                object.adjustmentType = options.enums === String ? $root.google.ads.googleads.v1.enums.ConversionAdjustmentTypeEnum.ConversionAdjustmentType[message.adjustmentType] : message.adjustmentType;
                            return object;
                        };

                        /**
                         * Converts this ConversionAdjustmentResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ConversionAdjustmentResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConversionAdjustmentResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ConversionAdjustmentResult;
                    })();

                    services.ConversionUploadService = (function() {

                        /**
                         * Constructs a new ConversionUploadService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ConversionUploadService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function ConversionUploadService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (ConversionUploadService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = ConversionUploadService;

                        /**
                         * Creates new ConversionUploadService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ConversionUploadService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {ConversionUploadService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        ConversionUploadService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.ConversionUploadService#uploadClickConversions}.
                         * @memberof google.ads.googleads.v1.services.ConversionUploadService
                         * @typedef UploadClickConversionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.UploadClickConversionsResponse} [response] UploadClickConversionsResponse
                         */

                        /**
                         * Calls UploadClickConversions.
                         * @function uploadClickConversions
                         * @memberof google.ads.googleads.v1.services.ConversionUploadService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IUploadClickConversionsRequest} request UploadClickConversionsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.ConversionUploadService.UploadClickConversionsCallback} callback Node-style callback called with the error, if any, and UploadClickConversionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ConversionUploadService.prototype.uploadClickConversions = function uploadClickConversions(request, callback) {
                            return this.rpcCall(uploadClickConversions, $root.google.ads.googleads.v1.services.UploadClickConversionsRequest, $root.google.ads.googleads.v1.services.UploadClickConversionsResponse, request, callback);
                        }, "name", { value: "UploadClickConversions" });

                        /**
                         * Calls UploadClickConversions.
                         * @function uploadClickConversions
                         * @memberof google.ads.googleads.v1.services.ConversionUploadService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IUploadClickConversionsRequest} request UploadClickConversionsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.UploadClickConversionsResponse>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.ConversionUploadService#uploadCallConversions}.
                         * @memberof google.ads.googleads.v1.services.ConversionUploadService
                         * @typedef UploadCallConversionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.UploadCallConversionsResponse} [response] UploadCallConversionsResponse
                         */

                        /**
                         * Calls UploadCallConversions.
                         * @function uploadCallConversions
                         * @memberof google.ads.googleads.v1.services.ConversionUploadService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IUploadCallConversionsRequest} request UploadCallConversionsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.ConversionUploadService.UploadCallConversionsCallback} callback Node-style callback called with the error, if any, and UploadCallConversionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ConversionUploadService.prototype.uploadCallConversions = function uploadCallConversions(request, callback) {
                            return this.rpcCall(uploadCallConversions, $root.google.ads.googleads.v1.services.UploadCallConversionsRequest, $root.google.ads.googleads.v1.services.UploadCallConversionsResponse, request, callback);
                        }, "name", { value: "UploadCallConversions" });

                        /**
                         * Calls UploadCallConversions.
                         * @function uploadCallConversions
                         * @memberof google.ads.googleads.v1.services.ConversionUploadService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IUploadCallConversionsRequest} request UploadCallConversionsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.UploadCallConversionsResponse>} Promise
                         * @variation 2
                         */

                        return ConversionUploadService;
                    })();

                    services.UploadClickConversionsRequest = (function() {

                        /**
                         * Properties of an UploadClickConversionsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IUploadClickConversionsRequest
                         * @property {string|null} [customerId] UploadClickConversionsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IClickConversion>|null} [conversions] UploadClickConversionsRequest conversions
                         * @property {boolean|null} [partialFailure] UploadClickConversionsRequest partialFailure
                         */

                        /**
                         * Constructs a new UploadClickConversionsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an UploadClickConversionsRequest.
                         * @implements IUploadClickConversionsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IUploadClickConversionsRequest=} [properties] Properties to set
                         */
                        function UploadClickConversionsRequest(properties) {
                            this.conversions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UploadClickConversionsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsRequest
                         * @instance
                         */
                        UploadClickConversionsRequest.prototype.customerId = "";

                        /**
                         * UploadClickConversionsRequest conversions.
                         * @member {Array.<google.ads.googleads.v1.services.IClickConversion>} conversions
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsRequest
                         * @instance
                         */
                        UploadClickConversionsRequest.prototype.conversions = $util.emptyArray;

                        /**
                         * UploadClickConversionsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsRequest
                         * @instance
                         */
                        UploadClickConversionsRequest.prototype.partialFailure = false;

                        /**
                         * Creates a new UploadClickConversionsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IUploadClickConversionsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.UploadClickConversionsRequest} UploadClickConversionsRequest instance
                         */
                        UploadClickConversionsRequest.create = function create(properties) {
                            return new UploadClickConversionsRequest(properties);
                        };

                        /**
                         * Encodes the specified UploadClickConversionsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.UploadClickConversionsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IUploadClickConversionsRequest} message UploadClickConversionsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UploadClickConversionsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.conversions != null && message.conversions.length)
                                for (var i = 0; i < message.conversions.length; ++i)
                                    $root.google.ads.googleads.v1.services.ClickConversion.encode(message.conversions[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            return writer;
                        };

                        /**
                         * Encodes the specified UploadClickConversionsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.UploadClickConversionsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IUploadClickConversionsRequest} message UploadClickConversionsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UploadClickConversionsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an UploadClickConversionsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.UploadClickConversionsRequest} UploadClickConversionsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UploadClickConversionsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.UploadClickConversionsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.conversions && message.conversions.length))
                                        message.conversions = [];
                                    message.conversions.push($root.google.ads.googleads.v1.services.ClickConversion.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an UploadClickConversionsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.UploadClickConversionsRequest} UploadClickConversionsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UploadClickConversionsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an UploadClickConversionsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UploadClickConversionsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.conversions != null && message.hasOwnProperty("conversions")) {
                                if (!Array.isArray(message.conversions))
                                    return "conversions: array expected";
                                for (var i = 0; i < message.conversions.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.ClickConversion.verify(message.conversions[i]);
                                    if (error)
                                        return "conversions." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            return null;
                        };

                        /**
                         * Creates an UploadClickConversionsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.UploadClickConversionsRequest} UploadClickConversionsRequest
                         */
                        UploadClickConversionsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.UploadClickConversionsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.UploadClickConversionsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.conversions) {
                                if (!Array.isArray(object.conversions))
                                    throw TypeError(".google.ads.googleads.v1.services.UploadClickConversionsRequest.conversions: array expected");
                                message.conversions = [];
                                for (var i = 0; i < object.conversions.length; ++i) {
                                    if (typeof object.conversions[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.UploadClickConversionsRequest.conversions: object expected");
                                    message.conversions[i] = $root.google.ads.googleads.v1.services.ClickConversion.fromObject(object.conversions[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            return message;
                        };

                        /**
                         * Creates a plain object from an UploadClickConversionsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.UploadClickConversionsRequest} message UploadClickConversionsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UploadClickConversionsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.conversions = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.conversions && message.conversions.length) {
                                object.conversions = [];
                                for (var j = 0; j < message.conversions.length; ++j)
                                    object.conversions[j] = $root.google.ads.googleads.v1.services.ClickConversion.toObject(message.conversions[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            return object;
                        };

                        /**
                         * Converts this UploadClickConversionsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UploadClickConversionsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UploadClickConversionsRequest;
                    })();

                    services.UploadClickConversionsResponse = (function() {

                        /**
                         * Properties of an UploadClickConversionsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IUploadClickConversionsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] UploadClickConversionsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IClickConversionResult>|null} [results] UploadClickConversionsResponse results
                         */

                        /**
                         * Constructs a new UploadClickConversionsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an UploadClickConversionsResponse.
                         * @implements IUploadClickConversionsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IUploadClickConversionsResponse=} [properties] Properties to set
                         */
                        function UploadClickConversionsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UploadClickConversionsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsResponse
                         * @instance
                         */
                        UploadClickConversionsResponse.prototype.partialFailureError = null;

                        /**
                         * UploadClickConversionsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IClickConversionResult>} results
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsResponse
                         * @instance
                         */
                        UploadClickConversionsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new UploadClickConversionsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IUploadClickConversionsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.UploadClickConversionsResponse} UploadClickConversionsResponse instance
                         */
                        UploadClickConversionsResponse.create = function create(properties) {
                            return new UploadClickConversionsResponse(properties);
                        };

                        /**
                         * Encodes the specified UploadClickConversionsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.UploadClickConversionsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IUploadClickConversionsResponse} message UploadClickConversionsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UploadClickConversionsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.ClickConversionResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified UploadClickConversionsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.UploadClickConversionsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IUploadClickConversionsResponse} message UploadClickConversionsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UploadClickConversionsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an UploadClickConversionsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.UploadClickConversionsResponse} UploadClickConversionsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UploadClickConversionsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.UploadClickConversionsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.ClickConversionResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an UploadClickConversionsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.UploadClickConversionsResponse} UploadClickConversionsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UploadClickConversionsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an UploadClickConversionsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UploadClickConversionsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.ClickConversionResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an UploadClickConversionsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.UploadClickConversionsResponse} UploadClickConversionsResponse
                         */
                        UploadClickConversionsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.UploadClickConversionsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.UploadClickConversionsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.UploadClickConversionsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.UploadClickConversionsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.UploadClickConversionsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.ClickConversionResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an UploadClickConversionsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.UploadClickConversionsResponse} message UploadClickConversionsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UploadClickConversionsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.ClickConversionResult.toObject(message.results[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this UploadClickConversionsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.UploadClickConversionsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UploadClickConversionsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UploadClickConversionsResponse;
                    })();

                    services.UploadCallConversionsRequest = (function() {

                        /**
                         * Properties of an UploadCallConversionsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IUploadCallConversionsRequest
                         * @property {string|null} [customerId] UploadCallConversionsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.ICallConversion>|null} [conversions] UploadCallConversionsRequest conversions
                         * @property {boolean|null} [partialFailure] UploadCallConversionsRequest partialFailure
                         */

                        /**
                         * Constructs a new UploadCallConversionsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an UploadCallConversionsRequest.
                         * @implements IUploadCallConversionsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IUploadCallConversionsRequest=} [properties] Properties to set
                         */
                        function UploadCallConversionsRequest(properties) {
                            this.conversions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UploadCallConversionsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsRequest
                         * @instance
                         */
                        UploadCallConversionsRequest.prototype.customerId = "";

                        /**
                         * UploadCallConversionsRequest conversions.
                         * @member {Array.<google.ads.googleads.v1.services.ICallConversion>} conversions
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsRequest
                         * @instance
                         */
                        UploadCallConversionsRequest.prototype.conversions = $util.emptyArray;

                        /**
                         * UploadCallConversionsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsRequest
                         * @instance
                         */
                        UploadCallConversionsRequest.prototype.partialFailure = false;

                        /**
                         * Creates a new UploadCallConversionsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IUploadCallConversionsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.UploadCallConversionsRequest} UploadCallConversionsRequest instance
                         */
                        UploadCallConversionsRequest.create = function create(properties) {
                            return new UploadCallConversionsRequest(properties);
                        };

                        /**
                         * Encodes the specified UploadCallConversionsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.UploadCallConversionsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IUploadCallConversionsRequest} message UploadCallConversionsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UploadCallConversionsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.conversions != null && message.conversions.length)
                                for (var i = 0; i < message.conversions.length; ++i)
                                    $root.google.ads.googleads.v1.services.CallConversion.encode(message.conversions[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            return writer;
                        };

                        /**
                         * Encodes the specified UploadCallConversionsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.UploadCallConversionsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IUploadCallConversionsRequest} message UploadCallConversionsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UploadCallConversionsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an UploadCallConversionsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.UploadCallConversionsRequest} UploadCallConversionsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UploadCallConversionsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.UploadCallConversionsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.conversions && message.conversions.length))
                                        message.conversions = [];
                                    message.conversions.push($root.google.ads.googleads.v1.services.CallConversion.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an UploadCallConversionsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.UploadCallConversionsRequest} UploadCallConversionsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UploadCallConversionsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an UploadCallConversionsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UploadCallConversionsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.conversions != null && message.hasOwnProperty("conversions")) {
                                if (!Array.isArray(message.conversions))
                                    return "conversions: array expected";
                                for (var i = 0; i < message.conversions.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.CallConversion.verify(message.conversions[i]);
                                    if (error)
                                        return "conversions." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            return null;
                        };

                        /**
                         * Creates an UploadCallConversionsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.UploadCallConversionsRequest} UploadCallConversionsRequest
                         */
                        UploadCallConversionsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.UploadCallConversionsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.UploadCallConversionsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.conversions) {
                                if (!Array.isArray(object.conversions))
                                    throw TypeError(".google.ads.googleads.v1.services.UploadCallConversionsRequest.conversions: array expected");
                                message.conversions = [];
                                for (var i = 0; i < object.conversions.length; ++i) {
                                    if (typeof object.conversions[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.UploadCallConversionsRequest.conversions: object expected");
                                    message.conversions[i] = $root.google.ads.googleads.v1.services.CallConversion.fromObject(object.conversions[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            return message;
                        };

                        /**
                         * Creates a plain object from an UploadCallConversionsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.UploadCallConversionsRequest} message UploadCallConversionsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UploadCallConversionsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.conversions = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.conversions && message.conversions.length) {
                                object.conversions = [];
                                for (var j = 0; j < message.conversions.length; ++j)
                                    object.conversions[j] = $root.google.ads.googleads.v1.services.CallConversion.toObject(message.conversions[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            return object;
                        };

                        /**
                         * Converts this UploadCallConversionsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UploadCallConversionsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UploadCallConversionsRequest;
                    })();

                    services.UploadCallConversionsResponse = (function() {

                        /**
                         * Properties of an UploadCallConversionsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IUploadCallConversionsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] UploadCallConversionsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.ICallConversionResult>|null} [results] UploadCallConversionsResponse results
                         */

                        /**
                         * Constructs a new UploadCallConversionsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an UploadCallConversionsResponse.
                         * @implements IUploadCallConversionsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IUploadCallConversionsResponse=} [properties] Properties to set
                         */
                        function UploadCallConversionsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UploadCallConversionsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsResponse
                         * @instance
                         */
                        UploadCallConversionsResponse.prototype.partialFailureError = null;

                        /**
                         * UploadCallConversionsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.ICallConversionResult>} results
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsResponse
                         * @instance
                         */
                        UploadCallConversionsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new UploadCallConversionsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IUploadCallConversionsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.UploadCallConversionsResponse} UploadCallConversionsResponse instance
                         */
                        UploadCallConversionsResponse.create = function create(properties) {
                            return new UploadCallConversionsResponse(properties);
                        };

                        /**
                         * Encodes the specified UploadCallConversionsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.UploadCallConversionsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IUploadCallConversionsResponse} message UploadCallConversionsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UploadCallConversionsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.CallConversionResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified UploadCallConversionsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.UploadCallConversionsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IUploadCallConversionsResponse} message UploadCallConversionsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UploadCallConversionsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an UploadCallConversionsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.UploadCallConversionsResponse} UploadCallConversionsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UploadCallConversionsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.UploadCallConversionsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.CallConversionResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an UploadCallConversionsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.UploadCallConversionsResponse} UploadCallConversionsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UploadCallConversionsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an UploadCallConversionsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UploadCallConversionsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.CallConversionResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an UploadCallConversionsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.UploadCallConversionsResponse} UploadCallConversionsResponse
                         */
                        UploadCallConversionsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.UploadCallConversionsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.UploadCallConversionsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.UploadCallConversionsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.UploadCallConversionsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.UploadCallConversionsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.CallConversionResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an UploadCallConversionsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.UploadCallConversionsResponse} message UploadCallConversionsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UploadCallConversionsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.CallConversionResult.toObject(message.results[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this UploadCallConversionsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.UploadCallConversionsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UploadCallConversionsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UploadCallConversionsResponse;
                    })();

                    services.ClickConversion = (function() {

                        /**
                         * Properties of a ClickConversion.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IClickConversion
                         * @property {google.protobuf.IStringValue|null} [gclid] ClickConversion gclid
                         * @property {google.protobuf.IStringValue|null} [conversionAction] ClickConversion conversionAction
                         * @property {google.protobuf.IStringValue|null} [conversionDateTime] ClickConversion conversionDateTime
                         * @property {google.protobuf.IDoubleValue|null} [conversionValue] ClickConversion conversionValue
                         * @property {google.protobuf.IStringValue|null} [currencyCode] ClickConversion currencyCode
                         * @property {google.protobuf.IStringValue|null} [orderId] ClickConversion orderId
                         * @property {google.ads.googleads.v1.services.IExternalAttributionData|null} [externalAttributionData] ClickConversion externalAttributionData
                         */

                        /**
                         * Constructs a new ClickConversion.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ClickConversion.
                         * @implements IClickConversion
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IClickConversion=} [properties] Properties to set
                         */
                        function ClickConversion(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ClickConversion gclid.
                         * @member {google.protobuf.IStringValue|null|undefined} gclid
                         * @memberof google.ads.googleads.v1.services.ClickConversion
                         * @instance
                         */
                        ClickConversion.prototype.gclid = null;

                        /**
                         * ClickConversion conversionAction.
                         * @member {google.protobuf.IStringValue|null|undefined} conversionAction
                         * @memberof google.ads.googleads.v1.services.ClickConversion
                         * @instance
                         */
                        ClickConversion.prototype.conversionAction = null;

                        /**
                         * ClickConversion conversionDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} conversionDateTime
                         * @memberof google.ads.googleads.v1.services.ClickConversion
                         * @instance
                         */
                        ClickConversion.prototype.conversionDateTime = null;

                        /**
                         * ClickConversion conversionValue.
                         * @member {google.protobuf.IDoubleValue|null|undefined} conversionValue
                         * @memberof google.ads.googleads.v1.services.ClickConversion
                         * @instance
                         */
                        ClickConversion.prototype.conversionValue = null;

                        /**
                         * ClickConversion currencyCode.
                         * @member {google.protobuf.IStringValue|null|undefined} currencyCode
                         * @memberof google.ads.googleads.v1.services.ClickConversion
                         * @instance
                         */
                        ClickConversion.prototype.currencyCode = null;

                        /**
                         * ClickConversion orderId.
                         * @member {google.protobuf.IStringValue|null|undefined} orderId
                         * @memberof google.ads.googleads.v1.services.ClickConversion
                         * @instance
                         */
                        ClickConversion.prototype.orderId = null;

                        /**
                         * ClickConversion externalAttributionData.
                         * @member {google.ads.googleads.v1.services.IExternalAttributionData|null|undefined} externalAttributionData
                         * @memberof google.ads.googleads.v1.services.ClickConversion
                         * @instance
                         */
                        ClickConversion.prototype.externalAttributionData = null;

                        /**
                         * Creates a new ClickConversion instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ClickConversion
                         * @static
                         * @param {google.ads.googleads.v1.services.IClickConversion=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ClickConversion} ClickConversion instance
                         */
                        ClickConversion.create = function create(properties) {
                            return new ClickConversion(properties);
                        };

                        /**
                         * Encodes the specified ClickConversion message. Does not implicitly {@link google.ads.googleads.v1.services.ClickConversion.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ClickConversion
                         * @static
                         * @param {google.ads.googleads.v1.services.IClickConversion} message ClickConversion message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ClickConversion.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.gclid != null && message.hasOwnProperty("gclid"))
                                $root.google.protobuf.StringValue.encode(message.gclid, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                $root.google.protobuf.StringValue.encode(message.conversionAction, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.conversionDateTime != null && message.hasOwnProperty("conversionDateTime"))
                                $root.google.protobuf.StringValue.encode(message.conversionDateTime, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.conversionValue != null && message.hasOwnProperty("conversionValue"))
                                $root.google.protobuf.DoubleValue.encode(message.conversionValue, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode"))
                                $root.google.protobuf.StringValue.encode(message.currencyCode, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.orderId != null && message.hasOwnProperty("orderId"))
                                $root.google.protobuf.StringValue.encode(message.orderId, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.externalAttributionData != null && message.hasOwnProperty("externalAttributionData"))
                                $root.google.ads.googleads.v1.services.ExternalAttributionData.encode(message.externalAttributionData, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ClickConversion message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ClickConversion.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ClickConversion
                         * @static
                         * @param {google.ads.googleads.v1.services.IClickConversion} message ClickConversion message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ClickConversion.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ClickConversion message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ClickConversion
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ClickConversion} ClickConversion
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ClickConversion.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ClickConversion();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.gclid = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.conversionAction = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.conversionDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.conversionValue = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.currencyCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.orderId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.externalAttributionData = $root.google.ads.googleads.v1.services.ExternalAttributionData.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ClickConversion message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ClickConversion
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ClickConversion} ClickConversion
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ClickConversion.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ClickConversion message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ClickConversion
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ClickConversion.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.gclid != null && message.hasOwnProperty("gclid")) {
                                var error = $root.google.protobuf.StringValue.verify(message.gclid);
                                if (error)
                                    return "gclid." + error;
                            }
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction")) {
                                var error = $root.google.protobuf.StringValue.verify(message.conversionAction);
                                if (error)
                                    return "conversionAction." + error;
                            }
                            if (message.conversionDateTime != null && message.hasOwnProperty("conversionDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.conversionDateTime);
                                if (error)
                                    return "conversionDateTime." + error;
                            }
                            if (message.conversionValue != null && message.hasOwnProperty("conversionValue")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.conversionValue);
                                if (error)
                                    return "conversionValue." + error;
                            }
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.currencyCode);
                                if (error)
                                    return "currencyCode." + error;
                            }
                            if (message.orderId != null && message.hasOwnProperty("orderId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.orderId);
                                if (error)
                                    return "orderId." + error;
                            }
                            if (message.externalAttributionData != null && message.hasOwnProperty("externalAttributionData")) {
                                var error = $root.google.ads.googleads.v1.services.ExternalAttributionData.verify(message.externalAttributionData);
                                if (error)
                                    return "externalAttributionData." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a ClickConversion message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ClickConversion
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ClickConversion} ClickConversion
                         */
                        ClickConversion.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ClickConversion)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ClickConversion();
                            if (object.gclid != null) {
                                if (typeof object.gclid !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ClickConversion.gclid: object expected");
                                message.gclid = $root.google.protobuf.StringValue.fromObject(object.gclid);
                            }
                            if (object.conversionAction != null) {
                                if (typeof object.conversionAction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ClickConversion.conversionAction: object expected");
                                message.conversionAction = $root.google.protobuf.StringValue.fromObject(object.conversionAction);
                            }
                            if (object.conversionDateTime != null) {
                                if (typeof object.conversionDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ClickConversion.conversionDateTime: object expected");
                                message.conversionDateTime = $root.google.protobuf.StringValue.fromObject(object.conversionDateTime);
                            }
                            if (object.conversionValue != null) {
                                if (typeof object.conversionValue !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ClickConversion.conversionValue: object expected");
                                message.conversionValue = $root.google.protobuf.DoubleValue.fromObject(object.conversionValue);
                            }
                            if (object.currencyCode != null) {
                                if (typeof object.currencyCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ClickConversion.currencyCode: object expected");
                                message.currencyCode = $root.google.protobuf.StringValue.fromObject(object.currencyCode);
                            }
                            if (object.orderId != null) {
                                if (typeof object.orderId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ClickConversion.orderId: object expected");
                                message.orderId = $root.google.protobuf.StringValue.fromObject(object.orderId);
                            }
                            if (object.externalAttributionData != null) {
                                if (typeof object.externalAttributionData !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ClickConversion.externalAttributionData: object expected");
                                message.externalAttributionData = $root.google.ads.googleads.v1.services.ExternalAttributionData.fromObject(object.externalAttributionData);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ClickConversion message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ClickConversion
                         * @static
                         * @param {google.ads.googleads.v1.services.ClickConversion} message ClickConversion
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ClickConversion.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.gclid = null;
                                object.conversionAction = null;
                                object.conversionDateTime = null;
                                object.conversionValue = null;
                                object.currencyCode = null;
                                object.orderId = null;
                                object.externalAttributionData = null;
                            }
                            if (message.gclid != null && message.hasOwnProperty("gclid"))
                                object.gclid = $root.google.protobuf.StringValue.toObject(message.gclid, options);
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                object.conversionAction = $root.google.protobuf.StringValue.toObject(message.conversionAction, options);
                            if (message.conversionDateTime != null && message.hasOwnProperty("conversionDateTime"))
                                object.conversionDateTime = $root.google.protobuf.StringValue.toObject(message.conversionDateTime, options);
                            if (message.conversionValue != null && message.hasOwnProperty("conversionValue"))
                                object.conversionValue = $root.google.protobuf.DoubleValue.toObject(message.conversionValue, options);
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode"))
                                object.currencyCode = $root.google.protobuf.StringValue.toObject(message.currencyCode, options);
                            if (message.orderId != null && message.hasOwnProperty("orderId"))
                                object.orderId = $root.google.protobuf.StringValue.toObject(message.orderId, options);
                            if (message.externalAttributionData != null && message.hasOwnProperty("externalAttributionData"))
                                object.externalAttributionData = $root.google.ads.googleads.v1.services.ExternalAttributionData.toObject(message.externalAttributionData, options);
                            return object;
                        };

                        /**
                         * Converts this ClickConversion to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ClickConversion
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ClickConversion.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ClickConversion;
                    })();

                    services.CallConversion = (function() {

                        /**
                         * Properties of a CallConversion.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICallConversion
                         * @property {google.protobuf.IStringValue|null} [callerId] CallConversion callerId
                         * @property {google.protobuf.IStringValue|null} [callStartDateTime] CallConversion callStartDateTime
                         * @property {google.protobuf.IStringValue|null} [conversionAction] CallConversion conversionAction
                         * @property {google.protobuf.IStringValue|null} [conversionDateTime] CallConversion conversionDateTime
                         * @property {google.protobuf.IDoubleValue|null} [conversionValue] CallConversion conversionValue
                         * @property {google.protobuf.IStringValue|null} [currencyCode] CallConversion currencyCode
                         */

                        /**
                         * Constructs a new CallConversion.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CallConversion.
                         * @implements ICallConversion
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICallConversion=} [properties] Properties to set
                         */
                        function CallConversion(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CallConversion callerId.
                         * @member {google.protobuf.IStringValue|null|undefined} callerId
                         * @memberof google.ads.googleads.v1.services.CallConversion
                         * @instance
                         */
                        CallConversion.prototype.callerId = null;

                        /**
                         * CallConversion callStartDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} callStartDateTime
                         * @memberof google.ads.googleads.v1.services.CallConversion
                         * @instance
                         */
                        CallConversion.prototype.callStartDateTime = null;

                        /**
                         * CallConversion conversionAction.
                         * @member {google.protobuf.IStringValue|null|undefined} conversionAction
                         * @memberof google.ads.googleads.v1.services.CallConversion
                         * @instance
                         */
                        CallConversion.prototype.conversionAction = null;

                        /**
                         * CallConversion conversionDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} conversionDateTime
                         * @memberof google.ads.googleads.v1.services.CallConversion
                         * @instance
                         */
                        CallConversion.prototype.conversionDateTime = null;

                        /**
                         * CallConversion conversionValue.
                         * @member {google.protobuf.IDoubleValue|null|undefined} conversionValue
                         * @memberof google.ads.googleads.v1.services.CallConversion
                         * @instance
                         */
                        CallConversion.prototype.conversionValue = null;

                        /**
                         * CallConversion currencyCode.
                         * @member {google.protobuf.IStringValue|null|undefined} currencyCode
                         * @memberof google.ads.googleads.v1.services.CallConversion
                         * @instance
                         */
                        CallConversion.prototype.currencyCode = null;

                        /**
                         * Creates a new CallConversion instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CallConversion
                         * @static
                         * @param {google.ads.googleads.v1.services.ICallConversion=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CallConversion} CallConversion instance
                         */
                        CallConversion.create = function create(properties) {
                            return new CallConversion(properties);
                        };

                        /**
                         * Encodes the specified CallConversion message. Does not implicitly {@link google.ads.googleads.v1.services.CallConversion.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CallConversion
                         * @static
                         * @param {google.ads.googleads.v1.services.ICallConversion} message CallConversion message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CallConversion.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.callerId != null && message.hasOwnProperty("callerId"))
                                $root.google.protobuf.StringValue.encode(message.callerId, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.callStartDateTime != null && message.hasOwnProperty("callStartDateTime"))
                                $root.google.protobuf.StringValue.encode(message.callStartDateTime, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                $root.google.protobuf.StringValue.encode(message.conversionAction, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.conversionDateTime != null && message.hasOwnProperty("conversionDateTime"))
                                $root.google.protobuf.StringValue.encode(message.conversionDateTime, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.conversionValue != null && message.hasOwnProperty("conversionValue"))
                                $root.google.protobuf.DoubleValue.encode(message.conversionValue, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode"))
                                $root.google.protobuf.StringValue.encode(message.currencyCode, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CallConversion message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CallConversion.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CallConversion
                         * @static
                         * @param {google.ads.googleads.v1.services.ICallConversion} message CallConversion message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CallConversion.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CallConversion message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CallConversion
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CallConversion} CallConversion
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CallConversion.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CallConversion();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.callerId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.callStartDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.conversionAction = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.conversionDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.conversionValue = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.currencyCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CallConversion message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CallConversion
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CallConversion} CallConversion
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CallConversion.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CallConversion message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CallConversion
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CallConversion.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.callerId != null && message.hasOwnProperty("callerId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.callerId);
                                if (error)
                                    return "callerId." + error;
                            }
                            if (message.callStartDateTime != null && message.hasOwnProperty("callStartDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.callStartDateTime);
                                if (error)
                                    return "callStartDateTime." + error;
                            }
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction")) {
                                var error = $root.google.protobuf.StringValue.verify(message.conversionAction);
                                if (error)
                                    return "conversionAction." + error;
                            }
                            if (message.conversionDateTime != null && message.hasOwnProperty("conversionDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.conversionDateTime);
                                if (error)
                                    return "conversionDateTime." + error;
                            }
                            if (message.conversionValue != null && message.hasOwnProperty("conversionValue")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.conversionValue);
                                if (error)
                                    return "conversionValue." + error;
                            }
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.currencyCode);
                                if (error)
                                    return "currencyCode." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CallConversion message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CallConversion
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CallConversion} CallConversion
                         */
                        CallConversion.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CallConversion)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CallConversion();
                            if (object.callerId != null) {
                                if (typeof object.callerId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CallConversion.callerId: object expected");
                                message.callerId = $root.google.protobuf.StringValue.fromObject(object.callerId);
                            }
                            if (object.callStartDateTime != null) {
                                if (typeof object.callStartDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CallConversion.callStartDateTime: object expected");
                                message.callStartDateTime = $root.google.protobuf.StringValue.fromObject(object.callStartDateTime);
                            }
                            if (object.conversionAction != null) {
                                if (typeof object.conversionAction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CallConversion.conversionAction: object expected");
                                message.conversionAction = $root.google.protobuf.StringValue.fromObject(object.conversionAction);
                            }
                            if (object.conversionDateTime != null) {
                                if (typeof object.conversionDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CallConversion.conversionDateTime: object expected");
                                message.conversionDateTime = $root.google.protobuf.StringValue.fromObject(object.conversionDateTime);
                            }
                            if (object.conversionValue != null) {
                                if (typeof object.conversionValue !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CallConversion.conversionValue: object expected");
                                message.conversionValue = $root.google.protobuf.DoubleValue.fromObject(object.conversionValue);
                            }
                            if (object.currencyCode != null) {
                                if (typeof object.currencyCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CallConversion.currencyCode: object expected");
                                message.currencyCode = $root.google.protobuf.StringValue.fromObject(object.currencyCode);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CallConversion message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CallConversion
                         * @static
                         * @param {google.ads.googleads.v1.services.CallConversion} message CallConversion
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CallConversion.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.callerId = null;
                                object.callStartDateTime = null;
                                object.conversionAction = null;
                                object.conversionDateTime = null;
                                object.conversionValue = null;
                                object.currencyCode = null;
                            }
                            if (message.callerId != null && message.hasOwnProperty("callerId"))
                                object.callerId = $root.google.protobuf.StringValue.toObject(message.callerId, options);
                            if (message.callStartDateTime != null && message.hasOwnProperty("callStartDateTime"))
                                object.callStartDateTime = $root.google.protobuf.StringValue.toObject(message.callStartDateTime, options);
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                object.conversionAction = $root.google.protobuf.StringValue.toObject(message.conversionAction, options);
                            if (message.conversionDateTime != null && message.hasOwnProperty("conversionDateTime"))
                                object.conversionDateTime = $root.google.protobuf.StringValue.toObject(message.conversionDateTime, options);
                            if (message.conversionValue != null && message.hasOwnProperty("conversionValue"))
                                object.conversionValue = $root.google.protobuf.DoubleValue.toObject(message.conversionValue, options);
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode"))
                                object.currencyCode = $root.google.protobuf.StringValue.toObject(message.currencyCode, options);
                            return object;
                        };

                        /**
                         * Converts this CallConversion to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CallConversion
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CallConversion.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CallConversion;
                    })();

                    services.ExternalAttributionData = (function() {

                        /**
                         * Properties of an ExternalAttributionData.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IExternalAttributionData
                         * @property {google.protobuf.IDoubleValue|null} [externalAttributionCredit] ExternalAttributionData externalAttributionCredit
                         * @property {google.protobuf.IStringValue|null} [externalAttributionModel] ExternalAttributionData externalAttributionModel
                         */

                        /**
                         * Constructs a new ExternalAttributionData.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an ExternalAttributionData.
                         * @implements IExternalAttributionData
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IExternalAttributionData=} [properties] Properties to set
                         */
                        function ExternalAttributionData(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ExternalAttributionData externalAttributionCredit.
                         * @member {google.protobuf.IDoubleValue|null|undefined} externalAttributionCredit
                         * @memberof google.ads.googleads.v1.services.ExternalAttributionData
                         * @instance
                         */
                        ExternalAttributionData.prototype.externalAttributionCredit = null;

                        /**
                         * ExternalAttributionData externalAttributionModel.
                         * @member {google.protobuf.IStringValue|null|undefined} externalAttributionModel
                         * @memberof google.ads.googleads.v1.services.ExternalAttributionData
                         * @instance
                         */
                        ExternalAttributionData.prototype.externalAttributionModel = null;

                        /**
                         * Creates a new ExternalAttributionData instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ExternalAttributionData
                         * @static
                         * @param {google.ads.googleads.v1.services.IExternalAttributionData=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ExternalAttributionData} ExternalAttributionData instance
                         */
                        ExternalAttributionData.create = function create(properties) {
                            return new ExternalAttributionData(properties);
                        };

                        /**
                         * Encodes the specified ExternalAttributionData message. Does not implicitly {@link google.ads.googleads.v1.services.ExternalAttributionData.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ExternalAttributionData
                         * @static
                         * @param {google.ads.googleads.v1.services.IExternalAttributionData} message ExternalAttributionData message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExternalAttributionData.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.externalAttributionCredit != null && message.hasOwnProperty("externalAttributionCredit"))
                                $root.google.protobuf.DoubleValue.encode(message.externalAttributionCredit, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.externalAttributionModel != null && message.hasOwnProperty("externalAttributionModel"))
                                $root.google.protobuf.StringValue.encode(message.externalAttributionModel, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ExternalAttributionData message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ExternalAttributionData.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ExternalAttributionData
                         * @static
                         * @param {google.ads.googleads.v1.services.IExternalAttributionData} message ExternalAttributionData message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExternalAttributionData.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ExternalAttributionData message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ExternalAttributionData
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ExternalAttributionData} ExternalAttributionData
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExternalAttributionData.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ExternalAttributionData();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.externalAttributionCredit = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.externalAttributionModel = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ExternalAttributionData message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ExternalAttributionData
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ExternalAttributionData} ExternalAttributionData
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExternalAttributionData.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ExternalAttributionData message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ExternalAttributionData
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExternalAttributionData.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.externalAttributionCredit != null && message.hasOwnProperty("externalAttributionCredit")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.externalAttributionCredit);
                                if (error)
                                    return "externalAttributionCredit." + error;
                            }
                            if (message.externalAttributionModel != null && message.hasOwnProperty("externalAttributionModel")) {
                                var error = $root.google.protobuf.StringValue.verify(message.externalAttributionModel);
                                if (error)
                                    return "externalAttributionModel." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an ExternalAttributionData message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ExternalAttributionData
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ExternalAttributionData} ExternalAttributionData
                         */
                        ExternalAttributionData.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ExternalAttributionData)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ExternalAttributionData();
                            if (object.externalAttributionCredit != null) {
                                if (typeof object.externalAttributionCredit !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ExternalAttributionData.externalAttributionCredit: object expected");
                                message.externalAttributionCredit = $root.google.protobuf.DoubleValue.fromObject(object.externalAttributionCredit);
                            }
                            if (object.externalAttributionModel != null) {
                                if (typeof object.externalAttributionModel !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ExternalAttributionData.externalAttributionModel: object expected");
                                message.externalAttributionModel = $root.google.protobuf.StringValue.fromObject(object.externalAttributionModel);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an ExternalAttributionData message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ExternalAttributionData
                         * @static
                         * @param {google.ads.googleads.v1.services.ExternalAttributionData} message ExternalAttributionData
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExternalAttributionData.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.externalAttributionCredit = null;
                                object.externalAttributionModel = null;
                            }
                            if (message.externalAttributionCredit != null && message.hasOwnProperty("externalAttributionCredit"))
                                object.externalAttributionCredit = $root.google.protobuf.DoubleValue.toObject(message.externalAttributionCredit, options);
                            if (message.externalAttributionModel != null && message.hasOwnProperty("externalAttributionModel"))
                                object.externalAttributionModel = $root.google.protobuf.StringValue.toObject(message.externalAttributionModel, options);
                            return object;
                        };

                        /**
                         * Converts this ExternalAttributionData to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ExternalAttributionData
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExternalAttributionData.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ExternalAttributionData;
                    })();

                    services.ClickConversionResult = (function() {

                        /**
                         * Properties of a ClickConversionResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IClickConversionResult
                         * @property {google.protobuf.IStringValue|null} [gclid] ClickConversionResult gclid
                         * @property {google.protobuf.IStringValue|null} [conversionAction] ClickConversionResult conversionAction
                         * @property {google.protobuf.IStringValue|null} [conversionDateTime] ClickConversionResult conversionDateTime
                         */

                        /**
                         * Constructs a new ClickConversionResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ClickConversionResult.
                         * @implements IClickConversionResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IClickConversionResult=} [properties] Properties to set
                         */
                        function ClickConversionResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ClickConversionResult gclid.
                         * @member {google.protobuf.IStringValue|null|undefined} gclid
                         * @memberof google.ads.googleads.v1.services.ClickConversionResult
                         * @instance
                         */
                        ClickConversionResult.prototype.gclid = null;

                        /**
                         * ClickConversionResult conversionAction.
                         * @member {google.protobuf.IStringValue|null|undefined} conversionAction
                         * @memberof google.ads.googleads.v1.services.ClickConversionResult
                         * @instance
                         */
                        ClickConversionResult.prototype.conversionAction = null;

                        /**
                         * ClickConversionResult conversionDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} conversionDateTime
                         * @memberof google.ads.googleads.v1.services.ClickConversionResult
                         * @instance
                         */
                        ClickConversionResult.prototype.conversionDateTime = null;

                        /**
                         * Creates a new ClickConversionResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ClickConversionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IClickConversionResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ClickConversionResult} ClickConversionResult instance
                         */
                        ClickConversionResult.create = function create(properties) {
                            return new ClickConversionResult(properties);
                        };

                        /**
                         * Encodes the specified ClickConversionResult message. Does not implicitly {@link google.ads.googleads.v1.services.ClickConversionResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ClickConversionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IClickConversionResult} message ClickConversionResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ClickConversionResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.gclid != null && message.hasOwnProperty("gclid"))
                                $root.google.protobuf.StringValue.encode(message.gclid, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                $root.google.protobuf.StringValue.encode(message.conversionAction, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.conversionDateTime != null && message.hasOwnProperty("conversionDateTime"))
                                $root.google.protobuf.StringValue.encode(message.conversionDateTime, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ClickConversionResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ClickConversionResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ClickConversionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IClickConversionResult} message ClickConversionResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ClickConversionResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ClickConversionResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ClickConversionResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ClickConversionResult} ClickConversionResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ClickConversionResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ClickConversionResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.gclid = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.conversionAction = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.conversionDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ClickConversionResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ClickConversionResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ClickConversionResult} ClickConversionResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ClickConversionResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ClickConversionResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ClickConversionResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ClickConversionResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.gclid != null && message.hasOwnProperty("gclid")) {
                                var error = $root.google.protobuf.StringValue.verify(message.gclid);
                                if (error)
                                    return "gclid." + error;
                            }
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction")) {
                                var error = $root.google.protobuf.StringValue.verify(message.conversionAction);
                                if (error)
                                    return "conversionAction." + error;
                            }
                            if (message.conversionDateTime != null && message.hasOwnProperty("conversionDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.conversionDateTime);
                                if (error)
                                    return "conversionDateTime." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a ClickConversionResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ClickConversionResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ClickConversionResult} ClickConversionResult
                         */
                        ClickConversionResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ClickConversionResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ClickConversionResult();
                            if (object.gclid != null) {
                                if (typeof object.gclid !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ClickConversionResult.gclid: object expected");
                                message.gclid = $root.google.protobuf.StringValue.fromObject(object.gclid);
                            }
                            if (object.conversionAction != null) {
                                if (typeof object.conversionAction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ClickConversionResult.conversionAction: object expected");
                                message.conversionAction = $root.google.protobuf.StringValue.fromObject(object.conversionAction);
                            }
                            if (object.conversionDateTime != null) {
                                if (typeof object.conversionDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ClickConversionResult.conversionDateTime: object expected");
                                message.conversionDateTime = $root.google.protobuf.StringValue.fromObject(object.conversionDateTime);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ClickConversionResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ClickConversionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.ClickConversionResult} message ClickConversionResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ClickConversionResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.gclid = null;
                                object.conversionAction = null;
                                object.conversionDateTime = null;
                            }
                            if (message.gclid != null && message.hasOwnProperty("gclid"))
                                object.gclid = $root.google.protobuf.StringValue.toObject(message.gclid, options);
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                object.conversionAction = $root.google.protobuf.StringValue.toObject(message.conversionAction, options);
                            if (message.conversionDateTime != null && message.hasOwnProperty("conversionDateTime"))
                                object.conversionDateTime = $root.google.protobuf.StringValue.toObject(message.conversionDateTime, options);
                            return object;
                        };

                        /**
                         * Converts this ClickConversionResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ClickConversionResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ClickConversionResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ClickConversionResult;
                    })();

                    services.CallConversionResult = (function() {

                        /**
                         * Properties of a CallConversionResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICallConversionResult
                         * @property {google.protobuf.IStringValue|null} [callerId] CallConversionResult callerId
                         * @property {google.protobuf.IStringValue|null} [callStartDateTime] CallConversionResult callStartDateTime
                         * @property {google.protobuf.IStringValue|null} [conversionAction] CallConversionResult conversionAction
                         * @property {google.protobuf.IStringValue|null} [conversionDateTime] CallConversionResult conversionDateTime
                         */

                        /**
                         * Constructs a new CallConversionResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CallConversionResult.
                         * @implements ICallConversionResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICallConversionResult=} [properties] Properties to set
                         */
                        function CallConversionResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CallConversionResult callerId.
                         * @member {google.protobuf.IStringValue|null|undefined} callerId
                         * @memberof google.ads.googleads.v1.services.CallConversionResult
                         * @instance
                         */
                        CallConversionResult.prototype.callerId = null;

                        /**
                         * CallConversionResult callStartDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} callStartDateTime
                         * @memberof google.ads.googleads.v1.services.CallConversionResult
                         * @instance
                         */
                        CallConversionResult.prototype.callStartDateTime = null;

                        /**
                         * CallConversionResult conversionAction.
                         * @member {google.protobuf.IStringValue|null|undefined} conversionAction
                         * @memberof google.ads.googleads.v1.services.CallConversionResult
                         * @instance
                         */
                        CallConversionResult.prototype.conversionAction = null;

                        /**
                         * CallConversionResult conversionDateTime.
                         * @member {google.protobuf.IStringValue|null|undefined} conversionDateTime
                         * @memberof google.ads.googleads.v1.services.CallConversionResult
                         * @instance
                         */
                        CallConversionResult.prototype.conversionDateTime = null;

                        /**
                         * Creates a new CallConversionResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CallConversionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.ICallConversionResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CallConversionResult} CallConversionResult instance
                         */
                        CallConversionResult.create = function create(properties) {
                            return new CallConversionResult(properties);
                        };

                        /**
                         * Encodes the specified CallConversionResult message. Does not implicitly {@link google.ads.googleads.v1.services.CallConversionResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CallConversionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.ICallConversionResult} message CallConversionResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CallConversionResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.callerId != null && message.hasOwnProperty("callerId"))
                                $root.google.protobuf.StringValue.encode(message.callerId, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.callStartDateTime != null && message.hasOwnProperty("callStartDateTime"))
                                $root.google.protobuf.StringValue.encode(message.callStartDateTime, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                $root.google.protobuf.StringValue.encode(message.conversionAction, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.conversionDateTime != null && message.hasOwnProperty("conversionDateTime"))
                                $root.google.protobuf.StringValue.encode(message.conversionDateTime, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CallConversionResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CallConversionResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CallConversionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.ICallConversionResult} message CallConversionResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CallConversionResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CallConversionResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CallConversionResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CallConversionResult} CallConversionResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CallConversionResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CallConversionResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.callerId = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.callStartDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.conversionAction = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.conversionDateTime = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CallConversionResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CallConversionResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CallConversionResult} CallConversionResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CallConversionResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CallConversionResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CallConversionResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CallConversionResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.callerId != null && message.hasOwnProperty("callerId")) {
                                var error = $root.google.protobuf.StringValue.verify(message.callerId);
                                if (error)
                                    return "callerId." + error;
                            }
                            if (message.callStartDateTime != null && message.hasOwnProperty("callStartDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.callStartDateTime);
                                if (error)
                                    return "callStartDateTime." + error;
                            }
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction")) {
                                var error = $root.google.protobuf.StringValue.verify(message.conversionAction);
                                if (error)
                                    return "conversionAction." + error;
                            }
                            if (message.conversionDateTime != null && message.hasOwnProperty("conversionDateTime")) {
                                var error = $root.google.protobuf.StringValue.verify(message.conversionDateTime);
                                if (error)
                                    return "conversionDateTime." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CallConversionResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CallConversionResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CallConversionResult} CallConversionResult
                         */
                        CallConversionResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CallConversionResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CallConversionResult();
                            if (object.callerId != null) {
                                if (typeof object.callerId !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CallConversionResult.callerId: object expected");
                                message.callerId = $root.google.protobuf.StringValue.fromObject(object.callerId);
                            }
                            if (object.callStartDateTime != null) {
                                if (typeof object.callStartDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CallConversionResult.callStartDateTime: object expected");
                                message.callStartDateTime = $root.google.protobuf.StringValue.fromObject(object.callStartDateTime);
                            }
                            if (object.conversionAction != null) {
                                if (typeof object.conversionAction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CallConversionResult.conversionAction: object expected");
                                message.conversionAction = $root.google.protobuf.StringValue.fromObject(object.conversionAction);
                            }
                            if (object.conversionDateTime != null) {
                                if (typeof object.conversionDateTime !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CallConversionResult.conversionDateTime: object expected");
                                message.conversionDateTime = $root.google.protobuf.StringValue.fromObject(object.conversionDateTime);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CallConversionResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CallConversionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.CallConversionResult} message CallConversionResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CallConversionResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.callerId = null;
                                object.callStartDateTime = null;
                                object.conversionAction = null;
                                object.conversionDateTime = null;
                            }
                            if (message.callerId != null && message.hasOwnProperty("callerId"))
                                object.callerId = $root.google.protobuf.StringValue.toObject(message.callerId, options);
                            if (message.callStartDateTime != null && message.hasOwnProperty("callStartDateTime"))
                                object.callStartDateTime = $root.google.protobuf.StringValue.toObject(message.callStartDateTime, options);
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                object.conversionAction = $root.google.protobuf.StringValue.toObject(message.conversionAction, options);
                            if (message.conversionDateTime != null && message.hasOwnProperty("conversionDateTime"))
                                object.conversionDateTime = $root.google.protobuf.StringValue.toObject(message.conversionDateTime, options);
                            return object;
                        };

                        /**
                         * Converts this CallConversionResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CallConversionResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CallConversionResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CallConversionResult;
                    })();

                    services.CustomInterestService = (function() {

                        /**
                         * Constructs a new CustomInterestService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CustomInterestService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CustomInterestService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CustomInterestService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CustomInterestService;

                        /**
                         * Creates new CustomInterestService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CustomInterestService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CustomInterestService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CustomInterestService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomInterestService#getCustomInterest}.
                         * @memberof google.ads.googleads.v1.services.CustomInterestService
                         * @typedef GetCustomInterestCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.CustomInterest} [response] CustomInterest
                         */

                        /**
                         * Calls GetCustomInterest.
                         * @function getCustomInterest
                         * @memberof google.ads.googleads.v1.services.CustomInterestService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCustomInterestRequest} request GetCustomInterestRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomInterestService.GetCustomInterestCallback} callback Node-style callback called with the error, if any, and CustomInterest
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomInterestService.prototype.getCustomInterest = function getCustomInterest(request, callback) {
                            return this.rpcCall(getCustomInterest, $root.google.ads.googleads.v1.services.GetCustomInterestRequest, $root.google.ads.googleads.v1.resources.CustomInterest, request, callback);
                        }, "name", { value: "GetCustomInterest" });

                        /**
                         * Calls GetCustomInterest.
                         * @function getCustomInterest
                         * @memberof google.ads.googleads.v1.services.CustomInterestService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCustomInterestRequest} request GetCustomInterestRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.CustomInterest>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomInterestService#mutateCustomInterests}.
                         * @memberof google.ads.googleads.v1.services.CustomInterestService
                         * @typedef MutateCustomInterestsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateCustomInterestsResponse} [response] MutateCustomInterestsResponse
                         */

                        /**
                         * Calls MutateCustomInterests.
                         * @function mutateCustomInterests
                         * @memberof google.ads.googleads.v1.services.CustomInterestService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCustomInterestsRequest} request MutateCustomInterestsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomInterestService.MutateCustomInterestsCallback} callback Node-style callback called with the error, if any, and MutateCustomInterestsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomInterestService.prototype.mutateCustomInterests = function mutateCustomInterests(request, callback) {
                            return this.rpcCall(mutateCustomInterests, $root.google.ads.googleads.v1.services.MutateCustomInterestsRequest, $root.google.ads.googleads.v1.services.MutateCustomInterestsResponse, request, callback);
                        }, "name", { value: "MutateCustomInterests" });

                        /**
                         * Calls MutateCustomInterests.
                         * @function mutateCustomInterests
                         * @memberof google.ads.googleads.v1.services.CustomInterestService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCustomInterestsRequest} request MutateCustomInterestsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateCustomInterestsResponse>} Promise
                         * @variation 2
                         */

                        return CustomInterestService;
                    })();

                    services.GetCustomInterestRequest = (function() {

                        /**
                         * Properties of a GetCustomInterestRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCustomInterestRequest
                         * @property {string|null} [resourceName] GetCustomInterestRequest resourceName
                         */

                        /**
                         * Constructs a new GetCustomInterestRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCustomInterestRequest.
                         * @implements IGetCustomInterestRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCustomInterestRequest=} [properties] Properties to set
                         */
                        function GetCustomInterestRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCustomInterestRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCustomInterestRequest
                         * @instance
                         */
                        GetCustomInterestRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCustomInterestRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCustomInterestRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomInterestRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCustomInterestRequest} GetCustomInterestRequest instance
                         */
                        GetCustomInterestRequest.create = function create(properties) {
                            return new GetCustomInterestRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCustomInterestRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCustomInterestRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCustomInterestRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomInterestRequest} message GetCustomInterestRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomInterestRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCustomInterestRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCustomInterestRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCustomInterestRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomInterestRequest} message GetCustomInterestRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomInterestRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCustomInterestRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCustomInterestRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCustomInterestRequest} GetCustomInterestRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomInterestRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCustomInterestRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCustomInterestRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCustomInterestRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCustomInterestRequest} GetCustomInterestRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomInterestRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCustomInterestRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCustomInterestRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCustomInterestRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCustomInterestRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCustomInterestRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCustomInterestRequest} GetCustomInterestRequest
                         */
                        GetCustomInterestRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCustomInterestRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCustomInterestRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCustomInterestRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCustomInterestRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCustomInterestRequest} message GetCustomInterestRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCustomInterestRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCustomInterestRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCustomInterestRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCustomInterestRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCustomInterestRequest;
                    })();

                    services.MutateCustomInterestsRequest = (function() {

                        /**
                         * Properties of a MutateCustomInterestsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomInterestsRequest
                         * @property {string|null} [customerId] MutateCustomInterestsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.ICustomInterestOperation>|null} [operations] MutateCustomInterestsRequest operations
                         * @property {boolean|null} [validateOnly] MutateCustomInterestsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateCustomInterestsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomInterestsRequest.
                         * @implements IMutateCustomInterestsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomInterestsRequest=} [properties] Properties to set
                         */
                        function MutateCustomInterestsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomInterestsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsRequest
                         * @instance
                         */
                        MutateCustomInterestsRequest.prototype.customerId = "";

                        /**
                         * MutateCustomInterestsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.ICustomInterestOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsRequest
                         * @instance
                         */
                        MutateCustomInterestsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateCustomInterestsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsRequest
                         * @instance
                         */
                        MutateCustomInterestsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateCustomInterestsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomInterestsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomInterestsRequest} MutateCustomInterestsRequest instance
                         */
                        MutateCustomInterestsRequest.create = function create(properties) {
                            return new MutateCustomInterestsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomInterestsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomInterestsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomInterestsRequest} message MutateCustomInterestsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomInterestsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.CustomInterestOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomInterestsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomInterestsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomInterestsRequest} message MutateCustomInterestsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomInterestsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomInterestsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomInterestsRequest} MutateCustomInterestsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomInterestsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomInterestsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.CustomInterestOperation.decode(reader, reader.uint32()));
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomInterestsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomInterestsRequest} MutateCustomInterestsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomInterestsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomInterestsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomInterestsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.CustomInterestOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCustomInterestsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomInterestsRequest} MutateCustomInterestsRequest
                         */
                        MutateCustomInterestsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomInterestsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomInterestsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomInterestsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCustomInterestsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.CustomInterestOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomInterestsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomInterestsRequest} message MutateCustomInterestsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomInterestsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.CustomInterestOperation.toObject(message.operations[j], options);
                            }
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateCustomInterestsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomInterestsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomInterestsRequest;
                    })();

                    services.CustomInterestOperation = (function() {

                        /**
                         * Properties of a CustomInterestOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICustomInterestOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] CustomInterestOperation updateMask
                         * @property {google.ads.googleads.v1.resources.ICustomInterest|null} [create] CustomInterestOperation create
                         * @property {google.ads.googleads.v1.resources.ICustomInterest|null} [update] CustomInterestOperation update
                         */

                        /**
                         * Constructs a new CustomInterestOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CustomInterestOperation.
                         * @implements ICustomInterestOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICustomInterestOperation=} [properties] Properties to set
                         */
                        function CustomInterestOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomInterestOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.CustomInterestOperation
                         * @instance
                         */
                        CustomInterestOperation.prototype.updateMask = null;

                        /**
                         * CustomInterestOperation create.
                         * @member {google.ads.googleads.v1.resources.ICustomInterest|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.CustomInterestOperation
                         * @instance
                         */
                        CustomInterestOperation.prototype.create = null;

                        /**
                         * CustomInterestOperation update.
                         * @member {google.ads.googleads.v1.resources.ICustomInterest|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.CustomInterestOperation
                         * @instance
                         */
                        CustomInterestOperation.prototype.update = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CustomInterestOperation operation.
                         * @member {"create"|"update"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.CustomInterestOperation
                         * @instance
                         */
                        Object.defineProperty(CustomInterestOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CustomInterestOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CustomInterestOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomInterestOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CustomInterestOperation} CustomInterestOperation instance
                         */
                        CustomInterestOperation.create = function create(properties) {
                            return new CustomInterestOperation(properties);
                        };

                        /**
                         * Encodes the specified CustomInterestOperation message. Does not implicitly {@link google.ads.googleads.v1.services.CustomInterestOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CustomInterestOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomInterestOperation} message CustomInterestOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomInterestOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.CustomInterest.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.CustomInterest.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomInterestOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CustomInterestOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CustomInterestOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomInterestOperation} message CustomInterestOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomInterestOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomInterestOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CustomInterestOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CustomInterestOperation} CustomInterestOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomInterestOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CustomInterestOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.CustomInterest.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.CustomInterest.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomInterestOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CustomInterestOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CustomInterestOperation} CustomInterestOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomInterestOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomInterestOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CustomInterestOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomInterestOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CustomInterest.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CustomInterest.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a CustomInterestOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CustomInterestOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CustomInterestOperation} CustomInterestOperation
                         */
                        CustomInterestOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CustomInterestOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CustomInterestOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CustomInterestOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CustomInterestOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.CustomInterest.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CustomInterestOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.CustomInterest.fromObject(object.update);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomInterestOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CustomInterestOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.CustomInterestOperation} message CustomInterestOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomInterestOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.CustomInterest.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.CustomInterest.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this CustomInterestOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CustomInterestOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomInterestOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomInterestOperation;
                    })();

                    services.MutateCustomInterestsResponse = (function() {

                        /**
                         * Properties of a MutateCustomInterestsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomInterestsResponse
                         * @property {Array.<google.ads.googleads.v1.services.IMutateCustomInterestResult>|null} [results] MutateCustomInterestsResponse results
                         */

                        /**
                         * Constructs a new MutateCustomInterestsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomInterestsResponse.
                         * @implements IMutateCustomInterestsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomInterestsResponse=} [properties] Properties to set
                         */
                        function MutateCustomInterestsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomInterestsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateCustomInterestResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsResponse
                         * @instance
                         */
                        MutateCustomInterestsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateCustomInterestsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomInterestsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomInterestsResponse} MutateCustomInterestsResponse instance
                         */
                        MutateCustomInterestsResponse.create = function create(properties) {
                            return new MutateCustomInterestsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomInterestsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomInterestsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomInterestsResponse} message MutateCustomInterestsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomInterestsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateCustomInterestResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomInterestsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomInterestsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomInterestsResponse} message MutateCustomInterestsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomInterestsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomInterestsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomInterestsResponse} MutateCustomInterestsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomInterestsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomInterestsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateCustomInterestResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomInterestsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomInterestsResponse} MutateCustomInterestsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomInterestsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomInterestsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomInterestsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateCustomInterestResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateCustomInterestsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomInterestsResponse} MutateCustomInterestsResponse
                         */
                        MutateCustomInterestsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomInterestsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomInterestsResponse();
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomInterestsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCustomInterestsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateCustomInterestResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomInterestsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomInterestsResponse} message MutateCustomInterestsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomInterestsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateCustomInterestResult.toObject(message.results[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this MutateCustomInterestsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomInterestsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomInterestsResponse;
                    })();

                    services.MutateCustomInterestResult = (function() {

                        /**
                         * Properties of a MutateCustomInterestResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomInterestResult
                         * @property {string|null} [resourceName] MutateCustomInterestResult resourceName
                         */

                        /**
                         * Constructs a new MutateCustomInterestResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomInterestResult.
                         * @implements IMutateCustomInterestResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomInterestResult=} [properties] Properties to set
                         */
                        function MutateCustomInterestResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomInterestResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestResult
                         * @instance
                         */
                        MutateCustomInterestResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateCustomInterestResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomInterestResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomInterestResult} MutateCustomInterestResult instance
                         */
                        MutateCustomInterestResult.create = function create(properties) {
                            return new MutateCustomInterestResult(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomInterestResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomInterestResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomInterestResult} message MutateCustomInterestResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomInterestResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomInterestResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomInterestResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomInterestResult} message MutateCustomInterestResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomInterestResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomInterestResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomInterestResult} MutateCustomInterestResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomInterestResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomInterestResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomInterestResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomInterestResult} MutateCustomInterestResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomInterestResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomInterestResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomInterestResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCustomInterestResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomInterestResult} MutateCustomInterestResult
                         */
                        MutateCustomInterestResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomInterestResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomInterestResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomInterestResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomInterestResult} message MutateCustomInterestResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomInterestResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateCustomInterestResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomInterestResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomInterestResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomInterestResult;
                    })();

                    services.CustomerClientLinkService = (function() {

                        /**
                         * Constructs a new CustomerClientLinkService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CustomerClientLinkService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CustomerClientLinkService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CustomerClientLinkService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CustomerClientLinkService;

                        /**
                         * Creates new CustomerClientLinkService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CustomerClientLinkService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CustomerClientLinkService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomerClientLinkService#getCustomerClientLink}.
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkService
                         * @typedef GetCustomerClientLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.CustomerClientLink} [response] CustomerClientLink
                         */

                        /**
                         * Calls GetCustomerClientLink.
                         * @function getCustomerClientLink
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCustomerClientLinkRequest} request GetCustomerClientLinkRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomerClientLinkService.GetCustomerClientLinkCallback} callback Node-style callback called with the error, if any, and CustomerClientLink
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomerClientLinkService.prototype.getCustomerClientLink = function getCustomerClientLink(request, callback) {
                            return this.rpcCall(getCustomerClientLink, $root.google.ads.googleads.v1.services.GetCustomerClientLinkRequest, $root.google.ads.googleads.v1.resources.CustomerClientLink, request, callback);
                        }, "name", { value: "GetCustomerClientLink" });

                        /**
                         * Calls GetCustomerClientLink.
                         * @function getCustomerClientLink
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCustomerClientLinkRequest} request GetCustomerClientLinkRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.CustomerClientLink>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomerClientLinkService#mutateCustomerClientLink}.
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkService
                         * @typedef MutateCustomerClientLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateCustomerClientLinkResponse} [response] MutateCustomerClientLinkResponse
                         */

                        /**
                         * Calls MutateCustomerClientLink.
                         * @function mutateCustomerClientLink
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCustomerClientLinkRequest} request MutateCustomerClientLinkRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomerClientLinkService.MutateCustomerClientLinkCallback} callback Node-style callback called with the error, if any, and MutateCustomerClientLinkResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomerClientLinkService.prototype.mutateCustomerClientLink = function mutateCustomerClientLink(request, callback) {
                            return this.rpcCall(mutateCustomerClientLink, $root.google.ads.googleads.v1.services.MutateCustomerClientLinkRequest, $root.google.ads.googleads.v1.services.MutateCustomerClientLinkResponse, request, callback);
                        }, "name", { value: "MutateCustomerClientLink" });

                        /**
                         * Calls MutateCustomerClientLink.
                         * @function mutateCustomerClientLink
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCustomerClientLinkRequest} request MutateCustomerClientLinkRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateCustomerClientLinkResponse>} Promise
                         * @variation 2
                         */

                        return CustomerClientLinkService;
                    })();

                    services.GetCustomerClientLinkRequest = (function() {

                        /**
                         * Properties of a GetCustomerClientLinkRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCustomerClientLinkRequest
                         * @property {string|null} [resourceName] GetCustomerClientLinkRequest resourceName
                         */

                        /**
                         * Constructs a new GetCustomerClientLinkRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCustomerClientLinkRequest.
                         * @implements IGetCustomerClientLinkRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCustomerClientLinkRequest=} [properties] Properties to set
                         */
                        function GetCustomerClientLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCustomerClientLinkRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientLinkRequest
                         * @instance
                         */
                        GetCustomerClientLinkRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCustomerClientLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerClientLinkRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCustomerClientLinkRequest} GetCustomerClientLinkRequest instance
                         */
                        GetCustomerClientLinkRequest.create = function create(properties) {
                            return new GetCustomerClientLinkRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCustomerClientLinkRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCustomerClientLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerClientLinkRequest} message GetCustomerClientLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomerClientLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCustomerClientLinkRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCustomerClientLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerClientLinkRequest} message GetCustomerClientLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomerClientLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCustomerClientLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCustomerClientLinkRequest} GetCustomerClientLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomerClientLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCustomerClientLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCustomerClientLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCustomerClientLinkRequest} GetCustomerClientLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomerClientLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCustomerClientLinkRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCustomerClientLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCustomerClientLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCustomerClientLinkRequest} GetCustomerClientLinkRequest
                         */
                        GetCustomerClientLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCustomerClientLinkRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCustomerClientLinkRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCustomerClientLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCustomerClientLinkRequest} message GetCustomerClientLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCustomerClientLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCustomerClientLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCustomerClientLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCustomerClientLinkRequest;
                    })();

                    services.MutateCustomerClientLinkRequest = (function() {

                        /**
                         * Properties of a MutateCustomerClientLinkRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerClientLinkRequest
                         * @property {string|null} [customerId] MutateCustomerClientLinkRequest customerId
                         * @property {google.ads.googleads.v1.services.ICustomerClientLinkOperation|null} [operation] MutateCustomerClientLinkRequest operation
                         */

                        /**
                         * Constructs a new MutateCustomerClientLinkRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerClientLinkRequest.
                         * @implements IMutateCustomerClientLinkRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerClientLinkRequest=} [properties] Properties to set
                         */
                        function MutateCustomerClientLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerClientLinkRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkRequest
                         * @instance
                         */
                        MutateCustomerClientLinkRequest.prototype.customerId = "";

                        /**
                         * MutateCustomerClientLinkRequest operation.
                         * @member {google.ads.googleads.v1.services.ICustomerClientLinkOperation|null|undefined} operation
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkRequest
                         * @instance
                         */
                        MutateCustomerClientLinkRequest.prototype.operation = null;

                        /**
                         * Creates a new MutateCustomerClientLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerClientLinkRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerClientLinkRequest} MutateCustomerClientLinkRequest instance
                         */
                        MutateCustomerClientLinkRequest.create = function create(properties) {
                            return new MutateCustomerClientLinkRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerClientLinkRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerClientLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerClientLinkRequest} message MutateCustomerClientLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerClientLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                $root.google.ads.googleads.v1.services.CustomerClientLinkOperation.encode(message.operation, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerClientLinkRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerClientLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerClientLinkRequest} message MutateCustomerClientLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerClientLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerClientLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerClientLinkRequest} MutateCustomerClientLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerClientLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerClientLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    message.operation = $root.google.ads.googleads.v1.services.CustomerClientLinkOperation.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerClientLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerClientLinkRequest} MutateCustomerClientLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerClientLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerClientLinkRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerClientLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operation != null && message.hasOwnProperty("operation")) {
                                var error = $root.google.ads.googleads.v1.services.CustomerClientLinkOperation.verify(message.operation);
                                if (error)
                                    return "operation." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerClientLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerClientLinkRequest} MutateCustomerClientLinkRequest
                         */
                        MutateCustomerClientLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerClientLinkRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerClientLinkRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operation != null) {
                                if (typeof object.operation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomerClientLinkRequest.operation: object expected");
                                message.operation = $root.google.ads.googleads.v1.services.CustomerClientLinkOperation.fromObject(object.operation);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerClientLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerClientLinkRequest} message MutateCustomerClientLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerClientLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.customerId = "";
                                object.operation = null;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = $root.google.ads.googleads.v1.services.CustomerClientLinkOperation.toObject(message.operation, options);
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerClientLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerClientLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerClientLinkRequest;
                    })();

                    services.CustomerClientLinkOperation = (function() {

                        /**
                         * Properties of a CustomerClientLinkOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICustomerClientLinkOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] CustomerClientLinkOperation updateMask
                         * @property {google.ads.googleads.v1.resources.ICustomerClientLink|null} [create] CustomerClientLinkOperation create
                         * @property {google.ads.googleads.v1.resources.ICustomerClientLink|null} [update] CustomerClientLinkOperation update
                         */

                        /**
                         * Constructs a new CustomerClientLinkOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CustomerClientLinkOperation.
                         * @implements ICustomerClientLinkOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICustomerClientLinkOperation=} [properties] Properties to set
                         */
                        function CustomerClientLinkOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomerClientLinkOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkOperation
                         * @instance
                         */
                        CustomerClientLinkOperation.prototype.updateMask = null;

                        /**
                         * CustomerClientLinkOperation create.
                         * @member {google.ads.googleads.v1.resources.ICustomerClientLink|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkOperation
                         * @instance
                         */
                        CustomerClientLinkOperation.prototype.create = null;

                        /**
                         * CustomerClientLinkOperation update.
                         * @member {google.ads.googleads.v1.resources.ICustomerClientLink|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkOperation
                         * @instance
                         */
                        CustomerClientLinkOperation.prototype.update = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CustomerClientLinkOperation operation.
                         * @member {"create"|"update"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkOperation
                         * @instance
                         */
                        Object.defineProperty(CustomerClientLinkOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CustomerClientLinkOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerClientLinkOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CustomerClientLinkOperation} CustomerClientLinkOperation instance
                         */
                        CustomerClientLinkOperation.create = function create(properties) {
                            return new CustomerClientLinkOperation(properties);
                        };

                        /**
                         * Encodes the specified CustomerClientLinkOperation message. Does not implicitly {@link google.ads.googleads.v1.services.CustomerClientLinkOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerClientLinkOperation} message CustomerClientLinkOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerClientLinkOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.CustomerClientLink.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.CustomerClientLink.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerClientLinkOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CustomerClientLinkOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerClientLinkOperation} message CustomerClientLinkOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerClientLinkOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerClientLinkOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CustomerClientLinkOperation} CustomerClientLinkOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerClientLinkOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CustomerClientLinkOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.CustomerClientLink.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.CustomerClientLink.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerClientLinkOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CustomerClientLinkOperation} CustomerClientLinkOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerClientLinkOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerClientLinkOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerClientLinkOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CustomerClientLink.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CustomerClientLink.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a CustomerClientLinkOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CustomerClientLinkOperation} CustomerClientLinkOperation
                         */
                        CustomerClientLinkOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CustomerClientLinkOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CustomerClientLinkOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CustomerClientLinkOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CustomerClientLinkOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.CustomerClientLink.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CustomerClientLinkOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.CustomerClientLink.fromObject(object.update);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomerClientLinkOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.CustomerClientLinkOperation} message CustomerClientLinkOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerClientLinkOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.CustomerClientLink.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.CustomerClientLink.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this CustomerClientLinkOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CustomerClientLinkOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerClientLinkOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomerClientLinkOperation;
                    })();

                    services.MutateCustomerClientLinkResponse = (function() {

                        /**
                         * Properties of a MutateCustomerClientLinkResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerClientLinkResponse
                         * @property {google.ads.googleads.v1.services.IMutateCustomerClientLinkResult|null} [result] MutateCustomerClientLinkResponse result
                         */

                        /**
                         * Constructs a new MutateCustomerClientLinkResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerClientLinkResponse.
                         * @implements IMutateCustomerClientLinkResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerClientLinkResponse=} [properties] Properties to set
                         */
                        function MutateCustomerClientLinkResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerClientLinkResponse result.
                         * @member {google.ads.googleads.v1.services.IMutateCustomerClientLinkResult|null|undefined} result
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResponse
                         * @instance
                         */
                        MutateCustomerClientLinkResponse.prototype.result = null;

                        /**
                         * Creates a new MutateCustomerClientLinkResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerClientLinkResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerClientLinkResponse} MutateCustomerClientLinkResponse instance
                         */
                        MutateCustomerClientLinkResponse.create = function create(properties) {
                            return new MutateCustomerClientLinkResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerClientLinkResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerClientLinkResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerClientLinkResponse} message MutateCustomerClientLinkResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerClientLinkResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.result != null && message.hasOwnProperty("result"))
                                $root.google.ads.googleads.v1.services.MutateCustomerClientLinkResult.encode(message.result, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerClientLinkResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerClientLinkResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerClientLinkResponse} message MutateCustomerClientLinkResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerClientLinkResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerClientLinkResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerClientLinkResponse} MutateCustomerClientLinkResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerClientLinkResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerClientLinkResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.result = $root.google.ads.googleads.v1.services.MutateCustomerClientLinkResult.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerClientLinkResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerClientLinkResponse} MutateCustomerClientLinkResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerClientLinkResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerClientLinkResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerClientLinkResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.result != null && message.hasOwnProperty("result")) {
                                var error = $root.google.ads.googleads.v1.services.MutateCustomerClientLinkResult.verify(message.result);
                                if (error)
                                    return "result." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerClientLinkResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerClientLinkResponse} MutateCustomerClientLinkResponse
                         */
                        MutateCustomerClientLinkResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerClientLinkResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerClientLinkResponse();
                            if (object.result != null) {
                                if (typeof object.result !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomerClientLinkResponse.result: object expected");
                                message.result = $root.google.ads.googleads.v1.services.MutateCustomerClientLinkResult.fromObject(object.result);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerClientLinkResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerClientLinkResponse} message MutateCustomerClientLinkResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerClientLinkResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.result = null;
                            if (message.result != null && message.hasOwnProperty("result"))
                                object.result = $root.google.ads.googleads.v1.services.MutateCustomerClientLinkResult.toObject(message.result, options);
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerClientLinkResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerClientLinkResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerClientLinkResponse;
                    })();

                    services.MutateCustomerClientLinkResult = (function() {

                        /**
                         * Properties of a MutateCustomerClientLinkResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerClientLinkResult
                         * @property {string|null} [resourceName] MutateCustomerClientLinkResult resourceName
                         */

                        /**
                         * Constructs a new MutateCustomerClientLinkResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerClientLinkResult.
                         * @implements IMutateCustomerClientLinkResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerClientLinkResult=} [properties] Properties to set
                         */
                        function MutateCustomerClientLinkResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerClientLinkResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResult
                         * @instance
                         */
                        MutateCustomerClientLinkResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateCustomerClientLinkResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerClientLinkResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerClientLinkResult} MutateCustomerClientLinkResult instance
                         */
                        MutateCustomerClientLinkResult.create = function create(properties) {
                            return new MutateCustomerClientLinkResult(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerClientLinkResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerClientLinkResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerClientLinkResult} message MutateCustomerClientLinkResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerClientLinkResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerClientLinkResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerClientLinkResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerClientLinkResult} message MutateCustomerClientLinkResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerClientLinkResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerClientLinkResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerClientLinkResult} MutateCustomerClientLinkResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerClientLinkResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerClientLinkResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerClientLinkResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerClientLinkResult} MutateCustomerClientLinkResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerClientLinkResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerClientLinkResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerClientLinkResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerClientLinkResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerClientLinkResult} MutateCustomerClientLinkResult
                         */
                        MutateCustomerClientLinkResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerClientLinkResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerClientLinkResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerClientLinkResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerClientLinkResult} message MutateCustomerClientLinkResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerClientLinkResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerClientLinkResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerClientLinkResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerClientLinkResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerClientLinkResult;
                    })();

                    services.CustomerClientService = (function() {

                        /**
                         * Constructs a new CustomerClientService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CustomerClientService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CustomerClientService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CustomerClientService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CustomerClientService;

                        /**
                         * Creates new CustomerClientService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CustomerClientService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CustomerClientService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CustomerClientService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomerClientService#getCustomerClient}.
                         * @memberof google.ads.googleads.v1.services.CustomerClientService
                         * @typedef GetCustomerClientCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.CustomerClient} [response] CustomerClient
                         */

                        /**
                         * Calls GetCustomerClient.
                         * @function getCustomerClient
                         * @memberof google.ads.googleads.v1.services.CustomerClientService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCustomerClientRequest} request GetCustomerClientRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomerClientService.GetCustomerClientCallback} callback Node-style callback called with the error, if any, and CustomerClient
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomerClientService.prototype.getCustomerClient = function getCustomerClient(request, callback) {
                            return this.rpcCall(getCustomerClient, $root.google.ads.googleads.v1.services.GetCustomerClientRequest, $root.google.ads.googleads.v1.resources.CustomerClient, request, callback);
                        }, "name", { value: "GetCustomerClient" });

                        /**
                         * Calls GetCustomerClient.
                         * @function getCustomerClient
                         * @memberof google.ads.googleads.v1.services.CustomerClientService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCustomerClientRequest} request GetCustomerClientRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.CustomerClient>} Promise
                         * @variation 2
                         */

                        return CustomerClientService;
                    })();

                    services.GetCustomerClientRequest = (function() {

                        /**
                         * Properties of a GetCustomerClientRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCustomerClientRequest
                         * @property {string|null} [resourceName] GetCustomerClientRequest resourceName
                         */

                        /**
                         * Constructs a new GetCustomerClientRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCustomerClientRequest.
                         * @implements IGetCustomerClientRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCustomerClientRequest=} [properties] Properties to set
                         */
                        function GetCustomerClientRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCustomerClientRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientRequest
                         * @instance
                         */
                        GetCustomerClientRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCustomerClientRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerClientRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCustomerClientRequest} GetCustomerClientRequest instance
                         */
                        GetCustomerClientRequest.create = function create(properties) {
                            return new GetCustomerClientRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCustomerClientRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCustomerClientRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerClientRequest} message GetCustomerClientRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomerClientRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCustomerClientRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCustomerClientRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerClientRequest} message GetCustomerClientRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomerClientRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCustomerClientRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCustomerClientRequest} GetCustomerClientRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomerClientRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCustomerClientRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCustomerClientRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCustomerClientRequest} GetCustomerClientRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomerClientRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCustomerClientRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCustomerClientRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCustomerClientRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCustomerClientRequest} GetCustomerClientRequest
                         */
                        GetCustomerClientRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCustomerClientRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCustomerClientRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCustomerClientRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCustomerClientRequest} message GetCustomerClientRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCustomerClientRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCustomerClientRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCustomerClientRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCustomerClientRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCustomerClientRequest;
                    })();

                    services.CustomerExtensionSettingService = (function() {

                        /**
                         * Constructs a new CustomerExtensionSettingService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CustomerExtensionSettingService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CustomerExtensionSettingService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CustomerExtensionSettingService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CustomerExtensionSettingService;

                        /**
                         * Creates new CustomerExtensionSettingService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CustomerExtensionSettingService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CustomerExtensionSettingService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomerExtensionSettingService#getCustomerExtensionSetting}.
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingService
                         * @typedef GetCustomerExtensionSettingCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.CustomerExtensionSetting} [response] CustomerExtensionSetting
                         */

                        /**
                         * Calls GetCustomerExtensionSetting.
                         * @function getCustomerExtensionSetting
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCustomerExtensionSettingRequest} request GetCustomerExtensionSettingRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomerExtensionSettingService.GetCustomerExtensionSettingCallback} callback Node-style callback called with the error, if any, and CustomerExtensionSetting
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomerExtensionSettingService.prototype.getCustomerExtensionSetting = function getCustomerExtensionSetting(request, callback) {
                            return this.rpcCall(getCustomerExtensionSetting, $root.google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest, $root.google.ads.googleads.v1.resources.CustomerExtensionSetting, request, callback);
                        }, "name", { value: "GetCustomerExtensionSetting" });

                        /**
                         * Calls GetCustomerExtensionSetting.
                         * @function getCustomerExtensionSetting
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCustomerExtensionSettingRequest} request GetCustomerExtensionSettingRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.CustomerExtensionSetting>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomerExtensionSettingService#mutateCustomerExtensionSettings}.
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingService
                         * @typedef MutateCustomerExtensionSettingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse} [response] MutateCustomerExtensionSettingsResponse
                         */

                        /**
                         * Calls MutateCustomerExtensionSettings.
                         * @function mutateCustomerExtensionSettings
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCustomerExtensionSettingsRequest} request MutateCustomerExtensionSettingsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomerExtensionSettingService.MutateCustomerExtensionSettingsCallback} callback Node-style callback called with the error, if any, and MutateCustomerExtensionSettingsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomerExtensionSettingService.prototype.mutateCustomerExtensionSettings = function mutateCustomerExtensionSettings(request, callback) {
                            return this.rpcCall(mutateCustomerExtensionSettings, $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest, $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse, request, callback);
                        }, "name", { value: "MutateCustomerExtensionSettings" });

                        /**
                         * Calls MutateCustomerExtensionSettings.
                         * @function mutateCustomerExtensionSettings
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCustomerExtensionSettingsRequest} request MutateCustomerExtensionSettingsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse>} Promise
                         * @variation 2
                         */

                        return CustomerExtensionSettingService;
                    })();

                    services.GetCustomerExtensionSettingRequest = (function() {

                        /**
                         * Properties of a GetCustomerExtensionSettingRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCustomerExtensionSettingRequest
                         * @property {string|null} [resourceName] GetCustomerExtensionSettingRequest resourceName
                         */

                        /**
                         * Constructs a new GetCustomerExtensionSettingRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCustomerExtensionSettingRequest.
                         * @implements IGetCustomerExtensionSettingRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCustomerExtensionSettingRequest=} [properties] Properties to set
                         */
                        function GetCustomerExtensionSettingRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCustomerExtensionSettingRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest
                         * @instance
                         */
                        GetCustomerExtensionSettingRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCustomerExtensionSettingRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerExtensionSettingRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest} GetCustomerExtensionSettingRequest instance
                         */
                        GetCustomerExtensionSettingRequest.create = function create(properties) {
                            return new GetCustomerExtensionSettingRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCustomerExtensionSettingRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerExtensionSettingRequest} message GetCustomerExtensionSettingRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomerExtensionSettingRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCustomerExtensionSettingRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerExtensionSettingRequest} message GetCustomerExtensionSettingRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomerExtensionSettingRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCustomerExtensionSettingRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest} GetCustomerExtensionSettingRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomerExtensionSettingRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCustomerExtensionSettingRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest} GetCustomerExtensionSettingRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomerExtensionSettingRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCustomerExtensionSettingRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCustomerExtensionSettingRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCustomerExtensionSettingRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest} GetCustomerExtensionSettingRequest
                         */
                        GetCustomerExtensionSettingRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCustomerExtensionSettingRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest} message GetCustomerExtensionSettingRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCustomerExtensionSettingRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCustomerExtensionSettingRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCustomerExtensionSettingRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCustomerExtensionSettingRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCustomerExtensionSettingRequest;
                    })();

                    services.MutateCustomerExtensionSettingsRequest = (function() {

                        /**
                         * Properties of a MutateCustomerExtensionSettingsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerExtensionSettingsRequest
                         * @property {string|null} [customerId] MutateCustomerExtensionSettingsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.ICustomerExtensionSettingOperation>|null} [operations] MutateCustomerExtensionSettingsRequest operations
                         * @property {boolean|null} [partialFailure] MutateCustomerExtensionSettingsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateCustomerExtensionSettingsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateCustomerExtensionSettingsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerExtensionSettingsRequest.
                         * @implements IMutateCustomerExtensionSettingsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerExtensionSettingsRequest=} [properties] Properties to set
                         */
                        function MutateCustomerExtensionSettingsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerExtensionSettingsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest
                         * @instance
                         */
                        MutateCustomerExtensionSettingsRequest.prototype.customerId = "";

                        /**
                         * MutateCustomerExtensionSettingsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.ICustomerExtensionSettingOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest
                         * @instance
                         */
                        MutateCustomerExtensionSettingsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateCustomerExtensionSettingsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest
                         * @instance
                         */
                        MutateCustomerExtensionSettingsRequest.prototype.partialFailure = false;

                        /**
                         * MutateCustomerExtensionSettingsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest
                         * @instance
                         */
                        MutateCustomerExtensionSettingsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateCustomerExtensionSettingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerExtensionSettingsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest} MutateCustomerExtensionSettingsRequest instance
                         */
                        MutateCustomerExtensionSettingsRequest.create = function create(properties) {
                            return new MutateCustomerExtensionSettingsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerExtensionSettingsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerExtensionSettingsRequest} message MutateCustomerExtensionSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerExtensionSettingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.CustomerExtensionSettingOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerExtensionSettingsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerExtensionSettingsRequest} message MutateCustomerExtensionSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerExtensionSettingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerExtensionSettingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest} MutateCustomerExtensionSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerExtensionSettingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.CustomerExtensionSettingOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerExtensionSettingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest} MutateCustomerExtensionSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerExtensionSettingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerExtensionSettingsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerExtensionSettingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.CustomerExtensionSettingOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerExtensionSettingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest} MutateCustomerExtensionSettingsRequest
                         */
                        MutateCustomerExtensionSettingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.CustomerExtensionSettingOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerExtensionSettingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest} message MutateCustomerExtensionSettingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerExtensionSettingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.CustomerExtensionSettingOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerExtensionSettingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerExtensionSettingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerExtensionSettingsRequest;
                    })();

                    services.CustomerExtensionSettingOperation = (function() {

                        /**
                         * Properties of a CustomerExtensionSettingOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICustomerExtensionSettingOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] CustomerExtensionSettingOperation updateMask
                         * @property {google.ads.googleads.v1.resources.ICustomerExtensionSetting|null} [create] CustomerExtensionSettingOperation create
                         * @property {google.ads.googleads.v1.resources.ICustomerExtensionSetting|null} [update] CustomerExtensionSettingOperation update
                         * @property {string|null} [remove] CustomerExtensionSettingOperation remove
                         */

                        /**
                         * Constructs a new CustomerExtensionSettingOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CustomerExtensionSettingOperation.
                         * @implements ICustomerExtensionSettingOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICustomerExtensionSettingOperation=} [properties] Properties to set
                         */
                        function CustomerExtensionSettingOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomerExtensionSettingOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingOperation
                         * @instance
                         */
                        CustomerExtensionSettingOperation.prototype.updateMask = null;

                        /**
                         * CustomerExtensionSettingOperation create.
                         * @member {google.ads.googleads.v1.resources.ICustomerExtensionSetting|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingOperation
                         * @instance
                         */
                        CustomerExtensionSettingOperation.prototype.create = null;

                        /**
                         * CustomerExtensionSettingOperation update.
                         * @member {google.ads.googleads.v1.resources.ICustomerExtensionSetting|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingOperation
                         * @instance
                         */
                        CustomerExtensionSettingOperation.prototype.update = null;

                        /**
                         * CustomerExtensionSettingOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingOperation
                         * @instance
                         */
                        CustomerExtensionSettingOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CustomerExtensionSettingOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingOperation
                         * @instance
                         */
                        Object.defineProperty(CustomerExtensionSettingOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CustomerExtensionSettingOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerExtensionSettingOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CustomerExtensionSettingOperation} CustomerExtensionSettingOperation instance
                         */
                        CustomerExtensionSettingOperation.create = function create(properties) {
                            return new CustomerExtensionSettingOperation(properties);
                        };

                        /**
                         * Encodes the specified CustomerExtensionSettingOperation message. Does not implicitly {@link google.ads.googleads.v1.services.CustomerExtensionSettingOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerExtensionSettingOperation} message CustomerExtensionSettingOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerExtensionSettingOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.CustomerExtensionSetting.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.CustomerExtensionSetting.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerExtensionSettingOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CustomerExtensionSettingOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerExtensionSettingOperation} message CustomerExtensionSettingOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerExtensionSettingOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerExtensionSettingOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CustomerExtensionSettingOperation} CustomerExtensionSettingOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerExtensionSettingOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CustomerExtensionSettingOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.CustomerExtensionSetting.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.CustomerExtensionSetting.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerExtensionSettingOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CustomerExtensionSettingOperation} CustomerExtensionSettingOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerExtensionSettingOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerExtensionSettingOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerExtensionSettingOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CustomerExtensionSetting.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CustomerExtensionSetting.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a CustomerExtensionSettingOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CustomerExtensionSettingOperation} CustomerExtensionSettingOperation
                         */
                        CustomerExtensionSettingOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CustomerExtensionSettingOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CustomerExtensionSettingOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CustomerExtensionSettingOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CustomerExtensionSettingOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.CustomerExtensionSetting.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CustomerExtensionSettingOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.CustomerExtensionSetting.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomerExtensionSettingOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.CustomerExtensionSettingOperation} message CustomerExtensionSettingOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerExtensionSettingOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.CustomerExtensionSetting.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.CustomerExtensionSetting.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this CustomerExtensionSettingOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CustomerExtensionSettingOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerExtensionSettingOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomerExtensionSettingOperation;
                    })();

                    services.MutateCustomerExtensionSettingsResponse = (function() {

                        /**
                         * Properties of a MutateCustomerExtensionSettingsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerExtensionSettingsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateCustomerExtensionSettingsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateCustomerExtensionSettingResult>|null} [results] MutateCustomerExtensionSettingsResponse results
                         */

                        /**
                         * Constructs a new MutateCustomerExtensionSettingsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerExtensionSettingsResponse.
                         * @implements IMutateCustomerExtensionSettingsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerExtensionSettingsResponse=} [properties] Properties to set
                         */
                        function MutateCustomerExtensionSettingsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerExtensionSettingsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse
                         * @instance
                         */
                        MutateCustomerExtensionSettingsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateCustomerExtensionSettingsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateCustomerExtensionSettingResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse
                         * @instance
                         */
                        MutateCustomerExtensionSettingsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateCustomerExtensionSettingsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerExtensionSettingsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse} MutateCustomerExtensionSettingsResponse instance
                         */
                        MutateCustomerExtensionSettingsResponse.create = function create(properties) {
                            return new MutateCustomerExtensionSettingsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerExtensionSettingsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerExtensionSettingsResponse} message MutateCustomerExtensionSettingsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerExtensionSettingsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerExtensionSettingsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerExtensionSettingsResponse} message MutateCustomerExtensionSettingsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerExtensionSettingsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerExtensionSettingsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse} MutateCustomerExtensionSettingsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerExtensionSettingsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerExtensionSettingsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse} MutateCustomerExtensionSettingsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerExtensionSettingsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerExtensionSettingsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerExtensionSettingsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerExtensionSettingsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse} MutateCustomerExtensionSettingsResponse
                         */
                        MutateCustomerExtensionSettingsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerExtensionSettingsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse} message MutateCustomerExtensionSettingsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerExtensionSettingsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerExtensionSettingsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerExtensionSettingsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerExtensionSettingsResponse;
                    })();

                    services.MutateCustomerExtensionSettingResult = (function() {

                        /**
                         * Properties of a MutateCustomerExtensionSettingResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerExtensionSettingResult
                         * @property {string|null} [resourceName] MutateCustomerExtensionSettingResult resourceName
                         */

                        /**
                         * Constructs a new MutateCustomerExtensionSettingResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerExtensionSettingResult.
                         * @implements IMutateCustomerExtensionSettingResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerExtensionSettingResult=} [properties] Properties to set
                         */
                        function MutateCustomerExtensionSettingResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerExtensionSettingResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult
                         * @instance
                         */
                        MutateCustomerExtensionSettingResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateCustomerExtensionSettingResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerExtensionSettingResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult} MutateCustomerExtensionSettingResult instance
                         */
                        MutateCustomerExtensionSettingResult.create = function create(properties) {
                            return new MutateCustomerExtensionSettingResult(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerExtensionSettingResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerExtensionSettingResult} message MutateCustomerExtensionSettingResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerExtensionSettingResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerExtensionSettingResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerExtensionSettingResult} message MutateCustomerExtensionSettingResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerExtensionSettingResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerExtensionSettingResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult} MutateCustomerExtensionSettingResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerExtensionSettingResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerExtensionSettingResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult} MutateCustomerExtensionSettingResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerExtensionSettingResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerExtensionSettingResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerExtensionSettingResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerExtensionSettingResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult} MutateCustomerExtensionSettingResult
                         */
                        MutateCustomerExtensionSettingResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerExtensionSettingResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult} message MutateCustomerExtensionSettingResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerExtensionSettingResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerExtensionSettingResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerExtensionSettingResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerExtensionSettingResult;
                    })();

                    services.CustomerFeedService = (function() {

                        /**
                         * Constructs a new CustomerFeedService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CustomerFeedService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CustomerFeedService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CustomerFeedService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CustomerFeedService;

                        /**
                         * Creates new CustomerFeedService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CustomerFeedService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CustomerFeedService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CustomerFeedService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomerFeedService#getCustomerFeed}.
                         * @memberof google.ads.googleads.v1.services.CustomerFeedService
                         * @typedef GetCustomerFeedCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.CustomerFeed} [response] CustomerFeed
                         */

                        /**
                         * Calls GetCustomerFeed.
                         * @function getCustomerFeed
                         * @memberof google.ads.googleads.v1.services.CustomerFeedService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCustomerFeedRequest} request GetCustomerFeedRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomerFeedService.GetCustomerFeedCallback} callback Node-style callback called with the error, if any, and CustomerFeed
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomerFeedService.prototype.getCustomerFeed = function getCustomerFeed(request, callback) {
                            return this.rpcCall(getCustomerFeed, $root.google.ads.googleads.v1.services.GetCustomerFeedRequest, $root.google.ads.googleads.v1.resources.CustomerFeed, request, callback);
                        }, "name", { value: "GetCustomerFeed" });

                        /**
                         * Calls GetCustomerFeed.
                         * @function getCustomerFeed
                         * @memberof google.ads.googleads.v1.services.CustomerFeedService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCustomerFeedRequest} request GetCustomerFeedRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.CustomerFeed>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomerFeedService#mutateCustomerFeeds}.
                         * @memberof google.ads.googleads.v1.services.CustomerFeedService
                         * @typedef MutateCustomerFeedsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateCustomerFeedsResponse} [response] MutateCustomerFeedsResponse
                         */

                        /**
                         * Calls MutateCustomerFeeds.
                         * @function mutateCustomerFeeds
                         * @memberof google.ads.googleads.v1.services.CustomerFeedService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCustomerFeedsRequest} request MutateCustomerFeedsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomerFeedService.MutateCustomerFeedsCallback} callback Node-style callback called with the error, if any, and MutateCustomerFeedsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomerFeedService.prototype.mutateCustomerFeeds = function mutateCustomerFeeds(request, callback) {
                            return this.rpcCall(mutateCustomerFeeds, $root.google.ads.googleads.v1.services.MutateCustomerFeedsRequest, $root.google.ads.googleads.v1.services.MutateCustomerFeedsResponse, request, callback);
                        }, "name", { value: "MutateCustomerFeeds" });

                        /**
                         * Calls MutateCustomerFeeds.
                         * @function mutateCustomerFeeds
                         * @memberof google.ads.googleads.v1.services.CustomerFeedService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCustomerFeedsRequest} request MutateCustomerFeedsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateCustomerFeedsResponse>} Promise
                         * @variation 2
                         */

                        return CustomerFeedService;
                    })();

                    services.GetCustomerFeedRequest = (function() {

                        /**
                         * Properties of a GetCustomerFeedRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCustomerFeedRequest
                         * @property {string|null} [resourceName] GetCustomerFeedRequest resourceName
                         */

                        /**
                         * Constructs a new GetCustomerFeedRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCustomerFeedRequest.
                         * @implements IGetCustomerFeedRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCustomerFeedRequest=} [properties] Properties to set
                         */
                        function GetCustomerFeedRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCustomerFeedRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCustomerFeedRequest
                         * @instance
                         */
                        GetCustomerFeedRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCustomerFeedRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCustomerFeedRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerFeedRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCustomerFeedRequest} GetCustomerFeedRequest instance
                         */
                        GetCustomerFeedRequest.create = function create(properties) {
                            return new GetCustomerFeedRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCustomerFeedRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCustomerFeedRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCustomerFeedRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerFeedRequest} message GetCustomerFeedRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomerFeedRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCustomerFeedRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCustomerFeedRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCustomerFeedRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerFeedRequest} message GetCustomerFeedRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomerFeedRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCustomerFeedRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCustomerFeedRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCustomerFeedRequest} GetCustomerFeedRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomerFeedRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCustomerFeedRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCustomerFeedRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCustomerFeedRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCustomerFeedRequest} GetCustomerFeedRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomerFeedRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCustomerFeedRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCustomerFeedRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCustomerFeedRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCustomerFeedRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCustomerFeedRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCustomerFeedRequest} GetCustomerFeedRequest
                         */
                        GetCustomerFeedRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCustomerFeedRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCustomerFeedRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCustomerFeedRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCustomerFeedRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCustomerFeedRequest} message GetCustomerFeedRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCustomerFeedRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCustomerFeedRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCustomerFeedRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCustomerFeedRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCustomerFeedRequest;
                    })();

                    services.MutateCustomerFeedsRequest = (function() {

                        /**
                         * Properties of a MutateCustomerFeedsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerFeedsRequest
                         * @property {string|null} [customerId] MutateCustomerFeedsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.ICustomerFeedOperation>|null} [operations] MutateCustomerFeedsRequest operations
                         * @property {boolean|null} [partialFailure] MutateCustomerFeedsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateCustomerFeedsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateCustomerFeedsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerFeedsRequest.
                         * @implements IMutateCustomerFeedsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerFeedsRequest=} [properties] Properties to set
                         */
                        function MutateCustomerFeedsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerFeedsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsRequest
                         * @instance
                         */
                        MutateCustomerFeedsRequest.prototype.customerId = "";

                        /**
                         * MutateCustomerFeedsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.ICustomerFeedOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsRequest
                         * @instance
                         */
                        MutateCustomerFeedsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateCustomerFeedsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsRequest
                         * @instance
                         */
                        MutateCustomerFeedsRequest.prototype.partialFailure = false;

                        /**
                         * MutateCustomerFeedsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsRequest
                         * @instance
                         */
                        MutateCustomerFeedsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateCustomerFeedsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerFeedsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerFeedsRequest} MutateCustomerFeedsRequest instance
                         */
                        MutateCustomerFeedsRequest.create = function create(properties) {
                            return new MutateCustomerFeedsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerFeedsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerFeedsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerFeedsRequest} message MutateCustomerFeedsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerFeedsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.CustomerFeedOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerFeedsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerFeedsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerFeedsRequest} message MutateCustomerFeedsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerFeedsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerFeedsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerFeedsRequest} MutateCustomerFeedsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerFeedsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerFeedsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.CustomerFeedOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerFeedsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerFeedsRequest} MutateCustomerFeedsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerFeedsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerFeedsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerFeedsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.CustomerFeedOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerFeedsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerFeedsRequest} MutateCustomerFeedsRequest
                         */
                        MutateCustomerFeedsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerFeedsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerFeedsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomerFeedsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCustomerFeedsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.CustomerFeedOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerFeedsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerFeedsRequest} message MutateCustomerFeedsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerFeedsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.CustomerFeedOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerFeedsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerFeedsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerFeedsRequest;
                    })();

                    services.CustomerFeedOperation = (function() {

                        /**
                         * Properties of a CustomerFeedOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICustomerFeedOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] CustomerFeedOperation updateMask
                         * @property {google.ads.googleads.v1.resources.ICustomerFeed|null} [create] CustomerFeedOperation create
                         * @property {google.ads.googleads.v1.resources.ICustomerFeed|null} [update] CustomerFeedOperation update
                         * @property {string|null} [remove] CustomerFeedOperation remove
                         */

                        /**
                         * Constructs a new CustomerFeedOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CustomerFeedOperation.
                         * @implements ICustomerFeedOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICustomerFeedOperation=} [properties] Properties to set
                         */
                        function CustomerFeedOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomerFeedOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.CustomerFeedOperation
                         * @instance
                         */
                        CustomerFeedOperation.prototype.updateMask = null;

                        /**
                         * CustomerFeedOperation create.
                         * @member {google.ads.googleads.v1.resources.ICustomerFeed|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.CustomerFeedOperation
                         * @instance
                         */
                        CustomerFeedOperation.prototype.create = null;

                        /**
                         * CustomerFeedOperation update.
                         * @member {google.ads.googleads.v1.resources.ICustomerFeed|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.CustomerFeedOperation
                         * @instance
                         */
                        CustomerFeedOperation.prototype.update = null;

                        /**
                         * CustomerFeedOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.CustomerFeedOperation
                         * @instance
                         */
                        CustomerFeedOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CustomerFeedOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.CustomerFeedOperation
                         * @instance
                         */
                        Object.defineProperty(CustomerFeedOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CustomerFeedOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CustomerFeedOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerFeedOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CustomerFeedOperation} CustomerFeedOperation instance
                         */
                        CustomerFeedOperation.create = function create(properties) {
                            return new CustomerFeedOperation(properties);
                        };

                        /**
                         * Encodes the specified CustomerFeedOperation message. Does not implicitly {@link google.ads.googleads.v1.services.CustomerFeedOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CustomerFeedOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerFeedOperation} message CustomerFeedOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerFeedOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.CustomerFeed.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.CustomerFeed.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerFeedOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CustomerFeedOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CustomerFeedOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerFeedOperation} message CustomerFeedOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerFeedOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerFeedOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CustomerFeedOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CustomerFeedOperation} CustomerFeedOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerFeedOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CustomerFeedOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.CustomerFeed.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.CustomerFeed.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerFeedOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CustomerFeedOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CustomerFeedOperation} CustomerFeedOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerFeedOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerFeedOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CustomerFeedOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerFeedOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CustomerFeed.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CustomerFeed.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a CustomerFeedOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CustomerFeedOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CustomerFeedOperation} CustomerFeedOperation
                         */
                        CustomerFeedOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CustomerFeedOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CustomerFeedOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CustomerFeedOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CustomerFeedOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.CustomerFeed.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CustomerFeedOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.CustomerFeed.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomerFeedOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CustomerFeedOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.CustomerFeedOperation} message CustomerFeedOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerFeedOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.CustomerFeed.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.CustomerFeed.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this CustomerFeedOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CustomerFeedOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerFeedOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomerFeedOperation;
                    })();

                    services.MutateCustomerFeedsResponse = (function() {

                        /**
                         * Properties of a MutateCustomerFeedsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerFeedsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateCustomerFeedsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateCustomerFeedResult>|null} [results] MutateCustomerFeedsResponse results
                         */

                        /**
                         * Constructs a new MutateCustomerFeedsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerFeedsResponse.
                         * @implements IMutateCustomerFeedsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerFeedsResponse=} [properties] Properties to set
                         */
                        function MutateCustomerFeedsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerFeedsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsResponse
                         * @instance
                         */
                        MutateCustomerFeedsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateCustomerFeedsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateCustomerFeedResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsResponse
                         * @instance
                         */
                        MutateCustomerFeedsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateCustomerFeedsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerFeedsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerFeedsResponse} MutateCustomerFeedsResponse instance
                         */
                        MutateCustomerFeedsResponse.create = function create(properties) {
                            return new MutateCustomerFeedsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerFeedsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerFeedsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerFeedsResponse} message MutateCustomerFeedsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerFeedsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateCustomerFeedResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerFeedsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerFeedsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerFeedsResponse} message MutateCustomerFeedsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerFeedsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerFeedsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerFeedsResponse} MutateCustomerFeedsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerFeedsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerFeedsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateCustomerFeedResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerFeedsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerFeedsResponse} MutateCustomerFeedsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerFeedsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerFeedsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerFeedsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateCustomerFeedResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerFeedsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerFeedsResponse} MutateCustomerFeedsResponse
                         */
                        MutateCustomerFeedsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerFeedsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerFeedsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomerFeedsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomerFeedsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCustomerFeedsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateCustomerFeedResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerFeedsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerFeedsResponse} message MutateCustomerFeedsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerFeedsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateCustomerFeedResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerFeedsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerFeedsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerFeedsResponse;
                    })();

                    services.MutateCustomerFeedResult = (function() {

                        /**
                         * Properties of a MutateCustomerFeedResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerFeedResult
                         * @property {string|null} [resourceName] MutateCustomerFeedResult resourceName
                         */

                        /**
                         * Constructs a new MutateCustomerFeedResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerFeedResult.
                         * @implements IMutateCustomerFeedResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerFeedResult=} [properties] Properties to set
                         */
                        function MutateCustomerFeedResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerFeedResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedResult
                         * @instance
                         */
                        MutateCustomerFeedResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateCustomerFeedResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerFeedResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerFeedResult} MutateCustomerFeedResult instance
                         */
                        MutateCustomerFeedResult.create = function create(properties) {
                            return new MutateCustomerFeedResult(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerFeedResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerFeedResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerFeedResult} message MutateCustomerFeedResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerFeedResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerFeedResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerFeedResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerFeedResult} message MutateCustomerFeedResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerFeedResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerFeedResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerFeedResult} MutateCustomerFeedResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerFeedResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerFeedResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerFeedResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerFeedResult} MutateCustomerFeedResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerFeedResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerFeedResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerFeedResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerFeedResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerFeedResult} MutateCustomerFeedResult
                         */
                        MutateCustomerFeedResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerFeedResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerFeedResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerFeedResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerFeedResult} message MutateCustomerFeedResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerFeedResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerFeedResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerFeedResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerFeedResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerFeedResult;
                    })();

                    services.CustomerLabelService = (function() {

                        /**
                         * Constructs a new CustomerLabelService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CustomerLabelService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CustomerLabelService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CustomerLabelService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CustomerLabelService;

                        /**
                         * Creates new CustomerLabelService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CustomerLabelService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CustomerLabelService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CustomerLabelService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomerLabelService#getCustomerLabel}.
                         * @memberof google.ads.googleads.v1.services.CustomerLabelService
                         * @typedef GetCustomerLabelCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.CustomerLabel} [response] CustomerLabel
                         */

                        /**
                         * Calls GetCustomerLabel.
                         * @function getCustomerLabel
                         * @memberof google.ads.googleads.v1.services.CustomerLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCustomerLabelRequest} request GetCustomerLabelRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomerLabelService.GetCustomerLabelCallback} callback Node-style callback called with the error, if any, and CustomerLabel
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomerLabelService.prototype.getCustomerLabel = function getCustomerLabel(request, callback) {
                            return this.rpcCall(getCustomerLabel, $root.google.ads.googleads.v1.services.GetCustomerLabelRequest, $root.google.ads.googleads.v1.resources.CustomerLabel, request, callback);
                        }, "name", { value: "GetCustomerLabel" });

                        /**
                         * Calls GetCustomerLabel.
                         * @function getCustomerLabel
                         * @memberof google.ads.googleads.v1.services.CustomerLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCustomerLabelRequest} request GetCustomerLabelRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.CustomerLabel>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomerLabelService#mutateCustomerLabels}.
                         * @memberof google.ads.googleads.v1.services.CustomerLabelService
                         * @typedef MutateCustomerLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateCustomerLabelsResponse} [response] MutateCustomerLabelsResponse
                         */

                        /**
                         * Calls MutateCustomerLabels.
                         * @function mutateCustomerLabels
                         * @memberof google.ads.googleads.v1.services.CustomerLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCustomerLabelsRequest} request MutateCustomerLabelsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomerLabelService.MutateCustomerLabelsCallback} callback Node-style callback called with the error, if any, and MutateCustomerLabelsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomerLabelService.prototype.mutateCustomerLabels = function mutateCustomerLabels(request, callback) {
                            return this.rpcCall(mutateCustomerLabels, $root.google.ads.googleads.v1.services.MutateCustomerLabelsRequest, $root.google.ads.googleads.v1.services.MutateCustomerLabelsResponse, request, callback);
                        }, "name", { value: "MutateCustomerLabels" });

                        /**
                         * Calls MutateCustomerLabels.
                         * @function mutateCustomerLabels
                         * @memberof google.ads.googleads.v1.services.CustomerLabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCustomerLabelsRequest} request MutateCustomerLabelsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateCustomerLabelsResponse>} Promise
                         * @variation 2
                         */

                        return CustomerLabelService;
                    })();

                    services.GetCustomerLabelRequest = (function() {

                        /**
                         * Properties of a GetCustomerLabelRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCustomerLabelRequest
                         * @property {string|null} [resourceName] GetCustomerLabelRequest resourceName
                         */

                        /**
                         * Constructs a new GetCustomerLabelRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCustomerLabelRequest.
                         * @implements IGetCustomerLabelRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCustomerLabelRequest=} [properties] Properties to set
                         */
                        function GetCustomerLabelRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCustomerLabelRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCustomerLabelRequest
                         * @instance
                         */
                        GetCustomerLabelRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCustomerLabelRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCustomerLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerLabelRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCustomerLabelRequest} GetCustomerLabelRequest instance
                         */
                        GetCustomerLabelRequest.create = function create(properties) {
                            return new GetCustomerLabelRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCustomerLabelRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCustomerLabelRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCustomerLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerLabelRequest} message GetCustomerLabelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomerLabelRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCustomerLabelRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCustomerLabelRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCustomerLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerLabelRequest} message GetCustomerLabelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomerLabelRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCustomerLabelRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCustomerLabelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCustomerLabelRequest} GetCustomerLabelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomerLabelRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCustomerLabelRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCustomerLabelRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCustomerLabelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCustomerLabelRequest} GetCustomerLabelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomerLabelRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCustomerLabelRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCustomerLabelRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCustomerLabelRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCustomerLabelRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCustomerLabelRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCustomerLabelRequest} GetCustomerLabelRequest
                         */
                        GetCustomerLabelRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCustomerLabelRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCustomerLabelRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCustomerLabelRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCustomerLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCustomerLabelRequest} message GetCustomerLabelRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCustomerLabelRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCustomerLabelRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCustomerLabelRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCustomerLabelRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCustomerLabelRequest;
                    })();

                    services.MutateCustomerLabelsRequest = (function() {

                        /**
                         * Properties of a MutateCustomerLabelsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerLabelsRequest
                         * @property {string|null} [customerId] MutateCustomerLabelsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.ICustomerLabelOperation>|null} [operations] MutateCustomerLabelsRequest operations
                         * @property {boolean|null} [partialFailure] MutateCustomerLabelsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateCustomerLabelsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateCustomerLabelsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerLabelsRequest.
                         * @implements IMutateCustomerLabelsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerLabelsRequest=} [properties] Properties to set
                         */
                        function MutateCustomerLabelsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerLabelsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsRequest
                         * @instance
                         */
                        MutateCustomerLabelsRequest.prototype.customerId = "";

                        /**
                         * MutateCustomerLabelsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.ICustomerLabelOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsRequest
                         * @instance
                         */
                        MutateCustomerLabelsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateCustomerLabelsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsRequest
                         * @instance
                         */
                        MutateCustomerLabelsRequest.prototype.partialFailure = false;

                        /**
                         * MutateCustomerLabelsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsRequest
                         * @instance
                         */
                        MutateCustomerLabelsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateCustomerLabelsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerLabelsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerLabelsRequest} MutateCustomerLabelsRequest instance
                         */
                        MutateCustomerLabelsRequest.create = function create(properties) {
                            return new MutateCustomerLabelsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerLabelsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerLabelsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerLabelsRequest} message MutateCustomerLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerLabelsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.CustomerLabelOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerLabelsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerLabelsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerLabelsRequest} message MutateCustomerLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerLabelsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerLabelsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerLabelsRequest} MutateCustomerLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerLabelsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerLabelsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.CustomerLabelOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerLabelsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerLabelsRequest} MutateCustomerLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerLabelsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerLabelsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerLabelsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.CustomerLabelOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerLabelsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerLabelsRequest} MutateCustomerLabelsRequest
                         */
                        MutateCustomerLabelsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerLabelsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerLabelsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomerLabelsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCustomerLabelsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.CustomerLabelOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerLabelsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerLabelsRequest} message MutateCustomerLabelsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerLabelsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.CustomerLabelOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerLabelsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerLabelsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerLabelsRequest;
                    })();

                    services.CustomerLabelOperation = (function() {

                        /**
                         * Properties of a CustomerLabelOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICustomerLabelOperation
                         * @property {google.ads.googleads.v1.resources.ICustomerLabel|null} [create] CustomerLabelOperation create
                         * @property {string|null} [remove] CustomerLabelOperation remove
                         */

                        /**
                         * Constructs a new CustomerLabelOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CustomerLabelOperation.
                         * @implements ICustomerLabelOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICustomerLabelOperation=} [properties] Properties to set
                         */
                        function CustomerLabelOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomerLabelOperation create.
                         * @member {google.ads.googleads.v1.resources.ICustomerLabel|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.CustomerLabelOperation
                         * @instance
                         */
                        CustomerLabelOperation.prototype.create = null;

                        /**
                         * CustomerLabelOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.CustomerLabelOperation
                         * @instance
                         */
                        CustomerLabelOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CustomerLabelOperation operation.
                         * @member {"create"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.CustomerLabelOperation
                         * @instance
                         */
                        Object.defineProperty(CustomerLabelOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CustomerLabelOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CustomerLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerLabelOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CustomerLabelOperation} CustomerLabelOperation instance
                         */
                        CustomerLabelOperation.create = function create(properties) {
                            return new CustomerLabelOperation(properties);
                        };

                        /**
                         * Encodes the specified CustomerLabelOperation message. Does not implicitly {@link google.ads.googleads.v1.services.CustomerLabelOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CustomerLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerLabelOperation} message CustomerLabelOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerLabelOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.CustomerLabel.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.remove);
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerLabelOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CustomerLabelOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CustomerLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerLabelOperation} message CustomerLabelOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerLabelOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerLabelOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CustomerLabelOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CustomerLabelOperation} CustomerLabelOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerLabelOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CustomerLabelOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.CustomerLabel.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerLabelOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CustomerLabelOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CustomerLabelOperation} CustomerLabelOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerLabelOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerLabelOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CustomerLabelOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerLabelOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CustomerLabel.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a CustomerLabelOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CustomerLabelOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CustomerLabelOperation} CustomerLabelOperation
                         */
                        CustomerLabelOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CustomerLabelOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CustomerLabelOperation();
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CustomerLabelOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.CustomerLabel.fromObject(object.create);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomerLabelOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CustomerLabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.CustomerLabelOperation} message CustomerLabelOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerLabelOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.CustomerLabel.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            return object;
                        };

                        /**
                         * Converts this CustomerLabelOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CustomerLabelOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerLabelOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomerLabelOperation;
                    })();

                    services.MutateCustomerLabelsResponse = (function() {

                        /**
                         * Properties of a MutateCustomerLabelsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerLabelsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateCustomerLabelsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateCustomerLabelResult>|null} [results] MutateCustomerLabelsResponse results
                         */

                        /**
                         * Constructs a new MutateCustomerLabelsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerLabelsResponse.
                         * @implements IMutateCustomerLabelsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerLabelsResponse=} [properties] Properties to set
                         */
                        function MutateCustomerLabelsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerLabelsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsResponse
                         * @instance
                         */
                        MutateCustomerLabelsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateCustomerLabelsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateCustomerLabelResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsResponse
                         * @instance
                         */
                        MutateCustomerLabelsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateCustomerLabelsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerLabelsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerLabelsResponse} MutateCustomerLabelsResponse instance
                         */
                        MutateCustomerLabelsResponse.create = function create(properties) {
                            return new MutateCustomerLabelsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerLabelsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerLabelsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerLabelsResponse} message MutateCustomerLabelsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerLabelsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateCustomerLabelResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerLabelsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerLabelsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerLabelsResponse} message MutateCustomerLabelsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerLabelsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerLabelsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerLabelsResponse} MutateCustomerLabelsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerLabelsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerLabelsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateCustomerLabelResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerLabelsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerLabelsResponse} MutateCustomerLabelsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerLabelsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerLabelsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerLabelsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateCustomerLabelResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerLabelsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerLabelsResponse} MutateCustomerLabelsResponse
                         */
                        MutateCustomerLabelsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerLabelsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerLabelsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomerLabelsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomerLabelsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCustomerLabelsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateCustomerLabelResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerLabelsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerLabelsResponse} message MutateCustomerLabelsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerLabelsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateCustomerLabelResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerLabelsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerLabelsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerLabelsResponse;
                    })();

                    services.MutateCustomerLabelResult = (function() {

                        /**
                         * Properties of a MutateCustomerLabelResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerLabelResult
                         * @property {string|null} [resourceName] MutateCustomerLabelResult resourceName
                         */

                        /**
                         * Constructs a new MutateCustomerLabelResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerLabelResult.
                         * @implements IMutateCustomerLabelResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerLabelResult=} [properties] Properties to set
                         */
                        function MutateCustomerLabelResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerLabelResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelResult
                         * @instance
                         */
                        MutateCustomerLabelResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateCustomerLabelResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerLabelResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerLabelResult} MutateCustomerLabelResult instance
                         */
                        MutateCustomerLabelResult.create = function create(properties) {
                            return new MutateCustomerLabelResult(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerLabelResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerLabelResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerLabelResult} message MutateCustomerLabelResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerLabelResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerLabelResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerLabelResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerLabelResult} message MutateCustomerLabelResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerLabelResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerLabelResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerLabelResult} MutateCustomerLabelResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerLabelResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerLabelResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerLabelResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerLabelResult} MutateCustomerLabelResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerLabelResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerLabelResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerLabelResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerLabelResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerLabelResult} MutateCustomerLabelResult
                         */
                        MutateCustomerLabelResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerLabelResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerLabelResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerLabelResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerLabelResult} message MutateCustomerLabelResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerLabelResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerLabelResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerLabelResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerLabelResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerLabelResult;
                    })();

                    services.CustomerManagerLinkService = (function() {

                        /**
                         * Constructs a new CustomerManagerLinkService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CustomerManagerLinkService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CustomerManagerLinkService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CustomerManagerLinkService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CustomerManagerLinkService;

                        /**
                         * Creates new CustomerManagerLinkService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CustomerManagerLinkService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CustomerManagerLinkService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomerManagerLinkService#getCustomerManagerLink}.
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkService
                         * @typedef GetCustomerManagerLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.CustomerManagerLink} [response] CustomerManagerLink
                         */

                        /**
                         * Calls GetCustomerManagerLink.
                         * @function getCustomerManagerLink
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCustomerManagerLinkRequest} request GetCustomerManagerLinkRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomerManagerLinkService.GetCustomerManagerLinkCallback} callback Node-style callback called with the error, if any, and CustomerManagerLink
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomerManagerLinkService.prototype.getCustomerManagerLink = function getCustomerManagerLink(request, callback) {
                            return this.rpcCall(getCustomerManagerLink, $root.google.ads.googleads.v1.services.GetCustomerManagerLinkRequest, $root.google.ads.googleads.v1.resources.CustomerManagerLink, request, callback);
                        }, "name", { value: "GetCustomerManagerLink" });

                        /**
                         * Calls GetCustomerManagerLink.
                         * @function getCustomerManagerLink
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCustomerManagerLinkRequest} request GetCustomerManagerLinkRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.CustomerManagerLink>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomerManagerLinkService#mutateCustomerManagerLink}.
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkService
                         * @typedef MutateCustomerManagerLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse} [response] MutateCustomerManagerLinkResponse
                         */

                        /**
                         * Calls MutateCustomerManagerLink.
                         * @function mutateCustomerManagerLink
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCustomerManagerLinkRequest} request MutateCustomerManagerLinkRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomerManagerLinkService.MutateCustomerManagerLinkCallback} callback Node-style callback called with the error, if any, and MutateCustomerManagerLinkResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomerManagerLinkService.prototype.mutateCustomerManagerLink = function mutateCustomerManagerLink(request, callback) {
                            return this.rpcCall(mutateCustomerManagerLink, $root.google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest, $root.google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse, request, callback);
                        }, "name", { value: "MutateCustomerManagerLink" });

                        /**
                         * Calls MutateCustomerManagerLink.
                         * @function mutateCustomerManagerLink
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCustomerManagerLinkRequest} request MutateCustomerManagerLinkRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse>} Promise
                         * @variation 2
                         */

                        return CustomerManagerLinkService;
                    })();

                    services.GetCustomerManagerLinkRequest = (function() {

                        /**
                         * Properties of a GetCustomerManagerLinkRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCustomerManagerLinkRequest
                         * @property {string|null} [resourceName] GetCustomerManagerLinkRequest resourceName
                         */

                        /**
                         * Constructs a new GetCustomerManagerLinkRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCustomerManagerLinkRequest.
                         * @implements IGetCustomerManagerLinkRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCustomerManagerLinkRequest=} [properties] Properties to set
                         */
                        function GetCustomerManagerLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCustomerManagerLinkRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCustomerManagerLinkRequest
                         * @instance
                         */
                        GetCustomerManagerLinkRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCustomerManagerLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCustomerManagerLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerManagerLinkRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCustomerManagerLinkRequest} GetCustomerManagerLinkRequest instance
                         */
                        GetCustomerManagerLinkRequest.create = function create(properties) {
                            return new GetCustomerManagerLinkRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCustomerManagerLinkRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCustomerManagerLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCustomerManagerLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerManagerLinkRequest} message GetCustomerManagerLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomerManagerLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCustomerManagerLinkRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCustomerManagerLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCustomerManagerLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerManagerLinkRequest} message GetCustomerManagerLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomerManagerLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCustomerManagerLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCustomerManagerLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCustomerManagerLinkRequest} GetCustomerManagerLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomerManagerLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCustomerManagerLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCustomerManagerLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCustomerManagerLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCustomerManagerLinkRequest} GetCustomerManagerLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomerManagerLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCustomerManagerLinkRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCustomerManagerLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCustomerManagerLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCustomerManagerLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCustomerManagerLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCustomerManagerLinkRequest} GetCustomerManagerLinkRequest
                         */
                        GetCustomerManagerLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCustomerManagerLinkRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCustomerManagerLinkRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCustomerManagerLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCustomerManagerLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCustomerManagerLinkRequest} message GetCustomerManagerLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCustomerManagerLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCustomerManagerLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCustomerManagerLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCustomerManagerLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCustomerManagerLinkRequest;
                    })();

                    services.MutateCustomerManagerLinkRequest = (function() {

                        /**
                         * Properties of a MutateCustomerManagerLinkRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerManagerLinkRequest
                         * @property {string|null} [customerId] MutateCustomerManagerLinkRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.ICustomerManagerLinkOperation>|null} [operations] MutateCustomerManagerLinkRequest operations
                         */

                        /**
                         * Constructs a new MutateCustomerManagerLinkRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerManagerLinkRequest.
                         * @implements IMutateCustomerManagerLinkRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerManagerLinkRequest=} [properties] Properties to set
                         */
                        function MutateCustomerManagerLinkRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerManagerLinkRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest
                         * @instance
                         */
                        MutateCustomerManagerLinkRequest.prototype.customerId = "";

                        /**
                         * MutateCustomerManagerLinkRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.ICustomerManagerLinkOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest
                         * @instance
                         */
                        MutateCustomerManagerLinkRequest.prototype.operations = $util.emptyArray;

                        /**
                         * Creates a new MutateCustomerManagerLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerManagerLinkRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest} MutateCustomerManagerLinkRequest instance
                         */
                        MutateCustomerManagerLinkRequest.create = function create(properties) {
                            return new MutateCustomerManagerLinkRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerManagerLinkRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerManagerLinkRequest} message MutateCustomerManagerLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerManagerLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.CustomerManagerLinkOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerManagerLinkRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerManagerLinkRequest} message MutateCustomerManagerLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerManagerLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerManagerLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest} MutateCustomerManagerLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerManagerLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.CustomerManagerLinkOperation.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerManagerLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest} MutateCustomerManagerLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerManagerLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerManagerLinkRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerManagerLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.CustomerManagerLinkOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerManagerLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest} MutateCustomerManagerLinkRequest
                         */
                        MutateCustomerManagerLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.CustomerManagerLinkOperation.fromObject(object.operations[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerManagerLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest} message MutateCustomerManagerLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerManagerLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults)
                                object.customerId = "";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.CustomerManagerLinkOperation.toObject(message.operations[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerManagerLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerManagerLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerManagerLinkRequest;
                    })();

                    services.CustomerManagerLinkOperation = (function() {

                        /**
                         * Properties of a CustomerManagerLinkOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICustomerManagerLinkOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] CustomerManagerLinkOperation updateMask
                         * @property {google.ads.googleads.v1.resources.ICustomerManagerLink|null} [update] CustomerManagerLinkOperation update
                         */

                        /**
                         * Constructs a new CustomerManagerLinkOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CustomerManagerLinkOperation.
                         * @implements ICustomerManagerLinkOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICustomerManagerLinkOperation=} [properties] Properties to set
                         */
                        function CustomerManagerLinkOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomerManagerLinkOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkOperation
                         * @instance
                         */
                        CustomerManagerLinkOperation.prototype.updateMask = null;

                        /**
                         * CustomerManagerLinkOperation update.
                         * @member {google.ads.googleads.v1.resources.ICustomerManagerLink|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkOperation
                         * @instance
                         */
                        CustomerManagerLinkOperation.prototype.update = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CustomerManagerLinkOperation operation.
                         * @member {"update"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkOperation
                         * @instance
                         */
                        Object.defineProperty(CustomerManagerLinkOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["update"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CustomerManagerLinkOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerManagerLinkOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CustomerManagerLinkOperation} CustomerManagerLinkOperation instance
                         */
                        CustomerManagerLinkOperation.create = function create(properties) {
                            return new CustomerManagerLinkOperation(properties);
                        };

                        /**
                         * Encodes the specified CustomerManagerLinkOperation message. Does not implicitly {@link google.ads.googleads.v1.services.CustomerManagerLinkOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerManagerLinkOperation} message CustomerManagerLinkOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerManagerLinkOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.CustomerManagerLink.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerManagerLinkOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CustomerManagerLinkOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerManagerLinkOperation} message CustomerManagerLinkOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerManagerLinkOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerManagerLinkOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CustomerManagerLinkOperation} CustomerManagerLinkOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerManagerLinkOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CustomerManagerLinkOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.CustomerManagerLink.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerManagerLinkOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CustomerManagerLinkOperation} CustomerManagerLinkOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerManagerLinkOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerManagerLinkOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerManagerLinkOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CustomerManagerLink.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a CustomerManagerLinkOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CustomerManagerLinkOperation} CustomerManagerLinkOperation
                         */
                        CustomerManagerLinkOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CustomerManagerLinkOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CustomerManagerLinkOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CustomerManagerLinkOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CustomerManagerLinkOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.CustomerManagerLink.fromObject(object.update);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomerManagerLinkOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.CustomerManagerLinkOperation} message CustomerManagerLinkOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerManagerLinkOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.CustomerManagerLink.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this CustomerManagerLinkOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CustomerManagerLinkOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerManagerLinkOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomerManagerLinkOperation;
                    })();

                    services.MutateCustomerManagerLinkResponse = (function() {

                        /**
                         * Properties of a MutateCustomerManagerLinkResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerManagerLinkResponse
                         * @property {Array.<google.ads.googleads.v1.services.IMutateCustomerManagerLinkResult>|null} [results] MutateCustomerManagerLinkResponse results
                         */

                        /**
                         * Constructs a new MutateCustomerManagerLinkResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerManagerLinkResponse.
                         * @implements IMutateCustomerManagerLinkResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerManagerLinkResponse=} [properties] Properties to set
                         */
                        function MutateCustomerManagerLinkResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerManagerLinkResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateCustomerManagerLinkResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse
                         * @instance
                         */
                        MutateCustomerManagerLinkResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateCustomerManagerLinkResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerManagerLinkResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse} MutateCustomerManagerLinkResponse instance
                         */
                        MutateCustomerManagerLinkResponse.create = function create(properties) {
                            return new MutateCustomerManagerLinkResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerManagerLinkResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerManagerLinkResponse} message MutateCustomerManagerLinkResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerManagerLinkResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateCustomerManagerLinkResult.encode(message.results[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerManagerLinkResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerManagerLinkResponse} message MutateCustomerManagerLinkResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerManagerLinkResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerManagerLinkResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse} MutateCustomerManagerLinkResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerManagerLinkResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateCustomerManagerLinkResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerManagerLinkResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse} MutateCustomerManagerLinkResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerManagerLinkResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerManagerLinkResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerManagerLinkResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateCustomerManagerLinkResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerManagerLinkResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse} MutateCustomerManagerLinkResponse
                         */
                        MutateCustomerManagerLinkResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse();
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateCustomerManagerLinkResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerManagerLinkResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse} message MutateCustomerManagerLinkResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerManagerLinkResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateCustomerManagerLinkResult.toObject(message.results[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerManagerLinkResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerManagerLinkResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerManagerLinkResponse;
                    })();

                    services.MutateCustomerManagerLinkResult = (function() {

                        /**
                         * Properties of a MutateCustomerManagerLinkResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerManagerLinkResult
                         * @property {string|null} [resourceName] MutateCustomerManagerLinkResult resourceName
                         */

                        /**
                         * Constructs a new MutateCustomerManagerLinkResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerManagerLinkResult.
                         * @implements IMutateCustomerManagerLinkResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerManagerLinkResult=} [properties] Properties to set
                         */
                        function MutateCustomerManagerLinkResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerManagerLinkResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResult
                         * @instance
                         */
                        MutateCustomerManagerLinkResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateCustomerManagerLinkResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerManagerLinkResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerManagerLinkResult} MutateCustomerManagerLinkResult instance
                         */
                        MutateCustomerManagerLinkResult.create = function create(properties) {
                            return new MutateCustomerManagerLinkResult(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerManagerLinkResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerManagerLinkResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerManagerLinkResult} message MutateCustomerManagerLinkResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerManagerLinkResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerManagerLinkResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerManagerLinkResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerManagerLinkResult} message MutateCustomerManagerLinkResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerManagerLinkResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerManagerLinkResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerManagerLinkResult} MutateCustomerManagerLinkResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerManagerLinkResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerManagerLinkResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerManagerLinkResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerManagerLinkResult} MutateCustomerManagerLinkResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerManagerLinkResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerManagerLinkResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerManagerLinkResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerManagerLinkResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerManagerLinkResult} MutateCustomerManagerLinkResult
                         */
                        MutateCustomerManagerLinkResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerManagerLinkResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerManagerLinkResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerManagerLinkResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerManagerLinkResult} message MutateCustomerManagerLinkResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerManagerLinkResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerManagerLinkResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerManagerLinkResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerManagerLinkResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerManagerLinkResult;
                    })();

                    services.CustomerNegativeCriterionService = (function() {

                        /**
                         * Constructs a new CustomerNegativeCriterionService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CustomerNegativeCriterionService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CustomerNegativeCriterionService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CustomerNegativeCriterionService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CustomerNegativeCriterionService;

                        /**
                         * Creates new CustomerNegativeCriterionService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CustomerNegativeCriterionService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CustomerNegativeCriterionService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomerNegativeCriterionService#getCustomerNegativeCriterion}.
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionService
                         * @typedef GetCustomerNegativeCriterionCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.CustomerNegativeCriterion} [response] CustomerNegativeCriterion
                         */

                        /**
                         * Calls GetCustomerNegativeCriterion.
                         * @function getCustomerNegativeCriterion
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCustomerNegativeCriterionRequest} request GetCustomerNegativeCriterionRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomerNegativeCriterionService.GetCustomerNegativeCriterionCallback} callback Node-style callback called with the error, if any, and CustomerNegativeCriterion
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomerNegativeCriterionService.prototype.getCustomerNegativeCriterion = function getCustomerNegativeCriterion(request, callback) {
                            return this.rpcCall(getCustomerNegativeCriterion, $root.google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest, $root.google.ads.googleads.v1.resources.CustomerNegativeCriterion, request, callback);
                        }, "name", { value: "GetCustomerNegativeCriterion" });

                        /**
                         * Calls GetCustomerNegativeCriterion.
                         * @function getCustomerNegativeCriterion
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCustomerNegativeCriterionRequest} request GetCustomerNegativeCriterionRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.CustomerNegativeCriterion>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomerNegativeCriterionService#mutateCustomerNegativeCriteria}.
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionService
                         * @typedef MutateCustomerNegativeCriteriaCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse} [response] MutateCustomerNegativeCriteriaResponse
                         */

                        /**
                         * Calls MutateCustomerNegativeCriteria.
                         * @function mutateCustomerNegativeCriteria
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCustomerNegativeCriteriaRequest} request MutateCustomerNegativeCriteriaRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomerNegativeCriterionService.MutateCustomerNegativeCriteriaCallback} callback Node-style callback called with the error, if any, and MutateCustomerNegativeCriteriaResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomerNegativeCriterionService.prototype.mutateCustomerNegativeCriteria = function mutateCustomerNegativeCriteria(request, callback) {
                            return this.rpcCall(mutateCustomerNegativeCriteria, $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest, $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse, request, callback);
                        }, "name", { value: "MutateCustomerNegativeCriteria" });

                        /**
                         * Calls MutateCustomerNegativeCriteria.
                         * @function mutateCustomerNegativeCriteria
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCustomerNegativeCriteriaRequest} request MutateCustomerNegativeCriteriaRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse>} Promise
                         * @variation 2
                         */

                        return CustomerNegativeCriterionService;
                    })();

                    services.GetCustomerNegativeCriterionRequest = (function() {

                        /**
                         * Properties of a GetCustomerNegativeCriterionRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCustomerNegativeCriterionRequest
                         * @property {string|null} [resourceName] GetCustomerNegativeCriterionRequest resourceName
                         */

                        /**
                         * Constructs a new GetCustomerNegativeCriterionRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCustomerNegativeCriterionRequest.
                         * @implements IGetCustomerNegativeCriterionRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCustomerNegativeCriterionRequest=} [properties] Properties to set
                         */
                        function GetCustomerNegativeCriterionRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCustomerNegativeCriterionRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest
                         * @instance
                         */
                        GetCustomerNegativeCriterionRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCustomerNegativeCriterionRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerNegativeCriterionRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest} GetCustomerNegativeCriterionRequest instance
                         */
                        GetCustomerNegativeCriterionRequest.create = function create(properties) {
                            return new GetCustomerNegativeCriterionRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCustomerNegativeCriterionRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerNegativeCriterionRequest} message GetCustomerNegativeCriterionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomerNegativeCriterionRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCustomerNegativeCriterionRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerNegativeCriterionRequest} message GetCustomerNegativeCriterionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomerNegativeCriterionRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCustomerNegativeCriterionRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest} GetCustomerNegativeCriterionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomerNegativeCriterionRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCustomerNegativeCriterionRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest} GetCustomerNegativeCriterionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomerNegativeCriterionRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCustomerNegativeCriterionRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCustomerNegativeCriterionRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCustomerNegativeCriterionRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest} GetCustomerNegativeCriterionRequest
                         */
                        GetCustomerNegativeCriterionRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCustomerNegativeCriterionRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest} message GetCustomerNegativeCriterionRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCustomerNegativeCriterionRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCustomerNegativeCriterionRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCustomerNegativeCriterionRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCustomerNegativeCriterionRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCustomerNegativeCriterionRequest;
                    })();

                    services.MutateCustomerNegativeCriteriaRequest = (function() {

                        /**
                         * Properties of a MutateCustomerNegativeCriteriaRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerNegativeCriteriaRequest
                         * @property {string|null} [customerId] MutateCustomerNegativeCriteriaRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.ICustomerNegativeCriterionOperation>|null} [operations] MutateCustomerNegativeCriteriaRequest operations
                         * @property {boolean|null} [partialFailure] MutateCustomerNegativeCriteriaRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateCustomerNegativeCriteriaRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateCustomerNegativeCriteriaRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerNegativeCriteriaRequest.
                         * @implements IMutateCustomerNegativeCriteriaRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerNegativeCriteriaRequest=} [properties] Properties to set
                         */
                        function MutateCustomerNegativeCriteriaRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerNegativeCriteriaRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest
                         * @instance
                         */
                        MutateCustomerNegativeCriteriaRequest.prototype.customerId = "";

                        /**
                         * MutateCustomerNegativeCriteriaRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.ICustomerNegativeCriterionOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest
                         * @instance
                         */
                        MutateCustomerNegativeCriteriaRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateCustomerNegativeCriteriaRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest
                         * @instance
                         */
                        MutateCustomerNegativeCriteriaRequest.prototype.partialFailure = false;

                        /**
                         * MutateCustomerNegativeCriteriaRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest
                         * @instance
                         */
                        MutateCustomerNegativeCriteriaRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateCustomerNegativeCriteriaRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerNegativeCriteriaRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest} MutateCustomerNegativeCriteriaRequest instance
                         */
                        MutateCustomerNegativeCriteriaRequest.create = function create(properties) {
                            return new MutateCustomerNegativeCriteriaRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerNegativeCriteriaRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerNegativeCriteriaRequest} message MutateCustomerNegativeCriteriaRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerNegativeCriteriaRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.CustomerNegativeCriterionOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerNegativeCriteriaRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerNegativeCriteriaRequest} message MutateCustomerNegativeCriteriaRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerNegativeCriteriaRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerNegativeCriteriaRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest} MutateCustomerNegativeCriteriaRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerNegativeCriteriaRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.CustomerNegativeCriterionOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerNegativeCriteriaRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest} MutateCustomerNegativeCriteriaRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerNegativeCriteriaRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerNegativeCriteriaRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerNegativeCriteriaRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.CustomerNegativeCriterionOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerNegativeCriteriaRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest} MutateCustomerNegativeCriteriaRequest
                         */
                        MutateCustomerNegativeCriteriaRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.CustomerNegativeCriterionOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerNegativeCriteriaRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest} message MutateCustomerNegativeCriteriaRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerNegativeCriteriaRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.CustomerNegativeCriterionOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerNegativeCriteriaRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerNegativeCriteriaRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerNegativeCriteriaRequest;
                    })();

                    services.CustomerNegativeCriterionOperation = (function() {

                        /**
                         * Properties of a CustomerNegativeCriterionOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICustomerNegativeCriterionOperation
                         * @property {google.ads.googleads.v1.resources.ICustomerNegativeCriterion|null} [create] CustomerNegativeCriterionOperation create
                         * @property {string|null} [remove] CustomerNegativeCriterionOperation remove
                         */

                        /**
                         * Constructs a new CustomerNegativeCriterionOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CustomerNegativeCriterionOperation.
                         * @implements ICustomerNegativeCriterionOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICustomerNegativeCriterionOperation=} [properties] Properties to set
                         */
                        function CustomerNegativeCriterionOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomerNegativeCriterionOperation create.
                         * @member {google.ads.googleads.v1.resources.ICustomerNegativeCriterion|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionOperation
                         * @instance
                         */
                        CustomerNegativeCriterionOperation.prototype.create = null;

                        /**
                         * CustomerNegativeCriterionOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionOperation
                         * @instance
                         */
                        CustomerNegativeCriterionOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * CustomerNegativeCriterionOperation operation.
                         * @member {"create"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionOperation
                         * @instance
                         */
                        Object.defineProperty(CustomerNegativeCriterionOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new CustomerNegativeCriterionOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerNegativeCriterionOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CustomerNegativeCriterionOperation} CustomerNegativeCriterionOperation instance
                         */
                        CustomerNegativeCriterionOperation.create = function create(properties) {
                            return new CustomerNegativeCriterionOperation(properties);
                        };

                        /**
                         * Encodes the specified CustomerNegativeCriterionOperation message. Does not implicitly {@link google.ads.googleads.v1.services.CustomerNegativeCriterionOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerNegativeCriterionOperation} message CustomerNegativeCriterionOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerNegativeCriterionOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.CustomerNegativeCriterion.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.remove);
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerNegativeCriterionOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CustomerNegativeCriterionOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerNegativeCriterionOperation} message CustomerNegativeCriterionOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerNegativeCriterionOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerNegativeCriterionOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CustomerNegativeCriterionOperation} CustomerNegativeCriterionOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerNegativeCriterionOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CustomerNegativeCriterionOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.CustomerNegativeCriterion.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerNegativeCriterionOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CustomerNegativeCriterionOperation} CustomerNegativeCriterionOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerNegativeCriterionOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerNegativeCriterionOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerNegativeCriterionOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.CustomerNegativeCriterion.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a CustomerNegativeCriterionOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CustomerNegativeCriterionOperation} CustomerNegativeCriterionOperation
                         */
                        CustomerNegativeCriterionOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CustomerNegativeCriterionOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CustomerNegativeCriterionOperation();
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CustomerNegativeCriterionOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.CustomerNegativeCriterion.fromObject(object.create);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomerNegativeCriterionOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.CustomerNegativeCriterionOperation} message CustomerNegativeCriterionOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerNegativeCriterionOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.CustomerNegativeCriterion.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            return object;
                        };

                        /**
                         * Converts this CustomerNegativeCriterionOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CustomerNegativeCriterionOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerNegativeCriterionOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomerNegativeCriterionOperation;
                    })();

                    services.MutateCustomerNegativeCriteriaResponse = (function() {

                        /**
                         * Properties of a MutateCustomerNegativeCriteriaResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerNegativeCriteriaResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateCustomerNegativeCriteriaResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateCustomerNegativeCriteriaResult>|null} [results] MutateCustomerNegativeCriteriaResponse results
                         */

                        /**
                         * Constructs a new MutateCustomerNegativeCriteriaResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerNegativeCriteriaResponse.
                         * @implements IMutateCustomerNegativeCriteriaResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerNegativeCriteriaResponse=} [properties] Properties to set
                         */
                        function MutateCustomerNegativeCriteriaResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerNegativeCriteriaResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse
                         * @instance
                         */
                        MutateCustomerNegativeCriteriaResponse.prototype.partialFailureError = null;

                        /**
                         * MutateCustomerNegativeCriteriaResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateCustomerNegativeCriteriaResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse
                         * @instance
                         */
                        MutateCustomerNegativeCriteriaResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateCustomerNegativeCriteriaResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerNegativeCriteriaResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse} MutateCustomerNegativeCriteriaResponse instance
                         */
                        MutateCustomerNegativeCriteriaResponse.create = function create(properties) {
                            return new MutateCustomerNegativeCriteriaResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerNegativeCriteriaResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerNegativeCriteriaResponse} message MutateCustomerNegativeCriteriaResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerNegativeCriteriaResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerNegativeCriteriaResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerNegativeCriteriaResponse} message MutateCustomerNegativeCriteriaResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerNegativeCriteriaResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerNegativeCriteriaResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse} MutateCustomerNegativeCriteriaResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerNegativeCriteriaResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerNegativeCriteriaResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse} MutateCustomerNegativeCriteriaResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerNegativeCriteriaResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerNegativeCriteriaResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerNegativeCriteriaResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerNegativeCriteriaResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse} MutateCustomerNegativeCriteriaResponse
                         */
                        MutateCustomerNegativeCriteriaResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerNegativeCriteriaResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse} message MutateCustomerNegativeCriteriaResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerNegativeCriteriaResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerNegativeCriteriaResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerNegativeCriteriaResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerNegativeCriteriaResponse;
                    })();

                    services.MutateCustomerNegativeCriteriaResult = (function() {

                        /**
                         * Properties of a MutateCustomerNegativeCriteriaResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerNegativeCriteriaResult
                         * @property {string|null} [resourceName] MutateCustomerNegativeCriteriaResult resourceName
                         */

                        /**
                         * Constructs a new MutateCustomerNegativeCriteriaResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerNegativeCriteriaResult.
                         * @implements IMutateCustomerNegativeCriteriaResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerNegativeCriteriaResult=} [properties] Properties to set
                         */
                        function MutateCustomerNegativeCriteriaResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerNegativeCriteriaResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult
                         * @instance
                         */
                        MutateCustomerNegativeCriteriaResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateCustomerNegativeCriteriaResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerNegativeCriteriaResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult} MutateCustomerNegativeCriteriaResult instance
                         */
                        MutateCustomerNegativeCriteriaResult.create = function create(properties) {
                            return new MutateCustomerNegativeCriteriaResult(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerNegativeCriteriaResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerNegativeCriteriaResult} message MutateCustomerNegativeCriteriaResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerNegativeCriteriaResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerNegativeCriteriaResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerNegativeCriteriaResult} message MutateCustomerNegativeCriteriaResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerNegativeCriteriaResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerNegativeCriteriaResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult} MutateCustomerNegativeCriteriaResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerNegativeCriteriaResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerNegativeCriteriaResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult} MutateCustomerNegativeCriteriaResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerNegativeCriteriaResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerNegativeCriteriaResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerNegativeCriteriaResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerNegativeCriteriaResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult} MutateCustomerNegativeCriteriaResult
                         */
                        MutateCustomerNegativeCriteriaResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerNegativeCriteriaResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult} message MutateCustomerNegativeCriteriaResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerNegativeCriteriaResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerNegativeCriteriaResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerNegativeCriteriaResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerNegativeCriteriaResult;
                    })();

                    services.CustomerService = (function() {

                        /**
                         * Constructs a new CustomerService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CustomerService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function CustomerService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (CustomerService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = CustomerService;

                        /**
                         * Creates new CustomerService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CustomerService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {CustomerService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        CustomerService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomerService#getCustomer}.
                         * @memberof google.ads.googleads.v1.services.CustomerService
                         * @typedef GetCustomerCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.Customer} [response] Customer
                         */

                        /**
                         * Calls GetCustomer.
                         * @function getCustomer
                         * @memberof google.ads.googleads.v1.services.CustomerService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCustomerRequest} request GetCustomerRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomerService.GetCustomerCallback} callback Node-style callback called with the error, if any, and Customer
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomerService.prototype.getCustomer = function getCustomer(request, callback) {
                            return this.rpcCall(getCustomer, $root.google.ads.googleads.v1.services.GetCustomerRequest, $root.google.ads.googleads.v1.resources.Customer, request, callback);
                        }, "name", { value: "GetCustomer" });

                        /**
                         * Calls GetCustomer.
                         * @function getCustomer
                         * @memberof google.ads.googleads.v1.services.CustomerService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetCustomerRequest} request GetCustomerRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.Customer>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomerService#mutateCustomer}.
                         * @memberof google.ads.googleads.v1.services.CustomerService
                         * @typedef MutateCustomerCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateCustomerResponse} [response] MutateCustomerResponse
                         */

                        /**
                         * Calls MutateCustomer.
                         * @function mutateCustomer
                         * @memberof google.ads.googleads.v1.services.CustomerService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCustomerRequest} request MutateCustomerRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomerService.MutateCustomerCallback} callback Node-style callback called with the error, if any, and MutateCustomerResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomerService.prototype.mutateCustomer = function mutateCustomer(request, callback) {
                            return this.rpcCall(mutateCustomer, $root.google.ads.googleads.v1.services.MutateCustomerRequest, $root.google.ads.googleads.v1.services.MutateCustomerResponse, request, callback);
                        }, "name", { value: "MutateCustomer" });

                        /**
                         * Calls MutateCustomer.
                         * @function mutateCustomer
                         * @memberof google.ads.googleads.v1.services.CustomerService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateCustomerRequest} request MutateCustomerRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateCustomerResponse>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomerService#listAccessibleCustomers}.
                         * @memberof google.ads.googleads.v1.services.CustomerService
                         * @typedef ListAccessibleCustomersCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.ListAccessibleCustomersResponse} [response] ListAccessibleCustomersResponse
                         */

                        /**
                         * Calls ListAccessibleCustomers.
                         * @function listAccessibleCustomers
                         * @memberof google.ads.googleads.v1.services.CustomerService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IListAccessibleCustomersRequest} request ListAccessibleCustomersRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomerService.ListAccessibleCustomersCallback} callback Node-style callback called with the error, if any, and ListAccessibleCustomersResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomerService.prototype.listAccessibleCustomers = function listAccessibleCustomers(request, callback) {
                            return this.rpcCall(listAccessibleCustomers, $root.google.ads.googleads.v1.services.ListAccessibleCustomersRequest, $root.google.ads.googleads.v1.services.ListAccessibleCustomersResponse, request, callback);
                        }, "name", { value: "ListAccessibleCustomers" });

                        /**
                         * Calls ListAccessibleCustomers.
                         * @function listAccessibleCustomers
                         * @memberof google.ads.googleads.v1.services.CustomerService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IListAccessibleCustomersRequest} request ListAccessibleCustomersRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.ListAccessibleCustomersResponse>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.CustomerService#createCustomerClient}.
                         * @memberof google.ads.googleads.v1.services.CustomerService
                         * @typedef CreateCustomerClientCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.CreateCustomerClientResponse} [response] CreateCustomerClientResponse
                         */

                        /**
                         * Calls CreateCustomerClient.
                         * @function createCustomerClient
                         * @memberof google.ads.googleads.v1.services.CustomerService
                         * @instance
                         * @param {google.ads.googleads.v1.services.ICreateCustomerClientRequest} request CreateCustomerClientRequest message or plain object
                         * @param {google.ads.googleads.v1.services.CustomerService.CreateCustomerClientCallback} callback Node-style callback called with the error, if any, and CreateCustomerClientResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(CustomerService.prototype.createCustomerClient = function createCustomerClient(request, callback) {
                            return this.rpcCall(createCustomerClient, $root.google.ads.googleads.v1.services.CreateCustomerClientRequest, $root.google.ads.googleads.v1.services.CreateCustomerClientResponse, request, callback);
                        }, "name", { value: "CreateCustomerClient" });

                        /**
                         * Calls CreateCustomerClient.
                         * @function createCustomerClient
                         * @memberof google.ads.googleads.v1.services.CustomerService
                         * @instance
                         * @param {google.ads.googleads.v1.services.ICreateCustomerClientRequest} request CreateCustomerClientRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.CreateCustomerClientResponse>} Promise
                         * @variation 2
                         */

                        return CustomerService;
                    })();

                    services.GetCustomerRequest = (function() {

                        /**
                         * Properties of a GetCustomerRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetCustomerRequest
                         * @property {string|null} [resourceName] GetCustomerRequest resourceName
                         */

                        /**
                         * Constructs a new GetCustomerRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetCustomerRequest.
                         * @implements IGetCustomerRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetCustomerRequest=} [properties] Properties to set
                         */
                        function GetCustomerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetCustomerRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetCustomerRequest
                         * @instance
                         */
                        GetCustomerRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetCustomerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetCustomerRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetCustomerRequest} GetCustomerRequest instance
                         */
                        GetCustomerRequest.create = function create(properties) {
                            return new GetCustomerRequest(properties);
                        };

                        /**
                         * Encodes the specified GetCustomerRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetCustomerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetCustomerRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerRequest} message GetCustomerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetCustomerRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetCustomerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCustomerRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetCustomerRequest} message GetCustomerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetCustomerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetCustomerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetCustomerRequest} GetCustomerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetCustomerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetCustomerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetCustomerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetCustomerRequest} GetCustomerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetCustomerRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetCustomerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCustomerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetCustomerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetCustomerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetCustomerRequest} GetCustomerRequest
                         */
                        GetCustomerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetCustomerRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetCustomerRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetCustomerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetCustomerRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetCustomerRequest} message GetCustomerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCustomerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetCustomerRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetCustomerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCustomerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetCustomerRequest;
                    })();

                    services.MutateCustomerRequest = (function() {

                        /**
                         * Properties of a MutateCustomerRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerRequest
                         * @property {string|null} [customerId] MutateCustomerRequest customerId
                         * @property {google.ads.googleads.v1.services.ICustomerOperation|null} [operation] MutateCustomerRequest operation
                         * @property {boolean|null} [validateOnly] MutateCustomerRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateCustomerRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerRequest.
                         * @implements IMutateCustomerRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerRequest=} [properties] Properties to set
                         */
                        function MutateCustomerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateCustomerRequest
                         * @instance
                         */
                        MutateCustomerRequest.prototype.customerId = "";

                        /**
                         * MutateCustomerRequest operation.
                         * @member {google.ads.googleads.v1.services.ICustomerOperation|null|undefined} operation
                         * @memberof google.ads.googleads.v1.services.MutateCustomerRequest
                         * @instance
                         */
                        MutateCustomerRequest.prototype.operation = null;

                        /**
                         * MutateCustomerRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateCustomerRequest
                         * @instance
                         */
                        MutateCustomerRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateCustomerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerRequest} MutateCustomerRequest instance
                         */
                        MutateCustomerRequest.create = function create(properties) {
                            return new MutateCustomerRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerRequest} message MutateCustomerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                $root.google.ads.googleads.v1.services.CustomerOperation.encode(message.operation, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 5, wireType 0 =*/40).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerRequest} message MutateCustomerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerRequest} MutateCustomerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 4:
                                    message.operation = $root.google.ads.googleads.v1.services.CustomerOperation.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerRequest} MutateCustomerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operation != null && message.hasOwnProperty("operation")) {
                                var error = $root.google.ads.googleads.v1.services.CustomerOperation.verify(message.operation);
                                if (error)
                                    return "operation." + error;
                            }
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerRequest} MutateCustomerRequest
                         */
                        MutateCustomerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operation != null) {
                                if (typeof object.operation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomerRequest.operation: object expected");
                                message.operation = $root.google.ads.googleads.v1.services.CustomerOperation.fromObject(object.operation);
                            }
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerRequest} message MutateCustomerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.customerId = "";
                                object.operation = null;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = $root.google.ads.googleads.v1.services.CustomerOperation.toObject(message.operation, options);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerRequest;
                    })();

                    services.CreateCustomerClientRequest = (function() {

                        /**
                         * Properties of a CreateCustomerClientRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICreateCustomerClientRequest
                         * @property {string|null} [customerId] CreateCustomerClientRequest customerId
                         * @property {google.ads.googleads.v1.resources.ICustomer|null} [customerClient] CreateCustomerClientRequest customerClient
                         */

                        /**
                         * Constructs a new CreateCustomerClientRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CreateCustomerClientRequest.
                         * @implements ICreateCustomerClientRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICreateCustomerClientRequest=} [properties] Properties to set
                         */
                        function CreateCustomerClientRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CreateCustomerClientRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientRequest
                         * @instance
                         */
                        CreateCustomerClientRequest.prototype.customerId = "";

                        /**
                         * CreateCustomerClientRequest customerClient.
                         * @member {google.ads.googleads.v1.resources.ICustomer|null|undefined} customerClient
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientRequest
                         * @instance
                         */
                        CreateCustomerClientRequest.prototype.customerClient = null;

                        /**
                         * Creates a new CreateCustomerClientRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ICreateCustomerClientRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CreateCustomerClientRequest} CreateCustomerClientRequest instance
                         */
                        CreateCustomerClientRequest.create = function create(properties) {
                            return new CreateCustomerClientRequest(properties);
                        };

                        /**
                         * Encodes the specified CreateCustomerClientRequest message. Does not implicitly {@link google.ads.googleads.v1.services.CreateCustomerClientRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ICreateCustomerClientRequest} message CreateCustomerClientRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateCustomerClientRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.customerClient != null && message.hasOwnProperty("customerClient"))
                                $root.google.ads.googleads.v1.resources.Customer.encode(message.customerClient, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CreateCustomerClientRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CreateCustomerClientRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ICreateCustomerClientRequest} message CreateCustomerClientRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateCustomerClientRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CreateCustomerClientRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CreateCustomerClientRequest} CreateCustomerClientRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateCustomerClientRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CreateCustomerClientRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    message.customerClient = $root.google.ads.googleads.v1.resources.Customer.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CreateCustomerClientRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CreateCustomerClientRequest} CreateCustomerClientRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateCustomerClientRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CreateCustomerClientRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateCustomerClientRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.customerClient != null && message.hasOwnProperty("customerClient")) {
                                var error = $root.google.ads.googleads.v1.resources.Customer.verify(message.customerClient);
                                if (error)
                                    return "customerClient." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CreateCustomerClientRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CreateCustomerClientRequest} CreateCustomerClientRequest
                         */
                        CreateCustomerClientRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CreateCustomerClientRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CreateCustomerClientRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.customerClient != null) {
                                if (typeof object.customerClient !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CreateCustomerClientRequest.customerClient: object expected");
                                message.customerClient = $root.google.ads.googleads.v1.resources.Customer.fromObject(object.customerClient);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CreateCustomerClientRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.CreateCustomerClientRequest} message CreateCustomerClientRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateCustomerClientRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.customerId = "";
                                object.customerClient = null;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.customerClient != null && message.hasOwnProperty("customerClient"))
                                object.customerClient = $root.google.ads.googleads.v1.resources.Customer.toObject(message.customerClient, options);
                            return object;
                        };

                        /**
                         * Converts this CreateCustomerClientRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateCustomerClientRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CreateCustomerClientRequest;
                    })();

                    services.CustomerOperation = (function() {

                        /**
                         * Properties of a CustomerOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICustomerOperation
                         * @property {google.ads.googleads.v1.resources.ICustomer|null} [update] CustomerOperation update
                         * @property {google.protobuf.IFieldMask|null} [updateMask] CustomerOperation updateMask
                         */

                        /**
                         * Constructs a new CustomerOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CustomerOperation.
                         * @implements ICustomerOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICustomerOperation=} [properties] Properties to set
                         */
                        function CustomerOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CustomerOperation update.
                         * @member {google.ads.googleads.v1.resources.ICustomer|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.CustomerOperation
                         * @instance
                         */
                        CustomerOperation.prototype.update = null;

                        /**
                         * CustomerOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.CustomerOperation
                         * @instance
                         */
                        CustomerOperation.prototype.updateMask = null;

                        /**
                         * Creates a new CustomerOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CustomerOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CustomerOperation} CustomerOperation instance
                         */
                        CustomerOperation.create = function create(properties) {
                            return new CustomerOperation(properties);
                        };

                        /**
                         * Encodes the specified CustomerOperation message. Does not implicitly {@link google.ads.googleads.v1.services.CustomerOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CustomerOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerOperation} message CustomerOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.Customer.encode(message.update, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified CustomerOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CustomerOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CustomerOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ICustomerOperation} message CustomerOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CustomerOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CustomerOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CustomerOperation} CustomerOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CustomerOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.update = $root.google.ads.googleads.v1.resources.Customer.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CustomerOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CustomerOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CustomerOperation} CustomerOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CustomerOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CustomerOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.update != null && message.hasOwnProperty("update")) {
                                var error = $root.google.ads.googleads.v1.resources.Customer.verify(message.update);
                                if (error)
                                    return "update." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a CustomerOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CustomerOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CustomerOperation} CustomerOperation
                         */
                        CustomerOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CustomerOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CustomerOperation();
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CustomerOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.Customer.fromObject(object.update);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.CustomerOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a CustomerOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CustomerOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.CustomerOperation} message CustomerOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.update = null;
                                object.updateMask = null;
                            }
                            if (message.update != null && message.hasOwnProperty("update"))
                                object.update = $root.google.ads.googleads.v1.resources.Customer.toObject(message.update, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this CustomerOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CustomerOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CustomerOperation;
                    })();

                    services.CreateCustomerClientResponse = (function() {

                        /**
                         * Properties of a CreateCustomerClientResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICreateCustomerClientResponse
                         * @property {string|null} [resourceName] CreateCustomerClientResponse resourceName
                         */

                        /**
                         * Constructs a new CreateCustomerClientResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CreateCustomerClientResponse.
                         * @implements ICreateCustomerClientResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICreateCustomerClientResponse=} [properties] Properties to set
                         */
                        function CreateCustomerClientResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CreateCustomerClientResponse resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientResponse
                         * @instance
                         */
                        CreateCustomerClientResponse.prototype.resourceName = "";

                        /**
                         * Creates a new CreateCustomerClientResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ICreateCustomerClientResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CreateCustomerClientResponse} CreateCustomerClientResponse instance
                         */
                        CreateCustomerClientResponse.create = function create(properties) {
                            return new CreateCustomerClientResponse(properties);
                        };

                        /**
                         * Encodes the specified CreateCustomerClientResponse message. Does not implicitly {@link google.ads.googleads.v1.services.CreateCustomerClientResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ICreateCustomerClientResponse} message CreateCustomerClientResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateCustomerClientResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified CreateCustomerClientResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CreateCustomerClientResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ICreateCustomerClientResponse} message CreateCustomerClientResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateCustomerClientResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CreateCustomerClientResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CreateCustomerClientResponse} CreateCustomerClientResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateCustomerClientResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CreateCustomerClientResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CreateCustomerClientResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CreateCustomerClientResponse} CreateCustomerClientResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateCustomerClientResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CreateCustomerClientResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateCustomerClientResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a CreateCustomerClientResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CreateCustomerClientResponse} CreateCustomerClientResponse
                         */
                        CreateCustomerClientResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CreateCustomerClientResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CreateCustomerClientResponse();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a CreateCustomerClientResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.CreateCustomerClientResponse} message CreateCustomerClientResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateCustomerClientResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this CreateCustomerClientResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CreateCustomerClientResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateCustomerClientResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CreateCustomerClientResponse;
                    })();

                    services.MutateCustomerResponse = (function() {

                        /**
                         * Properties of a MutateCustomerResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerResponse
                         * @property {google.ads.googleads.v1.services.IMutateCustomerResult|null} [result] MutateCustomerResponse result
                         */

                        /**
                         * Constructs a new MutateCustomerResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerResponse.
                         * @implements IMutateCustomerResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerResponse=} [properties] Properties to set
                         */
                        function MutateCustomerResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerResponse result.
                         * @member {google.ads.googleads.v1.services.IMutateCustomerResult|null|undefined} result
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResponse
                         * @instance
                         */
                        MutateCustomerResponse.prototype.result = null;

                        /**
                         * Creates a new MutateCustomerResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerResponse} MutateCustomerResponse instance
                         */
                        MutateCustomerResponse.create = function create(properties) {
                            return new MutateCustomerResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerResponse} message MutateCustomerResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.result != null && message.hasOwnProperty("result"))
                                $root.google.ads.googleads.v1.services.MutateCustomerResult.encode(message.result, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerResponse} message MutateCustomerResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerResponse} MutateCustomerResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2:
                                    message.result = $root.google.ads.googleads.v1.services.MutateCustomerResult.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerResponse} MutateCustomerResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.result != null && message.hasOwnProperty("result")) {
                                var error = $root.google.ads.googleads.v1.services.MutateCustomerResult.verify(message.result);
                                if (error)
                                    return "result." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerResponse} MutateCustomerResponse
                         */
                        MutateCustomerResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerResponse();
                            if (object.result != null) {
                                if (typeof object.result !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateCustomerResponse.result: object expected");
                                message.result = $root.google.ads.googleads.v1.services.MutateCustomerResult.fromObject(object.result);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerResponse} message MutateCustomerResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.result = null;
                            if (message.result != null && message.hasOwnProperty("result"))
                                object.result = $root.google.ads.googleads.v1.services.MutateCustomerResult.toObject(message.result, options);
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerResponse;
                    })();

                    services.MutateCustomerResult = (function() {

                        /**
                         * Properties of a MutateCustomerResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateCustomerResult
                         * @property {string|null} [resourceName] MutateCustomerResult resourceName
                         */

                        /**
                         * Constructs a new MutateCustomerResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateCustomerResult.
                         * @implements IMutateCustomerResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateCustomerResult=} [properties] Properties to set
                         */
                        function MutateCustomerResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateCustomerResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResult
                         * @instance
                         */
                        MutateCustomerResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateCustomerResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateCustomerResult} MutateCustomerResult instance
                         */
                        MutateCustomerResult.create = function create(properties) {
                            return new MutateCustomerResult(properties);
                        };

                        /**
                         * Encodes the specified MutateCustomerResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerResult} message MutateCustomerResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateCustomerResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateCustomerResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateCustomerResult} message MutateCustomerResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateCustomerResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateCustomerResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateCustomerResult} MutateCustomerResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateCustomerResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateCustomerResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateCustomerResult} MutateCustomerResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateCustomerResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateCustomerResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateCustomerResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateCustomerResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateCustomerResult} MutateCustomerResult
                         */
                        MutateCustomerResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateCustomerResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateCustomerResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateCustomerResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateCustomerResult} message MutateCustomerResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateCustomerResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateCustomerResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateCustomerResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateCustomerResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateCustomerResult;
                    })();

                    services.ListAccessibleCustomersRequest = (function() {

                        /**
                         * Properties of a ListAccessibleCustomersRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IListAccessibleCustomersRequest
                         */

                        /**
                         * Constructs a new ListAccessibleCustomersRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ListAccessibleCustomersRequest.
                         * @implements IListAccessibleCustomersRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IListAccessibleCustomersRequest=} [properties] Properties to set
                         */
                        function ListAccessibleCustomersRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * Creates a new ListAccessibleCustomersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IListAccessibleCustomersRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ListAccessibleCustomersRequest} ListAccessibleCustomersRequest instance
                         */
                        ListAccessibleCustomersRequest.create = function create(properties) {
                            return new ListAccessibleCustomersRequest(properties);
                        };

                        /**
                         * Encodes the specified ListAccessibleCustomersRequest message. Does not implicitly {@link google.ads.googleads.v1.services.ListAccessibleCustomersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IListAccessibleCustomersRequest} message ListAccessibleCustomersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccessibleCustomersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };

                        /**
                         * Encodes the specified ListAccessibleCustomersRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ListAccessibleCustomersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IListAccessibleCustomersRequest} message ListAccessibleCustomersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccessibleCustomersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ListAccessibleCustomersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ListAccessibleCustomersRequest} ListAccessibleCustomersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccessibleCustomersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ListAccessibleCustomersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ListAccessibleCustomersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ListAccessibleCustomersRequest} ListAccessibleCustomersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccessibleCustomersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ListAccessibleCustomersRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAccessibleCustomersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };

                        /**
                         * Creates a ListAccessibleCustomersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ListAccessibleCustomersRequest} ListAccessibleCustomersRequest
                         */
                        ListAccessibleCustomersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ListAccessibleCustomersRequest)
                                return object;
                            return new $root.google.ads.googleads.v1.services.ListAccessibleCustomersRequest();
                        };

                        /**
                         * Creates a plain object from a ListAccessibleCustomersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ListAccessibleCustomersRequest} message ListAccessibleCustomersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAccessibleCustomersRequest.toObject = function toObject() {
                            return {};
                        };

                        /**
                         * Converts this ListAccessibleCustomersRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAccessibleCustomersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ListAccessibleCustomersRequest;
                    })();

                    services.ListAccessibleCustomersResponse = (function() {

                        /**
                         * Properties of a ListAccessibleCustomersResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IListAccessibleCustomersResponse
                         * @property {Array.<string>|null} [resourceNames] ListAccessibleCustomersResponse resourceNames
                         */

                        /**
                         * Constructs a new ListAccessibleCustomersResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ListAccessibleCustomersResponse.
                         * @implements IListAccessibleCustomersResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IListAccessibleCustomersResponse=} [properties] Properties to set
                         */
                        function ListAccessibleCustomersResponse(properties) {
                            this.resourceNames = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ListAccessibleCustomersResponse resourceNames.
                         * @member {Array.<string>} resourceNames
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersResponse
                         * @instance
                         */
                        ListAccessibleCustomersResponse.prototype.resourceNames = $util.emptyArray;

                        /**
                         * Creates a new ListAccessibleCustomersResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IListAccessibleCustomersResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ListAccessibleCustomersResponse} ListAccessibleCustomersResponse instance
                         */
                        ListAccessibleCustomersResponse.create = function create(properties) {
                            return new ListAccessibleCustomersResponse(properties);
                        };

                        /**
                         * Encodes the specified ListAccessibleCustomersResponse message. Does not implicitly {@link google.ads.googleads.v1.services.ListAccessibleCustomersResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IListAccessibleCustomersResponse} message ListAccessibleCustomersResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccessibleCustomersResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceNames != null && message.resourceNames.length)
                                for (var i = 0; i < message.resourceNames.length; ++i)
                                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceNames[i]);
                            return writer;
                        };

                        /**
                         * Encodes the specified ListAccessibleCustomersResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ListAccessibleCustomersResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IListAccessibleCustomersResponse} message ListAccessibleCustomersResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccessibleCustomersResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ListAccessibleCustomersResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ListAccessibleCustomersResponse} ListAccessibleCustomersResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccessibleCustomersResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ListAccessibleCustomersResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.resourceNames && message.resourceNames.length))
                                        message.resourceNames = [];
                                    message.resourceNames.push(reader.string());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ListAccessibleCustomersResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ListAccessibleCustomersResponse} ListAccessibleCustomersResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccessibleCustomersResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ListAccessibleCustomersResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAccessibleCustomersResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceNames != null && message.hasOwnProperty("resourceNames")) {
                                if (!Array.isArray(message.resourceNames))
                                    return "resourceNames: array expected";
                                for (var i = 0; i < message.resourceNames.length; ++i)
                                    if (!$util.isString(message.resourceNames[i]))
                                        return "resourceNames: string[] expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a ListAccessibleCustomersResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ListAccessibleCustomersResponse} ListAccessibleCustomersResponse
                         */
                        ListAccessibleCustomersResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ListAccessibleCustomersResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ListAccessibleCustomersResponse();
                            if (object.resourceNames) {
                                if (!Array.isArray(object.resourceNames))
                                    throw TypeError(".google.ads.googleads.v1.services.ListAccessibleCustomersResponse.resourceNames: array expected");
                                message.resourceNames = [];
                                for (var i = 0; i < object.resourceNames.length; ++i)
                                    message.resourceNames[i] = String(object.resourceNames[i]);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ListAccessibleCustomersResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ListAccessibleCustomersResponse} message ListAccessibleCustomersResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAccessibleCustomersResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.resourceNames = [];
                            if (message.resourceNames && message.resourceNames.length) {
                                object.resourceNames = [];
                                for (var j = 0; j < message.resourceNames.length; ++j)
                                    object.resourceNames[j] = message.resourceNames[j];
                            }
                            return object;
                        };

                        /**
                         * Converts this ListAccessibleCustomersResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ListAccessibleCustomersResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAccessibleCustomersResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ListAccessibleCustomersResponse;
                    })();

                    services.DetailPlacementViewService = (function() {

                        /**
                         * Constructs a new DetailPlacementViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a DetailPlacementViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function DetailPlacementViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (DetailPlacementViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = DetailPlacementViewService;

                        /**
                         * Creates new DetailPlacementViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.DetailPlacementViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {DetailPlacementViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        DetailPlacementViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.DetailPlacementViewService#getDetailPlacementView}.
                         * @memberof google.ads.googleads.v1.services.DetailPlacementViewService
                         * @typedef GetDetailPlacementViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.DetailPlacementView} [response] DetailPlacementView
                         */

                        /**
                         * Calls GetDetailPlacementView.
                         * @function getDetailPlacementView
                         * @memberof google.ads.googleads.v1.services.DetailPlacementViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetDetailPlacementViewRequest} request GetDetailPlacementViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.DetailPlacementViewService.GetDetailPlacementViewCallback} callback Node-style callback called with the error, if any, and DetailPlacementView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(DetailPlacementViewService.prototype.getDetailPlacementView = function getDetailPlacementView(request, callback) {
                            return this.rpcCall(getDetailPlacementView, $root.google.ads.googleads.v1.services.GetDetailPlacementViewRequest, $root.google.ads.googleads.v1.resources.DetailPlacementView, request, callback);
                        }, "name", { value: "GetDetailPlacementView" });

                        /**
                         * Calls GetDetailPlacementView.
                         * @function getDetailPlacementView
                         * @memberof google.ads.googleads.v1.services.DetailPlacementViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetDetailPlacementViewRequest} request GetDetailPlacementViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.DetailPlacementView>} Promise
                         * @variation 2
                         */

                        return DetailPlacementViewService;
                    })();

                    services.GetDetailPlacementViewRequest = (function() {

                        /**
                         * Properties of a GetDetailPlacementViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetDetailPlacementViewRequest
                         * @property {string|null} [resourceName] GetDetailPlacementViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetDetailPlacementViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetDetailPlacementViewRequest.
                         * @implements IGetDetailPlacementViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetDetailPlacementViewRequest=} [properties] Properties to set
                         */
                        function GetDetailPlacementViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetDetailPlacementViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetDetailPlacementViewRequest
                         * @instance
                         */
                        GetDetailPlacementViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetDetailPlacementViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetDetailPlacementViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetDetailPlacementViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetDetailPlacementViewRequest} GetDetailPlacementViewRequest instance
                         */
                        GetDetailPlacementViewRequest.create = function create(properties) {
                            return new GetDetailPlacementViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetDetailPlacementViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetDetailPlacementViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetDetailPlacementViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetDetailPlacementViewRequest} message GetDetailPlacementViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDetailPlacementViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetDetailPlacementViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetDetailPlacementViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetDetailPlacementViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetDetailPlacementViewRequest} message GetDetailPlacementViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDetailPlacementViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetDetailPlacementViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetDetailPlacementViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetDetailPlacementViewRequest} GetDetailPlacementViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDetailPlacementViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetDetailPlacementViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetDetailPlacementViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetDetailPlacementViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetDetailPlacementViewRequest} GetDetailPlacementViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDetailPlacementViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetDetailPlacementViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetDetailPlacementViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetDetailPlacementViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetDetailPlacementViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetDetailPlacementViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetDetailPlacementViewRequest} GetDetailPlacementViewRequest
                         */
                        GetDetailPlacementViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetDetailPlacementViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetDetailPlacementViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetDetailPlacementViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetDetailPlacementViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetDetailPlacementViewRequest} message GetDetailPlacementViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetDetailPlacementViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetDetailPlacementViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetDetailPlacementViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetDetailPlacementViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetDetailPlacementViewRequest;
                    })();

                    services.DisplayKeywordViewService = (function() {

                        /**
                         * Constructs a new DisplayKeywordViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a DisplayKeywordViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function DisplayKeywordViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (DisplayKeywordViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = DisplayKeywordViewService;

                        /**
                         * Creates new DisplayKeywordViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.DisplayKeywordViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {DisplayKeywordViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        DisplayKeywordViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.DisplayKeywordViewService#getDisplayKeywordView}.
                         * @memberof google.ads.googleads.v1.services.DisplayKeywordViewService
                         * @typedef GetDisplayKeywordViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.DisplayKeywordView} [response] DisplayKeywordView
                         */

                        /**
                         * Calls GetDisplayKeywordView.
                         * @function getDisplayKeywordView
                         * @memberof google.ads.googleads.v1.services.DisplayKeywordViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetDisplayKeywordViewRequest} request GetDisplayKeywordViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.DisplayKeywordViewService.GetDisplayKeywordViewCallback} callback Node-style callback called with the error, if any, and DisplayKeywordView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(DisplayKeywordViewService.prototype.getDisplayKeywordView = function getDisplayKeywordView(request, callback) {
                            return this.rpcCall(getDisplayKeywordView, $root.google.ads.googleads.v1.services.GetDisplayKeywordViewRequest, $root.google.ads.googleads.v1.resources.DisplayKeywordView, request, callback);
                        }, "name", { value: "GetDisplayKeywordView" });

                        /**
                         * Calls GetDisplayKeywordView.
                         * @function getDisplayKeywordView
                         * @memberof google.ads.googleads.v1.services.DisplayKeywordViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetDisplayKeywordViewRequest} request GetDisplayKeywordViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.DisplayKeywordView>} Promise
                         * @variation 2
                         */

                        return DisplayKeywordViewService;
                    })();

                    services.GetDisplayKeywordViewRequest = (function() {

                        /**
                         * Properties of a GetDisplayKeywordViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetDisplayKeywordViewRequest
                         * @property {string|null} [resourceName] GetDisplayKeywordViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetDisplayKeywordViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetDisplayKeywordViewRequest.
                         * @implements IGetDisplayKeywordViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetDisplayKeywordViewRequest=} [properties] Properties to set
                         */
                        function GetDisplayKeywordViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetDisplayKeywordViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetDisplayKeywordViewRequest
                         * @instance
                         */
                        GetDisplayKeywordViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetDisplayKeywordViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetDisplayKeywordViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetDisplayKeywordViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetDisplayKeywordViewRequest} GetDisplayKeywordViewRequest instance
                         */
                        GetDisplayKeywordViewRequest.create = function create(properties) {
                            return new GetDisplayKeywordViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetDisplayKeywordViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetDisplayKeywordViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetDisplayKeywordViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetDisplayKeywordViewRequest} message GetDisplayKeywordViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDisplayKeywordViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetDisplayKeywordViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetDisplayKeywordViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetDisplayKeywordViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetDisplayKeywordViewRequest} message GetDisplayKeywordViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDisplayKeywordViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetDisplayKeywordViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetDisplayKeywordViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetDisplayKeywordViewRequest} GetDisplayKeywordViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDisplayKeywordViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetDisplayKeywordViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetDisplayKeywordViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetDisplayKeywordViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetDisplayKeywordViewRequest} GetDisplayKeywordViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDisplayKeywordViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetDisplayKeywordViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetDisplayKeywordViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetDisplayKeywordViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetDisplayKeywordViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetDisplayKeywordViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetDisplayKeywordViewRequest} GetDisplayKeywordViewRequest
                         */
                        GetDisplayKeywordViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetDisplayKeywordViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetDisplayKeywordViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetDisplayKeywordViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetDisplayKeywordViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetDisplayKeywordViewRequest} message GetDisplayKeywordViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetDisplayKeywordViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetDisplayKeywordViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetDisplayKeywordViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetDisplayKeywordViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetDisplayKeywordViewRequest;
                    })();

                    services.DomainCategoryService = (function() {

                        /**
                         * Constructs a new DomainCategoryService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a DomainCategoryService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function DomainCategoryService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (DomainCategoryService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = DomainCategoryService;

                        /**
                         * Creates new DomainCategoryService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.DomainCategoryService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {DomainCategoryService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        DomainCategoryService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.DomainCategoryService#getDomainCategory}.
                         * @memberof google.ads.googleads.v1.services.DomainCategoryService
                         * @typedef GetDomainCategoryCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.DomainCategory} [response] DomainCategory
                         */

                        /**
                         * Calls GetDomainCategory.
                         * @function getDomainCategory
                         * @memberof google.ads.googleads.v1.services.DomainCategoryService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetDomainCategoryRequest} request GetDomainCategoryRequest message or plain object
                         * @param {google.ads.googleads.v1.services.DomainCategoryService.GetDomainCategoryCallback} callback Node-style callback called with the error, if any, and DomainCategory
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(DomainCategoryService.prototype.getDomainCategory = function getDomainCategory(request, callback) {
                            return this.rpcCall(getDomainCategory, $root.google.ads.googleads.v1.services.GetDomainCategoryRequest, $root.google.ads.googleads.v1.resources.DomainCategory, request, callback);
                        }, "name", { value: "GetDomainCategory" });

                        /**
                         * Calls GetDomainCategory.
                         * @function getDomainCategory
                         * @memberof google.ads.googleads.v1.services.DomainCategoryService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetDomainCategoryRequest} request GetDomainCategoryRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.DomainCategory>} Promise
                         * @variation 2
                         */

                        return DomainCategoryService;
                    })();

                    services.GetDomainCategoryRequest = (function() {

                        /**
                         * Properties of a GetDomainCategoryRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetDomainCategoryRequest
                         * @property {string|null} [resourceName] GetDomainCategoryRequest resourceName
                         */

                        /**
                         * Constructs a new GetDomainCategoryRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetDomainCategoryRequest.
                         * @implements IGetDomainCategoryRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetDomainCategoryRequest=} [properties] Properties to set
                         */
                        function GetDomainCategoryRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetDomainCategoryRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetDomainCategoryRequest
                         * @instance
                         */
                        GetDomainCategoryRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetDomainCategoryRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetDomainCategoryRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetDomainCategoryRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetDomainCategoryRequest} GetDomainCategoryRequest instance
                         */
                        GetDomainCategoryRequest.create = function create(properties) {
                            return new GetDomainCategoryRequest(properties);
                        };

                        /**
                         * Encodes the specified GetDomainCategoryRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetDomainCategoryRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetDomainCategoryRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetDomainCategoryRequest} message GetDomainCategoryRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDomainCategoryRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetDomainCategoryRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetDomainCategoryRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetDomainCategoryRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetDomainCategoryRequest} message GetDomainCategoryRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDomainCategoryRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetDomainCategoryRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetDomainCategoryRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetDomainCategoryRequest} GetDomainCategoryRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDomainCategoryRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetDomainCategoryRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetDomainCategoryRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetDomainCategoryRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetDomainCategoryRequest} GetDomainCategoryRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDomainCategoryRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetDomainCategoryRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetDomainCategoryRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetDomainCategoryRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetDomainCategoryRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetDomainCategoryRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetDomainCategoryRequest} GetDomainCategoryRequest
                         */
                        GetDomainCategoryRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetDomainCategoryRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetDomainCategoryRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetDomainCategoryRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetDomainCategoryRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetDomainCategoryRequest} message GetDomainCategoryRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetDomainCategoryRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetDomainCategoryRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetDomainCategoryRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetDomainCategoryRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetDomainCategoryRequest;
                    })();

                    services.DynamicSearchAdsSearchTermViewService = (function() {

                        /**
                         * Constructs a new DynamicSearchAdsSearchTermViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a DynamicSearchAdsSearchTermViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function DynamicSearchAdsSearchTermViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (DynamicSearchAdsSearchTermViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = DynamicSearchAdsSearchTermViewService;

                        /**
                         * Creates new DynamicSearchAdsSearchTermViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.DynamicSearchAdsSearchTermViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {DynamicSearchAdsSearchTermViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        DynamicSearchAdsSearchTermViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.DynamicSearchAdsSearchTermViewService#getDynamicSearchAdsSearchTermView}.
                         * @memberof google.ads.googleads.v1.services.DynamicSearchAdsSearchTermViewService
                         * @typedef GetDynamicSearchAdsSearchTermViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView} [response] DynamicSearchAdsSearchTermView
                         */

                        /**
                         * Calls GetDynamicSearchAdsSearchTermView.
                         * @function getDynamicSearchAdsSearchTermView
                         * @memberof google.ads.googleads.v1.services.DynamicSearchAdsSearchTermViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetDynamicSearchAdsSearchTermViewRequest} request GetDynamicSearchAdsSearchTermViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.DynamicSearchAdsSearchTermViewService.GetDynamicSearchAdsSearchTermViewCallback} callback Node-style callback called with the error, if any, and DynamicSearchAdsSearchTermView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(DynamicSearchAdsSearchTermViewService.prototype.getDynamicSearchAdsSearchTermView = function getDynamicSearchAdsSearchTermView(request, callback) {
                            return this.rpcCall(getDynamicSearchAdsSearchTermView, $root.google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest, $root.google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView, request, callback);
                        }, "name", { value: "GetDynamicSearchAdsSearchTermView" });

                        /**
                         * Calls GetDynamicSearchAdsSearchTermView.
                         * @function getDynamicSearchAdsSearchTermView
                         * @memberof google.ads.googleads.v1.services.DynamicSearchAdsSearchTermViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetDynamicSearchAdsSearchTermViewRequest} request GetDynamicSearchAdsSearchTermViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView>} Promise
                         * @variation 2
                         */

                        return DynamicSearchAdsSearchTermViewService;
                    })();

                    services.GetDynamicSearchAdsSearchTermViewRequest = (function() {

                        /**
                         * Properties of a GetDynamicSearchAdsSearchTermViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetDynamicSearchAdsSearchTermViewRequest
                         * @property {string|null} [resourceName] GetDynamicSearchAdsSearchTermViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetDynamicSearchAdsSearchTermViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetDynamicSearchAdsSearchTermViewRequest.
                         * @implements IGetDynamicSearchAdsSearchTermViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetDynamicSearchAdsSearchTermViewRequest=} [properties] Properties to set
                         */
                        function GetDynamicSearchAdsSearchTermViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetDynamicSearchAdsSearchTermViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest
                         * @instance
                         */
                        GetDynamicSearchAdsSearchTermViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetDynamicSearchAdsSearchTermViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetDynamicSearchAdsSearchTermViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest} GetDynamicSearchAdsSearchTermViewRequest instance
                         */
                        GetDynamicSearchAdsSearchTermViewRequest.create = function create(properties) {
                            return new GetDynamicSearchAdsSearchTermViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetDynamicSearchAdsSearchTermViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetDynamicSearchAdsSearchTermViewRequest} message GetDynamicSearchAdsSearchTermViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDynamicSearchAdsSearchTermViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetDynamicSearchAdsSearchTermViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetDynamicSearchAdsSearchTermViewRequest} message GetDynamicSearchAdsSearchTermViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDynamicSearchAdsSearchTermViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetDynamicSearchAdsSearchTermViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest} GetDynamicSearchAdsSearchTermViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDynamicSearchAdsSearchTermViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetDynamicSearchAdsSearchTermViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest} GetDynamicSearchAdsSearchTermViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDynamicSearchAdsSearchTermViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetDynamicSearchAdsSearchTermViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetDynamicSearchAdsSearchTermViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetDynamicSearchAdsSearchTermViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest} GetDynamicSearchAdsSearchTermViewRequest
                         */
                        GetDynamicSearchAdsSearchTermViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetDynamicSearchAdsSearchTermViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest} message GetDynamicSearchAdsSearchTermViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetDynamicSearchAdsSearchTermViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetDynamicSearchAdsSearchTermViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetDynamicSearchAdsSearchTermViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetDynamicSearchAdsSearchTermViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetDynamicSearchAdsSearchTermViewRequest;
                    })();

                    services.ExpandedLandingPageViewService = (function() {

                        /**
                         * Constructs a new ExpandedLandingPageViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an ExpandedLandingPageViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function ExpandedLandingPageViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (ExpandedLandingPageViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = ExpandedLandingPageViewService;

                        /**
                         * Creates new ExpandedLandingPageViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ExpandedLandingPageViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {ExpandedLandingPageViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        ExpandedLandingPageViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.ExpandedLandingPageViewService#getExpandedLandingPageView}.
                         * @memberof google.ads.googleads.v1.services.ExpandedLandingPageViewService
                         * @typedef GetExpandedLandingPageViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.ExpandedLandingPageView} [response] ExpandedLandingPageView
                         */

                        /**
                         * Calls GetExpandedLandingPageView.
                         * @function getExpandedLandingPageView
                         * @memberof google.ads.googleads.v1.services.ExpandedLandingPageViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetExpandedLandingPageViewRequest} request GetExpandedLandingPageViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.ExpandedLandingPageViewService.GetExpandedLandingPageViewCallback} callback Node-style callback called with the error, if any, and ExpandedLandingPageView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ExpandedLandingPageViewService.prototype.getExpandedLandingPageView = function getExpandedLandingPageView(request, callback) {
                            return this.rpcCall(getExpandedLandingPageView, $root.google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest, $root.google.ads.googleads.v1.resources.ExpandedLandingPageView, request, callback);
                        }, "name", { value: "GetExpandedLandingPageView" });

                        /**
                         * Calls GetExpandedLandingPageView.
                         * @function getExpandedLandingPageView
                         * @memberof google.ads.googleads.v1.services.ExpandedLandingPageViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetExpandedLandingPageViewRequest} request GetExpandedLandingPageViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.ExpandedLandingPageView>} Promise
                         * @variation 2
                         */

                        return ExpandedLandingPageViewService;
                    })();

                    services.GetExpandedLandingPageViewRequest = (function() {

                        /**
                         * Properties of a GetExpandedLandingPageViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetExpandedLandingPageViewRequest
                         * @property {string|null} [resourceName] GetExpandedLandingPageViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetExpandedLandingPageViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetExpandedLandingPageViewRequest.
                         * @implements IGetExpandedLandingPageViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetExpandedLandingPageViewRequest=} [properties] Properties to set
                         */
                        function GetExpandedLandingPageViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetExpandedLandingPageViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest
                         * @instance
                         */
                        GetExpandedLandingPageViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetExpandedLandingPageViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetExpandedLandingPageViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest} GetExpandedLandingPageViewRequest instance
                         */
                        GetExpandedLandingPageViewRequest.create = function create(properties) {
                            return new GetExpandedLandingPageViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetExpandedLandingPageViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetExpandedLandingPageViewRequest} message GetExpandedLandingPageViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetExpandedLandingPageViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetExpandedLandingPageViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetExpandedLandingPageViewRequest} message GetExpandedLandingPageViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetExpandedLandingPageViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetExpandedLandingPageViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest} GetExpandedLandingPageViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetExpandedLandingPageViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetExpandedLandingPageViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest} GetExpandedLandingPageViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetExpandedLandingPageViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetExpandedLandingPageViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetExpandedLandingPageViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetExpandedLandingPageViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest} GetExpandedLandingPageViewRequest
                         */
                        GetExpandedLandingPageViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetExpandedLandingPageViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest} message GetExpandedLandingPageViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetExpandedLandingPageViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetExpandedLandingPageViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetExpandedLandingPageViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetExpandedLandingPageViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetExpandedLandingPageViewRequest;
                    })();

                    services.ExtensionFeedItemService = (function() {

                        /**
                         * Constructs a new ExtensionFeedItemService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an ExtensionFeedItemService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function ExtensionFeedItemService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (ExtensionFeedItemService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = ExtensionFeedItemService;

                        /**
                         * Creates new ExtensionFeedItemService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {ExtensionFeedItemService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        ExtensionFeedItemService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.ExtensionFeedItemService#getExtensionFeedItem}.
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemService
                         * @typedef GetExtensionFeedItemCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.ExtensionFeedItem} [response] ExtensionFeedItem
                         */

                        /**
                         * Calls GetExtensionFeedItem.
                         * @function getExtensionFeedItem
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetExtensionFeedItemRequest} request GetExtensionFeedItemRequest message or plain object
                         * @param {google.ads.googleads.v1.services.ExtensionFeedItemService.GetExtensionFeedItemCallback} callback Node-style callback called with the error, if any, and ExtensionFeedItem
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ExtensionFeedItemService.prototype.getExtensionFeedItem = function getExtensionFeedItem(request, callback) {
                            return this.rpcCall(getExtensionFeedItem, $root.google.ads.googleads.v1.services.GetExtensionFeedItemRequest, $root.google.ads.googleads.v1.resources.ExtensionFeedItem, request, callback);
                        }, "name", { value: "GetExtensionFeedItem" });

                        /**
                         * Calls GetExtensionFeedItem.
                         * @function getExtensionFeedItem
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetExtensionFeedItemRequest} request GetExtensionFeedItemRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.ExtensionFeedItem>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.ExtensionFeedItemService#mutateExtensionFeedItems}.
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemService
                         * @typedef MutateExtensionFeedItemsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse} [response] MutateExtensionFeedItemsResponse
                         */

                        /**
                         * Calls MutateExtensionFeedItems.
                         * @function mutateExtensionFeedItems
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateExtensionFeedItemsRequest} request MutateExtensionFeedItemsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.ExtensionFeedItemService.MutateExtensionFeedItemsCallback} callback Node-style callback called with the error, if any, and MutateExtensionFeedItemsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ExtensionFeedItemService.prototype.mutateExtensionFeedItems = function mutateExtensionFeedItems(request, callback) {
                            return this.rpcCall(mutateExtensionFeedItems, $root.google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest, $root.google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse, request, callback);
                        }, "name", { value: "MutateExtensionFeedItems" });

                        /**
                         * Calls MutateExtensionFeedItems.
                         * @function mutateExtensionFeedItems
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateExtensionFeedItemsRequest} request MutateExtensionFeedItemsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse>} Promise
                         * @variation 2
                         */

                        return ExtensionFeedItemService;
                    })();

                    services.GetExtensionFeedItemRequest = (function() {

                        /**
                         * Properties of a GetExtensionFeedItemRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetExtensionFeedItemRequest
                         * @property {string|null} [resourceName] GetExtensionFeedItemRequest resourceName
                         */

                        /**
                         * Constructs a new GetExtensionFeedItemRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetExtensionFeedItemRequest.
                         * @implements IGetExtensionFeedItemRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetExtensionFeedItemRequest=} [properties] Properties to set
                         */
                        function GetExtensionFeedItemRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetExtensionFeedItemRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetExtensionFeedItemRequest
                         * @instance
                         */
                        GetExtensionFeedItemRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetExtensionFeedItemRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetExtensionFeedItemRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetExtensionFeedItemRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetExtensionFeedItemRequest} GetExtensionFeedItemRequest instance
                         */
                        GetExtensionFeedItemRequest.create = function create(properties) {
                            return new GetExtensionFeedItemRequest(properties);
                        };

                        /**
                         * Encodes the specified GetExtensionFeedItemRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetExtensionFeedItemRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetExtensionFeedItemRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetExtensionFeedItemRequest} message GetExtensionFeedItemRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetExtensionFeedItemRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetExtensionFeedItemRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetExtensionFeedItemRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetExtensionFeedItemRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetExtensionFeedItemRequest} message GetExtensionFeedItemRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetExtensionFeedItemRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetExtensionFeedItemRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetExtensionFeedItemRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetExtensionFeedItemRequest} GetExtensionFeedItemRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetExtensionFeedItemRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetExtensionFeedItemRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetExtensionFeedItemRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetExtensionFeedItemRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetExtensionFeedItemRequest} GetExtensionFeedItemRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetExtensionFeedItemRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetExtensionFeedItemRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetExtensionFeedItemRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetExtensionFeedItemRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetExtensionFeedItemRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetExtensionFeedItemRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetExtensionFeedItemRequest} GetExtensionFeedItemRequest
                         */
                        GetExtensionFeedItemRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetExtensionFeedItemRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetExtensionFeedItemRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetExtensionFeedItemRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetExtensionFeedItemRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetExtensionFeedItemRequest} message GetExtensionFeedItemRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetExtensionFeedItemRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetExtensionFeedItemRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetExtensionFeedItemRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetExtensionFeedItemRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetExtensionFeedItemRequest;
                    })();

                    services.MutateExtensionFeedItemsRequest = (function() {

                        /**
                         * Properties of a MutateExtensionFeedItemsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateExtensionFeedItemsRequest
                         * @property {string|null} [customerId] MutateExtensionFeedItemsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IExtensionFeedItemOperation>|null} [operations] MutateExtensionFeedItemsRequest operations
                         * @property {boolean|null} [validateOnly] MutateExtensionFeedItemsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateExtensionFeedItemsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateExtensionFeedItemsRequest.
                         * @implements IMutateExtensionFeedItemsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateExtensionFeedItemsRequest=} [properties] Properties to set
                         */
                        function MutateExtensionFeedItemsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateExtensionFeedItemsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest
                         * @instance
                         */
                        MutateExtensionFeedItemsRequest.prototype.customerId = "";

                        /**
                         * MutateExtensionFeedItemsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IExtensionFeedItemOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest
                         * @instance
                         */
                        MutateExtensionFeedItemsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateExtensionFeedItemsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest
                         * @instance
                         */
                        MutateExtensionFeedItemsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateExtensionFeedItemsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateExtensionFeedItemsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest} MutateExtensionFeedItemsRequest instance
                         */
                        MutateExtensionFeedItemsRequest.create = function create(properties) {
                            return new MutateExtensionFeedItemsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateExtensionFeedItemsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateExtensionFeedItemsRequest} message MutateExtensionFeedItemsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateExtensionFeedItemsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.ExtensionFeedItemOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateExtensionFeedItemsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateExtensionFeedItemsRequest} message MutateExtensionFeedItemsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateExtensionFeedItemsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateExtensionFeedItemsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest} MutateExtensionFeedItemsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateExtensionFeedItemsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.ExtensionFeedItemOperation.decode(reader, reader.uint32()));
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateExtensionFeedItemsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest} MutateExtensionFeedItemsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateExtensionFeedItemsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateExtensionFeedItemsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateExtensionFeedItemsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.ExtensionFeedItemOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateExtensionFeedItemsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest} MutateExtensionFeedItemsRequest
                         */
                        MutateExtensionFeedItemsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.ExtensionFeedItemOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateExtensionFeedItemsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest} message MutateExtensionFeedItemsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateExtensionFeedItemsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.ExtensionFeedItemOperation.toObject(message.operations[j], options);
                            }
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateExtensionFeedItemsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateExtensionFeedItemsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateExtensionFeedItemsRequest;
                    })();

                    services.ExtensionFeedItemOperation = (function() {

                        /**
                         * Properties of an ExtensionFeedItemOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IExtensionFeedItemOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] ExtensionFeedItemOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IExtensionFeedItem|null} [create] ExtensionFeedItemOperation create
                         * @property {google.ads.googleads.v1.resources.IExtensionFeedItem|null} [update] ExtensionFeedItemOperation update
                         * @property {string|null} [remove] ExtensionFeedItemOperation remove
                         */

                        /**
                         * Constructs a new ExtensionFeedItemOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an ExtensionFeedItemOperation.
                         * @implements IExtensionFeedItemOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IExtensionFeedItemOperation=} [properties] Properties to set
                         */
                        function ExtensionFeedItemOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ExtensionFeedItemOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemOperation
                         * @instance
                         */
                        ExtensionFeedItemOperation.prototype.updateMask = null;

                        /**
                         * ExtensionFeedItemOperation create.
                         * @member {google.ads.googleads.v1.resources.IExtensionFeedItem|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemOperation
                         * @instance
                         */
                        ExtensionFeedItemOperation.prototype.create = null;

                        /**
                         * ExtensionFeedItemOperation update.
                         * @member {google.ads.googleads.v1.resources.IExtensionFeedItem|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemOperation
                         * @instance
                         */
                        ExtensionFeedItemOperation.prototype.update = null;

                        /**
                         * ExtensionFeedItemOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemOperation
                         * @instance
                         */
                        ExtensionFeedItemOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * ExtensionFeedItemOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemOperation
                         * @instance
                         */
                        Object.defineProperty(ExtensionFeedItemOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new ExtensionFeedItemOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IExtensionFeedItemOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ExtensionFeedItemOperation} ExtensionFeedItemOperation instance
                         */
                        ExtensionFeedItemOperation.create = function create(properties) {
                            return new ExtensionFeedItemOperation(properties);
                        };

                        /**
                         * Encodes the specified ExtensionFeedItemOperation message. Does not implicitly {@link google.ads.googleads.v1.services.ExtensionFeedItemOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IExtensionFeedItemOperation} message ExtensionFeedItemOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExtensionFeedItemOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.ExtensionFeedItem.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.ExtensionFeedItem.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ExtensionFeedItemOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ExtensionFeedItemOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IExtensionFeedItemOperation} message ExtensionFeedItemOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExtensionFeedItemOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ExtensionFeedItemOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ExtensionFeedItemOperation} ExtensionFeedItemOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExtensionFeedItemOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ExtensionFeedItemOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.ExtensionFeedItem.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.ExtensionFeedItem.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ExtensionFeedItemOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ExtensionFeedItemOperation} ExtensionFeedItemOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExtensionFeedItemOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ExtensionFeedItemOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExtensionFeedItemOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.ExtensionFeedItem.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.ExtensionFeedItem.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates an ExtensionFeedItemOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ExtensionFeedItemOperation} ExtensionFeedItemOperation
                         */
                        ExtensionFeedItemOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ExtensionFeedItemOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ExtensionFeedItemOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ExtensionFeedItemOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ExtensionFeedItemOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.ExtensionFeedItem.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ExtensionFeedItemOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.ExtensionFeedItem.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from an ExtensionFeedItemOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ExtensionFeedItemOperation} message ExtensionFeedItemOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExtensionFeedItemOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.ExtensionFeedItem.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.ExtensionFeedItem.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this ExtensionFeedItemOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ExtensionFeedItemOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExtensionFeedItemOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ExtensionFeedItemOperation;
                    })();

                    services.MutateExtensionFeedItemsResponse = (function() {

                        /**
                         * Properties of a MutateExtensionFeedItemsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateExtensionFeedItemsResponse
                         * @property {Array.<google.ads.googleads.v1.services.IMutateExtensionFeedItemResult>|null} [results] MutateExtensionFeedItemsResponse results
                         */

                        /**
                         * Constructs a new MutateExtensionFeedItemsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateExtensionFeedItemsResponse.
                         * @implements IMutateExtensionFeedItemsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateExtensionFeedItemsResponse=} [properties] Properties to set
                         */
                        function MutateExtensionFeedItemsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateExtensionFeedItemsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateExtensionFeedItemResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse
                         * @instance
                         */
                        MutateExtensionFeedItemsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateExtensionFeedItemsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateExtensionFeedItemsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse} MutateExtensionFeedItemsResponse instance
                         */
                        MutateExtensionFeedItemsResponse.create = function create(properties) {
                            return new MutateExtensionFeedItemsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateExtensionFeedItemsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateExtensionFeedItemsResponse} message MutateExtensionFeedItemsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateExtensionFeedItemsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateExtensionFeedItemResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateExtensionFeedItemsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateExtensionFeedItemsResponse} message MutateExtensionFeedItemsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateExtensionFeedItemsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateExtensionFeedItemsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse} MutateExtensionFeedItemsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateExtensionFeedItemsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateExtensionFeedItemResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateExtensionFeedItemsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse} MutateExtensionFeedItemsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateExtensionFeedItemsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateExtensionFeedItemsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateExtensionFeedItemsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateExtensionFeedItemResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateExtensionFeedItemsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse} MutateExtensionFeedItemsResponse
                         */
                        MutateExtensionFeedItemsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse();
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateExtensionFeedItemResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateExtensionFeedItemsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse} message MutateExtensionFeedItemsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateExtensionFeedItemsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateExtensionFeedItemResult.toObject(message.results[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this MutateExtensionFeedItemsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateExtensionFeedItemsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateExtensionFeedItemsResponse;
                    })();

                    services.MutateExtensionFeedItemResult = (function() {

                        /**
                         * Properties of a MutateExtensionFeedItemResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateExtensionFeedItemResult
                         * @property {string|null} [resourceName] MutateExtensionFeedItemResult resourceName
                         */

                        /**
                         * Constructs a new MutateExtensionFeedItemResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateExtensionFeedItemResult.
                         * @implements IMutateExtensionFeedItemResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateExtensionFeedItemResult=} [properties] Properties to set
                         */
                        function MutateExtensionFeedItemResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateExtensionFeedItemResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemResult
                         * @instance
                         */
                        MutateExtensionFeedItemResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateExtensionFeedItemResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateExtensionFeedItemResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateExtensionFeedItemResult} MutateExtensionFeedItemResult instance
                         */
                        MutateExtensionFeedItemResult.create = function create(properties) {
                            return new MutateExtensionFeedItemResult(properties);
                        };

                        /**
                         * Encodes the specified MutateExtensionFeedItemResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateExtensionFeedItemResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateExtensionFeedItemResult} message MutateExtensionFeedItemResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateExtensionFeedItemResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateExtensionFeedItemResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateExtensionFeedItemResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateExtensionFeedItemResult} message MutateExtensionFeedItemResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateExtensionFeedItemResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateExtensionFeedItemResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateExtensionFeedItemResult} MutateExtensionFeedItemResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateExtensionFeedItemResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateExtensionFeedItemResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateExtensionFeedItemResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateExtensionFeedItemResult} MutateExtensionFeedItemResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateExtensionFeedItemResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateExtensionFeedItemResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateExtensionFeedItemResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateExtensionFeedItemResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateExtensionFeedItemResult} MutateExtensionFeedItemResult
                         */
                        MutateExtensionFeedItemResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateExtensionFeedItemResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateExtensionFeedItemResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateExtensionFeedItemResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateExtensionFeedItemResult} message MutateExtensionFeedItemResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateExtensionFeedItemResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateExtensionFeedItemResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateExtensionFeedItemResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateExtensionFeedItemResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateExtensionFeedItemResult;
                    })();

                    services.FeedItemService = (function() {

                        /**
                         * Constructs a new FeedItemService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a FeedItemService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function FeedItemService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (FeedItemService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = FeedItemService;

                        /**
                         * Creates new FeedItemService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.FeedItemService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {FeedItemService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        FeedItemService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.FeedItemService#getFeedItem}.
                         * @memberof google.ads.googleads.v1.services.FeedItemService
                         * @typedef GetFeedItemCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.FeedItem} [response] FeedItem
                         */

                        /**
                         * Calls GetFeedItem.
                         * @function getFeedItem
                         * @memberof google.ads.googleads.v1.services.FeedItemService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetFeedItemRequest} request GetFeedItemRequest message or plain object
                         * @param {google.ads.googleads.v1.services.FeedItemService.GetFeedItemCallback} callback Node-style callback called with the error, if any, and FeedItem
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FeedItemService.prototype.getFeedItem = function getFeedItem(request, callback) {
                            return this.rpcCall(getFeedItem, $root.google.ads.googleads.v1.services.GetFeedItemRequest, $root.google.ads.googleads.v1.resources.FeedItem, request, callback);
                        }, "name", { value: "GetFeedItem" });

                        /**
                         * Calls GetFeedItem.
                         * @function getFeedItem
                         * @memberof google.ads.googleads.v1.services.FeedItemService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetFeedItemRequest} request GetFeedItemRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.FeedItem>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.FeedItemService#mutateFeedItems}.
                         * @memberof google.ads.googleads.v1.services.FeedItemService
                         * @typedef MutateFeedItemsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateFeedItemsResponse} [response] MutateFeedItemsResponse
                         */

                        /**
                         * Calls MutateFeedItems.
                         * @function mutateFeedItems
                         * @memberof google.ads.googleads.v1.services.FeedItemService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemsRequest} request MutateFeedItemsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.FeedItemService.MutateFeedItemsCallback} callback Node-style callback called with the error, if any, and MutateFeedItemsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FeedItemService.prototype.mutateFeedItems = function mutateFeedItems(request, callback) {
                            return this.rpcCall(mutateFeedItems, $root.google.ads.googleads.v1.services.MutateFeedItemsRequest, $root.google.ads.googleads.v1.services.MutateFeedItemsResponse, request, callback);
                        }, "name", { value: "MutateFeedItems" });

                        /**
                         * Calls MutateFeedItems.
                         * @function mutateFeedItems
                         * @memberof google.ads.googleads.v1.services.FeedItemService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemsRequest} request MutateFeedItemsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateFeedItemsResponse>} Promise
                         * @variation 2
                         */

                        return FeedItemService;
                    })();

                    services.GetFeedItemRequest = (function() {

                        /**
                         * Properties of a GetFeedItemRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetFeedItemRequest
                         * @property {string|null} [resourceName] GetFeedItemRequest resourceName
                         */

                        /**
                         * Constructs a new GetFeedItemRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetFeedItemRequest.
                         * @implements IGetFeedItemRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetFeedItemRequest=} [properties] Properties to set
                         */
                        function GetFeedItemRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetFeedItemRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetFeedItemRequest
                         * @instance
                         */
                        GetFeedItemRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetFeedItemRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetFeedItemRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetFeedItemRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetFeedItemRequest} GetFeedItemRequest instance
                         */
                        GetFeedItemRequest.create = function create(properties) {
                            return new GetFeedItemRequest(properties);
                        };

                        /**
                         * Encodes the specified GetFeedItemRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetFeedItemRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetFeedItemRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetFeedItemRequest} message GetFeedItemRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetFeedItemRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetFeedItemRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetFeedItemRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetFeedItemRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetFeedItemRequest} message GetFeedItemRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetFeedItemRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetFeedItemRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetFeedItemRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetFeedItemRequest} GetFeedItemRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetFeedItemRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetFeedItemRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetFeedItemRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetFeedItemRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetFeedItemRequest} GetFeedItemRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetFeedItemRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetFeedItemRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetFeedItemRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetFeedItemRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetFeedItemRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetFeedItemRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetFeedItemRequest} GetFeedItemRequest
                         */
                        GetFeedItemRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetFeedItemRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetFeedItemRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetFeedItemRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetFeedItemRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetFeedItemRequest} message GetFeedItemRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetFeedItemRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetFeedItemRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetFeedItemRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetFeedItemRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetFeedItemRequest;
                    })();

                    services.MutateFeedItemsRequest = (function() {

                        /**
                         * Properties of a MutateFeedItemsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateFeedItemsRequest
                         * @property {string|null} [customerId] MutateFeedItemsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IFeedItemOperation>|null} [operations] MutateFeedItemsRequest operations
                         * @property {boolean|null} [partialFailure] MutateFeedItemsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateFeedItemsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateFeedItemsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateFeedItemsRequest.
                         * @implements IMutateFeedItemsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemsRequest=} [properties] Properties to set
                         */
                        function MutateFeedItemsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateFeedItemsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsRequest
                         * @instance
                         */
                        MutateFeedItemsRequest.prototype.customerId = "";

                        /**
                         * MutateFeedItemsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IFeedItemOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsRequest
                         * @instance
                         */
                        MutateFeedItemsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateFeedItemsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsRequest
                         * @instance
                         */
                        MutateFeedItemsRequest.prototype.partialFailure = false;

                        /**
                         * MutateFeedItemsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsRequest
                         * @instance
                         */
                        MutateFeedItemsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateFeedItemsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemsRequest} MutateFeedItemsRequest instance
                         */
                        MutateFeedItemsRequest.create = function create(properties) {
                            return new MutateFeedItemsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateFeedItemsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedItemsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemsRequest} message MutateFeedItemsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedItemsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.FeedItemOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateFeedItemsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedItemsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemsRequest} message MutateFeedItemsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedItemsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateFeedItemsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemsRequest} MutateFeedItemsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedItemsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateFeedItemsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.FeedItemOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateFeedItemsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemsRequest} MutateFeedItemsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedItemsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateFeedItemsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateFeedItemsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.FeedItemOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateFeedItemsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemsRequest} MutateFeedItemsRequest
                         */
                        MutateFeedItemsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateFeedItemsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateFeedItemsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateFeedItemsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateFeedItemsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.FeedItemOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateFeedItemsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateFeedItemsRequest} message MutateFeedItemsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateFeedItemsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.FeedItemOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateFeedItemsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateFeedItemsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateFeedItemsRequest;
                    })();

                    services.FeedItemOperation = (function() {

                        /**
                         * Properties of a FeedItemOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IFeedItemOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] FeedItemOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IFeedItem|null} [create] FeedItemOperation create
                         * @property {google.ads.googleads.v1.resources.IFeedItem|null} [update] FeedItemOperation update
                         * @property {string|null} [remove] FeedItemOperation remove
                         */

                        /**
                         * Constructs a new FeedItemOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a FeedItemOperation.
                         * @implements IFeedItemOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IFeedItemOperation=} [properties] Properties to set
                         */
                        function FeedItemOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * FeedItemOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.FeedItemOperation
                         * @instance
                         */
                        FeedItemOperation.prototype.updateMask = null;

                        /**
                         * FeedItemOperation create.
                         * @member {google.ads.googleads.v1.resources.IFeedItem|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.FeedItemOperation
                         * @instance
                         */
                        FeedItemOperation.prototype.create = null;

                        /**
                         * FeedItemOperation update.
                         * @member {google.ads.googleads.v1.resources.IFeedItem|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.FeedItemOperation
                         * @instance
                         */
                        FeedItemOperation.prototype.update = null;

                        /**
                         * FeedItemOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.FeedItemOperation
                         * @instance
                         */
                        FeedItemOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * FeedItemOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.FeedItemOperation
                         * @instance
                         */
                        Object.defineProperty(FeedItemOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new FeedItemOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.FeedItemOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IFeedItemOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.FeedItemOperation} FeedItemOperation instance
                         */
                        FeedItemOperation.create = function create(properties) {
                            return new FeedItemOperation(properties);
                        };

                        /**
                         * Encodes the specified FeedItemOperation message. Does not implicitly {@link google.ads.googleads.v1.services.FeedItemOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.FeedItemOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IFeedItemOperation} message FeedItemOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.FeedItem.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.FeedItem.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedItemOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.FeedItemOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.FeedItemOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IFeedItemOperation} message FeedItemOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedItemOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.FeedItemOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.FeedItemOperation} FeedItemOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.FeedItemOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.FeedItem.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.FeedItem.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedItemOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.FeedItemOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.FeedItemOperation} FeedItemOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedItemOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.FeedItemOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedItemOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.FeedItem.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.FeedItem.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a FeedItemOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.FeedItemOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.FeedItemOperation} FeedItemOperation
                         */
                        FeedItemOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.FeedItemOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.FeedItemOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.FeedItemOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.FeedItemOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.FeedItem.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.FeedItemOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.FeedItem.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a FeedItemOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.FeedItemOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.FeedItemOperation} message FeedItemOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedItemOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.FeedItem.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.FeedItem.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this FeedItemOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.FeedItemOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedItemOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return FeedItemOperation;
                    })();

                    services.MutateFeedItemsResponse = (function() {

                        /**
                         * Properties of a MutateFeedItemsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateFeedItemsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateFeedItemsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateFeedItemResult>|null} [results] MutateFeedItemsResponse results
                         */

                        /**
                         * Constructs a new MutateFeedItemsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateFeedItemsResponse.
                         * @implements IMutateFeedItemsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemsResponse=} [properties] Properties to set
                         */
                        function MutateFeedItemsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateFeedItemsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsResponse
                         * @instance
                         */
                        MutateFeedItemsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateFeedItemsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateFeedItemResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsResponse
                         * @instance
                         */
                        MutateFeedItemsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateFeedItemsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemsResponse} MutateFeedItemsResponse instance
                         */
                        MutateFeedItemsResponse.create = function create(properties) {
                            return new MutateFeedItemsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateFeedItemsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedItemsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemsResponse} message MutateFeedItemsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedItemsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateFeedItemResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateFeedItemsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedItemsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemsResponse} message MutateFeedItemsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedItemsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateFeedItemsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemsResponse} MutateFeedItemsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedItemsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateFeedItemsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateFeedItemResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateFeedItemsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemsResponse} MutateFeedItemsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedItemsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateFeedItemsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateFeedItemsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateFeedItemResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateFeedItemsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemsResponse} MutateFeedItemsResponse
                         */
                        MutateFeedItemsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateFeedItemsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateFeedItemsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateFeedItemsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateFeedItemsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateFeedItemsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateFeedItemResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateFeedItemsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateFeedItemsResponse} message MutateFeedItemsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateFeedItemsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateFeedItemResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateFeedItemsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateFeedItemsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateFeedItemsResponse;
                    })();

                    services.MutateFeedItemResult = (function() {

                        /**
                         * Properties of a MutateFeedItemResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateFeedItemResult
                         * @property {string|null} [resourceName] MutateFeedItemResult resourceName
                         */

                        /**
                         * Constructs a new MutateFeedItemResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateFeedItemResult.
                         * @implements IMutateFeedItemResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemResult=} [properties] Properties to set
                         */
                        function MutateFeedItemResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateFeedItemResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemResult
                         * @instance
                         */
                        MutateFeedItemResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateFeedItemResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemResult} MutateFeedItemResult instance
                         */
                        MutateFeedItemResult.create = function create(properties) {
                            return new MutateFeedItemResult(properties);
                        };

                        /**
                         * Encodes the specified MutateFeedItemResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedItemResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemResult} message MutateFeedItemResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedItemResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateFeedItemResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedItemResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemResult} message MutateFeedItemResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedItemResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateFeedItemResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemResult} MutateFeedItemResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedItemResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateFeedItemResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateFeedItemResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemResult} MutateFeedItemResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedItemResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateFeedItemResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateFeedItemResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateFeedItemResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemResult} MutateFeedItemResult
                         */
                        MutateFeedItemResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateFeedItemResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateFeedItemResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateFeedItemResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateFeedItemResult} message MutateFeedItemResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateFeedItemResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateFeedItemResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateFeedItemResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateFeedItemResult;
                    })();

                    services.FeedItemTargetService = (function() {

                        /**
                         * Constructs a new FeedItemTargetService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a FeedItemTargetService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function FeedItemTargetService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (FeedItemTargetService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = FeedItemTargetService;

                        /**
                         * Creates new FeedItemTargetService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {FeedItemTargetService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        FeedItemTargetService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.FeedItemTargetService#getFeedItemTarget}.
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetService
                         * @typedef GetFeedItemTargetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.FeedItemTarget} [response] FeedItemTarget
                         */

                        /**
                         * Calls GetFeedItemTarget.
                         * @function getFeedItemTarget
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetFeedItemTargetRequest} request GetFeedItemTargetRequest message or plain object
                         * @param {google.ads.googleads.v1.services.FeedItemTargetService.GetFeedItemTargetCallback} callback Node-style callback called with the error, if any, and FeedItemTarget
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FeedItemTargetService.prototype.getFeedItemTarget = function getFeedItemTarget(request, callback) {
                            return this.rpcCall(getFeedItemTarget, $root.google.ads.googleads.v1.services.GetFeedItemTargetRequest, $root.google.ads.googleads.v1.resources.FeedItemTarget, request, callback);
                        }, "name", { value: "GetFeedItemTarget" });

                        /**
                         * Calls GetFeedItemTarget.
                         * @function getFeedItemTarget
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetFeedItemTargetRequest} request GetFeedItemTargetRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.FeedItemTarget>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.FeedItemTargetService#mutateFeedItemTargets}.
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetService
                         * @typedef MutateFeedItemTargetsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateFeedItemTargetsResponse} [response] MutateFeedItemTargetsResponse
                         */

                        /**
                         * Calls MutateFeedItemTargets.
                         * @function mutateFeedItemTargets
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemTargetsRequest} request MutateFeedItemTargetsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.FeedItemTargetService.MutateFeedItemTargetsCallback} callback Node-style callback called with the error, if any, and MutateFeedItemTargetsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FeedItemTargetService.prototype.mutateFeedItemTargets = function mutateFeedItemTargets(request, callback) {
                            return this.rpcCall(mutateFeedItemTargets, $root.google.ads.googleads.v1.services.MutateFeedItemTargetsRequest, $root.google.ads.googleads.v1.services.MutateFeedItemTargetsResponse, request, callback);
                        }, "name", { value: "MutateFeedItemTargets" });

                        /**
                         * Calls MutateFeedItemTargets.
                         * @function mutateFeedItemTargets
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemTargetsRequest} request MutateFeedItemTargetsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateFeedItemTargetsResponse>} Promise
                         * @variation 2
                         */

                        return FeedItemTargetService;
                    })();

                    services.GetFeedItemTargetRequest = (function() {

                        /**
                         * Properties of a GetFeedItemTargetRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetFeedItemTargetRequest
                         * @property {string|null} [resourceName] GetFeedItemTargetRequest resourceName
                         */

                        /**
                         * Constructs a new GetFeedItemTargetRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetFeedItemTargetRequest.
                         * @implements IGetFeedItemTargetRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetFeedItemTargetRequest=} [properties] Properties to set
                         */
                        function GetFeedItemTargetRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetFeedItemTargetRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetFeedItemTargetRequest
                         * @instance
                         */
                        GetFeedItemTargetRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetFeedItemTargetRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetFeedItemTargetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetFeedItemTargetRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetFeedItemTargetRequest} GetFeedItemTargetRequest instance
                         */
                        GetFeedItemTargetRequest.create = function create(properties) {
                            return new GetFeedItemTargetRequest(properties);
                        };

                        /**
                         * Encodes the specified GetFeedItemTargetRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetFeedItemTargetRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetFeedItemTargetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetFeedItemTargetRequest} message GetFeedItemTargetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetFeedItemTargetRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetFeedItemTargetRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetFeedItemTargetRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetFeedItemTargetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetFeedItemTargetRequest} message GetFeedItemTargetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetFeedItemTargetRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetFeedItemTargetRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetFeedItemTargetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetFeedItemTargetRequest} GetFeedItemTargetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetFeedItemTargetRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetFeedItemTargetRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetFeedItemTargetRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetFeedItemTargetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetFeedItemTargetRequest} GetFeedItemTargetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetFeedItemTargetRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetFeedItemTargetRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetFeedItemTargetRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetFeedItemTargetRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetFeedItemTargetRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetFeedItemTargetRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetFeedItemTargetRequest} GetFeedItemTargetRequest
                         */
                        GetFeedItemTargetRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetFeedItemTargetRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetFeedItemTargetRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetFeedItemTargetRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetFeedItemTargetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetFeedItemTargetRequest} message GetFeedItemTargetRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetFeedItemTargetRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetFeedItemTargetRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetFeedItemTargetRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetFeedItemTargetRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetFeedItemTargetRequest;
                    })();

                    services.MutateFeedItemTargetsRequest = (function() {

                        /**
                         * Properties of a MutateFeedItemTargetsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateFeedItemTargetsRequest
                         * @property {string|null} [customerId] MutateFeedItemTargetsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IFeedItemTargetOperation>|null} [operations] MutateFeedItemTargetsRequest operations
                         */

                        /**
                         * Constructs a new MutateFeedItemTargetsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateFeedItemTargetsRequest.
                         * @implements IMutateFeedItemTargetsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemTargetsRequest=} [properties] Properties to set
                         */
                        function MutateFeedItemTargetsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateFeedItemTargetsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsRequest
                         * @instance
                         */
                        MutateFeedItemTargetsRequest.prototype.customerId = "";

                        /**
                         * MutateFeedItemTargetsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IFeedItemTargetOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsRequest
                         * @instance
                         */
                        MutateFeedItemTargetsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * Creates a new MutateFeedItemTargetsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemTargetsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemTargetsRequest} MutateFeedItemTargetsRequest instance
                         */
                        MutateFeedItemTargetsRequest.create = function create(properties) {
                            return new MutateFeedItemTargetsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateFeedItemTargetsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedItemTargetsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemTargetsRequest} message MutateFeedItemTargetsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedItemTargetsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.FeedItemTargetOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateFeedItemTargetsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedItemTargetsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemTargetsRequest} message MutateFeedItemTargetsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedItemTargetsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateFeedItemTargetsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemTargetsRequest} MutateFeedItemTargetsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedItemTargetsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateFeedItemTargetsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.FeedItemTargetOperation.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateFeedItemTargetsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemTargetsRequest} MutateFeedItemTargetsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedItemTargetsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateFeedItemTargetsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateFeedItemTargetsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.FeedItemTargetOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateFeedItemTargetsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemTargetsRequest} MutateFeedItemTargetsRequest
                         */
                        MutateFeedItemTargetsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateFeedItemTargetsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateFeedItemTargetsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateFeedItemTargetsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateFeedItemTargetsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.FeedItemTargetOperation.fromObject(object.operations[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateFeedItemTargetsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateFeedItemTargetsRequest} message MutateFeedItemTargetsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateFeedItemTargetsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults)
                                object.customerId = "";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.FeedItemTargetOperation.toObject(message.operations[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this MutateFeedItemTargetsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateFeedItemTargetsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateFeedItemTargetsRequest;
                    })();

                    services.FeedItemTargetOperation = (function() {

                        /**
                         * Properties of a FeedItemTargetOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IFeedItemTargetOperation
                         * @property {google.ads.googleads.v1.resources.IFeedItemTarget|null} [create] FeedItemTargetOperation create
                         * @property {string|null} [remove] FeedItemTargetOperation remove
                         */

                        /**
                         * Constructs a new FeedItemTargetOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a FeedItemTargetOperation.
                         * @implements IFeedItemTargetOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IFeedItemTargetOperation=} [properties] Properties to set
                         */
                        function FeedItemTargetOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * FeedItemTargetOperation create.
                         * @member {google.ads.googleads.v1.resources.IFeedItemTarget|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetOperation
                         * @instance
                         */
                        FeedItemTargetOperation.prototype.create = null;

                        /**
                         * FeedItemTargetOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetOperation
                         * @instance
                         */
                        FeedItemTargetOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * FeedItemTargetOperation operation.
                         * @member {"create"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetOperation
                         * @instance
                         */
                        Object.defineProperty(FeedItemTargetOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new FeedItemTargetOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IFeedItemTargetOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.FeedItemTargetOperation} FeedItemTargetOperation instance
                         */
                        FeedItemTargetOperation.create = function create(properties) {
                            return new FeedItemTargetOperation(properties);
                        };

                        /**
                         * Encodes the specified FeedItemTargetOperation message. Does not implicitly {@link google.ads.googleads.v1.services.FeedItemTargetOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IFeedItemTargetOperation} message FeedItemTargetOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemTargetOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.FeedItemTarget.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.remove);
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedItemTargetOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.FeedItemTargetOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IFeedItemTargetOperation} message FeedItemTargetOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedItemTargetOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedItemTargetOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.FeedItemTargetOperation} FeedItemTargetOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemTargetOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.FeedItemTargetOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.FeedItemTarget.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedItemTargetOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.FeedItemTargetOperation} FeedItemTargetOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedItemTargetOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedItemTargetOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedItemTargetOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.FeedItemTarget.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a FeedItemTargetOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.FeedItemTargetOperation} FeedItemTargetOperation
                         */
                        FeedItemTargetOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.FeedItemTargetOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.FeedItemTargetOperation();
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.FeedItemTargetOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.FeedItemTarget.fromObject(object.create);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a FeedItemTargetOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.FeedItemTargetOperation} message FeedItemTargetOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedItemTargetOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.FeedItemTarget.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            return object;
                        };

                        /**
                         * Converts this FeedItemTargetOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.FeedItemTargetOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedItemTargetOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return FeedItemTargetOperation;
                    })();

                    services.MutateFeedItemTargetsResponse = (function() {

                        /**
                         * Properties of a MutateFeedItemTargetsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateFeedItemTargetsResponse
                         * @property {Array.<google.ads.googleads.v1.services.IMutateFeedItemTargetResult>|null} [results] MutateFeedItemTargetsResponse results
                         */

                        /**
                         * Constructs a new MutateFeedItemTargetsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateFeedItemTargetsResponse.
                         * @implements IMutateFeedItemTargetsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemTargetsResponse=} [properties] Properties to set
                         */
                        function MutateFeedItemTargetsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateFeedItemTargetsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateFeedItemTargetResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsResponse
                         * @instance
                         */
                        MutateFeedItemTargetsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateFeedItemTargetsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemTargetsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemTargetsResponse} MutateFeedItemTargetsResponse instance
                         */
                        MutateFeedItemTargetsResponse.create = function create(properties) {
                            return new MutateFeedItemTargetsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateFeedItemTargetsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedItemTargetsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemTargetsResponse} message MutateFeedItemTargetsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedItemTargetsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateFeedItemTargetResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateFeedItemTargetsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedItemTargetsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemTargetsResponse} message MutateFeedItemTargetsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedItemTargetsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateFeedItemTargetsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemTargetsResponse} MutateFeedItemTargetsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedItemTargetsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateFeedItemTargetsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateFeedItemTargetResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateFeedItemTargetsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemTargetsResponse} MutateFeedItemTargetsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedItemTargetsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateFeedItemTargetsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateFeedItemTargetsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateFeedItemTargetResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateFeedItemTargetsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemTargetsResponse} MutateFeedItemTargetsResponse
                         */
                        MutateFeedItemTargetsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateFeedItemTargetsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateFeedItemTargetsResponse();
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateFeedItemTargetsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateFeedItemTargetsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateFeedItemTargetResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateFeedItemTargetsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateFeedItemTargetsResponse} message MutateFeedItemTargetsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateFeedItemTargetsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateFeedItemTargetResult.toObject(message.results[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this MutateFeedItemTargetsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateFeedItemTargetsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateFeedItemTargetsResponse;
                    })();

                    services.MutateFeedItemTargetResult = (function() {

                        /**
                         * Properties of a MutateFeedItemTargetResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateFeedItemTargetResult
                         * @property {string|null} [resourceName] MutateFeedItemTargetResult resourceName
                         */

                        /**
                         * Constructs a new MutateFeedItemTargetResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateFeedItemTargetResult.
                         * @implements IMutateFeedItemTargetResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemTargetResult=} [properties] Properties to set
                         */
                        function MutateFeedItemTargetResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateFeedItemTargetResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetResult
                         * @instance
                         */
                        MutateFeedItemTargetResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateFeedItemTargetResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemTargetResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemTargetResult} MutateFeedItemTargetResult instance
                         */
                        MutateFeedItemTargetResult.create = function create(properties) {
                            return new MutateFeedItemTargetResult(properties);
                        };

                        /**
                         * Encodes the specified MutateFeedItemTargetResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedItemTargetResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemTargetResult} message MutateFeedItemTargetResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedItemTargetResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateFeedItemTargetResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedItemTargetResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedItemTargetResult} message MutateFeedItemTargetResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedItemTargetResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateFeedItemTargetResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemTargetResult} MutateFeedItemTargetResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedItemTargetResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateFeedItemTargetResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateFeedItemTargetResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemTargetResult} MutateFeedItemTargetResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedItemTargetResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateFeedItemTargetResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateFeedItemTargetResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateFeedItemTargetResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateFeedItemTargetResult} MutateFeedItemTargetResult
                         */
                        MutateFeedItemTargetResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateFeedItemTargetResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateFeedItemTargetResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateFeedItemTargetResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateFeedItemTargetResult} message MutateFeedItemTargetResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateFeedItemTargetResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateFeedItemTargetResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateFeedItemTargetResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateFeedItemTargetResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateFeedItemTargetResult;
                    })();

                    services.FeedMappingService = (function() {

                        /**
                         * Constructs a new FeedMappingService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a FeedMappingService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function FeedMappingService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (FeedMappingService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = FeedMappingService;

                        /**
                         * Creates new FeedMappingService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.FeedMappingService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {FeedMappingService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        FeedMappingService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.FeedMappingService#getFeedMapping}.
                         * @memberof google.ads.googleads.v1.services.FeedMappingService
                         * @typedef GetFeedMappingCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.FeedMapping} [response] FeedMapping
                         */

                        /**
                         * Calls GetFeedMapping.
                         * @function getFeedMapping
                         * @memberof google.ads.googleads.v1.services.FeedMappingService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetFeedMappingRequest} request GetFeedMappingRequest message or plain object
                         * @param {google.ads.googleads.v1.services.FeedMappingService.GetFeedMappingCallback} callback Node-style callback called with the error, if any, and FeedMapping
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FeedMappingService.prototype.getFeedMapping = function getFeedMapping(request, callback) {
                            return this.rpcCall(getFeedMapping, $root.google.ads.googleads.v1.services.GetFeedMappingRequest, $root.google.ads.googleads.v1.resources.FeedMapping, request, callback);
                        }, "name", { value: "GetFeedMapping" });

                        /**
                         * Calls GetFeedMapping.
                         * @function getFeedMapping
                         * @memberof google.ads.googleads.v1.services.FeedMappingService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetFeedMappingRequest} request GetFeedMappingRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.FeedMapping>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.FeedMappingService#mutateFeedMappings}.
                         * @memberof google.ads.googleads.v1.services.FeedMappingService
                         * @typedef MutateFeedMappingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateFeedMappingsResponse} [response] MutateFeedMappingsResponse
                         */

                        /**
                         * Calls MutateFeedMappings.
                         * @function mutateFeedMappings
                         * @memberof google.ads.googleads.v1.services.FeedMappingService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateFeedMappingsRequest} request MutateFeedMappingsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.FeedMappingService.MutateFeedMappingsCallback} callback Node-style callback called with the error, if any, and MutateFeedMappingsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FeedMappingService.prototype.mutateFeedMappings = function mutateFeedMappings(request, callback) {
                            return this.rpcCall(mutateFeedMappings, $root.google.ads.googleads.v1.services.MutateFeedMappingsRequest, $root.google.ads.googleads.v1.services.MutateFeedMappingsResponse, request, callback);
                        }, "name", { value: "MutateFeedMappings" });

                        /**
                         * Calls MutateFeedMappings.
                         * @function mutateFeedMappings
                         * @memberof google.ads.googleads.v1.services.FeedMappingService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateFeedMappingsRequest} request MutateFeedMappingsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateFeedMappingsResponse>} Promise
                         * @variation 2
                         */

                        return FeedMappingService;
                    })();

                    services.GetFeedMappingRequest = (function() {

                        /**
                         * Properties of a GetFeedMappingRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetFeedMappingRequest
                         * @property {string|null} [resourceName] GetFeedMappingRequest resourceName
                         */

                        /**
                         * Constructs a new GetFeedMappingRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetFeedMappingRequest.
                         * @implements IGetFeedMappingRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetFeedMappingRequest=} [properties] Properties to set
                         */
                        function GetFeedMappingRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetFeedMappingRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetFeedMappingRequest
                         * @instance
                         */
                        GetFeedMappingRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetFeedMappingRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetFeedMappingRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetFeedMappingRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetFeedMappingRequest} GetFeedMappingRequest instance
                         */
                        GetFeedMappingRequest.create = function create(properties) {
                            return new GetFeedMappingRequest(properties);
                        };

                        /**
                         * Encodes the specified GetFeedMappingRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetFeedMappingRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetFeedMappingRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetFeedMappingRequest} message GetFeedMappingRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetFeedMappingRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetFeedMappingRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetFeedMappingRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetFeedMappingRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetFeedMappingRequest} message GetFeedMappingRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetFeedMappingRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetFeedMappingRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetFeedMappingRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetFeedMappingRequest} GetFeedMappingRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetFeedMappingRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetFeedMappingRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetFeedMappingRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetFeedMappingRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetFeedMappingRequest} GetFeedMappingRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetFeedMappingRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetFeedMappingRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetFeedMappingRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetFeedMappingRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetFeedMappingRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetFeedMappingRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetFeedMappingRequest} GetFeedMappingRequest
                         */
                        GetFeedMappingRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetFeedMappingRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetFeedMappingRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetFeedMappingRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetFeedMappingRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetFeedMappingRequest} message GetFeedMappingRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetFeedMappingRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetFeedMappingRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetFeedMappingRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetFeedMappingRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetFeedMappingRequest;
                    })();

                    services.MutateFeedMappingsRequest = (function() {

                        /**
                         * Properties of a MutateFeedMappingsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateFeedMappingsRequest
                         * @property {string|null} [customerId] MutateFeedMappingsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IFeedMappingOperation>|null} [operations] MutateFeedMappingsRequest operations
                         * @property {boolean|null} [partialFailure] MutateFeedMappingsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateFeedMappingsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateFeedMappingsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateFeedMappingsRequest.
                         * @implements IMutateFeedMappingsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateFeedMappingsRequest=} [properties] Properties to set
                         */
                        function MutateFeedMappingsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateFeedMappingsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsRequest
                         * @instance
                         */
                        MutateFeedMappingsRequest.prototype.customerId = "";

                        /**
                         * MutateFeedMappingsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IFeedMappingOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsRequest
                         * @instance
                         */
                        MutateFeedMappingsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateFeedMappingsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsRequest
                         * @instance
                         */
                        MutateFeedMappingsRequest.prototype.partialFailure = false;

                        /**
                         * MutateFeedMappingsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsRequest
                         * @instance
                         */
                        MutateFeedMappingsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateFeedMappingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedMappingsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateFeedMappingsRequest} MutateFeedMappingsRequest instance
                         */
                        MutateFeedMappingsRequest.create = function create(properties) {
                            return new MutateFeedMappingsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateFeedMappingsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedMappingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedMappingsRequest} message MutateFeedMappingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedMappingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.FeedMappingOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateFeedMappingsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedMappingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedMappingsRequest} message MutateFeedMappingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedMappingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateFeedMappingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateFeedMappingsRequest} MutateFeedMappingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedMappingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateFeedMappingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.FeedMappingOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateFeedMappingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateFeedMappingsRequest} MutateFeedMappingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedMappingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateFeedMappingsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateFeedMappingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.FeedMappingOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateFeedMappingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateFeedMappingsRequest} MutateFeedMappingsRequest
                         */
                        MutateFeedMappingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateFeedMappingsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateFeedMappingsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateFeedMappingsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateFeedMappingsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.FeedMappingOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateFeedMappingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateFeedMappingsRequest} message MutateFeedMappingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateFeedMappingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.FeedMappingOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateFeedMappingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateFeedMappingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateFeedMappingsRequest;
                    })();

                    services.FeedMappingOperation = (function() {

                        /**
                         * Properties of a FeedMappingOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IFeedMappingOperation
                         * @property {google.ads.googleads.v1.resources.IFeedMapping|null} [create] FeedMappingOperation create
                         * @property {string|null} [remove] FeedMappingOperation remove
                         */

                        /**
                         * Constructs a new FeedMappingOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a FeedMappingOperation.
                         * @implements IFeedMappingOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IFeedMappingOperation=} [properties] Properties to set
                         */
                        function FeedMappingOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * FeedMappingOperation create.
                         * @member {google.ads.googleads.v1.resources.IFeedMapping|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.FeedMappingOperation
                         * @instance
                         */
                        FeedMappingOperation.prototype.create = null;

                        /**
                         * FeedMappingOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.FeedMappingOperation
                         * @instance
                         */
                        FeedMappingOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * FeedMappingOperation operation.
                         * @member {"create"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.FeedMappingOperation
                         * @instance
                         */
                        Object.defineProperty(FeedMappingOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new FeedMappingOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.FeedMappingOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IFeedMappingOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.FeedMappingOperation} FeedMappingOperation instance
                         */
                        FeedMappingOperation.create = function create(properties) {
                            return new FeedMappingOperation(properties);
                        };

                        /**
                         * Encodes the specified FeedMappingOperation message. Does not implicitly {@link google.ads.googleads.v1.services.FeedMappingOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.FeedMappingOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IFeedMappingOperation} message FeedMappingOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedMappingOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.FeedMapping.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedMappingOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.FeedMappingOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.FeedMappingOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IFeedMappingOperation} message FeedMappingOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedMappingOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedMappingOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.FeedMappingOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.FeedMappingOperation} FeedMappingOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedMappingOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.FeedMappingOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.FeedMapping.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedMappingOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.FeedMappingOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.FeedMappingOperation} FeedMappingOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedMappingOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedMappingOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.FeedMappingOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedMappingOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.FeedMapping.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a FeedMappingOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.FeedMappingOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.FeedMappingOperation} FeedMappingOperation
                         */
                        FeedMappingOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.FeedMappingOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.FeedMappingOperation();
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.FeedMappingOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.FeedMapping.fromObject(object.create);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a FeedMappingOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.FeedMappingOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.FeedMappingOperation} message FeedMappingOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedMappingOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.FeedMapping.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            return object;
                        };

                        /**
                         * Converts this FeedMappingOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.FeedMappingOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedMappingOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return FeedMappingOperation;
                    })();

                    services.MutateFeedMappingsResponse = (function() {

                        /**
                         * Properties of a MutateFeedMappingsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateFeedMappingsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateFeedMappingsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateFeedMappingResult>|null} [results] MutateFeedMappingsResponse results
                         */

                        /**
                         * Constructs a new MutateFeedMappingsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateFeedMappingsResponse.
                         * @implements IMutateFeedMappingsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateFeedMappingsResponse=} [properties] Properties to set
                         */
                        function MutateFeedMappingsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateFeedMappingsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsResponse
                         * @instance
                         */
                        MutateFeedMappingsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateFeedMappingsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateFeedMappingResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsResponse
                         * @instance
                         */
                        MutateFeedMappingsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateFeedMappingsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedMappingsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateFeedMappingsResponse} MutateFeedMappingsResponse instance
                         */
                        MutateFeedMappingsResponse.create = function create(properties) {
                            return new MutateFeedMappingsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateFeedMappingsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedMappingsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedMappingsResponse} message MutateFeedMappingsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedMappingsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateFeedMappingResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateFeedMappingsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedMappingsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedMappingsResponse} message MutateFeedMappingsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedMappingsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateFeedMappingsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateFeedMappingsResponse} MutateFeedMappingsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedMappingsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateFeedMappingsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateFeedMappingResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateFeedMappingsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateFeedMappingsResponse} MutateFeedMappingsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedMappingsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateFeedMappingsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateFeedMappingsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateFeedMappingResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateFeedMappingsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateFeedMappingsResponse} MutateFeedMappingsResponse
                         */
                        MutateFeedMappingsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateFeedMappingsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateFeedMappingsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateFeedMappingsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateFeedMappingsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateFeedMappingsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateFeedMappingResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateFeedMappingsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateFeedMappingsResponse} message MutateFeedMappingsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateFeedMappingsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateFeedMappingResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateFeedMappingsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateFeedMappingsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateFeedMappingsResponse;
                    })();

                    services.MutateFeedMappingResult = (function() {

                        /**
                         * Properties of a MutateFeedMappingResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateFeedMappingResult
                         * @property {string|null} [resourceName] MutateFeedMappingResult resourceName
                         */

                        /**
                         * Constructs a new MutateFeedMappingResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateFeedMappingResult.
                         * @implements IMutateFeedMappingResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateFeedMappingResult=} [properties] Properties to set
                         */
                        function MutateFeedMappingResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateFeedMappingResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingResult
                         * @instance
                         */
                        MutateFeedMappingResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateFeedMappingResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedMappingResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateFeedMappingResult} MutateFeedMappingResult instance
                         */
                        MutateFeedMappingResult.create = function create(properties) {
                            return new MutateFeedMappingResult(properties);
                        };

                        /**
                         * Encodes the specified MutateFeedMappingResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedMappingResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedMappingResult} message MutateFeedMappingResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedMappingResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateFeedMappingResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedMappingResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedMappingResult} message MutateFeedMappingResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedMappingResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateFeedMappingResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateFeedMappingResult} MutateFeedMappingResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedMappingResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateFeedMappingResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateFeedMappingResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateFeedMappingResult} MutateFeedMappingResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedMappingResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateFeedMappingResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateFeedMappingResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateFeedMappingResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateFeedMappingResult} MutateFeedMappingResult
                         */
                        MutateFeedMappingResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateFeedMappingResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateFeedMappingResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateFeedMappingResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateFeedMappingResult} message MutateFeedMappingResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateFeedMappingResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateFeedMappingResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateFeedMappingResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateFeedMappingResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateFeedMappingResult;
                    })();

                    services.FeedPlaceholderViewService = (function() {

                        /**
                         * Constructs a new FeedPlaceholderViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a FeedPlaceholderViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function FeedPlaceholderViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (FeedPlaceholderViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = FeedPlaceholderViewService;

                        /**
                         * Creates new FeedPlaceholderViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.FeedPlaceholderViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {FeedPlaceholderViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        FeedPlaceholderViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.FeedPlaceholderViewService#getFeedPlaceholderView}.
                         * @memberof google.ads.googleads.v1.services.FeedPlaceholderViewService
                         * @typedef GetFeedPlaceholderViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.FeedPlaceholderView} [response] FeedPlaceholderView
                         */

                        /**
                         * Calls GetFeedPlaceholderView.
                         * @function getFeedPlaceholderView
                         * @memberof google.ads.googleads.v1.services.FeedPlaceholderViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetFeedPlaceholderViewRequest} request GetFeedPlaceholderViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.FeedPlaceholderViewService.GetFeedPlaceholderViewCallback} callback Node-style callback called with the error, if any, and FeedPlaceholderView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FeedPlaceholderViewService.prototype.getFeedPlaceholderView = function getFeedPlaceholderView(request, callback) {
                            return this.rpcCall(getFeedPlaceholderView, $root.google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest, $root.google.ads.googleads.v1.resources.FeedPlaceholderView, request, callback);
                        }, "name", { value: "GetFeedPlaceholderView" });

                        /**
                         * Calls GetFeedPlaceholderView.
                         * @function getFeedPlaceholderView
                         * @memberof google.ads.googleads.v1.services.FeedPlaceholderViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetFeedPlaceholderViewRequest} request GetFeedPlaceholderViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.FeedPlaceholderView>} Promise
                         * @variation 2
                         */

                        return FeedPlaceholderViewService;
                    })();

                    services.GetFeedPlaceholderViewRequest = (function() {

                        /**
                         * Properties of a GetFeedPlaceholderViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetFeedPlaceholderViewRequest
                         * @property {string|null} [resourceName] GetFeedPlaceholderViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetFeedPlaceholderViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetFeedPlaceholderViewRequest.
                         * @implements IGetFeedPlaceholderViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetFeedPlaceholderViewRequest=} [properties] Properties to set
                         */
                        function GetFeedPlaceholderViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetFeedPlaceholderViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest
                         * @instance
                         */
                        GetFeedPlaceholderViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetFeedPlaceholderViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetFeedPlaceholderViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest} GetFeedPlaceholderViewRequest instance
                         */
                        GetFeedPlaceholderViewRequest.create = function create(properties) {
                            return new GetFeedPlaceholderViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetFeedPlaceholderViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetFeedPlaceholderViewRequest} message GetFeedPlaceholderViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetFeedPlaceholderViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetFeedPlaceholderViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetFeedPlaceholderViewRequest} message GetFeedPlaceholderViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetFeedPlaceholderViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetFeedPlaceholderViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest} GetFeedPlaceholderViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetFeedPlaceholderViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetFeedPlaceholderViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest} GetFeedPlaceholderViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetFeedPlaceholderViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetFeedPlaceholderViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetFeedPlaceholderViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetFeedPlaceholderViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest} GetFeedPlaceholderViewRequest
                         */
                        GetFeedPlaceholderViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetFeedPlaceholderViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest} message GetFeedPlaceholderViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetFeedPlaceholderViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetFeedPlaceholderViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetFeedPlaceholderViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetFeedPlaceholderViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetFeedPlaceholderViewRequest;
                    })();

                    services.FeedService = (function() {

                        /**
                         * Constructs a new FeedService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a FeedService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function FeedService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (FeedService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = FeedService;

                        /**
                         * Creates new FeedService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.FeedService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {FeedService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        FeedService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.FeedService#getFeed}.
                         * @memberof google.ads.googleads.v1.services.FeedService
                         * @typedef GetFeedCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.Feed} [response] Feed
                         */

                        /**
                         * Calls GetFeed.
                         * @function getFeed
                         * @memberof google.ads.googleads.v1.services.FeedService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetFeedRequest} request GetFeedRequest message or plain object
                         * @param {google.ads.googleads.v1.services.FeedService.GetFeedCallback} callback Node-style callback called with the error, if any, and Feed
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FeedService.prototype.getFeed = function getFeed(request, callback) {
                            return this.rpcCall(getFeed, $root.google.ads.googleads.v1.services.GetFeedRequest, $root.google.ads.googleads.v1.resources.Feed, request, callback);
                        }, "name", { value: "GetFeed" });

                        /**
                         * Calls GetFeed.
                         * @function getFeed
                         * @memberof google.ads.googleads.v1.services.FeedService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetFeedRequest} request GetFeedRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.Feed>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.FeedService#mutateFeeds}.
                         * @memberof google.ads.googleads.v1.services.FeedService
                         * @typedef MutateFeedsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateFeedsResponse} [response] MutateFeedsResponse
                         */

                        /**
                         * Calls MutateFeeds.
                         * @function mutateFeeds
                         * @memberof google.ads.googleads.v1.services.FeedService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateFeedsRequest} request MutateFeedsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.FeedService.MutateFeedsCallback} callback Node-style callback called with the error, if any, and MutateFeedsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FeedService.prototype.mutateFeeds = function mutateFeeds(request, callback) {
                            return this.rpcCall(mutateFeeds, $root.google.ads.googleads.v1.services.MutateFeedsRequest, $root.google.ads.googleads.v1.services.MutateFeedsResponse, request, callback);
                        }, "name", { value: "MutateFeeds" });

                        /**
                         * Calls MutateFeeds.
                         * @function mutateFeeds
                         * @memberof google.ads.googleads.v1.services.FeedService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateFeedsRequest} request MutateFeedsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateFeedsResponse>} Promise
                         * @variation 2
                         */

                        return FeedService;
                    })();

                    services.GetFeedRequest = (function() {

                        /**
                         * Properties of a GetFeedRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetFeedRequest
                         * @property {string|null} [resourceName] GetFeedRequest resourceName
                         */

                        /**
                         * Constructs a new GetFeedRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetFeedRequest.
                         * @implements IGetFeedRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetFeedRequest=} [properties] Properties to set
                         */
                        function GetFeedRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetFeedRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetFeedRequest
                         * @instance
                         */
                        GetFeedRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetFeedRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetFeedRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetFeedRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetFeedRequest} GetFeedRequest instance
                         */
                        GetFeedRequest.create = function create(properties) {
                            return new GetFeedRequest(properties);
                        };

                        /**
                         * Encodes the specified GetFeedRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetFeedRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetFeedRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetFeedRequest} message GetFeedRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetFeedRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetFeedRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetFeedRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetFeedRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetFeedRequest} message GetFeedRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetFeedRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetFeedRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetFeedRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetFeedRequest} GetFeedRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetFeedRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetFeedRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetFeedRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetFeedRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetFeedRequest} GetFeedRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetFeedRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetFeedRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetFeedRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetFeedRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetFeedRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetFeedRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetFeedRequest} GetFeedRequest
                         */
                        GetFeedRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetFeedRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetFeedRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetFeedRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetFeedRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetFeedRequest} message GetFeedRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetFeedRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetFeedRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetFeedRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetFeedRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetFeedRequest;
                    })();

                    services.MutateFeedsRequest = (function() {

                        /**
                         * Properties of a MutateFeedsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateFeedsRequest
                         * @property {string|null} [customerId] MutateFeedsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IFeedOperation>|null} [operations] MutateFeedsRequest operations
                         * @property {boolean|null} [partialFailure] MutateFeedsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateFeedsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateFeedsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateFeedsRequest.
                         * @implements IMutateFeedsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateFeedsRequest=} [properties] Properties to set
                         */
                        function MutateFeedsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateFeedsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateFeedsRequest
                         * @instance
                         */
                        MutateFeedsRequest.prototype.customerId = "";

                        /**
                         * MutateFeedsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IFeedOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateFeedsRequest
                         * @instance
                         */
                        MutateFeedsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateFeedsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateFeedsRequest
                         * @instance
                         */
                        MutateFeedsRequest.prototype.partialFailure = false;

                        /**
                         * MutateFeedsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateFeedsRequest
                         * @instance
                         */
                        MutateFeedsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateFeedsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateFeedsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateFeedsRequest} MutateFeedsRequest instance
                         */
                        MutateFeedsRequest.create = function create(properties) {
                            return new MutateFeedsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateFeedsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateFeedsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedsRequest} message MutateFeedsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.FeedOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateFeedsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedsRequest} message MutateFeedsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateFeedsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateFeedsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateFeedsRequest} MutateFeedsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateFeedsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.FeedOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateFeedsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateFeedsRequest} MutateFeedsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateFeedsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateFeedsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateFeedsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.FeedOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateFeedsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateFeedsRequest} MutateFeedsRequest
                         */
                        MutateFeedsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateFeedsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateFeedsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateFeedsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateFeedsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.FeedOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateFeedsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateFeedsRequest} message MutateFeedsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateFeedsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.FeedOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateFeedsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateFeedsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateFeedsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateFeedsRequest;
                    })();

                    services.FeedOperation = (function() {

                        /**
                         * Properties of a FeedOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IFeedOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] FeedOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IFeed|null} [create] FeedOperation create
                         * @property {google.ads.googleads.v1.resources.IFeed|null} [update] FeedOperation update
                         * @property {string|null} [remove] FeedOperation remove
                         */

                        /**
                         * Constructs a new FeedOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a FeedOperation.
                         * @implements IFeedOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IFeedOperation=} [properties] Properties to set
                         */
                        function FeedOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * FeedOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.FeedOperation
                         * @instance
                         */
                        FeedOperation.prototype.updateMask = null;

                        /**
                         * FeedOperation create.
                         * @member {google.ads.googleads.v1.resources.IFeed|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.FeedOperation
                         * @instance
                         */
                        FeedOperation.prototype.create = null;

                        /**
                         * FeedOperation update.
                         * @member {google.ads.googleads.v1.resources.IFeed|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.FeedOperation
                         * @instance
                         */
                        FeedOperation.prototype.update = null;

                        /**
                         * FeedOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.FeedOperation
                         * @instance
                         */
                        FeedOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * FeedOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.FeedOperation
                         * @instance
                         */
                        Object.defineProperty(FeedOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new FeedOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.FeedOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IFeedOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.FeedOperation} FeedOperation instance
                         */
                        FeedOperation.create = function create(properties) {
                            return new FeedOperation(properties);
                        };

                        /**
                         * Encodes the specified FeedOperation message. Does not implicitly {@link google.ads.googleads.v1.services.FeedOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.FeedOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IFeedOperation} message FeedOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.Feed.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.Feed.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified FeedOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.FeedOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.FeedOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IFeedOperation} message FeedOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FeedOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a FeedOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.FeedOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.FeedOperation} FeedOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.FeedOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.Feed.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.Feed.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a FeedOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.FeedOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.FeedOperation} FeedOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FeedOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a FeedOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.FeedOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FeedOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Feed.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Feed.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a FeedOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.FeedOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.FeedOperation} FeedOperation
                         */
                        FeedOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.FeedOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.FeedOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.FeedOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.FeedOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.Feed.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.FeedOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.Feed.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a FeedOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.FeedOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.FeedOperation} message FeedOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FeedOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.Feed.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.Feed.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this FeedOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.FeedOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FeedOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return FeedOperation;
                    })();

                    services.MutateFeedsResponse = (function() {

                        /**
                         * Properties of a MutateFeedsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateFeedsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateFeedsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateFeedResult>|null} [results] MutateFeedsResponse results
                         */

                        /**
                         * Constructs a new MutateFeedsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateFeedsResponse.
                         * @implements IMutateFeedsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateFeedsResponse=} [properties] Properties to set
                         */
                        function MutateFeedsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateFeedsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateFeedsResponse
                         * @instance
                         */
                        MutateFeedsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateFeedsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateFeedResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateFeedsResponse
                         * @instance
                         */
                        MutateFeedsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateFeedsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateFeedsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateFeedsResponse} MutateFeedsResponse instance
                         */
                        MutateFeedsResponse.create = function create(properties) {
                            return new MutateFeedsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateFeedsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateFeedsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedsResponse} message MutateFeedsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateFeedResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateFeedsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedsResponse} message MutateFeedsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateFeedsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateFeedsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateFeedsResponse} MutateFeedsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateFeedsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateFeedResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateFeedsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateFeedsResponse} MutateFeedsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateFeedsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateFeedsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateFeedsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateFeedResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateFeedsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateFeedsResponse} MutateFeedsResponse
                         */
                        MutateFeedsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateFeedsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateFeedsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateFeedsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateFeedsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateFeedsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateFeedResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateFeedsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateFeedsResponse} message MutateFeedsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateFeedsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateFeedResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateFeedsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateFeedsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateFeedsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateFeedsResponse;
                    })();

                    services.MutateFeedResult = (function() {

                        /**
                         * Properties of a MutateFeedResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateFeedResult
                         * @property {string|null} [resourceName] MutateFeedResult resourceName
                         */

                        /**
                         * Constructs a new MutateFeedResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateFeedResult.
                         * @implements IMutateFeedResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateFeedResult=} [properties] Properties to set
                         */
                        function MutateFeedResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateFeedResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateFeedResult
                         * @instance
                         */
                        MutateFeedResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateFeedResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateFeedResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateFeedResult} MutateFeedResult instance
                         */
                        MutateFeedResult.create = function create(properties) {
                            return new MutateFeedResult(properties);
                        };

                        /**
                         * Encodes the specified MutateFeedResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateFeedResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedResult} message MutateFeedResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateFeedResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateFeedResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateFeedResult} message MutateFeedResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateFeedResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateFeedResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateFeedResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateFeedResult} MutateFeedResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateFeedResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateFeedResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateFeedResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateFeedResult} MutateFeedResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateFeedResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateFeedResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateFeedResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateFeedResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateFeedResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateFeedResult} MutateFeedResult
                         */
                        MutateFeedResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateFeedResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateFeedResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateFeedResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateFeedResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateFeedResult} message MutateFeedResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateFeedResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateFeedResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateFeedResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateFeedResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateFeedResult;
                    })();

                    services.GenderViewService = (function() {

                        /**
                         * Constructs a new GenderViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GenderViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function GenderViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (GenderViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = GenderViewService;

                        /**
                         * Creates new GenderViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GenderViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {GenderViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        GenderViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.GenderViewService#getGenderView}.
                         * @memberof google.ads.googleads.v1.services.GenderViewService
                         * @typedef GetGenderViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.GenderView} [response] GenderView
                         */

                        /**
                         * Calls GetGenderView.
                         * @function getGenderView
                         * @memberof google.ads.googleads.v1.services.GenderViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetGenderViewRequest} request GetGenderViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.GenderViewService.GetGenderViewCallback} callback Node-style callback called with the error, if any, and GenderView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GenderViewService.prototype.getGenderView = function getGenderView(request, callback) {
                            return this.rpcCall(getGenderView, $root.google.ads.googleads.v1.services.GetGenderViewRequest, $root.google.ads.googleads.v1.resources.GenderView, request, callback);
                        }, "name", { value: "GetGenderView" });

                        /**
                         * Calls GetGenderView.
                         * @function getGenderView
                         * @memberof google.ads.googleads.v1.services.GenderViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetGenderViewRequest} request GetGenderViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.GenderView>} Promise
                         * @variation 2
                         */

                        return GenderViewService;
                    })();

                    services.GetGenderViewRequest = (function() {

                        /**
                         * Properties of a GetGenderViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetGenderViewRequest
                         * @property {string|null} [resourceName] GetGenderViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetGenderViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetGenderViewRequest.
                         * @implements IGetGenderViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetGenderViewRequest=} [properties] Properties to set
                         */
                        function GetGenderViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetGenderViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetGenderViewRequest
                         * @instance
                         */
                        GetGenderViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetGenderViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetGenderViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetGenderViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetGenderViewRequest} GetGenderViewRequest instance
                         */
                        GetGenderViewRequest.create = function create(properties) {
                            return new GetGenderViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetGenderViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetGenderViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetGenderViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetGenderViewRequest} message GetGenderViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGenderViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetGenderViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetGenderViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetGenderViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetGenderViewRequest} message GetGenderViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGenderViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetGenderViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetGenderViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetGenderViewRequest} GetGenderViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGenderViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetGenderViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetGenderViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetGenderViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetGenderViewRequest} GetGenderViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGenderViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetGenderViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetGenderViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetGenderViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetGenderViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetGenderViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetGenderViewRequest} GetGenderViewRequest
                         */
                        GetGenderViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetGenderViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetGenderViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetGenderViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetGenderViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetGenderViewRequest} message GetGenderViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetGenderViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetGenderViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetGenderViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetGenderViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetGenderViewRequest;
                    })();

                    services.GeoTargetConstantService = (function() {

                        /**
                         * Constructs a new GeoTargetConstantService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GeoTargetConstantService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function GeoTargetConstantService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (GeoTargetConstantService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = GeoTargetConstantService;

                        /**
                         * Creates new GeoTargetConstantService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {GeoTargetConstantService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        GeoTargetConstantService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.GeoTargetConstantService#getGeoTargetConstant}.
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantService
                         * @typedef GetGeoTargetConstantCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.GeoTargetConstant} [response] GeoTargetConstant
                         */

                        /**
                         * Calls GetGeoTargetConstant.
                         * @function getGeoTargetConstant
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetGeoTargetConstantRequest} request GetGeoTargetConstantRequest message or plain object
                         * @param {google.ads.googleads.v1.services.GeoTargetConstantService.GetGeoTargetConstantCallback} callback Node-style callback called with the error, if any, and GeoTargetConstant
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GeoTargetConstantService.prototype.getGeoTargetConstant = function getGeoTargetConstant(request, callback) {
                            return this.rpcCall(getGeoTargetConstant, $root.google.ads.googleads.v1.services.GetGeoTargetConstantRequest, $root.google.ads.googleads.v1.resources.GeoTargetConstant, request, callback);
                        }, "name", { value: "GetGeoTargetConstant" });

                        /**
                         * Calls GetGeoTargetConstant.
                         * @function getGeoTargetConstant
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetGeoTargetConstantRequest} request GetGeoTargetConstantRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.GeoTargetConstant>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.GeoTargetConstantService#suggestGeoTargetConstants}.
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantService
                         * @typedef SuggestGeoTargetConstantsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse} [response] SuggestGeoTargetConstantsResponse
                         */

                        /**
                         * Calls SuggestGeoTargetConstants.
                         * @function suggestGeoTargetConstants
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantService
                         * @instance
                         * @param {google.ads.googleads.v1.services.ISuggestGeoTargetConstantsRequest} request SuggestGeoTargetConstantsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.GeoTargetConstantService.SuggestGeoTargetConstantsCallback} callback Node-style callback called with the error, if any, and SuggestGeoTargetConstantsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GeoTargetConstantService.prototype.suggestGeoTargetConstants = function suggestGeoTargetConstants(request, callback) {
                            return this.rpcCall(suggestGeoTargetConstants, $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest, $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse, request, callback);
                        }, "name", { value: "SuggestGeoTargetConstants" });

                        /**
                         * Calls SuggestGeoTargetConstants.
                         * @function suggestGeoTargetConstants
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantService
                         * @instance
                         * @param {google.ads.googleads.v1.services.ISuggestGeoTargetConstantsRequest} request SuggestGeoTargetConstantsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse>} Promise
                         * @variation 2
                         */

                        return GeoTargetConstantService;
                    })();

                    services.GetGeoTargetConstantRequest = (function() {

                        /**
                         * Properties of a GetGeoTargetConstantRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetGeoTargetConstantRequest
                         * @property {string|null} [resourceName] GetGeoTargetConstantRequest resourceName
                         */

                        /**
                         * Constructs a new GetGeoTargetConstantRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetGeoTargetConstantRequest.
                         * @implements IGetGeoTargetConstantRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetGeoTargetConstantRequest=} [properties] Properties to set
                         */
                        function GetGeoTargetConstantRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetGeoTargetConstantRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetGeoTargetConstantRequest
                         * @instance
                         */
                        GetGeoTargetConstantRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetGeoTargetConstantRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetGeoTargetConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetGeoTargetConstantRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetGeoTargetConstantRequest} GetGeoTargetConstantRequest instance
                         */
                        GetGeoTargetConstantRequest.create = function create(properties) {
                            return new GetGeoTargetConstantRequest(properties);
                        };

                        /**
                         * Encodes the specified GetGeoTargetConstantRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetGeoTargetConstantRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetGeoTargetConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetGeoTargetConstantRequest} message GetGeoTargetConstantRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGeoTargetConstantRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetGeoTargetConstantRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetGeoTargetConstantRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetGeoTargetConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetGeoTargetConstantRequest} message GetGeoTargetConstantRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGeoTargetConstantRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetGeoTargetConstantRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetGeoTargetConstantRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetGeoTargetConstantRequest} GetGeoTargetConstantRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGeoTargetConstantRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetGeoTargetConstantRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetGeoTargetConstantRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetGeoTargetConstantRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetGeoTargetConstantRequest} GetGeoTargetConstantRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGeoTargetConstantRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetGeoTargetConstantRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetGeoTargetConstantRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetGeoTargetConstantRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetGeoTargetConstantRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetGeoTargetConstantRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetGeoTargetConstantRequest} GetGeoTargetConstantRequest
                         */
                        GetGeoTargetConstantRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetGeoTargetConstantRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetGeoTargetConstantRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetGeoTargetConstantRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetGeoTargetConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetGeoTargetConstantRequest} message GetGeoTargetConstantRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetGeoTargetConstantRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetGeoTargetConstantRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetGeoTargetConstantRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetGeoTargetConstantRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetGeoTargetConstantRequest;
                    })();

                    services.SuggestGeoTargetConstantsRequest = (function() {

                        /**
                         * Properties of a SuggestGeoTargetConstantsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ISuggestGeoTargetConstantsRequest
                         * @property {google.protobuf.IStringValue|null} [locale] SuggestGeoTargetConstantsRequest locale
                         * @property {google.protobuf.IStringValue|null} [countryCode] SuggestGeoTargetConstantsRequest countryCode
                         * @property {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.ILocationNames|null} [locationNames] SuggestGeoTargetConstantsRequest locationNames
                         * @property {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.IGeoTargets|null} [geoTargets] SuggestGeoTargetConstantsRequest geoTargets
                         */

                        /**
                         * Constructs a new SuggestGeoTargetConstantsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a SuggestGeoTargetConstantsRequest.
                         * @implements ISuggestGeoTargetConstantsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ISuggestGeoTargetConstantsRequest=} [properties] Properties to set
                         */
                        function SuggestGeoTargetConstantsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * SuggestGeoTargetConstantsRequest locale.
                         * @member {google.protobuf.IStringValue|null|undefined} locale
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest
                         * @instance
                         */
                        SuggestGeoTargetConstantsRequest.prototype.locale = null;

                        /**
                         * SuggestGeoTargetConstantsRequest countryCode.
                         * @member {google.protobuf.IStringValue|null|undefined} countryCode
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest
                         * @instance
                         */
                        SuggestGeoTargetConstantsRequest.prototype.countryCode = null;

                        /**
                         * SuggestGeoTargetConstantsRequest locationNames.
                         * @member {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.ILocationNames|null|undefined} locationNames
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest
                         * @instance
                         */
                        SuggestGeoTargetConstantsRequest.prototype.locationNames = null;

                        /**
                         * SuggestGeoTargetConstantsRequest geoTargets.
                         * @member {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.IGeoTargets|null|undefined} geoTargets
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest
                         * @instance
                         */
                        SuggestGeoTargetConstantsRequest.prototype.geoTargets = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * SuggestGeoTargetConstantsRequest query.
                         * @member {"locationNames"|"geoTargets"|undefined} query
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest
                         * @instance
                         */
                        Object.defineProperty(SuggestGeoTargetConstantsRequest.prototype, "query", {
                            get: $util.oneOfGetter($oneOfFields = ["locationNames", "geoTargets"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new SuggestGeoTargetConstantsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ISuggestGeoTargetConstantsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest} SuggestGeoTargetConstantsRequest instance
                         */
                        SuggestGeoTargetConstantsRequest.create = function create(properties) {
                            return new SuggestGeoTargetConstantsRequest(properties);
                        };

                        /**
                         * Encodes the specified SuggestGeoTargetConstantsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ISuggestGeoTargetConstantsRequest} message SuggestGeoTargetConstantsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SuggestGeoTargetConstantsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.locationNames != null && message.hasOwnProperty("locationNames"))
                                $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames.encode(message.locationNames, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.geoTargets != null && message.hasOwnProperty("geoTargets"))
                                $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets.encode(message.geoTargets, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.locale != null && message.hasOwnProperty("locale"))
                                $root.google.protobuf.StringValue.encode(message.locale, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                $root.google.protobuf.StringValue.encode(message.countryCode, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified SuggestGeoTargetConstantsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ISuggestGeoTargetConstantsRequest} message SuggestGeoTargetConstantsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SuggestGeoTargetConstantsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SuggestGeoTargetConstantsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest} SuggestGeoTargetConstantsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SuggestGeoTargetConstantsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.locale = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.countryCode = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.locationNames = $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.geoTargets = $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SuggestGeoTargetConstantsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest} SuggestGeoTargetConstantsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SuggestGeoTargetConstantsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SuggestGeoTargetConstantsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SuggestGeoTargetConstantsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.locale != null && message.hasOwnProperty("locale")) {
                                var error = $root.google.protobuf.StringValue.verify(message.locale);
                                if (error)
                                    return "locale." + error;
                            }
                            if (message.countryCode != null && message.hasOwnProperty("countryCode")) {
                                var error = $root.google.protobuf.StringValue.verify(message.countryCode);
                                if (error)
                                    return "countryCode." + error;
                            }
                            if (message.locationNames != null && message.hasOwnProperty("locationNames")) {
                                properties.query = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames.verify(message.locationNames);
                                    if (error)
                                        return "locationNames." + error;
                                }
                            }
                            if (message.geoTargets != null && message.hasOwnProperty("geoTargets")) {
                                if (properties.query === 1)
                                    return "query: multiple values";
                                properties.query = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets.verify(message.geoTargets);
                                    if (error)
                                        return "geoTargets." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a SuggestGeoTargetConstantsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest} SuggestGeoTargetConstantsRequest
                         */
                        SuggestGeoTargetConstantsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest();
                            if (object.locale != null) {
                                if (typeof object.locale !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.locale: object expected");
                                message.locale = $root.google.protobuf.StringValue.fromObject(object.locale);
                            }
                            if (object.countryCode != null) {
                                if (typeof object.countryCode !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.countryCode: object expected");
                                message.countryCode = $root.google.protobuf.StringValue.fromObject(object.countryCode);
                            }
                            if (object.locationNames != null) {
                                if (typeof object.locationNames !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.locationNames: object expected");
                                message.locationNames = $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames.fromObject(object.locationNames);
                            }
                            if (object.geoTargets != null) {
                                if (typeof object.geoTargets !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.geoTargets: object expected");
                                message.geoTargets = $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets.fromObject(object.geoTargets);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a SuggestGeoTargetConstantsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest} message SuggestGeoTargetConstantsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SuggestGeoTargetConstantsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.locale = null;
                                object.countryCode = null;
                            }
                            if (message.locationNames != null && message.hasOwnProperty("locationNames")) {
                                object.locationNames = $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames.toObject(message.locationNames, options);
                                if (options.oneofs)
                                    object.query = "locationNames";
                            }
                            if (message.geoTargets != null && message.hasOwnProperty("geoTargets")) {
                                object.geoTargets = $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets.toObject(message.geoTargets, options);
                                if (options.oneofs)
                                    object.query = "geoTargets";
                            }
                            if (message.locale != null && message.hasOwnProperty("locale"))
                                object.locale = $root.google.protobuf.StringValue.toObject(message.locale, options);
                            if (message.countryCode != null && message.hasOwnProperty("countryCode"))
                                object.countryCode = $root.google.protobuf.StringValue.toObject(message.countryCode, options);
                            return object;
                        };

                        /**
                         * Converts this SuggestGeoTargetConstantsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SuggestGeoTargetConstantsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        SuggestGeoTargetConstantsRequest.LocationNames = (function() {

                            /**
                             * Properties of a LocationNames.
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest
                             * @interface ILocationNames
                             * @property {Array.<google.protobuf.IStringValue>|null} [names] LocationNames names
                             */

                            /**
                             * Constructs a new LocationNames.
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest
                             * @classdesc Represents a LocationNames.
                             * @implements ILocationNames
                             * @constructor
                             * @param {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.ILocationNames=} [properties] Properties to set
                             */
                            function LocationNames(properties) {
                                this.names = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * LocationNames names.
                             * @member {Array.<google.protobuf.IStringValue>} names
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames
                             * @instance
                             */
                            LocationNames.prototype.names = $util.emptyArray;

                            /**
                             * Creates a new LocationNames instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames
                             * @static
                             * @param {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.ILocationNames=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames} LocationNames instance
                             */
                            LocationNames.create = function create(properties) {
                                return new LocationNames(properties);
                            };

                            /**
                             * Encodes the specified LocationNames message. Does not implicitly {@link google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames
                             * @static
                             * @param {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.ILocationNames} message LocationNames message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            LocationNames.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.names != null && message.names.length)
                                    for (var i = 0; i < message.names.length; ++i)
                                        $root.google.protobuf.StringValue.encode(message.names[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified LocationNames message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames
                             * @static
                             * @param {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.ILocationNames} message LocationNames message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            LocationNames.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a LocationNames message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames} LocationNames
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            LocationNames.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        if (!(message.names && message.names.length))
                                            message.names = [];
                                        message.names.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a LocationNames message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames} LocationNames
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            LocationNames.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a LocationNames message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            LocationNames.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.names != null && message.hasOwnProperty("names")) {
                                    if (!Array.isArray(message.names))
                                        return "names: array expected";
                                    for (var i = 0; i < message.names.length; ++i) {
                                        var error = $root.google.protobuf.StringValue.verify(message.names[i]);
                                        if (error)
                                            return "names." + error;
                                    }
                                }
                                return null;
                            };

                            /**
                             * Creates a LocationNames message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames} LocationNames
                             */
                            LocationNames.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames();
                                if (object.names) {
                                    if (!Array.isArray(object.names))
                                        throw TypeError(".google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames.names: array expected");
                                    message.names = [];
                                    for (var i = 0; i < object.names.length; ++i) {
                                        if (typeof object.names[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames.names: object expected");
                                        message.names[i] = $root.google.protobuf.StringValue.fromObject(object.names[i]);
                                    }
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a LocationNames message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames
                             * @static
                             * @param {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames} message LocationNames
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            LocationNames.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.names = [];
                                if (message.names && message.names.length) {
                                    object.names = [];
                                    for (var j = 0; j < message.names.length; ++j)
                                        object.names[j] = $root.google.protobuf.StringValue.toObject(message.names[j], options);
                                }
                                return object;
                            };

                            /**
                             * Converts this LocationNames to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.LocationNames
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            LocationNames.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return LocationNames;
                        })();

                        SuggestGeoTargetConstantsRequest.GeoTargets = (function() {

                            /**
                             * Properties of a GeoTargets.
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest
                             * @interface IGeoTargets
                             * @property {Array.<google.protobuf.IStringValue>|null} [geoTargetConstants] GeoTargets geoTargetConstants
                             */

                            /**
                             * Constructs a new GeoTargets.
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest
                             * @classdesc Represents a GeoTargets.
                             * @implements IGeoTargets
                             * @constructor
                             * @param {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.IGeoTargets=} [properties] Properties to set
                             */
                            function GeoTargets(properties) {
                                this.geoTargetConstants = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * GeoTargets geoTargetConstants.
                             * @member {Array.<google.protobuf.IStringValue>} geoTargetConstants
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets
                             * @instance
                             */
                            GeoTargets.prototype.geoTargetConstants = $util.emptyArray;

                            /**
                             * Creates a new GeoTargets instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets
                             * @static
                             * @param {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.IGeoTargets=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets} GeoTargets instance
                             */
                            GeoTargets.create = function create(properties) {
                                return new GeoTargets(properties);
                            };

                            /**
                             * Encodes the specified GeoTargets message. Does not implicitly {@link google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets
                             * @static
                             * @param {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.IGeoTargets} message GeoTargets message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            GeoTargets.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.geoTargetConstants != null && message.geoTargetConstants.length)
                                    for (var i = 0; i < message.geoTargetConstants.length; ++i)
                                        $root.google.protobuf.StringValue.encode(message.geoTargetConstants[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified GeoTargets message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets
                             * @static
                             * @param {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.IGeoTargets} message GeoTargets message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            GeoTargets.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a GeoTargets message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets} GeoTargets
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            GeoTargets.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        if (!(message.geoTargetConstants && message.geoTargetConstants.length))
                                            message.geoTargetConstants = [];
                                        message.geoTargetConstants.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a GeoTargets message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets} GeoTargets
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            GeoTargets.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a GeoTargets message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            GeoTargets.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.geoTargetConstants != null && message.hasOwnProperty("geoTargetConstants")) {
                                    if (!Array.isArray(message.geoTargetConstants))
                                        return "geoTargetConstants: array expected";
                                    for (var i = 0; i < message.geoTargetConstants.length; ++i) {
                                        var error = $root.google.protobuf.StringValue.verify(message.geoTargetConstants[i]);
                                        if (error)
                                            return "geoTargetConstants." + error;
                                    }
                                }
                                return null;
                            };

                            /**
                             * Creates a GeoTargets message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets} GeoTargets
                             */
                            GeoTargets.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets();
                                if (object.geoTargetConstants) {
                                    if (!Array.isArray(object.geoTargetConstants))
                                        throw TypeError(".google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets.geoTargetConstants: array expected");
                                    message.geoTargetConstants = [];
                                    for (var i = 0; i < object.geoTargetConstants.length; ++i) {
                                        if (typeof object.geoTargetConstants[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets.geoTargetConstants: object expected");
                                        message.geoTargetConstants[i] = $root.google.protobuf.StringValue.fromObject(object.geoTargetConstants[i]);
                                    }
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a GeoTargets message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets
                             * @static
                             * @param {google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets} message GeoTargets
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            GeoTargets.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.geoTargetConstants = [];
                                if (message.geoTargetConstants && message.geoTargetConstants.length) {
                                    object.geoTargetConstants = [];
                                    for (var j = 0; j < message.geoTargetConstants.length; ++j)
                                        object.geoTargetConstants[j] = $root.google.protobuf.StringValue.toObject(message.geoTargetConstants[j], options);
                                }
                                return object;
                            };

                            /**
                             * Converts this GeoTargets to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsRequest.GeoTargets
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            GeoTargets.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return GeoTargets;
                        })();

                        return SuggestGeoTargetConstantsRequest;
                    })();

                    services.SuggestGeoTargetConstantsResponse = (function() {

                        /**
                         * Properties of a SuggestGeoTargetConstantsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ISuggestGeoTargetConstantsResponse
                         * @property {Array.<google.ads.googleads.v1.services.IGeoTargetConstantSuggestion>|null} [geoTargetConstantSuggestions] SuggestGeoTargetConstantsResponse geoTargetConstantSuggestions
                         */

                        /**
                         * Constructs a new SuggestGeoTargetConstantsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a SuggestGeoTargetConstantsResponse.
                         * @implements ISuggestGeoTargetConstantsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ISuggestGeoTargetConstantsResponse=} [properties] Properties to set
                         */
                        function SuggestGeoTargetConstantsResponse(properties) {
                            this.geoTargetConstantSuggestions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * SuggestGeoTargetConstantsResponse geoTargetConstantSuggestions.
                         * @member {Array.<google.ads.googleads.v1.services.IGeoTargetConstantSuggestion>} geoTargetConstantSuggestions
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse
                         * @instance
                         */
                        SuggestGeoTargetConstantsResponse.prototype.geoTargetConstantSuggestions = $util.emptyArray;

                        /**
                         * Creates a new SuggestGeoTargetConstantsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ISuggestGeoTargetConstantsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse} SuggestGeoTargetConstantsResponse instance
                         */
                        SuggestGeoTargetConstantsResponse.create = function create(properties) {
                            return new SuggestGeoTargetConstantsResponse(properties);
                        };

                        /**
                         * Encodes the specified SuggestGeoTargetConstantsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ISuggestGeoTargetConstantsResponse} message SuggestGeoTargetConstantsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SuggestGeoTargetConstantsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.geoTargetConstantSuggestions != null && message.geoTargetConstantSuggestions.length)
                                for (var i = 0; i < message.geoTargetConstantSuggestions.length; ++i)
                                    $root.google.ads.googleads.v1.services.GeoTargetConstantSuggestion.encode(message.geoTargetConstantSuggestions[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified SuggestGeoTargetConstantsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ISuggestGeoTargetConstantsResponse} message SuggestGeoTargetConstantsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SuggestGeoTargetConstantsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SuggestGeoTargetConstantsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse} SuggestGeoTargetConstantsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SuggestGeoTargetConstantsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.geoTargetConstantSuggestions && message.geoTargetConstantSuggestions.length))
                                        message.geoTargetConstantSuggestions = [];
                                    message.geoTargetConstantSuggestions.push($root.google.ads.googleads.v1.services.GeoTargetConstantSuggestion.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SuggestGeoTargetConstantsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse} SuggestGeoTargetConstantsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SuggestGeoTargetConstantsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SuggestGeoTargetConstantsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SuggestGeoTargetConstantsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.geoTargetConstantSuggestions != null && message.hasOwnProperty("geoTargetConstantSuggestions")) {
                                if (!Array.isArray(message.geoTargetConstantSuggestions))
                                    return "geoTargetConstantSuggestions: array expected";
                                for (var i = 0; i < message.geoTargetConstantSuggestions.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.GeoTargetConstantSuggestion.verify(message.geoTargetConstantSuggestions[i]);
                                    if (error)
                                        return "geoTargetConstantSuggestions." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a SuggestGeoTargetConstantsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse} SuggestGeoTargetConstantsResponse
                         */
                        SuggestGeoTargetConstantsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse();
                            if (object.geoTargetConstantSuggestions) {
                                if (!Array.isArray(object.geoTargetConstantSuggestions))
                                    throw TypeError(".google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse.geoTargetConstantSuggestions: array expected");
                                message.geoTargetConstantSuggestions = [];
                                for (var i = 0; i < object.geoTargetConstantSuggestions.length; ++i) {
                                    if (typeof object.geoTargetConstantSuggestions[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse.geoTargetConstantSuggestions: object expected");
                                    message.geoTargetConstantSuggestions[i] = $root.google.ads.googleads.v1.services.GeoTargetConstantSuggestion.fromObject(object.geoTargetConstantSuggestions[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a SuggestGeoTargetConstantsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse} message SuggestGeoTargetConstantsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SuggestGeoTargetConstantsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.geoTargetConstantSuggestions = [];
                            if (message.geoTargetConstantSuggestions && message.geoTargetConstantSuggestions.length) {
                                object.geoTargetConstantSuggestions = [];
                                for (var j = 0; j < message.geoTargetConstantSuggestions.length; ++j)
                                    object.geoTargetConstantSuggestions[j] = $root.google.ads.googleads.v1.services.GeoTargetConstantSuggestion.toObject(message.geoTargetConstantSuggestions[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this SuggestGeoTargetConstantsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.SuggestGeoTargetConstantsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SuggestGeoTargetConstantsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return SuggestGeoTargetConstantsResponse;
                    })();

                    services.GeoTargetConstantSuggestion = (function() {

                        /**
                         * Properties of a GeoTargetConstantSuggestion.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGeoTargetConstantSuggestion
                         * @property {google.protobuf.IStringValue|null} [locale] GeoTargetConstantSuggestion locale
                         * @property {google.protobuf.IInt64Value|null} [reach] GeoTargetConstantSuggestion reach
                         * @property {google.protobuf.IStringValue|null} [searchTerm] GeoTargetConstantSuggestion searchTerm
                         * @property {google.ads.googleads.v1.resources.IGeoTargetConstant|null} [geoTargetConstant] GeoTargetConstantSuggestion geoTargetConstant
                         * @property {Array.<google.ads.googleads.v1.resources.IGeoTargetConstant>|null} [geoTargetConstantParents] GeoTargetConstantSuggestion geoTargetConstantParents
                         */

                        /**
                         * Constructs a new GeoTargetConstantSuggestion.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GeoTargetConstantSuggestion.
                         * @implements IGeoTargetConstantSuggestion
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGeoTargetConstantSuggestion=} [properties] Properties to set
                         */
                        function GeoTargetConstantSuggestion(properties) {
                            this.geoTargetConstantParents = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GeoTargetConstantSuggestion locale.
                         * @member {google.protobuf.IStringValue|null|undefined} locale
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantSuggestion
                         * @instance
                         */
                        GeoTargetConstantSuggestion.prototype.locale = null;

                        /**
                         * GeoTargetConstantSuggestion reach.
                         * @member {google.protobuf.IInt64Value|null|undefined} reach
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantSuggestion
                         * @instance
                         */
                        GeoTargetConstantSuggestion.prototype.reach = null;

                        /**
                         * GeoTargetConstantSuggestion searchTerm.
                         * @member {google.protobuf.IStringValue|null|undefined} searchTerm
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantSuggestion
                         * @instance
                         */
                        GeoTargetConstantSuggestion.prototype.searchTerm = null;

                        /**
                         * GeoTargetConstantSuggestion geoTargetConstant.
                         * @member {google.ads.googleads.v1.resources.IGeoTargetConstant|null|undefined} geoTargetConstant
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantSuggestion
                         * @instance
                         */
                        GeoTargetConstantSuggestion.prototype.geoTargetConstant = null;

                        /**
                         * GeoTargetConstantSuggestion geoTargetConstantParents.
                         * @member {Array.<google.ads.googleads.v1.resources.IGeoTargetConstant>} geoTargetConstantParents
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantSuggestion
                         * @instance
                         */
                        GeoTargetConstantSuggestion.prototype.geoTargetConstantParents = $util.emptyArray;

                        /**
                         * Creates a new GeoTargetConstantSuggestion instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantSuggestion
                         * @static
                         * @param {google.ads.googleads.v1.services.IGeoTargetConstantSuggestion=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GeoTargetConstantSuggestion} GeoTargetConstantSuggestion instance
                         */
                        GeoTargetConstantSuggestion.create = function create(properties) {
                            return new GeoTargetConstantSuggestion(properties);
                        };

                        /**
                         * Encodes the specified GeoTargetConstantSuggestion message. Does not implicitly {@link google.ads.googleads.v1.services.GeoTargetConstantSuggestion.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantSuggestion
                         * @static
                         * @param {google.ads.googleads.v1.services.IGeoTargetConstantSuggestion} message GeoTargetConstantSuggestion message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GeoTargetConstantSuggestion.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.locale != null && message.hasOwnProperty("locale"))
                                $root.google.protobuf.StringValue.encode(message.locale, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.reach != null && message.hasOwnProperty("reach"))
                                $root.google.protobuf.Int64Value.encode(message.reach, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.searchTerm != null && message.hasOwnProperty("searchTerm"))
                                $root.google.protobuf.StringValue.encode(message.searchTerm, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.geoTargetConstant != null && message.hasOwnProperty("geoTargetConstant"))
                                $root.google.ads.googleads.v1.resources.GeoTargetConstant.encode(message.geoTargetConstant, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.geoTargetConstantParents != null && message.geoTargetConstantParents.length)
                                for (var i = 0; i < message.geoTargetConstantParents.length; ++i)
                                    $root.google.ads.googleads.v1.resources.GeoTargetConstant.encode(message.geoTargetConstantParents[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified GeoTargetConstantSuggestion message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GeoTargetConstantSuggestion.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantSuggestion
                         * @static
                         * @param {google.ads.googleads.v1.services.IGeoTargetConstantSuggestion} message GeoTargetConstantSuggestion message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GeoTargetConstantSuggestion.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GeoTargetConstantSuggestion message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantSuggestion
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GeoTargetConstantSuggestion} GeoTargetConstantSuggestion
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GeoTargetConstantSuggestion.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GeoTargetConstantSuggestion();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.locale = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.reach = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.searchTerm = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.geoTargetConstant = $root.google.ads.googleads.v1.resources.GeoTargetConstant.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    if (!(message.geoTargetConstantParents && message.geoTargetConstantParents.length))
                                        message.geoTargetConstantParents = [];
                                    message.geoTargetConstantParents.push($root.google.ads.googleads.v1.resources.GeoTargetConstant.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GeoTargetConstantSuggestion message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantSuggestion
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GeoTargetConstantSuggestion} GeoTargetConstantSuggestion
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GeoTargetConstantSuggestion.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GeoTargetConstantSuggestion message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantSuggestion
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GeoTargetConstantSuggestion.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.locale != null && message.hasOwnProperty("locale")) {
                                var error = $root.google.protobuf.StringValue.verify(message.locale);
                                if (error)
                                    return "locale." + error;
                            }
                            if (message.reach != null && message.hasOwnProperty("reach")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.reach);
                                if (error)
                                    return "reach." + error;
                            }
                            if (message.searchTerm != null && message.hasOwnProperty("searchTerm")) {
                                var error = $root.google.protobuf.StringValue.verify(message.searchTerm);
                                if (error)
                                    return "searchTerm." + error;
                            }
                            if (message.geoTargetConstant != null && message.hasOwnProperty("geoTargetConstant")) {
                                var error = $root.google.ads.googleads.v1.resources.GeoTargetConstant.verify(message.geoTargetConstant);
                                if (error)
                                    return "geoTargetConstant." + error;
                            }
                            if (message.geoTargetConstantParents != null && message.hasOwnProperty("geoTargetConstantParents")) {
                                if (!Array.isArray(message.geoTargetConstantParents))
                                    return "geoTargetConstantParents: array expected";
                                for (var i = 0; i < message.geoTargetConstantParents.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.resources.GeoTargetConstant.verify(message.geoTargetConstantParents[i]);
                                    if (error)
                                        return "geoTargetConstantParents." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a GeoTargetConstantSuggestion message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantSuggestion
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GeoTargetConstantSuggestion} GeoTargetConstantSuggestion
                         */
                        GeoTargetConstantSuggestion.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GeoTargetConstantSuggestion)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GeoTargetConstantSuggestion();
                            if (object.locale != null) {
                                if (typeof object.locale !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GeoTargetConstantSuggestion.locale: object expected");
                                message.locale = $root.google.protobuf.StringValue.fromObject(object.locale);
                            }
                            if (object.reach != null) {
                                if (typeof object.reach !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GeoTargetConstantSuggestion.reach: object expected");
                                message.reach = $root.google.protobuf.Int64Value.fromObject(object.reach);
                            }
                            if (object.searchTerm != null) {
                                if (typeof object.searchTerm !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GeoTargetConstantSuggestion.searchTerm: object expected");
                                message.searchTerm = $root.google.protobuf.StringValue.fromObject(object.searchTerm);
                            }
                            if (object.geoTargetConstant != null) {
                                if (typeof object.geoTargetConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GeoTargetConstantSuggestion.geoTargetConstant: object expected");
                                message.geoTargetConstant = $root.google.ads.googleads.v1.resources.GeoTargetConstant.fromObject(object.geoTargetConstant);
                            }
                            if (object.geoTargetConstantParents) {
                                if (!Array.isArray(object.geoTargetConstantParents))
                                    throw TypeError(".google.ads.googleads.v1.services.GeoTargetConstantSuggestion.geoTargetConstantParents: array expected");
                                message.geoTargetConstantParents = [];
                                for (var i = 0; i < object.geoTargetConstantParents.length; ++i) {
                                    if (typeof object.geoTargetConstantParents[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.GeoTargetConstantSuggestion.geoTargetConstantParents: object expected");
                                    message.geoTargetConstantParents[i] = $root.google.ads.googleads.v1.resources.GeoTargetConstant.fromObject(object.geoTargetConstantParents[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a GeoTargetConstantSuggestion message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantSuggestion
                         * @static
                         * @param {google.ads.googleads.v1.services.GeoTargetConstantSuggestion} message GeoTargetConstantSuggestion
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GeoTargetConstantSuggestion.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.geoTargetConstantParents = [];
                            if (options.defaults) {
                                object.locale = null;
                                object.reach = null;
                                object.searchTerm = null;
                                object.geoTargetConstant = null;
                            }
                            if (message.locale != null && message.hasOwnProperty("locale"))
                                object.locale = $root.google.protobuf.StringValue.toObject(message.locale, options);
                            if (message.reach != null && message.hasOwnProperty("reach"))
                                object.reach = $root.google.protobuf.Int64Value.toObject(message.reach, options);
                            if (message.searchTerm != null && message.hasOwnProperty("searchTerm"))
                                object.searchTerm = $root.google.protobuf.StringValue.toObject(message.searchTerm, options);
                            if (message.geoTargetConstant != null && message.hasOwnProperty("geoTargetConstant"))
                                object.geoTargetConstant = $root.google.ads.googleads.v1.resources.GeoTargetConstant.toObject(message.geoTargetConstant, options);
                            if (message.geoTargetConstantParents && message.geoTargetConstantParents.length) {
                                object.geoTargetConstantParents = [];
                                for (var j = 0; j < message.geoTargetConstantParents.length; ++j)
                                    object.geoTargetConstantParents[j] = $root.google.ads.googleads.v1.resources.GeoTargetConstant.toObject(message.geoTargetConstantParents[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this GeoTargetConstantSuggestion to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GeoTargetConstantSuggestion
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GeoTargetConstantSuggestion.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GeoTargetConstantSuggestion;
                    })();

                    services.GeographicViewService = (function() {

                        /**
                         * Constructs a new GeographicViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GeographicViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function GeographicViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (GeographicViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = GeographicViewService;

                        /**
                         * Creates new GeographicViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GeographicViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {GeographicViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        GeographicViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.GeographicViewService#getGeographicView}.
                         * @memberof google.ads.googleads.v1.services.GeographicViewService
                         * @typedef GetGeographicViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.GeographicView} [response] GeographicView
                         */

                        /**
                         * Calls GetGeographicView.
                         * @function getGeographicView
                         * @memberof google.ads.googleads.v1.services.GeographicViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetGeographicViewRequest} request GetGeographicViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.GeographicViewService.GetGeographicViewCallback} callback Node-style callback called with the error, if any, and GeographicView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GeographicViewService.prototype.getGeographicView = function getGeographicView(request, callback) {
                            return this.rpcCall(getGeographicView, $root.google.ads.googleads.v1.services.GetGeographicViewRequest, $root.google.ads.googleads.v1.resources.GeographicView, request, callback);
                        }, "name", { value: "GetGeographicView" });

                        /**
                         * Calls GetGeographicView.
                         * @function getGeographicView
                         * @memberof google.ads.googleads.v1.services.GeographicViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetGeographicViewRequest} request GetGeographicViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.GeographicView>} Promise
                         * @variation 2
                         */

                        return GeographicViewService;
                    })();

                    services.GetGeographicViewRequest = (function() {

                        /**
                         * Properties of a GetGeographicViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetGeographicViewRequest
                         * @property {string|null} [resourceName] GetGeographicViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetGeographicViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetGeographicViewRequest.
                         * @implements IGetGeographicViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetGeographicViewRequest=} [properties] Properties to set
                         */
                        function GetGeographicViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetGeographicViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetGeographicViewRequest
                         * @instance
                         */
                        GetGeographicViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetGeographicViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetGeographicViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetGeographicViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetGeographicViewRequest} GetGeographicViewRequest instance
                         */
                        GetGeographicViewRequest.create = function create(properties) {
                            return new GetGeographicViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetGeographicViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetGeographicViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetGeographicViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetGeographicViewRequest} message GetGeographicViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGeographicViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetGeographicViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetGeographicViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetGeographicViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetGeographicViewRequest} message GetGeographicViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGeographicViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetGeographicViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetGeographicViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetGeographicViewRequest} GetGeographicViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGeographicViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetGeographicViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetGeographicViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetGeographicViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetGeographicViewRequest} GetGeographicViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGeographicViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetGeographicViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetGeographicViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetGeographicViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetGeographicViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetGeographicViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetGeographicViewRequest} GetGeographicViewRequest
                         */
                        GetGeographicViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetGeographicViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetGeographicViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetGeographicViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetGeographicViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetGeographicViewRequest} message GetGeographicViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetGeographicViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetGeographicViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetGeographicViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetGeographicViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetGeographicViewRequest;
                    })();

                    services.GoogleAdsFieldService = (function() {

                        /**
                         * Constructs a new GoogleAdsFieldService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GoogleAdsFieldService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function GoogleAdsFieldService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (GoogleAdsFieldService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = GoogleAdsFieldService;

                        /**
                         * Creates new GoogleAdsFieldService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GoogleAdsFieldService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {GoogleAdsFieldService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        GoogleAdsFieldService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.GoogleAdsFieldService#getGoogleAdsField}.
                         * @memberof google.ads.googleads.v1.services.GoogleAdsFieldService
                         * @typedef GetGoogleAdsFieldCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.GoogleAdsField} [response] GoogleAdsField
                         */

                        /**
                         * Calls GetGoogleAdsField.
                         * @function getGoogleAdsField
                         * @memberof google.ads.googleads.v1.services.GoogleAdsFieldService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetGoogleAdsFieldRequest} request GetGoogleAdsFieldRequest message or plain object
                         * @param {google.ads.googleads.v1.services.GoogleAdsFieldService.GetGoogleAdsFieldCallback} callback Node-style callback called with the error, if any, and GoogleAdsField
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GoogleAdsFieldService.prototype.getGoogleAdsField = function getGoogleAdsField(request, callback) {
                            return this.rpcCall(getGoogleAdsField, $root.google.ads.googleads.v1.services.GetGoogleAdsFieldRequest, $root.google.ads.googleads.v1.resources.GoogleAdsField, request, callback);
                        }, "name", { value: "GetGoogleAdsField" });

                        /**
                         * Calls GetGoogleAdsField.
                         * @function getGoogleAdsField
                         * @memberof google.ads.googleads.v1.services.GoogleAdsFieldService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetGoogleAdsFieldRequest} request GetGoogleAdsFieldRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.GoogleAdsField>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.GoogleAdsFieldService#searchGoogleAdsFields}.
                         * @memberof google.ads.googleads.v1.services.GoogleAdsFieldService
                         * @typedef SearchGoogleAdsFieldsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse} [response] SearchGoogleAdsFieldsResponse
                         */

                        /**
                         * Calls SearchGoogleAdsFields.
                         * @function searchGoogleAdsFields
                         * @memberof google.ads.googleads.v1.services.GoogleAdsFieldService
                         * @instance
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsFieldsRequest} request SearchGoogleAdsFieldsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.GoogleAdsFieldService.SearchGoogleAdsFieldsCallback} callback Node-style callback called with the error, if any, and SearchGoogleAdsFieldsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GoogleAdsFieldService.prototype.searchGoogleAdsFields = function searchGoogleAdsFields(request, callback) {
                            return this.rpcCall(searchGoogleAdsFields, $root.google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest, $root.google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse, request, callback);
                        }, "name", { value: "SearchGoogleAdsFields" });

                        /**
                         * Calls SearchGoogleAdsFields.
                         * @function searchGoogleAdsFields
                         * @memberof google.ads.googleads.v1.services.GoogleAdsFieldService
                         * @instance
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsFieldsRequest} request SearchGoogleAdsFieldsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse>} Promise
                         * @variation 2
                         */

                        return GoogleAdsFieldService;
                    })();

                    services.GetGoogleAdsFieldRequest = (function() {

                        /**
                         * Properties of a GetGoogleAdsFieldRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetGoogleAdsFieldRequest
                         * @property {string|null} [resourceName] GetGoogleAdsFieldRequest resourceName
                         */

                        /**
                         * Constructs a new GetGoogleAdsFieldRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetGoogleAdsFieldRequest.
                         * @implements IGetGoogleAdsFieldRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetGoogleAdsFieldRequest=} [properties] Properties to set
                         */
                        function GetGoogleAdsFieldRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetGoogleAdsFieldRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetGoogleAdsFieldRequest
                         * @instance
                         */
                        GetGoogleAdsFieldRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetGoogleAdsFieldRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetGoogleAdsFieldRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetGoogleAdsFieldRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetGoogleAdsFieldRequest} GetGoogleAdsFieldRequest instance
                         */
                        GetGoogleAdsFieldRequest.create = function create(properties) {
                            return new GetGoogleAdsFieldRequest(properties);
                        };

                        /**
                         * Encodes the specified GetGoogleAdsFieldRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetGoogleAdsFieldRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetGoogleAdsFieldRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetGoogleAdsFieldRequest} message GetGoogleAdsFieldRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGoogleAdsFieldRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetGoogleAdsFieldRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetGoogleAdsFieldRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetGoogleAdsFieldRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetGoogleAdsFieldRequest} message GetGoogleAdsFieldRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGoogleAdsFieldRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetGoogleAdsFieldRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetGoogleAdsFieldRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetGoogleAdsFieldRequest} GetGoogleAdsFieldRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGoogleAdsFieldRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetGoogleAdsFieldRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetGoogleAdsFieldRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetGoogleAdsFieldRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetGoogleAdsFieldRequest} GetGoogleAdsFieldRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGoogleAdsFieldRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetGoogleAdsFieldRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetGoogleAdsFieldRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetGoogleAdsFieldRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetGoogleAdsFieldRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetGoogleAdsFieldRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetGoogleAdsFieldRequest} GetGoogleAdsFieldRequest
                         */
                        GetGoogleAdsFieldRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetGoogleAdsFieldRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetGoogleAdsFieldRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetGoogleAdsFieldRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetGoogleAdsFieldRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetGoogleAdsFieldRequest} message GetGoogleAdsFieldRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetGoogleAdsFieldRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetGoogleAdsFieldRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetGoogleAdsFieldRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetGoogleAdsFieldRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetGoogleAdsFieldRequest;
                    })();

                    services.SearchGoogleAdsFieldsRequest = (function() {

                        /**
                         * Properties of a SearchGoogleAdsFieldsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ISearchGoogleAdsFieldsRequest
                         * @property {string|null} [query] SearchGoogleAdsFieldsRequest query
                         * @property {string|null} [pageToken] SearchGoogleAdsFieldsRequest pageToken
                         * @property {number|null} [pageSize] SearchGoogleAdsFieldsRequest pageSize
                         */

                        /**
                         * Constructs a new SearchGoogleAdsFieldsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a SearchGoogleAdsFieldsRequest.
                         * @implements ISearchGoogleAdsFieldsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsFieldsRequest=} [properties] Properties to set
                         */
                        function SearchGoogleAdsFieldsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * SearchGoogleAdsFieldsRequest query.
                         * @member {string} query
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest
                         * @instance
                         */
                        SearchGoogleAdsFieldsRequest.prototype.query = "";

                        /**
                         * SearchGoogleAdsFieldsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest
                         * @instance
                         */
                        SearchGoogleAdsFieldsRequest.prototype.pageToken = "";

                        /**
                         * SearchGoogleAdsFieldsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest
                         * @instance
                         */
                        SearchGoogleAdsFieldsRequest.prototype.pageSize = 0;

                        /**
                         * Creates a new SearchGoogleAdsFieldsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsFieldsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest} SearchGoogleAdsFieldsRequest instance
                         */
                        SearchGoogleAdsFieldsRequest.create = function create(properties) {
                            return new SearchGoogleAdsFieldsRequest(properties);
                        };

                        /**
                         * Encodes the specified SearchGoogleAdsFieldsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsFieldsRequest} message SearchGoogleAdsFieldsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchGoogleAdsFieldsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.query != null && message.hasOwnProperty("query"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.query);
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.pageToken);
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.pageSize);
                            return writer;
                        };

                        /**
                         * Encodes the specified SearchGoogleAdsFieldsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsFieldsRequest} message SearchGoogleAdsFieldsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchGoogleAdsFieldsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SearchGoogleAdsFieldsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest} SearchGoogleAdsFieldsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchGoogleAdsFieldsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.query = reader.string();
                                    break;
                                case 2:
                                    message.pageToken = reader.string();
                                    break;
                                case 3:
                                    message.pageSize = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SearchGoogleAdsFieldsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest} SearchGoogleAdsFieldsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchGoogleAdsFieldsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SearchGoogleAdsFieldsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SearchGoogleAdsFieldsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.query != null && message.hasOwnProperty("query"))
                                if (!$util.isString(message.query))
                                    return "query: string expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            return null;
                        };

                        /**
                         * Creates a SearchGoogleAdsFieldsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest} SearchGoogleAdsFieldsRequest
                         */
                        SearchGoogleAdsFieldsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest();
                            if (object.query != null)
                                message.query = String(object.query);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            return message;
                        };

                        /**
                         * Creates a plain object from a SearchGoogleAdsFieldsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest} message SearchGoogleAdsFieldsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SearchGoogleAdsFieldsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.query = "";
                                object.pageToken = "";
                                object.pageSize = 0;
                            }
                            if (message.query != null && message.hasOwnProperty("query"))
                                object.query = message.query;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            return object;
                        };

                        /**
                         * Converts this SearchGoogleAdsFieldsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SearchGoogleAdsFieldsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return SearchGoogleAdsFieldsRequest;
                    })();

                    services.SearchGoogleAdsFieldsResponse = (function() {

                        /**
                         * Properties of a SearchGoogleAdsFieldsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ISearchGoogleAdsFieldsResponse
                         * @property {Array.<google.ads.googleads.v1.resources.IGoogleAdsField>|null} [results] SearchGoogleAdsFieldsResponse results
                         * @property {string|null} [nextPageToken] SearchGoogleAdsFieldsResponse nextPageToken
                         * @property {number|Long|null} [totalResultsCount] SearchGoogleAdsFieldsResponse totalResultsCount
                         */

                        /**
                         * Constructs a new SearchGoogleAdsFieldsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a SearchGoogleAdsFieldsResponse.
                         * @implements ISearchGoogleAdsFieldsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsFieldsResponse=} [properties] Properties to set
                         */
                        function SearchGoogleAdsFieldsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * SearchGoogleAdsFieldsResponse results.
                         * @member {Array.<google.ads.googleads.v1.resources.IGoogleAdsField>} results
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse
                         * @instance
                         */
                        SearchGoogleAdsFieldsResponse.prototype.results = $util.emptyArray;

                        /**
                         * SearchGoogleAdsFieldsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse
                         * @instance
                         */
                        SearchGoogleAdsFieldsResponse.prototype.nextPageToken = "";

                        /**
                         * SearchGoogleAdsFieldsResponse totalResultsCount.
                         * @member {number|Long} totalResultsCount
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse
                         * @instance
                         */
                        SearchGoogleAdsFieldsResponse.prototype.totalResultsCount = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

                        /**
                         * Creates a new SearchGoogleAdsFieldsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsFieldsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse} SearchGoogleAdsFieldsResponse instance
                         */
                        SearchGoogleAdsFieldsResponse.create = function create(properties) {
                            return new SearchGoogleAdsFieldsResponse(properties);
                        };

                        /**
                         * Encodes the specified SearchGoogleAdsFieldsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsFieldsResponse} message SearchGoogleAdsFieldsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchGoogleAdsFieldsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.resources.GoogleAdsField.encode(message.results[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            if (message.totalResultsCount != null && message.hasOwnProperty("totalResultsCount"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int64(message.totalResultsCount);
                            return writer;
                        };

                        /**
                         * Encodes the specified SearchGoogleAdsFieldsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsFieldsResponse} message SearchGoogleAdsFieldsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchGoogleAdsFieldsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SearchGoogleAdsFieldsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse} SearchGoogleAdsFieldsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchGoogleAdsFieldsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.resources.GoogleAdsField.decode(reader, reader.uint32()));
                                    break;
                                case 2:
                                    message.nextPageToken = reader.string();
                                    break;
                                case 3:
                                    message.totalResultsCount = reader.int64();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SearchGoogleAdsFieldsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse} SearchGoogleAdsFieldsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchGoogleAdsFieldsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SearchGoogleAdsFieldsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SearchGoogleAdsFieldsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.resources.GoogleAdsField.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            if (message.totalResultsCount != null && message.hasOwnProperty("totalResultsCount"))
                                if (!$util.isInteger(message.totalResultsCount) && !(message.totalResultsCount && $util.isInteger(message.totalResultsCount.low) && $util.isInteger(message.totalResultsCount.high)))
                                    return "totalResultsCount: integer|Long expected";
                            return null;
                        };

                        /**
                         * Creates a SearchGoogleAdsFieldsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse} SearchGoogleAdsFieldsResponse
                         */
                        SearchGoogleAdsFieldsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse();
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.resources.GoogleAdsField.fromObject(object.results[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.totalResultsCount != null)
                                if ($util.Long)
                                    (message.totalResultsCount = $util.Long.fromValue(object.totalResultsCount)).unsigned = false;
                                else if (typeof object.totalResultsCount === "string")
                                    message.totalResultsCount = parseInt(object.totalResultsCount, 10);
                                else if (typeof object.totalResultsCount === "number")
                                    message.totalResultsCount = object.totalResultsCount;
                                else if (typeof object.totalResultsCount === "object")
                                    message.totalResultsCount = new $util.LongBits(object.totalResultsCount.low >>> 0, object.totalResultsCount.high >>> 0).toNumber();
                            return message;
                        };

                        /**
                         * Creates a plain object from a SearchGoogleAdsFieldsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse} message SearchGoogleAdsFieldsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SearchGoogleAdsFieldsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults) {
                                object.nextPageToken = "";
                                if ($util.Long) {
                                    var long = new $util.Long(0, 0, false);
                                    object.totalResultsCount = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                                } else
                                    object.totalResultsCount = options.longs === String ? "0" : 0;
                            }
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.resources.GoogleAdsField.toObject(message.results[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            if (message.totalResultsCount != null && message.hasOwnProperty("totalResultsCount"))
                                if (typeof message.totalResultsCount === "number")
                                    object.totalResultsCount = options.longs === String ? String(message.totalResultsCount) : message.totalResultsCount;
                                else
                                    object.totalResultsCount = options.longs === String ? $util.Long.prototype.toString.call(message.totalResultsCount) : options.longs === Number ? new $util.LongBits(message.totalResultsCount.low >>> 0, message.totalResultsCount.high >>> 0).toNumber() : message.totalResultsCount;
                            return object;
                        };

                        /**
                         * Converts this SearchGoogleAdsFieldsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsFieldsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SearchGoogleAdsFieldsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return SearchGoogleAdsFieldsResponse;
                    })();

                    services.GoogleAdsService = (function() {

                        /**
                         * Constructs a new GoogleAdsService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GoogleAdsService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function GoogleAdsService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (GoogleAdsService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = GoogleAdsService;

                        /**
                         * Creates new GoogleAdsService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GoogleAdsService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {GoogleAdsService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        GoogleAdsService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.GoogleAdsService#search}.
                         * @memberof google.ads.googleads.v1.services.GoogleAdsService
                         * @typedef SearchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.SearchGoogleAdsResponse} [response] SearchGoogleAdsResponse
                         */

                        /**
                         * Calls Search.
                         * @function search
                         * @memberof google.ads.googleads.v1.services.GoogleAdsService
                         * @instance
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsRequest} request SearchGoogleAdsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.GoogleAdsService.SearchCallback} callback Node-style callback called with the error, if any, and SearchGoogleAdsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GoogleAdsService.prototype.search = function search(request, callback) {
                            return this.rpcCall(search, $root.google.ads.googleads.v1.services.SearchGoogleAdsRequest, $root.google.ads.googleads.v1.services.SearchGoogleAdsResponse, request, callback);
                        }, "name", { value: "Search" });

                        /**
                         * Calls Search.
                         * @function search
                         * @memberof google.ads.googleads.v1.services.GoogleAdsService
                         * @instance
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsRequest} request SearchGoogleAdsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.SearchGoogleAdsResponse>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.GoogleAdsService#mutate}.
                         * @memberof google.ads.googleads.v1.services.GoogleAdsService
                         * @typedef MutateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateGoogleAdsResponse} [response] MutateGoogleAdsResponse
                         */

                        /**
                         * Calls Mutate.
                         * @function mutate
                         * @memberof google.ads.googleads.v1.services.GoogleAdsService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateGoogleAdsRequest} request MutateGoogleAdsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.GoogleAdsService.MutateCallback} callback Node-style callback called with the error, if any, and MutateGoogleAdsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GoogleAdsService.prototype.mutate = function mutate(request, callback) {
                            return this.rpcCall(mutate, $root.google.ads.googleads.v1.services.MutateGoogleAdsRequest, $root.google.ads.googleads.v1.services.MutateGoogleAdsResponse, request, callback);
                        }, "name", { value: "Mutate" });

                        /**
                         * Calls Mutate.
                         * @function mutate
                         * @memberof google.ads.googleads.v1.services.GoogleAdsService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateGoogleAdsRequest} request MutateGoogleAdsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateGoogleAdsResponse>} Promise
                         * @variation 2
                         */

                        return GoogleAdsService;
                    })();

                    services.SearchGoogleAdsRequest = (function() {

                        /**
                         * Properties of a SearchGoogleAdsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ISearchGoogleAdsRequest
                         * @property {string|null} [customerId] SearchGoogleAdsRequest customerId
                         * @property {string|null} [query] SearchGoogleAdsRequest query
                         * @property {string|null} [pageToken] SearchGoogleAdsRequest pageToken
                         * @property {number|null} [pageSize] SearchGoogleAdsRequest pageSize
                         * @property {boolean|null} [validateOnly] SearchGoogleAdsRequest validateOnly
                         */

                        /**
                         * Constructs a new SearchGoogleAdsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a SearchGoogleAdsRequest.
                         * @implements ISearchGoogleAdsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsRequest=} [properties] Properties to set
                         */
                        function SearchGoogleAdsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * SearchGoogleAdsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsRequest
                         * @instance
                         */
                        SearchGoogleAdsRequest.prototype.customerId = "";

                        /**
                         * SearchGoogleAdsRequest query.
                         * @member {string} query
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsRequest
                         * @instance
                         */
                        SearchGoogleAdsRequest.prototype.query = "";

                        /**
                         * SearchGoogleAdsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsRequest
                         * @instance
                         */
                        SearchGoogleAdsRequest.prototype.pageToken = "";

                        /**
                         * SearchGoogleAdsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsRequest
                         * @instance
                         */
                        SearchGoogleAdsRequest.prototype.pageSize = 0;

                        /**
                         * SearchGoogleAdsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsRequest
                         * @instance
                         */
                        SearchGoogleAdsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new SearchGoogleAdsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.SearchGoogleAdsRequest} SearchGoogleAdsRequest instance
                         */
                        SearchGoogleAdsRequest.create = function create(properties) {
                            return new SearchGoogleAdsRequest(properties);
                        };

                        /**
                         * Encodes the specified SearchGoogleAdsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.SearchGoogleAdsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsRequest} message SearchGoogleAdsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchGoogleAdsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.query != null && message.hasOwnProperty("query"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.query);
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.pageSize);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 5, wireType 0 =*/40).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified SearchGoogleAdsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.SearchGoogleAdsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsRequest} message SearchGoogleAdsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchGoogleAdsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SearchGoogleAdsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.SearchGoogleAdsRequest} SearchGoogleAdsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchGoogleAdsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.SearchGoogleAdsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    message.query = reader.string();
                                    break;
                                case 3:
                                    message.pageToken = reader.string();
                                    break;
                                case 4:
                                    message.pageSize = reader.int32();
                                    break;
                                case 5:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SearchGoogleAdsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.SearchGoogleAdsRequest} SearchGoogleAdsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchGoogleAdsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SearchGoogleAdsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SearchGoogleAdsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.query != null && message.hasOwnProperty("query"))
                                if (!$util.isString(message.query))
                                    return "query: string expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a SearchGoogleAdsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.SearchGoogleAdsRequest} SearchGoogleAdsRequest
                         */
                        SearchGoogleAdsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.SearchGoogleAdsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.SearchGoogleAdsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.query != null)
                                message.query = String(object.query);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a SearchGoogleAdsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.SearchGoogleAdsRequest} message SearchGoogleAdsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SearchGoogleAdsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.customerId = "";
                                object.query = "";
                                object.pageToken = "";
                                object.pageSize = 0;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.query != null && message.hasOwnProperty("query"))
                                object.query = message.query;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this SearchGoogleAdsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SearchGoogleAdsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return SearchGoogleAdsRequest;
                    })();

                    services.SearchGoogleAdsResponse = (function() {

                        /**
                         * Properties of a SearchGoogleAdsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ISearchGoogleAdsResponse
                         * @property {Array.<google.ads.googleads.v1.services.IGoogleAdsRow>|null} [results] SearchGoogleAdsResponse results
                         * @property {string|null} [nextPageToken] SearchGoogleAdsResponse nextPageToken
                         * @property {number|Long|null} [totalResultsCount] SearchGoogleAdsResponse totalResultsCount
                         * @property {google.protobuf.IFieldMask|null} [fieldMask] SearchGoogleAdsResponse fieldMask
                         */

                        /**
                         * Constructs a new SearchGoogleAdsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a SearchGoogleAdsResponse.
                         * @implements ISearchGoogleAdsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsResponse=} [properties] Properties to set
                         */
                        function SearchGoogleAdsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * SearchGoogleAdsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IGoogleAdsRow>} results
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsResponse
                         * @instance
                         */
                        SearchGoogleAdsResponse.prototype.results = $util.emptyArray;

                        /**
                         * SearchGoogleAdsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsResponse
                         * @instance
                         */
                        SearchGoogleAdsResponse.prototype.nextPageToken = "";

                        /**
                         * SearchGoogleAdsResponse totalResultsCount.
                         * @member {number|Long} totalResultsCount
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsResponse
                         * @instance
                         */
                        SearchGoogleAdsResponse.prototype.totalResultsCount = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

                        /**
                         * SearchGoogleAdsResponse fieldMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} fieldMask
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsResponse
                         * @instance
                         */
                        SearchGoogleAdsResponse.prototype.fieldMask = null;

                        /**
                         * Creates a new SearchGoogleAdsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.SearchGoogleAdsResponse} SearchGoogleAdsResponse instance
                         */
                        SearchGoogleAdsResponse.create = function create(properties) {
                            return new SearchGoogleAdsResponse(properties);
                        };

                        /**
                         * Encodes the specified SearchGoogleAdsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.SearchGoogleAdsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsResponse} message SearchGoogleAdsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchGoogleAdsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.GoogleAdsRow.encode(message.results[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            if (message.totalResultsCount != null && message.hasOwnProperty("totalResultsCount"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int64(message.totalResultsCount);
                            if (message.fieldMask != null && message.hasOwnProperty("fieldMask"))
                                $root.google.protobuf.FieldMask.encode(message.fieldMask, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified SearchGoogleAdsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.SearchGoogleAdsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ISearchGoogleAdsResponse} message SearchGoogleAdsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchGoogleAdsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SearchGoogleAdsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.SearchGoogleAdsResponse} SearchGoogleAdsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchGoogleAdsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.SearchGoogleAdsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.GoogleAdsRow.decode(reader, reader.uint32()));
                                    break;
                                case 2:
                                    message.nextPageToken = reader.string();
                                    break;
                                case 3:
                                    message.totalResultsCount = reader.int64();
                                    break;
                                case 5:
                                    message.fieldMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SearchGoogleAdsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.SearchGoogleAdsResponse} SearchGoogleAdsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchGoogleAdsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SearchGoogleAdsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SearchGoogleAdsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.GoogleAdsRow.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            if (message.totalResultsCount != null && message.hasOwnProperty("totalResultsCount"))
                                if (!$util.isInteger(message.totalResultsCount) && !(message.totalResultsCount && $util.isInteger(message.totalResultsCount.low) && $util.isInteger(message.totalResultsCount.high)))
                                    return "totalResultsCount: integer|Long expected";
                            if (message.fieldMask != null && message.hasOwnProperty("fieldMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.fieldMask);
                                if (error)
                                    return "fieldMask." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a SearchGoogleAdsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.SearchGoogleAdsResponse} SearchGoogleAdsResponse
                         */
                        SearchGoogleAdsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.SearchGoogleAdsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.SearchGoogleAdsResponse();
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.SearchGoogleAdsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.SearchGoogleAdsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.GoogleAdsRow.fromObject(object.results[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.totalResultsCount != null)
                                if ($util.Long)
                                    (message.totalResultsCount = $util.Long.fromValue(object.totalResultsCount)).unsigned = false;
                                else if (typeof object.totalResultsCount === "string")
                                    message.totalResultsCount = parseInt(object.totalResultsCount, 10);
                                else if (typeof object.totalResultsCount === "number")
                                    message.totalResultsCount = object.totalResultsCount;
                                else if (typeof object.totalResultsCount === "object")
                                    message.totalResultsCount = new $util.LongBits(object.totalResultsCount.low >>> 0, object.totalResultsCount.high >>> 0).toNumber();
                            if (object.fieldMask != null) {
                                if (typeof object.fieldMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.SearchGoogleAdsResponse.fieldMask: object expected");
                                message.fieldMask = $root.google.protobuf.FieldMask.fromObject(object.fieldMask);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a SearchGoogleAdsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.SearchGoogleAdsResponse} message SearchGoogleAdsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SearchGoogleAdsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults) {
                                object.nextPageToken = "";
                                if ($util.Long) {
                                    var long = new $util.Long(0, 0, false);
                                    object.totalResultsCount = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                                } else
                                    object.totalResultsCount = options.longs === String ? "0" : 0;
                                object.fieldMask = null;
                            }
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.GoogleAdsRow.toObject(message.results[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            if (message.totalResultsCount != null && message.hasOwnProperty("totalResultsCount"))
                                if (typeof message.totalResultsCount === "number")
                                    object.totalResultsCount = options.longs === String ? String(message.totalResultsCount) : message.totalResultsCount;
                                else
                                    object.totalResultsCount = options.longs === String ? $util.Long.prototype.toString.call(message.totalResultsCount) : options.longs === Number ? new $util.LongBits(message.totalResultsCount.low >>> 0, message.totalResultsCount.high >>> 0).toNumber() : message.totalResultsCount;
                            if (message.fieldMask != null && message.hasOwnProperty("fieldMask"))
                                object.fieldMask = $root.google.protobuf.FieldMask.toObject(message.fieldMask, options);
                            return object;
                        };

                        /**
                         * Converts this SearchGoogleAdsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.SearchGoogleAdsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SearchGoogleAdsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return SearchGoogleAdsResponse;
                    })();

                    services.GoogleAdsRow = (function() {

                        /**
                         * Properties of a GoogleAdsRow.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGoogleAdsRow
                         * @property {google.ads.googleads.v1.resources.IAccountBudget|null} [accountBudget] GoogleAdsRow accountBudget
                         * @property {google.ads.googleads.v1.resources.IAccountBudgetProposal|null} [accountBudgetProposal] GoogleAdsRow accountBudgetProposal
                         * @property {google.ads.googleads.v1.resources.IAdGroup|null} [adGroup] GoogleAdsRow adGroup
                         * @property {google.ads.googleads.v1.resources.IAdGroupAd|null} [adGroupAd] GoogleAdsRow adGroupAd
                         * @property {google.ads.googleads.v1.resources.IAdGroupAdLabel|null} [adGroupAdLabel] GoogleAdsRow adGroupAdLabel
                         * @property {google.ads.googleads.v1.resources.IAdGroupAudienceView|null} [adGroupAudienceView] GoogleAdsRow adGroupAudienceView
                         * @property {google.ads.googleads.v1.resources.IAdGroupBidModifier|null} [adGroupBidModifier] GoogleAdsRow adGroupBidModifier
                         * @property {google.ads.googleads.v1.resources.IAdGroupCriterion|null} [adGroupCriterion] GoogleAdsRow adGroupCriterion
                         * @property {google.ads.googleads.v1.resources.IAdGroupCriterionLabel|null} [adGroupCriterionLabel] GoogleAdsRow adGroupCriterionLabel
                         * @property {google.ads.googleads.v1.resources.IAdGroupCriterionSimulation|null} [adGroupCriterionSimulation] GoogleAdsRow adGroupCriterionSimulation
                         * @property {google.ads.googleads.v1.resources.IAdGroupExtensionSetting|null} [adGroupExtensionSetting] GoogleAdsRow adGroupExtensionSetting
                         * @property {google.ads.googleads.v1.resources.IAdGroupFeed|null} [adGroupFeed] GoogleAdsRow adGroupFeed
                         * @property {google.ads.googleads.v1.resources.IAdGroupLabel|null} [adGroupLabel] GoogleAdsRow adGroupLabel
                         * @property {google.ads.googleads.v1.resources.IAdGroupSimulation|null} [adGroupSimulation] GoogleAdsRow adGroupSimulation
                         * @property {google.ads.googleads.v1.resources.IAdParameter|null} [adParameter] GoogleAdsRow adParameter
                         * @property {google.ads.googleads.v1.resources.IAgeRangeView|null} [ageRangeView] GoogleAdsRow ageRangeView
                         * @property {google.ads.googleads.v1.resources.IAdScheduleView|null} [adScheduleView] GoogleAdsRow adScheduleView
                         * @property {google.ads.googleads.v1.resources.IDomainCategory|null} [domainCategory] GoogleAdsRow domainCategory
                         * @property {google.ads.googleads.v1.resources.IAsset|null} [asset] GoogleAdsRow asset
                         * @property {google.ads.googleads.v1.resources.IBiddingStrategy|null} [biddingStrategy] GoogleAdsRow biddingStrategy
                         * @property {google.ads.googleads.v1.resources.IBillingSetup|null} [billingSetup] GoogleAdsRow billingSetup
                         * @property {google.ads.googleads.v1.resources.ICampaignBudget|null} [campaignBudget] GoogleAdsRow campaignBudget
                         * @property {google.ads.googleads.v1.resources.ICampaign|null} [campaign] GoogleAdsRow campaign
                         * @property {google.ads.googleads.v1.resources.ICampaignAudienceView|null} [campaignAudienceView] GoogleAdsRow campaignAudienceView
                         * @property {google.ads.googleads.v1.resources.ICampaignBidModifier|null} [campaignBidModifier] GoogleAdsRow campaignBidModifier
                         * @property {google.ads.googleads.v1.resources.ICampaignCriterion|null} [campaignCriterion] GoogleAdsRow campaignCriterion
                         * @property {google.ads.googleads.v1.resources.ICampaignCriterionSimulation|null} [campaignCriterionSimulation] GoogleAdsRow campaignCriterionSimulation
                         * @property {google.ads.googleads.v1.resources.ICampaignExtensionSetting|null} [campaignExtensionSetting] GoogleAdsRow campaignExtensionSetting
                         * @property {google.ads.googleads.v1.resources.ICampaignFeed|null} [campaignFeed] GoogleAdsRow campaignFeed
                         * @property {google.ads.googleads.v1.resources.ICampaignLabel|null} [campaignLabel] GoogleAdsRow campaignLabel
                         * @property {google.ads.googleads.v1.resources.ICampaignSharedSet|null} [campaignSharedSet] GoogleAdsRow campaignSharedSet
                         * @property {google.ads.googleads.v1.resources.ICarrierConstant|null} [carrierConstant] GoogleAdsRow carrierConstant
                         * @property {google.ads.googleads.v1.resources.IChangeStatus|null} [changeStatus] GoogleAdsRow changeStatus
                         * @property {google.ads.googleads.v1.resources.IConversionAction|null} [conversionAction] GoogleAdsRow conversionAction
                         * @property {google.ads.googleads.v1.resources.IClickView|null} [clickView] GoogleAdsRow clickView
                         * @property {google.ads.googleads.v1.resources.ICustomInterest|null} [customInterest] GoogleAdsRow customInterest
                         * @property {google.ads.googleads.v1.resources.ICustomer|null} [customer] GoogleAdsRow customer
                         * @property {google.ads.googleads.v1.resources.ICustomerManagerLink|null} [customerManagerLink] GoogleAdsRow customerManagerLink
                         * @property {google.ads.googleads.v1.resources.ICustomerClientLink|null} [customerClientLink] GoogleAdsRow customerClientLink
                         * @property {google.ads.googleads.v1.resources.ICustomerClient|null} [customerClient] GoogleAdsRow customerClient
                         * @property {google.ads.googleads.v1.resources.ICustomerExtensionSetting|null} [customerExtensionSetting] GoogleAdsRow customerExtensionSetting
                         * @property {google.ads.googleads.v1.resources.ICustomerFeed|null} [customerFeed] GoogleAdsRow customerFeed
                         * @property {google.ads.googleads.v1.resources.ICustomerLabel|null} [customerLabel] GoogleAdsRow customerLabel
                         * @property {google.ads.googleads.v1.resources.ICustomerNegativeCriterion|null} [customerNegativeCriterion] GoogleAdsRow customerNegativeCriterion
                         * @property {google.ads.googleads.v1.resources.IDetailPlacementView|null} [detailPlacementView] GoogleAdsRow detailPlacementView
                         * @property {google.ads.googleads.v1.resources.IDisplayKeywordView|null} [displayKeywordView] GoogleAdsRow displayKeywordView
                         * @property {google.ads.googleads.v1.resources.IDynamicSearchAdsSearchTermView|null} [dynamicSearchAdsSearchTermView] GoogleAdsRow dynamicSearchAdsSearchTermView
                         * @property {google.ads.googleads.v1.resources.IExpandedLandingPageView|null} [expandedLandingPageView] GoogleAdsRow expandedLandingPageView
                         * @property {google.ads.googleads.v1.resources.IExtensionFeedItem|null} [extensionFeedItem] GoogleAdsRow extensionFeedItem
                         * @property {google.ads.googleads.v1.resources.IFeed|null} [feed] GoogleAdsRow feed
                         * @property {google.ads.googleads.v1.resources.IFeedItem|null} [feedItem] GoogleAdsRow feedItem
                         * @property {google.ads.googleads.v1.resources.IFeedItemTarget|null} [feedItemTarget] GoogleAdsRow feedItemTarget
                         * @property {google.ads.googleads.v1.resources.IFeedMapping|null} [feedMapping] GoogleAdsRow feedMapping
                         * @property {google.ads.googleads.v1.resources.IFeedPlaceholderView|null} [feedPlaceholderView] GoogleAdsRow feedPlaceholderView
                         * @property {google.ads.googleads.v1.resources.IGenderView|null} [genderView] GoogleAdsRow genderView
                         * @property {google.ads.googleads.v1.resources.IGeoTargetConstant|null} [geoTargetConstant] GoogleAdsRow geoTargetConstant
                         * @property {google.ads.googleads.v1.resources.IGeographicView|null} [geographicView] GoogleAdsRow geographicView
                         * @property {google.ads.googleads.v1.resources.IGroupPlacementView|null} [groupPlacementView] GoogleAdsRow groupPlacementView
                         * @property {google.ads.googleads.v1.resources.IHotelGroupView|null} [hotelGroupView] GoogleAdsRow hotelGroupView
                         * @property {google.ads.googleads.v1.resources.IHotelPerformanceView|null} [hotelPerformanceView] GoogleAdsRow hotelPerformanceView
                         * @property {google.ads.googleads.v1.resources.IKeywordView|null} [keywordView] GoogleAdsRow keywordView
                         * @property {google.ads.googleads.v1.resources.IKeywordPlan|null} [keywordPlan] GoogleAdsRow keywordPlan
                         * @property {google.ads.googleads.v1.resources.IKeywordPlanCampaign|null} [keywordPlanCampaign] GoogleAdsRow keywordPlanCampaign
                         * @property {google.ads.googleads.v1.resources.IKeywordPlanNegativeKeyword|null} [keywordPlanNegativeKeyword] GoogleAdsRow keywordPlanNegativeKeyword
                         * @property {google.ads.googleads.v1.resources.IKeywordPlanAdGroup|null} [keywordPlanAdGroup] GoogleAdsRow keywordPlanAdGroup
                         * @property {google.ads.googleads.v1.resources.IKeywordPlanKeyword|null} [keywordPlanKeyword] GoogleAdsRow keywordPlanKeyword
                         * @property {google.ads.googleads.v1.resources.ILabel|null} [label] GoogleAdsRow label
                         * @property {google.ads.googleads.v1.resources.ILandingPageView|null} [landingPageView] GoogleAdsRow landingPageView
                         * @property {google.ads.googleads.v1.resources.ILanguageConstant|null} [languageConstant] GoogleAdsRow languageConstant
                         * @property {google.ads.googleads.v1.resources.ILocationView|null} [locationView] GoogleAdsRow locationView
                         * @property {google.ads.googleads.v1.resources.IManagedPlacementView|null} [managedPlacementView] GoogleAdsRow managedPlacementView
                         * @property {google.ads.googleads.v1.resources.IMediaFile|null} [mediaFile] GoogleAdsRow mediaFile
                         * @property {google.ads.googleads.v1.resources.IMobileAppCategoryConstant|null} [mobileAppCategoryConstant] GoogleAdsRow mobileAppCategoryConstant
                         * @property {google.ads.googleads.v1.resources.IMobileDeviceConstant|null} [mobileDeviceConstant] GoogleAdsRow mobileDeviceConstant
                         * @property {google.ads.googleads.v1.resources.IMutateJob|null} [mutateJob] GoogleAdsRow mutateJob
                         * @property {google.ads.googleads.v1.resources.IOperatingSystemVersionConstant|null} [operatingSystemVersionConstant] GoogleAdsRow operatingSystemVersionConstant
                         * @property {google.ads.googleads.v1.resources.IPaidOrganicSearchTermView|null} [paidOrganicSearchTermView] GoogleAdsRow paidOrganicSearchTermView
                         * @property {google.ads.googleads.v1.resources.IParentalStatusView|null} [parentalStatusView] GoogleAdsRow parentalStatusView
                         * @property {google.ads.googleads.v1.resources.IProductBiddingCategoryConstant|null} [productBiddingCategoryConstant] GoogleAdsRow productBiddingCategoryConstant
                         * @property {google.ads.googleads.v1.resources.IProductGroupView|null} [productGroupView] GoogleAdsRow productGroupView
                         * @property {google.ads.googleads.v1.resources.IRecommendation|null} [recommendation] GoogleAdsRow recommendation
                         * @property {google.ads.googleads.v1.resources.ISearchTermView|null} [searchTermView] GoogleAdsRow searchTermView
                         * @property {google.ads.googleads.v1.resources.ISharedCriterion|null} [sharedCriterion] GoogleAdsRow sharedCriterion
                         * @property {google.ads.googleads.v1.resources.ISharedSet|null} [sharedSet] GoogleAdsRow sharedSet
                         * @property {google.ads.googleads.v1.resources.IShoppingPerformanceView|null} [shoppingPerformanceView] GoogleAdsRow shoppingPerformanceView
                         * @property {google.ads.googleads.v1.resources.ITopicView|null} [topicView] GoogleAdsRow topicView
                         * @property {google.ads.googleads.v1.resources.IUserInterest|null} [userInterest] GoogleAdsRow userInterest
                         * @property {google.ads.googleads.v1.resources.IUserList|null} [userList] GoogleAdsRow userList
                         * @property {google.ads.googleads.v1.resources.IRemarketingAction|null} [remarketingAction] GoogleAdsRow remarketingAction
                         * @property {google.ads.googleads.v1.resources.ITopicConstant|null} [topicConstant] GoogleAdsRow topicConstant
                         * @property {google.ads.googleads.v1.resources.IVideo|null} [video] GoogleAdsRow video
                         * @property {google.ads.googleads.v1.common.IMetrics|null} [metrics] GoogleAdsRow metrics
                         * @property {google.ads.googleads.v1.common.ISegments|null} [segments] GoogleAdsRow segments
                         */

                        /**
                         * Constructs a new GoogleAdsRow.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GoogleAdsRow.
                         * @implements IGoogleAdsRow
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGoogleAdsRow=} [properties] Properties to set
                         */
                        function GoogleAdsRow(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GoogleAdsRow accountBudget.
                         * @member {google.ads.googleads.v1.resources.IAccountBudget|null|undefined} accountBudget
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.accountBudget = null;

                        /**
                         * GoogleAdsRow accountBudgetProposal.
                         * @member {google.ads.googleads.v1.resources.IAccountBudgetProposal|null|undefined} accountBudgetProposal
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.accountBudgetProposal = null;

                        /**
                         * GoogleAdsRow adGroup.
                         * @member {google.ads.googleads.v1.resources.IAdGroup|null|undefined} adGroup
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.adGroup = null;

                        /**
                         * GoogleAdsRow adGroupAd.
                         * @member {google.ads.googleads.v1.resources.IAdGroupAd|null|undefined} adGroupAd
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.adGroupAd = null;

                        /**
                         * GoogleAdsRow adGroupAdLabel.
                         * @member {google.ads.googleads.v1.resources.IAdGroupAdLabel|null|undefined} adGroupAdLabel
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.adGroupAdLabel = null;

                        /**
                         * GoogleAdsRow adGroupAudienceView.
                         * @member {google.ads.googleads.v1.resources.IAdGroupAudienceView|null|undefined} adGroupAudienceView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.adGroupAudienceView = null;

                        /**
                         * GoogleAdsRow adGroupBidModifier.
                         * @member {google.ads.googleads.v1.resources.IAdGroupBidModifier|null|undefined} adGroupBidModifier
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.adGroupBidModifier = null;

                        /**
                         * GoogleAdsRow adGroupCriterion.
                         * @member {google.ads.googleads.v1.resources.IAdGroupCriterion|null|undefined} adGroupCriterion
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.adGroupCriterion = null;

                        /**
                         * GoogleAdsRow adGroupCriterionLabel.
                         * @member {google.ads.googleads.v1.resources.IAdGroupCriterionLabel|null|undefined} adGroupCriterionLabel
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.adGroupCriterionLabel = null;

                        /**
                         * GoogleAdsRow adGroupCriterionSimulation.
                         * @member {google.ads.googleads.v1.resources.IAdGroupCriterionSimulation|null|undefined} adGroupCriterionSimulation
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.adGroupCriterionSimulation = null;

                        /**
                         * GoogleAdsRow adGroupExtensionSetting.
                         * @member {google.ads.googleads.v1.resources.IAdGroupExtensionSetting|null|undefined} adGroupExtensionSetting
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.adGroupExtensionSetting = null;

                        /**
                         * GoogleAdsRow adGroupFeed.
                         * @member {google.ads.googleads.v1.resources.IAdGroupFeed|null|undefined} adGroupFeed
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.adGroupFeed = null;

                        /**
                         * GoogleAdsRow adGroupLabel.
                         * @member {google.ads.googleads.v1.resources.IAdGroupLabel|null|undefined} adGroupLabel
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.adGroupLabel = null;

                        /**
                         * GoogleAdsRow adGroupSimulation.
                         * @member {google.ads.googleads.v1.resources.IAdGroupSimulation|null|undefined} adGroupSimulation
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.adGroupSimulation = null;

                        /**
                         * GoogleAdsRow adParameter.
                         * @member {google.ads.googleads.v1.resources.IAdParameter|null|undefined} adParameter
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.adParameter = null;

                        /**
                         * GoogleAdsRow ageRangeView.
                         * @member {google.ads.googleads.v1.resources.IAgeRangeView|null|undefined} ageRangeView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.ageRangeView = null;

                        /**
                         * GoogleAdsRow adScheduleView.
                         * @member {google.ads.googleads.v1.resources.IAdScheduleView|null|undefined} adScheduleView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.adScheduleView = null;

                        /**
                         * GoogleAdsRow domainCategory.
                         * @member {google.ads.googleads.v1.resources.IDomainCategory|null|undefined} domainCategory
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.domainCategory = null;

                        /**
                         * GoogleAdsRow asset.
                         * @member {google.ads.googleads.v1.resources.IAsset|null|undefined} asset
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.asset = null;

                        /**
                         * GoogleAdsRow biddingStrategy.
                         * @member {google.ads.googleads.v1.resources.IBiddingStrategy|null|undefined} biddingStrategy
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.biddingStrategy = null;

                        /**
                         * GoogleAdsRow billingSetup.
                         * @member {google.ads.googleads.v1.resources.IBillingSetup|null|undefined} billingSetup
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.billingSetup = null;

                        /**
                         * GoogleAdsRow campaignBudget.
                         * @member {google.ads.googleads.v1.resources.ICampaignBudget|null|undefined} campaignBudget
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.campaignBudget = null;

                        /**
                         * GoogleAdsRow campaign.
                         * @member {google.ads.googleads.v1.resources.ICampaign|null|undefined} campaign
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.campaign = null;

                        /**
                         * GoogleAdsRow campaignAudienceView.
                         * @member {google.ads.googleads.v1.resources.ICampaignAudienceView|null|undefined} campaignAudienceView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.campaignAudienceView = null;

                        /**
                         * GoogleAdsRow campaignBidModifier.
                         * @member {google.ads.googleads.v1.resources.ICampaignBidModifier|null|undefined} campaignBidModifier
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.campaignBidModifier = null;

                        /**
                         * GoogleAdsRow campaignCriterion.
                         * @member {google.ads.googleads.v1.resources.ICampaignCriterion|null|undefined} campaignCriterion
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.campaignCriterion = null;

                        /**
                         * GoogleAdsRow campaignCriterionSimulation.
                         * @member {google.ads.googleads.v1.resources.ICampaignCriterionSimulation|null|undefined} campaignCriterionSimulation
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.campaignCriterionSimulation = null;

                        /**
                         * GoogleAdsRow campaignExtensionSetting.
                         * @member {google.ads.googleads.v1.resources.ICampaignExtensionSetting|null|undefined} campaignExtensionSetting
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.campaignExtensionSetting = null;

                        /**
                         * GoogleAdsRow campaignFeed.
                         * @member {google.ads.googleads.v1.resources.ICampaignFeed|null|undefined} campaignFeed
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.campaignFeed = null;

                        /**
                         * GoogleAdsRow campaignLabel.
                         * @member {google.ads.googleads.v1.resources.ICampaignLabel|null|undefined} campaignLabel
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.campaignLabel = null;

                        /**
                         * GoogleAdsRow campaignSharedSet.
                         * @member {google.ads.googleads.v1.resources.ICampaignSharedSet|null|undefined} campaignSharedSet
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.campaignSharedSet = null;

                        /**
                         * GoogleAdsRow carrierConstant.
                         * @member {google.ads.googleads.v1.resources.ICarrierConstant|null|undefined} carrierConstant
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.carrierConstant = null;

                        /**
                         * GoogleAdsRow changeStatus.
                         * @member {google.ads.googleads.v1.resources.IChangeStatus|null|undefined} changeStatus
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.changeStatus = null;

                        /**
                         * GoogleAdsRow conversionAction.
                         * @member {google.ads.googleads.v1.resources.IConversionAction|null|undefined} conversionAction
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.conversionAction = null;

                        /**
                         * GoogleAdsRow clickView.
                         * @member {google.ads.googleads.v1.resources.IClickView|null|undefined} clickView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.clickView = null;

                        /**
                         * GoogleAdsRow customInterest.
                         * @member {google.ads.googleads.v1.resources.ICustomInterest|null|undefined} customInterest
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.customInterest = null;

                        /**
                         * GoogleAdsRow customer.
                         * @member {google.ads.googleads.v1.resources.ICustomer|null|undefined} customer
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.customer = null;

                        /**
                         * GoogleAdsRow customerManagerLink.
                         * @member {google.ads.googleads.v1.resources.ICustomerManagerLink|null|undefined} customerManagerLink
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.customerManagerLink = null;

                        /**
                         * GoogleAdsRow customerClientLink.
                         * @member {google.ads.googleads.v1.resources.ICustomerClientLink|null|undefined} customerClientLink
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.customerClientLink = null;

                        /**
                         * GoogleAdsRow customerClient.
                         * @member {google.ads.googleads.v1.resources.ICustomerClient|null|undefined} customerClient
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.customerClient = null;

                        /**
                         * GoogleAdsRow customerExtensionSetting.
                         * @member {google.ads.googleads.v1.resources.ICustomerExtensionSetting|null|undefined} customerExtensionSetting
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.customerExtensionSetting = null;

                        /**
                         * GoogleAdsRow customerFeed.
                         * @member {google.ads.googleads.v1.resources.ICustomerFeed|null|undefined} customerFeed
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.customerFeed = null;

                        /**
                         * GoogleAdsRow customerLabel.
                         * @member {google.ads.googleads.v1.resources.ICustomerLabel|null|undefined} customerLabel
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.customerLabel = null;

                        /**
                         * GoogleAdsRow customerNegativeCriterion.
                         * @member {google.ads.googleads.v1.resources.ICustomerNegativeCriterion|null|undefined} customerNegativeCriterion
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.customerNegativeCriterion = null;

                        /**
                         * GoogleAdsRow detailPlacementView.
                         * @member {google.ads.googleads.v1.resources.IDetailPlacementView|null|undefined} detailPlacementView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.detailPlacementView = null;

                        /**
                         * GoogleAdsRow displayKeywordView.
                         * @member {google.ads.googleads.v1.resources.IDisplayKeywordView|null|undefined} displayKeywordView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.displayKeywordView = null;

                        /**
                         * GoogleAdsRow dynamicSearchAdsSearchTermView.
                         * @member {google.ads.googleads.v1.resources.IDynamicSearchAdsSearchTermView|null|undefined} dynamicSearchAdsSearchTermView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.dynamicSearchAdsSearchTermView = null;

                        /**
                         * GoogleAdsRow expandedLandingPageView.
                         * @member {google.ads.googleads.v1.resources.IExpandedLandingPageView|null|undefined} expandedLandingPageView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.expandedLandingPageView = null;

                        /**
                         * GoogleAdsRow extensionFeedItem.
                         * @member {google.ads.googleads.v1.resources.IExtensionFeedItem|null|undefined} extensionFeedItem
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.extensionFeedItem = null;

                        /**
                         * GoogleAdsRow feed.
                         * @member {google.ads.googleads.v1.resources.IFeed|null|undefined} feed
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.feed = null;

                        /**
                         * GoogleAdsRow feedItem.
                         * @member {google.ads.googleads.v1.resources.IFeedItem|null|undefined} feedItem
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.feedItem = null;

                        /**
                         * GoogleAdsRow feedItemTarget.
                         * @member {google.ads.googleads.v1.resources.IFeedItemTarget|null|undefined} feedItemTarget
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.feedItemTarget = null;

                        /**
                         * GoogleAdsRow feedMapping.
                         * @member {google.ads.googleads.v1.resources.IFeedMapping|null|undefined} feedMapping
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.feedMapping = null;

                        /**
                         * GoogleAdsRow feedPlaceholderView.
                         * @member {google.ads.googleads.v1.resources.IFeedPlaceholderView|null|undefined} feedPlaceholderView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.feedPlaceholderView = null;

                        /**
                         * GoogleAdsRow genderView.
                         * @member {google.ads.googleads.v1.resources.IGenderView|null|undefined} genderView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.genderView = null;

                        /**
                         * GoogleAdsRow geoTargetConstant.
                         * @member {google.ads.googleads.v1.resources.IGeoTargetConstant|null|undefined} geoTargetConstant
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.geoTargetConstant = null;

                        /**
                         * GoogleAdsRow geographicView.
                         * @member {google.ads.googleads.v1.resources.IGeographicView|null|undefined} geographicView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.geographicView = null;

                        /**
                         * GoogleAdsRow groupPlacementView.
                         * @member {google.ads.googleads.v1.resources.IGroupPlacementView|null|undefined} groupPlacementView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.groupPlacementView = null;

                        /**
                         * GoogleAdsRow hotelGroupView.
                         * @member {google.ads.googleads.v1.resources.IHotelGroupView|null|undefined} hotelGroupView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.hotelGroupView = null;

                        /**
                         * GoogleAdsRow hotelPerformanceView.
                         * @member {google.ads.googleads.v1.resources.IHotelPerformanceView|null|undefined} hotelPerformanceView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.hotelPerformanceView = null;

                        /**
                         * GoogleAdsRow keywordView.
                         * @member {google.ads.googleads.v1.resources.IKeywordView|null|undefined} keywordView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.keywordView = null;

                        /**
                         * GoogleAdsRow keywordPlan.
                         * @member {google.ads.googleads.v1.resources.IKeywordPlan|null|undefined} keywordPlan
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.keywordPlan = null;

                        /**
                         * GoogleAdsRow keywordPlanCampaign.
                         * @member {google.ads.googleads.v1.resources.IKeywordPlanCampaign|null|undefined} keywordPlanCampaign
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.keywordPlanCampaign = null;

                        /**
                         * GoogleAdsRow keywordPlanNegativeKeyword.
                         * @member {google.ads.googleads.v1.resources.IKeywordPlanNegativeKeyword|null|undefined} keywordPlanNegativeKeyword
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.keywordPlanNegativeKeyword = null;

                        /**
                         * GoogleAdsRow keywordPlanAdGroup.
                         * @member {google.ads.googleads.v1.resources.IKeywordPlanAdGroup|null|undefined} keywordPlanAdGroup
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.keywordPlanAdGroup = null;

                        /**
                         * GoogleAdsRow keywordPlanKeyword.
                         * @member {google.ads.googleads.v1.resources.IKeywordPlanKeyword|null|undefined} keywordPlanKeyword
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.keywordPlanKeyword = null;

                        /**
                         * GoogleAdsRow label.
                         * @member {google.ads.googleads.v1.resources.ILabel|null|undefined} label
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.label = null;

                        /**
                         * GoogleAdsRow landingPageView.
                         * @member {google.ads.googleads.v1.resources.ILandingPageView|null|undefined} landingPageView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.landingPageView = null;

                        /**
                         * GoogleAdsRow languageConstant.
                         * @member {google.ads.googleads.v1.resources.ILanguageConstant|null|undefined} languageConstant
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.languageConstant = null;

                        /**
                         * GoogleAdsRow locationView.
                         * @member {google.ads.googleads.v1.resources.ILocationView|null|undefined} locationView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.locationView = null;

                        /**
                         * GoogleAdsRow managedPlacementView.
                         * @member {google.ads.googleads.v1.resources.IManagedPlacementView|null|undefined} managedPlacementView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.managedPlacementView = null;

                        /**
                         * GoogleAdsRow mediaFile.
                         * @member {google.ads.googleads.v1.resources.IMediaFile|null|undefined} mediaFile
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.mediaFile = null;

                        /**
                         * GoogleAdsRow mobileAppCategoryConstant.
                         * @member {google.ads.googleads.v1.resources.IMobileAppCategoryConstant|null|undefined} mobileAppCategoryConstant
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.mobileAppCategoryConstant = null;

                        /**
                         * GoogleAdsRow mobileDeviceConstant.
                         * @member {google.ads.googleads.v1.resources.IMobileDeviceConstant|null|undefined} mobileDeviceConstant
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.mobileDeviceConstant = null;

                        /**
                         * GoogleAdsRow mutateJob.
                         * @member {google.ads.googleads.v1.resources.IMutateJob|null|undefined} mutateJob
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.mutateJob = null;

                        /**
                         * GoogleAdsRow operatingSystemVersionConstant.
                         * @member {google.ads.googleads.v1.resources.IOperatingSystemVersionConstant|null|undefined} operatingSystemVersionConstant
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.operatingSystemVersionConstant = null;

                        /**
                         * GoogleAdsRow paidOrganicSearchTermView.
                         * @member {google.ads.googleads.v1.resources.IPaidOrganicSearchTermView|null|undefined} paidOrganicSearchTermView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.paidOrganicSearchTermView = null;

                        /**
                         * GoogleAdsRow parentalStatusView.
                         * @member {google.ads.googleads.v1.resources.IParentalStatusView|null|undefined} parentalStatusView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.parentalStatusView = null;

                        /**
                         * GoogleAdsRow productBiddingCategoryConstant.
                         * @member {google.ads.googleads.v1.resources.IProductBiddingCategoryConstant|null|undefined} productBiddingCategoryConstant
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.productBiddingCategoryConstant = null;

                        /**
                         * GoogleAdsRow productGroupView.
                         * @member {google.ads.googleads.v1.resources.IProductGroupView|null|undefined} productGroupView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.productGroupView = null;

                        /**
                         * GoogleAdsRow recommendation.
                         * @member {google.ads.googleads.v1.resources.IRecommendation|null|undefined} recommendation
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.recommendation = null;

                        /**
                         * GoogleAdsRow searchTermView.
                         * @member {google.ads.googleads.v1.resources.ISearchTermView|null|undefined} searchTermView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.searchTermView = null;

                        /**
                         * GoogleAdsRow sharedCriterion.
                         * @member {google.ads.googleads.v1.resources.ISharedCriterion|null|undefined} sharedCriterion
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.sharedCriterion = null;

                        /**
                         * GoogleAdsRow sharedSet.
                         * @member {google.ads.googleads.v1.resources.ISharedSet|null|undefined} sharedSet
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.sharedSet = null;

                        /**
                         * GoogleAdsRow shoppingPerformanceView.
                         * @member {google.ads.googleads.v1.resources.IShoppingPerformanceView|null|undefined} shoppingPerformanceView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.shoppingPerformanceView = null;

                        /**
                         * GoogleAdsRow topicView.
                         * @member {google.ads.googleads.v1.resources.ITopicView|null|undefined} topicView
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.topicView = null;

                        /**
                         * GoogleAdsRow userInterest.
                         * @member {google.ads.googleads.v1.resources.IUserInterest|null|undefined} userInterest
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.userInterest = null;

                        /**
                         * GoogleAdsRow userList.
                         * @member {google.ads.googleads.v1.resources.IUserList|null|undefined} userList
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.userList = null;

                        /**
                         * GoogleAdsRow remarketingAction.
                         * @member {google.ads.googleads.v1.resources.IRemarketingAction|null|undefined} remarketingAction
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.remarketingAction = null;

                        /**
                         * GoogleAdsRow topicConstant.
                         * @member {google.ads.googleads.v1.resources.ITopicConstant|null|undefined} topicConstant
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.topicConstant = null;

                        /**
                         * GoogleAdsRow video.
                         * @member {google.ads.googleads.v1.resources.IVideo|null|undefined} video
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.video = null;

                        /**
                         * GoogleAdsRow metrics.
                         * @member {google.ads.googleads.v1.common.IMetrics|null|undefined} metrics
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.metrics = null;

                        /**
                         * GoogleAdsRow segments.
                         * @member {google.ads.googleads.v1.common.ISegments|null|undefined} segments
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         */
                        GoogleAdsRow.prototype.segments = null;

                        /**
                         * Creates a new GoogleAdsRow instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @static
                         * @param {google.ads.googleads.v1.services.IGoogleAdsRow=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GoogleAdsRow} GoogleAdsRow instance
                         */
                        GoogleAdsRow.create = function create(properties) {
                            return new GoogleAdsRow(properties);
                        };

                        /**
                         * Encodes the specified GoogleAdsRow message. Does not implicitly {@link google.ads.googleads.v1.services.GoogleAdsRow.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @static
                         * @param {google.ads.googleads.v1.services.IGoogleAdsRow} message GoogleAdsRow message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GoogleAdsRow.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customer != null && message.hasOwnProperty("customer"))
                                $root.google.ads.googleads.v1.resources.Customer.encode(message.customer, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                $root.google.ads.googleads.v1.resources.Campaign.encode(message.campaign, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                $root.google.ads.googleads.v1.resources.AdGroup.encode(message.adGroup, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.metrics != null && message.hasOwnProperty("metrics"))
                                $root.google.ads.googleads.v1.common.Metrics.encode(message.metrics, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.adGroupAd != null && message.hasOwnProperty("adGroupAd"))
                                $root.google.ads.googleads.v1.resources.AdGroupAd.encode(message.adGroupAd, writer.uint32(/* id 16, wireType 2 =*/130).fork()).ldelim();
                            if (message.adGroupCriterion != null && message.hasOwnProperty("adGroupCriterion"))
                                $root.google.ads.googleads.v1.resources.AdGroupCriterion.encode(message.adGroupCriterion, writer.uint32(/* id 17, wireType 2 =*/138).fork()).ldelim();
                            if (message.biddingStrategy != null && message.hasOwnProperty("biddingStrategy"))
                                $root.google.ads.googleads.v1.resources.BiddingStrategy.encode(message.biddingStrategy, writer.uint32(/* id 18, wireType 2 =*/146).fork()).ldelim();
                            if (message.campaignBudget != null && message.hasOwnProperty("campaignBudget"))
                                $root.google.ads.googleads.v1.resources.CampaignBudget.encode(message.campaignBudget, writer.uint32(/* id 19, wireType 2 =*/154).fork()).ldelim();
                            if (message.campaignCriterion != null && message.hasOwnProperty("campaignCriterion"))
                                $root.google.ads.googleads.v1.resources.CampaignCriterion.encode(message.campaignCriterion, writer.uint32(/* id 20, wireType 2 =*/162).fork()).ldelim();
                            if (message.keywordView != null && message.hasOwnProperty("keywordView"))
                                $root.google.ads.googleads.v1.resources.KeywordView.encode(message.keywordView, writer.uint32(/* id 21, wireType 2 =*/170).fork()).ldelim();
                            if (message.recommendation != null && message.hasOwnProperty("recommendation"))
                                $root.google.ads.googleads.v1.resources.Recommendation.encode(message.recommendation, writer.uint32(/* id 22, wireType 2 =*/178).fork()).ldelim();
                            if (message.geoTargetConstant != null && message.hasOwnProperty("geoTargetConstant"))
                                $root.google.ads.googleads.v1.resources.GeoTargetConstant.encode(message.geoTargetConstant, writer.uint32(/* id 23, wireType 2 =*/186).fork()).ldelim();
                            if (message.adGroupBidModifier != null && message.hasOwnProperty("adGroupBidModifier"))
                                $root.google.ads.googleads.v1.resources.AdGroupBidModifier.encode(message.adGroupBidModifier, writer.uint32(/* id 24, wireType 2 =*/194).fork()).ldelim();
                            if (message.campaignBidModifier != null && message.hasOwnProperty("campaignBidModifier"))
                                $root.google.ads.googleads.v1.resources.CampaignBidModifier.encode(message.campaignBidModifier, writer.uint32(/* id 26, wireType 2 =*/210).fork()).ldelim();
                            if (message.sharedSet != null && message.hasOwnProperty("sharedSet"))
                                $root.google.ads.googleads.v1.resources.SharedSet.encode(message.sharedSet, writer.uint32(/* id 27, wireType 2 =*/218).fork()).ldelim();
                            if (message.sharedCriterion != null && message.hasOwnProperty("sharedCriterion"))
                                $root.google.ads.googleads.v1.resources.SharedCriterion.encode(message.sharedCriterion, writer.uint32(/* id 29, wireType 2 =*/234).fork()).ldelim();
                            if (message.campaignSharedSet != null && message.hasOwnProperty("campaignSharedSet"))
                                $root.google.ads.googleads.v1.resources.CampaignSharedSet.encode(message.campaignSharedSet, writer.uint32(/* id 30, wireType 2 =*/242).fork()).ldelim();
                            if (message.topicConstant != null && message.hasOwnProperty("topicConstant"))
                                $root.google.ads.googleads.v1.resources.TopicConstant.encode(message.topicConstant, writer.uint32(/* id 31, wireType 2 =*/250).fork()).ldelim();
                            if (message.keywordPlan != null && message.hasOwnProperty("keywordPlan"))
                                $root.google.ads.googleads.v1.resources.KeywordPlan.encode(message.keywordPlan, writer.uint32(/* id 32, wireType 2 =*/258).fork()).ldelim();
                            if (message.keywordPlanCampaign != null && message.hasOwnProperty("keywordPlanCampaign"))
                                $root.google.ads.googleads.v1.resources.KeywordPlanCampaign.encode(message.keywordPlanCampaign, writer.uint32(/* id 33, wireType 2 =*/266).fork()).ldelim();
                            if (message.keywordPlanNegativeKeyword != null && message.hasOwnProperty("keywordPlanNegativeKeyword"))
                                $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.encode(message.keywordPlanNegativeKeyword, writer.uint32(/* id 34, wireType 2 =*/274).fork()).ldelim();
                            if (message.keywordPlanAdGroup != null && message.hasOwnProperty("keywordPlanAdGroup"))
                                $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup.encode(message.keywordPlanAdGroup, writer.uint32(/* id 35, wireType 2 =*/282).fork()).ldelim();
                            if (message.keywordPlanKeyword != null && message.hasOwnProperty("keywordPlanKeyword"))
                                $root.google.ads.googleads.v1.resources.KeywordPlanKeyword.encode(message.keywordPlanKeyword, writer.uint32(/* id 36, wireType 2 =*/290).fork()).ldelim();
                            if (message.changeStatus != null && message.hasOwnProperty("changeStatus"))
                                $root.google.ads.googleads.v1.resources.ChangeStatus.encode(message.changeStatus, writer.uint32(/* id 37, wireType 2 =*/298).fork()).ldelim();
                            if (message.userList != null && message.hasOwnProperty("userList"))
                                $root.google.ads.googleads.v1.resources.UserList.encode(message.userList, writer.uint32(/* id 38, wireType 2 =*/306).fork()).ldelim();
                            if (message.video != null && message.hasOwnProperty("video"))
                                $root.google.ads.googleads.v1.resources.Video.encode(message.video, writer.uint32(/* id 39, wireType 2 =*/314).fork()).ldelim();
                            if (message.genderView != null && message.hasOwnProperty("genderView"))
                                $root.google.ads.googleads.v1.resources.GenderView.encode(message.genderView, writer.uint32(/* id 40, wireType 2 =*/322).fork()).ldelim();
                            if (message.billingSetup != null && message.hasOwnProperty("billingSetup"))
                                $root.google.ads.googleads.v1.resources.BillingSetup.encode(message.billingSetup, writer.uint32(/* id 41, wireType 2 =*/330).fork()).ldelim();
                            if (message.accountBudget != null && message.hasOwnProperty("accountBudget"))
                                $root.google.ads.googleads.v1.resources.AccountBudget.encode(message.accountBudget, writer.uint32(/* id 42, wireType 2 =*/338).fork()).ldelim();
                            if (message.accountBudgetProposal != null && message.hasOwnProperty("accountBudgetProposal"))
                                $root.google.ads.googleads.v1.resources.AccountBudgetProposal.encode(message.accountBudgetProposal, writer.uint32(/* id 43, wireType 2 =*/346).fork()).ldelim();
                            if (message.topicView != null && message.hasOwnProperty("topicView"))
                                $root.google.ads.googleads.v1.resources.TopicView.encode(message.topicView, writer.uint32(/* id 44, wireType 2 =*/354).fork()).ldelim();
                            if (message.parentalStatusView != null && message.hasOwnProperty("parentalStatusView"))
                                $root.google.ads.googleads.v1.resources.ParentalStatusView.encode(message.parentalStatusView, writer.uint32(/* id 45, wireType 2 =*/362).fork()).ldelim();
                            if (message.feed != null && message.hasOwnProperty("feed"))
                                $root.google.ads.googleads.v1.resources.Feed.encode(message.feed, writer.uint32(/* id 46, wireType 2 =*/370).fork()).ldelim();
                            if (message.displayKeywordView != null && message.hasOwnProperty("displayKeywordView"))
                                $root.google.ads.googleads.v1.resources.DisplayKeywordView.encode(message.displayKeywordView, writer.uint32(/* id 47, wireType 2 =*/378).fork()).ldelim();
                            if (message.ageRangeView != null && message.hasOwnProperty("ageRangeView"))
                                $root.google.ads.googleads.v1.resources.AgeRangeView.encode(message.ageRangeView, writer.uint32(/* id 48, wireType 2 =*/386).fork()).ldelim();
                            if (message.feedItem != null && message.hasOwnProperty("feedItem"))
                                $root.google.ads.googleads.v1.resources.FeedItem.encode(message.feedItem, writer.uint32(/* id 50, wireType 2 =*/402).fork()).ldelim();
                            if (message.hotelGroupView != null && message.hasOwnProperty("hotelGroupView"))
                                $root.google.ads.googleads.v1.resources.HotelGroupView.encode(message.hotelGroupView, writer.uint32(/* id 51, wireType 2 =*/410).fork()).ldelim();
                            if (message.label != null && message.hasOwnProperty("label"))
                                $root.google.ads.googleads.v1.resources.Label.encode(message.label, writer.uint32(/* id 52, wireType 2 =*/418).fork()).ldelim();
                            if (message.managedPlacementView != null && message.hasOwnProperty("managedPlacementView"))
                                $root.google.ads.googleads.v1.resources.ManagedPlacementView.encode(message.managedPlacementView, writer.uint32(/* id 53, wireType 2 =*/426).fork()).ldelim();
                            if (message.productGroupView != null && message.hasOwnProperty("productGroupView"))
                                $root.google.ads.googleads.v1.resources.ProductGroupView.encode(message.productGroupView, writer.uint32(/* id 54, wireType 2 =*/434).fork()).ldelim();
                            if (message.languageConstant != null && message.hasOwnProperty("languageConstant"))
                                $root.google.ads.googleads.v1.resources.LanguageConstant.encode(message.languageConstant, writer.uint32(/* id 55, wireType 2 =*/442).fork()).ldelim();
                            if (message.adGroupAudienceView != null && message.hasOwnProperty("adGroupAudienceView"))
                                $root.google.ads.googleads.v1.resources.AdGroupAudienceView.encode(message.adGroupAudienceView, writer.uint32(/* id 57, wireType 2 =*/458).fork()).ldelim();
                            if (message.feedMapping != null && message.hasOwnProperty("feedMapping"))
                                $root.google.ads.googleads.v1.resources.FeedMapping.encode(message.feedMapping, writer.uint32(/* id 58, wireType 2 =*/466).fork()).ldelim();
                            if (message.userInterest != null && message.hasOwnProperty("userInterest"))
                                $root.google.ads.googleads.v1.resources.UserInterest.encode(message.userInterest, writer.uint32(/* id 59, wireType 2 =*/474).fork()).ldelim();
                            if (message.remarketingAction != null && message.hasOwnProperty("remarketingAction"))
                                $root.google.ads.googleads.v1.resources.RemarketingAction.encode(message.remarketingAction, writer.uint32(/* id 60, wireType 2 =*/482).fork()).ldelim();
                            if (message.customerManagerLink != null && message.hasOwnProperty("customerManagerLink"))
                                $root.google.ads.googleads.v1.resources.CustomerManagerLink.encode(message.customerManagerLink, writer.uint32(/* id 61, wireType 2 =*/490).fork()).ldelim();
                            if (message.customerClientLink != null && message.hasOwnProperty("customerClientLink"))
                                $root.google.ads.googleads.v1.resources.CustomerClientLink.encode(message.customerClientLink, writer.uint32(/* id 62, wireType 2 =*/498).fork()).ldelim();
                            if (message.campaignFeed != null && message.hasOwnProperty("campaignFeed"))
                                $root.google.ads.googleads.v1.resources.CampaignFeed.encode(message.campaignFeed, writer.uint32(/* id 63, wireType 2 =*/506).fork()).ldelim();
                            if (message.customerFeed != null && message.hasOwnProperty("customerFeed"))
                                $root.google.ads.googleads.v1.resources.CustomerFeed.encode(message.customerFeed, writer.uint32(/* id 64, wireType 2 =*/514).fork()).ldelim();
                            if (message.carrierConstant != null && message.hasOwnProperty("carrierConstant"))
                                $root.google.ads.googleads.v1.resources.CarrierConstant.encode(message.carrierConstant, writer.uint32(/* id 66, wireType 2 =*/530).fork()).ldelim();
                            if (message.adGroupFeed != null && message.hasOwnProperty("adGroupFeed"))
                                $root.google.ads.googleads.v1.resources.AdGroupFeed.encode(message.adGroupFeed, writer.uint32(/* id 67, wireType 2 =*/538).fork()).ldelim();
                            if (message.searchTermView != null && message.hasOwnProperty("searchTermView"))
                                $root.google.ads.googleads.v1.resources.SearchTermView.encode(message.searchTermView, writer.uint32(/* id 68, wireType 2 =*/546).fork()).ldelim();
                            if (message.campaignAudienceView != null && message.hasOwnProperty("campaignAudienceView"))
                                $root.google.ads.googleads.v1.resources.CampaignAudienceView.encode(message.campaignAudienceView, writer.uint32(/* id 69, wireType 2 =*/554).fork()).ldelim();
                            if (message.customerClient != null && message.hasOwnProperty("customerClient"))
                                $root.google.ads.googleads.v1.resources.CustomerClient.encode(message.customerClient, writer.uint32(/* id 70, wireType 2 =*/562).fork()).ldelim();
                            if (message.hotelPerformanceView != null && message.hasOwnProperty("hotelPerformanceView"))
                                $root.google.ads.googleads.v1.resources.HotelPerformanceView.encode(message.hotelPerformanceView, writer.uint32(/* id 71, wireType 2 =*/570).fork()).ldelim();
                            if (message.extensionFeedItem != null && message.hasOwnProperty("extensionFeedItem"))
                                $root.google.ads.googleads.v1.resources.ExtensionFeedItem.encode(message.extensionFeedItem, writer.uint32(/* id 85, wireType 2 =*/682).fork()).ldelim();
                            if (message.operatingSystemVersionConstant != null && message.hasOwnProperty("operatingSystemVersionConstant"))
                                $root.google.ads.googleads.v1.resources.OperatingSystemVersionConstant.encode(message.operatingSystemVersionConstant, writer.uint32(/* id 86, wireType 2 =*/690).fork()).ldelim();
                            if (message.mobileAppCategoryConstant != null && message.hasOwnProperty("mobileAppCategoryConstant"))
                                $root.google.ads.googleads.v1.resources.MobileAppCategoryConstant.encode(message.mobileAppCategoryConstant, writer.uint32(/* id 87, wireType 2 =*/698).fork()).ldelim();
                            if (message.customerNegativeCriterion != null && message.hasOwnProperty("customerNegativeCriterion"))
                                $root.google.ads.googleads.v1.resources.CustomerNegativeCriterion.encode(message.customerNegativeCriterion, writer.uint32(/* id 88, wireType 2 =*/706).fork()).ldelim();
                            if (message.adScheduleView != null && message.hasOwnProperty("adScheduleView"))
                                $root.google.ads.googleads.v1.resources.AdScheduleView.encode(message.adScheduleView, writer.uint32(/* id 89, wireType 2 =*/714).fork()).ldelim();
                            if (message.mediaFile != null && message.hasOwnProperty("mediaFile"))
                                $root.google.ads.googleads.v1.resources.MediaFile.encode(message.mediaFile, writer.uint32(/* id 90, wireType 2 =*/722).fork()).ldelim();
                            if (message.domainCategory != null && message.hasOwnProperty("domainCategory"))
                                $root.google.ads.googleads.v1.resources.DomainCategory.encode(message.domainCategory, writer.uint32(/* id 91, wireType 2 =*/730).fork()).ldelim();
                            if (message.feedPlaceholderView != null && message.hasOwnProperty("feedPlaceholderView"))
                                $root.google.ads.googleads.v1.resources.FeedPlaceholderView.encode(message.feedPlaceholderView, writer.uint32(/* id 97, wireType 2 =*/778).fork()).ldelim();
                            if (message.mobileDeviceConstant != null && message.hasOwnProperty("mobileDeviceConstant"))
                                $root.google.ads.googleads.v1.resources.MobileDeviceConstant.encode(message.mobileDeviceConstant, writer.uint32(/* id 98, wireType 2 =*/786).fork()).ldelim();
                            if (message.segments != null && message.hasOwnProperty("segments"))
                                $root.google.ads.googleads.v1.common.Segments.encode(message.segments, writer.uint32(/* id 102, wireType 2 =*/818).fork()).ldelim();
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                $root.google.ads.googleads.v1.resources.ConversionAction.encode(message.conversionAction, writer.uint32(/* id 103, wireType 2 =*/826).fork()).ldelim();
                            if (message.customInterest != null && message.hasOwnProperty("customInterest"))
                                $root.google.ads.googleads.v1.resources.CustomInterest.encode(message.customInterest, writer.uint32(/* id 104, wireType 2 =*/834).fork()).ldelim();
                            if (message.asset != null && message.hasOwnProperty("asset"))
                                $root.google.ads.googleads.v1.resources.Asset.encode(message.asset, writer.uint32(/* id 105, wireType 2 =*/842).fork()).ldelim();
                            if (message.dynamicSearchAdsSearchTermView != null && message.hasOwnProperty("dynamicSearchAdsSearchTermView"))
                                $root.google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView.encode(message.dynamicSearchAdsSearchTermView, writer.uint32(/* id 106, wireType 2 =*/850).fork()).ldelim();
                            if (message.adGroupSimulation != null && message.hasOwnProperty("adGroupSimulation"))
                                $root.google.ads.googleads.v1.resources.AdGroupSimulation.encode(message.adGroupSimulation, writer.uint32(/* id 107, wireType 2 =*/858).fork()).ldelim();
                            if (message.campaignLabel != null && message.hasOwnProperty("campaignLabel"))
                                $root.google.ads.googleads.v1.resources.CampaignLabel.encode(message.campaignLabel, writer.uint32(/* id 108, wireType 2 =*/866).fork()).ldelim();
                            if (message.productBiddingCategoryConstant != null && message.hasOwnProperty("productBiddingCategoryConstant"))
                                $root.google.ads.googleads.v1.resources.ProductBiddingCategoryConstant.encode(message.productBiddingCategoryConstant, writer.uint32(/* id 109, wireType 2 =*/874).fork()).ldelim();
                            if (message.adGroupCriterionSimulation != null && message.hasOwnProperty("adGroupCriterionSimulation"))
                                $root.google.ads.googleads.v1.resources.AdGroupCriterionSimulation.encode(message.adGroupCriterionSimulation, writer.uint32(/* id 110, wireType 2 =*/882).fork()).ldelim();
                            if (message.campaignCriterionSimulation != null && message.hasOwnProperty("campaignCriterionSimulation"))
                                $root.google.ads.googleads.v1.resources.CampaignCriterionSimulation.encode(message.campaignCriterionSimulation, writer.uint32(/* id 111, wireType 2 =*/890).fork()).ldelim();
                            if (message.adGroupExtensionSetting != null && message.hasOwnProperty("adGroupExtensionSetting"))
                                $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting.encode(message.adGroupExtensionSetting, writer.uint32(/* id 112, wireType 2 =*/898).fork()).ldelim();
                            if (message.campaignExtensionSetting != null && message.hasOwnProperty("campaignExtensionSetting"))
                                $root.google.ads.googleads.v1.resources.CampaignExtensionSetting.encode(message.campaignExtensionSetting, writer.uint32(/* id 113, wireType 2 =*/906).fork()).ldelim();
                            if (message.customerExtensionSetting != null && message.hasOwnProperty("customerExtensionSetting"))
                                $root.google.ads.googleads.v1.resources.CustomerExtensionSetting.encode(message.customerExtensionSetting, writer.uint32(/* id 114, wireType 2 =*/914).fork()).ldelim();
                            if (message.adGroupLabel != null && message.hasOwnProperty("adGroupLabel"))
                                $root.google.ads.googleads.v1.resources.AdGroupLabel.encode(message.adGroupLabel, writer.uint32(/* id 115, wireType 2 =*/922).fork()).ldelim();
                            if (message.feedItemTarget != null && message.hasOwnProperty("feedItemTarget"))
                                $root.google.ads.googleads.v1.resources.FeedItemTarget.encode(message.feedItemTarget, writer.uint32(/* id 116, wireType 2 =*/930).fork()).ldelim();
                            if (message.shoppingPerformanceView != null && message.hasOwnProperty("shoppingPerformanceView"))
                                $root.google.ads.googleads.v1.resources.ShoppingPerformanceView.encode(message.shoppingPerformanceView, writer.uint32(/* id 117, wireType 2 =*/938).fork()).ldelim();
                            if (message.detailPlacementView != null && message.hasOwnProperty("detailPlacementView"))
                                $root.google.ads.googleads.v1.resources.DetailPlacementView.encode(message.detailPlacementView, writer.uint32(/* id 118, wireType 2 =*/946).fork()).ldelim();
                            if (message.groupPlacementView != null && message.hasOwnProperty("groupPlacementView"))
                                $root.google.ads.googleads.v1.resources.GroupPlacementView.encode(message.groupPlacementView, writer.uint32(/* id 119, wireType 2 =*/954).fork()).ldelim();
                            if (message.adGroupAdLabel != null && message.hasOwnProperty("adGroupAdLabel"))
                                $root.google.ads.googleads.v1.resources.AdGroupAdLabel.encode(message.adGroupAdLabel, writer.uint32(/* id 120, wireType 2 =*/962).fork()).ldelim();
                            if (message.adGroupCriterionLabel != null && message.hasOwnProperty("adGroupCriterionLabel"))
                                $root.google.ads.googleads.v1.resources.AdGroupCriterionLabel.encode(message.adGroupCriterionLabel, writer.uint32(/* id 121, wireType 2 =*/970).fork()).ldelim();
                            if (message.clickView != null && message.hasOwnProperty("clickView"))
                                $root.google.ads.googleads.v1.resources.ClickView.encode(message.clickView, writer.uint32(/* id 122, wireType 2 =*/978).fork()).ldelim();
                            if (message.locationView != null && message.hasOwnProperty("locationView"))
                                $root.google.ads.googleads.v1.resources.LocationView.encode(message.locationView, writer.uint32(/* id 123, wireType 2 =*/986).fork()).ldelim();
                            if (message.customerLabel != null && message.hasOwnProperty("customerLabel"))
                                $root.google.ads.googleads.v1.resources.CustomerLabel.encode(message.customerLabel, writer.uint32(/* id 124, wireType 2 =*/994).fork()).ldelim();
                            if (message.geographicView != null && message.hasOwnProperty("geographicView"))
                                $root.google.ads.googleads.v1.resources.GeographicView.encode(message.geographicView, writer.uint32(/* id 125, wireType 2 =*/1002).fork()).ldelim();
                            if (message.landingPageView != null && message.hasOwnProperty("landingPageView"))
                                $root.google.ads.googleads.v1.resources.LandingPageView.encode(message.landingPageView, writer.uint32(/* id 126, wireType 2 =*/1010).fork()).ldelim();
                            if (message.mutateJob != null && message.hasOwnProperty("mutateJob"))
                                $root.google.ads.googleads.v1.resources.MutateJob.encode(message.mutateJob, writer.uint32(/* id 127, wireType 2 =*/1018).fork()).ldelim();
                            if (message.expandedLandingPageView != null && message.hasOwnProperty("expandedLandingPageView"))
                                $root.google.ads.googleads.v1.resources.ExpandedLandingPageView.encode(message.expandedLandingPageView, writer.uint32(/* id 128, wireType 2 =*/1026).fork()).ldelim();
                            if (message.paidOrganicSearchTermView != null && message.hasOwnProperty("paidOrganicSearchTermView"))
                                $root.google.ads.googleads.v1.resources.PaidOrganicSearchTermView.encode(message.paidOrganicSearchTermView, writer.uint32(/* id 129, wireType 2 =*/1034).fork()).ldelim();
                            if (message.adParameter != null && message.hasOwnProperty("adParameter"))
                                $root.google.ads.googleads.v1.resources.AdParameter.encode(message.adParameter, writer.uint32(/* id 130, wireType 2 =*/1042).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified GoogleAdsRow message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GoogleAdsRow.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @static
                         * @param {google.ads.googleads.v1.services.IGoogleAdsRow} message GoogleAdsRow message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GoogleAdsRow.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GoogleAdsRow message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GoogleAdsRow} GoogleAdsRow
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GoogleAdsRow.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GoogleAdsRow();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 42:
                                    message.accountBudget = $root.google.ads.googleads.v1.resources.AccountBudget.decode(reader, reader.uint32());
                                    break;
                                case 43:
                                    message.accountBudgetProposal = $root.google.ads.googleads.v1.resources.AccountBudgetProposal.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.adGroup = $root.google.ads.googleads.v1.resources.AdGroup.decode(reader, reader.uint32());
                                    break;
                                case 16:
                                    message.adGroupAd = $root.google.ads.googleads.v1.resources.AdGroupAd.decode(reader, reader.uint32());
                                    break;
                                case 120:
                                    message.adGroupAdLabel = $root.google.ads.googleads.v1.resources.AdGroupAdLabel.decode(reader, reader.uint32());
                                    break;
                                case 57:
                                    message.adGroupAudienceView = $root.google.ads.googleads.v1.resources.AdGroupAudienceView.decode(reader, reader.uint32());
                                    break;
                                case 24:
                                    message.adGroupBidModifier = $root.google.ads.googleads.v1.resources.AdGroupBidModifier.decode(reader, reader.uint32());
                                    break;
                                case 17:
                                    message.adGroupCriterion = $root.google.ads.googleads.v1.resources.AdGroupCriterion.decode(reader, reader.uint32());
                                    break;
                                case 121:
                                    message.adGroupCriterionLabel = $root.google.ads.googleads.v1.resources.AdGroupCriterionLabel.decode(reader, reader.uint32());
                                    break;
                                case 110:
                                    message.adGroupCriterionSimulation = $root.google.ads.googleads.v1.resources.AdGroupCriterionSimulation.decode(reader, reader.uint32());
                                    break;
                                case 112:
                                    message.adGroupExtensionSetting = $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting.decode(reader, reader.uint32());
                                    break;
                                case 67:
                                    message.adGroupFeed = $root.google.ads.googleads.v1.resources.AdGroupFeed.decode(reader, reader.uint32());
                                    break;
                                case 115:
                                    message.adGroupLabel = $root.google.ads.googleads.v1.resources.AdGroupLabel.decode(reader, reader.uint32());
                                    break;
                                case 107:
                                    message.adGroupSimulation = $root.google.ads.googleads.v1.resources.AdGroupSimulation.decode(reader, reader.uint32());
                                    break;
                                case 130:
                                    message.adParameter = $root.google.ads.googleads.v1.resources.AdParameter.decode(reader, reader.uint32());
                                    break;
                                case 48:
                                    message.ageRangeView = $root.google.ads.googleads.v1.resources.AgeRangeView.decode(reader, reader.uint32());
                                    break;
                                case 89:
                                    message.adScheduleView = $root.google.ads.googleads.v1.resources.AdScheduleView.decode(reader, reader.uint32());
                                    break;
                                case 91:
                                    message.domainCategory = $root.google.ads.googleads.v1.resources.DomainCategory.decode(reader, reader.uint32());
                                    break;
                                case 105:
                                    message.asset = $root.google.ads.googleads.v1.resources.Asset.decode(reader, reader.uint32());
                                    break;
                                case 18:
                                    message.biddingStrategy = $root.google.ads.googleads.v1.resources.BiddingStrategy.decode(reader, reader.uint32());
                                    break;
                                case 41:
                                    message.billingSetup = $root.google.ads.googleads.v1.resources.BillingSetup.decode(reader, reader.uint32());
                                    break;
                                case 19:
                                    message.campaignBudget = $root.google.ads.googleads.v1.resources.CampaignBudget.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.campaign = $root.google.ads.googleads.v1.resources.Campaign.decode(reader, reader.uint32());
                                    break;
                                case 69:
                                    message.campaignAudienceView = $root.google.ads.googleads.v1.resources.CampaignAudienceView.decode(reader, reader.uint32());
                                    break;
                                case 26:
                                    message.campaignBidModifier = $root.google.ads.googleads.v1.resources.CampaignBidModifier.decode(reader, reader.uint32());
                                    break;
                                case 20:
                                    message.campaignCriterion = $root.google.ads.googleads.v1.resources.CampaignCriterion.decode(reader, reader.uint32());
                                    break;
                                case 111:
                                    message.campaignCriterionSimulation = $root.google.ads.googleads.v1.resources.CampaignCriterionSimulation.decode(reader, reader.uint32());
                                    break;
                                case 113:
                                    message.campaignExtensionSetting = $root.google.ads.googleads.v1.resources.CampaignExtensionSetting.decode(reader, reader.uint32());
                                    break;
                                case 63:
                                    message.campaignFeed = $root.google.ads.googleads.v1.resources.CampaignFeed.decode(reader, reader.uint32());
                                    break;
                                case 108:
                                    message.campaignLabel = $root.google.ads.googleads.v1.resources.CampaignLabel.decode(reader, reader.uint32());
                                    break;
                                case 30:
                                    message.campaignSharedSet = $root.google.ads.googleads.v1.resources.CampaignSharedSet.decode(reader, reader.uint32());
                                    break;
                                case 66:
                                    message.carrierConstant = $root.google.ads.googleads.v1.resources.CarrierConstant.decode(reader, reader.uint32());
                                    break;
                                case 37:
                                    message.changeStatus = $root.google.ads.googleads.v1.resources.ChangeStatus.decode(reader, reader.uint32());
                                    break;
                                case 103:
                                    message.conversionAction = $root.google.ads.googleads.v1.resources.ConversionAction.decode(reader, reader.uint32());
                                    break;
                                case 122:
                                    message.clickView = $root.google.ads.googleads.v1.resources.ClickView.decode(reader, reader.uint32());
                                    break;
                                case 104:
                                    message.customInterest = $root.google.ads.googleads.v1.resources.CustomInterest.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.customer = $root.google.ads.googleads.v1.resources.Customer.decode(reader, reader.uint32());
                                    break;
                                case 61:
                                    message.customerManagerLink = $root.google.ads.googleads.v1.resources.CustomerManagerLink.decode(reader, reader.uint32());
                                    break;
                                case 62:
                                    message.customerClientLink = $root.google.ads.googleads.v1.resources.CustomerClientLink.decode(reader, reader.uint32());
                                    break;
                                case 70:
                                    message.customerClient = $root.google.ads.googleads.v1.resources.CustomerClient.decode(reader, reader.uint32());
                                    break;
                                case 114:
                                    message.customerExtensionSetting = $root.google.ads.googleads.v1.resources.CustomerExtensionSetting.decode(reader, reader.uint32());
                                    break;
                                case 64:
                                    message.customerFeed = $root.google.ads.googleads.v1.resources.CustomerFeed.decode(reader, reader.uint32());
                                    break;
                                case 124:
                                    message.customerLabel = $root.google.ads.googleads.v1.resources.CustomerLabel.decode(reader, reader.uint32());
                                    break;
                                case 88:
                                    message.customerNegativeCriterion = $root.google.ads.googleads.v1.resources.CustomerNegativeCriterion.decode(reader, reader.uint32());
                                    break;
                                case 118:
                                    message.detailPlacementView = $root.google.ads.googleads.v1.resources.DetailPlacementView.decode(reader, reader.uint32());
                                    break;
                                case 47:
                                    message.displayKeywordView = $root.google.ads.googleads.v1.resources.DisplayKeywordView.decode(reader, reader.uint32());
                                    break;
                                case 106:
                                    message.dynamicSearchAdsSearchTermView = $root.google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView.decode(reader, reader.uint32());
                                    break;
                                case 128:
                                    message.expandedLandingPageView = $root.google.ads.googleads.v1.resources.ExpandedLandingPageView.decode(reader, reader.uint32());
                                    break;
                                case 85:
                                    message.extensionFeedItem = $root.google.ads.googleads.v1.resources.ExtensionFeedItem.decode(reader, reader.uint32());
                                    break;
                                case 46:
                                    message.feed = $root.google.ads.googleads.v1.resources.Feed.decode(reader, reader.uint32());
                                    break;
                                case 50:
                                    message.feedItem = $root.google.ads.googleads.v1.resources.FeedItem.decode(reader, reader.uint32());
                                    break;
                                case 116:
                                    message.feedItemTarget = $root.google.ads.googleads.v1.resources.FeedItemTarget.decode(reader, reader.uint32());
                                    break;
                                case 58:
                                    message.feedMapping = $root.google.ads.googleads.v1.resources.FeedMapping.decode(reader, reader.uint32());
                                    break;
                                case 97:
                                    message.feedPlaceholderView = $root.google.ads.googleads.v1.resources.FeedPlaceholderView.decode(reader, reader.uint32());
                                    break;
                                case 40:
                                    message.genderView = $root.google.ads.googleads.v1.resources.GenderView.decode(reader, reader.uint32());
                                    break;
                                case 23:
                                    message.geoTargetConstant = $root.google.ads.googleads.v1.resources.GeoTargetConstant.decode(reader, reader.uint32());
                                    break;
                                case 125:
                                    message.geographicView = $root.google.ads.googleads.v1.resources.GeographicView.decode(reader, reader.uint32());
                                    break;
                                case 119:
                                    message.groupPlacementView = $root.google.ads.googleads.v1.resources.GroupPlacementView.decode(reader, reader.uint32());
                                    break;
                                case 51:
                                    message.hotelGroupView = $root.google.ads.googleads.v1.resources.HotelGroupView.decode(reader, reader.uint32());
                                    break;
                                case 71:
                                    message.hotelPerformanceView = $root.google.ads.googleads.v1.resources.HotelPerformanceView.decode(reader, reader.uint32());
                                    break;
                                case 21:
                                    message.keywordView = $root.google.ads.googleads.v1.resources.KeywordView.decode(reader, reader.uint32());
                                    break;
                                case 32:
                                    message.keywordPlan = $root.google.ads.googleads.v1.resources.KeywordPlan.decode(reader, reader.uint32());
                                    break;
                                case 33:
                                    message.keywordPlanCampaign = $root.google.ads.googleads.v1.resources.KeywordPlanCampaign.decode(reader, reader.uint32());
                                    break;
                                case 34:
                                    message.keywordPlanNegativeKeyword = $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.decode(reader, reader.uint32());
                                    break;
                                case 35:
                                    message.keywordPlanAdGroup = $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup.decode(reader, reader.uint32());
                                    break;
                                case 36:
                                    message.keywordPlanKeyword = $root.google.ads.googleads.v1.resources.KeywordPlanKeyword.decode(reader, reader.uint32());
                                    break;
                                case 52:
                                    message.label = $root.google.ads.googleads.v1.resources.Label.decode(reader, reader.uint32());
                                    break;
                                case 126:
                                    message.landingPageView = $root.google.ads.googleads.v1.resources.LandingPageView.decode(reader, reader.uint32());
                                    break;
                                case 55:
                                    message.languageConstant = $root.google.ads.googleads.v1.resources.LanguageConstant.decode(reader, reader.uint32());
                                    break;
                                case 123:
                                    message.locationView = $root.google.ads.googleads.v1.resources.LocationView.decode(reader, reader.uint32());
                                    break;
                                case 53:
                                    message.managedPlacementView = $root.google.ads.googleads.v1.resources.ManagedPlacementView.decode(reader, reader.uint32());
                                    break;
                                case 90:
                                    message.mediaFile = $root.google.ads.googleads.v1.resources.MediaFile.decode(reader, reader.uint32());
                                    break;
                                case 87:
                                    message.mobileAppCategoryConstant = $root.google.ads.googleads.v1.resources.MobileAppCategoryConstant.decode(reader, reader.uint32());
                                    break;
                                case 98:
                                    message.mobileDeviceConstant = $root.google.ads.googleads.v1.resources.MobileDeviceConstant.decode(reader, reader.uint32());
                                    break;
                                case 127:
                                    message.mutateJob = $root.google.ads.googleads.v1.resources.MutateJob.decode(reader, reader.uint32());
                                    break;
                                case 86:
                                    message.operatingSystemVersionConstant = $root.google.ads.googleads.v1.resources.OperatingSystemVersionConstant.decode(reader, reader.uint32());
                                    break;
                                case 129:
                                    message.paidOrganicSearchTermView = $root.google.ads.googleads.v1.resources.PaidOrganicSearchTermView.decode(reader, reader.uint32());
                                    break;
                                case 45:
                                    message.parentalStatusView = $root.google.ads.googleads.v1.resources.ParentalStatusView.decode(reader, reader.uint32());
                                    break;
                                case 109:
                                    message.productBiddingCategoryConstant = $root.google.ads.googleads.v1.resources.ProductBiddingCategoryConstant.decode(reader, reader.uint32());
                                    break;
                                case 54:
                                    message.productGroupView = $root.google.ads.googleads.v1.resources.ProductGroupView.decode(reader, reader.uint32());
                                    break;
                                case 22:
                                    message.recommendation = $root.google.ads.googleads.v1.resources.Recommendation.decode(reader, reader.uint32());
                                    break;
                                case 68:
                                    message.searchTermView = $root.google.ads.googleads.v1.resources.SearchTermView.decode(reader, reader.uint32());
                                    break;
                                case 29:
                                    message.sharedCriterion = $root.google.ads.googleads.v1.resources.SharedCriterion.decode(reader, reader.uint32());
                                    break;
                                case 27:
                                    message.sharedSet = $root.google.ads.googleads.v1.resources.SharedSet.decode(reader, reader.uint32());
                                    break;
                                case 117:
                                    message.shoppingPerformanceView = $root.google.ads.googleads.v1.resources.ShoppingPerformanceView.decode(reader, reader.uint32());
                                    break;
                                case 44:
                                    message.topicView = $root.google.ads.googleads.v1.resources.TopicView.decode(reader, reader.uint32());
                                    break;
                                case 59:
                                    message.userInterest = $root.google.ads.googleads.v1.resources.UserInterest.decode(reader, reader.uint32());
                                    break;
                                case 38:
                                    message.userList = $root.google.ads.googleads.v1.resources.UserList.decode(reader, reader.uint32());
                                    break;
                                case 60:
                                    message.remarketingAction = $root.google.ads.googleads.v1.resources.RemarketingAction.decode(reader, reader.uint32());
                                    break;
                                case 31:
                                    message.topicConstant = $root.google.ads.googleads.v1.resources.TopicConstant.decode(reader, reader.uint32());
                                    break;
                                case 39:
                                    message.video = $root.google.ads.googleads.v1.resources.Video.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.metrics = $root.google.ads.googleads.v1.common.Metrics.decode(reader, reader.uint32());
                                    break;
                                case 102:
                                    message.segments = $root.google.ads.googleads.v1.common.Segments.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GoogleAdsRow message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GoogleAdsRow} GoogleAdsRow
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GoogleAdsRow.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GoogleAdsRow message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GoogleAdsRow.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.accountBudget != null && message.hasOwnProperty("accountBudget")) {
                                var error = $root.google.ads.googleads.v1.resources.AccountBudget.verify(message.accountBudget);
                                if (error)
                                    return "accountBudget." + error;
                            }
                            if (message.accountBudgetProposal != null && message.hasOwnProperty("accountBudgetProposal")) {
                                var error = $root.google.ads.googleads.v1.resources.AccountBudgetProposal.verify(message.accountBudgetProposal);
                                if (error)
                                    return "accountBudgetProposal." + error;
                            }
                            if (message.adGroup != null && message.hasOwnProperty("adGroup")) {
                                var error = $root.google.ads.googleads.v1.resources.AdGroup.verify(message.adGroup);
                                if (error)
                                    return "adGroup." + error;
                            }
                            if (message.adGroupAd != null && message.hasOwnProperty("adGroupAd")) {
                                var error = $root.google.ads.googleads.v1.resources.AdGroupAd.verify(message.adGroupAd);
                                if (error)
                                    return "adGroupAd." + error;
                            }
                            if (message.adGroupAdLabel != null && message.hasOwnProperty("adGroupAdLabel")) {
                                var error = $root.google.ads.googleads.v1.resources.AdGroupAdLabel.verify(message.adGroupAdLabel);
                                if (error)
                                    return "adGroupAdLabel." + error;
                            }
                            if (message.adGroupAudienceView != null && message.hasOwnProperty("adGroupAudienceView")) {
                                var error = $root.google.ads.googleads.v1.resources.AdGroupAudienceView.verify(message.adGroupAudienceView);
                                if (error)
                                    return "adGroupAudienceView." + error;
                            }
                            if (message.adGroupBidModifier != null && message.hasOwnProperty("adGroupBidModifier")) {
                                var error = $root.google.ads.googleads.v1.resources.AdGroupBidModifier.verify(message.adGroupBidModifier);
                                if (error)
                                    return "adGroupBidModifier." + error;
                            }
                            if (message.adGroupCriterion != null && message.hasOwnProperty("adGroupCriterion")) {
                                var error = $root.google.ads.googleads.v1.resources.AdGroupCriterion.verify(message.adGroupCriterion);
                                if (error)
                                    return "adGroupCriterion." + error;
                            }
                            if (message.adGroupCriterionLabel != null && message.hasOwnProperty("adGroupCriterionLabel")) {
                                var error = $root.google.ads.googleads.v1.resources.AdGroupCriterionLabel.verify(message.adGroupCriterionLabel);
                                if (error)
                                    return "adGroupCriterionLabel." + error;
                            }
                            if (message.adGroupCriterionSimulation != null && message.hasOwnProperty("adGroupCriterionSimulation")) {
                                var error = $root.google.ads.googleads.v1.resources.AdGroupCriterionSimulation.verify(message.adGroupCriterionSimulation);
                                if (error)
                                    return "adGroupCriterionSimulation." + error;
                            }
                            if (message.adGroupExtensionSetting != null && message.hasOwnProperty("adGroupExtensionSetting")) {
                                var error = $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting.verify(message.adGroupExtensionSetting);
                                if (error)
                                    return "adGroupExtensionSetting." + error;
                            }
                            if (message.adGroupFeed != null && message.hasOwnProperty("adGroupFeed")) {
                                var error = $root.google.ads.googleads.v1.resources.AdGroupFeed.verify(message.adGroupFeed);
                                if (error)
                                    return "adGroupFeed." + error;
                            }
                            if (message.adGroupLabel != null && message.hasOwnProperty("adGroupLabel")) {
                                var error = $root.google.ads.googleads.v1.resources.AdGroupLabel.verify(message.adGroupLabel);
                                if (error)
                                    return "adGroupLabel." + error;
                            }
                            if (message.adGroupSimulation != null && message.hasOwnProperty("adGroupSimulation")) {
                                var error = $root.google.ads.googleads.v1.resources.AdGroupSimulation.verify(message.adGroupSimulation);
                                if (error)
                                    return "adGroupSimulation." + error;
                            }
                            if (message.adParameter != null && message.hasOwnProperty("adParameter")) {
                                var error = $root.google.ads.googleads.v1.resources.AdParameter.verify(message.adParameter);
                                if (error)
                                    return "adParameter." + error;
                            }
                            if (message.ageRangeView != null && message.hasOwnProperty("ageRangeView")) {
                                var error = $root.google.ads.googleads.v1.resources.AgeRangeView.verify(message.ageRangeView);
                                if (error)
                                    return "ageRangeView." + error;
                            }
                            if (message.adScheduleView != null && message.hasOwnProperty("adScheduleView")) {
                                var error = $root.google.ads.googleads.v1.resources.AdScheduleView.verify(message.adScheduleView);
                                if (error)
                                    return "adScheduleView." + error;
                            }
                            if (message.domainCategory != null && message.hasOwnProperty("domainCategory")) {
                                var error = $root.google.ads.googleads.v1.resources.DomainCategory.verify(message.domainCategory);
                                if (error)
                                    return "domainCategory." + error;
                            }
                            if (message.asset != null && message.hasOwnProperty("asset")) {
                                var error = $root.google.ads.googleads.v1.resources.Asset.verify(message.asset);
                                if (error)
                                    return "asset." + error;
                            }
                            if (message.biddingStrategy != null && message.hasOwnProperty("biddingStrategy")) {
                                var error = $root.google.ads.googleads.v1.resources.BiddingStrategy.verify(message.biddingStrategy);
                                if (error)
                                    return "biddingStrategy." + error;
                            }
                            if (message.billingSetup != null && message.hasOwnProperty("billingSetup")) {
                                var error = $root.google.ads.googleads.v1.resources.BillingSetup.verify(message.billingSetup);
                                if (error)
                                    return "billingSetup." + error;
                            }
                            if (message.campaignBudget != null && message.hasOwnProperty("campaignBudget")) {
                                var error = $root.google.ads.googleads.v1.resources.CampaignBudget.verify(message.campaignBudget);
                                if (error)
                                    return "campaignBudget." + error;
                            }
                            if (message.campaign != null && message.hasOwnProperty("campaign")) {
                                var error = $root.google.ads.googleads.v1.resources.Campaign.verify(message.campaign);
                                if (error)
                                    return "campaign." + error;
                            }
                            if (message.campaignAudienceView != null && message.hasOwnProperty("campaignAudienceView")) {
                                var error = $root.google.ads.googleads.v1.resources.CampaignAudienceView.verify(message.campaignAudienceView);
                                if (error)
                                    return "campaignAudienceView." + error;
                            }
                            if (message.campaignBidModifier != null && message.hasOwnProperty("campaignBidModifier")) {
                                var error = $root.google.ads.googleads.v1.resources.CampaignBidModifier.verify(message.campaignBidModifier);
                                if (error)
                                    return "campaignBidModifier." + error;
                            }
                            if (message.campaignCriterion != null && message.hasOwnProperty("campaignCriterion")) {
                                var error = $root.google.ads.googleads.v1.resources.CampaignCriterion.verify(message.campaignCriterion);
                                if (error)
                                    return "campaignCriterion." + error;
                            }
                            if (message.campaignCriterionSimulation != null && message.hasOwnProperty("campaignCriterionSimulation")) {
                                var error = $root.google.ads.googleads.v1.resources.CampaignCriterionSimulation.verify(message.campaignCriterionSimulation);
                                if (error)
                                    return "campaignCriterionSimulation." + error;
                            }
                            if (message.campaignExtensionSetting != null && message.hasOwnProperty("campaignExtensionSetting")) {
                                var error = $root.google.ads.googleads.v1.resources.CampaignExtensionSetting.verify(message.campaignExtensionSetting);
                                if (error)
                                    return "campaignExtensionSetting." + error;
                            }
                            if (message.campaignFeed != null && message.hasOwnProperty("campaignFeed")) {
                                var error = $root.google.ads.googleads.v1.resources.CampaignFeed.verify(message.campaignFeed);
                                if (error)
                                    return "campaignFeed." + error;
                            }
                            if (message.campaignLabel != null && message.hasOwnProperty("campaignLabel")) {
                                var error = $root.google.ads.googleads.v1.resources.CampaignLabel.verify(message.campaignLabel);
                                if (error)
                                    return "campaignLabel." + error;
                            }
                            if (message.campaignSharedSet != null && message.hasOwnProperty("campaignSharedSet")) {
                                var error = $root.google.ads.googleads.v1.resources.CampaignSharedSet.verify(message.campaignSharedSet);
                                if (error)
                                    return "campaignSharedSet." + error;
                            }
                            if (message.carrierConstant != null && message.hasOwnProperty("carrierConstant")) {
                                var error = $root.google.ads.googleads.v1.resources.CarrierConstant.verify(message.carrierConstant);
                                if (error)
                                    return "carrierConstant." + error;
                            }
                            if (message.changeStatus != null && message.hasOwnProperty("changeStatus")) {
                                var error = $root.google.ads.googleads.v1.resources.ChangeStatus.verify(message.changeStatus);
                                if (error)
                                    return "changeStatus." + error;
                            }
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction")) {
                                var error = $root.google.ads.googleads.v1.resources.ConversionAction.verify(message.conversionAction);
                                if (error)
                                    return "conversionAction." + error;
                            }
                            if (message.clickView != null && message.hasOwnProperty("clickView")) {
                                var error = $root.google.ads.googleads.v1.resources.ClickView.verify(message.clickView);
                                if (error)
                                    return "clickView." + error;
                            }
                            if (message.customInterest != null && message.hasOwnProperty("customInterest")) {
                                var error = $root.google.ads.googleads.v1.resources.CustomInterest.verify(message.customInterest);
                                if (error)
                                    return "customInterest." + error;
                            }
                            if (message.customer != null && message.hasOwnProperty("customer")) {
                                var error = $root.google.ads.googleads.v1.resources.Customer.verify(message.customer);
                                if (error)
                                    return "customer." + error;
                            }
                            if (message.customerManagerLink != null && message.hasOwnProperty("customerManagerLink")) {
                                var error = $root.google.ads.googleads.v1.resources.CustomerManagerLink.verify(message.customerManagerLink);
                                if (error)
                                    return "customerManagerLink." + error;
                            }
                            if (message.customerClientLink != null && message.hasOwnProperty("customerClientLink")) {
                                var error = $root.google.ads.googleads.v1.resources.CustomerClientLink.verify(message.customerClientLink);
                                if (error)
                                    return "customerClientLink." + error;
                            }
                            if (message.customerClient != null && message.hasOwnProperty("customerClient")) {
                                var error = $root.google.ads.googleads.v1.resources.CustomerClient.verify(message.customerClient);
                                if (error)
                                    return "customerClient." + error;
                            }
                            if (message.customerExtensionSetting != null && message.hasOwnProperty("customerExtensionSetting")) {
                                var error = $root.google.ads.googleads.v1.resources.CustomerExtensionSetting.verify(message.customerExtensionSetting);
                                if (error)
                                    return "customerExtensionSetting." + error;
                            }
                            if (message.customerFeed != null && message.hasOwnProperty("customerFeed")) {
                                var error = $root.google.ads.googleads.v1.resources.CustomerFeed.verify(message.customerFeed);
                                if (error)
                                    return "customerFeed." + error;
                            }
                            if (message.customerLabel != null && message.hasOwnProperty("customerLabel")) {
                                var error = $root.google.ads.googleads.v1.resources.CustomerLabel.verify(message.customerLabel);
                                if (error)
                                    return "customerLabel." + error;
                            }
                            if (message.customerNegativeCriterion != null && message.hasOwnProperty("customerNegativeCriterion")) {
                                var error = $root.google.ads.googleads.v1.resources.CustomerNegativeCriterion.verify(message.customerNegativeCriterion);
                                if (error)
                                    return "customerNegativeCriterion." + error;
                            }
                            if (message.detailPlacementView != null && message.hasOwnProperty("detailPlacementView")) {
                                var error = $root.google.ads.googleads.v1.resources.DetailPlacementView.verify(message.detailPlacementView);
                                if (error)
                                    return "detailPlacementView." + error;
                            }
                            if (message.displayKeywordView != null && message.hasOwnProperty("displayKeywordView")) {
                                var error = $root.google.ads.googleads.v1.resources.DisplayKeywordView.verify(message.displayKeywordView);
                                if (error)
                                    return "displayKeywordView." + error;
                            }
                            if (message.dynamicSearchAdsSearchTermView != null && message.hasOwnProperty("dynamicSearchAdsSearchTermView")) {
                                var error = $root.google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView.verify(message.dynamicSearchAdsSearchTermView);
                                if (error)
                                    return "dynamicSearchAdsSearchTermView." + error;
                            }
                            if (message.expandedLandingPageView != null && message.hasOwnProperty("expandedLandingPageView")) {
                                var error = $root.google.ads.googleads.v1.resources.ExpandedLandingPageView.verify(message.expandedLandingPageView);
                                if (error)
                                    return "expandedLandingPageView." + error;
                            }
                            if (message.extensionFeedItem != null && message.hasOwnProperty("extensionFeedItem")) {
                                var error = $root.google.ads.googleads.v1.resources.ExtensionFeedItem.verify(message.extensionFeedItem);
                                if (error)
                                    return "extensionFeedItem." + error;
                            }
                            if (message.feed != null && message.hasOwnProperty("feed")) {
                                var error = $root.google.ads.googleads.v1.resources.Feed.verify(message.feed);
                                if (error)
                                    return "feed." + error;
                            }
                            if (message.feedItem != null && message.hasOwnProperty("feedItem")) {
                                var error = $root.google.ads.googleads.v1.resources.FeedItem.verify(message.feedItem);
                                if (error)
                                    return "feedItem." + error;
                            }
                            if (message.feedItemTarget != null && message.hasOwnProperty("feedItemTarget")) {
                                var error = $root.google.ads.googleads.v1.resources.FeedItemTarget.verify(message.feedItemTarget);
                                if (error)
                                    return "feedItemTarget." + error;
                            }
                            if (message.feedMapping != null && message.hasOwnProperty("feedMapping")) {
                                var error = $root.google.ads.googleads.v1.resources.FeedMapping.verify(message.feedMapping);
                                if (error)
                                    return "feedMapping." + error;
                            }
                            if (message.feedPlaceholderView != null && message.hasOwnProperty("feedPlaceholderView")) {
                                var error = $root.google.ads.googleads.v1.resources.FeedPlaceholderView.verify(message.feedPlaceholderView);
                                if (error)
                                    return "feedPlaceholderView." + error;
                            }
                            if (message.genderView != null && message.hasOwnProperty("genderView")) {
                                var error = $root.google.ads.googleads.v1.resources.GenderView.verify(message.genderView);
                                if (error)
                                    return "genderView." + error;
                            }
                            if (message.geoTargetConstant != null && message.hasOwnProperty("geoTargetConstant")) {
                                var error = $root.google.ads.googleads.v1.resources.GeoTargetConstant.verify(message.geoTargetConstant);
                                if (error)
                                    return "geoTargetConstant." + error;
                            }
                            if (message.geographicView != null && message.hasOwnProperty("geographicView")) {
                                var error = $root.google.ads.googleads.v1.resources.GeographicView.verify(message.geographicView);
                                if (error)
                                    return "geographicView." + error;
                            }
                            if (message.groupPlacementView != null && message.hasOwnProperty("groupPlacementView")) {
                                var error = $root.google.ads.googleads.v1.resources.GroupPlacementView.verify(message.groupPlacementView);
                                if (error)
                                    return "groupPlacementView." + error;
                            }
                            if (message.hotelGroupView != null && message.hasOwnProperty("hotelGroupView")) {
                                var error = $root.google.ads.googleads.v1.resources.HotelGroupView.verify(message.hotelGroupView);
                                if (error)
                                    return "hotelGroupView." + error;
                            }
                            if (message.hotelPerformanceView != null && message.hasOwnProperty("hotelPerformanceView")) {
                                var error = $root.google.ads.googleads.v1.resources.HotelPerformanceView.verify(message.hotelPerformanceView);
                                if (error)
                                    return "hotelPerformanceView." + error;
                            }
                            if (message.keywordView != null && message.hasOwnProperty("keywordView")) {
                                var error = $root.google.ads.googleads.v1.resources.KeywordView.verify(message.keywordView);
                                if (error)
                                    return "keywordView." + error;
                            }
                            if (message.keywordPlan != null && message.hasOwnProperty("keywordPlan")) {
                                var error = $root.google.ads.googleads.v1.resources.KeywordPlan.verify(message.keywordPlan);
                                if (error)
                                    return "keywordPlan." + error;
                            }
                            if (message.keywordPlanCampaign != null && message.hasOwnProperty("keywordPlanCampaign")) {
                                var error = $root.google.ads.googleads.v1.resources.KeywordPlanCampaign.verify(message.keywordPlanCampaign);
                                if (error)
                                    return "keywordPlanCampaign." + error;
                            }
                            if (message.keywordPlanNegativeKeyword != null && message.hasOwnProperty("keywordPlanNegativeKeyword")) {
                                var error = $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.verify(message.keywordPlanNegativeKeyword);
                                if (error)
                                    return "keywordPlanNegativeKeyword." + error;
                            }
                            if (message.keywordPlanAdGroup != null && message.hasOwnProperty("keywordPlanAdGroup")) {
                                var error = $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup.verify(message.keywordPlanAdGroup);
                                if (error)
                                    return "keywordPlanAdGroup." + error;
                            }
                            if (message.keywordPlanKeyword != null && message.hasOwnProperty("keywordPlanKeyword")) {
                                var error = $root.google.ads.googleads.v1.resources.KeywordPlanKeyword.verify(message.keywordPlanKeyword);
                                if (error)
                                    return "keywordPlanKeyword." + error;
                            }
                            if (message.label != null && message.hasOwnProperty("label")) {
                                var error = $root.google.ads.googleads.v1.resources.Label.verify(message.label);
                                if (error)
                                    return "label." + error;
                            }
                            if (message.landingPageView != null && message.hasOwnProperty("landingPageView")) {
                                var error = $root.google.ads.googleads.v1.resources.LandingPageView.verify(message.landingPageView);
                                if (error)
                                    return "landingPageView." + error;
                            }
                            if (message.languageConstant != null && message.hasOwnProperty("languageConstant")) {
                                var error = $root.google.ads.googleads.v1.resources.LanguageConstant.verify(message.languageConstant);
                                if (error)
                                    return "languageConstant." + error;
                            }
                            if (message.locationView != null && message.hasOwnProperty("locationView")) {
                                var error = $root.google.ads.googleads.v1.resources.LocationView.verify(message.locationView);
                                if (error)
                                    return "locationView." + error;
                            }
                            if (message.managedPlacementView != null && message.hasOwnProperty("managedPlacementView")) {
                                var error = $root.google.ads.googleads.v1.resources.ManagedPlacementView.verify(message.managedPlacementView);
                                if (error)
                                    return "managedPlacementView." + error;
                            }
                            if (message.mediaFile != null && message.hasOwnProperty("mediaFile")) {
                                var error = $root.google.ads.googleads.v1.resources.MediaFile.verify(message.mediaFile);
                                if (error)
                                    return "mediaFile." + error;
                            }
                            if (message.mobileAppCategoryConstant != null && message.hasOwnProperty("mobileAppCategoryConstant")) {
                                var error = $root.google.ads.googleads.v1.resources.MobileAppCategoryConstant.verify(message.mobileAppCategoryConstant);
                                if (error)
                                    return "mobileAppCategoryConstant." + error;
                            }
                            if (message.mobileDeviceConstant != null && message.hasOwnProperty("mobileDeviceConstant")) {
                                var error = $root.google.ads.googleads.v1.resources.MobileDeviceConstant.verify(message.mobileDeviceConstant);
                                if (error)
                                    return "mobileDeviceConstant." + error;
                            }
                            if (message.mutateJob != null && message.hasOwnProperty("mutateJob")) {
                                var error = $root.google.ads.googleads.v1.resources.MutateJob.verify(message.mutateJob);
                                if (error)
                                    return "mutateJob." + error;
                            }
                            if (message.operatingSystemVersionConstant != null && message.hasOwnProperty("operatingSystemVersionConstant")) {
                                var error = $root.google.ads.googleads.v1.resources.OperatingSystemVersionConstant.verify(message.operatingSystemVersionConstant);
                                if (error)
                                    return "operatingSystemVersionConstant." + error;
                            }
                            if (message.paidOrganicSearchTermView != null && message.hasOwnProperty("paidOrganicSearchTermView")) {
                                var error = $root.google.ads.googleads.v1.resources.PaidOrganicSearchTermView.verify(message.paidOrganicSearchTermView);
                                if (error)
                                    return "paidOrganicSearchTermView." + error;
                            }
                            if (message.parentalStatusView != null && message.hasOwnProperty("parentalStatusView")) {
                                var error = $root.google.ads.googleads.v1.resources.ParentalStatusView.verify(message.parentalStatusView);
                                if (error)
                                    return "parentalStatusView." + error;
                            }
                            if (message.productBiddingCategoryConstant != null && message.hasOwnProperty("productBiddingCategoryConstant")) {
                                var error = $root.google.ads.googleads.v1.resources.ProductBiddingCategoryConstant.verify(message.productBiddingCategoryConstant);
                                if (error)
                                    return "productBiddingCategoryConstant." + error;
                            }
                            if (message.productGroupView != null && message.hasOwnProperty("productGroupView")) {
                                var error = $root.google.ads.googleads.v1.resources.ProductGroupView.verify(message.productGroupView);
                                if (error)
                                    return "productGroupView." + error;
                            }
                            if (message.recommendation != null && message.hasOwnProperty("recommendation")) {
                                var error = $root.google.ads.googleads.v1.resources.Recommendation.verify(message.recommendation);
                                if (error)
                                    return "recommendation." + error;
                            }
                            if (message.searchTermView != null && message.hasOwnProperty("searchTermView")) {
                                var error = $root.google.ads.googleads.v1.resources.SearchTermView.verify(message.searchTermView);
                                if (error)
                                    return "searchTermView." + error;
                            }
                            if (message.sharedCriterion != null && message.hasOwnProperty("sharedCriterion")) {
                                var error = $root.google.ads.googleads.v1.resources.SharedCriterion.verify(message.sharedCriterion);
                                if (error)
                                    return "sharedCriterion." + error;
                            }
                            if (message.sharedSet != null && message.hasOwnProperty("sharedSet")) {
                                var error = $root.google.ads.googleads.v1.resources.SharedSet.verify(message.sharedSet);
                                if (error)
                                    return "sharedSet." + error;
                            }
                            if (message.shoppingPerformanceView != null && message.hasOwnProperty("shoppingPerformanceView")) {
                                var error = $root.google.ads.googleads.v1.resources.ShoppingPerformanceView.verify(message.shoppingPerformanceView);
                                if (error)
                                    return "shoppingPerformanceView." + error;
                            }
                            if (message.topicView != null && message.hasOwnProperty("topicView")) {
                                var error = $root.google.ads.googleads.v1.resources.TopicView.verify(message.topicView);
                                if (error)
                                    return "topicView." + error;
                            }
                            if (message.userInterest != null && message.hasOwnProperty("userInterest")) {
                                var error = $root.google.ads.googleads.v1.resources.UserInterest.verify(message.userInterest);
                                if (error)
                                    return "userInterest." + error;
                            }
                            if (message.userList != null && message.hasOwnProperty("userList")) {
                                var error = $root.google.ads.googleads.v1.resources.UserList.verify(message.userList);
                                if (error)
                                    return "userList." + error;
                            }
                            if (message.remarketingAction != null && message.hasOwnProperty("remarketingAction")) {
                                var error = $root.google.ads.googleads.v1.resources.RemarketingAction.verify(message.remarketingAction);
                                if (error)
                                    return "remarketingAction." + error;
                            }
                            if (message.topicConstant != null && message.hasOwnProperty("topicConstant")) {
                                var error = $root.google.ads.googleads.v1.resources.TopicConstant.verify(message.topicConstant);
                                if (error)
                                    return "topicConstant." + error;
                            }
                            if (message.video != null && message.hasOwnProperty("video")) {
                                var error = $root.google.ads.googleads.v1.resources.Video.verify(message.video);
                                if (error)
                                    return "video." + error;
                            }
                            if (message.metrics != null && message.hasOwnProperty("metrics")) {
                                var error = $root.google.ads.googleads.v1.common.Metrics.verify(message.metrics);
                                if (error)
                                    return "metrics." + error;
                            }
                            if (message.segments != null && message.hasOwnProperty("segments")) {
                                var error = $root.google.ads.googleads.v1.common.Segments.verify(message.segments);
                                if (error)
                                    return "segments." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a GoogleAdsRow message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GoogleAdsRow} GoogleAdsRow
                         */
                        GoogleAdsRow.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GoogleAdsRow)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GoogleAdsRow();
                            if (object.accountBudget != null) {
                                if (typeof object.accountBudget !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.accountBudget: object expected");
                                message.accountBudget = $root.google.ads.googleads.v1.resources.AccountBudget.fromObject(object.accountBudget);
                            }
                            if (object.accountBudgetProposal != null) {
                                if (typeof object.accountBudgetProposal !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.accountBudgetProposal: object expected");
                                message.accountBudgetProposal = $root.google.ads.googleads.v1.resources.AccountBudgetProposal.fromObject(object.accountBudgetProposal);
                            }
                            if (object.adGroup != null) {
                                if (typeof object.adGroup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.adGroup: object expected");
                                message.adGroup = $root.google.ads.googleads.v1.resources.AdGroup.fromObject(object.adGroup);
                            }
                            if (object.adGroupAd != null) {
                                if (typeof object.adGroupAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.adGroupAd: object expected");
                                message.adGroupAd = $root.google.ads.googleads.v1.resources.AdGroupAd.fromObject(object.adGroupAd);
                            }
                            if (object.adGroupAdLabel != null) {
                                if (typeof object.adGroupAdLabel !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.adGroupAdLabel: object expected");
                                message.adGroupAdLabel = $root.google.ads.googleads.v1.resources.AdGroupAdLabel.fromObject(object.adGroupAdLabel);
                            }
                            if (object.adGroupAudienceView != null) {
                                if (typeof object.adGroupAudienceView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.adGroupAudienceView: object expected");
                                message.adGroupAudienceView = $root.google.ads.googleads.v1.resources.AdGroupAudienceView.fromObject(object.adGroupAudienceView);
                            }
                            if (object.adGroupBidModifier != null) {
                                if (typeof object.adGroupBidModifier !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.adGroupBidModifier: object expected");
                                message.adGroupBidModifier = $root.google.ads.googleads.v1.resources.AdGroupBidModifier.fromObject(object.adGroupBidModifier);
                            }
                            if (object.adGroupCriterion != null) {
                                if (typeof object.adGroupCriterion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.adGroupCriterion: object expected");
                                message.adGroupCriterion = $root.google.ads.googleads.v1.resources.AdGroupCriterion.fromObject(object.adGroupCriterion);
                            }
                            if (object.adGroupCriterionLabel != null) {
                                if (typeof object.adGroupCriterionLabel !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.adGroupCriterionLabel: object expected");
                                message.adGroupCriterionLabel = $root.google.ads.googleads.v1.resources.AdGroupCriterionLabel.fromObject(object.adGroupCriterionLabel);
                            }
                            if (object.adGroupCriterionSimulation != null) {
                                if (typeof object.adGroupCriterionSimulation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.adGroupCriterionSimulation: object expected");
                                message.adGroupCriterionSimulation = $root.google.ads.googleads.v1.resources.AdGroupCriterionSimulation.fromObject(object.adGroupCriterionSimulation);
                            }
                            if (object.adGroupExtensionSetting != null) {
                                if (typeof object.adGroupExtensionSetting !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.adGroupExtensionSetting: object expected");
                                message.adGroupExtensionSetting = $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting.fromObject(object.adGroupExtensionSetting);
                            }
                            if (object.adGroupFeed != null) {
                                if (typeof object.adGroupFeed !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.adGroupFeed: object expected");
                                message.adGroupFeed = $root.google.ads.googleads.v1.resources.AdGroupFeed.fromObject(object.adGroupFeed);
                            }
                            if (object.adGroupLabel != null) {
                                if (typeof object.adGroupLabel !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.adGroupLabel: object expected");
                                message.adGroupLabel = $root.google.ads.googleads.v1.resources.AdGroupLabel.fromObject(object.adGroupLabel);
                            }
                            if (object.adGroupSimulation != null) {
                                if (typeof object.adGroupSimulation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.adGroupSimulation: object expected");
                                message.adGroupSimulation = $root.google.ads.googleads.v1.resources.AdGroupSimulation.fromObject(object.adGroupSimulation);
                            }
                            if (object.adParameter != null) {
                                if (typeof object.adParameter !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.adParameter: object expected");
                                message.adParameter = $root.google.ads.googleads.v1.resources.AdParameter.fromObject(object.adParameter);
                            }
                            if (object.ageRangeView != null) {
                                if (typeof object.ageRangeView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.ageRangeView: object expected");
                                message.ageRangeView = $root.google.ads.googleads.v1.resources.AgeRangeView.fromObject(object.ageRangeView);
                            }
                            if (object.adScheduleView != null) {
                                if (typeof object.adScheduleView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.adScheduleView: object expected");
                                message.adScheduleView = $root.google.ads.googleads.v1.resources.AdScheduleView.fromObject(object.adScheduleView);
                            }
                            if (object.domainCategory != null) {
                                if (typeof object.domainCategory !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.domainCategory: object expected");
                                message.domainCategory = $root.google.ads.googleads.v1.resources.DomainCategory.fromObject(object.domainCategory);
                            }
                            if (object.asset != null) {
                                if (typeof object.asset !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.asset: object expected");
                                message.asset = $root.google.ads.googleads.v1.resources.Asset.fromObject(object.asset);
                            }
                            if (object.biddingStrategy != null) {
                                if (typeof object.biddingStrategy !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.biddingStrategy: object expected");
                                message.biddingStrategy = $root.google.ads.googleads.v1.resources.BiddingStrategy.fromObject(object.biddingStrategy);
                            }
                            if (object.billingSetup != null) {
                                if (typeof object.billingSetup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.billingSetup: object expected");
                                message.billingSetup = $root.google.ads.googleads.v1.resources.BillingSetup.fromObject(object.billingSetup);
                            }
                            if (object.campaignBudget != null) {
                                if (typeof object.campaignBudget !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.campaignBudget: object expected");
                                message.campaignBudget = $root.google.ads.googleads.v1.resources.CampaignBudget.fromObject(object.campaignBudget);
                            }
                            if (object.campaign != null) {
                                if (typeof object.campaign !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.campaign: object expected");
                                message.campaign = $root.google.ads.googleads.v1.resources.Campaign.fromObject(object.campaign);
                            }
                            if (object.campaignAudienceView != null) {
                                if (typeof object.campaignAudienceView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.campaignAudienceView: object expected");
                                message.campaignAudienceView = $root.google.ads.googleads.v1.resources.CampaignAudienceView.fromObject(object.campaignAudienceView);
                            }
                            if (object.campaignBidModifier != null) {
                                if (typeof object.campaignBidModifier !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.campaignBidModifier: object expected");
                                message.campaignBidModifier = $root.google.ads.googleads.v1.resources.CampaignBidModifier.fromObject(object.campaignBidModifier);
                            }
                            if (object.campaignCriterion != null) {
                                if (typeof object.campaignCriterion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.campaignCriterion: object expected");
                                message.campaignCriterion = $root.google.ads.googleads.v1.resources.CampaignCriterion.fromObject(object.campaignCriterion);
                            }
                            if (object.campaignCriterionSimulation != null) {
                                if (typeof object.campaignCriterionSimulation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.campaignCriterionSimulation: object expected");
                                message.campaignCriterionSimulation = $root.google.ads.googleads.v1.resources.CampaignCriterionSimulation.fromObject(object.campaignCriterionSimulation);
                            }
                            if (object.campaignExtensionSetting != null) {
                                if (typeof object.campaignExtensionSetting !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.campaignExtensionSetting: object expected");
                                message.campaignExtensionSetting = $root.google.ads.googleads.v1.resources.CampaignExtensionSetting.fromObject(object.campaignExtensionSetting);
                            }
                            if (object.campaignFeed != null) {
                                if (typeof object.campaignFeed !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.campaignFeed: object expected");
                                message.campaignFeed = $root.google.ads.googleads.v1.resources.CampaignFeed.fromObject(object.campaignFeed);
                            }
                            if (object.campaignLabel != null) {
                                if (typeof object.campaignLabel !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.campaignLabel: object expected");
                                message.campaignLabel = $root.google.ads.googleads.v1.resources.CampaignLabel.fromObject(object.campaignLabel);
                            }
                            if (object.campaignSharedSet != null) {
                                if (typeof object.campaignSharedSet !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.campaignSharedSet: object expected");
                                message.campaignSharedSet = $root.google.ads.googleads.v1.resources.CampaignSharedSet.fromObject(object.campaignSharedSet);
                            }
                            if (object.carrierConstant != null) {
                                if (typeof object.carrierConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.carrierConstant: object expected");
                                message.carrierConstant = $root.google.ads.googleads.v1.resources.CarrierConstant.fromObject(object.carrierConstant);
                            }
                            if (object.changeStatus != null) {
                                if (typeof object.changeStatus !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.changeStatus: object expected");
                                message.changeStatus = $root.google.ads.googleads.v1.resources.ChangeStatus.fromObject(object.changeStatus);
                            }
                            if (object.conversionAction != null) {
                                if (typeof object.conversionAction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.conversionAction: object expected");
                                message.conversionAction = $root.google.ads.googleads.v1.resources.ConversionAction.fromObject(object.conversionAction);
                            }
                            if (object.clickView != null) {
                                if (typeof object.clickView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.clickView: object expected");
                                message.clickView = $root.google.ads.googleads.v1.resources.ClickView.fromObject(object.clickView);
                            }
                            if (object.customInterest != null) {
                                if (typeof object.customInterest !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.customInterest: object expected");
                                message.customInterest = $root.google.ads.googleads.v1.resources.CustomInterest.fromObject(object.customInterest);
                            }
                            if (object.customer != null) {
                                if (typeof object.customer !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.customer: object expected");
                                message.customer = $root.google.ads.googleads.v1.resources.Customer.fromObject(object.customer);
                            }
                            if (object.customerManagerLink != null) {
                                if (typeof object.customerManagerLink !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.customerManagerLink: object expected");
                                message.customerManagerLink = $root.google.ads.googleads.v1.resources.CustomerManagerLink.fromObject(object.customerManagerLink);
                            }
                            if (object.customerClientLink != null) {
                                if (typeof object.customerClientLink !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.customerClientLink: object expected");
                                message.customerClientLink = $root.google.ads.googleads.v1.resources.CustomerClientLink.fromObject(object.customerClientLink);
                            }
                            if (object.customerClient != null) {
                                if (typeof object.customerClient !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.customerClient: object expected");
                                message.customerClient = $root.google.ads.googleads.v1.resources.CustomerClient.fromObject(object.customerClient);
                            }
                            if (object.customerExtensionSetting != null) {
                                if (typeof object.customerExtensionSetting !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.customerExtensionSetting: object expected");
                                message.customerExtensionSetting = $root.google.ads.googleads.v1.resources.CustomerExtensionSetting.fromObject(object.customerExtensionSetting);
                            }
                            if (object.customerFeed != null) {
                                if (typeof object.customerFeed !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.customerFeed: object expected");
                                message.customerFeed = $root.google.ads.googleads.v1.resources.CustomerFeed.fromObject(object.customerFeed);
                            }
                            if (object.customerLabel != null) {
                                if (typeof object.customerLabel !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.customerLabel: object expected");
                                message.customerLabel = $root.google.ads.googleads.v1.resources.CustomerLabel.fromObject(object.customerLabel);
                            }
                            if (object.customerNegativeCriterion != null) {
                                if (typeof object.customerNegativeCriterion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.customerNegativeCriterion: object expected");
                                message.customerNegativeCriterion = $root.google.ads.googleads.v1.resources.CustomerNegativeCriterion.fromObject(object.customerNegativeCriterion);
                            }
                            if (object.detailPlacementView != null) {
                                if (typeof object.detailPlacementView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.detailPlacementView: object expected");
                                message.detailPlacementView = $root.google.ads.googleads.v1.resources.DetailPlacementView.fromObject(object.detailPlacementView);
                            }
                            if (object.displayKeywordView != null) {
                                if (typeof object.displayKeywordView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.displayKeywordView: object expected");
                                message.displayKeywordView = $root.google.ads.googleads.v1.resources.DisplayKeywordView.fromObject(object.displayKeywordView);
                            }
                            if (object.dynamicSearchAdsSearchTermView != null) {
                                if (typeof object.dynamicSearchAdsSearchTermView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.dynamicSearchAdsSearchTermView: object expected");
                                message.dynamicSearchAdsSearchTermView = $root.google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView.fromObject(object.dynamicSearchAdsSearchTermView);
                            }
                            if (object.expandedLandingPageView != null) {
                                if (typeof object.expandedLandingPageView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.expandedLandingPageView: object expected");
                                message.expandedLandingPageView = $root.google.ads.googleads.v1.resources.ExpandedLandingPageView.fromObject(object.expandedLandingPageView);
                            }
                            if (object.extensionFeedItem != null) {
                                if (typeof object.extensionFeedItem !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.extensionFeedItem: object expected");
                                message.extensionFeedItem = $root.google.ads.googleads.v1.resources.ExtensionFeedItem.fromObject(object.extensionFeedItem);
                            }
                            if (object.feed != null) {
                                if (typeof object.feed !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.feed: object expected");
                                message.feed = $root.google.ads.googleads.v1.resources.Feed.fromObject(object.feed);
                            }
                            if (object.feedItem != null) {
                                if (typeof object.feedItem !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.feedItem: object expected");
                                message.feedItem = $root.google.ads.googleads.v1.resources.FeedItem.fromObject(object.feedItem);
                            }
                            if (object.feedItemTarget != null) {
                                if (typeof object.feedItemTarget !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.feedItemTarget: object expected");
                                message.feedItemTarget = $root.google.ads.googleads.v1.resources.FeedItemTarget.fromObject(object.feedItemTarget);
                            }
                            if (object.feedMapping != null) {
                                if (typeof object.feedMapping !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.feedMapping: object expected");
                                message.feedMapping = $root.google.ads.googleads.v1.resources.FeedMapping.fromObject(object.feedMapping);
                            }
                            if (object.feedPlaceholderView != null) {
                                if (typeof object.feedPlaceholderView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.feedPlaceholderView: object expected");
                                message.feedPlaceholderView = $root.google.ads.googleads.v1.resources.FeedPlaceholderView.fromObject(object.feedPlaceholderView);
                            }
                            if (object.genderView != null) {
                                if (typeof object.genderView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.genderView: object expected");
                                message.genderView = $root.google.ads.googleads.v1.resources.GenderView.fromObject(object.genderView);
                            }
                            if (object.geoTargetConstant != null) {
                                if (typeof object.geoTargetConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.geoTargetConstant: object expected");
                                message.geoTargetConstant = $root.google.ads.googleads.v1.resources.GeoTargetConstant.fromObject(object.geoTargetConstant);
                            }
                            if (object.geographicView != null) {
                                if (typeof object.geographicView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.geographicView: object expected");
                                message.geographicView = $root.google.ads.googleads.v1.resources.GeographicView.fromObject(object.geographicView);
                            }
                            if (object.groupPlacementView != null) {
                                if (typeof object.groupPlacementView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.groupPlacementView: object expected");
                                message.groupPlacementView = $root.google.ads.googleads.v1.resources.GroupPlacementView.fromObject(object.groupPlacementView);
                            }
                            if (object.hotelGroupView != null) {
                                if (typeof object.hotelGroupView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.hotelGroupView: object expected");
                                message.hotelGroupView = $root.google.ads.googleads.v1.resources.HotelGroupView.fromObject(object.hotelGroupView);
                            }
                            if (object.hotelPerformanceView != null) {
                                if (typeof object.hotelPerformanceView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.hotelPerformanceView: object expected");
                                message.hotelPerformanceView = $root.google.ads.googleads.v1.resources.HotelPerformanceView.fromObject(object.hotelPerformanceView);
                            }
                            if (object.keywordView != null) {
                                if (typeof object.keywordView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.keywordView: object expected");
                                message.keywordView = $root.google.ads.googleads.v1.resources.KeywordView.fromObject(object.keywordView);
                            }
                            if (object.keywordPlan != null) {
                                if (typeof object.keywordPlan !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.keywordPlan: object expected");
                                message.keywordPlan = $root.google.ads.googleads.v1.resources.KeywordPlan.fromObject(object.keywordPlan);
                            }
                            if (object.keywordPlanCampaign != null) {
                                if (typeof object.keywordPlanCampaign !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.keywordPlanCampaign: object expected");
                                message.keywordPlanCampaign = $root.google.ads.googleads.v1.resources.KeywordPlanCampaign.fromObject(object.keywordPlanCampaign);
                            }
                            if (object.keywordPlanNegativeKeyword != null) {
                                if (typeof object.keywordPlanNegativeKeyword !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.keywordPlanNegativeKeyword: object expected");
                                message.keywordPlanNegativeKeyword = $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.fromObject(object.keywordPlanNegativeKeyword);
                            }
                            if (object.keywordPlanAdGroup != null) {
                                if (typeof object.keywordPlanAdGroup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.keywordPlanAdGroup: object expected");
                                message.keywordPlanAdGroup = $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup.fromObject(object.keywordPlanAdGroup);
                            }
                            if (object.keywordPlanKeyword != null) {
                                if (typeof object.keywordPlanKeyword !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.keywordPlanKeyword: object expected");
                                message.keywordPlanKeyword = $root.google.ads.googleads.v1.resources.KeywordPlanKeyword.fromObject(object.keywordPlanKeyword);
                            }
                            if (object.label != null) {
                                if (typeof object.label !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.label: object expected");
                                message.label = $root.google.ads.googleads.v1.resources.Label.fromObject(object.label);
                            }
                            if (object.landingPageView != null) {
                                if (typeof object.landingPageView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.landingPageView: object expected");
                                message.landingPageView = $root.google.ads.googleads.v1.resources.LandingPageView.fromObject(object.landingPageView);
                            }
                            if (object.languageConstant != null) {
                                if (typeof object.languageConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.languageConstant: object expected");
                                message.languageConstant = $root.google.ads.googleads.v1.resources.LanguageConstant.fromObject(object.languageConstant);
                            }
                            if (object.locationView != null) {
                                if (typeof object.locationView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.locationView: object expected");
                                message.locationView = $root.google.ads.googleads.v1.resources.LocationView.fromObject(object.locationView);
                            }
                            if (object.managedPlacementView != null) {
                                if (typeof object.managedPlacementView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.managedPlacementView: object expected");
                                message.managedPlacementView = $root.google.ads.googleads.v1.resources.ManagedPlacementView.fromObject(object.managedPlacementView);
                            }
                            if (object.mediaFile != null) {
                                if (typeof object.mediaFile !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.mediaFile: object expected");
                                message.mediaFile = $root.google.ads.googleads.v1.resources.MediaFile.fromObject(object.mediaFile);
                            }
                            if (object.mobileAppCategoryConstant != null) {
                                if (typeof object.mobileAppCategoryConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.mobileAppCategoryConstant: object expected");
                                message.mobileAppCategoryConstant = $root.google.ads.googleads.v1.resources.MobileAppCategoryConstant.fromObject(object.mobileAppCategoryConstant);
                            }
                            if (object.mobileDeviceConstant != null) {
                                if (typeof object.mobileDeviceConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.mobileDeviceConstant: object expected");
                                message.mobileDeviceConstant = $root.google.ads.googleads.v1.resources.MobileDeviceConstant.fromObject(object.mobileDeviceConstant);
                            }
                            if (object.mutateJob != null) {
                                if (typeof object.mutateJob !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.mutateJob: object expected");
                                message.mutateJob = $root.google.ads.googleads.v1.resources.MutateJob.fromObject(object.mutateJob);
                            }
                            if (object.operatingSystemVersionConstant != null) {
                                if (typeof object.operatingSystemVersionConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.operatingSystemVersionConstant: object expected");
                                message.operatingSystemVersionConstant = $root.google.ads.googleads.v1.resources.OperatingSystemVersionConstant.fromObject(object.operatingSystemVersionConstant);
                            }
                            if (object.paidOrganicSearchTermView != null) {
                                if (typeof object.paidOrganicSearchTermView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.paidOrganicSearchTermView: object expected");
                                message.paidOrganicSearchTermView = $root.google.ads.googleads.v1.resources.PaidOrganicSearchTermView.fromObject(object.paidOrganicSearchTermView);
                            }
                            if (object.parentalStatusView != null) {
                                if (typeof object.parentalStatusView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.parentalStatusView: object expected");
                                message.parentalStatusView = $root.google.ads.googleads.v1.resources.ParentalStatusView.fromObject(object.parentalStatusView);
                            }
                            if (object.productBiddingCategoryConstant != null) {
                                if (typeof object.productBiddingCategoryConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.productBiddingCategoryConstant: object expected");
                                message.productBiddingCategoryConstant = $root.google.ads.googleads.v1.resources.ProductBiddingCategoryConstant.fromObject(object.productBiddingCategoryConstant);
                            }
                            if (object.productGroupView != null) {
                                if (typeof object.productGroupView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.productGroupView: object expected");
                                message.productGroupView = $root.google.ads.googleads.v1.resources.ProductGroupView.fromObject(object.productGroupView);
                            }
                            if (object.recommendation != null) {
                                if (typeof object.recommendation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.recommendation: object expected");
                                message.recommendation = $root.google.ads.googleads.v1.resources.Recommendation.fromObject(object.recommendation);
                            }
                            if (object.searchTermView != null) {
                                if (typeof object.searchTermView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.searchTermView: object expected");
                                message.searchTermView = $root.google.ads.googleads.v1.resources.SearchTermView.fromObject(object.searchTermView);
                            }
                            if (object.sharedCriterion != null) {
                                if (typeof object.sharedCriterion !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.sharedCriterion: object expected");
                                message.sharedCriterion = $root.google.ads.googleads.v1.resources.SharedCriterion.fromObject(object.sharedCriterion);
                            }
                            if (object.sharedSet != null) {
                                if (typeof object.sharedSet !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.sharedSet: object expected");
                                message.sharedSet = $root.google.ads.googleads.v1.resources.SharedSet.fromObject(object.sharedSet);
                            }
                            if (object.shoppingPerformanceView != null) {
                                if (typeof object.shoppingPerformanceView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.shoppingPerformanceView: object expected");
                                message.shoppingPerformanceView = $root.google.ads.googleads.v1.resources.ShoppingPerformanceView.fromObject(object.shoppingPerformanceView);
                            }
                            if (object.topicView != null) {
                                if (typeof object.topicView !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.topicView: object expected");
                                message.topicView = $root.google.ads.googleads.v1.resources.TopicView.fromObject(object.topicView);
                            }
                            if (object.userInterest != null) {
                                if (typeof object.userInterest !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.userInterest: object expected");
                                message.userInterest = $root.google.ads.googleads.v1.resources.UserInterest.fromObject(object.userInterest);
                            }
                            if (object.userList != null) {
                                if (typeof object.userList !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.userList: object expected");
                                message.userList = $root.google.ads.googleads.v1.resources.UserList.fromObject(object.userList);
                            }
                            if (object.remarketingAction != null) {
                                if (typeof object.remarketingAction !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.remarketingAction: object expected");
                                message.remarketingAction = $root.google.ads.googleads.v1.resources.RemarketingAction.fromObject(object.remarketingAction);
                            }
                            if (object.topicConstant != null) {
                                if (typeof object.topicConstant !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.topicConstant: object expected");
                                message.topicConstant = $root.google.ads.googleads.v1.resources.TopicConstant.fromObject(object.topicConstant);
                            }
                            if (object.video != null) {
                                if (typeof object.video !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.video: object expected");
                                message.video = $root.google.ads.googleads.v1.resources.Video.fromObject(object.video);
                            }
                            if (object.metrics != null) {
                                if (typeof object.metrics !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.metrics: object expected");
                                message.metrics = $root.google.ads.googleads.v1.common.Metrics.fromObject(object.metrics);
                            }
                            if (object.segments != null) {
                                if (typeof object.segments !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GoogleAdsRow.segments: object expected");
                                message.segments = $root.google.ads.googleads.v1.common.Segments.fromObject(object.segments);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a GoogleAdsRow message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @static
                         * @param {google.ads.googleads.v1.services.GoogleAdsRow} message GoogleAdsRow
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GoogleAdsRow.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.customer = null;
                                object.campaign = null;
                                object.adGroup = null;
                                object.metrics = null;
                                object.adGroupAd = null;
                                object.adGroupCriterion = null;
                                object.biddingStrategy = null;
                                object.campaignBudget = null;
                                object.campaignCriterion = null;
                                object.keywordView = null;
                                object.recommendation = null;
                                object.geoTargetConstant = null;
                                object.adGroupBidModifier = null;
                                object.campaignBidModifier = null;
                                object.sharedSet = null;
                                object.sharedCriterion = null;
                                object.campaignSharedSet = null;
                                object.topicConstant = null;
                                object.keywordPlan = null;
                                object.keywordPlanCampaign = null;
                                object.keywordPlanNegativeKeyword = null;
                                object.keywordPlanAdGroup = null;
                                object.keywordPlanKeyword = null;
                                object.changeStatus = null;
                                object.userList = null;
                                object.video = null;
                                object.genderView = null;
                                object.billingSetup = null;
                                object.accountBudget = null;
                                object.accountBudgetProposal = null;
                                object.topicView = null;
                                object.parentalStatusView = null;
                                object.feed = null;
                                object.displayKeywordView = null;
                                object.ageRangeView = null;
                                object.feedItem = null;
                                object.hotelGroupView = null;
                                object.label = null;
                                object.managedPlacementView = null;
                                object.productGroupView = null;
                                object.languageConstant = null;
                                object.adGroupAudienceView = null;
                                object.feedMapping = null;
                                object.userInterest = null;
                                object.remarketingAction = null;
                                object.customerManagerLink = null;
                                object.customerClientLink = null;
                                object.campaignFeed = null;
                                object.customerFeed = null;
                                object.carrierConstant = null;
                                object.adGroupFeed = null;
                                object.searchTermView = null;
                                object.campaignAudienceView = null;
                                object.customerClient = null;
                                object.hotelPerformanceView = null;
                                object.extensionFeedItem = null;
                                object.operatingSystemVersionConstant = null;
                                object.mobileAppCategoryConstant = null;
                                object.customerNegativeCriterion = null;
                                object.adScheduleView = null;
                                object.mediaFile = null;
                                object.domainCategory = null;
                                object.feedPlaceholderView = null;
                                object.mobileDeviceConstant = null;
                                object.segments = null;
                                object.conversionAction = null;
                                object.customInterest = null;
                                object.asset = null;
                                object.dynamicSearchAdsSearchTermView = null;
                                object.adGroupSimulation = null;
                                object.campaignLabel = null;
                                object.productBiddingCategoryConstant = null;
                                object.adGroupCriterionSimulation = null;
                                object.campaignCriterionSimulation = null;
                                object.adGroupExtensionSetting = null;
                                object.campaignExtensionSetting = null;
                                object.customerExtensionSetting = null;
                                object.adGroupLabel = null;
                                object.feedItemTarget = null;
                                object.shoppingPerformanceView = null;
                                object.detailPlacementView = null;
                                object.groupPlacementView = null;
                                object.adGroupAdLabel = null;
                                object.adGroupCriterionLabel = null;
                                object.clickView = null;
                                object.locationView = null;
                                object.customerLabel = null;
                                object.geographicView = null;
                                object.landingPageView = null;
                                object.mutateJob = null;
                                object.expandedLandingPageView = null;
                                object.paidOrganicSearchTermView = null;
                                object.adParameter = null;
                            }
                            if (message.customer != null && message.hasOwnProperty("customer"))
                                object.customer = $root.google.ads.googleads.v1.resources.Customer.toObject(message.customer, options);
                            if (message.campaign != null && message.hasOwnProperty("campaign"))
                                object.campaign = $root.google.ads.googleads.v1.resources.Campaign.toObject(message.campaign, options);
                            if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                object.adGroup = $root.google.ads.googleads.v1.resources.AdGroup.toObject(message.adGroup, options);
                            if (message.metrics != null && message.hasOwnProperty("metrics"))
                                object.metrics = $root.google.ads.googleads.v1.common.Metrics.toObject(message.metrics, options);
                            if (message.adGroupAd != null && message.hasOwnProperty("adGroupAd"))
                                object.adGroupAd = $root.google.ads.googleads.v1.resources.AdGroupAd.toObject(message.adGroupAd, options);
                            if (message.adGroupCriterion != null && message.hasOwnProperty("adGroupCriterion"))
                                object.adGroupCriterion = $root.google.ads.googleads.v1.resources.AdGroupCriterion.toObject(message.adGroupCriterion, options);
                            if (message.biddingStrategy != null && message.hasOwnProperty("biddingStrategy"))
                                object.biddingStrategy = $root.google.ads.googleads.v1.resources.BiddingStrategy.toObject(message.biddingStrategy, options);
                            if (message.campaignBudget != null && message.hasOwnProperty("campaignBudget"))
                                object.campaignBudget = $root.google.ads.googleads.v1.resources.CampaignBudget.toObject(message.campaignBudget, options);
                            if (message.campaignCriterion != null && message.hasOwnProperty("campaignCriterion"))
                                object.campaignCriterion = $root.google.ads.googleads.v1.resources.CampaignCriterion.toObject(message.campaignCriterion, options);
                            if (message.keywordView != null && message.hasOwnProperty("keywordView"))
                                object.keywordView = $root.google.ads.googleads.v1.resources.KeywordView.toObject(message.keywordView, options);
                            if (message.recommendation != null && message.hasOwnProperty("recommendation"))
                                object.recommendation = $root.google.ads.googleads.v1.resources.Recommendation.toObject(message.recommendation, options);
                            if (message.geoTargetConstant != null && message.hasOwnProperty("geoTargetConstant"))
                                object.geoTargetConstant = $root.google.ads.googleads.v1.resources.GeoTargetConstant.toObject(message.geoTargetConstant, options);
                            if (message.adGroupBidModifier != null && message.hasOwnProperty("adGroupBidModifier"))
                                object.adGroupBidModifier = $root.google.ads.googleads.v1.resources.AdGroupBidModifier.toObject(message.adGroupBidModifier, options);
                            if (message.campaignBidModifier != null && message.hasOwnProperty("campaignBidModifier"))
                                object.campaignBidModifier = $root.google.ads.googleads.v1.resources.CampaignBidModifier.toObject(message.campaignBidModifier, options);
                            if (message.sharedSet != null && message.hasOwnProperty("sharedSet"))
                                object.sharedSet = $root.google.ads.googleads.v1.resources.SharedSet.toObject(message.sharedSet, options);
                            if (message.sharedCriterion != null && message.hasOwnProperty("sharedCriterion"))
                                object.sharedCriterion = $root.google.ads.googleads.v1.resources.SharedCriterion.toObject(message.sharedCriterion, options);
                            if (message.campaignSharedSet != null && message.hasOwnProperty("campaignSharedSet"))
                                object.campaignSharedSet = $root.google.ads.googleads.v1.resources.CampaignSharedSet.toObject(message.campaignSharedSet, options);
                            if (message.topicConstant != null && message.hasOwnProperty("topicConstant"))
                                object.topicConstant = $root.google.ads.googleads.v1.resources.TopicConstant.toObject(message.topicConstant, options);
                            if (message.keywordPlan != null && message.hasOwnProperty("keywordPlan"))
                                object.keywordPlan = $root.google.ads.googleads.v1.resources.KeywordPlan.toObject(message.keywordPlan, options);
                            if (message.keywordPlanCampaign != null && message.hasOwnProperty("keywordPlanCampaign"))
                                object.keywordPlanCampaign = $root.google.ads.googleads.v1.resources.KeywordPlanCampaign.toObject(message.keywordPlanCampaign, options);
                            if (message.keywordPlanNegativeKeyword != null && message.hasOwnProperty("keywordPlanNegativeKeyword"))
                                object.keywordPlanNegativeKeyword = $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.toObject(message.keywordPlanNegativeKeyword, options);
                            if (message.keywordPlanAdGroup != null && message.hasOwnProperty("keywordPlanAdGroup"))
                                object.keywordPlanAdGroup = $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup.toObject(message.keywordPlanAdGroup, options);
                            if (message.keywordPlanKeyword != null && message.hasOwnProperty("keywordPlanKeyword"))
                                object.keywordPlanKeyword = $root.google.ads.googleads.v1.resources.KeywordPlanKeyword.toObject(message.keywordPlanKeyword, options);
                            if (message.changeStatus != null && message.hasOwnProperty("changeStatus"))
                                object.changeStatus = $root.google.ads.googleads.v1.resources.ChangeStatus.toObject(message.changeStatus, options);
                            if (message.userList != null && message.hasOwnProperty("userList"))
                                object.userList = $root.google.ads.googleads.v1.resources.UserList.toObject(message.userList, options);
                            if (message.video != null && message.hasOwnProperty("video"))
                                object.video = $root.google.ads.googleads.v1.resources.Video.toObject(message.video, options);
                            if (message.genderView != null && message.hasOwnProperty("genderView"))
                                object.genderView = $root.google.ads.googleads.v1.resources.GenderView.toObject(message.genderView, options);
                            if (message.billingSetup != null && message.hasOwnProperty("billingSetup"))
                                object.billingSetup = $root.google.ads.googleads.v1.resources.BillingSetup.toObject(message.billingSetup, options);
                            if (message.accountBudget != null && message.hasOwnProperty("accountBudget"))
                                object.accountBudget = $root.google.ads.googleads.v1.resources.AccountBudget.toObject(message.accountBudget, options);
                            if (message.accountBudgetProposal != null && message.hasOwnProperty("accountBudgetProposal"))
                                object.accountBudgetProposal = $root.google.ads.googleads.v1.resources.AccountBudgetProposal.toObject(message.accountBudgetProposal, options);
                            if (message.topicView != null && message.hasOwnProperty("topicView"))
                                object.topicView = $root.google.ads.googleads.v1.resources.TopicView.toObject(message.topicView, options);
                            if (message.parentalStatusView != null && message.hasOwnProperty("parentalStatusView"))
                                object.parentalStatusView = $root.google.ads.googleads.v1.resources.ParentalStatusView.toObject(message.parentalStatusView, options);
                            if (message.feed != null && message.hasOwnProperty("feed"))
                                object.feed = $root.google.ads.googleads.v1.resources.Feed.toObject(message.feed, options);
                            if (message.displayKeywordView != null && message.hasOwnProperty("displayKeywordView"))
                                object.displayKeywordView = $root.google.ads.googleads.v1.resources.DisplayKeywordView.toObject(message.displayKeywordView, options);
                            if (message.ageRangeView != null && message.hasOwnProperty("ageRangeView"))
                                object.ageRangeView = $root.google.ads.googleads.v1.resources.AgeRangeView.toObject(message.ageRangeView, options);
                            if (message.feedItem != null && message.hasOwnProperty("feedItem"))
                                object.feedItem = $root.google.ads.googleads.v1.resources.FeedItem.toObject(message.feedItem, options);
                            if (message.hotelGroupView != null && message.hasOwnProperty("hotelGroupView"))
                                object.hotelGroupView = $root.google.ads.googleads.v1.resources.HotelGroupView.toObject(message.hotelGroupView, options);
                            if (message.label != null && message.hasOwnProperty("label"))
                                object.label = $root.google.ads.googleads.v1.resources.Label.toObject(message.label, options);
                            if (message.managedPlacementView != null && message.hasOwnProperty("managedPlacementView"))
                                object.managedPlacementView = $root.google.ads.googleads.v1.resources.ManagedPlacementView.toObject(message.managedPlacementView, options);
                            if (message.productGroupView != null && message.hasOwnProperty("productGroupView"))
                                object.productGroupView = $root.google.ads.googleads.v1.resources.ProductGroupView.toObject(message.productGroupView, options);
                            if (message.languageConstant != null && message.hasOwnProperty("languageConstant"))
                                object.languageConstant = $root.google.ads.googleads.v1.resources.LanguageConstant.toObject(message.languageConstant, options);
                            if (message.adGroupAudienceView != null && message.hasOwnProperty("adGroupAudienceView"))
                                object.adGroupAudienceView = $root.google.ads.googleads.v1.resources.AdGroupAudienceView.toObject(message.adGroupAudienceView, options);
                            if (message.feedMapping != null && message.hasOwnProperty("feedMapping"))
                                object.feedMapping = $root.google.ads.googleads.v1.resources.FeedMapping.toObject(message.feedMapping, options);
                            if (message.userInterest != null && message.hasOwnProperty("userInterest"))
                                object.userInterest = $root.google.ads.googleads.v1.resources.UserInterest.toObject(message.userInterest, options);
                            if (message.remarketingAction != null && message.hasOwnProperty("remarketingAction"))
                                object.remarketingAction = $root.google.ads.googleads.v1.resources.RemarketingAction.toObject(message.remarketingAction, options);
                            if (message.customerManagerLink != null && message.hasOwnProperty("customerManagerLink"))
                                object.customerManagerLink = $root.google.ads.googleads.v1.resources.CustomerManagerLink.toObject(message.customerManagerLink, options);
                            if (message.customerClientLink != null && message.hasOwnProperty("customerClientLink"))
                                object.customerClientLink = $root.google.ads.googleads.v1.resources.CustomerClientLink.toObject(message.customerClientLink, options);
                            if (message.campaignFeed != null && message.hasOwnProperty("campaignFeed"))
                                object.campaignFeed = $root.google.ads.googleads.v1.resources.CampaignFeed.toObject(message.campaignFeed, options);
                            if (message.customerFeed != null && message.hasOwnProperty("customerFeed"))
                                object.customerFeed = $root.google.ads.googleads.v1.resources.CustomerFeed.toObject(message.customerFeed, options);
                            if (message.carrierConstant != null && message.hasOwnProperty("carrierConstant"))
                                object.carrierConstant = $root.google.ads.googleads.v1.resources.CarrierConstant.toObject(message.carrierConstant, options);
                            if (message.adGroupFeed != null && message.hasOwnProperty("adGroupFeed"))
                                object.adGroupFeed = $root.google.ads.googleads.v1.resources.AdGroupFeed.toObject(message.adGroupFeed, options);
                            if (message.searchTermView != null && message.hasOwnProperty("searchTermView"))
                                object.searchTermView = $root.google.ads.googleads.v1.resources.SearchTermView.toObject(message.searchTermView, options);
                            if (message.campaignAudienceView != null && message.hasOwnProperty("campaignAudienceView"))
                                object.campaignAudienceView = $root.google.ads.googleads.v1.resources.CampaignAudienceView.toObject(message.campaignAudienceView, options);
                            if (message.customerClient != null && message.hasOwnProperty("customerClient"))
                                object.customerClient = $root.google.ads.googleads.v1.resources.CustomerClient.toObject(message.customerClient, options);
                            if (message.hotelPerformanceView != null && message.hasOwnProperty("hotelPerformanceView"))
                                object.hotelPerformanceView = $root.google.ads.googleads.v1.resources.HotelPerformanceView.toObject(message.hotelPerformanceView, options);
                            if (message.extensionFeedItem != null && message.hasOwnProperty("extensionFeedItem"))
                                object.extensionFeedItem = $root.google.ads.googleads.v1.resources.ExtensionFeedItem.toObject(message.extensionFeedItem, options);
                            if (message.operatingSystemVersionConstant != null && message.hasOwnProperty("operatingSystemVersionConstant"))
                                object.operatingSystemVersionConstant = $root.google.ads.googleads.v1.resources.OperatingSystemVersionConstant.toObject(message.operatingSystemVersionConstant, options);
                            if (message.mobileAppCategoryConstant != null && message.hasOwnProperty("mobileAppCategoryConstant"))
                                object.mobileAppCategoryConstant = $root.google.ads.googleads.v1.resources.MobileAppCategoryConstant.toObject(message.mobileAppCategoryConstant, options);
                            if (message.customerNegativeCriterion != null && message.hasOwnProperty("customerNegativeCriterion"))
                                object.customerNegativeCriterion = $root.google.ads.googleads.v1.resources.CustomerNegativeCriterion.toObject(message.customerNegativeCriterion, options);
                            if (message.adScheduleView != null && message.hasOwnProperty("adScheduleView"))
                                object.adScheduleView = $root.google.ads.googleads.v1.resources.AdScheduleView.toObject(message.adScheduleView, options);
                            if (message.mediaFile != null && message.hasOwnProperty("mediaFile"))
                                object.mediaFile = $root.google.ads.googleads.v1.resources.MediaFile.toObject(message.mediaFile, options);
                            if (message.domainCategory != null && message.hasOwnProperty("domainCategory"))
                                object.domainCategory = $root.google.ads.googleads.v1.resources.DomainCategory.toObject(message.domainCategory, options);
                            if (message.feedPlaceholderView != null && message.hasOwnProperty("feedPlaceholderView"))
                                object.feedPlaceholderView = $root.google.ads.googleads.v1.resources.FeedPlaceholderView.toObject(message.feedPlaceholderView, options);
                            if (message.mobileDeviceConstant != null && message.hasOwnProperty("mobileDeviceConstant"))
                                object.mobileDeviceConstant = $root.google.ads.googleads.v1.resources.MobileDeviceConstant.toObject(message.mobileDeviceConstant, options);
                            if (message.segments != null && message.hasOwnProperty("segments"))
                                object.segments = $root.google.ads.googleads.v1.common.Segments.toObject(message.segments, options);
                            if (message.conversionAction != null && message.hasOwnProperty("conversionAction"))
                                object.conversionAction = $root.google.ads.googleads.v1.resources.ConversionAction.toObject(message.conversionAction, options);
                            if (message.customInterest != null && message.hasOwnProperty("customInterest"))
                                object.customInterest = $root.google.ads.googleads.v1.resources.CustomInterest.toObject(message.customInterest, options);
                            if (message.asset != null && message.hasOwnProperty("asset"))
                                object.asset = $root.google.ads.googleads.v1.resources.Asset.toObject(message.asset, options);
                            if (message.dynamicSearchAdsSearchTermView != null && message.hasOwnProperty("dynamicSearchAdsSearchTermView"))
                                object.dynamicSearchAdsSearchTermView = $root.google.ads.googleads.v1.resources.DynamicSearchAdsSearchTermView.toObject(message.dynamicSearchAdsSearchTermView, options);
                            if (message.adGroupSimulation != null && message.hasOwnProperty("adGroupSimulation"))
                                object.adGroupSimulation = $root.google.ads.googleads.v1.resources.AdGroupSimulation.toObject(message.adGroupSimulation, options);
                            if (message.campaignLabel != null && message.hasOwnProperty("campaignLabel"))
                                object.campaignLabel = $root.google.ads.googleads.v1.resources.CampaignLabel.toObject(message.campaignLabel, options);
                            if (message.productBiddingCategoryConstant != null && message.hasOwnProperty("productBiddingCategoryConstant"))
                                object.productBiddingCategoryConstant = $root.google.ads.googleads.v1.resources.ProductBiddingCategoryConstant.toObject(message.productBiddingCategoryConstant, options);
                            if (message.adGroupCriterionSimulation != null && message.hasOwnProperty("adGroupCriterionSimulation"))
                                object.adGroupCriterionSimulation = $root.google.ads.googleads.v1.resources.AdGroupCriterionSimulation.toObject(message.adGroupCriterionSimulation, options);
                            if (message.campaignCriterionSimulation != null && message.hasOwnProperty("campaignCriterionSimulation"))
                                object.campaignCriterionSimulation = $root.google.ads.googleads.v1.resources.CampaignCriterionSimulation.toObject(message.campaignCriterionSimulation, options);
                            if (message.adGroupExtensionSetting != null && message.hasOwnProperty("adGroupExtensionSetting"))
                                object.adGroupExtensionSetting = $root.google.ads.googleads.v1.resources.AdGroupExtensionSetting.toObject(message.adGroupExtensionSetting, options);
                            if (message.campaignExtensionSetting != null && message.hasOwnProperty("campaignExtensionSetting"))
                                object.campaignExtensionSetting = $root.google.ads.googleads.v1.resources.CampaignExtensionSetting.toObject(message.campaignExtensionSetting, options);
                            if (message.customerExtensionSetting != null && message.hasOwnProperty("customerExtensionSetting"))
                                object.customerExtensionSetting = $root.google.ads.googleads.v1.resources.CustomerExtensionSetting.toObject(message.customerExtensionSetting, options);
                            if (message.adGroupLabel != null && message.hasOwnProperty("adGroupLabel"))
                                object.adGroupLabel = $root.google.ads.googleads.v1.resources.AdGroupLabel.toObject(message.adGroupLabel, options);
                            if (message.feedItemTarget != null && message.hasOwnProperty("feedItemTarget"))
                                object.feedItemTarget = $root.google.ads.googleads.v1.resources.FeedItemTarget.toObject(message.feedItemTarget, options);
                            if (message.shoppingPerformanceView != null && message.hasOwnProperty("shoppingPerformanceView"))
                                object.shoppingPerformanceView = $root.google.ads.googleads.v1.resources.ShoppingPerformanceView.toObject(message.shoppingPerformanceView, options);
                            if (message.detailPlacementView != null && message.hasOwnProperty("detailPlacementView"))
                                object.detailPlacementView = $root.google.ads.googleads.v1.resources.DetailPlacementView.toObject(message.detailPlacementView, options);
                            if (message.groupPlacementView != null && message.hasOwnProperty("groupPlacementView"))
                                object.groupPlacementView = $root.google.ads.googleads.v1.resources.GroupPlacementView.toObject(message.groupPlacementView, options);
                            if (message.adGroupAdLabel != null && message.hasOwnProperty("adGroupAdLabel"))
                                object.adGroupAdLabel = $root.google.ads.googleads.v1.resources.AdGroupAdLabel.toObject(message.adGroupAdLabel, options);
                            if (message.adGroupCriterionLabel != null && message.hasOwnProperty("adGroupCriterionLabel"))
                                object.adGroupCriterionLabel = $root.google.ads.googleads.v1.resources.AdGroupCriterionLabel.toObject(message.adGroupCriterionLabel, options);
                            if (message.clickView != null && message.hasOwnProperty("clickView"))
                                object.clickView = $root.google.ads.googleads.v1.resources.ClickView.toObject(message.clickView, options);
                            if (message.locationView != null && message.hasOwnProperty("locationView"))
                                object.locationView = $root.google.ads.googleads.v1.resources.LocationView.toObject(message.locationView, options);
                            if (message.customerLabel != null && message.hasOwnProperty("customerLabel"))
                                object.customerLabel = $root.google.ads.googleads.v1.resources.CustomerLabel.toObject(message.customerLabel, options);
                            if (message.geographicView != null && message.hasOwnProperty("geographicView"))
                                object.geographicView = $root.google.ads.googleads.v1.resources.GeographicView.toObject(message.geographicView, options);
                            if (message.landingPageView != null && message.hasOwnProperty("landingPageView"))
                                object.landingPageView = $root.google.ads.googleads.v1.resources.LandingPageView.toObject(message.landingPageView, options);
                            if (message.mutateJob != null && message.hasOwnProperty("mutateJob"))
                                object.mutateJob = $root.google.ads.googleads.v1.resources.MutateJob.toObject(message.mutateJob, options);
                            if (message.expandedLandingPageView != null && message.hasOwnProperty("expandedLandingPageView"))
                                object.expandedLandingPageView = $root.google.ads.googleads.v1.resources.ExpandedLandingPageView.toObject(message.expandedLandingPageView, options);
                            if (message.paidOrganicSearchTermView != null && message.hasOwnProperty("paidOrganicSearchTermView"))
                                object.paidOrganicSearchTermView = $root.google.ads.googleads.v1.resources.PaidOrganicSearchTermView.toObject(message.paidOrganicSearchTermView, options);
                            if (message.adParameter != null && message.hasOwnProperty("adParameter"))
                                object.adParameter = $root.google.ads.googleads.v1.resources.AdParameter.toObject(message.adParameter, options);
                            return object;
                        };

                        /**
                         * Converts this GoogleAdsRow to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GoogleAdsRow
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GoogleAdsRow.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GoogleAdsRow;
                    })();

                    services.MutateGoogleAdsRequest = (function() {

                        /**
                         * Properties of a MutateGoogleAdsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateGoogleAdsRequest
                         * @property {string|null} [customerId] MutateGoogleAdsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IMutateOperation>|null} [mutateOperations] MutateGoogleAdsRequest mutateOperations
                         * @property {boolean|null} [partialFailure] MutateGoogleAdsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateGoogleAdsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateGoogleAdsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateGoogleAdsRequest.
                         * @implements IMutateGoogleAdsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateGoogleAdsRequest=} [properties] Properties to set
                         */
                        function MutateGoogleAdsRequest(properties) {
                            this.mutateOperations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateGoogleAdsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsRequest
                         * @instance
                         */
                        MutateGoogleAdsRequest.prototype.customerId = "";

                        /**
                         * MutateGoogleAdsRequest mutateOperations.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateOperation>} mutateOperations
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsRequest
                         * @instance
                         */
                        MutateGoogleAdsRequest.prototype.mutateOperations = $util.emptyArray;

                        /**
                         * MutateGoogleAdsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsRequest
                         * @instance
                         */
                        MutateGoogleAdsRequest.prototype.partialFailure = false;

                        /**
                         * MutateGoogleAdsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsRequest
                         * @instance
                         */
                        MutateGoogleAdsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateGoogleAdsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateGoogleAdsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateGoogleAdsRequest} MutateGoogleAdsRequest instance
                         */
                        MutateGoogleAdsRequest.create = function create(properties) {
                            return new MutateGoogleAdsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateGoogleAdsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateGoogleAdsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateGoogleAdsRequest} message MutateGoogleAdsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateGoogleAdsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.mutateOperations != null && message.mutateOperations.length)
                                for (var i = 0; i < message.mutateOperations.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateOperation.encode(message.mutateOperations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateGoogleAdsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateGoogleAdsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateGoogleAdsRequest} message MutateGoogleAdsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateGoogleAdsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateGoogleAdsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateGoogleAdsRequest} MutateGoogleAdsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateGoogleAdsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateGoogleAdsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.mutateOperations && message.mutateOperations.length))
                                        message.mutateOperations = [];
                                    message.mutateOperations.push($root.google.ads.googleads.v1.services.MutateOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateGoogleAdsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateGoogleAdsRequest} MutateGoogleAdsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateGoogleAdsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateGoogleAdsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateGoogleAdsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.mutateOperations != null && message.hasOwnProperty("mutateOperations")) {
                                if (!Array.isArray(message.mutateOperations))
                                    return "mutateOperations: array expected";
                                for (var i = 0; i < message.mutateOperations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateOperation.verify(message.mutateOperations[i]);
                                    if (error)
                                        return "mutateOperations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateGoogleAdsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateGoogleAdsRequest} MutateGoogleAdsRequest
                         */
                        MutateGoogleAdsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateGoogleAdsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateGoogleAdsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.mutateOperations) {
                                if (!Array.isArray(object.mutateOperations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateGoogleAdsRequest.mutateOperations: array expected");
                                message.mutateOperations = [];
                                for (var i = 0; i < object.mutateOperations.length; ++i) {
                                    if (typeof object.mutateOperations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateGoogleAdsRequest.mutateOperations: object expected");
                                    message.mutateOperations[i] = $root.google.ads.googleads.v1.services.MutateOperation.fromObject(object.mutateOperations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateGoogleAdsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateGoogleAdsRequest} message MutateGoogleAdsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateGoogleAdsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.mutateOperations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.mutateOperations && message.mutateOperations.length) {
                                object.mutateOperations = [];
                                for (var j = 0; j < message.mutateOperations.length; ++j)
                                    object.mutateOperations[j] = $root.google.ads.googleads.v1.services.MutateOperation.toObject(message.mutateOperations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateGoogleAdsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateGoogleAdsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateGoogleAdsRequest;
                    })();

                    services.MutateGoogleAdsResponse = (function() {

                        /**
                         * Properties of a MutateGoogleAdsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateGoogleAdsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateGoogleAdsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateOperationResponse>|null} [mutateOperationResponses] MutateGoogleAdsResponse mutateOperationResponses
                         */

                        /**
                         * Constructs a new MutateGoogleAdsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateGoogleAdsResponse.
                         * @implements IMutateGoogleAdsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateGoogleAdsResponse=} [properties] Properties to set
                         */
                        function MutateGoogleAdsResponse(properties) {
                            this.mutateOperationResponses = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateGoogleAdsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsResponse
                         * @instance
                         */
                        MutateGoogleAdsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateGoogleAdsResponse mutateOperationResponses.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateOperationResponse>} mutateOperationResponses
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsResponse
                         * @instance
                         */
                        MutateGoogleAdsResponse.prototype.mutateOperationResponses = $util.emptyArray;

                        /**
                         * Creates a new MutateGoogleAdsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateGoogleAdsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateGoogleAdsResponse} MutateGoogleAdsResponse instance
                         */
                        MutateGoogleAdsResponse.create = function create(properties) {
                            return new MutateGoogleAdsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateGoogleAdsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateGoogleAdsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateGoogleAdsResponse} message MutateGoogleAdsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateGoogleAdsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.mutateOperationResponses != null && message.mutateOperationResponses.length)
                                for (var i = 0; i < message.mutateOperationResponses.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateOperationResponse.encode(message.mutateOperationResponses[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateGoogleAdsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateGoogleAdsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateGoogleAdsResponse} message MutateGoogleAdsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateGoogleAdsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateGoogleAdsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateGoogleAdsResponse} MutateGoogleAdsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateGoogleAdsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateGoogleAdsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    if (!(message.mutateOperationResponses && message.mutateOperationResponses.length))
                                        message.mutateOperationResponses = [];
                                    message.mutateOperationResponses.push($root.google.ads.googleads.v1.services.MutateOperationResponse.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateGoogleAdsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateGoogleAdsResponse} MutateGoogleAdsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateGoogleAdsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateGoogleAdsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateGoogleAdsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.mutateOperationResponses != null && message.hasOwnProperty("mutateOperationResponses")) {
                                if (!Array.isArray(message.mutateOperationResponses))
                                    return "mutateOperationResponses: array expected";
                                for (var i = 0; i < message.mutateOperationResponses.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateOperationResponse.verify(message.mutateOperationResponses[i]);
                                    if (error)
                                        return "mutateOperationResponses." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateGoogleAdsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateGoogleAdsResponse} MutateGoogleAdsResponse
                         */
                        MutateGoogleAdsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateGoogleAdsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateGoogleAdsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateGoogleAdsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.mutateOperationResponses) {
                                if (!Array.isArray(object.mutateOperationResponses))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateGoogleAdsResponse.mutateOperationResponses: array expected");
                                message.mutateOperationResponses = [];
                                for (var i = 0; i < object.mutateOperationResponses.length; ++i) {
                                    if (typeof object.mutateOperationResponses[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateGoogleAdsResponse.mutateOperationResponses: object expected");
                                    message.mutateOperationResponses[i] = $root.google.ads.googleads.v1.services.MutateOperationResponse.fromObject(object.mutateOperationResponses[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateGoogleAdsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateGoogleAdsResponse} message MutateGoogleAdsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateGoogleAdsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.mutateOperationResponses = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.mutateOperationResponses && message.mutateOperationResponses.length) {
                                object.mutateOperationResponses = [];
                                for (var j = 0; j < message.mutateOperationResponses.length; ++j)
                                    object.mutateOperationResponses[j] = $root.google.ads.googleads.v1.services.MutateOperationResponse.toObject(message.mutateOperationResponses[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateGoogleAdsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateGoogleAdsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateGoogleAdsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateGoogleAdsResponse;
                    })();

                    services.MutateOperation = (function() {

                        /**
                         * Properties of a MutateOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateOperation
                         * @property {google.ads.googleads.v1.services.IAdGroupAdLabelOperation|null} [adGroupAdLabelOperation] MutateOperation adGroupAdLabelOperation
                         * @property {google.ads.googleads.v1.services.IAdGroupAdOperation|null} [adGroupAdOperation] MutateOperation adGroupAdOperation
                         * @property {google.ads.googleads.v1.services.IAdGroupBidModifierOperation|null} [adGroupBidModifierOperation] MutateOperation adGroupBidModifierOperation
                         * @property {google.ads.googleads.v1.services.IAdGroupCriterionLabelOperation|null} [adGroupCriterionLabelOperation] MutateOperation adGroupCriterionLabelOperation
                         * @property {google.ads.googleads.v1.services.IAdGroupCriterionOperation|null} [adGroupCriterionOperation] MutateOperation adGroupCriterionOperation
                         * @property {google.ads.googleads.v1.services.IAdGroupExtensionSettingOperation|null} [adGroupExtensionSettingOperation] MutateOperation adGroupExtensionSettingOperation
                         * @property {google.ads.googleads.v1.services.IAdGroupFeedOperation|null} [adGroupFeedOperation] MutateOperation adGroupFeedOperation
                         * @property {google.ads.googleads.v1.services.IAdGroupLabelOperation|null} [adGroupLabelOperation] MutateOperation adGroupLabelOperation
                         * @property {google.ads.googleads.v1.services.IAdGroupOperation|null} [adGroupOperation] MutateOperation adGroupOperation
                         * @property {google.ads.googleads.v1.services.IAdParameterOperation|null} [adParameterOperation] MutateOperation adParameterOperation
                         * @property {google.ads.googleads.v1.services.IAssetOperation|null} [assetOperation] MutateOperation assetOperation
                         * @property {google.ads.googleads.v1.services.IBiddingStrategyOperation|null} [biddingStrategyOperation] MutateOperation biddingStrategyOperation
                         * @property {google.ads.googleads.v1.services.ICampaignBidModifierOperation|null} [campaignBidModifierOperation] MutateOperation campaignBidModifierOperation
                         * @property {google.ads.googleads.v1.services.ICampaignBudgetOperation|null} [campaignBudgetOperation] MutateOperation campaignBudgetOperation
                         * @property {google.ads.googleads.v1.services.ICampaignCriterionOperation|null} [campaignCriterionOperation] MutateOperation campaignCriterionOperation
                         * @property {google.ads.googleads.v1.services.ICampaignExtensionSettingOperation|null} [campaignExtensionSettingOperation] MutateOperation campaignExtensionSettingOperation
                         * @property {google.ads.googleads.v1.services.ICampaignFeedOperation|null} [campaignFeedOperation] MutateOperation campaignFeedOperation
                         * @property {google.ads.googleads.v1.services.ICampaignLabelOperation|null} [campaignLabelOperation] MutateOperation campaignLabelOperation
                         * @property {google.ads.googleads.v1.services.ICampaignOperation|null} [campaignOperation] MutateOperation campaignOperation
                         * @property {google.ads.googleads.v1.services.ICampaignSharedSetOperation|null} [campaignSharedSetOperation] MutateOperation campaignSharedSetOperation
                         * @property {google.ads.googleads.v1.services.IConversionActionOperation|null} [conversionActionOperation] MutateOperation conversionActionOperation
                         * @property {google.ads.googleads.v1.services.ICustomerExtensionSettingOperation|null} [customerExtensionSettingOperation] MutateOperation customerExtensionSettingOperation
                         * @property {google.ads.googleads.v1.services.ICustomerFeedOperation|null} [customerFeedOperation] MutateOperation customerFeedOperation
                         * @property {google.ads.googleads.v1.services.ICustomerLabelOperation|null} [customerLabelOperation] MutateOperation customerLabelOperation
                         * @property {google.ads.googleads.v1.services.ICustomerNegativeCriterionOperation|null} [customerNegativeCriterionOperation] MutateOperation customerNegativeCriterionOperation
                         * @property {google.ads.googleads.v1.services.ICustomerOperation|null} [customerOperation] MutateOperation customerOperation
                         * @property {google.ads.googleads.v1.services.IExtensionFeedItemOperation|null} [extensionFeedItemOperation] MutateOperation extensionFeedItemOperation
                         * @property {google.ads.googleads.v1.services.IFeedItemOperation|null} [feedItemOperation] MutateOperation feedItemOperation
                         * @property {google.ads.googleads.v1.services.IFeedItemTargetOperation|null} [feedItemTargetOperation] MutateOperation feedItemTargetOperation
                         * @property {google.ads.googleads.v1.services.IFeedMappingOperation|null} [feedMappingOperation] MutateOperation feedMappingOperation
                         * @property {google.ads.googleads.v1.services.IFeedOperation|null} [feedOperation] MutateOperation feedOperation
                         * @property {google.ads.googleads.v1.services.ILabelOperation|null} [labelOperation] MutateOperation labelOperation
                         * @property {google.ads.googleads.v1.services.IMediaFileOperation|null} [mediaFileOperation] MutateOperation mediaFileOperation
                         * @property {google.ads.googleads.v1.services.IRemarketingActionOperation|null} [remarketingActionOperation] MutateOperation remarketingActionOperation
                         * @property {google.ads.googleads.v1.services.ISharedCriterionOperation|null} [sharedCriterionOperation] MutateOperation sharedCriterionOperation
                         * @property {google.ads.googleads.v1.services.ISharedSetOperation|null} [sharedSetOperation] MutateOperation sharedSetOperation
                         * @property {google.ads.googleads.v1.services.IUserListOperation|null} [userListOperation] MutateOperation userListOperation
                         */

                        /**
                         * Constructs a new MutateOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateOperation.
                         * @implements IMutateOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateOperation=} [properties] Properties to set
                         */
                        function MutateOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateOperation adGroupAdLabelOperation.
                         * @member {google.ads.googleads.v1.services.IAdGroupAdLabelOperation|null|undefined} adGroupAdLabelOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.adGroupAdLabelOperation = null;

                        /**
                         * MutateOperation adGroupAdOperation.
                         * @member {google.ads.googleads.v1.services.IAdGroupAdOperation|null|undefined} adGroupAdOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.adGroupAdOperation = null;

                        /**
                         * MutateOperation adGroupBidModifierOperation.
                         * @member {google.ads.googleads.v1.services.IAdGroupBidModifierOperation|null|undefined} adGroupBidModifierOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.adGroupBidModifierOperation = null;

                        /**
                         * MutateOperation adGroupCriterionLabelOperation.
                         * @member {google.ads.googleads.v1.services.IAdGroupCriterionLabelOperation|null|undefined} adGroupCriterionLabelOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.adGroupCriterionLabelOperation = null;

                        /**
                         * MutateOperation adGroupCriterionOperation.
                         * @member {google.ads.googleads.v1.services.IAdGroupCriterionOperation|null|undefined} adGroupCriterionOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.adGroupCriterionOperation = null;

                        /**
                         * MutateOperation adGroupExtensionSettingOperation.
                         * @member {google.ads.googleads.v1.services.IAdGroupExtensionSettingOperation|null|undefined} adGroupExtensionSettingOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.adGroupExtensionSettingOperation = null;

                        /**
                         * MutateOperation adGroupFeedOperation.
                         * @member {google.ads.googleads.v1.services.IAdGroupFeedOperation|null|undefined} adGroupFeedOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.adGroupFeedOperation = null;

                        /**
                         * MutateOperation adGroupLabelOperation.
                         * @member {google.ads.googleads.v1.services.IAdGroupLabelOperation|null|undefined} adGroupLabelOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.adGroupLabelOperation = null;

                        /**
                         * MutateOperation adGroupOperation.
                         * @member {google.ads.googleads.v1.services.IAdGroupOperation|null|undefined} adGroupOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.adGroupOperation = null;

                        /**
                         * MutateOperation adParameterOperation.
                         * @member {google.ads.googleads.v1.services.IAdParameterOperation|null|undefined} adParameterOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.adParameterOperation = null;

                        /**
                         * MutateOperation assetOperation.
                         * @member {google.ads.googleads.v1.services.IAssetOperation|null|undefined} assetOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.assetOperation = null;

                        /**
                         * MutateOperation biddingStrategyOperation.
                         * @member {google.ads.googleads.v1.services.IBiddingStrategyOperation|null|undefined} biddingStrategyOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.biddingStrategyOperation = null;

                        /**
                         * MutateOperation campaignBidModifierOperation.
                         * @member {google.ads.googleads.v1.services.ICampaignBidModifierOperation|null|undefined} campaignBidModifierOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.campaignBidModifierOperation = null;

                        /**
                         * MutateOperation campaignBudgetOperation.
                         * @member {google.ads.googleads.v1.services.ICampaignBudgetOperation|null|undefined} campaignBudgetOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.campaignBudgetOperation = null;

                        /**
                         * MutateOperation campaignCriterionOperation.
                         * @member {google.ads.googleads.v1.services.ICampaignCriterionOperation|null|undefined} campaignCriterionOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.campaignCriterionOperation = null;

                        /**
                         * MutateOperation campaignExtensionSettingOperation.
                         * @member {google.ads.googleads.v1.services.ICampaignExtensionSettingOperation|null|undefined} campaignExtensionSettingOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.campaignExtensionSettingOperation = null;

                        /**
                         * MutateOperation campaignFeedOperation.
                         * @member {google.ads.googleads.v1.services.ICampaignFeedOperation|null|undefined} campaignFeedOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.campaignFeedOperation = null;

                        /**
                         * MutateOperation campaignLabelOperation.
                         * @member {google.ads.googleads.v1.services.ICampaignLabelOperation|null|undefined} campaignLabelOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.campaignLabelOperation = null;

                        /**
                         * MutateOperation campaignOperation.
                         * @member {google.ads.googleads.v1.services.ICampaignOperation|null|undefined} campaignOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.campaignOperation = null;

                        /**
                         * MutateOperation campaignSharedSetOperation.
                         * @member {google.ads.googleads.v1.services.ICampaignSharedSetOperation|null|undefined} campaignSharedSetOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.campaignSharedSetOperation = null;

                        /**
                         * MutateOperation conversionActionOperation.
                         * @member {google.ads.googleads.v1.services.IConversionActionOperation|null|undefined} conversionActionOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.conversionActionOperation = null;

                        /**
                         * MutateOperation customerExtensionSettingOperation.
                         * @member {google.ads.googleads.v1.services.ICustomerExtensionSettingOperation|null|undefined} customerExtensionSettingOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.customerExtensionSettingOperation = null;

                        /**
                         * MutateOperation customerFeedOperation.
                         * @member {google.ads.googleads.v1.services.ICustomerFeedOperation|null|undefined} customerFeedOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.customerFeedOperation = null;

                        /**
                         * MutateOperation customerLabelOperation.
                         * @member {google.ads.googleads.v1.services.ICustomerLabelOperation|null|undefined} customerLabelOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.customerLabelOperation = null;

                        /**
                         * MutateOperation customerNegativeCriterionOperation.
                         * @member {google.ads.googleads.v1.services.ICustomerNegativeCriterionOperation|null|undefined} customerNegativeCriterionOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.customerNegativeCriterionOperation = null;

                        /**
                         * MutateOperation customerOperation.
                         * @member {google.ads.googleads.v1.services.ICustomerOperation|null|undefined} customerOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.customerOperation = null;

                        /**
                         * MutateOperation extensionFeedItemOperation.
                         * @member {google.ads.googleads.v1.services.IExtensionFeedItemOperation|null|undefined} extensionFeedItemOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.extensionFeedItemOperation = null;

                        /**
                         * MutateOperation feedItemOperation.
                         * @member {google.ads.googleads.v1.services.IFeedItemOperation|null|undefined} feedItemOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.feedItemOperation = null;

                        /**
                         * MutateOperation feedItemTargetOperation.
                         * @member {google.ads.googleads.v1.services.IFeedItemTargetOperation|null|undefined} feedItemTargetOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.feedItemTargetOperation = null;

                        /**
                         * MutateOperation feedMappingOperation.
                         * @member {google.ads.googleads.v1.services.IFeedMappingOperation|null|undefined} feedMappingOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.feedMappingOperation = null;

                        /**
                         * MutateOperation feedOperation.
                         * @member {google.ads.googleads.v1.services.IFeedOperation|null|undefined} feedOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.feedOperation = null;

                        /**
                         * MutateOperation labelOperation.
                         * @member {google.ads.googleads.v1.services.ILabelOperation|null|undefined} labelOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.labelOperation = null;

                        /**
                         * MutateOperation mediaFileOperation.
                         * @member {google.ads.googleads.v1.services.IMediaFileOperation|null|undefined} mediaFileOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.mediaFileOperation = null;

                        /**
                         * MutateOperation remarketingActionOperation.
                         * @member {google.ads.googleads.v1.services.IRemarketingActionOperation|null|undefined} remarketingActionOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.remarketingActionOperation = null;

                        /**
                         * MutateOperation sharedCriterionOperation.
                         * @member {google.ads.googleads.v1.services.ISharedCriterionOperation|null|undefined} sharedCriterionOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.sharedCriterionOperation = null;

                        /**
                         * MutateOperation sharedSetOperation.
                         * @member {google.ads.googleads.v1.services.ISharedSetOperation|null|undefined} sharedSetOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.sharedSetOperation = null;

                        /**
                         * MutateOperation userListOperation.
                         * @member {google.ads.googleads.v1.services.IUserListOperation|null|undefined} userListOperation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        MutateOperation.prototype.userListOperation = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * MutateOperation operation.
                         * @member {"adGroupAdLabelOperation"|"adGroupAdOperation"|"adGroupBidModifierOperation"|"adGroupCriterionLabelOperation"|"adGroupCriterionOperation"|"adGroupExtensionSettingOperation"|"adGroupFeedOperation"|"adGroupLabelOperation"|"adGroupOperation"|"adParameterOperation"|"assetOperation"|"biddingStrategyOperation"|"campaignBidModifierOperation"|"campaignBudgetOperation"|"campaignCriterionOperation"|"campaignExtensionSettingOperation"|"campaignFeedOperation"|"campaignLabelOperation"|"campaignOperation"|"campaignSharedSetOperation"|"conversionActionOperation"|"customerExtensionSettingOperation"|"customerFeedOperation"|"customerLabelOperation"|"customerNegativeCriterionOperation"|"customerOperation"|"extensionFeedItemOperation"|"feedItemOperation"|"feedItemTargetOperation"|"feedMappingOperation"|"feedOperation"|"labelOperation"|"mediaFileOperation"|"remarketingActionOperation"|"sharedCriterionOperation"|"sharedSetOperation"|"userListOperation"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         */
                        Object.defineProperty(MutateOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["adGroupAdLabelOperation", "adGroupAdOperation", "adGroupBidModifierOperation", "adGroupCriterionLabelOperation", "adGroupCriterionOperation", "adGroupExtensionSettingOperation", "adGroupFeedOperation", "adGroupLabelOperation", "adGroupOperation", "adParameterOperation", "assetOperation", "biddingStrategyOperation", "campaignBidModifierOperation", "campaignBudgetOperation", "campaignCriterionOperation", "campaignExtensionSettingOperation", "campaignFeedOperation", "campaignLabelOperation", "campaignOperation", "campaignSharedSetOperation", "conversionActionOperation", "customerExtensionSettingOperation", "customerFeedOperation", "customerLabelOperation", "customerNegativeCriterionOperation", "customerOperation", "extensionFeedItemOperation", "feedItemOperation", "feedItemTargetOperation", "feedMappingOperation", "feedOperation", "labelOperation", "mediaFileOperation", "remarketingActionOperation", "sharedCriterionOperation", "sharedSetOperation", "userListOperation"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new MutateOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateOperation} MutateOperation instance
                         */
                        MutateOperation.create = function create(properties) {
                            return new MutateOperation(properties);
                        };

                        /**
                         * Encodes the specified MutateOperation message. Does not implicitly {@link google.ads.googleads.v1.services.MutateOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateOperation} message MutateOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.adGroupAdOperation != null && message.hasOwnProperty("adGroupAdOperation"))
                                $root.google.ads.googleads.v1.services.AdGroupAdOperation.encode(message.adGroupAdOperation, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.adGroupBidModifierOperation != null && message.hasOwnProperty("adGroupBidModifierOperation"))
                                $root.google.ads.googleads.v1.services.AdGroupBidModifierOperation.encode(message.adGroupBidModifierOperation, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.adGroupCriterionOperation != null && message.hasOwnProperty("adGroupCriterionOperation"))
                                $root.google.ads.googleads.v1.services.AdGroupCriterionOperation.encode(message.adGroupCriterionOperation, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.adGroupOperation != null && message.hasOwnProperty("adGroupOperation"))
                                $root.google.ads.googleads.v1.services.AdGroupOperation.encode(message.adGroupOperation, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.biddingStrategyOperation != null && message.hasOwnProperty("biddingStrategyOperation"))
                                $root.google.ads.googleads.v1.services.BiddingStrategyOperation.encode(message.biddingStrategyOperation, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.campaignBidModifierOperation != null && message.hasOwnProperty("campaignBidModifierOperation"))
                                $root.google.ads.googleads.v1.services.CampaignBidModifierOperation.encode(message.campaignBidModifierOperation, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.campaignBudgetOperation != null && message.hasOwnProperty("campaignBudgetOperation"))
                                $root.google.ads.googleads.v1.services.CampaignBudgetOperation.encode(message.campaignBudgetOperation, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.campaignOperation != null && message.hasOwnProperty("campaignOperation"))
                                $root.google.ads.googleads.v1.services.CampaignOperation.encode(message.campaignOperation, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.campaignSharedSetOperation != null && message.hasOwnProperty("campaignSharedSetOperation"))
                                $root.google.ads.googleads.v1.services.CampaignSharedSetOperation.encode(message.campaignSharedSetOperation, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.conversionActionOperation != null && message.hasOwnProperty("conversionActionOperation"))
                                $root.google.ads.googleads.v1.services.ConversionActionOperation.encode(message.conversionActionOperation, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.campaignCriterionOperation != null && message.hasOwnProperty("campaignCriterionOperation"))
                                $root.google.ads.googleads.v1.services.CampaignCriterionOperation.encode(message.campaignCriterionOperation, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                            if (message.sharedCriterionOperation != null && message.hasOwnProperty("sharedCriterionOperation"))
                                $root.google.ads.googleads.v1.services.SharedCriterionOperation.encode(message.sharedCriterionOperation, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.sharedSetOperation != null && message.hasOwnProperty("sharedSetOperation"))
                                $root.google.ads.googleads.v1.services.SharedSetOperation.encode(message.sharedSetOperation, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
                            if (message.userListOperation != null && message.hasOwnProperty("userListOperation"))
                                $root.google.ads.googleads.v1.services.UserListOperation.encode(message.userListOperation, writer.uint32(/* id 16, wireType 2 =*/130).fork()).ldelim();
                            if (message.adGroupAdLabelOperation != null && message.hasOwnProperty("adGroupAdLabelOperation"))
                                $root.google.ads.googleads.v1.services.AdGroupAdLabelOperation.encode(message.adGroupAdLabelOperation, writer.uint32(/* id 17, wireType 2 =*/138).fork()).ldelim();
                            if (message.adGroupCriterionLabelOperation != null && message.hasOwnProperty("adGroupCriterionLabelOperation"))
                                $root.google.ads.googleads.v1.services.AdGroupCriterionLabelOperation.encode(message.adGroupCriterionLabelOperation, writer.uint32(/* id 18, wireType 2 =*/146).fork()).ldelim();
                            if (message.adGroupExtensionSettingOperation != null && message.hasOwnProperty("adGroupExtensionSettingOperation"))
                                $root.google.ads.googleads.v1.services.AdGroupExtensionSettingOperation.encode(message.adGroupExtensionSettingOperation, writer.uint32(/* id 19, wireType 2 =*/154).fork()).ldelim();
                            if (message.adGroupFeedOperation != null && message.hasOwnProperty("adGroupFeedOperation"))
                                $root.google.ads.googleads.v1.services.AdGroupFeedOperation.encode(message.adGroupFeedOperation, writer.uint32(/* id 20, wireType 2 =*/162).fork()).ldelim();
                            if (message.adGroupLabelOperation != null && message.hasOwnProperty("adGroupLabelOperation"))
                                $root.google.ads.googleads.v1.services.AdGroupLabelOperation.encode(message.adGroupLabelOperation, writer.uint32(/* id 21, wireType 2 =*/170).fork()).ldelim();
                            if (message.adParameterOperation != null && message.hasOwnProperty("adParameterOperation"))
                                $root.google.ads.googleads.v1.services.AdParameterOperation.encode(message.adParameterOperation, writer.uint32(/* id 22, wireType 2 =*/178).fork()).ldelim();
                            if (message.assetOperation != null && message.hasOwnProperty("assetOperation"))
                                $root.google.ads.googleads.v1.services.AssetOperation.encode(message.assetOperation, writer.uint32(/* id 23, wireType 2 =*/186).fork()).ldelim();
                            if (message.campaignExtensionSettingOperation != null && message.hasOwnProperty("campaignExtensionSettingOperation"))
                                $root.google.ads.googleads.v1.services.CampaignExtensionSettingOperation.encode(message.campaignExtensionSettingOperation, writer.uint32(/* id 26, wireType 2 =*/210).fork()).ldelim();
                            if (message.campaignFeedOperation != null && message.hasOwnProperty("campaignFeedOperation"))
                                $root.google.ads.googleads.v1.services.CampaignFeedOperation.encode(message.campaignFeedOperation, writer.uint32(/* id 27, wireType 2 =*/218).fork()).ldelim();
                            if (message.campaignLabelOperation != null && message.hasOwnProperty("campaignLabelOperation"))
                                $root.google.ads.googleads.v1.services.CampaignLabelOperation.encode(message.campaignLabelOperation, writer.uint32(/* id 28, wireType 2 =*/226).fork()).ldelim();
                            if (message.customerExtensionSettingOperation != null && message.hasOwnProperty("customerExtensionSettingOperation"))
                                $root.google.ads.googleads.v1.services.CustomerExtensionSettingOperation.encode(message.customerExtensionSettingOperation, writer.uint32(/* id 30, wireType 2 =*/242).fork()).ldelim();
                            if (message.customerFeedOperation != null && message.hasOwnProperty("customerFeedOperation"))
                                $root.google.ads.googleads.v1.services.CustomerFeedOperation.encode(message.customerFeedOperation, writer.uint32(/* id 31, wireType 2 =*/250).fork()).ldelim();
                            if (message.customerLabelOperation != null && message.hasOwnProperty("customerLabelOperation"))
                                $root.google.ads.googleads.v1.services.CustomerLabelOperation.encode(message.customerLabelOperation, writer.uint32(/* id 32, wireType 2 =*/258).fork()).ldelim();
                            if (message.customerNegativeCriterionOperation != null && message.hasOwnProperty("customerNegativeCriterionOperation"))
                                $root.google.ads.googleads.v1.services.CustomerNegativeCriterionOperation.encode(message.customerNegativeCriterionOperation, writer.uint32(/* id 34, wireType 2 =*/274).fork()).ldelim();
                            if (message.customerOperation != null && message.hasOwnProperty("customerOperation"))
                                $root.google.ads.googleads.v1.services.CustomerOperation.encode(message.customerOperation, writer.uint32(/* id 35, wireType 2 =*/282).fork()).ldelim();
                            if (message.extensionFeedItemOperation != null && message.hasOwnProperty("extensionFeedItemOperation"))
                                $root.google.ads.googleads.v1.services.ExtensionFeedItemOperation.encode(message.extensionFeedItemOperation, writer.uint32(/* id 36, wireType 2 =*/290).fork()).ldelim();
                            if (message.feedItemOperation != null && message.hasOwnProperty("feedItemOperation"))
                                $root.google.ads.googleads.v1.services.FeedItemOperation.encode(message.feedItemOperation, writer.uint32(/* id 37, wireType 2 =*/298).fork()).ldelim();
                            if (message.feedItemTargetOperation != null && message.hasOwnProperty("feedItemTargetOperation"))
                                $root.google.ads.googleads.v1.services.FeedItemTargetOperation.encode(message.feedItemTargetOperation, writer.uint32(/* id 38, wireType 2 =*/306).fork()).ldelim();
                            if (message.feedMappingOperation != null && message.hasOwnProperty("feedMappingOperation"))
                                $root.google.ads.googleads.v1.services.FeedMappingOperation.encode(message.feedMappingOperation, writer.uint32(/* id 39, wireType 2 =*/314).fork()).ldelim();
                            if (message.feedOperation != null && message.hasOwnProperty("feedOperation"))
                                $root.google.ads.googleads.v1.services.FeedOperation.encode(message.feedOperation, writer.uint32(/* id 40, wireType 2 =*/322).fork()).ldelim();
                            if (message.labelOperation != null && message.hasOwnProperty("labelOperation"))
                                $root.google.ads.googleads.v1.services.LabelOperation.encode(message.labelOperation, writer.uint32(/* id 41, wireType 2 =*/330).fork()).ldelim();
                            if (message.mediaFileOperation != null && message.hasOwnProperty("mediaFileOperation"))
                                $root.google.ads.googleads.v1.services.MediaFileOperation.encode(message.mediaFileOperation, writer.uint32(/* id 42, wireType 2 =*/338).fork()).ldelim();
                            if (message.remarketingActionOperation != null && message.hasOwnProperty("remarketingActionOperation"))
                                $root.google.ads.googleads.v1.services.RemarketingActionOperation.encode(message.remarketingActionOperation, writer.uint32(/* id 43, wireType 2 =*/346).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateOperation} message MutateOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateOperation} MutateOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 17:
                                    message.adGroupAdLabelOperation = $root.google.ads.googleads.v1.services.AdGroupAdLabelOperation.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.adGroupAdOperation = $root.google.ads.googleads.v1.services.AdGroupAdOperation.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.adGroupBidModifierOperation = $root.google.ads.googleads.v1.services.AdGroupBidModifierOperation.decode(reader, reader.uint32());
                                    break;
                                case 18:
                                    message.adGroupCriterionLabelOperation = $root.google.ads.googleads.v1.services.AdGroupCriterionLabelOperation.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.adGroupCriterionOperation = $root.google.ads.googleads.v1.services.AdGroupCriterionOperation.decode(reader, reader.uint32());
                                    break;
                                case 19:
                                    message.adGroupExtensionSettingOperation = $root.google.ads.googleads.v1.services.AdGroupExtensionSettingOperation.decode(reader, reader.uint32());
                                    break;
                                case 20:
                                    message.adGroupFeedOperation = $root.google.ads.googleads.v1.services.AdGroupFeedOperation.decode(reader, reader.uint32());
                                    break;
                                case 21:
                                    message.adGroupLabelOperation = $root.google.ads.googleads.v1.services.AdGroupLabelOperation.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.adGroupOperation = $root.google.ads.googleads.v1.services.AdGroupOperation.decode(reader, reader.uint32());
                                    break;
                                case 22:
                                    message.adParameterOperation = $root.google.ads.googleads.v1.services.AdParameterOperation.decode(reader, reader.uint32());
                                    break;
                                case 23:
                                    message.assetOperation = $root.google.ads.googleads.v1.services.AssetOperation.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.biddingStrategyOperation = $root.google.ads.googleads.v1.services.BiddingStrategyOperation.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.campaignBidModifierOperation = $root.google.ads.googleads.v1.services.CampaignBidModifierOperation.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.campaignBudgetOperation = $root.google.ads.googleads.v1.services.CampaignBudgetOperation.decode(reader, reader.uint32());
                                    break;
                                case 13:
                                    message.campaignCriterionOperation = $root.google.ads.googleads.v1.services.CampaignCriterionOperation.decode(reader, reader.uint32());
                                    break;
                                case 26:
                                    message.campaignExtensionSettingOperation = $root.google.ads.googleads.v1.services.CampaignExtensionSettingOperation.decode(reader, reader.uint32());
                                    break;
                                case 27:
                                    message.campaignFeedOperation = $root.google.ads.googleads.v1.services.CampaignFeedOperation.decode(reader, reader.uint32());
                                    break;
                                case 28:
                                    message.campaignLabelOperation = $root.google.ads.googleads.v1.services.CampaignLabelOperation.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.campaignOperation = $root.google.ads.googleads.v1.services.CampaignOperation.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.campaignSharedSetOperation = $root.google.ads.googleads.v1.services.CampaignSharedSetOperation.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.conversionActionOperation = $root.google.ads.googleads.v1.services.ConversionActionOperation.decode(reader, reader.uint32());
                                    break;
                                case 30:
                                    message.customerExtensionSettingOperation = $root.google.ads.googleads.v1.services.CustomerExtensionSettingOperation.decode(reader, reader.uint32());
                                    break;
                                case 31:
                                    message.customerFeedOperation = $root.google.ads.googleads.v1.services.CustomerFeedOperation.decode(reader, reader.uint32());
                                    break;
                                case 32:
                                    message.customerLabelOperation = $root.google.ads.googleads.v1.services.CustomerLabelOperation.decode(reader, reader.uint32());
                                    break;
                                case 34:
                                    message.customerNegativeCriterionOperation = $root.google.ads.googleads.v1.services.CustomerNegativeCriterionOperation.decode(reader, reader.uint32());
                                    break;
                                case 35:
                                    message.customerOperation = $root.google.ads.googleads.v1.services.CustomerOperation.decode(reader, reader.uint32());
                                    break;
                                case 36:
                                    message.extensionFeedItemOperation = $root.google.ads.googleads.v1.services.ExtensionFeedItemOperation.decode(reader, reader.uint32());
                                    break;
                                case 37:
                                    message.feedItemOperation = $root.google.ads.googleads.v1.services.FeedItemOperation.decode(reader, reader.uint32());
                                    break;
                                case 38:
                                    message.feedItemTargetOperation = $root.google.ads.googleads.v1.services.FeedItemTargetOperation.decode(reader, reader.uint32());
                                    break;
                                case 39:
                                    message.feedMappingOperation = $root.google.ads.googleads.v1.services.FeedMappingOperation.decode(reader, reader.uint32());
                                    break;
                                case 40:
                                    message.feedOperation = $root.google.ads.googleads.v1.services.FeedOperation.decode(reader, reader.uint32());
                                    break;
                                case 41:
                                    message.labelOperation = $root.google.ads.googleads.v1.services.LabelOperation.decode(reader, reader.uint32());
                                    break;
                                case 42:
                                    message.mediaFileOperation = $root.google.ads.googleads.v1.services.MediaFileOperation.decode(reader, reader.uint32());
                                    break;
                                case 43:
                                    message.remarketingActionOperation = $root.google.ads.googleads.v1.services.RemarketingActionOperation.decode(reader, reader.uint32());
                                    break;
                                case 14:
                                    message.sharedCriterionOperation = $root.google.ads.googleads.v1.services.SharedCriterionOperation.decode(reader, reader.uint32());
                                    break;
                                case 15:
                                    message.sharedSetOperation = $root.google.ads.googleads.v1.services.SharedSetOperation.decode(reader, reader.uint32());
                                    break;
                                case 16:
                                    message.userListOperation = $root.google.ads.googleads.v1.services.UserListOperation.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateOperation} MutateOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.adGroupAdLabelOperation != null && message.hasOwnProperty("adGroupAdLabelOperation")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.AdGroupAdLabelOperation.verify(message.adGroupAdLabelOperation);
                                    if (error)
                                        return "adGroupAdLabelOperation." + error;
                                }
                            }
                            if (message.adGroupAdOperation != null && message.hasOwnProperty("adGroupAdOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.AdGroupAdOperation.verify(message.adGroupAdOperation);
                                    if (error)
                                        return "adGroupAdOperation." + error;
                                }
                            }
                            if (message.adGroupBidModifierOperation != null && message.hasOwnProperty("adGroupBidModifierOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.AdGroupBidModifierOperation.verify(message.adGroupBidModifierOperation);
                                    if (error)
                                        return "adGroupBidModifierOperation." + error;
                                }
                            }
                            if (message.adGroupCriterionLabelOperation != null && message.hasOwnProperty("adGroupCriterionLabelOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.AdGroupCriterionLabelOperation.verify(message.adGroupCriterionLabelOperation);
                                    if (error)
                                        return "adGroupCriterionLabelOperation." + error;
                                }
                            }
                            if (message.adGroupCriterionOperation != null && message.hasOwnProperty("adGroupCriterionOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.AdGroupCriterionOperation.verify(message.adGroupCriterionOperation);
                                    if (error)
                                        return "adGroupCriterionOperation." + error;
                                }
                            }
                            if (message.adGroupExtensionSettingOperation != null && message.hasOwnProperty("adGroupExtensionSettingOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.AdGroupExtensionSettingOperation.verify(message.adGroupExtensionSettingOperation);
                                    if (error)
                                        return "adGroupExtensionSettingOperation." + error;
                                }
                            }
                            if (message.adGroupFeedOperation != null && message.hasOwnProperty("adGroupFeedOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.AdGroupFeedOperation.verify(message.adGroupFeedOperation);
                                    if (error)
                                        return "adGroupFeedOperation." + error;
                                }
                            }
                            if (message.adGroupLabelOperation != null && message.hasOwnProperty("adGroupLabelOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.AdGroupLabelOperation.verify(message.adGroupLabelOperation);
                                    if (error)
                                        return "adGroupLabelOperation." + error;
                                }
                            }
                            if (message.adGroupOperation != null && message.hasOwnProperty("adGroupOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.AdGroupOperation.verify(message.adGroupOperation);
                                    if (error)
                                        return "adGroupOperation." + error;
                                }
                            }
                            if (message.adParameterOperation != null && message.hasOwnProperty("adParameterOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.AdParameterOperation.verify(message.adParameterOperation);
                                    if (error)
                                        return "adParameterOperation." + error;
                                }
                            }
                            if (message.assetOperation != null && message.hasOwnProperty("assetOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.AssetOperation.verify(message.assetOperation);
                                    if (error)
                                        return "assetOperation." + error;
                                }
                            }
                            if (message.biddingStrategyOperation != null && message.hasOwnProperty("biddingStrategyOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.BiddingStrategyOperation.verify(message.biddingStrategyOperation);
                                    if (error)
                                        return "biddingStrategyOperation." + error;
                                }
                            }
                            if (message.campaignBidModifierOperation != null && message.hasOwnProperty("campaignBidModifierOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.CampaignBidModifierOperation.verify(message.campaignBidModifierOperation);
                                    if (error)
                                        return "campaignBidModifierOperation." + error;
                                }
                            }
                            if (message.campaignBudgetOperation != null && message.hasOwnProperty("campaignBudgetOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.CampaignBudgetOperation.verify(message.campaignBudgetOperation);
                                    if (error)
                                        return "campaignBudgetOperation." + error;
                                }
                            }
                            if (message.campaignCriterionOperation != null && message.hasOwnProperty("campaignCriterionOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.CampaignCriterionOperation.verify(message.campaignCriterionOperation);
                                    if (error)
                                        return "campaignCriterionOperation." + error;
                                }
                            }
                            if (message.campaignExtensionSettingOperation != null && message.hasOwnProperty("campaignExtensionSettingOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.CampaignExtensionSettingOperation.verify(message.campaignExtensionSettingOperation);
                                    if (error)
                                        return "campaignExtensionSettingOperation." + error;
                                }
                            }
                            if (message.campaignFeedOperation != null && message.hasOwnProperty("campaignFeedOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.CampaignFeedOperation.verify(message.campaignFeedOperation);
                                    if (error)
                                        return "campaignFeedOperation." + error;
                                }
                            }
                            if (message.campaignLabelOperation != null && message.hasOwnProperty("campaignLabelOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.CampaignLabelOperation.verify(message.campaignLabelOperation);
                                    if (error)
                                        return "campaignLabelOperation." + error;
                                }
                            }
                            if (message.campaignOperation != null && message.hasOwnProperty("campaignOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.CampaignOperation.verify(message.campaignOperation);
                                    if (error)
                                        return "campaignOperation." + error;
                                }
                            }
                            if (message.campaignSharedSetOperation != null && message.hasOwnProperty("campaignSharedSetOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.CampaignSharedSetOperation.verify(message.campaignSharedSetOperation);
                                    if (error)
                                        return "campaignSharedSetOperation." + error;
                                }
                            }
                            if (message.conversionActionOperation != null && message.hasOwnProperty("conversionActionOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.ConversionActionOperation.verify(message.conversionActionOperation);
                                    if (error)
                                        return "conversionActionOperation." + error;
                                }
                            }
                            if (message.customerExtensionSettingOperation != null && message.hasOwnProperty("customerExtensionSettingOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.CustomerExtensionSettingOperation.verify(message.customerExtensionSettingOperation);
                                    if (error)
                                        return "customerExtensionSettingOperation." + error;
                                }
                            }
                            if (message.customerFeedOperation != null && message.hasOwnProperty("customerFeedOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.CustomerFeedOperation.verify(message.customerFeedOperation);
                                    if (error)
                                        return "customerFeedOperation." + error;
                                }
                            }
                            if (message.customerLabelOperation != null && message.hasOwnProperty("customerLabelOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.CustomerLabelOperation.verify(message.customerLabelOperation);
                                    if (error)
                                        return "customerLabelOperation." + error;
                                }
                            }
                            if (message.customerNegativeCriterionOperation != null && message.hasOwnProperty("customerNegativeCriterionOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.CustomerNegativeCriterionOperation.verify(message.customerNegativeCriterionOperation);
                                    if (error)
                                        return "customerNegativeCriterionOperation." + error;
                                }
                            }
                            if (message.customerOperation != null && message.hasOwnProperty("customerOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.CustomerOperation.verify(message.customerOperation);
                                    if (error)
                                        return "customerOperation." + error;
                                }
                            }
                            if (message.extensionFeedItemOperation != null && message.hasOwnProperty("extensionFeedItemOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.ExtensionFeedItemOperation.verify(message.extensionFeedItemOperation);
                                    if (error)
                                        return "extensionFeedItemOperation." + error;
                                }
                            }
                            if (message.feedItemOperation != null && message.hasOwnProperty("feedItemOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.FeedItemOperation.verify(message.feedItemOperation);
                                    if (error)
                                        return "feedItemOperation." + error;
                                }
                            }
                            if (message.feedItemTargetOperation != null && message.hasOwnProperty("feedItemTargetOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.FeedItemTargetOperation.verify(message.feedItemTargetOperation);
                                    if (error)
                                        return "feedItemTargetOperation." + error;
                                }
                            }
                            if (message.feedMappingOperation != null && message.hasOwnProperty("feedMappingOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.FeedMappingOperation.verify(message.feedMappingOperation);
                                    if (error)
                                        return "feedMappingOperation." + error;
                                }
                            }
                            if (message.feedOperation != null && message.hasOwnProperty("feedOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.FeedOperation.verify(message.feedOperation);
                                    if (error)
                                        return "feedOperation." + error;
                                }
                            }
                            if (message.labelOperation != null && message.hasOwnProperty("labelOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.LabelOperation.verify(message.labelOperation);
                                    if (error)
                                        return "labelOperation." + error;
                                }
                            }
                            if (message.mediaFileOperation != null && message.hasOwnProperty("mediaFileOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MediaFileOperation.verify(message.mediaFileOperation);
                                    if (error)
                                        return "mediaFileOperation." + error;
                                }
                            }
                            if (message.remarketingActionOperation != null && message.hasOwnProperty("remarketingActionOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.RemarketingActionOperation.verify(message.remarketingActionOperation);
                                    if (error)
                                        return "remarketingActionOperation." + error;
                                }
                            }
                            if (message.sharedCriterionOperation != null && message.hasOwnProperty("sharedCriterionOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.SharedCriterionOperation.verify(message.sharedCriterionOperation);
                                    if (error)
                                        return "sharedCriterionOperation." + error;
                                }
                            }
                            if (message.sharedSetOperation != null && message.hasOwnProperty("sharedSetOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.SharedSetOperation.verify(message.sharedSetOperation);
                                    if (error)
                                        return "sharedSetOperation." + error;
                                }
                            }
                            if (message.userListOperation != null && message.hasOwnProperty("userListOperation")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.UserListOperation.verify(message.userListOperation);
                                    if (error)
                                        return "userListOperation." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateOperation} MutateOperation
                         */
                        MutateOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateOperation();
                            if (object.adGroupAdLabelOperation != null) {
                                if (typeof object.adGroupAdLabelOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.adGroupAdLabelOperation: object expected");
                                message.adGroupAdLabelOperation = $root.google.ads.googleads.v1.services.AdGroupAdLabelOperation.fromObject(object.adGroupAdLabelOperation);
                            }
                            if (object.adGroupAdOperation != null) {
                                if (typeof object.adGroupAdOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.adGroupAdOperation: object expected");
                                message.adGroupAdOperation = $root.google.ads.googleads.v1.services.AdGroupAdOperation.fromObject(object.adGroupAdOperation);
                            }
                            if (object.adGroupBidModifierOperation != null) {
                                if (typeof object.adGroupBidModifierOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.adGroupBidModifierOperation: object expected");
                                message.adGroupBidModifierOperation = $root.google.ads.googleads.v1.services.AdGroupBidModifierOperation.fromObject(object.adGroupBidModifierOperation);
                            }
                            if (object.adGroupCriterionLabelOperation != null) {
                                if (typeof object.adGroupCriterionLabelOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.adGroupCriterionLabelOperation: object expected");
                                message.adGroupCriterionLabelOperation = $root.google.ads.googleads.v1.services.AdGroupCriterionLabelOperation.fromObject(object.adGroupCriterionLabelOperation);
                            }
                            if (object.adGroupCriterionOperation != null) {
                                if (typeof object.adGroupCriterionOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.adGroupCriterionOperation: object expected");
                                message.adGroupCriterionOperation = $root.google.ads.googleads.v1.services.AdGroupCriterionOperation.fromObject(object.adGroupCriterionOperation);
                            }
                            if (object.adGroupExtensionSettingOperation != null) {
                                if (typeof object.adGroupExtensionSettingOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.adGroupExtensionSettingOperation: object expected");
                                message.adGroupExtensionSettingOperation = $root.google.ads.googleads.v1.services.AdGroupExtensionSettingOperation.fromObject(object.adGroupExtensionSettingOperation);
                            }
                            if (object.adGroupFeedOperation != null) {
                                if (typeof object.adGroupFeedOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.adGroupFeedOperation: object expected");
                                message.adGroupFeedOperation = $root.google.ads.googleads.v1.services.AdGroupFeedOperation.fromObject(object.adGroupFeedOperation);
                            }
                            if (object.adGroupLabelOperation != null) {
                                if (typeof object.adGroupLabelOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.adGroupLabelOperation: object expected");
                                message.adGroupLabelOperation = $root.google.ads.googleads.v1.services.AdGroupLabelOperation.fromObject(object.adGroupLabelOperation);
                            }
                            if (object.adGroupOperation != null) {
                                if (typeof object.adGroupOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.adGroupOperation: object expected");
                                message.adGroupOperation = $root.google.ads.googleads.v1.services.AdGroupOperation.fromObject(object.adGroupOperation);
                            }
                            if (object.adParameterOperation != null) {
                                if (typeof object.adParameterOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.adParameterOperation: object expected");
                                message.adParameterOperation = $root.google.ads.googleads.v1.services.AdParameterOperation.fromObject(object.adParameterOperation);
                            }
                            if (object.assetOperation != null) {
                                if (typeof object.assetOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.assetOperation: object expected");
                                message.assetOperation = $root.google.ads.googleads.v1.services.AssetOperation.fromObject(object.assetOperation);
                            }
                            if (object.biddingStrategyOperation != null) {
                                if (typeof object.biddingStrategyOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.biddingStrategyOperation: object expected");
                                message.biddingStrategyOperation = $root.google.ads.googleads.v1.services.BiddingStrategyOperation.fromObject(object.biddingStrategyOperation);
                            }
                            if (object.campaignBidModifierOperation != null) {
                                if (typeof object.campaignBidModifierOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.campaignBidModifierOperation: object expected");
                                message.campaignBidModifierOperation = $root.google.ads.googleads.v1.services.CampaignBidModifierOperation.fromObject(object.campaignBidModifierOperation);
                            }
                            if (object.campaignBudgetOperation != null) {
                                if (typeof object.campaignBudgetOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.campaignBudgetOperation: object expected");
                                message.campaignBudgetOperation = $root.google.ads.googleads.v1.services.CampaignBudgetOperation.fromObject(object.campaignBudgetOperation);
                            }
                            if (object.campaignCriterionOperation != null) {
                                if (typeof object.campaignCriterionOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.campaignCriterionOperation: object expected");
                                message.campaignCriterionOperation = $root.google.ads.googleads.v1.services.CampaignCriterionOperation.fromObject(object.campaignCriterionOperation);
                            }
                            if (object.campaignExtensionSettingOperation != null) {
                                if (typeof object.campaignExtensionSettingOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.campaignExtensionSettingOperation: object expected");
                                message.campaignExtensionSettingOperation = $root.google.ads.googleads.v1.services.CampaignExtensionSettingOperation.fromObject(object.campaignExtensionSettingOperation);
                            }
                            if (object.campaignFeedOperation != null) {
                                if (typeof object.campaignFeedOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.campaignFeedOperation: object expected");
                                message.campaignFeedOperation = $root.google.ads.googleads.v1.services.CampaignFeedOperation.fromObject(object.campaignFeedOperation);
                            }
                            if (object.campaignLabelOperation != null) {
                                if (typeof object.campaignLabelOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.campaignLabelOperation: object expected");
                                message.campaignLabelOperation = $root.google.ads.googleads.v1.services.CampaignLabelOperation.fromObject(object.campaignLabelOperation);
                            }
                            if (object.campaignOperation != null) {
                                if (typeof object.campaignOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.campaignOperation: object expected");
                                message.campaignOperation = $root.google.ads.googleads.v1.services.CampaignOperation.fromObject(object.campaignOperation);
                            }
                            if (object.campaignSharedSetOperation != null) {
                                if (typeof object.campaignSharedSetOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.campaignSharedSetOperation: object expected");
                                message.campaignSharedSetOperation = $root.google.ads.googleads.v1.services.CampaignSharedSetOperation.fromObject(object.campaignSharedSetOperation);
                            }
                            if (object.conversionActionOperation != null) {
                                if (typeof object.conversionActionOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.conversionActionOperation: object expected");
                                message.conversionActionOperation = $root.google.ads.googleads.v1.services.ConversionActionOperation.fromObject(object.conversionActionOperation);
                            }
                            if (object.customerExtensionSettingOperation != null) {
                                if (typeof object.customerExtensionSettingOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.customerExtensionSettingOperation: object expected");
                                message.customerExtensionSettingOperation = $root.google.ads.googleads.v1.services.CustomerExtensionSettingOperation.fromObject(object.customerExtensionSettingOperation);
                            }
                            if (object.customerFeedOperation != null) {
                                if (typeof object.customerFeedOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.customerFeedOperation: object expected");
                                message.customerFeedOperation = $root.google.ads.googleads.v1.services.CustomerFeedOperation.fromObject(object.customerFeedOperation);
                            }
                            if (object.customerLabelOperation != null) {
                                if (typeof object.customerLabelOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.customerLabelOperation: object expected");
                                message.customerLabelOperation = $root.google.ads.googleads.v1.services.CustomerLabelOperation.fromObject(object.customerLabelOperation);
                            }
                            if (object.customerNegativeCriterionOperation != null) {
                                if (typeof object.customerNegativeCriterionOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.customerNegativeCriterionOperation: object expected");
                                message.customerNegativeCriterionOperation = $root.google.ads.googleads.v1.services.CustomerNegativeCriterionOperation.fromObject(object.customerNegativeCriterionOperation);
                            }
                            if (object.customerOperation != null) {
                                if (typeof object.customerOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.customerOperation: object expected");
                                message.customerOperation = $root.google.ads.googleads.v1.services.CustomerOperation.fromObject(object.customerOperation);
                            }
                            if (object.extensionFeedItemOperation != null) {
                                if (typeof object.extensionFeedItemOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.extensionFeedItemOperation: object expected");
                                message.extensionFeedItemOperation = $root.google.ads.googleads.v1.services.ExtensionFeedItemOperation.fromObject(object.extensionFeedItemOperation);
                            }
                            if (object.feedItemOperation != null) {
                                if (typeof object.feedItemOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.feedItemOperation: object expected");
                                message.feedItemOperation = $root.google.ads.googleads.v1.services.FeedItemOperation.fromObject(object.feedItemOperation);
                            }
                            if (object.feedItemTargetOperation != null) {
                                if (typeof object.feedItemTargetOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.feedItemTargetOperation: object expected");
                                message.feedItemTargetOperation = $root.google.ads.googleads.v1.services.FeedItemTargetOperation.fromObject(object.feedItemTargetOperation);
                            }
                            if (object.feedMappingOperation != null) {
                                if (typeof object.feedMappingOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.feedMappingOperation: object expected");
                                message.feedMappingOperation = $root.google.ads.googleads.v1.services.FeedMappingOperation.fromObject(object.feedMappingOperation);
                            }
                            if (object.feedOperation != null) {
                                if (typeof object.feedOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.feedOperation: object expected");
                                message.feedOperation = $root.google.ads.googleads.v1.services.FeedOperation.fromObject(object.feedOperation);
                            }
                            if (object.labelOperation != null) {
                                if (typeof object.labelOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.labelOperation: object expected");
                                message.labelOperation = $root.google.ads.googleads.v1.services.LabelOperation.fromObject(object.labelOperation);
                            }
                            if (object.mediaFileOperation != null) {
                                if (typeof object.mediaFileOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.mediaFileOperation: object expected");
                                message.mediaFileOperation = $root.google.ads.googleads.v1.services.MediaFileOperation.fromObject(object.mediaFileOperation);
                            }
                            if (object.remarketingActionOperation != null) {
                                if (typeof object.remarketingActionOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.remarketingActionOperation: object expected");
                                message.remarketingActionOperation = $root.google.ads.googleads.v1.services.RemarketingActionOperation.fromObject(object.remarketingActionOperation);
                            }
                            if (object.sharedCriterionOperation != null) {
                                if (typeof object.sharedCriterionOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.sharedCriterionOperation: object expected");
                                message.sharedCriterionOperation = $root.google.ads.googleads.v1.services.SharedCriterionOperation.fromObject(object.sharedCriterionOperation);
                            }
                            if (object.sharedSetOperation != null) {
                                if (typeof object.sharedSetOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.sharedSetOperation: object expected");
                                message.sharedSetOperation = $root.google.ads.googleads.v1.services.SharedSetOperation.fromObject(object.sharedSetOperation);
                            }
                            if (object.userListOperation != null) {
                                if (typeof object.userListOperation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperation.userListOperation: object expected");
                                message.userListOperation = $root.google.ads.googleads.v1.services.UserListOperation.fromObject(object.userListOperation);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateOperation} message MutateOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.adGroupAdOperation != null && message.hasOwnProperty("adGroupAdOperation")) {
                                object.adGroupAdOperation = $root.google.ads.googleads.v1.services.AdGroupAdOperation.toObject(message.adGroupAdOperation, options);
                                if (options.oneofs)
                                    object.operation = "adGroupAdOperation";
                            }
                            if (message.adGroupBidModifierOperation != null && message.hasOwnProperty("adGroupBidModifierOperation")) {
                                object.adGroupBidModifierOperation = $root.google.ads.googleads.v1.services.AdGroupBidModifierOperation.toObject(message.adGroupBidModifierOperation, options);
                                if (options.oneofs)
                                    object.operation = "adGroupBidModifierOperation";
                            }
                            if (message.adGroupCriterionOperation != null && message.hasOwnProperty("adGroupCriterionOperation")) {
                                object.adGroupCriterionOperation = $root.google.ads.googleads.v1.services.AdGroupCriterionOperation.toObject(message.adGroupCriterionOperation, options);
                                if (options.oneofs)
                                    object.operation = "adGroupCriterionOperation";
                            }
                            if (message.adGroupOperation != null && message.hasOwnProperty("adGroupOperation")) {
                                object.adGroupOperation = $root.google.ads.googleads.v1.services.AdGroupOperation.toObject(message.adGroupOperation, options);
                                if (options.oneofs)
                                    object.operation = "adGroupOperation";
                            }
                            if (message.biddingStrategyOperation != null && message.hasOwnProperty("biddingStrategyOperation")) {
                                object.biddingStrategyOperation = $root.google.ads.googleads.v1.services.BiddingStrategyOperation.toObject(message.biddingStrategyOperation, options);
                                if (options.oneofs)
                                    object.operation = "biddingStrategyOperation";
                            }
                            if (message.campaignBidModifierOperation != null && message.hasOwnProperty("campaignBidModifierOperation")) {
                                object.campaignBidModifierOperation = $root.google.ads.googleads.v1.services.CampaignBidModifierOperation.toObject(message.campaignBidModifierOperation, options);
                                if (options.oneofs)
                                    object.operation = "campaignBidModifierOperation";
                            }
                            if (message.campaignBudgetOperation != null && message.hasOwnProperty("campaignBudgetOperation")) {
                                object.campaignBudgetOperation = $root.google.ads.googleads.v1.services.CampaignBudgetOperation.toObject(message.campaignBudgetOperation, options);
                                if (options.oneofs)
                                    object.operation = "campaignBudgetOperation";
                            }
                            if (message.campaignOperation != null && message.hasOwnProperty("campaignOperation")) {
                                object.campaignOperation = $root.google.ads.googleads.v1.services.CampaignOperation.toObject(message.campaignOperation, options);
                                if (options.oneofs)
                                    object.operation = "campaignOperation";
                            }
                            if (message.campaignSharedSetOperation != null && message.hasOwnProperty("campaignSharedSetOperation")) {
                                object.campaignSharedSetOperation = $root.google.ads.googleads.v1.services.CampaignSharedSetOperation.toObject(message.campaignSharedSetOperation, options);
                                if (options.oneofs)
                                    object.operation = "campaignSharedSetOperation";
                            }
                            if (message.conversionActionOperation != null && message.hasOwnProperty("conversionActionOperation")) {
                                object.conversionActionOperation = $root.google.ads.googleads.v1.services.ConversionActionOperation.toObject(message.conversionActionOperation, options);
                                if (options.oneofs)
                                    object.operation = "conversionActionOperation";
                            }
                            if (message.campaignCriterionOperation != null && message.hasOwnProperty("campaignCriterionOperation")) {
                                object.campaignCriterionOperation = $root.google.ads.googleads.v1.services.CampaignCriterionOperation.toObject(message.campaignCriterionOperation, options);
                                if (options.oneofs)
                                    object.operation = "campaignCriterionOperation";
                            }
                            if (message.sharedCriterionOperation != null && message.hasOwnProperty("sharedCriterionOperation")) {
                                object.sharedCriterionOperation = $root.google.ads.googleads.v1.services.SharedCriterionOperation.toObject(message.sharedCriterionOperation, options);
                                if (options.oneofs)
                                    object.operation = "sharedCriterionOperation";
                            }
                            if (message.sharedSetOperation != null && message.hasOwnProperty("sharedSetOperation")) {
                                object.sharedSetOperation = $root.google.ads.googleads.v1.services.SharedSetOperation.toObject(message.sharedSetOperation, options);
                                if (options.oneofs)
                                    object.operation = "sharedSetOperation";
                            }
                            if (message.userListOperation != null && message.hasOwnProperty("userListOperation")) {
                                object.userListOperation = $root.google.ads.googleads.v1.services.UserListOperation.toObject(message.userListOperation, options);
                                if (options.oneofs)
                                    object.operation = "userListOperation";
                            }
                            if (message.adGroupAdLabelOperation != null && message.hasOwnProperty("adGroupAdLabelOperation")) {
                                object.adGroupAdLabelOperation = $root.google.ads.googleads.v1.services.AdGroupAdLabelOperation.toObject(message.adGroupAdLabelOperation, options);
                                if (options.oneofs)
                                    object.operation = "adGroupAdLabelOperation";
                            }
                            if (message.adGroupCriterionLabelOperation != null && message.hasOwnProperty("adGroupCriterionLabelOperation")) {
                                object.adGroupCriterionLabelOperation = $root.google.ads.googleads.v1.services.AdGroupCriterionLabelOperation.toObject(message.adGroupCriterionLabelOperation, options);
                                if (options.oneofs)
                                    object.operation = "adGroupCriterionLabelOperation";
                            }
                            if (message.adGroupExtensionSettingOperation != null && message.hasOwnProperty("adGroupExtensionSettingOperation")) {
                                object.adGroupExtensionSettingOperation = $root.google.ads.googleads.v1.services.AdGroupExtensionSettingOperation.toObject(message.adGroupExtensionSettingOperation, options);
                                if (options.oneofs)
                                    object.operation = "adGroupExtensionSettingOperation";
                            }
                            if (message.adGroupFeedOperation != null && message.hasOwnProperty("adGroupFeedOperation")) {
                                object.adGroupFeedOperation = $root.google.ads.googleads.v1.services.AdGroupFeedOperation.toObject(message.adGroupFeedOperation, options);
                                if (options.oneofs)
                                    object.operation = "adGroupFeedOperation";
                            }
                            if (message.adGroupLabelOperation != null && message.hasOwnProperty("adGroupLabelOperation")) {
                                object.adGroupLabelOperation = $root.google.ads.googleads.v1.services.AdGroupLabelOperation.toObject(message.adGroupLabelOperation, options);
                                if (options.oneofs)
                                    object.operation = "adGroupLabelOperation";
                            }
                            if (message.adParameterOperation != null && message.hasOwnProperty("adParameterOperation")) {
                                object.adParameterOperation = $root.google.ads.googleads.v1.services.AdParameterOperation.toObject(message.adParameterOperation, options);
                                if (options.oneofs)
                                    object.operation = "adParameterOperation";
                            }
                            if (message.assetOperation != null && message.hasOwnProperty("assetOperation")) {
                                object.assetOperation = $root.google.ads.googleads.v1.services.AssetOperation.toObject(message.assetOperation, options);
                                if (options.oneofs)
                                    object.operation = "assetOperation";
                            }
                            if (message.campaignExtensionSettingOperation != null && message.hasOwnProperty("campaignExtensionSettingOperation")) {
                                object.campaignExtensionSettingOperation = $root.google.ads.googleads.v1.services.CampaignExtensionSettingOperation.toObject(message.campaignExtensionSettingOperation, options);
                                if (options.oneofs)
                                    object.operation = "campaignExtensionSettingOperation";
                            }
                            if (message.campaignFeedOperation != null && message.hasOwnProperty("campaignFeedOperation")) {
                                object.campaignFeedOperation = $root.google.ads.googleads.v1.services.CampaignFeedOperation.toObject(message.campaignFeedOperation, options);
                                if (options.oneofs)
                                    object.operation = "campaignFeedOperation";
                            }
                            if (message.campaignLabelOperation != null && message.hasOwnProperty("campaignLabelOperation")) {
                                object.campaignLabelOperation = $root.google.ads.googleads.v1.services.CampaignLabelOperation.toObject(message.campaignLabelOperation, options);
                                if (options.oneofs)
                                    object.operation = "campaignLabelOperation";
                            }
                            if (message.customerExtensionSettingOperation != null && message.hasOwnProperty("customerExtensionSettingOperation")) {
                                object.customerExtensionSettingOperation = $root.google.ads.googleads.v1.services.CustomerExtensionSettingOperation.toObject(message.customerExtensionSettingOperation, options);
                                if (options.oneofs)
                                    object.operation = "customerExtensionSettingOperation";
                            }
                            if (message.customerFeedOperation != null && message.hasOwnProperty("customerFeedOperation")) {
                                object.customerFeedOperation = $root.google.ads.googleads.v1.services.CustomerFeedOperation.toObject(message.customerFeedOperation, options);
                                if (options.oneofs)
                                    object.operation = "customerFeedOperation";
                            }
                            if (message.customerLabelOperation != null && message.hasOwnProperty("customerLabelOperation")) {
                                object.customerLabelOperation = $root.google.ads.googleads.v1.services.CustomerLabelOperation.toObject(message.customerLabelOperation, options);
                                if (options.oneofs)
                                    object.operation = "customerLabelOperation";
                            }
                            if (message.customerNegativeCriterionOperation != null && message.hasOwnProperty("customerNegativeCriterionOperation")) {
                                object.customerNegativeCriterionOperation = $root.google.ads.googleads.v1.services.CustomerNegativeCriterionOperation.toObject(message.customerNegativeCriterionOperation, options);
                                if (options.oneofs)
                                    object.operation = "customerNegativeCriterionOperation";
                            }
                            if (message.customerOperation != null && message.hasOwnProperty("customerOperation")) {
                                object.customerOperation = $root.google.ads.googleads.v1.services.CustomerOperation.toObject(message.customerOperation, options);
                                if (options.oneofs)
                                    object.operation = "customerOperation";
                            }
                            if (message.extensionFeedItemOperation != null && message.hasOwnProperty("extensionFeedItemOperation")) {
                                object.extensionFeedItemOperation = $root.google.ads.googleads.v1.services.ExtensionFeedItemOperation.toObject(message.extensionFeedItemOperation, options);
                                if (options.oneofs)
                                    object.operation = "extensionFeedItemOperation";
                            }
                            if (message.feedItemOperation != null && message.hasOwnProperty("feedItemOperation")) {
                                object.feedItemOperation = $root.google.ads.googleads.v1.services.FeedItemOperation.toObject(message.feedItemOperation, options);
                                if (options.oneofs)
                                    object.operation = "feedItemOperation";
                            }
                            if (message.feedItemTargetOperation != null && message.hasOwnProperty("feedItemTargetOperation")) {
                                object.feedItemTargetOperation = $root.google.ads.googleads.v1.services.FeedItemTargetOperation.toObject(message.feedItemTargetOperation, options);
                                if (options.oneofs)
                                    object.operation = "feedItemTargetOperation";
                            }
                            if (message.feedMappingOperation != null && message.hasOwnProperty("feedMappingOperation")) {
                                object.feedMappingOperation = $root.google.ads.googleads.v1.services.FeedMappingOperation.toObject(message.feedMappingOperation, options);
                                if (options.oneofs)
                                    object.operation = "feedMappingOperation";
                            }
                            if (message.feedOperation != null && message.hasOwnProperty("feedOperation")) {
                                object.feedOperation = $root.google.ads.googleads.v1.services.FeedOperation.toObject(message.feedOperation, options);
                                if (options.oneofs)
                                    object.operation = "feedOperation";
                            }
                            if (message.labelOperation != null && message.hasOwnProperty("labelOperation")) {
                                object.labelOperation = $root.google.ads.googleads.v1.services.LabelOperation.toObject(message.labelOperation, options);
                                if (options.oneofs)
                                    object.operation = "labelOperation";
                            }
                            if (message.mediaFileOperation != null && message.hasOwnProperty("mediaFileOperation")) {
                                object.mediaFileOperation = $root.google.ads.googleads.v1.services.MediaFileOperation.toObject(message.mediaFileOperation, options);
                                if (options.oneofs)
                                    object.operation = "mediaFileOperation";
                            }
                            if (message.remarketingActionOperation != null && message.hasOwnProperty("remarketingActionOperation")) {
                                object.remarketingActionOperation = $root.google.ads.googleads.v1.services.RemarketingActionOperation.toObject(message.remarketingActionOperation, options);
                                if (options.oneofs)
                                    object.operation = "remarketingActionOperation";
                            }
                            return object;
                        };

                        /**
                         * Converts this MutateOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateOperation;
                    })();

                    services.MutateOperationResponse = (function() {

                        /**
                         * Properties of a MutateOperationResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateOperationResponse
                         * @property {google.ads.googleads.v1.services.IMutateAdGroupAdLabelResult|null} [adGroupAdLabelResult] MutateOperationResponse adGroupAdLabelResult
                         * @property {google.ads.googleads.v1.services.IMutateAdGroupAdResult|null} [adGroupAdResult] MutateOperationResponse adGroupAdResult
                         * @property {google.ads.googleads.v1.services.IMutateAdGroupBidModifierResult|null} [adGroupBidModifierResult] MutateOperationResponse adGroupBidModifierResult
                         * @property {google.ads.googleads.v1.services.IMutateAdGroupCriterionLabelResult|null} [adGroupCriterionLabelResult] MutateOperationResponse adGroupCriterionLabelResult
                         * @property {google.ads.googleads.v1.services.IMutateAdGroupCriterionResult|null} [adGroupCriterionResult] MutateOperationResponse adGroupCriterionResult
                         * @property {google.ads.googleads.v1.services.IMutateAdGroupExtensionSettingResult|null} [adGroupExtensionSettingResult] MutateOperationResponse adGroupExtensionSettingResult
                         * @property {google.ads.googleads.v1.services.IMutateAdGroupFeedResult|null} [adGroupFeedResult] MutateOperationResponse adGroupFeedResult
                         * @property {google.ads.googleads.v1.services.IMutateAdGroupLabelResult|null} [adGroupLabelResult] MutateOperationResponse adGroupLabelResult
                         * @property {google.ads.googleads.v1.services.IMutateAdGroupResult|null} [adGroupResult] MutateOperationResponse adGroupResult
                         * @property {google.ads.googleads.v1.services.IMutateAdParameterResult|null} [adParameterResult] MutateOperationResponse adParameterResult
                         * @property {google.ads.googleads.v1.services.IMutateAssetResult|null} [assetResult] MutateOperationResponse assetResult
                         * @property {google.ads.googleads.v1.services.IMutateBiddingStrategyResult|null} [biddingStrategyResult] MutateOperationResponse biddingStrategyResult
                         * @property {google.ads.googleads.v1.services.IMutateCampaignBidModifierResult|null} [campaignBidModifierResult] MutateOperationResponse campaignBidModifierResult
                         * @property {google.ads.googleads.v1.services.IMutateCampaignBudgetResult|null} [campaignBudgetResult] MutateOperationResponse campaignBudgetResult
                         * @property {google.ads.googleads.v1.services.IMutateCampaignCriterionResult|null} [campaignCriterionResult] MutateOperationResponse campaignCriterionResult
                         * @property {google.ads.googleads.v1.services.IMutateCampaignExtensionSettingResult|null} [campaignExtensionSettingResult] MutateOperationResponse campaignExtensionSettingResult
                         * @property {google.ads.googleads.v1.services.IMutateCampaignFeedResult|null} [campaignFeedResult] MutateOperationResponse campaignFeedResult
                         * @property {google.ads.googleads.v1.services.IMutateCampaignLabelResult|null} [campaignLabelResult] MutateOperationResponse campaignLabelResult
                         * @property {google.ads.googleads.v1.services.IMutateCampaignResult|null} [campaignResult] MutateOperationResponse campaignResult
                         * @property {google.ads.googleads.v1.services.IMutateCampaignSharedSetResult|null} [campaignSharedSetResult] MutateOperationResponse campaignSharedSetResult
                         * @property {google.ads.googleads.v1.services.IMutateConversionActionResult|null} [conversionActionResult] MutateOperationResponse conversionActionResult
                         * @property {google.ads.googleads.v1.services.IMutateCustomerExtensionSettingResult|null} [customerExtensionSettingResult] MutateOperationResponse customerExtensionSettingResult
                         * @property {google.ads.googleads.v1.services.IMutateCustomerFeedResult|null} [customerFeedResult] MutateOperationResponse customerFeedResult
                         * @property {google.ads.googleads.v1.services.IMutateCustomerLabelResult|null} [customerLabelResult] MutateOperationResponse customerLabelResult
                         * @property {google.ads.googleads.v1.services.IMutateCustomerNegativeCriteriaResult|null} [customerNegativeCriterionResult] MutateOperationResponse customerNegativeCriterionResult
                         * @property {google.ads.googleads.v1.services.IMutateCustomerResult|null} [customerResult] MutateOperationResponse customerResult
                         * @property {google.ads.googleads.v1.services.IMutateExtensionFeedItemResult|null} [extensionFeedItemResult] MutateOperationResponse extensionFeedItemResult
                         * @property {google.ads.googleads.v1.services.IMutateFeedItemResult|null} [feedItemResult] MutateOperationResponse feedItemResult
                         * @property {google.ads.googleads.v1.services.IMutateFeedItemTargetResult|null} [feedItemTargetResult] MutateOperationResponse feedItemTargetResult
                         * @property {google.ads.googleads.v1.services.IMutateFeedMappingResult|null} [feedMappingResult] MutateOperationResponse feedMappingResult
                         * @property {google.ads.googleads.v1.services.IMutateFeedResult|null} [feedResult] MutateOperationResponse feedResult
                         * @property {google.ads.googleads.v1.services.IMutateLabelResult|null} [labelResult] MutateOperationResponse labelResult
                         * @property {google.ads.googleads.v1.services.IMutateMediaFileResult|null} [mediaFileResult] MutateOperationResponse mediaFileResult
                         * @property {google.ads.googleads.v1.services.IMutateRemarketingActionResult|null} [remarketingActionResult] MutateOperationResponse remarketingActionResult
                         * @property {google.ads.googleads.v1.services.IMutateSharedCriterionResult|null} [sharedCriterionResult] MutateOperationResponse sharedCriterionResult
                         * @property {google.ads.googleads.v1.services.IMutateSharedSetResult|null} [sharedSetResult] MutateOperationResponse sharedSetResult
                         * @property {google.ads.googleads.v1.services.IMutateUserListResult|null} [userListResult] MutateOperationResponse userListResult
                         */

                        /**
                         * Constructs a new MutateOperationResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateOperationResponse.
                         * @implements IMutateOperationResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateOperationResponse=} [properties] Properties to set
                         */
                        function MutateOperationResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateOperationResponse adGroupAdLabelResult.
                         * @member {google.ads.googleads.v1.services.IMutateAdGroupAdLabelResult|null|undefined} adGroupAdLabelResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.adGroupAdLabelResult = null;

                        /**
                         * MutateOperationResponse adGroupAdResult.
                         * @member {google.ads.googleads.v1.services.IMutateAdGroupAdResult|null|undefined} adGroupAdResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.adGroupAdResult = null;

                        /**
                         * MutateOperationResponse adGroupBidModifierResult.
                         * @member {google.ads.googleads.v1.services.IMutateAdGroupBidModifierResult|null|undefined} adGroupBidModifierResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.adGroupBidModifierResult = null;

                        /**
                         * MutateOperationResponse adGroupCriterionLabelResult.
                         * @member {google.ads.googleads.v1.services.IMutateAdGroupCriterionLabelResult|null|undefined} adGroupCriterionLabelResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.adGroupCriterionLabelResult = null;

                        /**
                         * MutateOperationResponse adGroupCriterionResult.
                         * @member {google.ads.googleads.v1.services.IMutateAdGroupCriterionResult|null|undefined} adGroupCriterionResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.adGroupCriterionResult = null;

                        /**
                         * MutateOperationResponse adGroupExtensionSettingResult.
                         * @member {google.ads.googleads.v1.services.IMutateAdGroupExtensionSettingResult|null|undefined} adGroupExtensionSettingResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.adGroupExtensionSettingResult = null;

                        /**
                         * MutateOperationResponse adGroupFeedResult.
                         * @member {google.ads.googleads.v1.services.IMutateAdGroupFeedResult|null|undefined} adGroupFeedResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.adGroupFeedResult = null;

                        /**
                         * MutateOperationResponse adGroupLabelResult.
                         * @member {google.ads.googleads.v1.services.IMutateAdGroupLabelResult|null|undefined} adGroupLabelResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.adGroupLabelResult = null;

                        /**
                         * MutateOperationResponse adGroupResult.
                         * @member {google.ads.googleads.v1.services.IMutateAdGroupResult|null|undefined} adGroupResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.adGroupResult = null;

                        /**
                         * MutateOperationResponse adParameterResult.
                         * @member {google.ads.googleads.v1.services.IMutateAdParameterResult|null|undefined} adParameterResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.adParameterResult = null;

                        /**
                         * MutateOperationResponse assetResult.
                         * @member {google.ads.googleads.v1.services.IMutateAssetResult|null|undefined} assetResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.assetResult = null;

                        /**
                         * MutateOperationResponse biddingStrategyResult.
                         * @member {google.ads.googleads.v1.services.IMutateBiddingStrategyResult|null|undefined} biddingStrategyResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.biddingStrategyResult = null;

                        /**
                         * MutateOperationResponse campaignBidModifierResult.
                         * @member {google.ads.googleads.v1.services.IMutateCampaignBidModifierResult|null|undefined} campaignBidModifierResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.campaignBidModifierResult = null;

                        /**
                         * MutateOperationResponse campaignBudgetResult.
                         * @member {google.ads.googleads.v1.services.IMutateCampaignBudgetResult|null|undefined} campaignBudgetResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.campaignBudgetResult = null;

                        /**
                         * MutateOperationResponse campaignCriterionResult.
                         * @member {google.ads.googleads.v1.services.IMutateCampaignCriterionResult|null|undefined} campaignCriterionResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.campaignCriterionResult = null;

                        /**
                         * MutateOperationResponse campaignExtensionSettingResult.
                         * @member {google.ads.googleads.v1.services.IMutateCampaignExtensionSettingResult|null|undefined} campaignExtensionSettingResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.campaignExtensionSettingResult = null;

                        /**
                         * MutateOperationResponse campaignFeedResult.
                         * @member {google.ads.googleads.v1.services.IMutateCampaignFeedResult|null|undefined} campaignFeedResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.campaignFeedResult = null;

                        /**
                         * MutateOperationResponse campaignLabelResult.
                         * @member {google.ads.googleads.v1.services.IMutateCampaignLabelResult|null|undefined} campaignLabelResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.campaignLabelResult = null;

                        /**
                         * MutateOperationResponse campaignResult.
                         * @member {google.ads.googleads.v1.services.IMutateCampaignResult|null|undefined} campaignResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.campaignResult = null;

                        /**
                         * MutateOperationResponse campaignSharedSetResult.
                         * @member {google.ads.googleads.v1.services.IMutateCampaignSharedSetResult|null|undefined} campaignSharedSetResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.campaignSharedSetResult = null;

                        /**
                         * MutateOperationResponse conversionActionResult.
                         * @member {google.ads.googleads.v1.services.IMutateConversionActionResult|null|undefined} conversionActionResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.conversionActionResult = null;

                        /**
                         * MutateOperationResponse customerExtensionSettingResult.
                         * @member {google.ads.googleads.v1.services.IMutateCustomerExtensionSettingResult|null|undefined} customerExtensionSettingResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.customerExtensionSettingResult = null;

                        /**
                         * MutateOperationResponse customerFeedResult.
                         * @member {google.ads.googleads.v1.services.IMutateCustomerFeedResult|null|undefined} customerFeedResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.customerFeedResult = null;

                        /**
                         * MutateOperationResponse customerLabelResult.
                         * @member {google.ads.googleads.v1.services.IMutateCustomerLabelResult|null|undefined} customerLabelResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.customerLabelResult = null;

                        /**
                         * MutateOperationResponse customerNegativeCriterionResult.
                         * @member {google.ads.googleads.v1.services.IMutateCustomerNegativeCriteriaResult|null|undefined} customerNegativeCriterionResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.customerNegativeCriterionResult = null;

                        /**
                         * MutateOperationResponse customerResult.
                         * @member {google.ads.googleads.v1.services.IMutateCustomerResult|null|undefined} customerResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.customerResult = null;

                        /**
                         * MutateOperationResponse extensionFeedItemResult.
                         * @member {google.ads.googleads.v1.services.IMutateExtensionFeedItemResult|null|undefined} extensionFeedItemResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.extensionFeedItemResult = null;

                        /**
                         * MutateOperationResponse feedItemResult.
                         * @member {google.ads.googleads.v1.services.IMutateFeedItemResult|null|undefined} feedItemResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.feedItemResult = null;

                        /**
                         * MutateOperationResponse feedItemTargetResult.
                         * @member {google.ads.googleads.v1.services.IMutateFeedItemTargetResult|null|undefined} feedItemTargetResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.feedItemTargetResult = null;

                        /**
                         * MutateOperationResponse feedMappingResult.
                         * @member {google.ads.googleads.v1.services.IMutateFeedMappingResult|null|undefined} feedMappingResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.feedMappingResult = null;

                        /**
                         * MutateOperationResponse feedResult.
                         * @member {google.ads.googleads.v1.services.IMutateFeedResult|null|undefined} feedResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.feedResult = null;

                        /**
                         * MutateOperationResponse labelResult.
                         * @member {google.ads.googleads.v1.services.IMutateLabelResult|null|undefined} labelResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.labelResult = null;

                        /**
                         * MutateOperationResponse mediaFileResult.
                         * @member {google.ads.googleads.v1.services.IMutateMediaFileResult|null|undefined} mediaFileResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.mediaFileResult = null;

                        /**
                         * MutateOperationResponse remarketingActionResult.
                         * @member {google.ads.googleads.v1.services.IMutateRemarketingActionResult|null|undefined} remarketingActionResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.remarketingActionResult = null;

                        /**
                         * MutateOperationResponse sharedCriterionResult.
                         * @member {google.ads.googleads.v1.services.IMutateSharedCriterionResult|null|undefined} sharedCriterionResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.sharedCriterionResult = null;

                        /**
                         * MutateOperationResponse sharedSetResult.
                         * @member {google.ads.googleads.v1.services.IMutateSharedSetResult|null|undefined} sharedSetResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.sharedSetResult = null;

                        /**
                         * MutateOperationResponse userListResult.
                         * @member {google.ads.googleads.v1.services.IMutateUserListResult|null|undefined} userListResult
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        MutateOperationResponse.prototype.userListResult = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * MutateOperationResponse response.
                         * @member {"adGroupAdLabelResult"|"adGroupAdResult"|"adGroupBidModifierResult"|"adGroupCriterionLabelResult"|"adGroupCriterionResult"|"adGroupExtensionSettingResult"|"adGroupFeedResult"|"adGroupLabelResult"|"adGroupResult"|"adParameterResult"|"assetResult"|"biddingStrategyResult"|"campaignBidModifierResult"|"campaignBudgetResult"|"campaignCriterionResult"|"campaignExtensionSettingResult"|"campaignFeedResult"|"campaignLabelResult"|"campaignResult"|"campaignSharedSetResult"|"conversionActionResult"|"customerExtensionSettingResult"|"customerFeedResult"|"customerLabelResult"|"customerNegativeCriterionResult"|"customerResult"|"extensionFeedItemResult"|"feedItemResult"|"feedItemTargetResult"|"feedMappingResult"|"feedResult"|"labelResult"|"mediaFileResult"|"remarketingActionResult"|"sharedCriterionResult"|"sharedSetResult"|"userListResult"|undefined} response
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         */
                        Object.defineProperty(MutateOperationResponse.prototype, "response", {
                            get: $util.oneOfGetter($oneOfFields = ["adGroupAdLabelResult", "adGroupAdResult", "adGroupBidModifierResult", "adGroupCriterionLabelResult", "adGroupCriterionResult", "adGroupExtensionSettingResult", "adGroupFeedResult", "adGroupLabelResult", "adGroupResult", "adParameterResult", "assetResult", "biddingStrategyResult", "campaignBidModifierResult", "campaignBudgetResult", "campaignCriterionResult", "campaignExtensionSettingResult", "campaignFeedResult", "campaignLabelResult", "campaignResult", "campaignSharedSetResult", "conversionActionResult", "customerExtensionSettingResult", "customerFeedResult", "customerLabelResult", "customerNegativeCriterionResult", "customerResult", "extensionFeedItemResult", "feedItemResult", "feedItemTargetResult", "feedMappingResult", "feedResult", "labelResult", "mediaFileResult", "remarketingActionResult", "sharedCriterionResult", "sharedSetResult", "userListResult"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new MutateOperationResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateOperationResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateOperationResponse} MutateOperationResponse instance
                         */
                        MutateOperationResponse.create = function create(properties) {
                            return new MutateOperationResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateOperationResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateOperationResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateOperationResponse} message MutateOperationResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateOperationResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.adGroupAdResult != null && message.hasOwnProperty("adGroupAdResult"))
                                $root.google.ads.googleads.v1.services.MutateAdGroupAdResult.encode(message.adGroupAdResult, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.adGroupBidModifierResult != null && message.hasOwnProperty("adGroupBidModifierResult"))
                                $root.google.ads.googleads.v1.services.MutateAdGroupBidModifierResult.encode(message.adGroupBidModifierResult, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.adGroupCriterionResult != null && message.hasOwnProperty("adGroupCriterionResult"))
                                $root.google.ads.googleads.v1.services.MutateAdGroupCriterionResult.encode(message.adGroupCriterionResult, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.adGroupResult != null && message.hasOwnProperty("adGroupResult"))
                                $root.google.ads.googleads.v1.services.MutateAdGroupResult.encode(message.adGroupResult, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.biddingStrategyResult != null && message.hasOwnProperty("biddingStrategyResult"))
                                $root.google.ads.googleads.v1.services.MutateBiddingStrategyResult.encode(message.biddingStrategyResult, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.campaignBidModifierResult != null && message.hasOwnProperty("campaignBidModifierResult"))
                                $root.google.ads.googleads.v1.services.MutateCampaignBidModifierResult.encode(message.campaignBidModifierResult, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.campaignBudgetResult != null && message.hasOwnProperty("campaignBudgetResult"))
                                $root.google.ads.googleads.v1.services.MutateCampaignBudgetResult.encode(message.campaignBudgetResult, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.campaignResult != null && message.hasOwnProperty("campaignResult"))
                                $root.google.ads.googleads.v1.services.MutateCampaignResult.encode(message.campaignResult, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.campaignSharedSetResult != null && message.hasOwnProperty("campaignSharedSetResult"))
                                $root.google.ads.googleads.v1.services.MutateCampaignSharedSetResult.encode(message.campaignSharedSetResult, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.conversionActionResult != null && message.hasOwnProperty("conversionActionResult"))
                                $root.google.ads.googleads.v1.services.MutateConversionActionResult.encode(message.conversionActionResult, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.campaignCriterionResult != null && message.hasOwnProperty("campaignCriterionResult"))
                                $root.google.ads.googleads.v1.services.MutateCampaignCriterionResult.encode(message.campaignCriterionResult, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                            if (message.sharedCriterionResult != null && message.hasOwnProperty("sharedCriterionResult"))
                                $root.google.ads.googleads.v1.services.MutateSharedCriterionResult.encode(message.sharedCriterionResult, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                            if (message.sharedSetResult != null && message.hasOwnProperty("sharedSetResult"))
                                $root.google.ads.googleads.v1.services.MutateSharedSetResult.encode(message.sharedSetResult, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
                            if (message.userListResult != null && message.hasOwnProperty("userListResult"))
                                $root.google.ads.googleads.v1.services.MutateUserListResult.encode(message.userListResult, writer.uint32(/* id 16, wireType 2 =*/130).fork()).ldelim();
                            if (message.adGroupAdLabelResult != null && message.hasOwnProperty("adGroupAdLabelResult"))
                                $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelResult.encode(message.adGroupAdLabelResult, writer.uint32(/* id 17, wireType 2 =*/138).fork()).ldelim();
                            if (message.adGroupCriterionLabelResult != null && message.hasOwnProperty("adGroupCriterionLabelResult"))
                                $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult.encode(message.adGroupCriterionLabelResult, writer.uint32(/* id 18, wireType 2 =*/146).fork()).ldelim();
                            if (message.adGroupExtensionSettingResult != null && message.hasOwnProperty("adGroupExtensionSettingResult"))
                                $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult.encode(message.adGroupExtensionSettingResult, writer.uint32(/* id 19, wireType 2 =*/154).fork()).ldelim();
                            if (message.adGroupFeedResult != null && message.hasOwnProperty("adGroupFeedResult"))
                                $root.google.ads.googleads.v1.services.MutateAdGroupFeedResult.encode(message.adGroupFeedResult, writer.uint32(/* id 20, wireType 2 =*/162).fork()).ldelim();
                            if (message.adGroupLabelResult != null && message.hasOwnProperty("adGroupLabelResult"))
                                $root.google.ads.googleads.v1.services.MutateAdGroupLabelResult.encode(message.adGroupLabelResult, writer.uint32(/* id 21, wireType 2 =*/170).fork()).ldelim();
                            if (message.adParameterResult != null && message.hasOwnProperty("adParameterResult"))
                                $root.google.ads.googleads.v1.services.MutateAdParameterResult.encode(message.adParameterResult, writer.uint32(/* id 22, wireType 2 =*/178).fork()).ldelim();
                            if (message.assetResult != null && message.hasOwnProperty("assetResult"))
                                $root.google.ads.googleads.v1.services.MutateAssetResult.encode(message.assetResult, writer.uint32(/* id 23, wireType 2 =*/186).fork()).ldelim();
                            if (message.campaignExtensionSettingResult != null && message.hasOwnProperty("campaignExtensionSettingResult"))
                                $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult.encode(message.campaignExtensionSettingResult, writer.uint32(/* id 26, wireType 2 =*/210).fork()).ldelim();
                            if (message.campaignFeedResult != null && message.hasOwnProperty("campaignFeedResult"))
                                $root.google.ads.googleads.v1.services.MutateCampaignFeedResult.encode(message.campaignFeedResult, writer.uint32(/* id 27, wireType 2 =*/218).fork()).ldelim();
                            if (message.campaignLabelResult != null && message.hasOwnProperty("campaignLabelResult"))
                                $root.google.ads.googleads.v1.services.MutateCampaignLabelResult.encode(message.campaignLabelResult, writer.uint32(/* id 28, wireType 2 =*/226).fork()).ldelim();
                            if (message.customerExtensionSettingResult != null && message.hasOwnProperty("customerExtensionSettingResult"))
                                $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult.encode(message.customerExtensionSettingResult, writer.uint32(/* id 30, wireType 2 =*/242).fork()).ldelim();
                            if (message.customerFeedResult != null && message.hasOwnProperty("customerFeedResult"))
                                $root.google.ads.googleads.v1.services.MutateCustomerFeedResult.encode(message.customerFeedResult, writer.uint32(/* id 31, wireType 2 =*/250).fork()).ldelim();
                            if (message.customerLabelResult != null && message.hasOwnProperty("customerLabelResult"))
                                $root.google.ads.googleads.v1.services.MutateCustomerLabelResult.encode(message.customerLabelResult, writer.uint32(/* id 32, wireType 2 =*/258).fork()).ldelim();
                            if (message.customerNegativeCriterionResult != null && message.hasOwnProperty("customerNegativeCriterionResult"))
                                $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult.encode(message.customerNegativeCriterionResult, writer.uint32(/* id 34, wireType 2 =*/274).fork()).ldelim();
                            if (message.customerResult != null && message.hasOwnProperty("customerResult"))
                                $root.google.ads.googleads.v1.services.MutateCustomerResult.encode(message.customerResult, writer.uint32(/* id 35, wireType 2 =*/282).fork()).ldelim();
                            if (message.extensionFeedItemResult != null && message.hasOwnProperty("extensionFeedItemResult"))
                                $root.google.ads.googleads.v1.services.MutateExtensionFeedItemResult.encode(message.extensionFeedItemResult, writer.uint32(/* id 36, wireType 2 =*/290).fork()).ldelim();
                            if (message.feedItemResult != null && message.hasOwnProperty("feedItemResult"))
                                $root.google.ads.googleads.v1.services.MutateFeedItemResult.encode(message.feedItemResult, writer.uint32(/* id 37, wireType 2 =*/298).fork()).ldelim();
                            if (message.feedItemTargetResult != null && message.hasOwnProperty("feedItemTargetResult"))
                                $root.google.ads.googleads.v1.services.MutateFeedItemTargetResult.encode(message.feedItemTargetResult, writer.uint32(/* id 38, wireType 2 =*/306).fork()).ldelim();
                            if (message.feedMappingResult != null && message.hasOwnProperty("feedMappingResult"))
                                $root.google.ads.googleads.v1.services.MutateFeedMappingResult.encode(message.feedMappingResult, writer.uint32(/* id 39, wireType 2 =*/314).fork()).ldelim();
                            if (message.feedResult != null && message.hasOwnProperty("feedResult"))
                                $root.google.ads.googleads.v1.services.MutateFeedResult.encode(message.feedResult, writer.uint32(/* id 40, wireType 2 =*/322).fork()).ldelim();
                            if (message.labelResult != null && message.hasOwnProperty("labelResult"))
                                $root.google.ads.googleads.v1.services.MutateLabelResult.encode(message.labelResult, writer.uint32(/* id 41, wireType 2 =*/330).fork()).ldelim();
                            if (message.mediaFileResult != null && message.hasOwnProperty("mediaFileResult"))
                                $root.google.ads.googleads.v1.services.MutateMediaFileResult.encode(message.mediaFileResult, writer.uint32(/* id 42, wireType 2 =*/338).fork()).ldelim();
                            if (message.remarketingActionResult != null && message.hasOwnProperty("remarketingActionResult"))
                                $root.google.ads.googleads.v1.services.MutateRemarketingActionResult.encode(message.remarketingActionResult, writer.uint32(/* id 43, wireType 2 =*/346).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateOperationResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateOperationResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateOperationResponse} message MutateOperationResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateOperationResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateOperationResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateOperationResponse} MutateOperationResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateOperationResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateOperationResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 17:
                                    message.adGroupAdLabelResult = $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelResult.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.adGroupAdResult = $root.google.ads.googleads.v1.services.MutateAdGroupAdResult.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.adGroupBidModifierResult = $root.google.ads.googleads.v1.services.MutateAdGroupBidModifierResult.decode(reader, reader.uint32());
                                    break;
                                case 18:
                                    message.adGroupCriterionLabelResult = $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.adGroupCriterionResult = $root.google.ads.googleads.v1.services.MutateAdGroupCriterionResult.decode(reader, reader.uint32());
                                    break;
                                case 19:
                                    message.adGroupExtensionSettingResult = $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult.decode(reader, reader.uint32());
                                    break;
                                case 20:
                                    message.adGroupFeedResult = $root.google.ads.googleads.v1.services.MutateAdGroupFeedResult.decode(reader, reader.uint32());
                                    break;
                                case 21:
                                    message.adGroupLabelResult = $root.google.ads.googleads.v1.services.MutateAdGroupLabelResult.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.adGroupResult = $root.google.ads.googleads.v1.services.MutateAdGroupResult.decode(reader, reader.uint32());
                                    break;
                                case 22:
                                    message.adParameterResult = $root.google.ads.googleads.v1.services.MutateAdParameterResult.decode(reader, reader.uint32());
                                    break;
                                case 23:
                                    message.assetResult = $root.google.ads.googleads.v1.services.MutateAssetResult.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.biddingStrategyResult = $root.google.ads.googleads.v1.services.MutateBiddingStrategyResult.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.campaignBidModifierResult = $root.google.ads.googleads.v1.services.MutateCampaignBidModifierResult.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.campaignBudgetResult = $root.google.ads.googleads.v1.services.MutateCampaignBudgetResult.decode(reader, reader.uint32());
                                    break;
                                case 13:
                                    message.campaignCriterionResult = $root.google.ads.googleads.v1.services.MutateCampaignCriterionResult.decode(reader, reader.uint32());
                                    break;
                                case 26:
                                    message.campaignExtensionSettingResult = $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult.decode(reader, reader.uint32());
                                    break;
                                case 27:
                                    message.campaignFeedResult = $root.google.ads.googleads.v1.services.MutateCampaignFeedResult.decode(reader, reader.uint32());
                                    break;
                                case 28:
                                    message.campaignLabelResult = $root.google.ads.googleads.v1.services.MutateCampaignLabelResult.decode(reader, reader.uint32());
                                    break;
                                case 10:
                                    message.campaignResult = $root.google.ads.googleads.v1.services.MutateCampaignResult.decode(reader, reader.uint32());
                                    break;
                                case 11:
                                    message.campaignSharedSetResult = $root.google.ads.googleads.v1.services.MutateCampaignSharedSetResult.decode(reader, reader.uint32());
                                    break;
                                case 12:
                                    message.conversionActionResult = $root.google.ads.googleads.v1.services.MutateConversionActionResult.decode(reader, reader.uint32());
                                    break;
                                case 30:
                                    message.customerExtensionSettingResult = $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult.decode(reader, reader.uint32());
                                    break;
                                case 31:
                                    message.customerFeedResult = $root.google.ads.googleads.v1.services.MutateCustomerFeedResult.decode(reader, reader.uint32());
                                    break;
                                case 32:
                                    message.customerLabelResult = $root.google.ads.googleads.v1.services.MutateCustomerLabelResult.decode(reader, reader.uint32());
                                    break;
                                case 34:
                                    message.customerNegativeCriterionResult = $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult.decode(reader, reader.uint32());
                                    break;
                                case 35:
                                    message.customerResult = $root.google.ads.googleads.v1.services.MutateCustomerResult.decode(reader, reader.uint32());
                                    break;
                                case 36:
                                    message.extensionFeedItemResult = $root.google.ads.googleads.v1.services.MutateExtensionFeedItemResult.decode(reader, reader.uint32());
                                    break;
                                case 37:
                                    message.feedItemResult = $root.google.ads.googleads.v1.services.MutateFeedItemResult.decode(reader, reader.uint32());
                                    break;
                                case 38:
                                    message.feedItemTargetResult = $root.google.ads.googleads.v1.services.MutateFeedItemTargetResult.decode(reader, reader.uint32());
                                    break;
                                case 39:
                                    message.feedMappingResult = $root.google.ads.googleads.v1.services.MutateFeedMappingResult.decode(reader, reader.uint32());
                                    break;
                                case 40:
                                    message.feedResult = $root.google.ads.googleads.v1.services.MutateFeedResult.decode(reader, reader.uint32());
                                    break;
                                case 41:
                                    message.labelResult = $root.google.ads.googleads.v1.services.MutateLabelResult.decode(reader, reader.uint32());
                                    break;
                                case 42:
                                    message.mediaFileResult = $root.google.ads.googleads.v1.services.MutateMediaFileResult.decode(reader, reader.uint32());
                                    break;
                                case 43:
                                    message.remarketingActionResult = $root.google.ads.googleads.v1.services.MutateRemarketingActionResult.decode(reader, reader.uint32());
                                    break;
                                case 14:
                                    message.sharedCriterionResult = $root.google.ads.googleads.v1.services.MutateSharedCriterionResult.decode(reader, reader.uint32());
                                    break;
                                case 15:
                                    message.sharedSetResult = $root.google.ads.googleads.v1.services.MutateSharedSetResult.decode(reader, reader.uint32());
                                    break;
                                case 16:
                                    message.userListResult = $root.google.ads.googleads.v1.services.MutateUserListResult.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateOperationResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateOperationResponse} MutateOperationResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateOperationResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateOperationResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateOperationResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.adGroupAdLabelResult != null && message.hasOwnProperty("adGroupAdLabelResult")) {
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelResult.verify(message.adGroupAdLabelResult);
                                    if (error)
                                        return "adGroupAdLabelResult." + error;
                                }
                            }
                            if (message.adGroupAdResult != null && message.hasOwnProperty("adGroupAdResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdGroupAdResult.verify(message.adGroupAdResult);
                                    if (error)
                                        return "adGroupAdResult." + error;
                                }
                            }
                            if (message.adGroupBidModifierResult != null && message.hasOwnProperty("adGroupBidModifierResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdGroupBidModifierResult.verify(message.adGroupBidModifierResult);
                                    if (error)
                                        return "adGroupBidModifierResult." + error;
                                }
                            }
                            if (message.adGroupCriterionLabelResult != null && message.hasOwnProperty("adGroupCriterionLabelResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult.verify(message.adGroupCriterionLabelResult);
                                    if (error)
                                        return "adGroupCriterionLabelResult." + error;
                                }
                            }
                            if (message.adGroupCriterionResult != null && message.hasOwnProperty("adGroupCriterionResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdGroupCriterionResult.verify(message.adGroupCriterionResult);
                                    if (error)
                                        return "adGroupCriterionResult." + error;
                                }
                            }
                            if (message.adGroupExtensionSettingResult != null && message.hasOwnProperty("adGroupExtensionSettingResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult.verify(message.adGroupExtensionSettingResult);
                                    if (error)
                                        return "adGroupExtensionSettingResult." + error;
                                }
                            }
                            if (message.adGroupFeedResult != null && message.hasOwnProperty("adGroupFeedResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdGroupFeedResult.verify(message.adGroupFeedResult);
                                    if (error)
                                        return "adGroupFeedResult." + error;
                                }
                            }
                            if (message.adGroupLabelResult != null && message.hasOwnProperty("adGroupLabelResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdGroupLabelResult.verify(message.adGroupLabelResult);
                                    if (error)
                                        return "adGroupLabelResult." + error;
                                }
                            }
                            if (message.adGroupResult != null && message.hasOwnProperty("adGroupResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdGroupResult.verify(message.adGroupResult);
                                    if (error)
                                        return "adGroupResult." + error;
                                }
                            }
                            if (message.adParameterResult != null && message.hasOwnProperty("adParameterResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateAdParameterResult.verify(message.adParameterResult);
                                    if (error)
                                        return "adParameterResult." + error;
                                }
                            }
                            if (message.assetResult != null && message.hasOwnProperty("assetResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateAssetResult.verify(message.assetResult);
                                    if (error)
                                        return "assetResult." + error;
                                }
                            }
                            if (message.biddingStrategyResult != null && message.hasOwnProperty("biddingStrategyResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateBiddingStrategyResult.verify(message.biddingStrategyResult);
                                    if (error)
                                        return "biddingStrategyResult." + error;
                                }
                            }
                            if (message.campaignBidModifierResult != null && message.hasOwnProperty("campaignBidModifierResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateCampaignBidModifierResult.verify(message.campaignBidModifierResult);
                                    if (error)
                                        return "campaignBidModifierResult." + error;
                                }
                            }
                            if (message.campaignBudgetResult != null && message.hasOwnProperty("campaignBudgetResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateCampaignBudgetResult.verify(message.campaignBudgetResult);
                                    if (error)
                                        return "campaignBudgetResult." + error;
                                }
                            }
                            if (message.campaignCriterionResult != null && message.hasOwnProperty("campaignCriterionResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateCampaignCriterionResult.verify(message.campaignCriterionResult);
                                    if (error)
                                        return "campaignCriterionResult." + error;
                                }
                            }
                            if (message.campaignExtensionSettingResult != null && message.hasOwnProperty("campaignExtensionSettingResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult.verify(message.campaignExtensionSettingResult);
                                    if (error)
                                        return "campaignExtensionSettingResult." + error;
                                }
                            }
                            if (message.campaignFeedResult != null && message.hasOwnProperty("campaignFeedResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateCampaignFeedResult.verify(message.campaignFeedResult);
                                    if (error)
                                        return "campaignFeedResult." + error;
                                }
                            }
                            if (message.campaignLabelResult != null && message.hasOwnProperty("campaignLabelResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateCampaignLabelResult.verify(message.campaignLabelResult);
                                    if (error)
                                        return "campaignLabelResult." + error;
                                }
                            }
                            if (message.campaignResult != null && message.hasOwnProperty("campaignResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateCampaignResult.verify(message.campaignResult);
                                    if (error)
                                        return "campaignResult." + error;
                                }
                            }
                            if (message.campaignSharedSetResult != null && message.hasOwnProperty("campaignSharedSetResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateCampaignSharedSetResult.verify(message.campaignSharedSetResult);
                                    if (error)
                                        return "campaignSharedSetResult." + error;
                                }
                            }
                            if (message.conversionActionResult != null && message.hasOwnProperty("conversionActionResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateConversionActionResult.verify(message.conversionActionResult);
                                    if (error)
                                        return "conversionActionResult." + error;
                                }
                            }
                            if (message.customerExtensionSettingResult != null && message.hasOwnProperty("customerExtensionSettingResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult.verify(message.customerExtensionSettingResult);
                                    if (error)
                                        return "customerExtensionSettingResult." + error;
                                }
                            }
                            if (message.customerFeedResult != null && message.hasOwnProperty("customerFeedResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateCustomerFeedResult.verify(message.customerFeedResult);
                                    if (error)
                                        return "customerFeedResult." + error;
                                }
                            }
                            if (message.customerLabelResult != null && message.hasOwnProperty("customerLabelResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateCustomerLabelResult.verify(message.customerLabelResult);
                                    if (error)
                                        return "customerLabelResult." + error;
                                }
                            }
                            if (message.customerNegativeCriterionResult != null && message.hasOwnProperty("customerNegativeCriterionResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult.verify(message.customerNegativeCriterionResult);
                                    if (error)
                                        return "customerNegativeCriterionResult." + error;
                                }
                            }
                            if (message.customerResult != null && message.hasOwnProperty("customerResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateCustomerResult.verify(message.customerResult);
                                    if (error)
                                        return "customerResult." + error;
                                }
                            }
                            if (message.extensionFeedItemResult != null && message.hasOwnProperty("extensionFeedItemResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateExtensionFeedItemResult.verify(message.extensionFeedItemResult);
                                    if (error)
                                        return "extensionFeedItemResult." + error;
                                }
                            }
                            if (message.feedItemResult != null && message.hasOwnProperty("feedItemResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateFeedItemResult.verify(message.feedItemResult);
                                    if (error)
                                        return "feedItemResult." + error;
                                }
                            }
                            if (message.feedItemTargetResult != null && message.hasOwnProperty("feedItemTargetResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateFeedItemTargetResult.verify(message.feedItemTargetResult);
                                    if (error)
                                        return "feedItemTargetResult." + error;
                                }
                            }
                            if (message.feedMappingResult != null && message.hasOwnProperty("feedMappingResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateFeedMappingResult.verify(message.feedMappingResult);
                                    if (error)
                                        return "feedMappingResult." + error;
                                }
                            }
                            if (message.feedResult != null && message.hasOwnProperty("feedResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateFeedResult.verify(message.feedResult);
                                    if (error)
                                        return "feedResult." + error;
                                }
                            }
                            if (message.labelResult != null && message.hasOwnProperty("labelResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateLabelResult.verify(message.labelResult);
                                    if (error)
                                        return "labelResult." + error;
                                }
                            }
                            if (message.mediaFileResult != null && message.hasOwnProperty("mediaFileResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateMediaFileResult.verify(message.mediaFileResult);
                                    if (error)
                                        return "mediaFileResult." + error;
                                }
                            }
                            if (message.remarketingActionResult != null && message.hasOwnProperty("remarketingActionResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateRemarketingActionResult.verify(message.remarketingActionResult);
                                    if (error)
                                        return "remarketingActionResult." + error;
                                }
                            }
                            if (message.sharedCriterionResult != null && message.hasOwnProperty("sharedCriterionResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateSharedCriterionResult.verify(message.sharedCriterionResult);
                                    if (error)
                                        return "sharedCriterionResult." + error;
                                }
                            }
                            if (message.sharedSetResult != null && message.hasOwnProperty("sharedSetResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateSharedSetResult.verify(message.sharedSetResult);
                                    if (error)
                                        return "sharedSetResult." + error;
                                }
                            }
                            if (message.userListResult != null && message.hasOwnProperty("userListResult")) {
                                if (properties.response === 1)
                                    return "response: multiple values";
                                properties.response = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.MutateUserListResult.verify(message.userListResult);
                                    if (error)
                                        return "userListResult." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateOperationResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateOperationResponse} MutateOperationResponse
                         */
                        MutateOperationResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateOperationResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateOperationResponse();
                            if (object.adGroupAdLabelResult != null) {
                                if (typeof object.adGroupAdLabelResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.adGroupAdLabelResult: object expected");
                                message.adGroupAdLabelResult = $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelResult.fromObject(object.adGroupAdLabelResult);
                            }
                            if (object.adGroupAdResult != null) {
                                if (typeof object.adGroupAdResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.adGroupAdResult: object expected");
                                message.adGroupAdResult = $root.google.ads.googleads.v1.services.MutateAdGroupAdResult.fromObject(object.adGroupAdResult);
                            }
                            if (object.adGroupBidModifierResult != null) {
                                if (typeof object.adGroupBidModifierResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.adGroupBidModifierResult: object expected");
                                message.adGroupBidModifierResult = $root.google.ads.googleads.v1.services.MutateAdGroupBidModifierResult.fromObject(object.adGroupBidModifierResult);
                            }
                            if (object.adGroupCriterionLabelResult != null) {
                                if (typeof object.adGroupCriterionLabelResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.adGroupCriterionLabelResult: object expected");
                                message.adGroupCriterionLabelResult = $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult.fromObject(object.adGroupCriterionLabelResult);
                            }
                            if (object.adGroupCriterionResult != null) {
                                if (typeof object.adGroupCriterionResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.adGroupCriterionResult: object expected");
                                message.adGroupCriterionResult = $root.google.ads.googleads.v1.services.MutateAdGroupCriterionResult.fromObject(object.adGroupCriterionResult);
                            }
                            if (object.adGroupExtensionSettingResult != null) {
                                if (typeof object.adGroupExtensionSettingResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.adGroupExtensionSettingResult: object expected");
                                message.adGroupExtensionSettingResult = $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult.fromObject(object.adGroupExtensionSettingResult);
                            }
                            if (object.adGroupFeedResult != null) {
                                if (typeof object.adGroupFeedResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.adGroupFeedResult: object expected");
                                message.adGroupFeedResult = $root.google.ads.googleads.v1.services.MutateAdGroupFeedResult.fromObject(object.adGroupFeedResult);
                            }
                            if (object.adGroupLabelResult != null) {
                                if (typeof object.adGroupLabelResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.adGroupLabelResult: object expected");
                                message.adGroupLabelResult = $root.google.ads.googleads.v1.services.MutateAdGroupLabelResult.fromObject(object.adGroupLabelResult);
                            }
                            if (object.adGroupResult != null) {
                                if (typeof object.adGroupResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.adGroupResult: object expected");
                                message.adGroupResult = $root.google.ads.googleads.v1.services.MutateAdGroupResult.fromObject(object.adGroupResult);
                            }
                            if (object.adParameterResult != null) {
                                if (typeof object.adParameterResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.adParameterResult: object expected");
                                message.adParameterResult = $root.google.ads.googleads.v1.services.MutateAdParameterResult.fromObject(object.adParameterResult);
                            }
                            if (object.assetResult != null) {
                                if (typeof object.assetResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.assetResult: object expected");
                                message.assetResult = $root.google.ads.googleads.v1.services.MutateAssetResult.fromObject(object.assetResult);
                            }
                            if (object.biddingStrategyResult != null) {
                                if (typeof object.biddingStrategyResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.biddingStrategyResult: object expected");
                                message.biddingStrategyResult = $root.google.ads.googleads.v1.services.MutateBiddingStrategyResult.fromObject(object.biddingStrategyResult);
                            }
                            if (object.campaignBidModifierResult != null) {
                                if (typeof object.campaignBidModifierResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.campaignBidModifierResult: object expected");
                                message.campaignBidModifierResult = $root.google.ads.googleads.v1.services.MutateCampaignBidModifierResult.fromObject(object.campaignBidModifierResult);
                            }
                            if (object.campaignBudgetResult != null) {
                                if (typeof object.campaignBudgetResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.campaignBudgetResult: object expected");
                                message.campaignBudgetResult = $root.google.ads.googleads.v1.services.MutateCampaignBudgetResult.fromObject(object.campaignBudgetResult);
                            }
                            if (object.campaignCriterionResult != null) {
                                if (typeof object.campaignCriterionResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.campaignCriterionResult: object expected");
                                message.campaignCriterionResult = $root.google.ads.googleads.v1.services.MutateCampaignCriterionResult.fromObject(object.campaignCriterionResult);
                            }
                            if (object.campaignExtensionSettingResult != null) {
                                if (typeof object.campaignExtensionSettingResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.campaignExtensionSettingResult: object expected");
                                message.campaignExtensionSettingResult = $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult.fromObject(object.campaignExtensionSettingResult);
                            }
                            if (object.campaignFeedResult != null) {
                                if (typeof object.campaignFeedResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.campaignFeedResult: object expected");
                                message.campaignFeedResult = $root.google.ads.googleads.v1.services.MutateCampaignFeedResult.fromObject(object.campaignFeedResult);
                            }
                            if (object.campaignLabelResult != null) {
                                if (typeof object.campaignLabelResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.campaignLabelResult: object expected");
                                message.campaignLabelResult = $root.google.ads.googleads.v1.services.MutateCampaignLabelResult.fromObject(object.campaignLabelResult);
                            }
                            if (object.campaignResult != null) {
                                if (typeof object.campaignResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.campaignResult: object expected");
                                message.campaignResult = $root.google.ads.googleads.v1.services.MutateCampaignResult.fromObject(object.campaignResult);
                            }
                            if (object.campaignSharedSetResult != null) {
                                if (typeof object.campaignSharedSetResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.campaignSharedSetResult: object expected");
                                message.campaignSharedSetResult = $root.google.ads.googleads.v1.services.MutateCampaignSharedSetResult.fromObject(object.campaignSharedSetResult);
                            }
                            if (object.conversionActionResult != null) {
                                if (typeof object.conversionActionResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.conversionActionResult: object expected");
                                message.conversionActionResult = $root.google.ads.googleads.v1.services.MutateConversionActionResult.fromObject(object.conversionActionResult);
                            }
                            if (object.customerExtensionSettingResult != null) {
                                if (typeof object.customerExtensionSettingResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.customerExtensionSettingResult: object expected");
                                message.customerExtensionSettingResult = $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult.fromObject(object.customerExtensionSettingResult);
                            }
                            if (object.customerFeedResult != null) {
                                if (typeof object.customerFeedResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.customerFeedResult: object expected");
                                message.customerFeedResult = $root.google.ads.googleads.v1.services.MutateCustomerFeedResult.fromObject(object.customerFeedResult);
                            }
                            if (object.customerLabelResult != null) {
                                if (typeof object.customerLabelResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.customerLabelResult: object expected");
                                message.customerLabelResult = $root.google.ads.googleads.v1.services.MutateCustomerLabelResult.fromObject(object.customerLabelResult);
                            }
                            if (object.customerNegativeCriterionResult != null) {
                                if (typeof object.customerNegativeCriterionResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.customerNegativeCriterionResult: object expected");
                                message.customerNegativeCriterionResult = $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult.fromObject(object.customerNegativeCriterionResult);
                            }
                            if (object.customerResult != null) {
                                if (typeof object.customerResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.customerResult: object expected");
                                message.customerResult = $root.google.ads.googleads.v1.services.MutateCustomerResult.fromObject(object.customerResult);
                            }
                            if (object.extensionFeedItemResult != null) {
                                if (typeof object.extensionFeedItemResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.extensionFeedItemResult: object expected");
                                message.extensionFeedItemResult = $root.google.ads.googleads.v1.services.MutateExtensionFeedItemResult.fromObject(object.extensionFeedItemResult);
                            }
                            if (object.feedItemResult != null) {
                                if (typeof object.feedItemResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.feedItemResult: object expected");
                                message.feedItemResult = $root.google.ads.googleads.v1.services.MutateFeedItemResult.fromObject(object.feedItemResult);
                            }
                            if (object.feedItemTargetResult != null) {
                                if (typeof object.feedItemTargetResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.feedItemTargetResult: object expected");
                                message.feedItemTargetResult = $root.google.ads.googleads.v1.services.MutateFeedItemTargetResult.fromObject(object.feedItemTargetResult);
                            }
                            if (object.feedMappingResult != null) {
                                if (typeof object.feedMappingResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.feedMappingResult: object expected");
                                message.feedMappingResult = $root.google.ads.googleads.v1.services.MutateFeedMappingResult.fromObject(object.feedMappingResult);
                            }
                            if (object.feedResult != null) {
                                if (typeof object.feedResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.feedResult: object expected");
                                message.feedResult = $root.google.ads.googleads.v1.services.MutateFeedResult.fromObject(object.feedResult);
                            }
                            if (object.labelResult != null) {
                                if (typeof object.labelResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.labelResult: object expected");
                                message.labelResult = $root.google.ads.googleads.v1.services.MutateLabelResult.fromObject(object.labelResult);
                            }
                            if (object.mediaFileResult != null) {
                                if (typeof object.mediaFileResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.mediaFileResult: object expected");
                                message.mediaFileResult = $root.google.ads.googleads.v1.services.MutateMediaFileResult.fromObject(object.mediaFileResult);
                            }
                            if (object.remarketingActionResult != null) {
                                if (typeof object.remarketingActionResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.remarketingActionResult: object expected");
                                message.remarketingActionResult = $root.google.ads.googleads.v1.services.MutateRemarketingActionResult.fromObject(object.remarketingActionResult);
                            }
                            if (object.sharedCriterionResult != null) {
                                if (typeof object.sharedCriterionResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.sharedCriterionResult: object expected");
                                message.sharedCriterionResult = $root.google.ads.googleads.v1.services.MutateSharedCriterionResult.fromObject(object.sharedCriterionResult);
                            }
                            if (object.sharedSetResult != null) {
                                if (typeof object.sharedSetResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.sharedSetResult: object expected");
                                message.sharedSetResult = $root.google.ads.googleads.v1.services.MutateSharedSetResult.fromObject(object.sharedSetResult);
                            }
                            if (object.userListResult != null) {
                                if (typeof object.userListResult !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateOperationResponse.userListResult: object expected");
                                message.userListResult = $root.google.ads.googleads.v1.services.MutateUserListResult.fromObject(object.userListResult);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateOperationResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateOperationResponse} message MutateOperationResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateOperationResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.adGroupAdResult != null && message.hasOwnProperty("adGroupAdResult")) {
                                object.adGroupAdResult = $root.google.ads.googleads.v1.services.MutateAdGroupAdResult.toObject(message.adGroupAdResult, options);
                                if (options.oneofs)
                                    object.response = "adGroupAdResult";
                            }
                            if (message.adGroupBidModifierResult != null && message.hasOwnProperty("adGroupBidModifierResult")) {
                                object.adGroupBidModifierResult = $root.google.ads.googleads.v1.services.MutateAdGroupBidModifierResult.toObject(message.adGroupBidModifierResult, options);
                                if (options.oneofs)
                                    object.response = "adGroupBidModifierResult";
                            }
                            if (message.adGroupCriterionResult != null && message.hasOwnProperty("adGroupCriterionResult")) {
                                object.adGroupCriterionResult = $root.google.ads.googleads.v1.services.MutateAdGroupCriterionResult.toObject(message.adGroupCriterionResult, options);
                                if (options.oneofs)
                                    object.response = "adGroupCriterionResult";
                            }
                            if (message.adGroupResult != null && message.hasOwnProperty("adGroupResult")) {
                                object.adGroupResult = $root.google.ads.googleads.v1.services.MutateAdGroupResult.toObject(message.adGroupResult, options);
                                if (options.oneofs)
                                    object.response = "adGroupResult";
                            }
                            if (message.biddingStrategyResult != null && message.hasOwnProperty("biddingStrategyResult")) {
                                object.biddingStrategyResult = $root.google.ads.googleads.v1.services.MutateBiddingStrategyResult.toObject(message.biddingStrategyResult, options);
                                if (options.oneofs)
                                    object.response = "biddingStrategyResult";
                            }
                            if (message.campaignBidModifierResult != null && message.hasOwnProperty("campaignBidModifierResult")) {
                                object.campaignBidModifierResult = $root.google.ads.googleads.v1.services.MutateCampaignBidModifierResult.toObject(message.campaignBidModifierResult, options);
                                if (options.oneofs)
                                    object.response = "campaignBidModifierResult";
                            }
                            if (message.campaignBudgetResult != null && message.hasOwnProperty("campaignBudgetResult")) {
                                object.campaignBudgetResult = $root.google.ads.googleads.v1.services.MutateCampaignBudgetResult.toObject(message.campaignBudgetResult, options);
                                if (options.oneofs)
                                    object.response = "campaignBudgetResult";
                            }
                            if (message.campaignResult != null && message.hasOwnProperty("campaignResult")) {
                                object.campaignResult = $root.google.ads.googleads.v1.services.MutateCampaignResult.toObject(message.campaignResult, options);
                                if (options.oneofs)
                                    object.response = "campaignResult";
                            }
                            if (message.campaignSharedSetResult != null && message.hasOwnProperty("campaignSharedSetResult")) {
                                object.campaignSharedSetResult = $root.google.ads.googleads.v1.services.MutateCampaignSharedSetResult.toObject(message.campaignSharedSetResult, options);
                                if (options.oneofs)
                                    object.response = "campaignSharedSetResult";
                            }
                            if (message.conversionActionResult != null && message.hasOwnProperty("conversionActionResult")) {
                                object.conversionActionResult = $root.google.ads.googleads.v1.services.MutateConversionActionResult.toObject(message.conversionActionResult, options);
                                if (options.oneofs)
                                    object.response = "conversionActionResult";
                            }
                            if (message.campaignCriterionResult != null && message.hasOwnProperty("campaignCriterionResult")) {
                                object.campaignCriterionResult = $root.google.ads.googleads.v1.services.MutateCampaignCriterionResult.toObject(message.campaignCriterionResult, options);
                                if (options.oneofs)
                                    object.response = "campaignCriterionResult";
                            }
                            if (message.sharedCriterionResult != null && message.hasOwnProperty("sharedCriterionResult")) {
                                object.sharedCriterionResult = $root.google.ads.googleads.v1.services.MutateSharedCriterionResult.toObject(message.sharedCriterionResult, options);
                                if (options.oneofs)
                                    object.response = "sharedCriterionResult";
                            }
                            if (message.sharedSetResult != null && message.hasOwnProperty("sharedSetResult")) {
                                object.sharedSetResult = $root.google.ads.googleads.v1.services.MutateSharedSetResult.toObject(message.sharedSetResult, options);
                                if (options.oneofs)
                                    object.response = "sharedSetResult";
                            }
                            if (message.userListResult != null && message.hasOwnProperty("userListResult")) {
                                object.userListResult = $root.google.ads.googleads.v1.services.MutateUserListResult.toObject(message.userListResult, options);
                                if (options.oneofs)
                                    object.response = "userListResult";
                            }
                            if (message.adGroupAdLabelResult != null && message.hasOwnProperty("adGroupAdLabelResult")) {
                                object.adGroupAdLabelResult = $root.google.ads.googleads.v1.services.MutateAdGroupAdLabelResult.toObject(message.adGroupAdLabelResult, options);
                                if (options.oneofs)
                                    object.response = "adGroupAdLabelResult";
                            }
                            if (message.adGroupCriterionLabelResult != null && message.hasOwnProperty("adGroupCriterionLabelResult")) {
                                object.adGroupCriterionLabelResult = $root.google.ads.googleads.v1.services.MutateAdGroupCriterionLabelResult.toObject(message.adGroupCriterionLabelResult, options);
                                if (options.oneofs)
                                    object.response = "adGroupCriterionLabelResult";
                            }
                            if (message.adGroupExtensionSettingResult != null && message.hasOwnProperty("adGroupExtensionSettingResult")) {
                                object.adGroupExtensionSettingResult = $root.google.ads.googleads.v1.services.MutateAdGroupExtensionSettingResult.toObject(message.adGroupExtensionSettingResult, options);
                                if (options.oneofs)
                                    object.response = "adGroupExtensionSettingResult";
                            }
                            if (message.adGroupFeedResult != null && message.hasOwnProperty("adGroupFeedResult")) {
                                object.adGroupFeedResult = $root.google.ads.googleads.v1.services.MutateAdGroupFeedResult.toObject(message.adGroupFeedResult, options);
                                if (options.oneofs)
                                    object.response = "adGroupFeedResult";
                            }
                            if (message.adGroupLabelResult != null && message.hasOwnProperty("adGroupLabelResult")) {
                                object.adGroupLabelResult = $root.google.ads.googleads.v1.services.MutateAdGroupLabelResult.toObject(message.adGroupLabelResult, options);
                                if (options.oneofs)
                                    object.response = "adGroupLabelResult";
                            }
                            if (message.adParameterResult != null && message.hasOwnProperty("adParameterResult")) {
                                object.adParameterResult = $root.google.ads.googleads.v1.services.MutateAdParameterResult.toObject(message.adParameterResult, options);
                                if (options.oneofs)
                                    object.response = "adParameterResult";
                            }
                            if (message.assetResult != null && message.hasOwnProperty("assetResult")) {
                                object.assetResult = $root.google.ads.googleads.v1.services.MutateAssetResult.toObject(message.assetResult, options);
                                if (options.oneofs)
                                    object.response = "assetResult";
                            }
                            if (message.campaignExtensionSettingResult != null && message.hasOwnProperty("campaignExtensionSettingResult")) {
                                object.campaignExtensionSettingResult = $root.google.ads.googleads.v1.services.MutateCampaignExtensionSettingResult.toObject(message.campaignExtensionSettingResult, options);
                                if (options.oneofs)
                                    object.response = "campaignExtensionSettingResult";
                            }
                            if (message.campaignFeedResult != null && message.hasOwnProperty("campaignFeedResult")) {
                                object.campaignFeedResult = $root.google.ads.googleads.v1.services.MutateCampaignFeedResult.toObject(message.campaignFeedResult, options);
                                if (options.oneofs)
                                    object.response = "campaignFeedResult";
                            }
                            if (message.campaignLabelResult != null && message.hasOwnProperty("campaignLabelResult")) {
                                object.campaignLabelResult = $root.google.ads.googleads.v1.services.MutateCampaignLabelResult.toObject(message.campaignLabelResult, options);
                                if (options.oneofs)
                                    object.response = "campaignLabelResult";
                            }
                            if (message.customerExtensionSettingResult != null && message.hasOwnProperty("customerExtensionSettingResult")) {
                                object.customerExtensionSettingResult = $root.google.ads.googleads.v1.services.MutateCustomerExtensionSettingResult.toObject(message.customerExtensionSettingResult, options);
                                if (options.oneofs)
                                    object.response = "customerExtensionSettingResult";
                            }
                            if (message.customerFeedResult != null && message.hasOwnProperty("customerFeedResult")) {
                                object.customerFeedResult = $root.google.ads.googleads.v1.services.MutateCustomerFeedResult.toObject(message.customerFeedResult, options);
                                if (options.oneofs)
                                    object.response = "customerFeedResult";
                            }
                            if (message.customerLabelResult != null && message.hasOwnProperty("customerLabelResult")) {
                                object.customerLabelResult = $root.google.ads.googleads.v1.services.MutateCustomerLabelResult.toObject(message.customerLabelResult, options);
                                if (options.oneofs)
                                    object.response = "customerLabelResult";
                            }
                            if (message.customerNegativeCriterionResult != null && message.hasOwnProperty("customerNegativeCriterionResult")) {
                                object.customerNegativeCriterionResult = $root.google.ads.googleads.v1.services.MutateCustomerNegativeCriteriaResult.toObject(message.customerNegativeCriterionResult, options);
                                if (options.oneofs)
                                    object.response = "customerNegativeCriterionResult";
                            }
                            if (message.customerResult != null && message.hasOwnProperty("customerResult")) {
                                object.customerResult = $root.google.ads.googleads.v1.services.MutateCustomerResult.toObject(message.customerResult, options);
                                if (options.oneofs)
                                    object.response = "customerResult";
                            }
                            if (message.extensionFeedItemResult != null && message.hasOwnProperty("extensionFeedItemResult")) {
                                object.extensionFeedItemResult = $root.google.ads.googleads.v1.services.MutateExtensionFeedItemResult.toObject(message.extensionFeedItemResult, options);
                                if (options.oneofs)
                                    object.response = "extensionFeedItemResult";
                            }
                            if (message.feedItemResult != null && message.hasOwnProperty("feedItemResult")) {
                                object.feedItemResult = $root.google.ads.googleads.v1.services.MutateFeedItemResult.toObject(message.feedItemResult, options);
                                if (options.oneofs)
                                    object.response = "feedItemResult";
                            }
                            if (message.feedItemTargetResult != null && message.hasOwnProperty("feedItemTargetResult")) {
                                object.feedItemTargetResult = $root.google.ads.googleads.v1.services.MutateFeedItemTargetResult.toObject(message.feedItemTargetResult, options);
                                if (options.oneofs)
                                    object.response = "feedItemTargetResult";
                            }
                            if (message.feedMappingResult != null && message.hasOwnProperty("feedMappingResult")) {
                                object.feedMappingResult = $root.google.ads.googleads.v1.services.MutateFeedMappingResult.toObject(message.feedMappingResult, options);
                                if (options.oneofs)
                                    object.response = "feedMappingResult";
                            }
                            if (message.feedResult != null && message.hasOwnProperty("feedResult")) {
                                object.feedResult = $root.google.ads.googleads.v1.services.MutateFeedResult.toObject(message.feedResult, options);
                                if (options.oneofs)
                                    object.response = "feedResult";
                            }
                            if (message.labelResult != null && message.hasOwnProperty("labelResult")) {
                                object.labelResult = $root.google.ads.googleads.v1.services.MutateLabelResult.toObject(message.labelResult, options);
                                if (options.oneofs)
                                    object.response = "labelResult";
                            }
                            if (message.mediaFileResult != null && message.hasOwnProperty("mediaFileResult")) {
                                object.mediaFileResult = $root.google.ads.googleads.v1.services.MutateMediaFileResult.toObject(message.mediaFileResult, options);
                                if (options.oneofs)
                                    object.response = "mediaFileResult";
                            }
                            if (message.remarketingActionResult != null && message.hasOwnProperty("remarketingActionResult")) {
                                object.remarketingActionResult = $root.google.ads.googleads.v1.services.MutateRemarketingActionResult.toObject(message.remarketingActionResult, options);
                                if (options.oneofs)
                                    object.response = "remarketingActionResult";
                            }
                            return object;
                        };

                        /**
                         * Converts this MutateOperationResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateOperationResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateOperationResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateOperationResponse;
                    })();

                    services.GroupPlacementViewService = (function() {

                        /**
                         * Constructs a new GroupPlacementViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GroupPlacementViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function GroupPlacementViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (GroupPlacementViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = GroupPlacementViewService;

                        /**
                         * Creates new GroupPlacementViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GroupPlacementViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {GroupPlacementViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        GroupPlacementViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.GroupPlacementViewService#getGroupPlacementView}.
                         * @memberof google.ads.googleads.v1.services.GroupPlacementViewService
                         * @typedef GetGroupPlacementViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.GroupPlacementView} [response] GroupPlacementView
                         */

                        /**
                         * Calls GetGroupPlacementView.
                         * @function getGroupPlacementView
                         * @memberof google.ads.googleads.v1.services.GroupPlacementViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetGroupPlacementViewRequest} request GetGroupPlacementViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.GroupPlacementViewService.GetGroupPlacementViewCallback} callback Node-style callback called with the error, if any, and GroupPlacementView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GroupPlacementViewService.prototype.getGroupPlacementView = function getGroupPlacementView(request, callback) {
                            return this.rpcCall(getGroupPlacementView, $root.google.ads.googleads.v1.services.GetGroupPlacementViewRequest, $root.google.ads.googleads.v1.resources.GroupPlacementView, request, callback);
                        }, "name", { value: "GetGroupPlacementView" });

                        /**
                         * Calls GetGroupPlacementView.
                         * @function getGroupPlacementView
                         * @memberof google.ads.googleads.v1.services.GroupPlacementViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetGroupPlacementViewRequest} request GetGroupPlacementViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.GroupPlacementView>} Promise
                         * @variation 2
                         */

                        return GroupPlacementViewService;
                    })();

                    services.GetGroupPlacementViewRequest = (function() {

                        /**
                         * Properties of a GetGroupPlacementViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetGroupPlacementViewRequest
                         * @property {string|null} [resourceName] GetGroupPlacementViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetGroupPlacementViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetGroupPlacementViewRequest.
                         * @implements IGetGroupPlacementViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetGroupPlacementViewRequest=} [properties] Properties to set
                         */
                        function GetGroupPlacementViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetGroupPlacementViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetGroupPlacementViewRequest
                         * @instance
                         */
                        GetGroupPlacementViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetGroupPlacementViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetGroupPlacementViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetGroupPlacementViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetGroupPlacementViewRequest} GetGroupPlacementViewRequest instance
                         */
                        GetGroupPlacementViewRequest.create = function create(properties) {
                            return new GetGroupPlacementViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetGroupPlacementViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetGroupPlacementViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetGroupPlacementViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetGroupPlacementViewRequest} message GetGroupPlacementViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGroupPlacementViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetGroupPlacementViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetGroupPlacementViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetGroupPlacementViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetGroupPlacementViewRequest} message GetGroupPlacementViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGroupPlacementViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetGroupPlacementViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetGroupPlacementViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetGroupPlacementViewRequest} GetGroupPlacementViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGroupPlacementViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetGroupPlacementViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetGroupPlacementViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetGroupPlacementViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetGroupPlacementViewRequest} GetGroupPlacementViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGroupPlacementViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetGroupPlacementViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetGroupPlacementViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetGroupPlacementViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetGroupPlacementViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetGroupPlacementViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetGroupPlacementViewRequest} GetGroupPlacementViewRequest
                         */
                        GetGroupPlacementViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetGroupPlacementViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetGroupPlacementViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetGroupPlacementViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetGroupPlacementViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetGroupPlacementViewRequest} message GetGroupPlacementViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetGroupPlacementViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetGroupPlacementViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetGroupPlacementViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetGroupPlacementViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetGroupPlacementViewRequest;
                    })();

                    services.HotelGroupViewService = (function() {

                        /**
                         * Constructs a new HotelGroupViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a HotelGroupViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function HotelGroupViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (HotelGroupViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = HotelGroupViewService;

                        /**
                         * Creates new HotelGroupViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.HotelGroupViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {HotelGroupViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        HotelGroupViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.HotelGroupViewService#getHotelGroupView}.
                         * @memberof google.ads.googleads.v1.services.HotelGroupViewService
                         * @typedef GetHotelGroupViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.HotelGroupView} [response] HotelGroupView
                         */

                        /**
                         * Calls GetHotelGroupView.
                         * @function getHotelGroupView
                         * @memberof google.ads.googleads.v1.services.HotelGroupViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetHotelGroupViewRequest} request GetHotelGroupViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.HotelGroupViewService.GetHotelGroupViewCallback} callback Node-style callback called with the error, if any, and HotelGroupView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(HotelGroupViewService.prototype.getHotelGroupView = function getHotelGroupView(request, callback) {
                            return this.rpcCall(getHotelGroupView, $root.google.ads.googleads.v1.services.GetHotelGroupViewRequest, $root.google.ads.googleads.v1.resources.HotelGroupView, request, callback);
                        }, "name", { value: "GetHotelGroupView" });

                        /**
                         * Calls GetHotelGroupView.
                         * @function getHotelGroupView
                         * @memberof google.ads.googleads.v1.services.HotelGroupViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetHotelGroupViewRequest} request GetHotelGroupViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.HotelGroupView>} Promise
                         * @variation 2
                         */

                        return HotelGroupViewService;
                    })();

                    services.GetHotelGroupViewRequest = (function() {

                        /**
                         * Properties of a GetHotelGroupViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetHotelGroupViewRequest
                         * @property {string|null} [resourceName] GetHotelGroupViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetHotelGroupViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetHotelGroupViewRequest.
                         * @implements IGetHotelGroupViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetHotelGroupViewRequest=} [properties] Properties to set
                         */
                        function GetHotelGroupViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetHotelGroupViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetHotelGroupViewRequest
                         * @instance
                         */
                        GetHotelGroupViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetHotelGroupViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetHotelGroupViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetHotelGroupViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetHotelGroupViewRequest} GetHotelGroupViewRequest instance
                         */
                        GetHotelGroupViewRequest.create = function create(properties) {
                            return new GetHotelGroupViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetHotelGroupViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetHotelGroupViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetHotelGroupViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetHotelGroupViewRequest} message GetHotelGroupViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetHotelGroupViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetHotelGroupViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetHotelGroupViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetHotelGroupViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetHotelGroupViewRequest} message GetHotelGroupViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetHotelGroupViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetHotelGroupViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetHotelGroupViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetHotelGroupViewRequest} GetHotelGroupViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetHotelGroupViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetHotelGroupViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetHotelGroupViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetHotelGroupViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetHotelGroupViewRequest} GetHotelGroupViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetHotelGroupViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetHotelGroupViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetHotelGroupViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetHotelGroupViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetHotelGroupViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetHotelGroupViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetHotelGroupViewRequest} GetHotelGroupViewRequest
                         */
                        GetHotelGroupViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetHotelGroupViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetHotelGroupViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetHotelGroupViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetHotelGroupViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetHotelGroupViewRequest} message GetHotelGroupViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetHotelGroupViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetHotelGroupViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetHotelGroupViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetHotelGroupViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetHotelGroupViewRequest;
                    })();

                    services.HotelPerformanceViewService = (function() {

                        /**
                         * Constructs a new HotelPerformanceViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a HotelPerformanceViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function HotelPerformanceViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (HotelPerformanceViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = HotelPerformanceViewService;

                        /**
                         * Creates new HotelPerformanceViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.HotelPerformanceViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {HotelPerformanceViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        HotelPerformanceViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.HotelPerformanceViewService#getHotelPerformanceView}.
                         * @memberof google.ads.googleads.v1.services.HotelPerformanceViewService
                         * @typedef GetHotelPerformanceViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.HotelPerformanceView} [response] HotelPerformanceView
                         */

                        /**
                         * Calls GetHotelPerformanceView.
                         * @function getHotelPerformanceView
                         * @memberof google.ads.googleads.v1.services.HotelPerformanceViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetHotelPerformanceViewRequest} request GetHotelPerformanceViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.HotelPerformanceViewService.GetHotelPerformanceViewCallback} callback Node-style callback called with the error, if any, and HotelPerformanceView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(HotelPerformanceViewService.prototype.getHotelPerformanceView = function getHotelPerformanceView(request, callback) {
                            return this.rpcCall(getHotelPerformanceView, $root.google.ads.googleads.v1.services.GetHotelPerformanceViewRequest, $root.google.ads.googleads.v1.resources.HotelPerformanceView, request, callback);
                        }, "name", { value: "GetHotelPerformanceView" });

                        /**
                         * Calls GetHotelPerformanceView.
                         * @function getHotelPerformanceView
                         * @memberof google.ads.googleads.v1.services.HotelPerformanceViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetHotelPerformanceViewRequest} request GetHotelPerformanceViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.HotelPerformanceView>} Promise
                         * @variation 2
                         */

                        return HotelPerformanceViewService;
                    })();

                    services.GetHotelPerformanceViewRequest = (function() {

                        /**
                         * Properties of a GetHotelPerformanceViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetHotelPerformanceViewRequest
                         * @property {string|null} [resourceName] GetHotelPerformanceViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetHotelPerformanceViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetHotelPerformanceViewRequest.
                         * @implements IGetHotelPerformanceViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetHotelPerformanceViewRequest=} [properties] Properties to set
                         */
                        function GetHotelPerformanceViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetHotelPerformanceViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetHotelPerformanceViewRequest
                         * @instance
                         */
                        GetHotelPerformanceViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetHotelPerformanceViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetHotelPerformanceViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetHotelPerformanceViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetHotelPerformanceViewRequest} GetHotelPerformanceViewRequest instance
                         */
                        GetHotelPerformanceViewRequest.create = function create(properties) {
                            return new GetHotelPerformanceViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetHotelPerformanceViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetHotelPerformanceViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetHotelPerformanceViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetHotelPerformanceViewRequest} message GetHotelPerformanceViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetHotelPerformanceViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetHotelPerformanceViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetHotelPerformanceViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetHotelPerformanceViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetHotelPerformanceViewRequest} message GetHotelPerformanceViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetHotelPerformanceViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetHotelPerformanceViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetHotelPerformanceViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetHotelPerformanceViewRequest} GetHotelPerformanceViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetHotelPerformanceViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetHotelPerformanceViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetHotelPerformanceViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetHotelPerformanceViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetHotelPerformanceViewRequest} GetHotelPerformanceViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetHotelPerformanceViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetHotelPerformanceViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetHotelPerformanceViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetHotelPerformanceViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetHotelPerformanceViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetHotelPerformanceViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetHotelPerformanceViewRequest} GetHotelPerformanceViewRequest
                         */
                        GetHotelPerformanceViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetHotelPerformanceViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetHotelPerformanceViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetHotelPerformanceViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetHotelPerformanceViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetHotelPerformanceViewRequest} message GetHotelPerformanceViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetHotelPerformanceViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetHotelPerformanceViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetHotelPerformanceViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetHotelPerformanceViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetHotelPerformanceViewRequest;
                    })();

                    services.KeywordPlanAdGroupService = (function() {

                        /**
                         * Constructs a new KeywordPlanAdGroupService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a KeywordPlanAdGroupService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function KeywordPlanAdGroupService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (KeywordPlanAdGroupService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = KeywordPlanAdGroupService;

                        /**
                         * Creates new KeywordPlanAdGroupService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {KeywordPlanAdGroupService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        KeywordPlanAdGroupService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.KeywordPlanAdGroupService#getKeywordPlanAdGroup}.
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupService
                         * @typedef GetKeywordPlanAdGroupCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.KeywordPlanAdGroup} [response] KeywordPlanAdGroup
                         */

                        /**
                         * Calls GetKeywordPlanAdGroup.
                         * @function getKeywordPlanAdGroup
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanAdGroupRequest} request GetKeywordPlanAdGroupRequest message or plain object
                         * @param {google.ads.googleads.v1.services.KeywordPlanAdGroupService.GetKeywordPlanAdGroupCallback} callback Node-style callback called with the error, if any, and KeywordPlanAdGroup
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(KeywordPlanAdGroupService.prototype.getKeywordPlanAdGroup = function getKeywordPlanAdGroup(request, callback) {
                            return this.rpcCall(getKeywordPlanAdGroup, $root.google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest, $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup, request, callback);
                        }, "name", { value: "GetKeywordPlanAdGroup" });

                        /**
                         * Calls GetKeywordPlanAdGroup.
                         * @function getKeywordPlanAdGroup
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanAdGroupRequest} request GetKeywordPlanAdGroupRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.KeywordPlanAdGroup>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.KeywordPlanAdGroupService#mutateKeywordPlanAdGroups}.
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupService
                         * @typedef MutateKeywordPlanAdGroupsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse} [response] MutateKeywordPlanAdGroupsResponse
                         */

                        /**
                         * Calls MutateKeywordPlanAdGroups.
                         * @function mutateKeywordPlanAdGroups
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanAdGroupsRequest} request MutateKeywordPlanAdGroupsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.KeywordPlanAdGroupService.MutateKeywordPlanAdGroupsCallback} callback Node-style callback called with the error, if any, and MutateKeywordPlanAdGroupsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(KeywordPlanAdGroupService.prototype.mutateKeywordPlanAdGroups = function mutateKeywordPlanAdGroups(request, callback) {
                            return this.rpcCall(mutateKeywordPlanAdGroups, $root.google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest, $root.google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse, request, callback);
                        }, "name", { value: "MutateKeywordPlanAdGroups" });

                        /**
                         * Calls MutateKeywordPlanAdGroups.
                         * @function mutateKeywordPlanAdGroups
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanAdGroupsRequest} request MutateKeywordPlanAdGroupsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse>} Promise
                         * @variation 2
                         */

                        return KeywordPlanAdGroupService;
                    })();

                    services.GetKeywordPlanAdGroupRequest = (function() {

                        /**
                         * Properties of a GetKeywordPlanAdGroupRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetKeywordPlanAdGroupRequest
                         * @property {string|null} [resourceName] GetKeywordPlanAdGroupRequest resourceName
                         */

                        /**
                         * Constructs a new GetKeywordPlanAdGroupRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetKeywordPlanAdGroupRequest.
                         * @implements IGetKeywordPlanAdGroupRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanAdGroupRequest=} [properties] Properties to set
                         */
                        function GetKeywordPlanAdGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetKeywordPlanAdGroupRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest
                         * @instance
                         */
                        GetKeywordPlanAdGroupRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetKeywordPlanAdGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanAdGroupRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest} GetKeywordPlanAdGroupRequest instance
                         */
                        GetKeywordPlanAdGroupRequest.create = function create(properties) {
                            return new GetKeywordPlanAdGroupRequest(properties);
                        };

                        /**
                         * Encodes the specified GetKeywordPlanAdGroupRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanAdGroupRequest} message GetKeywordPlanAdGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetKeywordPlanAdGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetKeywordPlanAdGroupRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanAdGroupRequest} message GetKeywordPlanAdGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetKeywordPlanAdGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetKeywordPlanAdGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest} GetKeywordPlanAdGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetKeywordPlanAdGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetKeywordPlanAdGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest} GetKeywordPlanAdGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetKeywordPlanAdGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetKeywordPlanAdGroupRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetKeywordPlanAdGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetKeywordPlanAdGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest} GetKeywordPlanAdGroupRequest
                         */
                        GetKeywordPlanAdGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetKeywordPlanAdGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest} message GetKeywordPlanAdGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetKeywordPlanAdGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetKeywordPlanAdGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanAdGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetKeywordPlanAdGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetKeywordPlanAdGroupRequest;
                    })();

                    services.MutateKeywordPlanAdGroupsRequest = (function() {

                        /**
                         * Properties of a MutateKeywordPlanAdGroupsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateKeywordPlanAdGroupsRequest
                         * @property {string|null} [customerId] MutateKeywordPlanAdGroupsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IKeywordPlanAdGroupOperation>|null} [operations] MutateKeywordPlanAdGroupsRequest operations
                         * @property {boolean|null} [partialFailure] MutateKeywordPlanAdGroupsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateKeywordPlanAdGroupsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateKeywordPlanAdGroupsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateKeywordPlanAdGroupsRequest.
                         * @implements IMutateKeywordPlanAdGroupsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanAdGroupsRequest=} [properties] Properties to set
                         */
                        function MutateKeywordPlanAdGroupsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateKeywordPlanAdGroupsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest
                         * @instance
                         */
                        MutateKeywordPlanAdGroupsRequest.prototype.customerId = "";

                        /**
                         * MutateKeywordPlanAdGroupsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IKeywordPlanAdGroupOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest
                         * @instance
                         */
                        MutateKeywordPlanAdGroupsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateKeywordPlanAdGroupsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest
                         * @instance
                         */
                        MutateKeywordPlanAdGroupsRequest.prototype.partialFailure = false;

                        /**
                         * MutateKeywordPlanAdGroupsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest
                         * @instance
                         */
                        MutateKeywordPlanAdGroupsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateKeywordPlanAdGroupsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanAdGroupsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest} MutateKeywordPlanAdGroupsRequest instance
                         */
                        MutateKeywordPlanAdGroupsRequest.create = function create(properties) {
                            return new MutateKeywordPlanAdGroupsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanAdGroupsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanAdGroupsRequest} message MutateKeywordPlanAdGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanAdGroupsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.KeywordPlanAdGroupOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanAdGroupsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanAdGroupsRequest} message MutateKeywordPlanAdGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanAdGroupsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateKeywordPlanAdGroupsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest} MutateKeywordPlanAdGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanAdGroupsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.KeywordPlanAdGroupOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateKeywordPlanAdGroupsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest} MutateKeywordPlanAdGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanAdGroupsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateKeywordPlanAdGroupsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateKeywordPlanAdGroupsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.KeywordPlanAdGroupOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateKeywordPlanAdGroupsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest} MutateKeywordPlanAdGroupsRequest
                         */
                        MutateKeywordPlanAdGroupsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.KeywordPlanAdGroupOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateKeywordPlanAdGroupsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest} message MutateKeywordPlanAdGroupsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateKeywordPlanAdGroupsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.KeywordPlanAdGroupOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateKeywordPlanAdGroupsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateKeywordPlanAdGroupsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateKeywordPlanAdGroupsRequest;
                    })();

                    services.KeywordPlanAdGroupOperation = (function() {

                        /**
                         * Properties of a KeywordPlanAdGroupOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IKeywordPlanAdGroupOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] KeywordPlanAdGroupOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IKeywordPlanAdGroup|null} [create] KeywordPlanAdGroupOperation create
                         * @property {google.ads.googleads.v1.resources.IKeywordPlanAdGroup|null} [update] KeywordPlanAdGroupOperation update
                         * @property {string|null} [remove] KeywordPlanAdGroupOperation remove
                         */

                        /**
                         * Constructs a new KeywordPlanAdGroupOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a KeywordPlanAdGroupOperation.
                         * @implements IKeywordPlanAdGroupOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IKeywordPlanAdGroupOperation=} [properties] Properties to set
                         */
                        function KeywordPlanAdGroupOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordPlanAdGroupOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupOperation
                         * @instance
                         */
                        KeywordPlanAdGroupOperation.prototype.updateMask = null;

                        /**
                         * KeywordPlanAdGroupOperation create.
                         * @member {google.ads.googleads.v1.resources.IKeywordPlanAdGroup|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupOperation
                         * @instance
                         */
                        KeywordPlanAdGroupOperation.prototype.create = null;

                        /**
                         * KeywordPlanAdGroupOperation update.
                         * @member {google.ads.googleads.v1.resources.IKeywordPlanAdGroup|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupOperation
                         * @instance
                         */
                        KeywordPlanAdGroupOperation.prototype.update = null;

                        /**
                         * KeywordPlanAdGroupOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupOperation
                         * @instance
                         */
                        KeywordPlanAdGroupOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * KeywordPlanAdGroupOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupOperation
                         * @instance
                         */
                        Object.defineProperty(KeywordPlanAdGroupOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new KeywordPlanAdGroupOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanAdGroupOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.KeywordPlanAdGroupOperation} KeywordPlanAdGroupOperation instance
                         */
                        KeywordPlanAdGroupOperation.create = function create(properties) {
                            return new KeywordPlanAdGroupOperation(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanAdGroupOperation message. Does not implicitly {@link google.ads.googleads.v1.services.KeywordPlanAdGroupOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanAdGroupOperation} message KeywordPlanAdGroupOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanAdGroupOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanAdGroupOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.KeywordPlanAdGroupOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanAdGroupOperation} message KeywordPlanAdGroupOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanAdGroupOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanAdGroupOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.KeywordPlanAdGroupOperation} KeywordPlanAdGroupOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanAdGroupOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.KeywordPlanAdGroupOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanAdGroupOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.KeywordPlanAdGroupOperation} KeywordPlanAdGroupOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanAdGroupOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanAdGroupOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanAdGroupOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanAdGroupOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.KeywordPlanAdGroupOperation} KeywordPlanAdGroupOperation
                         */
                        KeywordPlanAdGroupOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.KeywordPlanAdGroupOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.KeywordPlanAdGroupOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanAdGroupOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanAdGroupOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanAdGroupOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordPlanAdGroupOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.KeywordPlanAdGroupOperation} message KeywordPlanAdGroupOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanAdGroupOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.KeywordPlanAdGroup.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this KeywordPlanAdGroupOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanAdGroupOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordPlanAdGroupOperation;
                    })();

                    services.MutateKeywordPlanAdGroupsResponse = (function() {

                        /**
                         * Properties of a MutateKeywordPlanAdGroupsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateKeywordPlanAdGroupsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateKeywordPlanAdGroupsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateKeywordPlanAdGroupResult>|null} [results] MutateKeywordPlanAdGroupsResponse results
                         */

                        /**
                         * Constructs a new MutateKeywordPlanAdGroupsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateKeywordPlanAdGroupsResponse.
                         * @implements IMutateKeywordPlanAdGroupsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanAdGroupsResponse=} [properties] Properties to set
                         */
                        function MutateKeywordPlanAdGroupsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateKeywordPlanAdGroupsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse
                         * @instance
                         */
                        MutateKeywordPlanAdGroupsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateKeywordPlanAdGroupsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateKeywordPlanAdGroupResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse
                         * @instance
                         */
                        MutateKeywordPlanAdGroupsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateKeywordPlanAdGroupsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanAdGroupsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse} MutateKeywordPlanAdGroupsResponse instance
                         */
                        MutateKeywordPlanAdGroupsResponse.create = function create(properties) {
                            return new MutateKeywordPlanAdGroupsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanAdGroupsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanAdGroupsResponse} message MutateKeywordPlanAdGroupsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanAdGroupsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanAdGroupsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanAdGroupsResponse} message MutateKeywordPlanAdGroupsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanAdGroupsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateKeywordPlanAdGroupsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse} MutateKeywordPlanAdGroupsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanAdGroupsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateKeywordPlanAdGroupsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse} MutateKeywordPlanAdGroupsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanAdGroupsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateKeywordPlanAdGroupsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateKeywordPlanAdGroupsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateKeywordPlanAdGroupsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse} MutateKeywordPlanAdGroupsResponse
                         */
                        MutateKeywordPlanAdGroupsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateKeywordPlanAdGroupsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse} message MutateKeywordPlanAdGroupsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateKeywordPlanAdGroupsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateKeywordPlanAdGroupsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateKeywordPlanAdGroupsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateKeywordPlanAdGroupsResponse;
                    })();

                    services.MutateKeywordPlanAdGroupResult = (function() {

                        /**
                         * Properties of a MutateKeywordPlanAdGroupResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateKeywordPlanAdGroupResult
                         * @property {string|null} [resourceName] MutateKeywordPlanAdGroupResult resourceName
                         */

                        /**
                         * Constructs a new MutateKeywordPlanAdGroupResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateKeywordPlanAdGroupResult.
                         * @implements IMutateKeywordPlanAdGroupResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanAdGroupResult=} [properties] Properties to set
                         */
                        function MutateKeywordPlanAdGroupResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateKeywordPlanAdGroupResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult
                         * @instance
                         */
                        MutateKeywordPlanAdGroupResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateKeywordPlanAdGroupResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanAdGroupResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult} MutateKeywordPlanAdGroupResult instance
                         */
                        MutateKeywordPlanAdGroupResult.create = function create(properties) {
                            return new MutateKeywordPlanAdGroupResult(properties);
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanAdGroupResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanAdGroupResult} message MutateKeywordPlanAdGroupResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanAdGroupResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanAdGroupResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanAdGroupResult} message MutateKeywordPlanAdGroupResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanAdGroupResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateKeywordPlanAdGroupResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult} MutateKeywordPlanAdGroupResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanAdGroupResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateKeywordPlanAdGroupResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult} MutateKeywordPlanAdGroupResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanAdGroupResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateKeywordPlanAdGroupResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateKeywordPlanAdGroupResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateKeywordPlanAdGroupResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult} MutateKeywordPlanAdGroupResult
                         */
                        MutateKeywordPlanAdGroupResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateKeywordPlanAdGroupResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult} message MutateKeywordPlanAdGroupResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateKeywordPlanAdGroupResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateKeywordPlanAdGroupResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanAdGroupResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateKeywordPlanAdGroupResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateKeywordPlanAdGroupResult;
                    })();

                    services.KeywordPlanCampaignService = (function() {

                        /**
                         * Constructs a new KeywordPlanCampaignService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a KeywordPlanCampaignService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function KeywordPlanCampaignService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (KeywordPlanCampaignService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = KeywordPlanCampaignService;

                        /**
                         * Creates new KeywordPlanCampaignService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {KeywordPlanCampaignService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        KeywordPlanCampaignService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.KeywordPlanCampaignService#getKeywordPlanCampaign}.
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignService
                         * @typedef GetKeywordPlanCampaignCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.KeywordPlanCampaign} [response] KeywordPlanCampaign
                         */

                        /**
                         * Calls GetKeywordPlanCampaign.
                         * @function getKeywordPlanCampaign
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanCampaignRequest} request GetKeywordPlanCampaignRequest message or plain object
                         * @param {google.ads.googleads.v1.services.KeywordPlanCampaignService.GetKeywordPlanCampaignCallback} callback Node-style callback called with the error, if any, and KeywordPlanCampaign
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(KeywordPlanCampaignService.prototype.getKeywordPlanCampaign = function getKeywordPlanCampaign(request, callback) {
                            return this.rpcCall(getKeywordPlanCampaign, $root.google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest, $root.google.ads.googleads.v1.resources.KeywordPlanCampaign, request, callback);
                        }, "name", { value: "GetKeywordPlanCampaign" });

                        /**
                         * Calls GetKeywordPlanCampaign.
                         * @function getKeywordPlanCampaign
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanCampaignRequest} request GetKeywordPlanCampaignRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.KeywordPlanCampaign>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.KeywordPlanCampaignService#mutateKeywordPlanCampaigns}.
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignService
                         * @typedef MutateKeywordPlanCampaignsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse} [response] MutateKeywordPlanCampaignsResponse
                         */

                        /**
                         * Calls MutateKeywordPlanCampaigns.
                         * @function mutateKeywordPlanCampaigns
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanCampaignsRequest} request MutateKeywordPlanCampaignsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.KeywordPlanCampaignService.MutateKeywordPlanCampaignsCallback} callback Node-style callback called with the error, if any, and MutateKeywordPlanCampaignsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(KeywordPlanCampaignService.prototype.mutateKeywordPlanCampaigns = function mutateKeywordPlanCampaigns(request, callback) {
                            return this.rpcCall(mutateKeywordPlanCampaigns, $root.google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest, $root.google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse, request, callback);
                        }, "name", { value: "MutateKeywordPlanCampaigns" });

                        /**
                         * Calls MutateKeywordPlanCampaigns.
                         * @function mutateKeywordPlanCampaigns
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanCampaignsRequest} request MutateKeywordPlanCampaignsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse>} Promise
                         * @variation 2
                         */

                        return KeywordPlanCampaignService;
                    })();

                    services.GetKeywordPlanCampaignRequest = (function() {

                        /**
                         * Properties of a GetKeywordPlanCampaignRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetKeywordPlanCampaignRequest
                         * @property {string|null} [resourceName] GetKeywordPlanCampaignRequest resourceName
                         */

                        /**
                         * Constructs a new GetKeywordPlanCampaignRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetKeywordPlanCampaignRequest.
                         * @implements IGetKeywordPlanCampaignRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanCampaignRequest=} [properties] Properties to set
                         */
                        function GetKeywordPlanCampaignRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetKeywordPlanCampaignRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest
                         * @instance
                         */
                        GetKeywordPlanCampaignRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetKeywordPlanCampaignRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanCampaignRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest} GetKeywordPlanCampaignRequest instance
                         */
                        GetKeywordPlanCampaignRequest.create = function create(properties) {
                            return new GetKeywordPlanCampaignRequest(properties);
                        };

                        /**
                         * Encodes the specified GetKeywordPlanCampaignRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanCampaignRequest} message GetKeywordPlanCampaignRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetKeywordPlanCampaignRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetKeywordPlanCampaignRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanCampaignRequest} message GetKeywordPlanCampaignRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetKeywordPlanCampaignRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetKeywordPlanCampaignRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest} GetKeywordPlanCampaignRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetKeywordPlanCampaignRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetKeywordPlanCampaignRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest} GetKeywordPlanCampaignRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetKeywordPlanCampaignRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetKeywordPlanCampaignRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetKeywordPlanCampaignRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetKeywordPlanCampaignRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest} GetKeywordPlanCampaignRequest
                         */
                        GetKeywordPlanCampaignRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetKeywordPlanCampaignRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest} message GetKeywordPlanCampaignRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetKeywordPlanCampaignRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetKeywordPlanCampaignRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanCampaignRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetKeywordPlanCampaignRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetKeywordPlanCampaignRequest;
                    })();

                    services.MutateKeywordPlanCampaignsRequest = (function() {

                        /**
                         * Properties of a MutateKeywordPlanCampaignsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateKeywordPlanCampaignsRequest
                         * @property {string|null} [customerId] MutateKeywordPlanCampaignsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IKeywordPlanCampaignOperation>|null} [operations] MutateKeywordPlanCampaignsRequest operations
                         * @property {boolean|null} [partialFailure] MutateKeywordPlanCampaignsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateKeywordPlanCampaignsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateKeywordPlanCampaignsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateKeywordPlanCampaignsRequest.
                         * @implements IMutateKeywordPlanCampaignsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanCampaignsRequest=} [properties] Properties to set
                         */
                        function MutateKeywordPlanCampaignsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateKeywordPlanCampaignsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest
                         * @instance
                         */
                        MutateKeywordPlanCampaignsRequest.prototype.customerId = "";

                        /**
                         * MutateKeywordPlanCampaignsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IKeywordPlanCampaignOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest
                         * @instance
                         */
                        MutateKeywordPlanCampaignsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateKeywordPlanCampaignsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest
                         * @instance
                         */
                        MutateKeywordPlanCampaignsRequest.prototype.partialFailure = false;

                        /**
                         * MutateKeywordPlanCampaignsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest
                         * @instance
                         */
                        MutateKeywordPlanCampaignsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateKeywordPlanCampaignsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanCampaignsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest} MutateKeywordPlanCampaignsRequest instance
                         */
                        MutateKeywordPlanCampaignsRequest.create = function create(properties) {
                            return new MutateKeywordPlanCampaignsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanCampaignsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanCampaignsRequest} message MutateKeywordPlanCampaignsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanCampaignsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.KeywordPlanCampaignOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanCampaignsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanCampaignsRequest} message MutateKeywordPlanCampaignsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanCampaignsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateKeywordPlanCampaignsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest} MutateKeywordPlanCampaignsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanCampaignsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.KeywordPlanCampaignOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateKeywordPlanCampaignsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest} MutateKeywordPlanCampaignsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanCampaignsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateKeywordPlanCampaignsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateKeywordPlanCampaignsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.KeywordPlanCampaignOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateKeywordPlanCampaignsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest} MutateKeywordPlanCampaignsRequest
                         */
                        MutateKeywordPlanCampaignsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.KeywordPlanCampaignOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateKeywordPlanCampaignsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest} message MutateKeywordPlanCampaignsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateKeywordPlanCampaignsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.KeywordPlanCampaignOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateKeywordPlanCampaignsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateKeywordPlanCampaignsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateKeywordPlanCampaignsRequest;
                    })();

                    services.KeywordPlanCampaignOperation = (function() {

                        /**
                         * Properties of a KeywordPlanCampaignOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IKeywordPlanCampaignOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] KeywordPlanCampaignOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IKeywordPlanCampaign|null} [create] KeywordPlanCampaignOperation create
                         * @property {google.ads.googleads.v1.resources.IKeywordPlanCampaign|null} [update] KeywordPlanCampaignOperation update
                         * @property {string|null} [remove] KeywordPlanCampaignOperation remove
                         */

                        /**
                         * Constructs a new KeywordPlanCampaignOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a KeywordPlanCampaignOperation.
                         * @implements IKeywordPlanCampaignOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IKeywordPlanCampaignOperation=} [properties] Properties to set
                         */
                        function KeywordPlanCampaignOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordPlanCampaignOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignOperation
                         * @instance
                         */
                        KeywordPlanCampaignOperation.prototype.updateMask = null;

                        /**
                         * KeywordPlanCampaignOperation create.
                         * @member {google.ads.googleads.v1.resources.IKeywordPlanCampaign|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignOperation
                         * @instance
                         */
                        KeywordPlanCampaignOperation.prototype.create = null;

                        /**
                         * KeywordPlanCampaignOperation update.
                         * @member {google.ads.googleads.v1.resources.IKeywordPlanCampaign|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignOperation
                         * @instance
                         */
                        KeywordPlanCampaignOperation.prototype.update = null;

                        /**
                         * KeywordPlanCampaignOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignOperation
                         * @instance
                         */
                        KeywordPlanCampaignOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * KeywordPlanCampaignOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignOperation
                         * @instance
                         */
                        Object.defineProperty(KeywordPlanCampaignOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new KeywordPlanCampaignOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanCampaignOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.KeywordPlanCampaignOperation} KeywordPlanCampaignOperation instance
                         */
                        KeywordPlanCampaignOperation.create = function create(properties) {
                            return new KeywordPlanCampaignOperation(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanCampaignOperation message. Does not implicitly {@link google.ads.googleads.v1.services.KeywordPlanCampaignOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanCampaignOperation} message KeywordPlanCampaignOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanCampaignOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.KeywordPlanCampaign.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.KeywordPlanCampaign.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanCampaignOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.KeywordPlanCampaignOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanCampaignOperation} message KeywordPlanCampaignOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanCampaignOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanCampaignOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.KeywordPlanCampaignOperation} KeywordPlanCampaignOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanCampaignOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.KeywordPlanCampaignOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.KeywordPlanCampaign.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.KeywordPlanCampaign.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanCampaignOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.KeywordPlanCampaignOperation} KeywordPlanCampaignOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanCampaignOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanCampaignOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanCampaignOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.KeywordPlanCampaign.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.KeywordPlanCampaign.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanCampaignOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.KeywordPlanCampaignOperation} KeywordPlanCampaignOperation
                         */
                        KeywordPlanCampaignOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.KeywordPlanCampaignOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.KeywordPlanCampaignOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanCampaignOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanCampaignOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.KeywordPlanCampaign.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanCampaignOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.KeywordPlanCampaign.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordPlanCampaignOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.KeywordPlanCampaignOperation} message KeywordPlanCampaignOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanCampaignOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.KeywordPlanCampaign.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.KeywordPlanCampaign.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this KeywordPlanCampaignOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanCampaignOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordPlanCampaignOperation;
                    })();

                    services.MutateKeywordPlanCampaignsResponse = (function() {

                        /**
                         * Properties of a MutateKeywordPlanCampaignsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateKeywordPlanCampaignsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateKeywordPlanCampaignsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateKeywordPlanCampaignResult>|null} [results] MutateKeywordPlanCampaignsResponse results
                         */

                        /**
                         * Constructs a new MutateKeywordPlanCampaignsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateKeywordPlanCampaignsResponse.
                         * @implements IMutateKeywordPlanCampaignsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanCampaignsResponse=} [properties] Properties to set
                         */
                        function MutateKeywordPlanCampaignsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateKeywordPlanCampaignsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse
                         * @instance
                         */
                        MutateKeywordPlanCampaignsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateKeywordPlanCampaignsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateKeywordPlanCampaignResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse
                         * @instance
                         */
                        MutateKeywordPlanCampaignsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateKeywordPlanCampaignsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanCampaignsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse} MutateKeywordPlanCampaignsResponse instance
                         */
                        MutateKeywordPlanCampaignsResponse.create = function create(properties) {
                            return new MutateKeywordPlanCampaignsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanCampaignsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanCampaignsResponse} message MutateKeywordPlanCampaignsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanCampaignsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanCampaignsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanCampaignsResponse} message MutateKeywordPlanCampaignsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanCampaignsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateKeywordPlanCampaignsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse} MutateKeywordPlanCampaignsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanCampaignsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateKeywordPlanCampaignsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse} MutateKeywordPlanCampaignsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanCampaignsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateKeywordPlanCampaignsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateKeywordPlanCampaignsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateKeywordPlanCampaignsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse} MutateKeywordPlanCampaignsResponse
                         */
                        MutateKeywordPlanCampaignsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateKeywordPlanCampaignsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse} message MutateKeywordPlanCampaignsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateKeywordPlanCampaignsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateKeywordPlanCampaignsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateKeywordPlanCampaignsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateKeywordPlanCampaignsResponse;
                    })();

                    services.MutateKeywordPlanCampaignResult = (function() {

                        /**
                         * Properties of a MutateKeywordPlanCampaignResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateKeywordPlanCampaignResult
                         * @property {string|null} [resourceName] MutateKeywordPlanCampaignResult resourceName
                         */

                        /**
                         * Constructs a new MutateKeywordPlanCampaignResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateKeywordPlanCampaignResult.
                         * @implements IMutateKeywordPlanCampaignResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanCampaignResult=} [properties] Properties to set
                         */
                        function MutateKeywordPlanCampaignResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateKeywordPlanCampaignResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult
                         * @instance
                         */
                        MutateKeywordPlanCampaignResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateKeywordPlanCampaignResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanCampaignResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult} MutateKeywordPlanCampaignResult instance
                         */
                        MutateKeywordPlanCampaignResult.create = function create(properties) {
                            return new MutateKeywordPlanCampaignResult(properties);
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanCampaignResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanCampaignResult} message MutateKeywordPlanCampaignResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanCampaignResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanCampaignResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanCampaignResult} message MutateKeywordPlanCampaignResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanCampaignResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateKeywordPlanCampaignResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult} MutateKeywordPlanCampaignResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanCampaignResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateKeywordPlanCampaignResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult} MutateKeywordPlanCampaignResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanCampaignResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateKeywordPlanCampaignResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateKeywordPlanCampaignResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateKeywordPlanCampaignResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult} MutateKeywordPlanCampaignResult
                         */
                        MutateKeywordPlanCampaignResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateKeywordPlanCampaignResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult} message MutateKeywordPlanCampaignResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateKeywordPlanCampaignResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateKeywordPlanCampaignResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanCampaignResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateKeywordPlanCampaignResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateKeywordPlanCampaignResult;
                    })();

                    services.KeywordPlanIdeaService = (function() {

                        /**
                         * Constructs a new KeywordPlanIdeaService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a KeywordPlanIdeaService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function KeywordPlanIdeaService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (KeywordPlanIdeaService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = KeywordPlanIdeaService;

                        /**
                         * Creates new KeywordPlanIdeaService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanIdeaService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {KeywordPlanIdeaService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        KeywordPlanIdeaService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.KeywordPlanIdeaService#generateKeywordIdeas}.
                         * @memberof google.ads.googleads.v1.services.KeywordPlanIdeaService
                         * @typedef GenerateKeywordIdeasCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.GenerateKeywordIdeaResponse} [response] GenerateKeywordIdeaResponse
                         */

                        /**
                         * Calls GenerateKeywordIdeas.
                         * @function generateKeywordIdeas
                         * @memberof google.ads.googleads.v1.services.KeywordPlanIdeaService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGenerateKeywordIdeasRequest} request GenerateKeywordIdeasRequest message or plain object
                         * @param {google.ads.googleads.v1.services.KeywordPlanIdeaService.GenerateKeywordIdeasCallback} callback Node-style callback called with the error, if any, and GenerateKeywordIdeaResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(KeywordPlanIdeaService.prototype.generateKeywordIdeas = function generateKeywordIdeas(request, callback) {
                            return this.rpcCall(generateKeywordIdeas, $root.google.ads.googleads.v1.services.GenerateKeywordIdeasRequest, $root.google.ads.googleads.v1.services.GenerateKeywordIdeaResponse, request, callback);
                        }, "name", { value: "GenerateKeywordIdeas" });

                        /**
                         * Calls GenerateKeywordIdeas.
                         * @function generateKeywordIdeas
                         * @memberof google.ads.googleads.v1.services.KeywordPlanIdeaService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGenerateKeywordIdeasRequest} request GenerateKeywordIdeasRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.GenerateKeywordIdeaResponse>} Promise
                         * @variation 2
                         */

                        return KeywordPlanIdeaService;
                    })();

                    services.GenerateKeywordIdeasRequest = (function() {

                        /**
                         * Properties of a GenerateKeywordIdeasRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGenerateKeywordIdeasRequest
                         * @property {string|null} [customerId] GenerateKeywordIdeasRequest customerId
                         * @property {google.protobuf.IStringValue|null} [language] GenerateKeywordIdeasRequest language
                         * @property {Array.<google.protobuf.IStringValue>|null} [geoTargetConstants] GenerateKeywordIdeasRequest geoTargetConstants
                         * @property {google.ads.googleads.v1.enums.KeywordPlanNetworkEnum.KeywordPlanNetwork|null} [keywordPlanNetwork] GenerateKeywordIdeasRequest keywordPlanNetwork
                         * @property {google.ads.googleads.v1.services.IKeywordAndUrlSeed|null} [keywordAndUrlSeed] GenerateKeywordIdeasRequest keywordAndUrlSeed
                         * @property {google.ads.googleads.v1.services.IKeywordSeed|null} [keywordSeed] GenerateKeywordIdeasRequest keywordSeed
                         * @property {google.ads.googleads.v1.services.IUrlSeed|null} [urlSeed] GenerateKeywordIdeasRequest urlSeed
                         */

                        /**
                         * Constructs a new GenerateKeywordIdeasRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GenerateKeywordIdeasRequest.
                         * @implements IGenerateKeywordIdeasRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGenerateKeywordIdeasRequest=} [properties] Properties to set
                         */
                        function GenerateKeywordIdeasRequest(properties) {
                            this.geoTargetConstants = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GenerateKeywordIdeasRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeasRequest
                         * @instance
                         */
                        GenerateKeywordIdeasRequest.prototype.customerId = "";

                        /**
                         * GenerateKeywordIdeasRequest language.
                         * @member {google.protobuf.IStringValue|null|undefined} language
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeasRequest
                         * @instance
                         */
                        GenerateKeywordIdeasRequest.prototype.language = null;

                        /**
                         * GenerateKeywordIdeasRequest geoTargetConstants.
                         * @member {Array.<google.protobuf.IStringValue>} geoTargetConstants
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeasRequest
                         * @instance
                         */
                        GenerateKeywordIdeasRequest.prototype.geoTargetConstants = $util.emptyArray;

                        /**
                         * GenerateKeywordIdeasRequest keywordPlanNetwork.
                         * @member {google.ads.googleads.v1.enums.KeywordPlanNetworkEnum.KeywordPlanNetwork} keywordPlanNetwork
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeasRequest
                         * @instance
                         */
                        GenerateKeywordIdeasRequest.prototype.keywordPlanNetwork = 0;

                        /**
                         * GenerateKeywordIdeasRequest keywordAndUrlSeed.
                         * @member {google.ads.googleads.v1.services.IKeywordAndUrlSeed|null|undefined} keywordAndUrlSeed
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeasRequest
                         * @instance
                         */
                        GenerateKeywordIdeasRequest.prototype.keywordAndUrlSeed = null;

                        /**
                         * GenerateKeywordIdeasRequest keywordSeed.
                         * @member {google.ads.googleads.v1.services.IKeywordSeed|null|undefined} keywordSeed
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeasRequest
                         * @instance
                         */
                        GenerateKeywordIdeasRequest.prototype.keywordSeed = null;

                        /**
                         * GenerateKeywordIdeasRequest urlSeed.
                         * @member {google.ads.googleads.v1.services.IUrlSeed|null|undefined} urlSeed
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeasRequest
                         * @instance
                         */
                        GenerateKeywordIdeasRequest.prototype.urlSeed = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * GenerateKeywordIdeasRequest seed.
                         * @member {"keywordAndUrlSeed"|"keywordSeed"|"urlSeed"|undefined} seed
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeasRequest
                         * @instance
                         */
                        Object.defineProperty(GenerateKeywordIdeasRequest.prototype, "seed", {
                            get: $util.oneOfGetter($oneOfFields = ["keywordAndUrlSeed", "keywordSeed", "urlSeed"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new GenerateKeywordIdeasRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeasRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateKeywordIdeasRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GenerateKeywordIdeasRequest} GenerateKeywordIdeasRequest instance
                         */
                        GenerateKeywordIdeasRequest.create = function create(properties) {
                            return new GenerateKeywordIdeasRequest(properties);
                        };

                        /**
                         * Encodes the specified GenerateKeywordIdeasRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GenerateKeywordIdeasRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeasRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateKeywordIdeasRequest} message GenerateKeywordIdeasRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenerateKeywordIdeasRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.keywordAndUrlSeed != null && message.hasOwnProperty("keywordAndUrlSeed"))
                                $root.google.ads.googleads.v1.services.KeywordAndUrlSeed.encode(message.keywordAndUrlSeed, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.keywordSeed != null && message.hasOwnProperty("keywordSeed"))
                                $root.google.ads.googleads.v1.services.KeywordSeed.encode(message.keywordSeed, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.urlSeed != null && message.hasOwnProperty("urlSeed"))
                                $root.google.ads.googleads.v1.services.UrlSeed.encode(message.urlSeed, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.language != null && message.hasOwnProperty("language"))
                                $root.google.protobuf.StringValue.encode(message.language, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.geoTargetConstants != null && message.geoTargetConstants.length)
                                for (var i = 0; i < message.geoTargetConstants.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.geoTargetConstants[i], writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.keywordPlanNetwork != null && message.hasOwnProperty("keywordPlanNetwork"))
                                writer.uint32(/* id 9, wireType 0 =*/72).int32(message.keywordPlanNetwork);
                            return writer;
                        };

                        /**
                         * Encodes the specified GenerateKeywordIdeasRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GenerateKeywordIdeasRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeasRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateKeywordIdeasRequest} message GenerateKeywordIdeasRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenerateKeywordIdeasRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GenerateKeywordIdeasRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeasRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GenerateKeywordIdeasRequest} GenerateKeywordIdeasRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenerateKeywordIdeasRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GenerateKeywordIdeasRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 7:
                                    message.language = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    if (!(message.geoTargetConstants && message.geoTargetConstants.length))
                                        message.geoTargetConstants = [];
                                    message.geoTargetConstants.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                case 9:
                                    message.keywordPlanNetwork = reader.int32();
                                    break;
                                case 2:
                                    message.keywordAndUrlSeed = $root.google.ads.googleads.v1.services.KeywordAndUrlSeed.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.keywordSeed = $root.google.ads.googleads.v1.services.KeywordSeed.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.urlSeed = $root.google.ads.googleads.v1.services.UrlSeed.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GenerateKeywordIdeasRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeasRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GenerateKeywordIdeasRequest} GenerateKeywordIdeasRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenerateKeywordIdeasRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GenerateKeywordIdeasRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeasRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GenerateKeywordIdeasRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.language != null && message.hasOwnProperty("language")) {
                                var error = $root.google.protobuf.StringValue.verify(message.language);
                                if (error)
                                    return "language." + error;
                            }
                            if (message.geoTargetConstants != null && message.hasOwnProperty("geoTargetConstants")) {
                                if (!Array.isArray(message.geoTargetConstants))
                                    return "geoTargetConstants: array expected";
                                for (var i = 0; i < message.geoTargetConstants.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.geoTargetConstants[i]);
                                    if (error)
                                        return "geoTargetConstants." + error;
                                }
                            }
                            if (message.keywordPlanNetwork != null && message.hasOwnProperty("keywordPlanNetwork"))
                                switch (message.keywordPlanNetwork) {
                                default:
                                    return "keywordPlanNetwork: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.keywordAndUrlSeed != null && message.hasOwnProperty("keywordAndUrlSeed")) {
                                properties.seed = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.KeywordAndUrlSeed.verify(message.keywordAndUrlSeed);
                                    if (error)
                                        return "keywordAndUrlSeed." + error;
                                }
                            }
                            if (message.keywordSeed != null && message.hasOwnProperty("keywordSeed")) {
                                if (properties.seed === 1)
                                    return "seed: multiple values";
                                properties.seed = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.KeywordSeed.verify(message.keywordSeed);
                                    if (error)
                                        return "keywordSeed." + error;
                                }
                            }
                            if (message.urlSeed != null && message.hasOwnProperty("urlSeed")) {
                                if (properties.seed === 1)
                                    return "seed: multiple values";
                                properties.seed = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.UrlSeed.verify(message.urlSeed);
                                    if (error)
                                        return "urlSeed." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a GenerateKeywordIdeasRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeasRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GenerateKeywordIdeasRequest} GenerateKeywordIdeasRequest
                         */
                        GenerateKeywordIdeasRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GenerateKeywordIdeasRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GenerateKeywordIdeasRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.language != null) {
                                if (typeof object.language !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GenerateKeywordIdeasRequest.language: object expected");
                                message.language = $root.google.protobuf.StringValue.fromObject(object.language);
                            }
                            if (object.geoTargetConstants) {
                                if (!Array.isArray(object.geoTargetConstants))
                                    throw TypeError(".google.ads.googleads.v1.services.GenerateKeywordIdeasRequest.geoTargetConstants: array expected");
                                message.geoTargetConstants = [];
                                for (var i = 0; i < object.geoTargetConstants.length; ++i) {
                                    if (typeof object.geoTargetConstants[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.GenerateKeywordIdeasRequest.geoTargetConstants: object expected");
                                    message.geoTargetConstants[i] = $root.google.protobuf.StringValue.fromObject(object.geoTargetConstants[i]);
                                }
                            }
                            switch (object.keywordPlanNetwork) {
                            case "UNSPECIFIED":
                            case 0:
                                message.keywordPlanNetwork = 0;
                                break;
                            case "UNKNOWN":
                            case 1:
                                message.keywordPlanNetwork = 1;
                                break;
                            case "GOOGLE_SEARCH":
                            case 2:
                                message.keywordPlanNetwork = 2;
                                break;
                            case "GOOGLE_SEARCH_AND_PARTNERS":
                            case 3:
                                message.keywordPlanNetwork = 3;
                                break;
                            }
                            if (object.keywordAndUrlSeed != null) {
                                if (typeof object.keywordAndUrlSeed !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GenerateKeywordIdeasRequest.keywordAndUrlSeed: object expected");
                                message.keywordAndUrlSeed = $root.google.ads.googleads.v1.services.KeywordAndUrlSeed.fromObject(object.keywordAndUrlSeed);
                            }
                            if (object.keywordSeed != null) {
                                if (typeof object.keywordSeed !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GenerateKeywordIdeasRequest.keywordSeed: object expected");
                                message.keywordSeed = $root.google.ads.googleads.v1.services.KeywordSeed.fromObject(object.keywordSeed);
                            }
                            if (object.urlSeed != null) {
                                if (typeof object.urlSeed !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GenerateKeywordIdeasRequest.urlSeed: object expected");
                                message.urlSeed = $root.google.ads.googleads.v1.services.UrlSeed.fromObject(object.urlSeed);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a GenerateKeywordIdeasRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeasRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GenerateKeywordIdeasRequest} message GenerateKeywordIdeasRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GenerateKeywordIdeasRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.geoTargetConstants = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.language = null;
                                object.keywordPlanNetwork = options.enums === String ? "UNSPECIFIED" : 0;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.keywordAndUrlSeed != null && message.hasOwnProperty("keywordAndUrlSeed")) {
                                object.keywordAndUrlSeed = $root.google.ads.googleads.v1.services.KeywordAndUrlSeed.toObject(message.keywordAndUrlSeed, options);
                                if (options.oneofs)
                                    object.seed = "keywordAndUrlSeed";
                            }
                            if (message.keywordSeed != null && message.hasOwnProperty("keywordSeed")) {
                                object.keywordSeed = $root.google.ads.googleads.v1.services.KeywordSeed.toObject(message.keywordSeed, options);
                                if (options.oneofs)
                                    object.seed = "keywordSeed";
                            }
                            if (message.urlSeed != null && message.hasOwnProperty("urlSeed")) {
                                object.urlSeed = $root.google.ads.googleads.v1.services.UrlSeed.toObject(message.urlSeed, options);
                                if (options.oneofs)
                                    object.seed = "urlSeed";
                            }
                            if (message.language != null && message.hasOwnProperty("language"))
                                object.language = $root.google.protobuf.StringValue.toObject(message.language, options);
                            if (message.geoTargetConstants && message.geoTargetConstants.length) {
                                object.geoTargetConstants = [];
                                for (var j = 0; j < message.geoTargetConstants.length; ++j)
                                    object.geoTargetConstants[j] = $root.google.protobuf.StringValue.toObject(message.geoTargetConstants[j], options);
                            }
                            if (message.keywordPlanNetwork != null && message.hasOwnProperty("keywordPlanNetwork"))
                                object.keywordPlanNetwork = options.enums === String ? $root.google.ads.googleads.v1.enums.KeywordPlanNetworkEnum.KeywordPlanNetwork[message.keywordPlanNetwork] : message.keywordPlanNetwork;
                            return object;
                        };

                        /**
                         * Converts this GenerateKeywordIdeasRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeasRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GenerateKeywordIdeasRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GenerateKeywordIdeasRequest;
                    })();

                    services.KeywordAndUrlSeed = (function() {

                        /**
                         * Properties of a KeywordAndUrlSeed.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IKeywordAndUrlSeed
                         * @property {google.protobuf.IStringValue|null} [url] KeywordAndUrlSeed url
                         * @property {Array.<google.protobuf.IStringValue>|null} [keywords] KeywordAndUrlSeed keywords
                         */

                        /**
                         * Constructs a new KeywordAndUrlSeed.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a KeywordAndUrlSeed.
                         * @implements IKeywordAndUrlSeed
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IKeywordAndUrlSeed=} [properties] Properties to set
                         */
                        function KeywordAndUrlSeed(properties) {
                            this.keywords = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordAndUrlSeed url.
                         * @member {google.protobuf.IStringValue|null|undefined} url
                         * @memberof google.ads.googleads.v1.services.KeywordAndUrlSeed
                         * @instance
                         */
                        KeywordAndUrlSeed.prototype.url = null;

                        /**
                         * KeywordAndUrlSeed keywords.
                         * @member {Array.<google.protobuf.IStringValue>} keywords
                         * @memberof google.ads.googleads.v1.services.KeywordAndUrlSeed
                         * @instance
                         */
                        KeywordAndUrlSeed.prototype.keywords = $util.emptyArray;

                        /**
                         * Creates a new KeywordAndUrlSeed instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.KeywordAndUrlSeed
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordAndUrlSeed=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.KeywordAndUrlSeed} KeywordAndUrlSeed instance
                         */
                        KeywordAndUrlSeed.create = function create(properties) {
                            return new KeywordAndUrlSeed(properties);
                        };

                        /**
                         * Encodes the specified KeywordAndUrlSeed message. Does not implicitly {@link google.ads.googleads.v1.services.KeywordAndUrlSeed.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.KeywordAndUrlSeed
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordAndUrlSeed} message KeywordAndUrlSeed message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordAndUrlSeed.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.url != null && message.hasOwnProperty("url"))
                                $root.google.protobuf.StringValue.encode(message.url, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.keywords != null && message.keywords.length)
                                for (var i = 0; i < message.keywords.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.keywords[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordAndUrlSeed message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.KeywordAndUrlSeed.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordAndUrlSeed
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordAndUrlSeed} message KeywordAndUrlSeed message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordAndUrlSeed.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordAndUrlSeed message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.KeywordAndUrlSeed
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.KeywordAndUrlSeed} KeywordAndUrlSeed
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordAndUrlSeed.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.KeywordAndUrlSeed();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.url = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.keywords && message.keywords.length))
                                        message.keywords = [];
                                    message.keywords.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordAndUrlSeed message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordAndUrlSeed
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.KeywordAndUrlSeed} KeywordAndUrlSeed
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordAndUrlSeed.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordAndUrlSeed message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.KeywordAndUrlSeed
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordAndUrlSeed.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.url != null && message.hasOwnProperty("url")) {
                                var error = $root.google.protobuf.StringValue.verify(message.url);
                                if (error)
                                    return "url." + error;
                            }
                            if (message.keywords != null && message.hasOwnProperty("keywords")) {
                                if (!Array.isArray(message.keywords))
                                    return "keywords: array expected";
                                for (var i = 0; i < message.keywords.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.keywords[i]);
                                    if (error)
                                        return "keywords." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a KeywordAndUrlSeed message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.KeywordAndUrlSeed
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.KeywordAndUrlSeed} KeywordAndUrlSeed
                         */
                        KeywordAndUrlSeed.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.KeywordAndUrlSeed)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.KeywordAndUrlSeed();
                            if (object.url != null) {
                                if (typeof object.url !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordAndUrlSeed.url: object expected");
                                message.url = $root.google.protobuf.StringValue.fromObject(object.url);
                            }
                            if (object.keywords) {
                                if (!Array.isArray(object.keywords))
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordAndUrlSeed.keywords: array expected");
                                message.keywords = [];
                                for (var i = 0; i < object.keywords.length; ++i) {
                                    if (typeof object.keywords[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.KeywordAndUrlSeed.keywords: object expected");
                                    message.keywords[i] = $root.google.protobuf.StringValue.fromObject(object.keywords[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordAndUrlSeed message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.KeywordAndUrlSeed
                         * @static
                         * @param {google.ads.googleads.v1.services.KeywordAndUrlSeed} message KeywordAndUrlSeed
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordAndUrlSeed.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.keywords = [];
                            if (options.defaults)
                                object.url = null;
                            if (message.url != null && message.hasOwnProperty("url"))
                                object.url = $root.google.protobuf.StringValue.toObject(message.url, options);
                            if (message.keywords && message.keywords.length) {
                                object.keywords = [];
                                for (var j = 0; j < message.keywords.length; ++j)
                                    object.keywords[j] = $root.google.protobuf.StringValue.toObject(message.keywords[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this KeywordAndUrlSeed to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.KeywordAndUrlSeed
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordAndUrlSeed.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordAndUrlSeed;
                    })();

                    services.KeywordSeed = (function() {

                        /**
                         * Properties of a KeywordSeed.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IKeywordSeed
                         * @property {Array.<google.protobuf.IStringValue>|null} [keywords] KeywordSeed keywords
                         */

                        /**
                         * Constructs a new KeywordSeed.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a KeywordSeed.
                         * @implements IKeywordSeed
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IKeywordSeed=} [properties] Properties to set
                         */
                        function KeywordSeed(properties) {
                            this.keywords = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordSeed keywords.
                         * @member {Array.<google.protobuf.IStringValue>} keywords
                         * @memberof google.ads.googleads.v1.services.KeywordSeed
                         * @instance
                         */
                        KeywordSeed.prototype.keywords = $util.emptyArray;

                        /**
                         * Creates a new KeywordSeed instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.KeywordSeed
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordSeed=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.KeywordSeed} KeywordSeed instance
                         */
                        KeywordSeed.create = function create(properties) {
                            return new KeywordSeed(properties);
                        };

                        /**
                         * Encodes the specified KeywordSeed message. Does not implicitly {@link google.ads.googleads.v1.services.KeywordSeed.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.KeywordSeed
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordSeed} message KeywordSeed message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordSeed.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.keywords != null && message.keywords.length)
                                for (var i = 0; i < message.keywords.length; ++i)
                                    $root.google.protobuf.StringValue.encode(message.keywords[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordSeed message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.KeywordSeed.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordSeed
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordSeed} message KeywordSeed message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordSeed.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordSeed message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.KeywordSeed
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.KeywordSeed} KeywordSeed
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordSeed.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.KeywordSeed();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.keywords && message.keywords.length))
                                        message.keywords = [];
                                    message.keywords.push($root.google.protobuf.StringValue.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordSeed message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordSeed
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.KeywordSeed} KeywordSeed
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordSeed.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordSeed message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.KeywordSeed
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordSeed.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.keywords != null && message.hasOwnProperty("keywords")) {
                                if (!Array.isArray(message.keywords))
                                    return "keywords: array expected";
                                for (var i = 0; i < message.keywords.length; ++i) {
                                    var error = $root.google.protobuf.StringValue.verify(message.keywords[i]);
                                    if (error)
                                        return "keywords." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a KeywordSeed message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.KeywordSeed
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.KeywordSeed} KeywordSeed
                         */
                        KeywordSeed.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.KeywordSeed)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.KeywordSeed();
                            if (object.keywords) {
                                if (!Array.isArray(object.keywords))
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordSeed.keywords: array expected");
                                message.keywords = [];
                                for (var i = 0; i < object.keywords.length; ++i) {
                                    if (typeof object.keywords[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.KeywordSeed.keywords: object expected");
                                    message.keywords[i] = $root.google.protobuf.StringValue.fromObject(object.keywords[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordSeed message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.KeywordSeed
                         * @static
                         * @param {google.ads.googleads.v1.services.KeywordSeed} message KeywordSeed
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordSeed.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.keywords = [];
                            if (message.keywords && message.keywords.length) {
                                object.keywords = [];
                                for (var j = 0; j < message.keywords.length; ++j)
                                    object.keywords[j] = $root.google.protobuf.StringValue.toObject(message.keywords[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this KeywordSeed to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.KeywordSeed
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordSeed.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordSeed;
                    })();

                    services.UrlSeed = (function() {

                        /**
                         * Properties of an UrlSeed.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IUrlSeed
                         * @property {google.protobuf.IStringValue|null} [url] UrlSeed url
                         */

                        /**
                         * Constructs a new UrlSeed.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an UrlSeed.
                         * @implements IUrlSeed
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IUrlSeed=} [properties] Properties to set
                         */
                        function UrlSeed(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UrlSeed url.
                         * @member {google.protobuf.IStringValue|null|undefined} url
                         * @memberof google.ads.googleads.v1.services.UrlSeed
                         * @instance
                         */
                        UrlSeed.prototype.url = null;

                        /**
                         * Creates a new UrlSeed instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.UrlSeed
                         * @static
                         * @param {google.ads.googleads.v1.services.IUrlSeed=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.UrlSeed} UrlSeed instance
                         */
                        UrlSeed.create = function create(properties) {
                            return new UrlSeed(properties);
                        };

                        /**
                         * Encodes the specified UrlSeed message. Does not implicitly {@link google.ads.googleads.v1.services.UrlSeed.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.UrlSeed
                         * @static
                         * @param {google.ads.googleads.v1.services.IUrlSeed} message UrlSeed message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlSeed.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.url != null && message.hasOwnProperty("url"))
                                $root.google.protobuf.StringValue.encode(message.url, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified UrlSeed message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.UrlSeed.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.UrlSeed
                         * @static
                         * @param {google.ads.googleads.v1.services.IUrlSeed} message UrlSeed message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlSeed.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an UrlSeed message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.UrlSeed
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.UrlSeed} UrlSeed
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlSeed.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.UrlSeed();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.url = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an UrlSeed message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.UrlSeed
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.UrlSeed} UrlSeed
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlSeed.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an UrlSeed message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.UrlSeed
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UrlSeed.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.url != null && message.hasOwnProperty("url")) {
                                var error = $root.google.protobuf.StringValue.verify(message.url);
                                if (error)
                                    return "url." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an UrlSeed message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.UrlSeed
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.UrlSeed} UrlSeed
                         */
                        UrlSeed.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.UrlSeed)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.UrlSeed();
                            if (object.url != null) {
                                if (typeof object.url !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.UrlSeed.url: object expected");
                                message.url = $root.google.protobuf.StringValue.fromObject(object.url);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an UrlSeed message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.UrlSeed
                         * @static
                         * @param {google.ads.googleads.v1.services.UrlSeed} message UrlSeed
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UrlSeed.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.url = null;
                            if (message.url != null && message.hasOwnProperty("url"))
                                object.url = $root.google.protobuf.StringValue.toObject(message.url, options);
                            return object;
                        };

                        /**
                         * Converts this UrlSeed to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.UrlSeed
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UrlSeed.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UrlSeed;
                    })();

                    services.GenerateKeywordIdeaResponse = (function() {

                        /**
                         * Properties of a GenerateKeywordIdeaResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGenerateKeywordIdeaResponse
                         * @property {Array.<google.ads.googleads.v1.services.IGenerateKeywordIdeaResult>|null} [results] GenerateKeywordIdeaResponse results
                         */

                        /**
                         * Constructs a new GenerateKeywordIdeaResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GenerateKeywordIdeaResponse.
                         * @implements IGenerateKeywordIdeaResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGenerateKeywordIdeaResponse=} [properties] Properties to set
                         */
                        function GenerateKeywordIdeaResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GenerateKeywordIdeaResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IGenerateKeywordIdeaResult>} results
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResponse
                         * @instance
                         */
                        GenerateKeywordIdeaResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new GenerateKeywordIdeaResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateKeywordIdeaResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GenerateKeywordIdeaResponse} GenerateKeywordIdeaResponse instance
                         */
                        GenerateKeywordIdeaResponse.create = function create(properties) {
                            return new GenerateKeywordIdeaResponse(properties);
                        };

                        /**
                         * Encodes the specified GenerateKeywordIdeaResponse message. Does not implicitly {@link google.ads.googleads.v1.services.GenerateKeywordIdeaResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateKeywordIdeaResponse} message GenerateKeywordIdeaResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenerateKeywordIdeaResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.GenerateKeywordIdeaResult.encode(message.results[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified GenerateKeywordIdeaResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GenerateKeywordIdeaResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateKeywordIdeaResponse} message GenerateKeywordIdeaResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenerateKeywordIdeaResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GenerateKeywordIdeaResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GenerateKeywordIdeaResponse} GenerateKeywordIdeaResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenerateKeywordIdeaResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GenerateKeywordIdeaResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.GenerateKeywordIdeaResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GenerateKeywordIdeaResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GenerateKeywordIdeaResponse} GenerateKeywordIdeaResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenerateKeywordIdeaResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GenerateKeywordIdeaResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GenerateKeywordIdeaResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.GenerateKeywordIdeaResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a GenerateKeywordIdeaResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GenerateKeywordIdeaResponse} GenerateKeywordIdeaResponse
                         */
                        GenerateKeywordIdeaResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GenerateKeywordIdeaResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GenerateKeywordIdeaResponse();
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.GenerateKeywordIdeaResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.GenerateKeywordIdeaResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.GenerateKeywordIdeaResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a GenerateKeywordIdeaResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.GenerateKeywordIdeaResponse} message GenerateKeywordIdeaResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GenerateKeywordIdeaResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.GenerateKeywordIdeaResult.toObject(message.results[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this GenerateKeywordIdeaResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GenerateKeywordIdeaResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GenerateKeywordIdeaResponse;
                    })();

                    services.GenerateKeywordIdeaResult = (function() {

                        /**
                         * Properties of a GenerateKeywordIdeaResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGenerateKeywordIdeaResult
                         * @property {google.protobuf.IStringValue|null} [text] GenerateKeywordIdeaResult text
                         * @property {google.ads.googleads.v1.common.IKeywordPlanHistoricalMetrics|null} [keywordIdeaMetrics] GenerateKeywordIdeaResult keywordIdeaMetrics
                         */

                        /**
                         * Constructs a new GenerateKeywordIdeaResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GenerateKeywordIdeaResult.
                         * @implements IGenerateKeywordIdeaResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGenerateKeywordIdeaResult=} [properties] Properties to set
                         */
                        function GenerateKeywordIdeaResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GenerateKeywordIdeaResult text.
                         * @member {google.protobuf.IStringValue|null|undefined} text
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResult
                         * @instance
                         */
                        GenerateKeywordIdeaResult.prototype.text = null;

                        /**
                         * GenerateKeywordIdeaResult keywordIdeaMetrics.
                         * @member {google.ads.googleads.v1.common.IKeywordPlanHistoricalMetrics|null|undefined} keywordIdeaMetrics
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResult
                         * @instance
                         */
                        GenerateKeywordIdeaResult.prototype.keywordIdeaMetrics = null;

                        /**
                         * Creates a new GenerateKeywordIdeaResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateKeywordIdeaResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GenerateKeywordIdeaResult} GenerateKeywordIdeaResult instance
                         */
                        GenerateKeywordIdeaResult.create = function create(properties) {
                            return new GenerateKeywordIdeaResult(properties);
                        };

                        /**
                         * Encodes the specified GenerateKeywordIdeaResult message. Does not implicitly {@link google.ads.googleads.v1.services.GenerateKeywordIdeaResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateKeywordIdeaResult} message GenerateKeywordIdeaResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenerateKeywordIdeaResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.text != null && message.hasOwnProperty("text"))
                                $root.google.protobuf.StringValue.encode(message.text, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.keywordIdeaMetrics != null && message.hasOwnProperty("keywordIdeaMetrics"))
                                $root.google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics.encode(message.keywordIdeaMetrics, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified GenerateKeywordIdeaResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GenerateKeywordIdeaResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateKeywordIdeaResult} message GenerateKeywordIdeaResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenerateKeywordIdeaResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GenerateKeywordIdeaResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GenerateKeywordIdeaResult} GenerateKeywordIdeaResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenerateKeywordIdeaResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GenerateKeywordIdeaResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2:
                                    message.text = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.keywordIdeaMetrics = $root.google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GenerateKeywordIdeaResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GenerateKeywordIdeaResult} GenerateKeywordIdeaResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenerateKeywordIdeaResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GenerateKeywordIdeaResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GenerateKeywordIdeaResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.text != null && message.hasOwnProperty("text")) {
                                var error = $root.google.protobuf.StringValue.verify(message.text);
                                if (error)
                                    return "text." + error;
                            }
                            if (message.keywordIdeaMetrics != null && message.hasOwnProperty("keywordIdeaMetrics")) {
                                var error = $root.google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics.verify(message.keywordIdeaMetrics);
                                if (error)
                                    return "keywordIdeaMetrics." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a GenerateKeywordIdeaResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GenerateKeywordIdeaResult} GenerateKeywordIdeaResult
                         */
                        GenerateKeywordIdeaResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GenerateKeywordIdeaResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GenerateKeywordIdeaResult();
                            if (object.text != null) {
                                if (typeof object.text !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GenerateKeywordIdeaResult.text: object expected");
                                message.text = $root.google.protobuf.StringValue.fromObject(object.text);
                            }
                            if (object.keywordIdeaMetrics != null) {
                                if (typeof object.keywordIdeaMetrics !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.GenerateKeywordIdeaResult.keywordIdeaMetrics: object expected");
                                message.keywordIdeaMetrics = $root.google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics.fromObject(object.keywordIdeaMetrics);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a GenerateKeywordIdeaResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResult
                         * @static
                         * @param {google.ads.googleads.v1.services.GenerateKeywordIdeaResult} message GenerateKeywordIdeaResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GenerateKeywordIdeaResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.text = null;
                                object.keywordIdeaMetrics = null;
                            }
                            if (message.text != null && message.hasOwnProperty("text"))
                                object.text = $root.google.protobuf.StringValue.toObject(message.text, options);
                            if (message.keywordIdeaMetrics != null && message.hasOwnProperty("keywordIdeaMetrics"))
                                object.keywordIdeaMetrics = $root.google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics.toObject(message.keywordIdeaMetrics, options);
                            return object;
                        };

                        /**
                         * Converts this GenerateKeywordIdeaResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GenerateKeywordIdeaResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GenerateKeywordIdeaResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GenerateKeywordIdeaResult;
                    })();

                    services.KeywordPlanKeywordService = (function() {

                        /**
                         * Constructs a new KeywordPlanKeywordService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a KeywordPlanKeywordService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function KeywordPlanKeywordService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (KeywordPlanKeywordService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = KeywordPlanKeywordService;

                        /**
                         * Creates new KeywordPlanKeywordService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {KeywordPlanKeywordService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        KeywordPlanKeywordService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.KeywordPlanKeywordService#getKeywordPlanKeyword}.
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordService
                         * @typedef GetKeywordPlanKeywordCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.KeywordPlanKeyword} [response] KeywordPlanKeyword
                         */

                        /**
                         * Calls GetKeywordPlanKeyword.
                         * @function getKeywordPlanKeyword
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanKeywordRequest} request GetKeywordPlanKeywordRequest message or plain object
                         * @param {google.ads.googleads.v1.services.KeywordPlanKeywordService.GetKeywordPlanKeywordCallback} callback Node-style callback called with the error, if any, and KeywordPlanKeyword
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(KeywordPlanKeywordService.prototype.getKeywordPlanKeyword = function getKeywordPlanKeyword(request, callback) {
                            return this.rpcCall(getKeywordPlanKeyword, $root.google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest, $root.google.ads.googleads.v1.resources.KeywordPlanKeyword, request, callback);
                        }, "name", { value: "GetKeywordPlanKeyword" });

                        /**
                         * Calls GetKeywordPlanKeyword.
                         * @function getKeywordPlanKeyword
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanKeywordRequest} request GetKeywordPlanKeywordRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.KeywordPlanKeyword>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.KeywordPlanKeywordService#mutateKeywordPlanKeywords}.
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordService
                         * @typedef MutateKeywordPlanKeywordsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse} [response] MutateKeywordPlanKeywordsResponse
                         */

                        /**
                         * Calls MutateKeywordPlanKeywords.
                         * @function mutateKeywordPlanKeywords
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanKeywordsRequest} request MutateKeywordPlanKeywordsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.KeywordPlanKeywordService.MutateKeywordPlanKeywordsCallback} callback Node-style callback called with the error, if any, and MutateKeywordPlanKeywordsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(KeywordPlanKeywordService.prototype.mutateKeywordPlanKeywords = function mutateKeywordPlanKeywords(request, callback) {
                            return this.rpcCall(mutateKeywordPlanKeywords, $root.google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest, $root.google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse, request, callback);
                        }, "name", { value: "MutateKeywordPlanKeywords" });

                        /**
                         * Calls MutateKeywordPlanKeywords.
                         * @function mutateKeywordPlanKeywords
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanKeywordsRequest} request MutateKeywordPlanKeywordsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse>} Promise
                         * @variation 2
                         */

                        return KeywordPlanKeywordService;
                    })();

                    services.GetKeywordPlanKeywordRequest = (function() {

                        /**
                         * Properties of a GetKeywordPlanKeywordRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetKeywordPlanKeywordRequest
                         * @property {string|null} [resourceName] GetKeywordPlanKeywordRequest resourceName
                         */

                        /**
                         * Constructs a new GetKeywordPlanKeywordRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetKeywordPlanKeywordRequest.
                         * @implements IGetKeywordPlanKeywordRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanKeywordRequest=} [properties] Properties to set
                         */
                        function GetKeywordPlanKeywordRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetKeywordPlanKeywordRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest
                         * @instance
                         */
                        GetKeywordPlanKeywordRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetKeywordPlanKeywordRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanKeywordRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest} GetKeywordPlanKeywordRequest instance
                         */
                        GetKeywordPlanKeywordRequest.create = function create(properties) {
                            return new GetKeywordPlanKeywordRequest(properties);
                        };

                        /**
                         * Encodes the specified GetKeywordPlanKeywordRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanKeywordRequest} message GetKeywordPlanKeywordRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetKeywordPlanKeywordRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetKeywordPlanKeywordRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanKeywordRequest} message GetKeywordPlanKeywordRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetKeywordPlanKeywordRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetKeywordPlanKeywordRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest} GetKeywordPlanKeywordRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetKeywordPlanKeywordRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetKeywordPlanKeywordRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest} GetKeywordPlanKeywordRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetKeywordPlanKeywordRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetKeywordPlanKeywordRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetKeywordPlanKeywordRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetKeywordPlanKeywordRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest} GetKeywordPlanKeywordRequest
                         */
                        GetKeywordPlanKeywordRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetKeywordPlanKeywordRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest} message GetKeywordPlanKeywordRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetKeywordPlanKeywordRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetKeywordPlanKeywordRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanKeywordRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetKeywordPlanKeywordRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetKeywordPlanKeywordRequest;
                    })();

                    services.MutateKeywordPlanKeywordsRequest = (function() {

                        /**
                         * Properties of a MutateKeywordPlanKeywordsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateKeywordPlanKeywordsRequest
                         * @property {string|null} [customerId] MutateKeywordPlanKeywordsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IKeywordPlanKeywordOperation>|null} [operations] MutateKeywordPlanKeywordsRequest operations
                         * @property {boolean|null} [partialFailure] MutateKeywordPlanKeywordsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateKeywordPlanKeywordsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateKeywordPlanKeywordsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateKeywordPlanKeywordsRequest.
                         * @implements IMutateKeywordPlanKeywordsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanKeywordsRequest=} [properties] Properties to set
                         */
                        function MutateKeywordPlanKeywordsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateKeywordPlanKeywordsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest
                         * @instance
                         */
                        MutateKeywordPlanKeywordsRequest.prototype.customerId = "";

                        /**
                         * MutateKeywordPlanKeywordsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IKeywordPlanKeywordOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest
                         * @instance
                         */
                        MutateKeywordPlanKeywordsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateKeywordPlanKeywordsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest
                         * @instance
                         */
                        MutateKeywordPlanKeywordsRequest.prototype.partialFailure = false;

                        /**
                         * MutateKeywordPlanKeywordsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest
                         * @instance
                         */
                        MutateKeywordPlanKeywordsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateKeywordPlanKeywordsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanKeywordsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest} MutateKeywordPlanKeywordsRequest instance
                         */
                        MutateKeywordPlanKeywordsRequest.create = function create(properties) {
                            return new MutateKeywordPlanKeywordsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanKeywordsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanKeywordsRequest} message MutateKeywordPlanKeywordsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanKeywordsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.KeywordPlanKeywordOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanKeywordsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanKeywordsRequest} message MutateKeywordPlanKeywordsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanKeywordsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateKeywordPlanKeywordsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest} MutateKeywordPlanKeywordsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanKeywordsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.KeywordPlanKeywordOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateKeywordPlanKeywordsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest} MutateKeywordPlanKeywordsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanKeywordsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateKeywordPlanKeywordsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateKeywordPlanKeywordsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.KeywordPlanKeywordOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateKeywordPlanKeywordsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest} MutateKeywordPlanKeywordsRequest
                         */
                        MutateKeywordPlanKeywordsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.KeywordPlanKeywordOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateKeywordPlanKeywordsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest} message MutateKeywordPlanKeywordsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateKeywordPlanKeywordsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.KeywordPlanKeywordOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateKeywordPlanKeywordsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateKeywordPlanKeywordsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateKeywordPlanKeywordsRequest;
                    })();

                    services.KeywordPlanKeywordOperation = (function() {

                        /**
                         * Properties of a KeywordPlanKeywordOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IKeywordPlanKeywordOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] KeywordPlanKeywordOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IKeywordPlanKeyword|null} [create] KeywordPlanKeywordOperation create
                         * @property {google.ads.googleads.v1.resources.IKeywordPlanKeyword|null} [update] KeywordPlanKeywordOperation update
                         * @property {string|null} [remove] KeywordPlanKeywordOperation remove
                         */

                        /**
                         * Constructs a new KeywordPlanKeywordOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a KeywordPlanKeywordOperation.
                         * @implements IKeywordPlanKeywordOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IKeywordPlanKeywordOperation=} [properties] Properties to set
                         */
                        function KeywordPlanKeywordOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordPlanKeywordOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordOperation
                         * @instance
                         */
                        KeywordPlanKeywordOperation.prototype.updateMask = null;

                        /**
                         * KeywordPlanKeywordOperation create.
                         * @member {google.ads.googleads.v1.resources.IKeywordPlanKeyword|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordOperation
                         * @instance
                         */
                        KeywordPlanKeywordOperation.prototype.create = null;

                        /**
                         * KeywordPlanKeywordOperation update.
                         * @member {google.ads.googleads.v1.resources.IKeywordPlanKeyword|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordOperation
                         * @instance
                         */
                        KeywordPlanKeywordOperation.prototype.update = null;

                        /**
                         * KeywordPlanKeywordOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordOperation
                         * @instance
                         */
                        KeywordPlanKeywordOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * KeywordPlanKeywordOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordOperation
                         * @instance
                         */
                        Object.defineProperty(KeywordPlanKeywordOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new KeywordPlanKeywordOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanKeywordOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.KeywordPlanKeywordOperation} KeywordPlanKeywordOperation instance
                         */
                        KeywordPlanKeywordOperation.create = function create(properties) {
                            return new KeywordPlanKeywordOperation(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanKeywordOperation message. Does not implicitly {@link google.ads.googleads.v1.services.KeywordPlanKeywordOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanKeywordOperation} message KeywordPlanKeywordOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanKeywordOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.KeywordPlanKeyword.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.KeywordPlanKeyword.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanKeywordOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.KeywordPlanKeywordOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanKeywordOperation} message KeywordPlanKeywordOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanKeywordOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanKeywordOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.KeywordPlanKeywordOperation} KeywordPlanKeywordOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanKeywordOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.KeywordPlanKeywordOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.KeywordPlanKeyword.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.KeywordPlanKeyword.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanKeywordOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.KeywordPlanKeywordOperation} KeywordPlanKeywordOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanKeywordOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanKeywordOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanKeywordOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.KeywordPlanKeyword.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.KeywordPlanKeyword.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanKeywordOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.KeywordPlanKeywordOperation} KeywordPlanKeywordOperation
                         */
                        KeywordPlanKeywordOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.KeywordPlanKeywordOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.KeywordPlanKeywordOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanKeywordOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanKeywordOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.KeywordPlanKeyword.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanKeywordOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.KeywordPlanKeyword.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordPlanKeywordOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.KeywordPlanKeywordOperation} message KeywordPlanKeywordOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanKeywordOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.KeywordPlanKeyword.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.KeywordPlanKeyword.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this KeywordPlanKeywordOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanKeywordOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordPlanKeywordOperation;
                    })();

                    services.MutateKeywordPlanKeywordsResponse = (function() {

                        /**
                         * Properties of a MutateKeywordPlanKeywordsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateKeywordPlanKeywordsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateKeywordPlanKeywordsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateKeywordPlanKeywordResult>|null} [results] MutateKeywordPlanKeywordsResponse results
                         */

                        /**
                         * Constructs a new MutateKeywordPlanKeywordsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateKeywordPlanKeywordsResponse.
                         * @implements IMutateKeywordPlanKeywordsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanKeywordsResponse=} [properties] Properties to set
                         */
                        function MutateKeywordPlanKeywordsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateKeywordPlanKeywordsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse
                         * @instance
                         */
                        MutateKeywordPlanKeywordsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateKeywordPlanKeywordsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateKeywordPlanKeywordResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse
                         * @instance
                         */
                        MutateKeywordPlanKeywordsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateKeywordPlanKeywordsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanKeywordsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse} MutateKeywordPlanKeywordsResponse instance
                         */
                        MutateKeywordPlanKeywordsResponse.create = function create(properties) {
                            return new MutateKeywordPlanKeywordsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanKeywordsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanKeywordsResponse} message MutateKeywordPlanKeywordsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanKeywordsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanKeywordsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanKeywordsResponse} message MutateKeywordPlanKeywordsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanKeywordsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateKeywordPlanKeywordsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse} MutateKeywordPlanKeywordsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanKeywordsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateKeywordPlanKeywordsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse} MutateKeywordPlanKeywordsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanKeywordsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateKeywordPlanKeywordsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateKeywordPlanKeywordsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateKeywordPlanKeywordsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse} MutateKeywordPlanKeywordsResponse
                         */
                        MutateKeywordPlanKeywordsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateKeywordPlanKeywordsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse} message MutateKeywordPlanKeywordsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateKeywordPlanKeywordsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateKeywordPlanKeywordsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateKeywordPlanKeywordsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateKeywordPlanKeywordsResponse;
                    })();

                    services.MutateKeywordPlanKeywordResult = (function() {

                        /**
                         * Properties of a MutateKeywordPlanKeywordResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateKeywordPlanKeywordResult
                         * @property {string|null} [resourceName] MutateKeywordPlanKeywordResult resourceName
                         */

                        /**
                         * Constructs a new MutateKeywordPlanKeywordResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateKeywordPlanKeywordResult.
                         * @implements IMutateKeywordPlanKeywordResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanKeywordResult=} [properties] Properties to set
                         */
                        function MutateKeywordPlanKeywordResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateKeywordPlanKeywordResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult
                         * @instance
                         */
                        MutateKeywordPlanKeywordResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateKeywordPlanKeywordResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanKeywordResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult} MutateKeywordPlanKeywordResult instance
                         */
                        MutateKeywordPlanKeywordResult.create = function create(properties) {
                            return new MutateKeywordPlanKeywordResult(properties);
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanKeywordResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanKeywordResult} message MutateKeywordPlanKeywordResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanKeywordResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanKeywordResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanKeywordResult} message MutateKeywordPlanKeywordResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanKeywordResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateKeywordPlanKeywordResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult} MutateKeywordPlanKeywordResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanKeywordResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateKeywordPlanKeywordResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult} MutateKeywordPlanKeywordResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanKeywordResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateKeywordPlanKeywordResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateKeywordPlanKeywordResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateKeywordPlanKeywordResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult} MutateKeywordPlanKeywordResult
                         */
                        MutateKeywordPlanKeywordResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateKeywordPlanKeywordResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult} message MutateKeywordPlanKeywordResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateKeywordPlanKeywordResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateKeywordPlanKeywordResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanKeywordResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateKeywordPlanKeywordResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateKeywordPlanKeywordResult;
                    })();

                    services.KeywordPlanNegativeKeywordService = (function() {

                        /**
                         * Constructs a new KeywordPlanNegativeKeywordService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a KeywordPlanNegativeKeywordService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function KeywordPlanNegativeKeywordService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (KeywordPlanNegativeKeywordService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = KeywordPlanNegativeKeywordService;

                        /**
                         * Creates new KeywordPlanNegativeKeywordService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {KeywordPlanNegativeKeywordService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        KeywordPlanNegativeKeywordService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.KeywordPlanNegativeKeywordService#getKeywordPlanNegativeKeyword}.
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordService
                         * @typedef GetKeywordPlanNegativeKeywordCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword} [response] KeywordPlanNegativeKeyword
                         */

                        /**
                         * Calls GetKeywordPlanNegativeKeyword.
                         * @function getKeywordPlanNegativeKeyword
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanNegativeKeywordRequest} request GetKeywordPlanNegativeKeywordRequest message or plain object
                         * @param {google.ads.googleads.v1.services.KeywordPlanNegativeKeywordService.GetKeywordPlanNegativeKeywordCallback} callback Node-style callback called with the error, if any, and KeywordPlanNegativeKeyword
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(KeywordPlanNegativeKeywordService.prototype.getKeywordPlanNegativeKeyword = function getKeywordPlanNegativeKeyword(request, callback) {
                            return this.rpcCall(getKeywordPlanNegativeKeyword, $root.google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest, $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword, request, callback);
                        }, "name", { value: "GetKeywordPlanNegativeKeyword" });

                        /**
                         * Calls GetKeywordPlanNegativeKeyword.
                         * @function getKeywordPlanNegativeKeyword
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanNegativeKeywordRequest} request GetKeywordPlanNegativeKeywordRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.KeywordPlanNegativeKeywordService#mutateKeywordPlanNegativeKeywords}.
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordService
                         * @typedef MutateKeywordPlanNegativeKeywordsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse} [response] MutateKeywordPlanNegativeKeywordsResponse
                         */

                        /**
                         * Calls MutateKeywordPlanNegativeKeywords.
                         * @function mutateKeywordPlanNegativeKeywords
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanNegativeKeywordsRequest} request MutateKeywordPlanNegativeKeywordsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.KeywordPlanNegativeKeywordService.MutateKeywordPlanNegativeKeywordsCallback} callback Node-style callback called with the error, if any, and MutateKeywordPlanNegativeKeywordsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(KeywordPlanNegativeKeywordService.prototype.mutateKeywordPlanNegativeKeywords = function mutateKeywordPlanNegativeKeywords(request, callback) {
                            return this.rpcCall(mutateKeywordPlanNegativeKeywords, $root.google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest, $root.google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse, request, callback);
                        }, "name", { value: "MutateKeywordPlanNegativeKeywords" });

                        /**
                         * Calls MutateKeywordPlanNegativeKeywords.
                         * @function mutateKeywordPlanNegativeKeywords
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanNegativeKeywordsRequest} request MutateKeywordPlanNegativeKeywordsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse>} Promise
                         * @variation 2
                         */

                        return KeywordPlanNegativeKeywordService;
                    })();

                    services.GetKeywordPlanNegativeKeywordRequest = (function() {

                        /**
                         * Properties of a GetKeywordPlanNegativeKeywordRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetKeywordPlanNegativeKeywordRequest
                         * @property {string|null} [resourceName] GetKeywordPlanNegativeKeywordRequest resourceName
                         */

                        /**
                         * Constructs a new GetKeywordPlanNegativeKeywordRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetKeywordPlanNegativeKeywordRequest.
                         * @implements IGetKeywordPlanNegativeKeywordRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanNegativeKeywordRequest=} [properties] Properties to set
                         */
                        function GetKeywordPlanNegativeKeywordRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetKeywordPlanNegativeKeywordRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest
                         * @instance
                         */
                        GetKeywordPlanNegativeKeywordRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetKeywordPlanNegativeKeywordRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanNegativeKeywordRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest} GetKeywordPlanNegativeKeywordRequest instance
                         */
                        GetKeywordPlanNegativeKeywordRequest.create = function create(properties) {
                            return new GetKeywordPlanNegativeKeywordRequest(properties);
                        };

                        /**
                         * Encodes the specified GetKeywordPlanNegativeKeywordRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanNegativeKeywordRequest} message GetKeywordPlanNegativeKeywordRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetKeywordPlanNegativeKeywordRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetKeywordPlanNegativeKeywordRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanNegativeKeywordRequest} message GetKeywordPlanNegativeKeywordRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetKeywordPlanNegativeKeywordRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetKeywordPlanNegativeKeywordRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest} GetKeywordPlanNegativeKeywordRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetKeywordPlanNegativeKeywordRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetKeywordPlanNegativeKeywordRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest} GetKeywordPlanNegativeKeywordRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetKeywordPlanNegativeKeywordRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetKeywordPlanNegativeKeywordRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetKeywordPlanNegativeKeywordRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetKeywordPlanNegativeKeywordRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest} GetKeywordPlanNegativeKeywordRequest
                         */
                        GetKeywordPlanNegativeKeywordRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetKeywordPlanNegativeKeywordRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest} message GetKeywordPlanNegativeKeywordRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetKeywordPlanNegativeKeywordRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetKeywordPlanNegativeKeywordRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanNegativeKeywordRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetKeywordPlanNegativeKeywordRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetKeywordPlanNegativeKeywordRequest;
                    })();

                    services.MutateKeywordPlanNegativeKeywordsRequest = (function() {

                        /**
                         * Properties of a MutateKeywordPlanNegativeKeywordsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateKeywordPlanNegativeKeywordsRequest
                         * @property {string|null} [customerId] MutateKeywordPlanNegativeKeywordsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IKeywordPlanNegativeKeywordOperation>|null} [operations] MutateKeywordPlanNegativeKeywordsRequest operations
                         * @property {boolean|null} [partialFailure] MutateKeywordPlanNegativeKeywordsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateKeywordPlanNegativeKeywordsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateKeywordPlanNegativeKeywordsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateKeywordPlanNegativeKeywordsRequest.
                         * @implements IMutateKeywordPlanNegativeKeywordsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanNegativeKeywordsRequest=} [properties] Properties to set
                         */
                        function MutateKeywordPlanNegativeKeywordsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateKeywordPlanNegativeKeywordsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest
                         * @instance
                         */
                        MutateKeywordPlanNegativeKeywordsRequest.prototype.customerId = "";

                        /**
                         * MutateKeywordPlanNegativeKeywordsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IKeywordPlanNegativeKeywordOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest
                         * @instance
                         */
                        MutateKeywordPlanNegativeKeywordsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateKeywordPlanNegativeKeywordsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest
                         * @instance
                         */
                        MutateKeywordPlanNegativeKeywordsRequest.prototype.partialFailure = false;

                        /**
                         * MutateKeywordPlanNegativeKeywordsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest
                         * @instance
                         */
                        MutateKeywordPlanNegativeKeywordsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateKeywordPlanNegativeKeywordsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanNegativeKeywordsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest} MutateKeywordPlanNegativeKeywordsRequest instance
                         */
                        MutateKeywordPlanNegativeKeywordsRequest.create = function create(properties) {
                            return new MutateKeywordPlanNegativeKeywordsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanNegativeKeywordsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanNegativeKeywordsRequest} message MutateKeywordPlanNegativeKeywordsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanNegativeKeywordsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanNegativeKeywordsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanNegativeKeywordsRequest} message MutateKeywordPlanNegativeKeywordsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanNegativeKeywordsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateKeywordPlanNegativeKeywordsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest} MutateKeywordPlanNegativeKeywordsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanNegativeKeywordsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateKeywordPlanNegativeKeywordsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest} MutateKeywordPlanNegativeKeywordsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanNegativeKeywordsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateKeywordPlanNegativeKeywordsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateKeywordPlanNegativeKeywordsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateKeywordPlanNegativeKeywordsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest} MutateKeywordPlanNegativeKeywordsRequest
                         */
                        MutateKeywordPlanNegativeKeywordsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateKeywordPlanNegativeKeywordsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest} message MutateKeywordPlanNegativeKeywordsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateKeywordPlanNegativeKeywordsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateKeywordPlanNegativeKeywordsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateKeywordPlanNegativeKeywordsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateKeywordPlanNegativeKeywordsRequest;
                    })();

                    services.KeywordPlanNegativeKeywordOperation = (function() {

                        /**
                         * Properties of a KeywordPlanNegativeKeywordOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IKeywordPlanNegativeKeywordOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] KeywordPlanNegativeKeywordOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IKeywordPlanNegativeKeyword|null} [create] KeywordPlanNegativeKeywordOperation create
                         * @property {google.ads.googleads.v1.resources.IKeywordPlanNegativeKeyword|null} [update] KeywordPlanNegativeKeywordOperation update
                         * @property {string|null} [remove] KeywordPlanNegativeKeywordOperation remove
                         */

                        /**
                         * Constructs a new KeywordPlanNegativeKeywordOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a KeywordPlanNegativeKeywordOperation.
                         * @implements IKeywordPlanNegativeKeywordOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IKeywordPlanNegativeKeywordOperation=} [properties] Properties to set
                         */
                        function KeywordPlanNegativeKeywordOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordPlanNegativeKeywordOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation
                         * @instance
                         */
                        KeywordPlanNegativeKeywordOperation.prototype.updateMask = null;

                        /**
                         * KeywordPlanNegativeKeywordOperation create.
                         * @member {google.ads.googleads.v1.resources.IKeywordPlanNegativeKeyword|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation
                         * @instance
                         */
                        KeywordPlanNegativeKeywordOperation.prototype.create = null;

                        /**
                         * KeywordPlanNegativeKeywordOperation update.
                         * @member {google.ads.googleads.v1.resources.IKeywordPlanNegativeKeyword|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation
                         * @instance
                         */
                        KeywordPlanNegativeKeywordOperation.prototype.update = null;

                        /**
                         * KeywordPlanNegativeKeywordOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation
                         * @instance
                         */
                        KeywordPlanNegativeKeywordOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * KeywordPlanNegativeKeywordOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation
                         * @instance
                         */
                        Object.defineProperty(KeywordPlanNegativeKeywordOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new KeywordPlanNegativeKeywordOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanNegativeKeywordOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation} KeywordPlanNegativeKeywordOperation instance
                         */
                        KeywordPlanNegativeKeywordOperation.create = function create(properties) {
                            return new KeywordPlanNegativeKeywordOperation(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanNegativeKeywordOperation message. Does not implicitly {@link google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanNegativeKeywordOperation} message KeywordPlanNegativeKeywordOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanNegativeKeywordOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanNegativeKeywordOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanNegativeKeywordOperation} message KeywordPlanNegativeKeywordOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanNegativeKeywordOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanNegativeKeywordOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation} KeywordPlanNegativeKeywordOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanNegativeKeywordOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanNegativeKeywordOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation} KeywordPlanNegativeKeywordOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanNegativeKeywordOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanNegativeKeywordOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanNegativeKeywordOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanNegativeKeywordOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation} KeywordPlanNegativeKeywordOperation
                         */
                        KeywordPlanNegativeKeywordOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordPlanNegativeKeywordOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation} message KeywordPlanNegativeKeywordOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanNegativeKeywordOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.KeywordPlanNegativeKeyword.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this KeywordPlanNegativeKeywordOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.KeywordPlanNegativeKeywordOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanNegativeKeywordOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordPlanNegativeKeywordOperation;
                    })();

                    services.MutateKeywordPlanNegativeKeywordsResponse = (function() {

                        /**
                         * Properties of a MutateKeywordPlanNegativeKeywordsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateKeywordPlanNegativeKeywordsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateKeywordPlanNegativeKeywordsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateKeywordPlanNegativeKeywordResult>|null} [results] MutateKeywordPlanNegativeKeywordsResponse results
                         */

                        /**
                         * Constructs a new MutateKeywordPlanNegativeKeywordsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateKeywordPlanNegativeKeywordsResponse.
                         * @implements IMutateKeywordPlanNegativeKeywordsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanNegativeKeywordsResponse=} [properties] Properties to set
                         */
                        function MutateKeywordPlanNegativeKeywordsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateKeywordPlanNegativeKeywordsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse
                         * @instance
                         */
                        MutateKeywordPlanNegativeKeywordsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateKeywordPlanNegativeKeywordsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateKeywordPlanNegativeKeywordResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse
                         * @instance
                         */
                        MutateKeywordPlanNegativeKeywordsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateKeywordPlanNegativeKeywordsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanNegativeKeywordsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse} MutateKeywordPlanNegativeKeywordsResponse instance
                         */
                        MutateKeywordPlanNegativeKeywordsResponse.create = function create(properties) {
                            return new MutateKeywordPlanNegativeKeywordsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanNegativeKeywordsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanNegativeKeywordsResponse} message MutateKeywordPlanNegativeKeywordsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanNegativeKeywordsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanNegativeKeywordsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanNegativeKeywordsResponse} message MutateKeywordPlanNegativeKeywordsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanNegativeKeywordsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateKeywordPlanNegativeKeywordsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse} MutateKeywordPlanNegativeKeywordsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanNegativeKeywordsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateKeywordPlanNegativeKeywordsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse} MutateKeywordPlanNegativeKeywordsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanNegativeKeywordsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateKeywordPlanNegativeKeywordsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateKeywordPlanNegativeKeywordsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateKeywordPlanNegativeKeywordsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse} MutateKeywordPlanNegativeKeywordsResponse
                         */
                        MutateKeywordPlanNegativeKeywordsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateKeywordPlanNegativeKeywordsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse} message MutateKeywordPlanNegativeKeywordsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateKeywordPlanNegativeKeywordsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateKeywordPlanNegativeKeywordsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateKeywordPlanNegativeKeywordsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateKeywordPlanNegativeKeywordsResponse;
                    })();

                    services.MutateKeywordPlanNegativeKeywordResult = (function() {

                        /**
                         * Properties of a MutateKeywordPlanNegativeKeywordResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateKeywordPlanNegativeKeywordResult
                         * @property {string|null} [resourceName] MutateKeywordPlanNegativeKeywordResult resourceName
                         */

                        /**
                         * Constructs a new MutateKeywordPlanNegativeKeywordResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateKeywordPlanNegativeKeywordResult.
                         * @implements IMutateKeywordPlanNegativeKeywordResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanNegativeKeywordResult=} [properties] Properties to set
                         */
                        function MutateKeywordPlanNegativeKeywordResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateKeywordPlanNegativeKeywordResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult
                         * @instance
                         */
                        MutateKeywordPlanNegativeKeywordResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateKeywordPlanNegativeKeywordResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanNegativeKeywordResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult} MutateKeywordPlanNegativeKeywordResult instance
                         */
                        MutateKeywordPlanNegativeKeywordResult.create = function create(properties) {
                            return new MutateKeywordPlanNegativeKeywordResult(properties);
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanNegativeKeywordResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanNegativeKeywordResult} message MutateKeywordPlanNegativeKeywordResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanNegativeKeywordResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateKeywordPlanNegativeKeywordResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlanNegativeKeywordResult} message MutateKeywordPlanNegativeKeywordResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlanNegativeKeywordResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateKeywordPlanNegativeKeywordResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult} MutateKeywordPlanNegativeKeywordResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanNegativeKeywordResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateKeywordPlanNegativeKeywordResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult} MutateKeywordPlanNegativeKeywordResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlanNegativeKeywordResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateKeywordPlanNegativeKeywordResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateKeywordPlanNegativeKeywordResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateKeywordPlanNegativeKeywordResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult} MutateKeywordPlanNegativeKeywordResult
                         */
                        MutateKeywordPlanNegativeKeywordResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateKeywordPlanNegativeKeywordResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult} message MutateKeywordPlanNegativeKeywordResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateKeywordPlanNegativeKeywordResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateKeywordPlanNegativeKeywordResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlanNegativeKeywordResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateKeywordPlanNegativeKeywordResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateKeywordPlanNegativeKeywordResult;
                    })();

                    services.KeywordPlanService = (function() {

                        /**
                         * Constructs a new KeywordPlanService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a KeywordPlanService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function KeywordPlanService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (KeywordPlanService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = KeywordPlanService;

                        /**
                         * Creates new KeywordPlanService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {KeywordPlanService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        KeywordPlanService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.KeywordPlanService#getKeywordPlan}.
                         * @memberof google.ads.googleads.v1.services.KeywordPlanService
                         * @typedef GetKeywordPlanCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.KeywordPlan} [response] KeywordPlan
                         */

                        /**
                         * Calls GetKeywordPlan.
                         * @function getKeywordPlan
                         * @memberof google.ads.googleads.v1.services.KeywordPlanService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanRequest} request GetKeywordPlanRequest message or plain object
                         * @param {google.ads.googleads.v1.services.KeywordPlanService.GetKeywordPlanCallback} callback Node-style callback called with the error, if any, and KeywordPlan
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(KeywordPlanService.prototype.getKeywordPlan = function getKeywordPlan(request, callback) {
                            return this.rpcCall(getKeywordPlan, $root.google.ads.googleads.v1.services.GetKeywordPlanRequest, $root.google.ads.googleads.v1.resources.KeywordPlan, request, callback);
                        }, "name", { value: "GetKeywordPlan" });

                        /**
                         * Calls GetKeywordPlan.
                         * @function getKeywordPlan
                         * @memberof google.ads.googleads.v1.services.KeywordPlanService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanRequest} request GetKeywordPlanRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.KeywordPlan>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.KeywordPlanService#mutateKeywordPlans}.
                         * @memberof google.ads.googleads.v1.services.KeywordPlanService
                         * @typedef MutateKeywordPlansCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlansResponse} [response] MutateKeywordPlansResponse
                         */

                        /**
                         * Calls MutateKeywordPlans.
                         * @function mutateKeywordPlans
                         * @memberof google.ads.googleads.v1.services.KeywordPlanService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlansRequest} request MutateKeywordPlansRequest message or plain object
                         * @param {google.ads.googleads.v1.services.KeywordPlanService.MutateKeywordPlansCallback} callback Node-style callback called with the error, if any, and MutateKeywordPlansResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(KeywordPlanService.prototype.mutateKeywordPlans = function mutateKeywordPlans(request, callback) {
                            return this.rpcCall(mutateKeywordPlans, $root.google.ads.googleads.v1.services.MutateKeywordPlansRequest, $root.google.ads.googleads.v1.services.MutateKeywordPlansResponse, request, callback);
                        }, "name", { value: "MutateKeywordPlans" });

                        /**
                         * Calls MutateKeywordPlans.
                         * @function mutateKeywordPlans
                         * @memberof google.ads.googleads.v1.services.KeywordPlanService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlansRequest} request MutateKeywordPlansRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateKeywordPlansResponse>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.KeywordPlanService#generateForecastMetrics}.
                         * @memberof google.ads.googleads.v1.services.KeywordPlanService
                         * @typedef GenerateForecastMetricsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.GenerateForecastMetricsResponse} [response] GenerateForecastMetricsResponse
                         */

                        /**
                         * Calls GenerateForecastMetrics.
                         * @function generateForecastMetrics
                         * @memberof google.ads.googleads.v1.services.KeywordPlanService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGenerateForecastMetricsRequest} request GenerateForecastMetricsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.KeywordPlanService.GenerateForecastMetricsCallback} callback Node-style callback called with the error, if any, and GenerateForecastMetricsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(KeywordPlanService.prototype.generateForecastMetrics = function generateForecastMetrics(request, callback) {
                            return this.rpcCall(generateForecastMetrics, $root.google.ads.googleads.v1.services.GenerateForecastMetricsRequest, $root.google.ads.googleads.v1.services.GenerateForecastMetricsResponse, request, callback);
                        }, "name", { value: "GenerateForecastMetrics" });

                        /**
                         * Calls GenerateForecastMetrics.
                         * @function generateForecastMetrics
                         * @memberof google.ads.googleads.v1.services.KeywordPlanService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGenerateForecastMetricsRequest} request GenerateForecastMetricsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.GenerateForecastMetricsResponse>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.KeywordPlanService#generateHistoricalMetrics}.
                         * @memberof google.ads.googleads.v1.services.KeywordPlanService
                         * @typedef GenerateHistoricalMetricsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse} [response] GenerateHistoricalMetricsResponse
                         */

                        /**
                         * Calls GenerateHistoricalMetrics.
                         * @function generateHistoricalMetrics
                         * @memberof google.ads.googleads.v1.services.KeywordPlanService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGenerateHistoricalMetricsRequest} request GenerateHistoricalMetricsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.KeywordPlanService.GenerateHistoricalMetricsCallback} callback Node-style callback called with the error, if any, and GenerateHistoricalMetricsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(KeywordPlanService.prototype.generateHistoricalMetrics = function generateHistoricalMetrics(request, callback) {
                            return this.rpcCall(generateHistoricalMetrics, $root.google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest, $root.google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse, request, callback);
                        }, "name", { value: "GenerateHistoricalMetrics" });

                        /**
                         * Calls GenerateHistoricalMetrics.
                         * @function generateHistoricalMetrics
                         * @memberof google.ads.googleads.v1.services.KeywordPlanService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGenerateHistoricalMetricsRequest} request GenerateHistoricalMetricsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse>} Promise
                         * @variation 2
                         */

                        return KeywordPlanService;
                    })();

                    services.GetKeywordPlanRequest = (function() {

                        /**
                         * Properties of a GetKeywordPlanRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetKeywordPlanRequest
                         * @property {string|null} [resourceName] GetKeywordPlanRequest resourceName
                         */

                        /**
                         * Constructs a new GetKeywordPlanRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetKeywordPlanRequest.
                         * @implements IGetKeywordPlanRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanRequest=} [properties] Properties to set
                         */
                        function GetKeywordPlanRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetKeywordPlanRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanRequest
                         * @instance
                         */
                        GetKeywordPlanRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetKeywordPlanRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanRequest} GetKeywordPlanRequest instance
                         */
                        GetKeywordPlanRequest.create = function create(properties) {
                            return new GetKeywordPlanRequest(properties);
                        };

                        /**
                         * Encodes the specified GetKeywordPlanRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetKeywordPlanRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanRequest} message GetKeywordPlanRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetKeywordPlanRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetKeywordPlanRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetKeywordPlanRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetKeywordPlanRequest} message GetKeywordPlanRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetKeywordPlanRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetKeywordPlanRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanRequest} GetKeywordPlanRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetKeywordPlanRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetKeywordPlanRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetKeywordPlanRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanRequest} GetKeywordPlanRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetKeywordPlanRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetKeywordPlanRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetKeywordPlanRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetKeywordPlanRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetKeywordPlanRequest} GetKeywordPlanRequest
                         */
                        GetKeywordPlanRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetKeywordPlanRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetKeywordPlanRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetKeywordPlanRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetKeywordPlanRequest} message GetKeywordPlanRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetKeywordPlanRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetKeywordPlanRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetKeywordPlanRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetKeywordPlanRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetKeywordPlanRequest;
                    })();

                    services.MutateKeywordPlansRequest = (function() {

                        /**
                         * Properties of a MutateKeywordPlansRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateKeywordPlansRequest
                         * @property {string|null} [customerId] MutateKeywordPlansRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IKeywordPlanOperation>|null} [operations] MutateKeywordPlansRequest operations
                         * @property {boolean|null} [partialFailure] MutateKeywordPlansRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateKeywordPlansRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateKeywordPlansRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateKeywordPlansRequest.
                         * @implements IMutateKeywordPlansRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlansRequest=} [properties] Properties to set
                         */
                        function MutateKeywordPlansRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateKeywordPlansRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansRequest
                         * @instance
                         */
                        MutateKeywordPlansRequest.prototype.customerId = "";

                        /**
                         * MutateKeywordPlansRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IKeywordPlanOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansRequest
                         * @instance
                         */
                        MutateKeywordPlansRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateKeywordPlansRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansRequest
                         * @instance
                         */
                        MutateKeywordPlansRequest.prototype.partialFailure = false;

                        /**
                         * MutateKeywordPlansRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansRequest
                         * @instance
                         */
                        MutateKeywordPlansRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateKeywordPlansRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlansRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlansRequest} MutateKeywordPlansRequest instance
                         */
                        MutateKeywordPlansRequest.create = function create(properties) {
                            return new MutateKeywordPlansRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateKeywordPlansRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlansRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlansRequest} message MutateKeywordPlansRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlansRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.KeywordPlanOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateKeywordPlansRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlansRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlansRequest} message MutateKeywordPlansRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlansRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateKeywordPlansRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlansRequest} MutateKeywordPlansRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlansRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateKeywordPlansRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.KeywordPlanOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateKeywordPlansRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlansRequest} MutateKeywordPlansRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlansRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateKeywordPlansRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateKeywordPlansRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.KeywordPlanOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateKeywordPlansRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlansRequest} MutateKeywordPlansRequest
                         */
                        MutateKeywordPlansRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateKeywordPlansRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateKeywordPlansRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlansRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlansRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.KeywordPlanOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateKeywordPlansRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlansRequest} message MutateKeywordPlansRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateKeywordPlansRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.KeywordPlanOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateKeywordPlansRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateKeywordPlansRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateKeywordPlansRequest;
                    })();

                    services.KeywordPlanOperation = (function() {

                        /**
                         * Properties of a KeywordPlanOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IKeywordPlanOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] KeywordPlanOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IKeywordPlan|null} [create] KeywordPlanOperation create
                         * @property {google.ads.googleads.v1.resources.IKeywordPlan|null} [update] KeywordPlanOperation update
                         * @property {string|null} [remove] KeywordPlanOperation remove
                         */

                        /**
                         * Constructs a new KeywordPlanOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a KeywordPlanOperation.
                         * @implements IKeywordPlanOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IKeywordPlanOperation=} [properties] Properties to set
                         */
                        function KeywordPlanOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordPlanOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.KeywordPlanOperation
                         * @instance
                         */
                        KeywordPlanOperation.prototype.updateMask = null;

                        /**
                         * KeywordPlanOperation create.
                         * @member {google.ads.googleads.v1.resources.IKeywordPlan|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanOperation
                         * @instance
                         */
                        KeywordPlanOperation.prototype.create = null;

                        /**
                         * KeywordPlanOperation update.
                         * @member {google.ads.googleads.v1.resources.IKeywordPlan|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.KeywordPlanOperation
                         * @instance
                         */
                        KeywordPlanOperation.prototype.update = null;

                        /**
                         * KeywordPlanOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.KeywordPlanOperation
                         * @instance
                         */
                        KeywordPlanOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * KeywordPlanOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.KeywordPlanOperation
                         * @instance
                         */
                        Object.defineProperty(KeywordPlanOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new KeywordPlanOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.KeywordPlanOperation} KeywordPlanOperation instance
                         */
                        KeywordPlanOperation.create = function create(properties) {
                            return new KeywordPlanOperation(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanOperation message. Does not implicitly {@link google.ads.googleads.v1.services.KeywordPlanOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.KeywordPlanOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanOperation} message KeywordPlanOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.KeywordPlan.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.KeywordPlan.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.KeywordPlanOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordPlanOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanOperation} message KeywordPlanOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.KeywordPlanOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.KeywordPlanOperation} KeywordPlanOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.KeywordPlanOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.KeywordPlan.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.KeywordPlan.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordPlanOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.KeywordPlanOperation} KeywordPlanOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.KeywordPlanOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.KeywordPlan.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.KeywordPlan.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.KeywordPlanOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.KeywordPlanOperation} KeywordPlanOperation
                         */
                        KeywordPlanOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.KeywordPlanOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.KeywordPlanOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.KeywordPlan.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.KeywordPlan.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordPlanOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.KeywordPlanOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.KeywordPlanOperation} message KeywordPlanOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.KeywordPlan.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.KeywordPlan.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this KeywordPlanOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.KeywordPlanOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordPlanOperation;
                    })();

                    services.MutateKeywordPlansResponse = (function() {

                        /**
                         * Properties of a MutateKeywordPlansResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateKeywordPlansResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateKeywordPlansResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateKeywordPlansResult>|null} [results] MutateKeywordPlansResponse results
                         */

                        /**
                         * Constructs a new MutateKeywordPlansResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateKeywordPlansResponse.
                         * @implements IMutateKeywordPlansResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlansResponse=} [properties] Properties to set
                         */
                        function MutateKeywordPlansResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateKeywordPlansResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResponse
                         * @instance
                         */
                        MutateKeywordPlansResponse.prototype.partialFailureError = null;

                        /**
                         * MutateKeywordPlansResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateKeywordPlansResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResponse
                         * @instance
                         */
                        MutateKeywordPlansResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateKeywordPlansResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlansResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlansResponse} MutateKeywordPlansResponse instance
                         */
                        MutateKeywordPlansResponse.create = function create(properties) {
                            return new MutateKeywordPlansResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateKeywordPlansResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlansResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlansResponse} message MutateKeywordPlansResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlansResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateKeywordPlansResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateKeywordPlansResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlansResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlansResponse} message MutateKeywordPlansResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlansResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateKeywordPlansResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlansResponse} MutateKeywordPlansResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlansResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateKeywordPlansResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateKeywordPlansResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateKeywordPlansResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlansResponse} MutateKeywordPlansResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlansResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateKeywordPlansResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateKeywordPlansResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateKeywordPlansResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateKeywordPlansResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlansResponse} MutateKeywordPlansResponse
                         */
                        MutateKeywordPlansResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateKeywordPlansResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateKeywordPlansResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlansResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlansResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateKeywordPlansResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateKeywordPlansResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateKeywordPlansResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlansResponse} message MutateKeywordPlansResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateKeywordPlansResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateKeywordPlansResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateKeywordPlansResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateKeywordPlansResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateKeywordPlansResponse;
                    })();

                    services.MutateKeywordPlansResult = (function() {

                        /**
                         * Properties of a MutateKeywordPlansResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateKeywordPlansResult
                         * @property {string|null} [resourceName] MutateKeywordPlansResult resourceName
                         */

                        /**
                         * Constructs a new MutateKeywordPlansResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateKeywordPlansResult.
                         * @implements IMutateKeywordPlansResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlansResult=} [properties] Properties to set
                         */
                        function MutateKeywordPlansResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateKeywordPlansResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResult
                         * @instance
                         */
                        MutateKeywordPlansResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateKeywordPlansResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlansResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlansResult} MutateKeywordPlansResult instance
                         */
                        MutateKeywordPlansResult.create = function create(properties) {
                            return new MutateKeywordPlansResult(properties);
                        };

                        /**
                         * Encodes the specified MutateKeywordPlansResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlansResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlansResult} message MutateKeywordPlansResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlansResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateKeywordPlansResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateKeywordPlansResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateKeywordPlansResult} message MutateKeywordPlansResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateKeywordPlansResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateKeywordPlansResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlansResult} MutateKeywordPlansResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlansResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateKeywordPlansResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateKeywordPlansResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlansResult} MutateKeywordPlansResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateKeywordPlansResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateKeywordPlansResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateKeywordPlansResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateKeywordPlansResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateKeywordPlansResult} MutateKeywordPlansResult
                         */
                        MutateKeywordPlansResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateKeywordPlansResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateKeywordPlansResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateKeywordPlansResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateKeywordPlansResult} message MutateKeywordPlansResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateKeywordPlansResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateKeywordPlansResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateKeywordPlansResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateKeywordPlansResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateKeywordPlansResult;
                    })();

                    services.GenerateForecastMetricsRequest = (function() {

                        /**
                         * Properties of a GenerateForecastMetricsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGenerateForecastMetricsRequest
                         * @property {string|null} [keywordPlan] GenerateForecastMetricsRequest keywordPlan
                         */

                        /**
                         * Constructs a new GenerateForecastMetricsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GenerateForecastMetricsRequest.
                         * @implements IGenerateForecastMetricsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGenerateForecastMetricsRequest=} [properties] Properties to set
                         */
                        function GenerateForecastMetricsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GenerateForecastMetricsRequest keywordPlan.
                         * @member {string} keywordPlan
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsRequest
                         * @instance
                         */
                        GenerateForecastMetricsRequest.prototype.keywordPlan = "";

                        /**
                         * Creates a new GenerateForecastMetricsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateForecastMetricsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GenerateForecastMetricsRequest} GenerateForecastMetricsRequest instance
                         */
                        GenerateForecastMetricsRequest.create = function create(properties) {
                            return new GenerateForecastMetricsRequest(properties);
                        };

                        /**
                         * Encodes the specified GenerateForecastMetricsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GenerateForecastMetricsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateForecastMetricsRequest} message GenerateForecastMetricsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenerateForecastMetricsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.keywordPlan != null && message.hasOwnProperty("keywordPlan"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.keywordPlan);
                            return writer;
                        };

                        /**
                         * Encodes the specified GenerateForecastMetricsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GenerateForecastMetricsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateForecastMetricsRequest} message GenerateForecastMetricsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenerateForecastMetricsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GenerateForecastMetricsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GenerateForecastMetricsRequest} GenerateForecastMetricsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenerateForecastMetricsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GenerateForecastMetricsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.keywordPlan = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GenerateForecastMetricsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GenerateForecastMetricsRequest} GenerateForecastMetricsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenerateForecastMetricsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GenerateForecastMetricsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GenerateForecastMetricsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.keywordPlan != null && message.hasOwnProperty("keywordPlan"))
                                if (!$util.isString(message.keywordPlan))
                                    return "keywordPlan: string expected";
                            return null;
                        };

                        /**
                         * Creates a GenerateForecastMetricsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GenerateForecastMetricsRequest} GenerateForecastMetricsRequest
                         */
                        GenerateForecastMetricsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GenerateForecastMetricsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GenerateForecastMetricsRequest();
                            if (object.keywordPlan != null)
                                message.keywordPlan = String(object.keywordPlan);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GenerateForecastMetricsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GenerateForecastMetricsRequest} message GenerateForecastMetricsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GenerateForecastMetricsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.keywordPlan = "";
                            if (message.keywordPlan != null && message.hasOwnProperty("keywordPlan"))
                                object.keywordPlan = message.keywordPlan;
                            return object;
                        };

                        /**
                         * Converts this GenerateForecastMetricsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GenerateForecastMetricsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GenerateForecastMetricsRequest;
                    })();

                    services.GenerateForecastMetricsResponse = (function() {

                        /**
                         * Properties of a GenerateForecastMetricsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGenerateForecastMetricsResponse
                         * @property {Array.<google.ads.googleads.v1.services.IKeywordPlanCampaignForecast>|null} [campaignForecasts] GenerateForecastMetricsResponse campaignForecasts
                         * @property {Array.<google.ads.googleads.v1.services.IKeywordPlanAdGroupForecast>|null} [adGroupForecasts] GenerateForecastMetricsResponse adGroupForecasts
                         * @property {Array.<google.ads.googleads.v1.services.IKeywordPlanKeywordForecast>|null} [keywordForecasts] GenerateForecastMetricsResponse keywordForecasts
                         */

                        /**
                         * Constructs a new GenerateForecastMetricsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GenerateForecastMetricsResponse.
                         * @implements IGenerateForecastMetricsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGenerateForecastMetricsResponse=} [properties] Properties to set
                         */
                        function GenerateForecastMetricsResponse(properties) {
                            this.campaignForecasts = [];
                            this.adGroupForecasts = [];
                            this.keywordForecasts = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GenerateForecastMetricsResponse campaignForecasts.
                         * @member {Array.<google.ads.googleads.v1.services.IKeywordPlanCampaignForecast>} campaignForecasts
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsResponse
                         * @instance
                         */
                        GenerateForecastMetricsResponse.prototype.campaignForecasts = $util.emptyArray;

                        /**
                         * GenerateForecastMetricsResponse adGroupForecasts.
                         * @member {Array.<google.ads.googleads.v1.services.IKeywordPlanAdGroupForecast>} adGroupForecasts
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsResponse
                         * @instance
                         */
                        GenerateForecastMetricsResponse.prototype.adGroupForecasts = $util.emptyArray;

                        /**
                         * GenerateForecastMetricsResponse keywordForecasts.
                         * @member {Array.<google.ads.googleads.v1.services.IKeywordPlanKeywordForecast>} keywordForecasts
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsResponse
                         * @instance
                         */
                        GenerateForecastMetricsResponse.prototype.keywordForecasts = $util.emptyArray;

                        /**
                         * Creates a new GenerateForecastMetricsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateForecastMetricsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GenerateForecastMetricsResponse} GenerateForecastMetricsResponse instance
                         */
                        GenerateForecastMetricsResponse.create = function create(properties) {
                            return new GenerateForecastMetricsResponse(properties);
                        };

                        /**
                         * Encodes the specified GenerateForecastMetricsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.GenerateForecastMetricsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateForecastMetricsResponse} message GenerateForecastMetricsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenerateForecastMetricsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.campaignForecasts != null && message.campaignForecasts.length)
                                for (var i = 0; i < message.campaignForecasts.length; ++i)
                                    $root.google.ads.googleads.v1.services.KeywordPlanCampaignForecast.encode(message.campaignForecasts[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.adGroupForecasts != null && message.adGroupForecasts.length)
                                for (var i = 0; i < message.adGroupForecasts.length; ++i)
                                    $root.google.ads.googleads.v1.services.KeywordPlanAdGroupForecast.encode(message.adGroupForecasts[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.keywordForecasts != null && message.keywordForecasts.length)
                                for (var i = 0; i < message.keywordForecasts.length; ++i)
                                    $root.google.ads.googleads.v1.services.KeywordPlanKeywordForecast.encode(message.keywordForecasts[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified GenerateForecastMetricsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GenerateForecastMetricsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateForecastMetricsResponse} message GenerateForecastMetricsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenerateForecastMetricsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GenerateForecastMetricsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GenerateForecastMetricsResponse} GenerateForecastMetricsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenerateForecastMetricsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GenerateForecastMetricsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.campaignForecasts && message.campaignForecasts.length))
                                        message.campaignForecasts = [];
                                    message.campaignForecasts.push($root.google.ads.googleads.v1.services.KeywordPlanCampaignForecast.decode(reader, reader.uint32()));
                                    break;
                                case 2:
                                    if (!(message.adGroupForecasts && message.adGroupForecasts.length))
                                        message.adGroupForecasts = [];
                                    message.adGroupForecasts.push($root.google.ads.googleads.v1.services.KeywordPlanAdGroupForecast.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    if (!(message.keywordForecasts && message.keywordForecasts.length))
                                        message.keywordForecasts = [];
                                    message.keywordForecasts.push($root.google.ads.googleads.v1.services.KeywordPlanKeywordForecast.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GenerateForecastMetricsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GenerateForecastMetricsResponse} GenerateForecastMetricsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenerateForecastMetricsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GenerateForecastMetricsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GenerateForecastMetricsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.campaignForecasts != null && message.hasOwnProperty("campaignForecasts")) {
                                if (!Array.isArray(message.campaignForecasts))
                                    return "campaignForecasts: array expected";
                                for (var i = 0; i < message.campaignForecasts.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.KeywordPlanCampaignForecast.verify(message.campaignForecasts[i]);
                                    if (error)
                                        return "campaignForecasts." + error;
                                }
                            }
                            if (message.adGroupForecasts != null && message.hasOwnProperty("adGroupForecasts")) {
                                if (!Array.isArray(message.adGroupForecasts))
                                    return "adGroupForecasts: array expected";
                                for (var i = 0; i < message.adGroupForecasts.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.KeywordPlanAdGroupForecast.verify(message.adGroupForecasts[i]);
                                    if (error)
                                        return "adGroupForecasts." + error;
                                }
                            }
                            if (message.keywordForecasts != null && message.hasOwnProperty("keywordForecasts")) {
                                if (!Array.isArray(message.keywordForecasts))
                                    return "keywordForecasts: array expected";
                                for (var i = 0; i < message.keywordForecasts.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.KeywordPlanKeywordForecast.verify(message.keywordForecasts[i]);
                                    if (error)
                                        return "keywordForecasts." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a GenerateForecastMetricsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GenerateForecastMetricsResponse} GenerateForecastMetricsResponse
                         */
                        GenerateForecastMetricsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GenerateForecastMetricsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GenerateForecastMetricsResponse();
                            if (object.campaignForecasts) {
                                if (!Array.isArray(object.campaignForecasts))
                                    throw TypeError(".google.ads.googleads.v1.services.GenerateForecastMetricsResponse.campaignForecasts: array expected");
                                message.campaignForecasts = [];
                                for (var i = 0; i < object.campaignForecasts.length; ++i) {
                                    if (typeof object.campaignForecasts[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.GenerateForecastMetricsResponse.campaignForecasts: object expected");
                                    message.campaignForecasts[i] = $root.google.ads.googleads.v1.services.KeywordPlanCampaignForecast.fromObject(object.campaignForecasts[i]);
                                }
                            }
                            if (object.adGroupForecasts) {
                                if (!Array.isArray(object.adGroupForecasts))
                                    throw TypeError(".google.ads.googleads.v1.services.GenerateForecastMetricsResponse.adGroupForecasts: array expected");
                                message.adGroupForecasts = [];
                                for (var i = 0; i < object.adGroupForecasts.length; ++i) {
                                    if (typeof object.adGroupForecasts[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.GenerateForecastMetricsResponse.adGroupForecasts: object expected");
                                    message.adGroupForecasts[i] = $root.google.ads.googleads.v1.services.KeywordPlanAdGroupForecast.fromObject(object.adGroupForecasts[i]);
                                }
                            }
                            if (object.keywordForecasts) {
                                if (!Array.isArray(object.keywordForecasts))
                                    throw TypeError(".google.ads.googleads.v1.services.GenerateForecastMetricsResponse.keywordForecasts: array expected");
                                message.keywordForecasts = [];
                                for (var i = 0; i < object.keywordForecasts.length; ++i) {
                                    if (typeof object.keywordForecasts[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.GenerateForecastMetricsResponse.keywordForecasts: object expected");
                                    message.keywordForecasts[i] = $root.google.ads.googleads.v1.services.KeywordPlanKeywordForecast.fromObject(object.keywordForecasts[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a GenerateForecastMetricsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.GenerateForecastMetricsResponse} message GenerateForecastMetricsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GenerateForecastMetricsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.campaignForecasts = [];
                                object.adGroupForecasts = [];
                                object.keywordForecasts = [];
                            }
                            if (message.campaignForecasts && message.campaignForecasts.length) {
                                object.campaignForecasts = [];
                                for (var j = 0; j < message.campaignForecasts.length; ++j)
                                    object.campaignForecasts[j] = $root.google.ads.googleads.v1.services.KeywordPlanCampaignForecast.toObject(message.campaignForecasts[j], options);
                            }
                            if (message.adGroupForecasts && message.adGroupForecasts.length) {
                                object.adGroupForecasts = [];
                                for (var j = 0; j < message.adGroupForecasts.length; ++j)
                                    object.adGroupForecasts[j] = $root.google.ads.googleads.v1.services.KeywordPlanAdGroupForecast.toObject(message.adGroupForecasts[j], options);
                            }
                            if (message.keywordForecasts && message.keywordForecasts.length) {
                                object.keywordForecasts = [];
                                for (var j = 0; j < message.keywordForecasts.length; ++j)
                                    object.keywordForecasts[j] = $root.google.ads.googleads.v1.services.KeywordPlanKeywordForecast.toObject(message.keywordForecasts[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this GenerateForecastMetricsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GenerateForecastMetricsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GenerateForecastMetricsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GenerateForecastMetricsResponse;
                    })();

                    services.KeywordPlanCampaignForecast = (function() {

                        /**
                         * Properties of a KeywordPlanCampaignForecast.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IKeywordPlanCampaignForecast
                         * @property {google.protobuf.IStringValue|null} [keywordPlanCampaign] KeywordPlanCampaignForecast keywordPlanCampaign
                         * @property {google.ads.googleads.v1.services.IForecastMetrics|null} [campaignForecast] KeywordPlanCampaignForecast campaignForecast
                         */

                        /**
                         * Constructs a new KeywordPlanCampaignForecast.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a KeywordPlanCampaignForecast.
                         * @implements IKeywordPlanCampaignForecast
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IKeywordPlanCampaignForecast=} [properties] Properties to set
                         */
                        function KeywordPlanCampaignForecast(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordPlanCampaignForecast keywordPlanCampaign.
                         * @member {google.protobuf.IStringValue|null|undefined} keywordPlanCampaign
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignForecast
                         * @instance
                         */
                        KeywordPlanCampaignForecast.prototype.keywordPlanCampaign = null;

                        /**
                         * KeywordPlanCampaignForecast campaignForecast.
                         * @member {google.ads.googleads.v1.services.IForecastMetrics|null|undefined} campaignForecast
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignForecast
                         * @instance
                         */
                        KeywordPlanCampaignForecast.prototype.campaignForecast = null;

                        /**
                         * Creates a new KeywordPlanCampaignForecast instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignForecast
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanCampaignForecast=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.KeywordPlanCampaignForecast} KeywordPlanCampaignForecast instance
                         */
                        KeywordPlanCampaignForecast.create = function create(properties) {
                            return new KeywordPlanCampaignForecast(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanCampaignForecast message. Does not implicitly {@link google.ads.googleads.v1.services.KeywordPlanCampaignForecast.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignForecast
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanCampaignForecast} message KeywordPlanCampaignForecast message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanCampaignForecast.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.keywordPlanCampaign != null && message.hasOwnProperty("keywordPlanCampaign"))
                                $root.google.protobuf.StringValue.encode(message.keywordPlanCampaign, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.campaignForecast != null && message.hasOwnProperty("campaignForecast"))
                                $root.google.ads.googleads.v1.services.ForecastMetrics.encode(message.campaignForecast, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanCampaignForecast message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.KeywordPlanCampaignForecast.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignForecast
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanCampaignForecast} message KeywordPlanCampaignForecast message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanCampaignForecast.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanCampaignForecast message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignForecast
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.KeywordPlanCampaignForecast} KeywordPlanCampaignForecast
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanCampaignForecast.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.KeywordPlanCampaignForecast();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.keywordPlanCampaign = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.campaignForecast = $root.google.ads.googleads.v1.services.ForecastMetrics.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanCampaignForecast message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignForecast
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.KeywordPlanCampaignForecast} KeywordPlanCampaignForecast
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanCampaignForecast.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanCampaignForecast message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignForecast
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanCampaignForecast.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.keywordPlanCampaign != null && message.hasOwnProperty("keywordPlanCampaign")) {
                                var error = $root.google.protobuf.StringValue.verify(message.keywordPlanCampaign);
                                if (error)
                                    return "keywordPlanCampaign." + error;
                            }
                            if (message.campaignForecast != null && message.hasOwnProperty("campaignForecast")) {
                                var error = $root.google.ads.googleads.v1.services.ForecastMetrics.verify(message.campaignForecast);
                                if (error)
                                    return "campaignForecast." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanCampaignForecast message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignForecast
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.KeywordPlanCampaignForecast} KeywordPlanCampaignForecast
                         */
                        KeywordPlanCampaignForecast.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.KeywordPlanCampaignForecast)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.KeywordPlanCampaignForecast();
                            if (object.keywordPlanCampaign != null) {
                                if (typeof object.keywordPlanCampaign !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanCampaignForecast.keywordPlanCampaign: object expected");
                                message.keywordPlanCampaign = $root.google.protobuf.StringValue.fromObject(object.keywordPlanCampaign);
                            }
                            if (object.campaignForecast != null) {
                                if (typeof object.campaignForecast !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanCampaignForecast.campaignForecast: object expected");
                                message.campaignForecast = $root.google.ads.googleads.v1.services.ForecastMetrics.fromObject(object.campaignForecast);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordPlanCampaignForecast message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignForecast
                         * @static
                         * @param {google.ads.googleads.v1.services.KeywordPlanCampaignForecast} message KeywordPlanCampaignForecast
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanCampaignForecast.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.keywordPlanCampaign = null;
                                object.campaignForecast = null;
                            }
                            if (message.keywordPlanCampaign != null && message.hasOwnProperty("keywordPlanCampaign"))
                                object.keywordPlanCampaign = $root.google.protobuf.StringValue.toObject(message.keywordPlanCampaign, options);
                            if (message.campaignForecast != null && message.hasOwnProperty("campaignForecast"))
                                object.campaignForecast = $root.google.ads.googleads.v1.services.ForecastMetrics.toObject(message.campaignForecast, options);
                            return object;
                        };

                        /**
                         * Converts this KeywordPlanCampaignForecast to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.KeywordPlanCampaignForecast
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanCampaignForecast.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordPlanCampaignForecast;
                    })();

                    services.KeywordPlanAdGroupForecast = (function() {

                        /**
                         * Properties of a KeywordPlanAdGroupForecast.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IKeywordPlanAdGroupForecast
                         * @property {google.protobuf.IStringValue|null} [keywordPlanAdGroup] KeywordPlanAdGroupForecast keywordPlanAdGroup
                         * @property {google.ads.googleads.v1.services.IForecastMetrics|null} [adGroupForecast] KeywordPlanAdGroupForecast adGroupForecast
                         */

                        /**
                         * Constructs a new KeywordPlanAdGroupForecast.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a KeywordPlanAdGroupForecast.
                         * @implements IKeywordPlanAdGroupForecast
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IKeywordPlanAdGroupForecast=} [properties] Properties to set
                         */
                        function KeywordPlanAdGroupForecast(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordPlanAdGroupForecast keywordPlanAdGroup.
                         * @member {google.protobuf.IStringValue|null|undefined} keywordPlanAdGroup
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupForecast
                         * @instance
                         */
                        KeywordPlanAdGroupForecast.prototype.keywordPlanAdGroup = null;

                        /**
                         * KeywordPlanAdGroupForecast adGroupForecast.
                         * @member {google.ads.googleads.v1.services.IForecastMetrics|null|undefined} adGroupForecast
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupForecast
                         * @instance
                         */
                        KeywordPlanAdGroupForecast.prototype.adGroupForecast = null;

                        /**
                         * Creates a new KeywordPlanAdGroupForecast instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupForecast
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanAdGroupForecast=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.KeywordPlanAdGroupForecast} KeywordPlanAdGroupForecast instance
                         */
                        KeywordPlanAdGroupForecast.create = function create(properties) {
                            return new KeywordPlanAdGroupForecast(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanAdGroupForecast message. Does not implicitly {@link google.ads.googleads.v1.services.KeywordPlanAdGroupForecast.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupForecast
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanAdGroupForecast} message KeywordPlanAdGroupForecast message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanAdGroupForecast.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.keywordPlanAdGroup != null && message.hasOwnProperty("keywordPlanAdGroup"))
                                $root.google.protobuf.StringValue.encode(message.keywordPlanAdGroup, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.adGroupForecast != null && message.hasOwnProperty("adGroupForecast"))
                                $root.google.ads.googleads.v1.services.ForecastMetrics.encode(message.adGroupForecast, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanAdGroupForecast message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.KeywordPlanAdGroupForecast.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupForecast
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanAdGroupForecast} message KeywordPlanAdGroupForecast message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanAdGroupForecast.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanAdGroupForecast message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupForecast
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.KeywordPlanAdGroupForecast} KeywordPlanAdGroupForecast
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanAdGroupForecast.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.KeywordPlanAdGroupForecast();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.keywordPlanAdGroup = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.adGroupForecast = $root.google.ads.googleads.v1.services.ForecastMetrics.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanAdGroupForecast message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupForecast
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.KeywordPlanAdGroupForecast} KeywordPlanAdGroupForecast
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanAdGroupForecast.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanAdGroupForecast message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupForecast
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanAdGroupForecast.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.keywordPlanAdGroup != null && message.hasOwnProperty("keywordPlanAdGroup")) {
                                var error = $root.google.protobuf.StringValue.verify(message.keywordPlanAdGroup);
                                if (error)
                                    return "keywordPlanAdGroup." + error;
                            }
                            if (message.adGroupForecast != null && message.hasOwnProperty("adGroupForecast")) {
                                var error = $root.google.ads.googleads.v1.services.ForecastMetrics.verify(message.adGroupForecast);
                                if (error)
                                    return "adGroupForecast." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanAdGroupForecast message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupForecast
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.KeywordPlanAdGroupForecast} KeywordPlanAdGroupForecast
                         */
                        KeywordPlanAdGroupForecast.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.KeywordPlanAdGroupForecast)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.KeywordPlanAdGroupForecast();
                            if (object.keywordPlanAdGroup != null) {
                                if (typeof object.keywordPlanAdGroup !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanAdGroupForecast.keywordPlanAdGroup: object expected");
                                message.keywordPlanAdGroup = $root.google.protobuf.StringValue.fromObject(object.keywordPlanAdGroup);
                            }
                            if (object.adGroupForecast != null) {
                                if (typeof object.adGroupForecast !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanAdGroupForecast.adGroupForecast: object expected");
                                message.adGroupForecast = $root.google.ads.googleads.v1.services.ForecastMetrics.fromObject(object.adGroupForecast);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordPlanAdGroupForecast message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupForecast
                         * @static
                         * @param {google.ads.googleads.v1.services.KeywordPlanAdGroupForecast} message KeywordPlanAdGroupForecast
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanAdGroupForecast.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.keywordPlanAdGroup = null;
                                object.adGroupForecast = null;
                            }
                            if (message.keywordPlanAdGroup != null && message.hasOwnProperty("keywordPlanAdGroup"))
                                object.keywordPlanAdGroup = $root.google.protobuf.StringValue.toObject(message.keywordPlanAdGroup, options);
                            if (message.adGroupForecast != null && message.hasOwnProperty("adGroupForecast"))
                                object.adGroupForecast = $root.google.ads.googleads.v1.services.ForecastMetrics.toObject(message.adGroupForecast, options);
                            return object;
                        };

                        /**
                         * Converts this KeywordPlanAdGroupForecast to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.KeywordPlanAdGroupForecast
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanAdGroupForecast.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordPlanAdGroupForecast;
                    })();

                    services.KeywordPlanKeywordForecast = (function() {

                        /**
                         * Properties of a KeywordPlanKeywordForecast.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IKeywordPlanKeywordForecast
                         * @property {google.protobuf.IStringValue|null} [keywordPlanAdGroupKeyword] KeywordPlanKeywordForecast keywordPlanAdGroupKeyword
                         * @property {google.ads.googleads.v1.services.IForecastMetrics|null} [keywordForecast] KeywordPlanKeywordForecast keywordForecast
                         */

                        /**
                         * Constructs a new KeywordPlanKeywordForecast.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a KeywordPlanKeywordForecast.
                         * @implements IKeywordPlanKeywordForecast
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IKeywordPlanKeywordForecast=} [properties] Properties to set
                         */
                        function KeywordPlanKeywordForecast(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordPlanKeywordForecast keywordPlanAdGroupKeyword.
                         * @member {google.protobuf.IStringValue|null|undefined} keywordPlanAdGroupKeyword
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordForecast
                         * @instance
                         */
                        KeywordPlanKeywordForecast.prototype.keywordPlanAdGroupKeyword = null;

                        /**
                         * KeywordPlanKeywordForecast keywordForecast.
                         * @member {google.ads.googleads.v1.services.IForecastMetrics|null|undefined} keywordForecast
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordForecast
                         * @instance
                         */
                        KeywordPlanKeywordForecast.prototype.keywordForecast = null;

                        /**
                         * Creates a new KeywordPlanKeywordForecast instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordForecast
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanKeywordForecast=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.KeywordPlanKeywordForecast} KeywordPlanKeywordForecast instance
                         */
                        KeywordPlanKeywordForecast.create = function create(properties) {
                            return new KeywordPlanKeywordForecast(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanKeywordForecast message. Does not implicitly {@link google.ads.googleads.v1.services.KeywordPlanKeywordForecast.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordForecast
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanKeywordForecast} message KeywordPlanKeywordForecast message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanKeywordForecast.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.keywordPlanAdGroupKeyword != null && message.hasOwnProperty("keywordPlanAdGroupKeyword"))
                                $root.google.protobuf.StringValue.encode(message.keywordPlanAdGroupKeyword, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.keywordForecast != null && message.hasOwnProperty("keywordForecast"))
                                $root.google.ads.googleads.v1.services.ForecastMetrics.encode(message.keywordForecast, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanKeywordForecast message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.KeywordPlanKeywordForecast.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordForecast
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanKeywordForecast} message KeywordPlanKeywordForecast message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanKeywordForecast.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanKeywordForecast message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordForecast
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.KeywordPlanKeywordForecast} KeywordPlanKeywordForecast
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanKeywordForecast.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.KeywordPlanKeywordForecast();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.keywordPlanAdGroupKeyword = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.keywordForecast = $root.google.ads.googleads.v1.services.ForecastMetrics.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanKeywordForecast message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordForecast
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.KeywordPlanKeywordForecast} KeywordPlanKeywordForecast
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanKeywordForecast.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanKeywordForecast message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordForecast
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanKeywordForecast.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.keywordPlanAdGroupKeyword != null && message.hasOwnProperty("keywordPlanAdGroupKeyword")) {
                                var error = $root.google.protobuf.StringValue.verify(message.keywordPlanAdGroupKeyword);
                                if (error)
                                    return "keywordPlanAdGroupKeyword." + error;
                            }
                            if (message.keywordForecast != null && message.hasOwnProperty("keywordForecast")) {
                                var error = $root.google.ads.googleads.v1.services.ForecastMetrics.verify(message.keywordForecast);
                                if (error)
                                    return "keywordForecast." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanKeywordForecast message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordForecast
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.KeywordPlanKeywordForecast} KeywordPlanKeywordForecast
                         */
                        KeywordPlanKeywordForecast.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.KeywordPlanKeywordForecast)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.KeywordPlanKeywordForecast();
                            if (object.keywordPlanAdGroupKeyword != null) {
                                if (typeof object.keywordPlanAdGroupKeyword !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanKeywordForecast.keywordPlanAdGroupKeyword: object expected");
                                message.keywordPlanAdGroupKeyword = $root.google.protobuf.StringValue.fromObject(object.keywordPlanAdGroupKeyword);
                            }
                            if (object.keywordForecast != null) {
                                if (typeof object.keywordForecast !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanKeywordForecast.keywordForecast: object expected");
                                message.keywordForecast = $root.google.ads.googleads.v1.services.ForecastMetrics.fromObject(object.keywordForecast);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordPlanKeywordForecast message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordForecast
                         * @static
                         * @param {google.ads.googleads.v1.services.KeywordPlanKeywordForecast} message KeywordPlanKeywordForecast
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanKeywordForecast.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.keywordPlanAdGroupKeyword = null;
                                object.keywordForecast = null;
                            }
                            if (message.keywordPlanAdGroupKeyword != null && message.hasOwnProperty("keywordPlanAdGroupKeyword"))
                                object.keywordPlanAdGroupKeyword = $root.google.protobuf.StringValue.toObject(message.keywordPlanAdGroupKeyword, options);
                            if (message.keywordForecast != null && message.hasOwnProperty("keywordForecast"))
                                object.keywordForecast = $root.google.ads.googleads.v1.services.ForecastMetrics.toObject(message.keywordForecast, options);
                            return object;
                        };

                        /**
                         * Converts this KeywordPlanKeywordForecast to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordForecast
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanKeywordForecast.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordPlanKeywordForecast;
                    })();

                    services.ForecastMetrics = (function() {

                        /**
                         * Properties of a ForecastMetrics.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IForecastMetrics
                         * @property {google.protobuf.IDoubleValue|null} [impressions] ForecastMetrics impressions
                         * @property {google.protobuf.IDoubleValue|null} [ctr] ForecastMetrics ctr
                         * @property {google.protobuf.IInt64Value|null} [averageCpc] ForecastMetrics averageCpc
                         * @property {google.protobuf.IDoubleValue|null} [clicks] ForecastMetrics clicks
                         * @property {google.protobuf.IInt64Value|null} [costMicros] ForecastMetrics costMicros
                         */

                        /**
                         * Constructs a new ForecastMetrics.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ForecastMetrics.
                         * @implements IForecastMetrics
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IForecastMetrics=} [properties] Properties to set
                         */
                        function ForecastMetrics(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ForecastMetrics impressions.
                         * @member {google.protobuf.IDoubleValue|null|undefined} impressions
                         * @memberof google.ads.googleads.v1.services.ForecastMetrics
                         * @instance
                         */
                        ForecastMetrics.prototype.impressions = null;

                        /**
                         * ForecastMetrics ctr.
                         * @member {google.protobuf.IDoubleValue|null|undefined} ctr
                         * @memberof google.ads.googleads.v1.services.ForecastMetrics
                         * @instance
                         */
                        ForecastMetrics.prototype.ctr = null;

                        /**
                         * ForecastMetrics averageCpc.
                         * @member {google.protobuf.IInt64Value|null|undefined} averageCpc
                         * @memberof google.ads.googleads.v1.services.ForecastMetrics
                         * @instance
                         */
                        ForecastMetrics.prototype.averageCpc = null;

                        /**
                         * ForecastMetrics clicks.
                         * @member {google.protobuf.IDoubleValue|null|undefined} clicks
                         * @memberof google.ads.googleads.v1.services.ForecastMetrics
                         * @instance
                         */
                        ForecastMetrics.prototype.clicks = null;

                        /**
                         * ForecastMetrics costMicros.
                         * @member {google.protobuf.IInt64Value|null|undefined} costMicros
                         * @memberof google.ads.googleads.v1.services.ForecastMetrics
                         * @instance
                         */
                        ForecastMetrics.prototype.costMicros = null;

                        /**
                         * Creates a new ForecastMetrics instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ForecastMetrics
                         * @static
                         * @param {google.ads.googleads.v1.services.IForecastMetrics=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ForecastMetrics} ForecastMetrics instance
                         */
                        ForecastMetrics.create = function create(properties) {
                            return new ForecastMetrics(properties);
                        };

                        /**
                         * Encodes the specified ForecastMetrics message. Does not implicitly {@link google.ads.googleads.v1.services.ForecastMetrics.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ForecastMetrics
                         * @static
                         * @param {google.ads.googleads.v1.services.IForecastMetrics} message ForecastMetrics message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ForecastMetrics.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.impressions != null && message.hasOwnProperty("impressions"))
                                $root.google.protobuf.DoubleValue.encode(message.impressions, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.ctr != null && message.hasOwnProperty("ctr"))
                                $root.google.protobuf.DoubleValue.encode(message.ctr, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.averageCpc != null && message.hasOwnProperty("averageCpc"))
                                $root.google.protobuf.Int64Value.encode(message.averageCpc, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.clicks != null && message.hasOwnProperty("clicks"))
                                $root.google.protobuf.DoubleValue.encode(message.clicks, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.costMicros != null && message.hasOwnProperty("costMicros"))
                                $root.google.protobuf.Int64Value.encode(message.costMicros, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ForecastMetrics message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ForecastMetrics.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ForecastMetrics
                         * @static
                         * @param {google.ads.googleads.v1.services.IForecastMetrics} message ForecastMetrics message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ForecastMetrics.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ForecastMetrics message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ForecastMetrics
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ForecastMetrics} ForecastMetrics
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ForecastMetrics.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ForecastMetrics();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.impressions = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.ctr = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.averageCpc = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.clicks = $root.google.protobuf.DoubleValue.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.costMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ForecastMetrics message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ForecastMetrics
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ForecastMetrics} ForecastMetrics
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ForecastMetrics.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ForecastMetrics message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ForecastMetrics
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ForecastMetrics.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.impressions != null && message.hasOwnProperty("impressions")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.impressions);
                                if (error)
                                    return "impressions." + error;
                            }
                            if (message.ctr != null && message.hasOwnProperty("ctr")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.ctr);
                                if (error)
                                    return "ctr." + error;
                            }
                            if (message.averageCpc != null && message.hasOwnProperty("averageCpc")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.averageCpc);
                                if (error)
                                    return "averageCpc." + error;
                            }
                            if (message.clicks != null && message.hasOwnProperty("clicks")) {
                                var error = $root.google.protobuf.DoubleValue.verify(message.clicks);
                                if (error)
                                    return "clicks." + error;
                            }
                            if (message.costMicros != null && message.hasOwnProperty("costMicros")) {
                                var error = $root.google.protobuf.Int64Value.verify(message.costMicros);
                                if (error)
                                    return "costMicros." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a ForecastMetrics message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ForecastMetrics
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ForecastMetrics} ForecastMetrics
                         */
                        ForecastMetrics.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ForecastMetrics)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ForecastMetrics();
                            if (object.impressions != null) {
                                if (typeof object.impressions !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ForecastMetrics.impressions: object expected");
                                message.impressions = $root.google.protobuf.DoubleValue.fromObject(object.impressions);
                            }
                            if (object.ctr != null) {
                                if (typeof object.ctr !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ForecastMetrics.ctr: object expected");
                                message.ctr = $root.google.protobuf.DoubleValue.fromObject(object.ctr);
                            }
                            if (object.averageCpc != null) {
                                if (typeof object.averageCpc !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ForecastMetrics.averageCpc: object expected");
                                message.averageCpc = $root.google.protobuf.Int64Value.fromObject(object.averageCpc);
                            }
                            if (object.clicks != null) {
                                if (typeof object.clicks !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ForecastMetrics.clicks: object expected");
                                message.clicks = $root.google.protobuf.DoubleValue.fromObject(object.clicks);
                            }
                            if (object.costMicros != null) {
                                if (typeof object.costMicros !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ForecastMetrics.costMicros: object expected");
                                message.costMicros = $root.google.protobuf.Int64Value.fromObject(object.costMicros);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ForecastMetrics message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ForecastMetrics
                         * @static
                         * @param {google.ads.googleads.v1.services.ForecastMetrics} message ForecastMetrics
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ForecastMetrics.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.impressions = null;
                                object.ctr = null;
                                object.averageCpc = null;
                                object.clicks = null;
                                object.costMicros = null;
                            }
                            if (message.impressions != null && message.hasOwnProperty("impressions"))
                                object.impressions = $root.google.protobuf.DoubleValue.toObject(message.impressions, options);
                            if (message.ctr != null && message.hasOwnProperty("ctr"))
                                object.ctr = $root.google.protobuf.DoubleValue.toObject(message.ctr, options);
                            if (message.averageCpc != null && message.hasOwnProperty("averageCpc"))
                                object.averageCpc = $root.google.protobuf.Int64Value.toObject(message.averageCpc, options);
                            if (message.clicks != null && message.hasOwnProperty("clicks"))
                                object.clicks = $root.google.protobuf.DoubleValue.toObject(message.clicks, options);
                            if (message.costMicros != null && message.hasOwnProperty("costMicros"))
                                object.costMicros = $root.google.protobuf.Int64Value.toObject(message.costMicros, options);
                            return object;
                        };

                        /**
                         * Converts this ForecastMetrics to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ForecastMetrics
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ForecastMetrics.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ForecastMetrics;
                    })();

                    services.GenerateHistoricalMetricsRequest = (function() {

                        /**
                         * Properties of a GenerateHistoricalMetricsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGenerateHistoricalMetricsRequest
                         * @property {string|null} [keywordPlan] GenerateHistoricalMetricsRequest keywordPlan
                         */

                        /**
                         * Constructs a new GenerateHistoricalMetricsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GenerateHistoricalMetricsRequest.
                         * @implements IGenerateHistoricalMetricsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGenerateHistoricalMetricsRequest=} [properties] Properties to set
                         */
                        function GenerateHistoricalMetricsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GenerateHistoricalMetricsRequest keywordPlan.
                         * @member {string} keywordPlan
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest
                         * @instance
                         */
                        GenerateHistoricalMetricsRequest.prototype.keywordPlan = "";

                        /**
                         * Creates a new GenerateHistoricalMetricsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateHistoricalMetricsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest} GenerateHistoricalMetricsRequest instance
                         */
                        GenerateHistoricalMetricsRequest.create = function create(properties) {
                            return new GenerateHistoricalMetricsRequest(properties);
                        };

                        /**
                         * Encodes the specified GenerateHistoricalMetricsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateHistoricalMetricsRequest} message GenerateHistoricalMetricsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenerateHistoricalMetricsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.keywordPlan != null && message.hasOwnProperty("keywordPlan"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.keywordPlan);
                            return writer;
                        };

                        /**
                         * Encodes the specified GenerateHistoricalMetricsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateHistoricalMetricsRequest} message GenerateHistoricalMetricsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenerateHistoricalMetricsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GenerateHistoricalMetricsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest} GenerateHistoricalMetricsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenerateHistoricalMetricsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.keywordPlan = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GenerateHistoricalMetricsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest} GenerateHistoricalMetricsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenerateHistoricalMetricsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GenerateHistoricalMetricsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GenerateHistoricalMetricsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.keywordPlan != null && message.hasOwnProperty("keywordPlan"))
                                if (!$util.isString(message.keywordPlan))
                                    return "keywordPlan: string expected";
                            return null;
                        };

                        /**
                         * Creates a GenerateHistoricalMetricsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest} GenerateHistoricalMetricsRequest
                         */
                        GenerateHistoricalMetricsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest();
                            if (object.keywordPlan != null)
                                message.keywordPlan = String(object.keywordPlan);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GenerateHistoricalMetricsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest} message GenerateHistoricalMetricsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GenerateHistoricalMetricsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.keywordPlan = "";
                            if (message.keywordPlan != null && message.hasOwnProperty("keywordPlan"))
                                object.keywordPlan = message.keywordPlan;
                            return object;
                        };

                        /**
                         * Converts this GenerateHistoricalMetricsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GenerateHistoricalMetricsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GenerateHistoricalMetricsRequest;
                    })();

                    services.GenerateHistoricalMetricsResponse = (function() {

                        /**
                         * Properties of a GenerateHistoricalMetricsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGenerateHistoricalMetricsResponse
                         * @property {Array.<google.ads.googleads.v1.services.IKeywordPlanKeywordHistoricalMetrics>|null} [metrics] GenerateHistoricalMetricsResponse metrics
                         */

                        /**
                         * Constructs a new GenerateHistoricalMetricsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GenerateHistoricalMetricsResponse.
                         * @implements IGenerateHistoricalMetricsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGenerateHistoricalMetricsResponse=} [properties] Properties to set
                         */
                        function GenerateHistoricalMetricsResponse(properties) {
                            this.metrics = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GenerateHistoricalMetricsResponse metrics.
                         * @member {Array.<google.ads.googleads.v1.services.IKeywordPlanKeywordHistoricalMetrics>} metrics
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse
                         * @instance
                         */
                        GenerateHistoricalMetricsResponse.prototype.metrics = $util.emptyArray;

                        /**
                         * Creates a new GenerateHistoricalMetricsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateHistoricalMetricsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse} GenerateHistoricalMetricsResponse instance
                         */
                        GenerateHistoricalMetricsResponse.create = function create(properties) {
                            return new GenerateHistoricalMetricsResponse(properties);
                        };

                        /**
                         * Encodes the specified GenerateHistoricalMetricsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateHistoricalMetricsResponse} message GenerateHistoricalMetricsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenerateHistoricalMetricsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.metrics != null && message.metrics.length)
                                for (var i = 0; i < message.metrics.length; ++i)
                                    $root.google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics.encode(message.metrics[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified GenerateHistoricalMetricsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IGenerateHistoricalMetricsResponse} message GenerateHistoricalMetricsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GenerateHistoricalMetricsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GenerateHistoricalMetricsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse} GenerateHistoricalMetricsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenerateHistoricalMetricsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.metrics && message.metrics.length))
                                        message.metrics = [];
                                    message.metrics.push($root.google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GenerateHistoricalMetricsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse} GenerateHistoricalMetricsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GenerateHistoricalMetricsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GenerateHistoricalMetricsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GenerateHistoricalMetricsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.metrics != null && message.hasOwnProperty("metrics")) {
                                if (!Array.isArray(message.metrics))
                                    return "metrics: array expected";
                                for (var i = 0; i < message.metrics.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics.verify(message.metrics[i]);
                                    if (error)
                                        return "metrics." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a GenerateHistoricalMetricsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse} GenerateHistoricalMetricsResponse
                         */
                        GenerateHistoricalMetricsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse();
                            if (object.metrics) {
                                if (!Array.isArray(object.metrics))
                                    throw TypeError(".google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse.metrics: array expected");
                                message.metrics = [];
                                for (var i = 0; i < object.metrics.length; ++i) {
                                    if (typeof object.metrics[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse.metrics: object expected");
                                    message.metrics[i] = $root.google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics.fromObject(object.metrics[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a GenerateHistoricalMetricsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse} message GenerateHistoricalMetricsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GenerateHistoricalMetricsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.metrics = [];
                            if (message.metrics && message.metrics.length) {
                                object.metrics = [];
                                for (var j = 0; j < message.metrics.length; ++j)
                                    object.metrics[j] = $root.google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics.toObject(message.metrics[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this GenerateHistoricalMetricsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GenerateHistoricalMetricsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GenerateHistoricalMetricsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GenerateHistoricalMetricsResponse;
                    })();

                    services.KeywordPlanKeywordHistoricalMetrics = (function() {

                        /**
                         * Properties of a KeywordPlanKeywordHistoricalMetrics.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IKeywordPlanKeywordHistoricalMetrics
                         * @property {google.protobuf.IStringValue|null} [searchQuery] KeywordPlanKeywordHistoricalMetrics searchQuery
                         * @property {google.ads.googleads.v1.common.IKeywordPlanHistoricalMetrics|null} [keywordMetrics] KeywordPlanKeywordHistoricalMetrics keywordMetrics
                         */

                        /**
                         * Constructs a new KeywordPlanKeywordHistoricalMetrics.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a KeywordPlanKeywordHistoricalMetrics.
                         * @implements IKeywordPlanKeywordHistoricalMetrics
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IKeywordPlanKeywordHistoricalMetrics=} [properties] Properties to set
                         */
                        function KeywordPlanKeywordHistoricalMetrics(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * KeywordPlanKeywordHistoricalMetrics searchQuery.
                         * @member {google.protobuf.IStringValue|null|undefined} searchQuery
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics
                         * @instance
                         */
                        KeywordPlanKeywordHistoricalMetrics.prototype.searchQuery = null;

                        /**
                         * KeywordPlanKeywordHistoricalMetrics keywordMetrics.
                         * @member {google.ads.googleads.v1.common.IKeywordPlanHistoricalMetrics|null|undefined} keywordMetrics
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics
                         * @instance
                         */
                        KeywordPlanKeywordHistoricalMetrics.prototype.keywordMetrics = null;

                        /**
                         * Creates a new KeywordPlanKeywordHistoricalMetrics instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanKeywordHistoricalMetrics=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics} KeywordPlanKeywordHistoricalMetrics instance
                         */
                        KeywordPlanKeywordHistoricalMetrics.create = function create(properties) {
                            return new KeywordPlanKeywordHistoricalMetrics(properties);
                        };

                        /**
                         * Encodes the specified KeywordPlanKeywordHistoricalMetrics message. Does not implicitly {@link google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanKeywordHistoricalMetrics} message KeywordPlanKeywordHistoricalMetrics message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanKeywordHistoricalMetrics.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.searchQuery != null && message.hasOwnProperty("searchQuery"))
                                $root.google.protobuf.StringValue.encode(message.searchQuery, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.keywordMetrics != null && message.hasOwnProperty("keywordMetrics"))
                                $root.google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics.encode(message.keywordMetrics, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified KeywordPlanKeywordHistoricalMetrics message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics
                         * @static
                         * @param {google.ads.googleads.v1.services.IKeywordPlanKeywordHistoricalMetrics} message KeywordPlanKeywordHistoricalMetrics message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        KeywordPlanKeywordHistoricalMetrics.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a KeywordPlanKeywordHistoricalMetrics message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics} KeywordPlanKeywordHistoricalMetrics
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanKeywordHistoricalMetrics.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.searchQuery = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.keywordMetrics = $root.google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a KeywordPlanKeywordHistoricalMetrics message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics} KeywordPlanKeywordHistoricalMetrics
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        KeywordPlanKeywordHistoricalMetrics.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a KeywordPlanKeywordHistoricalMetrics message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        KeywordPlanKeywordHistoricalMetrics.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.searchQuery != null && message.hasOwnProperty("searchQuery")) {
                                var error = $root.google.protobuf.StringValue.verify(message.searchQuery);
                                if (error)
                                    return "searchQuery." + error;
                            }
                            if (message.keywordMetrics != null && message.hasOwnProperty("keywordMetrics")) {
                                var error = $root.google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics.verify(message.keywordMetrics);
                                if (error)
                                    return "keywordMetrics." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a KeywordPlanKeywordHistoricalMetrics message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics} KeywordPlanKeywordHistoricalMetrics
                         */
                        KeywordPlanKeywordHistoricalMetrics.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics();
                            if (object.searchQuery != null) {
                                if (typeof object.searchQuery !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics.searchQuery: object expected");
                                message.searchQuery = $root.google.protobuf.StringValue.fromObject(object.searchQuery);
                            }
                            if (object.keywordMetrics != null) {
                                if (typeof object.keywordMetrics !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics.keywordMetrics: object expected");
                                message.keywordMetrics = $root.google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics.fromObject(object.keywordMetrics);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a KeywordPlanKeywordHistoricalMetrics message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics
                         * @static
                         * @param {google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics} message KeywordPlanKeywordHistoricalMetrics
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        KeywordPlanKeywordHistoricalMetrics.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.searchQuery = null;
                                object.keywordMetrics = null;
                            }
                            if (message.searchQuery != null && message.hasOwnProperty("searchQuery"))
                                object.searchQuery = $root.google.protobuf.StringValue.toObject(message.searchQuery, options);
                            if (message.keywordMetrics != null && message.hasOwnProperty("keywordMetrics"))
                                object.keywordMetrics = $root.google.ads.googleads.v1.common.KeywordPlanHistoricalMetrics.toObject(message.keywordMetrics, options);
                            return object;
                        };

                        /**
                         * Converts this KeywordPlanKeywordHistoricalMetrics to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.KeywordPlanKeywordHistoricalMetrics
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        KeywordPlanKeywordHistoricalMetrics.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return KeywordPlanKeywordHistoricalMetrics;
                    })();

                    services.KeywordViewService = (function() {

                        /**
                         * Constructs a new KeywordViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a KeywordViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function KeywordViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (KeywordViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = KeywordViewService;

                        /**
                         * Creates new KeywordViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.KeywordViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {KeywordViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        KeywordViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.KeywordViewService#getKeywordView}.
                         * @memberof google.ads.googleads.v1.services.KeywordViewService
                         * @typedef GetKeywordViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.KeywordView} [response] KeywordView
                         */

                        /**
                         * Calls GetKeywordView.
                         * @function getKeywordView
                         * @memberof google.ads.googleads.v1.services.KeywordViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetKeywordViewRequest} request GetKeywordViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.KeywordViewService.GetKeywordViewCallback} callback Node-style callback called with the error, if any, and KeywordView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(KeywordViewService.prototype.getKeywordView = function getKeywordView(request, callback) {
                            return this.rpcCall(getKeywordView, $root.google.ads.googleads.v1.services.GetKeywordViewRequest, $root.google.ads.googleads.v1.resources.KeywordView, request, callback);
                        }, "name", { value: "GetKeywordView" });

                        /**
                         * Calls GetKeywordView.
                         * @function getKeywordView
                         * @memberof google.ads.googleads.v1.services.KeywordViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetKeywordViewRequest} request GetKeywordViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.KeywordView>} Promise
                         * @variation 2
                         */

                        return KeywordViewService;
                    })();

                    services.GetKeywordViewRequest = (function() {

                        /**
                         * Properties of a GetKeywordViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetKeywordViewRequest
                         * @property {string|null} [resourceName] GetKeywordViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetKeywordViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetKeywordViewRequest.
                         * @implements IGetKeywordViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetKeywordViewRequest=} [properties] Properties to set
                         */
                        function GetKeywordViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetKeywordViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetKeywordViewRequest
                         * @instance
                         */
                        GetKeywordViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetKeywordViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetKeywordViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetKeywordViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetKeywordViewRequest} GetKeywordViewRequest instance
                         */
                        GetKeywordViewRequest.create = function create(properties) {
                            return new GetKeywordViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetKeywordViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetKeywordViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetKeywordViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetKeywordViewRequest} message GetKeywordViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetKeywordViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetKeywordViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetKeywordViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetKeywordViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetKeywordViewRequest} message GetKeywordViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetKeywordViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetKeywordViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetKeywordViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetKeywordViewRequest} GetKeywordViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetKeywordViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetKeywordViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetKeywordViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetKeywordViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetKeywordViewRequest} GetKeywordViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetKeywordViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetKeywordViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetKeywordViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetKeywordViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetKeywordViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetKeywordViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetKeywordViewRequest} GetKeywordViewRequest
                         */
                        GetKeywordViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetKeywordViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetKeywordViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetKeywordViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetKeywordViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetKeywordViewRequest} message GetKeywordViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetKeywordViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetKeywordViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetKeywordViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetKeywordViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetKeywordViewRequest;
                    })();

                    services.LabelService = (function() {

                        /**
                         * Constructs a new LabelService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a LabelService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function LabelService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (LabelService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = LabelService;

                        /**
                         * Creates new LabelService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.LabelService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {LabelService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        LabelService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.LabelService#getLabel}.
                         * @memberof google.ads.googleads.v1.services.LabelService
                         * @typedef GetLabelCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.Label} [response] Label
                         */

                        /**
                         * Calls GetLabel.
                         * @function getLabel
                         * @memberof google.ads.googleads.v1.services.LabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetLabelRequest} request GetLabelRequest message or plain object
                         * @param {google.ads.googleads.v1.services.LabelService.GetLabelCallback} callback Node-style callback called with the error, if any, and Label
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(LabelService.prototype.getLabel = function getLabel(request, callback) {
                            return this.rpcCall(getLabel, $root.google.ads.googleads.v1.services.GetLabelRequest, $root.google.ads.googleads.v1.resources.Label, request, callback);
                        }, "name", { value: "GetLabel" });

                        /**
                         * Calls GetLabel.
                         * @function getLabel
                         * @memberof google.ads.googleads.v1.services.LabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetLabelRequest} request GetLabelRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.Label>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.LabelService#mutateLabels}.
                         * @memberof google.ads.googleads.v1.services.LabelService
                         * @typedef MutateLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateLabelsResponse} [response] MutateLabelsResponse
                         */

                        /**
                         * Calls MutateLabels.
                         * @function mutateLabels
                         * @memberof google.ads.googleads.v1.services.LabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateLabelsRequest} request MutateLabelsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.LabelService.MutateLabelsCallback} callback Node-style callback called with the error, if any, and MutateLabelsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(LabelService.prototype.mutateLabels = function mutateLabels(request, callback) {
                            return this.rpcCall(mutateLabels, $root.google.ads.googleads.v1.services.MutateLabelsRequest, $root.google.ads.googleads.v1.services.MutateLabelsResponse, request, callback);
                        }, "name", { value: "MutateLabels" });

                        /**
                         * Calls MutateLabels.
                         * @function mutateLabels
                         * @memberof google.ads.googleads.v1.services.LabelService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateLabelsRequest} request MutateLabelsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateLabelsResponse>} Promise
                         * @variation 2
                         */

                        return LabelService;
                    })();

                    services.GetLabelRequest = (function() {

                        /**
                         * Properties of a GetLabelRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetLabelRequest
                         * @property {string|null} [resourceName] GetLabelRequest resourceName
                         */

                        /**
                         * Constructs a new GetLabelRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetLabelRequest.
                         * @implements IGetLabelRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetLabelRequest=} [properties] Properties to set
                         */
                        function GetLabelRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetLabelRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetLabelRequest
                         * @instance
                         */
                        GetLabelRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetLabelRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetLabelRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetLabelRequest} GetLabelRequest instance
                         */
                        GetLabelRequest.create = function create(properties) {
                            return new GetLabelRequest(properties);
                        };

                        /**
                         * Encodes the specified GetLabelRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetLabelRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetLabelRequest} message GetLabelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetLabelRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetLabelRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetLabelRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetLabelRequest} message GetLabelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetLabelRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetLabelRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetLabelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetLabelRequest} GetLabelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetLabelRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetLabelRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetLabelRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetLabelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetLabelRequest} GetLabelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetLabelRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetLabelRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetLabelRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetLabelRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetLabelRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetLabelRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetLabelRequest} GetLabelRequest
                         */
                        GetLabelRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetLabelRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetLabelRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetLabelRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetLabelRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetLabelRequest} message GetLabelRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetLabelRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetLabelRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetLabelRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetLabelRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetLabelRequest;
                    })();

                    services.MutateLabelsRequest = (function() {

                        /**
                         * Properties of a MutateLabelsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateLabelsRequest
                         * @property {string|null} [customerId] MutateLabelsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.ILabelOperation>|null} [operations] MutateLabelsRequest operations
                         * @property {boolean|null} [partialFailure] MutateLabelsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateLabelsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateLabelsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateLabelsRequest.
                         * @implements IMutateLabelsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateLabelsRequest=} [properties] Properties to set
                         */
                        function MutateLabelsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateLabelsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateLabelsRequest
                         * @instance
                         */
                        MutateLabelsRequest.prototype.customerId = "";

                        /**
                         * MutateLabelsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.ILabelOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateLabelsRequest
                         * @instance
                         */
                        MutateLabelsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateLabelsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateLabelsRequest
                         * @instance
                         */
                        MutateLabelsRequest.prototype.partialFailure = false;

                        /**
                         * MutateLabelsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateLabelsRequest
                         * @instance
                         */
                        MutateLabelsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateLabelsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateLabelsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateLabelsRequest} MutateLabelsRequest instance
                         */
                        MutateLabelsRequest.create = function create(properties) {
                            return new MutateLabelsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateLabelsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateLabelsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateLabelsRequest} message MutateLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateLabelsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.LabelOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateLabelsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateLabelsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateLabelsRequest} message MutateLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateLabelsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateLabelsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateLabelsRequest} MutateLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateLabelsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateLabelsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.LabelOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateLabelsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateLabelsRequest} MutateLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateLabelsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateLabelsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateLabelsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateLabelsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.LabelOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateLabelsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateLabelsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateLabelsRequest} MutateLabelsRequest
                         */
                        MutateLabelsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateLabelsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateLabelsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateLabelsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateLabelsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.LabelOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateLabelsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateLabelsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateLabelsRequest} message MutateLabelsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateLabelsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.LabelOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateLabelsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateLabelsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateLabelsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateLabelsRequest;
                    })();

                    services.LabelOperation = (function() {

                        /**
                         * Properties of a LabelOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ILabelOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] LabelOperation updateMask
                         * @property {google.ads.googleads.v1.resources.ILabel|null} [create] LabelOperation create
                         * @property {google.ads.googleads.v1.resources.ILabel|null} [update] LabelOperation update
                         * @property {string|null} [remove] LabelOperation remove
                         */

                        /**
                         * Constructs a new LabelOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a LabelOperation.
                         * @implements ILabelOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ILabelOperation=} [properties] Properties to set
                         */
                        function LabelOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * LabelOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.LabelOperation
                         * @instance
                         */
                        LabelOperation.prototype.updateMask = null;

                        /**
                         * LabelOperation create.
                         * @member {google.ads.googleads.v1.resources.ILabel|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.LabelOperation
                         * @instance
                         */
                        LabelOperation.prototype.create = null;

                        /**
                         * LabelOperation update.
                         * @member {google.ads.googleads.v1.resources.ILabel|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.LabelOperation
                         * @instance
                         */
                        LabelOperation.prototype.update = null;

                        /**
                         * LabelOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.LabelOperation
                         * @instance
                         */
                        LabelOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * LabelOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.LabelOperation
                         * @instance
                         */
                        Object.defineProperty(LabelOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new LabelOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.LabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ILabelOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.LabelOperation} LabelOperation instance
                         */
                        LabelOperation.create = function create(properties) {
                            return new LabelOperation(properties);
                        };

                        /**
                         * Encodes the specified LabelOperation message. Does not implicitly {@link google.ads.googleads.v1.services.LabelOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.LabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ILabelOperation} message LabelOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LabelOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.Label.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.Label.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified LabelOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.LabelOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.LabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ILabelOperation} message LabelOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LabelOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a LabelOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.LabelOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.LabelOperation} LabelOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LabelOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.LabelOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.Label.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.Label.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a LabelOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.LabelOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.LabelOperation} LabelOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LabelOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a LabelOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.LabelOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LabelOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Label.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.Label.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a LabelOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.LabelOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.LabelOperation} LabelOperation
                         */
                        LabelOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.LabelOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.LabelOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.LabelOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.LabelOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.Label.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.LabelOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.Label.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a LabelOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.LabelOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.LabelOperation} message LabelOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LabelOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.Label.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.Label.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this LabelOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.LabelOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LabelOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return LabelOperation;
                    })();

                    services.MutateLabelsResponse = (function() {

                        /**
                         * Properties of a MutateLabelsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateLabelsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateLabelsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateLabelResult>|null} [results] MutateLabelsResponse results
                         */

                        /**
                         * Constructs a new MutateLabelsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateLabelsResponse.
                         * @implements IMutateLabelsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateLabelsResponse=} [properties] Properties to set
                         */
                        function MutateLabelsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateLabelsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateLabelsResponse
                         * @instance
                         */
                        MutateLabelsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateLabelsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateLabelResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateLabelsResponse
                         * @instance
                         */
                        MutateLabelsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateLabelsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateLabelsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateLabelsResponse} MutateLabelsResponse instance
                         */
                        MutateLabelsResponse.create = function create(properties) {
                            return new MutateLabelsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateLabelsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateLabelsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateLabelsResponse} message MutateLabelsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateLabelsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateLabelResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateLabelsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateLabelsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateLabelsResponse} message MutateLabelsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateLabelsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateLabelsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateLabelsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateLabelsResponse} MutateLabelsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateLabelsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateLabelsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateLabelResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateLabelsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateLabelsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateLabelsResponse} MutateLabelsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateLabelsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateLabelsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateLabelsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateLabelsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateLabelResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateLabelsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateLabelsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateLabelsResponse} MutateLabelsResponse
                         */
                        MutateLabelsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateLabelsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateLabelsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateLabelsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateLabelsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateLabelsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateLabelResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateLabelsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateLabelsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateLabelsResponse} message MutateLabelsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateLabelsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateLabelResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateLabelsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateLabelsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateLabelsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateLabelsResponse;
                    })();

                    services.MutateLabelResult = (function() {

                        /**
                         * Properties of a MutateLabelResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateLabelResult
                         * @property {string|null} [resourceName] MutateLabelResult resourceName
                         */

                        /**
                         * Constructs a new MutateLabelResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateLabelResult.
                         * @implements IMutateLabelResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateLabelResult=} [properties] Properties to set
                         */
                        function MutateLabelResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateLabelResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateLabelResult
                         * @instance
                         */
                        MutateLabelResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateLabelResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateLabelResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateLabelResult} MutateLabelResult instance
                         */
                        MutateLabelResult.create = function create(properties) {
                            return new MutateLabelResult(properties);
                        };

                        /**
                         * Encodes the specified MutateLabelResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateLabelResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateLabelResult} message MutateLabelResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateLabelResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateLabelResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateLabelResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateLabelResult} message MutateLabelResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateLabelResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateLabelResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateLabelResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateLabelResult} MutateLabelResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateLabelResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateLabelResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateLabelResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateLabelResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateLabelResult} MutateLabelResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateLabelResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateLabelResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateLabelResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateLabelResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateLabelResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateLabelResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateLabelResult} MutateLabelResult
                         */
                        MutateLabelResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateLabelResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateLabelResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateLabelResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateLabelResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateLabelResult} message MutateLabelResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateLabelResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateLabelResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateLabelResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateLabelResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateLabelResult;
                    })();

                    services.LandingPageViewService = (function() {

                        /**
                         * Constructs a new LandingPageViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a LandingPageViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function LandingPageViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (LandingPageViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = LandingPageViewService;

                        /**
                         * Creates new LandingPageViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.LandingPageViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {LandingPageViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        LandingPageViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.LandingPageViewService#getLandingPageView}.
                         * @memberof google.ads.googleads.v1.services.LandingPageViewService
                         * @typedef GetLandingPageViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.LandingPageView} [response] LandingPageView
                         */

                        /**
                         * Calls GetLandingPageView.
                         * @function getLandingPageView
                         * @memberof google.ads.googleads.v1.services.LandingPageViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetLandingPageViewRequest} request GetLandingPageViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.LandingPageViewService.GetLandingPageViewCallback} callback Node-style callback called with the error, if any, and LandingPageView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(LandingPageViewService.prototype.getLandingPageView = function getLandingPageView(request, callback) {
                            return this.rpcCall(getLandingPageView, $root.google.ads.googleads.v1.services.GetLandingPageViewRequest, $root.google.ads.googleads.v1.resources.LandingPageView, request, callback);
                        }, "name", { value: "GetLandingPageView" });

                        /**
                         * Calls GetLandingPageView.
                         * @function getLandingPageView
                         * @memberof google.ads.googleads.v1.services.LandingPageViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetLandingPageViewRequest} request GetLandingPageViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.LandingPageView>} Promise
                         * @variation 2
                         */

                        return LandingPageViewService;
                    })();

                    services.GetLandingPageViewRequest = (function() {

                        /**
                         * Properties of a GetLandingPageViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetLandingPageViewRequest
                         * @property {string|null} [resourceName] GetLandingPageViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetLandingPageViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetLandingPageViewRequest.
                         * @implements IGetLandingPageViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetLandingPageViewRequest=} [properties] Properties to set
                         */
                        function GetLandingPageViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetLandingPageViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetLandingPageViewRequest
                         * @instance
                         */
                        GetLandingPageViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetLandingPageViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetLandingPageViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetLandingPageViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetLandingPageViewRequest} GetLandingPageViewRequest instance
                         */
                        GetLandingPageViewRequest.create = function create(properties) {
                            return new GetLandingPageViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetLandingPageViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetLandingPageViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetLandingPageViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetLandingPageViewRequest} message GetLandingPageViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetLandingPageViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetLandingPageViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetLandingPageViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetLandingPageViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetLandingPageViewRequest} message GetLandingPageViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetLandingPageViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetLandingPageViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetLandingPageViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetLandingPageViewRequest} GetLandingPageViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetLandingPageViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetLandingPageViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetLandingPageViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetLandingPageViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetLandingPageViewRequest} GetLandingPageViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetLandingPageViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetLandingPageViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetLandingPageViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetLandingPageViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetLandingPageViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetLandingPageViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetLandingPageViewRequest} GetLandingPageViewRequest
                         */
                        GetLandingPageViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetLandingPageViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetLandingPageViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetLandingPageViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetLandingPageViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetLandingPageViewRequest} message GetLandingPageViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetLandingPageViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetLandingPageViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetLandingPageViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetLandingPageViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetLandingPageViewRequest;
                    })();

                    services.LanguageConstantService = (function() {

                        /**
                         * Constructs a new LanguageConstantService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a LanguageConstantService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function LanguageConstantService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (LanguageConstantService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = LanguageConstantService;

                        /**
                         * Creates new LanguageConstantService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.LanguageConstantService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {LanguageConstantService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        LanguageConstantService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.LanguageConstantService#getLanguageConstant}.
                         * @memberof google.ads.googleads.v1.services.LanguageConstantService
                         * @typedef GetLanguageConstantCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.LanguageConstant} [response] LanguageConstant
                         */

                        /**
                         * Calls GetLanguageConstant.
                         * @function getLanguageConstant
                         * @memberof google.ads.googleads.v1.services.LanguageConstantService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetLanguageConstantRequest} request GetLanguageConstantRequest message or plain object
                         * @param {google.ads.googleads.v1.services.LanguageConstantService.GetLanguageConstantCallback} callback Node-style callback called with the error, if any, and LanguageConstant
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(LanguageConstantService.prototype.getLanguageConstant = function getLanguageConstant(request, callback) {
                            return this.rpcCall(getLanguageConstant, $root.google.ads.googleads.v1.services.GetLanguageConstantRequest, $root.google.ads.googleads.v1.resources.LanguageConstant, request, callback);
                        }, "name", { value: "GetLanguageConstant" });

                        /**
                         * Calls GetLanguageConstant.
                         * @function getLanguageConstant
                         * @memberof google.ads.googleads.v1.services.LanguageConstantService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetLanguageConstantRequest} request GetLanguageConstantRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.LanguageConstant>} Promise
                         * @variation 2
                         */

                        return LanguageConstantService;
                    })();

                    services.GetLanguageConstantRequest = (function() {

                        /**
                         * Properties of a GetLanguageConstantRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetLanguageConstantRequest
                         * @property {string|null} [resourceName] GetLanguageConstantRequest resourceName
                         */

                        /**
                         * Constructs a new GetLanguageConstantRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetLanguageConstantRequest.
                         * @implements IGetLanguageConstantRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetLanguageConstantRequest=} [properties] Properties to set
                         */
                        function GetLanguageConstantRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetLanguageConstantRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetLanguageConstantRequest
                         * @instance
                         */
                        GetLanguageConstantRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetLanguageConstantRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetLanguageConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetLanguageConstantRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetLanguageConstantRequest} GetLanguageConstantRequest instance
                         */
                        GetLanguageConstantRequest.create = function create(properties) {
                            return new GetLanguageConstantRequest(properties);
                        };

                        /**
                         * Encodes the specified GetLanguageConstantRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetLanguageConstantRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetLanguageConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetLanguageConstantRequest} message GetLanguageConstantRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetLanguageConstantRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetLanguageConstantRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetLanguageConstantRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetLanguageConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetLanguageConstantRequest} message GetLanguageConstantRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetLanguageConstantRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetLanguageConstantRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetLanguageConstantRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetLanguageConstantRequest} GetLanguageConstantRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetLanguageConstantRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetLanguageConstantRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetLanguageConstantRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetLanguageConstantRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetLanguageConstantRequest} GetLanguageConstantRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetLanguageConstantRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetLanguageConstantRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetLanguageConstantRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetLanguageConstantRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetLanguageConstantRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetLanguageConstantRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetLanguageConstantRequest} GetLanguageConstantRequest
                         */
                        GetLanguageConstantRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetLanguageConstantRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetLanguageConstantRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetLanguageConstantRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetLanguageConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetLanguageConstantRequest} message GetLanguageConstantRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetLanguageConstantRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetLanguageConstantRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetLanguageConstantRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetLanguageConstantRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetLanguageConstantRequest;
                    })();

                    services.LocationViewService = (function() {

                        /**
                         * Constructs a new LocationViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a LocationViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function LocationViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (LocationViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = LocationViewService;

                        /**
                         * Creates new LocationViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.LocationViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {LocationViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        LocationViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.LocationViewService#getLocationView}.
                         * @memberof google.ads.googleads.v1.services.LocationViewService
                         * @typedef GetLocationViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.LocationView} [response] LocationView
                         */

                        /**
                         * Calls GetLocationView.
                         * @function getLocationView
                         * @memberof google.ads.googleads.v1.services.LocationViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetLocationViewRequest} request GetLocationViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.LocationViewService.GetLocationViewCallback} callback Node-style callback called with the error, if any, and LocationView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(LocationViewService.prototype.getLocationView = function getLocationView(request, callback) {
                            return this.rpcCall(getLocationView, $root.google.ads.googleads.v1.services.GetLocationViewRequest, $root.google.ads.googleads.v1.resources.LocationView, request, callback);
                        }, "name", { value: "GetLocationView" });

                        /**
                         * Calls GetLocationView.
                         * @function getLocationView
                         * @memberof google.ads.googleads.v1.services.LocationViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetLocationViewRequest} request GetLocationViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.LocationView>} Promise
                         * @variation 2
                         */

                        return LocationViewService;
                    })();

                    services.GetLocationViewRequest = (function() {

                        /**
                         * Properties of a GetLocationViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetLocationViewRequest
                         * @property {string|null} [resourceName] GetLocationViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetLocationViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetLocationViewRequest.
                         * @implements IGetLocationViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetLocationViewRequest=} [properties] Properties to set
                         */
                        function GetLocationViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetLocationViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetLocationViewRequest
                         * @instance
                         */
                        GetLocationViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetLocationViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetLocationViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetLocationViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetLocationViewRequest} GetLocationViewRequest instance
                         */
                        GetLocationViewRequest.create = function create(properties) {
                            return new GetLocationViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetLocationViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetLocationViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetLocationViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetLocationViewRequest} message GetLocationViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetLocationViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetLocationViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetLocationViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetLocationViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetLocationViewRequest} message GetLocationViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetLocationViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetLocationViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetLocationViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetLocationViewRequest} GetLocationViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetLocationViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetLocationViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetLocationViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetLocationViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetLocationViewRequest} GetLocationViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetLocationViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetLocationViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetLocationViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetLocationViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetLocationViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetLocationViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetLocationViewRequest} GetLocationViewRequest
                         */
                        GetLocationViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetLocationViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetLocationViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetLocationViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetLocationViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetLocationViewRequest} message GetLocationViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetLocationViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetLocationViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetLocationViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetLocationViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetLocationViewRequest;
                    })();

                    services.ManagedPlacementViewService = (function() {

                        /**
                         * Constructs a new ManagedPlacementViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ManagedPlacementViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function ManagedPlacementViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (ManagedPlacementViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = ManagedPlacementViewService;

                        /**
                         * Creates new ManagedPlacementViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ManagedPlacementViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {ManagedPlacementViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        ManagedPlacementViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.ManagedPlacementViewService#getManagedPlacementView}.
                         * @memberof google.ads.googleads.v1.services.ManagedPlacementViewService
                         * @typedef GetManagedPlacementViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.ManagedPlacementView} [response] ManagedPlacementView
                         */

                        /**
                         * Calls GetManagedPlacementView.
                         * @function getManagedPlacementView
                         * @memberof google.ads.googleads.v1.services.ManagedPlacementViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetManagedPlacementViewRequest} request GetManagedPlacementViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.ManagedPlacementViewService.GetManagedPlacementViewCallback} callback Node-style callback called with the error, if any, and ManagedPlacementView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ManagedPlacementViewService.prototype.getManagedPlacementView = function getManagedPlacementView(request, callback) {
                            return this.rpcCall(getManagedPlacementView, $root.google.ads.googleads.v1.services.GetManagedPlacementViewRequest, $root.google.ads.googleads.v1.resources.ManagedPlacementView, request, callback);
                        }, "name", { value: "GetManagedPlacementView" });

                        /**
                         * Calls GetManagedPlacementView.
                         * @function getManagedPlacementView
                         * @memberof google.ads.googleads.v1.services.ManagedPlacementViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetManagedPlacementViewRequest} request GetManagedPlacementViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.ManagedPlacementView>} Promise
                         * @variation 2
                         */

                        return ManagedPlacementViewService;
                    })();

                    services.GetManagedPlacementViewRequest = (function() {

                        /**
                         * Properties of a GetManagedPlacementViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetManagedPlacementViewRequest
                         * @property {string|null} [resourceName] GetManagedPlacementViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetManagedPlacementViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetManagedPlacementViewRequest.
                         * @implements IGetManagedPlacementViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetManagedPlacementViewRequest=} [properties] Properties to set
                         */
                        function GetManagedPlacementViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetManagedPlacementViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetManagedPlacementViewRequest
                         * @instance
                         */
                        GetManagedPlacementViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetManagedPlacementViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetManagedPlacementViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetManagedPlacementViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetManagedPlacementViewRequest} GetManagedPlacementViewRequest instance
                         */
                        GetManagedPlacementViewRequest.create = function create(properties) {
                            return new GetManagedPlacementViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetManagedPlacementViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetManagedPlacementViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetManagedPlacementViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetManagedPlacementViewRequest} message GetManagedPlacementViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetManagedPlacementViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetManagedPlacementViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetManagedPlacementViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetManagedPlacementViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetManagedPlacementViewRequest} message GetManagedPlacementViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetManagedPlacementViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetManagedPlacementViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetManagedPlacementViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetManagedPlacementViewRequest} GetManagedPlacementViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetManagedPlacementViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetManagedPlacementViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetManagedPlacementViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetManagedPlacementViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetManagedPlacementViewRequest} GetManagedPlacementViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetManagedPlacementViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetManagedPlacementViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetManagedPlacementViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetManagedPlacementViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetManagedPlacementViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetManagedPlacementViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetManagedPlacementViewRequest} GetManagedPlacementViewRequest
                         */
                        GetManagedPlacementViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetManagedPlacementViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetManagedPlacementViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetManagedPlacementViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetManagedPlacementViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetManagedPlacementViewRequest} message GetManagedPlacementViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetManagedPlacementViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetManagedPlacementViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetManagedPlacementViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetManagedPlacementViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetManagedPlacementViewRequest;
                    })();

                    services.MediaFileService = (function() {

                        /**
                         * Constructs a new MediaFileService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MediaFileService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function MediaFileService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (MediaFileService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = MediaFileService;

                        /**
                         * Creates new MediaFileService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MediaFileService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {MediaFileService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        MediaFileService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.MediaFileService#getMediaFile}.
                         * @memberof google.ads.googleads.v1.services.MediaFileService
                         * @typedef GetMediaFileCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.MediaFile} [response] MediaFile
                         */

                        /**
                         * Calls GetMediaFile.
                         * @function getMediaFile
                         * @memberof google.ads.googleads.v1.services.MediaFileService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetMediaFileRequest} request GetMediaFileRequest message or plain object
                         * @param {google.ads.googleads.v1.services.MediaFileService.GetMediaFileCallback} callback Node-style callback called with the error, if any, and MediaFile
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MediaFileService.prototype.getMediaFile = function getMediaFile(request, callback) {
                            return this.rpcCall(getMediaFile, $root.google.ads.googleads.v1.services.GetMediaFileRequest, $root.google.ads.googleads.v1.resources.MediaFile, request, callback);
                        }, "name", { value: "GetMediaFile" });

                        /**
                         * Calls GetMediaFile.
                         * @function getMediaFile
                         * @memberof google.ads.googleads.v1.services.MediaFileService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetMediaFileRequest} request GetMediaFileRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.MediaFile>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.MediaFileService#mutateMediaFiles}.
                         * @memberof google.ads.googleads.v1.services.MediaFileService
                         * @typedef MutateMediaFilesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateMediaFilesResponse} [response] MutateMediaFilesResponse
                         */

                        /**
                         * Calls MutateMediaFiles.
                         * @function mutateMediaFiles
                         * @memberof google.ads.googleads.v1.services.MediaFileService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateMediaFilesRequest} request MutateMediaFilesRequest message or plain object
                         * @param {google.ads.googleads.v1.services.MediaFileService.MutateMediaFilesCallback} callback Node-style callback called with the error, if any, and MutateMediaFilesResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MediaFileService.prototype.mutateMediaFiles = function mutateMediaFiles(request, callback) {
                            return this.rpcCall(mutateMediaFiles, $root.google.ads.googleads.v1.services.MutateMediaFilesRequest, $root.google.ads.googleads.v1.services.MutateMediaFilesResponse, request, callback);
                        }, "name", { value: "MutateMediaFiles" });

                        /**
                         * Calls MutateMediaFiles.
                         * @function mutateMediaFiles
                         * @memberof google.ads.googleads.v1.services.MediaFileService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateMediaFilesRequest} request MutateMediaFilesRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateMediaFilesResponse>} Promise
                         * @variation 2
                         */

                        return MediaFileService;
                    })();

                    services.GetMediaFileRequest = (function() {

                        /**
                         * Properties of a GetMediaFileRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetMediaFileRequest
                         * @property {string|null} [resourceName] GetMediaFileRequest resourceName
                         */

                        /**
                         * Constructs a new GetMediaFileRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetMediaFileRequest.
                         * @implements IGetMediaFileRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetMediaFileRequest=} [properties] Properties to set
                         */
                        function GetMediaFileRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetMediaFileRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetMediaFileRequest
                         * @instance
                         */
                        GetMediaFileRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetMediaFileRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetMediaFileRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetMediaFileRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetMediaFileRequest} GetMediaFileRequest instance
                         */
                        GetMediaFileRequest.create = function create(properties) {
                            return new GetMediaFileRequest(properties);
                        };

                        /**
                         * Encodes the specified GetMediaFileRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetMediaFileRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetMediaFileRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetMediaFileRequest} message GetMediaFileRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetMediaFileRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetMediaFileRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetMediaFileRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetMediaFileRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetMediaFileRequest} message GetMediaFileRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetMediaFileRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetMediaFileRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetMediaFileRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetMediaFileRequest} GetMediaFileRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetMediaFileRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetMediaFileRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetMediaFileRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetMediaFileRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetMediaFileRequest} GetMediaFileRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetMediaFileRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetMediaFileRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetMediaFileRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetMediaFileRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetMediaFileRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetMediaFileRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetMediaFileRequest} GetMediaFileRequest
                         */
                        GetMediaFileRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetMediaFileRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetMediaFileRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetMediaFileRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetMediaFileRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetMediaFileRequest} message GetMediaFileRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetMediaFileRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetMediaFileRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetMediaFileRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetMediaFileRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetMediaFileRequest;
                    })();

                    services.MutateMediaFilesRequest = (function() {

                        /**
                         * Properties of a MutateMediaFilesRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateMediaFilesRequest
                         * @property {string|null} [customerId] MutateMediaFilesRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IMediaFileOperation>|null} [operations] MutateMediaFilesRequest operations
                         * @property {boolean|null} [partialFailure] MutateMediaFilesRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateMediaFilesRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateMediaFilesRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateMediaFilesRequest.
                         * @implements IMutateMediaFilesRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateMediaFilesRequest=} [properties] Properties to set
                         */
                        function MutateMediaFilesRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateMediaFilesRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesRequest
                         * @instance
                         */
                        MutateMediaFilesRequest.prototype.customerId = "";

                        /**
                         * MutateMediaFilesRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IMediaFileOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesRequest
                         * @instance
                         */
                        MutateMediaFilesRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateMediaFilesRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesRequest
                         * @instance
                         */
                        MutateMediaFilesRequest.prototype.partialFailure = false;

                        /**
                         * MutateMediaFilesRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesRequest
                         * @instance
                         */
                        MutateMediaFilesRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateMediaFilesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateMediaFilesRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateMediaFilesRequest} MutateMediaFilesRequest instance
                         */
                        MutateMediaFilesRequest.create = function create(properties) {
                            return new MutateMediaFilesRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateMediaFilesRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateMediaFilesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateMediaFilesRequest} message MutateMediaFilesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateMediaFilesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.MediaFileOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateMediaFilesRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateMediaFilesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateMediaFilesRequest} message MutateMediaFilesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateMediaFilesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateMediaFilesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateMediaFilesRequest} MutateMediaFilesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateMediaFilesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateMediaFilesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.MediaFileOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateMediaFilesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateMediaFilesRequest} MutateMediaFilesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateMediaFilesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateMediaFilesRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateMediaFilesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MediaFileOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateMediaFilesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateMediaFilesRequest} MutateMediaFilesRequest
                         */
                        MutateMediaFilesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateMediaFilesRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateMediaFilesRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateMediaFilesRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateMediaFilesRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.MediaFileOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateMediaFilesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateMediaFilesRequest} message MutateMediaFilesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateMediaFilesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.MediaFileOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateMediaFilesRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateMediaFilesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateMediaFilesRequest;
                    })();

                    services.MediaFileOperation = (function() {

                        /**
                         * Properties of a MediaFileOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMediaFileOperation
                         * @property {google.ads.googleads.v1.resources.IMediaFile|null} [create] MediaFileOperation create
                         */

                        /**
                         * Constructs a new MediaFileOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MediaFileOperation.
                         * @implements IMediaFileOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMediaFileOperation=} [properties] Properties to set
                         */
                        function MediaFileOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MediaFileOperation create.
                         * @member {google.ads.googleads.v1.resources.IMediaFile|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.MediaFileOperation
                         * @instance
                         */
                        MediaFileOperation.prototype.create = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * MediaFileOperation operation.
                         * @member {"create"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.MediaFileOperation
                         * @instance
                         */
                        Object.defineProperty(MediaFileOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new MediaFileOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MediaFileOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IMediaFileOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MediaFileOperation} MediaFileOperation instance
                         */
                        MediaFileOperation.create = function create(properties) {
                            return new MediaFileOperation(properties);
                        };

                        /**
                         * Encodes the specified MediaFileOperation message. Does not implicitly {@link google.ads.googleads.v1.services.MediaFileOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MediaFileOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IMediaFileOperation} message MediaFileOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaFileOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.MediaFile.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MediaFileOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MediaFileOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MediaFileOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IMediaFileOperation} message MediaFileOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MediaFileOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MediaFileOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MediaFileOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MediaFileOperation} MediaFileOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaFileOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MediaFileOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.MediaFile.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MediaFileOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MediaFileOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MediaFileOperation} MediaFileOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MediaFileOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MediaFileOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MediaFileOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MediaFileOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.MediaFile.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MediaFileOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MediaFileOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MediaFileOperation} MediaFileOperation
                         */
                        MediaFileOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MediaFileOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MediaFileOperation();
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MediaFileOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.MediaFile.fromObject(object.create);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MediaFileOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MediaFileOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.MediaFileOperation} message MediaFileOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MediaFileOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.MediaFile.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            return object;
                        };

                        /**
                         * Converts this MediaFileOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MediaFileOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MediaFileOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MediaFileOperation;
                    })();

                    services.MutateMediaFilesResponse = (function() {

                        /**
                         * Properties of a MutateMediaFilesResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateMediaFilesResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateMediaFilesResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateMediaFileResult>|null} [results] MutateMediaFilesResponse results
                         */

                        /**
                         * Constructs a new MutateMediaFilesResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateMediaFilesResponse.
                         * @implements IMutateMediaFilesResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateMediaFilesResponse=} [properties] Properties to set
                         */
                        function MutateMediaFilesResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateMediaFilesResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesResponse
                         * @instance
                         */
                        MutateMediaFilesResponse.prototype.partialFailureError = null;

                        /**
                         * MutateMediaFilesResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateMediaFileResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesResponse
                         * @instance
                         */
                        MutateMediaFilesResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateMediaFilesResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateMediaFilesResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateMediaFilesResponse} MutateMediaFilesResponse instance
                         */
                        MutateMediaFilesResponse.create = function create(properties) {
                            return new MutateMediaFilesResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateMediaFilesResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateMediaFilesResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateMediaFilesResponse} message MutateMediaFilesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateMediaFilesResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateMediaFileResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateMediaFilesResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateMediaFilesResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateMediaFilesResponse} message MutateMediaFilesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateMediaFilesResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateMediaFilesResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateMediaFilesResponse} MutateMediaFilesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateMediaFilesResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateMediaFilesResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateMediaFileResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateMediaFilesResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateMediaFilesResponse} MutateMediaFilesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateMediaFilesResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateMediaFilesResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateMediaFilesResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateMediaFileResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateMediaFilesResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateMediaFilesResponse} MutateMediaFilesResponse
                         */
                        MutateMediaFilesResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateMediaFilesResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateMediaFilesResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateMediaFilesResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateMediaFilesResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateMediaFilesResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateMediaFileResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateMediaFilesResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateMediaFilesResponse} message MutateMediaFilesResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateMediaFilesResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateMediaFileResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateMediaFilesResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateMediaFilesResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateMediaFilesResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateMediaFilesResponse;
                    })();

                    services.MutateMediaFileResult = (function() {

                        /**
                         * Properties of a MutateMediaFileResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateMediaFileResult
                         * @property {string|null} [resourceName] MutateMediaFileResult resourceName
                         */

                        /**
                         * Constructs a new MutateMediaFileResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateMediaFileResult.
                         * @implements IMutateMediaFileResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateMediaFileResult=} [properties] Properties to set
                         */
                        function MutateMediaFileResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateMediaFileResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateMediaFileResult
                         * @instance
                         */
                        MutateMediaFileResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateMediaFileResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateMediaFileResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateMediaFileResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateMediaFileResult} MutateMediaFileResult instance
                         */
                        MutateMediaFileResult.create = function create(properties) {
                            return new MutateMediaFileResult(properties);
                        };

                        /**
                         * Encodes the specified MutateMediaFileResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateMediaFileResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateMediaFileResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateMediaFileResult} message MutateMediaFileResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateMediaFileResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateMediaFileResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateMediaFileResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateMediaFileResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateMediaFileResult} message MutateMediaFileResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateMediaFileResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateMediaFileResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateMediaFileResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateMediaFileResult} MutateMediaFileResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateMediaFileResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateMediaFileResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateMediaFileResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateMediaFileResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateMediaFileResult} MutateMediaFileResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateMediaFileResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateMediaFileResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateMediaFileResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateMediaFileResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateMediaFileResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateMediaFileResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateMediaFileResult} MutateMediaFileResult
                         */
                        MutateMediaFileResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateMediaFileResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateMediaFileResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateMediaFileResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateMediaFileResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateMediaFileResult} message MutateMediaFileResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateMediaFileResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateMediaFileResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateMediaFileResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateMediaFileResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateMediaFileResult;
                    })();

                    services.MerchantCenterLinkService = (function() {

                        /**
                         * Constructs a new MerchantCenterLinkService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MerchantCenterLinkService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function MerchantCenterLinkService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (MerchantCenterLinkService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = MerchantCenterLinkService;

                        /**
                         * Creates new MerchantCenterLinkService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {MerchantCenterLinkService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        MerchantCenterLinkService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.MerchantCenterLinkService#listMerchantCenterLinks}.
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkService
                         * @typedef ListMerchantCenterLinksCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.ListMerchantCenterLinksResponse} [response] ListMerchantCenterLinksResponse
                         */

                        /**
                         * Calls ListMerchantCenterLinks.
                         * @function listMerchantCenterLinks
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IListMerchantCenterLinksRequest} request ListMerchantCenterLinksRequest message or plain object
                         * @param {google.ads.googleads.v1.services.MerchantCenterLinkService.ListMerchantCenterLinksCallback} callback Node-style callback called with the error, if any, and ListMerchantCenterLinksResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MerchantCenterLinkService.prototype.listMerchantCenterLinks = function listMerchantCenterLinks(request, callback) {
                            return this.rpcCall(listMerchantCenterLinks, $root.google.ads.googleads.v1.services.ListMerchantCenterLinksRequest, $root.google.ads.googleads.v1.services.ListMerchantCenterLinksResponse, request, callback);
                        }, "name", { value: "ListMerchantCenterLinks" });

                        /**
                         * Calls ListMerchantCenterLinks.
                         * @function listMerchantCenterLinks
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IListMerchantCenterLinksRequest} request ListMerchantCenterLinksRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.ListMerchantCenterLinksResponse>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.MerchantCenterLinkService#getMerchantCenterLink}.
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkService
                         * @typedef GetMerchantCenterLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.MerchantCenterLink} [response] MerchantCenterLink
                         */

                        /**
                         * Calls GetMerchantCenterLink.
                         * @function getMerchantCenterLink
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetMerchantCenterLinkRequest} request GetMerchantCenterLinkRequest message or plain object
                         * @param {google.ads.googleads.v1.services.MerchantCenterLinkService.GetMerchantCenterLinkCallback} callback Node-style callback called with the error, if any, and MerchantCenterLink
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MerchantCenterLinkService.prototype.getMerchantCenterLink = function getMerchantCenterLink(request, callback) {
                            return this.rpcCall(getMerchantCenterLink, $root.google.ads.googleads.v1.services.GetMerchantCenterLinkRequest, $root.google.ads.googleads.v1.resources.MerchantCenterLink, request, callback);
                        }, "name", { value: "GetMerchantCenterLink" });

                        /**
                         * Calls GetMerchantCenterLink.
                         * @function getMerchantCenterLink
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetMerchantCenterLinkRequest} request GetMerchantCenterLinkRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.MerchantCenterLink>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.MerchantCenterLinkService#mutateMerchantCenterLink}.
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkService
                         * @typedef MutateMerchantCenterLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse} [response] MutateMerchantCenterLinkResponse
                         */

                        /**
                         * Calls MutateMerchantCenterLink.
                         * @function mutateMerchantCenterLink
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateMerchantCenterLinkRequest} request MutateMerchantCenterLinkRequest message or plain object
                         * @param {google.ads.googleads.v1.services.MerchantCenterLinkService.MutateMerchantCenterLinkCallback} callback Node-style callback called with the error, if any, and MutateMerchantCenterLinkResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MerchantCenterLinkService.prototype.mutateMerchantCenterLink = function mutateMerchantCenterLink(request, callback) {
                            return this.rpcCall(mutateMerchantCenterLink, $root.google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest, $root.google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse, request, callback);
                        }, "name", { value: "MutateMerchantCenterLink" });

                        /**
                         * Calls MutateMerchantCenterLink.
                         * @function mutateMerchantCenterLink
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateMerchantCenterLinkRequest} request MutateMerchantCenterLinkRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse>} Promise
                         * @variation 2
                         */

                        return MerchantCenterLinkService;
                    })();

                    services.ListMerchantCenterLinksRequest = (function() {

                        /**
                         * Properties of a ListMerchantCenterLinksRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IListMerchantCenterLinksRequest
                         * @property {string|null} [customerId] ListMerchantCenterLinksRequest customerId
                         */

                        /**
                         * Constructs a new ListMerchantCenterLinksRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ListMerchantCenterLinksRequest.
                         * @implements IListMerchantCenterLinksRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IListMerchantCenterLinksRequest=} [properties] Properties to set
                         */
                        function ListMerchantCenterLinksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ListMerchantCenterLinksRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksRequest
                         * @instance
                         */
                        ListMerchantCenterLinksRequest.prototype.customerId = "";

                        /**
                         * Creates a new ListMerchantCenterLinksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IListMerchantCenterLinksRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ListMerchantCenterLinksRequest} ListMerchantCenterLinksRequest instance
                         */
                        ListMerchantCenterLinksRequest.create = function create(properties) {
                            return new ListMerchantCenterLinksRequest(properties);
                        };

                        /**
                         * Encodes the specified ListMerchantCenterLinksRequest message. Does not implicitly {@link google.ads.googleads.v1.services.ListMerchantCenterLinksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IListMerchantCenterLinksRequest} message ListMerchantCenterLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMerchantCenterLinksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            return writer;
                        };

                        /**
                         * Encodes the specified ListMerchantCenterLinksRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ListMerchantCenterLinksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IListMerchantCenterLinksRequest} message ListMerchantCenterLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMerchantCenterLinksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ListMerchantCenterLinksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ListMerchantCenterLinksRequest} ListMerchantCenterLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMerchantCenterLinksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ListMerchantCenterLinksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ListMerchantCenterLinksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ListMerchantCenterLinksRequest} ListMerchantCenterLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMerchantCenterLinksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ListMerchantCenterLinksRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListMerchantCenterLinksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            return null;
                        };

                        /**
                         * Creates a ListMerchantCenterLinksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ListMerchantCenterLinksRequest} ListMerchantCenterLinksRequest
                         */
                        ListMerchantCenterLinksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ListMerchantCenterLinksRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ListMerchantCenterLinksRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            return message;
                        };

                        /**
                         * Creates a plain object from a ListMerchantCenterLinksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ListMerchantCenterLinksRequest} message ListMerchantCenterLinksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListMerchantCenterLinksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.customerId = "";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            return object;
                        };

                        /**
                         * Converts this ListMerchantCenterLinksRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListMerchantCenterLinksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ListMerchantCenterLinksRequest;
                    })();

                    services.ListMerchantCenterLinksResponse = (function() {

                        /**
                         * Properties of a ListMerchantCenterLinksResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IListMerchantCenterLinksResponse
                         * @property {Array.<google.ads.googleads.v1.resources.IMerchantCenterLink>|null} [merchantCenterLinks] ListMerchantCenterLinksResponse merchantCenterLinks
                         */

                        /**
                         * Constructs a new ListMerchantCenterLinksResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ListMerchantCenterLinksResponse.
                         * @implements IListMerchantCenterLinksResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IListMerchantCenterLinksResponse=} [properties] Properties to set
                         */
                        function ListMerchantCenterLinksResponse(properties) {
                            this.merchantCenterLinks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ListMerchantCenterLinksResponse merchantCenterLinks.
                         * @member {Array.<google.ads.googleads.v1.resources.IMerchantCenterLink>} merchantCenterLinks
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksResponse
                         * @instance
                         */
                        ListMerchantCenterLinksResponse.prototype.merchantCenterLinks = $util.emptyArray;

                        /**
                         * Creates a new ListMerchantCenterLinksResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IListMerchantCenterLinksResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ListMerchantCenterLinksResponse} ListMerchantCenterLinksResponse instance
                         */
                        ListMerchantCenterLinksResponse.create = function create(properties) {
                            return new ListMerchantCenterLinksResponse(properties);
                        };

                        /**
                         * Encodes the specified ListMerchantCenterLinksResponse message. Does not implicitly {@link google.ads.googleads.v1.services.ListMerchantCenterLinksResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IListMerchantCenterLinksResponse} message ListMerchantCenterLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMerchantCenterLinksResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.merchantCenterLinks != null && message.merchantCenterLinks.length)
                                for (var i = 0; i < message.merchantCenterLinks.length; ++i)
                                    $root.google.ads.googleads.v1.resources.MerchantCenterLink.encode(message.merchantCenterLinks[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ListMerchantCenterLinksResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ListMerchantCenterLinksResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IListMerchantCenterLinksResponse} message ListMerchantCenterLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMerchantCenterLinksResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ListMerchantCenterLinksResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ListMerchantCenterLinksResponse} ListMerchantCenterLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMerchantCenterLinksResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ListMerchantCenterLinksResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.merchantCenterLinks && message.merchantCenterLinks.length))
                                        message.merchantCenterLinks = [];
                                    message.merchantCenterLinks.push($root.google.ads.googleads.v1.resources.MerchantCenterLink.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ListMerchantCenterLinksResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ListMerchantCenterLinksResponse} ListMerchantCenterLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMerchantCenterLinksResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ListMerchantCenterLinksResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListMerchantCenterLinksResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.merchantCenterLinks != null && message.hasOwnProperty("merchantCenterLinks")) {
                                if (!Array.isArray(message.merchantCenterLinks))
                                    return "merchantCenterLinks: array expected";
                                for (var i = 0; i < message.merchantCenterLinks.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.resources.MerchantCenterLink.verify(message.merchantCenterLinks[i]);
                                    if (error)
                                        return "merchantCenterLinks." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a ListMerchantCenterLinksResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ListMerchantCenterLinksResponse} ListMerchantCenterLinksResponse
                         */
                        ListMerchantCenterLinksResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ListMerchantCenterLinksResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ListMerchantCenterLinksResponse();
                            if (object.merchantCenterLinks) {
                                if (!Array.isArray(object.merchantCenterLinks))
                                    throw TypeError(".google.ads.googleads.v1.services.ListMerchantCenterLinksResponse.merchantCenterLinks: array expected");
                                message.merchantCenterLinks = [];
                                for (var i = 0; i < object.merchantCenterLinks.length; ++i) {
                                    if (typeof object.merchantCenterLinks[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.ListMerchantCenterLinksResponse.merchantCenterLinks: object expected");
                                    message.merchantCenterLinks[i] = $root.google.ads.googleads.v1.resources.MerchantCenterLink.fromObject(object.merchantCenterLinks[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ListMerchantCenterLinksResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ListMerchantCenterLinksResponse} message ListMerchantCenterLinksResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListMerchantCenterLinksResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.merchantCenterLinks = [];
                            if (message.merchantCenterLinks && message.merchantCenterLinks.length) {
                                object.merchantCenterLinks = [];
                                for (var j = 0; j < message.merchantCenterLinks.length; ++j)
                                    object.merchantCenterLinks[j] = $root.google.ads.googleads.v1.resources.MerchantCenterLink.toObject(message.merchantCenterLinks[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this ListMerchantCenterLinksResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ListMerchantCenterLinksResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListMerchantCenterLinksResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ListMerchantCenterLinksResponse;
                    })();

                    services.GetMerchantCenterLinkRequest = (function() {

                        /**
                         * Properties of a GetMerchantCenterLinkRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetMerchantCenterLinkRequest
                         * @property {string|null} [resourceName] GetMerchantCenterLinkRequest resourceName
                         */

                        /**
                         * Constructs a new GetMerchantCenterLinkRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetMerchantCenterLinkRequest.
                         * @implements IGetMerchantCenterLinkRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetMerchantCenterLinkRequest=} [properties] Properties to set
                         */
                        function GetMerchantCenterLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetMerchantCenterLinkRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetMerchantCenterLinkRequest
                         * @instance
                         */
                        GetMerchantCenterLinkRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetMerchantCenterLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetMerchantCenterLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetMerchantCenterLinkRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetMerchantCenterLinkRequest} GetMerchantCenterLinkRequest instance
                         */
                        GetMerchantCenterLinkRequest.create = function create(properties) {
                            return new GetMerchantCenterLinkRequest(properties);
                        };

                        /**
                         * Encodes the specified GetMerchantCenterLinkRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetMerchantCenterLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetMerchantCenterLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetMerchantCenterLinkRequest} message GetMerchantCenterLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetMerchantCenterLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetMerchantCenterLinkRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetMerchantCenterLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetMerchantCenterLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetMerchantCenterLinkRequest} message GetMerchantCenterLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetMerchantCenterLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetMerchantCenterLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetMerchantCenterLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetMerchantCenterLinkRequest} GetMerchantCenterLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetMerchantCenterLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetMerchantCenterLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetMerchantCenterLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetMerchantCenterLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetMerchantCenterLinkRequest} GetMerchantCenterLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetMerchantCenterLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetMerchantCenterLinkRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetMerchantCenterLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetMerchantCenterLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetMerchantCenterLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetMerchantCenterLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetMerchantCenterLinkRequest} GetMerchantCenterLinkRequest
                         */
                        GetMerchantCenterLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetMerchantCenterLinkRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetMerchantCenterLinkRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetMerchantCenterLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetMerchantCenterLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetMerchantCenterLinkRequest} message GetMerchantCenterLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetMerchantCenterLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetMerchantCenterLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetMerchantCenterLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetMerchantCenterLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetMerchantCenterLinkRequest;
                    })();

                    services.MutateMerchantCenterLinkRequest = (function() {

                        /**
                         * Properties of a MutateMerchantCenterLinkRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateMerchantCenterLinkRequest
                         * @property {string|null} [customerId] MutateMerchantCenterLinkRequest customerId
                         * @property {google.ads.googleads.v1.services.IMerchantCenterLinkOperation|null} [operation] MutateMerchantCenterLinkRequest operation
                         */

                        /**
                         * Constructs a new MutateMerchantCenterLinkRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateMerchantCenterLinkRequest.
                         * @implements IMutateMerchantCenterLinkRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateMerchantCenterLinkRequest=} [properties] Properties to set
                         */
                        function MutateMerchantCenterLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateMerchantCenterLinkRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest
                         * @instance
                         */
                        MutateMerchantCenterLinkRequest.prototype.customerId = "";

                        /**
                         * MutateMerchantCenterLinkRequest operation.
                         * @member {google.ads.googleads.v1.services.IMerchantCenterLinkOperation|null|undefined} operation
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest
                         * @instance
                         */
                        MutateMerchantCenterLinkRequest.prototype.operation = null;

                        /**
                         * Creates a new MutateMerchantCenterLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateMerchantCenterLinkRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest} MutateMerchantCenterLinkRequest instance
                         */
                        MutateMerchantCenterLinkRequest.create = function create(properties) {
                            return new MutateMerchantCenterLinkRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateMerchantCenterLinkRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateMerchantCenterLinkRequest} message MutateMerchantCenterLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateMerchantCenterLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                $root.google.ads.googleads.v1.services.MerchantCenterLinkOperation.encode(message.operation, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateMerchantCenterLinkRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateMerchantCenterLinkRequest} message MutateMerchantCenterLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateMerchantCenterLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateMerchantCenterLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest} MutateMerchantCenterLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateMerchantCenterLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    message.operation = $root.google.ads.googleads.v1.services.MerchantCenterLinkOperation.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateMerchantCenterLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest} MutateMerchantCenterLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateMerchantCenterLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateMerchantCenterLinkRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateMerchantCenterLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operation != null && message.hasOwnProperty("operation")) {
                                var error = $root.google.ads.googleads.v1.services.MerchantCenterLinkOperation.verify(message.operation);
                                if (error)
                                    return "operation." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateMerchantCenterLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest} MutateMerchantCenterLinkRequest
                         */
                        MutateMerchantCenterLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operation != null) {
                                if (typeof object.operation !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest.operation: object expected");
                                message.operation = $root.google.ads.googleads.v1.services.MerchantCenterLinkOperation.fromObject(object.operation);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateMerchantCenterLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest} message MutateMerchantCenterLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateMerchantCenterLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.customerId = "";
                                object.operation = null;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = $root.google.ads.googleads.v1.services.MerchantCenterLinkOperation.toObject(message.operation, options);
                            return object;
                        };

                        /**
                         * Converts this MutateMerchantCenterLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateMerchantCenterLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateMerchantCenterLinkRequest;
                    })();

                    services.MerchantCenterLinkOperation = (function() {

                        /**
                         * Properties of a MerchantCenterLinkOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMerchantCenterLinkOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] MerchantCenterLinkOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IMerchantCenterLink|null} [update] MerchantCenterLinkOperation update
                         * @property {string|null} [remove] MerchantCenterLinkOperation remove
                         */

                        /**
                         * Constructs a new MerchantCenterLinkOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MerchantCenterLinkOperation.
                         * @implements IMerchantCenterLinkOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMerchantCenterLinkOperation=} [properties] Properties to set
                         */
                        function MerchantCenterLinkOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MerchantCenterLinkOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkOperation
                         * @instance
                         */
                        MerchantCenterLinkOperation.prototype.updateMask = null;

                        /**
                         * MerchantCenterLinkOperation update.
                         * @member {google.ads.googleads.v1.resources.IMerchantCenterLink|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkOperation
                         * @instance
                         */
                        MerchantCenterLinkOperation.prototype.update = null;

                        /**
                         * MerchantCenterLinkOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkOperation
                         * @instance
                         */
                        MerchantCenterLinkOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * MerchantCenterLinkOperation operation.
                         * @member {"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkOperation
                         * @instance
                         */
                        Object.defineProperty(MerchantCenterLinkOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new MerchantCenterLinkOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IMerchantCenterLinkOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MerchantCenterLinkOperation} MerchantCenterLinkOperation instance
                         */
                        MerchantCenterLinkOperation.create = function create(properties) {
                            return new MerchantCenterLinkOperation(properties);
                        };

                        /**
                         * Encodes the specified MerchantCenterLinkOperation message. Does not implicitly {@link google.ads.googleads.v1.services.MerchantCenterLinkOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IMerchantCenterLinkOperation} message MerchantCenterLinkOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MerchantCenterLinkOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.MerchantCenterLink.encode(message.update, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MerchantCenterLinkOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MerchantCenterLinkOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IMerchantCenterLinkOperation} message MerchantCenterLinkOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MerchantCenterLinkOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MerchantCenterLinkOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MerchantCenterLinkOperation} MerchantCenterLinkOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MerchantCenterLinkOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MerchantCenterLinkOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.update = $root.google.ads.googleads.v1.resources.MerchantCenterLink.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MerchantCenterLinkOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MerchantCenterLinkOperation} MerchantCenterLinkOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MerchantCenterLinkOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MerchantCenterLinkOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MerchantCenterLinkOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.MerchantCenterLink.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a MerchantCenterLinkOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MerchantCenterLinkOperation} MerchantCenterLinkOperation
                         */
                        MerchantCenterLinkOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MerchantCenterLinkOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MerchantCenterLinkOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MerchantCenterLinkOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MerchantCenterLinkOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.MerchantCenterLink.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MerchantCenterLinkOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.MerchantCenterLinkOperation} message MerchantCenterLinkOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MerchantCenterLinkOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.MerchantCenterLink.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this MerchantCenterLinkOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MerchantCenterLinkOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MerchantCenterLinkOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MerchantCenterLinkOperation;
                    })();

                    services.MutateMerchantCenterLinkResponse = (function() {

                        /**
                         * Properties of a MutateMerchantCenterLinkResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateMerchantCenterLinkResponse
                         * @property {google.ads.googleads.v1.services.IMutateMerchantCenterLinkResult|null} [result] MutateMerchantCenterLinkResponse result
                         */

                        /**
                         * Constructs a new MutateMerchantCenterLinkResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateMerchantCenterLinkResponse.
                         * @implements IMutateMerchantCenterLinkResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateMerchantCenterLinkResponse=} [properties] Properties to set
                         */
                        function MutateMerchantCenterLinkResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateMerchantCenterLinkResponse result.
                         * @member {google.ads.googleads.v1.services.IMutateMerchantCenterLinkResult|null|undefined} result
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse
                         * @instance
                         */
                        MutateMerchantCenterLinkResponse.prototype.result = null;

                        /**
                         * Creates a new MutateMerchantCenterLinkResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateMerchantCenterLinkResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse} MutateMerchantCenterLinkResponse instance
                         */
                        MutateMerchantCenterLinkResponse.create = function create(properties) {
                            return new MutateMerchantCenterLinkResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateMerchantCenterLinkResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateMerchantCenterLinkResponse} message MutateMerchantCenterLinkResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateMerchantCenterLinkResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.result != null && message.hasOwnProperty("result"))
                                $root.google.ads.googleads.v1.services.MutateMerchantCenterLinkResult.encode(message.result, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateMerchantCenterLinkResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateMerchantCenterLinkResponse} message MutateMerchantCenterLinkResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateMerchantCenterLinkResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateMerchantCenterLinkResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse} MutateMerchantCenterLinkResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateMerchantCenterLinkResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2:
                                    message.result = $root.google.ads.googleads.v1.services.MutateMerchantCenterLinkResult.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateMerchantCenterLinkResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse} MutateMerchantCenterLinkResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateMerchantCenterLinkResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateMerchantCenterLinkResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateMerchantCenterLinkResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.result != null && message.hasOwnProperty("result")) {
                                var error = $root.google.ads.googleads.v1.services.MutateMerchantCenterLinkResult.verify(message.result);
                                if (error)
                                    return "result." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateMerchantCenterLinkResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse} MutateMerchantCenterLinkResponse
                         */
                        MutateMerchantCenterLinkResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse();
                            if (object.result != null) {
                                if (typeof object.result !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse.result: object expected");
                                message.result = $root.google.ads.googleads.v1.services.MutateMerchantCenterLinkResult.fromObject(object.result);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateMerchantCenterLinkResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse} message MutateMerchantCenterLinkResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateMerchantCenterLinkResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.result = null;
                            if (message.result != null && message.hasOwnProperty("result"))
                                object.result = $root.google.ads.googleads.v1.services.MutateMerchantCenterLinkResult.toObject(message.result, options);
                            return object;
                        };

                        /**
                         * Converts this MutateMerchantCenterLinkResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateMerchantCenterLinkResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateMerchantCenterLinkResponse;
                    })();

                    services.MutateMerchantCenterLinkResult = (function() {

                        /**
                         * Properties of a MutateMerchantCenterLinkResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateMerchantCenterLinkResult
                         * @property {string|null} [resourceName] MutateMerchantCenterLinkResult resourceName
                         */

                        /**
                         * Constructs a new MutateMerchantCenterLinkResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateMerchantCenterLinkResult.
                         * @implements IMutateMerchantCenterLinkResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateMerchantCenterLinkResult=} [properties] Properties to set
                         */
                        function MutateMerchantCenterLinkResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateMerchantCenterLinkResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResult
                         * @instance
                         */
                        MutateMerchantCenterLinkResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateMerchantCenterLinkResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateMerchantCenterLinkResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateMerchantCenterLinkResult} MutateMerchantCenterLinkResult instance
                         */
                        MutateMerchantCenterLinkResult.create = function create(properties) {
                            return new MutateMerchantCenterLinkResult(properties);
                        };

                        /**
                         * Encodes the specified MutateMerchantCenterLinkResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateMerchantCenterLinkResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateMerchantCenterLinkResult} message MutateMerchantCenterLinkResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateMerchantCenterLinkResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateMerchantCenterLinkResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateMerchantCenterLinkResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateMerchantCenterLinkResult} message MutateMerchantCenterLinkResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateMerchantCenterLinkResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateMerchantCenterLinkResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateMerchantCenterLinkResult} MutateMerchantCenterLinkResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateMerchantCenterLinkResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateMerchantCenterLinkResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateMerchantCenterLinkResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateMerchantCenterLinkResult} MutateMerchantCenterLinkResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateMerchantCenterLinkResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateMerchantCenterLinkResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateMerchantCenterLinkResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateMerchantCenterLinkResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateMerchantCenterLinkResult} MutateMerchantCenterLinkResult
                         */
                        MutateMerchantCenterLinkResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateMerchantCenterLinkResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateMerchantCenterLinkResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateMerchantCenterLinkResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateMerchantCenterLinkResult} message MutateMerchantCenterLinkResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateMerchantCenterLinkResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateMerchantCenterLinkResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateMerchantCenterLinkResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateMerchantCenterLinkResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateMerchantCenterLinkResult;
                    })();

                    services.MobileAppCategoryConstantService = (function() {

                        /**
                         * Constructs a new MobileAppCategoryConstantService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MobileAppCategoryConstantService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function MobileAppCategoryConstantService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (MobileAppCategoryConstantService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = MobileAppCategoryConstantService;

                        /**
                         * Creates new MobileAppCategoryConstantService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MobileAppCategoryConstantService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {MobileAppCategoryConstantService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        MobileAppCategoryConstantService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.MobileAppCategoryConstantService#getMobileAppCategoryConstant}.
                         * @memberof google.ads.googleads.v1.services.MobileAppCategoryConstantService
                         * @typedef GetMobileAppCategoryConstantCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.MobileAppCategoryConstant} [response] MobileAppCategoryConstant
                         */

                        /**
                         * Calls GetMobileAppCategoryConstant.
                         * @function getMobileAppCategoryConstant
                         * @memberof google.ads.googleads.v1.services.MobileAppCategoryConstantService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetMobileAppCategoryConstantRequest} request GetMobileAppCategoryConstantRequest message or plain object
                         * @param {google.ads.googleads.v1.services.MobileAppCategoryConstantService.GetMobileAppCategoryConstantCallback} callback Node-style callback called with the error, if any, and MobileAppCategoryConstant
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MobileAppCategoryConstantService.prototype.getMobileAppCategoryConstant = function getMobileAppCategoryConstant(request, callback) {
                            return this.rpcCall(getMobileAppCategoryConstant, $root.google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest, $root.google.ads.googleads.v1.resources.MobileAppCategoryConstant, request, callback);
                        }, "name", { value: "GetMobileAppCategoryConstant" });

                        /**
                         * Calls GetMobileAppCategoryConstant.
                         * @function getMobileAppCategoryConstant
                         * @memberof google.ads.googleads.v1.services.MobileAppCategoryConstantService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetMobileAppCategoryConstantRequest} request GetMobileAppCategoryConstantRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.MobileAppCategoryConstant>} Promise
                         * @variation 2
                         */

                        return MobileAppCategoryConstantService;
                    })();

                    services.GetMobileAppCategoryConstantRequest = (function() {

                        /**
                         * Properties of a GetMobileAppCategoryConstantRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetMobileAppCategoryConstantRequest
                         * @property {string|null} [resourceName] GetMobileAppCategoryConstantRequest resourceName
                         */

                        /**
                         * Constructs a new GetMobileAppCategoryConstantRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetMobileAppCategoryConstantRequest.
                         * @implements IGetMobileAppCategoryConstantRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetMobileAppCategoryConstantRequest=} [properties] Properties to set
                         */
                        function GetMobileAppCategoryConstantRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetMobileAppCategoryConstantRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest
                         * @instance
                         */
                        GetMobileAppCategoryConstantRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetMobileAppCategoryConstantRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetMobileAppCategoryConstantRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest} GetMobileAppCategoryConstantRequest instance
                         */
                        GetMobileAppCategoryConstantRequest.create = function create(properties) {
                            return new GetMobileAppCategoryConstantRequest(properties);
                        };

                        /**
                         * Encodes the specified GetMobileAppCategoryConstantRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetMobileAppCategoryConstantRequest} message GetMobileAppCategoryConstantRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetMobileAppCategoryConstantRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetMobileAppCategoryConstantRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetMobileAppCategoryConstantRequest} message GetMobileAppCategoryConstantRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetMobileAppCategoryConstantRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetMobileAppCategoryConstantRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest} GetMobileAppCategoryConstantRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetMobileAppCategoryConstantRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetMobileAppCategoryConstantRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest} GetMobileAppCategoryConstantRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetMobileAppCategoryConstantRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetMobileAppCategoryConstantRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetMobileAppCategoryConstantRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetMobileAppCategoryConstantRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest} GetMobileAppCategoryConstantRequest
                         */
                        GetMobileAppCategoryConstantRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetMobileAppCategoryConstantRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest} message GetMobileAppCategoryConstantRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetMobileAppCategoryConstantRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetMobileAppCategoryConstantRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetMobileAppCategoryConstantRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetMobileAppCategoryConstantRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetMobileAppCategoryConstantRequest;
                    })();

                    services.MobileDeviceConstantService = (function() {

                        /**
                         * Constructs a new MobileDeviceConstantService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MobileDeviceConstantService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function MobileDeviceConstantService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (MobileDeviceConstantService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = MobileDeviceConstantService;

                        /**
                         * Creates new MobileDeviceConstantService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MobileDeviceConstantService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {MobileDeviceConstantService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        MobileDeviceConstantService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.MobileDeviceConstantService#getMobileDeviceConstant}.
                         * @memberof google.ads.googleads.v1.services.MobileDeviceConstantService
                         * @typedef GetMobileDeviceConstantCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.MobileDeviceConstant} [response] MobileDeviceConstant
                         */

                        /**
                         * Calls GetMobileDeviceConstant.
                         * @function getMobileDeviceConstant
                         * @memberof google.ads.googleads.v1.services.MobileDeviceConstantService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetMobileDeviceConstantRequest} request GetMobileDeviceConstantRequest message or plain object
                         * @param {google.ads.googleads.v1.services.MobileDeviceConstantService.GetMobileDeviceConstantCallback} callback Node-style callback called with the error, if any, and MobileDeviceConstant
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MobileDeviceConstantService.prototype.getMobileDeviceConstant = function getMobileDeviceConstant(request, callback) {
                            return this.rpcCall(getMobileDeviceConstant, $root.google.ads.googleads.v1.services.GetMobileDeviceConstantRequest, $root.google.ads.googleads.v1.resources.MobileDeviceConstant, request, callback);
                        }, "name", { value: "GetMobileDeviceConstant" });

                        /**
                         * Calls GetMobileDeviceConstant.
                         * @function getMobileDeviceConstant
                         * @memberof google.ads.googleads.v1.services.MobileDeviceConstantService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetMobileDeviceConstantRequest} request GetMobileDeviceConstantRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.MobileDeviceConstant>} Promise
                         * @variation 2
                         */

                        return MobileDeviceConstantService;
                    })();

                    services.GetMobileDeviceConstantRequest = (function() {

                        /**
                         * Properties of a GetMobileDeviceConstantRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetMobileDeviceConstantRequest
                         * @property {string|null} [resourceName] GetMobileDeviceConstantRequest resourceName
                         */

                        /**
                         * Constructs a new GetMobileDeviceConstantRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetMobileDeviceConstantRequest.
                         * @implements IGetMobileDeviceConstantRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetMobileDeviceConstantRequest=} [properties] Properties to set
                         */
                        function GetMobileDeviceConstantRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetMobileDeviceConstantRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetMobileDeviceConstantRequest
                         * @instance
                         */
                        GetMobileDeviceConstantRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetMobileDeviceConstantRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetMobileDeviceConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetMobileDeviceConstantRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetMobileDeviceConstantRequest} GetMobileDeviceConstantRequest instance
                         */
                        GetMobileDeviceConstantRequest.create = function create(properties) {
                            return new GetMobileDeviceConstantRequest(properties);
                        };

                        /**
                         * Encodes the specified GetMobileDeviceConstantRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetMobileDeviceConstantRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetMobileDeviceConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetMobileDeviceConstantRequest} message GetMobileDeviceConstantRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetMobileDeviceConstantRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetMobileDeviceConstantRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetMobileDeviceConstantRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetMobileDeviceConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetMobileDeviceConstantRequest} message GetMobileDeviceConstantRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetMobileDeviceConstantRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetMobileDeviceConstantRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetMobileDeviceConstantRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetMobileDeviceConstantRequest} GetMobileDeviceConstantRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetMobileDeviceConstantRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetMobileDeviceConstantRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetMobileDeviceConstantRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetMobileDeviceConstantRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetMobileDeviceConstantRequest} GetMobileDeviceConstantRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetMobileDeviceConstantRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetMobileDeviceConstantRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetMobileDeviceConstantRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetMobileDeviceConstantRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetMobileDeviceConstantRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetMobileDeviceConstantRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetMobileDeviceConstantRequest} GetMobileDeviceConstantRequest
                         */
                        GetMobileDeviceConstantRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetMobileDeviceConstantRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetMobileDeviceConstantRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetMobileDeviceConstantRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetMobileDeviceConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetMobileDeviceConstantRequest} message GetMobileDeviceConstantRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetMobileDeviceConstantRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetMobileDeviceConstantRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetMobileDeviceConstantRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetMobileDeviceConstantRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetMobileDeviceConstantRequest;
                    })();

                    services.MutateJobService = (function() {

                        /**
                         * Constructs a new MutateJobService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateJobService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function MutateJobService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (MutateJobService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = MutateJobService;

                        /**
                         * Creates new MutateJobService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateJobService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {MutateJobService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        MutateJobService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.MutateJobService#createMutateJob}.
                         * @memberof google.ads.googleads.v1.services.MutateJobService
                         * @typedef CreateMutateJobCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.CreateMutateJobResponse} [response] CreateMutateJobResponse
                         */

                        /**
                         * Calls CreateMutateJob.
                         * @function createMutateJob
                         * @memberof google.ads.googleads.v1.services.MutateJobService
                         * @instance
                         * @param {google.ads.googleads.v1.services.ICreateMutateJobRequest} request CreateMutateJobRequest message or plain object
                         * @param {google.ads.googleads.v1.services.MutateJobService.CreateMutateJobCallback} callback Node-style callback called with the error, if any, and CreateMutateJobResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MutateJobService.prototype.createMutateJob = function createMutateJob(request, callback) {
                            return this.rpcCall(createMutateJob, $root.google.ads.googleads.v1.services.CreateMutateJobRequest, $root.google.ads.googleads.v1.services.CreateMutateJobResponse, request, callback);
                        }, "name", { value: "CreateMutateJob" });

                        /**
                         * Calls CreateMutateJob.
                         * @function createMutateJob
                         * @memberof google.ads.googleads.v1.services.MutateJobService
                         * @instance
                         * @param {google.ads.googleads.v1.services.ICreateMutateJobRequest} request CreateMutateJobRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.CreateMutateJobResponse>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.MutateJobService#getMutateJob}.
                         * @memberof google.ads.googleads.v1.services.MutateJobService
                         * @typedef GetMutateJobCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.MutateJob} [response] MutateJob
                         */

                        /**
                         * Calls GetMutateJob.
                         * @function getMutateJob
                         * @memberof google.ads.googleads.v1.services.MutateJobService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetMutateJobRequest} request GetMutateJobRequest message or plain object
                         * @param {google.ads.googleads.v1.services.MutateJobService.GetMutateJobCallback} callback Node-style callback called with the error, if any, and MutateJob
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MutateJobService.prototype.getMutateJob = function getMutateJob(request, callback) {
                            return this.rpcCall(getMutateJob, $root.google.ads.googleads.v1.services.GetMutateJobRequest, $root.google.ads.googleads.v1.resources.MutateJob, request, callback);
                        }, "name", { value: "GetMutateJob" });

                        /**
                         * Calls GetMutateJob.
                         * @function getMutateJob
                         * @memberof google.ads.googleads.v1.services.MutateJobService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetMutateJobRequest} request GetMutateJobRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.MutateJob>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.MutateJobService#listMutateJobResults}.
                         * @memberof google.ads.googleads.v1.services.MutateJobService
                         * @typedef ListMutateJobResultsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.ListMutateJobResultsResponse} [response] ListMutateJobResultsResponse
                         */

                        /**
                         * Calls ListMutateJobResults.
                         * @function listMutateJobResults
                         * @memberof google.ads.googleads.v1.services.MutateJobService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IListMutateJobResultsRequest} request ListMutateJobResultsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.MutateJobService.ListMutateJobResultsCallback} callback Node-style callback called with the error, if any, and ListMutateJobResultsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MutateJobService.prototype.listMutateJobResults = function listMutateJobResults(request, callback) {
                            return this.rpcCall(listMutateJobResults, $root.google.ads.googleads.v1.services.ListMutateJobResultsRequest, $root.google.ads.googleads.v1.services.ListMutateJobResultsResponse, request, callback);
                        }, "name", { value: "ListMutateJobResults" });

                        /**
                         * Calls ListMutateJobResults.
                         * @function listMutateJobResults
                         * @memberof google.ads.googleads.v1.services.MutateJobService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IListMutateJobResultsRequest} request ListMutateJobResultsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.ListMutateJobResultsResponse>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.MutateJobService#runMutateJob}.
                         * @memberof google.ads.googleads.v1.services.MutateJobService
                         * @typedef RunMutateJobCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.longrunning.Operation} [response] Operation
                         */

                        /**
                         * Calls RunMutateJob.
                         * @function runMutateJob
                         * @memberof google.ads.googleads.v1.services.MutateJobService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IRunMutateJobRequest} request RunMutateJobRequest message or plain object
                         * @param {google.ads.googleads.v1.services.MutateJobService.RunMutateJobCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MutateJobService.prototype.runMutateJob = function runMutateJob(request, callback) {
                            return this.rpcCall(runMutateJob, $root.google.ads.googleads.v1.services.RunMutateJobRequest, $root.google.longrunning.Operation, request, callback);
                        }, "name", { value: "RunMutateJob" });

                        /**
                         * Calls RunMutateJob.
                         * @function runMutateJob
                         * @memberof google.ads.googleads.v1.services.MutateJobService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IRunMutateJobRequest} request RunMutateJobRequest message or plain object
                         * @returns {Promise<google.longrunning.Operation>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.MutateJobService#addMutateJobOperations}.
                         * @memberof google.ads.googleads.v1.services.MutateJobService
                         * @typedef AddMutateJobOperationsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.AddMutateJobOperationsResponse} [response] AddMutateJobOperationsResponse
                         */

                        /**
                         * Calls AddMutateJobOperations.
                         * @function addMutateJobOperations
                         * @memberof google.ads.googleads.v1.services.MutateJobService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IAddMutateJobOperationsRequest} request AddMutateJobOperationsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.MutateJobService.AddMutateJobOperationsCallback} callback Node-style callback called with the error, if any, and AddMutateJobOperationsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MutateJobService.prototype.addMutateJobOperations = function addMutateJobOperations(request, callback) {
                            return this.rpcCall(addMutateJobOperations, $root.google.ads.googleads.v1.services.AddMutateJobOperationsRequest, $root.google.ads.googleads.v1.services.AddMutateJobOperationsResponse, request, callback);
                        }, "name", { value: "AddMutateJobOperations" });

                        /**
                         * Calls AddMutateJobOperations.
                         * @function addMutateJobOperations
                         * @memberof google.ads.googleads.v1.services.MutateJobService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IAddMutateJobOperationsRequest} request AddMutateJobOperationsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.AddMutateJobOperationsResponse>} Promise
                         * @variation 2
                         */

                        return MutateJobService;
                    })();

                    services.CreateMutateJobRequest = (function() {

                        /**
                         * Properties of a CreateMutateJobRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICreateMutateJobRequest
                         * @property {string|null} [customerId] CreateMutateJobRequest customerId
                         */

                        /**
                         * Constructs a new CreateMutateJobRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CreateMutateJobRequest.
                         * @implements ICreateMutateJobRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICreateMutateJobRequest=} [properties] Properties to set
                         */
                        function CreateMutateJobRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CreateMutateJobRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobRequest
                         * @instance
                         */
                        CreateMutateJobRequest.prototype.customerId = "";

                        /**
                         * Creates a new CreateMutateJobRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ICreateMutateJobRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CreateMutateJobRequest} CreateMutateJobRequest instance
                         */
                        CreateMutateJobRequest.create = function create(properties) {
                            return new CreateMutateJobRequest(properties);
                        };

                        /**
                         * Encodes the specified CreateMutateJobRequest message. Does not implicitly {@link google.ads.googleads.v1.services.CreateMutateJobRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ICreateMutateJobRequest} message CreateMutateJobRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateMutateJobRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            return writer;
                        };

                        /**
                         * Encodes the specified CreateMutateJobRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CreateMutateJobRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ICreateMutateJobRequest} message CreateMutateJobRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateMutateJobRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CreateMutateJobRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CreateMutateJobRequest} CreateMutateJobRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateMutateJobRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CreateMutateJobRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CreateMutateJobRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CreateMutateJobRequest} CreateMutateJobRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateMutateJobRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CreateMutateJobRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateMutateJobRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            return null;
                        };

                        /**
                         * Creates a CreateMutateJobRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CreateMutateJobRequest} CreateMutateJobRequest
                         */
                        CreateMutateJobRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CreateMutateJobRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CreateMutateJobRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            return message;
                        };

                        /**
                         * Creates a plain object from a CreateMutateJobRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.CreateMutateJobRequest} message CreateMutateJobRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateMutateJobRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.customerId = "";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            return object;
                        };

                        /**
                         * Converts this CreateMutateJobRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateMutateJobRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CreateMutateJobRequest;
                    })();

                    services.CreateMutateJobResponse = (function() {

                        /**
                         * Properties of a CreateMutateJobResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ICreateMutateJobResponse
                         * @property {string|null} [resourceName] CreateMutateJobResponse resourceName
                         */

                        /**
                         * Constructs a new CreateMutateJobResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a CreateMutateJobResponse.
                         * @implements ICreateMutateJobResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ICreateMutateJobResponse=} [properties] Properties to set
                         */
                        function CreateMutateJobResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * CreateMutateJobResponse resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobResponse
                         * @instance
                         */
                        CreateMutateJobResponse.prototype.resourceName = "";

                        /**
                         * Creates a new CreateMutateJobResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ICreateMutateJobResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.CreateMutateJobResponse} CreateMutateJobResponse instance
                         */
                        CreateMutateJobResponse.create = function create(properties) {
                            return new CreateMutateJobResponse(properties);
                        };

                        /**
                         * Encodes the specified CreateMutateJobResponse message. Does not implicitly {@link google.ads.googleads.v1.services.CreateMutateJobResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ICreateMutateJobResponse} message CreateMutateJobResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateMutateJobResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified CreateMutateJobResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.CreateMutateJobResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ICreateMutateJobResponse} message CreateMutateJobResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateMutateJobResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a CreateMutateJobResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.CreateMutateJobResponse} CreateMutateJobResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateMutateJobResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.CreateMutateJobResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a CreateMutateJobResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.CreateMutateJobResponse} CreateMutateJobResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateMutateJobResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a CreateMutateJobResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateMutateJobResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a CreateMutateJobResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.CreateMutateJobResponse} CreateMutateJobResponse
                         */
                        CreateMutateJobResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.CreateMutateJobResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.CreateMutateJobResponse();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a CreateMutateJobResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.CreateMutateJobResponse} message CreateMutateJobResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateMutateJobResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this CreateMutateJobResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.CreateMutateJobResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateMutateJobResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return CreateMutateJobResponse;
                    })();

                    services.GetMutateJobRequest = (function() {

                        /**
                         * Properties of a GetMutateJobRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetMutateJobRequest
                         * @property {string|null} [resourceName] GetMutateJobRequest resourceName
                         */

                        /**
                         * Constructs a new GetMutateJobRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetMutateJobRequest.
                         * @implements IGetMutateJobRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetMutateJobRequest=} [properties] Properties to set
                         */
                        function GetMutateJobRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetMutateJobRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetMutateJobRequest
                         * @instance
                         */
                        GetMutateJobRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetMutateJobRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetMutateJobRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetMutateJobRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetMutateJobRequest} GetMutateJobRequest instance
                         */
                        GetMutateJobRequest.create = function create(properties) {
                            return new GetMutateJobRequest(properties);
                        };

                        /**
                         * Encodes the specified GetMutateJobRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetMutateJobRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetMutateJobRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetMutateJobRequest} message GetMutateJobRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetMutateJobRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetMutateJobRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetMutateJobRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetMutateJobRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetMutateJobRequest} message GetMutateJobRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetMutateJobRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetMutateJobRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetMutateJobRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetMutateJobRequest} GetMutateJobRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetMutateJobRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetMutateJobRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetMutateJobRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetMutateJobRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetMutateJobRequest} GetMutateJobRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetMutateJobRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetMutateJobRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetMutateJobRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetMutateJobRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetMutateJobRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetMutateJobRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetMutateJobRequest} GetMutateJobRequest
                         */
                        GetMutateJobRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetMutateJobRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetMutateJobRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetMutateJobRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetMutateJobRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetMutateJobRequest} message GetMutateJobRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetMutateJobRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetMutateJobRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetMutateJobRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetMutateJobRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetMutateJobRequest;
                    })();

                    services.RunMutateJobRequest = (function() {

                        /**
                         * Properties of a RunMutateJobRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IRunMutateJobRequest
                         * @property {string|null} [resourceName] RunMutateJobRequest resourceName
                         */

                        /**
                         * Constructs a new RunMutateJobRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a RunMutateJobRequest.
                         * @implements IRunMutateJobRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IRunMutateJobRequest=} [properties] Properties to set
                         */
                        function RunMutateJobRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * RunMutateJobRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.RunMutateJobRequest
                         * @instance
                         */
                        RunMutateJobRequest.prototype.resourceName = "";

                        /**
                         * Creates a new RunMutateJobRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.RunMutateJobRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IRunMutateJobRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.RunMutateJobRequest} RunMutateJobRequest instance
                         */
                        RunMutateJobRequest.create = function create(properties) {
                            return new RunMutateJobRequest(properties);
                        };

                        /**
                         * Encodes the specified RunMutateJobRequest message. Does not implicitly {@link google.ads.googleads.v1.services.RunMutateJobRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.RunMutateJobRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IRunMutateJobRequest} message RunMutateJobRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RunMutateJobRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified RunMutateJobRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.RunMutateJobRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.RunMutateJobRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IRunMutateJobRequest} message RunMutateJobRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RunMutateJobRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a RunMutateJobRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.RunMutateJobRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.RunMutateJobRequest} RunMutateJobRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RunMutateJobRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.RunMutateJobRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a RunMutateJobRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.RunMutateJobRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.RunMutateJobRequest} RunMutateJobRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RunMutateJobRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a RunMutateJobRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.RunMutateJobRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RunMutateJobRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a RunMutateJobRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.RunMutateJobRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.RunMutateJobRequest} RunMutateJobRequest
                         */
                        RunMutateJobRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.RunMutateJobRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.RunMutateJobRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a RunMutateJobRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.RunMutateJobRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.RunMutateJobRequest} message RunMutateJobRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RunMutateJobRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this RunMutateJobRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.RunMutateJobRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RunMutateJobRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return RunMutateJobRequest;
                    })();

                    services.AddMutateJobOperationsRequest = (function() {

                        /**
                         * Properties of an AddMutateJobOperationsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IAddMutateJobOperationsRequest
                         * @property {string|null} [resourceName] AddMutateJobOperationsRequest resourceName
                         * @property {string|null} [sequenceToken] AddMutateJobOperationsRequest sequenceToken
                         * @property {Array.<google.ads.googleads.v1.services.IMutateOperation>|null} [mutateOperations] AddMutateJobOperationsRequest mutateOperations
                         */

                        /**
                         * Constructs a new AddMutateJobOperationsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AddMutateJobOperationsRequest.
                         * @implements IAddMutateJobOperationsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IAddMutateJobOperationsRequest=} [properties] Properties to set
                         */
                        function AddMutateJobOperationsRequest(properties) {
                            this.mutateOperations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AddMutateJobOperationsRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsRequest
                         * @instance
                         */
                        AddMutateJobOperationsRequest.prototype.resourceName = "";

                        /**
                         * AddMutateJobOperationsRequest sequenceToken.
                         * @member {string} sequenceToken
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsRequest
                         * @instance
                         */
                        AddMutateJobOperationsRequest.prototype.sequenceToken = "";

                        /**
                         * AddMutateJobOperationsRequest mutateOperations.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateOperation>} mutateOperations
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsRequest
                         * @instance
                         */
                        AddMutateJobOperationsRequest.prototype.mutateOperations = $util.emptyArray;

                        /**
                         * Creates a new AddMutateJobOperationsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IAddMutateJobOperationsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.AddMutateJobOperationsRequest} AddMutateJobOperationsRequest instance
                         */
                        AddMutateJobOperationsRequest.create = function create(properties) {
                            return new AddMutateJobOperationsRequest(properties);
                        };

                        /**
                         * Encodes the specified AddMutateJobOperationsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.AddMutateJobOperationsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IAddMutateJobOperationsRequest} message AddMutateJobOperationsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddMutateJobOperationsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.sequenceToken != null && message.hasOwnProperty("sequenceToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.sequenceToken);
                            if (message.mutateOperations != null && message.mutateOperations.length)
                                for (var i = 0; i < message.mutateOperations.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateOperation.encode(message.mutateOperations[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified AddMutateJobOperationsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.AddMutateJobOperationsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IAddMutateJobOperationsRequest} message AddMutateJobOperationsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddMutateJobOperationsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AddMutateJobOperationsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.AddMutateJobOperationsRequest} AddMutateJobOperationsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddMutateJobOperationsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.AddMutateJobOperationsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.sequenceToken = reader.string();
                                    break;
                                case 3:
                                    if (!(message.mutateOperations && message.mutateOperations.length))
                                        message.mutateOperations = [];
                                    message.mutateOperations.push($root.google.ads.googleads.v1.services.MutateOperation.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AddMutateJobOperationsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.AddMutateJobOperationsRequest} AddMutateJobOperationsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddMutateJobOperationsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AddMutateJobOperationsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddMutateJobOperationsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.sequenceToken != null && message.hasOwnProperty("sequenceToken"))
                                if (!$util.isString(message.sequenceToken))
                                    return "sequenceToken: string expected";
                            if (message.mutateOperations != null && message.hasOwnProperty("mutateOperations")) {
                                if (!Array.isArray(message.mutateOperations))
                                    return "mutateOperations: array expected";
                                for (var i = 0; i < message.mutateOperations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateOperation.verify(message.mutateOperations[i]);
                                    if (error)
                                        return "mutateOperations." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an AddMutateJobOperationsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.AddMutateJobOperationsRequest} AddMutateJobOperationsRequest
                         */
                        AddMutateJobOperationsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.AddMutateJobOperationsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.AddMutateJobOperationsRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.sequenceToken != null)
                                message.sequenceToken = String(object.sequenceToken);
                            if (object.mutateOperations) {
                                if (!Array.isArray(object.mutateOperations))
                                    throw TypeError(".google.ads.googleads.v1.services.AddMutateJobOperationsRequest.mutateOperations: array expected");
                                message.mutateOperations = [];
                                for (var i = 0; i < object.mutateOperations.length; ++i) {
                                    if (typeof object.mutateOperations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.AddMutateJobOperationsRequest.mutateOperations: object expected");
                                    message.mutateOperations[i] = $root.google.ads.googleads.v1.services.MutateOperation.fromObject(object.mutateOperations[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an AddMutateJobOperationsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.AddMutateJobOperationsRequest} message AddMutateJobOperationsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddMutateJobOperationsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.mutateOperations = [];
                            if (options.defaults) {
                                object.resourceName = "";
                                object.sequenceToken = "";
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.sequenceToken != null && message.hasOwnProperty("sequenceToken"))
                                object.sequenceToken = message.sequenceToken;
                            if (message.mutateOperations && message.mutateOperations.length) {
                                object.mutateOperations = [];
                                for (var j = 0; j < message.mutateOperations.length; ++j)
                                    object.mutateOperations[j] = $root.google.ads.googleads.v1.services.MutateOperation.toObject(message.mutateOperations[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this AddMutateJobOperationsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddMutateJobOperationsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AddMutateJobOperationsRequest;
                    })();

                    services.AddMutateJobOperationsResponse = (function() {

                        /**
                         * Properties of an AddMutateJobOperationsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IAddMutateJobOperationsResponse
                         * @property {number|Long|null} [totalOperations] AddMutateJobOperationsResponse totalOperations
                         * @property {string|null} [nextSequenceToken] AddMutateJobOperationsResponse nextSequenceToken
                         */

                        /**
                         * Constructs a new AddMutateJobOperationsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an AddMutateJobOperationsResponse.
                         * @implements IAddMutateJobOperationsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IAddMutateJobOperationsResponse=} [properties] Properties to set
                         */
                        function AddMutateJobOperationsResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * AddMutateJobOperationsResponse totalOperations.
                         * @member {number|Long} totalOperations
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsResponse
                         * @instance
                         */
                        AddMutateJobOperationsResponse.prototype.totalOperations = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

                        /**
                         * AddMutateJobOperationsResponse nextSequenceToken.
                         * @member {string} nextSequenceToken
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsResponse
                         * @instance
                         */
                        AddMutateJobOperationsResponse.prototype.nextSequenceToken = "";

                        /**
                         * Creates a new AddMutateJobOperationsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IAddMutateJobOperationsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.AddMutateJobOperationsResponse} AddMutateJobOperationsResponse instance
                         */
                        AddMutateJobOperationsResponse.create = function create(properties) {
                            return new AddMutateJobOperationsResponse(properties);
                        };

                        /**
                         * Encodes the specified AddMutateJobOperationsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.AddMutateJobOperationsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IAddMutateJobOperationsResponse} message AddMutateJobOperationsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddMutateJobOperationsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.totalOperations != null && message.hasOwnProperty("totalOperations"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int64(message.totalOperations);
                            if (message.nextSequenceToken != null && message.hasOwnProperty("nextSequenceToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextSequenceToken);
                            return writer;
                        };

                        /**
                         * Encodes the specified AddMutateJobOperationsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.AddMutateJobOperationsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IAddMutateJobOperationsResponse} message AddMutateJobOperationsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddMutateJobOperationsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an AddMutateJobOperationsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.AddMutateJobOperationsResponse} AddMutateJobOperationsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddMutateJobOperationsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.AddMutateJobOperationsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.totalOperations = reader.int64();
                                    break;
                                case 2:
                                    message.nextSequenceToken = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an AddMutateJobOperationsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.AddMutateJobOperationsResponse} AddMutateJobOperationsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddMutateJobOperationsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an AddMutateJobOperationsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddMutateJobOperationsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.totalOperations != null && message.hasOwnProperty("totalOperations"))
                                if (!$util.isInteger(message.totalOperations) && !(message.totalOperations && $util.isInteger(message.totalOperations.low) && $util.isInteger(message.totalOperations.high)))
                                    return "totalOperations: integer|Long expected";
                            if (message.nextSequenceToken != null && message.hasOwnProperty("nextSequenceToken"))
                                if (!$util.isString(message.nextSequenceToken))
                                    return "nextSequenceToken: string expected";
                            return null;
                        };

                        /**
                         * Creates an AddMutateJobOperationsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.AddMutateJobOperationsResponse} AddMutateJobOperationsResponse
                         */
                        AddMutateJobOperationsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.AddMutateJobOperationsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.AddMutateJobOperationsResponse();
                            if (object.totalOperations != null)
                                if ($util.Long)
                                    (message.totalOperations = $util.Long.fromValue(object.totalOperations)).unsigned = false;
                                else if (typeof object.totalOperations === "string")
                                    message.totalOperations = parseInt(object.totalOperations, 10);
                                else if (typeof object.totalOperations === "number")
                                    message.totalOperations = object.totalOperations;
                                else if (typeof object.totalOperations === "object")
                                    message.totalOperations = new $util.LongBits(object.totalOperations.low >>> 0, object.totalOperations.high >>> 0).toNumber();
                            if (object.nextSequenceToken != null)
                                message.nextSequenceToken = String(object.nextSequenceToken);
                            return message;
                        };

                        /**
                         * Creates a plain object from an AddMutateJobOperationsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.AddMutateJobOperationsResponse} message AddMutateJobOperationsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddMutateJobOperationsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                if ($util.Long) {
                                    var long = new $util.Long(0, 0, false);
                                    object.totalOperations = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                                } else
                                    object.totalOperations = options.longs === String ? "0" : 0;
                                object.nextSequenceToken = "";
                            }
                            if (message.totalOperations != null && message.hasOwnProperty("totalOperations"))
                                if (typeof message.totalOperations === "number")
                                    object.totalOperations = options.longs === String ? String(message.totalOperations) : message.totalOperations;
                                else
                                    object.totalOperations = options.longs === String ? $util.Long.prototype.toString.call(message.totalOperations) : options.longs === Number ? new $util.LongBits(message.totalOperations.low >>> 0, message.totalOperations.high >>> 0).toNumber() : message.totalOperations;
                            if (message.nextSequenceToken != null && message.hasOwnProperty("nextSequenceToken"))
                                object.nextSequenceToken = message.nextSequenceToken;
                            return object;
                        };

                        /**
                         * Converts this AddMutateJobOperationsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.AddMutateJobOperationsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddMutateJobOperationsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return AddMutateJobOperationsResponse;
                    })();

                    services.ListMutateJobResultsRequest = (function() {

                        /**
                         * Properties of a ListMutateJobResultsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IListMutateJobResultsRequest
                         * @property {string|null} [resourceName] ListMutateJobResultsRequest resourceName
                         * @property {string|null} [pageToken] ListMutateJobResultsRequest pageToken
                         * @property {number|null} [pageSize] ListMutateJobResultsRequest pageSize
                         */

                        /**
                         * Constructs a new ListMutateJobResultsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ListMutateJobResultsRequest.
                         * @implements IListMutateJobResultsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IListMutateJobResultsRequest=} [properties] Properties to set
                         */
                        function ListMutateJobResultsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ListMutateJobResultsRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsRequest
                         * @instance
                         */
                        ListMutateJobResultsRequest.prototype.resourceName = "";

                        /**
                         * ListMutateJobResultsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsRequest
                         * @instance
                         */
                        ListMutateJobResultsRequest.prototype.pageToken = "";

                        /**
                         * ListMutateJobResultsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsRequest
                         * @instance
                         */
                        ListMutateJobResultsRequest.prototype.pageSize = 0;

                        /**
                         * Creates a new ListMutateJobResultsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IListMutateJobResultsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ListMutateJobResultsRequest} ListMutateJobResultsRequest instance
                         */
                        ListMutateJobResultsRequest.create = function create(properties) {
                            return new ListMutateJobResultsRequest(properties);
                        };

                        /**
                         * Encodes the specified ListMutateJobResultsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.ListMutateJobResultsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IListMutateJobResultsRequest} message ListMutateJobResultsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMutateJobResultsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.pageToken);
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.pageSize);
                            return writer;
                        };

                        /**
                         * Encodes the specified ListMutateJobResultsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ListMutateJobResultsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IListMutateJobResultsRequest} message ListMutateJobResultsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMutateJobResultsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ListMutateJobResultsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ListMutateJobResultsRequest} ListMutateJobResultsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMutateJobResultsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ListMutateJobResultsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.pageToken = reader.string();
                                    break;
                                case 3:
                                    message.pageSize = reader.int32();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ListMutateJobResultsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ListMutateJobResultsRequest} ListMutateJobResultsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMutateJobResultsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ListMutateJobResultsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListMutateJobResultsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            return null;
                        };

                        /**
                         * Creates a ListMutateJobResultsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ListMutateJobResultsRequest} ListMutateJobResultsRequest
                         */
                        ListMutateJobResultsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ListMutateJobResultsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ListMutateJobResultsRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            return message;
                        };

                        /**
                         * Creates a plain object from a ListMutateJobResultsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ListMutateJobResultsRequest} message ListMutateJobResultsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListMutateJobResultsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceName = "";
                                object.pageToken = "";
                                object.pageSize = 0;
                            }
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            return object;
                        };

                        /**
                         * Converts this ListMutateJobResultsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListMutateJobResultsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ListMutateJobResultsRequest;
                    })();

                    services.ListMutateJobResultsResponse = (function() {

                        /**
                         * Properties of a ListMutateJobResultsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IListMutateJobResultsResponse
                         * @property {Array.<google.ads.googleads.v1.services.IMutateJobResult>|null} [results] ListMutateJobResultsResponse results
                         * @property {string|null} [nextPageToken] ListMutateJobResultsResponse nextPageToken
                         */

                        /**
                         * Constructs a new ListMutateJobResultsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ListMutateJobResultsResponse.
                         * @implements IListMutateJobResultsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IListMutateJobResultsResponse=} [properties] Properties to set
                         */
                        function ListMutateJobResultsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ListMutateJobResultsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateJobResult>} results
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsResponse
                         * @instance
                         */
                        ListMutateJobResultsResponse.prototype.results = $util.emptyArray;

                        /**
                         * ListMutateJobResultsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsResponse
                         * @instance
                         */
                        ListMutateJobResultsResponse.prototype.nextPageToken = "";

                        /**
                         * Creates a new ListMutateJobResultsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IListMutateJobResultsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ListMutateJobResultsResponse} ListMutateJobResultsResponse instance
                         */
                        ListMutateJobResultsResponse.create = function create(properties) {
                            return new ListMutateJobResultsResponse(properties);
                        };

                        /**
                         * Encodes the specified ListMutateJobResultsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.ListMutateJobResultsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IListMutateJobResultsResponse} message ListMutateJobResultsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMutateJobResultsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateJobResult.encode(message.results[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };

                        /**
                         * Encodes the specified ListMutateJobResultsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ListMutateJobResultsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IListMutateJobResultsResponse} message ListMutateJobResultsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMutateJobResultsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ListMutateJobResultsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ListMutateJobResultsResponse} ListMutateJobResultsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMutateJobResultsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ListMutateJobResultsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateJobResult.decode(reader, reader.uint32()));
                                    break;
                                case 2:
                                    message.nextPageToken = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ListMutateJobResultsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ListMutateJobResultsResponse} ListMutateJobResultsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMutateJobResultsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ListMutateJobResultsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListMutateJobResultsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateJobResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };

                        /**
                         * Creates a ListMutateJobResultsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ListMutateJobResultsResponse} ListMutateJobResultsResponse
                         */
                        ListMutateJobResultsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ListMutateJobResultsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ListMutateJobResultsResponse();
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.ListMutateJobResultsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.ListMutateJobResultsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateJobResult.fromObject(object.results[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };

                        /**
                         * Creates a plain object from a ListMutateJobResultsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ListMutateJobResultsResponse} message ListMutateJobResultsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListMutateJobResultsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateJobResult.toObject(message.results[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };

                        /**
                         * Converts this ListMutateJobResultsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ListMutateJobResultsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListMutateJobResultsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ListMutateJobResultsResponse;
                    })();

                    services.MutateJobResult = (function() {

                        /**
                         * Properties of a MutateJobResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateJobResult
                         * @property {number|Long|null} [operationIndex] MutateJobResult operationIndex
                         * @property {google.ads.googleads.v1.services.IMutateOperationResponse|null} [mutateOperationResponse] MutateJobResult mutateOperationResponse
                         * @property {google.rpc.IStatus|null} [status] MutateJobResult status
                         */

                        /**
                         * Constructs a new MutateJobResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateJobResult.
                         * @implements IMutateJobResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateJobResult=} [properties] Properties to set
                         */
                        function MutateJobResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateJobResult operationIndex.
                         * @member {number|Long} operationIndex
                         * @memberof google.ads.googleads.v1.services.MutateJobResult
                         * @instance
                         */
                        MutateJobResult.prototype.operationIndex = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

                        /**
                         * MutateJobResult mutateOperationResponse.
                         * @member {google.ads.googleads.v1.services.IMutateOperationResponse|null|undefined} mutateOperationResponse
                         * @memberof google.ads.googleads.v1.services.MutateJobResult
                         * @instance
                         */
                        MutateJobResult.prototype.mutateOperationResponse = null;

                        /**
                         * MutateJobResult status.
                         * @member {google.rpc.IStatus|null|undefined} status
                         * @memberof google.ads.googleads.v1.services.MutateJobResult
                         * @instance
                         */
                        MutateJobResult.prototype.status = null;

                        /**
                         * Creates a new MutateJobResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateJobResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateJobResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateJobResult} MutateJobResult instance
                         */
                        MutateJobResult.create = function create(properties) {
                            return new MutateJobResult(properties);
                        };

                        /**
                         * Encodes the specified MutateJobResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateJobResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateJobResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateJobResult} message MutateJobResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateJobResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operationIndex != null && message.hasOwnProperty("operationIndex"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int64(message.operationIndex);
                            if (message.mutateOperationResponse != null && message.hasOwnProperty("mutateOperationResponse"))
                                $root.google.ads.googleads.v1.services.MutateOperationResponse.encode(message.mutateOperationResponse, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.status != null && message.hasOwnProperty("status"))
                                $root.google.rpc.Status.encode(message.status, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateJobResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateJobResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateJobResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateJobResult} message MutateJobResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateJobResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateJobResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateJobResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateJobResult} MutateJobResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateJobResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateJobResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.operationIndex = reader.int64();
                                    break;
                                case 2:
                                    message.mutateOperationResponse = $root.google.ads.googleads.v1.services.MutateOperationResponse.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.status = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateJobResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateJobResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateJobResult} MutateJobResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateJobResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateJobResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateJobResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateJobResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operationIndex != null && message.hasOwnProperty("operationIndex"))
                                if (!$util.isInteger(message.operationIndex) && !(message.operationIndex && $util.isInteger(message.operationIndex.low) && $util.isInteger(message.operationIndex.high)))
                                    return "operationIndex: integer|Long expected";
                            if (message.mutateOperationResponse != null && message.hasOwnProperty("mutateOperationResponse")) {
                                var error = $root.google.ads.googleads.v1.services.MutateOperationResponse.verify(message.mutateOperationResponse);
                                if (error)
                                    return "mutateOperationResponse." + error;
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                var error = $root.google.rpc.Status.verify(message.status);
                                if (error)
                                    return "status." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateJobResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateJobResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateJobResult} MutateJobResult
                         */
                        MutateJobResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateJobResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateJobResult();
                            if (object.operationIndex != null)
                                if ($util.Long)
                                    (message.operationIndex = $util.Long.fromValue(object.operationIndex)).unsigned = false;
                                else if (typeof object.operationIndex === "string")
                                    message.operationIndex = parseInt(object.operationIndex, 10);
                                else if (typeof object.operationIndex === "number")
                                    message.operationIndex = object.operationIndex;
                                else if (typeof object.operationIndex === "object")
                                    message.operationIndex = new $util.LongBits(object.operationIndex.low >>> 0, object.operationIndex.high >>> 0).toNumber();
                            if (object.mutateOperationResponse != null) {
                                if (typeof object.mutateOperationResponse !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateJobResult.mutateOperationResponse: object expected");
                                message.mutateOperationResponse = $root.google.ads.googleads.v1.services.MutateOperationResponse.fromObject(object.mutateOperationResponse);
                            }
                            if (object.status != null) {
                                if (typeof object.status !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateJobResult.status: object expected");
                                message.status = $root.google.rpc.Status.fromObject(object.status);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateJobResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateJobResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateJobResult} message MutateJobResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateJobResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                if ($util.Long) {
                                    var long = new $util.Long(0, 0, false);
                                    object.operationIndex = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                                } else
                                    object.operationIndex = options.longs === String ? "0" : 0;
                                object.mutateOperationResponse = null;
                                object.status = null;
                            }
                            if (message.operationIndex != null && message.hasOwnProperty("operationIndex"))
                                if (typeof message.operationIndex === "number")
                                    object.operationIndex = options.longs === String ? String(message.operationIndex) : message.operationIndex;
                                else
                                    object.operationIndex = options.longs === String ? $util.Long.prototype.toString.call(message.operationIndex) : options.longs === Number ? new $util.LongBits(message.operationIndex.low >>> 0, message.operationIndex.high >>> 0).toNumber() : message.operationIndex;
                            if (message.mutateOperationResponse != null && message.hasOwnProperty("mutateOperationResponse"))
                                object.mutateOperationResponse = $root.google.ads.googleads.v1.services.MutateOperationResponse.toObject(message.mutateOperationResponse, options);
                            if (message.status != null && message.hasOwnProperty("status"))
                                object.status = $root.google.rpc.Status.toObject(message.status, options);
                            return object;
                        };

                        /**
                         * Converts this MutateJobResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateJobResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateJobResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateJobResult;
                    })();

                    services.OperatingSystemVersionConstantService = (function() {

                        /**
                         * Constructs a new OperatingSystemVersionConstantService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an OperatingSystemVersionConstantService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function OperatingSystemVersionConstantService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (OperatingSystemVersionConstantService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = OperatingSystemVersionConstantService;

                        /**
                         * Creates new OperatingSystemVersionConstantService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.OperatingSystemVersionConstantService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {OperatingSystemVersionConstantService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        OperatingSystemVersionConstantService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.OperatingSystemVersionConstantService#getOperatingSystemVersionConstant}.
                         * @memberof google.ads.googleads.v1.services.OperatingSystemVersionConstantService
                         * @typedef GetOperatingSystemVersionConstantCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.OperatingSystemVersionConstant} [response] OperatingSystemVersionConstant
                         */

                        /**
                         * Calls GetOperatingSystemVersionConstant.
                         * @function getOperatingSystemVersionConstant
                         * @memberof google.ads.googleads.v1.services.OperatingSystemVersionConstantService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetOperatingSystemVersionConstantRequest} request GetOperatingSystemVersionConstantRequest message or plain object
                         * @param {google.ads.googleads.v1.services.OperatingSystemVersionConstantService.GetOperatingSystemVersionConstantCallback} callback Node-style callback called with the error, if any, and OperatingSystemVersionConstant
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(OperatingSystemVersionConstantService.prototype.getOperatingSystemVersionConstant = function getOperatingSystemVersionConstant(request, callback) {
                            return this.rpcCall(getOperatingSystemVersionConstant, $root.google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest, $root.google.ads.googleads.v1.resources.OperatingSystemVersionConstant, request, callback);
                        }, "name", { value: "GetOperatingSystemVersionConstant" });

                        /**
                         * Calls GetOperatingSystemVersionConstant.
                         * @function getOperatingSystemVersionConstant
                         * @memberof google.ads.googleads.v1.services.OperatingSystemVersionConstantService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetOperatingSystemVersionConstantRequest} request GetOperatingSystemVersionConstantRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.OperatingSystemVersionConstant>} Promise
                         * @variation 2
                         */

                        return OperatingSystemVersionConstantService;
                    })();

                    services.GetOperatingSystemVersionConstantRequest = (function() {

                        /**
                         * Properties of a GetOperatingSystemVersionConstantRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetOperatingSystemVersionConstantRequest
                         * @property {string|null} [resourceName] GetOperatingSystemVersionConstantRequest resourceName
                         */

                        /**
                         * Constructs a new GetOperatingSystemVersionConstantRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetOperatingSystemVersionConstantRequest.
                         * @implements IGetOperatingSystemVersionConstantRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetOperatingSystemVersionConstantRequest=} [properties] Properties to set
                         */
                        function GetOperatingSystemVersionConstantRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetOperatingSystemVersionConstantRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest
                         * @instance
                         */
                        GetOperatingSystemVersionConstantRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetOperatingSystemVersionConstantRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetOperatingSystemVersionConstantRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest} GetOperatingSystemVersionConstantRequest instance
                         */
                        GetOperatingSystemVersionConstantRequest.create = function create(properties) {
                            return new GetOperatingSystemVersionConstantRequest(properties);
                        };

                        /**
                         * Encodes the specified GetOperatingSystemVersionConstantRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetOperatingSystemVersionConstantRequest} message GetOperatingSystemVersionConstantRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetOperatingSystemVersionConstantRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetOperatingSystemVersionConstantRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetOperatingSystemVersionConstantRequest} message GetOperatingSystemVersionConstantRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetOperatingSystemVersionConstantRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetOperatingSystemVersionConstantRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest} GetOperatingSystemVersionConstantRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetOperatingSystemVersionConstantRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetOperatingSystemVersionConstantRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest} GetOperatingSystemVersionConstantRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetOperatingSystemVersionConstantRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetOperatingSystemVersionConstantRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetOperatingSystemVersionConstantRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetOperatingSystemVersionConstantRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest} GetOperatingSystemVersionConstantRequest
                         */
                        GetOperatingSystemVersionConstantRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetOperatingSystemVersionConstantRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest} message GetOperatingSystemVersionConstantRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetOperatingSystemVersionConstantRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetOperatingSystemVersionConstantRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetOperatingSystemVersionConstantRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetOperatingSystemVersionConstantRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetOperatingSystemVersionConstantRequest;
                    })();

                    services.PaidOrganicSearchTermViewService = (function() {

                        /**
                         * Constructs a new PaidOrganicSearchTermViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a PaidOrganicSearchTermViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function PaidOrganicSearchTermViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (PaidOrganicSearchTermViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = PaidOrganicSearchTermViewService;

                        /**
                         * Creates new PaidOrganicSearchTermViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.PaidOrganicSearchTermViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {PaidOrganicSearchTermViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        PaidOrganicSearchTermViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.PaidOrganicSearchTermViewService#getPaidOrganicSearchTermView}.
                         * @memberof google.ads.googleads.v1.services.PaidOrganicSearchTermViewService
                         * @typedef GetPaidOrganicSearchTermViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.PaidOrganicSearchTermView} [response] PaidOrganicSearchTermView
                         */

                        /**
                         * Calls GetPaidOrganicSearchTermView.
                         * @function getPaidOrganicSearchTermView
                         * @memberof google.ads.googleads.v1.services.PaidOrganicSearchTermViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetPaidOrganicSearchTermViewRequest} request GetPaidOrganicSearchTermViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.PaidOrganicSearchTermViewService.GetPaidOrganicSearchTermViewCallback} callback Node-style callback called with the error, if any, and PaidOrganicSearchTermView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PaidOrganicSearchTermViewService.prototype.getPaidOrganicSearchTermView = function getPaidOrganicSearchTermView(request, callback) {
                            return this.rpcCall(getPaidOrganicSearchTermView, $root.google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest, $root.google.ads.googleads.v1.resources.PaidOrganicSearchTermView, request, callback);
                        }, "name", { value: "GetPaidOrganicSearchTermView" });

                        /**
                         * Calls GetPaidOrganicSearchTermView.
                         * @function getPaidOrganicSearchTermView
                         * @memberof google.ads.googleads.v1.services.PaidOrganicSearchTermViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetPaidOrganicSearchTermViewRequest} request GetPaidOrganicSearchTermViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.PaidOrganicSearchTermView>} Promise
                         * @variation 2
                         */

                        return PaidOrganicSearchTermViewService;
                    })();

                    services.GetPaidOrganicSearchTermViewRequest = (function() {

                        /**
                         * Properties of a GetPaidOrganicSearchTermViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetPaidOrganicSearchTermViewRequest
                         * @property {string|null} [resourceName] GetPaidOrganicSearchTermViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetPaidOrganicSearchTermViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetPaidOrganicSearchTermViewRequest.
                         * @implements IGetPaidOrganicSearchTermViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetPaidOrganicSearchTermViewRequest=} [properties] Properties to set
                         */
                        function GetPaidOrganicSearchTermViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetPaidOrganicSearchTermViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest
                         * @instance
                         */
                        GetPaidOrganicSearchTermViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetPaidOrganicSearchTermViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetPaidOrganicSearchTermViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest} GetPaidOrganicSearchTermViewRequest instance
                         */
                        GetPaidOrganicSearchTermViewRequest.create = function create(properties) {
                            return new GetPaidOrganicSearchTermViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetPaidOrganicSearchTermViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetPaidOrganicSearchTermViewRequest} message GetPaidOrganicSearchTermViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetPaidOrganicSearchTermViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetPaidOrganicSearchTermViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetPaidOrganicSearchTermViewRequest} message GetPaidOrganicSearchTermViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetPaidOrganicSearchTermViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetPaidOrganicSearchTermViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest} GetPaidOrganicSearchTermViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetPaidOrganicSearchTermViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetPaidOrganicSearchTermViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest} GetPaidOrganicSearchTermViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetPaidOrganicSearchTermViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetPaidOrganicSearchTermViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetPaidOrganicSearchTermViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetPaidOrganicSearchTermViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest} GetPaidOrganicSearchTermViewRequest
                         */
                        GetPaidOrganicSearchTermViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetPaidOrganicSearchTermViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest} message GetPaidOrganicSearchTermViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetPaidOrganicSearchTermViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetPaidOrganicSearchTermViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetPaidOrganicSearchTermViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetPaidOrganicSearchTermViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetPaidOrganicSearchTermViewRequest;
                    })();

                    services.ParentalStatusViewService = (function() {

                        /**
                         * Constructs a new ParentalStatusViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ParentalStatusViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function ParentalStatusViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (ParentalStatusViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = ParentalStatusViewService;

                        /**
                         * Creates new ParentalStatusViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ParentalStatusViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {ParentalStatusViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        ParentalStatusViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.ParentalStatusViewService#getParentalStatusView}.
                         * @memberof google.ads.googleads.v1.services.ParentalStatusViewService
                         * @typedef GetParentalStatusViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.ParentalStatusView} [response] ParentalStatusView
                         */

                        /**
                         * Calls GetParentalStatusView.
                         * @function getParentalStatusView
                         * @memberof google.ads.googleads.v1.services.ParentalStatusViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetParentalStatusViewRequest} request GetParentalStatusViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.ParentalStatusViewService.GetParentalStatusViewCallback} callback Node-style callback called with the error, if any, and ParentalStatusView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ParentalStatusViewService.prototype.getParentalStatusView = function getParentalStatusView(request, callback) {
                            return this.rpcCall(getParentalStatusView, $root.google.ads.googleads.v1.services.GetParentalStatusViewRequest, $root.google.ads.googleads.v1.resources.ParentalStatusView, request, callback);
                        }, "name", { value: "GetParentalStatusView" });

                        /**
                         * Calls GetParentalStatusView.
                         * @function getParentalStatusView
                         * @memberof google.ads.googleads.v1.services.ParentalStatusViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetParentalStatusViewRequest} request GetParentalStatusViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.ParentalStatusView>} Promise
                         * @variation 2
                         */

                        return ParentalStatusViewService;
                    })();

                    services.GetParentalStatusViewRequest = (function() {

                        /**
                         * Properties of a GetParentalStatusViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetParentalStatusViewRequest
                         * @property {string|null} [resourceName] GetParentalStatusViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetParentalStatusViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetParentalStatusViewRequest.
                         * @implements IGetParentalStatusViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetParentalStatusViewRequest=} [properties] Properties to set
                         */
                        function GetParentalStatusViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetParentalStatusViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetParentalStatusViewRequest
                         * @instance
                         */
                        GetParentalStatusViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetParentalStatusViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetParentalStatusViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetParentalStatusViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetParentalStatusViewRequest} GetParentalStatusViewRequest instance
                         */
                        GetParentalStatusViewRequest.create = function create(properties) {
                            return new GetParentalStatusViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetParentalStatusViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetParentalStatusViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetParentalStatusViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetParentalStatusViewRequest} message GetParentalStatusViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetParentalStatusViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetParentalStatusViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetParentalStatusViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetParentalStatusViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetParentalStatusViewRequest} message GetParentalStatusViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetParentalStatusViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetParentalStatusViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetParentalStatusViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetParentalStatusViewRequest} GetParentalStatusViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetParentalStatusViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetParentalStatusViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetParentalStatusViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetParentalStatusViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetParentalStatusViewRequest} GetParentalStatusViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetParentalStatusViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetParentalStatusViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetParentalStatusViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetParentalStatusViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetParentalStatusViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetParentalStatusViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetParentalStatusViewRequest} GetParentalStatusViewRequest
                         */
                        GetParentalStatusViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetParentalStatusViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetParentalStatusViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetParentalStatusViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetParentalStatusViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetParentalStatusViewRequest} message GetParentalStatusViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetParentalStatusViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetParentalStatusViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetParentalStatusViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetParentalStatusViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetParentalStatusViewRequest;
                    })();

                    services.PaymentsAccountService = (function() {

                        /**
                         * Constructs a new PaymentsAccountService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a PaymentsAccountService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function PaymentsAccountService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (PaymentsAccountService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = PaymentsAccountService;

                        /**
                         * Creates new PaymentsAccountService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.PaymentsAccountService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {PaymentsAccountService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        PaymentsAccountService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.PaymentsAccountService#listPaymentsAccounts}.
                         * @memberof google.ads.googleads.v1.services.PaymentsAccountService
                         * @typedef ListPaymentsAccountsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.ListPaymentsAccountsResponse} [response] ListPaymentsAccountsResponse
                         */

                        /**
                         * Calls ListPaymentsAccounts.
                         * @function listPaymentsAccounts
                         * @memberof google.ads.googleads.v1.services.PaymentsAccountService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IListPaymentsAccountsRequest} request ListPaymentsAccountsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.PaymentsAccountService.ListPaymentsAccountsCallback} callback Node-style callback called with the error, if any, and ListPaymentsAccountsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PaymentsAccountService.prototype.listPaymentsAccounts = function listPaymentsAccounts(request, callback) {
                            return this.rpcCall(listPaymentsAccounts, $root.google.ads.googleads.v1.services.ListPaymentsAccountsRequest, $root.google.ads.googleads.v1.services.ListPaymentsAccountsResponse, request, callback);
                        }, "name", { value: "ListPaymentsAccounts" });

                        /**
                         * Calls ListPaymentsAccounts.
                         * @function listPaymentsAccounts
                         * @memberof google.ads.googleads.v1.services.PaymentsAccountService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IListPaymentsAccountsRequest} request ListPaymentsAccountsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.ListPaymentsAccountsResponse>} Promise
                         * @variation 2
                         */

                        return PaymentsAccountService;
                    })();

                    services.ListPaymentsAccountsRequest = (function() {

                        /**
                         * Properties of a ListPaymentsAccountsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IListPaymentsAccountsRequest
                         * @property {string|null} [customerId] ListPaymentsAccountsRequest customerId
                         */

                        /**
                         * Constructs a new ListPaymentsAccountsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ListPaymentsAccountsRequest.
                         * @implements IListPaymentsAccountsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IListPaymentsAccountsRequest=} [properties] Properties to set
                         */
                        function ListPaymentsAccountsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ListPaymentsAccountsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsRequest
                         * @instance
                         */
                        ListPaymentsAccountsRequest.prototype.customerId = "";

                        /**
                         * Creates a new ListPaymentsAccountsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IListPaymentsAccountsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ListPaymentsAccountsRequest} ListPaymentsAccountsRequest instance
                         */
                        ListPaymentsAccountsRequest.create = function create(properties) {
                            return new ListPaymentsAccountsRequest(properties);
                        };

                        /**
                         * Encodes the specified ListPaymentsAccountsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.ListPaymentsAccountsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IListPaymentsAccountsRequest} message ListPaymentsAccountsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPaymentsAccountsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            return writer;
                        };

                        /**
                         * Encodes the specified ListPaymentsAccountsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ListPaymentsAccountsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IListPaymentsAccountsRequest} message ListPaymentsAccountsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPaymentsAccountsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ListPaymentsAccountsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ListPaymentsAccountsRequest} ListPaymentsAccountsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPaymentsAccountsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ListPaymentsAccountsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ListPaymentsAccountsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ListPaymentsAccountsRequest} ListPaymentsAccountsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPaymentsAccountsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ListPaymentsAccountsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListPaymentsAccountsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            return null;
                        };

                        /**
                         * Creates a ListPaymentsAccountsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ListPaymentsAccountsRequest} ListPaymentsAccountsRequest
                         */
                        ListPaymentsAccountsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ListPaymentsAccountsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ListPaymentsAccountsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            return message;
                        };

                        /**
                         * Creates a plain object from a ListPaymentsAccountsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ListPaymentsAccountsRequest} message ListPaymentsAccountsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListPaymentsAccountsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.customerId = "";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            return object;
                        };

                        /**
                         * Converts this ListPaymentsAccountsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListPaymentsAccountsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ListPaymentsAccountsRequest;
                    })();

                    services.ListPaymentsAccountsResponse = (function() {

                        /**
                         * Properties of a ListPaymentsAccountsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IListPaymentsAccountsResponse
                         * @property {Array.<google.ads.googleads.v1.resources.IPaymentsAccount>|null} [paymentsAccounts] ListPaymentsAccountsResponse paymentsAccounts
                         */

                        /**
                         * Constructs a new ListPaymentsAccountsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ListPaymentsAccountsResponse.
                         * @implements IListPaymentsAccountsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IListPaymentsAccountsResponse=} [properties] Properties to set
                         */
                        function ListPaymentsAccountsResponse(properties) {
                            this.paymentsAccounts = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ListPaymentsAccountsResponse paymentsAccounts.
                         * @member {Array.<google.ads.googleads.v1.resources.IPaymentsAccount>} paymentsAccounts
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsResponse
                         * @instance
                         */
                        ListPaymentsAccountsResponse.prototype.paymentsAccounts = $util.emptyArray;

                        /**
                         * Creates a new ListPaymentsAccountsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IListPaymentsAccountsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ListPaymentsAccountsResponse} ListPaymentsAccountsResponse instance
                         */
                        ListPaymentsAccountsResponse.create = function create(properties) {
                            return new ListPaymentsAccountsResponse(properties);
                        };

                        /**
                         * Encodes the specified ListPaymentsAccountsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.ListPaymentsAccountsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IListPaymentsAccountsResponse} message ListPaymentsAccountsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPaymentsAccountsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.paymentsAccounts != null && message.paymentsAccounts.length)
                                for (var i = 0; i < message.paymentsAccounts.length; ++i)
                                    $root.google.ads.googleads.v1.resources.PaymentsAccount.encode(message.paymentsAccounts[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ListPaymentsAccountsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ListPaymentsAccountsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IListPaymentsAccountsResponse} message ListPaymentsAccountsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPaymentsAccountsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a ListPaymentsAccountsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ListPaymentsAccountsResponse} ListPaymentsAccountsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPaymentsAccountsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ListPaymentsAccountsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.paymentsAccounts && message.paymentsAccounts.length))
                                        message.paymentsAccounts = [];
                                    message.paymentsAccounts.push($root.google.ads.googleads.v1.resources.PaymentsAccount.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a ListPaymentsAccountsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ListPaymentsAccountsResponse} ListPaymentsAccountsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPaymentsAccountsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a ListPaymentsAccountsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListPaymentsAccountsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.paymentsAccounts != null && message.hasOwnProperty("paymentsAccounts")) {
                                if (!Array.isArray(message.paymentsAccounts))
                                    return "paymentsAccounts: array expected";
                                for (var i = 0; i < message.paymentsAccounts.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.resources.PaymentsAccount.verify(message.paymentsAccounts[i]);
                                    if (error)
                                        return "paymentsAccounts." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a ListPaymentsAccountsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ListPaymentsAccountsResponse} ListPaymentsAccountsResponse
                         */
                        ListPaymentsAccountsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ListPaymentsAccountsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ListPaymentsAccountsResponse();
                            if (object.paymentsAccounts) {
                                if (!Array.isArray(object.paymentsAccounts))
                                    throw TypeError(".google.ads.googleads.v1.services.ListPaymentsAccountsResponse.paymentsAccounts: array expected");
                                message.paymentsAccounts = [];
                                for (var i = 0; i < object.paymentsAccounts.length; ++i) {
                                    if (typeof object.paymentsAccounts[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.ListPaymentsAccountsResponse.paymentsAccounts: object expected");
                                    message.paymentsAccounts[i] = $root.google.ads.googleads.v1.resources.PaymentsAccount.fromObject(object.paymentsAccounts[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a ListPaymentsAccountsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ListPaymentsAccountsResponse} message ListPaymentsAccountsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListPaymentsAccountsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.paymentsAccounts = [];
                            if (message.paymentsAccounts && message.paymentsAccounts.length) {
                                object.paymentsAccounts = [];
                                for (var j = 0; j < message.paymentsAccounts.length; ++j)
                                    object.paymentsAccounts[j] = $root.google.ads.googleads.v1.resources.PaymentsAccount.toObject(message.paymentsAccounts[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this ListPaymentsAccountsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ListPaymentsAccountsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListPaymentsAccountsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ListPaymentsAccountsResponse;
                    })();

                    services.ProductBiddingCategoryConstantService = (function() {

                        /**
                         * Constructs a new ProductBiddingCategoryConstantService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ProductBiddingCategoryConstantService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function ProductBiddingCategoryConstantService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (ProductBiddingCategoryConstantService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = ProductBiddingCategoryConstantService;

                        /**
                         * Creates new ProductBiddingCategoryConstantService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ProductBiddingCategoryConstantService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {ProductBiddingCategoryConstantService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        ProductBiddingCategoryConstantService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.ProductBiddingCategoryConstantService#getProductBiddingCategoryConstant}.
                         * @memberof google.ads.googleads.v1.services.ProductBiddingCategoryConstantService
                         * @typedef GetProductBiddingCategoryConstantCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.ProductBiddingCategoryConstant} [response] ProductBiddingCategoryConstant
                         */

                        /**
                         * Calls GetProductBiddingCategoryConstant.
                         * @function getProductBiddingCategoryConstant
                         * @memberof google.ads.googleads.v1.services.ProductBiddingCategoryConstantService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetProductBiddingCategoryConstantRequest} request GetProductBiddingCategoryConstantRequest message or plain object
                         * @param {google.ads.googleads.v1.services.ProductBiddingCategoryConstantService.GetProductBiddingCategoryConstantCallback} callback Node-style callback called with the error, if any, and ProductBiddingCategoryConstant
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ProductBiddingCategoryConstantService.prototype.getProductBiddingCategoryConstant = function getProductBiddingCategoryConstant(request, callback) {
                            return this.rpcCall(getProductBiddingCategoryConstant, $root.google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest, $root.google.ads.googleads.v1.resources.ProductBiddingCategoryConstant, request, callback);
                        }, "name", { value: "GetProductBiddingCategoryConstant" });

                        /**
                         * Calls GetProductBiddingCategoryConstant.
                         * @function getProductBiddingCategoryConstant
                         * @memberof google.ads.googleads.v1.services.ProductBiddingCategoryConstantService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetProductBiddingCategoryConstantRequest} request GetProductBiddingCategoryConstantRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.ProductBiddingCategoryConstant>} Promise
                         * @variation 2
                         */

                        return ProductBiddingCategoryConstantService;
                    })();

                    services.GetProductBiddingCategoryConstantRequest = (function() {

                        /**
                         * Properties of a GetProductBiddingCategoryConstantRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetProductBiddingCategoryConstantRequest
                         * @property {string|null} [resourceName] GetProductBiddingCategoryConstantRequest resourceName
                         */

                        /**
                         * Constructs a new GetProductBiddingCategoryConstantRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetProductBiddingCategoryConstantRequest.
                         * @implements IGetProductBiddingCategoryConstantRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetProductBiddingCategoryConstantRequest=} [properties] Properties to set
                         */
                        function GetProductBiddingCategoryConstantRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetProductBiddingCategoryConstantRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest
                         * @instance
                         */
                        GetProductBiddingCategoryConstantRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetProductBiddingCategoryConstantRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetProductBiddingCategoryConstantRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest} GetProductBiddingCategoryConstantRequest instance
                         */
                        GetProductBiddingCategoryConstantRequest.create = function create(properties) {
                            return new GetProductBiddingCategoryConstantRequest(properties);
                        };

                        /**
                         * Encodes the specified GetProductBiddingCategoryConstantRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetProductBiddingCategoryConstantRequest} message GetProductBiddingCategoryConstantRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetProductBiddingCategoryConstantRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetProductBiddingCategoryConstantRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetProductBiddingCategoryConstantRequest} message GetProductBiddingCategoryConstantRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetProductBiddingCategoryConstantRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetProductBiddingCategoryConstantRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest} GetProductBiddingCategoryConstantRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetProductBiddingCategoryConstantRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetProductBiddingCategoryConstantRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest} GetProductBiddingCategoryConstantRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetProductBiddingCategoryConstantRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetProductBiddingCategoryConstantRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetProductBiddingCategoryConstantRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetProductBiddingCategoryConstantRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest} GetProductBiddingCategoryConstantRequest
                         */
                        GetProductBiddingCategoryConstantRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetProductBiddingCategoryConstantRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest} message GetProductBiddingCategoryConstantRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetProductBiddingCategoryConstantRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetProductBiddingCategoryConstantRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetProductBiddingCategoryConstantRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetProductBiddingCategoryConstantRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetProductBiddingCategoryConstantRequest;
                    })();

                    services.ProductGroupViewService = (function() {

                        /**
                         * Constructs a new ProductGroupViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ProductGroupViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function ProductGroupViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (ProductGroupViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = ProductGroupViewService;

                        /**
                         * Creates new ProductGroupViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ProductGroupViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {ProductGroupViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        ProductGroupViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.ProductGroupViewService#getProductGroupView}.
                         * @memberof google.ads.googleads.v1.services.ProductGroupViewService
                         * @typedef GetProductGroupViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.ProductGroupView} [response] ProductGroupView
                         */

                        /**
                         * Calls GetProductGroupView.
                         * @function getProductGroupView
                         * @memberof google.ads.googleads.v1.services.ProductGroupViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetProductGroupViewRequest} request GetProductGroupViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.ProductGroupViewService.GetProductGroupViewCallback} callback Node-style callback called with the error, if any, and ProductGroupView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ProductGroupViewService.prototype.getProductGroupView = function getProductGroupView(request, callback) {
                            return this.rpcCall(getProductGroupView, $root.google.ads.googleads.v1.services.GetProductGroupViewRequest, $root.google.ads.googleads.v1.resources.ProductGroupView, request, callback);
                        }, "name", { value: "GetProductGroupView" });

                        /**
                         * Calls GetProductGroupView.
                         * @function getProductGroupView
                         * @memberof google.ads.googleads.v1.services.ProductGroupViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetProductGroupViewRequest} request GetProductGroupViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.ProductGroupView>} Promise
                         * @variation 2
                         */

                        return ProductGroupViewService;
                    })();

                    services.GetProductGroupViewRequest = (function() {

                        /**
                         * Properties of a GetProductGroupViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetProductGroupViewRequest
                         * @property {string|null} [resourceName] GetProductGroupViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetProductGroupViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetProductGroupViewRequest.
                         * @implements IGetProductGroupViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetProductGroupViewRequest=} [properties] Properties to set
                         */
                        function GetProductGroupViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetProductGroupViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetProductGroupViewRequest
                         * @instance
                         */
                        GetProductGroupViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetProductGroupViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetProductGroupViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetProductGroupViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetProductGroupViewRequest} GetProductGroupViewRequest instance
                         */
                        GetProductGroupViewRequest.create = function create(properties) {
                            return new GetProductGroupViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetProductGroupViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetProductGroupViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetProductGroupViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetProductGroupViewRequest} message GetProductGroupViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetProductGroupViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetProductGroupViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetProductGroupViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetProductGroupViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetProductGroupViewRequest} message GetProductGroupViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetProductGroupViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetProductGroupViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetProductGroupViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetProductGroupViewRequest} GetProductGroupViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetProductGroupViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetProductGroupViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetProductGroupViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetProductGroupViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetProductGroupViewRequest} GetProductGroupViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetProductGroupViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetProductGroupViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetProductGroupViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetProductGroupViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetProductGroupViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetProductGroupViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetProductGroupViewRequest} GetProductGroupViewRequest
                         */
                        GetProductGroupViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetProductGroupViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetProductGroupViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetProductGroupViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetProductGroupViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetProductGroupViewRequest} message GetProductGroupViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetProductGroupViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetProductGroupViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetProductGroupViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetProductGroupViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetProductGroupViewRequest;
                    })();

                    services.RecommendationService = (function() {

                        /**
                         * Constructs a new RecommendationService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a RecommendationService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RecommendationService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (RecommendationService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RecommendationService;

                        /**
                         * Creates new RecommendationService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.RecommendationService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RecommendationService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RecommendationService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.RecommendationService#getRecommendation}.
                         * @memberof google.ads.googleads.v1.services.RecommendationService
                         * @typedef GetRecommendationCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.Recommendation} [response] Recommendation
                         */

                        /**
                         * Calls GetRecommendation.
                         * @function getRecommendation
                         * @memberof google.ads.googleads.v1.services.RecommendationService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetRecommendationRequest} request GetRecommendationRequest message or plain object
                         * @param {google.ads.googleads.v1.services.RecommendationService.GetRecommendationCallback} callback Node-style callback called with the error, if any, and Recommendation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RecommendationService.prototype.getRecommendation = function getRecommendation(request, callback) {
                            return this.rpcCall(getRecommendation, $root.google.ads.googleads.v1.services.GetRecommendationRequest, $root.google.ads.googleads.v1.resources.Recommendation, request, callback);
                        }, "name", { value: "GetRecommendation" });

                        /**
                         * Calls GetRecommendation.
                         * @function getRecommendation
                         * @memberof google.ads.googleads.v1.services.RecommendationService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetRecommendationRequest} request GetRecommendationRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.Recommendation>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.RecommendationService#applyRecommendation}.
                         * @memberof google.ads.googleads.v1.services.RecommendationService
                         * @typedef ApplyRecommendationCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.ApplyRecommendationResponse} [response] ApplyRecommendationResponse
                         */

                        /**
                         * Calls ApplyRecommendation.
                         * @function applyRecommendation
                         * @memberof google.ads.googleads.v1.services.RecommendationService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IApplyRecommendationRequest} request ApplyRecommendationRequest message or plain object
                         * @param {google.ads.googleads.v1.services.RecommendationService.ApplyRecommendationCallback} callback Node-style callback called with the error, if any, and ApplyRecommendationResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RecommendationService.prototype.applyRecommendation = function applyRecommendation(request, callback) {
                            return this.rpcCall(applyRecommendation, $root.google.ads.googleads.v1.services.ApplyRecommendationRequest, $root.google.ads.googleads.v1.services.ApplyRecommendationResponse, request, callback);
                        }, "name", { value: "ApplyRecommendation" });

                        /**
                         * Calls ApplyRecommendation.
                         * @function applyRecommendation
                         * @memberof google.ads.googleads.v1.services.RecommendationService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IApplyRecommendationRequest} request ApplyRecommendationRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.ApplyRecommendationResponse>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.RecommendationService#dismissRecommendation}.
                         * @memberof google.ads.googleads.v1.services.RecommendationService
                         * @typedef DismissRecommendationCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.DismissRecommendationResponse} [response] DismissRecommendationResponse
                         */

                        /**
                         * Calls DismissRecommendation.
                         * @function dismissRecommendation
                         * @memberof google.ads.googleads.v1.services.RecommendationService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IDismissRecommendationRequest} request DismissRecommendationRequest message or plain object
                         * @param {google.ads.googleads.v1.services.RecommendationService.DismissRecommendationCallback} callback Node-style callback called with the error, if any, and DismissRecommendationResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RecommendationService.prototype.dismissRecommendation = function dismissRecommendation(request, callback) {
                            return this.rpcCall(dismissRecommendation, $root.google.ads.googleads.v1.services.DismissRecommendationRequest, $root.google.ads.googleads.v1.services.DismissRecommendationResponse, request, callback);
                        }, "name", { value: "DismissRecommendation" });

                        /**
                         * Calls DismissRecommendation.
                         * @function dismissRecommendation
                         * @memberof google.ads.googleads.v1.services.RecommendationService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IDismissRecommendationRequest} request DismissRecommendationRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.DismissRecommendationResponse>} Promise
                         * @variation 2
                         */

                        return RecommendationService;
                    })();

                    services.GetRecommendationRequest = (function() {

                        /**
                         * Properties of a GetRecommendationRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetRecommendationRequest
                         * @property {string|null} [resourceName] GetRecommendationRequest resourceName
                         */

                        /**
                         * Constructs a new GetRecommendationRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetRecommendationRequest.
                         * @implements IGetRecommendationRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetRecommendationRequest=} [properties] Properties to set
                         */
                        function GetRecommendationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetRecommendationRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetRecommendationRequest
                         * @instance
                         */
                        GetRecommendationRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetRecommendationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetRecommendationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetRecommendationRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetRecommendationRequest} GetRecommendationRequest instance
                         */
                        GetRecommendationRequest.create = function create(properties) {
                            return new GetRecommendationRequest(properties);
                        };

                        /**
                         * Encodes the specified GetRecommendationRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetRecommendationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetRecommendationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetRecommendationRequest} message GetRecommendationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRecommendationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetRecommendationRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetRecommendationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetRecommendationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetRecommendationRequest} message GetRecommendationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRecommendationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetRecommendationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetRecommendationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetRecommendationRequest} GetRecommendationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRecommendationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetRecommendationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetRecommendationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetRecommendationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetRecommendationRequest} GetRecommendationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRecommendationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetRecommendationRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetRecommendationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRecommendationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetRecommendationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetRecommendationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetRecommendationRequest} GetRecommendationRequest
                         */
                        GetRecommendationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetRecommendationRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetRecommendationRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetRecommendationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetRecommendationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetRecommendationRequest} message GetRecommendationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRecommendationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetRecommendationRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetRecommendationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRecommendationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetRecommendationRequest;
                    })();

                    services.ApplyRecommendationRequest = (function() {

                        /**
                         * Properties of an ApplyRecommendationRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IApplyRecommendationRequest
                         * @property {string|null} [customerId] ApplyRecommendationRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IApplyRecommendationOperation>|null} [operations] ApplyRecommendationRequest operations
                         * @property {boolean|null} [partialFailure] ApplyRecommendationRequest partialFailure
                         */

                        /**
                         * Constructs a new ApplyRecommendationRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an ApplyRecommendationRequest.
                         * @implements IApplyRecommendationRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IApplyRecommendationRequest=} [properties] Properties to set
                         */
                        function ApplyRecommendationRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ApplyRecommendationRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationRequest
                         * @instance
                         */
                        ApplyRecommendationRequest.prototype.customerId = "";

                        /**
                         * ApplyRecommendationRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IApplyRecommendationOperation>} operations
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationRequest
                         * @instance
                         */
                        ApplyRecommendationRequest.prototype.operations = $util.emptyArray;

                        /**
                         * ApplyRecommendationRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationRequest
                         * @instance
                         */
                        ApplyRecommendationRequest.prototype.partialFailure = false;

                        /**
                         * Creates a new ApplyRecommendationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IApplyRecommendationRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ApplyRecommendationRequest} ApplyRecommendationRequest instance
                         */
                        ApplyRecommendationRequest.create = function create(properties) {
                            return new ApplyRecommendationRequest(properties);
                        };

                        /**
                         * Encodes the specified ApplyRecommendationRequest message. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IApplyRecommendationRequest} message ApplyRecommendationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ApplyRecommendationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            return writer;
                        };

                        /**
                         * Encodes the specified ApplyRecommendationRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IApplyRecommendationRequest} message ApplyRecommendationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ApplyRecommendationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ApplyRecommendationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ApplyRecommendationRequest} ApplyRecommendationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ApplyRecommendationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ApplyRecommendationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.ApplyRecommendationOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ApplyRecommendationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ApplyRecommendationRequest} ApplyRecommendationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ApplyRecommendationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ApplyRecommendationRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ApplyRecommendationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            return null;
                        };

                        /**
                         * Creates an ApplyRecommendationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ApplyRecommendationRequest} ApplyRecommendationRequest
                         */
                        ApplyRecommendationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ApplyRecommendationRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ApplyRecommendationRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            return message;
                        };

                        /**
                         * Creates a plain object from an ApplyRecommendationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.ApplyRecommendationRequest} message ApplyRecommendationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ApplyRecommendationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            return object;
                        };

                        /**
                         * Converts this ApplyRecommendationRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ApplyRecommendationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ApplyRecommendationRequest;
                    })();

                    services.ApplyRecommendationOperation = (function() {

                        /**
                         * Properties of an ApplyRecommendationOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IApplyRecommendationOperation
                         * @property {string|null} [resourceName] ApplyRecommendationOperation resourceName
                         * @property {google.ads.googleads.v1.services.ApplyRecommendationOperation.ICampaignBudgetParameters|null} [campaignBudget] ApplyRecommendationOperation campaignBudget
                         * @property {google.ads.googleads.v1.services.ApplyRecommendationOperation.ITextAdParameters|null} [textAd] ApplyRecommendationOperation textAd
                         * @property {google.ads.googleads.v1.services.ApplyRecommendationOperation.IKeywordParameters|null} [keyword] ApplyRecommendationOperation keyword
                         * @property {google.ads.googleads.v1.services.ApplyRecommendationOperation.ITargetCpaOptInParameters|null} [targetCpaOptIn] ApplyRecommendationOperation targetCpaOptIn
                         * @property {google.ads.googleads.v1.services.ApplyRecommendationOperation.ICalloutExtensionParameters|null} [calloutExtension] ApplyRecommendationOperation calloutExtension
                         * @property {google.ads.googleads.v1.services.ApplyRecommendationOperation.ICallExtensionParameters|null} [callExtension] ApplyRecommendationOperation callExtension
                         * @property {google.ads.googleads.v1.services.ApplyRecommendationOperation.ISitelinkExtensionParameters|null} [sitelinkExtension] ApplyRecommendationOperation sitelinkExtension
                         * @property {google.ads.googleads.v1.services.ApplyRecommendationOperation.IMoveUnusedBudgetParameters|null} [moveUnusedBudget] ApplyRecommendationOperation moveUnusedBudget
                         */

                        /**
                         * Constructs a new ApplyRecommendationOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an ApplyRecommendationOperation.
                         * @implements IApplyRecommendationOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IApplyRecommendationOperation=} [properties] Properties to set
                         */
                        function ApplyRecommendationOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ApplyRecommendationOperation resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @instance
                         */
                        ApplyRecommendationOperation.prototype.resourceName = "";

                        /**
                         * ApplyRecommendationOperation campaignBudget.
                         * @member {google.ads.googleads.v1.services.ApplyRecommendationOperation.ICampaignBudgetParameters|null|undefined} campaignBudget
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @instance
                         */
                        ApplyRecommendationOperation.prototype.campaignBudget = null;

                        /**
                         * ApplyRecommendationOperation textAd.
                         * @member {google.ads.googleads.v1.services.ApplyRecommendationOperation.ITextAdParameters|null|undefined} textAd
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @instance
                         */
                        ApplyRecommendationOperation.prototype.textAd = null;

                        /**
                         * ApplyRecommendationOperation keyword.
                         * @member {google.ads.googleads.v1.services.ApplyRecommendationOperation.IKeywordParameters|null|undefined} keyword
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @instance
                         */
                        ApplyRecommendationOperation.prototype.keyword = null;

                        /**
                         * ApplyRecommendationOperation targetCpaOptIn.
                         * @member {google.ads.googleads.v1.services.ApplyRecommendationOperation.ITargetCpaOptInParameters|null|undefined} targetCpaOptIn
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @instance
                         */
                        ApplyRecommendationOperation.prototype.targetCpaOptIn = null;

                        /**
                         * ApplyRecommendationOperation calloutExtension.
                         * @member {google.ads.googleads.v1.services.ApplyRecommendationOperation.ICalloutExtensionParameters|null|undefined} calloutExtension
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @instance
                         */
                        ApplyRecommendationOperation.prototype.calloutExtension = null;

                        /**
                         * ApplyRecommendationOperation callExtension.
                         * @member {google.ads.googleads.v1.services.ApplyRecommendationOperation.ICallExtensionParameters|null|undefined} callExtension
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @instance
                         */
                        ApplyRecommendationOperation.prototype.callExtension = null;

                        /**
                         * ApplyRecommendationOperation sitelinkExtension.
                         * @member {google.ads.googleads.v1.services.ApplyRecommendationOperation.ISitelinkExtensionParameters|null|undefined} sitelinkExtension
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @instance
                         */
                        ApplyRecommendationOperation.prototype.sitelinkExtension = null;

                        /**
                         * ApplyRecommendationOperation moveUnusedBudget.
                         * @member {google.ads.googleads.v1.services.ApplyRecommendationOperation.IMoveUnusedBudgetParameters|null|undefined} moveUnusedBudget
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @instance
                         */
                        ApplyRecommendationOperation.prototype.moveUnusedBudget = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * ApplyRecommendationOperation applyParameters.
                         * @member {"campaignBudget"|"textAd"|"keyword"|"targetCpaOptIn"|"calloutExtension"|"callExtension"|"sitelinkExtension"|"moveUnusedBudget"|undefined} applyParameters
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @instance
                         */
                        Object.defineProperty(ApplyRecommendationOperation.prototype, "applyParameters", {
                            get: $util.oneOfGetter($oneOfFields = ["campaignBudget", "textAd", "keyword", "targetCpaOptIn", "calloutExtension", "callExtension", "sitelinkExtension", "moveUnusedBudget"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new ApplyRecommendationOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IApplyRecommendationOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation} ApplyRecommendationOperation instance
                         */
                        ApplyRecommendationOperation.create = function create(properties) {
                            return new ApplyRecommendationOperation(properties);
                        };

                        /**
                         * Encodes the specified ApplyRecommendationOperation message. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IApplyRecommendationOperation} message ApplyRecommendationOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ApplyRecommendationOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            if (message.campaignBudget != null && message.hasOwnProperty("campaignBudget"))
                                $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters.encode(message.campaignBudget, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.textAd != null && message.hasOwnProperty("textAd"))
                                $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters.encode(message.textAd, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.keyword != null && message.hasOwnProperty("keyword"))
                                $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters.encode(message.keyword, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.targetCpaOptIn != null && message.hasOwnProperty("targetCpaOptIn"))
                                $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters.encode(message.targetCpaOptIn, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.calloutExtension != null && message.hasOwnProperty("calloutExtension"))
                                $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters.encode(message.calloutExtension, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.callExtension != null && message.hasOwnProperty("callExtension"))
                                $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters.encode(message.callExtension, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.sitelinkExtension != null && message.hasOwnProperty("sitelinkExtension"))
                                $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters.encode(message.sitelinkExtension, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.moveUnusedBudget != null && message.hasOwnProperty("moveUnusedBudget"))
                                $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters.encode(message.moveUnusedBudget, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ApplyRecommendationOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IApplyRecommendationOperation} message ApplyRecommendationOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ApplyRecommendationOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ApplyRecommendationOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation} ApplyRecommendationOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ApplyRecommendationOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ApplyRecommendationOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                case 2:
                                    message.campaignBudget = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.textAd = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters.decode(reader, reader.uint32());
                                    break;
                                case 4:
                                    message.keyword = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters.decode(reader, reader.uint32());
                                    break;
                                case 5:
                                    message.targetCpaOptIn = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters.decode(reader, reader.uint32());
                                    break;
                                case 6:
                                    message.calloutExtension = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters.decode(reader, reader.uint32());
                                    break;
                                case 7:
                                    message.callExtension = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters.decode(reader, reader.uint32());
                                    break;
                                case 8:
                                    message.sitelinkExtension = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters.decode(reader, reader.uint32());
                                    break;
                                case 9:
                                    message.moveUnusedBudget = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ApplyRecommendationOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation} ApplyRecommendationOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ApplyRecommendationOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ApplyRecommendationOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ApplyRecommendationOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            if (message.campaignBudget != null && message.hasOwnProperty("campaignBudget")) {
                                properties.applyParameters = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters.verify(message.campaignBudget);
                                    if (error)
                                        return "campaignBudget." + error;
                                }
                            }
                            if (message.textAd != null && message.hasOwnProperty("textAd")) {
                                if (properties.applyParameters === 1)
                                    return "applyParameters: multiple values";
                                properties.applyParameters = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters.verify(message.textAd);
                                    if (error)
                                        return "textAd." + error;
                                }
                            }
                            if (message.keyword != null && message.hasOwnProperty("keyword")) {
                                if (properties.applyParameters === 1)
                                    return "applyParameters: multiple values";
                                properties.applyParameters = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters.verify(message.keyword);
                                    if (error)
                                        return "keyword." + error;
                                }
                            }
                            if (message.targetCpaOptIn != null && message.hasOwnProperty("targetCpaOptIn")) {
                                if (properties.applyParameters === 1)
                                    return "applyParameters: multiple values";
                                properties.applyParameters = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters.verify(message.targetCpaOptIn);
                                    if (error)
                                        return "targetCpaOptIn." + error;
                                }
                            }
                            if (message.calloutExtension != null && message.hasOwnProperty("calloutExtension")) {
                                if (properties.applyParameters === 1)
                                    return "applyParameters: multiple values";
                                properties.applyParameters = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters.verify(message.calloutExtension);
                                    if (error)
                                        return "calloutExtension." + error;
                                }
                            }
                            if (message.callExtension != null && message.hasOwnProperty("callExtension")) {
                                if (properties.applyParameters === 1)
                                    return "applyParameters: multiple values";
                                properties.applyParameters = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters.verify(message.callExtension);
                                    if (error)
                                        return "callExtension." + error;
                                }
                            }
                            if (message.sitelinkExtension != null && message.hasOwnProperty("sitelinkExtension")) {
                                if (properties.applyParameters === 1)
                                    return "applyParameters: multiple values";
                                properties.applyParameters = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters.verify(message.sitelinkExtension);
                                    if (error)
                                        return "sitelinkExtension." + error;
                                }
                            }
                            if (message.moveUnusedBudget != null && message.hasOwnProperty("moveUnusedBudget")) {
                                if (properties.applyParameters === 1)
                                    return "applyParameters: multiple values";
                                properties.applyParameters = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters.verify(message.moveUnusedBudget);
                                    if (error)
                                        return "moveUnusedBudget." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates an ApplyRecommendationOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation} ApplyRecommendationOperation
                         */
                        ApplyRecommendationOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ApplyRecommendationOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ApplyRecommendationOperation();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            if (object.campaignBudget != null) {
                                if (typeof object.campaignBudget !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.campaignBudget: object expected");
                                message.campaignBudget = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters.fromObject(object.campaignBudget);
                            }
                            if (object.textAd != null) {
                                if (typeof object.textAd !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.textAd: object expected");
                                message.textAd = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters.fromObject(object.textAd);
                            }
                            if (object.keyword != null) {
                                if (typeof object.keyword !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.keyword: object expected");
                                message.keyword = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters.fromObject(object.keyword);
                            }
                            if (object.targetCpaOptIn != null) {
                                if (typeof object.targetCpaOptIn !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.targetCpaOptIn: object expected");
                                message.targetCpaOptIn = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters.fromObject(object.targetCpaOptIn);
                            }
                            if (object.calloutExtension != null) {
                                if (typeof object.calloutExtension !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.calloutExtension: object expected");
                                message.calloutExtension = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters.fromObject(object.calloutExtension);
                            }
                            if (object.callExtension != null) {
                                if (typeof object.callExtension !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.callExtension: object expected");
                                message.callExtension = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters.fromObject(object.callExtension);
                            }
                            if (object.sitelinkExtension != null) {
                                if (typeof object.sitelinkExtension !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.sitelinkExtension: object expected");
                                message.sitelinkExtension = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters.fromObject(object.sitelinkExtension);
                            }
                            if (object.moveUnusedBudget != null) {
                                if (typeof object.moveUnusedBudget !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.moveUnusedBudget: object expected");
                                message.moveUnusedBudget = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters.fromObject(object.moveUnusedBudget);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an ApplyRecommendationOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation} message ApplyRecommendationOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ApplyRecommendationOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            if (message.campaignBudget != null && message.hasOwnProperty("campaignBudget")) {
                                object.campaignBudget = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters.toObject(message.campaignBudget, options);
                                if (options.oneofs)
                                    object.applyParameters = "campaignBudget";
                            }
                            if (message.textAd != null && message.hasOwnProperty("textAd")) {
                                object.textAd = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters.toObject(message.textAd, options);
                                if (options.oneofs)
                                    object.applyParameters = "textAd";
                            }
                            if (message.keyword != null && message.hasOwnProperty("keyword")) {
                                object.keyword = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters.toObject(message.keyword, options);
                                if (options.oneofs)
                                    object.applyParameters = "keyword";
                            }
                            if (message.targetCpaOptIn != null && message.hasOwnProperty("targetCpaOptIn")) {
                                object.targetCpaOptIn = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters.toObject(message.targetCpaOptIn, options);
                                if (options.oneofs)
                                    object.applyParameters = "targetCpaOptIn";
                            }
                            if (message.calloutExtension != null && message.hasOwnProperty("calloutExtension")) {
                                object.calloutExtension = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters.toObject(message.calloutExtension, options);
                                if (options.oneofs)
                                    object.applyParameters = "calloutExtension";
                            }
                            if (message.callExtension != null && message.hasOwnProperty("callExtension")) {
                                object.callExtension = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters.toObject(message.callExtension, options);
                                if (options.oneofs)
                                    object.applyParameters = "callExtension";
                            }
                            if (message.sitelinkExtension != null && message.hasOwnProperty("sitelinkExtension")) {
                                object.sitelinkExtension = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters.toObject(message.sitelinkExtension, options);
                                if (options.oneofs)
                                    object.applyParameters = "sitelinkExtension";
                            }
                            if (message.moveUnusedBudget != null && message.hasOwnProperty("moveUnusedBudget")) {
                                object.moveUnusedBudget = $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters.toObject(message.moveUnusedBudget, options);
                                if (options.oneofs)
                                    object.applyParameters = "moveUnusedBudget";
                            }
                            return object;
                        };

                        /**
                         * Converts this ApplyRecommendationOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ApplyRecommendationOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        ApplyRecommendationOperation.CampaignBudgetParameters = (function() {

                            /**
                             * Properties of a CampaignBudgetParameters.
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                             * @interface ICampaignBudgetParameters
                             * @property {google.protobuf.IInt64Value|null} [newBudgetAmountMicros] CampaignBudgetParameters newBudgetAmountMicros
                             */

                            /**
                             * Constructs a new CampaignBudgetParameters.
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                             * @classdesc Represents a CampaignBudgetParameters.
                             * @implements ICampaignBudgetParameters
                             * @constructor
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ICampaignBudgetParameters=} [properties] Properties to set
                             */
                            function CampaignBudgetParameters(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * CampaignBudgetParameters newBudgetAmountMicros.
                             * @member {google.protobuf.IInt64Value|null|undefined} newBudgetAmountMicros
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters
                             * @instance
                             */
                            CampaignBudgetParameters.prototype.newBudgetAmountMicros = null;

                            /**
                             * Creates a new CampaignBudgetParameters instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ICampaignBudgetParameters=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters} CampaignBudgetParameters instance
                             */
                            CampaignBudgetParameters.create = function create(properties) {
                                return new CampaignBudgetParameters(properties);
                            };

                            /**
                             * Encodes the specified CampaignBudgetParameters message. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ICampaignBudgetParameters} message CampaignBudgetParameters message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            CampaignBudgetParameters.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.newBudgetAmountMicros != null && message.hasOwnProperty("newBudgetAmountMicros"))
                                    $root.google.protobuf.Int64Value.encode(message.newBudgetAmountMicros, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified CampaignBudgetParameters message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ICampaignBudgetParameters} message CampaignBudgetParameters message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            CampaignBudgetParameters.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a CampaignBudgetParameters message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters} CampaignBudgetParameters
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            CampaignBudgetParameters.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.newBudgetAmountMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a CampaignBudgetParameters message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters} CampaignBudgetParameters
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            CampaignBudgetParameters.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a CampaignBudgetParameters message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            CampaignBudgetParameters.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.newBudgetAmountMicros != null && message.hasOwnProperty("newBudgetAmountMicros")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.newBudgetAmountMicros);
                                    if (error)
                                        return "newBudgetAmountMicros." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a CampaignBudgetParameters message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters} CampaignBudgetParameters
                             */
                            CampaignBudgetParameters.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters();
                                if (object.newBudgetAmountMicros != null) {
                                    if (typeof object.newBudgetAmountMicros !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters.newBudgetAmountMicros: object expected");
                                    message.newBudgetAmountMicros = $root.google.protobuf.Int64Value.fromObject(object.newBudgetAmountMicros);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a CampaignBudgetParameters message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters} message CampaignBudgetParameters
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            CampaignBudgetParameters.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults)
                                    object.newBudgetAmountMicros = null;
                                if (message.newBudgetAmountMicros != null && message.hasOwnProperty("newBudgetAmountMicros"))
                                    object.newBudgetAmountMicros = $root.google.protobuf.Int64Value.toObject(message.newBudgetAmountMicros, options);
                                return object;
                            };

                            /**
                             * Converts this CampaignBudgetParameters to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CampaignBudgetParameters
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            CampaignBudgetParameters.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return CampaignBudgetParameters;
                        })();

                        ApplyRecommendationOperation.TextAdParameters = (function() {

                            /**
                             * Properties of a TextAdParameters.
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                             * @interface ITextAdParameters
                             * @property {google.ads.googleads.v1.resources.IAd|null} [ad] TextAdParameters ad
                             */

                            /**
                             * Constructs a new TextAdParameters.
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                             * @classdesc Represents a TextAdParameters.
                             * @implements ITextAdParameters
                             * @constructor
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ITextAdParameters=} [properties] Properties to set
                             */
                            function TextAdParameters(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * TextAdParameters ad.
                             * @member {google.ads.googleads.v1.resources.IAd|null|undefined} ad
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters
                             * @instance
                             */
                            TextAdParameters.prototype.ad = null;

                            /**
                             * Creates a new TextAdParameters instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ITextAdParameters=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters} TextAdParameters instance
                             */
                            TextAdParameters.create = function create(properties) {
                                return new TextAdParameters(properties);
                            };

                            /**
                             * Encodes the specified TextAdParameters message. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ITextAdParameters} message TextAdParameters message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            TextAdParameters.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.ad != null && message.hasOwnProperty("ad"))
                                    $root.google.ads.googleads.v1.resources.Ad.encode(message.ad, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified TextAdParameters message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ITextAdParameters} message TextAdParameters message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            TextAdParameters.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a TextAdParameters message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters} TextAdParameters
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            TextAdParameters.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.ad = $root.google.ads.googleads.v1.resources.Ad.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a TextAdParameters message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters} TextAdParameters
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            TextAdParameters.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a TextAdParameters message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            TextAdParameters.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.ad != null && message.hasOwnProperty("ad")) {
                                    var error = $root.google.ads.googleads.v1.resources.Ad.verify(message.ad);
                                    if (error)
                                        return "ad." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a TextAdParameters message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters} TextAdParameters
                             */
                            TextAdParameters.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters();
                                if (object.ad != null) {
                                    if (typeof object.ad !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters.ad: object expected");
                                    message.ad = $root.google.ads.googleads.v1.resources.Ad.fromObject(object.ad);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a TextAdParameters message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters} message TextAdParameters
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            TextAdParameters.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults)
                                    object.ad = null;
                                if (message.ad != null && message.hasOwnProperty("ad"))
                                    object.ad = $root.google.ads.googleads.v1.resources.Ad.toObject(message.ad, options);
                                return object;
                            };

                            /**
                             * Converts this TextAdParameters to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TextAdParameters
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            TextAdParameters.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return TextAdParameters;
                        })();

                        ApplyRecommendationOperation.KeywordParameters = (function() {

                            /**
                             * Properties of a KeywordParameters.
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                             * @interface IKeywordParameters
                             * @property {google.protobuf.IStringValue|null} [adGroup] KeywordParameters adGroup
                             * @property {google.ads.googleads.v1.enums.KeywordMatchTypeEnum.KeywordMatchType|null} [matchType] KeywordParameters matchType
                             * @property {google.protobuf.IInt64Value|null} [cpcBidMicros] KeywordParameters cpcBidMicros
                             */

                            /**
                             * Constructs a new KeywordParameters.
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                             * @classdesc Represents a KeywordParameters.
                             * @implements IKeywordParameters
                             * @constructor
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.IKeywordParameters=} [properties] Properties to set
                             */
                            function KeywordParameters(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * KeywordParameters adGroup.
                             * @member {google.protobuf.IStringValue|null|undefined} adGroup
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters
                             * @instance
                             */
                            KeywordParameters.prototype.adGroup = null;

                            /**
                             * KeywordParameters matchType.
                             * @member {google.ads.googleads.v1.enums.KeywordMatchTypeEnum.KeywordMatchType} matchType
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters
                             * @instance
                             */
                            KeywordParameters.prototype.matchType = 0;

                            /**
                             * KeywordParameters cpcBidMicros.
                             * @member {google.protobuf.IInt64Value|null|undefined} cpcBidMicros
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters
                             * @instance
                             */
                            KeywordParameters.prototype.cpcBidMicros = null;

                            /**
                             * Creates a new KeywordParameters instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.IKeywordParameters=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters} KeywordParameters instance
                             */
                            KeywordParameters.create = function create(properties) {
                                return new KeywordParameters(properties);
                            };

                            /**
                             * Encodes the specified KeywordParameters message. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.IKeywordParameters} message KeywordParameters message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            KeywordParameters.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                    $root.google.protobuf.StringValue.encode(message.adGroup, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.matchType != null && message.hasOwnProperty("matchType"))
                                    writer.uint32(/* id 2, wireType 0 =*/16).int32(message.matchType);
                                if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros"))
                                    $root.google.protobuf.Int64Value.encode(message.cpcBidMicros, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified KeywordParameters message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.IKeywordParameters} message KeywordParameters message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            KeywordParameters.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a KeywordParameters message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters} KeywordParameters
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            KeywordParameters.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.adGroup = $root.google.protobuf.StringValue.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.matchType = reader.int32();
                                        break;
                                    case 3:
                                        message.cpcBidMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a KeywordParameters message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters} KeywordParameters
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            KeywordParameters.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a KeywordParameters message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            KeywordParameters.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.adGroup != null && message.hasOwnProperty("adGroup")) {
                                    var error = $root.google.protobuf.StringValue.verify(message.adGroup);
                                    if (error)
                                        return "adGroup." + error;
                                }
                                if (message.matchType != null && message.hasOwnProperty("matchType"))
                                    switch (message.matchType) {
                                    default:
                                        return "matchType: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                        break;
                                    }
                                if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.cpcBidMicros);
                                    if (error)
                                        return "cpcBidMicros." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a KeywordParameters message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters} KeywordParameters
                             */
                            KeywordParameters.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters();
                                if (object.adGroup != null) {
                                    if (typeof object.adGroup !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters.adGroup: object expected");
                                    message.adGroup = $root.google.protobuf.StringValue.fromObject(object.adGroup);
                                }
                                switch (object.matchType) {
                                case "UNSPECIFIED":
                                case 0:
                                    message.matchType = 0;
                                    break;
                                case "UNKNOWN":
                                case 1:
                                    message.matchType = 1;
                                    break;
                                case "EXACT":
                                case 2:
                                    message.matchType = 2;
                                    break;
                                case "PHRASE":
                                case 3:
                                    message.matchType = 3;
                                    break;
                                case "BROAD":
                                case 4:
                                    message.matchType = 4;
                                    break;
                                }
                                if (object.cpcBidMicros != null) {
                                    if (typeof object.cpcBidMicros !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters.cpcBidMicros: object expected");
                                    message.cpcBidMicros = $root.google.protobuf.Int64Value.fromObject(object.cpcBidMicros);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a KeywordParameters message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters} message KeywordParameters
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            KeywordParameters.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.adGroup = null;
                                    object.matchType = options.enums === String ? "UNSPECIFIED" : 0;
                                    object.cpcBidMicros = null;
                                }
                                if (message.adGroup != null && message.hasOwnProperty("adGroup"))
                                    object.adGroup = $root.google.protobuf.StringValue.toObject(message.adGroup, options);
                                if (message.matchType != null && message.hasOwnProperty("matchType"))
                                    object.matchType = options.enums === String ? $root.google.ads.googleads.v1.enums.KeywordMatchTypeEnum.KeywordMatchType[message.matchType] : message.matchType;
                                if (message.cpcBidMicros != null && message.hasOwnProperty("cpcBidMicros"))
                                    object.cpcBidMicros = $root.google.protobuf.Int64Value.toObject(message.cpcBidMicros, options);
                                return object;
                            };

                            /**
                             * Converts this KeywordParameters to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.KeywordParameters
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            KeywordParameters.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return KeywordParameters;
                        })();

                        ApplyRecommendationOperation.TargetCpaOptInParameters = (function() {

                            /**
                             * Properties of a TargetCpaOptInParameters.
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                             * @interface ITargetCpaOptInParameters
                             * @property {google.protobuf.IInt64Value|null} [targetCpaMicros] TargetCpaOptInParameters targetCpaMicros
                             * @property {google.protobuf.IInt64Value|null} [newCampaignBudgetAmountMicros] TargetCpaOptInParameters newCampaignBudgetAmountMicros
                             */

                            /**
                             * Constructs a new TargetCpaOptInParameters.
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                             * @classdesc Represents a TargetCpaOptInParameters.
                             * @implements ITargetCpaOptInParameters
                             * @constructor
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ITargetCpaOptInParameters=} [properties] Properties to set
                             */
                            function TargetCpaOptInParameters(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * TargetCpaOptInParameters targetCpaMicros.
                             * @member {google.protobuf.IInt64Value|null|undefined} targetCpaMicros
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters
                             * @instance
                             */
                            TargetCpaOptInParameters.prototype.targetCpaMicros = null;

                            /**
                             * TargetCpaOptInParameters newCampaignBudgetAmountMicros.
                             * @member {google.protobuf.IInt64Value|null|undefined} newCampaignBudgetAmountMicros
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters
                             * @instance
                             */
                            TargetCpaOptInParameters.prototype.newCampaignBudgetAmountMicros = null;

                            /**
                             * Creates a new TargetCpaOptInParameters instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ITargetCpaOptInParameters=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters} TargetCpaOptInParameters instance
                             */
                            TargetCpaOptInParameters.create = function create(properties) {
                                return new TargetCpaOptInParameters(properties);
                            };

                            /**
                             * Encodes the specified TargetCpaOptInParameters message. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ITargetCpaOptInParameters} message TargetCpaOptInParameters message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            TargetCpaOptInParameters.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.targetCpaMicros != null && message.hasOwnProperty("targetCpaMicros"))
                                    $root.google.protobuf.Int64Value.encode(message.targetCpaMicros, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.newCampaignBudgetAmountMicros != null && message.hasOwnProperty("newCampaignBudgetAmountMicros"))
                                    $root.google.protobuf.Int64Value.encode(message.newCampaignBudgetAmountMicros, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified TargetCpaOptInParameters message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ITargetCpaOptInParameters} message TargetCpaOptInParameters message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            TargetCpaOptInParameters.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a TargetCpaOptInParameters message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters} TargetCpaOptInParameters
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            TargetCpaOptInParameters.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.targetCpaMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    case 2:
                                        message.newCampaignBudgetAmountMicros = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a TargetCpaOptInParameters message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters} TargetCpaOptInParameters
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            TargetCpaOptInParameters.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a TargetCpaOptInParameters message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            TargetCpaOptInParameters.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.targetCpaMicros != null && message.hasOwnProperty("targetCpaMicros")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.targetCpaMicros);
                                    if (error)
                                        return "targetCpaMicros." + error;
                                }
                                if (message.newCampaignBudgetAmountMicros != null && message.hasOwnProperty("newCampaignBudgetAmountMicros")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.newCampaignBudgetAmountMicros);
                                    if (error)
                                        return "newCampaignBudgetAmountMicros." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a TargetCpaOptInParameters message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters} TargetCpaOptInParameters
                             */
                            TargetCpaOptInParameters.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters();
                                if (object.targetCpaMicros != null) {
                                    if (typeof object.targetCpaMicros !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters.targetCpaMicros: object expected");
                                    message.targetCpaMicros = $root.google.protobuf.Int64Value.fromObject(object.targetCpaMicros);
                                }
                                if (object.newCampaignBudgetAmountMicros != null) {
                                    if (typeof object.newCampaignBudgetAmountMicros !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters.newCampaignBudgetAmountMicros: object expected");
                                    message.newCampaignBudgetAmountMicros = $root.google.protobuf.Int64Value.fromObject(object.newCampaignBudgetAmountMicros);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a TargetCpaOptInParameters message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters} message TargetCpaOptInParameters
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            TargetCpaOptInParameters.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.targetCpaMicros = null;
                                    object.newCampaignBudgetAmountMicros = null;
                                }
                                if (message.targetCpaMicros != null && message.hasOwnProperty("targetCpaMicros"))
                                    object.targetCpaMicros = $root.google.protobuf.Int64Value.toObject(message.targetCpaMicros, options);
                                if (message.newCampaignBudgetAmountMicros != null && message.hasOwnProperty("newCampaignBudgetAmountMicros"))
                                    object.newCampaignBudgetAmountMicros = $root.google.protobuf.Int64Value.toObject(message.newCampaignBudgetAmountMicros, options);
                                return object;
                            };

                            /**
                             * Converts this TargetCpaOptInParameters to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.TargetCpaOptInParameters
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            TargetCpaOptInParameters.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return TargetCpaOptInParameters;
                        })();

                        ApplyRecommendationOperation.CalloutExtensionParameters = (function() {

                            /**
                             * Properties of a CalloutExtensionParameters.
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                             * @interface ICalloutExtensionParameters
                             * @property {Array.<google.ads.googleads.v1.common.ICalloutFeedItem>|null} [calloutExtensions] CalloutExtensionParameters calloutExtensions
                             */

                            /**
                             * Constructs a new CalloutExtensionParameters.
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                             * @classdesc Represents a CalloutExtensionParameters.
                             * @implements ICalloutExtensionParameters
                             * @constructor
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ICalloutExtensionParameters=} [properties] Properties to set
                             */
                            function CalloutExtensionParameters(properties) {
                                this.calloutExtensions = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * CalloutExtensionParameters calloutExtensions.
                             * @member {Array.<google.ads.googleads.v1.common.ICalloutFeedItem>} calloutExtensions
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters
                             * @instance
                             */
                            CalloutExtensionParameters.prototype.calloutExtensions = $util.emptyArray;

                            /**
                             * Creates a new CalloutExtensionParameters instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ICalloutExtensionParameters=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters} CalloutExtensionParameters instance
                             */
                            CalloutExtensionParameters.create = function create(properties) {
                                return new CalloutExtensionParameters(properties);
                            };

                            /**
                             * Encodes the specified CalloutExtensionParameters message. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ICalloutExtensionParameters} message CalloutExtensionParameters message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            CalloutExtensionParameters.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.calloutExtensions != null && message.calloutExtensions.length)
                                    for (var i = 0; i < message.calloutExtensions.length; ++i)
                                        $root.google.ads.googleads.v1.common.CalloutFeedItem.encode(message.calloutExtensions[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified CalloutExtensionParameters message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ICalloutExtensionParameters} message CalloutExtensionParameters message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            CalloutExtensionParameters.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a CalloutExtensionParameters message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters} CalloutExtensionParameters
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            CalloutExtensionParameters.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        if (!(message.calloutExtensions && message.calloutExtensions.length))
                                            message.calloutExtensions = [];
                                        message.calloutExtensions.push($root.google.ads.googleads.v1.common.CalloutFeedItem.decode(reader, reader.uint32()));
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a CalloutExtensionParameters message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters} CalloutExtensionParameters
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            CalloutExtensionParameters.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a CalloutExtensionParameters message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            CalloutExtensionParameters.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.calloutExtensions != null && message.hasOwnProperty("calloutExtensions")) {
                                    if (!Array.isArray(message.calloutExtensions))
                                        return "calloutExtensions: array expected";
                                    for (var i = 0; i < message.calloutExtensions.length; ++i) {
                                        var error = $root.google.ads.googleads.v1.common.CalloutFeedItem.verify(message.calloutExtensions[i]);
                                        if (error)
                                            return "calloutExtensions." + error;
                                    }
                                }
                                return null;
                            };

                            /**
                             * Creates a CalloutExtensionParameters message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters} CalloutExtensionParameters
                             */
                            CalloutExtensionParameters.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters();
                                if (object.calloutExtensions) {
                                    if (!Array.isArray(object.calloutExtensions))
                                        throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters.calloutExtensions: array expected");
                                    message.calloutExtensions = [];
                                    for (var i = 0; i < object.calloutExtensions.length; ++i) {
                                        if (typeof object.calloutExtensions[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters.calloutExtensions: object expected");
                                        message.calloutExtensions[i] = $root.google.ads.googleads.v1.common.CalloutFeedItem.fromObject(object.calloutExtensions[i]);
                                    }
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a CalloutExtensionParameters message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters} message CalloutExtensionParameters
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            CalloutExtensionParameters.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.calloutExtensions = [];
                                if (message.calloutExtensions && message.calloutExtensions.length) {
                                    object.calloutExtensions = [];
                                    for (var j = 0; j < message.calloutExtensions.length; ++j)
                                        object.calloutExtensions[j] = $root.google.ads.googleads.v1.common.CalloutFeedItem.toObject(message.calloutExtensions[j], options);
                                }
                                return object;
                            };

                            /**
                             * Converts this CalloutExtensionParameters to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CalloutExtensionParameters
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            CalloutExtensionParameters.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return CalloutExtensionParameters;
                        })();

                        ApplyRecommendationOperation.CallExtensionParameters = (function() {

                            /**
                             * Properties of a CallExtensionParameters.
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                             * @interface ICallExtensionParameters
                             * @property {Array.<google.ads.googleads.v1.common.ICallFeedItem>|null} [callExtensions] CallExtensionParameters callExtensions
                             */

                            /**
                             * Constructs a new CallExtensionParameters.
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                             * @classdesc Represents a CallExtensionParameters.
                             * @implements ICallExtensionParameters
                             * @constructor
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ICallExtensionParameters=} [properties] Properties to set
                             */
                            function CallExtensionParameters(properties) {
                                this.callExtensions = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * CallExtensionParameters callExtensions.
                             * @member {Array.<google.ads.googleads.v1.common.ICallFeedItem>} callExtensions
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters
                             * @instance
                             */
                            CallExtensionParameters.prototype.callExtensions = $util.emptyArray;

                            /**
                             * Creates a new CallExtensionParameters instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ICallExtensionParameters=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters} CallExtensionParameters instance
                             */
                            CallExtensionParameters.create = function create(properties) {
                                return new CallExtensionParameters(properties);
                            };

                            /**
                             * Encodes the specified CallExtensionParameters message. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ICallExtensionParameters} message CallExtensionParameters message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            CallExtensionParameters.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.callExtensions != null && message.callExtensions.length)
                                    for (var i = 0; i < message.callExtensions.length; ++i)
                                        $root.google.ads.googleads.v1.common.CallFeedItem.encode(message.callExtensions[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified CallExtensionParameters message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ICallExtensionParameters} message CallExtensionParameters message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            CallExtensionParameters.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a CallExtensionParameters message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters} CallExtensionParameters
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            CallExtensionParameters.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        if (!(message.callExtensions && message.callExtensions.length))
                                            message.callExtensions = [];
                                        message.callExtensions.push($root.google.ads.googleads.v1.common.CallFeedItem.decode(reader, reader.uint32()));
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a CallExtensionParameters message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters} CallExtensionParameters
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            CallExtensionParameters.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a CallExtensionParameters message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            CallExtensionParameters.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.callExtensions != null && message.hasOwnProperty("callExtensions")) {
                                    if (!Array.isArray(message.callExtensions))
                                        return "callExtensions: array expected";
                                    for (var i = 0; i < message.callExtensions.length; ++i) {
                                        var error = $root.google.ads.googleads.v1.common.CallFeedItem.verify(message.callExtensions[i]);
                                        if (error)
                                            return "callExtensions." + error;
                                    }
                                }
                                return null;
                            };

                            /**
                             * Creates a CallExtensionParameters message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters} CallExtensionParameters
                             */
                            CallExtensionParameters.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters();
                                if (object.callExtensions) {
                                    if (!Array.isArray(object.callExtensions))
                                        throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters.callExtensions: array expected");
                                    message.callExtensions = [];
                                    for (var i = 0; i < object.callExtensions.length; ++i) {
                                        if (typeof object.callExtensions[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters.callExtensions: object expected");
                                        message.callExtensions[i] = $root.google.ads.googleads.v1.common.CallFeedItem.fromObject(object.callExtensions[i]);
                                    }
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a CallExtensionParameters message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters} message CallExtensionParameters
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            CallExtensionParameters.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.callExtensions = [];
                                if (message.callExtensions && message.callExtensions.length) {
                                    object.callExtensions = [];
                                    for (var j = 0; j < message.callExtensions.length; ++j)
                                        object.callExtensions[j] = $root.google.ads.googleads.v1.common.CallFeedItem.toObject(message.callExtensions[j], options);
                                }
                                return object;
                            };

                            /**
                             * Converts this CallExtensionParameters to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.CallExtensionParameters
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            CallExtensionParameters.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return CallExtensionParameters;
                        })();

                        ApplyRecommendationOperation.SitelinkExtensionParameters = (function() {

                            /**
                             * Properties of a SitelinkExtensionParameters.
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                             * @interface ISitelinkExtensionParameters
                             * @property {Array.<google.ads.googleads.v1.common.ISitelinkFeedItem>|null} [sitelinkExtensions] SitelinkExtensionParameters sitelinkExtensions
                             */

                            /**
                             * Constructs a new SitelinkExtensionParameters.
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                             * @classdesc Represents a SitelinkExtensionParameters.
                             * @implements ISitelinkExtensionParameters
                             * @constructor
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ISitelinkExtensionParameters=} [properties] Properties to set
                             */
                            function SitelinkExtensionParameters(properties) {
                                this.sitelinkExtensions = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * SitelinkExtensionParameters sitelinkExtensions.
                             * @member {Array.<google.ads.googleads.v1.common.ISitelinkFeedItem>} sitelinkExtensions
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters
                             * @instance
                             */
                            SitelinkExtensionParameters.prototype.sitelinkExtensions = $util.emptyArray;

                            /**
                             * Creates a new SitelinkExtensionParameters instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ISitelinkExtensionParameters=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters} SitelinkExtensionParameters instance
                             */
                            SitelinkExtensionParameters.create = function create(properties) {
                                return new SitelinkExtensionParameters(properties);
                            };

                            /**
                             * Encodes the specified SitelinkExtensionParameters message. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ISitelinkExtensionParameters} message SitelinkExtensionParameters message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            SitelinkExtensionParameters.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.sitelinkExtensions != null && message.sitelinkExtensions.length)
                                    for (var i = 0; i < message.sitelinkExtensions.length; ++i)
                                        $root.google.ads.googleads.v1.common.SitelinkFeedItem.encode(message.sitelinkExtensions[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified SitelinkExtensionParameters message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.ISitelinkExtensionParameters} message SitelinkExtensionParameters message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            SitelinkExtensionParameters.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a SitelinkExtensionParameters message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters} SitelinkExtensionParameters
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            SitelinkExtensionParameters.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        if (!(message.sitelinkExtensions && message.sitelinkExtensions.length))
                                            message.sitelinkExtensions = [];
                                        message.sitelinkExtensions.push($root.google.ads.googleads.v1.common.SitelinkFeedItem.decode(reader, reader.uint32()));
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a SitelinkExtensionParameters message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters} SitelinkExtensionParameters
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            SitelinkExtensionParameters.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a SitelinkExtensionParameters message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            SitelinkExtensionParameters.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.sitelinkExtensions != null && message.hasOwnProperty("sitelinkExtensions")) {
                                    if (!Array.isArray(message.sitelinkExtensions))
                                        return "sitelinkExtensions: array expected";
                                    for (var i = 0; i < message.sitelinkExtensions.length; ++i) {
                                        var error = $root.google.ads.googleads.v1.common.SitelinkFeedItem.verify(message.sitelinkExtensions[i]);
                                        if (error)
                                            return "sitelinkExtensions." + error;
                                    }
                                }
                                return null;
                            };

                            /**
                             * Creates a SitelinkExtensionParameters message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters} SitelinkExtensionParameters
                             */
                            SitelinkExtensionParameters.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters();
                                if (object.sitelinkExtensions) {
                                    if (!Array.isArray(object.sitelinkExtensions))
                                        throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters.sitelinkExtensions: array expected");
                                    message.sitelinkExtensions = [];
                                    for (var i = 0; i < object.sitelinkExtensions.length; ++i) {
                                        if (typeof object.sitelinkExtensions[i] !== "object")
                                            throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters.sitelinkExtensions: object expected");
                                        message.sitelinkExtensions[i] = $root.google.ads.googleads.v1.common.SitelinkFeedItem.fromObject(object.sitelinkExtensions[i]);
                                    }
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a SitelinkExtensionParameters message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters} message SitelinkExtensionParameters
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            SitelinkExtensionParameters.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.sitelinkExtensions = [];
                                if (message.sitelinkExtensions && message.sitelinkExtensions.length) {
                                    object.sitelinkExtensions = [];
                                    for (var j = 0; j < message.sitelinkExtensions.length; ++j)
                                        object.sitelinkExtensions[j] = $root.google.ads.googleads.v1.common.SitelinkFeedItem.toObject(message.sitelinkExtensions[j], options);
                                }
                                return object;
                            };

                            /**
                             * Converts this SitelinkExtensionParameters to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.SitelinkExtensionParameters
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            SitelinkExtensionParameters.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return SitelinkExtensionParameters;
                        })();

                        ApplyRecommendationOperation.MoveUnusedBudgetParameters = (function() {

                            /**
                             * Properties of a MoveUnusedBudgetParameters.
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                             * @interface IMoveUnusedBudgetParameters
                             * @property {google.protobuf.IInt64Value|null} [budgetMicrosToMove] MoveUnusedBudgetParameters budgetMicrosToMove
                             */

                            /**
                             * Constructs a new MoveUnusedBudgetParameters.
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation
                             * @classdesc Represents a MoveUnusedBudgetParameters.
                             * @implements IMoveUnusedBudgetParameters
                             * @constructor
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.IMoveUnusedBudgetParameters=} [properties] Properties to set
                             */
                            function MoveUnusedBudgetParameters(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * MoveUnusedBudgetParameters budgetMicrosToMove.
                             * @member {google.protobuf.IInt64Value|null|undefined} budgetMicrosToMove
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters
                             * @instance
                             */
                            MoveUnusedBudgetParameters.prototype.budgetMicrosToMove = null;

                            /**
                             * Creates a new MoveUnusedBudgetParameters instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.IMoveUnusedBudgetParameters=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters} MoveUnusedBudgetParameters instance
                             */
                            MoveUnusedBudgetParameters.create = function create(properties) {
                                return new MoveUnusedBudgetParameters(properties);
                            };

                            /**
                             * Encodes the specified MoveUnusedBudgetParameters message. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.IMoveUnusedBudgetParameters} message MoveUnusedBudgetParameters message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            MoveUnusedBudgetParameters.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.budgetMicrosToMove != null && message.hasOwnProperty("budgetMicrosToMove"))
                                    $root.google.protobuf.Int64Value.encode(message.budgetMicrosToMove, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                return writer;
                            };

                            /**
                             * Encodes the specified MoveUnusedBudgetParameters message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.IMoveUnusedBudgetParameters} message MoveUnusedBudgetParameters message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            MoveUnusedBudgetParameters.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a MoveUnusedBudgetParameters message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters} MoveUnusedBudgetParameters
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            MoveUnusedBudgetParameters.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.budgetMicrosToMove = $root.google.protobuf.Int64Value.decode(reader, reader.uint32());
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a MoveUnusedBudgetParameters message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters} MoveUnusedBudgetParameters
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            MoveUnusedBudgetParameters.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a MoveUnusedBudgetParameters message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            MoveUnusedBudgetParameters.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.budgetMicrosToMove != null && message.hasOwnProperty("budgetMicrosToMove")) {
                                    var error = $root.google.protobuf.Int64Value.verify(message.budgetMicrosToMove);
                                    if (error)
                                        return "budgetMicrosToMove." + error;
                                }
                                return null;
                            };

                            /**
                             * Creates a MoveUnusedBudgetParameters message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters} MoveUnusedBudgetParameters
                             */
                            MoveUnusedBudgetParameters.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters();
                                if (object.budgetMicrosToMove != null) {
                                    if (typeof object.budgetMicrosToMove !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters.budgetMicrosToMove: object expected");
                                    message.budgetMicrosToMove = $root.google.protobuf.Int64Value.fromObject(object.budgetMicrosToMove);
                                }
                                return message;
                            };

                            /**
                             * Creates a plain object from a MoveUnusedBudgetParameters message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters
                             * @static
                             * @param {google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters} message MoveUnusedBudgetParameters
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            MoveUnusedBudgetParameters.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults)
                                    object.budgetMicrosToMove = null;
                                if (message.budgetMicrosToMove != null && message.hasOwnProperty("budgetMicrosToMove"))
                                    object.budgetMicrosToMove = $root.google.protobuf.Int64Value.toObject(message.budgetMicrosToMove, options);
                                return object;
                            };

                            /**
                             * Converts this MoveUnusedBudgetParameters to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.services.ApplyRecommendationOperation.MoveUnusedBudgetParameters
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            MoveUnusedBudgetParameters.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return MoveUnusedBudgetParameters;
                        })();

                        return ApplyRecommendationOperation;
                    })();

                    services.ApplyRecommendationResponse = (function() {

                        /**
                         * Properties of an ApplyRecommendationResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IApplyRecommendationResponse
                         * @property {Array.<google.ads.googleads.v1.services.IApplyRecommendationResult>|null} [results] ApplyRecommendationResponse results
                         * @property {google.rpc.IStatus|null} [partialFailureError] ApplyRecommendationResponse partialFailureError
                         */

                        /**
                         * Constructs a new ApplyRecommendationResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an ApplyRecommendationResponse.
                         * @implements IApplyRecommendationResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IApplyRecommendationResponse=} [properties] Properties to set
                         */
                        function ApplyRecommendationResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ApplyRecommendationResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IApplyRecommendationResult>} results
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResponse
                         * @instance
                         */
                        ApplyRecommendationResponse.prototype.results = $util.emptyArray;

                        /**
                         * ApplyRecommendationResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResponse
                         * @instance
                         */
                        ApplyRecommendationResponse.prototype.partialFailureError = null;

                        /**
                         * Creates a new ApplyRecommendationResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IApplyRecommendationResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ApplyRecommendationResponse} ApplyRecommendationResponse instance
                         */
                        ApplyRecommendationResponse.create = function create(properties) {
                            return new ApplyRecommendationResponse(properties);
                        };

                        /**
                         * Encodes the specified ApplyRecommendationResponse message. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IApplyRecommendationResponse} message ApplyRecommendationResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ApplyRecommendationResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.ApplyRecommendationResult.encode(message.results[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified ApplyRecommendationResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IApplyRecommendationResponse} message ApplyRecommendationResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ApplyRecommendationResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ApplyRecommendationResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ApplyRecommendationResponse} ApplyRecommendationResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ApplyRecommendationResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ApplyRecommendationResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.ApplyRecommendationResult.decode(reader, reader.uint32()));
                                    break;
                                case 2:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ApplyRecommendationResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ApplyRecommendationResponse} ApplyRecommendationResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ApplyRecommendationResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ApplyRecommendationResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ApplyRecommendationResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.ApplyRecommendationResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates an ApplyRecommendationResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ApplyRecommendationResponse} ApplyRecommendationResponse
                         */
                        ApplyRecommendationResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ApplyRecommendationResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ApplyRecommendationResponse();
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.ApplyRecommendationResult.fromObject(object.results[i]);
                                }
                            }
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.ApplyRecommendationResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from an ApplyRecommendationResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.ApplyRecommendationResponse} message ApplyRecommendationResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ApplyRecommendationResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.ApplyRecommendationResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this ApplyRecommendationResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ApplyRecommendationResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ApplyRecommendationResponse;
                    })();

                    services.ApplyRecommendationResult = (function() {

                        /**
                         * Properties of an ApplyRecommendationResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IApplyRecommendationResult
                         * @property {string|null} [resourceName] ApplyRecommendationResult resourceName
                         */

                        /**
                         * Constructs a new ApplyRecommendationResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents an ApplyRecommendationResult.
                         * @implements IApplyRecommendationResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IApplyRecommendationResult=} [properties] Properties to set
                         */
                        function ApplyRecommendationResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * ApplyRecommendationResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResult
                         * @instance
                         */
                        ApplyRecommendationResult.prototype.resourceName = "";

                        /**
                         * Creates a new ApplyRecommendationResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IApplyRecommendationResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.ApplyRecommendationResult} ApplyRecommendationResult instance
                         */
                        ApplyRecommendationResult.create = function create(properties) {
                            return new ApplyRecommendationResult(properties);
                        };

                        /**
                         * Encodes the specified ApplyRecommendationResult message. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IApplyRecommendationResult} message ApplyRecommendationResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ApplyRecommendationResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified ApplyRecommendationResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.ApplyRecommendationResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IApplyRecommendationResult} message ApplyRecommendationResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ApplyRecommendationResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes an ApplyRecommendationResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.ApplyRecommendationResult} ApplyRecommendationResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ApplyRecommendationResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.ApplyRecommendationResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes an ApplyRecommendationResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.ApplyRecommendationResult} ApplyRecommendationResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ApplyRecommendationResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies an ApplyRecommendationResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ApplyRecommendationResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates an ApplyRecommendationResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.ApplyRecommendationResult} ApplyRecommendationResult
                         */
                        ApplyRecommendationResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.ApplyRecommendationResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.ApplyRecommendationResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from an ApplyRecommendationResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResult
                         * @static
                         * @param {google.ads.googleads.v1.services.ApplyRecommendationResult} message ApplyRecommendationResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ApplyRecommendationResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this ApplyRecommendationResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.ApplyRecommendationResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ApplyRecommendationResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return ApplyRecommendationResult;
                    })();

                    services.DismissRecommendationRequest = (function() {

                        /**
                         * Properties of a DismissRecommendationRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IDismissRecommendationRequest
                         * @property {string|null} [customerId] DismissRecommendationRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.DismissRecommendationRequest.IDismissRecommendationOperation>|null} [operations] DismissRecommendationRequest operations
                         * @property {boolean|null} [partialFailure] DismissRecommendationRequest partialFailure
                         */

                        /**
                         * Constructs a new DismissRecommendationRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a DismissRecommendationRequest.
                         * @implements IDismissRecommendationRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IDismissRecommendationRequest=} [properties] Properties to set
                         */
                        function DismissRecommendationRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * DismissRecommendationRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest
                         * @instance
                         */
                        DismissRecommendationRequest.prototype.customerId = "";

                        /**
                         * DismissRecommendationRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.DismissRecommendationRequest.IDismissRecommendationOperation>} operations
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest
                         * @instance
                         */
                        DismissRecommendationRequest.prototype.operations = $util.emptyArray;

                        /**
                         * DismissRecommendationRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest
                         * @instance
                         */
                        DismissRecommendationRequest.prototype.partialFailure = false;

                        /**
                         * Creates a new DismissRecommendationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IDismissRecommendationRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.DismissRecommendationRequest} DismissRecommendationRequest instance
                         */
                        DismissRecommendationRequest.create = function create(properties) {
                            return new DismissRecommendationRequest(properties);
                        };

                        /**
                         * Encodes the specified DismissRecommendationRequest message. Does not implicitly {@link google.ads.googleads.v1.services.DismissRecommendationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IDismissRecommendationRequest} message DismissRecommendationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DismissRecommendationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 2, wireType 0 =*/16).bool(message.partialFailure);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation.encode(message.operations[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified DismissRecommendationRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.DismissRecommendationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IDismissRecommendationRequest} message DismissRecommendationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DismissRecommendationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DismissRecommendationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.DismissRecommendationRequest} DismissRecommendationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DismissRecommendationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.DismissRecommendationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 3:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation.decode(reader, reader.uint32()));
                                    break;
                                case 2:
                                    message.partialFailure = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DismissRecommendationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.DismissRecommendationRequest} DismissRecommendationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DismissRecommendationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DismissRecommendationRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DismissRecommendationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a DismissRecommendationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.DismissRecommendationRequest} DismissRecommendationRequest
                         */
                        DismissRecommendationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.DismissRecommendationRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.DismissRecommendationRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.DismissRecommendationRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.DismissRecommendationRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            return message;
                        };

                        /**
                         * Creates a plain object from a DismissRecommendationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.DismissRecommendationRequest} message DismissRecommendationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DismissRecommendationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation.toObject(message.operations[j], options);
                            }
                            return object;
                        };

                        /**
                         * Converts this DismissRecommendationRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DismissRecommendationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        DismissRecommendationRequest.DismissRecommendationOperation = (function() {

                            /**
                             * Properties of a DismissRecommendationOperation.
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest
                             * @interface IDismissRecommendationOperation
                             * @property {string|null} [resourceName] DismissRecommendationOperation resourceName
                             */

                            /**
                             * Constructs a new DismissRecommendationOperation.
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest
                             * @classdesc Represents a DismissRecommendationOperation.
                             * @implements IDismissRecommendationOperation
                             * @constructor
                             * @param {google.ads.googleads.v1.services.DismissRecommendationRequest.IDismissRecommendationOperation=} [properties] Properties to set
                             */
                            function DismissRecommendationOperation(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * DismissRecommendationOperation resourceName.
                             * @member {string} resourceName
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation
                             * @instance
                             */
                            DismissRecommendationOperation.prototype.resourceName = "";

                            /**
                             * Creates a new DismissRecommendationOperation instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation
                             * @static
                             * @param {google.ads.googleads.v1.services.DismissRecommendationRequest.IDismissRecommendationOperation=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation} DismissRecommendationOperation instance
                             */
                            DismissRecommendationOperation.create = function create(properties) {
                                return new DismissRecommendationOperation(properties);
                            };

                            /**
                             * Encodes the specified DismissRecommendationOperation message. Does not implicitly {@link google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation
                             * @static
                             * @param {google.ads.googleads.v1.services.DismissRecommendationRequest.IDismissRecommendationOperation} message DismissRecommendationOperation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            DismissRecommendationOperation.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                                return writer;
                            };

                            /**
                             * Encodes the specified DismissRecommendationOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation
                             * @static
                             * @param {google.ads.googleads.v1.services.DismissRecommendationRequest.IDismissRecommendationOperation} message DismissRecommendationOperation message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            DismissRecommendationOperation.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a DismissRecommendationOperation message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation} DismissRecommendationOperation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            DismissRecommendationOperation.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.resourceName = reader.string();
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a DismissRecommendationOperation message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation} DismissRecommendationOperation
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            DismissRecommendationOperation.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a DismissRecommendationOperation message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            DismissRecommendationOperation.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                    if (!$util.isString(message.resourceName))
                                        return "resourceName: string expected";
                                return null;
                            };

                            /**
                             * Creates a DismissRecommendationOperation message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation} DismissRecommendationOperation
                             */
                            DismissRecommendationOperation.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation();
                                if (object.resourceName != null)
                                    message.resourceName = String(object.resourceName);
                                return message;
                            };

                            /**
                             * Creates a plain object from a DismissRecommendationOperation message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation
                             * @static
                             * @param {google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation} message DismissRecommendationOperation
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            DismissRecommendationOperation.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults)
                                    object.resourceName = "";
                                if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                    object.resourceName = message.resourceName;
                                return object;
                            };

                            /**
                             * Converts this DismissRecommendationOperation to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationRequest.DismissRecommendationOperation
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            DismissRecommendationOperation.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return DismissRecommendationOperation;
                        })();

                        return DismissRecommendationRequest;
                    })();

                    services.DismissRecommendationResponse = (function() {

                        /**
                         * Properties of a DismissRecommendationResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IDismissRecommendationResponse
                         * @property {Array.<google.ads.googleads.v1.services.DismissRecommendationResponse.IDismissRecommendationResult>|null} [results] DismissRecommendationResponse results
                         * @property {google.rpc.IStatus|null} [partialFailureError] DismissRecommendationResponse partialFailureError
                         */

                        /**
                         * Constructs a new DismissRecommendationResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a DismissRecommendationResponse.
                         * @implements IDismissRecommendationResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IDismissRecommendationResponse=} [properties] Properties to set
                         */
                        function DismissRecommendationResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * DismissRecommendationResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.DismissRecommendationResponse.IDismissRecommendationResult>} results
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse
                         * @instance
                         */
                        DismissRecommendationResponse.prototype.results = $util.emptyArray;

                        /**
                         * DismissRecommendationResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse
                         * @instance
                         */
                        DismissRecommendationResponse.prototype.partialFailureError = null;

                        /**
                         * Creates a new DismissRecommendationResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IDismissRecommendationResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.DismissRecommendationResponse} DismissRecommendationResponse instance
                         */
                        DismissRecommendationResponse.create = function create(properties) {
                            return new DismissRecommendationResponse(properties);
                        };

                        /**
                         * Encodes the specified DismissRecommendationResponse message. Does not implicitly {@link google.ads.googleads.v1.services.DismissRecommendationResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IDismissRecommendationResponse} message DismissRecommendationResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DismissRecommendationResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult.encode(message.results[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified DismissRecommendationResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.DismissRecommendationResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IDismissRecommendationResponse} message DismissRecommendationResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DismissRecommendationResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a DismissRecommendationResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.DismissRecommendationResponse} DismissRecommendationResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DismissRecommendationResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.DismissRecommendationResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult.decode(reader, reader.uint32()));
                                    break;
                                case 2:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a DismissRecommendationResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.DismissRecommendationResponse} DismissRecommendationResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DismissRecommendationResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a DismissRecommendationResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DismissRecommendationResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            return null;
                        };

                        /**
                         * Creates a DismissRecommendationResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.DismissRecommendationResponse} DismissRecommendationResponse
                         */
                        DismissRecommendationResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.DismissRecommendationResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.DismissRecommendationResponse();
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.DismissRecommendationResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.DismissRecommendationResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult.fromObject(object.results[i]);
                                }
                            }
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.DismissRecommendationResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a DismissRecommendationResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.DismissRecommendationResponse} message DismissRecommendationResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DismissRecommendationResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this DismissRecommendationResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DismissRecommendationResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        DismissRecommendationResponse.DismissRecommendationResult = (function() {

                            /**
                             * Properties of a DismissRecommendationResult.
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse
                             * @interface IDismissRecommendationResult
                             * @property {string|null} [resourceName] DismissRecommendationResult resourceName
                             */

                            /**
                             * Constructs a new DismissRecommendationResult.
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse
                             * @classdesc Represents a DismissRecommendationResult.
                             * @implements IDismissRecommendationResult
                             * @constructor
                             * @param {google.ads.googleads.v1.services.DismissRecommendationResponse.IDismissRecommendationResult=} [properties] Properties to set
                             */
                            function DismissRecommendationResult(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }

                            /**
                             * DismissRecommendationResult resourceName.
                             * @member {string} resourceName
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult
                             * @instance
                             */
                            DismissRecommendationResult.prototype.resourceName = "";

                            /**
                             * Creates a new DismissRecommendationResult instance using the specified properties.
                             * @function create
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult
                             * @static
                             * @param {google.ads.googleads.v1.services.DismissRecommendationResponse.IDismissRecommendationResult=} [properties] Properties to set
                             * @returns {google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult} DismissRecommendationResult instance
                             */
                            DismissRecommendationResult.create = function create(properties) {
                                return new DismissRecommendationResult(properties);
                            };

                            /**
                             * Encodes the specified DismissRecommendationResult message. Does not implicitly {@link google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult.verify|verify} messages.
                             * @function encode
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult
                             * @static
                             * @param {google.ads.googleads.v1.services.DismissRecommendationResponse.IDismissRecommendationResult} message DismissRecommendationResult message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            DismissRecommendationResult.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                                return writer;
                            };

                            /**
                             * Encodes the specified DismissRecommendationResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult
                             * @static
                             * @param {google.ads.googleads.v1.services.DismissRecommendationResponse.IDismissRecommendationResult} message DismissRecommendationResult message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            DismissRecommendationResult.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };

                            /**
                             * Decodes a DismissRecommendationResult message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult} DismissRecommendationResult
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            DismissRecommendationResult.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1:
                                        message.resourceName = reader.string();
                                        break;
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };

                            /**
                             * Decodes a DismissRecommendationResult message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult} DismissRecommendationResult
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            DismissRecommendationResult.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };

                            /**
                             * Verifies a DismissRecommendationResult message.
                             * @function verify
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            DismissRecommendationResult.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                    if (!$util.isString(message.resourceName))
                                        return "resourceName: string expected";
                                return null;
                            };

                            /**
                             * Creates a DismissRecommendationResult message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult} DismissRecommendationResult
                             */
                            DismissRecommendationResult.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult)
                                    return object;
                                var message = new $root.google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult();
                                if (object.resourceName != null)
                                    message.resourceName = String(object.resourceName);
                                return message;
                            };

                            /**
                             * Creates a plain object from a DismissRecommendationResult message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult
                             * @static
                             * @param {google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult} message DismissRecommendationResult
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            DismissRecommendationResult.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults)
                                    object.resourceName = "";
                                if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                    object.resourceName = message.resourceName;
                                return object;
                            };

                            /**
                             * Converts this DismissRecommendationResult to JSON.
                             * @function toJSON
                             * @memberof google.ads.googleads.v1.services.DismissRecommendationResponse.DismissRecommendationResult
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            DismissRecommendationResult.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };

                            return DismissRecommendationResult;
                        })();

                        return DismissRecommendationResponse;
                    })();

                    services.RemarketingActionService = (function() {

                        /**
                         * Constructs a new RemarketingActionService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a RemarketingActionService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RemarketingActionService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (RemarketingActionService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RemarketingActionService;

                        /**
                         * Creates new RemarketingActionService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.RemarketingActionService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RemarketingActionService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RemarketingActionService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.RemarketingActionService#getRemarketingAction}.
                         * @memberof google.ads.googleads.v1.services.RemarketingActionService
                         * @typedef GetRemarketingActionCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.RemarketingAction} [response] RemarketingAction
                         */

                        /**
                         * Calls GetRemarketingAction.
                         * @function getRemarketingAction
                         * @memberof google.ads.googleads.v1.services.RemarketingActionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetRemarketingActionRequest} request GetRemarketingActionRequest message or plain object
                         * @param {google.ads.googleads.v1.services.RemarketingActionService.GetRemarketingActionCallback} callback Node-style callback called with the error, if any, and RemarketingAction
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RemarketingActionService.prototype.getRemarketingAction = function getRemarketingAction(request, callback) {
                            return this.rpcCall(getRemarketingAction, $root.google.ads.googleads.v1.services.GetRemarketingActionRequest, $root.google.ads.googleads.v1.resources.RemarketingAction, request, callback);
                        }, "name", { value: "GetRemarketingAction" });

                        /**
                         * Calls GetRemarketingAction.
                         * @function getRemarketingAction
                         * @memberof google.ads.googleads.v1.services.RemarketingActionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetRemarketingActionRequest} request GetRemarketingActionRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.RemarketingAction>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.RemarketingActionService#mutateRemarketingActions}.
                         * @memberof google.ads.googleads.v1.services.RemarketingActionService
                         * @typedef MutateRemarketingActionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateRemarketingActionsResponse} [response] MutateRemarketingActionsResponse
                         */

                        /**
                         * Calls MutateRemarketingActions.
                         * @function mutateRemarketingActions
                         * @memberof google.ads.googleads.v1.services.RemarketingActionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateRemarketingActionsRequest} request MutateRemarketingActionsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.RemarketingActionService.MutateRemarketingActionsCallback} callback Node-style callback called with the error, if any, and MutateRemarketingActionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RemarketingActionService.prototype.mutateRemarketingActions = function mutateRemarketingActions(request, callback) {
                            return this.rpcCall(mutateRemarketingActions, $root.google.ads.googleads.v1.services.MutateRemarketingActionsRequest, $root.google.ads.googleads.v1.services.MutateRemarketingActionsResponse, request, callback);
                        }, "name", { value: "MutateRemarketingActions" });

                        /**
                         * Calls MutateRemarketingActions.
                         * @function mutateRemarketingActions
                         * @memberof google.ads.googleads.v1.services.RemarketingActionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateRemarketingActionsRequest} request MutateRemarketingActionsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateRemarketingActionsResponse>} Promise
                         * @variation 2
                         */

                        return RemarketingActionService;
                    })();

                    services.GetRemarketingActionRequest = (function() {

                        /**
                         * Properties of a GetRemarketingActionRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetRemarketingActionRequest
                         * @property {string|null} [resourceName] GetRemarketingActionRequest resourceName
                         */

                        /**
                         * Constructs a new GetRemarketingActionRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetRemarketingActionRequest.
                         * @implements IGetRemarketingActionRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetRemarketingActionRequest=} [properties] Properties to set
                         */
                        function GetRemarketingActionRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetRemarketingActionRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetRemarketingActionRequest
                         * @instance
                         */
                        GetRemarketingActionRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetRemarketingActionRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetRemarketingActionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetRemarketingActionRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetRemarketingActionRequest} GetRemarketingActionRequest instance
                         */
                        GetRemarketingActionRequest.create = function create(properties) {
                            return new GetRemarketingActionRequest(properties);
                        };

                        /**
                         * Encodes the specified GetRemarketingActionRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetRemarketingActionRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetRemarketingActionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetRemarketingActionRequest} message GetRemarketingActionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRemarketingActionRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetRemarketingActionRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetRemarketingActionRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetRemarketingActionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetRemarketingActionRequest} message GetRemarketingActionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRemarketingActionRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetRemarketingActionRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetRemarketingActionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetRemarketingActionRequest} GetRemarketingActionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRemarketingActionRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetRemarketingActionRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetRemarketingActionRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetRemarketingActionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetRemarketingActionRequest} GetRemarketingActionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRemarketingActionRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetRemarketingActionRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetRemarketingActionRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRemarketingActionRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetRemarketingActionRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetRemarketingActionRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetRemarketingActionRequest} GetRemarketingActionRequest
                         */
                        GetRemarketingActionRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetRemarketingActionRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetRemarketingActionRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetRemarketingActionRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetRemarketingActionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetRemarketingActionRequest} message GetRemarketingActionRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRemarketingActionRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetRemarketingActionRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetRemarketingActionRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRemarketingActionRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetRemarketingActionRequest;
                    })();

                    services.MutateRemarketingActionsRequest = (function() {

                        /**
                         * Properties of a MutateRemarketingActionsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateRemarketingActionsRequest
                         * @property {string|null} [customerId] MutateRemarketingActionsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IRemarketingActionOperation>|null} [operations] MutateRemarketingActionsRequest operations
                         * @property {boolean|null} [partialFailure] MutateRemarketingActionsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateRemarketingActionsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateRemarketingActionsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateRemarketingActionsRequest.
                         * @implements IMutateRemarketingActionsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateRemarketingActionsRequest=} [properties] Properties to set
                         */
                        function MutateRemarketingActionsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateRemarketingActionsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsRequest
                         * @instance
                         */
                        MutateRemarketingActionsRequest.prototype.customerId = "";

                        /**
                         * MutateRemarketingActionsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IRemarketingActionOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsRequest
                         * @instance
                         */
                        MutateRemarketingActionsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateRemarketingActionsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsRequest
                         * @instance
                         */
                        MutateRemarketingActionsRequest.prototype.partialFailure = false;

                        /**
                         * MutateRemarketingActionsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsRequest
                         * @instance
                         */
                        MutateRemarketingActionsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateRemarketingActionsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateRemarketingActionsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateRemarketingActionsRequest} MutateRemarketingActionsRequest instance
                         */
                        MutateRemarketingActionsRequest.create = function create(properties) {
                            return new MutateRemarketingActionsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateRemarketingActionsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateRemarketingActionsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateRemarketingActionsRequest} message MutateRemarketingActionsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateRemarketingActionsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.RemarketingActionOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateRemarketingActionsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateRemarketingActionsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateRemarketingActionsRequest} message MutateRemarketingActionsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateRemarketingActionsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateRemarketingActionsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateRemarketingActionsRequest} MutateRemarketingActionsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateRemarketingActionsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateRemarketingActionsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.RemarketingActionOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateRemarketingActionsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateRemarketingActionsRequest} MutateRemarketingActionsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateRemarketingActionsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateRemarketingActionsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateRemarketingActionsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.RemarketingActionOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateRemarketingActionsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateRemarketingActionsRequest} MutateRemarketingActionsRequest
                         */
                        MutateRemarketingActionsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateRemarketingActionsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateRemarketingActionsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateRemarketingActionsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateRemarketingActionsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.RemarketingActionOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateRemarketingActionsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateRemarketingActionsRequest} message MutateRemarketingActionsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateRemarketingActionsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.RemarketingActionOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateRemarketingActionsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateRemarketingActionsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateRemarketingActionsRequest;
                    })();

                    services.RemarketingActionOperation = (function() {

                        /**
                         * Properties of a RemarketingActionOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IRemarketingActionOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] RemarketingActionOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IRemarketingAction|null} [create] RemarketingActionOperation create
                         * @property {google.ads.googleads.v1.resources.IRemarketingAction|null} [update] RemarketingActionOperation update
                         */

                        /**
                         * Constructs a new RemarketingActionOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a RemarketingActionOperation.
                         * @implements IRemarketingActionOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IRemarketingActionOperation=} [properties] Properties to set
                         */
                        function RemarketingActionOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * RemarketingActionOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.RemarketingActionOperation
                         * @instance
                         */
                        RemarketingActionOperation.prototype.updateMask = null;

                        /**
                         * RemarketingActionOperation create.
                         * @member {google.ads.googleads.v1.resources.IRemarketingAction|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.RemarketingActionOperation
                         * @instance
                         */
                        RemarketingActionOperation.prototype.create = null;

                        /**
                         * RemarketingActionOperation update.
                         * @member {google.ads.googleads.v1.resources.IRemarketingAction|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.RemarketingActionOperation
                         * @instance
                         */
                        RemarketingActionOperation.prototype.update = null;

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * RemarketingActionOperation operation.
                         * @member {"create"|"update"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.RemarketingActionOperation
                         * @instance
                         */
                        Object.defineProperty(RemarketingActionOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new RemarketingActionOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.RemarketingActionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IRemarketingActionOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.RemarketingActionOperation} RemarketingActionOperation instance
                         */
                        RemarketingActionOperation.create = function create(properties) {
                            return new RemarketingActionOperation(properties);
                        };

                        /**
                         * Encodes the specified RemarketingActionOperation message. Does not implicitly {@link google.ads.googleads.v1.services.RemarketingActionOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.RemarketingActionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IRemarketingActionOperation} message RemarketingActionOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemarketingActionOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.RemarketingAction.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.RemarketingAction.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified RemarketingActionOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.RemarketingActionOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.RemarketingActionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IRemarketingActionOperation} message RemarketingActionOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemarketingActionOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a RemarketingActionOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.RemarketingActionOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.RemarketingActionOperation} RemarketingActionOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemarketingActionOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.RemarketingActionOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.RemarketingAction.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.RemarketingAction.decode(reader, reader.uint32());
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a RemarketingActionOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.RemarketingActionOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.RemarketingActionOperation} RemarketingActionOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemarketingActionOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a RemarketingActionOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.RemarketingActionOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RemarketingActionOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.RemarketingAction.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.RemarketingAction.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a RemarketingActionOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.RemarketingActionOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.RemarketingActionOperation} RemarketingActionOperation
                         */
                        RemarketingActionOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.RemarketingActionOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.RemarketingActionOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.RemarketingActionOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.RemarketingActionOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.RemarketingAction.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.RemarketingActionOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.RemarketingAction.fromObject(object.update);
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a RemarketingActionOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.RemarketingActionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.RemarketingActionOperation} message RemarketingActionOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RemarketingActionOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.RemarketingAction.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.RemarketingAction.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this RemarketingActionOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.RemarketingActionOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RemarketingActionOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return RemarketingActionOperation;
                    })();

                    services.MutateRemarketingActionsResponse = (function() {

                        /**
                         * Properties of a MutateRemarketingActionsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateRemarketingActionsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateRemarketingActionsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateRemarketingActionResult>|null} [results] MutateRemarketingActionsResponse results
                         */

                        /**
                         * Constructs a new MutateRemarketingActionsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateRemarketingActionsResponse.
                         * @implements IMutateRemarketingActionsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateRemarketingActionsResponse=} [properties] Properties to set
                         */
                        function MutateRemarketingActionsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateRemarketingActionsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsResponse
                         * @instance
                         */
                        MutateRemarketingActionsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateRemarketingActionsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateRemarketingActionResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsResponse
                         * @instance
                         */
                        MutateRemarketingActionsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateRemarketingActionsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateRemarketingActionsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateRemarketingActionsResponse} MutateRemarketingActionsResponse instance
                         */
                        MutateRemarketingActionsResponse.create = function create(properties) {
                            return new MutateRemarketingActionsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateRemarketingActionsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateRemarketingActionsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateRemarketingActionsResponse} message MutateRemarketingActionsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateRemarketingActionsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateRemarketingActionResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateRemarketingActionsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateRemarketingActionsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateRemarketingActionsResponse} message MutateRemarketingActionsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateRemarketingActionsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateRemarketingActionsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateRemarketingActionsResponse} MutateRemarketingActionsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateRemarketingActionsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateRemarketingActionsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateRemarketingActionResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateRemarketingActionsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateRemarketingActionsResponse} MutateRemarketingActionsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateRemarketingActionsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateRemarketingActionsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateRemarketingActionsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateRemarketingActionResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateRemarketingActionsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateRemarketingActionsResponse} MutateRemarketingActionsResponse
                         */
                        MutateRemarketingActionsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateRemarketingActionsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateRemarketingActionsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateRemarketingActionsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateRemarketingActionsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateRemarketingActionsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateRemarketingActionResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateRemarketingActionsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateRemarketingActionsResponse} message MutateRemarketingActionsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateRemarketingActionsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateRemarketingActionResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateRemarketingActionsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateRemarketingActionsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateRemarketingActionsResponse;
                    })();

                    services.MutateRemarketingActionResult = (function() {

                        /**
                         * Properties of a MutateRemarketingActionResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateRemarketingActionResult
                         * @property {string|null} [resourceName] MutateRemarketingActionResult resourceName
                         */

                        /**
                         * Constructs a new MutateRemarketingActionResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateRemarketingActionResult.
                         * @implements IMutateRemarketingActionResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateRemarketingActionResult=} [properties] Properties to set
                         */
                        function MutateRemarketingActionResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateRemarketingActionResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionResult
                         * @instance
                         */
                        MutateRemarketingActionResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateRemarketingActionResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateRemarketingActionResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateRemarketingActionResult} MutateRemarketingActionResult instance
                         */
                        MutateRemarketingActionResult.create = function create(properties) {
                            return new MutateRemarketingActionResult(properties);
                        };

                        /**
                         * Encodes the specified MutateRemarketingActionResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateRemarketingActionResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateRemarketingActionResult} message MutateRemarketingActionResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateRemarketingActionResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateRemarketingActionResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateRemarketingActionResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateRemarketingActionResult} message MutateRemarketingActionResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateRemarketingActionResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateRemarketingActionResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateRemarketingActionResult} MutateRemarketingActionResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateRemarketingActionResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateRemarketingActionResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateRemarketingActionResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateRemarketingActionResult} MutateRemarketingActionResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateRemarketingActionResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateRemarketingActionResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateRemarketingActionResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateRemarketingActionResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateRemarketingActionResult} MutateRemarketingActionResult
                         */
                        MutateRemarketingActionResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateRemarketingActionResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateRemarketingActionResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateRemarketingActionResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateRemarketingActionResult} message MutateRemarketingActionResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateRemarketingActionResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateRemarketingActionResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateRemarketingActionResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateRemarketingActionResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateRemarketingActionResult;
                    })();

                    services.SearchTermViewService = (function() {

                        /**
                         * Constructs a new SearchTermViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a SearchTermViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function SearchTermViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (SearchTermViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = SearchTermViewService;

                        /**
                         * Creates new SearchTermViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.SearchTermViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {SearchTermViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        SearchTermViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.SearchTermViewService#getSearchTermView}.
                         * @memberof google.ads.googleads.v1.services.SearchTermViewService
                         * @typedef GetSearchTermViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.SearchTermView} [response] SearchTermView
                         */

                        /**
                         * Calls GetSearchTermView.
                         * @function getSearchTermView
                         * @memberof google.ads.googleads.v1.services.SearchTermViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetSearchTermViewRequest} request GetSearchTermViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.SearchTermViewService.GetSearchTermViewCallback} callback Node-style callback called with the error, if any, and SearchTermView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SearchTermViewService.prototype.getSearchTermView = function getSearchTermView(request, callback) {
                            return this.rpcCall(getSearchTermView, $root.google.ads.googleads.v1.services.GetSearchTermViewRequest, $root.google.ads.googleads.v1.resources.SearchTermView, request, callback);
                        }, "name", { value: "GetSearchTermView" });

                        /**
                         * Calls GetSearchTermView.
                         * @function getSearchTermView
                         * @memberof google.ads.googleads.v1.services.SearchTermViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetSearchTermViewRequest} request GetSearchTermViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.SearchTermView>} Promise
                         * @variation 2
                         */

                        return SearchTermViewService;
                    })();

                    services.GetSearchTermViewRequest = (function() {

                        /**
                         * Properties of a GetSearchTermViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetSearchTermViewRequest
                         * @property {string|null} [resourceName] GetSearchTermViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetSearchTermViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetSearchTermViewRequest.
                         * @implements IGetSearchTermViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetSearchTermViewRequest=} [properties] Properties to set
                         */
                        function GetSearchTermViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetSearchTermViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetSearchTermViewRequest
                         * @instance
                         */
                        GetSearchTermViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetSearchTermViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetSearchTermViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetSearchTermViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetSearchTermViewRequest} GetSearchTermViewRequest instance
                         */
                        GetSearchTermViewRequest.create = function create(properties) {
                            return new GetSearchTermViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetSearchTermViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetSearchTermViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetSearchTermViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetSearchTermViewRequest} message GetSearchTermViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSearchTermViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetSearchTermViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetSearchTermViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetSearchTermViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetSearchTermViewRequest} message GetSearchTermViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSearchTermViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetSearchTermViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetSearchTermViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetSearchTermViewRequest} GetSearchTermViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSearchTermViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetSearchTermViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetSearchTermViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetSearchTermViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetSearchTermViewRequest} GetSearchTermViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSearchTermViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetSearchTermViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetSearchTermViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetSearchTermViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetSearchTermViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetSearchTermViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetSearchTermViewRequest} GetSearchTermViewRequest
                         */
                        GetSearchTermViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetSearchTermViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetSearchTermViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetSearchTermViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetSearchTermViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetSearchTermViewRequest} message GetSearchTermViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetSearchTermViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetSearchTermViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetSearchTermViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetSearchTermViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetSearchTermViewRequest;
                    })();

                    services.SharedCriterionService = (function() {

                        /**
                         * Constructs a new SharedCriterionService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a SharedCriterionService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function SharedCriterionService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (SharedCriterionService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = SharedCriterionService;

                        /**
                         * Creates new SharedCriterionService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.SharedCriterionService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {SharedCriterionService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        SharedCriterionService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.SharedCriterionService#getSharedCriterion}.
                         * @memberof google.ads.googleads.v1.services.SharedCriterionService
                         * @typedef GetSharedCriterionCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.SharedCriterion} [response] SharedCriterion
                         */

                        /**
                         * Calls GetSharedCriterion.
                         * @function getSharedCriterion
                         * @memberof google.ads.googleads.v1.services.SharedCriterionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetSharedCriterionRequest} request GetSharedCriterionRequest message or plain object
                         * @param {google.ads.googleads.v1.services.SharedCriterionService.GetSharedCriterionCallback} callback Node-style callback called with the error, if any, and SharedCriterion
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SharedCriterionService.prototype.getSharedCriterion = function getSharedCriterion(request, callback) {
                            return this.rpcCall(getSharedCriterion, $root.google.ads.googleads.v1.services.GetSharedCriterionRequest, $root.google.ads.googleads.v1.resources.SharedCriterion, request, callback);
                        }, "name", { value: "GetSharedCriterion" });

                        /**
                         * Calls GetSharedCriterion.
                         * @function getSharedCriterion
                         * @memberof google.ads.googleads.v1.services.SharedCriterionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetSharedCriterionRequest} request GetSharedCriterionRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.SharedCriterion>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.SharedCriterionService#mutateSharedCriteria}.
                         * @memberof google.ads.googleads.v1.services.SharedCriterionService
                         * @typedef MutateSharedCriteriaCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateSharedCriteriaResponse} [response] MutateSharedCriteriaResponse
                         */

                        /**
                         * Calls MutateSharedCriteria.
                         * @function mutateSharedCriteria
                         * @memberof google.ads.googleads.v1.services.SharedCriterionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateSharedCriteriaRequest} request MutateSharedCriteriaRequest message or plain object
                         * @param {google.ads.googleads.v1.services.SharedCriterionService.MutateSharedCriteriaCallback} callback Node-style callback called with the error, if any, and MutateSharedCriteriaResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SharedCriterionService.prototype.mutateSharedCriteria = function mutateSharedCriteria(request, callback) {
                            return this.rpcCall(mutateSharedCriteria, $root.google.ads.googleads.v1.services.MutateSharedCriteriaRequest, $root.google.ads.googleads.v1.services.MutateSharedCriteriaResponse, request, callback);
                        }, "name", { value: "MutateSharedCriteria" });

                        /**
                         * Calls MutateSharedCriteria.
                         * @function mutateSharedCriteria
                         * @memberof google.ads.googleads.v1.services.SharedCriterionService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateSharedCriteriaRequest} request MutateSharedCriteriaRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateSharedCriteriaResponse>} Promise
                         * @variation 2
                         */

                        return SharedCriterionService;
                    })();

                    services.GetSharedCriterionRequest = (function() {

                        /**
                         * Properties of a GetSharedCriterionRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetSharedCriterionRequest
                         * @property {string|null} [resourceName] GetSharedCriterionRequest resourceName
                         */

                        /**
                         * Constructs a new GetSharedCriterionRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetSharedCriterionRequest.
                         * @implements IGetSharedCriterionRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetSharedCriterionRequest=} [properties] Properties to set
                         */
                        function GetSharedCriterionRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetSharedCriterionRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetSharedCriterionRequest
                         * @instance
                         */
                        GetSharedCriterionRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetSharedCriterionRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetSharedCriterionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetSharedCriterionRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetSharedCriterionRequest} GetSharedCriterionRequest instance
                         */
                        GetSharedCriterionRequest.create = function create(properties) {
                            return new GetSharedCriterionRequest(properties);
                        };

                        /**
                         * Encodes the specified GetSharedCriterionRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetSharedCriterionRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetSharedCriterionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetSharedCriterionRequest} message GetSharedCriterionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSharedCriterionRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetSharedCriterionRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetSharedCriterionRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetSharedCriterionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetSharedCriterionRequest} message GetSharedCriterionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSharedCriterionRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetSharedCriterionRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetSharedCriterionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetSharedCriterionRequest} GetSharedCriterionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSharedCriterionRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetSharedCriterionRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetSharedCriterionRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetSharedCriterionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetSharedCriterionRequest} GetSharedCriterionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSharedCriterionRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetSharedCriterionRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetSharedCriterionRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetSharedCriterionRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetSharedCriterionRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetSharedCriterionRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetSharedCriterionRequest} GetSharedCriterionRequest
                         */
                        GetSharedCriterionRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetSharedCriterionRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetSharedCriterionRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetSharedCriterionRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetSharedCriterionRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetSharedCriterionRequest} message GetSharedCriterionRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetSharedCriterionRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetSharedCriterionRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetSharedCriterionRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetSharedCriterionRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetSharedCriterionRequest;
                    })();

                    services.MutateSharedCriteriaRequest = (function() {

                        /**
                         * Properties of a MutateSharedCriteriaRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateSharedCriteriaRequest
                         * @property {string|null} [customerId] MutateSharedCriteriaRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.ISharedCriterionOperation>|null} [operations] MutateSharedCriteriaRequest operations
                         * @property {boolean|null} [partialFailure] MutateSharedCriteriaRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateSharedCriteriaRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateSharedCriteriaRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateSharedCriteriaRequest.
                         * @implements IMutateSharedCriteriaRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateSharedCriteriaRequest=} [properties] Properties to set
                         */
                        function MutateSharedCriteriaRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateSharedCriteriaRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaRequest
                         * @instance
                         */
                        MutateSharedCriteriaRequest.prototype.customerId = "";

                        /**
                         * MutateSharedCriteriaRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.ISharedCriterionOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaRequest
                         * @instance
                         */
                        MutateSharedCriteriaRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateSharedCriteriaRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaRequest
                         * @instance
                         */
                        MutateSharedCriteriaRequest.prototype.partialFailure = false;

                        /**
                         * MutateSharedCriteriaRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaRequest
                         * @instance
                         */
                        MutateSharedCriteriaRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateSharedCriteriaRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateSharedCriteriaRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateSharedCriteriaRequest} MutateSharedCriteriaRequest instance
                         */
                        MutateSharedCriteriaRequest.create = function create(properties) {
                            return new MutateSharedCriteriaRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateSharedCriteriaRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateSharedCriteriaRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateSharedCriteriaRequest} message MutateSharedCriteriaRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateSharedCriteriaRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.SharedCriterionOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateSharedCriteriaRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateSharedCriteriaRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateSharedCriteriaRequest} message MutateSharedCriteriaRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateSharedCriteriaRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateSharedCriteriaRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateSharedCriteriaRequest} MutateSharedCriteriaRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateSharedCriteriaRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateSharedCriteriaRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.SharedCriterionOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateSharedCriteriaRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateSharedCriteriaRequest} MutateSharedCriteriaRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateSharedCriteriaRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateSharedCriteriaRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateSharedCriteriaRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.SharedCriterionOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateSharedCriteriaRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateSharedCriteriaRequest} MutateSharedCriteriaRequest
                         */
                        MutateSharedCriteriaRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateSharedCriteriaRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateSharedCriteriaRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateSharedCriteriaRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateSharedCriteriaRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.SharedCriterionOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateSharedCriteriaRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateSharedCriteriaRequest} message MutateSharedCriteriaRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateSharedCriteriaRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.SharedCriterionOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateSharedCriteriaRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateSharedCriteriaRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateSharedCriteriaRequest;
                    })();

                    services.SharedCriterionOperation = (function() {

                        /**
                         * Properties of a SharedCriterionOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ISharedCriterionOperation
                         * @property {google.ads.googleads.v1.resources.ISharedCriterion|null} [create] SharedCriterionOperation create
                         * @property {string|null} [remove] SharedCriterionOperation remove
                         */

                        /**
                         * Constructs a new SharedCriterionOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a SharedCriterionOperation.
                         * @implements ISharedCriterionOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ISharedCriterionOperation=} [properties] Properties to set
                         */
                        function SharedCriterionOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * SharedCriterionOperation create.
                         * @member {google.ads.googleads.v1.resources.ISharedCriterion|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.SharedCriterionOperation
                         * @instance
                         */
                        SharedCriterionOperation.prototype.create = null;

                        /**
                         * SharedCriterionOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.SharedCriterionOperation
                         * @instance
                         */
                        SharedCriterionOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * SharedCriterionOperation operation.
                         * @member {"create"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.SharedCriterionOperation
                         * @instance
                         */
                        Object.defineProperty(SharedCriterionOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new SharedCriterionOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.SharedCriterionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ISharedCriterionOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.SharedCriterionOperation} SharedCriterionOperation instance
                         */
                        SharedCriterionOperation.create = function create(properties) {
                            return new SharedCriterionOperation(properties);
                        };

                        /**
                         * Encodes the specified SharedCriterionOperation message. Does not implicitly {@link google.ads.googleads.v1.services.SharedCriterionOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.SharedCriterionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ISharedCriterionOperation} message SharedCriterionOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SharedCriterionOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.SharedCriterion.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            return writer;
                        };

                        /**
                         * Encodes the specified SharedCriterionOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.SharedCriterionOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.SharedCriterionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ISharedCriterionOperation} message SharedCriterionOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SharedCriterionOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SharedCriterionOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.SharedCriterionOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.SharedCriterionOperation} SharedCriterionOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SharedCriterionOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.SharedCriterionOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.SharedCriterion.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SharedCriterionOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.SharedCriterionOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.SharedCriterionOperation} SharedCriterionOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SharedCriterionOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SharedCriterionOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.SharedCriterionOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SharedCriterionOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.SharedCriterion.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a SharedCriterionOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.SharedCriterionOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.SharedCriterionOperation} SharedCriterionOperation
                         */
                        SharedCriterionOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.SharedCriterionOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.SharedCriterionOperation();
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.SharedCriterionOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.SharedCriterion.fromObject(object.create);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a SharedCriterionOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.SharedCriterionOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.SharedCriterionOperation} message SharedCriterionOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SharedCriterionOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.SharedCriterion.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            return object;
                        };

                        /**
                         * Converts this SharedCriterionOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.SharedCriterionOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SharedCriterionOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return SharedCriterionOperation;
                    })();

                    services.MutateSharedCriteriaResponse = (function() {

                        /**
                         * Properties of a MutateSharedCriteriaResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateSharedCriteriaResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateSharedCriteriaResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateSharedCriterionResult>|null} [results] MutateSharedCriteriaResponse results
                         */

                        /**
                         * Constructs a new MutateSharedCriteriaResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateSharedCriteriaResponse.
                         * @implements IMutateSharedCriteriaResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateSharedCriteriaResponse=} [properties] Properties to set
                         */
                        function MutateSharedCriteriaResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateSharedCriteriaResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaResponse
                         * @instance
                         */
                        MutateSharedCriteriaResponse.prototype.partialFailureError = null;

                        /**
                         * MutateSharedCriteriaResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateSharedCriterionResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaResponse
                         * @instance
                         */
                        MutateSharedCriteriaResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateSharedCriteriaResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateSharedCriteriaResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateSharedCriteriaResponse} MutateSharedCriteriaResponse instance
                         */
                        MutateSharedCriteriaResponse.create = function create(properties) {
                            return new MutateSharedCriteriaResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateSharedCriteriaResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateSharedCriteriaResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateSharedCriteriaResponse} message MutateSharedCriteriaResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateSharedCriteriaResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateSharedCriterionResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateSharedCriteriaResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateSharedCriteriaResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateSharedCriteriaResponse} message MutateSharedCriteriaResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateSharedCriteriaResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateSharedCriteriaResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateSharedCriteriaResponse} MutateSharedCriteriaResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateSharedCriteriaResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateSharedCriteriaResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateSharedCriterionResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateSharedCriteriaResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateSharedCriteriaResponse} MutateSharedCriteriaResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateSharedCriteriaResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateSharedCriteriaResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateSharedCriteriaResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateSharedCriterionResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateSharedCriteriaResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateSharedCriteriaResponse} MutateSharedCriteriaResponse
                         */
                        MutateSharedCriteriaResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateSharedCriteriaResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateSharedCriteriaResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateSharedCriteriaResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateSharedCriteriaResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateSharedCriteriaResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateSharedCriterionResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateSharedCriteriaResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateSharedCriteriaResponse} message MutateSharedCriteriaResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateSharedCriteriaResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateSharedCriterionResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateSharedCriteriaResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriteriaResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateSharedCriteriaResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateSharedCriteriaResponse;
                    })();

                    services.MutateSharedCriterionResult = (function() {

                        /**
                         * Properties of a MutateSharedCriterionResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateSharedCriterionResult
                         * @property {string|null} [resourceName] MutateSharedCriterionResult resourceName
                         */

                        /**
                         * Constructs a new MutateSharedCriterionResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateSharedCriterionResult.
                         * @implements IMutateSharedCriterionResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateSharedCriterionResult=} [properties] Properties to set
                         */
                        function MutateSharedCriterionResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateSharedCriterionResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriterionResult
                         * @instance
                         */
                        MutateSharedCriterionResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateSharedCriterionResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriterionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateSharedCriterionResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateSharedCriterionResult} MutateSharedCriterionResult instance
                         */
                        MutateSharedCriterionResult.create = function create(properties) {
                            return new MutateSharedCriterionResult(properties);
                        };

                        /**
                         * Encodes the specified MutateSharedCriterionResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateSharedCriterionResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriterionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateSharedCriterionResult} message MutateSharedCriterionResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateSharedCriterionResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateSharedCriterionResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateSharedCriterionResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriterionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateSharedCriterionResult} message MutateSharedCriterionResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateSharedCriterionResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateSharedCriterionResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriterionResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateSharedCriterionResult} MutateSharedCriterionResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateSharedCriterionResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateSharedCriterionResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateSharedCriterionResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriterionResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateSharedCriterionResult} MutateSharedCriterionResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateSharedCriterionResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateSharedCriterionResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriterionResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateSharedCriterionResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateSharedCriterionResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriterionResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateSharedCriterionResult} MutateSharedCriterionResult
                         */
                        MutateSharedCriterionResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateSharedCriterionResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateSharedCriterionResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateSharedCriterionResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriterionResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateSharedCriterionResult} message MutateSharedCriterionResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateSharedCriterionResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateSharedCriterionResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateSharedCriterionResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateSharedCriterionResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateSharedCriterionResult;
                    })();

                    services.SharedSetService = (function() {

                        /**
                         * Constructs a new SharedSetService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a SharedSetService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function SharedSetService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (SharedSetService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = SharedSetService;

                        /**
                         * Creates new SharedSetService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.SharedSetService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {SharedSetService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        SharedSetService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.SharedSetService#getSharedSet}.
                         * @memberof google.ads.googleads.v1.services.SharedSetService
                         * @typedef GetSharedSetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.SharedSet} [response] SharedSet
                         */

                        /**
                         * Calls GetSharedSet.
                         * @function getSharedSet
                         * @memberof google.ads.googleads.v1.services.SharedSetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetSharedSetRequest} request GetSharedSetRequest message or plain object
                         * @param {google.ads.googleads.v1.services.SharedSetService.GetSharedSetCallback} callback Node-style callback called with the error, if any, and SharedSet
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SharedSetService.prototype.getSharedSet = function getSharedSet(request, callback) {
                            return this.rpcCall(getSharedSet, $root.google.ads.googleads.v1.services.GetSharedSetRequest, $root.google.ads.googleads.v1.resources.SharedSet, request, callback);
                        }, "name", { value: "GetSharedSet" });

                        /**
                         * Calls GetSharedSet.
                         * @function getSharedSet
                         * @memberof google.ads.googleads.v1.services.SharedSetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetSharedSetRequest} request GetSharedSetRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.SharedSet>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.SharedSetService#mutateSharedSets}.
                         * @memberof google.ads.googleads.v1.services.SharedSetService
                         * @typedef MutateSharedSetsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateSharedSetsResponse} [response] MutateSharedSetsResponse
                         */

                        /**
                         * Calls MutateSharedSets.
                         * @function mutateSharedSets
                         * @memberof google.ads.googleads.v1.services.SharedSetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateSharedSetsRequest} request MutateSharedSetsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.SharedSetService.MutateSharedSetsCallback} callback Node-style callback called with the error, if any, and MutateSharedSetsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SharedSetService.prototype.mutateSharedSets = function mutateSharedSets(request, callback) {
                            return this.rpcCall(mutateSharedSets, $root.google.ads.googleads.v1.services.MutateSharedSetsRequest, $root.google.ads.googleads.v1.services.MutateSharedSetsResponse, request, callback);
                        }, "name", { value: "MutateSharedSets" });

                        /**
                         * Calls MutateSharedSets.
                         * @function mutateSharedSets
                         * @memberof google.ads.googleads.v1.services.SharedSetService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateSharedSetsRequest} request MutateSharedSetsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateSharedSetsResponse>} Promise
                         * @variation 2
                         */

                        return SharedSetService;
                    })();

                    services.GetSharedSetRequest = (function() {

                        /**
                         * Properties of a GetSharedSetRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetSharedSetRequest
                         * @property {string|null} [resourceName] GetSharedSetRequest resourceName
                         */

                        /**
                         * Constructs a new GetSharedSetRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetSharedSetRequest.
                         * @implements IGetSharedSetRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetSharedSetRequest=} [properties] Properties to set
                         */
                        function GetSharedSetRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetSharedSetRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetSharedSetRequest
                         * @instance
                         */
                        GetSharedSetRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetSharedSetRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetSharedSetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetSharedSetRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetSharedSetRequest} GetSharedSetRequest instance
                         */
                        GetSharedSetRequest.create = function create(properties) {
                            return new GetSharedSetRequest(properties);
                        };

                        /**
                         * Encodes the specified GetSharedSetRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetSharedSetRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetSharedSetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetSharedSetRequest} message GetSharedSetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSharedSetRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetSharedSetRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetSharedSetRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetSharedSetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetSharedSetRequest} message GetSharedSetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSharedSetRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetSharedSetRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetSharedSetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetSharedSetRequest} GetSharedSetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSharedSetRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetSharedSetRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetSharedSetRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetSharedSetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetSharedSetRequest} GetSharedSetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSharedSetRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetSharedSetRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetSharedSetRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetSharedSetRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetSharedSetRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetSharedSetRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetSharedSetRequest} GetSharedSetRequest
                         */
                        GetSharedSetRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetSharedSetRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetSharedSetRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetSharedSetRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetSharedSetRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetSharedSetRequest} message GetSharedSetRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetSharedSetRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetSharedSetRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetSharedSetRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetSharedSetRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetSharedSetRequest;
                    })();

                    services.MutateSharedSetsRequest = (function() {

                        /**
                         * Properties of a MutateSharedSetsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateSharedSetsRequest
                         * @property {string|null} [customerId] MutateSharedSetsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.ISharedSetOperation>|null} [operations] MutateSharedSetsRequest operations
                         * @property {boolean|null} [partialFailure] MutateSharedSetsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateSharedSetsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateSharedSetsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateSharedSetsRequest.
                         * @implements IMutateSharedSetsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateSharedSetsRequest=} [properties] Properties to set
                         */
                        function MutateSharedSetsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateSharedSetsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsRequest
                         * @instance
                         */
                        MutateSharedSetsRequest.prototype.customerId = "";

                        /**
                         * MutateSharedSetsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.ISharedSetOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsRequest
                         * @instance
                         */
                        MutateSharedSetsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateSharedSetsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsRequest
                         * @instance
                         */
                        MutateSharedSetsRequest.prototype.partialFailure = false;

                        /**
                         * MutateSharedSetsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsRequest
                         * @instance
                         */
                        MutateSharedSetsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateSharedSetsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateSharedSetsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateSharedSetsRequest} MutateSharedSetsRequest instance
                         */
                        MutateSharedSetsRequest.create = function create(properties) {
                            return new MutateSharedSetsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateSharedSetsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateSharedSetsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateSharedSetsRequest} message MutateSharedSetsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateSharedSetsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.SharedSetOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateSharedSetsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateSharedSetsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateSharedSetsRequest} message MutateSharedSetsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateSharedSetsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateSharedSetsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateSharedSetsRequest} MutateSharedSetsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateSharedSetsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateSharedSetsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.SharedSetOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateSharedSetsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateSharedSetsRequest} MutateSharedSetsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateSharedSetsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateSharedSetsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateSharedSetsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.SharedSetOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateSharedSetsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateSharedSetsRequest} MutateSharedSetsRequest
                         */
                        MutateSharedSetsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateSharedSetsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateSharedSetsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateSharedSetsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateSharedSetsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.SharedSetOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateSharedSetsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateSharedSetsRequest} message MutateSharedSetsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateSharedSetsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.SharedSetOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateSharedSetsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateSharedSetsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateSharedSetsRequest;
                    })();

                    services.SharedSetOperation = (function() {

                        /**
                         * Properties of a SharedSetOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface ISharedSetOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] SharedSetOperation updateMask
                         * @property {google.ads.googleads.v1.resources.ISharedSet|null} [create] SharedSetOperation create
                         * @property {google.ads.googleads.v1.resources.ISharedSet|null} [update] SharedSetOperation update
                         * @property {string|null} [remove] SharedSetOperation remove
                         */

                        /**
                         * Constructs a new SharedSetOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a SharedSetOperation.
                         * @implements ISharedSetOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.ISharedSetOperation=} [properties] Properties to set
                         */
                        function SharedSetOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * SharedSetOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.SharedSetOperation
                         * @instance
                         */
                        SharedSetOperation.prototype.updateMask = null;

                        /**
                         * SharedSetOperation create.
                         * @member {google.ads.googleads.v1.resources.ISharedSet|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.SharedSetOperation
                         * @instance
                         */
                        SharedSetOperation.prototype.create = null;

                        /**
                         * SharedSetOperation update.
                         * @member {google.ads.googleads.v1.resources.ISharedSet|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.SharedSetOperation
                         * @instance
                         */
                        SharedSetOperation.prototype.update = null;

                        /**
                         * SharedSetOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.SharedSetOperation
                         * @instance
                         */
                        SharedSetOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * SharedSetOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.SharedSetOperation
                         * @instance
                         */
                        Object.defineProperty(SharedSetOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new SharedSetOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.SharedSetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ISharedSetOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.SharedSetOperation} SharedSetOperation instance
                         */
                        SharedSetOperation.create = function create(properties) {
                            return new SharedSetOperation(properties);
                        };

                        /**
                         * Encodes the specified SharedSetOperation message. Does not implicitly {@link google.ads.googleads.v1.services.SharedSetOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.SharedSetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ISharedSetOperation} message SharedSetOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SharedSetOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.SharedSet.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.SharedSet.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified SharedSetOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.SharedSetOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.SharedSetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.ISharedSetOperation} message SharedSetOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SharedSetOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a SharedSetOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.SharedSetOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.SharedSetOperation} SharedSetOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SharedSetOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.SharedSetOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.SharedSet.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.SharedSet.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a SharedSetOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.SharedSetOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.SharedSetOperation} SharedSetOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SharedSetOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a SharedSetOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.SharedSetOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SharedSetOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.SharedSet.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.SharedSet.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a SharedSetOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.SharedSetOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.SharedSetOperation} SharedSetOperation
                         */
                        SharedSetOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.SharedSetOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.SharedSetOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.SharedSetOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.SharedSetOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.SharedSet.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.SharedSetOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.SharedSet.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a SharedSetOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.SharedSetOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.SharedSetOperation} message SharedSetOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SharedSetOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.SharedSet.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.SharedSet.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this SharedSetOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.SharedSetOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SharedSetOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return SharedSetOperation;
                    })();

                    services.MutateSharedSetsResponse = (function() {

                        /**
                         * Properties of a MutateSharedSetsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateSharedSetsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateSharedSetsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateSharedSetResult>|null} [results] MutateSharedSetsResponse results
                         */

                        /**
                         * Constructs a new MutateSharedSetsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateSharedSetsResponse.
                         * @implements IMutateSharedSetsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateSharedSetsResponse=} [properties] Properties to set
                         */
                        function MutateSharedSetsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateSharedSetsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsResponse
                         * @instance
                         */
                        MutateSharedSetsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateSharedSetsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateSharedSetResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsResponse
                         * @instance
                         */
                        MutateSharedSetsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateSharedSetsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateSharedSetsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateSharedSetsResponse} MutateSharedSetsResponse instance
                         */
                        MutateSharedSetsResponse.create = function create(properties) {
                            return new MutateSharedSetsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateSharedSetsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateSharedSetsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateSharedSetsResponse} message MutateSharedSetsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateSharedSetsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateSharedSetResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateSharedSetsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateSharedSetsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateSharedSetsResponse} message MutateSharedSetsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateSharedSetsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateSharedSetsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateSharedSetsResponse} MutateSharedSetsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateSharedSetsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateSharedSetsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateSharedSetResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateSharedSetsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateSharedSetsResponse} MutateSharedSetsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateSharedSetsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateSharedSetsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateSharedSetsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateSharedSetResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateSharedSetsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateSharedSetsResponse} MutateSharedSetsResponse
                         */
                        MutateSharedSetsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateSharedSetsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateSharedSetsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateSharedSetsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateSharedSetsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateSharedSetsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateSharedSetResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateSharedSetsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateSharedSetsResponse} message MutateSharedSetsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateSharedSetsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateSharedSetResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateSharedSetsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateSharedSetsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateSharedSetsResponse;
                    })();

                    services.MutateSharedSetResult = (function() {

                        /**
                         * Properties of a MutateSharedSetResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateSharedSetResult
                         * @property {string|null} [resourceName] MutateSharedSetResult resourceName
                         */

                        /**
                         * Constructs a new MutateSharedSetResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateSharedSetResult.
                         * @implements IMutateSharedSetResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateSharedSetResult=} [properties] Properties to set
                         */
                        function MutateSharedSetResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateSharedSetResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetResult
                         * @instance
                         */
                        MutateSharedSetResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateSharedSetResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateSharedSetResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateSharedSetResult} MutateSharedSetResult instance
                         */
                        MutateSharedSetResult.create = function create(properties) {
                            return new MutateSharedSetResult(properties);
                        };

                        /**
                         * Encodes the specified MutateSharedSetResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateSharedSetResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateSharedSetResult} message MutateSharedSetResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateSharedSetResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateSharedSetResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateSharedSetResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateSharedSetResult} message MutateSharedSetResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateSharedSetResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateSharedSetResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateSharedSetResult} MutateSharedSetResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateSharedSetResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateSharedSetResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateSharedSetResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateSharedSetResult} MutateSharedSetResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateSharedSetResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateSharedSetResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateSharedSetResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateSharedSetResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateSharedSetResult} MutateSharedSetResult
                         */
                        MutateSharedSetResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateSharedSetResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateSharedSetResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateSharedSetResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateSharedSetResult} message MutateSharedSetResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateSharedSetResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateSharedSetResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateSharedSetResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateSharedSetResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateSharedSetResult;
                    })();

                    services.ShoppingPerformanceViewService = (function() {

                        /**
                         * Constructs a new ShoppingPerformanceViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a ShoppingPerformanceViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function ShoppingPerformanceViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (ShoppingPerformanceViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = ShoppingPerformanceViewService;

                        /**
                         * Creates new ShoppingPerformanceViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.ShoppingPerformanceViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {ShoppingPerformanceViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        ShoppingPerformanceViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.ShoppingPerformanceViewService#getShoppingPerformanceView}.
                         * @memberof google.ads.googleads.v1.services.ShoppingPerformanceViewService
                         * @typedef GetShoppingPerformanceViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.ShoppingPerformanceView} [response] ShoppingPerformanceView
                         */

                        /**
                         * Calls GetShoppingPerformanceView.
                         * @function getShoppingPerformanceView
                         * @memberof google.ads.googleads.v1.services.ShoppingPerformanceViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetShoppingPerformanceViewRequest} request GetShoppingPerformanceViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.ShoppingPerformanceViewService.GetShoppingPerformanceViewCallback} callback Node-style callback called with the error, if any, and ShoppingPerformanceView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ShoppingPerformanceViewService.prototype.getShoppingPerformanceView = function getShoppingPerformanceView(request, callback) {
                            return this.rpcCall(getShoppingPerformanceView, $root.google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest, $root.google.ads.googleads.v1.resources.ShoppingPerformanceView, request, callback);
                        }, "name", { value: "GetShoppingPerformanceView" });

                        /**
                         * Calls GetShoppingPerformanceView.
                         * @function getShoppingPerformanceView
                         * @memberof google.ads.googleads.v1.services.ShoppingPerformanceViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetShoppingPerformanceViewRequest} request GetShoppingPerformanceViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.ShoppingPerformanceView>} Promise
                         * @variation 2
                         */

                        return ShoppingPerformanceViewService;
                    })();

                    services.GetShoppingPerformanceViewRequest = (function() {

                        /**
                         * Properties of a GetShoppingPerformanceViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetShoppingPerformanceViewRequest
                         * @property {string|null} [resourceName] GetShoppingPerformanceViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetShoppingPerformanceViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetShoppingPerformanceViewRequest.
                         * @implements IGetShoppingPerformanceViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetShoppingPerformanceViewRequest=} [properties] Properties to set
                         */
                        function GetShoppingPerformanceViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetShoppingPerformanceViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest
                         * @instance
                         */
                        GetShoppingPerformanceViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetShoppingPerformanceViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetShoppingPerformanceViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest} GetShoppingPerformanceViewRequest instance
                         */
                        GetShoppingPerformanceViewRequest.create = function create(properties) {
                            return new GetShoppingPerformanceViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetShoppingPerformanceViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetShoppingPerformanceViewRequest} message GetShoppingPerformanceViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetShoppingPerformanceViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetShoppingPerformanceViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetShoppingPerformanceViewRequest} message GetShoppingPerformanceViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetShoppingPerformanceViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetShoppingPerformanceViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest} GetShoppingPerformanceViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetShoppingPerformanceViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetShoppingPerformanceViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest} GetShoppingPerformanceViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetShoppingPerformanceViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetShoppingPerformanceViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetShoppingPerformanceViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetShoppingPerformanceViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest} GetShoppingPerformanceViewRequest
                         */
                        GetShoppingPerformanceViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetShoppingPerformanceViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest} message GetShoppingPerformanceViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetShoppingPerformanceViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetShoppingPerformanceViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetShoppingPerformanceViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetShoppingPerformanceViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetShoppingPerformanceViewRequest;
                    })();

                    services.TopicConstantService = (function() {

                        /**
                         * Constructs a new TopicConstantService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a TopicConstantService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function TopicConstantService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (TopicConstantService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = TopicConstantService;

                        /**
                         * Creates new TopicConstantService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.TopicConstantService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {TopicConstantService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        TopicConstantService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.TopicConstantService#getTopicConstant}.
                         * @memberof google.ads.googleads.v1.services.TopicConstantService
                         * @typedef GetTopicConstantCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.TopicConstant} [response] TopicConstant
                         */

                        /**
                         * Calls GetTopicConstant.
                         * @function getTopicConstant
                         * @memberof google.ads.googleads.v1.services.TopicConstantService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetTopicConstantRequest} request GetTopicConstantRequest message or plain object
                         * @param {google.ads.googleads.v1.services.TopicConstantService.GetTopicConstantCallback} callback Node-style callback called with the error, if any, and TopicConstant
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TopicConstantService.prototype.getTopicConstant = function getTopicConstant(request, callback) {
                            return this.rpcCall(getTopicConstant, $root.google.ads.googleads.v1.services.GetTopicConstantRequest, $root.google.ads.googleads.v1.resources.TopicConstant, request, callback);
                        }, "name", { value: "GetTopicConstant" });

                        /**
                         * Calls GetTopicConstant.
                         * @function getTopicConstant
                         * @memberof google.ads.googleads.v1.services.TopicConstantService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetTopicConstantRequest} request GetTopicConstantRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.TopicConstant>} Promise
                         * @variation 2
                         */

                        return TopicConstantService;
                    })();

                    services.GetTopicConstantRequest = (function() {

                        /**
                         * Properties of a GetTopicConstantRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetTopicConstantRequest
                         * @property {string|null} [resourceName] GetTopicConstantRequest resourceName
                         */

                        /**
                         * Constructs a new GetTopicConstantRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetTopicConstantRequest.
                         * @implements IGetTopicConstantRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetTopicConstantRequest=} [properties] Properties to set
                         */
                        function GetTopicConstantRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetTopicConstantRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetTopicConstantRequest
                         * @instance
                         */
                        GetTopicConstantRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetTopicConstantRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetTopicConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetTopicConstantRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetTopicConstantRequest} GetTopicConstantRequest instance
                         */
                        GetTopicConstantRequest.create = function create(properties) {
                            return new GetTopicConstantRequest(properties);
                        };

                        /**
                         * Encodes the specified GetTopicConstantRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetTopicConstantRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetTopicConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetTopicConstantRequest} message GetTopicConstantRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTopicConstantRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetTopicConstantRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetTopicConstantRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetTopicConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetTopicConstantRequest} message GetTopicConstantRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTopicConstantRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetTopicConstantRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetTopicConstantRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetTopicConstantRequest} GetTopicConstantRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTopicConstantRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetTopicConstantRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetTopicConstantRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetTopicConstantRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetTopicConstantRequest} GetTopicConstantRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTopicConstantRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetTopicConstantRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetTopicConstantRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetTopicConstantRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetTopicConstantRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetTopicConstantRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetTopicConstantRequest} GetTopicConstantRequest
                         */
                        GetTopicConstantRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetTopicConstantRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetTopicConstantRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetTopicConstantRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetTopicConstantRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetTopicConstantRequest} message GetTopicConstantRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetTopicConstantRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetTopicConstantRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetTopicConstantRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetTopicConstantRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetTopicConstantRequest;
                    })();

                    services.TopicViewService = (function() {

                        /**
                         * Constructs a new TopicViewService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a TopicViewService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function TopicViewService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (TopicViewService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = TopicViewService;

                        /**
                         * Creates new TopicViewService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.TopicViewService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {TopicViewService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        TopicViewService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.TopicViewService#getTopicView}.
                         * @memberof google.ads.googleads.v1.services.TopicViewService
                         * @typedef GetTopicViewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.TopicView} [response] TopicView
                         */

                        /**
                         * Calls GetTopicView.
                         * @function getTopicView
                         * @memberof google.ads.googleads.v1.services.TopicViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetTopicViewRequest} request GetTopicViewRequest message or plain object
                         * @param {google.ads.googleads.v1.services.TopicViewService.GetTopicViewCallback} callback Node-style callback called with the error, if any, and TopicView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TopicViewService.prototype.getTopicView = function getTopicView(request, callback) {
                            return this.rpcCall(getTopicView, $root.google.ads.googleads.v1.services.GetTopicViewRequest, $root.google.ads.googleads.v1.resources.TopicView, request, callback);
                        }, "name", { value: "GetTopicView" });

                        /**
                         * Calls GetTopicView.
                         * @function getTopicView
                         * @memberof google.ads.googleads.v1.services.TopicViewService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetTopicViewRequest} request GetTopicViewRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.TopicView>} Promise
                         * @variation 2
                         */

                        return TopicViewService;
                    })();

                    services.GetTopicViewRequest = (function() {

                        /**
                         * Properties of a GetTopicViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetTopicViewRequest
                         * @property {string|null} [resourceName] GetTopicViewRequest resourceName
                         */

                        /**
                         * Constructs a new GetTopicViewRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetTopicViewRequest.
                         * @implements IGetTopicViewRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetTopicViewRequest=} [properties] Properties to set
                         */
                        function GetTopicViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetTopicViewRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetTopicViewRequest
                         * @instance
                         */
                        GetTopicViewRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetTopicViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetTopicViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetTopicViewRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetTopicViewRequest} GetTopicViewRequest instance
                         */
                        GetTopicViewRequest.create = function create(properties) {
                            return new GetTopicViewRequest(properties);
                        };

                        /**
                         * Encodes the specified GetTopicViewRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetTopicViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetTopicViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetTopicViewRequest} message GetTopicViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTopicViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetTopicViewRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetTopicViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetTopicViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetTopicViewRequest} message GetTopicViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTopicViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetTopicViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetTopicViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetTopicViewRequest} GetTopicViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTopicViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetTopicViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetTopicViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetTopicViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetTopicViewRequest} GetTopicViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTopicViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetTopicViewRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetTopicViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetTopicViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetTopicViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetTopicViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetTopicViewRequest} GetTopicViewRequest
                         */
                        GetTopicViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetTopicViewRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetTopicViewRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetTopicViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetTopicViewRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetTopicViewRequest} message GetTopicViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetTopicViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetTopicViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetTopicViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetTopicViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetTopicViewRequest;
                    })();

                    services.UserInterestService = (function() {

                        /**
                         * Constructs a new UserInterestService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a UserInterestService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function UserInterestService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (UserInterestService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = UserInterestService;

                        /**
                         * Creates new UserInterestService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.UserInterestService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {UserInterestService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        UserInterestService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.UserInterestService#getUserInterest}.
                         * @memberof google.ads.googleads.v1.services.UserInterestService
                         * @typedef GetUserInterestCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.UserInterest} [response] UserInterest
                         */

                        /**
                         * Calls GetUserInterest.
                         * @function getUserInterest
                         * @memberof google.ads.googleads.v1.services.UserInterestService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetUserInterestRequest} request GetUserInterestRequest message or plain object
                         * @param {google.ads.googleads.v1.services.UserInterestService.GetUserInterestCallback} callback Node-style callback called with the error, if any, and UserInterest
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(UserInterestService.prototype.getUserInterest = function getUserInterest(request, callback) {
                            return this.rpcCall(getUserInterest, $root.google.ads.googleads.v1.services.GetUserInterestRequest, $root.google.ads.googleads.v1.resources.UserInterest, request, callback);
                        }, "name", { value: "GetUserInterest" });

                        /**
                         * Calls GetUserInterest.
                         * @function getUserInterest
                         * @memberof google.ads.googleads.v1.services.UserInterestService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetUserInterestRequest} request GetUserInterestRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.UserInterest>} Promise
                         * @variation 2
                         */

                        return UserInterestService;
                    })();

                    services.GetUserInterestRequest = (function() {

                        /**
                         * Properties of a GetUserInterestRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetUserInterestRequest
                         * @property {string|null} [resourceName] GetUserInterestRequest resourceName
                         */

                        /**
                         * Constructs a new GetUserInterestRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetUserInterestRequest.
                         * @implements IGetUserInterestRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetUserInterestRequest=} [properties] Properties to set
                         */
                        function GetUserInterestRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetUserInterestRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetUserInterestRequest
                         * @instance
                         */
                        GetUserInterestRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetUserInterestRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetUserInterestRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetUserInterestRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetUserInterestRequest} GetUserInterestRequest instance
                         */
                        GetUserInterestRequest.create = function create(properties) {
                            return new GetUserInterestRequest(properties);
                        };

                        /**
                         * Encodes the specified GetUserInterestRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetUserInterestRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetUserInterestRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetUserInterestRequest} message GetUserInterestRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetUserInterestRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetUserInterestRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetUserInterestRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetUserInterestRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetUserInterestRequest} message GetUserInterestRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetUserInterestRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetUserInterestRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetUserInterestRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetUserInterestRequest} GetUserInterestRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetUserInterestRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetUserInterestRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetUserInterestRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetUserInterestRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetUserInterestRequest} GetUserInterestRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetUserInterestRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetUserInterestRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetUserInterestRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetUserInterestRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetUserInterestRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetUserInterestRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetUserInterestRequest} GetUserInterestRequest
                         */
                        GetUserInterestRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetUserInterestRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetUserInterestRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetUserInterestRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetUserInterestRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetUserInterestRequest} message GetUserInterestRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetUserInterestRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetUserInterestRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetUserInterestRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetUserInterestRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetUserInterestRequest;
                    })();

                    services.UserListService = (function() {

                        /**
                         * Constructs a new UserListService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a UserListService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function UserListService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (UserListService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = UserListService;

                        /**
                         * Creates new UserListService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.UserListService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {UserListService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        UserListService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.UserListService#getUserList}.
                         * @memberof google.ads.googleads.v1.services.UserListService
                         * @typedef GetUserListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.UserList} [response] UserList
                         */

                        /**
                         * Calls GetUserList.
                         * @function getUserList
                         * @memberof google.ads.googleads.v1.services.UserListService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetUserListRequest} request GetUserListRequest message or plain object
                         * @param {google.ads.googleads.v1.services.UserListService.GetUserListCallback} callback Node-style callback called with the error, if any, and UserList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(UserListService.prototype.getUserList = function getUserList(request, callback) {
                            return this.rpcCall(getUserList, $root.google.ads.googleads.v1.services.GetUserListRequest, $root.google.ads.googleads.v1.resources.UserList, request, callback);
                        }, "name", { value: "GetUserList" });

                        /**
                         * Calls GetUserList.
                         * @function getUserList
                         * @memberof google.ads.googleads.v1.services.UserListService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetUserListRequest} request GetUserListRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.UserList>} Promise
                         * @variation 2
                         */

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.UserListService#mutateUserLists}.
                         * @memberof google.ads.googleads.v1.services.UserListService
                         * @typedef MutateUserListsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.services.MutateUserListsResponse} [response] MutateUserListsResponse
                         */

                        /**
                         * Calls MutateUserLists.
                         * @function mutateUserLists
                         * @memberof google.ads.googleads.v1.services.UserListService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateUserListsRequest} request MutateUserListsRequest message or plain object
                         * @param {google.ads.googleads.v1.services.UserListService.MutateUserListsCallback} callback Node-style callback called with the error, if any, and MutateUserListsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(UserListService.prototype.mutateUserLists = function mutateUserLists(request, callback) {
                            return this.rpcCall(mutateUserLists, $root.google.ads.googleads.v1.services.MutateUserListsRequest, $root.google.ads.googleads.v1.services.MutateUserListsResponse, request, callback);
                        }, "name", { value: "MutateUserLists" });

                        /**
                         * Calls MutateUserLists.
                         * @function mutateUserLists
                         * @memberof google.ads.googleads.v1.services.UserListService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IMutateUserListsRequest} request MutateUserListsRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.services.MutateUserListsResponse>} Promise
                         * @variation 2
                         */

                        return UserListService;
                    })();

                    services.GetUserListRequest = (function() {

                        /**
                         * Properties of a GetUserListRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetUserListRequest
                         * @property {string|null} [resourceName] GetUserListRequest resourceName
                         */

                        /**
                         * Constructs a new GetUserListRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetUserListRequest.
                         * @implements IGetUserListRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetUserListRequest=} [properties] Properties to set
                         */
                        function GetUserListRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetUserListRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetUserListRequest
                         * @instance
                         */
                        GetUserListRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetUserListRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetUserListRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetUserListRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetUserListRequest} GetUserListRequest instance
                         */
                        GetUserListRequest.create = function create(properties) {
                            return new GetUserListRequest(properties);
                        };

                        /**
                         * Encodes the specified GetUserListRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetUserListRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetUserListRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetUserListRequest} message GetUserListRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetUserListRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetUserListRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetUserListRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetUserListRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetUserListRequest} message GetUserListRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetUserListRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetUserListRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetUserListRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetUserListRequest} GetUserListRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetUserListRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetUserListRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetUserListRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetUserListRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetUserListRequest} GetUserListRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetUserListRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetUserListRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetUserListRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetUserListRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetUserListRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetUserListRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetUserListRequest} GetUserListRequest
                         */
                        GetUserListRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetUserListRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetUserListRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetUserListRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetUserListRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetUserListRequest} message GetUserListRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetUserListRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetUserListRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetUserListRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetUserListRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetUserListRequest;
                    })();

                    services.MutateUserListsRequest = (function() {

                        /**
                         * Properties of a MutateUserListsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateUserListsRequest
                         * @property {string|null} [customerId] MutateUserListsRequest customerId
                         * @property {Array.<google.ads.googleads.v1.services.IUserListOperation>|null} [operations] MutateUserListsRequest operations
                         * @property {boolean|null} [partialFailure] MutateUserListsRequest partialFailure
                         * @property {boolean|null} [validateOnly] MutateUserListsRequest validateOnly
                         */

                        /**
                         * Constructs a new MutateUserListsRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateUserListsRequest.
                         * @implements IMutateUserListsRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateUserListsRequest=} [properties] Properties to set
                         */
                        function MutateUserListsRequest(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateUserListsRequest customerId.
                         * @member {string} customerId
                         * @memberof google.ads.googleads.v1.services.MutateUserListsRequest
                         * @instance
                         */
                        MutateUserListsRequest.prototype.customerId = "";

                        /**
                         * MutateUserListsRequest operations.
                         * @member {Array.<google.ads.googleads.v1.services.IUserListOperation>} operations
                         * @memberof google.ads.googleads.v1.services.MutateUserListsRequest
                         * @instance
                         */
                        MutateUserListsRequest.prototype.operations = $util.emptyArray;

                        /**
                         * MutateUserListsRequest partialFailure.
                         * @member {boolean} partialFailure
                         * @memberof google.ads.googleads.v1.services.MutateUserListsRequest
                         * @instance
                         */
                        MutateUserListsRequest.prototype.partialFailure = false;

                        /**
                         * MutateUserListsRequest validateOnly.
                         * @member {boolean} validateOnly
                         * @memberof google.ads.googleads.v1.services.MutateUserListsRequest
                         * @instance
                         */
                        MutateUserListsRequest.prototype.validateOnly = false;

                        /**
                         * Creates a new MutateUserListsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateUserListsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateUserListsRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateUserListsRequest} MutateUserListsRequest instance
                         */
                        MutateUserListsRequest.create = function create(properties) {
                            return new MutateUserListsRequest(properties);
                        };

                        /**
                         * Encodes the specified MutateUserListsRequest message. Does not implicitly {@link google.ads.googleads.v1.services.MutateUserListsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateUserListsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateUserListsRequest} message MutateUserListsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateUserListsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customerId);
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.ads.googleads.v1.services.UserListOperation.encode(message.operations[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.partialFailure);
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.validateOnly);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateUserListsRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateUserListsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateUserListsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateUserListsRequest} message MutateUserListsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateUserListsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateUserListsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateUserListsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateUserListsRequest} MutateUserListsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateUserListsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateUserListsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.customerId = reader.string();
                                    break;
                                case 2:
                                    if (!(message.operations && message.operations.length))
                                        message.operations = [];
                                    message.operations.push($root.google.ads.googleads.v1.services.UserListOperation.decode(reader, reader.uint32()));
                                    break;
                                case 3:
                                    message.partialFailure = reader.bool();
                                    break;
                                case 4:
                                    message.validateOnly = reader.bool();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateUserListsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateUserListsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateUserListsRequest} MutateUserListsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateUserListsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateUserListsRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateUserListsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateUserListsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.UserListOperation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                if (typeof message.partialFailure !== "boolean")
                                    return "partialFailure: boolean expected";
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            return null;
                        };

                        /**
                         * Creates a MutateUserListsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateUserListsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateUserListsRequest} MutateUserListsRequest
                         */
                        MutateUserListsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateUserListsRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateUserListsRequest();
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateUserListsRequest.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateUserListsRequest.operations: object expected");
                                    message.operations[i] = $root.google.ads.googleads.v1.services.UserListOperation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.partialFailure != null)
                                message.partialFailure = Boolean(object.partialFailure);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateUserListsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateUserListsRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateUserListsRequest} message MutateUserListsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateUserListsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (options.defaults) {
                                object.customerId = "";
                                object.partialFailure = false;
                                object.validateOnly = false;
                            }
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.ads.googleads.v1.services.UserListOperation.toObject(message.operations[j], options);
                            }
                            if (message.partialFailure != null && message.hasOwnProperty("partialFailure"))
                                object.partialFailure = message.partialFailure;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly"))
                                object.validateOnly = message.validateOnly;
                            return object;
                        };

                        /**
                         * Converts this MutateUserListsRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateUserListsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateUserListsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateUserListsRequest;
                    })();

                    services.UserListOperation = (function() {

                        /**
                         * Properties of a UserListOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IUserListOperation
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UserListOperation updateMask
                         * @property {google.ads.googleads.v1.resources.IUserList|null} [create] UserListOperation create
                         * @property {google.ads.googleads.v1.resources.IUserList|null} [update] UserListOperation update
                         * @property {string|null} [remove] UserListOperation remove
                         */

                        /**
                         * Constructs a new UserListOperation.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a UserListOperation.
                         * @implements IUserListOperation
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IUserListOperation=} [properties] Properties to set
                         */
                        function UserListOperation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * UserListOperation updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.ads.googleads.v1.services.UserListOperation
                         * @instance
                         */
                        UserListOperation.prototype.updateMask = null;

                        /**
                         * UserListOperation create.
                         * @member {google.ads.googleads.v1.resources.IUserList|null|undefined} create
                         * @memberof google.ads.googleads.v1.services.UserListOperation
                         * @instance
                         */
                        UserListOperation.prototype.create = null;

                        /**
                         * UserListOperation update.
                         * @member {google.ads.googleads.v1.resources.IUserList|null|undefined} update
                         * @memberof google.ads.googleads.v1.services.UserListOperation
                         * @instance
                         */
                        UserListOperation.prototype.update = null;

                        /**
                         * UserListOperation remove.
                         * @member {string} remove
                         * @memberof google.ads.googleads.v1.services.UserListOperation
                         * @instance
                         */
                        UserListOperation.prototype.remove = "";

                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;

                        /**
                         * UserListOperation operation.
                         * @member {"create"|"update"|"remove"|undefined} operation
                         * @memberof google.ads.googleads.v1.services.UserListOperation
                         * @instance
                         */
                        Object.defineProperty(UserListOperation.prototype, "operation", {
                            get: $util.oneOfGetter($oneOfFields = ["create", "update", "remove"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });

                        /**
                         * Creates a new UserListOperation instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.UserListOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IUserListOperation=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.UserListOperation} UserListOperation instance
                         */
                        UserListOperation.create = function create(properties) {
                            return new UserListOperation(properties);
                        };

                        /**
                         * Encodes the specified UserListOperation message. Does not implicitly {@link google.ads.googleads.v1.services.UserListOperation.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.UserListOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IUserListOperation} message UserListOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListOperation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.create != null && message.hasOwnProperty("create"))
                                $root.google.ads.googleads.v1.resources.UserList.encode(message.create, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.update != null && message.hasOwnProperty("update"))
                                $root.google.ads.googleads.v1.resources.UserList.encode(message.update, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.remove != null && message.hasOwnProperty("remove"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.remove);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified UserListOperation message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.UserListOperation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.UserListOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.IUserListOperation} message UserListOperation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserListOperation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a UserListOperation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.UserListOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.UserListOperation} UserListOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListOperation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.UserListOperation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4:
                                    message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                    break;
                                case 1:
                                    message.create = $root.google.ads.googleads.v1.resources.UserList.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    message.update = $root.google.ads.googleads.v1.resources.UserList.decode(reader, reader.uint32());
                                    break;
                                case 3:
                                    message.remove = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a UserListOperation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.UserListOperation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.UserListOperation} UserListOperation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserListOperation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a UserListOperation message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.UserListOperation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserListOperation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            if (message.create != null && message.hasOwnProperty("create")) {
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.UserList.verify(message.create);
                                    if (error)
                                        return "create." + error;
                                }
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                {
                                    var error = $root.google.ads.googleads.v1.resources.UserList.verify(message.update);
                                    if (error)
                                        return "update." + error;
                                }
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                if (properties.operation === 1)
                                    return "operation: multiple values";
                                properties.operation = 1;
                                if (!$util.isString(message.remove))
                                    return "remove: string expected";
                            }
                            return null;
                        };

                        /**
                         * Creates a UserListOperation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.UserListOperation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.UserListOperation} UserListOperation
                         */
                        UserListOperation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.UserListOperation)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.UserListOperation();
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.UserListOperation.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            if (object.create != null) {
                                if (typeof object.create !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.UserListOperation.create: object expected");
                                message.create = $root.google.ads.googleads.v1.resources.UserList.fromObject(object.create);
                            }
                            if (object.update != null) {
                                if (typeof object.update !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.UserListOperation.update: object expected");
                                message.update = $root.google.ads.googleads.v1.resources.UserList.fromObject(object.update);
                            }
                            if (object.remove != null)
                                message.remove = String(object.remove);
                            return message;
                        };

                        /**
                         * Creates a plain object from a UserListOperation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.UserListOperation
                         * @static
                         * @param {google.ads.googleads.v1.services.UserListOperation} message UserListOperation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserListOperation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.updateMask = null;
                            if (message.create != null && message.hasOwnProperty("create")) {
                                object.create = $root.google.ads.googleads.v1.resources.UserList.toObject(message.create, options);
                                if (options.oneofs)
                                    object.operation = "create";
                            }
                            if (message.update != null && message.hasOwnProperty("update")) {
                                object.update = $root.google.ads.googleads.v1.resources.UserList.toObject(message.update, options);
                                if (options.oneofs)
                                    object.operation = "update";
                            }
                            if (message.remove != null && message.hasOwnProperty("remove")) {
                                object.remove = message.remove;
                                if (options.oneofs)
                                    object.operation = "remove";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };

                        /**
                         * Converts this UserListOperation to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.UserListOperation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserListOperation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return UserListOperation;
                    })();

                    services.MutateUserListsResponse = (function() {

                        /**
                         * Properties of a MutateUserListsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateUserListsResponse
                         * @property {google.rpc.IStatus|null} [partialFailureError] MutateUserListsResponse partialFailureError
                         * @property {Array.<google.ads.googleads.v1.services.IMutateUserListResult>|null} [results] MutateUserListsResponse results
                         */

                        /**
                         * Constructs a new MutateUserListsResponse.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateUserListsResponse.
                         * @implements IMutateUserListsResponse
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateUserListsResponse=} [properties] Properties to set
                         */
                        function MutateUserListsResponse(properties) {
                            this.results = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateUserListsResponse partialFailureError.
                         * @member {google.rpc.IStatus|null|undefined} partialFailureError
                         * @memberof google.ads.googleads.v1.services.MutateUserListsResponse
                         * @instance
                         */
                        MutateUserListsResponse.prototype.partialFailureError = null;

                        /**
                         * MutateUserListsResponse results.
                         * @member {Array.<google.ads.googleads.v1.services.IMutateUserListResult>} results
                         * @memberof google.ads.googleads.v1.services.MutateUserListsResponse
                         * @instance
                         */
                        MutateUserListsResponse.prototype.results = $util.emptyArray;

                        /**
                         * Creates a new MutateUserListsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateUserListsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateUserListsResponse=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateUserListsResponse} MutateUserListsResponse instance
                         */
                        MutateUserListsResponse.create = function create(properties) {
                            return new MutateUserListsResponse(properties);
                        };

                        /**
                         * Encodes the specified MutateUserListsResponse message. Does not implicitly {@link google.ads.googleads.v1.services.MutateUserListsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateUserListsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateUserListsResponse} message MutateUserListsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateUserListsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.results != null && message.results.length)
                                for (var i = 0; i < message.results.length; ++i)
                                    $root.google.ads.googleads.v1.services.MutateUserListResult.encode(message.results[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                $root.google.rpc.Status.encode(message.partialFailureError, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateUserListsResponse message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateUserListsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateUserListsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateUserListsResponse} message MutateUserListsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateUserListsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateUserListsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateUserListsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateUserListsResponse} MutateUserListsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateUserListsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateUserListsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3:
                                    message.partialFailureError = $root.google.rpc.Status.decode(reader, reader.uint32());
                                    break;
                                case 2:
                                    if (!(message.results && message.results.length))
                                        message.results = [];
                                    message.results.push($root.google.ads.googleads.v1.services.MutateUserListResult.decode(reader, reader.uint32()));
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateUserListsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateUserListsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateUserListsResponse} MutateUserListsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateUserListsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateUserListsResponse message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateUserListsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateUserListsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError")) {
                                var error = $root.google.rpc.Status.verify(message.partialFailureError);
                                if (error)
                                    return "partialFailureError." + error;
                            }
                            if (message.results != null && message.hasOwnProperty("results")) {
                                if (!Array.isArray(message.results))
                                    return "results: array expected";
                                for (var i = 0; i < message.results.length; ++i) {
                                    var error = $root.google.ads.googleads.v1.services.MutateUserListResult.verify(message.results[i]);
                                    if (error)
                                        return "results." + error;
                                }
                            }
                            return null;
                        };

                        /**
                         * Creates a MutateUserListsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateUserListsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateUserListsResponse} MutateUserListsResponse
                         */
                        MutateUserListsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateUserListsResponse)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateUserListsResponse();
                            if (object.partialFailureError != null) {
                                if (typeof object.partialFailureError !== "object")
                                    throw TypeError(".google.ads.googleads.v1.services.MutateUserListsResponse.partialFailureError: object expected");
                                message.partialFailureError = $root.google.rpc.Status.fromObject(object.partialFailureError);
                            }
                            if (object.results) {
                                if (!Array.isArray(object.results))
                                    throw TypeError(".google.ads.googleads.v1.services.MutateUserListsResponse.results: array expected");
                                message.results = [];
                                for (var i = 0; i < object.results.length; ++i) {
                                    if (typeof object.results[i] !== "object")
                                        throw TypeError(".google.ads.googleads.v1.services.MutateUserListsResponse.results: object expected");
                                    message.results[i] = $root.google.ads.googleads.v1.services.MutateUserListResult.fromObject(object.results[i]);
                                }
                            }
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateUserListsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateUserListsResponse
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateUserListsResponse} message MutateUserListsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateUserListsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.results = [];
                            if (options.defaults)
                                object.partialFailureError = null;
                            if (message.results && message.results.length) {
                                object.results = [];
                                for (var j = 0; j < message.results.length; ++j)
                                    object.results[j] = $root.google.ads.googleads.v1.services.MutateUserListResult.toObject(message.results[j], options);
                            }
                            if (message.partialFailureError != null && message.hasOwnProperty("partialFailureError"))
                                object.partialFailureError = $root.google.rpc.Status.toObject(message.partialFailureError, options);
                            return object;
                        };

                        /**
                         * Converts this MutateUserListsResponse to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateUserListsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateUserListsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateUserListsResponse;
                    })();

                    services.MutateUserListResult = (function() {

                        /**
                         * Properties of a MutateUserListResult.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IMutateUserListResult
                         * @property {string|null} [resourceName] MutateUserListResult resourceName
                         */

                        /**
                         * Constructs a new MutateUserListResult.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a MutateUserListResult.
                         * @implements IMutateUserListResult
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IMutateUserListResult=} [properties] Properties to set
                         */
                        function MutateUserListResult(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * MutateUserListResult resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.MutateUserListResult
                         * @instance
                         */
                        MutateUserListResult.prototype.resourceName = "";

                        /**
                         * Creates a new MutateUserListResult instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.MutateUserListResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateUserListResult=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.MutateUserListResult} MutateUserListResult instance
                         */
                        MutateUserListResult.create = function create(properties) {
                            return new MutateUserListResult(properties);
                        };

                        /**
                         * Encodes the specified MutateUserListResult message. Does not implicitly {@link google.ads.googleads.v1.services.MutateUserListResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.MutateUserListResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateUserListResult} message MutateUserListResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateUserListResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified MutateUserListResult message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.MutateUserListResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateUserListResult
                         * @static
                         * @param {google.ads.googleads.v1.services.IMutateUserListResult} message MutateUserListResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MutateUserListResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a MutateUserListResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.MutateUserListResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.MutateUserListResult} MutateUserListResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateUserListResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.MutateUserListResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a MutateUserListResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.MutateUserListResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.MutateUserListResult} MutateUserListResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MutateUserListResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a MutateUserListResult message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.MutateUserListResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MutateUserListResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a MutateUserListResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.MutateUserListResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.MutateUserListResult} MutateUserListResult
                         */
                        MutateUserListResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.MutateUserListResult)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.MutateUserListResult();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a MutateUserListResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.MutateUserListResult
                         * @static
                         * @param {google.ads.googleads.v1.services.MutateUserListResult} message MutateUserListResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MutateUserListResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this MutateUserListResult to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.MutateUserListResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MutateUserListResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return MutateUserListResult;
                    })();

                    services.VideoService = (function() {

                        /**
                         * Constructs a new VideoService service.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a VideoService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function VideoService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }

                        (VideoService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = VideoService;

                        /**
                         * Creates new VideoService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.VideoService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {VideoService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        VideoService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };

                        /**
                         * Callback as used by {@link google.ads.googleads.v1.services.VideoService#getVideo}.
                         * @memberof google.ads.googleads.v1.services.VideoService
                         * @typedef GetVideoCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.ads.googleads.v1.resources.Video} [response] Video
                         */

                        /**
                         * Calls GetVideo.
                         * @function getVideo
                         * @memberof google.ads.googleads.v1.services.VideoService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetVideoRequest} request GetVideoRequest message or plain object
                         * @param {google.ads.googleads.v1.services.VideoService.GetVideoCallback} callback Node-style callback called with the error, if any, and Video
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(VideoService.prototype.getVideo = function getVideo(request, callback) {
                            return this.rpcCall(getVideo, $root.google.ads.googleads.v1.services.GetVideoRequest, $root.google.ads.googleads.v1.resources.Video, request, callback);
                        }, "name", { value: "GetVideo" });

                        /**
                         * Calls GetVideo.
                         * @function getVideo
                         * @memberof google.ads.googleads.v1.services.VideoService
                         * @instance
                         * @param {google.ads.googleads.v1.services.IGetVideoRequest} request GetVideoRequest message or plain object
                         * @returns {Promise<google.ads.googleads.v1.resources.Video>} Promise
                         * @variation 2
                         */

                        return VideoService;
                    })();

                    services.GetVideoRequest = (function() {

                        /**
                         * Properties of a GetVideoRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @interface IGetVideoRequest
                         * @property {string|null} [resourceName] GetVideoRequest resourceName
                         */

                        /**
                         * Constructs a new GetVideoRequest.
                         * @memberof google.ads.googleads.v1.services
                         * @classdesc Represents a GetVideoRequest.
                         * @implements IGetVideoRequest
                         * @constructor
                         * @param {google.ads.googleads.v1.services.IGetVideoRequest=} [properties] Properties to set
                         */
                        function GetVideoRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }

                        /**
                         * GetVideoRequest resourceName.
                         * @member {string} resourceName
                         * @memberof google.ads.googleads.v1.services.GetVideoRequest
                         * @instance
                         */
                        GetVideoRequest.prototype.resourceName = "";

                        /**
                         * Creates a new GetVideoRequest instance using the specified properties.
                         * @function create
                         * @memberof google.ads.googleads.v1.services.GetVideoRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetVideoRequest=} [properties] Properties to set
                         * @returns {google.ads.googleads.v1.services.GetVideoRequest} GetVideoRequest instance
                         */
                        GetVideoRequest.create = function create(properties) {
                            return new GetVideoRequest(properties);
                        };

                        /**
                         * Encodes the specified GetVideoRequest message. Does not implicitly {@link google.ads.googleads.v1.services.GetVideoRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.ads.googleads.v1.services.GetVideoRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetVideoRequest} message GetVideoRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetVideoRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resourceName);
                            return writer;
                        };

                        /**
                         * Encodes the specified GetVideoRequest message, length delimited. Does not implicitly {@link google.ads.googleads.v1.services.GetVideoRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetVideoRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.IGetVideoRequest} message GetVideoRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetVideoRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };

                        /**
                         * Decodes a GetVideoRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.ads.googleads.v1.services.GetVideoRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.ads.googleads.v1.services.GetVideoRequest} GetVideoRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetVideoRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.ads.googleads.v1.services.GetVideoRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1:
                                    message.resourceName = reader.string();
                                    break;
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };

                        /**
                         * Decodes a GetVideoRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.ads.googleads.v1.services.GetVideoRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.ads.googleads.v1.services.GetVideoRequest} GetVideoRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetVideoRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };

                        /**
                         * Verifies a GetVideoRequest message.
                         * @function verify
                         * @memberof google.ads.googleads.v1.services.GetVideoRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetVideoRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                if (!$util.isString(message.resourceName))
                                    return "resourceName: string expected";
                            return null;
                        };

                        /**
                         * Creates a GetVideoRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.ads.googleads.v1.services.GetVideoRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.ads.googleads.v1.services.GetVideoRequest} GetVideoRequest
                         */
                        GetVideoRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.ads.googleads.v1.services.GetVideoRequest)
                                return object;
                            var message = new $root.google.ads.googleads.v1.services.GetVideoRequest();
                            if (object.resourceName != null)
                                message.resourceName = String(object.resourceName);
                            return message;
                        };

                        /**
                         * Creates a plain object from a GetVideoRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.ads.googleads.v1.services.GetVideoRequest
                         * @static
                         * @param {google.ads.googleads.v1.services.GetVideoRequest} message GetVideoRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetVideoRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resourceName = "";
                            if (message.resourceName != null && message.hasOwnProperty("resourceName"))
                                object.resourceName = message.resourceName;
                            return object;
                        };

                        /**
                         * Converts this GetVideoRequest to JSON.
                         * @function toJSON
                         * @memberof google.ads.googleads.v1.services.GetVideoRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetVideoRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };

                        return GetVideoRequest;
                    })();

                    return services;
                })();

                return v1;
            })();

            return googleads;
        })();

        return ads;
    })();

    return google;
})();

module.exports = $root;
